#ifdef GET_RISCVMaskedPseudosTable_DECL
const RISCVMaskedPseudoInfo *getMaskedPseudoInfo(unsigned MaskedPseudo);
const RISCVMaskedPseudoInfo *lookupMaskedIntrinsicByUnmaskedTA(unsigned UnmaskedPseudo);
#endif

#ifdef GET_RISCVMaskedPseudosTable_IMPL
constexpr RISCVMaskedPseudoInfo RISCVMaskedPseudosTable[] = {
  { PseudoTHVdotVMAQASU_VV_M1_MASK, PseudoTHVdotVMAQASU_VV_M1, PseudoTHVdotVMAQASU_VV_M1, 0x3 }, // 0
  { PseudoTHVdotVMAQASU_VV_M2_MASK, PseudoTHVdotVMAQASU_VV_M2, PseudoTHVdotVMAQASU_VV_M2, 0x3 }, // 1
  { PseudoTHVdotVMAQASU_VV_M4_MASK, PseudoTHVdotVMAQASU_VV_M4, PseudoTHVdotVMAQASU_VV_M4, 0x3 }, // 2
  { PseudoTHVdotVMAQASU_VV_M8_MASK, PseudoTHVdotVMAQASU_VV_M8, PseudoTHVdotVMAQASU_VV_M8, 0x3 }, // 3
  { PseudoTHVdotVMAQASU_VV_MF2_MASK, PseudoTHVdotVMAQASU_VV_MF2, PseudoTHVdotVMAQASU_VV_MF2, 0x3 }, // 4
  { PseudoTHVdotVMAQASU_VX_M1_MASK, PseudoTHVdotVMAQASU_VX_M1, PseudoTHVdotVMAQASU_VX_M1, 0x3 }, // 5
  { PseudoTHVdotVMAQASU_VX_M2_MASK, PseudoTHVdotVMAQASU_VX_M2, PseudoTHVdotVMAQASU_VX_M2, 0x3 }, // 6
  { PseudoTHVdotVMAQASU_VX_M4_MASK, PseudoTHVdotVMAQASU_VX_M4, PseudoTHVdotVMAQASU_VX_M4, 0x3 }, // 7
  { PseudoTHVdotVMAQASU_VX_M8_MASK, PseudoTHVdotVMAQASU_VX_M8, PseudoTHVdotVMAQASU_VX_M8, 0x3 }, // 8
  { PseudoTHVdotVMAQASU_VX_MF2_MASK, PseudoTHVdotVMAQASU_VX_MF2, PseudoTHVdotVMAQASU_VX_MF2, 0x3 }, // 9
  { PseudoTHVdotVMAQAUS_VX_M1_MASK, PseudoTHVdotVMAQAUS_VX_M1, PseudoTHVdotVMAQAUS_VX_M1, 0x3 }, // 10
  { PseudoTHVdotVMAQAUS_VX_M2_MASK, PseudoTHVdotVMAQAUS_VX_M2, PseudoTHVdotVMAQAUS_VX_M2, 0x3 }, // 11
  { PseudoTHVdotVMAQAUS_VX_M4_MASK, PseudoTHVdotVMAQAUS_VX_M4, PseudoTHVdotVMAQAUS_VX_M4, 0x3 }, // 12
  { PseudoTHVdotVMAQAUS_VX_M8_MASK, PseudoTHVdotVMAQAUS_VX_M8, PseudoTHVdotVMAQAUS_VX_M8, 0x3 }, // 13
  { PseudoTHVdotVMAQAUS_VX_MF2_MASK, PseudoTHVdotVMAQAUS_VX_MF2, PseudoTHVdotVMAQAUS_VX_MF2, 0x3 }, // 14
  { PseudoTHVdotVMAQAU_VV_M1_MASK, PseudoTHVdotVMAQAU_VV_M1, PseudoTHVdotVMAQAU_VV_M1, 0x3 }, // 15
  { PseudoTHVdotVMAQAU_VV_M2_MASK, PseudoTHVdotVMAQAU_VV_M2, PseudoTHVdotVMAQAU_VV_M2, 0x3 }, // 16
  { PseudoTHVdotVMAQAU_VV_M4_MASK, PseudoTHVdotVMAQAU_VV_M4, PseudoTHVdotVMAQAU_VV_M4, 0x3 }, // 17
  { PseudoTHVdotVMAQAU_VV_M8_MASK, PseudoTHVdotVMAQAU_VV_M8, PseudoTHVdotVMAQAU_VV_M8, 0x3 }, // 18
  { PseudoTHVdotVMAQAU_VV_MF2_MASK, PseudoTHVdotVMAQAU_VV_MF2, PseudoTHVdotVMAQAU_VV_MF2, 0x3 }, // 19
  { PseudoTHVdotVMAQAU_VX_M1_MASK, PseudoTHVdotVMAQAU_VX_M1, PseudoTHVdotVMAQAU_VX_M1, 0x3 }, // 20
  { PseudoTHVdotVMAQAU_VX_M2_MASK, PseudoTHVdotVMAQAU_VX_M2, PseudoTHVdotVMAQAU_VX_M2, 0x3 }, // 21
  { PseudoTHVdotVMAQAU_VX_M4_MASK, PseudoTHVdotVMAQAU_VX_M4, PseudoTHVdotVMAQAU_VX_M4, 0x3 }, // 22
  { PseudoTHVdotVMAQAU_VX_M8_MASK, PseudoTHVdotVMAQAU_VX_M8, PseudoTHVdotVMAQAU_VX_M8, 0x3 }, // 23
  { PseudoTHVdotVMAQAU_VX_MF2_MASK, PseudoTHVdotVMAQAU_VX_MF2, PseudoTHVdotVMAQAU_VX_MF2, 0x3 }, // 24
  { PseudoTHVdotVMAQA_VV_M1_MASK, PseudoTHVdotVMAQA_VV_M1, PseudoTHVdotVMAQA_VV_M1, 0x3 }, // 25
  { PseudoTHVdotVMAQA_VV_M2_MASK, PseudoTHVdotVMAQA_VV_M2, PseudoTHVdotVMAQA_VV_M2, 0x3 }, // 26
  { PseudoTHVdotVMAQA_VV_M4_MASK, PseudoTHVdotVMAQA_VV_M4, PseudoTHVdotVMAQA_VV_M4, 0x3 }, // 27
  { PseudoTHVdotVMAQA_VV_M8_MASK, PseudoTHVdotVMAQA_VV_M8, PseudoTHVdotVMAQA_VV_M8, 0x3 }, // 28
  { PseudoTHVdotVMAQA_VV_MF2_MASK, PseudoTHVdotVMAQA_VV_MF2, PseudoTHVdotVMAQA_VV_MF2, 0x3 }, // 29
  { PseudoTHVdotVMAQA_VX_M1_MASK, PseudoTHVdotVMAQA_VX_M1, PseudoTHVdotVMAQA_VX_M1, 0x3 }, // 30
  { PseudoTHVdotVMAQA_VX_M2_MASK, PseudoTHVdotVMAQA_VX_M2, PseudoTHVdotVMAQA_VX_M2, 0x3 }, // 31
  { PseudoTHVdotVMAQA_VX_M4_MASK, PseudoTHVdotVMAQA_VX_M4, PseudoTHVdotVMAQA_VX_M4, 0x3 }, // 32
  { PseudoTHVdotVMAQA_VX_M8_MASK, PseudoTHVdotVMAQA_VX_M8, PseudoTHVdotVMAQA_VX_M8, 0x3 }, // 33
  { PseudoTHVdotVMAQA_VX_MF2_MASK, PseudoTHVdotVMAQA_VX_MF2, PseudoTHVdotVMAQA_VX_MF2, 0x3 }, // 34
  { PseudoVAADDU_VV_M1_MASK, PseudoVAADDU_VV_M1, PseudoVAADDU_VV_M1_TU, 0x3 }, // 35
  { PseudoVAADDU_VV_M2_MASK, PseudoVAADDU_VV_M2, PseudoVAADDU_VV_M2_TU, 0x3 }, // 36
  { PseudoVAADDU_VV_M4_MASK, PseudoVAADDU_VV_M4, PseudoVAADDU_VV_M4_TU, 0x3 }, // 37
  { PseudoVAADDU_VV_M8_MASK, PseudoVAADDU_VV_M8, PseudoVAADDU_VV_M8_TU, 0x3 }, // 38
  { PseudoVAADDU_VV_MF2_MASK, PseudoVAADDU_VV_MF2, PseudoVAADDU_VV_MF2_TU, 0x3 }, // 39
  { PseudoVAADDU_VV_MF4_MASK, PseudoVAADDU_VV_MF4, PseudoVAADDU_VV_MF4_TU, 0x3 }, // 40
  { PseudoVAADDU_VV_MF8_MASK, PseudoVAADDU_VV_MF8, PseudoVAADDU_VV_MF8_TU, 0x3 }, // 41
  { PseudoVAADDU_VX_M1_MASK, PseudoVAADDU_VX_M1, PseudoVAADDU_VX_M1_TU, 0x3 }, // 42
  { PseudoVAADDU_VX_M2_MASK, PseudoVAADDU_VX_M2, PseudoVAADDU_VX_M2_TU, 0x3 }, // 43
  { PseudoVAADDU_VX_M4_MASK, PseudoVAADDU_VX_M4, PseudoVAADDU_VX_M4_TU, 0x3 }, // 44
  { PseudoVAADDU_VX_M8_MASK, PseudoVAADDU_VX_M8, PseudoVAADDU_VX_M8_TU, 0x3 }, // 45
  { PseudoVAADDU_VX_MF2_MASK, PseudoVAADDU_VX_MF2, PseudoVAADDU_VX_MF2_TU, 0x3 }, // 46
  { PseudoVAADDU_VX_MF4_MASK, PseudoVAADDU_VX_MF4, PseudoVAADDU_VX_MF4_TU, 0x3 }, // 47
  { PseudoVAADDU_VX_MF8_MASK, PseudoVAADDU_VX_MF8, PseudoVAADDU_VX_MF8_TU, 0x3 }, // 48
  { PseudoVAADD_VV_M1_MASK, PseudoVAADD_VV_M1, PseudoVAADD_VV_M1_TU, 0x3 }, // 49
  { PseudoVAADD_VV_M2_MASK, PseudoVAADD_VV_M2, PseudoVAADD_VV_M2_TU, 0x3 }, // 50
  { PseudoVAADD_VV_M4_MASK, PseudoVAADD_VV_M4, PseudoVAADD_VV_M4_TU, 0x3 }, // 51
  { PseudoVAADD_VV_M8_MASK, PseudoVAADD_VV_M8, PseudoVAADD_VV_M8_TU, 0x3 }, // 52
  { PseudoVAADD_VV_MF2_MASK, PseudoVAADD_VV_MF2, PseudoVAADD_VV_MF2_TU, 0x3 }, // 53
  { PseudoVAADD_VV_MF4_MASK, PseudoVAADD_VV_MF4, PseudoVAADD_VV_MF4_TU, 0x3 }, // 54
  { PseudoVAADD_VV_MF8_MASK, PseudoVAADD_VV_MF8, PseudoVAADD_VV_MF8_TU, 0x3 }, // 55
  { PseudoVAADD_VX_M1_MASK, PseudoVAADD_VX_M1, PseudoVAADD_VX_M1_TU, 0x3 }, // 56
  { PseudoVAADD_VX_M2_MASK, PseudoVAADD_VX_M2, PseudoVAADD_VX_M2_TU, 0x3 }, // 57
  { PseudoVAADD_VX_M4_MASK, PseudoVAADD_VX_M4, PseudoVAADD_VX_M4_TU, 0x3 }, // 58
  { PseudoVAADD_VX_M8_MASK, PseudoVAADD_VX_M8, PseudoVAADD_VX_M8_TU, 0x3 }, // 59
  { PseudoVAADD_VX_MF2_MASK, PseudoVAADD_VX_MF2, PseudoVAADD_VX_MF2_TU, 0x3 }, // 60
  { PseudoVAADD_VX_MF4_MASK, PseudoVAADD_VX_MF4, PseudoVAADD_VX_MF4_TU, 0x3 }, // 61
  { PseudoVAADD_VX_MF8_MASK, PseudoVAADD_VX_MF8, PseudoVAADD_VX_MF8_TU, 0x3 }, // 62
  { PseudoVADD_VI_M1_MASK, PseudoVADD_VI_M1, PseudoVADD_VI_M1_TU, 0x3 }, // 63
  { PseudoVADD_VI_M2_MASK, PseudoVADD_VI_M2, PseudoVADD_VI_M2_TU, 0x3 }, // 64
  { PseudoVADD_VI_M4_MASK, PseudoVADD_VI_M4, PseudoVADD_VI_M4_TU, 0x3 }, // 65
  { PseudoVADD_VI_M8_MASK, PseudoVADD_VI_M8, PseudoVADD_VI_M8_TU, 0x3 }, // 66
  { PseudoVADD_VI_MF2_MASK, PseudoVADD_VI_MF2, PseudoVADD_VI_MF2_TU, 0x3 }, // 67
  { PseudoVADD_VI_MF4_MASK, PseudoVADD_VI_MF4, PseudoVADD_VI_MF4_TU, 0x3 }, // 68
  { PseudoVADD_VI_MF8_MASK, PseudoVADD_VI_MF8, PseudoVADD_VI_MF8_TU, 0x3 }, // 69
  { PseudoVADD_VV_M1_MASK, PseudoVADD_VV_M1, PseudoVADD_VV_M1_TU, 0x3 }, // 70
  { PseudoVADD_VV_M2_MASK, PseudoVADD_VV_M2, PseudoVADD_VV_M2_TU, 0x3 }, // 71
  { PseudoVADD_VV_M4_MASK, PseudoVADD_VV_M4, PseudoVADD_VV_M4_TU, 0x3 }, // 72
  { PseudoVADD_VV_M8_MASK, PseudoVADD_VV_M8, PseudoVADD_VV_M8_TU, 0x3 }, // 73
  { PseudoVADD_VV_MF2_MASK, PseudoVADD_VV_MF2, PseudoVADD_VV_MF2_TU, 0x3 }, // 74
  { PseudoVADD_VV_MF4_MASK, PseudoVADD_VV_MF4, PseudoVADD_VV_MF4_TU, 0x3 }, // 75
  { PseudoVADD_VV_MF8_MASK, PseudoVADD_VV_MF8, PseudoVADD_VV_MF8_TU, 0x3 }, // 76
  { PseudoVADD_VX_M1_MASK, PseudoVADD_VX_M1, PseudoVADD_VX_M1_TU, 0x3 }, // 77
  { PseudoVADD_VX_M2_MASK, PseudoVADD_VX_M2, PseudoVADD_VX_M2_TU, 0x3 }, // 78
  { PseudoVADD_VX_M4_MASK, PseudoVADD_VX_M4, PseudoVADD_VX_M4_TU, 0x3 }, // 79
  { PseudoVADD_VX_M8_MASK, PseudoVADD_VX_M8, PseudoVADD_VX_M8_TU, 0x3 }, // 80
  { PseudoVADD_VX_MF2_MASK, PseudoVADD_VX_MF2, PseudoVADD_VX_MF2_TU, 0x3 }, // 81
  { PseudoVADD_VX_MF4_MASK, PseudoVADD_VX_MF4, PseudoVADD_VX_MF4_TU, 0x3 }, // 82
  { PseudoVADD_VX_MF8_MASK, PseudoVADD_VX_MF8, PseudoVADD_VX_MF8_TU, 0x3 }, // 83
  { PseudoVAND_VI_M1_MASK, PseudoVAND_VI_M1, PseudoVAND_VI_M1_TU, 0x3 }, // 84
  { PseudoVAND_VI_M2_MASK, PseudoVAND_VI_M2, PseudoVAND_VI_M2_TU, 0x3 }, // 85
  { PseudoVAND_VI_M4_MASK, PseudoVAND_VI_M4, PseudoVAND_VI_M4_TU, 0x3 }, // 86
  { PseudoVAND_VI_M8_MASK, PseudoVAND_VI_M8, PseudoVAND_VI_M8_TU, 0x3 }, // 87
  { PseudoVAND_VI_MF2_MASK, PseudoVAND_VI_MF2, PseudoVAND_VI_MF2_TU, 0x3 }, // 88
  { PseudoVAND_VI_MF4_MASK, PseudoVAND_VI_MF4, PseudoVAND_VI_MF4_TU, 0x3 }, // 89
  { PseudoVAND_VI_MF8_MASK, PseudoVAND_VI_MF8, PseudoVAND_VI_MF8_TU, 0x3 }, // 90
  { PseudoVAND_VV_M1_MASK, PseudoVAND_VV_M1, PseudoVAND_VV_M1_TU, 0x3 }, // 91
  { PseudoVAND_VV_M2_MASK, PseudoVAND_VV_M2, PseudoVAND_VV_M2_TU, 0x3 }, // 92
  { PseudoVAND_VV_M4_MASK, PseudoVAND_VV_M4, PseudoVAND_VV_M4_TU, 0x3 }, // 93
  { PseudoVAND_VV_M8_MASK, PseudoVAND_VV_M8, PseudoVAND_VV_M8_TU, 0x3 }, // 94
  { PseudoVAND_VV_MF2_MASK, PseudoVAND_VV_MF2, PseudoVAND_VV_MF2_TU, 0x3 }, // 95
  { PseudoVAND_VV_MF4_MASK, PseudoVAND_VV_MF4, PseudoVAND_VV_MF4_TU, 0x3 }, // 96
  { PseudoVAND_VV_MF8_MASK, PseudoVAND_VV_MF8, PseudoVAND_VV_MF8_TU, 0x3 }, // 97
  { PseudoVAND_VX_M1_MASK, PseudoVAND_VX_M1, PseudoVAND_VX_M1_TU, 0x3 }, // 98
  { PseudoVAND_VX_M2_MASK, PseudoVAND_VX_M2, PseudoVAND_VX_M2_TU, 0x3 }, // 99
  { PseudoVAND_VX_M4_MASK, PseudoVAND_VX_M4, PseudoVAND_VX_M4_TU, 0x3 }, // 100
  { PseudoVAND_VX_M8_MASK, PseudoVAND_VX_M8, PseudoVAND_VX_M8_TU, 0x3 }, // 101
  { PseudoVAND_VX_MF2_MASK, PseudoVAND_VX_MF2, PseudoVAND_VX_MF2_TU, 0x3 }, // 102
  { PseudoVAND_VX_MF4_MASK, PseudoVAND_VX_MF4, PseudoVAND_VX_MF4_TU, 0x3 }, // 103
  { PseudoVAND_VX_MF8_MASK, PseudoVAND_VX_MF8, PseudoVAND_VX_MF8_TU, 0x3 }, // 104
  { PseudoVASUBU_VV_M1_MASK, PseudoVASUBU_VV_M1, PseudoVASUBU_VV_M1_TU, 0x3 }, // 105
  { PseudoVASUBU_VV_M2_MASK, PseudoVASUBU_VV_M2, PseudoVASUBU_VV_M2_TU, 0x3 }, // 106
  { PseudoVASUBU_VV_M4_MASK, PseudoVASUBU_VV_M4, PseudoVASUBU_VV_M4_TU, 0x3 }, // 107
  { PseudoVASUBU_VV_M8_MASK, PseudoVASUBU_VV_M8, PseudoVASUBU_VV_M8_TU, 0x3 }, // 108
  { PseudoVASUBU_VV_MF2_MASK, PseudoVASUBU_VV_MF2, PseudoVASUBU_VV_MF2_TU, 0x3 }, // 109
  { PseudoVASUBU_VV_MF4_MASK, PseudoVASUBU_VV_MF4, PseudoVASUBU_VV_MF4_TU, 0x3 }, // 110
  { PseudoVASUBU_VV_MF8_MASK, PseudoVASUBU_VV_MF8, PseudoVASUBU_VV_MF8_TU, 0x3 }, // 111
  { PseudoVASUBU_VX_M1_MASK, PseudoVASUBU_VX_M1, PseudoVASUBU_VX_M1_TU, 0x3 }, // 112
  { PseudoVASUBU_VX_M2_MASK, PseudoVASUBU_VX_M2, PseudoVASUBU_VX_M2_TU, 0x3 }, // 113
  { PseudoVASUBU_VX_M4_MASK, PseudoVASUBU_VX_M4, PseudoVASUBU_VX_M4_TU, 0x3 }, // 114
  { PseudoVASUBU_VX_M8_MASK, PseudoVASUBU_VX_M8, PseudoVASUBU_VX_M8_TU, 0x3 }, // 115
  { PseudoVASUBU_VX_MF2_MASK, PseudoVASUBU_VX_MF2, PseudoVASUBU_VX_MF2_TU, 0x3 }, // 116
  { PseudoVASUBU_VX_MF4_MASK, PseudoVASUBU_VX_MF4, PseudoVASUBU_VX_MF4_TU, 0x3 }, // 117
  { PseudoVASUBU_VX_MF8_MASK, PseudoVASUBU_VX_MF8, PseudoVASUBU_VX_MF8_TU, 0x3 }, // 118
  { PseudoVASUB_VV_M1_MASK, PseudoVASUB_VV_M1, PseudoVASUB_VV_M1_TU, 0x3 }, // 119
  { PseudoVASUB_VV_M2_MASK, PseudoVASUB_VV_M2, PseudoVASUB_VV_M2_TU, 0x3 }, // 120
  { PseudoVASUB_VV_M4_MASK, PseudoVASUB_VV_M4, PseudoVASUB_VV_M4_TU, 0x3 }, // 121
  { PseudoVASUB_VV_M8_MASK, PseudoVASUB_VV_M8, PseudoVASUB_VV_M8_TU, 0x3 }, // 122
  { PseudoVASUB_VV_MF2_MASK, PseudoVASUB_VV_MF2, PseudoVASUB_VV_MF2_TU, 0x3 }, // 123
  { PseudoVASUB_VV_MF4_MASK, PseudoVASUB_VV_MF4, PseudoVASUB_VV_MF4_TU, 0x3 }, // 124
  { PseudoVASUB_VV_MF8_MASK, PseudoVASUB_VV_MF8, PseudoVASUB_VV_MF8_TU, 0x3 }, // 125
  { PseudoVASUB_VX_M1_MASK, PseudoVASUB_VX_M1, PseudoVASUB_VX_M1_TU, 0x3 }, // 126
  { PseudoVASUB_VX_M2_MASK, PseudoVASUB_VX_M2, PseudoVASUB_VX_M2_TU, 0x3 }, // 127
  { PseudoVASUB_VX_M4_MASK, PseudoVASUB_VX_M4, PseudoVASUB_VX_M4_TU, 0x3 }, // 128
  { PseudoVASUB_VX_M8_MASK, PseudoVASUB_VX_M8, PseudoVASUB_VX_M8_TU, 0x3 }, // 129
  { PseudoVASUB_VX_MF2_MASK, PseudoVASUB_VX_MF2, PseudoVASUB_VX_MF2_TU, 0x3 }, // 130
  { PseudoVASUB_VX_MF4_MASK, PseudoVASUB_VX_MF4, PseudoVASUB_VX_MF4_TU, 0x3 }, // 131
  { PseudoVASUB_VX_MF8_MASK, PseudoVASUB_VX_MF8, PseudoVASUB_VX_MF8_TU, 0x3 }, // 132
  { PseudoVDIVU_VV_M1_E16_MASK, PseudoVDIVU_VV_M1_E16, PseudoVDIVU_VV_M1_E16_TU, 0x3 }, // 133
  { PseudoVDIVU_VV_M1_E32_MASK, PseudoVDIVU_VV_M1_E32, PseudoVDIVU_VV_M1_E32_TU, 0x3 }, // 134
  { PseudoVDIVU_VV_M1_E64_MASK, PseudoVDIVU_VV_M1_E64, PseudoVDIVU_VV_M1_E64_TU, 0x3 }, // 135
  { PseudoVDIVU_VV_M1_E8_MASK, PseudoVDIVU_VV_M1_E8, PseudoVDIVU_VV_M1_E8_TU, 0x3 }, // 136
  { PseudoVDIVU_VV_M2_E16_MASK, PseudoVDIVU_VV_M2_E16, PseudoVDIVU_VV_M2_E16_TU, 0x3 }, // 137
  { PseudoVDIVU_VV_M2_E32_MASK, PseudoVDIVU_VV_M2_E32, PseudoVDIVU_VV_M2_E32_TU, 0x3 }, // 138
  { PseudoVDIVU_VV_M2_E64_MASK, PseudoVDIVU_VV_M2_E64, PseudoVDIVU_VV_M2_E64_TU, 0x3 }, // 139
  { PseudoVDIVU_VV_M2_E8_MASK, PseudoVDIVU_VV_M2_E8, PseudoVDIVU_VV_M2_E8_TU, 0x3 }, // 140
  { PseudoVDIVU_VV_M4_E16_MASK, PseudoVDIVU_VV_M4_E16, PseudoVDIVU_VV_M4_E16_TU, 0x3 }, // 141
  { PseudoVDIVU_VV_M4_E32_MASK, PseudoVDIVU_VV_M4_E32, PseudoVDIVU_VV_M4_E32_TU, 0x3 }, // 142
  { PseudoVDIVU_VV_M4_E64_MASK, PseudoVDIVU_VV_M4_E64, PseudoVDIVU_VV_M4_E64_TU, 0x3 }, // 143
  { PseudoVDIVU_VV_M4_E8_MASK, PseudoVDIVU_VV_M4_E8, PseudoVDIVU_VV_M4_E8_TU, 0x3 }, // 144
  { PseudoVDIVU_VV_M8_E16_MASK, PseudoVDIVU_VV_M8_E16, PseudoVDIVU_VV_M8_E16_TU, 0x3 }, // 145
  { PseudoVDIVU_VV_M8_E32_MASK, PseudoVDIVU_VV_M8_E32, PseudoVDIVU_VV_M8_E32_TU, 0x3 }, // 146
  { PseudoVDIVU_VV_M8_E64_MASK, PseudoVDIVU_VV_M8_E64, PseudoVDIVU_VV_M8_E64_TU, 0x3 }, // 147
  { PseudoVDIVU_VV_M8_E8_MASK, PseudoVDIVU_VV_M8_E8, PseudoVDIVU_VV_M8_E8_TU, 0x3 }, // 148
  { PseudoVDIVU_VV_MF2_E16_MASK, PseudoVDIVU_VV_MF2_E16, PseudoVDIVU_VV_MF2_E16_TU, 0x3 }, // 149
  { PseudoVDIVU_VV_MF2_E32_MASK, PseudoVDIVU_VV_MF2_E32, PseudoVDIVU_VV_MF2_E32_TU, 0x3 }, // 150
  { PseudoVDIVU_VV_MF2_E8_MASK, PseudoVDIVU_VV_MF2_E8, PseudoVDIVU_VV_MF2_E8_TU, 0x3 }, // 151
  { PseudoVDIVU_VV_MF4_E16_MASK, PseudoVDIVU_VV_MF4_E16, PseudoVDIVU_VV_MF4_E16_TU, 0x3 }, // 152
  { PseudoVDIVU_VV_MF4_E8_MASK, PseudoVDIVU_VV_MF4_E8, PseudoVDIVU_VV_MF4_E8_TU, 0x3 }, // 153
  { PseudoVDIVU_VV_MF8_E8_MASK, PseudoVDIVU_VV_MF8_E8, PseudoVDIVU_VV_MF8_E8_TU, 0x3 }, // 154
  { PseudoVDIVU_VX_M1_E16_MASK, PseudoVDIVU_VX_M1_E16, PseudoVDIVU_VX_M1_E16_TU, 0x3 }, // 155
  { PseudoVDIVU_VX_M1_E32_MASK, PseudoVDIVU_VX_M1_E32, PseudoVDIVU_VX_M1_E32_TU, 0x3 }, // 156
  { PseudoVDIVU_VX_M1_E64_MASK, PseudoVDIVU_VX_M1_E64, PseudoVDIVU_VX_M1_E64_TU, 0x3 }, // 157
  { PseudoVDIVU_VX_M1_E8_MASK, PseudoVDIVU_VX_M1_E8, PseudoVDIVU_VX_M1_E8_TU, 0x3 }, // 158
  { PseudoVDIVU_VX_M2_E16_MASK, PseudoVDIVU_VX_M2_E16, PseudoVDIVU_VX_M2_E16_TU, 0x3 }, // 159
  { PseudoVDIVU_VX_M2_E32_MASK, PseudoVDIVU_VX_M2_E32, PseudoVDIVU_VX_M2_E32_TU, 0x3 }, // 160
  { PseudoVDIVU_VX_M2_E64_MASK, PseudoVDIVU_VX_M2_E64, PseudoVDIVU_VX_M2_E64_TU, 0x3 }, // 161
  { PseudoVDIVU_VX_M2_E8_MASK, PseudoVDIVU_VX_M2_E8, PseudoVDIVU_VX_M2_E8_TU, 0x3 }, // 162
  { PseudoVDIVU_VX_M4_E16_MASK, PseudoVDIVU_VX_M4_E16, PseudoVDIVU_VX_M4_E16_TU, 0x3 }, // 163
  { PseudoVDIVU_VX_M4_E32_MASK, PseudoVDIVU_VX_M4_E32, PseudoVDIVU_VX_M4_E32_TU, 0x3 }, // 164
  { PseudoVDIVU_VX_M4_E64_MASK, PseudoVDIVU_VX_M4_E64, PseudoVDIVU_VX_M4_E64_TU, 0x3 }, // 165
  { PseudoVDIVU_VX_M4_E8_MASK, PseudoVDIVU_VX_M4_E8, PseudoVDIVU_VX_M4_E8_TU, 0x3 }, // 166
  { PseudoVDIVU_VX_M8_E16_MASK, PseudoVDIVU_VX_M8_E16, PseudoVDIVU_VX_M8_E16_TU, 0x3 }, // 167
  { PseudoVDIVU_VX_M8_E32_MASK, PseudoVDIVU_VX_M8_E32, PseudoVDIVU_VX_M8_E32_TU, 0x3 }, // 168
  { PseudoVDIVU_VX_M8_E64_MASK, PseudoVDIVU_VX_M8_E64, PseudoVDIVU_VX_M8_E64_TU, 0x3 }, // 169
  { PseudoVDIVU_VX_M8_E8_MASK, PseudoVDIVU_VX_M8_E8, PseudoVDIVU_VX_M8_E8_TU, 0x3 }, // 170
  { PseudoVDIVU_VX_MF2_E16_MASK, PseudoVDIVU_VX_MF2_E16, PseudoVDIVU_VX_MF2_E16_TU, 0x3 }, // 171
  { PseudoVDIVU_VX_MF2_E32_MASK, PseudoVDIVU_VX_MF2_E32, PseudoVDIVU_VX_MF2_E32_TU, 0x3 }, // 172
  { PseudoVDIVU_VX_MF2_E8_MASK, PseudoVDIVU_VX_MF2_E8, PseudoVDIVU_VX_MF2_E8_TU, 0x3 }, // 173
  { PseudoVDIVU_VX_MF4_E16_MASK, PseudoVDIVU_VX_MF4_E16, PseudoVDIVU_VX_MF4_E16_TU, 0x3 }, // 174
  { PseudoVDIVU_VX_MF4_E8_MASK, PseudoVDIVU_VX_MF4_E8, PseudoVDIVU_VX_MF4_E8_TU, 0x3 }, // 175
  { PseudoVDIVU_VX_MF8_E8_MASK, PseudoVDIVU_VX_MF8_E8, PseudoVDIVU_VX_MF8_E8_TU, 0x3 }, // 176
  { PseudoVDIV_VV_M1_E16_MASK, PseudoVDIV_VV_M1_E16, PseudoVDIV_VV_M1_E16_TU, 0x3 }, // 177
  { PseudoVDIV_VV_M1_E32_MASK, PseudoVDIV_VV_M1_E32, PseudoVDIV_VV_M1_E32_TU, 0x3 }, // 178
  { PseudoVDIV_VV_M1_E64_MASK, PseudoVDIV_VV_M1_E64, PseudoVDIV_VV_M1_E64_TU, 0x3 }, // 179
  { PseudoVDIV_VV_M1_E8_MASK, PseudoVDIV_VV_M1_E8, PseudoVDIV_VV_M1_E8_TU, 0x3 }, // 180
  { PseudoVDIV_VV_M2_E16_MASK, PseudoVDIV_VV_M2_E16, PseudoVDIV_VV_M2_E16_TU, 0x3 }, // 181
  { PseudoVDIV_VV_M2_E32_MASK, PseudoVDIV_VV_M2_E32, PseudoVDIV_VV_M2_E32_TU, 0x3 }, // 182
  { PseudoVDIV_VV_M2_E64_MASK, PseudoVDIV_VV_M2_E64, PseudoVDIV_VV_M2_E64_TU, 0x3 }, // 183
  { PseudoVDIV_VV_M2_E8_MASK, PseudoVDIV_VV_M2_E8, PseudoVDIV_VV_M2_E8_TU, 0x3 }, // 184
  { PseudoVDIV_VV_M4_E16_MASK, PseudoVDIV_VV_M4_E16, PseudoVDIV_VV_M4_E16_TU, 0x3 }, // 185
  { PseudoVDIV_VV_M4_E32_MASK, PseudoVDIV_VV_M4_E32, PseudoVDIV_VV_M4_E32_TU, 0x3 }, // 186
  { PseudoVDIV_VV_M4_E64_MASK, PseudoVDIV_VV_M4_E64, PseudoVDIV_VV_M4_E64_TU, 0x3 }, // 187
  { PseudoVDIV_VV_M4_E8_MASK, PseudoVDIV_VV_M4_E8, PseudoVDIV_VV_M4_E8_TU, 0x3 }, // 188
  { PseudoVDIV_VV_M8_E16_MASK, PseudoVDIV_VV_M8_E16, PseudoVDIV_VV_M8_E16_TU, 0x3 }, // 189
  { PseudoVDIV_VV_M8_E32_MASK, PseudoVDIV_VV_M8_E32, PseudoVDIV_VV_M8_E32_TU, 0x3 }, // 190
  { PseudoVDIV_VV_M8_E64_MASK, PseudoVDIV_VV_M8_E64, PseudoVDIV_VV_M8_E64_TU, 0x3 }, // 191
  { PseudoVDIV_VV_M8_E8_MASK, PseudoVDIV_VV_M8_E8, PseudoVDIV_VV_M8_E8_TU, 0x3 }, // 192
  { PseudoVDIV_VV_MF2_E16_MASK, PseudoVDIV_VV_MF2_E16, PseudoVDIV_VV_MF2_E16_TU, 0x3 }, // 193
  { PseudoVDIV_VV_MF2_E32_MASK, PseudoVDIV_VV_MF2_E32, PseudoVDIV_VV_MF2_E32_TU, 0x3 }, // 194
  { PseudoVDIV_VV_MF2_E8_MASK, PseudoVDIV_VV_MF2_E8, PseudoVDIV_VV_MF2_E8_TU, 0x3 }, // 195
  { PseudoVDIV_VV_MF4_E16_MASK, PseudoVDIV_VV_MF4_E16, PseudoVDIV_VV_MF4_E16_TU, 0x3 }, // 196
  { PseudoVDIV_VV_MF4_E8_MASK, PseudoVDIV_VV_MF4_E8, PseudoVDIV_VV_MF4_E8_TU, 0x3 }, // 197
  { PseudoVDIV_VV_MF8_E8_MASK, PseudoVDIV_VV_MF8_E8, PseudoVDIV_VV_MF8_E8_TU, 0x3 }, // 198
  { PseudoVDIV_VX_M1_E16_MASK, PseudoVDIV_VX_M1_E16, PseudoVDIV_VX_M1_E16_TU, 0x3 }, // 199
  { PseudoVDIV_VX_M1_E32_MASK, PseudoVDIV_VX_M1_E32, PseudoVDIV_VX_M1_E32_TU, 0x3 }, // 200
  { PseudoVDIV_VX_M1_E64_MASK, PseudoVDIV_VX_M1_E64, PseudoVDIV_VX_M1_E64_TU, 0x3 }, // 201
  { PseudoVDIV_VX_M1_E8_MASK, PseudoVDIV_VX_M1_E8, PseudoVDIV_VX_M1_E8_TU, 0x3 }, // 202
  { PseudoVDIV_VX_M2_E16_MASK, PseudoVDIV_VX_M2_E16, PseudoVDIV_VX_M2_E16_TU, 0x3 }, // 203
  { PseudoVDIV_VX_M2_E32_MASK, PseudoVDIV_VX_M2_E32, PseudoVDIV_VX_M2_E32_TU, 0x3 }, // 204
  { PseudoVDIV_VX_M2_E64_MASK, PseudoVDIV_VX_M2_E64, PseudoVDIV_VX_M2_E64_TU, 0x3 }, // 205
  { PseudoVDIV_VX_M2_E8_MASK, PseudoVDIV_VX_M2_E8, PseudoVDIV_VX_M2_E8_TU, 0x3 }, // 206
  { PseudoVDIV_VX_M4_E16_MASK, PseudoVDIV_VX_M4_E16, PseudoVDIV_VX_M4_E16_TU, 0x3 }, // 207
  { PseudoVDIV_VX_M4_E32_MASK, PseudoVDIV_VX_M4_E32, PseudoVDIV_VX_M4_E32_TU, 0x3 }, // 208
  { PseudoVDIV_VX_M4_E64_MASK, PseudoVDIV_VX_M4_E64, PseudoVDIV_VX_M4_E64_TU, 0x3 }, // 209
  { PseudoVDIV_VX_M4_E8_MASK, PseudoVDIV_VX_M4_E8, PseudoVDIV_VX_M4_E8_TU, 0x3 }, // 210
  { PseudoVDIV_VX_M8_E16_MASK, PseudoVDIV_VX_M8_E16, PseudoVDIV_VX_M8_E16_TU, 0x3 }, // 211
  { PseudoVDIV_VX_M8_E32_MASK, PseudoVDIV_VX_M8_E32, PseudoVDIV_VX_M8_E32_TU, 0x3 }, // 212
  { PseudoVDIV_VX_M8_E64_MASK, PseudoVDIV_VX_M8_E64, PseudoVDIV_VX_M8_E64_TU, 0x3 }, // 213
  { PseudoVDIV_VX_M8_E8_MASK, PseudoVDIV_VX_M8_E8, PseudoVDIV_VX_M8_E8_TU, 0x3 }, // 214
  { PseudoVDIV_VX_MF2_E16_MASK, PseudoVDIV_VX_MF2_E16, PseudoVDIV_VX_MF2_E16_TU, 0x3 }, // 215
  { PseudoVDIV_VX_MF2_E32_MASK, PseudoVDIV_VX_MF2_E32, PseudoVDIV_VX_MF2_E32_TU, 0x3 }, // 216
  { PseudoVDIV_VX_MF2_E8_MASK, PseudoVDIV_VX_MF2_E8, PseudoVDIV_VX_MF2_E8_TU, 0x3 }, // 217
  { PseudoVDIV_VX_MF4_E16_MASK, PseudoVDIV_VX_MF4_E16, PseudoVDIV_VX_MF4_E16_TU, 0x3 }, // 218
  { PseudoVDIV_VX_MF4_E8_MASK, PseudoVDIV_VX_MF4_E8, PseudoVDIV_VX_MF4_E8_TU, 0x3 }, // 219
  { PseudoVDIV_VX_MF8_E8_MASK, PseudoVDIV_VX_MF8_E8, PseudoVDIV_VX_MF8_E8_TU, 0x3 }, // 220
  { PseudoVFADD_VF16_M1_MASK, PseudoVFADD_VF16_M1, PseudoVFADD_VF16_M1_TU, 0x3 }, // 221
  { PseudoVFADD_VF16_M2_MASK, PseudoVFADD_VF16_M2, PseudoVFADD_VF16_M2_TU, 0x3 }, // 222
  { PseudoVFADD_VF16_M4_MASK, PseudoVFADD_VF16_M4, PseudoVFADD_VF16_M4_TU, 0x3 }, // 223
  { PseudoVFADD_VF16_M8_MASK, PseudoVFADD_VF16_M8, PseudoVFADD_VF16_M8_TU, 0x3 }, // 224
  { PseudoVFADD_VF16_MF2_MASK, PseudoVFADD_VF16_MF2, PseudoVFADD_VF16_MF2_TU, 0x3 }, // 225
  { PseudoVFADD_VF16_MF4_MASK, PseudoVFADD_VF16_MF4, PseudoVFADD_VF16_MF4_TU, 0x3 }, // 226
  { PseudoVFADD_VF32_M1_MASK, PseudoVFADD_VF32_M1, PseudoVFADD_VF32_M1_TU, 0x3 }, // 227
  { PseudoVFADD_VF32_M2_MASK, PseudoVFADD_VF32_M2, PseudoVFADD_VF32_M2_TU, 0x3 }, // 228
  { PseudoVFADD_VF32_M4_MASK, PseudoVFADD_VF32_M4, PseudoVFADD_VF32_M4_TU, 0x3 }, // 229
  { PseudoVFADD_VF32_M8_MASK, PseudoVFADD_VF32_M8, PseudoVFADD_VF32_M8_TU, 0x3 }, // 230
  { PseudoVFADD_VF32_MF2_MASK, PseudoVFADD_VF32_MF2, PseudoVFADD_VF32_MF2_TU, 0x3 }, // 231
  { PseudoVFADD_VF64_M1_MASK, PseudoVFADD_VF64_M1, PseudoVFADD_VF64_M1_TU, 0x3 }, // 232
  { PseudoVFADD_VF64_M2_MASK, PseudoVFADD_VF64_M2, PseudoVFADD_VF64_M2_TU, 0x3 }, // 233
  { PseudoVFADD_VF64_M4_MASK, PseudoVFADD_VF64_M4, PseudoVFADD_VF64_M4_TU, 0x3 }, // 234
  { PseudoVFADD_VF64_M8_MASK, PseudoVFADD_VF64_M8, PseudoVFADD_VF64_M8_TU, 0x3 }, // 235
  { PseudoVFADD_VV_M1_MASK, PseudoVFADD_VV_M1, PseudoVFADD_VV_M1_TU, 0x3 }, // 236
  { PseudoVFADD_VV_M2_MASK, PseudoVFADD_VV_M2, PseudoVFADD_VV_M2_TU, 0x3 }, // 237
  { PseudoVFADD_VV_M4_MASK, PseudoVFADD_VV_M4, PseudoVFADD_VV_M4_TU, 0x3 }, // 238
  { PseudoVFADD_VV_M8_MASK, PseudoVFADD_VV_M8, PseudoVFADD_VV_M8_TU, 0x3 }, // 239
  { PseudoVFADD_VV_MF2_MASK, PseudoVFADD_VV_MF2, PseudoVFADD_VV_MF2_TU, 0x3 }, // 240
  { PseudoVFADD_VV_MF4_MASK, PseudoVFADD_VV_MF4, PseudoVFADD_VV_MF4_TU, 0x3 }, // 241
  { PseudoVFCLASS_V_M1_MASK, PseudoVFCLASS_V_M1, PseudoVFCLASS_V_M1_TU, 0x2 }, // 242
  { PseudoVFCLASS_V_M2_MASK, PseudoVFCLASS_V_M2, PseudoVFCLASS_V_M2_TU, 0x2 }, // 243
  { PseudoVFCLASS_V_M4_MASK, PseudoVFCLASS_V_M4, PseudoVFCLASS_V_M4_TU, 0x2 }, // 244
  { PseudoVFCLASS_V_M8_MASK, PseudoVFCLASS_V_M8, PseudoVFCLASS_V_M8_TU, 0x2 }, // 245
  { PseudoVFCLASS_V_MF2_MASK, PseudoVFCLASS_V_MF2, PseudoVFCLASS_V_MF2_TU, 0x2 }, // 246
  { PseudoVFCLASS_V_MF4_MASK, PseudoVFCLASS_V_MF4, PseudoVFCLASS_V_MF4_TU, 0x2 }, // 247
  { PseudoVFCVT_F_XU_V_M1_MASK, PseudoVFCVT_F_XU_V_M1, PseudoVFCVT_F_XU_V_M1_TU, 0x2 }, // 248
  { PseudoVFCVT_F_XU_V_M2_MASK, PseudoVFCVT_F_XU_V_M2, PseudoVFCVT_F_XU_V_M2_TU, 0x2 }, // 249
  { PseudoVFCVT_F_XU_V_M4_MASK, PseudoVFCVT_F_XU_V_M4, PseudoVFCVT_F_XU_V_M4_TU, 0x2 }, // 250
  { PseudoVFCVT_F_XU_V_M8_MASK, PseudoVFCVT_F_XU_V_M8, PseudoVFCVT_F_XU_V_M8_TU, 0x2 }, // 251
  { PseudoVFCVT_F_XU_V_MF2_MASK, PseudoVFCVT_F_XU_V_MF2, PseudoVFCVT_F_XU_V_MF2_TU, 0x2 }, // 252
  { PseudoVFCVT_F_XU_V_MF4_MASK, PseudoVFCVT_F_XU_V_MF4, PseudoVFCVT_F_XU_V_MF4_TU, 0x2 }, // 253
  { PseudoVFCVT_F_X_V_M1_MASK, PseudoVFCVT_F_X_V_M1, PseudoVFCVT_F_X_V_M1_TU, 0x2 }, // 254
  { PseudoVFCVT_F_X_V_M2_MASK, PseudoVFCVT_F_X_V_M2, PseudoVFCVT_F_X_V_M2_TU, 0x2 }, // 255
  { PseudoVFCVT_F_X_V_M4_MASK, PseudoVFCVT_F_X_V_M4, PseudoVFCVT_F_X_V_M4_TU, 0x2 }, // 256
  { PseudoVFCVT_F_X_V_M8_MASK, PseudoVFCVT_F_X_V_M8, PseudoVFCVT_F_X_V_M8_TU, 0x2 }, // 257
  { PseudoVFCVT_F_X_V_MF2_MASK, PseudoVFCVT_F_X_V_MF2, PseudoVFCVT_F_X_V_MF2_TU, 0x2 }, // 258
  { PseudoVFCVT_F_X_V_MF4_MASK, PseudoVFCVT_F_X_V_MF4, PseudoVFCVT_F_X_V_MF4_TU, 0x2 }, // 259
  { PseudoVFCVT_RTZ_XU_F_V_M1_MASK, PseudoVFCVT_RTZ_XU_F_V_M1, PseudoVFCVT_RTZ_XU_F_V_M1_TU, 0x2 }, // 260
  { PseudoVFCVT_RTZ_XU_F_V_M2_MASK, PseudoVFCVT_RTZ_XU_F_V_M2, PseudoVFCVT_RTZ_XU_F_V_M2_TU, 0x2 }, // 261
  { PseudoVFCVT_RTZ_XU_F_V_M4_MASK, PseudoVFCVT_RTZ_XU_F_V_M4, PseudoVFCVT_RTZ_XU_F_V_M4_TU, 0x2 }, // 262
  { PseudoVFCVT_RTZ_XU_F_V_M8_MASK, PseudoVFCVT_RTZ_XU_F_V_M8, PseudoVFCVT_RTZ_XU_F_V_M8_TU, 0x2 }, // 263
  { PseudoVFCVT_RTZ_XU_F_V_MF2_MASK, PseudoVFCVT_RTZ_XU_F_V_MF2, PseudoVFCVT_RTZ_XU_F_V_MF2_TU, 0x2 }, // 264
  { PseudoVFCVT_RTZ_XU_F_V_MF4_MASK, PseudoVFCVT_RTZ_XU_F_V_MF4, PseudoVFCVT_RTZ_XU_F_V_MF4_TU, 0x2 }, // 265
  { PseudoVFCVT_RTZ_X_F_V_M1_MASK, PseudoVFCVT_RTZ_X_F_V_M1, PseudoVFCVT_RTZ_X_F_V_M1_TU, 0x2 }, // 266
  { PseudoVFCVT_RTZ_X_F_V_M2_MASK, PseudoVFCVT_RTZ_X_F_V_M2, PseudoVFCVT_RTZ_X_F_V_M2_TU, 0x2 }, // 267
  { PseudoVFCVT_RTZ_X_F_V_M4_MASK, PseudoVFCVT_RTZ_X_F_V_M4, PseudoVFCVT_RTZ_X_F_V_M4_TU, 0x2 }, // 268
  { PseudoVFCVT_RTZ_X_F_V_M8_MASK, PseudoVFCVT_RTZ_X_F_V_M8, PseudoVFCVT_RTZ_X_F_V_M8_TU, 0x2 }, // 269
  { PseudoVFCVT_RTZ_X_F_V_MF2_MASK, PseudoVFCVT_RTZ_X_F_V_MF2, PseudoVFCVT_RTZ_X_F_V_MF2_TU, 0x2 }, // 270
  { PseudoVFCVT_RTZ_X_F_V_MF4_MASK, PseudoVFCVT_RTZ_X_F_V_MF4, PseudoVFCVT_RTZ_X_F_V_MF4_TU, 0x2 }, // 271
  { PseudoVFCVT_XU_F_V_M1_MASK, PseudoVFCVT_XU_F_V_M1, PseudoVFCVT_XU_F_V_M1_TU, 0x2 }, // 272
  { PseudoVFCVT_XU_F_V_M2_MASK, PseudoVFCVT_XU_F_V_M2, PseudoVFCVT_XU_F_V_M2_TU, 0x2 }, // 273
  { PseudoVFCVT_XU_F_V_M4_MASK, PseudoVFCVT_XU_F_V_M4, PseudoVFCVT_XU_F_V_M4_TU, 0x2 }, // 274
  { PseudoVFCVT_XU_F_V_M8_MASK, PseudoVFCVT_XU_F_V_M8, PseudoVFCVT_XU_F_V_M8_TU, 0x2 }, // 275
  { PseudoVFCVT_XU_F_V_MF2_MASK, PseudoVFCVT_XU_F_V_MF2, PseudoVFCVT_XU_F_V_MF2_TU, 0x2 }, // 276
  { PseudoVFCVT_XU_F_V_MF4_MASK, PseudoVFCVT_XU_F_V_MF4, PseudoVFCVT_XU_F_V_MF4_TU, 0x2 }, // 277
  { PseudoVFCVT_X_F_V_M1_MASK, PseudoVFCVT_X_F_V_M1, PseudoVFCVT_X_F_V_M1_TU, 0x2 }, // 278
  { PseudoVFCVT_X_F_V_M2_MASK, PseudoVFCVT_X_F_V_M2, PseudoVFCVT_X_F_V_M2_TU, 0x2 }, // 279
  { PseudoVFCVT_X_F_V_M4_MASK, PseudoVFCVT_X_F_V_M4, PseudoVFCVT_X_F_V_M4_TU, 0x2 }, // 280
  { PseudoVFCVT_X_F_V_M8_MASK, PseudoVFCVT_X_F_V_M8, PseudoVFCVT_X_F_V_M8_TU, 0x2 }, // 281
  { PseudoVFCVT_X_F_V_MF2_MASK, PseudoVFCVT_X_F_V_MF2, PseudoVFCVT_X_F_V_MF2_TU, 0x2 }, // 282
  { PseudoVFCVT_X_F_V_MF4_MASK, PseudoVFCVT_X_F_V_MF4, PseudoVFCVT_X_F_V_MF4_TU, 0x2 }, // 283
  { PseudoVFDIV_VF16_M1_E16_MASK, PseudoVFDIV_VF16_M1_E16, PseudoVFDIV_VF16_M1_E16_TU, 0x3 }, // 284
  { PseudoVFDIV_VF16_M1_E32_MASK, PseudoVFDIV_VF16_M1_E32, PseudoVFDIV_VF16_M1_E32_TU, 0x3 }, // 285
  { PseudoVFDIV_VF16_M1_E64_MASK, PseudoVFDIV_VF16_M1_E64, PseudoVFDIV_VF16_M1_E64_TU, 0x3 }, // 286
  { PseudoVFDIV_VF16_M2_E16_MASK, PseudoVFDIV_VF16_M2_E16, PseudoVFDIV_VF16_M2_E16_TU, 0x3 }, // 287
  { PseudoVFDIV_VF16_M2_E32_MASK, PseudoVFDIV_VF16_M2_E32, PseudoVFDIV_VF16_M2_E32_TU, 0x3 }, // 288
  { PseudoVFDIV_VF16_M2_E64_MASK, PseudoVFDIV_VF16_M2_E64, PseudoVFDIV_VF16_M2_E64_TU, 0x3 }, // 289
  { PseudoVFDIV_VF16_M4_E16_MASK, PseudoVFDIV_VF16_M4_E16, PseudoVFDIV_VF16_M4_E16_TU, 0x3 }, // 290
  { PseudoVFDIV_VF16_M4_E32_MASK, PseudoVFDIV_VF16_M4_E32, PseudoVFDIV_VF16_M4_E32_TU, 0x3 }, // 291
  { PseudoVFDIV_VF16_M4_E64_MASK, PseudoVFDIV_VF16_M4_E64, PseudoVFDIV_VF16_M4_E64_TU, 0x3 }, // 292
  { PseudoVFDIV_VF16_M8_E16_MASK, PseudoVFDIV_VF16_M8_E16, PseudoVFDIV_VF16_M8_E16_TU, 0x3 }, // 293
  { PseudoVFDIV_VF16_M8_E32_MASK, PseudoVFDIV_VF16_M8_E32, PseudoVFDIV_VF16_M8_E32_TU, 0x3 }, // 294
  { PseudoVFDIV_VF16_M8_E64_MASK, PseudoVFDIV_VF16_M8_E64, PseudoVFDIV_VF16_M8_E64_TU, 0x3 }, // 295
  { PseudoVFDIV_VF16_MF2_E16_MASK, PseudoVFDIV_VF16_MF2_E16, PseudoVFDIV_VF16_MF2_E16_TU, 0x3 }, // 296
  { PseudoVFDIV_VF16_MF2_E32_MASK, PseudoVFDIV_VF16_MF2_E32, PseudoVFDIV_VF16_MF2_E32_TU, 0x3 }, // 297
  { PseudoVFDIV_VF16_MF4_E16_MASK, PseudoVFDIV_VF16_MF4_E16, PseudoVFDIV_VF16_MF4_E16_TU, 0x3 }, // 298
  { PseudoVFDIV_VF32_M1_E16_MASK, PseudoVFDIV_VF32_M1_E16, PseudoVFDIV_VF32_M1_E16_TU, 0x3 }, // 299
  { PseudoVFDIV_VF32_M1_E32_MASK, PseudoVFDIV_VF32_M1_E32, PseudoVFDIV_VF32_M1_E32_TU, 0x3 }, // 300
  { PseudoVFDIV_VF32_M1_E64_MASK, PseudoVFDIV_VF32_M1_E64, PseudoVFDIV_VF32_M1_E64_TU, 0x3 }, // 301
  { PseudoVFDIV_VF32_M2_E16_MASK, PseudoVFDIV_VF32_M2_E16, PseudoVFDIV_VF32_M2_E16_TU, 0x3 }, // 302
  { PseudoVFDIV_VF32_M2_E32_MASK, PseudoVFDIV_VF32_M2_E32, PseudoVFDIV_VF32_M2_E32_TU, 0x3 }, // 303
  { PseudoVFDIV_VF32_M2_E64_MASK, PseudoVFDIV_VF32_M2_E64, PseudoVFDIV_VF32_M2_E64_TU, 0x3 }, // 304
  { PseudoVFDIV_VF32_M4_E16_MASK, PseudoVFDIV_VF32_M4_E16, PseudoVFDIV_VF32_M4_E16_TU, 0x3 }, // 305
  { PseudoVFDIV_VF32_M4_E32_MASK, PseudoVFDIV_VF32_M4_E32, PseudoVFDIV_VF32_M4_E32_TU, 0x3 }, // 306
  { PseudoVFDIV_VF32_M4_E64_MASK, PseudoVFDIV_VF32_M4_E64, PseudoVFDIV_VF32_M4_E64_TU, 0x3 }, // 307
  { PseudoVFDIV_VF32_M8_E16_MASK, PseudoVFDIV_VF32_M8_E16, PseudoVFDIV_VF32_M8_E16_TU, 0x3 }, // 308
  { PseudoVFDIV_VF32_M8_E32_MASK, PseudoVFDIV_VF32_M8_E32, PseudoVFDIV_VF32_M8_E32_TU, 0x3 }, // 309
  { PseudoVFDIV_VF32_M8_E64_MASK, PseudoVFDIV_VF32_M8_E64, PseudoVFDIV_VF32_M8_E64_TU, 0x3 }, // 310
  { PseudoVFDIV_VF32_MF2_E16_MASK, PseudoVFDIV_VF32_MF2_E16, PseudoVFDIV_VF32_MF2_E16_TU, 0x3 }, // 311
  { PseudoVFDIV_VF32_MF2_E32_MASK, PseudoVFDIV_VF32_MF2_E32, PseudoVFDIV_VF32_MF2_E32_TU, 0x3 }, // 312
  { PseudoVFDIV_VF64_M1_E16_MASK, PseudoVFDIV_VF64_M1_E16, PseudoVFDIV_VF64_M1_E16_TU, 0x3 }, // 313
  { PseudoVFDIV_VF64_M1_E32_MASK, PseudoVFDIV_VF64_M1_E32, PseudoVFDIV_VF64_M1_E32_TU, 0x3 }, // 314
  { PseudoVFDIV_VF64_M1_E64_MASK, PseudoVFDIV_VF64_M1_E64, PseudoVFDIV_VF64_M1_E64_TU, 0x3 }, // 315
  { PseudoVFDIV_VF64_M2_E16_MASK, PseudoVFDIV_VF64_M2_E16, PseudoVFDIV_VF64_M2_E16_TU, 0x3 }, // 316
  { PseudoVFDIV_VF64_M2_E32_MASK, PseudoVFDIV_VF64_M2_E32, PseudoVFDIV_VF64_M2_E32_TU, 0x3 }, // 317
  { PseudoVFDIV_VF64_M2_E64_MASK, PseudoVFDIV_VF64_M2_E64, PseudoVFDIV_VF64_M2_E64_TU, 0x3 }, // 318
  { PseudoVFDIV_VF64_M4_E16_MASK, PseudoVFDIV_VF64_M4_E16, PseudoVFDIV_VF64_M4_E16_TU, 0x3 }, // 319
  { PseudoVFDIV_VF64_M4_E32_MASK, PseudoVFDIV_VF64_M4_E32, PseudoVFDIV_VF64_M4_E32_TU, 0x3 }, // 320
  { PseudoVFDIV_VF64_M4_E64_MASK, PseudoVFDIV_VF64_M4_E64, PseudoVFDIV_VF64_M4_E64_TU, 0x3 }, // 321
  { PseudoVFDIV_VF64_M8_E16_MASK, PseudoVFDIV_VF64_M8_E16, PseudoVFDIV_VF64_M8_E16_TU, 0x3 }, // 322
  { PseudoVFDIV_VF64_M8_E32_MASK, PseudoVFDIV_VF64_M8_E32, PseudoVFDIV_VF64_M8_E32_TU, 0x3 }, // 323
  { PseudoVFDIV_VF64_M8_E64_MASK, PseudoVFDIV_VF64_M8_E64, PseudoVFDIV_VF64_M8_E64_TU, 0x3 }, // 324
  { PseudoVFDIV_VV_M1_E16_MASK, PseudoVFDIV_VV_M1_E16, PseudoVFDIV_VV_M1_E16_TU, 0x3 }, // 325
  { PseudoVFDIV_VV_M1_E32_MASK, PseudoVFDIV_VV_M1_E32, PseudoVFDIV_VV_M1_E32_TU, 0x3 }, // 326
  { PseudoVFDIV_VV_M1_E64_MASK, PseudoVFDIV_VV_M1_E64, PseudoVFDIV_VV_M1_E64_TU, 0x3 }, // 327
  { PseudoVFDIV_VV_M2_E16_MASK, PseudoVFDIV_VV_M2_E16, PseudoVFDIV_VV_M2_E16_TU, 0x3 }, // 328
  { PseudoVFDIV_VV_M2_E32_MASK, PseudoVFDIV_VV_M2_E32, PseudoVFDIV_VV_M2_E32_TU, 0x3 }, // 329
  { PseudoVFDIV_VV_M2_E64_MASK, PseudoVFDIV_VV_M2_E64, PseudoVFDIV_VV_M2_E64_TU, 0x3 }, // 330
  { PseudoVFDIV_VV_M4_E16_MASK, PseudoVFDIV_VV_M4_E16, PseudoVFDIV_VV_M4_E16_TU, 0x3 }, // 331
  { PseudoVFDIV_VV_M4_E32_MASK, PseudoVFDIV_VV_M4_E32, PseudoVFDIV_VV_M4_E32_TU, 0x3 }, // 332
  { PseudoVFDIV_VV_M4_E64_MASK, PseudoVFDIV_VV_M4_E64, PseudoVFDIV_VV_M4_E64_TU, 0x3 }, // 333
  { PseudoVFDIV_VV_M8_E16_MASK, PseudoVFDIV_VV_M8_E16, PseudoVFDIV_VV_M8_E16_TU, 0x3 }, // 334
  { PseudoVFDIV_VV_M8_E32_MASK, PseudoVFDIV_VV_M8_E32, PseudoVFDIV_VV_M8_E32_TU, 0x3 }, // 335
  { PseudoVFDIV_VV_M8_E64_MASK, PseudoVFDIV_VV_M8_E64, PseudoVFDIV_VV_M8_E64_TU, 0x3 }, // 336
  { PseudoVFDIV_VV_MF2_E16_MASK, PseudoVFDIV_VV_MF2_E16, PseudoVFDIV_VV_MF2_E16_TU, 0x3 }, // 337
  { PseudoVFDIV_VV_MF2_E32_MASK, PseudoVFDIV_VV_MF2_E32, PseudoVFDIV_VV_MF2_E32_TU, 0x3 }, // 338
  { PseudoVFDIV_VV_MF4_E16_MASK, PseudoVFDIV_VV_MF4_E16, PseudoVFDIV_VV_MF4_E16_TU, 0x3 }, // 339
  { PseudoVFMACC_VF16_M1_MASK, PseudoVFMACC_VF16_M1, PseudoVFMACC_VF16_M1, 0x3 }, // 340
  { PseudoVFMACC_VF16_M2_MASK, PseudoVFMACC_VF16_M2, PseudoVFMACC_VF16_M2, 0x3 }, // 341
  { PseudoVFMACC_VF16_M4_MASK, PseudoVFMACC_VF16_M4, PseudoVFMACC_VF16_M4, 0x3 }, // 342
  { PseudoVFMACC_VF16_M8_MASK, PseudoVFMACC_VF16_M8, PseudoVFMACC_VF16_M8, 0x3 }, // 343
  { PseudoVFMACC_VF16_MF2_MASK, PseudoVFMACC_VF16_MF2, PseudoVFMACC_VF16_MF2, 0x3 }, // 344
  { PseudoVFMACC_VF16_MF4_MASK, PseudoVFMACC_VF16_MF4, PseudoVFMACC_VF16_MF4, 0x3 }, // 345
  { PseudoVFMACC_VF32_M1_MASK, PseudoVFMACC_VF32_M1, PseudoVFMACC_VF32_M1, 0x3 }, // 346
  { PseudoVFMACC_VF32_M2_MASK, PseudoVFMACC_VF32_M2, PseudoVFMACC_VF32_M2, 0x3 }, // 347
  { PseudoVFMACC_VF32_M4_MASK, PseudoVFMACC_VF32_M4, PseudoVFMACC_VF32_M4, 0x3 }, // 348
  { PseudoVFMACC_VF32_M8_MASK, PseudoVFMACC_VF32_M8, PseudoVFMACC_VF32_M8, 0x3 }, // 349
  { PseudoVFMACC_VF32_MF2_MASK, PseudoVFMACC_VF32_MF2, PseudoVFMACC_VF32_MF2, 0x3 }, // 350
  { PseudoVFMACC_VF64_M1_MASK, PseudoVFMACC_VF64_M1, PseudoVFMACC_VF64_M1, 0x3 }, // 351
  { PseudoVFMACC_VF64_M2_MASK, PseudoVFMACC_VF64_M2, PseudoVFMACC_VF64_M2, 0x3 }, // 352
  { PseudoVFMACC_VF64_M4_MASK, PseudoVFMACC_VF64_M4, PseudoVFMACC_VF64_M4, 0x3 }, // 353
  { PseudoVFMACC_VF64_M8_MASK, PseudoVFMACC_VF64_M8, PseudoVFMACC_VF64_M8, 0x3 }, // 354
  { PseudoVFMACC_VV_M1_MASK, PseudoVFMACC_VV_M1, PseudoVFMACC_VV_M1, 0x3 }, // 355
  { PseudoVFMACC_VV_M2_MASK, PseudoVFMACC_VV_M2, PseudoVFMACC_VV_M2, 0x3 }, // 356
  { PseudoVFMACC_VV_M4_MASK, PseudoVFMACC_VV_M4, PseudoVFMACC_VV_M4, 0x3 }, // 357
  { PseudoVFMACC_VV_M8_MASK, PseudoVFMACC_VV_M8, PseudoVFMACC_VV_M8, 0x3 }, // 358
  { PseudoVFMACC_VV_MF2_MASK, PseudoVFMACC_VV_MF2, PseudoVFMACC_VV_MF2, 0x3 }, // 359
  { PseudoVFMACC_VV_MF4_MASK, PseudoVFMACC_VV_MF4, PseudoVFMACC_VV_MF4, 0x3 }, // 360
  { PseudoVFMADD_VF16_M1_MASK, PseudoVFMADD_VF16_M1, PseudoVFMADD_VF16_M1, 0x3 }, // 361
  { PseudoVFMADD_VF16_M2_MASK, PseudoVFMADD_VF16_M2, PseudoVFMADD_VF16_M2, 0x3 }, // 362
  { PseudoVFMADD_VF16_M4_MASK, PseudoVFMADD_VF16_M4, PseudoVFMADD_VF16_M4, 0x3 }, // 363
  { PseudoVFMADD_VF16_M8_MASK, PseudoVFMADD_VF16_M8, PseudoVFMADD_VF16_M8, 0x3 }, // 364
  { PseudoVFMADD_VF16_MF2_MASK, PseudoVFMADD_VF16_MF2, PseudoVFMADD_VF16_MF2, 0x3 }, // 365
  { PseudoVFMADD_VF16_MF4_MASK, PseudoVFMADD_VF16_MF4, PseudoVFMADD_VF16_MF4, 0x3 }, // 366
  { PseudoVFMADD_VF32_M1_MASK, PseudoVFMADD_VF32_M1, PseudoVFMADD_VF32_M1, 0x3 }, // 367
  { PseudoVFMADD_VF32_M2_MASK, PseudoVFMADD_VF32_M2, PseudoVFMADD_VF32_M2, 0x3 }, // 368
  { PseudoVFMADD_VF32_M4_MASK, PseudoVFMADD_VF32_M4, PseudoVFMADD_VF32_M4, 0x3 }, // 369
  { PseudoVFMADD_VF32_M8_MASK, PseudoVFMADD_VF32_M8, PseudoVFMADD_VF32_M8, 0x3 }, // 370
  { PseudoVFMADD_VF32_MF2_MASK, PseudoVFMADD_VF32_MF2, PseudoVFMADD_VF32_MF2, 0x3 }, // 371
  { PseudoVFMADD_VF64_M1_MASK, PseudoVFMADD_VF64_M1, PseudoVFMADD_VF64_M1, 0x3 }, // 372
  { PseudoVFMADD_VF64_M2_MASK, PseudoVFMADD_VF64_M2, PseudoVFMADD_VF64_M2, 0x3 }, // 373
  { PseudoVFMADD_VF64_M4_MASK, PseudoVFMADD_VF64_M4, PseudoVFMADD_VF64_M4, 0x3 }, // 374
  { PseudoVFMADD_VF64_M8_MASK, PseudoVFMADD_VF64_M8, PseudoVFMADD_VF64_M8, 0x3 }, // 375
  { PseudoVFMADD_VV_M1_MASK, PseudoVFMADD_VV_M1, PseudoVFMADD_VV_M1, 0x3 }, // 376
  { PseudoVFMADD_VV_M2_MASK, PseudoVFMADD_VV_M2, PseudoVFMADD_VV_M2, 0x3 }, // 377
  { PseudoVFMADD_VV_M4_MASK, PseudoVFMADD_VV_M4, PseudoVFMADD_VV_M4, 0x3 }, // 378
  { PseudoVFMADD_VV_M8_MASK, PseudoVFMADD_VV_M8, PseudoVFMADD_VV_M8, 0x3 }, // 379
  { PseudoVFMADD_VV_MF2_MASK, PseudoVFMADD_VV_MF2, PseudoVFMADD_VV_MF2, 0x3 }, // 380
  { PseudoVFMADD_VV_MF4_MASK, PseudoVFMADD_VV_MF4, PseudoVFMADD_VV_MF4, 0x3 }, // 381
  { PseudoVFMAX_VF16_M1_MASK, PseudoVFMAX_VF16_M1, PseudoVFMAX_VF16_M1_TU, 0x3 }, // 382
  { PseudoVFMAX_VF16_M2_MASK, PseudoVFMAX_VF16_M2, PseudoVFMAX_VF16_M2_TU, 0x3 }, // 383
  { PseudoVFMAX_VF16_M4_MASK, PseudoVFMAX_VF16_M4, PseudoVFMAX_VF16_M4_TU, 0x3 }, // 384
  { PseudoVFMAX_VF16_M8_MASK, PseudoVFMAX_VF16_M8, PseudoVFMAX_VF16_M8_TU, 0x3 }, // 385
  { PseudoVFMAX_VF16_MF2_MASK, PseudoVFMAX_VF16_MF2, PseudoVFMAX_VF16_MF2_TU, 0x3 }, // 386
  { PseudoVFMAX_VF16_MF4_MASK, PseudoVFMAX_VF16_MF4, PseudoVFMAX_VF16_MF4_TU, 0x3 }, // 387
  { PseudoVFMAX_VF32_M1_MASK, PseudoVFMAX_VF32_M1, PseudoVFMAX_VF32_M1_TU, 0x3 }, // 388
  { PseudoVFMAX_VF32_M2_MASK, PseudoVFMAX_VF32_M2, PseudoVFMAX_VF32_M2_TU, 0x3 }, // 389
  { PseudoVFMAX_VF32_M4_MASK, PseudoVFMAX_VF32_M4, PseudoVFMAX_VF32_M4_TU, 0x3 }, // 390
  { PseudoVFMAX_VF32_M8_MASK, PseudoVFMAX_VF32_M8, PseudoVFMAX_VF32_M8_TU, 0x3 }, // 391
  { PseudoVFMAX_VF32_MF2_MASK, PseudoVFMAX_VF32_MF2, PseudoVFMAX_VF32_MF2_TU, 0x3 }, // 392
  { PseudoVFMAX_VF64_M1_MASK, PseudoVFMAX_VF64_M1, PseudoVFMAX_VF64_M1_TU, 0x3 }, // 393
  { PseudoVFMAX_VF64_M2_MASK, PseudoVFMAX_VF64_M2, PseudoVFMAX_VF64_M2_TU, 0x3 }, // 394
  { PseudoVFMAX_VF64_M4_MASK, PseudoVFMAX_VF64_M4, PseudoVFMAX_VF64_M4_TU, 0x3 }, // 395
  { PseudoVFMAX_VF64_M8_MASK, PseudoVFMAX_VF64_M8, PseudoVFMAX_VF64_M8_TU, 0x3 }, // 396
  { PseudoVFMAX_VV_M1_MASK, PseudoVFMAX_VV_M1, PseudoVFMAX_VV_M1_TU, 0x3 }, // 397
  { PseudoVFMAX_VV_M2_MASK, PseudoVFMAX_VV_M2, PseudoVFMAX_VV_M2_TU, 0x3 }, // 398
  { PseudoVFMAX_VV_M4_MASK, PseudoVFMAX_VV_M4, PseudoVFMAX_VV_M4_TU, 0x3 }, // 399
  { PseudoVFMAX_VV_M8_MASK, PseudoVFMAX_VV_M8, PseudoVFMAX_VV_M8_TU, 0x3 }, // 400
  { PseudoVFMAX_VV_MF2_MASK, PseudoVFMAX_VV_MF2, PseudoVFMAX_VV_MF2_TU, 0x3 }, // 401
  { PseudoVFMAX_VV_MF4_MASK, PseudoVFMAX_VV_MF4, PseudoVFMAX_VV_MF4_TU, 0x3 }, // 402
  { PseudoVFMIN_VF16_M1_MASK, PseudoVFMIN_VF16_M1, PseudoVFMIN_VF16_M1_TU, 0x3 }, // 403
  { PseudoVFMIN_VF16_M2_MASK, PseudoVFMIN_VF16_M2, PseudoVFMIN_VF16_M2_TU, 0x3 }, // 404
  { PseudoVFMIN_VF16_M4_MASK, PseudoVFMIN_VF16_M4, PseudoVFMIN_VF16_M4_TU, 0x3 }, // 405
  { PseudoVFMIN_VF16_M8_MASK, PseudoVFMIN_VF16_M8, PseudoVFMIN_VF16_M8_TU, 0x3 }, // 406
  { PseudoVFMIN_VF16_MF2_MASK, PseudoVFMIN_VF16_MF2, PseudoVFMIN_VF16_MF2_TU, 0x3 }, // 407
  { PseudoVFMIN_VF16_MF4_MASK, PseudoVFMIN_VF16_MF4, PseudoVFMIN_VF16_MF4_TU, 0x3 }, // 408
  { PseudoVFMIN_VF32_M1_MASK, PseudoVFMIN_VF32_M1, PseudoVFMIN_VF32_M1_TU, 0x3 }, // 409
  { PseudoVFMIN_VF32_M2_MASK, PseudoVFMIN_VF32_M2, PseudoVFMIN_VF32_M2_TU, 0x3 }, // 410
  { PseudoVFMIN_VF32_M4_MASK, PseudoVFMIN_VF32_M4, PseudoVFMIN_VF32_M4_TU, 0x3 }, // 411
  { PseudoVFMIN_VF32_M8_MASK, PseudoVFMIN_VF32_M8, PseudoVFMIN_VF32_M8_TU, 0x3 }, // 412
  { PseudoVFMIN_VF32_MF2_MASK, PseudoVFMIN_VF32_MF2, PseudoVFMIN_VF32_MF2_TU, 0x3 }, // 413
  { PseudoVFMIN_VF64_M1_MASK, PseudoVFMIN_VF64_M1, PseudoVFMIN_VF64_M1_TU, 0x3 }, // 414
  { PseudoVFMIN_VF64_M2_MASK, PseudoVFMIN_VF64_M2, PseudoVFMIN_VF64_M2_TU, 0x3 }, // 415
  { PseudoVFMIN_VF64_M4_MASK, PseudoVFMIN_VF64_M4, PseudoVFMIN_VF64_M4_TU, 0x3 }, // 416
  { PseudoVFMIN_VF64_M8_MASK, PseudoVFMIN_VF64_M8, PseudoVFMIN_VF64_M8_TU, 0x3 }, // 417
  { PseudoVFMIN_VV_M1_MASK, PseudoVFMIN_VV_M1, PseudoVFMIN_VV_M1_TU, 0x3 }, // 418
  { PseudoVFMIN_VV_M2_MASK, PseudoVFMIN_VV_M2, PseudoVFMIN_VV_M2_TU, 0x3 }, // 419
  { PseudoVFMIN_VV_M4_MASK, PseudoVFMIN_VV_M4, PseudoVFMIN_VV_M4_TU, 0x3 }, // 420
  { PseudoVFMIN_VV_M8_MASK, PseudoVFMIN_VV_M8, PseudoVFMIN_VV_M8_TU, 0x3 }, // 421
  { PseudoVFMIN_VV_MF2_MASK, PseudoVFMIN_VV_MF2, PseudoVFMIN_VV_MF2_TU, 0x3 }, // 422
  { PseudoVFMIN_VV_MF4_MASK, PseudoVFMIN_VV_MF4, PseudoVFMIN_VV_MF4_TU, 0x3 }, // 423
  { PseudoVFMSAC_VF16_M1_MASK, PseudoVFMSAC_VF16_M1, PseudoVFMSAC_VF16_M1, 0x3 }, // 424
  { PseudoVFMSAC_VF16_M2_MASK, PseudoVFMSAC_VF16_M2, PseudoVFMSAC_VF16_M2, 0x3 }, // 425
  { PseudoVFMSAC_VF16_M4_MASK, PseudoVFMSAC_VF16_M4, PseudoVFMSAC_VF16_M4, 0x3 }, // 426
  { PseudoVFMSAC_VF16_M8_MASK, PseudoVFMSAC_VF16_M8, PseudoVFMSAC_VF16_M8, 0x3 }, // 427
  { PseudoVFMSAC_VF16_MF2_MASK, PseudoVFMSAC_VF16_MF2, PseudoVFMSAC_VF16_MF2, 0x3 }, // 428
  { PseudoVFMSAC_VF16_MF4_MASK, PseudoVFMSAC_VF16_MF4, PseudoVFMSAC_VF16_MF4, 0x3 }, // 429
  { PseudoVFMSAC_VF32_M1_MASK, PseudoVFMSAC_VF32_M1, PseudoVFMSAC_VF32_M1, 0x3 }, // 430
  { PseudoVFMSAC_VF32_M2_MASK, PseudoVFMSAC_VF32_M2, PseudoVFMSAC_VF32_M2, 0x3 }, // 431
  { PseudoVFMSAC_VF32_M4_MASK, PseudoVFMSAC_VF32_M4, PseudoVFMSAC_VF32_M4, 0x3 }, // 432
  { PseudoVFMSAC_VF32_M8_MASK, PseudoVFMSAC_VF32_M8, PseudoVFMSAC_VF32_M8, 0x3 }, // 433
  { PseudoVFMSAC_VF32_MF2_MASK, PseudoVFMSAC_VF32_MF2, PseudoVFMSAC_VF32_MF2, 0x3 }, // 434
  { PseudoVFMSAC_VF64_M1_MASK, PseudoVFMSAC_VF64_M1, PseudoVFMSAC_VF64_M1, 0x3 }, // 435
  { PseudoVFMSAC_VF64_M2_MASK, PseudoVFMSAC_VF64_M2, PseudoVFMSAC_VF64_M2, 0x3 }, // 436
  { PseudoVFMSAC_VF64_M4_MASK, PseudoVFMSAC_VF64_M4, PseudoVFMSAC_VF64_M4, 0x3 }, // 437
  { PseudoVFMSAC_VF64_M8_MASK, PseudoVFMSAC_VF64_M8, PseudoVFMSAC_VF64_M8, 0x3 }, // 438
  { PseudoVFMSAC_VV_M1_MASK, PseudoVFMSAC_VV_M1, PseudoVFMSAC_VV_M1, 0x3 }, // 439
  { PseudoVFMSAC_VV_M2_MASK, PseudoVFMSAC_VV_M2, PseudoVFMSAC_VV_M2, 0x3 }, // 440
  { PseudoVFMSAC_VV_M4_MASK, PseudoVFMSAC_VV_M4, PseudoVFMSAC_VV_M4, 0x3 }, // 441
  { PseudoVFMSAC_VV_M8_MASK, PseudoVFMSAC_VV_M8, PseudoVFMSAC_VV_M8, 0x3 }, // 442
  { PseudoVFMSAC_VV_MF2_MASK, PseudoVFMSAC_VV_MF2, PseudoVFMSAC_VV_MF2, 0x3 }, // 443
  { PseudoVFMSAC_VV_MF4_MASK, PseudoVFMSAC_VV_MF4, PseudoVFMSAC_VV_MF4, 0x3 }, // 444
  { PseudoVFMSUB_VF16_M1_MASK, PseudoVFMSUB_VF16_M1, PseudoVFMSUB_VF16_M1, 0x3 }, // 445
  { PseudoVFMSUB_VF16_M2_MASK, PseudoVFMSUB_VF16_M2, PseudoVFMSUB_VF16_M2, 0x3 }, // 446
  { PseudoVFMSUB_VF16_M4_MASK, PseudoVFMSUB_VF16_M4, PseudoVFMSUB_VF16_M4, 0x3 }, // 447
  { PseudoVFMSUB_VF16_M8_MASK, PseudoVFMSUB_VF16_M8, PseudoVFMSUB_VF16_M8, 0x3 }, // 448
  { PseudoVFMSUB_VF16_MF2_MASK, PseudoVFMSUB_VF16_MF2, PseudoVFMSUB_VF16_MF2, 0x3 }, // 449
  { PseudoVFMSUB_VF16_MF4_MASK, PseudoVFMSUB_VF16_MF4, PseudoVFMSUB_VF16_MF4, 0x3 }, // 450
  { PseudoVFMSUB_VF32_M1_MASK, PseudoVFMSUB_VF32_M1, PseudoVFMSUB_VF32_M1, 0x3 }, // 451
  { PseudoVFMSUB_VF32_M2_MASK, PseudoVFMSUB_VF32_M2, PseudoVFMSUB_VF32_M2, 0x3 }, // 452
  { PseudoVFMSUB_VF32_M4_MASK, PseudoVFMSUB_VF32_M4, PseudoVFMSUB_VF32_M4, 0x3 }, // 453
  { PseudoVFMSUB_VF32_M8_MASK, PseudoVFMSUB_VF32_M8, PseudoVFMSUB_VF32_M8, 0x3 }, // 454
  { PseudoVFMSUB_VF32_MF2_MASK, PseudoVFMSUB_VF32_MF2, PseudoVFMSUB_VF32_MF2, 0x3 }, // 455
  { PseudoVFMSUB_VF64_M1_MASK, PseudoVFMSUB_VF64_M1, PseudoVFMSUB_VF64_M1, 0x3 }, // 456
  { PseudoVFMSUB_VF64_M2_MASK, PseudoVFMSUB_VF64_M2, PseudoVFMSUB_VF64_M2, 0x3 }, // 457
  { PseudoVFMSUB_VF64_M4_MASK, PseudoVFMSUB_VF64_M4, PseudoVFMSUB_VF64_M4, 0x3 }, // 458
  { PseudoVFMSUB_VF64_M8_MASK, PseudoVFMSUB_VF64_M8, PseudoVFMSUB_VF64_M8, 0x3 }, // 459
  { PseudoVFMSUB_VV_M1_MASK, PseudoVFMSUB_VV_M1, PseudoVFMSUB_VV_M1, 0x3 }, // 460
  { PseudoVFMSUB_VV_M2_MASK, PseudoVFMSUB_VV_M2, PseudoVFMSUB_VV_M2, 0x3 }, // 461
  { PseudoVFMSUB_VV_M4_MASK, PseudoVFMSUB_VV_M4, PseudoVFMSUB_VV_M4, 0x3 }, // 462
  { PseudoVFMSUB_VV_M8_MASK, PseudoVFMSUB_VV_M8, PseudoVFMSUB_VV_M8, 0x3 }, // 463
  { PseudoVFMSUB_VV_MF2_MASK, PseudoVFMSUB_VV_MF2, PseudoVFMSUB_VV_MF2, 0x3 }, // 464
  { PseudoVFMSUB_VV_MF4_MASK, PseudoVFMSUB_VV_MF4, PseudoVFMSUB_VV_MF4, 0x3 }, // 465
  { PseudoVFMUL_VF16_M1_MASK, PseudoVFMUL_VF16_M1, PseudoVFMUL_VF16_M1_TU, 0x3 }, // 466
  { PseudoVFMUL_VF16_M2_MASK, PseudoVFMUL_VF16_M2, PseudoVFMUL_VF16_M2_TU, 0x3 }, // 467
  { PseudoVFMUL_VF16_M4_MASK, PseudoVFMUL_VF16_M4, PseudoVFMUL_VF16_M4_TU, 0x3 }, // 468
  { PseudoVFMUL_VF16_M8_MASK, PseudoVFMUL_VF16_M8, PseudoVFMUL_VF16_M8_TU, 0x3 }, // 469
  { PseudoVFMUL_VF16_MF2_MASK, PseudoVFMUL_VF16_MF2, PseudoVFMUL_VF16_MF2_TU, 0x3 }, // 470
  { PseudoVFMUL_VF16_MF4_MASK, PseudoVFMUL_VF16_MF4, PseudoVFMUL_VF16_MF4_TU, 0x3 }, // 471
  { PseudoVFMUL_VF32_M1_MASK, PseudoVFMUL_VF32_M1, PseudoVFMUL_VF32_M1_TU, 0x3 }, // 472
  { PseudoVFMUL_VF32_M2_MASK, PseudoVFMUL_VF32_M2, PseudoVFMUL_VF32_M2_TU, 0x3 }, // 473
  { PseudoVFMUL_VF32_M4_MASK, PseudoVFMUL_VF32_M4, PseudoVFMUL_VF32_M4_TU, 0x3 }, // 474
  { PseudoVFMUL_VF32_M8_MASK, PseudoVFMUL_VF32_M8, PseudoVFMUL_VF32_M8_TU, 0x3 }, // 475
  { PseudoVFMUL_VF32_MF2_MASK, PseudoVFMUL_VF32_MF2, PseudoVFMUL_VF32_MF2_TU, 0x3 }, // 476
  { PseudoVFMUL_VF64_M1_MASK, PseudoVFMUL_VF64_M1, PseudoVFMUL_VF64_M1_TU, 0x3 }, // 477
  { PseudoVFMUL_VF64_M2_MASK, PseudoVFMUL_VF64_M2, PseudoVFMUL_VF64_M2_TU, 0x3 }, // 478
  { PseudoVFMUL_VF64_M4_MASK, PseudoVFMUL_VF64_M4, PseudoVFMUL_VF64_M4_TU, 0x3 }, // 479
  { PseudoVFMUL_VF64_M8_MASK, PseudoVFMUL_VF64_M8, PseudoVFMUL_VF64_M8_TU, 0x3 }, // 480
  { PseudoVFMUL_VV_M1_MASK, PseudoVFMUL_VV_M1, PseudoVFMUL_VV_M1_TU, 0x3 }, // 481
  { PseudoVFMUL_VV_M2_MASK, PseudoVFMUL_VV_M2, PseudoVFMUL_VV_M2_TU, 0x3 }, // 482
  { PseudoVFMUL_VV_M4_MASK, PseudoVFMUL_VV_M4, PseudoVFMUL_VV_M4_TU, 0x3 }, // 483
  { PseudoVFMUL_VV_M8_MASK, PseudoVFMUL_VV_M8, PseudoVFMUL_VV_M8_TU, 0x3 }, // 484
  { PseudoVFMUL_VV_MF2_MASK, PseudoVFMUL_VV_MF2, PseudoVFMUL_VV_MF2_TU, 0x3 }, // 485
  { PseudoVFMUL_VV_MF4_MASK, PseudoVFMUL_VV_MF4, PseudoVFMUL_VV_MF4_TU, 0x3 }, // 486
  { PseudoVFNCVT_F_F_W_M1_MASK, PseudoVFNCVT_F_F_W_M1, PseudoVFNCVT_F_F_W_M1_TU, 0x2 }, // 487
  { PseudoVFNCVT_F_F_W_M2_MASK, PseudoVFNCVT_F_F_W_M2, PseudoVFNCVT_F_F_W_M2_TU, 0x2 }, // 488
  { PseudoVFNCVT_F_F_W_M4_MASK, PseudoVFNCVT_F_F_W_M4, PseudoVFNCVT_F_F_W_M4_TU, 0x2 }, // 489
  { PseudoVFNCVT_F_F_W_MF2_MASK, PseudoVFNCVT_F_F_W_MF2, PseudoVFNCVT_F_F_W_MF2_TU, 0x2 }, // 490
  { PseudoVFNCVT_F_F_W_MF4_MASK, PseudoVFNCVT_F_F_W_MF4, PseudoVFNCVT_F_F_W_MF4_TU, 0x2 }, // 491
  { PseudoVFNCVT_F_XU_W_M1_MASK, PseudoVFNCVT_F_XU_W_M1, PseudoVFNCVT_F_XU_W_M1_TU, 0x2 }, // 492
  { PseudoVFNCVT_F_XU_W_M2_MASK, PseudoVFNCVT_F_XU_W_M2, PseudoVFNCVT_F_XU_W_M2_TU, 0x2 }, // 493
  { PseudoVFNCVT_F_XU_W_M4_MASK, PseudoVFNCVT_F_XU_W_M4, PseudoVFNCVT_F_XU_W_M4_TU, 0x2 }, // 494
  { PseudoVFNCVT_F_XU_W_MF2_MASK, PseudoVFNCVT_F_XU_W_MF2, PseudoVFNCVT_F_XU_W_MF2_TU, 0x2 }, // 495
  { PseudoVFNCVT_F_XU_W_MF4_MASK, PseudoVFNCVT_F_XU_W_MF4, PseudoVFNCVT_F_XU_W_MF4_TU, 0x2 }, // 496
  { PseudoVFNCVT_F_X_W_M1_MASK, PseudoVFNCVT_F_X_W_M1, PseudoVFNCVT_F_X_W_M1_TU, 0x2 }, // 497
  { PseudoVFNCVT_F_X_W_M2_MASK, PseudoVFNCVT_F_X_W_M2, PseudoVFNCVT_F_X_W_M2_TU, 0x2 }, // 498
  { PseudoVFNCVT_F_X_W_M4_MASK, PseudoVFNCVT_F_X_W_M4, PseudoVFNCVT_F_X_W_M4_TU, 0x2 }, // 499
  { PseudoVFNCVT_F_X_W_MF2_MASK, PseudoVFNCVT_F_X_W_MF2, PseudoVFNCVT_F_X_W_MF2_TU, 0x2 }, // 500
  { PseudoVFNCVT_F_X_W_MF4_MASK, PseudoVFNCVT_F_X_W_MF4, PseudoVFNCVT_F_X_W_MF4_TU, 0x2 }, // 501
  { PseudoVFNCVT_ROD_F_F_W_M1_MASK, PseudoVFNCVT_ROD_F_F_W_M1, PseudoVFNCVT_ROD_F_F_W_M1_TU, 0x2 }, // 502
  { PseudoVFNCVT_ROD_F_F_W_M2_MASK, PseudoVFNCVT_ROD_F_F_W_M2, PseudoVFNCVT_ROD_F_F_W_M2_TU, 0x2 }, // 503
  { PseudoVFNCVT_ROD_F_F_W_M4_MASK, PseudoVFNCVT_ROD_F_F_W_M4, PseudoVFNCVT_ROD_F_F_W_M4_TU, 0x2 }, // 504
  { PseudoVFNCVT_ROD_F_F_W_MF2_MASK, PseudoVFNCVT_ROD_F_F_W_MF2, PseudoVFNCVT_ROD_F_F_W_MF2_TU, 0x2 }, // 505
  { PseudoVFNCVT_ROD_F_F_W_MF4_MASK, PseudoVFNCVT_ROD_F_F_W_MF4, PseudoVFNCVT_ROD_F_F_W_MF4_TU, 0x2 }, // 506
  { PseudoVFNCVT_RTZ_XU_F_W_M1_MASK, PseudoVFNCVT_RTZ_XU_F_W_M1, PseudoVFNCVT_RTZ_XU_F_W_M1_TU, 0x2 }, // 507
  { PseudoVFNCVT_RTZ_XU_F_W_M2_MASK, PseudoVFNCVT_RTZ_XU_F_W_M2, PseudoVFNCVT_RTZ_XU_F_W_M2_TU, 0x2 }, // 508
  { PseudoVFNCVT_RTZ_XU_F_W_M4_MASK, PseudoVFNCVT_RTZ_XU_F_W_M4, PseudoVFNCVT_RTZ_XU_F_W_M4_TU, 0x2 }, // 509
  { PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK, PseudoVFNCVT_RTZ_XU_F_W_MF2, PseudoVFNCVT_RTZ_XU_F_W_MF2_TU, 0x2 }, // 510
  { PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK, PseudoVFNCVT_RTZ_XU_F_W_MF4, PseudoVFNCVT_RTZ_XU_F_W_MF4_TU, 0x2 }, // 511
  { PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK, PseudoVFNCVT_RTZ_XU_F_W_MF8, PseudoVFNCVT_RTZ_XU_F_W_MF8_TU, 0x2 }, // 512
  { PseudoVFNCVT_RTZ_X_F_W_M1_MASK, PseudoVFNCVT_RTZ_X_F_W_M1, PseudoVFNCVT_RTZ_X_F_W_M1_TU, 0x2 }, // 513
  { PseudoVFNCVT_RTZ_X_F_W_M2_MASK, PseudoVFNCVT_RTZ_X_F_W_M2, PseudoVFNCVT_RTZ_X_F_W_M2_TU, 0x2 }, // 514
  { PseudoVFNCVT_RTZ_X_F_W_M4_MASK, PseudoVFNCVT_RTZ_X_F_W_M4, PseudoVFNCVT_RTZ_X_F_W_M4_TU, 0x2 }, // 515
  { PseudoVFNCVT_RTZ_X_F_W_MF2_MASK, PseudoVFNCVT_RTZ_X_F_W_MF2, PseudoVFNCVT_RTZ_X_F_W_MF2_TU, 0x2 }, // 516
  { PseudoVFNCVT_RTZ_X_F_W_MF4_MASK, PseudoVFNCVT_RTZ_X_F_W_MF4, PseudoVFNCVT_RTZ_X_F_W_MF4_TU, 0x2 }, // 517
  { PseudoVFNCVT_RTZ_X_F_W_MF8_MASK, PseudoVFNCVT_RTZ_X_F_W_MF8, PseudoVFNCVT_RTZ_X_F_W_MF8_TU, 0x2 }, // 518
  { PseudoVFNCVT_XU_F_W_M1_MASK, PseudoVFNCVT_XU_F_W_M1, PseudoVFNCVT_XU_F_W_M1_TU, 0x2 }, // 519
  { PseudoVFNCVT_XU_F_W_M2_MASK, PseudoVFNCVT_XU_F_W_M2, PseudoVFNCVT_XU_F_W_M2_TU, 0x2 }, // 520
  { PseudoVFNCVT_XU_F_W_M4_MASK, PseudoVFNCVT_XU_F_W_M4, PseudoVFNCVT_XU_F_W_M4_TU, 0x2 }, // 521
  { PseudoVFNCVT_XU_F_W_MF2_MASK, PseudoVFNCVT_XU_F_W_MF2, PseudoVFNCVT_XU_F_W_MF2_TU, 0x2 }, // 522
  { PseudoVFNCVT_XU_F_W_MF4_MASK, PseudoVFNCVT_XU_F_W_MF4, PseudoVFNCVT_XU_F_W_MF4_TU, 0x2 }, // 523
  { PseudoVFNCVT_XU_F_W_MF8_MASK, PseudoVFNCVT_XU_F_W_MF8, PseudoVFNCVT_XU_F_W_MF8_TU, 0x2 }, // 524
  { PseudoVFNCVT_X_F_W_M1_MASK, PseudoVFNCVT_X_F_W_M1, PseudoVFNCVT_X_F_W_M1_TU, 0x2 }, // 525
  { PseudoVFNCVT_X_F_W_M2_MASK, PseudoVFNCVT_X_F_W_M2, PseudoVFNCVT_X_F_W_M2_TU, 0x2 }, // 526
  { PseudoVFNCVT_X_F_W_M4_MASK, PseudoVFNCVT_X_F_W_M4, PseudoVFNCVT_X_F_W_M4_TU, 0x2 }, // 527
  { PseudoVFNCVT_X_F_W_MF2_MASK, PseudoVFNCVT_X_F_W_MF2, PseudoVFNCVT_X_F_W_MF2_TU, 0x2 }, // 528
  { PseudoVFNCVT_X_F_W_MF4_MASK, PseudoVFNCVT_X_F_W_MF4, PseudoVFNCVT_X_F_W_MF4_TU, 0x2 }, // 529
  { PseudoVFNCVT_X_F_W_MF8_MASK, PseudoVFNCVT_X_F_W_MF8, PseudoVFNCVT_X_F_W_MF8_TU, 0x2 }, // 530
  { PseudoVFNMACC_VF16_M1_MASK, PseudoVFNMACC_VF16_M1, PseudoVFNMACC_VF16_M1, 0x3 }, // 531
  { PseudoVFNMACC_VF16_M2_MASK, PseudoVFNMACC_VF16_M2, PseudoVFNMACC_VF16_M2, 0x3 }, // 532
  { PseudoVFNMACC_VF16_M4_MASK, PseudoVFNMACC_VF16_M4, PseudoVFNMACC_VF16_M4, 0x3 }, // 533
  { PseudoVFNMACC_VF16_M8_MASK, PseudoVFNMACC_VF16_M8, PseudoVFNMACC_VF16_M8, 0x3 }, // 534
  { PseudoVFNMACC_VF16_MF2_MASK, PseudoVFNMACC_VF16_MF2, PseudoVFNMACC_VF16_MF2, 0x3 }, // 535
  { PseudoVFNMACC_VF16_MF4_MASK, PseudoVFNMACC_VF16_MF4, PseudoVFNMACC_VF16_MF4, 0x3 }, // 536
  { PseudoVFNMACC_VF32_M1_MASK, PseudoVFNMACC_VF32_M1, PseudoVFNMACC_VF32_M1, 0x3 }, // 537
  { PseudoVFNMACC_VF32_M2_MASK, PseudoVFNMACC_VF32_M2, PseudoVFNMACC_VF32_M2, 0x3 }, // 538
  { PseudoVFNMACC_VF32_M4_MASK, PseudoVFNMACC_VF32_M4, PseudoVFNMACC_VF32_M4, 0x3 }, // 539
  { PseudoVFNMACC_VF32_M8_MASK, PseudoVFNMACC_VF32_M8, PseudoVFNMACC_VF32_M8, 0x3 }, // 540
  { PseudoVFNMACC_VF32_MF2_MASK, PseudoVFNMACC_VF32_MF2, PseudoVFNMACC_VF32_MF2, 0x3 }, // 541
  { PseudoVFNMACC_VF64_M1_MASK, PseudoVFNMACC_VF64_M1, PseudoVFNMACC_VF64_M1, 0x3 }, // 542
  { PseudoVFNMACC_VF64_M2_MASK, PseudoVFNMACC_VF64_M2, PseudoVFNMACC_VF64_M2, 0x3 }, // 543
  { PseudoVFNMACC_VF64_M4_MASK, PseudoVFNMACC_VF64_M4, PseudoVFNMACC_VF64_M4, 0x3 }, // 544
  { PseudoVFNMACC_VF64_M8_MASK, PseudoVFNMACC_VF64_M8, PseudoVFNMACC_VF64_M8, 0x3 }, // 545
  { PseudoVFNMACC_VV_M1_MASK, PseudoVFNMACC_VV_M1, PseudoVFNMACC_VV_M1, 0x3 }, // 546
  { PseudoVFNMACC_VV_M2_MASK, PseudoVFNMACC_VV_M2, PseudoVFNMACC_VV_M2, 0x3 }, // 547
  { PseudoVFNMACC_VV_M4_MASK, PseudoVFNMACC_VV_M4, PseudoVFNMACC_VV_M4, 0x3 }, // 548
  { PseudoVFNMACC_VV_M8_MASK, PseudoVFNMACC_VV_M8, PseudoVFNMACC_VV_M8, 0x3 }, // 549
  { PseudoVFNMACC_VV_MF2_MASK, PseudoVFNMACC_VV_MF2, PseudoVFNMACC_VV_MF2, 0x3 }, // 550
  { PseudoVFNMACC_VV_MF4_MASK, PseudoVFNMACC_VV_MF4, PseudoVFNMACC_VV_MF4, 0x3 }, // 551
  { PseudoVFNMADD_VF16_M1_MASK, PseudoVFNMADD_VF16_M1, PseudoVFNMADD_VF16_M1, 0x3 }, // 552
  { PseudoVFNMADD_VF16_M2_MASK, PseudoVFNMADD_VF16_M2, PseudoVFNMADD_VF16_M2, 0x3 }, // 553
  { PseudoVFNMADD_VF16_M4_MASK, PseudoVFNMADD_VF16_M4, PseudoVFNMADD_VF16_M4, 0x3 }, // 554
  { PseudoVFNMADD_VF16_M8_MASK, PseudoVFNMADD_VF16_M8, PseudoVFNMADD_VF16_M8, 0x3 }, // 555
  { PseudoVFNMADD_VF16_MF2_MASK, PseudoVFNMADD_VF16_MF2, PseudoVFNMADD_VF16_MF2, 0x3 }, // 556
  { PseudoVFNMADD_VF16_MF4_MASK, PseudoVFNMADD_VF16_MF4, PseudoVFNMADD_VF16_MF4, 0x3 }, // 557
  { PseudoVFNMADD_VF32_M1_MASK, PseudoVFNMADD_VF32_M1, PseudoVFNMADD_VF32_M1, 0x3 }, // 558
  { PseudoVFNMADD_VF32_M2_MASK, PseudoVFNMADD_VF32_M2, PseudoVFNMADD_VF32_M2, 0x3 }, // 559
  { PseudoVFNMADD_VF32_M4_MASK, PseudoVFNMADD_VF32_M4, PseudoVFNMADD_VF32_M4, 0x3 }, // 560
  { PseudoVFNMADD_VF32_M8_MASK, PseudoVFNMADD_VF32_M8, PseudoVFNMADD_VF32_M8, 0x3 }, // 561
  { PseudoVFNMADD_VF32_MF2_MASK, PseudoVFNMADD_VF32_MF2, PseudoVFNMADD_VF32_MF2, 0x3 }, // 562
  { PseudoVFNMADD_VF64_M1_MASK, PseudoVFNMADD_VF64_M1, PseudoVFNMADD_VF64_M1, 0x3 }, // 563
  { PseudoVFNMADD_VF64_M2_MASK, PseudoVFNMADD_VF64_M2, PseudoVFNMADD_VF64_M2, 0x3 }, // 564
  { PseudoVFNMADD_VF64_M4_MASK, PseudoVFNMADD_VF64_M4, PseudoVFNMADD_VF64_M4, 0x3 }, // 565
  { PseudoVFNMADD_VF64_M8_MASK, PseudoVFNMADD_VF64_M8, PseudoVFNMADD_VF64_M8, 0x3 }, // 566
  { PseudoVFNMADD_VV_M1_MASK, PseudoVFNMADD_VV_M1, PseudoVFNMADD_VV_M1, 0x3 }, // 567
  { PseudoVFNMADD_VV_M2_MASK, PseudoVFNMADD_VV_M2, PseudoVFNMADD_VV_M2, 0x3 }, // 568
  { PseudoVFNMADD_VV_M4_MASK, PseudoVFNMADD_VV_M4, PseudoVFNMADD_VV_M4, 0x3 }, // 569
  { PseudoVFNMADD_VV_M8_MASK, PseudoVFNMADD_VV_M8, PseudoVFNMADD_VV_M8, 0x3 }, // 570
  { PseudoVFNMADD_VV_MF2_MASK, PseudoVFNMADD_VV_MF2, PseudoVFNMADD_VV_MF2, 0x3 }, // 571
  { PseudoVFNMADD_VV_MF4_MASK, PseudoVFNMADD_VV_MF4, PseudoVFNMADD_VV_MF4, 0x3 }, // 572
  { PseudoVFNMSAC_VF16_M1_MASK, PseudoVFNMSAC_VF16_M1, PseudoVFNMSAC_VF16_M1, 0x3 }, // 573
  { PseudoVFNMSAC_VF16_M2_MASK, PseudoVFNMSAC_VF16_M2, PseudoVFNMSAC_VF16_M2, 0x3 }, // 574
  { PseudoVFNMSAC_VF16_M4_MASK, PseudoVFNMSAC_VF16_M4, PseudoVFNMSAC_VF16_M4, 0x3 }, // 575
  { PseudoVFNMSAC_VF16_M8_MASK, PseudoVFNMSAC_VF16_M8, PseudoVFNMSAC_VF16_M8, 0x3 }, // 576
  { PseudoVFNMSAC_VF16_MF2_MASK, PseudoVFNMSAC_VF16_MF2, PseudoVFNMSAC_VF16_MF2, 0x3 }, // 577
  { PseudoVFNMSAC_VF16_MF4_MASK, PseudoVFNMSAC_VF16_MF4, PseudoVFNMSAC_VF16_MF4, 0x3 }, // 578
  { PseudoVFNMSAC_VF32_M1_MASK, PseudoVFNMSAC_VF32_M1, PseudoVFNMSAC_VF32_M1, 0x3 }, // 579
  { PseudoVFNMSAC_VF32_M2_MASK, PseudoVFNMSAC_VF32_M2, PseudoVFNMSAC_VF32_M2, 0x3 }, // 580
  { PseudoVFNMSAC_VF32_M4_MASK, PseudoVFNMSAC_VF32_M4, PseudoVFNMSAC_VF32_M4, 0x3 }, // 581
  { PseudoVFNMSAC_VF32_M8_MASK, PseudoVFNMSAC_VF32_M8, PseudoVFNMSAC_VF32_M8, 0x3 }, // 582
  { PseudoVFNMSAC_VF32_MF2_MASK, PseudoVFNMSAC_VF32_MF2, PseudoVFNMSAC_VF32_MF2, 0x3 }, // 583
  { PseudoVFNMSAC_VF64_M1_MASK, PseudoVFNMSAC_VF64_M1, PseudoVFNMSAC_VF64_M1, 0x3 }, // 584
  { PseudoVFNMSAC_VF64_M2_MASK, PseudoVFNMSAC_VF64_M2, PseudoVFNMSAC_VF64_M2, 0x3 }, // 585
  { PseudoVFNMSAC_VF64_M4_MASK, PseudoVFNMSAC_VF64_M4, PseudoVFNMSAC_VF64_M4, 0x3 }, // 586
  { PseudoVFNMSAC_VF64_M8_MASK, PseudoVFNMSAC_VF64_M8, PseudoVFNMSAC_VF64_M8, 0x3 }, // 587
  { PseudoVFNMSAC_VV_M1_MASK, PseudoVFNMSAC_VV_M1, PseudoVFNMSAC_VV_M1, 0x3 }, // 588
  { PseudoVFNMSAC_VV_M2_MASK, PseudoVFNMSAC_VV_M2, PseudoVFNMSAC_VV_M2, 0x3 }, // 589
  { PseudoVFNMSAC_VV_M4_MASK, PseudoVFNMSAC_VV_M4, PseudoVFNMSAC_VV_M4, 0x3 }, // 590
  { PseudoVFNMSAC_VV_M8_MASK, PseudoVFNMSAC_VV_M8, PseudoVFNMSAC_VV_M8, 0x3 }, // 591
  { PseudoVFNMSAC_VV_MF2_MASK, PseudoVFNMSAC_VV_MF2, PseudoVFNMSAC_VV_MF2, 0x3 }, // 592
  { PseudoVFNMSAC_VV_MF4_MASK, PseudoVFNMSAC_VV_MF4, PseudoVFNMSAC_VV_MF4, 0x3 }, // 593
  { PseudoVFNMSUB_VF16_M1_MASK, PseudoVFNMSUB_VF16_M1, PseudoVFNMSUB_VF16_M1, 0x3 }, // 594
  { PseudoVFNMSUB_VF16_M2_MASK, PseudoVFNMSUB_VF16_M2, PseudoVFNMSUB_VF16_M2, 0x3 }, // 595
  { PseudoVFNMSUB_VF16_M4_MASK, PseudoVFNMSUB_VF16_M4, PseudoVFNMSUB_VF16_M4, 0x3 }, // 596
  { PseudoVFNMSUB_VF16_M8_MASK, PseudoVFNMSUB_VF16_M8, PseudoVFNMSUB_VF16_M8, 0x3 }, // 597
  { PseudoVFNMSUB_VF16_MF2_MASK, PseudoVFNMSUB_VF16_MF2, PseudoVFNMSUB_VF16_MF2, 0x3 }, // 598
  { PseudoVFNMSUB_VF16_MF4_MASK, PseudoVFNMSUB_VF16_MF4, PseudoVFNMSUB_VF16_MF4, 0x3 }, // 599
  { PseudoVFNMSUB_VF32_M1_MASK, PseudoVFNMSUB_VF32_M1, PseudoVFNMSUB_VF32_M1, 0x3 }, // 600
  { PseudoVFNMSUB_VF32_M2_MASK, PseudoVFNMSUB_VF32_M2, PseudoVFNMSUB_VF32_M2, 0x3 }, // 601
  { PseudoVFNMSUB_VF32_M4_MASK, PseudoVFNMSUB_VF32_M4, PseudoVFNMSUB_VF32_M4, 0x3 }, // 602
  { PseudoVFNMSUB_VF32_M8_MASK, PseudoVFNMSUB_VF32_M8, PseudoVFNMSUB_VF32_M8, 0x3 }, // 603
  { PseudoVFNMSUB_VF32_MF2_MASK, PseudoVFNMSUB_VF32_MF2, PseudoVFNMSUB_VF32_MF2, 0x3 }, // 604
  { PseudoVFNMSUB_VF64_M1_MASK, PseudoVFNMSUB_VF64_M1, PseudoVFNMSUB_VF64_M1, 0x3 }, // 605
  { PseudoVFNMSUB_VF64_M2_MASK, PseudoVFNMSUB_VF64_M2, PseudoVFNMSUB_VF64_M2, 0x3 }, // 606
  { PseudoVFNMSUB_VF64_M4_MASK, PseudoVFNMSUB_VF64_M4, PseudoVFNMSUB_VF64_M4, 0x3 }, // 607
  { PseudoVFNMSUB_VF64_M8_MASK, PseudoVFNMSUB_VF64_M8, PseudoVFNMSUB_VF64_M8, 0x3 }, // 608
  { PseudoVFNMSUB_VV_M1_MASK, PseudoVFNMSUB_VV_M1, PseudoVFNMSUB_VV_M1, 0x3 }, // 609
  { PseudoVFNMSUB_VV_M2_MASK, PseudoVFNMSUB_VV_M2, PseudoVFNMSUB_VV_M2, 0x3 }, // 610
  { PseudoVFNMSUB_VV_M4_MASK, PseudoVFNMSUB_VV_M4, PseudoVFNMSUB_VV_M4, 0x3 }, // 611
  { PseudoVFNMSUB_VV_M8_MASK, PseudoVFNMSUB_VV_M8, PseudoVFNMSUB_VV_M8, 0x3 }, // 612
  { PseudoVFNMSUB_VV_MF2_MASK, PseudoVFNMSUB_VV_MF2, PseudoVFNMSUB_VV_MF2, 0x3 }, // 613
  { PseudoVFNMSUB_VV_MF4_MASK, PseudoVFNMSUB_VV_MF4, PseudoVFNMSUB_VV_MF4, 0x3 }, // 614
  { PseudoVFRDIV_VF16_M1_E16_MASK, PseudoVFRDIV_VF16_M1_E16, PseudoVFRDIV_VF16_M1_E16_TU, 0x3 }, // 615
  { PseudoVFRDIV_VF16_M1_E32_MASK, PseudoVFRDIV_VF16_M1_E32, PseudoVFRDIV_VF16_M1_E32_TU, 0x3 }, // 616
  { PseudoVFRDIV_VF16_M1_E64_MASK, PseudoVFRDIV_VF16_M1_E64, PseudoVFRDIV_VF16_M1_E64_TU, 0x3 }, // 617
  { PseudoVFRDIV_VF16_M2_E16_MASK, PseudoVFRDIV_VF16_M2_E16, PseudoVFRDIV_VF16_M2_E16_TU, 0x3 }, // 618
  { PseudoVFRDIV_VF16_M2_E32_MASK, PseudoVFRDIV_VF16_M2_E32, PseudoVFRDIV_VF16_M2_E32_TU, 0x3 }, // 619
  { PseudoVFRDIV_VF16_M2_E64_MASK, PseudoVFRDIV_VF16_M2_E64, PseudoVFRDIV_VF16_M2_E64_TU, 0x3 }, // 620
  { PseudoVFRDIV_VF16_M4_E16_MASK, PseudoVFRDIV_VF16_M4_E16, PseudoVFRDIV_VF16_M4_E16_TU, 0x3 }, // 621
  { PseudoVFRDIV_VF16_M4_E32_MASK, PseudoVFRDIV_VF16_M4_E32, PseudoVFRDIV_VF16_M4_E32_TU, 0x3 }, // 622
  { PseudoVFRDIV_VF16_M4_E64_MASK, PseudoVFRDIV_VF16_M4_E64, PseudoVFRDIV_VF16_M4_E64_TU, 0x3 }, // 623
  { PseudoVFRDIV_VF16_M8_E16_MASK, PseudoVFRDIV_VF16_M8_E16, PseudoVFRDIV_VF16_M8_E16_TU, 0x3 }, // 624
  { PseudoVFRDIV_VF16_M8_E32_MASK, PseudoVFRDIV_VF16_M8_E32, PseudoVFRDIV_VF16_M8_E32_TU, 0x3 }, // 625
  { PseudoVFRDIV_VF16_M8_E64_MASK, PseudoVFRDIV_VF16_M8_E64, PseudoVFRDIV_VF16_M8_E64_TU, 0x3 }, // 626
  { PseudoVFRDIV_VF16_MF2_E16_MASK, PseudoVFRDIV_VF16_MF2_E16, PseudoVFRDIV_VF16_MF2_E16_TU, 0x3 }, // 627
  { PseudoVFRDIV_VF16_MF2_E32_MASK, PseudoVFRDIV_VF16_MF2_E32, PseudoVFRDIV_VF16_MF2_E32_TU, 0x3 }, // 628
  { PseudoVFRDIV_VF16_MF4_E16_MASK, PseudoVFRDIV_VF16_MF4_E16, PseudoVFRDIV_VF16_MF4_E16_TU, 0x3 }, // 629
  { PseudoVFRDIV_VF32_M1_E16_MASK, PseudoVFRDIV_VF32_M1_E16, PseudoVFRDIV_VF32_M1_E16_TU, 0x3 }, // 630
  { PseudoVFRDIV_VF32_M1_E32_MASK, PseudoVFRDIV_VF32_M1_E32, PseudoVFRDIV_VF32_M1_E32_TU, 0x3 }, // 631
  { PseudoVFRDIV_VF32_M1_E64_MASK, PseudoVFRDIV_VF32_M1_E64, PseudoVFRDIV_VF32_M1_E64_TU, 0x3 }, // 632
  { PseudoVFRDIV_VF32_M2_E16_MASK, PseudoVFRDIV_VF32_M2_E16, PseudoVFRDIV_VF32_M2_E16_TU, 0x3 }, // 633
  { PseudoVFRDIV_VF32_M2_E32_MASK, PseudoVFRDIV_VF32_M2_E32, PseudoVFRDIV_VF32_M2_E32_TU, 0x3 }, // 634
  { PseudoVFRDIV_VF32_M2_E64_MASK, PseudoVFRDIV_VF32_M2_E64, PseudoVFRDIV_VF32_M2_E64_TU, 0x3 }, // 635
  { PseudoVFRDIV_VF32_M4_E16_MASK, PseudoVFRDIV_VF32_M4_E16, PseudoVFRDIV_VF32_M4_E16_TU, 0x3 }, // 636
  { PseudoVFRDIV_VF32_M4_E32_MASK, PseudoVFRDIV_VF32_M4_E32, PseudoVFRDIV_VF32_M4_E32_TU, 0x3 }, // 637
  { PseudoVFRDIV_VF32_M4_E64_MASK, PseudoVFRDIV_VF32_M4_E64, PseudoVFRDIV_VF32_M4_E64_TU, 0x3 }, // 638
  { PseudoVFRDIV_VF32_M8_E16_MASK, PseudoVFRDIV_VF32_M8_E16, PseudoVFRDIV_VF32_M8_E16_TU, 0x3 }, // 639
  { PseudoVFRDIV_VF32_M8_E32_MASK, PseudoVFRDIV_VF32_M8_E32, PseudoVFRDIV_VF32_M8_E32_TU, 0x3 }, // 640
  { PseudoVFRDIV_VF32_M8_E64_MASK, PseudoVFRDIV_VF32_M8_E64, PseudoVFRDIV_VF32_M8_E64_TU, 0x3 }, // 641
  { PseudoVFRDIV_VF32_MF2_E16_MASK, PseudoVFRDIV_VF32_MF2_E16, PseudoVFRDIV_VF32_MF2_E16_TU, 0x3 }, // 642
  { PseudoVFRDIV_VF32_MF2_E32_MASK, PseudoVFRDIV_VF32_MF2_E32, PseudoVFRDIV_VF32_MF2_E32_TU, 0x3 }, // 643
  { PseudoVFRDIV_VF64_M1_E16_MASK, PseudoVFRDIV_VF64_M1_E16, PseudoVFRDIV_VF64_M1_E16_TU, 0x3 }, // 644
  { PseudoVFRDIV_VF64_M1_E32_MASK, PseudoVFRDIV_VF64_M1_E32, PseudoVFRDIV_VF64_M1_E32_TU, 0x3 }, // 645
  { PseudoVFRDIV_VF64_M1_E64_MASK, PseudoVFRDIV_VF64_M1_E64, PseudoVFRDIV_VF64_M1_E64_TU, 0x3 }, // 646
  { PseudoVFRDIV_VF64_M2_E16_MASK, PseudoVFRDIV_VF64_M2_E16, PseudoVFRDIV_VF64_M2_E16_TU, 0x3 }, // 647
  { PseudoVFRDIV_VF64_M2_E32_MASK, PseudoVFRDIV_VF64_M2_E32, PseudoVFRDIV_VF64_M2_E32_TU, 0x3 }, // 648
  { PseudoVFRDIV_VF64_M2_E64_MASK, PseudoVFRDIV_VF64_M2_E64, PseudoVFRDIV_VF64_M2_E64_TU, 0x3 }, // 649
  { PseudoVFRDIV_VF64_M4_E16_MASK, PseudoVFRDIV_VF64_M4_E16, PseudoVFRDIV_VF64_M4_E16_TU, 0x3 }, // 650
  { PseudoVFRDIV_VF64_M4_E32_MASK, PseudoVFRDIV_VF64_M4_E32, PseudoVFRDIV_VF64_M4_E32_TU, 0x3 }, // 651
  { PseudoVFRDIV_VF64_M4_E64_MASK, PseudoVFRDIV_VF64_M4_E64, PseudoVFRDIV_VF64_M4_E64_TU, 0x3 }, // 652
  { PseudoVFRDIV_VF64_M8_E16_MASK, PseudoVFRDIV_VF64_M8_E16, PseudoVFRDIV_VF64_M8_E16_TU, 0x3 }, // 653
  { PseudoVFRDIV_VF64_M8_E32_MASK, PseudoVFRDIV_VF64_M8_E32, PseudoVFRDIV_VF64_M8_E32_TU, 0x3 }, // 654
  { PseudoVFRDIV_VF64_M8_E64_MASK, PseudoVFRDIV_VF64_M8_E64, PseudoVFRDIV_VF64_M8_E64_TU, 0x3 }, // 655
  { PseudoVFREC7_V_M1_MASK, PseudoVFREC7_V_M1, PseudoVFREC7_V_M1_TU, 0x2 }, // 656
  { PseudoVFREC7_V_M2_MASK, PseudoVFREC7_V_M2, PseudoVFREC7_V_M2_TU, 0x2 }, // 657
  { PseudoVFREC7_V_M4_MASK, PseudoVFREC7_V_M4, PseudoVFREC7_V_M4_TU, 0x2 }, // 658
  { PseudoVFREC7_V_M8_MASK, PseudoVFREC7_V_M8, PseudoVFREC7_V_M8_TU, 0x2 }, // 659
  { PseudoVFREC7_V_MF2_MASK, PseudoVFREC7_V_MF2, PseudoVFREC7_V_MF2_TU, 0x2 }, // 660
  { PseudoVFREC7_V_MF4_MASK, PseudoVFREC7_V_MF4, PseudoVFREC7_V_MF4_TU, 0x2 }, // 661
  { PseudoVFRSQRT7_V_M1_MASK, PseudoVFRSQRT7_V_M1, PseudoVFRSQRT7_V_M1_TU, 0x2 }, // 662
  { PseudoVFRSQRT7_V_M2_MASK, PseudoVFRSQRT7_V_M2, PseudoVFRSQRT7_V_M2_TU, 0x2 }, // 663
  { PseudoVFRSQRT7_V_M4_MASK, PseudoVFRSQRT7_V_M4, PseudoVFRSQRT7_V_M4_TU, 0x2 }, // 664
  { PseudoVFRSQRT7_V_M8_MASK, PseudoVFRSQRT7_V_M8, PseudoVFRSQRT7_V_M8_TU, 0x2 }, // 665
  { PseudoVFRSQRT7_V_MF2_MASK, PseudoVFRSQRT7_V_MF2, PseudoVFRSQRT7_V_MF2_TU, 0x2 }, // 666
  { PseudoVFRSQRT7_V_MF4_MASK, PseudoVFRSQRT7_V_MF4, PseudoVFRSQRT7_V_MF4_TU, 0x2 }, // 667
  { PseudoVFRSUB_VF16_M1_MASK, PseudoVFRSUB_VF16_M1, PseudoVFRSUB_VF16_M1_TU, 0x3 }, // 668
  { PseudoVFRSUB_VF16_M2_MASK, PseudoVFRSUB_VF16_M2, PseudoVFRSUB_VF16_M2_TU, 0x3 }, // 669
  { PseudoVFRSUB_VF16_M4_MASK, PseudoVFRSUB_VF16_M4, PseudoVFRSUB_VF16_M4_TU, 0x3 }, // 670
  { PseudoVFRSUB_VF16_M8_MASK, PseudoVFRSUB_VF16_M8, PseudoVFRSUB_VF16_M8_TU, 0x3 }, // 671
  { PseudoVFRSUB_VF16_MF2_MASK, PseudoVFRSUB_VF16_MF2, PseudoVFRSUB_VF16_MF2_TU, 0x3 }, // 672
  { PseudoVFRSUB_VF16_MF4_MASK, PseudoVFRSUB_VF16_MF4, PseudoVFRSUB_VF16_MF4_TU, 0x3 }, // 673
  { PseudoVFRSUB_VF32_M1_MASK, PseudoVFRSUB_VF32_M1, PseudoVFRSUB_VF32_M1_TU, 0x3 }, // 674
  { PseudoVFRSUB_VF32_M2_MASK, PseudoVFRSUB_VF32_M2, PseudoVFRSUB_VF32_M2_TU, 0x3 }, // 675
  { PseudoVFRSUB_VF32_M4_MASK, PseudoVFRSUB_VF32_M4, PseudoVFRSUB_VF32_M4_TU, 0x3 }, // 676
  { PseudoVFRSUB_VF32_M8_MASK, PseudoVFRSUB_VF32_M8, PseudoVFRSUB_VF32_M8_TU, 0x3 }, // 677
  { PseudoVFRSUB_VF32_MF2_MASK, PseudoVFRSUB_VF32_MF2, PseudoVFRSUB_VF32_MF2_TU, 0x3 }, // 678
  { PseudoVFRSUB_VF64_M1_MASK, PseudoVFRSUB_VF64_M1, PseudoVFRSUB_VF64_M1_TU, 0x3 }, // 679
  { PseudoVFRSUB_VF64_M2_MASK, PseudoVFRSUB_VF64_M2, PseudoVFRSUB_VF64_M2_TU, 0x3 }, // 680
  { PseudoVFRSUB_VF64_M4_MASK, PseudoVFRSUB_VF64_M4, PseudoVFRSUB_VF64_M4_TU, 0x3 }, // 681
  { PseudoVFRSUB_VF64_M8_MASK, PseudoVFRSUB_VF64_M8, PseudoVFRSUB_VF64_M8_TU, 0x3 }, // 682
  { PseudoVFSGNJN_VF16_M1_MASK, PseudoVFSGNJN_VF16_M1, PseudoVFSGNJN_VF16_M1_TU, 0x3 }, // 683
  { PseudoVFSGNJN_VF16_M2_MASK, PseudoVFSGNJN_VF16_M2, PseudoVFSGNJN_VF16_M2_TU, 0x3 }, // 684
  { PseudoVFSGNJN_VF16_M4_MASK, PseudoVFSGNJN_VF16_M4, PseudoVFSGNJN_VF16_M4_TU, 0x3 }, // 685
  { PseudoVFSGNJN_VF16_M8_MASK, PseudoVFSGNJN_VF16_M8, PseudoVFSGNJN_VF16_M8_TU, 0x3 }, // 686
  { PseudoVFSGNJN_VF16_MF2_MASK, PseudoVFSGNJN_VF16_MF2, PseudoVFSGNJN_VF16_MF2_TU, 0x3 }, // 687
  { PseudoVFSGNJN_VF16_MF4_MASK, PseudoVFSGNJN_VF16_MF4, PseudoVFSGNJN_VF16_MF4_TU, 0x3 }, // 688
  { PseudoVFSGNJN_VF32_M1_MASK, PseudoVFSGNJN_VF32_M1, PseudoVFSGNJN_VF32_M1_TU, 0x3 }, // 689
  { PseudoVFSGNJN_VF32_M2_MASK, PseudoVFSGNJN_VF32_M2, PseudoVFSGNJN_VF32_M2_TU, 0x3 }, // 690
  { PseudoVFSGNJN_VF32_M4_MASK, PseudoVFSGNJN_VF32_M4, PseudoVFSGNJN_VF32_M4_TU, 0x3 }, // 691
  { PseudoVFSGNJN_VF32_M8_MASK, PseudoVFSGNJN_VF32_M8, PseudoVFSGNJN_VF32_M8_TU, 0x3 }, // 692
  { PseudoVFSGNJN_VF32_MF2_MASK, PseudoVFSGNJN_VF32_MF2, PseudoVFSGNJN_VF32_MF2_TU, 0x3 }, // 693
  { PseudoVFSGNJN_VF64_M1_MASK, PseudoVFSGNJN_VF64_M1, PseudoVFSGNJN_VF64_M1_TU, 0x3 }, // 694
  { PseudoVFSGNJN_VF64_M2_MASK, PseudoVFSGNJN_VF64_M2, PseudoVFSGNJN_VF64_M2_TU, 0x3 }, // 695
  { PseudoVFSGNJN_VF64_M4_MASK, PseudoVFSGNJN_VF64_M4, PseudoVFSGNJN_VF64_M4_TU, 0x3 }, // 696
  { PseudoVFSGNJN_VF64_M8_MASK, PseudoVFSGNJN_VF64_M8, PseudoVFSGNJN_VF64_M8_TU, 0x3 }, // 697
  { PseudoVFSGNJN_VV_M1_MASK, PseudoVFSGNJN_VV_M1, PseudoVFSGNJN_VV_M1_TU, 0x3 }, // 698
  { PseudoVFSGNJN_VV_M2_MASK, PseudoVFSGNJN_VV_M2, PseudoVFSGNJN_VV_M2_TU, 0x3 }, // 699
  { PseudoVFSGNJN_VV_M4_MASK, PseudoVFSGNJN_VV_M4, PseudoVFSGNJN_VV_M4_TU, 0x3 }, // 700
  { PseudoVFSGNJN_VV_M8_MASK, PseudoVFSGNJN_VV_M8, PseudoVFSGNJN_VV_M8_TU, 0x3 }, // 701
  { PseudoVFSGNJN_VV_MF2_MASK, PseudoVFSGNJN_VV_MF2, PseudoVFSGNJN_VV_MF2_TU, 0x3 }, // 702
  { PseudoVFSGNJN_VV_MF4_MASK, PseudoVFSGNJN_VV_MF4, PseudoVFSGNJN_VV_MF4_TU, 0x3 }, // 703
  { PseudoVFSGNJX_VF16_M1_MASK, PseudoVFSGNJX_VF16_M1, PseudoVFSGNJX_VF16_M1_TU, 0x3 }, // 704
  { PseudoVFSGNJX_VF16_M2_MASK, PseudoVFSGNJX_VF16_M2, PseudoVFSGNJX_VF16_M2_TU, 0x3 }, // 705
  { PseudoVFSGNJX_VF16_M4_MASK, PseudoVFSGNJX_VF16_M4, PseudoVFSGNJX_VF16_M4_TU, 0x3 }, // 706
  { PseudoVFSGNJX_VF16_M8_MASK, PseudoVFSGNJX_VF16_M8, PseudoVFSGNJX_VF16_M8_TU, 0x3 }, // 707
  { PseudoVFSGNJX_VF16_MF2_MASK, PseudoVFSGNJX_VF16_MF2, PseudoVFSGNJX_VF16_MF2_TU, 0x3 }, // 708
  { PseudoVFSGNJX_VF16_MF4_MASK, PseudoVFSGNJX_VF16_MF4, PseudoVFSGNJX_VF16_MF4_TU, 0x3 }, // 709
  { PseudoVFSGNJX_VF32_M1_MASK, PseudoVFSGNJX_VF32_M1, PseudoVFSGNJX_VF32_M1_TU, 0x3 }, // 710
  { PseudoVFSGNJX_VF32_M2_MASK, PseudoVFSGNJX_VF32_M2, PseudoVFSGNJX_VF32_M2_TU, 0x3 }, // 711
  { PseudoVFSGNJX_VF32_M4_MASK, PseudoVFSGNJX_VF32_M4, PseudoVFSGNJX_VF32_M4_TU, 0x3 }, // 712
  { PseudoVFSGNJX_VF32_M8_MASK, PseudoVFSGNJX_VF32_M8, PseudoVFSGNJX_VF32_M8_TU, 0x3 }, // 713
  { PseudoVFSGNJX_VF32_MF2_MASK, PseudoVFSGNJX_VF32_MF2, PseudoVFSGNJX_VF32_MF2_TU, 0x3 }, // 714
  { PseudoVFSGNJX_VF64_M1_MASK, PseudoVFSGNJX_VF64_M1, PseudoVFSGNJX_VF64_M1_TU, 0x3 }, // 715
  { PseudoVFSGNJX_VF64_M2_MASK, PseudoVFSGNJX_VF64_M2, PseudoVFSGNJX_VF64_M2_TU, 0x3 }, // 716
  { PseudoVFSGNJX_VF64_M4_MASK, PseudoVFSGNJX_VF64_M4, PseudoVFSGNJX_VF64_M4_TU, 0x3 }, // 717
  { PseudoVFSGNJX_VF64_M8_MASK, PseudoVFSGNJX_VF64_M8, PseudoVFSGNJX_VF64_M8_TU, 0x3 }, // 718
  { PseudoVFSGNJX_VV_M1_MASK, PseudoVFSGNJX_VV_M1, PseudoVFSGNJX_VV_M1_TU, 0x3 }, // 719
  { PseudoVFSGNJX_VV_M2_MASK, PseudoVFSGNJX_VV_M2, PseudoVFSGNJX_VV_M2_TU, 0x3 }, // 720
  { PseudoVFSGNJX_VV_M4_MASK, PseudoVFSGNJX_VV_M4, PseudoVFSGNJX_VV_M4_TU, 0x3 }, // 721
  { PseudoVFSGNJX_VV_M8_MASK, PseudoVFSGNJX_VV_M8, PseudoVFSGNJX_VV_M8_TU, 0x3 }, // 722
  { PseudoVFSGNJX_VV_MF2_MASK, PseudoVFSGNJX_VV_MF2, PseudoVFSGNJX_VV_MF2_TU, 0x3 }, // 723
  { PseudoVFSGNJX_VV_MF4_MASK, PseudoVFSGNJX_VV_MF4, PseudoVFSGNJX_VV_MF4_TU, 0x3 }, // 724
  { PseudoVFSGNJ_VF16_M1_MASK, PseudoVFSGNJ_VF16_M1, PseudoVFSGNJ_VF16_M1_TU, 0x3 }, // 725
  { PseudoVFSGNJ_VF16_M2_MASK, PseudoVFSGNJ_VF16_M2, PseudoVFSGNJ_VF16_M2_TU, 0x3 }, // 726
  { PseudoVFSGNJ_VF16_M4_MASK, PseudoVFSGNJ_VF16_M4, PseudoVFSGNJ_VF16_M4_TU, 0x3 }, // 727
  { PseudoVFSGNJ_VF16_M8_MASK, PseudoVFSGNJ_VF16_M8, PseudoVFSGNJ_VF16_M8_TU, 0x3 }, // 728
  { PseudoVFSGNJ_VF16_MF2_MASK, PseudoVFSGNJ_VF16_MF2, PseudoVFSGNJ_VF16_MF2_TU, 0x3 }, // 729
  { PseudoVFSGNJ_VF16_MF4_MASK, PseudoVFSGNJ_VF16_MF4, PseudoVFSGNJ_VF16_MF4_TU, 0x3 }, // 730
  { PseudoVFSGNJ_VF32_M1_MASK, PseudoVFSGNJ_VF32_M1, PseudoVFSGNJ_VF32_M1_TU, 0x3 }, // 731
  { PseudoVFSGNJ_VF32_M2_MASK, PseudoVFSGNJ_VF32_M2, PseudoVFSGNJ_VF32_M2_TU, 0x3 }, // 732
  { PseudoVFSGNJ_VF32_M4_MASK, PseudoVFSGNJ_VF32_M4, PseudoVFSGNJ_VF32_M4_TU, 0x3 }, // 733
  { PseudoVFSGNJ_VF32_M8_MASK, PseudoVFSGNJ_VF32_M8, PseudoVFSGNJ_VF32_M8_TU, 0x3 }, // 734
  { PseudoVFSGNJ_VF32_MF2_MASK, PseudoVFSGNJ_VF32_MF2, PseudoVFSGNJ_VF32_MF2_TU, 0x3 }, // 735
  { PseudoVFSGNJ_VF64_M1_MASK, PseudoVFSGNJ_VF64_M1, PseudoVFSGNJ_VF64_M1_TU, 0x3 }, // 736
  { PseudoVFSGNJ_VF64_M2_MASK, PseudoVFSGNJ_VF64_M2, PseudoVFSGNJ_VF64_M2_TU, 0x3 }, // 737
  { PseudoVFSGNJ_VF64_M4_MASK, PseudoVFSGNJ_VF64_M4, PseudoVFSGNJ_VF64_M4_TU, 0x3 }, // 738
  { PseudoVFSGNJ_VF64_M8_MASK, PseudoVFSGNJ_VF64_M8, PseudoVFSGNJ_VF64_M8_TU, 0x3 }, // 739
  { PseudoVFSGNJ_VV_M1_MASK, PseudoVFSGNJ_VV_M1, PseudoVFSGNJ_VV_M1_TU, 0x3 }, // 740
  { PseudoVFSGNJ_VV_M2_MASK, PseudoVFSGNJ_VV_M2, PseudoVFSGNJ_VV_M2_TU, 0x3 }, // 741
  { PseudoVFSGNJ_VV_M4_MASK, PseudoVFSGNJ_VV_M4, PseudoVFSGNJ_VV_M4_TU, 0x3 }, // 742
  { PseudoVFSGNJ_VV_M8_MASK, PseudoVFSGNJ_VV_M8, PseudoVFSGNJ_VV_M8_TU, 0x3 }, // 743
  { PseudoVFSGNJ_VV_MF2_MASK, PseudoVFSGNJ_VV_MF2, PseudoVFSGNJ_VV_MF2_TU, 0x3 }, // 744
  { PseudoVFSGNJ_VV_MF4_MASK, PseudoVFSGNJ_VV_MF4, PseudoVFSGNJ_VV_MF4_TU, 0x3 }, // 745
  { PseudoVFSLIDE1DOWN_VF16_M1_MASK, PseudoVFSLIDE1DOWN_VF16_M1, PseudoVFSLIDE1DOWN_VF16_M1_TU, 0x3 }, // 746
  { PseudoVFSLIDE1DOWN_VF16_M2_MASK, PseudoVFSLIDE1DOWN_VF16_M2, PseudoVFSLIDE1DOWN_VF16_M2_TU, 0x3 }, // 747
  { PseudoVFSLIDE1DOWN_VF16_M4_MASK, PseudoVFSLIDE1DOWN_VF16_M4, PseudoVFSLIDE1DOWN_VF16_M4_TU, 0x3 }, // 748
  { PseudoVFSLIDE1DOWN_VF16_M8_MASK, PseudoVFSLIDE1DOWN_VF16_M8, PseudoVFSLIDE1DOWN_VF16_M8_TU, 0x3 }, // 749
  { PseudoVFSLIDE1DOWN_VF16_MF2_MASK, PseudoVFSLIDE1DOWN_VF16_MF2, PseudoVFSLIDE1DOWN_VF16_MF2_TU, 0x3 }, // 750
  { PseudoVFSLIDE1DOWN_VF16_MF4_MASK, PseudoVFSLIDE1DOWN_VF16_MF4, PseudoVFSLIDE1DOWN_VF16_MF4_TU, 0x3 }, // 751
  { PseudoVFSLIDE1DOWN_VF32_M1_MASK, PseudoVFSLIDE1DOWN_VF32_M1, PseudoVFSLIDE1DOWN_VF32_M1_TU, 0x3 }, // 752
  { PseudoVFSLIDE1DOWN_VF32_M2_MASK, PseudoVFSLIDE1DOWN_VF32_M2, PseudoVFSLIDE1DOWN_VF32_M2_TU, 0x3 }, // 753
  { PseudoVFSLIDE1DOWN_VF32_M4_MASK, PseudoVFSLIDE1DOWN_VF32_M4, PseudoVFSLIDE1DOWN_VF32_M4_TU, 0x3 }, // 754
  { PseudoVFSLIDE1DOWN_VF32_M8_MASK, PseudoVFSLIDE1DOWN_VF32_M8, PseudoVFSLIDE1DOWN_VF32_M8_TU, 0x3 }, // 755
  { PseudoVFSLIDE1DOWN_VF32_MF2_MASK, PseudoVFSLIDE1DOWN_VF32_MF2, PseudoVFSLIDE1DOWN_VF32_MF2_TU, 0x3 }, // 756
  { PseudoVFSLIDE1DOWN_VF64_M1_MASK, PseudoVFSLIDE1DOWN_VF64_M1, PseudoVFSLIDE1DOWN_VF64_M1_TU, 0x3 }, // 757
  { PseudoVFSLIDE1DOWN_VF64_M2_MASK, PseudoVFSLIDE1DOWN_VF64_M2, PseudoVFSLIDE1DOWN_VF64_M2_TU, 0x3 }, // 758
  { PseudoVFSLIDE1DOWN_VF64_M4_MASK, PseudoVFSLIDE1DOWN_VF64_M4, PseudoVFSLIDE1DOWN_VF64_M4_TU, 0x3 }, // 759
  { PseudoVFSLIDE1DOWN_VF64_M8_MASK, PseudoVFSLIDE1DOWN_VF64_M8, PseudoVFSLIDE1DOWN_VF64_M8_TU, 0x3 }, // 760
  { PseudoVFSLIDE1UP_VF16_M1_MASK, PseudoVFSLIDE1UP_VF16_M1, PseudoVFSLIDE1UP_VF16_M1_TU, 0x3 }, // 761
  { PseudoVFSLIDE1UP_VF16_M2_MASK, PseudoVFSLIDE1UP_VF16_M2, PseudoVFSLIDE1UP_VF16_M2_TU, 0x3 }, // 762
  { PseudoVFSLIDE1UP_VF16_M4_MASK, PseudoVFSLIDE1UP_VF16_M4, PseudoVFSLIDE1UP_VF16_M4_TU, 0x3 }, // 763
  { PseudoVFSLIDE1UP_VF16_M8_MASK, PseudoVFSLIDE1UP_VF16_M8, PseudoVFSLIDE1UP_VF16_M8_TU, 0x3 }, // 764
  { PseudoVFSLIDE1UP_VF16_MF2_MASK, PseudoVFSLIDE1UP_VF16_MF2, PseudoVFSLIDE1UP_VF16_MF2_TU, 0x3 }, // 765
  { PseudoVFSLIDE1UP_VF16_MF4_MASK, PseudoVFSLIDE1UP_VF16_MF4, PseudoVFSLIDE1UP_VF16_MF4_TU, 0x3 }, // 766
  { PseudoVFSLIDE1UP_VF32_M1_MASK, PseudoVFSLIDE1UP_VF32_M1, PseudoVFSLIDE1UP_VF32_M1_TU, 0x3 }, // 767
  { PseudoVFSLIDE1UP_VF32_M2_MASK, PseudoVFSLIDE1UP_VF32_M2, PseudoVFSLIDE1UP_VF32_M2_TU, 0x3 }, // 768
  { PseudoVFSLIDE1UP_VF32_M4_MASK, PseudoVFSLIDE1UP_VF32_M4, PseudoVFSLIDE1UP_VF32_M4_TU, 0x3 }, // 769
  { PseudoVFSLIDE1UP_VF32_M8_MASK, PseudoVFSLIDE1UP_VF32_M8, PseudoVFSLIDE1UP_VF32_M8_TU, 0x3 }, // 770
  { PseudoVFSLIDE1UP_VF32_MF2_MASK, PseudoVFSLIDE1UP_VF32_MF2, PseudoVFSLIDE1UP_VF32_MF2_TU, 0x3 }, // 771
  { PseudoVFSLIDE1UP_VF64_M1_MASK, PseudoVFSLIDE1UP_VF64_M1, PseudoVFSLIDE1UP_VF64_M1_TU, 0x3 }, // 772
  { PseudoVFSLIDE1UP_VF64_M2_MASK, PseudoVFSLIDE1UP_VF64_M2, PseudoVFSLIDE1UP_VF64_M2_TU, 0x3 }, // 773
  { PseudoVFSLIDE1UP_VF64_M4_MASK, PseudoVFSLIDE1UP_VF64_M4, PseudoVFSLIDE1UP_VF64_M4_TU, 0x3 }, // 774
  { PseudoVFSLIDE1UP_VF64_M8_MASK, PseudoVFSLIDE1UP_VF64_M8, PseudoVFSLIDE1UP_VF64_M8_TU, 0x3 }, // 775
  { PseudoVFSQRT_V_M1_E16_MASK, PseudoVFSQRT_V_M1_E16, PseudoVFSQRT_V_M1_E16_TU, 0x2 }, // 776
  { PseudoVFSQRT_V_M1_E32_MASK, PseudoVFSQRT_V_M1_E32, PseudoVFSQRT_V_M1_E32_TU, 0x2 }, // 777
  { PseudoVFSQRT_V_M1_E64_MASK, PseudoVFSQRT_V_M1_E64, PseudoVFSQRT_V_M1_E64_TU, 0x2 }, // 778
  { PseudoVFSQRT_V_M2_E16_MASK, PseudoVFSQRT_V_M2_E16, PseudoVFSQRT_V_M2_E16_TU, 0x2 }, // 779
  { PseudoVFSQRT_V_M2_E32_MASK, PseudoVFSQRT_V_M2_E32, PseudoVFSQRT_V_M2_E32_TU, 0x2 }, // 780
  { PseudoVFSQRT_V_M2_E64_MASK, PseudoVFSQRT_V_M2_E64, PseudoVFSQRT_V_M2_E64_TU, 0x2 }, // 781
  { PseudoVFSQRT_V_M4_E16_MASK, PseudoVFSQRT_V_M4_E16, PseudoVFSQRT_V_M4_E16_TU, 0x2 }, // 782
  { PseudoVFSQRT_V_M4_E32_MASK, PseudoVFSQRT_V_M4_E32, PseudoVFSQRT_V_M4_E32_TU, 0x2 }, // 783
  { PseudoVFSQRT_V_M4_E64_MASK, PseudoVFSQRT_V_M4_E64, PseudoVFSQRT_V_M4_E64_TU, 0x2 }, // 784
  { PseudoVFSQRT_V_M8_E16_MASK, PseudoVFSQRT_V_M8_E16, PseudoVFSQRT_V_M8_E16_TU, 0x2 }, // 785
  { PseudoVFSQRT_V_M8_E32_MASK, PseudoVFSQRT_V_M8_E32, PseudoVFSQRT_V_M8_E32_TU, 0x2 }, // 786
  { PseudoVFSQRT_V_M8_E64_MASK, PseudoVFSQRT_V_M8_E64, PseudoVFSQRT_V_M8_E64_TU, 0x2 }, // 787
  { PseudoVFSQRT_V_MF2_E16_MASK, PseudoVFSQRT_V_MF2_E16, PseudoVFSQRT_V_MF2_E16_TU, 0x2 }, // 788
  { PseudoVFSQRT_V_MF2_E32_MASK, PseudoVFSQRT_V_MF2_E32, PseudoVFSQRT_V_MF2_E32_TU, 0x2 }, // 789
  { PseudoVFSQRT_V_MF4_E16_MASK, PseudoVFSQRT_V_MF4_E16, PseudoVFSQRT_V_MF4_E16_TU, 0x2 }, // 790
  { PseudoVFSUB_VF16_M1_MASK, PseudoVFSUB_VF16_M1, PseudoVFSUB_VF16_M1_TU, 0x3 }, // 791
  { PseudoVFSUB_VF16_M2_MASK, PseudoVFSUB_VF16_M2, PseudoVFSUB_VF16_M2_TU, 0x3 }, // 792
  { PseudoVFSUB_VF16_M4_MASK, PseudoVFSUB_VF16_M4, PseudoVFSUB_VF16_M4_TU, 0x3 }, // 793
  { PseudoVFSUB_VF16_M8_MASK, PseudoVFSUB_VF16_M8, PseudoVFSUB_VF16_M8_TU, 0x3 }, // 794
  { PseudoVFSUB_VF16_MF2_MASK, PseudoVFSUB_VF16_MF2, PseudoVFSUB_VF16_MF2_TU, 0x3 }, // 795
  { PseudoVFSUB_VF16_MF4_MASK, PseudoVFSUB_VF16_MF4, PseudoVFSUB_VF16_MF4_TU, 0x3 }, // 796
  { PseudoVFSUB_VF32_M1_MASK, PseudoVFSUB_VF32_M1, PseudoVFSUB_VF32_M1_TU, 0x3 }, // 797
  { PseudoVFSUB_VF32_M2_MASK, PseudoVFSUB_VF32_M2, PseudoVFSUB_VF32_M2_TU, 0x3 }, // 798
  { PseudoVFSUB_VF32_M4_MASK, PseudoVFSUB_VF32_M4, PseudoVFSUB_VF32_M4_TU, 0x3 }, // 799
  { PseudoVFSUB_VF32_M8_MASK, PseudoVFSUB_VF32_M8, PseudoVFSUB_VF32_M8_TU, 0x3 }, // 800
  { PseudoVFSUB_VF32_MF2_MASK, PseudoVFSUB_VF32_MF2, PseudoVFSUB_VF32_MF2_TU, 0x3 }, // 801
  { PseudoVFSUB_VF64_M1_MASK, PseudoVFSUB_VF64_M1, PseudoVFSUB_VF64_M1_TU, 0x3 }, // 802
  { PseudoVFSUB_VF64_M2_MASK, PseudoVFSUB_VF64_M2, PseudoVFSUB_VF64_M2_TU, 0x3 }, // 803
  { PseudoVFSUB_VF64_M4_MASK, PseudoVFSUB_VF64_M4, PseudoVFSUB_VF64_M4_TU, 0x3 }, // 804
  { PseudoVFSUB_VF64_M8_MASK, PseudoVFSUB_VF64_M8, PseudoVFSUB_VF64_M8_TU, 0x3 }, // 805
  { PseudoVFSUB_VV_M1_MASK, PseudoVFSUB_VV_M1, PseudoVFSUB_VV_M1_TU, 0x3 }, // 806
  { PseudoVFSUB_VV_M2_MASK, PseudoVFSUB_VV_M2, PseudoVFSUB_VV_M2_TU, 0x3 }, // 807
  { PseudoVFSUB_VV_M4_MASK, PseudoVFSUB_VV_M4, PseudoVFSUB_VV_M4_TU, 0x3 }, // 808
  { PseudoVFSUB_VV_M8_MASK, PseudoVFSUB_VV_M8, PseudoVFSUB_VV_M8_TU, 0x3 }, // 809
  { PseudoVFSUB_VV_MF2_MASK, PseudoVFSUB_VV_MF2, PseudoVFSUB_VV_MF2_TU, 0x3 }, // 810
  { PseudoVFSUB_VV_MF4_MASK, PseudoVFSUB_VV_MF4, PseudoVFSUB_VV_MF4_TU, 0x3 }, // 811
  { PseudoVFWADD_VF16_M1_MASK, PseudoVFWADD_VF16_M1, PseudoVFWADD_VF16_M1_TU, 0x3 }, // 812
  { PseudoVFWADD_VF16_M2_MASK, PseudoVFWADD_VF16_M2, PseudoVFWADD_VF16_M2_TU, 0x3 }, // 813
  { PseudoVFWADD_VF16_M4_MASK, PseudoVFWADD_VF16_M4, PseudoVFWADD_VF16_M4_TU, 0x3 }, // 814
  { PseudoVFWADD_VF16_MF2_MASK, PseudoVFWADD_VF16_MF2, PseudoVFWADD_VF16_MF2_TU, 0x3 }, // 815
  { PseudoVFWADD_VF16_MF4_MASK, PseudoVFWADD_VF16_MF4, PseudoVFWADD_VF16_MF4_TU, 0x3 }, // 816
  { PseudoVFWADD_VF32_M1_MASK, PseudoVFWADD_VF32_M1, PseudoVFWADD_VF32_M1_TU, 0x3 }, // 817
  { PseudoVFWADD_VF32_M2_MASK, PseudoVFWADD_VF32_M2, PseudoVFWADD_VF32_M2_TU, 0x3 }, // 818
  { PseudoVFWADD_VF32_M4_MASK, PseudoVFWADD_VF32_M4, PseudoVFWADD_VF32_M4_TU, 0x3 }, // 819
  { PseudoVFWADD_VF32_MF2_MASK, PseudoVFWADD_VF32_MF2, PseudoVFWADD_VF32_MF2_TU, 0x3 }, // 820
  { PseudoVFWADD_VV_M1_MASK, PseudoVFWADD_VV_M1, PseudoVFWADD_VV_M1_TU, 0x3 }, // 821
  { PseudoVFWADD_VV_M2_MASK, PseudoVFWADD_VV_M2, PseudoVFWADD_VV_M2_TU, 0x3 }, // 822
  { PseudoVFWADD_VV_M4_MASK, PseudoVFWADD_VV_M4, PseudoVFWADD_VV_M4_TU, 0x3 }, // 823
  { PseudoVFWADD_VV_MF2_MASK, PseudoVFWADD_VV_MF2, PseudoVFWADD_VV_MF2_TU, 0x3 }, // 824
  { PseudoVFWADD_VV_MF4_MASK, PseudoVFWADD_VV_MF4, PseudoVFWADD_VV_MF4_TU, 0x3 }, // 825
  { PseudoVFWADD_WF16_M1_MASK, PseudoVFWADD_WF16_M1, PseudoVFWADD_WF16_M1_TU, 0x3 }, // 826
  { PseudoVFWADD_WF16_M2_MASK, PseudoVFWADD_WF16_M2, PseudoVFWADD_WF16_M2_TU, 0x3 }, // 827
  { PseudoVFWADD_WF16_M4_MASK, PseudoVFWADD_WF16_M4, PseudoVFWADD_WF16_M4_TU, 0x3 }, // 828
  { PseudoVFWADD_WF16_MF2_MASK, PseudoVFWADD_WF16_MF2, PseudoVFWADD_WF16_MF2_TU, 0x3 }, // 829
  { PseudoVFWADD_WF16_MF4_MASK, PseudoVFWADD_WF16_MF4, PseudoVFWADD_WF16_MF4_TU, 0x3 }, // 830
  { PseudoVFWADD_WF32_M1_MASK, PseudoVFWADD_WF32_M1, PseudoVFWADD_WF32_M1_TU, 0x3 }, // 831
  { PseudoVFWADD_WF32_M2_MASK, PseudoVFWADD_WF32_M2, PseudoVFWADD_WF32_M2_TU, 0x3 }, // 832
  { PseudoVFWADD_WF32_M4_MASK, PseudoVFWADD_WF32_M4, PseudoVFWADD_WF32_M4_TU, 0x3 }, // 833
  { PseudoVFWADD_WF32_MF2_MASK, PseudoVFWADD_WF32_MF2, PseudoVFWADD_WF32_MF2_TU, 0x3 }, // 834
  { PseudoVFWADD_WV_M1_MASK, PseudoVFWADD_WV_M1, PseudoVFWADD_WV_M1_TU, 0x3 }, // 835
  { PseudoVFWADD_WV_M2_MASK, PseudoVFWADD_WV_M2, PseudoVFWADD_WV_M2_TU, 0x3 }, // 836
  { PseudoVFWADD_WV_M4_MASK, PseudoVFWADD_WV_M4, PseudoVFWADD_WV_M4_TU, 0x3 }, // 837
  { PseudoVFWADD_WV_MF2_MASK, PseudoVFWADD_WV_MF2, PseudoVFWADD_WV_MF2_TU, 0x3 }, // 838
  { PseudoVFWADD_WV_MF4_MASK, PseudoVFWADD_WV_MF4, PseudoVFWADD_WV_MF4_TU, 0x3 }, // 839
  { PseudoVFWCVT_F_F_V_M1_MASK, PseudoVFWCVT_F_F_V_M1, PseudoVFWCVT_F_F_V_M1_TU, 0x2 }, // 840
  { PseudoVFWCVT_F_F_V_M2_MASK, PseudoVFWCVT_F_F_V_M2, PseudoVFWCVT_F_F_V_M2_TU, 0x2 }, // 841
  { PseudoVFWCVT_F_F_V_M4_MASK, PseudoVFWCVT_F_F_V_M4, PseudoVFWCVT_F_F_V_M4_TU, 0x2 }, // 842
  { PseudoVFWCVT_F_F_V_MF2_MASK, PseudoVFWCVT_F_F_V_MF2, PseudoVFWCVT_F_F_V_MF2_TU, 0x2 }, // 843
  { PseudoVFWCVT_F_F_V_MF4_MASK, PseudoVFWCVT_F_F_V_MF4, PseudoVFWCVT_F_F_V_MF4_TU, 0x2 }, // 844
  { PseudoVFWCVT_F_XU_V_M1_MASK, PseudoVFWCVT_F_XU_V_M1, PseudoVFWCVT_F_XU_V_M1_TU, 0x2 }, // 845
  { PseudoVFWCVT_F_XU_V_M2_MASK, PseudoVFWCVT_F_XU_V_M2, PseudoVFWCVT_F_XU_V_M2_TU, 0x2 }, // 846
  { PseudoVFWCVT_F_XU_V_M4_MASK, PseudoVFWCVT_F_XU_V_M4, PseudoVFWCVT_F_XU_V_M4_TU, 0x2 }, // 847
  { PseudoVFWCVT_F_XU_V_MF2_MASK, PseudoVFWCVT_F_XU_V_MF2, PseudoVFWCVT_F_XU_V_MF2_TU, 0x2 }, // 848
  { PseudoVFWCVT_F_XU_V_MF4_MASK, PseudoVFWCVT_F_XU_V_MF4, PseudoVFWCVT_F_XU_V_MF4_TU, 0x2 }, // 849
  { PseudoVFWCVT_F_XU_V_MF8_MASK, PseudoVFWCVT_F_XU_V_MF8, PseudoVFWCVT_F_XU_V_MF8_TU, 0x2 }, // 850
  { PseudoVFWCVT_F_X_V_M1_MASK, PseudoVFWCVT_F_X_V_M1, PseudoVFWCVT_F_X_V_M1_TU, 0x2 }, // 851
  { PseudoVFWCVT_F_X_V_M2_MASK, PseudoVFWCVT_F_X_V_M2, PseudoVFWCVT_F_X_V_M2_TU, 0x2 }, // 852
  { PseudoVFWCVT_F_X_V_M4_MASK, PseudoVFWCVT_F_X_V_M4, PseudoVFWCVT_F_X_V_M4_TU, 0x2 }, // 853
  { PseudoVFWCVT_F_X_V_MF2_MASK, PseudoVFWCVT_F_X_V_MF2, PseudoVFWCVT_F_X_V_MF2_TU, 0x2 }, // 854
  { PseudoVFWCVT_F_X_V_MF4_MASK, PseudoVFWCVT_F_X_V_MF4, PseudoVFWCVT_F_X_V_MF4_TU, 0x2 }, // 855
  { PseudoVFWCVT_F_X_V_MF8_MASK, PseudoVFWCVT_F_X_V_MF8, PseudoVFWCVT_F_X_V_MF8_TU, 0x2 }, // 856
  { PseudoVFWCVT_RTZ_XU_F_V_M1_MASK, PseudoVFWCVT_RTZ_XU_F_V_M1, PseudoVFWCVT_RTZ_XU_F_V_M1_TU, 0x2 }, // 857
  { PseudoVFWCVT_RTZ_XU_F_V_M2_MASK, PseudoVFWCVT_RTZ_XU_F_V_M2, PseudoVFWCVT_RTZ_XU_F_V_M2_TU, 0x2 }, // 858
  { PseudoVFWCVT_RTZ_XU_F_V_M4_MASK, PseudoVFWCVT_RTZ_XU_F_V_M4, PseudoVFWCVT_RTZ_XU_F_V_M4_TU, 0x2 }, // 859
  { PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK, PseudoVFWCVT_RTZ_XU_F_V_MF2, PseudoVFWCVT_RTZ_XU_F_V_MF2_TU, 0x2 }, // 860
  { PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK, PseudoVFWCVT_RTZ_XU_F_V_MF4, PseudoVFWCVT_RTZ_XU_F_V_MF4_TU, 0x2 }, // 861
  { PseudoVFWCVT_RTZ_X_F_V_M1_MASK, PseudoVFWCVT_RTZ_X_F_V_M1, PseudoVFWCVT_RTZ_X_F_V_M1_TU, 0x2 }, // 862
  { PseudoVFWCVT_RTZ_X_F_V_M2_MASK, PseudoVFWCVT_RTZ_X_F_V_M2, PseudoVFWCVT_RTZ_X_F_V_M2_TU, 0x2 }, // 863
  { PseudoVFWCVT_RTZ_X_F_V_M4_MASK, PseudoVFWCVT_RTZ_X_F_V_M4, PseudoVFWCVT_RTZ_X_F_V_M4_TU, 0x2 }, // 864
  { PseudoVFWCVT_RTZ_X_F_V_MF2_MASK, PseudoVFWCVT_RTZ_X_F_V_MF2, PseudoVFWCVT_RTZ_X_F_V_MF2_TU, 0x2 }, // 865
  { PseudoVFWCVT_RTZ_X_F_V_MF4_MASK, PseudoVFWCVT_RTZ_X_F_V_MF4, PseudoVFWCVT_RTZ_X_F_V_MF4_TU, 0x2 }, // 866
  { PseudoVFWCVT_XU_F_V_M1_MASK, PseudoVFWCVT_XU_F_V_M1, PseudoVFWCVT_XU_F_V_M1_TU, 0x2 }, // 867
  { PseudoVFWCVT_XU_F_V_M2_MASK, PseudoVFWCVT_XU_F_V_M2, PseudoVFWCVT_XU_F_V_M2_TU, 0x2 }, // 868
  { PseudoVFWCVT_XU_F_V_M4_MASK, PseudoVFWCVT_XU_F_V_M4, PseudoVFWCVT_XU_F_V_M4_TU, 0x2 }, // 869
  { PseudoVFWCVT_XU_F_V_MF2_MASK, PseudoVFWCVT_XU_F_V_MF2, PseudoVFWCVT_XU_F_V_MF2_TU, 0x2 }, // 870
  { PseudoVFWCVT_XU_F_V_MF4_MASK, PseudoVFWCVT_XU_F_V_MF4, PseudoVFWCVT_XU_F_V_MF4_TU, 0x2 }, // 871
  { PseudoVFWCVT_X_F_V_M1_MASK, PseudoVFWCVT_X_F_V_M1, PseudoVFWCVT_X_F_V_M1_TU, 0x2 }, // 872
  { PseudoVFWCVT_X_F_V_M2_MASK, PseudoVFWCVT_X_F_V_M2, PseudoVFWCVT_X_F_V_M2_TU, 0x2 }, // 873
  { PseudoVFWCVT_X_F_V_M4_MASK, PseudoVFWCVT_X_F_V_M4, PseudoVFWCVT_X_F_V_M4_TU, 0x2 }, // 874
  { PseudoVFWCVT_X_F_V_MF2_MASK, PseudoVFWCVT_X_F_V_MF2, PseudoVFWCVT_X_F_V_MF2_TU, 0x2 }, // 875
  { PseudoVFWCVT_X_F_V_MF4_MASK, PseudoVFWCVT_X_F_V_MF4, PseudoVFWCVT_X_F_V_MF4_TU, 0x2 }, // 876
  { PseudoVFWMACC_VF16_M1_MASK, PseudoVFWMACC_VF16_M1, PseudoVFWMACC_VF16_M1, 0x3 }, // 877
  { PseudoVFWMACC_VF16_M2_MASK, PseudoVFWMACC_VF16_M2, PseudoVFWMACC_VF16_M2, 0x3 }, // 878
  { PseudoVFWMACC_VF16_M4_MASK, PseudoVFWMACC_VF16_M4, PseudoVFWMACC_VF16_M4, 0x3 }, // 879
  { PseudoVFWMACC_VF16_MF2_MASK, PseudoVFWMACC_VF16_MF2, PseudoVFWMACC_VF16_MF2, 0x3 }, // 880
  { PseudoVFWMACC_VF16_MF4_MASK, PseudoVFWMACC_VF16_MF4, PseudoVFWMACC_VF16_MF4, 0x3 }, // 881
  { PseudoVFWMACC_VF32_M1_MASK, PseudoVFWMACC_VF32_M1, PseudoVFWMACC_VF32_M1, 0x3 }, // 882
  { PseudoVFWMACC_VF32_M2_MASK, PseudoVFWMACC_VF32_M2, PseudoVFWMACC_VF32_M2, 0x3 }, // 883
  { PseudoVFWMACC_VF32_M4_MASK, PseudoVFWMACC_VF32_M4, PseudoVFWMACC_VF32_M4, 0x3 }, // 884
  { PseudoVFWMACC_VF32_MF2_MASK, PseudoVFWMACC_VF32_MF2, PseudoVFWMACC_VF32_MF2, 0x3 }, // 885
  { PseudoVFWMACC_VV_M1_MASK, PseudoVFWMACC_VV_M1, PseudoVFWMACC_VV_M1, 0x3 }, // 886
  { PseudoVFWMACC_VV_M2_MASK, PseudoVFWMACC_VV_M2, PseudoVFWMACC_VV_M2, 0x3 }, // 887
  { PseudoVFWMACC_VV_M4_MASK, PseudoVFWMACC_VV_M4, PseudoVFWMACC_VV_M4, 0x3 }, // 888
  { PseudoVFWMACC_VV_MF2_MASK, PseudoVFWMACC_VV_MF2, PseudoVFWMACC_VV_MF2, 0x3 }, // 889
  { PseudoVFWMACC_VV_MF4_MASK, PseudoVFWMACC_VV_MF4, PseudoVFWMACC_VV_MF4, 0x3 }, // 890
  { PseudoVFWMSAC_VF16_M1_MASK, PseudoVFWMSAC_VF16_M1, PseudoVFWMSAC_VF16_M1, 0x3 }, // 891
  { PseudoVFWMSAC_VF16_M2_MASK, PseudoVFWMSAC_VF16_M2, PseudoVFWMSAC_VF16_M2, 0x3 }, // 892
  { PseudoVFWMSAC_VF16_M4_MASK, PseudoVFWMSAC_VF16_M4, PseudoVFWMSAC_VF16_M4, 0x3 }, // 893
  { PseudoVFWMSAC_VF16_MF2_MASK, PseudoVFWMSAC_VF16_MF2, PseudoVFWMSAC_VF16_MF2, 0x3 }, // 894
  { PseudoVFWMSAC_VF16_MF4_MASK, PseudoVFWMSAC_VF16_MF4, PseudoVFWMSAC_VF16_MF4, 0x3 }, // 895
  { PseudoVFWMSAC_VF32_M1_MASK, PseudoVFWMSAC_VF32_M1, PseudoVFWMSAC_VF32_M1, 0x3 }, // 896
  { PseudoVFWMSAC_VF32_M2_MASK, PseudoVFWMSAC_VF32_M2, PseudoVFWMSAC_VF32_M2, 0x3 }, // 897
  { PseudoVFWMSAC_VF32_M4_MASK, PseudoVFWMSAC_VF32_M4, PseudoVFWMSAC_VF32_M4, 0x3 }, // 898
  { PseudoVFWMSAC_VF32_MF2_MASK, PseudoVFWMSAC_VF32_MF2, PseudoVFWMSAC_VF32_MF2, 0x3 }, // 899
  { PseudoVFWMSAC_VV_M1_MASK, PseudoVFWMSAC_VV_M1, PseudoVFWMSAC_VV_M1, 0x3 }, // 900
  { PseudoVFWMSAC_VV_M2_MASK, PseudoVFWMSAC_VV_M2, PseudoVFWMSAC_VV_M2, 0x3 }, // 901
  { PseudoVFWMSAC_VV_M4_MASK, PseudoVFWMSAC_VV_M4, PseudoVFWMSAC_VV_M4, 0x3 }, // 902
  { PseudoVFWMSAC_VV_MF2_MASK, PseudoVFWMSAC_VV_MF2, PseudoVFWMSAC_VV_MF2, 0x3 }, // 903
  { PseudoVFWMSAC_VV_MF4_MASK, PseudoVFWMSAC_VV_MF4, PseudoVFWMSAC_VV_MF4, 0x3 }, // 904
  { PseudoVFWMUL_VF16_M1_MASK, PseudoVFWMUL_VF16_M1, PseudoVFWMUL_VF16_M1_TU, 0x3 }, // 905
  { PseudoVFWMUL_VF16_M2_MASK, PseudoVFWMUL_VF16_M2, PseudoVFWMUL_VF16_M2_TU, 0x3 }, // 906
  { PseudoVFWMUL_VF16_M4_MASK, PseudoVFWMUL_VF16_M4, PseudoVFWMUL_VF16_M4_TU, 0x3 }, // 907
  { PseudoVFWMUL_VF16_MF2_MASK, PseudoVFWMUL_VF16_MF2, PseudoVFWMUL_VF16_MF2_TU, 0x3 }, // 908
  { PseudoVFWMUL_VF16_MF4_MASK, PseudoVFWMUL_VF16_MF4, PseudoVFWMUL_VF16_MF4_TU, 0x3 }, // 909
  { PseudoVFWMUL_VF32_M1_MASK, PseudoVFWMUL_VF32_M1, PseudoVFWMUL_VF32_M1_TU, 0x3 }, // 910
  { PseudoVFWMUL_VF32_M2_MASK, PseudoVFWMUL_VF32_M2, PseudoVFWMUL_VF32_M2_TU, 0x3 }, // 911
  { PseudoVFWMUL_VF32_M4_MASK, PseudoVFWMUL_VF32_M4, PseudoVFWMUL_VF32_M4_TU, 0x3 }, // 912
  { PseudoVFWMUL_VF32_MF2_MASK, PseudoVFWMUL_VF32_MF2, PseudoVFWMUL_VF32_MF2_TU, 0x3 }, // 913
  { PseudoVFWMUL_VV_M1_MASK, PseudoVFWMUL_VV_M1, PseudoVFWMUL_VV_M1_TU, 0x3 }, // 914
  { PseudoVFWMUL_VV_M2_MASK, PseudoVFWMUL_VV_M2, PseudoVFWMUL_VV_M2_TU, 0x3 }, // 915
  { PseudoVFWMUL_VV_M4_MASK, PseudoVFWMUL_VV_M4, PseudoVFWMUL_VV_M4_TU, 0x3 }, // 916
  { PseudoVFWMUL_VV_MF2_MASK, PseudoVFWMUL_VV_MF2, PseudoVFWMUL_VV_MF2_TU, 0x3 }, // 917
  { PseudoVFWMUL_VV_MF4_MASK, PseudoVFWMUL_VV_MF4, PseudoVFWMUL_VV_MF4_TU, 0x3 }, // 918
  { PseudoVFWNMACC_VF16_M1_MASK, PseudoVFWNMACC_VF16_M1, PseudoVFWNMACC_VF16_M1, 0x3 }, // 919
  { PseudoVFWNMACC_VF16_M2_MASK, PseudoVFWNMACC_VF16_M2, PseudoVFWNMACC_VF16_M2, 0x3 }, // 920
  { PseudoVFWNMACC_VF16_M4_MASK, PseudoVFWNMACC_VF16_M4, PseudoVFWNMACC_VF16_M4, 0x3 }, // 921
  { PseudoVFWNMACC_VF16_MF2_MASK, PseudoVFWNMACC_VF16_MF2, PseudoVFWNMACC_VF16_MF2, 0x3 }, // 922
  { PseudoVFWNMACC_VF16_MF4_MASK, PseudoVFWNMACC_VF16_MF4, PseudoVFWNMACC_VF16_MF4, 0x3 }, // 923
  { PseudoVFWNMACC_VF32_M1_MASK, PseudoVFWNMACC_VF32_M1, PseudoVFWNMACC_VF32_M1, 0x3 }, // 924
  { PseudoVFWNMACC_VF32_M2_MASK, PseudoVFWNMACC_VF32_M2, PseudoVFWNMACC_VF32_M2, 0x3 }, // 925
  { PseudoVFWNMACC_VF32_M4_MASK, PseudoVFWNMACC_VF32_M4, PseudoVFWNMACC_VF32_M4, 0x3 }, // 926
  { PseudoVFWNMACC_VF32_MF2_MASK, PseudoVFWNMACC_VF32_MF2, PseudoVFWNMACC_VF32_MF2, 0x3 }, // 927
  { PseudoVFWNMACC_VV_M1_MASK, PseudoVFWNMACC_VV_M1, PseudoVFWNMACC_VV_M1, 0x3 }, // 928
  { PseudoVFWNMACC_VV_M2_MASK, PseudoVFWNMACC_VV_M2, PseudoVFWNMACC_VV_M2, 0x3 }, // 929
  { PseudoVFWNMACC_VV_M4_MASK, PseudoVFWNMACC_VV_M4, PseudoVFWNMACC_VV_M4, 0x3 }, // 930
  { PseudoVFWNMACC_VV_MF2_MASK, PseudoVFWNMACC_VV_MF2, PseudoVFWNMACC_VV_MF2, 0x3 }, // 931
  { PseudoVFWNMACC_VV_MF4_MASK, PseudoVFWNMACC_VV_MF4, PseudoVFWNMACC_VV_MF4, 0x3 }, // 932
  { PseudoVFWNMSAC_VF16_M1_MASK, PseudoVFWNMSAC_VF16_M1, PseudoVFWNMSAC_VF16_M1, 0x3 }, // 933
  { PseudoVFWNMSAC_VF16_M2_MASK, PseudoVFWNMSAC_VF16_M2, PseudoVFWNMSAC_VF16_M2, 0x3 }, // 934
  { PseudoVFWNMSAC_VF16_M4_MASK, PseudoVFWNMSAC_VF16_M4, PseudoVFWNMSAC_VF16_M4, 0x3 }, // 935
  { PseudoVFWNMSAC_VF16_MF2_MASK, PseudoVFWNMSAC_VF16_MF2, PseudoVFWNMSAC_VF16_MF2, 0x3 }, // 936
  { PseudoVFWNMSAC_VF16_MF4_MASK, PseudoVFWNMSAC_VF16_MF4, PseudoVFWNMSAC_VF16_MF4, 0x3 }, // 937
  { PseudoVFWNMSAC_VF32_M1_MASK, PseudoVFWNMSAC_VF32_M1, PseudoVFWNMSAC_VF32_M1, 0x3 }, // 938
  { PseudoVFWNMSAC_VF32_M2_MASK, PseudoVFWNMSAC_VF32_M2, PseudoVFWNMSAC_VF32_M2, 0x3 }, // 939
  { PseudoVFWNMSAC_VF32_M4_MASK, PseudoVFWNMSAC_VF32_M4, PseudoVFWNMSAC_VF32_M4, 0x3 }, // 940
  { PseudoVFWNMSAC_VF32_MF2_MASK, PseudoVFWNMSAC_VF32_MF2, PseudoVFWNMSAC_VF32_MF2, 0x3 }, // 941
  { PseudoVFWNMSAC_VV_M1_MASK, PseudoVFWNMSAC_VV_M1, PseudoVFWNMSAC_VV_M1, 0x3 }, // 942
  { PseudoVFWNMSAC_VV_M2_MASK, PseudoVFWNMSAC_VV_M2, PseudoVFWNMSAC_VV_M2, 0x3 }, // 943
  { PseudoVFWNMSAC_VV_M4_MASK, PseudoVFWNMSAC_VV_M4, PseudoVFWNMSAC_VV_M4, 0x3 }, // 944
  { PseudoVFWNMSAC_VV_MF2_MASK, PseudoVFWNMSAC_VV_MF2, PseudoVFWNMSAC_VV_MF2, 0x3 }, // 945
  { PseudoVFWNMSAC_VV_MF4_MASK, PseudoVFWNMSAC_VV_MF4, PseudoVFWNMSAC_VV_MF4, 0x3 }, // 946
  { PseudoVFWSUB_VF16_M1_MASK, PseudoVFWSUB_VF16_M1, PseudoVFWSUB_VF16_M1_TU, 0x3 }, // 947
  { PseudoVFWSUB_VF16_M2_MASK, PseudoVFWSUB_VF16_M2, PseudoVFWSUB_VF16_M2_TU, 0x3 }, // 948
  { PseudoVFWSUB_VF16_M4_MASK, PseudoVFWSUB_VF16_M4, PseudoVFWSUB_VF16_M4_TU, 0x3 }, // 949
  { PseudoVFWSUB_VF16_MF2_MASK, PseudoVFWSUB_VF16_MF2, PseudoVFWSUB_VF16_MF2_TU, 0x3 }, // 950
  { PseudoVFWSUB_VF16_MF4_MASK, PseudoVFWSUB_VF16_MF4, PseudoVFWSUB_VF16_MF4_TU, 0x3 }, // 951
  { PseudoVFWSUB_VF32_M1_MASK, PseudoVFWSUB_VF32_M1, PseudoVFWSUB_VF32_M1_TU, 0x3 }, // 952
  { PseudoVFWSUB_VF32_M2_MASK, PseudoVFWSUB_VF32_M2, PseudoVFWSUB_VF32_M2_TU, 0x3 }, // 953
  { PseudoVFWSUB_VF32_M4_MASK, PseudoVFWSUB_VF32_M4, PseudoVFWSUB_VF32_M4_TU, 0x3 }, // 954
  { PseudoVFWSUB_VF32_MF2_MASK, PseudoVFWSUB_VF32_MF2, PseudoVFWSUB_VF32_MF2_TU, 0x3 }, // 955
  { PseudoVFWSUB_VV_M1_MASK, PseudoVFWSUB_VV_M1, PseudoVFWSUB_VV_M1_TU, 0x3 }, // 956
  { PseudoVFWSUB_VV_M2_MASK, PseudoVFWSUB_VV_M2, PseudoVFWSUB_VV_M2_TU, 0x3 }, // 957
  { PseudoVFWSUB_VV_M4_MASK, PseudoVFWSUB_VV_M4, PseudoVFWSUB_VV_M4_TU, 0x3 }, // 958
  { PseudoVFWSUB_VV_MF2_MASK, PseudoVFWSUB_VV_MF2, PseudoVFWSUB_VV_MF2_TU, 0x3 }, // 959
  { PseudoVFWSUB_VV_MF4_MASK, PseudoVFWSUB_VV_MF4, PseudoVFWSUB_VV_MF4_TU, 0x3 }, // 960
  { PseudoVFWSUB_WF16_M1_MASK, PseudoVFWSUB_WF16_M1, PseudoVFWSUB_WF16_M1_TU, 0x3 }, // 961
  { PseudoVFWSUB_WF16_M2_MASK, PseudoVFWSUB_WF16_M2, PseudoVFWSUB_WF16_M2_TU, 0x3 }, // 962
  { PseudoVFWSUB_WF16_M4_MASK, PseudoVFWSUB_WF16_M4, PseudoVFWSUB_WF16_M4_TU, 0x3 }, // 963
  { PseudoVFWSUB_WF16_MF2_MASK, PseudoVFWSUB_WF16_MF2, PseudoVFWSUB_WF16_MF2_TU, 0x3 }, // 964
  { PseudoVFWSUB_WF16_MF4_MASK, PseudoVFWSUB_WF16_MF4, PseudoVFWSUB_WF16_MF4_TU, 0x3 }, // 965
  { PseudoVFWSUB_WF32_M1_MASK, PseudoVFWSUB_WF32_M1, PseudoVFWSUB_WF32_M1_TU, 0x3 }, // 966
  { PseudoVFWSUB_WF32_M2_MASK, PseudoVFWSUB_WF32_M2, PseudoVFWSUB_WF32_M2_TU, 0x3 }, // 967
  { PseudoVFWSUB_WF32_M4_MASK, PseudoVFWSUB_WF32_M4, PseudoVFWSUB_WF32_M4_TU, 0x3 }, // 968
  { PseudoVFWSUB_WF32_MF2_MASK, PseudoVFWSUB_WF32_MF2, PseudoVFWSUB_WF32_MF2_TU, 0x3 }, // 969
  { PseudoVFWSUB_WV_M1_MASK, PseudoVFWSUB_WV_M1, PseudoVFWSUB_WV_M1_TU, 0x3 }, // 970
  { PseudoVFWSUB_WV_M2_MASK, PseudoVFWSUB_WV_M2, PseudoVFWSUB_WV_M2_TU, 0x3 }, // 971
  { PseudoVFWSUB_WV_M4_MASK, PseudoVFWSUB_WV_M4, PseudoVFWSUB_WV_M4_TU, 0x3 }, // 972
  { PseudoVFWSUB_WV_MF2_MASK, PseudoVFWSUB_WV_MF2, PseudoVFWSUB_WV_MF2_TU, 0x3 }, // 973
  { PseudoVFWSUB_WV_MF4_MASK, PseudoVFWSUB_WV_MF4, PseudoVFWSUB_WV_MF4_TU, 0x3 }, // 974
  { PseudoVID_V_M1_MASK, PseudoVID_V_M1, PseudoVID_V_M1_TU, 0x1 }, // 975
  { PseudoVID_V_M2_MASK, PseudoVID_V_M2, PseudoVID_V_M2_TU, 0x1 }, // 976
  { PseudoVID_V_M4_MASK, PseudoVID_V_M4, PseudoVID_V_M4_TU, 0x1 }, // 977
  { PseudoVID_V_M8_MASK, PseudoVID_V_M8, PseudoVID_V_M8_TU, 0x1 }, // 978
  { PseudoVID_V_MF2_MASK, PseudoVID_V_MF2, PseudoVID_V_MF2_TU, 0x1 }, // 979
  { PseudoVID_V_MF4_MASK, PseudoVID_V_MF4, PseudoVID_V_MF4_TU, 0x1 }, // 980
  { PseudoVID_V_MF8_MASK, PseudoVID_V_MF8, PseudoVID_V_MF8_TU, 0x1 }, // 981
  { PseudoVIOTA_M_M1_MASK, PseudoVIOTA_M_M1, PseudoVIOTA_M_M1_TU, 0x2 }, // 982
  { PseudoVIOTA_M_M2_MASK, PseudoVIOTA_M_M2, PseudoVIOTA_M_M2_TU, 0x2 }, // 983
  { PseudoVIOTA_M_M4_MASK, PseudoVIOTA_M_M4, PseudoVIOTA_M_M4_TU, 0x2 }, // 984
  { PseudoVIOTA_M_M8_MASK, PseudoVIOTA_M_M8, PseudoVIOTA_M_M8_TU, 0x2 }, // 985
  { PseudoVIOTA_M_MF2_MASK, PseudoVIOTA_M_MF2, PseudoVIOTA_M_MF2_TU, 0x2 }, // 986
  { PseudoVIOTA_M_MF4_MASK, PseudoVIOTA_M_MF4, PseudoVIOTA_M_MF4_TU, 0x2 }, // 987
  { PseudoVIOTA_M_MF8_MASK, PseudoVIOTA_M_MF8, PseudoVIOTA_M_MF8_TU, 0x2 }, // 988
  { PseudoVLE16FF_V_M1_MASK, PseudoVLE16FF_V_M1, PseudoVLE16FF_V_M1_TU, 0x2 }, // 989
  { PseudoVLE16FF_V_M2_MASK, PseudoVLE16FF_V_M2, PseudoVLE16FF_V_M2_TU, 0x2 }, // 990
  { PseudoVLE16FF_V_M4_MASK, PseudoVLE16FF_V_M4, PseudoVLE16FF_V_M4_TU, 0x2 }, // 991
  { PseudoVLE16FF_V_M8_MASK, PseudoVLE16FF_V_M8, PseudoVLE16FF_V_M8_TU, 0x2 }, // 992
  { PseudoVLE16FF_V_MF2_MASK, PseudoVLE16FF_V_MF2, PseudoVLE16FF_V_MF2_TU, 0x2 }, // 993
  { PseudoVLE16FF_V_MF4_MASK, PseudoVLE16FF_V_MF4, PseudoVLE16FF_V_MF4_TU, 0x2 }, // 994
  { PseudoVLE16_V_M1_MASK, PseudoVLE16_V_M1, PseudoVLE16_V_M1_TU, 0x2 }, // 995
  { PseudoVLE16_V_M2_MASK, PseudoVLE16_V_M2, PseudoVLE16_V_M2_TU, 0x2 }, // 996
  { PseudoVLE16_V_M4_MASK, PseudoVLE16_V_M4, PseudoVLE16_V_M4_TU, 0x2 }, // 997
  { PseudoVLE16_V_M8_MASK, PseudoVLE16_V_M8, PseudoVLE16_V_M8_TU, 0x2 }, // 998
  { PseudoVLE16_V_MF2_MASK, PseudoVLE16_V_MF2, PseudoVLE16_V_MF2_TU, 0x2 }, // 999
  { PseudoVLE16_V_MF4_MASK, PseudoVLE16_V_MF4, PseudoVLE16_V_MF4_TU, 0x2 }, // 1000
  { PseudoVLE32FF_V_M1_MASK, PseudoVLE32FF_V_M1, PseudoVLE32FF_V_M1_TU, 0x2 }, // 1001
  { PseudoVLE32FF_V_M2_MASK, PseudoVLE32FF_V_M2, PseudoVLE32FF_V_M2_TU, 0x2 }, // 1002
  { PseudoVLE32FF_V_M4_MASK, PseudoVLE32FF_V_M4, PseudoVLE32FF_V_M4_TU, 0x2 }, // 1003
  { PseudoVLE32FF_V_M8_MASK, PseudoVLE32FF_V_M8, PseudoVLE32FF_V_M8_TU, 0x2 }, // 1004
  { PseudoVLE32FF_V_MF2_MASK, PseudoVLE32FF_V_MF2, PseudoVLE32FF_V_MF2_TU, 0x2 }, // 1005
  { PseudoVLE32_V_M1_MASK, PseudoVLE32_V_M1, PseudoVLE32_V_M1_TU, 0x2 }, // 1006
  { PseudoVLE32_V_M2_MASK, PseudoVLE32_V_M2, PseudoVLE32_V_M2_TU, 0x2 }, // 1007
  { PseudoVLE32_V_M4_MASK, PseudoVLE32_V_M4, PseudoVLE32_V_M4_TU, 0x2 }, // 1008
  { PseudoVLE32_V_M8_MASK, PseudoVLE32_V_M8, PseudoVLE32_V_M8_TU, 0x2 }, // 1009
  { PseudoVLE32_V_MF2_MASK, PseudoVLE32_V_MF2, PseudoVLE32_V_MF2_TU, 0x2 }, // 1010
  { PseudoVLE64FF_V_M1_MASK, PseudoVLE64FF_V_M1, PseudoVLE64FF_V_M1_TU, 0x2 }, // 1011
  { PseudoVLE64FF_V_M2_MASK, PseudoVLE64FF_V_M2, PseudoVLE64FF_V_M2_TU, 0x2 }, // 1012
  { PseudoVLE64FF_V_M4_MASK, PseudoVLE64FF_V_M4, PseudoVLE64FF_V_M4_TU, 0x2 }, // 1013
  { PseudoVLE64FF_V_M8_MASK, PseudoVLE64FF_V_M8, PseudoVLE64FF_V_M8_TU, 0x2 }, // 1014
  { PseudoVLE64_V_M1_MASK, PseudoVLE64_V_M1, PseudoVLE64_V_M1_TU, 0x2 }, // 1015
  { PseudoVLE64_V_M2_MASK, PseudoVLE64_V_M2, PseudoVLE64_V_M2_TU, 0x2 }, // 1016
  { PseudoVLE64_V_M4_MASK, PseudoVLE64_V_M4, PseudoVLE64_V_M4_TU, 0x2 }, // 1017
  { PseudoVLE64_V_M8_MASK, PseudoVLE64_V_M8, PseudoVLE64_V_M8_TU, 0x2 }, // 1018
  { PseudoVLE8FF_V_M1_MASK, PseudoVLE8FF_V_M1, PseudoVLE8FF_V_M1_TU, 0x2 }, // 1019
  { PseudoVLE8FF_V_M2_MASK, PseudoVLE8FF_V_M2, PseudoVLE8FF_V_M2_TU, 0x2 }, // 1020
  { PseudoVLE8FF_V_M4_MASK, PseudoVLE8FF_V_M4, PseudoVLE8FF_V_M4_TU, 0x2 }, // 1021
  { PseudoVLE8FF_V_M8_MASK, PseudoVLE8FF_V_M8, PseudoVLE8FF_V_M8_TU, 0x2 }, // 1022
  { PseudoVLE8FF_V_MF2_MASK, PseudoVLE8FF_V_MF2, PseudoVLE8FF_V_MF2_TU, 0x2 }, // 1023
  { PseudoVLE8FF_V_MF4_MASK, PseudoVLE8FF_V_MF4, PseudoVLE8FF_V_MF4_TU, 0x2 }, // 1024
  { PseudoVLE8FF_V_MF8_MASK, PseudoVLE8FF_V_MF8, PseudoVLE8FF_V_MF8_TU, 0x2 }, // 1025
  { PseudoVLE8_V_M1_MASK, PseudoVLE8_V_M1, PseudoVLE8_V_M1_TU, 0x2 }, // 1026
  { PseudoVLE8_V_M2_MASK, PseudoVLE8_V_M2, PseudoVLE8_V_M2_TU, 0x2 }, // 1027
  { PseudoVLE8_V_M4_MASK, PseudoVLE8_V_M4, PseudoVLE8_V_M4_TU, 0x2 }, // 1028
  { PseudoVLE8_V_M8_MASK, PseudoVLE8_V_M8, PseudoVLE8_V_M8_TU, 0x2 }, // 1029
  { PseudoVLE8_V_MF2_MASK, PseudoVLE8_V_MF2, PseudoVLE8_V_MF2_TU, 0x2 }, // 1030
  { PseudoVLE8_V_MF4_MASK, PseudoVLE8_V_MF4, PseudoVLE8_V_MF4_TU, 0x2 }, // 1031
  { PseudoVLE8_V_MF8_MASK, PseudoVLE8_V_MF8, PseudoVLE8_V_MF8_TU, 0x2 }, // 1032
  { PseudoVLOXEI16_V_M1_M1_MASK, PseudoVLOXEI16_V_M1_M1, PseudoVLOXEI16_V_M1_M1_TU, 0x3 }, // 1033
  { PseudoVLOXEI16_V_M1_M2_MASK, PseudoVLOXEI16_V_M1_M2, PseudoVLOXEI16_V_M1_M2_TU, 0x3 }, // 1034
  { PseudoVLOXEI16_V_M1_M4_MASK, PseudoVLOXEI16_V_M1_M4, PseudoVLOXEI16_V_M1_M4_TU, 0x3 }, // 1035
  { PseudoVLOXEI16_V_M1_MF2_MASK, PseudoVLOXEI16_V_M1_MF2, PseudoVLOXEI16_V_M1_MF2_TU, 0x3 }, // 1036
  { PseudoVLOXEI16_V_M2_M1_MASK, PseudoVLOXEI16_V_M2_M1, PseudoVLOXEI16_V_M2_M1_TU, 0x3 }, // 1037
  { PseudoVLOXEI16_V_M2_M2_MASK, PseudoVLOXEI16_V_M2_M2, PseudoVLOXEI16_V_M2_M2_TU, 0x3 }, // 1038
  { PseudoVLOXEI16_V_M2_M4_MASK, PseudoVLOXEI16_V_M2_M4, PseudoVLOXEI16_V_M2_M4_TU, 0x3 }, // 1039
  { PseudoVLOXEI16_V_M2_M8_MASK, PseudoVLOXEI16_V_M2_M8, PseudoVLOXEI16_V_M2_M8_TU, 0x3 }, // 1040
  { PseudoVLOXEI16_V_M4_M2_MASK, PseudoVLOXEI16_V_M4_M2, PseudoVLOXEI16_V_M4_M2_TU, 0x3 }, // 1041
  { PseudoVLOXEI16_V_M4_M4_MASK, PseudoVLOXEI16_V_M4_M4, PseudoVLOXEI16_V_M4_M4_TU, 0x3 }, // 1042
  { PseudoVLOXEI16_V_M4_M8_MASK, PseudoVLOXEI16_V_M4_M8, PseudoVLOXEI16_V_M4_M8_TU, 0x3 }, // 1043
  { PseudoVLOXEI16_V_M8_M4_MASK, PseudoVLOXEI16_V_M8_M4, PseudoVLOXEI16_V_M8_M4_TU, 0x3 }, // 1044
  { PseudoVLOXEI16_V_M8_M8_MASK, PseudoVLOXEI16_V_M8_M8, PseudoVLOXEI16_V_M8_M8_TU, 0x3 }, // 1045
  { PseudoVLOXEI16_V_MF2_M1_MASK, PseudoVLOXEI16_V_MF2_M1, PseudoVLOXEI16_V_MF2_M1_TU, 0x3 }, // 1046
  { PseudoVLOXEI16_V_MF2_M2_MASK, PseudoVLOXEI16_V_MF2_M2, PseudoVLOXEI16_V_MF2_M2_TU, 0x3 }, // 1047
  { PseudoVLOXEI16_V_MF2_MF2_MASK, PseudoVLOXEI16_V_MF2_MF2, PseudoVLOXEI16_V_MF2_MF2_TU, 0x3 }, // 1048
  { PseudoVLOXEI16_V_MF2_MF4_MASK, PseudoVLOXEI16_V_MF2_MF4, PseudoVLOXEI16_V_MF2_MF4_TU, 0x3 }, // 1049
  { PseudoVLOXEI16_V_MF4_M1_MASK, PseudoVLOXEI16_V_MF4_M1, PseudoVLOXEI16_V_MF4_M1_TU, 0x3 }, // 1050
  { PseudoVLOXEI16_V_MF4_MF2_MASK, PseudoVLOXEI16_V_MF4_MF2, PseudoVLOXEI16_V_MF4_MF2_TU, 0x3 }, // 1051
  { PseudoVLOXEI16_V_MF4_MF4_MASK, PseudoVLOXEI16_V_MF4_MF4, PseudoVLOXEI16_V_MF4_MF4_TU, 0x3 }, // 1052
  { PseudoVLOXEI16_V_MF4_MF8_MASK, PseudoVLOXEI16_V_MF4_MF8, PseudoVLOXEI16_V_MF4_MF8_TU, 0x3 }, // 1053
  { PseudoVLOXEI32_V_M1_M1_MASK, PseudoVLOXEI32_V_M1_M1, PseudoVLOXEI32_V_M1_M1_TU, 0x3 }, // 1054
  { PseudoVLOXEI32_V_M1_M2_MASK, PseudoVLOXEI32_V_M1_M2, PseudoVLOXEI32_V_M1_M2_TU, 0x3 }, // 1055
  { PseudoVLOXEI32_V_M1_MF2_MASK, PseudoVLOXEI32_V_M1_MF2, PseudoVLOXEI32_V_M1_MF2_TU, 0x3 }, // 1056
  { PseudoVLOXEI32_V_M1_MF4_MASK, PseudoVLOXEI32_V_M1_MF4, PseudoVLOXEI32_V_M1_MF4_TU, 0x3 }, // 1057
  { PseudoVLOXEI32_V_M2_M1_MASK, PseudoVLOXEI32_V_M2_M1, PseudoVLOXEI32_V_M2_M1_TU, 0x3 }, // 1058
  { PseudoVLOXEI32_V_M2_M2_MASK, PseudoVLOXEI32_V_M2_M2, PseudoVLOXEI32_V_M2_M2_TU, 0x3 }, // 1059
  { PseudoVLOXEI32_V_M2_M4_MASK, PseudoVLOXEI32_V_M2_M4, PseudoVLOXEI32_V_M2_M4_TU, 0x3 }, // 1060
  { PseudoVLOXEI32_V_M2_MF2_MASK, PseudoVLOXEI32_V_M2_MF2, PseudoVLOXEI32_V_M2_MF2_TU, 0x3 }, // 1061
  { PseudoVLOXEI32_V_M4_M1_MASK, PseudoVLOXEI32_V_M4_M1, PseudoVLOXEI32_V_M4_M1_TU, 0x3 }, // 1062
  { PseudoVLOXEI32_V_M4_M2_MASK, PseudoVLOXEI32_V_M4_M2, PseudoVLOXEI32_V_M4_M2_TU, 0x3 }, // 1063
  { PseudoVLOXEI32_V_M4_M4_MASK, PseudoVLOXEI32_V_M4_M4, PseudoVLOXEI32_V_M4_M4_TU, 0x3 }, // 1064
  { PseudoVLOXEI32_V_M4_M8_MASK, PseudoVLOXEI32_V_M4_M8, PseudoVLOXEI32_V_M4_M8_TU, 0x3 }, // 1065
  { PseudoVLOXEI32_V_M8_M2_MASK, PseudoVLOXEI32_V_M8_M2, PseudoVLOXEI32_V_M8_M2_TU, 0x3 }, // 1066
  { PseudoVLOXEI32_V_M8_M4_MASK, PseudoVLOXEI32_V_M8_M4, PseudoVLOXEI32_V_M8_M4_TU, 0x3 }, // 1067
  { PseudoVLOXEI32_V_M8_M8_MASK, PseudoVLOXEI32_V_M8_M8, PseudoVLOXEI32_V_M8_M8_TU, 0x3 }, // 1068
  { PseudoVLOXEI32_V_MF2_M1_MASK, PseudoVLOXEI32_V_MF2_M1, PseudoVLOXEI32_V_MF2_M1_TU, 0x3 }, // 1069
  { PseudoVLOXEI32_V_MF2_MF2_MASK, PseudoVLOXEI32_V_MF2_MF2, PseudoVLOXEI32_V_MF2_MF2_TU, 0x3 }, // 1070
  { PseudoVLOXEI32_V_MF2_MF4_MASK, PseudoVLOXEI32_V_MF2_MF4, PseudoVLOXEI32_V_MF2_MF4_TU, 0x3 }, // 1071
  { PseudoVLOXEI32_V_MF2_MF8_MASK, PseudoVLOXEI32_V_MF2_MF8, PseudoVLOXEI32_V_MF2_MF8_TU, 0x3 }, // 1072
  { PseudoVLOXEI64_V_M1_M1_MASK, PseudoVLOXEI64_V_M1_M1, PseudoVLOXEI64_V_M1_M1_TU, 0x3 }, // 1073
  { PseudoVLOXEI64_V_M1_MF2_MASK, PseudoVLOXEI64_V_M1_MF2, PseudoVLOXEI64_V_M1_MF2_TU, 0x3 }, // 1074
  { PseudoVLOXEI64_V_M1_MF4_MASK, PseudoVLOXEI64_V_M1_MF4, PseudoVLOXEI64_V_M1_MF4_TU, 0x3 }, // 1075
  { PseudoVLOXEI64_V_M1_MF8_MASK, PseudoVLOXEI64_V_M1_MF8, PseudoVLOXEI64_V_M1_MF8_TU, 0x3 }, // 1076
  { PseudoVLOXEI64_V_M2_M1_MASK, PseudoVLOXEI64_V_M2_M1, PseudoVLOXEI64_V_M2_M1_TU, 0x3 }, // 1077
  { PseudoVLOXEI64_V_M2_M2_MASK, PseudoVLOXEI64_V_M2_M2, PseudoVLOXEI64_V_M2_M2_TU, 0x3 }, // 1078
  { PseudoVLOXEI64_V_M2_MF2_MASK, PseudoVLOXEI64_V_M2_MF2, PseudoVLOXEI64_V_M2_MF2_TU, 0x3 }, // 1079
  { PseudoVLOXEI64_V_M2_MF4_MASK, PseudoVLOXEI64_V_M2_MF4, PseudoVLOXEI64_V_M2_MF4_TU, 0x3 }, // 1080
  { PseudoVLOXEI64_V_M4_M1_MASK, PseudoVLOXEI64_V_M4_M1, PseudoVLOXEI64_V_M4_M1_TU, 0x3 }, // 1081
  { PseudoVLOXEI64_V_M4_M2_MASK, PseudoVLOXEI64_V_M4_M2, PseudoVLOXEI64_V_M4_M2_TU, 0x3 }, // 1082
  { PseudoVLOXEI64_V_M4_M4_MASK, PseudoVLOXEI64_V_M4_M4, PseudoVLOXEI64_V_M4_M4_TU, 0x3 }, // 1083
  { PseudoVLOXEI64_V_M4_MF2_MASK, PseudoVLOXEI64_V_M4_MF2, PseudoVLOXEI64_V_M4_MF2_TU, 0x3 }, // 1084
  { PseudoVLOXEI64_V_M8_M1_MASK, PseudoVLOXEI64_V_M8_M1, PseudoVLOXEI64_V_M8_M1_TU, 0x3 }, // 1085
  { PseudoVLOXEI64_V_M8_M2_MASK, PseudoVLOXEI64_V_M8_M2, PseudoVLOXEI64_V_M8_M2_TU, 0x3 }, // 1086
  { PseudoVLOXEI64_V_M8_M4_MASK, PseudoVLOXEI64_V_M8_M4, PseudoVLOXEI64_V_M8_M4_TU, 0x3 }, // 1087
  { PseudoVLOXEI64_V_M8_M8_MASK, PseudoVLOXEI64_V_M8_M8, PseudoVLOXEI64_V_M8_M8_TU, 0x3 }, // 1088
  { PseudoVLOXEI8_V_M1_M1_MASK, PseudoVLOXEI8_V_M1_M1, PseudoVLOXEI8_V_M1_M1_TU, 0x3 }, // 1089
  { PseudoVLOXEI8_V_M1_M2_MASK, PseudoVLOXEI8_V_M1_M2, PseudoVLOXEI8_V_M1_M2_TU, 0x3 }, // 1090
  { PseudoVLOXEI8_V_M1_M4_MASK, PseudoVLOXEI8_V_M1_M4, PseudoVLOXEI8_V_M1_M4_TU, 0x3 }, // 1091
  { PseudoVLOXEI8_V_M1_M8_MASK, PseudoVLOXEI8_V_M1_M8, PseudoVLOXEI8_V_M1_M8_TU, 0x3 }, // 1092
  { PseudoVLOXEI8_V_M2_M2_MASK, PseudoVLOXEI8_V_M2_M2, PseudoVLOXEI8_V_M2_M2_TU, 0x3 }, // 1093
  { PseudoVLOXEI8_V_M2_M4_MASK, PseudoVLOXEI8_V_M2_M4, PseudoVLOXEI8_V_M2_M4_TU, 0x3 }, // 1094
  { PseudoVLOXEI8_V_M2_M8_MASK, PseudoVLOXEI8_V_M2_M8, PseudoVLOXEI8_V_M2_M8_TU, 0x3 }, // 1095
  { PseudoVLOXEI8_V_M4_M4_MASK, PseudoVLOXEI8_V_M4_M4, PseudoVLOXEI8_V_M4_M4_TU, 0x3 }, // 1096
  { PseudoVLOXEI8_V_M4_M8_MASK, PseudoVLOXEI8_V_M4_M8, PseudoVLOXEI8_V_M4_M8_TU, 0x3 }, // 1097
  { PseudoVLOXEI8_V_M8_M8_MASK, PseudoVLOXEI8_V_M8_M8, PseudoVLOXEI8_V_M8_M8_TU, 0x3 }, // 1098
  { PseudoVLOXEI8_V_MF2_M1_MASK, PseudoVLOXEI8_V_MF2_M1, PseudoVLOXEI8_V_MF2_M1_TU, 0x3 }, // 1099
  { PseudoVLOXEI8_V_MF2_M2_MASK, PseudoVLOXEI8_V_MF2_M2, PseudoVLOXEI8_V_MF2_M2_TU, 0x3 }, // 1100
  { PseudoVLOXEI8_V_MF2_M4_MASK, PseudoVLOXEI8_V_MF2_M4, PseudoVLOXEI8_V_MF2_M4_TU, 0x3 }, // 1101
  { PseudoVLOXEI8_V_MF2_MF2_MASK, PseudoVLOXEI8_V_MF2_MF2, PseudoVLOXEI8_V_MF2_MF2_TU, 0x3 }, // 1102
  { PseudoVLOXEI8_V_MF4_M1_MASK, PseudoVLOXEI8_V_MF4_M1, PseudoVLOXEI8_V_MF4_M1_TU, 0x3 }, // 1103
  { PseudoVLOXEI8_V_MF4_M2_MASK, PseudoVLOXEI8_V_MF4_M2, PseudoVLOXEI8_V_MF4_M2_TU, 0x3 }, // 1104
  { PseudoVLOXEI8_V_MF4_MF2_MASK, PseudoVLOXEI8_V_MF4_MF2, PseudoVLOXEI8_V_MF4_MF2_TU, 0x3 }, // 1105
  { PseudoVLOXEI8_V_MF4_MF4_MASK, PseudoVLOXEI8_V_MF4_MF4, PseudoVLOXEI8_V_MF4_MF4_TU, 0x3 }, // 1106
  { PseudoVLOXEI8_V_MF8_M1_MASK, PseudoVLOXEI8_V_MF8_M1, PseudoVLOXEI8_V_MF8_M1_TU, 0x3 }, // 1107
  { PseudoVLOXEI8_V_MF8_MF2_MASK, PseudoVLOXEI8_V_MF8_MF2, PseudoVLOXEI8_V_MF8_MF2_TU, 0x3 }, // 1108
  { PseudoVLOXEI8_V_MF8_MF4_MASK, PseudoVLOXEI8_V_MF8_MF4, PseudoVLOXEI8_V_MF8_MF4_TU, 0x3 }, // 1109
  { PseudoVLOXEI8_V_MF8_MF8_MASK, PseudoVLOXEI8_V_MF8_MF8, PseudoVLOXEI8_V_MF8_MF8_TU, 0x3 }, // 1110
  { PseudoVLSE16_V_M1_MASK, PseudoVLSE16_V_M1, PseudoVLSE16_V_M1_TU, 0x3 }, // 1111
  { PseudoVLSE16_V_M2_MASK, PseudoVLSE16_V_M2, PseudoVLSE16_V_M2_TU, 0x3 }, // 1112
  { PseudoVLSE16_V_M4_MASK, PseudoVLSE16_V_M4, PseudoVLSE16_V_M4_TU, 0x3 }, // 1113
  { PseudoVLSE16_V_M8_MASK, PseudoVLSE16_V_M8, PseudoVLSE16_V_M8_TU, 0x3 }, // 1114
  { PseudoVLSE16_V_MF2_MASK, PseudoVLSE16_V_MF2, PseudoVLSE16_V_MF2_TU, 0x3 }, // 1115
  { PseudoVLSE16_V_MF4_MASK, PseudoVLSE16_V_MF4, PseudoVLSE16_V_MF4_TU, 0x3 }, // 1116
  { PseudoVLSE32_V_M1_MASK, PseudoVLSE32_V_M1, PseudoVLSE32_V_M1_TU, 0x3 }, // 1117
  { PseudoVLSE32_V_M2_MASK, PseudoVLSE32_V_M2, PseudoVLSE32_V_M2_TU, 0x3 }, // 1118
  { PseudoVLSE32_V_M4_MASK, PseudoVLSE32_V_M4, PseudoVLSE32_V_M4_TU, 0x3 }, // 1119
  { PseudoVLSE32_V_M8_MASK, PseudoVLSE32_V_M8, PseudoVLSE32_V_M8_TU, 0x3 }, // 1120
  { PseudoVLSE32_V_MF2_MASK, PseudoVLSE32_V_MF2, PseudoVLSE32_V_MF2_TU, 0x3 }, // 1121
  { PseudoVLSE64_V_M1_MASK, PseudoVLSE64_V_M1, PseudoVLSE64_V_M1_TU, 0x3 }, // 1122
  { PseudoVLSE64_V_M2_MASK, PseudoVLSE64_V_M2, PseudoVLSE64_V_M2_TU, 0x3 }, // 1123
  { PseudoVLSE64_V_M4_MASK, PseudoVLSE64_V_M4, PseudoVLSE64_V_M4_TU, 0x3 }, // 1124
  { PseudoVLSE64_V_M8_MASK, PseudoVLSE64_V_M8, PseudoVLSE64_V_M8_TU, 0x3 }, // 1125
  { PseudoVLSE8_V_M1_MASK, PseudoVLSE8_V_M1, PseudoVLSE8_V_M1_TU, 0x3 }, // 1126
  { PseudoVLSE8_V_M2_MASK, PseudoVLSE8_V_M2, PseudoVLSE8_V_M2_TU, 0x3 }, // 1127
  { PseudoVLSE8_V_M4_MASK, PseudoVLSE8_V_M4, PseudoVLSE8_V_M4_TU, 0x3 }, // 1128
  { PseudoVLSE8_V_M8_MASK, PseudoVLSE8_V_M8, PseudoVLSE8_V_M8_TU, 0x3 }, // 1129
  { PseudoVLSE8_V_MF2_MASK, PseudoVLSE8_V_MF2, PseudoVLSE8_V_MF2_TU, 0x3 }, // 1130
  { PseudoVLSE8_V_MF4_MASK, PseudoVLSE8_V_MF4, PseudoVLSE8_V_MF4_TU, 0x3 }, // 1131
  { PseudoVLSE8_V_MF8_MASK, PseudoVLSE8_V_MF8, PseudoVLSE8_V_MF8_TU, 0x3 }, // 1132
  { PseudoVLUXEI16_V_M1_M1_MASK, PseudoVLUXEI16_V_M1_M1, PseudoVLUXEI16_V_M1_M1_TU, 0x3 }, // 1133
  { PseudoVLUXEI16_V_M1_M2_MASK, PseudoVLUXEI16_V_M1_M2, PseudoVLUXEI16_V_M1_M2_TU, 0x3 }, // 1134
  { PseudoVLUXEI16_V_M1_M4_MASK, PseudoVLUXEI16_V_M1_M4, PseudoVLUXEI16_V_M1_M4_TU, 0x3 }, // 1135
  { PseudoVLUXEI16_V_M1_MF2_MASK, PseudoVLUXEI16_V_M1_MF2, PseudoVLUXEI16_V_M1_MF2_TU, 0x3 }, // 1136
  { PseudoVLUXEI16_V_M2_M1_MASK, PseudoVLUXEI16_V_M2_M1, PseudoVLUXEI16_V_M2_M1_TU, 0x3 }, // 1137
  { PseudoVLUXEI16_V_M2_M2_MASK, PseudoVLUXEI16_V_M2_M2, PseudoVLUXEI16_V_M2_M2_TU, 0x3 }, // 1138
  { PseudoVLUXEI16_V_M2_M4_MASK, PseudoVLUXEI16_V_M2_M4, PseudoVLUXEI16_V_M2_M4_TU, 0x3 }, // 1139
  { PseudoVLUXEI16_V_M2_M8_MASK, PseudoVLUXEI16_V_M2_M8, PseudoVLUXEI16_V_M2_M8_TU, 0x3 }, // 1140
  { PseudoVLUXEI16_V_M4_M2_MASK, PseudoVLUXEI16_V_M4_M2, PseudoVLUXEI16_V_M4_M2_TU, 0x3 }, // 1141
  { PseudoVLUXEI16_V_M4_M4_MASK, PseudoVLUXEI16_V_M4_M4, PseudoVLUXEI16_V_M4_M4_TU, 0x3 }, // 1142
  { PseudoVLUXEI16_V_M4_M8_MASK, PseudoVLUXEI16_V_M4_M8, PseudoVLUXEI16_V_M4_M8_TU, 0x3 }, // 1143
  { PseudoVLUXEI16_V_M8_M4_MASK, PseudoVLUXEI16_V_M8_M4, PseudoVLUXEI16_V_M8_M4_TU, 0x3 }, // 1144
  { PseudoVLUXEI16_V_M8_M8_MASK, PseudoVLUXEI16_V_M8_M8, PseudoVLUXEI16_V_M8_M8_TU, 0x3 }, // 1145
  { PseudoVLUXEI16_V_MF2_M1_MASK, PseudoVLUXEI16_V_MF2_M1, PseudoVLUXEI16_V_MF2_M1_TU, 0x3 }, // 1146
  { PseudoVLUXEI16_V_MF2_M2_MASK, PseudoVLUXEI16_V_MF2_M2, PseudoVLUXEI16_V_MF2_M2_TU, 0x3 }, // 1147
  { PseudoVLUXEI16_V_MF2_MF2_MASK, PseudoVLUXEI16_V_MF2_MF2, PseudoVLUXEI16_V_MF2_MF2_TU, 0x3 }, // 1148
  { PseudoVLUXEI16_V_MF2_MF4_MASK, PseudoVLUXEI16_V_MF2_MF4, PseudoVLUXEI16_V_MF2_MF4_TU, 0x3 }, // 1149
  { PseudoVLUXEI16_V_MF4_M1_MASK, PseudoVLUXEI16_V_MF4_M1, PseudoVLUXEI16_V_MF4_M1_TU, 0x3 }, // 1150
  { PseudoVLUXEI16_V_MF4_MF2_MASK, PseudoVLUXEI16_V_MF4_MF2, PseudoVLUXEI16_V_MF4_MF2_TU, 0x3 }, // 1151
  { PseudoVLUXEI16_V_MF4_MF4_MASK, PseudoVLUXEI16_V_MF4_MF4, PseudoVLUXEI16_V_MF4_MF4_TU, 0x3 }, // 1152
  { PseudoVLUXEI16_V_MF4_MF8_MASK, PseudoVLUXEI16_V_MF4_MF8, PseudoVLUXEI16_V_MF4_MF8_TU, 0x3 }, // 1153
  { PseudoVLUXEI32_V_M1_M1_MASK, PseudoVLUXEI32_V_M1_M1, PseudoVLUXEI32_V_M1_M1_TU, 0x3 }, // 1154
  { PseudoVLUXEI32_V_M1_M2_MASK, PseudoVLUXEI32_V_M1_M2, PseudoVLUXEI32_V_M1_M2_TU, 0x3 }, // 1155
  { PseudoVLUXEI32_V_M1_MF2_MASK, PseudoVLUXEI32_V_M1_MF2, PseudoVLUXEI32_V_M1_MF2_TU, 0x3 }, // 1156
  { PseudoVLUXEI32_V_M1_MF4_MASK, PseudoVLUXEI32_V_M1_MF4, PseudoVLUXEI32_V_M1_MF4_TU, 0x3 }, // 1157
  { PseudoVLUXEI32_V_M2_M1_MASK, PseudoVLUXEI32_V_M2_M1, PseudoVLUXEI32_V_M2_M1_TU, 0x3 }, // 1158
  { PseudoVLUXEI32_V_M2_M2_MASK, PseudoVLUXEI32_V_M2_M2, PseudoVLUXEI32_V_M2_M2_TU, 0x3 }, // 1159
  { PseudoVLUXEI32_V_M2_M4_MASK, PseudoVLUXEI32_V_M2_M4, PseudoVLUXEI32_V_M2_M4_TU, 0x3 }, // 1160
  { PseudoVLUXEI32_V_M2_MF2_MASK, PseudoVLUXEI32_V_M2_MF2, PseudoVLUXEI32_V_M2_MF2_TU, 0x3 }, // 1161
  { PseudoVLUXEI32_V_M4_M1_MASK, PseudoVLUXEI32_V_M4_M1, PseudoVLUXEI32_V_M4_M1_TU, 0x3 }, // 1162
  { PseudoVLUXEI32_V_M4_M2_MASK, PseudoVLUXEI32_V_M4_M2, PseudoVLUXEI32_V_M4_M2_TU, 0x3 }, // 1163
  { PseudoVLUXEI32_V_M4_M4_MASK, PseudoVLUXEI32_V_M4_M4, PseudoVLUXEI32_V_M4_M4_TU, 0x3 }, // 1164
  { PseudoVLUXEI32_V_M4_M8_MASK, PseudoVLUXEI32_V_M4_M8, PseudoVLUXEI32_V_M4_M8_TU, 0x3 }, // 1165
  { PseudoVLUXEI32_V_M8_M2_MASK, PseudoVLUXEI32_V_M8_M2, PseudoVLUXEI32_V_M8_M2_TU, 0x3 }, // 1166
  { PseudoVLUXEI32_V_M8_M4_MASK, PseudoVLUXEI32_V_M8_M4, PseudoVLUXEI32_V_M8_M4_TU, 0x3 }, // 1167
  { PseudoVLUXEI32_V_M8_M8_MASK, PseudoVLUXEI32_V_M8_M8, PseudoVLUXEI32_V_M8_M8_TU, 0x3 }, // 1168
  { PseudoVLUXEI32_V_MF2_M1_MASK, PseudoVLUXEI32_V_MF2_M1, PseudoVLUXEI32_V_MF2_M1_TU, 0x3 }, // 1169
  { PseudoVLUXEI32_V_MF2_MF2_MASK, PseudoVLUXEI32_V_MF2_MF2, PseudoVLUXEI32_V_MF2_MF2_TU, 0x3 }, // 1170
  { PseudoVLUXEI32_V_MF2_MF4_MASK, PseudoVLUXEI32_V_MF2_MF4, PseudoVLUXEI32_V_MF2_MF4_TU, 0x3 }, // 1171
  { PseudoVLUXEI32_V_MF2_MF8_MASK, PseudoVLUXEI32_V_MF2_MF8, PseudoVLUXEI32_V_MF2_MF8_TU, 0x3 }, // 1172
  { PseudoVLUXEI64_V_M1_M1_MASK, PseudoVLUXEI64_V_M1_M1, PseudoVLUXEI64_V_M1_M1_TU, 0x3 }, // 1173
  { PseudoVLUXEI64_V_M1_MF2_MASK, PseudoVLUXEI64_V_M1_MF2, PseudoVLUXEI64_V_M1_MF2_TU, 0x3 }, // 1174
  { PseudoVLUXEI64_V_M1_MF4_MASK, PseudoVLUXEI64_V_M1_MF4, PseudoVLUXEI64_V_M1_MF4_TU, 0x3 }, // 1175
  { PseudoVLUXEI64_V_M1_MF8_MASK, PseudoVLUXEI64_V_M1_MF8, PseudoVLUXEI64_V_M1_MF8_TU, 0x3 }, // 1176
  { PseudoVLUXEI64_V_M2_M1_MASK, PseudoVLUXEI64_V_M2_M1, PseudoVLUXEI64_V_M2_M1_TU, 0x3 }, // 1177
  { PseudoVLUXEI64_V_M2_M2_MASK, PseudoVLUXEI64_V_M2_M2, PseudoVLUXEI64_V_M2_M2_TU, 0x3 }, // 1178
  { PseudoVLUXEI64_V_M2_MF2_MASK, PseudoVLUXEI64_V_M2_MF2, PseudoVLUXEI64_V_M2_MF2_TU, 0x3 }, // 1179
  { PseudoVLUXEI64_V_M2_MF4_MASK, PseudoVLUXEI64_V_M2_MF4, PseudoVLUXEI64_V_M2_MF4_TU, 0x3 }, // 1180
  { PseudoVLUXEI64_V_M4_M1_MASK, PseudoVLUXEI64_V_M4_M1, PseudoVLUXEI64_V_M4_M1_TU, 0x3 }, // 1181
  { PseudoVLUXEI64_V_M4_M2_MASK, PseudoVLUXEI64_V_M4_M2, PseudoVLUXEI64_V_M4_M2_TU, 0x3 }, // 1182
  { PseudoVLUXEI64_V_M4_M4_MASK, PseudoVLUXEI64_V_M4_M4, PseudoVLUXEI64_V_M4_M4_TU, 0x3 }, // 1183
  { PseudoVLUXEI64_V_M4_MF2_MASK, PseudoVLUXEI64_V_M4_MF2, PseudoVLUXEI64_V_M4_MF2_TU, 0x3 }, // 1184
  { PseudoVLUXEI64_V_M8_M1_MASK, PseudoVLUXEI64_V_M8_M1, PseudoVLUXEI64_V_M8_M1_TU, 0x3 }, // 1185
  { PseudoVLUXEI64_V_M8_M2_MASK, PseudoVLUXEI64_V_M8_M2, PseudoVLUXEI64_V_M8_M2_TU, 0x3 }, // 1186
  { PseudoVLUXEI64_V_M8_M4_MASK, PseudoVLUXEI64_V_M8_M4, PseudoVLUXEI64_V_M8_M4_TU, 0x3 }, // 1187
  { PseudoVLUXEI64_V_M8_M8_MASK, PseudoVLUXEI64_V_M8_M8, PseudoVLUXEI64_V_M8_M8_TU, 0x3 }, // 1188
  { PseudoVLUXEI8_V_M1_M1_MASK, PseudoVLUXEI8_V_M1_M1, PseudoVLUXEI8_V_M1_M1_TU, 0x3 }, // 1189
  { PseudoVLUXEI8_V_M1_M2_MASK, PseudoVLUXEI8_V_M1_M2, PseudoVLUXEI8_V_M1_M2_TU, 0x3 }, // 1190
  { PseudoVLUXEI8_V_M1_M4_MASK, PseudoVLUXEI8_V_M1_M4, PseudoVLUXEI8_V_M1_M4_TU, 0x3 }, // 1191
  { PseudoVLUXEI8_V_M1_M8_MASK, PseudoVLUXEI8_V_M1_M8, PseudoVLUXEI8_V_M1_M8_TU, 0x3 }, // 1192
  { PseudoVLUXEI8_V_M2_M2_MASK, PseudoVLUXEI8_V_M2_M2, PseudoVLUXEI8_V_M2_M2_TU, 0x3 }, // 1193
  { PseudoVLUXEI8_V_M2_M4_MASK, PseudoVLUXEI8_V_M2_M4, PseudoVLUXEI8_V_M2_M4_TU, 0x3 }, // 1194
  { PseudoVLUXEI8_V_M2_M8_MASK, PseudoVLUXEI8_V_M2_M8, PseudoVLUXEI8_V_M2_M8_TU, 0x3 }, // 1195
  { PseudoVLUXEI8_V_M4_M4_MASK, PseudoVLUXEI8_V_M4_M4, PseudoVLUXEI8_V_M4_M4_TU, 0x3 }, // 1196
  { PseudoVLUXEI8_V_M4_M8_MASK, PseudoVLUXEI8_V_M4_M8, PseudoVLUXEI8_V_M4_M8_TU, 0x3 }, // 1197
  { PseudoVLUXEI8_V_M8_M8_MASK, PseudoVLUXEI8_V_M8_M8, PseudoVLUXEI8_V_M8_M8_TU, 0x3 }, // 1198
  { PseudoVLUXEI8_V_MF2_M1_MASK, PseudoVLUXEI8_V_MF2_M1, PseudoVLUXEI8_V_MF2_M1_TU, 0x3 }, // 1199
  { PseudoVLUXEI8_V_MF2_M2_MASK, PseudoVLUXEI8_V_MF2_M2, PseudoVLUXEI8_V_MF2_M2_TU, 0x3 }, // 1200
  { PseudoVLUXEI8_V_MF2_M4_MASK, PseudoVLUXEI8_V_MF2_M4, PseudoVLUXEI8_V_MF2_M4_TU, 0x3 }, // 1201
  { PseudoVLUXEI8_V_MF2_MF2_MASK, PseudoVLUXEI8_V_MF2_MF2, PseudoVLUXEI8_V_MF2_MF2_TU, 0x3 }, // 1202
  { PseudoVLUXEI8_V_MF4_M1_MASK, PseudoVLUXEI8_V_MF4_M1, PseudoVLUXEI8_V_MF4_M1_TU, 0x3 }, // 1203
  { PseudoVLUXEI8_V_MF4_M2_MASK, PseudoVLUXEI8_V_MF4_M2, PseudoVLUXEI8_V_MF4_M2_TU, 0x3 }, // 1204
  { PseudoVLUXEI8_V_MF4_MF2_MASK, PseudoVLUXEI8_V_MF4_MF2, PseudoVLUXEI8_V_MF4_MF2_TU, 0x3 }, // 1205
  { PseudoVLUXEI8_V_MF4_MF4_MASK, PseudoVLUXEI8_V_MF4_MF4, PseudoVLUXEI8_V_MF4_MF4_TU, 0x3 }, // 1206
  { PseudoVLUXEI8_V_MF8_M1_MASK, PseudoVLUXEI8_V_MF8_M1, PseudoVLUXEI8_V_MF8_M1_TU, 0x3 }, // 1207
  { PseudoVLUXEI8_V_MF8_MF2_MASK, PseudoVLUXEI8_V_MF8_MF2, PseudoVLUXEI8_V_MF8_MF2_TU, 0x3 }, // 1208
  { PseudoVLUXEI8_V_MF8_MF4_MASK, PseudoVLUXEI8_V_MF8_MF4, PseudoVLUXEI8_V_MF8_MF4_TU, 0x3 }, // 1209
  { PseudoVLUXEI8_V_MF8_MF8_MASK, PseudoVLUXEI8_V_MF8_MF8, PseudoVLUXEI8_V_MF8_MF8_TU, 0x3 }, // 1210
  { PseudoVMACC_VV_M1_MASK, PseudoVMACC_VV_M1, PseudoVMACC_VV_M1, 0x3 }, // 1211
  { PseudoVMACC_VV_M2_MASK, PseudoVMACC_VV_M2, PseudoVMACC_VV_M2, 0x3 }, // 1212
  { PseudoVMACC_VV_M4_MASK, PseudoVMACC_VV_M4, PseudoVMACC_VV_M4, 0x3 }, // 1213
  { PseudoVMACC_VV_M8_MASK, PseudoVMACC_VV_M8, PseudoVMACC_VV_M8, 0x3 }, // 1214
  { PseudoVMACC_VV_MF2_MASK, PseudoVMACC_VV_MF2, PseudoVMACC_VV_MF2, 0x3 }, // 1215
  { PseudoVMACC_VV_MF4_MASK, PseudoVMACC_VV_MF4, PseudoVMACC_VV_MF4, 0x3 }, // 1216
  { PseudoVMACC_VV_MF8_MASK, PseudoVMACC_VV_MF8, PseudoVMACC_VV_MF8, 0x3 }, // 1217
  { PseudoVMACC_VX_M1_MASK, PseudoVMACC_VX_M1, PseudoVMACC_VX_M1, 0x3 }, // 1218
  { PseudoVMACC_VX_M2_MASK, PseudoVMACC_VX_M2, PseudoVMACC_VX_M2, 0x3 }, // 1219
  { PseudoVMACC_VX_M4_MASK, PseudoVMACC_VX_M4, PseudoVMACC_VX_M4, 0x3 }, // 1220
  { PseudoVMACC_VX_M8_MASK, PseudoVMACC_VX_M8, PseudoVMACC_VX_M8, 0x3 }, // 1221
  { PseudoVMACC_VX_MF2_MASK, PseudoVMACC_VX_MF2, PseudoVMACC_VX_MF2, 0x3 }, // 1222
  { PseudoVMACC_VX_MF4_MASK, PseudoVMACC_VX_MF4, PseudoVMACC_VX_MF4, 0x3 }, // 1223
  { PseudoVMACC_VX_MF8_MASK, PseudoVMACC_VX_MF8, PseudoVMACC_VX_MF8, 0x3 }, // 1224
  { PseudoVMADD_VV_M1_MASK, PseudoVMADD_VV_M1, PseudoVMADD_VV_M1, 0x3 }, // 1225
  { PseudoVMADD_VV_M2_MASK, PseudoVMADD_VV_M2, PseudoVMADD_VV_M2, 0x3 }, // 1226
  { PseudoVMADD_VV_M4_MASK, PseudoVMADD_VV_M4, PseudoVMADD_VV_M4, 0x3 }, // 1227
  { PseudoVMADD_VV_M8_MASK, PseudoVMADD_VV_M8, PseudoVMADD_VV_M8, 0x3 }, // 1228
  { PseudoVMADD_VV_MF2_MASK, PseudoVMADD_VV_MF2, PseudoVMADD_VV_MF2, 0x3 }, // 1229
  { PseudoVMADD_VV_MF4_MASK, PseudoVMADD_VV_MF4, PseudoVMADD_VV_MF4, 0x3 }, // 1230
  { PseudoVMADD_VV_MF8_MASK, PseudoVMADD_VV_MF8, PseudoVMADD_VV_MF8, 0x3 }, // 1231
  { PseudoVMADD_VX_M1_MASK, PseudoVMADD_VX_M1, PseudoVMADD_VX_M1, 0x3 }, // 1232
  { PseudoVMADD_VX_M2_MASK, PseudoVMADD_VX_M2, PseudoVMADD_VX_M2, 0x3 }, // 1233
  { PseudoVMADD_VX_M4_MASK, PseudoVMADD_VX_M4, PseudoVMADD_VX_M4, 0x3 }, // 1234
  { PseudoVMADD_VX_M8_MASK, PseudoVMADD_VX_M8, PseudoVMADD_VX_M8, 0x3 }, // 1235
  { PseudoVMADD_VX_MF2_MASK, PseudoVMADD_VX_MF2, PseudoVMADD_VX_MF2, 0x3 }, // 1236
  { PseudoVMADD_VX_MF4_MASK, PseudoVMADD_VX_MF4, PseudoVMADD_VX_MF4, 0x3 }, // 1237
  { PseudoVMADD_VX_MF8_MASK, PseudoVMADD_VX_MF8, PseudoVMADD_VX_MF8, 0x3 }, // 1238
  { PseudoVMAXU_VV_M1_MASK, PseudoVMAXU_VV_M1, PseudoVMAXU_VV_M1_TU, 0x3 }, // 1239
  { PseudoVMAXU_VV_M2_MASK, PseudoVMAXU_VV_M2, PseudoVMAXU_VV_M2_TU, 0x3 }, // 1240
  { PseudoVMAXU_VV_M4_MASK, PseudoVMAXU_VV_M4, PseudoVMAXU_VV_M4_TU, 0x3 }, // 1241
  { PseudoVMAXU_VV_M8_MASK, PseudoVMAXU_VV_M8, PseudoVMAXU_VV_M8_TU, 0x3 }, // 1242
  { PseudoVMAXU_VV_MF2_MASK, PseudoVMAXU_VV_MF2, PseudoVMAXU_VV_MF2_TU, 0x3 }, // 1243
  { PseudoVMAXU_VV_MF4_MASK, PseudoVMAXU_VV_MF4, PseudoVMAXU_VV_MF4_TU, 0x3 }, // 1244
  { PseudoVMAXU_VV_MF8_MASK, PseudoVMAXU_VV_MF8, PseudoVMAXU_VV_MF8_TU, 0x3 }, // 1245
  { PseudoVMAXU_VX_M1_MASK, PseudoVMAXU_VX_M1, PseudoVMAXU_VX_M1_TU, 0x3 }, // 1246
  { PseudoVMAXU_VX_M2_MASK, PseudoVMAXU_VX_M2, PseudoVMAXU_VX_M2_TU, 0x3 }, // 1247
  { PseudoVMAXU_VX_M4_MASK, PseudoVMAXU_VX_M4, PseudoVMAXU_VX_M4_TU, 0x3 }, // 1248
  { PseudoVMAXU_VX_M8_MASK, PseudoVMAXU_VX_M8, PseudoVMAXU_VX_M8_TU, 0x3 }, // 1249
  { PseudoVMAXU_VX_MF2_MASK, PseudoVMAXU_VX_MF2, PseudoVMAXU_VX_MF2_TU, 0x3 }, // 1250
  { PseudoVMAXU_VX_MF4_MASK, PseudoVMAXU_VX_MF4, PseudoVMAXU_VX_MF4_TU, 0x3 }, // 1251
  { PseudoVMAXU_VX_MF8_MASK, PseudoVMAXU_VX_MF8, PseudoVMAXU_VX_MF8_TU, 0x3 }, // 1252
  { PseudoVMAX_VV_M1_MASK, PseudoVMAX_VV_M1, PseudoVMAX_VV_M1_TU, 0x3 }, // 1253
  { PseudoVMAX_VV_M2_MASK, PseudoVMAX_VV_M2, PseudoVMAX_VV_M2_TU, 0x3 }, // 1254
  { PseudoVMAX_VV_M4_MASK, PseudoVMAX_VV_M4, PseudoVMAX_VV_M4_TU, 0x3 }, // 1255
  { PseudoVMAX_VV_M8_MASK, PseudoVMAX_VV_M8, PseudoVMAX_VV_M8_TU, 0x3 }, // 1256
  { PseudoVMAX_VV_MF2_MASK, PseudoVMAX_VV_MF2, PseudoVMAX_VV_MF2_TU, 0x3 }, // 1257
  { PseudoVMAX_VV_MF4_MASK, PseudoVMAX_VV_MF4, PseudoVMAX_VV_MF4_TU, 0x3 }, // 1258
  { PseudoVMAX_VV_MF8_MASK, PseudoVMAX_VV_MF8, PseudoVMAX_VV_MF8_TU, 0x3 }, // 1259
  { PseudoVMAX_VX_M1_MASK, PseudoVMAX_VX_M1, PseudoVMAX_VX_M1_TU, 0x3 }, // 1260
  { PseudoVMAX_VX_M2_MASK, PseudoVMAX_VX_M2, PseudoVMAX_VX_M2_TU, 0x3 }, // 1261
  { PseudoVMAX_VX_M4_MASK, PseudoVMAX_VX_M4, PseudoVMAX_VX_M4_TU, 0x3 }, // 1262
  { PseudoVMAX_VX_M8_MASK, PseudoVMAX_VX_M8, PseudoVMAX_VX_M8_TU, 0x3 }, // 1263
  { PseudoVMAX_VX_MF2_MASK, PseudoVMAX_VX_MF2, PseudoVMAX_VX_MF2_TU, 0x3 }, // 1264
  { PseudoVMAX_VX_MF4_MASK, PseudoVMAX_VX_MF4, PseudoVMAX_VX_MF4_TU, 0x3 }, // 1265
  { PseudoVMAX_VX_MF8_MASK, PseudoVMAX_VX_MF8, PseudoVMAX_VX_MF8_TU, 0x3 }, // 1266
  { PseudoVMFEQ_VF16_M1_MASK, PseudoVMFEQ_VF16_M1, PseudoVMFEQ_VF16_M1_MASK, 0x3 }, // 1267
  { PseudoVMFEQ_VF16_M2_MASK, PseudoVMFEQ_VF16_M2, PseudoVMFEQ_VF16_M2_MASK, 0x3 }, // 1268
  { PseudoVMFEQ_VF16_M4_MASK, PseudoVMFEQ_VF16_M4, PseudoVMFEQ_VF16_M4_MASK, 0x3 }, // 1269
  { PseudoVMFEQ_VF16_M8_MASK, PseudoVMFEQ_VF16_M8, PseudoVMFEQ_VF16_M8_MASK, 0x3 }, // 1270
  { PseudoVMFEQ_VF16_MF2_MASK, PseudoVMFEQ_VF16_MF2, PseudoVMFEQ_VF16_MF2_MASK, 0x3 }, // 1271
  { PseudoVMFEQ_VF16_MF4_MASK, PseudoVMFEQ_VF16_MF4, PseudoVMFEQ_VF16_MF4_MASK, 0x3 }, // 1272
  { PseudoVMFEQ_VF32_M1_MASK, PseudoVMFEQ_VF32_M1, PseudoVMFEQ_VF32_M1_MASK, 0x3 }, // 1273
  { PseudoVMFEQ_VF32_M2_MASK, PseudoVMFEQ_VF32_M2, PseudoVMFEQ_VF32_M2_MASK, 0x3 }, // 1274
  { PseudoVMFEQ_VF32_M4_MASK, PseudoVMFEQ_VF32_M4, PseudoVMFEQ_VF32_M4_MASK, 0x3 }, // 1275
  { PseudoVMFEQ_VF32_M8_MASK, PseudoVMFEQ_VF32_M8, PseudoVMFEQ_VF32_M8_MASK, 0x3 }, // 1276
  { PseudoVMFEQ_VF32_MF2_MASK, PseudoVMFEQ_VF32_MF2, PseudoVMFEQ_VF32_MF2_MASK, 0x3 }, // 1277
  { PseudoVMFEQ_VF64_M1_MASK, PseudoVMFEQ_VF64_M1, PseudoVMFEQ_VF64_M1_MASK, 0x3 }, // 1278
  { PseudoVMFEQ_VF64_M2_MASK, PseudoVMFEQ_VF64_M2, PseudoVMFEQ_VF64_M2_MASK, 0x3 }, // 1279
  { PseudoVMFEQ_VF64_M4_MASK, PseudoVMFEQ_VF64_M4, PseudoVMFEQ_VF64_M4_MASK, 0x3 }, // 1280
  { PseudoVMFEQ_VF64_M8_MASK, PseudoVMFEQ_VF64_M8, PseudoVMFEQ_VF64_M8_MASK, 0x3 }, // 1281
  { PseudoVMFEQ_VV_M1_MASK, PseudoVMFEQ_VV_M1, PseudoVMFEQ_VV_M1_MASK, 0x3 }, // 1282
  { PseudoVMFEQ_VV_M2_MASK, PseudoVMFEQ_VV_M2, PseudoVMFEQ_VV_M2_MASK, 0x3 }, // 1283
  { PseudoVMFEQ_VV_M4_MASK, PseudoVMFEQ_VV_M4, PseudoVMFEQ_VV_M4_MASK, 0x3 }, // 1284
  { PseudoVMFEQ_VV_M8_MASK, PseudoVMFEQ_VV_M8, PseudoVMFEQ_VV_M8_MASK, 0x3 }, // 1285
  { PseudoVMFEQ_VV_MF2_MASK, PseudoVMFEQ_VV_MF2, PseudoVMFEQ_VV_MF2_MASK, 0x3 }, // 1286
  { PseudoVMFEQ_VV_MF4_MASK, PseudoVMFEQ_VV_MF4, PseudoVMFEQ_VV_MF4_MASK, 0x3 }, // 1287
  { PseudoVMFGE_VF16_M1_MASK, PseudoVMFGE_VF16_M1, PseudoVMFGE_VF16_M1_MASK, 0x3 }, // 1288
  { PseudoVMFGE_VF16_M2_MASK, PseudoVMFGE_VF16_M2, PseudoVMFGE_VF16_M2_MASK, 0x3 }, // 1289
  { PseudoVMFGE_VF16_M4_MASK, PseudoVMFGE_VF16_M4, PseudoVMFGE_VF16_M4_MASK, 0x3 }, // 1290
  { PseudoVMFGE_VF16_M8_MASK, PseudoVMFGE_VF16_M8, PseudoVMFGE_VF16_M8_MASK, 0x3 }, // 1291
  { PseudoVMFGE_VF16_MF2_MASK, PseudoVMFGE_VF16_MF2, PseudoVMFGE_VF16_MF2_MASK, 0x3 }, // 1292
  { PseudoVMFGE_VF16_MF4_MASK, PseudoVMFGE_VF16_MF4, PseudoVMFGE_VF16_MF4_MASK, 0x3 }, // 1293
  { PseudoVMFGE_VF32_M1_MASK, PseudoVMFGE_VF32_M1, PseudoVMFGE_VF32_M1_MASK, 0x3 }, // 1294
  { PseudoVMFGE_VF32_M2_MASK, PseudoVMFGE_VF32_M2, PseudoVMFGE_VF32_M2_MASK, 0x3 }, // 1295
  { PseudoVMFGE_VF32_M4_MASK, PseudoVMFGE_VF32_M4, PseudoVMFGE_VF32_M4_MASK, 0x3 }, // 1296
  { PseudoVMFGE_VF32_M8_MASK, PseudoVMFGE_VF32_M8, PseudoVMFGE_VF32_M8_MASK, 0x3 }, // 1297
  { PseudoVMFGE_VF32_MF2_MASK, PseudoVMFGE_VF32_MF2, PseudoVMFGE_VF32_MF2_MASK, 0x3 }, // 1298
  { PseudoVMFGE_VF64_M1_MASK, PseudoVMFGE_VF64_M1, PseudoVMFGE_VF64_M1_MASK, 0x3 }, // 1299
  { PseudoVMFGE_VF64_M2_MASK, PseudoVMFGE_VF64_M2, PseudoVMFGE_VF64_M2_MASK, 0x3 }, // 1300
  { PseudoVMFGE_VF64_M4_MASK, PseudoVMFGE_VF64_M4, PseudoVMFGE_VF64_M4_MASK, 0x3 }, // 1301
  { PseudoVMFGE_VF64_M8_MASK, PseudoVMFGE_VF64_M8, PseudoVMFGE_VF64_M8_MASK, 0x3 }, // 1302
  { PseudoVMFGT_VF16_M1_MASK, PseudoVMFGT_VF16_M1, PseudoVMFGT_VF16_M1_MASK, 0x3 }, // 1303
  { PseudoVMFGT_VF16_M2_MASK, PseudoVMFGT_VF16_M2, PseudoVMFGT_VF16_M2_MASK, 0x3 }, // 1304
  { PseudoVMFGT_VF16_M4_MASK, PseudoVMFGT_VF16_M4, PseudoVMFGT_VF16_M4_MASK, 0x3 }, // 1305
  { PseudoVMFGT_VF16_M8_MASK, PseudoVMFGT_VF16_M8, PseudoVMFGT_VF16_M8_MASK, 0x3 }, // 1306
  { PseudoVMFGT_VF16_MF2_MASK, PseudoVMFGT_VF16_MF2, PseudoVMFGT_VF16_MF2_MASK, 0x3 }, // 1307
  { PseudoVMFGT_VF16_MF4_MASK, PseudoVMFGT_VF16_MF4, PseudoVMFGT_VF16_MF4_MASK, 0x3 }, // 1308
  { PseudoVMFGT_VF32_M1_MASK, PseudoVMFGT_VF32_M1, PseudoVMFGT_VF32_M1_MASK, 0x3 }, // 1309
  { PseudoVMFGT_VF32_M2_MASK, PseudoVMFGT_VF32_M2, PseudoVMFGT_VF32_M2_MASK, 0x3 }, // 1310
  { PseudoVMFGT_VF32_M4_MASK, PseudoVMFGT_VF32_M4, PseudoVMFGT_VF32_M4_MASK, 0x3 }, // 1311
  { PseudoVMFGT_VF32_M8_MASK, PseudoVMFGT_VF32_M8, PseudoVMFGT_VF32_M8_MASK, 0x3 }, // 1312
  { PseudoVMFGT_VF32_MF2_MASK, PseudoVMFGT_VF32_MF2, PseudoVMFGT_VF32_MF2_MASK, 0x3 }, // 1313
  { PseudoVMFGT_VF64_M1_MASK, PseudoVMFGT_VF64_M1, PseudoVMFGT_VF64_M1_MASK, 0x3 }, // 1314
  { PseudoVMFGT_VF64_M2_MASK, PseudoVMFGT_VF64_M2, PseudoVMFGT_VF64_M2_MASK, 0x3 }, // 1315
  { PseudoVMFGT_VF64_M4_MASK, PseudoVMFGT_VF64_M4, PseudoVMFGT_VF64_M4_MASK, 0x3 }, // 1316
  { PseudoVMFGT_VF64_M8_MASK, PseudoVMFGT_VF64_M8, PseudoVMFGT_VF64_M8_MASK, 0x3 }, // 1317
  { PseudoVMFLE_VF16_M1_MASK, PseudoVMFLE_VF16_M1, PseudoVMFLE_VF16_M1_MASK, 0x3 }, // 1318
  { PseudoVMFLE_VF16_M2_MASK, PseudoVMFLE_VF16_M2, PseudoVMFLE_VF16_M2_MASK, 0x3 }, // 1319
  { PseudoVMFLE_VF16_M4_MASK, PseudoVMFLE_VF16_M4, PseudoVMFLE_VF16_M4_MASK, 0x3 }, // 1320
  { PseudoVMFLE_VF16_M8_MASK, PseudoVMFLE_VF16_M8, PseudoVMFLE_VF16_M8_MASK, 0x3 }, // 1321
  { PseudoVMFLE_VF16_MF2_MASK, PseudoVMFLE_VF16_MF2, PseudoVMFLE_VF16_MF2_MASK, 0x3 }, // 1322
  { PseudoVMFLE_VF16_MF4_MASK, PseudoVMFLE_VF16_MF4, PseudoVMFLE_VF16_MF4_MASK, 0x3 }, // 1323
  { PseudoVMFLE_VF32_M1_MASK, PseudoVMFLE_VF32_M1, PseudoVMFLE_VF32_M1_MASK, 0x3 }, // 1324
  { PseudoVMFLE_VF32_M2_MASK, PseudoVMFLE_VF32_M2, PseudoVMFLE_VF32_M2_MASK, 0x3 }, // 1325
  { PseudoVMFLE_VF32_M4_MASK, PseudoVMFLE_VF32_M4, PseudoVMFLE_VF32_M4_MASK, 0x3 }, // 1326
  { PseudoVMFLE_VF32_M8_MASK, PseudoVMFLE_VF32_M8, PseudoVMFLE_VF32_M8_MASK, 0x3 }, // 1327
  { PseudoVMFLE_VF32_MF2_MASK, PseudoVMFLE_VF32_MF2, PseudoVMFLE_VF32_MF2_MASK, 0x3 }, // 1328
  { PseudoVMFLE_VF64_M1_MASK, PseudoVMFLE_VF64_M1, PseudoVMFLE_VF64_M1_MASK, 0x3 }, // 1329
  { PseudoVMFLE_VF64_M2_MASK, PseudoVMFLE_VF64_M2, PseudoVMFLE_VF64_M2_MASK, 0x3 }, // 1330
  { PseudoVMFLE_VF64_M4_MASK, PseudoVMFLE_VF64_M4, PseudoVMFLE_VF64_M4_MASK, 0x3 }, // 1331
  { PseudoVMFLE_VF64_M8_MASK, PseudoVMFLE_VF64_M8, PseudoVMFLE_VF64_M8_MASK, 0x3 }, // 1332
  { PseudoVMFLE_VV_M1_MASK, PseudoVMFLE_VV_M1, PseudoVMFLE_VV_M1_MASK, 0x3 }, // 1333
  { PseudoVMFLE_VV_M2_MASK, PseudoVMFLE_VV_M2, PseudoVMFLE_VV_M2_MASK, 0x3 }, // 1334
  { PseudoVMFLE_VV_M4_MASK, PseudoVMFLE_VV_M4, PseudoVMFLE_VV_M4_MASK, 0x3 }, // 1335
  { PseudoVMFLE_VV_M8_MASK, PseudoVMFLE_VV_M8, PseudoVMFLE_VV_M8_MASK, 0x3 }, // 1336
  { PseudoVMFLE_VV_MF2_MASK, PseudoVMFLE_VV_MF2, PseudoVMFLE_VV_MF2_MASK, 0x3 }, // 1337
  { PseudoVMFLE_VV_MF4_MASK, PseudoVMFLE_VV_MF4, PseudoVMFLE_VV_MF4_MASK, 0x3 }, // 1338
  { PseudoVMFLT_VF16_M1_MASK, PseudoVMFLT_VF16_M1, PseudoVMFLT_VF16_M1_MASK, 0x3 }, // 1339
  { PseudoVMFLT_VF16_M2_MASK, PseudoVMFLT_VF16_M2, PseudoVMFLT_VF16_M2_MASK, 0x3 }, // 1340
  { PseudoVMFLT_VF16_M4_MASK, PseudoVMFLT_VF16_M4, PseudoVMFLT_VF16_M4_MASK, 0x3 }, // 1341
  { PseudoVMFLT_VF16_M8_MASK, PseudoVMFLT_VF16_M8, PseudoVMFLT_VF16_M8_MASK, 0x3 }, // 1342
  { PseudoVMFLT_VF16_MF2_MASK, PseudoVMFLT_VF16_MF2, PseudoVMFLT_VF16_MF2_MASK, 0x3 }, // 1343
  { PseudoVMFLT_VF16_MF4_MASK, PseudoVMFLT_VF16_MF4, PseudoVMFLT_VF16_MF4_MASK, 0x3 }, // 1344
  { PseudoVMFLT_VF32_M1_MASK, PseudoVMFLT_VF32_M1, PseudoVMFLT_VF32_M1_MASK, 0x3 }, // 1345
  { PseudoVMFLT_VF32_M2_MASK, PseudoVMFLT_VF32_M2, PseudoVMFLT_VF32_M2_MASK, 0x3 }, // 1346
  { PseudoVMFLT_VF32_M4_MASK, PseudoVMFLT_VF32_M4, PseudoVMFLT_VF32_M4_MASK, 0x3 }, // 1347
  { PseudoVMFLT_VF32_M8_MASK, PseudoVMFLT_VF32_M8, PseudoVMFLT_VF32_M8_MASK, 0x3 }, // 1348
  { PseudoVMFLT_VF32_MF2_MASK, PseudoVMFLT_VF32_MF2, PseudoVMFLT_VF32_MF2_MASK, 0x3 }, // 1349
  { PseudoVMFLT_VF64_M1_MASK, PseudoVMFLT_VF64_M1, PseudoVMFLT_VF64_M1_MASK, 0x3 }, // 1350
  { PseudoVMFLT_VF64_M2_MASK, PseudoVMFLT_VF64_M2, PseudoVMFLT_VF64_M2_MASK, 0x3 }, // 1351
  { PseudoVMFLT_VF64_M4_MASK, PseudoVMFLT_VF64_M4, PseudoVMFLT_VF64_M4_MASK, 0x3 }, // 1352
  { PseudoVMFLT_VF64_M8_MASK, PseudoVMFLT_VF64_M8, PseudoVMFLT_VF64_M8_MASK, 0x3 }, // 1353
  { PseudoVMFLT_VV_M1_MASK, PseudoVMFLT_VV_M1, PseudoVMFLT_VV_M1_MASK, 0x3 }, // 1354
  { PseudoVMFLT_VV_M2_MASK, PseudoVMFLT_VV_M2, PseudoVMFLT_VV_M2_MASK, 0x3 }, // 1355
  { PseudoVMFLT_VV_M4_MASK, PseudoVMFLT_VV_M4, PseudoVMFLT_VV_M4_MASK, 0x3 }, // 1356
  { PseudoVMFLT_VV_M8_MASK, PseudoVMFLT_VV_M8, PseudoVMFLT_VV_M8_MASK, 0x3 }, // 1357
  { PseudoVMFLT_VV_MF2_MASK, PseudoVMFLT_VV_MF2, PseudoVMFLT_VV_MF2_MASK, 0x3 }, // 1358
  { PseudoVMFLT_VV_MF4_MASK, PseudoVMFLT_VV_MF4, PseudoVMFLT_VV_MF4_MASK, 0x3 }, // 1359
  { PseudoVMFNE_VF16_M1_MASK, PseudoVMFNE_VF16_M1, PseudoVMFNE_VF16_M1_MASK, 0x3 }, // 1360
  { PseudoVMFNE_VF16_M2_MASK, PseudoVMFNE_VF16_M2, PseudoVMFNE_VF16_M2_MASK, 0x3 }, // 1361
  { PseudoVMFNE_VF16_M4_MASK, PseudoVMFNE_VF16_M4, PseudoVMFNE_VF16_M4_MASK, 0x3 }, // 1362
  { PseudoVMFNE_VF16_M8_MASK, PseudoVMFNE_VF16_M8, PseudoVMFNE_VF16_M8_MASK, 0x3 }, // 1363
  { PseudoVMFNE_VF16_MF2_MASK, PseudoVMFNE_VF16_MF2, PseudoVMFNE_VF16_MF2_MASK, 0x3 }, // 1364
  { PseudoVMFNE_VF16_MF4_MASK, PseudoVMFNE_VF16_MF4, PseudoVMFNE_VF16_MF4_MASK, 0x3 }, // 1365
  { PseudoVMFNE_VF32_M1_MASK, PseudoVMFNE_VF32_M1, PseudoVMFNE_VF32_M1_MASK, 0x3 }, // 1366
  { PseudoVMFNE_VF32_M2_MASK, PseudoVMFNE_VF32_M2, PseudoVMFNE_VF32_M2_MASK, 0x3 }, // 1367
  { PseudoVMFNE_VF32_M4_MASK, PseudoVMFNE_VF32_M4, PseudoVMFNE_VF32_M4_MASK, 0x3 }, // 1368
  { PseudoVMFNE_VF32_M8_MASK, PseudoVMFNE_VF32_M8, PseudoVMFNE_VF32_M8_MASK, 0x3 }, // 1369
  { PseudoVMFNE_VF32_MF2_MASK, PseudoVMFNE_VF32_MF2, PseudoVMFNE_VF32_MF2_MASK, 0x3 }, // 1370
  { PseudoVMFNE_VF64_M1_MASK, PseudoVMFNE_VF64_M1, PseudoVMFNE_VF64_M1_MASK, 0x3 }, // 1371
  { PseudoVMFNE_VF64_M2_MASK, PseudoVMFNE_VF64_M2, PseudoVMFNE_VF64_M2_MASK, 0x3 }, // 1372
  { PseudoVMFNE_VF64_M4_MASK, PseudoVMFNE_VF64_M4, PseudoVMFNE_VF64_M4_MASK, 0x3 }, // 1373
  { PseudoVMFNE_VF64_M8_MASK, PseudoVMFNE_VF64_M8, PseudoVMFNE_VF64_M8_MASK, 0x3 }, // 1374
  { PseudoVMFNE_VV_M1_MASK, PseudoVMFNE_VV_M1, PseudoVMFNE_VV_M1_MASK, 0x3 }, // 1375
  { PseudoVMFNE_VV_M2_MASK, PseudoVMFNE_VV_M2, PseudoVMFNE_VV_M2_MASK, 0x3 }, // 1376
  { PseudoVMFNE_VV_M4_MASK, PseudoVMFNE_VV_M4, PseudoVMFNE_VV_M4_MASK, 0x3 }, // 1377
  { PseudoVMFNE_VV_M8_MASK, PseudoVMFNE_VV_M8, PseudoVMFNE_VV_M8_MASK, 0x3 }, // 1378
  { PseudoVMFNE_VV_MF2_MASK, PseudoVMFNE_VV_MF2, PseudoVMFNE_VV_MF2_MASK, 0x3 }, // 1379
  { PseudoVMFNE_VV_MF4_MASK, PseudoVMFNE_VV_MF4, PseudoVMFNE_VV_MF4_MASK, 0x3 }, // 1380
  { PseudoVMINU_VV_M1_MASK, PseudoVMINU_VV_M1, PseudoVMINU_VV_M1_TU, 0x3 }, // 1381
  { PseudoVMINU_VV_M2_MASK, PseudoVMINU_VV_M2, PseudoVMINU_VV_M2_TU, 0x3 }, // 1382
  { PseudoVMINU_VV_M4_MASK, PseudoVMINU_VV_M4, PseudoVMINU_VV_M4_TU, 0x3 }, // 1383
  { PseudoVMINU_VV_M8_MASK, PseudoVMINU_VV_M8, PseudoVMINU_VV_M8_TU, 0x3 }, // 1384
  { PseudoVMINU_VV_MF2_MASK, PseudoVMINU_VV_MF2, PseudoVMINU_VV_MF2_TU, 0x3 }, // 1385
  { PseudoVMINU_VV_MF4_MASK, PseudoVMINU_VV_MF4, PseudoVMINU_VV_MF4_TU, 0x3 }, // 1386
  { PseudoVMINU_VV_MF8_MASK, PseudoVMINU_VV_MF8, PseudoVMINU_VV_MF8_TU, 0x3 }, // 1387
  { PseudoVMINU_VX_M1_MASK, PseudoVMINU_VX_M1, PseudoVMINU_VX_M1_TU, 0x3 }, // 1388
  { PseudoVMINU_VX_M2_MASK, PseudoVMINU_VX_M2, PseudoVMINU_VX_M2_TU, 0x3 }, // 1389
  { PseudoVMINU_VX_M4_MASK, PseudoVMINU_VX_M4, PseudoVMINU_VX_M4_TU, 0x3 }, // 1390
  { PseudoVMINU_VX_M8_MASK, PseudoVMINU_VX_M8, PseudoVMINU_VX_M8_TU, 0x3 }, // 1391
  { PseudoVMINU_VX_MF2_MASK, PseudoVMINU_VX_MF2, PseudoVMINU_VX_MF2_TU, 0x3 }, // 1392
  { PseudoVMINU_VX_MF4_MASK, PseudoVMINU_VX_MF4, PseudoVMINU_VX_MF4_TU, 0x3 }, // 1393
  { PseudoVMINU_VX_MF8_MASK, PseudoVMINU_VX_MF8, PseudoVMINU_VX_MF8_TU, 0x3 }, // 1394
  { PseudoVMIN_VV_M1_MASK, PseudoVMIN_VV_M1, PseudoVMIN_VV_M1_TU, 0x3 }, // 1395
  { PseudoVMIN_VV_M2_MASK, PseudoVMIN_VV_M2, PseudoVMIN_VV_M2_TU, 0x3 }, // 1396
  { PseudoVMIN_VV_M4_MASK, PseudoVMIN_VV_M4, PseudoVMIN_VV_M4_TU, 0x3 }, // 1397
  { PseudoVMIN_VV_M8_MASK, PseudoVMIN_VV_M8, PseudoVMIN_VV_M8_TU, 0x3 }, // 1398
  { PseudoVMIN_VV_MF2_MASK, PseudoVMIN_VV_MF2, PseudoVMIN_VV_MF2_TU, 0x3 }, // 1399
  { PseudoVMIN_VV_MF4_MASK, PseudoVMIN_VV_MF4, PseudoVMIN_VV_MF4_TU, 0x3 }, // 1400
  { PseudoVMIN_VV_MF8_MASK, PseudoVMIN_VV_MF8, PseudoVMIN_VV_MF8_TU, 0x3 }, // 1401
  { PseudoVMIN_VX_M1_MASK, PseudoVMIN_VX_M1, PseudoVMIN_VX_M1_TU, 0x3 }, // 1402
  { PseudoVMIN_VX_M2_MASK, PseudoVMIN_VX_M2, PseudoVMIN_VX_M2_TU, 0x3 }, // 1403
  { PseudoVMIN_VX_M4_MASK, PseudoVMIN_VX_M4, PseudoVMIN_VX_M4_TU, 0x3 }, // 1404
  { PseudoVMIN_VX_M8_MASK, PseudoVMIN_VX_M8, PseudoVMIN_VX_M8_TU, 0x3 }, // 1405
  { PseudoVMIN_VX_MF2_MASK, PseudoVMIN_VX_MF2, PseudoVMIN_VX_MF2_TU, 0x3 }, // 1406
  { PseudoVMIN_VX_MF4_MASK, PseudoVMIN_VX_MF4, PseudoVMIN_VX_MF4_TU, 0x3 }, // 1407
  { PseudoVMIN_VX_MF8_MASK, PseudoVMIN_VX_MF8, PseudoVMIN_VX_MF8_TU, 0x3 }, // 1408
  { PseudoVMSEQ_VI_M1_MASK, PseudoVMSEQ_VI_M1, PseudoVMSEQ_VI_M1_MASK, 0x3 }, // 1409
  { PseudoVMSEQ_VI_M2_MASK, PseudoVMSEQ_VI_M2, PseudoVMSEQ_VI_M2_MASK, 0x3 }, // 1410
  { PseudoVMSEQ_VI_M4_MASK, PseudoVMSEQ_VI_M4, PseudoVMSEQ_VI_M4_MASK, 0x3 }, // 1411
  { PseudoVMSEQ_VI_M8_MASK, PseudoVMSEQ_VI_M8, PseudoVMSEQ_VI_M8_MASK, 0x3 }, // 1412
  { PseudoVMSEQ_VI_MF2_MASK, PseudoVMSEQ_VI_MF2, PseudoVMSEQ_VI_MF2_MASK, 0x3 }, // 1413
  { PseudoVMSEQ_VI_MF4_MASK, PseudoVMSEQ_VI_MF4, PseudoVMSEQ_VI_MF4_MASK, 0x3 }, // 1414
  { PseudoVMSEQ_VI_MF8_MASK, PseudoVMSEQ_VI_MF8, PseudoVMSEQ_VI_MF8_MASK, 0x3 }, // 1415
  { PseudoVMSEQ_VV_M1_MASK, PseudoVMSEQ_VV_M1, PseudoVMSEQ_VV_M1_MASK, 0x3 }, // 1416
  { PseudoVMSEQ_VV_M2_MASK, PseudoVMSEQ_VV_M2, PseudoVMSEQ_VV_M2_MASK, 0x3 }, // 1417
  { PseudoVMSEQ_VV_M4_MASK, PseudoVMSEQ_VV_M4, PseudoVMSEQ_VV_M4_MASK, 0x3 }, // 1418
  { PseudoVMSEQ_VV_M8_MASK, PseudoVMSEQ_VV_M8, PseudoVMSEQ_VV_M8_MASK, 0x3 }, // 1419
  { PseudoVMSEQ_VV_MF2_MASK, PseudoVMSEQ_VV_MF2, PseudoVMSEQ_VV_MF2_MASK, 0x3 }, // 1420
  { PseudoVMSEQ_VV_MF4_MASK, PseudoVMSEQ_VV_MF4, PseudoVMSEQ_VV_MF4_MASK, 0x3 }, // 1421
  { PseudoVMSEQ_VV_MF8_MASK, PseudoVMSEQ_VV_MF8, PseudoVMSEQ_VV_MF8_MASK, 0x3 }, // 1422
  { PseudoVMSEQ_VX_M1_MASK, PseudoVMSEQ_VX_M1, PseudoVMSEQ_VX_M1_MASK, 0x3 }, // 1423
  { PseudoVMSEQ_VX_M2_MASK, PseudoVMSEQ_VX_M2, PseudoVMSEQ_VX_M2_MASK, 0x3 }, // 1424
  { PseudoVMSEQ_VX_M4_MASK, PseudoVMSEQ_VX_M4, PseudoVMSEQ_VX_M4_MASK, 0x3 }, // 1425
  { PseudoVMSEQ_VX_M8_MASK, PseudoVMSEQ_VX_M8, PseudoVMSEQ_VX_M8_MASK, 0x3 }, // 1426
  { PseudoVMSEQ_VX_MF2_MASK, PseudoVMSEQ_VX_MF2, PseudoVMSEQ_VX_MF2_MASK, 0x3 }, // 1427
  { PseudoVMSEQ_VX_MF4_MASK, PseudoVMSEQ_VX_MF4, PseudoVMSEQ_VX_MF4_MASK, 0x3 }, // 1428
  { PseudoVMSEQ_VX_MF8_MASK, PseudoVMSEQ_VX_MF8, PseudoVMSEQ_VX_MF8_MASK, 0x3 }, // 1429
  { PseudoVMSGTU_VI_M1_MASK, PseudoVMSGTU_VI_M1, PseudoVMSGTU_VI_M1_MASK, 0x3 }, // 1430
  { PseudoVMSGTU_VI_M2_MASK, PseudoVMSGTU_VI_M2, PseudoVMSGTU_VI_M2_MASK, 0x3 }, // 1431
  { PseudoVMSGTU_VI_M4_MASK, PseudoVMSGTU_VI_M4, PseudoVMSGTU_VI_M4_MASK, 0x3 }, // 1432
  { PseudoVMSGTU_VI_M8_MASK, PseudoVMSGTU_VI_M8, PseudoVMSGTU_VI_M8_MASK, 0x3 }, // 1433
  { PseudoVMSGTU_VI_MF2_MASK, PseudoVMSGTU_VI_MF2, PseudoVMSGTU_VI_MF2_MASK, 0x3 }, // 1434
  { PseudoVMSGTU_VI_MF4_MASK, PseudoVMSGTU_VI_MF4, PseudoVMSGTU_VI_MF4_MASK, 0x3 }, // 1435
  { PseudoVMSGTU_VI_MF8_MASK, PseudoVMSGTU_VI_MF8, PseudoVMSGTU_VI_MF8_MASK, 0x3 }, // 1436
  { PseudoVMSGTU_VX_M1_MASK, PseudoVMSGTU_VX_M1, PseudoVMSGTU_VX_M1_MASK, 0x3 }, // 1437
  { PseudoVMSGTU_VX_M2_MASK, PseudoVMSGTU_VX_M2, PseudoVMSGTU_VX_M2_MASK, 0x3 }, // 1438
  { PseudoVMSGTU_VX_M4_MASK, PseudoVMSGTU_VX_M4, PseudoVMSGTU_VX_M4_MASK, 0x3 }, // 1439
  { PseudoVMSGTU_VX_M8_MASK, PseudoVMSGTU_VX_M8, PseudoVMSGTU_VX_M8_MASK, 0x3 }, // 1440
  { PseudoVMSGTU_VX_MF2_MASK, PseudoVMSGTU_VX_MF2, PseudoVMSGTU_VX_MF2_MASK, 0x3 }, // 1441
  { PseudoVMSGTU_VX_MF4_MASK, PseudoVMSGTU_VX_MF4, PseudoVMSGTU_VX_MF4_MASK, 0x3 }, // 1442
  { PseudoVMSGTU_VX_MF8_MASK, PseudoVMSGTU_VX_MF8, PseudoVMSGTU_VX_MF8_MASK, 0x3 }, // 1443
  { PseudoVMSGT_VI_M1_MASK, PseudoVMSGT_VI_M1, PseudoVMSGT_VI_M1_MASK, 0x3 }, // 1444
  { PseudoVMSGT_VI_M2_MASK, PseudoVMSGT_VI_M2, PseudoVMSGT_VI_M2_MASK, 0x3 }, // 1445
  { PseudoVMSGT_VI_M4_MASK, PseudoVMSGT_VI_M4, PseudoVMSGT_VI_M4_MASK, 0x3 }, // 1446
  { PseudoVMSGT_VI_M8_MASK, PseudoVMSGT_VI_M8, PseudoVMSGT_VI_M8_MASK, 0x3 }, // 1447
  { PseudoVMSGT_VI_MF2_MASK, PseudoVMSGT_VI_MF2, PseudoVMSGT_VI_MF2_MASK, 0x3 }, // 1448
  { PseudoVMSGT_VI_MF4_MASK, PseudoVMSGT_VI_MF4, PseudoVMSGT_VI_MF4_MASK, 0x3 }, // 1449
  { PseudoVMSGT_VI_MF8_MASK, PseudoVMSGT_VI_MF8, PseudoVMSGT_VI_MF8_MASK, 0x3 }, // 1450
  { PseudoVMSGT_VX_M1_MASK, PseudoVMSGT_VX_M1, PseudoVMSGT_VX_M1_MASK, 0x3 }, // 1451
  { PseudoVMSGT_VX_M2_MASK, PseudoVMSGT_VX_M2, PseudoVMSGT_VX_M2_MASK, 0x3 }, // 1452
  { PseudoVMSGT_VX_M4_MASK, PseudoVMSGT_VX_M4, PseudoVMSGT_VX_M4_MASK, 0x3 }, // 1453
  { PseudoVMSGT_VX_M8_MASK, PseudoVMSGT_VX_M8, PseudoVMSGT_VX_M8_MASK, 0x3 }, // 1454
  { PseudoVMSGT_VX_MF2_MASK, PseudoVMSGT_VX_MF2, PseudoVMSGT_VX_MF2_MASK, 0x3 }, // 1455
  { PseudoVMSGT_VX_MF4_MASK, PseudoVMSGT_VX_MF4, PseudoVMSGT_VX_MF4_MASK, 0x3 }, // 1456
  { PseudoVMSGT_VX_MF8_MASK, PseudoVMSGT_VX_MF8, PseudoVMSGT_VX_MF8_MASK, 0x3 }, // 1457
  { PseudoVMSLEU_VI_M1_MASK, PseudoVMSLEU_VI_M1, PseudoVMSLEU_VI_M1_MASK, 0x3 }, // 1458
  { PseudoVMSLEU_VI_M2_MASK, PseudoVMSLEU_VI_M2, PseudoVMSLEU_VI_M2_MASK, 0x3 }, // 1459
  { PseudoVMSLEU_VI_M4_MASK, PseudoVMSLEU_VI_M4, PseudoVMSLEU_VI_M4_MASK, 0x3 }, // 1460
  { PseudoVMSLEU_VI_M8_MASK, PseudoVMSLEU_VI_M8, PseudoVMSLEU_VI_M8_MASK, 0x3 }, // 1461
  { PseudoVMSLEU_VI_MF2_MASK, PseudoVMSLEU_VI_MF2, PseudoVMSLEU_VI_MF2_MASK, 0x3 }, // 1462
  { PseudoVMSLEU_VI_MF4_MASK, PseudoVMSLEU_VI_MF4, PseudoVMSLEU_VI_MF4_MASK, 0x3 }, // 1463
  { PseudoVMSLEU_VI_MF8_MASK, PseudoVMSLEU_VI_MF8, PseudoVMSLEU_VI_MF8_MASK, 0x3 }, // 1464
  { PseudoVMSLEU_VV_M1_MASK, PseudoVMSLEU_VV_M1, PseudoVMSLEU_VV_M1_MASK, 0x3 }, // 1465
  { PseudoVMSLEU_VV_M2_MASK, PseudoVMSLEU_VV_M2, PseudoVMSLEU_VV_M2_MASK, 0x3 }, // 1466
  { PseudoVMSLEU_VV_M4_MASK, PseudoVMSLEU_VV_M4, PseudoVMSLEU_VV_M4_MASK, 0x3 }, // 1467
  { PseudoVMSLEU_VV_M8_MASK, PseudoVMSLEU_VV_M8, PseudoVMSLEU_VV_M8_MASK, 0x3 }, // 1468
  { PseudoVMSLEU_VV_MF2_MASK, PseudoVMSLEU_VV_MF2, PseudoVMSLEU_VV_MF2_MASK, 0x3 }, // 1469
  { PseudoVMSLEU_VV_MF4_MASK, PseudoVMSLEU_VV_MF4, PseudoVMSLEU_VV_MF4_MASK, 0x3 }, // 1470
  { PseudoVMSLEU_VV_MF8_MASK, PseudoVMSLEU_VV_MF8, PseudoVMSLEU_VV_MF8_MASK, 0x3 }, // 1471
  { PseudoVMSLEU_VX_M1_MASK, PseudoVMSLEU_VX_M1, PseudoVMSLEU_VX_M1_MASK, 0x3 }, // 1472
  { PseudoVMSLEU_VX_M2_MASK, PseudoVMSLEU_VX_M2, PseudoVMSLEU_VX_M2_MASK, 0x3 }, // 1473
  { PseudoVMSLEU_VX_M4_MASK, PseudoVMSLEU_VX_M4, PseudoVMSLEU_VX_M4_MASK, 0x3 }, // 1474
  { PseudoVMSLEU_VX_M8_MASK, PseudoVMSLEU_VX_M8, PseudoVMSLEU_VX_M8_MASK, 0x3 }, // 1475
  { PseudoVMSLEU_VX_MF2_MASK, PseudoVMSLEU_VX_MF2, PseudoVMSLEU_VX_MF2_MASK, 0x3 }, // 1476
  { PseudoVMSLEU_VX_MF4_MASK, PseudoVMSLEU_VX_MF4, PseudoVMSLEU_VX_MF4_MASK, 0x3 }, // 1477
  { PseudoVMSLEU_VX_MF8_MASK, PseudoVMSLEU_VX_MF8, PseudoVMSLEU_VX_MF8_MASK, 0x3 }, // 1478
  { PseudoVMSLE_VI_M1_MASK, PseudoVMSLE_VI_M1, PseudoVMSLE_VI_M1_MASK, 0x3 }, // 1479
  { PseudoVMSLE_VI_M2_MASK, PseudoVMSLE_VI_M2, PseudoVMSLE_VI_M2_MASK, 0x3 }, // 1480
  { PseudoVMSLE_VI_M4_MASK, PseudoVMSLE_VI_M4, PseudoVMSLE_VI_M4_MASK, 0x3 }, // 1481
  { PseudoVMSLE_VI_M8_MASK, PseudoVMSLE_VI_M8, PseudoVMSLE_VI_M8_MASK, 0x3 }, // 1482
  { PseudoVMSLE_VI_MF2_MASK, PseudoVMSLE_VI_MF2, PseudoVMSLE_VI_MF2_MASK, 0x3 }, // 1483
  { PseudoVMSLE_VI_MF4_MASK, PseudoVMSLE_VI_MF4, PseudoVMSLE_VI_MF4_MASK, 0x3 }, // 1484
  { PseudoVMSLE_VI_MF8_MASK, PseudoVMSLE_VI_MF8, PseudoVMSLE_VI_MF8_MASK, 0x3 }, // 1485
  { PseudoVMSLE_VV_M1_MASK, PseudoVMSLE_VV_M1, PseudoVMSLE_VV_M1_MASK, 0x3 }, // 1486
  { PseudoVMSLE_VV_M2_MASK, PseudoVMSLE_VV_M2, PseudoVMSLE_VV_M2_MASK, 0x3 }, // 1487
  { PseudoVMSLE_VV_M4_MASK, PseudoVMSLE_VV_M4, PseudoVMSLE_VV_M4_MASK, 0x3 }, // 1488
  { PseudoVMSLE_VV_M8_MASK, PseudoVMSLE_VV_M8, PseudoVMSLE_VV_M8_MASK, 0x3 }, // 1489
  { PseudoVMSLE_VV_MF2_MASK, PseudoVMSLE_VV_MF2, PseudoVMSLE_VV_MF2_MASK, 0x3 }, // 1490
  { PseudoVMSLE_VV_MF4_MASK, PseudoVMSLE_VV_MF4, PseudoVMSLE_VV_MF4_MASK, 0x3 }, // 1491
  { PseudoVMSLE_VV_MF8_MASK, PseudoVMSLE_VV_MF8, PseudoVMSLE_VV_MF8_MASK, 0x3 }, // 1492
  { PseudoVMSLE_VX_M1_MASK, PseudoVMSLE_VX_M1, PseudoVMSLE_VX_M1_MASK, 0x3 }, // 1493
  { PseudoVMSLE_VX_M2_MASK, PseudoVMSLE_VX_M2, PseudoVMSLE_VX_M2_MASK, 0x3 }, // 1494
  { PseudoVMSLE_VX_M4_MASK, PseudoVMSLE_VX_M4, PseudoVMSLE_VX_M4_MASK, 0x3 }, // 1495
  { PseudoVMSLE_VX_M8_MASK, PseudoVMSLE_VX_M8, PseudoVMSLE_VX_M8_MASK, 0x3 }, // 1496
  { PseudoVMSLE_VX_MF2_MASK, PseudoVMSLE_VX_MF2, PseudoVMSLE_VX_MF2_MASK, 0x3 }, // 1497
  { PseudoVMSLE_VX_MF4_MASK, PseudoVMSLE_VX_MF4, PseudoVMSLE_VX_MF4_MASK, 0x3 }, // 1498
  { PseudoVMSLE_VX_MF8_MASK, PseudoVMSLE_VX_MF8, PseudoVMSLE_VX_MF8_MASK, 0x3 }, // 1499
  { PseudoVMSLTU_VV_M1_MASK, PseudoVMSLTU_VV_M1, PseudoVMSLTU_VV_M1_MASK, 0x3 }, // 1500
  { PseudoVMSLTU_VV_M2_MASK, PseudoVMSLTU_VV_M2, PseudoVMSLTU_VV_M2_MASK, 0x3 }, // 1501
  { PseudoVMSLTU_VV_M4_MASK, PseudoVMSLTU_VV_M4, PseudoVMSLTU_VV_M4_MASK, 0x3 }, // 1502
  { PseudoVMSLTU_VV_M8_MASK, PseudoVMSLTU_VV_M8, PseudoVMSLTU_VV_M8_MASK, 0x3 }, // 1503
  { PseudoVMSLTU_VV_MF2_MASK, PseudoVMSLTU_VV_MF2, PseudoVMSLTU_VV_MF2_MASK, 0x3 }, // 1504
  { PseudoVMSLTU_VV_MF4_MASK, PseudoVMSLTU_VV_MF4, PseudoVMSLTU_VV_MF4_MASK, 0x3 }, // 1505
  { PseudoVMSLTU_VV_MF8_MASK, PseudoVMSLTU_VV_MF8, PseudoVMSLTU_VV_MF8_MASK, 0x3 }, // 1506
  { PseudoVMSLTU_VX_M1_MASK, PseudoVMSLTU_VX_M1, PseudoVMSLTU_VX_M1_MASK, 0x3 }, // 1507
  { PseudoVMSLTU_VX_M2_MASK, PseudoVMSLTU_VX_M2, PseudoVMSLTU_VX_M2_MASK, 0x3 }, // 1508
  { PseudoVMSLTU_VX_M4_MASK, PseudoVMSLTU_VX_M4, PseudoVMSLTU_VX_M4_MASK, 0x3 }, // 1509
  { PseudoVMSLTU_VX_M8_MASK, PseudoVMSLTU_VX_M8, PseudoVMSLTU_VX_M8_MASK, 0x3 }, // 1510
  { PseudoVMSLTU_VX_MF2_MASK, PseudoVMSLTU_VX_MF2, PseudoVMSLTU_VX_MF2_MASK, 0x3 }, // 1511
  { PseudoVMSLTU_VX_MF4_MASK, PseudoVMSLTU_VX_MF4, PseudoVMSLTU_VX_MF4_MASK, 0x3 }, // 1512
  { PseudoVMSLTU_VX_MF8_MASK, PseudoVMSLTU_VX_MF8, PseudoVMSLTU_VX_MF8_MASK, 0x3 }, // 1513
  { PseudoVMSLT_VV_M1_MASK, PseudoVMSLT_VV_M1, PseudoVMSLT_VV_M1_MASK, 0x3 }, // 1514
  { PseudoVMSLT_VV_M2_MASK, PseudoVMSLT_VV_M2, PseudoVMSLT_VV_M2_MASK, 0x3 }, // 1515
  { PseudoVMSLT_VV_M4_MASK, PseudoVMSLT_VV_M4, PseudoVMSLT_VV_M4_MASK, 0x3 }, // 1516
  { PseudoVMSLT_VV_M8_MASK, PseudoVMSLT_VV_M8, PseudoVMSLT_VV_M8_MASK, 0x3 }, // 1517
  { PseudoVMSLT_VV_MF2_MASK, PseudoVMSLT_VV_MF2, PseudoVMSLT_VV_MF2_MASK, 0x3 }, // 1518
  { PseudoVMSLT_VV_MF4_MASK, PseudoVMSLT_VV_MF4, PseudoVMSLT_VV_MF4_MASK, 0x3 }, // 1519
  { PseudoVMSLT_VV_MF8_MASK, PseudoVMSLT_VV_MF8, PseudoVMSLT_VV_MF8_MASK, 0x3 }, // 1520
  { PseudoVMSLT_VX_M1_MASK, PseudoVMSLT_VX_M1, PseudoVMSLT_VX_M1_MASK, 0x3 }, // 1521
  { PseudoVMSLT_VX_M2_MASK, PseudoVMSLT_VX_M2, PseudoVMSLT_VX_M2_MASK, 0x3 }, // 1522
  { PseudoVMSLT_VX_M4_MASK, PseudoVMSLT_VX_M4, PseudoVMSLT_VX_M4_MASK, 0x3 }, // 1523
  { PseudoVMSLT_VX_M8_MASK, PseudoVMSLT_VX_M8, PseudoVMSLT_VX_M8_MASK, 0x3 }, // 1524
  { PseudoVMSLT_VX_MF2_MASK, PseudoVMSLT_VX_MF2, PseudoVMSLT_VX_MF2_MASK, 0x3 }, // 1525
  { PseudoVMSLT_VX_MF4_MASK, PseudoVMSLT_VX_MF4, PseudoVMSLT_VX_MF4_MASK, 0x3 }, // 1526
  { PseudoVMSLT_VX_MF8_MASK, PseudoVMSLT_VX_MF8, PseudoVMSLT_VX_MF8_MASK, 0x3 }, // 1527
  { PseudoVMSNE_VI_M1_MASK, PseudoVMSNE_VI_M1, PseudoVMSNE_VI_M1_MASK, 0x3 }, // 1528
  { PseudoVMSNE_VI_M2_MASK, PseudoVMSNE_VI_M2, PseudoVMSNE_VI_M2_MASK, 0x3 }, // 1529
  { PseudoVMSNE_VI_M4_MASK, PseudoVMSNE_VI_M4, PseudoVMSNE_VI_M4_MASK, 0x3 }, // 1530
  { PseudoVMSNE_VI_M8_MASK, PseudoVMSNE_VI_M8, PseudoVMSNE_VI_M8_MASK, 0x3 }, // 1531
  { PseudoVMSNE_VI_MF2_MASK, PseudoVMSNE_VI_MF2, PseudoVMSNE_VI_MF2_MASK, 0x3 }, // 1532
  { PseudoVMSNE_VI_MF4_MASK, PseudoVMSNE_VI_MF4, PseudoVMSNE_VI_MF4_MASK, 0x3 }, // 1533
  { PseudoVMSNE_VI_MF8_MASK, PseudoVMSNE_VI_MF8, PseudoVMSNE_VI_MF8_MASK, 0x3 }, // 1534
  { PseudoVMSNE_VV_M1_MASK, PseudoVMSNE_VV_M1, PseudoVMSNE_VV_M1_MASK, 0x3 }, // 1535
  { PseudoVMSNE_VV_M2_MASK, PseudoVMSNE_VV_M2, PseudoVMSNE_VV_M2_MASK, 0x3 }, // 1536
  { PseudoVMSNE_VV_M4_MASK, PseudoVMSNE_VV_M4, PseudoVMSNE_VV_M4_MASK, 0x3 }, // 1537
  { PseudoVMSNE_VV_M8_MASK, PseudoVMSNE_VV_M8, PseudoVMSNE_VV_M8_MASK, 0x3 }, // 1538
  { PseudoVMSNE_VV_MF2_MASK, PseudoVMSNE_VV_MF2, PseudoVMSNE_VV_MF2_MASK, 0x3 }, // 1539
  { PseudoVMSNE_VV_MF4_MASK, PseudoVMSNE_VV_MF4, PseudoVMSNE_VV_MF4_MASK, 0x3 }, // 1540
  { PseudoVMSNE_VV_MF8_MASK, PseudoVMSNE_VV_MF8, PseudoVMSNE_VV_MF8_MASK, 0x3 }, // 1541
  { PseudoVMSNE_VX_M1_MASK, PseudoVMSNE_VX_M1, PseudoVMSNE_VX_M1_MASK, 0x3 }, // 1542
  { PseudoVMSNE_VX_M2_MASK, PseudoVMSNE_VX_M2, PseudoVMSNE_VX_M2_MASK, 0x3 }, // 1543
  { PseudoVMSNE_VX_M4_MASK, PseudoVMSNE_VX_M4, PseudoVMSNE_VX_M4_MASK, 0x3 }, // 1544
  { PseudoVMSNE_VX_M8_MASK, PseudoVMSNE_VX_M8, PseudoVMSNE_VX_M8_MASK, 0x3 }, // 1545
  { PseudoVMSNE_VX_MF2_MASK, PseudoVMSNE_VX_MF2, PseudoVMSNE_VX_MF2_MASK, 0x3 }, // 1546
  { PseudoVMSNE_VX_MF4_MASK, PseudoVMSNE_VX_MF4, PseudoVMSNE_VX_MF4_MASK, 0x3 }, // 1547
  { PseudoVMSNE_VX_MF8_MASK, PseudoVMSNE_VX_MF8, PseudoVMSNE_VX_MF8_MASK, 0x3 }, // 1548
  { PseudoVMULHSU_VV_M1_MASK, PseudoVMULHSU_VV_M1, PseudoVMULHSU_VV_M1_TU, 0x3 }, // 1549
  { PseudoVMULHSU_VV_M2_MASK, PseudoVMULHSU_VV_M2, PseudoVMULHSU_VV_M2_TU, 0x3 }, // 1550
  { PseudoVMULHSU_VV_M4_MASK, PseudoVMULHSU_VV_M4, PseudoVMULHSU_VV_M4_TU, 0x3 }, // 1551
  { PseudoVMULHSU_VV_M8_MASK, PseudoVMULHSU_VV_M8, PseudoVMULHSU_VV_M8_TU, 0x3 }, // 1552
  { PseudoVMULHSU_VV_MF2_MASK, PseudoVMULHSU_VV_MF2, PseudoVMULHSU_VV_MF2_TU, 0x3 }, // 1553
  { PseudoVMULHSU_VV_MF4_MASK, PseudoVMULHSU_VV_MF4, PseudoVMULHSU_VV_MF4_TU, 0x3 }, // 1554
  { PseudoVMULHSU_VV_MF8_MASK, PseudoVMULHSU_VV_MF8, PseudoVMULHSU_VV_MF8_TU, 0x3 }, // 1555
  { PseudoVMULHSU_VX_M1_MASK, PseudoVMULHSU_VX_M1, PseudoVMULHSU_VX_M1_TU, 0x3 }, // 1556
  { PseudoVMULHSU_VX_M2_MASK, PseudoVMULHSU_VX_M2, PseudoVMULHSU_VX_M2_TU, 0x3 }, // 1557
  { PseudoVMULHSU_VX_M4_MASK, PseudoVMULHSU_VX_M4, PseudoVMULHSU_VX_M4_TU, 0x3 }, // 1558
  { PseudoVMULHSU_VX_M8_MASK, PseudoVMULHSU_VX_M8, PseudoVMULHSU_VX_M8_TU, 0x3 }, // 1559
  { PseudoVMULHSU_VX_MF2_MASK, PseudoVMULHSU_VX_MF2, PseudoVMULHSU_VX_MF2_TU, 0x3 }, // 1560
  { PseudoVMULHSU_VX_MF4_MASK, PseudoVMULHSU_VX_MF4, PseudoVMULHSU_VX_MF4_TU, 0x3 }, // 1561
  { PseudoVMULHSU_VX_MF8_MASK, PseudoVMULHSU_VX_MF8, PseudoVMULHSU_VX_MF8_TU, 0x3 }, // 1562
  { PseudoVMULHU_VV_M1_MASK, PseudoVMULHU_VV_M1, PseudoVMULHU_VV_M1_TU, 0x3 }, // 1563
  { PseudoVMULHU_VV_M2_MASK, PseudoVMULHU_VV_M2, PseudoVMULHU_VV_M2_TU, 0x3 }, // 1564
  { PseudoVMULHU_VV_M4_MASK, PseudoVMULHU_VV_M4, PseudoVMULHU_VV_M4_TU, 0x3 }, // 1565
  { PseudoVMULHU_VV_M8_MASK, PseudoVMULHU_VV_M8, PseudoVMULHU_VV_M8_TU, 0x3 }, // 1566
  { PseudoVMULHU_VV_MF2_MASK, PseudoVMULHU_VV_MF2, PseudoVMULHU_VV_MF2_TU, 0x3 }, // 1567
  { PseudoVMULHU_VV_MF4_MASK, PseudoVMULHU_VV_MF4, PseudoVMULHU_VV_MF4_TU, 0x3 }, // 1568
  { PseudoVMULHU_VV_MF8_MASK, PseudoVMULHU_VV_MF8, PseudoVMULHU_VV_MF8_TU, 0x3 }, // 1569
  { PseudoVMULHU_VX_M1_MASK, PseudoVMULHU_VX_M1, PseudoVMULHU_VX_M1_TU, 0x3 }, // 1570
  { PseudoVMULHU_VX_M2_MASK, PseudoVMULHU_VX_M2, PseudoVMULHU_VX_M2_TU, 0x3 }, // 1571
  { PseudoVMULHU_VX_M4_MASK, PseudoVMULHU_VX_M4, PseudoVMULHU_VX_M4_TU, 0x3 }, // 1572
  { PseudoVMULHU_VX_M8_MASK, PseudoVMULHU_VX_M8, PseudoVMULHU_VX_M8_TU, 0x3 }, // 1573
  { PseudoVMULHU_VX_MF2_MASK, PseudoVMULHU_VX_MF2, PseudoVMULHU_VX_MF2_TU, 0x3 }, // 1574
  { PseudoVMULHU_VX_MF4_MASK, PseudoVMULHU_VX_MF4, PseudoVMULHU_VX_MF4_TU, 0x3 }, // 1575
  { PseudoVMULHU_VX_MF8_MASK, PseudoVMULHU_VX_MF8, PseudoVMULHU_VX_MF8_TU, 0x3 }, // 1576
  { PseudoVMULH_VV_M1_MASK, PseudoVMULH_VV_M1, PseudoVMULH_VV_M1_TU, 0x3 }, // 1577
  { PseudoVMULH_VV_M2_MASK, PseudoVMULH_VV_M2, PseudoVMULH_VV_M2_TU, 0x3 }, // 1578
  { PseudoVMULH_VV_M4_MASK, PseudoVMULH_VV_M4, PseudoVMULH_VV_M4_TU, 0x3 }, // 1579
  { PseudoVMULH_VV_M8_MASK, PseudoVMULH_VV_M8, PseudoVMULH_VV_M8_TU, 0x3 }, // 1580
  { PseudoVMULH_VV_MF2_MASK, PseudoVMULH_VV_MF2, PseudoVMULH_VV_MF2_TU, 0x3 }, // 1581
  { PseudoVMULH_VV_MF4_MASK, PseudoVMULH_VV_MF4, PseudoVMULH_VV_MF4_TU, 0x3 }, // 1582
  { PseudoVMULH_VV_MF8_MASK, PseudoVMULH_VV_MF8, PseudoVMULH_VV_MF8_TU, 0x3 }, // 1583
  { PseudoVMULH_VX_M1_MASK, PseudoVMULH_VX_M1, PseudoVMULH_VX_M1_TU, 0x3 }, // 1584
  { PseudoVMULH_VX_M2_MASK, PseudoVMULH_VX_M2, PseudoVMULH_VX_M2_TU, 0x3 }, // 1585
  { PseudoVMULH_VX_M4_MASK, PseudoVMULH_VX_M4, PseudoVMULH_VX_M4_TU, 0x3 }, // 1586
  { PseudoVMULH_VX_M8_MASK, PseudoVMULH_VX_M8, PseudoVMULH_VX_M8_TU, 0x3 }, // 1587
  { PseudoVMULH_VX_MF2_MASK, PseudoVMULH_VX_MF2, PseudoVMULH_VX_MF2_TU, 0x3 }, // 1588
  { PseudoVMULH_VX_MF4_MASK, PseudoVMULH_VX_MF4, PseudoVMULH_VX_MF4_TU, 0x3 }, // 1589
  { PseudoVMULH_VX_MF8_MASK, PseudoVMULH_VX_MF8, PseudoVMULH_VX_MF8_TU, 0x3 }, // 1590
  { PseudoVMUL_VV_M1_MASK, PseudoVMUL_VV_M1, PseudoVMUL_VV_M1_TU, 0x3 }, // 1591
  { PseudoVMUL_VV_M2_MASK, PseudoVMUL_VV_M2, PseudoVMUL_VV_M2_TU, 0x3 }, // 1592
  { PseudoVMUL_VV_M4_MASK, PseudoVMUL_VV_M4, PseudoVMUL_VV_M4_TU, 0x3 }, // 1593
  { PseudoVMUL_VV_M8_MASK, PseudoVMUL_VV_M8, PseudoVMUL_VV_M8_TU, 0x3 }, // 1594
  { PseudoVMUL_VV_MF2_MASK, PseudoVMUL_VV_MF2, PseudoVMUL_VV_MF2_TU, 0x3 }, // 1595
  { PseudoVMUL_VV_MF4_MASK, PseudoVMUL_VV_MF4, PseudoVMUL_VV_MF4_TU, 0x3 }, // 1596
  { PseudoVMUL_VV_MF8_MASK, PseudoVMUL_VV_MF8, PseudoVMUL_VV_MF8_TU, 0x3 }, // 1597
  { PseudoVMUL_VX_M1_MASK, PseudoVMUL_VX_M1, PseudoVMUL_VX_M1_TU, 0x3 }, // 1598
  { PseudoVMUL_VX_M2_MASK, PseudoVMUL_VX_M2, PseudoVMUL_VX_M2_TU, 0x3 }, // 1599
  { PseudoVMUL_VX_M4_MASK, PseudoVMUL_VX_M4, PseudoVMUL_VX_M4_TU, 0x3 }, // 1600
  { PseudoVMUL_VX_M8_MASK, PseudoVMUL_VX_M8, PseudoVMUL_VX_M8_TU, 0x3 }, // 1601
  { PseudoVMUL_VX_MF2_MASK, PseudoVMUL_VX_MF2, PseudoVMUL_VX_MF2_TU, 0x3 }, // 1602
  { PseudoVMUL_VX_MF4_MASK, PseudoVMUL_VX_MF4, PseudoVMUL_VX_MF4_TU, 0x3 }, // 1603
  { PseudoVMUL_VX_MF8_MASK, PseudoVMUL_VX_MF8, PseudoVMUL_VX_MF8_TU, 0x3 }, // 1604
  { PseudoVNCLIPU_WI_M1_MASK, PseudoVNCLIPU_WI_M1, PseudoVNCLIPU_WI_M1_TU, 0x3 }, // 1605
  { PseudoVNCLIPU_WI_M2_MASK, PseudoVNCLIPU_WI_M2, PseudoVNCLIPU_WI_M2_TU, 0x3 }, // 1606
  { PseudoVNCLIPU_WI_M4_MASK, PseudoVNCLIPU_WI_M4, PseudoVNCLIPU_WI_M4_TU, 0x3 }, // 1607
  { PseudoVNCLIPU_WI_MF2_MASK, PseudoVNCLIPU_WI_MF2, PseudoVNCLIPU_WI_MF2_TU, 0x3 }, // 1608
  { PseudoVNCLIPU_WI_MF4_MASK, PseudoVNCLIPU_WI_MF4, PseudoVNCLIPU_WI_MF4_TU, 0x3 }, // 1609
  { PseudoVNCLIPU_WI_MF8_MASK, PseudoVNCLIPU_WI_MF8, PseudoVNCLIPU_WI_MF8_TU, 0x3 }, // 1610
  { PseudoVNCLIPU_WV_M1_MASK, PseudoVNCLIPU_WV_M1, PseudoVNCLIPU_WV_M1_TU, 0x3 }, // 1611
  { PseudoVNCLIPU_WV_M2_MASK, PseudoVNCLIPU_WV_M2, PseudoVNCLIPU_WV_M2_TU, 0x3 }, // 1612
  { PseudoVNCLIPU_WV_M4_MASK, PseudoVNCLIPU_WV_M4, PseudoVNCLIPU_WV_M4_TU, 0x3 }, // 1613
  { PseudoVNCLIPU_WV_MF2_MASK, PseudoVNCLIPU_WV_MF2, PseudoVNCLIPU_WV_MF2_TU, 0x3 }, // 1614
  { PseudoVNCLIPU_WV_MF4_MASK, PseudoVNCLIPU_WV_MF4, PseudoVNCLIPU_WV_MF4_TU, 0x3 }, // 1615
  { PseudoVNCLIPU_WV_MF8_MASK, PseudoVNCLIPU_WV_MF8, PseudoVNCLIPU_WV_MF8_TU, 0x3 }, // 1616
  { PseudoVNCLIPU_WX_M1_MASK, PseudoVNCLIPU_WX_M1, PseudoVNCLIPU_WX_M1_TU, 0x3 }, // 1617
  { PseudoVNCLIPU_WX_M2_MASK, PseudoVNCLIPU_WX_M2, PseudoVNCLIPU_WX_M2_TU, 0x3 }, // 1618
  { PseudoVNCLIPU_WX_M4_MASK, PseudoVNCLIPU_WX_M4, PseudoVNCLIPU_WX_M4_TU, 0x3 }, // 1619
  { PseudoVNCLIPU_WX_MF2_MASK, PseudoVNCLIPU_WX_MF2, PseudoVNCLIPU_WX_MF2_TU, 0x3 }, // 1620
  { PseudoVNCLIPU_WX_MF4_MASK, PseudoVNCLIPU_WX_MF4, PseudoVNCLIPU_WX_MF4_TU, 0x3 }, // 1621
  { PseudoVNCLIPU_WX_MF8_MASK, PseudoVNCLIPU_WX_MF8, PseudoVNCLIPU_WX_MF8_TU, 0x3 }, // 1622
  { PseudoVNCLIP_WI_M1_MASK, PseudoVNCLIP_WI_M1, PseudoVNCLIP_WI_M1_TU, 0x3 }, // 1623
  { PseudoVNCLIP_WI_M2_MASK, PseudoVNCLIP_WI_M2, PseudoVNCLIP_WI_M2_TU, 0x3 }, // 1624
  { PseudoVNCLIP_WI_M4_MASK, PseudoVNCLIP_WI_M4, PseudoVNCLIP_WI_M4_TU, 0x3 }, // 1625
  { PseudoVNCLIP_WI_MF2_MASK, PseudoVNCLIP_WI_MF2, PseudoVNCLIP_WI_MF2_TU, 0x3 }, // 1626
  { PseudoVNCLIP_WI_MF4_MASK, PseudoVNCLIP_WI_MF4, PseudoVNCLIP_WI_MF4_TU, 0x3 }, // 1627
  { PseudoVNCLIP_WI_MF8_MASK, PseudoVNCLIP_WI_MF8, PseudoVNCLIP_WI_MF8_TU, 0x3 }, // 1628
  { PseudoVNCLIP_WV_M1_MASK, PseudoVNCLIP_WV_M1, PseudoVNCLIP_WV_M1_TU, 0x3 }, // 1629
  { PseudoVNCLIP_WV_M2_MASK, PseudoVNCLIP_WV_M2, PseudoVNCLIP_WV_M2_TU, 0x3 }, // 1630
  { PseudoVNCLIP_WV_M4_MASK, PseudoVNCLIP_WV_M4, PseudoVNCLIP_WV_M4_TU, 0x3 }, // 1631
  { PseudoVNCLIP_WV_MF2_MASK, PseudoVNCLIP_WV_MF2, PseudoVNCLIP_WV_MF2_TU, 0x3 }, // 1632
  { PseudoVNCLIP_WV_MF4_MASK, PseudoVNCLIP_WV_MF4, PseudoVNCLIP_WV_MF4_TU, 0x3 }, // 1633
  { PseudoVNCLIP_WV_MF8_MASK, PseudoVNCLIP_WV_MF8, PseudoVNCLIP_WV_MF8_TU, 0x3 }, // 1634
  { PseudoVNCLIP_WX_M1_MASK, PseudoVNCLIP_WX_M1, PseudoVNCLIP_WX_M1_TU, 0x3 }, // 1635
  { PseudoVNCLIP_WX_M2_MASK, PseudoVNCLIP_WX_M2, PseudoVNCLIP_WX_M2_TU, 0x3 }, // 1636
  { PseudoVNCLIP_WX_M4_MASK, PseudoVNCLIP_WX_M4, PseudoVNCLIP_WX_M4_TU, 0x3 }, // 1637
  { PseudoVNCLIP_WX_MF2_MASK, PseudoVNCLIP_WX_MF2, PseudoVNCLIP_WX_MF2_TU, 0x3 }, // 1638
  { PseudoVNCLIP_WX_MF4_MASK, PseudoVNCLIP_WX_MF4, PseudoVNCLIP_WX_MF4_TU, 0x3 }, // 1639
  { PseudoVNCLIP_WX_MF8_MASK, PseudoVNCLIP_WX_MF8, PseudoVNCLIP_WX_MF8_TU, 0x3 }, // 1640
  { PseudoVNMSAC_VV_M1_MASK, PseudoVNMSAC_VV_M1, PseudoVNMSAC_VV_M1, 0x3 }, // 1641
  { PseudoVNMSAC_VV_M2_MASK, PseudoVNMSAC_VV_M2, PseudoVNMSAC_VV_M2, 0x3 }, // 1642
  { PseudoVNMSAC_VV_M4_MASK, PseudoVNMSAC_VV_M4, PseudoVNMSAC_VV_M4, 0x3 }, // 1643
  { PseudoVNMSAC_VV_M8_MASK, PseudoVNMSAC_VV_M8, PseudoVNMSAC_VV_M8, 0x3 }, // 1644
  { PseudoVNMSAC_VV_MF2_MASK, PseudoVNMSAC_VV_MF2, PseudoVNMSAC_VV_MF2, 0x3 }, // 1645
  { PseudoVNMSAC_VV_MF4_MASK, PseudoVNMSAC_VV_MF4, PseudoVNMSAC_VV_MF4, 0x3 }, // 1646
  { PseudoVNMSAC_VV_MF8_MASK, PseudoVNMSAC_VV_MF8, PseudoVNMSAC_VV_MF8, 0x3 }, // 1647
  { PseudoVNMSAC_VX_M1_MASK, PseudoVNMSAC_VX_M1, PseudoVNMSAC_VX_M1, 0x3 }, // 1648
  { PseudoVNMSAC_VX_M2_MASK, PseudoVNMSAC_VX_M2, PseudoVNMSAC_VX_M2, 0x3 }, // 1649
  { PseudoVNMSAC_VX_M4_MASK, PseudoVNMSAC_VX_M4, PseudoVNMSAC_VX_M4, 0x3 }, // 1650
  { PseudoVNMSAC_VX_M8_MASK, PseudoVNMSAC_VX_M8, PseudoVNMSAC_VX_M8, 0x3 }, // 1651
  { PseudoVNMSAC_VX_MF2_MASK, PseudoVNMSAC_VX_MF2, PseudoVNMSAC_VX_MF2, 0x3 }, // 1652
  { PseudoVNMSAC_VX_MF4_MASK, PseudoVNMSAC_VX_MF4, PseudoVNMSAC_VX_MF4, 0x3 }, // 1653
  { PseudoVNMSAC_VX_MF8_MASK, PseudoVNMSAC_VX_MF8, PseudoVNMSAC_VX_MF8, 0x3 }, // 1654
  { PseudoVNMSUB_VV_M1_MASK, PseudoVNMSUB_VV_M1, PseudoVNMSUB_VV_M1, 0x3 }, // 1655
  { PseudoVNMSUB_VV_M2_MASK, PseudoVNMSUB_VV_M2, PseudoVNMSUB_VV_M2, 0x3 }, // 1656
  { PseudoVNMSUB_VV_M4_MASK, PseudoVNMSUB_VV_M4, PseudoVNMSUB_VV_M4, 0x3 }, // 1657
  { PseudoVNMSUB_VV_M8_MASK, PseudoVNMSUB_VV_M8, PseudoVNMSUB_VV_M8, 0x3 }, // 1658
  { PseudoVNMSUB_VV_MF2_MASK, PseudoVNMSUB_VV_MF2, PseudoVNMSUB_VV_MF2, 0x3 }, // 1659
  { PseudoVNMSUB_VV_MF4_MASK, PseudoVNMSUB_VV_MF4, PseudoVNMSUB_VV_MF4, 0x3 }, // 1660
  { PseudoVNMSUB_VV_MF8_MASK, PseudoVNMSUB_VV_MF8, PseudoVNMSUB_VV_MF8, 0x3 }, // 1661
  { PseudoVNMSUB_VX_M1_MASK, PseudoVNMSUB_VX_M1, PseudoVNMSUB_VX_M1, 0x3 }, // 1662
  { PseudoVNMSUB_VX_M2_MASK, PseudoVNMSUB_VX_M2, PseudoVNMSUB_VX_M2, 0x3 }, // 1663
  { PseudoVNMSUB_VX_M4_MASK, PseudoVNMSUB_VX_M4, PseudoVNMSUB_VX_M4, 0x3 }, // 1664
  { PseudoVNMSUB_VX_M8_MASK, PseudoVNMSUB_VX_M8, PseudoVNMSUB_VX_M8, 0x3 }, // 1665
  { PseudoVNMSUB_VX_MF2_MASK, PseudoVNMSUB_VX_MF2, PseudoVNMSUB_VX_MF2, 0x3 }, // 1666
  { PseudoVNMSUB_VX_MF4_MASK, PseudoVNMSUB_VX_MF4, PseudoVNMSUB_VX_MF4, 0x3 }, // 1667
  { PseudoVNMSUB_VX_MF8_MASK, PseudoVNMSUB_VX_MF8, PseudoVNMSUB_VX_MF8, 0x3 }, // 1668
  { PseudoVNSRA_WI_M1_MASK, PseudoVNSRA_WI_M1, PseudoVNSRA_WI_M1_TU, 0x3 }, // 1669
  { PseudoVNSRA_WI_M2_MASK, PseudoVNSRA_WI_M2, PseudoVNSRA_WI_M2_TU, 0x3 }, // 1670
  { PseudoVNSRA_WI_M4_MASK, PseudoVNSRA_WI_M4, PseudoVNSRA_WI_M4_TU, 0x3 }, // 1671
  { PseudoVNSRA_WI_MF2_MASK, PseudoVNSRA_WI_MF2, PseudoVNSRA_WI_MF2_TU, 0x3 }, // 1672
  { PseudoVNSRA_WI_MF4_MASK, PseudoVNSRA_WI_MF4, PseudoVNSRA_WI_MF4_TU, 0x3 }, // 1673
  { PseudoVNSRA_WI_MF8_MASK, PseudoVNSRA_WI_MF8, PseudoVNSRA_WI_MF8_TU, 0x3 }, // 1674
  { PseudoVNSRA_WV_M1_MASK, PseudoVNSRA_WV_M1, PseudoVNSRA_WV_M1_TU, 0x3 }, // 1675
  { PseudoVNSRA_WV_M2_MASK, PseudoVNSRA_WV_M2, PseudoVNSRA_WV_M2_TU, 0x3 }, // 1676
  { PseudoVNSRA_WV_M4_MASK, PseudoVNSRA_WV_M4, PseudoVNSRA_WV_M4_TU, 0x3 }, // 1677
  { PseudoVNSRA_WV_MF2_MASK, PseudoVNSRA_WV_MF2, PseudoVNSRA_WV_MF2_TU, 0x3 }, // 1678
  { PseudoVNSRA_WV_MF4_MASK, PseudoVNSRA_WV_MF4, PseudoVNSRA_WV_MF4_TU, 0x3 }, // 1679
  { PseudoVNSRA_WV_MF8_MASK, PseudoVNSRA_WV_MF8, PseudoVNSRA_WV_MF8_TU, 0x3 }, // 1680
  { PseudoVNSRA_WX_M1_MASK, PseudoVNSRA_WX_M1, PseudoVNSRA_WX_M1_TU, 0x3 }, // 1681
  { PseudoVNSRA_WX_M2_MASK, PseudoVNSRA_WX_M2, PseudoVNSRA_WX_M2_TU, 0x3 }, // 1682
  { PseudoVNSRA_WX_M4_MASK, PseudoVNSRA_WX_M4, PseudoVNSRA_WX_M4_TU, 0x3 }, // 1683
  { PseudoVNSRA_WX_MF2_MASK, PseudoVNSRA_WX_MF2, PseudoVNSRA_WX_MF2_TU, 0x3 }, // 1684
  { PseudoVNSRA_WX_MF4_MASK, PseudoVNSRA_WX_MF4, PseudoVNSRA_WX_MF4_TU, 0x3 }, // 1685
  { PseudoVNSRA_WX_MF8_MASK, PseudoVNSRA_WX_MF8, PseudoVNSRA_WX_MF8_TU, 0x3 }, // 1686
  { PseudoVNSRL_WI_M1_MASK, PseudoVNSRL_WI_M1, PseudoVNSRL_WI_M1_TU, 0x3 }, // 1687
  { PseudoVNSRL_WI_M2_MASK, PseudoVNSRL_WI_M2, PseudoVNSRL_WI_M2_TU, 0x3 }, // 1688
  { PseudoVNSRL_WI_M4_MASK, PseudoVNSRL_WI_M4, PseudoVNSRL_WI_M4_TU, 0x3 }, // 1689
  { PseudoVNSRL_WI_MF2_MASK, PseudoVNSRL_WI_MF2, PseudoVNSRL_WI_MF2_TU, 0x3 }, // 1690
  { PseudoVNSRL_WI_MF4_MASK, PseudoVNSRL_WI_MF4, PseudoVNSRL_WI_MF4_TU, 0x3 }, // 1691
  { PseudoVNSRL_WI_MF8_MASK, PseudoVNSRL_WI_MF8, PseudoVNSRL_WI_MF8_TU, 0x3 }, // 1692
  { PseudoVNSRL_WV_M1_MASK, PseudoVNSRL_WV_M1, PseudoVNSRL_WV_M1_TU, 0x3 }, // 1693
  { PseudoVNSRL_WV_M2_MASK, PseudoVNSRL_WV_M2, PseudoVNSRL_WV_M2_TU, 0x3 }, // 1694
  { PseudoVNSRL_WV_M4_MASK, PseudoVNSRL_WV_M4, PseudoVNSRL_WV_M4_TU, 0x3 }, // 1695
  { PseudoVNSRL_WV_MF2_MASK, PseudoVNSRL_WV_MF2, PseudoVNSRL_WV_MF2_TU, 0x3 }, // 1696
  { PseudoVNSRL_WV_MF4_MASK, PseudoVNSRL_WV_MF4, PseudoVNSRL_WV_MF4_TU, 0x3 }, // 1697
  { PseudoVNSRL_WV_MF8_MASK, PseudoVNSRL_WV_MF8, PseudoVNSRL_WV_MF8_TU, 0x3 }, // 1698
  { PseudoVNSRL_WX_M1_MASK, PseudoVNSRL_WX_M1, PseudoVNSRL_WX_M1_TU, 0x3 }, // 1699
  { PseudoVNSRL_WX_M2_MASK, PseudoVNSRL_WX_M2, PseudoVNSRL_WX_M2_TU, 0x3 }, // 1700
  { PseudoVNSRL_WX_M4_MASK, PseudoVNSRL_WX_M4, PseudoVNSRL_WX_M4_TU, 0x3 }, // 1701
  { PseudoVNSRL_WX_MF2_MASK, PseudoVNSRL_WX_MF2, PseudoVNSRL_WX_MF2_TU, 0x3 }, // 1702
  { PseudoVNSRL_WX_MF4_MASK, PseudoVNSRL_WX_MF4, PseudoVNSRL_WX_MF4_TU, 0x3 }, // 1703
  { PseudoVNSRL_WX_MF8_MASK, PseudoVNSRL_WX_MF8, PseudoVNSRL_WX_MF8_TU, 0x3 }, // 1704
  { PseudoVOR_VI_M1_MASK, PseudoVOR_VI_M1, PseudoVOR_VI_M1_TU, 0x3 }, // 1705
  { PseudoVOR_VI_M2_MASK, PseudoVOR_VI_M2, PseudoVOR_VI_M2_TU, 0x3 }, // 1706
  { PseudoVOR_VI_M4_MASK, PseudoVOR_VI_M4, PseudoVOR_VI_M4_TU, 0x3 }, // 1707
  { PseudoVOR_VI_M8_MASK, PseudoVOR_VI_M8, PseudoVOR_VI_M8_TU, 0x3 }, // 1708
  { PseudoVOR_VI_MF2_MASK, PseudoVOR_VI_MF2, PseudoVOR_VI_MF2_TU, 0x3 }, // 1709
  { PseudoVOR_VI_MF4_MASK, PseudoVOR_VI_MF4, PseudoVOR_VI_MF4_TU, 0x3 }, // 1710
  { PseudoVOR_VI_MF8_MASK, PseudoVOR_VI_MF8, PseudoVOR_VI_MF8_TU, 0x3 }, // 1711
  { PseudoVOR_VV_M1_MASK, PseudoVOR_VV_M1, PseudoVOR_VV_M1_TU, 0x3 }, // 1712
  { PseudoVOR_VV_M2_MASK, PseudoVOR_VV_M2, PseudoVOR_VV_M2_TU, 0x3 }, // 1713
  { PseudoVOR_VV_M4_MASK, PseudoVOR_VV_M4, PseudoVOR_VV_M4_TU, 0x3 }, // 1714
  { PseudoVOR_VV_M8_MASK, PseudoVOR_VV_M8, PseudoVOR_VV_M8_TU, 0x3 }, // 1715
  { PseudoVOR_VV_MF2_MASK, PseudoVOR_VV_MF2, PseudoVOR_VV_MF2_TU, 0x3 }, // 1716
  { PseudoVOR_VV_MF4_MASK, PseudoVOR_VV_MF4, PseudoVOR_VV_MF4_TU, 0x3 }, // 1717
  { PseudoVOR_VV_MF8_MASK, PseudoVOR_VV_MF8, PseudoVOR_VV_MF8_TU, 0x3 }, // 1718
  { PseudoVOR_VX_M1_MASK, PseudoVOR_VX_M1, PseudoVOR_VX_M1_TU, 0x3 }, // 1719
  { PseudoVOR_VX_M2_MASK, PseudoVOR_VX_M2, PseudoVOR_VX_M2_TU, 0x3 }, // 1720
  { PseudoVOR_VX_M4_MASK, PseudoVOR_VX_M4, PseudoVOR_VX_M4_TU, 0x3 }, // 1721
  { PseudoVOR_VX_M8_MASK, PseudoVOR_VX_M8, PseudoVOR_VX_M8_TU, 0x3 }, // 1722
  { PseudoVOR_VX_MF2_MASK, PseudoVOR_VX_MF2, PseudoVOR_VX_MF2_TU, 0x3 }, // 1723
  { PseudoVOR_VX_MF4_MASK, PseudoVOR_VX_MF4, PseudoVOR_VX_MF4_TU, 0x3 }, // 1724
  { PseudoVOR_VX_MF8_MASK, PseudoVOR_VX_MF8, PseudoVOR_VX_MF8_TU, 0x3 }, // 1725
  { PseudoVREMU_VV_M1_E16_MASK, PseudoVREMU_VV_M1_E16, PseudoVREMU_VV_M1_E16_TU, 0x3 }, // 1726
  { PseudoVREMU_VV_M1_E32_MASK, PseudoVREMU_VV_M1_E32, PseudoVREMU_VV_M1_E32_TU, 0x3 }, // 1727
  { PseudoVREMU_VV_M1_E64_MASK, PseudoVREMU_VV_M1_E64, PseudoVREMU_VV_M1_E64_TU, 0x3 }, // 1728
  { PseudoVREMU_VV_M1_E8_MASK, PseudoVREMU_VV_M1_E8, PseudoVREMU_VV_M1_E8_TU, 0x3 }, // 1729
  { PseudoVREMU_VV_M2_E16_MASK, PseudoVREMU_VV_M2_E16, PseudoVREMU_VV_M2_E16_TU, 0x3 }, // 1730
  { PseudoVREMU_VV_M2_E32_MASK, PseudoVREMU_VV_M2_E32, PseudoVREMU_VV_M2_E32_TU, 0x3 }, // 1731
  { PseudoVREMU_VV_M2_E64_MASK, PseudoVREMU_VV_M2_E64, PseudoVREMU_VV_M2_E64_TU, 0x3 }, // 1732
  { PseudoVREMU_VV_M2_E8_MASK, PseudoVREMU_VV_M2_E8, PseudoVREMU_VV_M2_E8_TU, 0x3 }, // 1733
  { PseudoVREMU_VV_M4_E16_MASK, PseudoVREMU_VV_M4_E16, PseudoVREMU_VV_M4_E16_TU, 0x3 }, // 1734
  { PseudoVREMU_VV_M4_E32_MASK, PseudoVREMU_VV_M4_E32, PseudoVREMU_VV_M4_E32_TU, 0x3 }, // 1735
  { PseudoVREMU_VV_M4_E64_MASK, PseudoVREMU_VV_M4_E64, PseudoVREMU_VV_M4_E64_TU, 0x3 }, // 1736
  { PseudoVREMU_VV_M4_E8_MASK, PseudoVREMU_VV_M4_E8, PseudoVREMU_VV_M4_E8_TU, 0x3 }, // 1737
  { PseudoVREMU_VV_M8_E16_MASK, PseudoVREMU_VV_M8_E16, PseudoVREMU_VV_M8_E16_TU, 0x3 }, // 1738
  { PseudoVREMU_VV_M8_E32_MASK, PseudoVREMU_VV_M8_E32, PseudoVREMU_VV_M8_E32_TU, 0x3 }, // 1739
  { PseudoVREMU_VV_M8_E64_MASK, PseudoVREMU_VV_M8_E64, PseudoVREMU_VV_M8_E64_TU, 0x3 }, // 1740
  { PseudoVREMU_VV_M8_E8_MASK, PseudoVREMU_VV_M8_E8, PseudoVREMU_VV_M8_E8_TU, 0x3 }, // 1741
  { PseudoVREMU_VV_MF2_E16_MASK, PseudoVREMU_VV_MF2_E16, PseudoVREMU_VV_MF2_E16_TU, 0x3 }, // 1742
  { PseudoVREMU_VV_MF2_E32_MASK, PseudoVREMU_VV_MF2_E32, PseudoVREMU_VV_MF2_E32_TU, 0x3 }, // 1743
  { PseudoVREMU_VV_MF2_E8_MASK, PseudoVREMU_VV_MF2_E8, PseudoVREMU_VV_MF2_E8_TU, 0x3 }, // 1744
  { PseudoVREMU_VV_MF4_E16_MASK, PseudoVREMU_VV_MF4_E16, PseudoVREMU_VV_MF4_E16_TU, 0x3 }, // 1745
  { PseudoVREMU_VV_MF4_E8_MASK, PseudoVREMU_VV_MF4_E8, PseudoVREMU_VV_MF4_E8_TU, 0x3 }, // 1746
  { PseudoVREMU_VV_MF8_E8_MASK, PseudoVREMU_VV_MF8_E8, PseudoVREMU_VV_MF8_E8_TU, 0x3 }, // 1747
  { PseudoVREMU_VX_M1_E16_MASK, PseudoVREMU_VX_M1_E16, PseudoVREMU_VX_M1_E16_TU, 0x3 }, // 1748
  { PseudoVREMU_VX_M1_E32_MASK, PseudoVREMU_VX_M1_E32, PseudoVREMU_VX_M1_E32_TU, 0x3 }, // 1749
  { PseudoVREMU_VX_M1_E64_MASK, PseudoVREMU_VX_M1_E64, PseudoVREMU_VX_M1_E64_TU, 0x3 }, // 1750
  { PseudoVREMU_VX_M1_E8_MASK, PseudoVREMU_VX_M1_E8, PseudoVREMU_VX_M1_E8_TU, 0x3 }, // 1751
  { PseudoVREMU_VX_M2_E16_MASK, PseudoVREMU_VX_M2_E16, PseudoVREMU_VX_M2_E16_TU, 0x3 }, // 1752
  { PseudoVREMU_VX_M2_E32_MASK, PseudoVREMU_VX_M2_E32, PseudoVREMU_VX_M2_E32_TU, 0x3 }, // 1753
  { PseudoVREMU_VX_M2_E64_MASK, PseudoVREMU_VX_M2_E64, PseudoVREMU_VX_M2_E64_TU, 0x3 }, // 1754
  { PseudoVREMU_VX_M2_E8_MASK, PseudoVREMU_VX_M2_E8, PseudoVREMU_VX_M2_E8_TU, 0x3 }, // 1755
  { PseudoVREMU_VX_M4_E16_MASK, PseudoVREMU_VX_M4_E16, PseudoVREMU_VX_M4_E16_TU, 0x3 }, // 1756
  { PseudoVREMU_VX_M4_E32_MASK, PseudoVREMU_VX_M4_E32, PseudoVREMU_VX_M4_E32_TU, 0x3 }, // 1757
  { PseudoVREMU_VX_M4_E64_MASK, PseudoVREMU_VX_M4_E64, PseudoVREMU_VX_M4_E64_TU, 0x3 }, // 1758
  { PseudoVREMU_VX_M4_E8_MASK, PseudoVREMU_VX_M4_E8, PseudoVREMU_VX_M4_E8_TU, 0x3 }, // 1759
  { PseudoVREMU_VX_M8_E16_MASK, PseudoVREMU_VX_M8_E16, PseudoVREMU_VX_M8_E16_TU, 0x3 }, // 1760
  { PseudoVREMU_VX_M8_E32_MASK, PseudoVREMU_VX_M8_E32, PseudoVREMU_VX_M8_E32_TU, 0x3 }, // 1761
  { PseudoVREMU_VX_M8_E64_MASK, PseudoVREMU_VX_M8_E64, PseudoVREMU_VX_M8_E64_TU, 0x3 }, // 1762
  { PseudoVREMU_VX_M8_E8_MASK, PseudoVREMU_VX_M8_E8, PseudoVREMU_VX_M8_E8_TU, 0x3 }, // 1763
  { PseudoVREMU_VX_MF2_E16_MASK, PseudoVREMU_VX_MF2_E16, PseudoVREMU_VX_MF2_E16_TU, 0x3 }, // 1764
  { PseudoVREMU_VX_MF2_E32_MASK, PseudoVREMU_VX_MF2_E32, PseudoVREMU_VX_MF2_E32_TU, 0x3 }, // 1765
  { PseudoVREMU_VX_MF2_E8_MASK, PseudoVREMU_VX_MF2_E8, PseudoVREMU_VX_MF2_E8_TU, 0x3 }, // 1766
  { PseudoVREMU_VX_MF4_E16_MASK, PseudoVREMU_VX_MF4_E16, PseudoVREMU_VX_MF4_E16_TU, 0x3 }, // 1767
  { PseudoVREMU_VX_MF4_E8_MASK, PseudoVREMU_VX_MF4_E8, PseudoVREMU_VX_MF4_E8_TU, 0x3 }, // 1768
  { PseudoVREMU_VX_MF8_E8_MASK, PseudoVREMU_VX_MF8_E8, PseudoVREMU_VX_MF8_E8_TU, 0x3 }, // 1769
  { PseudoVREM_VV_M1_E16_MASK, PseudoVREM_VV_M1_E16, PseudoVREM_VV_M1_E16_TU, 0x3 }, // 1770
  { PseudoVREM_VV_M1_E32_MASK, PseudoVREM_VV_M1_E32, PseudoVREM_VV_M1_E32_TU, 0x3 }, // 1771
  { PseudoVREM_VV_M1_E64_MASK, PseudoVREM_VV_M1_E64, PseudoVREM_VV_M1_E64_TU, 0x3 }, // 1772
  { PseudoVREM_VV_M1_E8_MASK, PseudoVREM_VV_M1_E8, PseudoVREM_VV_M1_E8_TU, 0x3 }, // 1773
  { PseudoVREM_VV_M2_E16_MASK, PseudoVREM_VV_M2_E16, PseudoVREM_VV_M2_E16_TU, 0x3 }, // 1774
  { PseudoVREM_VV_M2_E32_MASK, PseudoVREM_VV_M2_E32, PseudoVREM_VV_M2_E32_TU, 0x3 }, // 1775
  { PseudoVREM_VV_M2_E64_MASK, PseudoVREM_VV_M2_E64, PseudoVREM_VV_M2_E64_TU, 0x3 }, // 1776
  { PseudoVREM_VV_M2_E8_MASK, PseudoVREM_VV_M2_E8, PseudoVREM_VV_M2_E8_TU, 0x3 }, // 1777
  { PseudoVREM_VV_M4_E16_MASK, PseudoVREM_VV_M4_E16, PseudoVREM_VV_M4_E16_TU, 0x3 }, // 1778
  { PseudoVREM_VV_M4_E32_MASK, PseudoVREM_VV_M4_E32, PseudoVREM_VV_M4_E32_TU, 0x3 }, // 1779
  { PseudoVREM_VV_M4_E64_MASK, PseudoVREM_VV_M4_E64, PseudoVREM_VV_M4_E64_TU, 0x3 }, // 1780
  { PseudoVREM_VV_M4_E8_MASK, PseudoVREM_VV_M4_E8, PseudoVREM_VV_M4_E8_TU, 0x3 }, // 1781
  { PseudoVREM_VV_M8_E16_MASK, PseudoVREM_VV_M8_E16, PseudoVREM_VV_M8_E16_TU, 0x3 }, // 1782
  { PseudoVREM_VV_M8_E32_MASK, PseudoVREM_VV_M8_E32, PseudoVREM_VV_M8_E32_TU, 0x3 }, // 1783
  { PseudoVREM_VV_M8_E64_MASK, PseudoVREM_VV_M8_E64, PseudoVREM_VV_M8_E64_TU, 0x3 }, // 1784
  { PseudoVREM_VV_M8_E8_MASK, PseudoVREM_VV_M8_E8, PseudoVREM_VV_M8_E8_TU, 0x3 }, // 1785
  { PseudoVREM_VV_MF2_E16_MASK, PseudoVREM_VV_MF2_E16, PseudoVREM_VV_MF2_E16_TU, 0x3 }, // 1786
  { PseudoVREM_VV_MF2_E32_MASK, PseudoVREM_VV_MF2_E32, PseudoVREM_VV_MF2_E32_TU, 0x3 }, // 1787
  { PseudoVREM_VV_MF2_E8_MASK, PseudoVREM_VV_MF2_E8, PseudoVREM_VV_MF2_E8_TU, 0x3 }, // 1788
  { PseudoVREM_VV_MF4_E16_MASK, PseudoVREM_VV_MF4_E16, PseudoVREM_VV_MF4_E16_TU, 0x3 }, // 1789
  { PseudoVREM_VV_MF4_E8_MASK, PseudoVREM_VV_MF4_E8, PseudoVREM_VV_MF4_E8_TU, 0x3 }, // 1790
  { PseudoVREM_VV_MF8_E8_MASK, PseudoVREM_VV_MF8_E8, PseudoVREM_VV_MF8_E8_TU, 0x3 }, // 1791
  { PseudoVREM_VX_M1_E16_MASK, PseudoVREM_VX_M1_E16, PseudoVREM_VX_M1_E16_TU, 0x3 }, // 1792
  { PseudoVREM_VX_M1_E32_MASK, PseudoVREM_VX_M1_E32, PseudoVREM_VX_M1_E32_TU, 0x3 }, // 1793
  { PseudoVREM_VX_M1_E64_MASK, PseudoVREM_VX_M1_E64, PseudoVREM_VX_M1_E64_TU, 0x3 }, // 1794
  { PseudoVREM_VX_M1_E8_MASK, PseudoVREM_VX_M1_E8, PseudoVREM_VX_M1_E8_TU, 0x3 }, // 1795
  { PseudoVREM_VX_M2_E16_MASK, PseudoVREM_VX_M2_E16, PseudoVREM_VX_M2_E16_TU, 0x3 }, // 1796
  { PseudoVREM_VX_M2_E32_MASK, PseudoVREM_VX_M2_E32, PseudoVREM_VX_M2_E32_TU, 0x3 }, // 1797
  { PseudoVREM_VX_M2_E64_MASK, PseudoVREM_VX_M2_E64, PseudoVREM_VX_M2_E64_TU, 0x3 }, // 1798
  { PseudoVREM_VX_M2_E8_MASK, PseudoVREM_VX_M2_E8, PseudoVREM_VX_M2_E8_TU, 0x3 }, // 1799
  { PseudoVREM_VX_M4_E16_MASK, PseudoVREM_VX_M4_E16, PseudoVREM_VX_M4_E16_TU, 0x3 }, // 1800
  { PseudoVREM_VX_M4_E32_MASK, PseudoVREM_VX_M4_E32, PseudoVREM_VX_M4_E32_TU, 0x3 }, // 1801
  { PseudoVREM_VX_M4_E64_MASK, PseudoVREM_VX_M4_E64, PseudoVREM_VX_M4_E64_TU, 0x3 }, // 1802
  { PseudoVREM_VX_M4_E8_MASK, PseudoVREM_VX_M4_E8, PseudoVREM_VX_M4_E8_TU, 0x3 }, // 1803
  { PseudoVREM_VX_M8_E16_MASK, PseudoVREM_VX_M8_E16, PseudoVREM_VX_M8_E16_TU, 0x3 }, // 1804
  { PseudoVREM_VX_M8_E32_MASK, PseudoVREM_VX_M8_E32, PseudoVREM_VX_M8_E32_TU, 0x3 }, // 1805
  { PseudoVREM_VX_M8_E64_MASK, PseudoVREM_VX_M8_E64, PseudoVREM_VX_M8_E64_TU, 0x3 }, // 1806
  { PseudoVREM_VX_M8_E8_MASK, PseudoVREM_VX_M8_E8, PseudoVREM_VX_M8_E8_TU, 0x3 }, // 1807
  { PseudoVREM_VX_MF2_E16_MASK, PseudoVREM_VX_MF2_E16, PseudoVREM_VX_MF2_E16_TU, 0x3 }, // 1808
  { PseudoVREM_VX_MF2_E32_MASK, PseudoVREM_VX_MF2_E32, PseudoVREM_VX_MF2_E32_TU, 0x3 }, // 1809
  { PseudoVREM_VX_MF2_E8_MASK, PseudoVREM_VX_MF2_E8, PseudoVREM_VX_MF2_E8_TU, 0x3 }, // 1810
  { PseudoVREM_VX_MF4_E16_MASK, PseudoVREM_VX_MF4_E16, PseudoVREM_VX_MF4_E16_TU, 0x3 }, // 1811
  { PseudoVREM_VX_MF4_E8_MASK, PseudoVREM_VX_MF4_E8, PseudoVREM_VX_MF4_E8_TU, 0x3 }, // 1812
  { PseudoVREM_VX_MF8_E8_MASK, PseudoVREM_VX_MF8_E8, PseudoVREM_VX_MF8_E8_TU, 0x3 }, // 1813
  { PseudoVRGATHEREI16_VV_M1_E16_M1_MASK, PseudoVRGATHEREI16_VV_M1_E16_M1, PseudoVRGATHEREI16_VV_M1_E16_M1_TU, 0x3 }, // 1814
  { PseudoVRGATHEREI16_VV_M1_E16_M2_MASK, PseudoVRGATHEREI16_VV_M1_E16_M2, PseudoVRGATHEREI16_VV_M1_E16_M2_TU, 0x3 }, // 1815
  { PseudoVRGATHEREI16_VV_M1_E16_MF2_MASK, PseudoVRGATHEREI16_VV_M1_E16_MF2, PseudoVRGATHEREI16_VV_M1_E16_MF2_TU, 0x3 }, // 1816
  { PseudoVRGATHEREI16_VV_M1_E16_MF4_MASK, PseudoVRGATHEREI16_VV_M1_E16_MF4, PseudoVRGATHEREI16_VV_M1_E16_MF4_TU, 0x3 }, // 1817
  { PseudoVRGATHEREI16_VV_M1_E32_M1_MASK, PseudoVRGATHEREI16_VV_M1_E32_M1, PseudoVRGATHEREI16_VV_M1_E32_M1_TU, 0x3 }, // 1818
  { PseudoVRGATHEREI16_VV_M1_E32_M2_MASK, PseudoVRGATHEREI16_VV_M1_E32_M2, PseudoVRGATHEREI16_VV_M1_E32_M2_TU, 0x3 }, // 1819
  { PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK, PseudoVRGATHEREI16_VV_M1_E32_MF2, PseudoVRGATHEREI16_VV_M1_E32_MF2_TU, 0x3 }, // 1820
  { PseudoVRGATHEREI16_VV_M1_E32_MF4_MASK, PseudoVRGATHEREI16_VV_M1_E32_MF4, PseudoVRGATHEREI16_VV_M1_E32_MF4_TU, 0x3 }, // 1821
  { PseudoVRGATHEREI16_VV_M1_E64_M1_MASK, PseudoVRGATHEREI16_VV_M1_E64_M1, PseudoVRGATHEREI16_VV_M1_E64_M1_TU, 0x3 }, // 1822
  { PseudoVRGATHEREI16_VV_M1_E64_M2_MASK, PseudoVRGATHEREI16_VV_M1_E64_M2, PseudoVRGATHEREI16_VV_M1_E64_M2_TU, 0x3 }, // 1823
  { PseudoVRGATHEREI16_VV_M1_E64_MF2_MASK, PseudoVRGATHEREI16_VV_M1_E64_MF2, PseudoVRGATHEREI16_VV_M1_E64_MF2_TU, 0x3 }, // 1824
  { PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK, PseudoVRGATHEREI16_VV_M1_E64_MF4, PseudoVRGATHEREI16_VV_M1_E64_MF4_TU, 0x3 }, // 1825
  { PseudoVRGATHEREI16_VV_M1_E8_M1_MASK, PseudoVRGATHEREI16_VV_M1_E8_M1, PseudoVRGATHEREI16_VV_M1_E8_M1_TU, 0x3 }, // 1826
  { PseudoVRGATHEREI16_VV_M1_E8_M2_MASK, PseudoVRGATHEREI16_VV_M1_E8_M2, PseudoVRGATHEREI16_VV_M1_E8_M2_TU, 0x3 }, // 1827
  { PseudoVRGATHEREI16_VV_M1_E8_MF2_MASK, PseudoVRGATHEREI16_VV_M1_E8_MF2, PseudoVRGATHEREI16_VV_M1_E8_MF2_TU, 0x3 }, // 1828
  { PseudoVRGATHEREI16_VV_M1_E8_MF4_MASK, PseudoVRGATHEREI16_VV_M1_E8_MF4, PseudoVRGATHEREI16_VV_M1_E8_MF4_TU, 0x3 }, // 1829
  { PseudoVRGATHEREI16_VV_M2_E16_M1_MASK, PseudoVRGATHEREI16_VV_M2_E16_M1, PseudoVRGATHEREI16_VV_M2_E16_M1_TU, 0x3 }, // 1830
  { PseudoVRGATHEREI16_VV_M2_E16_M2_MASK, PseudoVRGATHEREI16_VV_M2_E16_M2, PseudoVRGATHEREI16_VV_M2_E16_M2_TU, 0x3 }, // 1831
  { PseudoVRGATHEREI16_VV_M2_E16_M4_MASK, PseudoVRGATHEREI16_VV_M2_E16_M4, PseudoVRGATHEREI16_VV_M2_E16_M4_TU, 0x3 }, // 1832
  { PseudoVRGATHEREI16_VV_M2_E16_MF2_MASK, PseudoVRGATHEREI16_VV_M2_E16_MF2, PseudoVRGATHEREI16_VV_M2_E16_MF2_TU, 0x3 }, // 1833
  { PseudoVRGATHEREI16_VV_M2_E32_M1_MASK, PseudoVRGATHEREI16_VV_M2_E32_M1, PseudoVRGATHEREI16_VV_M2_E32_M1_TU, 0x3 }, // 1834
  { PseudoVRGATHEREI16_VV_M2_E32_M2_MASK, PseudoVRGATHEREI16_VV_M2_E32_M2, PseudoVRGATHEREI16_VV_M2_E32_M2_TU, 0x3 }, // 1835
  { PseudoVRGATHEREI16_VV_M2_E32_M4_MASK, PseudoVRGATHEREI16_VV_M2_E32_M4, PseudoVRGATHEREI16_VV_M2_E32_M4_TU, 0x3 }, // 1836
  { PseudoVRGATHEREI16_VV_M2_E32_MF2_MASK, PseudoVRGATHEREI16_VV_M2_E32_MF2, PseudoVRGATHEREI16_VV_M2_E32_MF2_TU, 0x3 }, // 1837
  { PseudoVRGATHEREI16_VV_M2_E64_M1_MASK, PseudoVRGATHEREI16_VV_M2_E64_M1, PseudoVRGATHEREI16_VV_M2_E64_M1_TU, 0x3 }, // 1838
  { PseudoVRGATHEREI16_VV_M2_E64_M2_MASK, PseudoVRGATHEREI16_VV_M2_E64_M2, PseudoVRGATHEREI16_VV_M2_E64_M2_TU, 0x3 }, // 1839
  { PseudoVRGATHEREI16_VV_M2_E64_M4_MASK, PseudoVRGATHEREI16_VV_M2_E64_M4, PseudoVRGATHEREI16_VV_M2_E64_M4_TU, 0x3 }, // 1840
  { PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK, PseudoVRGATHEREI16_VV_M2_E64_MF2, PseudoVRGATHEREI16_VV_M2_E64_MF2_TU, 0x3 }, // 1841
  { PseudoVRGATHEREI16_VV_M2_E8_M1_MASK, PseudoVRGATHEREI16_VV_M2_E8_M1, PseudoVRGATHEREI16_VV_M2_E8_M1_TU, 0x3 }, // 1842
  { PseudoVRGATHEREI16_VV_M2_E8_M2_MASK, PseudoVRGATHEREI16_VV_M2_E8_M2, PseudoVRGATHEREI16_VV_M2_E8_M2_TU, 0x3 }, // 1843
  { PseudoVRGATHEREI16_VV_M2_E8_M4_MASK, PseudoVRGATHEREI16_VV_M2_E8_M4, PseudoVRGATHEREI16_VV_M2_E8_M4_TU, 0x3 }, // 1844
  { PseudoVRGATHEREI16_VV_M2_E8_MF2_MASK, PseudoVRGATHEREI16_VV_M2_E8_MF2, PseudoVRGATHEREI16_VV_M2_E8_MF2_TU, 0x3 }, // 1845
  { PseudoVRGATHEREI16_VV_M4_E16_M1_MASK, PseudoVRGATHEREI16_VV_M4_E16_M1, PseudoVRGATHEREI16_VV_M4_E16_M1_TU, 0x3 }, // 1846
  { PseudoVRGATHEREI16_VV_M4_E16_M2_MASK, PseudoVRGATHEREI16_VV_M4_E16_M2, PseudoVRGATHEREI16_VV_M4_E16_M2_TU, 0x3 }, // 1847
  { PseudoVRGATHEREI16_VV_M4_E16_M4_MASK, PseudoVRGATHEREI16_VV_M4_E16_M4, PseudoVRGATHEREI16_VV_M4_E16_M4_TU, 0x3 }, // 1848
  { PseudoVRGATHEREI16_VV_M4_E16_M8_MASK, PseudoVRGATHEREI16_VV_M4_E16_M8, PseudoVRGATHEREI16_VV_M4_E16_M8_TU, 0x3 }, // 1849
  { PseudoVRGATHEREI16_VV_M4_E32_M1_MASK, PseudoVRGATHEREI16_VV_M4_E32_M1, PseudoVRGATHEREI16_VV_M4_E32_M1_TU, 0x3 }, // 1850
  { PseudoVRGATHEREI16_VV_M4_E32_M2_MASK, PseudoVRGATHEREI16_VV_M4_E32_M2, PseudoVRGATHEREI16_VV_M4_E32_M2_TU, 0x3 }, // 1851
  { PseudoVRGATHEREI16_VV_M4_E32_M4_MASK, PseudoVRGATHEREI16_VV_M4_E32_M4, PseudoVRGATHEREI16_VV_M4_E32_M4_TU, 0x3 }, // 1852
  { PseudoVRGATHEREI16_VV_M4_E32_M8_MASK, PseudoVRGATHEREI16_VV_M4_E32_M8, PseudoVRGATHEREI16_VV_M4_E32_M8_TU, 0x3 }, // 1853
  { PseudoVRGATHEREI16_VV_M4_E64_M1_MASK, PseudoVRGATHEREI16_VV_M4_E64_M1, PseudoVRGATHEREI16_VV_M4_E64_M1_TU, 0x3 }, // 1854
  { PseudoVRGATHEREI16_VV_M4_E64_M2_MASK, PseudoVRGATHEREI16_VV_M4_E64_M2, PseudoVRGATHEREI16_VV_M4_E64_M2_TU, 0x3 }, // 1855
  { PseudoVRGATHEREI16_VV_M4_E64_M4_MASK, PseudoVRGATHEREI16_VV_M4_E64_M4, PseudoVRGATHEREI16_VV_M4_E64_M4_TU, 0x3 }, // 1856
  { PseudoVRGATHEREI16_VV_M4_E64_M8_MASK, PseudoVRGATHEREI16_VV_M4_E64_M8, PseudoVRGATHEREI16_VV_M4_E64_M8_TU, 0x3 }, // 1857
  { PseudoVRGATHEREI16_VV_M4_E8_M1_MASK, PseudoVRGATHEREI16_VV_M4_E8_M1, PseudoVRGATHEREI16_VV_M4_E8_M1_TU, 0x3 }, // 1858
  { PseudoVRGATHEREI16_VV_M4_E8_M2_MASK, PseudoVRGATHEREI16_VV_M4_E8_M2, PseudoVRGATHEREI16_VV_M4_E8_M2_TU, 0x3 }, // 1859
  { PseudoVRGATHEREI16_VV_M4_E8_M4_MASK, PseudoVRGATHEREI16_VV_M4_E8_M4, PseudoVRGATHEREI16_VV_M4_E8_M4_TU, 0x3 }, // 1860
  { PseudoVRGATHEREI16_VV_M4_E8_M8_MASK, PseudoVRGATHEREI16_VV_M4_E8_M8, PseudoVRGATHEREI16_VV_M4_E8_M8_TU, 0x3 }, // 1861
  { PseudoVRGATHEREI16_VV_M8_E16_M2_MASK, PseudoVRGATHEREI16_VV_M8_E16_M2, PseudoVRGATHEREI16_VV_M8_E16_M2_TU, 0x3 }, // 1862
  { PseudoVRGATHEREI16_VV_M8_E16_M4_MASK, PseudoVRGATHEREI16_VV_M8_E16_M4, PseudoVRGATHEREI16_VV_M8_E16_M4_TU, 0x3 }, // 1863
  { PseudoVRGATHEREI16_VV_M8_E16_M8_MASK, PseudoVRGATHEREI16_VV_M8_E16_M8, PseudoVRGATHEREI16_VV_M8_E16_M8_TU, 0x3 }, // 1864
  { PseudoVRGATHEREI16_VV_M8_E32_M2_MASK, PseudoVRGATHEREI16_VV_M8_E32_M2, PseudoVRGATHEREI16_VV_M8_E32_M2_TU, 0x3 }, // 1865
  { PseudoVRGATHEREI16_VV_M8_E32_M4_MASK, PseudoVRGATHEREI16_VV_M8_E32_M4, PseudoVRGATHEREI16_VV_M8_E32_M4_TU, 0x3 }, // 1866
  { PseudoVRGATHEREI16_VV_M8_E32_M8_MASK, PseudoVRGATHEREI16_VV_M8_E32_M8, PseudoVRGATHEREI16_VV_M8_E32_M8_TU, 0x3 }, // 1867
  { PseudoVRGATHEREI16_VV_M8_E64_M2_MASK, PseudoVRGATHEREI16_VV_M8_E64_M2, PseudoVRGATHEREI16_VV_M8_E64_M2_TU, 0x3 }, // 1868
  { PseudoVRGATHEREI16_VV_M8_E64_M4_MASK, PseudoVRGATHEREI16_VV_M8_E64_M4, PseudoVRGATHEREI16_VV_M8_E64_M4_TU, 0x3 }, // 1869
  { PseudoVRGATHEREI16_VV_M8_E64_M8_MASK, PseudoVRGATHEREI16_VV_M8_E64_M8, PseudoVRGATHEREI16_VV_M8_E64_M8_TU, 0x3 }, // 1870
  { PseudoVRGATHEREI16_VV_M8_E8_M2_MASK, PseudoVRGATHEREI16_VV_M8_E8_M2, PseudoVRGATHEREI16_VV_M8_E8_M2_TU, 0x3 }, // 1871
  { PseudoVRGATHEREI16_VV_M8_E8_M4_MASK, PseudoVRGATHEREI16_VV_M8_E8_M4, PseudoVRGATHEREI16_VV_M8_E8_M4_TU, 0x3 }, // 1872
  { PseudoVRGATHEREI16_VV_M8_E8_M8_MASK, PseudoVRGATHEREI16_VV_M8_E8_M8, PseudoVRGATHEREI16_VV_M8_E8_M8_TU, 0x3 }, // 1873
  { PseudoVRGATHEREI16_VV_MF2_E16_M1_MASK, PseudoVRGATHEREI16_VV_MF2_E16_M1, PseudoVRGATHEREI16_VV_MF2_E16_M1_TU, 0x3 }, // 1874
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK, PseudoVRGATHEREI16_VV_MF2_E16_MF2, PseudoVRGATHEREI16_VV_MF2_E16_MF2_TU, 0x3 }, // 1875
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4_MASK, PseudoVRGATHEREI16_VV_MF2_E16_MF4, PseudoVRGATHEREI16_VV_MF2_E16_MF4_TU, 0x3 }, // 1876
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8_MASK, PseudoVRGATHEREI16_VV_MF2_E16_MF8, PseudoVRGATHEREI16_VV_MF2_E16_MF8_TU, 0x3 }, // 1877
  { PseudoVRGATHEREI16_VV_MF2_E32_M1_MASK, PseudoVRGATHEREI16_VV_MF2_E32_M1, PseudoVRGATHEREI16_VV_MF2_E32_M1_TU, 0x3 }, // 1878
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2_MASK, PseudoVRGATHEREI16_VV_MF2_E32_MF2, PseudoVRGATHEREI16_VV_MF2_E32_MF2_TU, 0x3 }, // 1879
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK, PseudoVRGATHEREI16_VV_MF2_E32_MF4, PseudoVRGATHEREI16_VV_MF2_E32_MF4_TU, 0x3 }, // 1880
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8_MASK, PseudoVRGATHEREI16_VV_MF2_E32_MF8, PseudoVRGATHEREI16_VV_MF2_E32_MF8_TU, 0x3 }, // 1881
  { PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK, PseudoVRGATHEREI16_VV_MF2_E8_M1, PseudoVRGATHEREI16_VV_MF2_E8_M1_TU, 0x3 }, // 1882
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2_MASK, PseudoVRGATHEREI16_VV_MF2_E8_MF2, PseudoVRGATHEREI16_VV_MF2_E8_MF2_TU, 0x3 }, // 1883
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4_MASK, PseudoVRGATHEREI16_VV_MF2_E8_MF4, PseudoVRGATHEREI16_VV_MF2_E8_MF4_TU, 0x3 }, // 1884
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8_MASK, PseudoVRGATHEREI16_VV_MF2_E8_MF8, PseudoVRGATHEREI16_VV_MF2_E8_MF8_TU, 0x3 }, // 1885
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2_MASK, PseudoVRGATHEREI16_VV_MF4_E16_MF2, PseudoVRGATHEREI16_VV_MF4_E16_MF2_TU, 0x3 }, // 1886
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK, PseudoVRGATHEREI16_VV_MF4_E16_MF4, PseudoVRGATHEREI16_VV_MF4_E16_MF4_TU, 0x3 }, // 1887
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8_MASK, PseudoVRGATHEREI16_VV_MF4_E16_MF8, PseudoVRGATHEREI16_VV_MF4_E16_MF8_TU, 0x3 }, // 1888
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK, PseudoVRGATHEREI16_VV_MF4_E8_MF2, PseudoVRGATHEREI16_VV_MF4_E8_MF2_TU, 0x3 }, // 1889
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4_MASK, PseudoVRGATHEREI16_VV_MF4_E8_MF4, PseudoVRGATHEREI16_VV_MF4_E8_MF4_TU, 0x3 }, // 1890
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8_MASK, PseudoVRGATHEREI16_VV_MF4_E8_MF8, PseudoVRGATHEREI16_VV_MF4_E8_MF8_TU, 0x3 }, // 1891
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK, PseudoVRGATHEREI16_VV_MF8_E8_MF4, PseudoVRGATHEREI16_VV_MF8_E8_MF4_TU, 0x3 }, // 1892
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8_MASK, PseudoVRGATHEREI16_VV_MF8_E8_MF8, PseudoVRGATHEREI16_VV_MF8_E8_MF8_TU, 0x3 }, // 1893
  { PseudoVRGATHER_VI_M1_MASK, PseudoVRGATHER_VI_M1, PseudoVRGATHER_VI_M1_TU, 0x3 }, // 1894
  { PseudoVRGATHER_VI_M2_MASK, PseudoVRGATHER_VI_M2, PseudoVRGATHER_VI_M2_TU, 0x3 }, // 1895
  { PseudoVRGATHER_VI_M4_MASK, PseudoVRGATHER_VI_M4, PseudoVRGATHER_VI_M4_TU, 0x3 }, // 1896
  { PseudoVRGATHER_VI_M8_MASK, PseudoVRGATHER_VI_M8, PseudoVRGATHER_VI_M8_TU, 0x3 }, // 1897
  { PseudoVRGATHER_VI_MF2_MASK, PseudoVRGATHER_VI_MF2, PseudoVRGATHER_VI_MF2_TU, 0x3 }, // 1898
  { PseudoVRGATHER_VI_MF4_MASK, PseudoVRGATHER_VI_MF4, PseudoVRGATHER_VI_MF4_TU, 0x3 }, // 1899
  { PseudoVRGATHER_VI_MF8_MASK, PseudoVRGATHER_VI_MF8, PseudoVRGATHER_VI_MF8_TU, 0x3 }, // 1900
  { PseudoVRGATHER_VV_M1_E16_MASK, PseudoVRGATHER_VV_M1_E16, PseudoVRGATHER_VV_M1_E16_TU, 0x3 }, // 1901
  { PseudoVRGATHER_VV_M1_E32_MASK, PseudoVRGATHER_VV_M1_E32, PseudoVRGATHER_VV_M1_E32_TU, 0x3 }, // 1902
  { PseudoVRGATHER_VV_M1_E64_MASK, PseudoVRGATHER_VV_M1_E64, PseudoVRGATHER_VV_M1_E64_TU, 0x3 }, // 1903
  { PseudoVRGATHER_VV_M1_E8_MASK, PseudoVRGATHER_VV_M1_E8, PseudoVRGATHER_VV_M1_E8_TU, 0x3 }, // 1904
  { PseudoVRGATHER_VV_M2_E16_MASK, PseudoVRGATHER_VV_M2_E16, PseudoVRGATHER_VV_M2_E16_TU, 0x3 }, // 1905
  { PseudoVRGATHER_VV_M2_E32_MASK, PseudoVRGATHER_VV_M2_E32, PseudoVRGATHER_VV_M2_E32_TU, 0x3 }, // 1906
  { PseudoVRGATHER_VV_M2_E64_MASK, PseudoVRGATHER_VV_M2_E64, PseudoVRGATHER_VV_M2_E64_TU, 0x3 }, // 1907
  { PseudoVRGATHER_VV_M2_E8_MASK, PseudoVRGATHER_VV_M2_E8, PseudoVRGATHER_VV_M2_E8_TU, 0x3 }, // 1908
  { PseudoVRGATHER_VV_M4_E16_MASK, PseudoVRGATHER_VV_M4_E16, PseudoVRGATHER_VV_M4_E16_TU, 0x3 }, // 1909
  { PseudoVRGATHER_VV_M4_E32_MASK, PseudoVRGATHER_VV_M4_E32, PseudoVRGATHER_VV_M4_E32_TU, 0x3 }, // 1910
  { PseudoVRGATHER_VV_M4_E64_MASK, PseudoVRGATHER_VV_M4_E64, PseudoVRGATHER_VV_M4_E64_TU, 0x3 }, // 1911
  { PseudoVRGATHER_VV_M4_E8_MASK, PseudoVRGATHER_VV_M4_E8, PseudoVRGATHER_VV_M4_E8_TU, 0x3 }, // 1912
  { PseudoVRGATHER_VV_M8_E16_MASK, PseudoVRGATHER_VV_M8_E16, PseudoVRGATHER_VV_M8_E16_TU, 0x3 }, // 1913
  { PseudoVRGATHER_VV_M8_E32_MASK, PseudoVRGATHER_VV_M8_E32, PseudoVRGATHER_VV_M8_E32_TU, 0x3 }, // 1914
  { PseudoVRGATHER_VV_M8_E64_MASK, PseudoVRGATHER_VV_M8_E64, PseudoVRGATHER_VV_M8_E64_TU, 0x3 }, // 1915
  { PseudoVRGATHER_VV_M8_E8_MASK, PseudoVRGATHER_VV_M8_E8, PseudoVRGATHER_VV_M8_E8_TU, 0x3 }, // 1916
  { PseudoVRGATHER_VV_MF2_E16_MASK, PseudoVRGATHER_VV_MF2_E16, PseudoVRGATHER_VV_MF2_E16_TU, 0x3 }, // 1917
  { PseudoVRGATHER_VV_MF2_E32_MASK, PseudoVRGATHER_VV_MF2_E32, PseudoVRGATHER_VV_MF2_E32_TU, 0x3 }, // 1918
  { PseudoVRGATHER_VV_MF2_E8_MASK, PseudoVRGATHER_VV_MF2_E8, PseudoVRGATHER_VV_MF2_E8_TU, 0x3 }, // 1919
  { PseudoVRGATHER_VV_MF4_E16_MASK, PseudoVRGATHER_VV_MF4_E16, PseudoVRGATHER_VV_MF4_E16_TU, 0x3 }, // 1920
  { PseudoVRGATHER_VV_MF4_E8_MASK, PseudoVRGATHER_VV_MF4_E8, PseudoVRGATHER_VV_MF4_E8_TU, 0x3 }, // 1921
  { PseudoVRGATHER_VV_MF8_E8_MASK, PseudoVRGATHER_VV_MF8_E8, PseudoVRGATHER_VV_MF8_E8_TU, 0x3 }, // 1922
  { PseudoVRGATHER_VX_M1_MASK, PseudoVRGATHER_VX_M1, PseudoVRGATHER_VX_M1_TU, 0x3 }, // 1923
  { PseudoVRGATHER_VX_M2_MASK, PseudoVRGATHER_VX_M2, PseudoVRGATHER_VX_M2_TU, 0x3 }, // 1924
  { PseudoVRGATHER_VX_M4_MASK, PseudoVRGATHER_VX_M4, PseudoVRGATHER_VX_M4_TU, 0x3 }, // 1925
  { PseudoVRGATHER_VX_M8_MASK, PseudoVRGATHER_VX_M8, PseudoVRGATHER_VX_M8_TU, 0x3 }, // 1926
  { PseudoVRGATHER_VX_MF2_MASK, PseudoVRGATHER_VX_MF2, PseudoVRGATHER_VX_MF2_TU, 0x3 }, // 1927
  { PseudoVRGATHER_VX_MF4_MASK, PseudoVRGATHER_VX_MF4, PseudoVRGATHER_VX_MF4_TU, 0x3 }, // 1928
  { PseudoVRGATHER_VX_MF8_MASK, PseudoVRGATHER_VX_MF8, PseudoVRGATHER_VX_MF8_TU, 0x3 }, // 1929
  { PseudoVRSUB_VI_M1_MASK, PseudoVRSUB_VI_M1, PseudoVRSUB_VI_M1_TU, 0x3 }, // 1930
  { PseudoVRSUB_VI_M2_MASK, PseudoVRSUB_VI_M2, PseudoVRSUB_VI_M2_TU, 0x3 }, // 1931
  { PseudoVRSUB_VI_M4_MASK, PseudoVRSUB_VI_M4, PseudoVRSUB_VI_M4_TU, 0x3 }, // 1932
  { PseudoVRSUB_VI_M8_MASK, PseudoVRSUB_VI_M8, PseudoVRSUB_VI_M8_TU, 0x3 }, // 1933
  { PseudoVRSUB_VI_MF2_MASK, PseudoVRSUB_VI_MF2, PseudoVRSUB_VI_MF2_TU, 0x3 }, // 1934
  { PseudoVRSUB_VI_MF4_MASK, PseudoVRSUB_VI_MF4, PseudoVRSUB_VI_MF4_TU, 0x3 }, // 1935
  { PseudoVRSUB_VI_MF8_MASK, PseudoVRSUB_VI_MF8, PseudoVRSUB_VI_MF8_TU, 0x3 }, // 1936
  { PseudoVRSUB_VX_M1_MASK, PseudoVRSUB_VX_M1, PseudoVRSUB_VX_M1_TU, 0x3 }, // 1937
  { PseudoVRSUB_VX_M2_MASK, PseudoVRSUB_VX_M2, PseudoVRSUB_VX_M2_TU, 0x3 }, // 1938
  { PseudoVRSUB_VX_M4_MASK, PseudoVRSUB_VX_M4, PseudoVRSUB_VX_M4_TU, 0x3 }, // 1939
  { PseudoVRSUB_VX_M8_MASK, PseudoVRSUB_VX_M8, PseudoVRSUB_VX_M8_TU, 0x3 }, // 1940
  { PseudoVRSUB_VX_MF2_MASK, PseudoVRSUB_VX_MF2, PseudoVRSUB_VX_MF2_TU, 0x3 }, // 1941
  { PseudoVRSUB_VX_MF4_MASK, PseudoVRSUB_VX_MF4, PseudoVRSUB_VX_MF4_TU, 0x3 }, // 1942
  { PseudoVRSUB_VX_MF8_MASK, PseudoVRSUB_VX_MF8, PseudoVRSUB_VX_MF8_TU, 0x3 }, // 1943
  { PseudoVSADDU_VI_M1_MASK, PseudoVSADDU_VI_M1, PseudoVSADDU_VI_M1_TU, 0x3 }, // 1944
  { PseudoVSADDU_VI_M2_MASK, PseudoVSADDU_VI_M2, PseudoVSADDU_VI_M2_TU, 0x3 }, // 1945
  { PseudoVSADDU_VI_M4_MASK, PseudoVSADDU_VI_M4, PseudoVSADDU_VI_M4_TU, 0x3 }, // 1946
  { PseudoVSADDU_VI_M8_MASK, PseudoVSADDU_VI_M8, PseudoVSADDU_VI_M8_TU, 0x3 }, // 1947
  { PseudoVSADDU_VI_MF2_MASK, PseudoVSADDU_VI_MF2, PseudoVSADDU_VI_MF2_TU, 0x3 }, // 1948
  { PseudoVSADDU_VI_MF4_MASK, PseudoVSADDU_VI_MF4, PseudoVSADDU_VI_MF4_TU, 0x3 }, // 1949
  { PseudoVSADDU_VI_MF8_MASK, PseudoVSADDU_VI_MF8, PseudoVSADDU_VI_MF8_TU, 0x3 }, // 1950
  { PseudoVSADDU_VV_M1_MASK, PseudoVSADDU_VV_M1, PseudoVSADDU_VV_M1_TU, 0x3 }, // 1951
  { PseudoVSADDU_VV_M2_MASK, PseudoVSADDU_VV_M2, PseudoVSADDU_VV_M2_TU, 0x3 }, // 1952
  { PseudoVSADDU_VV_M4_MASK, PseudoVSADDU_VV_M4, PseudoVSADDU_VV_M4_TU, 0x3 }, // 1953
  { PseudoVSADDU_VV_M8_MASK, PseudoVSADDU_VV_M8, PseudoVSADDU_VV_M8_TU, 0x3 }, // 1954
  { PseudoVSADDU_VV_MF2_MASK, PseudoVSADDU_VV_MF2, PseudoVSADDU_VV_MF2_TU, 0x3 }, // 1955
  { PseudoVSADDU_VV_MF4_MASK, PseudoVSADDU_VV_MF4, PseudoVSADDU_VV_MF4_TU, 0x3 }, // 1956
  { PseudoVSADDU_VV_MF8_MASK, PseudoVSADDU_VV_MF8, PseudoVSADDU_VV_MF8_TU, 0x3 }, // 1957
  { PseudoVSADDU_VX_M1_MASK, PseudoVSADDU_VX_M1, PseudoVSADDU_VX_M1_TU, 0x3 }, // 1958
  { PseudoVSADDU_VX_M2_MASK, PseudoVSADDU_VX_M2, PseudoVSADDU_VX_M2_TU, 0x3 }, // 1959
  { PseudoVSADDU_VX_M4_MASK, PseudoVSADDU_VX_M4, PseudoVSADDU_VX_M4_TU, 0x3 }, // 1960
  { PseudoVSADDU_VX_M8_MASK, PseudoVSADDU_VX_M8, PseudoVSADDU_VX_M8_TU, 0x3 }, // 1961
  { PseudoVSADDU_VX_MF2_MASK, PseudoVSADDU_VX_MF2, PseudoVSADDU_VX_MF2_TU, 0x3 }, // 1962
  { PseudoVSADDU_VX_MF4_MASK, PseudoVSADDU_VX_MF4, PseudoVSADDU_VX_MF4_TU, 0x3 }, // 1963
  { PseudoVSADDU_VX_MF8_MASK, PseudoVSADDU_VX_MF8, PseudoVSADDU_VX_MF8_TU, 0x3 }, // 1964
  { PseudoVSADD_VI_M1_MASK, PseudoVSADD_VI_M1, PseudoVSADD_VI_M1_TU, 0x3 }, // 1965
  { PseudoVSADD_VI_M2_MASK, PseudoVSADD_VI_M2, PseudoVSADD_VI_M2_TU, 0x3 }, // 1966
  { PseudoVSADD_VI_M4_MASK, PseudoVSADD_VI_M4, PseudoVSADD_VI_M4_TU, 0x3 }, // 1967
  { PseudoVSADD_VI_M8_MASK, PseudoVSADD_VI_M8, PseudoVSADD_VI_M8_TU, 0x3 }, // 1968
  { PseudoVSADD_VI_MF2_MASK, PseudoVSADD_VI_MF2, PseudoVSADD_VI_MF2_TU, 0x3 }, // 1969
  { PseudoVSADD_VI_MF4_MASK, PseudoVSADD_VI_MF4, PseudoVSADD_VI_MF4_TU, 0x3 }, // 1970
  { PseudoVSADD_VI_MF8_MASK, PseudoVSADD_VI_MF8, PseudoVSADD_VI_MF8_TU, 0x3 }, // 1971
  { PseudoVSADD_VV_M1_MASK, PseudoVSADD_VV_M1, PseudoVSADD_VV_M1_TU, 0x3 }, // 1972
  { PseudoVSADD_VV_M2_MASK, PseudoVSADD_VV_M2, PseudoVSADD_VV_M2_TU, 0x3 }, // 1973
  { PseudoVSADD_VV_M4_MASK, PseudoVSADD_VV_M4, PseudoVSADD_VV_M4_TU, 0x3 }, // 1974
  { PseudoVSADD_VV_M8_MASK, PseudoVSADD_VV_M8, PseudoVSADD_VV_M8_TU, 0x3 }, // 1975
  { PseudoVSADD_VV_MF2_MASK, PseudoVSADD_VV_MF2, PseudoVSADD_VV_MF2_TU, 0x3 }, // 1976
  { PseudoVSADD_VV_MF4_MASK, PseudoVSADD_VV_MF4, PseudoVSADD_VV_MF4_TU, 0x3 }, // 1977
  { PseudoVSADD_VV_MF8_MASK, PseudoVSADD_VV_MF8, PseudoVSADD_VV_MF8_TU, 0x3 }, // 1978
  { PseudoVSADD_VX_M1_MASK, PseudoVSADD_VX_M1, PseudoVSADD_VX_M1_TU, 0x3 }, // 1979
  { PseudoVSADD_VX_M2_MASK, PseudoVSADD_VX_M2, PseudoVSADD_VX_M2_TU, 0x3 }, // 1980
  { PseudoVSADD_VX_M4_MASK, PseudoVSADD_VX_M4, PseudoVSADD_VX_M4_TU, 0x3 }, // 1981
  { PseudoVSADD_VX_M8_MASK, PseudoVSADD_VX_M8, PseudoVSADD_VX_M8_TU, 0x3 }, // 1982
  { PseudoVSADD_VX_MF2_MASK, PseudoVSADD_VX_MF2, PseudoVSADD_VX_MF2_TU, 0x3 }, // 1983
  { PseudoVSADD_VX_MF4_MASK, PseudoVSADD_VX_MF4, PseudoVSADD_VX_MF4_TU, 0x3 }, // 1984
  { PseudoVSADD_VX_MF8_MASK, PseudoVSADD_VX_MF8, PseudoVSADD_VX_MF8_TU, 0x3 }, // 1985
  { PseudoVSEXT_VF2_M1_MASK, PseudoVSEXT_VF2_M1, PseudoVSEXT_VF2_M1_TU, 0x2 }, // 1986
  { PseudoVSEXT_VF2_M2_MASK, PseudoVSEXT_VF2_M2, PseudoVSEXT_VF2_M2_TU, 0x2 }, // 1987
  { PseudoVSEXT_VF2_M4_MASK, PseudoVSEXT_VF2_M4, PseudoVSEXT_VF2_M4_TU, 0x2 }, // 1988
  { PseudoVSEXT_VF2_M8_MASK, PseudoVSEXT_VF2_M8, PseudoVSEXT_VF2_M8_TU, 0x2 }, // 1989
  { PseudoVSEXT_VF2_MF2_MASK, PseudoVSEXT_VF2_MF2, PseudoVSEXT_VF2_MF2_TU, 0x2 }, // 1990
  { PseudoVSEXT_VF2_MF4_MASK, PseudoVSEXT_VF2_MF4, PseudoVSEXT_VF2_MF4_TU, 0x2 }, // 1991
  { PseudoVSEXT_VF4_M1_MASK, PseudoVSEXT_VF4_M1, PseudoVSEXT_VF4_M1_TU, 0x2 }, // 1992
  { PseudoVSEXT_VF4_M2_MASK, PseudoVSEXT_VF4_M2, PseudoVSEXT_VF4_M2_TU, 0x2 }, // 1993
  { PseudoVSEXT_VF4_M4_MASK, PseudoVSEXT_VF4_M4, PseudoVSEXT_VF4_M4_TU, 0x2 }, // 1994
  { PseudoVSEXT_VF4_M8_MASK, PseudoVSEXT_VF4_M8, PseudoVSEXT_VF4_M8_TU, 0x2 }, // 1995
  { PseudoVSEXT_VF4_MF2_MASK, PseudoVSEXT_VF4_MF2, PseudoVSEXT_VF4_MF2_TU, 0x2 }, // 1996
  { PseudoVSEXT_VF8_M1_MASK, PseudoVSEXT_VF8_M1, PseudoVSEXT_VF8_M1_TU, 0x2 }, // 1997
  { PseudoVSEXT_VF8_M2_MASK, PseudoVSEXT_VF8_M2, PseudoVSEXT_VF8_M2_TU, 0x2 }, // 1998
  { PseudoVSEXT_VF8_M4_MASK, PseudoVSEXT_VF8_M4, PseudoVSEXT_VF8_M4_TU, 0x2 }, // 1999
  { PseudoVSEXT_VF8_M8_MASK, PseudoVSEXT_VF8_M8, PseudoVSEXT_VF8_M8_TU, 0x2 }, // 2000
  { PseudoVSLIDE1DOWN_VX_M1_MASK, PseudoVSLIDE1DOWN_VX_M1, PseudoVSLIDE1DOWN_VX_M1_TU, 0x3 }, // 2001
  { PseudoVSLIDE1DOWN_VX_M2_MASK, PseudoVSLIDE1DOWN_VX_M2, PseudoVSLIDE1DOWN_VX_M2_TU, 0x3 }, // 2002
  { PseudoVSLIDE1DOWN_VX_M4_MASK, PseudoVSLIDE1DOWN_VX_M4, PseudoVSLIDE1DOWN_VX_M4_TU, 0x3 }, // 2003
  { PseudoVSLIDE1DOWN_VX_M8_MASK, PseudoVSLIDE1DOWN_VX_M8, PseudoVSLIDE1DOWN_VX_M8_TU, 0x3 }, // 2004
  { PseudoVSLIDE1DOWN_VX_MF2_MASK, PseudoVSLIDE1DOWN_VX_MF2, PseudoVSLIDE1DOWN_VX_MF2_TU, 0x3 }, // 2005
  { PseudoVSLIDE1DOWN_VX_MF4_MASK, PseudoVSLIDE1DOWN_VX_MF4, PseudoVSLIDE1DOWN_VX_MF4_TU, 0x3 }, // 2006
  { PseudoVSLIDE1DOWN_VX_MF8_MASK, PseudoVSLIDE1DOWN_VX_MF8, PseudoVSLIDE1DOWN_VX_MF8_TU, 0x3 }, // 2007
  { PseudoVSLIDE1UP_VX_M1_MASK, PseudoVSLIDE1UP_VX_M1, PseudoVSLIDE1UP_VX_M1_TU, 0x3 }, // 2008
  { PseudoVSLIDE1UP_VX_M2_MASK, PseudoVSLIDE1UP_VX_M2, PseudoVSLIDE1UP_VX_M2_TU, 0x3 }, // 2009
  { PseudoVSLIDE1UP_VX_M4_MASK, PseudoVSLIDE1UP_VX_M4, PseudoVSLIDE1UP_VX_M4_TU, 0x3 }, // 2010
  { PseudoVSLIDE1UP_VX_M8_MASK, PseudoVSLIDE1UP_VX_M8, PseudoVSLIDE1UP_VX_M8_TU, 0x3 }, // 2011
  { PseudoVSLIDE1UP_VX_MF2_MASK, PseudoVSLIDE1UP_VX_MF2, PseudoVSLIDE1UP_VX_MF2_TU, 0x3 }, // 2012
  { PseudoVSLIDE1UP_VX_MF4_MASK, PseudoVSLIDE1UP_VX_MF4, PseudoVSLIDE1UP_VX_MF4_TU, 0x3 }, // 2013
  { PseudoVSLIDE1UP_VX_MF8_MASK, PseudoVSLIDE1UP_VX_MF8, PseudoVSLIDE1UP_VX_MF8_TU, 0x3 }, // 2014
  { PseudoVSLIDEDOWN_VI_M1_MASK, PseudoVSLIDEDOWN_VI_M1, PseudoVSLIDEDOWN_VI_M1, 0x3 }, // 2015
  { PseudoVSLIDEDOWN_VI_M2_MASK, PseudoVSLIDEDOWN_VI_M2, PseudoVSLIDEDOWN_VI_M2, 0x3 }, // 2016
  { PseudoVSLIDEDOWN_VI_M4_MASK, PseudoVSLIDEDOWN_VI_M4, PseudoVSLIDEDOWN_VI_M4, 0x3 }, // 2017
  { PseudoVSLIDEDOWN_VI_M8_MASK, PseudoVSLIDEDOWN_VI_M8, PseudoVSLIDEDOWN_VI_M8, 0x3 }, // 2018
  { PseudoVSLIDEDOWN_VI_MF2_MASK, PseudoVSLIDEDOWN_VI_MF2, PseudoVSLIDEDOWN_VI_MF2, 0x3 }, // 2019
  { PseudoVSLIDEDOWN_VI_MF4_MASK, PseudoVSLIDEDOWN_VI_MF4, PseudoVSLIDEDOWN_VI_MF4, 0x3 }, // 2020
  { PseudoVSLIDEDOWN_VI_MF8_MASK, PseudoVSLIDEDOWN_VI_MF8, PseudoVSLIDEDOWN_VI_MF8, 0x3 }, // 2021
  { PseudoVSLIDEDOWN_VX_M1_MASK, PseudoVSLIDEDOWN_VX_M1, PseudoVSLIDEDOWN_VX_M1, 0x3 }, // 2022
  { PseudoVSLIDEDOWN_VX_M2_MASK, PseudoVSLIDEDOWN_VX_M2, PseudoVSLIDEDOWN_VX_M2, 0x3 }, // 2023
  { PseudoVSLIDEDOWN_VX_M4_MASK, PseudoVSLIDEDOWN_VX_M4, PseudoVSLIDEDOWN_VX_M4, 0x3 }, // 2024
  { PseudoVSLIDEDOWN_VX_M8_MASK, PseudoVSLIDEDOWN_VX_M8, PseudoVSLIDEDOWN_VX_M8, 0x3 }, // 2025
  { PseudoVSLIDEDOWN_VX_MF2_MASK, PseudoVSLIDEDOWN_VX_MF2, PseudoVSLIDEDOWN_VX_MF2, 0x3 }, // 2026
  { PseudoVSLIDEDOWN_VX_MF4_MASK, PseudoVSLIDEDOWN_VX_MF4, PseudoVSLIDEDOWN_VX_MF4, 0x3 }, // 2027
  { PseudoVSLIDEDOWN_VX_MF8_MASK, PseudoVSLIDEDOWN_VX_MF8, PseudoVSLIDEDOWN_VX_MF8, 0x3 }, // 2028
  { PseudoVSLIDEUP_VI_M1_MASK, PseudoVSLIDEUP_VI_M1, PseudoVSLIDEUP_VI_M1, 0x3 }, // 2029
  { PseudoVSLIDEUP_VI_M2_MASK, PseudoVSLIDEUP_VI_M2, PseudoVSLIDEUP_VI_M2, 0x3 }, // 2030
  { PseudoVSLIDEUP_VI_M4_MASK, PseudoVSLIDEUP_VI_M4, PseudoVSLIDEUP_VI_M4, 0x3 }, // 2031
  { PseudoVSLIDEUP_VI_M8_MASK, PseudoVSLIDEUP_VI_M8, PseudoVSLIDEUP_VI_M8, 0x3 }, // 2032
  { PseudoVSLIDEUP_VI_MF2_MASK, PseudoVSLIDEUP_VI_MF2, PseudoVSLIDEUP_VI_MF2, 0x3 }, // 2033
  { PseudoVSLIDEUP_VI_MF4_MASK, PseudoVSLIDEUP_VI_MF4, PseudoVSLIDEUP_VI_MF4, 0x3 }, // 2034
  { PseudoVSLIDEUP_VI_MF8_MASK, PseudoVSLIDEUP_VI_MF8, PseudoVSLIDEUP_VI_MF8, 0x3 }, // 2035
  { PseudoVSLIDEUP_VX_M1_MASK, PseudoVSLIDEUP_VX_M1, PseudoVSLIDEUP_VX_M1, 0x3 }, // 2036
  { PseudoVSLIDEUP_VX_M2_MASK, PseudoVSLIDEUP_VX_M2, PseudoVSLIDEUP_VX_M2, 0x3 }, // 2037
  { PseudoVSLIDEUP_VX_M4_MASK, PseudoVSLIDEUP_VX_M4, PseudoVSLIDEUP_VX_M4, 0x3 }, // 2038
  { PseudoVSLIDEUP_VX_M8_MASK, PseudoVSLIDEUP_VX_M8, PseudoVSLIDEUP_VX_M8, 0x3 }, // 2039
  { PseudoVSLIDEUP_VX_MF2_MASK, PseudoVSLIDEUP_VX_MF2, PseudoVSLIDEUP_VX_MF2, 0x3 }, // 2040
  { PseudoVSLIDEUP_VX_MF4_MASK, PseudoVSLIDEUP_VX_MF4, PseudoVSLIDEUP_VX_MF4, 0x3 }, // 2041
  { PseudoVSLIDEUP_VX_MF8_MASK, PseudoVSLIDEUP_VX_MF8, PseudoVSLIDEUP_VX_MF8, 0x3 }, // 2042
  { PseudoVSLL_VI_M1_MASK, PseudoVSLL_VI_M1, PseudoVSLL_VI_M1_TU, 0x3 }, // 2043
  { PseudoVSLL_VI_M2_MASK, PseudoVSLL_VI_M2, PseudoVSLL_VI_M2_TU, 0x3 }, // 2044
  { PseudoVSLL_VI_M4_MASK, PseudoVSLL_VI_M4, PseudoVSLL_VI_M4_TU, 0x3 }, // 2045
  { PseudoVSLL_VI_M8_MASK, PseudoVSLL_VI_M8, PseudoVSLL_VI_M8_TU, 0x3 }, // 2046
  { PseudoVSLL_VI_MF2_MASK, PseudoVSLL_VI_MF2, PseudoVSLL_VI_MF2_TU, 0x3 }, // 2047
  { PseudoVSLL_VI_MF4_MASK, PseudoVSLL_VI_MF4, PseudoVSLL_VI_MF4_TU, 0x3 }, // 2048
  { PseudoVSLL_VI_MF8_MASK, PseudoVSLL_VI_MF8, PseudoVSLL_VI_MF8_TU, 0x3 }, // 2049
  { PseudoVSLL_VV_M1_MASK, PseudoVSLL_VV_M1, PseudoVSLL_VV_M1_TU, 0x3 }, // 2050
  { PseudoVSLL_VV_M2_MASK, PseudoVSLL_VV_M2, PseudoVSLL_VV_M2_TU, 0x3 }, // 2051
  { PseudoVSLL_VV_M4_MASK, PseudoVSLL_VV_M4, PseudoVSLL_VV_M4_TU, 0x3 }, // 2052
  { PseudoVSLL_VV_M8_MASK, PseudoVSLL_VV_M8, PseudoVSLL_VV_M8_TU, 0x3 }, // 2053
  { PseudoVSLL_VV_MF2_MASK, PseudoVSLL_VV_MF2, PseudoVSLL_VV_MF2_TU, 0x3 }, // 2054
  { PseudoVSLL_VV_MF4_MASK, PseudoVSLL_VV_MF4, PseudoVSLL_VV_MF4_TU, 0x3 }, // 2055
  { PseudoVSLL_VV_MF8_MASK, PseudoVSLL_VV_MF8, PseudoVSLL_VV_MF8_TU, 0x3 }, // 2056
  { PseudoVSLL_VX_M1_MASK, PseudoVSLL_VX_M1, PseudoVSLL_VX_M1_TU, 0x3 }, // 2057
  { PseudoVSLL_VX_M2_MASK, PseudoVSLL_VX_M2, PseudoVSLL_VX_M2_TU, 0x3 }, // 2058
  { PseudoVSLL_VX_M4_MASK, PseudoVSLL_VX_M4, PseudoVSLL_VX_M4_TU, 0x3 }, // 2059
  { PseudoVSLL_VX_M8_MASK, PseudoVSLL_VX_M8, PseudoVSLL_VX_M8_TU, 0x3 }, // 2060
  { PseudoVSLL_VX_MF2_MASK, PseudoVSLL_VX_MF2, PseudoVSLL_VX_MF2_TU, 0x3 }, // 2061
  { PseudoVSLL_VX_MF4_MASK, PseudoVSLL_VX_MF4, PseudoVSLL_VX_MF4_TU, 0x3 }, // 2062
  { PseudoVSLL_VX_MF8_MASK, PseudoVSLL_VX_MF8, PseudoVSLL_VX_MF8_TU, 0x3 }, // 2063
  { PseudoVSMUL_VV_M1_MASK, PseudoVSMUL_VV_M1, PseudoVSMUL_VV_M1_TU, 0x3 }, // 2064
  { PseudoVSMUL_VV_M2_MASK, PseudoVSMUL_VV_M2, PseudoVSMUL_VV_M2_TU, 0x3 }, // 2065
  { PseudoVSMUL_VV_M4_MASK, PseudoVSMUL_VV_M4, PseudoVSMUL_VV_M4_TU, 0x3 }, // 2066
  { PseudoVSMUL_VV_M8_MASK, PseudoVSMUL_VV_M8, PseudoVSMUL_VV_M8_TU, 0x3 }, // 2067
  { PseudoVSMUL_VV_MF2_MASK, PseudoVSMUL_VV_MF2, PseudoVSMUL_VV_MF2_TU, 0x3 }, // 2068
  { PseudoVSMUL_VV_MF4_MASK, PseudoVSMUL_VV_MF4, PseudoVSMUL_VV_MF4_TU, 0x3 }, // 2069
  { PseudoVSMUL_VV_MF8_MASK, PseudoVSMUL_VV_MF8, PseudoVSMUL_VV_MF8_TU, 0x3 }, // 2070
  { PseudoVSMUL_VX_M1_MASK, PseudoVSMUL_VX_M1, PseudoVSMUL_VX_M1_TU, 0x3 }, // 2071
  { PseudoVSMUL_VX_M2_MASK, PseudoVSMUL_VX_M2, PseudoVSMUL_VX_M2_TU, 0x3 }, // 2072
  { PseudoVSMUL_VX_M4_MASK, PseudoVSMUL_VX_M4, PseudoVSMUL_VX_M4_TU, 0x3 }, // 2073
  { PseudoVSMUL_VX_M8_MASK, PseudoVSMUL_VX_M8, PseudoVSMUL_VX_M8_TU, 0x3 }, // 2074
  { PseudoVSMUL_VX_MF2_MASK, PseudoVSMUL_VX_MF2, PseudoVSMUL_VX_MF2_TU, 0x3 }, // 2075
  { PseudoVSMUL_VX_MF4_MASK, PseudoVSMUL_VX_MF4, PseudoVSMUL_VX_MF4_TU, 0x3 }, // 2076
  { PseudoVSMUL_VX_MF8_MASK, PseudoVSMUL_VX_MF8, PseudoVSMUL_VX_MF8_TU, 0x3 }, // 2077
  { PseudoVSRA_VI_M1_MASK, PseudoVSRA_VI_M1, PseudoVSRA_VI_M1_TU, 0x3 }, // 2078
  { PseudoVSRA_VI_M2_MASK, PseudoVSRA_VI_M2, PseudoVSRA_VI_M2_TU, 0x3 }, // 2079
  { PseudoVSRA_VI_M4_MASK, PseudoVSRA_VI_M4, PseudoVSRA_VI_M4_TU, 0x3 }, // 2080
  { PseudoVSRA_VI_M8_MASK, PseudoVSRA_VI_M8, PseudoVSRA_VI_M8_TU, 0x3 }, // 2081
  { PseudoVSRA_VI_MF2_MASK, PseudoVSRA_VI_MF2, PseudoVSRA_VI_MF2_TU, 0x3 }, // 2082
  { PseudoVSRA_VI_MF4_MASK, PseudoVSRA_VI_MF4, PseudoVSRA_VI_MF4_TU, 0x3 }, // 2083
  { PseudoVSRA_VI_MF8_MASK, PseudoVSRA_VI_MF8, PseudoVSRA_VI_MF8_TU, 0x3 }, // 2084
  { PseudoVSRA_VV_M1_MASK, PseudoVSRA_VV_M1, PseudoVSRA_VV_M1_TU, 0x3 }, // 2085
  { PseudoVSRA_VV_M2_MASK, PseudoVSRA_VV_M2, PseudoVSRA_VV_M2_TU, 0x3 }, // 2086
  { PseudoVSRA_VV_M4_MASK, PseudoVSRA_VV_M4, PseudoVSRA_VV_M4_TU, 0x3 }, // 2087
  { PseudoVSRA_VV_M8_MASK, PseudoVSRA_VV_M8, PseudoVSRA_VV_M8_TU, 0x3 }, // 2088
  { PseudoVSRA_VV_MF2_MASK, PseudoVSRA_VV_MF2, PseudoVSRA_VV_MF2_TU, 0x3 }, // 2089
  { PseudoVSRA_VV_MF4_MASK, PseudoVSRA_VV_MF4, PseudoVSRA_VV_MF4_TU, 0x3 }, // 2090
  { PseudoVSRA_VV_MF8_MASK, PseudoVSRA_VV_MF8, PseudoVSRA_VV_MF8_TU, 0x3 }, // 2091
  { PseudoVSRA_VX_M1_MASK, PseudoVSRA_VX_M1, PseudoVSRA_VX_M1_TU, 0x3 }, // 2092
  { PseudoVSRA_VX_M2_MASK, PseudoVSRA_VX_M2, PseudoVSRA_VX_M2_TU, 0x3 }, // 2093
  { PseudoVSRA_VX_M4_MASK, PseudoVSRA_VX_M4, PseudoVSRA_VX_M4_TU, 0x3 }, // 2094
  { PseudoVSRA_VX_M8_MASK, PseudoVSRA_VX_M8, PseudoVSRA_VX_M8_TU, 0x3 }, // 2095
  { PseudoVSRA_VX_MF2_MASK, PseudoVSRA_VX_MF2, PseudoVSRA_VX_MF2_TU, 0x3 }, // 2096
  { PseudoVSRA_VX_MF4_MASK, PseudoVSRA_VX_MF4, PseudoVSRA_VX_MF4_TU, 0x3 }, // 2097
  { PseudoVSRA_VX_MF8_MASK, PseudoVSRA_VX_MF8, PseudoVSRA_VX_MF8_TU, 0x3 }, // 2098
  { PseudoVSRL_VI_M1_MASK, PseudoVSRL_VI_M1, PseudoVSRL_VI_M1_TU, 0x3 }, // 2099
  { PseudoVSRL_VI_M2_MASK, PseudoVSRL_VI_M2, PseudoVSRL_VI_M2_TU, 0x3 }, // 2100
  { PseudoVSRL_VI_M4_MASK, PseudoVSRL_VI_M4, PseudoVSRL_VI_M4_TU, 0x3 }, // 2101
  { PseudoVSRL_VI_M8_MASK, PseudoVSRL_VI_M8, PseudoVSRL_VI_M8_TU, 0x3 }, // 2102
  { PseudoVSRL_VI_MF2_MASK, PseudoVSRL_VI_MF2, PseudoVSRL_VI_MF2_TU, 0x3 }, // 2103
  { PseudoVSRL_VI_MF4_MASK, PseudoVSRL_VI_MF4, PseudoVSRL_VI_MF4_TU, 0x3 }, // 2104
  { PseudoVSRL_VI_MF8_MASK, PseudoVSRL_VI_MF8, PseudoVSRL_VI_MF8_TU, 0x3 }, // 2105
  { PseudoVSRL_VV_M1_MASK, PseudoVSRL_VV_M1, PseudoVSRL_VV_M1_TU, 0x3 }, // 2106
  { PseudoVSRL_VV_M2_MASK, PseudoVSRL_VV_M2, PseudoVSRL_VV_M2_TU, 0x3 }, // 2107
  { PseudoVSRL_VV_M4_MASK, PseudoVSRL_VV_M4, PseudoVSRL_VV_M4_TU, 0x3 }, // 2108
  { PseudoVSRL_VV_M8_MASK, PseudoVSRL_VV_M8, PseudoVSRL_VV_M8_TU, 0x3 }, // 2109
  { PseudoVSRL_VV_MF2_MASK, PseudoVSRL_VV_MF2, PseudoVSRL_VV_MF2_TU, 0x3 }, // 2110
  { PseudoVSRL_VV_MF4_MASK, PseudoVSRL_VV_MF4, PseudoVSRL_VV_MF4_TU, 0x3 }, // 2111
  { PseudoVSRL_VV_MF8_MASK, PseudoVSRL_VV_MF8, PseudoVSRL_VV_MF8_TU, 0x3 }, // 2112
  { PseudoVSRL_VX_M1_MASK, PseudoVSRL_VX_M1, PseudoVSRL_VX_M1_TU, 0x3 }, // 2113
  { PseudoVSRL_VX_M2_MASK, PseudoVSRL_VX_M2, PseudoVSRL_VX_M2_TU, 0x3 }, // 2114
  { PseudoVSRL_VX_M4_MASK, PseudoVSRL_VX_M4, PseudoVSRL_VX_M4_TU, 0x3 }, // 2115
  { PseudoVSRL_VX_M8_MASK, PseudoVSRL_VX_M8, PseudoVSRL_VX_M8_TU, 0x3 }, // 2116
  { PseudoVSRL_VX_MF2_MASK, PseudoVSRL_VX_MF2, PseudoVSRL_VX_MF2_TU, 0x3 }, // 2117
  { PseudoVSRL_VX_MF4_MASK, PseudoVSRL_VX_MF4, PseudoVSRL_VX_MF4_TU, 0x3 }, // 2118
  { PseudoVSRL_VX_MF8_MASK, PseudoVSRL_VX_MF8, PseudoVSRL_VX_MF8_TU, 0x3 }, // 2119
  { PseudoVSSRA_VI_M1_MASK, PseudoVSSRA_VI_M1, PseudoVSSRA_VI_M1_TU, 0x3 }, // 2120
  { PseudoVSSRA_VI_M2_MASK, PseudoVSSRA_VI_M2, PseudoVSSRA_VI_M2_TU, 0x3 }, // 2121
  { PseudoVSSRA_VI_M4_MASK, PseudoVSSRA_VI_M4, PseudoVSSRA_VI_M4_TU, 0x3 }, // 2122
  { PseudoVSSRA_VI_M8_MASK, PseudoVSSRA_VI_M8, PseudoVSSRA_VI_M8_TU, 0x3 }, // 2123
  { PseudoVSSRA_VI_MF2_MASK, PseudoVSSRA_VI_MF2, PseudoVSSRA_VI_MF2_TU, 0x3 }, // 2124
  { PseudoVSSRA_VI_MF4_MASK, PseudoVSSRA_VI_MF4, PseudoVSSRA_VI_MF4_TU, 0x3 }, // 2125
  { PseudoVSSRA_VI_MF8_MASK, PseudoVSSRA_VI_MF8, PseudoVSSRA_VI_MF8_TU, 0x3 }, // 2126
  { PseudoVSSRA_VV_M1_MASK, PseudoVSSRA_VV_M1, PseudoVSSRA_VV_M1_TU, 0x3 }, // 2127
  { PseudoVSSRA_VV_M2_MASK, PseudoVSSRA_VV_M2, PseudoVSSRA_VV_M2_TU, 0x3 }, // 2128
  { PseudoVSSRA_VV_M4_MASK, PseudoVSSRA_VV_M4, PseudoVSSRA_VV_M4_TU, 0x3 }, // 2129
  { PseudoVSSRA_VV_M8_MASK, PseudoVSSRA_VV_M8, PseudoVSSRA_VV_M8_TU, 0x3 }, // 2130
  { PseudoVSSRA_VV_MF2_MASK, PseudoVSSRA_VV_MF2, PseudoVSSRA_VV_MF2_TU, 0x3 }, // 2131
  { PseudoVSSRA_VV_MF4_MASK, PseudoVSSRA_VV_MF4, PseudoVSSRA_VV_MF4_TU, 0x3 }, // 2132
  { PseudoVSSRA_VV_MF8_MASK, PseudoVSSRA_VV_MF8, PseudoVSSRA_VV_MF8_TU, 0x3 }, // 2133
  { PseudoVSSRA_VX_M1_MASK, PseudoVSSRA_VX_M1, PseudoVSSRA_VX_M1_TU, 0x3 }, // 2134
  { PseudoVSSRA_VX_M2_MASK, PseudoVSSRA_VX_M2, PseudoVSSRA_VX_M2_TU, 0x3 }, // 2135
  { PseudoVSSRA_VX_M4_MASK, PseudoVSSRA_VX_M4, PseudoVSSRA_VX_M4_TU, 0x3 }, // 2136
  { PseudoVSSRA_VX_M8_MASK, PseudoVSSRA_VX_M8, PseudoVSSRA_VX_M8_TU, 0x3 }, // 2137
  { PseudoVSSRA_VX_MF2_MASK, PseudoVSSRA_VX_MF2, PseudoVSSRA_VX_MF2_TU, 0x3 }, // 2138
  { PseudoVSSRA_VX_MF4_MASK, PseudoVSSRA_VX_MF4, PseudoVSSRA_VX_MF4_TU, 0x3 }, // 2139
  { PseudoVSSRA_VX_MF8_MASK, PseudoVSSRA_VX_MF8, PseudoVSSRA_VX_MF8_TU, 0x3 }, // 2140
  { PseudoVSSRL_VI_M1_MASK, PseudoVSSRL_VI_M1, PseudoVSSRL_VI_M1_TU, 0x3 }, // 2141
  { PseudoVSSRL_VI_M2_MASK, PseudoVSSRL_VI_M2, PseudoVSSRL_VI_M2_TU, 0x3 }, // 2142
  { PseudoVSSRL_VI_M4_MASK, PseudoVSSRL_VI_M4, PseudoVSSRL_VI_M4_TU, 0x3 }, // 2143
  { PseudoVSSRL_VI_M8_MASK, PseudoVSSRL_VI_M8, PseudoVSSRL_VI_M8_TU, 0x3 }, // 2144
  { PseudoVSSRL_VI_MF2_MASK, PseudoVSSRL_VI_MF2, PseudoVSSRL_VI_MF2_TU, 0x3 }, // 2145
  { PseudoVSSRL_VI_MF4_MASK, PseudoVSSRL_VI_MF4, PseudoVSSRL_VI_MF4_TU, 0x3 }, // 2146
  { PseudoVSSRL_VI_MF8_MASK, PseudoVSSRL_VI_MF8, PseudoVSSRL_VI_MF8_TU, 0x3 }, // 2147
  { PseudoVSSRL_VV_M1_MASK, PseudoVSSRL_VV_M1, PseudoVSSRL_VV_M1_TU, 0x3 }, // 2148
  { PseudoVSSRL_VV_M2_MASK, PseudoVSSRL_VV_M2, PseudoVSSRL_VV_M2_TU, 0x3 }, // 2149
  { PseudoVSSRL_VV_M4_MASK, PseudoVSSRL_VV_M4, PseudoVSSRL_VV_M4_TU, 0x3 }, // 2150
  { PseudoVSSRL_VV_M8_MASK, PseudoVSSRL_VV_M8, PseudoVSSRL_VV_M8_TU, 0x3 }, // 2151
  { PseudoVSSRL_VV_MF2_MASK, PseudoVSSRL_VV_MF2, PseudoVSSRL_VV_MF2_TU, 0x3 }, // 2152
  { PseudoVSSRL_VV_MF4_MASK, PseudoVSSRL_VV_MF4, PseudoVSSRL_VV_MF4_TU, 0x3 }, // 2153
  { PseudoVSSRL_VV_MF8_MASK, PseudoVSSRL_VV_MF8, PseudoVSSRL_VV_MF8_TU, 0x3 }, // 2154
  { PseudoVSSRL_VX_M1_MASK, PseudoVSSRL_VX_M1, PseudoVSSRL_VX_M1_TU, 0x3 }, // 2155
  { PseudoVSSRL_VX_M2_MASK, PseudoVSSRL_VX_M2, PseudoVSSRL_VX_M2_TU, 0x3 }, // 2156
  { PseudoVSSRL_VX_M4_MASK, PseudoVSSRL_VX_M4, PseudoVSSRL_VX_M4_TU, 0x3 }, // 2157
  { PseudoVSSRL_VX_M8_MASK, PseudoVSSRL_VX_M8, PseudoVSSRL_VX_M8_TU, 0x3 }, // 2158
  { PseudoVSSRL_VX_MF2_MASK, PseudoVSSRL_VX_MF2, PseudoVSSRL_VX_MF2_TU, 0x3 }, // 2159
  { PseudoVSSRL_VX_MF4_MASK, PseudoVSSRL_VX_MF4, PseudoVSSRL_VX_MF4_TU, 0x3 }, // 2160
  { PseudoVSSRL_VX_MF8_MASK, PseudoVSSRL_VX_MF8, PseudoVSSRL_VX_MF8_TU, 0x3 }, // 2161
  { PseudoVSSUBU_VV_M1_MASK, PseudoVSSUBU_VV_M1, PseudoVSSUBU_VV_M1_TU, 0x3 }, // 2162
  { PseudoVSSUBU_VV_M2_MASK, PseudoVSSUBU_VV_M2, PseudoVSSUBU_VV_M2_TU, 0x3 }, // 2163
  { PseudoVSSUBU_VV_M4_MASK, PseudoVSSUBU_VV_M4, PseudoVSSUBU_VV_M4_TU, 0x3 }, // 2164
  { PseudoVSSUBU_VV_M8_MASK, PseudoVSSUBU_VV_M8, PseudoVSSUBU_VV_M8_TU, 0x3 }, // 2165
  { PseudoVSSUBU_VV_MF2_MASK, PseudoVSSUBU_VV_MF2, PseudoVSSUBU_VV_MF2_TU, 0x3 }, // 2166
  { PseudoVSSUBU_VV_MF4_MASK, PseudoVSSUBU_VV_MF4, PseudoVSSUBU_VV_MF4_TU, 0x3 }, // 2167
  { PseudoVSSUBU_VV_MF8_MASK, PseudoVSSUBU_VV_MF8, PseudoVSSUBU_VV_MF8_TU, 0x3 }, // 2168
  { PseudoVSSUBU_VX_M1_MASK, PseudoVSSUBU_VX_M1, PseudoVSSUBU_VX_M1_TU, 0x3 }, // 2169
  { PseudoVSSUBU_VX_M2_MASK, PseudoVSSUBU_VX_M2, PseudoVSSUBU_VX_M2_TU, 0x3 }, // 2170
  { PseudoVSSUBU_VX_M4_MASK, PseudoVSSUBU_VX_M4, PseudoVSSUBU_VX_M4_TU, 0x3 }, // 2171
  { PseudoVSSUBU_VX_M8_MASK, PseudoVSSUBU_VX_M8, PseudoVSSUBU_VX_M8_TU, 0x3 }, // 2172
  { PseudoVSSUBU_VX_MF2_MASK, PseudoVSSUBU_VX_MF2, PseudoVSSUBU_VX_MF2_TU, 0x3 }, // 2173
  { PseudoVSSUBU_VX_MF4_MASK, PseudoVSSUBU_VX_MF4, PseudoVSSUBU_VX_MF4_TU, 0x3 }, // 2174
  { PseudoVSSUBU_VX_MF8_MASK, PseudoVSSUBU_VX_MF8, PseudoVSSUBU_VX_MF8_TU, 0x3 }, // 2175
  { PseudoVSSUB_VV_M1_MASK, PseudoVSSUB_VV_M1, PseudoVSSUB_VV_M1_TU, 0x3 }, // 2176
  { PseudoVSSUB_VV_M2_MASK, PseudoVSSUB_VV_M2, PseudoVSSUB_VV_M2_TU, 0x3 }, // 2177
  { PseudoVSSUB_VV_M4_MASK, PseudoVSSUB_VV_M4, PseudoVSSUB_VV_M4_TU, 0x3 }, // 2178
  { PseudoVSSUB_VV_M8_MASK, PseudoVSSUB_VV_M8, PseudoVSSUB_VV_M8_TU, 0x3 }, // 2179
  { PseudoVSSUB_VV_MF2_MASK, PseudoVSSUB_VV_MF2, PseudoVSSUB_VV_MF2_TU, 0x3 }, // 2180
  { PseudoVSSUB_VV_MF4_MASK, PseudoVSSUB_VV_MF4, PseudoVSSUB_VV_MF4_TU, 0x3 }, // 2181
  { PseudoVSSUB_VV_MF8_MASK, PseudoVSSUB_VV_MF8, PseudoVSSUB_VV_MF8_TU, 0x3 }, // 2182
  { PseudoVSSUB_VX_M1_MASK, PseudoVSSUB_VX_M1, PseudoVSSUB_VX_M1_TU, 0x3 }, // 2183
  { PseudoVSSUB_VX_M2_MASK, PseudoVSSUB_VX_M2, PseudoVSSUB_VX_M2_TU, 0x3 }, // 2184
  { PseudoVSSUB_VX_M4_MASK, PseudoVSSUB_VX_M4, PseudoVSSUB_VX_M4_TU, 0x3 }, // 2185
  { PseudoVSSUB_VX_M8_MASK, PseudoVSSUB_VX_M8, PseudoVSSUB_VX_M8_TU, 0x3 }, // 2186
  { PseudoVSSUB_VX_MF2_MASK, PseudoVSSUB_VX_MF2, PseudoVSSUB_VX_MF2_TU, 0x3 }, // 2187
  { PseudoVSSUB_VX_MF4_MASK, PseudoVSSUB_VX_MF4, PseudoVSSUB_VX_MF4_TU, 0x3 }, // 2188
  { PseudoVSSUB_VX_MF8_MASK, PseudoVSSUB_VX_MF8, PseudoVSSUB_VX_MF8_TU, 0x3 }, // 2189
  { PseudoVSUB_VV_M1_MASK, PseudoVSUB_VV_M1, PseudoVSUB_VV_M1_TU, 0x3 }, // 2190
  { PseudoVSUB_VV_M2_MASK, PseudoVSUB_VV_M2, PseudoVSUB_VV_M2_TU, 0x3 }, // 2191
  { PseudoVSUB_VV_M4_MASK, PseudoVSUB_VV_M4, PseudoVSUB_VV_M4_TU, 0x3 }, // 2192
  { PseudoVSUB_VV_M8_MASK, PseudoVSUB_VV_M8, PseudoVSUB_VV_M8_TU, 0x3 }, // 2193
  { PseudoVSUB_VV_MF2_MASK, PseudoVSUB_VV_MF2, PseudoVSUB_VV_MF2_TU, 0x3 }, // 2194
  { PseudoVSUB_VV_MF4_MASK, PseudoVSUB_VV_MF4, PseudoVSUB_VV_MF4_TU, 0x3 }, // 2195
  { PseudoVSUB_VV_MF8_MASK, PseudoVSUB_VV_MF8, PseudoVSUB_VV_MF8_TU, 0x3 }, // 2196
  { PseudoVSUB_VX_M1_MASK, PseudoVSUB_VX_M1, PseudoVSUB_VX_M1_TU, 0x3 }, // 2197
  { PseudoVSUB_VX_M2_MASK, PseudoVSUB_VX_M2, PseudoVSUB_VX_M2_TU, 0x3 }, // 2198
  { PseudoVSUB_VX_M4_MASK, PseudoVSUB_VX_M4, PseudoVSUB_VX_M4_TU, 0x3 }, // 2199
  { PseudoVSUB_VX_M8_MASK, PseudoVSUB_VX_M8, PseudoVSUB_VX_M8_TU, 0x3 }, // 2200
  { PseudoVSUB_VX_MF2_MASK, PseudoVSUB_VX_MF2, PseudoVSUB_VX_MF2_TU, 0x3 }, // 2201
  { PseudoVSUB_VX_MF4_MASK, PseudoVSUB_VX_MF4, PseudoVSUB_VX_MF4_TU, 0x3 }, // 2202
  { PseudoVSUB_VX_MF8_MASK, PseudoVSUB_VX_MF8, PseudoVSUB_VX_MF8_TU, 0x3 }, // 2203
  { PseudoVWADDU_VV_M1_MASK, PseudoVWADDU_VV_M1, PseudoVWADDU_VV_M1_TU, 0x3 }, // 2204
  { PseudoVWADDU_VV_M2_MASK, PseudoVWADDU_VV_M2, PseudoVWADDU_VV_M2_TU, 0x3 }, // 2205
  { PseudoVWADDU_VV_M4_MASK, PseudoVWADDU_VV_M4, PseudoVWADDU_VV_M4_TU, 0x3 }, // 2206
  { PseudoVWADDU_VV_MF2_MASK, PseudoVWADDU_VV_MF2, PseudoVWADDU_VV_MF2_TU, 0x3 }, // 2207
  { PseudoVWADDU_VV_MF4_MASK, PseudoVWADDU_VV_MF4, PseudoVWADDU_VV_MF4_TU, 0x3 }, // 2208
  { PseudoVWADDU_VV_MF8_MASK, PseudoVWADDU_VV_MF8, PseudoVWADDU_VV_MF8_TU, 0x3 }, // 2209
  { PseudoVWADDU_VX_M1_MASK, PseudoVWADDU_VX_M1, PseudoVWADDU_VX_M1_TU, 0x3 }, // 2210
  { PseudoVWADDU_VX_M2_MASK, PseudoVWADDU_VX_M2, PseudoVWADDU_VX_M2_TU, 0x3 }, // 2211
  { PseudoVWADDU_VX_M4_MASK, PseudoVWADDU_VX_M4, PseudoVWADDU_VX_M4_TU, 0x3 }, // 2212
  { PseudoVWADDU_VX_MF2_MASK, PseudoVWADDU_VX_MF2, PseudoVWADDU_VX_MF2_TU, 0x3 }, // 2213
  { PseudoVWADDU_VX_MF4_MASK, PseudoVWADDU_VX_MF4, PseudoVWADDU_VX_MF4_TU, 0x3 }, // 2214
  { PseudoVWADDU_VX_MF8_MASK, PseudoVWADDU_VX_MF8, PseudoVWADDU_VX_MF8_TU, 0x3 }, // 2215
  { PseudoVWADDU_WV_M1_MASK, PseudoVWADDU_WV_M1, PseudoVWADDU_WV_M1_TU, 0x3 }, // 2216
  { PseudoVWADDU_WV_M2_MASK, PseudoVWADDU_WV_M2, PseudoVWADDU_WV_M2_TU, 0x3 }, // 2217
  { PseudoVWADDU_WV_M4_MASK, PseudoVWADDU_WV_M4, PseudoVWADDU_WV_M4_TU, 0x3 }, // 2218
  { PseudoVWADDU_WV_MF2_MASK, PseudoVWADDU_WV_MF2, PseudoVWADDU_WV_MF2_TU, 0x3 }, // 2219
  { PseudoVWADDU_WV_MF4_MASK, PseudoVWADDU_WV_MF4, PseudoVWADDU_WV_MF4_TU, 0x3 }, // 2220
  { PseudoVWADDU_WV_MF8_MASK, PseudoVWADDU_WV_MF8, PseudoVWADDU_WV_MF8_TU, 0x3 }, // 2221
  { PseudoVWADDU_WX_M1_MASK, PseudoVWADDU_WX_M1, PseudoVWADDU_WX_M1_TU, 0x3 }, // 2222
  { PseudoVWADDU_WX_M2_MASK, PseudoVWADDU_WX_M2, PseudoVWADDU_WX_M2_TU, 0x3 }, // 2223
  { PseudoVWADDU_WX_M4_MASK, PseudoVWADDU_WX_M4, PseudoVWADDU_WX_M4_TU, 0x3 }, // 2224
  { PseudoVWADDU_WX_MF2_MASK, PseudoVWADDU_WX_MF2, PseudoVWADDU_WX_MF2_TU, 0x3 }, // 2225
  { PseudoVWADDU_WX_MF4_MASK, PseudoVWADDU_WX_MF4, PseudoVWADDU_WX_MF4_TU, 0x3 }, // 2226
  { PseudoVWADDU_WX_MF8_MASK, PseudoVWADDU_WX_MF8, PseudoVWADDU_WX_MF8_TU, 0x3 }, // 2227
  { PseudoVWADD_VV_M1_MASK, PseudoVWADD_VV_M1, PseudoVWADD_VV_M1_TU, 0x3 }, // 2228
  { PseudoVWADD_VV_M2_MASK, PseudoVWADD_VV_M2, PseudoVWADD_VV_M2_TU, 0x3 }, // 2229
  { PseudoVWADD_VV_M4_MASK, PseudoVWADD_VV_M4, PseudoVWADD_VV_M4_TU, 0x3 }, // 2230
  { PseudoVWADD_VV_MF2_MASK, PseudoVWADD_VV_MF2, PseudoVWADD_VV_MF2_TU, 0x3 }, // 2231
  { PseudoVWADD_VV_MF4_MASK, PseudoVWADD_VV_MF4, PseudoVWADD_VV_MF4_TU, 0x3 }, // 2232
  { PseudoVWADD_VV_MF8_MASK, PseudoVWADD_VV_MF8, PseudoVWADD_VV_MF8_TU, 0x3 }, // 2233
  { PseudoVWADD_VX_M1_MASK, PseudoVWADD_VX_M1, PseudoVWADD_VX_M1_TU, 0x3 }, // 2234
  { PseudoVWADD_VX_M2_MASK, PseudoVWADD_VX_M2, PseudoVWADD_VX_M2_TU, 0x3 }, // 2235
  { PseudoVWADD_VX_M4_MASK, PseudoVWADD_VX_M4, PseudoVWADD_VX_M4_TU, 0x3 }, // 2236
  { PseudoVWADD_VX_MF2_MASK, PseudoVWADD_VX_MF2, PseudoVWADD_VX_MF2_TU, 0x3 }, // 2237
  { PseudoVWADD_VX_MF4_MASK, PseudoVWADD_VX_MF4, PseudoVWADD_VX_MF4_TU, 0x3 }, // 2238
  { PseudoVWADD_VX_MF8_MASK, PseudoVWADD_VX_MF8, PseudoVWADD_VX_MF8_TU, 0x3 }, // 2239
  { PseudoVWADD_WV_M1_MASK, PseudoVWADD_WV_M1, PseudoVWADD_WV_M1_TU, 0x3 }, // 2240
  { PseudoVWADD_WV_M2_MASK, PseudoVWADD_WV_M2, PseudoVWADD_WV_M2_TU, 0x3 }, // 2241
  { PseudoVWADD_WV_M4_MASK, PseudoVWADD_WV_M4, PseudoVWADD_WV_M4_TU, 0x3 }, // 2242
  { PseudoVWADD_WV_MF2_MASK, PseudoVWADD_WV_MF2, PseudoVWADD_WV_MF2_TU, 0x3 }, // 2243
  { PseudoVWADD_WV_MF4_MASK, PseudoVWADD_WV_MF4, PseudoVWADD_WV_MF4_TU, 0x3 }, // 2244
  { PseudoVWADD_WV_MF8_MASK, PseudoVWADD_WV_MF8, PseudoVWADD_WV_MF8_TU, 0x3 }, // 2245
  { PseudoVWADD_WX_M1_MASK, PseudoVWADD_WX_M1, PseudoVWADD_WX_M1_TU, 0x3 }, // 2246
  { PseudoVWADD_WX_M2_MASK, PseudoVWADD_WX_M2, PseudoVWADD_WX_M2_TU, 0x3 }, // 2247
  { PseudoVWADD_WX_M4_MASK, PseudoVWADD_WX_M4, PseudoVWADD_WX_M4_TU, 0x3 }, // 2248
  { PseudoVWADD_WX_MF2_MASK, PseudoVWADD_WX_MF2, PseudoVWADD_WX_MF2_TU, 0x3 }, // 2249
  { PseudoVWADD_WX_MF4_MASK, PseudoVWADD_WX_MF4, PseudoVWADD_WX_MF4_TU, 0x3 }, // 2250
  { PseudoVWADD_WX_MF8_MASK, PseudoVWADD_WX_MF8, PseudoVWADD_WX_MF8_TU, 0x3 }, // 2251
  { PseudoVWMACCSU_VV_M1_MASK, PseudoVWMACCSU_VV_M1, PseudoVWMACCSU_VV_M1, 0x3 }, // 2252
  { PseudoVWMACCSU_VV_M2_MASK, PseudoVWMACCSU_VV_M2, PseudoVWMACCSU_VV_M2, 0x3 }, // 2253
  { PseudoVWMACCSU_VV_M4_MASK, PseudoVWMACCSU_VV_M4, PseudoVWMACCSU_VV_M4, 0x3 }, // 2254
  { PseudoVWMACCSU_VV_MF2_MASK, PseudoVWMACCSU_VV_MF2, PseudoVWMACCSU_VV_MF2, 0x3 }, // 2255
  { PseudoVWMACCSU_VV_MF4_MASK, PseudoVWMACCSU_VV_MF4, PseudoVWMACCSU_VV_MF4, 0x3 }, // 2256
  { PseudoVWMACCSU_VV_MF8_MASK, PseudoVWMACCSU_VV_MF8, PseudoVWMACCSU_VV_MF8, 0x3 }, // 2257
  { PseudoVWMACCSU_VX_M1_MASK, PseudoVWMACCSU_VX_M1, PseudoVWMACCSU_VX_M1, 0x3 }, // 2258
  { PseudoVWMACCSU_VX_M2_MASK, PseudoVWMACCSU_VX_M2, PseudoVWMACCSU_VX_M2, 0x3 }, // 2259
  { PseudoVWMACCSU_VX_M4_MASK, PseudoVWMACCSU_VX_M4, PseudoVWMACCSU_VX_M4, 0x3 }, // 2260
  { PseudoVWMACCSU_VX_MF2_MASK, PseudoVWMACCSU_VX_MF2, PseudoVWMACCSU_VX_MF2, 0x3 }, // 2261
  { PseudoVWMACCSU_VX_MF4_MASK, PseudoVWMACCSU_VX_MF4, PseudoVWMACCSU_VX_MF4, 0x3 }, // 2262
  { PseudoVWMACCSU_VX_MF8_MASK, PseudoVWMACCSU_VX_MF8, PseudoVWMACCSU_VX_MF8, 0x3 }, // 2263
  { PseudoVWMACCUS_VX_M1_MASK, PseudoVWMACCUS_VX_M1, PseudoVWMACCUS_VX_M1, 0x3 }, // 2264
  { PseudoVWMACCUS_VX_M2_MASK, PseudoVWMACCUS_VX_M2, PseudoVWMACCUS_VX_M2, 0x3 }, // 2265
  { PseudoVWMACCUS_VX_M4_MASK, PseudoVWMACCUS_VX_M4, PseudoVWMACCUS_VX_M4, 0x3 }, // 2266
  { PseudoVWMACCUS_VX_MF2_MASK, PseudoVWMACCUS_VX_MF2, PseudoVWMACCUS_VX_MF2, 0x3 }, // 2267
  { PseudoVWMACCUS_VX_MF4_MASK, PseudoVWMACCUS_VX_MF4, PseudoVWMACCUS_VX_MF4, 0x3 }, // 2268
  { PseudoVWMACCUS_VX_MF8_MASK, PseudoVWMACCUS_VX_MF8, PseudoVWMACCUS_VX_MF8, 0x3 }, // 2269
  { PseudoVWMACCU_VV_M1_MASK, PseudoVWMACCU_VV_M1, PseudoVWMACCU_VV_M1, 0x3 }, // 2270
  { PseudoVWMACCU_VV_M2_MASK, PseudoVWMACCU_VV_M2, PseudoVWMACCU_VV_M2, 0x3 }, // 2271
  { PseudoVWMACCU_VV_M4_MASK, PseudoVWMACCU_VV_M4, PseudoVWMACCU_VV_M4, 0x3 }, // 2272
  { PseudoVWMACCU_VV_MF2_MASK, PseudoVWMACCU_VV_MF2, PseudoVWMACCU_VV_MF2, 0x3 }, // 2273
  { PseudoVWMACCU_VV_MF4_MASK, PseudoVWMACCU_VV_MF4, PseudoVWMACCU_VV_MF4, 0x3 }, // 2274
  { PseudoVWMACCU_VV_MF8_MASK, PseudoVWMACCU_VV_MF8, PseudoVWMACCU_VV_MF8, 0x3 }, // 2275
  { PseudoVWMACCU_VX_M1_MASK, PseudoVWMACCU_VX_M1, PseudoVWMACCU_VX_M1, 0x3 }, // 2276
  { PseudoVWMACCU_VX_M2_MASK, PseudoVWMACCU_VX_M2, PseudoVWMACCU_VX_M2, 0x3 }, // 2277
  { PseudoVWMACCU_VX_M4_MASK, PseudoVWMACCU_VX_M4, PseudoVWMACCU_VX_M4, 0x3 }, // 2278
  { PseudoVWMACCU_VX_MF2_MASK, PseudoVWMACCU_VX_MF2, PseudoVWMACCU_VX_MF2, 0x3 }, // 2279
  { PseudoVWMACCU_VX_MF4_MASK, PseudoVWMACCU_VX_MF4, PseudoVWMACCU_VX_MF4, 0x3 }, // 2280
  { PseudoVWMACCU_VX_MF8_MASK, PseudoVWMACCU_VX_MF8, PseudoVWMACCU_VX_MF8, 0x3 }, // 2281
  { PseudoVWMACC_VV_M1_MASK, PseudoVWMACC_VV_M1, PseudoVWMACC_VV_M1, 0x3 }, // 2282
  { PseudoVWMACC_VV_M2_MASK, PseudoVWMACC_VV_M2, PseudoVWMACC_VV_M2, 0x3 }, // 2283
  { PseudoVWMACC_VV_M4_MASK, PseudoVWMACC_VV_M4, PseudoVWMACC_VV_M4, 0x3 }, // 2284
  { PseudoVWMACC_VV_MF2_MASK, PseudoVWMACC_VV_MF2, PseudoVWMACC_VV_MF2, 0x3 }, // 2285
  { PseudoVWMACC_VV_MF4_MASK, PseudoVWMACC_VV_MF4, PseudoVWMACC_VV_MF4, 0x3 }, // 2286
  { PseudoVWMACC_VV_MF8_MASK, PseudoVWMACC_VV_MF8, PseudoVWMACC_VV_MF8, 0x3 }, // 2287
  { PseudoVWMACC_VX_M1_MASK, PseudoVWMACC_VX_M1, PseudoVWMACC_VX_M1, 0x3 }, // 2288
  { PseudoVWMACC_VX_M2_MASK, PseudoVWMACC_VX_M2, PseudoVWMACC_VX_M2, 0x3 }, // 2289
  { PseudoVWMACC_VX_M4_MASK, PseudoVWMACC_VX_M4, PseudoVWMACC_VX_M4, 0x3 }, // 2290
  { PseudoVWMACC_VX_MF2_MASK, PseudoVWMACC_VX_MF2, PseudoVWMACC_VX_MF2, 0x3 }, // 2291
  { PseudoVWMACC_VX_MF4_MASK, PseudoVWMACC_VX_MF4, PseudoVWMACC_VX_MF4, 0x3 }, // 2292
  { PseudoVWMACC_VX_MF8_MASK, PseudoVWMACC_VX_MF8, PseudoVWMACC_VX_MF8, 0x3 }, // 2293
  { PseudoVWMULSU_VV_M1_MASK, PseudoVWMULSU_VV_M1, PseudoVWMULSU_VV_M1_TU, 0x3 }, // 2294
  { PseudoVWMULSU_VV_M2_MASK, PseudoVWMULSU_VV_M2, PseudoVWMULSU_VV_M2_TU, 0x3 }, // 2295
  { PseudoVWMULSU_VV_M4_MASK, PseudoVWMULSU_VV_M4, PseudoVWMULSU_VV_M4_TU, 0x3 }, // 2296
  { PseudoVWMULSU_VV_MF2_MASK, PseudoVWMULSU_VV_MF2, PseudoVWMULSU_VV_MF2_TU, 0x3 }, // 2297
  { PseudoVWMULSU_VV_MF4_MASK, PseudoVWMULSU_VV_MF4, PseudoVWMULSU_VV_MF4_TU, 0x3 }, // 2298
  { PseudoVWMULSU_VV_MF8_MASK, PseudoVWMULSU_VV_MF8, PseudoVWMULSU_VV_MF8_TU, 0x3 }, // 2299
  { PseudoVWMULSU_VX_M1_MASK, PseudoVWMULSU_VX_M1, PseudoVWMULSU_VX_M1_TU, 0x3 }, // 2300
  { PseudoVWMULSU_VX_M2_MASK, PseudoVWMULSU_VX_M2, PseudoVWMULSU_VX_M2_TU, 0x3 }, // 2301
  { PseudoVWMULSU_VX_M4_MASK, PseudoVWMULSU_VX_M4, PseudoVWMULSU_VX_M4_TU, 0x3 }, // 2302
  { PseudoVWMULSU_VX_MF2_MASK, PseudoVWMULSU_VX_MF2, PseudoVWMULSU_VX_MF2_TU, 0x3 }, // 2303
  { PseudoVWMULSU_VX_MF4_MASK, PseudoVWMULSU_VX_MF4, PseudoVWMULSU_VX_MF4_TU, 0x3 }, // 2304
  { PseudoVWMULSU_VX_MF8_MASK, PseudoVWMULSU_VX_MF8, PseudoVWMULSU_VX_MF8_TU, 0x3 }, // 2305
  { PseudoVWMULU_VV_M1_MASK, PseudoVWMULU_VV_M1, PseudoVWMULU_VV_M1_TU, 0x3 }, // 2306
  { PseudoVWMULU_VV_M2_MASK, PseudoVWMULU_VV_M2, PseudoVWMULU_VV_M2_TU, 0x3 }, // 2307
  { PseudoVWMULU_VV_M4_MASK, PseudoVWMULU_VV_M4, PseudoVWMULU_VV_M4_TU, 0x3 }, // 2308
  { PseudoVWMULU_VV_MF2_MASK, PseudoVWMULU_VV_MF2, PseudoVWMULU_VV_MF2_TU, 0x3 }, // 2309
  { PseudoVWMULU_VV_MF4_MASK, PseudoVWMULU_VV_MF4, PseudoVWMULU_VV_MF4_TU, 0x3 }, // 2310
  { PseudoVWMULU_VV_MF8_MASK, PseudoVWMULU_VV_MF8, PseudoVWMULU_VV_MF8_TU, 0x3 }, // 2311
  { PseudoVWMULU_VX_M1_MASK, PseudoVWMULU_VX_M1, PseudoVWMULU_VX_M1_TU, 0x3 }, // 2312
  { PseudoVWMULU_VX_M2_MASK, PseudoVWMULU_VX_M2, PseudoVWMULU_VX_M2_TU, 0x3 }, // 2313
  { PseudoVWMULU_VX_M4_MASK, PseudoVWMULU_VX_M4, PseudoVWMULU_VX_M4_TU, 0x3 }, // 2314
  { PseudoVWMULU_VX_MF2_MASK, PseudoVWMULU_VX_MF2, PseudoVWMULU_VX_MF2_TU, 0x3 }, // 2315
  { PseudoVWMULU_VX_MF4_MASK, PseudoVWMULU_VX_MF4, PseudoVWMULU_VX_MF4_TU, 0x3 }, // 2316
  { PseudoVWMULU_VX_MF8_MASK, PseudoVWMULU_VX_MF8, PseudoVWMULU_VX_MF8_TU, 0x3 }, // 2317
  { PseudoVWMUL_VV_M1_MASK, PseudoVWMUL_VV_M1, PseudoVWMUL_VV_M1_TU, 0x3 }, // 2318
  { PseudoVWMUL_VV_M2_MASK, PseudoVWMUL_VV_M2, PseudoVWMUL_VV_M2_TU, 0x3 }, // 2319
  { PseudoVWMUL_VV_M4_MASK, PseudoVWMUL_VV_M4, PseudoVWMUL_VV_M4_TU, 0x3 }, // 2320
  { PseudoVWMUL_VV_MF2_MASK, PseudoVWMUL_VV_MF2, PseudoVWMUL_VV_MF2_TU, 0x3 }, // 2321
  { PseudoVWMUL_VV_MF4_MASK, PseudoVWMUL_VV_MF4, PseudoVWMUL_VV_MF4_TU, 0x3 }, // 2322
  { PseudoVWMUL_VV_MF8_MASK, PseudoVWMUL_VV_MF8, PseudoVWMUL_VV_MF8_TU, 0x3 }, // 2323
  { PseudoVWMUL_VX_M1_MASK, PseudoVWMUL_VX_M1, PseudoVWMUL_VX_M1_TU, 0x3 }, // 2324
  { PseudoVWMUL_VX_M2_MASK, PseudoVWMUL_VX_M2, PseudoVWMUL_VX_M2_TU, 0x3 }, // 2325
  { PseudoVWMUL_VX_M4_MASK, PseudoVWMUL_VX_M4, PseudoVWMUL_VX_M4_TU, 0x3 }, // 2326
  { PseudoVWMUL_VX_MF2_MASK, PseudoVWMUL_VX_MF2, PseudoVWMUL_VX_MF2_TU, 0x3 }, // 2327
  { PseudoVWMUL_VX_MF4_MASK, PseudoVWMUL_VX_MF4, PseudoVWMUL_VX_MF4_TU, 0x3 }, // 2328
  { PseudoVWMUL_VX_MF8_MASK, PseudoVWMUL_VX_MF8, PseudoVWMUL_VX_MF8_TU, 0x3 }, // 2329
  { PseudoVWSUBU_VV_M1_MASK, PseudoVWSUBU_VV_M1, PseudoVWSUBU_VV_M1_TU, 0x3 }, // 2330
  { PseudoVWSUBU_VV_M2_MASK, PseudoVWSUBU_VV_M2, PseudoVWSUBU_VV_M2_TU, 0x3 }, // 2331
  { PseudoVWSUBU_VV_M4_MASK, PseudoVWSUBU_VV_M4, PseudoVWSUBU_VV_M4_TU, 0x3 }, // 2332
  { PseudoVWSUBU_VV_MF2_MASK, PseudoVWSUBU_VV_MF2, PseudoVWSUBU_VV_MF2_TU, 0x3 }, // 2333
  { PseudoVWSUBU_VV_MF4_MASK, PseudoVWSUBU_VV_MF4, PseudoVWSUBU_VV_MF4_TU, 0x3 }, // 2334
  { PseudoVWSUBU_VV_MF8_MASK, PseudoVWSUBU_VV_MF8, PseudoVWSUBU_VV_MF8_TU, 0x3 }, // 2335
  { PseudoVWSUBU_VX_M1_MASK, PseudoVWSUBU_VX_M1, PseudoVWSUBU_VX_M1_TU, 0x3 }, // 2336
  { PseudoVWSUBU_VX_M2_MASK, PseudoVWSUBU_VX_M2, PseudoVWSUBU_VX_M2_TU, 0x3 }, // 2337
  { PseudoVWSUBU_VX_M4_MASK, PseudoVWSUBU_VX_M4, PseudoVWSUBU_VX_M4_TU, 0x3 }, // 2338
  { PseudoVWSUBU_VX_MF2_MASK, PseudoVWSUBU_VX_MF2, PseudoVWSUBU_VX_MF2_TU, 0x3 }, // 2339
  { PseudoVWSUBU_VX_MF4_MASK, PseudoVWSUBU_VX_MF4, PseudoVWSUBU_VX_MF4_TU, 0x3 }, // 2340
  { PseudoVWSUBU_VX_MF8_MASK, PseudoVWSUBU_VX_MF8, PseudoVWSUBU_VX_MF8_TU, 0x3 }, // 2341
  { PseudoVWSUBU_WV_M1_MASK, PseudoVWSUBU_WV_M1, PseudoVWSUBU_WV_M1_TU, 0x3 }, // 2342
  { PseudoVWSUBU_WV_M2_MASK, PseudoVWSUBU_WV_M2, PseudoVWSUBU_WV_M2_TU, 0x3 }, // 2343
  { PseudoVWSUBU_WV_M4_MASK, PseudoVWSUBU_WV_M4, PseudoVWSUBU_WV_M4_TU, 0x3 }, // 2344
  { PseudoVWSUBU_WV_MF2_MASK, PseudoVWSUBU_WV_MF2, PseudoVWSUBU_WV_MF2_TU, 0x3 }, // 2345
  { PseudoVWSUBU_WV_MF4_MASK, PseudoVWSUBU_WV_MF4, PseudoVWSUBU_WV_MF4_TU, 0x3 }, // 2346
  { PseudoVWSUBU_WV_MF8_MASK, PseudoVWSUBU_WV_MF8, PseudoVWSUBU_WV_MF8_TU, 0x3 }, // 2347
  { PseudoVWSUBU_WX_M1_MASK, PseudoVWSUBU_WX_M1, PseudoVWSUBU_WX_M1_TU, 0x3 }, // 2348
  { PseudoVWSUBU_WX_M2_MASK, PseudoVWSUBU_WX_M2, PseudoVWSUBU_WX_M2_TU, 0x3 }, // 2349
  { PseudoVWSUBU_WX_M4_MASK, PseudoVWSUBU_WX_M4, PseudoVWSUBU_WX_M4_TU, 0x3 }, // 2350
  { PseudoVWSUBU_WX_MF2_MASK, PseudoVWSUBU_WX_MF2, PseudoVWSUBU_WX_MF2_TU, 0x3 }, // 2351
  { PseudoVWSUBU_WX_MF4_MASK, PseudoVWSUBU_WX_MF4, PseudoVWSUBU_WX_MF4_TU, 0x3 }, // 2352
  { PseudoVWSUBU_WX_MF8_MASK, PseudoVWSUBU_WX_MF8, PseudoVWSUBU_WX_MF8_TU, 0x3 }, // 2353
  { PseudoVWSUB_VV_M1_MASK, PseudoVWSUB_VV_M1, PseudoVWSUB_VV_M1_TU, 0x3 }, // 2354
  { PseudoVWSUB_VV_M2_MASK, PseudoVWSUB_VV_M2, PseudoVWSUB_VV_M2_TU, 0x3 }, // 2355
  { PseudoVWSUB_VV_M4_MASK, PseudoVWSUB_VV_M4, PseudoVWSUB_VV_M4_TU, 0x3 }, // 2356
  { PseudoVWSUB_VV_MF2_MASK, PseudoVWSUB_VV_MF2, PseudoVWSUB_VV_MF2_TU, 0x3 }, // 2357
  { PseudoVWSUB_VV_MF4_MASK, PseudoVWSUB_VV_MF4, PseudoVWSUB_VV_MF4_TU, 0x3 }, // 2358
  { PseudoVWSUB_VV_MF8_MASK, PseudoVWSUB_VV_MF8, PseudoVWSUB_VV_MF8_TU, 0x3 }, // 2359
  { PseudoVWSUB_VX_M1_MASK, PseudoVWSUB_VX_M1, PseudoVWSUB_VX_M1_TU, 0x3 }, // 2360
  { PseudoVWSUB_VX_M2_MASK, PseudoVWSUB_VX_M2, PseudoVWSUB_VX_M2_TU, 0x3 }, // 2361
  { PseudoVWSUB_VX_M4_MASK, PseudoVWSUB_VX_M4, PseudoVWSUB_VX_M4_TU, 0x3 }, // 2362
  { PseudoVWSUB_VX_MF2_MASK, PseudoVWSUB_VX_MF2, PseudoVWSUB_VX_MF2_TU, 0x3 }, // 2363
  { PseudoVWSUB_VX_MF4_MASK, PseudoVWSUB_VX_MF4, PseudoVWSUB_VX_MF4_TU, 0x3 }, // 2364
  { PseudoVWSUB_VX_MF8_MASK, PseudoVWSUB_VX_MF8, PseudoVWSUB_VX_MF8_TU, 0x3 }, // 2365
  { PseudoVWSUB_WV_M1_MASK, PseudoVWSUB_WV_M1, PseudoVWSUB_WV_M1_TU, 0x3 }, // 2366
  { PseudoVWSUB_WV_M2_MASK, PseudoVWSUB_WV_M2, PseudoVWSUB_WV_M2_TU, 0x3 }, // 2367
  { PseudoVWSUB_WV_M4_MASK, PseudoVWSUB_WV_M4, PseudoVWSUB_WV_M4_TU, 0x3 }, // 2368
  { PseudoVWSUB_WV_MF2_MASK, PseudoVWSUB_WV_MF2, PseudoVWSUB_WV_MF2_TU, 0x3 }, // 2369
  { PseudoVWSUB_WV_MF4_MASK, PseudoVWSUB_WV_MF4, PseudoVWSUB_WV_MF4_TU, 0x3 }, // 2370
  { PseudoVWSUB_WV_MF8_MASK, PseudoVWSUB_WV_MF8, PseudoVWSUB_WV_MF8_TU, 0x3 }, // 2371
  { PseudoVWSUB_WX_M1_MASK, PseudoVWSUB_WX_M1, PseudoVWSUB_WX_M1_TU, 0x3 }, // 2372
  { PseudoVWSUB_WX_M2_MASK, PseudoVWSUB_WX_M2, PseudoVWSUB_WX_M2_TU, 0x3 }, // 2373
  { PseudoVWSUB_WX_M4_MASK, PseudoVWSUB_WX_M4, PseudoVWSUB_WX_M4_TU, 0x3 }, // 2374
  { PseudoVWSUB_WX_MF2_MASK, PseudoVWSUB_WX_MF2, PseudoVWSUB_WX_MF2_TU, 0x3 }, // 2375
  { PseudoVWSUB_WX_MF4_MASK, PseudoVWSUB_WX_MF4, PseudoVWSUB_WX_MF4_TU, 0x3 }, // 2376
  { PseudoVWSUB_WX_MF8_MASK, PseudoVWSUB_WX_MF8, PseudoVWSUB_WX_MF8_TU, 0x3 }, // 2377
  { PseudoVXOR_VI_M1_MASK, PseudoVXOR_VI_M1, PseudoVXOR_VI_M1_TU, 0x3 }, // 2378
  { PseudoVXOR_VI_M2_MASK, PseudoVXOR_VI_M2, PseudoVXOR_VI_M2_TU, 0x3 }, // 2379
  { PseudoVXOR_VI_M4_MASK, PseudoVXOR_VI_M4, PseudoVXOR_VI_M4_TU, 0x3 }, // 2380
  { PseudoVXOR_VI_M8_MASK, PseudoVXOR_VI_M8, PseudoVXOR_VI_M8_TU, 0x3 }, // 2381
  { PseudoVXOR_VI_MF2_MASK, PseudoVXOR_VI_MF2, PseudoVXOR_VI_MF2_TU, 0x3 }, // 2382
  { PseudoVXOR_VI_MF4_MASK, PseudoVXOR_VI_MF4, PseudoVXOR_VI_MF4_TU, 0x3 }, // 2383
  { PseudoVXOR_VI_MF8_MASK, PseudoVXOR_VI_MF8, PseudoVXOR_VI_MF8_TU, 0x3 }, // 2384
  { PseudoVXOR_VV_M1_MASK, PseudoVXOR_VV_M1, PseudoVXOR_VV_M1_TU, 0x3 }, // 2385
  { PseudoVXOR_VV_M2_MASK, PseudoVXOR_VV_M2, PseudoVXOR_VV_M2_TU, 0x3 }, // 2386
  { PseudoVXOR_VV_M4_MASK, PseudoVXOR_VV_M4, PseudoVXOR_VV_M4_TU, 0x3 }, // 2387
  { PseudoVXOR_VV_M8_MASK, PseudoVXOR_VV_M8, PseudoVXOR_VV_M8_TU, 0x3 }, // 2388
  { PseudoVXOR_VV_MF2_MASK, PseudoVXOR_VV_MF2, PseudoVXOR_VV_MF2_TU, 0x3 }, // 2389
  { PseudoVXOR_VV_MF4_MASK, PseudoVXOR_VV_MF4, PseudoVXOR_VV_MF4_TU, 0x3 }, // 2390
  { PseudoVXOR_VV_MF8_MASK, PseudoVXOR_VV_MF8, PseudoVXOR_VV_MF8_TU, 0x3 }, // 2391
  { PseudoVXOR_VX_M1_MASK, PseudoVXOR_VX_M1, PseudoVXOR_VX_M1_TU, 0x3 }, // 2392
  { PseudoVXOR_VX_M2_MASK, PseudoVXOR_VX_M2, PseudoVXOR_VX_M2_TU, 0x3 }, // 2393
  { PseudoVXOR_VX_M4_MASK, PseudoVXOR_VX_M4, PseudoVXOR_VX_M4_TU, 0x3 }, // 2394
  { PseudoVXOR_VX_M8_MASK, PseudoVXOR_VX_M8, PseudoVXOR_VX_M8_TU, 0x3 }, // 2395
  { PseudoVXOR_VX_MF2_MASK, PseudoVXOR_VX_MF2, PseudoVXOR_VX_MF2_TU, 0x3 }, // 2396
  { PseudoVXOR_VX_MF4_MASK, PseudoVXOR_VX_MF4, PseudoVXOR_VX_MF4_TU, 0x3 }, // 2397
  { PseudoVXOR_VX_MF8_MASK, PseudoVXOR_VX_MF8, PseudoVXOR_VX_MF8_TU, 0x3 }, // 2398
  { PseudoVZEXT_VF2_M1_MASK, PseudoVZEXT_VF2_M1, PseudoVZEXT_VF2_M1_TU, 0x2 }, // 2399
  { PseudoVZEXT_VF2_M2_MASK, PseudoVZEXT_VF2_M2, PseudoVZEXT_VF2_M2_TU, 0x2 }, // 2400
  { PseudoVZEXT_VF2_M4_MASK, PseudoVZEXT_VF2_M4, PseudoVZEXT_VF2_M4_TU, 0x2 }, // 2401
  { PseudoVZEXT_VF2_M8_MASK, PseudoVZEXT_VF2_M8, PseudoVZEXT_VF2_M8_TU, 0x2 }, // 2402
  { PseudoVZEXT_VF2_MF2_MASK, PseudoVZEXT_VF2_MF2, PseudoVZEXT_VF2_MF2_TU, 0x2 }, // 2403
  { PseudoVZEXT_VF2_MF4_MASK, PseudoVZEXT_VF2_MF4, PseudoVZEXT_VF2_MF4_TU, 0x2 }, // 2404
  { PseudoVZEXT_VF4_M1_MASK, PseudoVZEXT_VF4_M1, PseudoVZEXT_VF4_M1_TU, 0x2 }, // 2405
  { PseudoVZEXT_VF4_M2_MASK, PseudoVZEXT_VF4_M2, PseudoVZEXT_VF4_M2_TU, 0x2 }, // 2406
  { PseudoVZEXT_VF4_M4_MASK, PseudoVZEXT_VF4_M4, PseudoVZEXT_VF4_M4_TU, 0x2 }, // 2407
  { PseudoVZEXT_VF4_M8_MASK, PseudoVZEXT_VF4_M8, PseudoVZEXT_VF4_M8_TU, 0x2 }, // 2408
  { PseudoVZEXT_VF4_MF2_MASK, PseudoVZEXT_VF4_MF2, PseudoVZEXT_VF4_MF2_TU, 0x2 }, // 2409
  { PseudoVZEXT_VF8_M1_MASK, PseudoVZEXT_VF8_M1, PseudoVZEXT_VF8_M1_TU, 0x2 }, // 2410
  { PseudoVZEXT_VF8_M2_MASK, PseudoVZEXT_VF8_M2, PseudoVZEXT_VF8_M2_TU, 0x2 }, // 2411
  { PseudoVZEXT_VF8_M4_MASK, PseudoVZEXT_VF8_M4, PseudoVZEXT_VF8_M4_TU, 0x2 }, // 2412
  { PseudoVZEXT_VF8_M8_MASK, PseudoVZEXT_VF8_M8, PseudoVZEXT_VF8_M8_TU, 0x2 }, // 2413
 };

const RISCVMaskedPseudoInfo *getMaskedPseudoInfo(unsigned MaskedPseudo) {
  struct KeyType {
    unsigned MaskedPseudo;
  };
  KeyType Key = {MaskedPseudo};
  auto Table = ArrayRef(RISCVMaskedPseudosTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const RISCVMaskedPseudoInfo &LHS, const KeyType &RHS) {
      if (LHS.MaskedPseudo < RHS.MaskedPseudo)
        return true;
      if (LHS.MaskedPseudo > RHS.MaskedPseudo)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.MaskedPseudo != Idx->MaskedPseudo)
    return nullptr;
  return &*Idx;
}

const RISCVMaskedPseudoInfo *lookupMaskedIntrinsicByUnmaskedTA(unsigned UnmaskedPseudo) {
  struct IndexType {
    unsigned UnmaskedPseudo;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { PseudoTHVdotVMAQASU_VV_M1, 0 },
    { PseudoTHVdotVMAQASU_VV_M2, 1 },
    { PseudoTHVdotVMAQASU_VV_M4, 2 },
    { PseudoTHVdotVMAQASU_VV_M8, 3 },
    { PseudoTHVdotVMAQASU_VV_MF2, 4 },
    { PseudoTHVdotVMAQASU_VX_M1, 5 },
    { PseudoTHVdotVMAQASU_VX_M2, 6 },
    { PseudoTHVdotVMAQASU_VX_M4, 7 },
    { PseudoTHVdotVMAQASU_VX_M8, 8 },
    { PseudoTHVdotVMAQASU_VX_MF2, 9 },
    { PseudoTHVdotVMAQAUS_VX_M1, 10 },
    { PseudoTHVdotVMAQAUS_VX_M2, 11 },
    { PseudoTHVdotVMAQAUS_VX_M4, 12 },
    { PseudoTHVdotVMAQAUS_VX_M8, 13 },
    { PseudoTHVdotVMAQAUS_VX_MF2, 14 },
    { PseudoTHVdotVMAQAU_VV_M1, 15 },
    { PseudoTHVdotVMAQAU_VV_M2, 16 },
    { PseudoTHVdotVMAQAU_VV_M4, 17 },
    { PseudoTHVdotVMAQAU_VV_M8, 18 },
    { PseudoTHVdotVMAQAU_VV_MF2, 19 },
    { PseudoTHVdotVMAQAU_VX_M1, 20 },
    { PseudoTHVdotVMAQAU_VX_M2, 21 },
    { PseudoTHVdotVMAQAU_VX_M4, 22 },
    { PseudoTHVdotVMAQAU_VX_M8, 23 },
    { PseudoTHVdotVMAQAU_VX_MF2, 24 },
    { PseudoTHVdotVMAQA_VV_M1, 25 },
    { PseudoTHVdotVMAQA_VV_M2, 26 },
    { PseudoTHVdotVMAQA_VV_M4, 27 },
    { PseudoTHVdotVMAQA_VV_M8, 28 },
    { PseudoTHVdotVMAQA_VV_MF2, 29 },
    { PseudoTHVdotVMAQA_VX_M1, 30 },
    { PseudoTHVdotVMAQA_VX_M2, 31 },
    { PseudoTHVdotVMAQA_VX_M4, 32 },
    { PseudoTHVdotVMAQA_VX_M8, 33 },
    { PseudoTHVdotVMAQA_VX_MF2, 34 },
    { PseudoVAADDU_VV_M1, 35 },
    { PseudoVAADDU_VV_M2, 36 },
    { PseudoVAADDU_VV_M4, 37 },
    { PseudoVAADDU_VV_M8, 38 },
    { PseudoVAADDU_VV_MF2, 39 },
    { PseudoVAADDU_VV_MF4, 40 },
    { PseudoVAADDU_VV_MF8, 41 },
    { PseudoVAADDU_VX_M1, 42 },
    { PseudoVAADDU_VX_M2, 43 },
    { PseudoVAADDU_VX_M4, 44 },
    { PseudoVAADDU_VX_M8, 45 },
    { PseudoVAADDU_VX_MF2, 46 },
    { PseudoVAADDU_VX_MF4, 47 },
    { PseudoVAADDU_VX_MF8, 48 },
    { PseudoVAADD_VV_M1, 49 },
    { PseudoVAADD_VV_M2, 50 },
    { PseudoVAADD_VV_M4, 51 },
    { PseudoVAADD_VV_M8, 52 },
    { PseudoVAADD_VV_MF2, 53 },
    { PseudoVAADD_VV_MF4, 54 },
    { PseudoVAADD_VV_MF8, 55 },
    { PseudoVAADD_VX_M1, 56 },
    { PseudoVAADD_VX_M2, 57 },
    { PseudoVAADD_VX_M4, 58 },
    { PseudoVAADD_VX_M8, 59 },
    { PseudoVAADD_VX_MF2, 60 },
    { PseudoVAADD_VX_MF4, 61 },
    { PseudoVAADD_VX_MF8, 62 },
    { PseudoVADD_VI_M1, 63 },
    { PseudoVADD_VI_M2, 64 },
    { PseudoVADD_VI_M4, 65 },
    { PseudoVADD_VI_M8, 66 },
    { PseudoVADD_VI_MF2, 67 },
    { PseudoVADD_VI_MF4, 68 },
    { PseudoVADD_VI_MF8, 69 },
    { PseudoVADD_VV_M1, 70 },
    { PseudoVADD_VV_M2, 71 },
    { PseudoVADD_VV_M4, 72 },
    { PseudoVADD_VV_M8, 73 },
    { PseudoVADD_VV_MF2, 74 },
    { PseudoVADD_VV_MF4, 75 },
    { PseudoVADD_VV_MF8, 76 },
    { PseudoVADD_VX_M1, 77 },
    { PseudoVADD_VX_M2, 78 },
    { PseudoVADD_VX_M4, 79 },
    { PseudoVADD_VX_M8, 80 },
    { PseudoVADD_VX_MF2, 81 },
    { PseudoVADD_VX_MF4, 82 },
    { PseudoVADD_VX_MF8, 83 },
    { PseudoVAND_VI_M1, 84 },
    { PseudoVAND_VI_M2, 85 },
    { PseudoVAND_VI_M4, 86 },
    { PseudoVAND_VI_M8, 87 },
    { PseudoVAND_VI_MF2, 88 },
    { PseudoVAND_VI_MF4, 89 },
    { PseudoVAND_VI_MF8, 90 },
    { PseudoVAND_VV_M1, 91 },
    { PseudoVAND_VV_M2, 92 },
    { PseudoVAND_VV_M4, 93 },
    { PseudoVAND_VV_M8, 94 },
    { PseudoVAND_VV_MF2, 95 },
    { PseudoVAND_VV_MF4, 96 },
    { PseudoVAND_VV_MF8, 97 },
    { PseudoVAND_VX_M1, 98 },
    { PseudoVAND_VX_M2, 99 },
    { PseudoVAND_VX_M4, 100 },
    { PseudoVAND_VX_M8, 101 },
    { PseudoVAND_VX_MF2, 102 },
    { PseudoVAND_VX_MF4, 103 },
    { PseudoVAND_VX_MF8, 104 },
    { PseudoVASUBU_VV_M1, 105 },
    { PseudoVASUBU_VV_M2, 106 },
    { PseudoVASUBU_VV_M4, 107 },
    { PseudoVASUBU_VV_M8, 108 },
    { PseudoVASUBU_VV_MF2, 109 },
    { PseudoVASUBU_VV_MF4, 110 },
    { PseudoVASUBU_VV_MF8, 111 },
    { PseudoVASUBU_VX_M1, 112 },
    { PseudoVASUBU_VX_M2, 113 },
    { PseudoVASUBU_VX_M4, 114 },
    { PseudoVASUBU_VX_M8, 115 },
    { PseudoVASUBU_VX_MF2, 116 },
    { PseudoVASUBU_VX_MF4, 117 },
    { PseudoVASUBU_VX_MF8, 118 },
    { PseudoVASUB_VV_M1, 119 },
    { PseudoVASUB_VV_M2, 120 },
    { PseudoVASUB_VV_M4, 121 },
    { PseudoVASUB_VV_M8, 122 },
    { PseudoVASUB_VV_MF2, 123 },
    { PseudoVASUB_VV_MF4, 124 },
    { PseudoVASUB_VV_MF8, 125 },
    { PseudoVASUB_VX_M1, 126 },
    { PseudoVASUB_VX_M2, 127 },
    { PseudoVASUB_VX_M4, 128 },
    { PseudoVASUB_VX_M8, 129 },
    { PseudoVASUB_VX_MF2, 130 },
    { PseudoVASUB_VX_MF4, 131 },
    { PseudoVASUB_VX_MF8, 132 },
    { PseudoVDIVU_VV_M1_E16, 133 },
    { PseudoVDIVU_VV_M1_E32, 134 },
    { PseudoVDIVU_VV_M1_E64, 135 },
    { PseudoVDIVU_VV_M1_E8, 136 },
    { PseudoVDIVU_VV_M2_E16, 137 },
    { PseudoVDIVU_VV_M2_E32, 138 },
    { PseudoVDIVU_VV_M2_E64, 139 },
    { PseudoVDIVU_VV_M2_E8, 140 },
    { PseudoVDIVU_VV_M4_E16, 141 },
    { PseudoVDIVU_VV_M4_E32, 142 },
    { PseudoVDIVU_VV_M4_E64, 143 },
    { PseudoVDIVU_VV_M4_E8, 144 },
    { PseudoVDIVU_VV_M8_E16, 145 },
    { PseudoVDIVU_VV_M8_E32, 146 },
    { PseudoVDIVU_VV_M8_E64, 147 },
    { PseudoVDIVU_VV_M8_E8, 148 },
    { PseudoVDIVU_VV_MF2_E16, 149 },
    { PseudoVDIVU_VV_MF2_E32, 150 },
    { PseudoVDIVU_VV_MF2_E8, 151 },
    { PseudoVDIVU_VV_MF4_E16, 152 },
    { PseudoVDIVU_VV_MF4_E8, 153 },
    { PseudoVDIVU_VV_MF8_E8, 154 },
    { PseudoVDIVU_VX_M1_E16, 155 },
    { PseudoVDIVU_VX_M1_E32, 156 },
    { PseudoVDIVU_VX_M1_E64, 157 },
    { PseudoVDIVU_VX_M1_E8, 158 },
    { PseudoVDIVU_VX_M2_E16, 159 },
    { PseudoVDIVU_VX_M2_E32, 160 },
    { PseudoVDIVU_VX_M2_E64, 161 },
    { PseudoVDIVU_VX_M2_E8, 162 },
    { PseudoVDIVU_VX_M4_E16, 163 },
    { PseudoVDIVU_VX_M4_E32, 164 },
    { PseudoVDIVU_VX_M4_E64, 165 },
    { PseudoVDIVU_VX_M4_E8, 166 },
    { PseudoVDIVU_VX_M8_E16, 167 },
    { PseudoVDIVU_VX_M8_E32, 168 },
    { PseudoVDIVU_VX_M8_E64, 169 },
    { PseudoVDIVU_VX_M8_E8, 170 },
    { PseudoVDIVU_VX_MF2_E16, 171 },
    { PseudoVDIVU_VX_MF2_E32, 172 },
    { PseudoVDIVU_VX_MF2_E8, 173 },
    { PseudoVDIVU_VX_MF4_E16, 174 },
    { PseudoVDIVU_VX_MF4_E8, 175 },
    { PseudoVDIVU_VX_MF8_E8, 176 },
    { PseudoVDIV_VV_M1_E16, 177 },
    { PseudoVDIV_VV_M1_E32, 178 },
    { PseudoVDIV_VV_M1_E64, 179 },
    { PseudoVDIV_VV_M1_E8, 180 },
    { PseudoVDIV_VV_M2_E16, 181 },
    { PseudoVDIV_VV_M2_E32, 182 },
    { PseudoVDIV_VV_M2_E64, 183 },
    { PseudoVDIV_VV_M2_E8, 184 },
    { PseudoVDIV_VV_M4_E16, 185 },
    { PseudoVDIV_VV_M4_E32, 186 },
    { PseudoVDIV_VV_M4_E64, 187 },
    { PseudoVDIV_VV_M4_E8, 188 },
    { PseudoVDIV_VV_M8_E16, 189 },
    { PseudoVDIV_VV_M8_E32, 190 },
    { PseudoVDIV_VV_M8_E64, 191 },
    { PseudoVDIV_VV_M8_E8, 192 },
    { PseudoVDIV_VV_MF2_E16, 193 },
    { PseudoVDIV_VV_MF2_E32, 194 },
    { PseudoVDIV_VV_MF2_E8, 195 },
    { PseudoVDIV_VV_MF4_E16, 196 },
    { PseudoVDIV_VV_MF4_E8, 197 },
    { PseudoVDIV_VV_MF8_E8, 198 },
    { PseudoVDIV_VX_M1_E16, 199 },
    { PseudoVDIV_VX_M1_E32, 200 },
    { PseudoVDIV_VX_M1_E64, 201 },
    { PseudoVDIV_VX_M1_E8, 202 },
    { PseudoVDIV_VX_M2_E16, 203 },
    { PseudoVDIV_VX_M2_E32, 204 },
    { PseudoVDIV_VX_M2_E64, 205 },
    { PseudoVDIV_VX_M2_E8, 206 },
    { PseudoVDIV_VX_M4_E16, 207 },
    { PseudoVDIV_VX_M4_E32, 208 },
    { PseudoVDIV_VX_M4_E64, 209 },
    { PseudoVDIV_VX_M4_E8, 210 },
    { PseudoVDIV_VX_M8_E16, 211 },
    { PseudoVDIV_VX_M8_E32, 212 },
    { PseudoVDIV_VX_M8_E64, 213 },
    { PseudoVDIV_VX_M8_E8, 214 },
    { PseudoVDIV_VX_MF2_E16, 215 },
    { PseudoVDIV_VX_MF2_E32, 216 },
    { PseudoVDIV_VX_MF2_E8, 217 },
    { PseudoVDIV_VX_MF4_E16, 218 },
    { PseudoVDIV_VX_MF4_E8, 219 },
    { PseudoVDIV_VX_MF8_E8, 220 },
    { PseudoVFADD_VF16_M1, 221 },
    { PseudoVFADD_VF16_M2, 222 },
    { PseudoVFADD_VF16_M4, 223 },
    { PseudoVFADD_VF16_M8, 224 },
    { PseudoVFADD_VF16_MF2, 225 },
    { PseudoVFADD_VF16_MF4, 226 },
    { PseudoVFADD_VF32_M1, 227 },
    { PseudoVFADD_VF32_M2, 228 },
    { PseudoVFADD_VF32_M4, 229 },
    { PseudoVFADD_VF32_M8, 230 },
    { PseudoVFADD_VF32_MF2, 231 },
    { PseudoVFADD_VF64_M1, 232 },
    { PseudoVFADD_VF64_M2, 233 },
    { PseudoVFADD_VF64_M4, 234 },
    { PseudoVFADD_VF64_M8, 235 },
    { PseudoVFADD_VV_M1, 236 },
    { PseudoVFADD_VV_M2, 237 },
    { PseudoVFADD_VV_M4, 238 },
    { PseudoVFADD_VV_M8, 239 },
    { PseudoVFADD_VV_MF2, 240 },
    { PseudoVFADD_VV_MF4, 241 },
    { PseudoVFCLASS_V_M1, 242 },
    { PseudoVFCLASS_V_M2, 243 },
    { PseudoVFCLASS_V_M4, 244 },
    { PseudoVFCLASS_V_M8, 245 },
    { PseudoVFCLASS_V_MF2, 246 },
    { PseudoVFCLASS_V_MF4, 247 },
    { PseudoVFCVT_F_XU_V_M1, 248 },
    { PseudoVFCVT_F_XU_V_M2, 249 },
    { PseudoVFCVT_F_XU_V_M4, 250 },
    { PseudoVFCVT_F_XU_V_M8, 251 },
    { PseudoVFCVT_F_XU_V_MF2, 252 },
    { PseudoVFCVT_F_XU_V_MF4, 253 },
    { PseudoVFCVT_F_X_V_M1, 254 },
    { PseudoVFCVT_F_X_V_M2, 255 },
    { PseudoVFCVT_F_X_V_M4, 256 },
    { PseudoVFCVT_F_X_V_M8, 257 },
    { PseudoVFCVT_F_X_V_MF2, 258 },
    { PseudoVFCVT_F_X_V_MF4, 259 },
    { PseudoVFCVT_RTZ_XU_F_V_M1, 260 },
    { PseudoVFCVT_RTZ_XU_F_V_M2, 261 },
    { PseudoVFCVT_RTZ_XU_F_V_M4, 262 },
    { PseudoVFCVT_RTZ_XU_F_V_M8, 263 },
    { PseudoVFCVT_RTZ_XU_F_V_MF2, 264 },
    { PseudoVFCVT_RTZ_XU_F_V_MF4, 265 },
    { PseudoVFCVT_RTZ_X_F_V_M1, 266 },
    { PseudoVFCVT_RTZ_X_F_V_M2, 267 },
    { PseudoVFCVT_RTZ_X_F_V_M4, 268 },
    { PseudoVFCVT_RTZ_X_F_V_M8, 269 },
    { PseudoVFCVT_RTZ_X_F_V_MF2, 270 },
    { PseudoVFCVT_RTZ_X_F_V_MF4, 271 },
    { PseudoVFCVT_XU_F_V_M1, 272 },
    { PseudoVFCVT_XU_F_V_M2, 273 },
    { PseudoVFCVT_XU_F_V_M4, 274 },
    { PseudoVFCVT_XU_F_V_M8, 275 },
    { PseudoVFCVT_XU_F_V_MF2, 276 },
    { PseudoVFCVT_XU_F_V_MF4, 277 },
    { PseudoVFCVT_X_F_V_M1, 278 },
    { PseudoVFCVT_X_F_V_M2, 279 },
    { PseudoVFCVT_X_F_V_M4, 280 },
    { PseudoVFCVT_X_F_V_M8, 281 },
    { PseudoVFCVT_X_F_V_MF2, 282 },
    { PseudoVFCVT_X_F_V_MF4, 283 },
    { PseudoVFDIV_VF16_M1_E16, 284 },
    { PseudoVFDIV_VF16_M1_E32, 285 },
    { PseudoVFDIV_VF16_M1_E64, 286 },
    { PseudoVFDIV_VF16_M2_E16, 287 },
    { PseudoVFDIV_VF16_M2_E32, 288 },
    { PseudoVFDIV_VF16_M2_E64, 289 },
    { PseudoVFDIV_VF16_M4_E16, 290 },
    { PseudoVFDIV_VF16_M4_E32, 291 },
    { PseudoVFDIV_VF16_M4_E64, 292 },
    { PseudoVFDIV_VF16_M8_E16, 293 },
    { PseudoVFDIV_VF16_M8_E32, 294 },
    { PseudoVFDIV_VF16_M8_E64, 295 },
    { PseudoVFDIV_VF16_MF2_E16, 296 },
    { PseudoVFDIV_VF16_MF2_E32, 297 },
    { PseudoVFDIV_VF16_MF4_E16, 298 },
    { PseudoVFDIV_VF32_M1_E16, 299 },
    { PseudoVFDIV_VF32_M1_E32, 300 },
    { PseudoVFDIV_VF32_M1_E64, 301 },
    { PseudoVFDIV_VF32_M2_E16, 302 },
    { PseudoVFDIV_VF32_M2_E32, 303 },
    { PseudoVFDIV_VF32_M2_E64, 304 },
    { PseudoVFDIV_VF32_M4_E16, 305 },
    { PseudoVFDIV_VF32_M4_E32, 306 },
    { PseudoVFDIV_VF32_M4_E64, 307 },
    { PseudoVFDIV_VF32_M8_E16, 308 },
    { PseudoVFDIV_VF32_M8_E32, 309 },
    { PseudoVFDIV_VF32_M8_E64, 310 },
    { PseudoVFDIV_VF32_MF2_E16, 311 },
    { PseudoVFDIV_VF32_MF2_E32, 312 },
    { PseudoVFDIV_VF64_M1_E16, 313 },
    { PseudoVFDIV_VF64_M1_E32, 314 },
    { PseudoVFDIV_VF64_M1_E64, 315 },
    { PseudoVFDIV_VF64_M2_E16, 316 },
    { PseudoVFDIV_VF64_M2_E32, 317 },
    { PseudoVFDIV_VF64_M2_E64, 318 },
    { PseudoVFDIV_VF64_M4_E16, 319 },
    { PseudoVFDIV_VF64_M4_E32, 320 },
    { PseudoVFDIV_VF64_M4_E64, 321 },
    { PseudoVFDIV_VF64_M8_E16, 322 },
    { PseudoVFDIV_VF64_M8_E32, 323 },
    { PseudoVFDIV_VF64_M8_E64, 324 },
    { PseudoVFDIV_VV_M1_E16, 325 },
    { PseudoVFDIV_VV_M1_E32, 326 },
    { PseudoVFDIV_VV_M1_E64, 327 },
    { PseudoVFDIV_VV_M2_E16, 328 },
    { PseudoVFDIV_VV_M2_E32, 329 },
    { PseudoVFDIV_VV_M2_E64, 330 },
    { PseudoVFDIV_VV_M4_E16, 331 },
    { PseudoVFDIV_VV_M4_E32, 332 },
    { PseudoVFDIV_VV_M4_E64, 333 },
    { PseudoVFDIV_VV_M8_E16, 334 },
    { PseudoVFDIV_VV_M8_E32, 335 },
    { PseudoVFDIV_VV_M8_E64, 336 },
    { PseudoVFDIV_VV_MF2_E16, 337 },
    { PseudoVFDIV_VV_MF2_E32, 338 },
    { PseudoVFDIV_VV_MF4_E16, 339 },
    { PseudoVFMACC_VF16_M1, 340 },
    { PseudoVFMACC_VF16_M2, 341 },
    { PseudoVFMACC_VF16_M4, 342 },
    { PseudoVFMACC_VF16_M8, 343 },
    { PseudoVFMACC_VF16_MF2, 344 },
    { PseudoVFMACC_VF16_MF4, 345 },
    { PseudoVFMACC_VF32_M1, 346 },
    { PseudoVFMACC_VF32_M2, 347 },
    { PseudoVFMACC_VF32_M4, 348 },
    { PseudoVFMACC_VF32_M8, 349 },
    { PseudoVFMACC_VF32_MF2, 350 },
    { PseudoVFMACC_VF64_M1, 351 },
    { PseudoVFMACC_VF64_M2, 352 },
    { PseudoVFMACC_VF64_M4, 353 },
    { PseudoVFMACC_VF64_M8, 354 },
    { PseudoVFMACC_VV_M1, 355 },
    { PseudoVFMACC_VV_M2, 356 },
    { PseudoVFMACC_VV_M4, 357 },
    { PseudoVFMACC_VV_M8, 358 },
    { PseudoVFMACC_VV_MF2, 359 },
    { PseudoVFMACC_VV_MF4, 360 },
    { PseudoVFMADD_VF16_M1, 361 },
    { PseudoVFMADD_VF16_M2, 362 },
    { PseudoVFMADD_VF16_M4, 363 },
    { PseudoVFMADD_VF16_M8, 364 },
    { PseudoVFMADD_VF16_MF2, 365 },
    { PseudoVFMADD_VF16_MF4, 366 },
    { PseudoVFMADD_VF32_M1, 367 },
    { PseudoVFMADD_VF32_M2, 368 },
    { PseudoVFMADD_VF32_M4, 369 },
    { PseudoVFMADD_VF32_M8, 370 },
    { PseudoVFMADD_VF32_MF2, 371 },
    { PseudoVFMADD_VF64_M1, 372 },
    { PseudoVFMADD_VF64_M2, 373 },
    { PseudoVFMADD_VF64_M4, 374 },
    { PseudoVFMADD_VF64_M8, 375 },
    { PseudoVFMADD_VV_M1, 376 },
    { PseudoVFMADD_VV_M2, 377 },
    { PseudoVFMADD_VV_M4, 378 },
    { PseudoVFMADD_VV_M8, 379 },
    { PseudoVFMADD_VV_MF2, 380 },
    { PseudoVFMADD_VV_MF4, 381 },
    { PseudoVFMAX_VF16_M1, 382 },
    { PseudoVFMAX_VF16_M2, 383 },
    { PseudoVFMAX_VF16_M4, 384 },
    { PseudoVFMAX_VF16_M8, 385 },
    { PseudoVFMAX_VF16_MF2, 386 },
    { PseudoVFMAX_VF16_MF4, 387 },
    { PseudoVFMAX_VF32_M1, 388 },
    { PseudoVFMAX_VF32_M2, 389 },
    { PseudoVFMAX_VF32_M4, 390 },
    { PseudoVFMAX_VF32_M8, 391 },
    { PseudoVFMAX_VF32_MF2, 392 },
    { PseudoVFMAX_VF64_M1, 393 },
    { PseudoVFMAX_VF64_M2, 394 },
    { PseudoVFMAX_VF64_M4, 395 },
    { PseudoVFMAX_VF64_M8, 396 },
    { PseudoVFMAX_VV_M1, 397 },
    { PseudoVFMAX_VV_M2, 398 },
    { PseudoVFMAX_VV_M4, 399 },
    { PseudoVFMAX_VV_M8, 400 },
    { PseudoVFMAX_VV_MF2, 401 },
    { PseudoVFMAX_VV_MF4, 402 },
    { PseudoVFMIN_VF16_M1, 403 },
    { PseudoVFMIN_VF16_M2, 404 },
    { PseudoVFMIN_VF16_M4, 405 },
    { PseudoVFMIN_VF16_M8, 406 },
    { PseudoVFMIN_VF16_MF2, 407 },
    { PseudoVFMIN_VF16_MF4, 408 },
    { PseudoVFMIN_VF32_M1, 409 },
    { PseudoVFMIN_VF32_M2, 410 },
    { PseudoVFMIN_VF32_M4, 411 },
    { PseudoVFMIN_VF32_M8, 412 },
    { PseudoVFMIN_VF32_MF2, 413 },
    { PseudoVFMIN_VF64_M1, 414 },
    { PseudoVFMIN_VF64_M2, 415 },
    { PseudoVFMIN_VF64_M4, 416 },
    { PseudoVFMIN_VF64_M8, 417 },
    { PseudoVFMIN_VV_M1, 418 },
    { PseudoVFMIN_VV_M2, 419 },
    { PseudoVFMIN_VV_M4, 420 },
    { PseudoVFMIN_VV_M8, 421 },
    { PseudoVFMIN_VV_MF2, 422 },
    { PseudoVFMIN_VV_MF4, 423 },
    { PseudoVFMSAC_VF16_M1, 424 },
    { PseudoVFMSAC_VF16_M2, 425 },
    { PseudoVFMSAC_VF16_M4, 426 },
    { PseudoVFMSAC_VF16_M8, 427 },
    { PseudoVFMSAC_VF16_MF2, 428 },
    { PseudoVFMSAC_VF16_MF4, 429 },
    { PseudoVFMSAC_VF32_M1, 430 },
    { PseudoVFMSAC_VF32_M2, 431 },
    { PseudoVFMSAC_VF32_M4, 432 },
    { PseudoVFMSAC_VF32_M8, 433 },
    { PseudoVFMSAC_VF32_MF2, 434 },
    { PseudoVFMSAC_VF64_M1, 435 },
    { PseudoVFMSAC_VF64_M2, 436 },
    { PseudoVFMSAC_VF64_M4, 437 },
    { PseudoVFMSAC_VF64_M8, 438 },
    { PseudoVFMSAC_VV_M1, 439 },
    { PseudoVFMSAC_VV_M2, 440 },
    { PseudoVFMSAC_VV_M4, 441 },
    { PseudoVFMSAC_VV_M8, 442 },
    { PseudoVFMSAC_VV_MF2, 443 },
    { PseudoVFMSAC_VV_MF4, 444 },
    { PseudoVFMSUB_VF16_M1, 445 },
    { PseudoVFMSUB_VF16_M2, 446 },
    { PseudoVFMSUB_VF16_M4, 447 },
    { PseudoVFMSUB_VF16_M8, 448 },
    { PseudoVFMSUB_VF16_MF2, 449 },
    { PseudoVFMSUB_VF16_MF4, 450 },
    { PseudoVFMSUB_VF32_M1, 451 },
    { PseudoVFMSUB_VF32_M2, 452 },
    { PseudoVFMSUB_VF32_M4, 453 },
    { PseudoVFMSUB_VF32_M8, 454 },
    { PseudoVFMSUB_VF32_MF2, 455 },
    { PseudoVFMSUB_VF64_M1, 456 },
    { PseudoVFMSUB_VF64_M2, 457 },
    { PseudoVFMSUB_VF64_M4, 458 },
    { PseudoVFMSUB_VF64_M8, 459 },
    { PseudoVFMSUB_VV_M1, 460 },
    { PseudoVFMSUB_VV_M2, 461 },
    { PseudoVFMSUB_VV_M4, 462 },
    { PseudoVFMSUB_VV_M8, 463 },
    { PseudoVFMSUB_VV_MF2, 464 },
    { PseudoVFMSUB_VV_MF4, 465 },
    { PseudoVFMUL_VF16_M1, 466 },
    { PseudoVFMUL_VF16_M2, 467 },
    { PseudoVFMUL_VF16_M4, 468 },
    { PseudoVFMUL_VF16_M8, 469 },
    { PseudoVFMUL_VF16_MF2, 470 },
    { PseudoVFMUL_VF16_MF4, 471 },
    { PseudoVFMUL_VF32_M1, 472 },
    { PseudoVFMUL_VF32_M2, 473 },
    { PseudoVFMUL_VF32_M4, 474 },
    { PseudoVFMUL_VF32_M8, 475 },
    { PseudoVFMUL_VF32_MF2, 476 },
    { PseudoVFMUL_VF64_M1, 477 },
    { PseudoVFMUL_VF64_M2, 478 },
    { PseudoVFMUL_VF64_M4, 479 },
    { PseudoVFMUL_VF64_M8, 480 },
    { PseudoVFMUL_VV_M1, 481 },
    { PseudoVFMUL_VV_M2, 482 },
    { PseudoVFMUL_VV_M4, 483 },
    { PseudoVFMUL_VV_M8, 484 },
    { PseudoVFMUL_VV_MF2, 485 },
    { PseudoVFMUL_VV_MF4, 486 },
    { PseudoVFNCVT_F_F_W_M1, 487 },
    { PseudoVFNCVT_F_F_W_M2, 488 },
    { PseudoVFNCVT_F_F_W_M4, 489 },
    { PseudoVFNCVT_F_F_W_MF2, 490 },
    { PseudoVFNCVT_F_F_W_MF4, 491 },
    { PseudoVFNCVT_F_XU_W_M1, 492 },
    { PseudoVFNCVT_F_XU_W_M2, 493 },
    { PseudoVFNCVT_F_XU_W_M4, 494 },
    { PseudoVFNCVT_F_XU_W_MF2, 495 },
    { PseudoVFNCVT_F_XU_W_MF4, 496 },
    { PseudoVFNCVT_F_X_W_M1, 497 },
    { PseudoVFNCVT_F_X_W_M2, 498 },
    { PseudoVFNCVT_F_X_W_M4, 499 },
    { PseudoVFNCVT_F_X_W_MF2, 500 },
    { PseudoVFNCVT_F_X_W_MF4, 501 },
    { PseudoVFNCVT_ROD_F_F_W_M1, 502 },
    { PseudoVFNCVT_ROD_F_F_W_M2, 503 },
    { PseudoVFNCVT_ROD_F_F_W_M4, 504 },
    { PseudoVFNCVT_ROD_F_F_W_MF2, 505 },
    { PseudoVFNCVT_ROD_F_F_W_MF4, 506 },
    { PseudoVFNCVT_RTZ_XU_F_W_M1, 507 },
    { PseudoVFNCVT_RTZ_XU_F_W_M2, 508 },
    { PseudoVFNCVT_RTZ_XU_F_W_M4, 509 },
    { PseudoVFNCVT_RTZ_XU_F_W_MF2, 510 },
    { PseudoVFNCVT_RTZ_XU_F_W_MF4, 511 },
    { PseudoVFNCVT_RTZ_XU_F_W_MF8, 512 },
    { PseudoVFNCVT_RTZ_X_F_W_M1, 513 },
    { PseudoVFNCVT_RTZ_X_F_W_M2, 514 },
    { PseudoVFNCVT_RTZ_X_F_W_M4, 515 },
    { PseudoVFNCVT_RTZ_X_F_W_MF2, 516 },
    { PseudoVFNCVT_RTZ_X_F_W_MF4, 517 },
    { PseudoVFNCVT_RTZ_X_F_W_MF8, 518 },
    { PseudoVFNCVT_XU_F_W_M1, 519 },
    { PseudoVFNCVT_XU_F_W_M2, 520 },
    { PseudoVFNCVT_XU_F_W_M4, 521 },
    { PseudoVFNCVT_XU_F_W_MF2, 522 },
    { PseudoVFNCVT_XU_F_W_MF4, 523 },
    { PseudoVFNCVT_XU_F_W_MF8, 524 },
    { PseudoVFNCVT_X_F_W_M1, 525 },
    { PseudoVFNCVT_X_F_W_M2, 526 },
    { PseudoVFNCVT_X_F_W_M4, 527 },
    { PseudoVFNCVT_X_F_W_MF2, 528 },
    { PseudoVFNCVT_X_F_W_MF4, 529 },
    { PseudoVFNCVT_X_F_W_MF8, 530 },
    { PseudoVFNMACC_VF16_M1, 531 },
    { PseudoVFNMACC_VF16_M2, 532 },
    { PseudoVFNMACC_VF16_M4, 533 },
    { PseudoVFNMACC_VF16_M8, 534 },
    { PseudoVFNMACC_VF16_MF2, 535 },
    { PseudoVFNMACC_VF16_MF4, 536 },
    { PseudoVFNMACC_VF32_M1, 537 },
    { PseudoVFNMACC_VF32_M2, 538 },
    { PseudoVFNMACC_VF32_M4, 539 },
    { PseudoVFNMACC_VF32_M8, 540 },
    { PseudoVFNMACC_VF32_MF2, 541 },
    { PseudoVFNMACC_VF64_M1, 542 },
    { PseudoVFNMACC_VF64_M2, 543 },
    { PseudoVFNMACC_VF64_M4, 544 },
    { PseudoVFNMACC_VF64_M8, 545 },
    { PseudoVFNMACC_VV_M1, 546 },
    { PseudoVFNMACC_VV_M2, 547 },
    { PseudoVFNMACC_VV_M4, 548 },
    { PseudoVFNMACC_VV_M8, 549 },
    { PseudoVFNMACC_VV_MF2, 550 },
    { PseudoVFNMACC_VV_MF4, 551 },
    { PseudoVFNMADD_VF16_M1, 552 },
    { PseudoVFNMADD_VF16_M2, 553 },
    { PseudoVFNMADD_VF16_M4, 554 },
    { PseudoVFNMADD_VF16_M8, 555 },
    { PseudoVFNMADD_VF16_MF2, 556 },
    { PseudoVFNMADD_VF16_MF4, 557 },
    { PseudoVFNMADD_VF32_M1, 558 },
    { PseudoVFNMADD_VF32_M2, 559 },
    { PseudoVFNMADD_VF32_M4, 560 },
    { PseudoVFNMADD_VF32_M8, 561 },
    { PseudoVFNMADD_VF32_MF2, 562 },
    { PseudoVFNMADD_VF64_M1, 563 },
    { PseudoVFNMADD_VF64_M2, 564 },
    { PseudoVFNMADD_VF64_M4, 565 },
    { PseudoVFNMADD_VF64_M8, 566 },
    { PseudoVFNMADD_VV_M1, 567 },
    { PseudoVFNMADD_VV_M2, 568 },
    { PseudoVFNMADD_VV_M4, 569 },
    { PseudoVFNMADD_VV_M8, 570 },
    { PseudoVFNMADD_VV_MF2, 571 },
    { PseudoVFNMADD_VV_MF4, 572 },
    { PseudoVFNMSAC_VF16_M1, 573 },
    { PseudoVFNMSAC_VF16_M2, 574 },
    { PseudoVFNMSAC_VF16_M4, 575 },
    { PseudoVFNMSAC_VF16_M8, 576 },
    { PseudoVFNMSAC_VF16_MF2, 577 },
    { PseudoVFNMSAC_VF16_MF4, 578 },
    { PseudoVFNMSAC_VF32_M1, 579 },
    { PseudoVFNMSAC_VF32_M2, 580 },
    { PseudoVFNMSAC_VF32_M4, 581 },
    { PseudoVFNMSAC_VF32_M8, 582 },
    { PseudoVFNMSAC_VF32_MF2, 583 },
    { PseudoVFNMSAC_VF64_M1, 584 },
    { PseudoVFNMSAC_VF64_M2, 585 },
    { PseudoVFNMSAC_VF64_M4, 586 },
    { PseudoVFNMSAC_VF64_M8, 587 },
    { PseudoVFNMSAC_VV_M1, 588 },
    { PseudoVFNMSAC_VV_M2, 589 },
    { PseudoVFNMSAC_VV_M4, 590 },
    { PseudoVFNMSAC_VV_M8, 591 },
    { PseudoVFNMSAC_VV_MF2, 592 },
    { PseudoVFNMSAC_VV_MF4, 593 },
    { PseudoVFNMSUB_VF16_M1, 594 },
    { PseudoVFNMSUB_VF16_M2, 595 },
    { PseudoVFNMSUB_VF16_M4, 596 },
    { PseudoVFNMSUB_VF16_M8, 597 },
    { PseudoVFNMSUB_VF16_MF2, 598 },
    { PseudoVFNMSUB_VF16_MF4, 599 },
    { PseudoVFNMSUB_VF32_M1, 600 },
    { PseudoVFNMSUB_VF32_M2, 601 },
    { PseudoVFNMSUB_VF32_M4, 602 },
    { PseudoVFNMSUB_VF32_M8, 603 },
    { PseudoVFNMSUB_VF32_MF2, 604 },
    { PseudoVFNMSUB_VF64_M1, 605 },
    { PseudoVFNMSUB_VF64_M2, 606 },
    { PseudoVFNMSUB_VF64_M4, 607 },
    { PseudoVFNMSUB_VF64_M8, 608 },
    { PseudoVFNMSUB_VV_M1, 609 },
    { PseudoVFNMSUB_VV_M2, 610 },
    { PseudoVFNMSUB_VV_M4, 611 },
    { PseudoVFNMSUB_VV_M8, 612 },
    { PseudoVFNMSUB_VV_MF2, 613 },
    { PseudoVFNMSUB_VV_MF4, 614 },
    { PseudoVFRDIV_VF16_M1_E16, 615 },
    { PseudoVFRDIV_VF16_M1_E32, 616 },
    { PseudoVFRDIV_VF16_M1_E64, 617 },
    { PseudoVFRDIV_VF16_M2_E16, 618 },
    { PseudoVFRDIV_VF16_M2_E32, 619 },
    { PseudoVFRDIV_VF16_M2_E64, 620 },
    { PseudoVFRDIV_VF16_M4_E16, 621 },
    { PseudoVFRDIV_VF16_M4_E32, 622 },
    { PseudoVFRDIV_VF16_M4_E64, 623 },
    { PseudoVFRDIV_VF16_M8_E16, 624 },
    { PseudoVFRDIV_VF16_M8_E32, 625 },
    { PseudoVFRDIV_VF16_M8_E64, 626 },
    { PseudoVFRDIV_VF16_MF2_E16, 627 },
    { PseudoVFRDIV_VF16_MF2_E32, 628 },
    { PseudoVFRDIV_VF16_MF4_E16, 629 },
    { PseudoVFRDIV_VF32_M1_E16, 630 },
    { PseudoVFRDIV_VF32_M1_E32, 631 },
    { PseudoVFRDIV_VF32_M1_E64, 632 },
    { PseudoVFRDIV_VF32_M2_E16, 633 },
    { PseudoVFRDIV_VF32_M2_E32, 634 },
    { PseudoVFRDIV_VF32_M2_E64, 635 },
    { PseudoVFRDIV_VF32_M4_E16, 636 },
    { PseudoVFRDIV_VF32_M4_E32, 637 },
    { PseudoVFRDIV_VF32_M4_E64, 638 },
    { PseudoVFRDIV_VF32_M8_E16, 639 },
    { PseudoVFRDIV_VF32_M8_E32, 640 },
    { PseudoVFRDIV_VF32_M8_E64, 641 },
    { PseudoVFRDIV_VF32_MF2_E16, 642 },
    { PseudoVFRDIV_VF32_MF2_E32, 643 },
    { PseudoVFRDIV_VF64_M1_E16, 644 },
    { PseudoVFRDIV_VF64_M1_E32, 645 },
    { PseudoVFRDIV_VF64_M1_E64, 646 },
    { PseudoVFRDIV_VF64_M2_E16, 647 },
    { PseudoVFRDIV_VF64_M2_E32, 648 },
    { PseudoVFRDIV_VF64_M2_E64, 649 },
    { PseudoVFRDIV_VF64_M4_E16, 650 },
    { PseudoVFRDIV_VF64_M4_E32, 651 },
    { PseudoVFRDIV_VF64_M4_E64, 652 },
    { PseudoVFRDIV_VF64_M8_E16, 653 },
    { PseudoVFRDIV_VF64_M8_E32, 654 },
    { PseudoVFRDIV_VF64_M8_E64, 655 },
    { PseudoVFREC7_V_M1, 656 },
    { PseudoVFREC7_V_M2, 657 },
    { PseudoVFREC7_V_M4, 658 },
    { PseudoVFREC7_V_M8, 659 },
    { PseudoVFREC7_V_MF2, 660 },
    { PseudoVFREC7_V_MF4, 661 },
    { PseudoVFRSQRT7_V_M1, 662 },
    { PseudoVFRSQRT7_V_M2, 663 },
    { PseudoVFRSQRT7_V_M4, 664 },
    { PseudoVFRSQRT7_V_M8, 665 },
    { PseudoVFRSQRT7_V_MF2, 666 },
    { PseudoVFRSQRT7_V_MF4, 667 },
    { PseudoVFRSUB_VF16_M1, 668 },
    { PseudoVFRSUB_VF16_M2, 669 },
    { PseudoVFRSUB_VF16_M4, 670 },
    { PseudoVFRSUB_VF16_M8, 671 },
    { PseudoVFRSUB_VF16_MF2, 672 },
    { PseudoVFRSUB_VF16_MF4, 673 },
    { PseudoVFRSUB_VF32_M1, 674 },
    { PseudoVFRSUB_VF32_M2, 675 },
    { PseudoVFRSUB_VF32_M4, 676 },
    { PseudoVFRSUB_VF32_M8, 677 },
    { PseudoVFRSUB_VF32_MF2, 678 },
    { PseudoVFRSUB_VF64_M1, 679 },
    { PseudoVFRSUB_VF64_M2, 680 },
    { PseudoVFRSUB_VF64_M4, 681 },
    { PseudoVFRSUB_VF64_M8, 682 },
    { PseudoVFSGNJN_VF16_M1, 683 },
    { PseudoVFSGNJN_VF16_M2, 684 },
    { PseudoVFSGNJN_VF16_M4, 685 },
    { PseudoVFSGNJN_VF16_M8, 686 },
    { PseudoVFSGNJN_VF16_MF2, 687 },
    { PseudoVFSGNJN_VF16_MF4, 688 },
    { PseudoVFSGNJN_VF32_M1, 689 },
    { PseudoVFSGNJN_VF32_M2, 690 },
    { PseudoVFSGNJN_VF32_M4, 691 },
    { PseudoVFSGNJN_VF32_M8, 692 },
    { PseudoVFSGNJN_VF32_MF2, 693 },
    { PseudoVFSGNJN_VF64_M1, 694 },
    { PseudoVFSGNJN_VF64_M2, 695 },
    { PseudoVFSGNJN_VF64_M4, 696 },
    { PseudoVFSGNJN_VF64_M8, 697 },
    { PseudoVFSGNJN_VV_M1, 698 },
    { PseudoVFSGNJN_VV_M2, 699 },
    { PseudoVFSGNJN_VV_M4, 700 },
    { PseudoVFSGNJN_VV_M8, 701 },
    { PseudoVFSGNJN_VV_MF2, 702 },
    { PseudoVFSGNJN_VV_MF4, 703 },
    { PseudoVFSGNJX_VF16_M1, 704 },
    { PseudoVFSGNJX_VF16_M2, 705 },
    { PseudoVFSGNJX_VF16_M4, 706 },
    { PseudoVFSGNJX_VF16_M8, 707 },
    { PseudoVFSGNJX_VF16_MF2, 708 },
    { PseudoVFSGNJX_VF16_MF4, 709 },
    { PseudoVFSGNJX_VF32_M1, 710 },
    { PseudoVFSGNJX_VF32_M2, 711 },
    { PseudoVFSGNJX_VF32_M4, 712 },
    { PseudoVFSGNJX_VF32_M8, 713 },
    { PseudoVFSGNJX_VF32_MF2, 714 },
    { PseudoVFSGNJX_VF64_M1, 715 },
    { PseudoVFSGNJX_VF64_M2, 716 },
    { PseudoVFSGNJX_VF64_M4, 717 },
    { PseudoVFSGNJX_VF64_M8, 718 },
    { PseudoVFSGNJX_VV_M1, 719 },
    { PseudoVFSGNJX_VV_M2, 720 },
    { PseudoVFSGNJX_VV_M4, 721 },
    { PseudoVFSGNJX_VV_M8, 722 },
    { PseudoVFSGNJX_VV_MF2, 723 },
    { PseudoVFSGNJX_VV_MF4, 724 },
    { PseudoVFSGNJ_VF16_M1, 725 },
    { PseudoVFSGNJ_VF16_M2, 726 },
    { PseudoVFSGNJ_VF16_M4, 727 },
    { PseudoVFSGNJ_VF16_M8, 728 },
    { PseudoVFSGNJ_VF16_MF2, 729 },
    { PseudoVFSGNJ_VF16_MF4, 730 },
    { PseudoVFSGNJ_VF32_M1, 731 },
    { PseudoVFSGNJ_VF32_M2, 732 },
    { PseudoVFSGNJ_VF32_M4, 733 },
    { PseudoVFSGNJ_VF32_M8, 734 },
    { PseudoVFSGNJ_VF32_MF2, 735 },
    { PseudoVFSGNJ_VF64_M1, 736 },
    { PseudoVFSGNJ_VF64_M2, 737 },
    { PseudoVFSGNJ_VF64_M4, 738 },
    { PseudoVFSGNJ_VF64_M8, 739 },
    { PseudoVFSGNJ_VV_M1, 740 },
    { PseudoVFSGNJ_VV_M2, 741 },
    { PseudoVFSGNJ_VV_M4, 742 },
    { PseudoVFSGNJ_VV_M8, 743 },
    { PseudoVFSGNJ_VV_MF2, 744 },
    { PseudoVFSGNJ_VV_MF4, 745 },
    { PseudoVFSLIDE1DOWN_VF16_M1, 746 },
    { PseudoVFSLIDE1DOWN_VF16_M2, 747 },
    { PseudoVFSLIDE1DOWN_VF16_M4, 748 },
    { PseudoVFSLIDE1DOWN_VF16_M8, 749 },
    { PseudoVFSLIDE1DOWN_VF16_MF2, 750 },
    { PseudoVFSLIDE1DOWN_VF16_MF4, 751 },
    { PseudoVFSLIDE1DOWN_VF32_M1, 752 },
    { PseudoVFSLIDE1DOWN_VF32_M2, 753 },
    { PseudoVFSLIDE1DOWN_VF32_M4, 754 },
    { PseudoVFSLIDE1DOWN_VF32_M8, 755 },
    { PseudoVFSLIDE1DOWN_VF32_MF2, 756 },
    { PseudoVFSLIDE1DOWN_VF64_M1, 757 },
    { PseudoVFSLIDE1DOWN_VF64_M2, 758 },
    { PseudoVFSLIDE1DOWN_VF64_M4, 759 },
    { PseudoVFSLIDE1DOWN_VF64_M8, 760 },
    { PseudoVFSLIDE1UP_VF16_M1, 761 },
    { PseudoVFSLIDE1UP_VF16_M2, 762 },
    { PseudoVFSLIDE1UP_VF16_M4, 763 },
    { PseudoVFSLIDE1UP_VF16_M8, 764 },
    { PseudoVFSLIDE1UP_VF16_MF2, 765 },
    { PseudoVFSLIDE1UP_VF16_MF4, 766 },
    { PseudoVFSLIDE1UP_VF32_M1, 767 },
    { PseudoVFSLIDE1UP_VF32_M2, 768 },
    { PseudoVFSLIDE1UP_VF32_M4, 769 },
    { PseudoVFSLIDE1UP_VF32_M8, 770 },
    { PseudoVFSLIDE1UP_VF32_MF2, 771 },
    { PseudoVFSLIDE1UP_VF64_M1, 772 },
    { PseudoVFSLIDE1UP_VF64_M2, 773 },
    { PseudoVFSLIDE1UP_VF64_M4, 774 },
    { PseudoVFSLIDE1UP_VF64_M8, 775 },
    { PseudoVFSQRT_V_M1_E16, 776 },
    { PseudoVFSQRT_V_M1_E32, 777 },
    { PseudoVFSQRT_V_M1_E64, 778 },
    { PseudoVFSQRT_V_M2_E16, 779 },
    { PseudoVFSQRT_V_M2_E32, 780 },
    { PseudoVFSQRT_V_M2_E64, 781 },
    { PseudoVFSQRT_V_M4_E16, 782 },
    { PseudoVFSQRT_V_M4_E32, 783 },
    { PseudoVFSQRT_V_M4_E64, 784 },
    { PseudoVFSQRT_V_M8_E16, 785 },
    { PseudoVFSQRT_V_M8_E32, 786 },
    { PseudoVFSQRT_V_M8_E64, 787 },
    { PseudoVFSQRT_V_MF2_E16, 788 },
    { PseudoVFSQRT_V_MF2_E32, 789 },
    { PseudoVFSQRT_V_MF4_E16, 790 },
    { PseudoVFSUB_VF16_M1, 791 },
    { PseudoVFSUB_VF16_M2, 792 },
    { PseudoVFSUB_VF16_M4, 793 },
    { PseudoVFSUB_VF16_M8, 794 },
    { PseudoVFSUB_VF16_MF2, 795 },
    { PseudoVFSUB_VF16_MF4, 796 },
    { PseudoVFSUB_VF32_M1, 797 },
    { PseudoVFSUB_VF32_M2, 798 },
    { PseudoVFSUB_VF32_M4, 799 },
    { PseudoVFSUB_VF32_M8, 800 },
    { PseudoVFSUB_VF32_MF2, 801 },
    { PseudoVFSUB_VF64_M1, 802 },
    { PseudoVFSUB_VF64_M2, 803 },
    { PseudoVFSUB_VF64_M4, 804 },
    { PseudoVFSUB_VF64_M8, 805 },
    { PseudoVFSUB_VV_M1, 806 },
    { PseudoVFSUB_VV_M2, 807 },
    { PseudoVFSUB_VV_M4, 808 },
    { PseudoVFSUB_VV_M8, 809 },
    { PseudoVFSUB_VV_MF2, 810 },
    { PseudoVFSUB_VV_MF4, 811 },
    { PseudoVFWADD_VF16_M1, 812 },
    { PseudoVFWADD_VF16_M2, 813 },
    { PseudoVFWADD_VF16_M4, 814 },
    { PseudoVFWADD_VF16_MF2, 815 },
    { PseudoVFWADD_VF16_MF4, 816 },
    { PseudoVFWADD_VF32_M1, 817 },
    { PseudoVFWADD_VF32_M2, 818 },
    { PseudoVFWADD_VF32_M4, 819 },
    { PseudoVFWADD_VF32_MF2, 820 },
    { PseudoVFWADD_VV_M1, 821 },
    { PseudoVFWADD_VV_M2, 822 },
    { PseudoVFWADD_VV_M4, 823 },
    { PseudoVFWADD_VV_MF2, 824 },
    { PseudoVFWADD_VV_MF4, 825 },
    { PseudoVFWADD_WF16_M1, 826 },
    { PseudoVFWADD_WF16_M2, 827 },
    { PseudoVFWADD_WF16_M4, 828 },
    { PseudoVFWADD_WF16_MF2, 829 },
    { PseudoVFWADD_WF16_MF4, 830 },
    { PseudoVFWADD_WF32_M1, 831 },
    { PseudoVFWADD_WF32_M2, 832 },
    { PseudoVFWADD_WF32_M4, 833 },
    { PseudoVFWADD_WF32_MF2, 834 },
    { PseudoVFWADD_WV_M1, 835 },
    { PseudoVFWADD_WV_M2, 836 },
    { PseudoVFWADD_WV_M4, 837 },
    { PseudoVFWADD_WV_MF2, 838 },
    { PseudoVFWADD_WV_MF4, 839 },
    { PseudoVFWCVT_F_F_V_M1, 840 },
    { PseudoVFWCVT_F_F_V_M2, 841 },
    { PseudoVFWCVT_F_F_V_M4, 842 },
    { PseudoVFWCVT_F_F_V_MF2, 843 },
    { PseudoVFWCVT_F_F_V_MF4, 844 },
    { PseudoVFWCVT_F_XU_V_M1, 845 },
    { PseudoVFWCVT_F_XU_V_M2, 846 },
    { PseudoVFWCVT_F_XU_V_M4, 847 },
    { PseudoVFWCVT_F_XU_V_MF2, 848 },
    { PseudoVFWCVT_F_XU_V_MF4, 849 },
    { PseudoVFWCVT_F_XU_V_MF8, 850 },
    { PseudoVFWCVT_F_X_V_M1, 851 },
    { PseudoVFWCVT_F_X_V_M2, 852 },
    { PseudoVFWCVT_F_X_V_M4, 853 },
    { PseudoVFWCVT_F_X_V_MF2, 854 },
    { PseudoVFWCVT_F_X_V_MF4, 855 },
    { PseudoVFWCVT_F_X_V_MF8, 856 },
    { PseudoVFWCVT_RTZ_XU_F_V_M1, 857 },
    { PseudoVFWCVT_RTZ_XU_F_V_M2, 858 },
    { PseudoVFWCVT_RTZ_XU_F_V_M4, 859 },
    { PseudoVFWCVT_RTZ_XU_F_V_MF2, 860 },
    { PseudoVFWCVT_RTZ_XU_F_V_MF4, 861 },
    { PseudoVFWCVT_RTZ_X_F_V_M1, 862 },
    { PseudoVFWCVT_RTZ_X_F_V_M2, 863 },
    { PseudoVFWCVT_RTZ_X_F_V_M4, 864 },
    { PseudoVFWCVT_RTZ_X_F_V_MF2, 865 },
    { PseudoVFWCVT_RTZ_X_F_V_MF4, 866 },
    { PseudoVFWCVT_XU_F_V_M1, 867 },
    { PseudoVFWCVT_XU_F_V_M2, 868 },
    { PseudoVFWCVT_XU_F_V_M4, 869 },
    { PseudoVFWCVT_XU_F_V_MF2, 870 },
    { PseudoVFWCVT_XU_F_V_MF4, 871 },
    { PseudoVFWCVT_X_F_V_M1, 872 },
    { PseudoVFWCVT_X_F_V_M2, 873 },
    { PseudoVFWCVT_X_F_V_M4, 874 },
    { PseudoVFWCVT_X_F_V_MF2, 875 },
    { PseudoVFWCVT_X_F_V_MF4, 876 },
    { PseudoVFWMACC_VF16_M1, 877 },
    { PseudoVFWMACC_VF16_M2, 878 },
    { PseudoVFWMACC_VF16_M4, 879 },
    { PseudoVFWMACC_VF16_MF2, 880 },
    { PseudoVFWMACC_VF16_MF4, 881 },
    { PseudoVFWMACC_VF32_M1, 882 },
    { PseudoVFWMACC_VF32_M2, 883 },
    { PseudoVFWMACC_VF32_M4, 884 },
    { PseudoVFWMACC_VF32_MF2, 885 },
    { PseudoVFWMACC_VV_M1, 886 },
    { PseudoVFWMACC_VV_M2, 887 },
    { PseudoVFWMACC_VV_M4, 888 },
    { PseudoVFWMACC_VV_MF2, 889 },
    { PseudoVFWMACC_VV_MF4, 890 },
    { PseudoVFWMSAC_VF16_M1, 891 },
    { PseudoVFWMSAC_VF16_M2, 892 },
    { PseudoVFWMSAC_VF16_M4, 893 },
    { PseudoVFWMSAC_VF16_MF2, 894 },
    { PseudoVFWMSAC_VF16_MF4, 895 },
    { PseudoVFWMSAC_VF32_M1, 896 },
    { PseudoVFWMSAC_VF32_M2, 897 },
    { PseudoVFWMSAC_VF32_M4, 898 },
    { PseudoVFWMSAC_VF32_MF2, 899 },
    { PseudoVFWMSAC_VV_M1, 900 },
    { PseudoVFWMSAC_VV_M2, 901 },
    { PseudoVFWMSAC_VV_M4, 902 },
    { PseudoVFWMSAC_VV_MF2, 903 },
    { PseudoVFWMSAC_VV_MF4, 904 },
    { PseudoVFWMUL_VF16_M1, 905 },
    { PseudoVFWMUL_VF16_M2, 906 },
    { PseudoVFWMUL_VF16_M4, 907 },
    { PseudoVFWMUL_VF16_MF2, 908 },
    { PseudoVFWMUL_VF16_MF4, 909 },
    { PseudoVFWMUL_VF32_M1, 910 },
    { PseudoVFWMUL_VF32_M2, 911 },
    { PseudoVFWMUL_VF32_M4, 912 },
    { PseudoVFWMUL_VF32_MF2, 913 },
    { PseudoVFWMUL_VV_M1, 914 },
    { PseudoVFWMUL_VV_M2, 915 },
    { PseudoVFWMUL_VV_M4, 916 },
    { PseudoVFWMUL_VV_MF2, 917 },
    { PseudoVFWMUL_VV_MF4, 918 },
    { PseudoVFWNMACC_VF16_M1, 919 },
    { PseudoVFWNMACC_VF16_M2, 920 },
    { PseudoVFWNMACC_VF16_M4, 921 },
    { PseudoVFWNMACC_VF16_MF2, 922 },
    { PseudoVFWNMACC_VF16_MF4, 923 },
    { PseudoVFWNMACC_VF32_M1, 924 },
    { PseudoVFWNMACC_VF32_M2, 925 },
    { PseudoVFWNMACC_VF32_M4, 926 },
    { PseudoVFWNMACC_VF32_MF2, 927 },
    { PseudoVFWNMACC_VV_M1, 928 },
    { PseudoVFWNMACC_VV_M2, 929 },
    { PseudoVFWNMACC_VV_M4, 930 },
    { PseudoVFWNMACC_VV_MF2, 931 },
    { PseudoVFWNMACC_VV_MF4, 932 },
    { PseudoVFWNMSAC_VF16_M1, 933 },
    { PseudoVFWNMSAC_VF16_M2, 934 },
    { PseudoVFWNMSAC_VF16_M4, 935 },
    { PseudoVFWNMSAC_VF16_MF2, 936 },
    { PseudoVFWNMSAC_VF16_MF4, 937 },
    { PseudoVFWNMSAC_VF32_M1, 938 },
    { PseudoVFWNMSAC_VF32_M2, 939 },
    { PseudoVFWNMSAC_VF32_M4, 940 },
    { PseudoVFWNMSAC_VF32_MF2, 941 },
    { PseudoVFWNMSAC_VV_M1, 942 },
    { PseudoVFWNMSAC_VV_M2, 943 },
    { PseudoVFWNMSAC_VV_M4, 944 },
    { PseudoVFWNMSAC_VV_MF2, 945 },
    { PseudoVFWNMSAC_VV_MF4, 946 },
    { PseudoVFWSUB_VF16_M1, 947 },
    { PseudoVFWSUB_VF16_M2, 948 },
    { PseudoVFWSUB_VF16_M4, 949 },
    { PseudoVFWSUB_VF16_MF2, 950 },
    { PseudoVFWSUB_VF16_MF4, 951 },
    { PseudoVFWSUB_VF32_M1, 952 },
    { PseudoVFWSUB_VF32_M2, 953 },
    { PseudoVFWSUB_VF32_M4, 954 },
    { PseudoVFWSUB_VF32_MF2, 955 },
    { PseudoVFWSUB_VV_M1, 956 },
    { PseudoVFWSUB_VV_M2, 957 },
    { PseudoVFWSUB_VV_M4, 958 },
    { PseudoVFWSUB_VV_MF2, 959 },
    { PseudoVFWSUB_VV_MF4, 960 },
    { PseudoVFWSUB_WF16_M1, 961 },
    { PseudoVFWSUB_WF16_M2, 962 },
    { PseudoVFWSUB_WF16_M4, 963 },
    { PseudoVFWSUB_WF16_MF2, 964 },
    { PseudoVFWSUB_WF16_MF4, 965 },
    { PseudoVFWSUB_WF32_M1, 966 },
    { PseudoVFWSUB_WF32_M2, 967 },
    { PseudoVFWSUB_WF32_M4, 968 },
    { PseudoVFWSUB_WF32_MF2, 969 },
    { PseudoVFWSUB_WV_M1, 970 },
    { PseudoVFWSUB_WV_M2, 971 },
    { PseudoVFWSUB_WV_M4, 972 },
    { PseudoVFWSUB_WV_MF2, 973 },
    { PseudoVFWSUB_WV_MF4, 974 },
    { PseudoVID_V_M1, 975 },
    { PseudoVID_V_M2, 976 },
    { PseudoVID_V_M4, 977 },
    { PseudoVID_V_M8, 978 },
    { PseudoVID_V_MF2, 979 },
    { PseudoVID_V_MF4, 980 },
    { PseudoVID_V_MF8, 981 },
    { PseudoVIOTA_M_M1, 982 },
    { PseudoVIOTA_M_M2, 983 },
    { PseudoVIOTA_M_M4, 984 },
    { PseudoVIOTA_M_M8, 985 },
    { PseudoVIOTA_M_MF2, 986 },
    { PseudoVIOTA_M_MF4, 987 },
    { PseudoVIOTA_M_MF8, 988 },
    { PseudoVLE16FF_V_M1, 989 },
    { PseudoVLE16FF_V_M2, 990 },
    { PseudoVLE16FF_V_M4, 991 },
    { PseudoVLE16FF_V_M8, 992 },
    { PseudoVLE16FF_V_MF2, 993 },
    { PseudoVLE16FF_V_MF4, 994 },
    { PseudoVLE16_V_M1, 995 },
    { PseudoVLE16_V_M2, 996 },
    { PseudoVLE16_V_M4, 997 },
    { PseudoVLE16_V_M8, 998 },
    { PseudoVLE16_V_MF2, 999 },
    { PseudoVLE16_V_MF4, 1000 },
    { PseudoVLE32FF_V_M1, 1001 },
    { PseudoVLE32FF_V_M2, 1002 },
    { PseudoVLE32FF_V_M4, 1003 },
    { PseudoVLE32FF_V_M8, 1004 },
    { PseudoVLE32FF_V_MF2, 1005 },
    { PseudoVLE32_V_M1, 1006 },
    { PseudoVLE32_V_M2, 1007 },
    { PseudoVLE32_V_M4, 1008 },
    { PseudoVLE32_V_M8, 1009 },
    { PseudoVLE32_V_MF2, 1010 },
    { PseudoVLE64FF_V_M1, 1011 },
    { PseudoVLE64FF_V_M2, 1012 },
    { PseudoVLE64FF_V_M4, 1013 },
    { PseudoVLE64FF_V_M8, 1014 },
    { PseudoVLE64_V_M1, 1015 },
    { PseudoVLE64_V_M2, 1016 },
    { PseudoVLE64_V_M4, 1017 },
    { PseudoVLE64_V_M8, 1018 },
    { PseudoVLE8FF_V_M1, 1019 },
    { PseudoVLE8FF_V_M2, 1020 },
    { PseudoVLE8FF_V_M4, 1021 },
    { PseudoVLE8FF_V_M8, 1022 },
    { PseudoVLE8FF_V_MF2, 1023 },
    { PseudoVLE8FF_V_MF4, 1024 },
    { PseudoVLE8FF_V_MF8, 1025 },
    { PseudoVLE8_V_M1, 1026 },
    { PseudoVLE8_V_M2, 1027 },
    { PseudoVLE8_V_M4, 1028 },
    { PseudoVLE8_V_M8, 1029 },
    { PseudoVLE8_V_MF2, 1030 },
    { PseudoVLE8_V_MF4, 1031 },
    { PseudoVLE8_V_MF8, 1032 },
    { PseudoVLOXEI16_V_M1_M1, 1033 },
    { PseudoVLOXEI16_V_M1_M2, 1034 },
    { PseudoVLOXEI16_V_M1_M4, 1035 },
    { PseudoVLOXEI16_V_M1_MF2, 1036 },
    { PseudoVLOXEI16_V_M2_M1, 1037 },
    { PseudoVLOXEI16_V_M2_M2, 1038 },
    { PseudoVLOXEI16_V_M2_M4, 1039 },
    { PseudoVLOXEI16_V_M2_M8, 1040 },
    { PseudoVLOXEI16_V_M4_M2, 1041 },
    { PseudoVLOXEI16_V_M4_M4, 1042 },
    { PseudoVLOXEI16_V_M4_M8, 1043 },
    { PseudoVLOXEI16_V_M8_M4, 1044 },
    { PseudoVLOXEI16_V_M8_M8, 1045 },
    { PseudoVLOXEI16_V_MF2_M1, 1046 },
    { PseudoVLOXEI16_V_MF2_M2, 1047 },
    { PseudoVLOXEI16_V_MF2_MF2, 1048 },
    { PseudoVLOXEI16_V_MF2_MF4, 1049 },
    { PseudoVLOXEI16_V_MF4_M1, 1050 },
    { PseudoVLOXEI16_V_MF4_MF2, 1051 },
    { PseudoVLOXEI16_V_MF4_MF4, 1052 },
    { PseudoVLOXEI16_V_MF4_MF8, 1053 },
    { PseudoVLOXEI32_V_M1_M1, 1054 },
    { PseudoVLOXEI32_V_M1_M2, 1055 },
    { PseudoVLOXEI32_V_M1_MF2, 1056 },
    { PseudoVLOXEI32_V_M1_MF4, 1057 },
    { PseudoVLOXEI32_V_M2_M1, 1058 },
    { PseudoVLOXEI32_V_M2_M2, 1059 },
    { PseudoVLOXEI32_V_M2_M4, 1060 },
    { PseudoVLOXEI32_V_M2_MF2, 1061 },
    { PseudoVLOXEI32_V_M4_M1, 1062 },
    { PseudoVLOXEI32_V_M4_M2, 1063 },
    { PseudoVLOXEI32_V_M4_M4, 1064 },
    { PseudoVLOXEI32_V_M4_M8, 1065 },
    { PseudoVLOXEI32_V_M8_M2, 1066 },
    { PseudoVLOXEI32_V_M8_M4, 1067 },
    { PseudoVLOXEI32_V_M8_M8, 1068 },
    { PseudoVLOXEI32_V_MF2_M1, 1069 },
    { PseudoVLOXEI32_V_MF2_MF2, 1070 },
    { PseudoVLOXEI32_V_MF2_MF4, 1071 },
    { PseudoVLOXEI32_V_MF2_MF8, 1072 },
    { PseudoVLOXEI64_V_M1_M1, 1073 },
    { PseudoVLOXEI64_V_M1_MF2, 1074 },
    { PseudoVLOXEI64_V_M1_MF4, 1075 },
    { PseudoVLOXEI64_V_M1_MF8, 1076 },
    { PseudoVLOXEI64_V_M2_M1, 1077 },
    { PseudoVLOXEI64_V_M2_M2, 1078 },
    { PseudoVLOXEI64_V_M2_MF2, 1079 },
    { PseudoVLOXEI64_V_M2_MF4, 1080 },
    { PseudoVLOXEI64_V_M4_M1, 1081 },
    { PseudoVLOXEI64_V_M4_M2, 1082 },
    { PseudoVLOXEI64_V_M4_M4, 1083 },
    { PseudoVLOXEI64_V_M4_MF2, 1084 },
    { PseudoVLOXEI64_V_M8_M1, 1085 },
    { PseudoVLOXEI64_V_M8_M2, 1086 },
    { PseudoVLOXEI64_V_M8_M4, 1087 },
    { PseudoVLOXEI64_V_M8_M8, 1088 },
    { PseudoVLOXEI8_V_M1_M1, 1089 },
    { PseudoVLOXEI8_V_M1_M2, 1090 },
    { PseudoVLOXEI8_V_M1_M4, 1091 },
    { PseudoVLOXEI8_V_M1_M8, 1092 },
    { PseudoVLOXEI8_V_M2_M2, 1093 },
    { PseudoVLOXEI8_V_M2_M4, 1094 },
    { PseudoVLOXEI8_V_M2_M8, 1095 },
    { PseudoVLOXEI8_V_M4_M4, 1096 },
    { PseudoVLOXEI8_V_M4_M8, 1097 },
    { PseudoVLOXEI8_V_M8_M8, 1098 },
    { PseudoVLOXEI8_V_MF2_M1, 1099 },
    { PseudoVLOXEI8_V_MF2_M2, 1100 },
    { PseudoVLOXEI8_V_MF2_M4, 1101 },
    { PseudoVLOXEI8_V_MF2_MF2, 1102 },
    { PseudoVLOXEI8_V_MF4_M1, 1103 },
    { PseudoVLOXEI8_V_MF4_M2, 1104 },
    { PseudoVLOXEI8_V_MF4_MF2, 1105 },
    { PseudoVLOXEI8_V_MF4_MF4, 1106 },
    { PseudoVLOXEI8_V_MF8_M1, 1107 },
    { PseudoVLOXEI8_V_MF8_MF2, 1108 },
    { PseudoVLOXEI8_V_MF8_MF4, 1109 },
    { PseudoVLOXEI8_V_MF8_MF8, 1110 },
    { PseudoVLSE16_V_M1, 1111 },
    { PseudoVLSE16_V_M2, 1112 },
    { PseudoVLSE16_V_M4, 1113 },
    { PseudoVLSE16_V_M8, 1114 },
    { PseudoVLSE16_V_MF2, 1115 },
    { PseudoVLSE16_V_MF4, 1116 },
    { PseudoVLSE32_V_M1, 1117 },
    { PseudoVLSE32_V_M2, 1118 },
    { PseudoVLSE32_V_M4, 1119 },
    { PseudoVLSE32_V_M8, 1120 },
    { PseudoVLSE32_V_MF2, 1121 },
    { PseudoVLSE64_V_M1, 1122 },
    { PseudoVLSE64_V_M2, 1123 },
    { PseudoVLSE64_V_M4, 1124 },
    { PseudoVLSE64_V_M8, 1125 },
    { PseudoVLSE8_V_M1, 1126 },
    { PseudoVLSE8_V_M2, 1127 },
    { PseudoVLSE8_V_M4, 1128 },
    { PseudoVLSE8_V_M8, 1129 },
    { PseudoVLSE8_V_MF2, 1130 },
    { PseudoVLSE8_V_MF4, 1131 },
    { PseudoVLSE8_V_MF8, 1132 },
    { PseudoVLUXEI16_V_M1_M1, 1133 },
    { PseudoVLUXEI16_V_M1_M2, 1134 },
    { PseudoVLUXEI16_V_M1_M4, 1135 },
    { PseudoVLUXEI16_V_M1_MF2, 1136 },
    { PseudoVLUXEI16_V_M2_M1, 1137 },
    { PseudoVLUXEI16_V_M2_M2, 1138 },
    { PseudoVLUXEI16_V_M2_M4, 1139 },
    { PseudoVLUXEI16_V_M2_M8, 1140 },
    { PseudoVLUXEI16_V_M4_M2, 1141 },
    { PseudoVLUXEI16_V_M4_M4, 1142 },
    { PseudoVLUXEI16_V_M4_M8, 1143 },
    { PseudoVLUXEI16_V_M8_M4, 1144 },
    { PseudoVLUXEI16_V_M8_M8, 1145 },
    { PseudoVLUXEI16_V_MF2_M1, 1146 },
    { PseudoVLUXEI16_V_MF2_M2, 1147 },
    { PseudoVLUXEI16_V_MF2_MF2, 1148 },
    { PseudoVLUXEI16_V_MF2_MF4, 1149 },
    { PseudoVLUXEI16_V_MF4_M1, 1150 },
    { PseudoVLUXEI16_V_MF4_MF2, 1151 },
    { PseudoVLUXEI16_V_MF4_MF4, 1152 },
    { PseudoVLUXEI16_V_MF4_MF8, 1153 },
    { PseudoVLUXEI32_V_M1_M1, 1154 },
    { PseudoVLUXEI32_V_M1_M2, 1155 },
    { PseudoVLUXEI32_V_M1_MF2, 1156 },
    { PseudoVLUXEI32_V_M1_MF4, 1157 },
    { PseudoVLUXEI32_V_M2_M1, 1158 },
    { PseudoVLUXEI32_V_M2_M2, 1159 },
    { PseudoVLUXEI32_V_M2_M4, 1160 },
    { PseudoVLUXEI32_V_M2_MF2, 1161 },
    { PseudoVLUXEI32_V_M4_M1, 1162 },
    { PseudoVLUXEI32_V_M4_M2, 1163 },
    { PseudoVLUXEI32_V_M4_M4, 1164 },
    { PseudoVLUXEI32_V_M4_M8, 1165 },
    { PseudoVLUXEI32_V_M8_M2, 1166 },
    { PseudoVLUXEI32_V_M8_M4, 1167 },
    { PseudoVLUXEI32_V_M8_M8, 1168 },
    { PseudoVLUXEI32_V_MF2_M1, 1169 },
    { PseudoVLUXEI32_V_MF2_MF2, 1170 },
    { PseudoVLUXEI32_V_MF2_MF4, 1171 },
    { PseudoVLUXEI32_V_MF2_MF8, 1172 },
    { PseudoVLUXEI64_V_M1_M1, 1173 },
    { PseudoVLUXEI64_V_M1_MF2, 1174 },
    { PseudoVLUXEI64_V_M1_MF4, 1175 },
    { PseudoVLUXEI64_V_M1_MF8, 1176 },
    { PseudoVLUXEI64_V_M2_M1, 1177 },
    { PseudoVLUXEI64_V_M2_M2, 1178 },
    { PseudoVLUXEI64_V_M2_MF2, 1179 },
    { PseudoVLUXEI64_V_M2_MF4, 1180 },
    { PseudoVLUXEI64_V_M4_M1, 1181 },
    { PseudoVLUXEI64_V_M4_M2, 1182 },
    { PseudoVLUXEI64_V_M4_M4, 1183 },
    { PseudoVLUXEI64_V_M4_MF2, 1184 },
    { PseudoVLUXEI64_V_M8_M1, 1185 },
    { PseudoVLUXEI64_V_M8_M2, 1186 },
    { PseudoVLUXEI64_V_M8_M4, 1187 },
    { PseudoVLUXEI64_V_M8_M8, 1188 },
    { PseudoVLUXEI8_V_M1_M1, 1189 },
    { PseudoVLUXEI8_V_M1_M2, 1190 },
    { PseudoVLUXEI8_V_M1_M4, 1191 },
    { PseudoVLUXEI8_V_M1_M8, 1192 },
    { PseudoVLUXEI8_V_M2_M2, 1193 },
    { PseudoVLUXEI8_V_M2_M4, 1194 },
    { PseudoVLUXEI8_V_M2_M8, 1195 },
    { PseudoVLUXEI8_V_M4_M4, 1196 },
    { PseudoVLUXEI8_V_M4_M8, 1197 },
    { PseudoVLUXEI8_V_M8_M8, 1198 },
    { PseudoVLUXEI8_V_MF2_M1, 1199 },
    { PseudoVLUXEI8_V_MF2_M2, 1200 },
    { PseudoVLUXEI8_V_MF2_M4, 1201 },
    { PseudoVLUXEI8_V_MF2_MF2, 1202 },
    { PseudoVLUXEI8_V_MF4_M1, 1203 },
    { PseudoVLUXEI8_V_MF4_M2, 1204 },
    { PseudoVLUXEI8_V_MF4_MF2, 1205 },
    { PseudoVLUXEI8_V_MF4_MF4, 1206 },
    { PseudoVLUXEI8_V_MF8_M1, 1207 },
    { PseudoVLUXEI8_V_MF8_MF2, 1208 },
    { PseudoVLUXEI8_V_MF8_MF4, 1209 },
    { PseudoVLUXEI8_V_MF8_MF8, 1210 },
    { PseudoVMACC_VV_M1, 1211 },
    { PseudoVMACC_VV_M2, 1212 },
    { PseudoVMACC_VV_M4, 1213 },
    { PseudoVMACC_VV_M8, 1214 },
    { PseudoVMACC_VV_MF2, 1215 },
    { PseudoVMACC_VV_MF4, 1216 },
    { PseudoVMACC_VV_MF8, 1217 },
    { PseudoVMACC_VX_M1, 1218 },
    { PseudoVMACC_VX_M2, 1219 },
    { PseudoVMACC_VX_M4, 1220 },
    { PseudoVMACC_VX_M8, 1221 },
    { PseudoVMACC_VX_MF2, 1222 },
    { PseudoVMACC_VX_MF4, 1223 },
    { PseudoVMACC_VX_MF8, 1224 },
    { PseudoVMADD_VV_M1, 1225 },
    { PseudoVMADD_VV_M2, 1226 },
    { PseudoVMADD_VV_M4, 1227 },
    { PseudoVMADD_VV_M8, 1228 },
    { PseudoVMADD_VV_MF2, 1229 },
    { PseudoVMADD_VV_MF4, 1230 },
    { PseudoVMADD_VV_MF8, 1231 },
    { PseudoVMADD_VX_M1, 1232 },
    { PseudoVMADD_VX_M2, 1233 },
    { PseudoVMADD_VX_M4, 1234 },
    { PseudoVMADD_VX_M8, 1235 },
    { PseudoVMADD_VX_MF2, 1236 },
    { PseudoVMADD_VX_MF4, 1237 },
    { PseudoVMADD_VX_MF8, 1238 },
    { PseudoVMAXU_VV_M1, 1239 },
    { PseudoVMAXU_VV_M2, 1240 },
    { PseudoVMAXU_VV_M4, 1241 },
    { PseudoVMAXU_VV_M8, 1242 },
    { PseudoVMAXU_VV_MF2, 1243 },
    { PseudoVMAXU_VV_MF4, 1244 },
    { PseudoVMAXU_VV_MF8, 1245 },
    { PseudoVMAXU_VX_M1, 1246 },
    { PseudoVMAXU_VX_M2, 1247 },
    { PseudoVMAXU_VX_M4, 1248 },
    { PseudoVMAXU_VX_M8, 1249 },
    { PseudoVMAXU_VX_MF2, 1250 },
    { PseudoVMAXU_VX_MF4, 1251 },
    { PseudoVMAXU_VX_MF8, 1252 },
    { PseudoVMAX_VV_M1, 1253 },
    { PseudoVMAX_VV_M2, 1254 },
    { PseudoVMAX_VV_M4, 1255 },
    { PseudoVMAX_VV_M8, 1256 },
    { PseudoVMAX_VV_MF2, 1257 },
    { PseudoVMAX_VV_MF4, 1258 },
    { PseudoVMAX_VV_MF8, 1259 },
    { PseudoVMAX_VX_M1, 1260 },
    { PseudoVMAX_VX_M2, 1261 },
    { PseudoVMAX_VX_M4, 1262 },
    { PseudoVMAX_VX_M8, 1263 },
    { PseudoVMAX_VX_MF2, 1264 },
    { PseudoVMAX_VX_MF4, 1265 },
    { PseudoVMAX_VX_MF8, 1266 },
    { PseudoVMFEQ_VF16_M1, 1267 },
    { PseudoVMFEQ_VF16_M2, 1268 },
    { PseudoVMFEQ_VF16_M4, 1269 },
    { PseudoVMFEQ_VF16_M8, 1270 },
    { PseudoVMFEQ_VF16_MF2, 1271 },
    { PseudoVMFEQ_VF16_MF4, 1272 },
    { PseudoVMFEQ_VF32_M1, 1273 },
    { PseudoVMFEQ_VF32_M2, 1274 },
    { PseudoVMFEQ_VF32_M4, 1275 },
    { PseudoVMFEQ_VF32_M8, 1276 },
    { PseudoVMFEQ_VF32_MF2, 1277 },
    { PseudoVMFEQ_VF64_M1, 1278 },
    { PseudoVMFEQ_VF64_M2, 1279 },
    { PseudoVMFEQ_VF64_M4, 1280 },
    { PseudoVMFEQ_VF64_M8, 1281 },
    { PseudoVMFEQ_VV_M1, 1282 },
    { PseudoVMFEQ_VV_M2, 1283 },
    { PseudoVMFEQ_VV_M4, 1284 },
    { PseudoVMFEQ_VV_M8, 1285 },
    { PseudoVMFEQ_VV_MF2, 1286 },
    { PseudoVMFEQ_VV_MF4, 1287 },
    { PseudoVMFGE_VF16_M1, 1288 },
    { PseudoVMFGE_VF16_M2, 1289 },
    { PseudoVMFGE_VF16_M4, 1290 },
    { PseudoVMFGE_VF16_M8, 1291 },
    { PseudoVMFGE_VF16_MF2, 1292 },
    { PseudoVMFGE_VF16_MF4, 1293 },
    { PseudoVMFGE_VF32_M1, 1294 },
    { PseudoVMFGE_VF32_M2, 1295 },
    { PseudoVMFGE_VF32_M4, 1296 },
    { PseudoVMFGE_VF32_M8, 1297 },
    { PseudoVMFGE_VF32_MF2, 1298 },
    { PseudoVMFGE_VF64_M1, 1299 },
    { PseudoVMFGE_VF64_M2, 1300 },
    { PseudoVMFGE_VF64_M4, 1301 },
    { PseudoVMFGE_VF64_M8, 1302 },
    { PseudoVMFGT_VF16_M1, 1303 },
    { PseudoVMFGT_VF16_M2, 1304 },
    { PseudoVMFGT_VF16_M4, 1305 },
    { PseudoVMFGT_VF16_M8, 1306 },
    { PseudoVMFGT_VF16_MF2, 1307 },
    { PseudoVMFGT_VF16_MF4, 1308 },
    { PseudoVMFGT_VF32_M1, 1309 },
    { PseudoVMFGT_VF32_M2, 1310 },
    { PseudoVMFGT_VF32_M4, 1311 },
    { PseudoVMFGT_VF32_M8, 1312 },
    { PseudoVMFGT_VF32_MF2, 1313 },
    { PseudoVMFGT_VF64_M1, 1314 },
    { PseudoVMFGT_VF64_M2, 1315 },
    { PseudoVMFGT_VF64_M4, 1316 },
    { PseudoVMFGT_VF64_M8, 1317 },
    { PseudoVMFLE_VF16_M1, 1318 },
    { PseudoVMFLE_VF16_M2, 1319 },
    { PseudoVMFLE_VF16_M4, 1320 },
    { PseudoVMFLE_VF16_M8, 1321 },
    { PseudoVMFLE_VF16_MF2, 1322 },
    { PseudoVMFLE_VF16_MF4, 1323 },
    { PseudoVMFLE_VF32_M1, 1324 },
    { PseudoVMFLE_VF32_M2, 1325 },
    { PseudoVMFLE_VF32_M4, 1326 },
    { PseudoVMFLE_VF32_M8, 1327 },
    { PseudoVMFLE_VF32_MF2, 1328 },
    { PseudoVMFLE_VF64_M1, 1329 },
    { PseudoVMFLE_VF64_M2, 1330 },
    { PseudoVMFLE_VF64_M4, 1331 },
    { PseudoVMFLE_VF64_M8, 1332 },
    { PseudoVMFLE_VV_M1, 1333 },
    { PseudoVMFLE_VV_M2, 1334 },
    { PseudoVMFLE_VV_M4, 1335 },
    { PseudoVMFLE_VV_M8, 1336 },
    { PseudoVMFLE_VV_MF2, 1337 },
    { PseudoVMFLE_VV_MF4, 1338 },
    { PseudoVMFLT_VF16_M1, 1339 },
    { PseudoVMFLT_VF16_M2, 1340 },
    { PseudoVMFLT_VF16_M4, 1341 },
    { PseudoVMFLT_VF16_M8, 1342 },
    { PseudoVMFLT_VF16_MF2, 1343 },
    { PseudoVMFLT_VF16_MF4, 1344 },
    { PseudoVMFLT_VF32_M1, 1345 },
    { PseudoVMFLT_VF32_M2, 1346 },
    { PseudoVMFLT_VF32_M4, 1347 },
    { PseudoVMFLT_VF32_M8, 1348 },
    { PseudoVMFLT_VF32_MF2, 1349 },
    { PseudoVMFLT_VF64_M1, 1350 },
    { PseudoVMFLT_VF64_M2, 1351 },
    { PseudoVMFLT_VF64_M4, 1352 },
    { PseudoVMFLT_VF64_M8, 1353 },
    { PseudoVMFLT_VV_M1, 1354 },
    { PseudoVMFLT_VV_M2, 1355 },
    { PseudoVMFLT_VV_M4, 1356 },
    { PseudoVMFLT_VV_M8, 1357 },
    { PseudoVMFLT_VV_MF2, 1358 },
    { PseudoVMFLT_VV_MF4, 1359 },
    { PseudoVMFNE_VF16_M1, 1360 },
    { PseudoVMFNE_VF16_M2, 1361 },
    { PseudoVMFNE_VF16_M4, 1362 },
    { PseudoVMFNE_VF16_M8, 1363 },
    { PseudoVMFNE_VF16_MF2, 1364 },
    { PseudoVMFNE_VF16_MF4, 1365 },
    { PseudoVMFNE_VF32_M1, 1366 },
    { PseudoVMFNE_VF32_M2, 1367 },
    { PseudoVMFNE_VF32_M4, 1368 },
    { PseudoVMFNE_VF32_M8, 1369 },
    { PseudoVMFNE_VF32_MF2, 1370 },
    { PseudoVMFNE_VF64_M1, 1371 },
    { PseudoVMFNE_VF64_M2, 1372 },
    { PseudoVMFNE_VF64_M4, 1373 },
    { PseudoVMFNE_VF64_M8, 1374 },
    { PseudoVMFNE_VV_M1, 1375 },
    { PseudoVMFNE_VV_M2, 1376 },
    { PseudoVMFNE_VV_M4, 1377 },
    { PseudoVMFNE_VV_M8, 1378 },
    { PseudoVMFNE_VV_MF2, 1379 },
    { PseudoVMFNE_VV_MF4, 1380 },
    { PseudoVMINU_VV_M1, 1381 },
    { PseudoVMINU_VV_M2, 1382 },
    { PseudoVMINU_VV_M4, 1383 },
    { PseudoVMINU_VV_M8, 1384 },
    { PseudoVMINU_VV_MF2, 1385 },
    { PseudoVMINU_VV_MF4, 1386 },
    { PseudoVMINU_VV_MF8, 1387 },
    { PseudoVMINU_VX_M1, 1388 },
    { PseudoVMINU_VX_M2, 1389 },
    { PseudoVMINU_VX_M4, 1390 },
    { PseudoVMINU_VX_M8, 1391 },
    { PseudoVMINU_VX_MF2, 1392 },
    { PseudoVMINU_VX_MF4, 1393 },
    { PseudoVMINU_VX_MF8, 1394 },
    { PseudoVMIN_VV_M1, 1395 },
    { PseudoVMIN_VV_M2, 1396 },
    { PseudoVMIN_VV_M4, 1397 },
    { PseudoVMIN_VV_M8, 1398 },
    { PseudoVMIN_VV_MF2, 1399 },
    { PseudoVMIN_VV_MF4, 1400 },
    { PseudoVMIN_VV_MF8, 1401 },
    { PseudoVMIN_VX_M1, 1402 },
    { PseudoVMIN_VX_M2, 1403 },
    { PseudoVMIN_VX_M4, 1404 },
    { PseudoVMIN_VX_M8, 1405 },
    { PseudoVMIN_VX_MF2, 1406 },
    { PseudoVMIN_VX_MF4, 1407 },
    { PseudoVMIN_VX_MF8, 1408 },
    { PseudoVMSEQ_VI_M1, 1409 },
    { PseudoVMSEQ_VI_M2, 1410 },
    { PseudoVMSEQ_VI_M4, 1411 },
    { PseudoVMSEQ_VI_M8, 1412 },
    { PseudoVMSEQ_VI_MF2, 1413 },
    { PseudoVMSEQ_VI_MF4, 1414 },
    { PseudoVMSEQ_VI_MF8, 1415 },
    { PseudoVMSEQ_VV_M1, 1416 },
    { PseudoVMSEQ_VV_M2, 1417 },
    { PseudoVMSEQ_VV_M4, 1418 },
    { PseudoVMSEQ_VV_M8, 1419 },
    { PseudoVMSEQ_VV_MF2, 1420 },
    { PseudoVMSEQ_VV_MF4, 1421 },
    { PseudoVMSEQ_VV_MF8, 1422 },
    { PseudoVMSEQ_VX_M1, 1423 },
    { PseudoVMSEQ_VX_M2, 1424 },
    { PseudoVMSEQ_VX_M4, 1425 },
    { PseudoVMSEQ_VX_M8, 1426 },
    { PseudoVMSEQ_VX_MF2, 1427 },
    { PseudoVMSEQ_VX_MF4, 1428 },
    { PseudoVMSEQ_VX_MF8, 1429 },
    { PseudoVMSGTU_VI_M1, 1430 },
    { PseudoVMSGTU_VI_M2, 1431 },
    { PseudoVMSGTU_VI_M4, 1432 },
    { PseudoVMSGTU_VI_M8, 1433 },
    { PseudoVMSGTU_VI_MF2, 1434 },
    { PseudoVMSGTU_VI_MF4, 1435 },
    { PseudoVMSGTU_VI_MF8, 1436 },
    { PseudoVMSGTU_VX_M1, 1437 },
    { PseudoVMSGTU_VX_M2, 1438 },
    { PseudoVMSGTU_VX_M4, 1439 },
    { PseudoVMSGTU_VX_M8, 1440 },
    { PseudoVMSGTU_VX_MF2, 1441 },
    { PseudoVMSGTU_VX_MF4, 1442 },
    { PseudoVMSGTU_VX_MF8, 1443 },
    { PseudoVMSGT_VI_M1, 1444 },
    { PseudoVMSGT_VI_M2, 1445 },
    { PseudoVMSGT_VI_M4, 1446 },
    { PseudoVMSGT_VI_M8, 1447 },
    { PseudoVMSGT_VI_MF2, 1448 },
    { PseudoVMSGT_VI_MF4, 1449 },
    { PseudoVMSGT_VI_MF8, 1450 },
    { PseudoVMSGT_VX_M1, 1451 },
    { PseudoVMSGT_VX_M2, 1452 },
    { PseudoVMSGT_VX_M4, 1453 },
    { PseudoVMSGT_VX_M8, 1454 },
    { PseudoVMSGT_VX_MF2, 1455 },
    { PseudoVMSGT_VX_MF4, 1456 },
    { PseudoVMSGT_VX_MF8, 1457 },
    { PseudoVMSLEU_VI_M1, 1458 },
    { PseudoVMSLEU_VI_M2, 1459 },
    { PseudoVMSLEU_VI_M4, 1460 },
    { PseudoVMSLEU_VI_M8, 1461 },
    { PseudoVMSLEU_VI_MF2, 1462 },
    { PseudoVMSLEU_VI_MF4, 1463 },
    { PseudoVMSLEU_VI_MF8, 1464 },
    { PseudoVMSLEU_VV_M1, 1465 },
    { PseudoVMSLEU_VV_M2, 1466 },
    { PseudoVMSLEU_VV_M4, 1467 },
    { PseudoVMSLEU_VV_M8, 1468 },
    { PseudoVMSLEU_VV_MF2, 1469 },
    { PseudoVMSLEU_VV_MF4, 1470 },
    { PseudoVMSLEU_VV_MF8, 1471 },
    { PseudoVMSLEU_VX_M1, 1472 },
    { PseudoVMSLEU_VX_M2, 1473 },
    { PseudoVMSLEU_VX_M4, 1474 },
    { PseudoVMSLEU_VX_M8, 1475 },
    { PseudoVMSLEU_VX_MF2, 1476 },
    { PseudoVMSLEU_VX_MF4, 1477 },
    { PseudoVMSLEU_VX_MF8, 1478 },
    { PseudoVMSLE_VI_M1, 1479 },
    { PseudoVMSLE_VI_M2, 1480 },
    { PseudoVMSLE_VI_M4, 1481 },
    { PseudoVMSLE_VI_M8, 1482 },
    { PseudoVMSLE_VI_MF2, 1483 },
    { PseudoVMSLE_VI_MF4, 1484 },
    { PseudoVMSLE_VI_MF8, 1485 },
    { PseudoVMSLE_VV_M1, 1486 },
    { PseudoVMSLE_VV_M2, 1487 },
    { PseudoVMSLE_VV_M4, 1488 },
    { PseudoVMSLE_VV_M8, 1489 },
    { PseudoVMSLE_VV_MF2, 1490 },
    { PseudoVMSLE_VV_MF4, 1491 },
    { PseudoVMSLE_VV_MF8, 1492 },
    { PseudoVMSLE_VX_M1, 1493 },
    { PseudoVMSLE_VX_M2, 1494 },
    { PseudoVMSLE_VX_M4, 1495 },
    { PseudoVMSLE_VX_M8, 1496 },
    { PseudoVMSLE_VX_MF2, 1497 },
    { PseudoVMSLE_VX_MF4, 1498 },
    { PseudoVMSLE_VX_MF8, 1499 },
    { PseudoVMSLTU_VV_M1, 1500 },
    { PseudoVMSLTU_VV_M2, 1501 },
    { PseudoVMSLTU_VV_M4, 1502 },
    { PseudoVMSLTU_VV_M8, 1503 },
    { PseudoVMSLTU_VV_MF2, 1504 },
    { PseudoVMSLTU_VV_MF4, 1505 },
    { PseudoVMSLTU_VV_MF8, 1506 },
    { PseudoVMSLTU_VX_M1, 1507 },
    { PseudoVMSLTU_VX_M2, 1508 },
    { PseudoVMSLTU_VX_M4, 1509 },
    { PseudoVMSLTU_VX_M8, 1510 },
    { PseudoVMSLTU_VX_MF2, 1511 },
    { PseudoVMSLTU_VX_MF4, 1512 },
    { PseudoVMSLTU_VX_MF8, 1513 },
    { PseudoVMSLT_VV_M1, 1514 },
    { PseudoVMSLT_VV_M2, 1515 },
    { PseudoVMSLT_VV_M4, 1516 },
    { PseudoVMSLT_VV_M8, 1517 },
    { PseudoVMSLT_VV_MF2, 1518 },
    { PseudoVMSLT_VV_MF4, 1519 },
    { PseudoVMSLT_VV_MF8, 1520 },
    { PseudoVMSLT_VX_M1, 1521 },
    { PseudoVMSLT_VX_M2, 1522 },
    { PseudoVMSLT_VX_M4, 1523 },
    { PseudoVMSLT_VX_M8, 1524 },
    { PseudoVMSLT_VX_MF2, 1525 },
    { PseudoVMSLT_VX_MF4, 1526 },
    { PseudoVMSLT_VX_MF8, 1527 },
    { PseudoVMSNE_VI_M1, 1528 },
    { PseudoVMSNE_VI_M2, 1529 },
    { PseudoVMSNE_VI_M4, 1530 },
    { PseudoVMSNE_VI_M8, 1531 },
    { PseudoVMSNE_VI_MF2, 1532 },
    { PseudoVMSNE_VI_MF4, 1533 },
    { PseudoVMSNE_VI_MF8, 1534 },
    { PseudoVMSNE_VV_M1, 1535 },
    { PseudoVMSNE_VV_M2, 1536 },
    { PseudoVMSNE_VV_M4, 1537 },
    { PseudoVMSNE_VV_M8, 1538 },
    { PseudoVMSNE_VV_MF2, 1539 },
    { PseudoVMSNE_VV_MF4, 1540 },
    { PseudoVMSNE_VV_MF8, 1541 },
    { PseudoVMSNE_VX_M1, 1542 },
    { PseudoVMSNE_VX_M2, 1543 },
    { PseudoVMSNE_VX_M4, 1544 },
    { PseudoVMSNE_VX_M8, 1545 },
    { PseudoVMSNE_VX_MF2, 1546 },
    { PseudoVMSNE_VX_MF4, 1547 },
    { PseudoVMSNE_VX_MF8, 1548 },
    { PseudoVMULHSU_VV_M1, 1549 },
    { PseudoVMULHSU_VV_M2, 1550 },
    { PseudoVMULHSU_VV_M4, 1551 },
    { PseudoVMULHSU_VV_M8, 1552 },
    { PseudoVMULHSU_VV_MF2, 1553 },
    { PseudoVMULHSU_VV_MF4, 1554 },
    { PseudoVMULHSU_VV_MF8, 1555 },
    { PseudoVMULHSU_VX_M1, 1556 },
    { PseudoVMULHSU_VX_M2, 1557 },
    { PseudoVMULHSU_VX_M4, 1558 },
    { PseudoVMULHSU_VX_M8, 1559 },
    { PseudoVMULHSU_VX_MF2, 1560 },
    { PseudoVMULHSU_VX_MF4, 1561 },
    { PseudoVMULHSU_VX_MF8, 1562 },
    { PseudoVMULHU_VV_M1, 1563 },
    { PseudoVMULHU_VV_M2, 1564 },
    { PseudoVMULHU_VV_M4, 1565 },
    { PseudoVMULHU_VV_M8, 1566 },
    { PseudoVMULHU_VV_MF2, 1567 },
    { PseudoVMULHU_VV_MF4, 1568 },
    { PseudoVMULHU_VV_MF8, 1569 },
    { PseudoVMULHU_VX_M1, 1570 },
    { PseudoVMULHU_VX_M2, 1571 },
    { PseudoVMULHU_VX_M4, 1572 },
    { PseudoVMULHU_VX_M8, 1573 },
    { PseudoVMULHU_VX_MF2, 1574 },
    { PseudoVMULHU_VX_MF4, 1575 },
    { PseudoVMULHU_VX_MF8, 1576 },
    { PseudoVMULH_VV_M1, 1577 },
    { PseudoVMULH_VV_M2, 1578 },
    { PseudoVMULH_VV_M4, 1579 },
    { PseudoVMULH_VV_M8, 1580 },
    { PseudoVMULH_VV_MF2, 1581 },
    { PseudoVMULH_VV_MF4, 1582 },
    { PseudoVMULH_VV_MF8, 1583 },
    { PseudoVMULH_VX_M1, 1584 },
    { PseudoVMULH_VX_M2, 1585 },
    { PseudoVMULH_VX_M4, 1586 },
    { PseudoVMULH_VX_M8, 1587 },
    { PseudoVMULH_VX_MF2, 1588 },
    { PseudoVMULH_VX_MF4, 1589 },
    { PseudoVMULH_VX_MF8, 1590 },
    { PseudoVMUL_VV_M1, 1591 },
    { PseudoVMUL_VV_M2, 1592 },
    { PseudoVMUL_VV_M4, 1593 },
    { PseudoVMUL_VV_M8, 1594 },
    { PseudoVMUL_VV_MF2, 1595 },
    { PseudoVMUL_VV_MF4, 1596 },
    { PseudoVMUL_VV_MF8, 1597 },
    { PseudoVMUL_VX_M1, 1598 },
    { PseudoVMUL_VX_M2, 1599 },
    { PseudoVMUL_VX_M4, 1600 },
    { PseudoVMUL_VX_M8, 1601 },
    { PseudoVMUL_VX_MF2, 1602 },
    { PseudoVMUL_VX_MF4, 1603 },
    { PseudoVMUL_VX_MF8, 1604 },
    { PseudoVNCLIPU_WI_M1, 1605 },
    { PseudoVNCLIPU_WI_M2, 1606 },
    { PseudoVNCLIPU_WI_M4, 1607 },
    { PseudoVNCLIPU_WI_MF2, 1608 },
    { PseudoVNCLIPU_WI_MF4, 1609 },
    { PseudoVNCLIPU_WI_MF8, 1610 },
    { PseudoVNCLIPU_WV_M1, 1611 },
    { PseudoVNCLIPU_WV_M2, 1612 },
    { PseudoVNCLIPU_WV_M4, 1613 },
    { PseudoVNCLIPU_WV_MF2, 1614 },
    { PseudoVNCLIPU_WV_MF4, 1615 },
    { PseudoVNCLIPU_WV_MF8, 1616 },
    { PseudoVNCLIPU_WX_M1, 1617 },
    { PseudoVNCLIPU_WX_M2, 1618 },
    { PseudoVNCLIPU_WX_M4, 1619 },
    { PseudoVNCLIPU_WX_MF2, 1620 },
    { PseudoVNCLIPU_WX_MF4, 1621 },
    { PseudoVNCLIPU_WX_MF8, 1622 },
    { PseudoVNCLIP_WI_M1, 1623 },
    { PseudoVNCLIP_WI_M2, 1624 },
    { PseudoVNCLIP_WI_M4, 1625 },
    { PseudoVNCLIP_WI_MF2, 1626 },
    { PseudoVNCLIP_WI_MF4, 1627 },
    { PseudoVNCLIP_WI_MF8, 1628 },
    { PseudoVNCLIP_WV_M1, 1629 },
    { PseudoVNCLIP_WV_M2, 1630 },
    { PseudoVNCLIP_WV_M4, 1631 },
    { PseudoVNCLIP_WV_MF2, 1632 },
    { PseudoVNCLIP_WV_MF4, 1633 },
    { PseudoVNCLIP_WV_MF8, 1634 },
    { PseudoVNCLIP_WX_M1, 1635 },
    { PseudoVNCLIP_WX_M2, 1636 },
    { PseudoVNCLIP_WX_M4, 1637 },
    { PseudoVNCLIP_WX_MF2, 1638 },
    { PseudoVNCLIP_WX_MF4, 1639 },
    { PseudoVNCLIP_WX_MF8, 1640 },
    { PseudoVNMSAC_VV_M1, 1641 },
    { PseudoVNMSAC_VV_M2, 1642 },
    { PseudoVNMSAC_VV_M4, 1643 },
    { PseudoVNMSAC_VV_M8, 1644 },
    { PseudoVNMSAC_VV_MF2, 1645 },
    { PseudoVNMSAC_VV_MF4, 1646 },
    { PseudoVNMSAC_VV_MF8, 1647 },
    { PseudoVNMSAC_VX_M1, 1648 },
    { PseudoVNMSAC_VX_M2, 1649 },
    { PseudoVNMSAC_VX_M4, 1650 },
    { PseudoVNMSAC_VX_M8, 1651 },
    { PseudoVNMSAC_VX_MF2, 1652 },
    { PseudoVNMSAC_VX_MF4, 1653 },
    { PseudoVNMSAC_VX_MF8, 1654 },
    { PseudoVNMSUB_VV_M1, 1655 },
    { PseudoVNMSUB_VV_M2, 1656 },
    { PseudoVNMSUB_VV_M4, 1657 },
    { PseudoVNMSUB_VV_M8, 1658 },
    { PseudoVNMSUB_VV_MF2, 1659 },
    { PseudoVNMSUB_VV_MF4, 1660 },
    { PseudoVNMSUB_VV_MF8, 1661 },
    { PseudoVNMSUB_VX_M1, 1662 },
    { PseudoVNMSUB_VX_M2, 1663 },
    { PseudoVNMSUB_VX_M4, 1664 },
    { PseudoVNMSUB_VX_M8, 1665 },
    { PseudoVNMSUB_VX_MF2, 1666 },
    { PseudoVNMSUB_VX_MF4, 1667 },
    { PseudoVNMSUB_VX_MF8, 1668 },
    { PseudoVNSRA_WI_M1, 1669 },
    { PseudoVNSRA_WI_M2, 1670 },
    { PseudoVNSRA_WI_M4, 1671 },
    { PseudoVNSRA_WI_MF2, 1672 },
    { PseudoVNSRA_WI_MF4, 1673 },
    { PseudoVNSRA_WI_MF8, 1674 },
    { PseudoVNSRA_WV_M1, 1675 },
    { PseudoVNSRA_WV_M2, 1676 },
    { PseudoVNSRA_WV_M4, 1677 },
    { PseudoVNSRA_WV_MF2, 1678 },
    { PseudoVNSRA_WV_MF4, 1679 },
    { PseudoVNSRA_WV_MF8, 1680 },
    { PseudoVNSRA_WX_M1, 1681 },
    { PseudoVNSRA_WX_M2, 1682 },
    { PseudoVNSRA_WX_M4, 1683 },
    { PseudoVNSRA_WX_MF2, 1684 },
    { PseudoVNSRA_WX_MF4, 1685 },
    { PseudoVNSRA_WX_MF8, 1686 },
    { PseudoVNSRL_WI_M1, 1687 },
    { PseudoVNSRL_WI_M2, 1688 },
    { PseudoVNSRL_WI_M4, 1689 },
    { PseudoVNSRL_WI_MF2, 1690 },
    { PseudoVNSRL_WI_MF4, 1691 },
    { PseudoVNSRL_WI_MF8, 1692 },
    { PseudoVNSRL_WV_M1, 1693 },
    { PseudoVNSRL_WV_M2, 1694 },
    { PseudoVNSRL_WV_M4, 1695 },
    { PseudoVNSRL_WV_MF2, 1696 },
    { PseudoVNSRL_WV_MF4, 1697 },
    { PseudoVNSRL_WV_MF8, 1698 },
    { PseudoVNSRL_WX_M1, 1699 },
    { PseudoVNSRL_WX_M2, 1700 },
    { PseudoVNSRL_WX_M4, 1701 },
    { PseudoVNSRL_WX_MF2, 1702 },
    { PseudoVNSRL_WX_MF4, 1703 },
    { PseudoVNSRL_WX_MF8, 1704 },
    { PseudoVOR_VI_M1, 1705 },
    { PseudoVOR_VI_M2, 1706 },
    { PseudoVOR_VI_M4, 1707 },
    { PseudoVOR_VI_M8, 1708 },
    { PseudoVOR_VI_MF2, 1709 },
    { PseudoVOR_VI_MF4, 1710 },
    { PseudoVOR_VI_MF8, 1711 },
    { PseudoVOR_VV_M1, 1712 },
    { PseudoVOR_VV_M2, 1713 },
    { PseudoVOR_VV_M4, 1714 },
    { PseudoVOR_VV_M8, 1715 },
    { PseudoVOR_VV_MF2, 1716 },
    { PseudoVOR_VV_MF4, 1717 },
    { PseudoVOR_VV_MF8, 1718 },
    { PseudoVOR_VX_M1, 1719 },
    { PseudoVOR_VX_M2, 1720 },
    { PseudoVOR_VX_M4, 1721 },
    { PseudoVOR_VX_M8, 1722 },
    { PseudoVOR_VX_MF2, 1723 },
    { PseudoVOR_VX_MF4, 1724 },
    { PseudoVOR_VX_MF8, 1725 },
    { PseudoVREMU_VV_M1_E16, 1726 },
    { PseudoVREMU_VV_M1_E32, 1727 },
    { PseudoVREMU_VV_M1_E64, 1728 },
    { PseudoVREMU_VV_M1_E8, 1729 },
    { PseudoVREMU_VV_M2_E16, 1730 },
    { PseudoVREMU_VV_M2_E32, 1731 },
    { PseudoVREMU_VV_M2_E64, 1732 },
    { PseudoVREMU_VV_M2_E8, 1733 },
    { PseudoVREMU_VV_M4_E16, 1734 },
    { PseudoVREMU_VV_M4_E32, 1735 },
    { PseudoVREMU_VV_M4_E64, 1736 },
    { PseudoVREMU_VV_M4_E8, 1737 },
    { PseudoVREMU_VV_M8_E16, 1738 },
    { PseudoVREMU_VV_M8_E32, 1739 },
    { PseudoVREMU_VV_M8_E64, 1740 },
    { PseudoVREMU_VV_M8_E8, 1741 },
    { PseudoVREMU_VV_MF2_E16, 1742 },
    { PseudoVREMU_VV_MF2_E32, 1743 },
    { PseudoVREMU_VV_MF2_E8, 1744 },
    { PseudoVREMU_VV_MF4_E16, 1745 },
    { PseudoVREMU_VV_MF4_E8, 1746 },
    { PseudoVREMU_VV_MF8_E8, 1747 },
    { PseudoVREMU_VX_M1_E16, 1748 },
    { PseudoVREMU_VX_M1_E32, 1749 },
    { PseudoVREMU_VX_M1_E64, 1750 },
    { PseudoVREMU_VX_M1_E8, 1751 },
    { PseudoVREMU_VX_M2_E16, 1752 },
    { PseudoVREMU_VX_M2_E32, 1753 },
    { PseudoVREMU_VX_M2_E64, 1754 },
    { PseudoVREMU_VX_M2_E8, 1755 },
    { PseudoVREMU_VX_M4_E16, 1756 },
    { PseudoVREMU_VX_M4_E32, 1757 },
    { PseudoVREMU_VX_M4_E64, 1758 },
    { PseudoVREMU_VX_M4_E8, 1759 },
    { PseudoVREMU_VX_M8_E16, 1760 },
    { PseudoVREMU_VX_M8_E32, 1761 },
    { PseudoVREMU_VX_M8_E64, 1762 },
    { PseudoVREMU_VX_M8_E8, 1763 },
    { PseudoVREMU_VX_MF2_E16, 1764 },
    { PseudoVREMU_VX_MF2_E32, 1765 },
    { PseudoVREMU_VX_MF2_E8, 1766 },
    { PseudoVREMU_VX_MF4_E16, 1767 },
    { PseudoVREMU_VX_MF4_E8, 1768 },
    { PseudoVREMU_VX_MF8_E8, 1769 },
    { PseudoVREM_VV_M1_E16, 1770 },
    { PseudoVREM_VV_M1_E32, 1771 },
    { PseudoVREM_VV_M1_E64, 1772 },
    { PseudoVREM_VV_M1_E8, 1773 },
    { PseudoVREM_VV_M2_E16, 1774 },
    { PseudoVREM_VV_M2_E32, 1775 },
    { PseudoVREM_VV_M2_E64, 1776 },
    { PseudoVREM_VV_M2_E8, 1777 },
    { PseudoVREM_VV_M4_E16, 1778 },
    { PseudoVREM_VV_M4_E32, 1779 },
    { PseudoVREM_VV_M4_E64, 1780 },
    { PseudoVREM_VV_M4_E8, 1781 },
    { PseudoVREM_VV_M8_E16, 1782 },
    { PseudoVREM_VV_M8_E32, 1783 },
    { PseudoVREM_VV_M8_E64, 1784 },
    { PseudoVREM_VV_M8_E8, 1785 },
    { PseudoVREM_VV_MF2_E16, 1786 },
    { PseudoVREM_VV_MF2_E32, 1787 },
    { PseudoVREM_VV_MF2_E8, 1788 },
    { PseudoVREM_VV_MF4_E16, 1789 },
    { PseudoVREM_VV_MF4_E8, 1790 },
    { PseudoVREM_VV_MF8_E8, 1791 },
    { PseudoVREM_VX_M1_E16, 1792 },
    { PseudoVREM_VX_M1_E32, 1793 },
    { PseudoVREM_VX_M1_E64, 1794 },
    { PseudoVREM_VX_M1_E8, 1795 },
    { PseudoVREM_VX_M2_E16, 1796 },
    { PseudoVREM_VX_M2_E32, 1797 },
    { PseudoVREM_VX_M2_E64, 1798 },
    { PseudoVREM_VX_M2_E8, 1799 },
    { PseudoVREM_VX_M4_E16, 1800 },
    { PseudoVREM_VX_M4_E32, 1801 },
    { PseudoVREM_VX_M4_E64, 1802 },
    { PseudoVREM_VX_M4_E8, 1803 },
    { PseudoVREM_VX_M8_E16, 1804 },
    { PseudoVREM_VX_M8_E32, 1805 },
    { PseudoVREM_VX_M8_E64, 1806 },
    { PseudoVREM_VX_M8_E8, 1807 },
    { PseudoVREM_VX_MF2_E16, 1808 },
    { PseudoVREM_VX_MF2_E32, 1809 },
    { PseudoVREM_VX_MF2_E8, 1810 },
    { PseudoVREM_VX_MF4_E16, 1811 },
    { PseudoVREM_VX_MF4_E8, 1812 },
    { PseudoVREM_VX_MF8_E8, 1813 },
    { PseudoVRGATHEREI16_VV_M1_E16_M1, 1814 },
    { PseudoVRGATHEREI16_VV_M1_E16_M2, 1815 },
    { PseudoVRGATHEREI16_VV_M1_E16_MF2, 1816 },
    { PseudoVRGATHEREI16_VV_M1_E16_MF4, 1817 },
    { PseudoVRGATHEREI16_VV_M1_E32_M1, 1818 },
    { PseudoVRGATHEREI16_VV_M1_E32_M2, 1819 },
    { PseudoVRGATHEREI16_VV_M1_E32_MF2, 1820 },
    { PseudoVRGATHEREI16_VV_M1_E32_MF4, 1821 },
    { PseudoVRGATHEREI16_VV_M1_E64_M1, 1822 },
    { PseudoVRGATHEREI16_VV_M1_E64_M2, 1823 },
    { PseudoVRGATHEREI16_VV_M1_E64_MF2, 1824 },
    { PseudoVRGATHEREI16_VV_M1_E64_MF4, 1825 },
    { PseudoVRGATHEREI16_VV_M1_E8_M1, 1826 },
    { PseudoVRGATHEREI16_VV_M1_E8_M2, 1827 },
    { PseudoVRGATHEREI16_VV_M1_E8_MF2, 1828 },
    { PseudoVRGATHEREI16_VV_M1_E8_MF4, 1829 },
    { PseudoVRGATHEREI16_VV_M2_E16_M1, 1830 },
    { PseudoVRGATHEREI16_VV_M2_E16_M2, 1831 },
    { PseudoVRGATHEREI16_VV_M2_E16_M4, 1832 },
    { PseudoVRGATHEREI16_VV_M2_E16_MF2, 1833 },
    { PseudoVRGATHEREI16_VV_M2_E32_M1, 1834 },
    { PseudoVRGATHEREI16_VV_M2_E32_M2, 1835 },
    { PseudoVRGATHEREI16_VV_M2_E32_M4, 1836 },
    { PseudoVRGATHEREI16_VV_M2_E32_MF2, 1837 },
    { PseudoVRGATHEREI16_VV_M2_E64_M1, 1838 },
    { PseudoVRGATHEREI16_VV_M2_E64_M2, 1839 },
    { PseudoVRGATHEREI16_VV_M2_E64_M4, 1840 },
    { PseudoVRGATHEREI16_VV_M2_E64_MF2, 1841 },
    { PseudoVRGATHEREI16_VV_M2_E8_M1, 1842 },
    { PseudoVRGATHEREI16_VV_M2_E8_M2, 1843 },
    { PseudoVRGATHEREI16_VV_M2_E8_M4, 1844 },
    { PseudoVRGATHEREI16_VV_M2_E8_MF2, 1845 },
    { PseudoVRGATHEREI16_VV_M4_E16_M1, 1846 },
    { PseudoVRGATHEREI16_VV_M4_E16_M2, 1847 },
    { PseudoVRGATHEREI16_VV_M4_E16_M4, 1848 },
    { PseudoVRGATHEREI16_VV_M4_E16_M8, 1849 },
    { PseudoVRGATHEREI16_VV_M4_E32_M1, 1850 },
    { PseudoVRGATHEREI16_VV_M4_E32_M2, 1851 },
    { PseudoVRGATHEREI16_VV_M4_E32_M4, 1852 },
    { PseudoVRGATHEREI16_VV_M4_E32_M8, 1853 },
    { PseudoVRGATHEREI16_VV_M4_E64_M1, 1854 },
    { PseudoVRGATHEREI16_VV_M4_E64_M2, 1855 },
    { PseudoVRGATHEREI16_VV_M4_E64_M4, 1856 },
    { PseudoVRGATHEREI16_VV_M4_E64_M8, 1857 },
    { PseudoVRGATHEREI16_VV_M4_E8_M1, 1858 },
    { PseudoVRGATHEREI16_VV_M4_E8_M2, 1859 },
    { PseudoVRGATHEREI16_VV_M4_E8_M4, 1860 },
    { PseudoVRGATHEREI16_VV_M4_E8_M8, 1861 },
    { PseudoVRGATHEREI16_VV_M8_E16_M2, 1862 },
    { PseudoVRGATHEREI16_VV_M8_E16_M4, 1863 },
    { PseudoVRGATHEREI16_VV_M8_E16_M8, 1864 },
    { PseudoVRGATHEREI16_VV_M8_E32_M2, 1865 },
    { PseudoVRGATHEREI16_VV_M8_E32_M4, 1866 },
    { PseudoVRGATHEREI16_VV_M8_E32_M8, 1867 },
    { PseudoVRGATHEREI16_VV_M8_E64_M2, 1868 },
    { PseudoVRGATHEREI16_VV_M8_E64_M4, 1869 },
    { PseudoVRGATHEREI16_VV_M8_E64_M8, 1870 },
    { PseudoVRGATHEREI16_VV_M8_E8_M2, 1871 },
    { PseudoVRGATHEREI16_VV_M8_E8_M4, 1872 },
    { PseudoVRGATHEREI16_VV_M8_E8_M8, 1873 },
    { PseudoVRGATHEREI16_VV_MF2_E16_M1, 1874 },
    { PseudoVRGATHEREI16_VV_MF2_E16_MF2, 1875 },
    { PseudoVRGATHEREI16_VV_MF2_E16_MF4, 1876 },
    { PseudoVRGATHEREI16_VV_MF2_E16_MF8, 1877 },
    { PseudoVRGATHEREI16_VV_MF2_E32_M1, 1878 },
    { PseudoVRGATHEREI16_VV_MF2_E32_MF2, 1879 },
    { PseudoVRGATHEREI16_VV_MF2_E32_MF4, 1880 },
    { PseudoVRGATHEREI16_VV_MF2_E32_MF8, 1881 },
    { PseudoVRGATHEREI16_VV_MF2_E8_M1, 1882 },
    { PseudoVRGATHEREI16_VV_MF2_E8_MF2, 1883 },
    { PseudoVRGATHEREI16_VV_MF2_E8_MF4, 1884 },
    { PseudoVRGATHEREI16_VV_MF2_E8_MF8, 1885 },
    { PseudoVRGATHEREI16_VV_MF4_E16_MF2, 1886 },
    { PseudoVRGATHEREI16_VV_MF4_E16_MF4, 1887 },
    { PseudoVRGATHEREI16_VV_MF4_E16_MF8, 1888 },
    { PseudoVRGATHEREI16_VV_MF4_E8_MF2, 1889 },
    { PseudoVRGATHEREI16_VV_MF4_E8_MF4, 1890 },
    { PseudoVRGATHEREI16_VV_MF4_E8_MF8, 1891 },
    { PseudoVRGATHEREI16_VV_MF8_E8_MF4, 1892 },
    { PseudoVRGATHEREI16_VV_MF8_E8_MF8, 1893 },
    { PseudoVRGATHER_VI_M1, 1894 },
    { PseudoVRGATHER_VI_M2, 1895 },
    { PseudoVRGATHER_VI_M4, 1896 },
    { PseudoVRGATHER_VI_M8, 1897 },
    { PseudoVRGATHER_VI_MF2, 1898 },
    { PseudoVRGATHER_VI_MF4, 1899 },
    { PseudoVRGATHER_VI_MF8, 1900 },
    { PseudoVRGATHER_VV_M1_E16, 1901 },
    { PseudoVRGATHER_VV_M1_E32, 1902 },
    { PseudoVRGATHER_VV_M1_E64, 1903 },
    { PseudoVRGATHER_VV_M1_E8, 1904 },
    { PseudoVRGATHER_VV_M2_E16, 1905 },
    { PseudoVRGATHER_VV_M2_E32, 1906 },
    { PseudoVRGATHER_VV_M2_E64, 1907 },
    { PseudoVRGATHER_VV_M2_E8, 1908 },
    { PseudoVRGATHER_VV_M4_E16, 1909 },
    { PseudoVRGATHER_VV_M4_E32, 1910 },
    { PseudoVRGATHER_VV_M4_E64, 1911 },
    { PseudoVRGATHER_VV_M4_E8, 1912 },
    { PseudoVRGATHER_VV_M8_E16, 1913 },
    { PseudoVRGATHER_VV_M8_E32, 1914 },
    { PseudoVRGATHER_VV_M8_E64, 1915 },
    { PseudoVRGATHER_VV_M8_E8, 1916 },
    { PseudoVRGATHER_VV_MF2_E16, 1917 },
    { PseudoVRGATHER_VV_MF2_E32, 1918 },
    { PseudoVRGATHER_VV_MF2_E8, 1919 },
    { PseudoVRGATHER_VV_MF4_E16, 1920 },
    { PseudoVRGATHER_VV_MF4_E8, 1921 },
    { PseudoVRGATHER_VV_MF8_E8, 1922 },
    { PseudoVRGATHER_VX_M1, 1923 },
    { PseudoVRGATHER_VX_M2, 1924 },
    { PseudoVRGATHER_VX_M4, 1925 },
    { PseudoVRGATHER_VX_M8, 1926 },
    { PseudoVRGATHER_VX_MF2, 1927 },
    { PseudoVRGATHER_VX_MF4, 1928 },
    { PseudoVRGATHER_VX_MF8, 1929 },
    { PseudoVRSUB_VI_M1, 1930 },
    { PseudoVRSUB_VI_M2, 1931 },
    { PseudoVRSUB_VI_M4, 1932 },
    { PseudoVRSUB_VI_M8, 1933 },
    { PseudoVRSUB_VI_MF2, 1934 },
    { PseudoVRSUB_VI_MF4, 1935 },
    { PseudoVRSUB_VI_MF8, 1936 },
    { PseudoVRSUB_VX_M1, 1937 },
    { PseudoVRSUB_VX_M2, 1938 },
    { PseudoVRSUB_VX_M4, 1939 },
    { PseudoVRSUB_VX_M8, 1940 },
    { PseudoVRSUB_VX_MF2, 1941 },
    { PseudoVRSUB_VX_MF4, 1942 },
    { PseudoVRSUB_VX_MF8, 1943 },
    { PseudoVSADDU_VI_M1, 1944 },
    { PseudoVSADDU_VI_M2, 1945 },
    { PseudoVSADDU_VI_M4, 1946 },
    { PseudoVSADDU_VI_M8, 1947 },
    { PseudoVSADDU_VI_MF2, 1948 },
    { PseudoVSADDU_VI_MF4, 1949 },
    { PseudoVSADDU_VI_MF8, 1950 },
    { PseudoVSADDU_VV_M1, 1951 },
    { PseudoVSADDU_VV_M2, 1952 },
    { PseudoVSADDU_VV_M4, 1953 },
    { PseudoVSADDU_VV_M8, 1954 },
    { PseudoVSADDU_VV_MF2, 1955 },
    { PseudoVSADDU_VV_MF4, 1956 },
    { PseudoVSADDU_VV_MF8, 1957 },
    { PseudoVSADDU_VX_M1, 1958 },
    { PseudoVSADDU_VX_M2, 1959 },
    { PseudoVSADDU_VX_M4, 1960 },
    { PseudoVSADDU_VX_M8, 1961 },
    { PseudoVSADDU_VX_MF2, 1962 },
    { PseudoVSADDU_VX_MF4, 1963 },
    { PseudoVSADDU_VX_MF8, 1964 },
    { PseudoVSADD_VI_M1, 1965 },
    { PseudoVSADD_VI_M2, 1966 },
    { PseudoVSADD_VI_M4, 1967 },
    { PseudoVSADD_VI_M8, 1968 },
    { PseudoVSADD_VI_MF2, 1969 },
    { PseudoVSADD_VI_MF4, 1970 },
    { PseudoVSADD_VI_MF8, 1971 },
    { PseudoVSADD_VV_M1, 1972 },
    { PseudoVSADD_VV_M2, 1973 },
    { PseudoVSADD_VV_M4, 1974 },
    { PseudoVSADD_VV_M8, 1975 },
    { PseudoVSADD_VV_MF2, 1976 },
    { PseudoVSADD_VV_MF4, 1977 },
    { PseudoVSADD_VV_MF8, 1978 },
    { PseudoVSADD_VX_M1, 1979 },
    { PseudoVSADD_VX_M2, 1980 },
    { PseudoVSADD_VX_M4, 1981 },
    { PseudoVSADD_VX_M8, 1982 },
    { PseudoVSADD_VX_MF2, 1983 },
    { PseudoVSADD_VX_MF4, 1984 },
    { PseudoVSADD_VX_MF8, 1985 },
    { PseudoVSEXT_VF2_M1, 1986 },
    { PseudoVSEXT_VF2_M2, 1987 },
    { PseudoVSEXT_VF2_M4, 1988 },
    { PseudoVSEXT_VF2_M8, 1989 },
    { PseudoVSEXT_VF2_MF2, 1990 },
    { PseudoVSEXT_VF2_MF4, 1991 },
    { PseudoVSEXT_VF4_M1, 1992 },
    { PseudoVSEXT_VF4_M2, 1993 },
    { PseudoVSEXT_VF4_M4, 1994 },
    { PseudoVSEXT_VF4_M8, 1995 },
    { PseudoVSEXT_VF4_MF2, 1996 },
    { PseudoVSEXT_VF8_M1, 1997 },
    { PseudoVSEXT_VF8_M2, 1998 },
    { PseudoVSEXT_VF8_M4, 1999 },
    { PseudoVSEXT_VF8_M8, 2000 },
    { PseudoVSLIDE1DOWN_VX_M1, 2001 },
    { PseudoVSLIDE1DOWN_VX_M2, 2002 },
    { PseudoVSLIDE1DOWN_VX_M4, 2003 },
    { PseudoVSLIDE1DOWN_VX_M8, 2004 },
    { PseudoVSLIDE1DOWN_VX_MF2, 2005 },
    { PseudoVSLIDE1DOWN_VX_MF4, 2006 },
    { PseudoVSLIDE1DOWN_VX_MF8, 2007 },
    { PseudoVSLIDE1UP_VX_M1, 2008 },
    { PseudoVSLIDE1UP_VX_M2, 2009 },
    { PseudoVSLIDE1UP_VX_M4, 2010 },
    { PseudoVSLIDE1UP_VX_M8, 2011 },
    { PseudoVSLIDE1UP_VX_MF2, 2012 },
    { PseudoVSLIDE1UP_VX_MF4, 2013 },
    { PseudoVSLIDE1UP_VX_MF8, 2014 },
    { PseudoVSLIDEDOWN_VI_M1, 2015 },
    { PseudoVSLIDEDOWN_VI_M2, 2016 },
    { PseudoVSLIDEDOWN_VI_M4, 2017 },
    { PseudoVSLIDEDOWN_VI_M8, 2018 },
    { PseudoVSLIDEDOWN_VI_MF2, 2019 },
    { PseudoVSLIDEDOWN_VI_MF4, 2020 },
    { PseudoVSLIDEDOWN_VI_MF8, 2021 },
    { PseudoVSLIDEDOWN_VX_M1, 2022 },
    { PseudoVSLIDEDOWN_VX_M2, 2023 },
    { PseudoVSLIDEDOWN_VX_M4, 2024 },
    { PseudoVSLIDEDOWN_VX_M8, 2025 },
    { PseudoVSLIDEDOWN_VX_MF2, 2026 },
    { PseudoVSLIDEDOWN_VX_MF4, 2027 },
    { PseudoVSLIDEDOWN_VX_MF8, 2028 },
    { PseudoVSLIDEUP_VI_M1, 2029 },
    { PseudoVSLIDEUP_VI_M2, 2030 },
    { PseudoVSLIDEUP_VI_M4, 2031 },
    { PseudoVSLIDEUP_VI_M8, 2032 },
    { PseudoVSLIDEUP_VI_MF2, 2033 },
    { PseudoVSLIDEUP_VI_MF4, 2034 },
    { PseudoVSLIDEUP_VI_MF8, 2035 },
    { PseudoVSLIDEUP_VX_M1, 2036 },
    { PseudoVSLIDEUP_VX_M2, 2037 },
    { PseudoVSLIDEUP_VX_M4, 2038 },
    { PseudoVSLIDEUP_VX_M8, 2039 },
    { PseudoVSLIDEUP_VX_MF2, 2040 },
    { PseudoVSLIDEUP_VX_MF4, 2041 },
    { PseudoVSLIDEUP_VX_MF8, 2042 },
    { PseudoVSLL_VI_M1, 2043 },
    { PseudoVSLL_VI_M2, 2044 },
    { PseudoVSLL_VI_M4, 2045 },
    { PseudoVSLL_VI_M8, 2046 },
    { PseudoVSLL_VI_MF2, 2047 },
    { PseudoVSLL_VI_MF4, 2048 },
    { PseudoVSLL_VI_MF8, 2049 },
    { PseudoVSLL_VV_M1, 2050 },
    { PseudoVSLL_VV_M2, 2051 },
    { PseudoVSLL_VV_M4, 2052 },
    { PseudoVSLL_VV_M8, 2053 },
    { PseudoVSLL_VV_MF2, 2054 },
    { PseudoVSLL_VV_MF4, 2055 },
    { PseudoVSLL_VV_MF8, 2056 },
    { PseudoVSLL_VX_M1, 2057 },
    { PseudoVSLL_VX_M2, 2058 },
    { PseudoVSLL_VX_M4, 2059 },
    { PseudoVSLL_VX_M8, 2060 },
    { PseudoVSLL_VX_MF2, 2061 },
    { PseudoVSLL_VX_MF4, 2062 },
    { PseudoVSLL_VX_MF8, 2063 },
    { PseudoVSMUL_VV_M1, 2064 },
    { PseudoVSMUL_VV_M2, 2065 },
    { PseudoVSMUL_VV_M4, 2066 },
    { PseudoVSMUL_VV_M8, 2067 },
    { PseudoVSMUL_VV_MF2, 2068 },
    { PseudoVSMUL_VV_MF4, 2069 },
    { PseudoVSMUL_VV_MF8, 2070 },
    { PseudoVSMUL_VX_M1, 2071 },
    { PseudoVSMUL_VX_M2, 2072 },
    { PseudoVSMUL_VX_M4, 2073 },
    { PseudoVSMUL_VX_M8, 2074 },
    { PseudoVSMUL_VX_MF2, 2075 },
    { PseudoVSMUL_VX_MF4, 2076 },
    { PseudoVSMUL_VX_MF8, 2077 },
    { PseudoVSRA_VI_M1, 2078 },
    { PseudoVSRA_VI_M2, 2079 },
    { PseudoVSRA_VI_M4, 2080 },
    { PseudoVSRA_VI_M8, 2081 },
    { PseudoVSRA_VI_MF2, 2082 },
    { PseudoVSRA_VI_MF4, 2083 },
    { PseudoVSRA_VI_MF8, 2084 },
    { PseudoVSRA_VV_M1, 2085 },
    { PseudoVSRA_VV_M2, 2086 },
    { PseudoVSRA_VV_M4, 2087 },
    { PseudoVSRA_VV_M8, 2088 },
    { PseudoVSRA_VV_MF2, 2089 },
    { PseudoVSRA_VV_MF4, 2090 },
    { PseudoVSRA_VV_MF8, 2091 },
    { PseudoVSRA_VX_M1, 2092 },
    { PseudoVSRA_VX_M2, 2093 },
    { PseudoVSRA_VX_M4, 2094 },
    { PseudoVSRA_VX_M8, 2095 },
    { PseudoVSRA_VX_MF2, 2096 },
    { PseudoVSRA_VX_MF4, 2097 },
    { PseudoVSRA_VX_MF8, 2098 },
    { PseudoVSRL_VI_M1, 2099 },
    { PseudoVSRL_VI_M2, 2100 },
    { PseudoVSRL_VI_M4, 2101 },
    { PseudoVSRL_VI_M8, 2102 },
    { PseudoVSRL_VI_MF2, 2103 },
    { PseudoVSRL_VI_MF4, 2104 },
    { PseudoVSRL_VI_MF8, 2105 },
    { PseudoVSRL_VV_M1, 2106 },
    { PseudoVSRL_VV_M2, 2107 },
    { PseudoVSRL_VV_M4, 2108 },
    { PseudoVSRL_VV_M8, 2109 },
    { PseudoVSRL_VV_MF2, 2110 },
    { PseudoVSRL_VV_MF4, 2111 },
    { PseudoVSRL_VV_MF8, 2112 },
    { PseudoVSRL_VX_M1, 2113 },
    { PseudoVSRL_VX_M2, 2114 },
    { PseudoVSRL_VX_M4, 2115 },
    { PseudoVSRL_VX_M8, 2116 },
    { PseudoVSRL_VX_MF2, 2117 },
    { PseudoVSRL_VX_MF4, 2118 },
    { PseudoVSRL_VX_MF8, 2119 },
    { PseudoVSSRA_VI_M1, 2120 },
    { PseudoVSSRA_VI_M2, 2121 },
    { PseudoVSSRA_VI_M4, 2122 },
    { PseudoVSSRA_VI_M8, 2123 },
    { PseudoVSSRA_VI_MF2, 2124 },
    { PseudoVSSRA_VI_MF4, 2125 },
    { PseudoVSSRA_VI_MF8, 2126 },
    { PseudoVSSRA_VV_M1, 2127 },
    { PseudoVSSRA_VV_M2, 2128 },
    { PseudoVSSRA_VV_M4, 2129 },
    { PseudoVSSRA_VV_M8, 2130 },
    { PseudoVSSRA_VV_MF2, 2131 },
    { PseudoVSSRA_VV_MF4, 2132 },
    { PseudoVSSRA_VV_MF8, 2133 },
    { PseudoVSSRA_VX_M1, 2134 },
    { PseudoVSSRA_VX_M2, 2135 },
    { PseudoVSSRA_VX_M4, 2136 },
    { PseudoVSSRA_VX_M8, 2137 },
    { PseudoVSSRA_VX_MF2, 2138 },
    { PseudoVSSRA_VX_MF4, 2139 },
    { PseudoVSSRA_VX_MF8, 2140 },
    { PseudoVSSRL_VI_M1, 2141 },
    { PseudoVSSRL_VI_M2, 2142 },
    { PseudoVSSRL_VI_M4, 2143 },
    { PseudoVSSRL_VI_M8, 2144 },
    { PseudoVSSRL_VI_MF2, 2145 },
    { PseudoVSSRL_VI_MF4, 2146 },
    { PseudoVSSRL_VI_MF8, 2147 },
    { PseudoVSSRL_VV_M1, 2148 },
    { PseudoVSSRL_VV_M2, 2149 },
    { PseudoVSSRL_VV_M4, 2150 },
    { PseudoVSSRL_VV_M8, 2151 },
    { PseudoVSSRL_VV_MF2, 2152 },
    { PseudoVSSRL_VV_MF4, 2153 },
    { PseudoVSSRL_VV_MF8, 2154 },
    { PseudoVSSRL_VX_M1, 2155 },
    { PseudoVSSRL_VX_M2, 2156 },
    { PseudoVSSRL_VX_M4, 2157 },
    { PseudoVSSRL_VX_M8, 2158 },
    { PseudoVSSRL_VX_MF2, 2159 },
    { PseudoVSSRL_VX_MF4, 2160 },
    { PseudoVSSRL_VX_MF8, 2161 },
    { PseudoVSSUBU_VV_M1, 2162 },
    { PseudoVSSUBU_VV_M2, 2163 },
    { PseudoVSSUBU_VV_M4, 2164 },
    { PseudoVSSUBU_VV_M8, 2165 },
    { PseudoVSSUBU_VV_MF2, 2166 },
    { PseudoVSSUBU_VV_MF4, 2167 },
    { PseudoVSSUBU_VV_MF8, 2168 },
    { PseudoVSSUBU_VX_M1, 2169 },
    { PseudoVSSUBU_VX_M2, 2170 },
    { PseudoVSSUBU_VX_M4, 2171 },
    { PseudoVSSUBU_VX_M8, 2172 },
    { PseudoVSSUBU_VX_MF2, 2173 },
    { PseudoVSSUBU_VX_MF4, 2174 },
    { PseudoVSSUBU_VX_MF8, 2175 },
    { PseudoVSSUB_VV_M1, 2176 },
    { PseudoVSSUB_VV_M2, 2177 },
    { PseudoVSSUB_VV_M4, 2178 },
    { PseudoVSSUB_VV_M8, 2179 },
    { PseudoVSSUB_VV_MF2, 2180 },
    { PseudoVSSUB_VV_MF4, 2181 },
    { PseudoVSSUB_VV_MF8, 2182 },
    { PseudoVSSUB_VX_M1, 2183 },
    { PseudoVSSUB_VX_M2, 2184 },
    { PseudoVSSUB_VX_M4, 2185 },
    { PseudoVSSUB_VX_M8, 2186 },
    { PseudoVSSUB_VX_MF2, 2187 },
    { PseudoVSSUB_VX_MF4, 2188 },
    { PseudoVSSUB_VX_MF8, 2189 },
    { PseudoVSUB_VV_M1, 2190 },
    { PseudoVSUB_VV_M2, 2191 },
    { PseudoVSUB_VV_M4, 2192 },
    { PseudoVSUB_VV_M8, 2193 },
    { PseudoVSUB_VV_MF2, 2194 },
    { PseudoVSUB_VV_MF4, 2195 },
    { PseudoVSUB_VV_MF8, 2196 },
    { PseudoVSUB_VX_M1, 2197 },
    { PseudoVSUB_VX_M2, 2198 },
    { PseudoVSUB_VX_M4, 2199 },
    { PseudoVSUB_VX_M8, 2200 },
    { PseudoVSUB_VX_MF2, 2201 },
    { PseudoVSUB_VX_MF4, 2202 },
    { PseudoVSUB_VX_MF8, 2203 },
    { PseudoVWADDU_VV_M1, 2204 },
    { PseudoVWADDU_VV_M2, 2205 },
    { PseudoVWADDU_VV_M4, 2206 },
    { PseudoVWADDU_VV_MF2, 2207 },
    { PseudoVWADDU_VV_MF4, 2208 },
    { PseudoVWADDU_VV_MF8, 2209 },
    { PseudoVWADDU_VX_M1, 2210 },
    { PseudoVWADDU_VX_M2, 2211 },
    { PseudoVWADDU_VX_M4, 2212 },
    { PseudoVWADDU_VX_MF2, 2213 },
    { PseudoVWADDU_VX_MF4, 2214 },
    { PseudoVWADDU_VX_MF8, 2215 },
    { PseudoVWADDU_WV_M1, 2216 },
    { PseudoVWADDU_WV_M2, 2217 },
    { PseudoVWADDU_WV_M4, 2218 },
    { PseudoVWADDU_WV_MF2, 2219 },
    { PseudoVWADDU_WV_MF4, 2220 },
    { PseudoVWADDU_WV_MF8, 2221 },
    { PseudoVWADDU_WX_M1, 2222 },
    { PseudoVWADDU_WX_M2, 2223 },
    { PseudoVWADDU_WX_M4, 2224 },
    { PseudoVWADDU_WX_MF2, 2225 },
    { PseudoVWADDU_WX_MF4, 2226 },
    { PseudoVWADDU_WX_MF8, 2227 },
    { PseudoVWADD_VV_M1, 2228 },
    { PseudoVWADD_VV_M2, 2229 },
    { PseudoVWADD_VV_M4, 2230 },
    { PseudoVWADD_VV_MF2, 2231 },
    { PseudoVWADD_VV_MF4, 2232 },
    { PseudoVWADD_VV_MF8, 2233 },
    { PseudoVWADD_VX_M1, 2234 },
    { PseudoVWADD_VX_M2, 2235 },
    { PseudoVWADD_VX_M4, 2236 },
    { PseudoVWADD_VX_MF2, 2237 },
    { PseudoVWADD_VX_MF4, 2238 },
    { PseudoVWADD_VX_MF8, 2239 },
    { PseudoVWADD_WV_M1, 2240 },
    { PseudoVWADD_WV_M2, 2241 },
    { PseudoVWADD_WV_M4, 2242 },
    { PseudoVWADD_WV_MF2, 2243 },
    { PseudoVWADD_WV_MF4, 2244 },
    { PseudoVWADD_WV_MF8, 2245 },
    { PseudoVWADD_WX_M1, 2246 },
    { PseudoVWADD_WX_M2, 2247 },
    { PseudoVWADD_WX_M4, 2248 },
    { PseudoVWADD_WX_MF2, 2249 },
    { PseudoVWADD_WX_MF4, 2250 },
    { PseudoVWADD_WX_MF8, 2251 },
    { PseudoVWMACCSU_VV_M1, 2252 },
    { PseudoVWMACCSU_VV_M2, 2253 },
    { PseudoVWMACCSU_VV_M4, 2254 },
    { PseudoVWMACCSU_VV_MF2, 2255 },
    { PseudoVWMACCSU_VV_MF4, 2256 },
    { PseudoVWMACCSU_VV_MF8, 2257 },
    { PseudoVWMACCSU_VX_M1, 2258 },
    { PseudoVWMACCSU_VX_M2, 2259 },
    { PseudoVWMACCSU_VX_M4, 2260 },
    { PseudoVWMACCSU_VX_MF2, 2261 },
    { PseudoVWMACCSU_VX_MF4, 2262 },
    { PseudoVWMACCSU_VX_MF8, 2263 },
    { PseudoVWMACCUS_VX_M1, 2264 },
    { PseudoVWMACCUS_VX_M2, 2265 },
    { PseudoVWMACCUS_VX_M4, 2266 },
    { PseudoVWMACCUS_VX_MF2, 2267 },
    { PseudoVWMACCUS_VX_MF4, 2268 },
    { PseudoVWMACCUS_VX_MF8, 2269 },
    { PseudoVWMACCU_VV_M1, 2270 },
    { PseudoVWMACCU_VV_M2, 2271 },
    { PseudoVWMACCU_VV_M4, 2272 },
    { PseudoVWMACCU_VV_MF2, 2273 },
    { PseudoVWMACCU_VV_MF4, 2274 },
    { PseudoVWMACCU_VV_MF8, 2275 },
    { PseudoVWMACCU_VX_M1, 2276 },
    { PseudoVWMACCU_VX_M2, 2277 },
    { PseudoVWMACCU_VX_M4, 2278 },
    { PseudoVWMACCU_VX_MF2, 2279 },
    { PseudoVWMACCU_VX_MF4, 2280 },
    { PseudoVWMACCU_VX_MF8, 2281 },
    { PseudoVWMACC_VV_M1, 2282 },
    { PseudoVWMACC_VV_M2, 2283 },
    { PseudoVWMACC_VV_M4, 2284 },
    { PseudoVWMACC_VV_MF2, 2285 },
    { PseudoVWMACC_VV_MF4, 2286 },
    { PseudoVWMACC_VV_MF8, 2287 },
    { PseudoVWMACC_VX_M1, 2288 },
    { PseudoVWMACC_VX_M2, 2289 },
    { PseudoVWMACC_VX_M4, 2290 },
    { PseudoVWMACC_VX_MF2, 2291 },
    { PseudoVWMACC_VX_MF4, 2292 },
    { PseudoVWMACC_VX_MF8, 2293 },
    { PseudoVWMULSU_VV_M1, 2294 },
    { PseudoVWMULSU_VV_M2, 2295 },
    { PseudoVWMULSU_VV_M4, 2296 },
    { PseudoVWMULSU_VV_MF2, 2297 },
    { PseudoVWMULSU_VV_MF4, 2298 },
    { PseudoVWMULSU_VV_MF8, 2299 },
    { PseudoVWMULSU_VX_M1, 2300 },
    { PseudoVWMULSU_VX_M2, 2301 },
    { PseudoVWMULSU_VX_M4, 2302 },
    { PseudoVWMULSU_VX_MF2, 2303 },
    { PseudoVWMULSU_VX_MF4, 2304 },
    { PseudoVWMULSU_VX_MF8, 2305 },
    { PseudoVWMULU_VV_M1, 2306 },
    { PseudoVWMULU_VV_M2, 2307 },
    { PseudoVWMULU_VV_M4, 2308 },
    { PseudoVWMULU_VV_MF2, 2309 },
    { PseudoVWMULU_VV_MF4, 2310 },
    { PseudoVWMULU_VV_MF8, 2311 },
    { PseudoVWMULU_VX_M1, 2312 },
    { PseudoVWMULU_VX_M2, 2313 },
    { PseudoVWMULU_VX_M4, 2314 },
    { PseudoVWMULU_VX_MF2, 2315 },
    { PseudoVWMULU_VX_MF4, 2316 },
    { PseudoVWMULU_VX_MF8, 2317 },
    { PseudoVWMUL_VV_M1, 2318 },
    { PseudoVWMUL_VV_M2, 2319 },
    { PseudoVWMUL_VV_M4, 2320 },
    { PseudoVWMUL_VV_MF2, 2321 },
    { PseudoVWMUL_VV_MF4, 2322 },
    { PseudoVWMUL_VV_MF8, 2323 },
    { PseudoVWMUL_VX_M1, 2324 },
    { PseudoVWMUL_VX_M2, 2325 },
    { PseudoVWMUL_VX_M4, 2326 },
    { PseudoVWMUL_VX_MF2, 2327 },
    { PseudoVWMUL_VX_MF4, 2328 },
    { PseudoVWMUL_VX_MF8, 2329 },
    { PseudoVWSUBU_VV_M1, 2330 },
    { PseudoVWSUBU_VV_M2, 2331 },
    { PseudoVWSUBU_VV_M4, 2332 },
    { PseudoVWSUBU_VV_MF2, 2333 },
    { PseudoVWSUBU_VV_MF4, 2334 },
    { PseudoVWSUBU_VV_MF8, 2335 },
    { PseudoVWSUBU_VX_M1, 2336 },
    { PseudoVWSUBU_VX_M2, 2337 },
    { PseudoVWSUBU_VX_M4, 2338 },
    { PseudoVWSUBU_VX_MF2, 2339 },
    { PseudoVWSUBU_VX_MF4, 2340 },
    { PseudoVWSUBU_VX_MF8, 2341 },
    { PseudoVWSUBU_WV_M1, 2342 },
    { PseudoVWSUBU_WV_M2, 2343 },
    { PseudoVWSUBU_WV_M4, 2344 },
    { PseudoVWSUBU_WV_MF2, 2345 },
    { PseudoVWSUBU_WV_MF4, 2346 },
    { PseudoVWSUBU_WV_MF8, 2347 },
    { PseudoVWSUBU_WX_M1, 2348 },
    { PseudoVWSUBU_WX_M2, 2349 },
    { PseudoVWSUBU_WX_M4, 2350 },
    { PseudoVWSUBU_WX_MF2, 2351 },
    { PseudoVWSUBU_WX_MF4, 2352 },
    { PseudoVWSUBU_WX_MF8, 2353 },
    { PseudoVWSUB_VV_M1, 2354 },
    { PseudoVWSUB_VV_M2, 2355 },
    { PseudoVWSUB_VV_M4, 2356 },
    { PseudoVWSUB_VV_MF2, 2357 },
    { PseudoVWSUB_VV_MF4, 2358 },
    { PseudoVWSUB_VV_MF8, 2359 },
    { PseudoVWSUB_VX_M1, 2360 },
    { PseudoVWSUB_VX_M2, 2361 },
    { PseudoVWSUB_VX_M4, 2362 },
    { PseudoVWSUB_VX_MF2, 2363 },
    { PseudoVWSUB_VX_MF4, 2364 },
    { PseudoVWSUB_VX_MF8, 2365 },
    { PseudoVWSUB_WV_M1, 2366 },
    { PseudoVWSUB_WV_M2, 2367 },
    { PseudoVWSUB_WV_M4, 2368 },
    { PseudoVWSUB_WV_MF2, 2369 },
    { PseudoVWSUB_WV_MF4, 2370 },
    { PseudoVWSUB_WV_MF8, 2371 },
    { PseudoVWSUB_WX_M1, 2372 },
    { PseudoVWSUB_WX_M2, 2373 },
    { PseudoVWSUB_WX_M4, 2374 },
    { PseudoVWSUB_WX_MF2, 2375 },
    { PseudoVWSUB_WX_MF4, 2376 },
    { PseudoVWSUB_WX_MF8, 2377 },
    { PseudoVXOR_VI_M1, 2378 },
    { PseudoVXOR_VI_M2, 2379 },
    { PseudoVXOR_VI_M4, 2380 },
    { PseudoVXOR_VI_M8, 2381 },
    { PseudoVXOR_VI_MF2, 2382 },
    { PseudoVXOR_VI_MF4, 2383 },
    { PseudoVXOR_VI_MF8, 2384 },
    { PseudoVXOR_VV_M1, 2385 },
    { PseudoVXOR_VV_M2, 2386 },
    { PseudoVXOR_VV_M4, 2387 },
    { PseudoVXOR_VV_M8, 2388 },
    { PseudoVXOR_VV_MF2, 2389 },
    { PseudoVXOR_VV_MF4, 2390 },
    { PseudoVXOR_VV_MF8, 2391 },
    { PseudoVXOR_VX_M1, 2392 },
    { PseudoVXOR_VX_M2, 2393 },
    { PseudoVXOR_VX_M4, 2394 },
    { PseudoVXOR_VX_M8, 2395 },
    { PseudoVXOR_VX_MF2, 2396 },
    { PseudoVXOR_VX_MF4, 2397 },
    { PseudoVXOR_VX_MF8, 2398 },
    { PseudoVZEXT_VF2_M1, 2399 },
    { PseudoVZEXT_VF2_M2, 2400 },
    { PseudoVZEXT_VF2_M4, 2401 },
    { PseudoVZEXT_VF2_M8, 2402 },
    { PseudoVZEXT_VF2_MF2, 2403 },
    { PseudoVZEXT_VF2_MF4, 2404 },
    { PseudoVZEXT_VF4_M1, 2405 },
    { PseudoVZEXT_VF4_M2, 2406 },
    { PseudoVZEXT_VF4_M4, 2407 },
    { PseudoVZEXT_VF4_M8, 2408 },
    { PseudoVZEXT_VF4_MF2, 2409 },
    { PseudoVZEXT_VF8_M1, 2410 },
    { PseudoVZEXT_VF8_M2, 2411 },
    { PseudoVZEXT_VF8_M4, 2412 },
    { PseudoVZEXT_VF8_M8, 2413 },
  };

  struct KeyType {
    unsigned UnmaskedPseudo;
  };
  KeyType Key = {UnmaskedPseudo};
  auto Table = ArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      if (LHS.UnmaskedPseudo < RHS.UnmaskedPseudo)
        return true;
      if (LHS.UnmaskedPseudo > RHS.UnmaskedPseudo)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.UnmaskedPseudo != Idx->UnmaskedPseudo)
    return nullptr;
  return &RISCVMaskedPseudosTable[Idx->_index];
}
#endif

#ifdef GET_RISCVOpcodesList_DECL
const RISCVOpcode *lookupRISCVOpcodeByValue(uint8_t Value);
const RISCVOpcode *lookupRISCVOpcodeByName(StringRef Name);
#endif

#ifdef GET_RISCVOpcodesList_IMPL
constexpr RISCVOpcode RISCVOpcodesList[] = {
  { "LOAD", 0x3 }, // 0
  { "LOAD_FP", 0x7 }, // 1
  { "CUSTOM_0", 0xB }, // 2
  { "MISC_MEM", 0xF }, // 3
  { "OP_IMM", 0x13 }, // 4
  { "AUIPC", 0x17 }, // 5
  { "OP_IMM_32", 0x1B }, // 6
  { "STORE", 0x23 }, // 7
  { "STORE_FP", 0x27 }, // 8
  { "CUSTOM_1", 0x2B }, // 9
  { "AMO", 0x2F }, // 10
  { "OP", 0x33 }, // 11
  { "LUI", 0x37 }, // 12
  { "OP_32", 0x3B }, // 13
  { "MADD", 0x43 }, // 14
  { "MSUB", 0x47 }, // 15
  { "NMSUB", 0x4B }, // 16
  { "NMADD", 0x4F }, // 17
  { "OP_FP", 0x53 }, // 18
  { "OP_V", 0x57 }, // 19
  { "CUSTOM_2", 0x5B }, // 20
  { "BRANCH", 0x63 }, // 21
  { "JALR", 0x67 }, // 22
  { "JAL", 0x6F }, // 23
  { "SYSTEM", 0x73 }, // 24
  { "OP_P", 0x77 }, // 25
  { "CUSTOM_3", 0x7B }, // 26
 };

const RISCVOpcode *lookupRISCVOpcodeByValue(uint8_t Value) {
  struct KeyType {
    uint8_t Value;
  };
  KeyType Key = {Value};
  auto Table = ArrayRef(RISCVOpcodesList);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const RISCVOpcode &LHS, const KeyType &RHS) {
      if (LHS.Value < RHS.Value)
        return true;
      if (LHS.Value > RHS.Value)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Value != Idx->Value)
    return nullptr;
  return &*Idx;
}

const RISCVOpcode *lookupRISCVOpcodeByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "AMO", 10 },
    { "AUIPC", 5 },
    { "BRANCH", 21 },
    { "CUSTOM_0", 2 },
    { "CUSTOM_1", 9 },
    { "CUSTOM_2", 20 },
    { "CUSTOM_3", 26 },
    { "JAL", 23 },
    { "JALR", 22 },
    { "LOAD", 0 },
    { "LOAD_FP", 1 },
    { "LUI", 12 },
    { "MADD", 14 },
    { "MISC_MEM", 3 },
    { "MSUB", 15 },
    { "NMADD", 17 },
    { "NMSUB", 16 },
    { "OP", 11 },
    { "OP_32", 13 },
    { "OP_FP", 18 },
    { "OP_IMM", 4 },
    { "OP_IMM_32", 6 },
    { "OP_P", 25 },
    { "OP_V", 19 },
    { "STORE", 7 },
    { "STORE_FP", 8 },
    { "SYSTEM", 24 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = ArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &RISCVOpcodesList[Idx->_index];
}
#endif

#ifdef GET_RISCVVIntrinsicsTable_DECL
const RISCVVIntrinsicInfo *getRISCVVIntrinsicInfo(unsigned IntrinsicID);
#endif

#ifdef GET_RISCVVIntrinsicsTable_IMPL
constexpr RISCVVIntrinsicInfo RISCVVIntrinsicsTable[] = {
  { Intrinsic::riscv_sf_vc_fv_se, 0x3, 0x4 }, // 0
  { Intrinsic::riscv_sf_vc_fvv_se, 0x3, 0x4 }, // 1
  { Intrinsic::riscv_sf_vc_fvw_se, 0x3, 0x4 }, // 2
  { Intrinsic::riscv_sf_vc_i_se_e16m1, 0xF, 0x4 }, // 3
  { Intrinsic::riscv_sf_vc_i_se_e16m2, 0xF, 0x4 }, // 4
  { Intrinsic::riscv_sf_vc_i_se_e16m4, 0xF, 0x4 }, // 5
  { Intrinsic::riscv_sf_vc_i_se_e16m8, 0xF, 0x4 }, // 6
  { Intrinsic::riscv_sf_vc_i_se_e16mf2, 0xF, 0x4 }, // 7
  { Intrinsic::riscv_sf_vc_i_se_e16mf4, 0xF, 0x4 }, // 8
  { Intrinsic::riscv_sf_vc_i_se_e32m1, 0xF, 0x4 }, // 9
  { Intrinsic::riscv_sf_vc_i_se_e32m2, 0xF, 0x4 }, // 10
  { Intrinsic::riscv_sf_vc_i_se_e32m4, 0xF, 0x4 }, // 11
  { Intrinsic::riscv_sf_vc_i_se_e32m8, 0xF, 0x4 }, // 12
  { Intrinsic::riscv_sf_vc_i_se_e32mf2, 0xF, 0x4 }, // 13
  { Intrinsic::riscv_sf_vc_i_se_e64m1, 0xF, 0x4 }, // 14
  { Intrinsic::riscv_sf_vc_i_se_e64m2, 0xF, 0x4 }, // 15
  { Intrinsic::riscv_sf_vc_i_se_e64m4, 0xF, 0x4 }, // 16
  { Intrinsic::riscv_sf_vc_i_se_e64m8, 0xF, 0x4 }, // 17
  { Intrinsic::riscv_sf_vc_i_se_e8m1, 0xF, 0x4 }, // 18
  { Intrinsic::riscv_sf_vc_i_se_e8m2, 0xF, 0x4 }, // 19
  { Intrinsic::riscv_sf_vc_i_se_e8m4, 0xF, 0x4 }, // 20
  { Intrinsic::riscv_sf_vc_i_se_e8m8, 0xF, 0x4 }, // 21
  { Intrinsic::riscv_sf_vc_i_se_e8mf2, 0xF, 0x4 }, // 22
  { Intrinsic::riscv_sf_vc_i_se_e8mf4, 0xF, 0x4 }, // 23
  { Intrinsic::riscv_sf_vc_i_se_e8mf8, 0xF, 0x4 }, // 24
  { Intrinsic::riscv_sf_vc_iv_se, 0xF, 0x4 }, // 25
  { Intrinsic::riscv_sf_vc_ivv_se, 0xF, 0x4 }, // 26
  { Intrinsic::riscv_sf_vc_ivw_se, 0xF, 0x4 }, // 27
  { Intrinsic::riscv_sf_vc_v_fv, 0x2, 0x3 }, // 28
  { Intrinsic::riscv_sf_vc_v_fv_se, 0x2, 0x3 }, // 29
  { Intrinsic::riscv_sf_vc_v_fvv, 0x3, 0x4 }, // 30
  { Intrinsic::riscv_sf_vc_v_fvv_se, 0x3, 0x4 }, // 31
  { Intrinsic::riscv_sf_vc_v_fvw, 0x3, 0x4 }, // 32
  { Intrinsic::riscv_sf_vc_v_fvw_se, 0x3, 0x4 }, // 33
  { Intrinsic::riscv_sf_vc_v_i, 0xF, 0x3 }, // 34
  { Intrinsic::riscv_sf_vc_v_i_se, 0xF, 0x3 }, // 35
  { Intrinsic::riscv_sf_vc_v_iv, 0xF, 0x3 }, // 36
  { Intrinsic::riscv_sf_vc_v_iv_se, 0xF, 0x3 }, // 37
  { Intrinsic::riscv_sf_vc_v_ivv, 0xF, 0x4 }, // 38
  { Intrinsic::riscv_sf_vc_v_ivv_se, 0xF, 0x4 }, // 39
  { Intrinsic::riscv_sf_vc_v_ivw, 0xF, 0x4 }, // 40
  { Intrinsic::riscv_sf_vc_v_ivw_se, 0xF, 0x4 }, // 41
  { Intrinsic::riscv_sf_vc_v_vv, 0x2, 0x3 }, // 42
  { Intrinsic::riscv_sf_vc_v_vv_se, 0x2, 0x3 }, // 43
  { Intrinsic::riscv_sf_vc_v_vvv, 0x3, 0x4 }, // 44
  { Intrinsic::riscv_sf_vc_v_vvv_se, 0x3, 0x4 }, // 45
  { Intrinsic::riscv_sf_vc_v_vvw, 0x3, 0x4 }, // 46
  { Intrinsic::riscv_sf_vc_v_vvw_se, 0x3, 0x4 }, // 47
  { Intrinsic::riscv_sf_vc_v_x, 0x2, 0x3 }, // 48
  { Intrinsic::riscv_sf_vc_v_x_se, 0x2, 0x3 }, // 49
  { Intrinsic::riscv_sf_vc_v_xv, 0x2, 0x3 }, // 50
  { Intrinsic::riscv_sf_vc_v_xv_se, 0x2, 0x3 }, // 51
  { Intrinsic::riscv_sf_vc_v_xvv, 0x3, 0x4 }, // 52
  { Intrinsic::riscv_sf_vc_v_xvv_se, 0x3, 0x4 }, // 53
  { Intrinsic::riscv_sf_vc_v_xvw, 0x3, 0x4 }, // 54
  { Intrinsic::riscv_sf_vc_v_xvw_se, 0x3, 0x4 }, // 55
  { Intrinsic::riscv_sf_vc_vv_se, 0x3, 0x4 }, // 56
  { Intrinsic::riscv_sf_vc_vvv_se, 0x3, 0x4 }, // 57
  { Intrinsic::riscv_sf_vc_vvw_se, 0x3, 0x4 }, // 58
  { Intrinsic::riscv_sf_vc_x_se_e16m1, 0x3, 0x4 }, // 59
  { Intrinsic::riscv_sf_vc_x_se_e16m2, 0x3, 0x4 }, // 60
  { Intrinsic::riscv_sf_vc_x_se_e16m4, 0x3, 0x4 }, // 61
  { Intrinsic::riscv_sf_vc_x_se_e16m8, 0x3, 0x4 }, // 62
  { Intrinsic::riscv_sf_vc_x_se_e16mf2, 0x3, 0x4 }, // 63
  { Intrinsic::riscv_sf_vc_x_se_e16mf4, 0x3, 0x4 }, // 64
  { Intrinsic::riscv_sf_vc_x_se_e32m1, 0x3, 0x4 }, // 65
  { Intrinsic::riscv_sf_vc_x_se_e32m2, 0x3, 0x4 }, // 66
  { Intrinsic::riscv_sf_vc_x_se_e32m4, 0x3, 0x4 }, // 67
  { Intrinsic::riscv_sf_vc_x_se_e32m8, 0x3, 0x4 }, // 68
  { Intrinsic::riscv_sf_vc_x_se_e32mf2, 0x3, 0x4 }, // 69
  { Intrinsic::riscv_sf_vc_x_se_e64m1, 0x3, 0x4 }, // 70
  { Intrinsic::riscv_sf_vc_x_se_e64m2, 0x3, 0x4 }, // 71
  { Intrinsic::riscv_sf_vc_x_se_e64m4, 0x3, 0x4 }, // 72
  { Intrinsic::riscv_sf_vc_x_se_e64m8, 0x3, 0x4 }, // 73
  { Intrinsic::riscv_sf_vc_x_se_e8m1, 0x3, 0x4 }, // 74
  { Intrinsic::riscv_sf_vc_x_se_e8m2, 0x3, 0x4 }, // 75
  { Intrinsic::riscv_sf_vc_x_se_e8m4, 0x3, 0x4 }, // 76
  { Intrinsic::riscv_sf_vc_x_se_e8m8, 0x3, 0x4 }, // 77
  { Intrinsic::riscv_sf_vc_x_se_e8mf2, 0x3, 0x4 }, // 78
  { Intrinsic::riscv_sf_vc_x_se_e8mf4, 0x3, 0x4 }, // 79
  { Intrinsic::riscv_sf_vc_x_se_e8mf8, 0x3, 0x4 }, // 80
  { Intrinsic::riscv_sf_vc_xv_se, 0x3, 0x4 }, // 81
  { Intrinsic::riscv_sf_vc_xvv_se, 0x3, 0x4 }, // 82
  { Intrinsic::riscv_sf_vc_xvw_se, 0x3, 0x4 }, // 83
  { Intrinsic::riscv_th_vmaqa, 0x1, 0x3 }, // 84
  { Intrinsic::riscv_th_vmaqa_mask, 0x1, 0x4 }, // 85
  { Intrinsic::riscv_th_vmaqasu, 0x1, 0x3 }, // 86
  { Intrinsic::riscv_th_vmaqasu_mask, 0x1, 0x4 }, // 87
  { Intrinsic::riscv_th_vmaqau, 0x1, 0x3 }, // 88
  { Intrinsic::riscv_th_vmaqau_mask, 0x1, 0x4 }, // 89
  { Intrinsic::riscv_th_vmaqaus, 0x1, 0x3 }, // 90
  { Intrinsic::riscv_th_vmaqaus_mask, 0x1, 0x4 }, // 91
  { Intrinsic::riscv_vaadd, 0x2, 0x3 }, // 92
  { Intrinsic::riscv_vaadd_mask, 0x2, 0x4 }, // 93
  { Intrinsic::riscv_vaaddu, 0x2, 0x3 }, // 94
  { Intrinsic::riscv_vaaddu_mask, 0x2, 0x4 }, // 95
  { Intrinsic::riscv_vadc, 0x2, 0x4 }, // 96
  { Intrinsic::riscv_vadd, 0x2, 0x3 }, // 97
  { Intrinsic::riscv_vadd_mask, 0x2, 0x4 }, // 98
  { Intrinsic::riscv_vand, 0x2, 0x3 }, // 99
  { Intrinsic::riscv_vand_mask, 0x2, 0x4 }, // 100
  { Intrinsic::riscv_vasub, 0x2, 0x3 }, // 101
  { Intrinsic::riscv_vasub_mask, 0x2, 0x4 }, // 102
  { Intrinsic::riscv_vasubu, 0x2, 0x3 }, // 103
  { Intrinsic::riscv_vasubu_mask, 0x2, 0x4 }, // 104
  { Intrinsic::riscv_vcompress, 0xF, 0x3 }, // 105
  { Intrinsic::riscv_vcpop, 0xF, 0x1 }, // 106
  { Intrinsic::riscv_vcpop_mask, 0xF, 0x2 }, // 107
  { Intrinsic::riscv_vdiv, 0x2, 0x3 }, // 108
  { Intrinsic::riscv_vdiv_mask, 0x2, 0x4 }, // 109
  { Intrinsic::riscv_vdivu, 0x2, 0x3 }, // 110
  { Intrinsic::riscv_vdivu_mask, 0x2, 0x4 }, // 111
  { Intrinsic::riscv_vfadd, 0x2, 0x3 }, // 112
  { Intrinsic::riscv_vfadd_mask, 0x2, 0x4 }, // 113
  { Intrinsic::riscv_vfclass, 0xF, 0x1 }, // 114
  { Intrinsic::riscv_vfclass_mask, 0xF, 0x3 }, // 115
  { Intrinsic::riscv_vfcvt_f_x_v, 0xF, 0x2 }, // 116
  { Intrinsic::riscv_vfcvt_f_x_v_mask, 0xF, 0x3 }, // 117
  { Intrinsic::riscv_vfcvt_f_xu_v, 0xF, 0x2 }, // 118
  { Intrinsic::riscv_vfcvt_f_xu_v_mask, 0xF, 0x3 }, // 119
  { Intrinsic::riscv_vfcvt_rtz_x_f_v, 0xF, 0x2 }, // 120
  { Intrinsic::riscv_vfcvt_rtz_x_f_v_mask, 0xF, 0x3 }, // 121
  { Intrinsic::riscv_vfcvt_rtz_xu_f_v, 0xF, 0x2 }, // 122
  { Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask, 0xF, 0x3 }, // 123
  { Intrinsic::riscv_vfcvt_x_f_v, 0xF, 0x2 }, // 124
  { Intrinsic::riscv_vfcvt_x_f_v_mask, 0xF, 0x3 }, // 125
  { Intrinsic::riscv_vfcvt_xu_f_v, 0xF, 0x2 }, // 126
  { Intrinsic::riscv_vfcvt_xu_f_v_mask, 0xF, 0x3 }, // 127
  { Intrinsic::riscv_vfdiv, 0x2, 0x3 }, // 128
  { Intrinsic::riscv_vfdiv_mask, 0x2, 0x4 }, // 129
  { Intrinsic::riscv_vfirst, 0xF, 0x1 }, // 130
  { Intrinsic::riscv_vfirst_mask, 0xF, 0x2 }, // 131
  { Intrinsic::riscv_vfmacc, 0x1, 0x3 }, // 132
  { Intrinsic::riscv_vfmacc_mask, 0x1, 0x4 }, // 133
  { Intrinsic::riscv_vfmadd, 0x1, 0x3 }, // 134
  { Intrinsic::riscv_vfmadd_mask, 0x1, 0x4 }, // 135
  { Intrinsic::riscv_vfmax, 0x2, 0x3 }, // 136
  { Intrinsic::riscv_vfmax_mask, 0x2, 0x4 }, // 137
  { Intrinsic::riscv_vfmerge, 0x2, 0x4 }, // 138
  { Intrinsic::riscv_vfmin, 0x2, 0x3 }, // 139
  { Intrinsic::riscv_vfmin_mask, 0x2, 0x4 }, // 140
  { Intrinsic::riscv_vfmsac, 0x1, 0x3 }, // 141
  { Intrinsic::riscv_vfmsac_mask, 0x1, 0x4 }, // 142
  { Intrinsic::riscv_vfmsub, 0x1, 0x3 }, // 143
  { Intrinsic::riscv_vfmsub_mask, 0x1, 0x4 }, // 144
  { Intrinsic::riscv_vfmul, 0x2, 0x3 }, // 145
  { Intrinsic::riscv_vfmul_mask, 0x2, 0x4 }, // 146
  { Intrinsic::riscv_vfmv_f_s, 0xF, 0x1F }, // 147
  { Intrinsic::riscv_vfmv_s_f, 0xF, 0x2 }, // 148
  { Intrinsic::riscv_vfmv_v_f, 0xF, 0x2 }, // 149
  { Intrinsic::riscv_vfncvt_f_f_w, 0xF, 0x2 }, // 150
  { Intrinsic::riscv_vfncvt_f_f_w_mask, 0xF, 0x3 }, // 151
  { Intrinsic::riscv_vfncvt_f_x_w, 0xF, 0x2 }, // 152
  { Intrinsic::riscv_vfncvt_f_x_w_mask, 0xF, 0x3 }, // 153
  { Intrinsic::riscv_vfncvt_f_xu_w, 0xF, 0x2 }, // 154
  { Intrinsic::riscv_vfncvt_f_xu_w_mask, 0xF, 0x3 }, // 155
  { Intrinsic::riscv_vfncvt_rod_f_f_w, 0xF, 0x2 }, // 156
  { Intrinsic::riscv_vfncvt_rod_f_f_w_mask, 0xF, 0x3 }, // 157
  { Intrinsic::riscv_vfncvt_rtz_x_f_w, 0xF, 0x2 }, // 158
  { Intrinsic::riscv_vfncvt_rtz_x_f_w_mask, 0xF, 0x3 }, // 159
  { Intrinsic::riscv_vfncvt_rtz_xu_f_w, 0xF, 0x2 }, // 160
  { Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask, 0xF, 0x3 }, // 161
  { Intrinsic::riscv_vfncvt_x_f_w, 0xF, 0x2 }, // 162
  { Intrinsic::riscv_vfncvt_x_f_w_mask, 0xF, 0x3 }, // 163
  { Intrinsic::riscv_vfncvt_xu_f_w, 0xF, 0x2 }, // 164
  { Intrinsic::riscv_vfncvt_xu_f_w_mask, 0xF, 0x3 }, // 165
  { Intrinsic::riscv_vfnmacc, 0x1, 0x3 }, // 166
  { Intrinsic::riscv_vfnmacc_mask, 0x1, 0x4 }, // 167
  { Intrinsic::riscv_vfnmadd, 0x1, 0x3 }, // 168
  { Intrinsic::riscv_vfnmadd_mask, 0x1, 0x4 }, // 169
  { Intrinsic::riscv_vfnmsac, 0x1, 0x3 }, // 170
  { Intrinsic::riscv_vfnmsac_mask, 0x1, 0x4 }, // 171
  { Intrinsic::riscv_vfnmsub, 0x1, 0x3 }, // 172
  { Intrinsic::riscv_vfnmsub_mask, 0x1, 0x4 }, // 173
  { Intrinsic::riscv_vfrdiv, 0x2, 0x3 }, // 174
  { Intrinsic::riscv_vfrdiv_mask, 0x2, 0x4 }, // 175
  { Intrinsic::riscv_vfrec7, 0xF, 0x2 }, // 176
  { Intrinsic::riscv_vfrec7_mask, 0xF, 0x3 }, // 177
  { Intrinsic::riscv_vfredmax, 0xF, 0x3 }, // 178
  { Intrinsic::riscv_vfredmax_mask, 0xF, 0x4 }, // 179
  { Intrinsic::riscv_vfredmin, 0xF, 0x3 }, // 180
  { Intrinsic::riscv_vfredmin_mask, 0xF, 0x4 }, // 181
  { Intrinsic::riscv_vfredosum, 0xF, 0x3 }, // 182
  { Intrinsic::riscv_vfredosum_mask, 0xF, 0x4 }, // 183
  { Intrinsic::riscv_vfredusum, 0xF, 0x3 }, // 184
  { Intrinsic::riscv_vfredusum_mask, 0xF, 0x4 }, // 185
  { Intrinsic::riscv_vfrsqrt7, 0xF, 0x2 }, // 186
  { Intrinsic::riscv_vfrsqrt7_mask, 0xF, 0x3 }, // 187
  { Intrinsic::riscv_vfrsub, 0x2, 0x3 }, // 188
  { Intrinsic::riscv_vfrsub_mask, 0x2, 0x4 }, // 189
  { Intrinsic::riscv_vfsgnj, 0x2, 0x3 }, // 190
  { Intrinsic::riscv_vfsgnj_mask, 0x2, 0x4 }, // 191
  { Intrinsic::riscv_vfsgnjn, 0x2, 0x3 }, // 192
  { Intrinsic::riscv_vfsgnjn_mask, 0x2, 0x4 }, // 193
  { Intrinsic::riscv_vfsgnjx, 0x2, 0x3 }, // 194
  { Intrinsic::riscv_vfsgnjx_mask, 0x2, 0x4 }, // 195
  { Intrinsic::riscv_vfslide1down, 0x2, 0x3 }, // 196
  { Intrinsic::riscv_vfslide1down_mask, 0x2, 0x4 }, // 197
  { Intrinsic::riscv_vfslide1up, 0x2, 0x3 }, // 198
  { Intrinsic::riscv_vfslide1up_mask, 0x2, 0x4 }, // 199
  { Intrinsic::riscv_vfsqrt, 0xF, 0x2 }, // 200
  { Intrinsic::riscv_vfsqrt_mask, 0xF, 0x3 }, // 201
  { Intrinsic::riscv_vfsub, 0x2, 0x3 }, // 202
  { Intrinsic::riscv_vfsub_mask, 0x2, 0x4 }, // 203
  { Intrinsic::riscv_vfwadd, 0x2, 0x3 }, // 204
  { Intrinsic::riscv_vfwadd_mask, 0x2, 0x4 }, // 205
  { Intrinsic::riscv_vfwadd_w, 0x2, 0x3 }, // 206
  { Intrinsic::riscv_vfwadd_w_mask, 0x2, 0x4 }, // 207
  { Intrinsic::riscv_vfwcvt_f_f_v, 0xF, 0x2 }, // 208
  { Intrinsic::riscv_vfwcvt_f_f_v_mask, 0xF, 0x3 }, // 209
  { Intrinsic::riscv_vfwcvt_f_x_v, 0xF, 0x2 }, // 210
  { Intrinsic::riscv_vfwcvt_f_x_v_mask, 0xF, 0x3 }, // 211
  { Intrinsic::riscv_vfwcvt_f_xu_v, 0xF, 0x2 }, // 212
  { Intrinsic::riscv_vfwcvt_f_xu_v_mask, 0xF, 0x3 }, // 213
  { Intrinsic::riscv_vfwcvt_rtz_x_f_v, 0xF, 0x2 }, // 214
  { Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask, 0xF, 0x3 }, // 215
  { Intrinsic::riscv_vfwcvt_rtz_xu_f_v, 0xF, 0x2 }, // 216
  { Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask, 0xF, 0x3 }, // 217
  { Intrinsic::riscv_vfwcvt_x_f_v, 0xF, 0x2 }, // 218
  { Intrinsic::riscv_vfwcvt_x_f_v_mask, 0xF, 0x3 }, // 219
  { Intrinsic::riscv_vfwcvt_xu_f_v, 0xF, 0x2 }, // 220
  { Intrinsic::riscv_vfwcvt_xu_f_v_mask, 0xF, 0x3 }, // 221
  { Intrinsic::riscv_vfwmacc, 0x1, 0x3 }, // 222
  { Intrinsic::riscv_vfwmacc_mask, 0x1, 0x4 }, // 223
  { Intrinsic::riscv_vfwmsac, 0x1, 0x3 }, // 224
  { Intrinsic::riscv_vfwmsac_mask, 0x1, 0x4 }, // 225
  { Intrinsic::riscv_vfwmul, 0x2, 0x3 }, // 226
  { Intrinsic::riscv_vfwmul_mask, 0x2, 0x4 }, // 227
  { Intrinsic::riscv_vfwnmacc, 0x1, 0x3 }, // 228
  { Intrinsic::riscv_vfwnmacc_mask, 0x1, 0x4 }, // 229
  { Intrinsic::riscv_vfwnmsac, 0x1, 0x3 }, // 230
  { Intrinsic::riscv_vfwnmsac_mask, 0x1, 0x4 }, // 231
  { Intrinsic::riscv_vfwredosum, 0xF, 0x3 }, // 232
  { Intrinsic::riscv_vfwredosum_mask, 0xF, 0x4 }, // 233
  { Intrinsic::riscv_vfwredusum, 0xF, 0x3 }, // 234
  { Intrinsic::riscv_vfwredusum_mask, 0xF, 0x4 }, // 235
  { Intrinsic::riscv_vfwsub, 0x2, 0x3 }, // 236
  { Intrinsic::riscv_vfwsub_mask, 0x2, 0x4 }, // 237
  { Intrinsic::riscv_vfwsub_w, 0x2, 0x3 }, // 238
  { Intrinsic::riscv_vfwsub_w_mask, 0x2, 0x4 }, // 239
  { Intrinsic::riscv_vid, 0xF, 0x1 }, // 240
  { Intrinsic::riscv_vid_mask, 0xF, 0x2 }, // 241
  { Intrinsic::riscv_viota, 0xF, 0x2 }, // 242
  { Intrinsic::riscv_viota_mask, 0xF, 0x3 }, // 243
  { Intrinsic::riscv_vle, 0xF, 0x2 }, // 244
  { Intrinsic::riscv_vle_mask, 0xF, 0x3 }, // 245
  { Intrinsic::riscv_vleff, 0xF, 0x2 }, // 246
  { Intrinsic::riscv_vleff_mask, 0xF, 0x3 }, // 247
  { Intrinsic::riscv_vlm, 0xF, 0x1 }, // 248
  { Intrinsic::riscv_vloxei, 0xF, 0x3 }, // 249
  { Intrinsic::riscv_vloxei_mask, 0xF, 0x4 }, // 250
  { Intrinsic::riscv_vloxseg2, 0xF, 0x4 }, // 251
  { Intrinsic::riscv_vloxseg2_mask, 0xF, 0x5 }, // 252
  { Intrinsic::riscv_vloxseg3, 0xF, 0x5 }, // 253
  { Intrinsic::riscv_vloxseg3_mask, 0xF, 0x6 }, // 254
  { Intrinsic::riscv_vloxseg4, 0xF, 0x6 }, // 255
  { Intrinsic::riscv_vloxseg4_mask, 0xF, 0x7 }, // 256
  { Intrinsic::riscv_vloxseg5, 0xF, 0x7 }, // 257
  { Intrinsic::riscv_vloxseg5_mask, 0xF, 0x8 }, // 258
  { Intrinsic::riscv_vloxseg6, 0xF, 0x8 }, // 259
  { Intrinsic::riscv_vloxseg6_mask, 0xF, 0x9 }, // 260
  { Intrinsic::riscv_vloxseg7, 0xF, 0x9 }, // 261
  { Intrinsic::riscv_vloxseg7_mask, 0xF, 0xA }, // 262
  { Intrinsic::riscv_vloxseg8, 0xF, 0xA }, // 263
  { Intrinsic::riscv_vloxseg8_mask, 0xF, 0xB }, // 264
  { Intrinsic::riscv_vlse, 0xF, 0x3 }, // 265
  { Intrinsic::riscv_vlse_mask, 0xF, 0x4 }, // 266
  { Intrinsic::riscv_vlseg2, 0xF, 0x3 }, // 267
  { Intrinsic::riscv_vlseg2_mask, 0xF, 0x4 }, // 268
  { Intrinsic::riscv_vlseg2ff, 0xF, 0x3 }, // 269
  { Intrinsic::riscv_vlseg2ff_mask, 0xF, 0x4 }, // 270
  { Intrinsic::riscv_vlseg3, 0xF, 0x4 }, // 271
  { Intrinsic::riscv_vlseg3_mask, 0xF, 0x5 }, // 272
  { Intrinsic::riscv_vlseg3ff, 0xF, 0x4 }, // 273
  { Intrinsic::riscv_vlseg3ff_mask, 0xF, 0x5 }, // 274
  { Intrinsic::riscv_vlseg4, 0xF, 0x5 }, // 275
  { Intrinsic::riscv_vlseg4_mask, 0xF, 0x6 }, // 276
  { Intrinsic::riscv_vlseg4ff, 0xF, 0x5 }, // 277
  { Intrinsic::riscv_vlseg4ff_mask, 0xF, 0x6 }, // 278
  { Intrinsic::riscv_vlseg5, 0xF, 0x6 }, // 279
  { Intrinsic::riscv_vlseg5_mask, 0xF, 0x7 }, // 280
  { Intrinsic::riscv_vlseg5ff, 0xF, 0x6 }, // 281
  { Intrinsic::riscv_vlseg5ff_mask, 0xF, 0x7 }, // 282
  { Intrinsic::riscv_vlseg6, 0xF, 0x7 }, // 283
  { Intrinsic::riscv_vlseg6_mask, 0xF, 0x8 }, // 284
  { Intrinsic::riscv_vlseg6ff, 0xF, 0x7 }, // 285
  { Intrinsic::riscv_vlseg6ff_mask, 0xF, 0x8 }, // 286
  { Intrinsic::riscv_vlseg7, 0xF, 0x8 }, // 287
  { Intrinsic::riscv_vlseg7_mask, 0xF, 0x9 }, // 288
  { Intrinsic::riscv_vlseg7ff, 0xF, 0x8 }, // 289
  { Intrinsic::riscv_vlseg7ff_mask, 0xF, 0x9 }, // 290
  { Intrinsic::riscv_vlseg8, 0xF, 0x9 }, // 291
  { Intrinsic::riscv_vlseg8_mask, 0xF, 0xA }, // 292
  { Intrinsic::riscv_vlseg8ff, 0xF, 0x9 }, // 293
  { Intrinsic::riscv_vlseg8ff_mask, 0xF, 0xA }, // 294
  { Intrinsic::riscv_vlsseg2, 0xF, 0x4 }, // 295
  { Intrinsic::riscv_vlsseg2_mask, 0xF, 0x5 }, // 296
  { Intrinsic::riscv_vlsseg3, 0xF, 0x5 }, // 297
  { Intrinsic::riscv_vlsseg3_mask, 0xF, 0x6 }, // 298
  { Intrinsic::riscv_vlsseg4, 0xF, 0x6 }, // 299
  { Intrinsic::riscv_vlsseg4_mask, 0xF, 0x7 }, // 300
  { Intrinsic::riscv_vlsseg5, 0xF, 0x7 }, // 301
  { Intrinsic::riscv_vlsseg5_mask, 0xF, 0x8 }, // 302
  { Intrinsic::riscv_vlsseg6, 0xF, 0x8 }, // 303
  { Intrinsic::riscv_vlsseg6_mask, 0xF, 0x9 }, // 304
  { Intrinsic::riscv_vlsseg7, 0xF, 0x9 }, // 305
  { Intrinsic::riscv_vlsseg7_mask, 0xF, 0xA }, // 306
  { Intrinsic::riscv_vlsseg8, 0xF, 0xA }, // 307
  { Intrinsic::riscv_vlsseg8_mask, 0xF, 0xB }, // 308
  { Intrinsic::riscv_vluxei, 0xF, 0x3 }, // 309
  { Intrinsic::riscv_vluxei_mask, 0xF, 0x4 }, // 310
  { Intrinsic::riscv_vluxseg2, 0xF, 0x4 }, // 311
  { Intrinsic::riscv_vluxseg2_mask, 0xF, 0x5 }, // 312
  { Intrinsic::riscv_vluxseg3, 0xF, 0x5 }, // 313
  { Intrinsic::riscv_vluxseg3_mask, 0xF, 0x6 }, // 314
  { Intrinsic::riscv_vluxseg4, 0xF, 0x6 }, // 315
  { Intrinsic::riscv_vluxseg4_mask, 0xF, 0x7 }, // 316
  { Intrinsic::riscv_vluxseg5, 0xF, 0x7 }, // 317
  { Intrinsic::riscv_vluxseg5_mask, 0xF, 0x8 }, // 318
  { Intrinsic::riscv_vluxseg6, 0xF, 0x8 }, // 319
  { Intrinsic::riscv_vluxseg6_mask, 0xF, 0x9 }, // 320
  { Intrinsic::riscv_vluxseg7, 0xF, 0x9 }, // 321
  { Intrinsic::riscv_vluxseg7_mask, 0xF, 0xA }, // 322
  { Intrinsic::riscv_vluxseg8, 0xF, 0xA }, // 323
  { Intrinsic::riscv_vluxseg8_mask, 0xF, 0xB }, // 324
  { Intrinsic::riscv_vmacc, 0x1, 0x3 }, // 325
  { Intrinsic::riscv_vmacc_mask, 0x1, 0x4 }, // 326
  { Intrinsic::riscv_vmadc, 0x1, 0x2 }, // 327
  { Intrinsic::riscv_vmadc_carry_in, 0x1, 0x3 }, // 328
  { Intrinsic::riscv_vmadd, 0x1, 0x3 }, // 329
  { Intrinsic::riscv_vmadd_mask, 0x1, 0x4 }, // 330
  { Intrinsic::riscv_vmand, 0xF, 0x2 }, // 331
  { Intrinsic::riscv_vmandn, 0xF, 0x2 }, // 332
  { Intrinsic::riscv_vmax, 0x2, 0x3 }, // 333
  { Intrinsic::riscv_vmax_mask, 0x2, 0x4 }, // 334
  { Intrinsic::riscv_vmaxu, 0x2, 0x3 }, // 335
  { Intrinsic::riscv_vmaxu_mask, 0x2, 0x4 }, // 336
  { Intrinsic::riscv_vmclr, 0xF, 0x1 }, // 337
  { Intrinsic::riscv_vmerge, 0x2, 0x4 }, // 338
  { Intrinsic::riscv_vmfeq, 0x1, 0x2 }, // 339
  { Intrinsic::riscv_vmfeq_mask, 0x2, 0x4 }, // 340
  { Intrinsic::riscv_vmfge, 0x1, 0x2 }, // 341
  { Intrinsic::riscv_vmfge_mask, 0x2, 0x4 }, // 342
  { Intrinsic::riscv_vmfgt, 0x1, 0x2 }, // 343
  { Intrinsic::riscv_vmfgt_mask, 0x2, 0x4 }, // 344
  { Intrinsic::riscv_vmfle, 0x1, 0x2 }, // 345
  { Intrinsic::riscv_vmfle_mask, 0x2, 0x4 }, // 346
  { Intrinsic::riscv_vmflt, 0x1, 0x2 }, // 347
  { Intrinsic::riscv_vmflt_mask, 0x2, 0x4 }, // 348
  { Intrinsic::riscv_vmfne, 0x1, 0x2 }, // 349
  { Intrinsic::riscv_vmfne_mask, 0x2, 0x4 }, // 350
  { Intrinsic::riscv_vmin, 0x2, 0x3 }, // 351
  { Intrinsic::riscv_vmin_mask, 0x2, 0x4 }, // 352
  { Intrinsic::riscv_vminu, 0x2, 0x3 }, // 353
  { Intrinsic::riscv_vminu_mask, 0x2, 0x4 }, // 354
  { Intrinsic::riscv_vmnand, 0xF, 0x2 }, // 355
  { Intrinsic::riscv_vmnor, 0xF, 0x2 }, // 356
  { Intrinsic::riscv_vmor, 0xF, 0x2 }, // 357
  { Intrinsic::riscv_vmorn, 0xF, 0x2 }, // 358
  { Intrinsic::riscv_vmsbc, 0x1, 0x2 }, // 359
  { Intrinsic::riscv_vmsbc_borrow_in, 0x1, 0x3 }, // 360
  { Intrinsic::riscv_vmsbf, 0xF, 0x1 }, // 361
  { Intrinsic::riscv_vmsbf_mask, 0xF, 0x3 }, // 362
  { Intrinsic::riscv_vmseq, 0x1, 0x2 }, // 363
  { Intrinsic::riscv_vmseq_mask, 0x2, 0x4 }, // 364
  { Intrinsic::riscv_vmset, 0xF, 0x1 }, // 365
  { Intrinsic::riscv_vmsge, 0x1, 0x2 }, // 366
  { Intrinsic::riscv_vmsge_mask, 0x2, 0x4 }, // 367
  { Intrinsic::riscv_vmsgeu, 0x1, 0x2 }, // 368
  { Intrinsic::riscv_vmsgeu_mask, 0x2, 0x4 }, // 369
  { Intrinsic::riscv_vmsgt, 0x1, 0x2 }, // 370
  { Intrinsic::riscv_vmsgt_mask, 0x2, 0x4 }, // 371
  { Intrinsic::riscv_vmsgtu, 0x1, 0x2 }, // 372
  { Intrinsic::riscv_vmsgtu_mask, 0x2, 0x4 }, // 373
  { Intrinsic::riscv_vmsif, 0xF, 0x1 }, // 374
  { Intrinsic::riscv_vmsif_mask, 0xF, 0x3 }, // 375
  { Intrinsic::riscv_vmsle, 0x1, 0x2 }, // 376
  { Intrinsic::riscv_vmsle_mask, 0x2, 0x4 }, // 377
  { Intrinsic::riscv_vmsleu, 0x1, 0x2 }, // 378
  { Intrinsic::riscv_vmsleu_mask, 0x2, 0x4 }, // 379
  { Intrinsic::riscv_vmslt, 0x1, 0x2 }, // 380
  { Intrinsic::riscv_vmslt_mask, 0x2, 0x4 }, // 381
  { Intrinsic::riscv_vmsltu, 0x1, 0x2 }, // 382
  { Intrinsic::riscv_vmsltu_mask, 0x2, 0x4 }, // 383
  { Intrinsic::riscv_vmsne, 0x1, 0x2 }, // 384
  { Intrinsic::riscv_vmsne_mask, 0x2, 0x4 }, // 385
  { Intrinsic::riscv_vmsof, 0xF, 0x1 }, // 386
  { Intrinsic::riscv_vmsof_mask, 0xF, 0x3 }, // 387
  { Intrinsic::riscv_vmul, 0x2, 0x3 }, // 388
  { Intrinsic::riscv_vmul_mask, 0x2, 0x4 }, // 389
  { Intrinsic::riscv_vmulh, 0x2, 0x3 }, // 390
  { Intrinsic::riscv_vmulh_mask, 0x2, 0x4 }, // 391
  { Intrinsic::riscv_vmulhsu, 0x2, 0x3 }, // 392
  { Intrinsic::riscv_vmulhsu_mask, 0x2, 0x4 }, // 393
  { Intrinsic::riscv_vmulhu, 0x2, 0x3 }, // 394
  { Intrinsic::riscv_vmulhu_mask, 0x2, 0x4 }, // 395
  { Intrinsic::riscv_vmv_s_x, 0xF, 0x2 }, // 396
  { Intrinsic::riscv_vmv_v_v, 0xF, 0x2 }, // 397
  { Intrinsic::riscv_vmv_v_x, 0xF, 0x2 }, // 398
  { Intrinsic::riscv_vmv_x_s, 0xF, 0x1F }, // 399
  { Intrinsic::riscv_vmxnor, 0xF, 0x2 }, // 400
  { Intrinsic::riscv_vmxor, 0xF, 0x2 }, // 401
  { Intrinsic::riscv_vnclip, 0xF, 0x3 }, // 402
  { Intrinsic::riscv_vnclip_mask, 0xF, 0x4 }, // 403
  { Intrinsic::riscv_vnclipu, 0xF, 0x3 }, // 404
  { Intrinsic::riscv_vnclipu_mask, 0xF, 0x4 }, // 405
  { Intrinsic::riscv_vnmsac, 0x1, 0x3 }, // 406
  { Intrinsic::riscv_vnmsac_mask, 0x1, 0x4 }, // 407
  { Intrinsic::riscv_vnmsub, 0x1, 0x3 }, // 408
  { Intrinsic::riscv_vnmsub_mask, 0x1, 0x4 }, // 409
  { Intrinsic::riscv_vnsra, 0xF, 0x3 }, // 410
  { Intrinsic::riscv_vnsra_mask, 0xF, 0x4 }, // 411
  { Intrinsic::riscv_vnsrl, 0xF, 0x3 }, // 412
  { Intrinsic::riscv_vnsrl_mask, 0xF, 0x4 }, // 413
  { Intrinsic::riscv_vor, 0x2, 0x3 }, // 414
  { Intrinsic::riscv_vor_mask, 0x2, 0x4 }, // 415
  { Intrinsic::riscv_vredand, 0xF, 0x3 }, // 416
  { Intrinsic::riscv_vredand_mask, 0xF, 0x4 }, // 417
  { Intrinsic::riscv_vredmax, 0xF, 0x3 }, // 418
  { Intrinsic::riscv_vredmax_mask, 0xF, 0x4 }, // 419
  { Intrinsic::riscv_vredmaxu, 0xF, 0x3 }, // 420
  { Intrinsic::riscv_vredmaxu_mask, 0xF, 0x4 }, // 421
  { Intrinsic::riscv_vredmin, 0xF, 0x3 }, // 422
  { Intrinsic::riscv_vredmin_mask, 0xF, 0x4 }, // 423
  { Intrinsic::riscv_vredminu, 0xF, 0x3 }, // 424
  { Intrinsic::riscv_vredminu_mask, 0xF, 0x4 }, // 425
  { Intrinsic::riscv_vredor, 0xF, 0x3 }, // 426
  { Intrinsic::riscv_vredor_mask, 0xF, 0x4 }, // 427
  { Intrinsic::riscv_vredsum, 0xF, 0x3 }, // 428
  { Intrinsic::riscv_vredsum_mask, 0xF, 0x4 }, // 429
  { Intrinsic::riscv_vredxor, 0xF, 0x3 }, // 430
  { Intrinsic::riscv_vredxor_mask, 0xF, 0x4 }, // 431
  { Intrinsic::riscv_vrem, 0x2, 0x3 }, // 432
  { Intrinsic::riscv_vrem_mask, 0x2, 0x4 }, // 433
  { Intrinsic::riscv_vremu, 0x2, 0x3 }, // 434
  { Intrinsic::riscv_vremu_mask, 0x2, 0x4 }, // 435
  { Intrinsic::riscv_vrgather_vv, 0xF, 0x3 }, // 436
  { Intrinsic::riscv_vrgather_vv_mask, 0xF, 0x4 }, // 437
  { Intrinsic::riscv_vrgather_vx, 0xF, 0x3 }, // 438
  { Intrinsic::riscv_vrgather_vx_mask, 0xF, 0x4 }, // 439
  { Intrinsic::riscv_vrgatherei16_vv, 0xF, 0x3 }, // 440
  { Intrinsic::riscv_vrgatherei16_vv_mask, 0xF, 0x4 }, // 441
  { Intrinsic::riscv_vrsub, 0x2, 0x3 }, // 442
  { Intrinsic::riscv_vrsub_mask, 0x2, 0x4 }, // 443
  { Intrinsic::riscv_vsadd, 0x2, 0x3 }, // 444
  { Intrinsic::riscv_vsadd_mask, 0x2, 0x4 }, // 445
  { Intrinsic::riscv_vsaddu, 0x2, 0x3 }, // 446
  { Intrinsic::riscv_vsaddu_mask, 0x2, 0x4 }, // 447
  { Intrinsic::riscv_vsbc, 0x2, 0x4 }, // 448
  { Intrinsic::riscv_vse, 0xF, 0x2 }, // 449
  { Intrinsic::riscv_vse_mask, 0xF, 0x3 }, // 450
  { Intrinsic::riscv_vsext, 0xF, 0x2 }, // 451
  { Intrinsic::riscv_vsext_mask, 0xF, 0x3 }, // 452
  { Intrinsic::riscv_vslide1down, 0x2, 0x3 }, // 453
  { Intrinsic::riscv_vslide1down_mask, 0x2, 0x4 }, // 454
  { Intrinsic::riscv_vslide1up, 0x2, 0x3 }, // 455
  { Intrinsic::riscv_vslide1up_mask, 0x2, 0x4 }, // 456
  { Intrinsic::riscv_vslidedown, 0xF, 0x3 }, // 457
  { Intrinsic::riscv_vslidedown_mask, 0xF, 0x4 }, // 458
  { Intrinsic::riscv_vslideup, 0xF, 0x3 }, // 459
  { Intrinsic::riscv_vslideup_mask, 0xF, 0x4 }, // 460
  { Intrinsic::riscv_vsll, 0xF, 0x3 }, // 461
  { Intrinsic::riscv_vsll_mask, 0xF, 0x4 }, // 462
  { Intrinsic::riscv_vsm, 0xF, 0x2 }, // 463
  { Intrinsic::riscv_vsmul, 0x2, 0x3 }, // 464
  { Intrinsic::riscv_vsmul_mask, 0x2, 0x4 }, // 465
  { Intrinsic::riscv_vsoxei, 0xF, 0x3 }, // 466
  { Intrinsic::riscv_vsoxei_mask, 0xF, 0x4 }, // 467
  { Intrinsic::riscv_vsoxseg2, 0xF, 0x4 }, // 468
  { Intrinsic::riscv_vsoxseg2_mask, 0xF, 0x5 }, // 469
  { Intrinsic::riscv_vsoxseg3, 0xF, 0x5 }, // 470
  { Intrinsic::riscv_vsoxseg3_mask, 0xF, 0x6 }, // 471
  { Intrinsic::riscv_vsoxseg4, 0xF, 0x6 }, // 472
  { Intrinsic::riscv_vsoxseg4_mask, 0xF, 0x7 }, // 473
  { Intrinsic::riscv_vsoxseg5, 0xF, 0x7 }, // 474
  { Intrinsic::riscv_vsoxseg5_mask, 0xF, 0x8 }, // 475
  { Intrinsic::riscv_vsoxseg6, 0xF, 0x8 }, // 476
  { Intrinsic::riscv_vsoxseg6_mask, 0xF, 0x9 }, // 477
  { Intrinsic::riscv_vsoxseg7, 0xF, 0x9 }, // 478
  { Intrinsic::riscv_vsoxseg7_mask, 0xF, 0xA }, // 479
  { Intrinsic::riscv_vsoxseg8, 0xF, 0xA }, // 480
  { Intrinsic::riscv_vsoxseg8_mask, 0xF, 0xB }, // 481
  { Intrinsic::riscv_vsra, 0xF, 0x3 }, // 482
  { Intrinsic::riscv_vsra_mask, 0xF, 0x4 }, // 483
  { Intrinsic::riscv_vsrl, 0xF, 0x3 }, // 484
  { Intrinsic::riscv_vsrl_mask, 0xF, 0x4 }, // 485
  { Intrinsic::riscv_vsse, 0xF, 0x3 }, // 486
  { Intrinsic::riscv_vsse_mask, 0xF, 0x4 }, // 487
  { Intrinsic::riscv_vsseg2, 0xF, 0x3 }, // 488
  { Intrinsic::riscv_vsseg2_mask, 0xF, 0x4 }, // 489
  { Intrinsic::riscv_vsseg3, 0xF, 0x4 }, // 490
  { Intrinsic::riscv_vsseg3_mask, 0xF, 0x5 }, // 491
  { Intrinsic::riscv_vsseg4, 0xF, 0x5 }, // 492
  { Intrinsic::riscv_vsseg4_mask, 0xF, 0x6 }, // 493
  { Intrinsic::riscv_vsseg5, 0xF, 0x6 }, // 494
  { Intrinsic::riscv_vsseg5_mask, 0xF, 0x7 }, // 495
  { Intrinsic::riscv_vsseg6, 0xF, 0x7 }, // 496
  { Intrinsic::riscv_vsseg6_mask, 0xF, 0x8 }, // 497
  { Intrinsic::riscv_vsseg7, 0xF, 0x8 }, // 498
  { Intrinsic::riscv_vsseg7_mask, 0xF, 0x9 }, // 499
  { Intrinsic::riscv_vsseg8, 0xF, 0x9 }, // 500
  { Intrinsic::riscv_vsseg8_mask, 0xF, 0xA }, // 501
  { Intrinsic::riscv_vssra, 0xF, 0x3 }, // 502
  { Intrinsic::riscv_vssra_mask, 0xF, 0x4 }, // 503
  { Intrinsic::riscv_vssrl, 0xF, 0x3 }, // 504
  { Intrinsic::riscv_vssrl_mask, 0xF, 0x4 }, // 505
  { Intrinsic::riscv_vssseg2, 0xF, 0x4 }, // 506
  { Intrinsic::riscv_vssseg2_mask, 0xF, 0x5 }, // 507
  { Intrinsic::riscv_vssseg3, 0xF, 0x5 }, // 508
  { Intrinsic::riscv_vssseg3_mask, 0xF, 0x6 }, // 509
  { Intrinsic::riscv_vssseg4, 0xF, 0x6 }, // 510
  { Intrinsic::riscv_vssseg4_mask, 0xF, 0x7 }, // 511
  { Intrinsic::riscv_vssseg5, 0xF, 0x7 }, // 512
  { Intrinsic::riscv_vssseg5_mask, 0xF, 0x8 }, // 513
  { Intrinsic::riscv_vssseg6, 0xF, 0x8 }, // 514
  { Intrinsic::riscv_vssseg6_mask, 0xF, 0x9 }, // 515
  { Intrinsic::riscv_vssseg7, 0xF, 0x9 }, // 516
  { Intrinsic::riscv_vssseg7_mask, 0xF, 0xA }, // 517
  { Intrinsic::riscv_vssseg8, 0xF, 0xA }, // 518
  { Intrinsic::riscv_vssseg8_mask, 0xF, 0xB }, // 519
  { Intrinsic::riscv_vssub, 0x2, 0x3 }, // 520
  { Intrinsic::riscv_vssub_mask, 0x2, 0x4 }, // 521
  { Intrinsic::riscv_vssubu, 0x2, 0x3 }, // 522
  { Intrinsic::riscv_vssubu_mask, 0x2, 0x4 }, // 523
  { Intrinsic::riscv_vsub, 0x2, 0x3 }, // 524
  { Intrinsic::riscv_vsub_mask, 0x2, 0x4 }, // 525
  { Intrinsic::riscv_vsuxei, 0xF, 0x3 }, // 526
  { Intrinsic::riscv_vsuxei_mask, 0xF, 0x4 }, // 527
  { Intrinsic::riscv_vsuxseg2, 0xF, 0x4 }, // 528
  { Intrinsic::riscv_vsuxseg2_mask, 0xF, 0x5 }, // 529
  { Intrinsic::riscv_vsuxseg3, 0xF, 0x5 }, // 530
  { Intrinsic::riscv_vsuxseg3_mask, 0xF, 0x6 }, // 531
  { Intrinsic::riscv_vsuxseg4, 0xF, 0x6 }, // 532
  { Intrinsic::riscv_vsuxseg4_mask, 0xF, 0x7 }, // 533
  { Intrinsic::riscv_vsuxseg5, 0xF, 0x7 }, // 534
  { Intrinsic::riscv_vsuxseg5_mask, 0xF, 0x8 }, // 535
  { Intrinsic::riscv_vsuxseg6, 0xF, 0x8 }, // 536
  { Intrinsic::riscv_vsuxseg6_mask, 0xF, 0x9 }, // 537
  { Intrinsic::riscv_vsuxseg7, 0xF, 0x9 }, // 538
  { Intrinsic::riscv_vsuxseg7_mask, 0xF, 0xA }, // 539
  { Intrinsic::riscv_vsuxseg8, 0xF, 0xA }, // 540
  { Intrinsic::riscv_vsuxseg8_mask, 0xF, 0xB }, // 541
  { Intrinsic::riscv_vwadd, 0x2, 0x3 }, // 542
  { Intrinsic::riscv_vwadd_mask, 0x2, 0x4 }, // 543
  { Intrinsic::riscv_vwadd_w, 0x2, 0x3 }, // 544
  { Intrinsic::riscv_vwadd_w_mask, 0x2, 0x4 }, // 545
  { Intrinsic::riscv_vwaddu, 0x2, 0x3 }, // 546
  { Intrinsic::riscv_vwaddu_mask, 0x2, 0x4 }, // 547
  { Intrinsic::riscv_vwaddu_w, 0x2, 0x3 }, // 548
  { Intrinsic::riscv_vwaddu_w_mask, 0x2, 0x4 }, // 549
  { Intrinsic::riscv_vwmacc, 0x1, 0x3 }, // 550
  { Intrinsic::riscv_vwmacc_mask, 0x1, 0x4 }, // 551
  { Intrinsic::riscv_vwmaccsu, 0x1, 0x3 }, // 552
  { Intrinsic::riscv_vwmaccsu_mask, 0x1, 0x4 }, // 553
  { Intrinsic::riscv_vwmaccu, 0x1, 0x3 }, // 554
  { Intrinsic::riscv_vwmaccu_mask, 0x1, 0x4 }, // 555
  { Intrinsic::riscv_vwmaccus, 0x1, 0x3 }, // 556
  { Intrinsic::riscv_vwmaccus_mask, 0x1, 0x4 }, // 557
  { Intrinsic::riscv_vwmul, 0x2, 0x3 }, // 558
  { Intrinsic::riscv_vwmul_mask, 0x2, 0x4 }, // 559
  { Intrinsic::riscv_vwmulsu, 0x2, 0x3 }, // 560
  { Intrinsic::riscv_vwmulsu_mask, 0x2, 0x4 }, // 561
  { Intrinsic::riscv_vwmulu, 0x2, 0x3 }, // 562
  { Intrinsic::riscv_vwmulu_mask, 0x2, 0x4 }, // 563
  { Intrinsic::riscv_vwredsum, 0xF, 0x3 }, // 564
  { Intrinsic::riscv_vwredsum_mask, 0xF, 0x4 }, // 565
  { Intrinsic::riscv_vwredsumu, 0xF, 0x3 }, // 566
  { Intrinsic::riscv_vwredsumu_mask, 0xF, 0x4 }, // 567
  { Intrinsic::riscv_vwsub, 0x2, 0x3 }, // 568
  { Intrinsic::riscv_vwsub_mask, 0x2, 0x4 }, // 569
  { Intrinsic::riscv_vwsub_w, 0x2, 0x3 }, // 570
  { Intrinsic::riscv_vwsub_w_mask, 0x2, 0x4 }, // 571
  { Intrinsic::riscv_vwsubu, 0x2, 0x3 }, // 572
  { Intrinsic::riscv_vwsubu_mask, 0x2, 0x4 }, // 573
  { Intrinsic::riscv_vwsubu_w, 0x2, 0x3 }, // 574
  { Intrinsic::riscv_vwsubu_w_mask, 0x2, 0x4 }, // 575
  { Intrinsic::riscv_vxor, 0x2, 0x3 }, // 576
  { Intrinsic::riscv_vxor_mask, 0x2, 0x4 }, // 577
  { Intrinsic::riscv_vzext, 0xF, 0x2 }, // 578
  { Intrinsic::riscv_vzext_mask, 0xF, 0x3 }, // 579
 };

const RISCVVIntrinsicInfo *getRISCVVIntrinsicInfo(unsigned IntrinsicID) {
  struct KeyType {
    unsigned IntrinsicID;
  };
  KeyType Key = {IntrinsicID};
  auto Table = ArrayRef(RISCVVIntrinsicsTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const RISCVVIntrinsicInfo &LHS, const KeyType &RHS) {
      if (LHS.IntrinsicID < RHS.IntrinsicID)
        return true;
      if (LHS.IntrinsicID > RHS.IntrinsicID)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.IntrinsicID != Idx->IntrinsicID)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVInversePseudosTable_DECL
const PseudoInfo *getBaseInfo(unsigned BaseInstr, uint8_t VLMul);
#endif

#ifdef GET_RISCVVInversePseudosTable_IMPL
constexpr PseudoInfo RISCVVInversePseudosTable[] = {
  { PseudoTHVdotVMAQASU_VV_M1, THVdotVMAQASU_VV, 0x0 }, // 0
  { PseudoTHVdotVMAQASU_VV_M1_MASK, THVdotVMAQASU_VV, 0x0 }, // 1
  { PseudoTHVdotVMAQASU_VV_M2, THVdotVMAQASU_VV, 0x1 }, // 2
  { PseudoTHVdotVMAQASU_VV_M2_MASK, THVdotVMAQASU_VV, 0x1 }, // 3
  { PseudoTHVdotVMAQASU_VV_M4, THVdotVMAQASU_VV, 0x2 }, // 4
  { PseudoTHVdotVMAQASU_VV_M4_MASK, THVdotVMAQASU_VV, 0x2 }, // 5
  { PseudoTHVdotVMAQASU_VV_M8, THVdotVMAQASU_VV, 0x3 }, // 6
  { PseudoTHVdotVMAQASU_VV_M8_MASK, THVdotVMAQASU_VV, 0x3 }, // 7
  { PseudoTHVdotVMAQASU_VV_MF2, THVdotVMAQASU_VV, 0x7 }, // 8
  { PseudoTHVdotVMAQASU_VV_MF2_MASK, THVdotVMAQASU_VV, 0x7 }, // 9
  { PseudoTHVdotVMAQASU_VX_M1, THVdotVMAQASU_VX, 0x0 }, // 10
  { PseudoTHVdotVMAQASU_VX_M1_MASK, THVdotVMAQASU_VX, 0x0 }, // 11
  { PseudoTHVdotVMAQASU_VX_M2, THVdotVMAQASU_VX, 0x1 }, // 12
  { PseudoTHVdotVMAQASU_VX_M2_MASK, THVdotVMAQASU_VX, 0x1 }, // 13
  { PseudoTHVdotVMAQASU_VX_M4, THVdotVMAQASU_VX, 0x2 }, // 14
  { PseudoTHVdotVMAQASU_VX_M4_MASK, THVdotVMAQASU_VX, 0x2 }, // 15
  { PseudoTHVdotVMAQASU_VX_M8, THVdotVMAQASU_VX, 0x3 }, // 16
  { PseudoTHVdotVMAQASU_VX_M8_MASK, THVdotVMAQASU_VX, 0x3 }, // 17
  { PseudoTHVdotVMAQASU_VX_MF2, THVdotVMAQASU_VX, 0x7 }, // 18
  { PseudoTHVdotVMAQASU_VX_MF2_MASK, THVdotVMAQASU_VX, 0x7 }, // 19
  { PseudoTHVdotVMAQAUS_VX_M1, THVdotVMAQAUS_VX, 0x0 }, // 20
  { PseudoTHVdotVMAQAUS_VX_M1_MASK, THVdotVMAQAUS_VX, 0x0 }, // 21
  { PseudoTHVdotVMAQAUS_VX_M2, THVdotVMAQAUS_VX, 0x1 }, // 22
  { PseudoTHVdotVMAQAUS_VX_M2_MASK, THVdotVMAQAUS_VX, 0x1 }, // 23
  { PseudoTHVdotVMAQAUS_VX_M4, THVdotVMAQAUS_VX, 0x2 }, // 24
  { PseudoTHVdotVMAQAUS_VX_M4_MASK, THVdotVMAQAUS_VX, 0x2 }, // 25
  { PseudoTHVdotVMAQAUS_VX_M8, THVdotVMAQAUS_VX, 0x3 }, // 26
  { PseudoTHVdotVMAQAUS_VX_M8_MASK, THVdotVMAQAUS_VX, 0x3 }, // 27
  { PseudoTHVdotVMAQAUS_VX_MF2, THVdotVMAQAUS_VX, 0x7 }, // 28
  { PseudoTHVdotVMAQAUS_VX_MF2_MASK, THVdotVMAQAUS_VX, 0x7 }, // 29
  { PseudoTHVdotVMAQAU_VV_M1, THVdotVMAQAU_VV, 0x0 }, // 30
  { PseudoTHVdotVMAQAU_VV_M1_MASK, THVdotVMAQAU_VV, 0x0 }, // 31
  { PseudoTHVdotVMAQAU_VV_M2, THVdotVMAQAU_VV, 0x1 }, // 32
  { PseudoTHVdotVMAQAU_VV_M2_MASK, THVdotVMAQAU_VV, 0x1 }, // 33
  { PseudoTHVdotVMAQAU_VV_M4, THVdotVMAQAU_VV, 0x2 }, // 34
  { PseudoTHVdotVMAQAU_VV_M4_MASK, THVdotVMAQAU_VV, 0x2 }, // 35
  { PseudoTHVdotVMAQAU_VV_M8, THVdotVMAQAU_VV, 0x3 }, // 36
  { PseudoTHVdotVMAQAU_VV_M8_MASK, THVdotVMAQAU_VV, 0x3 }, // 37
  { PseudoTHVdotVMAQAU_VV_MF2, THVdotVMAQAU_VV, 0x7 }, // 38
  { PseudoTHVdotVMAQAU_VV_MF2_MASK, THVdotVMAQAU_VV, 0x7 }, // 39
  { PseudoTHVdotVMAQAU_VX_M1, THVdotVMAQAU_VX, 0x0 }, // 40
  { PseudoTHVdotVMAQAU_VX_M1_MASK, THVdotVMAQAU_VX, 0x0 }, // 41
  { PseudoTHVdotVMAQAU_VX_M2, THVdotVMAQAU_VX, 0x1 }, // 42
  { PseudoTHVdotVMAQAU_VX_M2_MASK, THVdotVMAQAU_VX, 0x1 }, // 43
  { PseudoTHVdotVMAQAU_VX_M4, THVdotVMAQAU_VX, 0x2 }, // 44
  { PseudoTHVdotVMAQAU_VX_M4_MASK, THVdotVMAQAU_VX, 0x2 }, // 45
  { PseudoTHVdotVMAQAU_VX_M8, THVdotVMAQAU_VX, 0x3 }, // 46
  { PseudoTHVdotVMAQAU_VX_M8_MASK, THVdotVMAQAU_VX, 0x3 }, // 47
  { PseudoTHVdotVMAQAU_VX_MF2, THVdotVMAQAU_VX, 0x7 }, // 48
  { PseudoTHVdotVMAQAU_VX_MF2_MASK, THVdotVMAQAU_VX, 0x7 }, // 49
  { PseudoTHVdotVMAQA_VV_M1, THVdotVMAQA_VV, 0x0 }, // 50
  { PseudoTHVdotVMAQA_VV_M1_MASK, THVdotVMAQA_VV, 0x0 }, // 51
  { PseudoTHVdotVMAQA_VV_M2, THVdotVMAQA_VV, 0x1 }, // 52
  { PseudoTHVdotVMAQA_VV_M2_MASK, THVdotVMAQA_VV, 0x1 }, // 53
  { PseudoTHVdotVMAQA_VV_M4, THVdotVMAQA_VV, 0x2 }, // 54
  { PseudoTHVdotVMAQA_VV_M4_MASK, THVdotVMAQA_VV, 0x2 }, // 55
  { PseudoTHVdotVMAQA_VV_M8, THVdotVMAQA_VV, 0x3 }, // 56
  { PseudoTHVdotVMAQA_VV_M8_MASK, THVdotVMAQA_VV, 0x3 }, // 57
  { PseudoTHVdotVMAQA_VV_MF2, THVdotVMAQA_VV, 0x7 }, // 58
  { PseudoTHVdotVMAQA_VV_MF2_MASK, THVdotVMAQA_VV, 0x7 }, // 59
  { PseudoTHVdotVMAQA_VX_M1, THVdotVMAQA_VX, 0x0 }, // 60
  { PseudoTHVdotVMAQA_VX_M1_MASK, THVdotVMAQA_VX, 0x0 }, // 61
  { PseudoTHVdotVMAQA_VX_M2, THVdotVMAQA_VX, 0x1 }, // 62
  { PseudoTHVdotVMAQA_VX_M2_MASK, THVdotVMAQA_VX, 0x1 }, // 63
  { PseudoTHVdotVMAQA_VX_M4, THVdotVMAQA_VX, 0x2 }, // 64
  { PseudoTHVdotVMAQA_VX_M4_MASK, THVdotVMAQA_VX, 0x2 }, // 65
  { PseudoTHVdotVMAQA_VX_M8, THVdotVMAQA_VX, 0x3 }, // 66
  { PseudoTHVdotVMAQA_VX_M8_MASK, THVdotVMAQA_VX, 0x3 }, // 67
  { PseudoTHVdotVMAQA_VX_MF2, THVdotVMAQA_VX, 0x7 }, // 68
  { PseudoTHVdotVMAQA_VX_MF2_MASK, THVdotVMAQA_VX, 0x7 }, // 69
  { PseudoVAADDU_VV_M1, VAADDU_VV, 0x0 }, // 70
  { PseudoVAADDU_VV_M1_MASK, VAADDU_VV, 0x0 }, // 71
  { PseudoVAADDU_VV_M1_TU, VAADDU_VV, 0x0 }, // 72
  { PseudoVAADDU_VV_M2, VAADDU_VV, 0x1 }, // 73
  { PseudoVAADDU_VV_M2_MASK, VAADDU_VV, 0x1 }, // 74
  { PseudoVAADDU_VV_M2_TU, VAADDU_VV, 0x1 }, // 75
  { PseudoVAADDU_VV_M4, VAADDU_VV, 0x2 }, // 76
  { PseudoVAADDU_VV_M4_MASK, VAADDU_VV, 0x2 }, // 77
  { PseudoVAADDU_VV_M4_TU, VAADDU_VV, 0x2 }, // 78
  { PseudoVAADDU_VV_M8, VAADDU_VV, 0x3 }, // 79
  { PseudoVAADDU_VV_M8_MASK, VAADDU_VV, 0x3 }, // 80
  { PseudoVAADDU_VV_M8_TU, VAADDU_VV, 0x3 }, // 81
  { PseudoVAADDU_VV_MF8, VAADDU_VV, 0x5 }, // 82
  { PseudoVAADDU_VV_MF8_MASK, VAADDU_VV, 0x5 }, // 83
  { PseudoVAADDU_VV_MF8_TU, VAADDU_VV, 0x5 }, // 84
  { PseudoVAADDU_VV_MF4, VAADDU_VV, 0x6 }, // 85
  { PseudoVAADDU_VV_MF4_MASK, VAADDU_VV, 0x6 }, // 86
  { PseudoVAADDU_VV_MF4_TU, VAADDU_VV, 0x6 }, // 87
  { PseudoVAADDU_VV_MF2, VAADDU_VV, 0x7 }, // 88
  { PseudoVAADDU_VV_MF2_MASK, VAADDU_VV, 0x7 }, // 89
  { PseudoVAADDU_VV_MF2_TU, VAADDU_VV, 0x7 }, // 90
  { PseudoVAADDU_VX_M1, VAADDU_VX, 0x0 }, // 91
  { PseudoVAADDU_VX_M1_MASK, VAADDU_VX, 0x0 }, // 92
  { PseudoVAADDU_VX_M1_TU, VAADDU_VX, 0x0 }, // 93
  { PseudoVAADDU_VX_M2, VAADDU_VX, 0x1 }, // 94
  { PseudoVAADDU_VX_M2_MASK, VAADDU_VX, 0x1 }, // 95
  { PseudoVAADDU_VX_M2_TU, VAADDU_VX, 0x1 }, // 96
  { PseudoVAADDU_VX_M4, VAADDU_VX, 0x2 }, // 97
  { PseudoVAADDU_VX_M4_MASK, VAADDU_VX, 0x2 }, // 98
  { PseudoVAADDU_VX_M4_TU, VAADDU_VX, 0x2 }, // 99
  { PseudoVAADDU_VX_M8, VAADDU_VX, 0x3 }, // 100
  { PseudoVAADDU_VX_M8_MASK, VAADDU_VX, 0x3 }, // 101
  { PseudoVAADDU_VX_M8_TU, VAADDU_VX, 0x3 }, // 102
  { PseudoVAADDU_VX_MF8, VAADDU_VX, 0x5 }, // 103
  { PseudoVAADDU_VX_MF8_MASK, VAADDU_VX, 0x5 }, // 104
  { PseudoVAADDU_VX_MF8_TU, VAADDU_VX, 0x5 }, // 105
  { PseudoVAADDU_VX_MF4, VAADDU_VX, 0x6 }, // 106
  { PseudoVAADDU_VX_MF4_MASK, VAADDU_VX, 0x6 }, // 107
  { PseudoVAADDU_VX_MF4_TU, VAADDU_VX, 0x6 }, // 108
  { PseudoVAADDU_VX_MF2, VAADDU_VX, 0x7 }, // 109
  { PseudoVAADDU_VX_MF2_MASK, VAADDU_VX, 0x7 }, // 110
  { PseudoVAADDU_VX_MF2_TU, VAADDU_VX, 0x7 }, // 111
  { PseudoVAADD_VV_M1, VAADD_VV, 0x0 }, // 112
  { PseudoVAADD_VV_M1_MASK, VAADD_VV, 0x0 }, // 113
  { PseudoVAADD_VV_M1_TU, VAADD_VV, 0x0 }, // 114
  { PseudoVAADD_VV_M2, VAADD_VV, 0x1 }, // 115
  { PseudoVAADD_VV_M2_MASK, VAADD_VV, 0x1 }, // 116
  { PseudoVAADD_VV_M2_TU, VAADD_VV, 0x1 }, // 117
  { PseudoVAADD_VV_M4, VAADD_VV, 0x2 }, // 118
  { PseudoVAADD_VV_M4_MASK, VAADD_VV, 0x2 }, // 119
  { PseudoVAADD_VV_M4_TU, VAADD_VV, 0x2 }, // 120
  { PseudoVAADD_VV_M8, VAADD_VV, 0x3 }, // 121
  { PseudoVAADD_VV_M8_MASK, VAADD_VV, 0x3 }, // 122
  { PseudoVAADD_VV_M8_TU, VAADD_VV, 0x3 }, // 123
  { PseudoVAADD_VV_MF8, VAADD_VV, 0x5 }, // 124
  { PseudoVAADD_VV_MF8_MASK, VAADD_VV, 0x5 }, // 125
  { PseudoVAADD_VV_MF8_TU, VAADD_VV, 0x5 }, // 126
  { PseudoVAADD_VV_MF4, VAADD_VV, 0x6 }, // 127
  { PseudoVAADD_VV_MF4_MASK, VAADD_VV, 0x6 }, // 128
  { PseudoVAADD_VV_MF4_TU, VAADD_VV, 0x6 }, // 129
  { PseudoVAADD_VV_MF2, VAADD_VV, 0x7 }, // 130
  { PseudoVAADD_VV_MF2_MASK, VAADD_VV, 0x7 }, // 131
  { PseudoVAADD_VV_MF2_TU, VAADD_VV, 0x7 }, // 132
  { PseudoVAADD_VX_M1, VAADD_VX, 0x0 }, // 133
  { PseudoVAADD_VX_M1_MASK, VAADD_VX, 0x0 }, // 134
  { PseudoVAADD_VX_M1_TU, VAADD_VX, 0x0 }, // 135
  { PseudoVAADD_VX_M2, VAADD_VX, 0x1 }, // 136
  { PseudoVAADD_VX_M2_MASK, VAADD_VX, 0x1 }, // 137
  { PseudoVAADD_VX_M2_TU, VAADD_VX, 0x1 }, // 138
  { PseudoVAADD_VX_M4, VAADD_VX, 0x2 }, // 139
  { PseudoVAADD_VX_M4_MASK, VAADD_VX, 0x2 }, // 140
  { PseudoVAADD_VX_M4_TU, VAADD_VX, 0x2 }, // 141
  { PseudoVAADD_VX_M8, VAADD_VX, 0x3 }, // 142
  { PseudoVAADD_VX_M8_MASK, VAADD_VX, 0x3 }, // 143
  { PseudoVAADD_VX_M8_TU, VAADD_VX, 0x3 }, // 144
  { PseudoVAADD_VX_MF8, VAADD_VX, 0x5 }, // 145
  { PseudoVAADD_VX_MF8_MASK, VAADD_VX, 0x5 }, // 146
  { PseudoVAADD_VX_MF8_TU, VAADD_VX, 0x5 }, // 147
  { PseudoVAADD_VX_MF4, VAADD_VX, 0x6 }, // 148
  { PseudoVAADD_VX_MF4_MASK, VAADD_VX, 0x6 }, // 149
  { PseudoVAADD_VX_MF4_TU, VAADD_VX, 0x6 }, // 150
  { PseudoVAADD_VX_MF2, VAADD_VX, 0x7 }, // 151
  { PseudoVAADD_VX_MF2_MASK, VAADD_VX, 0x7 }, // 152
  { PseudoVAADD_VX_MF2_TU, VAADD_VX, 0x7 }, // 153
  { PseudoVADC_VIM_M1, VADC_VIM, 0x0 }, // 154
  { PseudoVADC_VIM_M1_TU, VADC_VIM, 0x0 }, // 155
  { PseudoVADC_VIM_M2, VADC_VIM, 0x1 }, // 156
  { PseudoVADC_VIM_M2_TU, VADC_VIM, 0x1 }, // 157
  { PseudoVADC_VIM_M4, VADC_VIM, 0x2 }, // 158
  { PseudoVADC_VIM_M4_TU, VADC_VIM, 0x2 }, // 159
  { PseudoVADC_VIM_M8, VADC_VIM, 0x3 }, // 160
  { PseudoVADC_VIM_M8_TU, VADC_VIM, 0x3 }, // 161
  { PseudoVADC_VIM_MF8, VADC_VIM, 0x5 }, // 162
  { PseudoVADC_VIM_MF8_TU, VADC_VIM, 0x5 }, // 163
  { PseudoVADC_VIM_MF4, VADC_VIM, 0x6 }, // 164
  { PseudoVADC_VIM_MF4_TU, VADC_VIM, 0x6 }, // 165
  { PseudoVADC_VIM_MF2, VADC_VIM, 0x7 }, // 166
  { PseudoVADC_VIM_MF2_TU, VADC_VIM, 0x7 }, // 167
  { PseudoVADC_VVM_M1, VADC_VVM, 0x0 }, // 168
  { PseudoVADC_VVM_M1_TU, VADC_VVM, 0x0 }, // 169
  { PseudoVADC_VVM_M2, VADC_VVM, 0x1 }, // 170
  { PseudoVADC_VVM_M2_TU, VADC_VVM, 0x1 }, // 171
  { PseudoVADC_VVM_M4, VADC_VVM, 0x2 }, // 172
  { PseudoVADC_VVM_M4_TU, VADC_VVM, 0x2 }, // 173
  { PseudoVADC_VVM_M8, VADC_VVM, 0x3 }, // 174
  { PseudoVADC_VVM_M8_TU, VADC_VVM, 0x3 }, // 175
  { PseudoVADC_VVM_MF8, VADC_VVM, 0x5 }, // 176
  { PseudoVADC_VVM_MF8_TU, VADC_VVM, 0x5 }, // 177
  { PseudoVADC_VVM_MF4, VADC_VVM, 0x6 }, // 178
  { PseudoVADC_VVM_MF4_TU, VADC_VVM, 0x6 }, // 179
  { PseudoVADC_VVM_MF2, VADC_VVM, 0x7 }, // 180
  { PseudoVADC_VVM_MF2_TU, VADC_VVM, 0x7 }, // 181
  { PseudoVADC_VXM_M1, VADC_VXM, 0x0 }, // 182
  { PseudoVADC_VXM_M1_TU, VADC_VXM, 0x0 }, // 183
  { PseudoVADC_VXM_M2, VADC_VXM, 0x1 }, // 184
  { PseudoVADC_VXM_M2_TU, VADC_VXM, 0x1 }, // 185
  { PseudoVADC_VXM_M4, VADC_VXM, 0x2 }, // 186
  { PseudoVADC_VXM_M4_TU, VADC_VXM, 0x2 }, // 187
  { PseudoVADC_VXM_M8, VADC_VXM, 0x3 }, // 188
  { PseudoVADC_VXM_M8_TU, VADC_VXM, 0x3 }, // 189
  { PseudoVADC_VXM_MF8, VADC_VXM, 0x5 }, // 190
  { PseudoVADC_VXM_MF8_TU, VADC_VXM, 0x5 }, // 191
  { PseudoVADC_VXM_MF4, VADC_VXM, 0x6 }, // 192
  { PseudoVADC_VXM_MF4_TU, VADC_VXM, 0x6 }, // 193
  { PseudoVADC_VXM_MF2, VADC_VXM, 0x7 }, // 194
  { PseudoVADC_VXM_MF2_TU, VADC_VXM, 0x7 }, // 195
  { PseudoVADD_VI_M1, VADD_VI, 0x0 }, // 196
  { PseudoVADD_VI_M1_MASK, VADD_VI, 0x0 }, // 197
  { PseudoVADD_VI_M1_TU, VADD_VI, 0x0 }, // 198
  { PseudoVADD_VI_M2, VADD_VI, 0x1 }, // 199
  { PseudoVADD_VI_M2_MASK, VADD_VI, 0x1 }, // 200
  { PseudoVADD_VI_M2_TU, VADD_VI, 0x1 }, // 201
  { PseudoVADD_VI_M4, VADD_VI, 0x2 }, // 202
  { PseudoVADD_VI_M4_MASK, VADD_VI, 0x2 }, // 203
  { PseudoVADD_VI_M4_TU, VADD_VI, 0x2 }, // 204
  { PseudoVADD_VI_M8, VADD_VI, 0x3 }, // 205
  { PseudoVADD_VI_M8_MASK, VADD_VI, 0x3 }, // 206
  { PseudoVADD_VI_M8_TU, VADD_VI, 0x3 }, // 207
  { PseudoVADD_VI_MF8, VADD_VI, 0x5 }, // 208
  { PseudoVADD_VI_MF8_MASK, VADD_VI, 0x5 }, // 209
  { PseudoVADD_VI_MF8_TU, VADD_VI, 0x5 }, // 210
  { PseudoVADD_VI_MF4, VADD_VI, 0x6 }, // 211
  { PseudoVADD_VI_MF4_MASK, VADD_VI, 0x6 }, // 212
  { PseudoVADD_VI_MF4_TU, VADD_VI, 0x6 }, // 213
  { PseudoVADD_VI_MF2, VADD_VI, 0x7 }, // 214
  { PseudoVADD_VI_MF2_MASK, VADD_VI, 0x7 }, // 215
  { PseudoVADD_VI_MF2_TU, VADD_VI, 0x7 }, // 216
  { PseudoVADD_VV_M1, VADD_VV, 0x0 }, // 217
  { PseudoVADD_VV_M1_MASK, VADD_VV, 0x0 }, // 218
  { PseudoVADD_VV_M1_TU, VADD_VV, 0x0 }, // 219
  { PseudoVADD_VV_M2, VADD_VV, 0x1 }, // 220
  { PseudoVADD_VV_M2_MASK, VADD_VV, 0x1 }, // 221
  { PseudoVADD_VV_M2_TU, VADD_VV, 0x1 }, // 222
  { PseudoVADD_VV_M4, VADD_VV, 0x2 }, // 223
  { PseudoVADD_VV_M4_MASK, VADD_VV, 0x2 }, // 224
  { PseudoVADD_VV_M4_TU, VADD_VV, 0x2 }, // 225
  { PseudoVADD_VV_M8, VADD_VV, 0x3 }, // 226
  { PseudoVADD_VV_M8_MASK, VADD_VV, 0x3 }, // 227
  { PseudoVADD_VV_M8_TU, VADD_VV, 0x3 }, // 228
  { PseudoVADD_VV_MF8, VADD_VV, 0x5 }, // 229
  { PseudoVADD_VV_MF8_MASK, VADD_VV, 0x5 }, // 230
  { PseudoVADD_VV_MF8_TU, VADD_VV, 0x5 }, // 231
  { PseudoVADD_VV_MF4, VADD_VV, 0x6 }, // 232
  { PseudoVADD_VV_MF4_MASK, VADD_VV, 0x6 }, // 233
  { PseudoVADD_VV_MF4_TU, VADD_VV, 0x6 }, // 234
  { PseudoVADD_VV_MF2, VADD_VV, 0x7 }, // 235
  { PseudoVADD_VV_MF2_MASK, VADD_VV, 0x7 }, // 236
  { PseudoVADD_VV_MF2_TU, VADD_VV, 0x7 }, // 237
  { PseudoVADD_VX_M1, VADD_VX, 0x0 }, // 238
  { PseudoVADD_VX_M1_MASK, VADD_VX, 0x0 }, // 239
  { PseudoVADD_VX_M1_TU, VADD_VX, 0x0 }, // 240
  { PseudoVADD_VX_M2, VADD_VX, 0x1 }, // 241
  { PseudoVADD_VX_M2_MASK, VADD_VX, 0x1 }, // 242
  { PseudoVADD_VX_M2_TU, VADD_VX, 0x1 }, // 243
  { PseudoVADD_VX_M4, VADD_VX, 0x2 }, // 244
  { PseudoVADD_VX_M4_MASK, VADD_VX, 0x2 }, // 245
  { PseudoVADD_VX_M4_TU, VADD_VX, 0x2 }, // 246
  { PseudoVADD_VX_M8, VADD_VX, 0x3 }, // 247
  { PseudoVADD_VX_M8_MASK, VADD_VX, 0x3 }, // 248
  { PseudoVADD_VX_M8_TU, VADD_VX, 0x3 }, // 249
  { PseudoVADD_VX_MF8, VADD_VX, 0x5 }, // 250
  { PseudoVADD_VX_MF8_MASK, VADD_VX, 0x5 }, // 251
  { PseudoVADD_VX_MF8_TU, VADD_VX, 0x5 }, // 252
  { PseudoVADD_VX_MF4, VADD_VX, 0x6 }, // 253
  { PseudoVADD_VX_MF4_MASK, VADD_VX, 0x6 }, // 254
  { PseudoVADD_VX_MF4_TU, VADD_VX, 0x6 }, // 255
  { PseudoVADD_VX_MF2, VADD_VX, 0x7 }, // 256
  { PseudoVADD_VX_MF2_MASK, VADD_VX, 0x7 }, // 257
  { PseudoVADD_VX_MF2_TU, VADD_VX, 0x7 }, // 258
  { PseudoVAND_VI_M1, VAND_VI, 0x0 }, // 259
  { PseudoVAND_VI_M1_MASK, VAND_VI, 0x0 }, // 260
  { PseudoVAND_VI_M1_TU, VAND_VI, 0x0 }, // 261
  { PseudoVAND_VI_M2, VAND_VI, 0x1 }, // 262
  { PseudoVAND_VI_M2_MASK, VAND_VI, 0x1 }, // 263
  { PseudoVAND_VI_M2_TU, VAND_VI, 0x1 }, // 264
  { PseudoVAND_VI_M4, VAND_VI, 0x2 }, // 265
  { PseudoVAND_VI_M4_MASK, VAND_VI, 0x2 }, // 266
  { PseudoVAND_VI_M4_TU, VAND_VI, 0x2 }, // 267
  { PseudoVAND_VI_M8, VAND_VI, 0x3 }, // 268
  { PseudoVAND_VI_M8_MASK, VAND_VI, 0x3 }, // 269
  { PseudoVAND_VI_M8_TU, VAND_VI, 0x3 }, // 270
  { PseudoVAND_VI_MF8, VAND_VI, 0x5 }, // 271
  { PseudoVAND_VI_MF8_MASK, VAND_VI, 0x5 }, // 272
  { PseudoVAND_VI_MF8_TU, VAND_VI, 0x5 }, // 273
  { PseudoVAND_VI_MF4, VAND_VI, 0x6 }, // 274
  { PseudoVAND_VI_MF4_MASK, VAND_VI, 0x6 }, // 275
  { PseudoVAND_VI_MF4_TU, VAND_VI, 0x6 }, // 276
  { PseudoVAND_VI_MF2, VAND_VI, 0x7 }, // 277
  { PseudoVAND_VI_MF2_MASK, VAND_VI, 0x7 }, // 278
  { PseudoVAND_VI_MF2_TU, VAND_VI, 0x7 }, // 279
  { PseudoVAND_VV_M1, VAND_VV, 0x0 }, // 280
  { PseudoVAND_VV_M1_MASK, VAND_VV, 0x0 }, // 281
  { PseudoVAND_VV_M1_TU, VAND_VV, 0x0 }, // 282
  { PseudoVAND_VV_M2, VAND_VV, 0x1 }, // 283
  { PseudoVAND_VV_M2_MASK, VAND_VV, 0x1 }, // 284
  { PseudoVAND_VV_M2_TU, VAND_VV, 0x1 }, // 285
  { PseudoVAND_VV_M4, VAND_VV, 0x2 }, // 286
  { PseudoVAND_VV_M4_MASK, VAND_VV, 0x2 }, // 287
  { PseudoVAND_VV_M4_TU, VAND_VV, 0x2 }, // 288
  { PseudoVAND_VV_M8, VAND_VV, 0x3 }, // 289
  { PseudoVAND_VV_M8_MASK, VAND_VV, 0x3 }, // 290
  { PseudoVAND_VV_M8_TU, VAND_VV, 0x3 }, // 291
  { PseudoVAND_VV_MF8, VAND_VV, 0x5 }, // 292
  { PseudoVAND_VV_MF8_MASK, VAND_VV, 0x5 }, // 293
  { PseudoVAND_VV_MF8_TU, VAND_VV, 0x5 }, // 294
  { PseudoVAND_VV_MF4, VAND_VV, 0x6 }, // 295
  { PseudoVAND_VV_MF4_MASK, VAND_VV, 0x6 }, // 296
  { PseudoVAND_VV_MF4_TU, VAND_VV, 0x6 }, // 297
  { PseudoVAND_VV_MF2, VAND_VV, 0x7 }, // 298
  { PseudoVAND_VV_MF2_MASK, VAND_VV, 0x7 }, // 299
  { PseudoVAND_VV_MF2_TU, VAND_VV, 0x7 }, // 300
  { PseudoVAND_VX_M1, VAND_VX, 0x0 }, // 301
  { PseudoVAND_VX_M1_MASK, VAND_VX, 0x0 }, // 302
  { PseudoVAND_VX_M1_TU, VAND_VX, 0x0 }, // 303
  { PseudoVAND_VX_M2, VAND_VX, 0x1 }, // 304
  { PseudoVAND_VX_M2_MASK, VAND_VX, 0x1 }, // 305
  { PseudoVAND_VX_M2_TU, VAND_VX, 0x1 }, // 306
  { PseudoVAND_VX_M4, VAND_VX, 0x2 }, // 307
  { PseudoVAND_VX_M4_MASK, VAND_VX, 0x2 }, // 308
  { PseudoVAND_VX_M4_TU, VAND_VX, 0x2 }, // 309
  { PseudoVAND_VX_M8, VAND_VX, 0x3 }, // 310
  { PseudoVAND_VX_M8_MASK, VAND_VX, 0x3 }, // 311
  { PseudoVAND_VX_M8_TU, VAND_VX, 0x3 }, // 312
  { PseudoVAND_VX_MF8, VAND_VX, 0x5 }, // 313
  { PseudoVAND_VX_MF8_MASK, VAND_VX, 0x5 }, // 314
  { PseudoVAND_VX_MF8_TU, VAND_VX, 0x5 }, // 315
  { PseudoVAND_VX_MF4, VAND_VX, 0x6 }, // 316
  { PseudoVAND_VX_MF4_MASK, VAND_VX, 0x6 }, // 317
  { PseudoVAND_VX_MF4_TU, VAND_VX, 0x6 }, // 318
  { PseudoVAND_VX_MF2, VAND_VX, 0x7 }, // 319
  { PseudoVAND_VX_MF2_MASK, VAND_VX, 0x7 }, // 320
  { PseudoVAND_VX_MF2_TU, VAND_VX, 0x7 }, // 321
  { PseudoVASUBU_VV_M1, VASUBU_VV, 0x0 }, // 322
  { PseudoVASUBU_VV_M1_MASK, VASUBU_VV, 0x0 }, // 323
  { PseudoVASUBU_VV_M1_TU, VASUBU_VV, 0x0 }, // 324
  { PseudoVASUBU_VV_M2, VASUBU_VV, 0x1 }, // 325
  { PseudoVASUBU_VV_M2_MASK, VASUBU_VV, 0x1 }, // 326
  { PseudoVASUBU_VV_M2_TU, VASUBU_VV, 0x1 }, // 327
  { PseudoVASUBU_VV_M4, VASUBU_VV, 0x2 }, // 328
  { PseudoVASUBU_VV_M4_MASK, VASUBU_VV, 0x2 }, // 329
  { PseudoVASUBU_VV_M4_TU, VASUBU_VV, 0x2 }, // 330
  { PseudoVASUBU_VV_M8, VASUBU_VV, 0x3 }, // 331
  { PseudoVASUBU_VV_M8_MASK, VASUBU_VV, 0x3 }, // 332
  { PseudoVASUBU_VV_M8_TU, VASUBU_VV, 0x3 }, // 333
  { PseudoVASUBU_VV_MF8, VASUBU_VV, 0x5 }, // 334
  { PseudoVASUBU_VV_MF8_MASK, VASUBU_VV, 0x5 }, // 335
  { PseudoVASUBU_VV_MF8_TU, VASUBU_VV, 0x5 }, // 336
  { PseudoVASUBU_VV_MF4, VASUBU_VV, 0x6 }, // 337
  { PseudoVASUBU_VV_MF4_MASK, VASUBU_VV, 0x6 }, // 338
  { PseudoVASUBU_VV_MF4_TU, VASUBU_VV, 0x6 }, // 339
  { PseudoVASUBU_VV_MF2, VASUBU_VV, 0x7 }, // 340
  { PseudoVASUBU_VV_MF2_MASK, VASUBU_VV, 0x7 }, // 341
  { PseudoVASUBU_VV_MF2_TU, VASUBU_VV, 0x7 }, // 342
  { PseudoVASUBU_VX_M1, VASUBU_VX, 0x0 }, // 343
  { PseudoVASUBU_VX_M1_MASK, VASUBU_VX, 0x0 }, // 344
  { PseudoVASUBU_VX_M1_TU, VASUBU_VX, 0x0 }, // 345
  { PseudoVASUBU_VX_M2, VASUBU_VX, 0x1 }, // 346
  { PseudoVASUBU_VX_M2_MASK, VASUBU_VX, 0x1 }, // 347
  { PseudoVASUBU_VX_M2_TU, VASUBU_VX, 0x1 }, // 348
  { PseudoVASUBU_VX_M4, VASUBU_VX, 0x2 }, // 349
  { PseudoVASUBU_VX_M4_MASK, VASUBU_VX, 0x2 }, // 350
  { PseudoVASUBU_VX_M4_TU, VASUBU_VX, 0x2 }, // 351
  { PseudoVASUBU_VX_M8, VASUBU_VX, 0x3 }, // 352
  { PseudoVASUBU_VX_M8_MASK, VASUBU_VX, 0x3 }, // 353
  { PseudoVASUBU_VX_M8_TU, VASUBU_VX, 0x3 }, // 354
  { PseudoVASUBU_VX_MF8, VASUBU_VX, 0x5 }, // 355
  { PseudoVASUBU_VX_MF8_MASK, VASUBU_VX, 0x5 }, // 356
  { PseudoVASUBU_VX_MF8_TU, VASUBU_VX, 0x5 }, // 357
  { PseudoVASUBU_VX_MF4, VASUBU_VX, 0x6 }, // 358
  { PseudoVASUBU_VX_MF4_MASK, VASUBU_VX, 0x6 }, // 359
  { PseudoVASUBU_VX_MF4_TU, VASUBU_VX, 0x6 }, // 360
  { PseudoVASUBU_VX_MF2, VASUBU_VX, 0x7 }, // 361
  { PseudoVASUBU_VX_MF2_MASK, VASUBU_VX, 0x7 }, // 362
  { PseudoVASUBU_VX_MF2_TU, VASUBU_VX, 0x7 }, // 363
  { PseudoVASUB_VV_M1, VASUB_VV, 0x0 }, // 364
  { PseudoVASUB_VV_M1_MASK, VASUB_VV, 0x0 }, // 365
  { PseudoVASUB_VV_M1_TU, VASUB_VV, 0x0 }, // 366
  { PseudoVASUB_VV_M2, VASUB_VV, 0x1 }, // 367
  { PseudoVASUB_VV_M2_MASK, VASUB_VV, 0x1 }, // 368
  { PseudoVASUB_VV_M2_TU, VASUB_VV, 0x1 }, // 369
  { PseudoVASUB_VV_M4, VASUB_VV, 0x2 }, // 370
  { PseudoVASUB_VV_M4_MASK, VASUB_VV, 0x2 }, // 371
  { PseudoVASUB_VV_M4_TU, VASUB_VV, 0x2 }, // 372
  { PseudoVASUB_VV_M8, VASUB_VV, 0x3 }, // 373
  { PseudoVASUB_VV_M8_MASK, VASUB_VV, 0x3 }, // 374
  { PseudoVASUB_VV_M8_TU, VASUB_VV, 0x3 }, // 375
  { PseudoVASUB_VV_MF8, VASUB_VV, 0x5 }, // 376
  { PseudoVASUB_VV_MF8_MASK, VASUB_VV, 0x5 }, // 377
  { PseudoVASUB_VV_MF8_TU, VASUB_VV, 0x5 }, // 378
  { PseudoVASUB_VV_MF4, VASUB_VV, 0x6 }, // 379
  { PseudoVASUB_VV_MF4_MASK, VASUB_VV, 0x6 }, // 380
  { PseudoVASUB_VV_MF4_TU, VASUB_VV, 0x6 }, // 381
  { PseudoVASUB_VV_MF2, VASUB_VV, 0x7 }, // 382
  { PseudoVASUB_VV_MF2_MASK, VASUB_VV, 0x7 }, // 383
  { PseudoVASUB_VV_MF2_TU, VASUB_VV, 0x7 }, // 384
  { PseudoVASUB_VX_M1, VASUB_VX, 0x0 }, // 385
  { PseudoVASUB_VX_M1_MASK, VASUB_VX, 0x0 }, // 386
  { PseudoVASUB_VX_M1_TU, VASUB_VX, 0x0 }, // 387
  { PseudoVASUB_VX_M2, VASUB_VX, 0x1 }, // 388
  { PseudoVASUB_VX_M2_MASK, VASUB_VX, 0x1 }, // 389
  { PseudoVASUB_VX_M2_TU, VASUB_VX, 0x1 }, // 390
  { PseudoVASUB_VX_M4, VASUB_VX, 0x2 }, // 391
  { PseudoVASUB_VX_M4_MASK, VASUB_VX, 0x2 }, // 392
  { PseudoVASUB_VX_M4_TU, VASUB_VX, 0x2 }, // 393
  { PseudoVASUB_VX_M8, VASUB_VX, 0x3 }, // 394
  { PseudoVASUB_VX_M8_MASK, VASUB_VX, 0x3 }, // 395
  { PseudoVASUB_VX_M8_TU, VASUB_VX, 0x3 }, // 396
  { PseudoVASUB_VX_MF8, VASUB_VX, 0x5 }, // 397
  { PseudoVASUB_VX_MF8_MASK, VASUB_VX, 0x5 }, // 398
  { PseudoVASUB_VX_MF8_TU, VASUB_VX, 0x5 }, // 399
  { PseudoVASUB_VX_MF4, VASUB_VX, 0x6 }, // 400
  { PseudoVASUB_VX_MF4_MASK, VASUB_VX, 0x6 }, // 401
  { PseudoVASUB_VX_MF4_TU, VASUB_VX, 0x6 }, // 402
  { PseudoVASUB_VX_MF2, VASUB_VX, 0x7 }, // 403
  { PseudoVASUB_VX_MF2_MASK, VASUB_VX, 0x7 }, // 404
  { PseudoVASUB_VX_MF2_TU, VASUB_VX, 0x7 }, // 405
  { PseudoVCOMPRESS_VM_M1_E16, VCOMPRESS_VM, 0x0 }, // 406
  { PseudoVCOMPRESS_VM_M1_E32, VCOMPRESS_VM, 0x0 }, // 407
  { PseudoVCOMPRESS_VM_M1_E64, VCOMPRESS_VM, 0x0 }, // 408
  { PseudoVCOMPRESS_VM_M1_E8, VCOMPRESS_VM, 0x0 }, // 409
  { PseudoVCOMPRESS_VM_M2_E16, VCOMPRESS_VM, 0x1 }, // 410
  { PseudoVCOMPRESS_VM_M2_E32, VCOMPRESS_VM, 0x1 }, // 411
  { PseudoVCOMPRESS_VM_M2_E64, VCOMPRESS_VM, 0x1 }, // 412
  { PseudoVCOMPRESS_VM_M2_E8, VCOMPRESS_VM, 0x1 }, // 413
  { PseudoVCOMPRESS_VM_M4_E16, VCOMPRESS_VM, 0x2 }, // 414
  { PseudoVCOMPRESS_VM_M4_E32, VCOMPRESS_VM, 0x2 }, // 415
  { PseudoVCOMPRESS_VM_M4_E64, VCOMPRESS_VM, 0x2 }, // 416
  { PseudoVCOMPRESS_VM_M4_E8, VCOMPRESS_VM, 0x2 }, // 417
  { PseudoVCOMPRESS_VM_M8_E16, VCOMPRESS_VM, 0x3 }, // 418
  { PseudoVCOMPRESS_VM_M8_E32, VCOMPRESS_VM, 0x3 }, // 419
  { PseudoVCOMPRESS_VM_M8_E64, VCOMPRESS_VM, 0x3 }, // 420
  { PseudoVCOMPRESS_VM_M8_E8, VCOMPRESS_VM, 0x3 }, // 421
  { PseudoVCOMPRESS_VM_MF8_E8, VCOMPRESS_VM, 0x5 }, // 422
  { PseudoVCOMPRESS_VM_MF4_E16, VCOMPRESS_VM, 0x6 }, // 423
  { PseudoVCOMPRESS_VM_MF4_E8, VCOMPRESS_VM, 0x6 }, // 424
  { PseudoVCOMPRESS_VM_MF2_E16, VCOMPRESS_VM, 0x7 }, // 425
  { PseudoVCOMPRESS_VM_MF2_E32, VCOMPRESS_VM, 0x7 }, // 426
  { PseudoVCOMPRESS_VM_MF2_E8, VCOMPRESS_VM, 0x7 }, // 427
  { PseudoVCPOP_M_B8, VCPOP_M, 0x0 }, // 428
  { PseudoVCPOP_M_B8_MASK, VCPOP_M, 0x0 }, // 429
  { PseudoVCPOP_M_B16, VCPOP_M, 0x1 }, // 430
  { PseudoVCPOP_M_B16_MASK, VCPOP_M, 0x1 }, // 431
  { PseudoVCPOP_M_B32, VCPOP_M, 0x2 }, // 432
  { PseudoVCPOP_M_B32_MASK, VCPOP_M, 0x2 }, // 433
  { PseudoVCPOP_M_B64, VCPOP_M, 0x3 }, // 434
  { PseudoVCPOP_M_B64_MASK, VCPOP_M, 0x3 }, // 435
  { PseudoVCPOP_M_B1, VCPOP_M, 0x5 }, // 436
  { PseudoVCPOP_M_B1_MASK, VCPOP_M, 0x5 }, // 437
  { PseudoVCPOP_M_B2, VCPOP_M, 0x6 }, // 438
  { PseudoVCPOP_M_B2_MASK, VCPOP_M, 0x6 }, // 439
  { PseudoVCPOP_M_B4, VCPOP_M, 0x7 }, // 440
  { PseudoVCPOP_M_B4_MASK, VCPOP_M, 0x7 }, // 441
  { PseudoVC_F16V_SE_M1, VC_FV, 0x0 }, // 442
  { PseudoVC_F32V_SE_M1, VC_FV, 0x0 }, // 443
  { PseudoVC_F64V_SE_M1, VC_FV, 0x0 }, // 444
  { PseudoVC_F16V_SE_M2, VC_FV, 0x1 }, // 445
  { PseudoVC_F32V_SE_M2, VC_FV, 0x1 }, // 446
  { PseudoVC_F64V_SE_M2, VC_FV, 0x1 }, // 447
  { PseudoVC_F16V_SE_M4, VC_FV, 0x2 }, // 448
  { PseudoVC_F32V_SE_M4, VC_FV, 0x2 }, // 449
  { PseudoVC_F64V_SE_M4, VC_FV, 0x2 }, // 450
  { PseudoVC_F16V_SE_M8, VC_FV, 0x3 }, // 451
  { PseudoVC_F32V_SE_M8, VC_FV, 0x3 }, // 452
  { PseudoVC_F64V_SE_M8, VC_FV, 0x3 }, // 453
  { PseudoVC_F16V_SE_MF4, VC_FV, 0x6 }, // 454
  { PseudoVC_F16V_SE_MF2, VC_FV, 0x7 }, // 455
  { PseudoVC_F32V_SE_MF2, VC_FV, 0x7 }, // 456
  { PseudoVC_F16VV_SE_M1, VC_FVV, 0x0 }, // 457
  { PseudoVC_F32VV_SE_M1, VC_FVV, 0x0 }, // 458
  { PseudoVC_F64VV_SE_M1, VC_FVV, 0x0 }, // 459
  { PseudoVC_F16VV_SE_M2, VC_FVV, 0x1 }, // 460
  { PseudoVC_F32VV_SE_M2, VC_FVV, 0x1 }, // 461
  { PseudoVC_F64VV_SE_M2, VC_FVV, 0x1 }, // 462
  { PseudoVC_F16VV_SE_M4, VC_FVV, 0x2 }, // 463
  { PseudoVC_F32VV_SE_M4, VC_FVV, 0x2 }, // 464
  { PseudoVC_F64VV_SE_M4, VC_FVV, 0x2 }, // 465
  { PseudoVC_F16VV_SE_M8, VC_FVV, 0x3 }, // 466
  { PseudoVC_F32VV_SE_M8, VC_FVV, 0x3 }, // 467
  { PseudoVC_F64VV_SE_M8, VC_FVV, 0x3 }, // 468
  { PseudoVC_F16VV_SE_MF4, VC_FVV, 0x6 }, // 469
  { PseudoVC_F16VV_SE_MF2, VC_FVV, 0x7 }, // 470
  { PseudoVC_F32VV_SE_MF2, VC_FVV, 0x7 }, // 471
  { PseudoVC_F16VW_SE_M1, VC_FVW, 0x0 }, // 472
  { PseudoVC_F32VW_SE_M1, VC_FVW, 0x0 }, // 473
  { PseudoVC_F16VW_SE_M2, VC_FVW, 0x1 }, // 474
  { PseudoVC_F32VW_SE_M2, VC_FVW, 0x1 }, // 475
  { PseudoVC_F16VW_SE_M4, VC_FVW, 0x2 }, // 476
  { PseudoVC_F32VW_SE_M4, VC_FVW, 0x2 }, // 477
  { PseudoVC_F16VW_SE_M8, VC_FVW, 0x3 }, // 478
  { PseudoVC_F32VW_SE_M8, VC_FVW, 0x3 }, // 479
  { PseudoVC_F16VW_SE_MF4, VC_FVW, 0x6 }, // 480
  { PseudoVC_F16VW_SE_MF2, VC_FVW, 0x7 }, // 481
  { PseudoVC_F32VW_SE_MF2, VC_FVW, 0x7 }, // 482
  { PseudoVC_I_SE_M1, VC_I, 0x0 }, // 483
  { PseudoVC_I_SE_M2, VC_I, 0x1 }, // 484
  { PseudoVC_I_SE_M4, VC_I, 0x2 }, // 485
  { PseudoVC_I_SE_M8, VC_I, 0x3 }, // 486
  { PseudoVC_I_SE_MF8, VC_I, 0x5 }, // 487
  { PseudoVC_I_SE_MF4, VC_I, 0x6 }, // 488
  { PseudoVC_I_SE_MF2, VC_I, 0x7 }, // 489
  { PseudoVC_IV_SE_M1, VC_IV, 0x0 }, // 490
  { PseudoVC_IV_SE_M2, VC_IV, 0x1 }, // 491
  { PseudoVC_IV_SE_M4, VC_IV, 0x2 }, // 492
  { PseudoVC_IV_SE_M8, VC_IV, 0x3 }, // 493
  { PseudoVC_IV_SE_MF8, VC_IV, 0x5 }, // 494
  { PseudoVC_IV_SE_MF4, VC_IV, 0x6 }, // 495
  { PseudoVC_IV_SE_MF2, VC_IV, 0x7 }, // 496
  { PseudoVC_IVV_SE_M1, VC_IVV, 0x0 }, // 497
  { PseudoVC_IVV_SE_M2, VC_IVV, 0x1 }, // 498
  { PseudoVC_IVV_SE_M4, VC_IVV, 0x2 }, // 499
  { PseudoVC_IVV_SE_M8, VC_IVV, 0x3 }, // 500
  { PseudoVC_IVV_SE_MF8, VC_IVV, 0x5 }, // 501
  { PseudoVC_IVV_SE_MF4, VC_IVV, 0x6 }, // 502
  { PseudoVC_IVV_SE_MF2, VC_IVV, 0x7 }, // 503
  { PseudoVC_IVW_SE_M1, VC_IVW, 0x0 }, // 504
  { PseudoVC_IVW_SE_M2, VC_IVW, 0x1 }, // 505
  { PseudoVC_IVW_SE_M4, VC_IVW, 0x2 }, // 506
  { PseudoVC_IVW_SE_MF8, VC_IVW, 0x5 }, // 507
  { PseudoVC_IVW_SE_MF4, VC_IVW, 0x6 }, // 508
  { PseudoVC_IVW_SE_MF2, VC_IVW, 0x7 }, // 509
  { PseudoVC_VV_SE_M1, VC_VV, 0x0 }, // 510
  { PseudoVC_VV_SE_M2, VC_VV, 0x1 }, // 511
  { PseudoVC_VV_SE_M4, VC_VV, 0x2 }, // 512
  { PseudoVC_VV_SE_M8, VC_VV, 0x3 }, // 513
  { PseudoVC_VV_SE_MF8, VC_VV, 0x5 }, // 514
  { PseudoVC_VV_SE_MF4, VC_VV, 0x6 }, // 515
  { PseudoVC_VV_SE_MF2, VC_VV, 0x7 }, // 516
  { PseudoVC_VVV_SE_M1, VC_VVV, 0x0 }, // 517
  { PseudoVC_VVV_SE_M2, VC_VVV, 0x1 }, // 518
  { PseudoVC_VVV_SE_M4, VC_VVV, 0x2 }, // 519
  { PseudoVC_VVV_SE_M8, VC_VVV, 0x3 }, // 520
  { PseudoVC_VVV_SE_MF8, VC_VVV, 0x5 }, // 521
  { PseudoVC_VVV_SE_MF4, VC_VVV, 0x6 }, // 522
  { PseudoVC_VVV_SE_MF2, VC_VVV, 0x7 }, // 523
  { PseudoVC_VVW_SE_M1, VC_VVW, 0x0 }, // 524
  { PseudoVC_VVW_SE_M2, VC_VVW, 0x1 }, // 525
  { PseudoVC_VVW_SE_M4, VC_VVW, 0x2 }, // 526
  { PseudoVC_VVW_SE_MF8, VC_VVW, 0x5 }, // 527
  { PseudoVC_VVW_SE_MF4, VC_VVW, 0x6 }, // 528
  { PseudoVC_VVW_SE_MF2, VC_VVW, 0x7 }, // 529
  { PseudoVC_V_F16V_M1, VC_V_FV, 0x0 }, // 530
  { PseudoVC_V_F16V_SE_M1, VC_V_FV, 0x0 }, // 531
  { PseudoVC_V_F32V_M1, VC_V_FV, 0x0 }, // 532
  { PseudoVC_V_F32V_SE_M1, VC_V_FV, 0x0 }, // 533
  { PseudoVC_V_F64V_M1, VC_V_FV, 0x0 }, // 534
  { PseudoVC_V_F64V_SE_M1, VC_V_FV, 0x0 }, // 535
  { PseudoVC_V_F16V_M2, VC_V_FV, 0x1 }, // 536
  { PseudoVC_V_F16V_SE_M2, VC_V_FV, 0x1 }, // 537
  { PseudoVC_V_F32V_M2, VC_V_FV, 0x1 }, // 538
  { PseudoVC_V_F32V_SE_M2, VC_V_FV, 0x1 }, // 539
  { PseudoVC_V_F64V_M2, VC_V_FV, 0x1 }, // 540
  { PseudoVC_V_F64V_SE_M2, VC_V_FV, 0x1 }, // 541
  { PseudoVC_V_F16V_M4, VC_V_FV, 0x2 }, // 542
  { PseudoVC_V_F16V_SE_M4, VC_V_FV, 0x2 }, // 543
  { PseudoVC_V_F32V_M4, VC_V_FV, 0x2 }, // 544
  { PseudoVC_V_F32V_SE_M4, VC_V_FV, 0x2 }, // 545
  { PseudoVC_V_F64V_M4, VC_V_FV, 0x2 }, // 546
  { PseudoVC_V_F64V_SE_M4, VC_V_FV, 0x2 }, // 547
  { PseudoVC_V_F16V_M8, VC_V_FV, 0x3 }, // 548
  { PseudoVC_V_F16V_SE_M8, VC_V_FV, 0x3 }, // 549
  { PseudoVC_V_F32V_M8, VC_V_FV, 0x3 }, // 550
  { PseudoVC_V_F32V_SE_M8, VC_V_FV, 0x3 }, // 551
  { PseudoVC_V_F64V_M8, VC_V_FV, 0x3 }, // 552
  { PseudoVC_V_F64V_SE_M8, VC_V_FV, 0x3 }, // 553
  { PseudoVC_V_F16V_MF4, VC_V_FV, 0x6 }, // 554
  { PseudoVC_V_F16V_SE_MF4, VC_V_FV, 0x6 }, // 555
  { PseudoVC_V_F16V_MF2, VC_V_FV, 0x7 }, // 556
  { PseudoVC_V_F16V_SE_MF2, VC_V_FV, 0x7 }, // 557
  { PseudoVC_V_F32V_MF2, VC_V_FV, 0x7 }, // 558
  { PseudoVC_V_F32V_SE_MF2, VC_V_FV, 0x7 }, // 559
  { PseudoVC_V_F16VV_M1, VC_V_FVV, 0x0 }, // 560
  { PseudoVC_V_F16VV_SE_M1, VC_V_FVV, 0x0 }, // 561
  { PseudoVC_V_F32VV_M1, VC_V_FVV, 0x0 }, // 562
  { PseudoVC_V_F32VV_SE_M1, VC_V_FVV, 0x0 }, // 563
  { PseudoVC_V_F64VV_M1, VC_V_FVV, 0x0 }, // 564
  { PseudoVC_V_F64VV_SE_M1, VC_V_FVV, 0x0 }, // 565
  { PseudoVC_V_F16VV_M2, VC_V_FVV, 0x1 }, // 566
  { PseudoVC_V_F16VV_SE_M2, VC_V_FVV, 0x1 }, // 567
  { PseudoVC_V_F32VV_M2, VC_V_FVV, 0x1 }, // 568
  { PseudoVC_V_F32VV_SE_M2, VC_V_FVV, 0x1 }, // 569
  { PseudoVC_V_F64VV_M2, VC_V_FVV, 0x1 }, // 570
  { PseudoVC_V_F64VV_SE_M2, VC_V_FVV, 0x1 }, // 571
  { PseudoVC_V_F16VV_M4, VC_V_FVV, 0x2 }, // 572
  { PseudoVC_V_F16VV_SE_M4, VC_V_FVV, 0x2 }, // 573
  { PseudoVC_V_F32VV_M4, VC_V_FVV, 0x2 }, // 574
  { PseudoVC_V_F32VV_SE_M4, VC_V_FVV, 0x2 }, // 575
  { PseudoVC_V_F64VV_M4, VC_V_FVV, 0x2 }, // 576
  { PseudoVC_V_F64VV_SE_M4, VC_V_FVV, 0x2 }, // 577
  { PseudoVC_V_F16VV_M8, VC_V_FVV, 0x3 }, // 578
  { PseudoVC_V_F16VV_SE_M8, VC_V_FVV, 0x3 }, // 579
  { PseudoVC_V_F32VV_M8, VC_V_FVV, 0x3 }, // 580
  { PseudoVC_V_F32VV_SE_M8, VC_V_FVV, 0x3 }, // 581
  { PseudoVC_V_F64VV_M8, VC_V_FVV, 0x3 }, // 582
  { PseudoVC_V_F64VV_SE_M8, VC_V_FVV, 0x3 }, // 583
  { PseudoVC_V_F16VV_MF4, VC_V_FVV, 0x6 }, // 584
  { PseudoVC_V_F16VV_SE_MF4, VC_V_FVV, 0x6 }, // 585
  { PseudoVC_V_F16VV_MF2, VC_V_FVV, 0x7 }, // 586
  { PseudoVC_V_F16VV_SE_MF2, VC_V_FVV, 0x7 }, // 587
  { PseudoVC_V_F32VV_MF2, VC_V_FVV, 0x7 }, // 588
  { PseudoVC_V_F32VV_SE_MF2, VC_V_FVV, 0x7 }, // 589
  { PseudoVC_V_F16VW_M1, VC_V_FVW, 0x0 }, // 590
  { PseudoVC_V_F16VW_SE_M1, VC_V_FVW, 0x0 }, // 591
  { PseudoVC_V_F32VW_M1, VC_V_FVW, 0x0 }, // 592
  { PseudoVC_V_F32VW_SE_M1, VC_V_FVW, 0x0 }, // 593
  { PseudoVC_V_F16VW_M2, VC_V_FVW, 0x1 }, // 594
  { PseudoVC_V_F16VW_SE_M2, VC_V_FVW, 0x1 }, // 595
  { PseudoVC_V_F32VW_M2, VC_V_FVW, 0x1 }, // 596
  { PseudoVC_V_F32VW_SE_M2, VC_V_FVW, 0x1 }, // 597
  { PseudoVC_V_F16VW_M4, VC_V_FVW, 0x2 }, // 598
  { PseudoVC_V_F16VW_SE_M4, VC_V_FVW, 0x2 }, // 599
  { PseudoVC_V_F32VW_M4, VC_V_FVW, 0x2 }, // 600
  { PseudoVC_V_F32VW_SE_M4, VC_V_FVW, 0x2 }, // 601
  { PseudoVC_V_F16VW_M8, VC_V_FVW, 0x3 }, // 602
  { PseudoVC_V_F16VW_SE_M8, VC_V_FVW, 0x3 }, // 603
  { PseudoVC_V_F32VW_M8, VC_V_FVW, 0x3 }, // 604
  { PseudoVC_V_F32VW_SE_M8, VC_V_FVW, 0x3 }, // 605
  { PseudoVC_V_F16VW_MF4, VC_V_FVW, 0x6 }, // 606
  { PseudoVC_V_F16VW_SE_MF4, VC_V_FVW, 0x6 }, // 607
  { PseudoVC_V_F16VW_MF2, VC_V_FVW, 0x7 }, // 608
  { PseudoVC_V_F16VW_SE_MF2, VC_V_FVW, 0x7 }, // 609
  { PseudoVC_V_F32VW_MF2, VC_V_FVW, 0x7 }, // 610
  { PseudoVC_V_F32VW_SE_MF2, VC_V_FVW, 0x7 }, // 611
  { PseudoVC_V_I_M1, VC_V_I, 0x0 }, // 612
  { PseudoVC_V_I_SE_M1, VC_V_I, 0x0 }, // 613
  { PseudoVC_V_I_M2, VC_V_I, 0x1 }, // 614
  { PseudoVC_V_I_SE_M2, VC_V_I, 0x1 }, // 615
  { PseudoVC_V_I_M4, VC_V_I, 0x2 }, // 616
  { PseudoVC_V_I_SE_M4, VC_V_I, 0x2 }, // 617
  { PseudoVC_V_I_M8, VC_V_I, 0x3 }, // 618
  { PseudoVC_V_I_SE_M8, VC_V_I, 0x3 }, // 619
  { PseudoVC_V_I_MF8, VC_V_I, 0x5 }, // 620
  { PseudoVC_V_I_SE_MF8, VC_V_I, 0x5 }, // 621
  { PseudoVC_V_I_MF4, VC_V_I, 0x6 }, // 622
  { PseudoVC_V_I_SE_MF4, VC_V_I, 0x6 }, // 623
  { PseudoVC_V_I_MF2, VC_V_I, 0x7 }, // 624
  { PseudoVC_V_I_SE_MF2, VC_V_I, 0x7 }, // 625
  { PseudoVC_V_IV_M1, VC_V_IV, 0x0 }, // 626
  { PseudoVC_V_IV_SE_M1, VC_V_IV, 0x0 }, // 627
  { PseudoVC_V_IV_M2, VC_V_IV, 0x1 }, // 628
  { PseudoVC_V_IV_SE_M2, VC_V_IV, 0x1 }, // 629
  { PseudoVC_V_IV_M4, VC_V_IV, 0x2 }, // 630
  { PseudoVC_V_IV_SE_M4, VC_V_IV, 0x2 }, // 631
  { PseudoVC_V_IV_M8, VC_V_IV, 0x3 }, // 632
  { PseudoVC_V_IV_SE_M8, VC_V_IV, 0x3 }, // 633
  { PseudoVC_V_IV_MF8, VC_V_IV, 0x5 }, // 634
  { PseudoVC_V_IV_SE_MF8, VC_V_IV, 0x5 }, // 635
  { PseudoVC_V_IV_MF4, VC_V_IV, 0x6 }, // 636
  { PseudoVC_V_IV_SE_MF4, VC_V_IV, 0x6 }, // 637
  { PseudoVC_V_IV_MF2, VC_V_IV, 0x7 }, // 638
  { PseudoVC_V_IV_SE_MF2, VC_V_IV, 0x7 }, // 639
  { PseudoVC_V_IVV_M1, VC_V_IVV, 0x0 }, // 640
  { PseudoVC_V_IVV_SE_M1, VC_V_IVV, 0x0 }, // 641
  { PseudoVC_V_IVV_M2, VC_V_IVV, 0x1 }, // 642
  { PseudoVC_V_IVV_SE_M2, VC_V_IVV, 0x1 }, // 643
  { PseudoVC_V_IVV_M4, VC_V_IVV, 0x2 }, // 644
  { PseudoVC_V_IVV_SE_M4, VC_V_IVV, 0x2 }, // 645
  { PseudoVC_V_IVV_M8, VC_V_IVV, 0x3 }, // 646
  { PseudoVC_V_IVV_SE_M8, VC_V_IVV, 0x3 }, // 647
  { PseudoVC_V_IVV_MF8, VC_V_IVV, 0x5 }, // 648
  { PseudoVC_V_IVV_SE_MF8, VC_V_IVV, 0x5 }, // 649
  { PseudoVC_V_IVV_MF4, VC_V_IVV, 0x6 }, // 650
  { PseudoVC_V_IVV_SE_MF4, VC_V_IVV, 0x6 }, // 651
  { PseudoVC_V_IVV_MF2, VC_V_IVV, 0x7 }, // 652
  { PseudoVC_V_IVV_SE_MF2, VC_V_IVV, 0x7 }, // 653
  { PseudoVC_V_IVW_M1, VC_V_IVW, 0x0 }, // 654
  { PseudoVC_V_IVW_SE_M1, VC_V_IVW, 0x0 }, // 655
  { PseudoVC_V_IVW_M2, VC_V_IVW, 0x1 }, // 656
  { PseudoVC_V_IVW_SE_M2, VC_V_IVW, 0x1 }, // 657
  { PseudoVC_V_IVW_M4, VC_V_IVW, 0x2 }, // 658
  { PseudoVC_V_IVW_SE_M4, VC_V_IVW, 0x2 }, // 659
  { PseudoVC_V_IVW_MF8, VC_V_IVW, 0x5 }, // 660
  { PseudoVC_V_IVW_SE_MF8, VC_V_IVW, 0x5 }, // 661
  { PseudoVC_V_IVW_MF4, VC_V_IVW, 0x6 }, // 662
  { PseudoVC_V_IVW_SE_MF4, VC_V_IVW, 0x6 }, // 663
  { PseudoVC_V_IVW_MF2, VC_V_IVW, 0x7 }, // 664
  { PseudoVC_V_IVW_SE_MF2, VC_V_IVW, 0x7 }, // 665
  { PseudoVC_V_VV_M1, VC_V_VV, 0x0 }, // 666
  { PseudoVC_V_VV_SE_M1, VC_V_VV, 0x0 }, // 667
  { PseudoVC_V_VV_M2, VC_V_VV, 0x1 }, // 668
  { PseudoVC_V_VV_SE_M2, VC_V_VV, 0x1 }, // 669
  { PseudoVC_V_VV_M4, VC_V_VV, 0x2 }, // 670
  { PseudoVC_V_VV_SE_M4, VC_V_VV, 0x2 }, // 671
  { PseudoVC_V_VV_M8, VC_V_VV, 0x3 }, // 672
  { PseudoVC_V_VV_SE_M8, VC_V_VV, 0x3 }, // 673
  { PseudoVC_V_VV_MF8, VC_V_VV, 0x5 }, // 674
  { PseudoVC_V_VV_SE_MF8, VC_V_VV, 0x5 }, // 675
  { PseudoVC_V_VV_MF4, VC_V_VV, 0x6 }, // 676
  { PseudoVC_V_VV_SE_MF4, VC_V_VV, 0x6 }, // 677
  { PseudoVC_V_VV_MF2, VC_V_VV, 0x7 }, // 678
  { PseudoVC_V_VV_SE_MF2, VC_V_VV, 0x7 }, // 679
  { PseudoVC_V_VVV_M1, VC_V_VVV, 0x0 }, // 680
  { PseudoVC_V_VVV_SE_M1, VC_V_VVV, 0x0 }, // 681
  { PseudoVC_V_VVV_M2, VC_V_VVV, 0x1 }, // 682
  { PseudoVC_V_VVV_SE_M2, VC_V_VVV, 0x1 }, // 683
  { PseudoVC_V_VVV_M4, VC_V_VVV, 0x2 }, // 684
  { PseudoVC_V_VVV_SE_M4, VC_V_VVV, 0x2 }, // 685
  { PseudoVC_V_VVV_M8, VC_V_VVV, 0x3 }, // 686
  { PseudoVC_V_VVV_SE_M8, VC_V_VVV, 0x3 }, // 687
  { PseudoVC_V_VVV_MF8, VC_V_VVV, 0x5 }, // 688
  { PseudoVC_V_VVV_SE_MF8, VC_V_VVV, 0x5 }, // 689
  { PseudoVC_V_VVV_MF4, VC_V_VVV, 0x6 }, // 690
  { PseudoVC_V_VVV_SE_MF4, VC_V_VVV, 0x6 }, // 691
  { PseudoVC_V_VVV_MF2, VC_V_VVV, 0x7 }, // 692
  { PseudoVC_V_VVV_SE_MF2, VC_V_VVV, 0x7 }, // 693
  { PseudoVC_V_VVW_M1, VC_V_VVW, 0x0 }, // 694
  { PseudoVC_V_VVW_SE_M1, VC_V_VVW, 0x0 }, // 695
  { PseudoVC_V_VVW_M2, VC_V_VVW, 0x1 }, // 696
  { PseudoVC_V_VVW_SE_M2, VC_V_VVW, 0x1 }, // 697
  { PseudoVC_V_VVW_M4, VC_V_VVW, 0x2 }, // 698
  { PseudoVC_V_VVW_SE_M4, VC_V_VVW, 0x2 }, // 699
  { PseudoVC_V_VVW_MF8, VC_V_VVW, 0x5 }, // 700
  { PseudoVC_V_VVW_SE_MF8, VC_V_VVW, 0x5 }, // 701
  { PseudoVC_V_VVW_MF4, VC_V_VVW, 0x6 }, // 702
  { PseudoVC_V_VVW_SE_MF4, VC_V_VVW, 0x6 }, // 703
  { PseudoVC_V_VVW_MF2, VC_V_VVW, 0x7 }, // 704
  { PseudoVC_V_VVW_SE_MF2, VC_V_VVW, 0x7 }, // 705
  { PseudoVC_V_X_M1, VC_V_X, 0x0 }, // 706
  { PseudoVC_V_X_SE_M1, VC_V_X, 0x0 }, // 707
  { PseudoVC_V_X_M2, VC_V_X, 0x1 }, // 708
  { PseudoVC_V_X_SE_M2, VC_V_X, 0x1 }, // 709
  { PseudoVC_V_X_M4, VC_V_X, 0x2 }, // 710
  { PseudoVC_V_X_SE_M4, VC_V_X, 0x2 }, // 711
  { PseudoVC_V_X_M8, VC_V_X, 0x3 }, // 712
  { PseudoVC_V_X_SE_M8, VC_V_X, 0x3 }, // 713
  { PseudoVC_V_X_MF8, VC_V_X, 0x5 }, // 714
  { PseudoVC_V_X_SE_MF8, VC_V_X, 0x5 }, // 715
  { PseudoVC_V_X_MF4, VC_V_X, 0x6 }, // 716
  { PseudoVC_V_X_SE_MF4, VC_V_X, 0x6 }, // 717
  { PseudoVC_V_X_MF2, VC_V_X, 0x7 }, // 718
  { PseudoVC_V_X_SE_MF2, VC_V_X, 0x7 }, // 719
  { PseudoVC_V_XV_M1, VC_V_XV, 0x0 }, // 720
  { PseudoVC_V_XV_SE_M1, VC_V_XV, 0x0 }, // 721
  { PseudoVC_V_XV_M2, VC_V_XV, 0x1 }, // 722
  { PseudoVC_V_XV_SE_M2, VC_V_XV, 0x1 }, // 723
  { PseudoVC_V_XV_M4, VC_V_XV, 0x2 }, // 724
  { PseudoVC_V_XV_SE_M4, VC_V_XV, 0x2 }, // 725
  { PseudoVC_V_XV_M8, VC_V_XV, 0x3 }, // 726
  { PseudoVC_V_XV_SE_M8, VC_V_XV, 0x3 }, // 727
  { PseudoVC_V_XV_MF8, VC_V_XV, 0x5 }, // 728
  { PseudoVC_V_XV_SE_MF8, VC_V_XV, 0x5 }, // 729
  { PseudoVC_V_XV_MF4, VC_V_XV, 0x6 }, // 730
  { PseudoVC_V_XV_SE_MF4, VC_V_XV, 0x6 }, // 731
  { PseudoVC_V_XV_MF2, VC_V_XV, 0x7 }, // 732
  { PseudoVC_V_XV_SE_MF2, VC_V_XV, 0x7 }, // 733
  { PseudoVC_V_XVV_M1, VC_V_XVV, 0x0 }, // 734
  { PseudoVC_V_XVV_SE_M1, VC_V_XVV, 0x0 }, // 735
  { PseudoVC_V_XVV_M2, VC_V_XVV, 0x1 }, // 736
  { PseudoVC_V_XVV_SE_M2, VC_V_XVV, 0x1 }, // 737
  { PseudoVC_V_XVV_M4, VC_V_XVV, 0x2 }, // 738
  { PseudoVC_V_XVV_SE_M4, VC_V_XVV, 0x2 }, // 739
  { PseudoVC_V_XVV_M8, VC_V_XVV, 0x3 }, // 740
  { PseudoVC_V_XVV_SE_M8, VC_V_XVV, 0x3 }, // 741
  { PseudoVC_V_XVV_MF8, VC_V_XVV, 0x5 }, // 742
  { PseudoVC_V_XVV_SE_MF8, VC_V_XVV, 0x5 }, // 743
  { PseudoVC_V_XVV_MF4, VC_V_XVV, 0x6 }, // 744
  { PseudoVC_V_XVV_SE_MF4, VC_V_XVV, 0x6 }, // 745
  { PseudoVC_V_XVV_MF2, VC_V_XVV, 0x7 }, // 746
  { PseudoVC_V_XVV_SE_MF2, VC_V_XVV, 0x7 }, // 747
  { PseudoVC_V_XVW_M1, VC_V_XVW, 0x0 }, // 748
  { PseudoVC_V_XVW_SE_M1, VC_V_XVW, 0x0 }, // 749
  { PseudoVC_V_XVW_M2, VC_V_XVW, 0x1 }, // 750
  { PseudoVC_V_XVW_SE_M2, VC_V_XVW, 0x1 }, // 751
  { PseudoVC_V_XVW_M4, VC_V_XVW, 0x2 }, // 752
  { PseudoVC_V_XVW_SE_M4, VC_V_XVW, 0x2 }, // 753
  { PseudoVC_V_XVW_MF8, VC_V_XVW, 0x5 }, // 754
  { PseudoVC_V_XVW_SE_MF8, VC_V_XVW, 0x5 }, // 755
  { PseudoVC_V_XVW_MF4, VC_V_XVW, 0x6 }, // 756
  { PseudoVC_V_XVW_SE_MF4, VC_V_XVW, 0x6 }, // 757
  { PseudoVC_V_XVW_MF2, VC_V_XVW, 0x7 }, // 758
  { PseudoVC_V_XVW_SE_MF2, VC_V_XVW, 0x7 }, // 759
  { PseudoVC_X_SE_M1, VC_X, 0x0 }, // 760
  { PseudoVC_X_SE_M2, VC_X, 0x1 }, // 761
  { PseudoVC_X_SE_M4, VC_X, 0x2 }, // 762
  { PseudoVC_X_SE_M8, VC_X, 0x3 }, // 763
  { PseudoVC_X_SE_MF8, VC_X, 0x5 }, // 764
  { PseudoVC_X_SE_MF4, VC_X, 0x6 }, // 765
  { PseudoVC_X_SE_MF2, VC_X, 0x7 }, // 766
  { PseudoVC_XV_SE_M1, VC_XV, 0x0 }, // 767
  { PseudoVC_XV_SE_M2, VC_XV, 0x1 }, // 768
  { PseudoVC_XV_SE_M4, VC_XV, 0x2 }, // 769
  { PseudoVC_XV_SE_M8, VC_XV, 0x3 }, // 770
  { PseudoVC_XV_SE_MF8, VC_XV, 0x5 }, // 771
  { PseudoVC_XV_SE_MF4, VC_XV, 0x6 }, // 772
  { PseudoVC_XV_SE_MF2, VC_XV, 0x7 }, // 773
  { PseudoVC_XVV_SE_M1, VC_XVV, 0x0 }, // 774
  { PseudoVC_XVV_SE_M2, VC_XVV, 0x1 }, // 775
  { PseudoVC_XVV_SE_M4, VC_XVV, 0x2 }, // 776
  { PseudoVC_XVV_SE_M8, VC_XVV, 0x3 }, // 777
  { PseudoVC_XVV_SE_MF8, VC_XVV, 0x5 }, // 778
  { PseudoVC_XVV_SE_MF4, VC_XVV, 0x6 }, // 779
  { PseudoVC_XVV_SE_MF2, VC_XVV, 0x7 }, // 780
  { PseudoVC_XVW_SE_M1, VC_XVW, 0x0 }, // 781
  { PseudoVC_XVW_SE_M2, VC_XVW, 0x1 }, // 782
  { PseudoVC_XVW_SE_M4, VC_XVW, 0x2 }, // 783
  { PseudoVC_XVW_SE_MF8, VC_XVW, 0x5 }, // 784
  { PseudoVC_XVW_SE_MF4, VC_XVW, 0x6 }, // 785
  { PseudoVC_XVW_SE_MF2, VC_XVW, 0x7 }, // 786
  { PseudoVDIVU_VV_M1_E16, VDIVU_VV, 0x0 }, // 787
  { PseudoVDIVU_VV_M1_E16_MASK, VDIVU_VV, 0x0 }, // 788
  { PseudoVDIVU_VV_M1_E16_TU, VDIVU_VV, 0x0 }, // 789
  { PseudoVDIVU_VV_M1_E32, VDIVU_VV, 0x0 }, // 790
  { PseudoVDIVU_VV_M1_E32_MASK, VDIVU_VV, 0x0 }, // 791
  { PseudoVDIVU_VV_M1_E32_TU, VDIVU_VV, 0x0 }, // 792
  { PseudoVDIVU_VV_M1_E64, VDIVU_VV, 0x0 }, // 793
  { PseudoVDIVU_VV_M1_E64_MASK, VDIVU_VV, 0x0 }, // 794
  { PseudoVDIVU_VV_M1_E64_TU, VDIVU_VV, 0x0 }, // 795
  { PseudoVDIVU_VV_M1_E8, VDIVU_VV, 0x0 }, // 796
  { PseudoVDIVU_VV_M1_E8_MASK, VDIVU_VV, 0x0 }, // 797
  { PseudoVDIVU_VV_M1_E8_TU, VDIVU_VV, 0x0 }, // 798
  { PseudoVDIVU_VV_M2_E16, VDIVU_VV, 0x1 }, // 799
  { PseudoVDIVU_VV_M2_E16_MASK, VDIVU_VV, 0x1 }, // 800
  { PseudoVDIVU_VV_M2_E16_TU, VDIVU_VV, 0x1 }, // 801
  { PseudoVDIVU_VV_M2_E32, VDIVU_VV, 0x1 }, // 802
  { PseudoVDIVU_VV_M2_E32_MASK, VDIVU_VV, 0x1 }, // 803
  { PseudoVDIVU_VV_M2_E32_TU, VDIVU_VV, 0x1 }, // 804
  { PseudoVDIVU_VV_M2_E64, VDIVU_VV, 0x1 }, // 805
  { PseudoVDIVU_VV_M2_E64_MASK, VDIVU_VV, 0x1 }, // 806
  { PseudoVDIVU_VV_M2_E64_TU, VDIVU_VV, 0x1 }, // 807
  { PseudoVDIVU_VV_M2_E8, VDIVU_VV, 0x1 }, // 808
  { PseudoVDIVU_VV_M2_E8_MASK, VDIVU_VV, 0x1 }, // 809
  { PseudoVDIVU_VV_M2_E8_TU, VDIVU_VV, 0x1 }, // 810
  { PseudoVDIVU_VV_M4_E16, VDIVU_VV, 0x2 }, // 811
  { PseudoVDIVU_VV_M4_E16_MASK, VDIVU_VV, 0x2 }, // 812
  { PseudoVDIVU_VV_M4_E16_TU, VDIVU_VV, 0x2 }, // 813
  { PseudoVDIVU_VV_M4_E32, VDIVU_VV, 0x2 }, // 814
  { PseudoVDIVU_VV_M4_E32_MASK, VDIVU_VV, 0x2 }, // 815
  { PseudoVDIVU_VV_M4_E32_TU, VDIVU_VV, 0x2 }, // 816
  { PseudoVDIVU_VV_M4_E64, VDIVU_VV, 0x2 }, // 817
  { PseudoVDIVU_VV_M4_E64_MASK, VDIVU_VV, 0x2 }, // 818
  { PseudoVDIVU_VV_M4_E64_TU, VDIVU_VV, 0x2 }, // 819
  { PseudoVDIVU_VV_M4_E8, VDIVU_VV, 0x2 }, // 820
  { PseudoVDIVU_VV_M4_E8_MASK, VDIVU_VV, 0x2 }, // 821
  { PseudoVDIVU_VV_M4_E8_TU, VDIVU_VV, 0x2 }, // 822
  { PseudoVDIVU_VV_M8_E16, VDIVU_VV, 0x3 }, // 823
  { PseudoVDIVU_VV_M8_E16_MASK, VDIVU_VV, 0x3 }, // 824
  { PseudoVDIVU_VV_M8_E16_TU, VDIVU_VV, 0x3 }, // 825
  { PseudoVDIVU_VV_M8_E32, VDIVU_VV, 0x3 }, // 826
  { PseudoVDIVU_VV_M8_E32_MASK, VDIVU_VV, 0x3 }, // 827
  { PseudoVDIVU_VV_M8_E32_TU, VDIVU_VV, 0x3 }, // 828
  { PseudoVDIVU_VV_M8_E64, VDIVU_VV, 0x3 }, // 829
  { PseudoVDIVU_VV_M8_E64_MASK, VDIVU_VV, 0x3 }, // 830
  { PseudoVDIVU_VV_M8_E64_TU, VDIVU_VV, 0x3 }, // 831
  { PseudoVDIVU_VV_M8_E8, VDIVU_VV, 0x3 }, // 832
  { PseudoVDIVU_VV_M8_E8_MASK, VDIVU_VV, 0x3 }, // 833
  { PseudoVDIVU_VV_M8_E8_TU, VDIVU_VV, 0x3 }, // 834
  { PseudoVDIVU_VV_MF8_E8, VDIVU_VV, 0x5 }, // 835
  { PseudoVDIVU_VV_MF8_E8_MASK, VDIVU_VV, 0x5 }, // 836
  { PseudoVDIVU_VV_MF8_E8_TU, VDIVU_VV, 0x5 }, // 837
  { PseudoVDIVU_VV_MF4_E16, VDIVU_VV, 0x6 }, // 838
  { PseudoVDIVU_VV_MF4_E16_MASK, VDIVU_VV, 0x6 }, // 839
  { PseudoVDIVU_VV_MF4_E16_TU, VDIVU_VV, 0x6 }, // 840
  { PseudoVDIVU_VV_MF4_E8, VDIVU_VV, 0x6 }, // 841
  { PseudoVDIVU_VV_MF4_E8_MASK, VDIVU_VV, 0x6 }, // 842
  { PseudoVDIVU_VV_MF4_E8_TU, VDIVU_VV, 0x6 }, // 843
  { PseudoVDIVU_VV_MF2_E16, VDIVU_VV, 0x7 }, // 844
  { PseudoVDIVU_VV_MF2_E16_MASK, VDIVU_VV, 0x7 }, // 845
  { PseudoVDIVU_VV_MF2_E16_TU, VDIVU_VV, 0x7 }, // 846
  { PseudoVDIVU_VV_MF2_E32, VDIVU_VV, 0x7 }, // 847
  { PseudoVDIVU_VV_MF2_E32_MASK, VDIVU_VV, 0x7 }, // 848
  { PseudoVDIVU_VV_MF2_E32_TU, VDIVU_VV, 0x7 }, // 849
  { PseudoVDIVU_VV_MF2_E8, VDIVU_VV, 0x7 }, // 850
  { PseudoVDIVU_VV_MF2_E8_MASK, VDIVU_VV, 0x7 }, // 851
  { PseudoVDIVU_VV_MF2_E8_TU, VDIVU_VV, 0x7 }, // 852
  { PseudoVDIVU_VX_M1_E16, VDIVU_VX, 0x0 }, // 853
  { PseudoVDIVU_VX_M1_E16_MASK, VDIVU_VX, 0x0 }, // 854
  { PseudoVDIVU_VX_M1_E16_TU, VDIVU_VX, 0x0 }, // 855
  { PseudoVDIVU_VX_M1_E32, VDIVU_VX, 0x0 }, // 856
  { PseudoVDIVU_VX_M1_E32_MASK, VDIVU_VX, 0x0 }, // 857
  { PseudoVDIVU_VX_M1_E32_TU, VDIVU_VX, 0x0 }, // 858
  { PseudoVDIVU_VX_M1_E64, VDIVU_VX, 0x0 }, // 859
  { PseudoVDIVU_VX_M1_E64_MASK, VDIVU_VX, 0x0 }, // 860
  { PseudoVDIVU_VX_M1_E64_TU, VDIVU_VX, 0x0 }, // 861
  { PseudoVDIVU_VX_M1_E8, VDIVU_VX, 0x0 }, // 862
  { PseudoVDIVU_VX_M1_E8_MASK, VDIVU_VX, 0x0 }, // 863
  { PseudoVDIVU_VX_M1_E8_TU, VDIVU_VX, 0x0 }, // 864
  { PseudoVDIVU_VX_M2_E16, VDIVU_VX, 0x1 }, // 865
  { PseudoVDIVU_VX_M2_E16_MASK, VDIVU_VX, 0x1 }, // 866
  { PseudoVDIVU_VX_M2_E16_TU, VDIVU_VX, 0x1 }, // 867
  { PseudoVDIVU_VX_M2_E32, VDIVU_VX, 0x1 }, // 868
  { PseudoVDIVU_VX_M2_E32_MASK, VDIVU_VX, 0x1 }, // 869
  { PseudoVDIVU_VX_M2_E32_TU, VDIVU_VX, 0x1 }, // 870
  { PseudoVDIVU_VX_M2_E64, VDIVU_VX, 0x1 }, // 871
  { PseudoVDIVU_VX_M2_E64_MASK, VDIVU_VX, 0x1 }, // 872
  { PseudoVDIVU_VX_M2_E64_TU, VDIVU_VX, 0x1 }, // 873
  { PseudoVDIVU_VX_M2_E8, VDIVU_VX, 0x1 }, // 874
  { PseudoVDIVU_VX_M2_E8_MASK, VDIVU_VX, 0x1 }, // 875
  { PseudoVDIVU_VX_M2_E8_TU, VDIVU_VX, 0x1 }, // 876
  { PseudoVDIVU_VX_M4_E16, VDIVU_VX, 0x2 }, // 877
  { PseudoVDIVU_VX_M4_E16_MASK, VDIVU_VX, 0x2 }, // 878
  { PseudoVDIVU_VX_M4_E16_TU, VDIVU_VX, 0x2 }, // 879
  { PseudoVDIVU_VX_M4_E32, VDIVU_VX, 0x2 }, // 880
  { PseudoVDIVU_VX_M4_E32_MASK, VDIVU_VX, 0x2 }, // 881
  { PseudoVDIVU_VX_M4_E32_TU, VDIVU_VX, 0x2 }, // 882
  { PseudoVDIVU_VX_M4_E64, VDIVU_VX, 0x2 }, // 883
  { PseudoVDIVU_VX_M4_E64_MASK, VDIVU_VX, 0x2 }, // 884
  { PseudoVDIVU_VX_M4_E64_TU, VDIVU_VX, 0x2 }, // 885
  { PseudoVDIVU_VX_M4_E8, VDIVU_VX, 0x2 }, // 886
  { PseudoVDIVU_VX_M4_E8_MASK, VDIVU_VX, 0x2 }, // 887
  { PseudoVDIVU_VX_M4_E8_TU, VDIVU_VX, 0x2 }, // 888
  { PseudoVDIVU_VX_M8_E16, VDIVU_VX, 0x3 }, // 889
  { PseudoVDIVU_VX_M8_E16_MASK, VDIVU_VX, 0x3 }, // 890
  { PseudoVDIVU_VX_M8_E16_TU, VDIVU_VX, 0x3 }, // 891
  { PseudoVDIVU_VX_M8_E32, VDIVU_VX, 0x3 }, // 892
  { PseudoVDIVU_VX_M8_E32_MASK, VDIVU_VX, 0x3 }, // 893
  { PseudoVDIVU_VX_M8_E32_TU, VDIVU_VX, 0x3 }, // 894
  { PseudoVDIVU_VX_M8_E64, VDIVU_VX, 0x3 }, // 895
  { PseudoVDIVU_VX_M8_E64_MASK, VDIVU_VX, 0x3 }, // 896
  { PseudoVDIVU_VX_M8_E64_TU, VDIVU_VX, 0x3 }, // 897
  { PseudoVDIVU_VX_M8_E8, VDIVU_VX, 0x3 }, // 898
  { PseudoVDIVU_VX_M8_E8_MASK, VDIVU_VX, 0x3 }, // 899
  { PseudoVDIVU_VX_M8_E8_TU, VDIVU_VX, 0x3 }, // 900
  { PseudoVDIVU_VX_MF8_E8, VDIVU_VX, 0x5 }, // 901
  { PseudoVDIVU_VX_MF8_E8_MASK, VDIVU_VX, 0x5 }, // 902
  { PseudoVDIVU_VX_MF8_E8_TU, VDIVU_VX, 0x5 }, // 903
  { PseudoVDIVU_VX_MF4_E16, VDIVU_VX, 0x6 }, // 904
  { PseudoVDIVU_VX_MF4_E16_MASK, VDIVU_VX, 0x6 }, // 905
  { PseudoVDIVU_VX_MF4_E16_TU, VDIVU_VX, 0x6 }, // 906
  { PseudoVDIVU_VX_MF4_E8, VDIVU_VX, 0x6 }, // 907
  { PseudoVDIVU_VX_MF4_E8_MASK, VDIVU_VX, 0x6 }, // 908
  { PseudoVDIVU_VX_MF4_E8_TU, VDIVU_VX, 0x6 }, // 909
  { PseudoVDIVU_VX_MF2_E16, VDIVU_VX, 0x7 }, // 910
  { PseudoVDIVU_VX_MF2_E16_MASK, VDIVU_VX, 0x7 }, // 911
  { PseudoVDIVU_VX_MF2_E16_TU, VDIVU_VX, 0x7 }, // 912
  { PseudoVDIVU_VX_MF2_E32, VDIVU_VX, 0x7 }, // 913
  { PseudoVDIVU_VX_MF2_E32_MASK, VDIVU_VX, 0x7 }, // 914
  { PseudoVDIVU_VX_MF2_E32_TU, VDIVU_VX, 0x7 }, // 915
  { PseudoVDIVU_VX_MF2_E8, VDIVU_VX, 0x7 }, // 916
  { PseudoVDIVU_VX_MF2_E8_MASK, VDIVU_VX, 0x7 }, // 917
  { PseudoVDIVU_VX_MF2_E8_TU, VDIVU_VX, 0x7 }, // 918
  { PseudoVDIV_VV_M1_E16, VDIV_VV, 0x0 }, // 919
  { PseudoVDIV_VV_M1_E16_MASK, VDIV_VV, 0x0 }, // 920
  { PseudoVDIV_VV_M1_E16_TU, VDIV_VV, 0x0 }, // 921
  { PseudoVDIV_VV_M1_E32, VDIV_VV, 0x0 }, // 922
  { PseudoVDIV_VV_M1_E32_MASK, VDIV_VV, 0x0 }, // 923
  { PseudoVDIV_VV_M1_E32_TU, VDIV_VV, 0x0 }, // 924
  { PseudoVDIV_VV_M1_E64, VDIV_VV, 0x0 }, // 925
  { PseudoVDIV_VV_M1_E64_MASK, VDIV_VV, 0x0 }, // 926
  { PseudoVDIV_VV_M1_E64_TU, VDIV_VV, 0x0 }, // 927
  { PseudoVDIV_VV_M1_E8, VDIV_VV, 0x0 }, // 928
  { PseudoVDIV_VV_M1_E8_MASK, VDIV_VV, 0x0 }, // 929
  { PseudoVDIV_VV_M1_E8_TU, VDIV_VV, 0x0 }, // 930
  { PseudoVDIV_VV_M2_E16, VDIV_VV, 0x1 }, // 931
  { PseudoVDIV_VV_M2_E16_MASK, VDIV_VV, 0x1 }, // 932
  { PseudoVDIV_VV_M2_E16_TU, VDIV_VV, 0x1 }, // 933
  { PseudoVDIV_VV_M2_E32, VDIV_VV, 0x1 }, // 934
  { PseudoVDIV_VV_M2_E32_MASK, VDIV_VV, 0x1 }, // 935
  { PseudoVDIV_VV_M2_E32_TU, VDIV_VV, 0x1 }, // 936
  { PseudoVDIV_VV_M2_E64, VDIV_VV, 0x1 }, // 937
  { PseudoVDIV_VV_M2_E64_MASK, VDIV_VV, 0x1 }, // 938
  { PseudoVDIV_VV_M2_E64_TU, VDIV_VV, 0x1 }, // 939
  { PseudoVDIV_VV_M2_E8, VDIV_VV, 0x1 }, // 940
  { PseudoVDIV_VV_M2_E8_MASK, VDIV_VV, 0x1 }, // 941
  { PseudoVDIV_VV_M2_E8_TU, VDIV_VV, 0x1 }, // 942
  { PseudoVDIV_VV_M4_E16, VDIV_VV, 0x2 }, // 943
  { PseudoVDIV_VV_M4_E16_MASK, VDIV_VV, 0x2 }, // 944
  { PseudoVDIV_VV_M4_E16_TU, VDIV_VV, 0x2 }, // 945
  { PseudoVDIV_VV_M4_E32, VDIV_VV, 0x2 }, // 946
  { PseudoVDIV_VV_M4_E32_MASK, VDIV_VV, 0x2 }, // 947
  { PseudoVDIV_VV_M4_E32_TU, VDIV_VV, 0x2 }, // 948
  { PseudoVDIV_VV_M4_E64, VDIV_VV, 0x2 }, // 949
  { PseudoVDIV_VV_M4_E64_MASK, VDIV_VV, 0x2 }, // 950
  { PseudoVDIV_VV_M4_E64_TU, VDIV_VV, 0x2 }, // 951
  { PseudoVDIV_VV_M4_E8, VDIV_VV, 0x2 }, // 952
  { PseudoVDIV_VV_M4_E8_MASK, VDIV_VV, 0x2 }, // 953
  { PseudoVDIV_VV_M4_E8_TU, VDIV_VV, 0x2 }, // 954
  { PseudoVDIV_VV_M8_E16, VDIV_VV, 0x3 }, // 955
  { PseudoVDIV_VV_M8_E16_MASK, VDIV_VV, 0x3 }, // 956
  { PseudoVDIV_VV_M8_E16_TU, VDIV_VV, 0x3 }, // 957
  { PseudoVDIV_VV_M8_E32, VDIV_VV, 0x3 }, // 958
  { PseudoVDIV_VV_M8_E32_MASK, VDIV_VV, 0x3 }, // 959
  { PseudoVDIV_VV_M8_E32_TU, VDIV_VV, 0x3 }, // 960
  { PseudoVDIV_VV_M8_E64, VDIV_VV, 0x3 }, // 961
  { PseudoVDIV_VV_M8_E64_MASK, VDIV_VV, 0x3 }, // 962
  { PseudoVDIV_VV_M8_E64_TU, VDIV_VV, 0x3 }, // 963
  { PseudoVDIV_VV_M8_E8, VDIV_VV, 0x3 }, // 964
  { PseudoVDIV_VV_M8_E8_MASK, VDIV_VV, 0x3 }, // 965
  { PseudoVDIV_VV_M8_E8_TU, VDIV_VV, 0x3 }, // 966
  { PseudoVDIV_VV_MF8_E8, VDIV_VV, 0x5 }, // 967
  { PseudoVDIV_VV_MF8_E8_MASK, VDIV_VV, 0x5 }, // 968
  { PseudoVDIV_VV_MF8_E8_TU, VDIV_VV, 0x5 }, // 969
  { PseudoVDIV_VV_MF4_E16, VDIV_VV, 0x6 }, // 970
  { PseudoVDIV_VV_MF4_E16_MASK, VDIV_VV, 0x6 }, // 971
  { PseudoVDIV_VV_MF4_E16_TU, VDIV_VV, 0x6 }, // 972
  { PseudoVDIV_VV_MF4_E8, VDIV_VV, 0x6 }, // 973
  { PseudoVDIV_VV_MF4_E8_MASK, VDIV_VV, 0x6 }, // 974
  { PseudoVDIV_VV_MF4_E8_TU, VDIV_VV, 0x6 }, // 975
  { PseudoVDIV_VV_MF2_E16, VDIV_VV, 0x7 }, // 976
  { PseudoVDIV_VV_MF2_E16_MASK, VDIV_VV, 0x7 }, // 977
  { PseudoVDIV_VV_MF2_E16_TU, VDIV_VV, 0x7 }, // 978
  { PseudoVDIV_VV_MF2_E32, VDIV_VV, 0x7 }, // 979
  { PseudoVDIV_VV_MF2_E32_MASK, VDIV_VV, 0x7 }, // 980
  { PseudoVDIV_VV_MF2_E32_TU, VDIV_VV, 0x7 }, // 981
  { PseudoVDIV_VV_MF2_E8, VDIV_VV, 0x7 }, // 982
  { PseudoVDIV_VV_MF2_E8_MASK, VDIV_VV, 0x7 }, // 983
  { PseudoVDIV_VV_MF2_E8_TU, VDIV_VV, 0x7 }, // 984
  { PseudoVDIV_VX_M1_E16, VDIV_VX, 0x0 }, // 985
  { PseudoVDIV_VX_M1_E16_MASK, VDIV_VX, 0x0 }, // 986
  { PseudoVDIV_VX_M1_E16_TU, VDIV_VX, 0x0 }, // 987
  { PseudoVDIV_VX_M1_E32, VDIV_VX, 0x0 }, // 988
  { PseudoVDIV_VX_M1_E32_MASK, VDIV_VX, 0x0 }, // 989
  { PseudoVDIV_VX_M1_E32_TU, VDIV_VX, 0x0 }, // 990
  { PseudoVDIV_VX_M1_E64, VDIV_VX, 0x0 }, // 991
  { PseudoVDIV_VX_M1_E64_MASK, VDIV_VX, 0x0 }, // 992
  { PseudoVDIV_VX_M1_E64_TU, VDIV_VX, 0x0 }, // 993
  { PseudoVDIV_VX_M1_E8, VDIV_VX, 0x0 }, // 994
  { PseudoVDIV_VX_M1_E8_MASK, VDIV_VX, 0x0 }, // 995
  { PseudoVDIV_VX_M1_E8_TU, VDIV_VX, 0x0 }, // 996
  { PseudoVDIV_VX_M2_E16, VDIV_VX, 0x1 }, // 997
  { PseudoVDIV_VX_M2_E16_MASK, VDIV_VX, 0x1 }, // 998
  { PseudoVDIV_VX_M2_E16_TU, VDIV_VX, 0x1 }, // 999
  { PseudoVDIV_VX_M2_E32, VDIV_VX, 0x1 }, // 1000
  { PseudoVDIV_VX_M2_E32_MASK, VDIV_VX, 0x1 }, // 1001
  { PseudoVDIV_VX_M2_E32_TU, VDIV_VX, 0x1 }, // 1002
  { PseudoVDIV_VX_M2_E64, VDIV_VX, 0x1 }, // 1003
  { PseudoVDIV_VX_M2_E64_MASK, VDIV_VX, 0x1 }, // 1004
  { PseudoVDIV_VX_M2_E64_TU, VDIV_VX, 0x1 }, // 1005
  { PseudoVDIV_VX_M2_E8, VDIV_VX, 0x1 }, // 1006
  { PseudoVDIV_VX_M2_E8_MASK, VDIV_VX, 0x1 }, // 1007
  { PseudoVDIV_VX_M2_E8_TU, VDIV_VX, 0x1 }, // 1008
  { PseudoVDIV_VX_M4_E16, VDIV_VX, 0x2 }, // 1009
  { PseudoVDIV_VX_M4_E16_MASK, VDIV_VX, 0x2 }, // 1010
  { PseudoVDIV_VX_M4_E16_TU, VDIV_VX, 0x2 }, // 1011
  { PseudoVDIV_VX_M4_E32, VDIV_VX, 0x2 }, // 1012
  { PseudoVDIV_VX_M4_E32_MASK, VDIV_VX, 0x2 }, // 1013
  { PseudoVDIV_VX_M4_E32_TU, VDIV_VX, 0x2 }, // 1014
  { PseudoVDIV_VX_M4_E64, VDIV_VX, 0x2 }, // 1015
  { PseudoVDIV_VX_M4_E64_MASK, VDIV_VX, 0x2 }, // 1016
  { PseudoVDIV_VX_M4_E64_TU, VDIV_VX, 0x2 }, // 1017
  { PseudoVDIV_VX_M4_E8, VDIV_VX, 0x2 }, // 1018
  { PseudoVDIV_VX_M4_E8_MASK, VDIV_VX, 0x2 }, // 1019
  { PseudoVDIV_VX_M4_E8_TU, VDIV_VX, 0x2 }, // 1020
  { PseudoVDIV_VX_M8_E16, VDIV_VX, 0x3 }, // 1021
  { PseudoVDIV_VX_M8_E16_MASK, VDIV_VX, 0x3 }, // 1022
  { PseudoVDIV_VX_M8_E16_TU, VDIV_VX, 0x3 }, // 1023
  { PseudoVDIV_VX_M8_E32, VDIV_VX, 0x3 }, // 1024
  { PseudoVDIV_VX_M8_E32_MASK, VDIV_VX, 0x3 }, // 1025
  { PseudoVDIV_VX_M8_E32_TU, VDIV_VX, 0x3 }, // 1026
  { PseudoVDIV_VX_M8_E64, VDIV_VX, 0x3 }, // 1027
  { PseudoVDIV_VX_M8_E64_MASK, VDIV_VX, 0x3 }, // 1028
  { PseudoVDIV_VX_M8_E64_TU, VDIV_VX, 0x3 }, // 1029
  { PseudoVDIV_VX_M8_E8, VDIV_VX, 0x3 }, // 1030
  { PseudoVDIV_VX_M8_E8_MASK, VDIV_VX, 0x3 }, // 1031
  { PseudoVDIV_VX_M8_E8_TU, VDIV_VX, 0x3 }, // 1032
  { PseudoVDIV_VX_MF8_E8, VDIV_VX, 0x5 }, // 1033
  { PseudoVDIV_VX_MF8_E8_MASK, VDIV_VX, 0x5 }, // 1034
  { PseudoVDIV_VX_MF8_E8_TU, VDIV_VX, 0x5 }, // 1035
  { PseudoVDIV_VX_MF4_E16, VDIV_VX, 0x6 }, // 1036
  { PseudoVDIV_VX_MF4_E16_MASK, VDIV_VX, 0x6 }, // 1037
  { PseudoVDIV_VX_MF4_E16_TU, VDIV_VX, 0x6 }, // 1038
  { PseudoVDIV_VX_MF4_E8, VDIV_VX, 0x6 }, // 1039
  { PseudoVDIV_VX_MF4_E8_MASK, VDIV_VX, 0x6 }, // 1040
  { PseudoVDIV_VX_MF4_E8_TU, VDIV_VX, 0x6 }, // 1041
  { PseudoVDIV_VX_MF2_E16, VDIV_VX, 0x7 }, // 1042
  { PseudoVDIV_VX_MF2_E16_MASK, VDIV_VX, 0x7 }, // 1043
  { PseudoVDIV_VX_MF2_E16_TU, VDIV_VX, 0x7 }, // 1044
  { PseudoVDIV_VX_MF2_E32, VDIV_VX, 0x7 }, // 1045
  { PseudoVDIV_VX_MF2_E32_MASK, VDIV_VX, 0x7 }, // 1046
  { PseudoVDIV_VX_MF2_E32_TU, VDIV_VX, 0x7 }, // 1047
  { PseudoVDIV_VX_MF2_E8, VDIV_VX, 0x7 }, // 1048
  { PseudoVDIV_VX_MF2_E8_MASK, VDIV_VX, 0x7 }, // 1049
  { PseudoVDIV_VX_MF2_E8_TU, VDIV_VX, 0x7 }, // 1050
  { PseudoVFADD_VF16_M1, VFADD_VF, 0x0 }, // 1051
  { PseudoVFADD_VF16_M1_MASK, VFADD_VF, 0x0 }, // 1052
  { PseudoVFADD_VF16_M1_TU, VFADD_VF, 0x0 }, // 1053
  { PseudoVFADD_VF32_M1, VFADD_VF, 0x0 }, // 1054
  { PseudoVFADD_VF32_M1_MASK, VFADD_VF, 0x0 }, // 1055
  { PseudoVFADD_VF32_M1_TU, VFADD_VF, 0x0 }, // 1056
  { PseudoVFADD_VF64_M1, VFADD_VF, 0x0 }, // 1057
  { PseudoVFADD_VF64_M1_MASK, VFADD_VF, 0x0 }, // 1058
  { PseudoVFADD_VF64_M1_TU, VFADD_VF, 0x0 }, // 1059
  { PseudoVFADD_VF16_M2, VFADD_VF, 0x1 }, // 1060
  { PseudoVFADD_VF16_M2_MASK, VFADD_VF, 0x1 }, // 1061
  { PseudoVFADD_VF16_M2_TU, VFADD_VF, 0x1 }, // 1062
  { PseudoVFADD_VF32_M2, VFADD_VF, 0x1 }, // 1063
  { PseudoVFADD_VF32_M2_MASK, VFADD_VF, 0x1 }, // 1064
  { PseudoVFADD_VF32_M2_TU, VFADD_VF, 0x1 }, // 1065
  { PseudoVFADD_VF64_M2, VFADD_VF, 0x1 }, // 1066
  { PseudoVFADD_VF64_M2_MASK, VFADD_VF, 0x1 }, // 1067
  { PseudoVFADD_VF64_M2_TU, VFADD_VF, 0x1 }, // 1068
  { PseudoVFADD_VF16_M4, VFADD_VF, 0x2 }, // 1069
  { PseudoVFADD_VF16_M4_MASK, VFADD_VF, 0x2 }, // 1070
  { PseudoVFADD_VF16_M4_TU, VFADD_VF, 0x2 }, // 1071
  { PseudoVFADD_VF32_M4, VFADD_VF, 0x2 }, // 1072
  { PseudoVFADD_VF32_M4_MASK, VFADD_VF, 0x2 }, // 1073
  { PseudoVFADD_VF32_M4_TU, VFADD_VF, 0x2 }, // 1074
  { PseudoVFADD_VF64_M4, VFADD_VF, 0x2 }, // 1075
  { PseudoVFADD_VF64_M4_MASK, VFADD_VF, 0x2 }, // 1076
  { PseudoVFADD_VF64_M4_TU, VFADD_VF, 0x2 }, // 1077
  { PseudoVFADD_VF16_M8, VFADD_VF, 0x3 }, // 1078
  { PseudoVFADD_VF16_M8_MASK, VFADD_VF, 0x3 }, // 1079
  { PseudoVFADD_VF16_M8_TU, VFADD_VF, 0x3 }, // 1080
  { PseudoVFADD_VF32_M8, VFADD_VF, 0x3 }, // 1081
  { PseudoVFADD_VF32_M8_MASK, VFADD_VF, 0x3 }, // 1082
  { PseudoVFADD_VF32_M8_TU, VFADD_VF, 0x3 }, // 1083
  { PseudoVFADD_VF64_M8, VFADD_VF, 0x3 }, // 1084
  { PseudoVFADD_VF64_M8_MASK, VFADD_VF, 0x3 }, // 1085
  { PseudoVFADD_VF64_M8_TU, VFADD_VF, 0x3 }, // 1086
  { PseudoVFADD_VF16_MF4, VFADD_VF, 0x6 }, // 1087
  { PseudoVFADD_VF16_MF4_MASK, VFADD_VF, 0x6 }, // 1088
  { PseudoVFADD_VF16_MF4_TU, VFADD_VF, 0x6 }, // 1089
  { PseudoVFADD_VF16_MF2, VFADD_VF, 0x7 }, // 1090
  { PseudoVFADD_VF16_MF2_MASK, VFADD_VF, 0x7 }, // 1091
  { PseudoVFADD_VF16_MF2_TU, VFADD_VF, 0x7 }, // 1092
  { PseudoVFADD_VF32_MF2, VFADD_VF, 0x7 }, // 1093
  { PseudoVFADD_VF32_MF2_MASK, VFADD_VF, 0x7 }, // 1094
  { PseudoVFADD_VF32_MF2_TU, VFADD_VF, 0x7 }, // 1095
  { PseudoVFADD_VV_M1, VFADD_VV, 0x0 }, // 1096
  { PseudoVFADD_VV_M1_MASK, VFADD_VV, 0x0 }, // 1097
  { PseudoVFADD_VV_M1_TU, VFADD_VV, 0x0 }, // 1098
  { PseudoVFADD_VV_M2, VFADD_VV, 0x1 }, // 1099
  { PseudoVFADD_VV_M2_MASK, VFADD_VV, 0x1 }, // 1100
  { PseudoVFADD_VV_M2_TU, VFADD_VV, 0x1 }, // 1101
  { PseudoVFADD_VV_M4, VFADD_VV, 0x2 }, // 1102
  { PseudoVFADD_VV_M4_MASK, VFADD_VV, 0x2 }, // 1103
  { PseudoVFADD_VV_M4_TU, VFADD_VV, 0x2 }, // 1104
  { PseudoVFADD_VV_M8, VFADD_VV, 0x3 }, // 1105
  { PseudoVFADD_VV_M8_MASK, VFADD_VV, 0x3 }, // 1106
  { PseudoVFADD_VV_M8_TU, VFADD_VV, 0x3 }, // 1107
  { PseudoVFADD_VV_MF4, VFADD_VV, 0x6 }, // 1108
  { PseudoVFADD_VV_MF4_MASK, VFADD_VV, 0x6 }, // 1109
  { PseudoVFADD_VV_MF4_TU, VFADD_VV, 0x6 }, // 1110
  { PseudoVFADD_VV_MF2, VFADD_VV, 0x7 }, // 1111
  { PseudoVFADD_VV_MF2_MASK, VFADD_VV, 0x7 }, // 1112
  { PseudoVFADD_VV_MF2_TU, VFADD_VV, 0x7 }, // 1113
  { PseudoVFCLASS_V_M1, VFCLASS_V, 0x0 }, // 1114
  { PseudoVFCLASS_V_M1_MASK, VFCLASS_V, 0x0 }, // 1115
  { PseudoVFCLASS_V_M1_TU, VFCLASS_V, 0x0 }, // 1116
  { PseudoVFCLASS_V_M2, VFCLASS_V, 0x1 }, // 1117
  { PseudoVFCLASS_V_M2_MASK, VFCLASS_V, 0x1 }, // 1118
  { PseudoVFCLASS_V_M2_TU, VFCLASS_V, 0x1 }, // 1119
  { PseudoVFCLASS_V_M4, VFCLASS_V, 0x2 }, // 1120
  { PseudoVFCLASS_V_M4_MASK, VFCLASS_V, 0x2 }, // 1121
  { PseudoVFCLASS_V_M4_TU, VFCLASS_V, 0x2 }, // 1122
  { PseudoVFCLASS_V_M8, VFCLASS_V, 0x3 }, // 1123
  { PseudoVFCLASS_V_M8_MASK, VFCLASS_V, 0x3 }, // 1124
  { PseudoVFCLASS_V_M8_TU, VFCLASS_V, 0x3 }, // 1125
  { PseudoVFCLASS_V_MF4, VFCLASS_V, 0x6 }, // 1126
  { PseudoVFCLASS_V_MF4_MASK, VFCLASS_V, 0x6 }, // 1127
  { PseudoVFCLASS_V_MF4_TU, VFCLASS_V, 0x6 }, // 1128
  { PseudoVFCLASS_V_MF2, VFCLASS_V, 0x7 }, // 1129
  { PseudoVFCLASS_V_MF2_MASK, VFCLASS_V, 0x7 }, // 1130
  { PseudoVFCLASS_V_MF2_TU, VFCLASS_V, 0x7 }, // 1131
  { PseudoVFCVT_F_XU_V_M1, VFCVT_F_XU_V, 0x0 }, // 1132
  { PseudoVFCVT_F_XU_V_M1_MASK, VFCVT_F_XU_V, 0x0 }, // 1133
  { PseudoVFCVT_F_XU_V_M1_TU, VFCVT_F_XU_V, 0x0 }, // 1134
  { PseudoVFCVT_F_XU_V_M2, VFCVT_F_XU_V, 0x1 }, // 1135
  { PseudoVFCVT_F_XU_V_M2_MASK, VFCVT_F_XU_V, 0x1 }, // 1136
  { PseudoVFCVT_F_XU_V_M2_TU, VFCVT_F_XU_V, 0x1 }, // 1137
  { PseudoVFCVT_F_XU_V_M4, VFCVT_F_XU_V, 0x2 }, // 1138
  { PseudoVFCVT_F_XU_V_M4_MASK, VFCVT_F_XU_V, 0x2 }, // 1139
  { PseudoVFCVT_F_XU_V_M4_TU, VFCVT_F_XU_V, 0x2 }, // 1140
  { PseudoVFCVT_F_XU_V_M8, VFCVT_F_XU_V, 0x3 }, // 1141
  { PseudoVFCVT_F_XU_V_M8_MASK, VFCVT_F_XU_V, 0x3 }, // 1142
  { PseudoVFCVT_F_XU_V_M8_TU, VFCVT_F_XU_V, 0x3 }, // 1143
  { PseudoVFCVT_F_XU_V_MF4, VFCVT_F_XU_V, 0x6 }, // 1144
  { PseudoVFCVT_F_XU_V_MF4_MASK, VFCVT_F_XU_V, 0x6 }, // 1145
  { PseudoVFCVT_F_XU_V_MF4_TU, VFCVT_F_XU_V, 0x6 }, // 1146
  { PseudoVFCVT_F_XU_V_MF2, VFCVT_F_XU_V, 0x7 }, // 1147
  { PseudoVFCVT_F_XU_V_MF2_MASK, VFCVT_F_XU_V, 0x7 }, // 1148
  { PseudoVFCVT_F_XU_V_MF2_TU, VFCVT_F_XU_V, 0x7 }, // 1149
  { PseudoVFCVT_F_X_V_M1, VFCVT_F_X_V, 0x0 }, // 1150
  { PseudoVFCVT_F_X_V_M1_MASK, VFCVT_F_X_V, 0x0 }, // 1151
  { PseudoVFCVT_F_X_V_M1_TU, VFCVT_F_X_V, 0x0 }, // 1152
  { PseudoVFCVT_F_X_V_M2, VFCVT_F_X_V, 0x1 }, // 1153
  { PseudoVFCVT_F_X_V_M2_MASK, VFCVT_F_X_V, 0x1 }, // 1154
  { PseudoVFCVT_F_X_V_M2_TU, VFCVT_F_X_V, 0x1 }, // 1155
  { PseudoVFCVT_F_X_V_M4, VFCVT_F_X_V, 0x2 }, // 1156
  { PseudoVFCVT_F_X_V_M4_MASK, VFCVT_F_X_V, 0x2 }, // 1157
  { PseudoVFCVT_F_X_V_M4_TU, VFCVT_F_X_V, 0x2 }, // 1158
  { PseudoVFCVT_F_X_V_M8, VFCVT_F_X_V, 0x3 }, // 1159
  { PseudoVFCVT_F_X_V_M8_MASK, VFCVT_F_X_V, 0x3 }, // 1160
  { PseudoVFCVT_F_X_V_M8_TU, VFCVT_F_X_V, 0x3 }, // 1161
  { PseudoVFCVT_F_X_V_MF4, VFCVT_F_X_V, 0x6 }, // 1162
  { PseudoVFCVT_F_X_V_MF4_MASK, VFCVT_F_X_V, 0x6 }, // 1163
  { PseudoVFCVT_F_X_V_MF4_TU, VFCVT_F_X_V, 0x6 }, // 1164
  { PseudoVFCVT_F_X_V_MF2, VFCVT_F_X_V, 0x7 }, // 1165
  { PseudoVFCVT_F_X_V_MF2_MASK, VFCVT_F_X_V, 0x7 }, // 1166
  { PseudoVFCVT_F_X_V_MF2_TU, VFCVT_F_X_V, 0x7 }, // 1167
  { PseudoVFCVT_RTZ_XU_F_V_M1, VFCVT_RTZ_XU_F_V, 0x0 }, // 1168
  { PseudoVFCVT_RTZ_XU_F_V_M1_MASK, VFCVT_RTZ_XU_F_V, 0x0 }, // 1169
  { PseudoVFCVT_RTZ_XU_F_V_M1_TU, VFCVT_RTZ_XU_F_V, 0x0 }, // 1170
  { PseudoVFCVT_RTZ_XU_F_V_M2, VFCVT_RTZ_XU_F_V, 0x1 }, // 1171
  { PseudoVFCVT_RTZ_XU_F_V_M2_MASK, VFCVT_RTZ_XU_F_V, 0x1 }, // 1172
  { PseudoVFCVT_RTZ_XU_F_V_M2_TU, VFCVT_RTZ_XU_F_V, 0x1 }, // 1173
  { PseudoVFCVT_RTZ_XU_F_V_M4, VFCVT_RTZ_XU_F_V, 0x2 }, // 1174
  { PseudoVFCVT_RTZ_XU_F_V_M4_MASK, VFCVT_RTZ_XU_F_V, 0x2 }, // 1175
  { PseudoVFCVT_RTZ_XU_F_V_M4_TU, VFCVT_RTZ_XU_F_V, 0x2 }, // 1176
  { PseudoVFCVT_RTZ_XU_F_V_M8, VFCVT_RTZ_XU_F_V, 0x3 }, // 1177
  { PseudoVFCVT_RTZ_XU_F_V_M8_MASK, VFCVT_RTZ_XU_F_V, 0x3 }, // 1178
  { PseudoVFCVT_RTZ_XU_F_V_M8_TU, VFCVT_RTZ_XU_F_V, 0x3 }, // 1179
  { PseudoVFCVT_RTZ_XU_F_V_MF4, VFCVT_RTZ_XU_F_V, 0x6 }, // 1180
  { PseudoVFCVT_RTZ_XU_F_V_MF4_MASK, VFCVT_RTZ_XU_F_V, 0x6 }, // 1181
  { PseudoVFCVT_RTZ_XU_F_V_MF4_TU, VFCVT_RTZ_XU_F_V, 0x6 }, // 1182
  { PseudoVFCVT_RTZ_XU_F_V_MF2, VFCVT_RTZ_XU_F_V, 0x7 }, // 1183
  { PseudoVFCVT_RTZ_XU_F_V_MF2_MASK, VFCVT_RTZ_XU_F_V, 0x7 }, // 1184
  { PseudoVFCVT_RTZ_XU_F_V_MF2_TU, VFCVT_RTZ_XU_F_V, 0x7 }, // 1185
  { PseudoVFCVT_RTZ_X_F_V_M1, VFCVT_RTZ_X_F_V, 0x0 }, // 1186
  { PseudoVFCVT_RTZ_X_F_V_M1_MASK, VFCVT_RTZ_X_F_V, 0x0 }, // 1187
  { PseudoVFCVT_RTZ_X_F_V_M1_TU, VFCVT_RTZ_X_F_V, 0x0 }, // 1188
  { PseudoVFCVT_RTZ_X_F_V_M2, VFCVT_RTZ_X_F_V, 0x1 }, // 1189
  { PseudoVFCVT_RTZ_X_F_V_M2_MASK, VFCVT_RTZ_X_F_V, 0x1 }, // 1190
  { PseudoVFCVT_RTZ_X_F_V_M2_TU, VFCVT_RTZ_X_F_V, 0x1 }, // 1191
  { PseudoVFCVT_RTZ_X_F_V_M4, VFCVT_RTZ_X_F_V, 0x2 }, // 1192
  { PseudoVFCVT_RTZ_X_F_V_M4_MASK, VFCVT_RTZ_X_F_V, 0x2 }, // 1193
  { PseudoVFCVT_RTZ_X_F_V_M4_TU, VFCVT_RTZ_X_F_V, 0x2 }, // 1194
  { PseudoVFCVT_RTZ_X_F_V_M8, VFCVT_RTZ_X_F_V, 0x3 }, // 1195
  { PseudoVFCVT_RTZ_X_F_V_M8_MASK, VFCVT_RTZ_X_F_V, 0x3 }, // 1196
  { PseudoVFCVT_RTZ_X_F_V_M8_TU, VFCVT_RTZ_X_F_V, 0x3 }, // 1197
  { PseudoVFCVT_RTZ_X_F_V_MF4, VFCVT_RTZ_X_F_V, 0x6 }, // 1198
  { PseudoVFCVT_RTZ_X_F_V_MF4_MASK, VFCVT_RTZ_X_F_V, 0x6 }, // 1199
  { PseudoVFCVT_RTZ_X_F_V_MF4_TU, VFCVT_RTZ_X_F_V, 0x6 }, // 1200
  { PseudoVFCVT_RTZ_X_F_V_MF2, VFCVT_RTZ_X_F_V, 0x7 }, // 1201
  { PseudoVFCVT_RTZ_X_F_V_MF2_MASK, VFCVT_RTZ_X_F_V, 0x7 }, // 1202
  { PseudoVFCVT_RTZ_X_F_V_MF2_TU, VFCVT_RTZ_X_F_V, 0x7 }, // 1203
  { PseudoVFCVT_XU_F_V_M1, VFCVT_XU_F_V, 0x0 }, // 1204
  { PseudoVFCVT_XU_F_V_M1_MASK, VFCVT_XU_F_V, 0x0 }, // 1205
  { PseudoVFCVT_XU_F_V_M1_TU, VFCVT_XU_F_V, 0x0 }, // 1206
  { PseudoVFCVT_XU_F_V_M2, VFCVT_XU_F_V, 0x1 }, // 1207
  { PseudoVFCVT_XU_F_V_M2_MASK, VFCVT_XU_F_V, 0x1 }, // 1208
  { PseudoVFCVT_XU_F_V_M2_TU, VFCVT_XU_F_V, 0x1 }, // 1209
  { PseudoVFCVT_XU_F_V_M4, VFCVT_XU_F_V, 0x2 }, // 1210
  { PseudoVFCVT_XU_F_V_M4_MASK, VFCVT_XU_F_V, 0x2 }, // 1211
  { PseudoVFCVT_XU_F_V_M4_TU, VFCVT_XU_F_V, 0x2 }, // 1212
  { PseudoVFCVT_XU_F_V_M8, VFCVT_XU_F_V, 0x3 }, // 1213
  { PseudoVFCVT_XU_F_V_M8_MASK, VFCVT_XU_F_V, 0x3 }, // 1214
  { PseudoVFCVT_XU_F_V_M8_TU, VFCVT_XU_F_V, 0x3 }, // 1215
  { PseudoVFCVT_XU_F_V_MF4, VFCVT_XU_F_V, 0x6 }, // 1216
  { PseudoVFCVT_XU_F_V_MF4_MASK, VFCVT_XU_F_V, 0x6 }, // 1217
  { PseudoVFCVT_XU_F_V_MF4_TU, VFCVT_XU_F_V, 0x6 }, // 1218
  { PseudoVFCVT_XU_F_V_MF2, VFCVT_XU_F_V, 0x7 }, // 1219
  { PseudoVFCVT_XU_F_V_MF2_MASK, VFCVT_XU_F_V, 0x7 }, // 1220
  { PseudoVFCVT_XU_F_V_MF2_TU, VFCVT_XU_F_V, 0x7 }, // 1221
  { PseudoVFCVT_X_F_V_M1, VFCVT_X_F_V, 0x0 }, // 1222
  { PseudoVFCVT_X_F_V_M1_MASK, VFCVT_X_F_V, 0x0 }, // 1223
  { PseudoVFCVT_X_F_V_M1_TU, VFCVT_X_F_V, 0x0 }, // 1224
  { PseudoVFCVT_X_F_V_M2, VFCVT_X_F_V, 0x1 }, // 1225
  { PseudoVFCVT_X_F_V_M2_MASK, VFCVT_X_F_V, 0x1 }, // 1226
  { PseudoVFCVT_X_F_V_M2_TU, VFCVT_X_F_V, 0x1 }, // 1227
  { PseudoVFCVT_X_F_V_M4, VFCVT_X_F_V, 0x2 }, // 1228
  { PseudoVFCVT_X_F_V_M4_MASK, VFCVT_X_F_V, 0x2 }, // 1229
  { PseudoVFCVT_X_F_V_M4_TU, VFCVT_X_F_V, 0x2 }, // 1230
  { PseudoVFCVT_X_F_V_M8, VFCVT_X_F_V, 0x3 }, // 1231
  { PseudoVFCVT_X_F_V_M8_MASK, VFCVT_X_F_V, 0x3 }, // 1232
  { PseudoVFCVT_X_F_V_M8_TU, VFCVT_X_F_V, 0x3 }, // 1233
  { PseudoVFCVT_X_F_V_MF4, VFCVT_X_F_V, 0x6 }, // 1234
  { PseudoVFCVT_X_F_V_MF4_MASK, VFCVT_X_F_V, 0x6 }, // 1235
  { PseudoVFCVT_X_F_V_MF4_TU, VFCVT_X_F_V, 0x6 }, // 1236
  { PseudoVFCVT_X_F_V_MF2, VFCVT_X_F_V, 0x7 }, // 1237
  { PseudoVFCVT_X_F_V_MF2_MASK, VFCVT_X_F_V, 0x7 }, // 1238
  { PseudoVFCVT_X_F_V_MF2_TU, VFCVT_X_F_V, 0x7 }, // 1239
  { PseudoVFDIV_VF16_M1_E16, VFDIV_VF, 0x0 }, // 1240
  { PseudoVFDIV_VF16_M1_E16_MASK, VFDIV_VF, 0x0 }, // 1241
  { PseudoVFDIV_VF16_M1_E16_TU, VFDIV_VF, 0x0 }, // 1242
  { PseudoVFDIV_VF16_M1_E32, VFDIV_VF, 0x0 }, // 1243
  { PseudoVFDIV_VF16_M1_E32_MASK, VFDIV_VF, 0x0 }, // 1244
  { PseudoVFDIV_VF16_M1_E32_TU, VFDIV_VF, 0x0 }, // 1245
  { PseudoVFDIV_VF16_M1_E64, VFDIV_VF, 0x0 }, // 1246
  { PseudoVFDIV_VF16_M1_E64_MASK, VFDIV_VF, 0x0 }, // 1247
  { PseudoVFDIV_VF16_M1_E64_TU, VFDIV_VF, 0x0 }, // 1248
  { PseudoVFDIV_VF32_M1_E16, VFDIV_VF, 0x0 }, // 1249
  { PseudoVFDIV_VF32_M1_E16_MASK, VFDIV_VF, 0x0 }, // 1250
  { PseudoVFDIV_VF32_M1_E16_TU, VFDIV_VF, 0x0 }, // 1251
  { PseudoVFDIV_VF32_M1_E32, VFDIV_VF, 0x0 }, // 1252
  { PseudoVFDIV_VF32_M1_E32_MASK, VFDIV_VF, 0x0 }, // 1253
  { PseudoVFDIV_VF32_M1_E32_TU, VFDIV_VF, 0x0 }, // 1254
  { PseudoVFDIV_VF32_M1_E64, VFDIV_VF, 0x0 }, // 1255
  { PseudoVFDIV_VF32_M1_E64_MASK, VFDIV_VF, 0x0 }, // 1256
  { PseudoVFDIV_VF32_M1_E64_TU, VFDIV_VF, 0x0 }, // 1257
  { PseudoVFDIV_VF64_M1_E16, VFDIV_VF, 0x0 }, // 1258
  { PseudoVFDIV_VF64_M1_E16_MASK, VFDIV_VF, 0x0 }, // 1259
  { PseudoVFDIV_VF64_M1_E16_TU, VFDIV_VF, 0x0 }, // 1260
  { PseudoVFDIV_VF64_M1_E32, VFDIV_VF, 0x0 }, // 1261
  { PseudoVFDIV_VF64_M1_E32_MASK, VFDIV_VF, 0x0 }, // 1262
  { PseudoVFDIV_VF64_M1_E32_TU, VFDIV_VF, 0x0 }, // 1263
  { PseudoVFDIV_VF64_M1_E64, VFDIV_VF, 0x0 }, // 1264
  { PseudoVFDIV_VF64_M1_E64_MASK, VFDIV_VF, 0x0 }, // 1265
  { PseudoVFDIV_VF64_M1_E64_TU, VFDIV_VF, 0x0 }, // 1266
  { PseudoVFDIV_VF16_M2_E16, VFDIV_VF, 0x1 }, // 1267
  { PseudoVFDIV_VF16_M2_E16_MASK, VFDIV_VF, 0x1 }, // 1268
  { PseudoVFDIV_VF16_M2_E16_TU, VFDIV_VF, 0x1 }, // 1269
  { PseudoVFDIV_VF16_M2_E32, VFDIV_VF, 0x1 }, // 1270
  { PseudoVFDIV_VF16_M2_E32_MASK, VFDIV_VF, 0x1 }, // 1271
  { PseudoVFDIV_VF16_M2_E32_TU, VFDIV_VF, 0x1 }, // 1272
  { PseudoVFDIV_VF16_M2_E64, VFDIV_VF, 0x1 }, // 1273
  { PseudoVFDIV_VF16_M2_E64_MASK, VFDIV_VF, 0x1 }, // 1274
  { PseudoVFDIV_VF16_M2_E64_TU, VFDIV_VF, 0x1 }, // 1275
  { PseudoVFDIV_VF32_M2_E16, VFDIV_VF, 0x1 }, // 1276
  { PseudoVFDIV_VF32_M2_E16_MASK, VFDIV_VF, 0x1 }, // 1277
  { PseudoVFDIV_VF32_M2_E16_TU, VFDIV_VF, 0x1 }, // 1278
  { PseudoVFDIV_VF32_M2_E32, VFDIV_VF, 0x1 }, // 1279
  { PseudoVFDIV_VF32_M2_E32_MASK, VFDIV_VF, 0x1 }, // 1280
  { PseudoVFDIV_VF32_M2_E32_TU, VFDIV_VF, 0x1 }, // 1281
  { PseudoVFDIV_VF32_M2_E64, VFDIV_VF, 0x1 }, // 1282
  { PseudoVFDIV_VF32_M2_E64_MASK, VFDIV_VF, 0x1 }, // 1283
  { PseudoVFDIV_VF32_M2_E64_TU, VFDIV_VF, 0x1 }, // 1284
  { PseudoVFDIV_VF64_M2_E16, VFDIV_VF, 0x1 }, // 1285
  { PseudoVFDIV_VF64_M2_E16_MASK, VFDIV_VF, 0x1 }, // 1286
  { PseudoVFDIV_VF64_M2_E16_TU, VFDIV_VF, 0x1 }, // 1287
  { PseudoVFDIV_VF64_M2_E32, VFDIV_VF, 0x1 }, // 1288
  { PseudoVFDIV_VF64_M2_E32_MASK, VFDIV_VF, 0x1 }, // 1289
  { PseudoVFDIV_VF64_M2_E32_TU, VFDIV_VF, 0x1 }, // 1290
  { PseudoVFDIV_VF64_M2_E64, VFDIV_VF, 0x1 }, // 1291
  { PseudoVFDIV_VF64_M2_E64_MASK, VFDIV_VF, 0x1 }, // 1292
  { PseudoVFDIV_VF64_M2_E64_TU, VFDIV_VF, 0x1 }, // 1293
  { PseudoVFDIV_VF16_M4_E16, VFDIV_VF, 0x2 }, // 1294
  { PseudoVFDIV_VF16_M4_E16_MASK, VFDIV_VF, 0x2 }, // 1295
  { PseudoVFDIV_VF16_M4_E16_TU, VFDIV_VF, 0x2 }, // 1296
  { PseudoVFDIV_VF16_M4_E32, VFDIV_VF, 0x2 }, // 1297
  { PseudoVFDIV_VF16_M4_E32_MASK, VFDIV_VF, 0x2 }, // 1298
  { PseudoVFDIV_VF16_M4_E32_TU, VFDIV_VF, 0x2 }, // 1299
  { PseudoVFDIV_VF16_M4_E64, VFDIV_VF, 0x2 }, // 1300
  { PseudoVFDIV_VF16_M4_E64_MASK, VFDIV_VF, 0x2 }, // 1301
  { PseudoVFDIV_VF16_M4_E64_TU, VFDIV_VF, 0x2 }, // 1302
  { PseudoVFDIV_VF32_M4_E16, VFDIV_VF, 0x2 }, // 1303
  { PseudoVFDIV_VF32_M4_E16_MASK, VFDIV_VF, 0x2 }, // 1304
  { PseudoVFDIV_VF32_M4_E16_TU, VFDIV_VF, 0x2 }, // 1305
  { PseudoVFDIV_VF32_M4_E32, VFDIV_VF, 0x2 }, // 1306
  { PseudoVFDIV_VF32_M4_E32_MASK, VFDIV_VF, 0x2 }, // 1307
  { PseudoVFDIV_VF32_M4_E32_TU, VFDIV_VF, 0x2 }, // 1308
  { PseudoVFDIV_VF32_M4_E64, VFDIV_VF, 0x2 }, // 1309
  { PseudoVFDIV_VF32_M4_E64_MASK, VFDIV_VF, 0x2 }, // 1310
  { PseudoVFDIV_VF32_M4_E64_TU, VFDIV_VF, 0x2 }, // 1311
  { PseudoVFDIV_VF64_M4_E16, VFDIV_VF, 0x2 }, // 1312
  { PseudoVFDIV_VF64_M4_E16_MASK, VFDIV_VF, 0x2 }, // 1313
  { PseudoVFDIV_VF64_M4_E16_TU, VFDIV_VF, 0x2 }, // 1314
  { PseudoVFDIV_VF64_M4_E32, VFDIV_VF, 0x2 }, // 1315
  { PseudoVFDIV_VF64_M4_E32_MASK, VFDIV_VF, 0x2 }, // 1316
  { PseudoVFDIV_VF64_M4_E32_TU, VFDIV_VF, 0x2 }, // 1317
  { PseudoVFDIV_VF64_M4_E64, VFDIV_VF, 0x2 }, // 1318
  { PseudoVFDIV_VF64_M4_E64_MASK, VFDIV_VF, 0x2 }, // 1319
  { PseudoVFDIV_VF64_M4_E64_TU, VFDIV_VF, 0x2 }, // 1320
  { PseudoVFDIV_VF16_M8_E16, VFDIV_VF, 0x3 }, // 1321
  { PseudoVFDIV_VF16_M8_E16_MASK, VFDIV_VF, 0x3 }, // 1322
  { PseudoVFDIV_VF16_M8_E16_TU, VFDIV_VF, 0x3 }, // 1323
  { PseudoVFDIV_VF16_M8_E32, VFDIV_VF, 0x3 }, // 1324
  { PseudoVFDIV_VF16_M8_E32_MASK, VFDIV_VF, 0x3 }, // 1325
  { PseudoVFDIV_VF16_M8_E32_TU, VFDIV_VF, 0x3 }, // 1326
  { PseudoVFDIV_VF16_M8_E64, VFDIV_VF, 0x3 }, // 1327
  { PseudoVFDIV_VF16_M8_E64_MASK, VFDIV_VF, 0x3 }, // 1328
  { PseudoVFDIV_VF16_M8_E64_TU, VFDIV_VF, 0x3 }, // 1329
  { PseudoVFDIV_VF32_M8_E16, VFDIV_VF, 0x3 }, // 1330
  { PseudoVFDIV_VF32_M8_E16_MASK, VFDIV_VF, 0x3 }, // 1331
  { PseudoVFDIV_VF32_M8_E16_TU, VFDIV_VF, 0x3 }, // 1332
  { PseudoVFDIV_VF32_M8_E32, VFDIV_VF, 0x3 }, // 1333
  { PseudoVFDIV_VF32_M8_E32_MASK, VFDIV_VF, 0x3 }, // 1334
  { PseudoVFDIV_VF32_M8_E32_TU, VFDIV_VF, 0x3 }, // 1335
  { PseudoVFDIV_VF32_M8_E64, VFDIV_VF, 0x3 }, // 1336
  { PseudoVFDIV_VF32_M8_E64_MASK, VFDIV_VF, 0x3 }, // 1337
  { PseudoVFDIV_VF32_M8_E64_TU, VFDIV_VF, 0x3 }, // 1338
  { PseudoVFDIV_VF64_M8_E16, VFDIV_VF, 0x3 }, // 1339
  { PseudoVFDIV_VF64_M8_E16_MASK, VFDIV_VF, 0x3 }, // 1340
  { PseudoVFDIV_VF64_M8_E16_TU, VFDIV_VF, 0x3 }, // 1341
  { PseudoVFDIV_VF64_M8_E32, VFDIV_VF, 0x3 }, // 1342
  { PseudoVFDIV_VF64_M8_E32_MASK, VFDIV_VF, 0x3 }, // 1343
  { PseudoVFDIV_VF64_M8_E32_TU, VFDIV_VF, 0x3 }, // 1344
  { PseudoVFDIV_VF64_M8_E64, VFDIV_VF, 0x3 }, // 1345
  { PseudoVFDIV_VF64_M8_E64_MASK, VFDIV_VF, 0x3 }, // 1346
  { PseudoVFDIV_VF64_M8_E64_TU, VFDIV_VF, 0x3 }, // 1347
  { PseudoVFDIV_VF16_MF4_E16, VFDIV_VF, 0x6 }, // 1348
  { PseudoVFDIV_VF16_MF4_E16_MASK, VFDIV_VF, 0x6 }, // 1349
  { PseudoVFDIV_VF16_MF4_E16_TU, VFDIV_VF, 0x6 }, // 1350
  { PseudoVFDIV_VF16_MF2_E16, VFDIV_VF, 0x7 }, // 1351
  { PseudoVFDIV_VF16_MF2_E16_MASK, VFDIV_VF, 0x7 }, // 1352
  { PseudoVFDIV_VF16_MF2_E16_TU, VFDIV_VF, 0x7 }, // 1353
  { PseudoVFDIV_VF16_MF2_E32, VFDIV_VF, 0x7 }, // 1354
  { PseudoVFDIV_VF16_MF2_E32_MASK, VFDIV_VF, 0x7 }, // 1355
  { PseudoVFDIV_VF16_MF2_E32_TU, VFDIV_VF, 0x7 }, // 1356
  { PseudoVFDIV_VF32_MF2_E16, VFDIV_VF, 0x7 }, // 1357
  { PseudoVFDIV_VF32_MF2_E16_MASK, VFDIV_VF, 0x7 }, // 1358
  { PseudoVFDIV_VF32_MF2_E16_TU, VFDIV_VF, 0x7 }, // 1359
  { PseudoVFDIV_VF32_MF2_E32, VFDIV_VF, 0x7 }, // 1360
  { PseudoVFDIV_VF32_MF2_E32_MASK, VFDIV_VF, 0x7 }, // 1361
  { PseudoVFDIV_VF32_MF2_E32_TU, VFDIV_VF, 0x7 }, // 1362
  { PseudoVFDIV_VV_M1_E16, VFDIV_VV, 0x0 }, // 1363
  { PseudoVFDIV_VV_M1_E16_MASK, VFDIV_VV, 0x0 }, // 1364
  { PseudoVFDIV_VV_M1_E16_TU, VFDIV_VV, 0x0 }, // 1365
  { PseudoVFDIV_VV_M1_E32, VFDIV_VV, 0x0 }, // 1366
  { PseudoVFDIV_VV_M1_E32_MASK, VFDIV_VV, 0x0 }, // 1367
  { PseudoVFDIV_VV_M1_E32_TU, VFDIV_VV, 0x0 }, // 1368
  { PseudoVFDIV_VV_M1_E64, VFDIV_VV, 0x0 }, // 1369
  { PseudoVFDIV_VV_M1_E64_MASK, VFDIV_VV, 0x0 }, // 1370
  { PseudoVFDIV_VV_M1_E64_TU, VFDIV_VV, 0x0 }, // 1371
  { PseudoVFDIV_VV_M2_E16, VFDIV_VV, 0x1 }, // 1372
  { PseudoVFDIV_VV_M2_E16_MASK, VFDIV_VV, 0x1 }, // 1373
  { PseudoVFDIV_VV_M2_E16_TU, VFDIV_VV, 0x1 }, // 1374
  { PseudoVFDIV_VV_M2_E32, VFDIV_VV, 0x1 }, // 1375
  { PseudoVFDIV_VV_M2_E32_MASK, VFDIV_VV, 0x1 }, // 1376
  { PseudoVFDIV_VV_M2_E32_TU, VFDIV_VV, 0x1 }, // 1377
  { PseudoVFDIV_VV_M2_E64, VFDIV_VV, 0x1 }, // 1378
  { PseudoVFDIV_VV_M2_E64_MASK, VFDIV_VV, 0x1 }, // 1379
  { PseudoVFDIV_VV_M2_E64_TU, VFDIV_VV, 0x1 }, // 1380
  { PseudoVFDIV_VV_M4_E16, VFDIV_VV, 0x2 }, // 1381
  { PseudoVFDIV_VV_M4_E16_MASK, VFDIV_VV, 0x2 }, // 1382
  { PseudoVFDIV_VV_M4_E16_TU, VFDIV_VV, 0x2 }, // 1383
  { PseudoVFDIV_VV_M4_E32, VFDIV_VV, 0x2 }, // 1384
  { PseudoVFDIV_VV_M4_E32_MASK, VFDIV_VV, 0x2 }, // 1385
  { PseudoVFDIV_VV_M4_E32_TU, VFDIV_VV, 0x2 }, // 1386
  { PseudoVFDIV_VV_M4_E64, VFDIV_VV, 0x2 }, // 1387
  { PseudoVFDIV_VV_M4_E64_MASK, VFDIV_VV, 0x2 }, // 1388
  { PseudoVFDIV_VV_M4_E64_TU, VFDIV_VV, 0x2 }, // 1389
  { PseudoVFDIV_VV_M8_E16, VFDIV_VV, 0x3 }, // 1390
  { PseudoVFDIV_VV_M8_E16_MASK, VFDIV_VV, 0x3 }, // 1391
  { PseudoVFDIV_VV_M8_E16_TU, VFDIV_VV, 0x3 }, // 1392
  { PseudoVFDIV_VV_M8_E32, VFDIV_VV, 0x3 }, // 1393
  { PseudoVFDIV_VV_M8_E32_MASK, VFDIV_VV, 0x3 }, // 1394
  { PseudoVFDIV_VV_M8_E32_TU, VFDIV_VV, 0x3 }, // 1395
  { PseudoVFDIV_VV_M8_E64, VFDIV_VV, 0x3 }, // 1396
  { PseudoVFDIV_VV_M8_E64_MASK, VFDIV_VV, 0x3 }, // 1397
  { PseudoVFDIV_VV_M8_E64_TU, VFDIV_VV, 0x3 }, // 1398
  { PseudoVFDIV_VV_MF4_E16, VFDIV_VV, 0x6 }, // 1399
  { PseudoVFDIV_VV_MF4_E16_MASK, VFDIV_VV, 0x6 }, // 1400
  { PseudoVFDIV_VV_MF4_E16_TU, VFDIV_VV, 0x6 }, // 1401
  { PseudoVFDIV_VV_MF2_E16, VFDIV_VV, 0x7 }, // 1402
  { PseudoVFDIV_VV_MF2_E16_MASK, VFDIV_VV, 0x7 }, // 1403
  { PseudoVFDIV_VV_MF2_E16_TU, VFDIV_VV, 0x7 }, // 1404
  { PseudoVFDIV_VV_MF2_E32, VFDIV_VV, 0x7 }, // 1405
  { PseudoVFDIV_VV_MF2_E32_MASK, VFDIV_VV, 0x7 }, // 1406
  { PseudoVFDIV_VV_MF2_E32_TU, VFDIV_VV, 0x7 }, // 1407
  { PseudoVFIRST_M_B8, VFIRST_M, 0x0 }, // 1408
  { PseudoVFIRST_M_B8_MASK, VFIRST_M, 0x0 }, // 1409
  { PseudoVFIRST_M_B16, VFIRST_M, 0x1 }, // 1410
  { PseudoVFIRST_M_B16_MASK, VFIRST_M, 0x1 }, // 1411
  { PseudoVFIRST_M_B32, VFIRST_M, 0x2 }, // 1412
  { PseudoVFIRST_M_B32_MASK, VFIRST_M, 0x2 }, // 1413
  { PseudoVFIRST_M_B64, VFIRST_M, 0x3 }, // 1414
  { PseudoVFIRST_M_B64_MASK, VFIRST_M, 0x3 }, // 1415
  { PseudoVFIRST_M_B1, VFIRST_M, 0x5 }, // 1416
  { PseudoVFIRST_M_B1_MASK, VFIRST_M, 0x5 }, // 1417
  { PseudoVFIRST_M_B2, VFIRST_M, 0x6 }, // 1418
  { PseudoVFIRST_M_B2_MASK, VFIRST_M, 0x6 }, // 1419
  { PseudoVFIRST_M_B4, VFIRST_M, 0x7 }, // 1420
  { PseudoVFIRST_M_B4_MASK, VFIRST_M, 0x7 }, // 1421
  { PseudoVFMACC_VF16_M1, VFMACC_VF, 0x0 }, // 1422
  { PseudoVFMACC_VF16_M1_MASK, VFMACC_VF, 0x0 }, // 1423
  { PseudoVFMACC_VF32_M1, VFMACC_VF, 0x0 }, // 1424
  { PseudoVFMACC_VF32_M1_MASK, VFMACC_VF, 0x0 }, // 1425
  { PseudoVFMACC_VF64_M1, VFMACC_VF, 0x0 }, // 1426
  { PseudoVFMACC_VF64_M1_MASK, VFMACC_VF, 0x0 }, // 1427
  { PseudoVFMACC_VF16_M2, VFMACC_VF, 0x1 }, // 1428
  { PseudoVFMACC_VF16_M2_MASK, VFMACC_VF, 0x1 }, // 1429
  { PseudoVFMACC_VF32_M2, VFMACC_VF, 0x1 }, // 1430
  { PseudoVFMACC_VF32_M2_MASK, VFMACC_VF, 0x1 }, // 1431
  { PseudoVFMACC_VF64_M2, VFMACC_VF, 0x1 }, // 1432
  { PseudoVFMACC_VF64_M2_MASK, VFMACC_VF, 0x1 }, // 1433
  { PseudoVFMACC_VF16_M4, VFMACC_VF, 0x2 }, // 1434
  { PseudoVFMACC_VF16_M4_MASK, VFMACC_VF, 0x2 }, // 1435
  { PseudoVFMACC_VF32_M4, VFMACC_VF, 0x2 }, // 1436
  { PseudoVFMACC_VF32_M4_MASK, VFMACC_VF, 0x2 }, // 1437
  { PseudoVFMACC_VF64_M4, VFMACC_VF, 0x2 }, // 1438
  { PseudoVFMACC_VF64_M4_MASK, VFMACC_VF, 0x2 }, // 1439
  { PseudoVFMACC_VF16_M8, VFMACC_VF, 0x3 }, // 1440
  { PseudoVFMACC_VF16_M8_MASK, VFMACC_VF, 0x3 }, // 1441
  { PseudoVFMACC_VF32_M8, VFMACC_VF, 0x3 }, // 1442
  { PseudoVFMACC_VF32_M8_MASK, VFMACC_VF, 0x3 }, // 1443
  { PseudoVFMACC_VF64_M8, VFMACC_VF, 0x3 }, // 1444
  { PseudoVFMACC_VF64_M8_MASK, VFMACC_VF, 0x3 }, // 1445
  { PseudoVFMACC_VF16_MF4, VFMACC_VF, 0x6 }, // 1446
  { PseudoVFMACC_VF16_MF4_MASK, VFMACC_VF, 0x6 }, // 1447
  { PseudoVFMACC_VF16_MF2, VFMACC_VF, 0x7 }, // 1448
  { PseudoVFMACC_VF16_MF2_MASK, VFMACC_VF, 0x7 }, // 1449
  { PseudoVFMACC_VF32_MF2, VFMACC_VF, 0x7 }, // 1450
  { PseudoVFMACC_VF32_MF2_MASK, VFMACC_VF, 0x7 }, // 1451
  { PseudoVFMACC_VV_M1, VFMACC_VV, 0x0 }, // 1452
  { PseudoVFMACC_VV_M1_MASK, VFMACC_VV, 0x0 }, // 1453
  { PseudoVFMACC_VV_M2, VFMACC_VV, 0x1 }, // 1454
  { PseudoVFMACC_VV_M2_MASK, VFMACC_VV, 0x1 }, // 1455
  { PseudoVFMACC_VV_M4, VFMACC_VV, 0x2 }, // 1456
  { PseudoVFMACC_VV_M4_MASK, VFMACC_VV, 0x2 }, // 1457
  { PseudoVFMACC_VV_M8, VFMACC_VV, 0x3 }, // 1458
  { PseudoVFMACC_VV_M8_MASK, VFMACC_VV, 0x3 }, // 1459
  { PseudoVFMACC_VV_MF4, VFMACC_VV, 0x6 }, // 1460
  { PseudoVFMACC_VV_MF4_MASK, VFMACC_VV, 0x6 }, // 1461
  { PseudoVFMACC_VV_MF2, VFMACC_VV, 0x7 }, // 1462
  { PseudoVFMACC_VV_MF2_MASK, VFMACC_VV, 0x7 }, // 1463
  { PseudoVFMADD_VF16_M1, VFMADD_VF, 0x0 }, // 1464
  { PseudoVFMADD_VF16_M1_MASK, VFMADD_VF, 0x0 }, // 1465
  { PseudoVFMADD_VF32_M1, VFMADD_VF, 0x0 }, // 1466
  { PseudoVFMADD_VF32_M1_MASK, VFMADD_VF, 0x0 }, // 1467
  { PseudoVFMADD_VF64_M1, VFMADD_VF, 0x0 }, // 1468
  { PseudoVFMADD_VF64_M1_MASK, VFMADD_VF, 0x0 }, // 1469
  { PseudoVFMADD_VF16_M2, VFMADD_VF, 0x1 }, // 1470
  { PseudoVFMADD_VF16_M2_MASK, VFMADD_VF, 0x1 }, // 1471
  { PseudoVFMADD_VF32_M2, VFMADD_VF, 0x1 }, // 1472
  { PseudoVFMADD_VF32_M2_MASK, VFMADD_VF, 0x1 }, // 1473
  { PseudoVFMADD_VF64_M2, VFMADD_VF, 0x1 }, // 1474
  { PseudoVFMADD_VF64_M2_MASK, VFMADD_VF, 0x1 }, // 1475
  { PseudoVFMADD_VF16_M4, VFMADD_VF, 0x2 }, // 1476
  { PseudoVFMADD_VF16_M4_MASK, VFMADD_VF, 0x2 }, // 1477
  { PseudoVFMADD_VF32_M4, VFMADD_VF, 0x2 }, // 1478
  { PseudoVFMADD_VF32_M4_MASK, VFMADD_VF, 0x2 }, // 1479
  { PseudoVFMADD_VF64_M4, VFMADD_VF, 0x2 }, // 1480
  { PseudoVFMADD_VF64_M4_MASK, VFMADD_VF, 0x2 }, // 1481
  { PseudoVFMADD_VF16_M8, VFMADD_VF, 0x3 }, // 1482
  { PseudoVFMADD_VF16_M8_MASK, VFMADD_VF, 0x3 }, // 1483
  { PseudoVFMADD_VF32_M8, VFMADD_VF, 0x3 }, // 1484
  { PseudoVFMADD_VF32_M8_MASK, VFMADD_VF, 0x3 }, // 1485
  { PseudoVFMADD_VF64_M8, VFMADD_VF, 0x3 }, // 1486
  { PseudoVFMADD_VF64_M8_MASK, VFMADD_VF, 0x3 }, // 1487
  { PseudoVFMADD_VF16_MF4, VFMADD_VF, 0x6 }, // 1488
  { PseudoVFMADD_VF16_MF4_MASK, VFMADD_VF, 0x6 }, // 1489
  { PseudoVFMADD_VF16_MF2, VFMADD_VF, 0x7 }, // 1490
  { PseudoVFMADD_VF16_MF2_MASK, VFMADD_VF, 0x7 }, // 1491
  { PseudoVFMADD_VF32_MF2, VFMADD_VF, 0x7 }, // 1492
  { PseudoVFMADD_VF32_MF2_MASK, VFMADD_VF, 0x7 }, // 1493
  { PseudoVFMADD_VV_M1, VFMADD_VV, 0x0 }, // 1494
  { PseudoVFMADD_VV_M1_MASK, VFMADD_VV, 0x0 }, // 1495
  { PseudoVFMADD_VV_M2, VFMADD_VV, 0x1 }, // 1496
  { PseudoVFMADD_VV_M2_MASK, VFMADD_VV, 0x1 }, // 1497
  { PseudoVFMADD_VV_M4, VFMADD_VV, 0x2 }, // 1498
  { PseudoVFMADD_VV_M4_MASK, VFMADD_VV, 0x2 }, // 1499
  { PseudoVFMADD_VV_M8, VFMADD_VV, 0x3 }, // 1500
  { PseudoVFMADD_VV_M8_MASK, VFMADD_VV, 0x3 }, // 1501
  { PseudoVFMADD_VV_MF4, VFMADD_VV, 0x6 }, // 1502
  { PseudoVFMADD_VV_MF4_MASK, VFMADD_VV, 0x6 }, // 1503
  { PseudoVFMADD_VV_MF2, VFMADD_VV, 0x7 }, // 1504
  { PseudoVFMADD_VV_MF2_MASK, VFMADD_VV, 0x7 }, // 1505
  { PseudoVFMAX_VF16_M1, VFMAX_VF, 0x0 }, // 1506
  { PseudoVFMAX_VF16_M1_MASK, VFMAX_VF, 0x0 }, // 1507
  { PseudoVFMAX_VF16_M1_TU, VFMAX_VF, 0x0 }, // 1508
  { PseudoVFMAX_VF32_M1, VFMAX_VF, 0x0 }, // 1509
  { PseudoVFMAX_VF32_M1_MASK, VFMAX_VF, 0x0 }, // 1510
  { PseudoVFMAX_VF32_M1_TU, VFMAX_VF, 0x0 }, // 1511
  { PseudoVFMAX_VF64_M1, VFMAX_VF, 0x0 }, // 1512
  { PseudoVFMAX_VF64_M1_MASK, VFMAX_VF, 0x0 }, // 1513
  { PseudoVFMAX_VF64_M1_TU, VFMAX_VF, 0x0 }, // 1514
  { PseudoVFMAX_VF16_M2, VFMAX_VF, 0x1 }, // 1515
  { PseudoVFMAX_VF16_M2_MASK, VFMAX_VF, 0x1 }, // 1516
  { PseudoVFMAX_VF16_M2_TU, VFMAX_VF, 0x1 }, // 1517
  { PseudoVFMAX_VF32_M2, VFMAX_VF, 0x1 }, // 1518
  { PseudoVFMAX_VF32_M2_MASK, VFMAX_VF, 0x1 }, // 1519
  { PseudoVFMAX_VF32_M2_TU, VFMAX_VF, 0x1 }, // 1520
  { PseudoVFMAX_VF64_M2, VFMAX_VF, 0x1 }, // 1521
  { PseudoVFMAX_VF64_M2_MASK, VFMAX_VF, 0x1 }, // 1522
  { PseudoVFMAX_VF64_M2_TU, VFMAX_VF, 0x1 }, // 1523
  { PseudoVFMAX_VF16_M4, VFMAX_VF, 0x2 }, // 1524
  { PseudoVFMAX_VF16_M4_MASK, VFMAX_VF, 0x2 }, // 1525
  { PseudoVFMAX_VF16_M4_TU, VFMAX_VF, 0x2 }, // 1526
  { PseudoVFMAX_VF32_M4, VFMAX_VF, 0x2 }, // 1527
  { PseudoVFMAX_VF32_M4_MASK, VFMAX_VF, 0x2 }, // 1528
  { PseudoVFMAX_VF32_M4_TU, VFMAX_VF, 0x2 }, // 1529
  { PseudoVFMAX_VF64_M4, VFMAX_VF, 0x2 }, // 1530
  { PseudoVFMAX_VF64_M4_MASK, VFMAX_VF, 0x2 }, // 1531
  { PseudoVFMAX_VF64_M4_TU, VFMAX_VF, 0x2 }, // 1532
  { PseudoVFMAX_VF16_M8, VFMAX_VF, 0x3 }, // 1533
  { PseudoVFMAX_VF16_M8_MASK, VFMAX_VF, 0x3 }, // 1534
  { PseudoVFMAX_VF16_M8_TU, VFMAX_VF, 0x3 }, // 1535
  { PseudoVFMAX_VF32_M8, VFMAX_VF, 0x3 }, // 1536
  { PseudoVFMAX_VF32_M8_MASK, VFMAX_VF, 0x3 }, // 1537
  { PseudoVFMAX_VF32_M8_TU, VFMAX_VF, 0x3 }, // 1538
  { PseudoVFMAX_VF64_M8, VFMAX_VF, 0x3 }, // 1539
  { PseudoVFMAX_VF64_M8_MASK, VFMAX_VF, 0x3 }, // 1540
  { PseudoVFMAX_VF64_M8_TU, VFMAX_VF, 0x3 }, // 1541
  { PseudoVFMAX_VF16_MF4, VFMAX_VF, 0x6 }, // 1542
  { PseudoVFMAX_VF16_MF4_MASK, VFMAX_VF, 0x6 }, // 1543
  { PseudoVFMAX_VF16_MF4_TU, VFMAX_VF, 0x6 }, // 1544
  { PseudoVFMAX_VF16_MF2, VFMAX_VF, 0x7 }, // 1545
  { PseudoVFMAX_VF16_MF2_MASK, VFMAX_VF, 0x7 }, // 1546
  { PseudoVFMAX_VF16_MF2_TU, VFMAX_VF, 0x7 }, // 1547
  { PseudoVFMAX_VF32_MF2, VFMAX_VF, 0x7 }, // 1548
  { PseudoVFMAX_VF32_MF2_MASK, VFMAX_VF, 0x7 }, // 1549
  { PseudoVFMAX_VF32_MF2_TU, VFMAX_VF, 0x7 }, // 1550
  { PseudoVFMAX_VV_M1, VFMAX_VV, 0x0 }, // 1551
  { PseudoVFMAX_VV_M1_MASK, VFMAX_VV, 0x0 }, // 1552
  { PseudoVFMAX_VV_M1_TU, VFMAX_VV, 0x0 }, // 1553
  { PseudoVFMAX_VV_M2, VFMAX_VV, 0x1 }, // 1554
  { PseudoVFMAX_VV_M2_MASK, VFMAX_VV, 0x1 }, // 1555
  { PseudoVFMAX_VV_M2_TU, VFMAX_VV, 0x1 }, // 1556
  { PseudoVFMAX_VV_M4, VFMAX_VV, 0x2 }, // 1557
  { PseudoVFMAX_VV_M4_MASK, VFMAX_VV, 0x2 }, // 1558
  { PseudoVFMAX_VV_M4_TU, VFMAX_VV, 0x2 }, // 1559
  { PseudoVFMAX_VV_M8, VFMAX_VV, 0x3 }, // 1560
  { PseudoVFMAX_VV_M8_MASK, VFMAX_VV, 0x3 }, // 1561
  { PseudoVFMAX_VV_M8_TU, VFMAX_VV, 0x3 }, // 1562
  { PseudoVFMAX_VV_MF4, VFMAX_VV, 0x6 }, // 1563
  { PseudoVFMAX_VV_MF4_MASK, VFMAX_VV, 0x6 }, // 1564
  { PseudoVFMAX_VV_MF4_TU, VFMAX_VV, 0x6 }, // 1565
  { PseudoVFMAX_VV_MF2, VFMAX_VV, 0x7 }, // 1566
  { PseudoVFMAX_VV_MF2_MASK, VFMAX_VV, 0x7 }, // 1567
  { PseudoVFMAX_VV_MF2_TU, VFMAX_VV, 0x7 }, // 1568
  { PseudoVFMERGE_VF16M_M1, VFMERGE_VFM, 0x0 }, // 1569
  { PseudoVFMERGE_VF16M_M1_TU, VFMERGE_VFM, 0x0 }, // 1570
  { PseudoVFMERGE_VF32M_M1, VFMERGE_VFM, 0x0 }, // 1571
  { PseudoVFMERGE_VF32M_M1_TU, VFMERGE_VFM, 0x0 }, // 1572
  { PseudoVFMERGE_VF64M_M1, VFMERGE_VFM, 0x0 }, // 1573
  { PseudoVFMERGE_VF64M_M1_TU, VFMERGE_VFM, 0x0 }, // 1574
  { PseudoVFMERGE_VF16M_M2, VFMERGE_VFM, 0x1 }, // 1575
  { PseudoVFMERGE_VF16M_M2_TU, VFMERGE_VFM, 0x1 }, // 1576
  { PseudoVFMERGE_VF32M_M2, VFMERGE_VFM, 0x1 }, // 1577
  { PseudoVFMERGE_VF32M_M2_TU, VFMERGE_VFM, 0x1 }, // 1578
  { PseudoVFMERGE_VF64M_M2, VFMERGE_VFM, 0x1 }, // 1579
  { PseudoVFMERGE_VF64M_M2_TU, VFMERGE_VFM, 0x1 }, // 1580
  { PseudoVFMERGE_VF16M_M4, VFMERGE_VFM, 0x2 }, // 1581
  { PseudoVFMERGE_VF16M_M4_TU, VFMERGE_VFM, 0x2 }, // 1582
  { PseudoVFMERGE_VF32M_M4, VFMERGE_VFM, 0x2 }, // 1583
  { PseudoVFMERGE_VF32M_M4_TU, VFMERGE_VFM, 0x2 }, // 1584
  { PseudoVFMERGE_VF64M_M4, VFMERGE_VFM, 0x2 }, // 1585
  { PseudoVFMERGE_VF64M_M4_TU, VFMERGE_VFM, 0x2 }, // 1586
  { PseudoVFMERGE_VF16M_M8, VFMERGE_VFM, 0x3 }, // 1587
  { PseudoVFMERGE_VF16M_M8_TU, VFMERGE_VFM, 0x3 }, // 1588
  { PseudoVFMERGE_VF32M_M8, VFMERGE_VFM, 0x3 }, // 1589
  { PseudoVFMERGE_VF32M_M8_TU, VFMERGE_VFM, 0x3 }, // 1590
  { PseudoVFMERGE_VF64M_M8, VFMERGE_VFM, 0x3 }, // 1591
  { PseudoVFMERGE_VF64M_M8_TU, VFMERGE_VFM, 0x3 }, // 1592
  { PseudoVFMERGE_VF16M_MF4, VFMERGE_VFM, 0x6 }, // 1593
  { PseudoVFMERGE_VF16M_MF4_TU, VFMERGE_VFM, 0x6 }, // 1594
  { PseudoVFMERGE_VF16M_MF2, VFMERGE_VFM, 0x7 }, // 1595
  { PseudoVFMERGE_VF16M_MF2_TU, VFMERGE_VFM, 0x7 }, // 1596
  { PseudoVFMERGE_VF32M_MF2, VFMERGE_VFM, 0x7 }, // 1597
  { PseudoVFMERGE_VF32M_MF2_TU, VFMERGE_VFM, 0x7 }, // 1598
  { PseudoVFMIN_VF16_M1, VFMIN_VF, 0x0 }, // 1599
  { PseudoVFMIN_VF16_M1_MASK, VFMIN_VF, 0x0 }, // 1600
  { PseudoVFMIN_VF16_M1_TU, VFMIN_VF, 0x0 }, // 1601
  { PseudoVFMIN_VF32_M1, VFMIN_VF, 0x0 }, // 1602
  { PseudoVFMIN_VF32_M1_MASK, VFMIN_VF, 0x0 }, // 1603
  { PseudoVFMIN_VF32_M1_TU, VFMIN_VF, 0x0 }, // 1604
  { PseudoVFMIN_VF64_M1, VFMIN_VF, 0x0 }, // 1605
  { PseudoVFMIN_VF64_M1_MASK, VFMIN_VF, 0x0 }, // 1606
  { PseudoVFMIN_VF64_M1_TU, VFMIN_VF, 0x0 }, // 1607
  { PseudoVFMIN_VF16_M2, VFMIN_VF, 0x1 }, // 1608
  { PseudoVFMIN_VF16_M2_MASK, VFMIN_VF, 0x1 }, // 1609
  { PseudoVFMIN_VF16_M2_TU, VFMIN_VF, 0x1 }, // 1610
  { PseudoVFMIN_VF32_M2, VFMIN_VF, 0x1 }, // 1611
  { PseudoVFMIN_VF32_M2_MASK, VFMIN_VF, 0x1 }, // 1612
  { PseudoVFMIN_VF32_M2_TU, VFMIN_VF, 0x1 }, // 1613
  { PseudoVFMIN_VF64_M2, VFMIN_VF, 0x1 }, // 1614
  { PseudoVFMIN_VF64_M2_MASK, VFMIN_VF, 0x1 }, // 1615
  { PseudoVFMIN_VF64_M2_TU, VFMIN_VF, 0x1 }, // 1616
  { PseudoVFMIN_VF16_M4, VFMIN_VF, 0x2 }, // 1617
  { PseudoVFMIN_VF16_M4_MASK, VFMIN_VF, 0x2 }, // 1618
  { PseudoVFMIN_VF16_M4_TU, VFMIN_VF, 0x2 }, // 1619
  { PseudoVFMIN_VF32_M4, VFMIN_VF, 0x2 }, // 1620
  { PseudoVFMIN_VF32_M4_MASK, VFMIN_VF, 0x2 }, // 1621
  { PseudoVFMIN_VF32_M4_TU, VFMIN_VF, 0x2 }, // 1622
  { PseudoVFMIN_VF64_M4, VFMIN_VF, 0x2 }, // 1623
  { PseudoVFMIN_VF64_M4_MASK, VFMIN_VF, 0x2 }, // 1624
  { PseudoVFMIN_VF64_M4_TU, VFMIN_VF, 0x2 }, // 1625
  { PseudoVFMIN_VF16_M8, VFMIN_VF, 0x3 }, // 1626
  { PseudoVFMIN_VF16_M8_MASK, VFMIN_VF, 0x3 }, // 1627
  { PseudoVFMIN_VF16_M8_TU, VFMIN_VF, 0x3 }, // 1628
  { PseudoVFMIN_VF32_M8, VFMIN_VF, 0x3 }, // 1629
  { PseudoVFMIN_VF32_M8_MASK, VFMIN_VF, 0x3 }, // 1630
  { PseudoVFMIN_VF32_M8_TU, VFMIN_VF, 0x3 }, // 1631
  { PseudoVFMIN_VF64_M8, VFMIN_VF, 0x3 }, // 1632
  { PseudoVFMIN_VF64_M8_MASK, VFMIN_VF, 0x3 }, // 1633
  { PseudoVFMIN_VF64_M8_TU, VFMIN_VF, 0x3 }, // 1634
  { PseudoVFMIN_VF16_MF4, VFMIN_VF, 0x6 }, // 1635
  { PseudoVFMIN_VF16_MF4_MASK, VFMIN_VF, 0x6 }, // 1636
  { PseudoVFMIN_VF16_MF4_TU, VFMIN_VF, 0x6 }, // 1637
  { PseudoVFMIN_VF16_MF2, VFMIN_VF, 0x7 }, // 1638
  { PseudoVFMIN_VF16_MF2_MASK, VFMIN_VF, 0x7 }, // 1639
  { PseudoVFMIN_VF16_MF2_TU, VFMIN_VF, 0x7 }, // 1640
  { PseudoVFMIN_VF32_MF2, VFMIN_VF, 0x7 }, // 1641
  { PseudoVFMIN_VF32_MF2_MASK, VFMIN_VF, 0x7 }, // 1642
  { PseudoVFMIN_VF32_MF2_TU, VFMIN_VF, 0x7 }, // 1643
  { PseudoVFMIN_VV_M1, VFMIN_VV, 0x0 }, // 1644
  { PseudoVFMIN_VV_M1_MASK, VFMIN_VV, 0x0 }, // 1645
  { PseudoVFMIN_VV_M1_TU, VFMIN_VV, 0x0 }, // 1646
  { PseudoVFMIN_VV_M2, VFMIN_VV, 0x1 }, // 1647
  { PseudoVFMIN_VV_M2_MASK, VFMIN_VV, 0x1 }, // 1648
  { PseudoVFMIN_VV_M2_TU, VFMIN_VV, 0x1 }, // 1649
  { PseudoVFMIN_VV_M4, VFMIN_VV, 0x2 }, // 1650
  { PseudoVFMIN_VV_M4_MASK, VFMIN_VV, 0x2 }, // 1651
  { PseudoVFMIN_VV_M4_TU, VFMIN_VV, 0x2 }, // 1652
  { PseudoVFMIN_VV_M8, VFMIN_VV, 0x3 }, // 1653
  { PseudoVFMIN_VV_M8_MASK, VFMIN_VV, 0x3 }, // 1654
  { PseudoVFMIN_VV_M8_TU, VFMIN_VV, 0x3 }, // 1655
  { PseudoVFMIN_VV_MF4, VFMIN_VV, 0x6 }, // 1656
  { PseudoVFMIN_VV_MF4_MASK, VFMIN_VV, 0x6 }, // 1657
  { PseudoVFMIN_VV_MF4_TU, VFMIN_VV, 0x6 }, // 1658
  { PseudoVFMIN_VV_MF2, VFMIN_VV, 0x7 }, // 1659
  { PseudoVFMIN_VV_MF2_MASK, VFMIN_VV, 0x7 }, // 1660
  { PseudoVFMIN_VV_MF2_TU, VFMIN_VV, 0x7 }, // 1661
  { PseudoVFMSAC_VF16_M1, VFMSAC_VF, 0x0 }, // 1662
  { PseudoVFMSAC_VF16_M1_MASK, VFMSAC_VF, 0x0 }, // 1663
  { PseudoVFMSAC_VF32_M1, VFMSAC_VF, 0x0 }, // 1664
  { PseudoVFMSAC_VF32_M1_MASK, VFMSAC_VF, 0x0 }, // 1665
  { PseudoVFMSAC_VF64_M1, VFMSAC_VF, 0x0 }, // 1666
  { PseudoVFMSAC_VF64_M1_MASK, VFMSAC_VF, 0x0 }, // 1667
  { PseudoVFMSAC_VF16_M2, VFMSAC_VF, 0x1 }, // 1668
  { PseudoVFMSAC_VF16_M2_MASK, VFMSAC_VF, 0x1 }, // 1669
  { PseudoVFMSAC_VF32_M2, VFMSAC_VF, 0x1 }, // 1670
  { PseudoVFMSAC_VF32_M2_MASK, VFMSAC_VF, 0x1 }, // 1671
  { PseudoVFMSAC_VF64_M2, VFMSAC_VF, 0x1 }, // 1672
  { PseudoVFMSAC_VF64_M2_MASK, VFMSAC_VF, 0x1 }, // 1673
  { PseudoVFMSAC_VF16_M4, VFMSAC_VF, 0x2 }, // 1674
  { PseudoVFMSAC_VF16_M4_MASK, VFMSAC_VF, 0x2 }, // 1675
  { PseudoVFMSAC_VF32_M4, VFMSAC_VF, 0x2 }, // 1676
  { PseudoVFMSAC_VF32_M4_MASK, VFMSAC_VF, 0x2 }, // 1677
  { PseudoVFMSAC_VF64_M4, VFMSAC_VF, 0x2 }, // 1678
  { PseudoVFMSAC_VF64_M4_MASK, VFMSAC_VF, 0x2 }, // 1679
  { PseudoVFMSAC_VF16_M8, VFMSAC_VF, 0x3 }, // 1680
  { PseudoVFMSAC_VF16_M8_MASK, VFMSAC_VF, 0x3 }, // 1681
  { PseudoVFMSAC_VF32_M8, VFMSAC_VF, 0x3 }, // 1682
  { PseudoVFMSAC_VF32_M8_MASK, VFMSAC_VF, 0x3 }, // 1683
  { PseudoVFMSAC_VF64_M8, VFMSAC_VF, 0x3 }, // 1684
  { PseudoVFMSAC_VF64_M8_MASK, VFMSAC_VF, 0x3 }, // 1685
  { PseudoVFMSAC_VF16_MF4, VFMSAC_VF, 0x6 }, // 1686
  { PseudoVFMSAC_VF16_MF4_MASK, VFMSAC_VF, 0x6 }, // 1687
  { PseudoVFMSAC_VF16_MF2, VFMSAC_VF, 0x7 }, // 1688
  { PseudoVFMSAC_VF16_MF2_MASK, VFMSAC_VF, 0x7 }, // 1689
  { PseudoVFMSAC_VF32_MF2, VFMSAC_VF, 0x7 }, // 1690
  { PseudoVFMSAC_VF32_MF2_MASK, VFMSAC_VF, 0x7 }, // 1691
  { PseudoVFMSAC_VV_M1, VFMSAC_VV, 0x0 }, // 1692
  { PseudoVFMSAC_VV_M1_MASK, VFMSAC_VV, 0x0 }, // 1693
  { PseudoVFMSAC_VV_M2, VFMSAC_VV, 0x1 }, // 1694
  { PseudoVFMSAC_VV_M2_MASK, VFMSAC_VV, 0x1 }, // 1695
  { PseudoVFMSAC_VV_M4, VFMSAC_VV, 0x2 }, // 1696
  { PseudoVFMSAC_VV_M4_MASK, VFMSAC_VV, 0x2 }, // 1697
  { PseudoVFMSAC_VV_M8, VFMSAC_VV, 0x3 }, // 1698
  { PseudoVFMSAC_VV_M8_MASK, VFMSAC_VV, 0x3 }, // 1699
  { PseudoVFMSAC_VV_MF4, VFMSAC_VV, 0x6 }, // 1700
  { PseudoVFMSAC_VV_MF4_MASK, VFMSAC_VV, 0x6 }, // 1701
  { PseudoVFMSAC_VV_MF2, VFMSAC_VV, 0x7 }, // 1702
  { PseudoVFMSAC_VV_MF2_MASK, VFMSAC_VV, 0x7 }, // 1703
  { PseudoVFMSUB_VF16_M1, VFMSUB_VF, 0x0 }, // 1704
  { PseudoVFMSUB_VF16_M1_MASK, VFMSUB_VF, 0x0 }, // 1705
  { PseudoVFMSUB_VF32_M1, VFMSUB_VF, 0x0 }, // 1706
  { PseudoVFMSUB_VF32_M1_MASK, VFMSUB_VF, 0x0 }, // 1707
  { PseudoVFMSUB_VF64_M1, VFMSUB_VF, 0x0 }, // 1708
  { PseudoVFMSUB_VF64_M1_MASK, VFMSUB_VF, 0x0 }, // 1709
  { PseudoVFMSUB_VF16_M2, VFMSUB_VF, 0x1 }, // 1710
  { PseudoVFMSUB_VF16_M2_MASK, VFMSUB_VF, 0x1 }, // 1711
  { PseudoVFMSUB_VF32_M2, VFMSUB_VF, 0x1 }, // 1712
  { PseudoVFMSUB_VF32_M2_MASK, VFMSUB_VF, 0x1 }, // 1713
  { PseudoVFMSUB_VF64_M2, VFMSUB_VF, 0x1 }, // 1714
  { PseudoVFMSUB_VF64_M2_MASK, VFMSUB_VF, 0x1 }, // 1715
  { PseudoVFMSUB_VF16_M4, VFMSUB_VF, 0x2 }, // 1716
  { PseudoVFMSUB_VF16_M4_MASK, VFMSUB_VF, 0x2 }, // 1717
  { PseudoVFMSUB_VF32_M4, VFMSUB_VF, 0x2 }, // 1718
  { PseudoVFMSUB_VF32_M4_MASK, VFMSUB_VF, 0x2 }, // 1719
  { PseudoVFMSUB_VF64_M4, VFMSUB_VF, 0x2 }, // 1720
  { PseudoVFMSUB_VF64_M4_MASK, VFMSUB_VF, 0x2 }, // 1721
  { PseudoVFMSUB_VF16_M8, VFMSUB_VF, 0x3 }, // 1722
  { PseudoVFMSUB_VF16_M8_MASK, VFMSUB_VF, 0x3 }, // 1723
  { PseudoVFMSUB_VF32_M8, VFMSUB_VF, 0x3 }, // 1724
  { PseudoVFMSUB_VF32_M8_MASK, VFMSUB_VF, 0x3 }, // 1725
  { PseudoVFMSUB_VF64_M8, VFMSUB_VF, 0x3 }, // 1726
  { PseudoVFMSUB_VF64_M8_MASK, VFMSUB_VF, 0x3 }, // 1727
  { PseudoVFMSUB_VF16_MF4, VFMSUB_VF, 0x6 }, // 1728
  { PseudoVFMSUB_VF16_MF4_MASK, VFMSUB_VF, 0x6 }, // 1729
  { PseudoVFMSUB_VF16_MF2, VFMSUB_VF, 0x7 }, // 1730
  { PseudoVFMSUB_VF16_MF2_MASK, VFMSUB_VF, 0x7 }, // 1731
  { PseudoVFMSUB_VF32_MF2, VFMSUB_VF, 0x7 }, // 1732
  { PseudoVFMSUB_VF32_MF2_MASK, VFMSUB_VF, 0x7 }, // 1733
  { PseudoVFMSUB_VV_M1, VFMSUB_VV, 0x0 }, // 1734
  { PseudoVFMSUB_VV_M1_MASK, VFMSUB_VV, 0x0 }, // 1735
  { PseudoVFMSUB_VV_M2, VFMSUB_VV, 0x1 }, // 1736
  { PseudoVFMSUB_VV_M2_MASK, VFMSUB_VV, 0x1 }, // 1737
  { PseudoVFMSUB_VV_M4, VFMSUB_VV, 0x2 }, // 1738
  { PseudoVFMSUB_VV_M4_MASK, VFMSUB_VV, 0x2 }, // 1739
  { PseudoVFMSUB_VV_M8, VFMSUB_VV, 0x3 }, // 1740
  { PseudoVFMSUB_VV_M8_MASK, VFMSUB_VV, 0x3 }, // 1741
  { PseudoVFMSUB_VV_MF4, VFMSUB_VV, 0x6 }, // 1742
  { PseudoVFMSUB_VV_MF4_MASK, VFMSUB_VV, 0x6 }, // 1743
  { PseudoVFMSUB_VV_MF2, VFMSUB_VV, 0x7 }, // 1744
  { PseudoVFMSUB_VV_MF2_MASK, VFMSUB_VV, 0x7 }, // 1745
  { PseudoVFMUL_VF16_M1, VFMUL_VF, 0x0 }, // 1746
  { PseudoVFMUL_VF16_M1_MASK, VFMUL_VF, 0x0 }, // 1747
  { PseudoVFMUL_VF16_M1_TU, VFMUL_VF, 0x0 }, // 1748
  { PseudoVFMUL_VF32_M1, VFMUL_VF, 0x0 }, // 1749
  { PseudoVFMUL_VF32_M1_MASK, VFMUL_VF, 0x0 }, // 1750
  { PseudoVFMUL_VF32_M1_TU, VFMUL_VF, 0x0 }, // 1751
  { PseudoVFMUL_VF64_M1, VFMUL_VF, 0x0 }, // 1752
  { PseudoVFMUL_VF64_M1_MASK, VFMUL_VF, 0x0 }, // 1753
  { PseudoVFMUL_VF64_M1_TU, VFMUL_VF, 0x0 }, // 1754
  { PseudoVFMUL_VF16_M2, VFMUL_VF, 0x1 }, // 1755
  { PseudoVFMUL_VF16_M2_MASK, VFMUL_VF, 0x1 }, // 1756
  { PseudoVFMUL_VF16_M2_TU, VFMUL_VF, 0x1 }, // 1757
  { PseudoVFMUL_VF32_M2, VFMUL_VF, 0x1 }, // 1758
  { PseudoVFMUL_VF32_M2_MASK, VFMUL_VF, 0x1 }, // 1759
  { PseudoVFMUL_VF32_M2_TU, VFMUL_VF, 0x1 }, // 1760
  { PseudoVFMUL_VF64_M2, VFMUL_VF, 0x1 }, // 1761
  { PseudoVFMUL_VF64_M2_MASK, VFMUL_VF, 0x1 }, // 1762
  { PseudoVFMUL_VF64_M2_TU, VFMUL_VF, 0x1 }, // 1763
  { PseudoVFMUL_VF16_M4, VFMUL_VF, 0x2 }, // 1764
  { PseudoVFMUL_VF16_M4_MASK, VFMUL_VF, 0x2 }, // 1765
  { PseudoVFMUL_VF16_M4_TU, VFMUL_VF, 0x2 }, // 1766
  { PseudoVFMUL_VF32_M4, VFMUL_VF, 0x2 }, // 1767
  { PseudoVFMUL_VF32_M4_MASK, VFMUL_VF, 0x2 }, // 1768
  { PseudoVFMUL_VF32_M4_TU, VFMUL_VF, 0x2 }, // 1769
  { PseudoVFMUL_VF64_M4, VFMUL_VF, 0x2 }, // 1770
  { PseudoVFMUL_VF64_M4_MASK, VFMUL_VF, 0x2 }, // 1771
  { PseudoVFMUL_VF64_M4_TU, VFMUL_VF, 0x2 }, // 1772
  { PseudoVFMUL_VF16_M8, VFMUL_VF, 0x3 }, // 1773
  { PseudoVFMUL_VF16_M8_MASK, VFMUL_VF, 0x3 }, // 1774
  { PseudoVFMUL_VF16_M8_TU, VFMUL_VF, 0x3 }, // 1775
  { PseudoVFMUL_VF32_M8, VFMUL_VF, 0x3 }, // 1776
  { PseudoVFMUL_VF32_M8_MASK, VFMUL_VF, 0x3 }, // 1777
  { PseudoVFMUL_VF32_M8_TU, VFMUL_VF, 0x3 }, // 1778
  { PseudoVFMUL_VF64_M8, VFMUL_VF, 0x3 }, // 1779
  { PseudoVFMUL_VF64_M8_MASK, VFMUL_VF, 0x3 }, // 1780
  { PseudoVFMUL_VF64_M8_TU, VFMUL_VF, 0x3 }, // 1781
  { PseudoVFMUL_VF16_MF4, VFMUL_VF, 0x6 }, // 1782
  { PseudoVFMUL_VF16_MF4_MASK, VFMUL_VF, 0x6 }, // 1783
  { PseudoVFMUL_VF16_MF4_TU, VFMUL_VF, 0x6 }, // 1784
  { PseudoVFMUL_VF16_MF2, VFMUL_VF, 0x7 }, // 1785
  { PseudoVFMUL_VF16_MF2_MASK, VFMUL_VF, 0x7 }, // 1786
  { PseudoVFMUL_VF16_MF2_TU, VFMUL_VF, 0x7 }, // 1787
  { PseudoVFMUL_VF32_MF2, VFMUL_VF, 0x7 }, // 1788
  { PseudoVFMUL_VF32_MF2_MASK, VFMUL_VF, 0x7 }, // 1789
  { PseudoVFMUL_VF32_MF2_TU, VFMUL_VF, 0x7 }, // 1790
  { PseudoVFMUL_VV_M1, VFMUL_VV, 0x0 }, // 1791
  { PseudoVFMUL_VV_M1_MASK, VFMUL_VV, 0x0 }, // 1792
  { PseudoVFMUL_VV_M1_TU, VFMUL_VV, 0x0 }, // 1793
  { PseudoVFMUL_VV_M2, VFMUL_VV, 0x1 }, // 1794
  { PseudoVFMUL_VV_M2_MASK, VFMUL_VV, 0x1 }, // 1795
  { PseudoVFMUL_VV_M2_TU, VFMUL_VV, 0x1 }, // 1796
  { PseudoVFMUL_VV_M4, VFMUL_VV, 0x2 }, // 1797
  { PseudoVFMUL_VV_M4_MASK, VFMUL_VV, 0x2 }, // 1798
  { PseudoVFMUL_VV_M4_TU, VFMUL_VV, 0x2 }, // 1799
  { PseudoVFMUL_VV_M8, VFMUL_VV, 0x3 }, // 1800
  { PseudoVFMUL_VV_M8_MASK, VFMUL_VV, 0x3 }, // 1801
  { PseudoVFMUL_VV_M8_TU, VFMUL_VV, 0x3 }, // 1802
  { PseudoVFMUL_VV_MF4, VFMUL_VV, 0x6 }, // 1803
  { PseudoVFMUL_VV_MF4_MASK, VFMUL_VV, 0x6 }, // 1804
  { PseudoVFMUL_VV_MF4_TU, VFMUL_VV, 0x6 }, // 1805
  { PseudoVFMUL_VV_MF2, VFMUL_VV, 0x7 }, // 1806
  { PseudoVFMUL_VV_MF2_MASK, VFMUL_VV, 0x7 }, // 1807
  { PseudoVFMUL_VV_MF2_TU, VFMUL_VV, 0x7 }, // 1808
  { PseudoVFMV_F16_S_M1, VFMV_F_S, 0x0 }, // 1809
  { PseudoVFMV_F32_S_M1, VFMV_F_S, 0x0 }, // 1810
  { PseudoVFMV_F64_S_M1, VFMV_F_S, 0x0 }, // 1811
  { PseudoVFMV_F16_S_M2, VFMV_F_S, 0x1 }, // 1812
  { PseudoVFMV_F32_S_M2, VFMV_F_S, 0x1 }, // 1813
  { PseudoVFMV_F64_S_M2, VFMV_F_S, 0x1 }, // 1814
  { PseudoVFMV_F16_S_M4, VFMV_F_S, 0x2 }, // 1815
  { PseudoVFMV_F32_S_M4, VFMV_F_S, 0x2 }, // 1816
  { PseudoVFMV_F64_S_M4, VFMV_F_S, 0x2 }, // 1817
  { PseudoVFMV_F16_S_M8, VFMV_F_S, 0x3 }, // 1818
  { PseudoVFMV_F32_S_M8, VFMV_F_S, 0x3 }, // 1819
  { PseudoVFMV_F64_S_M8, VFMV_F_S, 0x3 }, // 1820
  { PseudoVFMV_F16_S_MF4, VFMV_F_S, 0x6 }, // 1821
  { PseudoVFMV_F16_S_MF2, VFMV_F_S, 0x7 }, // 1822
  { PseudoVFMV_F32_S_MF2, VFMV_F_S, 0x7 }, // 1823
  { PseudoVFMV_S_F16_M1, VFMV_S_F, 0x0 }, // 1824
  { PseudoVFMV_S_F32_M1, VFMV_S_F, 0x0 }, // 1825
  { PseudoVFMV_S_F64_M1, VFMV_S_F, 0x0 }, // 1826
  { PseudoVFMV_S_F16_M2, VFMV_S_F, 0x1 }, // 1827
  { PseudoVFMV_S_F32_M2, VFMV_S_F, 0x1 }, // 1828
  { PseudoVFMV_S_F64_M2, VFMV_S_F, 0x1 }, // 1829
  { PseudoVFMV_S_F16_M4, VFMV_S_F, 0x2 }, // 1830
  { PseudoVFMV_S_F32_M4, VFMV_S_F, 0x2 }, // 1831
  { PseudoVFMV_S_F64_M4, VFMV_S_F, 0x2 }, // 1832
  { PseudoVFMV_S_F16_M8, VFMV_S_F, 0x3 }, // 1833
  { PseudoVFMV_S_F32_M8, VFMV_S_F, 0x3 }, // 1834
  { PseudoVFMV_S_F64_M8, VFMV_S_F, 0x3 }, // 1835
  { PseudoVFMV_S_F16_MF4, VFMV_S_F, 0x6 }, // 1836
  { PseudoVFMV_S_F16_MF2, VFMV_S_F, 0x7 }, // 1837
  { PseudoVFMV_S_F32_MF2, VFMV_S_F, 0x7 }, // 1838
  { PseudoVFMV_V_F16_M1, VFMV_V_F, 0x0 }, // 1839
  { PseudoVFMV_V_F16_M1_TU, VFMV_V_F, 0x0 }, // 1840
  { PseudoVFMV_V_F32_M1, VFMV_V_F, 0x0 }, // 1841
  { PseudoVFMV_V_F32_M1_TU, VFMV_V_F, 0x0 }, // 1842
  { PseudoVFMV_V_F64_M1, VFMV_V_F, 0x0 }, // 1843
  { PseudoVFMV_V_F64_M1_TU, VFMV_V_F, 0x0 }, // 1844
  { PseudoVFMV_V_F16_M2, VFMV_V_F, 0x1 }, // 1845
  { PseudoVFMV_V_F16_M2_TU, VFMV_V_F, 0x1 }, // 1846
  { PseudoVFMV_V_F32_M2, VFMV_V_F, 0x1 }, // 1847
  { PseudoVFMV_V_F32_M2_TU, VFMV_V_F, 0x1 }, // 1848
  { PseudoVFMV_V_F64_M2, VFMV_V_F, 0x1 }, // 1849
  { PseudoVFMV_V_F64_M2_TU, VFMV_V_F, 0x1 }, // 1850
  { PseudoVFMV_V_F16_M4, VFMV_V_F, 0x2 }, // 1851
  { PseudoVFMV_V_F16_M4_TU, VFMV_V_F, 0x2 }, // 1852
  { PseudoVFMV_V_F32_M4, VFMV_V_F, 0x2 }, // 1853
  { PseudoVFMV_V_F32_M4_TU, VFMV_V_F, 0x2 }, // 1854
  { PseudoVFMV_V_F64_M4, VFMV_V_F, 0x2 }, // 1855
  { PseudoVFMV_V_F64_M4_TU, VFMV_V_F, 0x2 }, // 1856
  { PseudoVFMV_V_F16_M8, VFMV_V_F, 0x3 }, // 1857
  { PseudoVFMV_V_F16_M8_TU, VFMV_V_F, 0x3 }, // 1858
  { PseudoVFMV_V_F32_M8, VFMV_V_F, 0x3 }, // 1859
  { PseudoVFMV_V_F32_M8_TU, VFMV_V_F, 0x3 }, // 1860
  { PseudoVFMV_V_F64_M8, VFMV_V_F, 0x3 }, // 1861
  { PseudoVFMV_V_F64_M8_TU, VFMV_V_F, 0x3 }, // 1862
  { PseudoVFMV_V_F16_MF4, VFMV_V_F, 0x6 }, // 1863
  { PseudoVFMV_V_F16_MF4_TU, VFMV_V_F, 0x6 }, // 1864
  { PseudoVFMV_V_F16_MF2, VFMV_V_F, 0x7 }, // 1865
  { PseudoVFMV_V_F16_MF2_TU, VFMV_V_F, 0x7 }, // 1866
  { PseudoVFMV_V_F32_MF2, VFMV_V_F, 0x7 }, // 1867
  { PseudoVFMV_V_F32_MF2_TU, VFMV_V_F, 0x7 }, // 1868
  { PseudoVFNCVT_F_F_W_M1, VFNCVT_F_F_W, 0x0 }, // 1869
  { PseudoVFNCVT_F_F_W_M1_MASK, VFNCVT_F_F_W, 0x0 }, // 1870
  { PseudoVFNCVT_F_F_W_M1_TU, VFNCVT_F_F_W, 0x0 }, // 1871
  { PseudoVFNCVT_F_F_W_M2, VFNCVT_F_F_W, 0x1 }, // 1872
  { PseudoVFNCVT_F_F_W_M2_MASK, VFNCVT_F_F_W, 0x1 }, // 1873
  { PseudoVFNCVT_F_F_W_M2_TU, VFNCVT_F_F_W, 0x1 }, // 1874
  { PseudoVFNCVT_F_F_W_M4, VFNCVT_F_F_W, 0x2 }, // 1875
  { PseudoVFNCVT_F_F_W_M4_MASK, VFNCVT_F_F_W, 0x2 }, // 1876
  { PseudoVFNCVT_F_F_W_M4_TU, VFNCVT_F_F_W, 0x2 }, // 1877
  { PseudoVFNCVT_F_F_W_MF4, VFNCVT_F_F_W, 0x6 }, // 1878
  { PseudoVFNCVT_F_F_W_MF4_MASK, VFNCVT_F_F_W, 0x6 }, // 1879
  { PseudoVFNCVT_F_F_W_MF4_TU, VFNCVT_F_F_W, 0x6 }, // 1880
  { PseudoVFNCVT_F_F_W_MF2, VFNCVT_F_F_W, 0x7 }, // 1881
  { PseudoVFNCVT_F_F_W_MF2_MASK, VFNCVT_F_F_W, 0x7 }, // 1882
  { PseudoVFNCVT_F_F_W_MF2_TU, VFNCVT_F_F_W, 0x7 }, // 1883
  { PseudoVFNCVT_F_XU_W_M1, VFNCVT_F_XU_W, 0x0 }, // 1884
  { PseudoVFNCVT_F_XU_W_M1_MASK, VFNCVT_F_XU_W, 0x0 }, // 1885
  { PseudoVFNCVT_F_XU_W_M1_TU, VFNCVT_F_XU_W, 0x0 }, // 1886
  { PseudoVFNCVT_F_XU_W_M2, VFNCVT_F_XU_W, 0x1 }, // 1887
  { PseudoVFNCVT_F_XU_W_M2_MASK, VFNCVT_F_XU_W, 0x1 }, // 1888
  { PseudoVFNCVT_F_XU_W_M2_TU, VFNCVT_F_XU_W, 0x1 }, // 1889
  { PseudoVFNCVT_F_XU_W_M4, VFNCVT_F_XU_W, 0x2 }, // 1890
  { PseudoVFNCVT_F_XU_W_M4_MASK, VFNCVT_F_XU_W, 0x2 }, // 1891
  { PseudoVFNCVT_F_XU_W_M4_TU, VFNCVT_F_XU_W, 0x2 }, // 1892
  { PseudoVFNCVT_F_XU_W_MF4, VFNCVT_F_XU_W, 0x6 }, // 1893
  { PseudoVFNCVT_F_XU_W_MF4_MASK, VFNCVT_F_XU_W, 0x6 }, // 1894
  { PseudoVFNCVT_F_XU_W_MF4_TU, VFNCVT_F_XU_W, 0x6 }, // 1895
  { PseudoVFNCVT_F_XU_W_MF2, VFNCVT_F_XU_W, 0x7 }, // 1896
  { PseudoVFNCVT_F_XU_W_MF2_MASK, VFNCVT_F_XU_W, 0x7 }, // 1897
  { PseudoVFNCVT_F_XU_W_MF2_TU, VFNCVT_F_XU_W, 0x7 }, // 1898
  { PseudoVFNCVT_F_X_W_M1, VFNCVT_F_X_W, 0x0 }, // 1899
  { PseudoVFNCVT_F_X_W_M1_MASK, VFNCVT_F_X_W, 0x0 }, // 1900
  { PseudoVFNCVT_F_X_W_M1_TU, VFNCVT_F_X_W, 0x0 }, // 1901
  { PseudoVFNCVT_F_X_W_M2, VFNCVT_F_X_W, 0x1 }, // 1902
  { PseudoVFNCVT_F_X_W_M2_MASK, VFNCVT_F_X_W, 0x1 }, // 1903
  { PseudoVFNCVT_F_X_W_M2_TU, VFNCVT_F_X_W, 0x1 }, // 1904
  { PseudoVFNCVT_F_X_W_M4, VFNCVT_F_X_W, 0x2 }, // 1905
  { PseudoVFNCVT_F_X_W_M4_MASK, VFNCVT_F_X_W, 0x2 }, // 1906
  { PseudoVFNCVT_F_X_W_M4_TU, VFNCVT_F_X_W, 0x2 }, // 1907
  { PseudoVFNCVT_F_X_W_MF4, VFNCVT_F_X_W, 0x6 }, // 1908
  { PseudoVFNCVT_F_X_W_MF4_MASK, VFNCVT_F_X_W, 0x6 }, // 1909
  { PseudoVFNCVT_F_X_W_MF4_TU, VFNCVT_F_X_W, 0x6 }, // 1910
  { PseudoVFNCVT_F_X_W_MF2, VFNCVT_F_X_W, 0x7 }, // 1911
  { PseudoVFNCVT_F_X_W_MF2_MASK, VFNCVT_F_X_W, 0x7 }, // 1912
  { PseudoVFNCVT_F_X_W_MF2_TU, VFNCVT_F_X_W, 0x7 }, // 1913
  { PseudoVFNCVT_ROD_F_F_W_M1, VFNCVT_ROD_F_F_W, 0x0 }, // 1914
  { PseudoVFNCVT_ROD_F_F_W_M1_MASK, VFNCVT_ROD_F_F_W, 0x0 }, // 1915
  { PseudoVFNCVT_ROD_F_F_W_M1_TU, VFNCVT_ROD_F_F_W, 0x0 }, // 1916
  { PseudoVFNCVT_ROD_F_F_W_M2, VFNCVT_ROD_F_F_W, 0x1 }, // 1917
  { PseudoVFNCVT_ROD_F_F_W_M2_MASK, VFNCVT_ROD_F_F_W, 0x1 }, // 1918
  { PseudoVFNCVT_ROD_F_F_W_M2_TU, VFNCVT_ROD_F_F_W, 0x1 }, // 1919
  { PseudoVFNCVT_ROD_F_F_W_M4, VFNCVT_ROD_F_F_W, 0x2 }, // 1920
  { PseudoVFNCVT_ROD_F_F_W_M4_MASK, VFNCVT_ROD_F_F_W, 0x2 }, // 1921
  { PseudoVFNCVT_ROD_F_F_W_M4_TU, VFNCVT_ROD_F_F_W, 0x2 }, // 1922
  { PseudoVFNCVT_ROD_F_F_W_MF4, VFNCVT_ROD_F_F_W, 0x6 }, // 1923
  { PseudoVFNCVT_ROD_F_F_W_MF4_MASK, VFNCVT_ROD_F_F_W, 0x6 }, // 1924
  { PseudoVFNCVT_ROD_F_F_W_MF4_TU, VFNCVT_ROD_F_F_W, 0x6 }, // 1925
  { PseudoVFNCVT_ROD_F_F_W_MF2, VFNCVT_ROD_F_F_W, 0x7 }, // 1926
  { PseudoVFNCVT_ROD_F_F_W_MF2_MASK, VFNCVT_ROD_F_F_W, 0x7 }, // 1927
  { PseudoVFNCVT_ROD_F_F_W_MF2_TU, VFNCVT_ROD_F_F_W, 0x7 }, // 1928
  { PseudoVFNCVT_RTZ_XU_F_W_M1, VFNCVT_RTZ_XU_F_W, 0x0 }, // 1929
  { PseudoVFNCVT_RTZ_XU_F_W_M1_MASK, VFNCVT_RTZ_XU_F_W, 0x0 }, // 1930
  { PseudoVFNCVT_RTZ_XU_F_W_M1_TU, VFNCVT_RTZ_XU_F_W, 0x0 }, // 1931
  { PseudoVFNCVT_RTZ_XU_F_W_M2, VFNCVT_RTZ_XU_F_W, 0x1 }, // 1932
  { PseudoVFNCVT_RTZ_XU_F_W_M2_MASK, VFNCVT_RTZ_XU_F_W, 0x1 }, // 1933
  { PseudoVFNCVT_RTZ_XU_F_W_M2_TU, VFNCVT_RTZ_XU_F_W, 0x1 }, // 1934
  { PseudoVFNCVT_RTZ_XU_F_W_M4, VFNCVT_RTZ_XU_F_W, 0x2 }, // 1935
  { PseudoVFNCVT_RTZ_XU_F_W_M4_MASK, VFNCVT_RTZ_XU_F_W, 0x2 }, // 1936
  { PseudoVFNCVT_RTZ_XU_F_W_M4_TU, VFNCVT_RTZ_XU_F_W, 0x2 }, // 1937
  { PseudoVFNCVT_RTZ_XU_F_W_MF8, VFNCVT_RTZ_XU_F_W, 0x5 }, // 1938
  { PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK, VFNCVT_RTZ_XU_F_W, 0x5 }, // 1939
  { PseudoVFNCVT_RTZ_XU_F_W_MF8_TU, VFNCVT_RTZ_XU_F_W, 0x5 }, // 1940
  { PseudoVFNCVT_RTZ_XU_F_W_MF4, VFNCVT_RTZ_XU_F_W, 0x6 }, // 1941
  { PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK, VFNCVT_RTZ_XU_F_W, 0x6 }, // 1942
  { PseudoVFNCVT_RTZ_XU_F_W_MF4_TU, VFNCVT_RTZ_XU_F_W, 0x6 }, // 1943
  { PseudoVFNCVT_RTZ_XU_F_W_MF2, VFNCVT_RTZ_XU_F_W, 0x7 }, // 1944
  { PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK, VFNCVT_RTZ_XU_F_W, 0x7 }, // 1945
  { PseudoVFNCVT_RTZ_XU_F_W_MF2_TU, VFNCVT_RTZ_XU_F_W, 0x7 }, // 1946
  { PseudoVFNCVT_RTZ_X_F_W_M1, VFNCVT_RTZ_X_F_W, 0x0 }, // 1947
  { PseudoVFNCVT_RTZ_X_F_W_M1_MASK, VFNCVT_RTZ_X_F_W, 0x0 }, // 1948
  { PseudoVFNCVT_RTZ_X_F_W_M1_TU, VFNCVT_RTZ_X_F_W, 0x0 }, // 1949
  { PseudoVFNCVT_RTZ_X_F_W_M2, VFNCVT_RTZ_X_F_W, 0x1 }, // 1950
  { PseudoVFNCVT_RTZ_X_F_W_M2_MASK, VFNCVT_RTZ_X_F_W, 0x1 }, // 1951
  { PseudoVFNCVT_RTZ_X_F_W_M2_TU, VFNCVT_RTZ_X_F_W, 0x1 }, // 1952
  { PseudoVFNCVT_RTZ_X_F_W_M4, VFNCVT_RTZ_X_F_W, 0x2 }, // 1953
  { PseudoVFNCVT_RTZ_X_F_W_M4_MASK, VFNCVT_RTZ_X_F_W, 0x2 }, // 1954
  { PseudoVFNCVT_RTZ_X_F_W_M4_TU, VFNCVT_RTZ_X_F_W, 0x2 }, // 1955
  { PseudoVFNCVT_RTZ_X_F_W_MF8, VFNCVT_RTZ_X_F_W, 0x5 }, // 1956
  { PseudoVFNCVT_RTZ_X_F_W_MF8_MASK, VFNCVT_RTZ_X_F_W, 0x5 }, // 1957
  { PseudoVFNCVT_RTZ_X_F_W_MF8_TU, VFNCVT_RTZ_X_F_W, 0x5 }, // 1958
  { PseudoVFNCVT_RTZ_X_F_W_MF4, VFNCVT_RTZ_X_F_W, 0x6 }, // 1959
  { PseudoVFNCVT_RTZ_X_F_W_MF4_MASK, VFNCVT_RTZ_X_F_W, 0x6 }, // 1960
  { PseudoVFNCVT_RTZ_X_F_W_MF4_TU, VFNCVT_RTZ_X_F_W, 0x6 }, // 1961
  { PseudoVFNCVT_RTZ_X_F_W_MF2, VFNCVT_RTZ_X_F_W, 0x7 }, // 1962
  { PseudoVFNCVT_RTZ_X_F_W_MF2_MASK, VFNCVT_RTZ_X_F_W, 0x7 }, // 1963
  { PseudoVFNCVT_RTZ_X_F_W_MF2_TU, VFNCVT_RTZ_X_F_W, 0x7 }, // 1964
  { PseudoVFNCVT_XU_F_W_M1, VFNCVT_XU_F_W, 0x0 }, // 1965
  { PseudoVFNCVT_XU_F_W_M1_MASK, VFNCVT_XU_F_W, 0x0 }, // 1966
  { PseudoVFNCVT_XU_F_W_M1_TU, VFNCVT_XU_F_W, 0x0 }, // 1967
  { PseudoVFNCVT_XU_F_W_M2, VFNCVT_XU_F_W, 0x1 }, // 1968
  { PseudoVFNCVT_XU_F_W_M2_MASK, VFNCVT_XU_F_W, 0x1 }, // 1969
  { PseudoVFNCVT_XU_F_W_M2_TU, VFNCVT_XU_F_W, 0x1 }, // 1970
  { PseudoVFNCVT_XU_F_W_M4, VFNCVT_XU_F_W, 0x2 }, // 1971
  { PseudoVFNCVT_XU_F_W_M4_MASK, VFNCVT_XU_F_W, 0x2 }, // 1972
  { PseudoVFNCVT_XU_F_W_M4_TU, VFNCVT_XU_F_W, 0x2 }, // 1973
  { PseudoVFNCVT_XU_F_W_MF8, VFNCVT_XU_F_W, 0x5 }, // 1974
  { PseudoVFNCVT_XU_F_W_MF8_MASK, VFNCVT_XU_F_W, 0x5 }, // 1975
  { PseudoVFNCVT_XU_F_W_MF8_TU, VFNCVT_XU_F_W, 0x5 }, // 1976
  { PseudoVFNCVT_XU_F_W_MF4, VFNCVT_XU_F_W, 0x6 }, // 1977
  { PseudoVFNCVT_XU_F_W_MF4_MASK, VFNCVT_XU_F_W, 0x6 }, // 1978
  { PseudoVFNCVT_XU_F_W_MF4_TU, VFNCVT_XU_F_W, 0x6 }, // 1979
  { PseudoVFNCVT_XU_F_W_MF2, VFNCVT_XU_F_W, 0x7 }, // 1980
  { PseudoVFNCVT_XU_F_W_MF2_MASK, VFNCVT_XU_F_W, 0x7 }, // 1981
  { PseudoVFNCVT_XU_F_W_MF2_TU, VFNCVT_XU_F_W, 0x7 }, // 1982
  { PseudoVFNCVT_X_F_W_M1, VFNCVT_X_F_W, 0x0 }, // 1983
  { PseudoVFNCVT_X_F_W_M1_MASK, VFNCVT_X_F_W, 0x0 }, // 1984
  { PseudoVFNCVT_X_F_W_M1_TU, VFNCVT_X_F_W, 0x0 }, // 1985
  { PseudoVFNCVT_X_F_W_M2, VFNCVT_X_F_W, 0x1 }, // 1986
  { PseudoVFNCVT_X_F_W_M2_MASK, VFNCVT_X_F_W, 0x1 }, // 1987
  { PseudoVFNCVT_X_F_W_M2_TU, VFNCVT_X_F_W, 0x1 }, // 1988
  { PseudoVFNCVT_X_F_W_M4, VFNCVT_X_F_W, 0x2 }, // 1989
  { PseudoVFNCVT_X_F_W_M4_MASK, VFNCVT_X_F_W, 0x2 }, // 1990
  { PseudoVFNCVT_X_F_W_M4_TU, VFNCVT_X_F_W, 0x2 }, // 1991
  { PseudoVFNCVT_X_F_W_MF8, VFNCVT_X_F_W, 0x5 }, // 1992
  { PseudoVFNCVT_X_F_W_MF8_MASK, VFNCVT_X_F_W, 0x5 }, // 1993
  { PseudoVFNCVT_X_F_W_MF8_TU, VFNCVT_X_F_W, 0x5 }, // 1994
  { PseudoVFNCVT_X_F_W_MF4, VFNCVT_X_F_W, 0x6 }, // 1995
  { PseudoVFNCVT_X_F_W_MF4_MASK, VFNCVT_X_F_W, 0x6 }, // 1996
  { PseudoVFNCVT_X_F_W_MF4_TU, VFNCVT_X_F_W, 0x6 }, // 1997
  { PseudoVFNCVT_X_F_W_MF2, VFNCVT_X_F_W, 0x7 }, // 1998
  { PseudoVFNCVT_X_F_W_MF2_MASK, VFNCVT_X_F_W, 0x7 }, // 1999
  { PseudoVFNCVT_X_F_W_MF2_TU, VFNCVT_X_F_W, 0x7 }, // 2000
  { PseudoVFNMACC_VF16_M1, VFNMACC_VF, 0x0 }, // 2001
  { PseudoVFNMACC_VF16_M1_MASK, VFNMACC_VF, 0x0 }, // 2002
  { PseudoVFNMACC_VF32_M1, VFNMACC_VF, 0x0 }, // 2003
  { PseudoVFNMACC_VF32_M1_MASK, VFNMACC_VF, 0x0 }, // 2004
  { PseudoVFNMACC_VF64_M1, VFNMACC_VF, 0x0 }, // 2005
  { PseudoVFNMACC_VF64_M1_MASK, VFNMACC_VF, 0x0 }, // 2006
  { PseudoVFNMACC_VF16_M2, VFNMACC_VF, 0x1 }, // 2007
  { PseudoVFNMACC_VF16_M2_MASK, VFNMACC_VF, 0x1 }, // 2008
  { PseudoVFNMACC_VF32_M2, VFNMACC_VF, 0x1 }, // 2009
  { PseudoVFNMACC_VF32_M2_MASK, VFNMACC_VF, 0x1 }, // 2010
  { PseudoVFNMACC_VF64_M2, VFNMACC_VF, 0x1 }, // 2011
  { PseudoVFNMACC_VF64_M2_MASK, VFNMACC_VF, 0x1 }, // 2012
  { PseudoVFNMACC_VF16_M4, VFNMACC_VF, 0x2 }, // 2013
  { PseudoVFNMACC_VF16_M4_MASK, VFNMACC_VF, 0x2 }, // 2014
  { PseudoVFNMACC_VF32_M4, VFNMACC_VF, 0x2 }, // 2015
  { PseudoVFNMACC_VF32_M4_MASK, VFNMACC_VF, 0x2 }, // 2016
  { PseudoVFNMACC_VF64_M4, VFNMACC_VF, 0x2 }, // 2017
  { PseudoVFNMACC_VF64_M4_MASK, VFNMACC_VF, 0x2 }, // 2018
  { PseudoVFNMACC_VF16_M8, VFNMACC_VF, 0x3 }, // 2019
  { PseudoVFNMACC_VF16_M8_MASK, VFNMACC_VF, 0x3 }, // 2020
  { PseudoVFNMACC_VF32_M8, VFNMACC_VF, 0x3 }, // 2021
  { PseudoVFNMACC_VF32_M8_MASK, VFNMACC_VF, 0x3 }, // 2022
  { PseudoVFNMACC_VF64_M8, VFNMACC_VF, 0x3 }, // 2023
  { PseudoVFNMACC_VF64_M8_MASK, VFNMACC_VF, 0x3 }, // 2024
  { PseudoVFNMACC_VF16_MF4, VFNMACC_VF, 0x6 }, // 2025
  { PseudoVFNMACC_VF16_MF4_MASK, VFNMACC_VF, 0x6 }, // 2026
  { PseudoVFNMACC_VF16_MF2, VFNMACC_VF, 0x7 }, // 2027
  { PseudoVFNMACC_VF16_MF2_MASK, VFNMACC_VF, 0x7 }, // 2028
  { PseudoVFNMACC_VF32_MF2, VFNMACC_VF, 0x7 }, // 2029
  { PseudoVFNMACC_VF32_MF2_MASK, VFNMACC_VF, 0x7 }, // 2030
  { PseudoVFNMACC_VV_M1, VFNMACC_VV, 0x0 }, // 2031
  { PseudoVFNMACC_VV_M1_MASK, VFNMACC_VV, 0x0 }, // 2032
  { PseudoVFNMACC_VV_M2, VFNMACC_VV, 0x1 }, // 2033
  { PseudoVFNMACC_VV_M2_MASK, VFNMACC_VV, 0x1 }, // 2034
  { PseudoVFNMACC_VV_M4, VFNMACC_VV, 0x2 }, // 2035
  { PseudoVFNMACC_VV_M4_MASK, VFNMACC_VV, 0x2 }, // 2036
  { PseudoVFNMACC_VV_M8, VFNMACC_VV, 0x3 }, // 2037
  { PseudoVFNMACC_VV_M8_MASK, VFNMACC_VV, 0x3 }, // 2038
  { PseudoVFNMACC_VV_MF4, VFNMACC_VV, 0x6 }, // 2039
  { PseudoVFNMACC_VV_MF4_MASK, VFNMACC_VV, 0x6 }, // 2040
  { PseudoVFNMACC_VV_MF2, VFNMACC_VV, 0x7 }, // 2041
  { PseudoVFNMACC_VV_MF2_MASK, VFNMACC_VV, 0x7 }, // 2042
  { PseudoVFNMADD_VF16_M1, VFNMADD_VF, 0x0 }, // 2043
  { PseudoVFNMADD_VF16_M1_MASK, VFNMADD_VF, 0x0 }, // 2044
  { PseudoVFNMADD_VF32_M1, VFNMADD_VF, 0x0 }, // 2045
  { PseudoVFNMADD_VF32_M1_MASK, VFNMADD_VF, 0x0 }, // 2046
  { PseudoVFNMADD_VF64_M1, VFNMADD_VF, 0x0 }, // 2047
  { PseudoVFNMADD_VF64_M1_MASK, VFNMADD_VF, 0x0 }, // 2048
  { PseudoVFNMADD_VF16_M2, VFNMADD_VF, 0x1 }, // 2049
  { PseudoVFNMADD_VF16_M2_MASK, VFNMADD_VF, 0x1 }, // 2050
  { PseudoVFNMADD_VF32_M2, VFNMADD_VF, 0x1 }, // 2051
  { PseudoVFNMADD_VF32_M2_MASK, VFNMADD_VF, 0x1 }, // 2052
  { PseudoVFNMADD_VF64_M2, VFNMADD_VF, 0x1 }, // 2053
  { PseudoVFNMADD_VF64_M2_MASK, VFNMADD_VF, 0x1 }, // 2054
  { PseudoVFNMADD_VF16_M4, VFNMADD_VF, 0x2 }, // 2055
  { PseudoVFNMADD_VF16_M4_MASK, VFNMADD_VF, 0x2 }, // 2056
  { PseudoVFNMADD_VF32_M4, VFNMADD_VF, 0x2 }, // 2057
  { PseudoVFNMADD_VF32_M4_MASK, VFNMADD_VF, 0x2 }, // 2058
  { PseudoVFNMADD_VF64_M4, VFNMADD_VF, 0x2 }, // 2059
  { PseudoVFNMADD_VF64_M4_MASK, VFNMADD_VF, 0x2 }, // 2060
  { PseudoVFNMADD_VF16_M8, VFNMADD_VF, 0x3 }, // 2061
  { PseudoVFNMADD_VF16_M8_MASK, VFNMADD_VF, 0x3 }, // 2062
  { PseudoVFNMADD_VF32_M8, VFNMADD_VF, 0x3 }, // 2063
  { PseudoVFNMADD_VF32_M8_MASK, VFNMADD_VF, 0x3 }, // 2064
  { PseudoVFNMADD_VF64_M8, VFNMADD_VF, 0x3 }, // 2065
  { PseudoVFNMADD_VF64_M8_MASK, VFNMADD_VF, 0x3 }, // 2066
  { PseudoVFNMADD_VF16_MF4, VFNMADD_VF, 0x6 }, // 2067
  { PseudoVFNMADD_VF16_MF4_MASK, VFNMADD_VF, 0x6 }, // 2068
  { PseudoVFNMADD_VF16_MF2, VFNMADD_VF, 0x7 }, // 2069
  { PseudoVFNMADD_VF16_MF2_MASK, VFNMADD_VF, 0x7 }, // 2070
  { PseudoVFNMADD_VF32_MF2, VFNMADD_VF, 0x7 }, // 2071
  { PseudoVFNMADD_VF32_MF2_MASK, VFNMADD_VF, 0x7 }, // 2072
  { PseudoVFNMADD_VV_M1, VFNMADD_VV, 0x0 }, // 2073
  { PseudoVFNMADD_VV_M1_MASK, VFNMADD_VV, 0x0 }, // 2074
  { PseudoVFNMADD_VV_M2, VFNMADD_VV, 0x1 }, // 2075
  { PseudoVFNMADD_VV_M2_MASK, VFNMADD_VV, 0x1 }, // 2076
  { PseudoVFNMADD_VV_M4, VFNMADD_VV, 0x2 }, // 2077
  { PseudoVFNMADD_VV_M4_MASK, VFNMADD_VV, 0x2 }, // 2078
  { PseudoVFNMADD_VV_M8, VFNMADD_VV, 0x3 }, // 2079
  { PseudoVFNMADD_VV_M8_MASK, VFNMADD_VV, 0x3 }, // 2080
  { PseudoVFNMADD_VV_MF4, VFNMADD_VV, 0x6 }, // 2081
  { PseudoVFNMADD_VV_MF4_MASK, VFNMADD_VV, 0x6 }, // 2082
  { PseudoVFNMADD_VV_MF2, VFNMADD_VV, 0x7 }, // 2083
  { PseudoVFNMADD_VV_MF2_MASK, VFNMADD_VV, 0x7 }, // 2084
  { PseudoVFNMSAC_VF16_M1, VFNMSAC_VF, 0x0 }, // 2085
  { PseudoVFNMSAC_VF16_M1_MASK, VFNMSAC_VF, 0x0 }, // 2086
  { PseudoVFNMSAC_VF32_M1, VFNMSAC_VF, 0x0 }, // 2087
  { PseudoVFNMSAC_VF32_M1_MASK, VFNMSAC_VF, 0x0 }, // 2088
  { PseudoVFNMSAC_VF64_M1, VFNMSAC_VF, 0x0 }, // 2089
  { PseudoVFNMSAC_VF64_M1_MASK, VFNMSAC_VF, 0x0 }, // 2090
  { PseudoVFNMSAC_VF16_M2, VFNMSAC_VF, 0x1 }, // 2091
  { PseudoVFNMSAC_VF16_M2_MASK, VFNMSAC_VF, 0x1 }, // 2092
  { PseudoVFNMSAC_VF32_M2, VFNMSAC_VF, 0x1 }, // 2093
  { PseudoVFNMSAC_VF32_M2_MASK, VFNMSAC_VF, 0x1 }, // 2094
  { PseudoVFNMSAC_VF64_M2, VFNMSAC_VF, 0x1 }, // 2095
  { PseudoVFNMSAC_VF64_M2_MASK, VFNMSAC_VF, 0x1 }, // 2096
  { PseudoVFNMSAC_VF16_M4, VFNMSAC_VF, 0x2 }, // 2097
  { PseudoVFNMSAC_VF16_M4_MASK, VFNMSAC_VF, 0x2 }, // 2098
  { PseudoVFNMSAC_VF32_M4, VFNMSAC_VF, 0x2 }, // 2099
  { PseudoVFNMSAC_VF32_M4_MASK, VFNMSAC_VF, 0x2 }, // 2100
  { PseudoVFNMSAC_VF64_M4, VFNMSAC_VF, 0x2 }, // 2101
  { PseudoVFNMSAC_VF64_M4_MASK, VFNMSAC_VF, 0x2 }, // 2102
  { PseudoVFNMSAC_VF16_M8, VFNMSAC_VF, 0x3 }, // 2103
  { PseudoVFNMSAC_VF16_M8_MASK, VFNMSAC_VF, 0x3 }, // 2104
  { PseudoVFNMSAC_VF32_M8, VFNMSAC_VF, 0x3 }, // 2105
  { PseudoVFNMSAC_VF32_M8_MASK, VFNMSAC_VF, 0x3 }, // 2106
  { PseudoVFNMSAC_VF64_M8, VFNMSAC_VF, 0x3 }, // 2107
  { PseudoVFNMSAC_VF64_M8_MASK, VFNMSAC_VF, 0x3 }, // 2108
  { PseudoVFNMSAC_VF16_MF4, VFNMSAC_VF, 0x6 }, // 2109
  { PseudoVFNMSAC_VF16_MF4_MASK, VFNMSAC_VF, 0x6 }, // 2110
  { PseudoVFNMSAC_VF16_MF2, VFNMSAC_VF, 0x7 }, // 2111
  { PseudoVFNMSAC_VF16_MF2_MASK, VFNMSAC_VF, 0x7 }, // 2112
  { PseudoVFNMSAC_VF32_MF2, VFNMSAC_VF, 0x7 }, // 2113
  { PseudoVFNMSAC_VF32_MF2_MASK, VFNMSAC_VF, 0x7 }, // 2114
  { PseudoVFNMSAC_VV_M1, VFNMSAC_VV, 0x0 }, // 2115
  { PseudoVFNMSAC_VV_M1_MASK, VFNMSAC_VV, 0x0 }, // 2116
  { PseudoVFNMSAC_VV_M2, VFNMSAC_VV, 0x1 }, // 2117
  { PseudoVFNMSAC_VV_M2_MASK, VFNMSAC_VV, 0x1 }, // 2118
  { PseudoVFNMSAC_VV_M4, VFNMSAC_VV, 0x2 }, // 2119
  { PseudoVFNMSAC_VV_M4_MASK, VFNMSAC_VV, 0x2 }, // 2120
  { PseudoVFNMSAC_VV_M8, VFNMSAC_VV, 0x3 }, // 2121
  { PseudoVFNMSAC_VV_M8_MASK, VFNMSAC_VV, 0x3 }, // 2122
  { PseudoVFNMSAC_VV_MF4, VFNMSAC_VV, 0x6 }, // 2123
  { PseudoVFNMSAC_VV_MF4_MASK, VFNMSAC_VV, 0x6 }, // 2124
  { PseudoVFNMSAC_VV_MF2, VFNMSAC_VV, 0x7 }, // 2125
  { PseudoVFNMSAC_VV_MF2_MASK, VFNMSAC_VV, 0x7 }, // 2126
  { PseudoVFNMSUB_VF16_M1, VFNMSUB_VF, 0x0 }, // 2127
  { PseudoVFNMSUB_VF16_M1_MASK, VFNMSUB_VF, 0x0 }, // 2128
  { PseudoVFNMSUB_VF32_M1, VFNMSUB_VF, 0x0 }, // 2129
  { PseudoVFNMSUB_VF32_M1_MASK, VFNMSUB_VF, 0x0 }, // 2130
  { PseudoVFNMSUB_VF64_M1, VFNMSUB_VF, 0x0 }, // 2131
  { PseudoVFNMSUB_VF64_M1_MASK, VFNMSUB_VF, 0x0 }, // 2132
  { PseudoVFNMSUB_VF16_M2, VFNMSUB_VF, 0x1 }, // 2133
  { PseudoVFNMSUB_VF16_M2_MASK, VFNMSUB_VF, 0x1 }, // 2134
  { PseudoVFNMSUB_VF32_M2, VFNMSUB_VF, 0x1 }, // 2135
  { PseudoVFNMSUB_VF32_M2_MASK, VFNMSUB_VF, 0x1 }, // 2136
  { PseudoVFNMSUB_VF64_M2, VFNMSUB_VF, 0x1 }, // 2137
  { PseudoVFNMSUB_VF64_M2_MASK, VFNMSUB_VF, 0x1 }, // 2138
  { PseudoVFNMSUB_VF16_M4, VFNMSUB_VF, 0x2 }, // 2139
  { PseudoVFNMSUB_VF16_M4_MASK, VFNMSUB_VF, 0x2 }, // 2140
  { PseudoVFNMSUB_VF32_M4, VFNMSUB_VF, 0x2 }, // 2141
  { PseudoVFNMSUB_VF32_M4_MASK, VFNMSUB_VF, 0x2 }, // 2142
  { PseudoVFNMSUB_VF64_M4, VFNMSUB_VF, 0x2 }, // 2143
  { PseudoVFNMSUB_VF64_M4_MASK, VFNMSUB_VF, 0x2 }, // 2144
  { PseudoVFNMSUB_VF16_M8, VFNMSUB_VF, 0x3 }, // 2145
  { PseudoVFNMSUB_VF16_M8_MASK, VFNMSUB_VF, 0x3 }, // 2146
  { PseudoVFNMSUB_VF32_M8, VFNMSUB_VF, 0x3 }, // 2147
  { PseudoVFNMSUB_VF32_M8_MASK, VFNMSUB_VF, 0x3 }, // 2148
  { PseudoVFNMSUB_VF64_M8, VFNMSUB_VF, 0x3 }, // 2149
  { PseudoVFNMSUB_VF64_M8_MASK, VFNMSUB_VF, 0x3 }, // 2150
  { PseudoVFNMSUB_VF16_MF4, VFNMSUB_VF, 0x6 }, // 2151
  { PseudoVFNMSUB_VF16_MF4_MASK, VFNMSUB_VF, 0x6 }, // 2152
  { PseudoVFNMSUB_VF16_MF2, VFNMSUB_VF, 0x7 }, // 2153
  { PseudoVFNMSUB_VF16_MF2_MASK, VFNMSUB_VF, 0x7 }, // 2154
  { PseudoVFNMSUB_VF32_MF2, VFNMSUB_VF, 0x7 }, // 2155
  { PseudoVFNMSUB_VF32_MF2_MASK, VFNMSUB_VF, 0x7 }, // 2156
  { PseudoVFNMSUB_VV_M1, VFNMSUB_VV, 0x0 }, // 2157
  { PseudoVFNMSUB_VV_M1_MASK, VFNMSUB_VV, 0x0 }, // 2158
  { PseudoVFNMSUB_VV_M2, VFNMSUB_VV, 0x1 }, // 2159
  { PseudoVFNMSUB_VV_M2_MASK, VFNMSUB_VV, 0x1 }, // 2160
  { PseudoVFNMSUB_VV_M4, VFNMSUB_VV, 0x2 }, // 2161
  { PseudoVFNMSUB_VV_M4_MASK, VFNMSUB_VV, 0x2 }, // 2162
  { PseudoVFNMSUB_VV_M8, VFNMSUB_VV, 0x3 }, // 2163
  { PseudoVFNMSUB_VV_M8_MASK, VFNMSUB_VV, 0x3 }, // 2164
  { PseudoVFNMSUB_VV_MF4, VFNMSUB_VV, 0x6 }, // 2165
  { PseudoVFNMSUB_VV_MF4_MASK, VFNMSUB_VV, 0x6 }, // 2166
  { PseudoVFNMSUB_VV_MF2, VFNMSUB_VV, 0x7 }, // 2167
  { PseudoVFNMSUB_VV_MF2_MASK, VFNMSUB_VV, 0x7 }, // 2168
  { PseudoVFRDIV_VF16_M1_E16, VFRDIV_VF, 0x0 }, // 2169
  { PseudoVFRDIV_VF16_M1_E16_MASK, VFRDIV_VF, 0x0 }, // 2170
  { PseudoVFRDIV_VF16_M1_E16_TU, VFRDIV_VF, 0x0 }, // 2171
  { PseudoVFRDIV_VF16_M1_E32, VFRDIV_VF, 0x0 }, // 2172
  { PseudoVFRDIV_VF16_M1_E32_MASK, VFRDIV_VF, 0x0 }, // 2173
  { PseudoVFRDIV_VF16_M1_E32_TU, VFRDIV_VF, 0x0 }, // 2174
  { PseudoVFRDIV_VF16_M1_E64, VFRDIV_VF, 0x0 }, // 2175
  { PseudoVFRDIV_VF16_M1_E64_MASK, VFRDIV_VF, 0x0 }, // 2176
  { PseudoVFRDIV_VF16_M1_E64_TU, VFRDIV_VF, 0x0 }, // 2177
  { PseudoVFRDIV_VF32_M1_E16, VFRDIV_VF, 0x0 }, // 2178
  { PseudoVFRDIV_VF32_M1_E16_MASK, VFRDIV_VF, 0x0 }, // 2179
  { PseudoVFRDIV_VF32_M1_E16_TU, VFRDIV_VF, 0x0 }, // 2180
  { PseudoVFRDIV_VF32_M1_E32, VFRDIV_VF, 0x0 }, // 2181
  { PseudoVFRDIV_VF32_M1_E32_MASK, VFRDIV_VF, 0x0 }, // 2182
  { PseudoVFRDIV_VF32_M1_E32_TU, VFRDIV_VF, 0x0 }, // 2183
  { PseudoVFRDIV_VF32_M1_E64, VFRDIV_VF, 0x0 }, // 2184
  { PseudoVFRDIV_VF32_M1_E64_MASK, VFRDIV_VF, 0x0 }, // 2185
  { PseudoVFRDIV_VF32_M1_E64_TU, VFRDIV_VF, 0x0 }, // 2186
  { PseudoVFRDIV_VF64_M1_E16, VFRDIV_VF, 0x0 }, // 2187
  { PseudoVFRDIV_VF64_M1_E16_MASK, VFRDIV_VF, 0x0 }, // 2188
  { PseudoVFRDIV_VF64_M1_E16_TU, VFRDIV_VF, 0x0 }, // 2189
  { PseudoVFRDIV_VF64_M1_E32, VFRDIV_VF, 0x0 }, // 2190
  { PseudoVFRDIV_VF64_M1_E32_MASK, VFRDIV_VF, 0x0 }, // 2191
  { PseudoVFRDIV_VF64_M1_E32_TU, VFRDIV_VF, 0x0 }, // 2192
  { PseudoVFRDIV_VF64_M1_E64, VFRDIV_VF, 0x0 }, // 2193
  { PseudoVFRDIV_VF64_M1_E64_MASK, VFRDIV_VF, 0x0 }, // 2194
  { PseudoVFRDIV_VF64_M1_E64_TU, VFRDIV_VF, 0x0 }, // 2195
  { PseudoVFRDIV_VF16_M2_E16, VFRDIV_VF, 0x1 }, // 2196
  { PseudoVFRDIV_VF16_M2_E16_MASK, VFRDIV_VF, 0x1 }, // 2197
  { PseudoVFRDIV_VF16_M2_E16_TU, VFRDIV_VF, 0x1 }, // 2198
  { PseudoVFRDIV_VF16_M2_E32, VFRDIV_VF, 0x1 }, // 2199
  { PseudoVFRDIV_VF16_M2_E32_MASK, VFRDIV_VF, 0x1 }, // 2200
  { PseudoVFRDIV_VF16_M2_E32_TU, VFRDIV_VF, 0x1 }, // 2201
  { PseudoVFRDIV_VF16_M2_E64, VFRDIV_VF, 0x1 }, // 2202
  { PseudoVFRDIV_VF16_M2_E64_MASK, VFRDIV_VF, 0x1 }, // 2203
  { PseudoVFRDIV_VF16_M2_E64_TU, VFRDIV_VF, 0x1 }, // 2204
  { PseudoVFRDIV_VF32_M2_E16, VFRDIV_VF, 0x1 }, // 2205
  { PseudoVFRDIV_VF32_M2_E16_MASK, VFRDIV_VF, 0x1 }, // 2206
  { PseudoVFRDIV_VF32_M2_E16_TU, VFRDIV_VF, 0x1 }, // 2207
  { PseudoVFRDIV_VF32_M2_E32, VFRDIV_VF, 0x1 }, // 2208
  { PseudoVFRDIV_VF32_M2_E32_MASK, VFRDIV_VF, 0x1 }, // 2209
  { PseudoVFRDIV_VF32_M2_E32_TU, VFRDIV_VF, 0x1 }, // 2210
  { PseudoVFRDIV_VF32_M2_E64, VFRDIV_VF, 0x1 }, // 2211
  { PseudoVFRDIV_VF32_M2_E64_MASK, VFRDIV_VF, 0x1 }, // 2212
  { PseudoVFRDIV_VF32_M2_E64_TU, VFRDIV_VF, 0x1 }, // 2213
  { PseudoVFRDIV_VF64_M2_E16, VFRDIV_VF, 0x1 }, // 2214
  { PseudoVFRDIV_VF64_M2_E16_MASK, VFRDIV_VF, 0x1 }, // 2215
  { PseudoVFRDIV_VF64_M2_E16_TU, VFRDIV_VF, 0x1 }, // 2216
  { PseudoVFRDIV_VF64_M2_E32, VFRDIV_VF, 0x1 }, // 2217
  { PseudoVFRDIV_VF64_M2_E32_MASK, VFRDIV_VF, 0x1 }, // 2218
  { PseudoVFRDIV_VF64_M2_E32_TU, VFRDIV_VF, 0x1 }, // 2219
  { PseudoVFRDIV_VF64_M2_E64, VFRDIV_VF, 0x1 }, // 2220
  { PseudoVFRDIV_VF64_M2_E64_MASK, VFRDIV_VF, 0x1 }, // 2221
  { PseudoVFRDIV_VF64_M2_E64_TU, VFRDIV_VF, 0x1 }, // 2222
  { PseudoVFRDIV_VF16_M4_E16, VFRDIV_VF, 0x2 }, // 2223
  { PseudoVFRDIV_VF16_M4_E16_MASK, VFRDIV_VF, 0x2 }, // 2224
  { PseudoVFRDIV_VF16_M4_E16_TU, VFRDIV_VF, 0x2 }, // 2225
  { PseudoVFRDIV_VF16_M4_E32, VFRDIV_VF, 0x2 }, // 2226
  { PseudoVFRDIV_VF16_M4_E32_MASK, VFRDIV_VF, 0x2 }, // 2227
  { PseudoVFRDIV_VF16_M4_E32_TU, VFRDIV_VF, 0x2 }, // 2228
  { PseudoVFRDIV_VF16_M4_E64, VFRDIV_VF, 0x2 }, // 2229
  { PseudoVFRDIV_VF16_M4_E64_MASK, VFRDIV_VF, 0x2 }, // 2230
  { PseudoVFRDIV_VF16_M4_E64_TU, VFRDIV_VF, 0x2 }, // 2231
  { PseudoVFRDIV_VF32_M4_E16, VFRDIV_VF, 0x2 }, // 2232
  { PseudoVFRDIV_VF32_M4_E16_MASK, VFRDIV_VF, 0x2 }, // 2233
  { PseudoVFRDIV_VF32_M4_E16_TU, VFRDIV_VF, 0x2 }, // 2234
  { PseudoVFRDIV_VF32_M4_E32, VFRDIV_VF, 0x2 }, // 2235
  { PseudoVFRDIV_VF32_M4_E32_MASK, VFRDIV_VF, 0x2 }, // 2236
  { PseudoVFRDIV_VF32_M4_E32_TU, VFRDIV_VF, 0x2 }, // 2237
  { PseudoVFRDIV_VF32_M4_E64, VFRDIV_VF, 0x2 }, // 2238
  { PseudoVFRDIV_VF32_M4_E64_MASK, VFRDIV_VF, 0x2 }, // 2239
  { PseudoVFRDIV_VF32_M4_E64_TU, VFRDIV_VF, 0x2 }, // 2240
  { PseudoVFRDIV_VF64_M4_E16, VFRDIV_VF, 0x2 }, // 2241
  { PseudoVFRDIV_VF64_M4_E16_MASK, VFRDIV_VF, 0x2 }, // 2242
  { PseudoVFRDIV_VF64_M4_E16_TU, VFRDIV_VF, 0x2 }, // 2243
  { PseudoVFRDIV_VF64_M4_E32, VFRDIV_VF, 0x2 }, // 2244
  { PseudoVFRDIV_VF64_M4_E32_MASK, VFRDIV_VF, 0x2 }, // 2245
  { PseudoVFRDIV_VF64_M4_E32_TU, VFRDIV_VF, 0x2 }, // 2246
  { PseudoVFRDIV_VF64_M4_E64, VFRDIV_VF, 0x2 }, // 2247
  { PseudoVFRDIV_VF64_M4_E64_MASK, VFRDIV_VF, 0x2 }, // 2248
  { PseudoVFRDIV_VF64_M4_E64_TU, VFRDIV_VF, 0x2 }, // 2249
  { PseudoVFRDIV_VF16_M8_E16, VFRDIV_VF, 0x3 }, // 2250
  { PseudoVFRDIV_VF16_M8_E16_MASK, VFRDIV_VF, 0x3 }, // 2251
  { PseudoVFRDIV_VF16_M8_E16_TU, VFRDIV_VF, 0x3 }, // 2252
  { PseudoVFRDIV_VF16_M8_E32, VFRDIV_VF, 0x3 }, // 2253
  { PseudoVFRDIV_VF16_M8_E32_MASK, VFRDIV_VF, 0x3 }, // 2254
  { PseudoVFRDIV_VF16_M8_E32_TU, VFRDIV_VF, 0x3 }, // 2255
  { PseudoVFRDIV_VF16_M8_E64, VFRDIV_VF, 0x3 }, // 2256
  { PseudoVFRDIV_VF16_M8_E64_MASK, VFRDIV_VF, 0x3 }, // 2257
  { PseudoVFRDIV_VF16_M8_E64_TU, VFRDIV_VF, 0x3 }, // 2258
  { PseudoVFRDIV_VF32_M8_E16, VFRDIV_VF, 0x3 }, // 2259
  { PseudoVFRDIV_VF32_M8_E16_MASK, VFRDIV_VF, 0x3 }, // 2260
  { PseudoVFRDIV_VF32_M8_E16_TU, VFRDIV_VF, 0x3 }, // 2261
  { PseudoVFRDIV_VF32_M8_E32, VFRDIV_VF, 0x3 }, // 2262
  { PseudoVFRDIV_VF32_M8_E32_MASK, VFRDIV_VF, 0x3 }, // 2263
  { PseudoVFRDIV_VF32_M8_E32_TU, VFRDIV_VF, 0x3 }, // 2264
  { PseudoVFRDIV_VF32_M8_E64, VFRDIV_VF, 0x3 }, // 2265
  { PseudoVFRDIV_VF32_M8_E64_MASK, VFRDIV_VF, 0x3 }, // 2266
  { PseudoVFRDIV_VF32_M8_E64_TU, VFRDIV_VF, 0x3 }, // 2267
  { PseudoVFRDIV_VF64_M8_E16, VFRDIV_VF, 0x3 }, // 2268
  { PseudoVFRDIV_VF64_M8_E16_MASK, VFRDIV_VF, 0x3 }, // 2269
  { PseudoVFRDIV_VF64_M8_E16_TU, VFRDIV_VF, 0x3 }, // 2270
  { PseudoVFRDIV_VF64_M8_E32, VFRDIV_VF, 0x3 }, // 2271
  { PseudoVFRDIV_VF64_M8_E32_MASK, VFRDIV_VF, 0x3 }, // 2272
  { PseudoVFRDIV_VF64_M8_E32_TU, VFRDIV_VF, 0x3 }, // 2273
  { PseudoVFRDIV_VF64_M8_E64, VFRDIV_VF, 0x3 }, // 2274
  { PseudoVFRDIV_VF64_M8_E64_MASK, VFRDIV_VF, 0x3 }, // 2275
  { PseudoVFRDIV_VF64_M8_E64_TU, VFRDIV_VF, 0x3 }, // 2276
  { PseudoVFRDIV_VF16_MF4_E16, VFRDIV_VF, 0x6 }, // 2277
  { PseudoVFRDIV_VF16_MF4_E16_MASK, VFRDIV_VF, 0x6 }, // 2278
  { PseudoVFRDIV_VF16_MF4_E16_TU, VFRDIV_VF, 0x6 }, // 2279
  { PseudoVFRDIV_VF16_MF2_E16, VFRDIV_VF, 0x7 }, // 2280
  { PseudoVFRDIV_VF16_MF2_E16_MASK, VFRDIV_VF, 0x7 }, // 2281
  { PseudoVFRDIV_VF16_MF2_E16_TU, VFRDIV_VF, 0x7 }, // 2282
  { PseudoVFRDIV_VF16_MF2_E32, VFRDIV_VF, 0x7 }, // 2283
  { PseudoVFRDIV_VF16_MF2_E32_MASK, VFRDIV_VF, 0x7 }, // 2284
  { PseudoVFRDIV_VF16_MF2_E32_TU, VFRDIV_VF, 0x7 }, // 2285
  { PseudoVFRDIV_VF32_MF2_E16, VFRDIV_VF, 0x7 }, // 2286
  { PseudoVFRDIV_VF32_MF2_E16_MASK, VFRDIV_VF, 0x7 }, // 2287
  { PseudoVFRDIV_VF32_MF2_E16_TU, VFRDIV_VF, 0x7 }, // 2288
  { PseudoVFRDIV_VF32_MF2_E32, VFRDIV_VF, 0x7 }, // 2289
  { PseudoVFRDIV_VF32_MF2_E32_MASK, VFRDIV_VF, 0x7 }, // 2290
  { PseudoVFRDIV_VF32_MF2_E32_TU, VFRDIV_VF, 0x7 }, // 2291
  { PseudoVFREC7_V_M1, VFREC7_V, 0x0 }, // 2292
  { PseudoVFREC7_V_M1_MASK, VFREC7_V, 0x0 }, // 2293
  { PseudoVFREC7_V_M1_TU, VFREC7_V, 0x0 }, // 2294
  { PseudoVFREC7_V_M2, VFREC7_V, 0x1 }, // 2295
  { PseudoVFREC7_V_M2_MASK, VFREC7_V, 0x1 }, // 2296
  { PseudoVFREC7_V_M2_TU, VFREC7_V, 0x1 }, // 2297
  { PseudoVFREC7_V_M4, VFREC7_V, 0x2 }, // 2298
  { PseudoVFREC7_V_M4_MASK, VFREC7_V, 0x2 }, // 2299
  { PseudoVFREC7_V_M4_TU, VFREC7_V, 0x2 }, // 2300
  { PseudoVFREC7_V_M8, VFREC7_V, 0x3 }, // 2301
  { PseudoVFREC7_V_M8_MASK, VFREC7_V, 0x3 }, // 2302
  { PseudoVFREC7_V_M8_TU, VFREC7_V, 0x3 }, // 2303
  { PseudoVFREC7_V_MF4, VFREC7_V, 0x6 }, // 2304
  { PseudoVFREC7_V_MF4_MASK, VFREC7_V, 0x6 }, // 2305
  { PseudoVFREC7_V_MF4_TU, VFREC7_V, 0x6 }, // 2306
  { PseudoVFREC7_V_MF2, VFREC7_V, 0x7 }, // 2307
  { PseudoVFREC7_V_MF2_MASK, VFREC7_V, 0x7 }, // 2308
  { PseudoVFREC7_V_MF2_TU, VFREC7_V, 0x7 }, // 2309
  { PseudoVFREDMAX_VS_M1_E16, VFREDMAX_VS, 0x0 }, // 2310
  { PseudoVFREDMAX_VS_M1_E16_MASK, VFREDMAX_VS, 0x0 }, // 2311
  { PseudoVFREDMAX_VS_M1_E32, VFREDMAX_VS, 0x0 }, // 2312
  { PseudoVFREDMAX_VS_M1_E32_MASK, VFREDMAX_VS, 0x0 }, // 2313
  { PseudoVFREDMAX_VS_M1_E64, VFREDMAX_VS, 0x0 }, // 2314
  { PseudoVFREDMAX_VS_M1_E64_MASK, VFREDMAX_VS, 0x0 }, // 2315
  { PseudoVFREDMAX_VS_M2_E16, VFREDMAX_VS, 0x1 }, // 2316
  { PseudoVFREDMAX_VS_M2_E16_MASK, VFREDMAX_VS, 0x1 }, // 2317
  { PseudoVFREDMAX_VS_M2_E32, VFREDMAX_VS, 0x1 }, // 2318
  { PseudoVFREDMAX_VS_M2_E32_MASK, VFREDMAX_VS, 0x1 }, // 2319
  { PseudoVFREDMAX_VS_M2_E64, VFREDMAX_VS, 0x1 }, // 2320
  { PseudoVFREDMAX_VS_M2_E64_MASK, VFREDMAX_VS, 0x1 }, // 2321
  { PseudoVFREDMAX_VS_M4_E16, VFREDMAX_VS, 0x2 }, // 2322
  { PseudoVFREDMAX_VS_M4_E16_MASK, VFREDMAX_VS, 0x2 }, // 2323
  { PseudoVFREDMAX_VS_M4_E32, VFREDMAX_VS, 0x2 }, // 2324
  { PseudoVFREDMAX_VS_M4_E32_MASK, VFREDMAX_VS, 0x2 }, // 2325
  { PseudoVFREDMAX_VS_M4_E64, VFREDMAX_VS, 0x2 }, // 2326
  { PseudoVFREDMAX_VS_M4_E64_MASK, VFREDMAX_VS, 0x2 }, // 2327
  { PseudoVFREDMAX_VS_M8_E16, VFREDMAX_VS, 0x3 }, // 2328
  { PseudoVFREDMAX_VS_M8_E16_MASK, VFREDMAX_VS, 0x3 }, // 2329
  { PseudoVFREDMAX_VS_M8_E32, VFREDMAX_VS, 0x3 }, // 2330
  { PseudoVFREDMAX_VS_M8_E32_MASK, VFREDMAX_VS, 0x3 }, // 2331
  { PseudoVFREDMAX_VS_M8_E64, VFREDMAX_VS, 0x3 }, // 2332
  { PseudoVFREDMAX_VS_M8_E64_MASK, VFREDMAX_VS, 0x3 }, // 2333
  { PseudoVFREDMAX_VS_MF4_E16, VFREDMAX_VS, 0x6 }, // 2334
  { PseudoVFREDMAX_VS_MF4_E16_MASK, VFREDMAX_VS, 0x6 }, // 2335
  { PseudoVFREDMAX_VS_MF2_E16, VFREDMAX_VS, 0x7 }, // 2336
  { PseudoVFREDMAX_VS_MF2_E16_MASK, VFREDMAX_VS, 0x7 }, // 2337
  { PseudoVFREDMAX_VS_MF2_E32, VFREDMAX_VS, 0x7 }, // 2338
  { PseudoVFREDMAX_VS_MF2_E32_MASK, VFREDMAX_VS, 0x7 }, // 2339
  { PseudoVFREDMIN_VS_M1_E16, VFREDMIN_VS, 0x0 }, // 2340
  { PseudoVFREDMIN_VS_M1_E16_MASK, VFREDMIN_VS, 0x0 }, // 2341
  { PseudoVFREDMIN_VS_M1_E32, VFREDMIN_VS, 0x0 }, // 2342
  { PseudoVFREDMIN_VS_M1_E32_MASK, VFREDMIN_VS, 0x0 }, // 2343
  { PseudoVFREDMIN_VS_M1_E64, VFREDMIN_VS, 0x0 }, // 2344
  { PseudoVFREDMIN_VS_M1_E64_MASK, VFREDMIN_VS, 0x0 }, // 2345
  { PseudoVFREDMIN_VS_M2_E16, VFREDMIN_VS, 0x1 }, // 2346
  { PseudoVFREDMIN_VS_M2_E16_MASK, VFREDMIN_VS, 0x1 }, // 2347
  { PseudoVFREDMIN_VS_M2_E32, VFREDMIN_VS, 0x1 }, // 2348
  { PseudoVFREDMIN_VS_M2_E32_MASK, VFREDMIN_VS, 0x1 }, // 2349
  { PseudoVFREDMIN_VS_M2_E64, VFREDMIN_VS, 0x1 }, // 2350
  { PseudoVFREDMIN_VS_M2_E64_MASK, VFREDMIN_VS, 0x1 }, // 2351
  { PseudoVFREDMIN_VS_M4_E16, VFREDMIN_VS, 0x2 }, // 2352
  { PseudoVFREDMIN_VS_M4_E16_MASK, VFREDMIN_VS, 0x2 }, // 2353
  { PseudoVFREDMIN_VS_M4_E32, VFREDMIN_VS, 0x2 }, // 2354
  { PseudoVFREDMIN_VS_M4_E32_MASK, VFREDMIN_VS, 0x2 }, // 2355
  { PseudoVFREDMIN_VS_M4_E64, VFREDMIN_VS, 0x2 }, // 2356
  { PseudoVFREDMIN_VS_M4_E64_MASK, VFREDMIN_VS, 0x2 }, // 2357
  { PseudoVFREDMIN_VS_M8_E16, VFREDMIN_VS, 0x3 }, // 2358
  { PseudoVFREDMIN_VS_M8_E16_MASK, VFREDMIN_VS, 0x3 }, // 2359
  { PseudoVFREDMIN_VS_M8_E32, VFREDMIN_VS, 0x3 }, // 2360
  { PseudoVFREDMIN_VS_M8_E32_MASK, VFREDMIN_VS, 0x3 }, // 2361
  { PseudoVFREDMIN_VS_M8_E64, VFREDMIN_VS, 0x3 }, // 2362
  { PseudoVFREDMIN_VS_M8_E64_MASK, VFREDMIN_VS, 0x3 }, // 2363
  { PseudoVFREDMIN_VS_MF4_E16, VFREDMIN_VS, 0x6 }, // 2364
  { PseudoVFREDMIN_VS_MF4_E16_MASK, VFREDMIN_VS, 0x6 }, // 2365
  { PseudoVFREDMIN_VS_MF2_E16, VFREDMIN_VS, 0x7 }, // 2366
  { PseudoVFREDMIN_VS_MF2_E16_MASK, VFREDMIN_VS, 0x7 }, // 2367
  { PseudoVFREDMIN_VS_MF2_E32, VFREDMIN_VS, 0x7 }, // 2368
  { PseudoVFREDMIN_VS_MF2_E32_MASK, VFREDMIN_VS, 0x7 }, // 2369
  { PseudoVFREDOSUM_VS_M1_E16, VFREDOSUM_VS, 0x0 }, // 2370
  { PseudoVFREDOSUM_VS_M1_E16_MASK, VFREDOSUM_VS, 0x0 }, // 2371
  { PseudoVFREDOSUM_VS_M1_E32, VFREDOSUM_VS, 0x0 }, // 2372
  { PseudoVFREDOSUM_VS_M1_E32_MASK, VFREDOSUM_VS, 0x0 }, // 2373
  { PseudoVFREDOSUM_VS_M1_E64, VFREDOSUM_VS, 0x0 }, // 2374
  { PseudoVFREDOSUM_VS_M1_E64_MASK, VFREDOSUM_VS, 0x0 }, // 2375
  { PseudoVFREDOSUM_VS_M2_E16, VFREDOSUM_VS, 0x1 }, // 2376
  { PseudoVFREDOSUM_VS_M2_E16_MASK, VFREDOSUM_VS, 0x1 }, // 2377
  { PseudoVFREDOSUM_VS_M2_E32, VFREDOSUM_VS, 0x1 }, // 2378
  { PseudoVFREDOSUM_VS_M2_E32_MASK, VFREDOSUM_VS, 0x1 }, // 2379
  { PseudoVFREDOSUM_VS_M2_E64, VFREDOSUM_VS, 0x1 }, // 2380
  { PseudoVFREDOSUM_VS_M2_E64_MASK, VFREDOSUM_VS, 0x1 }, // 2381
  { PseudoVFREDOSUM_VS_M4_E16, VFREDOSUM_VS, 0x2 }, // 2382
  { PseudoVFREDOSUM_VS_M4_E16_MASK, VFREDOSUM_VS, 0x2 }, // 2383
  { PseudoVFREDOSUM_VS_M4_E32, VFREDOSUM_VS, 0x2 }, // 2384
  { PseudoVFREDOSUM_VS_M4_E32_MASK, VFREDOSUM_VS, 0x2 }, // 2385
  { PseudoVFREDOSUM_VS_M4_E64, VFREDOSUM_VS, 0x2 }, // 2386
  { PseudoVFREDOSUM_VS_M4_E64_MASK, VFREDOSUM_VS, 0x2 }, // 2387
  { PseudoVFREDOSUM_VS_M8_E16, VFREDOSUM_VS, 0x3 }, // 2388
  { PseudoVFREDOSUM_VS_M8_E16_MASK, VFREDOSUM_VS, 0x3 }, // 2389
  { PseudoVFREDOSUM_VS_M8_E32, VFREDOSUM_VS, 0x3 }, // 2390
  { PseudoVFREDOSUM_VS_M8_E32_MASK, VFREDOSUM_VS, 0x3 }, // 2391
  { PseudoVFREDOSUM_VS_M8_E64, VFREDOSUM_VS, 0x3 }, // 2392
  { PseudoVFREDOSUM_VS_M8_E64_MASK, VFREDOSUM_VS, 0x3 }, // 2393
  { PseudoVFREDOSUM_VS_MF4_E16, VFREDOSUM_VS, 0x6 }, // 2394
  { PseudoVFREDOSUM_VS_MF4_E16_MASK, VFREDOSUM_VS, 0x6 }, // 2395
  { PseudoVFREDOSUM_VS_MF2_E16, VFREDOSUM_VS, 0x7 }, // 2396
  { PseudoVFREDOSUM_VS_MF2_E16_MASK, VFREDOSUM_VS, 0x7 }, // 2397
  { PseudoVFREDOSUM_VS_MF2_E32, VFREDOSUM_VS, 0x7 }, // 2398
  { PseudoVFREDOSUM_VS_MF2_E32_MASK, VFREDOSUM_VS, 0x7 }, // 2399
  { PseudoVFREDUSUM_VS_M1_E16, VFREDUSUM_VS, 0x0 }, // 2400
  { PseudoVFREDUSUM_VS_M1_E16_MASK, VFREDUSUM_VS, 0x0 }, // 2401
  { PseudoVFREDUSUM_VS_M1_E32, VFREDUSUM_VS, 0x0 }, // 2402
  { PseudoVFREDUSUM_VS_M1_E32_MASK, VFREDUSUM_VS, 0x0 }, // 2403
  { PseudoVFREDUSUM_VS_M1_E64, VFREDUSUM_VS, 0x0 }, // 2404
  { PseudoVFREDUSUM_VS_M1_E64_MASK, VFREDUSUM_VS, 0x0 }, // 2405
  { PseudoVFREDUSUM_VS_M2_E16, VFREDUSUM_VS, 0x1 }, // 2406
  { PseudoVFREDUSUM_VS_M2_E16_MASK, VFREDUSUM_VS, 0x1 }, // 2407
  { PseudoVFREDUSUM_VS_M2_E32, VFREDUSUM_VS, 0x1 }, // 2408
  { PseudoVFREDUSUM_VS_M2_E32_MASK, VFREDUSUM_VS, 0x1 }, // 2409
  { PseudoVFREDUSUM_VS_M2_E64, VFREDUSUM_VS, 0x1 }, // 2410
  { PseudoVFREDUSUM_VS_M2_E64_MASK, VFREDUSUM_VS, 0x1 }, // 2411
  { PseudoVFREDUSUM_VS_M4_E16, VFREDUSUM_VS, 0x2 }, // 2412
  { PseudoVFREDUSUM_VS_M4_E16_MASK, VFREDUSUM_VS, 0x2 }, // 2413
  { PseudoVFREDUSUM_VS_M4_E32, VFREDUSUM_VS, 0x2 }, // 2414
  { PseudoVFREDUSUM_VS_M4_E32_MASK, VFREDUSUM_VS, 0x2 }, // 2415
  { PseudoVFREDUSUM_VS_M4_E64, VFREDUSUM_VS, 0x2 }, // 2416
  { PseudoVFREDUSUM_VS_M4_E64_MASK, VFREDUSUM_VS, 0x2 }, // 2417
  { PseudoVFREDUSUM_VS_M8_E16, VFREDUSUM_VS, 0x3 }, // 2418
  { PseudoVFREDUSUM_VS_M8_E16_MASK, VFREDUSUM_VS, 0x3 }, // 2419
  { PseudoVFREDUSUM_VS_M8_E32, VFREDUSUM_VS, 0x3 }, // 2420
  { PseudoVFREDUSUM_VS_M8_E32_MASK, VFREDUSUM_VS, 0x3 }, // 2421
  { PseudoVFREDUSUM_VS_M8_E64, VFREDUSUM_VS, 0x3 }, // 2422
  { PseudoVFREDUSUM_VS_M8_E64_MASK, VFREDUSUM_VS, 0x3 }, // 2423
  { PseudoVFREDUSUM_VS_MF4_E16, VFREDUSUM_VS, 0x6 }, // 2424
  { PseudoVFREDUSUM_VS_MF4_E16_MASK, VFREDUSUM_VS, 0x6 }, // 2425
  { PseudoVFREDUSUM_VS_MF2_E16, VFREDUSUM_VS, 0x7 }, // 2426
  { PseudoVFREDUSUM_VS_MF2_E16_MASK, VFREDUSUM_VS, 0x7 }, // 2427
  { PseudoVFREDUSUM_VS_MF2_E32, VFREDUSUM_VS, 0x7 }, // 2428
  { PseudoVFREDUSUM_VS_MF2_E32_MASK, VFREDUSUM_VS, 0x7 }, // 2429
  { PseudoVFRSQRT7_V_M1, VFRSQRT7_V, 0x0 }, // 2430
  { PseudoVFRSQRT7_V_M1_MASK, VFRSQRT7_V, 0x0 }, // 2431
  { PseudoVFRSQRT7_V_M1_TU, VFRSQRT7_V, 0x0 }, // 2432
  { PseudoVFRSQRT7_V_M2, VFRSQRT7_V, 0x1 }, // 2433
  { PseudoVFRSQRT7_V_M2_MASK, VFRSQRT7_V, 0x1 }, // 2434
  { PseudoVFRSQRT7_V_M2_TU, VFRSQRT7_V, 0x1 }, // 2435
  { PseudoVFRSQRT7_V_M4, VFRSQRT7_V, 0x2 }, // 2436
  { PseudoVFRSQRT7_V_M4_MASK, VFRSQRT7_V, 0x2 }, // 2437
  { PseudoVFRSQRT7_V_M4_TU, VFRSQRT7_V, 0x2 }, // 2438
  { PseudoVFRSQRT7_V_M8, VFRSQRT7_V, 0x3 }, // 2439
  { PseudoVFRSQRT7_V_M8_MASK, VFRSQRT7_V, 0x3 }, // 2440
  { PseudoVFRSQRT7_V_M8_TU, VFRSQRT7_V, 0x3 }, // 2441
  { PseudoVFRSQRT7_V_MF4, VFRSQRT7_V, 0x6 }, // 2442
  { PseudoVFRSQRT7_V_MF4_MASK, VFRSQRT7_V, 0x6 }, // 2443
  { PseudoVFRSQRT7_V_MF4_TU, VFRSQRT7_V, 0x6 }, // 2444
  { PseudoVFRSQRT7_V_MF2, VFRSQRT7_V, 0x7 }, // 2445
  { PseudoVFRSQRT7_V_MF2_MASK, VFRSQRT7_V, 0x7 }, // 2446
  { PseudoVFRSQRT7_V_MF2_TU, VFRSQRT7_V, 0x7 }, // 2447
  { PseudoVFRSUB_VF16_M1, VFRSUB_VF, 0x0 }, // 2448
  { PseudoVFRSUB_VF16_M1_MASK, VFRSUB_VF, 0x0 }, // 2449
  { PseudoVFRSUB_VF16_M1_TU, VFRSUB_VF, 0x0 }, // 2450
  { PseudoVFRSUB_VF32_M1, VFRSUB_VF, 0x0 }, // 2451
  { PseudoVFRSUB_VF32_M1_MASK, VFRSUB_VF, 0x0 }, // 2452
  { PseudoVFRSUB_VF32_M1_TU, VFRSUB_VF, 0x0 }, // 2453
  { PseudoVFRSUB_VF64_M1, VFRSUB_VF, 0x0 }, // 2454
  { PseudoVFRSUB_VF64_M1_MASK, VFRSUB_VF, 0x0 }, // 2455
  { PseudoVFRSUB_VF64_M1_TU, VFRSUB_VF, 0x0 }, // 2456
  { PseudoVFRSUB_VF16_M2, VFRSUB_VF, 0x1 }, // 2457
  { PseudoVFRSUB_VF16_M2_MASK, VFRSUB_VF, 0x1 }, // 2458
  { PseudoVFRSUB_VF16_M2_TU, VFRSUB_VF, 0x1 }, // 2459
  { PseudoVFRSUB_VF32_M2, VFRSUB_VF, 0x1 }, // 2460
  { PseudoVFRSUB_VF32_M2_MASK, VFRSUB_VF, 0x1 }, // 2461
  { PseudoVFRSUB_VF32_M2_TU, VFRSUB_VF, 0x1 }, // 2462
  { PseudoVFRSUB_VF64_M2, VFRSUB_VF, 0x1 }, // 2463
  { PseudoVFRSUB_VF64_M2_MASK, VFRSUB_VF, 0x1 }, // 2464
  { PseudoVFRSUB_VF64_M2_TU, VFRSUB_VF, 0x1 }, // 2465
  { PseudoVFRSUB_VF16_M4, VFRSUB_VF, 0x2 }, // 2466
  { PseudoVFRSUB_VF16_M4_MASK, VFRSUB_VF, 0x2 }, // 2467
  { PseudoVFRSUB_VF16_M4_TU, VFRSUB_VF, 0x2 }, // 2468
  { PseudoVFRSUB_VF32_M4, VFRSUB_VF, 0x2 }, // 2469
  { PseudoVFRSUB_VF32_M4_MASK, VFRSUB_VF, 0x2 }, // 2470
  { PseudoVFRSUB_VF32_M4_TU, VFRSUB_VF, 0x2 }, // 2471
  { PseudoVFRSUB_VF64_M4, VFRSUB_VF, 0x2 }, // 2472
  { PseudoVFRSUB_VF64_M4_MASK, VFRSUB_VF, 0x2 }, // 2473
  { PseudoVFRSUB_VF64_M4_TU, VFRSUB_VF, 0x2 }, // 2474
  { PseudoVFRSUB_VF16_M8, VFRSUB_VF, 0x3 }, // 2475
  { PseudoVFRSUB_VF16_M8_MASK, VFRSUB_VF, 0x3 }, // 2476
  { PseudoVFRSUB_VF16_M8_TU, VFRSUB_VF, 0x3 }, // 2477
  { PseudoVFRSUB_VF32_M8, VFRSUB_VF, 0x3 }, // 2478
  { PseudoVFRSUB_VF32_M8_MASK, VFRSUB_VF, 0x3 }, // 2479
  { PseudoVFRSUB_VF32_M8_TU, VFRSUB_VF, 0x3 }, // 2480
  { PseudoVFRSUB_VF64_M8, VFRSUB_VF, 0x3 }, // 2481
  { PseudoVFRSUB_VF64_M8_MASK, VFRSUB_VF, 0x3 }, // 2482
  { PseudoVFRSUB_VF64_M8_TU, VFRSUB_VF, 0x3 }, // 2483
  { PseudoVFRSUB_VF16_MF4, VFRSUB_VF, 0x6 }, // 2484
  { PseudoVFRSUB_VF16_MF4_MASK, VFRSUB_VF, 0x6 }, // 2485
  { PseudoVFRSUB_VF16_MF4_TU, VFRSUB_VF, 0x6 }, // 2486
  { PseudoVFRSUB_VF16_MF2, VFRSUB_VF, 0x7 }, // 2487
  { PseudoVFRSUB_VF16_MF2_MASK, VFRSUB_VF, 0x7 }, // 2488
  { PseudoVFRSUB_VF16_MF2_TU, VFRSUB_VF, 0x7 }, // 2489
  { PseudoVFRSUB_VF32_MF2, VFRSUB_VF, 0x7 }, // 2490
  { PseudoVFRSUB_VF32_MF2_MASK, VFRSUB_VF, 0x7 }, // 2491
  { PseudoVFRSUB_VF32_MF2_TU, VFRSUB_VF, 0x7 }, // 2492
  { PseudoVFSGNJN_VF16_M1, VFSGNJN_VF, 0x0 }, // 2493
  { PseudoVFSGNJN_VF16_M1_MASK, VFSGNJN_VF, 0x0 }, // 2494
  { PseudoVFSGNJN_VF16_M1_TU, VFSGNJN_VF, 0x0 }, // 2495
  { PseudoVFSGNJN_VF32_M1, VFSGNJN_VF, 0x0 }, // 2496
  { PseudoVFSGNJN_VF32_M1_MASK, VFSGNJN_VF, 0x0 }, // 2497
  { PseudoVFSGNJN_VF32_M1_TU, VFSGNJN_VF, 0x0 }, // 2498
  { PseudoVFSGNJN_VF64_M1, VFSGNJN_VF, 0x0 }, // 2499
  { PseudoVFSGNJN_VF64_M1_MASK, VFSGNJN_VF, 0x0 }, // 2500
  { PseudoVFSGNJN_VF64_M1_TU, VFSGNJN_VF, 0x0 }, // 2501
  { PseudoVFSGNJN_VF16_M2, VFSGNJN_VF, 0x1 }, // 2502
  { PseudoVFSGNJN_VF16_M2_MASK, VFSGNJN_VF, 0x1 }, // 2503
  { PseudoVFSGNJN_VF16_M2_TU, VFSGNJN_VF, 0x1 }, // 2504
  { PseudoVFSGNJN_VF32_M2, VFSGNJN_VF, 0x1 }, // 2505
  { PseudoVFSGNJN_VF32_M2_MASK, VFSGNJN_VF, 0x1 }, // 2506
  { PseudoVFSGNJN_VF32_M2_TU, VFSGNJN_VF, 0x1 }, // 2507
  { PseudoVFSGNJN_VF64_M2, VFSGNJN_VF, 0x1 }, // 2508
  { PseudoVFSGNJN_VF64_M2_MASK, VFSGNJN_VF, 0x1 }, // 2509
  { PseudoVFSGNJN_VF64_M2_TU, VFSGNJN_VF, 0x1 }, // 2510
  { PseudoVFSGNJN_VF16_M4, VFSGNJN_VF, 0x2 }, // 2511
  { PseudoVFSGNJN_VF16_M4_MASK, VFSGNJN_VF, 0x2 }, // 2512
  { PseudoVFSGNJN_VF16_M4_TU, VFSGNJN_VF, 0x2 }, // 2513
  { PseudoVFSGNJN_VF32_M4, VFSGNJN_VF, 0x2 }, // 2514
  { PseudoVFSGNJN_VF32_M4_MASK, VFSGNJN_VF, 0x2 }, // 2515
  { PseudoVFSGNJN_VF32_M4_TU, VFSGNJN_VF, 0x2 }, // 2516
  { PseudoVFSGNJN_VF64_M4, VFSGNJN_VF, 0x2 }, // 2517
  { PseudoVFSGNJN_VF64_M4_MASK, VFSGNJN_VF, 0x2 }, // 2518
  { PseudoVFSGNJN_VF64_M4_TU, VFSGNJN_VF, 0x2 }, // 2519
  { PseudoVFSGNJN_VF16_M8, VFSGNJN_VF, 0x3 }, // 2520
  { PseudoVFSGNJN_VF16_M8_MASK, VFSGNJN_VF, 0x3 }, // 2521
  { PseudoVFSGNJN_VF16_M8_TU, VFSGNJN_VF, 0x3 }, // 2522
  { PseudoVFSGNJN_VF32_M8, VFSGNJN_VF, 0x3 }, // 2523
  { PseudoVFSGNJN_VF32_M8_MASK, VFSGNJN_VF, 0x3 }, // 2524
  { PseudoVFSGNJN_VF32_M8_TU, VFSGNJN_VF, 0x3 }, // 2525
  { PseudoVFSGNJN_VF64_M8, VFSGNJN_VF, 0x3 }, // 2526
  { PseudoVFSGNJN_VF64_M8_MASK, VFSGNJN_VF, 0x3 }, // 2527
  { PseudoVFSGNJN_VF64_M8_TU, VFSGNJN_VF, 0x3 }, // 2528
  { PseudoVFSGNJN_VF16_MF4, VFSGNJN_VF, 0x6 }, // 2529
  { PseudoVFSGNJN_VF16_MF4_MASK, VFSGNJN_VF, 0x6 }, // 2530
  { PseudoVFSGNJN_VF16_MF4_TU, VFSGNJN_VF, 0x6 }, // 2531
  { PseudoVFSGNJN_VF16_MF2, VFSGNJN_VF, 0x7 }, // 2532
  { PseudoVFSGNJN_VF16_MF2_MASK, VFSGNJN_VF, 0x7 }, // 2533
  { PseudoVFSGNJN_VF16_MF2_TU, VFSGNJN_VF, 0x7 }, // 2534
  { PseudoVFSGNJN_VF32_MF2, VFSGNJN_VF, 0x7 }, // 2535
  { PseudoVFSGNJN_VF32_MF2_MASK, VFSGNJN_VF, 0x7 }, // 2536
  { PseudoVFSGNJN_VF32_MF2_TU, VFSGNJN_VF, 0x7 }, // 2537
  { PseudoVFSGNJN_VV_M1, VFSGNJN_VV, 0x0 }, // 2538
  { PseudoVFSGNJN_VV_M1_MASK, VFSGNJN_VV, 0x0 }, // 2539
  { PseudoVFSGNJN_VV_M1_TU, VFSGNJN_VV, 0x0 }, // 2540
  { PseudoVFSGNJN_VV_M2, VFSGNJN_VV, 0x1 }, // 2541
  { PseudoVFSGNJN_VV_M2_MASK, VFSGNJN_VV, 0x1 }, // 2542
  { PseudoVFSGNJN_VV_M2_TU, VFSGNJN_VV, 0x1 }, // 2543
  { PseudoVFSGNJN_VV_M4, VFSGNJN_VV, 0x2 }, // 2544
  { PseudoVFSGNJN_VV_M4_MASK, VFSGNJN_VV, 0x2 }, // 2545
  { PseudoVFSGNJN_VV_M4_TU, VFSGNJN_VV, 0x2 }, // 2546
  { PseudoVFSGNJN_VV_M8, VFSGNJN_VV, 0x3 }, // 2547
  { PseudoVFSGNJN_VV_M8_MASK, VFSGNJN_VV, 0x3 }, // 2548
  { PseudoVFSGNJN_VV_M8_TU, VFSGNJN_VV, 0x3 }, // 2549
  { PseudoVFSGNJN_VV_MF4, VFSGNJN_VV, 0x6 }, // 2550
  { PseudoVFSGNJN_VV_MF4_MASK, VFSGNJN_VV, 0x6 }, // 2551
  { PseudoVFSGNJN_VV_MF4_TU, VFSGNJN_VV, 0x6 }, // 2552
  { PseudoVFSGNJN_VV_MF2, VFSGNJN_VV, 0x7 }, // 2553
  { PseudoVFSGNJN_VV_MF2_MASK, VFSGNJN_VV, 0x7 }, // 2554
  { PseudoVFSGNJN_VV_MF2_TU, VFSGNJN_VV, 0x7 }, // 2555
  { PseudoVFSGNJX_VF16_M1, VFSGNJX_VF, 0x0 }, // 2556
  { PseudoVFSGNJX_VF16_M1_MASK, VFSGNJX_VF, 0x0 }, // 2557
  { PseudoVFSGNJX_VF16_M1_TU, VFSGNJX_VF, 0x0 }, // 2558
  { PseudoVFSGNJX_VF32_M1, VFSGNJX_VF, 0x0 }, // 2559
  { PseudoVFSGNJX_VF32_M1_MASK, VFSGNJX_VF, 0x0 }, // 2560
  { PseudoVFSGNJX_VF32_M1_TU, VFSGNJX_VF, 0x0 }, // 2561
  { PseudoVFSGNJX_VF64_M1, VFSGNJX_VF, 0x0 }, // 2562
  { PseudoVFSGNJX_VF64_M1_MASK, VFSGNJX_VF, 0x0 }, // 2563
  { PseudoVFSGNJX_VF64_M1_TU, VFSGNJX_VF, 0x0 }, // 2564
  { PseudoVFSGNJX_VF16_M2, VFSGNJX_VF, 0x1 }, // 2565
  { PseudoVFSGNJX_VF16_M2_MASK, VFSGNJX_VF, 0x1 }, // 2566
  { PseudoVFSGNJX_VF16_M2_TU, VFSGNJX_VF, 0x1 }, // 2567
  { PseudoVFSGNJX_VF32_M2, VFSGNJX_VF, 0x1 }, // 2568
  { PseudoVFSGNJX_VF32_M2_MASK, VFSGNJX_VF, 0x1 }, // 2569
  { PseudoVFSGNJX_VF32_M2_TU, VFSGNJX_VF, 0x1 }, // 2570
  { PseudoVFSGNJX_VF64_M2, VFSGNJX_VF, 0x1 }, // 2571
  { PseudoVFSGNJX_VF64_M2_MASK, VFSGNJX_VF, 0x1 }, // 2572
  { PseudoVFSGNJX_VF64_M2_TU, VFSGNJX_VF, 0x1 }, // 2573
  { PseudoVFSGNJX_VF16_M4, VFSGNJX_VF, 0x2 }, // 2574
  { PseudoVFSGNJX_VF16_M4_MASK, VFSGNJX_VF, 0x2 }, // 2575
  { PseudoVFSGNJX_VF16_M4_TU, VFSGNJX_VF, 0x2 }, // 2576
  { PseudoVFSGNJX_VF32_M4, VFSGNJX_VF, 0x2 }, // 2577
  { PseudoVFSGNJX_VF32_M4_MASK, VFSGNJX_VF, 0x2 }, // 2578
  { PseudoVFSGNJX_VF32_M4_TU, VFSGNJX_VF, 0x2 }, // 2579
  { PseudoVFSGNJX_VF64_M4, VFSGNJX_VF, 0x2 }, // 2580
  { PseudoVFSGNJX_VF64_M4_MASK, VFSGNJX_VF, 0x2 }, // 2581
  { PseudoVFSGNJX_VF64_M4_TU, VFSGNJX_VF, 0x2 }, // 2582
  { PseudoVFSGNJX_VF16_M8, VFSGNJX_VF, 0x3 }, // 2583
  { PseudoVFSGNJX_VF16_M8_MASK, VFSGNJX_VF, 0x3 }, // 2584
  { PseudoVFSGNJX_VF16_M8_TU, VFSGNJX_VF, 0x3 }, // 2585
  { PseudoVFSGNJX_VF32_M8, VFSGNJX_VF, 0x3 }, // 2586
  { PseudoVFSGNJX_VF32_M8_MASK, VFSGNJX_VF, 0x3 }, // 2587
  { PseudoVFSGNJX_VF32_M8_TU, VFSGNJX_VF, 0x3 }, // 2588
  { PseudoVFSGNJX_VF64_M8, VFSGNJX_VF, 0x3 }, // 2589
  { PseudoVFSGNJX_VF64_M8_MASK, VFSGNJX_VF, 0x3 }, // 2590
  { PseudoVFSGNJX_VF64_M8_TU, VFSGNJX_VF, 0x3 }, // 2591
  { PseudoVFSGNJX_VF16_MF4, VFSGNJX_VF, 0x6 }, // 2592
  { PseudoVFSGNJX_VF16_MF4_MASK, VFSGNJX_VF, 0x6 }, // 2593
  { PseudoVFSGNJX_VF16_MF4_TU, VFSGNJX_VF, 0x6 }, // 2594
  { PseudoVFSGNJX_VF16_MF2, VFSGNJX_VF, 0x7 }, // 2595
  { PseudoVFSGNJX_VF16_MF2_MASK, VFSGNJX_VF, 0x7 }, // 2596
  { PseudoVFSGNJX_VF16_MF2_TU, VFSGNJX_VF, 0x7 }, // 2597
  { PseudoVFSGNJX_VF32_MF2, VFSGNJX_VF, 0x7 }, // 2598
  { PseudoVFSGNJX_VF32_MF2_MASK, VFSGNJX_VF, 0x7 }, // 2599
  { PseudoVFSGNJX_VF32_MF2_TU, VFSGNJX_VF, 0x7 }, // 2600
  { PseudoVFSGNJX_VV_M1, VFSGNJX_VV, 0x0 }, // 2601
  { PseudoVFSGNJX_VV_M1_MASK, VFSGNJX_VV, 0x0 }, // 2602
  { PseudoVFSGNJX_VV_M1_TU, VFSGNJX_VV, 0x0 }, // 2603
  { PseudoVFSGNJX_VV_M2, VFSGNJX_VV, 0x1 }, // 2604
  { PseudoVFSGNJX_VV_M2_MASK, VFSGNJX_VV, 0x1 }, // 2605
  { PseudoVFSGNJX_VV_M2_TU, VFSGNJX_VV, 0x1 }, // 2606
  { PseudoVFSGNJX_VV_M4, VFSGNJX_VV, 0x2 }, // 2607
  { PseudoVFSGNJX_VV_M4_MASK, VFSGNJX_VV, 0x2 }, // 2608
  { PseudoVFSGNJX_VV_M4_TU, VFSGNJX_VV, 0x2 }, // 2609
  { PseudoVFSGNJX_VV_M8, VFSGNJX_VV, 0x3 }, // 2610
  { PseudoVFSGNJX_VV_M8_MASK, VFSGNJX_VV, 0x3 }, // 2611
  { PseudoVFSGNJX_VV_M8_TU, VFSGNJX_VV, 0x3 }, // 2612
  { PseudoVFSGNJX_VV_MF4, VFSGNJX_VV, 0x6 }, // 2613
  { PseudoVFSGNJX_VV_MF4_MASK, VFSGNJX_VV, 0x6 }, // 2614
  { PseudoVFSGNJX_VV_MF4_TU, VFSGNJX_VV, 0x6 }, // 2615
  { PseudoVFSGNJX_VV_MF2, VFSGNJX_VV, 0x7 }, // 2616
  { PseudoVFSGNJX_VV_MF2_MASK, VFSGNJX_VV, 0x7 }, // 2617
  { PseudoVFSGNJX_VV_MF2_TU, VFSGNJX_VV, 0x7 }, // 2618
  { PseudoVFSGNJ_VF16_M1, VFSGNJ_VF, 0x0 }, // 2619
  { PseudoVFSGNJ_VF16_M1_MASK, VFSGNJ_VF, 0x0 }, // 2620
  { PseudoVFSGNJ_VF16_M1_TU, VFSGNJ_VF, 0x0 }, // 2621
  { PseudoVFSGNJ_VF32_M1, VFSGNJ_VF, 0x0 }, // 2622
  { PseudoVFSGNJ_VF32_M1_MASK, VFSGNJ_VF, 0x0 }, // 2623
  { PseudoVFSGNJ_VF32_M1_TU, VFSGNJ_VF, 0x0 }, // 2624
  { PseudoVFSGNJ_VF64_M1, VFSGNJ_VF, 0x0 }, // 2625
  { PseudoVFSGNJ_VF64_M1_MASK, VFSGNJ_VF, 0x0 }, // 2626
  { PseudoVFSGNJ_VF64_M1_TU, VFSGNJ_VF, 0x0 }, // 2627
  { PseudoVFSGNJ_VF16_M2, VFSGNJ_VF, 0x1 }, // 2628
  { PseudoVFSGNJ_VF16_M2_MASK, VFSGNJ_VF, 0x1 }, // 2629
  { PseudoVFSGNJ_VF16_M2_TU, VFSGNJ_VF, 0x1 }, // 2630
  { PseudoVFSGNJ_VF32_M2, VFSGNJ_VF, 0x1 }, // 2631
  { PseudoVFSGNJ_VF32_M2_MASK, VFSGNJ_VF, 0x1 }, // 2632
  { PseudoVFSGNJ_VF32_M2_TU, VFSGNJ_VF, 0x1 }, // 2633
  { PseudoVFSGNJ_VF64_M2, VFSGNJ_VF, 0x1 }, // 2634
  { PseudoVFSGNJ_VF64_M2_MASK, VFSGNJ_VF, 0x1 }, // 2635
  { PseudoVFSGNJ_VF64_M2_TU, VFSGNJ_VF, 0x1 }, // 2636
  { PseudoVFSGNJ_VF16_M4, VFSGNJ_VF, 0x2 }, // 2637
  { PseudoVFSGNJ_VF16_M4_MASK, VFSGNJ_VF, 0x2 }, // 2638
  { PseudoVFSGNJ_VF16_M4_TU, VFSGNJ_VF, 0x2 }, // 2639
  { PseudoVFSGNJ_VF32_M4, VFSGNJ_VF, 0x2 }, // 2640
  { PseudoVFSGNJ_VF32_M4_MASK, VFSGNJ_VF, 0x2 }, // 2641
  { PseudoVFSGNJ_VF32_M4_TU, VFSGNJ_VF, 0x2 }, // 2642
  { PseudoVFSGNJ_VF64_M4, VFSGNJ_VF, 0x2 }, // 2643
  { PseudoVFSGNJ_VF64_M4_MASK, VFSGNJ_VF, 0x2 }, // 2644
  { PseudoVFSGNJ_VF64_M4_TU, VFSGNJ_VF, 0x2 }, // 2645
  { PseudoVFSGNJ_VF16_M8, VFSGNJ_VF, 0x3 }, // 2646
  { PseudoVFSGNJ_VF16_M8_MASK, VFSGNJ_VF, 0x3 }, // 2647
  { PseudoVFSGNJ_VF16_M8_TU, VFSGNJ_VF, 0x3 }, // 2648
  { PseudoVFSGNJ_VF32_M8, VFSGNJ_VF, 0x3 }, // 2649
  { PseudoVFSGNJ_VF32_M8_MASK, VFSGNJ_VF, 0x3 }, // 2650
  { PseudoVFSGNJ_VF32_M8_TU, VFSGNJ_VF, 0x3 }, // 2651
  { PseudoVFSGNJ_VF64_M8, VFSGNJ_VF, 0x3 }, // 2652
  { PseudoVFSGNJ_VF64_M8_MASK, VFSGNJ_VF, 0x3 }, // 2653
  { PseudoVFSGNJ_VF64_M8_TU, VFSGNJ_VF, 0x3 }, // 2654
  { PseudoVFSGNJ_VF16_MF4, VFSGNJ_VF, 0x6 }, // 2655
  { PseudoVFSGNJ_VF16_MF4_MASK, VFSGNJ_VF, 0x6 }, // 2656
  { PseudoVFSGNJ_VF16_MF4_TU, VFSGNJ_VF, 0x6 }, // 2657
  { PseudoVFSGNJ_VF16_MF2, VFSGNJ_VF, 0x7 }, // 2658
  { PseudoVFSGNJ_VF16_MF2_MASK, VFSGNJ_VF, 0x7 }, // 2659
  { PseudoVFSGNJ_VF16_MF2_TU, VFSGNJ_VF, 0x7 }, // 2660
  { PseudoVFSGNJ_VF32_MF2, VFSGNJ_VF, 0x7 }, // 2661
  { PseudoVFSGNJ_VF32_MF2_MASK, VFSGNJ_VF, 0x7 }, // 2662
  { PseudoVFSGNJ_VF32_MF2_TU, VFSGNJ_VF, 0x7 }, // 2663
  { PseudoVFSGNJ_VV_M1, VFSGNJ_VV, 0x0 }, // 2664
  { PseudoVFSGNJ_VV_M1_MASK, VFSGNJ_VV, 0x0 }, // 2665
  { PseudoVFSGNJ_VV_M1_TU, VFSGNJ_VV, 0x0 }, // 2666
  { PseudoVFSGNJ_VV_M2, VFSGNJ_VV, 0x1 }, // 2667
  { PseudoVFSGNJ_VV_M2_MASK, VFSGNJ_VV, 0x1 }, // 2668
  { PseudoVFSGNJ_VV_M2_TU, VFSGNJ_VV, 0x1 }, // 2669
  { PseudoVFSGNJ_VV_M4, VFSGNJ_VV, 0x2 }, // 2670
  { PseudoVFSGNJ_VV_M4_MASK, VFSGNJ_VV, 0x2 }, // 2671
  { PseudoVFSGNJ_VV_M4_TU, VFSGNJ_VV, 0x2 }, // 2672
  { PseudoVFSGNJ_VV_M8, VFSGNJ_VV, 0x3 }, // 2673
  { PseudoVFSGNJ_VV_M8_MASK, VFSGNJ_VV, 0x3 }, // 2674
  { PseudoVFSGNJ_VV_M8_TU, VFSGNJ_VV, 0x3 }, // 2675
  { PseudoVFSGNJ_VV_MF4, VFSGNJ_VV, 0x6 }, // 2676
  { PseudoVFSGNJ_VV_MF4_MASK, VFSGNJ_VV, 0x6 }, // 2677
  { PseudoVFSGNJ_VV_MF4_TU, VFSGNJ_VV, 0x6 }, // 2678
  { PseudoVFSGNJ_VV_MF2, VFSGNJ_VV, 0x7 }, // 2679
  { PseudoVFSGNJ_VV_MF2_MASK, VFSGNJ_VV, 0x7 }, // 2680
  { PseudoVFSGNJ_VV_MF2_TU, VFSGNJ_VV, 0x7 }, // 2681
  { PseudoVFSLIDE1DOWN_VF16_M1, VFSLIDE1DOWN_VF, 0x0 }, // 2682
  { PseudoVFSLIDE1DOWN_VF16_M1_MASK, VFSLIDE1DOWN_VF, 0x0 }, // 2683
  { PseudoVFSLIDE1DOWN_VF16_M1_TU, VFSLIDE1DOWN_VF, 0x0 }, // 2684
  { PseudoVFSLIDE1DOWN_VF32_M1, VFSLIDE1DOWN_VF, 0x0 }, // 2685
  { PseudoVFSLIDE1DOWN_VF32_M1_MASK, VFSLIDE1DOWN_VF, 0x0 }, // 2686
  { PseudoVFSLIDE1DOWN_VF32_M1_TU, VFSLIDE1DOWN_VF, 0x0 }, // 2687
  { PseudoVFSLIDE1DOWN_VF64_M1, VFSLIDE1DOWN_VF, 0x0 }, // 2688
  { PseudoVFSLIDE1DOWN_VF64_M1_MASK, VFSLIDE1DOWN_VF, 0x0 }, // 2689
  { PseudoVFSLIDE1DOWN_VF64_M1_TU, VFSLIDE1DOWN_VF, 0x0 }, // 2690
  { PseudoVFSLIDE1DOWN_VF16_M2, VFSLIDE1DOWN_VF, 0x1 }, // 2691
  { PseudoVFSLIDE1DOWN_VF16_M2_MASK, VFSLIDE1DOWN_VF, 0x1 }, // 2692
  { PseudoVFSLIDE1DOWN_VF16_M2_TU, VFSLIDE1DOWN_VF, 0x1 }, // 2693
  { PseudoVFSLIDE1DOWN_VF32_M2, VFSLIDE1DOWN_VF, 0x1 }, // 2694
  { PseudoVFSLIDE1DOWN_VF32_M2_MASK, VFSLIDE1DOWN_VF, 0x1 }, // 2695
  { PseudoVFSLIDE1DOWN_VF32_M2_TU, VFSLIDE1DOWN_VF, 0x1 }, // 2696
  { PseudoVFSLIDE1DOWN_VF64_M2, VFSLIDE1DOWN_VF, 0x1 }, // 2697
  { PseudoVFSLIDE1DOWN_VF64_M2_MASK, VFSLIDE1DOWN_VF, 0x1 }, // 2698
  { PseudoVFSLIDE1DOWN_VF64_M2_TU, VFSLIDE1DOWN_VF, 0x1 }, // 2699
  { PseudoVFSLIDE1DOWN_VF16_M4, VFSLIDE1DOWN_VF, 0x2 }, // 2700
  { PseudoVFSLIDE1DOWN_VF16_M4_MASK, VFSLIDE1DOWN_VF, 0x2 }, // 2701
  { PseudoVFSLIDE1DOWN_VF16_M4_TU, VFSLIDE1DOWN_VF, 0x2 }, // 2702
  { PseudoVFSLIDE1DOWN_VF32_M4, VFSLIDE1DOWN_VF, 0x2 }, // 2703
  { PseudoVFSLIDE1DOWN_VF32_M4_MASK, VFSLIDE1DOWN_VF, 0x2 }, // 2704
  { PseudoVFSLIDE1DOWN_VF32_M4_TU, VFSLIDE1DOWN_VF, 0x2 }, // 2705
  { PseudoVFSLIDE1DOWN_VF64_M4, VFSLIDE1DOWN_VF, 0x2 }, // 2706
  { PseudoVFSLIDE1DOWN_VF64_M4_MASK, VFSLIDE1DOWN_VF, 0x2 }, // 2707
  { PseudoVFSLIDE1DOWN_VF64_M4_TU, VFSLIDE1DOWN_VF, 0x2 }, // 2708
  { PseudoVFSLIDE1DOWN_VF16_M8, VFSLIDE1DOWN_VF, 0x3 }, // 2709
  { PseudoVFSLIDE1DOWN_VF16_M8_MASK, VFSLIDE1DOWN_VF, 0x3 }, // 2710
  { PseudoVFSLIDE1DOWN_VF16_M8_TU, VFSLIDE1DOWN_VF, 0x3 }, // 2711
  { PseudoVFSLIDE1DOWN_VF32_M8, VFSLIDE1DOWN_VF, 0x3 }, // 2712
  { PseudoVFSLIDE1DOWN_VF32_M8_MASK, VFSLIDE1DOWN_VF, 0x3 }, // 2713
  { PseudoVFSLIDE1DOWN_VF32_M8_TU, VFSLIDE1DOWN_VF, 0x3 }, // 2714
  { PseudoVFSLIDE1DOWN_VF64_M8, VFSLIDE1DOWN_VF, 0x3 }, // 2715
  { PseudoVFSLIDE1DOWN_VF64_M8_MASK, VFSLIDE1DOWN_VF, 0x3 }, // 2716
  { PseudoVFSLIDE1DOWN_VF64_M8_TU, VFSLIDE1DOWN_VF, 0x3 }, // 2717
  { PseudoVFSLIDE1DOWN_VF16_MF4, VFSLIDE1DOWN_VF, 0x6 }, // 2718
  { PseudoVFSLIDE1DOWN_VF16_MF4_MASK, VFSLIDE1DOWN_VF, 0x6 }, // 2719
  { PseudoVFSLIDE1DOWN_VF16_MF4_TU, VFSLIDE1DOWN_VF, 0x6 }, // 2720
  { PseudoVFSLIDE1DOWN_VF16_MF2, VFSLIDE1DOWN_VF, 0x7 }, // 2721
  { PseudoVFSLIDE1DOWN_VF16_MF2_MASK, VFSLIDE1DOWN_VF, 0x7 }, // 2722
  { PseudoVFSLIDE1DOWN_VF16_MF2_TU, VFSLIDE1DOWN_VF, 0x7 }, // 2723
  { PseudoVFSLIDE1DOWN_VF32_MF2, VFSLIDE1DOWN_VF, 0x7 }, // 2724
  { PseudoVFSLIDE1DOWN_VF32_MF2_MASK, VFSLIDE1DOWN_VF, 0x7 }, // 2725
  { PseudoVFSLIDE1DOWN_VF32_MF2_TU, VFSLIDE1DOWN_VF, 0x7 }, // 2726
  { PseudoVFSLIDE1UP_VF16_M1, VFSLIDE1UP_VF, 0x0 }, // 2727
  { PseudoVFSLIDE1UP_VF16_M1_MASK, VFSLIDE1UP_VF, 0x0 }, // 2728
  { PseudoVFSLIDE1UP_VF16_M1_TU, VFSLIDE1UP_VF, 0x0 }, // 2729
  { PseudoVFSLIDE1UP_VF32_M1, VFSLIDE1UP_VF, 0x0 }, // 2730
  { PseudoVFSLIDE1UP_VF32_M1_MASK, VFSLIDE1UP_VF, 0x0 }, // 2731
  { PseudoVFSLIDE1UP_VF32_M1_TU, VFSLIDE1UP_VF, 0x0 }, // 2732
  { PseudoVFSLIDE1UP_VF64_M1, VFSLIDE1UP_VF, 0x0 }, // 2733
  { PseudoVFSLIDE1UP_VF64_M1_MASK, VFSLIDE1UP_VF, 0x0 }, // 2734
  { PseudoVFSLIDE1UP_VF64_M1_TU, VFSLIDE1UP_VF, 0x0 }, // 2735
  { PseudoVFSLIDE1UP_VF16_M2, VFSLIDE1UP_VF, 0x1 }, // 2736
  { PseudoVFSLIDE1UP_VF16_M2_MASK, VFSLIDE1UP_VF, 0x1 }, // 2737
  { PseudoVFSLIDE1UP_VF16_M2_TU, VFSLIDE1UP_VF, 0x1 }, // 2738
  { PseudoVFSLIDE1UP_VF32_M2, VFSLIDE1UP_VF, 0x1 }, // 2739
  { PseudoVFSLIDE1UP_VF32_M2_MASK, VFSLIDE1UP_VF, 0x1 }, // 2740
  { PseudoVFSLIDE1UP_VF32_M2_TU, VFSLIDE1UP_VF, 0x1 }, // 2741
  { PseudoVFSLIDE1UP_VF64_M2, VFSLIDE1UP_VF, 0x1 }, // 2742
  { PseudoVFSLIDE1UP_VF64_M2_MASK, VFSLIDE1UP_VF, 0x1 }, // 2743
  { PseudoVFSLIDE1UP_VF64_M2_TU, VFSLIDE1UP_VF, 0x1 }, // 2744
  { PseudoVFSLIDE1UP_VF16_M4, VFSLIDE1UP_VF, 0x2 }, // 2745
  { PseudoVFSLIDE1UP_VF16_M4_MASK, VFSLIDE1UP_VF, 0x2 }, // 2746
  { PseudoVFSLIDE1UP_VF16_M4_TU, VFSLIDE1UP_VF, 0x2 }, // 2747
  { PseudoVFSLIDE1UP_VF32_M4, VFSLIDE1UP_VF, 0x2 }, // 2748
  { PseudoVFSLIDE1UP_VF32_M4_MASK, VFSLIDE1UP_VF, 0x2 }, // 2749
  { PseudoVFSLIDE1UP_VF32_M4_TU, VFSLIDE1UP_VF, 0x2 }, // 2750
  { PseudoVFSLIDE1UP_VF64_M4, VFSLIDE1UP_VF, 0x2 }, // 2751
  { PseudoVFSLIDE1UP_VF64_M4_MASK, VFSLIDE1UP_VF, 0x2 }, // 2752
  { PseudoVFSLIDE1UP_VF64_M4_TU, VFSLIDE1UP_VF, 0x2 }, // 2753
  { PseudoVFSLIDE1UP_VF16_M8, VFSLIDE1UP_VF, 0x3 }, // 2754
  { PseudoVFSLIDE1UP_VF16_M8_MASK, VFSLIDE1UP_VF, 0x3 }, // 2755
  { PseudoVFSLIDE1UP_VF16_M8_TU, VFSLIDE1UP_VF, 0x3 }, // 2756
  { PseudoVFSLIDE1UP_VF32_M8, VFSLIDE1UP_VF, 0x3 }, // 2757
  { PseudoVFSLIDE1UP_VF32_M8_MASK, VFSLIDE1UP_VF, 0x3 }, // 2758
  { PseudoVFSLIDE1UP_VF32_M8_TU, VFSLIDE1UP_VF, 0x3 }, // 2759
  { PseudoVFSLIDE1UP_VF64_M8, VFSLIDE1UP_VF, 0x3 }, // 2760
  { PseudoVFSLIDE1UP_VF64_M8_MASK, VFSLIDE1UP_VF, 0x3 }, // 2761
  { PseudoVFSLIDE1UP_VF64_M8_TU, VFSLIDE1UP_VF, 0x3 }, // 2762
  { PseudoVFSLIDE1UP_VF16_MF4, VFSLIDE1UP_VF, 0x6 }, // 2763
  { PseudoVFSLIDE1UP_VF16_MF4_MASK, VFSLIDE1UP_VF, 0x6 }, // 2764
  { PseudoVFSLIDE1UP_VF16_MF4_TU, VFSLIDE1UP_VF, 0x6 }, // 2765
  { PseudoVFSLIDE1UP_VF16_MF2, VFSLIDE1UP_VF, 0x7 }, // 2766
  { PseudoVFSLIDE1UP_VF16_MF2_MASK, VFSLIDE1UP_VF, 0x7 }, // 2767
  { PseudoVFSLIDE1UP_VF16_MF2_TU, VFSLIDE1UP_VF, 0x7 }, // 2768
  { PseudoVFSLIDE1UP_VF32_MF2, VFSLIDE1UP_VF, 0x7 }, // 2769
  { PseudoVFSLIDE1UP_VF32_MF2_MASK, VFSLIDE1UP_VF, 0x7 }, // 2770
  { PseudoVFSLIDE1UP_VF32_MF2_TU, VFSLIDE1UP_VF, 0x7 }, // 2771
  { PseudoVFSQRT_V_M1_E16, VFSQRT_V, 0x0 }, // 2772
  { PseudoVFSQRT_V_M1_E16_MASK, VFSQRT_V, 0x0 }, // 2773
  { PseudoVFSQRT_V_M1_E16_TU, VFSQRT_V, 0x0 }, // 2774
  { PseudoVFSQRT_V_M1_E32, VFSQRT_V, 0x0 }, // 2775
  { PseudoVFSQRT_V_M1_E32_MASK, VFSQRT_V, 0x0 }, // 2776
  { PseudoVFSQRT_V_M1_E32_TU, VFSQRT_V, 0x0 }, // 2777
  { PseudoVFSQRT_V_M1_E64, VFSQRT_V, 0x0 }, // 2778
  { PseudoVFSQRT_V_M1_E64_MASK, VFSQRT_V, 0x0 }, // 2779
  { PseudoVFSQRT_V_M1_E64_TU, VFSQRT_V, 0x0 }, // 2780
  { PseudoVFSQRT_V_M2_E16, VFSQRT_V, 0x1 }, // 2781
  { PseudoVFSQRT_V_M2_E16_MASK, VFSQRT_V, 0x1 }, // 2782
  { PseudoVFSQRT_V_M2_E16_TU, VFSQRT_V, 0x1 }, // 2783
  { PseudoVFSQRT_V_M2_E32, VFSQRT_V, 0x1 }, // 2784
  { PseudoVFSQRT_V_M2_E32_MASK, VFSQRT_V, 0x1 }, // 2785
  { PseudoVFSQRT_V_M2_E32_TU, VFSQRT_V, 0x1 }, // 2786
  { PseudoVFSQRT_V_M2_E64, VFSQRT_V, 0x1 }, // 2787
  { PseudoVFSQRT_V_M2_E64_MASK, VFSQRT_V, 0x1 }, // 2788
  { PseudoVFSQRT_V_M2_E64_TU, VFSQRT_V, 0x1 }, // 2789
  { PseudoVFSQRT_V_M4_E16, VFSQRT_V, 0x2 }, // 2790
  { PseudoVFSQRT_V_M4_E16_MASK, VFSQRT_V, 0x2 }, // 2791
  { PseudoVFSQRT_V_M4_E16_TU, VFSQRT_V, 0x2 }, // 2792
  { PseudoVFSQRT_V_M4_E32, VFSQRT_V, 0x2 }, // 2793
  { PseudoVFSQRT_V_M4_E32_MASK, VFSQRT_V, 0x2 }, // 2794
  { PseudoVFSQRT_V_M4_E32_TU, VFSQRT_V, 0x2 }, // 2795
  { PseudoVFSQRT_V_M4_E64, VFSQRT_V, 0x2 }, // 2796
  { PseudoVFSQRT_V_M4_E64_MASK, VFSQRT_V, 0x2 }, // 2797
  { PseudoVFSQRT_V_M4_E64_TU, VFSQRT_V, 0x2 }, // 2798
  { PseudoVFSQRT_V_M8_E16, VFSQRT_V, 0x3 }, // 2799
  { PseudoVFSQRT_V_M8_E16_MASK, VFSQRT_V, 0x3 }, // 2800
  { PseudoVFSQRT_V_M8_E16_TU, VFSQRT_V, 0x3 }, // 2801
  { PseudoVFSQRT_V_M8_E32, VFSQRT_V, 0x3 }, // 2802
  { PseudoVFSQRT_V_M8_E32_MASK, VFSQRT_V, 0x3 }, // 2803
  { PseudoVFSQRT_V_M8_E32_TU, VFSQRT_V, 0x3 }, // 2804
  { PseudoVFSQRT_V_M8_E64, VFSQRT_V, 0x3 }, // 2805
  { PseudoVFSQRT_V_M8_E64_MASK, VFSQRT_V, 0x3 }, // 2806
  { PseudoVFSQRT_V_M8_E64_TU, VFSQRT_V, 0x3 }, // 2807
  { PseudoVFSQRT_V_MF4_E16, VFSQRT_V, 0x6 }, // 2808
  { PseudoVFSQRT_V_MF4_E16_MASK, VFSQRT_V, 0x6 }, // 2809
  { PseudoVFSQRT_V_MF4_E16_TU, VFSQRT_V, 0x6 }, // 2810
  { PseudoVFSQRT_V_MF2_E16, VFSQRT_V, 0x7 }, // 2811
  { PseudoVFSQRT_V_MF2_E16_MASK, VFSQRT_V, 0x7 }, // 2812
  { PseudoVFSQRT_V_MF2_E16_TU, VFSQRT_V, 0x7 }, // 2813
  { PseudoVFSQRT_V_MF2_E32, VFSQRT_V, 0x7 }, // 2814
  { PseudoVFSQRT_V_MF2_E32_MASK, VFSQRT_V, 0x7 }, // 2815
  { PseudoVFSQRT_V_MF2_E32_TU, VFSQRT_V, 0x7 }, // 2816
  { PseudoVFSUB_VF16_M1, VFSUB_VF, 0x0 }, // 2817
  { PseudoVFSUB_VF16_M1_MASK, VFSUB_VF, 0x0 }, // 2818
  { PseudoVFSUB_VF16_M1_TU, VFSUB_VF, 0x0 }, // 2819
  { PseudoVFSUB_VF32_M1, VFSUB_VF, 0x0 }, // 2820
  { PseudoVFSUB_VF32_M1_MASK, VFSUB_VF, 0x0 }, // 2821
  { PseudoVFSUB_VF32_M1_TU, VFSUB_VF, 0x0 }, // 2822
  { PseudoVFSUB_VF64_M1, VFSUB_VF, 0x0 }, // 2823
  { PseudoVFSUB_VF64_M1_MASK, VFSUB_VF, 0x0 }, // 2824
  { PseudoVFSUB_VF64_M1_TU, VFSUB_VF, 0x0 }, // 2825
  { PseudoVFSUB_VF16_M2, VFSUB_VF, 0x1 }, // 2826
  { PseudoVFSUB_VF16_M2_MASK, VFSUB_VF, 0x1 }, // 2827
  { PseudoVFSUB_VF16_M2_TU, VFSUB_VF, 0x1 }, // 2828
  { PseudoVFSUB_VF32_M2, VFSUB_VF, 0x1 }, // 2829
  { PseudoVFSUB_VF32_M2_MASK, VFSUB_VF, 0x1 }, // 2830
  { PseudoVFSUB_VF32_M2_TU, VFSUB_VF, 0x1 }, // 2831
  { PseudoVFSUB_VF64_M2, VFSUB_VF, 0x1 }, // 2832
  { PseudoVFSUB_VF64_M2_MASK, VFSUB_VF, 0x1 }, // 2833
  { PseudoVFSUB_VF64_M2_TU, VFSUB_VF, 0x1 }, // 2834
  { PseudoVFSUB_VF16_M4, VFSUB_VF, 0x2 }, // 2835
  { PseudoVFSUB_VF16_M4_MASK, VFSUB_VF, 0x2 }, // 2836
  { PseudoVFSUB_VF16_M4_TU, VFSUB_VF, 0x2 }, // 2837
  { PseudoVFSUB_VF32_M4, VFSUB_VF, 0x2 }, // 2838
  { PseudoVFSUB_VF32_M4_MASK, VFSUB_VF, 0x2 }, // 2839
  { PseudoVFSUB_VF32_M4_TU, VFSUB_VF, 0x2 }, // 2840
  { PseudoVFSUB_VF64_M4, VFSUB_VF, 0x2 }, // 2841
  { PseudoVFSUB_VF64_M4_MASK, VFSUB_VF, 0x2 }, // 2842
  { PseudoVFSUB_VF64_M4_TU, VFSUB_VF, 0x2 }, // 2843
  { PseudoVFSUB_VF16_M8, VFSUB_VF, 0x3 }, // 2844
  { PseudoVFSUB_VF16_M8_MASK, VFSUB_VF, 0x3 }, // 2845
  { PseudoVFSUB_VF16_M8_TU, VFSUB_VF, 0x3 }, // 2846
  { PseudoVFSUB_VF32_M8, VFSUB_VF, 0x3 }, // 2847
  { PseudoVFSUB_VF32_M8_MASK, VFSUB_VF, 0x3 }, // 2848
  { PseudoVFSUB_VF32_M8_TU, VFSUB_VF, 0x3 }, // 2849
  { PseudoVFSUB_VF64_M8, VFSUB_VF, 0x3 }, // 2850
  { PseudoVFSUB_VF64_M8_MASK, VFSUB_VF, 0x3 }, // 2851
  { PseudoVFSUB_VF64_M8_TU, VFSUB_VF, 0x3 }, // 2852
  { PseudoVFSUB_VF16_MF4, VFSUB_VF, 0x6 }, // 2853
  { PseudoVFSUB_VF16_MF4_MASK, VFSUB_VF, 0x6 }, // 2854
  { PseudoVFSUB_VF16_MF4_TU, VFSUB_VF, 0x6 }, // 2855
  { PseudoVFSUB_VF16_MF2, VFSUB_VF, 0x7 }, // 2856
  { PseudoVFSUB_VF16_MF2_MASK, VFSUB_VF, 0x7 }, // 2857
  { PseudoVFSUB_VF16_MF2_TU, VFSUB_VF, 0x7 }, // 2858
  { PseudoVFSUB_VF32_MF2, VFSUB_VF, 0x7 }, // 2859
  { PseudoVFSUB_VF32_MF2_MASK, VFSUB_VF, 0x7 }, // 2860
  { PseudoVFSUB_VF32_MF2_TU, VFSUB_VF, 0x7 }, // 2861
  { PseudoVFSUB_VV_M1, VFSUB_VV, 0x0 }, // 2862
  { PseudoVFSUB_VV_M1_MASK, VFSUB_VV, 0x0 }, // 2863
  { PseudoVFSUB_VV_M1_TU, VFSUB_VV, 0x0 }, // 2864
  { PseudoVFSUB_VV_M2, VFSUB_VV, 0x1 }, // 2865
  { PseudoVFSUB_VV_M2_MASK, VFSUB_VV, 0x1 }, // 2866
  { PseudoVFSUB_VV_M2_TU, VFSUB_VV, 0x1 }, // 2867
  { PseudoVFSUB_VV_M4, VFSUB_VV, 0x2 }, // 2868
  { PseudoVFSUB_VV_M4_MASK, VFSUB_VV, 0x2 }, // 2869
  { PseudoVFSUB_VV_M4_TU, VFSUB_VV, 0x2 }, // 2870
  { PseudoVFSUB_VV_M8, VFSUB_VV, 0x3 }, // 2871
  { PseudoVFSUB_VV_M8_MASK, VFSUB_VV, 0x3 }, // 2872
  { PseudoVFSUB_VV_M8_TU, VFSUB_VV, 0x3 }, // 2873
  { PseudoVFSUB_VV_MF4, VFSUB_VV, 0x6 }, // 2874
  { PseudoVFSUB_VV_MF4_MASK, VFSUB_VV, 0x6 }, // 2875
  { PseudoVFSUB_VV_MF4_TU, VFSUB_VV, 0x6 }, // 2876
  { PseudoVFSUB_VV_MF2, VFSUB_VV, 0x7 }, // 2877
  { PseudoVFSUB_VV_MF2_MASK, VFSUB_VV, 0x7 }, // 2878
  { PseudoVFSUB_VV_MF2_TU, VFSUB_VV, 0x7 }, // 2879
  { PseudoVFWADD_VF16_M1, VFWADD_VF, 0x0 }, // 2880
  { PseudoVFWADD_VF16_M1_MASK, VFWADD_VF, 0x0 }, // 2881
  { PseudoVFWADD_VF16_M1_TU, VFWADD_VF, 0x0 }, // 2882
  { PseudoVFWADD_VF32_M1, VFWADD_VF, 0x0 }, // 2883
  { PseudoVFWADD_VF32_M1_MASK, VFWADD_VF, 0x0 }, // 2884
  { PseudoVFWADD_VF32_M1_TU, VFWADD_VF, 0x0 }, // 2885
  { PseudoVFWADD_VF16_M2, VFWADD_VF, 0x1 }, // 2886
  { PseudoVFWADD_VF16_M2_MASK, VFWADD_VF, 0x1 }, // 2887
  { PseudoVFWADD_VF16_M2_TU, VFWADD_VF, 0x1 }, // 2888
  { PseudoVFWADD_VF32_M2, VFWADD_VF, 0x1 }, // 2889
  { PseudoVFWADD_VF32_M2_MASK, VFWADD_VF, 0x1 }, // 2890
  { PseudoVFWADD_VF32_M2_TU, VFWADD_VF, 0x1 }, // 2891
  { PseudoVFWADD_VF16_M4, VFWADD_VF, 0x2 }, // 2892
  { PseudoVFWADD_VF16_M4_MASK, VFWADD_VF, 0x2 }, // 2893
  { PseudoVFWADD_VF16_M4_TU, VFWADD_VF, 0x2 }, // 2894
  { PseudoVFWADD_VF32_M4, VFWADD_VF, 0x2 }, // 2895
  { PseudoVFWADD_VF32_M4_MASK, VFWADD_VF, 0x2 }, // 2896
  { PseudoVFWADD_VF32_M4_TU, VFWADD_VF, 0x2 }, // 2897
  { PseudoVFWADD_VF16_MF4, VFWADD_VF, 0x6 }, // 2898
  { PseudoVFWADD_VF16_MF4_MASK, VFWADD_VF, 0x6 }, // 2899
  { PseudoVFWADD_VF16_MF4_TU, VFWADD_VF, 0x6 }, // 2900
  { PseudoVFWADD_VF16_MF2, VFWADD_VF, 0x7 }, // 2901
  { PseudoVFWADD_VF16_MF2_MASK, VFWADD_VF, 0x7 }, // 2902
  { PseudoVFWADD_VF16_MF2_TU, VFWADD_VF, 0x7 }, // 2903
  { PseudoVFWADD_VF32_MF2, VFWADD_VF, 0x7 }, // 2904
  { PseudoVFWADD_VF32_MF2_MASK, VFWADD_VF, 0x7 }, // 2905
  { PseudoVFWADD_VF32_MF2_TU, VFWADD_VF, 0x7 }, // 2906
  { PseudoVFWADD_VV_M1, VFWADD_VV, 0x0 }, // 2907
  { PseudoVFWADD_VV_M1_MASK, VFWADD_VV, 0x0 }, // 2908
  { PseudoVFWADD_VV_M1_TU, VFWADD_VV, 0x0 }, // 2909
  { PseudoVFWADD_VV_M2, VFWADD_VV, 0x1 }, // 2910
  { PseudoVFWADD_VV_M2_MASK, VFWADD_VV, 0x1 }, // 2911
  { PseudoVFWADD_VV_M2_TU, VFWADD_VV, 0x1 }, // 2912
  { PseudoVFWADD_VV_M4, VFWADD_VV, 0x2 }, // 2913
  { PseudoVFWADD_VV_M4_MASK, VFWADD_VV, 0x2 }, // 2914
  { PseudoVFWADD_VV_M4_TU, VFWADD_VV, 0x2 }, // 2915
  { PseudoVFWADD_VV_MF4, VFWADD_VV, 0x6 }, // 2916
  { PseudoVFWADD_VV_MF4_MASK, VFWADD_VV, 0x6 }, // 2917
  { PseudoVFWADD_VV_MF4_TU, VFWADD_VV, 0x6 }, // 2918
  { PseudoVFWADD_VV_MF2, VFWADD_VV, 0x7 }, // 2919
  { PseudoVFWADD_VV_MF2_MASK, VFWADD_VV, 0x7 }, // 2920
  { PseudoVFWADD_VV_MF2_TU, VFWADD_VV, 0x7 }, // 2921
  { PseudoVFWADD_WF16_M1, VFWADD_WF, 0x0 }, // 2922
  { PseudoVFWADD_WF16_M1_MASK, VFWADD_WF, 0x0 }, // 2923
  { PseudoVFWADD_WF16_M1_TU, VFWADD_WF, 0x0 }, // 2924
  { PseudoVFWADD_WF32_M1, VFWADD_WF, 0x0 }, // 2925
  { PseudoVFWADD_WF32_M1_MASK, VFWADD_WF, 0x0 }, // 2926
  { PseudoVFWADD_WF32_M1_TU, VFWADD_WF, 0x0 }, // 2927
  { PseudoVFWADD_WF16_M2, VFWADD_WF, 0x1 }, // 2928
  { PseudoVFWADD_WF16_M2_MASK, VFWADD_WF, 0x1 }, // 2929
  { PseudoVFWADD_WF16_M2_TU, VFWADD_WF, 0x1 }, // 2930
  { PseudoVFWADD_WF32_M2, VFWADD_WF, 0x1 }, // 2931
  { PseudoVFWADD_WF32_M2_MASK, VFWADD_WF, 0x1 }, // 2932
  { PseudoVFWADD_WF32_M2_TU, VFWADD_WF, 0x1 }, // 2933
  { PseudoVFWADD_WF16_M4, VFWADD_WF, 0x2 }, // 2934
  { PseudoVFWADD_WF16_M4_MASK, VFWADD_WF, 0x2 }, // 2935
  { PseudoVFWADD_WF16_M4_TU, VFWADD_WF, 0x2 }, // 2936
  { PseudoVFWADD_WF32_M4, VFWADD_WF, 0x2 }, // 2937
  { PseudoVFWADD_WF32_M4_MASK, VFWADD_WF, 0x2 }, // 2938
  { PseudoVFWADD_WF32_M4_TU, VFWADD_WF, 0x2 }, // 2939
  { PseudoVFWADD_WF16_MF4, VFWADD_WF, 0x6 }, // 2940
  { PseudoVFWADD_WF16_MF4_MASK, VFWADD_WF, 0x6 }, // 2941
  { PseudoVFWADD_WF16_MF4_TU, VFWADD_WF, 0x6 }, // 2942
  { PseudoVFWADD_WF16_MF2, VFWADD_WF, 0x7 }, // 2943
  { PseudoVFWADD_WF16_MF2_MASK, VFWADD_WF, 0x7 }, // 2944
  { PseudoVFWADD_WF16_MF2_TU, VFWADD_WF, 0x7 }, // 2945
  { PseudoVFWADD_WF32_MF2, VFWADD_WF, 0x7 }, // 2946
  { PseudoVFWADD_WF32_MF2_MASK, VFWADD_WF, 0x7 }, // 2947
  { PseudoVFWADD_WF32_MF2_TU, VFWADD_WF, 0x7 }, // 2948
  { PseudoVFWADD_WV_M1, VFWADD_WV, 0x0 }, // 2949
  { PseudoVFWADD_WV_M1_MASK, VFWADD_WV, 0x0 }, // 2950
  { PseudoVFWADD_WV_M1_MASK_TIED, VFWADD_WV, 0x0 }, // 2951
  { PseudoVFWADD_WV_M1_TIED, VFWADD_WV, 0x0 }, // 2952
  { PseudoVFWADD_WV_M1_TU, VFWADD_WV, 0x0 }, // 2953
  { PseudoVFWADD_WV_M2, VFWADD_WV, 0x1 }, // 2954
  { PseudoVFWADD_WV_M2_MASK, VFWADD_WV, 0x1 }, // 2955
  { PseudoVFWADD_WV_M2_MASK_TIED, VFWADD_WV, 0x1 }, // 2956
  { PseudoVFWADD_WV_M2_TIED, VFWADD_WV, 0x1 }, // 2957
  { PseudoVFWADD_WV_M2_TU, VFWADD_WV, 0x1 }, // 2958
  { PseudoVFWADD_WV_M4, VFWADD_WV, 0x2 }, // 2959
  { PseudoVFWADD_WV_M4_MASK, VFWADD_WV, 0x2 }, // 2960
  { PseudoVFWADD_WV_M4_MASK_TIED, VFWADD_WV, 0x2 }, // 2961
  { PseudoVFWADD_WV_M4_TIED, VFWADD_WV, 0x2 }, // 2962
  { PseudoVFWADD_WV_M4_TU, VFWADD_WV, 0x2 }, // 2963
  { PseudoVFWADD_WV_MF4, VFWADD_WV, 0x6 }, // 2964
  { PseudoVFWADD_WV_MF4_MASK, VFWADD_WV, 0x6 }, // 2965
  { PseudoVFWADD_WV_MF4_MASK_TIED, VFWADD_WV, 0x6 }, // 2966
  { PseudoVFWADD_WV_MF4_TIED, VFWADD_WV, 0x6 }, // 2967
  { PseudoVFWADD_WV_MF4_TU, VFWADD_WV, 0x6 }, // 2968
  { PseudoVFWADD_WV_MF2, VFWADD_WV, 0x7 }, // 2969
  { PseudoVFWADD_WV_MF2_MASK, VFWADD_WV, 0x7 }, // 2970
  { PseudoVFWADD_WV_MF2_MASK_TIED, VFWADD_WV, 0x7 }, // 2971
  { PseudoVFWADD_WV_MF2_TIED, VFWADD_WV, 0x7 }, // 2972
  { PseudoVFWADD_WV_MF2_TU, VFWADD_WV, 0x7 }, // 2973
  { PseudoVFWCVT_F_F_V_M1, VFWCVT_F_F_V, 0x0 }, // 2974
  { PseudoVFWCVT_F_F_V_M1_MASK, VFWCVT_F_F_V, 0x0 }, // 2975
  { PseudoVFWCVT_F_F_V_M1_TU, VFWCVT_F_F_V, 0x0 }, // 2976
  { PseudoVFWCVT_F_F_V_M2, VFWCVT_F_F_V, 0x1 }, // 2977
  { PseudoVFWCVT_F_F_V_M2_MASK, VFWCVT_F_F_V, 0x1 }, // 2978
  { PseudoVFWCVT_F_F_V_M2_TU, VFWCVT_F_F_V, 0x1 }, // 2979
  { PseudoVFWCVT_F_F_V_M4, VFWCVT_F_F_V, 0x2 }, // 2980
  { PseudoVFWCVT_F_F_V_M4_MASK, VFWCVT_F_F_V, 0x2 }, // 2981
  { PseudoVFWCVT_F_F_V_M4_TU, VFWCVT_F_F_V, 0x2 }, // 2982
  { PseudoVFWCVT_F_F_V_MF4, VFWCVT_F_F_V, 0x6 }, // 2983
  { PseudoVFWCVT_F_F_V_MF4_MASK, VFWCVT_F_F_V, 0x6 }, // 2984
  { PseudoVFWCVT_F_F_V_MF4_TU, VFWCVT_F_F_V, 0x6 }, // 2985
  { PseudoVFWCVT_F_F_V_MF2, VFWCVT_F_F_V, 0x7 }, // 2986
  { PseudoVFWCVT_F_F_V_MF2_MASK, VFWCVT_F_F_V, 0x7 }, // 2987
  { PseudoVFWCVT_F_F_V_MF2_TU, VFWCVT_F_F_V, 0x7 }, // 2988
  { PseudoVFWCVT_F_XU_V_M1, VFWCVT_F_XU_V, 0x0 }, // 2989
  { PseudoVFWCVT_F_XU_V_M1_MASK, VFWCVT_F_XU_V, 0x0 }, // 2990
  { PseudoVFWCVT_F_XU_V_M1_TU, VFWCVT_F_XU_V, 0x0 }, // 2991
  { PseudoVFWCVT_F_XU_V_M2, VFWCVT_F_XU_V, 0x1 }, // 2992
  { PseudoVFWCVT_F_XU_V_M2_MASK, VFWCVT_F_XU_V, 0x1 }, // 2993
  { PseudoVFWCVT_F_XU_V_M2_TU, VFWCVT_F_XU_V, 0x1 }, // 2994
  { PseudoVFWCVT_F_XU_V_M4, VFWCVT_F_XU_V, 0x2 }, // 2995
  { PseudoVFWCVT_F_XU_V_M4_MASK, VFWCVT_F_XU_V, 0x2 }, // 2996
  { PseudoVFWCVT_F_XU_V_M4_TU, VFWCVT_F_XU_V, 0x2 }, // 2997
  { PseudoVFWCVT_F_XU_V_MF8, VFWCVT_F_XU_V, 0x5 }, // 2998
  { PseudoVFWCVT_F_XU_V_MF8_MASK, VFWCVT_F_XU_V, 0x5 }, // 2999
  { PseudoVFWCVT_F_XU_V_MF8_TU, VFWCVT_F_XU_V, 0x5 }, // 3000
  { PseudoVFWCVT_F_XU_V_MF4, VFWCVT_F_XU_V, 0x6 }, // 3001
  { PseudoVFWCVT_F_XU_V_MF4_MASK, VFWCVT_F_XU_V, 0x6 }, // 3002
  { PseudoVFWCVT_F_XU_V_MF4_TU, VFWCVT_F_XU_V, 0x6 }, // 3003
  { PseudoVFWCVT_F_XU_V_MF2, VFWCVT_F_XU_V, 0x7 }, // 3004
  { PseudoVFWCVT_F_XU_V_MF2_MASK, VFWCVT_F_XU_V, 0x7 }, // 3005
  { PseudoVFWCVT_F_XU_V_MF2_TU, VFWCVT_F_XU_V, 0x7 }, // 3006
  { PseudoVFWCVT_F_X_V_M1, VFWCVT_F_X_V, 0x0 }, // 3007
  { PseudoVFWCVT_F_X_V_M1_MASK, VFWCVT_F_X_V, 0x0 }, // 3008
  { PseudoVFWCVT_F_X_V_M1_TU, VFWCVT_F_X_V, 0x0 }, // 3009
  { PseudoVFWCVT_F_X_V_M2, VFWCVT_F_X_V, 0x1 }, // 3010
  { PseudoVFWCVT_F_X_V_M2_MASK, VFWCVT_F_X_V, 0x1 }, // 3011
  { PseudoVFWCVT_F_X_V_M2_TU, VFWCVT_F_X_V, 0x1 }, // 3012
  { PseudoVFWCVT_F_X_V_M4, VFWCVT_F_X_V, 0x2 }, // 3013
  { PseudoVFWCVT_F_X_V_M4_MASK, VFWCVT_F_X_V, 0x2 }, // 3014
  { PseudoVFWCVT_F_X_V_M4_TU, VFWCVT_F_X_V, 0x2 }, // 3015
  { PseudoVFWCVT_F_X_V_MF8, VFWCVT_F_X_V, 0x5 }, // 3016
  { PseudoVFWCVT_F_X_V_MF8_MASK, VFWCVT_F_X_V, 0x5 }, // 3017
  { PseudoVFWCVT_F_X_V_MF8_TU, VFWCVT_F_X_V, 0x5 }, // 3018
  { PseudoVFWCVT_F_X_V_MF4, VFWCVT_F_X_V, 0x6 }, // 3019
  { PseudoVFWCVT_F_X_V_MF4_MASK, VFWCVT_F_X_V, 0x6 }, // 3020
  { PseudoVFWCVT_F_X_V_MF4_TU, VFWCVT_F_X_V, 0x6 }, // 3021
  { PseudoVFWCVT_F_X_V_MF2, VFWCVT_F_X_V, 0x7 }, // 3022
  { PseudoVFWCVT_F_X_V_MF2_MASK, VFWCVT_F_X_V, 0x7 }, // 3023
  { PseudoVFWCVT_F_X_V_MF2_TU, VFWCVT_F_X_V, 0x7 }, // 3024
  { PseudoVFWCVT_RTZ_XU_F_V_M1, VFWCVT_RTZ_XU_F_V, 0x0 }, // 3025
  { PseudoVFWCVT_RTZ_XU_F_V_M1_MASK, VFWCVT_RTZ_XU_F_V, 0x0 }, // 3026
  { PseudoVFWCVT_RTZ_XU_F_V_M1_TU, VFWCVT_RTZ_XU_F_V, 0x0 }, // 3027
  { PseudoVFWCVT_RTZ_XU_F_V_M2, VFWCVT_RTZ_XU_F_V, 0x1 }, // 3028
  { PseudoVFWCVT_RTZ_XU_F_V_M2_MASK, VFWCVT_RTZ_XU_F_V, 0x1 }, // 3029
  { PseudoVFWCVT_RTZ_XU_F_V_M2_TU, VFWCVT_RTZ_XU_F_V, 0x1 }, // 3030
  { PseudoVFWCVT_RTZ_XU_F_V_M4, VFWCVT_RTZ_XU_F_V, 0x2 }, // 3031
  { PseudoVFWCVT_RTZ_XU_F_V_M4_MASK, VFWCVT_RTZ_XU_F_V, 0x2 }, // 3032
  { PseudoVFWCVT_RTZ_XU_F_V_M4_TU, VFWCVT_RTZ_XU_F_V, 0x2 }, // 3033
  { PseudoVFWCVT_RTZ_XU_F_V_MF4, VFWCVT_RTZ_XU_F_V, 0x6 }, // 3034
  { PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK, VFWCVT_RTZ_XU_F_V, 0x6 }, // 3035
  { PseudoVFWCVT_RTZ_XU_F_V_MF4_TU, VFWCVT_RTZ_XU_F_V, 0x6 }, // 3036
  { PseudoVFWCVT_RTZ_XU_F_V_MF2, VFWCVT_RTZ_XU_F_V, 0x7 }, // 3037
  { PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK, VFWCVT_RTZ_XU_F_V, 0x7 }, // 3038
  { PseudoVFWCVT_RTZ_XU_F_V_MF2_TU, VFWCVT_RTZ_XU_F_V, 0x7 }, // 3039
  { PseudoVFWCVT_RTZ_X_F_V_M1, VFWCVT_RTZ_X_F_V, 0x0 }, // 3040
  { PseudoVFWCVT_RTZ_X_F_V_M1_MASK, VFWCVT_RTZ_X_F_V, 0x0 }, // 3041
  { PseudoVFWCVT_RTZ_X_F_V_M1_TU, VFWCVT_RTZ_X_F_V, 0x0 }, // 3042
  { PseudoVFWCVT_RTZ_X_F_V_M2, VFWCVT_RTZ_X_F_V, 0x1 }, // 3043
  { PseudoVFWCVT_RTZ_X_F_V_M2_MASK, VFWCVT_RTZ_X_F_V, 0x1 }, // 3044
  { PseudoVFWCVT_RTZ_X_F_V_M2_TU, VFWCVT_RTZ_X_F_V, 0x1 }, // 3045
  { PseudoVFWCVT_RTZ_X_F_V_M4, VFWCVT_RTZ_X_F_V, 0x2 }, // 3046
  { PseudoVFWCVT_RTZ_X_F_V_M4_MASK, VFWCVT_RTZ_X_F_V, 0x2 }, // 3047
  { PseudoVFWCVT_RTZ_X_F_V_M4_TU, VFWCVT_RTZ_X_F_V, 0x2 }, // 3048
  { PseudoVFWCVT_RTZ_X_F_V_MF4, VFWCVT_RTZ_X_F_V, 0x6 }, // 3049
  { PseudoVFWCVT_RTZ_X_F_V_MF4_MASK, VFWCVT_RTZ_X_F_V, 0x6 }, // 3050
  { PseudoVFWCVT_RTZ_X_F_V_MF4_TU, VFWCVT_RTZ_X_F_V, 0x6 }, // 3051
  { PseudoVFWCVT_RTZ_X_F_V_MF2, VFWCVT_RTZ_X_F_V, 0x7 }, // 3052
  { PseudoVFWCVT_RTZ_X_F_V_MF2_MASK, VFWCVT_RTZ_X_F_V, 0x7 }, // 3053
  { PseudoVFWCVT_RTZ_X_F_V_MF2_TU, VFWCVT_RTZ_X_F_V, 0x7 }, // 3054
  { PseudoVFWCVT_XU_F_V_M1, VFWCVT_XU_F_V, 0x0 }, // 3055
  { PseudoVFWCVT_XU_F_V_M1_MASK, VFWCVT_XU_F_V, 0x0 }, // 3056
  { PseudoVFWCVT_XU_F_V_M1_TU, VFWCVT_XU_F_V, 0x0 }, // 3057
  { PseudoVFWCVT_XU_F_V_M2, VFWCVT_XU_F_V, 0x1 }, // 3058
  { PseudoVFWCVT_XU_F_V_M2_MASK, VFWCVT_XU_F_V, 0x1 }, // 3059
  { PseudoVFWCVT_XU_F_V_M2_TU, VFWCVT_XU_F_V, 0x1 }, // 3060
  { PseudoVFWCVT_XU_F_V_M4, VFWCVT_XU_F_V, 0x2 }, // 3061
  { PseudoVFWCVT_XU_F_V_M4_MASK, VFWCVT_XU_F_V, 0x2 }, // 3062
  { PseudoVFWCVT_XU_F_V_M4_TU, VFWCVT_XU_F_V, 0x2 }, // 3063
  { PseudoVFWCVT_XU_F_V_MF4, VFWCVT_XU_F_V, 0x6 }, // 3064
  { PseudoVFWCVT_XU_F_V_MF4_MASK, VFWCVT_XU_F_V, 0x6 }, // 3065
  { PseudoVFWCVT_XU_F_V_MF4_TU, VFWCVT_XU_F_V, 0x6 }, // 3066
  { PseudoVFWCVT_XU_F_V_MF2, VFWCVT_XU_F_V, 0x7 }, // 3067
  { PseudoVFWCVT_XU_F_V_MF2_MASK, VFWCVT_XU_F_V, 0x7 }, // 3068
  { PseudoVFWCVT_XU_F_V_MF2_TU, VFWCVT_XU_F_V, 0x7 }, // 3069
  { PseudoVFWCVT_X_F_V_M1, VFWCVT_X_F_V, 0x0 }, // 3070
  { PseudoVFWCVT_X_F_V_M1_MASK, VFWCVT_X_F_V, 0x0 }, // 3071
  { PseudoVFWCVT_X_F_V_M1_TU, VFWCVT_X_F_V, 0x0 }, // 3072
  { PseudoVFWCVT_X_F_V_M2, VFWCVT_X_F_V, 0x1 }, // 3073
  { PseudoVFWCVT_X_F_V_M2_MASK, VFWCVT_X_F_V, 0x1 }, // 3074
  { PseudoVFWCVT_X_F_V_M2_TU, VFWCVT_X_F_V, 0x1 }, // 3075
  { PseudoVFWCVT_X_F_V_M4, VFWCVT_X_F_V, 0x2 }, // 3076
  { PseudoVFWCVT_X_F_V_M4_MASK, VFWCVT_X_F_V, 0x2 }, // 3077
  { PseudoVFWCVT_X_F_V_M4_TU, VFWCVT_X_F_V, 0x2 }, // 3078
  { PseudoVFWCVT_X_F_V_MF4, VFWCVT_X_F_V, 0x6 }, // 3079
  { PseudoVFWCVT_X_F_V_MF4_MASK, VFWCVT_X_F_V, 0x6 }, // 3080
  { PseudoVFWCVT_X_F_V_MF4_TU, VFWCVT_X_F_V, 0x6 }, // 3081
  { PseudoVFWCVT_X_F_V_MF2, VFWCVT_X_F_V, 0x7 }, // 3082
  { PseudoVFWCVT_X_F_V_MF2_MASK, VFWCVT_X_F_V, 0x7 }, // 3083
  { PseudoVFWCVT_X_F_V_MF2_TU, VFWCVT_X_F_V, 0x7 }, // 3084
  { PseudoVFWMACC_VF16_M1, VFWMACC_VF, 0x0 }, // 3085
  { PseudoVFWMACC_VF16_M1_MASK, VFWMACC_VF, 0x0 }, // 3086
  { PseudoVFWMACC_VF32_M1, VFWMACC_VF, 0x0 }, // 3087
  { PseudoVFWMACC_VF32_M1_MASK, VFWMACC_VF, 0x0 }, // 3088
  { PseudoVFWMACC_VF16_M2, VFWMACC_VF, 0x1 }, // 3089
  { PseudoVFWMACC_VF16_M2_MASK, VFWMACC_VF, 0x1 }, // 3090
  { PseudoVFWMACC_VF32_M2, VFWMACC_VF, 0x1 }, // 3091
  { PseudoVFWMACC_VF32_M2_MASK, VFWMACC_VF, 0x1 }, // 3092
  { PseudoVFWMACC_VF16_M4, VFWMACC_VF, 0x2 }, // 3093
  { PseudoVFWMACC_VF16_M4_MASK, VFWMACC_VF, 0x2 }, // 3094
  { PseudoVFWMACC_VF32_M4, VFWMACC_VF, 0x2 }, // 3095
  { PseudoVFWMACC_VF32_M4_MASK, VFWMACC_VF, 0x2 }, // 3096
  { PseudoVFWMACC_VF16_MF4, VFWMACC_VF, 0x6 }, // 3097
  { PseudoVFWMACC_VF16_MF4_MASK, VFWMACC_VF, 0x6 }, // 3098
  { PseudoVFWMACC_VF16_MF2, VFWMACC_VF, 0x7 }, // 3099
  { PseudoVFWMACC_VF16_MF2_MASK, VFWMACC_VF, 0x7 }, // 3100
  { PseudoVFWMACC_VF32_MF2, VFWMACC_VF, 0x7 }, // 3101
  { PseudoVFWMACC_VF32_MF2_MASK, VFWMACC_VF, 0x7 }, // 3102
  { PseudoVFWMACC_VV_M1, VFWMACC_VV, 0x0 }, // 3103
  { PseudoVFWMACC_VV_M1_MASK, VFWMACC_VV, 0x0 }, // 3104
  { PseudoVFWMACC_VV_M2, VFWMACC_VV, 0x1 }, // 3105
  { PseudoVFWMACC_VV_M2_MASK, VFWMACC_VV, 0x1 }, // 3106
  { PseudoVFWMACC_VV_M4, VFWMACC_VV, 0x2 }, // 3107
  { PseudoVFWMACC_VV_M4_MASK, VFWMACC_VV, 0x2 }, // 3108
  { PseudoVFWMACC_VV_MF4, VFWMACC_VV, 0x6 }, // 3109
  { PseudoVFWMACC_VV_MF4_MASK, VFWMACC_VV, 0x6 }, // 3110
  { PseudoVFWMACC_VV_MF2, VFWMACC_VV, 0x7 }, // 3111
  { PseudoVFWMACC_VV_MF2_MASK, VFWMACC_VV, 0x7 }, // 3112
  { PseudoVFWMSAC_VF16_M1, VFWMSAC_VF, 0x0 }, // 3113
  { PseudoVFWMSAC_VF16_M1_MASK, VFWMSAC_VF, 0x0 }, // 3114
  { PseudoVFWMSAC_VF32_M1, VFWMSAC_VF, 0x0 }, // 3115
  { PseudoVFWMSAC_VF32_M1_MASK, VFWMSAC_VF, 0x0 }, // 3116
  { PseudoVFWMSAC_VF16_M2, VFWMSAC_VF, 0x1 }, // 3117
  { PseudoVFWMSAC_VF16_M2_MASK, VFWMSAC_VF, 0x1 }, // 3118
  { PseudoVFWMSAC_VF32_M2, VFWMSAC_VF, 0x1 }, // 3119
  { PseudoVFWMSAC_VF32_M2_MASK, VFWMSAC_VF, 0x1 }, // 3120
  { PseudoVFWMSAC_VF16_M4, VFWMSAC_VF, 0x2 }, // 3121
  { PseudoVFWMSAC_VF16_M4_MASK, VFWMSAC_VF, 0x2 }, // 3122
  { PseudoVFWMSAC_VF32_M4, VFWMSAC_VF, 0x2 }, // 3123
  { PseudoVFWMSAC_VF32_M4_MASK, VFWMSAC_VF, 0x2 }, // 3124
  { PseudoVFWMSAC_VF16_MF4, VFWMSAC_VF, 0x6 }, // 3125
  { PseudoVFWMSAC_VF16_MF4_MASK, VFWMSAC_VF, 0x6 }, // 3126
  { PseudoVFWMSAC_VF16_MF2, VFWMSAC_VF, 0x7 }, // 3127
  { PseudoVFWMSAC_VF16_MF2_MASK, VFWMSAC_VF, 0x7 }, // 3128
  { PseudoVFWMSAC_VF32_MF2, VFWMSAC_VF, 0x7 }, // 3129
  { PseudoVFWMSAC_VF32_MF2_MASK, VFWMSAC_VF, 0x7 }, // 3130
  { PseudoVFWMSAC_VV_M1, VFWMSAC_VV, 0x0 }, // 3131
  { PseudoVFWMSAC_VV_M1_MASK, VFWMSAC_VV, 0x0 }, // 3132
  { PseudoVFWMSAC_VV_M2, VFWMSAC_VV, 0x1 }, // 3133
  { PseudoVFWMSAC_VV_M2_MASK, VFWMSAC_VV, 0x1 }, // 3134
  { PseudoVFWMSAC_VV_M4, VFWMSAC_VV, 0x2 }, // 3135
  { PseudoVFWMSAC_VV_M4_MASK, VFWMSAC_VV, 0x2 }, // 3136
  { PseudoVFWMSAC_VV_MF4, VFWMSAC_VV, 0x6 }, // 3137
  { PseudoVFWMSAC_VV_MF4_MASK, VFWMSAC_VV, 0x6 }, // 3138
  { PseudoVFWMSAC_VV_MF2, VFWMSAC_VV, 0x7 }, // 3139
  { PseudoVFWMSAC_VV_MF2_MASK, VFWMSAC_VV, 0x7 }, // 3140
  { PseudoVFWMUL_VF16_M1, VFWMUL_VF, 0x0 }, // 3141
  { PseudoVFWMUL_VF16_M1_MASK, VFWMUL_VF, 0x0 }, // 3142
  { PseudoVFWMUL_VF16_M1_TU, VFWMUL_VF, 0x0 }, // 3143
  { PseudoVFWMUL_VF32_M1, VFWMUL_VF, 0x0 }, // 3144
  { PseudoVFWMUL_VF32_M1_MASK, VFWMUL_VF, 0x0 }, // 3145
  { PseudoVFWMUL_VF32_M1_TU, VFWMUL_VF, 0x0 }, // 3146
  { PseudoVFWMUL_VF16_M2, VFWMUL_VF, 0x1 }, // 3147
  { PseudoVFWMUL_VF16_M2_MASK, VFWMUL_VF, 0x1 }, // 3148
  { PseudoVFWMUL_VF16_M2_TU, VFWMUL_VF, 0x1 }, // 3149
  { PseudoVFWMUL_VF32_M2, VFWMUL_VF, 0x1 }, // 3150
  { PseudoVFWMUL_VF32_M2_MASK, VFWMUL_VF, 0x1 }, // 3151
  { PseudoVFWMUL_VF32_M2_TU, VFWMUL_VF, 0x1 }, // 3152
  { PseudoVFWMUL_VF16_M4, VFWMUL_VF, 0x2 }, // 3153
  { PseudoVFWMUL_VF16_M4_MASK, VFWMUL_VF, 0x2 }, // 3154
  { PseudoVFWMUL_VF16_M4_TU, VFWMUL_VF, 0x2 }, // 3155
  { PseudoVFWMUL_VF32_M4, VFWMUL_VF, 0x2 }, // 3156
  { PseudoVFWMUL_VF32_M4_MASK, VFWMUL_VF, 0x2 }, // 3157
  { PseudoVFWMUL_VF32_M4_TU, VFWMUL_VF, 0x2 }, // 3158
  { PseudoVFWMUL_VF16_MF4, VFWMUL_VF, 0x6 }, // 3159
  { PseudoVFWMUL_VF16_MF4_MASK, VFWMUL_VF, 0x6 }, // 3160
  { PseudoVFWMUL_VF16_MF4_TU, VFWMUL_VF, 0x6 }, // 3161
  { PseudoVFWMUL_VF16_MF2, VFWMUL_VF, 0x7 }, // 3162
  { PseudoVFWMUL_VF16_MF2_MASK, VFWMUL_VF, 0x7 }, // 3163
  { PseudoVFWMUL_VF16_MF2_TU, VFWMUL_VF, 0x7 }, // 3164
  { PseudoVFWMUL_VF32_MF2, VFWMUL_VF, 0x7 }, // 3165
  { PseudoVFWMUL_VF32_MF2_MASK, VFWMUL_VF, 0x7 }, // 3166
  { PseudoVFWMUL_VF32_MF2_TU, VFWMUL_VF, 0x7 }, // 3167
  { PseudoVFWMUL_VV_M1, VFWMUL_VV, 0x0 }, // 3168
  { PseudoVFWMUL_VV_M1_MASK, VFWMUL_VV, 0x0 }, // 3169
  { PseudoVFWMUL_VV_M1_TU, VFWMUL_VV, 0x0 }, // 3170
  { PseudoVFWMUL_VV_M2, VFWMUL_VV, 0x1 }, // 3171
  { PseudoVFWMUL_VV_M2_MASK, VFWMUL_VV, 0x1 }, // 3172
  { PseudoVFWMUL_VV_M2_TU, VFWMUL_VV, 0x1 }, // 3173
  { PseudoVFWMUL_VV_M4, VFWMUL_VV, 0x2 }, // 3174
  { PseudoVFWMUL_VV_M4_MASK, VFWMUL_VV, 0x2 }, // 3175
  { PseudoVFWMUL_VV_M4_TU, VFWMUL_VV, 0x2 }, // 3176
  { PseudoVFWMUL_VV_MF4, VFWMUL_VV, 0x6 }, // 3177
  { PseudoVFWMUL_VV_MF4_MASK, VFWMUL_VV, 0x6 }, // 3178
  { PseudoVFWMUL_VV_MF4_TU, VFWMUL_VV, 0x6 }, // 3179
  { PseudoVFWMUL_VV_MF2, VFWMUL_VV, 0x7 }, // 3180
  { PseudoVFWMUL_VV_MF2_MASK, VFWMUL_VV, 0x7 }, // 3181
  { PseudoVFWMUL_VV_MF2_TU, VFWMUL_VV, 0x7 }, // 3182
  { PseudoVFWNMACC_VF16_M1, VFWNMACC_VF, 0x0 }, // 3183
  { PseudoVFWNMACC_VF16_M1_MASK, VFWNMACC_VF, 0x0 }, // 3184
  { PseudoVFWNMACC_VF32_M1, VFWNMACC_VF, 0x0 }, // 3185
  { PseudoVFWNMACC_VF32_M1_MASK, VFWNMACC_VF, 0x0 }, // 3186
  { PseudoVFWNMACC_VF16_M2, VFWNMACC_VF, 0x1 }, // 3187
  { PseudoVFWNMACC_VF16_M2_MASK, VFWNMACC_VF, 0x1 }, // 3188
  { PseudoVFWNMACC_VF32_M2, VFWNMACC_VF, 0x1 }, // 3189
  { PseudoVFWNMACC_VF32_M2_MASK, VFWNMACC_VF, 0x1 }, // 3190
  { PseudoVFWNMACC_VF16_M4, VFWNMACC_VF, 0x2 }, // 3191
  { PseudoVFWNMACC_VF16_M4_MASK, VFWNMACC_VF, 0x2 }, // 3192
  { PseudoVFWNMACC_VF32_M4, VFWNMACC_VF, 0x2 }, // 3193
  { PseudoVFWNMACC_VF32_M4_MASK, VFWNMACC_VF, 0x2 }, // 3194
  { PseudoVFWNMACC_VF16_MF4, VFWNMACC_VF, 0x6 }, // 3195
  { PseudoVFWNMACC_VF16_MF4_MASK, VFWNMACC_VF, 0x6 }, // 3196
  { PseudoVFWNMACC_VF16_MF2, VFWNMACC_VF, 0x7 }, // 3197
  { PseudoVFWNMACC_VF16_MF2_MASK, VFWNMACC_VF, 0x7 }, // 3198
  { PseudoVFWNMACC_VF32_MF2, VFWNMACC_VF, 0x7 }, // 3199
  { PseudoVFWNMACC_VF32_MF2_MASK, VFWNMACC_VF, 0x7 }, // 3200
  { PseudoVFWNMACC_VV_M1, VFWNMACC_VV, 0x0 }, // 3201
  { PseudoVFWNMACC_VV_M1_MASK, VFWNMACC_VV, 0x0 }, // 3202
  { PseudoVFWNMACC_VV_M2, VFWNMACC_VV, 0x1 }, // 3203
  { PseudoVFWNMACC_VV_M2_MASK, VFWNMACC_VV, 0x1 }, // 3204
  { PseudoVFWNMACC_VV_M4, VFWNMACC_VV, 0x2 }, // 3205
  { PseudoVFWNMACC_VV_M4_MASK, VFWNMACC_VV, 0x2 }, // 3206
  { PseudoVFWNMACC_VV_MF4, VFWNMACC_VV, 0x6 }, // 3207
  { PseudoVFWNMACC_VV_MF4_MASK, VFWNMACC_VV, 0x6 }, // 3208
  { PseudoVFWNMACC_VV_MF2, VFWNMACC_VV, 0x7 }, // 3209
  { PseudoVFWNMACC_VV_MF2_MASK, VFWNMACC_VV, 0x7 }, // 3210
  { PseudoVFWNMSAC_VF16_M1, VFWNMSAC_VF, 0x0 }, // 3211
  { PseudoVFWNMSAC_VF16_M1_MASK, VFWNMSAC_VF, 0x0 }, // 3212
  { PseudoVFWNMSAC_VF32_M1, VFWNMSAC_VF, 0x0 }, // 3213
  { PseudoVFWNMSAC_VF32_M1_MASK, VFWNMSAC_VF, 0x0 }, // 3214
  { PseudoVFWNMSAC_VF16_M2, VFWNMSAC_VF, 0x1 }, // 3215
  { PseudoVFWNMSAC_VF16_M2_MASK, VFWNMSAC_VF, 0x1 }, // 3216
  { PseudoVFWNMSAC_VF32_M2, VFWNMSAC_VF, 0x1 }, // 3217
  { PseudoVFWNMSAC_VF32_M2_MASK, VFWNMSAC_VF, 0x1 }, // 3218
  { PseudoVFWNMSAC_VF16_M4, VFWNMSAC_VF, 0x2 }, // 3219
  { PseudoVFWNMSAC_VF16_M4_MASK, VFWNMSAC_VF, 0x2 }, // 3220
  { PseudoVFWNMSAC_VF32_M4, VFWNMSAC_VF, 0x2 }, // 3221
  { PseudoVFWNMSAC_VF32_M4_MASK, VFWNMSAC_VF, 0x2 }, // 3222
  { PseudoVFWNMSAC_VF16_MF4, VFWNMSAC_VF, 0x6 }, // 3223
  { PseudoVFWNMSAC_VF16_MF4_MASK, VFWNMSAC_VF, 0x6 }, // 3224
  { PseudoVFWNMSAC_VF16_MF2, VFWNMSAC_VF, 0x7 }, // 3225
  { PseudoVFWNMSAC_VF16_MF2_MASK, VFWNMSAC_VF, 0x7 }, // 3226
  { PseudoVFWNMSAC_VF32_MF2, VFWNMSAC_VF, 0x7 }, // 3227
  { PseudoVFWNMSAC_VF32_MF2_MASK, VFWNMSAC_VF, 0x7 }, // 3228
  { PseudoVFWNMSAC_VV_M1, VFWNMSAC_VV, 0x0 }, // 3229
  { PseudoVFWNMSAC_VV_M1_MASK, VFWNMSAC_VV, 0x0 }, // 3230
  { PseudoVFWNMSAC_VV_M2, VFWNMSAC_VV, 0x1 }, // 3231
  { PseudoVFWNMSAC_VV_M2_MASK, VFWNMSAC_VV, 0x1 }, // 3232
  { PseudoVFWNMSAC_VV_M4, VFWNMSAC_VV, 0x2 }, // 3233
  { PseudoVFWNMSAC_VV_M4_MASK, VFWNMSAC_VV, 0x2 }, // 3234
  { PseudoVFWNMSAC_VV_MF4, VFWNMSAC_VV, 0x6 }, // 3235
  { PseudoVFWNMSAC_VV_MF4_MASK, VFWNMSAC_VV, 0x6 }, // 3236
  { PseudoVFWNMSAC_VV_MF2, VFWNMSAC_VV, 0x7 }, // 3237
  { PseudoVFWNMSAC_VV_MF2_MASK, VFWNMSAC_VV, 0x7 }, // 3238
  { PseudoVFWREDOSUM_VS_M1_E16, VFWREDOSUM_VS, 0x0 }, // 3239
  { PseudoVFWREDOSUM_VS_M1_E16_MASK, VFWREDOSUM_VS, 0x0 }, // 3240
  { PseudoVFWREDOSUM_VS_M1_E32, VFWREDOSUM_VS, 0x0 }, // 3241
  { PseudoVFWREDOSUM_VS_M1_E32_MASK, VFWREDOSUM_VS, 0x0 }, // 3242
  { PseudoVFWREDOSUM_VS_M2_E16, VFWREDOSUM_VS, 0x1 }, // 3243
  { PseudoVFWREDOSUM_VS_M2_E16_MASK, VFWREDOSUM_VS, 0x1 }, // 3244
  { PseudoVFWREDOSUM_VS_M2_E32, VFWREDOSUM_VS, 0x1 }, // 3245
  { PseudoVFWREDOSUM_VS_M2_E32_MASK, VFWREDOSUM_VS, 0x1 }, // 3246
  { PseudoVFWREDOSUM_VS_M4_E16, VFWREDOSUM_VS, 0x2 }, // 3247
  { PseudoVFWREDOSUM_VS_M4_E16_MASK, VFWREDOSUM_VS, 0x2 }, // 3248
  { PseudoVFWREDOSUM_VS_M4_E32, VFWREDOSUM_VS, 0x2 }, // 3249
  { PseudoVFWREDOSUM_VS_M4_E32_MASK, VFWREDOSUM_VS, 0x2 }, // 3250
  { PseudoVFWREDOSUM_VS_M8_E16, VFWREDOSUM_VS, 0x3 }, // 3251
  { PseudoVFWREDOSUM_VS_M8_E16_MASK, VFWREDOSUM_VS, 0x3 }, // 3252
  { PseudoVFWREDOSUM_VS_M8_E32, VFWREDOSUM_VS, 0x3 }, // 3253
  { PseudoVFWREDOSUM_VS_M8_E32_MASK, VFWREDOSUM_VS, 0x3 }, // 3254
  { PseudoVFWREDOSUM_VS_MF4_E16, VFWREDOSUM_VS, 0x6 }, // 3255
  { PseudoVFWREDOSUM_VS_MF4_E16_MASK, VFWREDOSUM_VS, 0x6 }, // 3256
  { PseudoVFWREDOSUM_VS_MF2_E16, VFWREDOSUM_VS, 0x7 }, // 3257
  { PseudoVFWREDOSUM_VS_MF2_E16_MASK, VFWREDOSUM_VS, 0x7 }, // 3258
  { PseudoVFWREDOSUM_VS_MF2_E32, VFWREDOSUM_VS, 0x7 }, // 3259
  { PseudoVFWREDOSUM_VS_MF2_E32_MASK, VFWREDOSUM_VS, 0x7 }, // 3260
  { PseudoVFWREDUSUM_VS_M1_E16, VFWREDUSUM_VS, 0x0 }, // 3261
  { PseudoVFWREDUSUM_VS_M1_E16_MASK, VFWREDUSUM_VS, 0x0 }, // 3262
  { PseudoVFWREDUSUM_VS_M1_E32, VFWREDUSUM_VS, 0x0 }, // 3263
  { PseudoVFWREDUSUM_VS_M1_E32_MASK, VFWREDUSUM_VS, 0x0 }, // 3264
  { PseudoVFWREDUSUM_VS_M2_E16, VFWREDUSUM_VS, 0x1 }, // 3265
  { PseudoVFWREDUSUM_VS_M2_E16_MASK, VFWREDUSUM_VS, 0x1 }, // 3266
  { PseudoVFWREDUSUM_VS_M2_E32, VFWREDUSUM_VS, 0x1 }, // 3267
  { PseudoVFWREDUSUM_VS_M2_E32_MASK, VFWREDUSUM_VS, 0x1 }, // 3268
  { PseudoVFWREDUSUM_VS_M4_E16, VFWREDUSUM_VS, 0x2 }, // 3269
  { PseudoVFWREDUSUM_VS_M4_E16_MASK, VFWREDUSUM_VS, 0x2 }, // 3270
  { PseudoVFWREDUSUM_VS_M4_E32, VFWREDUSUM_VS, 0x2 }, // 3271
  { PseudoVFWREDUSUM_VS_M4_E32_MASK, VFWREDUSUM_VS, 0x2 }, // 3272
  { PseudoVFWREDUSUM_VS_M8_E16, VFWREDUSUM_VS, 0x3 }, // 3273
  { PseudoVFWREDUSUM_VS_M8_E16_MASK, VFWREDUSUM_VS, 0x3 }, // 3274
  { PseudoVFWREDUSUM_VS_M8_E32, VFWREDUSUM_VS, 0x3 }, // 3275
  { PseudoVFWREDUSUM_VS_M8_E32_MASK, VFWREDUSUM_VS, 0x3 }, // 3276
  { PseudoVFWREDUSUM_VS_MF4_E16, VFWREDUSUM_VS, 0x6 }, // 3277
  { PseudoVFWREDUSUM_VS_MF4_E16_MASK, VFWREDUSUM_VS, 0x6 }, // 3278
  { PseudoVFWREDUSUM_VS_MF2_E16, VFWREDUSUM_VS, 0x7 }, // 3279
  { PseudoVFWREDUSUM_VS_MF2_E16_MASK, VFWREDUSUM_VS, 0x7 }, // 3280
  { PseudoVFWREDUSUM_VS_MF2_E32, VFWREDUSUM_VS, 0x7 }, // 3281
  { PseudoVFWREDUSUM_VS_MF2_E32_MASK, VFWREDUSUM_VS, 0x7 }, // 3282
  { PseudoVFWSUB_VF16_M1, VFWSUB_VF, 0x0 }, // 3283
  { PseudoVFWSUB_VF16_M1_MASK, VFWSUB_VF, 0x0 }, // 3284
  { PseudoVFWSUB_VF16_M1_TU, VFWSUB_VF, 0x0 }, // 3285
  { PseudoVFWSUB_VF32_M1, VFWSUB_VF, 0x0 }, // 3286
  { PseudoVFWSUB_VF32_M1_MASK, VFWSUB_VF, 0x0 }, // 3287
  { PseudoVFWSUB_VF32_M1_TU, VFWSUB_VF, 0x0 }, // 3288
  { PseudoVFWSUB_VF16_M2, VFWSUB_VF, 0x1 }, // 3289
  { PseudoVFWSUB_VF16_M2_MASK, VFWSUB_VF, 0x1 }, // 3290
  { PseudoVFWSUB_VF16_M2_TU, VFWSUB_VF, 0x1 }, // 3291
  { PseudoVFWSUB_VF32_M2, VFWSUB_VF, 0x1 }, // 3292
  { PseudoVFWSUB_VF32_M2_MASK, VFWSUB_VF, 0x1 }, // 3293
  { PseudoVFWSUB_VF32_M2_TU, VFWSUB_VF, 0x1 }, // 3294
  { PseudoVFWSUB_VF16_M4, VFWSUB_VF, 0x2 }, // 3295
  { PseudoVFWSUB_VF16_M4_MASK, VFWSUB_VF, 0x2 }, // 3296
  { PseudoVFWSUB_VF16_M4_TU, VFWSUB_VF, 0x2 }, // 3297
  { PseudoVFWSUB_VF32_M4, VFWSUB_VF, 0x2 }, // 3298
  { PseudoVFWSUB_VF32_M4_MASK, VFWSUB_VF, 0x2 }, // 3299
  { PseudoVFWSUB_VF32_M4_TU, VFWSUB_VF, 0x2 }, // 3300
  { PseudoVFWSUB_VF16_MF4, VFWSUB_VF, 0x6 }, // 3301
  { PseudoVFWSUB_VF16_MF4_MASK, VFWSUB_VF, 0x6 }, // 3302
  { PseudoVFWSUB_VF16_MF4_TU, VFWSUB_VF, 0x6 }, // 3303
  { PseudoVFWSUB_VF16_MF2, VFWSUB_VF, 0x7 }, // 3304
  { PseudoVFWSUB_VF16_MF2_MASK, VFWSUB_VF, 0x7 }, // 3305
  { PseudoVFWSUB_VF16_MF2_TU, VFWSUB_VF, 0x7 }, // 3306
  { PseudoVFWSUB_VF32_MF2, VFWSUB_VF, 0x7 }, // 3307
  { PseudoVFWSUB_VF32_MF2_MASK, VFWSUB_VF, 0x7 }, // 3308
  { PseudoVFWSUB_VF32_MF2_TU, VFWSUB_VF, 0x7 }, // 3309
  { PseudoVFWSUB_VV_M1, VFWSUB_VV, 0x0 }, // 3310
  { PseudoVFWSUB_VV_M1_MASK, VFWSUB_VV, 0x0 }, // 3311
  { PseudoVFWSUB_VV_M1_TU, VFWSUB_VV, 0x0 }, // 3312
  { PseudoVFWSUB_VV_M2, VFWSUB_VV, 0x1 }, // 3313
  { PseudoVFWSUB_VV_M2_MASK, VFWSUB_VV, 0x1 }, // 3314
  { PseudoVFWSUB_VV_M2_TU, VFWSUB_VV, 0x1 }, // 3315
  { PseudoVFWSUB_VV_M4, VFWSUB_VV, 0x2 }, // 3316
  { PseudoVFWSUB_VV_M4_MASK, VFWSUB_VV, 0x2 }, // 3317
  { PseudoVFWSUB_VV_M4_TU, VFWSUB_VV, 0x2 }, // 3318
  { PseudoVFWSUB_VV_MF4, VFWSUB_VV, 0x6 }, // 3319
  { PseudoVFWSUB_VV_MF4_MASK, VFWSUB_VV, 0x6 }, // 3320
  { PseudoVFWSUB_VV_MF4_TU, VFWSUB_VV, 0x6 }, // 3321
  { PseudoVFWSUB_VV_MF2, VFWSUB_VV, 0x7 }, // 3322
  { PseudoVFWSUB_VV_MF2_MASK, VFWSUB_VV, 0x7 }, // 3323
  { PseudoVFWSUB_VV_MF2_TU, VFWSUB_VV, 0x7 }, // 3324
  { PseudoVFWSUB_WF16_M1, VFWSUB_WF, 0x0 }, // 3325
  { PseudoVFWSUB_WF16_M1_MASK, VFWSUB_WF, 0x0 }, // 3326
  { PseudoVFWSUB_WF16_M1_TU, VFWSUB_WF, 0x0 }, // 3327
  { PseudoVFWSUB_WF32_M1, VFWSUB_WF, 0x0 }, // 3328
  { PseudoVFWSUB_WF32_M1_MASK, VFWSUB_WF, 0x0 }, // 3329
  { PseudoVFWSUB_WF32_M1_TU, VFWSUB_WF, 0x0 }, // 3330
  { PseudoVFWSUB_WF16_M2, VFWSUB_WF, 0x1 }, // 3331
  { PseudoVFWSUB_WF16_M2_MASK, VFWSUB_WF, 0x1 }, // 3332
  { PseudoVFWSUB_WF16_M2_TU, VFWSUB_WF, 0x1 }, // 3333
  { PseudoVFWSUB_WF32_M2, VFWSUB_WF, 0x1 }, // 3334
  { PseudoVFWSUB_WF32_M2_MASK, VFWSUB_WF, 0x1 }, // 3335
  { PseudoVFWSUB_WF32_M2_TU, VFWSUB_WF, 0x1 }, // 3336
  { PseudoVFWSUB_WF16_M4, VFWSUB_WF, 0x2 }, // 3337
  { PseudoVFWSUB_WF16_M4_MASK, VFWSUB_WF, 0x2 }, // 3338
  { PseudoVFWSUB_WF16_M4_TU, VFWSUB_WF, 0x2 }, // 3339
  { PseudoVFWSUB_WF32_M4, VFWSUB_WF, 0x2 }, // 3340
  { PseudoVFWSUB_WF32_M4_MASK, VFWSUB_WF, 0x2 }, // 3341
  { PseudoVFWSUB_WF32_M4_TU, VFWSUB_WF, 0x2 }, // 3342
  { PseudoVFWSUB_WF16_MF4, VFWSUB_WF, 0x6 }, // 3343
  { PseudoVFWSUB_WF16_MF4_MASK, VFWSUB_WF, 0x6 }, // 3344
  { PseudoVFWSUB_WF16_MF4_TU, VFWSUB_WF, 0x6 }, // 3345
  { PseudoVFWSUB_WF16_MF2, VFWSUB_WF, 0x7 }, // 3346
  { PseudoVFWSUB_WF16_MF2_MASK, VFWSUB_WF, 0x7 }, // 3347
  { PseudoVFWSUB_WF16_MF2_TU, VFWSUB_WF, 0x7 }, // 3348
  { PseudoVFWSUB_WF32_MF2, VFWSUB_WF, 0x7 }, // 3349
  { PseudoVFWSUB_WF32_MF2_MASK, VFWSUB_WF, 0x7 }, // 3350
  { PseudoVFWSUB_WF32_MF2_TU, VFWSUB_WF, 0x7 }, // 3351
  { PseudoVFWSUB_WV_M1, VFWSUB_WV, 0x0 }, // 3352
  { PseudoVFWSUB_WV_M1_MASK, VFWSUB_WV, 0x0 }, // 3353
  { PseudoVFWSUB_WV_M1_MASK_TIED, VFWSUB_WV, 0x0 }, // 3354
  { PseudoVFWSUB_WV_M1_TIED, VFWSUB_WV, 0x0 }, // 3355
  { PseudoVFWSUB_WV_M1_TU, VFWSUB_WV, 0x0 }, // 3356
  { PseudoVFWSUB_WV_M2, VFWSUB_WV, 0x1 }, // 3357
  { PseudoVFWSUB_WV_M2_MASK, VFWSUB_WV, 0x1 }, // 3358
  { PseudoVFWSUB_WV_M2_MASK_TIED, VFWSUB_WV, 0x1 }, // 3359
  { PseudoVFWSUB_WV_M2_TIED, VFWSUB_WV, 0x1 }, // 3360
  { PseudoVFWSUB_WV_M2_TU, VFWSUB_WV, 0x1 }, // 3361
  { PseudoVFWSUB_WV_M4, VFWSUB_WV, 0x2 }, // 3362
  { PseudoVFWSUB_WV_M4_MASK, VFWSUB_WV, 0x2 }, // 3363
  { PseudoVFWSUB_WV_M4_MASK_TIED, VFWSUB_WV, 0x2 }, // 3364
  { PseudoVFWSUB_WV_M4_TIED, VFWSUB_WV, 0x2 }, // 3365
  { PseudoVFWSUB_WV_M4_TU, VFWSUB_WV, 0x2 }, // 3366
  { PseudoVFWSUB_WV_MF4, VFWSUB_WV, 0x6 }, // 3367
  { PseudoVFWSUB_WV_MF4_MASK, VFWSUB_WV, 0x6 }, // 3368
  { PseudoVFWSUB_WV_MF4_MASK_TIED, VFWSUB_WV, 0x6 }, // 3369
  { PseudoVFWSUB_WV_MF4_TIED, VFWSUB_WV, 0x6 }, // 3370
  { PseudoVFWSUB_WV_MF4_TU, VFWSUB_WV, 0x6 }, // 3371
  { PseudoVFWSUB_WV_MF2, VFWSUB_WV, 0x7 }, // 3372
  { PseudoVFWSUB_WV_MF2_MASK, VFWSUB_WV, 0x7 }, // 3373
  { PseudoVFWSUB_WV_MF2_MASK_TIED, VFWSUB_WV, 0x7 }, // 3374
  { PseudoVFWSUB_WV_MF2_TIED, VFWSUB_WV, 0x7 }, // 3375
  { PseudoVFWSUB_WV_MF2_TU, VFWSUB_WV, 0x7 }, // 3376
  { PseudoVID_V_M1, VID_V, 0x0 }, // 3377
  { PseudoVID_V_M1_MASK, VID_V, 0x0 }, // 3378
  { PseudoVID_V_M1_TU, VID_V, 0x0 }, // 3379
  { PseudoVID_V_M2, VID_V, 0x1 }, // 3380
  { PseudoVID_V_M2_MASK, VID_V, 0x1 }, // 3381
  { PseudoVID_V_M2_TU, VID_V, 0x1 }, // 3382
  { PseudoVID_V_M4, VID_V, 0x2 }, // 3383
  { PseudoVID_V_M4_MASK, VID_V, 0x2 }, // 3384
  { PseudoVID_V_M4_TU, VID_V, 0x2 }, // 3385
  { PseudoVID_V_M8, VID_V, 0x3 }, // 3386
  { PseudoVID_V_M8_MASK, VID_V, 0x3 }, // 3387
  { PseudoVID_V_M8_TU, VID_V, 0x3 }, // 3388
  { PseudoVID_V_MF8, VID_V, 0x5 }, // 3389
  { PseudoVID_V_MF8_MASK, VID_V, 0x5 }, // 3390
  { PseudoVID_V_MF8_TU, VID_V, 0x5 }, // 3391
  { PseudoVID_V_MF4, VID_V, 0x6 }, // 3392
  { PseudoVID_V_MF4_MASK, VID_V, 0x6 }, // 3393
  { PseudoVID_V_MF4_TU, VID_V, 0x6 }, // 3394
  { PseudoVID_V_MF2, VID_V, 0x7 }, // 3395
  { PseudoVID_V_MF2_MASK, VID_V, 0x7 }, // 3396
  { PseudoVID_V_MF2_TU, VID_V, 0x7 }, // 3397
  { PseudoVIOTA_M_M1, VIOTA_M, 0x0 }, // 3398
  { PseudoVIOTA_M_M1_MASK, VIOTA_M, 0x0 }, // 3399
  { PseudoVIOTA_M_M1_TU, VIOTA_M, 0x0 }, // 3400
  { PseudoVIOTA_M_M2, VIOTA_M, 0x1 }, // 3401
  { PseudoVIOTA_M_M2_MASK, VIOTA_M, 0x1 }, // 3402
  { PseudoVIOTA_M_M2_TU, VIOTA_M, 0x1 }, // 3403
  { PseudoVIOTA_M_M4, VIOTA_M, 0x2 }, // 3404
  { PseudoVIOTA_M_M4_MASK, VIOTA_M, 0x2 }, // 3405
  { PseudoVIOTA_M_M4_TU, VIOTA_M, 0x2 }, // 3406
  { PseudoVIOTA_M_M8, VIOTA_M, 0x3 }, // 3407
  { PseudoVIOTA_M_M8_MASK, VIOTA_M, 0x3 }, // 3408
  { PseudoVIOTA_M_M8_TU, VIOTA_M, 0x3 }, // 3409
  { PseudoVIOTA_M_MF8, VIOTA_M, 0x5 }, // 3410
  { PseudoVIOTA_M_MF8_MASK, VIOTA_M, 0x5 }, // 3411
  { PseudoVIOTA_M_MF8_TU, VIOTA_M, 0x5 }, // 3412
  { PseudoVIOTA_M_MF4, VIOTA_M, 0x6 }, // 3413
  { PseudoVIOTA_M_MF4_MASK, VIOTA_M, 0x6 }, // 3414
  { PseudoVIOTA_M_MF4_TU, VIOTA_M, 0x6 }, // 3415
  { PseudoVIOTA_M_MF2, VIOTA_M, 0x7 }, // 3416
  { PseudoVIOTA_M_MF2_MASK, VIOTA_M, 0x7 }, // 3417
  { PseudoVIOTA_M_MF2_TU, VIOTA_M, 0x7 }, // 3418
  { PseudoVLE16FF_V_M1, VLE16FF_V, 0x0 }, // 3419
  { PseudoVLE16FF_V_M1_MASK, VLE16FF_V, 0x0 }, // 3420
  { PseudoVLE16FF_V_M1_TU, VLE16FF_V, 0x0 }, // 3421
  { PseudoVLE16FF_V_M2, VLE16FF_V, 0x1 }, // 3422
  { PseudoVLE16FF_V_M2_MASK, VLE16FF_V, 0x1 }, // 3423
  { PseudoVLE16FF_V_M2_TU, VLE16FF_V, 0x1 }, // 3424
  { PseudoVLE16FF_V_M4, VLE16FF_V, 0x2 }, // 3425
  { PseudoVLE16FF_V_M4_MASK, VLE16FF_V, 0x2 }, // 3426
  { PseudoVLE16FF_V_M4_TU, VLE16FF_V, 0x2 }, // 3427
  { PseudoVLE16FF_V_M8, VLE16FF_V, 0x3 }, // 3428
  { PseudoVLE16FF_V_M8_MASK, VLE16FF_V, 0x3 }, // 3429
  { PseudoVLE16FF_V_M8_TU, VLE16FF_V, 0x3 }, // 3430
  { PseudoVLE16FF_V_MF4, VLE16FF_V, 0x6 }, // 3431
  { PseudoVLE16FF_V_MF4_MASK, VLE16FF_V, 0x6 }, // 3432
  { PseudoVLE16FF_V_MF4_TU, VLE16FF_V, 0x6 }, // 3433
  { PseudoVLE16FF_V_MF2, VLE16FF_V, 0x7 }, // 3434
  { PseudoVLE16FF_V_MF2_MASK, VLE16FF_V, 0x7 }, // 3435
  { PseudoVLE16FF_V_MF2_TU, VLE16FF_V, 0x7 }, // 3436
  { PseudoVLE16_V_M1, VLE16_V, 0x0 }, // 3437
  { PseudoVLE16_V_M1_MASK, VLE16_V, 0x0 }, // 3438
  { PseudoVLE16_V_M1_TU, VLE16_V, 0x0 }, // 3439
  { PseudoVLE16_V_M2, VLE16_V, 0x1 }, // 3440
  { PseudoVLE16_V_M2_MASK, VLE16_V, 0x1 }, // 3441
  { PseudoVLE16_V_M2_TU, VLE16_V, 0x1 }, // 3442
  { PseudoVLE16_V_M4, VLE16_V, 0x2 }, // 3443
  { PseudoVLE16_V_M4_MASK, VLE16_V, 0x2 }, // 3444
  { PseudoVLE16_V_M4_TU, VLE16_V, 0x2 }, // 3445
  { PseudoVLE16_V_M8, VLE16_V, 0x3 }, // 3446
  { PseudoVLE16_V_M8_MASK, VLE16_V, 0x3 }, // 3447
  { PseudoVLE16_V_M8_TU, VLE16_V, 0x3 }, // 3448
  { PseudoVLE16_V_MF4, VLE16_V, 0x6 }, // 3449
  { PseudoVLE16_V_MF4_MASK, VLE16_V, 0x6 }, // 3450
  { PseudoVLE16_V_MF4_TU, VLE16_V, 0x6 }, // 3451
  { PseudoVLE16_V_MF2, VLE16_V, 0x7 }, // 3452
  { PseudoVLE16_V_MF2_MASK, VLE16_V, 0x7 }, // 3453
  { PseudoVLE16_V_MF2_TU, VLE16_V, 0x7 }, // 3454
  { PseudoVLE32FF_V_M1, VLE32FF_V, 0x0 }, // 3455
  { PseudoVLE32FF_V_M1_MASK, VLE32FF_V, 0x0 }, // 3456
  { PseudoVLE32FF_V_M1_TU, VLE32FF_V, 0x0 }, // 3457
  { PseudoVLE32FF_V_M2, VLE32FF_V, 0x1 }, // 3458
  { PseudoVLE32FF_V_M2_MASK, VLE32FF_V, 0x1 }, // 3459
  { PseudoVLE32FF_V_M2_TU, VLE32FF_V, 0x1 }, // 3460
  { PseudoVLE32FF_V_M4, VLE32FF_V, 0x2 }, // 3461
  { PseudoVLE32FF_V_M4_MASK, VLE32FF_V, 0x2 }, // 3462
  { PseudoVLE32FF_V_M4_TU, VLE32FF_V, 0x2 }, // 3463
  { PseudoVLE32FF_V_M8, VLE32FF_V, 0x3 }, // 3464
  { PseudoVLE32FF_V_M8_MASK, VLE32FF_V, 0x3 }, // 3465
  { PseudoVLE32FF_V_M8_TU, VLE32FF_V, 0x3 }, // 3466
  { PseudoVLE32FF_V_MF2, VLE32FF_V, 0x7 }, // 3467
  { PseudoVLE32FF_V_MF2_MASK, VLE32FF_V, 0x7 }, // 3468
  { PseudoVLE32FF_V_MF2_TU, VLE32FF_V, 0x7 }, // 3469
  { PseudoVLE32_V_M1, VLE32_V, 0x0 }, // 3470
  { PseudoVLE32_V_M1_MASK, VLE32_V, 0x0 }, // 3471
  { PseudoVLE32_V_M1_TU, VLE32_V, 0x0 }, // 3472
  { PseudoVLE32_V_M2, VLE32_V, 0x1 }, // 3473
  { PseudoVLE32_V_M2_MASK, VLE32_V, 0x1 }, // 3474
  { PseudoVLE32_V_M2_TU, VLE32_V, 0x1 }, // 3475
  { PseudoVLE32_V_M4, VLE32_V, 0x2 }, // 3476
  { PseudoVLE32_V_M4_MASK, VLE32_V, 0x2 }, // 3477
  { PseudoVLE32_V_M4_TU, VLE32_V, 0x2 }, // 3478
  { PseudoVLE32_V_M8, VLE32_V, 0x3 }, // 3479
  { PseudoVLE32_V_M8_MASK, VLE32_V, 0x3 }, // 3480
  { PseudoVLE32_V_M8_TU, VLE32_V, 0x3 }, // 3481
  { PseudoVLE32_V_MF2, VLE32_V, 0x7 }, // 3482
  { PseudoVLE32_V_MF2_MASK, VLE32_V, 0x7 }, // 3483
  { PseudoVLE32_V_MF2_TU, VLE32_V, 0x7 }, // 3484
  { PseudoVLE64FF_V_M1, VLE64FF_V, 0x0 }, // 3485
  { PseudoVLE64FF_V_M1_MASK, VLE64FF_V, 0x0 }, // 3486
  { PseudoVLE64FF_V_M1_TU, VLE64FF_V, 0x0 }, // 3487
  { PseudoVLE64FF_V_M2, VLE64FF_V, 0x1 }, // 3488
  { PseudoVLE64FF_V_M2_MASK, VLE64FF_V, 0x1 }, // 3489
  { PseudoVLE64FF_V_M2_TU, VLE64FF_V, 0x1 }, // 3490
  { PseudoVLE64FF_V_M4, VLE64FF_V, 0x2 }, // 3491
  { PseudoVLE64FF_V_M4_MASK, VLE64FF_V, 0x2 }, // 3492
  { PseudoVLE64FF_V_M4_TU, VLE64FF_V, 0x2 }, // 3493
  { PseudoVLE64FF_V_M8, VLE64FF_V, 0x3 }, // 3494
  { PseudoVLE64FF_V_M8_MASK, VLE64FF_V, 0x3 }, // 3495
  { PseudoVLE64FF_V_M8_TU, VLE64FF_V, 0x3 }, // 3496
  { PseudoVLE64_V_M1, VLE64_V, 0x0 }, // 3497
  { PseudoVLE64_V_M1_MASK, VLE64_V, 0x0 }, // 3498
  { PseudoVLE64_V_M1_TU, VLE64_V, 0x0 }, // 3499
  { PseudoVLE64_V_M2, VLE64_V, 0x1 }, // 3500
  { PseudoVLE64_V_M2_MASK, VLE64_V, 0x1 }, // 3501
  { PseudoVLE64_V_M2_TU, VLE64_V, 0x1 }, // 3502
  { PseudoVLE64_V_M4, VLE64_V, 0x2 }, // 3503
  { PseudoVLE64_V_M4_MASK, VLE64_V, 0x2 }, // 3504
  { PseudoVLE64_V_M4_TU, VLE64_V, 0x2 }, // 3505
  { PseudoVLE64_V_M8, VLE64_V, 0x3 }, // 3506
  { PseudoVLE64_V_M8_MASK, VLE64_V, 0x3 }, // 3507
  { PseudoVLE64_V_M8_TU, VLE64_V, 0x3 }, // 3508
  { PseudoVLE8FF_V_M1, VLE8FF_V, 0x0 }, // 3509
  { PseudoVLE8FF_V_M1_MASK, VLE8FF_V, 0x0 }, // 3510
  { PseudoVLE8FF_V_M1_TU, VLE8FF_V, 0x0 }, // 3511
  { PseudoVLE8FF_V_M2, VLE8FF_V, 0x1 }, // 3512
  { PseudoVLE8FF_V_M2_MASK, VLE8FF_V, 0x1 }, // 3513
  { PseudoVLE8FF_V_M2_TU, VLE8FF_V, 0x1 }, // 3514
  { PseudoVLE8FF_V_M4, VLE8FF_V, 0x2 }, // 3515
  { PseudoVLE8FF_V_M4_MASK, VLE8FF_V, 0x2 }, // 3516
  { PseudoVLE8FF_V_M4_TU, VLE8FF_V, 0x2 }, // 3517
  { PseudoVLE8FF_V_M8, VLE8FF_V, 0x3 }, // 3518
  { PseudoVLE8FF_V_M8_MASK, VLE8FF_V, 0x3 }, // 3519
  { PseudoVLE8FF_V_M8_TU, VLE8FF_V, 0x3 }, // 3520
  { PseudoVLE8FF_V_MF8, VLE8FF_V, 0x5 }, // 3521
  { PseudoVLE8FF_V_MF8_MASK, VLE8FF_V, 0x5 }, // 3522
  { PseudoVLE8FF_V_MF8_TU, VLE8FF_V, 0x5 }, // 3523
  { PseudoVLE8FF_V_MF4, VLE8FF_V, 0x6 }, // 3524
  { PseudoVLE8FF_V_MF4_MASK, VLE8FF_V, 0x6 }, // 3525
  { PseudoVLE8FF_V_MF4_TU, VLE8FF_V, 0x6 }, // 3526
  { PseudoVLE8FF_V_MF2, VLE8FF_V, 0x7 }, // 3527
  { PseudoVLE8FF_V_MF2_MASK, VLE8FF_V, 0x7 }, // 3528
  { PseudoVLE8FF_V_MF2_TU, VLE8FF_V, 0x7 }, // 3529
  { PseudoVLE8_V_M1, VLE8_V, 0x0 }, // 3530
  { PseudoVLE8_V_M1_MASK, VLE8_V, 0x0 }, // 3531
  { PseudoVLE8_V_M1_TU, VLE8_V, 0x0 }, // 3532
  { PseudoVLE8_V_M2, VLE8_V, 0x1 }, // 3533
  { PseudoVLE8_V_M2_MASK, VLE8_V, 0x1 }, // 3534
  { PseudoVLE8_V_M2_TU, VLE8_V, 0x1 }, // 3535
  { PseudoVLE8_V_M4, VLE8_V, 0x2 }, // 3536
  { PseudoVLE8_V_M4_MASK, VLE8_V, 0x2 }, // 3537
  { PseudoVLE8_V_M4_TU, VLE8_V, 0x2 }, // 3538
  { PseudoVLE8_V_M8, VLE8_V, 0x3 }, // 3539
  { PseudoVLE8_V_M8_MASK, VLE8_V, 0x3 }, // 3540
  { PseudoVLE8_V_M8_TU, VLE8_V, 0x3 }, // 3541
  { PseudoVLE8_V_MF8, VLE8_V, 0x5 }, // 3542
  { PseudoVLE8_V_MF8_MASK, VLE8_V, 0x5 }, // 3543
  { PseudoVLE8_V_MF8_TU, VLE8_V, 0x5 }, // 3544
  { PseudoVLE8_V_MF4, VLE8_V, 0x6 }, // 3545
  { PseudoVLE8_V_MF4_MASK, VLE8_V, 0x6 }, // 3546
  { PseudoVLE8_V_MF4_TU, VLE8_V, 0x6 }, // 3547
  { PseudoVLE8_V_MF2, VLE8_V, 0x7 }, // 3548
  { PseudoVLE8_V_MF2_MASK, VLE8_V, 0x7 }, // 3549
  { PseudoVLE8_V_MF2_TU, VLE8_V, 0x7 }, // 3550
  { PseudoVLM_V_B8, VLM_V, 0x0 }, // 3551
  { PseudoVLM_V_B16, VLM_V, 0x1 }, // 3552
  { PseudoVLM_V_B32, VLM_V, 0x2 }, // 3553
  { PseudoVLM_V_B64, VLM_V, 0x3 }, // 3554
  { PseudoVLM_V_B1, VLM_V, 0x5 }, // 3555
  { PseudoVLM_V_B2, VLM_V, 0x6 }, // 3556
  { PseudoVLM_V_B4, VLM_V, 0x7 }, // 3557
  { PseudoVLOXEI16_V_M1_M1, VLOXEI16_V, 0x0 }, // 3558
  { PseudoVLOXEI16_V_M1_M1_MASK, VLOXEI16_V, 0x0 }, // 3559
  { PseudoVLOXEI16_V_M1_M1_TU, VLOXEI16_V, 0x0 }, // 3560
  { PseudoVLOXEI16_V_M2_M1, VLOXEI16_V, 0x0 }, // 3561
  { PseudoVLOXEI16_V_M2_M1_MASK, VLOXEI16_V, 0x0 }, // 3562
  { PseudoVLOXEI16_V_M2_M1_TU, VLOXEI16_V, 0x0 }, // 3563
  { PseudoVLOXEI16_V_MF2_M1, VLOXEI16_V, 0x0 }, // 3564
  { PseudoVLOXEI16_V_MF2_M1_MASK, VLOXEI16_V, 0x0 }, // 3565
  { PseudoVLOXEI16_V_MF2_M1_TU, VLOXEI16_V, 0x0 }, // 3566
  { PseudoVLOXEI16_V_MF4_M1, VLOXEI16_V, 0x0 }, // 3567
  { PseudoVLOXEI16_V_MF4_M1_MASK, VLOXEI16_V, 0x0 }, // 3568
  { PseudoVLOXEI16_V_MF4_M1_TU, VLOXEI16_V, 0x0 }, // 3569
  { PseudoVLOXEI16_V_M1_M2, VLOXEI16_V, 0x1 }, // 3570
  { PseudoVLOXEI16_V_M1_M2_MASK, VLOXEI16_V, 0x1 }, // 3571
  { PseudoVLOXEI16_V_M1_M2_TU, VLOXEI16_V, 0x1 }, // 3572
  { PseudoVLOXEI16_V_M2_M2, VLOXEI16_V, 0x1 }, // 3573
  { PseudoVLOXEI16_V_M2_M2_MASK, VLOXEI16_V, 0x1 }, // 3574
  { PseudoVLOXEI16_V_M2_M2_TU, VLOXEI16_V, 0x1 }, // 3575
  { PseudoVLOXEI16_V_M4_M2, VLOXEI16_V, 0x1 }, // 3576
  { PseudoVLOXEI16_V_M4_M2_MASK, VLOXEI16_V, 0x1 }, // 3577
  { PseudoVLOXEI16_V_M4_M2_TU, VLOXEI16_V, 0x1 }, // 3578
  { PseudoVLOXEI16_V_MF2_M2, VLOXEI16_V, 0x1 }, // 3579
  { PseudoVLOXEI16_V_MF2_M2_MASK, VLOXEI16_V, 0x1 }, // 3580
  { PseudoVLOXEI16_V_MF2_M2_TU, VLOXEI16_V, 0x1 }, // 3581
  { PseudoVLOXEI16_V_M1_M4, VLOXEI16_V, 0x2 }, // 3582
  { PseudoVLOXEI16_V_M1_M4_MASK, VLOXEI16_V, 0x2 }, // 3583
  { PseudoVLOXEI16_V_M1_M4_TU, VLOXEI16_V, 0x2 }, // 3584
  { PseudoVLOXEI16_V_M2_M4, VLOXEI16_V, 0x2 }, // 3585
  { PseudoVLOXEI16_V_M2_M4_MASK, VLOXEI16_V, 0x2 }, // 3586
  { PseudoVLOXEI16_V_M2_M4_TU, VLOXEI16_V, 0x2 }, // 3587
  { PseudoVLOXEI16_V_M4_M4, VLOXEI16_V, 0x2 }, // 3588
  { PseudoVLOXEI16_V_M4_M4_MASK, VLOXEI16_V, 0x2 }, // 3589
  { PseudoVLOXEI16_V_M4_M4_TU, VLOXEI16_V, 0x2 }, // 3590
  { PseudoVLOXEI16_V_M8_M4, VLOXEI16_V, 0x2 }, // 3591
  { PseudoVLOXEI16_V_M8_M4_MASK, VLOXEI16_V, 0x2 }, // 3592
  { PseudoVLOXEI16_V_M8_M4_TU, VLOXEI16_V, 0x2 }, // 3593
  { PseudoVLOXEI16_V_M2_M8, VLOXEI16_V, 0x3 }, // 3594
  { PseudoVLOXEI16_V_M2_M8_MASK, VLOXEI16_V, 0x3 }, // 3595
  { PseudoVLOXEI16_V_M2_M8_TU, VLOXEI16_V, 0x3 }, // 3596
  { PseudoVLOXEI16_V_M4_M8, VLOXEI16_V, 0x3 }, // 3597
  { PseudoVLOXEI16_V_M4_M8_MASK, VLOXEI16_V, 0x3 }, // 3598
  { PseudoVLOXEI16_V_M4_M8_TU, VLOXEI16_V, 0x3 }, // 3599
  { PseudoVLOXEI16_V_M8_M8, VLOXEI16_V, 0x3 }, // 3600
  { PseudoVLOXEI16_V_M8_M8_MASK, VLOXEI16_V, 0x3 }, // 3601
  { PseudoVLOXEI16_V_M8_M8_TU, VLOXEI16_V, 0x3 }, // 3602
  { PseudoVLOXEI16_V_MF4_MF8, VLOXEI16_V, 0x5 }, // 3603
  { PseudoVLOXEI16_V_MF4_MF8_MASK, VLOXEI16_V, 0x5 }, // 3604
  { PseudoVLOXEI16_V_MF4_MF8_TU, VLOXEI16_V, 0x5 }, // 3605
  { PseudoVLOXEI16_V_MF2_MF4, VLOXEI16_V, 0x6 }, // 3606
  { PseudoVLOXEI16_V_MF2_MF4_MASK, VLOXEI16_V, 0x6 }, // 3607
  { PseudoVLOXEI16_V_MF2_MF4_TU, VLOXEI16_V, 0x6 }, // 3608
  { PseudoVLOXEI16_V_MF4_MF4, VLOXEI16_V, 0x6 }, // 3609
  { PseudoVLOXEI16_V_MF4_MF4_MASK, VLOXEI16_V, 0x6 }, // 3610
  { PseudoVLOXEI16_V_MF4_MF4_TU, VLOXEI16_V, 0x6 }, // 3611
  { PseudoVLOXEI16_V_M1_MF2, VLOXEI16_V, 0x7 }, // 3612
  { PseudoVLOXEI16_V_M1_MF2_MASK, VLOXEI16_V, 0x7 }, // 3613
  { PseudoVLOXEI16_V_M1_MF2_TU, VLOXEI16_V, 0x7 }, // 3614
  { PseudoVLOXEI16_V_MF2_MF2, VLOXEI16_V, 0x7 }, // 3615
  { PseudoVLOXEI16_V_MF2_MF2_MASK, VLOXEI16_V, 0x7 }, // 3616
  { PseudoVLOXEI16_V_MF2_MF2_TU, VLOXEI16_V, 0x7 }, // 3617
  { PseudoVLOXEI16_V_MF4_MF2, VLOXEI16_V, 0x7 }, // 3618
  { PseudoVLOXEI16_V_MF4_MF2_MASK, VLOXEI16_V, 0x7 }, // 3619
  { PseudoVLOXEI16_V_MF4_MF2_TU, VLOXEI16_V, 0x7 }, // 3620
  { PseudoVLOXEI32_V_M1_M1, VLOXEI32_V, 0x0 }, // 3621
  { PseudoVLOXEI32_V_M1_M1_MASK, VLOXEI32_V, 0x0 }, // 3622
  { PseudoVLOXEI32_V_M1_M1_TU, VLOXEI32_V, 0x0 }, // 3623
  { PseudoVLOXEI32_V_M2_M1, VLOXEI32_V, 0x0 }, // 3624
  { PseudoVLOXEI32_V_M2_M1_MASK, VLOXEI32_V, 0x0 }, // 3625
  { PseudoVLOXEI32_V_M2_M1_TU, VLOXEI32_V, 0x0 }, // 3626
  { PseudoVLOXEI32_V_M4_M1, VLOXEI32_V, 0x0 }, // 3627
  { PseudoVLOXEI32_V_M4_M1_MASK, VLOXEI32_V, 0x0 }, // 3628
  { PseudoVLOXEI32_V_M4_M1_TU, VLOXEI32_V, 0x0 }, // 3629
  { PseudoVLOXEI32_V_MF2_M1, VLOXEI32_V, 0x0 }, // 3630
  { PseudoVLOXEI32_V_MF2_M1_MASK, VLOXEI32_V, 0x0 }, // 3631
  { PseudoVLOXEI32_V_MF2_M1_TU, VLOXEI32_V, 0x0 }, // 3632
  { PseudoVLOXEI32_V_M1_M2, VLOXEI32_V, 0x1 }, // 3633
  { PseudoVLOXEI32_V_M1_M2_MASK, VLOXEI32_V, 0x1 }, // 3634
  { PseudoVLOXEI32_V_M1_M2_TU, VLOXEI32_V, 0x1 }, // 3635
  { PseudoVLOXEI32_V_M2_M2, VLOXEI32_V, 0x1 }, // 3636
  { PseudoVLOXEI32_V_M2_M2_MASK, VLOXEI32_V, 0x1 }, // 3637
  { PseudoVLOXEI32_V_M2_M2_TU, VLOXEI32_V, 0x1 }, // 3638
  { PseudoVLOXEI32_V_M4_M2, VLOXEI32_V, 0x1 }, // 3639
  { PseudoVLOXEI32_V_M4_M2_MASK, VLOXEI32_V, 0x1 }, // 3640
  { PseudoVLOXEI32_V_M4_M2_TU, VLOXEI32_V, 0x1 }, // 3641
  { PseudoVLOXEI32_V_M8_M2, VLOXEI32_V, 0x1 }, // 3642
  { PseudoVLOXEI32_V_M8_M2_MASK, VLOXEI32_V, 0x1 }, // 3643
  { PseudoVLOXEI32_V_M8_M2_TU, VLOXEI32_V, 0x1 }, // 3644
  { PseudoVLOXEI32_V_M2_M4, VLOXEI32_V, 0x2 }, // 3645
  { PseudoVLOXEI32_V_M2_M4_MASK, VLOXEI32_V, 0x2 }, // 3646
  { PseudoVLOXEI32_V_M2_M4_TU, VLOXEI32_V, 0x2 }, // 3647
  { PseudoVLOXEI32_V_M4_M4, VLOXEI32_V, 0x2 }, // 3648
  { PseudoVLOXEI32_V_M4_M4_MASK, VLOXEI32_V, 0x2 }, // 3649
  { PseudoVLOXEI32_V_M4_M4_TU, VLOXEI32_V, 0x2 }, // 3650
  { PseudoVLOXEI32_V_M8_M4, VLOXEI32_V, 0x2 }, // 3651
  { PseudoVLOXEI32_V_M8_M4_MASK, VLOXEI32_V, 0x2 }, // 3652
  { PseudoVLOXEI32_V_M8_M4_TU, VLOXEI32_V, 0x2 }, // 3653
  { PseudoVLOXEI32_V_M4_M8, VLOXEI32_V, 0x3 }, // 3654
  { PseudoVLOXEI32_V_M4_M8_MASK, VLOXEI32_V, 0x3 }, // 3655
  { PseudoVLOXEI32_V_M4_M8_TU, VLOXEI32_V, 0x3 }, // 3656
  { PseudoVLOXEI32_V_M8_M8, VLOXEI32_V, 0x3 }, // 3657
  { PseudoVLOXEI32_V_M8_M8_MASK, VLOXEI32_V, 0x3 }, // 3658
  { PseudoVLOXEI32_V_M8_M8_TU, VLOXEI32_V, 0x3 }, // 3659
  { PseudoVLOXEI32_V_MF2_MF8, VLOXEI32_V, 0x5 }, // 3660
  { PseudoVLOXEI32_V_MF2_MF8_MASK, VLOXEI32_V, 0x5 }, // 3661
  { PseudoVLOXEI32_V_MF2_MF8_TU, VLOXEI32_V, 0x5 }, // 3662
  { PseudoVLOXEI32_V_M1_MF4, VLOXEI32_V, 0x6 }, // 3663
  { PseudoVLOXEI32_V_M1_MF4_MASK, VLOXEI32_V, 0x6 }, // 3664
  { PseudoVLOXEI32_V_M1_MF4_TU, VLOXEI32_V, 0x6 }, // 3665
  { PseudoVLOXEI32_V_MF2_MF4, VLOXEI32_V, 0x6 }, // 3666
  { PseudoVLOXEI32_V_MF2_MF4_MASK, VLOXEI32_V, 0x6 }, // 3667
  { PseudoVLOXEI32_V_MF2_MF4_TU, VLOXEI32_V, 0x6 }, // 3668
  { PseudoVLOXEI32_V_M1_MF2, VLOXEI32_V, 0x7 }, // 3669
  { PseudoVLOXEI32_V_M1_MF2_MASK, VLOXEI32_V, 0x7 }, // 3670
  { PseudoVLOXEI32_V_M1_MF2_TU, VLOXEI32_V, 0x7 }, // 3671
  { PseudoVLOXEI32_V_M2_MF2, VLOXEI32_V, 0x7 }, // 3672
  { PseudoVLOXEI32_V_M2_MF2_MASK, VLOXEI32_V, 0x7 }, // 3673
  { PseudoVLOXEI32_V_M2_MF2_TU, VLOXEI32_V, 0x7 }, // 3674
  { PseudoVLOXEI32_V_MF2_MF2, VLOXEI32_V, 0x7 }, // 3675
  { PseudoVLOXEI32_V_MF2_MF2_MASK, VLOXEI32_V, 0x7 }, // 3676
  { PseudoVLOXEI32_V_MF2_MF2_TU, VLOXEI32_V, 0x7 }, // 3677
  { PseudoVLOXEI64_V_M1_M1, VLOXEI64_V, 0x0 }, // 3678
  { PseudoVLOXEI64_V_M1_M1_MASK, VLOXEI64_V, 0x0 }, // 3679
  { PseudoVLOXEI64_V_M1_M1_TU, VLOXEI64_V, 0x0 }, // 3680
  { PseudoVLOXEI64_V_M2_M1, VLOXEI64_V, 0x0 }, // 3681
  { PseudoVLOXEI64_V_M2_M1_MASK, VLOXEI64_V, 0x0 }, // 3682
  { PseudoVLOXEI64_V_M2_M1_TU, VLOXEI64_V, 0x0 }, // 3683
  { PseudoVLOXEI64_V_M4_M1, VLOXEI64_V, 0x0 }, // 3684
  { PseudoVLOXEI64_V_M4_M1_MASK, VLOXEI64_V, 0x0 }, // 3685
  { PseudoVLOXEI64_V_M4_M1_TU, VLOXEI64_V, 0x0 }, // 3686
  { PseudoVLOXEI64_V_M8_M1, VLOXEI64_V, 0x0 }, // 3687
  { PseudoVLOXEI64_V_M8_M1_MASK, VLOXEI64_V, 0x0 }, // 3688
  { PseudoVLOXEI64_V_M8_M1_TU, VLOXEI64_V, 0x0 }, // 3689
  { PseudoVLOXEI64_V_M2_M2, VLOXEI64_V, 0x1 }, // 3690
  { PseudoVLOXEI64_V_M2_M2_MASK, VLOXEI64_V, 0x1 }, // 3691
  { PseudoVLOXEI64_V_M2_M2_TU, VLOXEI64_V, 0x1 }, // 3692
  { PseudoVLOXEI64_V_M4_M2, VLOXEI64_V, 0x1 }, // 3693
  { PseudoVLOXEI64_V_M4_M2_MASK, VLOXEI64_V, 0x1 }, // 3694
  { PseudoVLOXEI64_V_M4_M2_TU, VLOXEI64_V, 0x1 }, // 3695
  { PseudoVLOXEI64_V_M8_M2, VLOXEI64_V, 0x1 }, // 3696
  { PseudoVLOXEI64_V_M8_M2_MASK, VLOXEI64_V, 0x1 }, // 3697
  { PseudoVLOXEI64_V_M8_M2_TU, VLOXEI64_V, 0x1 }, // 3698
  { PseudoVLOXEI64_V_M4_M4, VLOXEI64_V, 0x2 }, // 3699
  { PseudoVLOXEI64_V_M4_M4_MASK, VLOXEI64_V, 0x2 }, // 3700
  { PseudoVLOXEI64_V_M4_M4_TU, VLOXEI64_V, 0x2 }, // 3701
  { PseudoVLOXEI64_V_M8_M4, VLOXEI64_V, 0x2 }, // 3702
  { PseudoVLOXEI64_V_M8_M4_MASK, VLOXEI64_V, 0x2 }, // 3703
  { PseudoVLOXEI64_V_M8_M4_TU, VLOXEI64_V, 0x2 }, // 3704
  { PseudoVLOXEI64_V_M8_M8, VLOXEI64_V, 0x3 }, // 3705
  { PseudoVLOXEI64_V_M8_M8_MASK, VLOXEI64_V, 0x3 }, // 3706
  { PseudoVLOXEI64_V_M8_M8_TU, VLOXEI64_V, 0x3 }, // 3707
  { PseudoVLOXEI64_V_M1_MF8, VLOXEI64_V, 0x5 }, // 3708
  { PseudoVLOXEI64_V_M1_MF8_MASK, VLOXEI64_V, 0x5 }, // 3709
  { PseudoVLOXEI64_V_M1_MF8_TU, VLOXEI64_V, 0x5 }, // 3710
  { PseudoVLOXEI64_V_M1_MF4, VLOXEI64_V, 0x6 }, // 3711
  { PseudoVLOXEI64_V_M1_MF4_MASK, VLOXEI64_V, 0x6 }, // 3712
  { PseudoVLOXEI64_V_M1_MF4_TU, VLOXEI64_V, 0x6 }, // 3713
  { PseudoVLOXEI64_V_M2_MF4, VLOXEI64_V, 0x6 }, // 3714
  { PseudoVLOXEI64_V_M2_MF4_MASK, VLOXEI64_V, 0x6 }, // 3715
  { PseudoVLOXEI64_V_M2_MF4_TU, VLOXEI64_V, 0x6 }, // 3716
  { PseudoVLOXEI64_V_M1_MF2, VLOXEI64_V, 0x7 }, // 3717
  { PseudoVLOXEI64_V_M1_MF2_MASK, VLOXEI64_V, 0x7 }, // 3718
  { PseudoVLOXEI64_V_M1_MF2_TU, VLOXEI64_V, 0x7 }, // 3719
  { PseudoVLOXEI64_V_M2_MF2, VLOXEI64_V, 0x7 }, // 3720
  { PseudoVLOXEI64_V_M2_MF2_MASK, VLOXEI64_V, 0x7 }, // 3721
  { PseudoVLOXEI64_V_M2_MF2_TU, VLOXEI64_V, 0x7 }, // 3722
  { PseudoVLOXEI64_V_M4_MF2, VLOXEI64_V, 0x7 }, // 3723
  { PseudoVLOXEI64_V_M4_MF2_MASK, VLOXEI64_V, 0x7 }, // 3724
  { PseudoVLOXEI64_V_M4_MF2_TU, VLOXEI64_V, 0x7 }, // 3725
  { PseudoVLOXEI8_V_M1_M1, VLOXEI8_V, 0x0 }, // 3726
  { PseudoVLOXEI8_V_M1_M1_MASK, VLOXEI8_V, 0x0 }, // 3727
  { PseudoVLOXEI8_V_M1_M1_TU, VLOXEI8_V, 0x0 }, // 3728
  { PseudoVLOXEI8_V_MF2_M1, VLOXEI8_V, 0x0 }, // 3729
  { PseudoVLOXEI8_V_MF2_M1_MASK, VLOXEI8_V, 0x0 }, // 3730
  { PseudoVLOXEI8_V_MF2_M1_TU, VLOXEI8_V, 0x0 }, // 3731
  { PseudoVLOXEI8_V_MF4_M1, VLOXEI8_V, 0x0 }, // 3732
  { PseudoVLOXEI8_V_MF4_M1_MASK, VLOXEI8_V, 0x0 }, // 3733
  { PseudoVLOXEI8_V_MF4_M1_TU, VLOXEI8_V, 0x0 }, // 3734
  { PseudoVLOXEI8_V_MF8_M1, VLOXEI8_V, 0x0 }, // 3735
  { PseudoVLOXEI8_V_MF8_M1_MASK, VLOXEI8_V, 0x0 }, // 3736
  { PseudoVLOXEI8_V_MF8_M1_TU, VLOXEI8_V, 0x0 }, // 3737
  { PseudoVLOXEI8_V_M1_M2, VLOXEI8_V, 0x1 }, // 3738
  { PseudoVLOXEI8_V_M1_M2_MASK, VLOXEI8_V, 0x1 }, // 3739
  { PseudoVLOXEI8_V_M1_M2_TU, VLOXEI8_V, 0x1 }, // 3740
  { PseudoVLOXEI8_V_M2_M2, VLOXEI8_V, 0x1 }, // 3741
  { PseudoVLOXEI8_V_M2_M2_MASK, VLOXEI8_V, 0x1 }, // 3742
  { PseudoVLOXEI8_V_M2_M2_TU, VLOXEI8_V, 0x1 }, // 3743
  { PseudoVLOXEI8_V_MF2_M2, VLOXEI8_V, 0x1 }, // 3744
  { PseudoVLOXEI8_V_MF2_M2_MASK, VLOXEI8_V, 0x1 }, // 3745
  { PseudoVLOXEI8_V_MF2_M2_TU, VLOXEI8_V, 0x1 }, // 3746
  { PseudoVLOXEI8_V_MF4_M2, VLOXEI8_V, 0x1 }, // 3747
  { PseudoVLOXEI8_V_MF4_M2_MASK, VLOXEI8_V, 0x1 }, // 3748
  { PseudoVLOXEI8_V_MF4_M2_TU, VLOXEI8_V, 0x1 }, // 3749
  { PseudoVLOXEI8_V_M1_M4, VLOXEI8_V, 0x2 }, // 3750
  { PseudoVLOXEI8_V_M1_M4_MASK, VLOXEI8_V, 0x2 }, // 3751
  { PseudoVLOXEI8_V_M1_M4_TU, VLOXEI8_V, 0x2 }, // 3752
  { PseudoVLOXEI8_V_M2_M4, VLOXEI8_V, 0x2 }, // 3753
  { PseudoVLOXEI8_V_M2_M4_MASK, VLOXEI8_V, 0x2 }, // 3754
  { PseudoVLOXEI8_V_M2_M4_TU, VLOXEI8_V, 0x2 }, // 3755
  { PseudoVLOXEI8_V_M4_M4, VLOXEI8_V, 0x2 }, // 3756
  { PseudoVLOXEI8_V_M4_M4_MASK, VLOXEI8_V, 0x2 }, // 3757
  { PseudoVLOXEI8_V_M4_M4_TU, VLOXEI8_V, 0x2 }, // 3758
  { PseudoVLOXEI8_V_MF2_M4, VLOXEI8_V, 0x2 }, // 3759
  { PseudoVLOXEI8_V_MF2_M4_MASK, VLOXEI8_V, 0x2 }, // 3760
  { PseudoVLOXEI8_V_MF2_M4_TU, VLOXEI8_V, 0x2 }, // 3761
  { PseudoVLOXEI8_V_M1_M8, VLOXEI8_V, 0x3 }, // 3762
  { PseudoVLOXEI8_V_M1_M8_MASK, VLOXEI8_V, 0x3 }, // 3763
  { PseudoVLOXEI8_V_M1_M8_TU, VLOXEI8_V, 0x3 }, // 3764
  { PseudoVLOXEI8_V_M2_M8, VLOXEI8_V, 0x3 }, // 3765
  { PseudoVLOXEI8_V_M2_M8_MASK, VLOXEI8_V, 0x3 }, // 3766
  { PseudoVLOXEI8_V_M2_M8_TU, VLOXEI8_V, 0x3 }, // 3767
  { PseudoVLOXEI8_V_M4_M8, VLOXEI8_V, 0x3 }, // 3768
  { PseudoVLOXEI8_V_M4_M8_MASK, VLOXEI8_V, 0x3 }, // 3769
  { PseudoVLOXEI8_V_M4_M8_TU, VLOXEI8_V, 0x3 }, // 3770
  { PseudoVLOXEI8_V_M8_M8, VLOXEI8_V, 0x3 }, // 3771
  { PseudoVLOXEI8_V_M8_M8_MASK, VLOXEI8_V, 0x3 }, // 3772
  { PseudoVLOXEI8_V_M8_M8_TU, VLOXEI8_V, 0x3 }, // 3773
  { PseudoVLOXEI8_V_MF8_MF8, VLOXEI8_V, 0x5 }, // 3774
  { PseudoVLOXEI8_V_MF8_MF8_MASK, VLOXEI8_V, 0x5 }, // 3775
  { PseudoVLOXEI8_V_MF8_MF8_TU, VLOXEI8_V, 0x5 }, // 3776
  { PseudoVLOXEI8_V_MF4_MF4, VLOXEI8_V, 0x6 }, // 3777
  { PseudoVLOXEI8_V_MF4_MF4_MASK, VLOXEI8_V, 0x6 }, // 3778
  { PseudoVLOXEI8_V_MF4_MF4_TU, VLOXEI8_V, 0x6 }, // 3779
  { PseudoVLOXEI8_V_MF8_MF4, VLOXEI8_V, 0x6 }, // 3780
  { PseudoVLOXEI8_V_MF8_MF4_MASK, VLOXEI8_V, 0x6 }, // 3781
  { PseudoVLOXEI8_V_MF8_MF4_TU, VLOXEI8_V, 0x6 }, // 3782
  { PseudoVLOXEI8_V_MF2_MF2, VLOXEI8_V, 0x7 }, // 3783
  { PseudoVLOXEI8_V_MF2_MF2_MASK, VLOXEI8_V, 0x7 }, // 3784
  { PseudoVLOXEI8_V_MF2_MF2_TU, VLOXEI8_V, 0x7 }, // 3785
  { PseudoVLOXEI8_V_MF4_MF2, VLOXEI8_V, 0x7 }, // 3786
  { PseudoVLOXEI8_V_MF4_MF2_MASK, VLOXEI8_V, 0x7 }, // 3787
  { PseudoVLOXEI8_V_MF4_MF2_TU, VLOXEI8_V, 0x7 }, // 3788
  { PseudoVLOXEI8_V_MF8_MF2, VLOXEI8_V, 0x7 }, // 3789
  { PseudoVLOXEI8_V_MF8_MF2_MASK, VLOXEI8_V, 0x7 }, // 3790
  { PseudoVLOXEI8_V_MF8_MF2_TU, VLOXEI8_V, 0x7 }, // 3791
  { PseudoVLOXSEG2EI16_V_M1_M1, VLOXSEG2EI16_V, 0x0 }, // 3792
  { PseudoVLOXSEG2EI16_V_M1_M1_MASK, VLOXSEG2EI16_V, 0x0 }, // 3793
  { PseudoVLOXSEG2EI16_V_M1_M1_TU, VLOXSEG2EI16_V, 0x0 }, // 3794
  { PseudoVLOXSEG2EI16_V_M2_M1, VLOXSEG2EI16_V, 0x0 }, // 3795
  { PseudoVLOXSEG2EI16_V_M2_M1_MASK, VLOXSEG2EI16_V, 0x0 }, // 3796
  { PseudoVLOXSEG2EI16_V_M2_M1_TU, VLOXSEG2EI16_V, 0x0 }, // 3797
  { PseudoVLOXSEG2EI16_V_MF2_M1, VLOXSEG2EI16_V, 0x0 }, // 3798
  { PseudoVLOXSEG2EI16_V_MF2_M1_MASK, VLOXSEG2EI16_V, 0x0 }, // 3799
  { PseudoVLOXSEG2EI16_V_MF2_M1_TU, VLOXSEG2EI16_V, 0x0 }, // 3800
  { PseudoVLOXSEG2EI16_V_MF4_M1, VLOXSEG2EI16_V, 0x0 }, // 3801
  { PseudoVLOXSEG2EI16_V_MF4_M1_MASK, VLOXSEG2EI16_V, 0x0 }, // 3802
  { PseudoVLOXSEG2EI16_V_MF4_M1_TU, VLOXSEG2EI16_V, 0x0 }, // 3803
  { PseudoVLOXSEG2EI16_V_M1_M2, VLOXSEG2EI16_V, 0x1 }, // 3804
  { PseudoVLOXSEG2EI16_V_M1_M2_MASK, VLOXSEG2EI16_V, 0x1 }, // 3805
  { PseudoVLOXSEG2EI16_V_M1_M2_TU, VLOXSEG2EI16_V, 0x1 }, // 3806
  { PseudoVLOXSEG2EI16_V_M2_M2, VLOXSEG2EI16_V, 0x1 }, // 3807
  { PseudoVLOXSEG2EI16_V_M2_M2_MASK, VLOXSEG2EI16_V, 0x1 }, // 3808
  { PseudoVLOXSEG2EI16_V_M2_M2_TU, VLOXSEG2EI16_V, 0x1 }, // 3809
  { PseudoVLOXSEG2EI16_V_M4_M2, VLOXSEG2EI16_V, 0x1 }, // 3810
  { PseudoVLOXSEG2EI16_V_M4_M2_MASK, VLOXSEG2EI16_V, 0x1 }, // 3811
  { PseudoVLOXSEG2EI16_V_M4_M2_TU, VLOXSEG2EI16_V, 0x1 }, // 3812
  { PseudoVLOXSEG2EI16_V_MF2_M2, VLOXSEG2EI16_V, 0x1 }, // 3813
  { PseudoVLOXSEG2EI16_V_MF2_M2_MASK, VLOXSEG2EI16_V, 0x1 }, // 3814
  { PseudoVLOXSEG2EI16_V_MF2_M2_TU, VLOXSEG2EI16_V, 0x1 }, // 3815
  { PseudoVLOXSEG2EI16_V_M1_M4, VLOXSEG2EI16_V, 0x2 }, // 3816
  { PseudoVLOXSEG2EI16_V_M1_M4_MASK, VLOXSEG2EI16_V, 0x2 }, // 3817
  { PseudoVLOXSEG2EI16_V_M1_M4_TU, VLOXSEG2EI16_V, 0x2 }, // 3818
  { PseudoVLOXSEG2EI16_V_M2_M4, VLOXSEG2EI16_V, 0x2 }, // 3819
  { PseudoVLOXSEG2EI16_V_M2_M4_MASK, VLOXSEG2EI16_V, 0x2 }, // 3820
  { PseudoVLOXSEG2EI16_V_M2_M4_TU, VLOXSEG2EI16_V, 0x2 }, // 3821
  { PseudoVLOXSEG2EI16_V_M4_M4, VLOXSEG2EI16_V, 0x2 }, // 3822
  { PseudoVLOXSEG2EI16_V_M4_M4_MASK, VLOXSEG2EI16_V, 0x2 }, // 3823
  { PseudoVLOXSEG2EI16_V_M4_M4_TU, VLOXSEG2EI16_V, 0x2 }, // 3824
  { PseudoVLOXSEG2EI16_V_M8_M4, VLOXSEG2EI16_V, 0x2 }, // 3825
  { PseudoVLOXSEG2EI16_V_M8_M4_MASK, VLOXSEG2EI16_V, 0x2 }, // 3826
  { PseudoVLOXSEG2EI16_V_M8_M4_TU, VLOXSEG2EI16_V, 0x2 }, // 3827
  { PseudoVLOXSEG2EI16_V_MF4_MF8, VLOXSEG2EI16_V, 0x5 }, // 3828
  { PseudoVLOXSEG2EI16_V_MF4_MF8_MASK, VLOXSEG2EI16_V, 0x5 }, // 3829
  { PseudoVLOXSEG2EI16_V_MF4_MF8_TU, VLOXSEG2EI16_V, 0x5 }, // 3830
  { PseudoVLOXSEG2EI16_V_MF2_MF4, VLOXSEG2EI16_V, 0x6 }, // 3831
  { PseudoVLOXSEG2EI16_V_MF2_MF4_MASK, VLOXSEG2EI16_V, 0x6 }, // 3832
  { PseudoVLOXSEG2EI16_V_MF2_MF4_TU, VLOXSEG2EI16_V, 0x6 }, // 3833
  { PseudoVLOXSEG2EI16_V_MF4_MF4, VLOXSEG2EI16_V, 0x6 }, // 3834
  { PseudoVLOXSEG2EI16_V_MF4_MF4_MASK, VLOXSEG2EI16_V, 0x6 }, // 3835
  { PseudoVLOXSEG2EI16_V_MF4_MF4_TU, VLOXSEG2EI16_V, 0x6 }, // 3836
  { PseudoVLOXSEG2EI16_V_M1_MF2, VLOXSEG2EI16_V, 0x7 }, // 3837
  { PseudoVLOXSEG2EI16_V_M1_MF2_MASK, VLOXSEG2EI16_V, 0x7 }, // 3838
  { PseudoVLOXSEG2EI16_V_M1_MF2_TU, VLOXSEG2EI16_V, 0x7 }, // 3839
  { PseudoVLOXSEG2EI16_V_MF2_MF2, VLOXSEG2EI16_V, 0x7 }, // 3840
  { PseudoVLOXSEG2EI16_V_MF2_MF2_MASK, VLOXSEG2EI16_V, 0x7 }, // 3841
  { PseudoVLOXSEG2EI16_V_MF2_MF2_TU, VLOXSEG2EI16_V, 0x7 }, // 3842
  { PseudoVLOXSEG2EI16_V_MF4_MF2, VLOXSEG2EI16_V, 0x7 }, // 3843
  { PseudoVLOXSEG2EI16_V_MF4_MF2_MASK, VLOXSEG2EI16_V, 0x7 }, // 3844
  { PseudoVLOXSEG2EI16_V_MF4_MF2_TU, VLOXSEG2EI16_V, 0x7 }, // 3845
  { PseudoVLOXSEG2EI32_V_M1_M1, VLOXSEG2EI32_V, 0x0 }, // 3846
  { PseudoVLOXSEG2EI32_V_M1_M1_MASK, VLOXSEG2EI32_V, 0x0 }, // 3847
  { PseudoVLOXSEG2EI32_V_M1_M1_TU, VLOXSEG2EI32_V, 0x0 }, // 3848
  { PseudoVLOXSEG2EI32_V_M2_M1, VLOXSEG2EI32_V, 0x0 }, // 3849
  { PseudoVLOXSEG2EI32_V_M2_M1_MASK, VLOXSEG2EI32_V, 0x0 }, // 3850
  { PseudoVLOXSEG2EI32_V_M2_M1_TU, VLOXSEG2EI32_V, 0x0 }, // 3851
  { PseudoVLOXSEG2EI32_V_M4_M1, VLOXSEG2EI32_V, 0x0 }, // 3852
  { PseudoVLOXSEG2EI32_V_M4_M1_MASK, VLOXSEG2EI32_V, 0x0 }, // 3853
  { PseudoVLOXSEG2EI32_V_M4_M1_TU, VLOXSEG2EI32_V, 0x0 }, // 3854
  { PseudoVLOXSEG2EI32_V_MF2_M1, VLOXSEG2EI32_V, 0x0 }, // 3855
  { PseudoVLOXSEG2EI32_V_MF2_M1_MASK, VLOXSEG2EI32_V, 0x0 }, // 3856
  { PseudoVLOXSEG2EI32_V_MF2_M1_TU, VLOXSEG2EI32_V, 0x0 }, // 3857
  { PseudoVLOXSEG2EI32_V_M1_M2, VLOXSEG2EI32_V, 0x1 }, // 3858
  { PseudoVLOXSEG2EI32_V_M1_M2_MASK, VLOXSEG2EI32_V, 0x1 }, // 3859
  { PseudoVLOXSEG2EI32_V_M1_M2_TU, VLOXSEG2EI32_V, 0x1 }, // 3860
  { PseudoVLOXSEG2EI32_V_M2_M2, VLOXSEG2EI32_V, 0x1 }, // 3861
  { PseudoVLOXSEG2EI32_V_M2_M2_MASK, VLOXSEG2EI32_V, 0x1 }, // 3862
  { PseudoVLOXSEG2EI32_V_M2_M2_TU, VLOXSEG2EI32_V, 0x1 }, // 3863
  { PseudoVLOXSEG2EI32_V_M4_M2, VLOXSEG2EI32_V, 0x1 }, // 3864
  { PseudoVLOXSEG2EI32_V_M4_M2_MASK, VLOXSEG2EI32_V, 0x1 }, // 3865
  { PseudoVLOXSEG2EI32_V_M4_M2_TU, VLOXSEG2EI32_V, 0x1 }, // 3866
  { PseudoVLOXSEG2EI32_V_M8_M2, VLOXSEG2EI32_V, 0x1 }, // 3867
  { PseudoVLOXSEG2EI32_V_M8_M2_MASK, VLOXSEG2EI32_V, 0x1 }, // 3868
  { PseudoVLOXSEG2EI32_V_M8_M2_TU, VLOXSEG2EI32_V, 0x1 }, // 3869
  { PseudoVLOXSEG2EI32_V_M2_M4, VLOXSEG2EI32_V, 0x2 }, // 3870
  { PseudoVLOXSEG2EI32_V_M2_M4_MASK, VLOXSEG2EI32_V, 0x2 }, // 3871
  { PseudoVLOXSEG2EI32_V_M2_M4_TU, VLOXSEG2EI32_V, 0x2 }, // 3872
  { PseudoVLOXSEG2EI32_V_M4_M4, VLOXSEG2EI32_V, 0x2 }, // 3873
  { PseudoVLOXSEG2EI32_V_M4_M4_MASK, VLOXSEG2EI32_V, 0x2 }, // 3874
  { PseudoVLOXSEG2EI32_V_M4_M4_TU, VLOXSEG2EI32_V, 0x2 }, // 3875
  { PseudoVLOXSEG2EI32_V_M8_M4, VLOXSEG2EI32_V, 0x2 }, // 3876
  { PseudoVLOXSEG2EI32_V_M8_M4_MASK, VLOXSEG2EI32_V, 0x2 }, // 3877
  { PseudoVLOXSEG2EI32_V_M8_M4_TU, VLOXSEG2EI32_V, 0x2 }, // 3878
  { PseudoVLOXSEG2EI32_V_MF2_MF8, VLOXSEG2EI32_V, 0x5 }, // 3879
  { PseudoVLOXSEG2EI32_V_MF2_MF8_MASK, VLOXSEG2EI32_V, 0x5 }, // 3880
  { PseudoVLOXSEG2EI32_V_MF2_MF8_TU, VLOXSEG2EI32_V, 0x5 }, // 3881
  { PseudoVLOXSEG2EI32_V_M1_MF4, VLOXSEG2EI32_V, 0x6 }, // 3882
  { PseudoVLOXSEG2EI32_V_M1_MF4_MASK, VLOXSEG2EI32_V, 0x6 }, // 3883
  { PseudoVLOXSEG2EI32_V_M1_MF4_TU, VLOXSEG2EI32_V, 0x6 }, // 3884
  { PseudoVLOXSEG2EI32_V_MF2_MF4, VLOXSEG2EI32_V, 0x6 }, // 3885
  { PseudoVLOXSEG2EI32_V_MF2_MF4_MASK, VLOXSEG2EI32_V, 0x6 }, // 3886
  { PseudoVLOXSEG2EI32_V_MF2_MF4_TU, VLOXSEG2EI32_V, 0x6 }, // 3887
  { PseudoVLOXSEG2EI32_V_M1_MF2, VLOXSEG2EI32_V, 0x7 }, // 3888
  { PseudoVLOXSEG2EI32_V_M1_MF2_MASK, VLOXSEG2EI32_V, 0x7 }, // 3889
  { PseudoVLOXSEG2EI32_V_M1_MF2_TU, VLOXSEG2EI32_V, 0x7 }, // 3890
  { PseudoVLOXSEG2EI32_V_M2_MF2, VLOXSEG2EI32_V, 0x7 }, // 3891
  { PseudoVLOXSEG2EI32_V_M2_MF2_MASK, VLOXSEG2EI32_V, 0x7 }, // 3892
  { PseudoVLOXSEG2EI32_V_M2_MF2_TU, VLOXSEG2EI32_V, 0x7 }, // 3893
  { PseudoVLOXSEG2EI32_V_MF2_MF2, VLOXSEG2EI32_V, 0x7 }, // 3894
  { PseudoVLOXSEG2EI32_V_MF2_MF2_MASK, VLOXSEG2EI32_V, 0x7 }, // 3895
  { PseudoVLOXSEG2EI32_V_MF2_MF2_TU, VLOXSEG2EI32_V, 0x7 }, // 3896
  { PseudoVLOXSEG2EI64_V_M1_M1, VLOXSEG2EI64_V, 0x0 }, // 3897
  { PseudoVLOXSEG2EI64_V_M1_M1_MASK, VLOXSEG2EI64_V, 0x0 }, // 3898
  { PseudoVLOXSEG2EI64_V_M1_M1_TU, VLOXSEG2EI64_V, 0x0 }, // 3899
  { PseudoVLOXSEG2EI64_V_M2_M1, VLOXSEG2EI64_V, 0x0 }, // 3900
  { PseudoVLOXSEG2EI64_V_M2_M1_MASK, VLOXSEG2EI64_V, 0x0 }, // 3901
  { PseudoVLOXSEG2EI64_V_M2_M1_TU, VLOXSEG2EI64_V, 0x0 }, // 3902
  { PseudoVLOXSEG2EI64_V_M4_M1, VLOXSEG2EI64_V, 0x0 }, // 3903
  { PseudoVLOXSEG2EI64_V_M4_M1_MASK, VLOXSEG2EI64_V, 0x0 }, // 3904
  { PseudoVLOXSEG2EI64_V_M4_M1_TU, VLOXSEG2EI64_V, 0x0 }, // 3905
  { PseudoVLOXSEG2EI64_V_M8_M1, VLOXSEG2EI64_V, 0x0 }, // 3906
  { PseudoVLOXSEG2EI64_V_M8_M1_MASK, VLOXSEG2EI64_V, 0x0 }, // 3907
  { PseudoVLOXSEG2EI64_V_M8_M1_TU, VLOXSEG2EI64_V, 0x0 }, // 3908
  { PseudoVLOXSEG2EI64_V_M2_M2, VLOXSEG2EI64_V, 0x1 }, // 3909
  { PseudoVLOXSEG2EI64_V_M2_M2_MASK, VLOXSEG2EI64_V, 0x1 }, // 3910
  { PseudoVLOXSEG2EI64_V_M2_M2_TU, VLOXSEG2EI64_V, 0x1 }, // 3911
  { PseudoVLOXSEG2EI64_V_M4_M2, VLOXSEG2EI64_V, 0x1 }, // 3912
  { PseudoVLOXSEG2EI64_V_M4_M2_MASK, VLOXSEG2EI64_V, 0x1 }, // 3913
  { PseudoVLOXSEG2EI64_V_M4_M2_TU, VLOXSEG2EI64_V, 0x1 }, // 3914
  { PseudoVLOXSEG2EI64_V_M8_M2, VLOXSEG2EI64_V, 0x1 }, // 3915
  { PseudoVLOXSEG2EI64_V_M8_M2_MASK, VLOXSEG2EI64_V, 0x1 }, // 3916
  { PseudoVLOXSEG2EI64_V_M8_M2_TU, VLOXSEG2EI64_V, 0x1 }, // 3917
  { PseudoVLOXSEG2EI64_V_M4_M4, VLOXSEG2EI64_V, 0x2 }, // 3918
  { PseudoVLOXSEG2EI64_V_M4_M4_MASK, VLOXSEG2EI64_V, 0x2 }, // 3919
  { PseudoVLOXSEG2EI64_V_M4_M4_TU, VLOXSEG2EI64_V, 0x2 }, // 3920
  { PseudoVLOXSEG2EI64_V_M8_M4, VLOXSEG2EI64_V, 0x2 }, // 3921
  { PseudoVLOXSEG2EI64_V_M8_M4_MASK, VLOXSEG2EI64_V, 0x2 }, // 3922
  { PseudoVLOXSEG2EI64_V_M8_M4_TU, VLOXSEG2EI64_V, 0x2 }, // 3923
  { PseudoVLOXSEG2EI64_V_M1_MF8, VLOXSEG2EI64_V, 0x5 }, // 3924
  { PseudoVLOXSEG2EI64_V_M1_MF8_MASK, VLOXSEG2EI64_V, 0x5 }, // 3925
  { PseudoVLOXSEG2EI64_V_M1_MF8_TU, VLOXSEG2EI64_V, 0x5 }, // 3926
  { PseudoVLOXSEG2EI64_V_M1_MF4, VLOXSEG2EI64_V, 0x6 }, // 3927
  { PseudoVLOXSEG2EI64_V_M1_MF4_MASK, VLOXSEG2EI64_V, 0x6 }, // 3928
  { PseudoVLOXSEG2EI64_V_M1_MF4_TU, VLOXSEG2EI64_V, 0x6 }, // 3929
  { PseudoVLOXSEG2EI64_V_M2_MF4, VLOXSEG2EI64_V, 0x6 }, // 3930
  { PseudoVLOXSEG2EI64_V_M2_MF4_MASK, VLOXSEG2EI64_V, 0x6 }, // 3931
  { PseudoVLOXSEG2EI64_V_M2_MF4_TU, VLOXSEG2EI64_V, 0x6 }, // 3932
  { PseudoVLOXSEG2EI64_V_M1_MF2, VLOXSEG2EI64_V, 0x7 }, // 3933
  { PseudoVLOXSEG2EI64_V_M1_MF2_MASK, VLOXSEG2EI64_V, 0x7 }, // 3934
  { PseudoVLOXSEG2EI64_V_M1_MF2_TU, VLOXSEG2EI64_V, 0x7 }, // 3935
  { PseudoVLOXSEG2EI64_V_M2_MF2, VLOXSEG2EI64_V, 0x7 }, // 3936
  { PseudoVLOXSEG2EI64_V_M2_MF2_MASK, VLOXSEG2EI64_V, 0x7 }, // 3937
  { PseudoVLOXSEG2EI64_V_M2_MF2_TU, VLOXSEG2EI64_V, 0x7 }, // 3938
  { PseudoVLOXSEG2EI64_V_M4_MF2, VLOXSEG2EI64_V, 0x7 }, // 3939
  { PseudoVLOXSEG2EI64_V_M4_MF2_MASK, VLOXSEG2EI64_V, 0x7 }, // 3940
  { PseudoVLOXSEG2EI64_V_M4_MF2_TU, VLOXSEG2EI64_V, 0x7 }, // 3941
  { PseudoVLOXSEG2EI8_V_M1_M1, VLOXSEG2EI8_V, 0x0 }, // 3942
  { PseudoVLOXSEG2EI8_V_M1_M1_MASK, VLOXSEG2EI8_V, 0x0 }, // 3943
  { PseudoVLOXSEG2EI8_V_M1_M1_TU, VLOXSEG2EI8_V, 0x0 }, // 3944
  { PseudoVLOXSEG2EI8_V_MF2_M1, VLOXSEG2EI8_V, 0x0 }, // 3945
  { PseudoVLOXSEG2EI8_V_MF2_M1_MASK, VLOXSEG2EI8_V, 0x0 }, // 3946
  { PseudoVLOXSEG2EI8_V_MF2_M1_TU, VLOXSEG2EI8_V, 0x0 }, // 3947
  { PseudoVLOXSEG2EI8_V_MF4_M1, VLOXSEG2EI8_V, 0x0 }, // 3948
  { PseudoVLOXSEG2EI8_V_MF4_M1_MASK, VLOXSEG2EI8_V, 0x0 }, // 3949
  { PseudoVLOXSEG2EI8_V_MF4_M1_TU, VLOXSEG2EI8_V, 0x0 }, // 3950
  { PseudoVLOXSEG2EI8_V_MF8_M1, VLOXSEG2EI8_V, 0x0 }, // 3951
  { PseudoVLOXSEG2EI8_V_MF8_M1_MASK, VLOXSEG2EI8_V, 0x0 }, // 3952
  { PseudoVLOXSEG2EI8_V_MF8_M1_TU, VLOXSEG2EI8_V, 0x0 }, // 3953
  { PseudoVLOXSEG2EI8_V_M1_M2, VLOXSEG2EI8_V, 0x1 }, // 3954
  { PseudoVLOXSEG2EI8_V_M1_M2_MASK, VLOXSEG2EI8_V, 0x1 }, // 3955
  { PseudoVLOXSEG2EI8_V_M1_M2_TU, VLOXSEG2EI8_V, 0x1 }, // 3956
  { PseudoVLOXSEG2EI8_V_M2_M2, VLOXSEG2EI8_V, 0x1 }, // 3957
  { PseudoVLOXSEG2EI8_V_M2_M2_MASK, VLOXSEG2EI8_V, 0x1 }, // 3958
  { PseudoVLOXSEG2EI8_V_M2_M2_TU, VLOXSEG2EI8_V, 0x1 }, // 3959
  { PseudoVLOXSEG2EI8_V_MF2_M2, VLOXSEG2EI8_V, 0x1 }, // 3960
  { PseudoVLOXSEG2EI8_V_MF2_M2_MASK, VLOXSEG2EI8_V, 0x1 }, // 3961
  { PseudoVLOXSEG2EI8_V_MF2_M2_TU, VLOXSEG2EI8_V, 0x1 }, // 3962
  { PseudoVLOXSEG2EI8_V_MF4_M2, VLOXSEG2EI8_V, 0x1 }, // 3963
  { PseudoVLOXSEG2EI8_V_MF4_M2_MASK, VLOXSEG2EI8_V, 0x1 }, // 3964
  { PseudoVLOXSEG2EI8_V_MF4_M2_TU, VLOXSEG2EI8_V, 0x1 }, // 3965
  { PseudoVLOXSEG2EI8_V_M1_M4, VLOXSEG2EI8_V, 0x2 }, // 3966
  { PseudoVLOXSEG2EI8_V_M1_M4_MASK, VLOXSEG2EI8_V, 0x2 }, // 3967
  { PseudoVLOXSEG2EI8_V_M1_M4_TU, VLOXSEG2EI8_V, 0x2 }, // 3968
  { PseudoVLOXSEG2EI8_V_M2_M4, VLOXSEG2EI8_V, 0x2 }, // 3969
  { PseudoVLOXSEG2EI8_V_M2_M4_MASK, VLOXSEG2EI8_V, 0x2 }, // 3970
  { PseudoVLOXSEG2EI8_V_M2_M4_TU, VLOXSEG2EI8_V, 0x2 }, // 3971
  { PseudoVLOXSEG2EI8_V_M4_M4, VLOXSEG2EI8_V, 0x2 }, // 3972
  { PseudoVLOXSEG2EI8_V_M4_M4_MASK, VLOXSEG2EI8_V, 0x2 }, // 3973
  { PseudoVLOXSEG2EI8_V_M4_M4_TU, VLOXSEG2EI8_V, 0x2 }, // 3974
  { PseudoVLOXSEG2EI8_V_MF2_M4, VLOXSEG2EI8_V, 0x2 }, // 3975
  { PseudoVLOXSEG2EI8_V_MF2_M4_MASK, VLOXSEG2EI8_V, 0x2 }, // 3976
  { PseudoVLOXSEG2EI8_V_MF2_M4_TU, VLOXSEG2EI8_V, 0x2 }, // 3977
  { PseudoVLOXSEG2EI8_V_MF8_MF8, VLOXSEG2EI8_V, 0x5 }, // 3978
  { PseudoVLOXSEG2EI8_V_MF8_MF8_MASK, VLOXSEG2EI8_V, 0x5 }, // 3979
  { PseudoVLOXSEG2EI8_V_MF8_MF8_TU, VLOXSEG2EI8_V, 0x5 }, // 3980
  { PseudoVLOXSEG2EI8_V_MF4_MF4, VLOXSEG2EI8_V, 0x6 }, // 3981
  { PseudoVLOXSEG2EI8_V_MF4_MF4_MASK, VLOXSEG2EI8_V, 0x6 }, // 3982
  { PseudoVLOXSEG2EI8_V_MF4_MF4_TU, VLOXSEG2EI8_V, 0x6 }, // 3983
  { PseudoVLOXSEG2EI8_V_MF8_MF4, VLOXSEG2EI8_V, 0x6 }, // 3984
  { PseudoVLOXSEG2EI8_V_MF8_MF4_MASK, VLOXSEG2EI8_V, 0x6 }, // 3985
  { PseudoVLOXSEG2EI8_V_MF8_MF4_TU, VLOXSEG2EI8_V, 0x6 }, // 3986
  { PseudoVLOXSEG2EI8_V_MF2_MF2, VLOXSEG2EI8_V, 0x7 }, // 3987
  { PseudoVLOXSEG2EI8_V_MF2_MF2_MASK, VLOXSEG2EI8_V, 0x7 }, // 3988
  { PseudoVLOXSEG2EI8_V_MF2_MF2_TU, VLOXSEG2EI8_V, 0x7 }, // 3989
  { PseudoVLOXSEG2EI8_V_MF4_MF2, VLOXSEG2EI8_V, 0x7 }, // 3990
  { PseudoVLOXSEG2EI8_V_MF4_MF2_MASK, VLOXSEG2EI8_V, 0x7 }, // 3991
  { PseudoVLOXSEG2EI8_V_MF4_MF2_TU, VLOXSEG2EI8_V, 0x7 }, // 3992
  { PseudoVLOXSEG2EI8_V_MF8_MF2, VLOXSEG2EI8_V, 0x7 }, // 3993
  { PseudoVLOXSEG2EI8_V_MF8_MF2_MASK, VLOXSEG2EI8_V, 0x7 }, // 3994
  { PseudoVLOXSEG2EI8_V_MF8_MF2_TU, VLOXSEG2EI8_V, 0x7 }, // 3995
  { PseudoVLOXSEG3EI16_V_M1_M1, VLOXSEG3EI16_V, 0x0 }, // 3996
  { PseudoVLOXSEG3EI16_V_M1_M1_MASK, VLOXSEG3EI16_V, 0x0 }, // 3997
  { PseudoVLOXSEG3EI16_V_M1_M1_TU, VLOXSEG3EI16_V, 0x0 }, // 3998
  { PseudoVLOXSEG3EI16_V_M2_M1, VLOXSEG3EI16_V, 0x0 }, // 3999
  { PseudoVLOXSEG3EI16_V_M2_M1_MASK, VLOXSEG3EI16_V, 0x0 }, // 4000
  { PseudoVLOXSEG3EI16_V_M2_M1_TU, VLOXSEG3EI16_V, 0x0 }, // 4001
  { PseudoVLOXSEG3EI16_V_MF2_M1, VLOXSEG3EI16_V, 0x0 }, // 4002
  { PseudoVLOXSEG3EI16_V_MF2_M1_MASK, VLOXSEG3EI16_V, 0x0 }, // 4003
  { PseudoVLOXSEG3EI16_V_MF2_M1_TU, VLOXSEG3EI16_V, 0x0 }, // 4004
  { PseudoVLOXSEG3EI16_V_MF4_M1, VLOXSEG3EI16_V, 0x0 }, // 4005
  { PseudoVLOXSEG3EI16_V_MF4_M1_MASK, VLOXSEG3EI16_V, 0x0 }, // 4006
  { PseudoVLOXSEG3EI16_V_MF4_M1_TU, VLOXSEG3EI16_V, 0x0 }, // 4007
  { PseudoVLOXSEG3EI16_V_M1_M2, VLOXSEG3EI16_V, 0x1 }, // 4008
  { PseudoVLOXSEG3EI16_V_M1_M2_MASK, VLOXSEG3EI16_V, 0x1 }, // 4009
  { PseudoVLOXSEG3EI16_V_M1_M2_TU, VLOXSEG3EI16_V, 0x1 }, // 4010
  { PseudoVLOXSEG3EI16_V_M2_M2, VLOXSEG3EI16_V, 0x1 }, // 4011
  { PseudoVLOXSEG3EI16_V_M2_M2_MASK, VLOXSEG3EI16_V, 0x1 }, // 4012
  { PseudoVLOXSEG3EI16_V_M2_M2_TU, VLOXSEG3EI16_V, 0x1 }, // 4013
  { PseudoVLOXSEG3EI16_V_M4_M2, VLOXSEG3EI16_V, 0x1 }, // 4014
  { PseudoVLOXSEG3EI16_V_M4_M2_MASK, VLOXSEG3EI16_V, 0x1 }, // 4015
  { PseudoVLOXSEG3EI16_V_M4_M2_TU, VLOXSEG3EI16_V, 0x1 }, // 4016
  { PseudoVLOXSEG3EI16_V_MF2_M2, VLOXSEG3EI16_V, 0x1 }, // 4017
  { PseudoVLOXSEG3EI16_V_MF2_M2_MASK, VLOXSEG3EI16_V, 0x1 }, // 4018
  { PseudoVLOXSEG3EI16_V_MF2_M2_TU, VLOXSEG3EI16_V, 0x1 }, // 4019
  { PseudoVLOXSEG3EI16_V_MF4_MF8, VLOXSEG3EI16_V, 0x5 }, // 4020
  { PseudoVLOXSEG3EI16_V_MF4_MF8_MASK, VLOXSEG3EI16_V, 0x5 }, // 4021
  { PseudoVLOXSEG3EI16_V_MF4_MF8_TU, VLOXSEG3EI16_V, 0x5 }, // 4022
  { PseudoVLOXSEG3EI16_V_MF2_MF4, VLOXSEG3EI16_V, 0x6 }, // 4023
  { PseudoVLOXSEG3EI16_V_MF2_MF4_MASK, VLOXSEG3EI16_V, 0x6 }, // 4024
  { PseudoVLOXSEG3EI16_V_MF2_MF4_TU, VLOXSEG3EI16_V, 0x6 }, // 4025
  { PseudoVLOXSEG3EI16_V_MF4_MF4, VLOXSEG3EI16_V, 0x6 }, // 4026
  { PseudoVLOXSEG3EI16_V_MF4_MF4_MASK, VLOXSEG3EI16_V, 0x6 }, // 4027
  { PseudoVLOXSEG3EI16_V_MF4_MF4_TU, VLOXSEG3EI16_V, 0x6 }, // 4028
  { PseudoVLOXSEG3EI16_V_M1_MF2, VLOXSEG3EI16_V, 0x7 }, // 4029
  { PseudoVLOXSEG3EI16_V_M1_MF2_MASK, VLOXSEG3EI16_V, 0x7 }, // 4030
  { PseudoVLOXSEG3EI16_V_M1_MF2_TU, VLOXSEG3EI16_V, 0x7 }, // 4031
  { PseudoVLOXSEG3EI16_V_MF2_MF2, VLOXSEG3EI16_V, 0x7 }, // 4032
  { PseudoVLOXSEG3EI16_V_MF2_MF2_MASK, VLOXSEG3EI16_V, 0x7 }, // 4033
  { PseudoVLOXSEG3EI16_V_MF2_MF2_TU, VLOXSEG3EI16_V, 0x7 }, // 4034
  { PseudoVLOXSEG3EI16_V_MF4_MF2, VLOXSEG3EI16_V, 0x7 }, // 4035
  { PseudoVLOXSEG3EI16_V_MF4_MF2_MASK, VLOXSEG3EI16_V, 0x7 }, // 4036
  { PseudoVLOXSEG3EI16_V_MF4_MF2_TU, VLOXSEG3EI16_V, 0x7 }, // 4037
  { PseudoVLOXSEG3EI32_V_M1_M1, VLOXSEG3EI32_V, 0x0 }, // 4038
  { PseudoVLOXSEG3EI32_V_M1_M1_MASK, VLOXSEG3EI32_V, 0x0 }, // 4039
  { PseudoVLOXSEG3EI32_V_M1_M1_TU, VLOXSEG3EI32_V, 0x0 }, // 4040
  { PseudoVLOXSEG3EI32_V_M2_M1, VLOXSEG3EI32_V, 0x0 }, // 4041
  { PseudoVLOXSEG3EI32_V_M2_M1_MASK, VLOXSEG3EI32_V, 0x0 }, // 4042
  { PseudoVLOXSEG3EI32_V_M2_M1_TU, VLOXSEG3EI32_V, 0x0 }, // 4043
  { PseudoVLOXSEG3EI32_V_M4_M1, VLOXSEG3EI32_V, 0x0 }, // 4044
  { PseudoVLOXSEG3EI32_V_M4_M1_MASK, VLOXSEG3EI32_V, 0x0 }, // 4045
  { PseudoVLOXSEG3EI32_V_M4_M1_TU, VLOXSEG3EI32_V, 0x0 }, // 4046
  { PseudoVLOXSEG3EI32_V_MF2_M1, VLOXSEG3EI32_V, 0x0 }, // 4047
  { PseudoVLOXSEG3EI32_V_MF2_M1_MASK, VLOXSEG3EI32_V, 0x0 }, // 4048
  { PseudoVLOXSEG3EI32_V_MF2_M1_TU, VLOXSEG3EI32_V, 0x0 }, // 4049
  { PseudoVLOXSEG3EI32_V_M1_M2, VLOXSEG3EI32_V, 0x1 }, // 4050
  { PseudoVLOXSEG3EI32_V_M1_M2_MASK, VLOXSEG3EI32_V, 0x1 }, // 4051
  { PseudoVLOXSEG3EI32_V_M1_M2_TU, VLOXSEG3EI32_V, 0x1 }, // 4052
  { PseudoVLOXSEG3EI32_V_M2_M2, VLOXSEG3EI32_V, 0x1 }, // 4053
  { PseudoVLOXSEG3EI32_V_M2_M2_MASK, VLOXSEG3EI32_V, 0x1 }, // 4054
  { PseudoVLOXSEG3EI32_V_M2_M2_TU, VLOXSEG3EI32_V, 0x1 }, // 4055
  { PseudoVLOXSEG3EI32_V_M4_M2, VLOXSEG3EI32_V, 0x1 }, // 4056
  { PseudoVLOXSEG3EI32_V_M4_M2_MASK, VLOXSEG3EI32_V, 0x1 }, // 4057
  { PseudoVLOXSEG3EI32_V_M4_M2_TU, VLOXSEG3EI32_V, 0x1 }, // 4058
  { PseudoVLOXSEG3EI32_V_M8_M2, VLOXSEG3EI32_V, 0x1 }, // 4059
  { PseudoVLOXSEG3EI32_V_M8_M2_MASK, VLOXSEG3EI32_V, 0x1 }, // 4060
  { PseudoVLOXSEG3EI32_V_M8_M2_TU, VLOXSEG3EI32_V, 0x1 }, // 4061
  { PseudoVLOXSEG3EI32_V_MF2_MF8, VLOXSEG3EI32_V, 0x5 }, // 4062
  { PseudoVLOXSEG3EI32_V_MF2_MF8_MASK, VLOXSEG3EI32_V, 0x5 }, // 4063
  { PseudoVLOXSEG3EI32_V_MF2_MF8_TU, VLOXSEG3EI32_V, 0x5 }, // 4064
  { PseudoVLOXSEG3EI32_V_M1_MF4, VLOXSEG3EI32_V, 0x6 }, // 4065
  { PseudoVLOXSEG3EI32_V_M1_MF4_MASK, VLOXSEG3EI32_V, 0x6 }, // 4066
  { PseudoVLOXSEG3EI32_V_M1_MF4_TU, VLOXSEG3EI32_V, 0x6 }, // 4067
  { PseudoVLOXSEG3EI32_V_MF2_MF4, VLOXSEG3EI32_V, 0x6 }, // 4068
  { PseudoVLOXSEG3EI32_V_MF2_MF4_MASK, VLOXSEG3EI32_V, 0x6 }, // 4069
  { PseudoVLOXSEG3EI32_V_MF2_MF4_TU, VLOXSEG3EI32_V, 0x6 }, // 4070
  { PseudoVLOXSEG3EI32_V_M1_MF2, VLOXSEG3EI32_V, 0x7 }, // 4071
  { PseudoVLOXSEG3EI32_V_M1_MF2_MASK, VLOXSEG3EI32_V, 0x7 }, // 4072
  { PseudoVLOXSEG3EI32_V_M1_MF2_TU, VLOXSEG3EI32_V, 0x7 }, // 4073
  { PseudoVLOXSEG3EI32_V_M2_MF2, VLOXSEG3EI32_V, 0x7 }, // 4074
  { PseudoVLOXSEG3EI32_V_M2_MF2_MASK, VLOXSEG3EI32_V, 0x7 }, // 4075
  { PseudoVLOXSEG3EI32_V_M2_MF2_TU, VLOXSEG3EI32_V, 0x7 }, // 4076
  { PseudoVLOXSEG3EI32_V_MF2_MF2, VLOXSEG3EI32_V, 0x7 }, // 4077
  { PseudoVLOXSEG3EI32_V_MF2_MF2_MASK, VLOXSEG3EI32_V, 0x7 }, // 4078
  { PseudoVLOXSEG3EI32_V_MF2_MF2_TU, VLOXSEG3EI32_V, 0x7 }, // 4079
  { PseudoVLOXSEG3EI64_V_M1_M1, VLOXSEG3EI64_V, 0x0 }, // 4080
  { PseudoVLOXSEG3EI64_V_M1_M1_MASK, VLOXSEG3EI64_V, 0x0 }, // 4081
  { PseudoVLOXSEG3EI64_V_M1_M1_TU, VLOXSEG3EI64_V, 0x0 }, // 4082
  { PseudoVLOXSEG3EI64_V_M2_M1, VLOXSEG3EI64_V, 0x0 }, // 4083
  { PseudoVLOXSEG3EI64_V_M2_M1_MASK, VLOXSEG3EI64_V, 0x0 }, // 4084
  { PseudoVLOXSEG3EI64_V_M2_M1_TU, VLOXSEG3EI64_V, 0x0 }, // 4085
  { PseudoVLOXSEG3EI64_V_M4_M1, VLOXSEG3EI64_V, 0x0 }, // 4086
  { PseudoVLOXSEG3EI64_V_M4_M1_MASK, VLOXSEG3EI64_V, 0x0 }, // 4087
  { PseudoVLOXSEG3EI64_V_M4_M1_TU, VLOXSEG3EI64_V, 0x0 }, // 4088
  { PseudoVLOXSEG3EI64_V_M8_M1, VLOXSEG3EI64_V, 0x0 }, // 4089
  { PseudoVLOXSEG3EI64_V_M8_M1_MASK, VLOXSEG3EI64_V, 0x0 }, // 4090
  { PseudoVLOXSEG3EI64_V_M8_M1_TU, VLOXSEG3EI64_V, 0x0 }, // 4091
  { PseudoVLOXSEG3EI64_V_M2_M2, VLOXSEG3EI64_V, 0x1 }, // 4092
  { PseudoVLOXSEG3EI64_V_M2_M2_MASK, VLOXSEG3EI64_V, 0x1 }, // 4093
  { PseudoVLOXSEG3EI64_V_M2_M2_TU, VLOXSEG3EI64_V, 0x1 }, // 4094
  { PseudoVLOXSEG3EI64_V_M4_M2, VLOXSEG3EI64_V, 0x1 }, // 4095
  { PseudoVLOXSEG3EI64_V_M4_M2_MASK, VLOXSEG3EI64_V, 0x1 }, // 4096
  { PseudoVLOXSEG3EI64_V_M4_M2_TU, VLOXSEG3EI64_V, 0x1 }, // 4097
  { PseudoVLOXSEG3EI64_V_M8_M2, VLOXSEG3EI64_V, 0x1 }, // 4098
  { PseudoVLOXSEG3EI64_V_M8_M2_MASK, VLOXSEG3EI64_V, 0x1 }, // 4099
  { PseudoVLOXSEG3EI64_V_M8_M2_TU, VLOXSEG3EI64_V, 0x1 }, // 4100
  { PseudoVLOXSEG3EI64_V_M1_MF8, VLOXSEG3EI64_V, 0x5 }, // 4101
  { PseudoVLOXSEG3EI64_V_M1_MF8_MASK, VLOXSEG3EI64_V, 0x5 }, // 4102
  { PseudoVLOXSEG3EI64_V_M1_MF8_TU, VLOXSEG3EI64_V, 0x5 }, // 4103
  { PseudoVLOXSEG3EI64_V_M1_MF4, VLOXSEG3EI64_V, 0x6 }, // 4104
  { PseudoVLOXSEG3EI64_V_M1_MF4_MASK, VLOXSEG3EI64_V, 0x6 }, // 4105
  { PseudoVLOXSEG3EI64_V_M1_MF4_TU, VLOXSEG3EI64_V, 0x6 }, // 4106
  { PseudoVLOXSEG3EI64_V_M2_MF4, VLOXSEG3EI64_V, 0x6 }, // 4107
  { PseudoVLOXSEG3EI64_V_M2_MF4_MASK, VLOXSEG3EI64_V, 0x6 }, // 4108
  { PseudoVLOXSEG3EI64_V_M2_MF4_TU, VLOXSEG3EI64_V, 0x6 }, // 4109
  { PseudoVLOXSEG3EI64_V_M1_MF2, VLOXSEG3EI64_V, 0x7 }, // 4110
  { PseudoVLOXSEG3EI64_V_M1_MF2_MASK, VLOXSEG3EI64_V, 0x7 }, // 4111
  { PseudoVLOXSEG3EI64_V_M1_MF2_TU, VLOXSEG3EI64_V, 0x7 }, // 4112
  { PseudoVLOXSEG3EI64_V_M2_MF2, VLOXSEG3EI64_V, 0x7 }, // 4113
  { PseudoVLOXSEG3EI64_V_M2_MF2_MASK, VLOXSEG3EI64_V, 0x7 }, // 4114
  { PseudoVLOXSEG3EI64_V_M2_MF2_TU, VLOXSEG3EI64_V, 0x7 }, // 4115
  { PseudoVLOXSEG3EI64_V_M4_MF2, VLOXSEG3EI64_V, 0x7 }, // 4116
  { PseudoVLOXSEG3EI64_V_M4_MF2_MASK, VLOXSEG3EI64_V, 0x7 }, // 4117
  { PseudoVLOXSEG3EI64_V_M4_MF2_TU, VLOXSEG3EI64_V, 0x7 }, // 4118
  { PseudoVLOXSEG3EI8_V_M1_M1, VLOXSEG3EI8_V, 0x0 }, // 4119
  { PseudoVLOXSEG3EI8_V_M1_M1_MASK, VLOXSEG3EI8_V, 0x0 }, // 4120
  { PseudoVLOXSEG3EI8_V_M1_M1_TU, VLOXSEG3EI8_V, 0x0 }, // 4121
  { PseudoVLOXSEG3EI8_V_MF2_M1, VLOXSEG3EI8_V, 0x0 }, // 4122
  { PseudoVLOXSEG3EI8_V_MF2_M1_MASK, VLOXSEG3EI8_V, 0x0 }, // 4123
  { PseudoVLOXSEG3EI8_V_MF2_M1_TU, VLOXSEG3EI8_V, 0x0 }, // 4124
  { PseudoVLOXSEG3EI8_V_MF4_M1, VLOXSEG3EI8_V, 0x0 }, // 4125
  { PseudoVLOXSEG3EI8_V_MF4_M1_MASK, VLOXSEG3EI8_V, 0x0 }, // 4126
  { PseudoVLOXSEG3EI8_V_MF4_M1_TU, VLOXSEG3EI8_V, 0x0 }, // 4127
  { PseudoVLOXSEG3EI8_V_MF8_M1, VLOXSEG3EI8_V, 0x0 }, // 4128
  { PseudoVLOXSEG3EI8_V_MF8_M1_MASK, VLOXSEG3EI8_V, 0x0 }, // 4129
  { PseudoVLOXSEG3EI8_V_MF8_M1_TU, VLOXSEG3EI8_V, 0x0 }, // 4130
  { PseudoVLOXSEG3EI8_V_M1_M2, VLOXSEG3EI8_V, 0x1 }, // 4131
  { PseudoVLOXSEG3EI8_V_M1_M2_MASK, VLOXSEG3EI8_V, 0x1 }, // 4132
  { PseudoVLOXSEG3EI8_V_M1_M2_TU, VLOXSEG3EI8_V, 0x1 }, // 4133
  { PseudoVLOXSEG3EI8_V_M2_M2, VLOXSEG3EI8_V, 0x1 }, // 4134
  { PseudoVLOXSEG3EI8_V_M2_M2_MASK, VLOXSEG3EI8_V, 0x1 }, // 4135
  { PseudoVLOXSEG3EI8_V_M2_M2_TU, VLOXSEG3EI8_V, 0x1 }, // 4136
  { PseudoVLOXSEG3EI8_V_MF2_M2, VLOXSEG3EI8_V, 0x1 }, // 4137
  { PseudoVLOXSEG3EI8_V_MF2_M2_MASK, VLOXSEG3EI8_V, 0x1 }, // 4138
  { PseudoVLOXSEG3EI8_V_MF2_M2_TU, VLOXSEG3EI8_V, 0x1 }, // 4139
  { PseudoVLOXSEG3EI8_V_MF4_M2, VLOXSEG3EI8_V, 0x1 }, // 4140
  { PseudoVLOXSEG3EI8_V_MF4_M2_MASK, VLOXSEG3EI8_V, 0x1 }, // 4141
  { PseudoVLOXSEG3EI8_V_MF4_M2_TU, VLOXSEG3EI8_V, 0x1 }, // 4142
  { PseudoVLOXSEG3EI8_V_MF8_MF8, VLOXSEG3EI8_V, 0x5 }, // 4143
  { PseudoVLOXSEG3EI8_V_MF8_MF8_MASK, VLOXSEG3EI8_V, 0x5 }, // 4144
  { PseudoVLOXSEG3EI8_V_MF8_MF8_TU, VLOXSEG3EI8_V, 0x5 }, // 4145
  { PseudoVLOXSEG3EI8_V_MF4_MF4, VLOXSEG3EI8_V, 0x6 }, // 4146
  { PseudoVLOXSEG3EI8_V_MF4_MF4_MASK, VLOXSEG3EI8_V, 0x6 }, // 4147
  { PseudoVLOXSEG3EI8_V_MF4_MF4_TU, VLOXSEG3EI8_V, 0x6 }, // 4148
  { PseudoVLOXSEG3EI8_V_MF8_MF4, VLOXSEG3EI8_V, 0x6 }, // 4149
  { PseudoVLOXSEG3EI8_V_MF8_MF4_MASK, VLOXSEG3EI8_V, 0x6 }, // 4150
  { PseudoVLOXSEG3EI8_V_MF8_MF4_TU, VLOXSEG3EI8_V, 0x6 }, // 4151
  { PseudoVLOXSEG3EI8_V_MF2_MF2, VLOXSEG3EI8_V, 0x7 }, // 4152
  { PseudoVLOXSEG3EI8_V_MF2_MF2_MASK, VLOXSEG3EI8_V, 0x7 }, // 4153
  { PseudoVLOXSEG3EI8_V_MF2_MF2_TU, VLOXSEG3EI8_V, 0x7 }, // 4154
  { PseudoVLOXSEG3EI8_V_MF4_MF2, VLOXSEG3EI8_V, 0x7 }, // 4155
  { PseudoVLOXSEG3EI8_V_MF4_MF2_MASK, VLOXSEG3EI8_V, 0x7 }, // 4156
  { PseudoVLOXSEG3EI8_V_MF4_MF2_TU, VLOXSEG3EI8_V, 0x7 }, // 4157
  { PseudoVLOXSEG3EI8_V_MF8_MF2, VLOXSEG3EI8_V, 0x7 }, // 4158
  { PseudoVLOXSEG3EI8_V_MF8_MF2_MASK, VLOXSEG3EI8_V, 0x7 }, // 4159
  { PseudoVLOXSEG3EI8_V_MF8_MF2_TU, VLOXSEG3EI8_V, 0x7 }, // 4160
  { PseudoVLOXSEG4EI16_V_M1_M1, VLOXSEG4EI16_V, 0x0 }, // 4161
  { PseudoVLOXSEG4EI16_V_M1_M1_MASK, VLOXSEG4EI16_V, 0x0 }, // 4162
  { PseudoVLOXSEG4EI16_V_M1_M1_TU, VLOXSEG4EI16_V, 0x0 }, // 4163
  { PseudoVLOXSEG4EI16_V_M2_M1, VLOXSEG4EI16_V, 0x0 }, // 4164
  { PseudoVLOXSEG4EI16_V_M2_M1_MASK, VLOXSEG4EI16_V, 0x0 }, // 4165
  { PseudoVLOXSEG4EI16_V_M2_M1_TU, VLOXSEG4EI16_V, 0x0 }, // 4166
  { PseudoVLOXSEG4EI16_V_MF2_M1, VLOXSEG4EI16_V, 0x0 }, // 4167
  { PseudoVLOXSEG4EI16_V_MF2_M1_MASK, VLOXSEG4EI16_V, 0x0 }, // 4168
  { PseudoVLOXSEG4EI16_V_MF2_M1_TU, VLOXSEG4EI16_V, 0x0 }, // 4169
  { PseudoVLOXSEG4EI16_V_MF4_M1, VLOXSEG4EI16_V, 0x0 }, // 4170
  { PseudoVLOXSEG4EI16_V_MF4_M1_MASK, VLOXSEG4EI16_V, 0x0 }, // 4171
  { PseudoVLOXSEG4EI16_V_MF4_M1_TU, VLOXSEG4EI16_V, 0x0 }, // 4172
  { PseudoVLOXSEG4EI16_V_M1_M2, VLOXSEG4EI16_V, 0x1 }, // 4173
  { PseudoVLOXSEG4EI16_V_M1_M2_MASK, VLOXSEG4EI16_V, 0x1 }, // 4174
  { PseudoVLOXSEG4EI16_V_M1_M2_TU, VLOXSEG4EI16_V, 0x1 }, // 4175
  { PseudoVLOXSEG4EI16_V_M2_M2, VLOXSEG4EI16_V, 0x1 }, // 4176
  { PseudoVLOXSEG4EI16_V_M2_M2_MASK, VLOXSEG4EI16_V, 0x1 }, // 4177
  { PseudoVLOXSEG4EI16_V_M2_M2_TU, VLOXSEG4EI16_V, 0x1 }, // 4178
  { PseudoVLOXSEG4EI16_V_M4_M2, VLOXSEG4EI16_V, 0x1 }, // 4179
  { PseudoVLOXSEG4EI16_V_M4_M2_MASK, VLOXSEG4EI16_V, 0x1 }, // 4180
  { PseudoVLOXSEG4EI16_V_M4_M2_TU, VLOXSEG4EI16_V, 0x1 }, // 4181
  { PseudoVLOXSEG4EI16_V_MF2_M2, VLOXSEG4EI16_V, 0x1 }, // 4182
  { PseudoVLOXSEG4EI16_V_MF2_M2_MASK, VLOXSEG4EI16_V, 0x1 }, // 4183
  { PseudoVLOXSEG4EI16_V_MF2_M2_TU, VLOXSEG4EI16_V, 0x1 }, // 4184
  { PseudoVLOXSEG4EI16_V_MF4_MF8, VLOXSEG4EI16_V, 0x5 }, // 4185
  { PseudoVLOXSEG4EI16_V_MF4_MF8_MASK, VLOXSEG4EI16_V, 0x5 }, // 4186
  { PseudoVLOXSEG4EI16_V_MF4_MF8_TU, VLOXSEG4EI16_V, 0x5 }, // 4187
  { PseudoVLOXSEG4EI16_V_MF2_MF4, VLOXSEG4EI16_V, 0x6 }, // 4188
  { PseudoVLOXSEG4EI16_V_MF2_MF4_MASK, VLOXSEG4EI16_V, 0x6 }, // 4189
  { PseudoVLOXSEG4EI16_V_MF2_MF4_TU, VLOXSEG4EI16_V, 0x6 }, // 4190
  { PseudoVLOXSEG4EI16_V_MF4_MF4, VLOXSEG4EI16_V, 0x6 }, // 4191
  { PseudoVLOXSEG4EI16_V_MF4_MF4_MASK, VLOXSEG4EI16_V, 0x6 }, // 4192
  { PseudoVLOXSEG4EI16_V_MF4_MF4_TU, VLOXSEG4EI16_V, 0x6 }, // 4193
  { PseudoVLOXSEG4EI16_V_M1_MF2, VLOXSEG4EI16_V, 0x7 }, // 4194
  { PseudoVLOXSEG4EI16_V_M1_MF2_MASK, VLOXSEG4EI16_V, 0x7 }, // 4195
  { PseudoVLOXSEG4EI16_V_M1_MF2_TU, VLOXSEG4EI16_V, 0x7 }, // 4196
  { PseudoVLOXSEG4EI16_V_MF2_MF2, VLOXSEG4EI16_V, 0x7 }, // 4197
  { PseudoVLOXSEG4EI16_V_MF2_MF2_MASK, VLOXSEG4EI16_V, 0x7 }, // 4198
  { PseudoVLOXSEG4EI16_V_MF2_MF2_TU, VLOXSEG4EI16_V, 0x7 }, // 4199
  { PseudoVLOXSEG4EI16_V_MF4_MF2, VLOXSEG4EI16_V, 0x7 }, // 4200
  { PseudoVLOXSEG4EI16_V_MF4_MF2_MASK, VLOXSEG4EI16_V, 0x7 }, // 4201
  { PseudoVLOXSEG4EI16_V_MF4_MF2_TU, VLOXSEG4EI16_V, 0x7 }, // 4202
  { PseudoVLOXSEG4EI32_V_M1_M1, VLOXSEG4EI32_V, 0x0 }, // 4203
  { PseudoVLOXSEG4EI32_V_M1_M1_MASK, VLOXSEG4EI32_V, 0x0 }, // 4204
  { PseudoVLOXSEG4EI32_V_M1_M1_TU, VLOXSEG4EI32_V, 0x0 }, // 4205
  { PseudoVLOXSEG4EI32_V_M2_M1, VLOXSEG4EI32_V, 0x0 }, // 4206
  { PseudoVLOXSEG4EI32_V_M2_M1_MASK, VLOXSEG4EI32_V, 0x0 }, // 4207
  { PseudoVLOXSEG4EI32_V_M2_M1_TU, VLOXSEG4EI32_V, 0x0 }, // 4208
  { PseudoVLOXSEG4EI32_V_M4_M1, VLOXSEG4EI32_V, 0x0 }, // 4209
  { PseudoVLOXSEG4EI32_V_M4_M1_MASK, VLOXSEG4EI32_V, 0x0 }, // 4210
  { PseudoVLOXSEG4EI32_V_M4_M1_TU, VLOXSEG4EI32_V, 0x0 }, // 4211
  { PseudoVLOXSEG4EI32_V_MF2_M1, VLOXSEG4EI32_V, 0x0 }, // 4212
  { PseudoVLOXSEG4EI32_V_MF2_M1_MASK, VLOXSEG4EI32_V, 0x0 }, // 4213
  { PseudoVLOXSEG4EI32_V_MF2_M1_TU, VLOXSEG4EI32_V, 0x0 }, // 4214
  { PseudoVLOXSEG4EI32_V_M1_M2, VLOXSEG4EI32_V, 0x1 }, // 4215
  { PseudoVLOXSEG4EI32_V_M1_M2_MASK, VLOXSEG4EI32_V, 0x1 }, // 4216
  { PseudoVLOXSEG4EI32_V_M1_M2_TU, VLOXSEG4EI32_V, 0x1 }, // 4217
  { PseudoVLOXSEG4EI32_V_M2_M2, VLOXSEG4EI32_V, 0x1 }, // 4218
  { PseudoVLOXSEG4EI32_V_M2_M2_MASK, VLOXSEG4EI32_V, 0x1 }, // 4219
  { PseudoVLOXSEG4EI32_V_M2_M2_TU, VLOXSEG4EI32_V, 0x1 }, // 4220
  { PseudoVLOXSEG4EI32_V_M4_M2, VLOXSEG4EI32_V, 0x1 }, // 4221
  { PseudoVLOXSEG4EI32_V_M4_M2_MASK, VLOXSEG4EI32_V, 0x1 }, // 4222
  { PseudoVLOXSEG4EI32_V_M4_M2_TU, VLOXSEG4EI32_V, 0x1 }, // 4223
  { PseudoVLOXSEG4EI32_V_M8_M2, VLOXSEG4EI32_V, 0x1 }, // 4224
  { PseudoVLOXSEG4EI32_V_M8_M2_MASK, VLOXSEG4EI32_V, 0x1 }, // 4225
  { PseudoVLOXSEG4EI32_V_M8_M2_TU, VLOXSEG4EI32_V, 0x1 }, // 4226
  { PseudoVLOXSEG4EI32_V_MF2_MF8, VLOXSEG4EI32_V, 0x5 }, // 4227
  { PseudoVLOXSEG4EI32_V_MF2_MF8_MASK, VLOXSEG4EI32_V, 0x5 }, // 4228
  { PseudoVLOXSEG4EI32_V_MF2_MF8_TU, VLOXSEG4EI32_V, 0x5 }, // 4229
  { PseudoVLOXSEG4EI32_V_M1_MF4, VLOXSEG4EI32_V, 0x6 }, // 4230
  { PseudoVLOXSEG4EI32_V_M1_MF4_MASK, VLOXSEG4EI32_V, 0x6 }, // 4231
  { PseudoVLOXSEG4EI32_V_M1_MF4_TU, VLOXSEG4EI32_V, 0x6 }, // 4232
  { PseudoVLOXSEG4EI32_V_MF2_MF4, VLOXSEG4EI32_V, 0x6 }, // 4233
  { PseudoVLOXSEG4EI32_V_MF2_MF4_MASK, VLOXSEG4EI32_V, 0x6 }, // 4234
  { PseudoVLOXSEG4EI32_V_MF2_MF4_TU, VLOXSEG4EI32_V, 0x6 }, // 4235
  { PseudoVLOXSEG4EI32_V_M1_MF2, VLOXSEG4EI32_V, 0x7 }, // 4236
  { PseudoVLOXSEG4EI32_V_M1_MF2_MASK, VLOXSEG4EI32_V, 0x7 }, // 4237
  { PseudoVLOXSEG4EI32_V_M1_MF2_TU, VLOXSEG4EI32_V, 0x7 }, // 4238
  { PseudoVLOXSEG4EI32_V_M2_MF2, VLOXSEG4EI32_V, 0x7 }, // 4239
  { PseudoVLOXSEG4EI32_V_M2_MF2_MASK, VLOXSEG4EI32_V, 0x7 }, // 4240
  { PseudoVLOXSEG4EI32_V_M2_MF2_TU, VLOXSEG4EI32_V, 0x7 }, // 4241
  { PseudoVLOXSEG4EI32_V_MF2_MF2, VLOXSEG4EI32_V, 0x7 }, // 4242
  { PseudoVLOXSEG4EI32_V_MF2_MF2_MASK, VLOXSEG4EI32_V, 0x7 }, // 4243
  { PseudoVLOXSEG4EI32_V_MF2_MF2_TU, VLOXSEG4EI32_V, 0x7 }, // 4244
  { PseudoVLOXSEG4EI64_V_M1_M1, VLOXSEG4EI64_V, 0x0 }, // 4245
  { PseudoVLOXSEG4EI64_V_M1_M1_MASK, VLOXSEG4EI64_V, 0x0 }, // 4246
  { PseudoVLOXSEG4EI64_V_M1_M1_TU, VLOXSEG4EI64_V, 0x0 }, // 4247
  { PseudoVLOXSEG4EI64_V_M2_M1, VLOXSEG4EI64_V, 0x0 }, // 4248
  { PseudoVLOXSEG4EI64_V_M2_M1_MASK, VLOXSEG4EI64_V, 0x0 }, // 4249
  { PseudoVLOXSEG4EI64_V_M2_M1_TU, VLOXSEG4EI64_V, 0x0 }, // 4250
  { PseudoVLOXSEG4EI64_V_M4_M1, VLOXSEG4EI64_V, 0x0 }, // 4251
  { PseudoVLOXSEG4EI64_V_M4_M1_MASK, VLOXSEG4EI64_V, 0x0 }, // 4252
  { PseudoVLOXSEG4EI64_V_M4_M1_TU, VLOXSEG4EI64_V, 0x0 }, // 4253
  { PseudoVLOXSEG4EI64_V_M8_M1, VLOXSEG4EI64_V, 0x0 }, // 4254
  { PseudoVLOXSEG4EI64_V_M8_M1_MASK, VLOXSEG4EI64_V, 0x0 }, // 4255
  { PseudoVLOXSEG4EI64_V_M8_M1_TU, VLOXSEG4EI64_V, 0x0 }, // 4256
  { PseudoVLOXSEG4EI64_V_M2_M2, VLOXSEG4EI64_V, 0x1 }, // 4257
  { PseudoVLOXSEG4EI64_V_M2_M2_MASK, VLOXSEG4EI64_V, 0x1 }, // 4258
  { PseudoVLOXSEG4EI64_V_M2_M2_TU, VLOXSEG4EI64_V, 0x1 }, // 4259
  { PseudoVLOXSEG4EI64_V_M4_M2, VLOXSEG4EI64_V, 0x1 }, // 4260
  { PseudoVLOXSEG4EI64_V_M4_M2_MASK, VLOXSEG4EI64_V, 0x1 }, // 4261
  { PseudoVLOXSEG4EI64_V_M4_M2_TU, VLOXSEG4EI64_V, 0x1 }, // 4262
  { PseudoVLOXSEG4EI64_V_M8_M2, VLOXSEG4EI64_V, 0x1 }, // 4263
  { PseudoVLOXSEG4EI64_V_M8_M2_MASK, VLOXSEG4EI64_V, 0x1 }, // 4264
  { PseudoVLOXSEG4EI64_V_M8_M2_TU, VLOXSEG4EI64_V, 0x1 }, // 4265
  { PseudoVLOXSEG4EI64_V_M1_MF8, VLOXSEG4EI64_V, 0x5 }, // 4266
  { PseudoVLOXSEG4EI64_V_M1_MF8_MASK, VLOXSEG4EI64_V, 0x5 }, // 4267
  { PseudoVLOXSEG4EI64_V_M1_MF8_TU, VLOXSEG4EI64_V, 0x5 }, // 4268
  { PseudoVLOXSEG4EI64_V_M1_MF4, VLOXSEG4EI64_V, 0x6 }, // 4269
  { PseudoVLOXSEG4EI64_V_M1_MF4_MASK, VLOXSEG4EI64_V, 0x6 }, // 4270
  { PseudoVLOXSEG4EI64_V_M1_MF4_TU, VLOXSEG4EI64_V, 0x6 }, // 4271
  { PseudoVLOXSEG4EI64_V_M2_MF4, VLOXSEG4EI64_V, 0x6 }, // 4272
  { PseudoVLOXSEG4EI64_V_M2_MF4_MASK, VLOXSEG4EI64_V, 0x6 }, // 4273
  { PseudoVLOXSEG4EI64_V_M2_MF4_TU, VLOXSEG4EI64_V, 0x6 }, // 4274
  { PseudoVLOXSEG4EI64_V_M1_MF2, VLOXSEG4EI64_V, 0x7 }, // 4275
  { PseudoVLOXSEG4EI64_V_M1_MF2_MASK, VLOXSEG4EI64_V, 0x7 }, // 4276
  { PseudoVLOXSEG4EI64_V_M1_MF2_TU, VLOXSEG4EI64_V, 0x7 }, // 4277
  { PseudoVLOXSEG4EI64_V_M2_MF2, VLOXSEG4EI64_V, 0x7 }, // 4278
  { PseudoVLOXSEG4EI64_V_M2_MF2_MASK, VLOXSEG4EI64_V, 0x7 }, // 4279
  { PseudoVLOXSEG4EI64_V_M2_MF2_TU, VLOXSEG4EI64_V, 0x7 }, // 4280
  { PseudoVLOXSEG4EI64_V_M4_MF2, VLOXSEG4EI64_V, 0x7 }, // 4281
  { PseudoVLOXSEG4EI64_V_M4_MF2_MASK, VLOXSEG4EI64_V, 0x7 }, // 4282
  { PseudoVLOXSEG4EI64_V_M4_MF2_TU, VLOXSEG4EI64_V, 0x7 }, // 4283
  { PseudoVLOXSEG4EI8_V_M1_M1, VLOXSEG4EI8_V, 0x0 }, // 4284
  { PseudoVLOXSEG4EI8_V_M1_M1_MASK, VLOXSEG4EI8_V, 0x0 }, // 4285
  { PseudoVLOXSEG4EI8_V_M1_M1_TU, VLOXSEG4EI8_V, 0x0 }, // 4286
  { PseudoVLOXSEG4EI8_V_MF2_M1, VLOXSEG4EI8_V, 0x0 }, // 4287
  { PseudoVLOXSEG4EI8_V_MF2_M1_MASK, VLOXSEG4EI8_V, 0x0 }, // 4288
  { PseudoVLOXSEG4EI8_V_MF2_M1_TU, VLOXSEG4EI8_V, 0x0 }, // 4289
  { PseudoVLOXSEG4EI8_V_MF4_M1, VLOXSEG4EI8_V, 0x0 }, // 4290
  { PseudoVLOXSEG4EI8_V_MF4_M1_MASK, VLOXSEG4EI8_V, 0x0 }, // 4291
  { PseudoVLOXSEG4EI8_V_MF4_M1_TU, VLOXSEG4EI8_V, 0x0 }, // 4292
  { PseudoVLOXSEG4EI8_V_MF8_M1, VLOXSEG4EI8_V, 0x0 }, // 4293
  { PseudoVLOXSEG4EI8_V_MF8_M1_MASK, VLOXSEG4EI8_V, 0x0 }, // 4294
  { PseudoVLOXSEG4EI8_V_MF8_M1_TU, VLOXSEG4EI8_V, 0x0 }, // 4295
  { PseudoVLOXSEG4EI8_V_M1_M2, VLOXSEG4EI8_V, 0x1 }, // 4296
  { PseudoVLOXSEG4EI8_V_M1_M2_MASK, VLOXSEG4EI8_V, 0x1 }, // 4297
  { PseudoVLOXSEG4EI8_V_M1_M2_TU, VLOXSEG4EI8_V, 0x1 }, // 4298
  { PseudoVLOXSEG4EI8_V_M2_M2, VLOXSEG4EI8_V, 0x1 }, // 4299
  { PseudoVLOXSEG4EI8_V_M2_M2_MASK, VLOXSEG4EI8_V, 0x1 }, // 4300
  { PseudoVLOXSEG4EI8_V_M2_M2_TU, VLOXSEG4EI8_V, 0x1 }, // 4301
  { PseudoVLOXSEG4EI8_V_MF2_M2, VLOXSEG4EI8_V, 0x1 }, // 4302
  { PseudoVLOXSEG4EI8_V_MF2_M2_MASK, VLOXSEG4EI8_V, 0x1 }, // 4303
  { PseudoVLOXSEG4EI8_V_MF2_M2_TU, VLOXSEG4EI8_V, 0x1 }, // 4304
  { PseudoVLOXSEG4EI8_V_MF4_M2, VLOXSEG4EI8_V, 0x1 }, // 4305
  { PseudoVLOXSEG4EI8_V_MF4_M2_MASK, VLOXSEG4EI8_V, 0x1 }, // 4306
  { PseudoVLOXSEG4EI8_V_MF4_M2_TU, VLOXSEG4EI8_V, 0x1 }, // 4307
  { PseudoVLOXSEG4EI8_V_MF8_MF8, VLOXSEG4EI8_V, 0x5 }, // 4308
  { PseudoVLOXSEG4EI8_V_MF8_MF8_MASK, VLOXSEG4EI8_V, 0x5 }, // 4309
  { PseudoVLOXSEG4EI8_V_MF8_MF8_TU, VLOXSEG4EI8_V, 0x5 }, // 4310
  { PseudoVLOXSEG4EI8_V_MF4_MF4, VLOXSEG4EI8_V, 0x6 }, // 4311
  { PseudoVLOXSEG4EI8_V_MF4_MF4_MASK, VLOXSEG4EI8_V, 0x6 }, // 4312
  { PseudoVLOXSEG4EI8_V_MF4_MF4_TU, VLOXSEG4EI8_V, 0x6 }, // 4313
  { PseudoVLOXSEG4EI8_V_MF8_MF4, VLOXSEG4EI8_V, 0x6 }, // 4314
  { PseudoVLOXSEG4EI8_V_MF8_MF4_MASK, VLOXSEG4EI8_V, 0x6 }, // 4315
  { PseudoVLOXSEG4EI8_V_MF8_MF4_TU, VLOXSEG4EI8_V, 0x6 }, // 4316
  { PseudoVLOXSEG4EI8_V_MF2_MF2, VLOXSEG4EI8_V, 0x7 }, // 4317
  { PseudoVLOXSEG4EI8_V_MF2_MF2_MASK, VLOXSEG4EI8_V, 0x7 }, // 4318
  { PseudoVLOXSEG4EI8_V_MF2_MF2_TU, VLOXSEG4EI8_V, 0x7 }, // 4319
  { PseudoVLOXSEG4EI8_V_MF4_MF2, VLOXSEG4EI8_V, 0x7 }, // 4320
  { PseudoVLOXSEG4EI8_V_MF4_MF2_MASK, VLOXSEG4EI8_V, 0x7 }, // 4321
  { PseudoVLOXSEG4EI8_V_MF4_MF2_TU, VLOXSEG4EI8_V, 0x7 }, // 4322
  { PseudoVLOXSEG4EI8_V_MF8_MF2, VLOXSEG4EI8_V, 0x7 }, // 4323
  { PseudoVLOXSEG4EI8_V_MF8_MF2_MASK, VLOXSEG4EI8_V, 0x7 }, // 4324
  { PseudoVLOXSEG4EI8_V_MF8_MF2_TU, VLOXSEG4EI8_V, 0x7 }, // 4325
  { PseudoVLOXSEG5EI16_V_M1_M1, VLOXSEG5EI16_V, 0x0 }, // 4326
  { PseudoVLOXSEG5EI16_V_M1_M1_MASK, VLOXSEG5EI16_V, 0x0 }, // 4327
  { PseudoVLOXSEG5EI16_V_M1_M1_TU, VLOXSEG5EI16_V, 0x0 }, // 4328
  { PseudoVLOXSEG5EI16_V_M2_M1, VLOXSEG5EI16_V, 0x0 }, // 4329
  { PseudoVLOXSEG5EI16_V_M2_M1_MASK, VLOXSEG5EI16_V, 0x0 }, // 4330
  { PseudoVLOXSEG5EI16_V_M2_M1_TU, VLOXSEG5EI16_V, 0x0 }, // 4331
  { PseudoVLOXSEG5EI16_V_MF2_M1, VLOXSEG5EI16_V, 0x0 }, // 4332
  { PseudoVLOXSEG5EI16_V_MF2_M1_MASK, VLOXSEG5EI16_V, 0x0 }, // 4333
  { PseudoVLOXSEG5EI16_V_MF2_M1_TU, VLOXSEG5EI16_V, 0x0 }, // 4334
  { PseudoVLOXSEG5EI16_V_MF4_M1, VLOXSEG5EI16_V, 0x0 }, // 4335
  { PseudoVLOXSEG5EI16_V_MF4_M1_MASK, VLOXSEG5EI16_V, 0x0 }, // 4336
  { PseudoVLOXSEG5EI16_V_MF4_M1_TU, VLOXSEG5EI16_V, 0x0 }, // 4337
  { PseudoVLOXSEG5EI16_V_MF4_MF8, VLOXSEG5EI16_V, 0x5 }, // 4338
  { PseudoVLOXSEG5EI16_V_MF4_MF8_MASK, VLOXSEG5EI16_V, 0x5 }, // 4339
  { PseudoVLOXSEG5EI16_V_MF4_MF8_TU, VLOXSEG5EI16_V, 0x5 }, // 4340
  { PseudoVLOXSEG5EI16_V_MF2_MF4, VLOXSEG5EI16_V, 0x6 }, // 4341
  { PseudoVLOXSEG5EI16_V_MF2_MF4_MASK, VLOXSEG5EI16_V, 0x6 }, // 4342
  { PseudoVLOXSEG5EI16_V_MF2_MF4_TU, VLOXSEG5EI16_V, 0x6 }, // 4343
  { PseudoVLOXSEG5EI16_V_MF4_MF4, VLOXSEG5EI16_V, 0x6 }, // 4344
  { PseudoVLOXSEG5EI16_V_MF4_MF4_MASK, VLOXSEG5EI16_V, 0x6 }, // 4345
  { PseudoVLOXSEG5EI16_V_MF4_MF4_TU, VLOXSEG5EI16_V, 0x6 }, // 4346
  { PseudoVLOXSEG5EI16_V_M1_MF2, VLOXSEG5EI16_V, 0x7 }, // 4347
  { PseudoVLOXSEG5EI16_V_M1_MF2_MASK, VLOXSEG5EI16_V, 0x7 }, // 4348
  { PseudoVLOXSEG5EI16_V_M1_MF2_TU, VLOXSEG5EI16_V, 0x7 }, // 4349
  { PseudoVLOXSEG5EI16_V_MF2_MF2, VLOXSEG5EI16_V, 0x7 }, // 4350
  { PseudoVLOXSEG5EI16_V_MF2_MF2_MASK, VLOXSEG5EI16_V, 0x7 }, // 4351
  { PseudoVLOXSEG5EI16_V_MF2_MF2_TU, VLOXSEG5EI16_V, 0x7 }, // 4352
  { PseudoVLOXSEG5EI16_V_MF4_MF2, VLOXSEG5EI16_V, 0x7 }, // 4353
  { PseudoVLOXSEG5EI16_V_MF4_MF2_MASK, VLOXSEG5EI16_V, 0x7 }, // 4354
  { PseudoVLOXSEG5EI16_V_MF4_MF2_TU, VLOXSEG5EI16_V, 0x7 }, // 4355
  { PseudoVLOXSEG5EI32_V_M1_M1, VLOXSEG5EI32_V, 0x0 }, // 4356
  { PseudoVLOXSEG5EI32_V_M1_M1_MASK, VLOXSEG5EI32_V, 0x0 }, // 4357
  { PseudoVLOXSEG5EI32_V_M1_M1_TU, VLOXSEG5EI32_V, 0x0 }, // 4358
  { PseudoVLOXSEG5EI32_V_M2_M1, VLOXSEG5EI32_V, 0x0 }, // 4359
  { PseudoVLOXSEG5EI32_V_M2_M1_MASK, VLOXSEG5EI32_V, 0x0 }, // 4360
  { PseudoVLOXSEG5EI32_V_M2_M1_TU, VLOXSEG5EI32_V, 0x0 }, // 4361
  { PseudoVLOXSEG5EI32_V_M4_M1, VLOXSEG5EI32_V, 0x0 }, // 4362
  { PseudoVLOXSEG5EI32_V_M4_M1_MASK, VLOXSEG5EI32_V, 0x0 }, // 4363
  { PseudoVLOXSEG5EI32_V_M4_M1_TU, VLOXSEG5EI32_V, 0x0 }, // 4364
  { PseudoVLOXSEG5EI32_V_MF2_M1, VLOXSEG5EI32_V, 0x0 }, // 4365
  { PseudoVLOXSEG5EI32_V_MF2_M1_MASK, VLOXSEG5EI32_V, 0x0 }, // 4366
  { PseudoVLOXSEG5EI32_V_MF2_M1_TU, VLOXSEG5EI32_V, 0x0 }, // 4367
  { PseudoVLOXSEG5EI32_V_MF2_MF8, VLOXSEG5EI32_V, 0x5 }, // 4368
  { PseudoVLOXSEG5EI32_V_MF2_MF8_MASK, VLOXSEG5EI32_V, 0x5 }, // 4369
  { PseudoVLOXSEG5EI32_V_MF2_MF8_TU, VLOXSEG5EI32_V, 0x5 }, // 4370
  { PseudoVLOXSEG5EI32_V_M1_MF4, VLOXSEG5EI32_V, 0x6 }, // 4371
  { PseudoVLOXSEG5EI32_V_M1_MF4_MASK, VLOXSEG5EI32_V, 0x6 }, // 4372
  { PseudoVLOXSEG5EI32_V_M1_MF4_TU, VLOXSEG5EI32_V, 0x6 }, // 4373
  { PseudoVLOXSEG5EI32_V_MF2_MF4, VLOXSEG5EI32_V, 0x6 }, // 4374
  { PseudoVLOXSEG5EI32_V_MF2_MF4_MASK, VLOXSEG5EI32_V, 0x6 }, // 4375
  { PseudoVLOXSEG5EI32_V_MF2_MF4_TU, VLOXSEG5EI32_V, 0x6 }, // 4376
  { PseudoVLOXSEG5EI32_V_M1_MF2, VLOXSEG5EI32_V, 0x7 }, // 4377
  { PseudoVLOXSEG5EI32_V_M1_MF2_MASK, VLOXSEG5EI32_V, 0x7 }, // 4378
  { PseudoVLOXSEG5EI32_V_M1_MF2_TU, VLOXSEG5EI32_V, 0x7 }, // 4379
  { PseudoVLOXSEG5EI32_V_M2_MF2, VLOXSEG5EI32_V, 0x7 }, // 4380
  { PseudoVLOXSEG5EI32_V_M2_MF2_MASK, VLOXSEG5EI32_V, 0x7 }, // 4381
  { PseudoVLOXSEG5EI32_V_M2_MF2_TU, VLOXSEG5EI32_V, 0x7 }, // 4382
  { PseudoVLOXSEG5EI32_V_MF2_MF2, VLOXSEG5EI32_V, 0x7 }, // 4383
  { PseudoVLOXSEG5EI32_V_MF2_MF2_MASK, VLOXSEG5EI32_V, 0x7 }, // 4384
  { PseudoVLOXSEG5EI32_V_MF2_MF2_TU, VLOXSEG5EI32_V, 0x7 }, // 4385
  { PseudoVLOXSEG5EI64_V_M1_M1, VLOXSEG5EI64_V, 0x0 }, // 4386
  { PseudoVLOXSEG5EI64_V_M1_M1_MASK, VLOXSEG5EI64_V, 0x0 }, // 4387
  { PseudoVLOXSEG5EI64_V_M1_M1_TU, VLOXSEG5EI64_V, 0x0 }, // 4388
  { PseudoVLOXSEG5EI64_V_M2_M1, VLOXSEG5EI64_V, 0x0 }, // 4389
  { PseudoVLOXSEG5EI64_V_M2_M1_MASK, VLOXSEG5EI64_V, 0x0 }, // 4390
  { PseudoVLOXSEG5EI64_V_M2_M1_TU, VLOXSEG5EI64_V, 0x0 }, // 4391
  { PseudoVLOXSEG5EI64_V_M4_M1, VLOXSEG5EI64_V, 0x0 }, // 4392
  { PseudoVLOXSEG5EI64_V_M4_M1_MASK, VLOXSEG5EI64_V, 0x0 }, // 4393
  { PseudoVLOXSEG5EI64_V_M4_M1_TU, VLOXSEG5EI64_V, 0x0 }, // 4394
  { PseudoVLOXSEG5EI64_V_M8_M1, VLOXSEG5EI64_V, 0x0 }, // 4395
  { PseudoVLOXSEG5EI64_V_M8_M1_MASK, VLOXSEG5EI64_V, 0x0 }, // 4396
  { PseudoVLOXSEG5EI64_V_M8_M1_TU, VLOXSEG5EI64_V, 0x0 }, // 4397
  { PseudoVLOXSEG5EI64_V_M1_MF8, VLOXSEG5EI64_V, 0x5 }, // 4398
  { PseudoVLOXSEG5EI64_V_M1_MF8_MASK, VLOXSEG5EI64_V, 0x5 }, // 4399
  { PseudoVLOXSEG5EI64_V_M1_MF8_TU, VLOXSEG5EI64_V, 0x5 }, // 4400
  { PseudoVLOXSEG5EI64_V_M1_MF4, VLOXSEG5EI64_V, 0x6 }, // 4401
  { PseudoVLOXSEG5EI64_V_M1_MF4_MASK, VLOXSEG5EI64_V, 0x6 }, // 4402
  { PseudoVLOXSEG5EI64_V_M1_MF4_TU, VLOXSEG5EI64_V, 0x6 }, // 4403
  { PseudoVLOXSEG5EI64_V_M2_MF4, VLOXSEG5EI64_V, 0x6 }, // 4404
  { PseudoVLOXSEG5EI64_V_M2_MF4_MASK, VLOXSEG5EI64_V, 0x6 }, // 4405
  { PseudoVLOXSEG5EI64_V_M2_MF4_TU, VLOXSEG5EI64_V, 0x6 }, // 4406
  { PseudoVLOXSEG5EI64_V_M1_MF2, VLOXSEG5EI64_V, 0x7 }, // 4407
  { PseudoVLOXSEG5EI64_V_M1_MF2_MASK, VLOXSEG5EI64_V, 0x7 }, // 4408
  { PseudoVLOXSEG5EI64_V_M1_MF2_TU, VLOXSEG5EI64_V, 0x7 }, // 4409
  { PseudoVLOXSEG5EI64_V_M2_MF2, VLOXSEG5EI64_V, 0x7 }, // 4410
  { PseudoVLOXSEG5EI64_V_M2_MF2_MASK, VLOXSEG5EI64_V, 0x7 }, // 4411
  { PseudoVLOXSEG5EI64_V_M2_MF2_TU, VLOXSEG5EI64_V, 0x7 }, // 4412
  { PseudoVLOXSEG5EI64_V_M4_MF2, VLOXSEG5EI64_V, 0x7 }, // 4413
  { PseudoVLOXSEG5EI64_V_M4_MF2_MASK, VLOXSEG5EI64_V, 0x7 }, // 4414
  { PseudoVLOXSEG5EI64_V_M4_MF2_TU, VLOXSEG5EI64_V, 0x7 }, // 4415
  { PseudoVLOXSEG5EI8_V_M1_M1, VLOXSEG5EI8_V, 0x0 }, // 4416
  { PseudoVLOXSEG5EI8_V_M1_M1_MASK, VLOXSEG5EI8_V, 0x0 }, // 4417
  { PseudoVLOXSEG5EI8_V_M1_M1_TU, VLOXSEG5EI8_V, 0x0 }, // 4418
  { PseudoVLOXSEG5EI8_V_MF2_M1, VLOXSEG5EI8_V, 0x0 }, // 4419
  { PseudoVLOXSEG5EI8_V_MF2_M1_MASK, VLOXSEG5EI8_V, 0x0 }, // 4420
  { PseudoVLOXSEG5EI8_V_MF2_M1_TU, VLOXSEG5EI8_V, 0x0 }, // 4421
  { PseudoVLOXSEG5EI8_V_MF4_M1, VLOXSEG5EI8_V, 0x0 }, // 4422
  { PseudoVLOXSEG5EI8_V_MF4_M1_MASK, VLOXSEG5EI8_V, 0x0 }, // 4423
  { PseudoVLOXSEG5EI8_V_MF4_M1_TU, VLOXSEG5EI8_V, 0x0 }, // 4424
  { PseudoVLOXSEG5EI8_V_MF8_M1, VLOXSEG5EI8_V, 0x0 }, // 4425
  { PseudoVLOXSEG5EI8_V_MF8_M1_MASK, VLOXSEG5EI8_V, 0x0 }, // 4426
  { PseudoVLOXSEG5EI8_V_MF8_M1_TU, VLOXSEG5EI8_V, 0x0 }, // 4427
  { PseudoVLOXSEG5EI8_V_MF8_MF8, VLOXSEG5EI8_V, 0x5 }, // 4428
  { PseudoVLOXSEG5EI8_V_MF8_MF8_MASK, VLOXSEG5EI8_V, 0x5 }, // 4429
  { PseudoVLOXSEG5EI8_V_MF8_MF8_TU, VLOXSEG5EI8_V, 0x5 }, // 4430
  { PseudoVLOXSEG5EI8_V_MF4_MF4, VLOXSEG5EI8_V, 0x6 }, // 4431
  { PseudoVLOXSEG5EI8_V_MF4_MF4_MASK, VLOXSEG5EI8_V, 0x6 }, // 4432
  { PseudoVLOXSEG5EI8_V_MF4_MF4_TU, VLOXSEG5EI8_V, 0x6 }, // 4433
  { PseudoVLOXSEG5EI8_V_MF8_MF4, VLOXSEG5EI8_V, 0x6 }, // 4434
  { PseudoVLOXSEG5EI8_V_MF8_MF4_MASK, VLOXSEG5EI8_V, 0x6 }, // 4435
  { PseudoVLOXSEG5EI8_V_MF8_MF4_TU, VLOXSEG5EI8_V, 0x6 }, // 4436
  { PseudoVLOXSEG5EI8_V_MF2_MF2, VLOXSEG5EI8_V, 0x7 }, // 4437
  { PseudoVLOXSEG5EI8_V_MF2_MF2_MASK, VLOXSEG5EI8_V, 0x7 }, // 4438
  { PseudoVLOXSEG5EI8_V_MF2_MF2_TU, VLOXSEG5EI8_V, 0x7 }, // 4439
  { PseudoVLOXSEG5EI8_V_MF4_MF2, VLOXSEG5EI8_V, 0x7 }, // 4440
  { PseudoVLOXSEG5EI8_V_MF4_MF2_MASK, VLOXSEG5EI8_V, 0x7 }, // 4441
  { PseudoVLOXSEG5EI8_V_MF4_MF2_TU, VLOXSEG5EI8_V, 0x7 }, // 4442
  { PseudoVLOXSEG5EI8_V_MF8_MF2, VLOXSEG5EI8_V, 0x7 }, // 4443
  { PseudoVLOXSEG5EI8_V_MF8_MF2_MASK, VLOXSEG5EI8_V, 0x7 }, // 4444
  { PseudoVLOXSEG5EI8_V_MF8_MF2_TU, VLOXSEG5EI8_V, 0x7 }, // 4445
  { PseudoVLOXSEG6EI16_V_M1_M1, VLOXSEG6EI16_V, 0x0 }, // 4446
  { PseudoVLOXSEG6EI16_V_M1_M1_MASK, VLOXSEG6EI16_V, 0x0 }, // 4447
  { PseudoVLOXSEG6EI16_V_M1_M1_TU, VLOXSEG6EI16_V, 0x0 }, // 4448
  { PseudoVLOXSEG6EI16_V_M2_M1, VLOXSEG6EI16_V, 0x0 }, // 4449
  { PseudoVLOXSEG6EI16_V_M2_M1_MASK, VLOXSEG6EI16_V, 0x0 }, // 4450
  { PseudoVLOXSEG6EI16_V_M2_M1_TU, VLOXSEG6EI16_V, 0x0 }, // 4451
  { PseudoVLOXSEG6EI16_V_MF2_M1, VLOXSEG6EI16_V, 0x0 }, // 4452
  { PseudoVLOXSEG6EI16_V_MF2_M1_MASK, VLOXSEG6EI16_V, 0x0 }, // 4453
  { PseudoVLOXSEG6EI16_V_MF2_M1_TU, VLOXSEG6EI16_V, 0x0 }, // 4454
  { PseudoVLOXSEG6EI16_V_MF4_M1, VLOXSEG6EI16_V, 0x0 }, // 4455
  { PseudoVLOXSEG6EI16_V_MF4_M1_MASK, VLOXSEG6EI16_V, 0x0 }, // 4456
  { PseudoVLOXSEG6EI16_V_MF4_M1_TU, VLOXSEG6EI16_V, 0x0 }, // 4457
  { PseudoVLOXSEG6EI16_V_MF4_MF8, VLOXSEG6EI16_V, 0x5 }, // 4458
  { PseudoVLOXSEG6EI16_V_MF4_MF8_MASK, VLOXSEG6EI16_V, 0x5 }, // 4459
  { PseudoVLOXSEG6EI16_V_MF4_MF8_TU, VLOXSEG6EI16_V, 0x5 }, // 4460
  { PseudoVLOXSEG6EI16_V_MF2_MF4, VLOXSEG6EI16_V, 0x6 }, // 4461
  { PseudoVLOXSEG6EI16_V_MF2_MF4_MASK, VLOXSEG6EI16_V, 0x6 }, // 4462
  { PseudoVLOXSEG6EI16_V_MF2_MF4_TU, VLOXSEG6EI16_V, 0x6 }, // 4463
  { PseudoVLOXSEG6EI16_V_MF4_MF4, VLOXSEG6EI16_V, 0x6 }, // 4464
  { PseudoVLOXSEG6EI16_V_MF4_MF4_MASK, VLOXSEG6EI16_V, 0x6 }, // 4465
  { PseudoVLOXSEG6EI16_V_MF4_MF4_TU, VLOXSEG6EI16_V, 0x6 }, // 4466
  { PseudoVLOXSEG6EI16_V_M1_MF2, VLOXSEG6EI16_V, 0x7 }, // 4467
  { PseudoVLOXSEG6EI16_V_M1_MF2_MASK, VLOXSEG6EI16_V, 0x7 }, // 4468
  { PseudoVLOXSEG6EI16_V_M1_MF2_TU, VLOXSEG6EI16_V, 0x7 }, // 4469
  { PseudoVLOXSEG6EI16_V_MF2_MF2, VLOXSEG6EI16_V, 0x7 }, // 4470
  { PseudoVLOXSEG6EI16_V_MF2_MF2_MASK, VLOXSEG6EI16_V, 0x7 }, // 4471
  { PseudoVLOXSEG6EI16_V_MF2_MF2_TU, VLOXSEG6EI16_V, 0x7 }, // 4472
  { PseudoVLOXSEG6EI16_V_MF4_MF2, VLOXSEG6EI16_V, 0x7 }, // 4473
  { PseudoVLOXSEG6EI16_V_MF4_MF2_MASK, VLOXSEG6EI16_V, 0x7 }, // 4474
  { PseudoVLOXSEG6EI16_V_MF4_MF2_TU, VLOXSEG6EI16_V, 0x7 }, // 4475
  { PseudoVLOXSEG6EI32_V_M1_M1, VLOXSEG6EI32_V, 0x0 }, // 4476
  { PseudoVLOXSEG6EI32_V_M1_M1_MASK, VLOXSEG6EI32_V, 0x0 }, // 4477
  { PseudoVLOXSEG6EI32_V_M1_M1_TU, VLOXSEG6EI32_V, 0x0 }, // 4478
  { PseudoVLOXSEG6EI32_V_M2_M1, VLOXSEG6EI32_V, 0x0 }, // 4479
  { PseudoVLOXSEG6EI32_V_M2_M1_MASK, VLOXSEG6EI32_V, 0x0 }, // 4480
  { PseudoVLOXSEG6EI32_V_M2_M1_TU, VLOXSEG6EI32_V, 0x0 }, // 4481
  { PseudoVLOXSEG6EI32_V_M4_M1, VLOXSEG6EI32_V, 0x0 }, // 4482
  { PseudoVLOXSEG6EI32_V_M4_M1_MASK, VLOXSEG6EI32_V, 0x0 }, // 4483
  { PseudoVLOXSEG6EI32_V_M4_M1_TU, VLOXSEG6EI32_V, 0x0 }, // 4484
  { PseudoVLOXSEG6EI32_V_MF2_M1, VLOXSEG6EI32_V, 0x0 }, // 4485
  { PseudoVLOXSEG6EI32_V_MF2_M1_MASK, VLOXSEG6EI32_V, 0x0 }, // 4486
  { PseudoVLOXSEG6EI32_V_MF2_M1_TU, VLOXSEG6EI32_V, 0x0 }, // 4487
  { PseudoVLOXSEG6EI32_V_MF2_MF8, VLOXSEG6EI32_V, 0x5 }, // 4488
  { PseudoVLOXSEG6EI32_V_MF2_MF8_MASK, VLOXSEG6EI32_V, 0x5 }, // 4489
  { PseudoVLOXSEG6EI32_V_MF2_MF8_TU, VLOXSEG6EI32_V, 0x5 }, // 4490
  { PseudoVLOXSEG6EI32_V_M1_MF4, VLOXSEG6EI32_V, 0x6 }, // 4491
  { PseudoVLOXSEG6EI32_V_M1_MF4_MASK, VLOXSEG6EI32_V, 0x6 }, // 4492
  { PseudoVLOXSEG6EI32_V_M1_MF4_TU, VLOXSEG6EI32_V, 0x6 }, // 4493
  { PseudoVLOXSEG6EI32_V_MF2_MF4, VLOXSEG6EI32_V, 0x6 }, // 4494
  { PseudoVLOXSEG6EI32_V_MF2_MF4_MASK, VLOXSEG6EI32_V, 0x6 }, // 4495
  { PseudoVLOXSEG6EI32_V_MF2_MF4_TU, VLOXSEG6EI32_V, 0x6 }, // 4496
  { PseudoVLOXSEG6EI32_V_M1_MF2, VLOXSEG6EI32_V, 0x7 }, // 4497
  { PseudoVLOXSEG6EI32_V_M1_MF2_MASK, VLOXSEG6EI32_V, 0x7 }, // 4498
  { PseudoVLOXSEG6EI32_V_M1_MF2_TU, VLOXSEG6EI32_V, 0x7 }, // 4499
  { PseudoVLOXSEG6EI32_V_M2_MF2, VLOXSEG6EI32_V, 0x7 }, // 4500
  { PseudoVLOXSEG6EI32_V_M2_MF2_MASK, VLOXSEG6EI32_V, 0x7 }, // 4501
  { PseudoVLOXSEG6EI32_V_M2_MF2_TU, VLOXSEG6EI32_V, 0x7 }, // 4502
  { PseudoVLOXSEG6EI32_V_MF2_MF2, VLOXSEG6EI32_V, 0x7 }, // 4503
  { PseudoVLOXSEG6EI32_V_MF2_MF2_MASK, VLOXSEG6EI32_V, 0x7 }, // 4504
  { PseudoVLOXSEG6EI32_V_MF2_MF2_TU, VLOXSEG6EI32_V, 0x7 }, // 4505
  { PseudoVLOXSEG6EI64_V_M1_M1, VLOXSEG6EI64_V, 0x0 }, // 4506
  { PseudoVLOXSEG6EI64_V_M1_M1_MASK, VLOXSEG6EI64_V, 0x0 }, // 4507
  { PseudoVLOXSEG6EI64_V_M1_M1_TU, VLOXSEG6EI64_V, 0x0 }, // 4508
  { PseudoVLOXSEG6EI64_V_M2_M1, VLOXSEG6EI64_V, 0x0 }, // 4509
  { PseudoVLOXSEG6EI64_V_M2_M1_MASK, VLOXSEG6EI64_V, 0x0 }, // 4510
  { PseudoVLOXSEG6EI64_V_M2_M1_TU, VLOXSEG6EI64_V, 0x0 }, // 4511
  { PseudoVLOXSEG6EI64_V_M4_M1, VLOXSEG6EI64_V, 0x0 }, // 4512
  { PseudoVLOXSEG6EI64_V_M4_M1_MASK, VLOXSEG6EI64_V, 0x0 }, // 4513
  { PseudoVLOXSEG6EI64_V_M4_M1_TU, VLOXSEG6EI64_V, 0x0 }, // 4514
  { PseudoVLOXSEG6EI64_V_M8_M1, VLOXSEG6EI64_V, 0x0 }, // 4515
  { PseudoVLOXSEG6EI64_V_M8_M1_MASK, VLOXSEG6EI64_V, 0x0 }, // 4516
  { PseudoVLOXSEG6EI64_V_M8_M1_TU, VLOXSEG6EI64_V, 0x0 }, // 4517
  { PseudoVLOXSEG6EI64_V_M1_MF8, VLOXSEG6EI64_V, 0x5 }, // 4518
  { PseudoVLOXSEG6EI64_V_M1_MF8_MASK, VLOXSEG6EI64_V, 0x5 }, // 4519
  { PseudoVLOXSEG6EI64_V_M1_MF8_TU, VLOXSEG6EI64_V, 0x5 }, // 4520
  { PseudoVLOXSEG6EI64_V_M1_MF4, VLOXSEG6EI64_V, 0x6 }, // 4521
  { PseudoVLOXSEG6EI64_V_M1_MF4_MASK, VLOXSEG6EI64_V, 0x6 }, // 4522
  { PseudoVLOXSEG6EI64_V_M1_MF4_TU, VLOXSEG6EI64_V, 0x6 }, // 4523
  { PseudoVLOXSEG6EI64_V_M2_MF4, VLOXSEG6EI64_V, 0x6 }, // 4524
  { PseudoVLOXSEG6EI64_V_M2_MF4_MASK, VLOXSEG6EI64_V, 0x6 }, // 4525
  { PseudoVLOXSEG6EI64_V_M2_MF4_TU, VLOXSEG6EI64_V, 0x6 }, // 4526
  { PseudoVLOXSEG6EI64_V_M1_MF2, VLOXSEG6EI64_V, 0x7 }, // 4527
  { PseudoVLOXSEG6EI64_V_M1_MF2_MASK, VLOXSEG6EI64_V, 0x7 }, // 4528
  { PseudoVLOXSEG6EI64_V_M1_MF2_TU, VLOXSEG6EI64_V, 0x7 }, // 4529
  { PseudoVLOXSEG6EI64_V_M2_MF2, VLOXSEG6EI64_V, 0x7 }, // 4530
  { PseudoVLOXSEG6EI64_V_M2_MF2_MASK, VLOXSEG6EI64_V, 0x7 }, // 4531
  { PseudoVLOXSEG6EI64_V_M2_MF2_TU, VLOXSEG6EI64_V, 0x7 }, // 4532
  { PseudoVLOXSEG6EI64_V_M4_MF2, VLOXSEG6EI64_V, 0x7 }, // 4533
  { PseudoVLOXSEG6EI64_V_M4_MF2_MASK, VLOXSEG6EI64_V, 0x7 }, // 4534
  { PseudoVLOXSEG6EI64_V_M4_MF2_TU, VLOXSEG6EI64_V, 0x7 }, // 4535
  { PseudoVLOXSEG6EI8_V_M1_M1, VLOXSEG6EI8_V, 0x0 }, // 4536
  { PseudoVLOXSEG6EI8_V_M1_M1_MASK, VLOXSEG6EI8_V, 0x0 }, // 4537
  { PseudoVLOXSEG6EI8_V_M1_M1_TU, VLOXSEG6EI8_V, 0x0 }, // 4538
  { PseudoVLOXSEG6EI8_V_MF2_M1, VLOXSEG6EI8_V, 0x0 }, // 4539
  { PseudoVLOXSEG6EI8_V_MF2_M1_MASK, VLOXSEG6EI8_V, 0x0 }, // 4540
  { PseudoVLOXSEG6EI8_V_MF2_M1_TU, VLOXSEG6EI8_V, 0x0 }, // 4541
  { PseudoVLOXSEG6EI8_V_MF4_M1, VLOXSEG6EI8_V, 0x0 }, // 4542
  { PseudoVLOXSEG6EI8_V_MF4_M1_MASK, VLOXSEG6EI8_V, 0x0 }, // 4543
  { PseudoVLOXSEG6EI8_V_MF4_M1_TU, VLOXSEG6EI8_V, 0x0 }, // 4544
  { PseudoVLOXSEG6EI8_V_MF8_M1, VLOXSEG6EI8_V, 0x0 }, // 4545
  { PseudoVLOXSEG6EI8_V_MF8_M1_MASK, VLOXSEG6EI8_V, 0x0 }, // 4546
  { PseudoVLOXSEG6EI8_V_MF8_M1_TU, VLOXSEG6EI8_V, 0x0 }, // 4547
  { PseudoVLOXSEG6EI8_V_MF8_MF8, VLOXSEG6EI8_V, 0x5 }, // 4548
  { PseudoVLOXSEG6EI8_V_MF8_MF8_MASK, VLOXSEG6EI8_V, 0x5 }, // 4549
  { PseudoVLOXSEG6EI8_V_MF8_MF8_TU, VLOXSEG6EI8_V, 0x5 }, // 4550
  { PseudoVLOXSEG6EI8_V_MF4_MF4, VLOXSEG6EI8_V, 0x6 }, // 4551
  { PseudoVLOXSEG6EI8_V_MF4_MF4_MASK, VLOXSEG6EI8_V, 0x6 }, // 4552
  { PseudoVLOXSEG6EI8_V_MF4_MF4_TU, VLOXSEG6EI8_V, 0x6 }, // 4553
  { PseudoVLOXSEG6EI8_V_MF8_MF4, VLOXSEG6EI8_V, 0x6 }, // 4554
  { PseudoVLOXSEG6EI8_V_MF8_MF4_MASK, VLOXSEG6EI8_V, 0x6 }, // 4555
  { PseudoVLOXSEG6EI8_V_MF8_MF4_TU, VLOXSEG6EI8_V, 0x6 }, // 4556
  { PseudoVLOXSEG6EI8_V_MF2_MF2, VLOXSEG6EI8_V, 0x7 }, // 4557
  { PseudoVLOXSEG6EI8_V_MF2_MF2_MASK, VLOXSEG6EI8_V, 0x7 }, // 4558
  { PseudoVLOXSEG6EI8_V_MF2_MF2_TU, VLOXSEG6EI8_V, 0x7 }, // 4559
  { PseudoVLOXSEG6EI8_V_MF4_MF2, VLOXSEG6EI8_V, 0x7 }, // 4560
  { PseudoVLOXSEG6EI8_V_MF4_MF2_MASK, VLOXSEG6EI8_V, 0x7 }, // 4561
  { PseudoVLOXSEG6EI8_V_MF4_MF2_TU, VLOXSEG6EI8_V, 0x7 }, // 4562
  { PseudoVLOXSEG6EI8_V_MF8_MF2, VLOXSEG6EI8_V, 0x7 }, // 4563
  { PseudoVLOXSEG6EI8_V_MF8_MF2_MASK, VLOXSEG6EI8_V, 0x7 }, // 4564
  { PseudoVLOXSEG6EI8_V_MF8_MF2_TU, VLOXSEG6EI8_V, 0x7 }, // 4565
  { PseudoVLOXSEG7EI16_V_M1_M1, VLOXSEG7EI16_V, 0x0 }, // 4566
  { PseudoVLOXSEG7EI16_V_M1_M1_MASK, VLOXSEG7EI16_V, 0x0 }, // 4567
  { PseudoVLOXSEG7EI16_V_M1_M1_TU, VLOXSEG7EI16_V, 0x0 }, // 4568
  { PseudoVLOXSEG7EI16_V_M2_M1, VLOXSEG7EI16_V, 0x0 }, // 4569
  { PseudoVLOXSEG7EI16_V_M2_M1_MASK, VLOXSEG7EI16_V, 0x0 }, // 4570
  { PseudoVLOXSEG7EI16_V_M2_M1_TU, VLOXSEG7EI16_V, 0x0 }, // 4571
  { PseudoVLOXSEG7EI16_V_MF2_M1, VLOXSEG7EI16_V, 0x0 }, // 4572
  { PseudoVLOXSEG7EI16_V_MF2_M1_MASK, VLOXSEG7EI16_V, 0x0 }, // 4573
  { PseudoVLOXSEG7EI16_V_MF2_M1_TU, VLOXSEG7EI16_V, 0x0 }, // 4574
  { PseudoVLOXSEG7EI16_V_MF4_M1, VLOXSEG7EI16_V, 0x0 }, // 4575
  { PseudoVLOXSEG7EI16_V_MF4_M1_MASK, VLOXSEG7EI16_V, 0x0 }, // 4576
  { PseudoVLOXSEG7EI16_V_MF4_M1_TU, VLOXSEG7EI16_V, 0x0 }, // 4577
  { PseudoVLOXSEG7EI16_V_MF4_MF8, VLOXSEG7EI16_V, 0x5 }, // 4578
  { PseudoVLOXSEG7EI16_V_MF4_MF8_MASK, VLOXSEG7EI16_V, 0x5 }, // 4579
  { PseudoVLOXSEG7EI16_V_MF4_MF8_TU, VLOXSEG7EI16_V, 0x5 }, // 4580
  { PseudoVLOXSEG7EI16_V_MF2_MF4, VLOXSEG7EI16_V, 0x6 }, // 4581
  { PseudoVLOXSEG7EI16_V_MF2_MF4_MASK, VLOXSEG7EI16_V, 0x6 }, // 4582
  { PseudoVLOXSEG7EI16_V_MF2_MF4_TU, VLOXSEG7EI16_V, 0x6 }, // 4583
  { PseudoVLOXSEG7EI16_V_MF4_MF4, VLOXSEG7EI16_V, 0x6 }, // 4584
  { PseudoVLOXSEG7EI16_V_MF4_MF4_MASK, VLOXSEG7EI16_V, 0x6 }, // 4585
  { PseudoVLOXSEG7EI16_V_MF4_MF4_TU, VLOXSEG7EI16_V, 0x6 }, // 4586
  { PseudoVLOXSEG7EI16_V_M1_MF2, VLOXSEG7EI16_V, 0x7 }, // 4587
  { PseudoVLOXSEG7EI16_V_M1_MF2_MASK, VLOXSEG7EI16_V, 0x7 }, // 4588
  { PseudoVLOXSEG7EI16_V_M1_MF2_TU, VLOXSEG7EI16_V, 0x7 }, // 4589
  { PseudoVLOXSEG7EI16_V_MF2_MF2, VLOXSEG7EI16_V, 0x7 }, // 4590
  { PseudoVLOXSEG7EI16_V_MF2_MF2_MASK, VLOXSEG7EI16_V, 0x7 }, // 4591
  { PseudoVLOXSEG7EI16_V_MF2_MF2_TU, VLOXSEG7EI16_V, 0x7 }, // 4592
  { PseudoVLOXSEG7EI16_V_MF4_MF2, VLOXSEG7EI16_V, 0x7 }, // 4593
  { PseudoVLOXSEG7EI16_V_MF4_MF2_MASK, VLOXSEG7EI16_V, 0x7 }, // 4594
  { PseudoVLOXSEG7EI16_V_MF4_MF2_TU, VLOXSEG7EI16_V, 0x7 }, // 4595
  { PseudoVLOXSEG7EI32_V_M1_M1, VLOXSEG7EI32_V, 0x0 }, // 4596
  { PseudoVLOXSEG7EI32_V_M1_M1_MASK, VLOXSEG7EI32_V, 0x0 }, // 4597
  { PseudoVLOXSEG7EI32_V_M1_M1_TU, VLOXSEG7EI32_V, 0x0 }, // 4598
  { PseudoVLOXSEG7EI32_V_M2_M1, VLOXSEG7EI32_V, 0x0 }, // 4599
  { PseudoVLOXSEG7EI32_V_M2_M1_MASK, VLOXSEG7EI32_V, 0x0 }, // 4600
  { PseudoVLOXSEG7EI32_V_M2_M1_TU, VLOXSEG7EI32_V, 0x0 }, // 4601
  { PseudoVLOXSEG7EI32_V_M4_M1, VLOXSEG7EI32_V, 0x0 }, // 4602
  { PseudoVLOXSEG7EI32_V_M4_M1_MASK, VLOXSEG7EI32_V, 0x0 }, // 4603
  { PseudoVLOXSEG7EI32_V_M4_M1_TU, VLOXSEG7EI32_V, 0x0 }, // 4604
  { PseudoVLOXSEG7EI32_V_MF2_M1, VLOXSEG7EI32_V, 0x0 }, // 4605
  { PseudoVLOXSEG7EI32_V_MF2_M1_MASK, VLOXSEG7EI32_V, 0x0 }, // 4606
  { PseudoVLOXSEG7EI32_V_MF2_M1_TU, VLOXSEG7EI32_V, 0x0 }, // 4607
  { PseudoVLOXSEG7EI32_V_MF2_MF8, VLOXSEG7EI32_V, 0x5 }, // 4608
  { PseudoVLOXSEG7EI32_V_MF2_MF8_MASK, VLOXSEG7EI32_V, 0x5 }, // 4609
  { PseudoVLOXSEG7EI32_V_MF2_MF8_TU, VLOXSEG7EI32_V, 0x5 }, // 4610
  { PseudoVLOXSEG7EI32_V_M1_MF4, VLOXSEG7EI32_V, 0x6 }, // 4611
  { PseudoVLOXSEG7EI32_V_M1_MF4_MASK, VLOXSEG7EI32_V, 0x6 }, // 4612
  { PseudoVLOXSEG7EI32_V_M1_MF4_TU, VLOXSEG7EI32_V, 0x6 }, // 4613
  { PseudoVLOXSEG7EI32_V_MF2_MF4, VLOXSEG7EI32_V, 0x6 }, // 4614
  { PseudoVLOXSEG7EI32_V_MF2_MF4_MASK, VLOXSEG7EI32_V, 0x6 }, // 4615
  { PseudoVLOXSEG7EI32_V_MF2_MF4_TU, VLOXSEG7EI32_V, 0x6 }, // 4616
  { PseudoVLOXSEG7EI32_V_M1_MF2, VLOXSEG7EI32_V, 0x7 }, // 4617
  { PseudoVLOXSEG7EI32_V_M1_MF2_MASK, VLOXSEG7EI32_V, 0x7 }, // 4618
  { PseudoVLOXSEG7EI32_V_M1_MF2_TU, VLOXSEG7EI32_V, 0x7 }, // 4619
  { PseudoVLOXSEG7EI32_V_M2_MF2, VLOXSEG7EI32_V, 0x7 }, // 4620
  { PseudoVLOXSEG7EI32_V_M2_MF2_MASK, VLOXSEG7EI32_V, 0x7 }, // 4621
  { PseudoVLOXSEG7EI32_V_M2_MF2_TU, VLOXSEG7EI32_V, 0x7 }, // 4622
  { PseudoVLOXSEG7EI32_V_MF2_MF2, VLOXSEG7EI32_V, 0x7 }, // 4623
  { PseudoVLOXSEG7EI32_V_MF2_MF2_MASK, VLOXSEG7EI32_V, 0x7 }, // 4624
  { PseudoVLOXSEG7EI32_V_MF2_MF2_TU, VLOXSEG7EI32_V, 0x7 }, // 4625
  { PseudoVLOXSEG7EI64_V_M1_M1, VLOXSEG7EI64_V, 0x0 }, // 4626
  { PseudoVLOXSEG7EI64_V_M1_M1_MASK, VLOXSEG7EI64_V, 0x0 }, // 4627
  { PseudoVLOXSEG7EI64_V_M1_M1_TU, VLOXSEG7EI64_V, 0x0 }, // 4628
  { PseudoVLOXSEG7EI64_V_M2_M1, VLOXSEG7EI64_V, 0x0 }, // 4629
  { PseudoVLOXSEG7EI64_V_M2_M1_MASK, VLOXSEG7EI64_V, 0x0 }, // 4630
  { PseudoVLOXSEG7EI64_V_M2_M1_TU, VLOXSEG7EI64_V, 0x0 }, // 4631
  { PseudoVLOXSEG7EI64_V_M4_M1, VLOXSEG7EI64_V, 0x0 }, // 4632
  { PseudoVLOXSEG7EI64_V_M4_M1_MASK, VLOXSEG7EI64_V, 0x0 }, // 4633
  { PseudoVLOXSEG7EI64_V_M4_M1_TU, VLOXSEG7EI64_V, 0x0 }, // 4634
  { PseudoVLOXSEG7EI64_V_M8_M1, VLOXSEG7EI64_V, 0x0 }, // 4635
  { PseudoVLOXSEG7EI64_V_M8_M1_MASK, VLOXSEG7EI64_V, 0x0 }, // 4636
  { PseudoVLOXSEG7EI64_V_M8_M1_TU, VLOXSEG7EI64_V, 0x0 }, // 4637
  { PseudoVLOXSEG7EI64_V_M1_MF8, VLOXSEG7EI64_V, 0x5 }, // 4638
  { PseudoVLOXSEG7EI64_V_M1_MF8_MASK, VLOXSEG7EI64_V, 0x5 }, // 4639
  { PseudoVLOXSEG7EI64_V_M1_MF8_TU, VLOXSEG7EI64_V, 0x5 }, // 4640
  { PseudoVLOXSEG7EI64_V_M1_MF4, VLOXSEG7EI64_V, 0x6 }, // 4641
  { PseudoVLOXSEG7EI64_V_M1_MF4_MASK, VLOXSEG7EI64_V, 0x6 }, // 4642
  { PseudoVLOXSEG7EI64_V_M1_MF4_TU, VLOXSEG7EI64_V, 0x6 }, // 4643
  { PseudoVLOXSEG7EI64_V_M2_MF4, VLOXSEG7EI64_V, 0x6 }, // 4644
  { PseudoVLOXSEG7EI64_V_M2_MF4_MASK, VLOXSEG7EI64_V, 0x6 }, // 4645
  { PseudoVLOXSEG7EI64_V_M2_MF4_TU, VLOXSEG7EI64_V, 0x6 }, // 4646
  { PseudoVLOXSEG7EI64_V_M1_MF2, VLOXSEG7EI64_V, 0x7 }, // 4647
  { PseudoVLOXSEG7EI64_V_M1_MF2_MASK, VLOXSEG7EI64_V, 0x7 }, // 4648
  { PseudoVLOXSEG7EI64_V_M1_MF2_TU, VLOXSEG7EI64_V, 0x7 }, // 4649
  { PseudoVLOXSEG7EI64_V_M2_MF2, VLOXSEG7EI64_V, 0x7 }, // 4650
  { PseudoVLOXSEG7EI64_V_M2_MF2_MASK, VLOXSEG7EI64_V, 0x7 }, // 4651
  { PseudoVLOXSEG7EI64_V_M2_MF2_TU, VLOXSEG7EI64_V, 0x7 }, // 4652
  { PseudoVLOXSEG7EI64_V_M4_MF2, VLOXSEG7EI64_V, 0x7 }, // 4653
  { PseudoVLOXSEG7EI64_V_M4_MF2_MASK, VLOXSEG7EI64_V, 0x7 }, // 4654
  { PseudoVLOXSEG7EI64_V_M4_MF2_TU, VLOXSEG7EI64_V, 0x7 }, // 4655
  { PseudoVLOXSEG7EI8_V_M1_M1, VLOXSEG7EI8_V, 0x0 }, // 4656
  { PseudoVLOXSEG7EI8_V_M1_M1_MASK, VLOXSEG7EI8_V, 0x0 }, // 4657
  { PseudoVLOXSEG7EI8_V_M1_M1_TU, VLOXSEG7EI8_V, 0x0 }, // 4658
  { PseudoVLOXSEG7EI8_V_MF2_M1, VLOXSEG7EI8_V, 0x0 }, // 4659
  { PseudoVLOXSEG7EI8_V_MF2_M1_MASK, VLOXSEG7EI8_V, 0x0 }, // 4660
  { PseudoVLOXSEG7EI8_V_MF2_M1_TU, VLOXSEG7EI8_V, 0x0 }, // 4661
  { PseudoVLOXSEG7EI8_V_MF4_M1, VLOXSEG7EI8_V, 0x0 }, // 4662
  { PseudoVLOXSEG7EI8_V_MF4_M1_MASK, VLOXSEG7EI8_V, 0x0 }, // 4663
  { PseudoVLOXSEG7EI8_V_MF4_M1_TU, VLOXSEG7EI8_V, 0x0 }, // 4664
  { PseudoVLOXSEG7EI8_V_MF8_M1, VLOXSEG7EI8_V, 0x0 }, // 4665
  { PseudoVLOXSEG7EI8_V_MF8_M1_MASK, VLOXSEG7EI8_V, 0x0 }, // 4666
  { PseudoVLOXSEG7EI8_V_MF8_M1_TU, VLOXSEG7EI8_V, 0x0 }, // 4667
  { PseudoVLOXSEG7EI8_V_MF8_MF8, VLOXSEG7EI8_V, 0x5 }, // 4668
  { PseudoVLOXSEG7EI8_V_MF8_MF8_MASK, VLOXSEG7EI8_V, 0x5 }, // 4669
  { PseudoVLOXSEG7EI8_V_MF8_MF8_TU, VLOXSEG7EI8_V, 0x5 }, // 4670
  { PseudoVLOXSEG7EI8_V_MF4_MF4, VLOXSEG7EI8_V, 0x6 }, // 4671
  { PseudoVLOXSEG7EI8_V_MF4_MF4_MASK, VLOXSEG7EI8_V, 0x6 }, // 4672
  { PseudoVLOXSEG7EI8_V_MF4_MF4_TU, VLOXSEG7EI8_V, 0x6 }, // 4673
  { PseudoVLOXSEG7EI8_V_MF8_MF4, VLOXSEG7EI8_V, 0x6 }, // 4674
  { PseudoVLOXSEG7EI8_V_MF8_MF4_MASK, VLOXSEG7EI8_V, 0x6 }, // 4675
  { PseudoVLOXSEG7EI8_V_MF8_MF4_TU, VLOXSEG7EI8_V, 0x6 }, // 4676
  { PseudoVLOXSEG7EI8_V_MF2_MF2, VLOXSEG7EI8_V, 0x7 }, // 4677
  { PseudoVLOXSEG7EI8_V_MF2_MF2_MASK, VLOXSEG7EI8_V, 0x7 }, // 4678
  { PseudoVLOXSEG7EI8_V_MF2_MF2_TU, VLOXSEG7EI8_V, 0x7 }, // 4679
  { PseudoVLOXSEG7EI8_V_MF4_MF2, VLOXSEG7EI8_V, 0x7 }, // 4680
  { PseudoVLOXSEG7EI8_V_MF4_MF2_MASK, VLOXSEG7EI8_V, 0x7 }, // 4681
  { PseudoVLOXSEG7EI8_V_MF4_MF2_TU, VLOXSEG7EI8_V, 0x7 }, // 4682
  { PseudoVLOXSEG7EI8_V_MF8_MF2, VLOXSEG7EI8_V, 0x7 }, // 4683
  { PseudoVLOXSEG7EI8_V_MF8_MF2_MASK, VLOXSEG7EI8_V, 0x7 }, // 4684
  { PseudoVLOXSEG7EI8_V_MF8_MF2_TU, VLOXSEG7EI8_V, 0x7 }, // 4685
  { PseudoVLOXSEG8EI16_V_M1_M1, VLOXSEG8EI16_V, 0x0 }, // 4686
  { PseudoVLOXSEG8EI16_V_M1_M1_MASK, VLOXSEG8EI16_V, 0x0 }, // 4687
  { PseudoVLOXSEG8EI16_V_M1_M1_TU, VLOXSEG8EI16_V, 0x0 }, // 4688
  { PseudoVLOXSEG8EI16_V_M2_M1, VLOXSEG8EI16_V, 0x0 }, // 4689
  { PseudoVLOXSEG8EI16_V_M2_M1_MASK, VLOXSEG8EI16_V, 0x0 }, // 4690
  { PseudoVLOXSEG8EI16_V_M2_M1_TU, VLOXSEG8EI16_V, 0x0 }, // 4691
  { PseudoVLOXSEG8EI16_V_MF2_M1, VLOXSEG8EI16_V, 0x0 }, // 4692
  { PseudoVLOXSEG8EI16_V_MF2_M1_MASK, VLOXSEG8EI16_V, 0x0 }, // 4693
  { PseudoVLOXSEG8EI16_V_MF2_M1_TU, VLOXSEG8EI16_V, 0x0 }, // 4694
  { PseudoVLOXSEG8EI16_V_MF4_M1, VLOXSEG8EI16_V, 0x0 }, // 4695
  { PseudoVLOXSEG8EI16_V_MF4_M1_MASK, VLOXSEG8EI16_V, 0x0 }, // 4696
  { PseudoVLOXSEG8EI16_V_MF4_M1_TU, VLOXSEG8EI16_V, 0x0 }, // 4697
  { PseudoVLOXSEG8EI16_V_MF4_MF8, VLOXSEG8EI16_V, 0x5 }, // 4698
  { PseudoVLOXSEG8EI16_V_MF4_MF8_MASK, VLOXSEG8EI16_V, 0x5 }, // 4699
  { PseudoVLOXSEG8EI16_V_MF4_MF8_TU, VLOXSEG8EI16_V, 0x5 }, // 4700
  { PseudoVLOXSEG8EI16_V_MF2_MF4, VLOXSEG8EI16_V, 0x6 }, // 4701
  { PseudoVLOXSEG8EI16_V_MF2_MF4_MASK, VLOXSEG8EI16_V, 0x6 }, // 4702
  { PseudoVLOXSEG8EI16_V_MF2_MF4_TU, VLOXSEG8EI16_V, 0x6 }, // 4703
  { PseudoVLOXSEG8EI16_V_MF4_MF4, VLOXSEG8EI16_V, 0x6 }, // 4704
  { PseudoVLOXSEG8EI16_V_MF4_MF4_MASK, VLOXSEG8EI16_V, 0x6 }, // 4705
  { PseudoVLOXSEG8EI16_V_MF4_MF4_TU, VLOXSEG8EI16_V, 0x6 }, // 4706
  { PseudoVLOXSEG8EI16_V_M1_MF2, VLOXSEG8EI16_V, 0x7 }, // 4707
  { PseudoVLOXSEG8EI16_V_M1_MF2_MASK, VLOXSEG8EI16_V, 0x7 }, // 4708
  { PseudoVLOXSEG8EI16_V_M1_MF2_TU, VLOXSEG8EI16_V, 0x7 }, // 4709
  { PseudoVLOXSEG8EI16_V_MF2_MF2, VLOXSEG8EI16_V, 0x7 }, // 4710
  { PseudoVLOXSEG8EI16_V_MF2_MF2_MASK, VLOXSEG8EI16_V, 0x7 }, // 4711
  { PseudoVLOXSEG8EI16_V_MF2_MF2_TU, VLOXSEG8EI16_V, 0x7 }, // 4712
  { PseudoVLOXSEG8EI16_V_MF4_MF2, VLOXSEG8EI16_V, 0x7 }, // 4713
  { PseudoVLOXSEG8EI16_V_MF4_MF2_MASK, VLOXSEG8EI16_V, 0x7 }, // 4714
  { PseudoVLOXSEG8EI16_V_MF4_MF2_TU, VLOXSEG8EI16_V, 0x7 }, // 4715
  { PseudoVLOXSEG8EI32_V_M1_M1, VLOXSEG8EI32_V, 0x0 }, // 4716
  { PseudoVLOXSEG8EI32_V_M1_M1_MASK, VLOXSEG8EI32_V, 0x0 }, // 4717
  { PseudoVLOXSEG8EI32_V_M1_M1_TU, VLOXSEG8EI32_V, 0x0 }, // 4718
  { PseudoVLOXSEG8EI32_V_M2_M1, VLOXSEG8EI32_V, 0x0 }, // 4719
  { PseudoVLOXSEG8EI32_V_M2_M1_MASK, VLOXSEG8EI32_V, 0x0 }, // 4720
  { PseudoVLOXSEG8EI32_V_M2_M1_TU, VLOXSEG8EI32_V, 0x0 }, // 4721
  { PseudoVLOXSEG8EI32_V_M4_M1, VLOXSEG8EI32_V, 0x0 }, // 4722
  { PseudoVLOXSEG8EI32_V_M4_M1_MASK, VLOXSEG8EI32_V, 0x0 }, // 4723
  { PseudoVLOXSEG8EI32_V_M4_M1_TU, VLOXSEG8EI32_V, 0x0 }, // 4724
  { PseudoVLOXSEG8EI32_V_MF2_M1, VLOXSEG8EI32_V, 0x0 }, // 4725
  { PseudoVLOXSEG8EI32_V_MF2_M1_MASK, VLOXSEG8EI32_V, 0x0 }, // 4726
  { PseudoVLOXSEG8EI32_V_MF2_M1_TU, VLOXSEG8EI32_V, 0x0 }, // 4727
  { PseudoVLOXSEG8EI32_V_MF2_MF8, VLOXSEG8EI32_V, 0x5 }, // 4728
  { PseudoVLOXSEG8EI32_V_MF2_MF8_MASK, VLOXSEG8EI32_V, 0x5 }, // 4729
  { PseudoVLOXSEG8EI32_V_MF2_MF8_TU, VLOXSEG8EI32_V, 0x5 }, // 4730
  { PseudoVLOXSEG8EI32_V_M1_MF4, VLOXSEG8EI32_V, 0x6 }, // 4731
  { PseudoVLOXSEG8EI32_V_M1_MF4_MASK, VLOXSEG8EI32_V, 0x6 }, // 4732
  { PseudoVLOXSEG8EI32_V_M1_MF4_TU, VLOXSEG8EI32_V, 0x6 }, // 4733
  { PseudoVLOXSEG8EI32_V_MF2_MF4, VLOXSEG8EI32_V, 0x6 }, // 4734
  { PseudoVLOXSEG8EI32_V_MF2_MF4_MASK, VLOXSEG8EI32_V, 0x6 }, // 4735
  { PseudoVLOXSEG8EI32_V_MF2_MF4_TU, VLOXSEG8EI32_V, 0x6 }, // 4736
  { PseudoVLOXSEG8EI32_V_M1_MF2, VLOXSEG8EI32_V, 0x7 }, // 4737
  { PseudoVLOXSEG8EI32_V_M1_MF2_MASK, VLOXSEG8EI32_V, 0x7 }, // 4738
  { PseudoVLOXSEG8EI32_V_M1_MF2_TU, VLOXSEG8EI32_V, 0x7 }, // 4739
  { PseudoVLOXSEG8EI32_V_M2_MF2, VLOXSEG8EI32_V, 0x7 }, // 4740
  { PseudoVLOXSEG8EI32_V_M2_MF2_MASK, VLOXSEG8EI32_V, 0x7 }, // 4741
  { PseudoVLOXSEG8EI32_V_M2_MF2_TU, VLOXSEG8EI32_V, 0x7 }, // 4742
  { PseudoVLOXSEG8EI32_V_MF2_MF2, VLOXSEG8EI32_V, 0x7 }, // 4743
  { PseudoVLOXSEG8EI32_V_MF2_MF2_MASK, VLOXSEG8EI32_V, 0x7 }, // 4744
  { PseudoVLOXSEG8EI32_V_MF2_MF2_TU, VLOXSEG8EI32_V, 0x7 }, // 4745
  { PseudoVLOXSEG8EI64_V_M1_M1, VLOXSEG8EI64_V, 0x0 }, // 4746
  { PseudoVLOXSEG8EI64_V_M1_M1_MASK, VLOXSEG8EI64_V, 0x0 }, // 4747
  { PseudoVLOXSEG8EI64_V_M1_M1_TU, VLOXSEG8EI64_V, 0x0 }, // 4748
  { PseudoVLOXSEG8EI64_V_M2_M1, VLOXSEG8EI64_V, 0x0 }, // 4749
  { PseudoVLOXSEG8EI64_V_M2_M1_MASK, VLOXSEG8EI64_V, 0x0 }, // 4750
  { PseudoVLOXSEG8EI64_V_M2_M1_TU, VLOXSEG8EI64_V, 0x0 }, // 4751
  { PseudoVLOXSEG8EI64_V_M4_M1, VLOXSEG8EI64_V, 0x0 }, // 4752
  { PseudoVLOXSEG8EI64_V_M4_M1_MASK, VLOXSEG8EI64_V, 0x0 }, // 4753
  { PseudoVLOXSEG8EI64_V_M4_M1_TU, VLOXSEG8EI64_V, 0x0 }, // 4754
  { PseudoVLOXSEG8EI64_V_M8_M1, VLOXSEG8EI64_V, 0x0 }, // 4755
  { PseudoVLOXSEG8EI64_V_M8_M1_MASK, VLOXSEG8EI64_V, 0x0 }, // 4756
  { PseudoVLOXSEG8EI64_V_M8_M1_TU, VLOXSEG8EI64_V, 0x0 }, // 4757
  { PseudoVLOXSEG8EI64_V_M1_MF8, VLOXSEG8EI64_V, 0x5 }, // 4758
  { PseudoVLOXSEG8EI64_V_M1_MF8_MASK, VLOXSEG8EI64_V, 0x5 }, // 4759
  { PseudoVLOXSEG8EI64_V_M1_MF8_TU, VLOXSEG8EI64_V, 0x5 }, // 4760
  { PseudoVLOXSEG8EI64_V_M1_MF4, VLOXSEG8EI64_V, 0x6 }, // 4761
  { PseudoVLOXSEG8EI64_V_M1_MF4_MASK, VLOXSEG8EI64_V, 0x6 }, // 4762
  { PseudoVLOXSEG8EI64_V_M1_MF4_TU, VLOXSEG8EI64_V, 0x6 }, // 4763
  { PseudoVLOXSEG8EI64_V_M2_MF4, VLOXSEG8EI64_V, 0x6 }, // 4764
  { PseudoVLOXSEG8EI64_V_M2_MF4_MASK, VLOXSEG8EI64_V, 0x6 }, // 4765
  { PseudoVLOXSEG8EI64_V_M2_MF4_TU, VLOXSEG8EI64_V, 0x6 }, // 4766
  { PseudoVLOXSEG8EI64_V_M1_MF2, VLOXSEG8EI64_V, 0x7 }, // 4767
  { PseudoVLOXSEG8EI64_V_M1_MF2_MASK, VLOXSEG8EI64_V, 0x7 }, // 4768
  { PseudoVLOXSEG8EI64_V_M1_MF2_TU, VLOXSEG8EI64_V, 0x7 }, // 4769
  { PseudoVLOXSEG8EI64_V_M2_MF2, VLOXSEG8EI64_V, 0x7 }, // 4770
  { PseudoVLOXSEG8EI64_V_M2_MF2_MASK, VLOXSEG8EI64_V, 0x7 }, // 4771
  { PseudoVLOXSEG8EI64_V_M2_MF2_TU, VLOXSEG8EI64_V, 0x7 }, // 4772
  { PseudoVLOXSEG8EI64_V_M4_MF2, VLOXSEG8EI64_V, 0x7 }, // 4773
  { PseudoVLOXSEG8EI64_V_M4_MF2_MASK, VLOXSEG8EI64_V, 0x7 }, // 4774
  { PseudoVLOXSEG8EI64_V_M4_MF2_TU, VLOXSEG8EI64_V, 0x7 }, // 4775
  { PseudoVLOXSEG8EI8_V_M1_M1, VLOXSEG8EI8_V, 0x0 }, // 4776
  { PseudoVLOXSEG8EI8_V_M1_M1_MASK, VLOXSEG8EI8_V, 0x0 }, // 4777
  { PseudoVLOXSEG8EI8_V_M1_M1_TU, VLOXSEG8EI8_V, 0x0 }, // 4778
  { PseudoVLOXSEG8EI8_V_MF2_M1, VLOXSEG8EI8_V, 0x0 }, // 4779
  { PseudoVLOXSEG8EI8_V_MF2_M1_MASK, VLOXSEG8EI8_V, 0x0 }, // 4780
  { PseudoVLOXSEG8EI8_V_MF2_M1_TU, VLOXSEG8EI8_V, 0x0 }, // 4781
  { PseudoVLOXSEG8EI8_V_MF4_M1, VLOXSEG8EI8_V, 0x0 }, // 4782
  { PseudoVLOXSEG8EI8_V_MF4_M1_MASK, VLOXSEG8EI8_V, 0x0 }, // 4783
  { PseudoVLOXSEG8EI8_V_MF4_M1_TU, VLOXSEG8EI8_V, 0x0 }, // 4784
  { PseudoVLOXSEG8EI8_V_MF8_M1, VLOXSEG8EI8_V, 0x0 }, // 4785
  { PseudoVLOXSEG8EI8_V_MF8_M1_MASK, VLOXSEG8EI8_V, 0x0 }, // 4786
  { PseudoVLOXSEG8EI8_V_MF8_M1_TU, VLOXSEG8EI8_V, 0x0 }, // 4787
  { PseudoVLOXSEG8EI8_V_MF8_MF8, VLOXSEG8EI8_V, 0x5 }, // 4788
  { PseudoVLOXSEG8EI8_V_MF8_MF8_MASK, VLOXSEG8EI8_V, 0x5 }, // 4789
  { PseudoVLOXSEG8EI8_V_MF8_MF8_TU, VLOXSEG8EI8_V, 0x5 }, // 4790
  { PseudoVLOXSEG8EI8_V_MF4_MF4, VLOXSEG8EI8_V, 0x6 }, // 4791
  { PseudoVLOXSEG8EI8_V_MF4_MF4_MASK, VLOXSEG8EI8_V, 0x6 }, // 4792
  { PseudoVLOXSEG8EI8_V_MF4_MF4_TU, VLOXSEG8EI8_V, 0x6 }, // 4793
  { PseudoVLOXSEG8EI8_V_MF8_MF4, VLOXSEG8EI8_V, 0x6 }, // 4794
  { PseudoVLOXSEG8EI8_V_MF8_MF4_MASK, VLOXSEG8EI8_V, 0x6 }, // 4795
  { PseudoVLOXSEG8EI8_V_MF8_MF4_TU, VLOXSEG8EI8_V, 0x6 }, // 4796
  { PseudoVLOXSEG8EI8_V_MF2_MF2, VLOXSEG8EI8_V, 0x7 }, // 4797
  { PseudoVLOXSEG8EI8_V_MF2_MF2_MASK, VLOXSEG8EI8_V, 0x7 }, // 4798
  { PseudoVLOXSEG8EI8_V_MF2_MF2_TU, VLOXSEG8EI8_V, 0x7 }, // 4799
  { PseudoVLOXSEG8EI8_V_MF4_MF2, VLOXSEG8EI8_V, 0x7 }, // 4800
  { PseudoVLOXSEG8EI8_V_MF4_MF2_MASK, VLOXSEG8EI8_V, 0x7 }, // 4801
  { PseudoVLOXSEG8EI8_V_MF4_MF2_TU, VLOXSEG8EI8_V, 0x7 }, // 4802
  { PseudoVLOXSEG8EI8_V_MF8_MF2, VLOXSEG8EI8_V, 0x7 }, // 4803
  { PseudoVLOXSEG8EI8_V_MF8_MF2_MASK, VLOXSEG8EI8_V, 0x7 }, // 4804
  { PseudoVLOXSEG8EI8_V_MF8_MF2_TU, VLOXSEG8EI8_V, 0x7 }, // 4805
  { PseudoVLSE16_V_M1, VLSE16_V, 0x0 }, // 4806
  { PseudoVLSE16_V_M1_MASK, VLSE16_V, 0x0 }, // 4807
  { PseudoVLSE16_V_M1_TU, VLSE16_V, 0x0 }, // 4808
  { PseudoVLSE16_V_M2, VLSE16_V, 0x1 }, // 4809
  { PseudoVLSE16_V_M2_MASK, VLSE16_V, 0x1 }, // 4810
  { PseudoVLSE16_V_M2_TU, VLSE16_V, 0x1 }, // 4811
  { PseudoVLSE16_V_M4, VLSE16_V, 0x2 }, // 4812
  { PseudoVLSE16_V_M4_MASK, VLSE16_V, 0x2 }, // 4813
  { PseudoVLSE16_V_M4_TU, VLSE16_V, 0x2 }, // 4814
  { PseudoVLSE16_V_M8, VLSE16_V, 0x3 }, // 4815
  { PseudoVLSE16_V_M8_MASK, VLSE16_V, 0x3 }, // 4816
  { PseudoVLSE16_V_M8_TU, VLSE16_V, 0x3 }, // 4817
  { PseudoVLSE16_V_MF4, VLSE16_V, 0x6 }, // 4818
  { PseudoVLSE16_V_MF4_MASK, VLSE16_V, 0x6 }, // 4819
  { PseudoVLSE16_V_MF4_TU, VLSE16_V, 0x6 }, // 4820
  { PseudoVLSE16_V_MF2, VLSE16_V, 0x7 }, // 4821
  { PseudoVLSE16_V_MF2_MASK, VLSE16_V, 0x7 }, // 4822
  { PseudoVLSE16_V_MF2_TU, VLSE16_V, 0x7 }, // 4823
  { PseudoVLSE32_V_M1, VLSE32_V, 0x0 }, // 4824
  { PseudoVLSE32_V_M1_MASK, VLSE32_V, 0x0 }, // 4825
  { PseudoVLSE32_V_M1_TU, VLSE32_V, 0x0 }, // 4826
  { PseudoVLSE32_V_M2, VLSE32_V, 0x1 }, // 4827
  { PseudoVLSE32_V_M2_MASK, VLSE32_V, 0x1 }, // 4828
  { PseudoVLSE32_V_M2_TU, VLSE32_V, 0x1 }, // 4829
  { PseudoVLSE32_V_M4, VLSE32_V, 0x2 }, // 4830
  { PseudoVLSE32_V_M4_MASK, VLSE32_V, 0x2 }, // 4831
  { PseudoVLSE32_V_M4_TU, VLSE32_V, 0x2 }, // 4832
  { PseudoVLSE32_V_M8, VLSE32_V, 0x3 }, // 4833
  { PseudoVLSE32_V_M8_MASK, VLSE32_V, 0x3 }, // 4834
  { PseudoVLSE32_V_M8_TU, VLSE32_V, 0x3 }, // 4835
  { PseudoVLSE32_V_MF2, VLSE32_V, 0x7 }, // 4836
  { PseudoVLSE32_V_MF2_MASK, VLSE32_V, 0x7 }, // 4837
  { PseudoVLSE32_V_MF2_TU, VLSE32_V, 0x7 }, // 4838
  { PseudoVLSE64_V_M1, VLSE64_V, 0x0 }, // 4839
  { PseudoVLSE64_V_M1_MASK, VLSE64_V, 0x0 }, // 4840
  { PseudoVLSE64_V_M1_TU, VLSE64_V, 0x0 }, // 4841
  { PseudoVLSE64_V_M2, VLSE64_V, 0x1 }, // 4842
  { PseudoVLSE64_V_M2_MASK, VLSE64_V, 0x1 }, // 4843
  { PseudoVLSE64_V_M2_TU, VLSE64_V, 0x1 }, // 4844
  { PseudoVLSE64_V_M4, VLSE64_V, 0x2 }, // 4845
  { PseudoVLSE64_V_M4_MASK, VLSE64_V, 0x2 }, // 4846
  { PseudoVLSE64_V_M4_TU, VLSE64_V, 0x2 }, // 4847
  { PseudoVLSE64_V_M8, VLSE64_V, 0x3 }, // 4848
  { PseudoVLSE64_V_M8_MASK, VLSE64_V, 0x3 }, // 4849
  { PseudoVLSE64_V_M8_TU, VLSE64_V, 0x3 }, // 4850
  { PseudoVLSE8_V_M1, VLSE8_V, 0x0 }, // 4851
  { PseudoVLSE8_V_M1_MASK, VLSE8_V, 0x0 }, // 4852
  { PseudoVLSE8_V_M1_TU, VLSE8_V, 0x0 }, // 4853
  { PseudoVLSE8_V_M2, VLSE8_V, 0x1 }, // 4854
  { PseudoVLSE8_V_M2_MASK, VLSE8_V, 0x1 }, // 4855
  { PseudoVLSE8_V_M2_TU, VLSE8_V, 0x1 }, // 4856
  { PseudoVLSE8_V_M4, VLSE8_V, 0x2 }, // 4857
  { PseudoVLSE8_V_M4_MASK, VLSE8_V, 0x2 }, // 4858
  { PseudoVLSE8_V_M4_TU, VLSE8_V, 0x2 }, // 4859
  { PseudoVLSE8_V_M8, VLSE8_V, 0x3 }, // 4860
  { PseudoVLSE8_V_M8_MASK, VLSE8_V, 0x3 }, // 4861
  { PseudoVLSE8_V_M8_TU, VLSE8_V, 0x3 }, // 4862
  { PseudoVLSE8_V_MF8, VLSE8_V, 0x5 }, // 4863
  { PseudoVLSE8_V_MF8_MASK, VLSE8_V, 0x5 }, // 4864
  { PseudoVLSE8_V_MF8_TU, VLSE8_V, 0x5 }, // 4865
  { PseudoVLSE8_V_MF4, VLSE8_V, 0x6 }, // 4866
  { PseudoVLSE8_V_MF4_MASK, VLSE8_V, 0x6 }, // 4867
  { PseudoVLSE8_V_MF4_TU, VLSE8_V, 0x6 }, // 4868
  { PseudoVLSE8_V_MF2, VLSE8_V, 0x7 }, // 4869
  { PseudoVLSE8_V_MF2_MASK, VLSE8_V, 0x7 }, // 4870
  { PseudoVLSE8_V_MF2_TU, VLSE8_V, 0x7 }, // 4871
  { PseudoVLSEG2E16FF_V_M1, VLSEG2E16FF_V, 0x0 }, // 4872
  { PseudoVLSEG2E16FF_V_M1_MASK, VLSEG2E16FF_V, 0x0 }, // 4873
  { PseudoVLSEG2E16FF_V_M1_TU, VLSEG2E16FF_V, 0x0 }, // 4874
  { PseudoVLSEG2E16FF_V_M2, VLSEG2E16FF_V, 0x1 }, // 4875
  { PseudoVLSEG2E16FF_V_M2_MASK, VLSEG2E16FF_V, 0x1 }, // 4876
  { PseudoVLSEG2E16FF_V_M2_TU, VLSEG2E16FF_V, 0x1 }, // 4877
  { PseudoVLSEG2E16FF_V_M4, VLSEG2E16FF_V, 0x2 }, // 4878
  { PseudoVLSEG2E16FF_V_M4_MASK, VLSEG2E16FF_V, 0x2 }, // 4879
  { PseudoVLSEG2E16FF_V_M4_TU, VLSEG2E16FF_V, 0x2 }, // 4880
  { PseudoVLSEG2E16FF_V_MF4, VLSEG2E16FF_V, 0x6 }, // 4881
  { PseudoVLSEG2E16FF_V_MF4_MASK, VLSEG2E16FF_V, 0x6 }, // 4882
  { PseudoVLSEG2E16FF_V_MF4_TU, VLSEG2E16FF_V, 0x6 }, // 4883
  { PseudoVLSEG2E16FF_V_MF2, VLSEG2E16FF_V, 0x7 }, // 4884
  { PseudoVLSEG2E16FF_V_MF2_MASK, VLSEG2E16FF_V, 0x7 }, // 4885
  { PseudoVLSEG2E16FF_V_MF2_TU, VLSEG2E16FF_V, 0x7 }, // 4886
  { PseudoVLSEG2E16_V_M1, VLSEG2E16_V, 0x0 }, // 4887
  { PseudoVLSEG2E16_V_M1_MASK, VLSEG2E16_V, 0x0 }, // 4888
  { PseudoVLSEG2E16_V_M1_TU, VLSEG2E16_V, 0x0 }, // 4889
  { PseudoVLSEG2E16_V_M2, VLSEG2E16_V, 0x1 }, // 4890
  { PseudoVLSEG2E16_V_M2_MASK, VLSEG2E16_V, 0x1 }, // 4891
  { PseudoVLSEG2E16_V_M2_TU, VLSEG2E16_V, 0x1 }, // 4892
  { PseudoVLSEG2E16_V_M4, VLSEG2E16_V, 0x2 }, // 4893
  { PseudoVLSEG2E16_V_M4_MASK, VLSEG2E16_V, 0x2 }, // 4894
  { PseudoVLSEG2E16_V_M4_TU, VLSEG2E16_V, 0x2 }, // 4895
  { PseudoVLSEG2E16_V_MF4, VLSEG2E16_V, 0x6 }, // 4896
  { PseudoVLSEG2E16_V_MF4_MASK, VLSEG2E16_V, 0x6 }, // 4897
  { PseudoVLSEG2E16_V_MF4_TU, VLSEG2E16_V, 0x6 }, // 4898
  { PseudoVLSEG2E16_V_MF2, VLSEG2E16_V, 0x7 }, // 4899
  { PseudoVLSEG2E16_V_MF2_MASK, VLSEG2E16_V, 0x7 }, // 4900
  { PseudoVLSEG2E16_V_MF2_TU, VLSEG2E16_V, 0x7 }, // 4901
  { PseudoVLSEG2E32FF_V_M1, VLSEG2E32FF_V, 0x0 }, // 4902
  { PseudoVLSEG2E32FF_V_M1_MASK, VLSEG2E32FF_V, 0x0 }, // 4903
  { PseudoVLSEG2E32FF_V_M1_TU, VLSEG2E32FF_V, 0x0 }, // 4904
  { PseudoVLSEG2E32FF_V_M2, VLSEG2E32FF_V, 0x1 }, // 4905
  { PseudoVLSEG2E32FF_V_M2_MASK, VLSEG2E32FF_V, 0x1 }, // 4906
  { PseudoVLSEG2E32FF_V_M2_TU, VLSEG2E32FF_V, 0x1 }, // 4907
  { PseudoVLSEG2E32FF_V_M4, VLSEG2E32FF_V, 0x2 }, // 4908
  { PseudoVLSEG2E32FF_V_M4_MASK, VLSEG2E32FF_V, 0x2 }, // 4909
  { PseudoVLSEG2E32FF_V_M4_TU, VLSEG2E32FF_V, 0x2 }, // 4910
  { PseudoVLSEG2E32FF_V_MF2, VLSEG2E32FF_V, 0x7 }, // 4911
  { PseudoVLSEG2E32FF_V_MF2_MASK, VLSEG2E32FF_V, 0x7 }, // 4912
  { PseudoVLSEG2E32FF_V_MF2_TU, VLSEG2E32FF_V, 0x7 }, // 4913
  { PseudoVLSEG2E32_V_M1, VLSEG2E32_V, 0x0 }, // 4914
  { PseudoVLSEG2E32_V_M1_MASK, VLSEG2E32_V, 0x0 }, // 4915
  { PseudoVLSEG2E32_V_M1_TU, VLSEG2E32_V, 0x0 }, // 4916
  { PseudoVLSEG2E32_V_M2, VLSEG2E32_V, 0x1 }, // 4917
  { PseudoVLSEG2E32_V_M2_MASK, VLSEG2E32_V, 0x1 }, // 4918
  { PseudoVLSEG2E32_V_M2_TU, VLSEG2E32_V, 0x1 }, // 4919
  { PseudoVLSEG2E32_V_M4, VLSEG2E32_V, 0x2 }, // 4920
  { PseudoVLSEG2E32_V_M4_MASK, VLSEG2E32_V, 0x2 }, // 4921
  { PseudoVLSEG2E32_V_M4_TU, VLSEG2E32_V, 0x2 }, // 4922
  { PseudoVLSEG2E32_V_MF2, VLSEG2E32_V, 0x7 }, // 4923
  { PseudoVLSEG2E32_V_MF2_MASK, VLSEG2E32_V, 0x7 }, // 4924
  { PseudoVLSEG2E32_V_MF2_TU, VLSEG2E32_V, 0x7 }, // 4925
  { PseudoVLSEG2E64FF_V_M1, VLSEG2E64FF_V, 0x0 }, // 4926
  { PseudoVLSEG2E64FF_V_M1_MASK, VLSEG2E64FF_V, 0x0 }, // 4927
  { PseudoVLSEG2E64FF_V_M1_TU, VLSEG2E64FF_V, 0x0 }, // 4928
  { PseudoVLSEG2E64FF_V_M2, VLSEG2E64FF_V, 0x1 }, // 4929
  { PseudoVLSEG2E64FF_V_M2_MASK, VLSEG2E64FF_V, 0x1 }, // 4930
  { PseudoVLSEG2E64FF_V_M2_TU, VLSEG2E64FF_V, 0x1 }, // 4931
  { PseudoVLSEG2E64FF_V_M4, VLSEG2E64FF_V, 0x2 }, // 4932
  { PseudoVLSEG2E64FF_V_M4_MASK, VLSEG2E64FF_V, 0x2 }, // 4933
  { PseudoVLSEG2E64FF_V_M4_TU, VLSEG2E64FF_V, 0x2 }, // 4934
  { PseudoVLSEG2E64_V_M1, VLSEG2E64_V, 0x0 }, // 4935
  { PseudoVLSEG2E64_V_M1_MASK, VLSEG2E64_V, 0x0 }, // 4936
  { PseudoVLSEG2E64_V_M1_TU, VLSEG2E64_V, 0x0 }, // 4937
  { PseudoVLSEG2E64_V_M2, VLSEG2E64_V, 0x1 }, // 4938
  { PseudoVLSEG2E64_V_M2_MASK, VLSEG2E64_V, 0x1 }, // 4939
  { PseudoVLSEG2E64_V_M2_TU, VLSEG2E64_V, 0x1 }, // 4940
  { PseudoVLSEG2E64_V_M4, VLSEG2E64_V, 0x2 }, // 4941
  { PseudoVLSEG2E64_V_M4_MASK, VLSEG2E64_V, 0x2 }, // 4942
  { PseudoVLSEG2E64_V_M4_TU, VLSEG2E64_V, 0x2 }, // 4943
  { PseudoVLSEG2E8FF_V_M1, VLSEG2E8FF_V, 0x0 }, // 4944
  { PseudoVLSEG2E8FF_V_M1_MASK, VLSEG2E8FF_V, 0x0 }, // 4945
  { PseudoVLSEG2E8FF_V_M1_TU, VLSEG2E8FF_V, 0x0 }, // 4946
  { PseudoVLSEG2E8FF_V_M2, VLSEG2E8FF_V, 0x1 }, // 4947
  { PseudoVLSEG2E8FF_V_M2_MASK, VLSEG2E8FF_V, 0x1 }, // 4948
  { PseudoVLSEG2E8FF_V_M2_TU, VLSEG2E8FF_V, 0x1 }, // 4949
  { PseudoVLSEG2E8FF_V_M4, VLSEG2E8FF_V, 0x2 }, // 4950
  { PseudoVLSEG2E8FF_V_M4_MASK, VLSEG2E8FF_V, 0x2 }, // 4951
  { PseudoVLSEG2E8FF_V_M4_TU, VLSEG2E8FF_V, 0x2 }, // 4952
  { PseudoVLSEG2E8FF_V_MF8, VLSEG2E8FF_V, 0x5 }, // 4953
  { PseudoVLSEG2E8FF_V_MF8_MASK, VLSEG2E8FF_V, 0x5 }, // 4954
  { PseudoVLSEG2E8FF_V_MF8_TU, VLSEG2E8FF_V, 0x5 }, // 4955
  { PseudoVLSEG2E8FF_V_MF4, VLSEG2E8FF_V, 0x6 }, // 4956
  { PseudoVLSEG2E8FF_V_MF4_MASK, VLSEG2E8FF_V, 0x6 }, // 4957
  { PseudoVLSEG2E8FF_V_MF4_TU, VLSEG2E8FF_V, 0x6 }, // 4958
  { PseudoVLSEG2E8FF_V_MF2, VLSEG2E8FF_V, 0x7 }, // 4959
  { PseudoVLSEG2E8FF_V_MF2_MASK, VLSEG2E8FF_V, 0x7 }, // 4960
  { PseudoVLSEG2E8FF_V_MF2_TU, VLSEG2E8FF_V, 0x7 }, // 4961
  { PseudoVLSEG2E8_V_M1, VLSEG2E8_V, 0x0 }, // 4962
  { PseudoVLSEG2E8_V_M1_MASK, VLSEG2E8_V, 0x0 }, // 4963
  { PseudoVLSEG2E8_V_M1_TU, VLSEG2E8_V, 0x0 }, // 4964
  { PseudoVLSEG2E8_V_M2, VLSEG2E8_V, 0x1 }, // 4965
  { PseudoVLSEG2E8_V_M2_MASK, VLSEG2E8_V, 0x1 }, // 4966
  { PseudoVLSEG2E8_V_M2_TU, VLSEG2E8_V, 0x1 }, // 4967
  { PseudoVLSEG2E8_V_M4, VLSEG2E8_V, 0x2 }, // 4968
  { PseudoVLSEG2E8_V_M4_MASK, VLSEG2E8_V, 0x2 }, // 4969
  { PseudoVLSEG2E8_V_M4_TU, VLSEG2E8_V, 0x2 }, // 4970
  { PseudoVLSEG2E8_V_MF8, VLSEG2E8_V, 0x5 }, // 4971
  { PseudoVLSEG2E8_V_MF8_MASK, VLSEG2E8_V, 0x5 }, // 4972
  { PseudoVLSEG2E8_V_MF8_TU, VLSEG2E8_V, 0x5 }, // 4973
  { PseudoVLSEG2E8_V_MF4, VLSEG2E8_V, 0x6 }, // 4974
  { PseudoVLSEG2E8_V_MF4_MASK, VLSEG2E8_V, 0x6 }, // 4975
  { PseudoVLSEG2E8_V_MF4_TU, VLSEG2E8_V, 0x6 }, // 4976
  { PseudoVLSEG2E8_V_MF2, VLSEG2E8_V, 0x7 }, // 4977
  { PseudoVLSEG2E8_V_MF2_MASK, VLSEG2E8_V, 0x7 }, // 4978
  { PseudoVLSEG2E8_V_MF2_TU, VLSEG2E8_V, 0x7 }, // 4979
  { PseudoVLSEG3E16FF_V_M1, VLSEG3E16FF_V, 0x0 }, // 4980
  { PseudoVLSEG3E16FF_V_M1_MASK, VLSEG3E16FF_V, 0x0 }, // 4981
  { PseudoVLSEG3E16FF_V_M1_TU, VLSEG3E16FF_V, 0x0 }, // 4982
  { PseudoVLSEG3E16FF_V_M2, VLSEG3E16FF_V, 0x1 }, // 4983
  { PseudoVLSEG3E16FF_V_M2_MASK, VLSEG3E16FF_V, 0x1 }, // 4984
  { PseudoVLSEG3E16FF_V_M2_TU, VLSEG3E16FF_V, 0x1 }, // 4985
  { PseudoVLSEG3E16FF_V_MF4, VLSEG3E16FF_V, 0x6 }, // 4986
  { PseudoVLSEG3E16FF_V_MF4_MASK, VLSEG3E16FF_V, 0x6 }, // 4987
  { PseudoVLSEG3E16FF_V_MF4_TU, VLSEG3E16FF_V, 0x6 }, // 4988
  { PseudoVLSEG3E16FF_V_MF2, VLSEG3E16FF_V, 0x7 }, // 4989
  { PseudoVLSEG3E16FF_V_MF2_MASK, VLSEG3E16FF_V, 0x7 }, // 4990
  { PseudoVLSEG3E16FF_V_MF2_TU, VLSEG3E16FF_V, 0x7 }, // 4991
  { PseudoVLSEG3E16_V_M1, VLSEG3E16_V, 0x0 }, // 4992
  { PseudoVLSEG3E16_V_M1_MASK, VLSEG3E16_V, 0x0 }, // 4993
  { PseudoVLSEG3E16_V_M1_TU, VLSEG3E16_V, 0x0 }, // 4994
  { PseudoVLSEG3E16_V_M2, VLSEG3E16_V, 0x1 }, // 4995
  { PseudoVLSEG3E16_V_M2_MASK, VLSEG3E16_V, 0x1 }, // 4996
  { PseudoVLSEG3E16_V_M2_TU, VLSEG3E16_V, 0x1 }, // 4997
  { PseudoVLSEG3E16_V_MF4, VLSEG3E16_V, 0x6 }, // 4998
  { PseudoVLSEG3E16_V_MF4_MASK, VLSEG3E16_V, 0x6 }, // 4999
  { PseudoVLSEG3E16_V_MF4_TU, VLSEG3E16_V, 0x6 }, // 5000
  { PseudoVLSEG3E16_V_MF2, VLSEG3E16_V, 0x7 }, // 5001
  { PseudoVLSEG3E16_V_MF2_MASK, VLSEG3E16_V, 0x7 }, // 5002
  { PseudoVLSEG3E16_V_MF2_TU, VLSEG3E16_V, 0x7 }, // 5003
  { PseudoVLSEG3E32FF_V_M1, VLSEG3E32FF_V, 0x0 }, // 5004
  { PseudoVLSEG3E32FF_V_M1_MASK, VLSEG3E32FF_V, 0x0 }, // 5005
  { PseudoVLSEG3E32FF_V_M1_TU, VLSEG3E32FF_V, 0x0 }, // 5006
  { PseudoVLSEG3E32FF_V_M2, VLSEG3E32FF_V, 0x1 }, // 5007
  { PseudoVLSEG3E32FF_V_M2_MASK, VLSEG3E32FF_V, 0x1 }, // 5008
  { PseudoVLSEG3E32FF_V_M2_TU, VLSEG3E32FF_V, 0x1 }, // 5009
  { PseudoVLSEG3E32FF_V_MF2, VLSEG3E32FF_V, 0x7 }, // 5010
  { PseudoVLSEG3E32FF_V_MF2_MASK, VLSEG3E32FF_V, 0x7 }, // 5011
  { PseudoVLSEG3E32FF_V_MF2_TU, VLSEG3E32FF_V, 0x7 }, // 5012
  { PseudoVLSEG3E32_V_M1, VLSEG3E32_V, 0x0 }, // 5013
  { PseudoVLSEG3E32_V_M1_MASK, VLSEG3E32_V, 0x0 }, // 5014
  { PseudoVLSEG3E32_V_M1_TU, VLSEG3E32_V, 0x0 }, // 5015
  { PseudoVLSEG3E32_V_M2, VLSEG3E32_V, 0x1 }, // 5016
  { PseudoVLSEG3E32_V_M2_MASK, VLSEG3E32_V, 0x1 }, // 5017
  { PseudoVLSEG3E32_V_M2_TU, VLSEG3E32_V, 0x1 }, // 5018
  { PseudoVLSEG3E32_V_MF2, VLSEG3E32_V, 0x7 }, // 5019
  { PseudoVLSEG3E32_V_MF2_MASK, VLSEG3E32_V, 0x7 }, // 5020
  { PseudoVLSEG3E32_V_MF2_TU, VLSEG3E32_V, 0x7 }, // 5021
  { PseudoVLSEG3E64FF_V_M1, VLSEG3E64FF_V, 0x0 }, // 5022
  { PseudoVLSEG3E64FF_V_M1_MASK, VLSEG3E64FF_V, 0x0 }, // 5023
  { PseudoVLSEG3E64FF_V_M1_TU, VLSEG3E64FF_V, 0x0 }, // 5024
  { PseudoVLSEG3E64FF_V_M2, VLSEG3E64FF_V, 0x1 }, // 5025
  { PseudoVLSEG3E64FF_V_M2_MASK, VLSEG3E64FF_V, 0x1 }, // 5026
  { PseudoVLSEG3E64FF_V_M2_TU, VLSEG3E64FF_V, 0x1 }, // 5027
  { PseudoVLSEG3E64_V_M1, VLSEG3E64_V, 0x0 }, // 5028
  { PseudoVLSEG3E64_V_M1_MASK, VLSEG3E64_V, 0x0 }, // 5029
  { PseudoVLSEG3E64_V_M1_TU, VLSEG3E64_V, 0x0 }, // 5030
  { PseudoVLSEG3E64_V_M2, VLSEG3E64_V, 0x1 }, // 5031
  { PseudoVLSEG3E64_V_M2_MASK, VLSEG3E64_V, 0x1 }, // 5032
  { PseudoVLSEG3E64_V_M2_TU, VLSEG3E64_V, 0x1 }, // 5033
  { PseudoVLSEG3E8FF_V_M1, VLSEG3E8FF_V, 0x0 }, // 5034
  { PseudoVLSEG3E8FF_V_M1_MASK, VLSEG3E8FF_V, 0x0 }, // 5035
  { PseudoVLSEG3E8FF_V_M1_TU, VLSEG3E8FF_V, 0x0 }, // 5036
  { PseudoVLSEG3E8FF_V_M2, VLSEG3E8FF_V, 0x1 }, // 5037
  { PseudoVLSEG3E8FF_V_M2_MASK, VLSEG3E8FF_V, 0x1 }, // 5038
  { PseudoVLSEG3E8FF_V_M2_TU, VLSEG3E8FF_V, 0x1 }, // 5039
  { PseudoVLSEG3E8FF_V_MF8, VLSEG3E8FF_V, 0x5 }, // 5040
  { PseudoVLSEG3E8FF_V_MF8_MASK, VLSEG3E8FF_V, 0x5 }, // 5041
  { PseudoVLSEG3E8FF_V_MF8_TU, VLSEG3E8FF_V, 0x5 }, // 5042
  { PseudoVLSEG3E8FF_V_MF4, VLSEG3E8FF_V, 0x6 }, // 5043
  { PseudoVLSEG3E8FF_V_MF4_MASK, VLSEG3E8FF_V, 0x6 }, // 5044
  { PseudoVLSEG3E8FF_V_MF4_TU, VLSEG3E8FF_V, 0x6 }, // 5045
  { PseudoVLSEG3E8FF_V_MF2, VLSEG3E8FF_V, 0x7 }, // 5046
  { PseudoVLSEG3E8FF_V_MF2_MASK, VLSEG3E8FF_V, 0x7 }, // 5047
  { PseudoVLSEG3E8FF_V_MF2_TU, VLSEG3E8FF_V, 0x7 }, // 5048
  { PseudoVLSEG3E8_V_M1, VLSEG3E8_V, 0x0 }, // 5049
  { PseudoVLSEG3E8_V_M1_MASK, VLSEG3E8_V, 0x0 }, // 5050
  { PseudoVLSEG3E8_V_M1_TU, VLSEG3E8_V, 0x0 }, // 5051
  { PseudoVLSEG3E8_V_M2, VLSEG3E8_V, 0x1 }, // 5052
  { PseudoVLSEG3E8_V_M2_MASK, VLSEG3E8_V, 0x1 }, // 5053
  { PseudoVLSEG3E8_V_M2_TU, VLSEG3E8_V, 0x1 }, // 5054
  { PseudoVLSEG3E8_V_MF8, VLSEG3E8_V, 0x5 }, // 5055
  { PseudoVLSEG3E8_V_MF8_MASK, VLSEG3E8_V, 0x5 }, // 5056
  { PseudoVLSEG3E8_V_MF8_TU, VLSEG3E8_V, 0x5 }, // 5057
  { PseudoVLSEG3E8_V_MF4, VLSEG3E8_V, 0x6 }, // 5058
  { PseudoVLSEG3E8_V_MF4_MASK, VLSEG3E8_V, 0x6 }, // 5059
  { PseudoVLSEG3E8_V_MF4_TU, VLSEG3E8_V, 0x6 }, // 5060
  { PseudoVLSEG3E8_V_MF2, VLSEG3E8_V, 0x7 }, // 5061
  { PseudoVLSEG3E8_V_MF2_MASK, VLSEG3E8_V, 0x7 }, // 5062
  { PseudoVLSEG3E8_V_MF2_TU, VLSEG3E8_V, 0x7 }, // 5063
  { PseudoVLSEG4E16FF_V_M1, VLSEG4E16FF_V, 0x0 }, // 5064
  { PseudoVLSEG4E16FF_V_M1_MASK, VLSEG4E16FF_V, 0x0 }, // 5065
  { PseudoVLSEG4E16FF_V_M1_TU, VLSEG4E16FF_V, 0x0 }, // 5066
  { PseudoVLSEG4E16FF_V_M2, VLSEG4E16FF_V, 0x1 }, // 5067
  { PseudoVLSEG4E16FF_V_M2_MASK, VLSEG4E16FF_V, 0x1 }, // 5068
  { PseudoVLSEG4E16FF_V_M2_TU, VLSEG4E16FF_V, 0x1 }, // 5069
  { PseudoVLSEG4E16FF_V_MF4, VLSEG4E16FF_V, 0x6 }, // 5070
  { PseudoVLSEG4E16FF_V_MF4_MASK, VLSEG4E16FF_V, 0x6 }, // 5071
  { PseudoVLSEG4E16FF_V_MF4_TU, VLSEG4E16FF_V, 0x6 }, // 5072
  { PseudoVLSEG4E16FF_V_MF2, VLSEG4E16FF_V, 0x7 }, // 5073
  { PseudoVLSEG4E16FF_V_MF2_MASK, VLSEG4E16FF_V, 0x7 }, // 5074
  { PseudoVLSEG4E16FF_V_MF2_TU, VLSEG4E16FF_V, 0x7 }, // 5075
  { PseudoVLSEG4E16_V_M1, VLSEG4E16_V, 0x0 }, // 5076
  { PseudoVLSEG4E16_V_M1_MASK, VLSEG4E16_V, 0x0 }, // 5077
  { PseudoVLSEG4E16_V_M1_TU, VLSEG4E16_V, 0x0 }, // 5078
  { PseudoVLSEG4E16_V_M2, VLSEG4E16_V, 0x1 }, // 5079
  { PseudoVLSEG4E16_V_M2_MASK, VLSEG4E16_V, 0x1 }, // 5080
  { PseudoVLSEG4E16_V_M2_TU, VLSEG4E16_V, 0x1 }, // 5081
  { PseudoVLSEG4E16_V_MF4, VLSEG4E16_V, 0x6 }, // 5082
  { PseudoVLSEG4E16_V_MF4_MASK, VLSEG4E16_V, 0x6 }, // 5083
  { PseudoVLSEG4E16_V_MF4_TU, VLSEG4E16_V, 0x6 }, // 5084
  { PseudoVLSEG4E16_V_MF2, VLSEG4E16_V, 0x7 }, // 5085
  { PseudoVLSEG4E16_V_MF2_MASK, VLSEG4E16_V, 0x7 }, // 5086
  { PseudoVLSEG4E16_V_MF2_TU, VLSEG4E16_V, 0x7 }, // 5087
  { PseudoVLSEG4E32FF_V_M1, VLSEG4E32FF_V, 0x0 }, // 5088
  { PseudoVLSEG4E32FF_V_M1_MASK, VLSEG4E32FF_V, 0x0 }, // 5089
  { PseudoVLSEG4E32FF_V_M1_TU, VLSEG4E32FF_V, 0x0 }, // 5090
  { PseudoVLSEG4E32FF_V_M2, VLSEG4E32FF_V, 0x1 }, // 5091
  { PseudoVLSEG4E32FF_V_M2_MASK, VLSEG4E32FF_V, 0x1 }, // 5092
  { PseudoVLSEG4E32FF_V_M2_TU, VLSEG4E32FF_V, 0x1 }, // 5093
  { PseudoVLSEG4E32FF_V_MF2, VLSEG4E32FF_V, 0x7 }, // 5094
  { PseudoVLSEG4E32FF_V_MF2_MASK, VLSEG4E32FF_V, 0x7 }, // 5095
  { PseudoVLSEG4E32FF_V_MF2_TU, VLSEG4E32FF_V, 0x7 }, // 5096
  { PseudoVLSEG4E32_V_M1, VLSEG4E32_V, 0x0 }, // 5097
  { PseudoVLSEG4E32_V_M1_MASK, VLSEG4E32_V, 0x0 }, // 5098
  { PseudoVLSEG4E32_V_M1_TU, VLSEG4E32_V, 0x0 }, // 5099
  { PseudoVLSEG4E32_V_M2, VLSEG4E32_V, 0x1 }, // 5100
  { PseudoVLSEG4E32_V_M2_MASK, VLSEG4E32_V, 0x1 }, // 5101
  { PseudoVLSEG4E32_V_M2_TU, VLSEG4E32_V, 0x1 }, // 5102
  { PseudoVLSEG4E32_V_MF2, VLSEG4E32_V, 0x7 }, // 5103
  { PseudoVLSEG4E32_V_MF2_MASK, VLSEG4E32_V, 0x7 }, // 5104
  { PseudoVLSEG4E32_V_MF2_TU, VLSEG4E32_V, 0x7 }, // 5105
  { PseudoVLSEG4E64FF_V_M1, VLSEG4E64FF_V, 0x0 }, // 5106
  { PseudoVLSEG4E64FF_V_M1_MASK, VLSEG4E64FF_V, 0x0 }, // 5107
  { PseudoVLSEG4E64FF_V_M1_TU, VLSEG4E64FF_V, 0x0 }, // 5108
  { PseudoVLSEG4E64FF_V_M2, VLSEG4E64FF_V, 0x1 }, // 5109
  { PseudoVLSEG4E64FF_V_M2_MASK, VLSEG4E64FF_V, 0x1 }, // 5110
  { PseudoVLSEG4E64FF_V_M2_TU, VLSEG4E64FF_V, 0x1 }, // 5111
  { PseudoVLSEG4E64_V_M1, VLSEG4E64_V, 0x0 }, // 5112
  { PseudoVLSEG4E64_V_M1_MASK, VLSEG4E64_V, 0x0 }, // 5113
  { PseudoVLSEG4E64_V_M1_TU, VLSEG4E64_V, 0x0 }, // 5114
  { PseudoVLSEG4E64_V_M2, VLSEG4E64_V, 0x1 }, // 5115
  { PseudoVLSEG4E64_V_M2_MASK, VLSEG4E64_V, 0x1 }, // 5116
  { PseudoVLSEG4E64_V_M2_TU, VLSEG4E64_V, 0x1 }, // 5117
  { PseudoVLSEG4E8FF_V_M1, VLSEG4E8FF_V, 0x0 }, // 5118
  { PseudoVLSEG4E8FF_V_M1_MASK, VLSEG4E8FF_V, 0x0 }, // 5119
  { PseudoVLSEG4E8FF_V_M1_TU, VLSEG4E8FF_V, 0x0 }, // 5120
  { PseudoVLSEG4E8FF_V_M2, VLSEG4E8FF_V, 0x1 }, // 5121
  { PseudoVLSEG4E8FF_V_M2_MASK, VLSEG4E8FF_V, 0x1 }, // 5122
  { PseudoVLSEG4E8FF_V_M2_TU, VLSEG4E8FF_V, 0x1 }, // 5123
  { PseudoVLSEG4E8FF_V_MF8, VLSEG4E8FF_V, 0x5 }, // 5124
  { PseudoVLSEG4E8FF_V_MF8_MASK, VLSEG4E8FF_V, 0x5 }, // 5125
  { PseudoVLSEG4E8FF_V_MF8_TU, VLSEG4E8FF_V, 0x5 }, // 5126
  { PseudoVLSEG4E8FF_V_MF4, VLSEG4E8FF_V, 0x6 }, // 5127
  { PseudoVLSEG4E8FF_V_MF4_MASK, VLSEG4E8FF_V, 0x6 }, // 5128
  { PseudoVLSEG4E8FF_V_MF4_TU, VLSEG4E8FF_V, 0x6 }, // 5129
  { PseudoVLSEG4E8FF_V_MF2, VLSEG4E8FF_V, 0x7 }, // 5130
  { PseudoVLSEG4E8FF_V_MF2_MASK, VLSEG4E8FF_V, 0x7 }, // 5131
  { PseudoVLSEG4E8FF_V_MF2_TU, VLSEG4E8FF_V, 0x7 }, // 5132
  { PseudoVLSEG4E8_V_M1, VLSEG4E8_V, 0x0 }, // 5133
  { PseudoVLSEG4E8_V_M1_MASK, VLSEG4E8_V, 0x0 }, // 5134
  { PseudoVLSEG4E8_V_M1_TU, VLSEG4E8_V, 0x0 }, // 5135
  { PseudoVLSEG4E8_V_M2, VLSEG4E8_V, 0x1 }, // 5136
  { PseudoVLSEG4E8_V_M2_MASK, VLSEG4E8_V, 0x1 }, // 5137
  { PseudoVLSEG4E8_V_M2_TU, VLSEG4E8_V, 0x1 }, // 5138
  { PseudoVLSEG4E8_V_MF8, VLSEG4E8_V, 0x5 }, // 5139
  { PseudoVLSEG4E8_V_MF8_MASK, VLSEG4E8_V, 0x5 }, // 5140
  { PseudoVLSEG4E8_V_MF8_TU, VLSEG4E8_V, 0x5 }, // 5141
  { PseudoVLSEG4E8_V_MF4, VLSEG4E8_V, 0x6 }, // 5142
  { PseudoVLSEG4E8_V_MF4_MASK, VLSEG4E8_V, 0x6 }, // 5143
  { PseudoVLSEG4E8_V_MF4_TU, VLSEG4E8_V, 0x6 }, // 5144
  { PseudoVLSEG4E8_V_MF2, VLSEG4E8_V, 0x7 }, // 5145
  { PseudoVLSEG4E8_V_MF2_MASK, VLSEG4E8_V, 0x7 }, // 5146
  { PseudoVLSEG4E8_V_MF2_TU, VLSEG4E8_V, 0x7 }, // 5147
  { PseudoVLSEG5E16FF_V_M1, VLSEG5E16FF_V, 0x0 }, // 5148
  { PseudoVLSEG5E16FF_V_M1_MASK, VLSEG5E16FF_V, 0x0 }, // 5149
  { PseudoVLSEG5E16FF_V_M1_TU, VLSEG5E16FF_V, 0x0 }, // 5150
  { PseudoVLSEG5E16FF_V_MF4, VLSEG5E16FF_V, 0x6 }, // 5151
  { PseudoVLSEG5E16FF_V_MF4_MASK, VLSEG5E16FF_V, 0x6 }, // 5152
  { PseudoVLSEG5E16FF_V_MF4_TU, VLSEG5E16FF_V, 0x6 }, // 5153
  { PseudoVLSEG5E16FF_V_MF2, VLSEG5E16FF_V, 0x7 }, // 5154
  { PseudoVLSEG5E16FF_V_MF2_MASK, VLSEG5E16FF_V, 0x7 }, // 5155
  { PseudoVLSEG5E16FF_V_MF2_TU, VLSEG5E16FF_V, 0x7 }, // 5156
  { PseudoVLSEG5E16_V_M1, VLSEG5E16_V, 0x0 }, // 5157
  { PseudoVLSEG5E16_V_M1_MASK, VLSEG5E16_V, 0x0 }, // 5158
  { PseudoVLSEG5E16_V_M1_TU, VLSEG5E16_V, 0x0 }, // 5159
  { PseudoVLSEG5E16_V_MF4, VLSEG5E16_V, 0x6 }, // 5160
  { PseudoVLSEG5E16_V_MF4_MASK, VLSEG5E16_V, 0x6 }, // 5161
  { PseudoVLSEG5E16_V_MF4_TU, VLSEG5E16_V, 0x6 }, // 5162
  { PseudoVLSEG5E16_V_MF2, VLSEG5E16_V, 0x7 }, // 5163
  { PseudoVLSEG5E16_V_MF2_MASK, VLSEG5E16_V, 0x7 }, // 5164
  { PseudoVLSEG5E16_V_MF2_TU, VLSEG5E16_V, 0x7 }, // 5165
  { PseudoVLSEG5E32FF_V_M1, VLSEG5E32FF_V, 0x0 }, // 5166
  { PseudoVLSEG5E32FF_V_M1_MASK, VLSEG5E32FF_V, 0x0 }, // 5167
  { PseudoVLSEG5E32FF_V_M1_TU, VLSEG5E32FF_V, 0x0 }, // 5168
  { PseudoVLSEG5E32FF_V_MF2, VLSEG5E32FF_V, 0x7 }, // 5169
  { PseudoVLSEG5E32FF_V_MF2_MASK, VLSEG5E32FF_V, 0x7 }, // 5170
  { PseudoVLSEG5E32FF_V_MF2_TU, VLSEG5E32FF_V, 0x7 }, // 5171
  { PseudoVLSEG5E32_V_M1, VLSEG5E32_V, 0x0 }, // 5172
  { PseudoVLSEG5E32_V_M1_MASK, VLSEG5E32_V, 0x0 }, // 5173
  { PseudoVLSEG5E32_V_M1_TU, VLSEG5E32_V, 0x0 }, // 5174
  { PseudoVLSEG5E32_V_MF2, VLSEG5E32_V, 0x7 }, // 5175
  { PseudoVLSEG5E32_V_MF2_MASK, VLSEG5E32_V, 0x7 }, // 5176
  { PseudoVLSEG5E32_V_MF2_TU, VLSEG5E32_V, 0x7 }, // 5177
  { PseudoVLSEG5E64FF_V_M1, VLSEG5E64FF_V, 0x0 }, // 5178
  { PseudoVLSEG5E64FF_V_M1_MASK, VLSEG5E64FF_V, 0x0 }, // 5179
  { PseudoVLSEG5E64FF_V_M1_TU, VLSEG5E64FF_V, 0x0 }, // 5180
  { PseudoVLSEG5E64_V_M1, VLSEG5E64_V, 0x0 }, // 5181
  { PseudoVLSEG5E64_V_M1_MASK, VLSEG5E64_V, 0x0 }, // 5182
  { PseudoVLSEG5E64_V_M1_TU, VLSEG5E64_V, 0x0 }, // 5183
  { PseudoVLSEG5E8FF_V_M1, VLSEG5E8FF_V, 0x0 }, // 5184
  { PseudoVLSEG5E8FF_V_M1_MASK, VLSEG5E8FF_V, 0x0 }, // 5185
  { PseudoVLSEG5E8FF_V_M1_TU, VLSEG5E8FF_V, 0x0 }, // 5186
  { PseudoVLSEG5E8FF_V_MF8, VLSEG5E8FF_V, 0x5 }, // 5187
  { PseudoVLSEG5E8FF_V_MF8_MASK, VLSEG5E8FF_V, 0x5 }, // 5188
  { PseudoVLSEG5E8FF_V_MF8_TU, VLSEG5E8FF_V, 0x5 }, // 5189
  { PseudoVLSEG5E8FF_V_MF4, VLSEG5E8FF_V, 0x6 }, // 5190
  { PseudoVLSEG5E8FF_V_MF4_MASK, VLSEG5E8FF_V, 0x6 }, // 5191
  { PseudoVLSEG5E8FF_V_MF4_TU, VLSEG5E8FF_V, 0x6 }, // 5192
  { PseudoVLSEG5E8FF_V_MF2, VLSEG5E8FF_V, 0x7 }, // 5193
  { PseudoVLSEG5E8FF_V_MF2_MASK, VLSEG5E8FF_V, 0x7 }, // 5194
  { PseudoVLSEG5E8FF_V_MF2_TU, VLSEG5E8FF_V, 0x7 }, // 5195
  { PseudoVLSEG5E8_V_M1, VLSEG5E8_V, 0x0 }, // 5196
  { PseudoVLSEG5E8_V_M1_MASK, VLSEG5E8_V, 0x0 }, // 5197
  { PseudoVLSEG5E8_V_M1_TU, VLSEG5E8_V, 0x0 }, // 5198
  { PseudoVLSEG5E8_V_MF8, VLSEG5E8_V, 0x5 }, // 5199
  { PseudoVLSEG5E8_V_MF8_MASK, VLSEG5E8_V, 0x5 }, // 5200
  { PseudoVLSEG5E8_V_MF8_TU, VLSEG5E8_V, 0x5 }, // 5201
  { PseudoVLSEG5E8_V_MF4, VLSEG5E8_V, 0x6 }, // 5202
  { PseudoVLSEG5E8_V_MF4_MASK, VLSEG5E8_V, 0x6 }, // 5203
  { PseudoVLSEG5E8_V_MF4_TU, VLSEG5E8_V, 0x6 }, // 5204
  { PseudoVLSEG5E8_V_MF2, VLSEG5E8_V, 0x7 }, // 5205
  { PseudoVLSEG5E8_V_MF2_MASK, VLSEG5E8_V, 0x7 }, // 5206
  { PseudoVLSEG5E8_V_MF2_TU, VLSEG5E8_V, 0x7 }, // 5207
  { PseudoVLSEG6E16FF_V_M1, VLSEG6E16FF_V, 0x0 }, // 5208
  { PseudoVLSEG6E16FF_V_M1_MASK, VLSEG6E16FF_V, 0x0 }, // 5209
  { PseudoVLSEG6E16FF_V_M1_TU, VLSEG6E16FF_V, 0x0 }, // 5210
  { PseudoVLSEG6E16FF_V_MF4, VLSEG6E16FF_V, 0x6 }, // 5211
  { PseudoVLSEG6E16FF_V_MF4_MASK, VLSEG6E16FF_V, 0x6 }, // 5212
  { PseudoVLSEG6E16FF_V_MF4_TU, VLSEG6E16FF_V, 0x6 }, // 5213
  { PseudoVLSEG6E16FF_V_MF2, VLSEG6E16FF_V, 0x7 }, // 5214
  { PseudoVLSEG6E16FF_V_MF2_MASK, VLSEG6E16FF_V, 0x7 }, // 5215
  { PseudoVLSEG6E16FF_V_MF2_TU, VLSEG6E16FF_V, 0x7 }, // 5216
  { PseudoVLSEG6E16_V_M1, VLSEG6E16_V, 0x0 }, // 5217
  { PseudoVLSEG6E16_V_M1_MASK, VLSEG6E16_V, 0x0 }, // 5218
  { PseudoVLSEG6E16_V_M1_TU, VLSEG6E16_V, 0x0 }, // 5219
  { PseudoVLSEG6E16_V_MF4, VLSEG6E16_V, 0x6 }, // 5220
  { PseudoVLSEG6E16_V_MF4_MASK, VLSEG6E16_V, 0x6 }, // 5221
  { PseudoVLSEG6E16_V_MF4_TU, VLSEG6E16_V, 0x6 }, // 5222
  { PseudoVLSEG6E16_V_MF2, VLSEG6E16_V, 0x7 }, // 5223
  { PseudoVLSEG6E16_V_MF2_MASK, VLSEG6E16_V, 0x7 }, // 5224
  { PseudoVLSEG6E16_V_MF2_TU, VLSEG6E16_V, 0x7 }, // 5225
  { PseudoVLSEG6E32FF_V_M1, VLSEG6E32FF_V, 0x0 }, // 5226
  { PseudoVLSEG6E32FF_V_M1_MASK, VLSEG6E32FF_V, 0x0 }, // 5227
  { PseudoVLSEG6E32FF_V_M1_TU, VLSEG6E32FF_V, 0x0 }, // 5228
  { PseudoVLSEG6E32FF_V_MF2, VLSEG6E32FF_V, 0x7 }, // 5229
  { PseudoVLSEG6E32FF_V_MF2_MASK, VLSEG6E32FF_V, 0x7 }, // 5230
  { PseudoVLSEG6E32FF_V_MF2_TU, VLSEG6E32FF_V, 0x7 }, // 5231
  { PseudoVLSEG6E32_V_M1, VLSEG6E32_V, 0x0 }, // 5232
  { PseudoVLSEG6E32_V_M1_MASK, VLSEG6E32_V, 0x0 }, // 5233
  { PseudoVLSEG6E32_V_M1_TU, VLSEG6E32_V, 0x0 }, // 5234
  { PseudoVLSEG6E32_V_MF2, VLSEG6E32_V, 0x7 }, // 5235
  { PseudoVLSEG6E32_V_MF2_MASK, VLSEG6E32_V, 0x7 }, // 5236
  { PseudoVLSEG6E32_V_MF2_TU, VLSEG6E32_V, 0x7 }, // 5237
  { PseudoVLSEG6E64FF_V_M1, VLSEG6E64FF_V, 0x0 }, // 5238
  { PseudoVLSEG6E64FF_V_M1_MASK, VLSEG6E64FF_V, 0x0 }, // 5239
  { PseudoVLSEG6E64FF_V_M1_TU, VLSEG6E64FF_V, 0x0 }, // 5240
  { PseudoVLSEG6E64_V_M1, VLSEG6E64_V, 0x0 }, // 5241
  { PseudoVLSEG6E64_V_M1_MASK, VLSEG6E64_V, 0x0 }, // 5242
  { PseudoVLSEG6E64_V_M1_TU, VLSEG6E64_V, 0x0 }, // 5243
  { PseudoVLSEG6E8FF_V_M1, VLSEG6E8FF_V, 0x0 }, // 5244
  { PseudoVLSEG6E8FF_V_M1_MASK, VLSEG6E8FF_V, 0x0 }, // 5245
  { PseudoVLSEG6E8FF_V_M1_TU, VLSEG6E8FF_V, 0x0 }, // 5246
  { PseudoVLSEG6E8FF_V_MF8, VLSEG6E8FF_V, 0x5 }, // 5247
  { PseudoVLSEG6E8FF_V_MF8_MASK, VLSEG6E8FF_V, 0x5 }, // 5248
  { PseudoVLSEG6E8FF_V_MF8_TU, VLSEG6E8FF_V, 0x5 }, // 5249
  { PseudoVLSEG6E8FF_V_MF4, VLSEG6E8FF_V, 0x6 }, // 5250
  { PseudoVLSEG6E8FF_V_MF4_MASK, VLSEG6E8FF_V, 0x6 }, // 5251
  { PseudoVLSEG6E8FF_V_MF4_TU, VLSEG6E8FF_V, 0x6 }, // 5252
  { PseudoVLSEG6E8FF_V_MF2, VLSEG6E8FF_V, 0x7 }, // 5253
  { PseudoVLSEG6E8FF_V_MF2_MASK, VLSEG6E8FF_V, 0x7 }, // 5254
  { PseudoVLSEG6E8FF_V_MF2_TU, VLSEG6E8FF_V, 0x7 }, // 5255
  { PseudoVLSEG6E8_V_M1, VLSEG6E8_V, 0x0 }, // 5256
  { PseudoVLSEG6E8_V_M1_MASK, VLSEG6E8_V, 0x0 }, // 5257
  { PseudoVLSEG6E8_V_M1_TU, VLSEG6E8_V, 0x0 }, // 5258
  { PseudoVLSEG6E8_V_MF8, VLSEG6E8_V, 0x5 }, // 5259
  { PseudoVLSEG6E8_V_MF8_MASK, VLSEG6E8_V, 0x5 }, // 5260
  { PseudoVLSEG6E8_V_MF8_TU, VLSEG6E8_V, 0x5 }, // 5261
  { PseudoVLSEG6E8_V_MF4, VLSEG6E8_V, 0x6 }, // 5262
  { PseudoVLSEG6E8_V_MF4_MASK, VLSEG6E8_V, 0x6 }, // 5263
  { PseudoVLSEG6E8_V_MF4_TU, VLSEG6E8_V, 0x6 }, // 5264
  { PseudoVLSEG6E8_V_MF2, VLSEG6E8_V, 0x7 }, // 5265
  { PseudoVLSEG6E8_V_MF2_MASK, VLSEG6E8_V, 0x7 }, // 5266
  { PseudoVLSEG6E8_V_MF2_TU, VLSEG6E8_V, 0x7 }, // 5267
  { PseudoVLSEG7E16FF_V_M1, VLSEG7E16FF_V, 0x0 }, // 5268
  { PseudoVLSEG7E16FF_V_M1_MASK, VLSEG7E16FF_V, 0x0 }, // 5269
  { PseudoVLSEG7E16FF_V_M1_TU, VLSEG7E16FF_V, 0x0 }, // 5270
  { PseudoVLSEG7E16FF_V_MF4, VLSEG7E16FF_V, 0x6 }, // 5271
  { PseudoVLSEG7E16FF_V_MF4_MASK, VLSEG7E16FF_V, 0x6 }, // 5272
  { PseudoVLSEG7E16FF_V_MF4_TU, VLSEG7E16FF_V, 0x6 }, // 5273
  { PseudoVLSEG7E16FF_V_MF2, VLSEG7E16FF_V, 0x7 }, // 5274
  { PseudoVLSEG7E16FF_V_MF2_MASK, VLSEG7E16FF_V, 0x7 }, // 5275
  { PseudoVLSEG7E16FF_V_MF2_TU, VLSEG7E16FF_V, 0x7 }, // 5276
  { PseudoVLSEG7E16_V_M1, VLSEG7E16_V, 0x0 }, // 5277
  { PseudoVLSEG7E16_V_M1_MASK, VLSEG7E16_V, 0x0 }, // 5278
  { PseudoVLSEG7E16_V_M1_TU, VLSEG7E16_V, 0x0 }, // 5279
  { PseudoVLSEG7E16_V_MF4, VLSEG7E16_V, 0x6 }, // 5280
  { PseudoVLSEG7E16_V_MF4_MASK, VLSEG7E16_V, 0x6 }, // 5281
  { PseudoVLSEG7E16_V_MF4_TU, VLSEG7E16_V, 0x6 }, // 5282
  { PseudoVLSEG7E16_V_MF2, VLSEG7E16_V, 0x7 }, // 5283
  { PseudoVLSEG7E16_V_MF2_MASK, VLSEG7E16_V, 0x7 }, // 5284
  { PseudoVLSEG7E16_V_MF2_TU, VLSEG7E16_V, 0x7 }, // 5285
  { PseudoVLSEG7E32FF_V_M1, VLSEG7E32FF_V, 0x0 }, // 5286
  { PseudoVLSEG7E32FF_V_M1_MASK, VLSEG7E32FF_V, 0x0 }, // 5287
  { PseudoVLSEG7E32FF_V_M1_TU, VLSEG7E32FF_V, 0x0 }, // 5288
  { PseudoVLSEG7E32FF_V_MF2, VLSEG7E32FF_V, 0x7 }, // 5289
  { PseudoVLSEG7E32FF_V_MF2_MASK, VLSEG7E32FF_V, 0x7 }, // 5290
  { PseudoVLSEG7E32FF_V_MF2_TU, VLSEG7E32FF_V, 0x7 }, // 5291
  { PseudoVLSEG7E32_V_M1, VLSEG7E32_V, 0x0 }, // 5292
  { PseudoVLSEG7E32_V_M1_MASK, VLSEG7E32_V, 0x0 }, // 5293
  { PseudoVLSEG7E32_V_M1_TU, VLSEG7E32_V, 0x0 }, // 5294
  { PseudoVLSEG7E32_V_MF2, VLSEG7E32_V, 0x7 }, // 5295
  { PseudoVLSEG7E32_V_MF2_MASK, VLSEG7E32_V, 0x7 }, // 5296
  { PseudoVLSEG7E32_V_MF2_TU, VLSEG7E32_V, 0x7 }, // 5297
  { PseudoVLSEG7E64FF_V_M1, VLSEG7E64FF_V, 0x0 }, // 5298
  { PseudoVLSEG7E64FF_V_M1_MASK, VLSEG7E64FF_V, 0x0 }, // 5299
  { PseudoVLSEG7E64FF_V_M1_TU, VLSEG7E64FF_V, 0x0 }, // 5300
  { PseudoVLSEG7E64_V_M1, VLSEG7E64_V, 0x0 }, // 5301
  { PseudoVLSEG7E64_V_M1_MASK, VLSEG7E64_V, 0x0 }, // 5302
  { PseudoVLSEG7E64_V_M1_TU, VLSEG7E64_V, 0x0 }, // 5303
  { PseudoVLSEG7E8FF_V_M1, VLSEG7E8FF_V, 0x0 }, // 5304
  { PseudoVLSEG7E8FF_V_M1_MASK, VLSEG7E8FF_V, 0x0 }, // 5305
  { PseudoVLSEG7E8FF_V_M1_TU, VLSEG7E8FF_V, 0x0 }, // 5306
  { PseudoVLSEG7E8FF_V_MF8, VLSEG7E8FF_V, 0x5 }, // 5307
  { PseudoVLSEG7E8FF_V_MF8_MASK, VLSEG7E8FF_V, 0x5 }, // 5308
  { PseudoVLSEG7E8FF_V_MF8_TU, VLSEG7E8FF_V, 0x5 }, // 5309
  { PseudoVLSEG7E8FF_V_MF4, VLSEG7E8FF_V, 0x6 }, // 5310
  { PseudoVLSEG7E8FF_V_MF4_MASK, VLSEG7E8FF_V, 0x6 }, // 5311
  { PseudoVLSEG7E8FF_V_MF4_TU, VLSEG7E8FF_V, 0x6 }, // 5312
  { PseudoVLSEG7E8FF_V_MF2, VLSEG7E8FF_V, 0x7 }, // 5313
  { PseudoVLSEG7E8FF_V_MF2_MASK, VLSEG7E8FF_V, 0x7 }, // 5314
  { PseudoVLSEG7E8FF_V_MF2_TU, VLSEG7E8FF_V, 0x7 }, // 5315
  { PseudoVLSEG7E8_V_M1, VLSEG7E8_V, 0x0 }, // 5316
  { PseudoVLSEG7E8_V_M1_MASK, VLSEG7E8_V, 0x0 }, // 5317
  { PseudoVLSEG7E8_V_M1_TU, VLSEG7E8_V, 0x0 }, // 5318
  { PseudoVLSEG7E8_V_MF8, VLSEG7E8_V, 0x5 }, // 5319
  { PseudoVLSEG7E8_V_MF8_MASK, VLSEG7E8_V, 0x5 }, // 5320
  { PseudoVLSEG7E8_V_MF8_TU, VLSEG7E8_V, 0x5 }, // 5321
  { PseudoVLSEG7E8_V_MF4, VLSEG7E8_V, 0x6 }, // 5322
  { PseudoVLSEG7E8_V_MF4_MASK, VLSEG7E8_V, 0x6 }, // 5323
  { PseudoVLSEG7E8_V_MF4_TU, VLSEG7E8_V, 0x6 }, // 5324
  { PseudoVLSEG7E8_V_MF2, VLSEG7E8_V, 0x7 }, // 5325
  { PseudoVLSEG7E8_V_MF2_MASK, VLSEG7E8_V, 0x7 }, // 5326
  { PseudoVLSEG7E8_V_MF2_TU, VLSEG7E8_V, 0x7 }, // 5327
  { PseudoVLSEG8E16FF_V_M1, VLSEG8E16FF_V, 0x0 }, // 5328
  { PseudoVLSEG8E16FF_V_M1_MASK, VLSEG8E16FF_V, 0x0 }, // 5329
  { PseudoVLSEG8E16FF_V_M1_TU, VLSEG8E16FF_V, 0x0 }, // 5330
  { PseudoVLSEG8E16FF_V_MF4, VLSEG8E16FF_V, 0x6 }, // 5331
  { PseudoVLSEG8E16FF_V_MF4_MASK, VLSEG8E16FF_V, 0x6 }, // 5332
  { PseudoVLSEG8E16FF_V_MF4_TU, VLSEG8E16FF_V, 0x6 }, // 5333
  { PseudoVLSEG8E16FF_V_MF2, VLSEG8E16FF_V, 0x7 }, // 5334
  { PseudoVLSEG8E16FF_V_MF2_MASK, VLSEG8E16FF_V, 0x7 }, // 5335
  { PseudoVLSEG8E16FF_V_MF2_TU, VLSEG8E16FF_V, 0x7 }, // 5336
  { PseudoVLSEG8E16_V_M1, VLSEG8E16_V, 0x0 }, // 5337
  { PseudoVLSEG8E16_V_M1_MASK, VLSEG8E16_V, 0x0 }, // 5338
  { PseudoVLSEG8E16_V_M1_TU, VLSEG8E16_V, 0x0 }, // 5339
  { PseudoVLSEG8E16_V_MF4, VLSEG8E16_V, 0x6 }, // 5340
  { PseudoVLSEG8E16_V_MF4_MASK, VLSEG8E16_V, 0x6 }, // 5341
  { PseudoVLSEG8E16_V_MF4_TU, VLSEG8E16_V, 0x6 }, // 5342
  { PseudoVLSEG8E16_V_MF2, VLSEG8E16_V, 0x7 }, // 5343
  { PseudoVLSEG8E16_V_MF2_MASK, VLSEG8E16_V, 0x7 }, // 5344
  { PseudoVLSEG8E16_V_MF2_TU, VLSEG8E16_V, 0x7 }, // 5345
  { PseudoVLSEG8E32FF_V_M1, VLSEG8E32FF_V, 0x0 }, // 5346
  { PseudoVLSEG8E32FF_V_M1_MASK, VLSEG8E32FF_V, 0x0 }, // 5347
  { PseudoVLSEG8E32FF_V_M1_TU, VLSEG8E32FF_V, 0x0 }, // 5348
  { PseudoVLSEG8E32FF_V_MF2, VLSEG8E32FF_V, 0x7 }, // 5349
  { PseudoVLSEG8E32FF_V_MF2_MASK, VLSEG8E32FF_V, 0x7 }, // 5350
  { PseudoVLSEG8E32FF_V_MF2_TU, VLSEG8E32FF_V, 0x7 }, // 5351
  { PseudoVLSEG8E32_V_M1, VLSEG8E32_V, 0x0 }, // 5352
  { PseudoVLSEG8E32_V_M1_MASK, VLSEG8E32_V, 0x0 }, // 5353
  { PseudoVLSEG8E32_V_M1_TU, VLSEG8E32_V, 0x0 }, // 5354
  { PseudoVLSEG8E32_V_MF2, VLSEG8E32_V, 0x7 }, // 5355
  { PseudoVLSEG8E32_V_MF2_MASK, VLSEG8E32_V, 0x7 }, // 5356
  { PseudoVLSEG8E32_V_MF2_TU, VLSEG8E32_V, 0x7 }, // 5357
  { PseudoVLSEG8E64FF_V_M1, VLSEG8E64FF_V, 0x0 }, // 5358
  { PseudoVLSEG8E64FF_V_M1_MASK, VLSEG8E64FF_V, 0x0 }, // 5359
  { PseudoVLSEG8E64FF_V_M1_TU, VLSEG8E64FF_V, 0x0 }, // 5360
  { PseudoVLSEG8E64_V_M1, VLSEG8E64_V, 0x0 }, // 5361
  { PseudoVLSEG8E64_V_M1_MASK, VLSEG8E64_V, 0x0 }, // 5362
  { PseudoVLSEG8E64_V_M1_TU, VLSEG8E64_V, 0x0 }, // 5363
  { PseudoVLSEG8E8FF_V_M1, VLSEG8E8FF_V, 0x0 }, // 5364
  { PseudoVLSEG8E8FF_V_M1_MASK, VLSEG8E8FF_V, 0x0 }, // 5365
  { PseudoVLSEG8E8FF_V_M1_TU, VLSEG8E8FF_V, 0x0 }, // 5366
  { PseudoVLSEG8E8FF_V_MF8, VLSEG8E8FF_V, 0x5 }, // 5367
  { PseudoVLSEG8E8FF_V_MF8_MASK, VLSEG8E8FF_V, 0x5 }, // 5368
  { PseudoVLSEG8E8FF_V_MF8_TU, VLSEG8E8FF_V, 0x5 }, // 5369
  { PseudoVLSEG8E8FF_V_MF4, VLSEG8E8FF_V, 0x6 }, // 5370
  { PseudoVLSEG8E8FF_V_MF4_MASK, VLSEG8E8FF_V, 0x6 }, // 5371
  { PseudoVLSEG8E8FF_V_MF4_TU, VLSEG8E8FF_V, 0x6 }, // 5372
  { PseudoVLSEG8E8FF_V_MF2, VLSEG8E8FF_V, 0x7 }, // 5373
  { PseudoVLSEG8E8FF_V_MF2_MASK, VLSEG8E8FF_V, 0x7 }, // 5374
  { PseudoVLSEG8E8FF_V_MF2_TU, VLSEG8E8FF_V, 0x7 }, // 5375
  { PseudoVLSEG8E8_V_M1, VLSEG8E8_V, 0x0 }, // 5376
  { PseudoVLSEG8E8_V_M1_MASK, VLSEG8E8_V, 0x0 }, // 5377
  { PseudoVLSEG8E8_V_M1_TU, VLSEG8E8_V, 0x0 }, // 5378
  { PseudoVLSEG8E8_V_MF8, VLSEG8E8_V, 0x5 }, // 5379
  { PseudoVLSEG8E8_V_MF8_MASK, VLSEG8E8_V, 0x5 }, // 5380
  { PseudoVLSEG8E8_V_MF8_TU, VLSEG8E8_V, 0x5 }, // 5381
  { PseudoVLSEG8E8_V_MF4, VLSEG8E8_V, 0x6 }, // 5382
  { PseudoVLSEG8E8_V_MF4_MASK, VLSEG8E8_V, 0x6 }, // 5383
  { PseudoVLSEG8E8_V_MF4_TU, VLSEG8E8_V, 0x6 }, // 5384
  { PseudoVLSEG8E8_V_MF2, VLSEG8E8_V, 0x7 }, // 5385
  { PseudoVLSEG8E8_V_MF2_MASK, VLSEG8E8_V, 0x7 }, // 5386
  { PseudoVLSEG8E8_V_MF2_TU, VLSEG8E8_V, 0x7 }, // 5387
  { PseudoVLSSEG2E16_V_M1, VLSSEG2E16_V, 0x0 }, // 5388
  { PseudoVLSSEG2E16_V_M1_MASK, VLSSEG2E16_V, 0x0 }, // 5389
  { PseudoVLSSEG2E16_V_M1_TU, VLSSEG2E16_V, 0x0 }, // 5390
  { PseudoVLSSEG2E16_V_M2, VLSSEG2E16_V, 0x1 }, // 5391
  { PseudoVLSSEG2E16_V_M2_MASK, VLSSEG2E16_V, 0x1 }, // 5392
  { PseudoVLSSEG2E16_V_M2_TU, VLSSEG2E16_V, 0x1 }, // 5393
  { PseudoVLSSEG2E16_V_M4, VLSSEG2E16_V, 0x2 }, // 5394
  { PseudoVLSSEG2E16_V_M4_MASK, VLSSEG2E16_V, 0x2 }, // 5395
  { PseudoVLSSEG2E16_V_M4_TU, VLSSEG2E16_V, 0x2 }, // 5396
  { PseudoVLSSEG2E16_V_MF4, VLSSEG2E16_V, 0x6 }, // 5397
  { PseudoVLSSEG2E16_V_MF4_MASK, VLSSEG2E16_V, 0x6 }, // 5398
  { PseudoVLSSEG2E16_V_MF4_TU, VLSSEG2E16_V, 0x6 }, // 5399
  { PseudoVLSSEG2E16_V_MF2, VLSSEG2E16_V, 0x7 }, // 5400
  { PseudoVLSSEG2E16_V_MF2_MASK, VLSSEG2E16_V, 0x7 }, // 5401
  { PseudoVLSSEG2E16_V_MF2_TU, VLSSEG2E16_V, 0x7 }, // 5402
  { PseudoVLSSEG2E32_V_M1, VLSSEG2E32_V, 0x0 }, // 5403
  { PseudoVLSSEG2E32_V_M1_MASK, VLSSEG2E32_V, 0x0 }, // 5404
  { PseudoVLSSEG2E32_V_M1_TU, VLSSEG2E32_V, 0x0 }, // 5405
  { PseudoVLSSEG2E32_V_M2, VLSSEG2E32_V, 0x1 }, // 5406
  { PseudoVLSSEG2E32_V_M2_MASK, VLSSEG2E32_V, 0x1 }, // 5407
  { PseudoVLSSEG2E32_V_M2_TU, VLSSEG2E32_V, 0x1 }, // 5408
  { PseudoVLSSEG2E32_V_M4, VLSSEG2E32_V, 0x2 }, // 5409
  { PseudoVLSSEG2E32_V_M4_MASK, VLSSEG2E32_V, 0x2 }, // 5410
  { PseudoVLSSEG2E32_V_M4_TU, VLSSEG2E32_V, 0x2 }, // 5411
  { PseudoVLSSEG2E32_V_MF2, VLSSEG2E32_V, 0x7 }, // 5412
  { PseudoVLSSEG2E32_V_MF2_MASK, VLSSEG2E32_V, 0x7 }, // 5413
  { PseudoVLSSEG2E32_V_MF2_TU, VLSSEG2E32_V, 0x7 }, // 5414
  { PseudoVLSSEG2E64_V_M1, VLSSEG2E64_V, 0x0 }, // 5415
  { PseudoVLSSEG2E64_V_M1_MASK, VLSSEG2E64_V, 0x0 }, // 5416
  { PseudoVLSSEG2E64_V_M1_TU, VLSSEG2E64_V, 0x0 }, // 5417
  { PseudoVLSSEG2E64_V_M2, VLSSEG2E64_V, 0x1 }, // 5418
  { PseudoVLSSEG2E64_V_M2_MASK, VLSSEG2E64_V, 0x1 }, // 5419
  { PseudoVLSSEG2E64_V_M2_TU, VLSSEG2E64_V, 0x1 }, // 5420
  { PseudoVLSSEG2E64_V_M4, VLSSEG2E64_V, 0x2 }, // 5421
  { PseudoVLSSEG2E64_V_M4_MASK, VLSSEG2E64_V, 0x2 }, // 5422
  { PseudoVLSSEG2E64_V_M4_TU, VLSSEG2E64_V, 0x2 }, // 5423
  { PseudoVLSSEG2E8_V_M1, VLSSEG2E8_V, 0x0 }, // 5424
  { PseudoVLSSEG2E8_V_M1_MASK, VLSSEG2E8_V, 0x0 }, // 5425
  { PseudoVLSSEG2E8_V_M1_TU, VLSSEG2E8_V, 0x0 }, // 5426
  { PseudoVLSSEG2E8_V_M2, VLSSEG2E8_V, 0x1 }, // 5427
  { PseudoVLSSEG2E8_V_M2_MASK, VLSSEG2E8_V, 0x1 }, // 5428
  { PseudoVLSSEG2E8_V_M2_TU, VLSSEG2E8_V, 0x1 }, // 5429
  { PseudoVLSSEG2E8_V_M4, VLSSEG2E8_V, 0x2 }, // 5430
  { PseudoVLSSEG2E8_V_M4_MASK, VLSSEG2E8_V, 0x2 }, // 5431
  { PseudoVLSSEG2E8_V_M4_TU, VLSSEG2E8_V, 0x2 }, // 5432
  { PseudoVLSSEG2E8_V_MF8, VLSSEG2E8_V, 0x5 }, // 5433
  { PseudoVLSSEG2E8_V_MF8_MASK, VLSSEG2E8_V, 0x5 }, // 5434
  { PseudoVLSSEG2E8_V_MF8_TU, VLSSEG2E8_V, 0x5 }, // 5435
  { PseudoVLSSEG2E8_V_MF4, VLSSEG2E8_V, 0x6 }, // 5436
  { PseudoVLSSEG2E8_V_MF4_MASK, VLSSEG2E8_V, 0x6 }, // 5437
  { PseudoVLSSEG2E8_V_MF4_TU, VLSSEG2E8_V, 0x6 }, // 5438
  { PseudoVLSSEG2E8_V_MF2, VLSSEG2E8_V, 0x7 }, // 5439
  { PseudoVLSSEG2E8_V_MF2_MASK, VLSSEG2E8_V, 0x7 }, // 5440
  { PseudoVLSSEG2E8_V_MF2_TU, VLSSEG2E8_V, 0x7 }, // 5441
  { PseudoVLSSEG3E16_V_M1, VLSSEG3E16_V, 0x0 }, // 5442
  { PseudoVLSSEG3E16_V_M1_MASK, VLSSEG3E16_V, 0x0 }, // 5443
  { PseudoVLSSEG3E16_V_M1_TU, VLSSEG3E16_V, 0x0 }, // 5444
  { PseudoVLSSEG3E16_V_M2, VLSSEG3E16_V, 0x1 }, // 5445
  { PseudoVLSSEG3E16_V_M2_MASK, VLSSEG3E16_V, 0x1 }, // 5446
  { PseudoVLSSEG3E16_V_M2_TU, VLSSEG3E16_V, 0x1 }, // 5447
  { PseudoVLSSEG3E16_V_MF4, VLSSEG3E16_V, 0x6 }, // 5448
  { PseudoVLSSEG3E16_V_MF4_MASK, VLSSEG3E16_V, 0x6 }, // 5449
  { PseudoVLSSEG3E16_V_MF4_TU, VLSSEG3E16_V, 0x6 }, // 5450
  { PseudoVLSSEG3E16_V_MF2, VLSSEG3E16_V, 0x7 }, // 5451
  { PseudoVLSSEG3E16_V_MF2_MASK, VLSSEG3E16_V, 0x7 }, // 5452
  { PseudoVLSSEG3E16_V_MF2_TU, VLSSEG3E16_V, 0x7 }, // 5453
  { PseudoVLSSEG3E32_V_M1, VLSSEG3E32_V, 0x0 }, // 5454
  { PseudoVLSSEG3E32_V_M1_MASK, VLSSEG3E32_V, 0x0 }, // 5455
  { PseudoVLSSEG3E32_V_M1_TU, VLSSEG3E32_V, 0x0 }, // 5456
  { PseudoVLSSEG3E32_V_M2, VLSSEG3E32_V, 0x1 }, // 5457
  { PseudoVLSSEG3E32_V_M2_MASK, VLSSEG3E32_V, 0x1 }, // 5458
  { PseudoVLSSEG3E32_V_M2_TU, VLSSEG3E32_V, 0x1 }, // 5459
  { PseudoVLSSEG3E32_V_MF2, VLSSEG3E32_V, 0x7 }, // 5460
  { PseudoVLSSEG3E32_V_MF2_MASK, VLSSEG3E32_V, 0x7 }, // 5461
  { PseudoVLSSEG3E32_V_MF2_TU, VLSSEG3E32_V, 0x7 }, // 5462
  { PseudoVLSSEG3E64_V_M1, VLSSEG3E64_V, 0x0 }, // 5463
  { PseudoVLSSEG3E64_V_M1_MASK, VLSSEG3E64_V, 0x0 }, // 5464
  { PseudoVLSSEG3E64_V_M1_TU, VLSSEG3E64_V, 0x0 }, // 5465
  { PseudoVLSSEG3E64_V_M2, VLSSEG3E64_V, 0x1 }, // 5466
  { PseudoVLSSEG3E64_V_M2_MASK, VLSSEG3E64_V, 0x1 }, // 5467
  { PseudoVLSSEG3E64_V_M2_TU, VLSSEG3E64_V, 0x1 }, // 5468
  { PseudoVLSSEG3E8_V_M1, VLSSEG3E8_V, 0x0 }, // 5469
  { PseudoVLSSEG3E8_V_M1_MASK, VLSSEG3E8_V, 0x0 }, // 5470
  { PseudoVLSSEG3E8_V_M1_TU, VLSSEG3E8_V, 0x0 }, // 5471
  { PseudoVLSSEG3E8_V_M2, VLSSEG3E8_V, 0x1 }, // 5472
  { PseudoVLSSEG3E8_V_M2_MASK, VLSSEG3E8_V, 0x1 }, // 5473
  { PseudoVLSSEG3E8_V_M2_TU, VLSSEG3E8_V, 0x1 }, // 5474
  { PseudoVLSSEG3E8_V_MF8, VLSSEG3E8_V, 0x5 }, // 5475
  { PseudoVLSSEG3E8_V_MF8_MASK, VLSSEG3E8_V, 0x5 }, // 5476
  { PseudoVLSSEG3E8_V_MF8_TU, VLSSEG3E8_V, 0x5 }, // 5477
  { PseudoVLSSEG3E8_V_MF4, VLSSEG3E8_V, 0x6 }, // 5478
  { PseudoVLSSEG3E8_V_MF4_MASK, VLSSEG3E8_V, 0x6 }, // 5479
  { PseudoVLSSEG3E8_V_MF4_TU, VLSSEG3E8_V, 0x6 }, // 5480
  { PseudoVLSSEG3E8_V_MF2, VLSSEG3E8_V, 0x7 }, // 5481
  { PseudoVLSSEG3E8_V_MF2_MASK, VLSSEG3E8_V, 0x7 }, // 5482
  { PseudoVLSSEG3E8_V_MF2_TU, VLSSEG3E8_V, 0x7 }, // 5483
  { PseudoVLSSEG4E16_V_M1, VLSSEG4E16_V, 0x0 }, // 5484
  { PseudoVLSSEG4E16_V_M1_MASK, VLSSEG4E16_V, 0x0 }, // 5485
  { PseudoVLSSEG4E16_V_M1_TU, VLSSEG4E16_V, 0x0 }, // 5486
  { PseudoVLSSEG4E16_V_M2, VLSSEG4E16_V, 0x1 }, // 5487
  { PseudoVLSSEG4E16_V_M2_MASK, VLSSEG4E16_V, 0x1 }, // 5488
  { PseudoVLSSEG4E16_V_M2_TU, VLSSEG4E16_V, 0x1 }, // 5489
  { PseudoVLSSEG4E16_V_MF4, VLSSEG4E16_V, 0x6 }, // 5490
  { PseudoVLSSEG4E16_V_MF4_MASK, VLSSEG4E16_V, 0x6 }, // 5491
  { PseudoVLSSEG4E16_V_MF4_TU, VLSSEG4E16_V, 0x6 }, // 5492
  { PseudoVLSSEG4E16_V_MF2, VLSSEG4E16_V, 0x7 }, // 5493
  { PseudoVLSSEG4E16_V_MF2_MASK, VLSSEG4E16_V, 0x7 }, // 5494
  { PseudoVLSSEG4E16_V_MF2_TU, VLSSEG4E16_V, 0x7 }, // 5495
  { PseudoVLSSEG4E32_V_M1, VLSSEG4E32_V, 0x0 }, // 5496
  { PseudoVLSSEG4E32_V_M1_MASK, VLSSEG4E32_V, 0x0 }, // 5497
  { PseudoVLSSEG4E32_V_M1_TU, VLSSEG4E32_V, 0x0 }, // 5498
  { PseudoVLSSEG4E32_V_M2, VLSSEG4E32_V, 0x1 }, // 5499
  { PseudoVLSSEG4E32_V_M2_MASK, VLSSEG4E32_V, 0x1 }, // 5500
  { PseudoVLSSEG4E32_V_M2_TU, VLSSEG4E32_V, 0x1 }, // 5501
  { PseudoVLSSEG4E32_V_MF2, VLSSEG4E32_V, 0x7 }, // 5502
  { PseudoVLSSEG4E32_V_MF2_MASK, VLSSEG4E32_V, 0x7 }, // 5503
  { PseudoVLSSEG4E32_V_MF2_TU, VLSSEG4E32_V, 0x7 }, // 5504
  { PseudoVLSSEG4E64_V_M1, VLSSEG4E64_V, 0x0 }, // 5505
  { PseudoVLSSEG4E64_V_M1_MASK, VLSSEG4E64_V, 0x0 }, // 5506
  { PseudoVLSSEG4E64_V_M1_TU, VLSSEG4E64_V, 0x0 }, // 5507
  { PseudoVLSSEG4E64_V_M2, VLSSEG4E64_V, 0x1 }, // 5508
  { PseudoVLSSEG4E64_V_M2_MASK, VLSSEG4E64_V, 0x1 }, // 5509
  { PseudoVLSSEG4E64_V_M2_TU, VLSSEG4E64_V, 0x1 }, // 5510
  { PseudoVLSSEG4E8_V_M1, VLSSEG4E8_V, 0x0 }, // 5511
  { PseudoVLSSEG4E8_V_M1_MASK, VLSSEG4E8_V, 0x0 }, // 5512
  { PseudoVLSSEG4E8_V_M1_TU, VLSSEG4E8_V, 0x0 }, // 5513
  { PseudoVLSSEG4E8_V_M2, VLSSEG4E8_V, 0x1 }, // 5514
  { PseudoVLSSEG4E8_V_M2_MASK, VLSSEG4E8_V, 0x1 }, // 5515
  { PseudoVLSSEG4E8_V_M2_TU, VLSSEG4E8_V, 0x1 }, // 5516
  { PseudoVLSSEG4E8_V_MF8, VLSSEG4E8_V, 0x5 }, // 5517
  { PseudoVLSSEG4E8_V_MF8_MASK, VLSSEG4E8_V, 0x5 }, // 5518
  { PseudoVLSSEG4E8_V_MF8_TU, VLSSEG4E8_V, 0x5 }, // 5519
  { PseudoVLSSEG4E8_V_MF4, VLSSEG4E8_V, 0x6 }, // 5520
  { PseudoVLSSEG4E8_V_MF4_MASK, VLSSEG4E8_V, 0x6 }, // 5521
  { PseudoVLSSEG4E8_V_MF4_TU, VLSSEG4E8_V, 0x6 }, // 5522
  { PseudoVLSSEG4E8_V_MF2, VLSSEG4E8_V, 0x7 }, // 5523
  { PseudoVLSSEG4E8_V_MF2_MASK, VLSSEG4E8_V, 0x7 }, // 5524
  { PseudoVLSSEG4E8_V_MF2_TU, VLSSEG4E8_V, 0x7 }, // 5525
  { PseudoVLSSEG5E16_V_M1, VLSSEG5E16_V, 0x0 }, // 5526
  { PseudoVLSSEG5E16_V_M1_MASK, VLSSEG5E16_V, 0x0 }, // 5527
  { PseudoVLSSEG5E16_V_M1_TU, VLSSEG5E16_V, 0x0 }, // 5528
  { PseudoVLSSEG5E16_V_MF4, VLSSEG5E16_V, 0x6 }, // 5529
  { PseudoVLSSEG5E16_V_MF4_MASK, VLSSEG5E16_V, 0x6 }, // 5530
  { PseudoVLSSEG5E16_V_MF4_TU, VLSSEG5E16_V, 0x6 }, // 5531
  { PseudoVLSSEG5E16_V_MF2, VLSSEG5E16_V, 0x7 }, // 5532
  { PseudoVLSSEG5E16_V_MF2_MASK, VLSSEG5E16_V, 0x7 }, // 5533
  { PseudoVLSSEG5E16_V_MF2_TU, VLSSEG5E16_V, 0x7 }, // 5534
  { PseudoVLSSEG5E32_V_M1, VLSSEG5E32_V, 0x0 }, // 5535
  { PseudoVLSSEG5E32_V_M1_MASK, VLSSEG5E32_V, 0x0 }, // 5536
  { PseudoVLSSEG5E32_V_M1_TU, VLSSEG5E32_V, 0x0 }, // 5537
  { PseudoVLSSEG5E32_V_MF2, VLSSEG5E32_V, 0x7 }, // 5538
  { PseudoVLSSEG5E32_V_MF2_MASK, VLSSEG5E32_V, 0x7 }, // 5539
  { PseudoVLSSEG5E32_V_MF2_TU, VLSSEG5E32_V, 0x7 }, // 5540
  { PseudoVLSSEG5E64_V_M1, VLSSEG5E64_V, 0x0 }, // 5541
  { PseudoVLSSEG5E64_V_M1_MASK, VLSSEG5E64_V, 0x0 }, // 5542
  { PseudoVLSSEG5E64_V_M1_TU, VLSSEG5E64_V, 0x0 }, // 5543
  { PseudoVLSSEG5E8_V_M1, VLSSEG5E8_V, 0x0 }, // 5544
  { PseudoVLSSEG5E8_V_M1_MASK, VLSSEG5E8_V, 0x0 }, // 5545
  { PseudoVLSSEG5E8_V_M1_TU, VLSSEG5E8_V, 0x0 }, // 5546
  { PseudoVLSSEG5E8_V_MF8, VLSSEG5E8_V, 0x5 }, // 5547
  { PseudoVLSSEG5E8_V_MF8_MASK, VLSSEG5E8_V, 0x5 }, // 5548
  { PseudoVLSSEG5E8_V_MF8_TU, VLSSEG5E8_V, 0x5 }, // 5549
  { PseudoVLSSEG5E8_V_MF4, VLSSEG5E8_V, 0x6 }, // 5550
  { PseudoVLSSEG5E8_V_MF4_MASK, VLSSEG5E8_V, 0x6 }, // 5551
  { PseudoVLSSEG5E8_V_MF4_TU, VLSSEG5E8_V, 0x6 }, // 5552
  { PseudoVLSSEG5E8_V_MF2, VLSSEG5E8_V, 0x7 }, // 5553
  { PseudoVLSSEG5E8_V_MF2_MASK, VLSSEG5E8_V, 0x7 }, // 5554
  { PseudoVLSSEG5E8_V_MF2_TU, VLSSEG5E8_V, 0x7 }, // 5555
  { PseudoVLSSEG6E16_V_M1, VLSSEG6E16_V, 0x0 }, // 5556
  { PseudoVLSSEG6E16_V_M1_MASK, VLSSEG6E16_V, 0x0 }, // 5557
  { PseudoVLSSEG6E16_V_M1_TU, VLSSEG6E16_V, 0x0 }, // 5558
  { PseudoVLSSEG6E16_V_MF4, VLSSEG6E16_V, 0x6 }, // 5559
  { PseudoVLSSEG6E16_V_MF4_MASK, VLSSEG6E16_V, 0x6 }, // 5560
  { PseudoVLSSEG6E16_V_MF4_TU, VLSSEG6E16_V, 0x6 }, // 5561
  { PseudoVLSSEG6E16_V_MF2, VLSSEG6E16_V, 0x7 }, // 5562
  { PseudoVLSSEG6E16_V_MF2_MASK, VLSSEG6E16_V, 0x7 }, // 5563
  { PseudoVLSSEG6E16_V_MF2_TU, VLSSEG6E16_V, 0x7 }, // 5564
  { PseudoVLSSEG6E32_V_M1, VLSSEG6E32_V, 0x0 }, // 5565
  { PseudoVLSSEG6E32_V_M1_MASK, VLSSEG6E32_V, 0x0 }, // 5566
  { PseudoVLSSEG6E32_V_M1_TU, VLSSEG6E32_V, 0x0 }, // 5567
  { PseudoVLSSEG6E32_V_MF2, VLSSEG6E32_V, 0x7 }, // 5568
  { PseudoVLSSEG6E32_V_MF2_MASK, VLSSEG6E32_V, 0x7 }, // 5569
  { PseudoVLSSEG6E32_V_MF2_TU, VLSSEG6E32_V, 0x7 }, // 5570
  { PseudoVLSSEG6E64_V_M1, VLSSEG6E64_V, 0x0 }, // 5571
  { PseudoVLSSEG6E64_V_M1_MASK, VLSSEG6E64_V, 0x0 }, // 5572
  { PseudoVLSSEG6E64_V_M1_TU, VLSSEG6E64_V, 0x0 }, // 5573
  { PseudoVLSSEG6E8_V_M1, VLSSEG6E8_V, 0x0 }, // 5574
  { PseudoVLSSEG6E8_V_M1_MASK, VLSSEG6E8_V, 0x0 }, // 5575
  { PseudoVLSSEG6E8_V_M1_TU, VLSSEG6E8_V, 0x0 }, // 5576
  { PseudoVLSSEG6E8_V_MF8, VLSSEG6E8_V, 0x5 }, // 5577
  { PseudoVLSSEG6E8_V_MF8_MASK, VLSSEG6E8_V, 0x5 }, // 5578
  { PseudoVLSSEG6E8_V_MF8_TU, VLSSEG6E8_V, 0x5 }, // 5579
  { PseudoVLSSEG6E8_V_MF4, VLSSEG6E8_V, 0x6 }, // 5580
  { PseudoVLSSEG6E8_V_MF4_MASK, VLSSEG6E8_V, 0x6 }, // 5581
  { PseudoVLSSEG6E8_V_MF4_TU, VLSSEG6E8_V, 0x6 }, // 5582
  { PseudoVLSSEG6E8_V_MF2, VLSSEG6E8_V, 0x7 }, // 5583
  { PseudoVLSSEG6E8_V_MF2_MASK, VLSSEG6E8_V, 0x7 }, // 5584
  { PseudoVLSSEG6E8_V_MF2_TU, VLSSEG6E8_V, 0x7 }, // 5585
  { PseudoVLSSEG7E16_V_M1, VLSSEG7E16_V, 0x0 }, // 5586
  { PseudoVLSSEG7E16_V_M1_MASK, VLSSEG7E16_V, 0x0 }, // 5587
  { PseudoVLSSEG7E16_V_M1_TU, VLSSEG7E16_V, 0x0 }, // 5588
  { PseudoVLSSEG7E16_V_MF4, VLSSEG7E16_V, 0x6 }, // 5589
  { PseudoVLSSEG7E16_V_MF4_MASK, VLSSEG7E16_V, 0x6 }, // 5590
  { PseudoVLSSEG7E16_V_MF4_TU, VLSSEG7E16_V, 0x6 }, // 5591
  { PseudoVLSSEG7E16_V_MF2, VLSSEG7E16_V, 0x7 }, // 5592
  { PseudoVLSSEG7E16_V_MF2_MASK, VLSSEG7E16_V, 0x7 }, // 5593
  { PseudoVLSSEG7E16_V_MF2_TU, VLSSEG7E16_V, 0x7 }, // 5594
  { PseudoVLSSEG7E32_V_M1, VLSSEG7E32_V, 0x0 }, // 5595
  { PseudoVLSSEG7E32_V_M1_MASK, VLSSEG7E32_V, 0x0 }, // 5596
  { PseudoVLSSEG7E32_V_M1_TU, VLSSEG7E32_V, 0x0 }, // 5597
  { PseudoVLSSEG7E32_V_MF2, VLSSEG7E32_V, 0x7 }, // 5598
  { PseudoVLSSEG7E32_V_MF2_MASK, VLSSEG7E32_V, 0x7 }, // 5599
  { PseudoVLSSEG7E32_V_MF2_TU, VLSSEG7E32_V, 0x7 }, // 5600
  { PseudoVLSSEG7E64_V_M1, VLSSEG7E64_V, 0x0 }, // 5601
  { PseudoVLSSEG7E64_V_M1_MASK, VLSSEG7E64_V, 0x0 }, // 5602
  { PseudoVLSSEG7E64_V_M1_TU, VLSSEG7E64_V, 0x0 }, // 5603
  { PseudoVLSSEG7E8_V_M1, VLSSEG7E8_V, 0x0 }, // 5604
  { PseudoVLSSEG7E8_V_M1_MASK, VLSSEG7E8_V, 0x0 }, // 5605
  { PseudoVLSSEG7E8_V_M1_TU, VLSSEG7E8_V, 0x0 }, // 5606
  { PseudoVLSSEG7E8_V_MF8, VLSSEG7E8_V, 0x5 }, // 5607
  { PseudoVLSSEG7E8_V_MF8_MASK, VLSSEG7E8_V, 0x5 }, // 5608
  { PseudoVLSSEG7E8_V_MF8_TU, VLSSEG7E8_V, 0x5 }, // 5609
  { PseudoVLSSEG7E8_V_MF4, VLSSEG7E8_V, 0x6 }, // 5610
  { PseudoVLSSEG7E8_V_MF4_MASK, VLSSEG7E8_V, 0x6 }, // 5611
  { PseudoVLSSEG7E8_V_MF4_TU, VLSSEG7E8_V, 0x6 }, // 5612
  { PseudoVLSSEG7E8_V_MF2, VLSSEG7E8_V, 0x7 }, // 5613
  { PseudoVLSSEG7E8_V_MF2_MASK, VLSSEG7E8_V, 0x7 }, // 5614
  { PseudoVLSSEG7E8_V_MF2_TU, VLSSEG7E8_V, 0x7 }, // 5615
  { PseudoVLSSEG8E16_V_M1, VLSSEG8E16_V, 0x0 }, // 5616
  { PseudoVLSSEG8E16_V_M1_MASK, VLSSEG8E16_V, 0x0 }, // 5617
  { PseudoVLSSEG8E16_V_M1_TU, VLSSEG8E16_V, 0x0 }, // 5618
  { PseudoVLSSEG8E16_V_MF4, VLSSEG8E16_V, 0x6 }, // 5619
  { PseudoVLSSEG8E16_V_MF4_MASK, VLSSEG8E16_V, 0x6 }, // 5620
  { PseudoVLSSEG8E16_V_MF4_TU, VLSSEG8E16_V, 0x6 }, // 5621
  { PseudoVLSSEG8E16_V_MF2, VLSSEG8E16_V, 0x7 }, // 5622
  { PseudoVLSSEG8E16_V_MF2_MASK, VLSSEG8E16_V, 0x7 }, // 5623
  { PseudoVLSSEG8E16_V_MF2_TU, VLSSEG8E16_V, 0x7 }, // 5624
  { PseudoVLSSEG8E32_V_M1, VLSSEG8E32_V, 0x0 }, // 5625
  { PseudoVLSSEG8E32_V_M1_MASK, VLSSEG8E32_V, 0x0 }, // 5626
  { PseudoVLSSEG8E32_V_M1_TU, VLSSEG8E32_V, 0x0 }, // 5627
  { PseudoVLSSEG8E32_V_MF2, VLSSEG8E32_V, 0x7 }, // 5628
  { PseudoVLSSEG8E32_V_MF2_MASK, VLSSEG8E32_V, 0x7 }, // 5629
  { PseudoVLSSEG8E32_V_MF2_TU, VLSSEG8E32_V, 0x7 }, // 5630
  { PseudoVLSSEG8E64_V_M1, VLSSEG8E64_V, 0x0 }, // 5631
  { PseudoVLSSEG8E64_V_M1_MASK, VLSSEG8E64_V, 0x0 }, // 5632
  { PseudoVLSSEG8E64_V_M1_TU, VLSSEG8E64_V, 0x0 }, // 5633
  { PseudoVLSSEG8E8_V_M1, VLSSEG8E8_V, 0x0 }, // 5634
  { PseudoVLSSEG8E8_V_M1_MASK, VLSSEG8E8_V, 0x0 }, // 5635
  { PseudoVLSSEG8E8_V_M1_TU, VLSSEG8E8_V, 0x0 }, // 5636
  { PseudoVLSSEG8E8_V_MF8, VLSSEG8E8_V, 0x5 }, // 5637
  { PseudoVLSSEG8E8_V_MF8_MASK, VLSSEG8E8_V, 0x5 }, // 5638
  { PseudoVLSSEG8E8_V_MF8_TU, VLSSEG8E8_V, 0x5 }, // 5639
  { PseudoVLSSEG8E8_V_MF4, VLSSEG8E8_V, 0x6 }, // 5640
  { PseudoVLSSEG8E8_V_MF4_MASK, VLSSEG8E8_V, 0x6 }, // 5641
  { PseudoVLSSEG8E8_V_MF4_TU, VLSSEG8E8_V, 0x6 }, // 5642
  { PseudoVLSSEG8E8_V_MF2, VLSSEG8E8_V, 0x7 }, // 5643
  { PseudoVLSSEG8E8_V_MF2_MASK, VLSSEG8E8_V, 0x7 }, // 5644
  { PseudoVLSSEG8E8_V_MF2_TU, VLSSEG8E8_V, 0x7 }, // 5645
  { PseudoVLUXEI16_V_M1_M1, VLUXEI16_V, 0x0 }, // 5646
  { PseudoVLUXEI16_V_M1_M1_MASK, VLUXEI16_V, 0x0 }, // 5647
  { PseudoVLUXEI16_V_M1_M1_TU, VLUXEI16_V, 0x0 }, // 5648
  { PseudoVLUXEI16_V_M2_M1, VLUXEI16_V, 0x0 }, // 5649
  { PseudoVLUXEI16_V_M2_M1_MASK, VLUXEI16_V, 0x0 }, // 5650
  { PseudoVLUXEI16_V_M2_M1_TU, VLUXEI16_V, 0x0 }, // 5651
  { PseudoVLUXEI16_V_MF2_M1, VLUXEI16_V, 0x0 }, // 5652
  { PseudoVLUXEI16_V_MF2_M1_MASK, VLUXEI16_V, 0x0 }, // 5653
  { PseudoVLUXEI16_V_MF2_M1_TU, VLUXEI16_V, 0x0 }, // 5654
  { PseudoVLUXEI16_V_MF4_M1, VLUXEI16_V, 0x0 }, // 5655
  { PseudoVLUXEI16_V_MF4_M1_MASK, VLUXEI16_V, 0x0 }, // 5656
  { PseudoVLUXEI16_V_MF4_M1_TU, VLUXEI16_V, 0x0 }, // 5657
  { PseudoVLUXEI16_V_M1_M2, VLUXEI16_V, 0x1 }, // 5658
  { PseudoVLUXEI16_V_M1_M2_MASK, VLUXEI16_V, 0x1 }, // 5659
  { PseudoVLUXEI16_V_M1_M2_TU, VLUXEI16_V, 0x1 }, // 5660
  { PseudoVLUXEI16_V_M2_M2, VLUXEI16_V, 0x1 }, // 5661
  { PseudoVLUXEI16_V_M2_M2_MASK, VLUXEI16_V, 0x1 }, // 5662
  { PseudoVLUXEI16_V_M2_M2_TU, VLUXEI16_V, 0x1 }, // 5663
  { PseudoVLUXEI16_V_M4_M2, VLUXEI16_V, 0x1 }, // 5664
  { PseudoVLUXEI16_V_M4_M2_MASK, VLUXEI16_V, 0x1 }, // 5665
  { PseudoVLUXEI16_V_M4_M2_TU, VLUXEI16_V, 0x1 }, // 5666
  { PseudoVLUXEI16_V_MF2_M2, VLUXEI16_V, 0x1 }, // 5667
  { PseudoVLUXEI16_V_MF2_M2_MASK, VLUXEI16_V, 0x1 }, // 5668
  { PseudoVLUXEI16_V_MF2_M2_TU, VLUXEI16_V, 0x1 }, // 5669
  { PseudoVLUXEI16_V_M1_M4, VLUXEI16_V, 0x2 }, // 5670
  { PseudoVLUXEI16_V_M1_M4_MASK, VLUXEI16_V, 0x2 }, // 5671
  { PseudoVLUXEI16_V_M1_M4_TU, VLUXEI16_V, 0x2 }, // 5672
  { PseudoVLUXEI16_V_M2_M4, VLUXEI16_V, 0x2 }, // 5673
  { PseudoVLUXEI16_V_M2_M4_MASK, VLUXEI16_V, 0x2 }, // 5674
  { PseudoVLUXEI16_V_M2_M4_TU, VLUXEI16_V, 0x2 }, // 5675
  { PseudoVLUXEI16_V_M4_M4, VLUXEI16_V, 0x2 }, // 5676
  { PseudoVLUXEI16_V_M4_M4_MASK, VLUXEI16_V, 0x2 }, // 5677
  { PseudoVLUXEI16_V_M4_M4_TU, VLUXEI16_V, 0x2 }, // 5678
  { PseudoVLUXEI16_V_M8_M4, VLUXEI16_V, 0x2 }, // 5679
  { PseudoVLUXEI16_V_M8_M4_MASK, VLUXEI16_V, 0x2 }, // 5680
  { PseudoVLUXEI16_V_M8_M4_TU, VLUXEI16_V, 0x2 }, // 5681
  { PseudoVLUXEI16_V_M2_M8, VLUXEI16_V, 0x3 }, // 5682
  { PseudoVLUXEI16_V_M2_M8_MASK, VLUXEI16_V, 0x3 }, // 5683
  { PseudoVLUXEI16_V_M2_M8_TU, VLUXEI16_V, 0x3 }, // 5684
  { PseudoVLUXEI16_V_M4_M8, VLUXEI16_V, 0x3 }, // 5685
  { PseudoVLUXEI16_V_M4_M8_MASK, VLUXEI16_V, 0x3 }, // 5686
  { PseudoVLUXEI16_V_M4_M8_TU, VLUXEI16_V, 0x3 }, // 5687
  { PseudoVLUXEI16_V_M8_M8, VLUXEI16_V, 0x3 }, // 5688
  { PseudoVLUXEI16_V_M8_M8_MASK, VLUXEI16_V, 0x3 }, // 5689
  { PseudoVLUXEI16_V_M8_M8_TU, VLUXEI16_V, 0x3 }, // 5690
  { PseudoVLUXEI16_V_MF4_MF8, VLUXEI16_V, 0x5 }, // 5691
  { PseudoVLUXEI16_V_MF4_MF8_MASK, VLUXEI16_V, 0x5 }, // 5692
  { PseudoVLUXEI16_V_MF4_MF8_TU, VLUXEI16_V, 0x5 }, // 5693
  { PseudoVLUXEI16_V_MF2_MF4, VLUXEI16_V, 0x6 }, // 5694
  { PseudoVLUXEI16_V_MF2_MF4_MASK, VLUXEI16_V, 0x6 }, // 5695
  { PseudoVLUXEI16_V_MF2_MF4_TU, VLUXEI16_V, 0x6 }, // 5696
  { PseudoVLUXEI16_V_MF4_MF4, VLUXEI16_V, 0x6 }, // 5697
  { PseudoVLUXEI16_V_MF4_MF4_MASK, VLUXEI16_V, 0x6 }, // 5698
  { PseudoVLUXEI16_V_MF4_MF4_TU, VLUXEI16_V, 0x6 }, // 5699
  { PseudoVLUXEI16_V_M1_MF2, VLUXEI16_V, 0x7 }, // 5700
  { PseudoVLUXEI16_V_M1_MF2_MASK, VLUXEI16_V, 0x7 }, // 5701
  { PseudoVLUXEI16_V_M1_MF2_TU, VLUXEI16_V, 0x7 }, // 5702
  { PseudoVLUXEI16_V_MF2_MF2, VLUXEI16_V, 0x7 }, // 5703
  { PseudoVLUXEI16_V_MF2_MF2_MASK, VLUXEI16_V, 0x7 }, // 5704
  { PseudoVLUXEI16_V_MF2_MF2_TU, VLUXEI16_V, 0x7 }, // 5705
  { PseudoVLUXEI16_V_MF4_MF2, VLUXEI16_V, 0x7 }, // 5706
  { PseudoVLUXEI16_V_MF4_MF2_MASK, VLUXEI16_V, 0x7 }, // 5707
  { PseudoVLUXEI16_V_MF4_MF2_TU, VLUXEI16_V, 0x7 }, // 5708
  { PseudoVLUXEI32_V_M1_M1, VLUXEI32_V, 0x0 }, // 5709
  { PseudoVLUXEI32_V_M1_M1_MASK, VLUXEI32_V, 0x0 }, // 5710
  { PseudoVLUXEI32_V_M1_M1_TU, VLUXEI32_V, 0x0 }, // 5711
  { PseudoVLUXEI32_V_M2_M1, VLUXEI32_V, 0x0 }, // 5712
  { PseudoVLUXEI32_V_M2_M1_MASK, VLUXEI32_V, 0x0 }, // 5713
  { PseudoVLUXEI32_V_M2_M1_TU, VLUXEI32_V, 0x0 }, // 5714
  { PseudoVLUXEI32_V_M4_M1, VLUXEI32_V, 0x0 }, // 5715
  { PseudoVLUXEI32_V_M4_M1_MASK, VLUXEI32_V, 0x0 }, // 5716
  { PseudoVLUXEI32_V_M4_M1_TU, VLUXEI32_V, 0x0 }, // 5717
  { PseudoVLUXEI32_V_MF2_M1, VLUXEI32_V, 0x0 }, // 5718
  { PseudoVLUXEI32_V_MF2_M1_MASK, VLUXEI32_V, 0x0 }, // 5719
  { PseudoVLUXEI32_V_MF2_M1_TU, VLUXEI32_V, 0x0 }, // 5720
  { PseudoVLUXEI32_V_M1_M2, VLUXEI32_V, 0x1 }, // 5721
  { PseudoVLUXEI32_V_M1_M2_MASK, VLUXEI32_V, 0x1 }, // 5722
  { PseudoVLUXEI32_V_M1_M2_TU, VLUXEI32_V, 0x1 }, // 5723
  { PseudoVLUXEI32_V_M2_M2, VLUXEI32_V, 0x1 }, // 5724
  { PseudoVLUXEI32_V_M2_M2_MASK, VLUXEI32_V, 0x1 }, // 5725
  { PseudoVLUXEI32_V_M2_M2_TU, VLUXEI32_V, 0x1 }, // 5726
  { PseudoVLUXEI32_V_M4_M2, VLUXEI32_V, 0x1 }, // 5727
  { PseudoVLUXEI32_V_M4_M2_MASK, VLUXEI32_V, 0x1 }, // 5728
  { PseudoVLUXEI32_V_M4_M2_TU, VLUXEI32_V, 0x1 }, // 5729
  { PseudoVLUXEI32_V_M8_M2, VLUXEI32_V, 0x1 }, // 5730
  { PseudoVLUXEI32_V_M8_M2_MASK, VLUXEI32_V, 0x1 }, // 5731
  { PseudoVLUXEI32_V_M8_M2_TU, VLUXEI32_V, 0x1 }, // 5732
  { PseudoVLUXEI32_V_M2_M4, VLUXEI32_V, 0x2 }, // 5733
  { PseudoVLUXEI32_V_M2_M4_MASK, VLUXEI32_V, 0x2 }, // 5734
  { PseudoVLUXEI32_V_M2_M4_TU, VLUXEI32_V, 0x2 }, // 5735
  { PseudoVLUXEI32_V_M4_M4, VLUXEI32_V, 0x2 }, // 5736
  { PseudoVLUXEI32_V_M4_M4_MASK, VLUXEI32_V, 0x2 }, // 5737
  { PseudoVLUXEI32_V_M4_M4_TU, VLUXEI32_V, 0x2 }, // 5738
  { PseudoVLUXEI32_V_M8_M4, VLUXEI32_V, 0x2 }, // 5739
  { PseudoVLUXEI32_V_M8_M4_MASK, VLUXEI32_V, 0x2 }, // 5740
  { PseudoVLUXEI32_V_M8_M4_TU, VLUXEI32_V, 0x2 }, // 5741
  { PseudoVLUXEI32_V_M4_M8, VLUXEI32_V, 0x3 }, // 5742
  { PseudoVLUXEI32_V_M4_M8_MASK, VLUXEI32_V, 0x3 }, // 5743
  { PseudoVLUXEI32_V_M4_M8_TU, VLUXEI32_V, 0x3 }, // 5744
  { PseudoVLUXEI32_V_M8_M8, VLUXEI32_V, 0x3 }, // 5745
  { PseudoVLUXEI32_V_M8_M8_MASK, VLUXEI32_V, 0x3 }, // 5746
  { PseudoVLUXEI32_V_M8_M8_TU, VLUXEI32_V, 0x3 }, // 5747
  { PseudoVLUXEI32_V_MF2_MF8, VLUXEI32_V, 0x5 }, // 5748
  { PseudoVLUXEI32_V_MF2_MF8_MASK, VLUXEI32_V, 0x5 }, // 5749
  { PseudoVLUXEI32_V_MF2_MF8_TU, VLUXEI32_V, 0x5 }, // 5750
  { PseudoVLUXEI32_V_M1_MF4, VLUXEI32_V, 0x6 }, // 5751
  { PseudoVLUXEI32_V_M1_MF4_MASK, VLUXEI32_V, 0x6 }, // 5752
  { PseudoVLUXEI32_V_M1_MF4_TU, VLUXEI32_V, 0x6 }, // 5753
  { PseudoVLUXEI32_V_MF2_MF4, VLUXEI32_V, 0x6 }, // 5754
  { PseudoVLUXEI32_V_MF2_MF4_MASK, VLUXEI32_V, 0x6 }, // 5755
  { PseudoVLUXEI32_V_MF2_MF4_TU, VLUXEI32_V, 0x6 }, // 5756
  { PseudoVLUXEI32_V_M1_MF2, VLUXEI32_V, 0x7 }, // 5757
  { PseudoVLUXEI32_V_M1_MF2_MASK, VLUXEI32_V, 0x7 }, // 5758
  { PseudoVLUXEI32_V_M1_MF2_TU, VLUXEI32_V, 0x7 }, // 5759
  { PseudoVLUXEI32_V_M2_MF2, VLUXEI32_V, 0x7 }, // 5760
  { PseudoVLUXEI32_V_M2_MF2_MASK, VLUXEI32_V, 0x7 }, // 5761
  { PseudoVLUXEI32_V_M2_MF2_TU, VLUXEI32_V, 0x7 }, // 5762
  { PseudoVLUXEI32_V_MF2_MF2, VLUXEI32_V, 0x7 }, // 5763
  { PseudoVLUXEI32_V_MF2_MF2_MASK, VLUXEI32_V, 0x7 }, // 5764
  { PseudoVLUXEI32_V_MF2_MF2_TU, VLUXEI32_V, 0x7 }, // 5765
  { PseudoVLUXEI64_V_M1_M1, VLUXEI64_V, 0x0 }, // 5766
  { PseudoVLUXEI64_V_M1_M1_MASK, VLUXEI64_V, 0x0 }, // 5767
  { PseudoVLUXEI64_V_M1_M1_TU, VLUXEI64_V, 0x0 }, // 5768
  { PseudoVLUXEI64_V_M2_M1, VLUXEI64_V, 0x0 }, // 5769
  { PseudoVLUXEI64_V_M2_M1_MASK, VLUXEI64_V, 0x0 }, // 5770
  { PseudoVLUXEI64_V_M2_M1_TU, VLUXEI64_V, 0x0 }, // 5771
  { PseudoVLUXEI64_V_M4_M1, VLUXEI64_V, 0x0 }, // 5772
  { PseudoVLUXEI64_V_M4_M1_MASK, VLUXEI64_V, 0x0 }, // 5773
  { PseudoVLUXEI64_V_M4_M1_TU, VLUXEI64_V, 0x0 }, // 5774
  { PseudoVLUXEI64_V_M8_M1, VLUXEI64_V, 0x0 }, // 5775
  { PseudoVLUXEI64_V_M8_M1_MASK, VLUXEI64_V, 0x0 }, // 5776
  { PseudoVLUXEI64_V_M8_M1_TU, VLUXEI64_V, 0x0 }, // 5777
  { PseudoVLUXEI64_V_M2_M2, VLUXEI64_V, 0x1 }, // 5778
  { PseudoVLUXEI64_V_M2_M2_MASK, VLUXEI64_V, 0x1 }, // 5779
  { PseudoVLUXEI64_V_M2_M2_TU, VLUXEI64_V, 0x1 }, // 5780
  { PseudoVLUXEI64_V_M4_M2, VLUXEI64_V, 0x1 }, // 5781
  { PseudoVLUXEI64_V_M4_M2_MASK, VLUXEI64_V, 0x1 }, // 5782
  { PseudoVLUXEI64_V_M4_M2_TU, VLUXEI64_V, 0x1 }, // 5783
  { PseudoVLUXEI64_V_M8_M2, VLUXEI64_V, 0x1 }, // 5784
  { PseudoVLUXEI64_V_M8_M2_MASK, VLUXEI64_V, 0x1 }, // 5785
  { PseudoVLUXEI64_V_M8_M2_TU, VLUXEI64_V, 0x1 }, // 5786
  { PseudoVLUXEI64_V_M4_M4, VLUXEI64_V, 0x2 }, // 5787
  { PseudoVLUXEI64_V_M4_M4_MASK, VLUXEI64_V, 0x2 }, // 5788
  { PseudoVLUXEI64_V_M4_M4_TU, VLUXEI64_V, 0x2 }, // 5789
  { PseudoVLUXEI64_V_M8_M4, VLUXEI64_V, 0x2 }, // 5790
  { PseudoVLUXEI64_V_M8_M4_MASK, VLUXEI64_V, 0x2 }, // 5791
  { PseudoVLUXEI64_V_M8_M4_TU, VLUXEI64_V, 0x2 }, // 5792
  { PseudoVLUXEI64_V_M8_M8, VLUXEI64_V, 0x3 }, // 5793
  { PseudoVLUXEI64_V_M8_M8_MASK, VLUXEI64_V, 0x3 }, // 5794
  { PseudoVLUXEI64_V_M8_M8_TU, VLUXEI64_V, 0x3 }, // 5795
  { PseudoVLUXEI64_V_M1_MF8, VLUXEI64_V, 0x5 }, // 5796
  { PseudoVLUXEI64_V_M1_MF8_MASK, VLUXEI64_V, 0x5 }, // 5797
  { PseudoVLUXEI64_V_M1_MF8_TU, VLUXEI64_V, 0x5 }, // 5798
  { PseudoVLUXEI64_V_M1_MF4, VLUXEI64_V, 0x6 }, // 5799
  { PseudoVLUXEI64_V_M1_MF4_MASK, VLUXEI64_V, 0x6 }, // 5800
  { PseudoVLUXEI64_V_M1_MF4_TU, VLUXEI64_V, 0x6 }, // 5801
  { PseudoVLUXEI64_V_M2_MF4, VLUXEI64_V, 0x6 }, // 5802
  { PseudoVLUXEI64_V_M2_MF4_MASK, VLUXEI64_V, 0x6 }, // 5803
  { PseudoVLUXEI64_V_M2_MF4_TU, VLUXEI64_V, 0x6 }, // 5804
  { PseudoVLUXEI64_V_M1_MF2, VLUXEI64_V, 0x7 }, // 5805
  { PseudoVLUXEI64_V_M1_MF2_MASK, VLUXEI64_V, 0x7 }, // 5806
  { PseudoVLUXEI64_V_M1_MF2_TU, VLUXEI64_V, 0x7 }, // 5807
  { PseudoVLUXEI64_V_M2_MF2, VLUXEI64_V, 0x7 }, // 5808
  { PseudoVLUXEI64_V_M2_MF2_MASK, VLUXEI64_V, 0x7 }, // 5809
  { PseudoVLUXEI64_V_M2_MF2_TU, VLUXEI64_V, 0x7 }, // 5810
  { PseudoVLUXEI64_V_M4_MF2, VLUXEI64_V, 0x7 }, // 5811
  { PseudoVLUXEI64_V_M4_MF2_MASK, VLUXEI64_V, 0x7 }, // 5812
  { PseudoVLUXEI64_V_M4_MF2_TU, VLUXEI64_V, 0x7 }, // 5813
  { PseudoVLUXEI8_V_M1_M1, VLUXEI8_V, 0x0 }, // 5814
  { PseudoVLUXEI8_V_M1_M1_MASK, VLUXEI8_V, 0x0 }, // 5815
  { PseudoVLUXEI8_V_M1_M1_TU, VLUXEI8_V, 0x0 }, // 5816
  { PseudoVLUXEI8_V_MF2_M1, VLUXEI8_V, 0x0 }, // 5817
  { PseudoVLUXEI8_V_MF2_M1_MASK, VLUXEI8_V, 0x0 }, // 5818
  { PseudoVLUXEI8_V_MF2_M1_TU, VLUXEI8_V, 0x0 }, // 5819
  { PseudoVLUXEI8_V_MF4_M1, VLUXEI8_V, 0x0 }, // 5820
  { PseudoVLUXEI8_V_MF4_M1_MASK, VLUXEI8_V, 0x0 }, // 5821
  { PseudoVLUXEI8_V_MF4_M1_TU, VLUXEI8_V, 0x0 }, // 5822
  { PseudoVLUXEI8_V_MF8_M1, VLUXEI8_V, 0x0 }, // 5823
  { PseudoVLUXEI8_V_MF8_M1_MASK, VLUXEI8_V, 0x0 }, // 5824
  { PseudoVLUXEI8_V_MF8_M1_TU, VLUXEI8_V, 0x0 }, // 5825
  { PseudoVLUXEI8_V_M1_M2, VLUXEI8_V, 0x1 }, // 5826
  { PseudoVLUXEI8_V_M1_M2_MASK, VLUXEI8_V, 0x1 }, // 5827
  { PseudoVLUXEI8_V_M1_M2_TU, VLUXEI8_V, 0x1 }, // 5828
  { PseudoVLUXEI8_V_M2_M2, VLUXEI8_V, 0x1 }, // 5829
  { PseudoVLUXEI8_V_M2_M2_MASK, VLUXEI8_V, 0x1 }, // 5830
  { PseudoVLUXEI8_V_M2_M2_TU, VLUXEI8_V, 0x1 }, // 5831
  { PseudoVLUXEI8_V_MF2_M2, VLUXEI8_V, 0x1 }, // 5832
  { PseudoVLUXEI8_V_MF2_M2_MASK, VLUXEI8_V, 0x1 }, // 5833
  { PseudoVLUXEI8_V_MF2_M2_TU, VLUXEI8_V, 0x1 }, // 5834
  { PseudoVLUXEI8_V_MF4_M2, VLUXEI8_V, 0x1 }, // 5835
  { PseudoVLUXEI8_V_MF4_M2_MASK, VLUXEI8_V, 0x1 }, // 5836
  { PseudoVLUXEI8_V_MF4_M2_TU, VLUXEI8_V, 0x1 }, // 5837
  { PseudoVLUXEI8_V_M1_M4, VLUXEI8_V, 0x2 }, // 5838
  { PseudoVLUXEI8_V_M1_M4_MASK, VLUXEI8_V, 0x2 }, // 5839
  { PseudoVLUXEI8_V_M1_M4_TU, VLUXEI8_V, 0x2 }, // 5840
  { PseudoVLUXEI8_V_M2_M4, VLUXEI8_V, 0x2 }, // 5841
  { PseudoVLUXEI8_V_M2_M4_MASK, VLUXEI8_V, 0x2 }, // 5842
  { PseudoVLUXEI8_V_M2_M4_TU, VLUXEI8_V, 0x2 }, // 5843
  { PseudoVLUXEI8_V_M4_M4, VLUXEI8_V, 0x2 }, // 5844
  { PseudoVLUXEI8_V_M4_M4_MASK, VLUXEI8_V, 0x2 }, // 5845
  { PseudoVLUXEI8_V_M4_M4_TU, VLUXEI8_V, 0x2 }, // 5846
  { PseudoVLUXEI8_V_MF2_M4, VLUXEI8_V, 0x2 }, // 5847
  { PseudoVLUXEI8_V_MF2_M4_MASK, VLUXEI8_V, 0x2 }, // 5848
  { PseudoVLUXEI8_V_MF2_M4_TU, VLUXEI8_V, 0x2 }, // 5849
  { PseudoVLUXEI8_V_M1_M8, VLUXEI8_V, 0x3 }, // 5850
  { PseudoVLUXEI8_V_M1_M8_MASK, VLUXEI8_V, 0x3 }, // 5851
  { PseudoVLUXEI8_V_M1_M8_TU, VLUXEI8_V, 0x3 }, // 5852
  { PseudoVLUXEI8_V_M2_M8, VLUXEI8_V, 0x3 }, // 5853
  { PseudoVLUXEI8_V_M2_M8_MASK, VLUXEI8_V, 0x3 }, // 5854
  { PseudoVLUXEI8_V_M2_M8_TU, VLUXEI8_V, 0x3 }, // 5855
  { PseudoVLUXEI8_V_M4_M8, VLUXEI8_V, 0x3 }, // 5856
  { PseudoVLUXEI8_V_M4_M8_MASK, VLUXEI8_V, 0x3 }, // 5857
  { PseudoVLUXEI8_V_M4_M8_TU, VLUXEI8_V, 0x3 }, // 5858
  { PseudoVLUXEI8_V_M8_M8, VLUXEI8_V, 0x3 }, // 5859
  { PseudoVLUXEI8_V_M8_M8_MASK, VLUXEI8_V, 0x3 }, // 5860
  { PseudoVLUXEI8_V_M8_M8_TU, VLUXEI8_V, 0x3 }, // 5861
  { PseudoVLUXEI8_V_MF8_MF8, VLUXEI8_V, 0x5 }, // 5862
  { PseudoVLUXEI8_V_MF8_MF8_MASK, VLUXEI8_V, 0x5 }, // 5863
  { PseudoVLUXEI8_V_MF8_MF8_TU, VLUXEI8_V, 0x5 }, // 5864
  { PseudoVLUXEI8_V_MF4_MF4, VLUXEI8_V, 0x6 }, // 5865
  { PseudoVLUXEI8_V_MF4_MF4_MASK, VLUXEI8_V, 0x6 }, // 5866
  { PseudoVLUXEI8_V_MF4_MF4_TU, VLUXEI8_V, 0x6 }, // 5867
  { PseudoVLUXEI8_V_MF8_MF4, VLUXEI8_V, 0x6 }, // 5868
  { PseudoVLUXEI8_V_MF8_MF4_MASK, VLUXEI8_V, 0x6 }, // 5869
  { PseudoVLUXEI8_V_MF8_MF4_TU, VLUXEI8_V, 0x6 }, // 5870
  { PseudoVLUXEI8_V_MF2_MF2, VLUXEI8_V, 0x7 }, // 5871
  { PseudoVLUXEI8_V_MF2_MF2_MASK, VLUXEI8_V, 0x7 }, // 5872
  { PseudoVLUXEI8_V_MF2_MF2_TU, VLUXEI8_V, 0x7 }, // 5873
  { PseudoVLUXEI8_V_MF4_MF2, VLUXEI8_V, 0x7 }, // 5874
  { PseudoVLUXEI8_V_MF4_MF2_MASK, VLUXEI8_V, 0x7 }, // 5875
  { PseudoVLUXEI8_V_MF4_MF2_TU, VLUXEI8_V, 0x7 }, // 5876
  { PseudoVLUXEI8_V_MF8_MF2, VLUXEI8_V, 0x7 }, // 5877
  { PseudoVLUXEI8_V_MF8_MF2_MASK, VLUXEI8_V, 0x7 }, // 5878
  { PseudoVLUXEI8_V_MF8_MF2_TU, VLUXEI8_V, 0x7 }, // 5879
  { PseudoVLUXSEG2EI16_V_M1_M1, VLUXSEG2EI16_V, 0x0 }, // 5880
  { PseudoVLUXSEG2EI16_V_M1_M1_MASK, VLUXSEG2EI16_V, 0x0 }, // 5881
  { PseudoVLUXSEG2EI16_V_M1_M1_TU, VLUXSEG2EI16_V, 0x0 }, // 5882
  { PseudoVLUXSEG2EI16_V_M2_M1, VLUXSEG2EI16_V, 0x0 }, // 5883
  { PseudoVLUXSEG2EI16_V_M2_M1_MASK, VLUXSEG2EI16_V, 0x0 }, // 5884
  { PseudoVLUXSEG2EI16_V_M2_M1_TU, VLUXSEG2EI16_V, 0x0 }, // 5885
  { PseudoVLUXSEG2EI16_V_MF2_M1, VLUXSEG2EI16_V, 0x0 }, // 5886
  { PseudoVLUXSEG2EI16_V_MF2_M1_MASK, VLUXSEG2EI16_V, 0x0 }, // 5887
  { PseudoVLUXSEG2EI16_V_MF2_M1_TU, VLUXSEG2EI16_V, 0x0 }, // 5888
  { PseudoVLUXSEG2EI16_V_MF4_M1, VLUXSEG2EI16_V, 0x0 }, // 5889
  { PseudoVLUXSEG2EI16_V_MF4_M1_MASK, VLUXSEG2EI16_V, 0x0 }, // 5890
  { PseudoVLUXSEG2EI16_V_MF4_M1_TU, VLUXSEG2EI16_V, 0x0 }, // 5891
  { PseudoVLUXSEG2EI16_V_M1_M2, VLUXSEG2EI16_V, 0x1 }, // 5892
  { PseudoVLUXSEG2EI16_V_M1_M2_MASK, VLUXSEG2EI16_V, 0x1 }, // 5893
  { PseudoVLUXSEG2EI16_V_M1_M2_TU, VLUXSEG2EI16_V, 0x1 }, // 5894
  { PseudoVLUXSEG2EI16_V_M2_M2, VLUXSEG2EI16_V, 0x1 }, // 5895
  { PseudoVLUXSEG2EI16_V_M2_M2_MASK, VLUXSEG2EI16_V, 0x1 }, // 5896
  { PseudoVLUXSEG2EI16_V_M2_M2_TU, VLUXSEG2EI16_V, 0x1 }, // 5897
  { PseudoVLUXSEG2EI16_V_M4_M2, VLUXSEG2EI16_V, 0x1 }, // 5898
  { PseudoVLUXSEG2EI16_V_M4_M2_MASK, VLUXSEG2EI16_V, 0x1 }, // 5899
  { PseudoVLUXSEG2EI16_V_M4_M2_TU, VLUXSEG2EI16_V, 0x1 }, // 5900
  { PseudoVLUXSEG2EI16_V_MF2_M2, VLUXSEG2EI16_V, 0x1 }, // 5901
  { PseudoVLUXSEG2EI16_V_MF2_M2_MASK, VLUXSEG2EI16_V, 0x1 }, // 5902
  { PseudoVLUXSEG2EI16_V_MF2_M2_TU, VLUXSEG2EI16_V, 0x1 }, // 5903
  { PseudoVLUXSEG2EI16_V_M1_M4, VLUXSEG2EI16_V, 0x2 }, // 5904
  { PseudoVLUXSEG2EI16_V_M1_M4_MASK, VLUXSEG2EI16_V, 0x2 }, // 5905
  { PseudoVLUXSEG2EI16_V_M1_M4_TU, VLUXSEG2EI16_V, 0x2 }, // 5906
  { PseudoVLUXSEG2EI16_V_M2_M4, VLUXSEG2EI16_V, 0x2 }, // 5907
  { PseudoVLUXSEG2EI16_V_M2_M4_MASK, VLUXSEG2EI16_V, 0x2 }, // 5908
  { PseudoVLUXSEG2EI16_V_M2_M4_TU, VLUXSEG2EI16_V, 0x2 }, // 5909
  { PseudoVLUXSEG2EI16_V_M4_M4, VLUXSEG2EI16_V, 0x2 }, // 5910
  { PseudoVLUXSEG2EI16_V_M4_M4_MASK, VLUXSEG2EI16_V, 0x2 }, // 5911
  { PseudoVLUXSEG2EI16_V_M4_M4_TU, VLUXSEG2EI16_V, 0x2 }, // 5912
  { PseudoVLUXSEG2EI16_V_M8_M4, VLUXSEG2EI16_V, 0x2 }, // 5913
  { PseudoVLUXSEG2EI16_V_M8_M4_MASK, VLUXSEG2EI16_V, 0x2 }, // 5914
  { PseudoVLUXSEG2EI16_V_M8_M4_TU, VLUXSEG2EI16_V, 0x2 }, // 5915
  { PseudoVLUXSEG2EI16_V_MF4_MF8, VLUXSEG2EI16_V, 0x5 }, // 5916
  { PseudoVLUXSEG2EI16_V_MF4_MF8_MASK, VLUXSEG2EI16_V, 0x5 }, // 5917
  { PseudoVLUXSEG2EI16_V_MF4_MF8_TU, VLUXSEG2EI16_V, 0x5 }, // 5918
  { PseudoVLUXSEG2EI16_V_MF2_MF4, VLUXSEG2EI16_V, 0x6 }, // 5919
  { PseudoVLUXSEG2EI16_V_MF2_MF4_MASK, VLUXSEG2EI16_V, 0x6 }, // 5920
  { PseudoVLUXSEG2EI16_V_MF2_MF4_TU, VLUXSEG2EI16_V, 0x6 }, // 5921
  { PseudoVLUXSEG2EI16_V_MF4_MF4, VLUXSEG2EI16_V, 0x6 }, // 5922
  { PseudoVLUXSEG2EI16_V_MF4_MF4_MASK, VLUXSEG2EI16_V, 0x6 }, // 5923
  { PseudoVLUXSEG2EI16_V_MF4_MF4_TU, VLUXSEG2EI16_V, 0x6 }, // 5924
  { PseudoVLUXSEG2EI16_V_M1_MF2, VLUXSEG2EI16_V, 0x7 }, // 5925
  { PseudoVLUXSEG2EI16_V_M1_MF2_MASK, VLUXSEG2EI16_V, 0x7 }, // 5926
  { PseudoVLUXSEG2EI16_V_M1_MF2_TU, VLUXSEG2EI16_V, 0x7 }, // 5927
  { PseudoVLUXSEG2EI16_V_MF2_MF2, VLUXSEG2EI16_V, 0x7 }, // 5928
  { PseudoVLUXSEG2EI16_V_MF2_MF2_MASK, VLUXSEG2EI16_V, 0x7 }, // 5929
  { PseudoVLUXSEG2EI16_V_MF2_MF2_TU, VLUXSEG2EI16_V, 0x7 }, // 5930
  { PseudoVLUXSEG2EI16_V_MF4_MF2, VLUXSEG2EI16_V, 0x7 }, // 5931
  { PseudoVLUXSEG2EI16_V_MF4_MF2_MASK, VLUXSEG2EI16_V, 0x7 }, // 5932
  { PseudoVLUXSEG2EI16_V_MF4_MF2_TU, VLUXSEG2EI16_V, 0x7 }, // 5933
  { PseudoVLUXSEG2EI32_V_M1_M1, VLUXSEG2EI32_V, 0x0 }, // 5934
  { PseudoVLUXSEG2EI32_V_M1_M1_MASK, VLUXSEG2EI32_V, 0x0 }, // 5935
  { PseudoVLUXSEG2EI32_V_M1_M1_TU, VLUXSEG2EI32_V, 0x0 }, // 5936
  { PseudoVLUXSEG2EI32_V_M2_M1, VLUXSEG2EI32_V, 0x0 }, // 5937
  { PseudoVLUXSEG2EI32_V_M2_M1_MASK, VLUXSEG2EI32_V, 0x0 }, // 5938
  { PseudoVLUXSEG2EI32_V_M2_M1_TU, VLUXSEG2EI32_V, 0x0 }, // 5939
  { PseudoVLUXSEG2EI32_V_M4_M1, VLUXSEG2EI32_V, 0x0 }, // 5940
  { PseudoVLUXSEG2EI32_V_M4_M1_MASK, VLUXSEG2EI32_V, 0x0 }, // 5941
  { PseudoVLUXSEG2EI32_V_M4_M1_TU, VLUXSEG2EI32_V, 0x0 }, // 5942
  { PseudoVLUXSEG2EI32_V_MF2_M1, VLUXSEG2EI32_V, 0x0 }, // 5943
  { PseudoVLUXSEG2EI32_V_MF2_M1_MASK, VLUXSEG2EI32_V, 0x0 }, // 5944
  { PseudoVLUXSEG2EI32_V_MF2_M1_TU, VLUXSEG2EI32_V, 0x0 }, // 5945
  { PseudoVLUXSEG2EI32_V_M1_M2, VLUXSEG2EI32_V, 0x1 }, // 5946
  { PseudoVLUXSEG2EI32_V_M1_M2_MASK, VLUXSEG2EI32_V, 0x1 }, // 5947
  { PseudoVLUXSEG2EI32_V_M1_M2_TU, VLUXSEG2EI32_V, 0x1 }, // 5948
  { PseudoVLUXSEG2EI32_V_M2_M2, VLUXSEG2EI32_V, 0x1 }, // 5949
  { PseudoVLUXSEG2EI32_V_M2_M2_MASK, VLUXSEG2EI32_V, 0x1 }, // 5950
  { PseudoVLUXSEG2EI32_V_M2_M2_TU, VLUXSEG2EI32_V, 0x1 }, // 5951
  { PseudoVLUXSEG2EI32_V_M4_M2, VLUXSEG2EI32_V, 0x1 }, // 5952
  { PseudoVLUXSEG2EI32_V_M4_M2_MASK, VLUXSEG2EI32_V, 0x1 }, // 5953
  { PseudoVLUXSEG2EI32_V_M4_M2_TU, VLUXSEG2EI32_V, 0x1 }, // 5954
  { PseudoVLUXSEG2EI32_V_M8_M2, VLUXSEG2EI32_V, 0x1 }, // 5955
  { PseudoVLUXSEG2EI32_V_M8_M2_MASK, VLUXSEG2EI32_V, 0x1 }, // 5956
  { PseudoVLUXSEG2EI32_V_M8_M2_TU, VLUXSEG2EI32_V, 0x1 }, // 5957
  { PseudoVLUXSEG2EI32_V_M2_M4, VLUXSEG2EI32_V, 0x2 }, // 5958
  { PseudoVLUXSEG2EI32_V_M2_M4_MASK, VLUXSEG2EI32_V, 0x2 }, // 5959
  { PseudoVLUXSEG2EI32_V_M2_M4_TU, VLUXSEG2EI32_V, 0x2 }, // 5960
  { PseudoVLUXSEG2EI32_V_M4_M4, VLUXSEG2EI32_V, 0x2 }, // 5961
  { PseudoVLUXSEG2EI32_V_M4_M4_MASK, VLUXSEG2EI32_V, 0x2 }, // 5962
  { PseudoVLUXSEG2EI32_V_M4_M4_TU, VLUXSEG2EI32_V, 0x2 }, // 5963
  { PseudoVLUXSEG2EI32_V_M8_M4, VLUXSEG2EI32_V, 0x2 }, // 5964
  { PseudoVLUXSEG2EI32_V_M8_M4_MASK, VLUXSEG2EI32_V, 0x2 }, // 5965
  { PseudoVLUXSEG2EI32_V_M8_M4_TU, VLUXSEG2EI32_V, 0x2 }, // 5966
  { PseudoVLUXSEG2EI32_V_MF2_MF8, VLUXSEG2EI32_V, 0x5 }, // 5967
  { PseudoVLUXSEG2EI32_V_MF2_MF8_MASK, VLUXSEG2EI32_V, 0x5 }, // 5968
  { PseudoVLUXSEG2EI32_V_MF2_MF8_TU, VLUXSEG2EI32_V, 0x5 }, // 5969
  { PseudoVLUXSEG2EI32_V_M1_MF4, VLUXSEG2EI32_V, 0x6 }, // 5970
  { PseudoVLUXSEG2EI32_V_M1_MF4_MASK, VLUXSEG2EI32_V, 0x6 }, // 5971
  { PseudoVLUXSEG2EI32_V_M1_MF4_TU, VLUXSEG2EI32_V, 0x6 }, // 5972
  { PseudoVLUXSEG2EI32_V_MF2_MF4, VLUXSEG2EI32_V, 0x6 }, // 5973
  { PseudoVLUXSEG2EI32_V_MF2_MF4_MASK, VLUXSEG2EI32_V, 0x6 }, // 5974
  { PseudoVLUXSEG2EI32_V_MF2_MF4_TU, VLUXSEG2EI32_V, 0x6 }, // 5975
  { PseudoVLUXSEG2EI32_V_M1_MF2, VLUXSEG2EI32_V, 0x7 }, // 5976
  { PseudoVLUXSEG2EI32_V_M1_MF2_MASK, VLUXSEG2EI32_V, 0x7 }, // 5977
  { PseudoVLUXSEG2EI32_V_M1_MF2_TU, VLUXSEG2EI32_V, 0x7 }, // 5978
  { PseudoVLUXSEG2EI32_V_M2_MF2, VLUXSEG2EI32_V, 0x7 }, // 5979
  { PseudoVLUXSEG2EI32_V_M2_MF2_MASK, VLUXSEG2EI32_V, 0x7 }, // 5980
  { PseudoVLUXSEG2EI32_V_M2_MF2_TU, VLUXSEG2EI32_V, 0x7 }, // 5981
  { PseudoVLUXSEG2EI32_V_MF2_MF2, VLUXSEG2EI32_V, 0x7 }, // 5982
  { PseudoVLUXSEG2EI32_V_MF2_MF2_MASK, VLUXSEG2EI32_V, 0x7 }, // 5983
  { PseudoVLUXSEG2EI32_V_MF2_MF2_TU, VLUXSEG2EI32_V, 0x7 }, // 5984
  { PseudoVLUXSEG2EI64_V_M1_M1, VLUXSEG2EI64_V, 0x0 }, // 5985
  { PseudoVLUXSEG2EI64_V_M1_M1_MASK, VLUXSEG2EI64_V, 0x0 }, // 5986
  { PseudoVLUXSEG2EI64_V_M1_M1_TU, VLUXSEG2EI64_V, 0x0 }, // 5987
  { PseudoVLUXSEG2EI64_V_M2_M1, VLUXSEG2EI64_V, 0x0 }, // 5988
  { PseudoVLUXSEG2EI64_V_M2_M1_MASK, VLUXSEG2EI64_V, 0x0 }, // 5989
  { PseudoVLUXSEG2EI64_V_M2_M1_TU, VLUXSEG2EI64_V, 0x0 }, // 5990
  { PseudoVLUXSEG2EI64_V_M4_M1, VLUXSEG2EI64_V, 0x0 }, // 5991
  { PseudoVLUXSEG2EI64_V_M4_M1_MASK, VLUXSEG2EI64_V, 0x0 }, // 5992
  { PseudoVLUXSEG2EI64_V_M4_M1_TU, VLUXSEG2EI64_V, 0x0 }, // 5993
  { PseudoVLUXSEG2EI64_V_M8_M1, VLUXSEG2EI64_V, 0x0 }, // 5994
  { PseudoVLUXSEG2EI64_V_M8_M1_MASK, VLUXSEG2EI64_V, 0x0 }, // 5995
  { PseudoVLUXSEG2EI64_V_M8_M1_TU, VLUXSEG2EI64_V, 0x0 }, // 5996
  { PseudoVLUXSEG2EI64_V_M2_M2, VLUXSEG2EI64_V, 0x1 }, // 5997
  { PseudoVLUXSEG2EI64_V_M2_M2_MASK, VLUXSEG2EI64_V, 0x1 }, // 5998
  { PseudoVLUXSEG2EI64_V_M2_M2_TU, VLUXSEG2EI64_V, 0x1 }, // 5999
  { PseudoVLUXSEG2EI64_V_M4_M2, VLUXSEG2EI64_V, 0x1 }, // 6000
  { PseudoVLUXSEG2EI64_V_M4_M2_MASK, VLUXSEG2EI64_V, 0x1 }, // 6001
  { PseudoVLUXSEG2EI64_V_M4_M2_TU, VLUXSEG2EI64_V, 0x1 }, // 6002
  { PseudoVLUXSEG2EI64_V_M8_M2, VLUXSEG2EI64_V, 0x1 }, // 6003
  { PseudoVLUXSEG2EI64_V_M8_M2_MASK, VLUXSEG2EI64_V, 0x1 }, // 6004
  { PseudoVLUXSEG2EI64_V_M8_M2_TU, VLUXSEG2EI64_V, 0x1 }, // 6005
  { PseudoVLUXSEG2EI64_V_M4_M4, VLUXSEG2EI64_V, 0x2 }, // 6006
  { PseudoVLUXSEG2EI64_V_M4_M4_MASK, VLUXSEG2EI64_V, 0x2 }, // 6007
  { PseudoVLUXSEG2EI64_V_M4_M4_TU, VLUXSEG2EI64_V, 0x2 }, // 6008
  { PseudoVLUXSEG2EI64_V_M8_M4, VLUXSEG2EI64_V, 0x2 }, // 6009
  { PseudoVLUXSEG2EI64_V_M8_M4_MASK, VLUXSEG2EI64_V, 0x2 }, // 6010
  { PseudoVLUXSEG2EI64_V_M8_M4_TU, VLUXSEG2EI64_V, 0x2 }, // 6011
  { PseudoVLUXSEG2EI64_V_M1_MF8, VLUXSEG2EI64_V, 0x5 }, // 6012
  { PseudoVLUXSEG2EI64_V_M1_MF8_MASK, VLUXSEG2EI64_V, 0x5 }, // 6013
  { PseudoVLUXSEG2EI64_V_M1_MF8_TU, VLUXSEG2EI64_V, 0x5 }, // 6014
  { PseudoVLUXSEG2EI64_V_M1_MF4, VLUXSEG2EI64_V, 0x6 }, // 6015
  { PseudoVLUXSEG2EI64_V_M1_MF4_MASK, VLUXSEG2EI64_V, 0x6 }, // 6016
  { PseudoVLUXSEG2EI64_V_M1_MF4_TU, VLUXSEG2EI64_V, 0x6 }, // 6017
  { PseudoVLUXSEG2EI64_V_M2_MF4, VLUXSEG2EI64_V, 0x6 }, // 6018
  { PseudoVLUXSEG2EI64_V_M2_MF4_MASK, VLUXSEG2EI64_V, 0x6 }, // 6019
  { PseudoVLUXSEG2EI64_V_M2_MF4_TU, VLUXSEG2EI64_V, 0x6 }, // 6020
  { PseudoVLUXSEG2EI64_V_M1_MF2, VLUXSEG2EI64_V, 0x7 }, // 6021
  { PseudoVLUXSEG2EI64_V_M1_MF2_MASK, VLUXSEG2EI64_V, 0x7 }, // 6022
  { PseudoVLUXSEG2EI64_V_M1_MF2_TU, VLUXSEG2EI64_V, 0x7 }, // 6023
  { PseudoVLUXSEG2EI64_V_M2_MF2, VLUXSEG2EI64_V, 0x7 }, // 6024
  { PseudoVLUXSEG2EI64_V_M2_MF2_MASK, VLUXSEG2EI64_V, 0x7 }, // 6025
  { PseudoVLUXSEG2EI64_V_M2_MF2_TU, VLUXSEG2EI64_V, 0x7 }, // 6026
  { PseudoVLUXSEG2EI64_V_M4_MF2, VLUXSEG2EI64_V, 0x7 }, // 6027
  { PseudoVLUXSEG2EI64_V_M4_MF2_MASK, VLUXSEG2EI64_V, 0x7 }, // 6028
  { PseudoVLUXSEG2EI64_V_M4_MF2_TU, VLUXSEG2EI64_V, 0x7 }, // 6029
  { PseudoVLUXSEG2EI8_V_M1_M1, VLUXSEG2EI8_V, 0x0 }, // 6030
  { PseudoVLUXSEG2EI8_V_M1_M1_MASK, VLUXSEG2EI8_V, 0x0 }, // 6031
  { PseudoVLUXSEG2EI8_V_M1_M1_TU, VLUXSEG2EI8_V, 0x0 }, // 6032
  { PseudoVLUXSEG2EI8_V_MF2_M1, VLUXSEG2EI8_V, 0x0 }, // 6033
  { PseudoVLUXSEG2EI8_V_MF2_M1_MASK, VLUXSEG2EI8_V, 0x0 }, // 6034
  { PseudoVLUXSEG2EI8_V_MF2_M1_TU, VLUXSEG2EI8_V, 0x0 }, // 6035
  { PseudoVLUXSEG2EI8_V_MF4_M1, VLUXSEG2EI8_V, 0x0 }, // 6036
  { PseudoVLUXSEG2EI8_V_MF4_M1_MASK, VLUXSEG2EI8_V, 0x0 }, // 6037
  { PseudoVLUXSEG2EI8_V_MF4_M1_TU, VLUXSEG2EI8_V, 0x0 }, // 6038
  { PseudoVLUXSEG2EI8_V_MF8_M1, VLUXSEG2EI8_V, 0x0 }, // 6039
  { PseudoVLUXSEG2EI8_V_MF8_M1_MASK, VLUXSEG2EI8_V, 0x0 }, // 6040
  { PseudoVLUXSEG2EI8_V_MF8_M1_TU, VLUXSEG2EI8_V, 0x0 }, // 6041
  { PseudoVLUXSEG2EI8_V_M1_M2, VLUXSEG2EI8_V, 0x1 }, // 6042
  { PseudoVLUXSEG2EI8_V_M1_M2_MASK, VLUXSEG2EI8_V, 0x1 }, // 6043
  { PseudoVLUXSEG2EI8_V_M1_M2_TU, VLUXSEG2EI8_V, 0x1 }, // 6044
  { PseudoVLUXSEG2EI8_V_M2_M2, VLUXSEG2EI8_V, 0x1 }, // 6045
  { PseudoVLUXSEG2EI8_V_M2_M2_MASK, VLUXSEG2EI8_V, 0x1 }, // 6046
  { PseudoVLUXSEG2EI8_V_M2_M2_TU, VLUXSEG2EI8_V, 0x1 }, // 6047
  { PseudoVLUXSEG2EI8_V_MF2_M2, VLUXSEG2EI8_V, 0x1 }, // 6048
  { PseudoVLUXSEG2EI8_V_MF2_M2_MASK, VLUXSEG2EI8_V, 0x1 }, // 6049
  { PseudoVLUXSEG2EI8_V_MF2_M2_TU, VLUXSEG2EI8_V, 0x1 }, // 6050
  { PseudoVLUXSEG2EI8_V_MF4_M2, VLUXSEG2EI8_V, 0x1 }, // 6051
  { PseudoVLUXSEG2EI8_V_MF4_M2_MASK, VLUXSEG2EI8_V, 0x1 }, // 6052
  { PseudoVLUXSEG2EI8_V_MF4_M2_TU, VLUXSEG2EI8_V, 0x1 }, // 6053
  { PseudoVLUXSEG2EI8_V_M1_M4, VLUXSEG2EI8_V, 0x2 }, // 6054
  { PseudoVLUXSEG2EI8_V_M1_M4_MASK, VLUXSEG2EI8_V, 0x2 }, // 6055
  { PseudoVLUXSEG2EI8_V_M1_M4_TU, VLUXSEG2EI8_V, 0x2 }, // 6056
  { PseudoVLUXSEG2EI8_V_M2_M4, VLUXSEG2EI8_V, 0x2 }, // 6057
  { PseudoVLUXSEG2EI8_V_M2_M4_MASK, VLUXSEG2EI8_V, 0x2 }, // 6058
  { PseudoVLUXSEG2EI8_V_M2_M4_TU, VLUXSEG2EI8_V, 0x2 }, // 6059
  { PseudoVLUXSEG2EI8_V_M4_M4, VLUXSEG2EI8_V, 0x2 }, // 6060
  { PseudoVLUXSEG2EI8_V_M4_M4_MASK, VLUXSEG2EI8_V, 0x2 }, // 6061
  { PseudoVLUXSEG2EI8_V_M4_M4_TU, VLUXSEG2EI8_V, 0x2 }, // 6062
  { PseudoVLUXSEG2EI8_V_MF2_M4, VLUXSEG2EI8_V, 0x2 }, // 6063
  { PseudoVLUXSEG2EI8_V_MF2_M4_MASK, VLUXSEG2EI8_V, 0x2 }, // 6064
  { PseudoVLUXSEG2EI8_V_MF2_M4_TU, VLUXSEG2EI8_V, 0x2 }, // 6065
  { PseudoVLUXSEG2EI8_V_MF8_MF8, VLUXSEG2EI8_V, 0x5 }, // 6066
  { PseudoVLUXSEG2EI8_V_MF8_MF8_MASK, VLUXSEG2EI8_V, 0x5 }, // 6067
  { PseudoVLUXSEG2EI8_V_MF8_MF8_TU, VLUXSEG2EI8_V, 0x5 }, // 6068
  { PseudoVLUXSEG2EI8_V_MF4_MF4, VLUXSEG2EI8_V, 0x6 }, // 6069
  { PseudoVLUXSEG2EI8_V_MF4_MF4_MASK, VLUXSEG2EI8_V, 0x6 }, // 6070
  { PseudoVLUXSEG2EI8_V_MF4_MF4_TU, VLUXSEG2EI8_V, 0x6 }, // 6071
  { PseudoVLUXSEG2EI8_V_MF8_MF4, VLUXSEG2EI8_V, 0x6 }, // 6072
  { PseudoVLUXSEG2EI8_V_MF8_MF4_MASK, VLUXSEG2EI8_V, 0x6 }, // 6073
  { PseudoVLUXSEG2EI8_V_MF8_MF4_TU, VLUXSEG2EI8_V, 0x6 }, // 6074
  { PseudoVLUXSEG2EI8_V_MF2_MF2, VLUXSEG2EI8_V, 0x7 }, // 6075
  { PseudoVLUXSEG2EI8_V_MF2_MF2_MASK, VLUXSEG2EI8_V, 0x7 }, // 6076
  { PseudoVLUXSEG2EI8_V_MF2_MF2_TU, VLUXSEG2EI8_V, 0x7 }, // 6077
  { PseudoVLUXSEG2EI8_V_MF4_MF2, VLUXSEG2EI8_V, 0x7 }, // 6078
  { PseudoVLUXSEG2EI8_V_MF4_MF2_MASK, VLUXSEG2EI8_V, 0x7 }, // 6079
  { PseudoVLUXSEG2EI8_V_MF4_MF2_TU, VLUXSEG2EI8_V, 0x7 }, // 6080
  { PseudoVLUXSEG2EI8_V_MF8_MF2, VLUXSEG2EI8_V, 0x7 }, // 6081
  { PseudoVLUXSEG2EI8_V_MF8_MF2_MASK, VLUXSEG2EI8_V, 0x7 }, // 6082
  { PseudoVLUXSEG2EI8_V_MF8_MF2_TU, VLUXSEG2EI8_V, 0x7 }, // 6083
  { PseudoVLUXSEG3EI16_V_M1_M1, VLUXSEG3EI16_V, 0x0 }, // 6084
  { PseudoVLUXSEG3EI16_V_M1_M1_MASK, VLUXSEG3EI16_V, 0x0 }, // 6085
  { PseudoVLUXSEG3EI16_V_M1_M1_TU, VLUXSEG3EI16_V, 0x0 }, // 6086
  { PseudoVLUXSEG3EI16_V_M2_M1, VLUXSEG3EI16_V, 0x0 }, // 6087
  { PseudoVLUXSEG3EI16_V_M2_M1_MASK, VLUXSEG3EI16_V, 0x0 }, // 6088
  { PseudoVLUXSEG3EI16_V_M2_M1_TU, VLUXSEG3EI16_V, 0x0 }, // 6089
  { PseudoVLUXSEG3EI16_V_MF2_M1, VLUXSEG3EI16_V, 0x0 }, // 6090
  { PseudoVLUXSEG3EI16_V_MF2_M1_MASK, VLUXSEG3EI16_V, 0x0 }, // 6091
  { PseudoVLUXSEG3EI16_V_MF2_M1_TU, VLUXSEG3EI16_V, 0x0 }, // 6092
  { PseudoVLUXSEG3EI16_V_MF4_M1, VLUXSEG3EI16_V, 0x0 }, // 6093
  { PseudoVLUXSEG3EI16_V_MF4_M1_MASK, VLUXSEG3EI16_V, 0x0 }, // 6094
  { PseudoVLUXSEG3EI16_V_MF4_M1_TU, VLUXSEG3EI16_V, 0x0 }, // 6095
  { PseudoVLUXSEG3EI16_V_M1_M2, VLUXSEG3EI16_V, 0x1 }, // 6096
  { PseudoVLUXSEG3EI16_V_M1_M2_MASK, VLUXSEG3EI16_V, 0x1 }, // 6097
  { PseudoVLUXSEG3EI16_V_M1_M2_TU, VLUXSEG3EI16_V, 0x1 }, // 6098
  { PseudoVLUXSEG3EI16_V_M2_M2, VLUXSEG3EI16_V, 0x1 }, // 6099
  { PseudoVLUXSEG3EI16_V_M2_M2_MASK, VLUXSEG3EI16_V, 0x1 }, // 6100
  { PseudoVLUXSEG3EI16_V_M2_M2_TU, VLUXSEG3EI16_V, 0x1 }, // 6101
  { PseudoVLUXSEG3EI16_V_M4_M2, VLUXSEG3EI16_V, 0x1 }, // 6102
  { PseudoVLUXSEG3EI16_V_M4_M2_MASK, VLUXSEG3EI16_V, 0x1 }, // 6103
  { PseudoVLUXSEG3EI16_V_M4_M2_TU, VLUXSEG3EI16_V, 0x1 }, // 6104
  { PseudoVLUXSEG3EI16_V_MF2_M2, VLUXSEG3EI16_V, 0x1 }, // 6105
  { PseudoVLUXSEG3EI16_V_MF2_M2_MASK, VLUXSEG3EI16_V, 0x1 }, // 6106
  { PseudoVLUXSEG3EI16_V_MF2_M2_TU, VLUXSEG3EI16_V, 0x1 }, // 6107
  { PseudoVLUXSEG3EI16_V_MF4_MF8, VLUXSEG3EI16_V, 0x5 }, // 6108
  { PseudoVLUXSEG3EI16_V_MF4_MF8_MASK, VLUXSEG3EI16_V, 0x5 }, // 6109
  { PseudoVLUXSEG3EI16_V_MF4_MF8_TU, VLUXSEG3EI16_V, 0x5 }, // 6110
  { PseudoVLUXSEG3EI16_V_MF2_MF4, VLUXSEG3EI16_V, 0x6 }, // 6111
  { PseudoVLUXSEG3EI16_V_MF2_MF4_MASK, VLUXSEG3EI16_V, 0x6 }, // 6112
  { PseudoVLUXSEG3EI16_V_MF2_MF4_TU, VLUXSEG3EI16_V, 0x6 }, // 6113
  { PseudoVLUXSEG3EI16_V_MF4_MF4, VLUXSEG3EI16_V, 0x6 }, // 6114
  { PseudoVLUXSEG3EI16_V_MF4_MF4_MASK, VLUXSEG3EI16_V, 0x6 }, // 6115
  { PseudoVLUXSEG3EI16_V_MF4_MF4_TU, VLUXSEG3EI16_V, 0x6 }, // 6116
  { PseudoVLUXSEG3EI16_V_M1_MF2, VLUXSEG3EI16_V, 0x7 }, // 6117
  { PseudoVLUXSEG3EI16_V_M1_MF2_MASK, VLUXSEG3EI16_V, 0x7 }, // 6118
  { PseudoVLUXSEG3EI16_V_M1_MF2_TU, VLUXSEG3EI16_V, 0x7 }, // 6119
  { PseudoVLUXSEG3EI16_V_MF2_MF2, VLUXSEG3EI16_V, 0x7 }, // 6120
  { PseudoVLUXSEG3EI16_V_MF2_MF2_MASK, VLUXSEG3EI16_V, 0x7 }, // 6121
  { PseudoVLUXSEG3EI16_V_MF2_MF2_TU, VLUXSEG3EI16_V, 0x7 }, // 6122
  { PseudoVLUXSEG3EI16_V_MF4_MF2, VLUXSEG3EI16_V, 0x7 }, // 6123
  { PseudoVLUXSEG3EI16_V_MF4_MF2_MASK, VLUXSEG3EI16_V, 0x7 }, // 6124
  { PseudoVLUXSEG3EI16_V_MF4_MF2_TU, VLUXSEG3EI16_V, 0x7 }, // 6125
  { PseudoVLUXSEG3EI32_V_M1_M1, VLUXSEG3EI32_V, 0x0 }, // 6126
  { PseudoVLUXSEG3EI32_V_M1_M1_MASK, VLUXSEG3EI32_V, 0x0 }, // 6127
  { PseudoVLUXSEG3EI32_V_M1_M1_TU, VLUXSEG3EI32_V, 0x0 }, // 6128
  { PseudoVLUXSEG3EI32_V_M2_M1, VLUXSEG3EI32_V, 0x0 }, // 6129
  { PseudoVLUXSEG3EI32_V_M2_M1_MASK, VLUXSEG3EI32_V, 0x0 }, // 6130
  { PseudoVLUXSEG3EI32_V_M2_M1_TU, VLUXSEG3EI32_V, 0x0 }, // 6131
  { PseudoVLUXSEG3EI32_V_M4_M1, VLUXSEG3EI32_V, 0x0 }, // 6132
  { PseudoVLUXSEG3EI32_V_M4_M1_MASK, VLUXSEG3EI32_V, 0x0 }, // 6133
  { PseudoVLUXSEG3EI32_V_M4_M1_TU, VLUXSEG3EI32_V, 0x0 }, // 6134
  { PseudoVLUXSEG3EI32_V_MF2_M1, VLUXSEG3EI32_V, 0x0 }, // 6135
  { PseudoVLUXSEG3EI32_V_MF2_M1_MASK, VLUXSEG3EI32_V, 0x0 }, // 6136
  { PseudoVLUXSEG3EI32_V_MF2_M1_TU, VLUXSEG3EI32_V, 0x0 }, // 6137
  { PseudoVLUXSEG3EI32_V_M1_M2, VLUXSEG3EI32_V, 0x1 }, // 6138
  { PseudoVLUXSEG3EI32_V_M1_M2_MASK, VLUXSEG3EI32_V, 0x1 }, // 6139
  { PseudoVLUXSEG3EI32_V_M1_M2_TU, VLUXSEG3EI32_V, 0x1 }, // 6140
  { PseudoVLUXSEG3EI32_V_M2_M2, VLUXSEG3EI32_V, 0x1 }, // 6141
  { PseudoVLUXSEG3EI32_V_M2_M2_MASK, VLUXSEG3EI32_V, 0x1 }, // 6142
  { PseudoVLUXSEG3EI32_V_M2_M2_TU, VLUXSEG3EI32_V, 0x1 }, // 6143
  { PseudoVLUXSEG3EI32_V_M4_M2, VLUXSEG3EI32_V, 0x1 }, // 6144
  { PseudoVLUXSEG3EI32_V_M4_M2_MASK, VLUXSEG3EI32_V, 0x1 }, // 6145
  { PseudoVLUXSEG3EI32_V_M4_M2_TU, VLUXSEG3EI32_V, 0x1 }, // 6146
  { PseudoVLUXSEG3EI32_V_M8_M2, VLUXSEG3EI32_V, 0x1 }, // 6147
  { PseudoVLUXSEG3EI32_V_M8_M2_MASK, VLUXSEG3EI32_V, 0x1 }, // 6148
  { PseudoVLUXSEG3EI32_V_M8_M2_TU, VLUXSEG3EI32_V, 0x1 }, // 6149
  { PseudoVLUXSEG3EI32_V_MF2_MF8, VLUXSEG3EI32_V, 0x5 }, // 6150
  { PseudoVLUXSEG3EI32_V_MF2_MF8_MASK, VLUXSEG3EI32_V, 0x5 }, // 6151
  { PseudoVLUXSEG3EI32_V_MF2_MF8_TU, VLUXSEG3EI32_V, 0x5 }, // 6152
  { PseudoVLUXSEG3EI32_V_M1_MF4, VLUXSEG3EI32_V, 0x6 }, // 6153
  { PseudoVLUXSEG3EI32_V_M1_MF4_MASK, VLUXSEG3EI32_V, 0x6 }, // 6154
  { PseudoVLUXSEG3EI32_V_M1_MF4_TU, VLUXSEG3EI32_V, 0x6 }, // 6155
  { PseudoVLUXSEG3EI32_V_MF2_MF4, VLUXSEG3EI32_V, 0x6 }, // 6156
  { PseudoVLUXSEG3EI32_V_MF2_MF4_MASK, VLUXSEG3EI32_V, 0x6 }, // 6157
  { PseudoVLUXSEG3EI32_V_MF2_MF4_TU, VLUXSEG3EI32_V, 0x6 }, // 6158
  { PseudoVLUXSEG3EI32_V_M1_MF2, VLUXSEG3EI32_V, 0x7 }, // 6159
  { PseudoVLUXSEG3EI32_V_M1_MF2_MASK, VLUXSEG3EI32_V, 0x7 }, // 6160
  { PseudoVLUXSEG3EI32_V_M1_MF2_TU, VLUXSEG3EI32_V, 0x7 }, // 6161
  { PseudoVLUXSEG3EI32_V_M2_MF2, VLUXSEG3EI32_V, 0x7 }, // 6162
  { PseudoVLUXSEG3EI32_V_M2_MF2_MASK, VLUXSEG3EI32_V, 0x7 }, // 6163
  { PseudoVLUXSEG3EI32_V_M2_MF2_TU, VLUXSEG3EI32_V, 0x7 }, // 6164
  { PseudoVLUXSEG3EI32_V_MF2_MF2, VLUXSEG3EI32_V, 0x7 }, // 6165
  { PseudoVLUXSEG3EI32_V_MF2_MF2_MASK, VLUXSEG3EI32_V, 0x7 }, // 6166
  { PseudoVLUXSEG3EI32_V_MF2_MF2_TU, VLUXSEG3EI32_V, 0x7 }, // 6167
  { PseudoVLUXSEG3EI64_V_M1_M1, VLUXSEG3EI64_V, 0x0 }, // 6168
  { PseudoVLUXSEG3EI64_V_M1_M1_MASK, VLUXSEG3EI64_V, 0x0 }, // 6169
  { PseudoVLUXSEG3EI64_V_M1_M1_TU, VLUXSEG3EI64_V, 0x0 }, // 6170
  { PseudoVLUXSEG3EI64_V_M2_M1, VLUXSEG3EI64_V, 0x0 }, // 6171
  { PseudoVLUXSEG3EI64_V_M2_M1_MASK, VLUXSEG3EI64_V, 0x0 }, // 6172
  { PseudoVLUXSEG3EI64_V_M2_M1_TU, VLUXSEG3EI64_V, 0x0 }, // 6173
  { PseudoVLUXSEG3EI64_V_M4_M1, VLUXSEG3EI64_V, 0x0 }, // 6174
  { PseudoVLUXSEG3EI64_V_M4_M1_MASK, VLUXSEG3EI64_V, 0x0 }, // 6175
  { PseudoVLUXSEG3EI64_V_M4_M1_TU, VLUXSEG3EI64_V, 0x0 }, // 6176
  { PseudoVLUXSEG3EI64_V_M8_M1, VLUXSEG3EI64_V, 0x0 }, // 6177
  { PseudoVLUXSEG3EI64_V_M8_M1_MASK, VLUXSEG3EI64_V, 0x0 }, // 6178
  { PseudoVLUXSEG3EI64_V_M8_M1_TU, VLUXSEG3EI64_V, 0x0 }, // 6179
  { PseudoVLUXSEG3EI64_V_M2_M2, VLUXSEG3EI64_V, 0x1 }, // 6180
  { PseudoVLUXSEG3EI64_V_M2_M2_MASK, VLUXSEG3EI64_V, 0x1 }, // 6181
  { PseudoVLUXSEG3EI64_V_M2_M2_TU, VLUXSEG3EI64_V, 0x1 }, // 6182
  { PseudoVLUXSEG3EI64_V_M4_M2, VLUXSEG3EI64_V, 0x1 }, // 6183
  { PseudoVLUXSEG3EI64_V_M4_M2_MASK, VLUXSEG3EI64_V, 0x1 }, // 6184
  { PseudoVLUXSEG3EI64_V_M4_M2_TU, VLUXSEG3EI64_V, 0x1 }, // 6185
  { PseudoVLUXSEG3EI64_V_M8_M2, VLUXSEG3EI64_V, 0x1 }, // 6186
  { PseudoVLUXSEG3EI64_V_M8_M2_MASK, VLUXSEG3EI64_V, 0x1 }, // 6187
  { PseudoVLUXSEG3EI64_V_M8_M2_TU, VLUXSEG3EI64_V, 0x1 }, // 6188
  { PseudoVLUXSEG3EI64_V_M1_MF8, VLUXSEG3EI64_V, 0x5 }, // 6189
  { PseudoVLUXSEG3EI64_V_M1_MF8_MASK, VLUXSEG3EI64_V, 0x5 }, // 6190
  { PseudoVLUXSEG3EI64_V_M1_MF8_TU, VLUXSEG3EI64_V, 0x5 }, // 6191
  { PseudoVLUXSEG3EI64_V_M1_MF4, VLUXSEG3EI64_V, 0x6 }, // 6192
  { PseudoVLUXSEG3EI64_V_M1_MF4_MASK, VLUXSEG3EI64_V, 0x6 }, // 6193
  { PseudoVLUXSEG3EI64_V_M1_MF4_TU, VLUXSEG3EI64_V, 0x6 }, // 6194
  { PseudoVLUXSEG3EI64_V_M2_MF4, VLUXSEG3EI64_V, 0x6 }, // 6195
  { PseudoVLUXSEG3EI64_V_M2_MF4_MASK, VLUXSEG3EI64_V, 0x6 }, // 6196
  { PseudoVLUXSEG3EI64_V_M2_MF4_TU, VLUXSEG3EI64_V, 0x6 }, // 6197
  { PseudoVLUXSEG3EI64_V_M1_MF2, VLUXSEG3EI64_V, 0x7 }, // 6198
  { PseudoVLUXSEG3EI64_V_M1_MF2_MASK, VLUXSEG3EI64_V, 0x7 }, // 6199
  { PseudoVLUXSEG3EI64_V_M1_MF2_TU, VLUXSEG3EI64_V, 0x7 }, // 6200
  { PseudoVLUXSEG3EI64_V_M2_MF2, VLUXSEG3EI64_V, 0x7 }, // 6201
  { PseudoVLUXSEG3EI64_V_M2_MF2_MASK, VLUXSEG3EI64_V, 0x7 }, // 6202
  { PseudoVLUXSEG3EI64_V_M2_MF2_TU, VLUXSEG3EI64_V, 0x7 }, // 6203
  { PseudoVLUXSEG3EI64_V_M4_MF2, VLUXSEG3EI64_V, 0x7 }, // 6204
  { PseudoVLUXSEG3EI64_V_M4_MF2_MASK, VLUXSEG3EI64_V, 0x7 }, // 6205
  { PseudoVLUXSEG3EI64_V_M4_MF2_TU, VLUXSEG3EI64_V, 0x7 }, // 6206
  { PseudoVLUXSEG3EI8_V_M1_M1, VLUXSEG3EI8_V, 0x0 }, // 6207
  { PseudoVLUXSEG3EI8_V_M1_M1_MASK, VLUXSEG3EI8_V, 0x0 }, // 6208
  { PseudoVLUXSEG3EI8_V_M1_M1_TU, VLUXSEG3EI8_V, 0x0 }, // 6209
  { PseudoVLUXSEG3EI8_V_MF2_M1, VLUXSEG3EI8_V, 0x0 }, // 6210
  { PseudoVLUXSEG3EI8_V_MF2_M1_MASK, VLUXSEG3EI8_V, 0x0 }, // 6211
  { PseudoVLUXSEG3EI8_V_MF2_M1_TU, VLUXSEG3EI8_V, 0x0 }, // 6212
  { PseudoVLUXSEG3EI8_V_MF4_M1, VLUXSEG3EI8_V, 0x0 }, // 6213
  { PseudoVLUXSEG3EI8_V_MF4_M1_MASK, VLUXSEG3EI8_V, 0x0 }, // 6214
  { PseudoVLUXSEG3EI8_V_MF4_M1_TU, VLUXSEG3EI8_V, 0x0 }, // 6215
  { PseudoVLUXSEG3EI8_V_MF8_M1, VLUXSEG3EI8_V, 0x0 }, // 6216
  { PseudoVLUXSEG3EI8_V_MF8_M1_MASK, VLUXSEG3EI8_V, 0x0 }, // 6217
  { PseudoVLUXSEG3EI8_V_MF8_M1_TU, VLUXSEG3EI8_V, 0x0 }, // 6218
  { PseudoVLUXSEG3EI8_V_M1_M2, VLUXSEG3EI8_V, 0x1 }, // 6219
  { PseudoVLUXSEG3EI8_V_M1_M2_MASK, VLUXSEG3EI8_V, 0x1 }, // 6220
  { PseudoVLUXSEG3EI8_V_M1_M2_TU, VLUXSEG3EI8_V, 0x1 }, // 6221
  { PseudoVLUXSEG3EI8_V_M2_M2, VLUXSEG3EI8_V, 0x1 }, // 6222
  { PseudoVLUXSEG3EI8_V_M2_M2_MASK, VLUXSEG3EI8_V, 0x1 }, // 6223
  { PseudoVLUXSEG3EI8_V_M2_M2_TU, VLUXSEG3EI8_V, 0x1 }, // 6224
  { PseudoVLUXSEG3EI8_V_MF2_M2, VLUXSEG3EI8_V, 0x1 }, // 6225
  { PseudoVLUXSEG3EI8_V_MF2_M2_MASK, VLUXSEG3EI8_V, 0x1 }, // 6226
  { PseudoVLUXSEG3EI8_V_MF2_M2_TU, VLUXSEG3EI8_V, 0x1 }, // 6227
  { PseudoVLUXSEG3EI8_V_MF4_M2, VLUXSEG3EI8_V, 0x1 }, // 6228
  { PseudoVLUXSEG3EI8_V_MF4_M2_MASK, VLUXSEG3EI8_V, 0x1 }, // 6229
  { PseudoVLUXSEG3EI8_V_MF4_M2_TU, VLUXSEG3EI8_V, 0x1 }, // 6230
  { PseudoVLUXSEG3EI8_V_MF8_MF8, VLUXSEG3EI8_V, 0x5 }, // 6231
  { PseudoVLUXSEG3EI8_V_MF8_MF8_MASK, VLUXSEG3EI8_V, 0x5 }, // 6232
  { PseudoVLUXSEG3EI8_V_MF8_MF8_TU, VLUXSEG3EI8_V, 0x5 }, // 6233
  { PseudoVLUXSEG3EI8_V_MF4_MF4, VLUXSEG3EI8_V, 0x6 }, // 6234
  { PseudoVLUXSEG3EI8_V_MF4_MF4_MASK, VLUXSEG3EI8_V, 0x6 }, // 6235
  { PseudoVLUXSEG3EI8_V_MF4_MF4_TU, VLUXSEG3EI8_V, 0x6 }, // 6236
  { PseudoVLUXSEG3EI8_V_MF8_MF4, VLUXSEG3EI8_V, 0x6 }, // 6237
  { PseudoVLUXSEG3EI8_V_MF8_MF4_MASK, VLUXSEG3EI8_V, 0x6 }, // 6238
  { PseudoVLUXSEG3EI8_V_MF8_MF4_TU, VLUXSEG3EI8_V, 0x6 }, // 6239
  { PseudoVLUXSEG3EI8_V_MF2_MF2, VLUXSEG3EI8_V, 0x7 }, // 6240
  { PseudoVLUXSEG3EI8_V_MF2_MF2_MASK, VLUXSEG3EI8_V, 0x7 }, // 6241
  { PseudoVLUXSEG3EI8_V_MF2_MF2_TU, VLUXSEG3EI8_V, 0x7 }, // 6242
  { PseudoVLUXSEG3EI8_V_MF4_MF2, VLUXSEG3EI8_V, 0x7 }, // 6243
  { PseudoVLUXSEG3EI8_V_MF4_MF2_MASK, VLUXSEG3EI8_V, 0x7 }, // 6244
  { PseudoVLUXSEG3EI8_V_MF4_MF2_TU, VLUXSEG3EI8_V, 0x7 }, // 6245
  { PseudoVLUXSEG3EI8_V_MF8_MF2, VLUXSEG3EI8_V, 0x7 }, // 6246
  { PseudoVLUXSEG3EI8_V_MF8_MF2_MASK, VLUXSEG3EI8_V, 0x7 }, // 6247
  { PseudoVLUXSEG3EI8_V_MF8_MF2_TU, VLUXSEG3EI8_V, 0x7 }, // 6248
  { PseudoVLUXSEG4EI16_V_M1_M1, VLUXSEG4EI16_V, 0x0 }, // 6249
  { PseudoVLUXSEG4EI16_V_M1_M1_MASK, VLUXSEG4EI16_V, 0x0 }, // 6250
  { PseudoVLUXSEG4EI16_V_M1_M1_TU, VLUXSEG4EI16_V, 0x0 }, // 6251
  { PseudoVLUXSEG4EI16_V_M2_M1, VLUXSEG4EI16_V, 0x0 }, // 6252
  { PseudoVLUXSEG4EI16_V_M2_M1_MASK, VLUXSEG4EI16_V, 0x0 }, // 6253
  { PseudoVLUXSEG4EI16_V_M2_M1_TU, VLUXSEG4EI16_V, 0x0 }, // 6254
  { PseudoVLUXSEG4EI16_V_MF2_M1, VLUXSEG4EI16_V, 0x0 }, // 6255
  { PseudoVLUXSEG4EI16_V_MF2_M1_MASK, VLUXSEG4EI16_V, 0x0 }, // 6256
  { PseudoVLUXSEG4EI16_V_MF2_M1_TU, VLUXSEG4EI16_V, 0x0 }, // 6257
  { PseudoVLUXSEG4EI16_V_MF4_M1, VLUXSEG4EI16_V, 0x0 }, // 6258
  { PseudoVLUXSEG4EI16_V_MF4_M1_MASK, VLUXSEG4EI16_V, 0x0 }, // 6259
  { PseudoVLUXSEG4EI16_V_MF4_M1_TU, VLUXSEG4EI16_V, 0x0 }, // 6260
  { PseudoVLUXSEG4EI16_V_M1_M2, VLUXSEG4EI16_V, 0x1 }, // 6261
  { PseudoVLUXSEG4EI16_V_M1_M2_MASK, VLUXSEG4EI16_V, 0x1 }, // 6262
  { PseudoVLUXSEG4EI16_V_M1_M2_TU, VLUXSEG4EI16_V, 0x1 }, // 6263
  { PseudoVLUXSEG4EI16_V_M2_M2, VLUXSEG4EI16_V, 0x1 }, // 6264
  { PseudoVLUXSEG4EI16_V_M2_M2_MASK, VLUXSEG4EI16_V, 0x1 }, // 6265
  { PseudoVLUXSEG4EI16_V_M2_M2_TU, VLUXSEG4EI16_V, 0x1 }, // 6266
  { PseudoVLUXSEG4EI16_V_M4_M2, VLUXSEG4EI16_V, 0x1 }, // 6267
  { PseudoVLUXSEG4EI16_V_M4_M2_MASK, VLUXSEG4EI16_V, 0x1 }, // 6268
  { PseudoVLUXSEG4EI16_V_M4_M2_TU, VLUXSEG4EI16_V, 0x1 }, // 6269
  { PseudoVLUXSEG4EI16_V_MF2_M2, VLUXSEG4EI16_V, 0x1 }, // 6270
  { PseudoVLUXSEG4EI16_V_MF2_M2_MASK, VLUXSEG4EI16_V, 0x1 }, // 6271
  { PseudoVLUXSEG4EI16_V_MF2_M2_TU, VLUXSEG4EI16_V, 0x1 }, // 6272
  { PseudoVLUXSEG4EI16_V_MF4_MF8, VLUXSEG4EI16_V, 0x5 }, // 6273
  { PseudoVLUXSEG4EI16_V_MF4_MF8_MASK, VLUXSEG4EI16_V, 0x5 }, // 6274
  { PseudoVLUXSEG4EI16_V_MF4_MF8_TU, VLUXSEG4EI16_V, 0x5 }, // 6275
  { PseudoVLUXSEG4EI16_V_MF2_MF4, VLUXSEG4EI16_V, 0x6 }, // 6276
  { PseudoVLUXSEG4EI16_V_MF2_MF4_MASK, VLUXSEG4EI16_V, 0x6 }, // 6277
  { PseudoVLUXSEG4EI16_V_MF2_MF4_TU, VLUXSEG4EI16_V, 0x6 }, // 6278
  { PseudoVLUXSEG4EI16_V_MF4_MF4, VLUXSEG4EI16_V, 0x6 }, // 6279
  { PseudoVLUXSEG4EI16_V_MF4_MF4_MASK, VLUXSEG4EI16_V, 0x6 }, // 6280
  { PseudoVLUXSEG4EI16_V_MF4_MF4_TU, VLUXSEG4EI16_V, 0x6 }, // 6281
  { PseudoVLUXSEG4EI16_V_M1_MF2, VLUXSEG4EI16_V, 0x7 }, // 6282
  { PseudoVLUXSEG4EI16_V_M1_MF2_MASK, VLUXSEG4EI16_V, 0x7 }, // 6283
  { PseudoVLUXSEG4EI16_V_M1_MF2_TU, VLUXSEG4EI16_V, 0x7 }, // 6284
  { PseudoVLUXSEG4EI16_V_MF2_MF2, VLUXSEG4EI16_V, 0x7 }, // 6285
  { PseudoVLUXSEG4EI16_V_MF2_MF2_MASK, VLUXSEG4EI16_V, 0x7 }, // 6286
  { PseudoVLUXSEG4EI16_V_MF2_MF2_TU, VLUXSEG4EI16_V, 0x7 }, // 6287
  { PseudoVLUXSEG4EI16_V_MF4_MF2, VLUXSEG4EI16_V, 0x7 }, // 6288
  { PseudoVLUXSEG4EI16_V_MF4_MF2_MASK, VLUXSEG4EI16_V, 0x7 }, // 6289
  { PseudoVLUXSEG4EI16_V_MF4_MF2_TU, VLUXSEG4EI16_V, 0x7 }, // 6290
  { PseudoVLUXSEG4EI32_V_M1_M1, VLUXSEG4EI32_V, 0x0 }, // 6291
  { PseudoVLUXSEG4EI32_V_M1_M1_MASK, VLUXSEG4EI32_V, 0x0 }, // 6292
  { PseudoVLUXSEG4EI32_V_M1_M1_TU, VLUXSEG4EI32_V, 0x0 }, // 6293
  { PseudoVLUXSEG4EI32_V_M2_M1, VLUXSEG4EI32_V, 0x0 }, // 6294
  { PseudoVLUXSEG4EI32_V_M2_M1_MASK, VLUXSEG4EI32_V, 0x0 }, // 6295
  { PseudoVLUXSEG4EI32_V_M2_M1_TU, VLUXSEG4EI32_V, 0x0 }, // 6296
  { PseudoVLUXSEG4EI32_V_M4_M1, VLUXSEG4EI32_V, 0x0 }, // 6297
  { PseudoVLUXSEG4EI32_V_M4_M1_MASK, VLUXSEG4EI32_V, 0x0 }, // 6298
  { PseudoVLUXSEG4EI32_V_M4_M1_TU, VLUXSEG4EI32_V, 0x0 }, // 6299
  { PseudoVLUXSEG4EI32_V_MF2_M1, VLUXSEG4EI32_V, 0x0 }, // 6300
  { PseudoVLUXSEG4EI32_V_MF2_M1_MASK, VLUXSEG4EI32_V, 0x0 }, // 6301
  { PseudoVLUXSEG4EI32_V_MF2_M1_TU, VLUXSEG4EI32_V, 0x0 }, // 6302
  { PseudoVLUXSEG4EI32_V_M1_M2, VLUXSEG4EI32_V, 0x1 }, // 6303
  { PseudoVLUXSEG4EI32_V_M1_M2_MASK, VLUXSEG4EI32_V, 0x1 }, // 6304
  { PseudoVLUXSEG4EI32_V_M1_M2_TU, VLUXSEG4EI32_V, 0x1 }, // 6305
  { PseudoVLUXSEG4EI32_V_M2_M2, VLUXSEG4EI32_V, 0x1 }, // 6306
  { PseudoVLUXSEG4EI32_V_M2_M2_MASK, VLUXSEG4EI32_V, 0x1 }, // 6307
  { PseudoVLUXSEG4EI32_V_M2_M2_TU, VLUXSEG4EI32_V, 0x1 }, // 6308
  { PseudoVLUXSEG4EI32_V_M4_M2, VLUXSEG4EI32_V, 0x1 }, // 6309
  { PseudoVLUXSEG4EI32_V_M4_M2_MASK, VLUXSEG4EI32_V, 0x1 }, // 6310
  { PseudoVLUXSEG4EI32_V_M4_M2_TU, VLUXSEG4EI32_V, 0x1 }, // 6311
  { PseudoVLUXSEG4EI32_V_M8_M2, VLUXSEG4EI32_V, 0x1 }, // 6312
  { PseudoVLUXSEG4EI32_V_M8_M2_MASK, VLUXSEG4EI32_V, 0x1 }, // 6313
  { PseudoVLUXSEG4EI32_V_M8_M2_TU, VLUXSEG4EI32_V, 0x1 }, // 6314
  { PseudoVLUXSEG4EI32_V_MF2_MF8, VLUXSEG4EI32_V, 0x5 }, // 6315
  { PseudoVLUXSEG4EI32_V_MF2_MF8_MASK, VLUXSEG4EI32_V, 0x5 }, // 6316
  { PseudoVLUXSEG4EI32_V_MF2_MF8_TU, VLUXSEG4EI32_V, 0x5 }, // 6317
  { PseudoVLUXSEG4EI32_V_M1_MF4, VLUXSEG4EI32_V, 0x6 }, // 6318
  { PseudoVLUXSEG4EI32_V_M1_MF4_MASK, VLUXSEG4EI32_V, 0x6 }, // 6319
  { PseudoVLUXSEG4EI32_V_M1_MF4_TU, VLUXSEG4EI32_V, 0x6 }, // 6320
  { PseudoVLUXSEG4EI32_V_MF2_MF4, VLUXSEG4EI32_V, 0x6 }, // 6321
  { PseudoVLUXSEG4EI32_V_MF2_MF4_MASK, VLUXSEG4EI32_V, 0x6 }, // 6322
  { PseudoVLUXSEG4EI32_V_MF2_MF4_TU, VLUXSEG4EI32_V, 0x6 }, // 6323
  { PseudoVLUXSEG4EI32_V_M1_MF2, VLUXSEG4EI32_V, 0x7 }, // 6324
  { PseudoVLUXSEG4EI32_V_M1_MF2_MASK, VLUXSEG4EI32_V, 0x7 }, // 6325
  { PseudoVLUXSEG4EI32_V_M1_MF2_TU, VLUXSEG4EI32_V, 0x7 }, // 6326
  { PseudoVLUXSEG4EI32_V_M2_MF2, VLUXSEG4EI32_V, 0x7 }, // 6327
  { PseudoVLUXSEG4EI32_V_M2_MF2_MASK, VLUXSEG4EI32_V, 0x7 }, // 6328
  { PseudoVLUXSEG4EI32_V_M2_MF2_TU, VLUXSEG4EI32_V, 0x7 }, // 6329
  { PseudoVLUXSEG4EI32_V_MF2_MF2, VLUXSEG4EI32_V, 0x7 }, // 6330
  { PseudoVLUXSEG4EI32_V_MF2_MF2_MASK, VLUXSEG4EI32_V, 0x7 }, // 6331
  { PseudoVLUXSEG4EI32_V_MF2_MF2_TU, VLUXSEG4EI32_V, 0x7 }, // 6332
  { PseudoVLUXSEG4EI64_V_M1_M1, VLUXSEG4EI64_V, 0x0 }, // 6333
  { PseudoVLUXSEG4EI64_V_M1_M1_MASK, VLUXSEG4EI64_V, 0x0 }, // 6334
  { PseudoVLUXSEG4EI64_V_M1_M1_TU, VLUXSEG4EI64_V, 0x0 }, // 6335
  { PseudoVLUXSEG4EI64_V_M2_M1, VLUXSEG4EI64_V, 0x0 }, // 6336
  { PseudoVLUXSEG4EI64_V_M2_M1_MASK, VLUXSEG4EI64_V, 0x0 }, // 6337
  { PseudoVLUXSEG4EI64_V_M2_M1_TU, VLUXSEG4EI64_V, 0x0 }, // 6338
  { PseudoVLUXSEG4EI64_V_M4_M1, VLUXSEG4EI64_V, 0x0 }, // 6339
  { PseudoVLUXSEG4EI64_V_M4_M1_MASK, VLUXSEG4EI64_V, 0x0 }, // 6340
  { PseudoVLUXSEG4EI64_V_M4_M1_TU, VLUXSEG4EI64_V, 0x0 }, // 6341
  { PseudoVLUXSEG4EI64_V_M8_M1, VLUXSEG4EI64_V, 0x0 }, // 6342
  { PseudoVLUXSEG4EI64_V_M8_M1_MASK, VLUXSEG4EI64_V, 0x0 }, // 6343
  { PseudoVLUXSEG4EI64_V_M8_M1_TU, VLUXSEG4EI64_V, 0x0 }, // 6344
  { PseudoVLUXSEG4EI64_V_M2_M2, VLUXSEG4EI64_V, 0x1 }, // 6345
  { PseudoVLUXSEG4EI64_V_M2_M2_MASK, VLUXSEG4EI64_V, 0x1 }, // 6346
  { PseudoVLUXSEG4EI64_V_M2_M2_TU, VLUXSEG4EI64_V, 0x1 }, // 6347
  { PseudoVLUXSEG4EI64_V_M4_M2, VLUXSEG4EI64_V, 0x1 }, // 6348
  { PseudoVLUXSEG4EI64_V_M4_M2_MASK, VLUXSEG4EI64_V, 0x1 }, // 6349
  { PseudoVLUXSEG4EI64_V_M4_M2_TU, VLUXSEG4EI64_V, 0x1 }, // 6350
  { PseudoVLUXSEG4EI64_V_M8_M2, VLUXSEG4EI64_V, 0x1 }, // 6351
  { PseudoVLUXSEG4EI64_V_M8_M2_MASK, VLUXSEG4EI64_V, 0x1 }, // 6352
  { PseudoVLUXSEG4EI64_V_M8_M2_TU, VLUXSEG4EI64_V, 0x1 }, // 6353
  { PseudoVLUXSEG4EI64_V_M1_MF8, VLUXSEG4EI64_V, 0x5 }, // 6354
  { PseudoVLUXSEG4EI64_V_M1_MF8_MASK, VLUXSEG4EI64_V, 0x5 }, // 6355
  { PseudoVLUXSEG4EI64_V_M1_MF8_TU, VLUXSEG4EI64_V, 0x5 }, // 6356
  { PseudoVLUXSEG4EI64_V_M1_MF4, VLUXSEG4EI64_V, 0x6 }, // 6357
  { PseudoVLUXSEG4EI64_V_M1_MF4_MASK, VLUXSEG4EI64_V, 0x6 }, // 6358
  { PseudoVLUXSEG4EI64_V_M1_MF4_TU, VLUXSEG4EI64_V, 0x6 }, // 6359
  { PseudoVLUXSEG4EI64_V_M2_MF4, VLUXSEG4EI64_V, 0x6 }, // 6360
  { PseudoVLUXSEG4EI64_V_M2_MF4_MASK, VLUXSEG4EI64_V, 0x6 }, // 6361
  { PseudoVLUXSEG4EI64_V_M2_MF4_TU, VLUXSEG4EI64_V, 0x6 }, // 6362
  { PseudoVLUXSEG4EI64_V_M1_MF2, VLUXSEG4EI64_V, 0x7 }, // 6363
  { PseudoVLUXSEG4EI64_V_M1_MF2_MASK, VLUXSEG4EI64_V, 0x7 }, // 6364
  { PseudoVLUXSEG4EI64_V_M1_MF2_TU, VLUXSEG4EI64_V, 0x7 }, // 6365
  { PseudoVLUXSEG4EI64_V_M2_MF2, VLUXSEG4EI64_V, 0x7 }, // 6366
  { PseudoVLUXSEG4EI64_V_M2_MF2_MASK, VLUXSEG4EI64_V, 0x7 }, // 6367
  { PseudoVLUXSEG4EI64_V_M2_MF2_TU, VLUXSEG4EI64_V, 0x7 }, // 6368
  { PseudoVLUXSEG4EI64_V_M4_MF2, VLUXSEG4EI64_V, 0x7 }, // 6369
  { PseudoVLUXSEG4EI64_V_M4_MF2_MASK, VLUXSEG4EI64_V, 0x7 }, // 6370
  { PseudoVLUXSEG4EI64_V_M4_MF2_TU, VLUXSEG4EI64_V, 0x7 }, // 6371
  { PseudoVLUXSEG4EI8_V_M1_M1, VLUXSEG4EI8_V, 0x0 }, // 6372
  { PseudoVLUXSEG4EI8_V_M1_M1_MASK, VLUXSEG4EI8_V, 0x0 }, // 6373
  { PseudoVLUXSEG4EI8_V_M1_M1_TU, VLUXSEG4EI8_V, 0x0 }, // 6374
  { PseudoVLUXSEG4EI8_V_MF2_M1, VLUXSEG4EI8_V, 0x0 }, // 6375
  { PseudoVLUXSEG4EI8_V_MF2_M1_MASK, VLUXSEG4EI8_V, 0x0 }, // 6376
  { PseudoVLUXSEG4EI8_V_MF2_M1_TU, VLUXSEG4EI8_V, 0x0 }, // 6377
  { PseudoVLUXSEG4EI8_V_MF4_M1, VLUXSEG4EI8_V, 0x0 }, // 6378
  { PseudoVLUXSEG4EI8_V_MF4_M1_MASK, VLUXSEG4EI8_V, 0x0 }, // 6379
  { PseudoVLUXSEG4EI8_V_MF4_M1_TU, VLUXSEG4EI8_V, 0x0 }, // 6380
  { PseudoVLUXSEG4EI8_V_MF8_M1, VLUXSEG4EI8_V, 0x0 }, // 6381
  { PseudoVLUXSEG4EI8_V_MF8_M1_MASK, VLUXSEG4EI8_V, 0x0 }, // 6382
  { PseudoVLUXSEG4EI8_V_MF8_M1_TU, VLUXSEG4EI8_V, 0x0 }, // 6383
  { PseudoVLUXSEG4EI8_V_M1_M2, VLUXSEG4EI8_V, 0x1 }, // 6384
  { PseudoVLUXSEG4EI8_V_M1_M2_MASK, VLUXSEG4EI8_V, 0x1 }, // 6385
  { PseudoVLUXSEG4EI8_V_M1_M2_TU, VLUXSEG4EI8_V, 0x1 }, // 6386
  { PseudoVLUXSEG4EI8_V_M2_M2, VLUXSEG4EI8_V, 0x1 }, // 6387
  { PseudoVLUXSEG4EI8_V_M2_M2_MASK, VLUXSEG4EI8_V, 0x1 }, // 6388
  { PseudoVLUXSEG4EI8_V_M2_M2_TU, VLUXSEG4EI8_V, 0x1 }, // 6389
  { PseudoVLUXSEG4EI8_V_MF2_M2, VLUXSEG4EI8_V, 0x1 }, // 6390
  { PseudoVLUXSEG4EI8_V_MF2_M2_MASK, VLUXSEG4EI8_V, 0x1 }, // 6391
  { PseudoVLUXSEG4EI8_V_MF2_M2_TU, VLUXSEG4EI8_V, 0x1 }, // 6392
  { PseudoVLUXSEG4EI8_V_MF4_M2, VLUXSEG4EI8_V, 0x1 }, // 6393
  { PseudoVLUXSEG4EI8_V_MF4_M2_MASK, VLUXSEG4EI8_V, 0x1 }, // 6394
  { PseudoVLUXSEG4EI8_V_MF4_M2_TU, VLUXSEG4EI8_V, 0x1 }, // 6395
  { PseudoVLUXSEG4EI8_V_MF8_MF8, VLUXSEG4EI8_V, 0x5 }, // 6396
  { PseudoVLUXSEG4EI8_V_MF8_MF8_MASK, VLUXSEG4EI8_V, 0x5 }, // 6397
  { PseudoVLUXSEG4EI8_V_MF8_MF8_TU, VLUXSEG4EI8_V, 0x5 }, // 6398
  { PseudoVLUXSEG4EI8_V_MF4_MF4, VLUXSEG4EI8_V, 0x6 }, // 6399
  { PseudoVLUXSEG4EI8_V_MF4_MF4_MASK, VLUXSEG4EI8_V, 0x6 }, // 6400
  { PseudoVLUXSEG4EI8_V_MF4_MF4_TU, VLUXSEG4EI8_V, 0x6 }, // 6401
  { PseudoVLUXSEG4EI8_V_MF8_MF4, VLUXSEG4EI8_V, 0x6 }, // 6402
  { PseudoVLUXSEG4EI8_V_MF8_MF4_MASK, VLUXSEG4EI8_V, 0x6 }, // 6403
  { PseudoVLUXSEG4EI8_V_MF8_MF4_TU, VLUXSEG4EI8_V, 0x6 }, // 6404
  { PseudoVLUXSEG4EI8_V_MF2_MF2, VLUXSEG4EI8_V, 0x7 }, // 6405
  { PseudoVLUXSEG4EI8_V_MF2_MF2_MASK, VLUXSEG4EI8_V, 0x7 }, // 6406
  { PseudoVLUXSEG4EI8_V_MF2_MF2_TU, VLUXSEG4EI8_V, 0x7 }, // 6407
  { PseudoVLUXSEG4EI8_V_MF4_MF2, VLUXSEG4EI8_V, 0x7 }, // 6408
  { PseudoVLUXSEG4EI8_V_MF4_MF2_MASK, VLUXSEG4EI8_V, 0x7 }, // 6409
  { PseudoVLUXSEG4EI8_V_MF4_MF2_TU, VLUXSEG4EI8_V, 0x7 }, // 6410
  { PseudoVLUXSEG4EI8_V_MF8_MF2, VLUXSEG4EI8_V, 0x7 }, // 6411
  { PseudoVLUXSEG4EI8_V_MF8_MF2_MASK, VLUXSEG4EI8_V, 0x7 }, // 6412
  { PseudoVLUXSEG4EI8_V_MF8_MF2_TU, VLUXSEG4EI8_V, 0x7 }, // 6413
  { PseudoVLUXSEG5EI16_V_M1_M1, VLUXSEG5EI16_V, 0x0 }, // 6414
  { PseudoVLUXSEG5EI16_V_M1_M1_MASK, VLUXSEG5EI16_V, 0x0 }, // 6415
  { PseudoVLUXSEG5EI16_V_M1_M1_TU, VLUXSEG5EI16_V, 0x0 }, // 6416
  { PseudoVLUXSEG5EI16_V_M2_M1, VLUXSEG5EI16_V, 0x0 }, // 6417
  { PseudoVLUXSEG5EI16_V_M2_M1_MASK, VLUXSEG5EI16_V, 0x0 }, // 6418
  { PseudoVLUXSEG5EI16_V_M2_M1_TU, VLUXSEG5EI16_V, 0x0 }, // 6419
  { PseudoVLUXSEG5EI16_V_MF2_M1, VLUXSEG5EI16_V, 0x0 }, // 6420
  { PseudoVLUXSEG5EI16_V_MF2_M1_MASK, VLUXSEG5EI16_V, 0x0 }, // 6421
  { PseudoVLUXSEG5EI16_V_MF2_M1_TU, VLUXSEG5EI16_V, 0x0 }, // 6422
  { PseudoVLUXSEG5EI16_V_MF4_M1, VLUXSEG5EI16_V, 0x0 }, // 6423
  { PseudoVLUXSEG5EI16_V_MF4_M1_MASK, VLUXSEG5EI16_V, 0x0 }, // 6424
  { PseudoVLUXSEG5EI16_V_MF4_M1_TU, VLUXSEG5EI16_V, 0x0 }, // 6425
  { PseudoVLUXSEG5EI16_V_MF4_MF8, VLUXSEG5EI16_V, 0x5 }, // 6426
  { PseudoVLUXSEG5EI16_V_MF4_MF8_MASK, VLUXSEG5EI16_V, 0x5 }, // 6427
  { PseudoVLUXSEG5EI16_V_MF4_MF8_TU, VLUXSEG5EI16_V, 0x5 }, // 6428
  { PseudoVLUXSEG5EI16_V_MF2_MF4, VLUXSEG5EI16_V, 0x6 }, // 6429
  { PseudoVLUXSEG5EI16_V_MF2_MF4_MASK, VLUXSEG5EI16_V, 0x6 }, // 6430
  { PseudoVLUXSEG5EI16_V_MF2_MF4_TU, VLUXSEG5EI16_V, 0x6 }, // 6431
  { PseudoVLUXSEG5EI16_V_MF4_MF4, VLUXSEG5EI16_V, 0x6 }, // 6432
  { PseudoVLUXSEG5EI16_V_MF4_MF4_MASK, VLUXSEG5EI16_V, 0x6 }, // 6433
  { PseudoVLUXSEG5EI16_V_MF4_MF4_TU, VLUXSEG5EI16_V, 0x6 }, // 6434
  { PseudoVLUXSEG5EI16_V_M1_MF2, VLUXSEG5EI16_V, 0x7 }, // 6435
  { PseudoVLUXSEG5EI16_V_M1_MF2_MASK, VLUXSEG5EI16_V, 0x7 }, // 6436
  { PseudoVLUXSEG5EI16_V_M1_MF2_TU, VLUXSEG5EI16_V, 0x7 }, // 6437
  { PseudoVLUXSEG5EI16_V_MF2_MF2, VLUXSEG5EI16_V, 0x7 }, // 6438
  { PseudoVLUXSEG5EI16_V_MF2_MF2_MASK, VLUXSEG5EI16_V, 0x7 }, // 6439
  { PseudoVLUXSEG5EI16_V_MF2_MF2_TU, VLUXSEG5EI16_V, 0x7 }, // 6440
  { PseudoVLUXSEG5EI16_V_MF4_MF2, VLUXSEG5EI16_V, 0x7 }, // 6441
  { PseudoVLUXSEG5EI16_V_MF4_MF2_MASK, VLUXSEG5EI16_V, 0x7 }, // 6442
  { PseudoVLUXSEG5EI16_V_MF4_MF2_TU, VLUXSEG5EI16_V, 0x7 }, // 6443
  { PseudoVLUXSEG5EI32_V_M1_M1, VLUXSEG5EI32_V, 0x0 }, // 6444
  { PseudoVLUXSEG5EI32_V_M1_M1_MASK, VLUXSEG5EI32_V, 0x0 }, // 6445
  { PseudoVLUXSEG5EI32_V_M1_M1_TU, VLUXSEG5EI32_V, 0x0 }, // 6446
  { PseudoVLUXSEG5EI32_V_M2_M1, VLUXSEG5EI32_V, 0x0 }, // 6447
  { PseudoVLUXSEG5EI32_V_M2_M1_MASK, VLUXSEG5EI32_V, 0x0 }, // 6448
  { PseudoVLUXSEG5EI32_V_M2_M1_TU, VLUXSEG5EI32_V, 0x0 }, // 6449
  { PseudoVLUXSEG5EI32_V_M4_M1, VLUXSEG5EI32_V, 0x0 }, // 6450
  { PseudoVLUXSEG5EI32_V_M4_M1_MASK, VLUXSEG5EI32_V, 0x0 }, // 6451
  { PseudoVLUXSEG5EI32_V_M4_M1_TU, VLUXSEG5EI32_V, 0x0 }, // 6452
  { PseudoVLUXSEG5EI32_V_MF2_M1, VLUXSEG5EI32_V, 0x0 }, // 6453
  { PseudoVLUXSEG5EI32_V_MF2_M1_MASK, VLUXSEG5EI32_V, 0x0 }, // 6454
  { PseudoVLUXSEG5EI32_V_MF2_M1_TU, VLUXSEG5EI32_V, 0x0 }, // 6455
  { PseudoVLUXSEG5EI32_V_MF2_MF8, VLUXSEG5EI32_V, 0x5 }, // 6456
  { PseudoVLUXSEG5EI32_V_MF2_MF8_MASK, VLUXSEG5EI32_V, 0x5 }, // 6457
  { PseudoVLUXSEG5EI32_V_MF2_MF8_TU, VLUXSEG5EI32_V, 0x5 }, // 6458
  { PseudoVLUXSEG5EI32_V_M1_MF4, VLUXSEG5EI32_V, 0x6 }, // 6459
  { PseudoVLUXSEG5EI32_V_M1_MF4_MASK, VLUXSEG5EI32_V, 0x6 }, // 6460
  { PseudoVLUXSEG5EI32_V_M1_MF4_TU, VLUXSEG5EI32_V, 0x6 }, // 6461
  { PseudoVLUXSEG5EI32_V_MF2_MF4, VLUXSEG5EI32_V, 0x6 }, // 6462
  { PseudoVLUXSEG5EI32_V_MF2_MF4_MASK, VLUXSEG5EI32_V, 0x6 }, // 6463
  { PseudoVLUXSEG5EI32_V_MF2_MF4_TU, VLUXSEG5EI32_V, 0x6 }, // 6464
  { PseudoVLUXSEG5EI32_V_M1_MF2, VLUXSEG5EI32_V, 0x7 }, // 6465
  { PseudoVLUXSEG5EI32_V_M1_MF2_MASK, VLUXSEG5EI32_V, 0x7 }, // 6466
  { PseudoVLUXSEG5EI32_V_M1_MF2_TU, VLUXSEG5EI32_V, 0x7 }, // 6467
  { PseudoVLUXSEG5EI32_V_M2_MF2, VLUXSEG5EI32_V, 0x7 }, // 6468
  { PseudoVLUXSEG5EI32_V_M2_MF2_MASK, VLUXSEG5EI32_V, 0x7 }, // 6469
  { PseudoVLUXSEG5EI32_V_M2_MF2_TU, VLUXSEG5EI32_V, 0x7 }, // 6470
  { PseudoVLUXSEG5EI32_V_MF2_MF2, VLUXSEG5EI32_V, 0x7 }, // 6471
  { PseudoVLUXSEG5EI32_V_MF2_MF2_MASK, VLUXSEG5EI32_V, 0x7 }, // 6472
  { PseudoVLUXSEG5EI32_V_MF2_MF2_TU, VLUXSEG5EI32_V, 0x7 }, // 6473
  { PseudoVLUXSEG5EI64_V_M1_M1, VLUXSEG5EI64_V, 0x0 }, // 6474
  { PseudoVLUXSEG5EI64_V_M1_M1_MASK, VLUXSEG5EI64_V, 0x0 }, // 6475
  { PseudoVLUXSEG5EI64_V_M1_M1_TU, VLUXSEG5EI64_V, 0x0 }, // 6476
  { PseudoVLUXSEG5EI64_V_M2_M1, VLUXSEG5EI64_V, 0x0 }, // 6477
  { PseudoVLUXSEG5EI64_V_M2_M1_MASK, VLUXSEG5EI64_V, 0x0 }, // 6478
  { PseudoVLUXSEG5EI64_V_M2_M1_TU, VLUXSEG5EI64_V, 0x0 }, // 6479
  { PseudoVLUXSEG5EI64_V_M4_M1, VLUXSEG5EI64_V, 0x0 }, // 6480
  { PseudoVLUXSEG5EI64_V_M4_M1_MASK, VLUXSEG5EI64_V, 0x0 }, // 6481
  { PseudoVLUXSEG5EI64_V_M4_M1_TU, VLUXSEG5EI64_V, 0x0 }, // 6482
  { PseudoVLUXSEG5EI64_V_M8_M1, VLUXSEG5EI64_V, 0x0 }, // 6483
  { PseudoVLUXSEG5EI64_V_M8_M1_MASK, VLUXSEG5EI64_V, 0x0 }, // 6484
  { PseudoVLUXSEG5EI64_V_M8_M1_TU, VLUXSEG5EI64_V, 0x0 }, // 6485
  { PseudoVLUXSEG5EI64_V_M1_MF8, VLUXSEG5EI64_V, 0x5 }, // 6486
  { PseudoVLUXSEG5EI64_V_M1_MF8_MASK, VLUXSEG5EI64_V, 0x5 }, // 6487
  { PseudoVLUXSEG5EI64_V_M1_MF8_TU, VLUXSEG5EI64_V, 0x5 }, // 6488
  { PseudoVLUXSEG5EI64_V_M1_MF4, VLUXSEG5EI64_V, 0x6 }, // 6489
  { PseudoVLUXSEG5EI64_V_M1_MF4_MASK, VLUXSEG5EI64_V, 0x6 }, // 6490
  { PseudoVLUXSEG5EI64_V_M1_MF4_TU, VLUXSEG5EI64_V, 0x6 }, // 6491
  { PseudoVLUXSEG5EI64_V_M2_MF4, VLUXSEG5EI64_V, 0x6 }, // 6492
  { PseudoVLUXSEG5EI64_V_M2_MF4_MASK, VLUXSEG5EI64_V, 0x6 }, // 6493
  { PseudoVLUXSEG5EI64_V_M2_MF4_TU, VLUXSEG5EI64_V, 0x6 }, // 6494
  { PseudoVLUXSEG5EI64_V_M1_MF2, VLUXSEG5EI64_V, 0x7 }, // 6495
  { PseudoVLUXSEG5EI64_V_M1_MF2_MASK, VLUXSEG5EI64_V, 0x7 }, // 6496
  { PseudoVLUXSEG5EI64_V_M1_MF2_TU, VLUXSEG5EI64_V, 0x7 }, // 6497
  { PseudoVLUXSEG5EI64_V_M2_MF2, VLUXSEG5EI64_V, 0x7 }, // 6498
  { PseudoVLUXSEG5EI64_V_M2_MF2_MASK, VLUXSEG5EI64_V, 0x7 }, // 6499
  { PseudoVLUXSEG5EI64_V_M2_MF2_TU, VLUXSEG5EI64_V, 0x7 }, // 6500
  { PseudoVLUXSEG5EI64_V_M4_MF2, VLUXSEG5EI64_V, 0x7 }, // 6501
  { PseudoVLUXSEG5EI64_V_M4_MF2_MASK, VLUXSEG5EI64_V, 0x7 }, // 6502
  { PseudoVLUXSEG5EI64_V_M4_MF2_TU, VLUXSEG5EI64_V, 0x7 }, // 6503
  { PseudoVLUXSEG5EI8_V_M1_M1, VLUXSEG5EI8_V, 0x0 }, // 6504
  { PseudoVLUXSEG5EI8_V_M1_M1_MASK, VLUXSEG5EI8_V, 0x0 }, // 6505
  { PseudoVLUXSEG5EI8_V_M1_M1_TU, VLUXSEG5EI8_V, 0x0 }, // 6506
  { PseudoVLUXSEG5EI8_V_MF2_M1, VLUXSEG5EI8_V, 0x0 }, // 6507
  { PseudoVLUXSEG5EI8_V_MF2_M1_MASK, VLUXSEG5EI8_V, 0x0 }, // 6508
  { PseudoVLUXSEG5EI8_V_MF2_M1_TU, VLUXSEG5EI8_V, 0x0 }, // 6509
  { PseudoVLUXSEG5EI8_V_MF4_M1, VLUXSEG5EI8_V, 0x0 }, // 6510
  { PseudoVLUXSEG5EI8_V_MF4_M1_MASK, VLUXSEG5EI8_V, 0x0 }, // 6511
  { PseudoVLUXSEG5EI8_V_MF4_M1_TU, VLUXSEG5EI8_V, 0x0 }, // 6512
  { PseudoVLUXSEG5EI8_V_MF8_M1, VLUXSEG5EI8_V, 0x0 }, // 6513
  { PseudoVLUXSEG5EI8_V_MF8_M1_MASK, VLUXSEG5EI8_V, 0x0 }, // 6514
  { PseudoVLUXSEG5EI8_V_MF8_M1_TU, VLUXSEG5EI8_V, 0x0 }, // 6515
  { PseudoVLUXSEG5EI8_V_MF8_MF8, VLUXSEG5EI8_V, 0x5 }, // 6516
  { PseudoVLUXSEG5EI8_V_MF8_MF8_MASK, VLUXSEG5EI8_V, 0x5 }, // 6517
  { PseudoVLUXSEG5EI8_V_MF8_MF8_TU, VLUXSEG5EI8_V, 0x5 }, // 6518
  { PseudoVLUXSEG5EI8_V_MF4_MF4, VLUXSEG5EI8_V, 0x6 }, // 6519
  { PseudoVLUXSEG5EI8_V_MF4_MF4_MASK, VLUXSEG5EI8_V, 0x6 }, // 6520
  { PseudoVLUXSEG5EI8_V_MF4_MF4_TU, VLUXSEG5EI8_V, 0x6 }, // 6521
  { PseudoVLUXSEG5EI8_V_MF8_MF4, VLUXSEG5EI8_V, 0x6 }, // 6522
  { PseudoVLUXSEG5EI8_V_MF8_MF4_MASK, VLUXSEG5EI8_V, 0x6 }, // 6523
  { PseudoVLUXSEG5EI8_V_MF8_MF4_TU, VLUXSEG5EI8_V, 0x6 }, // 6524
  { PseudoVLUXSEG5EI8_V_MF2_MF2, VLUXSEG5EI8_V, 0x7 }, // 6525
  { PseudoVLUXSEG5EI8_V_MF2_MF2_MASK, VLUXSEG5EI8_V, 0x7 }, // 6526
  { PseudoVLUXSEG5EI8_V_MF2_MF2_TU, VLUXSEG5EI8_V, 0x7 }, // 6527
  { PseudoVLUXSEG5EI8_V_MF4_MF2, VLUXSEG5EI8_V, 0x7 }, // 6528
  { PseudoVLUXSEG5EI8_V_MF4_MF2_MASK, VLUXSEG5EI8_V, 0x7 }, // 6529
  { PseudoVLUXSEG5EI8_V_MF4_MF2_TU, VLUXSEG5EI8_V, 0x7 }, // 6530
  { PseudoVLUXSEG5EI8_V_MF8_MF2, VLUXSEG5EI8_V, 0x7 }, // 6531
  { PseudoVLUXSEG5EI8_V_MF8_MF2_MASK, VLUXSEG5EI8_V, 0x7 }, // 6532
  { PseudoVLUXSEG5EI8_V_MF8_MF2_TU, VLUXSEG5EI8_V, 0x7 }, // 6533
  { PseudoVLUXSEG6EI16_V_M1_M1, VLUXSEG6EI16_V, 0x0 }, // 6534
  { PseudoVLUXSEG6EI16_V_M1_M1_MASK, VLUXSEG6EI16_V, 0x0 }, // 6535
  { PseudoVLUXSEG6EI16_V_M1_M1_TU, VLUXSEG6EI16_V, 0x0 }, // 6536
  { PseudoVLUXSEG6EI16_V_M2_M1, VLUXSEG6EI16_V, 0x0 }, // 6537
  { PseudoVLUXSEG6EI16_V_M2_M1_MASK, VLUXSEG6EI16_V, 0x0 }, // 6538
  { PseudoVLUXSEG6EI16_V_M2_M1_TU, VLUXSEG6EI16_V, 0x0 }, // 6539
  { PseudoVLUXSEG6EI16_V_MF2_M1, VLUXSEG6EI16_V, 0x0 }, // 6540
  { PseudoVLUXSEG6EI16_V_MF2_M1_MASK, VLUXSEG6EI16_V, 0x0 }, // 6541
  { PseudoVLUXSEG6EI16_V_MF2_M1_TU, VLUXSEG6EI16_V, 0x0 }, // 6542
  { PseudoVLUXSEG6EI16_V_MF4_M1, VLUXSEG6EI16_V, 0x0 }, // 6543
  { PseudoVLUXSEG6EI16_V_MF4_M1_MASK, VLUXSEG6EI16_V, 0x0 }, // 6544
  { PseudoVLUXSEG6EI16_V_MF4_M1_TU, VLUXSEG6EI16_V, 0x0 }, // 6545
  { PseudoVLUXSEG6EI16_V_MF4_MF8, VLUXSEG6EI16_V, 0x5 }, // 6546
  { PseudoVLUXSEG6EI16_V_MF4_MF8_MASK, VLUXSEG6EI16_V, 0x5 }, // 6547
  { PseudoVLUXSEG6EI16_V_MF4_MF8_TU, VLUXSEG6EI16_V, 0x5 }, // 6548
  { PseudoVLUXSEG6EI16_V_MF2_MF4, VLUXSEG6EI16_V, 0x6 }, // 6549
  { PseudoVLUXSEG6EI16_V_MF2_MF4_MASK, VLUXSEG6EI16_V, 0x6 }, // 6550
  { PseudoVLUXSEG6EI16_V_MF2_MF4_TU, VLUXSEG6EI16_V, 0x6 }, // 6551
  { PseudoVLUXSEG6EI16_V_MF4_MF4, VLUXSEG6EI16_V, 0x6 }, // 6552
  { PseudoVLUXSEG6EI16_V_MF4_MF4_MASK, VLUXSEG6EI16_V, 0x6 }, // 6553
  { PseudoVLUXSEG6EI16_V_MF4_MF4_TU, VLUXSEG6EI16_V, 0x6 }, // 6554
  { PseudoVLUXSEG6EI16_V_M1_MF2, VLUXSEG6EI16_V, 0x7 }, // 6555
  { PseudoVLUXSEG6EI16_V_M1_MF2_MASK, VLUXSEG6EI16_V, 0x7 }, // 6556
  { PseudoVLUXSEG6EI16_V_M1_MF2_TU, VLUXSEG6EI16_V, 0x7 }, // 6557
  { PseudoVLUXSEG6EI16_V_MF2_MF2, VLUXSEG6EI16_V, 0x7 }, // 6558
  { PseudoVLUXSEG6EI16_V_MF2_MF2_MASK, VLUXSEG6EI16_V, 0x7 }, // 6559
  { PseudoVLUXSEG6EI16_V_MF2_MF2_TU, VLUXSEG6EI16_V, 0x7 }, // 6560
  { PseudoVLUXSEG6EI16_V_MF4_MF2, VLUXSEG6EI16_V, 0x7 }, // 6561
  { PseudoVLUXSEG6EI16_V_MF4_MF2_MASK, VLUXSEG6EI16_V, 0x7 }, // 6562
  { PseudoVLUXSEG6EI16_V_MF4_MF2_TU, VLUXSEG6EI16_V, 0x7 }, // 6563
  { PseudoVLUXSEG6EI32_V_M1_M1, VLUXSEG6EI32_V, 0x0 }, // 6564
  { PseudoVLUXSEG6EI32_V_M1_M1_MASK, VLUXSEG6EI32_V, 0x0 }, // 6565
  { PseudoVLUXSEG6EI32_V_M1_M1_TU, VLUXSEG6EI32_V, 0x0 }, // 6566
  { PseudoVLUXSEG6EI32_V_M2_M1, VLUXSEG6EI32_V, 0x0 }, // 6567
  { PseudoVLUXSEG6EI32_V_M2_M1_MASK, VLUXSEG6EI32_V, 0x0 }, // 6568
  { PseudoVLUXSEG6EI32_V_M2_M1_TU, VLUXSEG6EI32_V, 0x0 }, // 6569
  { PseudoVLUXSEG6EI32_V_M4_M1, VLUXSEG6EI32_V, 0x0 }, // 6570
  { PseudoVLUXSEG6EI32_V_M4_M1_MASK, VLUXSEG6EI32_V, 0x0 }, // 6571
  { PseudoVLUXSEG6EI32_V_M4_M1_TU, VLUXSEG6EI32_V, 0x0 }, // 6572
  { PseudoVLUXSEG6EI32_V_MF2_M1, VLUXSEG6EI32_V, 0x0 }, // 6573
  { PseudoVLUXSEG6EI32_V_MF2_M1_MASK, VLUXSEG6EI32_V, 0x0 }, // 6574
  { PseudoVLUXSEG6EI32_V_MF2_M1_TU, VLUXSEG6EI32_V, 0x0 }, // 6575
  { PseudoVLUXSEG6EI32_V_MF2_MF8, VLUXSEG6EI32_V, 0x5 }, // 6576
  { PseudoVLUXSEG6EI32_V_MF2_MF8_MASK, VLUXSEG6EI32_V, 0x5 }, // 6577
  { PseudoVLUXSEG6EI32_V_MF2_MF8_TU, VLUXSEG6EI32_V, 0x5 }, // 6578
  { PseudoVLUXSEG6EI32_V_M1_MF4, VLUXSEG6EI32_V, 0x6 }, // 6579
  { PseudoVLUXSEG6EI32_V_M1_MF4_MASK, VLUXSEG6EI32_V, 0x6 }, // 6580
  { PseudoVLUXSEG6EI32_V_M1_MF4_TU, VLUXSEG6EI32_V, 0x6 }, // 6581
  { PseudoVLUXSEG6EI32_V_MF2_MF4, VLUXSEG6EI32_V, 0x6 }, // 6582
  { PseudoVLUXSEG6EI32_V_MF2_MF4_MASK, VLUXSEG6EI32_V, 0x6 }, // 6583
  { PseudoVLUXSEG6EI32_V_MF2_MF4_TU, VLUXSEG6EI32_V, 0x6 }, // 6584
  { PseudoVLUXSEG6EI32_V_M1_MF2, VLUXSEG6EI32_V, 0x7 }, // 6585
  { PseudoVLUXSEG6EI32_V_M1_MF2_MASK, VLUXSEG6EI32_V, 0x7 }, // 6586
  { PseudoVLUXSEG6EI32_V_M1_MF2_TU, VLUXSEG6EI32_V, 0x7 }, // 6587
  { PseudoVLUXSEG6EI32_V_M2_MF2, VLUXSEG6EI32_V, 0x7 }, // 6588
  { PseudoVLUXSEG6EI32_V_M2_MF2_MASK, VLUXSEG6EI32_V, 0x7 }, // 6589
  { PseudoVLUXSEG6EI32_V_M2_MF2_TU, VLUXSEG6EI32_V, 0x7 }, // 6590
  { PseudoVLUXSEG6EI32_V_MF2_MF2, VLUXSEG6EI32_V, 0x7 }, // 6591
  { PseudoVLUXSEG6EI32_V_MF2_MF2_MASK, VLUXSEG6EI32_V, 0x7 }, // 6592
  { PseudoVLUXSEG6EI32_V_MF2_MF2_TU, VLUXSEG6EI32_V, 0x7 }, // 6593
  { PseudoVLUXSEG6EI64_V_M1_M1, VLUXSEG6EI64_V, 0x0 }, // 6594
  { PseudoVLUXSEG6EI64_V_M1_M1_MASK, VLUXSEG6EI64_V, 0x0 }, // 6595
  { PseudoVLUXSEG6EI64_V_M1_M1_TU, VLUXSEG6EI64_V, 0x0 }, // 6596
  { PseudoVLUXSEG6EI64_V_M2_M1, VLUXSEG6EI64_V, 0x0 }, // 6597
  { PseudoVLUXSEG6EI64_V_M2_M1_MASK, VLUXSEG6EI64_V, 0x0 }, // 6598
  { PseudoVLUXSEG6EI64_V_M2_M1_TU, VLUXSEG6EI64_V, 0x0 }, // 6599
  { PseudoVLUXSEG6EI64_V_M4_M1, VLUXSEG6EI64_V, 0x0 }, // 6600
  { PseudoVLUXSEG6EI64_V_M4_M1_MASK, VLUXSEG6EI64_V, 0x0 }, // 6601
  { PseudoVLUXSEG6EI64_V_M4_M1_TU, VLUXSEG6EI64_V, 0x0 }, // 6602
  { PseudoVLUXSEG6EI64_V_M8_M1, VLUXSEG6EI64_V, 0x0 }, // 6603
  { PseudoVLUXSEG6EI64_V_M8_M1_MASK, VLUXSEG6EI64_V, 0x0 }, // 6604
  { PseudoVLUXSEG6EI64_V_M8_M1_TU, VLUXSEG6EI64_V, 0x0 }, // 6605
  { PseudoVLUXSEG6EI64_V_M1_MF8, VLUXSEG6EI64_V, 0x5 }, // 6606
  { PseudoVLUXSEG6EI64_V_M1_MF8_MASK, VLUXSEG6EI64_V, 0x5 }, // 6607
  { PseudoVLUXSEG6EI64_V_M1_MF8_TU, VLUXSEG6EI64_V, 0x5 }, // 6608
  { PseudoVLUXSEG6EI64_V_M1_MF4, VLUXSEG6EI64_V, 0x6 }, // 6609
  { PseudoVLUXSEG6EI64_V_M1_MF4_MASK, VLUXSEG6EI64_V, 0x6 }, // 6610
  { PseudoVLUXSEG6EI64_V_M1_MF4_TU, VLUXSEG6EI64_V, 0x6 }, // 6611
  { PseudoVLUXSEG6EI64_V_M2_MF4, VLUXSEG6EI64_V, 0x6 }, // 6612
  { PseudoVLUXSEG6EI64_V_M2_MF4_MASK, VLUXSEG6EI64_V, 0x6 }, // 6613
  { PseudoVLUXSEG6EI64_V_M2_MF4_TU, VLUXSEG6EI64_V, 0x6 }, // 6614
  { PseudoVLUXSEG6EI64_V_M1_MF2, VLUXSEG6EI64_V, 0x7 }, // 6615
  { PseudoVLUXSEG6EI64_V_M1_MF2_MASK, VLUXSEG6EI64_V, 0x7 }, // 6616
  { PseudoVLUXSEG6EI64_V_M1_MF2_TU, VLUXSEG6EI64_V, 0x7 }, // 6617
  { PseudoVLUXSEG6EI64_V_M2_MF2, VLUXSEG6EI64_V, 0x7 }, // 6618
  { PseudoVLUXSEG6EI64_V_M2_MF2_MASK, VLUXSEG6EI64_V, 0x7 }, // 6619
  { PseudoVLUXSEG6EI64_V_M2_MF2_TU, VLUXSEG6EI64_V, 0x7 }, // 6620
  { PseudoVLUXSEG6EI64_V_M4_MF2, VLUXSEG6EI64_V, 0x7 }, // 6621
  { PseudoVLUXSEG6EI64_V_M4_MF2_MASK, VLUXSEG6EI64_V, 0x7 }, // 6622
  { PseudoVLUXSEG6EI64_V_M4_MF2_TU, VLUXSEG6EI64_V, 0x7 }, // 6623
  { PseudoVLUXSEG6EI8_V_M1_M1, VLUXSEG6EI8_V, 0x0 }, // 6624
  { PseudoVLUXSEG6EI8_V_M1_M1_MASK, VLUXSEG6EI8_V, 0x0 }, // 6625
  { PseudoVLUXSEG6EI8_V_M1_M1_TU, VLUXSEG6EI8_V, 0x0 }, // 6626
  { PseudoVLUXSEG6EI8_V_MF2_M1, VLUXSEG6EI8_V, 0x0 }, // 6627
  { PseudoVLUXSEG6EI8_V_MF2_M1_MASK, VLUXSEG6EI8_V, 0x0 }, // 6628
  { PseudoVLUXSEG6EI8_V_MF2_M1_TU, VLUXSEG6EI8_V, 0x0 }, // 6629
  { PseudoVLUXSEG6EI8_V_MF4_M1, VLUXSEG6EI8_V, 0x0 }, // 6630
  { PseudoVLUXSEG6EI8_V_MF4_M1_MASK, VLUXSEG6EI8_V, 0x0 }, // 6631
  { PseudoVLUXSEG6EI8_V_MF4_M1_TU, VLUXSEG6EI8_V, 0x0 }, // 6632
  { PseudoVLUXSEG6EI8_V_MF8_M1, VLUXSEG6EI8_V, 0x0 }, // 6633
  { PseudoVLUXSEG6EI8_V_MF8_M1_MASK, VLUXSEG6EI8_V, 0x0 }, // 6634
  { PseudoVLUXSEG6EI8_V_MF8_M1_TU, VLUXSEG6EI8_V, 0x0 }, // 6635
  { PseudoVLUXSEG6EI8_V_MF8_MF8, VLUXSEG6EI8_V, 0x5 }, // 6636
  { PseudoVLUXSEG6EI8_V_MF8_MF8_MASK, VLUXSEG6EI8_V, 0x5 }, // 6637
  { PseudoVLUXSEG6EI8_V_MF8_MF8_TU, VLUXSEG6EI8_V, 0x5 }, // 6638
  { PseudoVLUXSEG6EI8_V_MF4_MF4, VLUXSEG6EI8_V, 0x6 }, // 6639
  { PseudoVLUXSEG6EI8_V_MF4_MF4_MASK, VLUXSEG6EI8_V, 0x6 }, // 6640
  { PseudoVLUXSEG6EI8_V_MF4_MF4_TU, VLUXSEG6EI8_V, 0x6 }, // 6641
  { PseudoVLUXSEG6EI8_V_MF8_MF4, VLUXSEG6EI8_V, 0x6 }, // 6642
  { PseudoVLUXSEG6EI8_V_MF8_MF4_MASK, VLUXSEG6EI8_V, 0x6 }, // 6643
  { PseudoVLUXSEG6EI8_V_MF8_MF4_TU, VLUXSEG6EI8_V, 0x6 }, // 6644
  { PseudoVLUXSEG6EI8_V_MF2_MF2, VLUXSEG6EI8_V, 0x7 }, // 6645
  { PseudoVLUXSEG6EI8_V_MF2_MF2_MASK, VLUXSEG6EI8_V, 0x7 }, // 6646
  { PseudoVLUXSEG6EI8_V_MF2_MF2_TU, VLUXSEG6EI8_V, 0x7 }, // 6647
  { PseudoVLUXSEG6EI8_V_MF4_MF2, VLUXSEG6EI8_V, 0x7 }, // 6648
  { PseudoVLUXSEG6EI8_V_MF4_MF2_MASK, VLUXSEG6EI8_V, 0x7 }, // 6649
  { PseudoVLUXSEG6EI8_V_MF4_MF2_TU, VLUXSEG6EI8_V, 0x7 }, // 6650
  { PseudoVLUXSEG6EI8_V_MF8_MF2, VLUXSEG6EI8_V, 0x7 }, // 6651
  { PseudoVLUXSEG6EI8_V_MF8_MF2_MASK, VLUXSEG6EI8_V, 0x7 }, // 6652
  { PseudoVLUXSEG6EI8_V_MF8_MF2_TU, VLUXSEG6EI8_V, 0x7 }, // 6653
  { PseudoVLUXSEG7EI16_V_M1_M1, VLUXSEG7EI16_V, 0x0 }, // 6654
  { PseudoVLUXSEG7EI16_V_M1_M1_MASK, VLUXSEG7EI16_V, 0x0 }, // 6655
  { PseudoVLUXSEG7EI16_V_M1_M1_TU, VLUXSEG7EI16_V, 0x0 }, // 6656
  { PseudoVLUXSEG7EI16_V_M2_M1, VLUXSEG7EI16_V, 0x0 }, // 6657
  { PseudoVLUXSEG7EI16_V_M2_M1_MASK, VLUXSEG7EI16_V, 0x0 }, // 6658
  { PseudoVLUXSEG7EI16_V_M2_M1_TU, VLUXSEG7EI16_V, 0x0 }, // 6659
  { PseudoVLUXSEG7EI16_V_MF2_M1, VLUXSEG7EI16_V, 0x0 }, // 6660
  { PseudoVLUXSEG7EI16_V_MF2_M1_MASK, VLUXSEG7EI16_V, 0x0 }, // 6661
  { PseudoVLUXSEG7EI16_V_MF2_M1_TU, VLUXSEG7EI16_V, 0x0 }, // 6662
  { PseudoVLUXSEG7EI16_V_MF4_M1, VLUXSEG7EI16_V, 0x0 }, // 6663
  { PseudoVLUXSEG7EI16_V_MF4_M1_MASK, VLUXSEG7EI16_V, 0x0 }, // 6664
  { PseudoVLUXSEG7EI16_V_MF4_M1_TU, VLUXSEG7EI16_V, 0x0 }, // 6665
  { PseudoVLUXSEG7EI16_V_MF4_MF8, VLUXSEG7EI16_V, 0x5 }, // 6666
  { PseudoVLUXSEG7EI16_V_MF4_MF8_MASK, VLUXSEG7EI16_V, 0x5 }, // 6667
  { PseudoVLUXSEG7EI16_V_MF4_MF8_TU, VLUXSEG7EI16_V, 0x5 }, // 6668
  { PseudoVLUXSEG7EI16_V_MF2_MF4, VLUXSEG7EI16_V, 0x6 }, // 6669
  { PseudoVLUXSEG7EI16_V_MF2_MF4_MASK, VLUXSEG7EI16_V, 0x6 }, // 6670
  { PseudoVLUXSEG7EI16_V_MF2_MF4_TU, VLUXSEG7EI16_V, 0x6 }, // 6671
  { PseudoVLUXSEG7EI16_V_MF4_MF4, VLUXSEG7EI16_V, 0x6 }, // 6672
  { PseudoVLUXSEG7EI16_V_MF4_MF4_MASK, VLUXSEG7EI16_V, 0x6 }, // 6673
  { PseudoVLUXSEG7EI16_V_MF4_MF4_TU, VLUXSEG7EI16_V, 0x6 }, // 6674
  { PseudoVLUXSEG7EI16_V_M1_MF2, VLUXSEG7EI16_V, 0x7 }, // 6675
  { PseudoVLUXSEG7EI16_V_M1_MF2_MASK, VLUXSEG7EI16_V, 0x7 }, // 6676
  { PseudoVLUXSEG7EI16_V_M1_MF2_TU, VLUXSEG7EI16_V, 0x7 }, // 6677
  { PseudoVLUXSEG7EI16_V_MF2_MF2, VLUXSEG7EI16_V, 0x7 }, // 6678
  { PseudoVLUXSEG7EI16_V_MF2_MF2_MASK, VLUXSEG7EI16_V, 0x7 }, // 6679
  { PseudoVLUXSEG7EI16_V_MF2_MF2_TU, VLUXSEG7EI16_V, 0x7 }, // 6680
  { PseudoVLUXSEG7EI16_V_MF4_MF2, VLUXSEG7EI16_V, 0x7 }, // 6681
  { PseudoVLUXSEG7EI16_V_MF4_MF2_MASK, VLUXSEG7EI16_V, 0x7 }, // 6682
  { PseudoVLUXSEG7EI16_V_MF4_MF2_TU, VLUXSEG7EI16_V, 0x7 }, // 6683
  { PseudoVLUXSEG7EI32_V_M1_M1, VLUXSEG7EI32_V, 0x0 }, // 6684
  { PseudoVLUXSEG7EI32_V_M1_M1_MASK, VLUXSEG7EI32_V, 0x0 }, // 6685
  { PseudoVLUXSEG7EI32_V_M1_M1_TU, VLUXSEG7EI32_V, 0x0 }, // 6686
  { PseudoVLUXSEG7EI32_V_M2_M1, VLUXSEG7EI32_V, 0x0 }, // 6687
  { PseudoVLUXSEG7EI32_V_M2_M1_MASK, VLUXSEG7EI32_V, 0x0 }, // 6688
  { PseudoVLUXSEG7EI32_V_M2_M1_TU, VLUXSEG7EI32_V, 0x0 }, // 6689
  { PseudoVLUXSEG7EI32_V_M4_M1, VLUXSEG7EI32_V, 0x0 }, // 6690
  { PseudoVLUXSEG7EI32_V_M4_M1_MASK, VLUXSEG7EI32_V, 0x0 }, // 6691
  { PseudoVLUXSEG7EI32_V_M4_M1_TU, VLUXSEG7EI32_V, 0x0 }, // 6692
  { PseudoVLUXSEG7EI32_V_MF2_M1, VLUXSEG7EI32_V, 0x0 }, // 6693
  { PseudoVLUXSEG7EI32_V_MF2_M1_MASK, VLUXSEG7EI32_V, 0x0 }, // 6694
  { PseudoVLUXSEG7EI32_V_MF2_M1_TU, VLUXSEG7EI32_V, 0x0 }, // 6695
  { PseudoVLUXSEG7EI32_V_MF2_MF8, VLUXSEG7EI32_V, 0x5 }, // 6696
  { PseudoVLUXSEG7EI32_V_MF2_MF8_MASK, VLUXSEG7EI32_V, 0x5 }, // 6697
  { PseudoVLUXSEG7EI32_V_MF2_MF8_TU, VLUXSEG7EI32_V, 0x5 }, // 6698
  { PseudoVLUXSEG7EI32_V_M1_MF4, VLUXSEG7EI32_V, 0x6 }, // 6699
  { PseudoVLUXSEG7EI32_V_M1_MF4_MASK, VLUXSEG7EI32_V, 0x6 }, // 6700
  { PseudoVLUXSEG7EI32_V_M1_MF4_TU, VLUXSEG7EI32_V, 0x6 }, // 6701
  { PseudoVLUXSEG7EI32_V_MF2_MF4, VLUXSEG7EI32_V, 0x6 }, // 6702
  { PseudoVLUXSEG7EI32_V_MF2_MF4_MASK, VLUXSEG7EI32_V, 0x6 }, // 6703
  { PseudoVLUXSEG7EI32_V_MF2_MF4_TU, VLUXSEG7EI32_V, 0x6 }, // 6704
  { PseudoVLUXSEG7EI32_V_M1_MF2, VLUXSEG7EI32_V, 0x7 }, // 6705
  { PseudoVLUXSEG7EI32_V_M1_MF2_MASK, VLUXSEG7EI32_V, 0x7 }, // 6706
  { PseudoVLUXSEG7EI32_V_M1_MF2_TU, VLUXSEG7EI32_V, 0x7 }, // 6707
  { PseudoVLUXSEG7EI32_V_M2_MF2, VLUXSEG7EI32_V, 0x7 }, // 6708
  { PseudoVLUXSEG7EI32_V_M2_MF2_MASK, VLUXSEG7EI32_V, 0x7 }, // 6709
  { PseudoVLUXSEG7EI32_V_M2_MF2_TU, VLUXSEG7EI32_V, 0x7 }, // 6710
  { PseudoVLUXSEG7EI32_V_MF2_MF2, VLUXSEG7EI32_V, 0x7 }, // 6711
  { PseudoVLUXSEG7EI32_V_MF2_MF2_MASK, VLUXSEG7EI32_V, 0x7 }, // 6712
  { PseudoVLUXSEG7EI32_V_MF2_MF2_TU, VLUXSEG7EI32_V, 0x7 }, // 6713
  { PseudoVLUXSEG7EI64_V_M1_M1, VLUXSEG7EI64_V, 0x0 }, // 6714
  { PseudoVLUXSEG7EI64_V_M1_M1_MASK, VLUXSEG7EI64_V, 0x0 }, // 6715
  { PseudoVLUXSEG7EI64_V_M1_M1_TU, VLUXSEG7EI64_V, 0x0 }, // 6716
  { PseudoVLUXSEG7EI64_V_M2_M1, VLUXSEG7EI64_V, 0x0 }, // 6717
  { PseudoVLUXSEG7EI64_V_M2_M1_MASK, VLUXSEG7EI64_V, 0x0 }, // 6718
  { PseudoVLUXSEG7EI64_V_M2_M1_TU, VLUXSEG7EI64_V, 0x0 }, // 6719
  { PseudoVLUXSEG7EI64_V_M4_M1, VLUXSEG7EI64_V, 0x0 }, // 6720
  { PseudoVLUXSEG7EI64_V_M4_M1_MASK, VLUXSEG7EI64_V, 0x0 }, // 6721
  { PseudoVLUXSEG7EI64_V_M4_M1_TU, VLUXSEG7EI64_V, 0x0 }, // 6722
  { PseudoVLUXSEG7EI64_V_M8_M1, VLUXSEG7EI64_V, 0x0 }, // 6723
  { PseudoVLUXSEG7EI64_V_M8_M1_MASK, VLUXSEG7EI64_V, 0x0 }, // 6724
  { PseudoVLUXSEG7EI64_V_M8_M1_TU, VLUXSEG7EI64_V, 0x0 }, // 6725
  { PseudoVLUXSEG7EI64_V_M1_MF8, VLUXSEG7EI64_V, 0x5 }, // 6726
  { PseudoVLUXSEG7EI64_V_M1_MF8_MASK, VLUXSEG7EI64_V, 0x5 }, // 6727
  { PseudoVLUXSEG7EI64_V_M1_MF8_TU, VLUXSEG7EI64_V, 0x5 }, // 6728
  { PseudoVLUXSEG7EI64_V_M1_MF4, VLUXSEG7EI64_V, 0x6 }, // 6729
  { PseudoVLUXSEG7EI64_V_M1_MF4_MASK, VLUXSEG7EI64_V, 0x6 }, // 6730
  { PseudoVLUXSEG7EI64_V_M1_MF4_TU, VLUXSEG7EI64_V, 0x6 }, // 6731
  { PseudoVLUXSEG7EI64_V_M2_MF4, VLUXSEG7EI64_V, 0x6 }, // 6732
  { PseudoVLUXSEG7EI64_V_M2_MF4_MASK, VLUXSEG7EI64_V, 0x6 }, // 6733
  { PseudoVLUXSEG7EI64_V_M2_MF4_TU, VLUXSEG7EI64_V, 0x6 }, // 6734
  { PseudoVLUXSEG7EI64_V_M1_MF2, VLUXSEG7EI64_V, 0x7 }, // 6735
  { PseudoVLUXSEG7EI64_V_M1_MF2_MASK, VLUXSEG7EI64_V, 0x7 }, // 6736
  { PseudoVLUXSEG7EI64_V_M1_MF2_TU, VLUXSEG7EI64_V, 0x7 }, // 6737
  { PseudoVLUXSEG7EI64_V_M2_MF2, VLUXSEG7EI64_V, 0x7 }, // 6738
  { PseudoVLUXSEG7EI64_V_M2_MF2_MASK, VLUXSEG7EI64_V, 0x7 }, // 6739
  { PseudoVLUXSEG7EI64_V_M2_MF2_TU, VLUXSEG7EI64_V, 0x7 }, // 6740
  { PseudoVLUXSEG7EI64_V_M4_MF2, VLUXSEG7EI64_V, 0x7 }, // 6741
  { PseudoVLUXSEG7EI64_V_M4_MF2_MASK, VLUXSEG7EI64_V, 0x7 }, // 6742
  { PseudoVLUXSEG7EI64_V_M4_MF2_TU, VLUXSEG7EI64_V, 0x7 }, // 6743
  { PseudoVLUXSEG7EI8_V_M1_M1, VLUXSEG7EI8_V, 0x0 }, // 6744
  { PseudoVLUXSEG7EI8_V_M1_M1_MASK, VLUXSEG7EI8_V, 0x0 }, // 6745
  { PseudoVLUXSEG7EI8_V_M1_M1_TU, VLUXSEG7EI8_V, 0x0 }, // 6746
  { PseudoVLUXSEG7EI8_V_MF2_M1, VLUXSEG7EI8_V, 0x0 }, // 6747
  { PseudoVLUXSEG7EI8_V_MF2_M1_MASK, VLUXSEG7EI8_V, 0x0 }, // 6748
  { PseudoVLUXSEG7EI8_V_MF2_M1_TU, VLUXSEG7EI8_V, 0x0 }, // 6749
  { PseudoVLUXSEG7EI8_V_MF4_M1, VLUXSEG7EI8_V, 0x0 }, // 6750
  { PseudoVLUXSEG7EI8_V_MF4_M1_MASK, VLUXSEG7EI8_V, 0x0 }, // 6751
  { PseudoVLUXSEG7EI8_V_MF4_M1_TU, VLUXSEG7EI8_V, 0x0 }, // 6752
  { PseudoVLUXSEG7EI8_V_MF8_M1, VLUXSEG7EI8_V, 0x0 }, // 6753
  { PseudoVLUXSEG7EI8_V_MF8_M1_MASK, VLUXSEG7EI8_V, 0x0 }, // 6754
  { PseudoVLUXSEG7EI8_V_MF8_M1_TU, VLUXSEG7EI8_V, 0x0 }, // 6755
  { PseudoVLUXSEG7EI8_V_MF8_MF8, VLUXSEG7EI8_V, 0x5 }, // 6756
  { PseudoVLUXSEG7EI8_V_MF8_MF8_MASK, VLUXSEG7EI8_V, 0x5 }, // 6757
  { PseudoVLUXSEG7EI8_V_MF8_MF8_TU, VLUXSEG7EI8_V, 0x5 }, // 6758
  { PseudoVLUXSEG7EI8_V_MF4_MF4, VLUXSEG7EI8_V, 0x6 }, // 6759
  { PseudoVLUXSEG7EI8_V_MF4_MF4_MASK, VLUXSEG7EI8_V, 0x6 }, // 6760
  { PseudoVLUXSEG7EI8_V_MF4_MF4_TU, VLUXSEG7EI8_V, 0x6 }, // 6761
  { PseudoVLUXSEG7EI8_V_MF8_MF4, VLUXSEG7EI8_V, 0x6 }, // 6762
  { PseudoVLUXSEG7EI8_V_MF8_MF4_MASK, VLUXSEG7EI8_V, 0x6 }, // 6763
  { PseudoVLUXSEG7EI8_V_MF8_MF4_TU, VLUXSEG7EI8_V, 0x6 }, // 6764
  { PseudoVLUXSEG7EI8_V_MF2_MF2, VLUXSEG7EI8_V, 0x7 }, // 6765
  { PseudoVLUXSEG7EI8_V_MF2_MF2_MASK, VLUXSEG7EI8_V, 0x7 }, // 6766
  { PseudoVLUXSEG7EI8_V_MF2_MF2_TU, VLUXSEG7EI8_V, 0x7 }, // 6767
  { PseudoVLUXSEG7EI8_V_MF4_MF2, VLUXSEG7EI8_V, 0x7 }, // 6768
  { PseudoVLUXSEG7EI8_V_MF4_MF2_MASK, VLUXSEG7EI8_V, 0x7 }, // 6769
  { PseudoVLUXSEG7EI8_V_MF4_MF2_TU, VLUXSEG7EI8_V, 0x7 }, // 6770
  { PseudoVLUXSEG7EI8_V_MF8_MF2, VLUXSEG7EI8_V, 0x7 }, // 6771
  { PseudoVLUXSEG7EI8_V_MF8_MF2_MASK, VLUXSEG7EI8_V, 0x7 }, // 6772
  { PseudoVLUXSEG7EI8_V_MF8_MF2_TU, VLUXSEG7EI8_V, 0x7 }, // 6773
  { PseudoVLUXSEG8EI16_V_M1_M1, VLUXSEG8EI16_V, 0x0 }, // 6774
  { PseudoVLUXSEG8EI16_V_M1_M1_MASK, VLUXSEG8EI16_V, 0x0 }, // 6775
  { PseudoVLUXSEG8EI16_V_M1_M1_TU, VLUXSEG8EI16_V, 0x0 }, // 6776
  { PseudoVLUXSEG8EI16_V_M2_M1, VLUXSEG8EI16_V, 0x0 }, // 6777
  { PseudoVLUXSEG8EI16_V_M2_M1_MASK, VLUXSEG8EI16_V, 0x0 }, // 6778
  { PseudoVLUXSEG8EI16_V_M2_M1_TU, VLUXSEG8EI16_V, 0x0 }, // 6779
  { PseudoVLUXSEG8EI16_V_MF2_M1, VLUXSEG8EI16_V, 0x0 }, // 6780
  { PseudoVLUXSEG8EI16_V_MF2_M1_MASK, VLUXSEG8EI16_V, 0x0 }, // 6781
  { PseudoVLUXSEG8EI16_V_MF2_M1_TU, VLUXSEG8EI16_V, 0x0 }, // 6782
  { PseudoVLUXSEG8EI16_V_MF4_M1, VLUXSEG8EI16_V, 0x0 }, // 6783
  { PseudoVLUXSEG8EI16_V_MF4_M1_MASK, VLUXSEG8EI16_V, 0x0 }, // 6784
  { PseudoVLUXSEG8EI16_V_MF4_M1_TU, VLUXSEG8EI16_V, 0x0 }, // 6785
  { PseudoVLUXSEG8EI16_V_MF4_MF8, VLUXSEG8EI16_V, 0x5 }, // 6786
  { PseudoVLUXSEG8EI16_V_MF4_MF8_MASK, VLUXSEG8EI16_V, 0x5 }, // 6787
  { PseudoVLUXSEG8EI16_V_MF4_MF8_TU, VLUXSEG8EI16_V, 0x5 }, // 6788
  { PseudoVLUXSEG8EI16_V_MF2_MF4, VLUXSEG8EI16_V, 0x6 }, // 6789
  { PseudoVLUXSEG8EI16_V_MF2_MF4_MASK, VLUXSEG8EI16_V, 0x6 }, // 6790
  { PseudoVLUXSEG8EI16_V_MF2_MF4_TU, VLUXSEG8EI16_V, 0x6 }, // 6791
  { PseudoVLUXSEG8EI16_V_MF4_MF4, VLUXSEG8EI16_V, 0x6 }, // 6792
  { PseudoVLUXSEG8EI16_V_MF4_MF4_MASK, VLUXSEG8EI16_V, 0x6 }, // 6793
  { PseudoVLUXSEG8EI16_V_MF4_MF4_TU, VLUXSEG8EI16_V, 0x6 }, // 6794
  { PseudoVLUXSEG8EI16_V_M1_MF2, VLUXSEG8EI16_V, 0x7 }, // 6795
  { PseudoVLUXSEG8EI16_V_M1_MF2_MASK, VLUXSEG8EI16_V, 0x7 }, // 6796
  { PseudoVLUXSEG8EI16_V_M1_MF2_TU, VLUXSEG8EI16_V, 0x7 }, // 6797
  { PseudoVLUXSEG8EI16_V_MF2_MF2, VLUXSEG8EI16_V, 0x7 }, // 6798
  { PseudoVLUXSEG8EI16_V_MF2_MF2_MASK, VLUXSEG8EI16_V, 0x7 }, // 6799
  { PseudoVLUXSEG8EI16_V_MF2_MF2_TU, VLUXSEG8EI16_V, 0x7 }, // 6800
  { PseudoVLUXSEG8EI16_V_MF4_MF2, VLUXSEG8EI16_V, 0x7 }, // 6801
  { PseudoVLUXSEG8EI16_V_MF4_MF2_MASK, VLUXSEG8EI16_V, 0x7 }, // 6802
  { PseudoVLUXSEG8EI16_V_MF4_MF2_TU, VLUXSEG8EI16_V, 0x7 }, // 6803
  { PseudoVLUXSEG8EI32_V_M1_M1, VLUXSEG8EI32_V, 0x0 }, // 6804
  { PseudoVLUXSEG8EI32_V_M1_M1_MASK, VLUXSEG8EI32_V, 0x0 }, // 6805
  { PseudoVLUXSEG8EI32_V_M1_M1_TU, VLUXSEG8EI32_V, 0x0 }, // 6806
  { PseudoVLUXSEG8EI32_V_M2_M1, VLUXSEG8EI32_V, 0x0 }, // 6807
  { PseudoVLUXSEG8EI32_V_M2_M1_MASK, VLUXSEG8EI32_V, 0x0 }, // 6808
  { PseudoVLUXSEG8EI32_V_M2_M1_TU, VLUXSEG8EI32_V, 0x0 }, // 6809
  { PseudoVLUXSEG8EI32_V_M4_M1, VLUXSEG8EI32_V, 0x0 }, // 6810
  { PseudoVLUXSEG8EI32_V_M4_M1_MASK, VLUXSEG8EI32_V, 0x0 }, // 6811
  { PseudoVLUXSEG8EI32_V_M4_M1_TU, VLUXSEG8EI32_V, 0x0 }, // 6812
  { PseudoVLUXSEG8EI32_V_MF2_M1, VLUXSEG8EI32_V, 0x0 }, // 6813
  { PseudoVLUXSEG8EI32_V_MF2_M1_MASK, VLUXSEG8EI32_V, 0x0 }, // 6814
  { PseudoVLUXSEG8EI32_V_MF2_M1_TU, VLUXSEG8EI32_V, 0x0 }, // 6815
  { PseudoVLUXSEG8EI32_V_MF2_MF8, VLUXSEG8EI32_V, 0x5 }, // 6816
  { PseudoVLUXSEG8EI32_V_MF2_MF8_MASK, VLUXSEG8EI32_V, 0x5 }, // 6817
  { PseudoVLUXSEG8EI32_V_MF2_MF8_TU, VLUXSEG8EI32_V, 0x5 }, // 6818
  { PseudoVLUXSEG8EI32_V_M1_MF4, VLUXSEG8EI32_V, 0x6 }, // 6819
  { PseudoVLUXSEG8EI32_V_M1_MF4_MASK, VLUXSEG8EI32_V, 0x6 }, // 6820
  { PseudoVLUXSEG8EI32_V_M1_MF4_TU, VLUXSEG8EI32_V, 0x6 }, // 6821
  { PseudoVLUXSEG8EI32_V_MF2_MF4, VLUXSEG8EI32_V, 0x6 }, // 6822
  { PseudoVLUXSEG8EI32_V_MF2_MF4_MASK, VLUXSEG8EI32_V, 0x6 }, // 6823
  { PseudoVLUXSEG8EI32_V_MF2_MF4_TU, VLUXSEG8EI32_V, 0x6 }, // 6824
  { PseudoVLUXSEG8EI32_V_M1_MF2, VLUXSEG8EI32_V, 0x7 }, // 6825
  { PseudoVLUXSEG8EI32_V_M1_MF2_MASK, VLUXSEG8EI32_V, 0x7 }, // 6826
  { PseudoVLUXSEG8EI32_V_M1_MF2_TU, VLUXSEG8EI32_V, 0x7 }, // 6827
  { PseudoVLUXSEG8EI32_V_M2_MF2, VLUXSEG8EI32_V, 0x7 }, // 6828
  { PseudoVLUXSEG8EI32_V_M2_MF2_MASK, VLUXSEG8EI32_V, 0x7 }, // 6829
  { PseudoVLUXSEG8EI32_V_M2_MF2_TU, VLUXSEG8EI32_V, 0x7 }, // 6830
  { PseudoVLUXSEG8EI32_V_MF2_MF2, VLUXSEG8EI32_V, 0x7 }, // 6831
  { PseudoVLUXSEG8EI32_V_MF2_MF2_MASK, VLUXSEG8EI32_V, 0x7 }, // 6832
  { PseudoVLUXSEG8EI32_V_MF2_MF2_TU, VLUXSEG8EI32_V, 0x7 }, // 6833
  { PseudoVLUXSEG8EI64_V_M1_M1, VLUXSEG8EI64_V, 0x0 }, // 6834
  { PseudoVLUXSEG8EI64_V_M1_M1_MASK, VLUXSEG8EI64_V, 0x0 }, // 6835
  { PseudoVLUXSEG8EI64_V_M1_M1_TU, VLUXSEG8EI64_V, 0x0 }, // 6836
  { PseudoVLUXSEG8EI64_V_M2_M1, VLUXSEG8EI64_V, 0x0 }, // 6837
  { PseudoVLUXSEG8EI64_V_M2_M1_MASK, VLUXSEG8EI64_V, 0x0 }, // 6838
  { PseudoVLUXSEG8EI64_V_M2_M1_TU, VLUXSEG8EI64_V, 0x0 }, // 6839
  { PseudoVLUXSEG8EI64_V_M4_M1, VLUXSEG8EI64_V, 0x0 }, // 6840
  { PseudoVLUXSEG8EI64_V_M4_M1_MASK, VLUXSEG8EI64_V, 0x0 }, // 6841
  { PseudoVLUXSEG8EI64_V_M4_M1_TU, VLUXSEG8EI64_V, 0x0 }, // 6842
  { PseudoVLUXSEG8EI64_V_M8_M1, VLUXSEG8EI64_V, 0x0 }, // 6843
  { PseudoVLUXSEG8EI64_V_M8_M1_MASK, VLUXSEG8EI64_V, 0x0 }, // 6844
  { PseudoVLUXSEG8EI64_V_M8_M1_TU, VLUXSEG8EI64_V, 0x0 }, // 6845
  { PseudoVLUXSEG8EI64_V_M1_MF8, VLUXSEG8EI64_V, 0x5 }, // 6846
  { PseudoVLUXSEG8EI64_V_M1_MF8_MASK, VLUXSEG8EI64_V, 0x5 }, // 6847
  { PseudoVLUXSEG8EI64_V_M1_MF8_TU, VLUXSEG8EI64_V, 0x5 }, // 6848
  { PseudoVLUXSEG8EI64_V_M1_MF4, VLUXSEG8EI64_V, 0x6 }, // 6849
  { PseudoVLUXSEG8EI64_V_M1_MF4_MASK, VLUXSEG8EI64_V, 0x6 }, // 6850
  { PseudoVLUXSEG8EI64_V_M1_MF4_TU, VLUXSEG8EI64_V, 0x6 }, // 6851
  { PseudoVLUXSEG8EI64_V_M2_MF4, VLUXSEG8EI64_V, 0x6 }, // 6852
  { PseudoVLUXSEG8EI64_V_M2_MF4_MASK, VLUXSEG8EI64_V, 0x6 }, // 6853
  { PseudoVLUXSEG8EI64_V_M2_MF4_TU, VLUXSEG8EI64_V, 0x6 }, // 6854
  { PseudoVLUXSEG8EI64_V_M1_MF2, VLUXSEG8EI64_V, 0x7 }, // 6855
  { PseudoVLUXSEG8EI64_V_M1_MF2_MASK, VLUXSEG8EI64_V, 0x7 }, // 6856
  { PseudoVLUXSEG8EI64_V_M1_MF2_TU, VLUXSEG8EI64_V, 0x7 }, // 6857
  { PseudoVLUXSEG8EI64_V_M2_MF2, VLUXSEG8EI64_V, 0x7 }, // 6858
  { PseudoVLUXSEG8EI64_V_M2_MF2_MASK, VLUXSEG8EI64_V, 0x7 }, // 6859
  { PseudoVLUXSEG8EI64_V_M2_MF2_TU, VLUXSEG8EI64_V, 0x7 }, // 6860
  { PseudoVLUXSEG8EI64_V_M4_MF2, VLUXSEG8EI64_V, 0x7 }, // 6861
  { PseudoVLUXSEG8EI64_V_M4_MF2_MASK, VLUXSEG8EI64_V, 0x7 }, // 6862
  { PseudoVLUXSEG8EI64_V_M4_MF2_TU, VLUXSEG8EI64_V, 0x7 }, // 6863
  { PseudoVLUXSEG8EI8_V_M1_M1, VLUXSEG8EI8_V, 0x0 }, // 6864
  { PseudoVLUXSEG8EI8_V_M1_M1_MASK, VLUXSEG8EI8_V, 0x0 }, // 6865
  { PseudoVLUXSEG8EI8_V_M1_M1_TU, VLUXSEG8EI8_V, 0x0 }, // 6866
  { PseudoVLUXSEG8EI8_V_MF2_M1, VLUXSEG8EI8_V, 0x0 }, // 6867
  { PseudoVLUXSEG8EI8_V_MF2_M1_MASK, VLUXSEG8EI8_V, 0x0 }, // 6868
  { PseudoVLUXSEG8EI8_V_MF2_M1_TU, VLUXSEG8EI8_V, 0x0 }, // 6869
  { PseudoVLUXSEG8EI8_V_MF4_M1, VLUXSEG8EI8_V, 0x0 }, // 6870
  { PseudoVLUXSEG8EI8_V_MF4_M1_MASK, VLUXSEG8EI8_V, 0x0 }, // 6871
  { PseudoVLUXSEG8EI8_V_MF4_M1_TU, VLUXSEG8EI8_V, 0x0 }, // 6872
  { PseudoVLUXSEG8EI8_V_MF8_M1, VLUXSEG8EI8_V, 0x0 }, // 6873
  { PseudoVLUXSEG8EI8_V_MF8_M1_MASK, VLUXSEG8EI8_V, 0x0 }, // 6874
  { PseudoVLUXSEG8EI8_V_MF8_M1_TU, VLUXSEG8EI8_V, 0x0 }, // 6875
  { PseudoVLUXSEG8EI8_V_MF8_MF8, VLUXSEG8EI8_V, 0x5 }, // 6876
  { PseudoVLUXSEG8EI8_V_MF8_MF8_MASK, VLUXSEG8EI8_V, 0x5 }, // 6877
  { PseudoVLUXSEG8EI8_V_MF8_MF8_TU, VLUXSEG8EI8_V, 0x5 }, // 6878
  { PseudoVLUXSEG8EI8_V_MF4_MF4, VLUXSEG8EI8_V, 0x6 }, // 6879
  { PseudoVLUXSEG8EI8_V_MF4_MF4_MASK, VLUXSEG8EI8_V, 0x6 }, // 6880
  { PseudoVLUXSEG8EI8_V_MF4_MF4_TU, VLUXSEG8EI8_V, 0x6 }, // 6881
  { PseudoVLUXSEG8EI8_V_MF8_MF4, VLUXSEG8EI8_V, 0x6 }, // 6882
  { PseudoVLUXSEG8EI8_V_MF8_MF4_MASK, VLUXSEG8EI8_V, 0x6 }, // 6883
  { PseudoVLUXSEG8EI8_V_MF8_MF4_TU, VLUXSEG8EI8_V, 0x6 }, // 6884
  { PseudoVLUXSEG8EI8_V_MF2_MF2, VLUXSEG8EI8_V, 0x7 }, // 6885
  { PseudoVLUXSEG8EI8_V_MF2_MF2_MASK, VLUXSEG8EI8_V, 0x7 }, // 6886
  { PseudoVLUXSEG8EI8_V_MF2_MF2_TU, VLUXSEG8EI8_V, 0x7 }, // 6887
  { PseudoVLUXSEG8EI8_V_MF4_MF2, VLUXSEG8EI8_V, 0x7 }, // 6888
  { PseudoVLUXSEG8EI8_V_MF4_MF2_MASK, VLUXSEG8EI8_V, 0x7 }, // 6889
  { PseudoVLUXSEG8EI8_V_MF4_MF2_TU, VLUXSEG8EI8_V, 0x7 }, // 6890
  { PseudoVLUXSEG8EI8_V_MF8_MF2, VLUXSEG8EI8_V, 0x7 }, // 6891
  { PseudoVLUXSEG8EI8_V_MF8_MF2_MASK, VLUXSEG8EI8_V, 0x7 }, // 6892
  { PseudoVLUXSEG8EI8_V_MF8_MF2_TU, VLUXSEG8EI8_V, 0x7 }, // 6893
  { PseudoVMACC_VV_M1, VMACC_VV, 0x0 }, // 6894
  { PseudoVMACC_VV_M1_MASK, VMACC_VV, 0x0 }, // 6895
  { PseudoVMACC_VV_M2, VMACC_VV, 0x1 }, // 6896
  { PseudoVMACC_VV_M2_MASK, VMACC_VV, 0x1 }, // 6897
  { PseudoVMACC_VV_M4, VMACC_VV, 0x2 }, // 6898
  { PseudoVMACC_VV_M4_MASK, VMACC_VV, 0x2 }, // 6899
  { PseudoVMACC_VV_M8, VMACC_VV, 0x3 }, // 6900
  { PseudoVMACC_VV_M8_MASK, VMACC_VV, 0x3 }, // 6901
  { PseudoVMACC_VV_MF8, VMACC_VV, 0x5 }, // 6902
  { PseudoVMACC_VV_MF8_MASK, VMACC_VV, 0x5 }, // 6903
  { PseudoVMACC_VV_MF4, VMACC_VV, 0x6 }, // 6904
  { PseudoVMACC_VV_MF4_MASK, VMACC_VV, 0x6 }, // 6905
  { PseudoVMACC_VV_MF2, VMACC_VV, 0x7 }, // 6906
  { PseudoVMACC_VV_MF2_MASK, VMACC_VV, 0x7 }, // 6907
  { PseudoVMACC_VX_M1, VMACC_VX, 0x0 }, // 6908
  { PseudoVMACC_VX_M1_MASK, VMACC_VX, 0x0 }, // 6909
  { PseudoVMACC_VX_M2, VMACC_VX, 0x1 }, // 6910
  { PseudoVMACC_VX_M2_MASK, VMACC_VX, 0x1 }, // 6911
  { PseudoVMACC_VX_M4, VMACC_VX, 0x2 }, // 6912
  { PseudoVMACC_VX_M4_MASK, VMACC_VX, 0x2 }, // 6913
  { PseudoVMACC_VX_M8, VMACC_VX, 0x3 }, // 6914
  { PseudoVMACC_VX_M8_MASK, VMACC_VX, 0x3 }, // 6915
  { PseudoVMACC_VX_MF8, VMACC_VX, 0x5 }, // 6916
  { PseudoVMACC_VX_MF8_MASK, VMACC_VX, 0x5 }, // 6917
  { PseudoVMACC_VX_MF4, VMACC_VX, 0x6 }, // 6918
  { PseudoVMACC_VX_MF4_MASK, VMACC_VX, 0x6 }, // 6919
  { PseudoVMACC_VX_MF2, VMACC_VX, 0x7 }, // 6920
  { PseudoVMACC_VX_MF2_MASK, VMACC_VX, 0x7 }, // 6921
  { PseudoVMADC_VI_M1, VMADC_VI, 0x0 }, // 6922
  { PseudoVMADC_VI_M2, VMADC_VI, 0x1 }, // 6923
  { PseudoVMADC_VI_M4, VMADC_VI, 0x2 }, // 6924
  { PseudoVMADC_VI_M8, VMADC_VI, 0x3 }, // 6925
  { PseudoVMADC_VI_MF8, VMADC_VI, 0x5 }, // 6926
  { PseudoVMADC_VI_MF4, VMADC_VI, 0x6 }, // 6927
  { PseudoVMADC_VI_MF2, VMADC_VI, 0x7 }, // 6928
  { PseudoVMADC_VIM_M1, VMADC_VIM, 0x0 }, // 6929
  { PseudoVMADC_VIM_M2, VMADC_VIM, 0x1 }, // 6930
  { PseudoVMADC_VIM_M4, VMADC_VIM, 0x2 }, // 6931
  { PseudoVMADC_VIM_M8, VMADC_VIM, 0x3 }, // 6932
  { PseudoVMADC_VIM_MF8, VMADC_VIM, 0x5 }, // 6933
  { PseudoVMADC_VIM_MF4, VMADC_VIM, 0x6 }, // 6934
  { PseudoVMADC_VIM_MF2, VMADC_VIM, 0x7 }, // 6935
  { PseudoVMADC_VV_M1, VMADC_VV, 0x0 }, // 6936
  { PseudoVMADC_VV_M2, VMADC_VV, 0x1 }, // 6937
  { PseudoVMADC_VV_M4, VMADC_VV, 0x2 }, // 6938
  { PseudoVMADC_VV_M8, VMADC_VV, 0x3 }, // 6939
  { PseudoVMADC_VV_MF8, VMADC_VV, 0x5 }, // 6940
  { PseudoVMADC_VV_MF4, VMADC_VV, 0x6 }, // 6941
  { PseudoVMADC_VV_MF2, VMADC_VV, 0x7 }, // 6942
  { PseudoVMADC_VVM_M1, VMADC_VVM, 0x0 }, // 6943
  { PseudoVMADC_VVM_M2, VMADC_VVM, 0x1 }, // 6944
  { PseudoVMADC_VVM_M4, VMADC_VVM, 0x2 }, // 6945
  { PseudoVMADC_VVM_M8, VMADC_VVM, 0x3 }, // 6946
  { PseudoVMADC_VVM_MF8, VMADC_VVM, 0x5 }, // 6947
  { PseudoVMADC_VVM_MF4, VMADC_VVM, 0x6 }, // 6948
  { PseudoVMADC_VVM_MF2, VMADC_VVM, 0x7 }, // 6949
  { PseudoVMADC_VX_M1, VMADC_VX, 0x0 }, // 6950
  { PseudoVMADC_VX_M2, VMADC_VX, 0x1 }, // 6951
  { PseudoVMADC_VX_M4, VMADC_VX, 0x2 }, // 6952
  { PseudoVMADC_VX_M8, VMADC_VX, 0x3 }, // 6953
  { PseudoVMADC_VX_MF8, VMADC_VX, 0x5 }, // 6954
  { PseudoVMADC_VX_MF4, VMADC_VX, 0x6 }, // 6955
  { PseudoVMADC_VX_MF2, VMADC_VX, 0x7 }, // 6956
  { PseudoVMADC_VXM_M1, VMADC_VXM, 0x0 }, // 6957
  { PseudoVMADC_VXM_M2, VMADC_VXM, 0x1 }, // 6958
  { PseudoVMADC_VXM_M4, VMADC_VXM, 0x2 }, // 6959
  { PseudoVMADC_VXM_M8, VMADC_VXM, 0x3 }, // 6960
  { PseudoVMADC_VXM_MF8, VMADC_VXM, 0x5 }, // 6961
  { PseudoVMADC_VXM_MF4, VMADC_VXM, 0x6 }, // 6962
  { PseudoVMADC_VXM_MF2, VMADC_VXM, 0x7 }, // 6963
  { PseudoVMADD_VV_M1, VMADD_VV, 0x0 }, // 6964
  { PseudoVMADD_VV_M1_MASK, VMADD_VV, 0x0 }, // 6965
  { PseudoVMADD_VV_M2, VMADD_VV, 0x1 }, // 6966
  { PseudoVMADD_VV_M2_MASK, VMADD_VV, 0x1 }, // 6967
  { PseudoVMADD_VV_M4, VMADD_VV, 0x2 }, // 6968
  { PseudoVMADD_VV_M4_MASK, VMADD_VV, 0x2 }, // 6969
  { PseudoVMADD_VV_M8, VMADD_VV, 0x3 }, // 6970
  { PseudoVMADD_VV_M8_MASK, VMADD_VV, 0x3 }, // 6971
  { PseudoVMADD_VV_MF8, VMADD_VV, 0x5 }, // 6972
  { PseudoVMADD_VV_MF8_MASK, VMADD_VV, 0x5 }, // 6973
  { PseudoVMADD_VV_MF4, VMADD_VV, 0x6 }, // 6974
  { PseudoVMADD_VV_MF4_MASK, VMADD_VV, 0x6 }, // 6975
  { PseudoVMADD_VV_MF2, VMADD_VV, 0x7 }, // 6976
  { PseudoVMADD_VV_MF2_MASK, VMADD_VV, 0x7 }, // 6977
  { PseudoVMADD_VX_M1, VMADD_VX, 0x0 }, // 6978
  { PseudoVMADD_VX_M1_MASK, VMADD_VX, 0x0 }, // 6979
  { PseudoVMADD_VX_M2, VMADD_VX, 0x1 }, // 6980
  { PseudoVMADD_VX_M2_MASK, VMADD_VX, 0x1 }, // 6981
  { PseudoVMADD_VX_M4, VMADD_VX, 0x2 }, // 6982
  { PseudoVMADD_VX_M4_MASK, VMADD_VX, 0x2 }, // 6983
  { PseudoVMADD_VX_M8, VMADD_VX, 0x3 }, // 6984
  { PseudoVMADD_VX_M8_MASK, VMADD_VX, 0x3 }, // 6985
  { PseudoVMADD_VX_MF8, VMADD_VX, 0x5 }, // 6986
  { PseudoVMADD_VX_MF8_MASK, VMADD_VX, 0x5 }, // 6987
  { PseudoVMADD_VX_MF4, VMADD_VX, 0x6 }, // 6988
  { PseudoVMADD_VX_MF4_MASK, VMADD_VX, 0x6 }, // 6989
  { PseudoVMADD_VX_MF2, VMADD_VX, 0x7 }, // 6990
  { PseudoVMADD_VX_MF2_MASK, VMADD_VX, 0x7 }, // 6991
  { PseudoVMANDN_MM_M1, VMANDN_MM, 0x0 }, // 6992
  { PseudoVMANDN_MM_M2, VMANDN_MM, 0x1 }, // 6993
  { PseudoVMANDN_MM_M4, VMANDN_MM, 0x2 }, // 6994
  { PseudoVMANDN_MM_M8, VMANDN_MM, 0x3 }, // 6995
  { PseudoVMANDN_MM_MF8, VMANDN_MM, 0x5 }, // 6996
  { PseudoVMANDN_MM_MF4, VMANDN_MM, 0x6 }, // 6997
  { PseudoVMANDN_MM_MF2, VMANDN_MM, 0x7 }, // 6998
  { PseudoVMAND_MM_M1, VMAND_MM, 0x0 }, // 6999
  { PseudoVMAND_MM_M2, VMAND_MM, 0x1 }, // 7000
  { PseudoVMAND_MM_M4, VMAND_MM, 0x2 }, // 7001
  { PseudoVMAND_MM_M8, VMAND_MM, 0x3 }, // 7002
  { PseudoVMAND_MM_MF8, VMAND_MM, 0x5 }, // 7003
  { PseudoVMAND_MM_MF4, VMAND_MM, 0x6 }, // 7004
  { PseudoVMAND_MM_MF2, VMAND_MM, 0x7 }, // 7005
  { PseudoVMAXU_VV_M1, VMAXU_VV, 0x0 }, // 7006
  { PseudoVMAXU_VV_M1_MASK, VMAXU_VV, 0x0 }, // 7007
  { PseudoVMAXU_VV_M1_TU, VMAXU_VV, 0x0 }, // 7008
  { PseudoVMAXU_VV_M2, VMAXU_VV, 0x1 }, // 7009
  { PseudoVMAXU_VV_M2_MASK, VMAXU_VV, 0x1 }, // 7010
  { PseudoVMAXU_VV_M2_TU, VMAXU_VV, 0x1 }, // 7011
  { PseudoVMAXU_VV_M4, VMAXU_VV, 0x2 }, // 7012
  { PseudoVMAXU_VV_M4_MASK, VMAXU_VV, 0x2 }, // 7013
  { PseudoVMAXU_VV_M4_TU, VMAXU_VV, 0x2 }, // 7014
  { PseudoVMAXU_VV_M8, VMAXU_VV, 0x3 }, // 7015
  { PseudoVMAXU_VV_M8_MASK, VMAXU_VV, 0x3 }, // 7016
  { PseudoVMAXU_VV_M8_TU, VMAXU_VV, 0x3 }, // 7017
  { PseudoVMAXU_VV_MF8, VMAXU_VV, 0x5 }, // 7018
  { PseudoVMAXU_VV_MF8_MASK, VMAXU_VV, 0x5 }, // 7019
  { PseudoVMAXU_VV_MF8_TU, VMAXU_VV, 0x5 }, // 7020
  { PseudoVMAXU_VV_MF4, VMAXU_VV, 0x6 }, // 7021
  { PseudoVMAXU_VV_MF4_MASK, VMAXU_VV, 0x6 }, // 7022
  { PseudoVMAXU_VV_MF4_TU, VMAXU_VV, 0x6 }, // 7023
  { PseudoVMAXU_VV_MF2, VMAXU_VV, 0x7 }, // 7024
  { PseudoVMAXU_VV_MF2_MASK, VMAXU_VV, 0x7 }, // 7025
  { PseudoVMAXU_VV_MF2_TU, VMAXU_VV, 0x7 }, // 7026
  { PseudoVMAXU_VX_M1, VMAXU_VX, 0x0 }, // 7027
  { PseudoVMAXU_VX_M1_MASK, VMAXU_VX, 0x0 }, // 7028
  { PseudoVMAXU_VX_M1_TU, VMAXU_VX, 0x0 }, // 7029
  { PseudoVMAXU_VX_M2, VMAXU_VX, 0x1 }, // 7030
  { PseudoVMAXU_VX_M2_MASK, VMAXU_VX, 0x1 }, // 7031
  { PseudoVMAXU_VX_M2_TU, VMAXU_VX, 0x1 }, // 7032
  { PseudoVMAXU_VX_M4, VMAXU_VX, 0x2 }, // 7033
  { PseudoVMAXU_VX_M4_MASK, VMAXU_VX, 0x2 }, // 7034
  { PseudoVMAXU_VX_M4_TU, VMAXU_VX, 0x2 }, // 7035
  { PseudoVMAXU_VX_M8, VMAXU_VX, 0x3 }, // 7036
  { PseudoVMAXU_VX_M8_MASK, VMAXU_VX, 0x3 }, // 7037
  { PseudoVMAXU_VX_M8_TU, VMAXU_VX, 0x3 }, // 7038
  { PseudoVMAXU_VX_MF8, VMAXU_VX, 0x5 }, // 7039
  { PseudoVMAXU_VX_MF8_MASK, VMAXU_VX, 0x5 }, // 7040
  { PseudoVMAXU_VX_MF8_TU, VMAXU_VX, 0x5 }, // 7041
  { PseudoVMAXU_VX_MF4, VMAXU_VX, 0x6 }, // 7042
  { PseudoVMAXU_VX_MF4_MASK, VMAXU_VX, 0x6 }, // 7043
  { PseudoVMAXU_VX_MF4_TU, VMAXU_VX, 0x6 }, // 7044
  { PseudoVMAXU_VX_MF2, VMAXU_VX, 0x7 }, // 7045
  { PseudoVMAXU_VX_MF2_MASK, VMAXU_VX, 0x7 }, // 7046
  { PseudoVMAXU_VX_MF2_TU, VMAXU_VX, 0x7 }, // 7047
  { PseudoVMAX_VV_M1, VMAX_VV, 0x0 }, // 7048
  { PseudoVMAX_VV_M1_MASK, VMAX_VV, 0x0 }, // 7049
  { PseudoVMAX_VV_M1_TU, VMAX_VV, 0x0 }, // 7050
  { PseudoVMAX_VV_M2, VMAX_VV, 0x1 }, // 7051
  { PseudoVMAX_VV_M2_MASK, VMAX_VV, 0x1 }, // 7052
  { PseudoVMAX_VV_M2_TU, VMAX_VV, 0x1 }, // 7053
  { PseudoVMAX_VV_M4, VMAX_VV, 0x2 }, // 7054
  { PseudoVMAX_VV_M4_MASK, VMAX_VV, 0x2 }, // 7055
  { PseudoVMAX_VV_M4_TU, VMAX_VV, 0x2 }, // 7056
  { PseudoVMAX_VV_M8, VMAX_VV, 0x3 }, // 7057
  { PseudoVMAX_VV_M8_MASK, VMAX_VV, 0x3 }, // 7058
  { PseudoVMAX_VV_M8_TU, VMAX_VV, 0x3 }, // 7059
  { PseudoVMAX_VV_MF8, VMAX_VV, 0x5 }, // 7060
  { PseudoVMAX_VV_MF8_MASK, VMAX_VV, 0x5 }, // 7061
  { PseudoVMAX_VV_MF8_TU, VMAX_VV, 0x5 }, // 7062
  { PseudoVMAX_VV_MF4, VMAX_VV, 0x6 }, // 7063
  { PseudoVMAX_VV_MF4_MASK, VMAX_VV, 0x6 }, // 7064
  { PseudoVMAX_VV_MF4_TU, VMAX_VV, 0x6 }, // 7065
  { PseudoVMAX_VV_MF2, VMAX_VV, 0x7 }, // 7066
  { PseudoVMAX_VV_MF2_MASK, VMAX_VV, 0x7 }, // 7067
  { PseudoVMAX_VV_MF2_TU, VMAX_VV, 0x7 }, // 7068
  { PseudoVMAX_VX_M1, VMAX_VX, 0x0 }, // 7069
  { PseudoVMAX_VX_M1_MASK, VMAX_VX, 0x0 }, // 7070
  { PseudoVMAX_VX_M1_TU, VMAX_VX, 0x0 }, // 7071
  { PseudoVMAX_VX_M2, VMAX_VX, 0x1 }, // 7072
  { PseudoVMAX_VX_M2_MASK, VMAX_VX, 0x1 }, // 7073
  { PseudoVMAX_VX_M2_TU, VMAX_VX, 0x1 }, // 7074
  { PseudoVMAX_VX_M4, VMAX_VX, 0x2 }, // 7075
  { PseudoVMAX_VX_M4_MASK, VMAX_VX, 0x2 }, // 7076
  { PseudoVMAX_VX_M4_TU, VMAX_VX, 0x2 }, // 7077
  { PseudoVMAX_VX_M8, VMAX_VX, 0x3 }, // 7078
  { PseudoVMAX_VX_M8_MASK, VMAX_VX, 0x3 }, // 7079
  { PseudoVMAX_VX_M8_TU, VMAX_VX, 0x3 }, // 7080
  { PseudoVMAX_VX_MF8, VMAX_VX, 0x5 }, // 7081
  { PseudoVMAX_VX_MF8_MASK, VMAX_VX, 0x5 }, // 7082
  { PseudoVMAX_VX_MF8_TU, VMAX_VX, 0x5 }, // 7083
  { PseudoVMAX_VX_MF4, VMAX_VX, 0x6 }, // 7084
  { PseudoVMAX_VX_MF4_MASK, VMAX_VX, 0x6 }, // 7085
  { PseudoVMAX_VX_MF4_TU, VMAX_VX, 0x6 }, // 7086
  { PseudoVMAX_VX_MF2, VMAX_VX, 0x7 }, // 7087
  { PseudoVMAX_VX_MF2_MASK, VMAX_VX, 0x7 }, // 7088
  { PseudoVMAX_VX_MF2_TU, VMAX_VX, 0x7 }, // 7089
  { PseudoVMERGE_VIM_M1, VMERGE_VIM, 0x0 }, // 7090
  { PseudoVMERGE_VIM_M1_TU, VMERGE_VIM, 0x0 }, // 7091
  { PseudoVMERGE_VIM_M2, VMERGE_VIM, 0x1 }, // 7092
  { PseudoVMERGE_VIM_M2_TU, VMERGE_VIM, 0x1 }, // 7093
  { PseudoVMERGE_VIM_M4, VMERGE_VIM, 0x2 }, // 7094
  { PseudoVMERGE_VIM_M4_TU, VMERGE_VIM, 0x2 }, // 7095
  { PseudoVMERGE_VIM_M8, VMERGE_VIM, 0x3 }, // 7096
  { PseudoVMERGE_VIM_M8_TU, VMERGE_VIM, 0x3 }, // 7097
  { PseudoVMERGE_VIM_MF8, VMERGE_VIM, 0x5 }, // 7098
  { PseudoVMERGE_VIM_MF8_TU, VMERGE_VIM, 0x5 }, // 7099
  { PseudoVMERGE_VIM_MF4, VMERGE_VIM, 0x6 }, // 7100
  { PseudoVMERGE_VIM_MF4_TU, VMERGE_VIM, 0x6 }, // 7101
  { PseudoVMERGE_VIM_MF2, VMERGE_VIM, 0x7 }, // 7102
  { PseudoVMERGE_VIM_MF2_TU, VMERGE_VIM, 0x7 }, // 7103
  { PseudoVMERGE_VVM_M1, VMERGE_VVM, 0x0 }, // 7104
  { PseudoVMERGE_VVM_M1_TU, VMERGE_VVM, 0x0 }, // 7105
  { PseudoVMERGE_VVM_M2, VMERGE_VVM, 0x1 }, // 7106
  { PseudoVMERGE_VVM_M2_TU, VMERGE_VVM, 0x1 }, // 7107
  { PseudoVMERGE_VVM_M4, VMERGE_VVM, 0x2 }, // 7108
  { PseudoVMERGE_VVM_M4_TU, VMERGE_VVM, 0x2 }, // 7109
  { PseudoVMERGE_VVM_M8, VMERGE_VVM, 0x3 }, // 7110
  { PseudoVMERGE_VVM_M8_TU, VMERGE_VVM, 0x3 }, // 7111
  { PseudoVMERGE_VVM_MF8, VMERGE_VVM, 0x5 }, // 7112
  { PseudoVMERGE_VVM_MF8_TU, VMERGE_VVM, 0x5 }, // 7113
  { PseudoVMERGE_VVM_MF4, VMERGE_VVM, 0x6 }, // 7114
  { PseudoVMERGE_VVM_MF4_TU, VMERGE_VVM, 0x6 }, // 7115
  { PseudoVMERGE_VVM_MF2, VMERGE_VVM, 0x7 }, // 7116
  { PseudoVMERGE_VVM_MF2_TU, VMERGE_VVM, 0x7 }, // 7117
  { PseudoVMERGE_VXM_M1, VMERGE_VXM, 0x0 }, // 7118
  { PseudoVMERGE_VXM_M1_TU, VMERGE_VXM, 0x0 }, // 7119
  { PseudoVMERGE_VXM_M2, VMERGE_VXM, 0x1 }, // 7120
  { PseudoVMERGE_VXM_M2_TU, VMERGE_VXM, 0x1 }, // 7121
  { PseudoVMERGE_VXM_M4, VMERGE_VXM, 0x2 }, // 7122
  { PseudoVMERGE_VXM_M4_TU, VMERGE_VXM, 0x2 }, // 7123
  { PseudoVMERGE_VXM_M8, VMERGE_VXM, 0x3 }, // 7124
  { PseudoVMERGE_VXM_M8_TU, VMERGE_VXM, 0x3 }, // 7125
  { PseudoVMERGE_VXM_MF8, VMERGE_VXM, 0x5 }, // 7126
  { PseudoVMERGE_VXM_MF8_TU, VMERGE_VXM, 0x5 }, // 7127
  { PseudoVMERGE_VXM_MF4, VMERGE_VXM, 0x6 }, // 7128
  { PseudoVMERGE_VXM_MF4_TU, VMERGE_VXM, 0x6 }, // 7129
  { PseudoVMERGE_VXM_MF2, VMERGE_VXM, 0x7 }, // 7130
  { PseudoVMERGE_VXM_MF2_TU, VMERGE_VXM, 0x7 }, // 7131
  { PseudoVMFEQ_VF16_M1, VMFEQ_VF, 0x0 }, // 7132
  { PseudoVMFEQ_VF16_M1_MASK, VMFEQ_VF, 0x0 }, // 7133
  { PseudoVMFEQ_VF32_M1, VMFEQ_VF, 0x0 }, // 7134
  { PseudoVMFEQ_VF32_M1_MASK, VMFEQ_VF, 0x0 }, // 7135
  { PseudoVMFEQ_VF64_M1, VMFEQ_VF, 0x0 }, // 7136
  { PseudoVMFEQ_VF64_M1_MASK, VMFEQ_VF, 0x0 }, // 7137
  { PseudoVMFEQ_VF16_M2, VMFEQ_VF, 0x1 }, // 7138
  { PseudoVMFEQ_VF16_M2_MASK, VMFEQ_VF, 0x1 }, // 7139
  { PseudoVMFEQ_VF32_M2, VMFEQ_VF, 0x1 }, // 7140
  { PseudoVMFEQ_VF32_M2_MASK, VMFEQ_VF, 0x1 }, // 7141
  { PseudoVMFEQ_VF64_M2, VMFEQ_VF, 0x1 }, // 7142
  { PseudoVMFEQ_VF64_M2_MASK, VMFEQ_VF, 0x1 }, // 7143
  { PseudoVMFEQ_VF16_M4, VMFEQ_VF, 0x2 }, // 7144
  { PseudoVMFEQ_VF16_M4_MASK, VMFEQ_VF, 0x2 }, // 7145
  { PseudoVMFEQ_VF32_M4, VMFEQ_VF, 0x2 }, // 7146
  { PseudoVMFEQ_VF32_M4_MASK, VMFEQ_VF, 0x2 }, // 7147
  { PseudoVMFEQ_VF64_M4, VMFEQ_VF, 0x2 }, // 7148
  { PseudoVMFEQ_VF64_M4_MASK, VMFEQ_VF, 0x2 }, // 7149
  { PseudoVMFEQ_VF16_M8, VMFEQ_VF, 0x3 }, // 7150
  { PseudoVMFEQ_VF16_M8_MASK, VMFEQ_VF, 0x3 }, // 7151
  { PseudoVMFEQ_VF32_M8, VMFEQ_VF, 0x3 }, // 7152
  { PseudoVMFEQ_VF32_M8_MASK, VMFEQ_VF, 0x3 }, // 7153
  { PseudoVMFEQ_VF64_M8, VMFEQ_VF, 0x3 }, // 7154
  { PseudoVMFEQ_VF64_M8_MASK, VMFEQ_VF, 0x3 }, // 7155
  { PseudoVMFEQ_VF16_MF4, VMFEQ_VF, 0x6 }, // 7156
  { PseudoVMFEQ_VF16_MF4_MASK, VMFEQ_VF, 0x6 }, // 7157
  { PseudoVMFEQ_VF16_MF2, VMFEQ_VF, 0x7 }, // 7158
  { PseudoVMFEQ_VF16_MF2_MASK, VMFEQ_VF, 0x7 }, // 7159
  { PseudoVMFEQ_VF32_MF2, VMFEQ_VF, 0x7 }, // 7160
  { PseudoVMFEQ_VF32_MF2_MASK, VMFEQ_VF, 0x7 }, // 7161
  { PseudoVMFEQ_VV_M1, VMFEQ_VV, 0x0 }, // 7162
  { PseudoVMFEQ_VV_M1_MASK, VMFEQ_VV, 0x0 }, // 7163
  { PseudoVMFEQ_VV_M2, VMFEQ_VV, 0x1 }, // 7164
  { PseudoVMFEQ_VV_M2_MASK, VMFEQ_VV, 0x1 }, // 7165
  { PseudoVMFEQ_VV_M4, VMFEQ_VV, 0x2 }, // 7166
  { PseudoVMFEQ_VV_M4_MASK, VMFEQ_VV, 0x2 }, // 7167
  { PseudoVMFEQ_VV_M8, VMFEQ_VV, 0x3 }, // 7168
  { PseudoVMFEQ_VV_M8_MASK, VMFEQ_VV, 0x3 }, // 7169
  { PseudoVMFEQ_VV_MF4, VMFEQ_VV, 0x6 }, // 7170
  { PseudoVMFEQ_VV_MF4_MASK, VMFEQ_VV, 0x6 }, // 7171
  { PseudoVMFEQ_VV_MF2, VMFEQ_VV, 0x7 }, // 7172
  { PseudoVMFEQ_VV_MF2_MASK, VMFEQ_VV, 0x7 }, // 7173
  { PseudoVMFGE_VF16_M1, VMFGE_VF, 0x0 }, // 7174
  { PseudoVMFGE_VF16_M1_MASK, VMFGE_VF, 0x0 }, // 7175
  { PseudoVMFGE_VF32_M1, VMFGE_VF, 0x0 }, // 7176
  { PseudoVMFGE_VF32_M1_MASK, VMFGE_VF, 0x0 }, // 7177
  { PseudoVMFGE_VF64_M1, VMFGE_VF, 0x0 }, // 7178
  { PseudoVMFGE_VF64_M1_MASK, VMFGE_VF, 0x0 }, // 7179
  { PseudoVMFGE_VF16_M2, VMFGE_VF, 0x1 }, // 7180
  { PseudoVMFGE_VF16_M2_MASK, VMFGE_VF, 0x1 }, // 7181
  { PseudoVMFGE_VF32_M2, VMFGE_VF, 0x1 }, // 7182
  { PseudoVMFGE_VF32_M2_MASK, VMFGE_VF, 0x1 }, // 7183
  { PseudoVMFGE_VF64_M2, VMFGE_VF, 0x1 }, // 7184
  { PseudoVMFGE_VF64_M2_MASK, VMFGE_VF, 0x1 }, // 7185
  { PseudoVMFGE_VF16_M4, VMFGE_VF, 0x2 }, // 7186
  { PseudoVMFGE_VF16_M4_MASK, VMFGE_VF, 0x2 }, // 7187
  { PseudoVMFGE_VF32_M4, VMFGE_VF, 0x2 }, // 7188
  { PseudoVMFGE_VF32_M4_MASK, VMFGE_VF, 0x2 }, // 7189
  { PseudoVMFGE_VF64_M4, VMFGE_VF, 0x2 }, // 7190
  { PseudoVMFGE_VF64_M4_MASK, VMFGE_VF, 0x2 }, // 7191
  { PseudoVMFGE_VF16_M8, VMFGE_VF, 0x3 }, // 7192
  { PseudoVMFGE_VF16_M8_MASK, VMFGE_VF, 0x3 }, // 7193
  { PseudoVMFGE_VF32_M8, VMFGE_VF, 0x3 }, // 7194
  { PseudoVMFGE_VF32_M8_MASK, VMFGE_VF, 0x3 }, // 7195
  { PseudoVMFGE_VF64_M8, VMFGE_VF, 0x3 }, // 7196
  { PseudoVMFGE_VF64_M8_MASK, VMFGE_VF, 0x3 }, // 7197
  { PseudoVMFGE_VF16_MF4, VMFGE_VF, 0x6 }, // 7198
  { PseudoVMFGE_VF16_MF4_MASK, VMFGE_VF, 0x6 }, // 7199
  { PseudoVMFGE_VF16_MF2, VMFGE_VF, 0x7 }, // 7200
  { PseudoVMFGE_VF16_MF2_MASK, VMFGE_VF, 0x7 }, // 7201
  { PseudoVMFGE_VF32_MF2, VMFGE_VF, 0x7 }, // 7202
  { PseudoVMFGE_VF32_MF2_MASK, VMFGE_VF, 0x7 }, // 7203
  { PseudoVMFGT_VF16_M1, VMFGT_VF, 0x0 }, // 7204
  { PseudoVMFGT_VF16_M1_MASK, VMFGT_VF, 0x0 }, // 7205
  { PseudoVMFGT_VF32_M1, VMFGT_VF, 0x0 }, // 7206
  { PseudoVMFGT_VF32_M1_MASK, VMFGT_VF, 0x0 }, // 7207
  { PseudoVMFGT_VF64_M1, VMFGT_VF, 0x0 }, // 7208
  { PseudoVMFGT_VF64_M1_MASK, VMFGT_VF, 0x0 }, // 7209
  { PseudoVMFGT_VF16_M2, VMFGT_VF, 0x1 }, // 7210
  { PseudoVMFGT_VF16_M2_MASK, VMFGT_VF, 0x1 }, // 7211
  { PseudoVMFGT_VF32_M2, VMFGT_VF, 0x1 }, // 7212
  { PseudoVMFGT_VF32_M2_MASK, VMFGT_VF, 0x1 }, // 7213
  { PseudoVMFGT_VF64_M2, VMFGT_VF, 0x1 }, // 7214
  { PseudoVMFGT_VF64_M2_MASK, VMFGT_VF, 0x1 }, // 7215
  { PseudoVMFGT_VF16_M4, VMFGT_VF, 0x2 }, // 7216
  { PseudoVMFGT_VF16_M4_MASK, VMFGT_VF, 0x2 }, // 7217
  { PseudoVMFGT_VF32_M4, VMFGT_VF, 0x2 }, // 7218
  { PseudoVMFGT_VF32_M4_MASK, VMFGT_VF, 0x2 }, // 7219
  { PseudoVMFGT_VF64_M4, VMFGT_VF, 0x2 }, // 7220
  { PseudoVMFGT_VF64_M4_MASK, VMFGT_VF, 0x2 }, // 7221
  { PseudoVMFGT_VF16_M8, VMFGT_VF, 0x3 }, // 7222
  { PseudoVMFGT_VF16_M8_MASK, VMFGT_VF, 0x3 }, // 7223
  { PseudoVMFGT_VF32_M8, VMFGT_VF, 0x3 }, // 7224
  { PseudoVMFGT_VF32_M8_MASK, VMFGT_VF, 0x3 }, // 7225
  { PseudoVMFGT_VF64_M8, VMFGT_VF, 0x3 }, // 7226
  { PseudoVMFGT_VF64_M8_MASK, VMFGT_VF, 0x3 }, // 7227
  { PseudoVMFGT_VF16_MF4, VMFGT_VF, 0x6 }, // 7228
  { PseudoVMFGT_VF16_MF4_MASK, VMFGT_VF, 0x6 }, // 7229
  { PseudoVMFGT_VF16_MF2, VMFGT_VF, 0x7 }, // 7230
  { PseudoVMFGT_VF16_MF2_MASK, VMFGT_VF, 0x7 }, // 7231
  { PseudoVMFGT_VF32_MF2, VMFGT_VF, 0x7 }, // 7232
  { PseudoVMFGT_VF32_MF2_MASK, VMFGT_VF, 0x7 }, // 7233
  { PseudoVMFLE_VF16_M1, VMFLE_VF, 0x0 }, // 7234
  { PseudoVMFLE_VF16_M1_MASK, VMFLE_VF, 0x0 }, // 7235
  { PseudoVMFLE_VF32_M1, VMFLE_VF, 0x0 }, // 7236
  { PseudoVMFLE_VF32_M1_MASK, VMFLE_VF, 0x0 }, // 7237
  { PseudoVMFLE_VF64_M1, VMFLE_VF, 0x0 }, // 7238
  { PseudoVMFLE_VF64_M1_MASK, VMFLE_VF, 0x0 }, // 7239
  { PseudoVMFLE_VF16_M2, VMFLE_VF, 0x1 }, // 7240
  { PseudoVMFLE_VF16_M2_MASK, VMFLE_VF, 0x1 }, // 7241
  { PseudoVMFLE_VF32_M2, VMFLE_VF, 0x1 }, // 7242
  { PseudoVMFLE_VF32_M2_MASK, VMFLE_VF, 0x1 }, // 7243
  { PseudoVMFLE_VF64_M2, VMFLE_VF, 0x1 }, // 7244
  { PseudoVMFLE_VF64_M2_MASK, VMFLE_VF, 0x1 }, // 7245
  { PseudoVMFLE_VF16_M4, VMFLE_VF, 0x2 }, // 7246
  { PseudoVMFLE_VF16_M4_MASK, VMFLE_VF, 0x2 }, // 7247
  { PseudoVMFLE_VF32_M4, VMFLE_VF, 0x2 }, // 7248
  { PseudoVMFLE_VF32_M4_MASK, VMFLE_VF, 0x2 }, // 7249
  { PseudoVMFLE_VF64_M4, VMFLE_VF, 0x2 }, // 7250
  { PseudoVMFLE_VF64_M4_MASK, VMFLE_VF, 0x2 }, // 7251
  { PseudoVMFLE_VF16_M8, VMFLE_VF, 0x3 }, // 7252
  { PseudoVMFLE_VF16_M8_MASK, VMFLE_VF, 0x3 }, // 7253
  { PseudoVMFLE_VF32_M8, VMFLE_VF, 0x3 }, // 7254
  { PseudoVMFLE_VF32_M8_MASK, VMFLE_VF, 0x3 }, // 7255
  { PseudoVMFLE_VF64_M8, VMFLE_VF, 0x3 }, // 7256
  { PseudoVMFLE_VF64_M8_MASK, VMFLE_VF, 0x3 }, // 7257
  { PseudoVMFLE_VF16_MF4, VMFLE_VF, 0x6 }, // 7258
  { PseudoVMFLE_VF16_MF4_MASK, VMFLE_VF, 0x6 }, // 7259
  { PseudoVMFLE_VF16_MF2, VMFLE_VF, 0x7 }, // 7260
  { PseudoVMFLE_VF16_MF2_MASK, VMFLE_VF, 0x7 }, // 7261
  { PseudoVMFLE_VF32_MF2, VMFLE_VF, 0x7 }, // 7262
  { PseudoVMFLE_VF32_MF2_MASK, VMFLE_VF, 0x7 }, // 7263
  { PseudoVMFLE_VV_M1, VMFLE_VV, 0x0 }, // 7264
  { PseudoVMFLE_VV_M1_MASK, VMFLE_VV, 0x0 }, // 7265
  { PseudoVMFLE_VV_M2, VMFLE_VV, 0x1 }, // 7266
  { PseudoVMFLE_VV_M2_MASK, VMFLE_VV, 0x1 }, // 7267
  { PseudoVMFLE_VV_M4, VMFLE_VV, 0x2 }, // 7268
  { PseudoVMFLE_VV_M4_MASK, VMFLE_VV, 0x2 }, // 7269
  { PseudoVMFLE_VV_M8, VMFLE_VV, 0x3 }, // 7270
  { PseudoVMFLE_VV_M8_MASK, VMFLE_VV, 0x3 }, // 7271
  { PseudoVMFLE_VV_MF4, VMFLE_VV, 0x6 }, // 7272
  { PseudoVMFLE_VV_MF4_MASK, VMFLE_VV, 0x6 }, // 7273
  { PseudoVMFLE_VV_MF2, VMFLE_VV, 0x7 }, // 7274
  { PseudoVMFLE_VV_MF2_MASK, VMFLE_VV, 0x7 }, // 7275
  { PseudoVMFLT_VF16_M1, VMFLT_VF, 0x0 }, // 7276
  { PseudoVMFLT_VF16_M1_MASK, VMFLT_VF, 0x0 }, // 7277
  { PseudoVMFLT_VF32_M1, VMFLT_VF, 0x0 }, // 7278
  { PseudoVMFLT_VF32_M1_MASK, VMFLT_VF, 0x0 }, // 7279
  { PseudoVMFLT_VF64_M1, VMFLT_VF, 0x0 }, // 7280
  { PseudoVMFLT_VF64_M1_MASK, VMFLT_VF, 0x0 }, // 7281
  { PseudoVMFLT_VF16_M2, VMFLT_VF, 0x1 }, // 7282
  { PseudoVMFLT_VF16_M2_MASK, VMFLT_VF, 0x1 }, // 7283
  { PseudoVMFLT_VF32_M2, VMFLT_VF, 0x1 }, // 7284
  { PseudoVMFLT_VF32_M2_MASK, VMFLT_VF, 0x1 }, // 7285
  { PseudoVMFLT_VF64_M2, VMFLT_VF, 0x1 }, // 7286
  { PseudoVMFLT_VF64_M2_MASK, VMFLT_VF, 0x1 }, // 7287
  { PseudoVMFLT_VF16_M4, VMFLT_VF, 0x2 }, // 7288
  { PseudoVMFLT_VF16_M4_MASK, VMFLT_VF, 0x2 }, // 7289
  { PseudoVMFLT_VF32_M4, VMFLT_VF, 0x2 }, // 7290
  { PseudoVMFLT_VF32_M4_MASK, VMFLT_VF, 0x2 }, // 7291
  { PseudoVMFLT_VF64_M4, VMFLT_VF, 0x2 }, // 7292
  { PseudoVMFLT_VF64_M4_MASK, VMFLT_VF, 0x2 }, // 7293
  { PseudoVMFLT_VF16_M8, VMFLT_VF, 0x3 }, // 7294
  { PseudoVMFLT_VF16_M8_MASK, VMFLT_VF, 0x3 }, // 7295
  { PseudoVMFLT_VF32_M8, VMFLT_VF, 0x3 }, // 7296
  { PseudoVMFLT_VF32_M8_MASK, VMFLT_VF, 0x3 }, // 7297
  { PseudoVMFLT_VF64_M8, VMFLT_VF, 0x3 }, // 7298
  { PseudoVMFLT_VF64_M8_MASK, VMFLT_VF, 0x3 }, // 7299
  { PseudoVMFLT_VF16_MF4, VMFLT_VF, 0x6 }, // 7300
  { PseudoVMFLT_VF16_MF4_MASK, VMFLT_VF, 0x6 }, // 7301
  { PseudoVMFLT_VF16_MF2, VMFLT_VF, 0x7 }, // 7302
  { PseudoVMFLT_VF16_MF2_MASK, VMFLT_VF, 0x7 }, // 7303
  { PseudoVMFLT_VF32_MF2, VMFLT_VF, 0x7 }, // 7304
  { PseudoVMFLT_VF32_MF2_MASK, VMFLT_VF, 0x7 }, // 7305
  { PseudoVMFLT_VV_M1, VMFLT_VV, 0x0 }, // 7306
  { PseudoVMFLT_VV_M1_MASK, VMFLT_VV, 0x0 }, // 7307
  { PseudoVMFLT_VV_M2, VMFLT_VV, 0x1 }, // 7308
  { PseudoVMFLT_VV_M2_MASK, VMFLT_VV, 0x1 }, // 7309
  { PseudoVMFLT_VV_M4, VMFLT_VV, 0x2 }, // 7310
  { PseudoVMFLT_VV_M4_MASK, VMFLT_VV, 0x2 }, // 7311
  { PseudoVMFLT_VV_M8, VMFLT_VV, 0x3 }, // 7312
  { PseudoVMFLT_VV_M8_MASK, VMFLT_VV, 0x3 }, // 7313
  { PseudoVMFLT_VV_MF4, VMFLT_VV, 0x6 }, // 7314
  { PseudoVMFLT_VV_MF4_MASK, VMFLT_VV, 0x6 }, // 7315
  { PseudoVMFLT_VV_MF2, VMFLT_VV, 0x7 }, // 7316
  { PseudoVMFLT_VV_MF2_MASK, VMFLT_VV, 0x7 }, // 7317
  { PseudoVMFNE_VF16_M1, VMFNE_VF, 0x0 }, // 7318
  { PseudoVMFNE_VF16_M1_MASK, VMFNE_VF, 0x0 }, // 7319
  { PseudoVMFNE_VF32_M1, VMFNE_VF, 0x0 }, // 7320
  { PseudoVMFNE_VF32_M1_MASK, VMFNE_VF, 0x0 }, // 7321
  { PseudoVMFNE_VF64_M1, VMFNE_VF, 0x0 }, // 7322
  { PseudoVMFNE_VF64_M1_MASK, VMFNE_VF, 0x0 }, // 7323
  { PseudoVMFNE_VF16_M2, VMFNE_VF, 0x1 }, // 7324
  { PseudoVMFNE_VF16_M2_MASK, VMFNE_VF, 0x1 }, // 7325
  { PseudoVMFNE_VF32_M2, VMFNE_VF, 0x1 }, // 7326
  { PseudoVMFNE_VF32_M2_MASK, VMFNE_VF, 0x1 }, // 7327
  { PseudoVMFNE_VF64_M2, VMFNE_VF, 0x1 }, // 7328
  { PseudoVMFNE_VF64_M2_MASK, VMFNE_VF, 0x1 }, // 7329
  { PseudoVMFNE_VF16_M4, VMFNE_VF, 0x2 }, // 7330
  { PseudoVMFNE_VF16_M4_MASK, VMFNE_VF, 0x2 }, // 7331
  { PseudoVMFNE_VF32_M4, VMFNE_VF, 0x2 }, // 7332
  { PseudoVMFNE_VF32_M4_MASK, VMFNE_VF, 0x2 }, // 7333
  { PseudoVMFNE_VF64_M4, VMFNE_VF, 0x2 }, // 7334
  { PseudoVMFNE_VF64_M4_MASK, VMFNE_VF, 0x2 }, // 7335
  { PseudoVMFNE_VF16_M8, VMFNE_VF, 0x3 }, // 7336
  { PseudoVMFNE_VF16_M8_MASK, VMFNE_VF, 0x3 }, // 7337
  { PseudoVMFNE_VF32_M8, VMFNE_VF, 0x3 }, // 7338
  { PseudoVMFNE_VF32_M8_MASK, VMFNE_VF, 0x3 }, // 7339
  { PseudoVMFNE_VF64_M8, VMFNE_VF, 0x3 }, // 7340
  { PseudoVMFNE_VF64_M8_MASK, VMFNE_VF, 0x3 }, // 7341
  { PseudoVMFNE_VF16_MF4, VMFNE_VF, 0x6 }, // 7342
  { PseudoVMFNE_VF16_MF4_MASK, VMFNE_VF, 0x6 }, // 7343
  { PseudoVMFNE_VF16_MF2, VMFNE_VF, 0x7 }, // 7344
  { PseudoVMFNE_VF16_MF2_MASK, VMFNE_VF, 0x7 }, // 7345
  { PseudoVMFNE_VF32_MF2, VMFNE_VF, 0x7 }, // 7346
  { PseudoVMFNE_VF32_MF2_MASK, VMFNE_VF, 0x7 }, // 7347
  { PseudoVMFNE_VV_M1, VMFNE_VV, 0x0 }, // 7348
  { PseudoVMFNE_VV_M1_MASK, VMFNE_VV, 0x0 }, // 7349
  { PseudoVMFNE_VV_M2, VMFNE_VV, 0x1 }, // 7350
  { PseudoVMFNE_VV_M2_MASK, VMFNE_VV, 0x1 }, // 7351
  { PseudoVMFNE_VV_M4, VMFNE_VV, 0x2 }, // 7352
  { PseudoVMFNE_VV_M4_MASK, VMFNE_VV, 0x2 }, // 7353
  { PseudoVMFNE_VV_M8, VMFNE_VV, 0x3 }, // 7354
  { PseudoVMFNE_VV_M8_MASK, VMFNE_VV, 0x3 }, // 7355
  { PseudoVMFNE_VV_MF4, VMFNE_VV, 0x6 }, // 7356
  { PseudoVMFNE_VV_MF4_MASK, VMFNE_VV, 0x6 }, // 7357
  { PseudoVMFNE_VV_MF2, VMFNE_VV, 0x7 }, // 7358
  { PseudoVMFNE_VV_MF2_MASK, VMFNE_VV, 0x7 }, // 7359
  { PseudoVMINU_VV_M1, VMINU_VV, 0x0 }, // 7360
  { PseudoVMINU_VV_M1_MASK, VMINU_VV, 0x0 }, // 7361
  { PseudoVMINU_VV_M1_TU, VMINU_VV, 0x0 }, // 7362
  { PseudoVMINU_VV_M2, VMINU_VV, 0x1 }, // 7363
  { PseudoVMINU_VV_M2_MASK, VMINU_VV, 0x1 }, // 7364
  { PseudoVMINU_VV_M2_TU, VMINU_VV, 0x1 }, // 7365
  { PseudoVMINU_VV_M4, VMINU_VV, 0x2 }, // 7366
  { PseudoVMINU_VV_M4_MASK, VMINU_VV, 0x2 }, // 7367
  { PseudoVMINU_VV_M4_TU, VMINU_VV, 0x2 }, // 7368
  { PseudoVMINU_VV_M8, VMINU_VV, 0x3 }, // 7369
  { PseudoVMINU_VV_M8_MASK, VMINU_VV, 0x3 }, // 7370
  { PseudoVMINU_VV_M8_TU, VMINU_VV, 0x3 }, // 7371
  { PseudoVMINU_VV_MF8, VMINU_VV, 0x5 }, // 7372
  { PseudoVMINU_VV_MF8_MASK, VMINU_VV, 0x5 }, // 7373
  { PseudoVMINU_VV_MF8_TU, VMINU_VV, 0x5 }, // 7374
  { PseudoVMINU_VV_MF4, VMINU_VV, 0x6 }, // 7375
  { PseudoVMINU_VV_MF4_MASK, VMINU_VV, 0x6 }, // 7376
  { PseudoVMINU_VV_MF4_TU, VMINU_VV, 0x6 }, // 7377
  { PseudoVMINU_VV_MF2, VMINU_VV, 0x7 }, // 7378
  { PseudoVMINU_VV_MF2_MASK, VMINU_VV, 0x7 }, // 7379
  { PseudoVMINU_VV_MF2_TU, VMINU_VV, 0x7 }, // 7380
  { PseudoVMINU_VX_M1, VMINU_VX, 0x0 }, // 7381
  { PseudoVMINU_VX_M1_MASK, VMINU_VX, 0x0 }, // 7382
  { PseudoVMINU_VX_M1_TU, VMINU_VX, 0x0 }, // 7383
  { PseudoVMINU_VX_M2, VMINU_VX, 0x1 }, // 7384
  { PseudoVMINU_VX_M2_MASK, VMINU_VX, 0x1 }, // 7385
  { PseudoVMINU_VX_M2_TU, VMINU_VX, 0x1 }, // 7386
  { PseudoVMINU_VX_M4, VMINU_VX, 0x2 }, // 7387
  { PseudoVMINU_VX_M4_MASK, VMINU_VX, 0x2 }, // 7388
  { PseudoVMINU_VX_M4_TU, VMINU_VX, 0x2 }, // 7389
  { PseudoVMINU_VX_M8, VMINU_VX, 0x3 }, // 7390
  { PseudoVMINU_VX_M8_MASK, VMINU_VX, 0x3 }, // 7391
  { PseudoVMINU_VX_M8_TU, VMINU_VX, 0x3 }, // 7392
  { PseudoVMINU_VX_MF8, VMINU_VX, 0x5 }, // 7393
  { PseudoVMINU_VX_MF8_MASK, VMINU_VX, 0x5 }, // 7394
  { PseudoVMINU_VX_MF8_TU, VMINU_VX, 0x5 }, // 7395
  { PseudoVMINU_VX_MF4, VMINU_VX, 0x6 }, // 7396
  { PseudoVMINU_VX_MF4_MASK, VMINU_VX, 0x6 }, // 7397
  { PseudoVMINU_VX_MF4_TU, VMINU_VX, 0x6 }, // 7398
  { PseudoVMINU_VX_MF2, VMINU_VX, 0x7 }, // 7399
  { PseudoVMINU_VX_MF2_MASK, VMINU_VX, 0x7 }, // 7400
  { PseudoVMINU_VX_MF2_TU, VMINU_VX, 0x7 }, // 7401
  { PseudoVMIN_VV_M1, VMIN_VV, 0x0 }, // 7402
  { PseudoVMIN_VV_M1_MASK, VMIN_VV, 0x0 }, // 7403
  { PseudoVMIN_VV_M1_TU, VMIN_VV, 0x0 }, // 7404
  { PseudoVMIN_VV_M2, VMIN_VV, 0x1 }, // 7405
  { PseudoVMIN_VV_M2_MASK, VMIN_VV, 0x1 }, // 7406
  { PseudoVMIN_VV_M2_TU, VMIN_VV, 0x1 }, // 7407
  { PseudoVMIN_VV_M4, VMIN_VV, 0x2 }, // 7408
  { PseudoVMIN_VV_M4_MASK, VMIN_VV, 0x2 }, // 7409
  { PseudoVMIN_VV_M4_TU, VMIN_VV, 0x2 }, // 7410
  { PseudoVMIN_VV_M8, VMIN_VV, 0x3 }, // 7411
  { PseudoVMIN_VV_M8_MASK, VMIN_VV, 0x3 }, // 7412
  { PseudoVMIN_VV_M8_TU, VMIN_VV, 0x3 }, // 7413
  { PseudoVMIN_VV_MF8, VMIN_VV, 0x5 }, // 7414
  { PseudoVMIN_VV_MF8_MASK, VMIN_VV, 0x5 }, // 7415
  { PseudoVMIN_VV_MF8_TU, VMIN_VV, 0x5 }, // 7416
  { PseudoVMIN_VV_MF4, VMIN_VV, 0x6 }, // 7417
  { PseudoVMIN_VV_MF4_MASK, VMIN_VV, 0x6 }, // 7418
  { PseudoVMIN_VV_MF4_TU, VMIN_VV, 0x6 }, // 7419
  { PseudoVMIN_VV_MF2, VMIN_VV, 0x7 }, // 7420
  { PseudoVMIN_VV_MF2_MASK, VMIN_VV, 0x7 }, // 7421
  { PseudoVMIN_VV_MF2_TU, VMIN_VV, 0x7 }, // 7422
  { PseudoVMIN_VX_M1, VMIN_VX, 0x0 }, // 7423
  { PseudoVMIN_VX_M1_MASK, VMIN_VX, 0x0 }, // 7424
  { PseudoVMIN_VX_M1_TU, VMIN_VX, 0x0 }, // 7425
  { PseudoVMIN_VX_M2, VMIN_VX, 0x1 }, // 7426
  { PseudoVMIN_VX_M2_MASK, VMIN_VX, 0x1 }, // 7427
  { PseudoVMIN_VX_M2_TU, VMIN_VX, 0x1 }, // 7428
  { PseudoVMIN_VX_M4, VMIN_VX, 0x2 }, // 7429
  { PseudoVMIN_VX_M4_MASK, VMIN_VX, 0x2 }, // 7430
  { PseudoVMIN_VX_M4_TU, VMIN_VX, 0x2 }, // 7431
  { PseudoVMIN_VX_M8, VMIN_VX, 0x3 }, // 7432
  { PseudoVMIN_VX_M8_MASK, VMIN_VX, 0x3 }, // 7433
  { PseudoVMIN_VX_M8_TU, VMIN_VX, 0x3 }, // 7434
  { PseudoVMIN_VX_MF8, VMIN_VX, 0x5 }, // 7435
  { PseudoVMIN_VX_MF8_MASK, VMIN_VX, 0x5 }, // 7436
  { PseudoVMIN_VX_MF8_TU, VMIN_VX, 0x5 }, // 7437
  { PseudoVMIN_VX_MF4, VMIN_VX, 0x6 }, // 7438
  { PseudoVMIN_VX_MF4_MASK, VMIN_VX, 0x6 }, // 7439
  { PseudoVMIN_VX_MF4_TU, VMIN_VX, 0x6 }, // 7440
  { PseudoVMIN_VX_MF2, VMIN_VX, 0x7 }, // 7441
  { PseudoVMIN_VX_MF2_MASK, VMIN_VX, 0x7 }, // 7442
  { PseudoVMIN_VX_MF2_TU, VMIN_VX, 0x7 }, // 7443
  { PseudoVMNAND_MM_M1, VMNAND_MM, 0x0 }, // 7444
  { PseudoVMNAND_MM_M2, VMNAND_MM, 0x1 }, // 7445
  { PseudoVMNAND_MM_M4, VMNAND_MM, 0x2 }, // 7446
  { PseudoVMNAND_MM_M8, VMNAND_MM, 0x3 }, // 7447
  { PseudoVMNAND_MM_MF8, VMNAND_MM, 0x5 }, // 7448
  { PseudoVMNAND_MM_MF4, VMNAND_MM, 0x6 }, // 7449
  { PseudoVMNAND_MM_MF2, VMNAND_MM, 0x7 }, // 7450
  { PseudoVMNOR_MM_M1, VMNOR_MM, 0x0 }, // 7451
  { PseudoVMNOR_MM_M2, VMNOR_MM, 0x1 }, // 7452
  { PseudoVMNOR_MM_M4, VMNOR_MM, 0x2 }, // 7453
  { PseudoVMNOR_MM_M8, VMNOR_MM, 0x3 }, // 7454
  { PseudoVMNOR_MM_MF8, VMNOR_MM, 0x5 }, // 7455
  { PseudoVMNOR_MM_MF4, VMNOR_MM, 0x6 }, // 7456
  { PseudoVMNOR_MM_MF2, VMNOR_MM, 0x7 }, // 7457
  { PseudoVMORN_MM_M1, VMORN_MM, 0x0 }, // 7458
  { PseudoVMORN_MM_M2, VMORN_MM, 0x1 }, // 7459
  { PseudoVMORN_MM_M4, VMORN_MM, 0x2 }, // 7460
  { PseudoVMORN_MM_M8, VMORN_MM, 0x3 }, // 7461
  { PseudoVMORN_MM_MF8, VMORN_MM, 0x5 }, // 7462
  { PseudoVMORN_MM_MF4, VMORN_MM, 0x6 }, // 7463
  { PseudoVMORN_MM_MF2, VMORN_MM, 0x7 }, // 7464
  { PseudoVMOR_MM_M1, VMOR_MM, 0x0 }, // 7465
  { PseudoVMOR_MM_M2, VMOR_MM, 0x1 }, // 7466
  { PseudoVMOR_MM_M4, VMOR_MM, 0x2 }, // 7467
  { PseudoVMOR_MM_M8, VMOR_MM, 0x3 }, // 7468
  { PseudoVMOR_MM_MF8, VMOR_MM, 0x5 }, // 7469
  { PseudoVMOR_MM_MF4, VMOR_MM, 0x6 }, // 7470
  { PseudoVMOR_MM_MF2, VMOR_MM, 0x7 }, // 7471
  { PseudoVMSBC_VV_M1, VMSBC_VV, 0x0 }, // 7472
  { PseudoVMSBC_VV_M2, VMSBC_VV, 0x1 }, // 7473
  { PseudoVMSBC_VV_M4, VMSBC_VV, 0x2 }, // 7474
  { PseudoVMSBC_VV_M8, VMSBC_VV, 0x3 }, // 7475
  { PseudoVMSBC_VV_MF8, VMSBC_VV, 0x5 }, // 7476
  { PseudoVMSBC_VV_MF4, VMSBC_VV, 0x6 }, // 7477
  { PseudoVMSBC_VV_MF2, VMSBC_VV, 0x7 }, // 7478
  { PseudoVMSBC_VVM_M1, VMSBC_VVM, 0x0 }, // 7479
  { PseudoVMSBC_VVM_M2, VMSBC_VVM, 0x1 }, // 7480
  { PseudoVMSBC_VVM_M4, VMSBC_VVM, 0x2 }, // 7481
  { PseudoVMSBC_VVM_M8, VMSBC_VVM, 0x3 }, // 7482
  { PseudoVMSBC_VVM_MF8, VMSBC_VVM, 0x5 }, // 7483
  { PseudoVMSBC_VVM_MF4, VMSBC_VVM, 0x6 }, // 7484
  { PseudoVMSBC_VVM_MF2, VMSBC_VVM, 0x7 }, // 7485
  { PseudoVMSBC_VX_M1, VMSBC_VX, 0x0 }, // 7486
  { PseudoVMSBC_VX_M2, VMSBC_VX, 0x1 }, // 7487
  { PseudoVMSBC_VX_M4, VMSBC_VX, 0x2 }, // 7488
  { PseudoVMSBC_VX_M8, VMSBC_VX, 0x3 }, // 7489
  { PseudoVMSBC_VX_MF8, VMSBC_VX, 0x5 }, // 7490
  { PseudoVMSBC_VX_MF4, VMSBC_VX, 0x6 }, // 7491
  { PseudoVMSBC_VX_MF2, VMSBC_VX, 0x7 }, // 7492
  { PseudoVMSBC_VXM_M1, VMSBC_VXM, 0x0 }, // 7493
  { PseudoVMSBC_VXM_M2, VMSBC_VXM, 0x1 }, // 7494
  { PseudoVMSBC_VXM_M4, VMSBC_VXM, 0x2 }, // 7495
  { PseudoVMSBC_VXM_M8, VMSBC_VXM, 0x3 }, // 7496
  { PseudoVMSBC_VXM_MF8, VMSBC_VXM, 0x5 }, // 7497
  { PseudoVMSBC_VXM_MF4, VMSBC_VXM, 0x6 }, // 7498
  { PseudoVMSBC_VXM_MF2, VMSBC_VXM, 0x7 }, // 7499
  { PseudoVMSBF_M_B8, VMSBF_M, 0x0 }, // 7500
  { PseudoVMSBF_M_B8_MASK, VMSBF_M, 0x0 }, // 7501
  { PseudoVMSBF_M_B16, VMSBF_M, 0x1 }, // 7502
  { PseudoVMSBF_M_B16_MASK, VMSBF_M, 0x1 }, // 7503
  { PseudoVMSBF_M_B32, VMSBF_M, 0x2 }, // 7504
  { PseudoVMSBF_M_B32_MASK, VMSBF_M, 0x2 }, // 7505
  { PseudoVMSBF_M_B64, VMSBF_M, 0x3 }, // 7506
  { PseudoVMSBF_M_B64_MASK, VMSBF_M, 0x3 }, // 7507
  { PseudoVMSBF_M_B1, VMSBF_M, 0x5 }, // 7508
  { PseudoVMSBF_M_B1_MASK, VMSBF_M, 0x5 }, // 7509
  { PseudoVMSBF_M_B2, VMSBF_M, 0x6 }, // 7510
  { PseudoVMSBF_M_B2_MASK, VMSBF_M, 0x6 }, // 7511
  { PseudoVMSBF_M_B4, VMSBF_M, 0x7 }, // 7512
  { PseudoVMSBF_M_B4_MASK, VMSBF_M, 0x7 }, // 7513
  { PseudoVMSEQ_VI_M1, VMSEQ_VI, 0x0 }, // 7514
  { PseudoVMSEQ_VI_M1_MASK, VMSEQ_VI, 0x0 }, // 7515
  { PseudoVMSEQ_VI_M2, VMSEQ_VI, 0x1 }, // 7516
  { PseudoVMSEQ_VI_M2_MASK, VMSEQ_VI, 0x1 }, // 7517
  { PseudoVMSEQ_VI_M4, VMSEQ_VI, 0x2 }, // 7518
  { PseudoVMSEQ_VI_M4_MASK, VMSEQ_VI, 0x2 }, // 7519
  { PseudoVMSEQ_VI_M8, VMSEQ_VI, 0x3 }, // 7520
  { PseudoVMSEQ_VI_M8_MASK, VMSEQ_VI, 0x3 }, // 7521
  { PseudoVMSEQ_VI_MF8, VMSEQ_VI, 0x5 }, // 7522
  { PseudoVMSEQ_VI_MF8_MASK, VMSEQ_VI, 0x5 }, // 7523
  { PseudoVMSEQ_VI_MF4, VMSEQ_VI, 0x6 }, // 7524
  { PseudoVMSEQ_VI_MF4_MASK, VMSEQ_VI, 0x6 }, // 7525
  { PseudoVMSEQ_VI_MF2, VMSEQ_VI, 0x7 }, // 7526
  { PseudoVMSEQ_VI_MF2_MASK, VMSEQ_VI, 0x7 }, // 7527
  { PseudoVMSEQ_VV_M1, VMSEQ_VV, 0x0 }, // 7528
  { PseudoVMSEQ_VV_M1_MASK, VMSEQ_VV, 0x0 }, // 7529
  { PseudoVMSEQ_VV_M2, VMSEQ_VV, 0x1 }, // 7530
  { PseudoVMSEQ_VV_M2_MASK, VMSEQ_VV, 0x1 }, // 7531
  { PseudoVMSEQ_VV_M4, VMSEQ_VV, 0x2 }, // 7532
  { PseudoVMSEQ_VV_M4_MASK, VMSEQ_VV, 0x2 }, // 7533
  { PseudoVMSEQ_VV_M8, VMSEQ_VV, 0x3 }, // 7534
  { PseudoVMSEQ_VV_M8_MASK, VMSEQ_VV, 0x3 }, // 7535
  { PseudoVMSEQ_VV_MF8, VMSEQ_VV, 0x5 }, // 7536
  { PseudoVMSEQ_VV_MF8_MASK, VMSEQ_VV, 0x5 }, // 7537
  { PseudoVMSEQ_VV_MF4, VMSEQ_VV, 0x6 }, // 7538
  { PseudoVMSEQ_VV_MF4_MASK, VMSEQ_VV, 0x6 }, // 7539
  { PseudoVMSEQ_VV_MF2, VMSEQ_VV, 0x7 }, // 7540
  { PseudoVMSEQ_VV_MF2_MASK, VMSEQ_VV, 0x7 }, // 7541
  { PseudoVMSEQ_VX_M1, VMSEQ_VX, 0x0 }, // 7542
  { PseudoVMSEQ_VX_M1_MASK, VMSEQ_VX, 0x0 }, // 7543
  { PseudoVMSEQ_VX_M2, VMSEQ_VX, 0x1 }, // 7544
  { PseudoVMSEQ_VX_M2_MASK, VMSEQ_VX, 0x1 }, // 7545
  { PseudoVMSEQ_VX_M4, VMSEQ_VX, 0x2 }, // 7546
  { PseudoVMSEQ_VX_M4_MASK, VMSEQ_VX, 0x2 }, // 7547
  { PseudoVMSEQ_VX_M8, VMSEQ_VX, 0x3 }, // 7548
  { PseudoVMSEQ_VX_M8_MASK, VMSEQ_VX, 0x3 }, // 7549
  { PseudoVMSEQ_VX_MF8, VMSEQ_VX, 0x5 }, // 7550
  { PseudoVMSEQ_VX_MF8_MASK, VMSEQ_VX, 0x5 }, // 7551
  { PseudoVMSEQ_VX_MF4, VMSEQ_VX, 0x6 }, // 7552
  { PseudoVMSEQ_VX_MF4_MASK, VMSEQ_VX, 0x6 }, // 7553
  { PseudoVMSEQ_VX_MF2, VMSEQ_VX, 0x7 }, // 7554
  { PseudoVMSEQ_VX_MF2_MASK, VMSEQ_VX, 0x7 }, // 7555
  { PseudoVMSGTU_VI_M1, VMSGTU_VI, 0x0 }, // 7556
  { PseudoVMSGTU_VI_M1_MASK, VMSGTU_VI, 0x0 }, // 7557
  { PseudoVMSGTU_VI_M2, VMSGTU_VI, 0x1 }, // 7558
  { PseudoVMSGTU_VI_M2_MASK, VMSGTU_VI, 0x1 }, // 7559
  { PseudoVMSGTU_VI_M4, VMSGTU_VI, 0x2 }, // 7560
  { PseudoVMSGTU_VI_M4_MASK, VMSGTU_VI, 0x2 }, // 7561
  { PseudoVMSGTU_VI_M8, VMSGTU_VI, 0x3 }, // 7562
  { PseudoVMSGTU_VI_M8_MASK, VMSGTU_VI, 0x3 }, // 7563
  { PseudoVMSGTU_VI_MF8, VMSGTU_VI, 0x5 }, // 7564
  { PseudoVMSGTU_VI_MF8_MASK, VMSGTU_VI, 0x5 }, // 7565
  { PseudoVMSGTU_VI_MF4, VMSGTU_VI, 0x6 }, // 7566
  { PseudoVMSGTU_VI_MF4_MASK, VMSGTU_VI, 0x6 }, // 7567
  { PseudoVMSGTU_VI_MF2, VMSGTU_VI, 0x7 }, // 7568
  { PseudoVMSGTU_VI_MF2_MASK, VMSGTU_VI, 0x7 }, // 7569
  { PseudoVMSGTU_VX_M1, VMSGTU_VX, 0x0 }, // 7570
  { PseudoVMSGTU_VX_M1_MASK, VMSGTU_VX, 0x0 }, // 7571
  { PseudoVMSGTU_VX_M2, VMSGTU_VX, 0x1 }, // 7572
  { PseudoVMSGTU_VX_M2_MASK, VMSGTU_VX, 0x1 }, // 7573
  { PseudoVMSGTU_VX_M4, VMSGTU_VX, 0x2 }, // 7574
  { PseudoVMSGTU_VX_M4_MASK, VMSGTU_VX, 0x2 }, // 7575
  { PseudoVMSGTU_VX_M8, VMSGTU_VX, 0x3 }, // 7576
  { PseudoVMSGTU_VX_M8_MASK, VMSGTU_VX, 0x3 }, // 7577
  { PseudoVMSGTU_VX_MF8, VMSGTU_VX, 0x5 }, // 7578
  { PseudoVMSGTU_VX_MF8_MASK, VMSGTU_VX, 0x5 }, // 7579
  { PseudoVMSGTU_VX_MF4, VMSGTU_VX, 0x6 }, // 7580
  { PseudoVMSGTU_VX_MF4_MASK, VMSGTU_VX, 0x6 }, // 7581
  { PseudoVMSGTU_VX_MF2, VMSGTU_VX, 0x7 }, // 7582
  { PseudoVMSGTU_VX_MF2_MASK, VMSGTU_VX, 0x7 }, // 7583
  { PseudoVMSGT_VI_M1, VMSGT_VI, 0x0 }, // 7584
  { PseudoVMSGT_VI_M1_MASK, VMSGT_VI, 0x0 }, // 7585
  { PseudoVMSGT_VI_M2, VMSGT_VI, 0x1 }, // 7586
  { PseudoVMSGT_VI_M2_MASK, VMSGT_VI, 0x1 }, // 7587
  { PseudoVMSGT_VI_M4, VMSGT_VI, 0x2 }, // 7588
  { PseudoVMSGT_VI_M4_MASK, VMSGT_VI, 0x2 }, // 7589
  { PseudoVMSGT_VI_M8, VMSGT_VI, 0x3 }, // 7590
  { PseudoVMSGT_VI_M8_MASK, VMSGT_VI, 0x3 }, // 7591
  { PseudoVMSGT_VI_MF8, VMSGT_VI, 0x5 }, // 7592
  { PseudoVMSGT_VI_MF8_MASK, VMSGT_VI, 0x5 }, // 7593
  { PseudoVMSGT_VI_MF4, VMSGT_VI, 0x6 }, // 7594
  { PseudoVMSGT_VI_MF4_MASK, VMSGT_VI, 0x6 }, // 7595
  { PseudoVMSGT_VI_MF2, VMSGT_VI, 0x7 }, // 7596
  { PseudoVMSGT_VI_MF2_MASK, VMSGT_VI, 0x7 }, // 7597
  { PseudoVMSGT_VX_M1, VMSGT_VX, 0x0 }, // 7598
  { PseudoVMSGT_VX_M1_MASK, VMSGT_VX, 0x0 }, // 7599
  { PseudoVMSGT_VX_M2, VMSGT_VX, 0x1 }, // 7600
  { PseudoVMSGT_VX_M2_MASK, VMSGT_VX, 0x1 }, // 7601
  { PseudoVMSGT_VX_M4, VMSGT_VX, 0x2 }, // 7602
  { PseudoVMSGT_VX_M4_MASK, VMSGT_VX, 0x2 }, // 7603
  { PseudoVMSGT_VX_M8, VMSGT_VX, 0x3 }, // 7604
  { PseudoVMSGT_VX_M8_MASK, VMSGT_VX, 0x3 }, // 7605
  { PseudoVMSGT_VX_MF8, VMSGT_VX, 0x5 }, // 7606
  { PseudoVMSGT_VX_MF8_MASK, VMSGT_VX, 0x5 }, // 7607
  { PseudoVMSGT_VX_MF4, VMSGT_VX, 0x6 }, // 7608
  { PseudoVMSGT_VX_MF4_MASK, VMSGT_VX, 0x6 }, // 7609
  { PseudoVMSGT_VX_MF2, VMSGT_VX, 0x7 }, // 7610
  { PseudoVMSGT_VX_MF2_MASK, VMSGT_VX, 0x7 }, // 7611
  { PseudoVMSIF_M_B8, VMSIF_M, 0x0 }, // 7612
  { PseudoVMSIF_M_B8_MASK, VMSIF_M, 0x0 }, // 7613
  { PseudoVMSIF_M_B16, VMSIF_M, 0x1 }, // 7614
  { PseudoVMSIF_M_B16_MASK, VMSIF_M, 0x1 }, // 7615
  { PseudoVMSIF_M_B32, VMSIF_M, 0x2 }, // 7616
  { PseudoVMSIF_M_B32_MASK, VMSIF_M, 0x2 }, // 7617
  { PseudoVMSIF_M_B64, VMSIF_M, 0x3 }, // 7618
  { PseudoVMSIF_M_B64_MASK, VMSIF_M, 0x3 }, // 7619
  { PseudoVMSIF_M_B1, VMSIF_M, 0x5 }, // 7620
  { PseudoVMSIF_M_B1_MASK, VMSIF_M, 0x5 }, // 7621
  { PseudoVMSIF_M_B2, VMSIF_M, 0x6 }, // 7622
  { PseudoVMSIF_M_B2_MASK, VMSIF_M, 0x6 }, // 7623
  { PseudoVMSIF_M_B4, VMSIF_M, 0x7 }, // 7624
  { PseudoVMSIF_M_B4_MASK, VMSIF_M, 0x7 }, // 7625
  { PseudoVMSLEU_VI_M1, VMSLEU_VI, 0x0 }, // 7626
  { PseudoVMSLEU_VI_M1_MASK, VMSLEU_VI, 0x0 }, // 7627
  { PseudoVMSLEU_VI_M2, VMSLEU_VI, 0x1 }, // 7628
  { PseudoVMSLEU_VI_M2_MASK, VMSLEU_VI, 0x1 }, // 7629
  { PseudoVMSLEU_VI_M4, VMSLEU_VI, 0x2 }, // 7630
  { PseudoVMSLEU_VI_M4_MASK, VMSLEU_VI, 0x2 }, // 7631
  { PseudoVMSLEU_VI_M8, VMSLEU_VI, 0x3 }, // 7632
  { PseudoVMSLEU_VI_M8_MASK, VMSLEU_VI, 0x3 }, // 7633
  { PseudoVMSLEU_VI_MF8, VMSLEU_VI, 0x5 }, // 7634
  { PseudoVMSLEU_VI_MF8_MASK, VMSLEU_VI, 0x5 }, // 7635
  { PseudoVMSLEU_VI_MF4, VMSLEU_VI, 0x6 }, // 7636
  { PseudoVMSLEU_VI_MF4_MASK, VMSLEU_VI, 0x6 }, // 7637
  { PseudoVMSLEU_VI_MF2, VMSLEU_VI, 0x7 }, // 7638
  { PseudoVMSLEU_VI_MF2_MASK, VMSLEU_VI, 0x7 }, // 7639
  { PseudoVMSLEU_VV_M1, VMSLEU_VV, 0x0 }, // 7640
  { PseudoVMSLEU_VV_M1_MASK, VMSLEU_VV, 0x0 }, // 7641
  { PseudoVMSLEU_VV_M2, VMSLEU_VV, 0x1 }, // 7642
  { PseudoVMSLEU_VV_M2_MASK, VMSLEU_VV, 0x1 }, // 7643
  { PseudoVMSLEU_VV_M4, VMSLEU_VV, 0x2 }, // 7644
  { PseudoVMSLEU_VV_M4_MASK, VMSLEU_VV, 0x2 }, // 7645
  { PseudoVMSLEU_VV_M8, VMSLEU_VV, 0x3 }, // 7646
  { PseudoVMSLEU_VV_M8_MASK, VMSLEU_VV, 0x3 }, // 7647
  { PseudoVMSLEU_VV_MF8, VMSLEU_VV, 0x5 }, // 7648
  { PseudoVMSLEU_VV_MF8_MASK, VMSLEU_VV, 0x5 }, // 7649
  { PseudoVMSLEU_VV_MF4, VMSLEU_VV, 0x6 }, // 7650
  { PseudoVMSLEU_VV_MF4_MASK, VMSLEU_VV, 0x6 }, // 7651
  { PseudoVMSLEU_VV_MF2, VMSLEU_VV, 0x7 }, // 7652
  { PseudoVMSLEU_VV_MF2_MASK, VMSLEU_VV, 0x7 }, // 7653
  { PseudoVMSLEU_VX_M1, VMSLEU_VX, 0x0 }, // 7654
  { PseudoVMSLEU_VX_M1_MASK, VMSLEU_VX, 0x0 }, // 7655
  { PseudoVMSLEU_VX_M2, VMSLEU_VX, 0x1 }, // 7656
  { PseudoVMSLEU_VX_M2_MASK, VMSLEU_VX, 0x1 }, // 7657
  { PseudoVMSLEU_VX_M4, VMSLEU_VX, 0x2 }, // 7658
  { PseudoVMSLEU_VX_M4_MASK, VMSLEU_VX, 0x2 }, // 7659
  { PseudoVMSLEU_VX_M8, VMSLEU_VX, 0x3 }, // 7660
  { PseudoVMSLEU_VX_M8_MASK, VMSLEU_VX, 0x3 }, // 7661
  { PseudoVMSLEU_VX_MF8, VMSLEU_VX, 0x5 }, // 7662
  { PseudoVMSLEU_VX_MF8_MASK, VMSLEU_VX, 0x5 }, // 7663
  { PseudoVMSLEU_VX_MF4, VMSLEU_VX, 0x6 }, // 7664
  { PseudoVMSLEU_VX_MF4_MASK, VMSLEU_VX, 0x6 }, // 7665
  { PseudoVMSLEU_VX_MF2, VMSLEU_VX, 0x7 }, // 7666
  { PseudoVMSLEU_VX_MF2_MASK, VMSLEU_VX, 0x7 }, // 7667
  { PseudoVMSLE_VI_M1, VMSLE_VI, 0x0 }, // 7668
  { PseudoVMSLE_VI_M1_MASK, VMSLE_VI, 0x0 }, // 7669
  { PseudoVMSLE_VI_M2, VMSLE_VI, 0x1 }, // 7670
  { PseudoVMSLE_VI_M2_MASK, VMSLE_VI, 0x1 }, // 7671
  { PseudoVMSLE_VI_M4, VMSLE_VI, 0x2 }, // 7672
  { PseudoVMSLE_VI_M4_MASK, VMSLE_VI, 0x2 }, // 7673
  { PseudoVMSLE_VI_M8, VMSLE_VI, 0x3 }, // 7674
  { PseudoVMSLE_VI_M8_MASK, VMSLE_VI, 0x3 }, // 7675
  { PseudoVMSLE_VI_MF8, VMSLE_VI, 0x5 }, // 7676
  { PseudoVMSLE_VI_MF8_MASK, VMSLE_VI, 0x5 }, // 7677
  { PseudoVMSLE_VI_MF4, VMSLE_VI, 0x6 }, // 7678
  { PseudoVMSLE_VI_MF4_MASK, VMSLE_VI, 0x6 }, // 7679
  { PseudoVMSLE_VI_MF2, VMSLE_VI, 0x7 }, // 7680
  { PseudoVMSLE_VI_MF2_MASK, VMSLE_VI, 0x7 }, // 7681
  { PseudoVMSLE_VV_M1, VMSLE_VV, 0x0 }, // 7682
  { PseudoVMSLE_VV_M1_MASK, VMSLE_VV, 0x0 }, // 7683
  { PseudoVMSLE_VV_M2, VMSLE_VV, 0x1 }, // 7684
  { PseudoVMSLE_VV_M2_MASK, VMSLE_VV, 0x1 }, // 7685
  { PseudoVMSLE_VV_M4, VMSLE_VV, 0x2 }, // 7686
  { PseudoVMSLE_VV_M4_MASK, VMSLE_VV, 0x2 }, // 7687
  { PseudoVMSLE_VV_M8, VMSLE_VV, 0x3 }, // 7688
  { PseudoVMSLE_VV_M8_MASK, VMSLE_VV, 0x3 }, // 7689
  { PseudoVMSLE_VV_MF8, VMSLE_VV, 0x5 }, // 7690
  { PseudoVMSLE_VV_MF8_MASK, VMSLE_VV, 0x5 }, // 7691
  { PseudoVMSLE_VV_MF4, VMSLE_VV, 0x6 }, // 7692
  { PseudoVMSLE_VV_MF4_MASK, VMSLE_VV, 0x6 }, // 7693
  { PseudoVMSLE_VV_MF2, VMSLE_VV, 0x7 }, // 7694
  { PseudoVMSLE_VV_MF2_MASK, VMSLE_VV, 0x7 }, // 7695
  { PseudoVMSLE_VX_M1, VMSLE_VX, 0x0 }, // 7696
  { PseudoVMSLE_VX_M1_MASK, VMSLE_VX, 0x0 }, // 7697
  { PseudoVMSLE_VX_M2, VMSLE_VX, 0x1 }, // 7698
  { PseudoVMSLE_VX_M2_MASK, VMSLE_VX, 0x1 }, // 7699
  { PseudoVMSLE_VX_M4, VMSLE_VX, 0x2 }, // 7700
  { PseudoVMSLE_VX_M4_MASK, VMSLE_VX, 0x2 }, // 7701
  { PseudoVMSLE_VX_M8, VMSLE_VX, 0x3 }, // 7702
  { PseudoVMSLE_VX_M8_MASK, VMSLE_VX, 0x3 }, // 7703
  { PseudoVMSLE_VX_MF8, VMSLE_VX, 0x5 }, // 7704
  { PseudoVMSLE_VX_MF8_MASK, VMSLE_VX, 0x5 }, // 7705
  { PseudoVMSLE_VX_MF4, VMSLE_VX, 0x6 }, // 7706
  { PseudoVMSLE_VX_MF4_MASK, VMSLE_VX, 0x6 }, // 7707
  { PseudoVMSLE_VX_MF2, VMSLE_VX, 0x7 }, // 7708
  { PseudoVMSLE_VX_MF2_MASK, VMSLE_VX, 0x7 }, // 7709
  { PseudoVMSLTU_VV_M1, VMSLTU_VV, 0x0 }, // 7710
  { PseudoVMSLTU_VV_M1_MASK, VMSLTU_VV, 0x0 }, // 7711
  { PseudoVMSLTU_VV_M2, VMSLTU_VV, 0x1 }, // 7712
  { PseudoVMSLTU_VV_M2_MASK, VMSLTU_VV, 0x1 }, // 7713
  { PseudoVMSLTU_VV_M4, VMSLTU_VV, 0x2 }, // 7714
  { PseudoVMSLTU_VV_M4_MASK, VMSLTU_VV, 0x2 }, // 7715
  { PseudoVMSLTU_VV_M8, VMSLTU_VV, 0x3 }, // 7716
  { PseudoVMSLTU_VV_M8_MASK, VMSLTU_VV, 0x3 }, // 7717
  { PseudoVMSLTU_VV_MF8, VMSLTU_VV, 0x5 }, // 7718
  { PseudoVMSLTU_VV_MF8_MASK, VMSLTU_VV, 0x5 }, // 7719
  { PseudoVMSLTU_VV_MF4, VMSLTU_VV, 0x6 }, // 7720
  { PseudoVMSLTU_VV_MF4_MASK, VMSLTU_VV, 0x6 }, // 7721
  { PseudoVMSLTU_VV_MF2, VMSLTU_VV, 0x7 }, // 7722
  { PseudoVMSLTU_VV_MF2_MASK, VMSLTU_VV, 0x7 }, // 7723
  { PseudoVMSLTU_VX_M1, VMSLTU_VX, 0x0 }, // 7724
  { PseudoVMSLTU_VX_M1_MASK, VMSLTU_VX, 0x0 }, // 7725
  { PseudoVMSLTU_VX_M2, VMSLTU_VX, 0x1 }, // 7726
  { PseudoVMSLTU_VX_M2_MASK, VMSLTU_VX, 0x1 }, // 7727
  { PseudoVMSLTU_VX_M4, VMSLTU_VX, 0x2 }, // 7728
  { PseudoVMSLTU_VX_M4_MASK, VMSLTU_VX, 0x2 }, // 7729
  { PseudoVMSLTU_VX_M8, VMSLTU_VX, 0x3 }, // 7730
  { PseudoVMSLTU_VX_M8_MASK, VMSLTU_VX, 0x3 }, // 7731
  { PseudoVMSLTU_VX_MF8, VMSLTU_VX, 0x5 }, // 7732
  { PseudoVMSLTU_VX_MF8_MASK, VMSLTU_VX, 0x5 }, // 7733
  { PseudoVMSLTU_VX_MF4, VMSLTU_VX, 0x6 }, // 7734
  { PseudoVMSLTU_VX_MF4_MASK, VMSLTU_VX, 0x6 }, // 7735
  { PseudoVMSLTU_VX_MF2, VMSLTU_VX, 0x7 }, // 7736
  { PseudoVMSLTU_VX_MF2_MASK, VMSLTU_VX, 0x7 }, // 7737
  { PseudoVMSLT_VV_M1, VMSLT_VV, 0x0 }, // 7738
  { PseudoVMSLT_VV_M1_MASK, VMSLT_VV, 0x0 }, // 7739
  { PseudoVMSLT_VV_M2, VMSLT_VV, 0x1 }, // 7740
  { PseudoVMSLT_VV_M2_MASK, VMSLT_VV, 0x1 }, // 7741
  { PseudoVMSLT_VV_M4, VMSLT_VV, 0x2 }, // 7742
  { PseudoVMSLT_VV_M4_MASK, VMSLT_VV, 0x2 }, // 7743
  { PseudoVMSLT_VV_M8, VMSLT_VV, 0x3 }, // 7744
  { PseudoVMSLT_VV_M8_MASK, VMSLT_VV, 0x3 }, // 7745
  { PseudoVMSLT_VV_MF8, VMSLT_VV, 0x5 }, // 7746
  { PseudoVMSLT_VV_MF8_MASK, VMSLT_VV, 0x5 }, // 7747
  { PseudoVMSLT_VV_MF4, VMSLT_VV, 0x6 }, // 7748
  { PseudoVMSLT_VV_MF4_MASK, VMSLT_VV, 0x6 }, // 7749
  { PseudoVMSLT_VV_MF2, VMSLT_VV, 0x7 }, // 7750
  { PseudoVMSLT_VV_MF2_MASK, VMSLT_VV, 0x7 }, // 7751
  { PseudoVMSLT_VX_M1, VMSLT_VX, 0x0 }, // 7752
  { PseudoVMSLT_VX_M1_MASK, VMSLT_VX, 0x0 }, // 7753
  { PseudoVMSLT_VX_M2, VMSLT_VX, 0x1 }, // 7754
  { PseudoVMSLT_VX_M2_MASK, VMSLT_VX, 0x1 }, // 7755
  { PseudoVMSLT_VX_M4, VMSLT_VX, 0x2 }, // 7756
  { PseudoVMSLT_VX_M4_MASK, VMSLT_VX, 0x2 }, // 7757
  { PseudoVMSLT_VX_M8, VMSLT_VX, 0x3 }, // 7758
  { PseudoVMSLT_VX_M8_MASK, VMSLT_VX, 0x3 }, // 7759
  { PseudoVMSLT_VX_MF8, VMSLT_VX, 0x5 }, // 7760
  { PseudoVMSLT_VX_MF8_MASK, VMSLT_VX, 0x5 }, // 7761
  { PseudoVMSLT_VX_MF4, VMSLT_VX, 0x6 }, // 7762
  { PseudoVMSLT_VX_MF4_MASK, VMSLT_VX, 0x6 }, // 7763
  { PseudoVMSLT_VX_MF2, VMSLT_VX, 0x7 }, // 7764
  { PseudoVMSLT_VX_MF2_MASK, VMSLT_VX, 0x7 }, // 7765
  { PseudoVMSNE_VI_M1, VMSNE_VI, 0x0 }, // 7766
  { PseudoVMSNE_VI_M1_MASK, VMSNE_VI, 0x0 }, // 7767
  { PseudoVMSNE_VI_M2, VMSNE_VI, 0x1 }, // 7768
  { PseudoVMSNE_VI_M2_MASK, VMSNE_VI, 0x1 }, // 7769
  { PseudoVMSNE_VI_M4, VMSNE_VI, 0x2 }, // 7770
  { PseudoVMSNE_VI_M4_MASK, VMSNE_VI, 0x2 }, // 7771
  { PseudoVMSNE_VI_M8, VMSNE_VI, 0x3 }, // 7772
  { PseudoVMSNE_VI_M8_MASK, VMSNE_VI, 0x3 }, // 7773
  { PseudoVMSNE_VI_MF8, VMSNE_VI, 0x5 }, // 7774
  { PseudoVMSNE_VI_MF8_MASK, VMSNE_VI, 0x5 }, // 7775
  { PseudoVMSNE_VI_MF4, VMSNE_VI, 0x6 }, // 7776
  { PseudoVMSNE_VI_MF4_MASK, VMSNE_VI, 0x6 }, // 7777
  { PseudoVMSNE_VI_MF2, VMSNE_VI, 0x7 }, // 7778
  { PseudoVMSNE_VI_MF2_MASK, VMSNE_VI, 0x7 }, // 7779
  { PseudoVMSNE_VV_M1, VMSNE_VV, 0x0 }, // 7780
  { PseudoVMSNE_VV_M1_MASK, VMSNE_VV, 0x0 }, // 7781
  { PseudoVMSNE_VV_M2, VMSNE_VV, 0x1 }, // 7782
  { PseudoVMSNE_VV_M2_MASK, VMSNE_VV, 0x1 }, // 7783
  { PseudoVMSNE_VV_M4, VMSNE_VV, 0x2 }, // 7784
  { PseudoVMSNE_VV_M4_MASK, VMSNE_VV, 0x2 }, // 7785
  { PseudoVMSNE_VV_M8, VMSNE_VV, 0x3 }, // 7786
  { PseudoVMSNE_VV_M8_MASK, VMSNE_VV, 0x3 }, // 7787
  { PseudoVMSNE_VV_MF8, VMSNE_VV, 0x5 }, // 7788
  { PseudoVMSNE_VV_MF8_MASK, VMSNE_VV, 0x5 }, // 7789
  { PseudoVMSNE_VV_MF4, VMSNE_VV, 0x6 }, // 7790
  { PseudoVMSNE_VV_MF4_MASK, VMSNE_VV, 0x6 }, // 7791
  { PseudoVMSNE_VV_MF2, VMSNE_VV, 0x7 }, // 7792
  { PseudoVMSNE_VV_MF2_MASK, VMSNE_VV, 0x7 }, // 7793
  { PseudoVMSNE_VX_M1, VMSNE_VX, 0x0 }, // 7794
  { PseudoVMSNE_VX_M1_MASK, VMSNE_VX, 0x0 }, // 7795
  { PseudoVMSNE_VX_M2, VMSNE_VX, 0x1 }, // 7796
  { PseudoVMSNE_VX_M2_MASK, VMSNE_VX, 0x1 }, // 7797
  { PseudoVMSNE_VX_M4, VMSNE_VX, 0x2 }, // 7798
  { PseudoVMSNE_VX_M4_MASK, VMSNE_VX, 0x2 }, // 7799
  { PseudoVMSNE_VX_M8, VMSNE_VX, 0x3 }, // 7800
  { PseudoVMSNE_VX_M8_MASK, VMSNE_VX, 0x3 }, // 7801
  { PseudoVMSNE_VX_MF8, VMSNE_VX, 0x5 }, // 7802
  { PseudoVMSNE_VX_MF8_MASK, VMSNE_VX, 0x5 }, // 7803
  { PseudoVMSNE_VX_MF4, VMSNE_VX, 0x6 }, // 7804
  { PseudoVMSNE_VX_MF4_MASK, VMSNE_VX, 0x6 }, // 7805
  { PseudoVMSNE_VX_MF2, VMSNE_VX, 0x7 }, // 7806
  { PseudoVMSNE_VX_MF2_MASK, VMSNE_VX, 0x7 }, // 7807
  { PseudoVMSOF_M_B8, VMSOF_M, 0x0 }, // 7808
  { PseudoVMSOF_M_B8_MASK, VMSOF_M, 0x0 }, // 7809
  { PseudoVMSOF_M_B16, VMSOF_M, 0x1 }, // 7810
  { PseudoVMSOF_M_B16_MASK, VMSOF_M, 0x1 }, // 7811
  { PseudoVMSOF_M_B32, VMSOF_M, 0x2 }, // 7812
  { PseudoVMSOF_M_B32_MASK, VMSOF_M, 0x2 }, // 7813
  { PseudoVMSOF_M_B64, VMSOF_M, 0x3 }, // 7814
  { PseudoVMSOF_M_B64_MASK, VMSOF_M, 0x3 }, // 7815
  { PseudoVMSOF_M_B1, VMSOF_M, 0x5 }, // 7816
  { PseudoVMSOF_M_B1_MASK, VMSOF_M, 0x5 }, // 7817
  { PseudoVMSOF_M_B2, VMSOF_M, 0x6 }, // 7818
  { PseudoVMSOF_M_B2_MASK, VMSOF_M, 0x6 }, // 7819
  { PseudoVMSOF_M_B4, VMSOF_M, 0x7 }, // 7820
  { PseudoVMSOF_M_B4_MASK, VMSOF_M, 0x7 }, // 7821
  { PseudoVMULHSU_VV_M1, VMULHSU_VV, 0x0 }, // 7822
  { PseudoVMULHSU_VV_M1_MASK, VMULHSU_VV, 0x0 }, // 7823
  { PseudoVMULHSU_VV_M1_TU, VMULHSU_VV, 0x0 }, // 7824
  { PseudoVMULHSU_VV_M2, VMULHSU_VV, 0x1 }, // 7825
  { PseudoVMULHSU_VV_M2_MASK, VMULHSU_VV, 0x1 }, // 7826
  { PseudoVMULHSU_VV_M2_TU, VMULHSU_VV, 0x1 }, // 7827
  { PseudoVMULHSU_VV_M4, VMULHSU_VV, 0x2 }, // 7828
  { PseudoVMULHSU_VV_M4_MASK, VMULHSU_VV, 0x2 }, // 7829
  { PseudoVMULHSU_VV_M4_TU, VMULHSU_VV, 0x2 }, // 7830
  { PseudoVMULHSU_VV_M8, VMULHSU_VV, 0x3 }, // 7831
  { PseudoVMULHSU_VV_M8_MASK, VMULHSU_VV, 0x3 }, // 7832
  { PseudoVMULHSU_VV_M8_TU, VMULHSU_VV, 0x3 }, // 7833
  { PseudoVMULHSU_VV_MF8, VMULHSU_VV, 0x5 }, // 7834
  { PseudoVMULHSU_VV_MF8_MASK, VMULHSU_VV, 0x5 }, // 7835
  { PseudoVMULHSU_VV_MF8_TU, VMULHSU_VV, 0x5 }, // 7836
  { PseudoVMULHSU_VV_MF4, VMULHSU_VV, 0x6 }, // 7837
  { PseudoVMULHSU_VV_MF4_MASK, VMULHSU_VV, 0x6 }, // 7838
  { PseudoVMULHSU_VV_MF4_TU, VMULHSU_VV, 0x6 }, // 7839
  { PseudoVMULHSU_VV_MF2, VMULHSU_VV, 0x7 }, // 7840
  { PseudoVMULHSU_VV_MF2_MASK, VMULHSU_VV, 0x7 }, // 7841
  { PseudoVMULHSU_VV_MF2_TU, VMULHSU_VV, 0x7 }, // 7842
  { PseudoVMULHSU_VX_M1, VMULHSU_VX, 0x0 }, // 7843
  { PseudoVMULHSU_VX_M1_MASK, VMULHSU_VX, 0x0 }, // 7844
  { PseudoVMULHSU_VX_M1_TU, VMULHSU_VX, 0x0 }, // 7845
  { PseudoVMULHSU_VX_M2, VMULHSU_VX, 0x1 }, // 7846
  { PseudoVMULHSU_VX_M2_MASK, VMULHSU_VX, 0x1 }, // 7847
  { PseudoVMULHSU_VX_M2_TU, VMULHSU_VX, 0x1 }, // 7848
  { PseudoVMULHSU_VX_M4, VMULHSU_VX, 0x2 }, // 7849
  { PseudoVMULHSU_VX_M4_MASK, VMULHSU_VX, 0x2 }, // 7850
  { PseudoVMULHSU_VX_M4_TU, VMULHSU_VX, 0x2 }, // 7851
  { PseudoVMULHSU_VX_M8, VMULHSU_VX, 0x3 }, // 7852
  { PseudoVMULHSU_VX_M8_MASK, VMULHSU_VX, 0x3 }, // 7853
  { PseudoVMULHSU_VX_M8_TU, VMULHSU_VX, 0x3 }, // 7854
  { PseudoVMULHSU_VX_MF8, VMULHSU_VX, 0x5 }, // 7855
  { PseudoVMULHSU_VX_MF8_MASK, VMULHSU_VX, 0x5 }, // 7856
  { PseudoVMULHSU_VX_MF8_TU, VMULHSU_VX, 0x5 }, // 7857
  { PseudoVMULHSU_VX_MF4, VMULHSU_VX, 0x6 }, // 7858
  { PseudoVMULHSU_VX_MF4_MASK, VMULHSU_VX, 0x6 }, // 7859
  { PseudoVMULHSU_VX_MF4_TU, VMULHSU_VX, 0x6 }, // 7860
  { PseudoVMULHSU_VX_MF2, VMULHSU_VX, 0x7 }, // 7861
  { PseudoVMULHSU_VX_MF2_MASK, VMULHSU_VX, 0x7 }, // 7862
  { PseudoVMULHSU_VX_MF2_TU, VMULHSU_VX, 0x7 }, // 7863
  { PseudoVMULHU_VV_M1, VMULHU_VV, 0x0 }, // 7864
  { PseudoVMULHU_VV_M1_MASK, VMULHU_VV, 0x0 }, // 7865
  { PseudoVMULHU_VV_M1_TU, VMULHU_VV, 0x0 }, // 7866
  { PseudoVMULHU_VV_M2, VMULHU_VV, 0x1 }, // 7867
  { PseudoVMULHU_VV_M2_MASK, VMULHU_VV, 0x1 }, // 7868
  { PseudoVMULHU_VV_M2_TU, VMULHU_VV, 0x1 }, // 7869
  { PseudoVMULHU_VV_M4, VMULHU_VV, 0x2 }, // 7870
  { PseudoVMULHU_VV_M4_MASK, VMULHU_VV, 0x2 }, // 7871
  { PseudoVMULHU_VV_M4_TU, VMULHU_VV, 0x2 }, // 7872
  { PseudoVMULHU_VV_M8, VMULHU_VV, 0x3 }, // 7873
  { PseudoVMULHU_VV_M8_MASK, VMULHU_VV, 0x3 }, // 7874
  { PseudoVMULHU_VV_M8_TU, VMULHU_VV, 0x3 }, // 7875
  { PseudoVMULHU_VV_MF8, VMULHU_VV, 0x5 }, // 7876
  { PseudoVMULHU_VV_MF8_MASK, VMULHU_VV, 0x5 }, // 7877
  { PseudoVMULHU_VV_MF8_TU, VMULHU_VV, 0x5 }, // 7878
  { PseudoVMULHU_VV_MF4, VMULHU_VV, 0x6 }, // 7879
  { PseudoVMULHU_VV_MF4_MASK, VMULHU_VV, 0x6 }, // 7880
  { PseudoVMULHU_VV_MF4_TU, VMULHU_VV, 0x6 }, // 7881
  { PseudoVMULHU_VV_MF2, VMULHU_VV, 0x7 }, // 7882
  { PseudoVMULHU_VV_MF2_MASK, VMULHU_VV, 0x7 }, // 7883
  { PseudoVMULHU_VV_MF2_TU, VMULHU_VV, 0x7 }, // 7884
  { PseudoVMULHU_VX_M1, VMULHU_VX, 0x0 }, // 7885
  { PseudoVMULHU_VX_M1_MASK, VMULHU_VX, 0x0 }, // 7886
  { PseudoVMULHU_VX_M1_TU, VMULHU_VX, 0x0 }, // 7887
  { PseudoVMULHU_VX_M2, VMULHU_VX, 0x1 }, // 7888
  { PseudoVMULHU_VX_M2_MASK, VMULHU_VX, 0x1 }, // 7889
  { PseudoVMULHU_VX_M2_TU, VMULHU_VX, 0x1 }, // 7890
  { PseudoVMULHU_VX_M4, VMULHU_VX, 0x2 }, // 7891
  { PseudoVMULHU_VX_M4_MASK, VMULHU_VX, 0x2 }, // 7892
  { PseudoVMULHU_VX_M4_TU, VMULHU_VX, 0x2 }, // 7893
  { PseudoVMULHU_VX_M8, VMULHU_VX, 0x3 }, // 7894
  { PseudoVMULHU_VX_M8_MASK, VMULHU_VX, 0x3 }, // 7895
  { PseudoVMULHU_VX_M8_TU, VMULHU_VX, 0x3 }, // 7896
  { PseudoVMULHU_VX_MF8, VMULHU_VX, 0x5 }, // 7897
  { PseudoVMULHU_VX_MF8_MASK, VMULHU_VX, 0x5 }, // 7898
  { PseudoVMULHU_VX_MF8_TU, VMULHU_VX, 0x5 }, // 7899
  { PseudoVMULHU_VX_MF4, VMULHU_VX, 0x6 }, // 7900
  { PseudoVMULHU_VX_MF4_MASK, VMULHU_VX, 0x6 }, // 7901
  { PseudoVMULHU_VX_MF4_TU, VMULHU_VX, 0x6 }, // 7902
  { PseudoVMULHU_VX_MF2, VMULHU_VX, 0x7 }, // 7903
  { PseudoVMULHU_VX_MF2_MASK, VMULHU_VX, 0x7 }, // 7904
  { PseudoVMULHU_VX_MF2_TU, VMULHU_VX, 0x7 }, // 7905
  { PseudoVMULH_VV_M1, VMULH_VV, 0x0 }, // 7906
  { PseudoVMULH_VV_M1_MASK, VMULH_VV, 0x0 }, // 7907
  { PseudoVMULH_VV_M1_TU, VMULH_VV, 0x0 }, // 7908
  { PseudoVMULH_VV_M2, VMULH_VV, 0x1 }, // 7909
  { PseudoVMULH_VV_M2_MASK, VMULH_VV, 0x1 }, // 7910
  { PseudoVMULH_VV_M2_TU, VMULH_VV, 0x1 }, // 7911
  { PseudoVMULH_VV_M4, VMULH_VV, 0x2 }, // 7912
  { PseudoVMULH_VV_M4_MASK, VMULH_VV, 0x2 }, // 7913
  { PseudoVMULH_VV_M4_TU, VMULH_VV, 0x2 }, // 7914
  { PseudoVMULH_VV_M8, VMULH_VV, 0x3 }, // 7915
  { PseudoVMULH_VV_M8_MASK, VMULH_VV, 0x3 }, // 7916
  { PseudoVMULH_VV_M8_TU, VMULH_VV, 0x3 }, // 7917
  { PseudoVMULH_VV_MF8, VMULH_VV, 0x5 }, // 7918
  { PseudoVMULH_VV_MF8_MASK, VMULH_VV, 0x5 }, // 7919
  { PseudoVMULH_VV_MF8_TU, VMULH_VV, 0x5 }, // 7920
  { PseudoVMULH_VV_MF4, VMULH_VV, 0x6 }, // 7921
  { PseudoVMULH_VV_MF4_MASK, VMULH_VV, 0x6 }, // 7922
  { PseudoVMULH_VV_MF4_TU, VMULH_VV, 0x6 }, // 7923
  { PseudoVMULH_VV_MF2, VMULH_VV, 0x7 }, // 7924
  { PseudoVMULH_VV_MF2_MASK, VMULH_VV, 0x7 }, // 7925
  { PseudoVMULH_VV_MF2_TU, VMULH_VV, 0x7 }, // 7926
  { PseudoVMULH_VX_M1, VMULH_VX, 0x0 }, // 7927
  { PseudoVMULH_VX_M1_MASK, VMULH_VX, 0x0 }, // 7928
  { PseudoVMULH_VX_M1_TU, VMULH_VX, 0x0 }, // 7929
  { PseudoVMULH_VX_M2, VMULH_VX, 0x1 }, // 7930
  { PseudoVMULH_VX_M2_MASK, VMULH_VX, 0x1 }, // 7931
  { PseudoVMULH_VX_M2_TU, VMULH_VX, 0x1 }, // 7932
  { PseudoVMULH_VX_M4, VMULH_VX, 0x2 }, // 7933
  { PseudoVMULH_VX_M4_MASK, VMULH_VX, 0x2 }, // 7934
  { PseudoVMULH_VX_M4_TU, VMULH_VX, 0x2 }, // 7935
  { PseudoVMULH_VX_M8, VMULH_VX, 0x3 }, // 7936
  { PseudoVMULH_VX_M8_MASK, VMULH_VX, 0x3 }, // 7937
  { PseudoVMULH_VX_M8_TU, VMULH_VX, 0x3 }, // 7938
  { PseudoVMULH_VX_MF8, VMULH_VX, 0x5 }, // 7939
  { PseudoVMULH_VX_MF8_MASK, VMULH_VX, 0x5 }, // 7940
  { PseudoVMULH_VX_MF8_TU, VMULH_VX, 0x5 }, // 7941
  { PseudoVMULH_VX_MF4, VMULH_VX, 0x6 }, // 7942
  { PseudoVMULH_VX_MF4_MASK, VMULH_VX, 0x6 }, // 7943
  { PseudoVMULH_VX_MF4_TU, VMULH_VX, 0x6 }, // 7944
  { PseudoVMULH_VX_MF2, VMULH_VX, 0x7 }, // 7945
  { PseudoVMULH_VX_MF2_MASK, VMULH_VX, 0x7 }, // 7946
  { PseudoVMULH_VX_MF2_TU, VMULH_VX, 0x7 }, // 7947
  { PseudoVMUL_VV_M1, VMUL_VV, 0x0 }, // 7948
  { PseudoVMUL_VV_M1_MASK, VMUL_VV, 0x0 }, // 7949
  { PseudoVMUL_VV_M1_TU, VMUL_VV, 0x0 }, // 7950
  { PseudoVMUL_VV_M2, VMUL_VV, 0x1 }, // 7951
  { PseudoVMUL_VV_M2_MASK, VMUL_VV, 0x1 }, // 7952
  { PseudoVMUL_VV_M2_TU, VMUL_VV, 0x1 }, // 7953
  { PseudoVMUL_VV_M4, VMUL_VV, 0x2 }, // 7954
  { PseudoVMUL_VV_M4_MASK, VMUL_VV, 0x2 }, // 7955
  { PseudoVMUL_VV_M4_TU, VMUL_VV, 0x2 }, // 7956
  { PseudoVMUL_VV_M8, VMUL_VV, 0x3 }, // 7957
  { PseudoVMUL_VV_M8_MASK, VMUL_VV, 0x3 }, // 7958
  { PseudoVMUL_VV_M8_TU, VMUL_VV, 0x3 }, // 7959
  { PseudoVMUL_VV_MF8, VMUL_VV, 0x5 }, // 7960
  { PseudoVMUL_VV_MF8_MASK, VMUL_VV, 0x5 }, // 7961
  { PseudoVMUL_VV_MF8_TU, VMUL_VV, 0x5 }, // 7962
  { PseudoVMUL_VV_MF4, VMUL_VV, 0x6 }, // 7963
  { PseudoVMUL_VV_MF4_MASK, VMUL_VV, 0x6 }, // 7964
  { PseudoVMUL_VV_MF4_TU, VMUL_VV, 0x6 }, // 7965
  { PseudoVMUL_VV_MF2, VMUL_VV, 0x7 }, // 7966
  { PseudoVMUL_VV_MF2_MASK, VMUL_VV, 0x7 }, // 7967
  { PseudoVMUL_VV_MF2_TU, VMUL_VV, 0x7 }, // 7968
  { PseudoVMUL_VX_M1, VMUL_VX, 0x0 }, // 7969
  { PseudoVMUL_VX_M1_MASK, VMUL_VX, 0x0 }, // 7970
  { PseudoVMUL_VX_M1_TU, VMUL_VX, 0x0 }, // 7971
  { PseudoVMUL_VX_M2, VMUL_VX, 0x1 }, // 7972
  { PseudoVMUL_VX_M2_MASK, VMUL_VX, 0x1 }, // 7973
  { PseudoVMUL_VX_M2_TU, VMUL_VX, 0x1 }, // 7974
  { PseudoVMUL_VX_M4, VMUL_VX, 0x2 }, // 7975
  { PseudoVMUL_VX_M4_MASK, VMUL_VX, 0x2 }, // 7976
  { PseudoVMUL_VX_M4_TU, VMUL_VX, 0x2 }, // 7977
  { PseudoVMUL_VX_M8, VMUL_VX, 0x3 }, // 7978
  { PseudoVMUL_VX_M8_MASK, VMUL_VX, 0x3 }, // 7979
  { PseudoVMUL_VX_M8_TU, VMUL_VX, 0x3 }, // 7980
  { PseudoVMUL_VX_MF8, VMUL_VX, 0x5 }, // 7981
  { PseudoVMUL_VX_MF8_MASK, VMUL_VX, 0x5 }, // 7982
  { PseudoVMUL_VX_MF8_TU, VMUL_VX, 0x5 }, // 7983
  { PseudoVMUL_VX_MF4, VMUL_VX, 0x6 }, // 7984
  { PseudoVMUL_VX_MF4_MASK, VMUL_VX, 0x6 }, // 7985
  { PseudoVMUL_VX_MF4_TU, VMUL_VX, 0x6 }, // 7986
  { PseudoVMUL_VX_MF2, VMUL_VX, 0x7 }, // 7987
  { PseudoVMUL_VX_MF2_MASK, VMUL_VX, 0x7 }, // 7988
  { PseudoVMUL_VX_MF2_TU, VMUL_VX, 0x7 }, // 7989
  { PseudoVMV_S_X_M1, VMV_S_X, 0x0 }, // 7990
  { PseudoVMV_S_X_M2, VMV_S_X, 0x1 }, // 7991
  { PseudoVMV_S_X_M4, VMV_S_X, 0x2 }, // 7992
  { PseudoVMV_S_X_M8, VMV_S_X, 0x3 }, // 7993
  { PseudoVMV_S_X_MF8, VMV_S_X, 0x5 }, // 7994
  { PseudoVMV_S_X_MF4, VMV_S_X, 0x6 }, // 7995
  { PseudoVMV_S_X_MF2, VMV_S_X, 0x7 }, // 7996
  { PseudoVMV_V_I_M1, VMV_V_I, 0x0 }, // 7997
  { PseudoVMV_V_I_M1_TU, VMV_V_I, 0x0 }, // 7998
  { PseudoVMV_V_I_M2, VMV_V_I, 0x1 }, // 7999
  { PseudoVMV_V_I_M2_TU, VMV_V_I, 0x1 }, // 8000
  { PseudoVMV_V_I_M4, VMV_V_I, 0x2 }, // 8001
  { PseudoVMV_V_I_M4_TU, VMV_V_I, 0x2 }, // 8002
  { PseudoVMV_V_I_M8, VMV_V_I, 0x3 }, // 8003
  { PseudoVMV_V_I_M8_TU, VMV_V_I, 0x3 }, // 8004
  { PseudoVMV_V_I_MF8, VMV_V_I, 0x5 }, // 8005
  { PseudoVMV_V_I_MF8_TU, VMV_V_I, 0x5 }, // 8006
  { PseudoVMV_V_I_MF4, VMV_V_I, 0x6 }, // 8007
  { PseudoVMV_V_I_MF4_TU, VMV_V_I, 0x6 }, // 8008
  { PseudoVMV_V_I_MF2, VMV_V_I, 0x7 }, // 8009
  { PseudoVMV_V_I_MF2_TU, VMV_V_I, 0x7 }, // 8010
  { PseudoVMV_V_V_M1, VMV_V_V, 0x0 }, // 8011
  { PseudoVMV_V_V_M1_TU, VMV_V_V, 0x0 }, // 8012
  { PseudoVMV_V_V_M2, VMV_V_V, 0x1 }, // 8013
  { PseudoVMV_V_V_M2_TU, VMV_V_V, 0x1 }, // 8014
  { PseudoVMV_V_V_M4, VMV_V_V, 0x2 }, // 8015
  { PseudoVMV_V_V_M4_TU, VMV_V_V, 0x2 }, // 8016
  { PseudoVMV_V_V_M8, VMV_V_V, 0x3 }, // 8017
  { PseudoVMV_V_V_M8_TU, VMV_V_V, 0x3 }, // 8018
  { PseudoVMV_V_V_MF8, VMV_V_V, 0x5 }, // 8019
  { PseudoVMV_V_V_MF8_TU, VMV_V_V, 0x5 }, // 8020
  { PseudoVMV_V_V_MF4, VMV_V_V, 0x6 }, // 8021
  { PseudoVMV_V_V_MF4_TU, VMV_V_V, 0x6 }, // 8022
  { PseudoVMV_V_V_MF2, VMV_V_V, 0x7 }, // 8023
  { PseudoVMV_V_V_MF2_TU, VMV_V_V, 0x7 }, // 8024
  { PseudoVMV_V_X_M1, VMV_V_X, 0x0 }, // 8025
  { PseudoVMV_V_X_M1_TU, VMV_V_X, 0x0 }, // 8026
  { PseudoVMV_V_X_M2, VMV_V_X, 0x1 }, // 8027
  { PseudoVMV_V_X_M2_TU, VMV_V_X, 0x1 }, // 8028
  { PseudoVMV_V_X_M4, VMV_V_X, 0x2 }, // 8029
  { PseudoVMV_V_X_M4_TU, VMV_V_X, 0x2 }, // 8030
  { PseudoVMV_V_X_M8, VMV_V_X, 0x3 }, // 8031
  { PseudoVMV_V_X_M8_TU, VMV_V_X, 0x3 }, // 8032
  { PseudoVMV_V_X_MF8, VMV_V_X, 0x5 }, // 8033
  { PseudoVMV_V_X_MF8_TU, VMV_V_X, 0x5 }, // 8034
  { PseudoVMV_V_X_MF4, VMV_V_X, 0x6 }, // 8035
  { PseudoVMV_V_X_MF4_TU, VMV_V_X, 0x6 }, // 8036
  { PseudoVMV_V_X_MF2, VMV_V_X, 0x7 }, // 8037
  { PseudoVMV_V_X_MF2_TU, VMV_V_X, 0x7 }, // 8038
  { PseudoVMV_X_S_M1, VMV_X_S, 0x0 }, // 8039
  { PseudoVMV_X_S_M2, VMV_X_S, 0x1 }, // 8040
  { PseudoVMV_X_S_M4, VMV_X_S, 0x2 }, // 8041
  { PseudoVMV_X_S_M8, VMV_X_S, 0x3 }, // 8042
  { PseudoVMV_X_S_MF8, VMV_X_S, 0x5 }, // 8043
  { PseudoVMV_X_S_MF4, VMV_X_S, 0x6 }, // 8044
  { PseudoVMV_X_S_MF2, VMV_X_S, 0x7 }, // 8045
  { PseudoVMSET_M_B8, VMXNOR_MM, 0x0 }, // 8046
  { PseudoVMXNOR_MM_M1, VMXNOR_MM, 0x0 }, // 8047
  { PseudoVMSET_M_B16, VMXNOR_MM, 0x1 }, // 8048
  { PseudoVMXNOR_MM_M2, VMXNOR_MM, 0x1 }, // 8049
  { PseudoVMSET_M_B32, VMXNOR_MM, 0x2 }, // 8050
  { PseudoVMXNOR_MM_M4, VMXNOR_MM, 0x2 }, // 8051
  { PseudoVMSET_M_B64, VMXNOR_MM, 0x3 }, // 8052
  { PseudoVMXNOR_MM_M8, VMXNOR_MM, 0x3 }, // 8053
  { PseudoVMSET_M_B1, VMXNOR_MM, 0x5 }, // 8054
  { PseudoVMXNOR_MM_MF8, VMXNOR_MM, 0x5 }, // 8055
  { PseudoVMSET_M_B2, VMXNOR_MM, 0x6 }, // 8056
  { PseudoVMXNOR_MM_MF4, VMXNOR_MM, 0x6 }, // 8057
  { PseudoVMSET_M_B4, VMXNOR_MM, 0x7 }, // 8058
  { PseudoVMXNOR_MM_MF2, VMXNOR_MM, 0x7 }, // 8059
  { PseudoVMCLR_M_B8, VMXOR_MM, 0x0 }, // 8060
  { PseudoVMXOR_MM_M1, VMXOR_MM, 0x0 }, // 8061
  { PseudoVMCLR_M_B16, VMXOR_MM, 0x1 }, // 8062
  { PseudoVMXOR_MM_M2, VMXOR_MM, 0x1 }, // 8063
  { PseudoVMCLR_M_B32, VMXOR_MM, 0x2 }, // 8064
  { PseudoVMXOR_MM_M4, VMXOR_MM, 0x2 }, // 8065
  { PseudoVMCLR_M_B64, VMXOR_MM, 0x3 }, // 8066
  { PseudoVMXOR_MM_M8, VMXOR_MM, 0x3 }, // 8067
  { PseudoVMCLR_M_B1, VMXOR_MM, 0x5 }, // 8068
  { PseudoVMXOR_MM_MF8, VMXOR_MM, 0x5 }, // 8069
  { PseudoVMCLR_M_B2, VMXOR_MM, 0x6 }, // 8070
  { PseudoVMXOR_MM_MF4, VMXOR_MM, 0x6 }, // 8071
  { PseudoVMCLR_M_B4, VMXOR_MM, 0x7 }, // 8072
  { PseudoVMXOR_MM_MF2, VMXOR_MM, 0x7 }, // 8073
  { PseudoVNCLIPU_WI_M1, VNCLIPU_WI, 0x0 }, // 8074
  { PseudoVNCLIPU_WI_M1_MASK, VNCLIPU_WI, 0x0 }, // 8075
  { PseudoVNCLIPU_WI_M1_TU, VNCLIPU_WI, 0x0 }, // 8076
  { PseudoVNCLIPU_WI_M2, VNCLIPU_WI, 0x1 }, // 8077
  { PseudoVNCLIPU_WI_M2_MASK, VNCLIPU_WI, 0x1 }, // 8078
  { PseudoVNCLIPU_WI_M2_TU, VNCLIPU_WI, 0x1 }, // 8079
  { PseudoVNCLIPU_WI_M4, VNCLIPU_WI, 0x2 }, // 8080
  { PseudoVNCLIPU_WI_M4_MASK, VNCLIPU_WI, 0x2 }, // 8081
  { PseudoVNCLIPU_WI_M4_TU, VNCLIPU_WI, 0x2 }, // 8082
  { PseudoVNCLIPU_WI_MF8, VNCLIPU_WI, 0x5 }, // 8083
  { PseudoVNCLIPU_WI_MF8_MASK, VNCLIPU_WI, 0x5 }, // 8084
  { PseudoVNCLIPU_WI_MF8_TU, VNCLIPU_WI, 0x5 }, // 8085
  { PseudoVNCLIPU_WI_MF4, VNCLIPU_WI, 0x6 }, // 8086
  { PseudoVNCLIPU_WI_MF4_MASK, VNCLIPU_WI, 0x6 }, // 8087
  { PseudoVNCLIPU_WI_MF4_TU, VNCLIPU_WI, 0x6 }, // 8088
  { PseudoVNCLIPU_WI_MF2, VNCLIPU_WI, 0x7 }, // 8089
  { PseudoVNCLIPU_WI_MF2_MASK, VNCLIPU_WI, 0x7 }, // 8090
  { PseudoVNCLIPU_WI_MF2_TU, VNCLIPU_WI, 0x7 }, // 8091
  { PseudoVNCLIPU_WV_M1, VNCLIPU_WV, 0x0 }, // 8092
  { PseudoVNCLIPU_WV_M1_MASK, VNCLIPU_WV, 0x0 }, // 8093
  { PseudoVNCLIPU_WV_M1_TU, VNCLIPU_WV, 0x0 }, // 8094
  { PseudoVNCLIPU_WV_M2, VNCLIPU_WV, 0x1 }, // 8095
  { PseudoVNCLIPU_WV_M2_MASK, VNCLIPU_WV, 0x1 }, // 8096
  { PseudoVNCLIPU_WV_M2_TU, VNCLIPU_WV, 0x1 }, // 8097
  { PseudoVNCLIPU_WV_M4, VNCLIPU_WV, 0x2 }, // 8098
  { PseudoVNCLIPU_WV_M4_MASK, VNCLIPU_WV, 0x2 }, // 8099
  { PseudoVNCLIPU_WV_M4_TU, VNCLIPU_WV, 0x2 }, // 8100
  { PseudoVNCLIPU_WV_MF8, VNCLIPU_WV, 0x5 }, // 8101
  { PseudoVNCLIPU_WV_MF8_MASK, VNCLIPU_WV, 0x5 }, // 8102
  { PseudoVNCLIPU_WV_MF8_TU, VNCLIPU_WV, 0x5 }, // 8103
  { PseudoVNCLIPU_WV_MF4, VNCLIPU_WV, 0x6 }, // 8104
  { PseudoVNCLIPU_WV_MF4_MASK, VNCLIPU_WV, 0x6 }, // 8105
  { PseudoVNCLIPU_WV_MF4_TU, VNCLIPU_WV, 0x6 }, // 8106
  { PseudoVNCLIPU_WV_MF2, VNCLIPU_WV, 0x7 }, // 8107
  { PseudoVNCLIPU_WV_MF2_MASK, VNCLIPU_WV, 0x7 }, // 8108
  { PseudoVNCLIPU_WV_MF2_TU, VNCLIPU_WV, 0x7 }, // 8109
  { PseudoVNCLIPU_WX_M1, VNCLIPU_WX, 0x0 }, // 8110
  { PseudoVNCLIPU_WX_M1_MASK, VNCLIPU_WX, 0x0 }, // 8111
  { PseudoVNCLIPU_WX_M1_TU, VNCLIPU_WX, 0x0 }, // 8112
  { PseudoVNCLIPU_WX_M2, VNCLIPU_WX, 0x1 }, // 8113
  { PseudoVNCLIPU_WX_M2_MASK, VNCLIPU_WX, 0x1 }, // 8114
  { PseudoVNCLIPU_WX_M2_TU, VNCLIPU_WX, 0x1 }, // 8115
  { PseudoVNCLIPU_WX_M4, VNCLIPU_WX, 0x2 }, // 8116
  { PseudoVNCLIPU_WX_M4_MASK, VNCLIPU_WX, 0x2 }, // 8117
  { PseudoVNCLIPU_WX_M4_TU, VNCLIPU_WX, 0x2 }, // 8118
  { PseudoVNCLIPU_WX_MF8, VNCLIPU_WX, 0x5 }, // 8119
  { PseudoVNCLIPU_WX_MF8_MASK, VNCLIPU_WX, 0x5 }, // 8120
  { PseudoVNCLIPU_WX_MF8_TU, VNCLIPU_WX, 0x5 }, // 8121
  { PseudoVNCLIPU_WX_MF4, VNCLIPU_WX, 0x6 }, // 8122
  { PseudoVNCLIPU_WX_MF4_MASK, VNCLIPU_WX, 0x6 }, // 8123
  { PseudoVNCLIPU_WX_MF4_TU, VNCLIPU_WX, 0x6 }, // 8124
  { PseudoVNCLIPU_WX_MF2, VNCLIPU_WX, 0x7 }, // 8125
  { PseudoVNCLIPU_WX_MF2_MASK, VNCLIPU_WX, 0x7 }, // 8126
  { PseudoVNCLIPU_WX_MF2_TU, VNCLIPU_WX, 0x7 }, // 8127
  { PseudoVNCLIP_WI_M1, VNCLIP_WI, 0x0 }, // 8128
  { PseudoVNCLIP_WI_M1_MASK, VNCLIP_WI, 0x0 }, // 8129
  { PseudoVNCLIP_WI_M1_TU, VNCLIP_WI, 0x0 }, // 8130
  { PseudoVNCLIP_WI_M2, VNCLIP_WI, 0x1 }, // 8131
  { PseudoVNCLIP_WI_M2_MASK, VNCLIP_WI, 0x1 }, // 8132
  { PseudoVNCLIP_WI_M2_TU, VNCLIP_WI, 0x1 }, // 8133
  { PseudoVNCLIP_WI_M4, VNCLIP_WI, 0x2 }, // 8134
  { PseudoVNCLIP_WI_M4_MASK, VNCLIP_WI, 0x2 }, // 8135
  { PseudoVNCLIP_WI_M4_TU, VNCLIP_WI, 0x2 }, // 8136
  { PseudoVNCLIP_WI_MF8, VNCLIP_WI, 0x5 }, // 8137
  { PseudoVNCLIP_WI_MF8_MASK, VNCLIP_WI, 0x5 }, // 8138
  { PseudoVNCLIP_WI_MF8_TU, VNCLIP_WI, 0x5 }, // 8139
  { PseudoVNCLIP_WI_MF4, VNCLIP_WI, 0x6 }, // 8140
  { PseudoVNCLIP_WI_MF4_MASK, VNCLIP_WI, 0x6 }, // 8141
  { PseudoVNCLIP_WI_MF4_TU, VNCLIP_WI, 0x6 }, // 8142
  { PseudoVNCLIP_WI_MF2, VNCLIP_WI, 0x7 }, // 8143
  { PseudoVNCLIP_WI_MF2_MASK, VNCLIP_WI, 0x7 }, // 8144
  { PseudoVNCLIP_WI_MF2_TU, VNCLIP_WI, 0x7 }, // 8145
  { PseudoVNCLIP_WV_M1, VNCLIP_WV, 0x0 }, // 8146
  { PseudoVNCLIP_WV_M1_MASK, VNCLIP_WV, 0x0 }, // 8147
  { PseudoVNCLIP_WV_M1_TU, VNCLIP_WV, 0x0 }, // 8148
  { PseudoVNCLIP_WV_M2, VNCLIP_WV, 0x1 }, // 8149
  { PseudoVNCLIP_WV_M2_MASK, VNCLIP_WV, 0x1 }, // 8150
  { PseudoVNCLIP_WV_M2_TU, VNCLIP_WV, 0x1 }, // 8151
  { PseudoVNCLIP_WV_M4, VNCLIP_WV, 0x2 }, // 8152
  { PseudoVNCLIP_WV_M4_MASK, VNCLIP_WV, 0x2 }, // 8153
  { PseudoVNCLIP_WV_M4_TU, VNCLIP_WV, 0x2 }, // 8154
  { PseudoVNCLIP_WV_MF8, VNCLIP_WV, 0x5 }, // 8155
  { PseudoVNCLIP_WV_MF8_MASK, VNCLIP_WV, 0x5 }, // 8156
  { PseudoVNCLIP_WV_MF8_TU, VNCLIP_WV, 0x5 }, // 8157
  { PseudoVNCLIP_WV_MF4, VNCLIP_WV, 0x6 }, // 8158
  { PseudoVNCLIP_WV_MF4_MASK, VNCLIP_WV, 0x6 }, // 8159
  { PseudoVNCLIP_WV_MF4_TU, VNCLIP_WV, 0x6 }, // 8160
  { PseudoVNCLIP_WV_MF2, VNCLIP_WV, 0x7 }, // 8161
  { PseudoVNCLIP_WV_MF2_MASK, VNCLIP_WV, 0x7 }, // 8162
  { PseudoVNCLIP_WV_MF2_TU, VNCLIP_WV, 0x7 }, // 8163
  { PseudoVNCLIP_WX_M1, VNCLIP_WX, 0x0 }, // 8164
  { PseudoVNCLIP_WX_M1_MASK, VNCLIP_WX, 0x0 }, // 8165
  { PseudoVNCLIP_WX_M1_TU, VNCLIP_WX, 0x0 }, // 8166
  { PseudoVNCLIP_WX_M2, VNCLIP_WX, 0x1 }, // 8167
  { PseudoVNCLIP_WX_M2_MASK, VNCLIP_WX, 0x1 }, // 8168
  { PseudoVNCLIP_WX_M2_TU, VNCLIP_WX, 0x1 }, // 8169
  { PseudoVNCLIP_WX_M4, VNCLIP_WX, 0x2 }, // 8170
  { PseudoVNCLIP_WX_M4_MASK, VNCLIP_WX, 0x2 }, // 8171
  { PseudoVNCLIP_WX_M4_TU, VNCLIP_WX, 0x2 }, // 8172
  { PseudoVNCLIP_WX_MF8, VNCLIP_WX, 0x5 }, // 8173
  { PseudoVNCLIP_WX_MF8_MASK, VNCLIP_WX, 0x5 }, // 8174
  { PseudoVNCLIP_WX_MF8_TU, VNCLIP_WX, 0x5 }, // 8175
  { PseudoVNCLIP_WX_MF4, VNCLIP_WX, 0x6 }, // 8176
  { PseudoVNCLIP_WX_MF4_MASK, VNCLIP_WX, 0x6 }, // 8177
  { PseudoVNCLIP_WX_MF4_TU, VNCLIP_WX, 0x6 }, // 8178
  { PseudoVNCLIP_WX_MF2, VNCLIP_WX, 0x7 }, // 8179
  { PseudoVNCLIP_WX_MF2_MASK, VNCLIP_WX, 0x7 }, // 8180
  { PseudoVNCLIP_WX_MF2_TU, VNCLIP_WX, 0x7 }, // 8181
  { PseudoVNMSAC_VV_M1, VNMSAC_VV, 0x0 }, // 8182
  { PseudoVNMSAC_VV_M1_MASK, VNMSAC_VV, 0x0 }, // 8183
  { PseudoVNMSAC_VV_M2, VNMSAC_VV, 0x1 }, // 8184
  { PseudoVNMSAC_VV_M2_MASK, VNMSAC_VV, 0x1 }, // 8185
  { PseudoVNMSAC_VV_M4, VNMSAC_VV, 0x2 }, // 8186
  { PseudoVNMSAC_VV_M4_MASK, VNMSAC_VV, 0x2 }, // 8187
  { PseudoVNMSAC_VV_M8, VNMSAC_VV, 0x3 }, // 8188
  { PseudoVNMSAC_VV_M8_MASK, VNMSAC_VV, 0x3 }, // 8189
  { PseudoVNMSAC_VV_MF8, VNMSAC_VV, 0x5 }, // 8190
  { PseudoVNMSAC_VV_MF8_MASK, VNMSAC_VV, 0x5 }, // 8191
  { PseudoVNMSAC_VV_MF4, VNMSAC_VV, 0x6 }, // 8192
  { PseudoVNMSAC_VV_MF4_MASK, VNMSAC_VV, 0x6 }, // 8193
  { PseudoVNMSAC_VV_MF2, VNMSAC_VV, 0x7 }, // 8194
  { PseudoVNMSAC_VV_MF2_MASK, VNMSAC_VV, 0x7 }, // 8195
  { PseudoVNMSAC_VX_M1, VNMSAC_VX, 0x0 }, // 8196
  { PseudoVNMSAC_VX_M1_MASK, VNMSAC_VX, 0x0 }, // 8197
  { PseudoVNMSAC_VX_M2, VNMSAC_VX, 0x1 }, // 8198
  { PseudoVNMSAC_VX_M2_MASK, VNMSAC_VX, 0x1 }, // 8199
  { PseudoVNMSAC_VX_M4, VNMSAC_VX, 0x2 }, // 8200
  { PseudoVNMSAC_VX_M4_MASK, VNMSAC_VX, 0x2 }, // 8201
  { PseudoVNMSAC_VX_M8, VNMSAC_VX, 0x3 }, // 8202
  { PseudoVNMSAC_VX_M8_MASK, VNMSAC_VX, 0x3 }, // 8203
  { PseudoVNMSAC_VX_MF8, VNMSAC_VX, 0x5 }, // 8204
  { PseudoVNMSAC_VX_MF8_MASK, VNMSAC_VX, 0x5 }, // 8205
  { PseudoVNMSAC_VX_MF4, VNMSAC_VX, 0x6 }, // 8206
  { PseudoVNMSAC_VX_MF4_MASK, VNMSAC_VX, 0x6 }, // 8207
  { PseudoVNMSAC_VX_MF2, VNMSAC_VX, 0x7 }, // 8208
  { PseudoVNMSAC_VX_MF2_MASK, VNMSAC_VX, 0x7 }, // 8209
  { PseudoVNMSUB_VV_M1, VNMSUB_VV, 0x0 }, // 8210
  { PseudoVNMSUB_VV_M1_MASK, VNMSUB_VV, 0x0 }, // 8211
  { PseudoVNMSUB_VV_M2, VNMSUB_VV, 0x1 }, // 8212
  { PseudoVNMSUB_VV_M2_MASK, VNMSUB_VV, 0x1 }, // 8213
  { PseudoVNMSUB_VV_M4, VNMSUB_VV, 0x2 }, // 8214
  { PseudoVNMSUB_VV_M4_MASK, VNMSUB_VV, 0x2 }, // 8215
  { PseudoVNMSUB_VV_M8, VNMSUB_VV, 0x3 }, // 8216
  { PseudoVNMSUB_VV_M8_MASK, VNMSUB_VV, 0x3 }, // 8217
  { PseudoVNMSUB_VV_MF8, VNMSUB_VV, 0x5 }, // 8218
  { PseudoVNMSUB_VV_MF8_MASK, VNMSUB_VV, 0x5 }, // 8219
  { PseudoVNMSUB_VV_MF4, VNMSUB_VV, 0x6 }, // 8220
  { PseudoVNMSUB_VV_MF4_MASK, VNMSUB_VV, 0x6 }, // 8221
  { PseudoVNMSUB_VV_MF2, VNMSUB_VV, 0x7 }, // 8222
  { PseudoVNMSUB_VV_MF2_MASK, VNMSUB_VV, 0x7 }, // 8223
  { PseudoVNMSUB_VX_M1, VNMSUB_VX, 0x0 }, // 8224
  { PseudoVNMSUB_VX_M1_MASK, VNMSUB_VX, 0x0 }, // 8225
  { PseudoVNMSUB_VX_M2, VNMSUB_VX, 0x1 }, // 8226
  { PseudoVNMSUB_VX_M2_MASK, VNMSUB_VX, 0x1 }, // 8227
  { PseudoVNMSUB_VX_M4, VNMSUB_VX, 0x2 }, // 8228
  { PseudoVNMSUB_VX_M4_MASK, VNMSUB_VX, 0x2 }, // 8229
  { PseudoVNMSUB_VX_M8, VNMSUB_VX, 0x3 }, // 8230
  { PseudoVNMSUB_VX_M8_MASK, VNMSUB_VX, 0x3 }, // 8231
  { PseudoVNMSUB_VX_MF8, VNMSUB_VX, 0x5 }, // 8232
  { PseudoVNMSUB_VX_MF8_MASK, VNMSUB_VX, 0x5 }, // 8233
  { PseudoVNMSUB_VX_MF4, VNMSUB_VX, 0x6 }, // 8234
  { PseudoVNMSUB_VX_MF4_MASK, VNMSUB_VX, 0x6 }, // 8235
  { PseudoVNMSUB_VX_MF2, VNMSUB_VX, 0x7 }, // 8236
  { PseudoVNMSUB_VX_MF2_MASK, VNMSUB_VX, 0x7 }, // 8237
  { PseudoVNSRA_WI_M1, VNSRA_WI, 0x0 }, // 8238
  { PseudoVNSRA_WI_M1_MASK, VNSRA_WI, 0x0 }, // 8239
  { PseudoVNSRA_WI_M1_TU, VNSRA_WI, 0x0 }, // 8240
  { PseudoVNSRA_WI_M2, VNSRA_WI, 0x1 }, // 8241
  { PseudoVNSRA_WI_M2_MASK, VNSRA_WI, 0x1 }, // 8242
  { PseudoVNSRA_WI_M2_TU, VNSRA_WI, 0x1 }, // 8243
  { PseudoVNSRA_WI_M4, VNSRA_WI, 0x2 }, // 8244
  { PseudoVNSRA_WI_M4_MASK, VNSRA_WI, 0x2 }, // 8245
  { PseudoVNSRA_WI_M4_TU, VNSRA_WI, 0x2 }, // 8246
  { PseudoVNSRA_WI_MF8, VNSRA_WI, 0x5 }, // 8247
  { PseudoVNSRA_WI_MF8_MASK, VNSRA_WI, 0x5 }, // 8248
  { PseudoVNSRA_WI_MF8_TU, VNSRA_WI, 0x5 }, // 8249
  { PseudoVNSRA_WI_MF4, VNSRA_WI, 0x6 }, // 8250
  { PseudoVNSRA_WI_MF4_MASK, VNSRA_WI, 0x6 }, // 8251
  { PseudoVNSRA_WI_MF4_TU, VNSRA_WI, 0x6 }, // 8252
  { PseudoVNSRA_WI_MF2, VNSRA_WI, 0x7 }, // 8253
  { PseudoVNSRA_WI_MF2_MASK, VNSRA_WI, 0x7 }, // 8254
  { PseudoVNSRA_WI_MF2_TU, VNSRA_WI, 0x7 }, // 8255
  { PseudoVNSRA_WV_M1, VNSRA_WV, 0x0 }, // 8256
  { PseudoVNSRA_WV_M1_MASK, VNSRA_WV, 0x0 }, // 8257
  { PseudoVNSRA_WV_M1_TU, VNSRA_WV, 0x0 }, // 8258
  { PseudoVNSRA_WV_M2, VNSRA_WV, 0x1 }, // 8259
  { PseudoVNSRA_WV_M2_MASK, VNSRA_WV, 0x1 }, // 8260
  { PseudoVNSRA_WV_M2_TU, VNSRA_WV, 0x1 }, // 8261
  { PseudoVNSRA_WV_M4, VNSRA_WV, 0x2 }, // 8262
  { PseudoVNSRA_WV_M4_MASK, VNSRA_WV, 0x2 }, // 8263
  { PseudoVNSRA_WV_M4_TU, VNSRA_WV, 0x2 }, // 8264
  { PseudoVNSRA_WV_MF8, VNSRA_WV, 0x5 }, // 8265
  { PseudoVNSRA_WV_MF8_MASK, VNSRA_WV, 0x5 }, // 8266
  { PseudoVNSRA_WV_MF8_TU, VNSRA_WV, 0x5 }, // 8267
  { PseudoVNSRA_WV_MF4, VNSRA_WV, 0x6 }, // 8268
  { PseudoVNSRA_WV_MF4_MASK, VNSRA_WV, 0x6 }, // 8269
  { PseudoVNSRA_WV_MF4_TU, VNSRA_WV, 0x6 }, // 8270
  { PseudoVNSRA_WV_MF2, VNSRA_WV, 0x7 }, // 8271
  { PseudoVNSRA_WV_MF2_MASK, VNSRA_WV, 0x7 }, // 8272
  { PseudoVNSRA_WV_MF2_TU, VNSRA_WV, 0x7 }, // 8273
  { PseudoVNSRA_WX_M1, VNSRA_WX, 0x0 }, // 8274
  { PseudoVNSRA_WX_M1_MASK, VNSRA_WX, 0x0 }, // 8275
  { PseudoVNSRA_WX_M1_TU, VNSRA_WX, 0x0 }, // 8276
  { PseudoVNSRA_WX_M2, VNSRA_WX, 0x1 }, // 8277
  { PseudoVNSRA_WX_M2_MASK, VNSRA_WX, 0x1 }, // 8278
  { PseudoVNSRA_WX_M2_TU, VNSRA_WX, 0x1 }, // 8279
  { PseudoVNSRA_WX_M4, VNSRA_WX, 0x2 }, // 8280
  { PseudoVNSRA_WX_M4_MASK, VNSRA_WX, 0x2 }, // 8281
  { PseudoVNSRA_WX_M4_TU, VNSRA_WX, 0x2 }, // 8282
  { PseudoVNSRA_WX_MF8, VNSRA_WX, 0x5 }, // 8283
  { PseudoVNSRA_WX_MF8_MASK, VNSRA_WX, 0x5 }, // 8284
  { PseudoVNSRA_WX_MF8_TU, VNSRA_WX, 0x5 }, // 8285
  { PseudoVNSRA_WX_MF4, VNSRA_WX, 0x6 }, // 8286
  { PseudoVNSRA_WX_MF4_MASK, VNSRA_WX, 0x6 }, // 8287
  { PseudoVNSRA_WX_MF4_TU, VNSRA_WX, 0x6 }, // 8288
  { PseudoVNSRA_WX_MF2, VNSRA_WX, 0x7 }, // 8289
  { PseudoVNSRA_WX_MF2_MASK, VNSRA_WX, 0x7 }, // 8290
  { PseudoVNSRA_WX_MF2_TU, VNSRA_WX, 0x7 }, // 8291
  { PseudoVNSRL_WI_M1, VNSRL_WI, 0x0 }, // 8292
  { PseudoVNSRL_WI_M1_MASK, VNSRL_WI, 0x0 }, // 8293
  { PseudoVNSRL_WI_M1_TU, VNSRL_WI, 0x0 }, // 8294
  { PseudoVNSRL_WI_M2, VNSRL_WI, 0x1 }, // 8295
  { PseudoVNSRL_WI_M2_MASK, VNSRL_WI, 0x1 }, // 8296
  { PseudoVNSRL_WI_M2_TU, VNSRL_WI, 0x1 }, // 8297
  { PseudoVNSRL_WI_M4, VNSRL_WI, 0x2 }, // 8298
  { PseudoVNSRL_WI_M4_MASK, VNSRL_WI, 0x2 }, // 8299
  { PseudoVNSRL_WI_M4_TU, VNSRL_WI, 0x2 }, // 8300
  { PseudoVNSRL_WI_MF8, VNSRL_WI, 0x5 }, // 8301
  { PseudoVNSRL_WI_MF8_MASK, VNSRL_WI, 0x5 }, // 8302
  { PseudoVNSRL_WI_MF8_TU, VNSRL_WI, 0x5 }, // 8303
  { PseudoVNSRL_WI_MF4, VNSRL_WI, 0x6 }, // 8304
  { PseudoVNSRL_WI_MF4_MASK, VNSRL_WI, 0x6 }, // 8305
  { PseudoVNSRL_WI_MF4_TU, VNSRL_WI, 0x6 }, // 8306
  { PseudoVNSRL_WI_MF2, VNSRL_WI, 0x7 }, // 8307
  { PseudoVNSRL_WI_MF2_MASK, VNSRL_WI, 0x7 }, // 8308
  { PseudoVNSRL_WI_MF2_TU, VNSRL_WI, 0x7 }, // 8309
  { PseudoVNSRL_WV_M1, VNSRL_WV, 0x0 }, // 8310
  { PseudoVNSRL_WV_M1_MASK, VNSRL_WV, 0x0 }, // 8311
  { PseudoVNSRL_WV_M1_TU, VNSRL_WV, 0x0 }, // 8312
  { PseudoVNSRL_WV_M2, VNSRL_WV, 0x1 }, // 8313
  { PseudoVNSRL_WV_M2_MASK, VNSRL_WV, 0x1 }, // 8314
  { PseudoVNSRL_WV_M2_TU, VNSRL_WV, 0x1 }, // 8315
  { PseudoVNSRL_WV_M4, VNSRL_WV, 0x2 }, // 8316
  { PseudoVNSRL_WV_M4_MASK, VNSRL_WV, 0x2 }, // 8317
  { PseudoVNSRL_WV_M4_TU, VNSRL_WV, 0x2 }, // 8318
  { PseudoVNSRL_WV_MF8, VNSRL_WV, 0x5 }, // 8319
  { PseudoVNSRL_WV_MF8_MASK, VNSRL_WV, 0x5 }, // 8320
  { PseudoVNSRL_WV_MF8_TU, VNSRL_WV, 0x5 }, // 8321
  { PseudoVNSRL_WV_MF4, VNSRL_WV, 0x6 }, // 8322
  { PseudoVNSRL_WV_MF4_MASK, VNSRL_WV, 0x6 }, // 8323
  { PseudoVNSRL_WV_MF4_TU, VNSRL_WV, 0x6 }, // 8324
  { PseudoVNSRL_WV_MF2, VNSRL_WV, 0x7 }, // 8325
  { PseudoVNSRL_WV_MF2_MASK, VNSRL_WV, 0x7 }, // 8326
  { PseudoVNSRL_WV_MF2_TU, VNSRL_WV, 0x7 }, // 8327
  { PseudoVNSRL_WX_M1, VNSRL_WX, 0x0 }, // 8328
  { PseudoVNSRL_WX_M1_MASK, VNSRL_WX, 0x0 }, // 8329
  { PseudoVNSRL_WX_M1_TU, VNSRL_WX, 0x0 }, // 8330
  { PseudoVNSRL_WX_M2, VNSRL_WX, 0x1 }, // 8331
  { PseudoVNSRL_WX_M2_MASK, VNSRL_WX, 0x1 }, // 8332
  { PseudoVNSRL_WX_M2_TU, VNSRL_WX, 0x1 }, // 8333
  { PseudoVNSRL_WX_M4, VNSRL_WX, 0x2 }, // 8334
  { PseudoVNSRL_WX_M4_MASK, VNSRL_WX, 0x2 }, // 8335
  { PseudoVNSRL_WX_M4_TU, VNSRL_WX, 0x2 }, // 8336
  { PseudoVNSRL_WX_MF8, VNSRL_WX, 0x5 }, // 8337
  { PseudoVNSRL_WX_MF8_MASK, VNSRL_WX, 0x5 }, // 8338
  { PseudoVNSRL_WX_MF8_TU, VNSRL_WX, 0x5 }, // 8339
  { PseudoVNSRL_WX_MF4, VNSRL_WX, 0x6 }, // 8340
  { PseudoVNSRL_WX_MF4_MASK, VNSRL_WX, 0x6 }, // 8341
  { PseudoVNSRL_WX_MF4_TU, VNSRL_WX, 0x6 }, // 8342
  { PseudoVNSRL_WX_MF2, VNSRL_WX, 0x7 }, // 8343
  { PseudoVNSRL_WX_MF2_MASK, VNSRL_WX, 0x7 }, // 8344
  { PseudoVNSRL_WX_MF2_TU, VNSRL_WX, 0x7 }, // 8345
  { PseudoVOR_VI_M1, VOR_VI, 0x0 }, // 8346
  { PseudoVOR_VI_M1_MASK, VOR_VI, 0x0 }, // 8347
  { PseudoVOR_VI_M1_TU, VOR_VI, 0x0 }, // 8348
  { PseudoVOR_VI_M2, VOR_VI, 0x1 }, // 8349
  { PseudoVOR_VI_M2_MASK, VOR_VI, 0x1 }, // 8350
  { PseudoVOR_VI_M2_TU, VOR_VI, 0x1 }, // 8351
  { PseudoVOR_VI_M4, VOR_VI, 0x2 }, // 8352
  { PseudoVOR_VI_M4_MASK, VOR_VI, 0x2 }, // 8353
  { PseudoVOR_VI_M4_TU, VOR_VI, 0x2 }, // 8354
  { PseudoVOR_VI_M8, VOR_VI, 0x3 }, // 8355
  { PseudoVOR_VI_M8_MASK, VOR_VI, 0x3 }, // 8356
  { PseudoVOR_VI_M8_TU, VOR_VI, 0x3 }, // 8357
  { PseudoVOR_VI_MF8, VOR_VI, 0x5 }, // 8358
  { PseudoVOR_VI_MF8_MASK, VOR_VI, 0x5 }, // 8359
  { PseudoVOR_VI_MF8_TU, VOR_VI, 0x5 }, // 8360
  { PseudoVOR_VI_MF4, VOR_VI, 0x6 }, // 8361
  { PseudoVOR_VI_MF4_MASK, VOR_VI, 0x6 }, // 8362
  { PseudoVOR_VI_MF4_TU, VOR_VI, 0x6 }, // 8363
  { PseudoVOR_VI_MF2, VOR_VI, 0x7 }, // 8364
  { PseudoVOR_VI_MF2_MASK, VOR_VI, 0x7 }, // 8365
  { PseudoVOR_VI_MF2_TU, VOR_VI, 0x7 }, // 8366
  { PseudoVOR_VV_M1, VOR_VV, 0x0 }, // 8367
  { PseudoVOR_VV_M1_MASK, VOR_VV, 0x0 }, // 8368
  { PseudoVOR_VV_M1_TU, VOR_VV, 0x0 }, // 8369
  { PseudoVOR_VV_M2, VOR_VV, 0x1 }, // 8370
  { PseudoVOR_VV_M2_MASK, VOR_VV, 0x1 }, // 8371
  { PseudoVOR_VV_M2_TU, VOR_VV, 0x1 }, // 8372
  { PseudoVOR_VV_M4, VOR_VV, 0x2 }, // 8373
  { PseudoVOR_VV_M4_MASK, VOR_VV, 0x2 }, // 8374
  { PseudoVOR_VV_M4_TU, VOR_VV, 0x2 }, // 8375
  { PseudoVOR_VV_M8, VOR_VV, 0x3 }, // 8376
  { PseudoVOR_VV_M8_MASK, VOR_VV, 0x3 }, // 8377
  { PseudoVOR_VV_M8_TU, VOR_VV, 0x3 }, // 8378
  { PseudoVOR_VV_MF8, VOR_VV, 0x5 }, // 8379
  { PseudoVOR_VV_MF8_MASK, VOR_VV, 0x5 }, // 8380
  { PseudoVOR_VV_MF8_TU, VOR_VV, 0x5 }, // 8381
  { PseudoVOR_VV_MF4, VOR_VV, 0x6 }, // 8382
  { PseudoVOR_VV_MF4_MASK, VOR_VV, 0x6 }, // 8383
  { PseudoVOR_VV_MF4_TU, VOR_VV, 0x6 }, // 8384
  { PseudoVOR_VV_MF2, VOR_VV, 0x7 }, // 8385
  { PseudoVOR_VV_MF2_MASK, VOR_VV, 0x7 }, // 8386
  { PseudoVOR_VV_MF2_TU, VOR_VV, 0x7 }, // 8387
  { PseudoVOR_VX_M1, VOR_VX, 0x0 }, // 8388
  { PseudoVOR_VX_M1_MASK, VOR_VX, 0x0 }, // 8389
  { PseudoVOR_VX_M1_TU, VOR_VX, 0x0 }, // 8390
  { PseudoVOR_VX_M2, VOR_VX, 0x1 }, // 8391
  { PseudoVOR_VX_M2_MASK, VOR_VX, 0x1 }, // 8392
  { PseudoVOR_VX_M2_TU, VOR_VX, 0x1 }, // 8393
  { PseudoVOR_VX_M4, VOR_VX, 0x2 }, // 8394
  { PseudoVOR_VX_M4_MASK, VOR_VX, 0x2 }, // 8395
  { PseudoVOR_VX_M4_TU, VOR_VX, 0x2 }, // 8396
  { PseudoVOR_VX_M8, VOR_VX, 0x3 }, // 8397
  { PseudoVOR_VX_M8_MASK, VOR_VX, 0x3 }, // 8398
  { PseudoVOR_VX_M8_TU, VOR_VX, 0x3 }, // 8399
  { PseudoVOR_VX_MF8, VOR_VX, 0x5 }, // 8400
  { PseudoVOR_VX_MF8_MASK, VOR_VX, 0x5 }, // 8401
  { PseudoVOR_VX_MF8_TU, VOR_VX, 0x5 }, // 8402
  { PseudoVOR_VX_MF4, VOR_VX, 0x6 }, // 8403
  { PseudoVOR_VX_MF4_MASK, VOR_VX, 0x6 }, // 8404
  { PseudoVOR_VX_MF4_TU, VOR_VX, 0x6 }, // 8405
  { PseudoVOR_VX_MF2, VOR_VX, 0x7 }, // 8406
  { PseudoVOR_VX_MF2_MASK, VOR_VX, 0x7 }, // 8407
  { PseudoVOR_VX_MF2_TU, VOR_VX, 0x7 }, // 8408
  { PseudoVREDAND_VS_M1_E16, VREDAND_VS, 0x0 }, // 8409
  { PseudoVREDAND_VS_M1_E16_MASK, VREDAND_VS, 0x0 }, // 8410
  { PseudoVREDAND_VS_M1_E32, VREDAND_VS, 0x0 }, // 8411
  { PseudoVREDAND_VS_M1_E32_MASK, VREDAND_VS, 0x0 }, // 8412
  { PseudoVREDAND_VS_M1_E64, VREDAND_VS, 0x0 }, // 8413
  { PseudoVREDAND_VS_M1_E64_MASK, VREDAND_VS, 0x0 }, // 8414
  { PseudoVREDAND_VS_M1_E8, VREDAND_VS, 0x0 }, // 8415
  { PseudoVREDAND_VS_M1_E8_MASK, VREDAND_VS, 0x0 }, // 8416
  { PseudoVREDAND_VS_M2_E16, VREDAND_VS, 0x1 }, // 8417
  { PseudoVREDAND_VS_M2_E16_MASK, VREDAND_VS, 0x1 }, // 8418
  { PseudoVREDAND_VS_M2_E32, VREDAND_VS, 0x1 }, // 8419
  { PseudoVREDAND_VS_M2_E32_MASK, VREDAND_VS, 0x1 }, // 8420
  { PseudoVREDAND_VS_M2_E64, VREDAND_VS, 0x1 }, // 8421
  { PseudoVREDAND_VS_M2_E64_MASK, VREDAND_VS, 0x1 }, // 8422
  { PseudoVREDAND_VS_M2_E8, VREDAND_VS, 0x1 }, // 8423
  { PseudoVREDAND_VS_M2_E8_MASK, VREDAND_VS, 0x1 }, // 8424
  { PseudoVREDAND_VS_M4_E16, VREDAND_VS, 0x2 }, // 8425
  { PseudoVREDAND_VS_M4_E16_MASK, VREDAND_VS, 0x2 }, // 8426
  { PseudoVREDAND_VS_M4_E32, VREDAND_VS, 0x2 }, // 8427
  { PseudoVREDAND_VS_M4_E32_MASK, VREDAND_VS, 0x2 }, // 8428
  { PseudoVREDAND_VS_M4_E64, VREDAND_VS, 0x2 }, // 8429
  { PseudoVREDAND_VS_M4_E64_MASK, VREDAND_VS, 0x2 }, // 8430
  { PseudoVREDAND_VS_M4_E8, VREDAND_VS, 0x2 }, // 8431
  { PseudoVREDAND_VS_M4_E8_MASK, VREDAND_VS, 0x2 }, // 8432
  { PseudoVREDAND_VS_M8_E16, VREDAND_VS, 0x3 }, // 8433
  { PseudoVREDAND_VS_M8_E16_MASK, VREDAND_VS, 0x3 }, // 8434
  { PseudoVREDAND_VS_M8_E32, VREDAND_VS, 0x3 }, // 8435
  { PseudoVREDAND_VS_M8_E32_MASK, VREDAND_VS, 0x3 }, // 8436
  { PseudoVREDAND_VS_M8_E64, VREDAND_VS, 0x3 }, // 8437
  { PseudoVREDAND_VS_M8_E64_MASK, VREDAND_VS, 0x3 }, // 8438
  { PseudoVREDAND_VS_M8_E8, VREDAND_VS, 0x3 }, // 8439
  { PseudoVREDAND_VS_M8_E8_MASK, VREDAND_VS, 0x3 }, // 8440
  { PseudoVREDAND_VS_MF8_E8, VREDAND_VS, 0x5 }, // 8441
  { PseudoVREDAND_VS_MF8_E8_MASK, VREDAND_VS, 0x5 }, // 8442
  { PseudoVREDAND_VS_MF4_E16, VREDAND_VS, 0x6 }, // 8443
  { PseudoVREDAND_VS_MF4_E16_MASK, VREDAND_VS, 0x6 }, // 8444
  { PseudoVREDAND_VS_MF4_E8, VREDAND_VS, 0x6 }, // 8445
  { PseudoVREDAND_VS_MF4_E8_MASK, VREDAND_VS, 0x6 }, // 8446
  { PseudoVREDAND_VS_MF2_E16, VREDAND_VS, 0x7 }, // 8447
  { PseudoVREDAND_VS_MF2_E16_MASK, VREDAND_VS, 0x7 }, // 8448
  { PseudoVREDAND_VS_MF2_E32, VREDAND_VS, 0x7 }, // 8449
  { PseudoVREDAND_VS_MF2_E32_MASK, VREDAND_VS, 0x7 }, // 8450
  { PseudoVREDAND_VS_MF2_E8, VREDAND_VS, 0x7 }, // 8451
  { PseudoVREDAND_VS_MF2_E8_MASK, VREDAND_VS, 0x7 }, // 8452
  { PseudoVREDMAXU_VS_M1_E16, VREDMAXU_VS, 0x0 }, // 8453
  { PseudoVREDMAXU_VS_M1_E16_MASK, VREDMAXU_VS, 0x0 }, // 8454
  { PseudoVREDMAXU_VS_M1_E32, VREDMAXU_VS, 0x0 }, // 8455
  { PseudoVREDMAXU_VS_M1_E32_MASK, VREDMAXU_VS, 0x0 }, // 8456
  { PseudoVREDMAXU_VS_M1_E64, VREDMAXU_VS, 0x0 }, // 8457
  { PseudoVREDMAXU_VS_M1_E64_MASK, VREDMAXU_VS, 0x0 }, // 8458
  { PseudoVREDMAXU_VS_M1_E8, VREDMAXU_VS, 0x0 }, // 8459
  { PseudoVREDMAXU_VS_M1_E8_MASK, VREDMAXU_VS, 0x0 }, // 8460
  { PseudoVREDMAXU_VS_M2_E16, VREDMAXU_VS, 0x1 }, // 8461
  { PseudoVREDMAXU_VS_M2_E16_MASK, VREDMAXU_VS, 0x1 }, // 8462
  { PseudoVREDMAXU_VS_M2_E32, VREDMAXU_VS, 0x1 }, // 8463
  { PseudoVREDMAXU_VS_M2_E32_MASK, VREDMAXU_VS, 0x1 }, // 8464
  { PseudoVREDMAXU_VS_M2_E64, VREDMAXU_VS, 0x1 }, // 8465
  { PseudoVREDMAXU_VS_M2_E64_MASK, VREDMAXU_VS, 0x1 }, // 8466
  { PseudoVREDMAXU_VS_M2_E8, VREDMAXU_VS, 0x1 }, // 8467
  { PseudoVREDMAXU_VS_M2_E8_MASK, VREDMAXU_VS, 0x1 }, // 8468
  { PseudoVREDMAXU_VS_M4_E16, VREDMAXU_VS, 0x2 }, // 8469
  { PseudoVREDMAXU_VS_M4_E16_MASK, VREDMAXU_VS, 0x2 }, // 8470
  { PseudoVREDMAXU_VS_M4_E32, VREDMAXU_VS, 0x2 }, // 8471
  { PseudoVREDMAXU_VS_M4_E32_MASK, VREDMAXU_VS, 0x2 }, // 8472
  { PseudoVREDMAXU_VS_M4_E64, VREDMAXU_VS, 0x2 }, // 8473
  { PseudoVREDMAXU_VS_M4_E64_MASK, VREDMAXU_VS, 0x2 }, // 8474
  { PseudoVREDMAXU_VS_M4_E8, VREDMAXU_VS, 0x2 }, // 8475
  { PseudoVREDMAXU_VS_M4_E8_MASK, VREDMAXU_VS, 0x2 }, // 8476
  { PseudoVREDMAXU_VS_M8_E16, VREDMAXU_VS, 0x3 }, // 8477
  { PseudoVREDMAXU_VS_M8_E16_MASK, VREDMAXU_VS, 0x3 }, // 8478
  { PseudoVREDMAXU_VS_M8_E32, VREDMAXU_VS, 0x3 }, // 8479
  { PseudoVREDMAXU_VS_M8_E32_MASK, VREDMAXU_VS, 0x3 }, // 8480
  { PseudoVREDMAXU_VS_M8_E64, VREDMAXU_VS, 0x3 }, // 8481
  { PseudoVREDMAXU_VS_M8_E64_MASK, VREDMAXU_VS, 0x3 }, // 8482
  { PseudoVREDMAXU_VS_M8_E8, VREDMAXU_VS, 0x3 }, // 8483
  { PseudoVREDMAXU_VS_M8_E8_MASK, VREDMAXU_VS, 0x3 }, // 8484
  { PseudoVREDMAXU_VS_MF8_E8, VREDMAXU_VS, 0x5 }, // 8485
  { PseudoVREDMAXU_VS_MF8_E8_MASK, VREDMAXU_VS, 0x5 }, // 8486
  { PseudoVREDMAXU_VS_MF4_E16, VREDMAXU_VS, 0x6 }, // 8487
  { PseudoVREDMAXU_VS_MF4_E16_MASK, VREDMAXU_VS, 0x6 }, // 8488
  { PseudoVREDMAXU_VS_MF4_E8, VREDMAXU_VS, 0x6 }, // 8489
  { PseudoVREDMAXU_VS_MF4_E8_MASK, VREDMAXU_VS, 0x6 }, // 8490
  { PseudoVREDMAXU_VS_MF2_E16, VREDMAXU_VS, 0x7 }, // 8491
  { PseudoVREDMAXU_VS_MF2_E16_MASK, VREDMAXU_VS, 0x7 }, // 8492
  { PseudoVREDMAXU_VS_MF2_E32, VREDMAXU_VS, 0x7 }, // 8493
  { PseudoVREDMAXU_VS_MF2_E32_MASK, VREDMAXU_VS, 0x7 }, // 8494
  { PseudoVREDMAXU_VS_MF2_E8, VREDMAXU_VS, 0x7 }, // 8495
  { PseudoVREDMAXU_VS_MF2_E8_MASK, VREDMAXU_VS, 0x7 }, // 8496
  { PseudoVREDMAX_VS_M1_E16, VREDMAX_VS, 0x0 }, // 8497
  { PseudoVREDMAX_VS_M1_E16_MASK, VREDMAX_VS, 0x0 }, // 8498
  { PseudoVREDMAX_VS_M1_E32, VREDMAX_VS, 0x0 }, // 8499
  { PseudoVREDMAX_VS_M1_E32_MASK, VREDMAX_VS, 0x0 }, // 8500
  { PseudoVREDMAX_VS_M1_E64, VREDMAX_VS, 0x0 }, // 8501
  { PseudoVREDMAX_VS_M1_E64_MASK, VREDMAX_VS, 0x0 }, // 8502
  { PseudoVREDMAX_VS_M1_E8, VREDMAX_VS, 0x0 }, // 8503
  { PseudoVREDMAX_VS_M1_E8_MASK, VREDMAX_VS, 0x0 }, // 8504
  { PseudoVREDMAX_VS_M2_E16, VREDMAX_VS, 0x1 }, // 8505
  { PseudoVREDMAX_VS_M2_E16_MASK, VREDMAX_VS, 0x1 }, // 8506
  { PseudoVREDMAX_VS_M2_E32, VREDMAX_VS, 0x1 }, // 8507
  { PseudoVREDMAX_VS_M2_E32_MASK, VREDMAX_VS, 0x1 }, // 8508
  { PseudoVREDMAX_VS_M2_E64, VREDMAX_VS, 0x1 }, // 8509
  { PseudoVREDMAX_VS_M2_E64_MASK, VREDMAX_VS, 0x1 }, // 8510
  { PseudoVREDMAX_VS_M2_E8, VREDMAX_VS, 0x1 }, // 8511
  { PseudoVREDMAX_VS_M2_E8_MASK, VREDMAX_VS, 0x1 }, // 8512
  { PseudoVREDMAX_VS_M4_E16, VREDMAX_VS, 0x2 }, // 8513
  { PseudoVREDMAX_VS_M4_E16_MASK, VREDMAX_VS, 0x2 }, // 8514
  { PseudoVREDMAX_VS_M4_E32, VREDMAX_VS, 0x2 }, // 8515
  { PseudoVREDMAX_VS_M4_E32_MASK, VREDMAX_VS, 0x2 }, // 8516
  { PseudoVREDMAX_VS_M4_E64, VREDMAX_VS, 0x2 }, // 8517
  { PseudoVREDMAX_VS_M4_E64_MASK, VREDMAX_VS, 0x2 }, // 8518
  { PseudoVREDMAX_VS_M4_E8, VREDMAX_VS, 0x2 }, // 8519
  { PseudoVREDMAX_VS_M4_E8_MASK, VREDMAX_VS, 0x2 }, // 8520
  { PseudoVREDMAX_VS_M8_E16, VREDMAX_VS, 0x3 }, // 8521
  { PseudoVREDMAX_VS_M8_E16_MASK, VREDMAX_VS, 0x3 }, // 8522
  { PseudoVREDMAX_VS_M8_E32, VREDMAX_VS, 0x3 }, // 8523
  { PseudoVREDMAX_VS_M8_E32_MASK, VREDMAX_VS, 0x3 }, // 8524
  { PseudoVREDMAX_VS_M8_E64, VREDMAX_VS, 0x3 }, // 8525
  { PseudoVREDMAX_VS_M8_E64_MASK, VREDMAX_VS, 0x3 }, // 8526
  { PseudoVREDMAX_VS_M8_E8, VREDMAX_VS, 0x3 }, // 8527
  { PseudoVREDMAX_VS_M8_E8_MASK, VREDMAX_VS, 0x3 }, // 8528
  { PseudoVREDMAX_VS_MF8_E8, VREDMAX_VS, 0x5 }, // 8529
  { PseudoVREDMAX_VS_MF8_E8_MASK, VREDMAX_VS, 0x5 }, // 8530
  { PseudoVREDMAX_VS_MF4_E16, VREDMAX_VS, 0x6 }, // 8531
  { PseudoVREDMAX_VS_MF4_E16_MASK, VREDMAX_VS, 0x6 }, // 8532
  { PseudoVREDMAX_VS_MF4_E8, VREDMAX_VS, 0x6 }, // 8533
  { PseudoVREDMAX_VS_MF4_E8_MASK, VREDMAX_VS, 0x6 }, // 8534
  { PseudoVREDMAX_VS_MF2_E16, VREDMAX_VS, 0x7 }, // 8535
  { PseudoVREDMAX_VS_MF2_E16_MASK, VREDMAX_VS, 0x7 }, // 8536
  { PseudoVREDMAX_VS_MF2_E32, VREDMAX_VS, 0x7 }, // 8537
  { PseudoVREDMAX_VS_MF2_E32_MASK, VREDMAX_VS, 0x7 }, // 8538
  { PseudoVREDMAX_VS_MF2_E8, VREDMAX_VS, 0x7 }, // 8539
  { PseudoVREDMAX_VS_MF2_E8_MASK, VREDMAX_VS, 0x7 }, // 8540
  { PseudoVREDMINU_VS_M1_E16, VREDMINU_VS, 0x0 }, // 8541
  { PseudoVREDMINU_VS_M1_E16_MASK, VREDMINU_VS, 0x0 }, // 8542
  { PseudoVREDMINU_VS_M1_E32, VREDMINU_VS, 0x0 }, // 8543
  { PseudoVREDMINU_VS_M1_E32_MASK, VREDMINU_VS, 0x0 }, // 8544
  { PseudoVREDMINU_VS_M1_E64, VREDMINU_VS, 0x0 }, // 8545
  { PseudoVREDMINU_VS_M1_E64_MASK, VREDMINU_VS, 0x0 }, // 8546
  { PseudoVREDMINU_VS_M1_E8, VREDMINU_VS, 0x0 }, // 8547
  { PseudoVREDMINU_VS_M1_E8_MASK, VREDMINU_VS, 0x0 }, // 8548
  { PseudoVREDMINU_VS_M2_E16, VREDMINU_VS, 0x1 }, // 8549
  { PseudoVREDMINU_VS_M2_E16_MASK, VREDMINU_VS, 0x1 }, // 8550
  { PseudoVREDMINU_VS_M2_E32, VREDMINU_VS, 0x1 }, // 8551
  { PseudoVREDMINU_VS_M2_E32_MASK, VREDMINU_VS, 0x1 }, // 8552
  { PseudoVREDMINU_VS_M2_E64, VREDMINU_VS, 0x1 }, // 8553
  { PseudoVREDMINU_VS_M2_E64_MASK, VREDMINU_VS, 0x1 }, // 8554
  { PseudoVREDMINU_VS_M2_E8, VREDMINU_VS, 0x1 }, // 8555
  { PseudoVREDMINU_VS_M2_E8_MASK, VREDMINU_VS, 0x1 }, // 8556
  { PseudoVREDMINU_VS_M4_E16, VREDMINU_VS, 0x2 }, // 8557
  { PseudoVREDMINU_VS_M4_E16_MASK, VREDMINU_VS, 0x2 }, // 8558
  { PseudoVREDMINU_VS_M4_E32, VREDMINU_VS, 0x2 }, // 8559
  { PseudoVREDMINU_VS_M4_E32_MASK, VREDMINU_VS, 0x2 }, // 8560
  { PseudoVREDMINU_VS_M4_E64, VREDMINU_VS, 0x2 }, // 8561
  { PseudoVREDMINU_VS_M4_E64_MASK, VREDMINU_VS, 0x2 }, // 8562
  { PseudoVREDMINU_VS_M4_E8, VREDMINU_VS, 0x2 }, // 8563
  { PseudoVREDMINU_VS_M4_E8_MASK, VREDMINU_VS, 0x2 }, // 8564
  { PseudoVREDMINU_VS_M8_E16, VREDMINU_VS, 0x3 }, // 8565
  { PseudoVREDMINU_VS_M8_E16_MASK, VREDMINU_VS, 0x3 }, // 8566
  { PseudoVREDMINU_VS_M8_E32, VREDMINU_VS, 0x3 }, // 8567
  { PseudoVREDMINU_VS_M8_E32_MASK, VREDMINU_VS, 0x3 }, // 8568
  { PseudoVREDMINU_VS_M8_E64, VREDMINU_VS, 0x3 }, // 8569
  { PseudoVREDMINU_VS_M8_E64_MASK, VREDMINU_VS, 0x3 }, // 8570
  { PseudoVREDMINU_VS_M8_E8, VREDMINU_VS, 0x3 }, // 8571
  { PseudoVREDMINU_VS_M8_E8_MASK, VREDMINU_VS, 0x3 }, // 8572
  { PseudoVREDMINU_VS_MF8_E8, VREDMINU_VS, 0x5 }, // 8573
  { PseudoVREDMINU_VS_MF8_E8_MASK, VREDMINU_VS, 0x5 }, // 8574
  { PseudoVREDMINU_VS_MF4_E16, VREDMINU_VS, 0x6 }, // 8575
  { PseudoVREDMINU_VS_MF4_E16_MASK, VREDMINU_VS, 0x6 }, // 8576
  { PseudoVREDMINU_VS_MF4_E8, VREDMINU_VS, 0x6 }, // 8577
  { PseudoVREDMINU_VS_MF4_E8_MASK, VREDMINU_VS, 0x6 }, // 8578
  { PseudoVREDMINU_VS_MF2_E16, VREDMINU_VS, 0x7 }, // 8579
  { PseudoVREDMINU_VS_MF2_E16_MASK, VREDMINU_VS, 0x7 }, // 8580
  { PseudoVREDMINU_VS_MF2_E32, VREDMINU_VS, 0x7 }, // 8581
  { PseudoVREDMINU_VS_MF2_E32_MASK, VREDMINU_VS, 0x7 }, // 8582
  { PseudoVREDMINU_VS_MF2_E8, VREDMINU_VS, 0x7 }, // 8583
  { PseudoVREDMINU_VS_MF2_E8_MASK, VREDMINU_VS, 0x7 }, // 8584
  { PseudoVREDMIN_VS_M1_E16, VREDMIN_VS, 0x0 }, // 8585
  { PseudoVREDMIN_VS_M1_E16_MASK, VREDMIN_VS, 0x0 }, // 8586
  { PseudoVREDMIN_VS_M1_E32, VREDMIN_VS, 0x0 }, // 8587
  { PseudoVREDMIN_VS_M1_E32_MASK, VREDMIN_VS, 0x0 }, // 8588
  { PseudoVREDMIN_VS_M1_E64, VREDMIN_VS, 0x0 }, // 8589
  { PseudoVREDMIN_VS_M1_E64_MASK, VREDMIN_VS, 0x0 }, // 8590
  { PseudoVREDMIN_VS_M1_E8, VREDMIN_VS, 0x0 }, // 8591
  { PseudoVREDMIN_VS_M1_E8_MASK, VREDMIN_VS, 0x0 }, // 8592
  { PseudoVREDMIN_VS_M2_E16, VREDMIN_VS, 0x1 }, // 8593
  { PseudoVREDMIN_VS_M2_E16_MASK, VREDMIN_VS, 0x1 }, // 8594
  { PseudoVREDMIN_VS_M2_E32, VREDMIN_VS, 0x1 }, // 8595
  { PseudoVREDMIN_VS_M2_E32_MASK, VREDMIN_VS, 0x1 }, // 8596
  { PseudoVREDMIN_VS_M2_E64, VREDMIN_VS, 0x1 }, // 8597
  { PseudoVREDMIN_VS_M2_E64_MASK, VREDMIN_VS, 0x1 }, // 8598
  { PseudoVREDMIN_VS_M2_E8, VREDMIN_VS, 0x1 }, // 8599
  { PseudoVREDMIN_VS_M2_E8_MASK, VREDMIN_VS, 0x1 }, // 8600
  { PseudoVREDMIN_VS_M4_E16, VREDMIN_VS, 0x2 }, // 8601
  { PseudoVREDMIN_VS_M4_E16_MASK, VREDMIN_VS, 0x2 }, // 8602
  { PseudoVREDMIN_VS_M4_E32, VREDMIN_VS, 0x2 }, // 8603
  { PseudoVREDMIN_VS_M4_E32_MASK, VREDMIN_VS, 0x2 }, // 8604
  { PseudoVREDMIN_VS_M4_E64, VREDMIN_VS, 0x2 }, // 8605
  { PseudoVREDMIN_VS_M4_E64_MASK, VREDMIN_VS, 0x2 }, // 8606
  { PseudoVREDMIN_VS_M4_E8, VREDMIN_VS, 0x2 }, // 8607
  { PseudoVREDMIN_VS_M4_E8_MASK, VREDMIN_VS, 0x2 }, // 8608
  { PseudoVREDMIN_VS_M8_E16, VREDMIN_VS, 0x3 }, // 8609
  { PseudoVREDMIN_VS_M8_E16_MASK, VREDMIN_VS, 0x3 }, // 8610
  { PseudoVREDMIN_VS_M8_E32, VREDMIN_VS, 0x3 }, // 8611
  { PseudoVREDMIN_VS_M8_E32_MASK, VREDMIN_VS, 0x3 }, // 8612
  { PseudoVREDMIN_VS_M8_E64, VREDMIN_VS, 0x3 }, // 8613
  { PseudoVREDMIN_VS_M8_E64_MASK, VREDMIN_VS, 0x3 }, // 8614
  { PseudoVREDMIN_VS_M8_E8, VREDMIN_VS, 0x3 }, // 8615
  { PseudoVREDMIN_VS_M8_E8_MASK, VREDMIN_VS, 0x3 }, // 8616
  { PseudoVREDMIN_VS_MF8_E8, VREDMIN_VS, 0x5 }, // 8617
  { PseudoVREDMIN_VS_MF8_E8_MASK, VREDMIN_VS, 0x5 }, // 8618
  { PseudoVREDMIN_VS_MF4_E16, VREDMIN_VS, 0x6 }, // 8619
  { PseudoVREDMIN_VS_MF4_E16_MASK, VREDMIN_VS, 0x6 }, // 8620
  { PseudoVREDMIN_VS_MF4_E8, VREDMIN_VS, 0x6 }, // 8621
  { PseudoVREDMIN_VS_MF4_E8_MASK, VREDMIN_VS, 0x6 }, // 8622
  { PseudoVREDMIN_VS_MF2_E16, VREDMIN_VS, 0x7 }, // 8623
  { PseudoVREDMIN_VS_MF2_E16_MASK, VREDMIN_VS, 0x7 }, // 8624
  { PseudoVREDMIN_VS_MF2_E32, VREDMIN_VS, 0x7 }, // 8625
  { PseudoVREDMIN_VS_MF2_E32_MASK, VREDMIN_VS, 0x7 }, // 8626
  { PseudoVREDMIN_VS_MF2_E8, VREDMIN_VS, 0x7 }, // 8627
  { PseudoVREDMIN_VS_MF2_E8_MASK, VREDMIN_VS, 0x7 }, // 8628
  { PseudoVREDOR_VS_M1_E16, VREDOR_VS, 0x0 }, // 8629
  { PseudoVREDOR_VS_M1_E16_MASK, VREDOR_VS, 0x0 }, // 8630
  { PseudoVREDOR_VS_M1_E32, VREDOR_VS, 0x0 }, // 8631
  { PseudoVREDOR_VS_M1_E32_MASK, VREDOR_VS, 0x0 }, // 8632
  { PseudoVREDOR_VS_M1_E64, VREDOR_VS, 0x0 }, // 8633
  { PseudoVREDOR_VS_M1_E64_MASK, VREDOR_VS, 0x0 }, // 8634
  { PseudoVREDOR_VS_M1_E8, VREDOR_VS, 0x0 }, // 8635
  { PseudoVREDOR_VS_M1_E8_MASK, VREDOR_VS, 0x0 }, // 8636
  { PseudoVREDOR_VS_M2_E16, VREDOR_VS, 0x1 }, // 8637
  { PseudoVREDOR_VS_M2_E16_MASK, VREDOR_VS, 0x1 }, // 8638
  { PseudoVREDOR_VS_M2_E32, VREDOR_VS, 0x1 }, // 8639
  { PseudoVREDOR_VS_M2_E32_MASK, VREDOR_VS, 0x1 }, // 8640
  { PseudoVREDOR_VS_M2_E64, VREDOR_VS, 0x1 }, // 8641
  { PseudoVREDOR_VS_M2_E64_MASK, VREDOR_VS, 0x1 }, // 8642
  { PseudoVREDOR_VS_M2_E8, VREDOR_VS, 0x1 }, // 8643
  { PseudoVREDOR_VS_M2_E8_MASK, VREDOR_VS, 0x1 }, // 8644
  { PseudoVREDOR_VS_M4_E16, VREDOR_VS, 0x2 }, // 8645
  { PseudoVREDOR_VS_M4_E16_MASK, VREDOR_VS, 0x2 }, // 8646
  { PseudoVREDOR_VS_M4_E32, VREDOR_VS, 0x2 }, // 8647
  { PseudoVREDOR_VS_M4_E32_MASK, VREDOR_VS, 0x2 }, // 8648
  { PseudoVREDOR_VS_M4_E64, VREDOR_VS, 0x2 }, // 8649
  { PseudoVREDOR_VS_M4_E64_MASK, VREDOR_VS, 0x2 }, // 8650
  { PseudoVREDOR_VS_M4_E8, VREDOR_VS, 0x2 }, // 8651
  { PseudoVREDOR_VS_M4_E8_MASK, VREDOR_VS, 0x2 }, // 8652
  { PseudoVREDOR_VS_M8_E16, VREDOR_VS, 0x3 }, // 8653
  { PseudoVREDOR_VS_M8_E16_MASK, VREDOR_VS, 0x3 }, // 8654
  { PseudoVREDOR_VS_M8_E32, VREDOR_VS, 0x3 }, // 8655
  { PseudoVREDOR_VS_M8_E32_MASK, VREDOR_VS, 0x3 }, // 8656
  { PseudoVREDOR_VS_M8_E64, VREDOR_VS, 0x3 }, // 8657
  { PseudoVREDOR_VS_M8_E64_MASK, VREDOR_VS, 0x3 }, // 8658
  { PseudoVREDOR_VS_M8_E8, VREDOR_VS, 0x3 }, // 8659
  { PseudoVREDOR_VS_M8_E8_MASK, VREDOR_VS, 0x3 }, // 8660
  { PseudoVREDOR_VS_MF8_E8, VREDOR_VS, 0x5 }, // 8661
  { PseudoVREDOR_VS_MF8_E8_MASK, VREDOR_VS, 0x5 }, // 8662
  { PseudoVREDOR_VS_MF4_E16, VREDOR_VS, 0x6 }, // 8663
  { PseudoVREDOR_VS_MF4_E16_MASK, VREDOR_VS, 0x6 }, // 8664
  { PseudoVREDOR_VS_MF4_E8, VREDOR_VS, 0x6 }, // 8665
  { PseudoVREDOR_VS_MF4_E8_MASK, VREDOR_VS, 0x6 }, // 8666
  { PseudoVREDOR_VS_MF2_E16, VREDOR_VS, 0x7 }, // 8667
  { PseudoVREDOR_VS_MF2_E16_MASK, VREDOR_VS, 0x7 }, // 8668
  { PseudoVREDOR_VS_MF2_E32, VREDOR_VS, 0x7 }, // 8669
  { PseudoVREDOR_VS_MF2_E32_MASK, VREDOR_VS, 0x7 }, // 8670
  { PseudoVREDOR_VS_MF2_E8, VREDOR_VS, 0x7 }, // 8671
  { PseudoVREDOR_VS_MF2_E8_MASK, VREDOR_VS, 0x7 }, // 8672
  { PseudoVREDSUM_VS_M1_E16, VREDSUM_VS, 0x0 }, // 8673
  { PseudoVREDSUM_VS_M1_E16_MASK, VREDSUM_VS, 0x0 }, // 8674
  { PseudoVREDSUM_VS_M1_E32, VREDSUM_VS, 0x0 }, // 8675
  { PseudoVREDSUM_VS_M1_E32_MASK, VREDSUM_VS, 0x0 }, // 8676
  { PseudoVREDSUM_VS_M1_E64, VREDSUM_VS, 0x0 }, // 8677
  { PseudoVREDSUM_VS_M1_E64_MASK, VREDSUM_VS, 0x0 }, // 8678
  { PseudoVREDSUM_VS_M1_E8, VREDSUM_VS, 0x0 }, // 8679
  { PseudoVREDSUM_VS_M1_E8_MASK, VREDSUM_VS, 0x0 }, // 8680
  { PseudoVREDSUM_VS_M2_E16, VREDSUM_VS, 0x1 }, // 8681
  { PseudoVREDSUM_VS_M2_E16_MASK, VREDSUM_VS, 0x1 }, // 8682
  { PseudoVREDSUM_VS_M2_E32, VREDSUM_VS, 0x1 }, // 8683
  { PseudoVREDSUM_VS_M2_E32_MASK, VREDSUM_VS, 0x1 }, // 8684
  { PseudoVREDSUM_VS_M2_E64, VREDSUM_VS, 0x1 }, // 8685
  { PseudoVREDSUM_VS_M2_E64_MASK, VREDSUM_VS, 0x1 }, // 8686
  { PseudoVREDSUM_VS_M2_E8, VREDSUM_VS, 0x1 }, // 8687
  { PseudoVREDSUM_VS_M2_E8_MASK, VREDSUM_VS, 0x1 }, // 8688
  { PseudoVREDSUM_VS_M4_E16, VREDSUM_VS, 0x2 }, // 8689
  { PseudoVREDSUM_VS_M4_E16_MASK, VREDSUM_VS, 0x2 }, // 8690
  { PseudoVREDSUM_VS_M4_E32, VREDSUM_VS, 0x2 }, // 8691
  { PseudoVREDSUM_VS_M4_E32_MASK, VREDSUM_VS, 0x2 }, // 8692
  { PseudoVREDSUM_VS_M4_E64, VREDSUM_VS, 0x2 }, // 8693
  { PseudoVREDSUM_VS_M4_E64_MASK, VREDSUM_VS, 0x2 }, // 8694
  { PseudoVREDSUM_VS_M4_E8, VREDSUM_VS, 0x2 }, // 8695
  { PseudoVREDSUM_VS_M4_E8_MASK, VREDSUM_VS, 0x2 }, // 8696
  { PseudoVREDSUM_VS_M8_E16, VREDSUM_VS, 0x3 }, // 8697
  { PseudoVREDSUM_VS_M8_E16_MASK, VREDSUM_VS, 0x3 }, // 8698
  { PseudoVREDSUM_VS_M8_E32, VREDSUM_VS, 0x3 }, // 8699
  { PseudoVREDSUM_VS_M8_E32_MASK, VREDSUM_VS, 0x3 }, // 8700
  { PseudoVREDSUM_VS_M8_E64, VREDSUM_VS, 0x3 }, // 8701
  { PseudoVREDSUM_VS_M8_E64_MASK, VREDSUM_VS, 0x3 }, // 8702
  { PseudoVREDSUM_VS_M8_E8, VREDSUM_VS, 0x3 }, // 8703
  { PseudoVREDSUM_VS_M8_E8_MASK, VREDSUM_VS, 0x3 }, // 8704
  { PseudoVREDSUM_VS_MF8_E8, VREDSUM_VS, 0x5 }, // 8705
  { PseudoVREDSUM_VS_MF8_E8_MASK, VREDSUM_VS, 0x5 }, // 8706
  { PseudoVREDSUM_VS_MF4_E16, VREDSUM_VS, 0x6 }, // 8707
  { PseudoVREDSUM_VS_MF4_E16_MASK, VREDSUM_VS, 0x6 }, // 8708
  { PseudoVREDSUM_VS_MF4_E8, VREDSUM_VS, 0x6 }, // 8709
  { PseudoVREDSUM_VS_MF4_E8_MASK, VREDSUM_VS, 0x6 }, // 8710
  { PseudoVREDSUM_VS_MF2_E16, VREDSUM_VS, 0x7 }, // 8711
  { PseudoVREDSUM_VS_MF2_E16_MASK, VREDSUM_VS, 0x7 }, // 8712
  { PseudoVREDSUM_VS_MF2_E32, VREDSUM_VS, 0x7 }, // 8713
  { PseudoVREDSUM_VS_MF2_E32_MASK, VREDSUM_VS, 0x7 }, // 8714
  { PseudoVREDSUM_VS_MF2_E8, VREDSUM_VS, 0x7 }, // 8715
  { PseudoVREDSUM_VS_MF2_E8_MASK, VREDSUM_VS, 0x7 }, // 8716
  { PseudoVREDXOR_VS_M1_E16, VREDXOR_VS, 0x0 }, // 8717
  { PseudoVREDXOR_VS_M1_E16_MASK, VREDXOR_VS, 0x0 }, // 8718
  { PseudoVREDXOR_VS_M1_E32, VREDXOR_VS, 0x0 }, // 8719
  { PseudoVREDXOR_VS_M1_E32_MASK, VREDXOR_VS, 0x0 }, // 8720
  { PseudoVREDXOR_VS_M1_E64, VREDXOR_VS, 0x0 }, // 8721
  { PseudoVREDXOR_VS_M1_E64_MASK, VREDXOR_VS, 0x0 }, // 8722
  { PseudoVREDXOR_VS_M1_E8, VREDXOR_VS, 0x0 }, // 8723
  { PseudoVREDXOR_VS_M1_E8_MASK, VREDXOR_VS, 0x0 }, // 8724
  { PseudoVREDXOR_VS_M2_E16, VREDXOR_VS, 0x1 }, // 8725
  { PseudoVREDXOR_VS_M2_E16_MASK, VREDXOR_VS, 0x1 }, // 8726
  { PseudoVREDXOR_VS_M2_E32, VREDXOR_VS, 0x1 }, // 8727
  { PseudoVREDXOR_VS_M2_E32_MASK, VREDXOR_VS, 0x1 }, // 8728
  { PseudoVREDXOR_VS_M2_E64, VREDXOR_VS, 0x1 }, // 8729
  { PseudoVREDXOR_VS_M2_E64_MASK, VREDXOR_VS, 0x1 }, // 8730
  { PseudoVREDXOR_VS_M2_E8, VREDXOR_VS, 0x1 }, // 8731
  { PseudoVREDXOR_VS_M2_E8_MASK, VREDXOR_VS, 0x1 }, // 8732
  { PseudoVREDXOR_VS_M4_E16, VREDXOR_VS, 0x2 }, // 8733
  { PseudoVREDXOR_VS_M4_E16_MASK, VREDXOR_VS, 0x2 }, // 8734
  { PseudoVREDXOR_VS_M4_E32, VREDXOR_VS, 0x2 }, // 8735
  { PseudoVREDXOR_VS_M4_E32_MASK, VREDXOR_VS, 0x2 }, // 8736
  { PseudoVREDXOR_VS_M4_E64, VREDXOR_VS, 0x2 }, // 8737
  { PseudoVREDXOR_VS_M4_E64_MASK, VREDXOR_VS, 0x2 }, // 8738
  { PseudoVREDXOR_VS_M4_E8, VREDXOR_VS, 0x2 }, // 8739
  { PseudoVREDXOR_VS_M4_E8_MASK, VREDXOR_VS, 0x2 }, // 8740
  { PseudoVREDXOR_VS_M8_E16, VREDXOR_VS, 0x3 }, // 8741
  { PseudoVREDXOR_VS_M8_E16_MASK, VREDXOR_VS, 0x3 }, // 8742
  { PseudoVREDXOR_VS_M8_E32, VREDXOR_VS, 0x3 }, // 8743
  { PseudoVREDXOR_VS_M8_E32_MASK, VREDXOR_VS, 0x3 }, // 8744
  { PseudoVREDXOR_VS_M8_E64, VREDXOR_VS, 0x3 }, // 8745
  { PseudoVREDXOR_VS_M8_E64_MASK, VREDXOR_VS, 0x3 }, // 8746
  { PseudoVREDXOR_VS_M8_E8, VREDXOR_VS, 0x3 }, // 8747
  { PseudoVREDXOR_VS_M8_E8_MASK, VREDXOR_VS, 0x3 }, // 8748
  { PseudoVREDXOR_VS_MF8_E8, VREDXOR_VS, 0x5 }, // 8749
  { PseudoVREDXOR_VS_MF8_E8_MASK, VREDXOR_VS, 0x5 }, // 8750
  { PseudoVREDXOR_VS_MF4_E16, VREDXOR_VS, 0x6 }, // 8751
  { PseudoVREDXOR_VS_MF4_E16_MASK, VREDXOR_VS, 0x6 }, // 8752
  { PseudoVREDXOR_VS_MF4_E8, VREDXOR_VS, 0x6 }, // 8753
  { PseudoVREDXOR_VS_MF4_E8_MASK, VREDXOR_VS, 0x6 }, // 8754
  { PseudoVREDXOR_VS_MF2_E16, VREDXOR_VS, 0x7 }, // 8755
  { PseudoVREDXOR_VS_MF2_E16_MASK, VREDXOR_VS, 0x7 }, // 8756
  { PseudoVREDXOR_VS_MF2_E32, VREDXOR_VS, 0x7 }, // 8757
  { PseudoVREDXOR_VS_MF2_E32_MASK, VREDXOR_VS, 0x7 }, // 8758
  { PseudoVREDXOR_VS_MF2_E8, VREDXOR_VS, 0x7 }, // 8759
  { PseudoVREDXOR_VS_MF2_E8_MASK, VREDXOR_VS, 0x7 }, // 8760
  { PseudoVREMU_VV_M1_E16, VREMU_VV, 0x0 }, // 8761
  { PseudoVREMU_VV_M1_E16_MASK, VREMU_VV, 0x0 }, // 8762
  { PseudoVREMU_VV_M1_E16_TU, VREMU_VV, 0x0 }, // 8763
  { PseudoVREMU_VV_M1_E32, VREMU_VV, 0x0 }, // 8764
  { PseudoVREMU_VV_M1_E32_MASK, VREMU_VV, 0x0 }, // 8765
  { PseudoVREMU_VV_M1_E32_TU, VREMU_VV, 0x0 }, // 8766
  { PseudoVREMU_VV_M1_E64, VREMU_VV, 0x0 }, // 8767
  { PseudoVREMU_VV_M1_E64_MASK, VREMU_VV, 0x0 }, // 8768
  { PseudoVREMU_VV_M1_E64_TU, VREMU_VV, 0x0 }, // 8769
  { PseudoVREMU_VV_M1_E8, VREMU_VV, 0x0 }, // 8770
  { PseudoVREMU_VV_M1_E8_MASK, VREMU_VV, 0x0 }, // 8771
  { PseudoVREMU_VV_M1_E8_TU, VREMU_VV, 0x0 }, // 8772
  { PseudoVREMU_VV_M2_E16, VREMU_VV, 0x1 }, // 8773
  { PseudoVREMU_VV_M2_E16_MASK, VREMU_VV, 0x1 }, // 8774
  { PseudoVREMU_VV_M2_E16_TU, VREMU_VV, 0x1 }, // 8775
  { PseudoVREMU_VV_M2_E32, VREMU_VV, 0x1 }, // 8776
  { PseudoVREMU_VV_M2_E32_MASK, VREMU_VV, 0x1 }, // 8777
  { PseudoVREMU_VV_M2_E32_TU, VREMU_VV, 0x1 }, // 8778
  { PseudoVREMU_VV_M2_E64, VREMU_VV, 0x1 }, // 8779
  { PseudoVREMU_VV_M2_E64_MASK, VREMU_VV, 0x1 }, // 8780
  { PseudoVREMU_VV_M2_E64_TU, VREMU_VV, 0x1 }, // 8781
  { PseudoVREMU_VV_M2_E8, VREMU_VV, 0x1 }, // 8782
  { PseudoVREMU_VV_M2_E8_MASK, VREMU_VV, 0x1 }, // 8783
  { PseudoVREMU_VV_M2_E8_TU, VREMU_VV, 0x1 }, // 8784
  { PseudoVREMU_VV_M4_E16, VREMU_VV, 0x2 }, // 8785
  { PseudoVREMU_VV_M4_E16_MASK, VREMU_VV, 0x2 }, // 8786
  { PseudoVREMU_VV_M4_E16_TU, VREMU_VV, 0x2 }, // 8787
  { PseudoVREMU_VV_M4_E32, VREMU_VV, 0x2 }, // 8788
  { PseudoVREMU_VV_M4_E32_MASK, VREMU_VV, 0x2 }, // 8789
  { PseudoVREMU_VV_M4_E32_TU, VREMU_VV, 0x2 }, // 8790
  { PseudoVREMU_VV_M4_E64, VREMU_VV, 0x2 }, // 8791
  { PseudoVREMU_VV_M4_E64_MASK, VREMU_VV, 0x2 }, // 8792
  { PseudoVREMU_VV_M4_E64_TU, VREMU_VV, 0x2 }, // 8793
  { PseudoVREMU_VV_M4_E8, VREMU_VV, 0x2 }, // 8794
  { PseudoVREMU_VV_M4_E8_MASK, VREMU_VV, 0x2 }, // 8795
  { PseudoVREMU_VV_M4_E8_TU, VREMU_VV, 0x2 }, // 8796
  { PseudoVREMU_VV_M8_E16, VREMU_VV, 0x3 }, // 8797
  { PseudoVREMU_VV_M8_E16_MASK, VREMU_VV, 0x3 }, // 8798
  { PseudoVREMU_VV_M8_E16_TU, VREMU_VV, 0x3 }, // 8799
  { PseudoVREMU_VV_M8_E32, VREMU_VV, 0x3 }, // 8800
  { PseudoVREMU_VV_M8_E32_MASK, VREMU_VV, 0x3 }, // 8801
  { PseudoVREMU_VV_M8_E32_TU, VREMU_VV, 0x3 }, // 8802
  { PseudoVREMU_VV_M8_E64, VREMU_VV, 0x3 }, // 8803
  { PseudoVREMU_VV_M8_E64_MASK, VREMU_VV, 0x3 }, // 8804
  { PseudoVREMU_VV_M8_E64_TU, VREMU_VV, 0x3 }, // 8805
  { PseudoVREMU_VV_M8_E8, VREMU_VV, 0x3 }, // 8806
  { PseudoVREMU_VV_M8_E8_MASK, VREMU_VV, 0x3 }, // 8807
  { PseudoVREMU_VV_M8_E8_TU, VREMU_VV, 0x3 }, // 8808
  { PseudoVREMU_VV_MF8_E8, VREMU_VV, 0x5 }, // 8809
  { PseudoVREMU_VV_MF8_E8_MASK, VREMU_VV, 0x5 }, // 8810
  { PseudoVREMU_VV_MF8_E8_TU, VREMU_VV, 0x5 }, // 8811
  { PseudoVREMU_VV_MF4_E16, VREMU_VV, 0x6 }, // 8812
  { PseudoVREMU_VV_MF4_E16_MASK, VREMU_VV, 0x6 }, // 8813
  { PseudoVREMU_VV_MF4_E16_TU, VREMU_VV, 0x6 }, // 8814
  { PseudoVREMU_VV_MF4_E8, VREMU_VV, 0x6 }, // 8815
  { PseudoVREMU_VV_MF4_E8_MASK, VREMU_VV, 0x6 }, // 8816
  { PseudoVREMU_VV_MF4_E8_TU, VREMU_VV, 0x6 }, // 8817
  { PseudoVREMU_VV_MF2_E16, VREMU_VV, 0x7 }, // 8818
  { PseudoVREMU_VV_MF2_E16_MASK, VREMU_VV, 0x7 }, // 8819
  { PseudoVREMU_VV_MF2_E16_TU, VREMU_VV, 0x7 }, // 8820
  { PseudoVREMU_VV_MF2_E32, VREMU_VV, 0x7 }, // 8821
  { PseudoVREMU_VV_MF2_E32_MASK, VREMU_VV, 0x7 }, // 8822
  { PseudoVREMU_VV_MF2_E32_TU, VREMU_VV, 0x7 }, // 8823
  { PseudoVREMU_VV_MF2_E8, VREMU_VV, 0x7 }, // 8824
  { PseudoVREMU_VV_MF2_E8_MASK, VREMU_VV, 0x7 }, // 8825
  { PseudoVREMU_VV_MF2_E8_TU, VREMU_VV, 0x7 }, // 8826
  { PseudoVREMU_VX_M1_E16, VREMU_VX, 0x0 }, // 8827
  { PseudoVREMU_VX_M1_E16_MASK, VREMU_VX, 0x0 }, // 8828
  { PseudoVREMU_VX_M1_E16_TU, VREMU_VX, 0x0 }, // 8829
  { PseudoVREMU_VX_M1_E32, VREMU_VX, 0x0 }, // 8830
  { PseudoVREMU_VX_M1_E32_MASK, VREMU_VX, 0x0 }, // 8831
  { PseudoVREMU_VX_M1_E32_TU, VREMU_VX, 0x0 }, // 8832
  { PseudoVREMU_VX_M1_E64, VREMU_VX, 0x0 }, // 8833
  { PseudoVREMU_VX_M1_E64_MASK, VREMU_VX, 0x0 }, // 8834
  { PseudoVREMU_VX_M1_E64_TU, VREMU_VX, 0x0 }, // 8835
  { PseudoVREMU_VX_M1_E8, VREMU_VX, 0x0 }, // 8836
  { PseudoVREMU_VX_M1_E8_MASK, VREMU_VX, 0x0 }, // 8837
  { PseudoVREMU_VX_M1_E8_TU, VREMU_VX, 0x0 }, // 8838
  { PseudoVREMU_VX_M2_E16, VREMU_VX, 0x1 }, // 8839
  { PseudoVREMU_VX_M2_E16_MASK, VREMU_VX, 0x1 }, // 8840
  { PseudoVREMU_VX_M2_E16_TU, VREMU_VX, 0x1 }, // 8841
  { PseudoVREMU_VX_M2_E32, VREMU_VX, 0x1 }, // 8842
  { PseudoVREMU_VX_M2_E32_MASK, VREMU_VX, 0x1 }, // 8843
  { PseudoVREMU_VX_M2_E32_TU, VREMU_VX, 0x1 }, // 8844
  { PseudoVREMU_VX_M2_E64, VREMU_VX, 0x1 }, // 8845
  { PseudoVREMU_VX_M2_E64_MASK, VREMU_VX, 0x1 }, // 8846
  { PseudoVREMU_VX_M2_E64_TU, VREMU_VX, 0x1 }, // 8847
  { PseudoVREMU_VX_M2_E8, VREMU_VX, 0x1 }, // 8848
  { PseudoVREMU_VX_M2_E8_MASK, VREMU_VX, 0x1 }, // 8849
  { PseudoVREMU_VX_M2_E8_TU, VREMU_VX, 0x1 }, // 8850
  { PseudoVREMU_VX_M4_E16, VREMU_VX, 0x2 }, // 8851
  { PseudoVREMU_VX_M4_E16_MASK, VREMU_VX, 0x2 }, // 8852
  { PseudoVREMU_VX_M4_E16_TU, VREMU_VX, 0x2 }, // 8853
  { PseudoVREMU_VX_M4_E32, VREMU_VX, 0x2 }, // 8854
  { PseudoVREMU_VX_M4_E32_MASK, VREMU_VX, 0x2 }, // 8855
  { PseudoVREMU_VX_M4_E32_TU, VREMU_VX, 0x2 }, // 8856
  { PseudoVREMU_VX_M4_E64, VREMU_VX, 0x2 }, // 8857
  { PseudoVREMU_VX_M4_E64_MASK, VREMU_VX, 0x2 }, // 8858
  { PseudoVREMU_VX_M4_E64_TU, VREMU_VX, 0x2 }, // 8859
  { PseudoVREMU_VX_M4_E8, VREMU_VX, 0x2 }, // 8860
  { PseudoVREMU_VX_M4_E8_MASK, VREMU_VX, 0x2 }, // 8861
  { PseudoVREMU_VX_M4_E8_TU, VREMU_VX, 0x2 }, // 8862
  { PseudoVREMU_VX_M8_E16, VREMU_VX, 0x3 }, // 8863
  { PseudoVREMU_VX_M8_E16_MASK, VREMU_VX, 0x3 }, // 8864
  { PseudoVREMU_VX_M8_E16_TU, VREMU_VX, 0x3 }, // 8865
  { PseudoVREMU_VX_M8_E32, VREMU_VX, 0x3 }, // 8866
  { PseudoVREMU_VX_M8_E32_MASK, VREMU_VX, 0x3 }, // 8867
  { PseudoVREMU_VX_M8_E32_TU, VREMU_VX, 0x3 }, // 8868
  { PseudoVREMU_VX_M8_E64, VREMU_VX, 0x3 }, // 8869
  { PseudoVREMU_VX_M8_E64_MASK, VREMU_VX, 0x3 }, // 8870
  { PseudoVREMU_VX_M8_E64_TU, VREMU_VX, 0x3 }, // 8871
  { PseudoVREMU_VX_M8_E8, VREMU_VX, 0x3 }, // 8872
  { PseudoVREMU_VX_M8_E8_MASK, VREMU_VX, 0x3 }, // 8873
  { PseudoVREMU_VX_M8_E8_TU, VREMU_VX, 0x3 }, // 8874
  { PseudoVREMU_VX_MF8_E8, VREMU_VX, 0x5 }, // 8875
  { PseudoVREMU_VX_MF8_E8_MASK, VREMU_VX, 0x5 }, // 8876
  { PseudoVREMU_VX_MF8_E8_TU, VREMU_VX, 0x5 }, // 8877
  { PseudoVREMU_VX_MF4_E16, VREMU_VX, 0x6 }, // 8878
  { PseudoVREMU_VX_MF4_E16_MASK, VREMU_VX, 0x6 }, // 8879
  { PseudoVREMU_VX_MF4_E16_TU, VREMU_VX, 0x6 }, // 8880
  { PseudoVREMU_VX_MF4_E8, VREMU_VX, 0x6 }, // 8881
  { PseudoVREMU_VX_MF4_E8_MASK, VREMU_VX, 0x6 }, // 8882
  { PseudoVREMU_VX_MF4_E8_TU, VREMU_VX, 0x6 }, // 8883
  { PseudoVREMU_VX_MF2_E16, VREMU_VX, 0x7 }, // 8884
  { PseudoVREMU_VX_MF2_E16_MASK, VREMU_VX, 0x7 }, // 8885
  { PseudoVREMU_VX_MF2_E16_TU, VREMU_VX, 0x7 }, // 8886
  { PseudoVREMU_VX_MF2_E32, VREMU_VX, 0x7 }, // 8887
  { PseudoVREMU_VX_MF2_E32_MASK, VREMU_VX, 0x7 }, // 8888
  { PseudoVREMU_VX_MF2_E32_TU, VREMU_VX, 0x7 }, // 8889
  { PseudoVREMU_VX_MF2_E8, VREMU_VX, 0x7 }, // 8890
  { PseudoVREMU_VX_MF2_E8_MASK, VREMU_VX, 0x7 }, // 8891
  { PseudoVREMU_VX_MF2_E8_TU, VREMU_VX, 0x7 }, // 8892
  { PseudoVREM_VV_M1_E16, VREM_VV, 0x0 }, // 8893
  { PseudoVREM_VV_M1_E16_MASK, VREM_VV, 0x0 }, // 8894
  { PseudoVREM_VV_M1_E16_TU, VREM_VV, 0x0 }, // 8895
  { PseudoVREM_VV_M1_E32, VREM_VV, 0x0 }, // 8896
  { PseudoVREM_VV_M1_E32_MASK, VREM_VV, 0x0 }, // 8897
  { PseudoVREM_VV_M1_E32_TU, VREM_VV, 0x0 }, // 8898
  { PseudoVREM_VV_M1_E64, VREM_VV, 0x0 }, // 8899
  { PseudoVREM_VV_M1_E64_MASK, VREM_VV, 0x0 }, // 8900
  { PseudoVREM_VV_M1_E64_TU, VREM_VV, 0x0 }, // 8901
  { PseudoVREM_VV_M1_E8, VREM_VV, 0x0 }, // 8902
  { PseudoVREM_VV_M1_E8_MASK, VREM_VV, 0x0 }, // 8903
  { PseudoVREM_VV_M1_E8_TU, VREM_VV, 0x0 }, // 8904
  { PseudoVREM_VV_M2_E16, VREM_VV, 0x1 }, // 8905
  { PseudoVREM_VV_M2_E16_MASK, VREM_VV, 0x1 }, // 8906
  { PseudoVREM_VV_M2_E16_TU, VREM_VV, 0x1 }, // 8907
  { PseudoVREM_VV_M2_E32, VREM_VV, 0x1 }, // 8908
  { PseudoVREM_VV_M2_E32_MASK, VREM_VV, 0x1 }, // 8909
  { PseudoVREM_VV_M2_E32_TU, VREM_VV, 0x1 }, // 8910
  { PseudoVREM_VV_M2_E64, VREM_VV, 0x1 }, // 8911
  { PseudoVREM_VV_M2_E64_MASK, VREM_VV, 0x1 }, // 8912
  { PseudoVREM_VV_M2_E64_TU, VREM_VV, 0x1 }, // 8913
  { PseudoVREM_VV_M2_E8, VREM_VV, 0x1 }, // 8914
  { PseudoVREM_VV_M2_E8_MASK, VREM_VV, 0x1 }, // 8915
  { PseudoVREM_VV_M2_E8_TU, VREM_VV, 0x1 }, // 8916
  { PseudoVREM_VV_M4_E16, VREM_VV, 0x2 }, // 8917
  { PseudoVREM_VV_M4_E16_MASK, VREM_VV, 0x2 }, // 8918
  { PseudoVREM_VV_M4_E16_TU, VREM_VV, 0x2 }, // 8919
  { PseudoVREM_VV_M4_E32, VREM_VV, 0x2 }, // 8920
  { PseudoVREM_VV_M4_E32_MASK, VREM_VV, 0x2 }, // 8921
  { PseudoVREM_VV_M4_E32_TU, VREM_VV, 0x2 }, // 8922
  { PseudoVREM_VV_M4_E64, VREM_VV, 0x2 }, // 8923
  { PseudoVREM_VV_M4_E64_MASK, VREM_VV, 0x2 }, // 8924
  { PseudoVREM_VV_M4_E64_TU, VREM_VV, 0x2 }, // 8925
  { PseudoVREM_VV_M4_E8, VREM_VV, 0x2 }, // 8926
  { PseudoVREM_VV_M4_E8_MASK, VREM_VV, 0x2 }, // 8927
  { PseudoVREM_VV_M4_E8_TU, VREM_VV, 0x2 }, // 8928
  { PseudoVREM_VV_M8_E16, VREM_VV, 0x3 }, // 8929
  { PseudoVREM_VV_M8_E16_MASK, VREM_VV, 0x3 }, // 8930
  { PseudoVREM_VV_M8_E16_TU, VREM_VV, 0x3 }, // 8931
  { PseudoVREM_VV_M8_E32, VREM_VV, 0x3 }, // 8932
  { PseudoVREM_VV_M8_E32_MASK, VREM_VV, 0x3 }, // 8933
  { PseudoVREM_VV_M8_E32_TU, VREM_VV, 0x3 }, // 8934
  { PseudoVREM_VV_M8_E64, VREM_VV, 0x3 }, // 8935
  { PseudoVREM_VV_M8_E64_MASK, VREM_VV, 0x3 }, // 8936
  { PseudoVREM_VV_M8_E64_TU, VREM_VV, 0x3 }, // 8937
  { PseudoVREM_VV_M8_E8, VREM_VV, 0x3 }, // 8938
  { PseudoVREM_VV_M8_E8_MASK, VREM_VV, 0x3 }, // 8939
  { PseudoVREM_VV_M8_E8_TU, VREM_VV, 0x3 }, // 8940
  { PseudoVREM_VV_MF8_E8, VREM_VV, 0x5 }, // 8941
  { PseudoVREM_VV_MF8_E8_MASK, VREM_VV, 0x5 }, // 8942
  { PseudoVREM_VV_MF8_E8_TU, VREM_VV, 0x5 }, // 8943
  { PseudoVREM_VV_MF4_E16, VREM_VV, 0x6 }, // 8944
  { PseudoVREM_VV_MF4_E16_MASK, VREM_VV, 0x6 }, // 8945
  { PseudoVREM_VV_MF4_E16_TU, VREM_VV, 0x6 }, // 8946
  { PseudoVREM_VV_MF4_E8, VREM_VV, 0x6 }, // 8947
  { PseudoVREM_VV_MF4_E8_MASK, VREM_VV, 0x6 }, // 8948
  { PseudoVREM_VV_MF4_E8_TU, VREM_VV, 0x6 }, // 8949
  { PseudoVREM_VV_MF2_E16, VREM_VV, 0x7 }, // 8950
  { PseudoVREM_VV_MF2_E16_MASK, VREM_VV, 0x7 }, // 8951
  { PseudoVREM_VV_MF2_E16_TU, VREM_VV, 0x7 }, // 8952
  { PseudoVREM_VV_MF2_E32, VREM_VV, 0x7 }, // 8953
  { PseudoVREM_VV_MF2_E32_MASK, VREM_VV, 0x7 }, // 8954
  { PseudoVREM_VV_MF2_E32_TU, VREM_VV, 0x7 }, // 8955
  { PseudoVREM_VV_MF2_E8, VREM_VV, 0x7 }, // 8956
  { PseudoVREM_VV_MF2_E8_MASK, VREM_VV, 0x7 }, // 8957
  { PseudoVREM_VV_MF2_E8_TU, VREM_VV, 0x7 }, // 8958
  { PseudoVREM_VX_M1_E16, VREM_VX, 0x0 }, // 8959
  { PseudoVREM_VX_M1_E16_MASK, VREM_VX, 0x0 }, // 8960
  { PseudoVREM_VX_M1_E16_TU, VREM_VX, 0x0 }, // 8961
  { PseudoVREM_VX_M1_E32, VREM_VX, 0x0 }, // 8962
  { PseudoVREM_VX_M1_E32_MASK, VREM_VX, 0x0 }, // 8963
  { PseudoVREM_VX_M1_E32_TU, VREM_VX, 0x0 }, // 8964
  { PseudoVREM_VX_M1_E64, VREM_VX, 0x0 }, // 8965
  { PseudoVREM_VX_M1_E64_MASK, VREM_VX, 0x0 }, // 8966
  { PseudoVREM_VX_M1_E64_TU, VREM_VX, 0x0 }, // 8967
  { PseudoVREM_VX_M1_E8, VREM_VX, 0x0 }, // 8968
  { PseudoVREM_VX_M1_E8_MASK, VREM_VX, 0x0 }, // 8969
  { PseudoVREM_VX_M1_E8_TU, VREM_VX, 0x0 }, // 8970
  { PseudoVREM_VX_M2_E16, VREM_VX, 0x1 }, // 8971
  { PseudoVREM_VX_M2_E16_MASK, VREM_VX, 0x1 }, // 8972
  { PseudoVREM_VX_M2_E16_TU, VREM_VX, 0x1 }, // 8973
  { PseudoVREM_VX_M2_E32, VREM_VX, 0x1 }, // 8974
  { PseudoVREM_VX_M2_E32_MASK, VREM_VX, 0x1 }, // 8975
  { PseudoVREM_VX_M2_E32_TU, VREM_VX, 0x1 }, // 8976
  { PseudoVREM_VX_M2_E64, VREM_VX, 0x1 }, // 8977
  { PseudoVREM_VX_M2_E64_MASK, VREM_VX, 0x1 }, // 8978
  { PseudoVREM_VX_M2_E64_TU, VREM_VX, 0x1 }, // 8979
  { PseudoVREM_VX_M2_E8, VREM_VX, 0x1 }, // 8980
  { PseudoVREM_VX_M2_E8_MASK, VREM_VX, 0x1 }, // 8981
  { PseudoVREM_VX_M2_E8_TU, VREM_VX, 0x1 }, // 8982
  { PseudoVREM_VX_M4_E16, VREM_VX, 0x2 }, // 8983
  { PseudoVREM_VX_M4_E16_MASK, VREM_VX, 0x2 }, // 8984
  { PseudoVREM_VX_M4_E16_TU, VREM_VX, 0x2 }, // 8985
  { PseudoVREM_VX_M4_E32, VREM_VX, 0x2 }, // 8986
  { PseudoVREM_VX_M4_E32_MASK, VREM_VX, 0x2 }, // 8987
  { PseudoVREM_VX_M4_E32_TU, VREM_VX, 0x2 }, // 8988
  { PseudoVREM_VX_M4_E64, VREM_VX, 0x2 }, // 8989
  { PseudoVREM_VX_M4_E64_MASK, VREM_VX, 0x2 }, // 8990
  { PseudoVREM_VX_M4_E64_TU, VREM_VX, 0x2 }, // 8991
  { PseudoVREM_VX_M4_E8, VREM_VX, 0x2 }, // 8992
  { PseudoVREM_VX_M4_E8_MASK, VREM_VX, 0x2 }, // 8993
  { PseudoVREM_VX_M4_E8_TU, VREM_VX, 0x2 }, // 8994
  { PseudoVREM_VX_M8_E16, VREM_VX, 0x3 }, // 8995
  { PseudoVREM_VX_M8_E16_MASK, VREM_VX, 0x3 }, // 8996
  { PseudoVREM_VX_M8_E16_TU, VREM_VX, 0x3 }, // 8997
  { PseudoVREM_VX_M8_E32, VREM_VX, 0x3 }, // 8998
  { PseudoVREM_VX_M8_E32_MASK, VREM_VX, 0x3 }, // 8999
  { PseudoVREM_VX_M8_E32_TU, VREM_VX, 0x3 }, // 9000
  { PseudoVREM_VX_M8_E64, VREM_VX, 0x3 }, // 9001
  { PseudoVREM_VX_M8_E64_MASK, VREM_VX, 0x3 }, // 9002
  { PseudoVREM_VX_M8_E64_TU, VREM_VX, 0x3 }, // 9003
  { PseudoVREM_VX_M8_E8, VREM_VX, 0x3 }, // 9004
  { PseudoVREM_VX_M8_E8_MASK, VREM_VX, 0x3 }, // 9005
  { PseudoVREM_VX_M8_E8_TU, VREM_VX, 0x3 }, // 9006
  { PseudoVREM_VX_MF8_E8, VREM_VX, 0x5 }, // 9007
  { PseudoVREM_VX_MF8_E8_MASK, VREM_VX, 0x5 }, // 9008
  { PseudoVREM_VX_MF8_E8_TU, VREM_VX, 0x5 }, // 9009
  { PseudoVREM_VX_MF4_E16, VREM_VX, 0x6 }, // 9010
  { PseudoVREM_VX_MF4_E16_MASK, VREM_VX, 0x6 }, // 9011
  { PseudoVREM_VX_MF4_E16_TU, VREM_VX, 0x6 }, // 9012
  { PseudoVREM_VX_MF4_E8, VREM_VX, 0x6 }, // 9013
  { PseudoVREM_VX_MF4_E8_MASK, VREM_VX, 0x6 }, // 9014
  { PseudoVREM_VX_MF4_E8_TU, VREM_VX, 0x6 }, // 9015
  { PseudoVREM_VX_MF2_E16, VREM_VX, 0x7 }, // 9016
  { PseudoVREM_VX_MF2_E16_MASK, VREM_VX, 0x7 }, // 9017
  { PseudoVREM_VX_MF2_E16_TU, VREM_VX, 0x7 }, // 9018
  { PseudoVREM_VX_MF2_E32, VREM_VX, 0x7 }, // 9019
  { PseudoVREM_VX_MF2_E32_MASK, VREM_VX, 0x7 }, // 9020
  { PseudoVREM_VX_MF2_E32_TU, VREM_VX, 0x7 }, // 9021
  { PseudoVREM_VX_MF2_E8, VREM_VX, 0x7 }, // 9022
  { PseudoVREM_VX_MF2_E8_MASK, VREM_VX, 0x7 }, // 9023
  { PseudoVREM_VX_MF2_E8_TU, VREM_VX, 0x7 }, // 9024
  { PseudoVRGATHEREI16_VV_M1_E16_M1, VRGATHEREI16_VV, 0x0 }, // 9025
  { PseudoVRGATHEREI16_VV_M1_E16_M1_MASK, VRGATHEREI16_VV, 0x0 }, // 9026
  { PseudoVRGATHEREI16_VV_M1_E16_M1_TU, VRGATHEREI16_VV, 0x0 }, // 9027
  { PseudoVRGATHEREI16_VV_M1_E16_M2, VRGATHEREI16_VV, 0x0 }, // 9028
  { PseudoVRGATHEREI16_VV_M1_E16_M2_MASK, VRGATHEREI16_VV, 0x0 }, // 9029
  { PseudoVRGATHEREI16_VV_M1_E16_M2_TU, VRGATHEREI16_VV, 0x0 }, // 9030
  { PseudoVRGATHEREI16_VV_M1_E16_MF2, VRGATHEREI16_VV, 0x0 }, // 9031
  { PseudoVRGATHEREI16_VV_M1_E16_MF2_MASK, VRGATHEREI16_VV, 0x0 }, // 9032
  { PseudoVRGATHEREI16_VV_M1_E16_MF2_TU, VRGATHEREI16_VV, 0x0 }, // 9033
  { PseudoVRGATHEREI16_VV_M1_E16_MF4, VRGATHEREI16_VV, 0x0 }, // 9034
  { PseudoVRGATHEREI16_VV_M1_E16_MF4_MASK, VRGATHEREI16_VV, 0x0 }, // 9035
  { PseudoVRGATHEREI16_VV_M1_E16_MF4_TU, VRGATHEREI16_VV, 0x0 }, // 9036
  { PseudoVRGATHEREI16_VV_M1_E32_M1, VRGATHEREI16_VV, 0x0 }, // 9037
  { PseudoVRGATHEREI16_VV_M1_E32_M1_MASK, VRGATHEREI16_VV, 0x0 }, // 9038
  { PseudoVRGATHEREI16_VV_M1_E32_M1_TU, VRGATHEREI16_VV, 0x0 }, // 9039
  { PseudoVRGATHEREI16_VV_M1_E32_M2, VRGATHEREI16_VV, 0x0 }, // 9040
  { PseudoVRGATHEREI16_VV_M1_E32_M2_MASK, VRGATHEREI16_VV, 0x0 }, // 9041
  { PseudoVRGATHEREI16_VV_M1_E32_M2_TU, VRGATHEREI16_VV, 0x0 }, // 9042
  { PseudoVRGATHEREI16_VV_M1_E32_MF2, VRGATHEREI16_VV, 0x0 }, // 9043
  { PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK, VRGATHEREI16_VV, 0x0 }, // 9044
  { PseudoVRGATHEREI16_VV_M1_E32_MF2_TU, VRGATHEREI16_VV, 0x0 }, // 9045
  { PseudoVRGATHEREI16_VV_M1_E32_MF4, VRGATHEREI16_VV, 0x0 }, // 9046
  { PseudoVRGATHEREI16_VV_M1_E32_MF4_MASK, VRGATHEREI16_VV, 0x0 }, // 9047
  { PseudoVRGATHEREI16_VV_M1_E32_MF4_TU, VRGATHEREI16_VV, 0x0 }, // 9048
  { PseudoVRGATHEREI16_VV_M1_E64_M1, VRGATHEREI16_VV, 0x0 }, // 9049
  { PseudoVRGATHEREI16_VV_M1_E64_M1_MASK, VRGATHEREI16_VV, 0x0 }, // 9050
  { PseudoVRGATHEREI16_VV_M1_E64_M1_TU, VRGATHEREI16_VV, 0x0 }, // 9051
  { PseudoVRGATHEREI16_VV_M1_E64_M2, VRGATHEREI16_VV, 0x0 }, // 9052
  { PseudoVRGATHEREI16_VV_M1_E64_M2_MASK, VRGATHEREI16_VV, 0x0 }, // 9053
  { PseudoVRGATHEREI16_VV_M1_E64_M2_TU, VRGATHEREI16_VV, 0x0 }, // 9054
  { PseudoVRGATHEREI16_VV_M1_E64_MF2, VRGATHEREI16_VV, 0x0 }, // 9055
  { PseudoVRGATHEREI16_VV_M1_E64_MF2_MASK, VRGATHEREI16_VV, 0x0 }, // 9056
  { PseudoVRGATHEREI16_VV_M1_E64_MF2_TU, VRGATHEREI16_VV, 0x0 }, // 9057
  { PseudoVRGATHEREI16_VV_M1_E64_MF4, VRGATHEREI16_VV, 0x0 }, // 9058
  { PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK, VRGATHEREI16_VV, 0x0 }, // 9059
  { PseudoVRGATHEREI16_VV_M1_E64_MF4_TU, VRGATHEREI16_VV, 0x0 }, // 9060
  { PseudoVRGATHEREI16_VV_M1_E8_M1, VRGATHEREI16_VV, 0x0 }, // 9061
  { PseudoVRGATHEREI16_VV_M1_E8_M1_MASK, VRGATHEREI16_VV, 0x0 }, // 9062
  { PseudoVRGATHEREI16_VV_M1_E8_M1_TU, VRGATHEREI16_VV, 0x0 }, // 9063
  { PseudoVRGATHEREI16_VV_M1_E8_M2, VRGATHEREI16_VV, 0x0 }, // 9064
  { PseudoVRGATHEREI16_VV_M1_E8_M2_MASK, VRGATHEREI16_VV, 0x0 }, // 9065
  { PseudoVRGATHEREI16_VV_M1_E8_M2_TU, VRGATHEREI16_VV, 0x0 }, // 9066
  { PseudoVRGATHEREI16_VV_M1_E8_MF2, VRGATHEREI16_VV, 0x0 }, // 9067
  { PseudoVRGATHEREI16_VV_M1_E8_MF2_MASK, VRGATHEREI16_VV, 0x0 }, // 9068
  { PseudoVRGATHEREI16_VV_M1_E8_MF2_TU, VRGATHEREI16_VV, 0x0 }, // 9069
  { PseudoVRGATHEREI16_VV_M1_E8_MF4, VRGATHEREI16_VV, 0x0 }, // 9070
  { PseudoVRGATHEREI16_VV_M1_E8_MF4_MASK, VRGATHEREI16_VV, 0x0 }, // 9071
  { PseudoVRGATHEREI16_VV_M1_E8_MF4_TU, VRGATHEREI16_VV, 0x0 }, // 9072
  { PseudoVRGATHEREI16_VV_M2_E16_M1, VRGATHEREI16_VV, 0x1 }, // 9073
  { PseudoVRGATHEREI16_VV_M2_E16_M1_MASK, VRGATHEREI16_VV, 0x1 }, // 9074
  { PseudoVRGATHEREI16_VV_M2_E16_M1_TU, VRGATHEREI16_VV, 0x1 }, // 9075
  { PseudoVRGATHEREI16_VV_M2_E16_M2, VRGATHEREI16_VV, 0x1 }, // 9076
  { PseudoVRGATHEREI16_VV_M2_E16_M2_MASK, VRGATHEREI16_VV, 0x1 }, // 9077
  { PseudoVRGATHEREI16_VV_M2_E16_M2_TU, VRGATHEREI16_VV, 0x1 }, // 9078
  { PseudoVRGATHEREI16_VV_M2_E16_M4, VRGATHEREI16_VV, 0x1 }, // 9079
  { PseudoVRGATHEREI16_VV_M2_E16_M4_MASK, VRGATHEREI16_VV, 0x1 }, // 9080
  { PseudoVRGATHEREI16_VV_M2_E16_M4_TU, VRGATHEREI16_VV, 0x1 }, // 9081
  { PseudoVRGATHEREI16_VV_M2_E16_MF2, VRGATHEREI16_VV, 0x1 }, // 9082
  { PseudoVRGATHEREI16_VV_M2_E16_MF2_MASK, VRGATHEREI16_VV, 0x1 }, // 9083
  { PseudoVRGATHEREI16_VV_M2_E16_MF2_TU, VRGATHEREI16_VV, 0x1 }, // 9084
  { PseudoVRGATHEREI16_VV_M2_E32_M1, VRGATHEREI16_VV, 0x1 }, // 9085
  { PseudoVRGATHEREI16_VV_M2_E32_M1_MASK, VRGATHEREI16_VV, 0x1 }, // 9086
  { PseudoVRGATHEREI16_VV_M2_E32_M1_TU, VRGATHEREI16_VV, 0x1 }, // 9087
  { PseudoVRGATHEREI16_VV_M2_E32_M2, VRGATHEREI16_VV, 0x1 }, // 9088
  { PseudoVRGATHEREI16_VV_M2_E32_M2_MASK, VRGATHEREI16_VV, 0x1 }, // 9089
  { PseudoVRGATHEREI16_VV_M2_E32_M2_TU, VRGATHEREI16_VV, 0x1 }, // 9090
  { PseudoVRGATHEREI16_VV_M2_E32_M4, VRGATHEREI16_VV, 0x1 }, // 9091
  { PseudoVRGATHEREI16_VV_M2_E32_M4_MASK, VRGATHEREI16_VV, 0x1 }, // 9092
  { PseudoVRGATHEREI16_VV_M2_E32_M4_TU, VRGATHEREI16_VV, 0x1 }, // 9093
  { PseudoVRGATHEREI16_VV_M2_E32_MF2, VRGATHEREI16_VV, 0x1 }, // 9094
  { PseudoVRGATHEREI16_VV_M2_E32_MF2_MASK, VRGATHEREI16_VV, 0x1 }, // 9095
  { PseudoVRGATHEREI16_VV_M2_E32_MF2_TU, VRGATHEREI16_VV, 0x1 }, // 9096
  { PseudoVRGATHEREI16_VV_M2_E64_M1, VRGATHEREI16_VV, 0x1 }, // 9097
  { PseudoVRGATHEREI16_VV_M2_E64_M1_MASK, VRGATHEREI16_VV, 0x1 }, // 9098
  { PseudoVRGATHEREI16_VV_M2_E64_M1_TU, VRGATHEREI16_VV, 0x1 }, // 9099
  { PseudoVRGATHEREI16_VV_M2_E64_M2, VRGATHEREI16_VV, 0x1 }, // 9100
  { PseudoVRGATHEREI16_VV_M2_E64_M2_MASK, VRGATHEREI16_VV, 0x1 }, // 9101
  { PseudoVRGATHEREI16_VV_M2_E64_M2_TU, VRGATHEREI16_VV, 0x1 }, // 9102
  { PseudoVRGATHEREI16_VV_M2_E64_M4, VRGATHEREI16_VV, 0x1 }, // 9103
  { PseudoVRGATHEREI16_VV_M2_E64_M4_MASK, VRGATHEREI16_VV, 0x1 }, // 9104
  { PseudoVRGATHEREI16_VV_M2_E64_M4_TU, VRGATHEREI16_VV, 0x1 }, // 9105
  { PseudoVRGATHEREI16_VV_M2_E64_MF2, VRGATHEREI16_VV, 0x1 }, // 9106
  { PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK, VRGATHEREI16_VV, 0x1 }, // 9107
  { PseudoVRGATHEREI16_VV_M2_E64_MF2_TU, VRGATHEREI16_VV, 0x1 }, // 9108
  { PseudoVRGATHEREI16_VV_M2_E8_M1, VRGATHEREI16_VV, 0x1 }, // 9109
  { PseudoVRGATHEREI16_VV_M2_E8_M1_MASK, VRGATHEREI16_VV, 0x1 }, // 9110
  { PseudoVRGATHEREI16_VV_M2_E8_M1_TU, VRGATHEREI16_VV, 0x1 }, // 9111
  { PseudoVRGATHEREI16_VV_M2_E8_M2, VRGATHEREI16_VV, 0x1 }, // 9112
  { PseudoVRGATHEREI16_VV_M2_E8_M2_MASK, VRGATHEREI16_VV, 0x1 }, // 9113
  { PseudoVRGATHEREI16_VV_M2_E8_M2_TU, VRGATHEREI16_VV, 0x1 }, // 9114
  { PseudoVRGATHEREI16_VV_M2_E8_M4, VRGATHEREI16_VV, 0x1 }, // 9115
  { PseudoVRGATHEREI16_VV_M2_E8_M4_MASK, VRGATHEREI16_VV, 0x1 }, // 9116
  { PseudoVRGATHEREI16_VV_M2_E8_M4_TU, VRGATHEREI16_VV, 0x1 }, // 9117
  { PseudoVRGATHEREI16_VV_M2_E8_MF2, VRGATHEREI16_VV, 0x1 }, // 9118
  { PseudoVRGATHEREI16_VV_M2_E8_MF2_MASK, VRGATHEREI16_VV, 0x1 }, // 9119
  { PseudoVRGATHEREI16_VV_M2_E8_MF2_TU, VRGATHEREI16_VV, 0x1 }, // 9120
  { PseudoVRGATHEREI16_VV_M4_E16_M1, VRGATHEREI16_VV, 0x2 }, // 9121
  { PseudoVRGATHEREI16_VV_M4_E16_M1_MASK, VRGATHEREI16_VV, 0x2 }, // 9122
  { PseudoVRGATHEREI16_VV_M4_E16_M1_TU, VRGATHEREI16_VV, 0x2 }, // 9123
  { PseudoVRGATHEREI16_VV_M4_E16_M2, VRGATHEREI16_VV, 0x2 }, // 9124
  { PseudoVRGATHEREI16_VV_M4_E16_M2_MASK, VRGATHEREI16_VV, 0x2 }, // 9125
  { PseudoVRGATHEREI16_VV_M4_E16_M2_TU, VRGATHEREI16_VV, 0x2 }, // 9126
  { PseudoVRGATHEREI16_VV_M4_E16_M4, VRGATHEREI16_VV, 0x2 }, // 9127
  { PseudoVRGATHEREI16_VV_M4_E16_M4_MASK, VRGATHEREI16_VV, 0x2 }, // 9128
  { PseudoVRGATHEREI16_VV_M4_E16_M4_TU, VRGATHEREI16_VV, 0x2 }, // 9129
  { PseudoVRGATHEREI16_VV_M4_E16_M8, VRGATHEREI16_VV, 0x2 }, // 9130
  { PseudoVRGATHEREI16_VV_M4_E16_M8_MASK, VRGATHEREI16_VV, 0x2 }, // 9131
  { PseudoVRGATHEREI16_VV_M4_E16_M8_TU, VRGATHEREI16_VV, 0x2 }, // 9132
  { PseudoVRGATHEREI16_VV_M4_E32_M1, VRGATHEREI16_VV, 0x2 }, // 9133
  { PseudoVRGATHEREI16_VV_M4_E32_M1_MASK, VRGATHEREI16_VV, 0x2 }, // 9134
  { PseudoVRGATHEREI16_VV_M4_E32_M1_TU, VRGATHEREI16_VV, 0x2 }, // 9135
  { PseudoVRGATHEREI16_VV_M4_E32_M2, VRGATHEREI16_VV, 0x2 }, // 9136
  { PseudoVRGATHEREI16_VV_M4_E32_M2_MASK, VRGATHEREI16_VV, 0x2 }, // 9137
  { PseudoVRGATHEREI16_VV_M4_E32_M2_TU, VRGATHEREI16_VV, 0x2 }, // 9138
  { PseudoVRGATHEREI16_VV_M4_E32_M4, VRGATHEREI16_VV, 0x2 }, // 9139
  { PseudoVRGATHEREI16_VV_M4_E32_M4_MASK, VRGATHEREI16_VV, 0x2 }, // 9140
  { PseudoVRGATHEREI16_VV_M4_E32_M4_TU, VRGATHEREI16_VV, 0x2 }, // 9141
  { PseudoVRGATHEREI16_VV_M4_E32_M8, VRGATHEREI16_VV, 0x2 }, // 9142
  { PseudoVRGATHEREI16_VV_M4_E32_M8_MASK, VRGATHEREI16_VV, 0x2 }, // 9143
  { PseudoVRGATHEREI16_VV_M4_E32_M8_TU, VRGATHEREI16_VV, 0x2 }, // 9144
  { PseudoVRGATHEREI16_VV_M4_E64_M1, VRGATHEREI16_VV, 0x2 }, // 9145
  { PseudoVRGATHEREI16_VV_M4_E64_M1_MASK, VRGATHEREI16_VV, 0x2 }, // 9146
  { PseudoVRGATHEREI16_VV_M4_E64_M1_TU, VRGATHEREI16_VV, 0x2 }, // 9147
  { PseudoVRGATHEREI16_VV_M4_E64_M2, VRGATHEREI16_VV, 0x2 }, // 9148
  { PseudoVRGATHEREI16_VV_M4_E64_M2_MASK, VRGATHEREI16_VV, 0x2 }, // 9149
  { PseudoVRGATHEREI16_VV_M4_E64_M2_TU, VRGATHEREI16_VV, 0x2 }, // 9150
  { PseudoVRGATHEREI16_VV_M4_E64_M4, VRGATHEREI16_VV, 0x2 }, // 9151
  { PseudoVRGATHEREI16_VV_M4_E64_M4_MASK, VRGATHEREI16_VV, 0x2 }, // 9152
  { PseudoVRGATHEREI16_VV_M4_E64_M4_TU, VRGATHEREI16_VV, 0x2 }, // 9153
  { PseudoVRGATHEREI16_VV_M4_E64_M8, VRGATHEREI16_VV, 0x2 }, // 9154
  { PseudoVRGATHEREI16_VV_M4_E64_M8_MASK, VRGATHEREI16_VV, 0x2 }, // 9155
  { PseudoVRGATHEREI16_VV_M4_E64_M8_TU, VRGATHEREI16_VV, 0x2 }, // 9156
  { PseudoVRGATHEREI16_VV_M4_E8_M1, VRGATHEREI16_VV, 0x2 }, // 9157
  { PseudoVRGATHEREI16_VV_M4_E8_M1_MASK, VRGATHEREI16_VV, 0x2 }, // 9158
  { PseudoVRGATHEREI16_VV_M4_E8_M1_TU, VRGATHEREI16_VV, 0x2 }, // 9159
  { PseudoVRGATHEREI16_VV_M4_E8_M2, VRGATHEREI16_VV, 0x2 }, // 9160
  { PseudoVRGATHEREI16_VV_M4_E8_M2_MASK, VRGATHEREI16_VV, 0x2 }, // 9161
  { PseudoVRGATHEREI16_VV_M4_E8_M2_TU, VRGATHEREI16_VV, 0x2 }, // 9162
  { PseudoVRGATHEREI16_VV_M4_E8_M4, VRGATHEREI16_VV, 0x2 }, // 9163
  { PseudoVRGATHEREI16_VV_M4_E8_M4_MASK, VRGATHEREI16_VV, 0x2 }, // 9164
  { PseudoVRGATHEREI16_VV_M4_E8_M4_TU, VRGATHEREI16_VV, 0x2 }, // 9165
  { PseudoVRGATHEREI16_VV_M4_E8_M8, VRGATHEREI16_VV, 0x2 }, // 9166
  { PseudoVRGATHEREI16_VV_M4_E8_M8_MASK, VRGATHEREI16_VV, 0x2 }, // 9167
  { PseudoVRGATHEREI16_VV_M4_E8_M8_TU, VRGATHEREI16_VV, 0x2 }, // 9168
  { PseudoVRGATHEREI16_VV_M8_E16_M2, VRGATHEREI16_VV, 0x3 }, // 9169
  { PseudoVRGATHEREI16_VV_M8_E16_M2_MASK, VRGATHEREI16_VV, 0x3 }, // 9170
  { PseudoVRGATHEREI16_VV_M8_E16_M2_TU, VRGATHEREI16_VV, 0x3 }, // 9171
  { PseudoVRGATHEREI16_VV_M8_E16_M4, VRGATHEREI16_VV, 0x3 }, // 9172
  { PseudoVRGATHEREI16_VV_M8_E16_M4_MASK, VRGATHEREI16_VV, 0x3 }, // 9173
  { PseudoVRGATHEREI16_VV_M8_E16_M4_TU, VRGATHEREI16_VV, 0x3 }, // 9174
  { PseudoVRGATHEREI16_VV_M8_E16_M8, VRGATHEREI16_VV, 0x3 }, // 9175
  { PseudoVRGATHEREI16_VV_M8_E16_M8_MASK, VRGATHEREI16_VV, 0x3 }, // 9176
  { PseudoVRGATHEREI16_VV_M8_E16_M8_TU, VRGATHEREI16_VV, 0x3 }, // 9177
  { PseudoVRGATHEREI16_VV_M8_E32_M2, VRGATHEREI16_VV, 0x3 }, // 9178
  { PseudoVRGATHEREI16_VV_M8_E32_M2_MASK, VRGATHEREI16_VV, 0x3 }, // 9179
  { PseudoVRGATHEREI16_VV_M8_E32_M2_TU, VRGATHEREI16_VV, 0x3 }, // 9180
  { PseudoVRGATHEREI16_VV_M8_E32_M4, VRGATHEREI16_VV, 0x3 }, // 9181
  { PseudoVRGATHEREI16_VV_M8_E32_M4_MASK, VRGATHEREI16_VV, 0x3 }, // 9182
  { PseudoVRGATHEREI16_VV_M8_E32_M4_TU, VRGATHEREI16_VV, 0x3 }, // 9183
  { PseudoVRGATHEREI16_VV_M8_E32_M8, VRGATHEREI16_VV, 0x3 }, // 9184
  { PseudoVRGATHEREI16_VV_M8_E32_M8_MASK, VRGATHEREI16_VV, 0x3 }, // 9185
  { PseudoVRGATHEREI16_VV_M8_E32_M8_TU, VRGATHEREI16_VV, 0x3 }, // 9186
  { PseudoVRGATHEREI16_VV_M8_E64_M2, VRGATHEREI16_VV, 0x3 }, // 9187
  { PseudoVRGATHEREI16_VV_M8_E64_M2_MASK, VRGATHEREI16_VV, 0x3 }, // 9188
  { PseudoVRGATHEREI16_VV_M8_E64_M2_TU, VRGATHEREI16_VV, 0x3 }, // 9189
  { PseudoVRGATHEREI16_VV_M8_E64_M4, VRGATHEREI16_VV, 0x3 }, // 9190
  { PseudoVRGATHEREI16_VV_M8_E64_M4_MASK, VRGATHEREI16_VV, 0x3 }, // 9191
  { PseudoVRGATHEREI16_VV_M8_E64_M4_TU, VRGATHEREI16_VV, 0x3 }, // 9192
  { PseudoVRGATHEREI16_VV_M8_E64_M8, VRGATHEREI16_VV, 0x3 }, // 9193
  { PseudoVRGATHEREI16_VV_M8_E64_M8_MASK, VRGATHEREI16_VV, 0x3 }, // 9194
  { PseudoVRGATHEREI16_VV_M8_E64_M8_TU, VRGATHEREI16_VV, 0x3 }, // 9195
  { PseudoVRGATHEREI16_VV_M8_E8_M2, VRGATHEREI16_VV, 0x3 }, // 9196
  { PseudoVRGATHEREI16_VV_M8_E8_M2_MASK, VRGATHEREI16_VV, 0x3 }, // 9197
  { PseudoVRGATHEREI16_VV_M8_E8_M2_TU, VRGATHEREI16_VV, 0x3 }, // 9198
  { PseudoVRGATHEREI16_VV_M8_E8_M4, VRGATHEREI16_VV, 0x3 }, // 9199
  { PseudoVRGATHEREI16_VV_M8_E8_M4_MASK, VRGATHEREI16_VV, 0x3 }, // 9200
  { PseudoVRGATHEREI16_VV_M8_E8_M4_TU, VRGATHEREI16_VV, 0x3 }, // 9201
  { PseudoVRGATHEREI16_VV_M8_E8_M8, VRGATHEREI16_VV, 0x3 }, // 9202
  { PseudoVRGATHEREI16_VV_M8_E8_M8_MASK, VRGATHEREI16_VV, 0x3 }, // 9203
  { PseudoVRGATHEREI16_VV_M8_E8_M8_TU, VRGATHEREI16_VV, 0x3 }, // 9204
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4, VRGATHEREI16_VV, 0x5 }, // 9205
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK, VRGATHEREI16_VV, 0x5 }, // 9206
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4_TU, VRGATHEREI16_VV, 0x5 }, // 9207
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8, VRGATHEREI16_VV, 0x5 }, // 9208
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8_MASK, VRGATHEREI16_VV, 0x5 }, // 9209
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8_TU, VRGATHEREI16_VV, 0x5 }, // 9210
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2, VRGATHEREI16_VV, 0x6 }, // 9211
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2_MASK, VRGATHEREI16_VV, 0x6 }, // 9212
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2_TU, VRGATHEREI16_VV, 0x6 }, // 9213
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4, VRGATHEREI16_VV, 0x6 }, // 9214
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK, VRGATHEREI16_VV, 0x6 }, // 9215
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4_TU, VRGATHEREI16_VV, 0x6 }, // 9216
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8, VRGATHEREI16_VV, 0x6 }, // 9217
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8_MASK, VRGATHEREI16_VV, 0x6 }, // 9218
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8_TU, VRGATHEREI16_VV, 0x6 }, // 9219
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2, VRGATHEREI16_VV, 0x6 }, // 9220
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK, VRGATHEREI16_VV, 0x6 }, // 9221
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2_TU, VRGATHEREI16_VV, 0x6 }, // 9222
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4, VRGATHEREI16_VV, 0x6 }, // 9223
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4_MASK, VRGATHEREI16_VV, 0x6 }, // 9224
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4_TU, VRGATHEREI16_VV, 0x6 }, // 9225
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8, VRGATHEREI16_VV, 0x6 }, // 9226
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8_MASK, VRGATHEREI16_VV, 0x6 }, // 9227
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8_TU, VRGATHEREI16_VV, 0x6 }, // 9228
  { PseudoVRGATHEREI16_VV_MF2_E16_M1, VRGATHEREI16_VV, 0x7 }, // 9229
  { PseudoVRGATHEREI16_VV_MF2_E16_M1_MASK, VRGATHEREI16_VV, 0x7 }, // 9230
  { PseudoVRGATHEREI16_VV_MF2_E16_M1_TU, VRGATHEREI16_VV, 0x7 }, // 9231
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2, VRGATHEREI16_VV, 0x7 }, // 9232
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK, VRGATHEREI16_VV, 0x7 }, // 9233
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2_TU, VRGATHEREI16_VV, 0x7 }, // 9234
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4, VRGATHEREI16_VV, 0x7 }, // 9235
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4_MASK, VRGATHEREI16_VV, 0x7 }, // 9236
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4_TU, VRGATHEREI16_VV, 0x7 }, // 9237
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8, VRGATHEREI16_VV, 0x7 }, // 9238
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8_MASK, VRGATHEREI16_VV, 0x7 }, // 9239
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8_TU, VRGATHEREI16_VV, 0x7 }, // 9240
  { PseudoVRGATHEREI16_VV_MF2_E32_M1, VRGATHEREI16_VV, 0x7 }, // 9241
  { PseudoVRGATHEREI16_VV_MF2_E32_M1_MASK, VRGATHEREI16_VV, 0x7 }, // 9242
  { PseudoVRGATHEREI16_VV_MF2_E32_M1_TU, VRGATHEREI16_VV, 0x7 }, // 9243
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2, VRGATHEREI16_VV, 0x7 }, // 9244
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2_MASK, VRGATHEREI16_VV, 0x7 }, // 9245
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2_TU, VRGATHEREI16_VV, 0x7 }, // 9246
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4, VRGATHEREI16_VV, 0x7 }, // 9247
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK, VRGATHEREI16_VV, 0x7 }, // 9248
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4_TU, VRGATHEREI16_VV, 0x7 }, // 9249
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8, VRGATHEREI16_VV, 0x7 }, // 9250
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8_MASK, VRGATHEREI16_VV, 0x7 }, // 9251
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8_TU, VRGATHEREI16_VV, 0x7 }, // 9252
  { PseudoVRGATHEREI16_VV_MF2_E8_M1, VRGATHEREI16_VV, 0x7 }, // 9253
  { PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK, VRGATHEREI16_VV, 0x7 }, // 9254
  { PseudoVRGATHEREI16_VV_MF2_E8_M1_TU, VRGATHEREI16_VV, 0x7 }, // 9255
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2, VRGATHEREI16_VV, 0x7 }, // 9256
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2_MASK, VRGATHEREI16_VV, 0x7 }, // 9257
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2_TU, VRGATHEREI16_VV, 0x7 }, // 9258
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4, VRGATHEREI16_VV, 0x7 }, // 9259
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4_MASK, VRGATHEREI16_VV, 0x7 }, // 9260
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4_TU, VRGATHEREI16_VV, 0x7 }, // 9261
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8, VRGATHEREI16_VV, 0x7 }, // 9262
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8_MASK, VRGATHEREI16_VV, 0x7 }, // 9263
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8_TU, VRGATHEREI16_VV, 0x7 }, // 9264
  { PseudoVRGATHER_VI_M1, VRGATHER_VI, 0x0 }, // 9265
  { PseudoVRGATHER_VI_M1_MASK, VRGATHER_VI, 0x0 }, // 9266
  { PseudoVRGATHER_VI_M1_TU, VRGATHER_VI, 0x0 }, // 9267
  { PseudoVRGATHER_VI_M2, VRGATHER_VI, 0x1 }, // 9268
  { PseudoVRGATHER_VI_M2_MASK, VRGATHER_VI, 0x1 }, // 9269
  { PseudoVRGATHER_VI_M2_TU, VRGATHER_VI, 0x1 }, // 9270
  { PseudoVRGATHER_VI_M4, VRGATHER_VI, 0x2 }, // 9271
  { PseudoVRGATHER_VI_M4_MASK, VRGATHER_VI, 0x2 }, // 9272
  { PseudoVRGATHER_VI_M4_TU, VRGATHER_VI, 0x2 }, // 9273
  { PseudoVRGATHER_VI_M8, VRGATHER_VI, 0x3 }, // 9274
  { PseudoVRGATHER_VI_M8_MASK, VRGATHER_VI, 0x3 }, // 9275
  { PseudoVRGATHER_VI_M8_TU, VRGATHER_VI, 0x3 }, // 9276
  { PseudoVRGATHER_VI_MF8, VRGATHER_VI, 0x5 }, // 9277
  { PseudoVRGATHER_VI_MF8_MASK, VRGATHER_VI, 0x5 }, // 9278
  { PseudoVRGATHER_VI_MF8_TU, VRGATHER_VI, 0x5 }, // 9279
  { PseudoVRGATHER_VI_MF4, VRGATHER_VI, 0x6 }, // 9280
  { PseudoVRGATHER_VI_MF4_MASK, VRGATHER_VI, 0x6 }, // 9281
  { PseudoVRGATHER_VI_MF4_TU, VRGATHER_VI, 0x6 }, // 9282
  { PseudoVRGATHER_VI_MF2, VRGATHER_VI, 0x7 }, // 9283
  { PseudoVRGATHER_VI_MF2_MASK, VRGATHER_VI, 0x7 }, // 9284
  { PseudoVRGATHER_VI_MF2_TU, VRGATHER_VI, 0x7 }, // 9285
  { PseudoVRGATHER_VV_M1_E16, VRGATHER_VV, 0x0 }, // 9286
  { PseudoVRGATHER_VV_M1_E16_MASK, VRGATHER_VV, 0x0 }, // 9287
  { PseudoVRGATHER_VV_M1_E16_TU, VRGATHER_VV, 0x0 }, // 9288
  { PseudoVRGATHER_VV_M1_E32, VRGATHER_VV, 0x0 }, // 9289
  { PseudoVRGATHER_VV_M1_E32_MASK, VRGATHER_VV, 0x0 }, // 9290
  { PseudoVRGATHER_VV_M1_E32_TU, VRGATHER_VV, 0x0 }, // 9291
  { PseudoVRGATHER_VV_M1_E64, VRGATHER_VV, 0x0 }, // 9292
  { PseudoVRGATHER_VV_M1_E64_MASK, VRGATHER_VV, 0x0 }, // 9293
  { PseudoVRGATHER_VV_M1_E64_TU, VRGATHER_VV, 0x0 }, // 9294
  { PseudoVRGATHER_VV_M1_E8, VRGATHER_VV, 0x0 }, // 9295
  { PseudoVRGATHER_VV_M1_E8_MASK, VRGATHER_VV, 0x0 }, // 9296
  { PseudoVRGATHER_VV_M1_E8_TU, VRGATHER_VV, 0x0 }, // 9297
  { PseudoVRGATHER_VV_M2_E16, VRGATHER_VV, 0x1 }, // 9298
  { PseudoVRGATHER_VV_M2_E16_MASK, VRGATHER_VV, 0x1 }, // 9299
  { PseudoVRGATHER_VV_M2_E16_TU, VRGATHER_VV, 0x1 }, // 9300
  { PseudoVRGATHER_VV_M2_E32, VRGATHER_VV, 0x1 }, // 9301
  { PseudoVRGATHER_VV_M2_E32_MASK, VRGATHER_VV, 0x1 }, // 9302
  { PseudoVRGATHER_VV_M2_E32_TU, VRGATHER_VV, 0x1 }, // 9303
  { PseudoVRGATHER_VV_M2_E64, VRGATHER_VV, 0x1 }, // 9304
  { PseudoVRGATHER_VV_M2_E64_MASK, VRGATHER_VV, 0x1 }, // 9305
  { PseudoVRGATHER_VV_M2_E64_TU, VRGATHER_VV, 0x1 }, // 9306
  { PseudoVRGATHER_VV_M2_E8, VRGATHER_VV, 0x1 }, // 9307
  { PseudoVRGATHER_VV_M2_E8_MASK, VRGATHER_VV, 0x1 }, // 9308
  { PseudoVRGATHER_VV_M2_E8_TU, VRGATHER_VV, 0x1 }, // 9309
  { PseudoVRGATHER_VV_M4_E16, VRGATHER_VV, 0x2 }, // 9310
  { PseudoVRGATHER_VV_M4_E16_MASK, VRGATHER_VV, 0x2 }, // 9311
  { PseudoVRGATHER_VV_M4_E16_TU, VRGATHER_VV, 0x2 }, // 9312
  { PseudoVRGATHER_VV_M4_E32, VRGATHER_VV, 0x2 }, // 9313
  { PseudoVRGATHER_VV_M4_E32_MASK, VRGATHER_VV, 0x2 }, // 9314
  { PseudoVRGATHER_VV_M4_E32_TU, VRGATHER_VV, 0x2 }, // 9315
  { PseudoVRGATHER_VV_M4_E64, VRGATHER_VV, 0x2 }, // 9316
  { PseudoVRGATHER_VV_M4_E64_MASK, VRGATHER_VV, 0x2 }, // 9317
  { PseudoVRGATHER_VV_M4_E64_TU, VRGATHER_VV, 0x2 }, // 9318
  { PseudoVRGATHER_VV_M4_E8, VRGATHER_VV, 0x2 }, // 9319
  { PseudoVRGATHER_VV_M4_E8_MASK, VRGATHER_VV, 0x2 }, // 9320
  { PseudoVRGATHER_VV_M4_E8_TU, VRGATHER_VV, 0x2 }, // 9321
  { PseudoVRGATHER_VV_M8_E16, VRGATHER_VV, 0x3 }, // 9322
  { PseudoVRGATHER_VV_M8_E16_MASK, VRGATHER_VV, 0x3 }, // 9323
  { PseudoVRGATHER_VV_M8_E16_TU, VRGATHER_VV, 0x3 }, // 9324
  { PseudoVRGATHER_VV_M8_E32, VRGATHER_VV, 0x3 }, // 9325
  { PseudoVRGATHER_VV_M8_E32_MASK, VRGATHER_VV, 0x3 }, // 9326
  { PseudoVRGATHER_VV_M8_E32_TU, VRGATHER_VV, 0x3 }, // 9327
  { PseudoVRGATHER_VV_M8_E64, VRGATHER_VV, 0x3 }, // 9328
  { PseudoVRGATHER_VV_M8_E64_MASK, VRGATHER_VV, 0x3 }, // 9329
  { PseudoVRGATHER_VV_M8_E64_TU, VRGATHER_VV, 0x3 }, // 9330
  { PseudoVRGATHER_VV_M8_E8, VRGATHER_VV, 0x3 }, // 9331
  { PseudoVRGATHER_VV_M8_E8_MASK, VRGATHER_VV, 0x3 }, // 9332
  { PseudoVRGATHER_VV_M8_E8_TU, VRGATHER_VV, 0x3 }, // 9333
  { PseudoVRGATHER_VV_MF8_E8, VRGATHER_VV, 0x5 }, // 9334
  { PseudoVRGATHER_VV_MF8_E8_MASK, VRGATHER_VV, 0x5 }, // 9335
  { PseudoVRGATHER_VV_MF8_E8_TU, VRGATHER_VV, 0x5 }, // 9336
  { PseudoVRGATHER_VV_MF4_E16, VRGATHER_VV, 0x6 }, // 9337
  { PseudoVRGATHER_VV_MF4_E16_MASK, VRGATHER_VV, 0x6 }, // 9338
  { PseudoVRGATHER_VV_MF4_E16_TU, VRGATHER_VV, 0x6 }, // 9339
  { PseudoVRGATHER_VV_MF4_E8, VRGATHER_VV, 0x6 }, // 9340
  { PseudoVRGATHER_VV_MF4_E8_MASK, VRGATHER_VV, 0x6 }, // 9341
  { PseudoVRGATHER_VV_MF4_E8_TU, VRGATHER_VV, 0x6 }, // 9342
  { PseudoVRGATHER_VV_MF2_E16, VRGATHER_VV, 0x7 }, // 9343
  { PseudoVRGATHER_VV_MF2_E16_MASK, VRGATHER_VV, 0x7 }, // 9344
  { PseudoVRGATHER_VV_MF2_E16_TU, VRGATHER_VV, 0x7 }, // 9345
  { PseudoVRGATHER_VV_MF2_E32, VRGATHER_VV, 0x7 }, // 9346
  { PseudoVRGATHER_VV_MF2_E32_MASK, VRGATHER_VV, 0x7 }, // 9347
  { PseudoVRGATHER_VV_MF2_E32_TU, VRGATHER_VV, 0x7 }, // 9348
  { PseudoVRGATHER_VV_MF2_E8, VRGATHER_VV, 0x7 }, // 9349
  { PseudoVRGATHER_VV_MF2_E8_MASK, VRGATHER_VV, 0x7 }, // 9350
  { PseudoVRGATHER_VV_MF2_E8_TU, VRGATHER_VV, 0x7 }, // 9351
  { PseudoVRGATHER_VX_M1, VRGATHER_VX, 0x0 }, // 9352
  { PseudoVRGATHER_VX_M1_MASK, VRGATHER_VX, 0x0 }, // 9353
  { PseudoVRGATHER_VX_M1_TU, VRGATHER_VX, 0x0 }, // 9354
  { PseudoVRGATHER_VX_M2, VRGATHER_VX, 0x1 }, // 9355
  { PseudoVRGATHER_VX_M2_MASK, VRGATHER_VX, 0x1 }, // 9356
  { PseudoVRGATHER_VX_M2_TU, VRGATHER_VX, 0x1 }, // 9357
  { PseudoVRGATHER_VX_M4, VRGATHER_VX, 0x2 }, // 9358
  { PseudoVRGATHER_VX_M4_MASK, VRGATHER_VX, 0x2 }, // 9359
  { PseudoVRGATHER_VX_M4_TU, VRGATHER_VX, 0x2 }, // 9360
  { PseudoVRGATHER_VX_M8, VRGATHER_VX, 0x3 }, // 9361
  { PseudoVRGATHER_VX_M8_MASK, VRGATHER_VX, 0x3 }, // 9362
  { PseudoVRGATHER_VX_M8_TU, VRGATHER_VX, 0x3 }, // 9363
  { PseudoVRGATHER_VX_MF8, VRGATHER_VX, 0x5 }, // 9364
  { PseudoVRGATHER_VX_MF8_MASK, VRGATHER_VX, 0x5 }, // 9365
  { PseudoVRGATHER_VX_MF8_TU, VRGATHER_VX, 0x5 }, // 9366
  { PseudoVRGATHER_VX_MF4, VRGATHER_VX, 0x6 }, // 9367
  { PseudoVRGATHER_VX_MF4_MASK, VRGATHER_VX, 0x6 }, // 9368
  { PseudoVRGATHER_VX_MF4_TU, VRGATHER_VX, 0x6 }, // 9369
  { PseudoVRGATHER_VX_MF2, VRGATHER_VX, 0x7 }, // 9370
  { PseudoVRGATHER_VX_MF2_MASK, VRGATHER_VX, 0x7 }, // 9371
  { PseudoVRGATHER_VX_MF2_TU, VRGATHER_VX, 0x7 }, // 9372
  { PseudoVRSUB_VI_M1, VRSUB_VI, 0x0 }, // 9373
  { PseudoVRSUB_VI_M1_MASK, VRSUB_VI, 0x0 }, // 9374
  { PseudoVRSUB_VI_M1_TU, VRSUB_VI, 0x0 }, // 9375
  { PseudoVRSUB_VI_M2, VRSUB_VI, 0x1 }, // 9376
  { PseudoVRSUB_VI_M2_MASK, VRSUB_VI, 0x1 }, // 9377
  { PseudoVRSUB_VI_M2_TU, VRSUB_VI, 0x1 }, // 9378
  { PseudoVRSUB_VI_M4, VRSUB_VI, 0x2 }, // 9379
  { PseudoVRSUB_VI_M4_MASK, VRSUB_VI, 0x2 }, // 9380
  { PseudoVRSUB_VI_M4_TU, VRSUB_VI, 0x2 }, // 9381
  { PseudoVRSUB_VI_M8, VRSUB_VI, 0x3 }, // 9382
  { PseudoVRSUB_VI_M8_MASK, VRSUB_VI, 0x3 }, // 9383
  { PseudoVRSUB_VI_M8_TU, VRSUB_VI, 0x3 }, // 9384
  { PseudoVRSUB_VI_MF8, VRSUB_VI, 0x5 }, // 9385
  { PseudoVRSUB_VI_MF8_MASK, VRSUB_VI, 0x5 }, // 9386
  { PseudoVRSUB_VI_MF8_TU, VRSUB_VI, 0x5 }, // 9387
  { PseudoVRSUB_VI_MF4, VRSUB_VI, 0x6 }, // 9388
  { PseudoVRSUB_VI_MF4_MASK, VRSUB_VI, 0x6 }, // 9389
  { PseudoVRSUB_VI_MF4_TU, VRSUB_VI, 0x6 }, // 9390
  { PseudoVRSUB_VI_MF2, VRSUB_VI, 0x7 }, // 9391
  { PseudoVRSUB_VI_MF2_MASK, VRSUB_VI, 0x7 }, // 9392
  { PseudoVRSUB_VI_MF2_TU, VRSUB_VI, 0x7 }, // 9393
  { PseudoVRSUB_VX_M1, VRSUB_VX, 0x0 }, // 9394
  { PseudoVRSUB_VX_M1_MASK, VRSUB_VX, 0x0 }, // 9395
  { PseudoVRSUB_VX_M1_TU, VRSUB_VX, 0x0 }, // 9396
  { PseudoVRSUB_VX_M2, VRSUB_VX, 0x1 }, // 9397
  { PseudoVRSUB_VX_M2_MASK, VRSUB_VX, 0x1 }, // 9398
  { PseudoVRSUB_VX_M2_TU, VRSUB_VX, 0x1 }, // 9399
  { PseudoVRSUB_VX_M4, VRSUB_VX, 0x2 }, // 9400
  { PseudoVRSUB_VX_M4_MASK, VRSUB_VX, 0x2 }, // 9401
  { PseudoVRSUB_VX_M4_TU, VRSUB_VX, 0x2 }, // 9402
  { PseudoVRSUB_VX_M8, VRSUB_VX, 0x3 }, // 9403
  { PseudoVRSUB_VX_M8_MASK, VRSUB_VX, 0x3 }, // 9404
  { PseudoVRSUB_VX_M8_TU, VRSUB_VX, 0x3 }, // 9405
  { PseudoVRSUB_VX_MF8, VRSUB_VX, 0x5 }, // 9406
  { PseudoVRSUB_VX_MF8_MASK, VRSUB_VX, 0x5 }, // 9407
  { PseudoVRSUB_VX_MF8_TU, VRSUB_VX, 0x5 }, // 9408
  { PseudoVRSUB_VX_MF4, VRSUB_VX, 0x6 }, // 9409
  { PseudoVRSUB_VX_MF4_MASK, VRSUB_VX, 0x6 }, // 9410
  { PseudoVRSUB_VX_MF4_TU, VRSUB_VX, 0x6 }, // 9411
  { PseudoVRSUB_VX_MF2, VRSUB_VX, 0x7 }, // 9412
  { PseudoVRSUB_VX_MF2_MASK, VRSUB_VX, 0x7 }, // 9413
  { PseudoVRSUB_VX_MF2_TU, VRSUB_VX, 0x7 }, // 9414
  { PseudoVSADDU_VI_M1, VSADDU_VI, 0x0 }, // 9415
  { PseudoVSADDU_VI_M1_MASK, VSADDU_VI, 0x0 }, // 9416
  { PseudoVSADDU_VI_M1_TU, VSADDU_VI, 0x0 }, // 9417
  { PseudoVSADDU_VI_M2, VSADDU_VI, 0x1 }, // 9418
  { PseudoVSADDU_VI_M2_MASK, VSADDU_VI, 0x1 }, // 9419
  { PseudoVSADDU_VI_M2_TU, VSADDU_VI, 0x1 }, // 9420
  { PseudoVSADDU_VI_M4, VSADDU_VI, 0x2 }, // 9421
  { PseudoVSADDU_VI_M4_MASK, VSADDU_VI, 0x2 }, // 9422
  { PseudoVSADDU_VI_M4_TU, VSADDU_VI, 0x2 }, // 9423
  { PseudoVSADDU_VI_M8, VSADDU_VI, 0x3 }, // 9424
  { PseudoVSADDU_VI_M8_MASK, VSADDU_VI, 0x3 }, // 9425
  { PseudoVSADDU_VI_M8_TU, VSADDU_VI, 0x3 }, // 9426
  { PseudoVSADDU_VI_MF8, VSADDU_VI, 0x5 }, // 9427
  { PseudoVSADDU_VI_MF8_MASK, VSADDU_VI, 0x5 }, // 9428
  { PseudoVSADDU_VI_MF8_TU, VSADDU_VI, 0x5 }, // 9429
  { PseudoVSADDU_VI_MF4, VSADDU_VI, 0x6 }, // 9430
  { PseudoVSADDU_VI_MF4_MASK, VSADDU_VI, 0x6 }, // 9431
  { PseudoVSADDU_VI_MF4_TU, VSADDU_VI, 0x6 }, // 9432
  { PseudoVSADDU_VI_MF2, VSADDU_VI, 0x7 }, // 9433
  { PseudoVSADDU_VI_MF2_MASK, VSADDU_VI, 0x7 }, // 9434
  { PseudoVSADDU_VI_MF2_TU, VSADDU_VI, 0x7 }, // 9435
  { PseudoVSADDU_VV_M1, VSADDU_VV, 0x0 }, // 9436
  { PseudoVSADDU_VV_M1_MASK, VSADDU_VV, 0x0 }, // 9437
  { PseudoVSADDU_VV_M1_TU, VSADDU_VV, 0x0 }, // 9438
  { PseudoVSADDU_VV_M2, VSADDU_VV, 0x1 }, // 9439
  { PseudoVSADDU_VV_M2_MASK, VSADDU_VV, 0x1 }, // 9440
  { PseudoVSADDU_VV_M2_TU, VSADDU_VV, 0x1 }, // 9441
  { PseudoVSADDU_VV_M4, VSADDU_VV, 0x2 }, // 9442
  { PseudoVSADDU_VV_M4_MASK, VSADDU_VV, 0x2 }, // 9443
  { PseudoVSADDU_VV_M4_TU, VSADDU_VV, 0x2 }, // 9444
  { PseudoVSADDU_VV_M8, VSADDU_VV, 0x3 }, // 9445
  { PseudoVSADDU_VV_M8_MASK, VSADDU_VV, 0x3 }, // 9446
  { PseudoVSADDU_VV_M8_TU, VSADDU_VV, 0x3 }, // 9447
  { PseudoVSADDU_VV_MF8, VSADDU_VV, 0x5 }, // 9448
  { PseudoVSADDU_VV_MF8_MASK, VSADDU_VV, 0x5 }, // 9449
  { PseudoVSADDU_VV_MF8_TU, VSADDU_VV, 0x5 }, // 9450
  { PseudoVSADDU_VV_MF4, VSADDU_VV, 0x6 }, // 9451
  { PseudoVSADDU_VV_MF4_MASK, VSADDU_VV, 0x6 }, // 9452
  { PseudoVSADDU_VV_MF4_TU, VSADDU_VV, 0x6 }, // 9453
  { PseudoVSADDU_VV_MF2, VSADDU_VV, 0x7 }, // 9454
  { PseudoVSADDU_VV_MF2_MASK, VSADDU_VV, 0x7 }, // 9455
  { PseudoVSADDU_VV_MF2_TU, VSADDU_VV, 0x7 }, // 9456
  { PseudoVSADDU_VX_M1, VSADDU_VX, 0x0 }, // 9457
  { PseudoVSADDU_VX_M1_MASK, VSADDU_VX, 0x0 }, // 9458
  { PseudoVSADDU_VX_M1_TU, VSADDU_VX, 0x0 }, // 9459
  { PseudoVSADDU_VX_M2, VSADDU_VX, 0x1 }, // 9460
  { PseudoVSADDU_VX_M2_MASK, VSADDU_VX, 0x1 }, // 9461
  { PseudoVSADDU_VX_M2_TU, VSADDU_VX, 0x1 }, // 9462
  { PseudoVSADDU_VX_M4, VSADDU_VX, 0x2 }, // 9463
  { PseudoVSADDU_VX_M4_MASK, VSADDU_VX, 0x2 }, // 9464
  { PseudoVSADDU_VX_M4_TU, VSADDU_VX, 0x2 }, // 9465
  { PseudoVSADDU_VX_M8, VSADDU_VX, 0x3 }, // 9466
  { PseudoVSADDU_VX_M8_MASK, VSADDU_VX, 0x3 }, // 9467
  { PseudoVSADDU_VX_M8_TU, VSADDU_VX, 0x3 }, // 9468
  { PseudoVSADDU_VX_MF8, VSADDU_VX, 0x5 }, // 9469
  { PseudoVSADDU_VX_MF8_MASK, VSADDU_VX, 0x5 }, // 9470
  { PseudoVSADDU_VX_MF8_TU, VSADDU_VX, 0x5 }, // 9471
  { PseudoVSADDU_VX_MF4, VSADDU_VX, 0x6 }, // 9472
  { PseudoVSADDU_VX_MF4_MASK, VSADDU_VX, 0x6 }, // 9473
  { PseudoVSADDU_VX_MF4_TU, VSADDU_VX, 0x6 }, // 9474
  { PseudoVSADDU_VX_MF2, VSADDU_VX, 0x7 }, // 9475
  { PseudoVSADDU_VX_MF2_MASK, VSADDU_VX, 0x7 }, // 9476
  { PseudoVSADDU_VX_MF2_TU, VSADDU_VX, 0x7 }, // 9477
  { PseudoVSADD_VI_M1, VSADD_VI, 0x0 }, // 9478
  { PseudoVSADD_VI_M1_MASK, VSADD_VI, 0x0 }, // 9479
  { PseudoVSADD_VI_M1_TU, VSADD_VI, 0x0 }, // 9480
  { PseudoVSADD_VI_M2, VSADD_VI, 0x1 }, // 9481
  { PseudoVSADD_VI_M2_MASK, VSADD_VI, 0x1 }, // 9482
  { PseudoVSADD_VI_M2_TU, VSADD_VI, 0x1 }, // 9483
  { PseudoVSADD_VI_M4, VSADD_VI, 0x2 }, // 9484
  { PseudoVSADD_VI_M4_MASK, VSADD_VI, 0x2 }, // 9485
  { PseudoVSADD_VI_M4_TU, VSADD_VI, 0x2 }, // 9486
  { PseudoVSADD_VI_M8, VSADD_VI, 0x3 }, // 9487
  { PseudoVSADD_VI_M8_MASK, VSADD_VI, 0x3 }, // 9488
  { PseudoVSADD_VI_M8_TU, VSADD_VI, 0x3 }, // 9489
  { PseudoVSADD_VI_MF8, VSADD_VI, 0x5 }, // 9490
  { PseudoVSADD_VI_MF8_MASK, VSADD_VI, 0x5 }, // 9491
  { PseudoVSADD_VI_MF8_TU, VSADD_VI, 0x5 }, // 9492
  { PseudoVSADD_VI_MF4, VSADD_VI, 0x6 }, // 9493
  { PseudoVSADD_VI_MF4_MASK, VSADD_VI, 0x6 }, // 9494
  { PseudoVSADD_VI_MF4_TU, VSADD_VI, 0x6 }, // 9495
  { PseudoVSADD_VI_MF2, VSADD_VI, 0x7 }, // 9496
  { PseudoVSADD_VI_MF2_MASK, VSADD_VI, 0x7 }, // 9497
  { PseudoVSADD_VI_MF2_TU, VSADD_VI, 0x7 }, // 9498
  { PseudoVSADD_VV_M1, VSADD_VV, 0x0 }, // 9499
  { PseudoVSADD_VV_M1_MASK, VSADD_VV, 0x0 }, // 9500
  { PseudoVSADD_VV_M1_TU, VSADD_VV, 0x0 }, // 9501
  { PseudoVSADD_VV_M2, VSADD_VV, 0x1 }, // 9502
  { PseudoVSADD_VV_M2_MASK, VSADD_VV, 0x1 }, // 9503
  { PseudoVSADD_VV_M2_TU, VSADD_VV, 0x1 }, // 9504
  { PseudoVSADD_VV_M4, VSADD_VV, 0x2 }, // 9505
  { PseudoVSADD_VV_M4_MASK, VSADD_VV, 0x2 }, // 9506
  { PseudoVSADD_VV_M4_TU, VSADD_VV, 0x2 }, // 9507
  { PseudoVSADD_VV_M8, VSADD_VV, 0x3 }, // 9508
  { PseudoVSADD_VV_M8_MASK, VSADD_VV, 0x3 }, // 9509
  { PseudoVSADD_VV_M8_TU, VSADD_VV, 0x3 }, // 9510
  { PseudoVSADD_VV_MF8, VSADD_VV, 0x5 }, // 9511
  { PseudoVSADD_VV_MF8_MASK, VSADD_VV, 0x5 }, // 9512
  { PseudoVSADD_VV_MF8_TU, VSADD_VV, 0x5 }, // 9513
  { PseudoVSADD_VV_MF4, VSADD_VV, 0x6 }, // 9514
  { PseudoVSADD_VV_MF4_MASK, VSADD_VV, 0x6 }, // 9515
  { PseudoVSADD_VV_MF4_TU, VSADD_VV, 0x6 }, // 9516
  { PseudoVSADD_VV_MF2, VSADD_VV, 0x7 }, // 9517
  { PseudoVSADD_VV_MF2_MASK, VSADD_VV, 0x7 }, // 9518
  { PseudoVSADD_VV_MF2_TU, VSADD_VV, 0x7 }, // 9519
  { PseudoVSADD_VX_M1, VSADD_VX, 0x0 }, // 9520
  { PseudoVSADD_VX_M1_MASK, VSADD_VX, 0x0 }, // 9521
  { PseudoVSADD_VX_M1_TU, VSADD_VX, 0x0 }, // 9522
  { PseudoVSADD_VX_M2, VSADD_VX, 0x1 }, // 9523
  { PseudoVSADD_VX_M2_MASK, VSADD_VX, 0x1 }, // 9524
  { PseudoVSADD_VX_M2_TU, VSADD_VX, 0x1 }, // 9525
  { PseudoVSADD_VX_M4, VSADD_VX, 0x2 }, // 9526
  { PseudoVSADD_VX_M4_MASK, VSADD_VX, 0x2 }, // 9527
  { PseudoVSADD_VX_M4_TU, VSADD_VX, 0x2 }, // 9528
  { PseudoVSADD_VX_M8, VSADD_VX, 0x3 }, // 9529
  { PseudoVSADD_VX_M8_MASK, VSADD_VX, 0x3 }, // 9530
  { PseudoVSADD_VX_M8_TU, VSADD_VX, 0x3 }, // 9531
  { PseudoVSADD_VX_MF8, VSADD_VX, 0x5 }, // 9532
  { PseudoVSADD_VX_MF8_MASK, VSADD_VX, 0x5 }, // 9533
  { PseudoVSADD_VX_MF8_TU, VSADD_VX, 0x5 }, // 9534
  { PseudoVSADD_VX_MF4, VSADD_VX, 0x6 }, // 9535
  { PseudoVSADD_VX_MF4_MASK, VSADD_VX, 0x6 }, // 9536
  { PseudoVSADD_VX_MF4_TU, VSADD_VX, 0x6 }, // 9537
  { PseudoVSADD_VX_MF2, VSADD_VX, 0x7 }, // 9538
  { PseudoVSADD_VX_MF2_MASK, VSADD_VX, 0x7 }, // 9539
  { PseudoVSADD_VX_MF2_TU, VSADD_VX, 0x7 }, // 9540
  { PseudoVSBC_VVM_M1, VSBC_VVM, 0x0 }, // 9541
  { PseudoVSBC_VVM_M1_TU, VSBC_VVM, 0x0 }, // 9542
  { PseudoVSBC_VVM_M2, VSBC_VVM, 0x1 }, // 9543
  { PseudoVSBC_VVM_M2_TU, VSBC_VVM, 0x1 }, // 9544
  { PseudoVSBC_VVM_M4, VSBC_VVM, 0x2 }, // 9545
  { PseudoVSBC_VVM_M4_TU, VSBC_VVM, 0x2 }, // 9546
  { PseudoVSBC_VVM_M8, VSBC_VVM, 0x3 }, // 9547
  { PseudoVSBC_VVM_M8_TU, VSBC_VVM, 0x3 }, // 9548
  { PseudoVSBC_VVM_MF8, VSBC_VVM, 0x5 }, // 9549
  { PseudoVSBC_VVM_MF8_TU, VSBC_VVM, 0x5 }, // 9550
  { PseudoVSBC_VVM_MF4, VSBC_VVM, 0x6 }, // 9551
  { PseudoVSBC_VVM_MF4_TU, VSBC_VVM, 0x6 }, // 9552
  { PseudoVSBC_VVM_MF2, VSBC_VVM, 0x7 }, // 9553
  { PseudoVSBC_VVM_MF2_TU, VSBC_VVM, 0x7 }, // 9554
  { PseudoVSBC_VXM_M1, VSBC_VXM, 0x0 }, // 9555
  { PseudoVSBC_VXM_M1_TU, VSBC_VXM, 0x0 }, // 9556
  { PseudoVSBC_VXM_M2, VSBC_VXM, 0x1 }, // 9557
  { PseudoVSBC_VXM_M2_TU, VSBC_VXM, 0x1 }, // 9558
  { PseudoVSBC_VXM_M4, VSBC_VXM, 0x2 }, // 9559
  { PseudoVSBC_VXM_M4_TU, VSBC_VXM, 0x2 }, // 9560
  { PseudoVSBC_VXM_M8, VSBC_VXM, 0x3 }, // 9561
  { PseudoVSBC_VXM_M8_TU, VSBC_VXM, 0x3 }, // 9562
  { PseudoVSBC_VXM_MF8, VSBC_VXM, 0x5 }, // 9563
  { PseudoVSBC_VXM_MF8_TU, VSBC_VXM, 0x5 }, // 9564
  { PseudoVSBC_VXM_MF4, VSBC_VXM, 0x6 }, // 9565
  { PseudoVSBC_VXM_MF4_TU, VSBC_VXM, 0x6 }, // 9566
  { PseudoVSBC_VXM_MF2, VSBC_VXM, 0x7 }, // 9567
  { PseudoVSBC_VXM_MF2_TU, VSBC_VXM, 0x7 }, // 9568
  { PseudoVSE16_V_M1, VSE16_V, 0x0 }, // 9569
  { PseudoVSE16_V_M1_MASK, VSE16_V, 0x0 }, // 9570
  { PseudoVSE16_V_M2, VSE16_V, 0x1 }, // 9571
  { PseudoVSE16_V_M2_MASK, VSE16_V, 0x1 }, // 9572
  { PseudoVSE16_V_M4, VSE16_V, 0x2 }, // 9573
  { PseudoVSE16_V_M4_MASK, VSE16_V, 0x2 }, // 9574
  { PseudoVSE16_V_M8, VSE16_V, 0x3 }, // 9575
  { PseudoVSE16_V_M8_MASK, VSE16_V, 0x3 }, // 9576
  { PseudoVSE16_V_MF4, VSE16_V, 0x6 }, // 9577
  { PseudoVSE16_V_MF4_MASK, VSE16_V, 0x6 }, // 9578
  { PseudoVSE16_V_MF2, VSE16_V, 0x7 }, // 9579
  { PseudoVSE16_V_MF2_MASK, VSE16_V, 0x7 }, // 9580
  { PseudoVSE32_V_M1, VSE32_V, 0x0 }, // 9581
  { PseudoVSE32_V_M1_MASK, VSE32_V, 0x0 }, // 9582
  { PseudoVSE32_V_M2, VSE32_V, 0x1 }, // 9583
  { PseudoVSE32_V_M2_MASK, VSE32_V, 0x1 }, // 9584
  { PseudoVSE32_V_M4, VSE32_V, 0x2 }, // 9585
  { PseudoVSE32_V_M4_MASK, VSE32_V, 0x2 }, // 9586
  { PseudoVSE32_V_M8, VSE32_V, 0x3 }, // 9587
  { PseudoVSE32_V_M8_MASK, VSE32_V, 0x3 }, // 9588
  { PseudoVSE32_V_MF2, VSE32_V, 0x7 }, // 9589
  { PseudoVSE32_V_MF2_MASK, VSE32_V, 0x7 }, // 9590
  { PseudoVSE64_V_M1, VSE64_V, 0x0 }, // 9591
  { PseudoVSE64_V_M1_MASK, VSE64_V, 0x0 }, // 9592
  { PseudoVSE64_V_M2, VSE64_V, 0x1 }, // 9593
  { PseudoVSE64_V_M2_MASK, VSE64_V, 0x1 }, // 9594
  { PseudoVSE64_V_M4, VSE64_V, 0x2 }, // 9595
  { PseudoVSE64_V_M4_MASK, VSE64_V, 0x2 }, // 9596
  { PseudoVSE64_V_M8, VSE64_V, 0x3 }, // 9597
  { PseudoVSE64_V_M8_MASK, VSE64_V, 0x3 }, // 9598
  { PseudoVSE8_V_M1, VSE8_V, 0x0 }, // 9599
  { PseudoVSE8_V_M1_MASK, VSE8_V, 0x0 }, // 9600
  { PseudoVSE8_V_M2, VSE8_V, 0x1 }, // 9601
  { PseudoVSE8_V_M2_MASK, VSE8_V, 0x1 }, // 9602
  { PseudoVSE8_V_M4, VSE8_V, 0x2 }, // 9603
  { PseudoVSE8_V_M4_MASK, VSE8_V, 0x2 }, // 9604
  { PseudoVSE8_V_M8, VSE8_V, 0x3 }, // 9605
  { PseudoVSE8_V_M8_MASK, VSE8_V, 0x3 }, // 9606
  { PseudoVSE8_V_MF8, VSE8_V, 0x5 }, // 9607
  { PseudoVSE8_V_MF8_MASK, VSE8_V, 0x5 }, // 9608
  { PseudoVSE8_V_MF4, VSE8_V, 0x6 }, // 9609
  { PseudoVSE8_V_MF4_MASK, VSE8_V, 0x6 }, // 9610
  { PseudoVSE8_V_MF2, VSE8_V, 0x7 }, // 9611
  { PseudoVSE8_V_MF2_MASK, VSE8_V, 0x7 }, // 9612
  { PseudoVSEXT_VF2_M1, VSEXT_VF2, 0x0 }, // 9613
  { PseudoVSEXT_VF2_M1_MASK, VSEXT_VF2, 0x0 }, // 9614
  { PseudoVSEXT_VF2_M1_TU, VSEXT_VF2, 0x0 }, // 9615
  { PseudoVSEXT_VF2_M2, VSEXT_VF2, 0x1 }, // 9616
  { PseudoVSEXT_VF2_M2_MASK, VSEXT_VF2, 0x1 }, // 9617
  { PseudoVSEXT_VF2_M2_TU, VSEXT_VF2, 0x1 }, // 9618
  { PseudoVSEXT_VF2_M4, VSEXT_VF2, 0x2 }, // 9619
  { PseudoVSEXT_VF2_M4_MASK, VSEXT_VF2, 0x2 }, // 9620
  { PseudoVSEXT_VF2_M4_TU, VSEXT_VF2, 0x2 }, // 9621
  { PseudoVSEXT_VF2_M8, VSEXT_VF2, 0x3 }, // 9622
  { PseudoVSEXT_VF2_M8_MASK, VSEXT_VF2, 0x3 }, // 9623
  { PseudoVSEXT_VF2_M8_TU, VSEXT_VF2, 0x3 }, // 9624
  { PseudoVSEXT_VF2_MF4, VSEXT_VF2, 0x6 }, // 9625
  { PseudoVSEXT_VF2_MF4_MASK, VSEXT_VF2, 0x6 }, // 9626
  { PseudoVSEXT_VF2_MF4_TU, VSEXT_VF2, 0x6 }, // 9627
  { PseudoVSEXT_VF2_MF2, VSEXT_VF2, 0x7 }, // 9628
  { PseudoVSEXT_VF2_MF2_MASK, VSEXT_VF2, 0x7 }, // 9629
  { PseudoVSEXT_VF2_MF2_TU, VSEXT_VF2, 0x7 }, // 9630
  { PseudoVSEXT_VF4_M1, VSEXT_VF4, 0x0 }, // 9631
  { PseudoVSEXT_VF4_M1_MASK, VSEXT_VF4, 0x0 }, // 9632
  { PseudoVSEXT_VF4_M1_TU, VSEXT_VF4, 0x0 }, // 9633
  { PseudoVSEXT_VF4_M2, VSEXT_VF4, 0x1 }, // 9634
  { PseudoVSEXT_VF4_M2_MASK, VSEXT_VF4, 0x1 }, // 9635
  { PseudoVSEXT_VF4_M2_TU, VSEXT_VF4, 0x1 }, // 9636
  { PseudoVSEXT_VF4_M4, VSEXT_VF4, 0x2 }, // 9637
  { PseudoVSEXT_VF4_M4_MASK, VSEXT_VF4, 0x2 }, // 9638
  { PseudoVSEXT_VF4_M4_TU, VSEXT_VF4, 0x2 }, // 9639
  { PseudoVSEXT_VF4_M8, VSEXT_VF4, 0x3 }, // 9640
  { PseudoVSEXT_VF4_M8_MASK, VSEXT_VF4, 0x3 }, // 9641
  { PseudoVSEXT_VF4_M8_TU, VSEXT_VF4, 0x3 }, // 9642
  { PseudoVSEXT_VF4_MF2, VSEXT_VF4, 0x7 }, // 9643
  { PseudoVSEXT_VF4_MF2_MASK, VSEXT_VF4, 0x7 }, // 9644
  { PseudoVSEXT_VF4_MF2_TU, VSEXT_VF4, 0x7 }, // 9645
  { PseudoVSEXT_VF8_M1, VSEXT_VF8, 0x0 }, // 9646
  { PseudoVSEXT_VF8_M1_MASK, VSEXT_VF8, 0x0 }, // 9647
  { PseudoVSEXT_VF8_M1_TU, VSEXT_VF8, 0x0 }, // 9648
  { PseudoVSEXT_VF8_M2, VSEXT_VF8, 0x1 }, // 9649
  { PseudoVSEXT_VF8_M2_MASK, VSEXT_VF8, 0x1 }, // 9650
  { PseudoVSEXT_VF8_M2_TU, VSEXT_VF8, 0x1 }, // 9651
  { PseudoVSEXT_VF8_M4, VSEXT_VF8, 0x2 }, // 9652
  { PseudoVSEXT_VF8_M4_MASK, VSEXT_VF8, 0x2 }, // 9653
  { PseudoVSEXT_VF8_M4_TU, VSEXT_VF8, 0x2 }, // 9654
  { PseudoVSEXT_VF8_M8, VSEXT_VF8, 0x3 }, // 9655
  { PseudoVSEXT_VF8_M8_MASK, VSEXT_VF8, 0x3 }, // 9656
  { PseudoVSEXT_VF8_M8_TU, VSEXT_VF8, 0x3 }, // 9657
  { PseudoVSLIDE1DOWN_VX_M1, VSLIDE1DOWN_VX, 0x0 }, // 9658
  { PseudoVSLIDE1DOWN_VX_M1_MASK, VSLIDE1DOWN_VX, 0x0 }, // 9659
  { PseudoVSLIDE1DOWN_VX_M1_TU, VSLIDE1DOWN_VX, 0x0 }, // 9660
  { PseudoVSLIDE1DOWN_VX_M2, VSLIDE1DOWN_VX, 0x1 }, // 9661
  { PseudoVSLIDE1DOWN_VX_M2_MASK, VSLIDE1DOWN_VX, 0x1 }, // 9662
  { PseudoVSLIDE1DOWN_VX_M2_TU, VSLIDE1DOWN_VX, 0x1 }, // 9663
  { PseudoVSLIDE1DOWN_VX_M4, VSLIDE1DOWN_VX, 0x2 }, // 9664
  { PseudoVSLIDE1DOWN_VX_M4_MASK, VSLIDE1DOWN_VX, 0x2 }, // 9665
  { PseudoVSLIDE1DOWN_VX_M4_TU, VSLIDE1DOWN_VX, 0x2 }, // 9666
  { PseudoVSLIDE1DOWN_VX_M8, VSLIDE1DOWN_VX, 0x3 }, // 9667
  { PseudoVSLIDE1DOWN_VX_M8_MASK, VSLIDE1DOWN_VX, 0x3 }, // 9668
  { PseudoVSLIDE1DOWN_VX_M8_TU, VSLIDE1DOWN_VX, 0x3 }, // 9669
  { PseudoVSLIDE1DOWN_VX_MF8, VSLIDE1DOWN_VX, 0x5 }, // 9670
  { PseudoVSLIDE1DOWN_VX_MF8_MASK, VSLIDE1DOWN_VX, 0x5 }, // 9671
  { PseudoVSLIDE1DOWN_VX_MF8_TU, VSLIDE1DOWN_VX, 0x5 }, // 9672
  { PseudoVSLIDE1DOWN_VX_MF4, VSLIDE1DOWN_VX, 0x6 }, // 9673
  { PseudoVSLIDE1DOWN_VX_MF4_MASK, VSLIDE1DOWN_VX, 0x6 }, // 9674
  { PseudoVSLIDE1DOWN_VX_MF4_TU, VSLIDE1DOWN_VX, 0x6 }, // 9675
  { PseudoVSLIDE1DOWN_VX_MF2, VSLIDE1DOWN_VX, 0x7 }, // 9676
  { PseudoVSLIDE1DOWN_VX_MF2_MASK, VSLIDE1DOWN_VX, 0x7 }, // 9677
  { PseudoVSLIDE1DOWN_VX_MF2_TU, VSLIDE1DOWN_VX, 0x7 }, // 9678
  { PseudoVSLIDE1UP_VX_M1, VSLIDE1UP_VX, 0x0 }, // 9679
  { PseudoVSLIDE1UP_VX_M1_MASK, VSLIDE1UP_VX, 0x0 }, // 9680
  { PseudoVSLIDE1UP_VX_M1_TU, VSLIDE1UP_VX, 0x0 }, // 9681
  { PseudoVSLIDE1UP_VX_M2, VSLIDE1UP_VX, 0x1 }, // 9682
  { PseudoVSLIDE1UP_VX_M2_MASK, VSLIDE1UP_VX, 0x1 }, // 9683
  { PseudoVSLIDE1UP_VX_M2_TU, VSLIDE1UP_VX, 0x1 }, // 9684
  { PseudoVSLIDE1UP_VX_M4, VSLIDE1UP_VX, 0x2 }, // 9685
  { PseudoVSLIDE1UP_VX_M4_MASK, VSLIDE1UP_VX, 0x2 }, // 9686
  { PseudoVSLIDE1UP_VX_M4_TU, VSLIDE1UP_VX, 0x2 }, // 9687
  { PseudoVSLIDE1UP_VX_M8, VSLIDE1UP_VX, 0x3 }, // 9688
  { PseudoVSLIDE1UP_VX_M8_MASK, VSLIDE1UP_VX, 0x3 }, // 9689
  { PseudoVSLIDE1UP_VX_M8_TU, VSLIDE1UP_VX, 0x3 }, // 9690
  { PseudoVSLIDE1UP_VX_MF8, VSLIDE1UP_VX, 0x5 }, // 9691
  { PseudoVSLIDE1UP_VX_MF8_MASK, VSLIDE1UP_VX, 0x5 }, // 9692
  { PseudoVSLIDE1UP_VX_MF8_TU, VSLIDE1UP_VX, 0x5 }, // 9693
  { PseudoVSLIDE1UP_VX_MF4, VSLIDE1UP_VX, 0x6 }, // 9694
  { PseudoVSLIDE1UP_VX_MF4_MASK, VSLIDE1UP_VX, 0x6 }, // 9695
  { PseudoVSLIDE1UP_VX_MF4_TU, VSLIDE1UP_VX, 0x6 }, // 9696
  { PseudoVSLIDE1UP_VX_MF2, VSLIDE1UP_VX, 0x7 }, // 9697
  { PseudoVSLIDE1UP_VX_MF2_MASK, VSLIDE1UP_VX, 0x7 }, // 9698
  { PseudoVSLIDE1UP_VX_MF2_TU, VSLIDE1UP_VX, 0x7 }, // 9699
  { PseudoVSLIDEDOWN_VI_M1, VSLIDEDOWN_VI, 0x0 }, // 9700
  { PseudoVSLIDEDOWN_VI_M1_MASK, VSLIDEDOWN_VI, 0x0 }, // 9701
  { PseudoVSLIDEDOWN_VI_M2, VSLIDEDOWN_VI, 0x1 }, // 9702
  { PseudoVSLIDEDOWN_VI_M2_MASK, VSLIDEDOWN_VI, 0x1 }, // 9703
  { PseudoVSLIDEDOWN_VI_M4, VSLIDEDOWN_VI, 0x2 }, // 9704
  { PseudoVSLIDEDOWN_VI_M4_MASK, VSLIDEDOWN_VI, 0x2 }, // 9705
  { PseudoVSLIDEDOWN_VI_M8, VSLIDEDOWN_VI, 0x3 }, // 9706
  { PseudoVSLIDEDOWN_VI_M8_MASK, VSLIDEDOWN_VI, 0x3 }, // 9707
  { PseudoVSLIDEDOWN_VI_MF8, VSLIDEDOWN_VI, 0x5 }, // 9708
  { PseudoVSLIDEDOWN_VI_MF8_MASK, VSLIDEDOWN_VI, 0x5 }, // 9709
  { PseudoVSLIDEDOWN_VI_MF4, VSLIDEDOWN_VI, 0x6 }, // 9710
  { PseudoVSLIDEDOWN_VI_MF4_MASK, VSLIDEDOWN_VI, 0x6 }, // 9711
  { PseudoVSLIDEDOWN_VI_MF2, VSLIDEDOWN_VI, 0x7 }, // 9712
  { PseudoVSLIDEDOWN_VI_MF2_MASK, VSLIDEDOWN_VI, 0x7 }, // 9713
  { PseudoVSLIDEDOWN_VX_M1, VSLIDEDOWN_VX, 0x0 }, // 9714
  { PseudoVSLIDEDOWN_VX_M1_MASK, VSLIDEDOWN_VX, 0x0 }, // 9715
  { PseudoVSLIDEDOWN_VX_M2, VSLIDEDOWN_VX, 0x1 }, // 9716
  { PseudoVSLIDEDOWN_VX_M2_MASK, VSLIDEDOWN_VX, 0x1 }, // 9717
  { PseudoVSLIDEDOWN_VX_M4, VSLIDEDOWN_VX, 0x2 }, // 9718
  { PseudoVSLIDEDOWN_VX_M4_MASK, VSLIDEDOWN_VX, 0x2 }, // 9719
  { PseudoVSLIDEDOWN_VX_M8, VSLIDEDOWN_VX, 0x3 }, // 9720
  { PseudoVSLIDEDOWN_VX_M8_MASK, VSLIDEDOWN_VX, 0x3 }, // 9721
  { PseudoVSLIDEDOWN_VX_MF8, VSLIDEDOWN_VX, 0x5 }, // 9722
  { PseudoVSLIDEDOWN_VX_MF8_MASK, VSLIDEDOWN_VX, 0x5 }, // 9723
  { PseudoVSLIDEDOWN_VX_MF4, VSLIDEDOWN_VX, 0x6 }, // 9724
  { PseudoVSLIDEDOWN_VX_MF4_MASK, VSLIDEDOWN_VX, 0x6 }, // 9725
  { PseudoVSLIDEDOWN_VX_MF2, VSLIDEDOWN_VX, 0x7 }, // 9726
  { PseudoVSLIDEDOWN_VX_MF2_MASK, VSLIDEDOWN_VX, 0x7 }, // 9727
  { PseudoVSLIDEUP_VI_M1, VSLIDEUP_VI, 0x0 }, // 9728
  { PseudoVSLIDEUP_VI_M1_MASK, VSLIDEUP_VI, 0x0 }, // 9729
  { PseudoVSLIDEUP_VI_M2, VSLIDEUP_VI, 0x1 }, // 9730
  { PseudoVSLIDEUP_VI_M2_MASK, VSLIDEUP_VI, 0x1 }, // 9731
  { PseudoVSLIDEUP_VI_M4, VSLIDEUP_VI, 0x2 }, // 9732
  { PseudoVSLIDEUP_VI_M4_MASK, VSLIDEUP_VI, 0x2 }, // 9733
  { PseudoVSLIDEUP_VI_M8, VSLIDEUP_VI, 0x3 }, // 9734
  { PseudoVSLIDEUP_VI_M8_MASK, VSLIDEUP_VI, 0x3 }, // 9735
  { PseudoVSLIDEUP_VI_MF8, VSLIDEUP_VI, 0x5 }, // 9736
  { PseudoVSLIDEUP_VI_MF8_MASK, VSLIDEUP_VI, 0x5 }, // 9737
  { PseudoVSLIDEUP_VI_MF4, VSLIDEUP_VI, 0x6 }, // 9738
  { PseudoVSLIDEUP_VI_MF4_MASK, VSLIDEUP_VI, 0x6 }, // 9739
  { PseudoVSLIDEUP_VI_MF2, VSLIDEUP_VI, 0x7 }, // 9740
  { PseudoVSLIDEUP_VI_MF2_MASK, VSLIDEUP_VI, 0x7 }, // 9741
  { PseudoVSLIDEUP_VX_M1, VSLIDEUP_VX, 0x0 }, // 9742
  { PseudoVSLIDEUP_VX_M1_MASK, VSLIDEUP_VX, 0x0 }, // 9743
  { PseudoVSLIDEUP_VX_M2, VSLIDEUP_VX, 0x1 }, // 9744
  { PseudoVSLIDEUP_VX_M2_MASK, VSLIDEUP_VX, 0x1 }, // 9745
  { PseudoVSLIDEUP_VX_M4, VSLIDEUP_VX, 0x2 }, // 9746
  { PseudoVSLIDEUP_VX_M4_MASK, VSLIDEUP_VX, 0x2 }, // 9747
  { PseudoVSLIDEUP_VX_M8, VSLIDEUP_VX, 0x3 }, // 9748
  { PseudoVSLIDEUP_VX_M8_MASK, VSLIDEUP_VX, 0x3 }, // 9749
  { PseudoVSLIDEUP_VX_MF8, VSLIDEUP_VX, 0x5 }, // 9750
  { PseudoVSLIDEUP_VX_MF8_MASK, VSLIDEUP_VX, 0x5 }, // 9751
  { PseudoVSLIDEUP_VX_MF4, VSLIDEUP_VX, 0x6 }, // 9752
  { PseudoVSLIDEUP_VX_MF4_MASK, VSLIDEUP_VX, 0x6 }, // 9753
  { PseudoVSLIDEUP_VX_MF2, VSLIDEUP_VX, 0x7 }, // 9754
  { PseudoVSLIDEUP_VX_MF2_MASK, VSLIDEUP_VX, 0x7 }, // 9755
  { PseudoVSLL_VI_M1, VSLL_VI, 0x0 }, // 9756
  { PseudoVSLL_VI_M1_MASK, VSLL_VI, 0x0 }, // 9757
  { PseudoVSLL_VI_M1_TU, VSLL_VI, 0x0 }, // 9758
  { PseudoVSLL_VI_M2, VSLL_VI, 0x1 }, // 9759
  { PseudoVSLL_VI_M2_MASK, VSLL_VI, 0x1 }, // 9760
  { PseudoVSLL_VI_M2_TU, VSLL_VI, 0x1 }, // 9761
  { PseudoVSLL_VI_M4, VSLL_VI, 0x2 }, // 9762
  { PseudoVSLL_VI_M4_MASK, VSLL_VI, 0x2 }, // 9763
  { PseudoVSLL_VI_M4_TU, VSLL_VI, 0x2 }, // 9764
  { PseudoVSLL_VI_M8, VSLL_VI, 0x3 }, // 9765
  { PseudoVSLL_VI_M8_MASK, VSLL_VI, 0x3 }, // 9766
  { PseudoVSLL_VI_M8_TU, VSLL_VI, 0x3 }, // 9767
  { PseudoVSLL_VI_MF8, VSLL_VI, 0x5 }, // 9768
  { PseudoVSLL_VI_MF8_MASK, VSLL_VI, 0x5 }, // 9769
  { PseudoVSLL_VI_MF8_TU, VSLL_VI, 0x5 }, // 9770
  { PseudoVSLL_VI_MF4, VSLL_VI, 0x6 }, // 9771
  { PseudoVSLL_VI_MF4_MASK, VSLL_VI, 0x6 }, // 9772
  { PseudoVSLL_VI_MF4_TU, VSLL_VI, 0x6 }, // 9773
  { PseudoVSLL_VI_MF2, VSLL_VI, 0x7 }, // 9774
  { PseudoVSLL_VI_MF2_MASK, VSLL_VI, 0x7 }, // 9775
  { PseudoVSLL_VI_MF2_TU, VSLL_VI, 0x7 }, // 9776
  { PseudoVSLL_VV_M1, VSLL_VV, 0x0 }, // 9777
  { PseudoVSLL_VV_M1_MASK, VSLL_VV, 0x0 }, // 9778
  { PseudoVSLL_VV_M1_TU, VSLL_VV, 0x0 }, // 9779
  { PseudoVSLL_VV_M2, VSLL_VV, 0x1 }, // 9780
  { PseudoVSLL_VV_M2_MASK, VSLL_VV, 0x1 }, // 9781
  { PseudoVSLL_VV_M2_TU, VSLL_VV, 0x1 }, // 9782
  { PseudoVSLL_VV_M4, VSLL_VV, 0x2 }, // 9783
  { PseudoVSLL_VV_M4_MASK, VSLL_VV, 0x2 }, // 9784
  { PseudoVSLL_VV_M4_TU, VSLL_VV, 0x2 }, // 9785
  { PseudoVSLL_VV_M8, VSLL_VV, 0x3 }, // 9786
  { PseudoVSLL_VV_M8_MASK, VSLL_VV, 0x3 }, // 9787
  { PseudoVSLL_VV_M8_TU, VSLL_VV, 0x3 }, // 9788
  { PseudoVSLL_VV_MF8, VSLL_VV, 0x5 }, // 9789
  { PseudoVSLL_VV_MF8_MASK, VSLL_VV, 0x5 }, // 9790
  { PseudoVSLL_VV_MF8_TU, VSLL_VV, 0x5 }, // 9791
  { PseudoVSLL_VV_MF4, VSLL_VV, 0x6 }, // 9792
  { PseudoVSLL_VV_MF4_MASK, VSLL_VV, 0x6 }, // 9793
  { PseudoVSLL_VV_MF4_TU, VSLL_VV, 0x6 }, // 9794
  { PseudoVSLL_VV_MF2, VSLL_VV, 0x7 }, // 9795
  { PseudoVSLL_VV_MF2_MASK, VSLL_VV, 0x7 }, // 9796
  { PseudoVSLL_VV_MF2_TU, VSLL_VV, 0x7 }, // 9797
  { PseudoVSLL_VX_M1, VSLL_VX, 0x0 }, // 9798
  { PseudoVSLL_VX_M1_MASK, VSLL_VX, 0x0 }, // 9799
  { PseudoVSLL_VX_M1_TU, VSLL_VX, 0x0 }, // 9800
  { PseudoVSLL_VX_M2, VSLL_VX, 0x1 }, // 9801
  { PseudoVSLL_VX_M2_MASK, VSLL_VX, 0x1 }, // 9802
  { PseudoVSLL_VX_M2_TU, VSLL_VX, 0x1 }, // 9803
  { PseudoVSLL_VX_M4, VSLL_VX, 0x2 }, // 9804
  { PseudoVSLL_VX_M4_MASK, VSLL_VX, 0x2 }, // 9805
  { PseudoVSLL_VX_M4_TU, VSLL_VX, 0x2 }, // 9806
  { PseudoVSLL_VX_M8, VSLL_VX, 0x3 }, // 9807
  { PseudoVSLL_VX_M8_MASK, VSLL_VX, 0x3 }, // 9808
  { PseudoVSLL_VX_M8_TU, VSLL_VX, 0x3 }, // 9809
  { PseudoVSLL_VX_MF8, VSLL_VX, 0x5 }, // 9810
  { PseudoVSLL_VX_MF8_MASK, VSLL_VX, 0x5 }, // 9811
  { PseudoVSLL_VX_MF8_TU, VSLL_VX, 0x5 }, // 9812
  { PseudoVSLL_VX_MF4, VSLL_VX, 0x6 }, // 9813
  { PseudoVSLL_VX_MF4_MASK, VSLL_VX, 0x6 }, // 9814
  { PseudoVSLL_VX_MF4_TU, VSLL_VX, 0x6 }, // 9815
  { PseudoVSLL_VX_MF2, VSLL_VX, 0x7 }, // 9816
  { PseudoVSLL_VX_MF2_MASK, VSLL_VX, 0x7 }, // 9817
  { PseudoVSLL_VX_MF2_TU, VSLL_VX, 0x7 }, // 9818
  { PseudoVSMUL_VV_M1, VSMUL_VV, 0x0 }, // 9819
  { PseudoVSMUL_VV_M1_MASK, VSMUL_VV, 0x0 }, // 9820
  { PseudoVSMUL_VV_M1_TU, VSMUL_VV, 0x0 }, // 9821
  { PseudoVSMUL_VV_M2, VSMUL_VV, 0x1 }, // 9822
  { PseudoVSMUL_VV_M2_MASK, VSMUL_VV, 0x1 }, // 9823
  { PseudoVSMUL_VV_M2_TU, VSMUL_VV, 0x1 }, // 9824
  { PseudoVSMUL_VV_M4, VSMUL_VV, 0x2 }, // 9825
  { PseudoVSMUL_VV_M4_MASK, VSMUL_VV, 0x2 }, // 9826
  { PseudoVSMUL_VV_M4_TU, VSMUL_VV, 0x2 }, // 9827
  { PseudoVSMUL_VV_M8, VSMUL_VV, 0x3 }, // 9828
  { PseudoVSMUL_VV_M8_MASK, VSMUL_VV, 0x3 }, // 9829
  { PseudoVSMUL_VV_M8_TU, VSMUL_VV, 0x3 }, // 9830
  { PseudoVSMUL_VV_MF8, VSMUL_VV, 0x5 }, // 9831
  { PseudoVSMUL_VV_MF8_MASK, VSMUL_VV, 0x5 }, // 9832
  { PseudoVSMUL_VV_MF8_TU, VSMUL_VV, 0x5 }, // 9833
  { PseudoVSMUL_VV_MF4, VSMUL_VV, 0x6 }, // 9834
  { PseudoVSMUL_VV_MF4_MASK, VSMUL_VV, 0x6 }, // 9835
  { PseudoVSMUL_VV_MF4_TU, VSMUL_VV, 0x6 }, // 9836
  { PseudoVSMUL_VV_MF2, VSMUL_VV, 0x7 }, // 9837
  { PseudoVSMUL_VV_MF2_MASK, VSMUL_VV, 0x7 }, // 9838
  { PseudoVSMUL_VV_MF2_TU, VSMUL_VV, 0x7 }, // 9839
  { PseudoVSMUL_VX_M1, VSMUL_VX, 0x0 }, // 9840
  { PseudoVSMUL_VX_M1_MASK, VSMUL_VX, 0x0 }, // 9841
  { PseudoVSMUL_VX_M1_TU, VSMUL_VX, 0x0 }, // 9842
  { PseudoVSMUL_VX_M2, VSMUL_VX, 0x1 }, // 9843
  { PseudoVSMUL_VX_M2_MASK, VSMUL_VX, 0x1 }, // 9844
  { PseudoVSMUL_VX_M2_TU, VSMUL_VX, 0x1 }, // 9845
  { PseudoVSMUL_VX_M4, VSMUL_VX, 0x2 }, // 9846
  { PseudoVSMUL_VX_M4_MASK, VSMUL_VX, 0x2 }, // 9847
  { PseudoVSMUL_VX_M4_TU, VSMUL_VX, 0x2 }, // 9848
  { PseudoVSMUL_VX_M8, VSMUL_VX, 0x3 }, // 9849
  { PseudoVSMUL_VX_M8_MASK, VSMUL_VX, 0x3 }, // 9850
  { PseudoVSMUL_VX_M8_TU, VSMUL_VX, 0x3 }, // 9851
  { PseudoVSMUL_VX_MF8, VSMUL_VX, 0x5 }, // 9852
  { PseudoVSMUL_VX_MF8_MASK, VSMUL_VX, 0x5 }, // 9853
  { PseudoVSMUL_VX_MF8_TU, VSMUL_VX, 0x5 }, // 9854
  { PseudoVSMUL_VX_MF4, VSMUL_VX, 0x6 }, // 9855
  { PseudoVSMUL_VX_MF4_MASK, VSMUL_VX, 0x6 }, // 9856
  { PseudoVSMUL_VX_MF4_TU, VSMUL_VX, 0x6 }, // 9857
  { PseudoVSMUL_VX_MF2, VSMUL_VX, 0x7 }, // 9858
  { PseudoVSMUL_VX_MF2_MASK, VSMUL_VX, 0x7 }, // 9859
  { PseudoVSMUL_VX_MF2_TU, VSMUL_VX, 0x7 }, // 9860
  { PseudoVSM_V_B8, VSM_V, 0x0 }, // 9861
  { PseudoVSM_V_B16, VSM_V, 0x1 }, // 9862
  { PseudoVSM_V_B32, VSM_V, 0x2 }, // 9863
  { PseudoVSM_V_B64, VSM_V, 0x3 }, // 9864
  { PseudoVSM_V_B1, VSM_V, 0x5 }, // 9865
  { PseudoVSM_V_B2, VSM_V, 0x6 }, // 9866
  { PseudoVSM_V_B4, VSM_V, 0x7 }, // 9867
  { PseudoVSOXEI16_V_M1_M1, VSOXEI16_V, 0x0 }, // 9868
  { PseudoVSOXEI16_V_M1_M1_MASK, VSOXEI16_V, 0x0 }, // 9869
  { PseudoVSOXEI16_V_M2_M1, VSOXEI16_V, 0x0 }, // 9870
  { PseudoVSOXEI16_V_M2_M1_MASK, VSOXEI16_V, 0x0 }, // 9871
  { PseudoVSOXEI16_V_MF2_M1, VSOXEI16_V, 0x0 }, // 9872
  { PseudoVSOXEI16_V_MF2_M1_MASK, VSOXEI16_V, 0x0 }, // 9873
  { PseudoVSOXEI16_V_MF4_M1, VSOXEI16_V, 0x0 }, // 9874
  { PseudoVSOXEI16_V_MF4_M1_MASK, VSOXEI16_V, 0x0 }, // 9875
  { PseudoVSOXEI16_V_M1_M2, VSOXEI16_V, 0x1 }, // 9876
  { PseudoVSOXEI16_V_M1_M2_MASK, VSOXEI16_V, 0x1 }, // 9877
  { PseudoVSOXEI16_V_M2_M2, VSOXEI16_V, 0x1 }, // 9878
  { PseudoVSOXEI16_V_M2_M2_MASK, VSOXEI16_V, 0x1 }, // 9879
  { PseudoVSOXEI16_V_M4_M2, VSOXEI16_V, 0x1 }, // 9880
  { PseudoVSOXEI16_V_M4_M2_MASK, VSOXEI16_V, 0x1 }, // 9881
  { PseudoVSOXEI16_V_MF2_M2, VSOXEI16_V, 0x1 }, // 9882
  { PseudoVSOXEI16_V_MF2_M2_MASK, VSOXEI16_V, 0x1 }, // 9883
  { PseudoVSOXEI16_V_M1_M4, VSOXEI16_V, 0x2 }, // 9884
  { PseudoVSOXEI16_V_M1_M4_MASK, VSOXEI16_V, 0x2 }, // 9885
  { PseudoVSOXEI16_V_M2_M4, VSOXEI16_V, 0x2 }, // 9886
  { PseudoVSOXEI16_V_M2_M4_MASK, VSOXEI16_V, 0x2 }, // 9887
  { PseudoVSOXEI16_V_M4_M4, VSOXEI16_V, 0x2 }, // 9888
  { PseudoVSOXEI16_V_M4_M4_MASK, VSOXEI16_V, 0x2 }, // 9889
  { PseudoVSOXEI16_V_M8_M4, VSOXEI16_V, 0x2 }, // 9890
  { PseudoVSOXEI16_V_M8_M4_MASK, VSOXEI16_V, 0x2 }, // 9891
  { PseudoVSOXEI16_V_M2_M8, VSOXEI16_V, 0x3 }, // 9892
  { PseudoVSOXEI16_V_M2_M8_MASK, VSOXEI16_V, 0x3 }, // 9893
  { PseudoVSOXEI16_V_M4_M8, VSOXEI16_V, 0x3 }, // 9894
  { PseudoVSOXEI16_V_M4_M8_MASK, VSOXEI16_V, 0x3 }, // 9895
  { PseudoVSOXEI16_V_M8_M8, VSOXEI16_V, 0x3 }, // 9896
  { PseudoVSOXEI16_V_M8_M8_MASK, VSOXEI16_V, 0x3 }, // 9897
  { PseudoVSOXEI16_V_MF4_MF8, VSOXEI16_V, 0x5 }, // 9898
  { PseudoVSOXEI16_V_MF4_MF8_MASK, VSOXEI16_V, 0x5 }, // 9899
  { PseudoVSOXEI16_V_MF2_MF4, VSOXEI16_V, 0x6 }, // 9900
  { PseudoVSOXEI16_V_MF2_MF4_MASK, VSOXEI16_V, 0x6 }, // 9901
  { PseudoVSOXEI16_V_MF4_MF4, VSOXEI16_V, 0x6 }, // 9902
  { PseudoVSOXEI16_V_MF4_MF4_MASK, VSOXEI16_V, 0x6 }, // 9903
  { PseudoVSOXEI16_V_M1_MF2, VSOXEI16_V, 0x7 }, // 9904
  { PseudoVSOXEI16_V_M1_MF2_MASK, VSOXEI16_V, 0x7 }, // 9905
  { PseudoVSOXEI16_V_MF2_MF2, VSOXEI16_V, 0x7 }, // 9906
  { PseudoVSOXEI16_V_MF2_MF2_MASK, VSOXEI16_V, 0x7 }, // 9907
  { PseudoVSOXEI16_V_MF4_MF2, VSOXEI16_V, 0x7 }, // 9908
  { PseudoVSOXEI16_V_MF4_MF2_MASK, VSOXEI16_V, 0x7 }, // 9909
  { PseudoVSOXEI32_V_M1_M1, VSOXEI32_V, 0x0 }, // 9910
  { PseudoVSOXEI32_V_M1_M1_MASK, VSOXEI32_V, 0x0 }, // 9911
  { PseudoVSOXEI32_V_M2_M1, VSOXEI32_V, 0x0 }, // 9912
  { PseudoVSOXEI32_V_M2_M1_MASK, VSOXEI32_V, 0x0 }, // 9913
  { PseudoVSOXEI32_V_M4_M1, VSOXEI32_V, 0x0 }, // 9914
  { PseudoVSOXEI32_V_M4_M1_MASK, VSOXEI32_V, 0x0 }, // 9915
  { PseudoVSOXEI32_V_MF2_M1, VSOXEI32_V, 0x0 }, // 9916
  { PseudoVSOXEI32_V_MF2_M1_MASK, VSOXEI32_V, 0x0 }, // 9917
  { PseudoVSOXEI32_V_M1_M2, VSOXEI32_V, 0x1 }, // 9918
  { PseudoVSOXEI32_V_M1_M2_MASK, VSOXEI32_V, 0x1 }, // 9919
  { PseudoVSOXEI32_V_M2_M2, VSOXEI32_V, 0x1 }, // 9920
  { PseudoVSOXEI32_V_M2_M2_MASK, VSOXEI32_V, 0x1 }, // 9921
  { PseudoVSOXEI32_V_M4_M2, VSOXEI32_V, 0x1 }, // 9922
  { PseudoVSOXEI32_V_M4_M2_MASK, VSOXEI32_V, 0x1 }, // 9923
  { PseudoVSOXEI32_V_M8_M2, VSOXEI32_V, 0x1 }, // 9924
  { PseudoVSOXEI32_V_M8_M2_MASK, VSOXEI32_V, 0x1 }, // 9925
  { PseudoVSOXEI32_V_M2_M4, VSOXEI32_V, 0x2 }, // 9926
  { PseudoVSOXEI32_V_M2_M4_MASK, VSOXEI32_V, 0x2 }, // 9927
  { PseudoVSOXEI32_V_M4_M4, VSOXEI32_V, 0x2 }, // 9928
  { PseudoVSOXEI32_V_M4_M4_MASK, VSOXEI32_V, 0x2 }, // 9929
  { PseudoVSOXEI32_V_M8_M4, VSOXEI32_V, 0x2 }, // 9930
  { PseudoVSOXEI32_V_M8_M4_MASK, VSOXEI32_V, 0x2 }, // 9931
  { PseudoVSOXEI32_V_M4_M8, VSOXEI32_V, 0x3 }, // 9932
  { PseudoVSOXEI32_V_M4_M8_MASK, VSOXEI32_V, 0x3 }, // 9933
  { PseudoVSOXEI32_V_M8_M8, VSOXEI32_V, 0x3 }, // 9934
  { PseudoVSOXEI32_V_M8_M8_MASK, VSOXEI32_V, 0x3 }, // 9935
  { PseudoVSOXEI32_V_MF2_MF8, VSOXEI32_V, 0x5 }, // 9936
  { PseudoVSOXEI32_V_MF2_MF8_MASK, VSOXEI32_V, 0x5 }, // 9937
  { PseudoVSOXEI32_V_M1_MF4, VSOXEI32_V, 0x6 }, // 9938
  { PseudoVSOXEI32_V_M1_MF4_MASK, VSOXEI32_V, 0x6 }, // 9939
  { PseudoVSOXEI32_V_MF2_MF4, VSOXEI32_V, 0x6 }, // 9940
  { PseudoVSOXEI32_V_MF2_MF4_MASK, VSOXEI32_V, 0x6 }, // 9941
  { PseudoVSOXEI32_V_M1_MF2, VSOXEI32_V, 0x7 }, // 9942
  { PseudoVSOXEI32_V_M1_MF2_MASK, VSOXEI32_V, 0x7 }, // 9943
  { PseudoVSOXEI32_V_M2_MF2, VSOXEI32_V, 0x7 }, // 9944
  { PseudoVSOXEI32_V_M2_MF2_MASK, VSOXEI32_V, 0x7 }, // 9945
  { PseudoVSOXEI32_V_MF2_MF2, VSOXEI32_V, 0x7 }, // 9946
  { PseudoVSOXEI32_V_MF2_MF2_MASK, VSOXEI32_V, 0x7 }, // 9947
  { PseudoVSOXEI64_V_M1_M1, VSOXEI64_V, 0x0 }, // 9948
  { PseudoVSOXEI64_V_M1_M1_MASK, VSOXEI64_V, 0x0 }, // 9949
  { PseudoVSOXEI64_V_M2_M1, VSOXEI64_V, 0x0 }, // 9950
  { PseudoVSOXEI64_V_M2_M1_MASK, VSOXEI64_V, 0x0 }, // 9951
  { PseudoVSOXEI64_V_M4_M1, VSOXEI64_V, 0x0 }, // 9952
  { PseudoVSOXEI64_V_M4_M1_MASK, VSOXEI64_V, 0x0 }, // 9953
  { PseudoVSOXEI64_V_M8_M1, VSOXEI64_V, 0x0 }, // 9954
  { PseudoVSOXEI64_V_M8_M1_MASK, VSOXEI64_V, 0x0 }, // 9955
  { PseudoVSOXEI64_V_M2_M2, VSOXEI64_V, 0x1 }, // 9956
  { PseudoVSOXEI64_V_M2_M2_MASK, VSOXEI64_V, 0x1 }, // 9957
  { PseudoVSOXEI64_V_M4_M2, VSOXEI64_V, 0x1 }, // 9958
  { PseudoVSOXEI64_V_M4_M2_MASK, VSOXEI64_V, 0x1 }, // 9959
  { PseudoVSOXEI64_V_M8_M2, VSOXEI64_V, 0x1 }, // 9960
  { PseudoVSOXEI64_V_M8_M2_MASK, VSOXEI64_V, 0x1 }, // 9961
  { PseudoVSOXEI64_V_M4_M4, VSOXEI64_V, 0x2 }, // 9962
  { PseudoVSOXEI64_V_M4_M4_MASK, VSOXEI64_V, 0x2 }, // 9963
  { PseudoVSOXEI64_V_M8_M4, VSOXEI64_V, 0x2 }, // 9964
  { PseudoVSOXEI64_V_M8_M4_MASK, VSOXEI64_V, 0x2 }, // 9965
  { PseudoVSOXEI64_V_M8_M8, VSOXEI64_V, 0x3 }, // 9966
  { PseudoVSOXEI64_V_M8_M8_MASK, VSOXEI64_V, 0x3 }, // 9967
  { PseudoVSOXEI64_V_M1_MF8, VSOXEI64_V, 0x5 }, // 9968
  { PseudoVSOXEI64_V_M1_MF8_MASK, VSOXEI64_V, 0x5 }, // 9969
  { PseudoVSOXEI64_V_M1_MF4, VSOXEI64_V, 0x6 }, // 9970
  { PseudoVSOXEI64_V_M1_MF4_MASK, VSOXEI64_V, 0x6 }, // 9971
  { PseudoVSOXEI64_V_M2_MF4, VSOXEI64_V, 0x6 }, // 9972
  { PseudoVSOXEI64_V_M2_MF4_MASK, VSOXEI64_V, 0x6 }, // 9973
  { PseudoVSOXEI64_V_M1_MF2, VSOXEI64_V, 0x7 }, // 9974
  { PseudoVSOXEI64_V_M1_MF2_MASK, VSOXEI64_V, 0x7 }, // 9975
  { PseudoVSOXEI64_V_M2_MF2, VSOXEI64_V, 0x7 }, // 9976
  { PseudoVSOXEI64_V_M2_MF2_MASK, VSOXEI64_V, 0x7 }, // 9977
  { PseudoVSOXEI64_V_M4_MF2, VSOXEI64_V, 0x7 }, // 9978
  { PseudoVSOXEI64_V_M4_MF2_MASK, VSOXEI64_V, 0x7 }, // 9979
  { PseudoVSOXEI8_V_M1_M1, VSOXEI8_V, 0x0 }, // 9980
  { PseudoVSOXEI8_V_M1_M1_MASK, VSOXEI8_V, 0x0 }, // 9981
  { PseudoVSOXEI8_V_MF2_M1, VSOXEI8_V, 0x0 }, // 9982
  { PseudoVSOXEI8_V_MF2_M1_MASK, VSOXEI8_V, 0x0 }, // 9983
  { PseudoVSOXEI8_V_MF4_M1, VSOXEI8_V, 0x0 }, // 9984
  { PseudoVSOXEI8_V_MF4_M1_MASK, VSOXEI8_V, 0x0 }, // 9985
  { PseudoVSOXEI8_V_MF8_M1, VSOXEI8_V, 0x0 }, // 9986
  { PseudoVSOXEI8_V_MF8_M1_MASK, VSOXEI8_V, 0x0 }, // 9987
  { PseudoVSOXEI8_V_M1_M2, VSOXEI8_V, 0x1 }, // 9988
  { PseudoVSOXEI8_V_M1_M2_MASK, VSOXEI8_V, 0x1 }, // 9989
  { PseudoVSOXEI8_V_M2_M2, VSOXEI8_V, 0x1 }, // 9990
  { PseudoVSOXEI8_V_M2_M2_MASK, VSOXEI8_V, 0x1 }, // 9991
  { PseudoVSOXEI8_V_MF2_M2, VSOXEI8_V, 0x1 }, // 9992
  { PseudoVSOXEI8_V_MF2_M2_MASK, VSOXEI8_V, 0x1 }, // 9993
  { PseudoVSOXEI8_V_MF4_M2, VSOXEI8_V, 0x1 }, // 9994
  { PseudoVSOXEI8_V_MF4_M2_MASK, VSOXEI8_V, 0x1 }, // 9995
  { PseudoVSOXEI8_V_M1_M4, VSOXEI8_V, 0x2 }, // 9996
  { PseudoVSOXEI8_V_M1_M4_MASK, VSOXEI8_V, 0x2 }, // 9997
  { PseudoVSOXEI8_V_M2_M4, VSOXEI8_V, 0x2 }, // 9998
  { PseudoVSOXEI8_V_M2_M4_MASK, VSOXEI8_V, 0x2 }, // 9999
  { PseudoVSOXEI8_V_M4_M4, VSOXEI8_V, 0x2 }, // 10000
  { PseudoVSOXEI8_V_M4_M4_MASK, VSOXEI8_V, 0x2 }, // 10001
  { PseudoVSOXEI8_V_MF2_M4, VSOXEI8_V, 0x2 }, // 10002
  { PseudoVSOXEI8_V_MF2_M4_MASK, VSOXEI8_V, 0x2 }, // 10003
  { PseudoVSOXEI8_V_M1_M8, VSOXEI8_V, 0x3 }, // 10004
  { PseudoVSOXEI8_V_M1_M8_MASK, VSOXEI8_V, 0x3 }, // 10005
  { PseudoVSOXEI8_V_M2_M8, VSOXEI8_V, 0x3 }, // 10006
  { PseudoVSOXEI8_V_M2_M8_MASK, VSOXEI8_V, 0x3 }, // 10007
  { PseudoVSOXEI8_V_M4_M8, VSOXEI8_V, 0x3 }, // 10008
  { PseudoVSOXEI8_V_M4_M8_MASK, VSOXEI8_V, 0x3 }, // 10009
  { PseudoVSOXEI8_V_M8_M8, VSOXEI8_V, 0x3 }, // 10010
  { PseudoVSOXEI8_V_M8_M8_MASK, VSOXEI8_V, 0x3 }, // 10011
  { PseudoVSOXEI8_V_MF8_MF8, VSOXEI8_V, 0x5 }, // 10012
  { PseudoVSOXEI8_V_MF8_MF8_MASK, VSOXEI8_V, 0x5 }, // 10013
  { PseudoVSOXEI8_V_MF4_MF4, VSOXEI8_V, 0x6 }, // 10014
  { PseudoVSOXEI8_V_MF4_MF4_MASK, VSOXEI8_V, 0x6 }, // 10015
  { PseudoVSOXEI8_V_MF8_MF4, VSOXEI8_V, 0x6 }, // 10016
  { PseudoVSOXEI8_V_MF8_MF4_MASK, VSOXEI8_V, 0x6 }, // 10017
  { PseudoVSOXEI8_V_MF2_MF2, VSOXEI8_V, 0x7 }, // 10018
  { PseudoVSOXEI8_V_MF2_MF2_MASK, VSOXEI8_V, 0x7 }, // 10019
  { PseudoVSOXEI8_V_MF4_MF2, VSOXEI8_V, 0x7 }, // 10020
  { PseudoVSOXEI8_V_MF4_MF2_MASK, VSOXEI8_V, 0x7 }, // 10021
  { PseudoVSOXEI8_V_MF8_MF2, VSOXEI8_V, 0x7 }, // 10022
  { PseudoVSOXEI8_V_MF8_MF2_MASK, VSOXEI8_V, 0x7 }, // 10023
  { PseudoVSOXSEG2EI16_V_M1_M1, VSOXSEG2EI16_V, 0x0 }, // 10024
  { PseudoVSOXSEG2EI16_V_M1_M1_MASK, VSOXSEG2EI16_V, 0x0 }, // 10025
  { PseudoVSOXSEG2EI16_V_M2_M1, VSOXSEG2EI16_V, 0x0 }, // 10026
  { PseudoVSOXSEG2EI16_V_M2_M1_MASK, VSOXSEG2EI16_V, 0x0 }, // 10027
  { PseudoVSOXSEG2EI16_V_MF2_M1, VSOXSEG2EI16_V, 0x0 }, // 10028
  { PseudoVSOXSEG2EI16_V_MF2_M1_MASK, VSOXSEG2EI16_V, 0x0 }, // 10029
  { PseudoVSOXSEG2EI16_V_MF4_M1, VSOXSEG2EI16_V, 0x0 }, // 10030
  { PseudoVSOXSEG2EI16_V_MF4_M1_MASK, VSOXSEG2EI16_V, 0x0 }, // 10031
  { PseudoVSOXSEG2EI16_V_M1_M2, VSOXSEG2EI16_V, 0x1 }, // 10032
  { PseudoVSOXSEG2EI16_V_M1_M2_MASK, VSOXSEG2EI16_V, 0x1 }, // 10033
  { PseudoVSOXSEG2EI16_V_M2_M2, VSOXSEG2EI16_V, 0x1 }, // 10034
  { PseudoVSOXSEG2EI16_V_M2_M2_MASK, VSOXSEG2EI16_V, 0x1 }, // 10035
  { PseudoVSOXSEG2EI16_V_M4_M2, VSOXSEG2EI16_V, 0x1 }, // 10036
  { PseudoVSOXSEG2EI16_V_M4_M2_MASK, VSOXSEG2EI16_V, 0x1 }, // 10037
  { PseudoVSOXSEG2EI16_V_MF2_M2, VSOXSEG2EI16_V, 0x1 }, // 10038
  { PseudoVSOXSEG2EI16_V_MF2_M2_MASK, VSOXSEG2EI16_V, 0x1 }, // 10039
  { PseudoVSOXSEG2EI16_V_M1_M4, VSOXSEG2EI16_V, 0x2 }, // 10040
  { PseudoVSOXSEG2EI16_V_M1_M4_MASK, VSOXSEG2EI16_V, 0x2 }, // 10041
  { PseudoVSOXSEG2EI16_V_M2_M4, VSOXSEG2EI16_V, 0x2 }, // 10042
  { PseudoVSOXSEG2EI16_V_M2_M4_MASK, VSOXSEG2EI16_V, 0x2 }, // 10043
  { PseudoVSOXSEG2EI16_V_M4_M4, VSOXSEG2EI16_V, 0x2 }, // 10044
  { PseudoVSOXSEG2EI16_V_M4_M4_MASK, VSOXSEG2EI16_V, 0x2 }, // 10045
  { PseudoVSOXSEG2EI16_V_M8_M4, VSOXSEG2EI16_V, 0x2 }, // 10046
  { PseudoVSOXSEG2EI16_V_M8_M4_MASK, VSOXSEG2EI16_V, 0x2 }, // 10047
  { PseudoVSOXSEG2EI16_V_MF4_MF8, VSOXSEG2EI16_V, 0x5 }, // 10048
  { PseudoVSOXSEG2EI16_V_MF4_MF8_MASK, VSOXSEG2EI16_V, 0x5 }, // 10049
  { PseudoVSOXSEG2EI16_V_MF2_MF4, VSOXSEG2EI16_V, 0x6 }, // 10050
  { PseudoVSOXSEG2EI16_V_MF2_MF4_MASK, VSOXSEG2EI16_V, 0x6 }, // 10051
  { PseudoVSOXSEG2EI16_V_MF4_MF4, VSOXSEG2EI16_V, 0x6 }, // 10052
  { PseudoVSOXSEG2EI16_V_MF4_MF4_MASK, VSOXSEG2EI16_V, 0x6 }, // 10053
  { PseudoVSOXSEG2EI16_V_M1_MF2, VSOXSEG2EI16_V, 0x7 }, // 10054
  { PseudoVSOXSEG2EI16_V_M1_MF2_MASK, VSOXSEG2EI16_V, 0x7 }, // 10055
  { PseudoVSOXSEG2EI16_V_MF2_MF2, VSOXSEG2EI16_V, 0x7 }, // 10056
  { PseudoVSOXSEG2EI16_V_MF2_MF2_MASK, VSOXSEG2EI16_V, 0x7 }, // 10057
  { PseudoVSOXSEG2EI16_V_MF4_MF2, VSOXSEG2EI16_V, 0x7 }, // 10058
  { PseudoVSOXSEG2EI16_V_MF4_MF2_MASK, VSOXSEG2EI16_V, 0x7 }, // 10059
  { PseudoVSOXSEG2EI32_V_M1_M1, VSOXSEG2EI32_V, 0x0 }, // 10060
  { PseudoVSOXSEG2EI32_V_M1_M1_MASK, VSOXSEG2EI32_V, 0x0 }, // 10061
  { PseudoVSOXSEG2EI32_V_M2_M1, VSOXSEG2EI32_V, 0x0 }, // 10062
  { PseudoVSOXSEG2EI32_V_M2_M1_MASK, VSOXSEG2EI32_V, 0x0 }, // 10063
  { PseudoVSOXSEG2EI32_V_M4_M1, VSOXSEG2EI32_V, 0x0 }, // 10064
  { PseudoVSOXSEG2EI32_V_M4_M1_MASK, VSOXSEG2EI32_V, 0x0 }, // 10065
  { PseudoVSOXSEG2EI32_V_MF2_M1, VSOXSEG2EI32_V, 0x0 }, // 10066
  { PseudoVSOXSEG2EI32_V_MF2_M1_MASK, VSOXSEG2EI32_V, 0x0 }, // 10067
  { PseudoVSOXSEG2EI32_V_M1_M2, VSOXSEG2EI32_V, 0x1 }, // 10068
  { PseudoVSOXSEG2EI32_V_M1_M2_MASK, VSOXSEG2EI32_V, 0x1 }, // 10069
  { PseudoVSOXSEG2EI32_V_M2_M2, VSOXSEG2EI32_V, 0x1 }, // 10070
  { PseudoVSOXSEG2EI32_V_M2_M2_MASK, VSOXSEG2EI32_V, 0x1 }, // 10071
  { PseudoVSOXSEG2EI32_V_M4_M2, VSOXSEG2EI32_V, 0x1 }, // 10072
  { PseudoVSOXSEG2EI32_V_M4_M2_MASK, VSOXSEG2EI32_V, 0x1 }, // 10073
  { PseudoVSOXSEG2EI32_V_M8_M2, VSOXSEG2EI32_V, 0x1 }, // 10074
  { PseudoVSOXSEG2EI32_V_M8_M2_MASK, VSOXSEG2EI32_V, 0x1 }, // 10075
  { PseudoVSOXSEG2EI32_V_M2_M4, VSOXSEG2EI32_V, 0x2 }, // 10076
  { PseudoVSOXSEG2EI32_V_M2_M4_MASK, VSOXSEG2EI32_V, 0x2 }, // 10077
  { PseudoVSOXSEG2EI32_V_M4_M4, VSOXSEG2EI32_V, 0x2 }, // 10078
  { PseudoVSOXSEG2EI32_V_M4_M4_MASK, VSOXSEG2EI32_V, 0x2 }, // 10079
  { PseudoVSOXSEG2EI32_V_M8_M4, VSOXSEG2EI32_V, 0x2 }, // 10080
  { PseudoVSOXSEG2EI32_V_M8_M4_MASK, VSOXSEG2EI32_V, 0x2 }, // 10081
  { PseudoVSOXSEG2EI32_V_MF2_MF8, VSOXSEG2EI32_V, 0x5 }, // 10082
  { PseudoVSOXSEG2EI32_V_MF2_MF8_MASK, VSOXSEG2EI32_V, 0x5 }, // 10083
  { PseudoVSOXSEG2EI32_V_M1_MF4, VSOXSEG2EI32_V, 0x6 }, // 10084
  { PseudoVSOXSEG2EI32_V_M1_MF4_MASK, VSOXSEG2EI32_V, 0x6 }, // 10085
  { PseudoVSOXSEG2EI32_V_MF2_MF4, VSOXSEG2EI32_V, 0x6 }, // 10086
  { PseudoVSOXSEG2EI32_V_MF2_MF4_MASK, VSOXSEG2EI32_V, 0x6 }, // 10087
  { PseudoVSOXSEG2EI32_V_M1_MF2, VSOXSEG2EI32_V, 0x7 }, // 10088
  { PseudoVSOXSEG2EI32_V_M1_MF2_MASK, VSOXSEG2EI32_V, 0x7 }, // 10089
  { PseudoVSOXSEG2EI32_V_M2_MF2, VSOXSEG2EI32_V, 0x7 }, // 10090
  { PseudoVSOXSEG2EI32_V_M2_MF2_MASK, VSOXSEG2EI32_V, 0x7 }, // 10091
  { PseudoVSOXSEG2EI32_V_MF2_MF2, VSOXSEG2EI32_V, 0x7 }, // 10092
  { PseudoVSOXSEG2EI32_V_MF2_MF2_MASK, VSOXSEG2EI32_V, 0x7 }, // 10093
  { PseudoVSOXSEG2EI64_V_M1_M1, VSOXSEG2EI64_V, 0x0 }, // 10094
  { PseudoVSOXSEG2EI64_V_M1_M1_MASK, VSOXSEG2EI64_V, 0x0 }, // 10095
  { PseudoVSOXSEG2EI64_V_M2_M1, VSOXSEG2EI64_V, 0x0 }, // 10096
  { PseudoVSOXSEG2EI64_V_M2_M1_MASK, VSOXSEG2EI64_V, 0x0 }, // 10097
  { PseudoVSOXSEG2EI64_V_M4_M1, VSOXSEG2EI64_V, 0x0 }, // 10098
  { PseudoVSOXSEG2EI64_V_M4_M1_MASK, VSOXSEG2EI64_V, 0x0 }, // 10099
  { PseudoVSOXSEG2EI64_V_M8_M1, VSOXSEG2EI64_V, 0x0 }, // 10100
  { PseudoVSOXSEG2EI64_V_M8_M1_MASK, VSOXSEG2EI64_V, 0x0 }, // 10101
  { PseudoVSOXSEG2EI64_V_M2_M2, VSOXSEG2EI64_V, 0x1 }, // 10102
  { PseudoVSOXSEG2EI64_V_M2_M2_MASK, VSOXSEG2EI64_V, 0x1 }, // 10103
  { PseudoVSOXSEG2EI64_V_M4_M2, VSOXSEG2EI64_V, 0x1 }, // 10104
  { PseudoVSOXSEG2EI64_V_M4_M2_MASK, VSOXSEG2EI64_V, 0x1 }, // 10105
  { PseudoVSOXSEG2EI64_V_M8_M2, VSOXSEG2EI64_V, 0x1 }, // 10106
  { PseudoVSOXSEG2EI64_V_M8_M2_MASK, VSOXSEG2EI64_V, 0x1 }, // 10107
  { PseudoVSOXSEG2EI64_V_M4_M4, VSOXSEG2EI64_V, 0x2 }, // 10108
  { PseudoVSOXSEG2EI64_V_M4_M4_MASK, VSOXSEG2EI64_V, 0x2 }, // 10109
  { PseudoVSOXSEG2EI64_V_M8_M4, VSOXSEG2EI64_V, 0x2 }, // 10110
  { PseudoVSOXSEG2EI64_V_M8_M4_MASK, VSOXSEG2EI64_V, 0x2 }, // 10111
  { PseudoVSOXSEG2EI64_V_M1_MF8, VSOXSEG2EI64_V, 0x5 }, // 10112
  { PseudoVSOXSEG2EI64_V_M1_MF8_MASK, VSOXSEG2EI64_V, 0x5 }, // 10113
  { PseudoVSOXSEG2EI64_V_M1_MF4, VSOXSEG2EI64_V, 0x6 }, // 10114
  { PseudoVSOXSEG2EI64_V_M1_MF4_MASK, VSOXSEG2EI64_V, 0x6 }, // 10115
  { PseudoVSOXSEG2EI64_V_M2_MF4, VSOXSEG2EI64_V, 0x6 }, // 10116
  { PseudoVSOXSEG2EI64_V_M2_MF4_MASK, VSOXSEG2EI64_V, 0x6 }, // 10117
  { PseudoVSOXSEG2EI64_V_M1_MF2, VSOXSEG2EI64_V, 0x7 }, // 10118
  { PseudoVSOXSEG2EI64_V_M1_MF2_MASK, VSOXSEG2EI64_V, 0x7 }, // 10119
  { PseudoVSOXSEG2EI64_V_M2_MF2, VSOXSEG2EI64_V, 0x7 }, // 10120
  { PseudoVSOXSEG2EI64_V_M2_MF2_MASK, VSOXSEG2EI64_V, 0x7 }, // 10121
  { PseudoVSOXSEG2EI64_V_M4_MF2, VSOXSEG2EI64_V, 0x7 }, // 10122
  { PseudoVSOXSEG2EI64_V_M4_MF2_MASK, VSOXSEG2EI64_V, 0x7 }, // 10123
  { PseudoVSOXSEG2EI8_V_M1_M1, VSOXSEG2EI8_V, 0x0 }, // 10124
  { PseudoVSOXSEG2EI8_V_M1_M1_MASK, VSOXSEG2EI8_V, 0x0 }, // 10125
  { PseudoVSOXSEG2EI8_V_MF2_M1, VSOXSEG2EI8_V, 0x0 }, // 10126
  { PseudoVSOXSEG2EI8_V_MF2_M1_MASK, VSOXSEG2EI8_V, 0x0 }, // 10127
  { PseudoVSOXSEG2EI8_V_MF4_M1, VSOXSEG2EI8_V, 0x0 }, // 10128
  { PseudoVSOXSEG2EI8_V_MF4_M1_MASK, VSOXSEG2EI8_V, 0x0 }, // 10129
  { PseudoVSOXSEG2EI8_V_MF8_M1, VSOXSEG2EI8_V, 0x0 }, // 10130
  { PseudoVSOXSEG2EI8_V_MF8_M1_MASK, VSOXSEG2EI8_V, 0x0 }, // 10131
  { PseudoVSOXSEG2EI8_V_M1_M2, VSOXSEG2EI8_V, 0x1 }, // 10132
  { PseudoVSOXSEG2EI8_V_M1_M2_MASK, VSOXSEG2EI8_V, 0x1 }, // 10133
  { PseudoVSOXSEG2EI8_V_M2_M2, VSOXSEG2EI8_V, 0x1 }, // 10134
  { PseudoVSOXSEG2EI8_V_M2_M2_MASK, VSOXSEG2EI8_V, 0x1 }, // 10135
  { PseudoVSOXSEG2EI8_V_MF2_M2, VSOXSEG2EI8_V, 0x1 }, // 10136
  { PseudoVSOXSEG2EI8_V_MF2_M2_MASK, VSOXSEG2EI8_V, 0x1 }, // 10137
  { PseudoVSOXSEG2EI8_V_MF4_M2, VSOXSEG2EI8_V, 0x1 }, // 10138
  { PseudoVSOXSEG2EI8_V_MF4_M2_MASK, VSOXSEG2EI8_V, 0x1 }, // 10139
  { PseudoVSOXSEG2EI8_V_M1_M4, VSOXSEG2EI8_V, 0x2 }, // 10140
  { PseudoVSOXSEG2EI8_V_M1_M4_MASK, VSOXSEG2EI8_V, 0x2 }, // 10141
  { PseudoVSOXSEG2EI8_V_M2_M4, VSOXSEG2EI8_V, 0x2 }, // 10142
  { PseudoVSOXSEG2EI8_V_M2_M4_MASK, VSOXSEG2EI8_V, 0x2 }, // 10143
  { PseudoVSOXSEG2EI8_V_M4_M4, VSOXSEG2EI8_V, 0x2 }, // 10144
  { PseudoVSOXSEG2EI8_V_M4_M4_MASK, VSOXSEG2EI8_V, 0x2 }, // 10145
  { PseudoVSOXSEG2EI8_V_MF2_M4, VSOXSEG2EI8_V, 0x2 }, // 10146
  { PseudoVSOXSEG2EI8_V_MF2_M4_MASK, VSOXSEG2EI8_V, 0x2 }, // 10147
  { PseudoVSOXSEG2EI8_V_MF8_MF8, VSOXSEG2EI8_V, 0x5 }, // 10148
  { PseudoVSOXSEG2EI8_V_MF8_MF8_MASK, VSOXSEG2EI8_V, 0x5 }, // 10149
  { PseudoVSOXSEG2EI8_V_MF4_MF4, VSOXSEG2EI8_V, 0x6 }, // 10150
  { PseudoVSOXSEG2EI8_V_MF4_MF4_MASK, VSOXSEG2EI8_V, 0x6 }, // 10151
  { PseudoVSOXSEG2EI8_V_MF8_MF4, VSOXSEG2EI8_V, 0x6 }, // 10152
  { PseudoVSOXSEG2EI8_V_MF8_MF4_MASK, VSOXSEG2EI8_V, 0x6 }, // 10153
  { PseudoVSOXSEG2EI8_V_MF2_MF2, VSOXSEG2EI8_V, 0x7 }, // 10154
  { PseudoVSOXSEG2EI8_V_MF2_MF2_MASK, VSOXSEG2EI8_V, 0x7 }, // 10155
  { PseudoVSOXSEG2EI8_V_MF4_MF2, VSOXSEG2EI8_V, 0x7 }, // 10156
  { PseudoVSOXSEG2EI8_V_MF4_MF2_MASK, VSOXSEG2EI8_V, 0x7 }, // 10157
  { PseudoVSOXSEG2EI8_V_MF8_MF2, VSOXSEG2EI8_V, 0x7 }, // 10158
  { PseudoVSOXSEG2EI8_V_MF8_MF2_MASK, VSOXSEG2EI8_V, 0x7 }, // 10159
  { PseudoVSOXSEG3EI16_V_M1_M1, VSOXSEG3EI16_V, 0x0 }, // 10160
  { PseudoVSOXSEG3EI16_V_M1_M1_MASK, VSOXSEG3EI16_V, 0x0 }, // 10161
  { PseudoVSOXSEG3EI16_V_M2_M1, VSOXSEG3EI16_V, 0x0 }, // 10162
  { PseudoVSOXSEG3EI16_V_M2_M1_MASK, VSOXSEG3EI16_V, 0x0 }, // 10163
  { PseudoVSOXSEG3EI16_V_MF2_M1, VSOXSEG3EI16_V, 0x0 }, // 10164
  { PseudoVSOXSEG3EI16_V_MF2_M1_MASK, VSOXSEG3EI16_V, 0x0 }, // 10165
  { PseudoVSOXSEG3EI16_V_MF4_M1, VSOXSEG3EI16_V, 0x0 }, // 10166
  { PseudoVSOXSEG3EI16_V_MF4_M1_MASK, VSOXSEG3EI16_V, 0x0 }, // 10167
  { PseudoVSOXSEG3EI16_V_M1_M2, VSOXSEG3EI16_V, 0x1 }, // 10168
  { PseudoVSOXSEG3EI16_V_M1_M2_MASK, VSOXSEG3EI16_V, 0x1 }, // 10169
  { PseudoVSOXSEG3EI16_V_M2_M2, VSOXSEG3EI16_V, 0x1 }, // 10170
  { PseudoVSOXSEG3EI16_V_M2_M2_MASK, VSOXSEG3EI16_V, 0x1 }, // 10171
  { PseudoVSOXSEG3EI16_V_M4_M2, VSOXSEG3EI16_V, 0x1 }, // 10172
  { PseudoVSOXSEG3EI16_V_M4_M2_MASK, VSOXSEG3EI16_V, 0x1 }, // 10173
  { PseudoVSOXSEG3EI16_V_MF2_M2, VSOXSEG3EI16_V, 0x1 }, // 10174
  { PseudoVSOXSEG3EI16_V_MF2_M2_MASK, VSOXSEG3EI16_V, 0x1 }, // 10175
  { PseudoVSOXSEG3EI16_V_MF4_MF8, VSOXSEG3EI16_V, 0x5 }, // 10176
  { PseudoVSOXSEG3EI16_V_MF4_MF8_MASK, VSOXSEG3EI16_V, 0x5 }, // 10177
  { PseudoVSOXSEG3EI16_V_MF2_MF4, VSOXSEG3EI16_V, 0x6 }, // 10178
  { PseudoVSOXSEG3EI16_V_MF2_MF4_MASK, VSOXSEG3EI16_V, 0x6 }, // 10179
  { PseudoVSOXSEG3EI16_V_MF4_MF4, VSOXSEG3EI16_V, 0x6 }, // 10180
  { PseudoVSOXSEG3EI16_V_MF4_MF4_MASK, VSOXSEG3EI16_V, 0x6 }, // 10181
  { PseudoVSOXSEG3EI16_V_M1_MF2, VSOXSEG3EI16_V, 0x7 }, // 10182
  { PseudoVSOXSEG3EI16_V_M1_MF2_MASK, VSOXSEG3EI16_V, 0x7 }, // 10183
  { PseudoVSOXSEG3EI16_V_MF2_MF2, VSOXSEG3EI16_V, 0x7 }, // 10184
  { PseudoVSOXSEG3EI16_V_MF2_MF2_MASK, VSOXSEG3EI16_V, 0x7 }, // 10185
  { PseudoVSOXSEG3EI16_V_MF4_MF2, VSOXSEG3EI16_V, 0x7 }, // 10186
  { PseudoVSOXSEG3EI16_V_MF4_MF2_MASK, VSOXSEG3EI16_V, 0x7 }, // 10187
  { PseudoVSOXSEG3EI32_V_M1_M1, VSOXSEG3EI32_V, 0x0 }, // 10188
  { PseudoVSOXSEG3EI32_V_M1_M1_MASK, VSOXSEG3EI32_V, 0x0 }, // 10189
  { PseudoVSOXSEG3EI32_V_M2_M1, VSOXSEG3EI32_V, 0x0 }, // 10190
  { PseudoVSOXSEG3EI32_V_M2_M1_MASK, VSOXSEG3EI32_V, 0x0 }, // 10191
  { PseudoVSOXSEG3EI32_V_M4_M1, VSOXSEG3EI32_V, 0x0 }, // 10192
  { PseudoVSOXSEG3EI32_V_M4_M1_MASK, VSOXSEG3EI32_V, 0x0 }, // 10193
  { PseudoVSOXSEG3EI32_V_MF2_M1, VSOXSEG3EI32_V, 0x0 }, // 10194
  { PseudoVSOXSEG3EI32_V_MF2_M1_MASK, VSOXSEG3EI32_V, 0x0 }, // 10195
  { PseudoVSOXSEG3EI32_V_M1_M2, VSOXSEG3EI32_V, 0x1 }, // 10196
  { PseudoVSOXSEG3EI32_V_M1_M2_MASK, VSOXSEG3EI32_V, 0x1 }, // 10197
  { PseudoVSOXSEG3EI32_V_M2_M2, VSOXSEG3EI32_V, 0x1 }, // 10198
  { PseudoVSOXSEG3EI32_V_M2_M2_MASK, VSOXSEG3EI32_V, 0x1 }, // 10199
  { PseudoVSOXSEG3EI32_V_M4_M2, VSOXSEG3EI32_V, 0x1 }, // 10200
  { PseudoVSOXSEG3EI32_V_M4_M2_MASK, VSOXSEG3EI32_V, 0x1 }, // 10201
  { PseudoVSOXSEG3EI32_V_M8_M2, VSOXSEG3EI32_V, 0x1 }, // 10202
  { PseudoVSOXSEG3EI32_V_M8_M2_MASK, VSOXSEG3EI32_V, 0x1 }, // 10203
  { PseudoVSOXSEG3EI32_V_MF2_MF8, VSOXSEG3EI32_V, 0x5 }, // 10204
  { PseudoVSOXSEG3EI32_V_MF2_MF8_MASK, VSOXSEG3EI32_V, 0x5 }, // 10205
  { PseudoVSOXSEG3EI32_V_M1_MF4, VSOXSEG3EI32_V, 0x6 }, // 10206
  { PseudoVSOXSEG3EI32_V_M1_MF4_MASK, VSOXSEG3EI32_V, 0x6 }, // 10207
  { PseudoVSOXSEG3EI32_V_MF2_MF4, VSOXSEG3EI32_V, 0x6 }, // 10208
  { PseudoVSOXSEG3EI32_V_MF2_MF4_MASK, VSOXSEG3EI32_V, 0x6 }, // 10209
  { PseudoVSOXSEG3EI32_V_M1_MF2, VSOXSEG3EI32_V, 0x7 }, // 10210
  { PseudoVSOXSEG3EI32_V_M1_MF2_MASK, VSOXSEG3EI32_V, 0x7 }, // 10211
  { PseudoVSOXSEG3EI32_V_M2_MF2, VSOXSEG3EI32_V, 0x7 }, // 10212
  { PseudoVSOXSEG3EI32_V_M2_MF2_MASK, VSOXSEG3EI32_V, 0x7 }, // 10213
  { PseudoVSOXSEG3EI32_V_MF2_MF2, VSOXSEG3EI32_V, 0x7 }, // 10214
  { PseudoVSOXSEG3EI32_V_MF2_MF2_MASK, VSOXSEG3EI32_V, 0x7 }, // 10215
  { PseudoVSOXSEG3EI64_V_M1_M1, VSOXSEG3EI64_V, 0x0 }, // 10216
  { PseudoVSOXSEG3EI64_V_M1_M1_MASK, VSOXSEG3EI64_V, 0x0 }, // 10217
  { PseudoVSOXSEG3EI64_V_M2_M1, VSOXSEG3EI64_V, 0x0 }, // 10218
  { PseudoVSOXSEG3EI64_V_M2_M1_MASK, VSOXSEG3EI64_V, 0x0 }, // 10219
  { PseudoVSOXSEG3EI64_V_M4_M1, VSOXSEG3EI64_V, 0x0 }, // 10220
  { PseudoVSOXSEG3EI64_V_M4_M1_MASK, VSOXSEG3EI64_V, 0x0 }, // 10221
  { PseudoVSOXSEG3EI64_V_M8_M1, VSOXSEG3EI64_V, 0x0 }, // 10222
  { PseudoVSOXSEG3EI64_V_M8_M1_MASK, VSOXSEG3EI64_V, 0x0 }, // 10223
  { PseudoVSOXSEG3EI64_V_M2_M2, VSOXSEG3EI64_V, 0x1 }, // 10224
  { PseudoVSOXSEG3EI64_V_M2_M2_MASK, VSOXSEG3EI64_V, 0x1 }, // 10225
  { PseudoVSOXSEG3EI64_V_M4_M2, VSOXSEG3EI64_V, 0x1 }, // 10226
  { PseudoVSOXSEG3EI64_V_M4_M2_MASK, VSOXSEG3EI64_V, 0x1 }, // 10227
  { PseudoVSOXSEG3EI64_V_M8_M2, VSOXSEG3EI64_V, 0x1 }, // 10228
  { PseudoVSOXSEG3EI64_V_M8_M2_MASK, VSOXSEG3EI64_V, 0x1 }, // 10229
  { PseudoVSOXSEG3EI64_V_M1_MF8, VSOXSEG3EI64_V, 0x5 }, // 10230
  { PseudoVSOXSEG3EI64_V_M1_MF8_MASK, VSOXSEG3EI64_V, 0x5 }, // 10231
  { PseudoVSOXSEG3EI64_V_M1_MF4, VSOXSEG3EI64_V, 0x6 }, // 10232
  { PseudoVSOXSEG3EI64_V_M1_MF4_MASK, VSOXSEG3EI64_V, 0x6 }, // 10233
  { PseudoVSOXSEG3EI64_V_M2_MF4, VSOXSEG3EI64_V, 0x6 }, // 10234
  { PseudoVSOXSEG3EI64_V_M2_MF4_MASK, VSOXSEG3EI64_V, 0x6 }, // 10235
  { PseudoVSOXSEG3EI64_V_M1_MF2, VSOXSEG3EI64_V, 0x7 }, // 10236
  { PseudoVSOXSEG3EI64_V_M1_MF2_MASK, VSOXSEG3EI64_V, 0x7 }, // 10237
  { PseudoVSOXSEG3EI64_V_M2_MF2, VSOXSEG3EI64_V, 0x7 }, // 10238
  { PseudoVSOXSEG3EI64_V_M2_MF2_MASK, VSOXSEG3EI64_V, 0x7 }, // 10239
  { PseudoVSOXSEG3EI64_V_M4_MF2, VSOXSEG3EI64_V, 0x7 }, // 10240
  { PseudoVSOXSEG3EI64_V_M4_MF2_MASK, VSOXSEG3EI64_V, 0x7 }, // 10241
  { PseudoVSOXSEG3EI8_V_M1_M1, VSOXSEG3EI8_V, 0x0 }, // 10242
  { PseudoVSOXSEG3EI8_V_M1_M1_MASK, VSOXSEG3EI8_V, 0x0 }, // 10243
  { PseudoVSOXSEG3EI8_V_MF2_M1, VSOXSEG3EI8_V, 0x0 }, // 10244
  { PseudoVSOXSEG3EI8_V_MF2_M1_MASK, VSOXSEG3EI8_V, 0x0 }, // 10245
  { PseudoVSOXSEG3EI8_V_MF4_M1, VSOXSEG3EI8_V, 0x0 }, // 10246
  { PseudoVSOXSEG3EI8_V_MF4_M1_MASK, VSOXSEG3EI8_V, 0x0 }, // 10247
  { PseudoVSOXSEG3EI8_V_MF8_M1, VSOXSEG3EI8_V, 0x0 }, // 10248
  { PseudoVSOXSEG3EI8_V_MF8_M1_MASK, VSOXSEG3EI8_V, 0x0 }, // 10249
  { PseudoVSOXSEG3EI8_V_M1_M2, VSOXSEG3EI8_V, 0x1 }, // 10250
  { PseudoVSOXSEG3EI8_V_M1_M2_MASK, VSOXSEG3EI8_V, 0x1 }, // 10251
  { PseudoVSOXSEG3EI8_V_M2_M2, VSOXSEG3EI8_V, 0x1 }, // 10252
  { PseudoVSOXSEG3EI8_V_M2_M2_MASK, VSOXSEG3EI8_V, 0x1 }, // 10253
  { PseudoVSOXSEG3EI8_V_MF2_M2, VSOXSEG3EI8_V, 0x1 }, // 10254
  { PseudoVSOXSEG3EI8_V_MF2_M2_MASK, VSOXSEG3EI8_V, 0x1 }, // 10255
  { PseudoVSOXSEG3EI8_V_MF4_M2, VSOXSEG3EI8_V, 0x1 }, // 10256
  { PseudoVSOXSEG3EI8_V_MF4_M2_MASK, VSOXSEG3EI8_V, 0x1 }, // 10257
  { PseudoVSOXSEG3EI8_V_MF8_MF8, VSOXSEG3EI8_V, 0x5 }, // 10258
  { PseudoVSOXSEG3EI8_V_MF8_MF8_MASK, VSOXSEG3EI8_V, 0x5 }, // 10259
  { PseudoVSOXSEG3EI8_V_MF4_MF4, VSOXSEG3EI8_V, 0x6 }, // 10260
  { PseudoVSOXSEG3EI8_V_MF4_MF4_MASK, VSOXSEG3EI8_V, 0x6 }, // 10261
  { PseudoVSOXSEG3EI8_V_MF8_MF4, VSOXSEG3EI8_V, 0x6 }, // 10262
  { PseudoVSOXSEG3EI8_V_MF8_MF4_MASK, VSOXSEG3EI8_V, 0x6 }, // 10263
  { PseudoVSOXSEG3EI8_V_MF2_MF2, VSOXSEG3EI8_V, 0x7 }, // 10264
  { PseudoVSOXSEG3EI8_V_MF2_MF2_MASK, VSOXSEG3EI8_V, 0x7 }, // 10265
  { PseudoVSOXSEG3EI8_V_MF4_MF2, VSOXSEG3EI8_V, 0x7 }, // 10266
  { PseudoVSOXSEG3EI8_V_MF4_MF2_MASK, VSOXSEG3EI8_V, 0x7 }, // 10267
  { PseudoVSOXSEG3EI8_V_MF8_MF2, VSOXSEG3EI8_V, 0x7 }, // 10268
  { PseudoVSOXSEG3EI8_V_MF8_MF2_MASK, VSOXSEG3EI8_V, 0x7 }, // 10269
  { PseudoVSOXSEG4EI16_V_M1_M1, VSOXSEG4EI16_V, 0x0 }, // 10270
  { PseudoVSOXSEG4EI16_V_M1_M1_MASK, VSOXSEG4EI16_V, 0x0 }, // 10271
  { PseudoVSOXSEG4EI16_V_M2_M1, VSOXSEG4EI16_V, 0x0 }, // 10272
  { PseudoVSOXSEG4EI16_V_M2_M1_MASK, VSOXSEG4EI16_V, 0x0 }, // 10273
  { PseudoVSOXSEG4EI16_V_MF2_M1, VSOXSEG4EI16_V, 0x0 }, // 10274
  { PseudoVSOXSEG4EI16_V_MF2_M1_MASK, VSOXSEG4EI16_V, 0x0 }, // 10275
  { PseudoVSOXSEG4EI16_V_MF4_M1, VSOXSEG4EI16_V, 0x0 }, // 10276
  { PseudoVSOXSEG4EI16_V_MF4_M1_MASK, VSOXSEG4EI16_V, 0x0 }, // 10277
  { PseudoVSOXSEG4EI16_V_M1_M2, VSOXSEG4EI16_V, 0x1 }, // 10278
  { PseudoVSOXSEG4EI16_V_M1_M2_MASK, VSOXSEG4EI16_V, 0x1 }, // 10279
  { PseudoVSOXSEG4EI16_V_M2_M2, VSOXSEG4EI16_V, 0x1 }, // 10280
  { PseudoVSOXSEG4EI16_V_M2_M2_MASK, VSOXSEG4EI16_V, 0x1 }, // 10281
  { PseudoVSOXSEG4EI16_V_M4_M2, VSOXSEG4EI16_V, 0x1 }, // 10282
  { PseudoVSOXSEG4EI16_V_M4_M2_MASK, VSOXSEG4EI16_V, 0x1 }, // 10283
  { PseudoVSOXSEG4EI16_V_MF2_M2, VSOXSEG4EI16_V, 0x1 }, // 10284
  { PseudoVSOXSEG4EI16_V_MF2_M2_MASK, VSOXSEG4EI16_V, 0x1 }, // 10285
  { PseudoVSOXSEG4EI16_V_MF4_MF8, VSOXSEG4EI16_V, 0x5 }, // 10286
  { PseudoVSOXSEG4EI16_V_MF4_MF8_MASK, VSOXSEG4EI16_V, 0x5 }, // 10287
  { PseudoVSOXSEG4EI16_V_MF2_MF4, VSOXSEG4EI16_V, 0x6 }, // 10288
  { PseudoVSOXSEG4EI16_V_MF2_MF4_MASK, VSOXSEG4EI16_V, 0x6 }, // 10289
  { PseudoVSOXSEG4EI16_V_MF4_MF4, VSOXSEG4EI16_V, 0x6 }, // 10290
  { PseudoVSOXSEG4EI16_V_MF4_MF4_MASK, VSOXSEG4EI16_V, 0x6 }, // 10291
  { PseudoVSOXSEG4EI16_V_M1_MF2, VSOXSEG4EI16_V, 0x7 }, // 10292
  { PseudoVSOXSEG4EI16_V_M1_MF2_MASK, VSOXSEG4EI16_V, 0x7 }, // 10293
  { PseudoVSOXSEG4EI16_V_MF2_MF2, VSOXSEG4EI16_V, 0x7 }, // 10294
  { PseudoVSOXSEG4EI16_V_MF2_MF2_MASK, VSOXSEG4EI16_V, 0x7 }, // 10295
  { PseudoVSOXSEG4EI16_V_MF4_MF2, VSOXSEG4EI16_V, 0x7 }, // 10296
  { PseudoVSOXSEG4EI16_V_MF4_MF2_MASK, VSOXSEG4EI16_V, 0x7 }, // 10297
  { PseudoVSOXSEG4EI32_V_M1_M1, VSOXSEG4EI32_V, 0x0 }, // 10298
  { PseudoVSOXSEG4EI32_V_M1_M1_MASK, VSOXSEG4EI32_V, 0x0 }, // 10299
  { PseudoVSOXSEG4EI32_V_M2_M1, VSOXSEG4EI32_V, 0x0 }, // 10300
  { PseudoVSOXSEG4EI32_V_M2_M1_MASK, VSOXSEG4EI32_V, 0x0 }, // 10301
  { PseudoVSOXSEG4EI32_V_M4_M1, VSOXSEG4EI32_V, 0x0 }, // 10302
  { PseudoVSOXSEG4EI32_V_M4_M1_MASK, VSOXSEG4EI32_V, 0x0 }, // 10303
  { PseudoVSOXSEG4EI32_V_MF2_M1, VSOXSEG4EI32_V, 0x0 }, // 10304
  { PseudoVSOXSEG4EI32_V_MF2_M1_MASK, VSOXSEG4EI32_V, 0x0 }, // 10305
  { PseudoVSOXSEG4EI32_V_M1_M2, VSOXSEG4EI32_V, 0x1 }, // 10306
  { PseudoVSOXSEG4EI32_V_M1_M2_MASK, VSOXSEG4EI32_V, 0x1 }, // 10307
  { PseudoVSOXSEG4EI32_V_M2_M2, VSOXSEG4EI32_V, 0x1 }, // 10308
  { PseudoVSOXSEG4EI32_V_M2_M2_MASK, VSOXSEG4EI32_V, 0x1 }, // 10309
  { PseudoVSOXSEG4EI32_V_M4_M2, VSOXSEG4EI32_V, 0x1 }, // 10310
  { PseudoVSOXSEG4EI32_V_M4_M2_MASK, VSOXSEG4EI32_V, 0x1 }, // 10311
  { PseudoVSOXSEG4EI32_V_M8_M2, VSOXSEG4EI32_V, 0x1 }, // 10312
  { PseudoVSOXSEG4EI32_V_M8_M2_MASK, VSOXSEG4EI32_V, 0x1 }, // 10313
  { PseudoVSOXSEG4EI32_V_MF2_MF8, VSOXSEG4EI32_V, 0x5 }, // 10314
  { PseudoVSOXSEG4EI32_V_MF2_MF8_MASK, VSOXSEG4EI32_V, 0x5 }, // 10315
  { PseudoVSOXSEG4EI32_V_M1_MF4, VSOXSEG4EI32_V, 0x6 }, // 10316
  { PseudoVSOXSEG4EI32_V_M1_MF4_MASK, VSOXSEG4EI32_V, 0x6 }, // 10317
  { PseudoVSOXSEG4EI32_V_MF2_MF4, VSOXSEG4EI32_V, 0x6 }, // 10318
  { PseudoVSOXSEG4EI32_V_MF2_MF4_MASK, VSOXSEG4EI32_V, 0x6 }, // 10319
  { PseudoVSOXSEG4EI32_V_M1_MF2, VSOXSEG4EI32_V, 0x7 }, // 10320
  { PseudoVSOXSEG4EI32_V_M1_MF2_MASK, VSOXSEG4EI32_V, 0x7 }, // 10321
  { PseudoVSOXSEG4EI32_V_M2_MF2, VSOXSEG4EI32_V, 0x7 }, // 10322
  { PseudoVSOXSEG4EI32_V_M2_MF2_MASK, VSOXSEG4EI32_V, 0x7 }, // 10323
  { PseudoVSOXSEG4EI32_V_MF2_MF2, VSOXSEG4EI32_V, 0x7 }, // 10324
  { PseudoVSOXSEG4EI32_V_MF2_MF2_MASK, VSOXSEG4EI32_V, 0x7 }, // 10325
  { PseudoVSOXSEG4EI64_V_M1_M1, VSOXSEG4EI64_V, 0x0 }, // 10326
  { PseudoVSOXSEG4EI64_V_M1_M1_MASK, VSOXSEG4EI64_V, 0x0 }, // 10327
  { PseudoVSOXSEG4EI64_V_M2_M1, VSOXSEG4EI64_V, 0x0 }, // 10328
  { PseudoVSOXSEG4EI64_V_M2_M1_MASK, VSOXSEG4EI64_V, 0x0 }, // 10329
  { PseudoVSOXSEG4EI64_V_M4_M1, VSOXSEG4EI64_V, 0x0 }, // 10330
  { PseudoVSOXSEG4EI64_V_M4_M1_MASK, VSOXSEG4EI64_V, 0x0 }, // 10331
  { PseudoVSOXSEG4EI64_V_M8_M1, VSOXSEG4EI64_V, 0x0 }, // 10332
  { PseudoVSOXSEG4EI64_V_M8_M1_MASK, VSOXSEG4EI64_V, 0x0 }, // 10333
  { PseudoVSOXSEG4EI64_V_M2_M2, VSOXSEG4EI64_V, 0x1 }, // 10334
  { PseudoVSOXSEG4EI64_V_M2_M2_MASK, VSOXSEG4EI64_V, 0x1 }, // 10335
  { PseudoVSOXSEG4EI64_V_M4_M2, VSOXSEG4EI64_V, 0x1 }, // 10336
  { PseudoVSOXSEG4EI64_V_M4_M2_MASK, VSOXSEG4EI64_V, 0x1 }, // 10337
  { PseudoVSOXSEG4EI64_V_M8_M2, VSOXSEG4EI64_V, 0x1 }, // 10338
  { PseudoVSOXSEG4EI64_V_M8_M2_MASK, VSOXSEG4EI64_V, 0x1 }, // 10339
  { PseudoVSOXSEG4EI64_V_M1_MF8, VSOXSEG4EI64_V, 0x5 }, // 10340
  { PseudoVSOXSEG4EI64_V_M1_MF8_MASK, VSOXSEG4EI64_V, 0x5 }, // 10341
  { PseudoVSOXSEG4EI64_V_M1_MF4, VSOXSEG4EI64_V, 0x6 }, // 10342
  { PseudoVSOXSEG4EI64_V_M1_MF4_MASK, VSOXSEG4EI64_V, 0x6 }, // 10343
  { PseudoVSOXSEG4EI64_V_M2_MF4, VSOXSEG4EI64_V, 0x6 }, // 10344
  { PseudoVSOXSEG4EI64_V_M2_MF4_MASK, VSOXSEG4EI64_V, 0x6 }, // 10345
  { PseudoVSOXSEG4EI64_V_M1_MF2, VSOXSEG4EI64_V, 0x7 }, // 10346
  { PseudoVSOXSEG4EI64_V_M1_MF2_MASK, VSOXSEG4EI64_V, 0x7 }, // 10347
  { PseudoVSOXSEG4EI64_V_M2_MF2, VSOXSEG4EI64_V, 0x7 }, // 10348
  { PseudoVSOXSEG4EI64_V_M2_MF2_MASK, VSOXSEG4EI64_V, 0x7 }, // 10349
  { PseudoVSOXSEG4EI64_V_M4_MF2, VSOXSEG4EI64_V, 0x7 }, // 10350
  { PseudoVSOXSEG4EI64_V_M4_MF2_MASK, VSOXSEG4EI64_V, 0x7 }, // 10351
  { PseudoVSOXSEG4EI8_V_M1_M1, VSOXSEG4EI8_V, 0x0 }, // 10352
  { PseudoVSOXSEG4EI8_V_M1_M1_MASK, VSOXSEG4EI8_V, 0x0 }, // 10353
  { PseudoVSOXSEG4EI8_V_MF2_M1, VSOXSEG4EI8_V, 0x0 }, // 10354
  { PseudoVSOXSEG4EI8_V_MF2_M1_MASK, VSOXSEG4EI8_V, 0x0 }, // 10355
  { PseudoVSOXSEG4EI8_V_MF4_M1, VSOXSEG4EI8_V, 0x0 }, // 10356
  { PseudoVSOXSEG4EI8_V_MF4_M1_MASK, VSOXSEG4EI8_V, 0x0 }, // 10357
  { PseudoVSOXSEG4EI8_V_MF8_M1, VSOXSEG4EI8_V, 0x0 }, // 10358
  { PseudoVSOXSEG4EI8_V_MF8_M1_MASK, VSOXSEG4EI8_V, 0x0 }, // 10359
  { PseudoVSOXSEG4EI8_V_M1_M2, VSOXSEG4EI8_V, 0x1 }, // 10360
  { PseudoVSOXSEG4EI8_V_M1_M2_MASK, VSOXSEG4EI8_V, 0x1 }, // 10361
  { PseudoVSOXSEG4EI8_V_M2_M2, VSOXSEG4EI8_V, 0x1 }, // 10362
  { PseudoVSOXSEG4EI8_V_M2_M2_MASK, VSOXSEG4EI8_V, 0x1 }, // 10363
  { PseudoVSOXSEG4EI8_V_MF2_M2, VSOXSEG4EI8_V, 0x1 }, // 10364
  { PseudoVSOXSEG4EI8_V_MF2_M2_MASK, VSOXSEG4EI8_V, 0x1 }, // 10365
  { PseudoVSOXSEG4EI8_V_MF4_M2, VSOXSEG4EI8_V, 0x1 }, // 10366
  { PseudoVSOXSEG4EI8_V_MF4_M2_MASK, VSOXSEG4EI8_V, 0x1 }, // 10367
  { PseudoVSOXSEG4EI8_V_MF8_MF8, VSOXSEG4EI8_V, 0x5 }, // 10368
  { PseudoVSOXSEG4EI8_V_MF8_MF8_MASK, VSOXSEG4EI8_V, 0x5 }, // 10369
  { PseudoVSOXSEG4EI8_V_MF4_MF4, VSOXSEG4EI8_V, 0x6 }, // 10370
  { PseudoVSOXSEG4EI8_V_MF4_MF4_MASK, VSOXSEG4EI8_V, 0x6 }, // 10371
  { PseudoVSOXSEG4EI8_V_MF8_MF4, VSOXSEG4EI8_V, 0x6 }, // 10372
  { PseudoVSOXSEG4EI8_V_MF8_MF4_MASK, VSOXSEG4EI8_V, 0x6 }, // 10373
  { PseudoVSOXSEG4EI8_V_MF2_MF2, VSOXSEG4EI8_V, 0x7 }, // 10374
  { PseudoVSOXSEG4EI8_V_MF2_MF2_MASK, VSOXSEG4EI8_V, 0x7 }, // 10375
  { PseudoVSOXSEG4EI8_V_MF4_MF2, VSOXSEG4EI8_V, 0x7 }, // 10376
  { PseudoVSOXSEG4EI8_V_MF4_MF2_MASK, VSOXSEG4EI8_V, 0x7 }, // 10377
  { PseudoVSOXSEG4EI8_V_MF8_MF2, VSOXSEG4EI8_V, 0x7 }, // 10378
  { PseudoVSOXSEG4EI8_V_MF8_MF2_MASK, VSOXSEG4EI8_V, 0x7 }, // 10379
  { PseudoVSOXSEG5EI16_V_M1_M1, VSOXSEG5EI16_V, 0x0 }, // 10380
  { PseudoVSOXSEG5EI16_V_M1_M1_MASK, VSOXSEG5EI16_V, 0x0 }, // 10381
  { PseudoVSOXSEG5EI16_V_M2_M1, VSOXSEG5EI16_V, 0x0 }, // 10382
  { PseudoVSOXSEG5EI16_V_M2_M1_MASK, VSOXSEG5EI16_V, 0x0 }, // 10383
  { PseudoVSOXSEG5EI16_V_MF2_M1, VSOXSEG5EI16_V, 0x0 }, // 10384
  { PseudoVSOXSEG5EI16_V_MF2_M1_MASK, VSOXSEG5EI16_V, 0x0 }, // 10385
  { PseudoVSOXSEG5EI16_V_MF4_M1, VSOXSEG5EI16_V, 0x0 }, // 10386
  { PseudoVSOXSEG5EI16_V_MF4_M1_MASK, VSOXSEG5EI16_V, 0x0 }, // 10387
  { PseudoVSOXSEG5EI16_V_MF4_MF8, VSOXSEG5EI16_V, 0x5 }, // 10388
  { PseudoVSOXSEG5EI16_V_MF4_MF8_MASK, VSOXSEG5EI16_V, 0x5 }, // 10389
  { PseudoVSOXSEG5EI16_V_MF2_MF4, VSOXSEG5EI16_V, 0x6 }, // 10390
  { PseudoVSOXSEG5EI16_V_MF2_MF4_MASK, VSOXSEG5EI16_V, 0x6 }, // 10391
  { PseudoVSOXSEG5EI16_V_MF4_MF4, VSOXSEG5EI16_V, 0x6 }, // 10392
  { PseudoVSOXSEG5EI16_V_MF4_MF4_MASK, VSOXSEG5EI16_V, 0x6 }, // 10393
  { PseudoVSOXSEG5EI16_V_M1_MF2, VSOXSEG5EI16_V, 0x7 }, // 10394
  { PseudoVSOXSEG5EI16_V_M1_MF2_MASK, VSOXSEG5EI16_V, 0x7 }, // 10395
  { PseudoVSOXSEG5EI16_V_MF2_MF2, VSOXSEG5EI16_V, 0x7 }, // 10396
  { PseudoVSOXSEG5EI16_V_MF2_MF2_MASK, VSOXSEG5EI16_V, 0x7 }, // 10397
  { PseudoVSOXSEG5EI16_V_MF4_MF2, VSOXSEG5EI16_V, 0x7 }, // 10398
  { PseudoVSOXSEG5EI16_V_MF4_MF2_MASK, VSOXSEG5EI16_V, 0x7 }, // 10399
  { PseudoVSOXSEG5EI32_V_M1_M1, VSOXSEG5EI32_V, 0x0 }, // 10400
  { PseudoVSOXSEG5EI32_V_M1_M1_MASK, VSOXSEG5EI32_V, 0x0 }, // 10401
  { PseudoVSOXSEG5EI32_V_M2_M1, VSOXSEG5EI32_V, 0x0 }, // 10402
  { PseudoVSOXSEG5EI32_V_M2_M1_MASK, VSOXSEG5EI32_V, 0x0 }, // 10403
  { PseudoVSOXSEG5EI32_V_M4_M1, VSOXSEG5EI32_V, 0x0 }, // 10404
  { PseudoVSOXSEG5EI32_V_M4_M1_MASK, VSOXSEG5EI32_V, 0x0 }, // 10405
  { PseudoVSOXSEG5EI32_V_MF2_M1, VSOXSEG5EI32_V, 0x0 }, // 10406
  { PseudoVSOXSEG5EI32_V_MF2_M1_MASK, VSOXSEG5EI32_V, 0x0 }, // 10407
  { PseudoVSOXSEG5EI32_V_MF2_MF8, VSOXSEG5EI32_V, 0x5 }, // 10408
  { PseudoVSOXSEG5EI32_V_MF2_MF8_MASK, VSOXSEG5EI32_V, 0x5 }, // 10409
  { PseudoVSOXSEG5EI32_V_M1_MF4, VSOXSEG5EI32_V, 0x6 }, // 10410
  { PseudoVSOXSEG5EI32_V_M1_MF4_MASK, VSOXSEG5EI32_V, 0x6 }, // 10411
  { PseudoVSOXSEG5EI32_V_MF2_MF4, VSOXSEG5EI32_V, 0x6 }, // 10412
  { PseudoVSOXSEG5EI32_V_MF2_MF4_MASK, VSOXSEG5EI32_V, 0x6 }, // 10413
  { PseudoVSOXSEG5EI32_V_M1_MF2, VSOXSEG5EI32_V, 0x7 }, // 10414
  { PseudoVSOXSEG5EI32_V_M1_MF2_MASK, VSOXSEG5EI32_V, 0x7 }, // 10415
  { PseudoVSOXSEG5EI32_V_M2_MF2, VSOXSEG5EI32_V, 0x7 }, // 10416
  { PseudoVSOXSEG5EI32_V_M2_MF2_MASK, VSOXSEG5EI32_V, 0x7 }, // 10417
  { PseudoVSOXSEG5EI32_V_MF2_MF2, VSOXSEG5EI32_V, 0x7 }, // 10418
  { PseudoVSOXSEG5EI32_V_MF2_MF2_MASK, VSOXSEG5EI32_V, 0x7 }, // 10419
  { PseudoVSOXSEG5EI64_V_M1_M1, VSOXSEG5EI64_V, 0x0 }, // 10420
  { PseudoVSOXSEG5EI64_V_M1_M1_MASK, VSOXSEG5EI64_V, 0x0 }, // 10421
  { PseudoVSOXSEG5EI64_V_M2_M1, VSOXSEG5EI64_V, 0x0 }, // 10422
  { PseudoVSOXSEG5EI64_V_M2_M1_MASK, VSOXSEG5EI64_V, 0x0 }, // 10423
  { PseudoVSOXSEG5EI64_V_M4_M1, VSOXSEG5EI64_V, 0x0 }, // 10424
  { PseudoVSOXSEG5EI64_V_M4_M1_MASK, VSOXSEG5EI64_V, 0x0 }, // 10425
  { PseudoVSOXSEG5EI64_V_M8_M1, VSOXSEG5EI64_V, 0x0 }, // 10426
  { PseudoVSOXSEG5EI64_V_M8_M1_MASK, VSOXSEG5EI64_V, 0x0 }, // 10427
  { PseudoVSOXSEG5EI64_V_M1_MF8, VSOXSEG5EI64_V, 0x5 }, // 10428
  { PseudoVSOXSEG5EI64_V_M1_MF8_MASK, VSOXSEG5EI64_V, 0x5 }, // 10429
  { PseudoVSOXSEG5EI64_V_M1_MF4, VSOXSEG5EI64_V, 0x6 }, // 10430
  { PseudoVSOXSEG5EI64_V_M1_MF4_MASK, VSOXSEG5EI64_V, 0x6 }, // 10431
  { PseudoVSOXSEG5EI64_V_M2_MF4, VSOXSEG5EI64_V, 0x6 }, // 10432
  { PseudoVSOXSEG5EI64_V_M2_MF4_MASK, VSOXSEG5EI64_V, 0x6 }, // 10433
  { PseudoVSOXSEG5EI64_V_M1_MF2, VSOXSEG5EI64_V, 0x7 }, // 10434
  { PseudoVSOXSEG5EI64_V_M1_MF2_MASK, VSOXSEG5EI64_V, 0x7 }, // 10435
  { PseudoVSOXSEG5EI64_V_M2_MF2, VSOXSEG5EI64_V, 0x7 }, // 10436
  { PseudoVSOXSEG5EI64_V_M2_MF2_MASK, VSOXSEG5EI64_V, 0x7 }, // 10437
  { PseudoVSOXSEG5EI64_V_M4_MF2, VSOXSEG5EI64_V, 0x7 }, // 10438
  { PseudoVSOXSEG5EI64_V_M4_MF2_MASK, VSOXSEG5EI64_V, 0x7 }, // 10439
  { PseudoVSOXSEG5EI8_V_M1_M1, VSOXSEG5EI8_V, 0x0 }, // 10440
  { PseudoVSOXSEG5EI8_V_M1_M1_MASK, VSOXSEG5EI8_V, 0x0 }, // 10441
  { PseudoVSOXSEG5EI8_V_MF2_M1, VSOXSEG5EI8_V, 0x0 }, // 10442
  { PseudoVSOXSEG5EI8_V_MF2_M1_MASK, VSOXSEG5EI8_V, 0x0 }, // 10443
  { PseudoVSOXSEG5EI8_V_MF4_M1, VSOXSEG5EI8_V, 0x0 }, // 10444
  { PseudoVSOXSEG5EI8_V_MF4_M1_MASK, VSOXSEG5EI8_V, 0x0 }, // 10445
  { PseudoVSOXSEG5EI8_V_MF8_M1, VSOXSEG5EI8_V, 0x0 }, // 10446
  { PseudoVSOXSEG5EI8_V_MF8_M1_MASK, VSOXSEG5EI8_V, 0x0 }, // 10447
  { PseudoVSOXSEG5EI8_V_MF8_MF8, VSOXSEG5EI8_V, 0x5 }, // 10448
  { PseudoVSOXSEG5EI8_V_MF8_MF8_MASK, VSOXSEG5EI8_V, 0x5 }, // 10449
  { PseudoVSOXSEG5EI8_V_MF4_MF4, VSOXSEG5EI8_V, 0x6 }, // 10450
  { PseudoVSOXSEG5EI8_V_MF4_MF4_MASK, VSOXSEG5EI8_V, 0x6 }, // 10451
  { PseudoVSOXSEG5EI8_V_MF8_MF4, VSOXSEG5EI8_V, 0x6 }, // 10452
  { PseudoVSOXSEG5EI8_V_MF8_MF4_MASK, VSOXSEG5EI8_V, 0x6 }, // 10453
  { PseudoVSOXSEG5EI8_V_MF2_MF2, VSOXSEG5EI8_V, 0x7 }, // 10454
  { PseudoVSOXSEG5EI8_V_MF2_MF2_MASK, VSOXSEG5EI8_V, 0x7 }, // 10455
  { PseudoVSOXSEG5EI8_V_MF4_MF2, VSOXSEG5EI8_V, 0x7 }, // 10456
  { PseudoVSOXSEG5EI8_V_MF4_MF2_MASK, VSOXSEG5EI8_V, 0x7 }, // 10457
  { PseudoVSOXSEG5EI8_V_MF8_MF2, VSOXSEG5EI8_V, 0x7 }, // 10458
  { PseudoVSOXSEG5EI8_V_MF8_MF2_MASK, VSOXSEG5EI8_V, 0x7 }, // 10459
  { PseudoVSOXSEG6EI16_V_M1_M1, VSOXSEG6EI16_V, 0x0 }, // 10460
  { PseudoVSOXSEG6EI16_V_M1_M1_MASK, VSOXSEG6EI16_V, 0x0 }, // 10461
  { PseudoVSOXSEG6EI16_V_M2_M1, VSOXSEG6EI16_V, 0x0 }, // 10462
  { PseudoVSOXSEG6EI16_V_M2_M1_MASK, VSOXSEG6EI16_V, 0x0 }, // 10463
  { PseudoVSOXSEG6EI16_V_MF2_M1, VSOXSEG6EI16_V, 0x0 }, // 10464
  { PseudoVSOXSEG6EI16_V_MF2_M1_MASK, VSOXSEG6EI16_V, 0x0 }, // 10465
  { PseudoVSOXSEG6EI16_V_MF4_M1, VSOXSEG6EI16_V, 0x0 }, // 10466
  { PseudoVSOXSEG6EI16_V_MF4_M1_MASK, VSOXSEG6EI16_V, 0x0 }, // 10467
  { PseudoVSOXSEG6EI16_V_MF4_MF8, VSOXSEG6EI16_V, 0x5 }, // 10468
  { PseudoVSOXSEG6EI16_V_MF4_MF8_MASK, VSOXSEG6EI16_V, 0x5 }, // 10469
  { PseudoVSOXSEG6EI16_V_MF2_MF4, VSOXSEG6EI16_V, 0x6 }, // 10470
  { PseudoVSOXSEG6EI16_V_MF2_MF4_MASK, VSOXSEG6EI16_V, 0x6 }, // 10471
  { PseudoVSOXSEG6EI16_V_MF4_MF4, VSOXSEG6EI16_V, 0x6 }, // 10472
  { PseudoVSOXSEG6EI16_V_MF4_MF4_MASK, VSOXSEG6EI16_V, 0x6 }, // 10473
  { PseudoVSOXSEG6EI16_V_M1_MF2, VSOXSEG6EI16_V, 0x7 }, // 10474
  { PseudoVSOXSEG6EI16_V_M1_MF2_MASK, VSOXSEG6EI16_V, 0x7 }, // 10475
  { PseudoVSOXSEG6EI16_V_MF2_MF2, VSOXSEG6EI16_V, 0x7 }, // 10476
  { PseudoVSOXSEG6EI16_V_MF2_MF2_MASK, VSOXSEG6EI16_V, 0x7 }, // 10477
  { PseudoVSOXSEG6EI16_V_MF4_MF2, VSOXSEG6EI16_V, 0x7 }, // 10478
  { PseudoVSOXSEG6EI16_V_MF4_MF2_MASK, VSOXSEG6EI16_V, 0x7 }, // 10479
  { PseudoVSOXSEG6EI32_V_M1_M1, VSOXSEG6EI32_V, 0x0 }, // 10480
  { PseudoVSOXSEG6EI32_V_M1_M1_MASK, VSOXSEG6EI32_V, 0x0 }, // 10481
  { PseudoVSOXSEG6EI32_V_M2_M1, VSOXSEG6EI32_V, 0x0 }, // 10482
  { PseudoVSOXSEG6EI32_V_M2_M1_MASK, VSOXSEG6EI32_V, 0x0 }, // 10483
  { PseudoVSOXSEG6EI32_V_M4_M1, VSOXSEG6EI32_V, 0x0 }, // 10484
  { PseudoVSOXSEG6EI32_V_M4_M1_MASK, VSOXSEG6EI32_V, 0x0 }, // 10485
  { PseudoVSOXSEG6EI32_V_MF2_M1, VSOXSEG6EI32_V, 0x0 }, // 10486
  { PseudoVSOXSEG6EI32_V_MF2_M1_MASK, VSOXSEG6EI32_V, 0x0 }, // 10487
  { PseudoVSOXSEG6EI32_V_MF2_MF8, VSOXSEG6EI32_V, 0x5 }, // 10488
  { PseudoVSOXSEG6EI32_V_MF2_MF8_MASK, VSOXSEG6EI32_V, 0x5 }, // 10489
  { PseudoVSOXSEG6EI32_V_M1_MF4, VSOXSEG6EI32_V, 0x6 }, // 10490
  { PseudoVSOXSEG6EI32_V_M1_MF4_MASK, VSOXSEG6EI32_V, 0x6 }, // 10491
  { PseudoVSOXSEG6EI32_V_MF2_MF4, VSOXSEG6EI32_V, 0x6 }, // 10492
  { PseudoVSOXSEG6EI32_V_MF2_MF4_MASK, VSOXSEG6EI32_V, 0x6 }, // 10493
  { PseudoVSOXSEG6EI32_V_M1_MF2, VSOXSEG6EI32_V, 0x7 }, // 10494
  { PseudoVSOXSEG6EI32_V_M1_MF2_MASK, VSOXSEG6EI32_V, 0x7 }, // 10495
  { PseudoVSOXSEG6EI32_V_M2_MF2, VSOXSEG6EI32_V, 0x7 }, // 10496
  { PseudoVSOXSEG6EI32_V_M2_MF2_MASK, VSOXSEG6EI32_V, 0x7 }, // 10497
  { PseudoVSOXSEG6EI32_V_MF2_MF2, VSOXSEG6EI32_V, 0x7 }, // 10498
  { PseudoVSOXSEG6EI32_V_MF2_MF2_MASK, VSOXSEG6EI32_V, 0x7 }, // 10499
  { PseudoVSOXSEG6EI64_V_M1_M1, VSOXSEG6EI64_V, 0x0 }, // 10500
  { PseudoVSOXSEG6EI64_V_M1_M1_MASK, VSOXSEG6EI64_V, 0x0 }, // 10501
  { PseudoVSOXSEG6EI64_V_M2_M1, VSOXSEG6EI64_V, 0x0 }, // 10502
  { PseudoVSOXSEG6EI64_V_M2_M1_MASK, VSOXSEG6EI64_V, 0x0 }, // 10503
  { PseudoVSOXSEG6EI64_V_M4_M1, VSOXSEG6EI64_V, 0x0 }, // 10504
  { PseudoVSOXSEG6EI64_V_M4_M1_MASK, VSOXSEG6EI64_V, 0x0 }, // 10505
  { PseudoVSOXSEG6EI64_V_M8_M1, VSOXSEG6EI64_V, 0x0 }, // 10506
  { PseudoVSOXSEG6EI64_V_M8_M1_MASK, VSOXSEG6EI64_V, 0x0 }, // 10507
  { PseudoVSOXSEG6EI64_V_M1_MF8, VSOXSEG6EI64_V, 0x5 }, // 10508
  { PseudoVSOXSEG6EI64_V_M1_MF8_MASK, VSOXSEG6EI64_V, 0x5 }, // 10509
  { PseudoVSOXSEG6EI64_V_M1_MF4, VSOXSEG6EI64_V, 0x6 }, // 10510
  { PseudoVSOXSEG6EI64_V_M1_MF4_MASK, VSOXSEG6EI64_V, 0x6 }, // 10511
  { PseudoVSOXSEG6EI64_V_M2_MF4, VSOXSEG6EI64_V, 0x6 }, // 10512
  { PseudoVSOXSEG6EI64_V_M2_MF4_MASK, VSOXSEG6EI64_V, 0x6 }, // 10513
  { PseudoVSOXSEG6EI64_V_M1_MF2, VSOXSEG6EI64_V, 0x7 }, // 10514
  { PseudoVSOXSEG6EI64_V_M1_MF2_MASK, VSOXSEG6EI64_V, 0x7 }, // 10515
  { PseudoVSOXSEG6EI64_V_M2_MF2, VSOXSEG6EI64_V, 0x7 }, // 10516
  { PseudoVSOXSEG6EI64_V_M2_MF2_MASK, VSOXSEG6EI64_V, 0x7 }, // 10517
  { PseudoVSOXSEG6EI64_V_M4_MF2, VSOXSEG6EI64_V, 0x7 }, // 10518
  { PseudoVSOXSEG6EI64_V_M4_MF2_MASK, VSOXSEG6EI64_V, 0x7 }, // 10519
  { PseudoVSOXSEG6EI8_V_M1_M1, VSOXSEG6EI8_V, 0x0 }, // 10520
  { PseudoVSOXSEG6EI8_V_M1_M1_MASK, VSOXSEG6EI8_V, 0x0 }, // 10521
  { PseudoVSOXSEG6EI8_V_MF2_M1, VSOXSEG6EI8_V, 0x0 }, // 10522
  { PseudoVSOXSEG6EI8_V_MF2_M1_MASK, VSOXSEG6EI8_V, 0x0 }, // 10523
  { PseudoVSOXSEG6EI8_V_MF4_M1, VSOXSEG6EI8_V, 0x0 }, // 10524
  { PseudoVSOXSEG6EI8_V_MF4_M1_MASK, VSOXSEG6EI8_V, 0x0 }, // 10525
  { PseudoVSOXSEG6EI8_V_MF8_M1, VSOXSEG6EI8_V, 0x0 }, // 10526
  { PseudoVSOXSEG6EI8_V_MF8_M1_MASK, VSOXSEG6EI8_V, 0x0 }, // 10527
  { PseudoVSOXSEG6EI8_V_MF8_MF8, VSOXSEG6EI8_V, 0x5 }, // 10528
  { PseudoVSOXSEG6EI8_V_MF8_MF8_MASK, VSOXSEG6EI8_V, 0x5 }, // 10529
  { PseudoVSOXSEG6EI8_V_MF4_MF4, VSOXSEG6EI8_V, 0x6 }, // 10530
  { PseudoVSOXSEG6EI8_V_MF4_MF4_MASK, VSOXSEG6EI8_V, 0x6 }, // 10531
  { PseudoVSOXSEG6EI8_V_MF8_MF4, VSOXSEG6EI8_V, 0x6 }, // 10532
  { PseudoVSOXSEG6EI8_V_MF8_MF4_MASK, VSOXSEG6EI8_V, 0x6 }, // 10533
  { PseudoVSOXSEG6EI8_V_MF2_MF2, VSOXSEG6EI8_V, 0x7 }, // 10534
  { PseudoVSOXSEG6EI8_V_MF2_MF2_MASK, VSOXSEG6EI8_V, 0x7 }, // 10535
  { PseudoVSOXSEG6EI8_V_MF4_MF2, VSOXSEG6EI8_V, 0x7 }, // 10536
  { PseudoVSOXSEG6EI8_V_MF4_MF2_MASK, VSOXSEG6EI8_V, 0x7 }, // 10537
  { PseudoVSOXSEG6EI8_V_MF8_MF2, VSOXSEG6EI8_V, 0x7 }, // 10538
  { PseudoVSOXSEG6EI8_V_MF8_MF2_MASK, VSOXSEG6EI8_V, 0x7 }, // 10539
  { PseudoVSOXSEG7EI16_V_M1_M1, VSOXSEG7EI16_V, 0x0 }, // 10540
  { PseudoVSOXSEG7EI16_V_M1_M1_MASK, VSOXSEG7EI16_V, 0x0 }, // 10541
  { PseudoVSOXSEG7EI16_V_M2_M1, VSOXSEG7EI16_V, 0x0 }, // 10542
  { PseudoVSOXSEG7EI16_V_M2_M1_MASK, VSOXSEG7EI16_V, 0x0 }, // 10543
  { PseudoVSOXSEG7EI16_V_MF2_M1, VSOXSEG7EI16_V, 0x0 }, // 10544
  { PseudoVSOXSEG7EI16_V_MF2_M1_MASK, VSOXSEG7EI16_V, 0x0 }, // 10545
  { PseudoVSOXSEG7EI16_V_MF4_M1, VSOXSEG7EI16_V, 0x0 }, // 10546
  { PseudoVSOXSEG7EI16_V_MF4_M1_MASK, VSOXSEG7EI16_V, 0x0 }, // 10547
  { PseudoVSOXSEG7EI16_V_MF4_MF8, VSOXSEG7EI16_V, 0x5 }, // 10548
  { PseudoVSOXSEG7EI16_V_MF4_MF8_MASK, VSOXSEG7EI16_V, 0x5 }, // 10549
  { PseudoVSOXSEG7EI16_V_MF2_MF4, VSOXSEG7EI16_V, 0x6 }, // 10550
  { PseudoVSOXSEG7EI16_V_MF2_MF4_MASK, VSOXSEG7EI16_V, 0x6 }, // 10551
  { PseudoVSOXSEG7EI16_V_MF4_MF4, VSOXSEG7EI16_V, 0x6 }, // 10552
  { PseudoVSOXSEG7EI16_V_MF4_MF4_MASK, VSOXSEG7EI16_V, 0x6 }, // 10553
  { PseudoVSOXSEG7EI16_V_M1_MF2, VSOXSEG7EI16_V, 0x7 }, // 10554
  { PseudoVSOXSEG7EI16_V_M1_MF2_MASK, VSOXSEG7EI16_V, 0x7 }, // 10555
  { PseudoVSOXSEG7EI16_V_MF2_MF2, VSOXSEG7EI16_V, 0x7 }, // 10556
  { PseudoVSOXSEG7EI16_V_MF2_MF2_MASK, VSOXSEG7EI16_V, 0x7 }, // 10557
  { PseudoVSOXSEG7EI16_V_MF4_MF2, VSOXSEG7EI16_V, 0x7 }, // 10558
  { PseudoVSOXSEG7EI16_V_MF4_MF2_MASK, VSOXSEG7EI16_V, 0x7 }, // 10559
  { PseudoVSOXSEG7EI32_V_M1_M1, VSOXSEG7EI32_V, 0x0 }, // 10560
  { PseudoVSOXSEG7EI32_V_M1_M1_MASK, VSOXSEG7EI32_V, 0x0 }, // 10561
  { PseudoVSOXSEG7EI32_V_M2_M1, VSOXSEG7EI32_V, 0x0 }, // 10562
  { PseudoVSOXSEG7EI32_V_M2_M1_MASK, VSOXSEG7EI32_V, 0x0 }, // 10563
  { PseudoVSOXSEG7EI32_V_M4_M1, VSOXSEG7EI32_V, 0x0 }, // 10564
  { PseudoVSOXSEG7EI32_V_M4_M1_MASK, VSOXSEG7EI32_V, 0x0 }, // 10565
  { PseudoVSOXSEG7EI32_V_MF2_M1, VSOXSEG7EI32_V, 0x0 }, // 10566
  { PseudoVSOXSEG7EI32_V_MF2_M1_MASK, VSOXSEG7EI32_V, 0x0 }, // 10567
  { PseudoVSOXSEG7EI32_V_MF2_MF8, VSOXSEG7EI32_V, 0x5 }, // 10568
  { PseudoVSOXSEG7EI32_V_MF2_MF8_MASK, VSOXSEG7EI32_V, 0x5 }, // 10569
  { PseudoVSOXSEG7EI32_V_M1_MF4, VSOXSEG7EI32_V, 0x6 }, // 10570
  { PseudoVSOXSEG7EI32_V_M1_MF4_MASK, VSOXSEG7EI32_V, 0x6 }, // 10571
  { PseudoVSOXSEG7EI32_V_MF2_MF4, VSOXSEG7EI32_V, 0x6 }, // 10572
  { PseudoVSOXSEG7EI32_V_MF2_MF4_MASK, VSOXSEG7EI32_V, 0x6 }, // 10573
  { PseudoVSOXSEG7EI32_V_M1_MF2, VSOXSEG7EI32_V, 0x7 }, // 10574
  { PseudoVSOXSEG7EI32_V_M1_MF2_MASK, VSOXSEG7EI32_V, 0x7 }, // 10575
  { PseudoVSOXSEG7EI32_V_M2_MF2, VSOXSEG7EI32_V, 0x7 }, // 10576
  { PseudoVSOXSEG7EI32_V_M2_MF2_MASK, VSOXSEG7EI32_V, 0x7 }, // 10577
  { PseudoVSOXSEG7EI32_V_MF2_MF2, VSOXSEG7EI32_V, 0x7 }, // 10578
  { PseudoVSOXSEG7EI32_V_MF2_MF2_MASK, VSOXSEG7EI32_V, 0x7 }, // 10579
  { PseudoVSOXSEG7EI64_V_M1_M1, VSOXSEG7EI64_V, 0x0 }, // 10580
  { PseudoVSOXSEG7EI64_V_M1_M1_MASK, VSOXSEG7EI64_V, 0x0 }, // 10581
  { PseudoVSOXSEG7EI64_V_M2_M1, VSOXSEG7EI64_V, 0x0 }, // 10582
  { PseudoVSOXSEG7EI64_V_M2_M1_MASK, VSOXSEG7EI64_V, 0x0 }, // 10583
  { PseudoVSOXSEG7EI64_V_M4_M1, VSOXSEG7EI64_V, 0x0 }, // 10584
  { PseudoVSOXSEG7EI64_V_M4_M1_MASK, VSOXSEG7EI64_V, 0x0 }, // 10585
  { PseudoVSOXSEG7EI64_V_M8_M1, VSOXSEG7EI64_V, 0x0 }, // 10586
  { PseudoVSOXSEG7EI64_V_M8_M1_MASK, VSOXSEG7EI64_V, 0x0 }, // 10587
  { PseudoVSOXSEG7EI64_V_M1_MF8, VSOXSEG7EI64_V, 0x5 }, // 10588
  { PseudoVSOXSEG7EI64_V_M1_MF8_MASK, VSOXSEG7EI64_V, 0x5 }, // 10589
  { PseudoVSOXSEG7EI64_V_M1_MF4, VSOXSEG7EI64_V, 0x6 }, // 10590
  { PseudoVSOXSEG7EI64_V_M1_MF4_MASK, VSOXSEG7EI64_V, 0x6 }, // 10591
  { PseudoVSOXSEG7EI64_V_M2_MF4, VSOXSEG7EI64_V, 0x6 }, // 10592
  { PseudoVSOXSEG7EI64_V_M2_MF4_MASK, VSOXSEG7EI64_V, 0x6 }, // 10593
  { PseudoVSOXSEG7EI64_V_M1_MF2, VSOXSEG7EI64_V, 0x7 }, // 10594
  { PseudoVSOXSEG7EI64_V_M1_MF2_MASK, VSOXSEG7EI64_V, 0x7 }, // 10595
  { PseudoVSOXSEG7EI64_V_M2_MF2, VSOXSEG7EI64_V, 0x7 }, // 10596
  { PseudoVSOXSEG7EI64_V_M2_MF2_MASK, VSOXSEG7EI64_V, 0x7 }, // 10597
  { PseudoVSOXSEG7EI64_V_M4_MF2, VSOXSEG7EI64_V, 0x7 }, // 10598
  { PseudoVSOXSEG7EI64_V_M4_MF2_MASK, VSOXSEG7EI64_V, 0x7 }, // 10599
  { PseudoVSOXSEG7EI8_V_M1_M1, VSOXSEG7EI8_V, 0x0 }, // 10600
  { PseudoVSOXSEG7EI8_V_M1_M1_MASK, VSOXSEG7EI8_V, 0x0 }, // 10601
  { PseudoVSOXSEG7EI8_V_MF2_M1, VSOXSEG7EI8_V, 0x0 }, // 10602
  { PseudoVSOXSEG7EI8_V_MF2_M1_MASK, VSOXSEG7EI8_V, 0x0 }, // 10603
  { PseudoVSOXSEG7EI8_V_MF4_M1, VSOXSEG7EI8_V, 0x0 }, // 10604
  { PseudoVSOXSEG7EI8_V_MF4_M1_MASK, VSOXSEG7EI8_V, 0x0 }, // 10605
  { PseudoVSOXSEG7EI8_V_MF8_M1, VSOXSEG7EI8_V, 0x0 }, // 10606
  { PseudoVSOXSEG7EI8_V_MF8_M1_MASK, VSOXSEG7EI8_V, 0x0 }, // 10607
  { PseudoVSOXSEG7EI8_V_MF8_MF8, VSOXSEG7EI8_V, 0x5 }, // 10608
  { PseudoVSOXSEG7EI8_V_MF8_MF8_MASK, VSOXSEG7EI8_V, 0x5 }, // 10609
  { PseudoVSOXSEG7EI8_V_MF4_MF4, VSOXSEG7EI8_V, 0x6 }, // 10610
  { PseudoVSOXSEG7EI8_V_MF4_MF4_MASK, VSOXSEG7EI8_V, 0x6 }, // 10611
  { PseudoVSOXSEG7EI8_V_MF8_MF4, VSOXSEG7EI8_V, 0x6 }, // 10612
  { PseudoVSOXSEG7EI8_V_MF8_MF4_MASK, VSOXSEG7EI8_V, 0x6 }, // 10613
  { PseudoVSOXSEG7EI8_V_MF2_MF2, VSOXSEG7EI8_V, 0x7 }, // 10614
  { PseudoVSOXSEG7EI8_V_MF2_MF2_MASK, VSOXSEG7EI8_V, 0x7 }, // 10615
  { PseudoVSOXSEG7EI8_V_MF4_MF2, VSOXSEG7EI8_V, 0x7 }, // 10616
  { PseudoVSOXSEG7EI8_V_MF4_MF2_MASK, VSOXSEG7EI8_V, 0x7 }, // 10617
  { PseudoVSOXSEG7EI8_V_MF8_MF2, VSOXSEG7EI8_V, 0x7 }, // 10618
  { PseudoVSOXSEG7EI8_V_MF8_MF2_MASK, VSOXSEG7EI8_V, 0x7 }, // 10619
  { PseudoVSOXSEG8EI16_V_M1_M1, VSOXSEG8EI16_V, 0x0 }, // 10620
  { PseudoVSOXSEG8EI16_V_M1_M1_MASK, VSOXSEG8EI16_V, 0x0 }, // 10621
  { PseudoVSOXSEG8EI16_V_M2_M1, VSOXSEG8EI16_V, 0x0 }, // 10622
  { PseudoVSOXSEG8EI16_V_M2_M1_MASK, VSOXSEG8EI16_V, 0x0 }, // 10623
  { PseudoVSOXSEG8EI16_V_MF2_M1, VSOXSEG8EI16_V, 0x0 }, // 10624
  { PseudoVSOXSEG8EI16_V_MF2_M1_MASK, VSOXSEG8EI16_V, 0x0 }, // 10625
  { PseudoVSOXSEG8EI16_V_MF4_M1, VSOXSEG8EI16_V, 0x0 }, // 10626
  { PseudoVSOXSEG8EI16_V_MF4_M1_MASK, VSOXSEG8EI16_V, 0x0 }, // 10627
  { PseudoVSOXSEG8EI16_V_MF4_MF8, VSOXSEG8EI16_V, 0x5 }, // 10628
  { PseudoVSOXSEG8EI16_V_MF4_MF8_MASK, VSOXSEG8EI16_V, 0x5 }, // 10629
  { PseudoVSOXSEG8EI16_V_MF2_MF4, VSOXSEG8EI16_V, 0x6 }, // 10630
  { PseudoVSOXSEG8EI16_V_MF2_MF4_MASK, VSOXSEG8EI16_V, 0x6 }, // 10631
  { PseudoVSOXSEG8EI16_V_MF4_MF4, VSOXSEG8EI16_V, 0x6 }, // 10632
  { PseudoVSOXSEG8EI16_V_MF4_MF4_MASK, VSOXSEG8EI16_V, 0x6 }, // 10633
  { PseudoVSOXSEG8EI16_V_M1_MF2, VSOXSEG8EI16_V, 0x7 }, // 10634
  { PseudoVSOXSEG8EI16_V_M1_MF2_MASK, VSOXSEG8EI16_V, 0x7 }, // 10635
  { PseudoVSOXSEG8EI16_V_MF2_MF2, VSOXSEG8EI16_V, 0x7 }, // 10636
  { PseudoVSOXSEG8EI16_V_MF2_MF2_MASK, VSOXSEG8EI16_V, 0x7 }, // 10637
  { PseudoVSOXSEG8EI16_V_MF4_MF2, VSOXSEG8EI16_V, 0x7 }, // 10638
  { PseudoVSOXSEG8EI16_V_MF4_MF2_MASK, VSOXSEG8EI16_V, 0x7 }, // 10639
  { PseudoVSOXSEG8EI32_V_M1_M1, VSOXSEG8EI32_V, 0x0 }, // 10640
  { PseudoVSOXSEG8EI32_V_M1_M1_MASK, VSOXSEG8EI32_V, 0x0 }, // 10641
  { PseudoVSOXSEG8EI32_V_M2_M1, VSOXSEG8EI32_V, 0x0 }, // 10642
  { PseudoVSOXSEG8EI32_V_M2_M1_MASK, VSOXSEG8EI32_V, 0x0 }, // 10643
  { PseudoVSOXSEG8EI32_V_M4_M1, VSOXSEG8EI32_V, 0x0 }, // 10644
  { PseudoVSOXSEG8EI32_V_M4_M1_MASK, VSOXSEG8EI32_V, 0x0 }, // 10645
  { PseudoVSOXSEG8EI32_V_MF2_M1, VSOXSEG8EI32_V, 0x0 }, // 10646
  { PseudoVSOXSEG8EI32_V_MF2_M1_MASK, VSOXSEG8EI32_V, 0x0 }, // 10647
  { PseudoVSOXSEG8EI32_V_MF2_MF8, VSOXSEG8EI32_V, 0x5 }, // 10648
  { PseudoVSOXSEG8EI32_V_MF2_MF8_MASK, VSOXSEG8EI32_V, 0x5 }, // 10649
  { PseudoVSOXSEG8EI32_V_M1_MF4, VSOXSEG8EI32_V, 0x6 }, // 10650
  { PseudoVSOXSEG8EI32_V_M1_MF4_MASK, VSOXSEG8EI32_V, 0x6 }, // 10651
  { PseudoVSOXSEG8EI32_V_MF2_MF4, VSOXSEG8EI32_V, 0x6 }, // 10652
  { PseudoVSOXSEG8EI32_V_MF2_MF4_MASK, VSOXSEG8EI32_V, 0x6 }, // 10653
  { PseudoVSOXSEG8EI32_V_M1_MF2, VSOXSEG8EI32_V, 0x7 }, // 10654
  { PseudoVSOXSEG8EI32_V_M1_MF2_MASK, VSOXSEG8EI32_V, 0x7 }, // 10655
  { PseudoVSOXSEG8EI32_V_M2_MF2, VSOXSEG8EI32_V, 0x7 }, // 10656
  { PseudoVSOXSEG8EI32_V_M2_MF2_MASK, VSOXSEG8EI32_V, 0x7 }, // 10657
  { PseudoVSOXSEG8EI32_V_MF2_MF2, VSOXSEG8EI32_V, 0x7 }, // 10658
  { PseudoVSOXSEG8EI32_V_MF2_MF2_MASK, VSOXSEG8EI32_V, 0x7 }, // 10659
  { PseudoVSOXSEG8EI64_V_M1_M1, VSOXSEG8EI64_V, 0x0 }, // 10660
  { PseudoVSOXSEG8EI64_V_M1_M1_MASK, VSOXSEG8EI64_V, 0x0 }, // 10661
  { PseudoVSOXSEG8EI64_V_M2_M1, VSOXSEG8EI64_V, 0x0 }, // 10662
  { PseudoVSOXSEG8EI64_V_M2_M1_MASK, VSOXSEG8EI64_V, 0x0 }, // 10663
  { PseudoVSOXSEG8EI64_V_M4_M1, VSOXSEG8EI64_V, 0x0 }, // 10664
  { PseudoVSOXSEG8EI64_V_M4_M1_MASK, VSOXSEG8EI64_V, 0x0 }, // 10665
  { PseudoVSOXSEG8EI64_V_M8_M1, VSOXSEG8EI64_V, 0x0 }, // 10666
  { PseudoVSOXSEG8EI64_V_M8_M1_MASK, VSOXSEG8EI64_V, 0x0 }, // 10667
  { PseudoVSOXSEG8EI64_V_M1_MF8, VSOXSEG8EI64_V, 0x5 }, // 10668
  { PseudoVSOXSEG8EI64_V_M1_MF8_MASK, VSOXSEG8EI64_V, 0x5 }, // 10669
  { PseudoVSOXSEG8EI64_V_M1_MF4, VSOXSEG8EI64_V, 0x6 }, // 10670
  { PseudoVSOXSEG8EI64_V_M1_MF4_MASK, VSOXSEG8EI64_V, 0x6 }, // 10671
  { PseudoVSOXSEG8EI64_V_M2_MF4, VSOXSEG8EI64_V, 0x6 }, // 10672
  { PseudoVSOXSEG8EI64_V_M2_MF4_MASK, VSOXSEG8EI64_V, 0x6 }, // 10673
  { PseudoVSOXSEG8EI64_V_M1_MF2, VSOXSEG8EI64_V, 0x7 }, // 10674
  { PseudoVSOXSEG8EI64_V_M1_MF2_MASK, VSOXSEG8EI64_V, 0x7 }, // 10675
  { PseudoVSOXSEG8EI64_V_M2_MF2, VSOXSEG8EI64_V, 0x7 }, // 10676
  { PseudoVSOXSEG8EI64_V_M2_MF2_MASK, VSOXSEG8EI64_V, 0x7 }, // 10677
  { PseudoVSOXSEG8EI64_V_M4_MF2, VSOXSEG8EI64_V, 0x7 }, // 10678
  { PseudoVSOXSEG8EI64_V_M4_MF2_MASK, VSOXSEG8EI64_V, 0x7 }, // 10679
  { PseudoVSOXSEG8EI8_V_M1_M1, VSOXSEG8EI8_V, 0x0 }, // 10680
  { PseudoVSOXSEG8EI8_V_M1_M1_MASK, VSOXSEG8EI8_V, 0x0 }, // 10681
  { PseudoVSOXSEG8EI8_V_MF2_M1, VSOXSEG8EI8_V, 0x0 }, // 10682
  { PseudoVSOXSEG8EI8_V_MF2_M1_MASK, VSOXSEG8EI8_V, 0x0 }, // 10683
  { PseudoVSOXSEG8EI8_V_MF4_M1, VSOXSEG8EI8_V, 0x0 }, // 10684
  { PseudoVSOXSEG8EI8_V_MF4_M1_MASK, VSOXSEG8EI8_V, 0x0 }, // 10685
  { PseudoVSOXSEG8EI8_V_MF8_M1, VSOXSEG8EI8_V, 0x0 }, // 10686
  { PseudoVSOXSEG8EI8_V_MF8_M1_MASK, VSOXSEG8EI8_V, 0x0 }, // 10687
  { PseudoVSOXSEG8EI8_V_MF8_MF8, VSOXSEG8EI8_V, 0x5 }, // 10688
  { PseudoVSOXSEG8EI8_V_MF8_MF8_MASK, VSOXSEG8EI8_V, 0x5 }, // 10689
  { PseudoVSOXSEG8EI8_V_MF4_MF4, VSOXSEG8EI8_V, 0x6 }, // 10690
  { PseudoVSOXSEG8EI8_V_MF4_MF4_MASK, VSOXSEG8EI8_V, 0x6 }, // 10691
  { PseudoVSOXSEG8EI8_V_MF8_MF4, VSOXSEG8EI8_V, 0x6 }, // 10692
  { PseudoVSOXSEG8EI8_V_MF8_MF4_MASK, VSOXSEG8EI8_V, 0x6 }, // 10693
  { PseudoVSOXSEG8EI8_V_MF2_MF2, VSOXSEG8EI8_V, 0x7 }, // 10694
  { PseudoVSOXSEG8EI8_V_MF2_MF2_MASK, VSOXSEG8EI8_V, 0x7 }, // 10695
  { PseudoVSOXSEG8EI8_V_MF4_MF2, VSOXSEG8EI8_V, 0x7 }, // 10696
  { PseudoVSOXSEG8EI8_V_MF4_MF2_MASK, VSOXSEG8EI8_V, 0x7 }, // 10697
  { PseudoVSOXSEG8EI8_V_MF8_MF2, VSOXSEG8EI8_V, 0x7 }, // 10698
  { PseudoVSOXSEG8EI8_V_MF8_MF2_MASK, VSOXSEG8EI8_V, 0x7 }, // 10699
  { PseudoVSRA_VI_M1, VSRA_VI, 0x0 }, // 10700
  { PseudoVSRA_VI_M1_MASK, VSRA_VI, 0x0 }, // 10701
  { PseudoVSRA_VI_M1_TU, VSRA_VI, 0x0 }, // 10702
  { PseudoVSRA_VI_M2, VSRA_VI, 0x1 }, // 10703
  { PseudoVSRA_VI_M2_MASK, VSRA_VI, 0x1 }, // 10704
  { PseudoVSRA_VI_M2_TU, VSRA_VI, 0x1 }, // 10705
  { PseudoVSRA_VI_M4, VSRA_VI, 0x2 }, // 10706
  { PseudoVSRA_VI_M4_MASK, VSRA_VI, 0x2 }, // 10707
  { PseudoVSRA_VI_M4_TU, VSRA_VI, 0x2 }, // 10708
  { PseudoVSRA_VI_M8, VSRA_VI, 0x3 }, // 10709
  { PseudoVSRA_VI_M8_MASK, VSRA_VI, 0x3 }, // 10710
  { PseudoVSRA_VI_M8_TU, VSRA_VI, 0x3 }, // 10711
  { PseudoVSRA_VI_MF8, VSRA_VI, 0x5 }, // 10712
  { PseudoVSRA_VI_MF8_MASK, VSRA_VI, 0x5 }, // 10713
  { PseudoVSRA_VI_MF8_TU, VSRA_VI, 0x5 }, // 10714
  { PseudoVSRA_VI_MF4, VSRA_VI, 0x6 }, // 10715
  { PseudoVSRA_VI_MF4_MASK, VSRA_VI, 0x6 }, // 10716
  { PseudoVSRA_VI_MF4_TU, VSRA_VI, 0x6 }, // 10717
  { PseudoVSRA_VI_MF2, VSRA_VI, 0x7 }, // 10718
  { PseudoVSRA_VI_MF2_MASK, VSRA_VI, 0x7 }, // 10719
  { PseudoVSRA_VI_MF2_TU, VSRA_VI, 0x7 }, // 10720
  { PseudoVSRA_VV_M1, VSRA_VV, 0x0 }, // 10721
  { PseudoVSRA_VV_M1_MASK, VSRA_VV, 0x0 }, // 10722
  { PseudoVSRA_VV_M1_TU, VSRA_VV, 0x0 }, // 10723
  { PseudoVSRA_VV_M2, VSRA_VV, 0x1 }, // 10724
  { PseudoVSRA_VV_M2_MASK, VSRA_VV, 0x1 }, // 10725
  { PseudoVSRA_VV_M2_TU, VSRA_VV, 0x1 }, // 10726
  { PseudoVSRA_VV_M4, VSRA_VV, 0x2 }, // 10727
  { PseudoVSRA_VV_M4_MASK, VSRA_VV, 0x2 }, // 10728
  { PseudoVSRA_VV_M4_TU, VSRA_VV, 0x2 }, // 10729
  { PseudoVSRA_VV_M8, VSRA_VV, 0x3 }, // 10730
  { PseudoVSRA_VV_M8_MASK, VSRA_VV, 0x3 }, // 10731
  { PseudoVSRA_VV_M8_TU, VSRA_VV, 0x3 }, // 10732
  { PseudoVSRA_VV_MF8, VSRA_VV, 0x5 }, // 10733
  { PseudoVSRA_VV_MF8_MASK, VSRA_VV, 0x5 }, // 10734
  { PseudoVSRA_VV_MF8_TU, VSRA_VV, 0x5 }, // 10735
  { PseudoVSRA_VV_MF4, VSRA_VV, 0x6 }, // 10736
  { PseudoVSRA_VV_MF4_MASK, VSRA_VV, 0x6 }, // 10737
  { PseudoVSRA_VV_MF4_TU, VSRA_VV, 0x6 }, // 10738
  { PseudoVSRA_VV_MF2, VSRA_VV, 0x7 }, // 10739
  { PseudoVSRA_VV_MF2_MASK, VSRA_VV, 0x7 }, // 10740
  { PseudoVSRA_VV_MF2_TU, VSRA_VV, 0x7 }, // 10741
  { PseudoVSRA_VX_M1, VSRA_VX, 0x0 }, // 10742
  { PseudoVSRA_VX_M1_MASK, VSRA_VX, 0x0 }, // 10743
  { PseudoVSRA_VX_M1_TU, VSRA_VX, 0x0 }, // 10744
  { PseudoVSRA_VX_M2, VSRA_VX, 0x1 }, // 10745
  { PseudoVSRA_VX_M2_MASK, VSRA_VX, 0x1 }, // 10746
  { PseudoVSRA_VX_M2_TU, VSRA_VX, 0x1 }, // 10747
  { PseudoVSRA_VX_M4, VSRA_VX, 0x2 }, // 10748
  { PseudoVSRA_VX_M4_MASK, VSRA_VX, 0x2 }, // 10749
  { PseudoVSRA_VX_M4_TU, VSRA_VX, 0x2 }, // 10750
  { PseudoVSRA_VX_M8, VSRA_VX, 0x3 }, // 10751
  { PseudoVSRA_VX_M8_MASK, VSRA_VX, 0x3 }, // 10752
  { PseudoVSRA_VX_M8_TU, VSRA_VX, 0x3 }, // 10753
  { PseudoVSRA_VX_MF8, VSRA_VX, 0x5 }, // 10754
  { PseudoVSRA_VX_MF8_MASK, VSRA_VX, 0x5 }, // 10755
  { PseudoVSRA_VX_MF8_TU, VSRA_VX, 0x5 }, // 10756
  { PseudoVSRA_VX_MF4, VSRA_VX, 0x6 }, // 10757
  { PseudoVSRA_VX_MF4_MASK, VSRA_VX, 0x6 }, // 10758
  { PseudoVSRA_VX_MF4_TU, VSRA_VX, 0x6 }, // 10759
  { PseudoVSRA_VX_MF2, VSRA_VX, 0x7 }, // 10760
  { PseudoVSRA_VX_MF2_MASK, VSRA_VX, 0x7 }, // 10761
  { PseudoVSRA_VX_MF2_TU, VSRA_VX, 0x7 }, // 10762
  { PseudoVSRL_VI_M1, VSRL_VI, 0x0 }, // 10763
  { PseudoVSRL_VI_M1_MASK, VSRL_VI, 0x0 }, // 10764
  { PseudoVSRL_VI_M1_TU, VSRL_VI, 0x0 }, // 10765
  { PseudoVSRL_VI_M2, VSRL_VI, 0x1 }, // 10766
  { PseudoVSRL_VI_M2_MASK, VSRL_VI, 0x1 }, // 10767
  { PseudoVSRL_VI_M2_TU, VSRL_VI, 0x1 }, // 10768
  { PseudoVSRL_VI_M4, VSRL_VI, 0x2 }, // 10769
  { PseudoVSRL_VI_M4_MASK, VSRL_VI, 0x2 }, // 10770
  { PseudoVSRL_VI_M4_TU, VSRL_VI, 0x2 }, // 10771
  { PseudoVSRL_VI_M8, VSRL_VI, 0x3 }, // 10772
  { PseudoVSRL_VI_M8_MASK, VSRL_VI, 0x3 }, // 10773
  { PseudoVSRL_VI_M8_TU, VSRL_VI, 0x3 }, // 10774
  { PseudoVSRL_VI_MF8, VSRL_VI, 0x5 }, // 10775
  { PseudoVSRL_VI_MF8_MASK, VSRL_VI, 0x5 }, // 10776
  { PseudoVSRL_VI_MF8_TU, VSRL_VI, 0x5 }, // 10777
  { PseudoVSRL_VI_MF4, VSRL_VI, 0x6 }, // 10778
  { PseudoVSRL_VI_MF4_MASK, VSRL_VI, 0x6 }, // 10779
  { PseudoVSRL_VI_MF4_TU, VSRL_VI, 0x6 }, // 10780
  { PseudoVSRL_VI_MF2, VSRL_VI, 0x7 }, // 10781
  { PseudoVSRL_VI_MF2_MASK, VSRL_VI, 0x7 }, // 10782
  { PseudoVSRL_VI_MF2_TU, VSRL_VI, 0x7 }, // 10783
  { PseudoVSRL_VV_M1, VSRL_VV, 0x0 }, // 10784
  { PseudoVSRL_VV_M1_MASK, VSRL_VV, 0x0 }, // 10785
  { PseudoVSRL_VV_M1_TU, VSRL_VV, 0x0 }, // 10786
  { PseudoVSRL_VV_M2, VSRL_VV, 0x1 }, // 10787
  { PseudoVSRL_VV_M2_MASK, VSRL_VV, 0x1 }, // 10788
  { PseudoVSRL_VV_M2_TU, VSRL_VV, 0x1 }, // 10789
  { PseudoVSRL_VV_M4, VSRL_VV, 0x2 }, // 10790
  { PseudoVSRL_VV_M4_MASK, VSRL_VV, 0x2 }, // 10791
  { PseudoVSRL_VV_M4_TU, VSRL_VV, 0x2 }, // 10792
  { PseudoVSRL_VV_M8, VSRL_VV, 0x3 }, // 10793
  { PseudoVSRL_VV_M8_MASK, VSRL_VV, 0x3 }, // 10794
  { PseudoVSRL_VV_M8_TU, VSRL_VV, 0x3 }, // 10795
  { PseudoVSRL_VV_MF8, VSRL_VV, 0x5 }, // 10796
  { PseudoVSRL_VV_MF8_MASK, VSRL_VV, 0x5 }, // 10797
  { PseudoVSRL_VV_MF8_TU, VSRL_VV, 0x5 }, // 10798
  { PseudoVSRL_VV_MF4, VSRL_VV, 0x6 }, // 10799
  { PseudoVSRL_VV_MF4_MASK, VSRL_VV, 0x6 }, // 10800
  { PseudoVSRL_VV_MF4_TU, VSRL_VV, 0x6 }, // 10801
  { PseudoVSRL_VV_MF2, VSRL_VV, 0x7 }, // 10802
  { PseudoVSRL_VV_MF2_MASK, VSRL_VV, 0x7 }, // 10803
  { PseudoVSRL_VV_MF2_TU, VSRL_VV, 0x7 }, // 10804
  { PseudoVSRL_VX_M1, VSRL_VX, 0x0 }, // 10805
  { PseudoVSRL_VX_M1_MASK, VSRL_VX, 0x0 }, // 10806
  { PseudoVSRL_VX_M1_TU, VSRL_VX, 0x0 }, // 10807
  { PseudoVSRL_VX_M2, VSRL_VX, 0x1 }, // 10808
  { PseudoVSRL_VX_M2_MASK, VSRL_VX, 0x1 }, // 10809
  { PseudoVSRL_VX_M2_TU, VSRL_VX, 0x1 }, // 10810
  { PseudoVSRL_VX_M4, VSRL_VX, 0x2 }, // 10811
  { PseudoVSRL_VX_M4_MASK, VSRL_VX, 0x2 }, // 10812
  { PseudoVSRL_VX_M4_TU, VSRL_VX, 0x2 }, // 10813
  { PseudoVSRL_VX_M8, VSRL_VX, 0x3 }, // 10814
  { PseudoVSRL_VX_M8_MASK, VSRL_VX, 0x3 }, // 10815
  { PseudoVSRL_VX_M8_TU, VSRL_VX, 0x3 }, // 10816
  { PseudoVSRL_VX_MF8, VSRL_VX, 0x5 }, // 10817
  { PseudoVSRL_VX_MF8_MASK, VSRL_VX, 0x5 }, // 10818
  { PseudoVSRL_VX_MF8_TU, VSRL_VX, 0x5 }, // 10819
  { PseudoVSRL_VX_MF4, VSRL_VX, 0x6 }, // 10820
  { PseudoVSRL_VX_MF4_MASK, VSRL_VX, 0x6 }, // 10821
  { PseudoVSRL_VX_MF4_TU, VSRL_VX, 0x6 }, // 10822
  { PseudoVSRL_VX_MF2, VSRL_VX, 0x7 }, // 10823
  { PseudoVSRL_VX_MF2_MASK, VSRL_VX, 0x7 }, // 10824
  { PseudoVSRL_VX_MF2_TU, VSRL_VX, 0x7 }, // 10825
  { PseudoVSSE16_V_M1, VSSE16_V, 0x0 }, // 10826
  { PseudoVSSE16_V_M1_MASK, VSSE16_V, 0x0 }, // 10827
  { PseudoVSSE16_V_M2, VSSE16_V, 0x1 }, // 10828
  { PseudoVSSE16_V_M2_MASK, VSSE16_V, 0x1 }, // 10829
  { PseudoVSSE16_V_M4, VSSE16_V, 0x2 }, // 10830
  { PseudoVSSE16_V_M4_MASK, VSSE16_V, 0x2 }, // 10831
  { PseudoVSSE16_V_M8, VSSE16_V, 0x3 }, // 10832
  { PseudoVSSE16_V_M8_MASK, VSSE16_V, 0x3 }, // 10833
  { PseudoVSSE16_V_MF4, VSSE16_V, 0x6 }, // 10834
  { PseudoVSSE16_V_MF4_MASK, VSSE16_V, 0x6 }, // 10835
  { PseudoVSSE16_V_MF2, VSSE16_V, 0x7 }, // 10836
  { PseudoVSSE16_V_MF2_MASK, VSSE16_V, 0x7 }, // 10837
  { PseudoVSSE32_V_M1, VSSE32_V, 0x0 }, // 10838
  { PseudoVSSE32_V_M1_MASK, VSSE32_V, 0x0 }, // 10839
  { PseudoVSSE32_V_M2, VSSE32_V, 0x1 }, // 10840
  { PseudoVSSE32_V_M2_MASK, VSSE32_V, 0x1 }, // 10841
  { PseudoVSSE32_V_M4, VSSE32_V, 0x2 }, // 10842
  { PseudoVSSE32_V_M4_MASK, VSSE32_V, 0x2 }, // 10843
  { PseudoVSSE32_V_M8, VSSE32_V, 0x3 }, // 10844
  { PseudoVSSE32_V_M8_MASK, VSSE32_V, 0x3 }, // 10845
  { PseudoVSSE32_V_MF2, VSSE32_V, 0x7 }, // 10846
  { PseudoVSSE32_V_MF2_MASK, VSSE32_V, 0x7 }, // 10847
  { PseudoVSSE64_V_M1, VSSE64_V, 0x0 }, // 10848
  { PseudoVSSE64_V_M1_MASK, VSSE64_V, 0x0 }, // 10849
  { PseudoVSSE64_V_M2, VSSE64_V, 0x1 }, // 10850
  { PseudoVSSE64_V_M2_MASK, VSSE64_V, 0x1 }, // 10851
  { PseudoVSSE64_V_M4, VSSE64_V, 0x2 }, // 10852
  { PseudoVSSE64_V_M4_MASK, VSSE64_V, 0x2 }, // 10853
  { PseudoVSSE64_V_M8, VSSE64_V, 0x3 }, // 10854
  { PseudoVSSE64_V_M8_MASK, VSSE64_V, 0x3 }, // 10855
  { PseudoVSSE8_V_M1, VSSE8_V, 0x0 }, // 10856
  { PseudoVSSE8_V_M1_MASK, VSSE8_V, 0x0 }, // 10857
  { PseudoVSSE8_V_M2, VSSE8_V, 0x1 }, // 10858
  { PseudoVSSE8_V_M2_MASK, VSSE8_V, 0x1 }, // 10859
  { PseudoVSSE8_V_M4, VSSE8_V, 0x2 }, // 10860
  { PseudoVSSE8_V_M4_MASK, VSSE8_V, 0x2 }, // 10861
  { PseudoVSSE8_V_M8, VSSE8_V, 0x3 }, // 10862
  { PseudoVSSE8_V_M8_MASK, VSSE8_V, 0x3 }, // 10863
  { PseudoVSSE8_V_MF8, VSSE8_V, 0x5 }, // 10864
  { PseudoVSSE8_V_MF8_MASK, VSSE8_V, 0x5 }, // 10865
  { PseudoVSSE8_V_MF4, VSSE8_V, 0x6 }, // 10866
  { PseudoVSSE8_V_MF4_MASK, VSSE8_V, 0x6 }, // 10867
  { PseudoVSSE8_V_MF2, VSSE8_V, 0x7 }, // 10868
  { PseudoVSSE8_V_MF2_MASK, VSSE8_V, 0x7 }, // 10869
  { PseudoVSSEG2E16_V_M1, VSSEG2E16_V, 0x0 }, // 10870
  { PseudoVSSEG2E16_V_M1_MASK, VSSEG2E16_V, 0x0 }, // 10871
  { PseudoVSSEG2E16_V_M2, VSSEG2E16_V, 0x1 }, // 10872
  { PseudoVSSEG2E16_V_M2_MASK, VSSEG2E16_V, 0x1 }, // 10873
  { PseudoVSSEG2E16_V_M4, VSSEG2E16_V, 0x2 }, // 10874
  { PseudoVSSEG2E16_V_M4_MASK, VSSEG2E16_V, 0x2 }, // 10875
  { PseudoVSSEG2E16_V_MF4, VSSEG2E16_V, 0x6 }, // 10876
  { PseudoVSSEG2E16_V_MF4_MASK, VSSEG2E16_V, 0x6 }, // 10877
  { PseudoVSSEG2E16_V_MF2, VSSEG2E16_V, 0x7 }, // 10878
  { PseudoVSSEG2E16_V_MF2_MASK, VSSEG2E16_V, 0x7 }, // 10879
  { PseudoVSSEG2E32_V_M1, VSSEG2E32_V, 0x0 }, // 10880
  { PseudoVSSEG2E32_V_M1_MASK, VSSEG2E32_V, 0x0 }, // 10881
  { PseudoVSSEG2E32_V_M2, VSSEG2E32_V, 0x1 }, // 10882
  { PseudoVSSEG2E32_V_M2_MASK, VSSEG2E32_V, 0x1 }, // 10883
  { PseudoVSSEG2E32_V_M4, VSSEG2E32_V, 0x2 }, // 10884
  { PseudoVSSEG2E32_V_M4_MASK, VSSEG2E32_V, 0x2 }, // 10885
  { PseudoVSSEG2E32_V_MF2, VSSEG2E32_V, 0x7 }, // 10886
  { PseudoVSSEG2E32_V_MF2_MASK, VSSEG2E32_V, 0x7 }, // 10887
  { PseudoVSSEG2E64_V_M1, VSSEG2E64_V, 0x0 }, // 10888
  { PseudoVSSEG2E64_V_M1_MASK, VSSEG2E64_V, 0x0 }, // 10889
  { PseudoVSSEG2E64_V_M2, VSSEG2E64_V, 0x1 }, // 10890
  { PseudoVSSEG2E64_V_M2_MASK, VSSEG2E64_V, 0x1 }, // 10891
  { PseudoVSSEG2E64_V_M4, VSSEG2E64_V, 0x2 }, // 10892
  { PseudoVSSEG2E64_V_M4_MASK, VSSEG2E64_V, 0x2 }, // 10893
  { PseudoVSSEG2E8_V_M1, VSSEG2E8_V, 0x0 }, // 10894
  { PseudoVSSEG2E8_V_M1_MASK, VSSEG2E8_V, 0x0 }, // 10895
  { PseudoVSSEG2E8_V_M2, VSSEG2E8_V, 0x1 }, // 10896
  { PseudoVSSEG2E8_V_M2_MASK, VSSEG2E8_V, 0x1 }, // 10897
  { PseudoVSSEG2E8_V_M4, VSSEG2E8_V, 0x2 }, // 10898
  { PseudoVSSEG2E8_V_M4_MASK, VSSEG2E8_V, 0x2 }, // 10899
  { PseudoVSSEG2E8_V_MF8, VSSEG2E8_V, 0x5 }, // 10900
  { PseudoVSSEG2E8_V_MF8_MASK, VSSEG2E8_V, 0x5 }, // 10901
  { PseudoVSSEG2E8_V_MF4, VSSEG2E8_V, 0x6 }, // 10902
  { PseudoVSSEG2E8_V_MF4_MASK, VSSEG2E8_V, 0x6 }, // 10903
  { PseudoVSSEG2E8_V_MF2, VSSEG2E8_V, 0x7 }, // 10904
  { PseudoVSSEG2E8_V_MF2_MASK, VSSEG2E8_V, 0x7 }, // 10905
  { PseudoVSSEG3E16_V_M1, VSSEG3E16_V, 0x0 }, // 10906
  { PseudoVSSEG3E16_V_M1_MASK, VSSEG3E16_V, 0x0 }, // 10907
  { PseudoVSSEG3E16_V_M2, VSSEG3E16_V, 0x1 }, // 10908
  { PseudoVSSEG3E16_V_M2_MASK, VSSEG3E16_V, 0x1 }, // 10909
  { PseudoVSSEG3E16_V_MF4, VSSEG3E16_V, 0x6 }, // 10910
  { PseudoVSSEG3E16_V_MF4_MASK, VSSEG3E16_V, 0x6 }, // 10911
  { PseudoVSSEG3E16_V_MF2, VSSEG3E16_V, 0x7 }, // 10912
  { PseudoVSSEG3E16_V_MF2_MASK, VSSEG3E16_V, 0x7 }, // 10913
  { PseudoVSSEG3E32_V_M1, VSSEG3E32_V, 0x0 }, // 10914
  { PseudoVSSEG3E32_V_M1_MASK, VSSEG3E32_V, 0x0 }, // 10915
  { PseudoVSSEG3E32_V_M2, VSSEG3E32_V, 0x1 }, // 10916
  { PseudoVSSEG3E32_V_M2_MASK, VSSEG3E32_V, 0x1 }, // 10917
  { PseudoVSSEG3E32_V_MF2, VSSEG3E32_V, 0x7 }, // 10918
  { PseudoVSSEG3E32_V_MF2_MASK, VSSEG3E32_V, 0x7 }, // 10919
  { PseudoVSSEG3E64_V_M1, VSSEG3E64_V, 0x0 }, // 10920
  { PseudoVSSEG3E64_V_M1_MASK, VSSEG3E64_V, 0x0 }, // 10921
  { PseudoVSSEG3E64_V_M2, VSSEG3E64_V, 0x1 }, // 10922
  { PseudoVSSEG3E64_V_M2_MASK, VSSEG3E64_V, 0x1 }, // 10923
  { PseudoVSSEG3E8_V_M1, VSSEG3E8_V, 0x0 }, // 10924
  { PseudoVSSEG3E8_V_M1_MASK, VSSEG3E8_V, 0x0 }, // 10925
  { PseudoVSSEG3E8_V_M2, VSSEG3E8_V, 0x1 }, // 10926
  { PseudoVSSEG3E8_V_M2_MASK, VSSEG3E8_V, 0x1 }, // 10927
  { PseudoVSSEG3E8_V_MF8, VSSEG3E8_V, 0x5 }, // 10928
  { PseudoVSSEG3E8_V_MF8_MASK, VSSEG3E8_V, 0x5 }, // 10929
  { PseudoVSSEG3E8_V_MF4, VSSEG3E8_V, 0x6 }, // 10930
  { PseudoVSSEG3E8_V_MF4_MASK, VSSEG3E8_V, 0x6 }, // 10931
  { PseudoVSSEG3E8_V_MF2, VSSEG3E8_V, 0x7 }, // 10932
  { PseudoVSSEG3E8_V_MF2_MASK, VSSEG3E8_V, 0x7 }, // 10933
  { PseudoVSSEG4E16_V_M1, VSSEG4E16_V, 0x0 }, // 10934
  { PseudoVSSEG4E16_V_M1_MASK, VSSEG4E16_V, 0x0 }, // 10935
  { PseudoVSSEG4E16_V_M2, VSSEG4E16_V, 0x1 }, // 10936
  { PseudoVSSEG4E16_V_M2_MASK, VSSEG4E16_V, 0x1 }, // 10937
  { PseudoVSSEG4E16_V_MF4, VSSEG4E16_V, 0x6 }, // 10938
  { PseudoVSSEG4E16_V_MF4_MASK, VSSEG4E16_V, 0x6 }, // 10939
  { PseudoVSSEG4E16_V_MF2, VSSEG4E16_V, 0x7 }, // 10940
  { PseudoVSSEG4E16_V_MF2_MASK, VSSEG4E16_V, 0x7 }, // 10941
  { PseudoVSSEG4E32_V_M1, VSSEG4E32_V, 0x0 }, // 10942
  { PseudoVSSEG4E32_V_M1_MASK, VSSEG4E32_V, 0x0 }, // 10943
  { PseudoVSSEG4E32_V_M2, VSSEG4E32_V, 0x1 }, // 10944
  { PseudoVSSEG4E32_V_M2_MASK, VSSEG4E32_V, 0x1 }, // 10945
  { PseudoVSSEG4E32_V_MF2, VSSEG4E32_V, 0x7 }, // 10946
  { PseudoVSSEG4E32_V_MF2_MASK, VSSEG4E32_V, 0x7 }, // 10947
  { PseudoVSSEG4E64_V_M1, VSSEG4E64_V, 0x0 }, // 10948
  { PseudoVSSEG4E64_V_M1_MASK, VSSEG4E64_V, 0x0 }, // 10949
  { PseudoVSSEG4E64_V_M2, VSSEG4E64_V, 0x1 }, // 10950
  { PseudoVSSEG4E64_V_M2_MASK, VSSEG4E64_V, 0x1 }, // 10951
  { PseudoVSSEG4E8_V_M1, VSSEG4E8_V, 0x0 }, // 10952
  { PseudoVSSEG4E8_V_M1_MASK, VSSEG4E8_V, 0x0 }, // 10953
  { PseudoVSSEG4E8_V_M2, VSSEG4E8_V, 0x1 }, // 10954
  { PseudoVSSEG4E8_V_M2_MASK, VSSEG4E8_V, 0x1 }, // 10955
  { PseudoVSSEG4E8_V_MF8, VSSEG4E8_V, 0x5 }, // 10956
  { PseudoVSSEG4E8_V_MF8_MASK, VSSEG4E8_V, 0x5 }, // 10957
  { PseudoVSSEG4E8_V_MF4, VSSEG4E8_V, 0x6 }, // 10958
  { PseudoVSSEG4E8_V_MF4_MASK, VSSEG4E8_V, 0x6 }, // 10959
  { PseudoVSSEG4E8_V_MF2, VSSEG4E8_V, 0x7 }, // 10960
  { PseudoVSSEG4E8_V_MF2_MASK, VSSEG4E8_V, 0x7 }, // 10961
  { PseudoVSSEG5E16_V_M1, VSSEG5E16_V, 0x0 }, // 10962
  { PseudoVSSEG5E16_V_M1_MASK, VSSEG5E16_V, 0x0 }, // 10963
  { PseudoVSSEG5E16_V_MF4, VSSEG5E16_V, 0x6 }, // 10964
  { PseudoVSSEG5E16_V_MF4_MASK, VSSEG5E16_V, 0x6 }, // 10965
  { PseudoVSSEG5E16_V_MF2, VSSEG5E16_V, 0x7 }, // 10966
  { PseudoVSSEG5E16_V_MF2_MASK, VSSEG5E16_V, 0x7 }, // 10967
  { PseudoVSSEG5E32_V_M1, VSSEG5E32_V, 0x0 }, // 10968
  { PseudoVSSEG5E32_V_M1_MASK, VSSEG5E32_V, 0x0 }, // 10969
  { PseudoVSSEG5E32_V_MF2, VSSEG5E32_V, 0x7 }, // 10970
  { PseudoVSSEG5E32_V_MF2_MASK, VSSEG5E32_V, 0x7 }, // 10971
  { PseudoVSSEG5E64_V_M1, VSSEG5E64_V, 0x0 }, // 10972
  { PseudoVSSEG5E64_V_M1_MASK, VSSEG5E64_V, 0x0 }, // 10973
  { PseudoVSSEG5E8_V_M1, VSSEG5E8_V, 0x0 }, // 10974
  { PseudoVSSEG5E8_V_M1_MASK, VSSEG5E8_V, 0x0 }, // 10975
  { PseudoVSSEG5E8_V_MF8, VSSEG5E8_V, 0x5 }, // 10976
  { PseudoVSSEG5E8_V_MF8_MASK, VSSEG5E8_V, 0x5 }, // 10977
  { PseudoVSSEG5E8_V_MF4, VSSEG5E8_V, 0x6 }, // 10978
  { PseudoVSSEG5E8_V_MF4_MASK, VSSEG5E8_V, 0x6 }, // 10979
  { PseudoVSSEG5E8_V_MF2, VSSEG5E8_V, 0x7 }, // 10980
  { PseudoVSSEG5E8_V_MF2_MASK, VSSEG5E8_V, 0x7 }, // 10981
  { PseudoVSSEG6E16_V_M1, VSSEG6E16_V, 0x0 }, // 10982
  { PseudoVSSEG6E16_V_M1_MASK, VSSEG6E16_V, 0x0 }, // 10983
  { PseudoVSSEG6E16_V_MF4, VSSEG6E16_V, 0x6 }, // 10984
  { PseudoVSSEG6E16_V_MF4_MASK, VSSEG6E16_V, 0x6 }, // 10985
  { PseudoVSSEG6E16_V_MF2, VSSEG6E16_V, 0x7 }, // 10986
  { PseudoVSSEG6E16_V_MF2_MASK, VSSEG6E16_V, 0x7 }, // 10987
  { PseudoVSSEG6E32_V_M1, VSSEG6E32_V, 0x0 }, // 10988
  { PseudoVSSEG6E32_V_M1_MASK, VSSEG6E32_V, 0x0 }, // 10989
  { PseudoVSSEG6E32_V_MF2, VSSEG6E32_V, 0x7 }, // 10990
  { PseudoVSSEG6E32_V_MF2_MASK, VSSEG6E32_V, 0x7 }, // 10991
  { PseudoVSSEG6E64_V_M1, VSSEG6E64_V, 0x0 }, // 10992
  { PseudoVSSEG6E64_V_M1_MASK, VSSEG6E64_V, 0x0 }, // 10993
  { PseudoVSSEG6E8_V_M1, VSSEG6E8_V, 0x0 }, // 10994
  { PseudoVSSEG6E8_V_M1_MASK, VSSEG6E8_V, 0x0 }, // 10995
  { PseudoVSSEG6E8_V_MF8, VSSEG6E8_V, 0x5 }, // 10996
  { PseudoVSSEG6E8_V_MF8_MASK, VSSEG6E8_V, 0x5 }, // 10997
  { PseudoVSSEG6E8_V_MF4, VSSEG6E8_V, 0x6 }, // 10998
  { PseudoVSSEG6E8_V_MF4_MASK, VSSEG6E8_V, 0x6 }, // 10999
  { PseudoVSSEG6E8_V_MF2, VSSEG6E8_V, 0x7 }, // 11000
  { PseudoVSSEG6E8_V_MF2_MASK, VSSEG6E8_V, 0x7 }, // 11001
  { PseudoVSSEG7E16_V_M1, VSSEG7E16_V, 0x0 }, // 11002
  { PseudoVSSEG7E16_V_M1_MASK, VSSEG7E16_V, 0x0 }, // 11003
  { PseudoVSSEG7E16_V_MF4, VSSEG7E16_V, 0x6 }, // 11004
  { PseudoVSSEG7E16_V_MF4_MASK, VSSEG7E16_V, 0x6 }, // 11005
  { PseudoVSSEG7E16_V_MF2, VSSEG7E16_V, 0x7 }, // 11006
  { PseudoVSSEG7E16_V_MF2_MASK, VSSEG7E16_V, 0x7 }, // 11007
  { PseudoVSSEG7E32_V_M1, VSSEG7E32_V, 0x0 }, // 11008
  { PseudoVSSEG7E32_V_M1_MASK, VSSEG7E32_V, 0x0 }, // 11009
  { PseudoVSSEG7E32_V_MF2, VSSEG7E32_V, 0x7 }, // 11010
  { PseudoVSSEG7E32_V_MF2_MASK, VSSEG7E32_V, 0x7 }, // 11011
  { PseudoVSSEG7E64_V_M1, VSSEG7E64_V, 0x0 }, // 11012
  { PseudoVSSEG7E64_V_M1_MASK, VSSEG7E64_V, 0x0 }, // 11013
  { PseudoVSSEG7E8_V_M1, VSSEG7E8_V, 0x0 }, // 11014
  { PseudoVSSEG7E8_V_M1_MASK, VSSEG7E8_V, 0x0 }, // 11015
  { PseudoVSSEG7E8_V_MF8, VSSEG7E8_V, 0x5 }, // 11016
  { PseudoVSSEG7E8_V_MF8_MASK, VSSEG7E8_V, 0x5 }, // 11017
  { PseudoVSSEG7E8_V_MF4, VSSEG7E8_V, 0x6 }, // 11018
  { PseudoVSSEG7E8_V_MF4_MASK, VSSEG7E8_V, 0x6 }, // 11019
  { PseudoVSSEG7E8_V_MF2, VSSEG7E8_V, 0x7 }, // 11020
  { PseudoVSSEG7E8_V_MF2_MASK, VSSEG7E8_V, 0x7 }, // 11021
  { PseudoVSSEG8E16_V_M1, VSSEG8E16_V, 0x0 }, // 11022
  { PseudoVSSEG8E16_V_M1_MASK, VSSEG8E16_V, 0x0 }, // 11023
  { PseudoVSSEG8E16_V_MF4, VSSEG8E16_V, 0x6 }, // 11024
  { PseudoVSSEG8E16_V_MF4_MASK, VSSEG8E16_V, 0x6 }, // 11025
  { PseudoVSSEG8E16_V_MF2, VSSEG8E16_V, 0x7 }, // 11026
  { PseudoVSSEG8E16_V_MF2_MASK, VSSEG8E16_V, 0x7 }, // 11027
  { PseudoVSSEG8E32_V_M1, VSSEG8E32_V, 0x0 }, // 11028
  { PseudoVSSEG8E32_V_M1_MASK, VSSEG8E32_V, 0x0 }, // 11029
  { PseudoVSSEG8E32_V_MF2, VSSEG8E32_V, 0x7 }, // 11030
  { PseudoVSSEG8E32_V_MF2_MASK, VSSEG8E32_V, 0x7 }, // 11031
  { PseudoVSSEG8E64_V_M1, VSSEG8E64_V, 0x0 }, // 11032
  { PseudoVSSEG8E64_V_M1_MASK, VSSEG8E64_V, 0x0 }, // 11033
  { PseudoVSSEG8E8_V_M1, VSSEG8E8_V, 0x0 }, // 11034
  { PseudoVSSEG8E8_V_M1_MASK, VSSEG8E8_V, 0x0 }, // 11035
  { PseudoVSSEG8E8_V_MF8, VSSEG8E8_V, 0x5 }, // 11036
  { PseudoVSSEG8E8_V_MF8_MASK, VSSEG8E8_V, 0x5 }, // 11037
  { PseudoVSSEG8E8_V_MF4, VSSEG8E8_V, 0x6 }, // 11038
  { PseudoVSSEG8E8_V_MF4_MASK, VSSEG8E8_V, 0x6 }, // 11039
  { PseudoVSSEG8E8_V_MF2, VSSEG8E8_V, 0x7 }, // 11040
  { PseudoVSSEG8E8_V_MF2_MASK, VSSEG8E8_V, 0x7 }, // 11041
  { PseudoVSSRA_VI_M1, VSSRA_VI, 0x0 }, // 11042
  { PseudoVSSRA_VI_M1_MASK, VSSRA_VI, 0x0 }, // 11043
  { PseudoVSSRA_VI_M1_TU, VSSRA_VI, 0x0 }, // 11044
  { PseudoVSSRA_VI_M2, VSSRA_VI, 0x1 }, // 11045
  { PseudoVSSRA_VI_M2_MASK, VSSRA_VI, 0x1 }, // 11046
  { PseudoVSSRA_VI_M2_TU, VSSRA_VI, 0x1 }, // 11047
  { PseudoVSSRA_VI_M4, VSSRA_VI, 0x2 }, // 11048
  { PseudoVSSRA_VI_M4_MASK, VSSRA_VI, 0x2 }, // 11049
  { PseudoVSSRA_VI_M4_TU, VSSRA_VI, 0x2 }, // 11050
  { PseudoVSSRA_VI_M8, VSSRA_VI, 0x3 }, // 11051
  { PseudoVSSRA_VI_M8_MASK, VSSRA_VI, 0x3 }, // 11052
  { PseudoVSSRA_VI_M8_TU, VSSRA_VI, 0x3 }, // 11053
  { PseudoVSSRA_VI_MF8, VSSRA_VI, 0x5 }, // 11054
  { PseudoVSSRA_VI_MF8_MASK, VSSRA_VI, 0x5 }, // 11055
  { PseudoVSSRA_VI_MF8_TU, VSSRA_VI, 0x5 }, // 11056
  { PseudoVSSRA_VI_MF4, VSSRA_VI, 0x6 }, // 11057
  { PseudoVSSRA_VI_MF4_MASK, VSSRA_VI, 0x6 }, // 11058
  { PseudoVSSRA_VI_MF4_TU, VSSRA_VI, 0x6 }, // 11059
  { PseudoVSSRA_VI_MF2, VSSRA_VI, 0x7 }, // 11060
  { PseudoVSSRA_VI_MF2_MASK, VSSRA_VI, 0x7 }, // 11061
  { PseudoVSSRA_VI_MF2_TU, VSSRA_VI, 0x7 }, // 11062
  { PseudoVSSRA_VV_M1, VSSRA_VV, 0x0 }, // 11063
  { PseudoVSSRA_VV_M1_MASK, VSSRA_VV, 0x0 }, // 11064
  { PseudoVSSRA_VV_M1_TU, VSSRA_VV, 0x0 }, // 11065
  { PseudoVSSRA_VV_M2, VSSRA_VV, 0x1 }, // 11066
  { PseudoVSSRA_VV_M2_MASK, VSSRA_VV, 0x1 }, // 11067
  { PseudoVSSRA_VV_M2_TU, VSSRA_VV, 0x1 }, // 11068
  { PseudoVSSRA_VV_M4, VSSRA_VV, 0x2 }, // 11069
  { PseudoVSSRA_VV_M4_MASK, VSSRA_VV, 0x2 }, // 11070
  { PseudoVSSRA_VV_M4_TU, VSSRA_VV, 0x2 }, // 11071
  { PseudoVSSRA_VV_M8, VSSRA_VV, 0x3 }, // 11072
  { PseudoVSSRA_VV_M8_MASK, VSSRA_VV, 0x3 }, // 11073
  { PseudoVSSRA_VV_M8_TU, VSSRA_VV, 0x3 }, // 11074
  { PseudoVSSRA_VV_MF8, VSSRA_VV, 0x5 }, // 11075
  { PseudoVSSRA_VV_MF8_MASK, VSSRA_VV, 0x5 }, // 11076
  { PseudoVSSRA_VV_MF8_TU, VSSRA_VV, 0x5 }, // 11077
  { PseudoVSSRA_VV_MF4, VSSRA_VV, 0x6 }, // 11078
  { PseudoVSSRA_VV_MF4_MASK, VSSRA_VV, 0x6 }, // 11079
  { PseudoVSSRA_VV_MF4_TU, VSSRA_VV, 0x6 }, // 11080
  { PseudoVSSRA_VV_MF2, VSSRA_VV, 0x7 }, // 11081
  { PseudoVSSRA_VV_MF2_MASK, VSSRA_VV, 0x7 }, // 11082
  { PseudoVSSRA_VV_MF2_TU, VSSRA_VV, 0x7 }, // 11083
  { PseudoVSSRA_VX_M1, VSSRA_VX, 0x0 }, // 11084
  { PseudoVSSRA_VX_M1_MASK, VSSRA_VX, 0x0 }, // 11085
  { PseudoVSSRA_VX_M1_TU, VSSRA_VX, 0x0 }, // 11086
  { PseudoVSSRA_VX_M2, VSSRA_VX, 0x1 }, // 11087
  { PseudoVSSRA_VX_M2_MASK, VSSRA_VX, 0x1 }, // 11088
  { PseudoVSSRA_VX_M2_TU, VSSRA_VX, 0x1 }, // 11089
  { PseudoVSSRA_VX_M4, VSSRA_VX, 0x2 }, // 11090
  { PseudoVSSRA_VX_M4_MASK, VSSRA_VX, 0x2 }, // 11091
  { PseudoVSSRA_VX_M4_TU, VSSRA_VX, 0x2 }, // 11092
  { PseudoVSSRA_VX_M8, VSSRA_VX, 0x3 }, // 11093
  { PseudoVSSRA_VX_M8_MASK, VSSRA_VX, 0x3 }, // 11094
  { PseudoVSSRA_VX_M8_TU, VSSRA_VX, 0x3 }, // 11095
  { PseudoVSSRA_VX_MF8, VSSRA_VX, 0x5 }, // 11096
  { PseudoVSSRA_VX_MF8_MASK, VSSRA_VX, 0x5 }, // 11097
  { PseudoVSSRA_VX_MF8_TU, VSSRA_VX, 0x5 }, // 11098
  { PseudoVSSRA_VX_MF4, VSSRA_VX, 0x6 }, // 11099
  { PseudoVSSRA_VX_MF4_MASK, VSSRA_VX, 0x6 }, // 11100
  { PseudoVSSRA_VX_MF4_TU, VSSRA_VX, 0x6 }, // 11101
  { PseudoVSSRA_VX_MF2, VSSRA_VX, 0x7 }, // 11102
  { PseudoVSSRA_VX_MF2_MASK, VSSRA_VX, 0x7 }, // 11103
  { PseudoVSSRA_VX_MF2_TU, VSSRA_VX, 0x7 }, // 11104
  { PseudoVSSRL_VI_M1, VSSRL_VI, 0x0 }, // 11105
  { PseudoVSSRL_VI_M1_MASK, VSSRL_VI, 0x0 }, // 11106
  { PseudoVSSRL_VI_M1_TU, VSSRL_VI, 0x0 }, // 11107
  { PseudoVSSRL_VI_M2, VSSRL_VI, 0x1 }, // 11108
  { PseudoVSSRL_VI_M2_MASK, VSSRL_VI, 0x1 }, // 11109
  { PseudoVSSRL_VI_M2_TU, VSSRL_VI, 0x1 }, // 11110
  { PseudoVSSRL_VI_M4, VSSRL_VI, 0x2 }, // 11111
  { PseudoVSSRL_VI_M4_MASK, VSSRL_VI, 0x2 }, // 11112
  { PseudoVSSRL_VI_M4_TU, VSSRL_VI, 0x2 }, // 11113
  { PseudoVSSRL_VI_M8, VSSRL_VI, 0x3 }, // 11114
  { PseudoVSSRL_VI_M8_MASK, VSSRL_VI, 0x3 }, // 11115
  { PseudoVSSRL_VI_M8_TU, VSSRL_VI, 0x3 }, // 11116
  { PseudoVSSRL_VI_MF8, VSSRL_VI, 0x5 }, // 11117
  { PseudoVSSRL_VI_MF8_MASK, VSSRL_VI, 0x5 }, // 11118
  { PseudoVSSRL_VI_MF8_TU, VSSRL_VI, 0x5 }, // 11119
  { PseudoVSSRL_VI_MF4, VSSRL_VI, 0x6 }, // 11120
  { PseudoVSSRL_VI_MF4_MASK, VSSRL_VI, 0x6 }, // 11121
  { PseudoVSSRL_VI_MF4_TU, VSSRL_VI, 0x6 }, // 11122
  { PseudoVSSRL_VI_MF2, VSSRL_VI, 0x7 }, // 11123
  { PseudoVSSRL_VI_MF2_MASK, VSSRL_VI, 0x7 }, // 11124
  { PseudoVSSRL_VI_MF2_TU, VSSRL_VI, 0x7 }, // 11125
  { PseudoVSSRL_VV_M1, VSSRL_VV, 0x0 }, // 11126
  { PseudoVSSRL_VV_M1_MASK, VSSRL_VV, 0x0 }, // 11127
  { PseudoVSSRL_VV_M1_TU, VSSRL_VV, 0x0 }, // 11128
  { PseudoVSSRL_VV_M2, VSSRL_VV, 0x1 }, // 11129
  { PseudoVSSRL_VV_M2_MASK, VSSRL_VV, 0x1 }, // 11130
  { PseudoVSSRL_VV_M2_TU, VSSRL_VV, 0x1 }, // 11131
  { PseudoVSSRL_VV_M4, VSSRL_VV, 0x2 }, // 11132
  { PseudoVSSRL_VV_M4_MASK, VSSRL_VV, 0x2 }, // 11133
  { PseudoVSSRL_VV_M4_TU, VSSRL_VV, 0x2 }, // 11134
  { PseudoVSSRL_VV_M8, VSSRL_VV, 0x3 }, // 11135
  { PseudoVSSRL_VV_M8_MASK, VSSRL_VV, 0x3 }, // 11136
  { PseudoVSSRL_VV_M8_TU, VSSRL_VV, 0x3 }, // 11137
  { PseudoVSSRL_VV_MF8, VSSRL_VV, 0x5 }, // 11138
  { PseudoVSSRL_VV_MF8_MASK, VSSRL_VV, 0x5 }, // 11139
  { PseudoVSSRL_VV_MF8_TU, VSSRL_VV, 0x5 }, // 11140
  { PseudoVSSRL_VV_MF4, VSSRL_VV, 0x6 }, // 11141
  { PseudoVSSRL_VV_MF4_MASK, VSSRL_VV, 0x6 }, // 11142
  { PseudoVSSRL_VV_MF4_TU, VSSRL_VV, 0x6 }, // 11143
  { PseudoVSSRL_VV_MF2, VSSRL_VV, 0x7 }, // 11144
  { PseudoVSSRL_VV_MF2_MASK, VSSRL_VV, 0x7 }, // 11145
  { PseudoVSSRL_VV_MF2_TU, VSSRL_VV, 0x7 }, // 11146
  { PseudoVSSRL_VX_M1, VSSRL_VX, 0x0 }, // 11147
  { PseudoVSSRL_VX_M1_MASK, VSSRL_VX, 0x0 }, // 11148
  { PseudoVSSRL_VX_M1_TU, VSSRL_VX, 0x0 }, // 11149
  { PseudoVSSRL_VX_M2, VSSRL_VX, 0x1 }, // 11150
  { PseudoVSSRL_VX_M2_MASK, VSSRL_VX, 0x1 }, // 11151
  { PseudoVSSRL_VX_M2_TU, VSSRL_VX, 0x1 }, // 11152
  { PseudoVSSRL_VX_M4, VSSRL_VX, 0x2 }, // 11153
  { PseudoVSSRL_VX_M4_MASK, VSSRL_VX, 0x2 }, // 11154
  { PseudoVSSRL_VX_M4_TU, VSSRL_VX, 0x2 }, // 11155
  { PseudoVSSRL_VX_M8, VSSRL_VX, 0x3 }, // 11156
  { PseudoVSSRL_VX_M8_MASK, VSSRL_VX, 0x3 }, // 11157
  { PseudoVSSRL_VX_M8_TU, VSSRL_VX, 0x3 }, // 11158
  { PseudoVSSRL_VX_MF8, VSSRL_VX, 0x5 }, // 11159
  { PseudoVSSRL_VX_MF8_MASK, VSSRL_VX, 0x5 }, // 11160
  { PseudoVSSRL_VX_MF8_TU, VSSRL_VX, 0x5 }, // 11161
  { PseudoVSSRL_VX_MF4, VSSRL_VX, 0x6 }, // 11162
  { PseudoVSSRL_VX_MF4_MASK, VSSRL_VX, 0x6 }, // 11163
  { PseudoVSSRL_VX_MF4_TU, VSSRL_VX, 0x6 }, // 11164
  { PseudoVSSRL_VX_MF2, VSSRL_VX, 0x7 }, // 11165
  { PseudoVSSRL_VX_MF2_MASK, VSSRL_VX, 0x7 }, // 11166
  { PseudoVSSRL_VX_MF2_TU, VSSRL_VX, 0x7 }, // 11167
  { PseudoVSSSEG2E16_V_M1, VSSSEG2E16_V, 0x0 }, // 11168
  { PseudoVSSSEG2E16_V_M1_MASK, VSSSEG2E16_V, 0x0 }, // 11169
  { PseudoVSSSEG2E16_V_M2, VSSSEG2E16_V, 0x1 }, // 11170
  { PseudoVSSSEG2E16_V_M2_MASK, VSSSEG2E16_V, 0x1 }, // 11171
  { PseudoVSSSEG2E16_V_M4, VSSSEG2E16_V, 0x2 }, // 11172
  { PseudoVSSSEG2E16_V_M4_MASK, VSSSEG2E16_V, 0x2 }, // 11173
  { PseudoVSSSEG2E16_V_MF4, VSSSEG2E16_V, 0x6 }, // 11174
  { PseudoVSSSEG2E16_V_MF4_MASK, VSSSEG2E16_V, 0x6 }, // 11175
  { PseudoVSSSEG2E16_V_MF2, VSSSEG2E16_V, 0x7 }, // 11176
  { PseudoVSSSEG2E16_V_MF2_MASK, VSSSEG2E16_V, 0x7 }, // 11177
  { PseudoVSSSEG2E32_V_M1, VSSSEG2E32_V, 0x0 }, // 11178
  { PseudoVSSSEG2E32_V_M1_MASK, VSSSEG2E32_V, 0x0 }, // 11179
  { PseudoVSSSEG2E32_V_M2, VSSSEG2E32_V, 0x1 }, // 11180
  { PseudoVSSSEG2E32_V_M2_MASK, VSSSEG2E32_V, 0x1 }, // 11181
  { PseudoVSSSEG2E32_V_M4, VSSSEG2E32_V, 0x2 }, // 11182
  { PseudoVSSSEG2E32_V_M4_MASK, VSSSEG2E32_V, 0x2 }, // 11183
  { PseudoVSSSEG2E32_V_MF2, VSSSEG2E32_V, 0x7 }, // 11184
  { PseudoVSSSEG2E32_V_MF2_MASK, VSSSEG2E32_V, 0x7 }, // 11185
  { PseudoVSSSEG2E64_V_M1, VSSSEG2E64_V, 0x0 }, // 11186
  { PseudoVSSSEG2E64_V_M1_MASK, VSSSEG2E64_V, 0x0 }, // 11187
  { PseudoVSSSEG2E64_V_M2, VSSSEG2E64_V, 0x1 }, // 11188
  { PseudoVSSSEG2E64_V_M2_MASK, VSSSEG2E64_V, 0x1 }, // 11189
  { PseudoVSSSEG2E64_V_M4, VSSSEG2E64_V, 0x2 }, // 11190
  { PseudoVSSSEG2E64_V_M4_MASK, VSSSEG2E64_V, 0x2 }, // 11191
  { PseudoVSSSEG2E8_V_M1, VSSSEG2E8_V, 0x0 }, // 11192
  { PseudoVSSSEG2E8_V_M1_MASK, VSSSEG2E8_V, 0x0 }, // 11193
  { PseudoVSSSEG2E8_V_M2, VSSSEG2E8_V, 0x1 }, // 11194
  { PseudoVSSSEG2E8_V_M2_MASK, VSSSEG2E8_V, 0x1 }, // 11195
  { PseudoVSSSEG2E8_V_M4, VSSSEG2E8_V, 0x2 }, // 11196
  { PseudoVSSSEG2E8_V_M4_MASK, VSSSEG2E8_V, 0x2 }, // 11197
  { PseudoVSSSEG2E8_V_MF8, VSSSEG2E8_V, 0x5 }, // 11198
  { PseudoVSSSEG2E8_V_MF8_MASK, VSSSEG2E8_V, 0x5 }, // 11199
  { PseudoVSSSEG2E8_V_MF4, VSSSEG2E8_V, 0x6 }, // 11200
  { PseudoVSSSEG2E8_V_MF4_MASK, VSSSEG2E8_V, 0x6 }, // 11201
  { PseudoVSSSEG2E8_V_MF2, VSSSEG2E8_V, 0x7 }, // 11202
  { PseudoVSSSEG2E8_V_MF2_MASK, VSSSEG2E8_V, 0x7 }, // 11203
  { PseudoVSSSEG3E16_V_M1, VSSSEG3E16_V, 0x0 }, // 11204
  { PseudoVSSSEG3E16_V_M1_MASK, VSSSEG3E16_V, 0x0 }, // 11205
  { PseudoVSSSEG3E16_V_M2, VSSSEG3E16_V, 0x1 }, // 11206
  { PseudoVSSSEG3E16_V_M2_MASK, VSSSEG3E16_V, 0x1 }, // 11207
  { PseudoVSSSEG3E16_V_MF4, VSSSEG3E16_V, 0x6 }, // 11208
  { PseudoVSSSEG3E16_V_MF4_MASK, VSSSEG3E16_V, 0x6 }, // 11209
  { PseudoVSSSEG3E16_V_MF2, VSSSEG3E16_V, 0x7 }, // 11210
  { PseudoVSSSEG3E16_V_MF2_MASK, VSSSEG3E16_V, 0x7 }, // 11211
  { PseudoVSSSEG3E32_V_M1, VSSSEG3E32_V, 0x0 }, // 11212
  { PseudoVSSSEG3E32_V_M1_MASK, VSSSEG3E32_V, 0x0 }, // 11213
  { PseudoVSSSEG3E32_V_M2, VSSSEG3E32_V, 0x1 }, // 11214
  { PseudoVSSSEG3E32_V_M2_MASK, VSSSEG3E32_V, 0x1 }, // 11215
  { PseudoVSSSEG3E32_V_MF2, VSSSEG3E32_V, 0x7 }, // 11216
  { PseudoVSSSEG3E32_V_MF2_MASK, VSSSEG3E32_V, 0x7 }, // 11217
  { PseudoVSSSEG3E64_V_M1, VSSSEG3E64_V, 0x0 }, // 11218
  { PseudoVSSSEG3E64_V_M1_MASK, VSSSEG3E64_V, 0x0 }, // 11219
  { PseudoVSSSEG3E64_V_M2, VSSSEG3E64_V, 0x1 }, // 11220
  { PseudoVSSSEG3E64_V_M2_MASK, VSSSEG3E64_V, 0x1 }, // 11221
  { PseudoVSSSEG3E8_V_M1, VSSSEG3E8_V, 0x0 }, // 11222
  { PseudoVSSSEG3E8_V_M1_MASK, VSSSEG3E8_V, 0x0 }, // 11223
  { PseudoVSSSEG3E8_V_M2, VSSSEG3E8_V, 0x1 }, // 11224
  { PseudoVSSSEG3E8_V_M2_MASK, VSSSEG3E8_V, 0x1 }, // 11225
  { PseudoVSSSEG3E8_V_MF8, VSSSEG3E8_V, 0x5 }, // 11226
  { PseudoVSSSEG3E8_V_MF8_MASK, VSSSEG3E8_V, 0x5 }, // 11227
  { PseudoVSSSEG3E8_V_MF4, VSSSEG3E8_V, 0x6 }, // 11228
  { PseudoVSSSEG3E8_V_MF4_MASK, VSSSEG3E8_V, 0x6 }, // 11229
  { PseudoVSSSEG3E8_V_MF2, VSSSEG3E8_V, 0x7 }, // 11230
  { PseudoVSSSEG3E8_V_MF2_MASK, VSSSEG3E8_V, 0x7 }, // 11231
  { PseudoVSSSEG4E16_V_M1, VSSSEG4E16_V, 0x0 }, // 11232
  { PseudoVSSSEG4E16_V_M1_MASK, VSSSEG4E16_V, 0x0 }, // 11233
  { PseudoVSSSEG4E16_V_M2, VSSSEG4E16_V, 0x1 }, // 11234
  { PseudoVSSSEG4E16_V_M2_MASK, VSSSEG4E16_V, 0x1 }, // 11235
  { PseudoVSSSEG4E16_V_MF4, VSSSEG4E16_V, 0x6 }, // 11236
  { PseudoVSSSEG4E16_V_MF4_MASK, VSSSEG4E16_V, 0x6 }, // 11237
  { PseudoVSSSEG4E16_V_MF2, VSSSEG4E16_V, 0x7 }, // 11238
  { PseudoVSSSEG4E16_V_MF2_MASK, VSSSEG4E16_V, 0x7 }, // 11239
  { PseudoVSSSEG4E32_V_M1, VSSSEG4E32_V, 0x0 }, // 11240
  { PseudoVSSSEG4E32_V_M1_MASK, VSSSEG4E32_V, 0x0 }, // 11241
  { PseudoVSSSEG4E32_V_M2, VSSSEG4E32_V, 0x1 }, // 11242
  { PseudoVSSSEG4E32_V_M2_MASK, VSSSEG4E32_V, 0x1 }, // 11243
  { PseudoVSSSEG4E32_V_MF2, VSSSEG4E32_V, 0x7 }, // 11244
  { PseudoVSSSEG4E32_V_MF2_MASK, VSSSEG4E32_V, 0x7 }, // 11245
  { PseudoVSSSEG4E64_V_M1, VSSSEG4E64_V, 0x0 }, // 11246
  { PseudoVSSSEG4E64_V_M1_MASK, VSSSEG4E64_V, 0x0 }, // 11247
  { PseudoVSSSEG4E64_V_M2, VSSSEG4E64_V, 0x1 }, // 11248
  { PseudoVSSSEG4E64_V_M2_MASK, VSSSEG4E64_V, 0x1 }, // 11249
  { PseudoVSSSEG4E8_V_M1, VSSSEG4E8_V, 0x0 }, // 11250
  { PseudoVSSSEG4E8_V_M1_MASK, VSSSEG4E8_V, 0x0 }, // 11251
  { PseudoVSSSEG4E8_V_M2, VSSSEG4E8_V, 0x1 }, // 11252
  { PseudoVSSSEG4E8_V_M2_MASK, VSSSEG4E8_V, 0x1 }, // 11253
  { PseudoVSSSEG4E8_V_MF8, VSSSEG4E8_V, 0x5 }, // 11254
  { PseudoVSSSEG4E8_V_MF8_MASK, VSSSEG4E8_V, 0x5 }, // 11255
  { PseudoVSSSEG4E8_V_MF4, VSSSEG4E8_V, 0x6 }, // 11256
  { PseudoVSSSEG4E8_V_MF4_MASK, VSSSEG4E8_V, 0x6 }, // 11257
  { PseudoVSSSEG4E8_V_MF2, VSSSEG4E8_V, 0x7 }, // 11258
  { PseudoVSSSEG4E8_V_MF2_MASK, VSSSEG4E8_V, 0x7 }, // 11259
  { PseudoVSSSEG5E16_V_M1, VSSSEG5E16_V, 0x0 }, // 11260
  { PseudoVSSSEG5E16_V_M1_MASK, VSSSEG5E16_V, 0x0 }, // 11261
  { PseudoVSSSEG5E16_V_MF4, VSSSEG5E16_V, 0x6 }, // 11262
  { PseudoVSSSEG5E16_V_MF4_MASK, VSSSEG5E16_V, 0x6 }, // 11263
  { PseudoVSSSEG5E16_V_MF2, VSSSEG5E16_V, 0x7 }, // 11264
  { PseudoVSSSEG5E16_V_MF2_MASK, VSSSEG5E16_V, 0x7 }, // 11265
  { PseudoVSSSEG5E32_V_M1, VSSSEG5E32_V, 0x0 }, // 11266
  { PseudoVSSSEG5E32_V_M1_MASK, VSSSEG5E32_V, 0x0 }, // 11267
  { PseudoVSSSEG5E32_V_MF2, VSSSEG5E32_V, 0x7 }, // 11268
  { PseudoVSSSEG5E32_V_MF2_MASK, VSSSEG5E32_V, 0x7 }, // 11269
  { PseudoVSSSEG5E64_V_M1, VSSSEG5E64_V, 0x0 }, // 11270
  { PseudoVSSSEG5E64_V_M1_MASK, VSSSEG5E64_V, 0x0 }, // 11271
  { PseudoVSSSEG5E8_V_M1, VSSSEG5E8_V, 0x0 }, // 11272
  { PseudoVSSSEG5E8_V_M1_MASK, VSSSEG5E8_V, 0x0 }, // 11273
  { PseudoVSSSEG5E8_V_MF8, VSSSEG5E8_V, 0x5 }, // 11274
  { PseudoVSSSEG5E8_V_MF8_MASK, VSSSEG5E8_V, 0x5 }, // 11275
  { PseudoVSSSEG5E8_V_MF4, VSSSEG5E8_V, 0x6 }, // 11276
  { PseudoVSSSEG5E8_V_MF4_MASK, VSSSEG5E8_V, 0x6 }, // 11277
  { PseudoVSSSEG5E8_V_MF2, VSSSEG5E8_V, 0x7 }, // 11278
  { PseudoVSSSEG5E8_V_MF2_MASK, VSSSEG5E8_V, 0x7 }, // 11279
  { PseudoVSSSEG6E16_V_M1, VSSSEG6E16_V, 0x0 }, // 11280
  { PseudoVSSSEG6E16_V_M1_MASK, VSSSEG6E16_V, 0x0 }, // 11281
  { PseudoVSSSEG6E16_V_MF4, VSSSEG6E16_V, 0x6 }, // 11282
  { PseudoVSSSEG6E16_V_MF4_MASK, VSSSEG6E16_V, 0x6 }, // 11283
  { PseudoVSSSEG6E16_V_MF2, VSSSEG6E16_V, 0x7 }, // 11284
  { PseudoVSSSEG6E16_V_MF2_MASK, VSSSEG6E16_V, 0x7 }, // 11285
  { PseudoVSSSEG6E32_V_M1, VSSSEG6E32_V, 0x0 }, // 11286
  { PseudoVSSSEG6E32_V_M1_MASK, VSSSEG6E32_V, 0x0 }, // 11287
  { PseudoVSSSEG6E32_V_MF2, VSSSEG6E32_V, 0x7 }, // 11288
  { PseudoVSSSEG6E32_V_MF2_MASK, VSSSEG6E32_V, 0x7 }, // 11289
  { PseudoVSSSEG6E64_V_M1, VSSSEG6E64_V, 0x0 }, // 11290
  { PseudoVSSSEG6E64_V_M1_MASK, VSSSEG6E64_V, 0x0 }, // 11291
  { PseudoVSSSEG6E8_V_M1, VSSSEG6E8_V, 0x0 }, // 11292
  { PseudoVSSSEG6E8_V_M1_MASK, VSSSEG6E8_V, 0x0 }, // 11293
  { PseudoVSSSEG6E8_V_MF8, VSSSEG6E8_V, 0x5 }, // 11294
  { PseudoVSSSEG6E8_V_MF8_MASK, VSSSEG6E8_V, 0x5 }, // 11295
  { PseudoVSSSEG6E8_V_MF4, VSSSEG6E8_V, 0x6 }, // 11296
  { PseudoVSSSEG6E8_V_MF4_MASK, VSSSEG6E8_V, 0x6 }, // 11297
  { PseudoVSSSEG6E8_V_MF2, VSSSEG6E8_V, 0x7 }, // 11298
  { PseudoVSSSEG6E8_V_MF2_MASK, VSSSEG6E8_V, 0x7 }, // 11299
  { PseudoVSSSEG7E16_V_M1, VSSSEG7E16_V, 0x0 }, // 11300
  { PseudoVSSSEG7E16_V_M1_MASK, VSSSEG7E16_V, 0x0 }, // 11301
  { PseudoVSSSEG7E16_V_MF4, VSSSEG7E16_V, 0x6 }, // 11302
  { PseudoVSSSEG7E16_V_MF4_MASK, VSSSEG7E16_V, 0x6 }, // 11303
  { PseudoVSSSEG7E16_V_MF2, VSSSEG7E16_V, 0x7 }, // 11304
  { PseudoVSSSEG7E16_V_MF2_MASK, VSSSEG7E16_V, 0x7 }, // 11305
  { PseudoVSSSEG7E32_V_M1, VSSSEG7E32_V, 0x0 }, // 11306
  { PseudoVSSSEG7E32_V_M1_MASK, VSSSEG7E32_V, 0x0 }, // 11307
  { PseudoVSSSEG7E32_V_MF2, VSSSEG7E32_V, 0x7 }, // 11308
  { PseudoVSSSEG7E32_V_MF2_MASK, VSSSEG7E32_V, 0x7 }, // 11309
  { PseudoVSSSEG7E64_V_M1, VSSSEG7E64_V, 0x0 }, // 11310
  { PseudoVSSSEG7E64_V_M1_MASK, VSSSEG7E64_V, 0x0 }, // 11311
  { PseudoVSSSEG7E8_V_M1, VSSSEG7E8_V, 0x0 }, // 11312
  { PseudoVSSSEG7E8_V_M1_MASK, VSSSEG7E8_V, 0x0 }, // 11313
  { PseudoVSSSEG7E8_V_MF8, VSSSEG7E8_V, 0x5 }, // 11314
  { PseudoVSSSEG7E8_V_MF8_MASK, VSSSEG7E8_V, 0x5 }, // 11315
  { PseudoVSSSEG7E8_V_MF4, VSSSEG7E8_V, 0x6 }, // 11316
  { PseudoVSSSEG7E8_V_MF4_MASK, VSSSEG7E8_V, 0x6 }, // 11317
  { PseudoVSSSEG7E8_V_MF2, VSSSEG7E8_V, 0x7 }, // 11318
  { PseudoVSSSEG7E8_V_MF2_MASK, VSSSEG7E8_V, 0x7 }, // 11319
  { PseudoVSSSEG8E16_V_M1, VSSSEG8E16_V, 0x0 }, // 11320
  { PseudoVSSSEG8E16_V_M1_MASK, VSSSEG8E16_V, 0x0 }, // 11321
  { PseudoVSSSEG8E16_V_MF4, VSSSEG8E16_V, 0x6 }, // 11322
  { PseudoVSSSEG8E16_V_MF4_MASK, VSSSEG8E16_V, 0x6 }, // 11323
  { PseudoVSSSEG8E16_V_MF2, VSSSEG8E16_V, 0x7 }, // 11324
  { PseudoVSSSEG8E16_V_MF2_MASK, VSSSEG8E16_V, 0x7 }, // 11325
  { PseudoVSSSEG8E32_V_M1, VSSSEG8E32_V, 0x0 }, // 11326
  { PseudoVSSSEG8E32_V_M1_MASK, VSSSEG8E32_V, 0x0 }, // 11327
  { PseudoVSSSEG8E32_V_MF2, VSSSEG8E32_V, 0x7 }, // 11328
  { PseudoVSSSEG8E32_V_MF2_MASK, VSSSEG8E32_V, 0x7 }, // 11329
  { PseudoVSSSEG8E64_V_M1, VSSSEG8E64_V, 0x0 }, // 11330
  { PseudoVSSSEG8E64_V_M1_MASK, VSSSEG8E64_V, 0x0 }, // 11331
  { PseudoVSSSEG8E8_V_M1, VSSSEG8E8_V, 0x0 }, // 11332
  { PseudoVSSSEG8E8_V_M1_MASK, VSSSEG8E8_V, 0x0 }, // 11333
  { PseudoVSSSEG8E8_V_MF8, VSSSEG8E8_V, 0x5 }, // 11334
  { PseudoVSSSEG8E8_V_MF8_MASK, VSSSEG8E8_V, 0x5 }, // 11335
  { PseudoVSSSEG8E8_V_MF4, VSSSEG8E8_V, 0x6 }, // 11336
  { PseudoVSSSEG8E8_V_MF4_MASK, VSSSEG8E8_V, 0x6 }, // 11337
  { PseudoVSSSEG8E8_V_MF2, VSSSEG8E8_V, 0x7 }, // 11338
  { PseudoVSSSEG8E8_V_MF2_MASK, VSSSEG8E8_V, 0x7 }, // 11339
  { PseudoVSSUBU_VV_M1, VSSUBU_VV, 0x0 }, // 11340
  { PseudoVSSUBU_VV_M1_MASK, VSSUBU_VV, 0x0 }, // 11341
  { PseudoVSSUBU_VV_M1_TU, VSSUBU_VV, 0x0 }, // 11342
  { PseudoVSSUBU_VV_M2, VSSUBU_VV, 0x1 }, // 11343
  { PseudoVSSUBU_VV_M2_MASK, VSSUBU_VV, 0x1 }, // 11344
  { PseudoVSSUBU_VV_M2_TU, VSSUBU_VV, 0x1 }, // 11345
  { PseudoVSSUBU_VV_M4, VSSUBU_VV, 0x2 }, // 11346
  { PseudoVSSUBU_VV_M4_MASK, VSSUBU_VV, 0x2 }, // 11347
  { PseudoVSSUBU_VV_M4_TU, VSSUBU_VV, 0x2 }, // 11348
  { PseudoVSSUBU_VV_M8, VSSUBU_VV, 0x3 }, // 11349
  { PseudoVSSUBU_VV_M8_MASK, VSSUBU_VV, 0x3 }, // 11350
  { PseudoVSSUBU_VV_M8_TU, VSSUBU_VV, 0x3 }, // 11351
  { PseudoVSSUBU_VV_MF8, VSSUBU_VV, 0x5 }, // 11352
  { PseudoVSSUBU_VV_MF8_MASK, VSSUBU_VV, 0x5 }, // 11353
  { PseudoVSSUBU_VV_MF8_TU, VSSUBU_VV, 0x5 }, // 11354
  { PseudoVSSUBU_VV_MF4, VSSUBU_VV, 0x6 }, // 11355
  { PseudoVSSUBU_VV_MF4_MASK, VSSUBU_VV, 0x6 }, // 11356
  { PseudoVSSUBU_VV_MF4_TU, VSSUBU_VV, 0x6 }, // 11357
  { PseudoVSSUBU_VV_MF2, VSSUBU_VV, 0x7 }, // 11358
  { PseudoVSSUBU_VV_MF2_MASK, VSSUBU_VV, 0x7 }, // 11359
  { PseudoVSSUBU_VV_MF2_TU, VSSUBU_VV, 0x7 }, // 11360
  { PseudoVSSUBU_VX_M1, VSSUBU_VX, 0x0 }, // 11361
  { PseudoVSSUBU_VX_M1_MASK, VSSUBU_VX, 0x0 }, // 11362
  { PseudoVSSUBU_VX_M1_TU, VSSUBU_VX, 0x0 }, // 11363
  { PseudoVSSUBU_VX_M2, VSSUBU_VX, 0x1 }, // 11364
  { PseudoVSSUBU_VX_M2_MASK, VSSUBU_VX, 0x1 }, // 11365
  { PseudoVSSUBU_VX_M2_TU, VSSUBU_VX, 0x1 }, // 11366
  { PseudoVSSUBU_VX_M4, VSSUBU_VX, 0x2 }, // 11367
  { PseudoVSSUBU_VX_M4_MASK, VSSUBU_VX, 0x2 }, // 11368
  { PseudoVSSUBU_VX_M4_TU, VSSUBU_VX, 0x2 }, // 11369
  { PseudoVSSUBU_VX_M8, VSSUBU_VX, 0x3 }, // 11370
  { PseudoVSSUBU_VX_M8_MASK, VSSUBU_VX, 0x3 }, // 11371
  { PseudoVSSUBU_VX_M8_TU, VSSUBU_VX, 0x3 }, // 11372
  { PseudoVSSUBU_VX_MF8, VSSUBU_VX, 0x5 }, // 11373
  { PseudoVSSUBU_VX_MF8_MASK, VSSUBU_VX, 0x5 }, // 11374
  { PseudoVSSUBU_VX_MF8_TU, VSSUBU_VX, 0x5 }, // 11375
  { PseudoVSSUBU_VX_MF4, VSSUBU_VX, 0x6 }, // 11376
  { PseudoVSSUBU_VX_MF4_MASK, VSSUBU_VX, 0x6 }, // 11377
  { PseudoVSSUBU_VX_MF4_TU, VSSUBU_VX, 0x6 }, // 11378
  { PseudoVSSUBU_VX_MF2, VSSUBU_VX, 0x7 }, // 11379
  { PseudoVSSUBU_VX_MF2_MASK, VSSUBU_VX, 0x7 }, // 11380
  { PseudoVSSUBU_VX_MF2_TU, VSSUBU_VX, 0x7 }, // 11381
  { PseudoVSSUB_VV_M1, VSSUB_VV, 0x0 }, // 11382
  { PseudoVSSUB_VV_M1_MASK, VSSUB_VV, 0x0 }, // 11383
  { PseudoVSSUB_VV_M1_TU, VSSUB_VV, 0x0 }, // 11384
  { PseudoVSSUB_VV_M2, VSSUB_VV, 0x1 }, // 11385
  { PseudoVSSUB_VV_M2_MASK, VSSUB_VV, 0x1 }, // 11386
  { PseudoVSSUB_VV_M2_TU, VSSUB_VV, 0x1 }, // 11387
  { PseudoVSSUB_VV_M4, VSSUB_VV, 0x2 }, // 11388
  { PseudoVSSUB_VV_M4_MASK, VSSUB_VV, 0x2 }, // 11389
  { PseudoVSSUB_VV_M4_TU, VSSUB_VV, 0x2 }, // 11390
  { PseudoVSSUB_VV_M8, VSSUB_VV, 0x3 }, // 11391
  { PseudoVSSUB_VV_M8_MASK, VSSUB_VV, 0x3 }, // 11392
  { PseudoVSSUB_VV_M8_TU, VSSUB_VV, 0x3 }, // 11393
  { PseudoVSSUB_VV_MF8, VSSUB_VV, 0x5 }, // 11394
  { PseudoVSSUB_VV_MF8_MASK, VSSUB_VV, 0x5 }, // 11395
  { PseudoVSSUB_VV_MF8_TU, VSSUB_VV, 0x5 }, // 11396
  { PseudoVSSUB_VV_MF4, VSSUB_VV, 0x6 }, // 11397
  { PseudoVSSUB_VV_MF4_MASK, VSSUB_VV, 0x6 }, // 11398
  { PseudoVSSUB_VV_MF4_TU, VSSUB_VV, 0x6 }, // 11399
  { PseudoVSSUB_VV_MF2, VSSUB_VV, 0x7 }, // 11400
  { PseudoVSSUB_VV_MF2_MASK, VSSUB_VV, 0x7 }, // 11401
  { PseudoVSSUB_VV_MF2_TU, VSSUB_VV, 0x7 }, // 11402
  { PseudoVSSUB_VX_M1, VSSUB_VX, 0x0 }, // 11403
  { PseudoVSSUB_VX_M1_MASK, VSSUB_VX, 0x0 }, // 11404
  { PseudoVSSUB_VX_M1_TU, VSSUB_VX, 0x0 }, // 11405
  { PseudoVSSUB_VX_M2, VSSUB_VX, 0x1 }, // 11406
  { PseudoVSSUB_VX_M2_MASK, VSSUB_VX, 0x1 }, // 11407
  { PseudoVSSUB_VX_M2_TU, VSSUB_VX, 0x1 }, // 11408
  { PseudoVSSUB_VX_M4, VSSUB_VX, 0x2 }, // 11409
  { PseudoVSSUB_VX_M4_MASK, VSSUB_VX, 0x2 }, // 11410
  { PseudoVSSUB_VX_M4_TU, VSSUB_VX, 0x2 }, // 11411
  { PseudoVSSUB_VX_M8, VSSUB_VX, 0x3 }, // 11412
  { PseudoVSSUB_VX_M8_MASK, VSSUB_VX, 0x3 }, // 11413
  { PseudoVSSUB_VX_M8_TU, VSSUB_VX, 0x3 }, // 11414
  { PseudoVSSUB_VX_MF8, VSSUB_VX, 0x5 }, // 11415
  { PseudoVSSUB_VX_MF8_MASK, VSSUB_VX, 0x5 }, // 11416
  { PseudoVSSUB_VX_MF8_TU, VSSUB_VX, 0x5 }, // 11417
  { PseudoVSSUB_VX_MF4, VSSUB_VX, 0x6 }, // 11418
  { PseudoVSSUB_VX_MF4_MASK, VSSUB_VX, 0x6 }, // 11419
  { PseudoVSSUB_VX_MF4_TU, VSSUB_VX, 0x6 }, // 11420
  { PseudoVSSUB_VX_MF2, VSSUB_VX, 0x7 }, // 11421
  { PseudoVSSUB_VX_MF2_MASK, VSSUB_VX, 0x7 }, // 11422
  { PseudoVSSUB_VX_MF2_TU, VSSUB_VX, 0x7 }, // 11423
  { PseudoVSUB_VV_M1, VSUB_VV, 0x0 }, // 11424
  { PseudoVSUB_VV_M1_MASK, VSUB_VV, 0x0 }, // 11425
  { PseudoVSUB_VV_M1_TU, VSUB_VV, 0x0 }, // 11426
  { PseudoVSUB_VV_M2, VSUB_VV, 0x1 }, // 11427
  { PseudoVSUB_VV_M2_MASK, VSUB_VV, 0x1 }, // 11428
  { PseudoVSUB_VV_M2_TU, VSUB_VV, 0x1 }, // 11429
  { PseudoVSUB_VV_M4, VSUB_VV, 0x2 }, // 11430
  { PseudoVSUB_VV_M4_MASK, VSUB_VV, 0x2 }, // 11431
  { PseudoVSUB_VV_M4_TU, VSUB_VV, 0x2 }, // 11432
  { PseudoVSUB_VV_M8, VSUB_VV, 0x3 }, // 11433
  { PseudoVSUB_VV_M8_MASK, VSUB_VV, 0x3 }, // 11434
  { PseudoVSUB_VV_M8_TU, VSUB_VV, 0x3 }, // 11435
  { PseudoVSUB_VV_MF8, VSUB_VV, 0x5 }, // 11436
  { PseudoVSUB_VV_MF8_MASK, VSUB_VV, 0x5 }, // 11437
  { PseudoVSUB_VV_MF8_TU, VSUB_VV, 0x5 }, // 11438
  { PseudoVSUB_VV_MF4, VSUB_VV, 0x6 }, // 11439
  { PseudoVSUB_VV_MF4_MASK, VSUB_VV, 0x6 }, // 11440
  { PseudoVSUB_VV_MF4_TU, VSUB_VV, 0x6 }, // 11441
  { PseudoVSUB_VV_MF2, VSUB_VV, 0x7 }, // 11442
  { PseudoVSUB_VV_MF2_MASK, VSUB_VV, 0x7 }, // 11443
  { PseudoVSUB_VV_MF2_TU, VSUB_VV, 0x7 }, // 11444
  { PseudoVSUB_VX_M1, VSUB_VX, 0x0 }, // 11445
  { PseudoVSUB_VX_M1_MASK, VSUB_VX, 0x0 }, // 11446
  { PseudoVSUB_VX_M1_TU, VSUB_VX, 0x0 }, // 11447
  { PseudoVSUB_VX_M2, VSUB_VX, 0x1 }, // 11448
  { PseudoVSUB_VX_M2_MASK, VSUB_VX, 0x1 }, // 11449
  { PseudoVSUB_VX_M2_TU, VSUB_VX, 0x1 }, // 11450
  { PseudoVSUB_VX_M4, VSUB_VX, 0x2 }, // 11451
  { PseudoVSUB_VX_M4_MASK, VSUB_VX, 0x2 }, // 11452
  { PseudoVSUB_VX_M4_TU, VSUB_VX, 0x2 }, // 11453
  { PseudoVSUB_VX_M8, VSUB_VX, 0x3 }, // 11454
  { PseudoVSUB_VX_M8_MASK, VSUB_VX, 0x3 }, // 11455
  { PseudoVSUB_VX_M8_TU, VSUB_VX, 0x3 }, // 11456
  { PseudoVSUB_VX_MF8, VSUB_VX, 0x5 }, // 11457
  { PseudoVSUB_VX_MF8_MASK, VSUB_VX, 0x5 }, // 11458
  { PseudoVSUB_VX_MF8_TU, VSUB_VX, 0x5 }, // 11459
  { PseudoVSUB_VX_MF4, VSUB_VX, 0x6 }, // 11460
  { PseudoVSUB_VX_MF4_MASK, VSUB_VX, 0x6 }, // 11461
  { PseudoVSUB_VX_MF4_TU, VSUB_VX, 0x6 }, // 11462
  { PseudoVSUB_VX_MF2, VSUB_VX, 0x7 }, // 11463
  { PseudoVSUB_VX_MF2_MASK, VSUB_VX, 0x7 }, // 11464
  { PseudoVSUB_VX_MF2_TU, VSUB_VX, 0x7 }, // 11465
  { PseudoVSUXEI16_V_M1_M1, VSUXEI16_V, 0x0 }, // 11466
  { PseudoVSUXEI16_V_M1_M1_MASK, VSUXEI16_V, 0x0 }, // 11467
  { PseudoVSUXEI16_V_M2_M1, VSUXEI16_V, 0x0 }, // 11468
  { PseudoVSUXEI16_V_M2_M1_MASK, VSUXEI16_V, 0x0 }, // 11469
  { PseudoVSUXEI16_V_MF2_M1, VSUXEI16_V, 0x0 }, // 11470
  { PseudoVSUXEI16_V_MF2_M1_MASK, VSUXEI16_V, 0x0 }, // 11471
  { PseudoVSUXEI16_V_MF4_M1, VSUXEI16_V, 0x0 }, // 11472
  { PseudoVSUXEI16_V_MF4_M1_MASK, VSUXEI16_V, 0x0 }, // 11473
  { PseudoVSUXEI16_V_M1_M2, VSUXEI16_V, 0x1 }, // 11474
  { PseudoVSUXEI16_V_M1_M2_MASK, VSUXEI16_V, 0x1 }, // 11475
  { PseudoVSUXEI16_V_M2_M2, VSUXEI16_V, 0x1 }, // 11476
  { PseudoVSUXEI16_V_M2_M2_MASK, VSUXEI16_V, 0x1 }, // 11477
  { PseudoVSUXEI16_V_M4_M2, VSUXEI16_V, 0x1 }, // 11478
  { PseudoVSUXEI16_V_M4_M2_MASK, VSUXEI16_V, 0x1 }, // 11479
  { PseudoVSUXEI16_V_MF2_M2, VSUXEI16_V, 0x1 }, // 11480
  { PseudoVSUXEI16_V_MF2_M2_MASK, VSUXEI16_V, 0x1 }, // 11481
  { PseudoVSUXEI16_V_M1_M4, VSUXEI16_V, 0x2 }, // 11482
  { PseudoVSUXEI16_V_M1_M4_MASK, VSUXEI16_V, 0x2 }, // 11483
  { PseudoVSUXEI16_V_M2_M4, VSUXEI16_V, 0x2 }, // 11484
  { PseudoVSUXEI16_V_M2_M4_MASK, VSUXEI16_V, 0x2 }, // 11485
  { PseudoVSUXEI16_V_M4_M4, VSUXEI16_V, 0x2 }, // 11486
  { PseudoVSUXEI16_V_M4_M4_MASK, VSUXEI16_V, 0x2 }, // 11487
  { PseudoVSUXEI16_V_M8_M4, VSUXEI16_V, 0x2 }, // 11488
  { PseudoVSUXEI16_V_M8_M4_MASK, VSUXEI16_V, 0x2 }, // 11489
  { PseudoVSUXEI16_V_M2_M8, VSUXEI16_V, 0x3 }, // 11490
  { PseudoVSUXEI16_V_M2_M8_MASK, VSUXEI16_V, 0x3 }, // 11491
  { PseudoVSUXEI16_V_M4_M8, VSUXEI16_V, 0x3 }, // 11492
  { PseudoVSUXEI16_V_M4_M8_MASK, VSUXEI16_V, 0x3 }, // 11493
  { PseudoVSUXEI16_V_M8_M8, VSUXEI16_V, 0x3 }, // 11494
  { PseudoVSUXEI16_V_M8_M8_MASK, VSUXEI16_V, 0x3 }, // 11495
  { PseudoVSUXEI16_V_MF4_MF8, VSUXEI16_V, 0x5 }, // 11496
  { PseudoVSUXEI16_V_MF4_MF8_MASK, VSUXEI16_V, 0x5 }, // 11497
  { PseudoVSUXEI16_V_MF2_MF4, VSUXEI16_V, 0x6 }, // 11498
  { PseudoVSUXEI16_V_MF2_MF4_MASK, VSUXEI16_V, 0x6 }, // 11499
  { PseudoVSUXEI16_V_MF4_MF4, VSUXEI16_V, 0x6 }, // 11500
  { PseudoVSUXEI16_V_MF4_MF4_MASK, VSUXEI16_V, 0x6 }, // 11501
  { PseudoVSUXEI16_V_M1_MF2, VSUXEI16_V, 0x7 }, // 11502
  { PseudoVSUXEI16_V_M1_MF2_MASK, VSUXEI16_V, 0x7 }, // 11503
  { PseudoVSUXEI16_V_MF2_MF2, VSUXEI16_V, 0x7 }, // 11504
  { PseudoVSUXEI16_V_MF2_MF2_MASK, VSUXEI16_V, 0x7 }, // 11505
  { PseudoVSUXEI16_V_MF4_MF2, VSUXEI16_V, 0x7 }, // 11506
  { PseudoVSUXEI16_V_MF4_MF2_MASK, VSUXEI16_V, 0x7 }, // 11507
  { PseudoVSUXEI32_V_M1_M1, VSUXEI32_V, 0x0 }, // 11508
  { PseudoVSUXEI32_V_M1_M1_MASK, VSUXEI32_V, 0x0 }, // 11509
  { PseudoVSUXEI32_V_M2_M1, VSUXEI32_V, 0x0 }, // 11510
  { PseudoVSUXEI32_V_M2_M1_MASK, VSUXEI32_V, 0x0 }, // 11511
  { PseudoVSUXEI32_V_M4_M1, VSUXEI32_V, 0x0 }, // 11512
  { PseudoVSUXEI32_V_M4_M1_MASK, VSUXEI32_V, 0x0 }, // 11513
  { PseudoVSUXEI32_V_MF2_M1, VSUXEI32_V, 0x0 }, // 11514
  { PseudoVSUXEI32_V_MF2_M1_MASK, VSUXEI32_V, 0x0 }, // 11515
  { PseudoVSUXEI32_V_M1_M2, VSUXEI32_V, 0x1 }, // 11516
  { PseudoVSUXEI32_V_M1_M2_MASK, VSUXEI32_V, 0x1 }, // 11517
  { PseudoVSUXEI32_V_M2_M2, VSUXEI32_V, 0x1 }, // 11518
  { PseudoVSUXEI32_V_M2_M2_MASK, VSUXEI32_V, 0x1 }, // 11519
  { PseudoVSUXEI32_V_M4_M2, VSUXEI32_V, 0x1 }, // 11520
  { PseudoVSUXEI32_V_M4_M2_MASK, VSUXEI32_V, 0x1 }, // 11521
  { PseudoVSUXEI32_V_M8_M2, VSUXEI32_V, 0x1 }, // 11522
  { PseudoVSUXEI32_V_M8_M2_MASK, VSUXEI32_V, 0x1 }, // 11523
  { PseudoVSUXEI32_V_M2_M4, VSUXEI32_V, 0x2 }, // 11524
  { PseudoVSUXEI32_V_M2_M4_MASK, VSUXEI32_V, 0x2 }, // 11525
  { PseudoVSUXEI32_V_M4_M4, VSUXEI32_V, 0x2 }, // 11526
  { PseudoVSUXEI32_V_M4_M4_MASK, VSUXEI32_V, 0x2 }, // 11527
  { PseudoVSUXEI32_V_M8_M4, VSUXEI32_V, 0x2 }, // 11528
  { PseudoVSUXEI32_V_M8_M4_MASK, VSUXEI32_V, 0x2 }, // 11529
  { PseudoVSUXEI32_V_M4_M8, VSUXEI32_V, 0x3 }, // 11530
  { PseudoVSUXEI32_V_M4_M8_MASK, VSUXEI32_V, 0x3 }, // 11531
  { PseudoVSUXEI32_V_M8_M8, VSUXEI32_V, 0x3 }, // 11532
  { PseudoVSUXEI32_V_M8_M8_MASK, VSUXEI32_V, 0x3 }, // 11533
  { PseudoVSUXEI32_V_MF2_MF8, VSUXEI32_V, 0x5 }, // 11534
  { PseudoVSUXEI32_V_MF2_MF8_MASK, VSUXEI32_V, 0x5 }, // 11535
  { PseudoVSUXEI32_V_M1_MF4, VSUXEI32_V, 0x6 }, // 11536
  { PseudoVSUXEI32_V_M1_MF4_MASK, VSUXEI32_V, 0x6 }, // 11537
  { PseudoVSUXEI32_V_MF2_MF4, VSUXEI32_V, 0x6 }, // 11538
  { PseudoVSUXEI32_V_MF2_MF4_MASK, VSUXEI32_V, 0x6 }, // 11539
  { PseudoVSUXEI32_V_M1_MF2, VSUXEI32_V, 0x7 }, // 11540
  { PseudoVSUXEI32_V_M1_MF2_MASK, VSUXEI32_V, 0x7 }, // 11541
  { PseudoVSUXEI32_V_M2_MF2, VSUXEI32_V, 0x7 }, // 11542
  { PseudoVSUXEI32_V_M2_MF2_MASK, VSUXEI32_V, 0x7 }, // 11543
  { PseudoVSUXEI32_V_MF2_MF2, VSUXEI32_V, 0x7 }, // 11544
  { PseudoVSUXEI32_V_MF2_MF2_MASK, VSUXEI32_V, 0x7 }, // 11545
  { PseudoVSUXEI64_V_M1_M1, VSUXEI64_V, 0x0 }, // 11546
  { PseudoVSUXEI64_V_M1_M1_MASK, VSUXEI64_V, 0x0 }, // 11547
  { PseudoVSUXEI64_V_M2_M1, VSUXEI64_V, 0x0 }, // 11548
  { PseudoVSUXEI64_V_M2_M1_MASK, VSUXEI64_V, 0x0 }, // 11549
  { PseudoVSUXEI64_V_M4_M1, VSUXEI64_V, 0x0 }, // 11550
  { PseudoVSUXEI64_V_M4_M1_MASK, VSUXEI64_V, 0x0 }, // 11551
  { PseudoVSUXEI64_V_M8_M1, VSUXEI64_V, 0x0 }, // 11552
  { PseudoVSUXEI64_V_M8_M1_MASK, VSUXEI64_V, 0x0 }, // 11553
  { PseudoVSUXEI64_V_M2_M2, VSUXEI64_V, 0x1 }, // 11554
  { PseudoVSUXEI64_V_M2_M2_MASK, VSUXEI64_V, 0x1 }, // 11555
  { PseudoVSUXEI64_V_M4_M2, VSUXEI64_V, 0x1 }, // 11556
  { PseudoVSUXEI64_V_M4_M2_MASK, VSUXEI64_V, 0x1 }, // 11557
  { PseudoVSUXEI64_V_M8_M2, VSUXEI64_V, 0x1 }, // 11558
  { PseudoVSUXEI64_V_M8_M2_MASK, VSUXEI64_V, 0x1 }, // 11559
  { PseudoVSUXEI64_V_M4_M4, VSUXEI64_V, 0x2 }, // 11560
  { PseudoVSUXEI64_V_M4_M4_MASK, VSUXEI64_V, 0x2 }, // 11561
  { PseudoVSUXEI64_V_M8_M4, VSUXEI64_V, 0x2 }, // 11562
  { PseudoVSUXEI64_V_M8_M4_MASK, VSUXEI64_V, 0x2 }, // 11563
  { PseudoVSUXEI64_V_M8_M8, VSUXEI64_V, 0x3 }, // 11564
  { PseudoVSUXEI64_V_M8_M8_MASK, VSUXEI64_V, 0x3 }, // 11565
  { PseudoVSUXEI64_V_M1_MF8, VSUXEI64_V, 0x5 }, // 11566
  { PseudoVSUXEI64_V_M1_MF8_MASK, VSUXEI64_V, 0x5 }, // 11567
  { PseudoVSUXEI64_V_M1_MF4, VSUXEI64_V, 0x6 }, // 11568
  { PseudoVSUXEI64_V_M1_MF4_MASK, VSUXEI64_V, 0x6 }, // 11569
  { PseudoVSUXEI64_V_M2_MF4, VSUXEI64_V, 0x6 }, // 11570
  { PseudoVSUXEI64_V_M2_MF4_MASK, VSUXEI64_V, 0x6 }, // 11571
  { PseudoVSUXEI64_V_M1_MF2, VSUXEI64_V, 0x7 }, // 11572
  { PseudoVSUXEI64_V_M1_MF2_MASK, VSUXEI64_V, 0x7 }, // 11573
  { PseudoVSUXEI64_V_M2_MF2, VSUXEI64_V, 0x7 }, // 11574
  { PseudoVSUXEI64_V_M2_MF2_MASK, VSUXEI64_V, 0x7 }, // 11575
  { PseudoVSUXEI64_V_M4_MF2, VSUXEI64_V, 0x7 }, // 11576
  { PseudoVSUXEI64_V_M4_MF2_MASK, VSUXEI64_V, 0x7 }, // 11577
  { PseudoVSUXEI8_V_M1_M1, VSUXEI8_V, 0x0 }, // 11578
  { PseudoVSUXEI8_V_M1_M1_MASK, VSUXEI8_V, 0x0 }, // 11579
  { PseudoVSUXEI8_V_MF2_M1, VSUXEI8_V, 0x0 }, // 11580
  { PseudoVSUXEI8_V_MF2_M1_MASK, VSUXEI8_V, 0x0 }, // 11581
  { PseudoVSUXEI8_V_MF4_M1, VSUXEI8_V, 0x0 }, // 11582
  { PseudoVSUXEI8_V_MF4_M1_MASK, VSUXEI8_V, 0x0 }, // 11583
  { PseudoVSUXEI8_V_MF8_M1, VSUXEI8_V, 0x0 }, // 11584
  { PseudoVSUXEI8_V_MF8_M1_MASK, VSUXEI8_V, 0x0 }, // 11585
  { PseudoVSUXEI8_V_M1_M2, VSUXEI8_V, 0x1 }, // 11586
  { PseudoVSUXEI8_V_M1_M2_MASK, VSUXEI8_V, 0x1 }, // 11587
  { PseudoVSUXEI8_V_M2_M2, VSUXEI8_V, 0x1 }, // 11588
  { PseudoVSUXEI8_V_M2_M2_MASK, VSUXEI8_V, 0x1 }, // 11589
  { PseudoVSUXEI8_V_MF2_M2, VSUXEI8_V, 0x1 }, // 11590
  { PseudoVSUXEI8_V_MF2_M2_MASK, VSUXEI8_V, 0x1 }, // 11591
  { PseudoVSUXEI8_V_MF4_M2, VSUXEI8_V, 0x1 }, // 11592
  { PseudoVSUXEI8_V_MF4_M2_MASK, VSUXEI8_V, 0x1 }, // 11593
  { PseudoVSUXEI8_V_M1_M4, VSUXEI8_V, 0x2 }, // 11594
  { PseudoVSUXEI8_V_M1_M4_MASK, VSUXEI8_V, 0x2 }, // 11595
  { PseudoVSUXEI8_V_M2_M4, VSUXEI8_V, 0x2 }, // 11596
  { PseudoVSUXEI8_V_M2_M4_MASK, VSUXEI8_V, 0x2 }, // 11597
  { PseudoVSUXEI8_V_M4_M4, VSUXEI8_V, 0x2 }, // 11598
  { PseudoVSUXEI8_V_M4_M4_MASK, VSUXEI8_V, 0x2 }, // 11599
  { PseudoVSUXEI8_V_MF2_M4, VSUXEI8_V, 0x2 }, // 11600
  { PseudoVSUXEI8_V_MF2_M4_MASK, VSUXEI8_V, 0x2 }, // 11601
  { PseudoVSUXEI8_V_M1_M8, VSUXEI8_V, 0x3 }, // 11602
  { PseudoVSUXEI8_V_M1_M8_MASK, VSUXEI8_V, 0x3 }, // 11603
  { PseudoVSUXEI8_V_M2_M8, VSUXEI8_V, 0x3 }, // 11604
  { PseudoVSUXEI8_V_M2_M8_MASK, VSUXEI8_V, 0x3 }, // 11605
  { PseudoVSUXEI8_V_M4_M8, VSUXEI8_V, 0x3 }, // 11606
  { PseudoVSUXEI8_V_M4_M8_MASK, VSUXEI8_V, 0x3 }, // 11607
  { PseudoVSUXEI8_V_M8_M8, VSUXEI8_V, 0x3 }, // 11608
  { PseudoVSUXEI8_V_M8_M8_MASK, VSUXEI8_V, 0x3 }, // 11609
  { PseudoVSUXEI8_V_MF8_MF8, VSUXEI8_V, 0x5 }, // 11610
  { PseudoVSUXEI8_V_MF8_MF8_MASK, VSUXEI8_V, 0x5 }, // 11611
  { PseudoVSUXEI8_V_MF4_MF4, VSUXEI8_V, 0x6 }, // 11612
  { PseudoVSUXEI8_V_MF4_MF4_MASK, VSUXEI8_V, 0x6 }, // 11613
  { PseudoVSUXEI8_V_MF8_MF4, VSUXEI8_V, 0x6 }, // 11614
  { PseudoVSUXEI8_V_MF8_MF4_MASK, VSUXEI8_V, 0x6 }, // 11615
  { PseudoVSUXEI8_V_MF2_MF2, VSUXEI8_V, 0x7 }, // 11616
  { PseudoVSUXEI8_V_MF2_MF2_MASK, VSUXEI8_V, 0x7 }, // 11617
  { PseudoVSUXEI8_V_MF4_MF2, VSUXEI8_V, 0x7 }, // 11618
  { PseudoVSUXEI8_V_MF4_MF2_MASK, VSUXEI8_V, 0x7 }, // 11619
  { PseudoVSUXEI8_V_MF8_MF2, VSUXEI8_V, 0x7 }, // 11620
  { PseudoVSUXEI8_V_MF8_MF2_MASK, VSUXEI8_V, 0x7 }, // 11621
  { PseudoVSUXSEG2EI16_V_M1_M1, VSUXSEG2EI16_V, 0x0 }, // 11622
  { PseudoVSUXSEG2EI16_V_M1_M1_MASK, VSUXSEG2EI16_V, 0x0 }, // 11623
  { PseudoVSUXSEG2EI16_V_M2_M1, VSUXSEG2EI16_V, 0x0 }, // 11624
  { PseudoVSUXSEG2EI16_V_M2_M1_MASK, VSUXSEG2EI16_V, 0x0 }, // 11625
  { PseudoVSUXSEG2EI16_V_MF2_M1, VSUXSEG2EI16_V, 0x0 }, // 11626
  { PseudoVSUXSEG2EI16_V_MF2_M1_MASK, VSUXSEG2EI16_V, 0x0 }, // 11627
  { PseudoVSUXSEG2EI16_V_MF4_M1, VSUXSEG2EI16_V, 0x0 }, // 11628
  { PseudoVSUXSEG2EI16_V_MF4_M1_MASK, VSUXSEG2EI16_V, 0x0 }, // 11629
  { PseudoVSUXSEG2EI16_V_M1_M2, VSUXSEG2EI16_V, 0x1 }, // 11630
  { PseudoVSUXSEG2EI16_V_M1_M2_MASK, VSUXSEG2EI16_V, 0x1 }, // 11631
  { PseudoVSUXSEG2EI16_V_M2_M2, VSUXSEG2EI16_V, 0x1 }, // 11632
  { PseudoVSUXSEG2EI16_V_M2_M2_MASK, VSUXSEG2EI16_V, 0x1 }, // 11633
  { PseudoVSUXSEG2EI16_V_M4_M2, VSUXSEG2EI16_V, 0x1 }, // 11634
  { PseudoVSUXSEG2EI16_V_M4_M2_MASK, VSUXSEG2EI16_V, 0x1 }, // 11635
  { PseudoVSUXSEG2EI16_V_MF2_M2, VSUXSEG2EI16_V, 0x1 }, // 11636
  { PseudoVSUXSEG2EI16_V_MF2_M2_MASK, VSUXSEG2EI16_V, 0x1 }, // 11637
  { PseudoVSUXSEG2EI16_V_M1_M4, VSUXSEG2EI16_V, 0x2 }, // 11638
  { PseudoVSUXSEG2EI16_V_M1_M4_MASK, VSUXSEG2EI16_V, 0x2 }, // 11639
  { PseudoVSUXSEG2EI16_V_M2_M4, VSUXSEG2EI16_V, 0x2 }, // 11640
  { PseudoVSUXSEG2EI16_V_M2_M4_MASK, VSUXSEG2EI16_V, 0x2 }, // 11641
  { PseudoVSUXSEG2EI16_V_M4_M4, VSUXSEG2EI16_V, 0x2 }, // 11642
  { PseudoVSUXSEG2EI16_V_M4_M4_MASK, VSUXSEG2EI16_V, 0x2 }, // 11643
  { PseudoVSUXSEG2EI16_V_M8_M4, VSUXSEG2EI16_V, 0x2 }, // 11644
  { PseudoVSUXSEG2EI16_V_M8_M4_MASK, VSUXSEG2EI16_V, 0x2 }, // 11645
  { PseudoVSUXSEG2EI16_V_MF4_MF8, VSUXSEG2EI16_V, 0x5 }, // 11646
  { PseudoVSUXSEG2EI16_V_MF4_MF8_MASK, VSUXSEG2EI16_V, 0x5 }, // 11647
  { PseudoVSUXSEG2EI16_V_MF2_MF4, VSUXSEG2EI16_V, 0x6 }, // 11648
  { PseudoVSUXSEG2EI16_V_MF2_MF4_MASK, VSUXSEG2EI16_V, 0x6 }, // 11649
  { PseudoVSUXSEG2EI16_V_MF4_MF4, VSUXSEG2EI16_V, 0x6 }, // 11650
  { PseudoVSUXSEG2EI16_V_MF4_MF4_MASK, VSUXSEG2EI16_V, 0x6 }, // 11651
  { PseudoVSUXSEG2EI16_V_M1_MF2, VSUXSEG2EI16_V, 0x7 }, // 11652
  { PseudoVSUXSEG2EI16_V_M1_MF2_MASK, VSUXSEG2EI16_V, 0x7 }, // 11653
  { PseudoVSUXSEG2EI16_V_MF2_MF2, VSUXSEG2EI16_V, 0x7 }, // 11654
  { PseudoVSUXSEG2EI16_V_MF2_MF2_MASK, VSUXSEG2EI16_V, 0x7 }, // 11655
  { PseudoVSUXSEG2EI16_V_MF4_MF2, VSUXSEG2EI16_V, 0x7 }, // 11656
  { PseudoVSUXSEG2EI16_V_MF4_MF2_MASK, VSUXSEG2EI16_V, 0x7 }, // 11657
  { PseudoVSUXSEG2EI32_V_M1_M1, VSUXSEG2EI32_V, 0x0 }, // 11658
  { PseudoVSUXSEG2EI32_V_M1_M1_MASK, VSUXSEG2EI32_V, 0x0 }, // 11659
  { PseudoVSUXSEG2EI32_V_M2_M1, VSUXSEG2EI32_V, 0x0 }, // 11660
  { PseudoVSUXSEG2EI32_V_M2_M1_MASK, VSUXSEG2EI32_V, 0x0 }, // 11661
  { PseudoVSUXSEG2EI32_V_M4_M1, VSUXSEG2EI32_V, 0x0 }, // 11662
  { PseudoVSUXSEG2EI32_V_M4_M1_MASK, VSUXSEG2EI32_V, 0x0 }, // 11663
  { PseudoVSUXSEG2EI32_V_MF2_M1, VSUXSEG2EI32_V, 0x0 }, // 11664
  { PseudoVSUXSEG2EI32_V_MF2_M1_MASK, VSUXSEG2EI32_V, 0x0 }, // 11665
  { PseudoVSUXSEG2EI32_V_M1_M2, VSUXSEG2EI32_V, 0x1 }, // 11666
  { PseudoVSUXSEG2EI32_V_M1_M2_MASK, VSUXSEG2EI32_V, 0x1 }, // 11667
  { PseudoVSUXSEG2EI32_V_M2_M2, VSUXSEG2EI32_V, 0x1 }, // 11668
  { PseudoVSUXSEG2EI32_V_M2_M2_MASK, VSUXSEG2EI32_V, 0x1 }, // 11669
  { PseudoVSUXSEG2EI32_V_M4_M2, VSUXSEG2EI32_V, 0x1 }, // 11670
  { PseudoVSUXSEG2EI32_V_M4_M2_MASK, VSUXSEG2EI32_V, 0x1 }, // 11671
  { PseudoVSUXSEG2EI32_V_M8_M2, VSUXSEG2EI32_V, 0x1 }, // 11672
  { PseudoVSUXSEG2EI32_V_M8_M2_MASK, VSUXSEG2EI32_V, 0x1 }, // 11673
  { PseudoVSUXSEG2EI32_V_M2_M4, VSUXSEG2EI32_V, 0x2 }, // 11674
  { PseudoVSUXSEG2EI32_V_M2_M4_MASK, VSUXSEG2EI32_V, 0x2 }, // 11675
  { PseudoVSUXSEG2EI32_V_M4_M4, VSUXSEG2EI32_V, 0x2 }, // 11676
  { PseudoVSUXSEG2EI32_V_M4_M4_MASK, VSUXSEG2EI32_V, 0x2 }, // 11677
  { PseudoVSUXSEG2EI32_V_M8_M4, VSUXSEG2EI32_V, 0x2 }, // 11678
  { PseudoVSUXSEG2EI32_V_M8_M4_MASK, VSUXSEG2EI32_V, 0x2 }, // 11679
  { PseudoVSUXSEG2EI32_V_MF2_MF8, VSUXSEG2EI32_V, 0x5 }, // 11680
  { PseudoVSUXSEG2EI32_V_MF2_MF8_MASK, VSUXSEG2EI32_V, 0x5 }, // 11681
  { PseudoVSUXSEG2EI32_V_M1_MF4, VSUXSEG2EI32_V, 0x6 }, // 11682
  { PseudoVSUXSEG2EI32_V_M1_MF4_MASK, VSUXSEG2EI32_V, 0x6 }, // 11683
  { PseudoVSUXSEG2EI32_V_MF2_MF4, VSUXSEG2EI32_V, 0x6 }, // 11684
  { PseudoVSUXSEG2EI32_V_MF2_MF4_MASK, VSUXSEG2EI32_V, 0x6 }, // 11685
  { PseudoVSUXSEG2EI32_V_M1_MF2, VSUXSEG2EI32_V, 0x7 }, // 11686
  { PseudoVSUXSEG2EI32_V_M1_MF2_MASK, VSUXSEG2EI32_V, 0x7 }, // 11687
  { PseudoVSUXSEG2EI32_V_M2_MF2, VSUXSEG2EI32_V, 0x7 }, // 11688
  { PseudoVSUXSEG2EI32_V_M2_MF2_MASK, VSUXSEG2EI32_V, 0x7 }, // 11689
  { PseudoVSUXSEG2EI32_V_MF2_MF2, VSUXSEG2EI32_V, 0x7 }, // 11690
  { PseudoVSUXSEG2EI32_V_MF2_MF2_MASK, VSUXSEG2EI32_V, 0x7 }, // 11691
  { PseudoVSUXSEG2EI64_V_M1_M1, VSUXSEG2EI64_V, 0x0 }, // 11692
  { PseudoVSUXSEG2EI64_V_M1_M1_MASK, VSUXSEG2EI64_V, 0x0 }, // 11693
  { PseudoVSUXSEG2EI64_V_M2_M1, VSUXSEG2EI64_V, 0x0 }, // 11694
  { PseudoVSUXSEG2EI64_V_M2_M1_MASK, VSUXSEG2EI64_V, 0x0 }, // 11695
  { PseudoVSUXSEG2EI64_V_M4_M1, VSUXSEG2EI64_V, 0x0 }, // 11696
  { PseudoVSUXSEG2EI64_V_M4_M1_MASK, VSUXSEG2EI64_V, 0x0 }, // 11697
  { PseudoVSUXSEG2EI64_V_M8_M1, VSUXSEG2EI64_V, 0x0 }, // 11698
  { PseudoVSUXSEG2EI64_V_M8_M1_MASK, VSUXSEG2EI64_V, 0x0 }, // 11699
  { PseudoVSUXSEG2EI64_V_M2_M2, VSUXSEG2EI64_V, 0x1 }, // 11700
  { PseudoVSUXSEG2EI64_V_M2_M2_MASK, VSUXSEG2EI64_V, 0x1 }, // 11701
  { PseudoVSUXSEG2EI64_V_M4_M2, VSUXSEG2EI64_V, 0x1 }, // 11702
  { PseudoVSUXSEG2EI64_V_M4_M2_MASK, VSUXSEG2EI64_V, 0x1 }, // 11703
  { PseudoVSUXSEG2EI64_V_M8_M2, VSUXSEG2EI64_V, 0x1 }, // 11704
  { PseudoVSUXSEG2EI64_V_M8_M2_MASK, VSUXSEG2EI64_V, 0x1 }, // 11705
  { PseudoVSUXSEG2EI64_V_M4_M4, VSUXSEG2EI64_V, 0x2 }, // 11706
  { PseudoVSUXSEG2EI64_V_M4_M4_MASK, VSUXSEG2EI64_V, 0x2 }, // 11707
  { PseudoVSUXSEG2EI64_V_M8_M4, VSUXSEG2EI64_V, 0x2 }, // 11708
  { PseudoVSUXSEG2EI64_V_M8_M4_MASK, VSUXSEG2EI64_V, 0x2 }, // 11709
  { PseudoVSUXSEG2EI64_V_M1_MF8, VSUXSEG2EI64_V, 0x5 }, // 11710
  { PseudoVSUXSEG2EI64_V_M1_MF8_MASK, VSUXSEG2EI64_V, 0x5 }, // 11711
  { PseudoVSUXSEG2EI64_V_M1_MF4, VSUXSEG2EI64_V, 0x6 }, // 11712
  { PseudoVSUXSEG2EI64_V_M1_MF4_MASK, VSUXSEG2EI64_V, 0x6 }, // 11713
  { PseudoVSUXSEG2EI64_V_M2_MF4, VSUXSEG2EI64_V, 0x6 }, // 11714
  { PseudoVSUXSEG2EI64_V_M2_MF4_MASK, VSUXSEG2EI64_V, 0x6 }, // 11715
  { PseudoVSUXSEG2EI64_V_M1_MF2, VSUXSEG2EI64_V, 0x7 }, // 11716
  { PseudoVSUXSEG2EI64_V_M1_MF2_MASK, VSUXSEG2EI64_V, 0x7 }, // 11717
  { PseudoVSUXSEG2EI64_V_M2_MF2, VSUXSEG2EI64_V, 0x7 }, // 11718
  { PseudoVSUXSEG2EI64_V_M2_MF2_MASK, VSUXSEG2EI64_V, 0x7 }, // 11719
  { PseudoVSUXSEG2EI64_V_M4_MF2, VSUXSEG2EI64_V, 0x7 }, // 11720
  { PseudoVSUXSEG2EI64_V_M4_MF2_MASK, VSUXSEG2EI64_V, 0x7 }, // 11721
  { PseudoVSUXSEG2EI8_V_M1_M1, VSUXSEG2EI8_V, 0x0 }, // 11722
  { PseudoVSUXSEG2EI8_V_M1_M1_MASK, VSUXSEG2EI8_V, 0x0 }, // 11723
  { PseudoVSUXSEG2EI8_V_MF2_M1, VSUXSEG2EI8_V, 0x0 }, // 11724
  { PseudoVSUXSEG2EI8_V_MF2_M1_MASK, VSUXSEG2EI8_V, 0x0 }, // 11725
  { PseudoVSUXSEG2EI8_V_MF4_M1, VSUXSEG2EI8_V, 0x0 }, // 11726
  { PseudoVSUXSEG2EI8_V_MF4_M1_MASK, VSUXSEG2EI8_V, 0x0 }, // 11727
  { PseudoVSUXSEG2EI8_V_MF8_M1, VSUXSEG2EI8_V, 0x0 }, // 11728
  { PseudoVSUXSEG2EI8_V_MF8_M1_MASK, VSUXSEG2EI8_V, 0x0 }, // 11729
  { PseudoVSUXSEG2EI8_V_M1_M2, VSUXSEG2EI8_V, 0x1 }, // 11730
  { PseudoVSUXSEG2EI8_V_M1_M2_MASK, VSUXSEG2EI8_V, 0x1 }, // 11731
  { PseudoVSUXSEG2EI8_V_M2_M2, VSUXSEG2EI8_V, 0x1 }, // 11732
  { PseudoVSUXSEG2EI8_V_M2_M2_MASK, VSUXSEG2EI8_V, 0x1 }, // 11733
  { PseudoVSUXSEG2EI8_V_MF2_M2, VSUXSEG2EI8_V, 0x1 }, // 11734
  { PseudoVSUXSEG2EI8_V_MF2_M2_MASK, VSUXSEG2EI8_V, 0x1 }, // 11735
  { PseudoVSUXSEG2EI8_V_MF4_M2, VSUXSEG2EI8_V, 0x1 }, // 11736
  { PseudoVSUXSEG2EI8_V_MF4_M2_MASK, VSUXSEG2EI8_V, 0x1 }, // 11737
  { PseudoVSUXSEG2EI8_V_M1_M4, VSUXSEG2EI8_V, 0x2 }, // 11738
  { PseudoVSUXSEG2EI8_V_M1_M4_MASK, VSUXSEG2EI8_V, 0x2 }, // 11739
  { PseudoVSUXSEG2EI8_V_M2_M4, VSUXSEG2EI8_V, 0x2 }, // 11740
  { PseudoVSUXSEG2EI8_V_M2_M4_MASK, VSUXSEG2EI8_V, 0x2 }, // 11741
  { PseudoVSUXSEG2EI8_V_M4_M4, VSUXSEG2EI8_V, 0x2 }, // 11742
  { PseudoVSUXSEG2EI8_V_M4_M4_MASK, VSUXSEG2EI8_V, 0x2 }, // 11743
  { PseudoVSUXSEG2EI8_V_MF2_M4, VSUXSEG2EI8_V, 0x2 }, // 11744
  { PseudoVSUXSEG2EI8_V_MF2_M4_MASK, VSUXSEG2EI8_V, 0x2 }, // 11745
  { PseudoVSUXSEG2EI8_V_MF8_MF8, VSUXSEG2EI8_V, 0x5 }, // 11746
  { PseudoVSUXSEG2EI8_V_MF8_MF8_MASK, VSUXSEG2EI8_V, 0x5 }, // 11747
  { PseudoVSUXSEG2EI8_V_MF4_MF4, VSUXSEG2EI8_V, 0x6 }, // 11748
  { PseudoVSUXSEG2EI8_V_MF4_MF4_MASK, VSUXSEG2EI8_V, 0x6 }, // 11749
  { PseudoVSUXSEG2EI8_V_MF8_MF4, VSUXSEG2EI8_V, 0x6 }, // 11750
  { PseudoVSUXSEG2EI8_V_MF8_MF4_MASK, VSUXSEG2EI8_V, 0x6 }, // 11751
  { PseudoVSUXSEG2EI8_V_MF2_MF2, VSUXSEG2EI8_V, 0x7 }, // 11752
  { PseudoVSUXSEG2EI8_V_MF2_MF2_MASK, VSUXSEG2EI8_V, 0x7 }, // 11753
  { PseudoVSUXSEG2EI8_V_MF4_MF2, VSUXSEG2EI8_V, 0x7 }, // 11754
  { PseudoVSUXSEG2EI8_V_MF4_MF2_MASK, VSUXSEG2EI8_V, 0x7 }, // 11755
  { PseudoVSUXSEG2EI8_V_MF8_MF2, VSUXSEG2EI8_V, 0x7 }, // 11756
  { PseudoVSUXSEG2EI8_V_MF8_MF2_MASK, VSUXSEG2EI8_V, 0x7 }, // 11757
  { PseudoVSUXSEG3EI16_V_M1_M1, VSUXSEG3EI16_V, 0x0 }, // 11758
  { PseudoVSUXSEG3EI16_V_M1_M1_MASK, VSUXSEG3EI16_V, 0x0 }, // 11759
  { PseudoVSUXSEG3EI16_V_M2_M1, VSUXSEG3EI16_V, 0x0 }, // 11760
  { PseudoVSUXSEG3EI16_V_M2_M1_MASK, VSUXSEG3EI16_V, 0x0 }, // 11761
  { PseudoVSUXSEG3EI16_V_MF2_M1, VSUXSEG3EI16_V, 0x0 }, // 11762
  { PseudoVSUXSEG3EI16_V_MF2_M1_MASK, VSUXSEG3EI16_V, 0x0 }, // 11763
  { PseudoVSUXSEG3EI16_V_MF4_M1, VSUXSEG3EI16_V, 0x0 }, // 11764
  { PseudoVSUXSEG3EI16_V_MF4_M1_MASK, VSUXSEG3EI16_V, 0x0 }, // 11765
  { PseudoVSUXSEG3EI16_V_M1_M2, VSUXSEG3EI16_V, 0x1 }, // 11766
  { PseudoVSUXSEG3EI16_V_M1_M2_MASK, VSUXSEG3EI16_V, 0x1 }, // 11767
  { PseudoVSUXSEG3EI16_V_M2_M2, VSUXSEG3EI16_V, 0x1 }, // 11768
  { PseudoVSUXSEG3EI16_V_M2_M2_MASK, VSUXSEG3EI16_V, 0x1 }, // 11769
  { PseudoVSUXSEG3EI16_V_M4_M2, VSUXSEG3EI16_V, 0x1 }, // 11770
  { PseudoVSUXSEG3EI16_V_M4_M2_MASK, VSUXSEG3EI16_V, 0x1 }, // 11771
  { PseudoVSUXSEG3EI16_V_MF2_M2, VSUXSEG3EI16_V, 0x1 }, // 11772
  { PseudoVSUXSEG3EI16_V_MF2_M2_MASK, VSUXSEG3EI16_V, 0x1 }, // 11773
  { PseudoVSUXSEG3EI16_V_MF4_MF8, VSUXSEG3EI16_V, 0x5 }, // 11774
  { PseudoVSUXSEG3EI16_V_MF4_MF8_MASK, VSUXSEG3EI16_V, 0x5 }, // 11775
  { PseudoVSUXSEG3EI16_V_MF2_MF4, VSUXSEG3EI16_V, 0x6 }, // 11776
  { PseudoVSUXSEG3EI16_V_MF2_MF4_MASK, VSUXSEG3EI16_V, 0x6 }, // 11777
  { PseudoVSUXSEG3EI16_V_MF4_MF4, VSUXSEG3EI16_V, 0x6 }, // 11778
  { PseudoVSUXSEG3EI16_V_MF4_MF4_MASK, VSUXSEG3EI16_V, 0x6 }, // 11779
  { PseudoVSUXSEG3EI16_V_M1_MF2, VSUXSEG3EI16_V, 0x7 }, // 11780
  { PseudoVSUXSEG3EI16_V_M1_MF2_MASK, VSUXSEG3EI16_V, 0x7 }, // 11781
  { PseudoVSUXSEG3EI16_V_MF2_MF2, VSUXSEG3EI16_V, 0x7 }, // 11782
  { PseudoVSUXSEG3EI16_V_MF2_MF2_MASK, VSUXSEG3EI16_V, 0x7 }, // 11783
  { PseudoVSUXSEG3EI16_V_MF4_MF2, VSUXSEG3EI16_V, 0x7 }, // 11784
  { PseudoVSUXSEG3EI16_V_MF4_MF2_MASK, VSUXSEG3EI16_V, 0x7 }, // 11785
  { PseudoVSUXSEG3EI32_V_M1_M1, VSUXSEG3EI32_V, 0x0 }, // 11786
  { PseudoVSUXSEG3EI32_V_M1_M1_MASK, VSUXSEG3EI32_V, 0x0 }, // 11787
  { PseudoVSUXSEG3EI32_V_M2_M1, VSUXSEG3EI32_V, 0x0 }, // 11788
  { PseudoVSUXSEG3EI32_V_M2_M1_MASK, VSUXSEG3EI32_V, 0x0 }, // 11789
  { PseudoVSUXSEG3EI32_V_M4_M1, VSUXSEG3EI32_V, 0x0 }, // 11790
  { PseudoVSUXSEG3EI32_V_M4_M1_MASK, VSUXSEG3EI32_V, 0x0 }, // 11791
  { PseudoVSUXSEG3EI32_V_MF2_M1, VSUXSEG3EI32_V, 0x0 }, // 11792
  { PseudoVSUXSEG3EI32_V_MF2_M1_MASK, VSUXSEG3EI32_V, 0x0 }, // 11793
  { PseudoVSUXSEG3EI32_V_M1_M2, VSUXSEG3EI32_V, 0x1 }, // 11794
  { PseudoVSUXSEG3EI32_V_M1_M2_MASK, VSUXSEG3EI32_V, 0x1 }, // 11795
  { PseudoVSUXSEG3EI32_V_M2_M2, VSUXSEG3EI32_V, 0x1 }, // 11796
  { PseudoVSUXSEG3EI32_V_M2_M2_MASK, VSUXSEG3EI32_V, 0x1 }, // 11797
  { PseudoVSUXSEG3EI32_V_M4_M2, VSUXSEG3EI32_V, 0x1 }, // 11798
  { PseudoVSUXSEG3EI32_V_M4_M2_MASK, VSUXSEG3EI32_V, 0x1 }, // 11799
  { PseudoVSUXSEG3EI32_V_M8_M2, VSUXSEG3EI32_V, 0x1 }, // 11800
  { PseudoVSUXSEG3EI32_V_M8_M2_MASK, VSUXSEG3EI32_V, 0x1 }, // 11801
  { PseudoVSUXSEG3EI32_V_MF2_MF8, VSUXSEG3EI32_V, 0x5 }, // 11802
  { PseudoVSUXSEG3EI32_V_MF2_MF8_MASK, VSUXSEG3EI32_V, 0x5 }, // 11803
  { PseudoVSUXSEG3EI32_V_M1_MF4, VSUXSEG3EI32_V, 0x6 }, // 11804
  { PseudoVSUXSEG3EI32_V_M1_MF4_MASK, VSUXSEG3EI32_V, 0x6 }, // 11805
  { PseudoVSUXSEG3EI32_V_MF2_MF4, VSUXSEG3EI32_V, 0x6 }, // 11806
  { PseudoVSUXSEG3EI32_V_MF2_MF4_MASK, VSUXSEG3EI32_V, 0x6 }, // 11807
  { PseudoVSUXSEG3EI32_V_M1_MF2, VSUXSEG3EI32_V, 0x7 }, // 11808
  { PseudoVSUXSEG3EI32_V_M1_MF2_MASK, VSUXSEG3EI32_V, 0x7 }, // 11809
  { PseudoVSUXSEG3EI32_V_M2_MF2, VSUXSEG3EI32_V, 0x7 }, // 11810
  { PseudoVSUXSEG3EI32_V_M2_MF2_MASK, VSUXSEG3EI32_V, 0x7 }, // 11811
  { PseudoVSUXSEG3EI32_V_MF2_MF2, VSUXSEG3EI32_V, 0x7 }, // 11812
  { PseudoVSUXSEG3EI32_V_MF2_MF2_MASK, VSUXSEG3EI32_V, 0x7 }, // 11813
  { PseudoVSUXSEG3EI64_V_M1_M1, VSUXSEG3EI64_V, 0x0 }, // 11814
  { PseudoVSUXSEG3EI64_V_M1_M1_MASK, VSUXSEG3EI64_V, 0x0 }, // 11815
  { PseudoVSUXSEG3EI64_V_M2_M1, VSUXSEG3EI64_V, 0x0 }, // 11816
  { PseudoVSUXSEG3EI64_V_M2_M1_MASK, VSUXSEG3EI64_V, 0x0 }, // 11817
  { PseudoVSUXSEG3EI64_V_M4_M1, VSUXSEG3EI64_V, 0x0 }, // 11818
  { PseudoVSUXSEG3EI64_V_M4_M1_MASK, VSUXSEG3EI64_V, 0x0 }, // 11819
  { PseudoVSUXSEG3EI64_V_M8_M1, VSUXSEG3EI64_V, 0x0 }, // 11820
  { PseudoVSUXSEG3EI64_V_M8_M1_MASK, VSUXSEG3EI64_V, 0x0 }, // 11821
  { PseudoVSUXSEG3EI64_V_M2_M2, VSUXSEG3EI64_V, 0x1 }, // 11822
  { PseudoVSUXSEG3EI64_V_M2_M2_MASK, VSUXSEG3EI64_V, 0x1 }, // 11823
  { PseudoVSUXSEG3EI64_V_M4_M2, VSUXSEG3EI64_V, 0x1 }, // 11824
  { PseudoVSUXSEG3EI64_V_M4_M2_MASK, VSUXSEG3EI64_V, 0x1 }, // 11825
  { PseudoVSUXSEG3EI64_V_M8_M2, VSUXSEG3EI64_V, 0x1 }, // 11826
  { PseudoVSUXSEG3EI64_V_M8_M2_MASK, VSUXSEG3EI64_V, 0x1 }, // 11827
  { PseudoVSUXSEG3EI64_V_M1_MF8, VSUXSEG3EI64_V, 0x5 }, // 11828
  { PseudoVSUXSEG3EI64_V_M1_MF8_MASK, VSUXSEG3EI64_V, 0x5 }, // 11829
  { PseudoVSUXSEG3EI64_V_M1_MF4, VSUXSEG3EI64_V, 0x6 }, // 11830
  { PseudoVSUXSEG3EI64_V_M1_MF4_MASK, VSUXSEG3EI64_V, 0x6 }, // 11831
  { PseudoVSUXSEG3EI64_V_M2_MF4, VSUXSEG3EI64_V, 0x6 }, // 11832
  { PseudoVSUXSEG3EI64_V_M2_MF4_MASK, VSUXSEG3EI64_V, 0x6 }, // 11833
  { PseudoVSUXSEG3EI64_V_M1_MF2, VSUXSEG3EI64_V, 0x7 }, // 11834
  { PseudoVSUXSEG3EI64_V_M1_MF2_MASK, VSUXSEG3EI64_V, 0x7 }, // 11835
  { PseudoVSUXSEG3EI64_V_M2_MF2, VSUXSEG3EI64_V, 0x7 }, // 11836
  { PseudoVSUXSEG3EI64_V_M2_MF2_MASK, VSUXSEG3EI64_V, 0x7 }, // 11837
  { PseudoVSUXSEG3EI64_V_M4_MF2, VSUXSEG3EI64_V, 0x7 }, // 11838
  { PseudoVSUXSEG3EI64_V_M4_MF2_MASK, VSUXSEG3EI64_V, 0x7 }, // 11839
  { PseudoVSUXSEG3EI8_V_M1_M1, VSUXSEG3EI8_V, 0x0 }, // 11840
  { PseudoVSUXSEG3EI8_V_M1_M1_MASK, VSUXSEG3EI8_V, 0x0 }, // 11841
  { PseudoVSUXSEG3EI8_V_MF2_M1, VSUXSEG3EI8_V, 0x0 }, // 11842
  { PseudoVSUXSEG3EI8_V_MF2_M1_MASK, VSUXSEG3EI8_V, 0x0 }, // 11843
  { PseudoVSUXSEG3EI8_V_MF4_M1, VSUXSEG3EI8_V, 0x0 }, // 11844
  { PseudoVSUXSEG3EI8_V_MF4_M1_MASK, VSUXSEG3EI8_V, 0x0 }, // 11845
  { PseudoVSUXSEG3EI8_V_MF8_M1, VSUXSEG3EI8_V, 0x0 }, // 11846
  { PseudoVSUXSEG3EI8_V_MF8_M1_MASK, VSUXSEG3EI8_V, 0x0 }, // 11847
  { PseudoVSUXSEG3EI8_V_M1_M2, VSUXSEG3EI8_V, 0x1 }, // 11848
  { PseudoVSUXSEG3EI8_V_M1_M2_MASK, VSUXSEG3EI8_V, 0x1 }, // 11849
  { PseudoVSUXSEG3EI8_V_M2_M2, VSUXSEG3EI8_V, 0x1 }, // 11850
  { PseudoVSUXSEG3EI8_V_M2_M2_MASK, VSUXSEG3EI8_V, 0x1 }, // 11851
  { PseudoVSUXSEG3EI8_V_MF2_M2, VSUXSEG3EI8_V, 0x1 }, // 11852
  { PseudoVSUXSEG3EI8_V_MF2_M2_MASK, VSUXSEG3EI8_V, 0x1 }, // 11853
  { PseudoVSUXSEG3EI8_V_MF4_M2, VSUXSEG3EI8_V, 0x1 }, // 11854
  { PseudoVSUXSEG3EI8_V_MF4_M2_MASK, VSUXSEG3EI8_V, 0x1 }, // 11855
  { PseudoVSUXSEG3EI8_V_MF8_MF8, VSUXSEG3EI8_V, 0x5 }, // 11856
  { PseudoVSUXSEG3EI8_V_MF8_MF8_MASK, VSUXSEG3EI8_V, 0x5 }, // 11857
  { PseudoVSUXSEG3EI8_V_MF4_MF4, VSUXSEG3EI8_V, 0x6 }, // 11858
  { PseudoVSUXSEG3EI8_V_MF4_MF4_MASK, VSUXSEG3EI8_V, 0x6 }, // 11859
  { PseudoVSUXSEG3EI8_V_MF8_MF4, VSUXSEG3EI8_V, 0x6 }, // 11860
  { PseudoVSUXSEG3EI8_V_MF8_MF4_MASK, VSUXSEG3EI8_V, 0x6 }, // 11861
  { PseudoVSUXSEG3EI8_V_MF2_MF2, VSUXSEG3EI8_V, 0x7 }, // 11862
  { PseudoVSUXSEG3EI8_V_MF2_MF2_MASK, VSUXSEG3EI8_V, 0x7 }, // 11863
  { PseudoVSUXSEG3EI8_V_MF4_MF2, VSUXSEG3EI8_V, 0x7 }, // 11864
  { PseudoVSUXSEG3EI8_V_MF4_MF2_MASK, VSUXSEG3EI8_V, 0x7 }, // 11865
  { PseudoVSUXSEG3EI8_V_MF8_MF2, VSUXSEG3EI8_V, 0x7 }, // 11866
  { PseudoVSUXSEG3EI8_V_MF8_MF2_MASK, VSUXSEG3EI8_V, 0x7 }, // 11867
  { PseudoVSUXSEG4EI16_V_M1_M1, VSUXSEG4EI16_V, 0x0 }, // 11868
  { PseudoVSUXSEG4EI16_V_M1_M1_MASK, VSUXSEG4EI16_V, 0x0 }, // 11869
  { PseudoVSUXSEG4EI16_V_M2_M1, VSUXSEG4EI16_V, 0x0 }, // 11870
  { PseudoVSUXSEG4EI16_V_M2_M1_MASK, VSUXSEG4EI16_V, 0x0 }, // 11871
  { PseudoVSUXSEG4EI16_V_MF2_M1, VSUXSEG4EI16_V, 0x0 }, // 11872
  { PseudoVSUXSEG4EI16_V_MF2_M1_MASK, VSUXSEG4EI16_V, 0x0 }, // 11873
  { PseudoVSUXSEG4EI16_V_MF4_M1, VSUXSEG4EI16_V, 0x0 }, // 11874
  { PseudoVSUXSEG4EI16_V_MF4_M1_MASK, VSUXSEG4EI16_V, 0x0 }, // 11875
  { PseudoVSUXSEG4EI16_V_M1_M2, VSUXSEG4EI16_V, 0x1 }, // 11876
  { PseudoVSUXSEG4EI16_V_M1_M2_MASK, VSUXSEG4EI16_V, 0x1 }, // 11877
  { PseudoVSUXSEG4EI16_V_M2_M2, VSUXSEG4EI16_V, 0x1 }, // 11878
  { PseudoVSUXSEG4EI16_V_M2_M2_MASK, VSUXSEG4EI16_V, 0x1 }, // 11879
  { PseudoVSUXSEG4EI16_V_M4_M2, VSUXSEG4EI16_V, 0x1 }, // 11880
  { PseudoVSUXSEG4EI16_V_M4_M2_MASK, VSUXSEG4EI16_V, 0x1 }, // 11881
  { PseudoVSUXSEG4EI16_V_MF2_M2, VSUXSEG4EI16_V, 0x1 }, // 11882
  { PseudoVSUXSEG4EI16_V_MF2_M2_MASK, VSUXSEG4EI16_V, 0x1 }, // 11883
  { PseudoVSUXSEG4EI16_V_MF4_MF8, VSUXSEG4EI16_V, 0x5 }, // 11884
  { PseudoVSUXSEG4EI16_V_MF4_MF8_MASK, VSUXSEG4EI16_V, 0x5 }, // 11885
  { PseudoVSUXSEG4EI16_V_MF2_MF4, VSUXSEG4EI16_V, 0x6 }, // 11886
  { PseudoVSUXSEG4EI16_V_MF2_MF4_MASK, VSUXSEG4EI16_V, 0x6 }, // 11887
  { PseudoVSUXSEG4EI16_V_MF4_MF4, VSUXSEG4EI16_V, 0x6 }, // 11888
  { PseudoVSUXSEG4EI16_V_MF4_MF4_MASK, VSUXSEG4EI16_V, 0x6 }, // 11889
  { PseudoVSUXSEG4EI16_V_M1_MF2, VSUXSEG4EI16_V, 0x7 }, // 11890
  { PseudoVSUXSEG4EI16_V_M1_MF2_MASK, VSUXSEG4EI16_V, 0x7 }, // 11891
  { PseudoVSUXSEG4EI16_V_MF2_MF2, VSUXSEG4EI16_V, 0x7 }, // 11892
  { PseudoVSUXSEG4EI16_V_MF2_MF2_MASK, VSUXSEG4EI16_V, 0x7 }, // 11893
  { PseudoVSUXSEG4EI16_V_MF4_MF2, VSUXSEG4EI16_V, 0x7 }, // 11894
  { PseudoVSUXSEG4EI16_V_MF4_MF2_MASK, VSUXSEG4EI16_V, 0x7 }, // 11895
  { PseudoVSUXSEG4EI32_V_M1_M1, VSUXSEG4EI32_V, 0x0 }, // 11896
  { PseudoVSUXSEG4EI32_V_M1_M1_MASK, VSUXSEG4EI32_V, 0x0 }, // 11897
  { PseudoVSUXSEG4EI32_V_M2_M1, VSUXSEG4EI32_V, 0x0 }, // 11898
  { PseudoVSUXSEG4EI32_V_M2_M1_MASK, VSUXSEG4EI32_V, 0x0 }, // 11899
  { PseudoVSUXSEG4EI32_V_M4_M1, VSUXSEG4EI32_V, 0x0 }, // 11900
  { PseudoVSUXSEG4EI32_V_M4_M1_MASK, VSUXSEG4EI32_V, 0x0 }, // 11901
  { PseudoVSUXSEG4EI32_V_MF2_M1, VSUXSEG4EI32_V, 0x0 }, // 11902
  { PseudoVSUXSEG4EI32_V_MF2_M1_MASK, VSUXSEG4EI32_V, 0x0 }, // 11903
  { PseudoVSUXSEG4EI32_V_M1_M2, VSUXSEG4EI32_V, 0x1 }, // 11904
  { PseudoVSUXSEG4EI32_V_M1_M2_MASK, VSUXSEG4EI32_V, 0x1 }, // 11905
  { PseudoVSUXSEG4EI32_V_M2_M2, VSUXSEG4EI32_V, 0x1 }, // 11906
  { PseudoVSUXSEG4EI32_V_M2_M2_MASK, VSUXSEG4EI32_V, 0x1 }, // 11907
  { PseudoVSUXSEG4EI32_V_M4_M2, VSUXSEG4EI32_V, 0x1 }, // 11908
  { PseudoVSUXSEG4EI32_V_M4_M2_MASK, VSUXSEG4EI32_V, 0x1 }, // 11909
  { PseudoVSUXSEG4EI32_V_M8_M2, VSUXSEG4EI32_V, 0x1 }, // 11910
  { PseudoVSUXSEG4EI32_V_M8_M2_MASK, VSUXSEG4EI32_V, 0x1 }, // 11911
  { PseudoVSUXSEG4EI32_V_MF2_MF8, VSUXSEG4EI32_V, 0x5 }, // 11912
  { PseudoVSUXSEG4EI32_V_MF2_MF8_MASK, VSUXSEG4EI32_V, 0x5 }, // 11913
  { PseudoVSUXSEG4EI32_V_M1_MF4, VSUXSEG4EI32_V, 0x6 }, // 11914
  { PseudoVSUXSEG4EI32_V_M1_MF4_MASK, VSUXSEG4EI32_V, 0x6 }, // 11915
  { PseudoVSUXSEG4EI32_V_MF2_MF4, VSUXSEG4EI32_V, 0x6 }, // 11916
  { PseudoVSUXSEG4EI32_V_MF2_MF4_MASK, VSUXSEG4EI32_V, 0x6 }, // 11917
  { PseudoVSUXSEG4EI32_V_M1_MF2, VSUXSEG4EI32_V, 0x7 }, // 11918
  { PseudoVSUXSEG4EI32_V_M1_MF2_MASK, VSUXSEG4EI32_V, 0x7 }, // 11919
  { PseudoVSUXSEG4EI32_V_M2_MF2, VSUXSEG4EI32_V, 0x7 }, // 11920
  { PseudoVSUXSEG4EI32_V_M2_MF2_MASK, VSUXSEG4EI32_V, 0x7 }, // 11921
  { PseudoVSUXSEG4EI32_V_MF2_MF2, VSUXSEG4EI32_V, 0x7 }, // 11922
  { PseudoVSUXSEG4EI32_V_MF2_MF2_MASK, VSUXSEG4EI32_V, 0x7 }, // 11923
  { PseudoVSUXSEG4EI64_V_M1_M1, VSUXSEG4EI64_V, 0x0 }, // 11924
  { PseudoVSUXSEG4EI64_V_M1_M1_MASK, VSUXSEG4EI64_V, 0x0 }, // 11925
  { PseudoVSUXSEG4EI64_V_M2_M1, VSUXSEG4EI64_V, 0x0 }, // 11926
  { PseudoVSUXSEG4EI64_V_M2_M1_MASK, VSUXSEG4EI64_V, 0x0 }, // 11927
  { PseudoVSUXSEG4EI64_V_M4_M1, VSUXSEG4EI64_V, 0x0 }, // 11928
  { PseudoVSUXSEG4EI64_V_M4_M1_MASK, VSUXSEG4EI64_V, 0x0 }, // 11929
  { PseudoVSUXSEG4EI64_V_M8_M1, VSUXSEG4EI64_V, 0x0 }, // 11930
  { PseudoVSUXSEG4EI64_V_M8_M1_MASK, VSUXSEG4EI64_V, 0x0 }, // 11931
  { PseudoVSUXSEG4EI64_V_M2_M2, VSUXSEG4EI64_V, 0x1 }, // 11932
  { PseudoVSUXSEG4EI64_V_M2_M2_MASK, VSUXSEG4EI64_V, 0x1 }, // 11933
  { PseudoVSUXSEG4EI64_V_M4_M2, VSUXSEG4EI64_V, 0x1 }, // 11934
  { PseudoVSUXSEG4EI64_V_M4_M2_MASK, VSUXSEG4EI64_V, 0x1 }, // 11935
  { PseudoVSUXSEG4EI64_V_M8_M2, VSUXSEG4EI64_V, 0x1 }, // 11936
  { PseudoVSUXSEG4EI64_V_M8_M2_MASK, VSUXSEG4EI64_V, 0x1 }, // 11937
  { PseudoVSUXSEG4EI64_V_M1_MF8, VSUXSEG4EI64_V, 0x5 }, // 11938
  { PseudoVSUXSEG4EI64_V_M1_MF8_MASK, VSUXSEG4EI64_V, 0x5 }, // 11939
  { PseudoVSUXSEG4EI64_V_M1_MF4, VSUXSEG4EI64_V, 0x6 }, // 11940
  { PseudoVSUXSEG4EI64_V_M1_MF4_MASK, VSUXSEG4EI64_V, 0x6 }, // 11941
  { PseudoVSUXSEG4EI64_V_M2_MF4, VSUXSEG4EI64_V, 0x6 }, // 11942
  { PseudoVSUXSEG4EI64_V_M2_MF4_MASK, VSUXSEG4EI64_V, 0x6 }, // 11943
  { PseudoVSUXSEG4EI64_V_M1_MF2, VSUXSEG4EI64_V, 0x7 }, // 11944
  { PseudoVSUXSEG4EI64_V_M1_MF2_MASK, VSUXSEG4EI64_V, 0x7 }, // 11945
  { PseudoVSUXSEG4EI64_V_M2_MF2, VSUXSEG4EI64_V, 0x7 }, // 11946
  { PseudoVSUXSEG4EI64_V_M2_MF2_MASK, VSUXSEG4EI64_V, 0x7 }, // 11947
  { PseudoVSUXSEG4EI64_V_M4_MF2, VSUXSEG4EI64_V, 0x7 }, // 11948
  { PseudoVSUXSEG4EI64_V_M4_MF2_MASK, VSUXSEG4EI64_V, 0x7 }, // 11949
  { PseudoVSUXSEG4EI8_V_M1_M1, VSUXSEG4EI8_V, 0x0 }, // 11950
  { PseudoVSUXSEG4EI8_V_M1_M1_MASK, VSUXSEG4EI8_V, 0x0 }, // 11951
  { PseudoVSUXSEG4EI8_V_MF2_M1, VSUXSEG4EI8_V, 0x0 }, // 11952
  { PseudoVSUXSEG4EI8_V_MF2_M1_MASK, VSUXSEG4EI8_V, 0x0 }, // 11953
  { PseudoVSUXSEG4EI8_V_MF4_M1, VSUXSEG4EI8_V, 0x0 }, // 11954
  { PseudoVSUXSEG4EI8_V_MF4_M1_MASK, VSUXSEG4EI8_V, 0x0 }, // 11955
  { PseudoVSUXSEG4EI8_V_MF8_M1, VSUXSEG4EI8_V, 0x0 }, // 11956
  { PseudoVSUXSEG4EI8_V_MF8_M1_MASK, VSUXSEG4EI8_V, 0x0 }, // 11957
  { PseudoVSUXSEG4EI8_V_M1_M2, VSUXSEG4EI8_V, 0x1 }, // 11958
  { PseudoVSUXSEG4EI8_V_M1_M2_MASK, VSUXSEG4EI8_V, 0x1 }, // 11959
  { PseudoVSUXSEG4EI8_V_M2_M2, VSUXSEG4EI8_V, 0x1 }, // 11960
  { PseudoVSUXSEG4EI8_V_M2_M2_MASK, VSUXSEG4EI8_V, 0x1 }, // 11961
  { PseudoVSUXSEG4EI8_V_MF2_M2, VSUXSEG4EI8_V, 0x1 }, // 11962
  { PseudoVSUXSEG4EI8_V_MF2_M2_MASK, VSUXSEG4EI8_V, 0x1 }, // 11963
  { PseudoVSUXSEG4EI8_V_MF4_M2, VSUXSEG4EI8_V, 0x1 }, // 11964
  { PseudoVSUXSEG4EI8_V_MF4_M2_MASK, VSUXSEG4EI8_V, 0x1 }, // 11965
  { PseudoVSUXSEG4EI8_V_MF8_MF8, VSUXSEG4EI8_V, 0x5 }, // 11966
  { PseudoVSUXSEG4EI8_V_MF8_MF8_MASK, VSUXSEG4EI8_V, 0x5 }, // 11967
  { PseudoVSUXSEG4EI8_V_MF4_MF4, VSUXSEG4EI8_V, 0x6 }, // 11968
  { PseudoVSUXSEG4EI8_V_MF4_MF4_MASK, VSUXSEG4EI8_V, 0x6 }, // 11969
  { PseudoVSUXSEG4EI8_V_MF8_MF4, VSUXSEG4EI8_V, 0x6 }, // 11970
  { PseudoVSUXSEG4EI8_V_MF8_MF4_MASK, VSUXSEG4EI8_V, 0x6 }, // 11971
  { PseudoVSUXSEG4EI8_V_MF2_MF2, VSUXSEG4EI8_V, 0x7 }, // 11972
  { PseudoVSUXSEG4EI8_V_MF2_MF2_MASK, VSUXSEG4EI8_V, 0x7 }, // 11973
  { PseudoVSUXSEG4EI8_V_MF4_MF2, VSUXSEG4EI8_V, 0x7 }, // 11974
  { PseudoVSUXSEG4EI8_V_MF4_MF2_MASK, VSUXSEG4EI8_V, 0x7 }, // 11975
  { PseudoVSUXSEG4EI8_V_MF8_MF2, VSUXSEG4EI8_V, 0x7 }, // 11976
  { PseudoVSUXSEG4EI8_V_MF8_MF2_MASK, VSUXSEG4EI8_V, 0x7 }, // 11977
  { PseudoVSUXSEG5EI16_V_M1_M1, VSUXSEG5EI16_V, 0x0 }, // 11978
  { PseudoVSUXSEG5EI16_V_M1_M1_MASK, VSUXSEG5EI16_V, 0x0 }, // 11979
  { PseudoVSUXSEG5EI16_V_M2_M1, VSUXSEG5EI16_V, 0x0 }, // 11980
  { PseudoVSUXSEG5EI16_V_M2_M1_MASK, VSUXSEG5EI16_V, 0x0 }, // 11981
  { PseudoVSUXSEG5EI16_V_MF2_M1, VSUXSEG5EI16_V, 0x0 }, // 11982
  { PseudoVSUXSEG5EI16_V_MF2_M1_MASK, VSUXSEG5EI16_V, 0x0 }, // 11983
  { PseudoVSUXSEG5EI16_V_MF4_M1, VSUXSEG5EI16_V, 0x0 }, // 11984
  { PseudoVSUXSEG5EI16_V_MF4_M1_MASK, VSUXSEG5EI16_V, 0x0 }, // 11985
  { PseudoVSUXSEG5EI16_V_MF4_MF8, VSUXSEG5EI16_V, 0x5 }, // 11986
  { PseudoVSUXSEG5EI16_V_MF4_MF8_MASK, VSUXSEG5EI16_V, 0x5 }, // 11987
  { PseudoVSUXSEG5EI16_V_MF2_MF4, VSUXSEG5EI16_V, 0x6 }, // 11988
  { PseudoVSUXSEG5EI16_V_MF2_MF4_MASK, VSUXSEG5EI16_V, 0x6 }, // 11989
  { PseudoVSUXSEG5EI16_V_MF4_MF4, VSUXSEG5EI16_V, 0x6 }, // 11990
  { PseudoVSUXSEG5EI16_V_MF4_MF4_MASK, VSUXSEG5EI16_V, 0x6 }, // 11991
  { PseudoVSUXSEG5EI16_V_M1_MF2, VSUXSEG5EI16_V, 0x7 }, // 11992
  { PseudoVSUXSEG5EI16_V_M1_MF2_MASK, VSUXSEG5EI16_V, 0x7 }, // 11993
  { PseudoVSUXSEG5EI16_V_MF2_MF2, VSUXSEG5EI16_V, 0x7 }, // 11994
  { PseudoVSUXSEG5EI16_V_MF2_MF2_MASK, VSUXSEG5EI16_V, 0x7 }, // 11995
  { PseudoVSUXSEG5EI16_V_MF4_MF2, VSUXSEG5EI16_V, 0x7 }, // 11996
  { PseudoVSUXSEG5EI16_V_MF4_MF2_MASK, VSUXSEG5EI16_V, 0x7 }, // 11997
  { PseudoVSUXSEG5EI32_V_M1_M1, VSUXSEG5EI32_V, 0x0 }, // 11998
  { PseudoVSUXSEG5EI32_V_M1_M1_MASK, VSUXSEG5EI32_V, 0x0 }, // 11999
  { PseudoVSUXSEG5EI32_V_M2_M1, VSUXSEG5EI32_V, 0x0 }, // 12000
  { PseudoVSUXSEG5EI32_V_M2_M1_MASK, VSUXSEG5EI32_V, 0x0 }, // 12001
  { PseudoVSUXSEG5EI32_V_M4_M1, VSUXSEG5EI32_V, 0x0 }, // 12002
  { PseudoVSUXSEG5EI32_V_M4_M1_MASK, VSUXSEG5EI32_V, 0x0 }, // 12003
  { PseudoVSUXSEG5EI32_V_MF2_M1, VSUXSEG5EI32_V, 0x0 }, // 12004
  { PseudoVSUXSEG5EI32_V_MF2_M1_MASK, VSUXSEG5EI32_V, 0x0 }, // 12005
  { PseudoVSUXSEG5EI32_V_MF2_MF8, VSUXSEG5EI32_V, 0x5 }, // 12006
  { PseudoVSUXSEG5EI32_V_MF2_MF8_MASK, VSUXSEG5EI32_V, 0x5 }, // 12007
  { PseudoVSUXSEG5EI32_V_M1_MF4, VSUXSEG5EI32_V, 0x6 }, // 12008
  { PseudoVSUXSEG5EI32_V_M1_MF4_MASK, VSUXSEG5EI32_V, 0x6 }, // 12009
  { PseudoVSUXSEG5EI32_V_MF2_MF4, VSUXSEG5EI32_V, 0x6 }, // 12010
  { PseudoVSUXSEG5EI32_V_MF2_MF4_MASK, VSUXSEG5EI32_V, 0x6 }, // 12011
  { PseudoVSUXSEG5EI32_V_M1_MF2, VSUXSEG5EI32_V, 0x7 }, // 12012
  { PseudoVSUXSEG5EI32_V_M1_MF2_MASK, VSUXSEG5EI32_V, 0x7 }, // 12013
  { PseudoVSUXSEG5EI32_V_M2_MF2, VSUXSEG5EI32_V, 0x7 }, // 12014
  { PseudoVSUXSEG5EI32_V_M2_MF2_MASK, VSUXSEG5EI32_V, 0x7 }, // 12015
  { PseudoVSUXSEG5EI32_V_MF2_MF2, VSUXSEG5EI32_V, 0x7 }, // 12016
  { PseudoVSUXSEG5EI32_V_MF2_MF2_MASK, VSUXSEG5EI32_V, 0x7 }, // 12017
  { PseudoVSUXSEG5EI64_V_M1_M1, VSUXSEG5EI64_V, 0x0 }, // 12018
  { PseudoVSUXSEG5EI64_V_M1_M1_MASK, VSUXSEG5EI64_V, 0x0 }, // 12019
  { PseudoVSUXSEG5EI64_V_M2_M1, VSUXSEG5EI64_V, 0x0 }, // 12020
  { PseudoVSUXSEG5EI64_V_M2_M1_MASK, VSUXSEG5EI64_V, 0x0 }, // 12021
  { PseudoVSUXSEG5EI64_V_M4_M1, VSUXSEG5EI64_V, 0x0 }, // 12022
  { PseudoVSUXSEG5EI64_V_M4_M1_MASK, VSUXSEG5EI64_V, 0x0 }, // 12023
  { PseudoVSUXSEG5EI64_V_M8_M1, VSUXSEG5EI64_V, 0x0 }, // 12024
  { PseudoVSUXSEG5EI64_V_M8_M1_MASK, VSUXSEG5EI64_V, 0x0 }, // 12025
  { PseudoVSUXSEG5EI64_V_M1_MF8, VSUXSEG5EI64_V, 0x5 }, // 12026
  { PseudoVSUXSEG5EI64_V_M1_MF8_MASK, VSUXSEG5EI64_V, 0x5 }, // 12027
  { PseudoVSUXSEG5EI64_V_M1_MF4, VSUXSEG5EI64_V, 0x6 }, // 12028
  { PseudoVSUXSEG5EI64_V_M1_MF4_MASK, VSUXSEG5EI64_V, 0x6 }, // 12029
  { PseudoVSUXSEG5EI64_V_M2_MF4, VSUXSEG5EI64_V, 0x6 }, // 12030
  { PseudoVSUXSEG5EI64_V_M2_MF4_MASK, VSUXSEG5EI64_V, 0x6 }, // 12031
  { PseudoVSUXSEG5EI64_V_M1_MF2, VSUXSEG5EI64_V, 0x7 }, // 12032
  { PseudoVSUXSEG5EI64_V_M1_MF2_MASK, VSUXSEG5EI64_V, 0x7 }, // 12033
  { PseudoVSUXSEG5EI64_V_M2_MF2, VSUXSEG5EI64_V, 0x7 }, // 12034
  { PseudoVSUXSEG5EI64_V_M2_MF2_MASK, VSUXSEG5EI64_V, 0x7 }, // 12035
  { PseudoVSUXSEG5EI64_V_M4_MF2, VSUXSEG5EI64_V, 0x7 }, // 12036
  { PseudoVSUXSEG5EI64_V_M4_MF2_MASK, VSUXSEG5EI64_V, 0x7 }, // 12037
  { PseudoVSUXSEG5EI8_V_M1_M1, VSUXSEG5EI8_V, 0x0 }, // 12038
  { PseudoVSUXSEG5EI8_V_M1_M1_MASK, VSUXSEG5EI8_V, 0x0 }, // 12039
  { PseudoVSUXSEG5EI8_V_MF2_M1, VSUXSEG5EI8_V, 0x0 }, // 12040
  { PseudoVSUXSEG5EI8_V_MF2_M1_MASK, VSUXSEG5EI8_V, 0x0 }, // 12041
  { PseudoVSUXSEG5EI8_V_MF4_M1, VSUXSEG5EI8_V, 0x0 }, // 12042
  { PseudoVSUXSEG5EI8_V_MF4_M1_MASK, VSUXSEG5EI8_V, 0x0 }, // 12043
  { PseudoVSUXSEG5EI8_V_MF8_M1, VSUXSEG5EI8_V, 0x0 }, // 12044
  { PseudoVSUXSEG5EI8_V_MF8_M1_MASK, VSUXSEG5EI8_V, 0x0 }, // 12045
  { PseudoVSUXSEG5EI8_V_MF8_MF8, VSUXSEG5EI8_V, 0x5 }, // 12046
  { PseudoVSUXSEG5EI8_V_MF8_MF8_MASK, VSUXSEG5EI8_V, 0x5 }, // 12047
  { PseudoVSUXSEG5EI8_V_MF4_MF4, VSUXSEG5EI8_V, 0x6 }, // 12048
  { PseudoVSUXSEG5EI8_V_MF4_MF4_MASK, VSUXSEG5EI8_V, 0x6 }, // 12049
  { PseudoVSUXSEG5EI8_V_MF8_MF4, VSUXSEG5EI8_V, 0x6 }, // 12050
  { PseudoVSUXSEG5EI8_V_MF8_MF4_MASK, VSUXSEG5EI8_V, 0x6 }, // 12051
  { PseudoVSUXSEG5EI8_V_MF2_MF2, VSUXSEG5EI8_V, 0x7 }, // 12052
  { PseudoVSUXSEG5EI8_V_MF2_MF2_MASK, VSUXSEG5EI8_V, 0x7 }, // 12053
  { PseudoVSUXSEG5EI8_V_MF4_MF2, VSUXSEG5EI8_V, 0x7 }, // 12054
  { PseudoVSUXSEG5EI8_V_MF4_MF2_MASK, VSUXSEG5EI8_V, 0x7 }, // 12055
  { PseudoVSUXSEG5EI8_V_MF8_MF2, VSUXSEG5EI8_V, 0x7 }, // 12056
  { PseudoVSUXSEG5EI8_V_MF8_MF2_MASK, VSUXSEG5EI8_V, 0x7 }, // 12057
  { PseudoVSUXSEG6EI16_V_M1_M1, VSUXSEG6EI16_V, 0x0 }, // 12058
  { PseudoVSUXSEG6EI16_V_M1_M1_MASK, VSUXSEG6EI16_V, 0x0 }, // 12059
  { PseudoVSUXSEG6EI16_V_M2_M1, VSUXSEG6EI16_V, 0x0 }, // 12060
  { PseudoVSUXSEG6EI16_V_M2_M1_MASK, VSUXSEG6EI16_V, 0x0 }, // 12061
  { PseudoVSUXSEG6EI16_V_MF2_M1, VSUXSEG6EI16_V, 0x0 }, // 12062
  { PseudoVSUXSEG6EI16_V_MF2_M1_MASK, VSUXSEG6EI16_V, 0x0 }, // 12063
  { PseudoVSUXSEG6EI16_V_MF4_M1, VSUXSEG6EI16_V, 0x0 }, // 12064
  { PseudoVSUXSEG6EI16_V_MF4_M1_MASK, VSUXSEG6EI16_V, 0x0 }, // 12065
  { PseudoVSUXSEG6EI16_V_MF4_MF8, VSUXSEG6EI16_V, 0x5 }, // 12066
  { PseudoVSUXSEG6EI16_V_MF4_MF8_MASK, VSUXSEG6EI16_V, 0x5 }, // 12067
  { PseudoVSUXSEG6EI16_V_MF2_MF4, VSUXSEG6EI16_V, 0x6 }, // 12068
  { PseudoVSUXSEG6EI16_V_MF2_MF4_MASK, VSUXSEG6EI16_V, 0x6 }, // 12069
  { PseudoVSUXSEG6EI16_V_MF4_MF4, VSUXSEG6EI16_V, 0x6 }, // 12070
  { PseudoVSUXSEG6EI16_V_MF4_MF4_MASK, VSUXSEG6EI16_V, 0x6 }, // 12071
  { PseudoVSUXSEG6EI16_V_M1_MF2, VSUXSEG6EI16_V, 0x7 }, // 12072
  { PseudoVSUXSEG6EI16_V_M1_MF2_MASK, VSUXSEG6EI16_V, 0x7 }, // 12073
  { PseudoVSUXSEG6EI16_V_MF2_MF2, VSUXSEG6EI16_V, 0x7 }, // 12074
  { PseudoVSUXSEG6EI16_V_MF2_MF2_MASK, VSUXSEG6EI16_V, 0x7 }, // 12075
  { PseudoVSUXSEG6EI16_V_MF4_MF2, VSUXSEG6EI16_V, 0x7 }, // 12076
  { PseudoVSUXSEG6EI16_V_MF4_MF2_MASK, VSUXSEG6EI16_V, 0x7 }, // 12077
  { PseudoVSUXSEG6EI32_V_M1_M1, VSUXSEG6EI32_V, 0x0 }, // 12078
  { PseudoVSUXSEG6EI32_V_M1_M1_MASK, VSUXSEG6EI32_V, 0x0 }, // 12079
  { PseudoVSUXSEG6EI32_V_M2_M1, VSUXSEG6EI32_V, 0x0 }, // 12080
  { PseudoVSUXSEG6EI32_V_M2_M1_MASK, VSUXSEG6EI32_V, 0x0 }, // 12081
  { PseudoVSUXSEG6EI32_V_M4_M1, VSUXSEG6EI32_V, 0x0 }, // 12082
  { PseudoVSUXSEG6EI32_V_M4_M1_MASK, VSUXSEG6EI32_V, 0x0 }, // 12083
  { PseudoVSUXSEG6EI32_V_MF2_M1, VSUXSEG6EI32_V, 0x0 }, // 12084
  { PseudoVSUXSEG6EI32_V_MF2_M1_MASK, VSUXSEG6EI32_V, 0x0 }, // 12085
  { PseudoVSUXSEG6EI32_V_MF2_MF8, VSUXSEG6EI32_V, 0x5 }, // 12086
  { PseudoVSUXSEG6EI32_V_MF2_MF8_MASK, VSUXSEG6EI32_V, 0x5 }, // 12087
  { PseudoVSUXSEG6EI32_V_M1_MF4, VSUXSEG6EI32_V, 0x6 }, // 12088
  { PseudoVSUXSEG6EI32_V_M1_MF4_MASK, VSUXSEG6EI32_V, 0x6 }, // 12089
  { PseudoVSUXSEG6EI32_V_MF2_MF4, VSUXSEG6EI32_V, 0x6 }, // 12090
  { PseudoVSUXSEG6EI32_V_MF2_MF4_MASK, VSUXSEG6EI32_V, 0x6 }, // 12091
  { PseudoVSUXSEG6EI32_V_M1_MF2, VSUXSEG6EI32_V, 0x7 }, // 12092
  { PseudoVSUXSEG6EI32_V_M1_MF2_MASK, VSUXSEG6EI32_V, 0x7 }, // 12093
  { PseudoVSUXSEG6EI32_V_M2_MF2, VSUXSEG6EI32_V, 0x7 }, // 12094
  { PseudoVSUXSEG6EI32_V_M2_MF2_MASK, VSUXSEG6EI32_V, 0x7 }, // 12095
  { PseudoVSUXSEG6EI32_V_MF2_MF2, VSUXSEG6EI32_V, 0x7 }, // 12096
  { PseudoVSUXSEG6EI32_V_MF2_MF2_MASK, VSUXSEG6EI32_V, 0x7 }, // 12097
  { PseudoVSUXSEG6EI64_V_M1_M1, VSUXSEG6EI64_V, 0x0 }, // 12098
  { PseudoVSUXSEG6EI64_V_M1_M1_MASK, VSUXSEG6EI64_V, 0x0 }, // 12099
  { PseudoVSUXSEG6EI64_V_M2_M1, VSUXSEG6EI64_V, 0x0 }, // 12100
  { PseudoVSUXSEG6EI64_V_M2_M1_MASK, VSUXSEG6EI64_V, 0x0 }, // 12101
  { PseudoVSUXSEG6EI64_V_M4_M1, VSUXSEG6EI64_V, 0x0 }, // 12102
  { PseudoVSUXSEG6EI64_V_M4_M1_MASK, VSUXSEG6EI64_V, 0x0 }, // 12103
  { PseudoVSUXSEG6EI64_V_M8_M1, VSUXSEG6EI64_V, 0x0 }, // 12104
  { PseudoVSUXSEG6EI64_V_M8_M1_MASK, VSUXSEG6EI64_V, 0x0 }, // 12105
  { PseudoVSUXSEG6EI64_V_M1_MF8, VSUXSEG6EI64_V, 0x5 }, // 12106
  { PseudoVSUXSEG6EI64_V_M1_MF8_MASK, VSUXSEG6EI64_V, 0x5 }, // 12107
  { PseudoVSUXSEG6EI64_V_M1_MF4, VSUXSEG6EI64_V, 0x6 }, // 12108
  { PseudoVSUXSEG6EI64_V_M1_MF4_MASK, VSUXSEG6EI64_V, 0x6 }, // 12109
  { PseudoVSUXSEG6EI64_V_M2_MF4, VSUXSEG6EI64_V, 0x6 }, // 12110
  { PseudoVSUXSEG6EI64_V_M2_MF4_MASK, VSUXSEG6EI64_V, 0x6 }, // 12111
  { PseudoVSUXSEG6EI64_V_M1_MF2, VSUXSEG6EI64_V, 0x7 }, // 12112
  { PseudoVSUXSEG6EI64_V_M1_MF2_MASK, VSUXSEG6EI64_V, 0x7 }, // 12113
  { PseudoVSUXSEG6EI64_V_M2_MF2, VSUXSEG6EI64_V, 0x7 }, // 12114
  { PseudoVSUXSEG6EI64_V_M2_MF2_MASK, VSUXSEG6EI64_V, 0x7 }, // 12115
  { PseudoVSUXSEG6EI64_V_M4_MF2, VSUXSEG6EI64_V, 0x7 }, // 12116
  { PseudoVSUXSEG6EI64_V_M4_MF2_MASK, VSUXSEG6EI64_V, 0x7 }, // 12117
  { PseudoVSUXSEG6EI8_V_M1_M1, VSUXSEG6EI8_V, 0x0 }, // 12118
  { PseudoVSUXSEG6EI8_V_M1_M1_MASK, VSUXSEG6EI8_V, 0x0 }, // 12119
  { PseudoVSUXSEG6EI8_V_MF2_M1, VSUXSEG6EI8_V, 0x0 }, // 12120
  { PseudoVSUXSEG6EI8_V_MF2_M1_MASK, VSUXSEG6EI8_V, 0x0 }, // 12121
  { PseudoVSUXSEG6EI8_V_MF4_M1, VSUXSEG6EI8_V, 0x0 }, // 12122
  { PseudoVSUXSEG6EI8_V_MF4_M1_MASK, VSUXSEG6EI8_V, 0x0 }, // 12123
  { PseudoVSUXSEG6EI8_V_MF8_M1, VSUXSEG6EI8_V, 0x0 }, // 12124
  { PseudoVSUXSEG6EI8_V_MF8_M1_MASK, VSUXSEG6EI8_V, 0x0 }, // 12125
  { PseudoVSUXSEG6EI8_V_MF8_MF8, VSUXSEG6EI8_V, 0x5 }, // 12126
  { PseudoVSUXSEG6EI8_V_MF8_MF8_MASK, VSUXSEG6EI8_V, 0x5 }, // 12127
  { PseudoVSUXSEG6EI8_V_MF4_MF4, VSUXSEG6EI8_V, 0x6 }, // 12128
  { PseudoVSUXSEG6EI8_V_MF4_MF4_MASK, VSUXSEG6EI8_V, 0x6 }, // 12129
  { PseudoVSUXSEG6EI8_V_MF8_MF4, VSUXSEG6EI8_V, 0x6 }, // 12130
  { PseudoVSUXSEG6EI8_V_MF8_MF4_MASK, VSUXSEG6EI8_V, 0x6 }, // 12131
  { PseudoVSUXSEG6EI8_V_MF2_MF2, VSUXSEG6EI8_V, 0x7 }, // 12132
  { PseudoVSUXSEG6EI8_V_MF2_MF2_MASK, VSUXSEG6EI8_V, 0x7 }, // 12133
  { PseudoVSUXSEG6EI8_V_MF4_MF2, VSUXSEG6EI8_V, 0x7 }, // 12134
  { PseudoVSUXSEG6EI8_V_MF4_MF2_MASK, VSUXSEG6EI8_V, 0x7 }, // 12135
  { PseudoVSUXSEG6EI8_V_MF8_MF2, VSUXSEG6EI8_V, 0x7 }, // 12136
  { PseudoVSUXSEG6EI8_V_MF8_MF2_MASK, VSUXSEG6EI8_V, 0x7 }, // 12137
  { PseudoVSUXSEG7EI16_V_M1_M1, VSUXSEG7EI16_V, 0x0 }, // 12138
  { PseudoVSUXSEG7EI16_V_M1_M1_MASK, VSUXSEG7EI16_V, 0x0 }, // 12139
  { PseudoVSUXSEG7EI16_V_M2_M1, VSUXSEG7EI16_V, 0x0 }, // 12140
  { PseudoVSUXSEG7EI16_V_M2_M1_MASK, VSUXSEG7EI16_V, 0x0 }, // 12141
  { PseudoVSUXSEG7EI16_V_MF2_M1, VSUXSEG7EI16_V, 0x0 }, // 12142
  { PseudoVSUXSEG7EI16_V_MF2_M1_MASK, VSUXSEG7EI16_V, 0x0 }, // 12143
  { PseudoVSUXSEG7EI16_V_MF4_M1, VSUXSEG7EI16_V, 0x0 }, // 12144
  { PseudoVSUXSEG7EI16_V_MF4_M1_MASK, VSUXSEG7EI16_V, 0x0 }, // 12145
  { PseudoVSUXSEG7EI16_V_MF4_MF8, VSUXSEG7EI16_V, 0x5 }, // 12146
  { PseudoVSUXSEG7EI16_V_MF4_MF8_MASK, VSUXSEG7EI16_V, 0x5 }, // 12147
  { PseudoVSUXSEG7EI16_V_MF2_MF4, VSUXSEG7EI16_V, 0x6 }, // 12148
  { PseudoVSUXSEG7EI16_V_MF2_MF4_MASK, VSUXSEG7EI16_V, 0x6 }, // 12149
  { PseudoVSUXSEG7EI16_V_MF4_MF4, VSUXSEG7EI16_V, 0x6 }, // 12150
  { PseudoVSUXSEG7EI16_V_MF4_MF4_MASK, VSUXSEG7EI16_V, 0x6 }, // 12151
  { PseudoVSUXSEG7EI16_V_M1_MF2, VSUXSEG7EI16_V, 0x7 }, // 12152
  { PseudoVSUXSEG7EI16_V_M1_MF2_MASK, VSUXSEG7EI16_V, 0x7 }, // 12153
  { PseudoVSUXSEG7EI16_V_MF2_MF2, VSUXSEG7EI16_V, 0x7 }, // 12154
  { PseudoVSUXSEG7EI16_V_MF2_MF2_MASK, VSUXSEG7EI16_V, 0x7 }, // 12155
  { PseudoVSUXSEG7EI16_V_MF4_MF2, VSUXSEG7EI16_V, 0x7 }, // 12156
  { PseudoVSUXSEG7EI16_V_MF4_MF2_MASK, VSUXSEG7EI16_V, 0x7 }, // 12157
  { PseudoVSUXSEG7EI32_V_M1_M1, VSUXSEG7EI32_V, 0x0 }, // 12158
  { PseudoVSUXSEG7EI32_V_M1_M1_MASK, VSUXSEG7EI32_V, 0x0 }, // 12159
  { PseudoVSUXSEG7EI32_V_M2_M1, VSUXSEG7EI32_V, 0x0 }, // 12160
  { PseudoVSUXSEG7EI32_V_M2_M1_MASK, VSUXSEG7EI32_V, 0x0 }, // 12161
  { PseudoVSUXSEG7EI32_V_M4_M1, VSUXSEG7EI32_V, 0x0 }, // 12162
  { PseudoVSUXSEG7EI32_V_M4_M1_MASK, VSUXSEG7EI32_V, 0x0 }, // 12163
  { PseudoVSUXSEG7EI32_V_MF2_M1, VSUXSEG7EI32_V, 0x0 }, // 12164
  { PseudoVSUXSEG7EI32_V_MF2_M1_MASK, VSUXSEG7EI32_V, 0x0 }, // 12165
  { PseudoVSUXSEG7EI32_V_MF2_MF8, VSUXSEG7EI32_V, 0x5 }, // 12166
  { PseudoVSUXSEG7EI32_V_MF2_MF8_MASK, VSUXSEG7EI32_V, 0x5 }, // 12167
  { PseudoVSUXSEG7EI32_V_M1_MF4, VSUXSEG7EI32_V, 0x6 }, // 12168
  { PseudoVSUXSEG7EI32_V_M1_MF4_MASK, VSUXSEG7EI32_V, 0x6 }, // 12169
  { PseudoVSUXSEG7EI32_V_MF2_MF4, VSUXSEG7EI32_V, 0x6 }, // 12170
  { PseudoVSUXSEG7EI32_V_MF2_MF4_MASK, VSUXSEG7EI32_V, 0x6 }, // 12171
  { PseudoVSUXSEG7EI32_V_M1_MF2, VSUXSEG7EI32_V, 0x7 }, // 12172
  { PseudoVSUXSEG7EI32_V_M1_MF2_MASK, VSUXSEG7EI32_V, 0x7 }, // 12173
  { PseudoVSUXSEG7EI32_V_M2_MF2, VSUXSEG7EI32_V, 0x7 }, // 12174
  { PseudoVSUXSEG7EI32_V_M2_MF2_MASK, VSUXSEG7EI32_V, 0x7 }, // 12175
  { PseudoVSUXSEG7EI32_V_MF2_MF2, VSUXSEG7EI32_V, 0x7 }, // 12176
  { PseudoVSUXSEG7EI32_V_MF2_MF2_MASK, VSUXSEG7EI32_V, 0x7 }, // 12177
  { PseudoVSUXSEG7EI64_V_M1_M1, VSUXSEG7EI64_V, 0x0 }, // 12178
  { PseudoVSUXSEG7EI64_V_M1_M1_MASK, VSUXSEG7EI64_V, 0x0 }, // 12179
  { PseudoVSUXSEG7EI64_V_M2_M1, VSUXSEG7EI64_V, 0x0 }, // 12180
  { PseudoVSUXSEG7EI64_V_M2_M1_MASK, VSUXSEG7EI64_V, 0x0 }, // 12181
  { PseudoVSUXSEG7EI64_V_M4_M1, VSUXSEG7EI64_V, 0x0 }, // 12182
  { PseudoVSUXSEG7EI64_V_M4_M1_MASK, VSUXSEG7EI64_V, 0x0 }, // 12183
  { PseudoVSUXSEG7EI64_V_M8_M1, VSUXSEG7EI64_V, 0x0 }, // 12184
  { PseudoVSUXSEG7EI64_V_M8_M1_MASK, VSUXSEG7EI64_V, 0x0 }, // 12185
  { PseudoVSUXSEG7EI64_V_M1_MF8, VSUXSEG7EI64_V, 0x5 }, // 12186
  { PseudoVSUXSEG7EI64_V_M1_MF8_MASK, VSUXSEG7EI64_V, 0x5 }, // 12187
  { PseudoVSUXSEG7EI64_V_M1_MF4, VSUXSEG7EI64_V, 0x6 }, // 12188
  { PseudoVSUXSEG7EI64_V_M1_MF4_MASK, VSUXSEG7EI64_V, 0x6 }, // 12189
  { PseudoVSUXSEG7EI64_V_M2_MF4, VSUXSEG7EI64_V, 0x6 }, // 12190
  { PseudoVSUXSEG7EI64_V_M2_MF4_MASK, VSUXSEG7EI64_V, 0x6 }, // 12191
  { PseudoVSUXSEG7EI64_V_M1_MF2, VSUXSEG7EI64_V, 0x7 }, // 12192
  { PseudoVSUXSEG7EI64_V_M1_MF2_MASK, VSUXSEG7EI64_V, 0x7 }, // 12193
  { PseudoVSUXSEG7EI64_V_M2_MF2, VSUXSEG7EI64_V, 0x7 }, // 12194
  { PseudoVSUXSEG7EI64_V_M2_MF2_MASK, VSUXSEG7EI64_V, 0x7 }, // 12195
  { PseudoVSUXSEG7EI64_V_M4_MF2, VSUXSEG7EI64_V, 0x7 }, // 12196
  { PseudoVSUXSEG7EI64_V_M4_MF2_MASK, VSUXSEG7EI64_V, 0x7 }, // 12197
  { PseudoVSUXSEG7EI8_V_M1_M1, VSUXSEG7EI8_V, 0x0 }, // 12198
  { PseudoVSUXSEG7EI8_V_M1_M1_MASK, VSUXSEG7EI8_V, 0x0 }, // 12199
  { PseudoVSUXSEG7EI8_V_MF2_M1, VSUXSEG7EI8_V, 0x0 }, // 12200
  { PseudoVSUXSEG7EI8_V_MF2_M1_MASK, VSUXSEG7EI8_V, 0x0 }, // 12201
  { PseudoVSUXSEG7EI8_V_MF4_M1, VSUXSEG7EI8_V, 0x0 }, // 12202
  { PseudoVSUXSEG7EI8_V_MF4_M1_MASK, VSUXSEG7EI8_V, 0x0 }, // 12203
  { PseudoVSUXSEG7EI8_V_MF8_M1, VSUXSEG7EI8_V, 0x0 }, // 12204
  { PseudoVSUXSEG7EI8_V_MF8_M1_MASK, VSUXSEG7EI8_V, 0x0 }, // 12205
  { PseudoVSUXSEG7EI8_V_MF8_MF8, VSUXSEG7EI8_V, 0x5 }, // 12206
  { PseudoVSUXSEG7EI8_V_MF8_MF8_MASK, VSUXSEG7EI8_V, 0x5 }, // 12207
  { PseudoVSUXSEG7EI8_V_MF4_MF4, VSUXSEG7EI8_V, 0x6 }, // 12208
  { PseudoVSUXSEG7EI8_V_MF4_MF4_MASK, VSUXSEG7EI8_V, 0x6 }, // 12209
  { PseudoVSUXSEG7EI8_V_MF8_MF4, VSUXSEG7EI8_V, 0x6 }, // 12210
  { PseudoVSUXSEG7EI8_V_MF8_MF4_MASK, VSUXSEG7EI8_V, 0x6 }, // 12211
  { PseudoVSUXSEG7EI8_V_MF2_MF2, VSUXSEG7EI8_V, 0x7 }, // 12212
  { PseudoVSUXSEG7EI8_V_MF2_MF2_MASK, VSUXSEG7EI8_V, 0x7 }, // 12213
  { PseudoVSUXSEG7EI8_V_MF4_MF2, VSUXSEG7EI8_V, 0x7 }, // 12214
  { PseudoVSUXSEG7EI8_V_MF4_MF2_MASK, VSUXSEG7EI8_V, 0x7 }, // 12215
  { PseudoVSUXSEG7EI8_V_MF8_MF2, VSUXSEG7EI8_V, 0x7 }, // 12216
  { PseudoVSUXSEG7EI8_V_MF8_MF2_MASK, VSUXSEG7EI8_V, 0x7 }, // 12217
  { PseudoVSUXSEG8EI16_V_M1_M1, VSUXSEG8EI16_V, 0x0 }, // 12218
  { PseudoVSUXSEG8EI16_V_M1_M1_MASK, VSUXSEG8EI16_V, 0x0 }, // 12219
  { PseudoVSUXSEG8EI16_V_M2_M1, VSUXSEG8EI16_V, 0x0 }, // 12220
  { PseudoVSUXSEG8EI16_V_M2_M1_MASK, VSUXSEG8EI16_V, 0x0 }, // 12221
  { PseudoVSUXSEG8EI16_V_MF2_M1, VSUXSEG8EI16_V, 0x0 }, // 12222
  { PseudoVSUXSEG8EI16_V_MF2_M1_MASK, VSUXSEG8EI16_V, 0x0 }, // 12223
  { PseudoVSUXSEG8EI16_V_MF4_M1, VSUXSEG8EI16_V, 0x0 }, // 12224
  { PseudoVSUXSEG8EI16_V_MF4_M1_MASK, VSUXSEG8EI16_V, 0x0 }, // 12225
  { PseudoVSUXSEG8EI16_V_MF4_MF8, VSUXSEG8EI16_V, 0x5 }, // 12226
  { PseudoVSUXSEG8EI16_V_MF4_MF8_MASK, VSUXSEG8EI16_V, 0x5 }, // 12227
  { PseudoVSUXSEG8EI16_V_MF2_MF4, VSUXSEG8EI16_V, 0x6 }, // 12228
  { PseudoVSUXSEG8EI16_V_MF2_MF4_MASK, VSUXSEG8EI16_V, 0x6 }, // 12229
  { PseudoVSUXSEG8EI16_V_MF4_MF4, VSUXSEG8EI16_V, 0x6 }, // 12230
  { PseudoVSUXSEG8EI16_V_MF4_MF4_MASK, VSUXSEG8EI16_V, 0x6 }, // 12231
  { PseudoVSUXSEG8EI16_V_M1_MF2, VSUXSEG8EI16_V, 0x7 }, // 12232
  { PseudoVSUXSEG8EI16_V_M1_MF2_MASK, VSUXSEG8EI16_V, 0x7 }, // 12233
  { PseudoVSUXSEG8EI16_V_MF2_MF2, VSUXSEG8EI16_V, 0x7 }, // 12234
  { PseudoVSUXSEG8EI16_V_MF2_MF2_MASK, VSUXSEG8EI16_V, 0x7 }, // 12235
  { PseudoVSUXSEG8EI16_V_MF4_MF2, VSUXSEG8EI16_V, 0x7 }, // 12236
  { PseudoVSUXSEG8EI16_V_MF4_MF2_MASK, VSUXSEG8EI16_V, 0x7 }, // 12237
  { PseudoVSUXSEG8EI32_V_M1_M1, VSUXSEG8EI32_V, 0x0 }, // 12238
  { PseudoVSUXSEG8EI32_V_M1_M1_MASK, VSUXSEG8EI32_V, 0x0 }, // 12239
  { PseudoVSUXSEG8EI32_V_M2_M1, VSUXSEG8EI32_V, 0x0 }, // 12240
  { PseudoVSUXSEG8EI32_V_M2_M1_MASK, VSUXSEG8EI32_V, 0x0 }, // 12241
  { PseudoVSUXSEG8EI32_V_M4_M1, VSUXSEG8EI32_V, 0x0 }, // 12242
  { PseudoVSUXSEG8EI32_V_M4_M1_MASK, VSUXSEG8EI32_V, 0x0 }, // 12243
  { PseudoVSUXSEG8EI32_V_MF2_M1, VSUXSEG8EI32_V, 0x0 }, // 12244
  { PseudoVSUXSEG8EI32_V_MF2_M1_MASK, VSUXSEG8EI32_V, 0x0 }, // 12245
  { PseudoVSUXSEG8EI32_V_MF2_MF8, VSUXSEG8EI32_V, 0x5 }, // 12246
  { PseudoVSUXSEG8EI32_V_MF2_MF8_MASK, VSUXSEG8EI32_V, 0x5 }, // 12247
  { PseudoVSUXSEG8EI32_V_M1_MF4, VSUXSEG8EI32_V, 0x6 }, // 12248
  { PseudoVSUXSEG8EI32_V_M1_MF4_MASK, VSUXSEG8EI32_V, 0x6 }, // 12249
  { PseudoVSUXSEG8EI32_V_MF2_MF4, VSUXSEG8EI32_V, 0x6 }, // 12250
  { PseudoVSUXSEG8EI32_V_MF2_MF4_MASK, VSUXSEG8EI32_V, 0x6 }, // 12251
  { PseudoVSUXSEG8EI32_V_M1_MF2, VSUXSEG8EI32_V, 0x7 }, // 12252
  { PseudoVSUXSEG8EI32_V_M1_MF2_MASK, VSUXSEG8EI32_V, 0x7 }, // 12253
  { PseudoVSUXSEG8EI32_V_M2_MF2, VSUXSEG8EI32_V, 0x7 }, // 12254
  { PseudoVSUXSEG8EI32_V_M2_MF2_MASK, VSUXSEG8EI32_V, 0x7 }, // 12255
  { PseudoVSUXSEG8EI32_V_MF2_MF2, VSUXSEG8EI32_V, 0x7 }, // 12256
  { PseudoVSUXSEG8EI32_V_MF2_MF2_MASK, VSUXSEG8EI32_V, 0x7 }, // 12257
  { PseudoVSUXSEG8EI64_V_M1_M1, VSUXSEG8EI64_V, 0x0 }, // 12258
  { PseudoVSUXSEG8EI64_V_M1_M1_MASK, VSUXSEG8EI64_V, 0x0 }, // 12259
  { PseudoVSUXSEG8EI64_V_M2_M1, VSUXSEG8EI64_V, 0x0 }, // 12260
  { PseudoVSUXSEG8EI64_V_M2_M1_MASK, VSUXSEG8EI64_V, 0x0 }, // 12261
  { PseudoVSUXSEG8EI64_V_M4_M1, VSUXSEG8EI64_V, 0x0 }, // 12262
  { PseudoVSUXSEG8EI64_V_M4_M1_MASK, VSUXSEG8EI64_V, 0x0 }, // 12263
  { PseudoVSUXSEG8EI64_V_M8_M1, VSUXSEG8EI64_V, 0x0 }, // 12264
  { PseudoVSUXSEG8EI64_V_M8_M1_MASK, VSUXSEG8EI64_V, 0x0 }, // 12265
  { PseudoVSUXSEG8EI64_V_M1_MF8, VSUXSEG8EI64_V, 0x5 }, // 12266
  { PseudoVSUXSEG8EI64_V_M1_MF8_MASK, VSUXSEG8EI64_V, 0x5 }, // 12267
  { PseudoVSUXSEG8EI64_V_M1_MF4, VSUXSEG8EI64_V, 0x6 }, // 12268
  { PseudoVSUXSEG8EI64_V_M1_MF4_MASK, VSUXSEG8EI64_V, 0x6 }, // 12269
  { PseudoVSUXSEG8EI64_V_M2_MF4, VSUXSEG8EI64_V, 0x6 }, // 12270
  { PseudoVSUXSEG8EI64_V_M2_MF4_MASK, VSUXSEG8EI64_V, 0x6 }, // 12271
  { PseudoVSUXSEG8EI64_V_M1_MF2, VSUXSEG8EI64_V, 0x7 }, // 12272
  { PseudoVSUXSEG8EI64_V_M1_MF2_MASK, VSUXSEG8EI64_V, 0x7 }, // 12273
  { PseudoVSUXSEG8EI64_V_M2_MF2, VSUXSEG8EI64_V, 0x7 }, // 12274
  { PseudoVSUXSEG8EI64_V_M2_MF2_MASK, VSUXSEG8EI64_V, 0x7 }, // 12275
  { PseudoVSUXSEG8EI64_V_M4_MF2, VSUXSEG8EI64_V, 0x7 }, // 12276
  { PseudoVSUXSEG8EI64_V_M4_MF2_MASK, VSUXSEG8EI64_V, 0x7 }, // 12277
  { PseudoVSUXSEG8EI8_V_M1_M1, VSUXSEG8EI8_V, 0x0 }, // 12278
  { PseudoVSUXSEG8EI8_V_M1_M1_MASK, VSUXSEG8EI8_V, 0x0 }, // 12279
  { PseudoVSUXSEG8EI8_V_MF2_M1, VSUXSEG8EI8_V, 0x0 }, // 12280
  { PseudoVSUXSEG8EI8_V_MF2_M1_MASK, VSUXSEG8EI8_V, 0x0 }, // 12281
  { PseudoVSUXSEG8EI8_V_MF4_M1, VSUXSEG8EI8_V, 0x0 }, // 12282
  { PseudoVSUXSEG8EI8_V_MF4_M1_MASK, VSUXSEG8EI8_V, 0x0 }, // 12283
  { PseudoVSUXSEG8EI8_V_MF8_M1, VSUXSEG8EI8_V, 0x0 }, // 12284
  { PseudoVSUXSEG8EI8_V_MF8_M1_MASK, VSUXSEG8EI8_V, 0x0 }, // 12285
  { PseudoVSUXSEG8EI8_V_MF8_MF8, VSUXSEG8EI8_V, 0x5 }, // 12286
  { PseudoVSUXSEG8EI8_V_MF8_MF8_MASK, VSUXSEG8EI8_V, 0x5 }, // 12287
  { PseudoVSUXSEG8EI8_V_MF4_MF4, VSUXSEG8EI8_V, 0x6 }, // 12288
  { PseudoVSUXSEG8EI8_V_MF4_MF4_MASK, VSUXSEG8EI8_V, 0x6 }, // 12289
  { PseudoVSUXSEG8EI8_V_MF8_MF4, VSUXSEG8EI8_V, 0x6 }, // 12290
  { PseudoVSUXSEG8EI8_V_MF8_MF4_MASK, VSUXSEG8EI8_V, 0x6 }, // 12291
  { PseudoVSUXSEG8EI8_V_MF2_MF2, VSUXSEG8EI8_V, 0x7 }, // 12292
  { PseudoVSUXSEG8EI8_V_MF2_MF2_MASK, VSUXSEG8EI8_V, 0x7 }, // 12293
  { PseudoVSUXSEG8EI8_V_MF4_MF2, VSUXSEG8EI8_V, 0x7 }, // 12294
  { PseudoVSUXSEG8EI8_V_MF4_MF2_MASK, VSUXSEG8EI8_V, 0x7 }, // 12295
  { PseudoVSUXSEG8EI8_V_MF8_MF2, VSUXSEG8EI8_V, 0x7 }, // 12296
  { PseudoVSUXSEG8EI8_V_MF8_MF2_MASK, VSUXSEG8EI8_V, 0x7 }, // 12297
  { PseudoVWADDU_VV_M1, VWADDU_VV, 0x0 }, // 12298
  { PseudoVWADDU_VV_M1_MASK, VWADDU_VV, 0x0 }, // 12299
  { PseudoVWADDU_VV_M1_TU, VWADDU_VV, 0x0 }, // 12300
  { PseudoVWADDU_VV_M2, VWADDU_VV, 0x1 }, // 12301
  { PseudoVWADDU_VV_M2_MASK, VWADDU_VV, 0x1 }, // 12302
  { PseudoVWADDU_VV_M2_TU, VWADDU_VV, 0x1 }, // 12303
  { PseudoVWADDU_VV_M4, VWADDU_VV, 0x2 }, // 12304
  { PseudoVWADDU_VV_M4_MASK, VWADDU_VV, 0x2 }, // 12305
  { PseudoVWADDU_VV_M4_TU, VWADDU_VV, 0x2 }, // 12306
  { PseudoVWADDU_VV_MF8, VWADDU_VV, 0x5 }, // 12307
  { PseudoVWADDU_VV_MF8_MASK, VWADDU_VV, 0x5 }, // 12308
  { PseudoVWADDU_VV_MF8_TU, VWADDU_VV, 0x5 }, // 12309
  { PseudoVWADDU_VV_MF4, VWADDU_VV, 0x6 }, // 12310
  { PseudoVWADDU_VV_MF4_MASK, VWADDU_VV, 0x6 }, // 12311
  { PseudoVWADDU_VV_MF4_TU, VWADDU_VV, 0x6 }, // 12312
  { PseudoVWADDU_VV_MF2, VWADDU_VV, 0x7 }, // 12313
  { PseudoVWADDU_VV_MF2_MASK, VWADDU_VV, 0x7 }, // 12314
  { PseudoVWADDU_VV_MF2_TU, VWADDU_VV, 0x7 }, // 12315
  { PseudoVWADDU_VX_M1, VWADDU_VX, 0x0 }, // 12316
  { PseudoVWADDU_VX_M1_MASK, VWADDU_VX, 0x0 }, // 12317
  { PseudoVWADDU_VX_M1_TU, VWADDU_VX, 0x0 }, // 12318
  { PseudoVWADDU_VX_M2, VWADDU_VX, 0x1 }, // 12319
  { PseudoVWADDU_VX_M2_MASK, VWADDU_VX, 0x1 }, // 12320
  { PseudoVWADDU_VX_M2_TU, VWADDU_VX, 0x1 }, // 12321
  { PseudoVWADDU_VX_M4, VWADDU_VX, 0x2 }, // 12322
  { PseudoVWADDU_VX_M4_MASK, VWADDU_VX, 0x2 }, // 12323
  { PseudoVWADDU_VX_M4_TU, VWADDU_VX, 0x2 }, // 12324
  { PseudoVWADDU_VX_MF8, VWADDU_VX, 0x5 }, // 12325
  { PseudoVWADDU_VX_MF8_MASK, VWADDU_VX, 0x5 }, // 12326
  { PseudoVWADDU_VX_MF8_TU, VWADDU_VX, 0x5 }, // 12327
  { PseudoVWADDU_VX_MF4, VWADDU_VX, 0x6 }, // 12328
  { PseudoVWADDU_VX_MF4_MASK, VWADDU_VX, 0x6 }, // 12329
  { PseudoVWADDU_VX_MF4_TU, VWADDU_VX, 0x6 }, // 12330
  { PseudoVWADDU_VX_MF2, VWADDU_VX, 0x7 }, // 12331
  { PseudoVWADDU_VX_MF2_MASK, VWADDU_VX, 0x7 }, // 12332
  { PseudoVWADDU_VX_MF2_TU, VWADDU_VX, 0x7 }, // 12333
  { PseudoVWADDU_WV_M1, VWADDU_WV, 0x0 }, // 12334
  { PseudoVWADDU_WV_M1_MASK, VWADDU_WV, 0x0 }, // 12335
  { PseudoVWADDU_WV_M1_MASK_TIED, VWADDU_WV, 0x0 }, // 12336
  { PseudoVWADDU_WV_M1_TIED, VWADDU_WV, 0x0 }, // 12337
  { PseudoVWADDU_WV_M1_TU, VWADDU_WV, 0x0 }, // 12338
  { PseudoVWADDU_WV_M2, VWADDU_WV, 0x1 }, // 12339
  { PseudoVWADDU_WV_M2_MASK, VWADDU_WV, 0x1 }, // 12340
  { PseudoVWADDU_WV_M2_MASK_TIED, VWADDU_WV, 0x1 }, // 12341
  { PseudoVWADDU_WV_M2_TIED, VWADDU_WV, 0x1 }, // 12342
  { PseudoVWADDU_WV_M2_TU, VWADDU_WV, 0x1 }, // 12343
  { PseudoVWADDU_WV_M4, VWADDU_WV, 0x2 }, // 12344
  { PseudoVWADDU_WV_M4_MASK, VWADDU_WV, 0x2 }, // 12345
  { PseudoVWADDU_WV_M4_MASK_TIED, VWADDU_WV, 0x2 }, // 12346
  { PseudoVWADDU_WV_M4_TIED, VWADDU_WV, 0x2 }, // 12347
  { PseudoVWADDU_WV_M4_TU, VWADDU_WV, 0x2 }, // 12348
  { PseudoVWADDU_WV_MF8, VWADDU_WV, 0x5 }, // 12349
  { PseudoVWADDU_WV_MF8_MASK, VWADDU_WV, 0x5 }, // 12350
  { PseudoVWADDU_WV_MF8_MASK_TIED, VWADDU_WV, 0x5 }, // 12351
  { PseudoVWADDU_WV_MF8_TIED, VWADDU_WV, 0x5 }, // 12352
  { PseudoVWADDU_WV_MF8_TU, VWADDU_WV, 0x5 }, // 12353
  { PseudoVWADDU_WV_MF4, VWADDU_WV, 0x6 }, // 12354
  { PseudoVWADDU_WV_MF4_MASK, VWADDU_WV, 0x6 }, // 12355
  { PseudoVWADDU_WV_MF4_MASK_TIED, VWADDU_WV, 0x6 }, // 12356
  { PseudoVWADDU_WV_MF4_TIED, VWADDU_WV, 0x6 }, // 12357
  { PseudoVWADDU_WV_MF4_TU, VWADDU_WV, 0x6 }, // 12358
  { PseudoVWADDU_WV_MF2, VWADDU_WV, 0x7 }, // 12359
  { PseudoVWADDU_WV_MF2_MASK, VWADDU_WV, 0x7 }, // 12360
  { PseudoVWADDU_WV_MF2_MASK_TIED, VWADDU_WV, 0x7 }, // 12361
  { PseudoVWADDU_WV_MF2_TIED, VWADDU_WV, 0x7 }, // 12362
  { PseudoVWADDU_WV_MF2_TU, VWADDU_WV, 0x7 }, // 12363
  { PseudoVWADDU_WX_M1, VWADDU_WX, 0x0 }, // 12364
  { PseudoVWADDU_WX_M1_MASK, VWADDU_WX, 0x0 }, // 12365
  { PseudoVWADDU_WX_M1_TU, VWADDU_WX, 0x0 }, // 12366
  { PseudoVWADDU_WX_M2, VWADDU_WX, 0x1 }, // 12367
  { PseudoVWADDU_WX_M2_MASK, VWADDU_WX, 0x1 }, // 12368
  { PseudoVWADDU_WX_M2_TU, VWADDU_WX, 0x1 }, // 12369
  { PseudoVWADDU_WX_M4, VWADDU_WX, 0x2 }, // 12370
  { PseudoVWADDU_WX_M4_MASK, VWADDU_WX, 0x2 }, // 12371
  { PseudoVWADDU_WX_M4_TU, VWADDU_WX, 0x2 }, // 12372
  { PseudoVWADDU_WX_MF8, VWADDU_WX, 0x5 }, // 12373
  { PseudoVWADDU_WX_MF8_MASK, VWADDU_WX, 0x5 }, // 12374
  { PseudoVWADDU_WX_MF8_TU, VWADDU_WX, 0x5 }, // 12375
  { PseudoVWADDU_WX_MF4, VWADDU_WX, 0x6 }, // 12376
  { PseudoVWADDU_WX_MF4_MASK, VWADDU_WX, 0x6 }, // 12377
  { PseudoVWADDU_WX_MF4_TU, VWADDU_WX, 0x6 }, // 12378
  { PseudoVWADDU_WX_MF2, VWADDU_WX, 0x7 }, // 12379
  { PseudoVWADDU_WX_MF2_MASK, VWADDU_WX, 0x7 }, // 12380
  { PseudoVWADDU_WX_MF2_TU, VWADDU_WX, 0x7 }, // 12381
  { PseudoVWADD_VV_M1, VWADD_VV, 0x0 }, // 12382
  { PseudoVWADD_VV_M1_MASK, VWADD_VV, 0x0 }, // 12383
  { PseudoVWADD_VV_M1_TU, VWADD_VV, 0x0 }, // 12384
  { PseudoVWADD_VV_M2, VWADD_VV, 0x1 }, // 12385
  { PseudoVWADD_VV_M2_MASK, VWADD_VV, 0x1 }, // 12386
  { PseudoVWADD_VV_M2_TU, VWADD_VV, 0x1 }, // 12387
  { PseudoVWADD_VV_M4, VWADD_VV, 0x2 }, // 12388
  { PseudoVWADD_VV_M4_MASK, VWADD_VV, 0x2 }, // 12389
  { PseudoVWADD_VV_M4_TU, VWADD_VV, 0x2 }, // 12390
  { PseudoVWADD_VV_MF8, VWADD_VV, 0x5 }, // 12391
  { PseudoVWADD_VV_MF8_MASK, VWADD_VV, 0x5 }, // 12392
  { PseudoVWADD_VV_MF8_TU, VWADD_VV, 0x5 }, // 12393
  { PseudoVWADD_VV_MF4, VWADD_VV, 0x6 }, // 12394
  { PseudoVWADD_VV_MF4_MASK, VWADD_VV, 0x6 }, // 12395
  { PseudoVWADD_VV_MF4_TU, VWADD_VV, 0x6 }, // 12396
  { PseudoVWADD_VV_MF2, VWADD_VV, 0x7 }, // 12397
  { PseudoVWADD_VV_MF2_MASK, VWADD_VV, 0x7 }, // 12398
  { PseudoVWADD_VV_MF2_TU, VWADD_VV, 0x7 }, // 12399
  { PseudoVWADD_VX_M1, VWADD_VX, 0x0 }, // 12400
  { PseudoVWADD_VX_M1_MASK, VWADD_VX, 0x0 }, // 12401
  { PseudoVWADD_VX_M1_TU, VWADD_VX, 0x0 }, // 12402
  { PseudoVWADD_VX_M2, VWADD_VX, 0x1 }, // 12403
  { PseudoVWADD_VX_M2_MASK, VWADD_VX, 0x1 }, // 12404
  { PseudoVWADD_VX_M2_TU, VWADD_VX, 0x1 }, // 12405
  { PseudoVWADD_VX_M4, VWADD_VX, 0x2 }, // 12406
  { PseudoVWADD_VX_M4_MASK, VWADD_VX, 0x2 }, // 12407
  { PseudoVWADD_VX_M4_TU, VWADD_VX, 0x2 }, // 12408
  { PseudoVWADD_VX_MF8, VWADD_VX, 0x5 }, // 12409
  { PseudoVWADD_VX_MF8_MASK, VWADD_VX, 0x5 }, // 12410
  { PseudoVWADD_VX_MF8_TU, VWADD_VX, 0x5 }, // 12411
  { PseudoVWADD_VX_MF4, VWADD_VX, 0x6 }, // 12412
  { PseudoVWADD_VX_MF4_MASK, VWADD_VX, 0x6 }, // 12413
  { PseudoVWADD_VX_MF4_TU, VWADD_VX, 0x6 }, // 12414
  { PseudoVWADD_VX_MF2, VWADD_VX, 0x7 }, // 12415
  { PseudoVWADD_VX_MF2_MASK, VWADD_VX, 0x7 }, // 12416
  { PseudoVWADD_VX_MF2_TU, VWADD_VX, 0x7 }, // 12417
  { PseudoVWADD_WV_M1, VWADD_WV, 0x0 }, // 12418
  { PseudoVWADD_WV_M1_MASK, VWADD_WV, 0x0 }, // 12419
  { PseudoVWADD_WV_M1_MASK_TIED, VWADD_WV, 0x0 }, // 12420
  { PseudoVWADD_WV_M1_TIED, VWADD_WV, 0x0 }, // 12421
  { PseudoVWADD_WV_M1_TU, VWADD_WV, 0x0 }, // 12422
  { PseudoVWADD_WV_M2, VWADD_WV, 0x1 }, // 12423
  { PseudoVWADD_WV_M2_MASK, VWADD_WV, 0x1 }, // 12424
  { PseudoVWADD_WV_M2_MASK_TIED, VWADD_WV, 0x1 }, // 12425
  { PseudoVWADD_WV_M2_TIED, VWADD_WV, 0x1 }, // 12426
  { PseudoVWADD_WV_M2_TU, VWADD_WV, 0x1 }, // 12427
  { PseudoVWADD_WV_M4, VWADD_WV, 0x2 }, // 12428
  { PseudoVWADD_WV_M4_MASK, VWADD_WV, 0x2 }, // 12429
  { PseudoVWADD_WV_M4_MASK_TIED, VWADD_WV, 0x2 }, // 12430
  { PseudoVWADD_WV_M4_TIED, VWADD_WV, 0x2 }, // 12431
  { PseudoVWADD_WV_M4_TU, VWADD_WV, 0x2 }, // 12432
  { PseudoVWADD_WV_MF8, VWADD_WV, 0x5 }, // 12433
  { PseudoVWADD_WV_MF8_MASK, VWADD_WV, 0x5 }, // 12434
  { PseudoVWADD_WV_MF8_MASK_TIED, VWADD_WV, 0x5 }, // 12435
  { PseudoVWADD_WV_MF8_TIED, VWADD_WV, 0x5 }, // 12436
  { PseudoVWADD_WV_MF8_TU, VWADD_WV, 0x5 }, // 12437
  { PseudoVWADD_WV_MF4, VWADD_WV, 0x6 }, // 12438
  { PseudoVWADD_WV_MF4_MASK, VWADD_WV, 0x6 }, // 12439
  { PseudoVWADD_WV_MF4_MASK_TIED, VWADD_WV, 0x6 }, // 12440
  { PseudoVWADD_WV_MF4_TIED, VWADD_WV, 0x6 }, // 12441
  { PseudoVWADD_WV_MF4_TU, VWADD_WV, 0x6 }, // 12442
  { PseudoVWADD_WV_MF2, VWADD_WV, 0x7 }, // 12443
  { PseudoVWADD_WV_MF2_MASK, VWADD_WV, 0x7 }, // 12444
  { PseudoVWADD_WV_MF2_MASK_TIED, VWADD_WV, 0x7 }, // 12445
  { PseudoVWADD_WV_MF2_TIED, VWADD_WV, 0x7 }, // 12446
  { PseudoVWADD_WV_MF2_TU, VWADD_WV, 0x7 }, // 12447
  { PseudoVWADD_WX_M1, VWADD_WX, 0x0 }, // 12448
  { PseudoVWADD_WX_M1_MASK, VWADD_WX, 0x0 }, // 12449
  { PseudoVWADD_WX_M1_TU, VWADD_WX, 0x0 }, // 12450
  { PseudoVWADD_WX_M2, VWADD_WX, 0x1 }, // 12451
  { PseudoVWADD_WX_M2_MASK, VWADD_WX, 0x1 }, // 12452
  { PseudoVWADD_WX_M2_TU, VWADD_WX, 0x1 }, // 12453
  { PseudoVWADD_WX_M4, VWADD_WX, 0x2 }, // 12454
  { PseudoVWADD_WX_M4_MASK, VWADD_WX, 0x2 }, // 12455
  { PseudoVWADD_WX_M4_TU, VWADD_WX, 0x2 }, // 12456
  { PseudoVWADD_WX_MF8, VWADD_WX, 0x5 }, // 12457
  { PseudoVWADD_WX_MF8_MASK, VWADD_WX, 0x5 }, // 12458
  { PseudoVWADD_WX_MF8_TU, VWADD_WX, 0x5 }, // 12459
  { PseudoVWADD_WX_MF4, VWADD_WX, 0x6 }, // 12460
  { PseudoVWADD_WX_MF4_MASK, VWADD_WX, 0x6 }, // 12461
  { PseudoVWADD_WX_MF4_TU, VWADD_WX, 0x6 }, // 12462
  { PseudoVWADD_WX_MF2, VWADD_WX, 0x7 }, // 12463
  { PseudoVWADD_WX_MF2_MASK, VWADD_WX, 0x7 }, // 12464
  { PseudoVWADD_WX_MF2_TU, VWADD_WX, 0x7 }, // 12465
  { PseudoVWMACCSU_VV_M1, VWMACCSU_VV, 0x0 }, // 12466
  { PseudoVWMACCSU_VV_M1_MASK, VWMACCSU_VV, 0x0 }, // 12467
  { PseudoVWMACCSU_VV_M2, VWMACCSU_VV, 0x1 }, // 12468
  { PseudoVWMACCSU_VV_M2_MASK, VWMACCSU_VV, 0x1 }, // 12469
  { PseudoVWMACCSU_VV_M4, VWMACCSU_VV, 0x2 }, // 12470
  { PseudoVWMACCSU_VV_M4_MASK, VWMACCSU_VV, 0x2 }, // 12471
  { PseudoVWMACCSU_VV_MF8, VWMACCSU_VV, 0x5 }, // 12472
  { PseudoVWMACCSU_VV_MF8_MASK, VWMACCSU_VV, 0x5 }, // 12473
  { PseudoVWMACCSU_VV_MF4, VWMACCSU_VV, 0x6 }, // 12474
  { PseudoVWMACCSU_VV_MF4_MASK, VWMACCSU_VV, 0x6 }, // 12475
  { PseudoVWMACCSU_VV_MF2, VWMACCSU_VV, 0x7 }, // 12476
  { PseudoVWMACCSU_VV_MF2_MASK, VWMACCSU_VV, 0x7 }, // 12477
  { PseudoVWMACCSU_VX_M1, VWMACCSU_VX, 0x0 }, // 12478
  { PseudoVWMACCSU_VX_M1_MASK, VWMACCSU_VX, 0x0 }, // 12479
  { PseudoVWMACCSU_VX_M2, VWMACCSU_VX, 0x1 }, // 12480
  { PseudoVWMACCSU_VX_M2_MASK, VWMACCSU_VX, 0x1 }, // 12481
  { PseudoVWMACCSU_VX_M4, VWMACCSU_VX, 0x2 }, // 12482
  { PseudoVWMACCSU_VX_M4_MASK, VWMACCSU_VX, 0x2 }, // 12483
  { PseudoVWMACCSU_VX_MF8, VWMACCSU_VX, 0x5 }, // 12484
  { PseudoVWMACCSU_VX_MF8_MASK, VWMACCSU_VX, 0x5 }, // 12485
  { PseudoVWMACCSU_VX_MF4, VWMACCSU_VX, 0x6 }, // 12486
  { PseudoVWMACCSU_VX_MF4_MASK, VWMACCSU_VX, 0x6 }, // 12487
  { PseudoVWMACCSU_VX_MF2, VWMACCSU_VX, 0x7 }, // 12488
  { PseudoVWMACCSU_VX_MF2_MASK, VWMACCSU_VX, 0x7 }, // 12489
  { PseudoVWMACCUS_VX_M1, VWMACCUS_VX, 0x0 }, // 12490
  { PseudoVWMACCUS_VX_M1_MASK, VWMACCUS_VX, 0x0 }, // 12491
  { PseudoVWMACCUS_VX_M2, VWMACCUS_VX, 0x1 }, // 12492
  { PseudoVWMACCUS_VX_M2_MASK, VWMACCUS_VX, 0x1 }, // 12493
  { PseudoVWMACCUS_VX_M4, VWMACCUS_VX, 0x2 }, // 12494
  { PseudoVWMACCUS_VX_M4_MASK, VWMACCUS_VX, 0x2 }, // 12495
  { PseudoVWMACCUS_VX_MF8, VWMACCUS_VX, 0x5 }, // 12496
  { PseudoVWMACCUS_VX_MF8_MASK, VWMACCUS_VX, 0x5 }, // 12497
  { PseudoVWMACCUS_VX_MF4, VWMACCUS_VX, 0x6 }, // 12498
  { PseudoVWMACCUS_VX_MF4_MASK, VWMACCUS_VX, 0x6 }, // 12499
  { PseudoVWMACCUS_VX_MF2, VWMACCUS_VX, 0x7 }, // 12500
  { PseudoVWMACCUS_VX_MF2_MASK, VWMACCUS_VX, 0x7 }, // 12501
  { PseudoVWMACCU_VV_M1, VWMACCU_VV, 0x0 }, // 12502
  { PseudoVWMACCU_VV_M1_MASK, VWMACCU_VV, 0x0 }, // 12503
  { PseudoVWMACCU_VV_M2, VWMACCU_VV, 0x1 }, // 12504
  { PseudoVWMACCU_VV_M2_MASK, VWMACCU_VV, 0x1 }, // 12505
  { PseudoVWMACCU_VV_M4, VWMACCU_VV, 0x2 }, // 12506
  { PseudoVWMACCU_VV_M4_MASK, VWMACCU_VV, 0x2 }, // 12507
  { PseudoVWMACCU_VV_MF8, VWMACCU_VV, 0x5 }, // 12508
  { PseudoVWMACCU_VV_MF8_MASK, VWMACCU_VV, 0x5 }, // 12509
  { PseudoVWMACCU_VV_MF4, VWMACCU_VV, 0x6 }, // 12510
  { PseudoVWMACCU_VV_MF4_MASK, VWMACCU_VV, 0x6 }, // 12511
  { PseudoVWMACCU_VV_MF2, VWMACCU_VV, 0x7 }, // 12512
  { PseudoVWMACCU_VV_MF2_MASK, VWMACCU_VV, 0x7 }, // 12513
  { PseudoVWMACCU_VX_M1, VWMACCU_VX, 0x0 }, // 12514
  { PseudoVWMACCU_VX_M1_MASK, VWMACCU_VX, 0x0 }, // 12515
  { PseudoVWMACCU_VX_M2, VWMACCU_VX, 0x1 }, // 12516
  { PseudoVWMACCU_VX_M2_MASK, VWMACCU_VX, 0x1 }, // 12517
  { PseudoVWMACCU_VX_M4, VWMACCU_VX, 0x2 }, // 12518
  { PseudoVWMACCU_VX_M4_MASK, VWMACCU_VX, 0x2 }, // 12519
  { PseudoVWMACCU_VX_MF8, VWMACCU_VX, 0x5 }, // 12520
  { PseudoVWMACCU_VX_MF8_MASK, VWMACCU_VX, 0x5 }, // 12521
  { PseudoVWMACCU_VX_MF4, VWMACCU_VX, 0x6 }, // 12522
  { PseudoVWMACCU_VX_MF4_MASK, VWMACCU_VX, 0x6 }, // 12523
  { PseudoVWMACCU_VX_MF2, VWMACCU_VX, 0x7 }, // 12524
  { PseudoVWMACCU_VX_MF2_MASK, VWMACCU_VX, 0x7 }, // 12525
  { PseudoVWMACC_VV_M1, VWMACC_VV, 0x0 }, // 12526
  { PseudoVWMACC_VV_M1_MASK, VWMACC_VV, 0x0 }, // 12527
  { PseudoVWMACC_VV_M2, VWMACC_VV, 0x1 }, // 12528
  { PseudoVWMACC_VV_M2_MASK, VWMACC_VV, 0x1 }, // 12529
  { PseudoVWMACC_VV_M4, VWMACC_VV, 0x2 }, // 12530
  { PseudoVWMACC_VV_M4_MASK, VWMACC_VV, 0x2 }, // 12531
  { PseudoVWMACC_VV_MF8, VWMACC_VV, 0x5 }, // 12532
  { PseudoVWMACC_VV_MF8_MASK, VWMACC_VV, 0x5 }, // 12533
  { PseudoVWMACC_VV_MF4, VWMACC_VV, 0x6 }, // 12534
  { PseudoVWMACC_VV_MF4_MASK, VWMACC_VV, 0x6 }, // 12535
  { PseudoVWMACC_VV_MF2, VWMACC_VV, 0x7 }, // 12536
  { PseudoVWMACC_VV_MF2_MASK, VWMACC_VV, 0x7 }, // 12537
  { PseudoVWMACC_VX_M1, VWMACC_VX, 0x0 }, // 12538
  { PseudoVWMACC_VX_M1_MASK, VWMACC_VX, 0x0 }, // 12539
  { PseudoVWMACC_VX_M2, VWMACC_VX, 0x1 }, // 12540
  { PseudoVWMACC_VX_M2_MASK, VWMACC_VX, 0x1 }, // 12541
  { PseudoVWMACC_VX_M4, VWMACC_VX, 0x2 }, // 12542
  { PseudoVWMACC_VX_M4_MASK, VWMACC_VX, 0x2 }, // 12543
  { PseudoVWMACC_VX_MF8, VWMACC_VX, 0x5 }, // 12544
  { PseudoVWMACC_VX_MF8_MASK, VWMACC_VX, 0x5 }, // 12545
  { PseudoVWMACC_VX_MF4, VWMACC_VX, 0x6 }, // 12546
  { PseudoVWMACC_VX_MF4_MASK, VWMACC_VX, 0x6 }, // 12547
  { PseudoVWMACC_VX_MF2, VWMACC_VX, 0x7 }, // 12548
  { PseudoVWMACC_VX_MF2_MASK, VWMACC_VX, 0x7 }, // 12549
  { PseudoVWMULSU_VV_M1, VWMULSU_VV, 0x0 }, // 12550
  { PseudoVWMULSU_VV_M1_MASK, VWMULSU_VV, 0x0 }, // 12551
  { PseudoVWMULSU_VV_M1_TU, VWMULSU_VV, 0x0 }, // 12552
  { PseudoVWMULSU_VV_M2, VWMULSU_VV, 0x1 }, // 12553
  { PseudoVWMULSU_VV_M2_MASK, VWMULSU_VV, 0x1 }, // 12554
  { PseudoVWMULSU_VV_M2_TU, VWMULSU_VV, 0x1 }, // 12555
  { PseudoVWMULSU_VV_M4, VWMULSU_VV, 0x2 }, // 12556
  { PseudoVWMULSU_VV_M4_MASK, VWMULSU_VV, 0x2 }, // 12557
  { PseudoVWMULSU_VV_M4_TU, VWMULSU_VV, 0x2 }, // 12558
  { PseudoVWMULSU_VV_MF8, VWMULSU_VV, 0x5 }, // 12559
  { PseudoVWMULSU_VV_MF8_MASK, VWMULSU_VV, 0x5 }, // 12560
  { PseudoVWMULSU_VV_MF8_TU, VWMULSU_VV, 0x5 }, // 12561
  { PseudoVWMULSU_VV_MF4, VWMULSU_VV, 0x6 }, // 12562
  { PseudoVWMULSU_VV_MF4_MASK, VWMULSU_VV, 0x6 }, // 12563
  { PseudoVWMULSU_VV_MF4_TU, VWMULSU_VV, 0x6 }, // 12564
  { PseudoVWMULSU_VV_MF2, VWMULSU_VV, 0x7 }, // 12565
  { PseudoVWMULSU_VV_MF2_MASK, VWMULSU_VV, 0x7 }, // 12566
  { PseudoVWMULSU_VV_MF2_TU, VWMULSU_VV, 0x7 }, // 12567
  { PseudoVWMULSU_VX_M1, VWMULSU_VX, 0x0 }, // 12568
  { PseudoVWMULSU_VX_M1_MASK, VWMULSU_VX, 0x0 }, // 12569
  { PseudoVWMULSU_VX_M1_TU, VWMULSU_VX, 0x0 }, // 12570
  { PseudoVWMULSU_VX_M2, VWMULSU_VX, 0x1 }, // 12571
  { PseudoVWMULSU_VX_M2_MASK, VWMULSU_VX, 0x1 }, // 12572
  { PseudoVWMULSU_VX_M2_TU, VWMULSU_VX, 0x1 }, // 12573
  { PseudoVWMULSU_VX_M4, VWMULSU_VX, 0x2 }, // 12574
  { PseudoVWMULSU_VX_M4_MASK, VWMULSU_VX, 0x2 }, // 12575
  { PseudoVWMULSU_VX_M4_TU, VWMULSU_VX, 0x2 }, // 12576
  { PseudoVWMULSU_VX_MF8, VWMULSU_VX, 0x5 }, // 12577
  { PseudoVWMULSU_VX_MF8_MASK, VWMULSU_VX, 0x5 }, // 12578
  { PseudoVWMULSU_VX_MF8_TU, VWMULSU_VX, 0x5 }, // 12579
  { PseudoVWMULSU_VX_MF4, VWMULSU_VX, 0x6 }, // 12580
  { PseudoVWMULSU_VX_MF4_MASK, VWMULSU_VX, 0x6 }, // 12581
  { PseudoVWMULSU_VX_MF4_TU, VWMULSU_VX, 0x6 }, // 12582
  { PseudoVWMULSU_VX_MF2, VWMULSU_VX, 0x7 }, // 12583
  { PseudoVWMULSU_VX_MF2_MASK, VWMULSU_VX, 0x7 }, // 12584
  { PseudoVWMULSU_VX_MF2_TU, VWMULSU_VX, 0x7 }, // 12585
  { PseudoVWMULU_VV_M1, VWMULU_VV, 0x0 }, // 12586
  { PseudoVWMULU_VV_M1_MASK, VWMULU_VV, 0x0 }, // 12587
  { PseudoVWMULU_VV_M1_TU, VWMULU_VV, 0x0 }, // 12588
  { PseudoVWMULU_VV_M2, VWMULU_VV, 0x1 }, // 12589
  { PseudoVWMULU_VV_M2_MASK, VWMULU_VV, 0x1 }, // 12590
  { PseudoVWMULU_VV_M2_TU, VWMULU_VV, 0x1 }, // 12591
  { PseudoVWMULU_VV_M4, VWMULU_VV, 0x2 }, // 12592
  { PseudoVWMULU_VV_M4_MASK, VWMULU_VV, 0x2 }, // 12593
  { PseudoVWMULU_VV_M4_TU, VWMULU_VV, 0x2 }, // 12594
  { PseudoVWMULU_VV_MF8, VWMULU_VV, 0x5 }, // 12595
  { PseudoVWMULU_VV_MF8_MASK, VWMULU_VV, 0x5 }, // 12596
  { PseudoVWMULU_VV_MF8_TU, VWMULU_VV, 0x5 }, // 12597
  { PseudoVWMULU_VV_MF4, VWMULU_VV, 0x6 }, // 12598
  { PseudoVWMULU_VV_MF4_MASK, VWMULU_VV, 0x6 }, // 12599
  { PseudoVWMULU_VV_MF4_TU, VWMULU_VV, 0x6 }, // 12600
  { PseudoVWMULU_VV_MF2, VWMULU_VV, 0x7 }, // 12601
  { PseudoVWMULU_VV_MF2_MASK, VWMULU_VV, 0x7 }, // 12602
  { PseudoVWMULU_VV_MF2_TU, VWMULU_VV, 0x7 }, // 12603
  { PseudoVWMULU_VX_M1, VWMULU_VX, 0x0 }, // 12604
  { PseudoVWMULU_VX_M1_MASK, VWMULU_VX, 0x0 }, // 12605
  { PseudoVWMULU_VX_M1_TU, VWMULU_VX, 0x0 }, // 12606
  { PseudoVWMULU_VX_M2, VWMULU_VX, 0x1 }, // 12607
  { PseudoVWMULU_VX_M2_MASK, VWMULU_VX, 0x1 }, // 12608
  { PseudoVWMULU_VX_M2_TU, VWMULU_VX, 0x1 }, // 12609
  { PseudoVWMULU_VX_M4, VWMULU_VX, 0x2 }, // 12610
  { PseudoVWMULU_VX_M4_MASK, VWMULU_VX, 0x2 }, // 12611
  { PseudoVWMULU_VX_M4_TU, VWMULU_VX, 0x2 }, // 12612
  { PseudoVWMULU_VX_MF8, VWMULU_VX, 0x5 }, // 12613
  { PseudoVWMULU_VX_MF8_MASK, VWMULU_VX, 0x5 }, // 12614
  { PseudoVWMULU_VX_MF8_TU, VWMULU_VX, 0x5 }, // 12615
  { PseudoVWMULU_VX_MF4, VWMULU_VX, 0x6 }, // 12616
  { PseudoVWMULU_VX_MF4_MASK, VWMULU_VX, 0x6 }, // 12617
  { PseudoVWMULU_VX_MF4_TU, VWMULU_VX, 0x6 }, // 12618
  { PseudoVWMULU_VX_MF2, VWMULU_VX, 0x7 }, // 12619
  { PseudoVWMULU_VX_MF2_MASK, VWMULU_VX, 0x7 }, // 12620
  { PseudoVWMULU_VX_MF2_TU, VWMULU_VX, 0x7 }, // 12621
  { PseudoVWMUL_VV_M1, VWMUL_VV, 0x0 }, // 12622
  { PseudoVWMUL_VV_M1_MASK, VWMUL_VV, 0x0 }, // 12623
  { PseudoVWMUL_VV_M1_TU, VWMUL_VV, 0x0 }, // 12624
  { PseudoVWMUL_VV_M2, VWMUL_VV, 0x1 }, // 12625
  { PseudoVWMUL_VV_M2_MASK, VWMUL_VV, 0x1 }, // 12626
  { PseudoVWMUL_VV_M2_TU, VWMUL_VV, 0x1 }, // 12627
  { PseudoVWMUL_VV_M4, VWMUL_VV, 0x2 }, // 12628
  { PseudoVWMUL_VV_M4_MASK, VWMUL_VV, 0x2 }, // 12629
  { PseudoVWMUL_VV_M4_TU, VWMUL_VV, 0x2 }, // 12630
  { PseudoVWMUL_VV_MF8, VWMUL_VV, 0x5 }, // 12631
  { PseudoVWMUL_VV_MF8_MASK, VWMUL_VV, 0x5 }, // 12632
  { PseudoVWMUL_VV_MF8_TU, VWMUL_VV, 0x5 }, // 12633
  { PseudoVWMUL_VV_MF4, VWMUL_VV, 0x6 }, // 12634
  { PseudoVWMUL_VV_MF4_MASK, VWMUL_VV, 0x6 }, // 12635
  { PseudoVWMUL_VV_MF4_TU, VWMUL_VV, 0x6 }, // 12636
  { PseudoVWMUL_VV_MF2, VWMUL_VV, 0x7 }, // 12637
  { PseudoVWMUL_VV_MF2_MASK, VWMUL_VV, 0x7 }, // 12638
  { PseudoVWMUL_VV_MF2_TU, VWMUL_VV, 0x7 }, // 12639
  { PseudoVWMUL_VX_M1, VWMUL_VX, 0x0 }, // 12640
  { PseudoVWMUL_VX_M1_MASK, VWMUL_VX, 0x0 }, // 12641
  { PseudoVWMUL_VX_M1_TU, VWMUL_VX, 0x0 }, // 12642
  { PseudoVWMUL_VX_M2, VWMUL_VX, 0x1 }, // 12643
  { PseudoVWMUL_VX_M2_MASK, VWMUL_VX, 0x1 }, // 12644
  { PseudoVWMUL_VX_M2_TU, VWMUL_VX, 0x1 }, // 12645
  { PseudoVWMUL_VX_M4, VWMUL_VX, 0x2 }, // 12646
  { PseudoVWMUL_VX_M4_MASK, VWMUL_VX, 0x2 }, // 12647
  { PseudoVWMUL_VX_M4_TU, VWMUL_VX, 0x2 }, // 12648
  { PseudoVWMUL_VX_MF8, VWMUL_VX, 0x5 }, // 12649
  { PseudoVWMUL_VX_MF8_MASK, VWMUL_VX, 0x5 }, // 12650
  { PseudoVWMUL_VX_MF8_TU, VWMUL_VX, 0x5 }, // 12651
  { PseudoVWMUL_VX_MF4, VWMUL_VX, 0x6 }, // 12652
  { PseudoVWMUL_VX_MF4_MASK, VWMUL_VX, 0x6 }, // 12653
  { PseudoVWMUL_VX_MF4_TU, VWMUL_VX, 0x6 }, // 12654
  { PseudoVWMUL_VX_MF2, VWMUL_VX, 0x7 }, // 12655
  { PseudoVWMUL_VX_MF2_MASK, VWMUL_VX, 0x7 }, // 12656
  { PseudoVWMUL_VX_MF2_TU, VWMUL_VX, 0x7 }, // 12657
  { PseudoVWREDSUMU_VS_M1_E16, VWREDSUMU_VS, 0x0 }, // 12658
  { PseudoVWREDSUMU_VS_M1_E16_MASK, VWREDSUMU_VS, 0x0 }, // 12659
  { PseudoVWREDSUMU_VS_M1_E32, VWREDSUMU_VS, 0x0 }, // 12660
  { PseudoVWREDSUMU_VS_M1_E32_MASK, VWREDSUMU_VS, 0x0 }, // 12661
  { PseudoVWREDSUMU_VS_M1_E8, VWREDSUMU_VS, 0x0 }, // 12662
  { PseudoVWREDSUMU_VS_M1_E8_MASK, VWREDSUMU_VS, 0x0 }, // 12663
  { PseudoVWREDSUMU_VS_M2_E16, VWREDSUMU_VS, 0x1 }, // 12664
  { PseudoVWREDSUMU_VS_M2_E16_MASK, VWREDSUMU_VS, 0x1 }, // 12665
  { PseudoVWREDSUMU_VS_M2_E32, VWREDSUMU_VS, 0x1 }, // 12666
  { PseudoVWREDSUMU_VS_M2_E32_MASK, VWREDSUMU_VS, 0x1 }, // 12667
  { PseudoVWREDSUMU_VS_M2_E8, VWREDSUMU_VS, 0x1 }, // 12668
  { PseudoVWREDSUMU_VS_M2_E8_MASK, VWREDSUMU_VS, 0x1 }, // 12669
  { PseudoVWREDSUMU_VS_M4_E16, VWREDSUMU_VS, 0x2 }, // 12670
  { PseudoVWREDSUMU_VS_M4_E16_MASK, VWREDSUMU_VS, 0x2 }, // 12671
  { PseudoVWREDSUMU_VS_M4_E32, VWREDSUMU_VS, 0x2 }, // 12672
  { PseudoVWREDSUMU_VS_M4_E32_MASK, VWREDSUMU_VS, 0x2 }, // 12673
  { PseudoVWREDSUMU_VS_M4_E8, VWREDSUMU_VS, 0x2 }, // 12674
  { PseudoVWREDSUMU_VS_M4_E8_MASK, VWREDSUMU_VS, 0x2 }, // 12675
  { PseudoVWREDSUMU_VS_M8_E16, VWREDSUMU_VS, 0x3 }, // 12676
  { PseudoVWREDSUMU_VS_M8_E16_MASK, VWREDSUMU_VS, 0x3 }, // 12677
  { PseudoVWREDSUMU_VS_M8_E32, VWREDSUMU_VS, 0x3 }, // 12678
  { PseudoVWREDSUMU_VS_M8_E32_MASK, VWREDSUMU_VS, 0x3 }, // 12679
  { PseudoVWREDSUMU_VS_M8_E8, VWREDSUMU_VS, 0x3 }, // 12680
  { PseudoVWREDSUMU_VS_M8_E8_MASK, VWREDSUMU_VS, 0x3 }, // 12681
  { PseudoVWREDSUMU_VS_MF8_E8, VWREDSUMU_VS, 0x5 }, // 12682
  { PseudoVWREDSUMU_VS_MF8_E8_MASK, VWREDSUMU_VS, 0x5 }, // 12683
  { PseudoVWREDSUMU_VS_MF4_E16, VWREDSUMU_VS, 0x6 }, // 12684
  { PseudoVWREDSUMU_VS_MF4_E16_MASK, VWREDSUMU_VS, 0x6 }, // 12685
  { PseudoVWREDSUMU_VS_MF4_E8, VWREDSUMU_VS, 0x6 }, // 12686
  { PseudoVWREDSUMU_VS_MF4_E8_MASK, VWREDSUMU_VS, 0x6 }, // 12687
  { PseudoVWREDSUMU_VS_MF2_E16, VWREDSUMU_VS, 0x7 }, // 12688
  { PseudoVWREDSUMU_VS_MF2_E16_MASK, VWREDSUMU_VS, 0x7 }, // 12689
  { PseudoVWREDSUMU_VS_MF2_E32, VWREDSUMU_VS, 0x7 }, // 12690
  { PseudoVWREDSUMU_VS_MF2_E32_MASK, VWREDSUMU_VS, 0x7 }, // 12691
  { PseudoVWREDSUMU_VS_MF2_E8, VWREDSUMU_VS, 0x7 }, // 12692
  { PseudoVWREDSUMU_VS_MF2_E8_MASK, VWREDSUMU_VS, 0x7 }, // 12693
  { PseudoVWREDSUM_VS_M1_E16, VWREDSUM_VS, 0x0 }, // 12694
  { PseudoVWREDSUM_VS_M1_E16_MASK, VWREDSUM_VS, 0x0 }, // 12695
  { PseudoVWREDSUM_VS_M1_E32, VWREDSUM_VS, 0x0 }, // 12696
  { PseudoVWREDSUM_VS_M1_E32_MASK, VWREDSUM_VS, 0x0 }, // 12697
  { PseudoVWREDSUM_VS_M1_E8, VWREDSUM_VS, 0x0 }, // 12698
  { PseudoVWREDSUM_VS_M1_E8_MASK, VWREDSUM_VS, 0x0 }, // 12699
  { PseudoVWREDSUM_VS_M2_E16, VWREDSUM_VS, 0x1 }, // 12700
  { PseudoVWREDSUM_VS_M2_E16_MASK, VWREDSUM_VS, 0x1 }, // 12701
  { PseudoVWREDSUM_VS_M2_E32, VWREDSUM_VS, 0x1 }, // 12702
  { PseudoVWREDSUM_VS_M2_E32_MASK, VWREDSUM_VS, 0x1 }, // 12703
  { PseudoVWREDSUM_VS_M2_E8, VWREDSUM_VS, 0x1 }, // 12704
  { PseudoVWREDSUM_VS_M2_E8_MASK, VWREDSUM_VS, 0x1 }, // 12705
  { PseudoVWREDSUM_VS_M4_E16, VWREDSUM_VS, 0x2 }, // 12706
  { PseudoVWREDSUM_VS_M4_E16_MASK, VWREDSUM_VS, 0x2 }, // 12707
  { PseudoVWREDSUM_VS_M4_E32, VWREDSUM_VS, 0x2 }, // 12708
  { PseudoVWREDSUM_VS_M4_E32_MASK, VWREDSUM_VS, 0x2 }, // 12709
  { PseudoVWREDSUM_VS_M4_E8, VWREDSUM_VS, 0x2 }, // 12710
  { PseudoVWREDSUM_VS_M4_E8_MASK, VWREDSUM_VS, 0x2 }, // 12711
  { PseudoVWREDSUM_VS_M8_E16, VWREDSUM_VS, 0x3 }, // 12712
  { PseudoVWREDSUM_VS_M8_E16_MASK, VWREDSUM_VS, 0x3 }, // 12713
  { PseudoVWREDSUM_VS_M8_E32, VWREDSUM_VS, 0x3 }, // 12714
  { PseudoVWREDSUM_VS_M8_E32_MASK, VWREDSUM_VS, 0x3 }, // 12715
  { PseudoVWREDSUM_VS_M8_E8, VWREDSUM_VS, 0x3 }, // 12716
  { PseudoVWREDSUM_VS_M8_E8_MASK, VWREDSUM_VS, 0x3 }, // 12717
  { PseudoVWREDSUM_VS_MF8_E8, VWREDSUM_VS, 0x5 }, // 12718
  { PseudoVWREDSUM_VS_MF8_E8_MASK, VWREDSUM_VS, 0x5 }, // 12719
  { PseudoVWREDSUM_VS_MF4_E16, VWREDSUM_VS, 0x6 }, // 12720
  { PseudoVWREDSUM_VS_MF4_E16_MASK, VWREDSUM_VS, 0x6 }, // 12721
  { PseudoVWREDSUM_VS_MF4_E8, VWREDSUM_VS, 0x6 }, // 12722
  { PseudoVWREDSUM_VS_MF4_E8_MASK, VWREDSUM_VS, 0x6 }, // 12723
  { PseudoVWREDSUM_VS_MF2_E16, VWREDSUM_VS, 0x7 }, // 12724
  { PseudoVWREDSUM_VS_MF2_E16_MASK, VWREDSUM_VS, 0x7 }, // 12725
  { PseudoVWREDSUM_VS_MF2_E32, VWREDSUM_VS, 0x7 }, // 12726
  { PseudoVWREDSUM_VS_MF2_E32_MASK, VWREDSUM_VS, 0x7 }, // 12727
  { PseudoVWREDSUM_VS_MF2_E8, VWREDSUM_VS, 0x7 }, // 12728
  { PseudoVWREDSUM_VS_MF2_E8_MASK, VWREDSUM_VS, 0x7 }, // 12729
  { PseudoVWSUBU_VV_M1, VWSUBU_VV, 0x0 }, // 12730
  { PseudoVWSUBU_VV_M1_MASK, VWSUBU_VV, 0x0 }, // 12731
  { PseudoVWSUBU_VV_M1_TU, VWSUBU_VV, 0x0 }, // 12732
  { PseudoVWSUBU_VV_M2, VWSUBU_VV, 0x1 }, // 12733
  { PseudoVWSUBU_VV_M2_MASK, VWSUBU_VV, 0x1 }, // 12734
  { PseudoVWSUBU_VV_M2_TU, VWSUBU_VV, 0x1 }, // 12735
  { PseudoVWSUBU_VV_M4, VWSUBU_VV, 0x2 }, // 12736
  { PseudoVWSUBU_VV_M4_MASK, VWSUBU_VV, 0x2 }, // 12737
  { PseudoVWSUBU_VV_M4_TU, VWSUBU_VV, 0x2 }, // 12738
  { PseudoVWSUBU_VV_MF8, VWSUBU_VV, 0x5 }, // 12739
  { PseudoVWSUBU_VV_MF8_MASK, VWSUBU_VV, 0x5 }, // 12740
  { PseudoVWSUBU_VV_MF8_TU, VWSUBU_VV, 0x5 }, // 12741
  { PseudoVWSUBU_VV_MF4, VWSUBU_VV, 0x6 }, // 12742
  { PseudoVWSUBU_VV_MF4_MASK, VWSUBU_VV, 0x6 }, // 12743
  { PseudoVWSUBU_VV_MF4_TU, VWSUBU_VV, 0x6 }, // 12744
  { PseudoVWSUBU_VV_MF2, VWSUBU_VV, 0x7 }, // 12745
  { PseudoVWSUBU_VV_MF2_MASK, VWSUBU_VV, 0x7 }, // 12746
  { PseudoVWSUBU_VV_MF2_TU, VWSUBU_VV, 0x7 }, // 12747
  { PseudoVWSUBU_VX_M1, VWSUBU_VX, 0x0 }, // 12748
  { PseudoVWSUBU_VX_M1_MASK, VWSUBU_VX, 0x0 }, // 12749
  { PseudoVWSUBU_VX_M1_TU, VWSUBU_VX, 0x0 }, // 12750
  { PseudoVWSUBU_VX_M2, VWSUBU_VX, 0x1 }, // 12751
  { PseudoVWSUBU_VX_M2_MASK, VWSUBU_VX, 0x1 }, // 12752
  { PseudoVWSUBU_VX_M2_TU, VWSUBU_VX, 0x1 }, // 12753
  { PseudoVWSUBU_VX_M4, VWSUBU_VX, 0x2 }, // 12754
  { PseudoVWSUBU_VX_M4_MASK, VWSUBU_VX, 0x2 }, // 12755
  { PseudoVWSUBU_VX_M4_TU, VWSUBU_VX, 0x2 }, // 12756
  { PseudoVWSUBU_VX_MF8, VWSUBU_VX, 0x5 }, // 12757
  { PseudoVWSUBU_VX_MF8_MASK, VWSUBU_VX, 0x5 }, // 12758
  { PseudoVWSUBU_VX_MF8_TU, VWSUBU_VX, 0x5 }, // 12759
  { PseudoVWSUBU_VX_MF4, VWSUBU_VX, 0x6 }, // 12760
  { PseudoVWSUBU_VX_MF4_MASK, VWSUBU_VX, 0x6 }, // 12761
  { PseudoVWSUBU_VX_MF4_TU, VWSUBU_VX, 0x6 }, // 12762
  { PseudoVWSUBU_VX_MF2, VWSUBU_VX, 0x7 }, // 12763
  { PseudoVWSUBU_VX_MF2_MASK, VWSUBU_VX, 0x7 }, // 12764
  { PseudoVWSUBU_VX_MF2_TU, VWSUBU_VX, 0x7 }, // 12765
  { PseudoVWSUBU_WV_M1, VWSUBU_WV, 0x0 }, // 12766
  { PseudoVWSUBU_WV_M1_MASK, VWSUBU_WV, 0x0 }, // 12767
  { PseudoVWSUBU_WV_M1_MASK_TIED, VWSUBU_WV, 0x0 }, // 12768
  { PseudoVWSUBU_WV_M1_TIED, VWSUBU_WV, 0x0 }, // 12769
  { PseudoVWSUBU_WV_M1_TU, VWSUBU_WV, 0x0 }, // 12770
  { PseudoVWSUBU_WV_M2, VWSUBU_WV, 0x1 }, // 12771
  { PseudoVWSUBU_WV_M2_MASK, VWSUBU_WV, 0x1 }, // 12772
  { PseudoVWSUBU_WV_M2_MASK_TIED, VWSUBU_WV, 0x1 }, // 12773
  { PseudoVWSUBU_WV_M2_TIED, VWSUBU_WV, 0x1 }, // 12774
  { PseudoVWSUBU_WV_M2_TU, VWSUBU_WV, 0x1 }, // 12775
  { PseudoVWSUBU_WV_M4, VWSUBU_WV, 0x2 }, // 12776
  { PseudoVWSUBU_WV_M4_MASK, VWSUBU_WV, 0x2 }, // 12777
  { PseudoVWSUBU_WV_M4_MASK_TIED, VWSUBU_WV, 0x2 }, // 12778
  { PseudoVWSUBU_WV_M4_TIED, VWSUBU_WV, 0x2 }, // 12779
  { PseudoVWSUBU_WV_M4_TU, VWSUBU_WV, 0x2 }, // 12780
  { PseudoVWSUBU_WV_MF8, VWSUBU_WV, 0x5 }, // 12781
  { PseudoVWSUBU_WV_MF8_MASK, VWSUBU_WV, 0x5 }, // 12782
  { PseudoVWSUBU_WV_MF8_MASK_TIED, VWSUBU_WV, 0x5 }, // 12783
  { PseudoVWSUBU_WV_MF8_TIED, VWSUBU_WV, 0x5 }, // 12784
  { PseudoVWSUBU_WV_MF8_TU, VWSUBU_WV, 0x5 }, // 12785
  { PseudoVWSUBU_WV_MF4, VWSUBU_WV, 0x6 }, // 12786
  { PseudoVWSUBU_WV_MF4_MASK, VWSUBU_WV, 0x6 }, // 12787
  { PseudoVWSUBU_WV_MF4_MASK_TIED, VWSUBU_WV, 0x6 }, // 12788
  { PseudoVWSUBU_WV_MF4_TIED, VWSUBU_WV, 0x6 }, // 12789
  { PseudoVWSUBU_WV_MF4_TU, VWSUBU_WV, 0x6 }, // 12790
  { PseudoVWSUBU_WV_MF2, VWSUBU_WV, 0x7 }, // 12791
  { PseudoVWSUBU_WV_MF2_MASK, VWSUBU_WV, 0x7 }, // 12792
  { PseudoVWSUBU_WV_MF2_MASK_TIED, VWSUBU_WV, 0x7 }, // 12793
  { PseudoVWSUBU_WV_MF2_TIED, VWSUBU_WV, 0x7 }, // 12794
  { PseudoVWSUBU_WV_MF2_TU, VWSUBU_WV, 0x7 }, // 12795
  { PseudoVWSUBU_WX_M1, VWSUBU_WX, 0x0 }, // 12796
  { PseudoVWSUBU_WX_M1_MASK, VWSUBU_WX, 0x0 }, // 12797
  { PseudoVWSUBU_WX_M1_TU, VWSUBU_WX, 0x0 }, // 12798
  { PseudoVWSUBU_WX_M2, VWSUBU_WX, 0x1 }, // 12799
  { PseudoVWSUBU_WX_M2_MASK, VWSUBU_WX, 0x1 }, // 12800
  { PseudoVWSUBU_WX_M2_TU, VWSUBU_WX, 0x1 }, // 12801
  { PseudoVWSUBU_WX_M4, VWSUBU_WX, 0x2 }, // 12802
  { PseudoVWSUBU_WX_M4_MASK, VWSUBU_WX, 0x2 }, // 12803
  { PseudoVWSUBU_WX_M4_TU, VWSUBU_WX, 0x2 }, // 12804
  { PseudoVWSUBU_WX_MF8, VWSUBU_WX, 0x5 }, // 12805
  { PseudoVWSUBU_WX_MF8_MASK, VWSUBU_WX, 0x5 }, // 12806
  { PseudoVWSUBU_WX_MF8_TU, VWSUBU_WX, 0x5 }, // 12807
  { PseudoVWSUBU_WX_MF4, VWSUBU_WX, 0x6 }, // 12808
  { PseudoVWSUBU_WX_MF4_MASK, VWSUBU_WX, 0x6 }, // 12809
  { PseudoVWSUBU_WX_MF4_TU, VWSUBU_WX, 0x6 }, // 12810
  { PseudoVWSUBU_WX_MF2, VWSUBU_WX, 0x7 }, // 12811
  { PseudoVWSUBU_WX_MF2_MASK, VWSUBU_WX, 0x7 }, // 12812
  { PseudoVWSUBU_WX_MF2_TU, VWSUBU_WX, 0x7 }, // 12813
  { PseudoVWSUB_VV_M1, VWSUB_VV, 0x0 }, // 12814
  { PseudoVWSUB_VV_M1_MASK, VWSUB_VV, 0x0 }, // 12815
  { PseudoVWSUB_VV_M1_TU, VWSUB_VV, 0x0 }, // 12816
  { PseudoVWSUB_VV_M2, VWSUB_VV, 0x1 }, // 12817
  { PseudoVWSUB_VV_M2_MASK, VWSUB_VV, 0x1 }, // 12818
  { PseudoVWSUB_VV_M2_TU, VWSUB_VV, 0x1 }, // 12819
  { PseudoVWSUB_VV_M4, VWSUB_VV, 0x2 }, // 12820
  { PseudoVWSUB_VV_M4_MASK, VWSUB_VV, 0x2 }, // 12821
  { PseudoVWSUB_VV_M4_TU, VWSUB_VV, 0x2 }, // 12822
  { PseudoVWSUB_VV_MF8, VWSUB_VV, 0x5 }, // 12823
  { PseudoVWSUB_VV_MF8_MASK, VWSUB_VV, 0x5 }, // 12824
  { PseudoVWSUB_VV_MF8_TU, VWSUB_VV, 0x5 }, // 12825
  { PseudoVWSUB_VV_MF4, VWSUB_VV, 0x6 }, // 12826
  { PseudoVWSUB_VV_MF4_MASK, VWSUB_VV, 0x6 }, // 12827
  { PseudoVWSUB_VV_MF4_TU, VWSUB_VV, 0x6 }, // 12828
  { PseudoVWSUB_VV_MF2, VWSUB_VV, 0x7 }, // 12829
  { PseudoVWSUB_VV_MF2_MASK, VWSUB_VV, 0x7 }, // 12830
  { PseudoVWSUB_VV_MF2_TU, VWSUB_VV, 0x7 }, // 12831
  { PseudoVWSUB_VX_M1, VWSUB_VX, 0x0 }, // 12832
  { PseudoVWSUB_VX_M1_MASK, VWSUB_VX, 0x0 }, // 12833
  { PseudoVWSUB_VX_M1_TU, VWSUB_VX, 0x0 }, // 12834
  { PseudoVWSUB_VX_M2, VWSUB_VX, 0x1 }, // 12835
  { PseudoVWSUB_VX_M2_MASK, VWSUB_VX, 0x1 }, // 12836
  { PseudoVWSUB_VX_M2_TU, VWSUB_VX, 0x1 }, // 12837
  { PseudoVWSUB_VX_M4, VWSUB_VX, 0x2 }, // 12838
  { PseudoVWSUB_VX_M4_MASK, VWSUB_VX, 0x2 }, // 12839
  { PseudoVWSUB_VX_M4_TU, VWSUB_VX, 0x2 }, // 12840
  { PseudoVWSUB_VX_MF8, VWSUB_VX, 0x5 }, // 12841
  { PseudoVWSUB_VX_MF8_MASK, VWSUB_VX, 0x5 }, // 12842
  { PseudoVWSUB_VX_MF8_TU, VWSUB_VX, 0x5 }, // 12843
  { PseudoVWSUB_VX_MF4, VWSUB_VX, 0x6 }, // 12844
  { PseudoVWSUB_VX_MF4_MASK, VWSUB_VX, 0x6 }, // 12845
  { PseudoVWSUB_VX_MF4_TU, VWSUB_VX, 0x6 }, // 12846
  { PseudoVWSUB_VX_MF2, VWSUB_VX, 0x7 }, // 12847
  { PseudoVWSUB_VX_MF2_MASK, VWSUB_VX, 0x7 }, // 12848
  { PseudoVWSUB_VX_MF2_TU, VWSUB_VX, 0x7 }, // 12849
  { PseudoVWSUB_WV_M1, VWSUB_WV, 0x0 }, // 12850
  { PseudoVWSUB_WV_M1_MASK, VWSUB_WV, 0x0 }, // 12851
  { PseudoVWSUB_WV_M1_MASK_TIED, VWSUB_WV, 0x0 }, // 12852
  { PseudoVWSUB_WV_M1_TIED, VWSUB_WV, 0x0 }, // 12853
  { PseudoVWSUB_WV_M1_TU, VWSUB_WV, 0x0 }, // 12854
  { PseudoVWSUB_WV_M2, VWSUB_WV, 0x1 }, // 12855
  { PseudoVWSUB_WV_M2_MASK, VWSUB_WV, 0x1 }, // 12856
  { PseudoVWSUB_WV_M2_MASK_TIED, VWSUB_WV, 0x1 }, // 12857
  { PseudoVWSUB_WV_M2_TIED, VWSUB_WV, 0x1 }, // 12858
  { PseudoVWSUB_WV_M2_TU, VWSUB_WV, 0x1 }, // 12859
  { PseudoVWSUB_WV_M4, VWSUB_WV, 0x2 }, // 12860
  { PseudoVWSUB_WV_M4_MASK, VWSUB_WV, 0x2 }, // 12861
  { PseudoVWSUB_WV_M4_MASK_TIED, VWSUB_WV, 0x2 }, // 12862
  { PseudoVWSUB_WV_M4_TIED, VWSUB_WV, 0x2 }, // 12863
  { PseudoVWSUB_WV_M4_TU, VWSUB_WV, 0x2 }, // 12864
  { PseudoVWSUB_WV_MF8, VWSUB_WV, 0x5 }, // 12865
  { PseudoVWSUB_WV_MF8_MASK, VWSUB_WV, 0x5 }, // 12866
  { PseudoVWSUB_WV_MF8_MASK_TIED, VWSUB_WV, 0x5 }, // 12867
  { PseudoVWSUB_WV_MF8_TIED, VWSUB_WV, 0x5 }, // 12868
  { PseudoVWSUB_WV_MF8_TU, VWSUB_WV, 0x5 }, // 12869
  { PseudoVWSUB_WV_MF4, VWSUB_WV, 0x6 }, // 12870
  { PseudoVWSUB_WV_MF4_MASK, VWSUB_WV, 0x6 }, // 12871
  { PseudoVWSUB_WV_MF4_MASK_TIED, VWSUB_WV, 0x6 }, // 12872
  { PseudoVWSUB_WV_MF4_TIED, VWSUB_WV, 0x6 }, // 12873
  { PseudoVWSUB_WV_MF4_TU, VWSUB_WV, 0x6 }, // 12874
  { PseudoVWSUB_WV_MF2, VWSUB_WV, 0x7 }, // 12875
  { PseudoVWSUB_WV_MF2_MASK, VWSUB_WV, 0x7 }, // 12876
  { PseudoVWSUB_WV_MF2_MASK_TIED, VWSUB_WV, 0x7 }, // 12877
  { PseudoVWSUB_WV_MF2_TIED, VWSUB_WV, 0x7 }, // 12878
  { PseudoVWSUB_WV_MF2_TU, VWSUB_WV, 0x7 }, // 12879
  { PseudoVWSUB_WX_M1, VWSUB_WX, 0x0 }, // 12880
  { PseudoVWSUB_WX_M1_MASK, VWSUB_WX, 0x0 }, // 12881
  { PseudoVWSUB_WX_M1_TU, VWSUB_WX, 0x0 }, // 12882
  { PseudoVWSUB_WX_M2, VWSUB_WX, 0x1 }, // 12883
  { PseudoVWSUB_WX_M2_MASK, VWSUB_WX, 0x1 }, // 12884
  { PseudoVWSUB_WX_M2_TU, VWSUB_WX, 0x1 }, // 12885
  { PseudoVWSUB_WX_M4, VWSUB_WX, 0x2 }, // 12886
  { PseudoVWSUB_WX_M4_MASK, VWSUB_WX, 0x2 }, // 12887
  { PseudoVWSUB_WX_M4_TU, VWSUB_WX, 0x2 }, // 12888
  { PseudoVWSUB_WX_MF8, VWSUB_WX, 0x5 }, // 12889
  { PseudoVWSUB_WX_MF8_MASK, VWSUB_WX, 0x5 }, // 12890
  { PseudoVWSUB_WX_MF8_TU, VWSUB_WX, 0x5 }, // 12891
  { PseudoVWSUB_WX_MF4, VWSUB_WX, 0x6 }, // 12892
  { PseudoVWSUB_WX_MF4_MASK, VWSUB_WX, 0x6 }, // 12893
  { PseudoVWSUB_WX_MF4_TU, VWSUB_WX, 0x6 }, // 12894
  { PseudoVWSUB_WX_MF2, VWSUB_WX, 0x7 }, // 12895
  { PseudoVWSUB_WX_MF2_MASK, VWSUB_WX, 0x7 }, // 12896
  { PseudoVWSUB_WX_MF2_TU, VWSUB_WX, 0x7 }, // 12897
  { PseudoVXOR_VI_M1, VXOR_VI, 0x0 }, // 12898
  { PseudoVXOR_VI_M1_MASK, VXOR_VI, 0x0 }, // 12899
  { PseudoVXOR_VI_M1_TU, VXOR_VI, 0x0 }, // 12900
  { PseudoVXOR_VI_M2, VXOR_VI, 0x1 }, // 12901
  { PseudoVXOR_VI_M2_MASK, VXOR_VI, 0x1 }, // 12902
  { PseudoVXOR_VI_M2_TU, VXOR_VI, 0x1 }, // 12903
  { PseudoVXOR_VI_M4, VXOR_VI, 0x2 }, // 12904
  { PseudoVXOR_VI_M4_MASK, VXOR_VI, 0x2 }, // 12905
  { PseudoVXOR_VI_M4_TU, VXOR_VI, 0x2 }, // 12906
  { PseudoVXOR_VI_M8, VXOR_VI, 0x3 }, // 12907
  { PseudoVXOR_VI_M8_MASK, VXOR_VI, 0x3 }, // 12908
  { PseudoVXOR_VI_M8_TU, VXOR_VI, 0x3 }, // 12909
  { PseudoVXOR_VI_MF8, VXOR_VI, 0x5 }, // 12910
  { PseudoVXOR_VI_MF8_MASK, VXOR_VI, 0x5 }, // 12911
  { PseudoVXOR_VI_MF8_TU, VXOR_VI, 0x5 }, // 12912
  { PseudoVXOR_VI_MF4, VXOR_VI, 0x6 }, // 12913
  { PseudoVXOR_VI_MF4_MASK, VXOR_VI, 0x6 }, // 12914
  { PseudoVXOR_VI_MF4_TU, VXOR_VI, 0x6 }, // 12915
  { PseudoVXOR_VI_MF2, VXOR_VI, 0x7 }, // 12916
  { PseudoVXOR_VI_MF2_MASK, VXOR_VI, 0x7 }, // 12917
  { PseudoVXOR_VI_MF2_TU, VXOR_VI, 0x7 }, // 12918
  { PseudoVXOR_VV_M1, VXOR_VV, 0x0 }, // 12919
  { PseudoVXOR_VV_M1_MASK, VXOR_VV, 0x0 }, // 12920
  { PseudoVXOR_VV_M1_TU, VXOR_VV, 0x0 }, // 12921
  { PseudoVXOR_VV_M2, VXOR_VV, 0x1 }, // 12922
  { PseudoVXOR_VV_M2_MASK, VXOR_VV, 0x1 }, // 12923
  { PseudoVXOR_VV_M2_TU, VXOR_VV, 0x1 }, // 12924
  { PseudoVXOR_VV_M4, VXOR_VV, 0x2 }, // 12925
  { PseudoVXOR_VV_M4_MASK, VXOR_VV, 0x2 }, // 12926
  { PseudoVXOR_VV_M4_TU, VXOR_VV, 0x2 }, // 12927
  { PseudoVXOR_VV_M8, VXOR_VV, 0x3 }, // 12928
  { PseudoVXOR_VV_M8_MASK, VXOR_VV, 0x3 }, // 12929
  { PseudoVXOR_VV_M8_TU, VXOR_VV, 0x3 }, // 12930
  { PseudoVXOR_VV_MF8, VXOR_VV, 0x5 }, // 12931
  { PseudoVXOR_VV_MF8_MASK, VXOR_VV, 0x5 }, // 12932
  { PseudoVXOR_VV_MF8_TU, VXOR_VV, 0x5 }, // 12933
  { PseudoVXOR_VV_MF4, VXOR_VV, 0x6 }, // 12934
  { PseudoVXOR_VV_MF4_MASK, VXOR_VV, 0x6 }, // 12935
  { PseudoVXOR_VV_MF4_TU, VXOR_VV, 0x6 }, // 12936
  { PseudoVXOR_VV_MF2, VXOR_VV, 0x7 }, // 12937
  { PseudoVXOR_VV_MF2_MASK, VXOR_VV, 0x7 }, // 12938
  { PseudoVXOR_VV_MF2_TU, VXOR_VV, 0x7 }, // 12939
  { PseudoVXOR_VX_M1, VXOR_VX, 0x0 }, // 12940
  { PseudoVXOR_VX_M1_MASK, VXOR_VX, 0x0 }, // 12941
  { PseudoVXOR_VX_M1_TU, VXOR_VX, 0x0 }, // 12942
  { PseudoVXOR_VX_M2, VXOR_VX, 0x1 }, // 12943
  { PseudoVXOR_VX_M2_MASK, VXOR_VX, 0x1 }, // 12944
  { PseudoVXOR_VX_M2_TU, VXOR_VX, 0x1 }, // 12945
  { PseudoVXOR_VX_M4, VXOR_VX, 0x2 }, // 12946
  { PseudoVXOR_VX_M4_MASK, VXOR_VX, 0x2 }, // 12947
  { PseudoVXOR_VX_M4_TU, VXOR_VX, 0x2 }, // 12948
  { PseudoVXOR_VX_M8, VXOR_VX, 0x3 }, // 12949
  { PseudoVXOR_VX_M8_MASK, VXOR_VX, 0x3 }, // 12950
  { PseudoVXOR_VX_M8_TU, VXOR_VX, 0x3 }, // 12951
  { PseudoVXOR_VX_MF8, VXOR_VX, 0x5 }, // 12952
  { PseudoVXOR_VX_MF8_MASK, VXOR_VX, 0x5 }, // 12953
  { PseudoVXOR_VX_MF8_TU, VXOR_VX, 0x5 }, // 12954
  { PseudoVXOR_VX_MF4, VXOR_VX, 0x6 }, // 12955
  { PseudoVXOR_VX_MF4_MASK, VXOR_VX, 0x6 }, // 12956
  { PseudoVXOR_VX_MF4_TU, VXOR_VX, 0x6 }, // 12957
  { PseudoVXOR_VX_MF2, VXOR_VX, 0x7 }, // 12958
  { PseudoVXOR_VX_MF2_MASK, VXOR_VX, 0x7 }, // 12959
  { PseudoVXOR_VX_MF2_TU, VXOR_VX, 0x7 }, // 12960
  { PseudoVZEXT_VF2_M1, VZEXT_VF2, 0x0 }, // 12961
  { PseudoVZEXT_VF2_M1_MASK, VZEXT_VF2, 0x0 }, // 12962
  { PseudoVZEXT_VF2_M1_TU, VZEXT_VF2, 0x0 }, // 12963
  { PseudoVZEXT_VF2_M2, VZEXT_VF2, 0x1 }, // 12964
  { PseudoVZEXT_VF2_M2_MASK, VZEXT_VF2, 0x1 }, // 12965
  { PseudoVZEXT_VF2_M2_TU, VZEXT_VF2, 0x1 }, // 12966
  { PseudoVZEXT_VF2_M4, VZEXT_VF2, 0x2 }, // 12967
  { PseudoVZEXT_VF2_M4_MASK, VZEXT_VF2, 0x2 }, // 12968
  { PseudoVZEXT_VF2_M4_TU, VZEXT_VF2, 0x2 }, // 12969
  { PseudoVZEXT_VF2_M8, VZEXT_VF2, 0x3 }, // 12970
  { PseudoVZEXT_VF2_M8_MASK, VZEXT_VF2, 0x3 }, // 12971
  { PseudoVZEXT_VF2_M8_TU, VZEXT_VF2, 0x3 }, // 12972
  { PseudoVZEXT_VF2_MF4, VZEXT_VF2, 0x6 }, // 12973
  { PseudoVZEXT_VF2_MF4_MASK, VZEXT_VF2, 0x6 }, // 12974
  { PseudoVZEXT_VF2_MF4_TU, VZEXT_VF2, 0x6 }, // 12975
  { PseudoVZEXT_VF2_MF2, VZEXT_VF2, 0x7 }, // 12976
  { PseudoVZEXT_VF2_MF2_MASK, VZEXT_VF2, 0x7 }, // 12977
  { PseudoVZEXT_VF2_MF2_TU, VZEXT_VF2, 0x7 }, // 12978
  { PseudoVZEXT_VF4_M1, VZEXT_VF4, 0x0 }, // 12979
  { PseudoVZEXT_VF4_M1_MASK, VZEXT_VF4, 0x0 }, // 12980
  { PseudoVZEXT_VF4_M1_TU, VZEXT_VF4, 0x0 }, // 12981
  { PseudoVZEXT_VF4_M2, VZEXT_VF4, 0x1 }, // 12982
  { PseudoVZEXT_VF4_M2_MASK, VZEXT_VF4, 0x1 }, // 12983
  { PseudoVZEXT_VF4_M2_TU, VZEXT_VF4, 0x1 }, // 12984
  { PseudoVZEXT_VF4_M4, VZEXT_VF4, 0x2 }, // 12985
  { PseudoVZEXT_VF4_M4_MASK, VZEXT_VF4, 0x2 }, // 12986
  { PseudoVZEXT_VF4_M4_TU, VZEXT_VF4, 0x2 }, // 12987
  { PseudoVZEXT_VF4_M8, VZEXT_VF4, 0x3 }, // 12988
  { PseudoVZEXT_VF4_M8_MASK, VZEXT_VF4, 0x3 }, // 12989
  { PseudoVZEXT_VF4_M8_TU, VZEXT_VF4, 0x3 }, // 12990
  { PseudoVZEXT_VF4_MF2, VZEXT_VF4, 0x7 }, // 12991
  { PseudoVZEXT_VF4_MF2_MASK, VZEXT_VF4, 0x7 }, // 12992
  { PseudoVZEXT_VF4_MF2_TU, VZEXT_VF4, 0x7 }, // 12993
  { PseudoVZEXT_VF8_M1, VZEXT_VF8, 0x0 }, // 12994
  { PseudoVZEXT_VF8_M1_MASK, VZEXT_VF8, 0x0 }, // 12995
  { PseudoVZEXT_VF8_M1_TU, VZEXT_VF8, 0x0 }, // 12996
  { PseudoVZEXT_VF8_M2, VZEXT_VF8, 0x1 }, // 12997
  { PseudoVZEXT_VF8_M2_MASK, VZEXT_VF8, 0x1 }, // 12998
  { PseudoVZEXT_VF8_M2_TU, VZEXT_VF8, 0x1 }, // 12999
  { PseudoVZEXT_VF8_M4, VZEXT_VF8, 0x2 }, // 13000
  { PseudoVZEXT_VF8_M4_MASK, VZEXT_VF8, 0x2 }, // 13001
  { PseudoVZEXT_VF8_M4_TU, VZEXT_VF8, 0x2 }, // 13002
  { PseudoVZEXT_VF8_M8, VZEXT_VF8, 0x3 }, // 13003
  { PseudoVZEXT_VF8_M8_MASK, VZEXT_VF8, 0x3 }, // 13004
  { PseudoVZEXT_VF8_M8_TU, VZEXT_VF8, 0x3 }, // 13005
 };

const PseudoInfo *getBaseInfo(unsigned BaseInstr, uint8_t VLMul) {
  if ((BaseInstr < THVdotVMAQASU_VV) ||
      (BaseInstr > VZEXT_VF8))
    return nullptr;

  struct KeyType {
    unsigned BaseInstr;
    uint8_t VLMul;
  };
  KeyType Key = {BaseInstr, VLMul};
  auto Table = ArrayRef(RISCVVInversePseudosTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const PseudoInfo &LHS, const KeyType &RHS) {
      if (LHS.BaseInstr < RHS.BaseInstr)
        return true;
      if (LHS.BaseInstr > RHS.BaseInstr)
        return false;
      if (LHS.VLMul < RHS.VLMul)
        return true;
      if (LHS.VLMul > RHS.VLMul)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.BaseInstr != Idx->BaseInstr ||
      Key.VLMul != Idx->VLMul)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVLETable_DECL
const VLEPseudo *getVLEPseudo(uint8_t Masked, uint8_t IsTU, uint8_t Strided, uint8_t FF, uint8_t Log2SEW, uint8_t LMUL);
#endif

#ifdef GET_RISCVVLETable_IMPL
constexpr VLEPseudo RISCVVLETable[] = {
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, PseudoVLM_V_B8 }, // 0
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, PseudoVLM_V_B16 }, // 1
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, PseudoVLM_V_B32 }, // 2
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, PseudoVLM_V_B64 }, // 3
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, PseudoVLM_V_B1 }, // 4
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, PseudoVLM_V_B2 }, // 5
  { 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, PseudoVLM_V_B4 }, // 6
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLE8_V_M1 }, // 7
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x1, PseudoVLE8_V_M2 }, // 8
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x2, PseudoVLE8_V_M4 }, // 9
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x3, PseudoVLE8_V_M8 }, // 10
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLE8_V_MF8 }, // 11
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLE8_V_MF4 }, // 12
  { 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLE8_V_MF2 }, // 13
  { 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLE16_V_M1 }, // 14
  { 0x0, 0x0, 0x0, 0x0, 0x4, 0x1, PseudoVLE16_V_M2 }, // 15
  { 0x0, 0x0, 0x0, 0x0, 0x4, 0x2, PseudoVLE16_V_M4 }, // 16
  { 0x0, 0x0, 0x0, 0x0, 0x4, 0x3, PseudoVLE16_V_M8 }, // 17
  { 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLE16_V_MF4 }, // 18
  { 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLE16_V_MF2 }, // 19
  { 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLE32_V_M1 }, // 20
  { 0x0, 0x0, 0x0, 0x0, 0x5, 0x1, PseudoVLE32_V_M2 }, // 21
  { 0x0, 0x0, 0x0, 0x0, 0x5, 0x2, PseudoVLE32_V_M4 }, // 22
  { 0x0, 0x0, 0x0, 0x0, 0x5, 0x3, PseudoVLE32_V_M8 }, // 23
  { 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLE32_V_MF2 }, // 24
  { 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLE64_V_M1 }, // 25
  { 0x0, 0x0, 0x0, 0x0, 0x6, 0x1, PseudoVLE64_V_M2 }, // 26
  { 0x0, 0x0, 0x0, 0x0, 0x6, 0x2, PseudoVLE64_V_M4 }, // 27
  { 0x0, 0x0, 0x0, 0x0, 0x6, 0x3, PseudoVLE64_V_M8 }, // 28
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLE8FF_V_M1 }, // 29
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x1, PseudoVLE8FF_V_M2 }, // 30
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, PseudoVLE8FF_V_M4 }, // 31
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x3, PseudoVLE8FF_V_M8 }, // 32
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLE8FF_V_MF8 }, // 33
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLE8FF_V_MF4 }, // 34
  { 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLE8FF_V_MF2 }, // 35
  { 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLE16FF_V_M1 }, // 36
  { 0x0, 0x0, 0x0, 0x1, 0x4, 0x1, PseudoVLE16FF_V_M2 }, // 37
  { 0x0, 0x0, 0x0, 0x1, 0x4, 0x2, PseudoVLE16FF_V_M4 }, // 38
  { 0x0, 0x0, 0x0, 0x1, 0x4, 0x3, PseudoVLE16FF_V_M8 }, // 39
  { 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLE16FF_V_MF4 }, // 40
  { 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLE16FF_V_MF2 }, // 41
  { 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLE32FF_V_M1 }, // 42
  { 0x0, 0x0, 0x0, 0x1, 0x5, 0x1, PseudoVLE32FF_V_M2 }, // 43
  { 0x0, 0x0, 0x0, 0x1, 0x5, 0x2, PseudoVLE32FF_V_M4 }, // 44
  { 0x0, 0x0, 0x0, 0x1, 0x5, 0x3, PseudoVLE32FF_V_M8 }, // 45
  { 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLE32FF_V_MF2 }, // 46
  { 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLE64FF_V_M1 }, // 47
  { 0x0, 0x0, 0x0, 0x1, 0x6, 0x1, PseudoVLE64FF_V_M2 }, // 48
  { 0x0, 0x0, 0x0, 0x1, 0x6, 0x2, PseudoVLE64FF_V_M4 }, // 49
  { 0x0, 0x0, 0x0, 0x1, 0x6, 0x3, PseudoVLE64FF_V_M8 }, // 50
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSE8_V_M1 }, // 51
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x1, PseudoVLSE8_V_M2 }, // 52
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x2, PseudoVLSE8_V_M4 }, // 53
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x3, PseudoVLSE8_V_M8 }, // 54
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSE8_V_MF8 }, // 55
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSE8_V_MF4 }, // 56
  { 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSE8_V_MF2 }, // 57
  { 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSE16_V_M1 }, // 58
  { 0x0, 0x0, 0x1, 0x0, 0x4, 0x1, PseudoVLSE16_V_M2 }, // 59
  { 0x0, 0x0, 0x1, 0x0, 0x4, 0x2, PseudoVLSE16_V_M4 }, // 60
  { 0x0, 0x0, 0x1, 0x0, 0x4, 0x3, PseudoVLSE16_V_M8 }, // 61
  { 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSE16_V_MF4 }, // 62
  { 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSE16_V_MF2 }, // 63
  { 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSE32_V_M1 }, // 64
  { 0x0, 0x0, 0x1, 0x0, 0x5, 0x1, PseudoVLSE32_V_M2 }, // 65
  { 0x0, 0x0, 0x1, 0x0, 0x5, 0x2, PseudoVLSE32_V_M4 }, // 66
  { 0x0, 0x0, 0x1, 0x0, 0x5, 0x3, PseudoVLSE32_V_M8 }, // 67
  { 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSE32_V_MF2 }, // 68
  { 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSE64_V_M1 }, // 69
  { 0x0, 0x0, 0x1, 0x0, 0x6, 0x1, PseudoVLSE64_V_M2 }, // 70
  { 0x0, 0x0, 0x1, 0x0, 0x6, 0x2, PseudoVLSE64_V_M4 }, // 71
  { 0x0, 0x0, 0x1, 0x0, 0x6, 0x3, PseudoVLSE64_V_M8 }, // 72
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLE8_V_M1_TU }, // 73
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLE8_V_M2_TU }, // 74
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x2, PseudoVLE8_V_M4_TU }, // 75
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x3, PseudoVLE8_V_M8_TU }, // 76
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLE8_V_MF8_TU }, // 77
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLE8_V_MF4_TU }, // 78
  { 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLE8_V_MF2_TU }, // 79
  { 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLE16_V_M1_TU }, // 80
  { 0x0, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLE16_V_M2_TU }, // 81
  { 0x0, 0x1, 0x0, 0x0, 0x4, 0x2, PseudoVLE16_V_M4_TU }, // 82
  { 0x0, 0x1, 0x0, 0x0, 0x4, 0x3, PseudoVLE16_V_M8_TU }, // 83
  { 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLE16_V_MF4_TU }, // 84
  { 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLE16_V_MF2_TU }, // 85
  { 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLE32_V_M1_TU }, // 86
  { 0x0, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLE32_V_M2_TU }, // 87
  { 0x0, 0x1, 0x0, 0x0, 0x5, 0x2, PseudoVLE32_V_M4_TU }, // 88
  { 0x0, 0x1, 0x0, 0x0, 0x5, 0x3, PseudoVLE32_V_M8_TU }, // 89
  { 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLE32_V_MF2_TU }, // 90
  { 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLE64_V_M1_TU }, // 91
  { 0x0, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLE64_V_M2_TU }, // 92
  { 0x0, 0x1, 0x0, 0x0, 0x6, 0x2, PseudoVLE64_V_M4_TU }, // 93
  { 0x0, 0x1, 0x0, 0x0, 0x6, 0x3, PseudoVLE64_V_M8_TU }, // 94
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLE8FF_V_M1_TU }, // 95
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLE8FF_V_M2_TU }, // 96
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x2, PseudoVLE8FF_V_M4_TU }, // 97
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x3, PseudoVLE8FF_V_M8_TU }, // 98
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLE8FF_V_MF8_TU }, // 99
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLE8FF_V_MF4_TU }, // 100
  { 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLE8FF_V_MF2_TU }, // 101
  { 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLE16FF_V_M1_TU }, // 102
  { 0x0, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLE16FF_V_M2_TU }, // 103
  { 0x0, 0x1, 0x0, 0x1, 0x4, 0x2, PseudoVLE16FF_V_M4_TU }, // 104
  { 0x0, 0x1, 0x0, 0x1, 0x4, 0x3, PseudoVLE16FF_V_M8_TU }, // 105
  { 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLE16FF_V_MF4_TU }, // 106
  { 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLE16FF_V_MF2_TU }, // 107
  { 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLE32FF_V_M1_TU }, // 108
  { 0x0, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLE32FF_V_M2_TU }, // 109
  { 0x0, 0x1, 0x0, 0x1, 0x5, 0x2, PseudoVLE32FF_V_M4_TU }, // 110
  { 0x0, 0x1, 0x0, 0x1, 0x5, 0x3, PseudoVLE32FF_V_M8_TU }, // 111
  { 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLE32FF_V_MF2_TU }, // 112
  { 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLE64FF_V_M1_TU }, // 113
  { 0x0, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLE64FF_V_M2_TU }, // 114
  { 0x0, 0x1, 0x0, 0x1, 0x6, 0x2, PseudoVLE64FF_V_M4_TU }, // 115
  { 0x0, 0x1, 0x0, 0x1, 0x6, 0x3, PseudoVLE64FF_V_M8_TU }, // 116
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSE8_V_M1_TU }, // 117
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSE8_V_M2_TU }, // 118
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x2, PseudoVLSE8_V_M4_TU }, // 119
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x3, PseudoVLSE8_V_M8_TU }, // 120
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSE8_V_MF8_TU }, // 121
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSE8_V_MF4_TU }, // 122
  { 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSE8_V_MF2_TU }, // 123
  { 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSE16_V_M1_TU }, // 124
  { 0x0, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSE16_V_M2_TU }, // 125
  { 0x0, 0x1, 0x1, 0x0, 0x4, 0x2, PseudoVLSE16_V_M4_TU }, // 126
  { 0x0, 0x1, 0x1, 0x0, 0x4, 0x3, PseudoVLSE16_V_M8_TU }, // 127
  { 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSE16_V_MF4_TU }, // 128
  { 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSE16_V_MF2_TU }, // 129
  { 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSE32_V_M1_TU }, // 130
  { 0x0, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSE32_V_M2_TU }, // 131
  { 0x0, 0x1, 0x1, 0x0, 0x5, 0x2, PseudoVLSE32_V_M4_TU }, // 132
  { 0x0, 0x1, 0x1, 0x0, 0x5, 0x3, PseudoVLSE32_V_M8_TU }, // 133
  { 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSE32_V_MF2_TU }, // 134
  { 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSE64_V_M1_TU }, // 135
  { 0x0, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSE64_V_M2_TU }, // 136
  { 0x0, 0x1, 0x1, 0x0, 0x6, 0x2, PseudoVLSE64_V_M4_TU }, // 137
  { 0x0, 0x1, 0x1, 0x0, 0x6, 0x3, PseudoVLSE64_V_M8_TU }, // 138
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLE8_V_M1_MASK }, // 139
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLE8_V_M2_MASK }, // 140
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x2, PseudoVLE8_V_M4_MASK }, // 141
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x3, PseudoVLE8_V_M8_MASK }, // 142
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLE8_V_MF8_MASK }, // 143
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLE8_V_MF4_MASK }, // 144
  { 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLE8_V_MF2_MASK }, // 145
  { 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLE16_V_M1_MASK }, // 146
  { 0x1, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLE16_V_M2_MASK }, // 147
  { 0x1, 0x1, 0x0, 0x0, 0x4, 0x2, PseudoVLE16_V_M4_MASK }, // 148
  { 0x1, 0x1, 0x0, 0x0, 0x4, 0x3, PseudoVLE16_V_M8_MASK }, // 149
  { 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLE16_V_MF4_MASK }, // 150
  { 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLE16_V_MF2_MASK }, // 151
  { 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLE32_V_M1_MASK }, // 152
  { 0x1, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLE32_V_M2_MASK }, // 153
  { 0x1, 0x1, 0x0, 0x0, 0x5, 0x2, PseudoVLE32_V_M4_MASK }, // 154
  { 0x1, 0x1, 0x0, 0x0, 0x5, 0x3, PseudoVLE32_V_M8_MASK }, // 155
  { 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLE32_V_MF2_MASK }, // 156
  { 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLE64_V_M1_MASK }, // 157
  { 0x1, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLE64_V_M2_MASK }, // 158
  { 0x1, 0x1, 0x0, 0x0, 0x6, 0x2, PseudoVLE64_V_M4_MASK }, // 159
  { 0x1, 0x1, 0x0, 0x0, 0x6, 0x3, PseudoVLE64_V_M8_MASK }, // 160
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLE8FF_V_M1_MASK }, // 161
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLE8FF_V_M2_MASK }, // 162
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x2, PseudoVLE8FF_V_M4_MASK }, // 163
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x3, PseudoVLE8FF_V_M8_MASK }, // 164
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLE8FF_V_MF8_MASK }, // 165
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLE8FF_V_MF4_MASK }, // 166
  { 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLE8FF_V_MF2_MASK }, // 167
  { 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLE16FF_V_M1_MASK }, // 168
  { 0x1, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLE16FF_V_M2_MASK }, // 169
  { 0x1, 0x1, 0x0, 0x1, 0x4, 0x2, PseudoVLE16FF_V_M4_MASK }, // 170
  { 0x1, 0x1, 0x0, 0x1, 0x4, 0x3, PseudoVLE16FF_V_M8_MASK }, // 171
  { 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLE16FF_V_MF4_MASK }, // 172
  { 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLE16FF_V_MF2_MASK }, // 173
  { 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLE32FF_V_M1_MASK }, // 174
  { 0x1, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLE32FF_V_M2_MASK }, // 175
  { 0x1, 0x1, 0x0, 0x1, 0x5, 0x2, PseudoVLE32FF_V_M4_MASK }, // 176
  { 0x1, 0x1, 0x0, 0x1, 0x5, 0x3, PseudoVLE32FF_V_M8_MASK }, // 177
  { 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLE32FF_V_MF2_MASK }, // 178
  { 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLE64FF_V_M1_MASK }, // 179
  { 0x1, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLE64FF_V_M2_MASK }, // 180
  { 0x1, 0x1, 0x0, 0x1, 0x6, 0x2, PseudoVLE64FF_V_M4_MASK }, // 181
  { 0x1, 0x1, 0x0, 0x1, 0x6, 0x3, PseudoVLE64FF_V_M8_MASK }, // 182
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSE8_V_M1_MASK }, // 183
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSE8_V_M2_MASK }, // 184
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x2, PseudoVLSE8_V_M4_MASK }, // 185
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x3, PseudoVLSE8_V_M8_MASK }, // 186
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSE8_V_MF8_MASK }, // 187
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSE8_V_MF4_MASK }, // 188
  { 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSE8_V_MF2_MASK }, // 189
  { 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSE16_V_M1_MASK }, // 190
  { 0x1, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSE16_V_M2_MASK }, // 191
  { 0x1, 0x1, 0x1, 0x0, 0x4, 0x2, PseudoVLSE16_V_M4_MASK }, // 192
  { 0x1, 0x1, 0x1, 0x0, 0x4, 0x3, PseudoVLSE16_V_M8_MASK }, // 193
  { 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSE16_V_MF4_MASK }, // 194
  { 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSE16_V_MF2_MASK }, // 195
  { 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSE32_V_M1_MASK }, // 196
  { 0x1, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSE32_V_M2_MASK }, // 197
  { 0x1, 0x1, 0x1, 0x0, 0x5, 0x2, PseudoVLSE32_V_M4_MASK }, // 198
  { 0x1, 0x1, 0x1, 0x0, 0x5, 0x3, PseudoVLSE32_V_M8_MASK }, // 199
  { 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSE32_V_MF2_MASK }, // 200
  { 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSE64_V_M1_MASK }, // 201
  { 0x1, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSE64_V_M2_MASK }, // 202
  { 0x1, 0x1, 0x1, 0x0, 0x6, 0x2, PseudoVLSE64_V_M4_MASK }, // 203
  { 0x1, 0x1, 0x1, 0x0, 0x6, 0x3, PseudoVLSE64_V_M8_MASK }, // 204
 };

const VLEPseudo *getVLEPseudo(uint8_t Masked, uint8_t IsTU, uint8_t Strided, uint8_t FF, uint8_t Log2SEW, uint8_t LMUL) {
  struct KeyType {
    uint8_t Masked;
    uint8_t IsTU;
    uint8_t Strided;
    uint8_t FF;
    uint8_t Log2SEW;
    uint8_t LMUL;
  };
  KeyType Key = {Masked, IsTU, Strided, FF, Log2SEW, LMUL};
  auto Table = ArrayRef(RISCVVLETable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VLEPseudo &LHS, const KeyType &RHS) {
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.IsTU < RHS.IsTU)
        return true;
      if (LHS.IsTU > RHS.IsTU)
        return false;
      if (LHS.Strided < RHS.Strided)
        return true;
      if (LHS.Strided > RHS.Strided)
        return false;
      if (LHS.FF < RHS.FF)
        return true;
      if (LHS.FF > RHS.FF)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Masked != Idx->Masked ||
      Key.IsTU != Idx->IsTU ||
      Key.Strided != Idx->Strided ||
      Key.FF != Idx->FF ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVLSEGTable_DECL
const VLSEGPseudo *getVLSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t IsTU, uint8_t Strided, uint8_t FF, uint8_t Log2SEW, uint8_t LMUL);
#endif

#ifdef GET_RISCVVLSEGTable_IMPL
constexpr VLSEGPseudo RISCVVLSEGTable[] = {
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG2E8_V_M1 }, // 0
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG2E8_V_M2 }, // 1
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x2, PseudoVLSEG2E8_V_M4 }, // 2
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG2E8_V_MF8 }, // 3
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG2E8_V_MF4 }, // 4
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG2E8_V_MF2 }, // 5
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG2E16_V_M1 }, // 6
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG2E16_V_M2 }, // 7
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x4, 0x2, PseudoVLSEG2E16_V_M4 }, // 8
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG2E16_V_MF4 }, // 9
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG2E16_V_MF2 }, // 10
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG2E32_V_M1 }, // 11
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG2E32_V_M2 }, // 12
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x5, 0x2, PseudoVLSEG2E32_V_M4 }, // 13
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG2E32_V_MF2 }, // 14
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG2E64_V_M1 }, // 15
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG2E64_V_M2 }, // 16
  { 0x2, 0x0, 0x0, 0x0, 0x0, 0x6, 0x2, PseudoVLSEG2E64_V_M4 }, // 17
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG2E8FF_V_M1 }, // 18
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG2E8FF_V_M2 }, // 19
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x3, 0x2, PseudoVLSEG2E8FF_V_M4 }, // 20
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG2E8FF_V_MF8 }, // 21
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG2E8FF_V_MF4 }, // 22
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG2E8FF_V_MF2 }, // 23
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG2E16FF_V_M1 }, // 24
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG2E16FF_V_M2 }, // 25
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x4, 0x2, PseudoVLSEG2E16FF_V_M4 }, // 26
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG2E16FF_V_MF4 }, // 27
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG2E16FF_V_MF2 }, // 28
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG2E32FF_V_M1 }, // 29
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG2E32FF_V_M2 }, // 30
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x5, 0x2, PseudoVLSEG2E32FF_V_M4 }, // 31
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG2E32FF_V_MF2 }, // 32
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG2E64FF_V_M1 }, // 33
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG2E64FF_V_M2 }, // 34
  { 0x2, 0x0, 0x0, 0x0, 0x1, 0x6, 0x2, PseudoVLSEG2E64FF_V_M4 }, // 35
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG2E8_V_M1 }, // 36
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG2E8_V_M2 }, // 37
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x2, PseudoVLSSEG2E8_V_M4 }, // 38
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG2E8_V_MF8 }, // 39
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG2E8_V_MF4 }, // 40
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG2E8_V_MF2 }, // 41
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG2E16_V_M1 }, // 42
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG2E16_V_M2 }, // 43
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x4, 0x2, PseudoVLSSEG2E16_V_M4 }, // 44
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG2E16_V_MF4 }, // 45
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG2E16_V_MF2 }, // 46
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG2E32_V_M1 }, // 47
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG2E32_V_M2 }, // 48
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x5, 0x2, PseudoVLSSEG2E32_V_M4 }, // 49
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG2E32_V_MF2 }, // 50
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG2E64_V_M1 }, // 51
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG2E64_V_M2 }, // 52
  { 0x2, 0x0, 0x0, 0x1, 0x0, 0x6, 0x2, PseudoVLSSEG2E64_V_M4 }, // 53
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG2E8_V_M1_TU }, // 54
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG2E8_V_M2_TU }, // 55
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x3, 0x2, PseudoVLSEG2E8_V_M4_TU }, // 56
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG2E8_V_MF8_TU }, // 57
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG2E8_V_MF4_TU }, // 58
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG2E8_V_MF2_TU }, // 59
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG2E16_V_M1_TU }, // 60
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG2E16_V_M2_TU }, // 61
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x4, 0x2, PseudoVLSEG2E16_V_M4_TU }, // 62
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG2E16_V_MF4_TU }, // 63
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG2E16_V_MF2_TU }, // 64
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG2E32_V_M1_TU }, // 65
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG2E32_V_M2_TU }, // 66
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x5, 0x2, PseudoVLSEG2E32_V_M4_TU }, // 67
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG2E32_V_MF2_TU }, // 68
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG2E64_V_M1_TU }, // 69
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG2E64_V_M2_TU }, // 70
  { 0x2, 0x0, 0x1, 0x0, 0x0, 0x6, 0x2, PseudoVLSEG2E64_V_M4_TU }, // 71
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG2E8FF_V_M1_TU }, // 72
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG2E8FF_V_M2_TU }, // 73
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x3, 0x2, PseudoVLSEG2E8FF_V_M4_TU }, // 74
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG2E8FF_V_MF8_TU }, // 75
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG2E8FF_V_MF4_TU }, // 76
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG2E8FF_V_MF2_TU }, // 77
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG2E16FF_V_M1_TU }, // 78
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG2E16FF_V_M2_TU }, // 79
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x4, 0x2, PseudoVLSEG2E16FF_V_M4_TU }, // 80
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG2E16FF_V_MF4_TU }, // 81
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG2E16FF_V_MF2_TU }, // 82
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG2E32FF_V_M1_TU }, // 83
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG2E32FF_V_M2_TU }, // 84
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x5, 0x2, PseudoVLSEG2E32FF_V_M4_TU }, // 85
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG2E32FF_V_MF2_TU }, // 86
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG2E64FF_V_M1_TU }, // 87
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG2E64FF_V_M2_TU }, // 88
  { 0x2, 0x0, 0x1, 0x0, 0x1, 0x6, 0x2, PseudoVLSEG2E64FF_V_M4_TU }, // 89
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG2E8_V_M1_TU }, // 90
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG2E8_V_M2_TU }, // 91
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x3, 0x2, PseudoVLSSEG2E8_V_M4_TU }, // 92
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG2E8_V_MF8_TU }, // 93
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG2E8_V_MF4_TU }, // 94
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG2E8_V_MF2_TU }, // 95
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG2E16_V_M1_TU }, // 96
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG2E16_V_M2_TU }, // 97
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x4, 0x2, PseudoVLSSEG2E16_V_M4_TU }, // 98
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG2E16_V_MF4_TU }, // 99
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG2E16_V_MF2_TU }, // 100
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG2E32_V_M1_TU }, // 101
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG2E32_V_M2_TU }, // 102
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x5, 0x2, PseudoVLSSEG2E32_V_M4_TU }, // 103
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG2E32_V_MF2_TU }, // 104
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG2E64_V_M1_TU }, // 105
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG2E64_V_M2_TU }, // 106
  { 0x2, 0x0, 0x1, 0x1, 0x0, 0x6, 0x2, PseudoVLSSEG2E64_V_M4_TU }, // 107
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG2E8_V_M1_MASK }, // 108
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG2E8_V_M2_MASK }, // 109
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x3, 0x2, PseudoVLSEG2E8_V_M4_MASK }, // 110
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG2E8_V_MF8_MASK }, // 111
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG2E8_V_MF4_MASK }, // 112
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG2E8_V_MF2_MASK }, // 113
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG2E16_V_M1_MASK }, // 114
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG2E16_V_M2_MASK }, // 115
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x4, 0x2, PseudoVLSEG2E16_V_M4_MASK }, // 116
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG2E16_V_MF4_MASK }, // 117
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG2E16_V_MF2_MASK }, // 118
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG2E32_V_M1_MASK }, // 119
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG2E32_V_M2_MASK }, // 120
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x5, 0x2, PseudoVLSEG2E32_V_M4_MASK }, // 121
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG2E32_V_MF2_MASK }, // 122
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG2E64_V_M1_MASK }, // 123
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG2E64_V_M2_MASK }, // 124
  { 0x2, 0x1, 0x1, 0x0, 0x0, 0x6, 0x2, PseudoVLSEG2E64_V_M4_MASK }, // 125
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG2E8FF_V_M1_MASK }, // 126
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG2E8FF_V_M2_MASK }, // 127
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x3, 0x2, PseudoVLSEG2E8FF_V_M4_MASK }, // 128
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG2E8FF_V_MF8_MASK }, // 129
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG2E8FF_V_MF4_MASK }, // 130
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG2E8FF_V_MF2_MASK }, // 131
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG2E16FF_V_M1_MASK }, // 132
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG2E16FF_V_M2_MASK }, // 133
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x4, 0x2, PseudoVLSEG2E16FF_V_M4_MASK }, // 134
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG2E16FF_V_MF4_MASK }, // 135
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG2E16FF_V_MF2_MASK }, // 136
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG2E32FF_V_M1_MASK }, // 137
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG2E32FF_V_M2_MASK }, // 138
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x5, 0x2, PseudoVLSEG2E32FF_V_M4_MASK }, // 139
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG2E32FF_V_MF2_MASK }, // 140
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG2E64FF_V_M1_MASK }, // 141
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG2E64FF_V_M2_MASK }, // 142
  { 0x2, 0x1, 0x1, 0x0, 0x1, 0x6, 0x2, PseudoVLSEG2E64FF_V_M4_MASK }, // 143
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG2E8_V_M1_MASK }, // 144
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG2E8_V_M2_MASK }, // 145
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x3, 0x2, PseudoVLSSEG2E8_V_M4_MASK }, // 146
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG2E8_V_MF8_MASK }, // 147
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG2E8_V_MF4_MASK }, // 148
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG2E8_V_MF2_MASK }, // 149
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG2E16_V_M1_MASK }, // 150
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG2E16_V_M2_MASK }, // 151
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x4, 0x2, PseudoVLSSEG2E16_V_M4_MASK }, // 152
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG2E16_V_MF4_MASK }, // 153
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG2E16_V_MF2_MASK }, // 154
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG2E32_V_M1_MASK }, // 155
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG2E32_V_M2_MASK }, // 156
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x5, 0x2, PseudoVLSSEG2E32_V_M4_MASK }, // 157
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG2E32_V_MF2_MASK }, // 158
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG2E64_V_M1_MASK }, // 159
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG2E64_V_M2_MASK }, // 160
  { 0x2, 0x1, 0x1, 0x1, 0x0, 0x6, 0x2, PseudoVLSSEG2E64_V_M4_MASK }, // 161
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG3E8_V_M1 }, // 162
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG3E8_V_M2 }, // 163
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG3E8_V_MF8 }, // 164
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG3E8_V_MF4 }, // 165
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG3E8_V_MF2 }, // 166
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG3E16_V_M1 }, // 167
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG3E16_V_M2 }, // 168
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG3E16_V_MF4 }, // 169
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG3E16_V_MF2 }, // 170
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG3E32_V_M1 }, // 171
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG3E32_V_M2 }, // 172
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG3E32_V_MF2 }, // 173
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG3E64_V_M1 }, // 174
  { 0x3, 0x0, 0x0, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG3E64_V_M2 }, // 175
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG3E8FF_V_M1 }, // 176
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG3E8FF_V_M2 }, // 177
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG3E8FF_V_MF8 }, // 178
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG3E8FF_V_MF4 }, // 179
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG3E8FF_V_MF2 }, // 180
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG3E16FF_V_M1 }, // 181
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG3E16FF_V_M2 }, // 182
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG3E16FF_V_MF4 }, // 183
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG3E16FF_V_MF2 }, // 184
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG3E32FF_V_M1 }, // 185
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG3E32FF_V_M2 }, // 186
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG3E32FF_V_MF2 }, // 187
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG3E64FF_V_M1 }, // 188
  { 0x3, 0x0, 0x0, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG3E64FF_V_M2 }, // 189
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG3E8_V_M1 }, // 190
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG3E8_V_M2 }, // 191
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG3E8_V_MF8 }, // 192
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG3E8_V_MF4 }, // 193
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG3E8_V_MF2 }, // 194
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG3E16_V_M1 }, // 195
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG3E16_V_M2 }, // 196
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG3E16_V_MF4 }, // 197
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG3E16_V_MF2 }, // 198
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG3E32_V_M1 }, // 199
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG3E32_V_M2 }, // 200
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG3E32_V_MF2 }, // 201
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG3E64_V_M1 }, // 202
  { 0x3, 0x0, 0x0, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG3E64_V_M2 }, // 203
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG3E8_V_M1_TU }, // 204
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG3E8_V_M2_TU }, // 205
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG3E8_V_MF8_TU }, // 206
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG3E8_V_MF4_TU }, // 207
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG3E8_V_MF2_TU }, // 208
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG3E16_V_M1_TU }, // 209
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG3E16_V_M2_TU }, // 210
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG3E16_V_MF4_TU }, // 211
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG3E16_V_MF2_TU }, // 212
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG3E32_V_M1_TU }, // 213
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG3E32_V_M2_TU }, // 214
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG3E32_V_MF2_TU }, // 215
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG3E64_V_M1_TU }, // 216
  { 0x3, 0x0, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG3E64_V_M2_TU }, // 217
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG3E8FF_V_M1_TU }, // 218
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG3E8FF_V_M2_TU }, // 219
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG3E8FF_V_MF8_TU }, // 220
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG3E8FF_V_MF4_TU }, // 221
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG3E8FF_V_MF2_TU }, // 222
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG3E16FF_V_M1_TU }, // 223
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG3E16FF_V_M2_TU }, // 224
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG3E16FF_V_MF4_TU }, // 225
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG3E16FF_V_MF2_TU }, // 226
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG3E32FF_V_M1_TU }, // 227
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG3E32FF_V_M2_TU }, // 228
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG3E32FF_V_MF2_TU }, // 229
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG3E64FF_V_M1_TU }, // 230
  { 0x3, 0x0, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG3E64FF_V_M2_TU }, // 231
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG3E8_V_M1_TU }, // 232
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG3E8_V_M2_TU }, // 233
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG3E8_V_MF8_TU }, // 234
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG3E8_V_MF4_TU }, // 235
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG3E8_V_MF2_TU }, // 236
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG3E16_V_M1_TU }, // 237
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG3E16_V_M2_TU }, // 238
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG3E16_V_MF4_TU }, // 239
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG3E16_V_MF2_TU }, // 240
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG3E32_V_M1_TU }, // 241
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG3E32_V_M2_TU }, // 242
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG3E32_V_MF2_TU }, // 243
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG3E64_V_M1_TU }, // 244
  { 0x3, 0x0, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG3E64_V_M2_TU }, // 245
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG3E8_V_M1_MASK }, // 246
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG3E8_V_M2_MASK }, // 247
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG3E8_V_MF8_MASK }, // 248
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG3E8_V_MF4_MASK }, // 249
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG3E8_V_MF2_MASK }, // 250
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG3E16_V_M1_MASK }, // 251
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG3E16_V_M2_MASK }, // 252
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG3E16_V_MF4_MASK }, // 253
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG3E16_V_MF2_MASK }, // 254
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG3E32_V_M1_MASK }, // 255
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG3E32_V_M2_MASK }, // 256
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG3E32_V_MF2_MASK }, // 257
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG3E64_V_M1_MASK }, // 258
  { 0x3, 0x1, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG3E64_V_M2_MASK }, // 259
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG3E8FF_V_M1_MASK }, // 260
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG3E8FF_V_M2_MASK }, // 261
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG3E8FF_V_MF8_MASK }, // 262
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG3E8FF_V_MF4_MASK }, // 263
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG3E8FF_V_MF2_MASK }, // 264
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG3E16FF_V_M1_MASK }, // 265
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG3E16FF_V_M2_MASK }, // 266
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG3E16FF_V_MF4_MASK }, // 267
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG3E16FF_V_MF2_MASK }, // 268
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG3E32FF_V_M1_MASK }, // 269
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG3E32FF_V_M2_MASK }, // 270
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG3E32FF_V_MF2_MASK }, // 271
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG3E64FF_V_M1_MASK }, // 272
  { 0x3, 0x1, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG3E64FF_V_M2_MASK }, // 273
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG3E8_V_M1_MASK }, // 274
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG3E8_V_M2_MASK }, // 275
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG3E8_V_MF8_MASK }, // 276
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG3E8_V_MF4_MASK }, // 277
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG3E8_V_MF2_MASK }, // 278
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG3E16_V_M1_MASK }, // 279
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG3E16_V_M2_MASK }, // 280
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG3E16_V_MF4_MASK }, // 281
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG3E16_V_MF2_MASK }, // 282
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG3E32_V_M1_MASK }, // 283
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG3E32_V_M2_MASK }, // 284
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG3E32_V_MF2_MASK }, // 285
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG3E64_V_M1_MASK }, // 286
  { 0x3, 0x1, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG3E64_V_M2_MASK }, // 287
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG4E8_V_M1 }, // 288
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG4E8_V_M2 }, // 289
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG4E8_V_MF8 }, // 290
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG4E8_V_MF4 }, // 291
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG4E8_V_MF2 }, // 292
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG4E16_V_M1 }, // 293
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG4E16_V_M2 }, // 294
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG4E16_V_MF4 }, // 295
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG4E16_V_MF2 }, // 296
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG4E32_V_M1 }, // 297
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG4E32_V_M2 }, // 298
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG4E32_V_MF2 }, // 299
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG4E64_V_M1 }, // 300
  { 0x4, 0x0, 0x0, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG4E64_V_M2 }, // 301
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG4E8FF_V_M1 }, // 302
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG4E8FF_V_M2 }, // 303
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG4E8FF_V_MF8 }, // 304
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG4E8FF_V_MF4 }, // 305
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG4E8FF_V_MF2 }, // 306
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG4E16FF_V_M1 }, // 307
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG4E16FF_V_M2 }, // 308
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG4E16FF_V_MF4 }, // 309
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG4E16FF_V_MF2 }, // 310
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG4E32FF_V_M1 }, // 311
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG4E32FF_V_M2 }, // 312
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG4E32FF_V_MF2 }, // 313
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG4E64FF_V_M1 }, // 314
  { 0x4, 0x0, 0x0, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG4E64FF_V_M2 }, // 315
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG4E8_V_M1 }, // 316
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG4E8_V_M2 }, // 317
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG4E8_V_MF8 }, // 318
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG4E8_V_MF4 }, // 319
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG4E8_V_MF2 }, // 320
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG4E16_V_M1 }, // 321
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG4E16_V_M2 }, // 322
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG4E16_V_MF4 }, // 323
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG4E16_V_MF2 }, // 324
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG4E32_V_M1 }, // 325
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG4E32_V_M2 }, // 326
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG4E32_V_MF2 }, // 327
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG4E64_V_M1 }, // 328
  { 0x4, 0x0, 0x0, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG4E64_V_M2 }, // 329
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG4E8_V_M1_TU }, // 330
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG4E8_V_M2_TU }, // 331
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG4E8_V_MF8_TU }, // 332
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG4E8_V_MF4_TU }, // 333
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG4E8_V_MF2_TU }, // 334
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG4E16_V_M1_TU }, // 335
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG4E16_V_M2_TU }, // 336
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG4E16_V_MF4_TU }, // 337
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG4E16_V_MF2_TU }, // 338
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG4E32_V_M1_TU }, // 339
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG4E32_V_M2_TU }, // 340
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG4E32_V_MF2_TU }, // 341
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG4E64_V_M1_TU }, // 342
  { 0x4, 0x0, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG4E64_V_M2_TU }, // 343
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG4E8FF_V_M1_TU }, // 344
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG4E8FF_V_M2_TU }, // 345
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG4E8FF_V_MF8_TU }, // 346
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG4E8FF_V_MF4_TU }, // 347
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG4E8FF_V_MF2_TU }, // 348
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG4E16FF_V_M1_TU }, // 349
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG4E16FF_V_M2_TU }, // 350
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG4E16FF_V_MF4_TU }, // 351
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG4E16FF_V_MF2_TU }, // 352
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG4E32FF_V_M1_TU }, // 353
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG4E32FF_V_M2_TU }, // 354
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG4E32FF_V_MF2_TU }, // 355
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG4E64FF_V_M1_TU }, // 356
  { 0x4, 0x0, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG4E64FF_V_M2_TU }, // 357
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG4E8_V_M1_TU }, // 358
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG4E8_V_M2_TU }, // 359
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG4E8_V_MF8_TU }, // 360
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG4E8_V_MF4_TU }, // 361
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG4E8_V_MF2_TU }, // 362
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG4E16_V_M1_TU }, // 363
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG4E16_V_M2_TU }, // 364
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG4E16_V_MF4_TU }, // 365
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG4E16_V_MF2_TU }, // 366
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG4E32_V_M1_TU }, // 367
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG4E32_V_M2_TU }, // 368
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG4E32_V_MF2_TU }, // 369
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG4E64_V_M1_TU }, // 370
  { 0x4, 0x0, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG4E64_V_M2_TU }, // 371
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG4E8_V_M1_MASK }, // 372
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x3, 0x1, PseudoVLSEG4E8_V_M2_MASK }, // 373
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG4E8_V_MF8_MASK }, // 374
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG4E8_V_MF4_MASK }, // 375
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG4E8_V_MF2_MASK }, // 376
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG4E16_V_M1_MASK }, // 377
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x4, 0x1, PseudoVLSEG4E16_V_M2_MASK }, // 378
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG4E16_V_MF4_MASK }, // 379
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG4E16_V_MF2_MASK }, // 380
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG4E32_V_M1_MASK }, // 381
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x5, 0x1, PseudoVLSEG4E32_V_M2_MASK }, // 382
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG4E32_V_MF2_MASK }, // 383
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG4E64_V_M1_MASK }, // 384
  { 0x4, 0x1, 0x1, 0x0, 0x0, 0x6, 0x1, PseudoVLSEG4E64_V_M2_MASK }, // 385
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG4E8FF_V_M1_MASK }, // 386
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x3, 0x1, PseudoVLSEG4E8FF_V_M2_MASK }, // 387
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG4E8FF_V_MF8_MASK }, // 388
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG4E8FF_V_MF4_MASK }, // 389
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG4E8FF_V_MF2_MASK }, // 390
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG4E16FF_V_M1_MASK }, // 391
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x4, 0x1, PseudoVLSEG4E16FF_V_M2_MASK }, // 392
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG4E16FF_V_MF4_MASK }, // 393
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG4E16FF_V_MF2_MASK }, // 394
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG4E32FF_V_M1_MASK }, // 395
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x5, 0x1, PseudoVLSEG4E32FF_V_M2_MASK }, // 396
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG4E32FF_V_MF2_MASK }, // 397
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG4E64FF_V_M1_MASK }, // 398
  { 0x4, 0x1, 0x1, 0x0, 0x1, 0x6, 0x1, PseudoVLSEG4E64FF_V_M2_MASK }, // 399
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG4E8_V_M1_MASK }, // 400
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x3, 0x1, PseudoVLSSEG4E8_V_M2_MASK }, // 401
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG4E8_V_MF8_MASK }, // 402
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG4E8_V_MF4_MASK }, // 403
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG4E8_V_MF2_MASK }, // 404
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG4E16_V_M1_MASK }, // 405
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x4, 0x1, PseudoVLSSEG4E16_V_M2_MASK }, // 406
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG4E16_V_MF4_MASK }, // 407
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG4E16_V_MF2_MASK }, // 408
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG4E32_V_M1_MASK }, // 409
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x5, 0x1, PseudoVLSSEG4E32_V_M2_MASK }, // 410
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG4E32_V_MF2_MASK }, // 411
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG4E64_V_M1_MASK }, // 412
  { 0x4, 0x1, 0x1, 0x1, 0x0, 0x6, 0x1, PseudoVLSSEG4E64_V_M2_MASK }, // 413
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG5E8_V_M1 }, // 414
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG5E8_V_MF8 }, // 415
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG5E8_V_MF4 }, // 416
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG5E8_V_MF2 }, // 417
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG5E16_V_M1 }, // 418
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG5E16_V_MF4 }, // 419
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG5E16_V_MF2 }, // 420
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG5E32_V_M1 }, // 421
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG5E32_V_MF2 }, // 422
  { 0x5, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG5E64_V_M1 }, // 423
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG5E8FF_V_M1 }, // 424
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG5E8FF_V_MF8 }, // 425
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG5E8FF_V_MF4 }, // 426
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG5E8FF_V_MF2 }, // 427
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG5E16FF_V_M1 }, // 428
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG5E16FF_V_MF4 }, // 429
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG5E16FF_V_MF2 }, // 430
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG5E32FF_V_M1 }, // 431
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG5E32FF_V_MF2 }, // 432
  { 0x5, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG5E64FF_V_M1 }, // 433
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG5E8_V_M1 }, // 434
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG5E8_V_MF8 }, // 435
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG5E8_V_MF4 }, // 436
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG5E8_V_MF2 }, // 437
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG5E16_V_M1 }, // 438
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG5E16_V_MF4 }, // 439
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG5E16_V_MF2 }, // 440
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG5E32_V_M1 }, // 441
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG5E32_V_MF2 }, // 442
  { 0x5, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG5E64_V_M1 }, // 443
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG5E8_V_M1_TU }, // 444
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG5E8_V_MF8_TU }, // 445
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG5E8_V_MF4_TU }, // 446
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG5E8_V_MF2_TU }, // 447
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG5E16_V_M1_TU }, // 448
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG5E16_V_MF4_TU }, // 449
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG5E16_V_MF2_TU }, // 450
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG5E32_V_M1_TU }, // 451
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG5E32_V_MF2_TU }, // 452
  { 0x5, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG5E64_V_M1_TU }, // 453
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG5E8FF_V_M1_TU }, // 454
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG5E8FF_V_MF8_TU }, // 455
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG5E8FF_V_MF4_TU }, // 456
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG5E8FF_V_MF2_TU }, // 457
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG5E16FF_V_M1_TU }, // 458
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG5E16FF_V_MF4_TU }, // 459
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG5E16FF_V_MF2_TU }, // 460
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG5E32FF_V_M1_TU }, // 461
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG5E32FF_V_MF2_TU }, // 462
  { 0x5, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG5E64FF_V_M1_TU }, // 463
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG5E8_V_M1_TU }, // 464
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG5E8_V_MF8_TU }, // 465
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG5E8_V_MF4_TU }, // 466
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG5E8_V_MF2_TU }, // 467
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG5E16_V_M1_TU }, // 468
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG5E16_V_MF4_TU }, // 469
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG5E16_V_MF2_TU }, // 470
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG5E32_V_M1_TU }, // 471
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG5E32_V_MF2_TU }, // 472
  { 0x5, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG5E64_V_M1_TU }, // 473
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG5E8_V_M1_MASK }, // 474
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG5E8_V_MF8_MASK }, // 475
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG5E8_V_MF4_MASK }, // 476
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG5E8_V_MF2_MASK }, // 477
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG5E16_V_M1_MASK }, // 478
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG5E16_V_MF4_MASK }, // 479
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG5E16_V_MF2_MASK }, // 480
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG5E32_V_M1_MASK }, // 481
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG5E32_V_MF2_MASK }, // 482
  { 0x5, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG5E64_V_M1_MASK }, // 483
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG5E8FF_V_M1_MASK }, // 484
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG5E8FF_V_MF8_MASK }, // 485
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG5E8FF_V_MF4_MASK }, // 486
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG5E8FF_V_MF2_MASK }, // 487
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG5E16FF_V_M1_MASK }, // 488
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG5E16FF_V_MF4_MASK }, // 489
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG5E16FF_V_MF2_MASK }, // 490
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG5E32FF_V_M1_MASK }, // 491
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG5E32FF_V_MF2_MASK }, // 492
  { 0x5, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG5E64FF_V_M1_MASK }, // 493
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG5E8_V_M1_MASK }, // 494
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG5E8_V_MF8_MASK }, // 495
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG5E8_V_MF4_MASK }, // 496
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG5E8_V_MF2_MASK }, // 497
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG5E16_V_M1_MASK }, // 498
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG5E16_V_MF4_MASK }, // 499
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG5E16_V_MF2_MASK }, // 500
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG5E32_V_M1_MASK }, // 501
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG5E32_V_MF2_MASK }, // 502
  { 0x5, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG5E64_V_M1_MASK }, // 503
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG6E8_V_M1 }, // 504
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG6E8_V_MF8 }, // 505
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG6E8_V_MF4 }, // 506
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG6E8_V_MF2 }, // 507
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG6E16_V_M1 }, // 508
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG6E16_V_MF4 }, // 509
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG6E16_V_MF2 }, // 510
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG6E32_V_M1 }, // 511
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG6E32_V_MF2 }, // 512
  { 0x6, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG6E64_V_M1 }, // 513
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG6E8FF_V_M1 }, // 514
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG6E8FF_V_MF8 }, // 515
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG6E8FF_V_MF4 }, // 516
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG6E8FF_V_MF2 }, // 517
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG6E16FF_V_M1 }, // 518
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG6E16FF_V_MF4 }, // 519
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG6E16FF_V_MF2 }, // 520
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG6E32FF_V_M1 }, // 521
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG6E32FF_V_MF2 }, // 522
  { 0x6, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG6E64FF_V_M1 }, // 523
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG6E8_V_M1 }, // 524
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG6E8_V_MF8 }, // 525
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG6E8_V_MF4 }, // 526
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG6E8_V_MF2 }, // 527
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG6E16_V_M1 }, // 528
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG6E16_V_MF4 }, // 529
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG6E16_V_MF2 }, // 530
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG6E32_V_M1 }, // 531
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG6E32_V_MF2 }, // 532
  { 0x6, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG6E64_V_M1 }, // 533
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG6E8_V_M1_TU }, // 534
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG6E8_V_MF8_TU }, // 535
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG6E8_V_MF4_TU }, // 536
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG6E8_V_MF2_TU }, // 537
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG6E16_V_M1_TU }, // 538
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG6E16_V_MF4_TU }, // 539
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG6E16_V_MF2_TU }, // 540
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG6E32_V_M1_TU }, // 541
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG6E32_V_MF2_TU }, // 542
  { 0x6, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG6E64_V_M1_TU }, // 543
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG6E8FF_V_M1_TU }, // 544
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG6E8FF_V_MF8_TU }, // 545
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG6E8FF_V_MF4_TU }, // 546
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG6E8FF_V_MF2_TU }, // 547
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG6E16FF_V_M1_TU }, // 548
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG6E16FF_V_MF4_TU }, // 549
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG6E16FF_V_MF2_TU }, // 550
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG6E32FF_V_M1_TU }, // 551
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG6E32FF_V_MF2_TU }, // 552
  { 0x6, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG6E64FF_V_M1_TU }, // 553
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG6E8_V_M1_TU }, // 554
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG6E8_V_MF8_TU }, // 555
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG6E8_V_MF4_TU }, // 556
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG6E8_V_MF2_TU }, // 557
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG6E16_V_M1_TU }, // 558
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG6E16_V_MF4_TU }, // 559
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG6E16_V_MF2_TU }, // 560
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG6E32_V_M1_TU }, // 561
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG6E32_V_MF2_TU }, // 562
  { 0x6, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG6E64_V_M1_TU }, // 563
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG6E8_V_M1_MASK }, // 564
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG6E8_V_MF8_MASK }, // 565
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG6E8_V_MF4_MASK }, // 566
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG6E8_V_MF2_MASK }, // 567
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG6E16_V_M1_MASK }, // 568
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG6E16_V_MF4_MASK }, // 569
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG6E16_V_MF2_MASK }, // 570
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG6E32_V_M1_MASK }, // 571
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG6E32_V_MF2_MASK }, // 572
  { 0x6, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG6E64_V_M1_MASK }, // 573
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG6E8FF_V_M1_MASK }, // 574
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG6E8FF_V_MF8_MASK }, // 575
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG6E8FF_V_MF4_MASK }, // 576
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG6E8FF_V_MF2_MASK }, // 577
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG6E16FF_V_M1_MASK }, // 578
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG6E16FF_V_MF4_MASK }, // 579
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG6E16FF_V_MF2_MASK }, // 580
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG6E32FF_V_M1_MASK }, // 581
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG6E32FF_V_MF2_MASK }, // 582
  { 0x6, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG6E64FF_V_M1_MASK }, // 583
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG6E8_V_M1_MASK }, // 584
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG6E8_V_MF8_MASK }, // 585
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG6E8_V_MF4_MASK }, // 586
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG6E8_V_MF2_MASK }, // 587
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG6E16_V_M1_MASK }, // 588
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG6E16_V_MF4_MASK }, // 589
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG6E16_V_MF2_MASK }, // 590
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG6E32_V_M1_MASK }, // 591
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG6E32_V_MF2_MASK }, // 592
  { 0x6, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG6E64_V_M1_MASK }, // 593
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG7E8_V_M1 }, // 594
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG7E8_V_MF8 }, // 595
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG7E8_V_MF4 }, // 596
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG7E8_V_MF2 }, // 597
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG7E16_V_M1 }, // 598
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG7E16_V_MF4 }, // 599
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG7E16_V_MF2 }, // 600
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG7E32_V_M1 }, // 601
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG7E32_V_MF2 }, // 602
  { 0x7, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG7E64_V_M1 }, // 603
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG7E8FF_V_M1 }, // 604
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG7E8FF_V_MF8 }, // 605
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG7E8FF_V_MF4 }, // 606
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG7E8FF_V_MF2 }, // 607
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG7E16FF_V_M1 }, // 608
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG7E16FF_V_MF4 }, // 609
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG7E16FF_V_MF2 }, // 610
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG7E32FF_V_M1 }, // 611
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG7E32FF_V_MF2 }, // 612
  { 0x7, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG7E64FF_V_M1 }, // 613
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG7E8_V_M1 }, // 614
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG7E8_V_MF8 }, // 615
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG7E8_V_MF4 }, // 616
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG7E8_V_MF2 }, // 617
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG7E16_V_M1 }, // 618
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG7E16_V_MF4 }, // 619
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG7E16_V_MF2 }, // 620
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG7E32_V_M1 }, // 621
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG7E32_V_MF2 }, // 622
  { 0x7, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG7E64_V_M1 }, // 623
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG7E8_V_M1_TU }, // 624
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG7E8_V_MF8_TU }, // 625
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG7E8_V_MF4_TU }, // 626
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG7E8_V_MF2_TU }, // 627
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG7E16_V_M1_TU }, // 628
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG7E16_V_MF4_TU }, // 629
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG7E16_V_MF2_TU }, // 630
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG7E32_V_M1_TU }, // 631
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG7E32_V_MF2_TU }, // 632
  { 0x7, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG7E64_V_M1_TU }, // 633
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG7E8FF_V_M1_TU }, // 634
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG7E8FF_V_MF8_TU }, // 635
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG7E8FF_V_MF4_TU }, // 636
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG7E8FF_V_MF2_TU }, // 637
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG7E16FF_V_M1_TU }, // 638
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG7E16FF_V_MF4_TU }, // 639
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG7E16FF_V_MF2_TU }, // 640
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG7E32FF_V_M1_TU }, // 641
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG7E32FF_V_MF2_TU }, // 642
  { 0x7, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG7E64FF_V_M1_TU }, // 643
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG7E8_V_M1_TU }, // 644
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG7E8_V_MF8_TU }, // 645
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG7E8_V_MF4_TU }, // 646
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG7E8_V_MF2_TU }, // 647
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG7E16_V_M1_TU }, // 648
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG7E16_V_MF4_TU }, // 649
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG7E16_V_MF2_TU }, // 650
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG7E32_V_M1_TU }, // 651
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG7E32_V_MF2_TU }, // 652
  { 0x7, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG7E64_V_M1_TU }, // 653
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG7E8_V_M1_MASK }, // 654
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG7E8_V_MF8_MASK }, // 655
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG7E8_V_MF4_MASK }, // 656
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG7E8_V_MF2_MASK }, // 657
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG7E16_V_M1_MASK }, // 658
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG7E16_V_MF4_MASK }, // 659
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG7E16_V_MF2_MASK }, // 660
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG7E32_V_M1_MASK }, // 661
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG7E32_V_MF2_MASK }, // 662
  { 0x7, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG7E64_V_M1_MASK }, // 663
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG7E8FF_V_M1_MASK }, // 664
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG7E8FF_V_MF8_MASK }, // 665
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG7E8FF_V_MF4_MASK }, // 666
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG7E8FF_V_MF2_MASK }, // 667
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG7E16FF_V_M1_MASK }, // 668
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG7E16FF_V_MF4_MASK }, // 669
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG7E16FF_V_MF2_MASK }, // 670
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG7E32FF_V_M1_MASK }, // 671
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG7E32FF_V_MF2_MASK }, // 672
  { 0x7, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG7E64FF_V_M1_MASK }, // 673
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG7E8_V_M1_MASK }, // 674
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG7E8_V_MF8_MASK }, // 675
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG7E8_V_MF4_MASK }, // 676
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG7E8_V_MF2_MASK }, // 677
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG7E16_V_M1_MASK }, // 678
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG7E16_V_MF4_MASK }, // 679
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG7E16_V_MF2_MASK }, // 680
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG7E32_V_M1_MASK }, // 681
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG7E32_V_MF2_MASK }, // 682
  { 0x7, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG7E64_V_M1_MASK }, // 683
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG8E8_V_M1 }, // 684
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG8E8_V_MF8 }, // 685
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG8E8_V_MF4 }, // 686
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG8E8_V_MF2 }, // 687
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG8E16_V_M1 }, // 688
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG8E16_V_MF4 }, // 689
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG8E16_V_MF2 }, // 690
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG8E32_V_M1 }, // 691
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG8E32_V_MF2 }, // 692
  { 0x8, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG8E64_V_M1 }, // 693
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG8E8FF_V_M1 }, // 694
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG8E8FF_V_MF8 }, // 695
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG8E8FF_V_MF4 }, // 696
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG8E8FF_V_MF2 }, // 697
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG8E16FF_V_M1 }, // 698
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG8E16FF_V_MF4 }, // 699
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG8E16FF_V_MF2 }, // 700
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG8E32FF_V_M1 }, // 701
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG8E32FF_V_MF2 }, // 702
  { 0x8, 0x0, 0x0, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG8E64FF_V_M1 }, // 703
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG8E8_V_M1 }, // 704
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG8E8_V_MF8 }, // 705
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG8E8_V_MF4 }, // 706
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG8E8_V_MF2 }, // 707
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG8E16_V_M1 }, // 708
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG8E16_V_MF4 }, // 709
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG8E16_V_MF2 }, // 710
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG8E32_V_M1 }, // 711
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG8E32_V_MF2 }, // 712
  { 0x8, 0x0, 0x0, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG8E64_V_M1 }, // 713
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG8E8_V_M1_TU }, // 714
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG8E8_V_MF8_TU }, // 715
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG8E8_V_MF4_TU }, // 716
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG8E8_V_MF2_TU }, // 717
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG8E16_V_M1_TU }, // 718
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG8E16_V_MF4_TU }, // 719
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG8E16_V_MF2_TU }, // 720
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG8E32_V_M1_TU }, // 721
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG8E32_V_MF2_TU }, // 722
  { 0x8, 0x0, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG8E64_V_M1_TU }, // 723
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG8E8FF_V_M1_TU }, // 724
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG8E8FF_V_MF8_TU }, // 725
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG8E8FF_V_MF4_TU }, // 726
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG8E8FF_V_MF2_TU }, // 727
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG8E16FF_V_M1_TU }, // 728
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG8E16FF_V_MF4_TU }, // 729
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG8E16FF_V_MF2_TU }, // 730
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG8E32FF_V_M1_TU }, // 731
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG8E32FF_V_MF2_TU }, // 732
  { 0x8, 0x0, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG8E64FF_V_M1_TU }, // 733
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG8E8_V_M1_TU }, // 734
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG8E8_V_MF8_TU }, // 735
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG8E8_V_MF4_TU }, // 736
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG8E8_V_MF2_TU }, // 737
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG8E16_V_M1_TU }, // 738
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG8E16_V_MF4_TU }, // 739
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG8E16_V_MF2_TU }, // 740
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG8E32_V_M1_TU }, // 741
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG8E32_V_MF2_TU }, // 742
  { 0x8, 0x0, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG8E64_V_M1_TU }, // 743
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x3, 0x0, PseudoVLSEG8E8_V_M1_MASK }, // 744
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x3, 0x5, PseudoVLSEG8E8_V_MF8_MASK }, // 745
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x3, 0x6, PseudoVLSEG8E8_V_MF4_MASK }, // 746
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x3, 0x7, PseudoVLSEG8E8_V_MF2_MASK }, // 747
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x4, 0x0, PseudoVLSEG8E16_V_M1_MASK }, // 748
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x4, 0x6, PseudoVLSEG8E16_V_MF4_MASK }, // 749
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x4, 0x7, PseudoVLSEG8E16_V_MF2_MASK }, // 750
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x5, 0x0, PseudoVLSEG8E32_V_M1_MASK }, // 751
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x5, 0x7, PseudoVLSEG8E32_V_MF2_MASK }, // 752
  { 0x8, 0x1, 0x1, 0x0, 0x0, 0x6, 0x0, PseudoVLSEG8E64_V_M1_MASK }, // 753
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x3, 0x0, PseudoVLSEG8E8FF_V_M1_MASK }, // 754
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x3, 0x5, PseudoVLSEG8E8FF_V_MF8_MASK }, // 755
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x3, 0x6, PseudoVLSEG8E8FF_V_MF4_MASK }, // 756
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x3, 0x7, PseudoVLSEG8E8FF_V_MF2_MASK }, // 757
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x4, 0x0, PseudoVLSEG8E16FF_V_M1_MASK }, // 758
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x4, 0x6, PseudoVLSEG8E16FF_V_MF4_MASK }, // 759
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x4, 0x7, PseudoVLSEG8E16FF_V_MF2_MASK }, // 760
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x5, 0x0, PseudoVLSEG8E32FF_V_M1_MASK }, // 761
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x5, 0x7, PseudoVLSEG8E32FF_V_MF2_MASK }, // 762
  { 0x8, 0x1, 0x1, 0x0, 0x1, 0x6, 0x0, PseudoVLSEG8E64FF_V_M1_MASK }, // 763
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x3, 0x0, PseudoVLSSEG8E8_V_M1_MASK }, // 764
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x3, 0x5, PseudoVLSSEG8E8_V_MF8_MASK }, // 765
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x3, 0x6, PseudoVLSSEG8E8_V_MF4_MASK }, // 766
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x3, 0x7, PseudoVLSSEG8E8_V_MF2_MASK }, // 767
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x4, 0x0, PseudoVLSSEG8E16_V_M1_MASK }, // 768
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x4, 0x6, PseudoVLSSEG8E16_V_MF4_MASK }, // 769
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x4, 0x7, PseudoVLSSEG8E16_V_MF2_MASK }, // 770
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x5, 0x0, PseudoVLSSEG8E32_V_M1_MASK }, // 771
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x5, 0x7, PseudoVLSSEG8E32_V_MF2_MASK }, // 772
  { 0x8, 0x1, 0x1, 0x1, 0x0, 0x6, 0x0, PseudoVLSSEG8E64_V_M1_MASK }, // 773
 };

const VLSEGPseudo *getVLSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t IsTU, uint8_t Strided, uint8_t FF, uint8_t Log2SEW, uint8_t LMUL) {
  struct KeyType {
    uint8_t NF;
    uint8_t Masked;
    uint8_t IsTU;
    uint8_t Strided;
    uint8_t FF;
    uint8_t Log2SEW;
    uint8_t LMUL;
  };
  KeyType Key = {NF, Masked, IsTU, Strided, FF, Log2SEW, LMUL};
  auto Table = ArrayRef(RISCVVLSEGTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VLSEGPseudo &LHS, const KeyType &RHS) {
      if (LHS.NF < RHS.NF)
        return true;
      if (LHS.NF > RHS.NF)
        return false;
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.IsTU < RHS.IsTU)
        return true;
      if (LHS.IsTU > RHS.IsTU)
        return false;
      if (LHS.Strided < RHS.Strided)
        return true;
      if (LHS.Strided > RHS.Strided)
        return false;
      if (LHS.FF < RHS.FF)
        return true;
      if (LHS.FF > RHS.FF)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.NF != Idx->NF ||
      Key.Masked != Idx->Masked ||
      Key.IsTU != Idx->IsTU ||
      Key.Strided != Idx->Strided ||
      Key.FF != Idx->FF ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVLXSEGTable_DECL
const VLXSEGPseudo *getVLXSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t IsTU, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL);
#endif

#ifdef GET_RISCVVLXSEGTable_IMPL
constexpr VLXSEGPseudo RISCVVLXSEGTable[] = {
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG2EI8_V_M1_M1 }, // 0
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG2EI8_V_MF8_M1 }, // 1
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG2EI8_V_MF4_M1 }, // 2
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG2EI8_V_MF2_M1 }, // 3
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG2EI8_V_M1_M2 }, // 4
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG2EI8_V_M2_M2 }, // 5
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG2EI8_V_MF4_M2 }, // 6
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG2EI8_V_MF2_M2 }, // 7
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x2, 0x0, PseudoVLUXSEG2EI8_V_M1_M4 }, // 8
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x2, 0x1, PseudoVLUXSEG2EI8_V_M2_M4 }, // 9
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x2, 0x2, PseudoVLUXSEG2EI8_V_M4_M4 }, // 10
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x2, 0x7, PseudoVLUXSEG2EI8_V_MF2_M4 }, // 11
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF8 }, // 12
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF4 }, // 13
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF4 }, // 14
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF2 }, // 15
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF2 }, // 16
  { 0x2, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF2 }, // 17
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG2EI16_V_M1_M1 }, // 18
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG2EI16_V_M2_M1 }, // 19
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG2EI16_V_MF4_M1 }, // 20
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG2EI16_V_MF2_M1 }, // 21
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG2EI16_V_M1_M2 }, // 22
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG2EI16_V_M2_M2 }, // 23
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG2EI16_V_M4_M2 }, // 24
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG2EI16_V_MF2_M2 }, // 25
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x2, 0x0, PseudoVLUXSEG2EI16_V_M1_M4 }, // 26
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x2, 0x1, PseudoVLUXSEG2EI16_V_M2_M4 }, // 27
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x2, 0x2, PseudoVLUXSEG2EI16_V_M4_M4 }, // 28
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x2, 0x3, PseudoVLUXSEG2EI16_V_M8_M4 }, // 29
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF8 }, // 30
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF4 }, // 31
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF4 }, // 32
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG2EI16_V_M1_MF2 }, // 33
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF2 }, // 34
  { 0x2, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF2 }, // 35
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG2EI32_V_M1_M1 }, // 36
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG2EI32_V_M2_M1 }, // 37
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG2EI32_V_M4_M1 }, // 38
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG2EI32_V_MF2_M1 }, // 39
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG2EI32_V_M1_M2 }, // 40
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG2EI32_V_M2_M2 }, // 41
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG2EI32_V_M4_M2 }, // 42
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG2EI32_V_M8_M2 }, // 43
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x2, 0x1, PseudoVLUXSEG2EI32_V_M2_M4 }, // 44
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x2, 0x2, PseudoVLUXSEG2EI32_V_M4_M4 }, // 45
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x2, 0x3, PseudoVLUXSEG2EI32_V_M8_M4 }, // 46
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF8 }, // 47
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG2EI32_V_M1_MF4 }, // 48
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF4 }, // 49
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG2EI32_V_M1_MF2 }, // 50
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG2EI32_V_M2_MF2 }, // 51
  { 0x2, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF2 }, // 52
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG2EI64_V_M1_M1 }, // 53
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG2EI64_V_M2_M1 }, // 54
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG2EI64_V_M4_M1 }, // 55
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG2EI64_V_M8_M1 }, // 56
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG2EI64_V_M2_M2 }, // 57
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG2EI64_V_M4_M2 }, // 58
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG2EI64_V_M8_M2 }, // 59
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x2, 0x2, PseudoVLUXSEG2EI64_V_M4_M4 }, // 60
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x2, 0x3, PseudoVLUXSEG2EI64_V_M8_M4 }, // 61
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG2EI64_V_M1_MF8 }, // 62
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG2EI64_V_M1_MF4 }, // 63
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG2EI64_V_M2_MF4 }, // 64
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG2EI64_V_M1_MF2 }, // 65
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG2EI64_V_M2_MF2 }, // 66
  { 0x2, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG2EI64_V_M4_MF2 }, // 67
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG2EI8_V_M1_M1 }, // 68
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG2EI8_V_MF8_M1 }, // 69
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG2EI8_V_MF4_M1 }, // 70
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG2EI8_V_MF2_M1 }, // 71
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG2EI8_V_M1_M2 }, // 72
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG2EI8_V_M2_M2 }, // 73
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG2EI8_V_MF4_M2 }, // 74
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG2EI8_V_MF2_M2 }, // 75
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, PseudoVLOXSEG2EI8_V_M1_M4 }, // 76
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x2, 0x1, PseudoVLOXSEG2EI8_V_M2_M4 }, // 77
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x2, 0x2, PseudoVLOXSEG2EI8_V_M4_M4 }, // 78
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x2, 0x7, PseudoVLOXSEG2EI8_V_MF2_M4 }, // 79
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF8 }, // 80
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF4 }, // 81
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF4 }, // 82
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF2 }, // 83
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF2 }, // 84
  { 0x2, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF2 }, // 85
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG2EI16_V_M1_M1 }, // 86
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG2EI16_V_M2_M1 }, // 87
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG2EI16_V_MF4_M1 }, // 88
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG2EI16_V_MF2_M1 }, // 89
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG2EI16_V_M1_M2 }, // 90
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG2EI16_V_M2_M2 }, // 91
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG2EI16_V_M4_M2 }, // 92
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG2EI16_V_MF2_M2 }, // 93
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x2, 0x0, PseudoVLOXSEG2EI16_V_M1_M4 }, // 94
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x2, 0x1, PseudoVLOXSEG2EI16_V_M2_M4 }, // 95
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x2, 0x2, PseudoVLOXSEG2EI16_V_M4_M4 }, // 96
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x2, 0x3, PseudoVLOXSEG2EI16_V_M8_M4 }, // 97
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF8 }, // 98
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF4 }, // 99
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF4 }, // 100
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG2EI16_V_M1_MF2 }, // 101
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF2 }, // 102
  { 0x2, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF2 }, // 103
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG2EI32_V_M1_M1 }, // 104
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG2EI32_V_M2_M1 }, // 105
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG2EI32_V_M4_M1 }, // 106
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG2EI32_V_MF2_M1 }, // 107
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG2EI32_V_M1_M2 }, // 108
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG2EI32_V_M2_M2 }, // 109
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG2EI32_V_M4_M2 }, // 110
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG2EI32_V_M8_M2 }, // 111
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x2, 0x1, PseudoVLOXSEG2EI32_V_M2_M4 }, // 112
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x2, 0x2, PseudoVLOXSEG2EI32_V_M4_M4 }, // 113
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x2, 0x3, PseudoVLOXSEG2EI32_V_M8_M4 }, // 114
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF8 }, // 115
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG2EI32_V_M1_MF4 }, // 116
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF4 }, // 117
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG2EI32_V_M1_MF2 }, // 118
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG2EI32_V_M2_MF2 }, // 119
  { 0x2, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF2 }, // 120
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG2EI64_V_M1_M1 }, // 121
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG2EI64_V_M2_M1 }, // 122
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG2EI64_V_M4_M1 }, // 123
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG2EI64_V_M8_M1 }, // 124
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG2EI64_V_M2_M2 }, // 125
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG2EI64_V_M4_M2 }, // 126
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG2EI64_V_M8_M2 }, // 127
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x2, 0x2, PseudoVLOXSEG2EI64_V_M4_M4 }, // 128
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x2, 0x3, PseudoVLOXSEG2EI64_V_M8_M4 }, // 129
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG2EI64_V_M1_MF8 }, // 130
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG2EI64_V_M1_MF4 }, // 131
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG2EI64_V_M2_MF4 }, // 132
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG2EI64_V_M1_MF2 }, // 133
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG2EI64_V_M2_MF2 }, // 134
  { 0x2, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG2EI64_V_M4_MF2 }, // 135
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG2EI8_V_M1_M1_TU }, // 136
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG2EI8_V_MF8_M1_TU }, // 137
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG2EI8_V_MF4_M1_TU }, // 138
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG2EI8_V_MF2_M1_TU }, // 139
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG2EI8_V_M1_M2_TU }, // 140
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG2EI8_V_M2_M2_TU }, // 141
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG2EI8_V_MF4_M2_TU }, // 142
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG2EI8_V_MF2_M2_TU }, // 143
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x2, 0x0, PseudoVLUXSEG2EI8_V_M1_M4_TU }, // 144
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x2, 0x1, PseudoVLUXSEG2EI8_V_M2_M4_TU }, // 145
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x2, 0x2, PseudoVLUXSEG2EI8_V_M4_M4_TU }, // 146
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x2, 0x7, PseudoVLUXSEG2EI8_V_MF2_M4_TU }, // 147
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF8_TU }, // 148
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF4_TU }, // 149
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF4_TU }, // 150
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF2_TU }, // 151
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF2_TU }, // 152
  { 0x2, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF2_TU }, // 153
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG2EI16_V_M1_M1_TU }, // 154
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG2EI16_V_M2_M1_TU }, // 155
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG2EI16_V_MF4_M1_TU }, // 156
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG2EI16_V_MF2_M1_TU }, // 157
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG2EI16_V_M1_M2_TU }, // 158
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG2EI16_V_M2_M2_TU }, // 159
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG2EI16_V_M4_M2_TU }, // 160
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG2EI16_V_MF2_M2_TU }, // 161
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x2, 0x0, PseudoVLUXSEG2EI16_V_M1_M4_TU }, // 162
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x2, 0x1, PseudoVLUXSEG2EI16_V_M2_M4_TU }, // 163
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x2, 0x2, PseudoVLUXSEG2EI16_V_M4_M4_TU }, // 164
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x2, 0x3, PseudoVLUXSEG2EI16_V_M8_M4_TU }, // 165
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF8_TU }, // 166
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF4_TU }, // 167
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF4_TU }, // 168
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG2EI16_V_M1_MF2_TU }, // 169
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF2_TU }, // 170
  { 0x2, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF2_TU }, // 171
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG2EI32_V_M1_M1_TU }, // 172
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG2EI32_V_M2_M1_TU }, // 173
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG2EI32_V_M4_M1_TU }, // 174
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG2EI32_V_MF2_M1_TU }, // 175
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG2EI32_V_M1_M2_TU }, // 176
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG2EI32_V_M2_M2_TU }, // 177
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG2EI32_V_M4_M2_TU }, // 178
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG2EI32_V_M8_M2_TU }, // 179
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x2, 0x1, PseudoVLUXSEG2EI32_V_M2_M4_TU }, // 180
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x2, 0x2, PseudoVLUXSEG2EI32_V_M4_M4_TU }, // 181
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x2, 0x3, PseudoVLUXSEG2EI32_V_M8_M4_TU }, // 182
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF8_TU }, // 183
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG2EI32_V_M1_MF4_TU }, // 184
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF4_TU }, // 185
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG2EI32_V_M1_MF2_TU }, // 186
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG2EI32_V_M2_MF2_TU }, // 187
  { 0x2, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF2_TU }, // 188
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG2EI64_V_M1_M1_TU }, // 189
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG2EI64_V_M2_M1_TU }, // 190
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG2EI64_V_M4_M1_TU }, // 191
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG2EI64_V_M8_M1_TU }, // 192
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG2EI64_V_M2_M2_TU }, // 193
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG2EI64_V_M4_M2_TU }, // 194
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG2EI64_V_M8_M2_TU }, // 195
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x2, 0x2, PseudoVLUXSEG2EI64_V_M4_M4_TU }, // 196
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x2, 0x3, PseudoVLUXSEG2EI64_V_M8_M4_TU }, // 197
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG2EI64_V_M1_MF8_TU }, // 198
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG2EI64_V_M1_MF4_TU }, // 199
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG2EI64_V_M2_MF4_TU }, // 200
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG2EI64_V_M1_MF2_TU }, // 201
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG2EI64_V_M2_MF2_TU }, // 202
  { 0x2, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG2EI64_V_M4_MF2_TU }, // 203
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG2EI8_V_M1_M1_TU }, // 204
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG2EI8_V_MF8_M1_TU }, // 205
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG2EI8_V_MF4_M1_TU }, // 206
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG2EI8_V_MF2_M1_TU }, // 207
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG2EI8_V_M1_M2_TU }, // 208
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG2EI8_V_M2_M2_TU }, // 209
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG2EI8_V_MF4_M2_TU }, // 210
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG2EI8_V_MF2_M2_TU }, // 211
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x2, 0x0, PseudoVLOXSEG2EI8_V_M1_M4_TU }, // 212
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x2, 0x1, PseudoVLOXSEG2EI8_V_M2_M4_TU }, // 213
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x2, 0x2, PseudoVLOXSEG2EI8_V_M4_M4_TU }, // 214
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x2, 0x7, PseudoVLOXSEG2EI8_V_MF2_M4_TU }, // 215
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF8_TU }, // 216
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF4_TU }, // 217
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF4_TU }, // 218
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF2_TU }, // 219
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF2_TU }, // 220
  { 0x2, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF2_TU }, // 221
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG2EI16_V_M1_M1_TU }, // 222
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG2EI16_V_M2_M1_TU }, // 223
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG2EI16_V_MF4_M1_TU }, // 224
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG2EI16_V_MF2_M1_TU }, // 225
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG2EI16_V_M1_M2_TU }, // 226
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG2EI16_V_M2_M2_TU }, // 227
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG2EI16_V_M4_M2_TU }, // 228
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG2EI16_V_MF2_M2_TU }, // 229
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x2, 0x0, PseudoVLOXSEG2EI16_V_M1_M4_TU }, // 230
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x2, 0x1, PseudoVLOXSEG2EI16_V_M2_M4_TU }, // 231
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x2, 0x2, PseudoVLOXSEG2EI16_V_M4_M4_TU }, // 232
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x2, 0x3, PseudoVLOXSEG2EI16_V_M8_M4_TU }, // 233
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF8_TU }, // 234
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF4_TU }, // 235
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF4_TU }, // 236
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG2EI16_V_M1_MF2_TU }, // 237
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF2_TU }, // 238
  { 0x2, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF2_TU }, // 239
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG2EI32_V_M1_M1_TU }, // 240
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG2EI32_V_M2_M1_TU }, // 241
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG2EI32_V_M4_M1_TU }, // 242
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG2EI32_V_MF2_M1_TU }, // 243
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG2EI32_V_M1_M2_TU }, // 244
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG2EI32_V_M2_M2_TU }, // 245
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG2EI32_V_M4_M2_TU }, // 246
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG2EI32_V_M8_M2_TU }, // 247
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x2, 0x1, PseudoVLOXSEG2EI32_V_M2_M4_TU }, // 248
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x2, 0x2, PseudoVLOXSEG2EI32_V_M4_M4_TU }, // 249
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x2, 0x3, PseudoVLOXSEG2EI32_V_M8_M4_TU }, // 250
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF8_TU }, // 251
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG2EI32_V_M1_MF4_TU }, // 252
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF4_TU }, // 253
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG2EI32_V_M1_MF2_TU }, // 254
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG2EI32_V_M2_MF2_TU }, // 255
  { 0x2, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF2_TU }, // 256
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG2EI64_V_M1_M1_TU }, // 257
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG2EI64_V_M2_M1_TU }, // 258
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG2EI64_V_M4_M1_TU }, // 259
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG2EI64_V_M8_M1_TU }, // 260
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG2EI64_V_M2_M2_TU }, // 261
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG2EI64_V_M4_M2_TU }, // 262
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG2EI64_V_M8_M2_TU }, // 263
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x2, 0x2, PseudoVLOXSEG2EI64_V_M4_M4_TU }, // 264
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x2, 0x3, PseudoVLOXSEG2EI64_V_M8_M4_TU }, // 265
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG2EI64_V_M1_MF8_TU }, // 266
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG2EI64_V_M1_MF4_TU }, // 267
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG2EI64_V_M2_MF4_TU }, // 268
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG2EI64_V_M1_MF2_TU }, // 269
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG2EI64_V_M2_MF2_TU }, // 270
  { 0x2, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG2EI64_V_M4_MF2_TU }, // 271
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG2EI8_V_M1_M1_MASK }, // 272
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG2EI8_V_MF8_M1_MASK }, // 273
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG2EI8_V_MF4_M1_MASK }, // 274
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG2EI8_V_MF2_M1_MASK }, // 275
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG2EI8_V_M1_M2_MASK }, // 276
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG2EI8_V_M2_M2_MASK }, // 277
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG2EI8_V_MF4_M2_MASK }, // 278
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG2EI8_V_MF2_M2_MASK }, // 279
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x2, 0x0, PseudoVLUXSEG2EI8_V_M1_M4_MASK }, // 280
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x2, 0x1, PseudoVLUXSEG2EI8_V_M2_M4_MASK }, // 281
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x2, 0x2, PseudoVLUXSEG2EI8_V_M4_M4_MASK }, // 282
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x2, 0x7, PseudoVLUXSEG2EI8_V_MF2_M4_MASK }, // 283
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF8_MASK }, // 284
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF4_MASK }, // 285
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF4_MASK }, // 286
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF2_MASK }, // 287
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF2_MASK }, // 288
  { 0x2, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF2_MASK }, // 289
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG2EI16_V_M1_M1_MASK }, // 290
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG2EI16_V_M2_M1_MASK }, // 291
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG2EI16_V_MF4_M1_MASK }, // 292
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG2EI16_V_MF2_M1_MASK }, // 293
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG2EI16_V_M1_M2_MASK }, // 294
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG2EI16_V_M2_M2_MASK }, // 295
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG2EI16_V_M4_M2_MASK }, // 296
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG2EI16_V_MF2_M2_MASK }, // 297
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x2, 0x0, PseudoVLUXSEG2EI16_V_M1_M4_MASK }, // 298
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x2, 0x1, PseudoVLUXSEG2EI16_V_M2_M4_MASK }, // 299
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x2, 0x2, PseudoVLUXSEG2EI16_V_M4_M4_MASK }, // 300
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x2, 0x3, PseudoVLUXSEG2EI16_V_M8_M4_MASK }, // 301
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF8_MASK }, // 302
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF4_MASK }, // 303
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF4_MASK }, // 304
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG2EI16_V_M1_MF2_MASK }, // 305
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF2_MASK }, // 306
  { 0x2, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF2_MASK }, // 307
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG2EI32_V_M1_M1_MASK }, // 308
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG2EI32_V_M2_M1_MASK }, // 309
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG2EI32_V_M4_M1_MASK }, // 310
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG2EI32_V_MF2_M1_MASK }, // 311
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG2EI32_V_M1_M2_MASK }, // 312
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG2EI32_V_M2_M2_MASK }, // 313
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG2EI32_V_M4_M2_MASK }, // 314
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG2EI32_V_M8_M2_MASK }, // 315
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x2, 0x1, PseudoVLUXSEG2EI32_V_M2_M4_MASK }, // 316
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x2, 0x2, PseudoVLUXSEG2EI32_V_M4_M4_MASK }, // 317
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x2, 0x3, PseudoVLUXSEG2EI32_V_M8_M4_MASK }, // 318
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF8_MASK }, // 319
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG2EI32_V_M1_MF4_MASK }, // 320
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF4_MASK }, // 321
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG2EI32_V_M1_MF2_MASK }, // 322
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG2EI32_V_M2_MF2_MASK }, // 323
  { 0x2, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF2_MASK }, // 324
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG2EI64_V_M1_M1_MASK }, // 325
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG2EI64_V_M2_M1_MASK }, // 326
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG2EI64_V_M4_M1_MASK }, // 327
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG2EI64_V_M8_M1_MASK }, // 328
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG2EI64_V_M2_M2_MASK }, // 329
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG2EI64_V_M4_M2_MASK }, // 330
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG2EI64_V_M8_M2_MASK }, // 331
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x2, 0x2, PseudoVLUXSEG2EI64_V_M4_M4_MASK }, // 332
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x2, 0x3, PseudoVLUXSEG2EI64_V_M8_M4_MASK }, // 333
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG2EI64_V_M1_MF8_MASK }, // 334
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG2EI64_V_M1_MF4_MASK }, // 335
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG2EI64_V_M2_MF4_MASK }, // 336
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG2EI64_V_M1_MF2_MASK }, // 337
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG2EI64_V_M2_MF2_MASK }, // 338
  { 0x2, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG2EI64_V_M4_MF2_MASK }, // 339
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG2EI8_V_M1_M1_MASK }, // 340
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG2EI8_V_MF8_M1_MASK }, // 341
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG2EI8_V_MF4_M1_MASK }, // 342
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG2EI8_V_MF2_M1_MASK }, // 343
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG2EI8_V_M1_M2_MASK }, // 344
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG2EI8_V_M2_M2_MASK }, // 345
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG2EI8_V_MF4_M2_MASK }, // 346
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG2EI8_V_MF2_M2_MASK }, // 347
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x2, 0x0, PseudoVLOXSEG2EI8_V_M1_M4_MASK }, // 348
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x2, 0x1, PseudoVLOXSEG2EI8_V_M2_M4_MASK }, // 349
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x2, 0x2, PseudoVLOXSEG2EI8_V_M4_M4_MASK }, // 350
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x2, 0x7, PseudoVLOXSEG2EI8_V_MF2_M4_MASK }, // 351
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF8_MASK }, // 352
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF4_MASK }, // 353
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF4_MASK }, // 354
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF2_MASK }, // 355
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF2_MASK }, // 356
  { 0x2, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF2_MASK }, // 357
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG2EI16_V_M1_M1_MASK }, // 358
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG2EI16_V_M2_M1_MASK }, // 359
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG2EI16_V_MF4_M1_MASK }, // 360
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG2EI16_V_MF2_M1_MASK }, // 361
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG2EI16_V_M1_M2_MASK }, // 362
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG2EI16_V_M2_M2_MASK }, // 363
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG2EI16_V_M4_M2_MASK }, // 364
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG2EI16_V_MF2_M2_MASK }, // 365
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x2, 0x0, PseudoVLOXSEG2EI16_V_M1_M4_MASK }, // 366
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x2, 0x1, PseudoVLOXSEG2EI16_V_M2_M4_MASK }, // 367
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x2, 0x2, PseudoVLOXSEG2EI16_V_M4_M4_MASK }, // 368
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x2, 0x3, PseudoVLOXSEG2EI16_V_M8_M4_MASK }, // 369
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF8_MASK }, // 370
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF4_MASK }, // 371
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF4_MASK }, // 372
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG2EI16_V_M1_MF2_MASK }, // 373
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF2_MASK }, // 374
  { 0x2, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF2_MASK }, // 375
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG2EI32_V_M1_M1_MASK }, // 376
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG2EI32_V_M2_M1_MASK }, // 377
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG2EI32_V_M4_M1_MASK }, // 378
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG2EI32_V_MF2_M1_MASK }, // 379
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG2EI32_V_M1_M2_MASK }, // 380
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG2EI32_V_M2_M2_MASK }, // 381
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG2EI32_V_M4_M2_MASK }, // 382
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG2EI32_V_M8_M2_MASK }, // 383
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x2, 0x1, PseudoVLOXSEG2EI32_V_M2_M4_MASK }, // 384
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x2, 0x2, PseudoVLOXSEG2EI32_V_M4_M4_MASK }, // 385
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x2, 0x3, PseudoVLOXSEG2EI32_V_M8_M4_MASK }, // 386
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF8_MASK }, // 387
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG2EI32_V_M1_MF4_MASK }, // 388
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF4_MASK }, // 389
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG2EI32_V_M1_MF2_MASK }, // 390
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG2EI32_V_M2_MF2_MASK }, // 391
  { 0x2, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF2_MASK }, // 392
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG2EI64_V_M1_M1_MASK }, // 393
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG2EI64_V_M2_M1_MASK }, // 394
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG2EI64_V_M4_M1_MASK }, // 395
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG2EI64_V_M8_M1_MASK }, // 396
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG2EI64_V_M2_M2_MASK }, // 397
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG2EI64_V_M4_M2_MASK }, // 398
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG2EI64_V_M8_M2_MASK }, // 399
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x2, 0x2, PseudoVLOXSEG2EI64_V_M4_M4_MASK }, // 400
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x2, 0x3, PseudoVLOXSEG2EI64_V_M8_M4_MASK }, // 401
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG2EI64_V_M1_MF8_MASK }, // 402
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG2EI64_V_M1_MF4_MASK }, // 403
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG2EI64_V_M2_MF4_MASK }, // 404
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG2EI64_V_M1_MF2_MASK }, // 405
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG2EI64_V_M2_MF2_MASK }, // 406
  { 0x2, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG2EI64_V_M4_MF2_MASK }, // 407
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG3EI8_V_M1_M1 }, // 408
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG3EI8_V_MF8_M1 }, // 409
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG3EI8_V_MF4_M1 }, // 410
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG3EI8_V_MF2_M1 }, // 411
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG3EI8_V_M1_M2 }, // 412
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG3EI8_V_M2_M2 }, // 413
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG3EI8_V_MF4_M2 }, // 414
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG3EI8_V_MF2_M2 }, // 415
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF8 }, // 416
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF4 }, // 417
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF4 }, // 418
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF2 }, // 419
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF2 }, // 420
  { 0x3, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF2 }, // 421
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG3EI16_V_M1_M1 }, // 422
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG3EI16_V_M2_M1 }, // 423
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG3EI16_V_MF4_M1 }, // 424
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG3EI16_V_MF2_M1 }, // 425
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG3EI16_V_M1_M2 }, // 426
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG3EI16_V_M2_M2 }, // 427
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG3EI16_V_M4_M2 }, // 428
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG3EI16_V_MF2_M2 }, // 429
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF8 }, // 430
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF4 }, // 431
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF4 }, // 432
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG3EI16_V_M1_MF2 }, // 433
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF2 }, // 434
  { 0x3, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF2 }, // 435
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG3EI32_V_M1_M1 }, // 436
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG3EI32_V_M2_M1 }, // 437
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG3EI32_V_M4_M1 }, // 438
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG3EI32_V_MF2_M1 }, // 439
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG3EI32_V_M1_M2 }, // 440
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG3EI32_V_M2_M2 }, // 441
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG3EI32_V_M4_M2 }, // 442
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG3EI32_V_M8_M2 }, // 443
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF8 }, // 444
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG3EI32_V_M1_MF4 }, // 445
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF4 }, // 446
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG3EI32_V_M1_MF2 }, // 447
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG3EI32_V_M2_MF2 }, // 448
  { 0x3, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF2 }, // 449
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG3EI64_V_M1_M1 }, // 450
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG3EI64_V_M2_M1 }, // 451
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG3EI64_V_M4_M1 }, // 452
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG3EI64_V_M8_M1 }, // 453
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG3EI64_V_M2_M2 }, // 454
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG3EI64_V_M4_M2 }, // 455
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG3EI64_V_M8_M2 }, // 456
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG3EI64_V_M1_MF8 }, // 457
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG3EI64_V_M1_MF4 }, // 458
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG3EI64_V_M2_MF4 }, // 459
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG3EI64_V_M1_MF2 }, // 460
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG3EI64_V_M2_MF2 }, // 461
  { 0x3, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG3EI64_V_M4_MF2 }, // 462
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG3EI8_V_M1_M1 }, // 463
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG3EI8_V_MF8_M1 }, // 464
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG3EI8_V_MF4_M1 }, // 465
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG3EI8_V_MF2_M1 }, // 466
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG3EI8_V_M1_M2 }, // 467
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG3EI8_V_M2_M2 }, // 468
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG3EI8_V_MF4_M2 }, // 469
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG3EI8_V_MF2_M2 }, // 470
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF8 }, // 471
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF4 }, // 472
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF4 }, // 473
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF2 }, // 474
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF2 }, // 475
  { 0x3, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF2 }, // 476
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG3EI16_V_M1_M1 }, // 477
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG3EI16_V_M2_M1 }, // 478
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG3EI16_V_MF4_M1 }, // 479
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG3EI16_V_MF2_M1 }, // 480
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG3EI16_V_M1_M2 }, // 481
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG3EI16_V_M2_M2 }, // 482
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG3EI16_V_M4_M2 }, // 483
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG3EI16_V_MF2_M2 }, // 484
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF8 }, // 485
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF4 }, // 486
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF4 }, // 487
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG3EI16_V_M1_MF2 }, // 488
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF2 }, // 489
  { 0x3, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF2 }, // 490
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG3EI32_V_M1_M1 }, // 491
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG3EI32_V_M2_M1 }, // 492
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG3EI32_V_M4_M1 }, // 493
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG3EI32_V_MF2_M1 }, // 494
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG3EI32_V_M1_M2 }, // 495
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG3EI32_V_M2_M2 }, // 496
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG3EI32_V_M4_M2 }, // 497
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG3EI32_V_M8_M2 }, // 498
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF8 }, // 499
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG3EI32_V_M1_MF4 }, // 500
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF4 }, // 501
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG3EI32_V_M1_MF2 }, // 502
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG3EI32_V_M2_MF2 }, // 503
  { 0x3, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF2 }, // 504
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG3EI64_V_M1_M1 }, // 505
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG3EI64_V_M2_M1 }, // 506
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG3EI64_V_M4_M1 }, // 507
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG3EI64_V_M8_M1 }, // 508
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG3EI64_V_M2_M2 }, // 509
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG3EI64_V_M4_M2 }, // 510
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG3EI64_V_M8_M2 }, // 511
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG3EI64_V_M1_MF8 }, // 512
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG3EI64_V_M1_MF4 }, // 513
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG3EI64_V_M2_MF4 }, // 514
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG3EI64_V_M1_MF2 }, // 515
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG3EI64_V_M2_MF2 }, // 516
  { 0x3, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG3EI64_V_M4_MF2 }, // 517
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG3EI8_V_M1_M1_TU }, // 518
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG3EI8_V_MF8_M1_TU }, // 519
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG3EI8_V_MF4_M1_TU }, // 520
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG3EI8_V_MF2_M1_TU }, // 521
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG3EI8_V_M1_M2_TU }, // 522
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG3EI8_V_M2_M2_TU }, // 523
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG3EI8_V_MF4_M2_TU }, // 524
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG3EI8_V_MF2_M2_TU }, // 525
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF8_TU }, // 526
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF4_TU }, // 527
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF4_TU }, // 528
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF2_TU }, // 529
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF2_TU }, // 530
  { 0x3, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF2_TU }, // 531
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG3EI16_V_M1_M1_TU }, // 532
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG3EI16_V_M2_M1_TU }, // 533
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG3EI16_V_MF4_M1_TU }, // 534
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG3EI16_V_MF2_M1_TU }, // 535
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG3EI16_V_M1_M2_TU }, // 536
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG3EI16_V_M2_M2_TU }, // 537
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG3EI16_V_M4_M2_TU }, // 538
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG3EI16_V_MF2_M2_TU }, // 539
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF8_TU }, // 540
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF4_TU }, // 541
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF4_TU }, // 542
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG3EI16_V_M1_MF2_TU }, // 543
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF2_TU }, // 544
  { 0x3, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF2_TU }, // 545
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG3EI32_V_M1_M1_TU }, // 546
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG3EI32_V_M2_M1_TU }, // 547
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG3EI32_V_M4_M1_TU }, // 548
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG3EI32_V_MF2_M1_TU }, // 549
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG3EI32_V_M1_M2_TU }, // 550
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG3EI32_V_M2_M2_TU }, // 551
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG3EI32_V_M4_M2_TU }, // 552
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG3EI32_V_M8_M2_TU }, // 553
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF8_TU }, // 554
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG3EI32_V_M1_MF4_TU }, // 555
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF4_TU }, // 556
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG3EI32_V_M1_MF2_TU }, // 557
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG3EI32_V_M2_MF2_TU }, // 558
  { 0x3, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF2_TU }, // 559
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG3EI64_V_M1_M1_TU }, // 560
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG3EI64_V_M2_M1_TU }, // 561
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG3EI64_V_M4_M1_TU }, // 562
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG3EI64_V_M8_M1_TU }, // 563
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG3EI64_V_M2_M2_TU }, // 564
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG3EI64_V_M4_M2_TU }, // 565
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG3EI64_V_M8_M2_TU }, // 566
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG3EI64_V_M1_MF8_TU }, // 567
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG3EI64_V_M1_MF4_TU }, // 568
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG3EI64_V_M2_MF4_TU }, // 569
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG3EI64_V_M1_MF2_TU }, // 570
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG3EI64_V_M2_MF2_TU }, // 571
  { 0x3, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG3EI64_V_M4_MF2_TU }, // 572
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG3EI8_V_M1_M1_TU }, // 573
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG3EI8_V_MF8_M1_TU }, // 574
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG3EI8_V_MF4_M1_TU }, // 575
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG3EI8_V_MF2_M1_TU }, // 576
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG3EI8_V_M1_M2_TU }, // 577
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG3EI8_V_M2_M2_TU }, // 578
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG3EI8_V_MF4_M2_TU }, // 579
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG3EI8_V_MF2_M2_TU }, // 580
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF8_TU }, // 581
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF4_TU }, // 582
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF4_TU }, // 583
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF2_TU }, // 584
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF2_TU }, // 585
  { 0x3, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF2_TU }, // 586
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG3EI16_V_M1_M1_TU }, // 587
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG3EI16_V_M2_M1_TU }, // 588
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG3EI16_V_MF4_M1_TU }, // 589
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG3EI16_V_MF2_M1_TU }, // 590
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG3EI16_V_M1_M2_TU }, // 591
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG3EI16_V_M2_M2_TU }, // 592
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG3EI16_V_M4_M2_TU }, // 593
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG3EI16_V_MF2_M2_TU }, // 594
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF8_TU }, // 595
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF4_TU }, // 596
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF4_TU }, // 597
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG3EI16_V_M1_MF2_TU }, // 598
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF2_TU }, // 599
  { 0x3, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF2_TU }, // 600
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG3EI32_V_M1_M1_TU }, // 601
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG3EI32_V_M2_M1_TU }, // 602
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG3EI32_V_M4_M1_TU }, // 603
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG3EI32_V_MF2_M1_TU }, // 604
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG3EI32_V_M1_M2_TU }, // 605
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG3EI32_V_M2_M2_TU }, // 606
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG3EI32_V_M4_M2_TU }, // 607
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG3EI32_V_M8_M2_TU }, // 608
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF8_TU }, // 609
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG3EI32_V_M1_MF4_TU }, // 610
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF4_TU }, // 611
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG3EI32_V_M1_MF2_TU }, // 612
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG3EI32_V_M2_MF2_TU }, // 613
  { 0x3, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF2_TU }, // 614
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG3EI64_V_M1_M1_TU }, // 615
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG3EI64_V_M2_M1_TU }, // 616
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG3EI64_V_M4_M1_TU }, // 617
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG3EI64_V_M8_M1_TU }, // 618
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG3EI64_V_M2_M2_TU }, // 619
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG3EI64_V_M4_M2_TU }, // 620
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG3EI64_V_M8_M2_TU }, // 621
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG3EI64_V_M1_MF8_TU }, // 622
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG3EI64_V_M1_MF4_TU }, // 623
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG3EI64_V_M2_MF4_TU }, // 624
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG3EI64_V_M1_MF2_TU }, // 625
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG3EI64_V_M2_MF2_TU }, // 626
  { 0x3, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG3EI64_V_M4_MF2_TU }, // 627
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG3EI8_V_M1_M1_MASK }, // 628
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG3EI8_V_MF8_M1_MASK }, // 629
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG3EI8_V_MF4_M1_MASK }, // 630
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG3EI8_V_MF2_M1_MASK }, // 631
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG3EI8_V_M1_M2_MASK }, // 632
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG3EI8_V_M2_M2_MASK }, // 633
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG3EI8_V_MF4_M2_MASK }, // 634
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG3EI8_V_MF2_M2_MASK }, // 635
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF8_MASK }, // 636
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF4_MASK }, // 637
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF4_MASK }, // 638
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF2_MASK }, // 639
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF2_MASK }, // 640
  { 0x3, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF2_MASK }, // 641
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG3EI16_V_M1_M1_MASK }, // 642
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG3EI16_V_M2_M1_MASK }, // 643
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG3EI16_V_MF4_M1_MASK }, // 644
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG3EI16_V_MF2_M1_MASK }, // 645
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG3EI16_V_M1_M2_MASK }, // 646
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG3EI16_V_M2_M2_MASK }, // 647
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG3EI16_V_M4_M2_MASK }, // 648
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG3EI16_V_MF2_M2_MASK }, // 649
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF8_MASK }, // 650
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF4_MASK }, // 651
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF4_MASK }, // 652
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG3EI16_V_M1_MF2_MASK }, // 653
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF2_MASK }, // 654
  { 0x3, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF2_MASK }, // 655
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG3EI32_V_M1_M1_MASK }, // 656
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG3EI32_V_M2_M1_MASK }, // 657
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG3EI32_V_M4_M1_MASK }, // 658
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG3EI32_V_MF2_M1_MASK }, // 659
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG3EI32_V_M1_M2_MASK }, // 660
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG3EI32_V_M2_M2_MASK }, // 661
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG3EI32_V_M4_M2_MASK }, // 662
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG3EI32_V_M8_M2_MASK }, // 663
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF8_MASK }, // 664
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG3EI32_V_M1_MF4_MASK }, // 665
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF4_MASK }, // 666
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG3EI32_V_M1_MF2_MASK }, // 667
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG3EI32_V_M2_MF2_MASK }, // 668
  { 0x3, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF2_MASK }, // 669
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG3EI64_V_M1_M1_MASK }, // 670
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG3EI64_V_M2_M1_MASK }, // 671
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG3EI64_V_M4_M1_MASK }, // 672
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG3EI64_V_M8_M1_MASK }, // 673
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG3EI64_V_M2_M2_MASK }, // 674
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG3EI64_V_M4_M2_MASK }, // 675
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG3EI64_V_M8_M2_MASK }, // 676
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG3EI64_V_M1_MF8_MASK }, // 677
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG3EI64_V_M1_MF4_MASK }, // 678
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG3EI64_V_M2_MF4_MASK }, // 679
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG3EI64_V_M1_MF2_MASK }, // 680
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG3EI64_V_M2_MF2_MASK }, // 681
  { 0x3, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG3EI64_V_M4_MF2_MASK }, // 682
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG3EI8_V_M1_M1_MASK }, // 683
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG3EI8_V_MF8_M1_MASK }, // 684
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG3EI8_V_MF4_M1_MASK }, // 685
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG3EI8_V_MF2_M1_MASK }, // 686
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG3EI8_V_M1_M2_MASK }, // 687
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG3EI8_V_M2_M2_MASK }, // 688
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG3EI8_V_MF4_M2_MASK }, // 689
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG3EI8_V_MF2_M2_MASK }, // 690
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF8_MASK }, // 691
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF4_MASK }, // 692
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF4_MASK }, // 693
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF2_MASK }, // 694
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF2_MASK }, // 695
  { 0x3, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF2_MASK }, // 696
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG3EI16_V_M1_M1_MASK }, // 697
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG3EI16_V_M2_M1_MASK }, // 698
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG3EI16_V_MF4_M1_MASK }, // 699
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG3EI16_V_MF2_M1_MASK }, // 700
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG3EI16_V_M1_M2_MASK }, // 701
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG3EI16_V_M2_M2_MASK }, // 702
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG3EI16_V_M4_M2_MASK }, // 703
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG3EI16_V_MF2_M2_MASK }, // 704
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF8_MASK }, // 705
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF4_MASK }, // 706
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF4_MASK }, // 707
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG3EI16_V_M1_MF2_MASK }, // 708
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF2_MASK }, // 709
  { 0x3, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF2_MASK }, // 710
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG3EI32_V_M1_M1_MASK }, // 711
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG3EI32_V_M2_M1_MASK }, // 712
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG3EI32_V_M4_M1_MASK }, // 713
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG3EI32_V_MF2_M1_MASK }, // 714
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG3EI32_V_M1_M2_MASK }, // 715
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG3EI32_V_M2_M2_MASK }, // 716
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG3EI32_V_M4_M2_MASK }, // 717
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG3EI32_V_M8_M2_MASK }, // 718
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF8_MASK }, // 719
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG3EI32_V_M1_MF4_MASK }, // 720
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF4_MASK }, // 721
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG3EI32_V_M1_MF2_MASK }, // 722
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG3EI32_V_M2_MF2_MASK }, // 723
  { 0x3, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF2_MASK }, // 724
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG3EI64_V_M1_M1_MASK }, // 725
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG3EI64_V_M2_M1_MASK }, // 726
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG3EI64_V_M4_M1_MASK }, // 727
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG3EI64_V_M8_M1_MASK }, // 728
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG3EI64_V_M2_M2_MASK }, // 729
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG3EI64_V_M4_M2_MASK }, // 730
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG3EI64_V_M8_M2_MASK }, // 731
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG3EI64_V_M1_MF8_MASK }, // 732
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG3EI64_V_M1_MF4_MASK }, // 733
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG3EI64_V_M2_MF4_MASK }, // 734
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG3EI64_V_M1_MF2_MASK }, // 735
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG3EI64_V_M2_MF2_MASK }, // 736
  { 0x3, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG3EI64_V_M4_MF2_MASK }, // 737
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG4EI8_V_M1_M1 }, // 738
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG4EI8_V_MF8_M1 }, // 739
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG4EI8_V_MF4_M1 }, // 740
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG4EI8_V_MF2_M1 }, // 741
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG4EI8_V_M1_M2 }, // 742
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG4EI8_V_M2_M2 }, // 743
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG4EI8_V_MF4_M2 }, // 744
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG4EI8_V_MF2_M2 }, // 745
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF8 }, // 746
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF4 }, // 747
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF4 }, // 748
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF2 }, // 749
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF2 }, // 750
  { 0x4, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF2 }, // 751
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG4EI16_V_M1_M1 }, // 752
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG4EI16_V_M2_M1 }, // 753
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG4EI16_V_MF4_M1 }, // 754
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG4EI16_V_MF2_M1 }, // 755
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG4EI16_V_M1_M2 }, // 756
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG4EI16_V_M2_M2 }, // 757
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG4EI16_V_M4_M2 }, // 758
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG4EI16_V_MF2_M2 }, // 759
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF8 }, // 760
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF4 }, // 761
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF4 }, // 762
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG4EI16_V_M1_MF2 }, // 763
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF2 }, // 764
  { 0x4, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF2 }, // 765
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG4EI32_V_M1_M1 }, // 766
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG4EI32_V_M2_M1 }, // 767
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG4EI32_V_M4_M1 }, // 768
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG4EI32_V_MF2_M1 }, // 769
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG4EI32_V_M1_M2 }, // 770
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG4EI32_V_M2_M2 }, // 771
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG4EI32_V_M4_M2 }, // 772
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG4EI32_V_M8_M2 }, // 773
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF8 }, // 774
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG4EI32_V_M1_MF4 }, // 775
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF4 }, // 776
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG4EI32_V_M1_MF2 }, // 777
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG4EI32_V_M2_MF2 }, // 778
  { 0x4, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF2 }, // 779
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG4EI64_V_M1_M1 }, // 780
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG4EI64_V_M2_M1 }, // 781
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG4EI64_V_M4_M1 }, // 782
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG4EI64_V_M8_M1 }, // 783
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG4EI64_V_M2_M2 }, // 784
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG4EI64_V_M4_M2 }, // 785
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG4EI64_V_M8_M2 }, // 786
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG4EI64_V_M1_MF8 }, // 787
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG4EI64_V_M1_MF4 }, // 788
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG4EI64_V_M2_MF4 }, // 789
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG4EI64_V_M1_MF2 }, // 790
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG4EI64_V_M2_MF2 }, // 791
  { 0x4, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG4EI64_V_M4_MF2 }, // 792
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG4EI8_V_M1_M1 }, // 793
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG4EI8_V_MF8_M1 }, // 794
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG4EI8_V_MF4_M1 }, // 795
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG4EI8_V_MF2_M1 }, // 796
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG4EI8_V_M1_M2 }, // 797
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG4EI8_V_M2_M2 }, // 798
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG4EI8_V_MF4_M2 }, // 799
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG4EI8_V_MF2_M2 }, // 800
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF8 }, // 801
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF4 }, // 802
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF4 }, // 803
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF2 }, // 804
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF2 }, // 805
  { 0x4, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF2 }, // 806
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG4EI16_V_M1_M1 }, // 807
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG4EI16_V_M2_M1 }, // 808
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG4EI16_V_MF4_M1 }, // 809
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG4EI16_V_MF2_M1 }, // 810
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG4EI16_V_M1_M2 }, // 811
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG4EI16_V_M2_M2 }, // 812
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG4EI16_V_M4_M2 }, // 813
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG4EI16_V_MF2_M2 }, // 814
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF8 }, // 815
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF4 }, // 816
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF4 }, // 817
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG4EI16_V_M1_MF2 }, // 818
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF2 }, // 819
  { 0x4, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF2 }, // 820
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG4EI32_V_M1_M1 }, // 821
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG4EI32_V_M2_M1 }, // 822
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG4EI32_V_M4_M1 }, // 823
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG4EI32_V_MF2_M1 }, // 824
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG4EI32_V_M1_M2 }, // 825
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG4EI32_V_M2_M2 }, // 826
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG4EI32_V_M4_M2 }, // 827
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG4EI32_V_M8_M2 }, // 828
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF8 }, // 829
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG4EI32_V_M1_MF4 }, // 830
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF4 }, // 831
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG4EI32_V_M1_MF2 }, // 832
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG4EI32_V_M2_MF2 }, // 833
  { 0x4, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF2 }, // 834
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG4EI64_V_M1_M1 }, // 835
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG4EI64_V_M2_M1 }, // 836
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG4EI64_V_M4_M1 }, // 837
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG4EI64_V_M8_M1 }, // 838
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG4EI64_V_M2_M2 }, // 839
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG4EI64_V_M4_M2 }, // 840
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG4EI64_V_M8_M2 }, // 841
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG4EI64_V_M1_MF8 }, // 842
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG4EI64_V_M1_MF4 }, // 843
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG4EI64_V_M2_MF4 }, // 844
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG4EI64_V_M1_MF2 }, // 845
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG4EI64_V_M2_MF2 }, // 846
  { 0x4, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG4EI64_V_M4_MF2 }, // 847
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG4EI8_V_M1_M1_TU }, // 848
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG4EI8_V_MF8_M1_TU }, // 849
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG4EI8_V_MF4_M1_TU }, // 850
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG4EI8_V_MF2_M1_TU }, // 851
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG4EI8_V_M1_M2_TU }, // 852
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG4EI8_V_M2_M2_TU }, // 853
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG4EI8_V_MF4_M2_TU }, // 854
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG4EI8_V_MF2_M2_TU }, // 855
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF8_TU }, // 856
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF4_TU }, // 857
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF4_TU }, // 858
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF2_TU }, // 859
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF2_TU }, // 860
  { 0x4, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF2_TU }, // 861
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG4EI16_V_M1_M1_TU }, // 862
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG4EI16_V_M2_M1_TU }, // 863
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG4EI16_V_MF4_M1_TU }, // 864
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG4EI16_V_MF2_M1_TU }, // 865
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG4EI16_V_M1_M2_TU }, // 866
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG4EI16_V_M2_M2_TU }, // 867
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG4EI16_V_M4_M2_TU }, // 868
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG4EI16_V_MF2_M2_TU }, // 869
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF8_TU }, // 870
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF4_TU }, // 871
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF4_TU }, // 872
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG4EI16_V_M1_MF2_TU }, // 873
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF2_TU }, // 874
  { 0x4, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF2_TU }, // 875
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG4EI32_V_M1_M1_TU }, // 876
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG4EI32_V_M2_M1_TU }, // 877
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG4EI32_V_M4_M1_TU }, // 878
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG4EI32_V_MF2_M1_TU }, // 879
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG4EI32_V_M1_M2_TU }, // 880
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG4EI32_V_M2_M2_TU }, // 881
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG4EI32_V_M4_M2_TU }, // 882
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG4EI32_V_M8_M2_TU }, // 883
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF8_TU }, // 884
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG4EI32_V_M1_MF4_TU }, // 885
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF4_TU }, // 886
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG4EI32_V_M1_MF2_TU }, // 887
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG4EI32_V_M2_MF2_TU }, // 888
  { 0x4, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF2_TU }, // 889
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG4EI64_V_M1_M1_TU }, // 890
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG4EI64_V_M2_M1_TU }, // 891
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG4EI64_V_M4_M1_TU }, // 892
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG4EI64_V_M8_M1_TU }, // 893
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG4EI64_V_M2_M2_TU }, // 894
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG4EI64_V_M4_M2_TU }, // 895
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG4EI64_V_M8_M2_TU }, // 896
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG4EI64_V_M1_MF8_TU }, // 897
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG4EI64_V_M1_MF4_TU }, // 898
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG4EI64_V_M2_MF4_TU }, // 899
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG4EI64_V_M1_MF2_TU }, // 900
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG4EI64_V_M2_MF2_TU }, // 901
  { 0x4, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG4EI64_V_M4_MF2_TU }, // 902
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG4EI8_V_M1_M1_TU }, // 903
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG4EI8_V_MF8_M1_TU }, // 904
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG4EI8_V_MF4_M1_TU }, // 905
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG4EI8_V_MF2_M1_TU }, // 906
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG4EI8_V_M1_M2_TU }, // 907
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG4EI8_V_M2_M2_TU }, // 908
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG4EI8_V_MF4_M2_TU }, // 909
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG4EI8_V_MF2_M2_TU }, // 910
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF8_TU }, // 911
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF4_TU }, // 912
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF4_TU }, // 913
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF2_TU }, // 914
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF2_TU }, // 915
  { 0x4, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF2_TU }, // 916
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG4EI16_V_M1_M1_TU }, // 917
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG4EI16_V_M2_M1_TU }, // 918
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG4EI16_V_MF4_M1_TU }, // 919
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG4EI16_V_MF2_M1_TU }, // 920
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG4EI16_V_M1_M2_TU }, // 921
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG4EI16_V_M2_M2_TU }, // 922
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG4EI16_V_M4_M2_TU }, // 923
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG4EI16_V_MF2_M2_TU }, // 924
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF8_TU }, // 925
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF4_TU }, // 926
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF4_TU }, // 927
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG4EI16_V_M1_MF2_TU }, // 928
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF2_TU }, // 929
  { 0x4, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF2_TU }, // 930
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG4EI32_V_M1_M1_TU }, // 931
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG4EI32_V_M2_M1_TU }, // 932
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG4EI32_V_M4_M1_TU }, // 933
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG4EI32_V_MF2_M1_TU }, // 934
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG4EI32_V_M1_M2_TU }, // 935
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG4EI32_V_M2_M2_TU }, // 936
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG4EI32_V_M4_M2_TU }, // 937
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG4EI32_V_M8_M2_TU }, // 938
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF8_TU }, // 939
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG4EI32_V_M1_MF4_TU }, // 940
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF4_TU }, // 941
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG4EI32_V_M1_MF2_TU }, // 942
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG4EI32_V_M2_MF2_TU }, // 943
  { 0x4, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF2_TU }, // 944
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG4EI64_V_M1_M1_TU }, // 945
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG4EI64_V_M2_M1_TU }, // 946
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG4EI64_V_M4_M1_TU }, // 947
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG4EI64_V_M8_M1_TU }, // 948
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG4EI64_V_M2_M2_TU }, // 949
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG4EI64_V_M4_M2_TU }, // 950
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG4EI64_V_M8_M2_TU }, // 951
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG4EI64_V_M1_MF8_TU }, // 952
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG4EI64_V_M1_MF4_TU }, // 953
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG4EI64_V_M2_MF4_TU }, // 954
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG4EI64_V_M1_MF2_TU }, // 955
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG4EI64_V_M2_MF2_TU }, // 956
  { 0x4, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG4EI64_V_M4_MF2_TU }, // 957
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG4EI8_V_M1_M1_MASK }, // 958
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG4EI8_V_MF8_M1_MASK }, // 959
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG4EI8_V_MF4_M1_MASK }, // 960
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG4EI8_V_MF2_M1_MASK }, // 961
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXSEG4EI8_V_M1_M2_MASK }, // 962
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXSEG4EI8_V_M2_M2_MASK }, // 963
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXSEG4EI8_V_MF4_M2_MASK }, // 964
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXSEG4EI8_V_MF2_M2_MASK }, // 965
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF8_MASK }, // 966
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF4_MASK }, // 967
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF4_MASK }, // 968
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF2_MASK }, // 969
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF2_MASK }, // 970
  { 0x4, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF2_MASK }, // 971
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG4EI16_V_M1_M1_MASK }, // 972
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG4EI16_V_M2_M1_MASK }, // 973
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG4EI16_V_MF4_M1_MASK }, // 974
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG4EI16_V_MF2_M1_MASK }, // 975
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXSEG4EI16_V_M1_M2_MASK }, // 976
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXSEG4EI16_V_M2_M2_MASK }, // 977
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXSEG4EI16_V_M4_M2_MASK }, // 978
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXSEG4EI16_V_MF2_M2_MASK }, // 979
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF8_MASK }, // 980
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF4_MASK }, // 981
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF4_MASK }, // 982
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG4EI16_V_M1_MF2_MASK }, // 983
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF2_MASK }, // 984
  { 0x4, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF2_MASK }, // 985
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG4EI32_V_M1_M1_MASK }, // 986
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG4EI32_V_M2_M1_MASK }, // 987
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG4EI32_V_M4_M1_MASK }, // 988
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG4EI32_V_MF2_M1_MASK }, // 989
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXSEG4EI32_V_M1_M2_MASK }, // 990
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXSEG4EI32_V_M2_M2_MASK }, // 991
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXSEG4EI32_V_M4_M2_MASK }, // 992
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXSEG4EI32_V_M8_M2_MASK }, // 993
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF8_MASK }, // 994
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG4EI32_V_M1_MF4_MASK }, // 995
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF4_MASK }, // 996
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG4EI32_V_M1_MF2_MASK }, // 997
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG4EI32_V_M2_MF2_MASK }, // 998
  { 0x4, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF2_MASK }, // 999
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG4EI64_V_M1_M1_MASK }, // 1000
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG4EI64_V_M2_M1_MASK }, // 1001
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG4EI64_V_M4_M1_MASK }, // 1002
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG4EI64_V_M8_M1_MASK }, // 1003
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXSEG4EI64_V_M2_M2_MASK }, // 1004
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXSEG4EI64_V_M4_M2_MASK }, // 1005
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXSEG4EI64_V_M8_M2_MASK }, // 1006
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG4EI64_V_M1_MF8_MASK }, // 1007
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG4EI64_V_M1_MF4_MASK }, // 1008
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG4EI64_V_M2_MF4_MASK }, // 1009
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG4EI64_V_M1_MF2_MASK }, // 1010
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG4EI64_V_M2_MF2_MASK }, // 1011
  { 0x4, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG4EI64_V_M4_MF2_MASK }, // 1012
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG4EI8_V_M1_M1_MASK }, // 1013
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG4EI8_V_MF8_M1_MASK }, // 1014
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG4EI8_V_MF4_M1_MASK }, // 1015
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG4EI8_V_MF2_M1_MASK }, // 1016
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXSEG4EI8_V_M1_M2_MASK }, // 1017
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXSEG4EI8_V_M2_M2_MASK }, // 1018
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXSEG4EI8_V_MF4_M2_MASK }, // 1019
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXSEG4EI8_V_MF2_M2_MASK }, // 1020
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF8_MASK }, // 1021
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF4_MASK }, // 1022
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF4_MASK }, // 1023
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF2_MASK }, // 1024
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF2_MASK }, // 1025
  { 0x4, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF2_MASK }, // 1026
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG4EI16_V_M1_M1_MASK }, // 1027
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG4EI16_V_M2_M1_MASK }, // 1028
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG4EI16_V_MF4_M1_MASK }, // 1029
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG4EI16_V_MF2_M1_MASK }, // 1030
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXSEG4EI16_V_M1_M2_MASK }, // 1031
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXSEG4EI16_V_M2_M2_MASK }, // 1032
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXSEG4EI16_V_M4_M2_MASK }, // 1033
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXSEG4EI16_V_MF2_M2_MASK }, // 1034
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF8_MASK }, // 1035
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF4_MASK }, // 1036
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF4_MASK }, // 1037
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG4EI16_V_M1_MF2_MASK }, // 1038
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF2_MASK }, // 1039
  { 0x4, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF2_MASK }, // 1040
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG4EI32_V_M1_M1_MASK }, // 1041
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG4EI32_V_M2_M1_MASK }, // 1042
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG4EI32_V_M4_M1_MASK }, // 1043
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG4EI32_V_MF2_M1_MASK }, // 1044
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXSEG4EI32_V_M1_M2_MASK }, // 1045
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXSEG4EI32_V_M2_M2_MASK }, // 1046
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXSEG4EI32_V_M4_M2_MASK }, // 1047
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXSEG4EI32_V_M8_M2_MASK }, // 1048
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF8_MASK }, // 1049
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG4EI32_V_M1_MF4_MASK }, // 1050
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF4_MASK }, // 1051
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG4EI32_V_M1_MF2_MASK }, // 1052
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG4EI32_V_M2_MF2_MASK }, // 1053
  { 0x4, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF2_MASK }, // 1054
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG4EI64_V_M1_M1_MASK }, // 1055
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG4EI64_V_M2_M1_MASK }, // 1056
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG4EI64_V_M4_M1_MASK }, // 1057
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG4EI64_V_M8_M1_MASK }, // 1058
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXSEG4EI64_V_M2_M2_MASK }, // 1059
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXSEG4EI64_V_M4_M2_MASK }, // 1060
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXSEG4EI64_V_M8_M2_MASK }, // 1061
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG4EI64_V_M1_MF8_MASK }, // 1062
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG4EI64_V_M1_MF4_MASK }, // 1063
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG4EI64_V_M2_MF4_MASK }, // 1064
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG4EI64_V_M1_MF2_MASK }, // 1065
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG4EI64_V_M2_MF2_MASK }, // 1066
  { 0x4, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG4EI64_V_M4_MF2_MASK }, // 1067
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG5EI8_V_M1_M1 }, // 1068
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG5EI8_V_MF8_M1 }, // 1069
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG5EI8_V_MF4_M1 }, // 1070
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG5EI8_V_MF2_M1 }, // 1071
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF8 }, // 1072
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF4 }, // 1073
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF4 }, // 1074
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF2 }, // 1075
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF2 }, // 1076
  { 0x5, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF2 }, // 1077
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG5EI16_V_M1_M1 }, // 1078
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG5EI16_V_M2_M1 }, // 1079
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG5EI16_V_MF4_M1 }, // 1080
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG5EI16_V_MF2_M1 }, // 1081
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF8 }, // 1082
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF4 }, // 1083
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF4 }, // 1084
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG5EI16_V_M1_MF2 }, // 1085
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF2 }, // 1086
  { 0x5, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF2 }, // 1087
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG5EI32_V_M1_M1 }, // 1088
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG5EI32_V_M2_M1 }, // 1089
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG5EI32_V_M4_M1 }, // 1090
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG5EI32_V_MF2_M1 }, // 1091
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF8 }, // 1092
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG5EI32_V_M1_MF4 }, // 1093
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF4 }, // 1094
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG5EI32_V_M1_MF2 }, // 1095
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG5EI32_V_M2_MF2 }, // 1096
  { 0x5, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF2 }, // 1097
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG5EI64_V_M1_M1 }, // 1098
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG5EI64_V_M2_M1 }, // 1099
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG5EI64_V_M4_M1 }, // 1100
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG5EI64_V_M8_M1 }, // 1101
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG5EI64_V_M1_MF8 }, // 1102
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG5EI64_V_M1_MF4 }, // 1103
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG5EI64_V_M2_MF4 }, // 1104
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG5EI64_V_M1_MF2 }, // 1105
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG5EI64_V_M2_MF2 }, // 1106
  { 0x5, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG5EI64_V_M4_MF2 }, // 1107
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG5EI8_V_M1_M1 }, // 1108
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG5EI8_V_MF8_M1 }, // 1109
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG5EI8_V_MF4_M1 }, // 1110
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG5EI8_V_MF2_M1 }, // 1111
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF8 }, // 1112
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF4 }, // 1113
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF4 }, // 1114
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF2 }, // 1115
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF2 }, // 1116
  { 0x5, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF2 }, // 1117
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG5EI16_V_M1_M1 }, // 1118
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG5EI16_V_M2_M1 }, // 1119
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG5EI16_V_MF4_M1 }, // 1120
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG5EI16_V_MF2_M1 }, // 1121
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF8 }, // 1122
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF4 }, // 1123
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF4 }, // 1124
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG5EI16_V_M1_MF2 }, // 1125
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF2 }, // 1126
  { 0x5, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF2 }, // 1127
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG5EI32_V_M1_M1 }, // 1128
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG5EI32_V_M2_M1 }, // 1129
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG5EI32_V_M4_M1 }, // 1130
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG5EI32_V_MF2_M1 }, // 1131
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF8 }, // 1132
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG5EI32_V_M1_MF4 }, // 1133
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF4 }, // 1134
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG5EI32_V_M1_MF2 }, // 1135
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG5EI32_V_M2_MF2 }, // 1136
  { 0x5, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF2 }, // 1137
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG5EI64_V_M1_M1 }, // 1138
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG5EI64_V_M2_M1 }, // 1139
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG5EI64_V_M4_M1 }, // 1140
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG5EI64_V_M8_M1 }, // 1141
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG5EI64_V_M1_MF8 }, // 1142
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG5EI64_V_M1_MF4 }, // 1143
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG5EI64_V_M2_MF4 }, // 1144
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG5EI64_V_M1_MF2 }, // 1145
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG5EI64_V_M2_MF2 }, // 1146
  { 0x5, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG5EI64_V_M4_MF2 }, // 1147
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG5EI8_V_M1_M1_TU }, // 1148
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG5EI8_V_MF8_M1_TU }, // 1149
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG5EI8_V_MF4_M1_TU }, // 1150
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG5EI8_V_MF2_M1_TU }, // 1151
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF8_TU }, // 1152
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF4_TU }, // 1153
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF4_TU }, // 1154
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF2_TU }, // 1155
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF2_TU }, // 1156
  { 0x5, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF2_TU }, // 1157
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG5EI16_V_M1_M1_TU }, // 1158
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG5EI16_V_M2_M1_TU }, // 1159
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG5EI16_V_MF4_M1_TU }, // 1160
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG5EI16_V_MF2_M1_TU }, // 1161
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF8_TU }, // 1162
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF4_TU }, // 1163
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF4_TU }, // 1164
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG5EI16_V_M1_MF2_TU }, // 1165
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF2_TU }, // 1166
  { 0x5, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF2_TU }, // 1167
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG5EI32_V_M1_M1_TU }, // 1168
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG5EI32_V_M2_M1_TU }, // 1169
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG5EI32_V_M4_M1_TU }, // 1170
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG5EI32_V_MF2_M1_TU }, // 1171
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF8_TU }, // 1172
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG5EI32_V_M1_MF4_TU }, // 1173
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF4_TU }, // 1174
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG5EI32_V_M1_MF2_TU }, // 1175
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG5EI32_V_M2_MF2_TU }, // 1176
  { 0x5, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF2_TU }, // 1177
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG5EI64_V_M1_M1_TU }, // 1178
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG5EI64_V_M2_M1_TU }, // 1179
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG5EI64_V_M4_M1_TU }, // 1180
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG5EI64_V_M8_M1_TU }, // 1181
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG5EI64_V_M1_MF8_TU }, // 1182
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG5EI64_V_M1_MF4_TU }, // 1183
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG5EI64_V_M2_MF4_TU }, // 1184
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG5EI64_V_M1_MF2_TU }, // 1185
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG5EI64_V_M2_MF2_TU }, // 1186
  { 0x5, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG5EI64_V_M4_MF2_TU }, // 1187
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG5EI8_V_M1_M1_TU }, // 1188
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG5EI8_V_MF8_M1_TU }, // 1189
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG5EI8_V_MF4_M1_TU }, // 1190
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG5EI8_V_MF2_M1_TU }, // 1191
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF8_TU }, // 1192
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF4_TU }, // 1193
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF4_TU }, // 1194
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF2_TU }, // 1195
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF2_TU }, // 1196
  { 0x5, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF2_TU }, // 1197
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG5EI16_V_M1_M1_TU }, // 1198
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG5EI16_V_M2_M1_TU }, // 1199
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG5EI16_V_MF4_M1_TU }, // 1200
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG5EI16_V_MF2_M1_TU }, // 1201
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF8_TU }, // 1202
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF4_TU }, // 1203
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF4_TU }, // 1204
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG5EI16_V_M1_MF2_TU }, // 1205
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF2_TU }, // 1206
  { 0x5, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF2_TU }, // 1207
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG5EI32_V_M1_M1_TU }, // 1208
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG5EI32_V_M2_M1_TU }, // 1209
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG5EI32_V_M4_M1_TU }, // 1210
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG5EI32_V_MF2_M1_TU }, // 1211
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF8_TU }, // 1212
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG5EI32_V_M1_MF4_TU }, // 1213
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF4_TU }, // 1214
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG5EI32_V_M1_MF2_TU }, // 1215
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG5EI32_V_M2_MF2_TU }, // 1216
  { 0x5, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF2_TU }, // 1217
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG5EI64_V_M1_M1_TU }, // 1218
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG5EI64_V_M2_M1_TU }, // 1219
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG5EI64_V_M4_M1_TU }, // 1220
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG5EI64_V_M8_M1_TU }, // 1221
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG5EI64_V_M1_MF8_TU }, // 1222
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG5EI64_V_M1_MF4_TU }, // 1223
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG5EI64_V_M2_MF4_TU }, // 1224
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG5EI64_V_M1_MF2_TU }, // 1225
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG5EI64_V_M2_MF2_TU }, // 1226
  { 0x5, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG5EI64_V_M4_MF2_TU }, // 1227
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG5EI8_V_M1_M1_MASK }, // 1228
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG5EI8_V_MF8_M1_MASK }, // 1229
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG5EI8_V_MF4_M1_MASK }, // 1230
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG5EI8_V_MF2_M1_MASK }, // 1231
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF8_MASK }, // 1232
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF4_MASK }, // 1233
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF4_MASK }, // 1234
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF2_MASK }, // 1235
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF2_MASK }, // 1236
  { 0x5, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF2_MASK }, // 1237
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG5EI16_V_M1_M1_MASK }, // 1238
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG5EI16_V_M2_M1_MASK }, // 1239
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG5EI16_V_MF4_M1_MASK }, // 1240
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG5EI16_V_MF2_M1_MASK }, // 1241
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF8_MASK }, // 1242
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF4_MASK }, // 1243
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF4_MASK }, // 1244
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG5EI16_V_M1_MF2_MASK }, // 1245
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF2_MASK }, // 1246
  { 0x5, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF2_MASK }, // 1247
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG5EI32_V_M1_M1_MASK }, // 1248
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG5EI32_V_M2_M1_MASK }, // 1249
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG5EI32_V_M4_M1_MASK }, // 1250
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG5EI32_V_MF2_M1_MASK }, // 1251
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF8_MASK }, // 1252
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG5EI32_V_M1_MF4_MASK }, // 1253
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF4_MASK }, // 1254
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG5EI32_V_M1_MF2_MASK }, // 1255
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG5EI32_V_M2_MF2_MASK }, // 1256
  { 0x5, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF2_MASK }, // 1257
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG5EI64_V_M1_M1_MASK }, // 1258
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG5EI64_V_M2_M1_MASK }, // 1259
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG5EI64_V_M4_M1_MASK }, // 1260
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG5EI64_V_M8_M1_MASK }, // 1261
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG5EI64_V_M1_MF8_MASK }, // 1262
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG5EI64_V_M1_MF4_MASK }, // 1263
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG5EI64_V_M2_MF4_MASK }, // 1264
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG5EI64_V_M1_MF2_MASK }, // 1265
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG5EI64_V_M2_MF2_MASK }, // 1266
  { 0x5, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG5EI64_V_M4_MF2_MASK }, // 1267
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG5EI8_V_M1_M1_MASK }, // 1268
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG5EI8_V_MF8_M1_MASK }, // 1269
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG5EI8_V_MF4_M1_MASK }, // 1270
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG5EI8_V_MF2_M1_MASK }, // 1271
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF8_MASK }, // 1272
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF4_MASK }, // 1273
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF4_MASK }, // 1274
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF2_MASK }, // 1275
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF2_MASK }, // 1276
  { 0x5, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF2_MASK }, // 1277
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG5EI16_V_M1_M1_MASK }, // 1278
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG5EI16_V_M2_M1_MASK }, // 1279
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG5EI16_V_MF4_M1_MASK }, // 1280
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG5EI16_V_MF2_M1_MASK }, // 1281
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF8_MASK }, // 1282
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF4_MASK }, // 1283
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF4_MASK }, // 1284
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG5EI16_V_M1_MF2_MASK }, // 1285
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF2_MASK }, // 1286
  { 0x5, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF2_MASK }, // 1287
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG5EI32_V_M1_M1_MASK }, // 1288
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG5EI32_V_M2_M1_MASK }, // 1289
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG5EI32_V_M4_M1_MASK }, // 1290
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG5EI32_V_MF2_M1_MASK }, // 1291
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF8_MASK }, // 1292
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG5EI32_V_M1_MF4_MASK }, // 1293
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF4_MASK }, // 1294
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG5EI32_V_M1_MF2_MASK }, // 1295
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG5EI32_V_M2_MF2_MASK }, // 1296
  { 0x5, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF2_MASK }, // 1297
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG5EI64_V_M1_M1_MASK }, // 1298
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG5EI64_V_M2_M1_MASK }, // 1299
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG5EI64_V_M4_M1_MASK }, // 1300
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG5EI64_V_M8_M1_MASK }, // 1301
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG5EI64_V_M1_MF8_MASK }, // 1302
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG5EI64_V_M1_MF4_MASK }, // 1303
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG5EI64_V_M2_MF4_MASK }, // 1304
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG5EI64_V_M1_MF2_MASK }, // 1305
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG5EI64_V_M2_MF2_MASK }, // 1306
  { 0x5, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG5EI64_V_M4_MF2_MASK }, // 1307
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG6EI8_V_M1_M1 }, // 1308
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG6EI8_V_MF8_M1 }, // 1309
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG6EI8_V_MF4_M1 }, // 1310
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG6EI8_V_MF2_M1 }, // 1311
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF8 }, // 1312
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF4 }, // 1313
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF4 }, // 1314
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF2 }, // 1315
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF2 }, // 1316
  { 0x6, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF2 }, // 1317
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG6EI16_V_M1_M1 }, // 1318
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG6EI16_V_M2_M1 }, // 1319
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG6EI16_V_MF4_M1 }, // 1320
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG6EI16_V_MF2_M1 }, // 1321
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF8 }, // 1322
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF4 }, // 1323
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF4 }, // 1324
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG6EI16_V_M1_MF2 }, // 1325
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF2 }, // 1326
  { 0x6, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF2 }, // 1327
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG6EI32_V_M1_M1 }, // 1328
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG6EI32_V_M2_M1 }, // 1329
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG6EI32_V_M4_M1 }, // 1330
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG6EI32_V_MF2_M1 }, // 1331
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF8 }, // 1332
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG6EI32_V_M1_MF4 }, // 1333
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF4 }, // 1334
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG6EI32_V_M1_MF2 }, // 1335
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG6EI32_V_M2_MF2 }, // 1336
  { 0x6, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF2 }, // 1337
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG6EI64_V_M1_M1 }, // 1338
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG6EI64_V_M2_M1 }, // 1339
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG6EI64_V_M4_M1 }, // 1340
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG6EI64_V_M8_M1 }, // 1341
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG6EI64_V_M1_MF8 }, // 1342
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG6EI64_V_M1_MF4 }, // 1343
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG6EI64_V_M2_MF4 }, // 1344
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG6EI64_V_M1_MF2 }, // 1345
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG6EI64_V_M2_MF2 }, // 1346
  { 0x6, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG6EI64_V_M4_MF2 }, // 1347
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG6EI8_V_M1_M1 }, // 1348
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG6EI8_V_MF8_M1 }, // 1349
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG6EI8_V_MF4_M1 }, // 1350
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG6EI8_V_MF2_M1 }, // 1351
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF8 }, // 1352
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF4 }, // 1353
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF4 }, // 1354
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF2 }, // 1355
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF2 }, // 1356
  { 0x6, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF2 }, // 1357
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG6EI16_V_M1_M1 }, // 1358
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG6EI16_V_M2_M1 }, // 1359
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG6EI16_V_MF4_M1 }, // 1360
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG6EI16_V_MF2_M1 }, // 1361
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF8 }, // 1362
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF4 }, // 1363
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF4 }, // 1364
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG6EI16_V_M1_MF2 }, // 1365
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF2 }, // 1366
  { 0x6, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF2 }, // 1367
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG6EI32_V_M1_M1 }, // 1368
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG6EI32_V_M2_M1 }, // 1369
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG6EI32_V_M4_M1 }, // 1370
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG6EI32_V_MF2_M1 }, // 1371
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF8 }, // 1372
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG6EI32_V_M1_MF4 }, // 1373
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF4 }, // 1374
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG6EI32_V_M1_MF2 }, // 1375
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG6EI32_V_M2_MF2 }, // 1376
  { 0x6, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF2 }, // 1377
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG6EI64_V_M1_M1 }, // 1378
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG6EI64_V_M2_M1 }, // 1379
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG6EI64_V_M4_M1 }, // 1380
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG6EI64_V_M8_M1 }, // 1381
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG6EI64_V_M1_MF8 }, // 1382
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG6EI64_V_M1_MF4 }, // 1383
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG6EI64_V_M2_MF4 }, // 1384
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG6EI64_V_M1_MF2 }, // 1385
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG6EI64_V_M2_MF2 }, // 1386
  { 0x6, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG6EI64_V_M4_MF2 }, // 1387
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG6EI8_V_M1_M1_TU }, // 1388
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG6EI8_V_MF8_M1_TU }, // 1389
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG6EI8_V_MF4_M1_TU }, // 1390
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG6EI8_V_MF2_M1_TU }, // 1391
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF8_TU }, // 1392
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF4_TU }, // 1393
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF4_TU }, // 1394
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF2_TU }, // 1395
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF2_TU }, // 1396
  { 0x6, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF2_TU }, // 1397
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG6EI16_V_M1_M1_TU }, // 1398
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG6EI16_V_M2_M1_TU }, // 1399
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG6EI16_V_MF4_M1_TU }, // 1400
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG6EI16_V_MF2_M1_TU }, // 1401
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF8_TU }, // 1402
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF4_TU }, // 1403
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF4_TU }, // 1404
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG6EI16_V_M1_MF2_TU }, // 1405
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF2_TU }, // 1406
  { 0x6, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF2_TU }, // 1407
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG6EI32_V_M1_M1_TU }, // 1408
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG6EI32_V_M2_M1_TU }, // 1409
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG6EI32_V_M4_M1_TU }, // 1410
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG6EI32_V_MF2_M1_TU }, // 1411
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF8_TU }, // 1412
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG6EI32_V_M1_MF4_TU }, // 1413
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF4_TU }, // 1414
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG6EI32_V_M1_MF2_TU }, // 1415
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG6EI32_V_M2_MF2_TU }, // 1416
  { 0x6, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF2_TU }, // 1417
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG6EI64_V_M1_M1_TU }, // 1418
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG6EI64_V_M2_M1_TU }, // 1419
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG6EI64_V_M4_M1_TU }, // 1420
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG6EI64_V_M8_M1_TU }, // 1421
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG6EI64_V_M1_MF8_TU }, // 1422
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG6EI64_V_M1_MF4_TU }, // 1423
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG6EI64_V_M2_MF4_TU }, // 1424
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG6EI64_V_M1_MF2_TU }, // 1425
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG6EI64_V_M2_MF2_TU }, // 1426
  { 0x6, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG6EI64_V_M4_MF2_TU }, // 1427
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG6EI8_V_M1_M1_TU }, // 1428
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG6EI8_V_MF8_M1_TU }, // 1429
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG6EI8_V_MF4_M1_TU }, // 1430
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG6EI8_V_MF2_M1_TU }, // 1431
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF8_TU }, // 1432
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF4_TU }, // 1433
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF4_TU }, // 1434
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF2_TU }, // 1435
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF2_TU }, // 1436
  { 0x6, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF2_TU }, // 1437
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG6EI16_V_M1_M1_TU }, // 1438
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG6EI16_V_M2_M1_TU }, // 1439
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG6EI16_V_MF4_M1_TU }, // 1440
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG6EI16_V_MF2_M1_TU }, // 1441
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF8_TU }, // 1442
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF4_TU }, // 1443
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF4_TU }, // 1444
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG6EI16_V_M1_MF2_TU }, // 1445
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF2_TU }, // 1446
  { 0x6, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF2_TU }, // 1447
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG6EI32_V_M1_M1_TU }, // 1448
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG6EI32_V_M2_M1_TU }, // 1449
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG6EI32_V_M4_M1_TU }, // 1450
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG6EI32_V_MF2_M1_TU }, // 1451
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF8_TU }, // 1452
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG6EI32_V_M1_MF4_TU }, // 1453
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF4_TU }, // 1454
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG6EI32_V_M1_MF2_TU }, // 1455
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG6EI32_V_M2_MF2_TU }, // 1456
  { 0x6, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF2_TU }, // 1457
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG6EI64_V_M1_M1_TU }, // 1458
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG6EI64_V_M2_M1_TU }, // 1459
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG6EI64_V_M4_M1_TU }, // 1460
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG6EI64_V_M8_M1_TU }, // 1461
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG6EI64_V_M1_MF8_TU }, // 1462
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG6EI64_V_M1_MF4_TU }, // 1463
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG6EI64_V_M2_MF4_TU }, // 1464
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG6EI64_V_M1_MF2_TU }, // 1465
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG6EI64_V_M2_MF2_TU }, // 1466
  { 0x6, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG6EI64_V_M4_MF2_TU }, // 1467
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG6EI8_V_M1_M1_MASK }, // 1468
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG6EI8_V_MF8_M1_MASK }, // 1469
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG6EI8_V_MF4_M1_MASK }, // 1470
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG6EI8_V_MF2_M1_MASK }, // 1471
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF8_MASK }, // 1472
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF4_MASK }, // 1473
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF4_MASK }, // 1474
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF2_MASK }, // 1475
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF2_MASK }, // 1476
  { 0x6, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF2_MASK }, // 1477
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG6EI16_V_M1_M1_MASK }, // 1478
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG6EI16_V_M2_M1_MASK }, // 1479
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG6EI16_V_MF4_M1_MASK }, // 1480
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG6EI16_V_MF2_M1_MASK }, // 1481
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF8_MASK }, // 1482
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF4_MASK }, // 1483
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF4_MASK }, // 1484
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG6EI16_V_M1_MF2_MASK }, // 1485
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF2_MASK }, // 1486
  { 0x6, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF2_MASK }, // 1487
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG6EI32_V_M1_M1_MASK }, // 1488
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG6EI32_V_M2_M1_MASK }, // 1489
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG6EI32_V_M4_M1_MASK }, // 1490
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG6EI32_V_MF2_M1_MASK }, // 1491
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF8_MASK }, // 1492
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG6EI32_V_M1_MF4_MASK }, // 1493
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF4_MASK }, // 1494
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG6EI32_V_M1_MF2_MASK }, // 1495
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG6EI32_V_M2_MF2_MASK }, // 1496
  { 0x6, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF2_MASK }, // 1497
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG6EI64_V_M1_M1_MASK }, // 1498
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG6EI64_V_M2_M1_MASK }, // 1499
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG6EI64_V_M4_M1_MASK }, // 1500
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG6EI64_V_M8_M1_MASK }, // 1501
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG6EI64_V_M1_MF8_MASK }, // 1502
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG6EI64_V_M1_MF4_MASK }, // 1503
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG6EI64_V_M2_MF4_MASK }, // 1504
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG6EI64_V_M1_MF2_MASK }, // 1505
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG6EI64_V_M2_MF2_MASK }, // 1506
  { 0x6, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG6EI64_V_M4_MF2_MASK }, // 1507
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG6EI8_V_M1_M1_MASK }, // 1508
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG6EI8_V_MF8_M1_MASK }, // 1509
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG6EI8_V_MF4_M1_MASK }, // 1510
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG6EI8_V_MF2_M1_MASK }, // 1511
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF8_MASK }, // 1512
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF4_MASK }, // 1513
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF4_MASK }, // 1514
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF2_MASK }, // 1515
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF2_MASK }, // 1516
  { 0x6, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF2_MASK }, // 1517
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG6EI16_V_M1_M1_MASK }, // 1518
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG6EI16_V_M2_M1_MASK }, // 1519
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG6EI16_V_MF4_M1_MASK }, // 1520
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG6EI16_V_MF2_M1_MASK }, // 1521
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF8_MASK }, // 1522
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF4_MASK }, // 1523
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF4_MASK }, // 1524
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG6EI16_V_M1_MF2_MASK }, // 1525
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF2_MASK }, // 1526
  { 0x6, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF2_MASK }, // 1527
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG6EI32_V_M1_M1_MASK }, // 1528
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG6EI32_V_M2_M1_MASK }, // 1529
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG6EI32_V_M4_M1_MASK }, // 1530
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG6EI32_V_MF2_M1_MASK }, // 1531
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF8_MASK }, // 1532
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG6EI32_V_M1_MF4_MASK }, // 1533
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF4_MASK }, // 1534
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG6EI32_V_M1_MF2_MASK }, // 1535
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG6EI32_V_M2_MF2_MASK }, // 1536
  { 0x6, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF2_MASK }, // 1537
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG6EI64_V_M1_M1_MASK }, // 1538
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG6EI64_V_M2_M1_MASK }, // 1539
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG6EI64_V_M4_M1_MASK }, // 1540
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG6EI64_V_M8_M1_MASK }, // 1541
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG6EI64_V_M1_MF8_MASK }, // 1542
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG6EI64_V_M1_MF4_MASK }, // 1543
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG6EI64_V_M2_MF4_MASK }, // 1544
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG6EI64_V_M1_MF2_MASK }, // 1545
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG6EI64_V_M2_MF2_MASK }, // 1546
  { 0x6, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG6EI64_V_M4_MF2_MASK }, // 1547
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG7EI8_V_M1_M1 }, // 1548
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG7EI8_V_MF8_M1 }, // 1549
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG7EI8_V_MF4_M1 }, // 1550
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG7EI8_V_MF2_M1 }, // 1551
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF8 }, // 1552
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF4 }, // 1553
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF4 }, // 1554
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF2 }, // 1555
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF2 }, // 1556
  { 0x7, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF2 }, // 1557
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG7EI16_V_M1_M1 }, // 1558
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG7EI16_V_M2_M1 }, // 1559
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG7EI16_V_MF4_M1 }, // 1560
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG7EI16_V_MF2_M1 }, // 1561
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF8 }, // 1562
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF4 }, // 1563
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF4 }, // 1564
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG7EI16_V_M1_MF2 }, // 1565
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF2 }, // 1566
  { 0x7, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF2 }, // 1567
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG7EI32_V_M1_M1 }, // 1568
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG7EI32_V_M2_M1 }, // 1569
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG7EI32_V_M4_M1 }, // 1570
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG7EI32_V_MF2_M1 }, // 1571
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF8 }, // 1572
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG7EI32_V_M1_MF4 }, // 1573
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF4 }, // 1574
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG7EI32_V_M1_MF2 }, // 1575
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG7EI32_V_M2_MF2 }, // 1576
  { 0x7, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF2 }, // 1577
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG7EI64_V_M1_M1 }, // 1578
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG7EI64_V_M2_M1 }, // 1579
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG7EI64_V_M4_M1 }, // 1580
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG7EI64_V_M8_M1 }, // 1581
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG7EI64_V_M1_MF8 }, // 1582
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG7EI64_V_M1_MF4 }, // 1583
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG7EI64_V_M2_MF4 }, // 1584
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG7EI64_V_M1_MF2 }, // 1585
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG7EI64_V_M2_MF2 }, // 1586
  { 0x7, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG7EI64_V_M4_MF2 }, // 1587
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG7EI8_V_M1_M1 }, // 1588
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG7EI8_V_MF8_M1 }, // 1589
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG7EI8_V_MF4_M1 }, // 1590
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG7EI8_V_MF2_M1 }, // 1591
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF8 }, // 1592
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF4 }, // 1593
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF4 }, // 1594
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF2 }, // 1595
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF2 }, // 1596
  { 0x7, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF2 }, // 1597
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG7EI16_V_M1_M1 }, // 1598
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG7EI16_V_M2_M1 }, // 1599
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG7EI16_V_MF4_M1 }, // 1600
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG7EI16_V_MF2_M1 }, // 1601
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF8 }, // 1602
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF4 }, // 1603
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF4 }, // 1604
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG7EI16_V_M1_MF2 }, // 1605
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF2 }, // 1606
  { 0x7, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF2 }, // 1607
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG7EI32_V_M1_M1 }, // 1608
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG7EI32_V_M2_M1 }, // 1609
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG7EI32_V_M4_M1 }, // 1610
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG7EI32_V_MF2_M1 }, // 1611
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF8 }, // 1612
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG7EI32_V_M1_MF4 }, // 1613
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF4 }, // 1614
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG7EI32_V_M1_MF2 }, // 1615
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG7EI32_V_M2_MF2 }, // 1616
  { 0x7, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF2 }, // 1617
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG7EI64_V_M1_M1 }, // 1618
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG7EI64_V_M2_M1 }, // 1619
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG7EI64_V_M4_M1 }, // 1620
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG7EI64_V_M8_M1 }, // 1621
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG7EI64_V_M1_MF8 }, // 1622
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG7EI64_V_M1_MF4 }, // 1623
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG7EI64_V_M2_MF4 }, // 1624
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG7EI64_V_M1_MF2 }, // 1625
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG7EI64_V_M2_MF2 }, // 1626
  { 0x7, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG7EI64_V_M4_MF2 }, // 1627
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG7EI8_V_M1_M1_TU }, // 1628
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG7EI8_V_MF8_M1_TU }, // 1629
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG7EI8_V_MF4_M1_TU }, // 1630
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG7EI8_V_MF2_M1_TU }, // 1631
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF8_TU }, // 1632
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF4_TU }, // 1633
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF4_TU }, // 1634
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF2_TU }, // 1635
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF2_TU }, // 1636
  { 0x7, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF2_TU }, // 1637
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG7EI16_V_M1_M1_TU }, // 1638
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG7EI16_V_M2_M1_TU }, // 1639
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG7EI16_V_MF4_M1_TU }, // 1640
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG7EI16_V_MF2_M1_TU }, // 1641
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF8_TU }, // 1642
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF4_TU }, // 1643
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF4_TU }, // 1644
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG7EI16_V_M1_MF2_TU }, // 1645
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF2_TU }, // 1646
  { 0x7, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF2_TU }, // 1647
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG7EI32_V_M1_M1_TU }, // 1648
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG7EI32_V_M2_M1_TU }, // 1649
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG7EI32_V_M4_M1_TU }, // 1650
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG7EI32_V_MF2_M1_TU }, // 1651
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF8_TU }, // 1652
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG7EI32_V_M1_MF4_TU }, // 1653
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF4_TU }, // 1654
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG7EI32_V_M1_MF2_TU }, // 1655
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG7EI32_V_M2_MF2_TU }, // 1656
  { 0x7, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF2_TU }, // 1657
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG7EI64_V_M1_M1_TU }, // 1658
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG7EI64_V_M2_M1_TU }, // 1659
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG7EI64_V_M4_M1_TU }, // 1660
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG7EI64_V_M8_M1_TU }, // 1661
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG7EI64_V_M1_MF8_TU }, // 1662
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG7EI64_V_M1_MF4_TU }, // 1663
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG7EI64_V_M2_MF4_TU }, // 1664
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG7EI64_V_M1_MF2_TU }, // 1665
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG7EI64_V_M2_MF2_TU }, // 1666
  { 0x7, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG7EI64_V_M4_MF2_TU }, // 1667
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG7EI8_V_M1_M1_TU }, // 1668
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG7EI8_V_MF8_M1_TU }, // 1669
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG7EI8_V_MF4_M1_TU }, // 1670
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG7EI8_V_MF2_M1_TU }, // 1671
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF8_TU }, // 1672
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF4_TU }, // 1673
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF4_TU }, // 1674
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF2_TU }, // 1675
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF2_TU }, // 1676
  { 0x7, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF2_TU }, // 1677
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG7EI16_V_M1_M1_TU }, // 1678
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG7EI16_V_M2_M1_TU }, // 1679
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG7EI16_V_MF4_M1_TU }, // 1680
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG7EI16_V_MF2_M1_TU }, // 1681
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF8_TU }, // 1682
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF4_TU }, // 1683
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF4_TU }, // 1684
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG7EI16_V_M1_MF2_TU }, // 1685
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF2_TU }, // 1686
  { 0x7, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF2_TU }, // 1687
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG7EI32_V_M1_M1_TU }, // 1688
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG7EI32_V_M2_M1_TU }, // 1689
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG7EI32_V_M4_M1_TU }, // 1690
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG7EI32_V_MF2_M1_TU }, // 1691
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF8_TU }, // 1692
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG7EI32_V_M1_MF4_TU }, // 1693
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF4_TU }, // 1694
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG7EI32_V_M1_MF2_TU }, // 1695
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG7EI32_V_M2_MF2_TU }, // 1696
  { 0x7, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF2_TU }, // 1697
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG7EI64_V_M1_M1_TU }, // 1698
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG7EI64_V_M2_M1_TU }, // 1699
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG7EI64_V_M4_M1_TU }, // 1700
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG7EI64_V_M8_M1_TU }, // 1701
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG7EI64_V_M1_MF8_TU }, // 1702
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG7EI64_V_M1_MF4_TU }, // 1703
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG7EI64_V_M2_MF4_TU }, // 1704
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG7EI64_V_M1_MF2_TU }, // 1705
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG7EI64_V_M2_MF2_TU }, // 1706
  { 0x7, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG7EI64_V_M4_MF2_TU }, // 1707
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG7EI8_V_M1_M1_MASK }, // 1708
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG7EI8_V_MF8_M1_MASK }, // 1709
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG7EI8_V_MF4_M1_MASK }, // 1710
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG7EI8_V_MF2_M1_MASK }, // 1711
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF8_MASK }, // 1712
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF4_MASK }, // 1713
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF4_MASK }, // 1714
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF2_MASK }, // 1715
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF2_MASK }, // 1716
  { 0x7, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF2_MASK }, // 1717
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG7EI16_V_M1_M1_MASK }, // 1718
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG7EI16_V_M2_M1_MASK }, // 1719
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG7EI16_V_MF4_M1_MASK }, // 1720
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG7EI16_V_MF2_M1_MASK }, // 1721
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF8_MASK }, // 1722
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF4_MASK }, // 1723
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF4_MASK }, // 1724
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG7EI16_V_M1_MF2_MASK }, // 1725
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF2_MASK }, // 1726
  { 0x7, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF2_MASK }, // 1727
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG7EI32_V_M1_M1_MASK }, // 1728
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG7EI32_V_M2_M1_MASK }, // 1729
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG7EI32_V_M4_M1_MASK }, // 1730
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG7EI32_V_MF2_M1_MASK }, // 1731
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF8_MASK }, // 1732
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG7EI32_V_M1_MF4_MASK }, // 1733
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF4_MASK }, // 1734
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG7EI32_V_M1_MF2_MASK }, // 1735
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG7EI32_V_M2_MF2_MASK }, // 1736
  { 0x7, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF2_MASK }, // 1737
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG7EI64_V_M1_M1_MASK }, // 1738
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG7EI64_V_M2_M1_MASK }, // 1739
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG7EI64_V_M4_M1_MASK }, // 1740
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG7EI64_V_M8_M1_MASK }, // 1741
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG7EI64_V_M1_MF8_MASK }, // 1742
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG7EI64_V_M1_MF4_MASK }, // 1743
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG7EI64_V_M2_MF4_MASK }, // 1744
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG7EI64_V_M1_MF2_MASK }, // 1745
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG7EI64_V_M2_MF2_MASK }, // 1746
  { 0x7, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG7EI64_V_M4_MF2_MASK }, // 1747
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG7EI8_V_M1_M1_MASK }, // 1748
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG7EI8_V_MF8_M1_MASK }, // 1749
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG7EI8_V_MF4_M1_MASK }, // 1750
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG7EI8_V_MF2_M1_MASK }, // 1751
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF8_MASK }, // 1752
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF4_MASK }, // 1753
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF4_MASK }, // 1754
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF2_MASK }, // 1755
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF2_MASK }, // 1756
  { 0x7, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF2_MASK }, // 1757
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG7EI16_V_M1_M1_MASK }, // 1758
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG7EI16_V_M2_M1_MASK }, // 1759
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG7EI16_V_MF4_M1_MASK }, // 1760
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG7EI16_V_MF2_M1_MASK }, // 1761
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF8_MASK }, // 1762
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF4_MASK }, // 1763
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF4_MASK }, // 1764
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG7EI16_V_M1_MF2_MASK }, // 1765
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF2_MASK }, // 1766
  { 0x7, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF2_MASK }, // 1767
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG7EI32_V_M1_M1_MASK }, // 1768
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG7EI32_V_M2_M1_MASK }, // 1769
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG7EI32_V_M4_M1_MASK }, // 1770
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG7EI32_V_MF2_M1_MASK }, // 1771
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF8_MASK }, // 1772
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG7EI32_V_M1_MF4_MASK }, // 1773
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF4_MASK }, // 1774
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG7EI32_V_M1_MF2_MASK }, // 1775
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG7EI32_V_M2_MF2_MASK }, // 1776
  { 0x7, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF2_MASK }, // 1777
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG7EI64_V_M1_M1_MASK }, // 1778
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG7EI64_V_M2_M1_MASK }, // 1779
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG7EI64_V_M4_M1_MASK }, // 1780
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG7EI64_V_M8_M1_MASK }, // 1781
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG7EI64_V_M1_MF8_MASK }, // 1782
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG7EI64_V_M1_MF4_MASK }, // 1783
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG7EI64_V_M2_MF4_MASK }, // 1784
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG7EI64_V_M1_MF2_MASK }, // 1785
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG7EI64_V_M2_MF2_MASK }, // 1786
  { 0x7, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG7EI64_V_M4_MF2_MASK }, // 1787
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG8EI8_V_M1_M1 }, // 1788
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG8EI8_V_MF8_M1 }, // 1789
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG8EI8_V_MF4_M1 }, // 1790
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG8EI8_V_MF2_M1 }, // 1791
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF8 }, // 1792
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF4 }, // 1793
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF4 }, // 1794
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF2 }, // 1795
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF2 }, // 1796
  { 0x8, 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF2 }, // 1797
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG8EI16_V_M1_M1 }, // 1798
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG8EI16_V_M2_M1 }, // 1799
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG8EI16_V_MF4_M1 }, // 1800
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG8EI16_V_MF2_M1 }, // 1801
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF8 }, // 1802
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF4 }, // 1803
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF4 }, // 1804
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG8EI16_V_M1_MF2 }, // 1805
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF2 }, // 1806
  { 0x8, 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF2 }, // 1807
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG8EI32_V_M1_M1 }, // 1808
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG8EI32_V_M2_M1 }, // 1809
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG8EI32_V_M4_M1 }, // 1810
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG8EI32_V_MF2_M1 }, // 1811
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF8 }, // 1812
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG8EI32_V_M1_MF4 }, // 1813
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF4 }, // 1814
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG8EI32_V_M1_MF2 }, // 1815
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG8EI32_V_M2_MF2 }, // 1816
  { 0x8, 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF2 }, // 1817
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG8EI64_V_M1_M1 }, // 1818
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG8EI64_V_M2_M1 }, // 1819
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG8EI64_V_M4_M1 }, // 1820
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG8EI64_V_M8_M1 }, // 1821
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG8EI64_V_M1_MF8 }, // 1822
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG8EI64_V_M1_MF4 }, // 1823
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG8EI64_V_M2_MF4 }, // 1824
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG8EI64_V_M1_MF2 }, // 1825
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG8EI64_V_M2_MF2 }, // 1826
  { 0x8, 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG8EI64_V_M4_MF2 }, // 1827
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG8EI8_V_M1_M1 }, // 1828
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG8EI8_V_MF8_M1 }, // 1829
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG8EI8_V_MF4_M1 }, // 1830
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG8EI8_V_MF2_M1 }, // 1831
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF8 }, // 1832
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF4 }, // 1833
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF4 }, // 1834
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF2 }, // 1835
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF2 }, // 1836
  { 0x8, 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF2 }, // 1837
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG8EI16_V_M1_M1 }, // 1838
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG8EI16_V_M2_M1 }, // 1839
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG8EI16_V_MF4_M1 }, // 1840
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG8EI16_V_MF2_M1 }, // 1841
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF8 }, // 1842
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF4 }, // 1843
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF4 }, // 1844
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG8EI16_V_M1_MF2 }, // 1845
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF2 }, // 1846
  { 0x8, 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF2 }, // 1847
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG8EI32_V_M1_M1 }, // 1848
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG8EI32_V_M2_M1 }, // 1849
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG8EI32_V_M4_M1 }, // 1850
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG8EI32_V_MF2_M1 }, // 1851
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF8 }, // 1852
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG8EI32_V_M1_MF4 }, // 1853
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF4 }, // 1854
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG8EI32_V_M1_MF2 }, // 1855
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG8EI32_V_M2_MF2 }, // 1856
  { 0x8, 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF2 }, // 1857
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG8EI64_V_M1_M1 }, // 1858
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG8EI64_V_M2_M1 }, // 1859
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG8EI64_V_M4_M1 }, // 1860
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG8EI64_V_M8_M1 }, // 1861
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG8EI64_V_M1_MF8 }, // 1862
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG8EI64_V_M1_MF4 }, // 1863
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG8EI64_V_M2_MF4 }, // 1864
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG8EI64_V_M1_MF2 }, // 1865
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG8EI64_V_M2_MF2 }, // 1866
  { 0x8, 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG8EI64_V_M4_MF2 }, // 1867
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG8EI8_V_M1_M1_TU }, // 1868
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG8EI8_V_MF8_M1_TU }, // 1869
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG8EI8_V_MF4_M1_TU }, // 1870
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG8EI8_V_MF2_M1_TU }, // 1871
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF8_TU }, // 1872
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF4_TU }, // 1873
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF4_TU }, // 1874
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF2_TU }, // 1875
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF2_TU }, // 1876
  { 0x8, 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF2_TU }, // 1877
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG8EI16_V_M1_M1_TU }, // 1878
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG8EI16_V_M2_M1_TU }, // 1879
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG8EI16_V_MF4_M1_TU }, // 1880
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG8EI16_V_MF2_M1_TU }, // 1881
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF8_TU }, // 1882
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF4_TU }, // 1883
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF4_TU }, // 1884
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG8EI16_V_M1_MF2_TU }, // 1885
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF2_TU }, // 1886
  { 0x8, 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF2_TU }, // 1887
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG8EI32_V_M1_M1_TU }, // 1888
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG8EI32_V_M2_M1_TU }, // 1889
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG8EI32_V_M4_M1_TU }, // 1890
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG8EI32_V_MF2_M1_TU }, // 1891
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF8_TU }, // 1892
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG8EI32_V_M1_MF4_TU }, // 1893
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF4_TU }, // 1894
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG8EI32_V_M1_MF2_TU }, // 1895
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG8EI32_V_M2_MF2_TU }, // 1896
  { 0x8, 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF2_TU }, // 1897
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG8EI64_V_M1_M1_TU }, // 1898
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG8EI64_V_M2_M1_TU }, // 1899
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG8EI64_V_M4_M1_TU }, // 1900
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG8EI64_V_M8_M1_TU }, // 1901
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG8EI64_V_M1_MF8_TU }, // 1902
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG8EI64_V_M1_MF4_TU }, // 1903
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG8EI64_V_M2_MF4_TU }, // 1904
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG8EI64_V_M1_MF2_TU }, // 1905
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG8EI64_V_M2_MF2_TU }, // 1906
  { 0x8, 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG8EI64_V_M4_MF2_TU }, // 1907
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG8EI8_V_M1_M1_TU }, // 1908
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG8EI8_V_MF8_M1_TU }, // 1909
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG8EI8_V_MF4_M1_TU }, // 1910
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG8EI8_V_MF2_M1_TU }, // 1911
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF8_TU }, // 1912
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF4_TU }, // 1913
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF4_TU }, // 1914
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF2_TU }, // 1915
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF2_TU }, // 1916
  { 0x8, 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF2_TU }, // 1917
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG8EI16_V_M1_M1_TU }, // 1918
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG8EI16_V_M2_M1_TU }, // 1919
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG8EI16_V_MF4_M1_TU }, // 1920
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG8EI16_V_MF2_M1_TU }, // 1921
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF8_TU }, // 1922
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF4_TU }, // 1923
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF4_TU }, // 1924
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG8EI16_V_M1_MF2_TU }, // 1925
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF2_TU }, // 1926
  { 0x8, 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF2_TU }, // 1927
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG8EI32_V_M1_M1_TU }, // 1928
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG8EI32_V_M2_M1_TU }, // 1929
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG8EI32_V_M4_M1_TU }, // 1930
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG8EI32_V_MF2_M1_TU }, // 1931
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF8_TU }, // 1932
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG8EI32_V_M1_MF4_TU }, // 1933
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF4_TU }, // 1934
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG8EI32_V_M1_MF2_TU }, // 1935
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG8EI32_V_M2_MF2_TU }, // 1936
  { 0x8, 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF2_TU }, // 1937
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG8EI64_V_M1_M1_TU }, // 1938
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG8EI64_V_M2_M1_TU }, // 1939
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG8EI64_V_M4_M1_TU }, // 1940
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG8EI64_V_M8_M1_TU }, // 1941
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG8EI64_V_M1_MF8_TU }, // 1942
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG8EI64_V_M1_MF4_TU }, // 1943
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG8EI64_V_M2_MF4_TU }, // 1944
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG8EI64_V_M1_MF2_TU }, // 1945
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG8EI64_V_M2_MF2_TU }, // 1946
  { 0x8, 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG8EI64_V_M4_MF2_TU }, // 1947
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXSEG8EI8_V_M1_M1_MASK }, // 1948
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXSEG8EI8_V_MF8_M1_MASK }, // 1949
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXSEG8EI8_V_MF4_M1_MASK }, // 1950
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXSEG8EI8_V_MF2_M1_MASK }, // 1951
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF8_MASK }, // 1952
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF4_MASK }, // 1953
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF4_MASK }, // 1954
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF2_MASK }, // 1955
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF2_MASK }, // 1956
  { 0x8, 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF2_MASK }, // 1957
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXSEG8EI16_V_M1_M1_MASK }, // 1958
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXSEG8EI16_V_M2_M1_MASK }, // 1959
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXSEG8EI16_V_MF4_M1_MASK }, // 1960
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXSEG8EI16_V_MF2_M1_MASK }, // 1961
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF8_MASK }, // 1962
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF4_MASK }, // 1963
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF4_MASK }, // 1964
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXSEG8EI16_V_M1_MF2_MASK }, // 1965
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF2_MASK }, // 1966
  { 0x8, 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF2_MASK }, // 1967
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXSEG8EI32_V_M1_M1_MASK }, // 1968
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXSEG8EI32_V_M2_M1_MASK }, // 1969
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXSEG8EI32_V_M4_M1_MASK }, // 1970
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXSEG8EI32_V_MF2_M1_MASK }, // 1971
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF8_MASK }, // 1972
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXSEG8EI32_V_M1_MF4_MASK }, // 1973
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF4_MASK }, // 1974
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXSEG8EI32_V_M1_MF2_MASK }, // 1975
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXSEG8EI32_V_M2_MF2_MASK }, // 1976
  { 0x8, 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF2_MASK }, // 1977
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXSEG8EI64_V_M1_M1_MASK }, // 1978
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXSEG8EI64_V_M2_M1_MASK }, // 1979
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXSEG8EI64_V_M4_M1_MASK }, // 1980
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXSEG8EI64_V_M8_M1_MASK }, // 1981
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXSEG8EI64_V_M1_MF8_MASK }, // 1982
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXSEG8EI64_V_M1_MF4_MASK }, // 1983
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXSEG8EI64_V_M2_MF4_MASK }, // 1984
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXSEG8EI64_V_M1_MF2_MASK }, // 1985
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXSEG8EI64_V_M2_MF2_MASK }, // 1986
  { 0x8, 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXSEG8EI64_V_M4_MF2_MASK }, // 1987
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXSEG8EI8_V_M1_M1_MASK }, // 1988
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXSEG8EI8_V_MF8_M1_MASK }, // 1989
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXSEG8EI8_V_MF4_M1_MASK }, // 1990
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXSEG8EI8_V_MF2_M1_MASK }, // 1991
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF8_MASK }, // 1992
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF4_MASK }, // 1993
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF4_MASK }, // 1994
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF2_MASK }, // 1995
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF2_MASK }, // 1996
  { 0x8, 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF2_MASK }, // 1997
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXSEG8EI16_V_M1_M1_MASK }, // 1998
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXSEG8EI16_V_M2_M1_MASK }, // 1999
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXSEG8EI16_V_MF4_M1_MASK }, // 2000
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXSEG8EI16_V_MF2_M1_MASK }, // 2001
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF8_MASK }, // 2002
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF4_MASK }, // 2003
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF4_MASK }, // 2004
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXSEG8EI16_V_M1_MF2_MASK }, // 2005
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF2_MASK }, // 2006
  { 0x8, 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF2_MASK }, // 2007
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXSEG8EI32_V_M1_M1_MASK }, // 2008
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXSEG8EI32_V_M2_M1_MASK }, // 2009
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXSEG8EI32_V_M4_M1_MASK }, // 2010
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXSEG8EI32_V_MF2_M1_MASK }, // 2011
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF8_MASK }, // 2012
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXSEG8EI32_V_M1_MF4_MASK }, // 2013
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF4_MASK }, // 2014
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXSEG8EI32_V_M1_MF2_MASK }, // 2015
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXSEG8EI32_V_M2_MF2_MASK }, // 2016
  { 0x8, 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF2_MASK }, // 2017
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXSEG8EI64_V_M1_M1_MASK }, // 2018
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXSEG8EI64_V_M2_M1_MASK }, // 2019
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXSEG8EI64_V_M4_M1_MASK }, // 2020
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXSEG8EI64_V_M8_M1_MASK }, // 2021
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXSEG8EI64_V_M1_MF8_MASK }, // 2022
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXSEG8EI64_V_M1_MF4_MASK }, // 2023
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXSEG8EI64_V_M2_MF4_MASK }, // 2024
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXSEG8EI64_V_M1_MF2_MASK }, // 2025
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXSEG8EI64_V_M2_MF2_MASK }, // 2026
  { 0x8, 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXSEG8EI64_V_M4_MF2_MASK }, // 2027
 };

const VLXSEGPseudo *getVLXSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t IsTU, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL) {
  struct KeyType {
    uint8_t NF;
    uint8_t Masked;
    uint8_t IsTU;
    uint8_t Ordered;
    uint8_t Log2SEW;
    uint8_t LMUL;
    uint8_t IndexLMUL;
  };
  KeyType Key = {NF, Masked, IsTU, Ordered, Log2SEW, LMUL, IndexLMUL};
  auto Table = ArrayRef(RISCVVLXSEGTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VLXSEGPseudo &LHS, const KeyType &RHS) {
      if (LHS.NF < RHS.NF)
        return true;
      if (LHS.NF > RHS.NF)
        return false;
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.IsTU < RHS.IsTU)
        return true;
      if (LHS.IsTU > RHS.IsTU)
        return false;
      if (LHS.Ordered < RHS.Ordered)
        return true;
      if (LHS.Ordered > RHS.Ordered)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      if (LHS.IndexLMUL < RHS.IndexLMUL)
        return true;
      if (LHS.IndexLMUL > RHS.IndexLMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.NF != Idx->NF ||
      Key.Masked != Idx->Masked ||
      Key.IsTU != Idx->IsTU ||
      Key.Ordered != Idx->Ordered ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL ||
      Key.IndexLMUL != Idx->IndexLMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVLXTable_DECL
const VLX_VSXPseudo *getVLXPseudo(uint8_t Masked, uint8_t IsTU, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL);
#endif

#ifdef GET_RISCVVLXTable_IMPL
constexpr VLX_VSXPseudo RISCVVLXTable[] = {
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVLUXEI8_V_M1_M1 }, // 0
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVLUXEI8_V_MF8_M1 }, // 1
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVLUXEI8_V_MF4_M1 }, // 2
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVLUXEI8_V_MF2_M1 }, // 3
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVLUXEI8_V_M1_M2 }, // 4
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVLUXEI8_V_M2_M2 }, // 5
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVLUXEI8_V_MF4_M2 }, // 6
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVLUXEI8_V_MF2_M2 }, // 7
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x0, PseudoVLUXEI8_V_M1_M4 }, // 8
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x1, PseudoVLUXEI8_V_M2_M4 }, // 9
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x2, PseudoVLUXEI8_V_M4_M4 }, // 10
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x7, PseudoVLUXEI8_V_MF2_M4 }, // 11
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x0, PseudoVLUXEI8_V_M1_M8 }, // 12
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x1, PseudoVLUXEI8_V_M2_M8 }, // 13
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x2, PseudoVLUXEI8_V_M4_M8 }, // 14
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x3, PseudoVLUXEI8_V_M8_M8 }, // 15
  { 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVLUXEI8_V_MF8_MF8 }, // 16
  { 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVLUXEI8_V_MF8_MF4 }, // 17
  { 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVLUXEI8_V_MF4_MF4 }, // 18
  { 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVLUXEI8_V_MF8_MF2 }, // 19
  { 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVLUXEI8_V_MF4_MF2 }, // 20
  { 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVLUXEI8_V_MF2_MF2 }, // 21
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVLUXEI16_V_M1_M1 }, // 22
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVLUXEI16_V_M2_M1 }, // 23
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVLUXEI16_V_MF4_M1 }, // 24
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVLUXEI16_V_MF2_M1 }, // 25
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVLUXEI16_V_M1_M2 }, // 26
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVLUXEI16_V_M2_M2 }, // 27
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVLUXEI16_V_M4_M2 }, // 28
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVLUXEI16_V_MF2_M2 }, // 29
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x0, PseudoVLUXEI16_V_M1_M4 }, // 30
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x1, PseudoVLUXEI16_V_M2_M4 }, // 31
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x2, PseudoVLUXEI16_V_M4_M4 }, // 32
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x3, PseudoVLUXEI16_V_M8_M4 }, // 33
  { 0x0, 0x0, 0x0, 0x4, 0x3, 0x1, PseudoVLUXEI16_V_M2_M8 }, // 34
  { 0x0, 0x0, 0x0, 0x4, 0x3, 0x2, PseudoVLUXEI16_V_M4_M8 }, // 35
  { 0x0, 0x0, 0x0, 0x4, 0x3, 0x3, PseudoVLUXEI16_V_M8_M8 }, // 36
  { 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVLUXEI16_V_MF4_MF8 }, // 37
  { 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVLUXEI16_V_MF4_MF4 }, // 38
  { 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVLUXEI16_V_MF2_MF4 }, // 39
  { 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVLUXEI16_V_M1_MF2 }, // 40
  { 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVLUXEI16_V_MF4_MF2 }, // 41
  { 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVLUXEI16_V_MF2_MF2 }, // 42
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVLUXEI32_V_M1_M1 }, // 43
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVLUXEI32_V_M2_M1 }, // 44
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVLUXEI32_V_M4_M1 }, // 45
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVLUXEI32_V_MF2_M1 }, // 46
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVLUXEI32_V_M1_M2 }, // 47
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVLUXEI32_V_M2_M2 }, // 48
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVLUXEI32_V_M4_M2 }, // 49
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVLUXEI32_V_M8_M2 }, // 50
  { 0x0, 0x0, 0x0, 0x5, 0x2, 0x1, PseudoVLUXEI32_V_M2_M4 }, // 51
  { 0x0, 0x0, 0x0, 0x5, 0x2, 0x2, PseudoVLUXEI32_V_M4_M4 }, // 52
  { 0x0, 0x0, 0x0, 0x5, 0x2, 0x3, PseudoVLUXEI32_V_M8_M4 }, // 53
  { 0x0, 0x0, 0x0, 0x5, 0x3, 0x2, PseudoVLUXEI32_V_M4_M8 }, // 54
  { 0x0, 0x0, 0x0, 0x5, 0x3, 0x3, PseudoVLUXEI32_V_M8_M8 }, // 55
  { 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVLUXEI32_V_MF2_MF8 }, // 56
  { 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVLUXEI32_V_M1_MF4 }, // 57
  { 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVLUXEI32_V_MF2_MF4 }, // 58
  { 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVLUXEI32_V_M1_MF2 }, // 59
  { 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVLUXEI32_V_M2_MF2 }, // 60
  { 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVLUXEI32_V_MF2_MF2 }, // 61
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVLUXEI64_V_M1_M1 }, // 62
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVLUXEI64_V_M2_M1 }, // 63
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVLUXEI64_V_M4_M1 }, // 64
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVLUXEI64_V_M8_M1 }, // 65
  { 0x0, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVLUXEI64_V_M2_M2 }, // 66
  { 0x0, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVLUXEI64_V_M4_M2 }, // 67
  { 0x0, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVLUXEI64_V_M8_M2 }, // 68
  { 0x0, 0x0, 0x0, 0x6, 0x2, 0x2, PseudoVLUXEI64_V_M4_M4 }, // 69
  { 0x0, 0x0, 0x0, 0x6, 0x2, 0x3, PseudoVLUXEI64_V_M8_M4 }, // 70
  { 0x0, 0x0, 0x0, 0x6, 0x3, 0x3, PseudoVLUXEI64_V_M8_M8 }, // 71
  { 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVLUXEI64_V_M1_MF8 }, // 72
  { 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVLUXEI64_V_M1_MF4 }, // 73
  { 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVLUXEI64_V_M2_MF4 }, // 74
  { 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVLUXEI64_V_M1_MF2 }, // 75
  { 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVLUXEI64_V_M2_MF2 }, // 76
  { 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVLUXEI64_V_M4_MF2 }, // 77
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVLOXEI8_V_M1_M1 }, // 78
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVLOXEI8_V_MF8_M1 }, // 79
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVLOXEI8_V_MF4_M1 }, // 80
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVLOXEI8_V_MF2_M1 }, // 81
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVLOXEI8_V_M1_M2 }, // 82
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVLOXEI8_V_M2_M2 }, // 83
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVLOXEI8_V_MF4_M2 }, // 84
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVLOXEI8_V_MF2_M2 }, // 85
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, PseudoVLOXEI8_V_M1_M4 }, // 86
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x1, PseudoVLOXEI8_V_M2_M4 }, // 87
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x2, PseudoVLOXEI8_V_M4_M4 }, // 88
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x7, PseudoVLOXEI8_V_MF2_M4 }, // 89
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x0, PseudoVLOXEI8_V_M1_M8 }, // 90
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x1, PseudoVLOXEI8_V_M2_M8 }, // 91
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x2, PseudoVLOXEI8_V_M4_M8 }, // 92
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x3, PseudoVLOXEI8_V_M8_M8 }, // 93
  { 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVLOXEI8_V_MF8_MF8 }, // 94
  { 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVLOXEI8_V_MF8_MF4 }, // 95
  { 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVLOXEI8_V_MF4_MF4 }, // 96
  { 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVLOXEI8_V_MF8_MF2 }, // 97
  { 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVLOXEI8_V_MF4_MF2 }, // 98
  { 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVLOXEI8_V_MF2_MF2 }, // 99
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVLOXEI16_V_M1_M1 }, // 100
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVLOXEI16_V_M2_M1 }, // 101
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVLOXEI16_V_MF4_M1 }, // 102
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVLOXEI16_V_MF2_M1 }, // 103
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVLOXEI16_V_M1_M2 }, // 104
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVLOXEI16_V_M2_M2 }, // 105
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVLOXEI16_V_M4_M2 }, // 106
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVLOXEI16_V_MF2_M2 }, // 107
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x0, PseudoVLOXEI16_V_M1_M4 }, // 108
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x1, PseudoVLOXEI16_V_M2_M4 }, // 109
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x2, PseudoVLOXEI16_V_M4_M4 }, // 110
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x3, PseudoVLOXEI16_V_M8_M4 }, // 111
  { 0x0, 0x0, 0x1, 0x4, 0x3, 0x1, PseudoVLOXEI16_V_M2_M8 }, // 112
  { 0x0, 0x0, 0x1, 0x4, 0x3, 0x2, PseudoVLOXEI16_V_M4_M8 }, // 113
  { 0x0, 0x0, 0x1, 0x4, 0x3, 0x3, PseudoVLOXEI16_V_M8_M8 }, // 114
  { 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVLOXEI16_V_MF4_MF8 }, // 115
  { 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVLOXEI16_V_MF4_MF4 }, // 116
  { 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVLOXEI16_V_MF2_MF4 }, // 117
  { 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVLOXEI16_V_M1_MF2 }, // 118
  { 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVLOXEI16_V_MF4_MF2 }, // 119
  { 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVLOXEI16_V_MF2_MF2 }, // 120
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVLOXEI32_V_M1_M1 }, // 121
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVLOXEI32_V_M2_M1 }, // 122
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVLOXEI32_V_M4_M1 }, // 123
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVLOXEI32_V_MF2_M1 }, // 124
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVLOXEI32_V_M1_M2 }, // 125
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVLOXEI32_V_M2_M2 }, // 126
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVLOXEI32_V_M4_M2 }, // 127
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVLOXEI32_V_M8_M2 }, // 128
  { 0x0, 0x0, 0x1, 0x5, 0x2, 0x1, PseudoVLOXEI32_V_M2_M4 }, // 129
  { 0x0, 0x0, 0x1, 0x5, 0x2, 0x2, PseudoVLOXEI32_V_M4_M4 }, // 130
  { 0x0, 0x0, 0x1, 0x5, 0x2, 0x3, PseudoVLOXEI32_V_M8_M4 }, // 131
  { 0x0, 0x0, 0x1, 0x5, 0x3, 0x2, PseudoVLOXEI32_V_M4_M8 }, // 132
  { 0x0, 0x0, 0x1, 0x5, 0x3, 0x3, PseudoVLOXEI32_V_M8_M8 }, // 133
  { 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVLOXEI32_V_MF2_MF8 }, // 134
  { 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVLOXEI32_V_M1_MF4 }, // 135
  { 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVLOXEI32_V_MF2_MF4 }, // 136
  { 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVLOXEI32_V_M1_MF2 }, // 137
  { 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVLOXEI32_V_M2_MF2 }, // 138
  { 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVLOXEI32_V_MF2_MF2 }, // 139
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVLOXEI64_V_M1_M1 }, // 140
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVLOXEI64_V_M2_M1 }, // 141
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVLOXEI64_V_M4_M1 }, // 142
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVLOXEI64_V_M8_M1 }, // 143
  { 0x0, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVLOXEI64_V_M2_M2 }, // 144
  { 0x0, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVLOXEI64_V_M4_M2 }, // 145
  { 0x0, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVLOXEI64_V_M8_M2 }, // 146
  { 0x0, 0x0, 0x1, 0x6, 0x2, 0x2, PseudoVLOXEI64_V_M4_M4 }, // 147
  { 0x0, 0x0, 0x1, 0x6, 0x2, 0x3, PseudoVLOXEI64_V_M8_M4 }, // 148
  { 0x0, 0x0, 0x1, 0x6, 0x3, 0x3, PseudoVLOXEI64_V_M8_M8 }, // 149
  { 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVLOXEI64_V_M1_MF8 }, // 150
  { 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVLOXEI64_V_M1_MF4 }, // 151
  { 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVLOXEI64_V_M2_MF4 }, // 152
  { 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVLOXEI64_V_M1_MF2 }, // 153
  { 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVLOXEI64_V_M2_MF2 }, // 154
  { 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVLOXEI64_V_M4_MF2 }, // 155
  { 0x0, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXEI8_V_M1_M1_TU }, // 156
  { 0x0, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXEI8_V_MF8_M1_TU }, // 157
  { 0x0, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXEI8_V_MF4_M1_TU }, // 158
  { 0x0, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXEI8_V_MF2_M1_TU }, // 159
  { 0x0, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXEI8_V_M1_M2_TU }, // 160
  { 0x0, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXEI8_V_M2_M2_TU }, // 161
  { 0x0, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXEI8_V_MF4_M2_TU }, // 162
  { 0x0, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXEI8_V_MF2_M2_TU }, // 163
  { 0x0, 0x1, 0x0, 0x3, 0x2, 0x0, PseudoVLUXEI8_V_M1_M4_TU }, // 164
  { 0x0, 0x1, 0x0, 0x3, 0x2, 0x1, PseudoVLUXEI8_V_M2_M4_TU }, // 165
  { 0x0, 0x1, 0x0, 0x3, 0x2, 0x2, PseudoVLUXEI8_V_M4_M4_TU }, // 166
  { 0x0, 0x1, 0x0, 0x3, 0x2, 0x7, PseudoVLUXEI8_V_MF2_M4_TU }, // 167
  { 0x0, 0x1, 0x0, 0x3, 0x3, 0x0, PseudoVLUXEI8_V_M1_M8_TU }, // 168
  { 0x0, 0x1, 0x0, 0x3, 0x3, 0x1, PseudoVLUXEI8_V_M2_M8_TU }, // 169
  { 0x0, 0x1, 0x0, 0x3, 0x3, 0x2, PseudoVLUXEI8_V_M4_M8_TU }, // 170
  { 0x0, 0x1, 0x0, 0x3, 0x3, 0x3, PseudoVLUXEI8_V_M8_M8_TU }, // 171
  { 0x0, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXEI8_V_MF8_MF8_TU }, // 172
  { 0x0, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXEI8_V_MF8_MF4_TU }, // 173
  { 0x0, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXEI8_V_MF4_MF4_TU }, // 174
  { 0x0, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXEI8_V_MF8_MF2_TU }, // 175
  { 0x0, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXEI8_V_MF4_MF2_TU }, // 176
  { 0x0, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXEI8_V_MF2_MF2_TU }, // 177
  { 0x0, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXEI16_V_M1_M1_TU }, // 178
  { 0x0, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXEI16_V_M2_M1_TU }, // 179
  { 0x0, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXEI16_V_MF4_M1_TU }, // 180
  { 0x0, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXEI16_V_MF2_M1_TU }, // 181
  { 0x0, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXEI16_V_M1_M2_TU }, // 182
  { 0x0, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXEI16_V_M2_M2_TU }, // 183
  { 0x0, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXEI16_V_M4_M2_TU }, // 184
  { 0x0, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXEI16_V_MF2_M2_TU }, // 185
  { 0x0, 0x1, 0x0, 0x4, 0x2, 0x0, PseudoVLUXEI16_V_M1_M4_TU }, // 186
  { 0x0, 0x1, 0x0, 0x4, 0x2, 0x1, PseudoVLUXEI16_V_M2_M4_TU }, // 187
  { 0x0, 0x1, 0x0, 0x4, 0x2, 0x2, PseudoVLUXEI16_V_M4_M4_TU }, // 188
  { 0x0, 0x1, 0x0, 0x4, 0x2, 0x3, PseudoVLUXEI16_V_M8_M4_TU }, // 189
  { 0x0, 0x1, 0x0, 0x4, 0x3, 0x1, PseudoVLUXEI16_V_M2_M8_TU }, // 190
  { 0x0, 0x1, 0x0, 0x4, 0x3, 0x2, PseudoVLUXEI16_V_M4_M8_TU }, // 191
  { 0x0, 0x1, 0x0, 0x4, 0x3, 0x3, PseudoVLUXEI16_V_M8_M8_TU }, // 192
  { 0x0, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXEI16_V_MF4_MF8_TU }, // 193
  { 0x0, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXEI16_V_MF4_MF4_TU }, // 194
  { 0x0, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXEI16_V_MF2_MF4_TU }, // 195
  { 0x0, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXEI16_V_M1_MF2_TU }, // 196
  { 0x0, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXEI16_V_MF4_MF2_TU }, // 197
  { 0x0, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXEI16_V_MF2_MF2_TU }, // 198
  { 0x0, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXEI32_V_M1_M1_TU }, // 199
  { 0x0, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXEI32_V_M2_M1_TU }, // 200
  { 0x0, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXEI32_V_M4_M1_TU }, // 201
  { 0x0, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXEI32_V_MF2_M1_TU }, // 202
  { 0x0, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXEI32_V_M1_M2_TU }, // 203
  { 0x0, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXEI32_V_M2_M2_TU }, // 204
  { 0x0, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXEI32_V_M4_M2_TU }, // 205
  { 0x0, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXEI32_V_M8_M2_TU }, // 206
  { 0x0, 0x1, 0x0, 0x5, 0x2, 0x1, PseudoVLUXEI32_V_M2_M4_TU }, // 207
  { 0x0, 0x1, 0x0, 0x5, 0x2, 0x2, PseudoVLUXEI32_V_M4_M4_TU }, // 208
  { 0x0, 0x1, 0x0, 0x5, 0x2, 0x3, PseudoVLUXEI32_V_M8_M4_TU }, // 209
  { 0x0, 0x1, 0x0, 0x5, 0x3, 0x2, PseudoVLUXEI32_V_M4_M8_TU }, // 210
  { 0x0, 0x1, 0x0, 0x5, 0x3, 0x3, PseudoVLUXEI32_V_M8_M8_TU }, // 211
  { 0x0, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXEI32_V_MF2_MF8_TU }, // 212
  { 0x0, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXEI32_V_M1_MF4_TU }, // 213
  { 0x0, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXEI32_V_MF2_MF4_TU }, // 214
  { 0x0, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXEI32_V_M1_MF2_TU }, // 215
  { 0x0, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXEI32_V_M2_MF2_TU }, // 216
  { 0x0, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXEI32_V_MF2_MF2_TU }, // 217
  { 0x0, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXEI64_V_M1_M1_TU }, // 218
  { 0x0, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXEI64_V_M2_M1_TU }, // 219
  { 0x0, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXEI64_V_M4_M1_TU }, // 220
  { 0x0, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXEI64_V_M8_M1_TU }, // 221
  { 0x0, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXEI64_V_M2_M2_TU }, // 222
  { 0x0, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXEI64_V_M4_M2_TU }, // 223
  { 0x0, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXEI64_V_M8_M2_TU }, // 224
  { 0x0, 0x1, 0x0, 0x6, 0x2, 0x2, PseudoVLUXEI64_V_M4_M4_TU }, // 225
  { 0x0, 0x1, 0x0, 0x6, 0x2, 0x3, PseudoVLUXEI64_V_M8_M4_TU }, // 226
  { 0x0, 0x1, 0x0, 0x6, 0x3, 0x3, PseudoVLUXEI64_V_M8_M8_TU }, // 227
  { 0x0, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXEI64_V_M1_MF8_TU }, // 228
  { 0x0, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXEI64_V_M1_MF4_TU }, // 229
  { 0x0, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXEI64_V_M2_MF4_TU }, // 230
  { 0x0, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXEI64_V_M1_MF2_TU }, // 231
  { 0x0, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXEI64_V_M2_MF2_TU }, // 232
  { 0x0, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXEI64_V_M4_MF2_TU }, // 233
  { 0x0, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXEI8_V_M1_M1_TU }, // 234
  { 0x0, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXEI8_V_MF8_M1_TU }, // 235
  { 0x0, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXEI8_V_MF4_M1_TU }, // 236
  { 0x0, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXEI8_V_MF2_M1_TU }, // 237
  { 0x0, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXEI8_V_M1_M2_TU }, // 238
  { 0x0, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXEI8_V_M2_M2_TU }, // 239
  { 0x0, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXEI8_V_MF4_M2_TU }, // 240
  { 0x0, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXEI8_V_MF2_M2_TU }, // 241
  { 0x0, 0x1, 0x1, 0x3, 0x2, 0x0, PseudoVLOXEI8_V_M1_M4_TU }, // 242
  { 0x0, 0x1, 0x1, 0x3, 0x2, 0x1, PseudoVLOXEI8_V_M2_M4_TU }, // 243
  { 0x0, 0x1, 0x1, 0x3, 0x2, 0x2, PseudoVLOXEI8_V_M4_M4_TU }, // 244
  { 0x0, 0x1, 0x1, 0x3, 0x2, 0x7, PseudoVLOXEI8_V_MF2_M4_TU }, // 245
  { 0x0, 0x1, 0x1, 0x3, 0x3, 0x0, PseudoVLOXEI8_V_M1_M8_TU }, // 246
  { 0x0, 0x1, 0x1, 0x3, 0x3, 0x1, PseudoVLOXEI8_V_M2_M8_TU }, // 247
  { 0x0, 0x1, 0x1, 0x3, 0x3, 0x2, PseudoVLOXEI8_V_M4_M8_TU }, // 248
  { 0x0, 0x1, 0x1, 0x3, 0x3, 0x3, PseudoVLOXEI8_V_M8_M8_TU }, // 249
  { 0x0, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXEI8_V_MF8_MF8_TU }, // 250
  { 0x0, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXEI8_V_MF8_MF4_TU }, // 251
  { 0x0, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXEI8_V_MF4_MF4_TU }, // 252
  { 0x0, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXEI8_V_MF8_MF2_TU }, // 253
  { 0x0, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXEI8_V_MF4_MF2_TU }, // 254
  { 0x0, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXEI8_V_MF2_MF2_TU }, // 255
  { 0x0, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXEI16_V_M1_M1_TU }, // 256
  { 0x0, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXEI16_V_M2_M1_TU }, // 257
  { 0x0, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXEI16_V_MF4_M1_TU }, // 258
  { 0x0, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXEI16_V_MF2_M1_TU }, // 259
  { 0x0, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXEI16_V_M1_M2_TU }, // 260
  { 0x0, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXEI16_V_M2_M2_TU }, // 261
  { 0x0, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXEI16_V_M4_M2_TU }, // 262
  { 0x0, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXEI16_V_MF2_M2_TU }, // 263
  { 0x0, 0x1, 0x1, 0x4, 0x2, 0x0, PseudoVLOXEI16_V_M1_M4_TU }, // 264
  { 0x0, 0x1, 0x1, 0x4, 0x2, 0x1, PseudoVLOXEI16_V_M2_M4_TU }, // 265
  { 0x0, 0x1, 0x1, 0x4, 0x2, 0x2, PseudoVLOXEI16_V_M4_M4_TU }, // 266
  { 0x0, 0x1, 0x1, 0x4, 0x2, 0x3, PseudoVLOXEI16_V_M8_M4_TU }, // 267
  { 0x0, 0x1, 0x1, 0x4, 0x3, 0x1, PseudoVLOXEI16_V_M2_M8_TU }, // 268
  { 0x0, 0x1, 0x1, 0x4, 0x3, 0x2, PseudoVLOXEI16_V_M4_M8_TU }, // 269
  { 0x0, 0x1, 0x1, 0x4, 0x3, 0x3, PseudoVLOXEI16_V_M8_M8_TU }, // 270
  { 0x0, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXEI16_V_MF4_MF8_TU }, // 271
  { 0x0, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXEI16_V_MF4_MF4_TU }, // 272
  { 0x0, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXEI16_V_MF2_MF4_TU }, // 273
  { 0x0, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXEI16_V_M1_MF2_TU }, // 274
  { 0x0, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXEI16_V_MF4_MF2_TU }, // 275
  { 0x0, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXEI16_V_MF2_MF2_TU }, // 276
  { 0x0, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXEI32_V_M1_M1_TU }, // 277
  { 0x0, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXEI32_V_M2_M1_TU }, // 278
  { 0x0, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXEI32_V_M4_M1_TU }, // 279
  { 0x0, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXEI32_V_MF2_M1_TU }, // 280
  { 0x0, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXEI32_V_M1_M2_TU }, // 281
  { 0x0, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXEI32_V_M2_M2_TU }, // 282
  { 0x0, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXEI32_V_M4_M2_TU }, // 283
  { 0x0, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXEI32_V_M8_M2_TU }, // 284
  { 0x0, 0x1, 0x1, 0x5, 0x2, 0x1, PseudoVLOXEI32_V_M2_M4_TU }, // 285
  { 0x0, 0x1, 0x1, 0x5, 0x2, 0x2, PseudoVLOXEI32_V_M4_M4_TU }, // 286
  { 0x0, 0x1, 0x1, 0x5, 0x2, 0x3, PseudoVLOXEI32_V_M8_M4_TU }, // 287
  { 0x0, 0x1, 0x1, 0x5, 0x3, 0x2, PseudoVLOXEI32_V_M4_M8_TU }, // 288
  { 0x0, 0x1, 0x1, 0x5, 0x3, 0x3, PseudoVLOXEI32_V_M8_M8_TU }, // 289
  { 0x0, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXEI32_V_MF2_MF8_TU }, // 290
  { 0x0, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXEI32_V_M1_MF4_TU }, // 291
  { 0x0, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXEI32_V_MF2_MF4_TU }, // 292
  { 0x0, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXEI32_V_M1_MF2_TU }, // 293
  { 0x0, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXEI32_V_M2_MF2_TU }, // 294
  { 0x0, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXEI32_V_MF2_MF2_TU }, // 295
  { 0x0, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXEI64_V_M1_M1_TU }, // 296
  { 0x0, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXEI64_V_M2_M1_TU }, // 297
  { 0x0, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXEI64_V_M4_M1_TU }, // 298
  { 0x0, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXEI64_V_M8_M1_TU }, // 299
  { 0x0, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXEI64_V_M2_M2_TU }, // 300
  { 0x0, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXEI64_V_M4_M2_TU }, // 301
  { 0x0, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXEI64_V_M8_M2_TU }, // 302
  { 0x0, 0x1, 0x1, 0x6, 0x2, 0x2, PseudoVLOXEI64_V_M4_M4_TU }, // 303
  { 0x0, 0x1, 0x1, 0x6, 0x2, 0x3, PseudoVLOXEI64_V_M8_M4_TU }, // 304
  { 0x0, 0x1, 0x1, 0x6, 0x3, 0x3, PseudoVLOXEI64_V_M8_M8_TU }, // 305
  { 0x0, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXEI64_V_M1_MF8_TU }, // 306
  { 0x0, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXEI64_V_M1_MF4_TU }, // 307
  { 0x0, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXEI64_V_M2_MF4_TU }, // 308
  { 0x0, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXEI64_V_M1_MF2_TU }, // 309
  { 0x0, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXEI64_V_M2_MF2_TU }, // 310
  { 0x0, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXEI64_V_M4_MF2_TU }, // 311
  { 0x1, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVLUXEI8_V_M1_M1_MASK }, // 312
  { 0x1, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVLUXEI8_V_MF8_M1_MASK }, // 313
  { 0x1, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVLUXEI8_V_MF4_M1_MASK }, // 314
  { 0x1, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVLUXEI8_V_MF2_M1_MASK }, // 315
  { 0x1, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVLUXEI8_V_M1_M2_MASK }, // 316
  { 0x1, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVLUXEI8_V_M2_M2_MASK }, // 317
  { 0x1, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVLUXEI8_V_MF4_M2_MASK }, // 318
  { 0x1, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVLUXEI8_V_MF2_M2_MASK }, // 319
  { 0x1, 0x1, 0x0, 0x3, 0x2, 0x0, PseudoVLUXEI8_V_M1_M4_MASK }, // 320
  { 0x1, 0x1, 0x0, 0x3, 0x2, 0x1, PseudoVLUXEI8_V_M2_M4_MASK }, // 321
  { 0x1, 0x1, 0x0, 0x3, 0x2, 0x2, PseudoVLUXEI8_V_M4_M4_MASK }, // 322
  { 0x1, 0x1, 0x0, 0x3, 0x2, 0x7, PseudoVLUXEI8_V_MF2_M4_MASK }, // 323
  { 0x1, 0x1, 0x0, 0x3, 0x3, 0x0, PseudoVLUXEI8_V_M1_M8_MASK }, // 324
  { 0x1, 0x1, 0x0, 0x3, 0x3, 0x1, PseudoVLUXEI8_V_M2_M8_MASK }, // 325
  { 0x1, 0x1, 0x0, 0x3, 0x3, 0x2, PseudoVLUXEI8_V_M4_M8_MASK }, // 326
  { 0x1, 0x1, 0x0, 0x3, 0x3, 0x3, PseudoVLUXEI8_V_M8_M8_MASK }, // 327
  { 0x1, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVLUXEI8_V_MF8_MF8_MASK }, // 328
  { 0x1, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVLUXEI8_V_MF8_MF4_MASK }, // 329
  { 0x1, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVLUXEI8_V_MF4_MF4_MASK }, // 330
  { 0x1, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVLUXEI8_V_MF8_MF2_MASK }, // 331
  { 0x1, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVLUXEI8_V_MF4_MF2_MASK }, // 332
  { 0x1, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVLUXEI8_V_MF2_MF2_MASK }, // 333
  { 0x1, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVLUXEI16_V_M1_M1_MASK }, // 334
  { 0x1, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVLUXEI16_V_M2_M1_MASK }, // 335
  { 0x1, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVLUXEI16_V_MF4_M1_MASK }, // 336
  { 0x1, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVLUXEI16_V_MF2_M1_MASK }, // 337
  { 0x1, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVLUXEI16_V_M1_M2_MASK }, // 338
  { 0x1, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVLUXEI16_V_M2_M2_MASK }, // 339
  { 0x1, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVLUXEI16_V_M4_M2_MASK }, // 340
  { 0x1, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVLUXEI16_V_MF2_M2_MASK }, // 341
  { 0x1, 0x1, 0x0, 0x4, 0x2, 0x0, PseudoVLUXEI16_V_M1_M4_MASK }, // 342
  { 0x1, 0x1, 0x0, 0x4, 0x2, 0x1, PseudoVLUXEI16_V_M2_M4_MASK }, // 343
  { 0x1, 0x1, 0x0, 0x4, 0x2, 0x2, PseudoVLUXEI16_V_M4_M4_MASK }, // 344
  { 0x1, 0x1, 0x0, 0x4, 0x2, 0x3, PseudoVLUXEI16_V_M8_M4_MASK }, // 345
  { 0x1, 0x1, 0x0, 0x4, 0x3, 0x1, PseudoVLUXEI16_V_M2_M8_MASK }, // 346
  { 0x1, 0x1, 0x0, 0x4, 0x3, 0x2, PseudoVLUXEI16_V_M4_M8_MASK }, // 347
  { 0x1, 0x1, 0x0, 0x4, 0x3, 0x3, PseudoVLUXEI16_V_M8_M8_MASK }, // 348
  { 0x1, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVLUXEI16_V_MF4_MF8_MASK }, // 349
  { 0x1, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVLUXEI16_V_MF4_MF4_MASK }, // 350
  { 0x1, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVLUXEI16_V_MF2_MF4_MASK }, // 351
  { 0x1, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVLUXEI16_V_M1_MF2_MASK }, // 352
  { 0x1, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVLUXEI16_V_MF4_MF2_MASK }, // 353
  { 0x1, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVLUXEI16_V_MF2_MF2_MASK }, // 354
  { 0x1, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVLUXEI32_V_M1_M1_MASK }, // 355
  { 0x1, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVLUXEI32_V_M2_M1_MASK }, // 356
  { 0x1, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVLUXEI32_V_M4_M1_MASK }, // 357
  { 0x1, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVLUXEI32_V_MF2_M1_MASK }, // 358
  { 0x1, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVLUXEI32_V_M1_M2_MASK }, // 359
  { 0x1, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVLUXEI32_V_M2_M2_MASK }, // 360
  { 0x1, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVLUXEI32_V_M4_M2_MASK }, // 361
  { 0x1, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVLUXEI32_V_M8_M2_MASK }, // 362
  { 0x1, 0x1, 0x0, 0x5, 0x2, 0x1, PseudoVLUXEI32_V_M2_M4_MASK }, // 363
  { 0x1, 0x1, 0x0, 0x5, 0x2, 0x2, PseudoVLUXEI32_V_M4_M4_MASK }, // 364
  { 0x1, 0x1, 0x0, 0x5, 0x2, 0x3, PseudoVLUXEI32_V_M8_M4_MASK }, // 365
  { 0x1, 0x1, 0x0, 0x5, 0x3, 0x2, PseudoVLUXEI32_V_M4_M8_MASK }, // 366
  { 0x1, 0x1, 0x0, 0x5, 0x3, 0x3, PseudoVLUXEI32_V_M8_M8_MASK }, // 367
  { 0x1, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVLUXEI32_V_MF2_MF8_MASK }, // 368
  { 0x1, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVLUXEI32_V_M1_MF4_MASK }, // 369
  { 0x1, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVLUXEI32_V_MF2_MF4_MASK }, // 370
  { 0x1, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVLUXEI32_V_M1_MF2_MASK }, // 371
  { 0x1, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVLUXEI32_V_M2_MF2_MASK }, // 372
  { 0x1, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVLUXEI32_V_MF2_MF2_MASK }, // 373
  { 0x1, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVLUXEI64_V_M1_M1_MASK }, // 374
  { 0x1, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVLUXEI64_V_M2_M1_MASK }, // 375
  { 0x1, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVLUXEI64_V_M4_M1_MASK }, // 376
  { 0x1, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVLUXEI64_V_M8_M1_MASK }, // 377
  { 0x1, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVLUXEI64_V_M2_M2_MASK }, // 378
  { 0x1, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVLUXEI64_V_M4_M2_MASK }, // 379
  { 0x1, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVLUXEI64_V_M8_M2_MASK }, // 380
  { 0x1, 0x1, 0x0, 0x6, 0x2, 0x2, PseudoVLUXEI64_V_M4_M4_MASK }, // 381
  { 0x1, 0x1, 0x0, 0x6, 0x2, 0x3, PseudoVLUXEI64_V_M8_M4_MASK }, // 382
  { 0x1, 0x1, 0x0, 0x6, 0x3, 0x3, PseudoVLUXEI64_V_M8_M8_MASK }, // 383
  { 0x1, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVLUXEI64_V_M1_MF8_MASK }, // 384
  { 0x1, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVLUXEI64_V_M1_MF4_MASK }, // 385
  { 0x1, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVLUXEI64_V_M2_MF4_MASK }, // 386
  { 0x1, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVLUXEI64_V_M1_MF2_MASK }, // 387
  { 0x1, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVLUXEI64_V_M2_MF2_MASK }, // 388
  { 0x1, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVLUXEI64_V_M4_MF2_MASK }, // 389
  { 0x1, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVLOXEI8_V_M1_M1_MASK }, // 390
  { 0x1, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVLOXEI8_V_MF8_M1_MASK }, // 391
  { 0x1, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVLOXEI8_V_MF4_M1_MASK }, // 392
  { 0x1, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVLOXEI8_V_MF2_M1_MASK }, // 393
  { 0x1, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVLOXEI8_V_M1_M2_MASK }, // 394
  { 0x1, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVLOXEI8_V_M2_M2_MASK }, // 395
  { 0x1, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVLOXEI8_V_MF4_M2_MASK }, // 396
  { 0x1, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVLOXEI8_V_MF2_M2_MASK }, // 397
  { 0x1, 0x1, 0x1, 0x3, 0x2, 0x0, PseudoVLOXEI8_V_M1_M4_MASK }, // 398
  { 0x1, 0x1, 0x1, 0x3, 0x2, 0x1, PseudoVLOXEI8_V_M2_M4_MASK }, // 399
  { 0x1, 0x1, 0x1, 0x3, 0x2, 0x2, PseudoVLOXEI8_V_M4_M4_MASK }, // 400
  { 0x1, 0x1, 0x1, 0x3, 0x2, 0x7, PseudoVLOXEI8_V_MF2_M4_MASK }, // 401
  { 0x1, 0x1, 0x1, 0x3, 0x3, 0x0, PseudoVLOXEI8_V_M1_M8_MASK }, // 402
  { 0x1, 0x1, 0x1, 0x3, 0x3, 0x1, PseudoVLOXEI8_V_M2_M8_MASK }, // 403
  { 0x1, 0x1, 0x1, 0x3, 0x3, 0x2, PseudoVLOXEI8_V_M4_M8_MASK }, // 404
  { 0x1, 0x1, 0x1, 0x3, 0x3, 0x3, PseudoVLOXEI8_V_M8_M8_MASK }, // 405
  { 0x1, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVLOXEI8_V_MF8_MF8_MASK }, // 406
  { 0x1, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVLOXEI8_V_MF8_MF4_MASK }, // 407
  { 0x1, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVLOXEI8_V_MF4_MF4_MASK }, // 408
  { 0x1, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVLOXEI8_V_MF8_MF2_MASK }, // 409
  { 0x1, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVLOXEI8_V_MF4_MF2_MASK }, // 410
  { 0x1, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVLOXEI8_V_MF2_MF2_MASK }, // 411
  { 0x1, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVLOXEI16_V_M1_M1_MASK }, // 412
  { 0x1, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVLOXEI16_V_M2_M1_MASK }, // 413
  { 0x1, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVLOXEI16_V_MF4_M1_MASK }, // 414
  { 0x1, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVLOXEI16_V_MF2_M1_MASK }, // 415
  { 0x1, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVLOXEI16_V_M1_M2_MASK }, // 416
  { 0x1, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVLOXEI16_V_M2_M2_MASK }, // 417
  { 0x1, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVLOXEI16_V_M4_M2_MASK }, // 418
  { 0x1, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVLOXEI16_V_MF2_M2_MASK }, // 419
  { 0x1, 0x1, 0x1, 0x4, 0x2, 0x0, PseudoVLOXEI16_V_M1_M4_MASK }, // 420
  { 0x1, 0x1, 0x1, 0x4, 0x2, 0x1, PseudoVLOXEI16_V_M2_M4_MASK }, // 421
  { 0x1, 0x1, 0x1, 0x4, 0x2, 0x2, PseudoVLOXEI16_V_M4_M4_MASK }, // 422
  { 0x1, 0x1, 0x1, 0x4, 0x2, 0x3, PseudoVLOXEI16_V_M8_M4_MASK }, // 423
  { 0x1, 0x1, 0x1, 0x4, 0x3, 0x1, PseudoVLOXEI16_V_M2_M8_MASK }, // 424
  { 0x1, 0x1, 0x1, 0x4, 0x3, 0x2, PseudoVLOXEI16_V_M4_M8_MASK }, // 425
  { 0x1, 0x1, 0x1, 0x4, 0x3, 0x3, PseudoVLOXEI16_V_M8_M8_MASK }, // 426
  { 0x1, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVLOXEI16_V_MF4_MF8_MASK }, // 427
  { 0x1, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVLOXEI16_V_MF4_MF4_MASK }, // 428
  { 0x1, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVLOXEI16_V_MF2_MF4_MASK }, // 429
  { 0x1, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVLOXEI16_V_M1_MF2_MASK }, // 430
  { 0x1, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVLOXEI16_V_MF4_MF2_MASK }, // 431
  { 0x1, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVLOXEI16_V_MF2_MF2_MASK }, // 432
  { 0x1, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVLOXEI32_V_M1_M1_MASK }, // 433
  { 0x1, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVLOXEI32_V_M2_M1_MASK }, // 434
  { 0x1, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVLOXEI32_V_M4_M1_MASK }, // 435
  { 0x1, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVLOXEI32_V_MF2_M1_MASK }, // 436
  { 0x1, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVLOXEI32_V_M1_M2_MASK }, // 437
  { 0x1, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVLOXEI32_V_M2_M2_MASK }, // 438
  { 0x1, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVLOXEI32_V_M4_M2_MASK }, // 439
  { 0x1, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVLOXEI32_V_M8_M2_MASK }, // 440
  { 0x1, 0x1, 0x1, 0x5, 0x2, 0x1, PseudoVLOXEI32_V_M2_M4_MASK }, // 441
  { 0x1, 0x1, 0x1, 0x5, 0x2, 0x2, PseudoVLOXEI32_V_M4_M4_MASK }, // 442
  { 0x1, 0x1, 0x1, 0x5, 0x2, 0x3, PseudoVLOXEI32_V_M8_M4_MASK }, // 443
  { 0x1, 0x1, 0x1, 0x5, 0x3, 0x2, PseudoVLOXEI32_V_M4_M8_MASK }, // 444
  { 0x1, 0x1, 0x1, 0x5, 0x3, 0x3, PseudoVLOXEI32_V_M8_M8_MASK }, // 445
  { 0x1, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVLOXEI32_V_MF2_MF8_MASK }, // 446
  { 0x1, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVLOXEI32_V_M1_MF4_MASK }, // 447
  { 0x1, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVLOXEI32_V_MF2_MF4_MASK }, // 448
  { 0x1, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVLOXEI32_V_M1_MF2_MASK }, // 449
  { 0x1, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVLOXEI32_V_M2_MF2_MASK }, // 450
  { 0x1, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVLOXEI32_V_MF2_MF2_MASK }, // 451
  { 0x1, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVLOXEI64_V_M1_M1_MASK }, // 452
  { 0x1, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVLOXEI64_V_M2_M1_MASK }, // 453
  { 0x1, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVLOXEI64_V_M4_M1_MASK }, // 454
  { 0x1, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVLOXEI64_V_M8_M1_MASK }, // 455
  { 0x1, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVLOXEI64_V_M2_M2_MASK }, // 456
  { 0x1, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVLOXEI64_V_M4_M2_MASK }, // 457
  { 0x1, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVLOXEI64_V_M8_M2_MASK }, // 458
  { 0x1, 0x1, 0x1, 0x6, 0x2, 0x2, PseudoVLOXEI64_V_M4_M4_MASK }, // 459
  { 0x1, 0x1, 0x1, 0x6, 0x2, 0x3, PseudoVLOXEI64_V_M8_M4_MASK }, // 460
  { 0x1, 0x1, 0x1, 0x6, 0x3, 0x3, PseudoVLOXEI64_V_M8_M8_MASK }, // 461
  { 0x1, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVLOXEI64_V_M1_MF8_MASK }, // 462
  { 0x1, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVLOXEI64_V_M1_MF4_MASK }, // 463
  { 0x1, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVLOXEI64_V_M2_MF4_MASK }, // 464
  { 0x1, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVLOXEI64_V_M1_MF2_MASK }, // 465
  { 0x1, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVLOXEI64_V_M2_MF2_MASK }, // 466
  { 0x1, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVLOXEI64_V_M4_MF2_MASK }, // 467
 };

const VLX_VSXPseudo *getVLXPseudo(uint8_t Masked, uint8_t IsTU, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL) {
  struct KeyType {
    uint8_t Masked;
    uint8_t IsTU;
    uint8_t Ordered;
    uint8_t Log2SEW;
    uint8_t LMUL;
    uint8_t IndexLMUL;
  };
  KeyType Key = {Masked, IsTU, Ordered, Log2SEW, LMUL, IndexLMUL};
  auto Table = ArrayRef(RISCVVLXTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VLX_VSXPseudo &LHS, const KeyType &RHS) {
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.IsTU < RHS.IsTU)
        return true;
      if (LHS.IsTU > RHS.IsTU)
        return false;
      if (LHS.Ordered < RHS.Ordered)
        return true;
      if (LHS.Ordered > RHS.Ordered)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      if (LHS.IndexLMUL < RHS.IndexLMUL)
        return true;
      if (LHS.IndexLMUL > RHS.IndexLMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Masked != Idx->Masked ||
      Key.IsTU != Idx->IsTU ||
      Key.Ordered != Idx->Ordered ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL ||
      Key.IndexLMUL != Idx->IndexLMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVPseudosTable_DECL
const PseudoInfo *getPseudoInfo(unsigned Pseudo);
#endif

#ifdef GET_RISCVVPseudosTable_IMPL
constexpr PseudoInfo RISCVVPseudosTable[] = {
  { PseudoTHVdotVMAQASU_VV_M1, THVdotVMAQASU_VV }, // 0
  { PseudoTHVdotVMAQASU_VV_M1_MASK, THVdotVMAQASU_VV }, // 1
  { PseudoTHVdotVMAQASU_VV_M2, THVdotVMAQASU_VV }, // 2
  { PseudoTHVdotVMAQASU_VV_M2_MASK, THVdotVMAQASU_VV }, // 3
  { PseudoTHVdotVMAQASU_VV_M4, THVdotVMAQASU_VV }, // 4
  { PseudoTHVdotVMAQASU_VV_M4_MASK, THVdotVMAQASU_VV }, // 5
  { PseudoTHVdotVMAQASU_VV_M8, THVdotVMAQASU_VV }, // 6
  { PseudoTHVdotVMAQASU_VV_M8_MASK, THVdotVMAQASU_VV }, // 7
  { PseudoTHVdotVMAQASU_VV_MF2, THVdotVMAQASU_VV }, // 8
  { PseudoTHVdotVMAQASU_VV_MF2_MASK, THVdotVMAQASU_VV }, // 9
  { PseudoTHVdotVMAQASU_VX_M1, THVdotVMAQASU_VX }, // 10
  { PseudoTHVdotVMAQASU_VX_M1_MASK, THVdotVMAQASU_VX }, // 11
  { PseudoTHVdotVMAQASU_VX_M2, THVdotVMAQASU_VX }, // 12
  { PseudoTHVdotVMAQASU_VX_M2_MASK, THVdotVMAQASU_VX }, // 13
  { PseudoTHVdotVMAQASU_VX_M4, THVdotVMAQASU_VX }, // 14
  { PseudoTHVdotVMAQASU_VX_M4_MASK, THVdotVMAQASU_VX }, // 15
  { PseudoTHVdotVMAQASU_VX_M8, THVdotVMAQASU_VX }, // 16
  { PseudoTHVdotVMAQASU_VX_M8_MASK, THVdotVMAQASU_VX }, // 17
  { PseudoTHVdotVMAQASU_VX_MF2, THVdotVMAQASU_VX }, // 18
  { PseudoTHVdotVMAQASU_VX_MF2_MASK, THVdotVMAQASU_VX }, // 19
  { PseudoTHVdotVMAQAUS_VX_M1, THVdotVMAQAUS_VX }, // 20
  { PseudoTHVdotVMAQAUS_VX_M1_MASK, THVdotVMAQAUS_VX }, // 21
  { PseudoTHVdotVMAQAUS_VX_M2, THVdotVMAQAUS_VX }, // 22
  { PseudoTHVdotVMAQAUS_VX_M2_MASK, THVdotVMAQAUS_VX }, // 23
  { PseudoTHVdotVMAQAUS_VX_M4, THVdotVMAQAUS_VX }, // 24
  { PseudoTHVdotVMAQAUS_VX_M4_MASK, THVdotVMAQAUS_VX }, // 25
  { PseudoTHVdotVMAQAUS_VX_M8, THVdotVMAQAUS_VX }, // 26
  { PseudoTHVdotVMAQAUS_VX_M8_MASK, THVdotVMAQAUS_VX }, // 27
  { PseudoTHVdotVMAQAUS_VX_MF2, THVdotVMAQAUS_VX }, // 28
  { PseudoTHVdotVMAQAUS_VX_MF2_MASK, THVdotVMAQAUS_VX }, // 29
  { PseudoTHVdotVMAQAU_VV_M1, THVdotVMAQAU_VV }, // 30
  { PseudoTHVdotVMAQAU_VV_M1_MASK, THVdotVMAQAU_VV }, // 31
  { PseudoTHVdotVMAQAU_VV_M2, THVdotVMAQAU_VV }, // 32
  { PseudoTHVdotVMAQAU_VV_M2_MASK, THVdotVMAQAU_VV }, // 33
  { PseudoTHVdotVMAQAU_VV_M4, THVdotVMAQAU_VV }, // 34
  { PseudoTHVdotVMAQAU_VV_M4_MASK, THVdotVMAQAU_VV }, // 35
  { PseudoTHVdotVMAQAU_VV_M8, THVdotVMAQAU_VV }, // 36
  { PseudoTHVdotVMAQAU_VV_M8_MASK, THVdotVMAQAU_VV }, // 37
  { PseudoTHVdotVMAQAU_VV_MF2, THVdotVMAQAU_VV }, // 38
  { PseudoTHVdotVMAQAU_VV_MF2_MASK, THVdotVMAQAU_VV }, // 39
  { PseudoTHVdotVMAQAU_VX_M1, THVdotVMAQAU_VX }, // 40
  { PseudoTHVdotVMAQAU_VX_M1_MASK, THVdotVMAQAU_VX }, // 41
  { PseudoTHVdotVMAQAU_VX_M2, THVdotVMAQAU_VX }, // 42
  { PseudoTHVdotVMAQAU_VX_M2_MASK, THVdotVMAQAU_VX }, // 43
  { PseudoTHVdotVMAQAU_VX_M4, THVdotVMAQAU_VX }, // 44
  { PseudoTHVdotVMAQAU_VX_M4_MASK, THVdotVMAQAU_VX }, // 45
  { PseudoTHVdotVMAQAU_VX_M8, THVdotVMAQAU_VX }, // 46
  { PseudoTHVdotVMAQAU_VX_M8_MASK, THVdotVMAQAU_VX }, // 47
  { PseudoTHVdotVMAQAU_VX_MF2, THVdotVMAQAU_VX }, // 48
  { PseudoTHVdotVMAQAU_VX_MF2_MASK, THVdotVMAQAU_VX }, // 49
  { PseudoTHVdotVMAQA_VV_M1, THVdotVMAQA_VV }, // 50
  { PseudoTHVdotVMAQA_VV_M1_MASK, THVdotVMAQA_VV }, // 51
  { PseudoTHVdotVMAQA_VV_M2, THVdotVMAQA_VV }, // 52
  { PseudoTHVdotVMAQA_VV_M2_MASK, THVdotVMAQA_VV }, // 53
  { PseudoTHVdotVMAQA_VV_M4, THVdotVMAQA_VV }, // 54
  { PseudoTHVdotVMAQA_VV_M4_MASK, THVdotVMAQA_VV }, // 55
  { PseudoTHVdotVMAQA_VV_M8, THVdotVMAQA_VV }, // 56
  { PseudoTHVdotVMAQA_VV_M8_MASK, THVdotVMAQA_VV }, // 57
  { PseudoTHVdotVMAQA_VV_MF2, THVdotVMAQA_VV }, // 58
  { PseudoTHVdotVMAQA_VV_MF2_MASK, THVdotVMAQA_VV }, // 59
  { PseudoTHVdotVMAQA_VX_M1, THVdotVMAQA_VX }, // 60
  { PseudoTHVdotVMAQA_VX_M1_MASK, THVdotVMAQA_VX }, // 61
  { PseudoTHVdotVMAQA_VX_M2, THVdotVMAQA_VX }, // 62
  { PseudoTHVdotVMAQA_VX_M2_MASK, THVdotVMAQA_VX }, // 63
  { PseudoTHVdotVMAQA_VX_M4, THVdotVMAQA_VX }, // 64
  { PseudoTHVdotVMAQA_VX_M4_MASK, THVdotVMAQA_VX }, // 65
  { PseudoTHVdotVMAQA_VX_M8, THVdotVMAQA_VX }, // 66
  { PseudoTHVdotVMAQA_VX_M8_MASK, THVdotVMAQA_VX }, // 67
  { PseudoTHVdotVMAQA_VX_MF2, THVdotVMAQA_VX }, // 68
  { PseudoTHVdotVMAQA_VX_MF2_MASK, THVdotVMAQA_VX }, // 69
  { PseudoVAADDU_VV_M1, VAADDU_VV }, // 70
  { PseudoVAADDU_VV_M1_MASK, VAADDU_VV }, // 71
  { PseudoVAADDU_VV_M1_TU, VAADDU_VV }, // 72
  { PseudoVAADDU_VV_M2, VAADDU_VV }, // 73
  { PseudoVAADDU_VV_M2_MASK, VAADDU_VV }, // 74
  { PseudoVAADDU_VV_M2_TU, VAADDU_VV }, // 75
  { PseudoVAADDU_VV_M4, VAADDU_VV }, // 76
  { PseudoVAADDU_VV_M4_MASK, VAADDU_VV }, // 77
  { PseudoVAADDU_VV_M4_TU, VAADDU_VV }, // 78
  { PseudoVAADDU_VV_M8, VAADDU_VV }, // 79
  { PseudoVAADDU_VV_M8_MASK, VAADDU_VV }, // 80
  { PseudoVAADDU_VV_M8_TU, VAADDU_VV }, // 81
  { PseudoVAADDU_VV_MF2, VAADDU_VV }, // 82
  { PseudoVAADDU_VV_MF2_MASK, VAADDU_VV }, // 83
  { PseudoVAADDU_VV_MF2_TU, VAADDU_VV }, // 84
  { PseudoVAADDU_VV_MF4, VAADDU_VV }, // 85
  { PseudoVAADDU_VV_MF4_MASK, VAADDU_VV }, // 86
  { PseudoVAADDU_VV_MF4_TU, VAADDU_VV }, // 87
  { PseudoVAADDU_VV_MF8, VAADDU_VV }, // 88
  { PseudoVAADDU_VV_MF8_MASK, VAADDU_VV }, // 89
  { PseudoVAADDU_VV_MF8_TU, VAADDU_VV }, // 90
  { PseudoVAADDU_VX_M1, VAADDU_VX }, // 91
  { PseudoVAADDU_VX_M1_MASK, VAADDU_VX }, // 92
  { PseudoVAADDU_VX_M1_TU, VAADDU_VX }, // 93
  { PseudoVAADDU_VX_M2, VAADDU_VX }, // 94
  { PseudoVAADDU_VX_M2_MASK, VAADDU_VX }, // 95
  { PseudoVAADDU_VX_M2_TU, VAADDU_VX }, // 96
  { PseudoVAADDU_VX_M4, VAADDU_VX }, // 97
  { PseudoVAADDU_VX_M4_MASK, VAADDU_VX }, // 98
  { PseudoVAADDU_VX_M4_TU, VAADDU_VX }, // 99
  { PseudoVAADDU_VX_M8, VAADDU_VX }, // 100
  { PseudoVAADDU_VX_M8_MASK, VAADDU_VX }, // 101
  { PseudoVAADDU_VX_M8_TU, VAADDU_VX }, // 102
  { PseudoVAADDU_VX_MF2, VAADDU_VX }, // 103
  { PseudoVAADDU_VX_MF2_MASK, VAADDU_VX }, // 104
  { PseudoVAADDU_VX_MF2_TU, VAADDU_VX }, // 105
  { PseudoVAADDU_VX_MF4, VAADDU_VX }, // 106
  { PseudoVAADDU_VX_MF4_MASK, VAADDU_VX }, // 107
  { PseudoVAADDU_VX_MF4_TU, VAADDU_VX }, // 108
  { PseudoVAADDU_VX_MF8, VAADDU_VX }, // 109
  { PseudoVAADDU_VX_MF8_MASK, VAADDU_VX }, // 110
  { PseudoVAADDU_VX_MF8_TU, VAADDU_VX }, // 111
  { PseudoVAADD_VV_M1, VAADD_VV }, // 112
  { PseudoVAADD_VV_M1_MASK, VAADD_VV }, // 113
  { PseudoVAADD_VV_M1_TU, VAADD_VV }, // 114
  { PseudoVAADD_VV_M2, VAADD_VV }, // 115
  { PseudoVAADD_VV_M2_MASK, VAADD_VV }, // 116
  { PseudoVAADD_VV_M2_TU, VAADD_VV }, // 117
  { PseudoVAADD_VV_M4, VAADD_VV }, // 118
  { PseudoVAADD_VV_M4_MASK, VAADD_VV }, // 119
  { PseudoVAADD_VV_M4_TU, VAADD_VV }, // 120
  { PseudoVAADD_VV_M8, VAADD_VV }, // 121
  { PseudoVAADD_VV_M8_MASK, VAADD_VV }, // 122
  { PseudoVAADD_VV_M8_TU, VAADD_VV }, // 123
  { PseudoVAADD_VV_MF2, VAADD_VV }, // 124
  { PseudoVAADD_VV_MF2_MASK, VAADD_VV }, // 125
  { PseudoVAADD_VV_MF2_TU, VAADD_VV }, // 126
  { PseudoVAADD_VV_MF4, VAADD_VV }, // 127
  { PseudoVAADD_VV_MF4_MASK, VAADD_VV }, // 128
  { PseudoVAADD_VV_MF4_TU, VAADD_VV }, // 129
  { PseudoVAADD_VV_MF8, VAADD_VV }, // 130
  { PseudoVAADD_VV_MF8_MASK, VAADD_VV }, // 131
  { PseudoVAADD_VV_MF8_TU, VAADD_VV }, // 132
  { PseudoVAADD_VX_M1, VAADD_VX }, // 133
  { PseudoVAADD_VX_M1_MASK, VAADD_VX }, // 134
  { PseudoVAADD_VX_M1_TU, VAADD_VX }, // 135
  { PseudoVAADD_VX_M2, VAADD_VX }, // 136
  { PseudoVAADD_VX_M2_MASK, VAADD_VX }, // 137
  { PseudoVAADD_VX_M2_TU, VAADD_VX }, // 138
  { PseudoVAADD_VX_M4, VAADD_VX }, // 139
  { PseudoVAADD_VX_M4_MASK, VAADD_VX }, // 140
  { PseudoVAADD_VX_M4_TU, VAADD_VX }, // 141
  { PseudoVAADD_VX_M8, VAADD_VX }, // 142
  { PseudoVAADD_VX_M8_MASK, VAADD_VX }, // 143
  { PseudoVAADD_VX_M8_TU, VAADD_VX }, // 144
  { PseudoVAADD_VX_MF2, VAADD_VX }, // 145
  { PseudoVAADD_VX_MF2_MASK, VAADD_VX }, // 146
  { PseudoVAADD_VX_MF2_TU, VAADD_VX }, // 147
  { PseudoVAADD_VX_MF4, VAADD_VX }, // 148
  { PseudoVAADD_VX_MF4_MASK, VAADD_VX }, // 149
  { PseudoVAADD_VX_MF4_TU, VAADD_VX }, // 150
  { PseudoVAADD_VX_MF8, VAADD_VX }, // 151
  { PseudoVAADD_VX_MF8_MASK, VAADD_VX }, // 152
  { PseudoVAADD_VX_MF8_TU, VAADD_VX }, // 153
  { PseudoVADC_VIM_M1, VADC_VIM }, // 154
  { PseudoVADC_VIM_M1_TU, VADC_VIM }, // 155
  { PseudoVADC_VIM_M2, VADC_VIM }, // 156
  { PseudoVADC_VIM_M2_TU, VADC_VIM }, // 157
  { PseudoVADC_VIM_M4, VADC_VIM }, // 158
  { PseudoVADC_VIM_M4_TU, VADC_VIM }, // 159
  { PseudoVADC_VIM_M8, VADC_VIM }, // 160
  { PseudoVADC_VIM_M8_TU, VADC_VIM }, // 161
  { PseudoVADC_VIM_MF2, VADC_VIM }, // 162
  { PseudoVADC_VIM_MF2_TU, VADC_VIM }, // 163
  { PseudoVADC_VIM_MF4, VADC_VIM }, // 164
  { PseudoVADC_VIM_MF4_TU, VADC_VIM }, // 165
  { PseudoVADC_VIM_MF8, VADC_VIM }, // 166
  { PseudoVADC_VIM_MF8_TU, VADC_VIM }, // 167
  { PseudoVADC_VVM_M1, VADC_VVM }, // 168
  { PseudoVADC_VVM_M1_TU, VADC_VVM }, // 169
  { PseudoVADC_VVM_M2, VADC_VVM }, // 170
  { PseudoVADC_VVM_M2_TU, VADC_VVM }, // 171
  { PseudoVADC_VVM_M4, VADC_VVM }, // 172
  { PseudoVADC_VVM_M4_TU, VADC_VVM }, // 173
  { PseudoVADC_VVM_M8, VADC_VVM }, // 174
  { PseudoVADC_VVM_M8_TU, VADC_VVM }, // 175
  { PseudoVADC_VVM_MF2, VADC_VVM }, // 176
  { PseudoVADC_VVM_MF2_TU, VADC_VVM }, // 177
  { PseudoVADC_VVM_MF4, VADC_VVM }, // 178
  { PseudoVADC_VVM_MF4_TU, VADC_VVM }, // 179
  { PseudoVADC_VVM_MF8, VADC_VVM }, // 180
  { PseudoVADC_VVM_MF8_TU, VADC_VVM }, // 181
  { PseudoVADC_VXM_M1, VADC_VXM }, // 182
  { PseudoVADC_VXM_M1_TU, VADC_VXM }, // 183
  { PseudoVADC_VXM_M2, VADC_VXM }, // 184
  { PseudoVADC_VXM_M2_TU, VADC_VXM }, // 185
  { PseudoVADC_VXM_M4, VADC_VXM }, // 186
  { PseudoVADC_VXM_M4_TU, VADC_VXM }, // 187
  { PseudoVADC_VXM_M8, VADC_VXM }, // 188
  { PseudoVADC_VXM_M8_TU, VADC_VXM }, // 189
  { PseudoVADC_VXM_MF2, VADC_VXM }, // 190
  { PseudoVADC_VXM_MF2_TU, VADC_VXM }, // 191
  { PseudoVADC_VXM_MF4, VADC_VXM }, // 192
  { PseudoVADC_VXM_MF4_TU, VADC_VXM }, // 193
  { PseudoVADC_VXM_MF8, VADC_VXM }, // 194
  { PseudoVADC_VXM_MF8_TU, VADC_VXM }, // 195
  { PseudoVADD_VI_M1, VADD_VI }, // 196
  { PseudoVADD_VI_M1_MASK, VADD_VI }, // 197
  { PseudoVADD_VI_M1_TU, VADD_VI }, // 198
  { PseudoVADD_VI_M2, VADD_VI }, // 199
  { PseudoVADD_VI_M2_MASK, VADD_VI }, // 200
  { PseudoVADD_VI_M2_TU, VADD_VI }, // 201
  { PseudoVADD_VI_M4, VADD_VI }, // 202
  { PseudoVADD_VI_M4_MASK, VADD_VI }, // 203
  { PseudoVADD_VI_M4_TU, VADD_VI }, // 204
  { PseudoVADD_VI_M8, VADD_VI }, // 205
  { PseudoVADD_VI_M8_MASK, VADD_VI }, // 206
  { PseudoVADD_VI_M8_TU, VADD_VI }, // 207
  { PseudoVADD_VI_MF2, VADD_VI }, // 208
  { PseudoVADD_VI_MF2_MASK, VADD_VI }, // 209
  { PseudoVADD_VI_MF2_TU, VADD_VI }, // 210
  { PseudoVADD_VI_MF4, VADD_VI }, // 211
  { PseudoVADD_VI_MF4_MASK, VADD_VI }, // 212
  { PseudoVADD_VI_MF4_TU, VADD_VI }, // 213
  { PseudoVADD_VI_MF8, VADD_VI }, // 214
  { PseudoVADD_VI_MF8_MASK, VADD_VI }, // 215
  { PseudoVADD_VI_MF8_TU, VADD_VI }, // 216
  { PseudoVADD_VV_M1, VADD_VV }, // 217
  { PseudoVADD_VV_M1_MASK, VADD_VV }, // 218
  { PseudoVADD_VV_M1_TU, VADD_VV }, // 219
  { PseudoVADD_VV_M2, VADD_VV }, // 220
  { PseudoVADD_VV_M2_MASK, VADD_VV }, // 221
  { PseudoVADD_VV_M2_TU, VADD_VV }, // 222
  { PseudoVADD_VV_M4, VADD_VV }, // 223
  { PseudoVADD_VV_M4_MASK, VADD_VV }, // 224
  { PseudoVADD_VV_M4_TU, VADD_VV }, // 225
  { PseudoVADD_VV_M8, VADD_VV }, // 226
  { PseudoVADD_VV_M8_MASK, VADD_VV }, // 227
  { PseudoVADD_VV_M8_TU, VADD_VV }, // 228
  { PseudoVADD_VV_MF2, VADD_VV }, // 229
  { PseudoVADD_VV_MF2_MASK, VADD_VV }, // 230
  { PseudoVADD_VV_MF2_TU, VADD_VV }, // 231
  { PseudoVADD_VV_MF4, VADD_VV }, // 232
  { PseudoVADD_VV_MF4_MASK, VADD_VV }, // 233
  { PseudoVADD_VV_MF4_TU, VADD_VV }, // 234
  { PseudoVADD_VV_MF8, VADD_VV }, // 235
  { PseudoVADD_VV_MF8_MASK, VADD_VV }, // 236
  { PseudoVADD_VV_MF8_TU, VADD_VV }, // 237
  { PseudoVADD_VX_M1, VADD_VX }, // 238
  { PseudoVADD_VX_M1_MASK, VADD_VX }, // 239
  { PseudoVADD_VX_M1_TU, VADD_VX }, // 240
  { PseudoVADD_VX_M2, VADD_VX }, // 241
  { PseudoVADD_VX_M2_MASK, VADD_VX }, // 242
  { PseudoVADD_VX_M2_TU, VADD_VX }, // 243
  { PseudoVADD_VX_M4, VADD_VX }, // 244
  { PseudoVADD_VX_M4_MASK, VADD_VX }, // 245
  { PseudoVADD_VX_M4_TU, VADD_VX }, // 246
  { PseudoVADD_VX_M8, VADD_VX }, // 247
  { PseudoVADD_VX_M8_MASK, VADD_VX }, // 248
  { PseudoVADD_VX_M8_TU, VADD_VX }, // 249
  { PseudoVADD_VX_MF2, VADD_VX }, // 250
  { PseudoVADD_VX_MF2_MASK, VADD_VX }, // 251
  { PseudoVADD_VX_MF2_TU, VADD_VX }, // 252
  { PseudoVADD_VX_MF4, VADD_VX }, // 253
  { PseudoVADD_VX_MF4_MASK, VADD_VX }, // 254
  { PseudoVADD_VX_MF4_TU, VADD_VX }, // 255
  { PseudoVADD_VX_MF8, VADD_VX }, // 256
  { PseudoVADD_VX_MF8_MASK, VADD_VX }, // 257
  { PseudoVADD_VX_MF8_TU, VADD_VX }, // 258
  { PseudoVAND_VI_M1, VAND_VI }, // 259
  { PseudoVAND_VI_M1_MASK, VAND_VI }, // 260
  { PseudoVAND_VI_M1_TU, VAND_VI }, // 261
  { PseudoVAND_VI_M2, VAND_VI }, // 262
  { PseudoVAND_VI_M2_MASK, VAND_VI }, // 263
  { PseudoVAND_VI_M2_TU, VAND_VI }, // 264
  { PseudoVAND_VI_M4, VAND_VI }, // 265
  { PseudoVAND_VI_M4_MASK, VAND_VI }, // 266
  { PseudoVAND_VI_M4_TU, VAND_VI }, // 267
  { PseudoVAND_VI_M8, VAND_VI }, // 268
  { PseudoVAND_VI_M8_MASK, VAND_VI }, // 269
  { PseudoVAND_VI_M8_TU, VAND_VI }, // 270
  { PseudoVAND_VI_MF2, VAND_VI }, // 271
  { PseudoVAND_VI_MF2_MASK, VAND_VI }, // 272
  { PseudoVAND_VI_MF2_TU, VAND_VI }, // 273
  { PseudoVAND_VI_MF4, VAND_VI }, // 274
  { PseudoVAND_VI_MF4_MASK, VAND_VI }, // 275
  { PseudoVAND_VI_MF4_TU, VAND_VI }, // 276
  { PseudoVAND_VI_MF8, VAND_VI }, // 277
  { PseudoVAND_VI_MF8_MASK, VAND_VI }, // 278
  { PseudoVAND_VI_MF8_TU, VAND_VI }, // 279
  { PseudoVAND_VV_M1, VAND_VV }, // 280
  { PseudoVAND_VV_M1_MASK, VAND_VV }, // 281
  { PseudoVAND_VV_M1_TU, VAND_VV }, // 282
  { PseudoVAND_VV_M2, VAND_VV }, // 283
  { PseudoVAND_VV_M2_MASK, VAND_VV }, // 284
  { PseudoVAND_VV_M2_TU, VAND_VV }, // 285
  { PseudoVAND_VV_M4, VAND_VV }, // 286
  { PseudoVAND_VV_M4_MASK, VAND_VV }, // 287
  { PseudoVAND_VV_M4_TU, VAND_VV }, // 288
  { PseudoVAND_VV_M8, VAND_VV }, // 289
  { PseudoVAND_VV_M8_MASK, VAND_VV }, // 290
  { PseudoVAND_VV_M8_TU, VAND_VV }, // 291
  { PseudoVAND_VV_MF2, VAND_VV }, // 292
  { PseudoVAND_VV_MF2_MASK, VAND_VV }, // 293
  { PseudoVAND_VV_MF2_TU, VAND_VV }, // 294
  { PseudoVAND_VV_MF4, VAND_VV }, // 295
  { PseudoVAND_VV_MF4_MASK, VAND_VV }, // 296
  { PseudoVAND_VV_MF4_TU, VAND_VV }, // 297
  { PseudoVAND_VV_MF8, VAND_VV }, // 298
  { PseudoVAND_VV_MF8_MASK, VAND_VV }, // 299
  { PseudoVAND_VV_MF8_TU, VAND_VV }, // 300
  { PseudoVAND_VX_M1, VAND_VX }, // 301
  { PseudoVAND_VX_M1_MASK, VAND_VX }, // 302
  { PseudoVAND_VX_M1_TU, VAND_VX }, // 303
  { PseudoVAND_VX_M2, VAND_VX }, // 304
  { PseudoVAND_VX_M2_MASK, VAND_VX }, // 305
  { PseudoVAND_VX_M2_TU, VAND_VX }, // 306
  { PseudoVAND_VX_M4, VAND_VX }, // 307
  { PseudoVAND_VX_M4_MASK, VAND_VX }, // 308
  { PseudoVAND_VX_M4_TU, VAND_VX }, // 309
  { PseudoVAND_VX_M8, VAND_VX }, // 310
  { PseudoVAND_VX_M8_MASK, VAND_VX }, // 311
  { PseudoVAND_VX_M8_TU, VAND_VX }, // 312
  { PseudoVAND_VX_MF2, VAND_VX }, // 313
  { PseudoVAND_VX_MF2_MASK, VAND_VX }, // 314
  { PseudoVAND_VX_MF2_TU, VAND_VX }, // 315
  { PseudoVAND_VX_MF4, VAND_VX }, // 316
  { PseudoVAND_VX_MF4_MASK, VAND_VX }, // 317
  { PseudoVAND_VX_MF4_TU, VAND_VX }, // 318
  { PseudoVAND_VX_MF8, VAND_VX }, // 319
  { PseudoVAND_VX_MF8_MASK, VAND_VX }, // 320
  { PseudoVAND_VX_MF8_TU, VAND_VX }, // 321
  { PseudoVASUBU_VV_M1, VASUBU_VV }, // 322
  { PseudoVASUBU_VV_M1_MASK, VASUBU_VV }, // 323
  { PseudoVASUBU_VV_M1_TU, VASUBU_VV }, // 324
  { PseudoVASUBU_VV_M2, VASUBU_VV }, // 325
  { PseudoVASUBU_VV_M2_MASK, VASUBU_VV }, // 326
  { PseudoVASUBU_VV_M2_TU, VASUBU_VV }, // 327
  { PseudoVASUBU_VV_M4, VASUBU_VV }, // 328
  { PseudoVASUBU_VV_M4_MASK, VASUBU_VV }, // 329
  { PseudoVASUBU_VV_M4_TU, VASUBU_VV }, // 330
  { PseudoVASUBU_VV_M8, VASUBU_VV }, // 331
  { PseudoVASUBU_VV_M8_MASK, VASUBU_VV }, // 332
  { PseudoVASUBU_VV_M8_TU, VASUBU_VV }, // 333
  { PseudoVASUBU_VV_MF2, VASUBU_VV }, // 334
  { PseudoVASUBU_VV_MF2_MASK, VASUBU_VV }, // 335
  { PseudoVASUBU_VV_MF2_TU, VASUBU_VV }, // 336
  { PseudoVASUBU_VV_MF4, VASUBU_VV }, // 337
  { PseudoVASUBU_VV_MF4_MASK, VASUBU_VV }, // 338
  { PseudoVASUBU_VV_MF4_TU, VASUBU_VV }, // 339
  { PseudoVASUBU_VV_MF8, VASUBU_VV }, // 340
  { PseudoVASUBU_VV_MF8_MASK, VASUBU_VV }, // 341
  { PseudoVASUBU_VV_MF8_TU, VASUBU_VV }, // 342
  { PseudoVASUBU_VX_M1, VASUBU_VX }, // 343
  { PseudoVASUBU_VX_M1_MASK, VASUBU_VX }, // 344
  { PseudoVASUBU_VX_M1_TU, VASUBU_VX }, // 345
  { PseudoVASUBU_VX_M2, VASUBU_VX }, // 346
  { PseudoVASUBU_VX_M2_MASK, VASUBU_VX }, // 347
  { PseudoVASUBU_VX_M2_TU, VASUBU_VX }, // 348
  { PseudoVASUBU_VX_M4, VASUBU_VX }, // 349
  { PseudoVASUBU_VX_M4_MASK, VASUBU_VX }, // 350
  { PseudoVASUBU_VX_M4_TU, VASUBU_VX }, // 351
  { PseudoVASUBU_VX_M8, VASUBU_VX }, // 352
  { PseudoVASUBU_VX_M8_MASK, VASUBU_VX }, // 353
  { PseudoVASUBU_VX_M8_TU, VASUBU_VX }, // 354
  { PseudoVASUBU_VX_MF2, VASUBU_VX }, // 355
  { PseudoVASUBU_VX_MF2_MASK, VASUBU_VX }, // 356
  { PseudoVASUBU_VX_MF2_TU, VASUBU_VX }, // 357
  { PseudoVASUBU_VX_MF4, VASUBU_VX }, // 358
  { PseudoVASUBU_VX_MF4_MASK, VASUBU_VX }, // 359
  { PseudoVASUBU_VX_MF4_TU, VASUBU_VX }, // 360
  { PseudoVASUBU_VX_MF8, VASUBU_VX }, // 361
  { PseudoVASUBU_VX_MF8_MASK, VASUBU_VX }, // 362
  { PseudoVASUBU_VX_MF8_TU, VASUBU_VX }, // 363
  { PseudoVASUB_VV_M1, VASUB_VV }, // 364
  { PseudoVASUB_VV_M1_MASK, VASUB_VV }, // 365
  { PseudoVASUB_VV_M1_TU, VASUB_VV }, // 366
  { PseudoVASUB_VV_M2, VASUB_VV }, // 367
  { PseudoVASUB_VV_M2_MASK, VASUB_VV }, // 368
  { PseudoVASUB_VV_M2_TU, VASUB_VV }, // 369
  { PseudoVASUB_VV_M4, VASUB_VV }, // 370
  { PseudoVASUB_VV_M4_MASK, VASUB_VV }, // 371
  { PseudoVASUB_VV_M4_TU, VASUB_VV }, // 372
  { PseudoVASUB_VV_M8, VASUB_VV }, // 373
  { PseudoVASUB_VV_M8_MASK, VASUB_VV }, // 374
  { PseudoVASUB_VV_M8_TU, VASUB_VV }, // 375
  { PseudoVASUB_VV_MF2, VASUB_VV }, // 376
  { PseudoVASUB_VV_MF2_MASK, VASUB_VV }, // 377
  { PseudoVASUB_VV_MF2_TU, VASUB_VV }, // 378
  { PseudoVASUB_VV_MF4, VASUB_VV }, // 379
  { PseudoVASUB_VV_MF4_MASK, VASUB_VV }, // 380
  { PseudoVASUB_VV_MF4_TU, VASUB_VV }, // 381
  { PseudoVASUB_VV_MF8, VASUB_VV }, // 382
  { PseudoVASUB_VV_MF8_MASK, VASUB_VV }, // 383
  { PseudoVASUB_VV_MF8_TU, VASUB_VV }, // 384
  { PseudoVASUB_VX_M1, VASUB_VX }, // 385
  { PseudoVASUB_VX_M1_MASK, VASUB_VX }, // 386
  { PseudoVASUB_VX_M1_TU, VASUB_VX }, // 387
  { PseudoVASUB_VX_M2, VASUB_VX }, // 388
  { PseudoVASUB_VX_M2_MASK, VASUB_VX }, // 389
  { PseudoVASUB_VX_M2_TU, VASUB_VX }, // 390
  { PseudoVASUB_VX_M4, VASUB_VX }, // 391
  { PseudoVASUB_VX_M4_MASK, VASUB_VX }, // 392
  { PseudoVASUB_VX_M4_TU, VASUB_VX }, // 393
  { PseudoVASUB_VX_M8, VASUB_VX }, // 394
  { PseudoVASUB_VX_M8_MASK, VASUB_VX }, // 395
  { PseudoVASUB_VX_M8_TU, VASUB_VX }, // 396
  { PseudoVASUB_VX_MF2, VASUB_VX }, // 397
  { PseudoVASUB_VX_MF2_MASK, VASUB_VX }, // 398
  { PseudoVASUB_VX_MF2_TU, VASUB_VX }, // 399
  { PseudoVASUB_VX_MF4, VASUB_VX }, // 400
  { PseudoVASUB_VX_MF4_MASK, VASUB_VX }, // 401
  { PseudoVASUB_VX_MF4_TU, VASUB_VX }, // 402
  { PseudoVASUB_VX_MF8, VASUB_VX }, // 403
  { PseudoVASUB_VX_MF8_MASK, VASUB_VX }, // 404
  { PseudoVASUB_VX_MF8_TU, VASUB_VX }, // 405
  { PseudoVCOMPRESS_VM_M1_E16, VCOMPRESS_VM }, // 406
  { PseudoVCOMPRESS_VM_M1_E32, VCOMPRESS_VM }, // 407
  { PseudoVCOMPRESS_VM_M1_E64, VCOMPRESS_VM }, // 408
  { PseudoVCOMPRESS_VM_M1_E8, VCOMPRESS_VM }, // 409
  { PseudoVCOMPRESS_VM_M2_E16, VCOMPRESS_VM }, // 410
  { PseudoVCOMPRESS_VM_M2_E32, VCOMPRESS_VM }, // 411
  { PseudoVCOMPRESS_VM_M2_E64, VCOMPRESS_VM }, // 412
  { PseudoVCOMPRESS_VM_M2_E8, VCOMPRESS_VM }, // 413
  { PseudoVCOMPRESS_VM_M4_E16, VCOMPRESS_VM }, // 414
  { PseudoVCOMPRESS_VM_M4_E32, VCOMPRESS_VM }, // 415
  { PseudoVCOMPRESS_VM_M4_E64, VCOMPRESS_VM }, // 416
  { PseudoVCOMPRESS_VM_M4_E8, VCOMPRESS_VM }, // 417
  { PseudoVCOMPRESS_VM_M8_E16, VCOMPRESS_VM }, // 418
  { PseudoVCOMPRESS_VM_M8_E32, VCOMPRESS_VM }, // 419
  { PseudoVCOMPRESS_VM_M8_E64, VCOMPRESS_VM }, // 420
  { PseudoVCOMPRESS_VM_M8_E8, VCOMPRESS_VM }, // 421
  { PseudoVCOMPRESS_VM_MF2_E16, VCOMPRESS_VM }, // 422
  { PseudoVCOMPRESS_VM_MF2_E32, VCOMPRESS_VM }, // 423
  { PseudoVCOMPRESS_VM_MF2_E8, VCOMPRESS_VM }, // 424
  { PseudoVCOMPRESS_VM_MF4_E16, VCOMPRESS_VM }, // 425
  { PseudoVCOMPRESS_VM_MF4_E8, VCOMPRESS_VM }, // 426
  { PseudoVCOMPRESS_VM_MF8_E8, VCOMPRESS_VM }, // 427
  { PseudoVCPOP_M_B1, VCPOP_M }, // 428
  { PseudoVCPOP_M_B16, VCPOP_M }, // 429
  { PseudoVCPOP_M_B16_MASK, VCPOP_M }, // 430
  { PseudoVCPOP_M_B1_MASK, VCPOP_M }, // 431
  { PseudoVCPOP_M_B2, VCPOP_M }, // 432
  { PseudoVCPOP_M_B2_MASK, VCPOP_M }, // 433
  { PseudoVCPOP_M_B32, VCPOP_M }, // 434
  { PseudoVCPOP_M_B32_MASK, VCPOP_M }, // 435
  { PseudoVCPOP_M_B4, VCPOP_M }, // 436
  { PseudoVCPOP_M_B4_MASK, VCPOP_M }, // 437
  { PseudoVCPOP_M_B64, VCPOP_M }, // 438
  { PseudoVCPOP_M_B64_MASK, VCPOP_M }, // 439
  { PseudoVCPOP_M_B8, VCPOP_M }, // 440
  { PseudoVCPOP_M_B8_MASK, VCPOP_M }, // 441
  { PseudoVC_F16VV_SE_M1, VC_FVV }, // 442
  { PseudoVC_F16VV_SE_M2, VC_FVV }, // 443
  { PseudoVC_F16VV_SE_M4, VC_FVV }, // 444
  { PseudoVC_F16VV_SE_M8, VC_FVV }, // 445
  { PseudoVC_F16VV_SE_MF2, VC_FVV }, // 446
  { PseudoVC_F16VV_SE_MF4, VC_FVV }, // 447
  { PseudoVC_F16VW_SE_M1, VC_FVW }, // 448
  { PseudoVC_F16VW_SE_M2, VC_FVW }, // 449
  { PseudoVC_F16VW_SE_M4, VC_FVW }, // 450
  { PseudoVC_F16VW_SE_M8, VC_FVW }, // 451
  { PseudoVC_F16VW_SE_MF2, VC_FVW }, // 452
  { PseudoVC_F16VW_SE_MF4, VC_FVW }, // 453
  { PseudoVC_F16V_SE_M1, VC_FV }, // 454
  { PseudoVC_F16V_SE_M2, VC_FV }, // 455
  { PseudoVC_F16V_SE_M4, VC_FV }, // 456
  { PseudoVC_F16V_SE_M8, VC_FV }, // 457
  { PseudoVC_F16V_SE_MF2, VC_FV }, // 458
  { PseudoVC_F16V_SE_MF4, VC_FV }, // 459
  { PseudoVC_F32VV_SE_M1, VC_FVV }, // 460
  { PseudoVC_F32VV_SE_M2, VC_FVV }, // 461
  { PseudoVC_F32VV_SE_M4, VC_FVV }, // 462
  { PseudoVC_F32VV_SE_M8, VC_FVV }, // 463
  { PseudoVC_F32VV_SE_MF2, VC_FVV }, // 464
  { PseudoVC_F32VW_SE_M1, VC_FVW }, // 465
  { PseudoVC_F32VW_SE_M2, VC_FVW }, // 466
  { PseudoVC_F32VW_SE_M4, VC_FVW }, // 467
  { PseudoVC_F32VW_SE_M8, VC_FVW }, // 468
  { PseudoVC_F32VW_SE_MF2, VC_FVW }, // 469
  { PseudoVC_F32V_SE_M1, VC_FV }, // 470
  { PseudoVC_F32V_SE_M2, VC_FV }, // 471
  { PseudoVC_F32V_SE_M4, VC_FV }, // 472
  { PseudoVC_F32V_SE_M8, VC_FV }, // 473
  { PseudoVC_F32V_SE_MF2, VC_FV }, // 474
  { PseudoVC_F64VV_SE_M1, VC_FVV }, // 475
  { PseudoVC_F64VV_SE_M2, VC_FVV }, // 476
  { PseudoVC_F64VV_SE_M4, VC_FVV }, // 477
  { PseudoVC_F64VV_SE_M8, VC_FVV }, // 478
  { PseudoVC_F64V_SE_M1, VC_FV }, // 479
  { PseudoVC_F64V_SE_M2, VC_FV }, // 480
  { PseudoVC_F64V_SE_M4, VC_FV }, // 481
  { PseudoVC_F64V_SE_M8, VC_FV }, // 482
  { PseudoVC_IVV_SE_M1, VC_IVV }, // 483
  { PseudoVC_IVV_SE_M2, VC_IVV }, // 484
  { PseudoVC_IVV_SE_M4, VC_IVV }, // 485
  { PseudoVC_IVV_SE_M8, VC_IVV }, // 486
  { PseudoVC_IVV_SE_MF2, VC_IVV }, // 487
  { PseudoVC_IVV_SE_MF4, VC_IVV }, // 488
  { PseudoVC_IVV_SE_MF8, VC_IVV }, // 489
  { PseudoVC_IVW_SE_M1, VC_IVW }, // 490
  { PseudoVC_IVW_SE_M2, VC_IVW }, // 491
  { PseudoVC_IVW_SE_M4, VC_IVW }, // 492
  { PseudoVC_IVW_SE_MF2, VC_IVW }, // 493
  { PseudoVC_IVW_SE_MF4, VC_IVW }, // 494
  { PseudoVC_IVW_SE_MF8, VC_IVW }, // 495
  { PseudoVC_IV_SE_M1, VC_IV }, // 496
  { PseudoVC_IV_SE_M2, VC_IV }, // 497
  { PseudoVC_IV_SE_M4, VC_IV }, // 498
  { PseudoVC_IV_SE_M8, VC_IV }, // 499
  { PseudoVC_IV_SE_MF2, VC_IV }, // 500
  { PseudoVC_IV_SE_MF4, VC_IV }, // 501
  { PseudoVC_IV_SE_MF8, VC_IV }, // 502
  { PseudoVC_I_SE_M1, VC_I }, // 503
  { PseudoVC_I_SE_M2, VC_I }, // 504
  { PseudoVC_I_SE_M4, VC_I }, // 505
  { PseudoVC_I_SE_M8, VC_I }, // 506
  { PseudoVC_I_SE_MF2, VC_I }, // 507
  { PseudoVC_I_SE_MF4, VC_I }, // 508
  { PseudoVC_I_SE_MF8, VC_I }, // 509
  { PseudoVC_VVV_SE_M1, VC_VVV }, // 510
  { PseudoVC_VVV_SE_M2, VC_VVV }, // 511
  { PseudoVC_VVV_SE_M4, VC_VVV }, // 512
  { PseudoVC_VVV_SE_M8, VC_VVV }, // 513
  { PseudoVC_VVV_SE_MF2, VC_VVV }, // 514
  { PseudoVC_VVV_SE_MF4, VC_VVV }, // 515
  { PseudoVC_VVV_SE_MF8, VC_VVV }, // 516
  { PseudoVC_VVW_SE_M1, VC_VVW }, // 517
  { PseudoVC_VVW_SE_M2, VC_VVW }, // 518
  { PseudoVC_VVW_SE_M4, VC_VVW }, // 519
  { PseudoVC_VVW_SE_MF2, VC_VVW }, // 520
  { PseudoVC_VVW_SE_MF4, VC_VVW }, // 521
  { PseudoVC_VVW_SE_MF8, VC_VVW }, // 522
  { PseudoVC_VV_SE_M1, VC_VV }, // 523
  { PseudoVC_VV_SE_M2, VC_VV }, // 524
  { PseudoVC_VV_SE_M4, VC_VV }, // 525
  { PseudoVC_VV_SE_M8, VC_VV }, // 526
  { PseudoVC_VV_SE_MF2, VC_VV }, // 527
  { PseudoVC_VV_SE_MF4, VC_VV }, // 528
  { PseudoVC_VV_SE_MF8, VC_VV }, // 529
  { PseudoVC_V_F16VV_M1, VC_V_FVV }, // 530
  { PseudoVC_V_F16VV_M2, VC_V_FVV }, // 531
  { PseudoVC_V_F16VV_M4, VC_V_FVV }, // 532
  { PseudoVC_V_F16VV_M8, VC_V_FVV }, // 533
  { PseudoVC_V_F16VV_MF2, VC_V_FVV }, // 534
  { PseudoVC_V_F16VV_MF4, VC_V_FVV }, // 535
  { PseudoVC_V_F16VV_SE_M1, VC_V_FVV }, // 536
  { PseudoVC_V_F16VV_SE_M2, VC_V_FVV }, // 537
  { PseudoVC_V_F16VV_SE_M4, VC_V_FVV }, // 538
  { PseudoVC_V_F16VV_SE_M8, VC_V_FVV }, // 539
  { PseudoVC_V_F16VV_SE_MF2, VC_V_FVV }, // 540
  { PseudoVC_V_F16VV_SE_MF4, VC_V_FVV }, // 541
  { PseudoVC_V_F16VW_M1, VC_V_FVW }, // 542
  { PseudoVC_V_F16VW_M2, VC_V_FVW }, // 543
  { PseudoVC_V_F16VW_M4, VC_V_FVW }, // 544
  { PseudoVC_V_F16VW_M8, VC_V_FVW }, // 545
  { PseudoVC_V_F16VW_MF2, VC_V_FVW }, // 546
  { PseudoVC_V_F16VW_MF4, VC_V_FVW }, // 547
  { PseudoVC_V_F16VW_SE_M1, VC_V_FVW }, // 548
  { PseudoVC_V_F16VW_SE_M2, VC_V_FVW }, // 549
  { PseudoVC_V_F16VW_SE_M4, VC_V_FVW }, // 550
  { PseudoVC_V_F16VW_SE_M8, VC_V_FVW }, // 551
  { PseudoVC_V_F16VW_SE_MF2, VC_V_FVW }, // 552
  { PseudoVC_V_F16VW_SE_MF4, VC_V_FVW }, // 553
  { PseudoVC_V_F16V_M1, VC_V_FV }, // 554
  { PseudoVC_V_F16V_M2, VC_V_FV }, // 555
  { PseudoVC_V_F16V_M4, VC_V_FV }, // 556
  { PseudoVC_V_F16V_M8, VC_V_FV }, // 557
  { PseudoVC_V_F16V_MF2, VC_V_FV }, // 558
  { PseudoVC_V_F16V_MF4, VC_V_FV }, // 559
  { PseudoVC_V_F16V_SE_M1, VC_V_FV }, // 560
  { PseudoVC_V_F16V_SE_M2, VC_V_FV }, // 561
  { PseudoVC_V_F16V_SE_M4, VC_V_FV }, // 562
  { PseudoVC_V_F16V_SE_M8, VC_V_FV }, // 563
  { PseudoVC_V_F16V_SE_MF2, VC_V_FV }, // 564
  { PseudoVC_V_F16V_SE_MF4, VC_V_FV }, // 565
  { PseudoVC_V_F32VV_M1, VC_V_FVV }, // 566
  { PseudoVC_V_F32VV_M2, VC_V_FVV }, // 567
  { PseudoVC_V_F32VV_M4, VC_V_FVV }, // 568
  { PseudoVC_V_F32VV_M8, VC_V_FVV }, // 569
  { PseudoVC_V_F32VV_MF2, VC_V_FVV }, // 570
  { PseudoVC_V_F32VV_SE_M1, VC_V_FVV }, // 571
  { PseudoVC_V_F32VV_SE_M2, VC_V_FVV }, // 572
  { PseudoVC_V_F32VV_SE_M4, VC_V_FVV }, // 573
  { PseudoVC_V_F32VV_SE_M8, VC_V_FVV }, // 574
  { PseudoVC_V_F32VV_SE_MF2, VC_V_FVV }, // 575
  { PseudoVC_V_F32VW_M1, VC_V_FVW }, // 576
  { PseudoVC_V_F32VW_M2, VC_V_FVW }, // 577
  { PseudoVC_V_F32VW_M4, VC_V_FVW }, // 578
  { PseudoVC_V_F32VW_M8, VC_V_FVW }, // 579
  { PseudoVC_V_F32VW_MF2, VC_V_FVW }, // 580
  { PseudoVC_V_F32VW_SE_M1, VC_V_FVW }, // 581
  { PseudoVC_V_F32VW_SE_M2, VC_V_FVW }, // 582
  { PseudoVC_V_F32VW_SE_M4, VC_V_FVW }, // 583
  { PseudoVC_V_F32VW_SE_M8, VC_V_FVW }, // 584
  { PseudoVC_V_F32VW_SE_MF2, VC_V_FVW }, // 585
  { PseudoVC_V_F32V_M1, VC_V_FV }, // 586
  { PseudoVC_V_F32V_M2, VC_V_FV }, // 587
  { PseudoVC_V_F32V_M4, VC_V_FV }, // 588
  { PseudoVC_V_F32V_M8, VC_V_FV }, // 589
  { PseudoVC_V_F32V_MF2, VC_V_FV }, // 590
  { PseudoVC_V_F32V_SE_M1, VC_V_FV }, // 591
  { PseudoVC_V_F32V_SE_M2, VC_V_FV }, // 592
  { PseudoVC_V_F32V_SE_M4, VC_V_FV }, // 593
  { PseudoVC_V_F32V_SE_M8, VC_V_FV }, // 594
  { PseudoVC_V_F32V_SE_MF2, VC_V_FV }, // 595
  { PseudoVC_V_F64VV_M1, VC_V_FVV }, // 596
  { PseudoVC_V_F64VV_M2, VC_V_FVV }, // 597
  { PseudoVC_V_F64VV_M4, VC_V_FVV }, // 598
  { PseudoVC_V_F64VV_M8, VC_V_FVV }, // 599
  { PseudoVC_V_F64VV_SE_M1, VC_V_FVV }, // 600
  { PseudoVC_V_F64VV_SE_M2, VC_V_FVV }, // 601
  { PseudoVC_V_F64VV_SE_M4, VC_V_FVV }, // 602
  { PseudoVC_V_F64VV_SE_M8, VC_V_FVV }, // 603
  { PseudoVC_V_F64V_M1, VC_V_FV }, // 604
  { PseudoVC_V_F64V_M2, VC_V_FV }, // 605
  { PseudoVC_V_F64V_M4, VC_V_FV }, // 606
  { PseudoVC_V_F64V_M8, VC_V_FV }, // 607
  { PseudoVC_V_F64V_SE_M1, VC_V_FV }, // 608
  { PseudoVC_V_F64V_SE_M2, VC_V_FV }, // 609
  { PseudoVC_V_F64V_SE_M4, VC_V_FV }, // 610
  { PseudoVC_V_F64V_SE_M8, VC_V_FV }, // 611
  { PseudoVC_V_IVV_M1, VC_V_IVV }, // 612
  { PseudoVC_V_IVV_M2, VC_V_IVV }, // 613
  { PseudoVC_V_IVV_M4, VC_V_IVV }, // 614
  { PseudoVC_V_IVV_M8, VC_V_IVV }, // 615
  { PseudoVC_V_IVV_MF2, VC_V_IVV }, // 616
  { PseudoVC_V_IVV_MF4, VC_V_IVV }, // 617
  { PseudoVC_V_IVV_MF8, VC_V_IVV }, // 618
  { PseudoVC_V_IVV_SE_M1, VC_V_IVV }, // 619
  { PseudoVC_V_IVV_SE_M2, VC_V_IVV }, // 620
  { PseudoVC_V_IVV_SE_M4, VC_V_IVV }, // 621
  { PseudoVC_V_IVV_SE_M8, VC_V_IVV }, // 622
  { PseudoVC_V_IVV_SE_MF2, VC_V_IVV }, // 623
  { PseudoVC_V_IVV_SE_MF4, VC_V_IVV }, // 624
  { PseudoVC_V_IVV_SE_MF8, VC_V_IVV }, // 625
  { PseudoVC_V_IVW_M1, VC_V_IVW }, // 626
  { PseudoVC_V_IVW_M2, VC_V_IVW }, // 627
  { PseudoVC_V_IVW_M4, VC_V_IVW }, // 628
  { PseudoVC_V_IVW_MF2, VC_V_IVW }, // 629
  { PseudoVC_V_IVW_MF4, VC_V_IVW }, // 630
  { PseudoVC_V_IVW_MF8, VC_V_IVW }, // 631
  { PseudoVC_V_IVW_SE_M1, VC_V_IVW }, // 632
  { PseudoVC_V_IVW_SE_M2, VC_V_IVW }, // 633
  { PseudoVC_V_IVW_SE_M4, VC_V_IVW }, // 634
  { PseudoVC_V_IVW_SE_MF2, VC_V_IVW }, // 635
  { PseudoVC_V_IVW_SE_MF4, VC_V_IVW }, // 636
  { PseudoVC_V_IVW_SE_MF8, VC_V_IVW }, // 637
  { PseudoVC_V_IV_M1, VC_V_IV }, // 638
  { PseudoVC_V_IV_M2, VC_V_IV }, // 639
  { PseudoVC_V_IV_M4, VC_V_IV }, // 640
  { PseudoVC_V_IV_M8, VC_V_IV }, // 641
  { PseudoVC_V_IV_MF2, VC_V_IV }, // 642
  { PseudoVC_V_IV_MF4, VC_V_IV }, // 643
  { PseudoVC_V_IV_MF8, VC_V_IV }, // 644
  { PseudoVC_V_IV_SE_M1, VC_V_IV }, // 645
  { PseudoVC_V_IV_SE_M2, VC_V_IV }, // 646
  { PseudoVC_V_IV_SE_M4, VC_V_IV }, // 647
  { PseudoVC_V_IV_SE_M8, VC_V_IV }, // 648
  { PseudoVC_V_IV_SE_MF2, VC_V_IV }, // 649
  { PseudoVC_V_IV_SE_MF4, VC_V_IV }, // 650
  { PseudoVC_V_IV_SE_MF8, VC_V_IV }, // 651
  { PseudoVC_V_I_M1, VC_V_I }, // 652
  { PseudoVC_V_I_M2, VC_V_I }, // 653
  { PseudoVC_V_I_M4, VC_V_I }, // 654
  { PseudoVC_V_I_M8, VC_V_I }, // 655
  { PseudoVC_V_I_MF2, VC_V_I }, // 656
  { PseudoVC_V_I_MF4, VC_V_I }, // 657
  { PseudoVC_V_I_MF8, VC_V_I }, // 658
  { PseudoVC_V_I_SE_M1, VC_V_I }, // 659
  { PseudoVC_V_I_SE_M2, VC_V_I }, // 660
  { PseudoVC_V_I_SE_M4, VC_V_I }, // 661
  { PseudoVC_V_I_SE_M8, VC_V_I }, // 662
  { PseudoVC_V_I_SE_MF2, VC_V_I }, // 663
  { PseudoVC_V_I_SE_MF4, VC_V_I }, // 664
  { PseudoVC_V_I_SE_MF8, VC_V_I }, // 665
  { PseudoVC_V_VVV_M1, VC_V_VVV }, // 666
  { PseudoVC_V_VVV_M2, VC_V_VVV }, // 667
  { PseudoVC_V_VVV_M4, VC_V_VVV }, // 668
  { PseudoVC_V_VVV_M8, VC_V_VVV }, // 669
  { PseudoVC_V_VVV_MF2, VC_V_VVV }, // 670
  { PseudoVC_V_VVV_MF4, VC_V_VVV }, // 671
  { PseudoVC_V_VVV_MF8, VC_V_VVV }, // 672
  { PseudoVC_V_VVV_SE_M1, VC_V_VVV }, // 673
  { PseudoVC_V_VVV_SE_M2, VC_V_VVV }, // 674
  { PseudoVC_V_VVV_SE_M4, VC_V_VVV }, // 675
  { PseudoVC_V_VVV_SE_M8, VC_V_VVV }, // 676
  { PseudoVC_V_VVV_SE_MF2, VC_V_VVV }, // 677
  { PseudoVC_V_VVV_SE_MF4, VC_V_VVV }, // 678
  { PseudoVC_V_VVV_SE_MF8, VC_V_VVV }, // 679
  { PseudoVC_V_VVW_M1, VC_V_VVW }, // 680
  { PseudoVC_V_VVW_M2, VC_V_VVW }, // 681
  { PseudoVC_V_VVW_M4, VC_V_VVW }, // 682
  { PseudoVC_V_VVW_MF2, VC_V_VVW }, // 683
  { PseudoVC_V_VVW_MF4, VC_V_VVW }, // 684
  { PseudoVC_V_VVW_MF8, VC_V_VVW }, // 685
  { PseudoVC_V_VVW_SE_M1, VC_V_VVW }, // 686
  { PseudoVC_V_VVW_SE_M2, VC_V_VVW }, // 687
  { PseudoVC_V_VVW_SE_M4, VC_V_VVW }, // 688
  { PseudoVC_V_VVW_SE_MF2, VC_V_VVW }, // 689
  { PseudoVC_V_VVW_SE_MF4, VC_V_VVW }, // 690
  { PseudoVC_V_VVW_SE_MF8, VC_V_VVW }, // 691
  { PseudoVC_V_VV_M1, VC_V_VV }, // 692
  { PseudoVC_V_VV_M2, VC_V_VV }, // 693
  { PseudoVC_V_VV_M4, VC_V_VV }, // 694
  { PseudoVC_V_VV_M8, VC_V_VV }, // 695
  { PseudoVC_V_VV_MF2, VC_V_VV }, // 696
  { PseudoVC_V_VV_MF4, VC_V_VV }, // 697
  { PseudoVC_V_VV_MF8, VC_V_VV }, // 698
  { PseudoVC_V_VV_SE_M1, VC_V_VV }, // 699
  { PseudoVC_V_VV_SE_M2, VC_V_VV }, // 700
  { PseudoVC_V_VV_SE_M4, VC_V_VV }, // 701
  { PseudoVC_V_VV_SE_M8, VC_V_VV }, // 702
  { PseudoVC_V_VV_SE_MF2, VC_V_VV }, // 703
  { PseudoVC_V_VV_SE_MF4, VC_V_VV }, // 704
  { PseudoVC_V_VV_SE_MF8, VC_V_VV }, // 705
  { PseudoVC_V_XVV_M1, VC_V_XVV }, // 706
  { PseudoVC_V_XVV_M2, VC_V_XVV }, // 707
  { PseudoVC_V_XVV_M4, VC_V_XVV }, // 708
  { PseudoVC_V_XVV_M8, VC_V_XVV }, // 709
  { PseudoVC_V_XVV_MF2, VC_V_XVV }, // 710
  { PseudoVC_V_XVV_MF4, VC_V_XVV }, // 711
  { PseudoVC_V_XVV_MF8, VC_V_XVV }, // 712
  { PseudoVC_V_XVV_SE_M1, VC_V_XVV }, // 713
  { PseudoVC_V_XVV_SE_M2, VC_V_XVV }, // 714
  { PseudoVC_V_XVV_SE_M4, VC_V_XVV }, // 715
  { PseudoVC_V_XVV_SE_M8, VC_V_XVV }, // 716
  { PseudoVC_V_XVV_SE_MF2, VC_V_XVV }, // 717
  { PseudoVC_V_XVV_SE_MF4, VC_V_XVV }, // 718
  { PseudoVC_V_XVV_SE_MF8, VC_V_XVV }, // 719
  { PseudoVC_V_XVW_M1, VC_V_XVW }, // 720
  { PseudoVC_V_XVW_M2, VC_V_XVW }, // 721
  { PseudoVC_V_XVW_M4, VC_V_XVW }, // 722
  { PseudoVC_V_XVW_MF2, VC_V_XVW }, // 723
  { PseudoVC_V_XVW_MF4, VC_V_XVW }, // 724
  { PseudoVC_V_XVW_MF8, VC_V_XVW }, // 725
  { PseudoVC_V_XVW_SE_M1, VC_V_XVW }, // 726
  { PseudoVC_V_XVW_SE_M2, VC_V_XVW }, // 727
  { PseudoVC_V_XVW_SE_M4, VC_V_XVW }, // 728
  { PseudoVC_V_XVW_SE_MF2, VC_V_XVW }, // 729
  { PseudoVC_V_XVW_SE_MF4, VC_V_XVW }, // 730
  { PseudoVC_V_XVW_SE_MF8, VC_V_XVW }, // 731
  { PseudoVC_V_XV_M1, VC_V_XV }, // 732
  { PseudoVC_V_XV_M2, VC_V_XV }, // 733
  { PseudoVC_V_XV_M4, VC_V_XV }, // 734
  { PseudoVC_V_XV_M8, VC_V_XV }, // 735
  { PseudoVC_V_XV_MF2, VC_V_XV }, // 736
  { PseudoVC_V_XV_MF4, VC_V_XV }, // 737
  { PseudoVC_V_XV_MF8, VC_V_XV }, // 738
  { PseudoVC_V_XV_SE_M1, VC_V_XV }, // 739
  { PseudoVC_V_XV_SE_M2, VC_V_XV }, // 740
  { PseudoVC_V_XV_SE_M4, VC_V_XV }, // 741
  { PseudoVC_V_XV_SE_M8, VC_V_XV }, // 742
  { PseudoVC_V_XV_SE_MF2, VC_V_XV }, // 743
  { PseudoVC_V_XV_SE_MF4, VC_V_XV }, // 744
  { PseudoVC_V_XV_SE_MF8, VC_V_XV }, // 745
  { PseudoVC_V_X_M1, VC_V_X }, // 746
  { PseudoVC_V_X_M2, VC_V_X }, // 747
  { PseudoVC_V_X_M4, VC_V_X }, // 748
  { PseudoVC_V_X_M8, VC_V_X }, // 749
  { PseudoVC_V_X_MF2, VC_V_X }, // 750
  { PseudoVC_V_X_MF4, VC_V_X }, // 751
  { PseudoVC_V_X_MF8, VC_V_X }, // 752
  { PseudoVC_V_X_SE_M1, VC_V_X }, // 753
  { PseudoVC_V_X_SE_M2, VC_V_X }, // 754
  { PseudoVC_V_X_SE_M4, VC_V_X }, // 755
  { PseudoVC_V_X_SE_M8, VC_V_X }, // 756
  { PseudoVC_V_X_SE_MF2, VC_V_X }, // 757
  { PseudoVC_V_X_SE_MF4, VC_V_X }, // 758
  { PseudoVC_V_X_SE_MF8, VC_V_X }, // 759
  { PseudoVC_XVV_SE_M1, VC_XVV }, // 760
  { PseudoVC_XVV_SE_M2, VC_XVV }, // 761
  { PseudoVC_XVV_SE_M4, VC_XVV }, // 762
  { PseudoVC_XVV_SE_M8, VC_XVV }, // 763
  { PseudoVC_XVV_SE_MF2, VC_XVV }, // 764
  { PseudoVC_XVV_SE_MF4, VC_XVV }, // 765
  { PseudoVC_XVV_SE_MF8, VC_XVV }, // 766
  { PseudoVC_XVW_SE_M1, VC_XVW }, // 767
  { PseudoVC_XVW_SE_M2, VC_XVW }, // 768
  { PseudoVC_XVW_SE_M4, VC_XVW }, // 769
  { PseudoVC_XVW_SE_MF2, VC_XVW }, // 770
  { PseudoVC_XVW_SE_MF4, VC_XVW }, // 771
  { PseudoVC_XVW_SE_MF8, VC_XVW }, // 772
  { PseudoVC_XV_SE_M1, VC_XV }, // 773
  { PseudoVC_XV_SE_M2, VC_XV }, // 774
  { PseudoVC_XV_SE_M4, VC_XV }, // 775
  { PseudoVC_XV_SE_M8, VC_XV }, // 776
  { PseudoVC_XV_SE_MF2, VC_XV }, // 777
  { PseudoVC_XV_SE_MF4, VC_XV }, // 778
  { PseudoVC_XV_SE_MF8, VC_XV }, // 779
  { PseudoVC_X_SE_M1, VC_X }, // 780
  { PseudoVC_X_SE_M2, VC_X }, // 781
  { PseudoVC_X_SE_M4, VC_X }, // 782
  { PseudoVC_X_SE_M8, VC_X }, // 783
  { PseudoVC_X_SE_MF2, VC_X }, // 784
  { PseudoVC_X_SE_MF4, VC_X }, // 785
  { PseudoVC_X_SE_MF8, VC_X }, // 786
  { PseudoVDIVU_VV_M1_E16, VDIVU_VV }, // 787
  { PseudoVDIVU_VV_M1_E16_MASK, VDIVU_VV }, // 788
  { PseudoVDIVU_VV_M1_E16_TU, VDIVU_VV }, // 789
  { PseudoVDIVU_VV_M1_E32, VDIVU_VV }, // 790
  { PseudoVDIVU_VV_M1_E32_MASK, VDIVU_VV }, // 791
  { PseudoVDIVU_VV_M1_E32_TU, VDIVU_VV }, // 792
  { PseudoVDIVU_VV_M1_E64, VDIVU_VV }, // 793
  { PseudoVDIVU_VV_M1_E64_MASK, VDIVU_VV }, // 794
  { PseudoVDIVU_VV_M1_E64_TU, VDIVU_VV }, // 795
  { PseudoVDIVU_VV_M1_E8, VDIVU_VV }, // 796
  { PseudoVDIVU_VV_M1_E8_MASK, VDIVU_VV }, // 797
  { PseudoVDIVU_VV_M1_E8_TU, VDIVU_VV }, // 798
  { PseudoVDIVU_VV_M2_E16, VDIVU_VV }, // 799
  { PseudoVDIVU_VV_M2_E16_MASK, VDIVU_VV }, // 800
  { PseudoVDIVU_VV_M2_E16_TU, VDIVU_VV }, // 801
  { PseudoVDIVU_VV_M2_E32, VDIVU_VV }, // 802
  { PseudoVDIVU_VV_M2_E32_MASK, VDIVU_VV }, // 803
  { PseudoVDIVU_VV_M2_E32_TU, VDIVU_VV }, // 804
  { PseudoVDIVU_VV_M2_E64, VDIVU_VV }, // 805
  { PseudoVDIVU_VV_M2_E64_MASK, VDIVU_VV }, // 806
  { PseudoVDIVU_VV_M2_E64_TU, VDIVU_VV }, // 807
  { PseudoVDIVU_VV_M2_E8, VDIVU_VV }, // 808
  { PseudoVDIVU_VV_M2_E8_MASK, VDIVU_VV }, // 809
  { PseudoVDIVU_VV_M2_E8_TU, VDIVU_VV }, // 810
  { PseudoVDIVU_VV_M4_E16, VDIVU_VV }, // 811
  { PseudoVDIVU_VV_M4_E16_MASK, VDIVU_VV }, // 812
  { PseudoVDIVU_VV_M4_E16_TU, VDIVU_VV }, // 813
  { PseudoVDIVU_VV_M4_E32, VDIVU_VV }, // 814
  { PseudoVDIVU_VV_M4_E32_MASK, VDIVU_VV }, // 815
  { PseudoVDIVU_VV_M4_E32_TU, VDIVU_VV }, // 816
  { PseudoVDIVU_VV_M4_E64, VDIVU_VV }, // 817
  { PseudoVDIVU_VV_M4_E64_MASK, VDIVU_VV }, // 818
  { PseudoVDIVU_VV_M4_E64_TU, VDIVU_VV }, // 819
  { PseudoVDIVU_VV_M4_E8, VDIVU_VV }, // 820
  { PseudoVDIVU_VV_M4_E8_MASK, VDIVU_VV }, // 821
  { PseudoVDIVU_VV_M4_E8_TU, VDIVU_VV }, // 822
  { PseudoVDIVU_VV_M8_E16, VDIVU_VV }, // 823
  { PseudoVDIVU_VV_M8_E16_MASK, VDIVU_VV }, // 824
  { PseudoVDIVU_VV_M8_E16_TU, VDIVU_VV }, // 825
  { PseudoVDIVU_VV_M8_E32, VDIVU_VV }, // 826
  { PseudoVDIVU_VV_M8_E32_MASK, VDIVU_VV }, // 827
  { PseudoVDIVU_VV_M8_E32_TU, VDIVU_VV }, // 828
  { PseudoVDIVU_VV_M8_E64, VDIVU_VV }, // 829
  { PseudoVDIVU_VV_M8_E64_MASK, VDIVU_VV }, // 830
  { PseudoVDIVU_VV_M8_E64_TU, VDIVU_VV }, // 831
  { PseudoVDIVU_VV_M8_E8, VDIVU_VV }, // 832
  { PseudoVDIVU_VV_M8_E8_MASK, VDIVU_VV }, // 833
  { PseudoVDIVU_VV_M8_E8_TU, VDIVU_VV }, // 834
  { PseudoVDIVU_VV_MF2_E16, VDIVU_VV }, // 835
  { PseudoVDIVU_VV_MF2_E16_MASK, VDIVU_VV }, // 836
  { PseudoVDIVU_VV_MF2_E16_TU, VDIVU_VV }, // 837
  { PseudoVDIVU_VV_MF2_E32, VDIVU_VV }, // 838
  { PseudoVDIVU_VV_MF2_E32_MASK, VDIVU_VV }, // 839
  { PseudoVDIVU_VV_MF2_E32_TU, VDIVU_VV }, // 840
  { PseudoVDIVU_VV_MF2_E8, VDIVU_VV }, // 841
  { PseudoVDIVU_VV_MF2_E8_MASK, VDIVU_VV }, // 842
  { PseudoVDIVU_VV_MF2_E8_TU, VDIVU_VV }, // 843
  { PseudoVDIVU_VV_MF4_E16, VDIVU_VV }, // 844
  { PseudoVDIVU_VV_MF4_E16_MASK, VDIVU_VV }, // 845
  { PseudoVDIVU_VV_MF4_E16_TU, VDIVU_VV }, // 846
  { PseudoVDIVU_VV_MF4_E8, VDIVU_VV }, // 847
  { PseudoVDIVU_VV_MF4_E8_MASK, VDIVU_VV }, // 848
  { PseudoVDIVU_VV_MF4_E8_TU, VDIVU_VV }, // 849
  { PseudoVDIVU_VV_MF8_E8, VDIVU_VV }, // 850
  { PseudoVDIVU_VV_MF8_E8_MASK, VDIVU_VV }, // 851
  { PseudoVDIVU_VV_MF8_E8_TU, VDIVU_VV }, // 852
  { PseudoVDIVU_VX_M1_E16, VDIVU_VX }, // 853
  { PseudoVDIVU_VX_M1_E16_MASK, VDIVU_VX }, // 854
  { PseudoVDIVU_VX_M1_E16_TU, VDIVU_VX }, // 855
  { PseudoVDIVU_VX_M1_E32, VDIVU_VX }, // 856
  { PseudoVDIVU_VX_M1_E32_MASK, VDIVU_VX }, // 857
  { PseudoVDIVU_VX_M1_E32_TU, VDIVU_VX }, // 858
  { PseudoVDIVU_VX_M1_E64, VDIVU_VX }, // 859
  { PseudoVDIVU_VX_M1_E64_MASK, VDIVU_VX }, // 860
  { PseudoVDIVU_VX_M1_E64_TU, VDIVU_VX }, // 861
  { PseudoVDIVU_VX_M1_E8, VDIVU_VX }, // 862
  { PseudoVDIVU_VX_M1_E8_MASK, VDIVU_VX }, // 863
  { PseudoVDIVU_VX_M1_E8_TU, VDIVU_VX }, // 864
  { PseudoVDIVU_VX_M2_E16, VDIVU_VX }, // 865
  { PseudoVDIVU_VX_M2_E16_MASK, VDIVU_VX }, // 866
  { PseudoVDIVU_VX_M2_E16_TU, VDIVU_VX }, // 867
  { PseudoVDIVU_VX_M2_E32, VDIVU_VX }, // 868
  { PseudoVDIVU_VX_M2_E32_MASK, VDIVU_VX }, // 869
  { PseudoVDIVU_VX_M2_E32_TU, VDIVU_VX }, // 870
  { PseudoVDIVU_VX_M2_E64, VDIVU_VX }, // 871
  { PseudoVDIVU_VX_M2_E64_MASK, VDIVU_VX }, // 872
  { PseudoVDIVU_VX_M2_E64_TU, VDIVU_VX }, // 873
  { PseudoVDIVU_VX_M2_E8, VDIVU_VX }, // 874
  { PseudoVDIVU_VX_M2_E8_MASK, VDIVU_VX }, // 875
  { PseudoVDIVU_VX_M2_E8_TU, VDIVU_VX }, // 876
  { PseudoVDIVU_VX_M4_E16, VDIVU_VX }, // 877
  { PseudoVDIVU_VX_M4_E16_MASK, VDIVU_VX }, // 878
  { PseudoVDIVU_VX_M4_E16_TU, VDIVU_VX }, // 879
  { PseudoVDIVU_VX_M4_E32, VDIVU_VX }, // 880
  { PseudoVDIVU_VX_M4_E32_MASK, VDIVU_VX }, // 881
  { PseudoVDIVU_VX_M4_E32_TU, VDIVU_VX }, // 882
  { PseudoVDIVU_VX_M4_E64, VDIVU_VX }, // 883
  { PseudoVDIVU_VX_M4_E64_MASK, VDIVU_VX }, // 884
  { PseudoVDIVU_VX_M4_E64_TU, VDIVU_VX }, // 885
  { PseudoVDIVU_VX_M4_E8, VDIVU_VX }, // 886
  { PseudoVDIVU_VX_M4_E8_MASK, VDIVU_VX }, // 887
  { PseudoVDIVU_VX_M4_E8_TU, VDIVU_VX }, // 888
  { PseudoVDIVU_VX_M8_E16, VDIVU_VX }, // 889
  { PseudoVDIVU_VX_M8_E16_MASK, VDIVU_VX }, // 890
  { PseudoVDIVU_VX_M8_E16_TU, VDIVU_VX }, // 891
  { PseudoVDIVU_VX_M8_E32, VDIVU_VX }, // 892
  { PseudoVDIVU_VX_M8_E32_MASK, VDIVU_VX }, // 893
  { PseudoVDIVU_VX_M8_E32_TU, VDIVU_VX }, // 894
  { PseudoVDIVU_VX_M8_E64, VDIVU_VX }, // 895
  { PseudoVDIVU_VX_M8_E64_MASK, VDIVU_VX }, // 896
  { PseudoVDIVU_VX_M8_E64_TU, VDIVU_VX }, // 897
  { PseudoVDIVU_VX_M8_E8, VDIVU_VX }, // 898
  { PseudoVDIVU_VX_M8_E8_MASK, VDIVU_VX }, // 899
  { PseudoVDIVU_VX_M8_E8_TU, VDIVU_VX }, // 900
  { PseudoVDIVU_VX_MF2_E16, VDIVU_VX }, // 901
  { PseudoVDIVU_VX_MF2_E16_MASK, VDIVU_VX }, // 902
  { PseudoVDIVU_VX_MF2_E16_TU, VDIVU_VX }, // 903
  { PseudoVDIVU_VX_MF2_E32, VDIVU_VX }, // 904
  { PseudoVDIVU_VX_MF2_E32_MASK, VDIVU_VX }, // 905
  { PseudoVDIVU_VX_MF2_E32_TU, VDIVU_VX }, // 906
  { PseudoVDIVU_VX_MF2_E8, VDIVU_VX }, // 907
  { PseudoVDIVU_VX_MF2_E8_MASK, VDIVU_VX }, // 908
  { PseudoVDIVU_VX_MF2_E8_TU, VDIVU_VX }, // 909
  { PseudoVDIVU_VX_MF4_E16, VDIVU_VX }, // 910
  { PseudoVDIVU_VX_MF4_E16_MASK, VDIVU_VX }, // 911
  { PseudoVDIVU_VX_MF4_E16_TU, VDIVU_VX }, // 912
  { PseudoVDIVU_VX_MF4_E8, VDIVU_VX }, // 913
  { PseudoVDIVU_VX_MF4_E8_MASK, VDIVU_VX }, // 914
  { PseudoVDIVU_VX_MF4_E8_TU, VDIVU_VX }, // 915
  { PseudoVDIVU_VX_MF8_E8, VDIVU_VX }, // 916
  { PseudoVDIVU_VX_MF8_E8_MASK, VDIVU_VX }, // 917
  { PseudoVDIVU_VX_MF8_E8_TU, VDIVU_VX }, // 918
  { PseudoVDIV_VV_M1_E16, VDIV_VV }, // 919
  { PseudoVDIV_VV_M1_E16_MASK, VDIV_VV }, // 920
  { PseudoVDIV_VV_M1_E16_TU, VDIV_VV }, // 921
  { PseudoVDIV_VV_M1_E32, VDIV_VV }, // 922
  { PseudoVDIV_VV_M1_E32_MASK, VDIV_VV }, // 923
  { PseudoVDIV_VV_M1_E32_TU, VDIV_VV }, // 924
  { PseudoVDIV_VV_M1_E64, VDIV_VV }, // 925
  { PseudoVDIV_VV_M1_E64_MASK, VDIV_VV }, // 926
  { PseudoVDIV_VV_M1_E64_TU, VDIV_VV }, // 927
  { PseudoVDIV_VV_M1_E8, VDIV_VV }, // 928
  { PseudoVDIV_VV_M1_E8_MASK, VDIV_VV }, // 929
  { PseudoVDIV_VV_M1_E8_TU, VDIV_VV }, // 930
  { PseudoVDIV_VV_M2_E16, VDIV_VV }, // 931
  { PseudoVDIV_VV_M2_E16_MASK, VDIV_VV }, // 932
  { PseudoVDIV_VV_M2_E16_TU, VDIV_VV }, // 933
  { PseudoVDIV_VV_M2_E32, VDIV_VV }, // 934
  { PseudoVDIV_VV_M2_E32_MASK, VDIV_VV }, // 935
  { PseudoVDIV_VV_M2_E32_TU, VDIV_VV }, // 936
  { PseudoVDIV_VV_M2_E64, VDIV_VV }, // 937
  { PseudoVDIV_VV_M2_E64_MASK, VDIV_VV }, // 938
  { PseudoVDIV_VV_M2_E64_TU, VDIV_VV }, // 939
  { PseudoVDIV_VV_M2_E8, VDIV_VV }, // 940
  { PseudoVDIV_VV_M2_E8_MASK, VDIV_VV }, // 941
  { PseudoVDIV_VV_M2_E8_TU, VDIV_VV }, // 942
  { PseudoVDIV_VV_M4_E16, VDIV_VV }, // 943
  { PseudoVDIV_VV_M4_E16_MASK, VDIV_VV }, // 944
  { PseudoVDIV_VV_M4_E16_TU, VDIV_VV }, // 945
  { PseudoVDIV_VV_M4_E32, VDIV_VV }, // 946
  { PseudoVDIV_VV_M4_E32_MASK, VDIV_VV }, // 947
  { PseudoVDIV_VV_M4_E32_TU, VDIV_VV }, // 948
  { PseudoVDIV_VV_M4_E64, VDIV_VV }, // 949
  { PseudoVDIV_VV_M4_E64_MASK, VDIV_VV }, // 950
  { PseudoVDIV_VV_M4_E64_TU, VDIV_VV }, // 951
  { PseudoVDIV_VV_M4_E8, VDIV_VV }, // 952
  { PseudoVDIV_VV_M4_E8_MASK, VDIV_VV }, // 953
  { PseudoVDIV_VV_M4_E8_TU, VDIV_VV }, // 954
  { PseudoVDIV_VV_M8_E16, VDIV_VV }, // 955
  { PseudoVDIV_VV_M8_E16_MASK, VDIV_VV }, // 956
  { PseudoVDIV_VV_M8_E16_TU, VDIV_VV }, // 957
  { PseudoVDIV_VV_M8_E32, VDIV_VV }, // 958
  { PseudoVDIV_VV_M8_E32_MASK, VDIV_VV }, // 959
  { PseudoVDIV_VV_M8_E32_TU, VDIV_VV }, // 960
  { PseudoVDIV_VV_M8_E64, VDIV_VV }, // 961
  { PseudoVDIV_VV_M8_E64_MASK, VDIV_VV }, // 962
  { PseudoVDIV_VV_M8_E64_TU, VDIV_VV }, // 963
  { PseudoVDIV_VV_M8_E8, VDIV_VV }, // 964
  { PseudoVDIV_VV_M8_E8_MASK, VDIV_VV }, // 965
  { PseudoVDIV_VV_M8_E8_TU, VDIV_VV }, // 966
  { PseudoVDIV_VV_MF2_E16, VDIV_VV }, // 967
  { PseudoVDIV_VV_MF2_E16_MASK, VDIV_VV }, // 968
  { PseudoVDIV_VV_MF2_E16_TU, VDIV_VV }, // 969
  { PseudoVDIV_VV_MF2_E32, VDIV_VV }, // 970
  { PseudoVDIV_VV_MF2_E32_MASK, VDIV_VV }, // 971
  { PseudoVDIV_VV_MF2_E32_TU, VDIV_VV }, // 972
  { PseudoVDIV_VV_MF2_E8, VDIV_VV }, // 973
  { PseudoVDIV_VV_MF2_E8_MASK, VDIV_VV }, // 974
  { PseudoVDIV_VV_MF2_E8_TU, VDIV_VV }, // 975
  { PseudoVDIV_VV_MF4_E16, VDIV_VV }, // 976
  { PseudoVDIV_VV_MF4_E16_MASK, VDIV_VV }, // 977
  { PseudoVDIV_VV_MF4_E16_TU, VDIV_VV }, // 978
  { PseudoVDIV_VV_MF4_E8, VDIV_VV }, // 979
  { PseudoVDIV_VV_MF4_E8_MASK, VDIV_VV }, // 980
  { PseudoVDIV_VV_MF4_E8_TU, VDIV_VV }, // 981
  { PseudoVDIV_VV_MF8_E8, VDIV_VV }, // 982
  { PseudoVDIV_VV_MF8_E8_MASK, VDIV_VV }, // 983
  { PseudoVDIV_VV_MF8_E8_TU, VDIV_VV }, // 984
  { PseudoVDIV_VX_M1_E16, VDIV_VX }, // 985
  { PseudoVDIV_VX_M1_E16_MASK, VDIV_VX }, // 986
  { PseudoVDIV_VX_M1_E16_TU, VDIV_VX }, // 987
  { PseudoVDIV_VX_M1_E32, VDIV_VX }, // 988
  { PseudoVDIV_VX_M1_E32_MASK, VDIV_VX }, // 989
  { PseudoVDIV_VX_M1_E32_TU, VDIV_VX }, // 990
  { PseudoVDIV_VX_M1_E64, VDIV_VX }, // 991
  { PseudoVDIV_VX_M1_E64_MASK, VDIV_VX }, // 992
  { PseudoVDIV_VX_M1_E64_TU, VDIV_VX }, // 993
  { PseudoVDIV_VX_M1_E8, VDIV_VX }, // 994
  { PseudoVDIV_VX_M1_E8_MASK, VDIV_VX }, // 995
  { PseudoVDIV_VX_M1_E8_TU, VDIV_VX }, // 996
  { PseudoVDIV_VX_M2_E16, VDIV_VX }, // 997
  { PseudoVDIV_VX_M2_E16_MASK, VDIV_VX }, // 998
  { PseudoVDIV_VX_M2_E16_TU, VDIV_VX }, // 999
  { PseudoVDIV_VX_M2_E32, VDIV_VX }, // 1000
  { PseudoVDIV_VX_M2_E32_MASK, VDIV_VX }, // 1001
  { PseudoVDIV_VX_M2_E32_TU, VDIV_VX }, // 1002
  { PseudoVDIV_VX_M2_E64, VDIV_VX }, // 1003
  { PseudoVDIV_VX_M2_E64_MASK, VDIV_VX }, // 1004
  { PseudoVDIV_VX_M2_E64_TU, VDIV_VX }, // 1005
  { PseudoVDIV_VX_M2_E8, VDIV_VX }, // 1006
  { PseudoVDIV_VX_M2_E8_MASK, VDIV_VX }, // 1007
  { PseudoVDIV_VX_M2_E8_TU, VDIV_VX }, // 1008
  { PseudoVDIV_VX_M4_E16, VDIV_VX }, // 1009
  { PseudoVDIV_VX_M4_E16_MASK, VDIV_VX }, // 1010
  { PseudoVDIV_VX_M4_E16_TU, VDIV_VX }, // 1011
  { PseudoVDIV_VX_M4_E32, VDIV_VX }, // 1012
  { PseudoVDIV_VX_M4_E32_MASK, VDIV_VX }, // 1013
  { PseudoVDIV_VX_M4_E32_TU, VDIV_VX }, // 1014
  { PseudoVDIV_VX_M4_E64, VDIV_VX }, // 1015
  { PseudoVDIV_VX_M4_E64_MASK, VDIV_VX }, // 1016
  { PseudoVDIV_VX_M4_E64_TU, VDIV_VX }, // 1017
  { PseudoVDIV_VX_M4_E8, VDIV_VX }, // 1018
  { PseudoVDIV_VX_M4_E8_MASK, VDIV_VX }, // 1019
  { PseudoVDIV_VX_M4_E8_TU, VDIV_VX }, // 1020
  { PseudoVDIV_VX_M8_E16, VDIV_VX }, // 1021
  { PseudoVDIV_VX_M8_E16_MASK, VDIV_VX }, // 1022
  { PseudoVDIV_VX_M8_E16_TU, VDIV_VX }, // 1023
  { PseudoVDIV_VX_M8_E32, VDIV_VX }, // 1024
  { PseudoVDIV_VX_M8_E32_MASK, VDIV_VX }, // 1025
  { PseudoVDIV_VX_M8_E32_TU, VDIV_VX }, // 1026
  { PseudoVDIV_VX_M8_E64, VDIV_VX }, // 1027
  { PseudoVDIV_VX_M8_E64_MASK, VDIV_VX }, // 1028
  { PseudoVDIV_VX_M8_E64_TU, VDIV_VX }, // 1029
  { PseudoVDIV_VX_M8_E8, VDIV_VX }, // 1030
  { PseudoVDIV_VX_M8_E8_MASK, VDIV_VX }, // 1031
  { PseudoVDIV_VX_M8_E8_TU, VDIV_VX }, // 1032
  { PseudoVDIV_VX_MF2_E16, VDIV_VX }, // 1033
  { PseudoVDIV_VX_MF2_E16_MASK, VDIV_VX }, // 1034
  { PseudoVDIV_VX_MF2_E16_TU, VDIV_VX }, // 1035
  { PseudoVDIV_VX_MF2_E32, VDIV_VX }, // 1036
  { PseudoVDIV_VX_MF2_E32_MASK, VDIV_VX }, // 1037
  { PseudoVDIV_VX_MF2_E32_TU, VDIV_VX }, // 1038
  { PseudoVDIV_VX_MF2_E8, VDIV_VX }, // 1039
  { PseudoVDIV_VX_MF2_E8_MASK, VDIV_VX }, // 1040
  { PseudoVDIV_VX_MF2_E8_TU, VDIV_VX }, // 1041
  { PseudoVDIV_VX_MF4_E16, VDIV_VX }, // 1042
  { PseudoVDIV_VX_MF4_E16_MASK, VDIV_VX }, // 1043
  { PseudoVDIV_VX_MF4_E16_TU, VDIV_VX }, // 1044
  { PseudoVDIV_VX_MF4_E8, VDIV_VX }, // 1045
  { PseudoVDIV_VX_MF4_E8_MASK, VDIV_VX }, // 1046
  { PseudoVDIV_VX_MF4_E8_TU, VDIV_VX }, // 1047
  { PseudoVDIV_VX_MF8_E8, VDIV_VX }, // 1048
  { PseudoVDIV_VX_MF8_E8_MASK, VDIV_VX }, // 1049
  { PseudoVDIV_VX_MF8_E8_TU, VDIV_VX }, // 1050
  { PseudoVFADD_VF16_M1, VFADD_VF }, // 1051
  { PseudoVFADD_VF16_M1_MASK, VFADD_VF }, // 1052
  { PseudoVFADD_VF16_M1_TU, VFADD_VF }, // 1053
  { PseudoVFADD_VF16_M2, VFADD_VF }, // 1054
  { PseudoVFADD_VF16_M2_MASK, VFADD_VF }, // 1055
  { PseudoVFADD_VF16_M2_TU, VFADD_VF }, // 1056
  { PseudoVFADD_VF16_M4, VFADD_VF }, // 1057
  { PseudoVFADD_VF16_M4_MASK, VFADD_VF }, // 1058
  { PseudoVFADD_VF16_M4_TU, VFADD_VF }, // 1059
  { PseudoVFADD_VF16_M8, VFADD_VF }, // 1060
  { PseudoVFADD_VF16_M8_MASK, VFADD_VF }, // 1061
  { PseudoVFADD_VF16_M8_TU, VFADD_VF }, // 1062
  { PseudoVFADD_VF16_MF2, VFADD_VF }, // 1063
  { PseudoVFADD_VF16_MF2_MASK, VFADD_VF }, // 1064
  { PseudoVFADD_VF16_MF2_TU, VFADD_VF }, // 1065
  { PseudoVFADD_VF16_MF4, VFADD_VF }, // 1066
  { PseudoVFADD_VF16_MF4_MASK, VFADD_VF }, // 1067
  { PseudoVFADD_VF16_MF4_TU, VFADD_VF }, // 1068
  { PseudoVFADD_VF32_M1, VFADD_VF }, // 1069
  { PseudoVFADD_VF32_M1_MASK, VFADD_VF }, // 1070
  { PseudoVFADD_VF32_M1_TU, VFADD_VF }, // 1071
  { PseudoVFADD_VF32_M2, VFADD_VF }, // 1072
  { PseudoVFADD_VF32_M2_MASK, VFADD_VF }, // 1073
  { PseudoVFADD_VF32_M2_TU, VFADD_VF }, // 1074
  { PseudoVFADD_VF32_M4, VFADD_VF }, // 1075
  { PseudoVFADD_VF32_M4_MASK, VFADD_VF }, // 1076
  { PseudoVFADD_VF32_M4_TU, VFADD_VF }, // 1077
  { PseudoVFADD_VF32_M8, VFADD_VF }, // 1078
  { PseudoVFADD_VF32_M8_MASK, VFADD_VF }, // 1079
  { PseudoVFADD_VF32_M8_TU, VFADD_VF }, // 1080
  { PseudoVFADD_VF32_MF2, VFADD_VF }, // 1081
  { PseudoVFADD_VF32_MF2_MASK, VFADD_VF }, // 1082
  { PseudoVFADD_VF32_MF2_TU, VFADD_VF }, // 1083
  { PseudoVFADD_VF64_M1, VFADD_VF }, // 1084
  { PseudoVFADD_VF64_M1_MASK, VFADD_VF }, // 1085
  { PseudoVFADD_VF64_M1_TU, VFADD_VF }, // 1086
  { PseudoVFADD_VF64_M2, VFADD_VF }, // 1087
  { PseudoVFADD_VF64_M2_MASK, VFADD_VF }, // 1088
  { PseudoVFADD_VF64_M2_TU, VFADD_VF }, // 1089
  { PseudoVFADD_VF64_M4, VFADD_VF }, // 1090
  { PseudoVFADD_VF64_M4_MASK, VFADD_VF }, // 1091
  { PseudoVFADD_VF64_M4_TU, VFADD_VF }, // 1092
  { PseudoVFADD_VF64_M8, VFADD_VF }, // 1093
  { PseudoVFADD_VF64_M8_MASK, VFADD_VF }, // 1094
  { PseudoVFADD_VF64_M8_TU, VFADD_VF }, // 1095
  { PseudoVFADD_VV_M1, VFADD_VV }, // 1096
  { PseudoVFADD_VV_M1_MASK, VFADD_VV }, // 1097
  { PseudoVFADD_VV_M1_TU, VFADD_VV }, // 1098
  { PseudoVFADD_VV_M2, VFADD_VV }, // 1099
  { PseudoVFADD_VV_M2_MASK, VFADD_VV }, // 1100
  { PseudoVFADD_VV_M2_TU, VFADD_VV }, // 1101
  { PseudoVFADD_VV_M4, VFADD_VV }, // 1102
  { PseudoVFADD_VV_M4_MASK, VFADD_VV }, // 1103
  { PseudoVFADD_VV_M4_TU, VFADD_VV }, // 1104
  { PseudoVFADD_VV_M8, VFADD_VV }, // 1105
  { PseudoVFADD_VV_M8_MASK, VFADD_VV }, // 1106
  { PseudoVFADD_VV_M8_TU, VFADD_VV }, // 1107
  { PseudoVFADD_VV_MF2, VFADD_VV }, // 1108
  { PseudoVFADD_VV_MF2_MASK, VFADD_VV }, // 1109
  { PseudoVFADD_VV_MF2_TU, VFADD_VV }, // 1110
  { PseudoVFADD_VV_MF4, VFADD_VV }, // 1111
  { PseudoVFADD_VV_MF4_MASK, VFADD_VV }, // 1112
  { PseudoVFADD_VV_MF4_TU, VFADD_VV }, // 1113
  { PseudoVFCLASS_V_M1, VFCLASS_V }, // 1114
  { PseudoVFCLASS_V_M1_MASK, VFCLASS_V }, // 1115
  { PseudoVFCLASS_V_M1_TU, VFCLASS_V }, // 1116
  { PseudoVFCLASS_V_M2, VFCLASS_V }, // 1117
  { PseudoVFCLASS_V_M2_MASK, VFCLASS_V }, // 1118
  { PseudoVFCLASS_V_M2_TU, VFCLASS_V }, // 1119
  { PseudoVFCLASS_V_M4, VFCLASS_V }, // 1120
  { PseudoVFCLASS_V_M4_MASK, VFCLASS_V }, // 1121
  { PseudoVFCLASS_V_M4_TU, VFCLASS_V }, // 1122
  { PseudoVFCLASS_V_M8, VFCLASS_V }, // 1123
  { PseudoVFCLASS_V_M8_MASK, VFCLASS_V }, // 1124
  { PseudoVFCLASS_V_M8_TU, VFCLASS_V }, // 1125
  { PseudoVFCLASS_V_MF2, VFCLASS_V }, // 1126
  { PseudoVFCLASS_V_MF2_MASK, VFCLASS_V }, // 1127
  { PseudoVFCLASS_V_MF2_TU, VFCLASS_V }, // 1128
  { PseudoVFCLASS_V_MF4, VFCLASS_V }, // 1129
  { PseudoVFCLASS_V_MF4_MASK, VFCLASS_V }, // 1130
  { PseudoVFCLASS_V_MF4_TU, VFCLASS_V }, // 1131
  { PseudoVFCVT_F_XU_V_M1, VFCVT_F_XU_V }, // 1132
  { PseudoVFCVT_F_XU_V_M1_MASK, VFCVT_F_XU_V }, // 1133
  { PseudoVFCVT_F_XU_V_M1_TU, VFCVT_F_XU_V }, // 1134
  { PseudoVFCVT_F_XU_V_M2, VFCVT_F_XU_V }, // 1135
  { PseudoVFCVT_F_XU_V_M2_MASK, VFCVT_F_XU_V }, // 1136
  { PseudoVFCVT_F_XU_V_M2_TU, VFCVT_F_XU_V }, // 1137
  { PseudoVFCVT_F_XU_V_M4, VFCVT_F_XU_V }, // 1138
  { PseudoVFCVT_F_XU_V_M4_MASK, VFCVT_F_XU_V }, // 1139
  { PseudoVFCVT_F_XU_V_M4_TU, VFCVT_F_XU_V }, // 1140
  { PseudoVFCVT_F_XU_V_M8, VFCVT_F_XU_V }, // 1141
  { PseudoVFCVT_F_XU_V_M8_MASK, VFCVT_F_XU_V }, // 1142
  { PseudoVFCVT_F_XU_V_M8_TU, VFCVT_F_XU_V }, // 1143
  { PseudoVFCVT_F_XU_V_MF2, VFCVT_F_XU_V }, // 1144
  { PseudoVFCVT_F_XU_V_MF2_MASK, VFCVT_F_XU_V }, // 1145
  { PseudoVFCVT_F_XU_V_MF2_TU, VFCVT_F_XU_V }, // 1146
  { PseudoVFCVT_F_XU_V_MF4, VFCVT_F_XU_V }, // 1147
  { PseudoVFCVT_F_XU_V_MF4_MASK, VFCVT_F_XU_V }, // 1148
  { PseudoVFCVT_F_XU_V_MF4_TU, VFCVT_F_XU_V }, // 1149
  { PseudoVFCVT_F_X_V_M1, VFCVT_F_X_V }, // 1150
  { PseudoVFCVT_F_X_V_M1_MASK, VFCVT_F_X_V }, // 1151
  { PseudoVFCVT_F_X_V_M1_TU, VFCVT_F_X_V }, // 1152
  { PseudoVFCVT_F_X_V_M2, VFCVT_F_X_V }, // 1153
  { PseudoVFCVT_F_X_V_M2_MASK, VFCVT_F_X_V }, // 1154
  { PseudoVFCVT_F_X_V_M2_TU, VFCVT_F_X_V }, // 1155
  { PseudoVFCVT_F_X_V_M4, VFCVT_F_X_V }, // 1156
  { PseudoVFCVT_F_X_V_M4_MASK, VFCVT_F_X_V }, // 1157
  { PseudoVFCVT_F_X_V_M4_TU, VFCVT_F_X_V }, // 1158
  { PseudoVFCVT_F_X_V_M8, VFCVT_F_X_V }, // 1159
  { PseudoVFCVT_F_X_V_M8_MASK, VFCVT_F_X_V }, // 1160
  { PseudoVFCVT_F_X_V_M8_TU, VFCVT_F_X_V }, // 1161
  { PseudoVFCVT_F_X_V_MF2, VFCVT_F_X_V }, // 1162
  { PseudoVFCVT_F_X_V_MF2_MASK, VFCVT_F_X_V }, // 1163
  { PseudoVFCVT_F_X_V_MF2_TU, VFCVT_F_X_V }, // 1164
  { PseudoVFCVT_F_X_V_MF4, VFCVT_F_X_V }, // 1165
  { PseudoVFCVT_F_X_V_MF4_MASK, VFCVT_F_X_V }, // 1166
  { PseudoVFCVT_F_X_V_MF4_TU, VFCVT_F_X_V }, // 1167
  { PseudoVFCVT_RTZ_XU_F_V_M1, VFCVT_RTZ_XU_F_V }, // 1168
  { PseudoVFCVT_RTZ_XU_F_V_M1_MASK, VFCVT_RTZ_XU_F_V }, // 1169
  { PseudoVFCVT_RTZ_XU_F_V_M1_TU, VFCVT_RTZ_XU_F_V }, // 1170
  { PseudoVFCVT_RTZ_XU_F_V_M2, VFCVT_RTZ_XU_F_V }, // 1171
  { PseudoVFCVT_RTZ_XU_F_V_M2_MASK, VFCVT_RTZ_XU_F_V }, // 1172
  { PseudoVFCVT_RTZ_XU_F_V_M2_TU, VFCVT_RTZ_XU_F_V }, // 1173
  { PseudoVFCVT_RTZ_XU_F_V_M4, VFCVT_RTZ_XU_F_V }, // 1174
  { PseudoVFCVT_RTZ_XU_F_V_M4_MASK, VFCVT_RTZ_XU_F_V }, // 1175
  { PseudoVFCVT_RTZ_XU_F_V_M4_TU, VFCVT_RTZ_XU_F_V }, // 1176
  { PseudoVFCVT_RTZ_XU_F_V_M8, VFCVT_RTZ_XU_F_V }, // 1177
  { PseudoVFCVT_RTZ_XU_F_V_M8_MASK, VFCVT_RTZ_XU_F_V }, // 1178
  { PseudoVFCVT_RTZ_XU_F_V_M8_TU, VFCVT_RTZ_XU_F_V }, // 1179
  { PseudoVFCVT_RTZ_XU_F_V_MF2, VFCVT_RTZ_XU_F_V }, // 1180
  { PseudoVFCVT_RTZ_XU_F_V_MF2_MASK, VFCVT_RTZ_XU_F_V }, // 1181
  { PseudoVFCVT_RTZ_XU_F_V_MF2_TU, VFCVT_RTZ_XU_F_V }, // 1182
  { PseudoVFCVT_RTZ_XU_F_V_MF4, VFCVT_RTZ_XU_F_V }, // 1183
  { PseudoVFCVT_RTZ_XU_F_V_MF4_MASK, VFCVT_RTZ_XU_F_V }, // 1184
  { PseudoVFCVT_RTZ_XU_F_V_MF4_TU, VFCVT_RTZ_XU_F_V }, // 1185
  { PseudoVFCVT_RTZ_X_F_V_M1, VFCVT_RTZ_X_F_V }, // 1186
  { PseudoVFCVT_RTZ_X_F_V_M1_MASK, VFCVT_RTZ_X_F_V }, // 1187
  { PseudoVFCVT_RTZ_X_F_V_M1_TU, VFCVT_RTZ_X_F_V }, // 1188
  { PseudoVFCVT_RTZ_X_F_V_M2, VFCVT_RTZ_X_F_V }, // 1189
  { PseudoVFCVT_RTZ_X_F_V_M2_MASK, VFCVT_RTZ_X_F_V }, // 1190
  { PseudoVFCVT_RTZ_X_F_V_M2_TU, VFCVT_RTZ_X_F_V }, // 1191
  { PseudoVFCVT_RTZ_X_F_V_M4, VFCVT_RTZ_X_F_V }, // 1192
  { PseudoVFCVT_RTZ_X_F_V_M4_MASK, VFCVT_RTZ_X_F_V }, // 1193
  { PseudoVFCVT_RTZ_X_F_V_M4_TU, VFCVT_RTZ_X_F_V }, // 1194
  { PseudoVFCVT_RTZ_X_F_V_M8, VFCVT_RTZ_X_F_V }, // 1195
  { PseudoVFCVT_RTZ_X_F_V_M8_MASK, VFCVT_RTZ_X_F_V }, // 1196
  { PseudoVFCVT_RTZ_X_F_V_M8_TU, VFCVT_RTZ_X_F_V }, // 1197
  { PseudoVFCVT_RTZ_X_F_V_MF2, VFCVT_RTZ_X_F_V }, // 1198
  { PseudoVFCVT_RTZ_X_F_V_MF2_MASK, VFCVT_RTZ_X_F_V }, // 1199
  { PseudoVFCVT_RTZ_X_F_V_MF2_TU, VFCVT_RTZ_X_F_V }, // 1200
  { PseudoVFCVT_RTZ_X_F_V_MF4, VFCVT_RTZ_X_F_V }, // 1201
  { PseudoVFCVT_RTZ_X_F_V_MF4_MASK, VFCVT_RTZ_X_F_V }, // 1202
  { PseudoVFCVT_RTZ_X_F_V_MF4_TU, VFCVT_RTZ_X_F_V }, // 1203
  { PseudoVFCVT_XU_F_V_M1, VFCVT_XU_F_V }, // 1204
  { PseudoVFCVT_XU_F_V_M1_MASK, VFCVT_XU_F_V }, // 1205
  { PseudoVFCVT_XU_F_V_M1_TU, VFCVT_XU_F_V }, // 1206
  { PseudoVFCVT_XU_F_V_M2, VFCVT_XU_F_V }, // 1207
  { PseudoVFCVT_XU_F_V_M2_MASK, VFCVT_XU_F_V }, // 1208
  { PseudoVFCVT_XU_F_V_M2_TU, VFCVT_XU_F_V }, // 1209
  { PseudoVFCVT_XU_F_V_M4, VFCVT_XU_F_V }, // 1210
  { PseudoVFCVT_XU_F_V_M4_MASK, VFCVT_XU_F_V }, // 1211
  { PseudoVFCVT_XU_F_V_M4_TU, VFCVT_XU_F_V }, // 1212
  { PseudoVFCVT_XU_F_V_M8, VFCVT_XU_F_V }, // 1213
  { PseudoVFCVT_XU_F_V_M8_MASK, VFCVT_XU_F_V }, // 1214
  { PseudoVFCVT_XU_F_V_M8_TU, VFCVT_XU_F_V }, // 1215
  { PseudoVFCVT_XU_F_V_MF2, VFCVT_XU_F_V }, // 1216
  { PseudoVFCVT_XU_F_V_MF2_MASK, VFCVT_XU_F_V }, // 1217
  { PseudoVFCVT_XU_F_V_MF2_TU, VFCVT_XU_F_V }, // 1218
  { PseudoVFCVT_XU_F_V_MF4, VFCVT_XU_F_V }, // 1219
  { PseudoVFCVT_XU_F_V_MF4_MASK, VFCVT_XU_F_V }, // 1220
  { PseudoVFCVT_XU_F_V_MF4_TU, VFCVT_XU_F_V }, // 1221
  { PseudoVFCVT_X_F_V_M1, VFCVT_X_F_V }, // 1222
  { PseudoVFCVT_X_F_V_M1_MASK, VFCVT_X_F_V }, // 1223
  { PseudoVFCVT_X_F_V_M1_TU, VFCVT_X_F_V }, // 1224
  { PseudoVFCVT_X_F_V_M2, VFCVT_X_F_V }, // 1225
  { PseudoVFCVT_X_F_V_M2_MASK, VFCVT_X_F_V }, // 1226
  { PseudoVFCVT_X_F_V_M2_TU, VFCVT_X_F_V }, // 1227
  { PseudoVFCVT_X_F_V_M4, VFCVT_X_F_V }, // 1228
  { PseudoVFCVT_X_F_V_M4_MASK, VFCVT_X_F_V }, // 1229
  { PseudoVFCVT_X_F_V_M4_TU, VFCVT_X_F_V }, // 1230
  { PseudoVFCVT_X_F_V_M8, VFCVT_X_F_V }, // 1231
  { PseudoVFCVT_X_F_V_M8_MASK, VFCVT_X_F_V }, // 1232
  { PseudoVFCVT_X_F_V_M8_TU, VFCVT_X_F_V }, // 1233
  { PseudoVFCVT_X_F_V_MF2, VFCVT_X_F_V }, // 1234
  { PseudoVFCVT_X_F_V_MF2_MASK, VFCVT_X_F_V }, // 1235
  { PseudoVFCVT_X_F_V_MF2_TU, VFCVT_X_F_V }, // 1236
  { PseudoVFCVT_X_F_V_MF4, VFCVT_X_F_V }, // 1237
  { PseudoVFCVT_X_F_V_MF4_MASK, VFCVT_X_F_V }, // 1238
  { PseudoVFCVT_X_F_V_MF4_TU, VFCVT_X_F_V }, // 1239
  { PseudoVFDIV_VF16_M1_E16, VFDIV_VF }, // 1240
  { PseudoVFDIV_VF16_M1_E16_MASK, VFDIV_VF }, // 1241
  { PseudoVFDIV_VF16_M1_E16_TU, VFDIV_VF }, // 1242
  { PseudoVFDIV_VF16_M1_E32, VFDIV_VF }, // 1243
  { PseudoVFDIV_VF16_M1_E32_MASK, VFDIV_VF }, // 1244
  { PseudoVFDIV_VF16_M1_E32_TU, VFDIV_VF }, // 1245
  { PseudoVFDIV_VF16_M1_E64, VFDIV_VF }, // 1246
  { PseudoVFDIV_VF16_M1_E64_MASK, VFDIV_VF }, // 1247
  { PseudoVFDIV_VF16_M1_E64_TU, VFDIV_VF }, // 1248
  { PseudoVFDIV_VF16_M2_E16, VFDIV_VF }, // 1249
  { PseudoVFDIV_VF16_M2_E16_MASK, VFDIV_VF }, // 1250
  { PseudoVFDIV_VF16_M2_E16_TU, VFDIV_VF }, // 1251
  { PseudoVFDIV_VF16_M2_E32, VFDIV_VF }, // 1252
  { PseudoVFDIV_VF16_M2_E32_MASK, VFDIV_VF }, // 1253
  { PseudoVFDIV_VF16_M2_E32_TU, VFDIV_VF }, // 1254
  { PseudoVFDIV_VF16_M2_E64, VFDIV_VF }, // 1255
  { PseudoVFDIV_VF16_M2_E64_MASK, VFDIV_VF }, // 1256
  { PseudoVFDIV_VF16_M2_E64_TU, VFDIV_VF }, // 1257
  { PseudoVFDIV_VF16_M4_E16, VFDIV_VF }, // 1258
  { PseudoVFDIV_VF16_M4_E16_MASK, VFDIV_VF }, // 1259
  { PseudoVFDIV_VF16_M4_E16_TU, VFDIV_VF }, // 1260
  { PseudoVFDIV_VF16_M4_E32, VFDIV_VF }, // 1261
  { PseudoVFDIV_VF16_M4_E32_MASK, VFDIV_VF }, // 1262
  { PseudoVFDIV_VF16_M4_E32_TU, VFDIV_VF }, // 1263
  { PseudoVFDIV_VF16_M4_E64, VFDIV_VF }, // 1264
  { PseudoVFDIV_VF16_M4_E64_MASK, VFDIV_VF }, // 1265
  { PseudoVFDIV_VF16_M4_E64_TU, VFDIV_VF }, // 1266
  { PseudoVFDIV_VF16_M8_E16, VFDIV_VF }, // 1267
  { PseudoVFDIV_VF16_M8_E16_MASK, VFDIV_VF }, // 1268
  { PseudoVFDIV_VF16_M8_E16_TU, VFDIV_VF }, // 1269
  { PseudoVFDIV_VF16_M8_E32, VFDIV_VF }, // 1270
  { PseudoVFDIV_VF16_M8_E32_MASK, VFDIV_VF }, // 1271
  { PseudoVFDIV_VF16_M8_E32_TU, VFDIV_VF }, // 1272
  { PseudoVFDIV_VF16_M8_E64, VFDIV_VF }, // 1273
  { PseudoVFDIV_VF16_M8_E64_MASK, VFDIV_VF }, // 1274
  { PseudoVFDIV_VF16_M8_E64_TU, VFDIV_VF }, // 1275
  { PseudoVFDIV_VF16_MF2_E16, VFDIV_VF }, // 1276
  { PseudoVFDIV_VF16_MF2_E16_MASK, VFDIV_VF }, // 1277
  { PseudoVFDIV_VF16_MF2_E16_TU, VFDIV_VF }, // 1278
  { PseudoVFDIV_VF16_MF2_E32, VFDIV_VF }, // 1279
  { PseudoVFDIV_VF16_MF2_E32_MASK, VFDIV_VF }, // 1280
  { PseudoVFDIV_VF16_MF2_E32_TU, VFDIV_VF }, // 1281
  { PseudoVFDIV_VF16_MF4_E16, VFDIV_VF }, // 1282
  { PseudoVFDIV_VF16_MF4_E16_MASK, VFDIV_VF }, // 1283
  { PseudoVFDIV_VF16_MF4_E16_TU, VFDIV_VF }, // 1284
  { PseudoVFDIV_VF32_M1_E16, VFDIV_VF }, // 1285
  { PseudoVFDIV_VF32_M1_E16_MASK, VFDIV_VF }, // 1286
  { PseudoVFDIV_VF32_M1_E16_TU, VFDIV_VF }, // 1287
  { PseudoVFDIV_VF32_M1_E32, VFDIV_VF }, // 1288
  { PseudoVFDIV_VF32_M1_E32_MASK, VFDIV_VF }, // 1289
  { PseudoVFDIV_VF32_M1_E32_TU, VFDIV_VF }, // 1290
  { PseudoVFDIV_VF32_M1_E64, VFDIV_VF }, // 1291
  { PseudoVFDIV_VF32_M1_E64_MASK, VFDIV_VF }, // 1292
  { PseudoVFDIV_VF32_M1_E64_TU, VFDIV_VF }, // 1293
  { PseudoVFDIV_VF32_M2_E16, VFDIV_VF }, // 1294
  { PseudoVFDIV_VF32_M2_E16_MASK, VFDIV_VF }, // 1295
  { PseudoVFDIV_VF32_M2_E16_TU, VFDIV_VF }, // 1296
  { PseudoVFDIV_VF32_M2_E32, VFDIV_VF }, // 1297
  { PseudoVFDIV_VF32_M2_E32_MASK, VFDIV_VF }, // 1298
  { PseudoVFDIV_VF32_M2_E32_TU, VFDIV_VF }, // 1299
  { PseudoVFDIV_VF32_M2_E64, VFDIV_VF }, // 1300
  { PseudoVFDIV_VF32_M2_E64_MASK, VFDIV_VF }, // 1301
  { PseudoVFDIV_VF32_M2_E64_TU, VFDIV_VF }, // 1302
  { PseudoVFDIV_VF32_M4_E16, VFDIV_VF }, // 1303
  { PseudoVFDIV_VF32_M4_E16_MASK, VFDIV_VF }, // 1304
  { PseudoVFDIV_VF32_M4_E16_TU, VFDIV_VF }, // 1305
  { PseudoVFDIV_VF32_M4_E32, VFDIV_VF }, // 1306
  { PseudoVFDIV_VF32_M4_E32_MASK, VFDIV_VF }, // 1307
  { PseudoVFDIV_VF32_M4_E32_TU, VFDIV_VF }, // 1308
  { PseudoVFDIV_VF32_M4_E64, VFDIV_VF }, // 1309
  { PseudoVFDIV_VF32_M4_E64_MASK, VFDIV_VF }, // 1310
  { PseudoVFDIV_VF32_M4_E64_TU, VFDIV_VF }, // 1311
  { PseudoVFDIV_VF32_M8_E16, VFDIV_VF }, // 1312
  { PseudoVFDIV_VF32_M8_E16_MASK, VFDIV_VF }, // 1313
  { PseudoVFDIV_VF32_M8_E16_TU, VFDIV_VF }, // 1314
  { PseudoVFDIV_VF32_M8_E32, VFDIV_VF }, // 1315
  { PseudoVFDIV_VF32_M8_E32_MASK, VFDIV_VF }, // 1316
  { PseudoVFDIV_VF32_M8_E32_TU, VFDIV_VF }, // 1317
  { PseudoVFDIV_VF32_M8_E64, VFDIV_VF }, // 1318
  { PseudoVFDIV_VF32_M8_E64_MASK, VFDIV_VF }, // 1319
  { PseudoVFDIV_VF32_M8_E64_TU, VFDIV_VF }, // 1320
  { PseudoVFDIV_VF32_MF2_E16, VFDIV_VF }, // 1321
  { PseudoVFDIV_VF32_MF2_E16_MASK, VFDIV_VF }, // 1322
  { PseudoVFDIV_VF32_MF2_E16_TU, VFDIV_VF }, // 1323
  { PseudoVFDIV_VF32_MF2_E32, VFDIV_VF }, // 1324
  { PseudoVFDIV_VF32_MF2_E32_MASK, VFDIV_VF }, // 1325
  { PseudoVFDIV_VF32_MF2_E32_TU, VFDIV_VF }, // 1326
  { PseudoVFDIV_VF64_M1_E16, VFDIV_VF }, // 1327
  { PseudoVFDIV_VF64_M1_E16_MASK, VFDIV_VF }, // 1328
  { PseudoVFDIV_VF64_M1_E16_TU, VFDIV_VF }, // 1329
  { PseudoVFDIV_VF64_M1_E32, VFDIV_VF }, // 1330
  { PseudoVFDIV_VF64_M1_E32_MASK, VFDIV_VF }, // 1331
  { PseudoVFDIV_VF64_M1_E32_TU, VFDIV_VF }, // 1332
  { PseudoVFDIV_VF64_M1_E64, VFDIV_VF }, // 1333
  { PseudoVFDIV_VF64_M1_E64_MASK, VFDIV_VF }, // 1334
  { PseudoVFDIV_VF64_M1_E64_TU, VFDIV_VF }, // 1335
  { PseudoVFDIV_VF64_M2_E16, VFDIV_VF }, // 1336
  { PseudoVFDIV_VF64_M2_E16_MASK, VFDIV_VF }, // 1337
  { PseudoVFDIV_VF64_M2_E16_TU, VFDIV_VF }, // 1338
  { PseudoVFDIV_VF64_M2_E32, VFDIV_VF }, // 1339
  { PseudoVFDIV_VF64_M2_E32_MASK, VFDIV_VF }, // 1340
  { PseudoVFDIV_VF64_M2_E32_TU, VFDIV_VF }, // 1341
  { PseudoVFDIV_VF64_M2_E64, VFDIV_VF }, // 1342
  { PseudoVFDIV_VF64_M2_E64_MASK, VFDIV_VF }, // 1343
  { PseudoVFDIV_VF64_M2_E64_TU, VFDIV_VF }, // 1344
  { PseudoVFDIV_VF64_M4_E16, VFDIV_VF }, // 1345
  { PseudoVFDIV_VF64_M4_E16_MASK, VFDIV_VF }, // 1346
  { PseudoVFDIV_VF64_M4_E16_TU, VFDIV_VF }, // 1347
  { PseudoVFDIV_VF64_M4_E32, VFDIV_VF }, // 1348
  { PseudoVFDIV_VF64_M4_E32_MASK, VFDIV_VF }, // 1349
  { PseudoVFDIV_VF64_M4_E32_TU, VFDIV_VF }, // 1350
  { PseudoVFDIV_VF64_M4_E64, VFDIV_VF }, // 1351
  { PseudoVFDIV_VF64_M4_E64_MASK, VFDIV_VF }, // 1352
  { PseudoVFDIV_VF64_M4_E64_TU, VFDIV_VF }, // 1353
  { PseudoVFDIV_VF64_M8_E16, VFDIV_VF }, // 1354
  { PseudoVFDIV_VF64_M8_E16_MASK, VFDIV_VF }, // 1355
  { PseudoVFDIV_VF64_M8_E16_TU, VFDIV_VF }, // 1356
  { PseudoVFDIV_VF64_M8_E32, VFDIV_VF }, // 1357
  { PseudoVFDIV_VF64_M8_E32_MASK, VFDIV_VF }, // 1358
  { PseudoVFDIV_VF64_M8_E32_TU, VFDIV_VF }, // 1359
  { PseudoVFDIV_VF64_M8_E64, VFDIV_VF }, // 1360
  { PseudoVFDIV_VF64_M8_E64_MASK, VFDIV_VF }, // 1361
  { PseudoVFDIV_VF64_M8_E64_TU, VFDIV_VF }, // 1362
  { PseudoVFDIV_VV_M1_E16, VFDIV_VV }, // 1363
  { PseudoVFDIV_VV_M1_E16_MASK, VFDIV_VV }, // 1364
  { PseudoVFDIV_VV_M1_E16_TU, VFDIV_VV }, // 1365
  { PseudoVFDIV_VV_M1_E32, VFDIV_VV }, // 1366
  { PseudoVFDIV_VV_M1_E32_MASK, VFDIV_VV }, // 1367
  { PseudoVFDIV_VV_M1_E32_TU, VFDIV_VV }, // 1368
  { PseudoVFDIV_VV_M1_E64, VFDIV_VV }, // 1369
  { PseudoVFDIV_VV_M1_E64_MASK, VFDIV_VV }, // 1370
  { PseudoVFDIV_VV_M1_E64_TU, VFDIV_VV }, // 1371
  { PseudoVFDIV_VV_M2_E16, VFDIV_VV }, // 1372
  { PseudoVFDIV_VV_M2_E16_MASK, VFDIV_VV }, // 1373
  { PseudoVFDIV_VV_M2_E16_TU, VFDIV_VV }, // 1374
  { PseudoVFDIV_VV_M2_E32, VFDIV_VV }, // 1375
  { PseudoVFDIV_VV_M2_E32_MASK, VFDIV_VV }, // 1376
  { PseudoVFDIV_VV_M2_E32_TU, VFDIV_VV }, // 1377
  { PseudoVFDIV_VV_M2_E64, VFDIV_VV }, // 1378
  { PseudoVFDIV_VV_M2_E64_MASK, VFDIV_VV }, // 1379
  { PseudoVFDIV_VV_M2_E64_TU, VFDIV_VV }, // 1380
  { PseudoVFDIV_VV_M4_E16, VFDIV_VV }, // 1381
  { PseudoVFDIV_VV_M4_E16_MASK, VFDIV_VV }, // 1382
  { PseudoVFDIV_VV_M4_E16_TU, VFDIV_VV }, // 1383
  { PseudoVFDIV_VV_M4_E32, VFDIV_VV }, // 1384
  { PseudoVFDIV_VV_M4_E32_MASK, VFDIV_VV }, // 1385
  { PseudoVFDIV_VV_M4_E32_TU, VFDIV_VV }, // 1386
  { PseudoVFDIV_VV_M4_E64, VFDIV_VV }, // 1387
  { PseudoVFDIV_VV_M4_E64_MASK, VFDIV_VV }, // 1388
  { PseudoVFDIV_VV_M4_E64_TU, VFDIV_VV }, // 1389
  { PseudoVFDIV_VV_M8_E16, VFDIV_VV }, // 1390
  { PseudoVFDIV_VV_M8_E16_MASK, VFDIV_VV }, // 1391
  { PseudoVFDIV_VV_M8_E16_TU, VFDIV_VV }, // 1392
  { PseudoVFDIV_VV_M8_E32, VFDIV_VV }, // 1393
  { PseudoVFDIV_VV_M8_E32_MASK, VFDIV_VV }, // 1394
  { PseudoVFDIV_VV_M8_E32_TU, VFDIV_VV }, // 1395
  { PseudoVFDIV_VV_M8_E64, VFDIV_VV }, // 1396
  { PseudoVFDIV_VV_M8_E64_MASK, VFDIV_VV }, // 1397
  { PseudoVFDIV_VV_M8_E64_TU, VFDIV_VV }, // 1398
  { PseudoVFDIV_VV_MF2_E16, VFDIV_VV }, // 1399
  { PseudoVFDIV_VV_MF2_E16_MASK, VFDIV_VV }, // 1400
  { PseudoVFDIV_VV_MF2_E16_TU, VFDIV_VV }, // 1401
  { PseudoVFDIV_VV_MF2_E32, VFDIV_VV }, // 1402
  { PseudoVFDIV_VV_MF2_E32_MASK, VFDIV_VV }, // 1403
  { PseudoVFDIV_VV_MF2_E32_TU, VFDIV_VV }, // 1404
  { PseudoVFDIV_VV_MF4_E16, VFDIV_VV }, // 1405
  { PseudoVFDIV_VV_MF4_E16_MASK, VFDIV_VV }, // 1406
  { PseudoVFDIV_VV_MF4_E16_TU, VFDIV_VV }, // 1407
  { PseudoVFIRST_M_B1, VFIRST_M }, // 1408
  { PseudoVFIRST_M_B16, VFIRST_M }, // 1409
  { PseudoVFIRST_M_B16_MASK, VFIRST_M }, // 1410
  { PseudoVFIRST_M_B1_MASK, VFIRST_M }, // 1411
  { PseudoVFIRST_M_B2, VFIRST_M }, // 1412
  { PseudoVFIRST_M_B2_MASK, VFIRST_M }, // 1413
  { PseudoVFIRST_M_B32, VFIRST_M }, // 1414
  { PseudoVFIRST_M_B32_MASK, VFIRST_M }, // 1415
  { PseudoVFIRST_M_B4, VFIRST_M }, // 1416
  { PseudoVFIRST_M_B4_MASK, VFIRST_M }, // 1417
  { PseudoVFIRST_M_B64, VFIRST_M }, // 1418
  { PseudoVFIRST_M_B64_MASK, VFIRST_M }, // 1419
  { PseudoVFIRST_M_B8, VFIRST_M }, // 1420
  { PseudoVFIRST_M_B8_MASK, VFIRST_M }, // 1421
  { PseudoVFMACC_VF16_M1, VFMACC_VF }, // 1422
  { PseudoVFMACC_VF16_M1_MASK, VFMACC_VF }, // 1423
  { PseudoVFMACC_VF16_M2, VFMACC_VF }, // 1424
  { PseudoVFMACC_VF16_M2_MASK, VFMACC_VF }, // 1425
  { PseudoVFMACC_VF16_M4, VFMACC_VF }, // 1426
  { PseudoVFMACC_VF16_M4_MASK, VFMACC_VF }, // 1427
  { PseudoVFMACC_VF16_M8, VFMACC_VF }, // 1428
  { PseudoVFMACC_VF16_M8_MASK, VFMACC_VF }, // 1429
  { PseudoVFMACC_VF16_MF2, VFMACC_VF }, // 1430
  { PseudoVFMACC_VF16_MF2_MASK, VFMACC_VF }, // 1431
  { PseudoVFMACC_VF16_MF4, VFMACC_VF }, // 1432
  { PseudoVFMACC_VF16_MF4_MASK, VFMACC_VF }, // 1433
  { PseudoVFMACC_VF32_M1, VFMACC_VF }, // 1434
  { PseudoVFMACC_VF32_M1_MASK, VFMACC_VF }, // 1435
  { PseudoVFMACC_VF32_M2, VFMACC_VF }, // 1436
  { PseudoVFMACC_VF32_M2_MASK, VFMACC_VF }, // 1437
  { PseudoVFMACC_VF32_M4, VFMACC_VF }, // 1438
  { PseudoVFMACC_VF32_M4_MASK, VFMACC_VF }, // 1439
  { PseudoVFMACC_VF32_M8, VFMACC_VF }, // 1440
  { PseudoVFMACC_VF32_M8_MASK, VFMACC_VF }, // 1441
  { PseudoVFMACC_VF32_MF2, VFMACC_VF }, // 1442
  { PseudoVFMACC_VF32_MF2_MASK, VFMACC_VF }, // 1443
  { PseudoVFMACC_VF64_M1, VFMACC_VF }, // 1444
  { PseudoVFMACC_VF64_M1_MASK, VFMACC_VF }, // 1445
  { PseudoVFMACC_VF64_M2, VFMACC_VF }, // 1446
  { PseudoVFMACC_VF64_M2_MASK, VFMACC_VF }, // 1447
  { PseudoVFMACC_VF64_M4, VFMACC_VF }, // 1448
  { PseudoVFMACC_VF64_M4_MASK, VFMACC_VF }, // 1449
  { PseudoVFMACC_VF64_M8, VFMACC_VF }, // 1450
  { PseudoVFMACC_VF64_M8_MASK, VFMACC_VF }, // 1451
  { PseudoVFMACC_VV_M1, VFMACC_VV }, // 1452
  { PseudoVFMACC_VV_M1_MASK, VFMACC_VV }, // 1453
  { PseudoVFMACC_VV_M2, VFMACC_VV }, // 1454
  { PseudoVFMACC_VV_M2_MASK, VFMACC_VV }, // 1455
  { PseudoVFMACC_VV_M4, VFMACC_VV }, // 1456
  { PseudoVFMACC_VV_M4_MASK, VFMACC_VV }, // 1457
  { PseudoVFMACC_VV_M8, VFMACC_VV }, // 1458
  { PseudoVFMACC_VV_M8_MASK, VFMACC_VV }, // 1459
  { PseudoVFMACC_VV_MF2, VFMACC_VV }, // 1460
  { PseudoVFMACC_VV_MF2_MASK, VFMACC_VV }, // 1461
  { PseudoVFMACC_VV_MF4, VFMACC_VV }, // 1462
  { PseudoVFMACC_VV_MF4_MASK, VFMACC_VV }, // 1463
  { PseudoVFMADD_VF16_M1, VFMADD_VF }, // 1464
  { PseudoVFMADD_VF16_M1_MASK, VFMADD_VF }, // 1465
  { PseudoVFMADD_VF16_M2, VFMADD_VF }, // 1466
  { PseudoVFMADD_VF16_M2_MASK, VFMADD_VF }, // 1467
  { PseudoVFMADD_VF16_M4, VFMADD_VF }, // 1468
  { PseudoVFMADD_VF16_M4_MASK, VFMADD_VF }, // 1469
  { PseudoVFMADD_VF16_M8, VFMADD_VF }, // 1470
  { PseudoVFMADD_VF16_M8_MASK, VFMADD_VF }, // 1471
  { PseudoVFMADD_VF16_MF2, VFMADD_VF }, // 1472
  { PseudoVFMADD_VF16_MF2_MASK, VFMADD_VF }, // 1473
  { PseudoVFMADD_VF16_MF4, VFMADD_VF }, // 1474
  { PseudoVFMADD_VF16_MF4_MASK, VFMADD_VF }, // 1475
  { PseudoVFMADD_VF32_M1, VFMADD_VF }, // 1476
  { PseudoVFMADD_VF32_M1_MASK, VFMADD_VF }, // 1477
  { PseudoVFMADD_VF32_M2, VFMADD_VF }, // 1478
  { PseudoVFMADD_VF32_M2_MASK, VFMADD_VF }, // 1479
  { PseudoVFMADD_VF32_M4, VFMADD_VF }, // 1480
  { PseudoVFMADD_VF32_M4_MASK, VFMADD_VF }, // 1481
  { PseudoVFMADD_VF32_M8, VFMADD_VF }, // 1482
  { PseudoVFMADD_VF32_M8_MASK, VFMADD_VF }, // 1483
  { PseudoVFMADD_VF32_MF2, VFMADD_VF }, // 1484
  { PseudoVFMADD_VF32_MF2_MASK, VFMADD_VF }, // 1485
  { PseudoVFMADD_VF64_M1, VFMADD_VF }, // 1486
  { PseudoVFMADD_VF64_M1_MASK, VFMADD_VF }, // 1487
  { PseudoVFMADD_VF64_M2, VFMADD_VF }, // 1488
  { PseudoVFMADD_VF64_M2_MASK, VFMADD_VF }, // 1489
  { PseudoVFMADD_VF64_M4, VFMADD_VF }, // 1490
  { PseudoVFMADD_VF64_M4_MASK, VFMADD_VF }, // 1491
  { PseudoVFMADD_VF64_M8, VFMADD_VF }, // 1492
  { PseudoVFMADD_VF64_M8_MASK, VFMADD_VF }, // 1493
  { PseudoVFMADD_VV_M1, VFMADD_VV }, // 1494
  { PseudoVFMADD_VV_M1_MASK, VFMADD_VV }, // 1495
  { PseudoVFMADD_VV_M2, VFMADD_VV }, // 1496
  { PseudoVFMADD_VV_M2_MASK, VFMADD_VV }, // 1497
  { PseudoVFMADD_VV_M4, VFMADD_VV }, // 1498
  { PseudoVFMADD_VV_M4_MASK, VFMADD_VV }, // 1499
  { PseudoVFMADD_VV_M8, VFMADD_VV }, // 1500
  { PseudoVFMADD_VV_M8_MASK, VFMADD_VV }, // 1501
  { PseudoVFMADD_VV_MF2, VFMADD_VV }, // 1502
  { PseudoVFMADD_VV_MF2_MASK, VFMADD_VV }, // 1503
  { PseudoVFMADD_VV_MF4, VFMADD_VV }, // 1504
  { PseudoVFMADD_VV_MF4_MASK, VFMADD_VV }, // 1505
  { PseudoVFMAX_VF16_M1, VFMAX_VF }, // 1506
  { PseudoVFMAX_VF16_M1_MASK, VFMAX_VF }, // 1507
  { PseudoVFMAX_VF16_M1_TU, VFMAX_VF }, // 1508
  { PseudoVFMAX_VF16_M2, VFMAX_VF }, // 1509
  { PseudoVFMAX_VF16_M2_MASK, VFMAX_VF }, // 1510
  { PseudoVFMAX_VF16_M2_TU, VFMAX_VF }, // 1511
  { PseudoVFMAX_VF16_M4, VFMAX_VF }, // 1512
  { PseudoVFMAX_VF16_M4_MASK, VFMAX_VF }, // 1513
  { PseudoVFMAX_VF16_M4_TU, VFMAX_VF }, // 1514
  { PseudoVFMAX_VF16_M8, VFMAX_VF }, // 1515
  { PseudoVFMAX_VF16_M8_MASK, VFMAX_VF }, // 1516
  { PseudoVFMAX_VF16_M8_TU, VFMAX_VF }, // 1517
  { PseudoVFMAX_VF16_MF2, VFMAX_VF }, // 1518
  { PseudoVFMAX_VF16_MF2_MASK, VFMAX_VF }, // 1519
  { PseudoVFMAX_VF16_MF2_TU, VFMAX_VF }, // 1520
  { PseudoVFMAX_VF16_MF4, VFMAX_VF }, // 1521
  { PseudoVFMAX_VF16_MF4_MASK, VFMAX_VF }, // 1522
  { PseudoVFMAX_VF16_MF4_TU, VFMAX_VF }, // 1523
  { PseudoVFMAX_VF32_M1, VFMAX_VF }, // 1524
  { PseudoVFMAX_VF32_M1_MASK, VFMAX_VF }, // 1525
  { PseudoVFMAX_VF32_M1_TU, VFMAX_VF }, // 1526
  { PseudoVFMAX_VF32_M2, VFMAX_VF }, // 1527
  { PseudoVFMAX_VF32_M2_MASK, VFMAX_VF }, // 1528
  { PseudoVFMAX_VF32_M2_TU, VFMAX_VF }, // 1529
  { PseudoVFMAX_VF32_M4, VFMAX_VF }, // 1530
  { PseudoVFMAX_VF32_M4_MASK, VFMAX_VF }, // 1531
  { PseudoVFMAX_VF32_M4_TU, VFMAX_VF }, // 1532
  { PseudoVFMAX_VF32_M8, VFMAX_VF }, // 1533
  { PseudoVFMAX_VF32_M8_MASK, VFMAX_VF }, // 1534
  { PseudoVFMAX_VF32_M8_TU, VFMAX_VF }, // 1535
  { PseudoVFMAX_VF32_MF2, VFMAX_VF }, // 1536
  { PseudoVFMAX_VF32_MF2_MASK, VFMAX_VF }, // 1537
  { PseudoVFMAX_VF32_MF2_TU, VFMAX_VF }, // 1538
  { PseudoVFMAX_VF64_M1, VFMAX_VF }, // 1539
  { PseudoVFMAX_VF64_M1_MASK, VFMAX_VF }, // 1540
  { PseudoVFMAX_VF64_M1_TU, VFMAX_VF }, // 1541
  { PseudoVFMAX_VF64_M2, VFMAX_VF }, // 1542
  { PseudoVFMAX_VF64_M2_MASK, VFMAX_VF }, // 1543
  { PseudoVFMAX_VF64_M2_TU, VFMAX_VF }, // 1544
  { PseudoVFMAX_VF64_M4, VFMAX_VF }, // 1545
  { PseudoVFMAX_VF64_M4_MASK, VFMAX_VF }, // 1546
  { PseudoVFMAX_VF64_M4_TU, VFMAX_VF }, // 1547
  { PseudoVFMAX_VF64_M8, VFMAX_VF }, // 1548
  { PseudoVFMAX_VF64_M8_MASK, VFMAX_VF }, // 1549
  { PseudoVFMAX_VF64_M8_TU, VFMAX_VF }, // 1550
  { PseudoVFMAX_VV_M1, VFMAX_VV }, // 1551
  { PseudoVFMAX_VV_M1_MASK, VFMAX_VV }, // 1552
  { PseudoVFMAX_VV_M1_TU, VFMAX_VV }, // 1553
  { PseudoVFMAX_VV_M2, VFMAX_VV }, // 1554
  { PseudoVFMAX_VV_M2_MASK, VFMAX_VV }, // 1555
  { PseudoVFMAX_VV_M2_TU, VFMAX_VV }, // 1556
  { PseudoVFMAX_VV_M4, VFMAX_VV }, // 1557
  { PseudoVFMAX_VV_M4_MASK, VFMAX_VV }, // 1558
  { PseudoVFMAX_VV_M4_TU, VFMAX_VV }, // 1559
  { PseudoVFMAX_VV_M8, VFMAX_VV }, // 1560
  { PseudoVFMAX_VV_M8_MASK, VFMAX_VV }, // 1561
  { PseudoVFMAX_VV_M8_TU, VFMAX_VV }, // 1562
  { PseudoVFMAX_VV_MF2, VFMAX_VV }, // 1563
  { PseudoVFMAX_VV_MF2_MASK, VFMAX_VV }, // 1564
  { PseudoVFMAX_VV_MF2_TU, VFMAX_VV }, // 1565
  { PseudoVFMAX_VV_MF4, VFMAX_VV }, // 1566
  { PseudoVFMAX_VV_MF4_MASK, VFMAX_VV }, // 1567
  { PseudoVFMAX_VV_MF4_TU, VFMAX_VV }, // 1568
  { PseudoVFMERGE_VF16M_M1, VFMERGE_VFM }, // 1569
  { PseudoVFMERGE_VF16M_M1_TU, VFMERGE_VFM }, // 1570
  { PseudoVFMERGE_VF16M_M2, VFMERGE_VFM }, // 1571
  { PseudoVFMERGE_VF16M_M2_TU, VFMERGE_VFM }, // 1572
  { PseudoVFMERGE_VF16M_M4, VFMERGE_VFM }, // 1573
  { PseudoVFMERGE_VF16M_M4_TU, VFMERGE_VFM }, // 1574
  { PseudoVFMERGE_VF16M_M8, VFMERGE_VFM }, // 1575
  { PseudoVFMERGE_VF16M_M8_TU, VFMERGE_VFM }, // 1576
  { PseudoVFMERGE_VF16M_MF2, VFMERGE_VFM }, // 1577
  { PseudoVFMERGE_VF16M_MF2_TU, VFMERGE_VFM }, // 1578
  { PseudoVFMERGE_VF16M_MF4, VFMERGE_VFM }, // 1579
  { PseudoVFMERGE_VF16M_MF4_TU, VFMERGE_VFM }, // 1580
  { PseudoVFMERGE_VF32M_M1, VFMERGE_VFM }, // 1581
  { PseudoVFMERGE_VF32M_M1_TU, VFMERGE_VFM }, // 1582
  { PseudoVFMERGE_VF32M_M2, VFMERGE_VFM }, // 1583
  { PseudoVFMERGE_VF32M_M2_TU, VFMERGE_VFM }, // 1584
  { PseudoVFMERGE_VF32M_M4, VFMERGE_VFM }, // 1585
  { PseudoVFMERGE_VF32M_M4_TU, VFMERGE_VFM }, // 1586
  { PseudoVFMERGE_VF32M_M8, VFMERGE_VFM }, // 1587
  { PseudoVFMERGE_VF32M_M8_TU, VFMERGE_VFM }, // 1588
  { PseudoVFMERGE_VF32M_MF2, VFMERGE_VFM }, // 1589
  { PseudoVFMERGE_VF32M_MF2_TU, VFMERGE_VFM }, // 1590
  { PseudoVFMERGE_VF64M_M1, VFMERGE_VFM }, // 1591
  { PseudoVFMERGE_VF64M_M1_TU, VFMERGE_VFM }, // 1592
  { PseudoVFMERGE_VF64M_M2, VFMERGE_VFM }, // 1593
  { PseudoVFMERGE_VF64M_M2_TU, VFMERGE_VFM }, // 1594
  { PseudoVFMERGE_VF64M_M4, VFMERGE_VFM }, // 1595
  { PseudoVFMERGE_VF64M_M4_TU, VFMERGE_VFM }, // 1596
  { PseudoVFMERGE_VF64M_M8, VFMERGE_VFM }, // 1597
  { PseudoVFMERGE_VF64M_M8_TU, VFMERGE_VFM }, // 1598
  { PseudoVFMIN_VF16_M1, VFMIN_VF }, // 1599
  { PseudoVFMIN_VF16_M1_MASK, VFMIN_VF }, // 1600
  { PseudoVFMIN_VF16_M1_TU, VFMIN_VF }, // 1601
  { PseudoVFMIN_VF16_M2, VFMIN_VF }, // 1602
  { PseudoVFMIN_VF16_M2_MASK, VFMIN_VF }, // 1603
  { PseudoVFMIN_VF16_M2_TU, VFMIN_VF }, // 1604
  { PseudoVFMIN_VF16_M4, VFMIN_VF }, // 1605
  { PseudoVFMIN_VF16_M4_MASK, VFMIN_VF }, // 1606
  { PseudoVFMIN_VF16_M4_TU, VFMIN_VF }, // 1607
  { PseudoVFMIN_VF16_M8, VFMIN_VF }, // 1608
  { PseudoVFMIN_VF16_M8_MASK, VFMIN_VF }, // 1609
  { PseudoVFMIN_VF16_M8_TU, VFMIN_VF }, // 1610
  { PseudoVFMIN_VF16_MF2, VFMIN_VF }, // 1611
  { PseudoVFMIN_VF16_MF2_MASK, VFMIN_VF }, // 1612
  { PseudoVFMIN_VF16_MF2_TU, VFMIN_VF }, // 1613
  { PseudoVFMIN_VF16_MF4, VFMIN_VF }, // 1614
  { PseudoVFMIN_VF16_MF4_MASK, VFMIN_VF }, // 1615
  { PseudoVFMIN_VF16_MF4_TU, VFMIN_VF }, // 1616
  { PseudoVFMIN_VF32_M1, VFMIN_VF }, // 1617
  { PseudoVFMIN_VF32_M1_MASK, VFMIN_VF }, // 1618
  { PseudoVFMIN_VF32_M1_TU, VFMIN_VF }, // 1619
  { PseudoVFMIN_VF32_M2, VFMIN_VF }, // 1620
  { PseudoVFMIN_VF32_M2_MASK, VFMIN_VF }, // 1621
  { PseudoVFMIN_VF32_M2_TU, VFMIN_VF }, // 1622
  { PseudoVFMIN_VF32_M4, VFMIN_VF }, // 1623
  { PseudoVFMIN_VF32_M4_MASK, VFMIN_VF }, // 1624
  { PseudoVFMIN_VF32_M4_TU, VFMIN_VF }, // 1625
  { PseudoVFMIN_VF32_M8, VFMIN_VF }, // 1626
  { PseudoVFMIN_VF32_M8_MASK, VFMIN_VF }, // 1627
  { PseudoVFMIN_VF32_M8_TU, VFMIN_VF }, // 1628
  { PseudoVFMIN_VF32_MF2, VFMIN_VF }, // 1629
  { PseudoVFMIN_VF32_MF2_MASK, VFMIN_VF }, // 1630
  { PseudoVFMIN_VF32_MF2_TU, VFMIN_VF }, // 1631
  { PseudoVFMIN_VF64_M1, VFMIN_VF }, // 1632
  { PseudoVFMIN_VF64_M1_MASK, VFMIN_VF }, // 1633
  { PseudoVFMIN_VF64_M1_TU, VFMIN_VF }, // 1634
  { PseudoVFMIN_VF64_M2, VFMIN_VF }, // 1635
  { PseudoVFMIN_VF64_M2_MASK, VFMIN_VF }, // 1636
  { PseudoVFMIN_VF64_M2_TU, VFMIN_VF }, // 1637
  { PseudoVFMIN_VF64_M4, VFMIN_VF }, // 1638
  { PseudoVFMIN_VF64_M4_MASK, VFMIN_VF }, // 1639
  { PseudoVFMIN_VF64_M4_TU, VFMIN_VF }, // 1640
  { PseudoVFMIN_VF64_M8, VFMIN_VF }, // 1641
  { PseudoVFMIN_VF64_M8_MASK, VFMIN_VF }, // 1642
  { PseudoVFMIN_VF64_M8_TU, VFMIN_VF }, // 1643
  { PseudoVFMIN_VV_M1, VFMIN_VV }, // 1644
  { PseudoVFMIN_VV_M1_MASK, VFMIN_VV }, // 1645
  { PseudoVFMIN_VV_M1_TU, VFMIN_VV }, // 1646
  { PseudoVFMIN_VV_M2, VFMIN_VV }, // 1647
  { PseudoVFMIN_VV_M2_MASK, VFMIN_VV }, // 1648
  { PseudoVFMIN_VV_M2_TU, VFMIN_VV }, // 1649
  { PseudoVFMIN_VV_M4, VFMIN_VV }, // 1650
  { PseudoVFMIN_VV_M4_MASK, VFMIN_VV }, // 1651
  { PseudoVFMIN_VV_M4_TU, VFMIN_VV }, // 1652
  { PseudoVFMIN_VV_M8, VFMIN_VV }, // 1653
  { PseudoVFMIN_VV_M8_MASK, VFMIN_VV }, // 1654
  { PseudoVFMIN_VV_M8_TU, VFMIN_VV }, // 1655
  { PseudoVFMIN_VV_MF2, VFMIN_VV }, // 1656
  { PseudoVFMIN_VV_MF2_MASK, VFMIN_VV }, // 1657
  { PseudoVFMIN_VV_MF2_TU, VFMIN_VV }, // 1658
  { PseudoVFMIN_VV_MF4, VFMIN_VV }, // 1659
  { PseudoVFMIN_VV_MF4_MASK, VFMIN_VV }, // 1660
  { PseudoVFMIN_VV_MF4_TU, VFMIN_VV }, // 1661
  { PseudoVFMSAC_VF16_M1, VFMSAC_VF }, // 1662
  { PseudoVFMSAC_VF16_M1_MASK, VFMSAC_VF }, // 1663
  { PseudoVFMSAC_VF16_M2, VFMSAC_VF }, // 1664
  { PseudoVFMSAC_VF16_M2_MASK, VFMSAC_VF }, // 1665
  { PseudoVFMSAC_VF16_M4, VFMSAC_VF }, // 1666
  { PseudoVFMSAC_VF16_M4_MASK, VFMSAC_VF }, // 1667
  { PseudoVFMSAC_VF16_M8, VFMSAC_VF }, // 1668
  { PseudoVFMSAC_VF16_M8_MASK, VFMSAC_VF }, // 1669
  { PseudoVFMSAC_VF16_MF2, VFMSAC_VF }, // 1670
  { PseudoVFMSAC_VF16_MF2_MASK, VFMSAC_VF }, // 1671
  { PseudoVFMSAC_VF16_MF4, VFMSAC_VF }, // 1672
  { PseudoVFMSAC_VF16_MF4_MASK, VFMSAC_VF }, // 1673
  { PseudoVFMSAC_VF32_M1, VFMSAC_VF }, // 1674
  { PseudoVFMSAC_VF32_M1_MASK, VFMSAC_VF }, // 1675
  { PseudoVFMSAC_VF32_M2, VFMSAC_VF }, // 1676
  { PseudoVFMSAC_VF32_M2_MASK, VFMSAC_VF }, // 1677
  { PseudoVFMSAC_VF32_M4, VFMSAC_VF }, // 1678
  { PseudoVFMSAC_VF32_M4_MASK, VFMSAC_VF }, // 1679
  { PseudoVFMSAC_VF32_M8, VFMSAC_VF }, // 1680
  { PseudoVFMSAC_VF32_M8_MASK, VFMSAC_VF }, // 1681
  { PseudoVFMSAC_VF32_MF2, VFMSAC_VF }, // 1682
  { PseudoVFMSAC_VF32_MF2_MASK, VFMSAC_VF }, // 1683
  { PseudoVFMSAC_VF64_M1, VFMSAC_VF }, // 1684
  { PseudoVFMSAC_VF64_M1_MASK, VFMSAC_VF }, // 1685
  { PseudoVFMSAC_VF64_M2, VFMSAC_VF }, // 1686
  { PseudoVFMSAC_VF64_M2_MASK, VFMSAC_VF }, // 1687
  { PseudoVFMSAC_VF64_M4, VFMSAC_VF }, // 1688
  { PseudoVFMSAC_VF64_M4_MASK, VFMSAC_VF }, // 1689
  { PseudoVFMSAC_VF64_M8, VFMSAC_VF }, // 1690
  { PseudoVFMSAC_VF64_M8_MASK, VFMSAC_VF }, // 1691
  { PseudoVFMSAC_VV_M1, VFMSAC_VV }, // 1692
  { PseudoVFMSAC_VV_M1_MASK, VFMSAC_VV }, // 1693
  { PseudoVFMSAC_VV_M2, VFMSAC_VV }, // 1694
  { PseudoVFMSAC_VV_M2_MASK, VFMSAC_VV }, // 1695
  { PseudoVFMSAC_VV_M4, VFMSAC_VV }, // 1696
  { PseudoVFMSAC_VV_M4_MASK, VFMSAC_VV }, // 1697
  { PseudoVFMSAC_VV_M8, VFMSAC_VV }, // 1698
  { PseudoVFMSAC_VV_M8_MASK, VFMSAC_VV }, // 1699
  { PseudoVFMSAC_VV_MF2, VFMSAC_VV }, // 1700
  { PseudoVFMSAC_VV_MF2_MASK, VFMSAC_VV }, // 1701
  { PseudoVFMSAC_VV_MF4, VFMSAC_VV }, // 1702
  { PseudoVFMSAC_VV_MF4_MASK, VFMSAC_VV }, // 1703
  { PseudoVFMSUB_VF16_M1, VFMSUB_VF }, // 1704
  { PseudoVFMSUB_VF16_M1_MASK, VFMSUB_VF }, // 1705
  { PseudoVFMSUB_VF16_M2, VFMSUB_VF }, // 1706
  { PseudoVFMSUB_VF16_M2_MASK, VFMSUB_VF }, // 1707
  { PseudoVFMSUB_VF16_M4, VFMSUB_VF }, // 1708
  { PseudoVFMSUB_VF16_M4_MASK, VFMSUB_VF }, // 1709
  { PseudoVFMSUB_VF16_M8, VFMSUB_VF }, // 1710
  { PseudoVFMSUB_VF16_M8_MASK, VFMSUB_VF }, // 1711
  { PseudoVFMSUB_VF16_MF2, VFMSUB_VF }, // 1712
  { PseudoVFMSUB_VF16_MF2_MASK, VFMSUB_VF }, // 1713
  { PseudoVFMSUB_VF16_MF4, VFMSUB_VF }, // 1714
  { PseudoVFMSUB_VF16_MF4_MASK, VFMSUB_VF }, // 1715
  { PseudoVFMSUB_VF32_M1, VFMSUB_VF }, // 1716
  { PseudoVFMSUB_VF32_M1_MASK, VFMSUB_VF }, // 1717
  { PseudoVFMSUB_VF32_M2, VFMSUB_VF }, // 1718
  { PseudoVFMSUB_VF32_M2_MASK, VFMSUB_VF }, // 1719
  { PseudoVFMSUB_VF32_M4, VFMSUB_VF }, // 1720
  { PseudoVFMSUB_VF32_M4_MASK, VFMSUB_VF }, // 1721
  { PseudoVFMSUB_VF32_M8, VFMSUB_VF }, // 1722
  { PseudoVFMSUB_VF32_M8_MASK, VFMSUB_VF }, // 1723
  { PseudoVFMSUB_VF32_MF2, VFMSUB_VF }, // 1724
  { PseudoVFMSUB_VF32_MF2_MASK, VFMSUB_VF }, // 1725
  { PseudoVFMSUB_VF64_M1, VFMSUB_VF }, // 1726
  { PseudoVFMSUB_VF64_M1_MASK, VFMSUB_VF }, // 1727
  { PseudoVFMSUB_VF64_M2, VFMSUB_VF }, // 1728
  { PseudoVFMSUB_VF64_M2_MASK, VFMSUB_VF }, // 1729
  { PseudoVFMSUB_VF64_M4, VFMSUB_VF }, // 1730
  { PseudoVFMSUB_VF64_M4_MASK, VFMSUB_VF }, // 1731
  { PseudoVFMSUB_VF64_M8, VFMSUB_VF }, // 1732
  { PseudoVFMSUB_VF64_M8_MASK, VFMSUB_VF }, // 1733
  { PseudoVFMSUB_VV_M1, VFMSUB_VV }, // 1734
  { PseudoVFMSUB_VV_M1_MASK, VFMSUB_VV }, // 1735
  { PseudoVFMSUB_VV_M2, VFMSUB_VV }, // 1736
  { PseudoVFMSUB_VV_M2_MASK, VFMSUB_VV }, // 1737
  { PseudoVFMSUB_VV_M4, VFMSUB_VV }, // 1738
  { PseudoVFMSUB_VV_M4_MASK, VFMSUB_VV }, // 1739
  { PseudoVFMSUB_VV_M8, VFMSUB_VV }, // 1740
  { PseudoVFMSUB_VV_M8_MASK, VFMSUB_VV }, // 1741
  { PseudoVFMSUB_VV_MF2, VFMSUB_VV }, // 1742
  { PseudoVFMSUB_VV_MF2_MASK, VFMSUB_VV }, // 1743
  { PseudoVFMSUB_VV_MF4, VFMSUB_VV }, // 1744
  { PseudoVFMSUB_VV_MF4_MASK, VFMSUB_VV }, // 1745
  { PseudoVFMUL_VF16_M1, VFMUL_VF }, // 1746
  { PseudoVFMUL_VF16_M1_MASK, VFMUL_VF }, // 1747
  { PseudoVFMUL_VF16_M1_TU, VFMUL_VF }, // 1748
  { PseudoVFMUL_VF16_M2, VFMUL_VF }, // 1749
  { PseudoVFMUL_VF16_M2_MASK, VFMUL_VF }, // 1750
  { PseudoVFMUL_VF16_M2_TU, VFMUL_VF }, // 1751
  { PseudoVFMUL_VF16_M4, VFMUL_VF }, // 1752
  { PseudoVFMUL_VF16_M4_MASK, VFMUL_VF }, // 1753
  { PseudoVFMUL_VF16_M4_TU, VFMUL_VF }, // 1754
  { PseudoVFMUL_VF16_M8, VFMUL_VF }, // 1755
  { PseudoVFMUL_VF16_M8_MASK, VFMUL_VF }, // 1756
  { PseudoVFMUL_VF16_M8_TU, VFMUL_VF }, // 1757
  { PseudoVFMUL_VF16_MF2, VFMUL_VF }, // 1758
  { PseudoVFMUL_VF16_MF2_MASK, VFMUL_VF }, // 1759
  { PseudoVFMUL_VF16_MF2_TU, VFMUL_VF }, // 1760
  { PseudoVFMUL_VF16_MF4, VFMUL_VF }, // 1761
  { PseudoVFMUL_VF16_MF4_MASK, VFMUL_VF }, // 1762
  { PseudoVFMUL_VF16_MF4_TU, VFMUL_VF }, // 1763
  { PseudoVFMUL_VF32_M1, VFMUL_VF }, // 1764
  { PseudoVFMUL_VF32_M1_MASK, VFMUL_VF }, // 1765
  { PseudoVFMUL_VF32_M1_TU, VFMUL_VF }, // 1766
  { PseudoVFMUL_VF32_M2, VFMUL_VF }, // 1767
  { PseudoVFMUL_VF32_M2_MASK, VFMUL_VF }, // 1768
  { PseudoVFMUL_VF32_M2_TU, VFMUL_VF }, // 1769
  { PseudoVFMUL_VF32_M4, VFMUL_VF }, // 1770
  { PseudoVFMUL_VF32_M4_MASK, VFMUL_VF }, // 1771
  { PseudoVFMUL_VF32_M4_TU, VFMUL_VF }, // 1772
  { PseudoVFMUL_VF32_M8, VFMUL_VF }, // 1773
  { PseudoVFMUL_VF32_M8_MASK, VFMUL_VF }, // 1774
  { PseudoVFMUL_VF32_M8_TU, VFMUL_VF }, // 1775
  { PseudoVFMUL_VF32_MF2, VFMUL_VF }, // 1776
  { PseudoVFMUL_VF32_MF2_MASK, VFMUL_VF }, // 1777
  { PseudoVFMUL_VF32_MF2_TU, VFMUL_VF }, // 1778
  { PseudoVFMUL_VF64_M1, VFMUL_VF }, // 1779
  { PseudoVFMUL_VF64_M1_MASK, VFMUL_VF }, // 1780
  { PseudoVFMUL_VF64_M1_TU, VFMUL_VF }, // 1781
  { PseudoVFMUL_VF64_M2, VFMUL_VF }, // 1782
  { PseudoVFMUL_VF64_M2_MASK, VFMUL_VF }, // 1783
  { PseudoVFMUL_VF64_M2_TU, VFMUL_VF }, // 1784
  { PseudoVFMUL_VF64_M4, VFMUL_VF }, // 1785
  { PseudoVFMUL_VF64_M4_MASK, VFMUL_VF }, // 1786
  { PseudoVFMUL_VF64_M4_TU, VFMUL_VF }, // 1787
  { PseudoVFMUL_VF64_M8, VFMUL_VF }, // 1788
  { PseudoVFMUL_VF64_M8_MASK, VFMUL_VF }, // 1789
  { PseudoVFMUL_VF64_M8_TU, VFMUL_VF }, // 1790
  { PseudoVFMUL_VV_M1, VFMUL_VV }, // 1791
  { PseudoVFMUL_VV_M1_MASK, VFMUL_VV }, // 1792
  { PseudoVFMUL_VV_M1_TU, VFMUL_VV }, // 1793
  { PseudoVFMUL_VV_M2, VFMUL_VV }, // 1794
  { PseudoVFMUL_VV_M2_MASK, VFMUL_VV }, // 1795
  { PseudoVFMUL_VV_M2_TU, VFMUL_VV }, // 1796
  { PseudoVFMUL_VV_M4, VFMUL_VV }, // 1797
  { PseudoVFMUL_VV_M4_MASK, VFMUL_VV }, // 1798
  { PseudoVFMUL_VV_M4_TU, VFMUL_VV }, // 1799
  { PseudoVFMUL_VV_M8, VFMUL_VV }, // 1800
  { PseudoVFMUL_VV_M8_MASK, VFMUL_VV }, // 1801
  { PseudoVFMUL_VV_M8_TU, VFMUL_VV }, // 1802
  { PseudoVFMUL_VV_MF2, VFMUL_VV }, // 1803
  { PseudoVFMUL_VV_MF2_MASK, VFMUL_VV }, // 1804
  { PseudoVFMUL_VV_MF2_TU, VFMUL_VV }, // 1805
  { PseudoVFMUL_VV_MF4, VFMUL_VV }, // 1806
  { PseudoVFMUL_VV_MF4_MASK, VFMUL_VV }, // 1807
  { PseudoVFMUL_VV_MF4_TU, VFMUL_VV }, // 1808
  { PseudoVFMV_F16_S_M1, VFMV_F_S }, // 1809
  { PseudoVFMV_F16_S_M2, VFMV_F_S }, // 1810
  { PseudoVFMV_F16_S_M4, VFMV_F_S }, // 1811
  { PseudoVFMV_F16_S_M8, VFMV_F_S }, // 1812
  { PseudoVFMV_F16_S_MF2, VFMV_F_S }, // 1813
  { PseudoVFMV_F16_S_MF4, VFMV_F_S }, // 1814
  { PseudoVFMV_F32_S_M1, VFMV_F_S }, // 1815
  { PseudoVFMV_F32_S_M2, VFMV_F_S }, // 1816
  { PseudoVFMV_F32_S_M4, VFMV_F_S }, // 1817
  { PseudoVFMV_F32_S_M8, VFMV_F_S }, // 1818
  { PseudoVFMV_F32_S_MF2, VFMV_F_S }, // 1819
  { PseudoVFMV_F64_S_M1, VFMV_F_S }, // 1820
  { PseudoVFMV_F64_S_M2, VFMV_F_S }, // 1821
  { PseudoVFMV_F64_S_M4, VFMV_F_S }, // 1822
  { PseudoVFMV_F64_S_M8, VFMV_F_S }, // 1823
  { PseudoVFMV_S_F16_M1, VFMV_S_F }, // 1824
  { PseudoVFMV_S_F16_M2, VFMV_S_F }, // 1825
  { PseudoVFMV_S_F16_M4, VFMV_S_F }, // 1826
  { PseudoVFMV_S_F16_M8, VFMV_S_F }, // 1827
  { PseudoVFMV_S_F16_MF2, VFMV_S_F }, // 1828
  { PseudoVFMV_S_F16_MF4, VFMV_S_F }, // 1829
  { PseudoVFMV_S_F32_M1, VFMV_S_F }, // 1830
  { PseudoVFMV_S_F32_M2, VFMV_S_F }, // 1831
  { PseudoVFMV_S_F32_M4, VFMV_S_F }, // 1832
  { PseudoVFMV_S_F32_M8, VFMV_S_F }, // 1833
  { PseudoVFMV_S_F32_MF2, VFMV_S_F }, // 1834
  { PseudoVFMV_S_F64_M1, VFMV_S_F }, // 1835
  { PseudoVFMV_S_F64_M2, VFMV_S_F }, // 1836
  { PseudoVFMV_S_F64_M4, VFMV_S_F }, // 1837
  { PseudoVFMV_S_F64_M8, VFMV_S_F }, // 1838
  { PseudoVFMV_V_F16_M1, VFMV_V_F }, // 1839
  { PseudoVFMV_V_F16_M1_TU, VFMV_V_F }, // 1840
  { PseudoVFMV_V_F16_M2, VFMV_V_F }, // 1841
  { PseudoVFMV_V_F16_M2_TU, VFMV_V_F }, // 1842
  { PseudoVFMV_V_F16_M4, VFMV_V_F }, // 1843
  { PseudoVFMV_V_F16_M4_TU, VFMV_V_F }, // 1844
  { PseudoVFMV_V_F16_M8, VFMV_V_F }, // 1845
  { PseudoVFMV_V_F16_M8_TU, VFMV_V_F }, // 1846
  { PseudoVFMV_V_F16_MF2, VFMV_V_F }, // 1847
  { PseudoVFMV_V_F16_MF2_TU, VFMV_V_F }, // 1848
  { PseudoVFMV_V_F16_MF4, VFMV_V_F }, // 1849
  { PseudoVFMV_V_F16_MF4_TU, VFMV_V_F }, // 1850
  { PseudoVFMV_V_F32_M1, VFMV_V_F }, // 1851
  { PseudoVFMV_V_F32_M1_TU, VFMV_V_F }, // 1852
  { PseudoVFMV_V_F32_M2, VFMV_V_F }, // 1853
  { PseudoVFMV_V_F32_M2_TU, VFMV_V_F }, // 1854
  { PseudoVFMV_V_F32_M4, VFMV_V_F }, // 1855
  { PseudoVFMV_V_F32_M4_TU, VFMV_V_F }, // 1856
  { PseudoVFMV_V_F32_M8, VFMV_V_F }, // 1857
  { PseudoVFMV_V_F32_M8_TU, VFMV_V_F }, // 1858
  { PseudoVFMV_V_F32_MF2, VFMV_V_F }, // 1859
  { PseudoVFMV_V_F32_MF2_TU, VFMV_V_F }, // 1860
  { PseudoVFMV_V_F64_M1, VFMV_V_F }, // 1861
  { PseudoVFMV_V_F64_M1_TU, VFMV_V_F }, // 1862
  { PseudoVFMV_V_F64_M2, VFMV_V_F }, // 1863
  { PseudoVFMV_V_F64_M2_TU, VFMV_V_F }, // 1864
  { PseudoVFMV_V_F64_M4, VFMV_V_F }, // 1865
  { PseudoVFMV_V_F64_M4_TU, VFMV_V_F }, // 1866
  { PseudoVFMV_V_F64_M8, VFMV_V_F }, // 1867
  { PseudoVFMV_V_F64_M8_TU, VFMV_V_F }, // 1868
  { PseudoVFNCVT_F_F_W_M1, VFNCVT_F_F_W }, // 1869
  { PseudoVFNCVT_F_F_W_M1_MASK, VFNCVT_F_F_W }, // 1870
  { PseudoVFNCVT_F_F_W_M1_TU, VFNCVT_F_F_W }, // 1871
  { PseudoVFNCVT_F_F_W_M2, VFNCVT_F_F_W }, // 1872
  { PseudoVFNCVT_F_F_W_M2_MASK, VFNCVT_F_F_W }, // 1873
  { PseudoVFNCVT_F_F_W_M2_TU, VFNCVT_F_F_W }, // 1874
  { PseudoVFNCVT_F_F_W_M4, VFNCVT_F_F_W }, // 1875
  { PseudoVFNCVT_F_F_W_M4_MASK, VFNCVT_F_F_W }, // 1876
  { PseudoVFNCVT_F_F_W_M4_TU, VFNCVT_F_F_W }, // 1877
  { PseudoVFNCVT_F_F_W_MF2, VFNCVT_F_F_W }, // 1878
  { PseudoVFNCVT_F_F_W_MF2_MASK, VFNCVT_F_F_W }, // 1879
  { PseudoVFNCVT_F_F_W_MF2_TU, VFNCVT_F_F_W }, // 1880
  { PseudoVFNCVT_F_F_W_MF4, VFNCVT_F_F_W }, // 1881
  { PseudoVFNCVT_F_F_W_MF4_MASK, VFNCVT_F_F_W }, // 1882
  { PseudoVFNCVT_F_F_W_MF4_TU, VFNCVT_F_F_W }, // 1883
  { PseudoVFNCVT_F_XU_W_M1, VFNCVT_F_XU_W }, // 1884
  { PseudoVFNCVT_F_XU_W_M1_MASK, VFNCVT_F_XU_W }, // 1885
  { PseudoVFNCVT_F_XU_W_M1_TU, VFNCVT_F_XU_W }, // 1886
  { PseudoVFNCVT_F_XU_W_M2, VFNCVT_F_XU_W }, // 1887
  { PseudoVFNCVT_F_XU_W_M2_MASK, VFNCVT_F_XU_W }, // 1888
  { PseudoVFNCVT_F_XU_W_M2_TU, VFNCVT_F_XU_W }, // 1889
  { PseudoVFNCVT_F_XU_W_M4, VFNCVT_F_XU_W }, // 1890
  { PseudoVFNCVT_F_XU_W_M4_MASK, VFNCVT_F_XU_W }, // 1891
  { PseudoVFNCVT_F_XU_W_M4_TU, VFNCVT_F_XU_W }, // 1892
  { PseudoVFNCVT_F_XU_W_MF2, VFNCVT_F_XU_W }, // 1893
  { PseudoVFNCVT_F_XU_W_MF2_MASK, VFNCVT_F_XU_W }, // 1894
  { PseudoVFNCVT_F_XU_W_MF2_TU, VFNCVT_F_XU_W }, // 1895
  { PseudoVFNCVT_F_XU_W_MF4, VFNCVT_F_XU_W }, // 1896
  { PseudoVFNCVT_F_XU_W_MF4_MASK, VFNCVT_F_XU_W }, // 1897
  { PseudoVFNCVT_F_XU_W_MF4_TU, VFNCVT_F_XU_W }, // 1898
  { PseudoVFNCVT_F_X_W_M1, VFNCVT_F_X_W }, // 1899
  { PseudoVFNCVT_F_X_W_M1_MASK, VFNCVT_F_X_W }, // 1900
  { PseudoVFNCVT_F_X_W_M1_TU, VFNCVT_F_X_W }, // 1901
  { PseudoVFNCVT_F_X_W_M2, VFNCVT_F_X_W }, // 1902
  { PseudoVFNCVT_F_X_W_M2_MASK, VFNCVT_F_X_W }, // 1903
  { PseudoVFNCVT_F_X_W_M2_TU, VFNCVT_F_X_W }, // 1904
  { PseudoVFNCVT_F_X_W_M4, VFNCVT_F_X_W }, // 1905
  { PseudoVFNCVT_F_X_W_M4_MASK, VFNCVT_F_X_W }, // 1906
  { PseudoVFNCVT_F_X_W_M4_TU, VFNCVT_F_X_W }, // 1907
  { PseudoVFNCVT_F_X_W_MF2, VFNCVT_F_X_W }, // 1908
  { PseudoVFNCVT_F_X_W_MF2_MASK, VFNCVT_F_X_W }, // 1909
  { PseudoVFNCVT_F_X_W_MF2_TU, VFNCVT_F_X_W }, // 1910
  { PseudoVFNCVT_F_X_W_MF4, VFNCVT_F_X_W }, // 1911
  { PseudoVFNCVT_F_X_W_MF4_MASK, VFNCVT_F_X_W }, // 1912
  { PseudoVFNCVT_F_X_W_MF4_TU, VFNCVT_F_X_W }, // 1913
  { PseudoVFNCVT_ROD_F_F_W_M1, VFNCVT_ROD_F_F_W }, // 1914
  { PseudoVFNCVT_ROD_F_F_W_M1_MASK, VFNCVT_ROD_F_F_W }, // 1915
  { PseudoVFNCVT_ROD_F_F_W_M1_TU, VFNCVT_ROD_F_F_W }, // 1916
  { PseudoVFNCVT_ROD_F_F_W_M2, VFNCVT_ROD_F_F_W }, // 1917
  { PseudoVFNCVT_ROD_F_F_W_M2_MASK, VFNCVT_ROD_F_F_W }, // 1918
  { PseudoVFNCVT_ROD_F_F_W_M2_TU, VFNCVT_ROD_F_F_W }, // 1919
  { PseudoVFNCVT_ROD_F_F_W_M4, VFNCVT_ROD_F_F_W }, // 1920
  { PseudoVFNCVT_ROD_F_F_W_M4_MASK, VFNCVT_ROD_F_F_W }, // 1921
  { PseudoVFNCVT_ROD_F_F_W_M4_TU, VFNCVT_ROD_F_F_W }, // 1922
  { PseudoVFNCVT_ROD_F_F_W_MF2, VFNCVT_ROD_F_F_W }, // 1923
  { PseudoVFNCVT_ROD_F_F_W_MF2_MASK, VFNCVT_ROD_F_F_W }, // 1924
  { PseudoVFNCVT_ROD_F_F_W_MF2_TU, VFNCVT_ROD_F_F_W }, // 1925
  { PseudoVFNCVT_ROD_F_F_W_MF4, VFNCVT_ROD_F_F_W }, // 1926
  { PseudoVFNCVT_ROD_F_F_W_MF4_MASK, VFNCVT_ROD_F_F_W }, // 1927
  { PseudoVFNCVT_ROD_F_F_W_MF4_TU, VFNCVT_ROD_F_F_W }, // 1928
  { PseudoVFNCVT_RTZ_XU_F_W_M1, VFNCVT_RTZ_XU_F_W }, // 1929
  { PseudoVFNCVT_RTZ_XU_F_W_M1_MASK, VFNCVT_RTZ_XU_F_W }, // 1930
  { PseudoVFNCVT_RTZ_XU_F_W_M1_TU, VFNCVT_RTZ_XU_F_W }, // 1931
  { PseudoVFNCVT_RTZ_XU_F_W_M2, VFNCVT_RTZ_XU_F_W }, // 1932
  { PseudoVFNCVT_RTZ_XU_F_W_M2_MASK, VFNCVT_RTZ_XU_F_W }, // 1933
  { PseudoVFNCVT_RTZ_XU_F_W_M2_TU, VFNCVT_RTZ_XU_F_W }, // 1934
  { PseudoVFNCVT_RTZ_XU_F_W_M4, VFNCVT_RTZ_XU_F_W }, // 1935
  { PseudoVFNCVT_RTZ_XU_F_W_M4_MASK, VFNCVT_RTZ_XU_F_W }, // 1936
  { PseudoVFNCVT_RTZ_XU_F_W_M4_TU, VFNCVT_RTZ_XU_F_W }, // 1937
  { PseudoVFNCVT_RTZ_XU_F_W_MF2, VFNCVT_RTZ_XU_F_W }, // 1938
  { PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK, VFNCVT_RTZ_XU_F_W }, // 1939
  { PseudoVFNCVT_RTZ_XU_F_W_MF2_TU, VFNCVT_RTZ_XU_F_W }, // 1940
  { PseudoVFNCVT_RTZ_XU_F_W_MF4, VFNCVT_RTZ_XU_F_W }, // 1941
  { PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK, VFNCVT_RTZ_XU_F_W }, // 1942
  { PseudoVFNCVT_RTZ_XU_F_W_MF4_TU, VFNCVT_RTZ_XU_F_W }, // 1943
  { PseudoVFNCVT_RTZ_XU_F_W_MF8, VFNCVT_RTZ_XU_F_W }, // 1944
  { PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK, VFNCVT_RTZ_XU_F_W }, // 1945
  { PseudoVFNCVT_RTZ_XU_F_W_MF8_TU, VFNCVT_RTZ_XU_F_W }, // 1946
  { PseudoVFNCVT_RTZ_X_F_W_M1, VFNCVT_RTZ_X_F_W }, // 1947
  { PseudoVFNCVT_RTZ_X_F_W_M1_MASK, VFNCVT_RTZ_X_F_W }, // 1948
  { PseudoVFNCVT_RTZ_X_F_W_M1_TU, VFNCVT_RTZ_X_F_W }, // 1949
  { PseudoVFNCVT_RTZ_X_F_W_M2, VFNCVT_RTZ_X_F_W }, // 1950
  { PseudoVFNCVT_RTZ_X_F_W_M2_MASK, VFNCVT_RTZ_X_F_W }, // 1951
  { PseudoVFNCVT_RTZ_X_F_W_M2_TU, VFNCVT_RTZ_X_F_W }, // 1952
  { PseudoVFNCVT_RTZ_X_F_W_M4, VFNCVT_RTZ_X_F_W }, // 1953
  { PseudoVFNCVT_RTZ_X_F_W_M4_MASK, VFNCVT_RTZ_X_F_W }, // 1954
  { PseudoVFNCVT_RTZ_X_F_W_M4_TU, VFNCVT_RTZ_X_F_W }, // 1955
  { PseudoVFNCVT_RTZ_X_F_W_MF2, VFNCVT_RTZ_X_F_W }, // 1956
  { PseudoVFNCVT_RTZ_X_F_W_MF2_MASK, VFNCVT_RTZ_X_F_W }, // 1957
  { PseudoVFNCVT_RTZ_X_F_W_MF2_TU, VFNCVT_RTZ_X_F_W }, // 1958
  { PseudoVFNCVT_RTZ_X_F_W_MF4, VFNCVT_RTZ_X_F_W }, // 1959
  { PseudoVFNCVT_RTZ_X_F_W_MF4_MASK, VFNCVT_RTZ_X_F_W }, // 1960
  { PseudoVFNCVT_RTZ_X_F_W_MF4_TU, VFNCVT_RTZ_X_F_W }, // 1961
  { PseudoVFNCVT_RTZ_X_F_W_MF8, VFNCVT_RTZ_X_F_W }, // 1962
  { PseudoVFNCVT_RTZ_X_F_W_MF8_MASK, VFNCVT_RTZ_X_F_W }, // 1963
  { PseudoVFNCVT_RTZ_X_F_W_MF8_TU, VFNCVT_RTZ_X_F_W }, // 1964
  { PseudoVFNCVT_XU_F_W_M1, VFNCVT_XU_F_W }, // 1965
  { PseudoVFNCVT_XU_F_W_M1_MASK, VFNCVT_XU_F_W }, // 1966
  { PseudoVFNCVT_XU_F_W_M1_TU, VFNCVT_XU_F_W }, // 1967
  { PseudoVFNCVT_XU_F_W_M2, VFNCVT_XU_F_W }, // 1968
  { PseudoVFNCVT_XU_F_W_M2_MASK, VFNCVT_XU_F_W }, // 1969
  { PseudoVFNCVT_XU_F_W_M2_TU, VFNCVT_XU_F_W }, // 1970
  { PseudoVFNCVT_XU_F_W_M4, VFNCVT_XU_F_W }, // 1971
  { PseudoVFNCVT_XU_F_W_M4_MASK, VFNCVT_XU_F_W }, // 1972
  { PseudoVFNCVT_XU_F_W_M4_TU, VFNCVT_XU_F_W }, // 1973
  { PseudoVFNCVT_XU_F_W_MF2, VFNCVT_XU_F_W }, // 1974
  { PseudoVFNCVT_XU_F_W_MF2_MASK, VFNCVT_XU_F_W }, // 1975
  { PseudoVFNCVT_XU_F_W_MF2_TU, VFNCVT_XU_F_W }, // 1976
  { PseudoVFNCVT_XU_F_W_MF4, VFNCVT_XU_F_W }, // 1977
  { PseudoVFNCVT_XU_F_W_MF4_MASK, VFNCVT_XU_F_W }, // 1978
  { PseudoVFNCVT_XU_F_W_MF4_TU, VFNCVT_XU_F_W }, // 1979
  { PseudoVFNCVT_XU_F_W_MF8, VFNCVT_XU_F_W }, // 1980
  { PseudoVFNCVT_XU_F_W_MF8_MASK, VFNCVT_XU_F_W }, // 1981
  { PseudoVFNCVT_XU_F_W_MF8_TU, VFNCVT_XU_F_W }, // 1982
  { PseudoVFNCVT_X_F_W_M1, VFNCVT_X_F_W }, // 1983
  { PseudoVFNCVT_X_F_W_M1_MASK, VFNCVT_X_F_W }, // 1984
  { PseudoVFNCVT_X_F_W_M1_TU, VFNCVT_X_F_W }, // 1985
  { PseudoVFNCVT_X_F_W_M2, VFNCVT_X_F_W }, // 1986
  { PseudoVFNCVT_X_F_W_M2_MASK, VFNCVT_X_F_W }, // 1987
  { PseudoVFNCVT_X_F_W_M2_TU, VFNCVT_X_F_W }, // 1988
  { PseudoVFNCVT_X_F_W_M4, VFNCVT_X_F_W }, // 1989
  { PseudoVFNCVT_X_F_W_M4_MASK, VFNCVT_X_F_W }, // 1990
  { PseudoVFNCVT_X_F_W_M4_TU, VFNCVT_X_F_W }, // 1991
  { PseudoVFNCVT_X_F_W_MF2, VFNCVT_X_F_W }, // 1992
  { PseudoVFNCVT_X_F_W_MF2_MASK, VFNCVT_X_F_W }, // 1993
  { PseudoVFNCVT_X_F_W_MF2_TU, VFNCVT_X_F_W }, // 1994
  { PseudoVFNCVT_X_F_W_MF4, VFNCVT_X_F_W }, // 1995
  { PseudoVFNCVT_X_F_W_MF4_MASK, VFNCVT_X_F_W }, // 1996
  { PseudoVFNCVT_X_F_W_MF4_TU, VFNCVT_X_F_W }, // 1997
  { PseudoVFNCVT_X_F_W_MF8, VFNCVT_X_F_W }, // 1998
  { PseudoVFNCVT_X_F_W_MF8_MASK, VFNCVT_X_F_W }, // 1999
  { PseudoVFNCVT_X_F_W_MF8_TU, VFNCVT_X_F_W }, // 2000
  { PseudoVFNMACC_VF16_M1, VFNMACC_VF }, // 2001
  { PseudoVFNMACC_VF16_M1_MASK, VFNMACC_VF }, // 2002
  { PseudoVFNMACC_VF16_M2, VFNMACC_VF }, // 2003
  { PseudoVFNMACC_VF16_M2_MASK, VFNMACC_VF }, // 2004
  { PseudoVFNMACC_VF16_M4, VFNMACC_VF }, // 2005
  { PseudoVFNMACC_VF16_M4_MASK, VFNMACC_VF }, // 2006
  { PseudoVFNMACC_VF16_M8, VFNMACC_VF }, // 2007
  { PseudoVFNMACC_VF16_M8_MASK, VFNMACC_VF }, // 2008
  { PseudoVFNMACC_VF16_MF2, VFNMACC_VF }, // 2009
  { PseudoVFNMACC_VF16_MF2_MASK, VFNMACC_VF }, // 2010
  { PseudoVFNMACC_VF16_MF4, VFNMACC_VF }, // 2011
  { PseudoVFNMACC_VF16_MF4_MASK, VFNMACC_VF }, // 2012
  { PseudoVFNMACC_VF32_M1, VFNMACC_VF }, // 2013
  { PseudoVFNMACC_VF32_M1_MASK, VFNMACC_VF }, // 2014
  { PseudoVFNMACC_VF32_M2, VFNMACC_VF }, // 2015
  { PseudoVFNMACC_VF32_M2_MASK, VFNMACC_VF }, // 2016
  { PseudoVFNMACC_VF32_M4, VFNMACC_VF }, // 2017
  { PseudoVFNMACC_VF32_M4_MASK, VFNMACC_VF }, // 2018
  { PseudoVFNMACC_VF32_M8, VFNMACC_VF }, // 2019
  { PseudoVFNMACC_VF32_M8_MASK, VFNMACC_VF }, // 2020
  { PseudoVFNMACC_VF32_MF2, VFNMACC_VF }, // 2021
  { PseudoVFNMACC_VF32_MF2_MASK, VFNMACC_VF }, // 2022
  { PseudoVFNMACC_VF64_M1, VFNMACC_VF }, // 2023
  { PseudoVFNMACC_VF64_M1_MASK, VFNMACC_VF }, // 2024
  { PseudoVFNMACC_VF64_M2, VFNMACC_VF }, // 2025
  { PseudoVFNMACC_VF64_M2_MASK, VFNMACC_VF }, // 2026
  { PseudoVFNMACC_VF64_M4, VFNMACC_VF }, // 2027
  { PseudoVFNMACC_VF64_M4_MASK, VFNMACC_VF }, // 2028
  { PseudoVFNMACC_VF64_M8, VFNMACC_VF }, // 2029
  { PseudoVFNMACC_VF64_M8_MASK, VFNMACC_VF }, // 2030
  { PseudoVFNMACC_VV_M1, VFNMACC_VV }, // 2031
  { PseudoVFNMACC_VV_M1_MASK, VFNMACC_VV }, // 2032
  { PseudoVFNMACC_VV_M2, VFNMACC_VV }, // 2033
  { PseudoVFNMACC_VV_M2_MASK, VFNMACC_VV }, // 2034
  { PseudoVFNMACC_VV_M4, VFNMACC_VV }, // 2035
  { PseudoVFNMACC_VV_M4_MASK, VFNMACC_VV }, // 2036
  { PseudoVFNMACC_VV_M8, VFNMACC_VV }, // 2037
  { PseudoVFNMACC_VV_M8_MASK, VFNMACC_VV }, // 2038
  { PseudoVFNMACC_VV_MF2, VFNMACC_VV }, // 2039
  { PseudoVFNMACC_VV_MF2_MASK, VFNMACC_VV }, // 2040
  { PseudoVFNMACC_VV_MF4, VFNMACC_VV }, // 2041
  { PseudoVFNMACC_VV_MF4_MASK, VFNMACC_VV }, // 2042
  { PseudoVFNMADD_VF16_M1, VFNMADD_VF }, // 2043
  { PseudoVFNMADD_VF16_M1_MASK, VFNMADD_VF }, // 2044
  { PseudoVFNMADD_VF16_M2, VFNMADD_VF }, // 2045
  { PseudoVFNMADD_VF16_M2_MASK, VFNMADD_VF }, // 2046
  { PseudoVFNMADD_VF16_M4, VFNMADD_VF }, // 2047
  { PseudoVFNMADD_VF16_M4_MASK, VFNMADD_VF }, // 2048
  { PseudoVFNMADD_VF16_M8, VFNMADD_VF }, // 2049
  { PseudoVFNMADD_VF16_M8_MASK, VFNMADD_VF }, // 2050
  { PseudoVFNMADD_VF16_MF2, VFNMADD_VF }, // 2051
  { PseudoVFNMADD_VF16_MF2_MASK, VFNMADD_VF }, // 2052
  { PseudoVFNMADD_VF16_MF4, VFNMADD_VF }, // 2053
  { PseudoVFNMADD_VF16_MF4_MASK, VFNMADD_VF }, // 2054
  { PseudoVFNMADD_VF32_M1, VFNMADD_VF }, // 2055
  { PseudoVFNMADD_VF32_M1_MASK, VFNMADD_VF }, // 2056
  { PseudoVFNMADD_VF32_M2, VFNMADD_VF }, // 2057
  { PseudoVFNMADD_VF32_M2_MASK, VFNMADD_VF }, // 2058
  { PseudoVFNMADD_VF32_M4, VFNMADD_VF }, // 2059
  { PseudoVFNMADD_VF32_M4_MASK, VFNMADD_VF }, // 2060
  { PseudoVFNMADD_VF32_M8, VFNMADD_VF }, // 2061
  { PseudoVFNMADD_VF32_M8_MASK, VFNMADD_VF }, // 2062
  { PseudoVFNMADD_VF32_MF2, VFNMADD_VF }, // 2063
  { PseudoVFNMADD_VF32_MF2_MASK, VFNMADD_VF }, // 2064
  { PseudoVFNMADD_VF64_M1, VFNMADD_VF }, // 2065
  { PseudoVFNMADD_VF64_M1_MASK, VFNMADD_VF }, // 2066
  { PseudoVFNMADD_VF64_M2, VFNMADD_VF }, // 2067
  { PseudoVFNMADD_VF64_M2_MASK, VFNMADD_VF }, // 2068
  { PseudoVFNMADD_VF64_M4, VFNMADD_VF }, // 2069
  { PseudoVFNMADD_VF64_M4_MASK, VFNMADD_VF }, // 2070
  { PseudoVFNMADD_VF64_M8, VFNMADD_VF }, // 2071
  { PseudoVFNMADD_VF64_M8_MASK, VFNMADD_VF }, // 2072
  { PseudoVFNMADD_VV_M1, VFNMADD_VV }, // 2073
  { PseudoVFNMADD_VV_M1_MASK, VFNMADD_VV }, // 2074
  { PseudoVFNMADD_VV_M2, VFNMADD_VV }, // 2075
  { PseudoVFNMADD_VV_M2_MASK, VFNMADD_VV }, // 2076
  { PseudoVFNMADD_VV_M4, VFNMADD_VV }, // 2077
  { PseudoVFNMADD_VV_M4_MASK, VFNMADD_VV }, // 2078
  { PseudoVFNMADD_VV_M8, VFNMADD_VV }, // 2079
  { PseudoVFNMADD_VV_M8_MASK, VFNMADD_VV }, // 2080
  { PseudoVFNMADD_VV_MF2, VFNMADD_VV }, // 2081
  { PseudoVFNMADD_VV_MF2_MASK, VFNMADD_VV }, // 2082
  { PseudoVFNMADD_VV_MF4, VFNMADD_VV }, // 2083
  { PseudoVFNMADD_VV_MF4_MASK, VFNMADD_VV }, // 2084
  { PseudoVFNMSAC_VF16_M1, VFNMSAC_VF }, // 2085
  { PseudoVFNMSAC_VF16_M1_MASK, VFNMSAC_VF }, // 2086
  { PseudoVFNMSAC_VF16_M2, VFNMSAC_VF }, // 2087
  { PseudoVFNMSAC_VF16_M2_MASK, VFNMSAC_VF }, // 2088
  { PseudoVFNMSAC_VF16_M4, VFNMSAC_VF }, // 2089
  { PseudoVFNMSAC_VF16_M4_MASK, VFNMSAC_VF }, // 2090
  { PseudoVFNMSAC_VF16_M8, VFNMSAC_VF }, // 2091
  { PseudoVFNMSAC_VF16_M8_MASK, VFNMSAC_VF }, // 2092
  { PseudoVFNMSAC_VF16_MF2, VFNMSAC_VF }, // 2093
  { PseudoVFNMSAC_VF16_MF2_MASK, VFNMSAC_VF }, // 2094
  { PseudoVFNMSAC_VF16_MF4, VFNMSAC_VF }, // 2095
  { PseudoVFNMSAC_VF16_MF4_MASK, VFNMSAC_VF }, // 2096
  { PseudoVFNMSAC_VF32_M1, VFNMSAC_VF }, // 2097
  { PseudoVFNMSAC_VF32_M1_MASK, VFNMSAC_VF }, // 2098
  { PseudoVFNMSAC_VF32_M2, VFNMSAC_VF }, // 2099
  { PseudoVFNMSAC_VF32_M2_MASK, VFNMSAC_VF }, // 2100
  { PseudoVFNMSAC_VF32_M4, VFNMSAC_VF }, // 2101
  { PseudoVFNMSAC_VF32_M4_MASK, VFNMSAC_VF }, // 2102
  { PseudoVFNMSAC_VF32_M8, VFNMSAC_VF }, // 2103
  { PseudoVFNMSAC_VF32_M8_MASK, VFNMSAC_VF }, // 2104
  { PseudoVFNMSAC_VF32_MF2, VFNMSAC_VF }, // 2105
  { PseudoVFNMSAC_VF32_MF2_MASK, VFNMSAC_VF }, // 2106
  { PseudoVFNMSAC_VF64_M1, VFNMSAC_VF }, // 2107
  { PseudoVFNMSAC_VF64_M1_MASK, VFNMSAC_VF }, // 2108
  { PseudoVFNMSAC_VF64_M2, VFNMSAC_VF }, // 2109
  { PseudoVFNMSAC_VF64_M2_MASK, VFNMSAC_VF }, // 2110
  { PseudoVFNMSAC_VF64_M4, VFNMSAC_VF }, // 2111
  { PseudoVFNMSAC_VF64_M4_MASK, VFNMSAC_VF }, // 2112
  { PseudoVFNMSAC_VF64_M8, VFNMSAC_VF }, // 2113
  { PseudoVFNMSAC_VF64_M8_MASK, VFNMSAC_VF }, // 2114
  { PseudoVFNMSAC_VV_M1, VFNMSAC_VV }, // 2115
  { PseudoVFNMSAC_VV_M1_MASK, VFNMSAC_VV }, // 2116
  { PseudoVFNMSAC_VV_M2, VFNMSAC_VV }, // 2117
  { PseudoVFNMSAC_VV_M2_MASK, VFNMSAC_VV }, // 2118
  { PseudoVFNMSAC_VV_M4, VFNMSAC_VV }, // 2119
  { PseudoVFNMSAC_VV_M4_MASK, VFNMSAC_VV }, // 2120
  { PseudoVFNMSAC_VV_M8, VFNMSAC_VV }, // 2121
  { PseudoVFNMSAC_VV_M8_MASK, VFNMSAC_VV }, // 2122
  { PseudoVFNMSAC_VV_MF2, VFNMSAC_VV }, // 2123
  { PseudoVFNMSAC_VV_MF2_MASK, VFNMSAC_VV }, // 2124
  { PseudoVFNMSAC_VV_MF4, VFNMSAC_VV }, // 2125
  { PseudoVFNMSAC_VV_MF4_MASK, VFNMSAC_VV }, // 2126
  { PseudoVFNMSUB_VF16_M1, VFNMSUB_VF }, // 2127
  { PseudoVFNMSUB_VF16_M1_MASK, VFNMSUB_VF }, // 2128
  { PseudoVFNMSUB_VF16_M2, VFNMSUB_VF }, // 2129
  { PseudoVFNMSUB_VF16_M2_MASK, VFNMSUB_VF }, // 2130
  { PseudoVFNMSUB_VF16_M4, VFNMSUB_VF }, // 2131
  { PseudoVFNMSUB_VF16_M4_MASK, VFNMSUB_VF }, // 2132
  { PseudoVFNMSUB_VF16_M8, VFNMSUB_VF }, // 2133
  { PseudoVFNMSUB_VF16_M8_MASK, VFNMSUB_VF }, // 2134
  { PseudoVFNMSUB_VF16_MF2, VFNMSUB_VF }, // 2135
  { PseudoVFNMSUB_VF16_MF2_MASK, VFNMSUB_VF }, // 2136
  { PseudoVFNMSUB_VF16_MF4, VFNMSUB_VF }, // 2137
  { PseudoVFNMSUB_VF16_MF4_MASK, VFNMSUB_VF }, // 2138
  { PseudoVFNMSUB_VF32_M1, VFNMSUB_VF }, // 2139
  { PseudoVFNMSUB_VF32_M1_MASK, VFNMSUB_VF }, // 2140
  { PseudoVFNMSUB_VF32_M2, VFNMSUB_VF }, // 2141
  { PseudoVFNMSUB_VF32_M2_MASK, VFNMSUB_VF }, // 2142
  { PseudoVFNMSUB_VF32_M4, VFNMSUB_VF }, // 2143
  { PseudoVFNMSUB_VF32_M4_MASK, VFNMSUB_VF }, // 2144
  { PseudoVFNMSUB_VF32_M8, VFNMSUB_VF }, // 2145
  { PseudoVFNMSUB_VF32_M8_MASK, VFNMSUB_VF }, // 2146
  { PseudoVFNMSUB_VF32_MF2, VFNMSUB_VF }, // 2147
  { PseudoVFNMSUB_VF32_MF2_MASK, VFNMSUB_VF }, // 2148
  { PseudoVFNMSUB_VF64_M1, VFNMSUB_VF }, // 2149
  { PseudoVFNMSUB_VF64_M1_MASK, VFNMSUB_VF }, // 2150
  { PseudoVFNMSUB_VF64_M2, VFNMSUB_VF }, // 2151
  { PseudoVFNMSUB_VF64_M2_MASK, VFNMSUB_VF }, // 2152
  { PseudoVFNMSUB_VF64_M4, VFNMSUB_VF }, // 2153
  { PseudoVFNMSUB_VF64_M4_MASK, VFNMSUB_VF }, // 2154
  { PseudoVFNMSUB_VF64_M8, VFNMSUB_VF }, // 2155
  { PseudoVFNMSUB_VF64_M8_MASK, VFNMSUB_VF }, // 2156
  { PseudoVFNMSUB_VV_M1, VFNMSUB_VV }, // 2157
  { PseudoVFNMSUB_VV_M1_MASK, VFNMSUB_VV }, // 2158
  { PseudoVFNMSUB_VV_M2, VFNMSUB_VV }, // 2159
  { PseudoVFNMSUB_VV_M2_MASK, VFNMSUB_VV }, // 2160
  { PseudoVFNMSUB_VV_M4, VFNMSUB_VV }, // 2161
  { PseudoVFNMSUB_VV_M4_MASK, VFNMSUB_VV }, // 2162
  { PseudoVFNMSUB_VV_M8, VFNMSUB_VV }, // 2163
  { PseudoVFNMSUB_VV_M8_MASK, VFNMSUB_VV }, // 2164
  { PseudoVFNMSUB_VV_MF2, VFNMSUB_VV }, // 2165
  { PseudoVFNMSUB_VV_MF2_MASK, VFNMSUB_VV }, // 2166
  { PseudoVFNMSUB_VV_MF4, VFNMSUB_VV }, // 2167
  { PseudoVFNMSUB_VV_MF4_MASK, VFNMSUB_VV }, // 2168
  { PseudoVFRDIV_VF16_M1_E16, VFRDIV_VF }, // 2169
  { PseudoVFRDIV_VF16_M1_E16_MASK, VFRDIV_VF }, // 2170
  { PseudoVFRDIV_VF16_M1_E16_TU, VFRDIV_VF }, // 2171
  { PseudoVFRDIV_VF16_M1_E32, VFRDIV_VF }, // 2172
  { PseudoVFRDIV_VF16_M1_E32_MASK, VFRDIV_VF }, // 2173
  { PseudoVFRDIV_VF16_M1_E32_TU, VFRDIV_VF }, // 2174
  { PseudoVFRDIV_VF16_M1_E64, VFRDIV_VF }, // 2175
  { PseudoVFRDIV_VF16_M1_E64_MASK, VFRDIV_VF }, // 2176
  { PseudoVFRDIV_VF16_M1_E64_TU, VFRDIV_VF }, // 2177
  { PseudoVFRDIV_VF16_M2_E16, VFRDIV_VF }, // 2178
  { PseudoVFRDIV_VF16_M2_E16_MASK, VFRDIV_VF }, // 2179
  { PseudoVFRDIV_VF16_M2_E16_TU, VFRDIV_VF }, // 2180
  { PseudoVFRDIV_VF16_M2_E32, VFRDIV_VF }, // 2181
  { PseudoVFRDIV_VF16_M2_E32_MASK, VFRDIV_VF }, // 2182
  { PseudoVFRDIV_VF16_M2_E32_TU, VFRDIV_VF }, // 2183
  { PseudoVFRDIV_VF16_M2_E64, VFRDIV_VF }, // 2184
  { PseudoVFRDIV_VF16_M2_E64_MASK, VFRDIV_VF }, // 2185
  { PseudoVFRDIV_VF16_M2_E64_TU, VFRDIV_VF }, // 2186
  { PseudoVFRDIV_VF16_M4_E16, VFRDIV_VF }, // 2187
  { PseudoVFRDIV_VF16_M4_E16_MASK, VFRDIV_VF }, // 2188
  { PseudoVFRDIV_VF16_M4_E16_TU, VFRDIV_VF }, // 2189
  { PseudoVFRDIV_VF16_M4_E32, VFRDIV_VF }, // 2190
  { PseudoVFRDIV_VF16_M4_E32_MASK, VFRDIV_VF }, // 2191
  { PseudoVFRDIV_VF16_M4_E32_TU, VFRDIV_VF }, // 2192
  { PseudoVFRDIV_VF16_M4_E64, VFRDIV_VF }, // 2193
  { PseudoVFRDIV_VF16_M4_E64_MASK, VFRDIV_VF }, // 2194
  { PseudoVFRDIV_VF16_M4_E64_TU, VFRDIV_VF }, // 2195
  { PseudoVFRDIV_VF16_M8_E16, VFRDIV_VF }, // 2196
  { PseudoVFRDIV_VF16_M8_E16_MASK, VFRDIV_VF }, // 2197
  { PseudoVFRDIV_VF16_M8_E16_TU, VFRDIV_VF }, // 2198
  { PseudoVFRDIV_VF16_M8_E32, VFRDIV_VF }, // 2199
  { PseudoVFRDIV_VF16_M8_E32_MASK, VFRDIV_VF }, // 2200
  { PseudoVFRDIV_VF16_M8_E32_TU, VFRDIV_VF }, // 2201
  { PseudoVFRDIV_VF16_M8_E64, VFRDIV_VF }, // 2202
  { PseudoVFRDIV_VF16_M8_E64_MASK, VFRDIV_VF }, // 2203
  { PseudoVFRDIV_VF16_M8_E64_TU, VFRDIV_VF }, // 2204
  { PseudoVFRDIV_VF16_MF2_E16, VFRDIV_VF }, // 2205
  { PseudoVFRDIV_VF16_MF2_E16_MASK, VFRDIV_VF }, // 2206
  { PseudoVFRDIV_VF16_MF2_E16_TU, VFRDIV_VF }, // 2207
  { PseudoVFRDIV_VF16_MF2_E32, VFRDIV_VF }, // 2208
  { PseudoVFRDIV_VF16_MF2_E32_MASK, VFRDIV_VF }, // 2209
  { PseudoVFRDIV_VF16_MF2_E32_TU, VFRDIV_VF }, // 2210
  { PseudoVFRDIV_VF16_MF4_E16, VFRDIV_VF }, // 2211
  { PseudoVFRDIV_VF16_MF4_E16_MASK, VFRDIV_VF }, // 2212
  { PseudoVFRDIV_VF16_MF4_E16_TU, VFRDIV_VF }, // 2213
  { PseudoVFRDIV_VF32_M1_E16, VFRDIV_VF }, // 2214
  { PseudoVFRDIV_VF32_M1_E16_MASK, VFRDIV_VF }, // 2215
  { PseudoVFRDIV_VF32_M1_E16_TU, VFRDIV_VF }, // 2216
  { PseudoVFRDIV_VF32_M1_E32, VFRDIV_VF }, // 2217
  { PseudoVFRDIV_VF32_M1_E32_MASK, VFRDIV_VF }, // 2218
  { PseudoVFRDIV_VF32_M1_E32_TU, VFRDIV_VF }, // 2219
  { PseudoVFRDIV_VF32_M1_E64, VFRDIV_VF }, // 2220
  { PseudoVFRDIV_VF32_M1_E64_MASK, VFRDIV_VF }, // 2221
  { PseudoVFRDIV_VF32_M1_E64_TU, VFRDIV_VF }, // 2222
  { PseudoVFRDIV_VF32_M2_E16, VFRDIV_VF }, // 2223
  { PseudoVFRDIV_VF32_M2_E16_MASK, VFRDIV_VF }, // 2224
  { PseudoVFRDIV_VF32_M2_E16_TU, VFRDIV_VF }, // 2225
  { PseudoVFRDIV_VF32_M2_E32, VFRDIV_VF }, // 2226
  { PseudoVFRDIV_VF32_M2_E32_MASK, VFRDIV_VF }, // 2227
  { PseudoVFRDIV_VF32_M2_E32_TU, VFRDIV_VF }, // 2228
  { PseudoVFRDIV_VF32_M2_E64, VFRDIV_VF }, // 2229
  { PseudoVFRDIV_VF32_M2_E64_MASK, VFRDIV_VF }, // 2230
  { PseudoVFRDIV_VF32_M2_E64_TU, VFRDIV_VF }, // 2231
  { PseudoVFRDIV_VF32_M4_E16, VFRDIV_VF }, // 2232
  { PseudoVFRDIV_VF32_M4_E16_MASK, VFRDIV_VF }, // 2233
  { PseudoVFRDIV_VF32_M4_E16_TU, VFRDIV_VF }, // 2234
  { PseudoVFRDIV_VF32_M4_E32, VFRDIV_VF }, // 2235
  { PseudoVFRDIV_VF32_M4_E32_MASK, VFRDIV_VF }, // 2236
  { PseudoVFRDIV_VF32_M4_E32_TU, VFRDIV_VF }, // 2237
  { PseudoVFRDIV_VF32_M4_E64, VFRDIV_VF }, // 2238
  { PseudoVFRDIV_VF32_M4_E64_MASK, VFRDIV_VF }, // 2239
  { PseudoVFRDIV_VF32_M4_E64_TU, VFRDIV_VF }, // 2240
  { PseudoVFRDIV_VF32_M8_E16, VFRDIV_VF }, // 2241
  { PseudoVFRDIV_VF32_M8_E16_MASK, VFRDIV_VF }, // 2242
  { PseudoVFRDIV_VF32_M8_E16_TU, VFRDIV_VF }, // 2243
  { PseudoVFRDIV_VF32_M8_E32, VFRDIV_VF }, // 2244
  { PseudoVFRDIV_VF32_M8_E32_MASK, VFRDIV_VF }, // 2245
  { PseudoVFRDIV_VF32_M8_E32_TU, VFRDIV_VF }, // 2246
  { PseudoVFRDIV_VF32_M8_E64, VFRDIV_VF }, // 2247
  { PseudoVFRDIV_VF32_M8_E64_MASK, VFRDIV_VF }, // 2248
  { PseudoVFRDIV_VF32_M8_E64_TU, VFRDIV_VF }, // 2249
  { PseudoVFRDIV_VF32_MF2_E16, VFRDIV_VF }, // 2250
  { PseudoVFRDIV_VF32_MF2_E16_MASK, VFRDIV_VF }, // 2251
  { PseudoVFRDIV_VF32_MF2_E16_TU, VFRDIV_VF }, // 2252
  { PseudoVFRDIV_VF32_MF2_E32, VFRDIV_VF }, // 2253
  { PseudoVFRDIV_VF32_MF2_E32_MASK, VFRDIV_VF }, // 2254
  { PseudoVFRDIV_VF32_MF2_E32_TU, VFRDIV_VF }, // 2255
  { PseudoVFRDIV_VF64_M1_E16, VFRDIV_VF }, // 2256
  { PseudoVFRDIV_VF64_M1_E16_MASK, VFRDIV_VF }, // 2257
  { PseudoVFRDIV_VF64_M1_E16_TU, VFRDIV_VF }, // 2258
  { PseudoVFRDIV_VF64_M1_E32, VFRDIV_VF }, // 2259
  { PseudoVFRDIV_VF64_M1_E32_MASK, VFRDIV_VF }, // 2260
  { PseudoVFRDIV_VF64_M1_E32_TU, VFRDIV_VF }, // 2261
  { PseudoVFRDIV_VF64_M1_E64, VFRDIV_VF }, // 2262
  { PseudoVFRDIV_VF64_M1_E64_MASK, VFRDIV_VF }, // 2263
  { PseudoVFRDIV_VF64_M1_E64_TU, VFRDIV_VF }, // 2264
  { PseudoVFRDIV_VF64_M2_E16, VFRDIV_VF }, // 2265
  { PseudoVFRDIV_VF64_M2_E16_MASK, VFRDIV_VF }, // 2266
  { PseudoVFRDIV_VF64_M2_E16_TU, VFRDIV_VF }, // 2267
  { PseudoVFRDIV_VF64_M2_E32, VFRDIV_VF }, // 2268
  { PseudoVFRDIV_VF64_M2_E32_MASK, VFRDIV_VF }, // 2269
  { PseudoVFRDIV_VF64_M2_E32_TU, VFRDIV_VF }, // 2270
  { PseudoVFRDIV_VF64_M2_E64, VFRDIV_VF }, // 2271
  { PseudoVFRDIV_VF64_M2_E64_MASK, VFRDIV_VF }, // 2272
  { PseudoVFRDIV_VF64_M2_E64_TU, VFRDIV_VF }, // 2273
  { PseudoVFRDIV_VF64_M4_E16, VFRDIV_VF }, // 2274
  { PseudoVFRDIV_VF64_M4_E16_MASK, VFRDIV_VF }, // 2275
  { PseudoVFRDIV_VF64_M4_E16_TU, VFRDIV_VF }, // 2276
  { PseudoVFRDIV_VF64_M4_E32, VFRDIV_VF }, // 2277
  { PseudoVFRDIV_VF64_M4_E32_MASK, VFRDIV_VF }, // 2278
  { PseudoVFRDIV_VF64_M4_E32_TU, VFRDIV_VF }, // 2279
  { PseudoVFRDIV_VF64_M4_E64, VFRDIV_VF }, // 2280
  { PseudoVFRDIV_VF64_M4_E64_MASK, VFRDIV_VF }, // 2281
  { PseudoVFRDIV_VF64_M4_E64_TU, VFRDIV_VF }, // 2282
  { PseudoVFRDIV_VF64_M8_E16, VFRDIV_VF }, // 2283
  { PseudoVFRDIV_VF64_M8_E16_MASK, VFRDIV_VF }, // 2284
  { PseudoVFRDIV_VF64_M8_E16_TU, VFRDIV_VF }, // 2285
  { PseudoVFRDIV_VF64_M8_E32, VFRDIV_VF }, // 2286
  { PseudoVFRDIV_VF64_M8_E32_MASK, VFRDIV_VF }, // 2287
  { PseudoVFRDIV_VF64_M8_E32_TU, VFRDIV_VF }, // 2288
  { PseudoVFRDIV_VF64_M8_E64, VFRDIV_VF }, // 2289
  { PseudoVFRDIV_VF64_M8_E64_MASK, VFRDIV_VF }, // 2290
  { PseudoVFRDIV_VF64_M8_E64_TU, VFRDIV_VF }, // 2291
  { PseudoVFREC7_V_M1, VFREC7_V }, // 2292
  { PseudoVFREC7_V_M1_MASK, VFREC7_V }, // 2293
  { PseudoVFREC7_V_M1_TU, VFREC7_V }, // 2294
  { PseudoVFREC7_V_M2, VFREC7_V }, // 2295
  { PseudoVFREC7_V_M2_MASK, VFREC7_V }, // 2296
  { PseudoVFREC7_V_M2_TU, VFREC7_V }, // 2297
  { PseudoVFREC7_V_M4, VFREC7_V }, // 2298
  { PseudoVFREC7_V_M4_MASK, VFREC7_V }, // 2299
  { PseudoVFREC7_V_M4_TU, VFREC7_V }, // 2300
  { PseudoVFREC7_V_M8, VFREC7_V }, // 2301
  { PseudoVFREC7_V_M8_MASK, VFREC7_V }, // 2302
  { PseudoVFREC7_V_M8_TU, VFREC7_V }, // 2303
  { PseudoVFREC7_V_MF2, VFREC7_V }, // 2304
  { PseudoVFREC7_V_MF2_MASK, VFREC7_V }, // 2305
  { PseudoVFREC7_V_MF2_TU, VFREC7_V }, // 2306
  { PseudoVFREC7_V_MF4, VFREC7_V }, // 2307
  { PseudoVFREC7_V_MF4_MASK, VFREC7_V }, // 2308
  { PseudoVFREC7_V_MF4_TU, VFREC7_V }, // 2309
  { PseudoVFREDMAX_VS_M1_E16, VFREDMAX_VS }, // 2310
  { PseudoVFREDMAX_VS_M1_E16_MASK, VFREDMAX_VS }, // 2311
  { PseudoVFREDMAX_VS_M1_E32, VFREDMAX_VS }, // 2312
  { PseudoVFREDMAX_VS_M1_E32_MASK, VFREDMAX_VS }, // 2313
  { PseudoVFREDMAX_VS_M1_E64, VFREDMAX_VS }, // 2314
  { PseudoVFREDMAX_VS_M1_E64_MASK, VFREDMAX_VS }, // 2315
  { PseudoVFREDMAX_VS_M2_E16, VFREDMAX_VS }, // 2316
  { PseudoVFREDMAX_VS_M2_E16_MASK, VFREDMAX_VS }, // 2317
  { PseudoVFREDMAX_VS_M2_E32, VFREDMAX_VS }, // 2318
  { PseudoVFREDMAX_VS_M2_E32_MASK, VFREDMAX_VS }, // 2319
  { PseudoVFREDMAX_VS_M2_E64, VFREDMAX_VS }, // 2320
  { PseudoVFREDMAX_VS_M2_E64_MASK, VFREDMAX_VS }, // 2321
  { PseudoVFREDMAX_VS_M4_E16, VFREDMAX_VS }, // 2322
  { PseudoVFREDMAX_VS_M4_E16_MASK, VFREDMAX_VS }, // 2323
  { PseudoVFREDMAX_VS_M4_E32, VFREDMAX_VS }, // 2324
  { PseudoVFREDMAX_VS_M4_E32_MASK, VFREDMAX_VS }, // 2325
  { PseudoVFREDMAX_VS_M4_E64, VFREDMAX_VS }, // 2326
  { PseudoVFREDMAX_VS_M4_E64_MASK, VFREDMAX_VS }, // 2327
  { PseudoVFREDMAX_VS_M8_E16, VFREDMAX_VS }, // 2328
  { PseudoVFREDMAX_VS_M8_E16_MASK, VFREDMAX_VS }, // 2329
  { PseudoVFREDMAX_VS_M8_E32, VFREDMAX_VS }, // 2330
  { PseudoVFREDMAX_VS_M8_E32_MASK, VFREDMAX_VS }, // 2331
  { PseudoVFREDMAX_VS_M8_E64, VFREDMAX_VS }, // 2332
  { PseudoVFREDMAX_VS_M8_E64_MASK, VFREDMAX_VS }, // 2333
  { PseudoVFREDMAX_VS_MF2_E16, VFREDMAX_VS }, // 2334
  { PseudoVFREDMAX_VS_MF2_E16_MASK, VFREDMAX_VS }, // 2335
  { PseudoVFREDMAX_VS_MF2_E32, VFREDMAX_VS }, // 2336
  { PseudoVFREDMAX_VS_MF2_E32_MASK, VFREDMAX_VS }, // 2337
  { PseudoVFREDMAX_VS_MF4_E16, VFREDMAX_VS }, // 2338
  { PseudoVFREDMAX_VS_MF4_E16_MASK, VFREDMAX_VS }, // 2339
  { PseudoVFREDMIN_VS_M1_E16, VFREDMIN_VS }, // 2340
  { PseudoVFREDMIN_VS_M1_E16_MASK, VFREDMIN_VS }, // 2341
  { PseudoVFREDMIN_VS_M1_E32, VFREDMIN_VS }, // 2342
  { PseudoVFREDMIN_VS_M1_E32_MASK, VFREDMIN_VS }, // 2343
  { PseudoVFREDMIN_VS_M1_E64, VFREDMIN_VS }, // 2344
  { PseudoVFREDMIN_VS_M1_E64_MASK, VFREDMIN_VS }, // 2345
  { PseudoVFREDMIN_VS_M2_E16, VFREDMIN_VS }, // 2346
  { PseudoVFREDMIN_VS_M2_E16_MASK, VFREDMIN_VS }, // 2347
  { PseudoVFREDMIN_VS_M2_E32, VFREDMIN_VS }, // 2348
  { PseudoVFREDMIN_VS_M2_E32_MASK, VFREDMIN_VS }, // 2349
  { PseudoVFREDMIN_VS_M2_E64, VFREDMIN_VS }, // 2350
  { PseudoVFREDMIN_VS_M2_E64_MASK, VFREDMIN_VS }, // 2351
  { PseudoVFREDMIN_VS_M4_E16, VFREDMIN_VS }, // 2352
  { PseudoVFREDMIN_VS_M4_E16_MASK, VFREDMIN_VS }, // 2353
  { PseudoVFREDMIN_VS_M4_E32, VFREDMIN_VS }, // 2354
  { PseudoVFREDMIN_VS_M4_E32_MASK, VFREDMIN_VS }, // 2355
  { PseudoVFREDMIN_VS_M4_E64, VFREDMIN_VS }, // 2356
  { PseudoVFREDMIN_VS_M4_E64_MASK, VFREDMIN_VS }, // 2357
  { PseudoVFREDMIN_VS_M8_E16, VFREDMIN_VS }, // 2358
  { PseudoVFREDMIN_VS_M8_E16_MASK, VFREDMIN_VS }, // 2359
  { PseudoVFREDMIN_VS_M8_E32, VFREDMIN_VS }, // 2360
  { PseudoVFREDMIN_VS_M8_E32_MASK, VFREDMIN_VS }, // 2361
  { PseudoVFREDMIN_VS_M8_E64, VFREDMIN_VS }, // 2362
  { PseudoVFREDMIN_VS_M8_E64_MASK, VFREDMIN_VS }, // 2363
  { PseudoVFREDMIN_VS_MF2_E16, VFREDMIN_VS }, // 2364
  { PseudoVFREDMIN_VS_MF2_E16_MASK, VFREDMIN_VS }, // 2365
  { PseudoVFREDMIN_VS_MF2_E32, VFREDMIN_VS }, // 2366
  { PseudoVFREDMIN_VS_MF2_E32_MASK, VFREDMIN_VS }, // 2367
  { PseudoVFREDMIN_VS_MF4_E16, VFREDMIN_VS }, // 2368
  { PseudoVFREDMIN_VS_MF4_E16_MASK, VFREDMIN_VS }, // 2369
  { PseudoVFREDOSUM_VS_M1_E16, VFREDOSUM_VS }, // 2370
  { PseudoVFREDOSUM_VS_M1_E16_MASK, VFREDOSUM_VS }, // 2371
  { PseudoVFREDOSUM_VS_M1_E32, VFREDOSUM_VS }, // 2372
  { PseudoVFREDOSUM_VS_M1_E32_MASK, VFREDOSUM_VS }, // 2373
  { PseudoVFREDOSUM_VS_M1_E64, VFREDOSUM_VS }, // 2374
  { PseudoVFREDOSUM_VS_M1_E64_MASK, VFREDOSUM_VS }, // 2375
  { PseudoVFREDOSUM_VS_M2_E16, VFREDOSUM_VS }, // 2376
  { PseudoVFREDOSUM_VS_M2_E16_MASK, VFREDOSUM_VS }, // 2377
  { PseudoVFREDOSUM_VS_M2_E32, VFREDOSUM_VS }, // 2378
  { PseudoVFREDOSUM_VS_M2_E32_MASK, VFREDOSUM_VS }, // 2379
  { PseudoVFREDOSUM_VS_M2_E64, VFREDOSUM_VS }, // 2380
  { PseudoVFREDOSUM_VS_M2_E64_MASK, VFREDOSUM_VS }, // 2381
  { PseudoVFREDOSUM_VS_M4_E16, VFREDOSUM_VS }, // 2382
  { PseudoVFREDOSUM_VS_M4_E16_MASK, VFREDOSUM_VS }, // 2383
  { PseudoVFREDOSUM_VS_M4_E32, VFREDOSUM_VS }, // 2384
  { PseudoVFREDOSUM_VS_M4_E32_MASK, VFREDOSUM_VS }, // 2385
  { PseudoVFREDOSUM_VS_M4_E64, VFREDOSUM_VS }, // 2386
  { PseudoVFREDOSUM_VS_M4_E64_MASK, VFREDOSUM_VS }, // 2387
  { PseudoVFREDOSUM_VS_M8_E16, VFREDOSUM_VS }, // 2388
  { PseudoVFREDOSUM_VS_M8_E16_MASK, VFREDOSUM_VS }, // 2389
  { PseudoVFREDOSUM_VS_M8_E32, VFREDOSUM_VS }, // 2390
  { PseudoVFREDOSUM_VS_M8_E32_MASK, VFREDOSUM_VS }, // 2391
  { PseudoVFREDOSUM_VS_M8_E64, VFREDOSUM_VS }, // 2392
  { PseudoVFREDOSUM_VS_M8_E64_MASK, VFREDOSUM_VS }, // 2393
  { PseudoVFREDOSUM_VS_MF2_E16, VFREDOSUM_VS }, // 2394
  { PseudoVFREDOSUM_VS_MF2_E16_MASK, VFREDOSUM_VS }, // 2395
  { PseudoVFREDOSUM_VS_MF2_E32, VFREDOSUM_VS }, // 2396
  { PseudoVFREDOSUM_VS_MF2_E32_MASK, VFREDOSUM_VS }, // 2397
  { PseudoVFREDOSUM_VS_MF4_E16, VFREDOSUM_VS }, // 2398
  { PseudoVFREDOSUM_VS_MF4_E16_MASK, VFREDOSUM_VS }, // 2399
  { PseudoVFREDUSUM_VS_M1_E16, VFREDUSUM_VS }, // 2400
  { PseudoVFREDUSUM_VS_M1_E16_MASK, VFREDUSUM_VS }, // 2401
  { PseudoVFREDUSUM_VS_M1_E32, VFREDUSUM_VS }, // 2402
  { PseudoVFREDUSUM_VS_M1_E32_MASK, VFREDUSUM_VS }, // 2403
  { PseudoVFREDUSUM_VS_M1_E64, VFREDUSUM_VS }, // 2404
  { PseudoVFREDUSUM_VS_M1_E64_MASK, VFREDUSUM_VS }, // 2405
  { PseudoVFREDUSUM_VS_M2_E16, VFREDUSUM_VS }, // 2406
  { PseudoVFREDUSUM_VS_M2_E16_MASK, VFREDUSUM_VS }, // 2407
  { PseudoVFREDUSUM_VS_M2_E32, VFREDUSUM_VS }, // 2408
  { PseudoVFREDUSUM_VS_M2_E32_MASK, VFREDUSUM_VS }, // 2409
  { PseudoVFREDUSUM_VS_M2_E64, VFREDUSUM_VS }, // 2410
  { PseudoVFREDUSUM_VS_M2_E64_MASK, VFREDUSUM_VS }, // 2411
  { PseudoVFREDUSUM_VS_M4_E16, VFREDUSUM_VS }, // 2412
  { PseudoVFREDUSUM_VS_M4_E16_MASK, VFREDUSUM_VS }, // 2413
  { PseudoVFREDUSUM_VS_M4_E32, VFREDUSUM_VS }, // 2414
  { PseudoVFREDUSUM_VS_M4_E32_MASK, VFREDUSUM_VS }, // 2415
  { PseudoVFREDUSUM_VS_M4_E64, VFREDUSUM_VS }, // 2416
  { PseudoVFREDUSUM_VS_M4_E64_MASK, VFREDUSUM_VS }, // 2417
  { PseudoVFREDUSUM_VS_M8_E16, VFREDUSUM_VS }, // 2418
  { PseudoVFREDUSUM_VS_M8_E16_MASK, VFREDUSUM_VS }, // 2419
  { PseudoVFREDUSUM_VS_M8_E32, VFREDUSUM_VS }, // 2420
  { PseudoVFREDUSUM_VS_M8_E32_MASK, VFREDUSUM_VS }, // 2421
  { PseudoVFREDUSUM_VS_M8_E64, VFREDUSUM_VS }, // 2422
  { PseudoVFREDUSUM_VS_M8_E64_MASK, VFREDUSUM_VS }, // 2423
  { PseudoVFREDUSUM_VS_MF2_E16, VFREDUSUM_VS }, // 2424
  { PseudoVFREDUSUM_VS_MF2_E16_MASK, VFREDUSUM_VS }, // 2425
  { PseudoVFREDUSUM_VS_MF2_E32, VFREDUSUM_VS }, // 2426
  { PseudoVFREDUSUM_VS_MF2_E32_MASK, VFREDUSUM_VS }, // 2427
  { PseudoVFREDUSUM_VS_MF4_E16, VFREDUSUM_VS }, // 2428
  { PseudoVFREDUSUM_VS_MF4_E16_MASK, VFREDUSUM_VS }, // 2429
  { PseudoVFRSQRT7_V_M1, VFRSQRT7_V }, // 2430
  { PseudoVFRSQRT7_V_M1_MASK, VFRSQRT7_V }, // 2431
  { PseudoVFRSQRT7_V_M1_TU, VFRSQRT7_V }, // 2432
  { PseudoVFRSQRT7_V_M2, VFRSQRT7_V }, // 2433
  { PseudoVFRSQRT7_V_M2_MASK, VFRSQRT7_V }, // 2434
  { PseudoVFRSQRT7_V_M2_TU, VFRSQRT7_V }, // 2435
  { PseudoVFRSQRT7_V_M4, VFRSQRT7_V }, // 2436
  { PseudoVFRSQRT7_V_M4_MASK, VFRSQRT7_V }, // 2437
  { PseudoVFRSQRT7_V_M4_TU, VFRSQRT7_V }, // 2438
  { PseudoVFRSQRT7_V_M8, VFRSQRT7_V }, // 2439
  { PseudoVFRSQRT7_V_M8_MASK, VFRSQRT7_V }, // 2440
  { PseudoVFRSQRT7_V_M8_TU, VFRSQRT7_V }, // 2441
  { PseudoVFRSQRT7_V_MF2, VFRSQRT7_V }, // 2442
  { PseudoVFRSQRT7_V_MF2_MASK, VFRSQRT7_V }, // 2443
  { PseudoVFRSQRT7_V_MF2_TU, VFRSQRT7_V }, // 2444
  { PseudoVFRSQRT7_V_MF4, VFRSQRT7_V }, // 2445
  { PseudoVFRSQRT7_V_MF4_MASK, VFRSQRT7_V }, // 2446
  { PseudoVFRSQRT7_V_MF4_TU, VFRSQRT7_V }, // 2447
  { PseudoVFRSUB_VF16_M1, VFRSUB_VF }, // 2448
  { PseudoVFRSUB_VF16_M1_MASK, VFRSUB_VF }, // 2449
  { PseudoVFRSUB_VF16_M1_TU, VFRSUB_VF }, // 2450
  { PseudoVFRSUB_VF16_M2, VFRSUB_VF }, // 2451
  { PseudoVFRSUB_VF16_M2_MASK, VFRSUB_VF }, // 2452
  { PseudoVFRSUB_VF16_M2_TU, VFRSUB_VF }, // 2453
  { PseudoVFRSUB_VF16_M4, VFRSUB_VF }, // 2454
  { PseudoVFRSUB_VF16_M4_MASK, VFRSUB_VF }, // 2455
  { PseudoVFRSUB_VF16_M4_TU, VFRSUB_VF }, // 2456
  { PseudoVFRSUB_VF16_M8, VFRSUB_VF }, // 2457
  { PseudoVFRSUB_VF16_M8_MASK, VFRSUB_VF }, // 2458
  { PseudoVFRSUB_VF16_M8_TU, VFRSUB_VF }, // 2459
  { PseudoVFRSUB_VF16_MF2, VFRSUB_VF }, // 2460
  { PseudoVFRSUB_VF16_MF2_MASK, VFRSUB_VF }, // 2461
  { PseudoVFRSUB_VF16_MF2_TU, VFRSUB_VF }, // 2462
  { PseudoVFRSUB_VF16_MF4, VFRSUB_VF }, // 2463
  { PseudoVFRSUB_VF16_MF4_MASK, VFRSUB_VF }, // 2464
  { PseudoVFRSUB_VF16_MF4_TU, VFRSUB_VF }, // 2465
  { PseudoVFRSUB_VF32_M1, VFRSUB_VF }, // 2466
  { PseudoVFRSUB_VF32_M1_MASK, VFRSUB_VF }, // 2467
  { PseudoVFRSUB_VF32_M1_TU, VFRSUB_VF }, // 2468
  { PseudoVFRSUB_VF32_M2, VFRSUB_VF }, // 2469
  { PseudoVFRSUB_VF32_M2_MASK, VFRSUB_VF }, // 2470
  { PseudoVFRSUB_VF32_M2_TU, VFRSUB_VF }, // 2471
  { PseudoVFRSUB_VF32_M4, VFRSUB_VF }, // 2472
  { PseudoVFRSUB_VF32_M4_MASK, VFRSUB_VF }, // 2473
  { PseudoVFRSUB_VF32_M4_TU, VFRSUB_VF }, // 2474
  { PseudoVFRSUB_VF32_M8, VFRSUB_VF }, // 2475
  { PseudoVFRSUB_VF32_M8_MASK, VFRSUB_VF }, // 2476
  { PseudoVFRSUB_VF32_M8_TU, VFRSUB_VF }, // 2477
  { PseudoVFRSUB_VF32_MF2, VFRSUB_VF }, // 2478
  { PseudoVFRSUB_VF32_MF2_MASK, VFRSUB_VF }, // 2479
  { PseudoVFRSUB_VF32_MF2_TU, VFRSUB_VF }, // 2480
  { PseudoVFRSUB_VF64_M1, VFRSUB_VF }, // 2481
  { PseudoVFRSUB_VF64_M1_MASK, VFRSUB_VF }, // 2482
  { PseudoVFRSUB_VF64_M1_TU, VFRSUB_VF }, // 2483
  { PseudoVFRSUB_VF64_M2, VFRSUB_VF }, // 2484
  { PseudoVFRSUB_VF64_M2_MASK, VFRSUB_VF }, // 2485
  { PseudoVFRSUB_VF64_M2_TU, VFRSUB_VF }, // 2486
  { PseudoVFRSUB_VF64_M4, VFRSUB_VF }, // 2487
  { PseudoVFRSUB_VF64_M4_MASK, VFRSUB_VF }, // 2488
  { PseudoVFRSUB_VF64_M4_TU, VFRSUB_VF }, // 2489
  { PseudoVFRSUB_VF64_M8, VFRSUB_VF }, // 2490
  { PseudoVFRSUB_VF64_M8_MASK, VFRSUB_VF }, // 2491
  { PseudoVFRSUB_VF64_M8_TU, VFRSUB_VF }, // 2492
  { PseudoVFSGNJN_VF16_M1, VFSGNJN_VF }, // 2493
  { PseudoVFSGNJN_VF16_M1_MASK, VFSGNJN_VF }, // 2494
  { PseudoVFSGNJN_VF16_M1_TU, VFSGNJN_VF }, // 2495
  { PseudoVFSGNJN_VF16_M2, VFSGNJN_VF }, // 2496
  { PseudoVFSGNJN_VF16_M2_MASK, VFSGNJN_VF }, // 2497
  { PseudoVFSGNJN_VF16_M2_TU, VFSGNJN_VF }, // 2498
  { PseudoVFSGNJN_VF16_M4, VFSGNJN_VF }, // 2499
  { PseudoVFSGNJN_VF16_M4_MASK, VFSGNJN_VF }, // 2500
  { PseudoVFSGNJN_VF16_M4_TU, VFSGNJN_VF }, // 2501
  { PseudoVFSGNJN_VF16_M8, VFSGNJN_VF }, // 2502
  { PseudoVFSGNJN_VF16_M8_MASK, VFSGNJN_VF }, // 2503
  { PseudoVFSGNJN_VF16_M8_TU, VFSGNJN_VF }, // 2504
  { PseudoVFSGNJN_VF16_MF2, VFSGNJN_VF }, // 2505
  { PseudoVFSGNJN_VF16_MF2_MASK, VFSGNJN_VF }, // 2506
  { PseudoVFSGNJN_VF16_MF2_TU, VFSGNJN_VF }, // 2507
  { PseudoVFSGNJN_VF16_MF4, VFSGNJN_VF }, // 2508
  { PseudoVFSGNJN_VF16_MF4_MASK, VFSGNJN_VF }, // 2509
  { PseudoVFSGNJN_VF16_MF4_TU, VFSGNJN_VF }, // 2510
  { PseudoVFSGNJN_VF32_M1, VFSGNJN_VF }, // 2511
  { PseudoVFSGNJN_VF32_M1_MASK, VFSGNJN_VF }, // 2512
  { PseudoVFSGNJN_VF32_M1_TU, VFSGNJN_VF }, // 2513
  { PseudoVFSGNJN_VF32_M2, VFSGNJN_VF }, // 2514
  { PseudoVFSGNJN_VF32_M2_MASK, VFSGNJN_VF }, // 2515
  { PseudoVFSGNJN_VF32_M2_TU, VFSGNJN_VF }, // 2516
  { PseudoVFSGNJN_VF32_M4, VFSGNJN_VF }, // 2517
  { PseudoVFSGNJN_VF32_M4_MASK, VFSGNJN_VF }, // 2518
  { PseudoVFSGNJN_VF32_M4_TU, VFSGNJN_VF }, // 2519
  { PseudoVFSGNJN_VF32_M8, VFSGNJN_VF }, // 2520
  { PseudoVFSGNJN_VF32_M8_MASK, VFSGNJN_VF }, // 2521
  { PseudoVFSGNJN_VF32_M8_TU, VFSGNJN_VF }, // 2522
  { PseudoVFSGNJN_VF32_MF2, VFSGNJN_VF }, // 2523
  { PseudoVFSGNJN_VF32_MF2_MASK, VFSGNJN_VF }, // 2524
  { PseudoVFSGNJN_VF32_MF2_TU, VFSGNJN_VF }, // 2525
  { PseudoVFSGNJN_VF64_M1, VFSGNJN_VF }, // 2526
  { PseudoVFSGNJN_VF64_M1_MASK, VFSGNJN_VF }, // 2527
  { PseudoVFSGNJN_VF64_M1_TU, VFSGNJN_VF }, // 2528
  { PseudoVFSGNJN_VF64_M2, VFSGNJN_VF }, // 2529
  { PseudoVFSGNJN_VF64_M2_MASK, VFSGNJN_VF }, // 2530
  { PseudoVFSGNJN_VF64_M2_TU, VFSGNJN_VF }, // 2531
  { PseudoVFSGNJN_VF64_M4, VFSGNJN_VF }, // 2532
  { PseudoVFSGNJN_VF64_M4_MASK, VFSGNJN_VF }, // 2533
  { PseudoVFSGNJN_VF64_M4_TU, VFSGNJN_VF }, // 2534
  { PseudoVFSGNJN_VF64_M8, VFSGNJN_VF }, // 2535
  { PseudoVFSGNJN_VF64_M8_MASK, VFSGNJN_VF }, // 2536
  { PseudoVFSGNJN_VF64_M8_TU, VFSGNJN_VF }, // 2537
  { PseudoVFSGNJN_VV_M1, VFSGNJN_VV }, // 2538
  { PseudoVFSGNJN_VV_M1_MASK, VFSGNJN_VV }, // 2539
  { PseudoVFSGNJN_VV_M1_TU, VFSGNJN_VV }, // 2540
  { PseudoVFSGNJN_VV_M2, VFSGNJN_VV }, // 2541
  { PseudoVFSGNJN_VV_M2_MASK, VFSGNJN_VV }, // 2542
  { PseudoVFSGNJN_VV_M2_TU, VFSGNJN_VV }, // 2543
  { PseudoVFSGNJN_VV_M4, VFSGNJN_VV }, // 2544
  { PseudoVFSGNJN_VV_M4_MASK, VFSGNJN_VV }, // 2545
  { PseudoVFSGNJN_VV_M4_TU, VFSGNJN_VV }, // 2546
  { PseudoVFSGNJN_VV_M8, VFSGNJN_VV }, // 2547
  { PseudoVFSGNJN_VV_M8_MASK, VFSGNJN_VV }, // 2548
  { PseudoVFSGNJN_VV_M8_TU, VFSGNJN_VV }, // 2549
  { PseudoVFSGNJN_VV_MF2, VFSGNJN_VV }, // 2550
  { PseudoVFSGNJN_VV_MF2_MASK, VFSGNJN_VV }, // 2551
  { PseudoVFSGNJN_VV_MF2_TU, VFSGNJN_VV }, // 2552
  { PseudoVFSGNJN_VV_MF4, VFSGNJN_VV }, // 2553
  { PseudoVFSGNJN_VV_MF4_MASK, VFSGNJN_VV }, // 2554
  { PseudoVFSGNJN_VV_MF4_TU, VFSGNJN_VV }, // 2555
  { PseudoVFSGNJX_VF16_M1, VFSGNJX_VF }, // 2556
  { PseudoVFSGNJX_VF16_M1_MASK, VFSGNJX_VF }, // 2557
  { PseudoVFSGNJX_VF16_M1_TU, VFSGNJX_VF }, // 2558
  { PseudoVFSGNJX_VF16_M2, VFSGNJX_VF }, // 2559
  { PseudoVFSGNJX_VF16_M2_MASK, VFSGNJX_VF }, // 2560
  { PseudoVFSGNJX_VF16_M2_TU, VFSGNJX_VF }, // 2561
  { PseudoVFSGNJX_VF16_M4, VFSGNJX_VF }, // 2562
  { PseudoVFSGNJX_VF16_M4_MASK, VFSGNJX_VF }, // 2563
  { PseudoVFSGNJX_VF16_M4_TU, VFSGNJX_VF }, // 2564
  { PseudoVFSGNJX_VF16_M8, VFSGNJX_VF }, // 2565
  { PseudoVFSGNJX_VF16_M8_MASK, VFSGNJX_VF }, // 2566
  { PseudoVFSGNJX_VF16_M8_TU, VFSGNJX_VF }, // 2567
  { PseudoVFSGNJX_VF16_MF2, VFSGNJX_VF }, // 2568
  { PseudoVFSGNJX_VF16_MF2_MASK, VFSGNJX_VF }, // 2569
  { PseudoVFSGNJX_VF16_MF2_TU, VFSGNJX_VF }, // 2570
  { PseudoVFSGNJX_VF16_MF4, VFSGNJX_VF }, // 2571
  { PseudoVFSGNJX_VF16_MF4_MASK, VFSGNJX_VF }, // 2572
  { PseudoVFSGNJX_VF16_MF4_TU, VFSGNJX_VF }, // 2573
  { PseudoVFSGNJX_VF32_M1, VFSGNJX_VF }, // 2574
  { PseudoVFSGNJX_VF32_M1_MASK, VFSGNJX_VF }, // 2575
  { PseudoVFSGNJX_VF32_M1_TU, VFSGNJX_VF }, // 2576
  { PseudoVFSGNJX_VF32_M2, VFSGNJX_VF }, // 2577
  { PseudoVFSGNJX_VF32_M2_MASK, VFSGNJX_VF }, // 2578
  { PseudoVFSGNJX_VF32_M2_TU, VFSGNJX_VF }, // 2579
  { PseudoVFSGNJX_VF32_M4, VFSGNJX_VF }, // 2580
  { PseudoVFSGNJX_VF32_M4_MASK, VFSGNJX_VF }, // 2581
  { PseudoVFSGNJX_VF32_M4_TU, VFSGNJX_VF }, // 2582
  { PseudoVFSGNJX_VF32_M8, VFSGNJX_VF }, // 2583
  { PseudoVFSGNJX_VF32_M8_MASK, VFSGNJX_VF }, // 2584
  { PseudoVFSGNJX_VF32_M8_TU, VFSGNJX_VF }, // 2585
  { PseudoVFSGNJX_VF32_MF2, VFSGNJX_VF }, // 2586
  { PseudoVFSGNJX_VF32_MF2_MASK, VFSGNJX_VF }, // 2587
  { PseudoVFSGNJX_VF32_MF2_TU, VFSGNJX_VF }, // 2588
  { PseudoVFSGNJX_VF64_M1, VFSGNJX_VF }, // 2589
  { PseudoVFSGNJX_VF64_M1_MASK, VFSGNJX_VF }, // 2590
  { PseudoVFSGNJX_VF64_M1_TU, VFSGNJX_VF }, // 2591
  { PseudoVFSGNJX_VF64_M2, VFSGNJX_VF }, // 2592
  { PseudoVFSGNJX_VF64_M2_MASK, VFSGNJX_VF }, // 2593
  { PseudoVFSGNJX_VF64_M2_TU, VFSGNJX_VF }, // 2594
  { PseudoVFSGNJX_VF64_M4, VFSGNJX_VF }, // 2595
  { PseudoVFSGNJX_VF64_M4_MASK, VFSGNJX_VF }, // 2596
  { PseudoVFSGNJX_VF64_M4_TU, VFSGNJX_VF }, // 2597
  { PseudoVFSGNJX_VF64_M8, VFSGNJX_VF }, // 2598
  { PseudoVFSGNJX_VF64_M8_MASK, VFSGNJX_VF }, // 2599
  { PseudoVFSGNJX_VF64_M8_TU, VFSGNJX_VF }, // 2600
  { PseudoVFSGNJX_VV_M1, VFSGNJX_VV }, // 2601
  { PseudoVFSGNJX_VV_M1_MASK, VFSGNJX_VV }, // 2602
  { PseudoVFSGNJX_VV_M1_TU, VFSGNJX_VV }, // 2603
  { PseudoVFSGNJX_VV_M2, VFSGNJX_VV }, // 2604
  { PseudoVFSGNJX_VV_M2_MASK, VFSGNJX_VV }, // 2605
  { PseudoVFSGNJX_VV_M2_TU, VFSGNJX_VV }, // 2606
  { PseudoVFSGNJX_VV_M4, VFSGNJX_VV }, // 2607
  { PseudoVFSGNJX_VV_M4_MASK, VFSGNJX_VV }, // 2608
  { PseudoVFSGNJX_VV_M4_TU, VFSGNJX_VV }, // 2609
  { PseudoVFSGNJX_VV_M8, VFSGNJX_VV }, // 2610
  { PseudoVFSGNJX_VV_M8_MASK, VFSGNJX_VV }, // 2611
  { PseudoVFSGNJX_VV_M8_TU, VFSGNJX_VV }, // 2612
  { PseudoVFSGNJX_VV_MF2, VFSGNJX_VV }, // 2613
  { PseudoVFSGNJX_VV_MF2_MASK, VFSGNJX_VV }, // 2614
  { PseudoVFSGNJX_VV_MF2_TU, VFSGNJX_VV }, // 2615
  { PseudoVFSGNJX_VV_MF4, VFSGNJX_VV }, // 2616
  { PseudoVFSGNJX_VV_MF4_MASK, VFSGNJX_VV }, // 2617
  { PseudoVFSGNJX_VV_MF4_TU, VFSGNJX_VV }, // 2618
  { PseudoVFSGNJ_VF16_M1, VFSGNJ_VF }, // 2619
  { PseudoVFSGNJ_VF16_M1_MASK, VFSGNJ_VF }, // 2620
  { PseudoVFSGNJ_VF16_M1_TU, VFSGNJ_VF }, // 2621
  { PseudoVFSGNJ_VF16_M2, VFSGNJ_VF }, // 2622
  { PseudoVFSGNJ_VF16_M2_MASK, VFSGNJ_VF }, // 2623
  { PseudoVFSGNJ_VF16_M2_TU, VFSGNJ_VF }, // 2624
  { PseudoVFSGNJ_VF16_M4, VFSGNJ_VF }, // 2625
  { PseudoVFSGNJ_VF16_M4_MASK, VFSGNJ_VF }, // 2626
  { PseudoVFSGNJ_VF16_M4_TU, VFSGNJ_VF }, // 2627
  { PseudoVFSGNJ_VF16_M8, VFSGNJ_VF }, // 2628
  { PseudoVFSGNJ_VF16_M8_MASK, VFSGNJ_VF }, // 2629
  { PseudoVFSGNJ_VF16_M8_TU, VFSGNJ_VF }, // 2630
  { PseudoVFSGNJ_VF16_MF2, VFSGNJ_VF }, // 2631
  { PseudoVFSGNJ_VF16_MF2_MASK, VFSGNJ_VF }, // 2632
  { PseudoVFSGNJ_VF16_MF2_TU, VFSGNJ_VF }, // 2633
  { PseudoVFSGNJ_VF16_MF4, VFSGNJ_VF }, // 2634
  { PseudoVFSGNJ_VF16_MF4_MASK, VFSGNJ_VF }, // 2635
  { PseudoVFSGNJ_VF16_MF4_TU, VFSGNJ_VF }, // 2636
  { PseudoVFSGNJ_VF32_M1, VFSGNJ_VF }, // 2637
  { PseudoVFSGNJ_VF32_M1_MASK, VFSGNJ_VF }, // 2638
  { PseudoVFSGNJ_VF32_M1_TU, VFSGNJ_VF }, // 2639
  { PseudoVFSGNJ_VF32_M2, VFSGNJ_VF }, // 2640
  { PseudoVFSGNJ_VF32_M2_MASK, VFSGNJ_VF }, // 2641
  { PseudoVFSGNJ_VF32_M2_TU, VFSGNJ_VF }, // 2642
  { PseudoVFSGNJ_VF32_M4, VFSGNJ_VF }, // 2643
  { PseudoVFSGNJ_VF32_M4_MASK, VFSGNJ_VF }, // 2644
  { PseudoVFSGNJ_VF32_M4_TU, VFSGNJ_VF }, // 2645
  { PseudoVFSGNJ_VF32_M8, VFSGNJ_VF }, // 2646
  { PseudoVFSGNJ_VF32_M8_MASK, VFSGNJ_VF }, // 2647
  { PseudoVFSGNJ_VF32_M8_TU, VFSGNJ_VF }, // 2648
  { PseudoVFSGNJ_VF32_MF2, VFSGNJ_VF }, // 2649
  { PseudoVFSGNJ_VF32_MF2_MASK, VFSGNJ_VF }, // 2650
  { PseudoVFSGNJ_VF32_MF2_TU, VFSGNJ_VF }, // 2651
  { PseudoVFSGNJ_VF64_M1, VFSGNJ_VF }, // 2652
  { PseudoVFSGNJ_VF64_M1_MASK, VFSGNJ_VF }, // 2653
  { PseudoVFSGNJ_VF64_M1_TU, VFSGNJ_VF }, // 2654
  { PseudoVFSGNJ_VF64_M2, VFSGNJ_VF }, // 2655
  { PseudoVFSGNJ_VF64_M2_MASK, VFSGNJ_VF }, // 2656
  { PseudoVFSGNJ_VF64_M2_TU, VFSGNJ_VF }, // 2657
  { PseudoVFSGNJ_VF64_M4, VFSGNJ_VF }, // 2658
  { PseudoVFSGNJ_VF64_M4_MASK, VFSGNJ_VF }, // 2659
  { PseudoVFSGNJ_VF64_M4_TU, VFSGNJ_VF }, // 2660
  { PseudoVFSGNJ_VF64_M8, VFSGNJ_VF }, // 2661
  { PseudoVFSGNJ_VF64_M8_MASK, VFSGNJ_VF }, // 2662
  { PseudoVFSGNJ_VF64_M8_TU, VFSGNJ_VF }, // 2663
  { PseudoVFSGNJ_VV_M1, VFSGNJ_VV }, // 2664
  { PseudoVFSGNJ_VV_M1_MASK, VFSGNJ_VV }, // 2665
  { PseudoVFSGNJ_VV_M1_TU, VFSGNJ_VV }, // 2666
  { PseudoVFSGNJ_VV_M2, VFSGNJ_VV }, // 2667
  { PseudoVFSGNJ_VV_M2_MASK, VFSGNJ_VV }, // 2668
  { PseudoVFSGNJ_VV_M2_TU, VFSGNJ_VV }, // 2669
  { PseudoVFSGNJ_VV_M4, VFSGNJ_VV }, // 2670
  { PseudoVFSGNJ_VV_M4_MASK, VFSGNJ_VV }, // 2671
  { PseudoVFSGNJ_VV_M4_TU, VFSGNJ_VV }, // 2672
  { PseudoVFSGNJ_VV_M8, VFSGNJ_VV }, // 2673
  { PseudoVFSGNJ_VV_M8_MASK, VFSGNJ_VV }, // 2674
  { PseudoVFSGNJ_VV_M8_TU, VFSGNJ_VV }, // 2675
  { PseudoVFSGNJ_VV_MF2, VFSGNJ_VV }, // 2676
  { PseudoVFSGNJ_VV_MF2_MASK, VFSGNJ_VV }, // 2677
  { PseudoVFSGNJ_VV_MF2_TU, VFSGNJ_VV }, // 2678
  { PseudoVFSGNJ_VV_MF4, VFSGNJ_VV }, // 2679
  { PseudoVFSGNJ_VV_MF4_MASK, VFSGNJ_VV }, // 2680
  { PseudoVFSGNJ_VV_MF4_TU, VFSGNJ_VV }, // 2681
  { PseudoVFSLIDE1DOWN_VF16_M1, VFSLIDE1DOWN_VF }, // 2682
  { PseudoVFSLIDE1DOWN_VF16_M1_MASK, VFSLIDE1DOWN_VF }, // 2683
  { PseudoVFSLIDE1DOWN_VF16_M1_TU, VFSLIDE1DOWN_VF }, // 2684
  { PseudoVFSLIDE1DOWN_VF16_M2, VFSLIDE1DOWN_VF }, // 2685
  { PseudoVFSLIDE1DOWN_VF16_M2_MASK, VFSLIDE1DOWN_VF }, // 2686
  { PseudoVFSLIDE1DOWN_VF16_M2_TU, VFSLIDE1DOWN_VF }, // 2687
  { PseudoVFSLIDE1DOWN_VF16_M4, VFSLIDE1DOWN_VF }, // 2688
  { PseudoVFSLIDE1DOWN_VF16_M4_MASK, VFSLIDE1DOWN_VF }, // 2689
  { PseudoVFSLIDE1DOWN_VF16_M4_TU, VFSLIDE1DOWN_VF }, // 2690
  { PseudoVFSLIDE1DOWN_VF16_M8, VFSLIDE1DOWN_VF }, // 2691
  { PseudoVFSLIDE1DOWN_VF16_M8_MASK, VFSLIDE1DOWN_VF }, // 2692
  { PseudoVFSLIDE1DOWN_VF16_M8_TU, VFSLIDE1DOWN_VF }, // 2693
  { PseudoVFSLIDE1DOWN_VF16_MF2, VFSLIDE1DOWN_VF }, // 2694
  { PseudoVFSLIDE1DOWN_VF16_MF2_MASK, VFSLIDE1DOWN_VF }, // 2695
  { PseudoVFSLIDE1DOWN_VF16_MF2_TU, VFSLIDE1DOWN_VF }, // 2696
  { PseudoVFSLIDE1DOWN_VF16_MF4, VFSLIDE1DOWN_VF }, // 2697
  { PseudoVFSLIDE1DOWN_VF16_MF4_MASK, VFSLIDE1DOWN_VF }, // 2698
  { PseudoVFSLIDE1DOWN_VF16_MF4_TU, VFSLIDE1DOWN_VF }, // 2699
  { PseudoVFSLIDE1DOWN_VF32_M1, VFSLIDE1DOWN_VF }, // 2700
  { PseudoVFSLIDE1DOWN_VF32_M1_MASK, VFSLIDE1DOWN_VF }, // 2701
  { PseudoVFSLIDE1DOWN_VF32_M1_TU, VFSLIDE1DOWN_VF }, // 2702
  { PseudoVFSLIDE1DOWN_VF32_M2, VFSLIDE1DOWN_VF }, // 2703
  { PseudoVFSLIDE1DOWN_VF32_M2_MASK, VFSLIDE1DOWN_VF }, // 2704
  { PseudoVFSLIDE1DOWN_VF32_M2_TU, VFSLIDE1DOWN_VF }, // 2705
  { PseudoVFSLIDE1DOWN_VF32_M4, VFSLIDE1DOWN_VF }, // 2706
  { PseudoVFSLIDE1DOWN_VF32_M4_MASK, VFSLIDE1DOWN_VF }, // 2707
  { PseudoVFSLIDE1DOWN_VF32_M4_TU, VFSLIDE1DOWN_VF }, // 2708
  { PseudoVFSLIDE1DOWN_VF32_M8, VFSLIDE1DOWN_VF }, // 2709
  { PseudoVFSLIDE1DOWN_VF32_M8_MASK, VFSLIDE1DOWN_VF }, // 2710
  { PseudoVFSLIDE1DOWN_VF32_M8_TU, VFSLIDE1DOWN_VF }, // 2711
  { PseudoVFSLIDE1DOWN_VF32_MF2, VFSLIDE1DOWN_VF }, // 2712
  { PseudoVFSLIDE1DOWN_VF32_MF2_MASK, VFSLIDE1DOWN_VF }, // 2713
  { PseudoVFSLIDE1DOWN_VF32_MF2_TU, VFSLIDE1DOWN_VF }, // 2714
  { PseudoVFSLIDE1DOWN_VF64_M1, VFSLIDE1DOWN_VF }, // 2715
  { PseudoVFSLIDE1DOWN_VF64_M1_MASK, VFSLIDE1DOWN_VF }, // 2716
  { PseudoVFSLIDE1DOWN_VF64_M1_TU, VFSLIDE1DOWN_VF }, // 2717
  { PseudoVFSLIDE1DOWN_VF64_M2, VFSLIDE1DOWN_VF }, // 2718
  { PseudoVFSLIDE1DOWN_VF64_M2_MASK, VFSLIDE1DOWN_VF }, // 2719
  { PseudoVFSLIDE1DOWN_VF64_M2_TU, VFSLIDE1DOWN_VF }, // 2720
  { PseudoVFSLIDE1DOWN_VF64_M4, VFSLIDE1DOWN_VF }, // 2721
  { PseudoVFSLIDE1DOWN_VF64_M4_MASK, VFSLIDE1DOWN_VF }, // 2722
  { PseudoVFSLIDE1DOWN_VF64_M4_TU, VFSLIDE1DOWN_VF }, // 2723
  { PseudoVFSLIDE1DOWN_VF64_M8, VFSLIDE1DOWN_VF }, // 2724
  { PseudoVFSLIDE1DOWN_VF64_M8_MASK, VFSLIDE1DOWN_VF }, // 2725
  { PseudoVFSLIDE1DOWN_VF64_M8_TU, VFSLIDE1DOWN_VF }, // 2726
  { PseudoVFSLIDE1UP_VF16_M1, VFSLIDE1UP_VF }, // 2727
  { PseudoVFSLIDE1UP_VF16_M1_MASK, VFSLIDE1UP_VF }, // 2728
  { PseudoVFSLIDE1UP_VF16_M1_TU, VFSLIDE1UP_VF }, // 2729
  { PseudoVFSLIDE1UP_VF16_M2, VFSLIDE1UP_VF }, // 2730
  { PseudoVFSLIDE1UP_VF16_M2_MASK, VFSLIDE1UP_VF }, // 2731
  { PseudoVFSLIDE1UP_VF16_M2_TU, VFSLIDE1UP_VF }, // 2732
  { PseudoVFSLIDE1UP_VF16_M4, VFSLIDE1UP_VF }, // 2733
  { PseudoVFSLIDE1UP_VF16_M4_MASK, VFSLIDE1UP_VF }, // 2734
  { PseudoVFSLIDE1UP_VF16_M4_TU, VFSLIDE1UP_VF }, // 2735
  { PseudoVFSLIDE1UP_VF16_M8, VFSLIDE1UP_VF }, // 2736
  { PseudoVFSLIDE1UP_VF16_M8_MASK, VFSLIDE1UP_VF }, // 2737
  { PseudoVFSLIDE1UP_VF16_M8_TU, VFSLIDE1UP_VF }, // 2738
  { PseudoVFSLIDE1UP_VF16_MF2, VFSLIDE1UP_VF }, // 2739
  { PseudoVFSLIDE1UP_VF16_MF2_MASK, VFSLIDE1UP_VF }, // 2740
  { PseudoVFSLIDE1UP_VF16_MF2_TU, VFSLIDE1UP_VF }, // 2741
  { PseudoVFSLIDE1UP_VF16_MF4, VFSLIDE1UP_VF }, // 2742
  { PseudoVFSLIDE1UP_VF16_MF4_MASK, VFSLIDE1UP_VF }, // 2743
  { PseudoVFSLIDE1UP_VF16_MF4_TU, VFSLIDE1UP_VF }, // 2744
  { PseudoVFSLIDE1UP_VF32_M1, VFSLIDE1UP_VF }, // 2745
  { PseudoVFSLIDE1UP_VF32_M1_MASK, VFSLIDE1UP_VF }, // 2746
  { PseudoVFSLIDE1UP_VF32_M1_TU, VFSLIDE1UP_VF }, // 2747
  { PseudoVFSLIDE1UP_VF32_M2, VFSLIDE1UP_VF }, // 2748
  { PseudoVFSLIDE1UP_VF32_M2_MASK, VFSLIDE1UP_VF }, // 2749
  { PseudoVFSLIDE1UP_VF32_M2_TU, VFSLIDE1UP_VF }, // 2750
  { PseudoVFSLIDE1UP_VF32_M4, VFSLIDE1UP_VF }, // 2751
  { PseudoVFSLIDE1UP_VF32_M4_MASK, VFSLIDE1UP_VF }, // 2752
  { PseudoVFSLIDE1UP_VF32_M4_TU, VFSLIDE1UP_VF }, // 2753
  { PseudoVFSLIDE1UP_VF32_M8, VFSLIDE1UP_VF }, // 2754
  { PseudoVFSLIDE1UP_VF32_M8_MASK, VFSLIDE1UP_VF }, // 2755
  { PseudoVFSLIDE1UP_VF32_M8_TU, VFSLIDE1UP_VF }, // 2756
  { PseudoVFSLIDE1UP_VF32_MF2, VFSLIDE1UP_VF }, // 2757
  { PseudoVFSLIDE1UP_VF32_MF2_MASK, VFSLIDE1UP_VF }, // 2758
  { PseudoVFSLIDE1UP_VF32_MF2_TU, VFSLIDE1UP_VF }, // 2759
  { PseudoVFSLIDE1UP_VF64_M1, VFSLIDE1UP_VF }, // 2760
  { PseudoVFSLIDE1UP_VF64_M1_MASK, VFSLIDE1UP_VF }, // 2761
  { PseudoVFSLIDE1UP_VF64_M1_TU, VFSLIDE1UP_VF }, // 2762
  { PseudoVFSLIDE1UP_VF64_M2, VFSLIDE1UP_VF }, // 2763
  { PseudoVFSLIDE1UP_VF64_M2_MASK, VFSLIDE1UP_VF }, // 2764
  { PseudoVFSLIDE1UP_VF64_M2_TU, VFSLIDE1UP_VF }, // 2765
  { PseudoVFSLIDE1UP_VF64_M4, VFSLIDE1UP_VF }, // 2766
  { PseudoVFSLIDE1UP_VF64_M4_MASK, VFSLIDE1UP_VF }, // 2767
  { PseudoVFSLIDE1UP_VF64_M4_TU, VFSLIDE1UP_VF }, // 2768
  { PseudoVFSLIDE1UP_VF64_M8, VFSLIDE1UP_VF }, // 2769
  { PseudoVFSLIDE1UP_VF64_M8_MASK, VFSLIDE1UP_VF }, // 2770
  { PseudoVFSLIDE1UP_VF64_M8_TU, VFSLIDE1UP_VF }, // 2771
  { PseudoVFSQRT_V_M1_E16, VFSQRT_V }, // 2772
  { PseudoVFSQRT_V_M1_E16_MASK, VFSQRT_V }, // 2773
  { PseudoVFSQRT_V_M1_E16_TU, VFSQRT_V }, // 2774
  { PseudoVFSQRT_V_M1_E32, VFSQRT_V }, // 2775
  { PseudoVFSQRT_V_M1_E32_MASK, VFSQRT_V }, // 2776
  { PseudoVFSQRT_V_M1_E32_TU, VFSQRT_V }, // 2777
  { PseudoVFSQRT_V_M1_E64, VFSQRT_V }, // 2778
  { PseudoVFSQRT_V_M1_E64_MASK, VFSQRT_V }, // 2779
  { PseudoVFSQRT_V_M1_E64_TU, VFSQRT_V }, // 2780
  { PseudoVFSQRT_V_M2_E16, VFSQRT_V }, // 2781
  { PseudoVFSQRT_V_M2_E16_MASK, VFSQRT_V }, // 2782
  { PseudoVFSQRT_V_M2_E16_TU, VFSQRT_V }, // 2783
  { PseudoVFSQRT_V_M2_E32, VFSQRT_V }, // 2784
  { PseudoVFSQRT_V_M2_E32_MASK, VFSQRT_V }, // 2785
  { PseudoVFSQRT_V_M2_E32_TU, VFSQRT_V }, // 2786
  { PseudoVFSQRT_V_M2_E64, VFSQRT_V }, // 2787
  { PseudoVFSQRT_V_M2_E64_MASK, VFSQRT_V }, // 2788
  { PseudoVFSQRT_V_M2_E64_TU, VFSQRT_V }, // 2789
  { PseudoVFSQRT_V_M4_E16, VFSQRT_V }, // 2790
  { PseudoVFSQRT_V_M4_E16_MASK, VFSQRT_V }, // 2791
  { PseudoVFSQRT_V_M4_E16_TU, VFSQRT_V }, // 2792
  { PseudoVFSQRT_V_M4_E32, VFSQRT_V }, // 2793
  { PseudoVFSQRT_V_M4_E32_MASK, VFSQRT_V }, // 2794
  { PseudoVFSQRT_V_M4_E32_TU, VFSQRT_V }, // 2795
  { PseudoVFSQRT_V_M4_E64, VFSQRT_V }, // 2796
  { PseudoVFSQRT_V_M4_E64_MASK, VFSQRT_V }, // 2797
  { PseudoVFSQRT_V_M4_E64_TU, VFSQRT_V }, // 2798
  { PseudoVFSQRT_V_M8_E16, VFSQRT_V }, // 2799
  { PseudoVFSQRT_V_M8_E16_MASK, VFSQRT_V }, // 2800
  { PseudoVFSQRT_V_M8_E16_TU, VFSQRT_V }, // 2801
  { PseudoVFSQRT_V_M8_E32, VFSQRT_V }, // 2802
  { PseudoVFSQRT_V_M8_E32_MASK, VFSQRT_V }, // 2803
  { PseudoVFSQRT_V_M8_E32_TU, VFSQRT_V }, // 2804
  { PseudoVFSQRT_V_M8_E64, VFSQRT_V }, // 2805
  { PseudoVFSQRT_V_M8_E64_MASK, VFSQRT_V }, // 2806
  { PseudoVFSQRT_V_M8_E64_TU, VFSQRT_V }, // 2807
  { PseudoVFSQRT_V_MF2_E16, VFSQRT_V }, // 2808
  { PseudoVFSQRT_V_MF2_E16_MASK, VFSQRT_V }, // 2809
  { PseudoVFSQRT_V_MF2_E16_TU, VFSQRT_V }, // 2810
  { PseudoVFSQRT_V_MF2_E32, VFSQRT_V }, // 2811
  { PseudoVFSQRT_V_MF2_E32_MASK, VFSQRT_V }, // 2812
  { PseudoVFSQRT_V_MF2_E32_TU, VFSQRT_V }, // 2813
  { PseudoVFSQRT_V_MF4_E16, VFSQRT_V }, // 2814
  { PseudoVFSQRT_V_MF4_E16_MASK, VFSQRT_V }, // 2815
  { PseudoVFSQRT_V_MF4_E16_TU, VFSQRT_V }, // 2816
  { PseudoVFSUB_VF16_M1, VFSUB_VF }, // 2817
  { PseudoVFSUB_VF16_M1_MASK, VFSUB_VF }, // 2818
  { PseudoVFSUB_VF16_M1_TU, VFSUB_VF }, // 2819
  { PseudoVFSUB_VF16_M2, VFSUB_VF }, // 2820
  { PseudoVFSUB_VF16_M2_MASK, VFSUB_VF }, // 2821
  { PseudoVFSUB_VF16_M2_TU, VFSUB_VF }, // 2822
  { PseudoVFSUB_VF16_M4, VFSUB_VF }, // 2823
  { PseudoVFSUB_VF16_M4_MASK, VFSUB_VF }, // 2824
  { PseudoVFSUB_VF16_M4_TU, VFSUB_VF }, // 2825
  { PseudoVFSUB_VF16_M8, VFSUB_VF }, // 2826
  { PseudoVFSUB_VF16_M8_MASK, VFSUB_VF }, // 2827
  { PseudoVFSUB_VF16_M8_TU, VFSUB_VF }, // 2828
  { PseudoVFSUB_VF16_MF2, VFSUB_VF }, // 2829
  { PseudoVFSUB_VF16_MF2_MASK, VFSUB_VF }, // 2830
  { PseudoVFSUB_VF16_MF2_TU, VFSUB_VF }, // 2831
  { PseudoVFSUB_VF16_MF4, VFSUB_VF }, // 2832
  { PseudoVFSUB_VF16_MF4_MASK, VFSUB_VF }, // 2833
  { PseudoVFSUB_VF16_MF4_TU, VFSUB_VF }, // 2834
  { PseudoVFSUB_VF32_M1, VFSUB_VF }, // 2835
  { PseudoVFSUB_VF32_M1_MASK, VFSUB_VF }, // 2836
  { PseudoVFSUB_VF32_M1_TU, VFSUB_VF }, // 2837
  { PseudoVFSUB_VF32_M2, VFSUB_VF }, // 2838
  { PseudoVFSUB_VF32_M2_MASK, VFSUB_VF }, // 2839
  { PseudoVFSUB_VF32_M2_TU, VFSUB_VF }, // 2840
  { PseudoVFSUB_VF32_M4, VFSUB_VF }, // 2841
  { PseudoVFSUB_VF32_M4_MASK, VFSUB_VF }, // 2842
  { PseudoVFSUB_VF32_M4_TU, VFSUB_VF }, // 2843
  { PseudoVFSUB_VF32_M8, VFSUB_VF }, // 2844
  { PseudoVFSUB_VF32_M8_MASK, VFSUB_VF }, // 2845
  { PseudoVFSUB_VF32_M8_TU, VFSUB_VF }, // 2846
  { PseudoVFSUB_VF32_MF2, VFSUB_VF }, // 2847
  { PseudoVFSUB_VF32_MF2_MASK, VFSUB_VF }, // 2848
  { PseudoVFSUB_VF32_MF2_TU, VFSUB_VF }, // 2849
  { PseudoVFSUB_VF64_M1, VFSUB_VF }, // 2850
  { PseudoVFSUB_VF64_M1_MASK, VFSUB_VF }, // 2851
  { PseudoVFSUB_VF64_M1_TU, VFSUB_VF }, // 2852
  { PseudoVFSUB_VF64_M2, VFSUB_VF }, // 2853
  { PseudoVFSUB_VF64_M2_MASK, VFSUB_VF }, // 2854
  { PseudoVFSUB_VF64_M2_TU, VFSUB_VF }, // 2855
  { PseudoVFSUB_VF64_M4, VFSUB_VF }, // 2856
  { PseudoVFSUB_VF64_M4_MASK, VFSUB_VF }, // 2857
  { PseudoVFSUB_VF64_M4_TU, VFSUB_VF }, // 2858
  { PseudoVFSUB_VF64_M8, VFSUB_VF }, // 2859
  { PseudoVFSUB_VF64_M8_MASK, VFSUB_VF }, // 2860
  { PseudoVFSUB_VF64_M8_TU, VFSUB_VF }, // 2861
  { PseudoVFSUB_VV_M1, VFSUB_VV }, // 2862
  { PseudoVFSUB_VV_M1_MASK, VFSUB_VV }, // 2863
  { PseudoVFSUB_VV_M1_TU, VFSUB_VV }, // 2864
  { PseudoVFSUB_VV_M2, VFSUB_VV }, // 2865
  { PseudoVFSUB_VV_M2_MASK, VFSUB_VV }, // 2866
  { PseudoVFSUB_VV_M2_TU, VFSUB_VV }, // 2867
  { PseudoVFSUB_VV_M4, VFSUB_VV }, // 2868
  { PseudoVFSUB_VV_M4_MASK, VFSUB_VV }, // 2869
  { PseudoVFSUB_VV_M4_TU, VFSUB_VV }, // 2870
  { PseudoVFSUB_VV_M8, VFSUB_VV }, // 2871
  { PseudoVFSUB_VV_M8_MASK, VFSUB_VV }, // 2872
  { PseudoVFSUB_VV_M8_TU, VFSUB_VV }, // 2873
  { PseudoVFSUB_VV_MF2, VFSUB_VV }, // 2874
  { PseudoVFSUB_VV_MF2_MASK, VFSUB_VV }, // 2875
  { PseudoVFSUB_VV_MF2_TU, VFSUB_VV }, // 2876
  { PseudoVFSUB_VV_MF4, VFSUB_VV }, // 2877
  { PseudoVFSUB_VV_MF4_MASK, VFSUB_VV }, // 2878
  { PseudoVFSUB_VV_MF4_TU, VFSUB_VV }, // 2879
  { PseudoVFWADD_VF16_M1, VFWADD_VF }, // 2880
  { PseudoVFWADD_VF16_M1_MASK, VFWADD_VF }, // 2881
  { PseudoVFWADD_VF16_M1_TU, VFWADD_VF }, // 2882
  { PseudoVFWADD_VF16_M2, VFWADD_VF }, // 2883
  { PseudoVFWADD_VF16_M2_MASK, VFWADD_VF }, // 2884
  { PseudoVFWADD_VF16_M2_TU, VFWADD_VF }, // 2885
  { PseudoVFWADD_VF16_M4, VFWADD_VF }, // 2886
  { PseudoVFWADD_VF16_M4_MASK, VFWADD_VF }, // 2887
  { PseudoVFWADD_VF16_M4_TU, VFWADD_VF }, // 2888
  { PseudoVFWADD_VF16_MF2, VFWADD_VF }, // 2889
  { PseudoVFWADD_VF16_MF2_MASK, VFWADD_VF }, // 2890
  { PseudoVFWADD_VF16_MF2_TU, VFWADD_VF }, // 2891
  { PseudoVFWADD_VF16_MF4, VFWADD_VF }, // 2892
  { PseudoVFWADD_VF16_MF4_MASK, VFWADD_VF }, // 2893
  { PseudoVFWADD_VF16_MF4_TU, VFWADD_VF }, // 2894
  { PseudoVFWADD_VF32_M1, VFWADD_VF }, // 2895
  { PseudoVFWADD_VF32_M1_MASK, VFWADD_VF }, // 2896
  { PseudoVFWADD_VF32_M1_TU, VFWADD_VF }, // 2897
  { PseudoVFWADD_VF32_M2, VFWADD_VF }, // 2898
  { PseudoVFWADD_VF32_M2_MASK, VFWADD_VF }, // 2899
  { PseudoVFWADD_VF32_M2_TU, VFWADD_VF }, // 2900
  { PseudoVFWADD_VF32_M4, VFWADD_VF }, // 2901
  { PseudoVFWADD_VF32_M4_MASK, VFWADD_VF }, // 2902
  { PseudoVFWADD_VF32_M4_TU, VFWADD_VF }, // 2903
  { PseudoVFWADD_VF32_MF2, VFWADD_VF }, // 2904
  { PseudoVFWADD_VF32_MF2_MASK, VFWADD_VF }, // 2905
  { PseudoVFWADD_VF32_MF2_TU, VFWADD_VF }, // 2906
  { PseudoVFWADD_VV_M1, VFWADD_VV }, // 2907
  { PseudoVFWADD_VV_M1_MASK, VFWADD_VV }, // 2908
  { PseudoVFWADD_VV_M1_TU, VFWADD_VV }, // 2909
  { PseudoVFWADD_VV_M2, VFWADD_VV }, // 2910
  { PseudoVFWADD_VV_M2_MASK, VFWADD_VV }, // 2911
  { PseudoVFWADD_VV_M2_TU, VFWADD_VV }, // 2912
  { PseudoVFWADD_VV_M4, VFWADD_VV }, // 2913
  { PseudoVFWADD_VV_M4_MASK, VFWADD_VV }, // 2914
  { PseudoVFWADD_VV_M4_TU, VFWADD_VV }, // 2915
  { PseudoVFWADD_VV_MF2, VFWADD_VV }, // 2916
  { PseudoVFWADD_VV_MF2_MASK, VFWADD_VV }, // 2917
  { PseudoVFWADD_VV_MF2_TU, VFWADD_VV }, // 2918
  { PseudoVFWADD_VV_MF4, VFWADD_VV }, // 2919
  { PseudoVFWADD_VV_MF4_MASK, VFWADD_VV }, // 2920
  { PseudoVFWADD_VV_MF4_TU, VFWADD_VV }, // 2921
  { PseudoVFWADD_WF16_M1, VFWADD_WF }, // 2922
  { PseudoVFWADD_WF16_M1_MASK, VFWADD_WF }, // 2923
  { PseudoVFWADD_WF16_M1_TU, VFWADD_WF }, // 2924
  { PseudoVFWADD_WF16_M2, VFWADD_WF }, // 2925
  { PseudoVFWADD_WF16_M2_MASK, VFWADD_WF }, // 2926
  { PseudoVFWADD_WF16_M2_TU, VFWADD_WF }, // 2927
  { PseudoVFWADD_WF16_M4, VFWADD_WF }, // 2928
  { PseudoVFWADD_WF16_M4_MASK, VFWADD_WF }, // 2929
  { PseudoVFWADD_WF16_M4_TU, VFWADD_WF }, // 2930
  { PseudoVFWADD_WF16_MF2, VFWADD_WF }, // 2931
  { PseudoVFWADD_WF16_MF2_MASK, VFWADD_WF }, // 2932
  { PseudoVFWADD_WF16_MF2_TU, VFWADD_WF }, // 2933
  { PseudoVFWADD_WF16_MF4, VFWADD_WF }, // 2934
  { PseudoVFWADD_WF16_MF4_MASK, VFWADD_WF }, // 2935
  { PseudoVFWADD_WF16_MF4_TU, VFWADD_WF }, // 2936
  { PseudoVFWADD_WF32_M1, VFWADD_WF }, // 2937
  { PseudoVFWADD_WF32_M1_MASK, VFWADD_WF }, // 2938
  { PseudoVFWADD_WF32_M1_TU, VFWADD_WF }, // 2939
  { PseudoVFWADD_WF32_M2, VFWADD_WF }, // 2940
  { PseudoVFWADD_WF32_M2_MASK, VFWADD_WF }, // 2941
  { PseudoVFWADD_WF32_M2_TU, VFWADD_WF }, // 2942
  { PseudoVFWADD_WF32_M4, VFWADD_WF }, // 2943
  { PseudoVFWADD_WF32_M4_MASK, VFWADD_WF }, // 2944
  { PseudoVFWADD_WF32_M4_TU, VFWADD_WF }, // 2945
  { PseudoVFWADD_WF32_MF2, VFWADD_WF }, // 2946
  { PseudoVFWADD_WF32_MF2_MASK, VFWADD_WF }, // 2947
  { PseudoVFWADD_WF32_MF2_TU, VFWADD_WF }, // 2948
  { PseudoVFWADD_WV_M1, VFWADD_WV }, // 2949
  { PseudoVFWADD_WV_M1_MASK, VFWADD_WV }, // 2950
  { PseudoVFWADD_WV_M1_MASK_TIED, VFWADD_WV }, // 2951
  { PseudoVFWADD_WV_M1_TIED, VFWADD_WV }, // 2952
  { PseudoVFWADD_WV_M1_TU, VFWADD_WV }, // 2953
  { PseudoVFWADD_WV_M2, VFWADD_WV }, // 2954
  { PseudoVFWADD_WV_M2_MASK, VFWADD_WV }, // 2955
  { PseudoVFWADD_WV_M2_MASK_TIED, VFWADD_WV }, // 2956
  { PseudoVFWADD_WV_M2_TIED, VFWADD_WV }, // 2957
  { PseudoVFWADD_WV_M2_TU, VFWADD_WV }, // 2958
  { PseudoVFWADD_WV_M4, VFWADD_WV }, // 2959
  { PseudoVFWADD_WV_M4_MASK, VFWADD_WV }, // 2960
  { PseudoVFWADD_WV_M4_MASK_TIED, VFWADD_WV }, // 2961
  { PseudoVFWADD_WV_M4_TIED, VFWADD_WV }, // 2962
  { PseudoVFWADD_WV_M4_TU, VFWADD_WV }, // 2963
  { PseudoVFWADD_WV_MF2, VFWADD_WV }, // 2964
  { PseudoVFWADD_WV_MF2_MASK, VFWADD_WV }, // 2965
  { PseudoVFWADD_WV_MF2_MASK_TIED, VFWADD_WV }, // 2966
  { PseudoVFWADD_WV_MF2_TIED, VFWADD_WV }, // 2967
  { PseudoVFWADD_WV_MF2_TU, VFWADD_WV }, // 2968
  { PseudoVFWADD_WV_MF4, VFWADD_WV }, // 2969
  { PseudoVFWADD_WV_MF4_MASK, VFWADD_WV }, // 2970
  { PseudoVFWADD_WV_MF4_MASK_TIED, VFWADD_WV }, // 2971
  { PseudoVFWADD_WV_MF4_TIED, VFWADD_WV }, // 2972
  { PseudoVFWADD_WV_MF4_TU, VFWADD_WV }, // 2973
  { PseudoVFWCVT_F_F_V_M1, VFWCVT_F_F_V }, // 2974
  { PseudoVFWCVT_F_F_V_M1_MASK, VFWCVT_F_F_V }, // 2975
  { PseudoVFWCVT_F_F_V_M1_TU, VFWCVT_F_F_V }, // 2976
  { PseudoVFWCVT_F_F_V_M2, VFWCVT_F_F_V }, // 2977
  { PseudoVFWCVT_F_F_V_M2_MASK, VFWCVT_F_F_V }, // 2978
  { PseudoVFWCVT_F_F_V_M2_TU, VFWCVT_F_F_V }, // 2979
  { PseudoVFWCVT_F_F_V_M4, VFWCVT_F_F_V }, // 2980
  { PseudoVFWCVT_F_F_V_M4_MASK, VFWCVT_F_F_V }, // 2981
  { PseudoVFWCVT_F_F_V_M4_TU, VFWCVT_F_F_V }, // 2982
  { PseudoVFWCVT_F_F_V_MF2, VFWCVT_F_F_V }, // 2983
  { PseudoVFWCVT_F_F_V_MF2_MASK, VFWCVT_F_F_V }, // 2984
  { PseudoVFWCVT_F_F_V_MF2_TU, VFWCVT_F_F_V }, // 2985
  { PseudoVFWCVT_F_F_V_MF4, VFWCVT_F_F_V }, // 2986
  { PseudoVFWCVT_F_F_V_MF4_MASK, VFWCVT_F_F_V }, // 2987
  { PseudoVFWCVT_F_F_V_MF4_TU, VFWCVT_F_F_V }, // 2988
  { PseudoVFWCVT_F_XU_V_M1, VFWCVT_F_XU_V }, // 2989
  { PseudoVFWCVT_F_XU_V_M1_MASK, VFWCVT_F_XU_V }, // 2990
  { PseudoVFWCVT_F_XU_V_M1_TU, VFWCVT_F_XU_V }, // 2991
  { PseudoVFWCVT_F_XU_V_M2, VFWCVT_F_XU_V }, // 2992
  { PseudoVFWCVT_F_XU_V_M2_MASK, VFWCVT_F_XU_V }, // 2993
  { PseudoVFWCVT_F_XU_V_M2_TU, VFWCVT_F_XU_V }, // 2994
  { PseudoVFWCVT_F_XU_V_M4, VFWCVT_F_XU_V }, // 2995
  { PseudoVFWCVT_F_XU_V_M4_MASK, VFWCVT_F_XU_V }, // 2996
  { PseudoVFWCVT_F_XU_V_M4_TU, VFWCVT_F_XU_V }, // 2997
  { PseudoVFWCVT_F_XU_V_MF2, VFWCVT_F_XU_V }, // 2998
  { PseudoVFWCVT_F_XU_V_MF2_MASK, VFWCVT_F_XU_V }, // 2999
  { PseudoVFWCVT_F_XU_V_MF2_TU, VFWCVT_F_XU_V }, // 3000
  { PseudoVFWCVT_F_XU_V_MF4, VFWCVT_F_XU_V }, // 3001
  { PseudoVFWCVT_F_XU_V_MF4_MASK, VFWCVT_F_XU_V }, // 3002
  { PseudoVFWCVT_F_XU_V_MF4_TU, VFWCVT_F_XU_V }, // 3003
  { PseudoVFWCVT_F_XU_V_MF8, VFWCVT_F_XU_V }, // 3004
  { PseudoVFWCVT_F_XU_V_MF8_MASK, VFWCVT_F_XU_V }, // 3005
  { PseudoVFWCVT_F_XU_V_MF8_TU, VFWCVT_F_XU_V }, // 3006
  { PseudoVFWCVT_F_X_V_M1, VFWCVT_F_X_V }, // 3007
  { PseudoVFWCVT_F_X_V_M1_MASK, VFWCVT_F_X_V }, // 3008
  { PseudoVFWCVT_F_X_V_M1_TU, VFWCVT_F_X_V }, // 3009
  { PseudoVFWCVT_F_X_V_M2, VFWCVT_F_X_V }, // 3010
  { PseudoVFWCVT_F_X_V_M2_MASK, VFWCVT_F_X_V }, // 3011
  { PseudoVFWCVT_F_X_V_M2_TU, VFWCVT_F_X_V }, // 3012
  { PseudoVFWCVT_F_X_V_M4, VFWCVT_F_X_V }, // 3013
  { PseudoVFWCVT_F_X_V_M4_MASK, VFWCVT_F_X_V }, // 3014
  { PseudoVFWCVT_F_X_V_M4_TU, VFWCVT_F_X_V }, // 3015
  { PseudoVFWCVT_F_X_V_MF2, VFWCVT_F_X_V }, // 3016
  { PseudoVFWCVT_F_X_V_MF2_MASK, VFWCVT_F_X_V }, // 3017
  { PseudoVFWCVT_F_X_V_MF2_TU, VFWCVT_F_X_V }, // 3018
  { PseudoVFWCVT_F_X_V_MF4, VFWCVT_F_X_V }, // 3019
  { PseudoVFWCVT_F_X_V_MF4_MASK, VFWCVT_F_X_V }, // 3020
  { PseudoVFWCVT_F_X_V_MF4_TU, VFWCVT_F_X_V }, // 3021
  { PseudoVFWCVT_F_X_V_MF8, VFWCVT_F_X_V }, // 3022
  { PseudoVFWCVT_F_X_V_MF8_MASK, VFWCVT_F_X_V }, // 3023
  { PseudoVFWCVT_F_X_V_MF8_TU, VFWCVT_F_X_V }, // 3024
  { PseudoVFWCVT_RTZ_XU_F_V_M1, VFWCVT_RTZ_XU_F_V }, // 3025
  { PseudoVFWCVT_RTZ_XU_F_V_M1_MASK, VFWCVT_RTZ_XU_F_V }, // 3026
  { PseudoVFWCVT_RTZ_XU_F_V_M1_TU, VFWCVT_RTZ_XU_F_V }, // 3027
  { PseudoVFWCVT_RTZ_XU_F_V_M2, VFWCVT_RTZ_XU_F_V }, // 3028
  { PseudoVFWCVT_RTZ_XU_F_V_M2_MASK, VFWCVT_RTZ_XU_F_V }, // 3029
  { PseudoVFWCVT_RTZ_XU_F_V_M2_TU, VFWCVT_RTZ_XU_F_V }, // 3030
  { PseudoVFWCVT_RTZ_XU_F_V_M4, VFWCVT_RTZ_XU_F_V }, // 3031
  { PseudoVFWCVT_RTZ_XU_F_V_M4_MASK, VFWCVT_RTZ_XU_F_V }, // 3032
  { PseudoVFWCVT_RTZ_XU_F_V_M4_TU, VFWCVT_RTZ_XU_F_V }, // 3033
  { PseudoVFWCVT_RTZ_XU_F_V_MF2, VFWCVT_RTZ_XU_F_V }, // 3034
  { PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK, VFWCVT_RTZ_XU_F_V }, // 3035
  { PseudoVFWCVT_RTZ_XU_F_V_MF2_TU, VFWCVT_RTZ_XU_F_V }, // 3036
  { PseudoVFWCVT_RTZ_XU_F_V_MF4, VFWCVT_RTZ_XU_F_V }, // 3037
  { PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK, VFWCVT_RTZ_XU_F_V }, // 3038
  { PseudoVFWCVT_RTZ_XU_F_V_MF4_TU, VFWCVT_RTZ_XU_F_V }, // 3039
  { PseudoVFWCVT_RTZ_X_F_V_M1, VFWCVT_RTZ_X_F_V }, // 3040
  { PseudoVFWCVT_RTZ_X_F_V_M1_MASK, VFWCVT_RTZ_X_F_V }, // 3041
  { PseudoVFWCVT_RTZ_X_F_V_M1_TU, VFWCVT_RTZ_X_F_V }, // 3042
  { PseudoVFWCVT_RTZ_X_F_V_M2, VFWCVT_RTZ_X_F_V }, // 3043
  { PseudoVFWCVT_RTZ_X_F_V_M2_MASK, VFWCVT_RTZ_X_F_V }, // 3044
  { PseudoVFWCVT_RTZ_X_F_V_M2_TU, VFWCVT_RTZ_X_F_V }, // 3045
  { PseudoVFWCVT_RTZ_X_F_V_M4, VFWCVT_RTZ_X_F_V }, // 3046
  { PseudoVFWCVT_RTZ_X_F_V_M4_MASK, VFWCVT_RTZ_X_F_V }, // 3047
  { PseudoVFWCVT_RTZ_X_F_V_M4_TU, VFWCVT_RTZ_X_F_V }, // 3048
  { PseudoVFWCVT_RTZ_X_F_V_MF2, VFWCVT_RTZ_X_F_V }, // 3049
  { PseudoVFWCVT_RTZ_X_F_V_MF2_MASK, VFWCVT_RTZ_X_F_V }, // 3050
  { PseudoVFWCVT_RTZ_X_F_V_MF2_TU, VFWCVT_RTZ_X_F_V }, // 3051
  { PseudoVFWCVT_RTZ_X_F_V_MF4, VFWCVT_RTZ_X_F_V }, // 3052
  { PseudoVFWCVT_RTZ_X_F_V_MF4_MASK, VFWCVT_RTZ_X_F_V }, // 3053
  { PseudoVFWCVT_RTZ_X_F_V_MF4_TU, VFWCVT_RTZ_X_F_V }, // 3054
  { PseudoVFWCVT_XU_F_V_M1, VFWCVT_XU_F_V }, // 3055
  { PseudoVFWCVT_XU_F_V_M1_MASK, VFWCVT_XU_F_V }, // 3056
  { PseudoVFWCVT_XU_F_V_M1_TU, VFWCVT_XU_F_V }, // 3057
  { PseudoVFWCVT_XU_F_V_M2, VFWCVT_XU_F_V }, // 3058
  { PseudoVFWCVT_XU_F_V_M2_MASK, VFWCVT_XU_F_V }, // 3059
  { PseudoVFWCVT_XU_F_V_M2_TU, VFWCVT_XU_F_V }, // 3060
  { PseudoVFWCVT_XU_F_V_M4, VFWCVT_XU_F_V }, // 3061
  { PseudoVFWCVT_XU_F_V_M4_MASK, VFWCVT_XU_F_V }, // 3062
  { PseudoVFWCVT_XU_F_V_M4_TU, VFWCVT_XU_F_V }, // 3063
  { PseudoVFWCVT_XU_F_V_MF2, VFWCVT_XU_F_V }, // 3064
  { PseudoVFWCVT_XU_F_V_MF2_MASK, VFWCVT_XU_F_V }, // 3065
  { PseudoVFWCVT_XU_F_V_MF2_TU, VFWCVT_XU_F_V }, // 3066
  { PseudoVFWCVT_XU_F_V_MF4, VFWCVT_XU_F_V }, // 3067
  { PseudoVFWCVT_XU_F_V_MF4_MASK, VFWCVT_XU_F_V }, // 3068
  { PseudoVFWCVT_XU_F_V_MF4_TU, VFWCVT_XU_F_V }, // 3069
  { PseudoVFWCVT_X_F_V_M1, VFWCVT_X_F_V }, // 3070
  { PseudoVFWCVT_X_F_V_M1_MASK, VFWCVT_X_F_V }, // 3071
  { PseudoVFWCVT_X_F_V_M1_TU, VFWCVT_X_F_V }, // 3072
  { PseudoVFWCVT_X_F_V_M2, VFWCVT_X_F_V }, // 3073
  { PseudoVFWCVT_X_F_V_M2_MASK, VFWCVT_X_F_V }, // 3074
  { PseudoVFWCVT_X_F_V_M2_TU, VFWCVT_X_F_V }, // 3075
  { PseudoVFWCVT_X_F_V_M4, VFWCVT_X_F_V }, // 3076
  { PseudoVFWCVT_X_F_V_M4_MASK, VFWCVT_X_F_V }, // 3077
  { PseudoVFWCVT_X_F_V_M4_TU, VFWCVT_X_F_V }, // 3078
  { PseudoVFWCVT_X_F_V_MF2, VFWCVT_X_F_V }, // 3079
  { PseudoVFWCVT_X_F_V_MF2_MASK, VFWCVT_X_F_V }, // 3080
  { PseudoVFWCVT_X_F_V_MF2_TU, VFWCVT_X_F_V }, // 3081
  { PseudoVFWCVT_X_F_V_MF4, VFWCVT_X_F_V }, // 3082
  { PseudoVFWCVT_X_F_V_MF4_MASK, VFWCVT_X_F_V }, // 3083
  { PseudoVFWCVT_X_F_V_MF4_TU, VFWCVT_X_F_V }, // 3084
  { PseudoVFWMACC_VF16_M1, VFWMACC_VF }, // 3085
  { PseudoVFWMACC_VF16_M1_MASK, VFWMACC_VF }, // 3086
  { PseudoVFWMACC_VF16_M2, VFWMACC_VF }, // 3087
  { PseudoVFWMACC_VF16_M2_MASK, VFWMACC_VF }, // 3088
  { PseudoVFWMACC_VF16_M4, VFWMACC_VF }, // 3089
  { PseudoVFWMACC_VF16_M4_MASK, VFWMACC_VF }, // 3090
  { PseudoVFWMACC_VF16_MF2, VFWMACC_VF }, // 3091
  { PseudoVFWMACC_VF16_MF2_MASK, VFWMACC_VF }, // 3092
  { PseudoVFWMACC_VF16_MF4, VFWMACC_VF }, // 3093
  { PseudoVFWMACC_VF16_MF4_MASK, VFWMACC_VF }, // 3094
  { PseudoVFWMACC_VF32_M1, VFWMACC_VF }, // 3095
  { PseudoVFWMACC_VF32_M1_MASK, VFWMACC_VF }, // 3096
  { PseudoVFWMACC_VF32_M2, VFWMACC_VF }, // 3097
  { PseudoVFWMACC_VF32_M2_MASK, VFWMACC_VF }, // 3098
  { PseudoVFWMACC_VF32_M4, VFWMACC_VF }, // 3099
  { PseudoVFWMACC_VF32_M4_MASK, VFWMACC_VF }, // 3100
  { PseudoVFWMACC_VF32_MF2, VFWMACC_VF }, // 3101
  { PseudoVFWMACC_VF32_MF2_MASK, VFWMACC_VF }, // 3102
  { PseudoVFWMACC_VV_M1, VFWMACC_VV }, // 3103
  { PseudoVFWMACC_VV_M1_MASK, VFWMACC_VV }, // 3104
  { PseudoVFWMACC_VV_M2, VFWMACC_VV }, // 3105
  { PseudoVFWMACC_VV_M2_MASK, VFWMACC_VV }, // 3106
  { PseudoVFWMACC_VV_M4, VFWMACC_VV }, // 3107
  { PseudoVFWMACC_VV_M4_MASK, VFWMACC_VV }, // 3108
  { PseudoVFWMACC_VV_MF2, VFWMACC_VV }, // 3109
  { PseudoVFWMACC_VV_MF2_MASK, VFWMACC_VV }, // 3110
  { PseudoVFWMACC_VV_MF4, VFWMACC_VV }, // 3111
  { PseudoVFWMACC_VV_MF4_MASK, VFWMACC_VV }, // 3112
  { PseudoVFWMSAC_VF16_M1, VFWMSAC_VF }, // 3113
  { PseudoVFWMSAC_VF16_M1_MASK, VFWMSAC_VF }, // 3114
  { PseudoVFWMSAC_VF16_M2, VFWMSAC_VF }, // 3115
  { PseudoVFWMSAC_VF16_M2_MASK, VFWMSAC_VF }, // 3116
  { PseudoVFWMSAC_VF16_M4, VFWMSAC_VF }, // 3117
  { PseudoVFWMSAC_VF16_M4_MASK, VFWMSAC_VF }, // 3118
  { PseudoVFWMSAC_VF16_MF2, VFWMSAC_VF }, // 3119
  { PseudoVFWMSAC_VF16_MF2_MASK, VFWMSAC_VF }, // 3120
  { PseudoVFWMSAC_VF16_MF4, VFWMSAC_VF }, // 3121
  { PseudoVFWMSAC_VF16_MF4_MASK, VFWMSAC_VF }, // 3122
  { PseudoVFWMSAC_VF32_M1, VFWMSAC_VF }, // 3123
  { PseudoVFWMSAC_VF32_M1_MASK, VFWMSAC_VF }, // 3124
  { PseudoVFWMSAC_VF32_M2, VFWMSAC_VF }, // 3125
  { PseudoVFWMSAC_VF32_M2_MASK, VFWMSAC_VF }, // 3126
  { PseudoVFWMSAC_VF32_M4, VFWMSAC_VF }, // 3127
  { PseudoVFWMSAC_VF32_M4_MASK, VFWMSAC_VF }, // 3128
  { PseudoVFWMSAC_VF32_MF2, VFWMSAC_VF }, // 3129
  { PseudoVFWMSAC_VF32_MF2_MASK, VFWMSAC_VF }, // 3130
  { PseudoVFWMSAC_VV_M1, VFWMSAC_VV }, // 3131
  { PseudoVFWMSAC_VV_M1_MASK, VFWMSAC_VV }, // 3132
  { PseudoVFWMSAC_VV_M2, VFWMSAC_VV }, // 3133
  { PseudoVFWMSAC_VV_M2_MASK, VFWMSAC_VV }, // 3134
  { PseudoVFWMSAC_VV_M4, VFWMSAC_VV }, // 3135
  { PseudoVFWMSAC_VV_M4_MASK, VFWMSAC_VV }, // 3136
  { PseudoVFWMSAC_VV_MF2, VFWMSAC_VV }, // 3137
  { PseudoVFWMSAC_VV_MF2_MASK, VFWMSAC_VV }, // 3138
  { PseudoVFWMSAC_VV_MF4, VFWMSAC_VV }, // 3139
  { PseudoVFWMSAC_VV_MF4_MASK, VFWMSAC_VV }, // 3140
  { PseudoVFWMUL_VF16_M1, VFWMUL_VF }, // 3141
  { PseudoVFWMUL_VF16_M1_MASK, VFWMUL_VF }, // 3142
  { PseudoVFWMUL_VF16_M1_TU, VFWMUL_VF }, // 3143
  { PseudoVFWMUL_VF16_M2, VFWMUL_VF }, // 3144
  { PseudoVFWMUL_VF16_M2_MASK, VFWMUL_VF }, // 3145
  { PseudoVFWMUL_VF16_M2_TU, VFWMUL_VF }, // 3146
  { PseudoVFWMUL_VF16_M4, VFWMUL_VF }, // 3147
  { PseudoVFWMUL_VF16_M4_MASK, VFWMUL_VF }, // 3148
  { PseudoVFWMUL_VF16_M4_TU, VFWMUL_VF }, // 3149
  { PseudoVFWMUL_VF16_MF2, VFWMUL_VF }, // 3150
  { PseudoVFWMUL_VF16_MF2_MASK, VFWMUL_VF }, // 3151
  { PseudoVFWMUL_VF16_MF2_TU, VFWMUL_VF }, // 3152
  { PseudoVFWMUL_VF16_MF4, VFWMUL_VF }, // 3153
  { PseudoVFWMUL_VF16_MF4_MASK, VFWMUL_VF }, // 3154
  { PseudoVFWMUL_VF16_MF4_TU, VFWMUL_VF }, // 3155
  { PseudoVFWMUL_VF32_M1, VFWMUL_VF }, // 3156
  { PseudoVFWMUL_VF32_M1_MASK, VFWMUL_VF }, // 3157
  { PseudoVFWMUL_VF32_M1_TU, VFWMUL_VF }, // 3158
  { PseudoVFWMUL_VF32_M2, VFWMUL_VF }, // 3159
  { PseudoVFWMUL_VF32_M2_MASK, VFWMUL_VF }, // 3160
  { PseudoVFWMUL_VF32_M2_TU, VFWMUL_VF }, // 3161
  { PseudoVFWMUL_VF32_M4, VFWMUL_VF }, // 3162
  { PseudoVFWMUL_VF32_M4_MASK, VFWMUL_VF }, // 3163
  { PseudoVFWMUL_VF32_M4_TU, VFWMUL_VF }, // 3164
  { PseudoVFWMUL_VF32_MF2, VFWMUL_VF }, // 3165
  { PseudoVFWMUL_VF32_MF2_MASK, VFWMUL_VF }, // 3166
  { PseudoVFWMUL_VF32_MF2_TU, VFWMUL_VF }, // 3167
  { PseudoVFWMUL_VV_M1, VFWMUL_VV }, // 3168
  { PseudoVFWMUL_VV_M1_MASK, VFWMUL_VV }, // 3169
  { PseudoVFWMUL_VV_M1_TU, VFWMUL_VV }, // 3170
  { PseudoVFWMUL_VV_M2, VFWMUL_VV }, // 3171
  { PseudoVFWMUL_VV_M2_MASK, VFWMUL_VV }, // 3172
  { PseudoVFWMUL_VV_M2_TU, VFWMUL_VV }, // 3173
  { PseudoVFWMUL_VV_M4, VFWMUL_VV }, // 3174
  { PseudoVFWMUL_VV_M4_MASK, VFWMUL_VV }, // 3175
  { PseudoVFWMUL_VV_M4_TU, VFWMUL_VV }, // 3176
  { PseudoVFWMUL_VV_MF2, VFWMUL_VV }, // 3177
  { PseudoVFWMUL_VV_MF2_MASK, VFWMUL_VV }, // 3178
  { PseudoVFWMUL_VV_MF2_TU, VFWMUL_VV }, // 3179
  { PseudoVFWMUL_VV_MF4, VFWMUL_VV }, // 3180
  { PseudoVFWMUL_VV_MF4_MASK, VFWMUL_VV }, // 3181
  { PseudoVFWMUL_VV_MF4_TU, VFWMUL_VV }, // 3182
  { PseudoVFWNMACC_VF16_M1, VFWNMACC_VF }, // 3183
  { PseudoVFWNMACC_VF16_M1_MASK, VFWNMACC_VF }, // 3184
  { PseudoVFWNMACC_VF16_M2, VFWNMACC_VF }, // 3185
  { PseudoVFWNMACC_VF16_M2_MASK, VFWNMACC_VF }, // 3186
  { PseudoVFWNMACC_VF16_M4, VFWNMACC_VF }, // 3187
  { PseudoVFWNMACC_VF16_M4_MASK, VFWNMACC_VF }, // 3188
  { PseudoVFWNMACC_VF16_MF2, VFWNMACC_VF }, // 3189
  { PseudoVFWNMACC_VF16_MF2_MASK, VFWNMACC_VF }, // 3190
  { PseudoVFWNMACC_VF16_MF4, VFWNMACC_VF }, // 3191
  { PseudoVFWNMACC_VF16_MF4_MASK, VFWNMACC_VF }, // 3192
  { PseudoVFWNMACC_VF32_M1, VFWNMACC_VF }, // 3193
  { PseudoVFWNMACC_VF32_M1_MASK, VFWNMACC_VF }, // 3194
  { PseudoVFWNMACC_VF32_M2, VFWNMACC_VF }, // 3195
  { PseudoVFWNMACC_VF32_M2_MASK, VFWNMACC_VF }, // 3196
  { PseudoVFWNMACC_VF32_M4, VFWNMACC_VF }, // 3197
  { PseudoVFWNMACC_VF32_M4_MASK, VFWNMACC_VF }, // 3198
  { PseudoVFWNMACC_VF32_MF2, VFWNMACC_VF }, // 3199
  { PseudoVFWNMACC_VF32_MF2_MASK, VFWNMACC_VF }, // 3200
  { PseudoVFWNMACC_VV_M1, VFWNMACC_VV }, // 3201
  { PseudoVFWNMACC_VV_M1_MASK, VFWNMACC_VV }, // 3202
  { PseudoVFWNMACC_VV_M2, VFWNMACC_VV }, // 3203
  { PseudoVFWNMACC_VV_M2_MASK, VFWNMACC_VV }, // 3204
  { PseudoVFWNMACC_VV_M4, VFWNMACC_VV }, // 3205
  { PseudoVFWNMACC_VV_M4_MASK, VFWNMACC_VV }, // 3206
  { PseudoVFWNMACC_VV_MF2, VFWNMACC_VV }, // 3207
  { PseudoVFWNMACC_VV_MF2_MASK, VFWNMACC_VV }, // 3208
  { PseudoVFWNMACC_VV_MF4, VFWNMACC_VV }, // 3209
  { PseudoVFWNMACC_VV_MF4_MASK, VFWNMACC_VV }, // 3210
  { PseudoVFWNMSAC_VF16_M1, VFWNMSAC_VF }, // 3211
  { PseudoVFWNMSAC_VF16_M1_MASK, VFWNMSAC_VF }, // 3212
  { PseudoVFWNMSAC_VF16_M2, VFWNMSAC_VF }, // 3213
  { PseudoVFWNMSAC_VF16_M2_MASK, VFWNMSAC_VF }, // 3214
  { PseudoVFWNMSAC_VF16_M4, VFWNMSAC_VF }, // 3215
  { PseudoVFWNMSAC_VF16_M4_MASK, VFWNMSAC_VF }, // 3216
  { PseudoVFWNMSAC_VF16_MF2, VFWNMSAC_VF }, // 3217
  { PseudoVFWNMSAC_VF16_MF2_MASK, VFWNMSAC_VF }, // 3218
  { PseudoVFWNMSAC_VF16_MF4, VFWNMSAC_VF }, // 3219
  { PseudoVFWNMSAC_VF16_MF4_MASK, VFWNMSAC_VF }, // 3220
  { PseudoVFWNMSAC_VF32_M1, VFWNMSAC_VF }, // 3221
  { PseudoVFWNMSAC_VF32_M1_MASK, VFWNMSAC_VF }, // 3222
  { PseudoVFWNMSAC_VF32_M2, VFWNMSAC_VF }, // 3223
  { PseudoVFWNMSAC_VF32_M2_MASK, VFWNMSAC_VF }, // 3224
  { PseudoVFWNMSAC_VF32_M4, VFWNMSAC_VF }, // 3225
  { PseudoVFWNMSAC_VF32_M4_MASK, VFWNMSAC_VF }, // 3226
  { PseudoVFWNMSAC_VF32_MF2, VFWNMSAC_VF }, // 3227
  { PseudoVFWNMSAC_VF32_MF2_MASK, VFWNMSAC_VF }, // 3228
  { PseudoVFWNMSAC_VV_M1, VFWNMSAC_VV }, // 3229
  { PseudoVFWNMSAC_VV_M1_MASK, VFWNMSAC_VV }, // 3230
  { PseudoVFWNMSAC_VV_M2, VFWNMSAC_VV }, // 3231
  { PseudoVFWNMSAC_VV_M2_MASK, VFWNMSAC_VV }, // 3232
  { PseudoVFWNMSAC_VV_M4, VFWNMSAC_VV }, // 3233
  { PseudoVFWNMSAC_VV_M4_MASK, VFWNMSAC_VV }, // 3234
  { PseudoVFWNMSAC_VV_MF2, VFWNMSAC_VV }, // 3235
  { PseudoVFWNMSAC_VV_MF2_MASK, VFWNMSAC_VV }, // 3236
  { PseudoVFWNMSAC_VV_MF4, VFWNMSAC_VV }, // 3237
  { PseudoVFWNMSAC_VV_MF4_MASK, VFWNMSAC_VV }, // 3238
  { PseudoVFWREDOSUM_VS_M1_E16, VFWREDOSUM_VS }, // 3239
  { PseudoVFWREDOSUM_VS_M1_E16_MASK, VFWREDOSUM_VS }, // 3240
  { PseudoVFWREDOSUM_VS_M1_E32, VFWREDOSUM_VS }, // 3241
  { PseudoVFWREDOSUM_VS_M1_E32_MASK, VFWREDOSUM_VS }, // 3242
  { PseudoVFWREDOSUM_VS_M2_E16, VFWREDOSUM_VS }, // 3243
  { PseudoVFWREDOSUM_VS_M2_E16_MASK, VFWREDOSUM_VS }, // 3244
  { PseudoVFWREDOSUM_VS_M2_E32, VFWREDOSUM_VS }, // 3245
  { PseudoVFWREDOSUM_VS_M2_E32_MASK, VFWREDOSUM_VS }, // 3246
  { PseudoVFWREDOSUM_VS_M4_E16, VFWREDOSUM_VS }, // 3247
  { PseudoVFWREDOSUM_VS_M4_E16_MASK, VFWREDOSUM_VS }, // 3248
  { PseudoVFWREDOSUM_VS_M4_E32, VFWREDOSUM_VS }, // 3249
  { PseudoVFWREDOSUM_VS_M4_E32_MASK, VFWREDOSUM_VS }, // 3250
  { PseudoVFWREDOSUM_VS_M8_E16, VFWREDOSUM_VS }, // 3251
  { PseudoVFWREDOSUM_VS_M8_E16_MASK, VFWREDOSUM_VS }, // 3252
  { PseudoVFWREDOSUM_VS_M8_E32, VFWREDOSUM_VS }, // 3253
  { PseudoVFWREDOSUM_VS_M8_E32_MASK, VFWREDOSUM_VS }, // 3254
  { PseudoVFWREDOSUM_VS_MF2_E16, VFWREDOSUM_VS }, // 3255
  { PseudoVFWREDOSUM_VS_MF2_E16_MASK, VFWREDOSUM_VS }, // 3256
  { PseudoVFWREDOSUM_VS_MF2_E32, VFWREDOSUM_VS }, // 3257
  { PseudoVFWREDOSUM_VS_MF2_E32_MASK, VFWREDOSUM_VS }, // 3258
  { PseudoVFWREDOSUM_VS_MF4_E16, VFWREDOSUM_VS }, // 3259
  { PseudoVFWREDOSUM_VS_MF4_E16_MASK, VFWREDOSUM_VS }, // 3260
  { PseudoVFWREDUSUM_VS_M1_E16, VFWREDUSUM_VS }, // 3261
  { PseudoVFWREDUSUM_VS_M1_E16_MASK, VFWREDUSUM_VS }, // 3262
  { PseudoVFWREDUSUM_VS_M1_E32, VFWREDUSUM_VS }, // 3263
  { PseudoVFWREDUSUM_VS_M1_E32_MASK, VFWREDUSUM_VS }, // 3264
  { PseudoVFWREDUSUM_VS_M2_E16, VFWREDUSUM_VS }, // 3265
  { PseudoVFWREDUSUM_VS_M2_E16_MASK, VFWREDUSUM_VS }, // 3266
  { PseudoVFWREDUSUM_VS_M2_E32, VFWREDUSUM_VS }, // 3267
  { PseudoVFWREDUSUM_VS_M2_E32_MASK, VFWREDUSUM_VS }, // 3268
  { PseudoVFWREDUSUM_VS_M4_E16, VFWREDUSUM_VS }, // 3269
  { PseudoVFWREDUSUM_VS_M4_E16_MASK, VFWREDUSUM_VS }, // 3270
  { PseudoVFWREDUSUM_VS_M4_E32, VFWREDUSUM_VS }, // 3271
  { PseudoVFWREDUSUM_VS_M4_E32_MASK, VFWREDUSUM_VS }, // 3272
  { PseudoVFWREDUSUM_VS_M8_E16, VFWREDUSUM_VS }, // 3273
  { PseudoVFWREDUSUM_VS_M8_E16_MASK, VFWREDUSUM_VS }, // 3274
  { PseudoVFWREDUSUM_VS_M8_E32, VFWREDUSUM_VS }, // 3275
  { PseudoVFWREDUSUM_VS_M8_E32_MASK, VFWREDUSUM_VS }, // 3276
  { PseudoVFWREDUSUM_VS_MF2_E16, VFWREDUSUM_VS }, // 3277
  { PseudoVFWREDUSUM_VS_MF2_E16_MASK, VFWREDUSUM_VS }, // 3278
  { PseudoVFWREDUSUM_VS_MF2_E32, VFWREDUSUM_VS }, // 3279
  { PseudoVFWREDUSUM_VS_MF2_E32_MASK, VFWREDUSUM_VS }, // 3280
  { PseudoVFWREDUSUM_VS_MF4_E16, VFWREDUSUM_VS }, // 3281
  { PseudoVFWREDUSUM_VS_MF4_E16_MASK, VFWREDUSUM_VS }, // 3282
  { PseudoVFWSUB_VF16_M1, VFWSUB_VF }, // 3283
  { PseudoVFWSUB_VF16_M1_MASK, VFWSUB_VF }, // 3284
  { PseudoVFWSUB_VF16_M1_TU, VFWSUB_VF }, // 3285
  { PseudoVFWSUB_VF16_M2, VFWSUB_VF }, // 3286
  { PseudoVFWSUB_VF16_M2_MASK, VFWSUB_VF }, // 3287
  { PseudoVFWSUB_VF16_M2_TU, VFWSUB_VF }, // 3288
  { PseudoVFWSUB_VF16_M4, VFWSUB_VF }, // 3289
  { PseudoVFWSUB_VF16_M4_MASK, VFWSUB_VF }, // 3290
  { PseudoVFWSUB_VF16_M4_TU, VFWSUB_VF }, // 3291
  { PseudoVFWSUB_VF16_MF2, VFWSUB_VF }, // 3292
  { PseudoVFWSUB_VF16_MF2_MASK, VFWSUB_VF }, // 3293
  { PseudoVFWSUB_VF16_MF2_TU, VFWSUB_VF }, // 3294
  { PseudoVFWSUB_VF16_MF4, VFWSUB_VF }, // 3295
  { PseudoVFWSUB_VF16_MF4_MASK, VFWSUB_VF }, // 3296
  { PseudoVFWSUB_VF16_MF4_TU, VFWSUB_VF }, // 3297
  { PseudoVFWSUB_VF32_M1, VFWSUB_VF }, // 3298
  { PseudoVFWSUB_VF32_M1_MASK, VFWSUB_VF }, // 3299
  { PseudoVFWSUB_VF32_M1_TU, VFWSUB_VF }, // 3300
  { PseudoVFWSUB_VF32_M2, VFWSUB_VF }, // 3301
  { PseudoVFWSUB_VF32_M2_MASK, VFWSUB_VF }, // 3302
  { PseudoVFWSUB_VF32_M2_TU, VFWSUB_VF }, // 3303
  { PseudoVFWSUB_VF32_M4, VFWSUB_VF }, // 3304
  { PseudoVFWSUB_VF32_M4_MASK, VFWSUB_VF }, // 3305
  { PseudoVFWSUB_VF32_M4_TU, VFWSUB_VF }, // 3306
  { PseudoVFWSUB_VF32_MF2, VFWSUB_VF }, // 3307
  { PseudoVFWSUB_VF32_MF2_MASK, VFWSUB_VF }, // 3308
  { PseudoVFWSUB_VF32_MF2_TU, VFWSUB_VF }, // 3309
  { PseudoVFWSUB_VV_M1, VFWSUB_VV }, // 3310
  { PseudoVFWSUB_VV_M1_MASK, VFWSUB_VV }, // 3311
  { PseudoVFWSUB_VV_M1_TU, VFWSUB_VV }, // 3312
  { PseudoVFWSUB_VV_M2, VFWSUB_VV }, // 3313
  { PseudoVFWSUB_VV_M2_MASK, VFWSUB_VV }, // 3314
  { PseudoVFWSUB_VV_M2_TU, VFWSUB_VV }, // 3315
  { PseudoVFWSUB_VV_M4, VFWSUB_VV }, // 3316
  { PseudoVFWSUB_VV_M4_MASK, VFWSUB_VV }, // 3317
  { PseudoVFWSUB_VV_M4_TU, VFWSUB_VV }, // 3318
  { PseudoVFWSUB_VV_MF2, VFWSUB_VV }, // 3319
  { PseudoVFWSUB_VV_MF2_MASK, VFWSUB_VV }, // 3320
  { PseudoVFWSUB_VV_MF2_TU, VFWSUB_VV }, // 3321
  { PseudoVFWSUB_VV_MF4, VFWSUB_VV }, // 3322
  { PseudoVFWSUB_VV_MF4_MASK, VFWSUB_VV }, // 3323
  { PseudoVFWSUB_VV_MF4_TU, VFWSUB_VV }, // 3324
  { PseudoVFWSUB_WF16_M1, VFWSUB_WF }, // 3325
  { PseudoVFWSUB_WF16_M1_MASK, VFWSUB_WF }, // 3326
  { PseudoVFWSUB_WF16_M1_TU, VFWSUB_WF }, // 3327
  { PseudoVFWSUB_WF16_M2, VFWSUB_WF }, // 3328
  { PseudoVFWSUB_WF16_M2_MASK, VFWSUB_WF }, // 3329
  { PseudoVFWSUB_WF16_M2_TU, VFWSUB_WF }, // 3330
  { PseudoVFWSUB_WF16_M4, VFWSUB_WF }, // 3331
  { PseudoVFWSUB_WF16_M4_MASK, VFWSUB_WF }, // 3332
  { PseudoVFWSUB_WF16_M4_TU, VFWSUB_WF }, // 3333
  { PseudoVFWSUB_WF16_MF2, VFWSUB_WF }, // 3334
  { PseudoVFWSUB_WF16_MF2_MASK, VFWSUB_WF }, // 3335
  { PseudoVFWSUB_WF16_MF2_TU, VFWSUB_WF }, // 3336
  { PseudoVFWSUB_WF16_MF4, VFWSUB_WF }, // 3337
  { PseudoVFWSUB_WF16_MF4_MASK, VFWSUB_WF }, // 3338
  { PseudoVFWSUB_WF16_MF4_TU, VFWSUB_WF }, // 3339
  { PseudoVFWSUB_WF32_M1, VFWSUB_WF }, // 3340
  { PseudoVFWSUB_WF32_M1_MASK, VFWSUB_WF }, // 3341
  { PseudoVFWSUB_WF32_M1_TU, VFWSUB_WF }, // 3342
  { PseudoVFWSUB_WF32_M2, VFWSUB_WF }, // 3343
  { PseudoVFWSUB_WF32_M2_MASK, VFWSUB_WF }, // 3344
  { PseudoVFWSUB_WF32_M2_TU, VFWSUB_WF }, // 3345
  { PseudoVFWSUB_WF32_M4, VFWSUB_WF }, // 3346
  { PseudoVFWSUB_WF32_M4_MASK, VFWSUB_WF }, // 3347
  { PseudoVFWSUB_WF32_M4_TU, VFWSUB_WF }, // 3348
  { PseudoVFWSUB_WF32_MF2, VFWSUB_WF }, // 3349
  { PseudoVFWSUB_WF32_MF2_MASK, VFWSUB_WF }, // 3350
  { PseudoVFWSUB_WF32_MF2_TU, VFWSUB_WF }, // 3351
  { PseudoVFWSUB_WV_M1, VFWSUB_WV }, // 3352
  { PseudoVFWSUB_WV_M1_MASK, VFWSUB_WV }, // 3353
  { PseudoVFWSUB_WV_M1_MASK_TIED, VFWSUB_WV }, // 3354
  { PseudoVFWSUB_WV_M1_TIED, VFWSUB_WV }, // 3355
  { PseudoVFWSUB_WV_M1_TU, VFWSUB_WV }, // 3356
  { PseudoVFWSUB_WV_M2, VFWSUB_WV }, // 3357
  { PseudoVFWSUB_WV_M2_MASK, VFWSUB_WV }, // 3358
  { PseudoVFWSUB_WV_M2_MASK_TIED, VFWSUB_WV }, // 3359
  { PseudoVFWSUB_WV_M2_TIED, VFWSUB_WV }, // 3360
  { PseudoVFWSUB_WV_M2_TU, VFWSUB_WV }, // 3361
  { PseudoVFWSUB_WV_M4, VFWSUB_WV }, // 3362
  { PseudoVFWSUB_WV_M4_MASK, VFWSUB_WV }, // 3363
  { PseudoVFWSUB_WV_M4_MASK_TIED, VFWSUB_WV }, // 3364
  { PseudoVFWSUB_WV_M4_TIED, VFWSUB_WV }, // 3365
  { PseudoVFWSUB_WV_M4_TU, VFWSUB_WV }, // 3366
  { PseudoVFWSUB_WV_MF2, VFWSUB_WV }, // 3367
  { PseudoVFWSUB_WV_MF2_MASK, VFWSUB_WV }, // 3368
  { PseudoVFWSUB_WV_MF2_MASK_TIED, VFWSUB_WV }, // 3369
  { PseudoVFWSUB_WV_MF2_TIED, VFWSUB_WV }, // 3370
  { PseudoVFWSUB_WV_MF2_TU, VFWSUB_WV }, // 3371
  { PseudoVFWSUB_WV_MF4, VFWSUB_WV }, // 3372
  { PseudoVFWSUB_WV_MF4_MASK, VFWSUB_WV }, // 3373
  { PseudoVFWSUB_WV_MF4_MASK_TIED, VFWSUB_WV }, // 3374
  { PseudoVFWSUB_WV_MF4_TIED, VFWSUB_WV }, // 3375
  { PseudoVFWSUB_WV_MF4_TU, VFWSUB_WV }, // 3376
  { PseudoVID_V_M1, VID_V }, // 3377
  { PseudoVID_V_M1_MASK, VID_V }, // 3378
  { PseudoVID_V_M1_TU, VID_V }, // 3379
  { PseudoVID_V_M2, VID_V }, // 3380
  { PseudoVID_V_M2_MASK, VID_V }, // 3381
  { PseudoVID_V_M2_TU, VID_V }, // 3382
  { PseudoVID_V_M4, VID_V }, // 3383
  { PseudoVID_V_M4_MASK, VID_V }, // 3384
  { PseudoVID_V_M4_TU, VID_V }, // 3385
  { PseudoVID_V_M8, VID_V }, // 3386
  { PseudoVID_V_M8_MASK, VID_V }, // 3387
  { PseudoVID_V_M8_TU, VID_V }, // 3388
  { PseudoVID_V_MF2, VID_V }, // 3389
  { PseudoVID_V_MF2_MASK, VID_V }, // 3390
  { PseudoVID_V_MF2_TU, VID_V }, // 3391
  { PseudoVID_V_MF4, VID_V }, // 3392
  { PseudoVID_V_MF4_MASK, VID_V }, // 3393
  { PseudoVID_V_MF4_TU, VID_V }, // 3394
  { PseudoVID_V_MF8, VID_V }, // 3395
  { PseudoVID_V_MF8_MASK, VID_V }, // 3396
  { PseudoVID_V_MF8_TU, VID_V }, // 3397
  { PseudoVIOTA_M_M1, VIOTA_M }, // 3398
  { PseudoVIOTA_M_M1_MASK, VIOTA_M }, // 3399
  { PseudoVIOTA_M_M1_TU, VIOTA_M }, // 3400
  { PseudoVIOTA_M_M2, VIOTA_M }, // 3401
  { PseudoVIOTA_M_M2_MASK, VIOTA_M }, // 3402
  { PseudoVIOTA_M_M2_TU, VIOTA_M }, // 3403
  { PseudoVIOTA_M_M4, VIOTA_M }, // 3404
  { PseudoVIOTA_M_M4_MASK, VIOTA_M }, // 3405
  { PseudoVIOTA_M_M4_TU, VIOTA_M }, // 3406
  { PseudoVIOTA_M_M8, VIOTA_M }, // 3407
  { PseudoVIOTA_M_M8_MASK, VIOTA_M }, // 3408
  { PseudoVIOTA_M_M8_TU, VIOTA_M }, // 3409
  { PseudoVIOTA_M_MF2, VIOTA_M }, // 3410
  { PseudoVIOTA_M_MF2_MASK, VIOTA_M }, // 3411
  { PseudoVIOTA_M_MF2_TU, VIOTA_M }, // 3412
  { PseudoVIOTA_M_MF4, VIOTA_M }, // 3413
  { PseudoVIOTA_M_MF4_MASK, VIOTA_M }, // 3414
  { PseudoVIOTA_M_MF4_TU, VIOTA_M }, // 3415
  { PseudoVIOTA_M_MF8, VIOTA_M }, // 3416
  { PseudoVIOTA_M_MF8_MASK, VIOTA_M }, // 3417
  { PseudoVIOTA_M_MF8_TU, VIOTA_M }, // 3418
  { PseudoVLE16FF_V_M1, VLE16FF_V }, // 3419
  { PseudoVLE16FF_V_M1_MASK, VLE16FF_V }, // 3420
  { PseudoVLE16FF_V_M1_TU, VLE16FF_V }, // 3421
  { PseudoVLE16FF_V_M2, VLE16FF_V }, // 3422
  { PseudoVLE16FF_V_M2_MASK, VLE16FF_V }, // 3423
  { PseudoVLE16FF_V_M2_TU, VLE16FF_V }, // 3424
  { PseudoVLE16FF_V_M4, VLE16FF_V }, // 3425
  { PseudoVLE16FF_V_M4_MASK, VLE16FF_V }, // 3426
  { PseudoVLE16FF_V_M4_TU, VLE16FF_V }, // 3427
  { PseudoVLE16FF_V_M8, VLE16FF_V }, // 3428
  { PseudoVLE16FF_V_M8_MASK, VLE16FF_V }, // 3429
  { PseudoVLE16FF_V_M8_TU, VLE16FF_V }, // 3430
  { PseudoVLE16FF_V_MF2, VLE16FF_V }, // 3431
  { PseudoVLE16FF_V_MF2_MASK, VLE16FF_V }, // 3432
  { PseudoVLE16FF_V_MF2_TU, VLE16FF_V }, // 3433
  { PseudoVLE16FF_V_MF4, VLE16FF_V }, // 3434
  { PseudoVLE16FF_V_MF4_MASK, VLE16FF_V }, // 3435
  { PseudoVLE16FF_V_MF4_TU, VLE16FF_V }, // 3436
  { PseudoVLE16_V_M1, VLE16_V }, // 3437
  { PseudoVLE16_V_M1_MASK, VLE16_V }, // 3438
  { PseudoVLE16_V_M1_TU, VLE16_V }, // 3439
  { PseudoVLE16_V_M2, VLE16_V }, // 3440
  { PseudoVLE16_V_M2_MASK, VLE16_V }, // 3441
  { PseudoVLE16_V_M2_TU, VLE16_V }, // 3442
  { PseudoVLE16_V_M4, VLE16_V }, // 3443
  { PseudoVLE16_V_M4_MASK, VLE16_V }, // 3444
  { PseudoVLE16_V_M4_TU, VLE16_V }, // 3445
  { PseudoVLE16_V_M8, VLE16_V }, // 3446
  { PseudoVLE16_V_M8_MASK, VLE16_V }, // 3447
  { PseudoVLE16_V_M8_TU, VLE16_V }, // 3448
  { PseudoVLE16_V_MF2, VLE16_V }, // 3449
  { PseudoVLE16_V_MF2_MASK, VLE16_V }, // 3450
  { PseudoVLE16_V_MF2_TU, VLE16_V }, // 3451
  { PseudoVLE16_V_MF4, VLE16_V }, // 3452
  { PseudoVLE16_V_MF4_MASK, VLE16_V }, // 3453
  { PseudoVLE16_V_MF4_TU, VLE16_V }, // 3454
  { PseudoVLE32FF_V_M1, VLE32FF_V }, // 3455
  { PseudoVLE32FF_V_M1_MASK, VLE32FF_V }, // 3456
  { PseudoVLE32FF_V_M1_TU, VLE32FF_V }, // 3457
  { PseudoVLE32FF_V_M2, VLE32FF_V }, // 3458
  { PseudoVLE32FF_V_M2_MASK, VLE32FF_V }, // 3459
  { PseudoVLE32FF_V_M2_TU, VLE32FF_V }, // 3460
  { PseudoVLE32FF_V_M4, VLE32FF_V }, // 3461
  { PseudoVLE32FF_V_M4_MASK, VLE32FF_V }, // 3462
  { PseudoVLE32FF_V_M4_TU, VLE32FF_V }, // 3463
  { PseudoVLE32FF_V_M8, VLE32FF_V }, // 3464
  { PseudoVLE32FF_V_M8_MASK, VLE32FF_V }, // 3465
  { PseudoVLE32FF_V_M8_TU, VLE32FF_V }, // 3466
  { PseudoVLE32FF_V_MF2, VLE32FF_V }, // 3467
  { PseudoVLE32FF_V_MF2_MASK, VLE32FF_V }, // 3468
  { PseudoVLE32FF_V_MF2_TU, VLE32FF_V }, // 3469
  { PseudoVLE32_V_M1, VLE32_V }, // 3470
  { PseudoVLE32_V_M1_MASK, VLE32_V }, // 3471
  { PseudoVLE32_V_M1_TU, VLE32_V }, // 3472
  { PseudoVLE32_V_M2, VLE32_V }, // 3473
  { PseudoVLE32_V_M2_MASK, VLE32_V }, // 3474
  { PseudoVLE32_V_M2_TU, VLE32_V }, // 3475
  { PseudoVLE32_V_M4, VLE32_V }, // 3476
  { PseudoVLE32_V_M4_MASK, VLE32_V }, // 3477
  { PseudoVLE32_V_M4_TU, VLE32_V }, // 3478
  { PseudoVLE32_V_M8, VLE32_V }, // 3479
  { PseudoVLE32_V_M8_MASK, VLE32_V }, // 3480
  { PseudoVLE32_V_M8_TU, VLE32_V }, // 3481
  { PseudoVLE32_V_MF2, VLE32_V }, // 3482
  { PseudoVLE32_V_MF2_MASK, VLE32_V }, // 3483
  { PseudoVLE32_V_MF2_TU, VLE32_V }, // 3484
  { PseudoVLE64FF_V_M1, VLE64FF_V }, // 3485
  { PseudoVLE64FF_V_M1_MASK, VLE64FF_V }, // 3486
  { PseudoVLE64FF_V_M1_TU, VLE64FF_V }, // 3487
  { PseudoVLE64FF_V_M2, VLE64FF_V }, // 3488
  { PseudoVLE64FF_V_M2_MASK, VLE64FF_V }, // 3489
  { PseudoVLE64FF_V_M2_TU, VLE64FF_V }, // 3490
  { PseudoVLE64FF_V_M4, VLE64FF_V }, // 3491
  { PseudoVLE64FF_V_M4_MASK, VLE64FF_V }, // 3492
  { PseudoVLE64FF_V_M4_TU, VLE64FF_V }, // 3493
  { PseudoVLE64FF_V_M8, VLE64FF_V }, // 3494
  { PseudoVLE64FF_V_M8_MASK, VLE64FF_V }, // 3495
  { PseudoVLE64FF_V_M8_TU, VLE64FF_V }, // 3496
  { PseudoVLE64_V_M1, VLE64_V }, // 3497
  { PseudoVLE64_V_M1_MASK, VLE64_V }, // 3498
  { PseudoVLE64_V_M1_TU, VLE64_V }, // 3499
  { PseudoVLE64_V_M2, VLE64_V }, // 3500
  { PseudoVLE64_V_M2_MASK, VLE64_V }, // 3501
  { PseudoVLE64_V_M2_TU, VLE64_V }, // 3502
  { PseudoVLE64_V_M4, VLE64_V }, // 3503
  { PseudoVLE64_V_M4_MASK, VLE64_V }, // 3504
  { PseudoVLE64_V_M4_TU, VLE64_V }, // 3505
  { PseudoVLE64_V_M8, VLE64_V }, // 3506
  { PseudoVLE64_V_M8_MASK, VLE64_V }, // 3507
  { PseudoVLE64_V_M8_TU, VLE64_V }, // 3508
  { PseudoVLE8FF_V_M1, VLE8FF_V }, // 3509
  { PseudoVLE8FF_V_M1_MASK, VLE8FF_V }, // 3510
  { PseudoVLE8FF_V_M1_TU, VLE8FF_V }, // 3511
  { PseudoVLE8FF_V_M2, VLE8FF_V }, // 3512
  { PseudoVLE8FF_V_M2_MASK, VLE8FF_V }, // 3513
  { PseudoVLE8FF_V_M2_TU, VLE8FF_V }, // 3514
  { PseudoVLE8FF_V_M4, VLE8FF_V }, // 3515
  { PseudoVLE8FF_V_M4_MASK, VLE8FF_V }, // 3516
  { PseudoVLE8FF_V_M4_TU, VLE8FF_V }, // 3517
  { PseudoVLE8FF_V_M8, VLE8FF_V }, // 3518
  { PseudoVLE8FF_V_M8_MASK, VLE8FF_V }, // 3519
  { PseudoVLE8FF_V_M8_TU, VLE8FF_V }, // 3520
  { PseudoVLE8FF_V_MF2, VLE8FF_V }, // 3521
  { PseudoVLE8FF_V_MF2_MASK, VLE8FF_V }, // 3522
  { PseudoVLE8FF_V_MF2_TU, VLE8FF_V }, // 3523
  { PseudoVLE8FF_V_MF4, VLE8FF_V }, // 3524
  { PseudoVLE8FF_V_MF4_MASK, VLE8FF_V }, // 3525
  { PseudoVLE8FF_V_MF4_TU, VLE8FF_V }, // 3526
  { PseudoVLE8FF_V_MF8, VLE8FF_V }, // 3527
  { PseudoVLE8FF_V_MF8_MASK, VLE8FF_V }, // 3528
  { PseudoVLE8FF_V_MF8_TU, VLE8FF_V }, // 3529
  { PseudoVLE8_V_M1, VLE8_V }, // 3530
  { PseudoVLE8_V_M1_MASK, VLE8_V }, // 3531
  { PseudoVLE8_V_M1_TU, VLE8_V }, // 3532
  { PseudoVLE8_V_M2, VLE8_V }, // 3533
  { PseudoVLE8_V_M2_MASK, VLE8_V }, // 3534
  { PseudoVLE8_V_M2_TU, VLE8_V }, // 3535
  { PseudoVLE8_V_M4, VLE8_V }, // 3536
  { PseudoVLE8_V_M4_MASK, VLE8_V }, // 3537
  { PseudoVLE8_V_M4_TU, VLE8_V }, // 3538
  { PseudoVLE8_V_M8, VLE8_V }, // 3539
  { PseudoVLE8_V_M8_MASK, VLE8_V }, // 3540
  { PseudoVLE8_V_M8_TU, VLE8_V }, // 3541
  { PseudoVLE8_V_MF2, VLE8_V }, // 3542
  { PseudoVLE8_V_MF2_MASK, VLE8_V }, // 3543
  { PseudoVLE8_V_MF2_TU, VLE8_V }, // 3544
  { PseudoVLE8_V_MF4, VLE8_V }, // 3545
  { PseudoVLE8_V_MF4_MASK, VLE8_V }, // 3546
  { PseudoVLE8_V_MF4_TU, VLE8_V }, // 3547
  { PseudoVLE8_V_MF8, VLE8_V }, // 3548
  { PseudoVLE8_V_MF8_MASK, VLE8_V }, // 3549
  { PseudoVLE8_V_MF8_TU, VLE8_V }, // 3550
  { PseudoVLM_V_B1, VLM_V }, // 3551
  { PseudoVLM_V_B16, VLM_V }, // 3552
  { PseudoVLM_V_B2, VLM_V }, // 3553
  { PseudoVLM_V_B32, VLM_V }, // 3554
  { PseudoVLM_V_B4, VLM_V }, // 3555
  { PseudoVLM_V_B64, VLM_V }, // 3556
  { PseudoVLM_V_B8, VLM_V }, // 3557
  { PseudoVLOXEI16_V_M1_M1, VLOXEI16_V }, // 3558
  { PseudoVLOXEI16_V_M1_M1_MASK, VLOXEI16_V }, // 3559
  { PseudoVLOXEI16_V_M1_M1_TU, VLOXEI16_V }, // 3560
  { PseudoVLOXEI16_V_M1_M2, VLOXEI16_V }, // 3561
  { PseudoVLOXEI16_V_M1_M2_MASK, VLOXEI16_V }, // 3562
  { PseudoVLOXEI16_V_M1_M2_TU, VLOXEI16_V }, // 3563
  { PseudoVLOXEI16_V_M1_M4, VLOXEI16_V }, // 3564
  { PseudoVLOXEI16_V_M1_M4_MASK, VLOXEI16_V }, // 3565
  { PseudoVLOXEI16_V_M1_M4_TU, VLOXEI16_V }, // 3566
  { PseudoVLOXEI16_V_M1_MF2, VLOXEI16_V }, // 3567
  { PseudoVLOXEI16_V_M1_MF2_MASK, VLOXEI16_V }, // 3568
  { PseudoVLOXEI16_V_M1_MF2_TU, VLOXEI16_V }, // 3569
  { PseudoVLOXEI16_V_M2_M1, VLOXEI16_V }, // 3570
  { PseudoVLOXEI16_V_M2_M1_MASK, VLOXEI16_V }, // 3571
  { PseudoVLOXEI16_V_M2_M1_TU, VLOXEI16_V }, // 3572
  { PseudoVLOXEI16_V_M2_M2, VLOXEI16_V }, // 3573
  { PseudoVLOXEI16_V_M2_M2_MASK, VLOXEI16_V }, // 3574
  { PseudoVLOXEI16_V_M2_M2_TU, VLOXEI16_V }, // 3575
  { PseudoVLOXEI16_V_M2_M4, VLOXEI16_V }, // 3576
  { PseudoVLOXEI16_V_M2_M4_MASK, VLOXEI16_V }, // 3577
  { PseudoVLOXEI16_V_M2_M4_TU, VLOXEI16_V }, // 3578
  { PseudoVLOXEI16_V_M2_M8, VLOXEI16_V }, // 3579
  { PseudoVLOXEI16_V_M2_M8_MASK, VLOXEI16_V }, // 3580
  { PseudoVLOXEI16_V_M2_M8_TU, VLOXEI16_V }, // 3581
  { PseudoVLOXEI16_V_M4_M2, VLOXEI16_V }, // 3582
  { PseudoVLOXEI16_V_M4_M2_MASK, VLOXEI16_V }, // 3583
  { PseudoVLOXEI16_V_M4_M2_TU, VLOXEI16_V }, // 3584
  { PseudoVLOXEI16_V_M4_M4, VLOXEI16_V }, // 3585
  { PseudoVLOXEI16_V_M4_M4_MASK, VLOXEI16_V }, // 3586
  { PseudoVLOXEI16_V_M4_M4_TU, VLOXEI16_V }, // 3587
  { PseudoVLOXEI16_V_M4_M8, VLOXEI16_V }, // 3588
  { PseudoVLOXEI16_V_M4_M8_MASK, VLOXEI16_V }, // 3589
  { PseudoVLOXEI16_V_M4_M8_TU, VLOXEI16_V }, // 3590
  { PseudoVLOXEI16_V_M8_M4, VLOXEI16_V }, // 3591
  { PseudoVLOXEI16_V_M8_M4_MASK, VLOXEI16_V }, // 3592
  { PseudoVLOXEI16_V_M8_M4_TU, VLOXEI16_V }, // 3593
  { PseudoVLOXEI16_V_M8_M8, VLOXEI16_V }, // 3594
  { PseudoVLOXEI16_V_M8_M8_MASK, VLOXEI16_V }, // 3595
  { PseudoVLOXEI16_V_M8_M8_TU, VLOXEI16_V }, // 3596
  { PseudoVLOXEI16_V_MF2_M1, VLOXEI16_V }, // 3597
  { PseudoVLOXEI16_V_MF2_M1_MASK, VLOXEI16_V }, // 3598
  { PseudoVLOXEI16_V_MF2_M1_TU, VLOXEI16_V }, // 3599
  { PseudoVLOXEI16_V_MF2_M2, VLOXEI16_V }, // 3600
  { PseudoVLOXEI16_V_MF2_M2_MASK, VLOXEI16_V }, // 3601
  { PseudoVLOXEI16_V_MF2_M2_TU, VLOXEI16_V }, // 3602
  { PseudoVLOXEI16_V_MF2_MF2, VLOXEI16_V }, // 3603
  { PseudoVLOXEI16_V_MF2_MF2_MASK, VLOXEI16_V }, // 3604
  { PseudoVLOXEI16_V_MF2_MF2_TU, VLOXEI16_V }, // 3605
  { PseudoVLOXEI16_V_MF2_MF4, VLOXEI16_V }, // 3606
  { PseudoVLOXEI16_V_MF2_MF4_MASK, VLOXEI16_V }, // 3607
  { PseudoVLOXEI16_V_MF2_MF4_TU, VLOXEI16_V }, // 3608
  { PseudoVLOXEI16_V_MF4_M1, VLOXEI16_V }, // 3609
  { PseudoVLOXEI16_V_MF4_M1_MASK, VLOXEI16_V }, // 3610
  { PseudoVLOXEI16_V_MF4_M1_TU, VLOXEI16_V }, // 3611
  { PseudoVLOXEI16_V_MF4_MF2, VLOXEI16_V }, // 3612
  { PseudoVLOXEI16_V_MF4_MF2_MASK, VLOXEI16_V }, // 3613
  { PseudoVLOXEI16_V_MF4_MF2_TU, VLOXEI16_V }, // 3614
  { PseudoVLOXEI16_V_MF4_MF4, VLOXEI16_V }, // 3615
  { PseudoVLOXEI16_V_MF4_MF4_MASK, VLOXEI16_V }, // 3616
  { PseudoVLOXEI16_V_MF4_MF4_TU, VLOXEI16_V }, // 3617
  { PseudoVLOXEI16_V_MF4_MF8, VLOXEI16_V }, // 3618
  { PseudoVLOXEI16_V_MF4_MF8_MASK, VLOXEI16_V }, // 3619
  { PseudoVLOXEI16_V_MF4_MF8_TU, VLOXEI16_V }, // 3620
  { PseudoVLOXEI32_V_M1_M1, VLOXEI32_V }, // 3621
  { PseudoVLOXEI32_V_M1_M1_MASK, VLOXEI32_V }, // 3622
  { PseudoVLOXEI32_V_M1_M1_TU, VLOXEI32_V }, // 3623
  { PseudoVLOXEI32_V_M1_M2, VLOXEI32_V }, // 3624
  { PseudoVLOXEI32_V_M1_M2_MASK, VLOXEI32_V }, // 3625
  { PseudoVLOXEI32_V_M1_M2_TU, VLOXEI32_V }, // 3626
  { PseudoVLOXEI32_V_M1_MF2, VLOXEI32_V }, // 3627
  { PseudoVLOXEI32_V_M1_MF2_MASK, VLOXEI32_V }, // 3628
  { PseudoVLOXEI32_V_M1_MF2_TU, VLOXEI32_V }, // 3629
  { PseudoVLOXEI32_V_M1_MF4, VLOXEI32_V }, // 3630
  { PseudoVLOXEI32_V_M1_MF4_MASK, VLOXEI32_V }, // 3631
  { PseudoVLOXEI32_V_M1_MF4_TU, VLOXEI32_V }, // 3632
  { PseudoVLOXEI32_V_M2_M1, VLOXEI32_V }, // 3633
  { PseudoVLOXEI32_V_M2_M1_MASK, VLOXEI32_V }, // 3634
  { PseudoVLOXEI32_V_M2_M1_TU, VLOXEI32_V }, // 3635
  { PseudoVLOXEI32_V_M2_M2, VLOXEI32_V }, // 3636
  { PseudoVLOXEI32_V_M2_M2_MASK, VLOXEI32_V }, // 3637
  { PseudoVLOXEI32_V_M2_M2_TU, VLOXEI32_V }, // 3638
  { PseudoVLOXEI32_V_M2_M4, VLOXEI32_V }, // 3639
  { PseudoVLOXEI32_V_M2_M4_MASK, VLOXEI32_V }, // 3640
  { PseudoVLOXEI32_V_M2_M4_TU, VLOXEI32_V }, // 3641
  { PseudoVLOXEI32_V_M2_MF2, VLOXEI32_V }, // 3642
  { PseudoVLOXEI32_V_M2_MF2_MASK, VLOXEI32_V }, // 3643
  { PseudoVLOXEI32_V_M2_MF2_TU, VLOXEI32_V }, // 3644
  { PseudoVLOXEI32_V_M4_M1, VLOXEI32_V }, // 3645
  { PseudoVLOXEI32_V_M4_M1_MASK, VLOXEI32_V }, // 3646
  { PseudoVLOXEI32_V_M4_M1_TU, VLOXEI32_V }, // 3647
  { PseudoVLOXEI32_V_M4_M2, VLOXEI32_V }, // 3648
  { PseudoVLOXEI32_V_M4_M2_MASK, VLOXEI32_V }, // 3649
  { PseudoVLOXEI32_V_M4_M2_TU, VLOXEI32_V }, // 3650
  { PseudoVLOXEI32_V_M4_M4, VLOXEI32_V }, // 3651
  { PseudoVLOXEI32_V_M4_M4_MASK, VLOXEI32_V }, // 3652
  { PseudoVLOXEI32_V_M4_M4_TU, VLOXEI32_V }, // 3653
  { PseudoVLOXEI32_V_M4_M8, VLOXEI32_V }, // 3654
  { PseudoVLOXEI32_V_M4_M8_MASK, VLOXEI32_V }, // 3655
  { PseudoVLOXEI32_V_M4_M8_TU, VLOXEI32_V }, // 3656
  { PseudoVLOXEI32_V_M8_M2, VLOXEI32_V }, // 3657
  { PseudoVLOXEI32_V_M8_M2_MASK, VLOXEI32_V }, // 3658
  { PseudoVLOXEI32_V_M8_M2_TU, VLOXEI32_V }, // 3659
  { PseudoVLOXEI32_V_M8_M4, VLOXEI32_V }, // 3660
  { PseudoVLOXEI32_V_M8_M4_MASK, VLOXEI32_V }, // 3661
  { PseudoVLOXEI32_V_M8_M4_TU, VLOXEI32_V }, // 3662
  { PseudoVLOXEI32_V_M8_M8, VLOXEI32_V }, // 3663
  { PseudoVLOXEI32_V_M8_M8_MASK, VLOXEI32_V }, // 3664
  { PseudoVLOXEI32_V_M8_M8_TU, VLOXEI32_V }, // 3665
  { PseudoVLOXEI32_V_MF2_M1, VLOXEI32_V }, // 3666
  { PseudoVLOXEI32_V_MF2_M1_MASK, VLOXEI32_V }, // 3667
  { PseudoVLOXEI32_V_MF2_M1_TU, VLOXEI32_V }, // 3668
  { PseudoVLOXEI32_V_MF2_MF2, VLOXEI32_V }, // 3669
  { PseudoVLOXEI32_V_MF2_MF2_MASK, VLOXEI32_V }, // 3670
  { PseudoVLOXEI32_V_MF2_MF2_TU, VLOXEI32_V }, // 3671
  { PseudoVLOXEI32_V_MF2_MF4, VLOXEI32_V }, // 3672
  { PseudoVLOXEI32_V_MF2_MF4_MASK, VLOXEI32_V }, // 3673
  { PseudoVLOXEI32_V_MF2_MF4_TU, VLOXEI32_V }, // 3674
  { PseudoVLOXEI32_V_MF2_MF8, VLOXEI32_V }, // 3675
  { PseudoVLOXEI32_V_MF2_MF8_MASK, VLOXEI32_V }, // 3676
  { PseudoVLOXEI32_V_MF2_MF8_TU, VLOXEI32_V }, // 3677
  { PseudoVLOXEI64_V_M1_M1, VLOXEI64_V }, // 3678
  { PseudoVLOXEI64_V_M1_M1_MASK, VLOXEI64_V }, // 3679
  { PseudoVLOXEI64_V_M1_M1_TU, VLOXEI64_V }, // 3680
  { PseudoVLOXEI64_V_M1_MF2, VLOXEI64_V }, // 3681
  { PseudoVLOXEI64_V_M1_MF2_MASK, VLOXEI64_V }, // 3682
  { PseudoVLOXEI64_V_M1_MF2_TU, VLOXEI64_V }, // 3683
  { PseudoVLOXEI64_V_M1_MF4, VLOXEI64_V }, // 3684
  { PseudoVLOXEI64_V_M1_MF4_MASK, VLOXEI64_V }, // 3685
  { PseudoVLOXEI64_V_M1_MF4_TU, VLOXEI64_V }, // 3686
  { PseudoVLOXEI64_V_M1_MF8, VLOXEI64_V }, // 3687
  { PseudoVLOXEI64_V_M1_MF8_MASK, VLOXEI64_V }, // 3688
  { PseudoVLOXEI64_V_M1_MF8_TU, VLOXEI64_V }, // 3689
  { PseudoVLOXEI64_V_M2_M1, VLOXEI64_V }, // 3690
  { PseudoVLOXEI64_V_M2_M1_MASK, VLOXEI64_V }, // 3691
  { PseudoVLOXEI64_V_M2_M1_TU, VLOXEI64_V }, // 3692
  { PseudoVLOXEI64_V_M2_M2, VLOXEI64_V }, // 3693
  { PseudoVLOXEI64_V_M2_M2_MASK, VLOXEI64_V }, // 3694
  { PseudoVLOXEI64_V_M2_M2_TU, VLOXEI64_V }, // 3695
  { PseudoVLOXEI64_V_M2_MF2, VLOXEI64_V }, // 3696
  { PseudoVLOXEI64_V_M2_MF2_MASK, VLOXEI64_V }, // 3697
  { PseudoVLOXEI64_V_M2_MF2_TU, VLOXEI64_V }, // 3698
  { PseudoVLOXEI64_V_M2_MF4, VLOXEI64_V }, // 3699
  { PseudoVLOXEI64_V_M2_MF4_MASK, VLOXEI64_V }, // 3700
  { PseudoVLOXEI64_V_M2_MF4_TU, VLOXEI64_V }, // 3701
  { PseudoVLOXEI64_V_M4_M1, VLOXEI64_V }, // 3702
  { PseudoVLOXEI64_V_M4_M1_MASK, VLOXEI64_V }, // 3703
  { PseudoVLOXEI64_V_M4_M1_TU, VLOXEI64_V }, // 3704
  { PseudoVLOXEI64_V_M4_M2, VLOXEI64_V }, // 3705
  { PseudoVLOXEI64_V_M4_M2_MASK, VLOXEI64_V }, // 3706
  { PseudoVLOXEI64_V_M4_M2_TU, VLOXEI64_V }, // 3707
  { PseudoVLOXEI64_V_M4_M4, VLOXEI64_V }, // 3708
  { PseudoVLOXEI64_V_M4_M4_MASK, VLOXEI64_V }, // 3709
  { PseudoVLOXEI64_V_M4_M4_TU, VLOXEI64_V }, // 3710
  { PseudoVLOXEI64_V_M4_MF2, VLOXEI64_V }, // 3711
  { PseudoVLOXEI64_V_M4_MF2_MASK, VLOXEI64_V }, // 3712
  { PseudoVLOXEI64_V_M4_MF2_TU, VLOXEI64_V }, // 3713
  { PseudoVLOXEI64_V_M8_M1, VLOXEI64_V }, // 3714
  { PseudoVLOXEI64_V_M8_M1_MASK, VLOXEI64_V }, // 3715
  { PseudoVLOXEI64_V_M8_M1_TU, VLOXEI64_V }, // 3716
  { PseudoVLOXEI64_V_M8_M2, VLOXEI64_V }, // 3717
  { PseudoVLOXEI64_V_M8_M2_MASK, VLOXEI64_V }, // 3718
  { PseudoVLOXEI64_V_M8_M2_TU, VLOXEI64_V }, // 3719
  { PseudoVLOXEI64_V_M8_M4, VLOXEI64_V }, // 3720
  { PseudoVLOXEI64_V_M8_M4_MASK, VLOXEI64_V }, // 3721
  { PseudoVLOXEI64_V_M8_M4_TU, VLOXEI64_V }, // 3722
  { PseudoVLOXEI64_V_M8_M8, VLOXEI64_V }, // 3723
  { PseudoVLOXEI64_V_M8_M8_MASK, VLOXEI64_V }, // 3724
  { PseudoVLOXEI64_V_M8_M8_TU, VLOXEI64_V }, // 3725
  { PseudoVLOXEI8_V_M1_M1, VLOXEI8_V }, // 3726
  { PseudoVLOXEI8_V_M1_M1_MASK, VLOXEI8_V }, // 3727
  { PseudoVLOXEI8_V_M1_M1_TU, VLOXEI8_V }, // 3728
  { PseudoVLOXEI8_V_M1_M2, VLOXEI8_V }, // 3729
  { PseudoVLOXEI8_V_M1_M2_MASK, VLOXEI8_V }, // 3730
  { PseudoVLOXEI8_V_M1_M2_TU, VLOXEI8_V }, // 3731
  { PseudoVLOXEI8_V_M1_M4, VLOXEI8_V }, // 3732
  { PseudoVLOXEI8_V_M1_M4_MASK, VLOXEI8_V }, // 3733
  { PseudoVLOXEI8_V_M1_M4_TU, VLOXEI8_V }, // 3734
  { PseudoVLOXEI8_V_M1_M8, VLOXEI8_V }, // 3735
  { PseudoVLOXEI8_V_M1_M8_MASK, VLOXEI8_V }, // 3736
  { PseudoVLOXEI8_V_M1_M8_TU, VLOXEI8_V }, // 3737
  { PseudoVLOXEI8_V_M2_M2, VLOXEI8_V }, // 3738
  { PseudoVLOXEI8_V_M2_M2_MASK, VLOXEI8_V }, // 3739
  { PseudoVLOXEI8_V_M2_M2_TU, VLOXEI8_V }, // 3740
  { PseudoVLOXEI8_V_M2_M4, VLOXEI8_V }, // 3741
  { PseudoVLOXEI8_V_M2_M4_MASK, VLOXEI8_V }, // 3742
  { PseudoVLOXEI8_V_M2_M4_TU, VLOXEI8_V }, // 3743
  { PseudoVLOXEI8_V_M2_M8, VLOXEI8_V }, // 3744
  { PseudoVLOXEI8_V_M2_M8_MASK, VLOXEI8_V }, // 3745
  { PseudoVLOXEI8_V_M2_M8_TU, VLOXEI8_V }, // 3746
  { PseudoVLOXEI8_V_M4_M4, VLOXEI8_V }, // 3747
  { PseudoVLOXEI8_V_M4_M4_MASK, VLOXEI8_V }, // 3748
  { PseudoVLOXEI8_V_M4_M4_TU, VLOXEI8_V }, // 3749
  { PseudoVLOXEI8_V_M4_M8, VLOXEI8_V }, // 3750
  { PseudoVLOXEI8_V_M4_M8_MASK, VLOXEI8_V }, // 3751
  { PseudoVLOXEI8_V_M4_M8_TU, VLOXEI8_V }, // 3752
  { PseudoVLOXEI8_V_M8_M8, VLOXEI8_V }, // 3753
  { PseudoVLOXEI8_V_M8_M8_MASK, VLOXEI8_V }, // 3754
  { PseudoVLOXEI8_V_M8_M8_TU, VLOXEI8_V }, // 3755
  { PseudoVLOXEI8_V_MF2_M1, VLOXEI8_V }, // 3756
  { PseudoVLOXEI8_V_MF2_M1_MASK, VLOXEI8_V }, // 3757
  { PseudoVLOXEI8_V_MF2_M1_TU, VLOXEI8_V }, // 3758
  { PseudoVLOXEI8_V_MF2_M2, VLOXEI8_V }, // 3759
  { PseudoVLOXEI8_V_MF2_M2_MASK, VLOXEI8_V }, // 3760
  { PseudoVLOXEI8_V_MF2_M2_TU, VLOXEI8_V }, // 3761
  { PseudoVLOXEI8_V_MF2_M4, VLOXEI8_V }, // 3762
  { PseudoVLOXEI8_V_MF2_M4_MASK, VLOXEI8_V }, // 3763
  { PseudoVLOXEI8_V_MF2_M4_TU, VLOXEI8_V }, // 3764
  { PseudoVLOXEI8_V_MF2_MF2, VLOXEI8_V }, // 3765
  { PseudoVLOXEI8_V_MF2_MF2_MASK, VLOXEI8_V }, // 3766
  { PseudoVLOXEI8_V_MF2_MF2_TU, VLOXEI8_V }, // 3767
  { PseudoVLOXEI8_V_MF4_M1, VLOXEI8_V }, // 3768
  { PseudoVLOXEI8_V_MF4_M1_MASK, VLOXEI8_V }, // 3769
  { PseudoVLOXEI8_V_MF4_M1_TU, VLOXEI8_V }, // 3770
  { PseudoVLOXEI8_V_MF4_M2, VLOXEI8_V }, // 3771
  { PseudoVLOXEI8_V_MF4_M2_MASK, VLOXEI8_V }, // 3772
  { PseudoVLOXEI8_V_MF4_M2_TU, VLOXEI8_V }, // 3773
  { PseudoVLOXEI8_V_MF4_MF2, VLOXEI8_V }, // 3774
  { PseudoVLOXEI8_V_MF4_MF2_MASK, VLOXEI8_V }, // 3775
  { PseudoVLOXEI8_V_MF4_MF2_TU, VLOXEI8_V }, // 3776
  { PseudoVLOXEI8_V_MF4_MF4, VLOXEI8_V }, // 3777
  { PseudoVLOXEI8_V_MF4_MF4_MASK, VLOXEI8_V }, // 3778
  { PseudoVLOXEI8_V_MF4_MF4_TU, VLOXEI8_V }, // 3779
  { PseudoVLOXEI8_V_MF8_M1, VLOXEI8_V }, // 3780
  { PseudoVLOXEI8_V_MF8_M1_MASK, VLOXEI8_V }, // 3781
  { PseudoVLOXEI8_V_MF8_M1_TU, VLOXEI8_V }, // 3782
  { PseudoVLOXEI8_V_MF8_MF2, VLOXEI8_V }, // 3783
  { PseudoVLOXEI8_V_MF8_MF2_MASK, VLOXEI8_V }, // 3784
  { PseudoVLOXEI8_V_MF8_MF2_TU, VLOXEI8_V }, // 3785
  { PseudoVLOXEI8_V_MF8_MF4, VLOXEI8_V }, // 3786
  { PseudoVLOXEI8_V_MF8_MF4_MASK, VLOXEI8_V }, // 3787
  { PseudoVLOXEI8_V_MF8_MF4_TU, VLOXEI8_V }, // 3788
  { PseudoVLOXEI8_V_MF8_MF8, VLOXEI8_V }, // 3789
  { PseudoVLOXEI8_V_MF8_MF8_MASK, VLOXEI8_V }, // 3790
  { PseudoVLOXEI8_V_MF8_MF8_TU, VLOXEI8_V }, // 3791
  { PseudoVLOXSEG2EI16_V_M1_M1, VLOXSEG2EI16_V }, // 3792
  { PseudoVLOXSEG2EI16_V_M1_M1_MASK, VLOXSEG2EI16_V }, // 3793
  { PseudoVLOXSEG2EI16_V_M1_M1_TU, VLOXSEG2EI16_V }, // 3794
  { PseudoVLOXSEG2EI16_V_M1_M2, VLOXSEG2EI16_V }, // 3795
  { PseudoVLOXSEG2EI16_V_M1_M2_MASK, VLOXSEG2EI16_V }, // 3796
  { PseudoVLOXSEG2EI16_V_M1_M2_TU, VLOXSEG2EI16_V }, // 3797
  { PseudoVLOXSEG2EI16_V_M1_M4, VLOXSEG2EI16_V }, // 3798
  { PseudoVLOXSEG2EI16_V_M1_M4_MASK, VLOXSEG2EI16_V }, // 3799
  { PseudoVLOXSEG2EI16_V_M1_M4_TU, VLOXSEG2EI16_V }, // 3800
  { PseudoVLOXSEG2EI16_V_M1_MF2, VLOXSEG2EI16_V }, // 3801
  { PseudoVLOXSEG2EI16_V_M1_MF2_MASK, VLOXSEG2EI16_V }, // 3802
  { PseudoVLOXSEG2EI16_V_M1_MF2_TU, VLOXSEG2EI16_V }, // 3803
  { PseudoVLOXSEG2EI16_V_M2_M1, VLOXSEG2EI16_V }, // 3804
  { PseudoVLOXSEG2EI16_V_M2_M1_MASK, VLOXSEG2EI16_V }, // 3805
  { PseudoVLOXSEG2EI16_V_M2_M1_TU, VLOXSEG2EI16_V }, // 3806
  { PseudoVLOXSEG2EI16_V_M2_M2, VLOXSEG2EI16_V }, // 3807
  { PseudoVLOXSEG2EI16_V_M2_M2_MASK, VLOXSEG2EI16_V }, // 3808
  { PseudoVLOXSEG2EI16_V_M2_M2_TU, VLOXSEG2EI16_V }, // 3809
  { PseudoVLOXSEG2EI16_V_M2_M4, VLOXSEG2EI16_V }, // 3810
  { PseudoVLOXSEG2EI16_V_M2_M4_MASK, VLOXSEG2EI16_V }, // 3811
  { PseudoVLOXSEG2EI16_V_M2_M4_TU, VLOXSEG2EI16_V }, // 3812
  { PseudoVLOXSEG2EI16_V_M4_M2, VLOXSEG2EI16_V }, // 3813
  { PseudoVLOXSEG2EI16_V_M4_M2_MASK, VLOXSEG2EI16_V }, // 3814
  { PseudoVLOXSEG2EI16_V_M4_M2_TU, VLOXSEG2EI16_V }, // 3815
  { PseudoVLOXSEG2EI16_V_M4_M4, VLOXSEG2EI16_V }, // 3816
  { PseudoVLOXSEG2EI16_V_M4_M4_MASK, VLOXSEG2EI16_V }, // 3817
  { PseudoVLOXSEG2EI16_V_M4_M4_TU, VLOXSEG2EI16_V }, // 3818
  { PseudoVLOXSEG2EI16_V_M8_M4, VLOXSEG2EI16_V }, // 3819
  { PseudoVLOXSEG2EI16_V_M8_M4_MASK, VLOXSEG2EI16_V }, // 3820
  { PseudoVLOXSEG2EI16_V_M8_M4_TU, VLOXSEG2EI16_V }, // 3821
  { PseudoVLOXSEG2EI16_V_MF2_M1, VLOXSEG2EI16_V }, // 3822
  { PseudoVLOXSEG2EI16_V_MF2_M1_MASK, VLOXSEG2EI16_V }, // 3823
  { PseudoVLOXSEG2EI16_V_MF2_M1_TU, VLOXSEG2EI16_V }, // 3824
  { PseudoVLOXSEG2EI16_V_MF2_M2, VLOXSEG2EI16_V }, // 3825
  { PseudoVLOXSEG2EI16_V_MF2_M2_MASK, VLOXSEG2EI16_V }, // 3826
  { PseudoVLOXSEG2EI16_V_MF2_M2_TU, VLOXSEG2EI16_V }, // 3827
  { PseudoVLOXSEG2EI16_V_MF2_MF2, VLOXSEG2EI16_V }, // 3828
  { PseudoVLOXSEG2EI16_V_MF2_MF2_MASK, VLOXSEG2EI16_V }, // 3829
  { PseudoVLOXSEG2EI16_V_MF2_MF2_TU, VLOXSEG2EI16_V }, // 3830
  { PseudoVLOXSEG2EI16_V_MF2_MF4, VLOXSEG2EI16_V }, // 3831
  { PseudoVLOXSEG2EI16_V_MF2_MF4_MASK, VLOXSEG2EI16_V }, // 3832
  { PseudoVLOXSEG2EI16_V_MF2_MF4_TU, VLOXSEG2EI16_V }, // 3833
  { PseudoVLOXSEG2EI16_V_MF4_M1, VLOXSEG2EI16_V }, // 3834
  { PseudoVLOXSEG2EI16_V_MF4_M1_MASK, VLOXSEG2EI16_V }, // 3835
  { PseudoVLOXSEG2EI16_V_MF4_M1_TU, VLOXSEG2EI16_V }, // 3836
  { PseudoVLOXSEG2EI16_V_MF4_MF2, VLOXSEG2EI16_V }, // 3837
  { PseudoVLOXSEG2EI16_V_MF4_MF2_MASK, VLOXSEG2EI16_V }, // 3838
  { PseudoVLOXSEG2EI16_V_MF4_MF2_TU, VLOXSEG2EI16_V }, // 3839
  { PseudoVLOXSEG2EI16_V_MF4_MF4, VLOXSEG2EI16_V }, // 3840
  { PseudoVLOXSEG2EI16_V_MF4_MF4_MASK, VLOXSEG2EI16_V }, // 3841
  { PseudoVLOXSEG2EI16_V_MF4_MF4_TU, VLOXSEG2EI16_V }, // 3842
  { PseudoVLOXSEG2EI16_V_MF4_MF8, VLOXSEG2EI16_V }, // 3843
  { PseudoVLOXSEG2EI16_V_MF4_MF8_MASK, VLOXSEG2EI16_V }, // 3844
  { PseudoVLOXSEG2EI16_V_MF4_MF8_TU, VLOXSEG2EI16_V }, // 3845
  { PseudoVLOXSEG2EI32_V_M1_M1, VLOXSEG2EI32_V }, // 3846
  { PseudoVLOXSEG2EI32_V_M1_M1_MASK, VLOXSEG2EI32_V }, // 3847
  { PseudoVLOXSEG2EI32_V_M1_M1_TU, VLOXSEG2EI32_V }, // 3848
  { PseudoVLOXSEG2EI32_V_M1_M2, VLOXSEG2EI32_V }, // 3849
  { PseudoVLOXSEG2EI32_V_M1_M2_MASK, VLOXSEG2EI32_V }, // 3850
  { PseudoVLOXSEG2EI32_V_M1_M2_TU, VLOXSEG2EI32_V }, // 3851
  { PseudoVLOXSEG2EI32_V_M1_MF2, VLOXSEG2EI32_V }, // 3852
  { PseudoVLOXSEG2EI32_V_M1_MF2_MASK, VLOXSEG2EI32_V }, // 3853
  { PseudoVLOXSEG2EI32_V_M1_MF2_TU, VLOXSEG2EI32_V }, // 3854
  { PseudoVLOXSEG2EI32_V_M1_MF4, VLOXSEG2EI32_V }, // 3855
  { PseudoVLOXSEG2EI32_V_M1_MF4_MASK, VLOXSEG2EI32_V }, // 3856
  { PseudoVLOXSEG2EI32_V_M1_MF4_TU, VLOXSEG2EI32_V }, // 3857
  { PseudoVLOXSEG2EI32_V_M2_M1, VLOXSEG2EI32_V }, // 3858
  { PseudoVLOXSEG2EI32_V_M2_M1_MASK, VLOXSEG2EI32_V }, // 3859
  { PseudoVLOXSEG2EI32_V_M2_M1_TU, VLOXSEG2EI32_V }, // 3860
  { PseudoVLOXSEG2EI32_V_M2_M2, VLOXSEG2EI32_V }, // 3861
  { PseudoVLOXSEG2EI32_V_M2_M2_MASK, VLOXSEG2EI32_V }, // 3862
  { PseudoVLOXSEG2EI32_V_M2_M2_TU, VLOXSEG2EI32_V }, // 3863
  { PseudoVLOXSEG2EI32_V_M2_M4, VLOXSEG2EI32_V }, // 3864
  { PseudoVLOXSEG2EI32_V_M2_M4_MASK, VLOXSEG2EI32_V }, // 3865
  { PseudoVLOXSEG2EI32_V_M2_M4_TU, VLOXSEG2EI32_V }, // 3866
  { PseudoVLOXSEG2EI32_V_M2_MF2, VLOXSEG2EI32_V }, // 3867
  { PseudoVLOXSEG2EI32_V_M2_MF2_MASK, VLOXSEG2EI32_V }, // 3868
  { PseudoVLOXSEG2EI32_V_M2_MF2_TU, VLOXSEG2EI32_V }, // 3869
  { PseudoVLOXSEG2EI32_V_M4_M1, VLOXSEG2EI32_V }, // 3870
  { PseudoVLOXSEG2EI32_V_M4_M1_MASK, VLOXSEG2EI32_V }, // 3871
  { PseudoVLOXSEG2EI32_V_M4_M1_TU, VLOXSEG2EI32_V }, // 3872
  { PseudoVLOXSEG2EI32_V_M4_M2, VLOXSEG2EI32_V }, // 3873
  { PseudoVLOXSEG2EI32_V_M4_M2_MASK, VLOXSEG2EI32_V }, // 3874
  { PseudoVLOXSEG2EI32_V_M4_M2_TU, VLOXSEG2EI32_V }, // 3875
  { PseudoVLOXSEG2EI32_V_M4_M4, VLOXSEG2EI32_V }, // 3876
  { PseudoVLOXSEG2EI32_V_M4_M4_MASK, VLOXSEG2EI32_V }, // 3877
  { PseudoVLOXSEG2EI32_V_M4_M4_TU, VLOXSEG2EI32_V }, // 3878
  { PseudoVLOXSEG2EI32_V_M8_M2, VLOXSEG2EI32_V }, // 3879
  { PseudoVLOXSEG2EI32_V_M8_M2_MASK, VLOXSEG2EI32_V }, // 3880
  { PseudoVLOXSEG2EI32_V_M8_M2_TU, VLOXSEG2EI32_V }, // 3881
  { PseudoVLOXSEG2EI32_V_M8_M4, VLOXSEG2EI32_V }, // 3882
  { PseudoVLOXSEG2EI32_V_M8_M4_MASK, VLOXSEG2EI32_V }, // 3883
  { PseudoVLOXSEG2EI32_V_M8_M4_TU, VLOXSEG2EI32_V }, // 3884
  { PseudoVLOXSEG2EI32_V_MF2_M1, VLOXSEG2EI32_V }, // 3885
  { PseudoVLOXSEG2EI32_V_MF2_M1_MASK, VLOXSEG2EI32_V }, // 3886
  { PseudoVLOXSEG2EI32_V_MF2_M1_TU, VLOXSEG2EI32_V }, // 3887
  { PseudoVLOXSEG2EI32_V_MF2_MF2, VLOXSEG2EI32_V }, // 3888
  { PseudoVLOXSEG2EI32_V_MF2_MF2_MASK, VLOXSEG2EI32_V }, // 3889
  { PseudoVLOXSEG2EI32_V_MF2_MF2_TU, VLOXSEG2EI32_V }, // 3890
  { PseudoVLOXSEG2EI32_V_MF2_MF4, VLOXSEG2EI32_V }, // 3891
  { PseudoVLOXSEG2EI32_V_MF2_MF4_MASK, VLOXSEG2EI32_V }, // 3892
  { PseudoVLOXSEG2EI32_V_MF2_MF4_TU, VLOXSEG2EI32_V }, // 3893
  { PseudoVLOXSEG2EI32_V_MF2_MF8, VLOXSEG2EI32_V }, // 3894
  { PseudoVLOXSEG2EI32_V_MF2_MF8_MASK, VLOXSEG2EI32_V }, // 3895
  { PseudoVLOXSEG2EI32_V_MF2_MF8_TU, VLOXSEG2EI32_V }, // 3896
  { PseudoVLOXSEG2EI64_V_M1_M1, VLOXSEG2EI64_V }, // 3897
  { PseudoVLOXSEG2EI64_V_M1_M1_MASK, VLOXSEG2EI64_V }, // 3898
  { PseudoVLOXSEG2EI64_V_M1_M1_TU, VLOXSEG2EI64_V }, // 3899
  { PseudoVLOXSEG2EI64_V_M1_MF2, VLOXSEG2EI64_V }, // 3900
  { PseudoVLOXSEG2EI64_V_M1_MF2_MASK, VLOXSEG2EI64_V }, // 3901
  { PseudoVLOXSEG2EI64_V_M1_MF2_TU, VLOXSEG2EI64_V }, // 3902
  { PseudoVLOXSEG2EI64_V_M1_MF4, VLOXSEG2EI64_V }, // 3903
  { PseudoVLOXSEG2EI64_V_M1_MF4_MASK, VLOXSEG2EI64_V }, // 3904
  { PseudoVLOXSEG2EI64_V_M1_MF4_TU, VLOXSEG2EI64_V }, // 3905
  { PseudoVLOXSEG2EI64_V_M1_MF8, VLOXSEG2EI64_V }, // 3906
  { PseudoVLOXSEG2EI64_V_M1_MF8_MASK, VLOXSEG2EI64_V }, // 3907
  { PseudoVLOXSEG2EI64_V_M1_MF8_TU, VLOXSEG2EI64_V }, // 3908
  { PseudoVLOXSEG2EI64_V_M2_M1, VLOXSEG2EI64_V }, // 3909
  { PseudoVLOXSEG2EI64_V_M2_M1_MASK, VLOXSEG2EI64_V }, // 3910
  { PseudoVLOXSEG2EI64_V_M2_M1_TU, VLOXSEG2EI64_V }, // 3911
  { PseudoVLOXSEG2EI64_V_M2_M2, VLOXSEG2EI64_V }, // 3912
  { PseudoVLOXSEG2EI64_V_M2_M2_MASK, VLOXSEG2EI64_V }, // 3913
  { PseudoVLOXSEG2EI64_V_M2_M2_TU, VLOXSEG2EI64_V }, // 3914
  { PseudoVLOXSEG2EI64_V_M2_MF2, VLOXSEG2EI64_V }, // 3915
  { PseudoVLOXSEG2EI64_V_M2_MF2_MASK, VLOXSEG2EI64_V }, // 3916
  { PseudoVLOXSEG2EI64_V_M2_MF2_TU, VLOXSEG2EI64_V }, // 3917
  { PseudoVLOXSEG2EI64_V_M2_MF4, VLOXSEG2EI64_V }, // 3918
  { PseudoVLOXSEG2EI64_V_M2_MF4_MASK, VLOXSEG2EI64_V }, // 3919
  { PseudoVLOXSEG2EI64_V_M2_MF4_TU, VLOXSEG2EI64_V }, // 3920
  { PseudoVLOXSEG2EI64_V_M4_M1, VLOXSEG2EI64_V }, // 3921
  { PseudoVLOXSEG2EI64_V_M4_M1_MASK, VLOXSEG2EI64_V }, // 3922
  { PseudoVLOXSEG2EI64_V_M4_M1_TU, VLOXSEG2EI64_V }, // 3923
  { PseudoVLOXSEG2EI64_V_M4_M2, VLOXSEG2EI64_V }, // 3924
  { PseudoVLOXSEG2EI64_V_M4_M2_MASK, VLOXSEG2EI64_V }, // 3925
  { PseudoVLOXSEG2EI64_V_M4_M2_TU, VLOXSEG2EI64_V }, // 3926
  { PseudoVLOXSEG2EI64_V_M4_M4, VLOXSEG2EI64_V }, // 3927
  { PseudoVLOXSEG2EI64_V_M4_M4_MASK, VLOXSEG2EI64_V }, // 3928
  { PseudoVLOXSEG2EI64_V_M4_M4_TU, VLOXSEG2EI64_V }, // 3929
  { PseudoVLOXSEG2EI64_V_M4_MF2, VLOXSEG2EI64_V }, // 3930
  { PseudoVLOXSEG2EI64_V_M4_MF2_MASK, VLOXSEG2EI64_V }, // 3931
  { PseudoVLOXSEG2EI64_V_M4_MF2_TU, VLOXSEG2EI64_V }, // 3932
  { PseudoVLOXSEG2EI64_V_M8_M1, VLOXSEG2EI64_V }, // 3933
  { PseudoVLOXSEG2EI64_V_M8_M1_MASK, VLOXSEG2EI64_V }, // 3934
  { PseudoVLOXSEG2EI64_V_M8_M1_TU, VLOXSEG2EI64_V }, // 3935
  { PseudoVLOXSEG2EI64_V_M8_M2, VLOXSEG2EI64_V }, // 3936
  { PseudoVLOXSEG2EI64_V_M8_M2_MASK, VLOXSEG2EI64_V }, // 3937
  { PseudoVLOXSEG2EI64_V_M8_M2_TU, VLOXSEG2EI64_V }, // 3938
  { PseudoVLOXSEG2EI64_V_M8_M4, VLOXSEG2EI64_V }, // 3939
  { PseudoVLOXSEG2EI64_V_M8_M4_MASK, VLOXSEG2EI64_V }, // 3940
  { PseudoVLOXSEG2EI64_V_M8_M4_TU, VLOXSEG2EI64_V }, // 3941
  { PseudoVLOXSEG2EI8_V_M1_M1, VLOXSEG2EI8_V }, // 3942
  { PseudoVLOXSEG2EI8_V_M1_M1_MASK, VLOXSEG2EI8_V }, // 3943
  { PseudoVLOXSEG2EI8_V_M1_M1_TU, VLOXSEG2EI8_V }, // 3944
  { PseudoVLOXSEG2EI8_V_M1_M2, VLOXSEG2EI8_V }, // 3945
  { PseudoVLOXSEG2EI8_V_M1_M2_MASK, VLOXSEG2EI8_V }, // 3946
  { PseudoVLOXSEG2EI8_V_M1_M2_TU, VLOXSEG2EI8_V }, // 3947
  { PseudoVLOXSEG2EI8_V_M1_M4, VLOXSEG2EI8_V }, // 3948
  { PseudoVLOXSEG2EI8_V_M1_M4_MASK, VLOXSEG2EI8_V }, // 3949
  { PseudoVLOXSEG2EI8_V_M1_M4_TU, VLOXSEG2EI8_V }, // 3950
  { PseudoVLOXSEG2EI8_V_M2_M2, VLOXSEG2EI8_V }, // 3951
  { PseudoVLOXSEG2EI8_V_M2_M2_MASK, VLOXSEG2EI8_V }, // 3952
  { PseudoVLOXSEG2EI8_V_M2_M2_TU, VLOXSEG2EI8_V }, // 3953
  { PseudoVLOXSEG2EI8_V_M2_M4, VLOXSEG2EI8_V }, // 3954
  { PseudoVLOXSEG2EI8_V_M2_M4_MASK, VLOXSEG2EI8_V }, // 3955
  { PseudoVLOXSEG2EI8_V_M2_M4_TU, VLOXSEG2EI8_V }, // 3956
  { PseudoVLOXSEG2EI8_V_M4_M4, VLOXSEG2EI8_V }, // 3957
  { PseudoVLOXSEG2EI8_V_M4_M4_MASK, VLOXSEG2EI8_V }, // 3958
  { PseudoVLOXSEG2EI8_V_M4_M4_TU, VLOXSEG2EI8_V }, // 3959
  { PseudoVLOXSEG2EI8_V_MF2_M1, VLOXSEG2EI8_V }, // 3960
  { PseudoVLOXSEG2EI8_V_MF2_M1_MASK, VLOXSEG2EI8_V }, // 3961
  { PseudoVLOXSEG2EI8_V_MF2_M1_TU, VLOXSEG2EI8_V }, // 3962
  { PseudoVLOXSEG2EI8_V_MF2_M2, VLOXSEG2EI8_V }, // 3963
  { PseudoVLOXSEG2EI8_V_MF2_M2_MASK, VLOXSEG2EI8_V }, // 3964
  { PseudoVLOXSEG2EI8_V_MF2_M2_TU, VLOXSEG2EI8_V }, // 3965
  { PseudoVLOXSEG2EI8_V_MF2_M4, VLOXSEG2EI8_V }, // 3966
  { PseudoVLOXSEG2EI8_V_MF2_M4_MASK, VLOXSEG2EI8_V }, // 3967
  { PseudoVLOXSEG2EI8_V_MF2_M4_TU, VLOXSEG2EI8_V }, // 3968
  { PseudoVLOXSEG2EI8_V_MF2_MF2, VLOXSEG2EI8_V }, // 3969
  { PseudoVLOXSEG2EI8_V_MF2_MF2_MASK, VLOXSEG2EI8_V }, // 3970
  { PseudoVLOXSEG2EI8_V_MF2_MF2_TU, VLOXSEG2EI8_V }, // 3971
  { PseudoVLOXSEG2EI8_V_MF4_M1, VLOXSEG2EI8_V }, // 3972
  { PseudoVLOXSEG2EI8_V_MF4_M1_MASK, VLOXSEG2EI8_V }, // 3973
  { PseudoVLOXSEG2EI8_V_MF4_M1_TU, VLOXSEG2EI8_V }, // 3974
  { PseudoVLOXSEG2EI8_V_MF4_M2, VLOXSEG2EI8_V }, // 3975
  { PseudoVLOXSEG2EI8_V_MF4_M2_MASK, VLOXSEG2EI8_V }, // 3976
  { PseudoVLOXSEG2EI8_V_MF4_M2_TU, VLOXSEG2EI8_V }, // 3977
  { PseudoVLOXSEG2EI8_V_MF4_MF2, VLOXSEG2EI8_V }, // 3978
  { PseudoVLOXSEG2EI8_V_MF4_MF2_MASK, VLOXSEG2EI8_V }, // 3979
  { PseudoVLOXSEG2EI8_V_MF4_MF2_TU, VLOXSEG2EI8_V }, // 3980
  { PseudoVLOXSEG2EI8_V_MF4_MF4, VLOXSEG2EI8_V }, // 3981
  { PseudoVLOXSEG2EI8_V_MF4_MF4_MASK, VLOXSEG2EI8_V }, // 3982
  { PseudoVLOXSEG2EI8_V_MF4_MF4_TU, VLOXSEG2EI8_V }, // 3983
  { PseudoVLOXSEG2EI8_V_MF8_M1, VLOXSEG2EI8_V }, // 3984
  { PseudoVLOXSEG2EI8_V_MF8_M1_MASK, VLOXSEG2EI8_V }, // 3985
  { PseudoVLOXSEG2EI8_V_MF8_M1_TU, VLOXSEG2EI8_V }, // 3986
  { PseudoVLOXSEG2EI8_V_MF8_MF2, VLOXSEG2EI8_V }, // 3987
  { PseudoVLOXSEG2EI8_V_MF8_MF2_MASK, VLOXSEG2EI8_V }, // 3988
  { PseudoVLOXSEG2EI8_V_MF8_MF2_TU, VLOXSEG2EI8_V }, // 3989
  { PseudoVLOXSEG2EI8_V_MF8_MF4, VLOXSEG2EI8_V }, // 3990
  { PseudoVLOXSEG2EI8_V_MF8_MF4_MASK, VLOXSEG2EI8_V }, // 3991
  { PseudoVLOXSEG2EI8_V_MF8_MF4_TU, VLOXSEG2EI8_V }, // 3992
  { PseudoVLOXSEG2EI8_V_MF8_MF8, VLOXSEG2EI8_V }, // 3993
  { PseudoVLOXSEG2EI8_V_MF8_MF8_MASK, VLOXSEG2EI8_V }, // 3994
  { PseudoVLOXSEG2EI8_V_MF8_MF8_TU, VLOXSEG2EI8_V }, // 3995
  { PseudoVLOXSEG3EI16_V_M1_M1, VLOXSEG3EI16_V }, // 3996
  { PseudoVLOXSEG3EI16_V_M1_M1_MASK, VLOXSEG3EI16_V }, // 3997
  { PseudoVLOXSEG3EI16_V_M1_M1_TU, VLOXSEG3EI16_V }, // 3998
  { PseudoVLOXSEG3EI16_V_M1_M2, VLOXSEG3EI16_V }, // 3999
  { PseudoVLOXSEG3EI16_V_M1_M2_MASK, VLOXSEG3EI16_V }, // 4000
  { PseudoVLOXSEG3EI16_V_M1_M2_TU, VLOXSEG3EI16_V }, // 4001
  { PseudoVLOXSEG3EI16_V_M1_MF2, VLOXSEG3EI16_V }, // 4002
  { PseudoVLOXSEG3EI16_V_M1_MF2_MASK, VLOXSEG3EI16_V }, // 4003
  { PseudoVLOXSEG3EI16_V_M1_MF2_TU, VLOXSEG3EI16_V }, // 4004
  { PseudoVLOXSEG3EI16_V_M2_M1, VLOXSEG3EI16_V }, // 4005
  { PseudoVLOXSEG3EI16_V_M2_M1_MASK, VLOXSEG3EI16_V }, // 4006
  { PseudoVLOXSEG3EI16_V_M2_M1_TU, VLOXSEG3EI16_V }, // 4007
  { PseudoVLOXSEG3EI16_V_M2_M2, VLOXSEG3EI16_V }, // 4008
  { PseudoVLOXSEG3EI16_V_M2_M2_MASK, VLOXSEG3EI16_V }, // 4009
  { PseudoVLOXSEG3EI16_V_M2_M2_TU, VLOXSEG3EI16_V }, // 4010
  { PseudoVLOXSEG3EI16_V_M4_M2, VLOXSEG3EI16_V }, // 4011
  { PseudoVLOXSEG3EI16_V_M4_M2_MASK, VLOXSEG3EI16_V }, // 4012
  { PseudoVLOXSEG3EI16_V_M4_M2_TU, VLOXSEG3EI16_V }, // 4013
  { PseudoVLOXSEG3EI16_V_MF2_M1, VLOXSEG3EI16_V }, // 4014
  { PseudoVLOXSEG3EI16_V_MF2_M1_MASK, VLOXSEG3EI16_V }, // 4015
  { PseudoVLOXSEG3EI16_V_MF2_M1_TU, VLOXSEG3EI16_V }, // 4016
  { PseudoVLOXSEG3EI16_V_MF2_M2, VLOXSEG3EI16_V }, // 4017
  { PseudoVLOXSEG3EI16_V_MF2_M2_MASK, VLOXSEG3EI16_V }, // 4018
  { PseudoVLOXSEG3EI16_V_MF2_M2_TU, VLOXSEG3EI16_V }, // 4019
  { PseudoVLOXSEG3EI16_V_MF2_MF2, VLOXSEG3EI16_V }, // 4020
  { PseudoVLOXSEG3EI16_V_MF2_MF2_MASK, VLOXSEG3EI16_V }, // 4021
  { PseudoVLOXSEG3EI16_V_MF2_MF2_TU, VLOXSEG3EI16_V }, // 4022
  { PseudoVLOXSEG3EI16_V_MF2_MF4, VLOXSEG3EI16_V }, // 4023
  { PseudoVLOXSEG3EI16_V_MF2_MF4_MASK, VLOXSEG3EI16_V }, // 4024
  { PseudoVLOXSEG3EI16_V_MF2_MF4_TU, VLOXSEG3EI16_V }, // 4025
  { PseudoVLOXSEG3EI16_V_MF4_M1, VLOXSEG3EI16_V }, // 4026
  { PseudoVLOXSEG3EI16_V_MF4_M1_MASK, VLOXSEG3EI16_V }, // 4027
  { PseudoVLOXSEG3EI16_V_MF4_M1_TU, VLOXSEG3EI16_V }, // 4028
  { PseudoVLOXSEG3EI16_V_MF4_MF2, VLOXSEG3EI16_V }, // 4029
  { PseudoVLOXSEG3EI16_V_MF4_MF2_MASK, VLOXSEG3EI16_V }, // 4030
  { PseudoVLOXSEG3EI16_V_MF4_MF2_TU, VLOXSEG3EI16_V }, // 4031
  { PseudoVLOXSEG3EI16_V_MF4_MF4, VLOXSEG3EI16_V }, // 4032
  { PseudoVLOXSEG3EI16_V_MF4_MF4_MASK, VLOXSEG3EI16_V }, // 4033
  { PseudoVLOXSEG3EI16_V_MF4_MF4_TU, VLOXSEG3EI16_V }, // 4034
  { PseudoVLOXSEG3EI16_V_MF4_MF8, VLOXSEG3EI16_V }, // 4035
  { PseudoVLOXSEG3EI16_V_MF4_MF8_MASK, VLOXSEG3EI16_V }, // 4036
  { PseudoVLOXSEG3EI16_V_MF4_MF8_TU, VLOXSEG3EI16_V }, // 4037
  { PseudoVLOXSEG3EI32_V_M1_M1, VLOXSEG3EI32_V }, // 4038
  { PseudoVLOXSEG3EI32_V_M1_M1_MASK, VLOXSEG3EI32_V }, // 4039
  { PseudoVLOXSEG3EI32_V_M1_M1_TU, VLOXSEG3EI32_V }, // 4040
  { PseudoVLOXSEG3EI32_V_M1_M2, VLOXSEG3EI32_V }, // 4041
  { PseudoVLOXSEG3EI32_V_M1_M2_MASK, VLOXSEG3EI32_V }, // 4042
  { PseudoVLOXSEG3EI32_V_M1_M2_TU, VLOXSEG3EI32_V }, // 4043
  { PseudoVLOXSEG3EI32_V_M1_MF2, VLOXSEG3EI32_V }, // 4044
  { PseudoVLOXSEG3EI32_V_M1_MF2_MASK, VLOXSEG3EI32_V }, // 4045
  { PseudoVLOXSEG3EI32_V_M1_MF2_TU, VLOXSEG3EI32_V }, // 4046
  { PseudoVLOXSEG3EI32_V_M1_MF4, VLOXSEG3EI32_V }, // 4047
  { PseudoVLOXSEG3EI32_V_M1_MF4_MASK, VLOXSEG3EI32_V }, // 4048
  { PseudoVLOXSEG3EI32_V_M1_MF4_TU, VLOXSEG3EI32_V }, // 4049
  { PseudoVLOXSEG3EI32_V_M2_M1, VLOXSEG3EI32_V }, // 4050
  { PseudoVLOXSEG3EI32_V_M2_M1_MASK, VLOXSEG3EI32_V }, // 4051
  { PseudoVLOXSEG3EI32_V_M2_M1_TU, VLOXSEG3EI32_V }, // 4052
  { PseudoVLOXSEG3EI32_V_M2_M2, VLOXSEG3EI32_V }, // 4053
  { PseudoVLOXSEG3EI32_V_M2_M2_MASK, VLOXSEG3EI32_V }, // 4054
  { PseudoVLOXSEG3EI32_V_M2_M2_TU, VLOXSEG3EI32_V }, // 4055
  { PseudoVLOXSEG3EI32_V_M2_MF2, VLOXSEG3EI32_V }, // 4056
  { PseudoVLOXSEG3EI32_V_M2_MF2_MASK, VLOXSEG3EI32_V }, // 4057
  { PseudoVLOXSEG3EI32_V_M2_MF2_TU, VLOXSEG3EI32_V }, // 4058
  { PseudoVLOXSEG3EI32_V_M4_M1, VLOXSEG3EI32_V }, // 4059
  { PseudoVLOXSEG3EI32_V_M4_M1_MASK, VLOXSEG3EI32_V }, // 4060
  { PseudoVLOXSEG3EI32_V_M4_M1_TU, VLOXSEG3EI32_V }, // 4061
  { PseudoVLOXSEG3EI32_V_M4_M2, VLOXSEG3EI32_V }, // 4062
  { PseudoVLOXSEG3EI32_V_M4_M2_MASK, VLOXSEG3EI32_V }, // 4063
  { PseudoVLOXSEG3EI32_V_M4_M2_TU, VLOXSEG3EI32_V }, // 4064
  { PseudoVLOXSEG3EI32_V_M8_M2, VLOXSEG3EI32_V }, // 4065
  { PseudoVLOXSEG3EI32_V_M8_M2_MASK, VLOXSEG3EI32_V }, // 4066
  { PseudoVLOXSEG3EI32_V_M8_M2_TU, VLOXSEG3EI32_V }, // 4067
  { PseudoVLOXSEG3EI32_V_MF2_M1, VLOXSEG3EI32_V }, // 4068
  { PseudoVLOXSEG3EI32_V_MF2_M1_MASK, VLOXSEG3EI32_V }, // 4069
  { PseudoVLOXSEG3EI32_V_MF2_M1_TU, VLOXSEG3EI32_V }, // 4070
  { PseudoVLOXSEG3EI32_V_MF2_MF2, VLOXSEG3EI32_V }, // 4071
  { PseudoVLOXSEG3EI32_V_MF2_MF2_MASK, VLOXSEG3EI32_V }, // 4072
  { PseudoVLOXSEG3EI32_V_MF2_MF2_TU, VLOXSEG3EI32_V }, // 4073
  { PseudoVLOXSEG3EI32_V_MF2_MF4, VLOXSEG3EI32_V }, // 4074
  { PseudoVLOXSEG3EI32_V_MF2_MF4_MASK, VLOXSEG3EI32_V }, // 4075
  { PseudoVLOXSEG3EI32_V_MF2_MF4_TU, VLOXSEG3EI32_V }, // 4076
  { PseudoVLOXSEG3EI32_V_MF2_MF8, VLOXSEG3EI32_V }, // 4077
  { PseudoVLOXSEG3EI32_V_MF2_MF8_MASK, VLOXSEG3EI32_V }, // 4078
  { PseudoVLOXSEG3EI32_V_MF2_MF8_TU, VLOXSEG3EI32_V }, // 4079
  { PseudoVLOXSEG3EI64_V_M1_M1, VLOXSEG3EI64_V }, // 4080
  { PseudoVLOXSEG3EI64_V_M1_M1_MASK, VLOXSEG3EI64_V }, // 4081
  { PseudoVLOXSEG3EI64_V_M1_M1_TU, VLOXSEG3EI64_V }, // 4082
  { PseudoVLOXSEG3EI64_V_M1_MF2, VLOXSEG3EI64_V }, // 4083
  { PseudoVLOXSEG3EI64_V_M1_MF2_MASK, VLOXSEG3EI64_V }, // 4084
  { PseudoVLOXSEG3EI64_V_M1_MF2_TU, VLOXSEG3EI64_V }, // 4085
  { PseudoVLOXSEG3EI64_V_M1_MF4, VLOXSEG3EI64_V }, // 4086
  { PseudoVLOXSEG3EI64_V_M1_MF4_MASK, VLOXSEG3EI64_V }, // 4087
  { PseudoVLOXSEG3EI64_V_M1_MF4_TU, VLOXSEG3EI64_V }, // 4088
  { PseudoVLOXSEG3EI64_V_M1_MF8, VLOXSEG3EI64_V }, // 4089
  { PseudoVLOXSEG3EI64_V_M1_MF8_MASK, VLOXSEG3EI64_V }, // 4090
  { PseudoVLOXSEG3EI64_V_M1_MF8_TU, VLOXSEG3EI64_V }, // 4091
  { PseudoVLOXSEG3EI64_V_M2_M1, VLOXSEG3EI64_V }, // 4092
  { PseudoVLOXSEG3EI64_V_M2_M1_MASK, VLOXSEG3EI64_V }, // 4093
  { PseudoVLOXSEG3EI64_V_M2_M1_TU, VLOXSEG3EI64_V }, // 4094
  { PseudoVLOXSEG3EI64_V_M2_M2, VLOXSEG3EI64_V }, // 4095
  { PseudoVLOXSEG3EI64_V_M2_M2_MASK, VLOXSEG3EI64_V }, // 4096
  { PseudoVLOXSEG3EI64_V_M2_M2_TU, VLOXSEG3EI64_V }, // 4097
  { PseudoVLOXSEG3EI64_V_M2_MF2, VLOXSEG3EI64_V }, // 4098
  { PseudoVLOXSEG3EI64_V_M2_MF2_MASK, VLOXSEG3EI64_V }, // 4099
  { PseudoVLOXSEG3EI64_V_M2_MF2_TU, VLOXSEG3EI64_V }, // 4100
  { PseudoVLOXSEG3EI64_V_M2_MF4, VLOXSEG3EI64_V }, // 4101
  { PseudoVLOXSEG3EI64_V_M2_MF4_MASK, VLOXSEG3EI64_V }, // 4102
  { PseudoVLOXSEG3EI64_V_M2_MF4_TU, VLOXSEG3EI64_V }, // 4103
  { PseudoVLOXSEG3EI64_V_M4_M1, VLOXSEG3EI64_V }, // 4104
  { PseudoVLOXSEG3EI64_V_M4_M1_MASK, VLOXSEG3EI64_V }, // 4105
  { PseudoVLOXSEG3EI64_V_M4_M1_TU, VLOXSEG3EI64_V }, // 4106
  { PseudoVLOXSEG3EI64_V_M4_M2, VLOXSEG3EI64_V }, // 4107
  { PseudoVLOXSEG3EI64_V_M4_M2_MASK, VLOXSEG3EI64_V }, // 4108
  { PseudoVLOXSEG3EI64_V_M4_M2_TU, VLOXSEG3EI64_V }, // 4109
  { PseudoVLOXSEG3EI64_V_M4_MF2, VLOXSEG3EI64_V }, // 4110
  { PseudoVLOXSEG3EI64_V_M4_MF2_MASK, VLOXSEG3EI64_V }, // 4111
  { PseudoVLOXSEG3EI64_V_M4_MF2_TU, VLOXSEG3EI64_V }, // 4112
  { PseudoVLOXSEG3EI64_V_M8_M1, VLOXSEG3EI64_V }, // 4113
  { PseudoVLOXSEG3EI64_V_M8_M1_MASK, VLOXSEG3EI64_V }, // 4114
  { PseudoVLOXSEG3EI64_V_M8_M1_TU, VLOXSEG3EI64_V }, // 4115
  { PseudoVLOXSEG3EI64_V_M8_M2, VLOXSEG3EI64_V }, // 4116
  { PseudoVLOXSEG3EI64_V_M8_M2_MASK, VLOXSEG3EI64_V }, // 4117
  { PseudoVLOXSEG3EI64_V_M8_M2_TU, VLOXSEG3EI64_V }, // 4118
  { PseudoVLOXSEG3EI8_V_M1_M1, VLOXSEG3EI8_V }, // 4119
  { PseudoVLOXSEG3EI8_V_M1_M1_MASK, VLOXSEG3EI8_V }, // 4120
  { PseudoVLOXSEG3EI8_V_M1_M1_TU, VLOXSEG3EI8_V }, // 4121
  { PseudoVLOXSEG3EI8_V_M1_M2, VLOXSEG3EI8_V }, // 4122
  { PseudoVLOXSEG3EI8_V_M1_M2_MASK, VLOXSEG3EI8_V }, // 4123
  { PseudoVLOXSEG3EI8_V_M1_M2_TU, VLOXSEG3EI8_V }, // 4124
  { PseudoVLOXSEG3EI8_V_M2_M2, VLOXSEG3EI8_V }, // 4125
  { PseudoVLOXSEG3EI8_V_M2_M2_MASK, VLOXSEG3EI8_V }, // 4126
  { PseudoVLOXSEG3EI8_V_M2_M2_TU, VLOXSEG3EI8_V }, // 4127
  { PseudoVLOXSEG3EI8_V_MF2_M1, VLOXSEG3EI8_V }, // 4128
  { PseudoVLOXSEG3EI8_V_MF2_M1_MASK, VLOXSEG3EI8_V }, // 4129
  { PseudoVLOXSEG3EI8_V_MF2_M1_TU, VLOXSEG3EI8_V }, // 4130
  { PseudoVLOXSEG3EI8_V_MF2_M2, VLOXSEG3EI8_V }, // 4131
  { PseudoVLOXSEG3EI8_V_MF2_M2_MASK, VLOXSEG3EI8_V }, // 4132
  { PseudoVLOXSEG3EI8_V_MF2_M2_TU, VLOXSEG3EI8_V }, // 4133
  { PseudoVLOXSEG3EI8_V_MF2_MF2, VLOXSEG3EI8_V }, // 4134
  { PseudoVLOXSEG3EI8_V_MF2_MF2_MASK, VLOXSEG3EI8_V }, // 4135
  { PseudoVLOXSEG3EI8_V_MF2_MF2_TU, VLOXSEG3EI8_V }, // 4136
  { PseudoVLOXSEG3EI8_V_MF4_M1, VLOXSEG3EI8_V }, // 4137
  { PseudoVLOXSEG3EI8_V_MF4_M1_MASK, VLOXSEG3EI8_V }, // 4138
  { PseudoVLOXSEG3EI8_V_MF4_M1_TU, VLOXSEG3EI8_V }, // 4139
  { PseudoVLOXSEG3EI8_V_MF4_M2, VLOXSEG3EI8_V }, // 4140
  { PseudoVLOXSEG3EI8_V_MF4_M2_MASK, VLOXSEG3EI8_V }, // 4141
  { PseudoVLOXSEG3EI8_V_MF4_M2_TU, VLOXSEG3EI8_V }, // 4142
  { PseudoVLOXSEG3EI8_V_MF4_MF2, VLOXSEG3EI8_V }, // 4143
  { PseudoVLOXSEG3EI8_V_MF4_MF2_MASK, VLOXSEG3EI8_V }, // 4144
  { PseudoVLOXSEG3EI8_V_MF4_MF2_TU, VLOXSEG3EI8_V }, // 4145
  { PseudoVLOXSEG3EI8_V_MF4_MF4, VLOXSEG3EI8_V }, // 4146
  { PseudoVLOXSEG3EI8_V_MF4_MF4_MASK, VLOXSEG3EI8_V }, // 4147
  { PseudoVLOXSEG3EI8_V_MF4_MF4_TU, VLOXSEG3EI8_V }, // 4148
  { PseudoVLOXSEG3EI8_V_MF8_M1, VLOXSEG3EI8_V }, // 4149
  { PseudoVLOXSEG3EI8_V_MF8_M1_MASK, VLOXSEG3EI8_V }, // 4150
  { PseudoVLOXSEG3EI8_V_MF8_M1_TU, VLOXSEG3EI8_V }, // 4151
  { PseudoVLOXSEG3EI8_V_MF8_MF2, VLOXSEG3EI8_V }, // 4152
  { PseudoVLOXSEG3EI8_V_MF8_MF2_MASK, VLOXSEG3EI8_V }, // 4153
  { PseudoVLOXSEG3EI8_V_MF8_MF2_TU, VLOXSEG3EI8_V }, // 4154
  { PseudoVLOXSEG3EI8_V_MF8_MF4, VLOXSEG3EI8_V }, // 4155
  { PseudoVLOXSEG3EI8_V_MF8_MF4_MASK, VLOXSEG3EI8_V }, // 4156
  { PseudoVLOXSEG3EI8_V_MF8_MF4_TU, VLOXSEG3EI8_V }, // 4157
  { PseudoVLOXSEG3EI8_V_MF8_MF8, VLOXSEG3EI8_V }, // 4158
  { PseudoVLOXSEG3EI8_V_MF8_MF8_MASK, VLOXSEG3EI8_V }, // 4159
  { PseudoVLOXSEG3EI8_V_MF8_MF8_TU, VLOXSEG3EI8_V }, // 4160
  { PseudoVLOXSEG4EI16_V_M1_M1, VLOXSEG4EI16_V }, // 4161
  { PseudoVLOXSEG4EI16_V_M1_M1_MASK, VLOXSEG4EI16_V }, // 4162
  { PseudoVLOXSEG4EI16_V_M1_M1_TU, VLOXSEG4EI16_V }, // 4163
  { PseudoVLOXSEG4EI16_V_M1_M2, VLOXSEG4EI16_V }, // 4164
  { PseudoVLOXSEG4EI16_V_M1_M2_MASK, VLOXSEG4EI16_V }, // 4165
  { PseudoVLOXSEG4EI16_V_M1_M2_TU, VLOXSEG4EI16_V }, // 4166
  { PseudoVLOXSEG4EI16_V_M1_MF2, VLOXSEG4EI16_V }, // 4167
  { PseudoVLOXSEG4EI16_V_M1_MF2_MASK, VLOXSEG4EI16_V }, // 4168
  { PseudoVLOXSEG4EI16_V_M1_MF2_TU, VLOXSEG4EI16_V }, // 4169
  { PseudoVLOXSEG4EI16_V_M2_M1, VLOXSEG4EI16_V }, // 4170
  { PseudoVLOXSEG4EI16_V_M2_M1_MASK, VLOXSEG4EI16_V }, // 4171
  { PseudoVLOXSEG4EI16_V_M2_M1_TU, VLOXSEG4EI16_V }, // 4172
  { PseudoVLOXSEG4EI16_V_M2_M2, VLOXSEG4EI16_V }, // 4173
  { PseudoVLOXSEG4EI16_V_M2_M2_MASK, VLOXSEG4EI16_V }, // 4174
  { PseudoVLOXSEG4EI16_V_M2_M2_TU, VLOXSEG4EI16_V }, // 4175
  { PseudoVLOXSEG4EI16_V_M4_M2, VLOXSEG4EI16_V }, // 4176
  { PseudoVLOXSEG4EI16_V_M4_M2_MASK, VLOXSEG4EI16_V }, // 4177
  { PseudoVLOXSEG4EI16_V_M4_M2_TU, VLOXSEG4EI16_V }, // 4178
  { PseudoVLOXSEG4EI16_V_MF2_M1, VLOXSEG4EI16_V }, // 4179
  { PseudoVLOXSEG4EI16_V_MF2_M1_MASK, VLOXSEG4EI16_V }, // 4180
  { PseudoVLOXSEG4EI16_V_MF2_M1_TU, VLOXSEG4EI16_V }, // 4181
  { PseudoVLOXSEG4EI16_V_MF2_M2, VLOXSEG4EI16_V }, // 4182
  { PseudoVLOXSEG4EI16_V_MF2_M2_MASK, VLOXSEG4EI16_V }, // 4183
  { PseudoVLOXSEG4EI16_V_MF2_M2_TU, VLOXSEG4EI16_V }, // 4184
  { PseudoVLOXSEG4EI16_V_MF2_MF2, VLOXSEG4EI16_V }, // 4185
  { PseudoVLOXSEG4EI16_V_MF2_MF2_MASK, VLOXSEG4EI16_V }, // 4186
  { PseudoVLOXSEG4EI16_V_MF2_MF2_TU, VLOXSEG4EI16_V }, // 4187
  { PseudoVLOXSEG4EI16_V_MF2_MF4, VLOXSEG4EI16_V }, // 4188
  { PseudoVLOXSEG4EI16_V_MF2_MF4_MASK, VLOXSEG4EI16_V }, // 4189
  { PseudoVLOXSEG4EI16_V_MF2_MF4_TU, VLOXSEG4EI16_V }, // 4190
  { PseudoVLOXSEG4EI16_V_MF4_M1, VLOXSEG4EI16_V }, // 4191
  { PseudoVLOXSEG4EI16_V_MF4_M1_MASK, VLOXSEG4EI16_V }, // 4192
  { PseudoVLOXSEG4EI16_V_MF4_M1_TU, VLOXSEG4EI16_V }, // 4193
  { PseudoVLOXSEG4EI16_V_MF4_MF2, VLOXSEG4EI16_V }, // 4194
  { PseudoVLOXSEG4EI16_V_MF4_MF2_MASK, VLOXSEG4EI16_V }, // 4195
  { PseudoVLOXSEG4EI16_V_MF4_MF2_TU, VLOXSEG4EI16_V }, // 4196
  { PseudoVLOXSEG4EI16_V_MF4_MF4, VLOXSEG4EI16_V }, // 4197
  { PseudoVLOXSEG4EI16_V_MF4_MF4_MASK, VLOXSEG4EI16_V }, // 4198
  { PseudoVLOXSEG4EI16_V_MF4_MF4_TU, VLOXSEG4EI16_V }, // 4199
  { PseudoVLOXSEG4EI16_V_MF4_MF8, VLOXSEG4EI16_V }, // 4200
  { PseudoVLOXSEG4EI16_V_MF4_MF8_MASK, VLOXSEG4EI16_V }, // 4201
  { PseudoVLOXSEG4EI16_V_MF4_MF8_TU, VLOXSEG4EI16_V }, // 4202
  { PseudoVLOXSEG4EI32_V_M1_M1, VLOXSEG4EI32_V }, // 4203
  { PseudoVLOXSEG4EI32_V_M1_M1_MASK, VLOXSEG4EI32_V }, // 4204
  { PseudoVLOXSEG4EI32_V_M1_M1_TU, VLOXSEG4EI32_V }, // 4205
  { PseudoVLOXSEG4EI32_V_M1_M2, VLOXSEG4EI32_V }, // 4206
  { PseudoVLOXSEG4EI32_V_M1_M2_MASK, VLOXSEG4EI32_V }, // 4207
  { PseudoVLOXSEG4EI32_V_M1_M2_TU, VLOXSEG4EI32_V }, // 4208
  { PseudoVLOXSEG4EI32_V_M1_MF2, VLOXSEG4EI32_V }, // 4209
  { PseudoVLOXSEG4EI32_V_M1_MF2_MASK, VLOXSEG4EI32_V }, // 4210
  { PseudoVLOXSEG4EI32_V_M1_MF2_TU, VLOXSEG4EI32_V }, // 4211
  { PseudoVLOXSEG4EI32_V_M1_MF4, VLOXSEG4EI32_V }, // 4212
  { PseudoVLOXSEG4EI32_V_M1_MF4_MASK, VLOXSEG4EI32_V }, // 4213
  { PseudoVLOXSEG4EI32_V_M1_MF4_TU, VLOXSEG4EI32_V }, // 4214
  { PseudoVLOXSEG4EI32_V_M2_M1, VLOXSEG4EI32_V }, // 4215
  { PseudoVLOXSEG4EI32_V_M2_M1_MASK, VLOXSEG4EI32_V }, // 4216
  { PseudoVLOXSEG4EI32_V_M2_M1_TU, VLOXSEG4EI32_V }, // 4217
  { PseudoVLOXSEG4EI32_V_M2_M2, VLOXSEG4EI32_V }, // 4218
  { PseudoVLOXSEG4EI32_V_M2_M2_MASK, VLOXSEG4EI32_V }, // 4219
  { PseudoVLOXSEG4EI32_V_M2_M2_TU, VLOXSEG4EI32_V }, // 4220
  { PseudoVLOXSEG4EI32_V_M2_MF2, VLOXSEG4EI32_V }, // 4221
  { PseudoVLOXSEG4EI32_V_M2_MF2_MASK, VLOXSEG4EI32_V }, // 4222
  { PseudoVLOXSEG4EI32_V_M2_MF2_TU, VLOXSEG4EI32_V }, // 4223
  { PseudoVLOXSEG4EI32_V_M4_M1, VLOXSEG4EI32_V }, // 4224
  { PseudoVLOXSEG4EI32_V_M4_M1_MASK, VLOXSEG4EI32_V }, // 4225
  { PseudoVLOXSEG4EI32_V_M4_M1_TU, VLOXSEG4EI32_V }, // 4226
  { PseudoVLOXSEG4EI32_V_M4_M2, VLOXSEG4EI32_V }, // 4227
  { PseudoVLOXSEG4EI32_V_M4_M2_MASK, VLOXSEG4EI32_V }, // 4228
  { PseudoVLOXSEG4EI32_V_M4_M2_TU, VLOXSEG4EI32_V }, // 4229
  { PseudoVLOXSEG4EI32_V_M8_M2, VLOXSEG4EI32_V }, // 4230
  { PseudoVLOXSEG4EI32_V_M8_M2_MASK, VLOXSEG4EI32_V }, // 4231
  { PseudoVLOXSEG4EI32_V_M8_M2_TU, VLOXSEG4EI32_V }, // 4232
  { PseudoVLOXSEG4EI32_V_MF2_M1, VLOXSEG4EI32_V }, // 4233
  { PseudoVLOXSEG4EI32_V_MF2_M1_MASK, VLOXSEG4EI32_V }, // 4234
  { PseudoVLOXSEG4EI32_V_MF2_M1_TU, VLOXSEG4EI32_V }, // 4235
  { PseudoVLOXSEG4EI32_V_MF2_MF2, VLOXSEG4EI32_V }, // 4236
  { PseudoVLOXSEG4EI32_V_MF2_MF2_MASK, VLOXSEG4EI32_V }, // 4237
  { PseudoVLOXSEG4EI32_V_MF2_MF2_TU, VLOXSEG4EI32_V }, // 4238
  { PseudoVLOXSEG4EI32_V_MF2_MF4, VLOXSEG4EI32_V }, // 4239
  { PseudoVLOXSEG4EI32_V_MF2_MF4_MASK, VLOXSEG4EI32_V }, // 4240
  { PseudoVLOXSEG4EI32_V_MF2_MF4_TU, VLOXSEG4EI32_V }, // 4241
  { PseudoVLOXSEG4EI32_V_MF2_MF8, VLOXSEG4EI32_V }, // 4242
  { PseudoVLOXSEG4EI32_V_MF2_MF8_MASK, VLOXSEG4EI32_V }, // 4243
  { PseudoVLOXSEG4EI32_V_MF2_MF8_TU, VLOXSEG4EI32_V }, // 4244
  { PseudoVLOXSEG4EI64_V_M1_M1, VLOXSEG4EI64_V }, // 4245
  { PseudoVLOXSEG4EI64_V_M1_M1_MASK, VLOXSEG4EI64_V }, // 4246
  { PseudoVLOXSEG4EI64_V_M1_M1_TU, VLOXSEG4EI64_V }, // 4247
  { PseudoVLOXSEG4EI64_V_M1_MF2, VLOXSEG4EI64_V }, // 4248
  { PseudoVLOXSEG4EI64_V_M1_MF2_MASK, VLOXSEG4EI64_V }, // 4249
  { PseudoVLOXSEG4EI64_V_M1_MF2_TU, VLOXSEG4EI64_V }, // 4250
  { PseudoVLOXSEG4EI64_V_M1_MF4, VLOXSEG4EI64_V }, // 4251
  { PseudoVLOXSEG4EI64_V_M1_MF4_MASK, VLOXSEG4EI64_V }, // 4252
  { PseudoVLOXSEG4EI64_V_M1_MF4_TU, VLOXSEG4EI64_V }, // 4253
  { PseudoVLOXSEG4EI64_V_M1_MF8, VLOXSEG4EI64_V }, // 4254
  { PseudoVLOXSEG4EI64_V_M1_MF8_MASK, VLOXSEG4EI64_V }, // 4255
  { PseudoVLOXSEG4EI64_V_M1_MF8_TU, VLOXSEG4EI64_V }, // 4256
  { PseudoVLOXSEG4EI64_V_M2_M1, VLOXSEG4EI64_V }, // 4257
  { PseudoVLOXSEG4EI64_V_M2_M1_MASK, VLOXSEG4EI64_V }, // 4258
  { PseudoVLOXSEG4EI64_V_M2_M1_TU, VLOXSEG4EI64_V }, // 4259
  { PseudoVLOXSEG4EI64_V_M2_M2, VLOXSEG4EI64_V }, // 4260
  { PseudoVLOXSEG4EI64_V_M2_M2_MASK, VLOXSEG4EI64_V }, // 4261
  { PseudoVLOXSEG4EI64_V_M2_M2_TU, VLOXSEG4EI64_V }, // 4262
  { PseudoVLOXSEG4EI64_V_M2_MF2, VLOXSEG4EI64_V }, // 4263
  { PseudoVLOXSEG4EI64_V_M2_MF2_MASK, VLOXSEG4EI64_V }, // 4264
  { PseudoVLOXSEG4EI64_V_M2_MF2_TU, VLOXSEG4EI64_V }, // 4265
  { PseudoVLOXSEG4EI64_V_M2_MF4, VLOXSEG4EI64_V }, // 4266
  { PseudoVLOXSEG4EI64_V_M2_MF4_MASK, VLOXSEG4EI64_V }, // 4267
  { PseudoVLOXSEG4EI64_V_M2_MF4_TU, VLOXSEG4EI64_V }, // 4268
  { PseudoVLOXSEG4EI64_V_M4_M1, VLOXSEG4EI64_V }, // 4269
  { PseudoVLOXSEG4EI64_V_M4_M1_MASK, VLOXSEG4EI64_V }, // 4270
  { PseudoVLOXSEG4EI64_V_M4_M1_TU, VLOXSEG4EI64_V }, // 4271
  { PseudoVLOXSEG4EI64_V_M4_M2, VLOXSEG4EI64_V }, // 4272
  { PseudoVLOXSEG4EI64_V_M4_M2_MASK, VLOXSEG4EI64_V }, // 4273
  { PseudoVLOXSEG4EI64_V_M4_M2_TU, VLOXSEG4EI64_V }, // 4274
  { PseudoVLOXSEG4EI64_V_M4_MF2, VLOXSEG4EI64_V }, // 4275
  { PseudoVLOXSEG4EI64_V_M4_MF2_MASK, VLOXSEG4EI64_V }, // 4276
  { PseudoVLOXSEG4EI64_V_M4_MF2_TU, VLOXSEG4EI64_V }, // 4277
  { PseudoVLOXSEG4EI64_V_M8_M1, VLOXSEG4EI64_V }, // 4278
  { PseudoVLOXSEG4EI64_V_M8_M1_MASK, VLOXSEG4EI64_V }, // 4279
  { PseudoVLOXSEG4EI64_V_M8_M1_TU, VLOXSEG4EI64_V }, // 4280
  { PseudoVLOXSEG4EI64_V_M8_M2, VLOXSEG4EI64_V }, // 4281
  { PseudoVLOXSEG4EI64_V_M8_M2_MASK, VLOXSEG4EI64_V }, // 4282
  { PseudoVLOXSEG4EI64_V_M8_M2_TU, VLOXSEG4EI64_V }, // 4283
  { PseudoVLOXSEG4EI8_V_M1_M1, VLOXSEG4EI8_V }, // 4284
  { PseudoVLOXSEG4EI8_V_M1_M1_MASK, VLOXSEG4EI8_V }, // 4285
  { PseudoVLOXSEG4EI8_V_M1_M1_TU, VLOXSEG4EI8_V }, // 4286
  { PseudoVLOXSEG4EI8_V_M1_M2, VLOXSEG4EI8_V }, // 4287
  { PseudoVLOXSEG4EI8_V_M1_M2_MASK, VLOXSEG4EI8_V }, // 4288
  { PseudoVLOXSEG4EI8_V_M1_M2_TU, VLOXSEG4EI8_V }, // 4289
  { PseudoVLOXSEG4EI8_V_M2_M2, VLOXSEG4EI8_V }, // 4290
  { PseudoVLOXSEG4EI8_V_M2_M2_MASK, VLOXSEG4EI8_V }, // 4291
  { PseudoVLOXSEG4EI8_V_M2_M2_TU, VLOXSEG4EI8_V }, // 4292
  { PseudoVLOXSEG4EI8_V_MF2_M1, VLOXSEG4EI8_V }, // 4293
  { PseudoVLOXSEG4EI8_V_MF2_M1_MASK, VLOXSEG4EI8_V }, // 4294
  { PseudoVLOXSEG4EI8_V_MF2_M1_TU, VLOXSEG4EI8_V }, // 4295
  { PseudoVLOXSEG4EI8_V_MF2_M2, VLOXSEG4EI8_V }, // 4296
  { PseudoVLOXSEG4EI8_V_MF2_M2_MASK, VLOXSEG4EI8_V }, // 4297
  { PseudoVLOXSEG4EI8_V_MF2_M2_TU, VLOXSEG4EI8_V }, // 4298
  { PseudoVLOXSEG4EI8_V_MF2_MF2, VLOXSEG4EI8_V }, // 4299
  { PseudoVLOXSEG4EI8_V_MF2_MF2_MASK, VLOXSEG4EI8_V }, // 4300
  { PseudoVLOXSEG4EI8_V_MF2_MF2_TU, VLOXSEG4EI8_V }, // 4301
  { PseudoVLOXSEG4EI8_V_MF4_M1, VLOXSEG4EI8_V }, // 4302
  { PseudoVLOXSEG4EI8_V_MF4_M1_MASK, VLOXSEG4EI8_V }, // 4303
  { PseudoVLOXSEG4EI8_V_MF4_M1_TU, VLOXSEG4EI8_V }, // 4304
  { PseudoVLOXSEG4EI8_V_MF4_M2, VLOXSEG4EI8_V }, // 4305
  { PseudoVLOXSEG4EI8_V_MF4_M2_MASK, VLOXSEG4EI8_V }, // 4306
  { PseudoVLOXSEG4EI8_V_MF4_M2_TU, VLOXSEG4EI8_V }, // 4307
  { PseudoVLOXSEG4EI8_V_MF4_MF2, VLOXSEG4EI8_V }, // 4308
  { PseudoVLOXSEG4EI8_V_MF4_MF2_MASK, VLOXSEG4EI8_V }, // 4309
  { PseudoVLOXSEG4EI8_V_MF4_MF2_TU, VLOXSEG4EI8_V }, // 4310
  { PseudoVLOXSEG4EI8_V_MF4_MF4, VLOXSEG4EI8_V }, // 4311
  { PseudoVLOXSEG4EI8_V_MF4_MF4_MASK, VLOXSEG4EI8_V }, // 4312
  { PseudoVLOXSEG4EI8_V_MF4_MF4_TU, VLOXSEG4EI8_V }, // 4313
  { PseudoVLOXSEG4EI8_V_MF8_M1, VLOXSEG4EI8_V }, // 4314
  { PseudoVLOXSEG4EI8_V_MF8_M1_MASK, VLOXSEG4EI8_V }, // 4315
  { PseudoVLOXSEG4EI8_V_MF8_M1_TU, VLOXSEG4EI8_V }, // 4316
  { PseudoVLOXSEG4EI8_V_MF8_MF2, VLOXSEG4EI8_V }, // 4317
  { PseudoVLOXSEG4EI8_V_MF8_MF2_MASK, VLOXSEG4EI8_V }, // 4318
  { PseudoVLOXSEG4EI8_V_MF8_MF2_TU, VLOXSEG4EI8_V }, // 4319
  { PseudoVLOXSEG4EI8_V_MF8_MF4, VLOXSEG4EI8_V }, // 4320
  { PseudoVLOXSEG4EI8_V_MF8_MF4_MASK, VLOXSEG4EI8_V }, // 4321
  { PseudoVLOXSEG4EI8_V_MF8_MF4_TU, VLOXSEG4EI8_V }, // 4322
  { PseudoVLOXSEG4EI8_V_MF8_MF8, VLOXSEG4EI8_V }, // 4323
  { PseudoVLOXSEG4EI8_V_MF8_MF8_MASK, VLOXSEG4EI8_V }, // 4324
  { PseudoVLOXSEG4EI8_V_MF8_MF8_TU, VLOXSEG4EI8_V }, // 4325
  { PseudoVLOXSEG5EI16_V_M1_M1, VLOXSEG5EI16_V }, // 4326
  { PseudoVLOXSEG5EI16_V_M1_M1_MASK, VLOXSEG5EI16_V }, // 4327
  { PseudoVLOXSEG5EI16_V_M1_M1_TU, VLOXSEG5EI16_V }, // 4328
  { PseudoVLOXSEG5EI16_V_M1_MF2, VLOXSEG5EI16_V }, // 4329
  { PseudoVLOXSEG5EI16_V_M1_MF2_MASK, VLOXSEG5EI16_V }, // 4330
  { PseudoVLOXSEG5EI16_V_M1_MF2_TU, VLOXSEG5EI16_V }, // 4331
  { PseudoVLOXSEG5EI16_V_M2_M1, VLOXSEG5EI16_V }, // 4332
  { PseudoVLOXSEG5EI16_V_M2_M1_MASK, VLOXSEG5EI16_V }, // 4333
  { PseudoVLOXSEG5EI16_V_M2_M1_TU, VLOXSEG5EI16_V }, // 4334
  { PseudoVLOXSEG5EI16_V_MF2_M1, VLOXSEG5EI16_V }, // 4335
  { PseudoVLOXSEG5EI16_V_MF2_M1_MASK, VLOXSEG5EI16_V }, // 4336
  { PseudoVLOXSEG5EI16_V_MF2_M1_TU, VLOXSEG5EI16_V }, // 4337
  { PseudoVLOXSEG5EI16_V_MF2_MF2, VLOXSEG5EI16_V }, // 4338
  { PseudoVLOXSEG5EI16_V_MF2_MF2_MASK, VLOXSEG5EI16_V }, // 4339
  { PseudoVLOXSEG5EI16_V_MF2_MF2_TU, VLOXSEG5EI16_V }, // 4340
  { PseudoVLOXSEG5EI16_V_MF2_MF4, VLOXSEG5EI16_V }, // 4341
  { PseudoVLOXSEG5EI16_V_MF2_MF4_MASK, VLOXSEG5EI16_V }, // 4342
  { PseudoVLOXSEG5EI16_V_MF2_MF4_TU, VLOXSEG5EI16_V }, // 4343
  { PseudoVLOXSEG5EI16_V_MF4_M1, VLOXSEG5EI16_V }, // 4344
  { PseudoVLOXSEG5EI16_V_MF4_M1_MASK, VLOXSEG5EI16_V }, // 4345
  { PseudoVLOXSEG5EI16_V_MF4_M1_TU, VLOXSEG5EI16_V }, // 4346
  { PseudoVLOXSEG5EI16_V_MF4_MF2, VLOXSEG5EI16_V }, // 4347
  { PseudoVLOXSEG5EI16_V_MF4_MF2_MASK, VLOXSEG5EI16_V }, // 4348
  { PseudoVLOXSEG5EI16_V_MF4_MF2_TU, VLOXSEG5EI16_V }, // 4349
  { PseudoVLOXSEG5EI16_V_MF4_MF4, VLOXSEG5EI16_V }, // 4350
  { PseudoVLOXSEG5EI16_V_MF4_MF4_MASK, VLOXSEG5EI16_V }, // 4351
  { PseudoVLOXSEG5EI16_V_MF4_MF4_TU, VLOXSEG5EI16_V }, // 4352
  { PseudoVLOXSEG5EI16_V_MF4_MF8, VLOXSEG5EI16_V }, // 4353
  { PseudoVLOXSEG5EI16_V_MF4_MF8_MASK, VLOXSEG5EI16_V }, // 4354
  { PseudoVLOXSEG5EI16_V_MF4_MF8_TU, VLOXSEG5EI16_V }, // 4355
  { PseudoVLOXSEG5EI32_V_M1_M1, VLOXSEG5EI32_V }, // 4356
  { PseudoVLOXSEG5EI32_V_M1_M1_MASK, VLOXSEG5EI32_V }, // 4357
  { PseudoVLOXSEG5EI32_V_M1_M1_TU, VLOXSEG5EI32_V }, // 4358
  { PseudoVLOXSEG5EI32_V_M1_MF2, VLOXSEG5EI32_V }, // 4359
  { PseudoVLOXSEG5EI32_V_M1_MF2_MASK, VLOXSEG5EI32_V }, // 4360
  { PseudoVLOXSEG5EI32_V_M1_MF2_TU, VLOXSEG5EI32_V }, // 4361
  { PseudoVLOXSEG5EI32_V_M1_MF4, VLOXSEG5EI32_V }, // 4362
  { PseudoVLOXSEG5EI32_V_M1_MF4_MASK, VLOXSEG5EI32_V }, // 4363
  { PseudoVLOXSEG5EI32_V_M1_MF4_TU, VLOXSEG5EI32_V }, // 4364
  { PseudoVLOXSEG5EI32_V_M2_M1, VLOXSEG5EI32_V }, // 4365
  { PseudoVLOXSEG5EI32_V_M2_M1_MASK, VLOXSEG5EI32_V }, // 4366
  { PseudoVLOXSEG5EI32_V_M2_M1_TU, VLOXSEG5EI32_V }, // 4367
  { PseudoVLOXSEG5EI32_V_M2_MF2, VLOXSEG5EI32_V }, // 4368
  { PseudoVLOXSEG5EI32_V_M2_MF2_MASK, VLOXSEG5EI32_V }, // 4369
  { PseudoVLOXSEG5EI32_V_M2_MF2_TU, VLOXSEG5EI32_V }, // 4370
  { PseudoVLOXSEG5EI32_V_M4_M1, VLOXSEG5EI32_V }, // 4371
  { PseudoVLOXSEG5EI32_V_M4_M1_MASK, VLOXSEG5EI32_V }, // 4372
  { PseudoVLOXSEG5EI32_V_M4_M1_TU, VLOXSEG5EI32_V }, // 4373
  { PseudoVLOXSEG5EI32_V_MF2_M1, VLOXSEG5EI32_V }, // 4374
  { PseudoVLOXSEG5EI32_V_MF2_M1_MASK, VLOXSEG5EI32_V }, // 4375
  { PseudoVLOXSEG5EI32_V_MF2_M1_TU, VLOXSEG5EI32_V }, // 4376
  { PseudoVLOXSEG5EI32_V_MF2_MF2, VLOXSEG5EI32_V }, // 4377
  { PseudoVLOXSEG5EI32_V_MF2_MF2_MASK, VLOXSEG5EI32_V }, // 4378
  { PseudoVLOXSEG5EI32_V_MF2_MF2_TU, VLOXSEG5EI32_V }, // 4379
  { PseudoVLOXSEG5EI32_V_MF2_MF4, VLOXSEG5EI32_V }, // 4380
  { PseudoVLOXSEG5EI32_V_MF2_MF4_MASK, VLOXSEG5EI32_V }, // 4381
  { PseudoVLOXSEG5EI32_V_MF2_MF4_TU, VLOXSEG5EI32_V }, // 4382
  { PseudoVLOXSEG5EI32_V_MF2_MF8, VLOXSEG5EI32_V }, // 4383
  { PseudoVLOXSEG5EI32_V_MF2_MF8_MASK, VLOXSEG5EI32_V }, // 4384
  { PseudoVLOXSEG5EI32_V_MF2_MF8_TU, VLOXSEG5EI32_V }, // 4385
  { PseudoVLOXSEG5EI64_V_M1_M1, VLOXSEG5EI64_V }, // 4386
  { PseudoVLOXSEG5EI64_V_M1_M1_MASK, VLOXSEG5EI64_V }, // 4387
  { PseudoVLOXSEG5EI64_V_M1_M1_TU, VLOXSEG5EI64_V }, // 4388
  { PseudoVLOXSEG5EI64_V_M1_MF2, VLOXSEG5EI64_V }, // 4389
  { PseudoVLOXSEG5EI64_V_M1_MF2_MASK, VLOXSEG5EI64_V }, // 4390
  { PseudoVLOXSEG5EI64_V_M1_MF2_TU, VLOXSEG5EI64_V }, // 4391
  { PseudoVLOXSEG5EI64_V_M1_MF4, VLOXSEG5EI64_V }, // 4392
  { PseudoVLOXSEG5EI64_V_M1_MF4_MASK, VLOXSEG5EI64_V }, // 4393
  { PseudoVLOXSEG5EI64_V_M1_MF4_TU, VLOXSEG5EI64_V }, // 4394
  { PseudoVLOXSEG5EI64_V_M1_MF8, VLOXSEG5EI64_V }, // 4395
  { PseudoVLOXSEG5EI64_V_M1_MF8_MASK, VLOXSEG5EI64_V }, // 4396
  { PseudoVLOXSEG5EI64_V_M1_MF8_TU, VLOXSEG5EI64_V }, // 4397
  { PseudoVLOXSEG5EI64_V_M2_M1, VLOXSEG5EI64_V }, // 4398
  { PseudoVLOXSEG5EI64_V_M2_M1_MASK, VLOXSEG5EI64_V }, // 4399
  { PseudoVLOXSEG5EI64_V_M2_M1_TU, VLOXSEG5EI64_V }, // 4400
  { PseudoVLOXSEG5EI64_V_M2_MF2, VLOXSEG5EI64_V }, // 4401
  { PseudoVLOXSEG5EI64_V_M2_MF2_MASK, VLOXSEG5EI64_V }, // 4402
  { PseudoVLOXSEG5EI64_V_M2_MF2_TU, VLOXSEG5EI64_V }, // 4403
  { PseudoVLOXSEG5EI64_V_M2_MF4, VLOXSEG5EI64_V }, // 4404
  { PseudoVLOXSEG5EI64_V_M2_MF4_MASK, VLOXSEG5EI64_V }, // 4405
  { PseudoVLOXSEG5EI64_V_M2_MF4_TU, VLOXSEG5EI64_V }, // 4406
  { PseudoVLOXSEG5EI64_V_M4_M1, VLOXSEG5EI64_V }, // 4407
  { PseudoVLOXSEG5EI64_V_M4_M1_MASK, VLOXSEG5EI64_V }, // 4408
  { PseudoVLOXSEG5EI64_V_M4_M1_TU, VLOXSEG5EI64_V }, // 4409
  { PseudoVLOXSEG5EI64_V_M4_MF2, VLOXSEG5EI64_V }, // 4410
  { PseudoVLOXSEG5EI64_V_M4_MF2_MASK, VLOXSEG5EI64_V }, // 4411
  { PseudoVLOXSEG5EI64_V_M4_MF2_TU, VLOXSEG5EI64_V }, // 4412
  { PseudoVLOXSEG5EI64_V_M8_M1, VLOXSEG5EI64_V }, // 4413
  { PseudoVLOXSEG5EI64_V_M8_M1_MASK, VLOXSEG5EI64_V }, // 4414
  { PseudoVLOXSEG5EI64_V_M8_M1_TU, VLOXSEG5EI64_V }, // 4415
  { PseudoVLOXSEG5EI8_V_M1_M1, VLOXSEG5EI8_V }, // 4416
  { PseudoVLOXSEG5EI8_V_M1_M1_MASK, VLOXSEG5EI8_V }, // 4417
  { PseudoVLOXSEG5EI8_V_M1_M1_TU, VLOXSEG5EI8_V }, // 4418
  { PseudoVLOXSEG5EI8_V_MF2_M1, VLOXSEG5EI8_V }, // 4419
  { PseudoVLOXSEG5EI8_V_MF2_M1_MASK, VLOXSEG5EI8_V }, // 4420
  { PseudoVLOXSEG5EI8_V_MF2_M1_TU, VLOXSEG5EI8_V }, // 4421
  { PseudoVLOXSEG5EI8_V_MF2_MF2, VLOXSEG5EI8_V }, // 4422
  { PseudoVLOXSEG5EI8_V_MF2_MF2_MASK, VLOXSEG5EI8_V }, // 4423
  { PseudoVLOXSEG5EI8_V_MF2_MF2_TU, VLOXSEG5EI8_V }, // 4424
  { PseudoVLOXSEG5EI8_V_MF4_M1, VLOXSEG5EI8_V }, // 4425
  { PseudoVLOXSEG5EI8_V_MF4_M1_MASK, VLOXSEG5EI8_V }, // 4426
  { PseudoVLOXSEG5EI8_V_MF4_M1_TU, VLOXSEG5EI8_V }, // 4427
  { PseudoVLOXSEG5EI8_V_MF4_MF2, VLOXSEG5EI8_V }, // 4428
  { PseudoVLOXSEG5EI8_V_MF4_MF2_MASK, VLOXSEG5EI8_V }, // 4429
  { PseudoVLOXSEG5EI8_V_MF4_MF2_TU, VLOXSEG5EI8_V }, // 4430
  { PseudoVLOXSEG5EI8_V_MF4_MF4, VLOXSEG5EI8_V }, // 4431
  { PseudoVLOXSEG5EI8_V_MF4_MF4_MASK, VLOXSEG5EI8_V }, // 4432
  { PseudoVLOXSEG5EI8_V_MF4_MF4_TU, VLOXSEG5EI8_V }, // 4433
  { PseudoVLOXSEG5EI8_V_MF8_M1, VLOXSEG5EI8_V }, // 4434
  { PseudoVLOXSEG5EI8_V_MF8_M1_MASK, VLOXSEG5EI8_V }, // 4435
  { PseudoVLOXSEG5EI8_V_MF8_M1_TU, VLOXSEG5EI8_V }, // 4436
  { PseudoVLOXSEG5EI8_V_MF8_MF2, VLOXSEG5EI8_V }, // 4437
  { PseudoVLOXSEG5EI8_V_MF8_MF2_MASK, VLOXSEG5EI8_V }, // 4438
  { PseudoVLOXSEG5EI8_V_MF8_MF2_TU, VLOXSEG5EI8_V }, // 4439
  { PseudoVLOXSEG5EI8_V_MF8_MF4, VLOXSEG5EI8_V }, // 4440
  { PseudoVLOXSEG5EI8_V_MF8_MF4_MASK, VLOXSEG5EI8_V }, // 4441
  { PseudoVLOXSEG5EI8_V_MF8_MF4_TU, VLOXSEG5EI8_V }, // 4442
  { PseudoVLOXSEG5EI8_V_MF8_MF8, VLOXSEG5EI8_V }, // 4443
  { PseudoVLOXSEG5EI8_V_MF8_MF8_MASK, VLOXSEG5EI8_V }, // 4444
  { PseudoVLOXSEG5EI8_V_MF8_MF8_TU, VLOXSEG5EI8_V }, // 4445
  { PseudoVLOXSEG6EI16_V_M1_M1, VLOXSEG6EI16_V }, // 4446
  { PseudoVLOXSEG6EI16_V_M1_M1_MASK, VLOXSEG6EI16_V }, // 4447
  { PseudoVLOXSEG6EI16_V_M1_M1_TU, VLOXSEG6EI16_V }, // 4448
  { PseudoVLOXSEG6EI16_V_M1_MF2, VLOXSEG6EI16_V }, // 4449
  { PseudoVLOXSEG6EI16_V_M1_MF2_MASK, VLOXSEG6EI16_V }, // 4450
  { PseudoVLOXSEG6EI16_V_M1_MF2_TU, VLOXSEG6EI16_V }, // 4451
  { PseudoVLOXSEG6EI16_V_M2_M1, VLOXSEG6EI16_V }, // 4452
  { PseudoVLOXSEG6EI16_V_M2_M1_MASK, VLOXSEG6EI16_V }, // 4453
  { PseudoVLOXSEG6EI16_V_M2_M1_TU, VLOXSEG6EI16_V }, // 4454
  { PseudoVLOXSEG6EI16_V_MF2_M1, VLOXSEG6EI16_V }, // 4455
  { PseudoVLOXSEG6EI16_V_MF2_M1_MASK, VLOXSEG6EI16_V }, // 4456
  { PseudoVLOXSEG6EI16_V_MF2_M1_TU, VLOXSEG6EI16_V }, // 4457
  { PseudoVLOXSEG6EI16_V_MF2_MF2, VLOXSEG6EI16_V }, // 4458
  { PseudoVLOXSEG6EI16_V_MF2_MF2_MASK, VLOXSEG6EI16_V }, // 4459
  { PseudoVLOXSEG6EI16_V_MF2_MF2_TU, VLOXSEG6EI16_V }, // 4460
  { PseudoVLOXSEG6EI16_V_MF2_MF4, VLOXSEG6EI16_V }, // 4461
  { PseudoVLOXSEG6EI16_V_MF2_MF4_MASK, VLOXSEG6EI16_V }, // 4462
  { PseudoVLOXSEG6EI16_V_MF2_MF4_TU, VLOXSEG6EI16_V }, // 4463
  { PseudoVLOXSEG6EI16_V_MF4_M1, VLOXSEG6EI16_V }, // 4464
  { PseudoVLOXSEG6EI16_V_MF4_M1_MASK, VLOXSEG6EI16_V }, // 4465
  { PseudoVLOXSEG6EI16_V_MF4_M1_TU, VLOXSEG6EI16_V }, // 4466
  { PseudoVLOXSEG6EI16_V_MF4_MF2, VLOXSEG6EI16_V }, // 4467
  { PseudoVLOXSEG6EI16_V_MF4_MF2_MASK, VLOXSEG6EI16_V }, // 4468
  { PseudoVLOXSEG6EI16_V_MF4_MF2_TU, VLOXSEG6EI16_V }, // 4469
  { PseudoVLOXSEG6EI16_V_MF4_MF4, VLOXSEG6EI16_V }, // 4470
  { PseudoVLOXSEG6EI16_V_MF4_MF4_MASK, VLOXSEG6EI16_V }, // 4471
  { PseudoVLOXSEG6EI16_V_MF4_MF4_TU, VLOXSEG6EI16_V }, // 4472
  { PseudoVLOXSEG6EI16_V_MF4_MF8, VLOXSEG6EI16_V }, // 4473
  { PseudoVLOXSEG6EI16_V_MF4_MF8_MASK, VLOXSEG6EI16_V }, // 4474
  { PseudoVLOXSEG6EI16_V_MF4_MF8_TU, VLOXSEG6EI16_V }, // 4475
  { PseudoVLOXSEG6EI32_V_M1_M1, VLOXSEG6EI32_V }, // 4476
  { PseudoVLOXSEG6EI32_V_M1_M1_MASK, VLOXSEG6EI32_V }, // 4477
  { PseudoVLOXSEG6EI32_V_M1_M1_TU, VLOXSEG6EI32_V }, // 4478
  { PseudoVLOXSEG6EI32_V_M1_MF2, VLOXSEG6EI32_V }, // 4479
  { PseudoVLOXSEG6EI32_V_M1_MF2_MASK, VLOXSEG6EI32_V }, // 4480
  { PseudoVLOXSEG6EI32_V_M1_MF2_TU, VLOXSEG6EI32_V }, // 4481
  { PseudoVLOXSEG6EI32_V_M1_MF4, VLOXSEG6EI32_V }, // 4482
  { PseudoVLOXSEG6EI32_V_M1_MF4_MASK, VLOXSEG6EI32_V }, // 4483
  { PseudoVLOXSEG6EI32_V_M1_MF4_TU, VLOXSEG6EI32_V }, // 4484
  { PseudoVLOXSEG6EI32_V_M2_M1, VLOXSEG6EI32_V }, // 4485
  { PseudoVLOXSEG6EI32_V_M2_M1_MASK, VLOXSEG6EI32_V }, // 4486
  { PseudoVLOXSEG6EI32_V_M2_M1_TU, VLOXSEG6EI32_V }, // 4487
  { PseudoVLOXSEG6EI32_V_M2_MF2, VLOXSEG6EI32_V }, // 4488
  { PseudoVLOXSEG6EI32_V_M2_MF2_MASK, VLOXSEG6EI32_V }, // 4489
  { PseudoVLOXSEG6EI32_V_M2_MF2_TU, VLOXSEG6EI32_V }, // 4490
  { PseudoVLOXSEG6EI32_V_M4_M1, VLOXSEG6EI32_V }, // 4491
  { PseudoVLOXSEG6EI32_V_M4_M1_MASK, VLOXSEG6EI32_V }, // 4492
  { PseudoVLOXSEG6EI32_V_M4_M1_TU, VLOXSEG6EI32_V }, // 4493
  { PseudoVLOXSEG6EI32_V_MF2_M1, VLOXSEG6EI32_V }, // 4494
  { PseudoVLOXSEG6EI32_V_MF2_M1_MASK, VLOXSEG6EI32_V }, // 4495
  { PseudoVLOXSEG6EI32_V_MF2_M1_TU, VLOXSEG6EI32_V }, // 4496
  { PseudoVLOXSEG6EI32_V_MF2_MF2, VLOXSEG6EI32_V }, // 4497
  { PseudoVLOXSEG6EI32_V_MF2_MF2_MASK, VLOXSEG6EI32_V }, // 4498
  { PseudoVLOXSEG6EI32_V_MF2_MF2_TU, VLOXSEG6EI32_V }, // 4499
  { PseudoVLOXSEG6EI32_V_MF2_MF4, VLOXSEG6EI32_V }, // 4500
  { PseudoVLOXSEG6EI32_V_MF2_MF4_MASK, VLOXSEG6EI32_V }, // 4501
  { PseudoVLOXSEG6EI32_V_MF2_MF4_TU, VLOXSEG6EI32_V }, // 4502
  { PseudoVLOXSEG6EI32_V_MF2_MF8, VLOXSEG6EI32_V }, // 4503
  { PseudoVLOXSEG6EI32_V_MF2_MF8_MASK, VLOXSEG6EI32_V }, // 4504
  { PseudoVLOXSEG6EI32_V_MF2_MF8_TU, VLOXSEG6EI32_V }, // 4505
  { PseudoVLOXSEG6EI64_V_M1_M1, VLOXSEG6EI64_V }, // 4506
  { PseudoVLOXSEG6EI64_V_M1_M1_MASK, VLOXSEG6EI64_V }, // 4507
  { PseudoVLOXSEG6EI64_V_M1_M1_TU, VLOXSEG6EI64_V }, // 4508
  { PseudoVLOXSEG6EI64_V_M1_MF2, VLOXSEG6EI64_V }, // 4509
  { PseudoVLOXSEG6EI64_V_M1_MF2_MASK, VLOXSEG6EI64_V }, // 4510
  { PseudoVLOXSEG6EI64_V_M1_MF2_TU, VLOXSEG6EI64_V }, // 4511
  { PseudoVLOXSEG6EI64_V_M1_MF4, VLOXSEG6EI64_V }, // 4512
  { PseudoVLOXSEG6EI64_V_M1_MF4_MASK, VLOXSEG6EI64_V }, // 4513
  { PseudoVLOXSEG6EI64_V_M1_MF4_TU, VLOXSEG6EI64_V }, // 4514
  { PseudoVLOXSEG6EI64_V_M1_MF8, VLOXSEG6EI64_V }, // 4515
  { PseudoVLOXSEG6EI64_V_M1_MF8_MASK, VLOXSEG6EI64_V }, // 4516
  { PseudoVLOXSEG6EI64_V_M1_MF8_TU, VLOXSEG6EI64_V }, // 4517
  { PseudoVLOXSEG6EI64_V_M2_M1, VLOXSEG6EI64_V }, // 4518
  { PseudoVLOXSEG6EI64_V_M2_M1_MASK, VLOXSEG6EI64_V }, // 4519
  { PseudoVLOXSEG6EI64_V_M2_M1_TU, VLOXSEG6EI64_V }, // 4520
  { PseudoVLOXSEG6EI64_V_M2_MF2, VLOXSEG6EI64_V }, // 4521
  { PseudoVLOXSEG6EI64_V_M2_MF2_MASK, VLOXSEG6EI64_V }, // 4522
  { PseudoVLOXSEG6EI64_V_M2_MF2_TU, VLOXSEG6EI64_V }, // 4523
  { PseudoVLOXSEG6EI64_V_M2_MF4, VLOXSEG6EI64_V }, // 4524
  { PseudoVLOXSEG6EI64_V_M2_MF4_MASK, VLOXSEG6EI64_V }, // 4525
  { PseudoVLOXSEG6EI64_V_M2_MF4_TU, VLOXSEG6EI64_V }, // 4526
  { PseudoVLOXSEG6EI64_V_M4_M1, VLOXSEG6EI64_V }, // 4527
  { PseudoVLOXSEG6EI64_V_M4_M1_MASK, VLOXSEG6EI64_V }, // 4528
  { PseudoVLOXSEG6EI64_V_M4_M1_TU, VLOXSEG6EI64_V }, // 4529
  { PseudoVLOXSEG6EI64_V_M4_MF2, VLOXSEG6EI64_V }, // 4530
  { PseudoVLOXSEG6EI64_V_M4_MF2_MASK, VLOXSEG6EI64_V }, // 4531
  { PseudoVLOXSEG6EI64_V_M4_MF2_TU, VLOXSEG6EI64_V }, // 4532
  { PseudoVLOXSEG6EI64_V_M8_M1, VLOXSEG6EI64_V }, // 4533
  { PseudoVLOXSEG6EI64_V_M8_M1_MASK, VLOXSEG6EI64_V }, // 4534
  { PseudoVLOXSEG6EI64_V_M8_M1_TU, VLOXSEG6EI64_V }, // 4535
  { PseudoVLOXSEG6EI8_V_M1_M1, VLOXSEG6EI8_V }, // 4536
  { PseudoVLOXSEG6EI8_V_M1_M1_MASK, VLOXSEG6EI8_V }, // 4537
  { PseudoVLOXSEG6EI8_V_M1_M1_TU, VLOXSEG6EI8_V }, // 4538
  { PseudoVLOXSEG6EI8_V_MF2_M1, VLOXSEG6EI8_V }, // 4539
  { PseudoVLOXSEG6EI8_V_MF2_M1_MASK, VLOXSEG6EI8_V }, // 4540
  { PseudoVLOXSEG6EI8_V_MF2_M1_TU, VLOXSEG6EI8_V }, // 4541
  { PseudoVLOXSEG6EI8_V_MF2_MF2, VLOXSEG6EI8_V }, // 4542
  { PseudoVLOXSEG6EI8_V_MF2_MF2_MASK, VLOXSEG6EI8_V }, // 4543
  { PseudoVLOXSEG6EI8_V_MF2_MF2_TU, VLOXSEG6EI8_V }, // 4544
  { PseudoVLOXSEG6EI8_V_MF4_M1, VLOXSEG6EI8_V }, // 4545
  { PseudoVLOXSEG6EI8_V_MF4_M1_MASK, VLOXSEG6EI8_V }, // 4546
  { PseudoVLOXSEG6EI8_V_MF4_M1_TU, VLOXSEG6EI8_V }, // 4547
  { PseudoVLOXSEG6EI8_V_MF4_MF2, VLOXSEG6EI8_V }, // 4548
  { PseudoVLOXSEG6EI8_V_MF4_MF2_MASK, VLOXSEG6EI8_V }, // 4549
  { PseudoVLOXSEG6EI8_V_MF4_MF2_TU, VLOXSEG6EI8_V }, // 4550
  { PseudoVLOXSEG6EI8_V_MF4_MF4, VLOXSEG6EI8_V }, // 4551
  { PseudoVLOXSEG6EI8_V_MF4_MF4_MASK, VLOXSEG6EI8_V }, // 4552
  { PseudoVLOXSEG6EI8_V_MF4_MF4_TU, VLOXSEG6EI8_V }, // 4553
  { PseudoVLOXSEG6EI8_V_MF8_M1, VLOXSEG6EI8_V }, // 4554
  { PseudoVLOXSEG6EI8_V_MF8_M1_MASK, VLOXSEG6EI8_V }, // 4555
  { PseudoVLOXSEG6EI8_V_MF8_M1_TU, VLOXSEG6EI8_V }, // 4556
  { PseudoVLOXSEG6EI8_V_MF8_MF2, VLOXSEG6EI8_V }, // 4557
  { PseudoVLOXSEG6EI8_V_MF8_MF2_MASK, VLOXSEG6EI8_V }, // 4558
  { PseudoVLOXSEG6EI8_V_MF8_MF2_TU, VLOXSEG6EI8_V }, // 4559
  { PseudoVLOXSEG6EI8_V_MF8_MF4, VLOXSEG6EI8_V }, // 4560
  { PseudoVLOXSEG6EI8_V_MF8_MF4_MASK, VLOXSEG6EI8_V }, // 4561
  { PseudoVLOXSEG6EI8_V_MF8_MF4_TU, VLOXSEG6EI8_V }, // 4562
  { PseudoVLOXSEG6EI8_V_MF8_MF8, VLOXSEG6EI8_V }, // 4563
  { PseudoVLOXSEG6EI8_V_MF8_MF8_MASK, VLOXSEG6EI8_V }, // 4564
  { PseudoVLOXSEG6EI8_V_MF8_MF8_TU, VLOXSEG6EI8_V }, // 4565
  { PseudoVLOXSEG7EI16_V_M1_M1, VLOXSEG7EI16_V }, // 4566
  { PseudoVLOXSEG7EI16_V_M1_M1_MASK, VLOXSEG7EI16_V }, // 4567
  { PseudoVLOXSEG7EI16_V_M1_M1_TU, VLOXSEG7EI16_V }, // 4568
  { PseudoVLOXSEG7EI16_V_M1_MF2, VLOXSEG7EI16_V }, // 4569
  { PseudoVLOXSEG7EI16_V_M1_MF2_MASK, VLOXSEG7EI16_V }, // 4570
  { PseudoVLOXSEG7EI16_V_M1_MF2_TU, VLOXSEG7EI16_V }, // 4571
  { PseudoVLOXSEG7EI16_V_M2_M1, VLOXSEG7EI16_V }, // 4572
  { PseudoVLOXSEG7EI16_V_M2_M1_MASK, VLOXSEG7EI16_V }, // 4573
  { PseudoVLOXSEG7EI16_V_M2_M1_TU, VLOXSEG7EI16_V }, // 4574
  { PseudoVLOXSEG7EI16_V_MF2_M1, VLOXSEG7EI16_V }, // 4575
  { PseudoVLOXSEG7EI16_V_MF2_M1_MASK, VLOXSEG7EI16_V }, // 4576
  { PseudoVLOXSEG7EI16_V_MF2_M1_TU, VLOXSEG7EI16_V }, // 4577
  { PseudoVLOXSEG7EI16_V_MF2_MF2, VLOXSEG7EI16_V }, // 4578
  { PseudoVLOXSEG7EI16_V_MF2_MF2_MASK, VLOXSEG7EI16_V }, // 4579
  { PseudoVLOXSEG7EI16_V_MF2_MF2_TU, VLOXSEG7EI16_V }, // 4580
  { PseudoVLOXSEG7EI16_V_MF2_MF4, VLOXSEG7EI16_V }, // 4581
  { PseudoVLOXSEG7EI16_V_MF2_MF4_MASK, VLOXSEG7EI16_V }, // 4582
  { PseudoVLOXSEG7EI16_V_MF2_MF4_TU, VLOXSEG7EI16_V }, // 4583
  { PseudoVLOXSEG7EI16_V_MF4_M1, VLOXSEG7EI16_V }, // 4584
  { PseudoVLOXSEG7EI16_V_MF4_M1_MASK, VLOXSEG7EI16_V }, // 4585
  { PseudoVLOXSEG7EI16_V_MF4_M1_TU, VLOXSEG7EI16_V }, // 4586
  { PseudoVLOXSEG7EI16_V_MF4_MF2, VLOXSEG7EI16_V }, // 4587
  { PseudoVLOXSEG7EI16_V_MF4_MF2_MASK, VLOXSEG7EI16_V }, // 4588
  { PseudoVLOXSEG7EI16_V_MF4_MF2_TU, VLOXSEG7EI16_V }, // 4589
  { PseudoVLOXSEG7EI16_V_MF4_MF4, VLOXSEG7EI16_V }, // 4590
  { PseudoVLOXSEG7EI16_V_MF4_MF4_MASK, VLOXSEG7EI16_V }, // 4591
  { PseudoVLOXSEG7EI16_V_MF4_MF4_TU, VLOXSEG7EI16_V }, // 4592
  { PseudoVLOXSEG7EI16_V_MF4_MF8, VLOXSEG7EI16_V }, // 4593
  { PseudoVLOXSEG7EI16_V_MF4_MF8_MASK, VLOXSEG7EI16_V }, // 4594
  { PseudoVLOXSEG7EI16_V_MF4_MF8_TU, VLOXSEG7EI16_V }, // 4595
  { PseudoVLOXSEG7EI32_V_M1_M1, VLOXSEG7EI32_V }, // 4596
  { PseudoVLOXSEG7EI32_V_M1_M1_MASK, VLOXSEG7EI32_V }, // 4597
  { PseudoVLOXSEG7EI32_V_M1_M1_TU, VLOXSEG7EI32_V }, // 4598
  { PseudoVLOXSEG7EI32_V_M1_MF2, VLOXSEG7EI32_V }, // 4599
  { PseudoVLOXSEG7EI32_V_M1_MF2_MASK, VLOXSEG7EI32_V }, // 4600
  { PseudoVLOXSEG7EI32_V_M1_MF2_TU, VLOXSEG7EI32_V }, // 4601
  { PseudoVLOXSEG7EI32_V_M1_MF4, VLOXSEG7EI32_V }, // 4602
  { PseudoVLOXSEG7EI32_V_M1_MF4_MASK, VLOXSEG7EI32_V }, // 4603
  { PseudoVLOXSEG7EI32_V_M1_MF4_TU, VLOXSEG7EI32_V }, // 4604
  { PseudoVLOXSEG7EI32_V_M2_M1, VLOXSEG7EI32_V }, // 4605
  { PseudoVLOXSEG7EI32_V_M2_M1_MASK, VLOXSEG7EI32_V }, // 4606
  { PseudoVLOXSEG7EI32_V_M2_M1_TU, VLOXSEG7EI32_V }, // 4607
  { PseudoVLOXSEG7EI32_V_M2_MF2, VLOXSEG7EI32_V }, // 4608
  { PseudoVLOXSEG7EI32_V_M2_MF2_MASK, VLOXSEG7EI32_V }, // 4609
  { PseudoVLOXSEG7EI32_V_M2_MF2_TU, VLOXSEG7EI32_V }, // 4610
  { PseudoVLOXSEG7EI32_V_M4_M1, VLOXSEG7EI32_V }, // 4611
  { PseudoVLOXSEG7EI32_V_M4_M1_MASK, VLOXSEG7EI32_V }, // 4612
  { PseudoVLOXSEG7EI32_V_M4_M1_TU, VLOXSEG7EI32_V }, // 4613
  { PseudoVLOXSEG7EI32_V_MF2_M1, VLOXSEG7EI32_V }, // 4614
  { PseudoVLOXSEG7EI32_V_MF2_M1_MASK, VLOXSEG7EI32_V }, // 4615
  { PseudoVLOXSEG7EI32_V_MF2_M1_TU, VLOXSEG7EI32_V }, // 4616
  { PseudoVLOXSEG7EI32_V_MF2_MF2, VLOXSEG7EI32_V }, // 4617
  { PseudoVLOXSEG7EI32_V_MF2_MF2_MASK, VLOXSEG7EI32_V }, // 4618
  { PseudoVLOXSEG7EI32_V_MF2_MF2_TU, VLOXSEG7EI32_V }, // 4619
  { PseudoVLOXSEG7EI32_V_MF2_MF4, VLOXSEG7EI32_V }, // 4620
  { PseudoVLOXSEG7EI32_V_MF2_MF4_MASK, VLOXSEG7EI32_V }, // 4621
  { PseudoVLOXSEG7EI32_V_MF2_MF4_TU, VLOXSEG7EI32_V }, // 4622
  { PseudoVLOXSEG7EI32_V_MF2_MF8, VLOXSEG7EI32_V }, // 4623
  { PseudoVLOXSEG7EI32_V_MF2_MF8_MASK, VLOXSEG7EI32_V }, // 4624
  { PseudoVLOXSEG7EI32_V_MF2_MF8_TU, VLOXSEG7EI32_V }, // 4625
  { PseudoVLOXSEG7EI64_V_M1_M1, VLOXSEG7EI64_V }, // 4626
  { PseudoVLOXSEG7EI64_V_M1_M1_MASK, VLOXSEG7EI64_V }, // 4627
  { PseudoVLOXSEG7EI64_V_M1_M1_TU, VLOXSEG7EI64_V }, // 4628
  { PseudoVLOXSEG7EI64_V_M1_MF2, VLOXSEG7EI64_V }, // 4629
  { PseudoVLOXSEG7EI64_V_M1_MF2_MASK, VLOXSEG7EI64_V }, // 4630
  { PseudoVLOXSEG7EI64_V_M1_MF2_TU, VLOXSEG7EI64_V }, // 4631
  { PseudoVLOXSEG7EI64_V_M1_MF4, VLOXSEG7EI64_V }, // 4632
  { PseudoVLOXSEG7EI64_V_M1_MF4_MASK, VLOXSEG7EI64_V }, // 4633
  { PseudoVLOXSEG7EI64_V_M1_MF4_TU, VLOXSEG7EI64_V }, // 4634
  { PseudoVLOXSEG7EI64_V_M1_MF8, VLOXSEG7EI64_V }, // 4635
  { PseudoVLOXSEG7EI64_V_M1_MF8_MASK, VLOXSEG7EI64_V }, // 4636
  { PseudoVLOXSEG7EI64_V_M1_MF8_TU, VLOXSEG7EI64_V }, // 4637
  { PseudoVLOXSEG7EI64_V_M2_M1, VLOXSEG7EI64_V }, // 4638
  { PseudoVLOXSEG7EI64_V_M2_M1_MASK, VLOXSEG7EI64_V }, // 4639
  { PseudoVLOXSEG7EI64_V_M2_M1_TU, VLOXSEG7EI64_V }, // 4640
  { PseudoVLOXSEG7EI64_V_M2_MF2, VLOXSEG7EI64_V }, // 4641
  { PseudoVLOXSEG7EI64_V_M2_MF2_MASK, VLOXSEG7EI64_V }, // 4642
  { PseudoVLOXSEG7EI64_V_M2_MF2_TU, VLOXSEG7EI64_V }, // 4643
  { PseudoVLOXSEG7EI64_V_M2_MF4, VLOXSEG7EI64_V }, // 4644
  { PseudoVLOXSEG7EI64_V_M2_MF4_MASK, VLOXSEG7EI64_V }, // 4645
  { PseudoVLOXSEG7EI64_V_M2_MF4_TU, VLOXSEG7EI64_V }, // 4646
  { PseudoVLOXSEG7EI64_V_M4_M1, VLOXSEG7EI64_V }, // 4647
  { PseudoVLOXSEG7EI64_V_M4_M1_MASK, VLOXSEG7EI64_V }, // 4648
  { PseudoVLOXSEG7EI64_V_M4_M1_TU, VLOXSEG7EI64_V }, // 4649
  { PseudoVLOXSEG7EI64_V_M4_MF2, VLOXSEG7EI64_V }, // 4650
  { PseudoVLOXSEG7EI64_V_M4_MF2_MASK, VLOXSEG7EI64_V }, // 4651
  { PseudoVLOXSEG7EI64_V_M4_MF2_TU, VLOXSEG7EI64_V }, // 4652
  { PseudoVLOXSEG7EI64_V_M8_M1, VLOXSEG7EI64_V }, // 4653
  { PseudoVLOXSEG7EI64_V_M8_M1_MASK, VLOXSEG7EI64_V }, // 4654
  { PseudoVLOXSEG7EI64_V_M8_M1_TU, VLOXSEG7EI64_V }, // 4655
  { PseudoVLOXSEG7EI8_V_M1_M1, VLOXSEG7EI8_V }, // 4656
  { PseudoVLOXSEG7EI8_V_M1_M1_MASK, VLOXSEG7EI8_V }, // 4657
  { PseudoVLOXSEG7EI8_V_M1_M1_TU, VLOXSEG7EI8_V }, // 4658
  { PseudoVLOXSEG7EI8_V_MF2_M1, VLOXSEG7EI8_V }, // 4659
  { PseudoVLOXSEG7EI8_V_MF2_M1_MASK, VLOXSEG7EI8_V }, // 4660
  { PseudoVLOXSEG7EI8_V_MF2_M1_TU, VLOXSEG7EI8_V }, // 4661
  { PseudoVLOXSEG7EI8_V_MF2_MF2, VLOXSEG7EI8_V }, // 4662
  { PseudoVLOXSEG7EI8_V_MF2_MF2_MASK, VLOXSEG7EI8_V }, // 4663
  { PseudoVLOXSEG7EI8_V_MF2_MF2_TU, VLOXSEG7EI8_V }, // 4664
  { PseudoVLOXSEG7EI8_V_MF4_M1, VLOXSEG7EI8_V }, // 4665
  { PseudoVLOXSEG7EI8_V_MF4_M1_MASK, VLOXSEG7EI8_V }, // 4666
  { PseudoVLOXSEG7EI8_V_MF4_M1_TU, VLOXSEG7EI8_V }, // 4667
  { PseudoVLOXSEG7EI8_V_MF4_MF2, VLOXSEG7EI8_V }, // 4668
  { PseudoVLOXSEG7EI8_V_MF4_MF2_MASK, VLOXSEG7EI8_V }, // 4669
  { PseudoVLOXSEG7EI8_V_MF4_MF2_TU, VLOXSEG7EI8_V }, // 4670
  { PseudoVLOXSEG7EI8_V_MF4_MF4, VLOXSEG7EI8_V }, // 4671
  { PseudoVLOXSEG7EI8_V_MF4_MF4_MASK, VLOXSEG7EI8_V }, // 4672
  { PseudoVLOXSEG7EI8_V_MF4_MF4_TU, VLOXSEG7EI8_V }, // 4673
  { PseudoVLOXSEG7EI8_V_MF8_M1, VLOXSEG7EI8_V }, // 4674
  { PseudoVLOXSEG7EI8_V_MF8_M1_MASK, VLOXSEG7EI8_V }, // 4675
  { PseudoVLOXSEG7EI8_V_MF8_M1_TU, VLOXSEG7EI8_V }, // 4676
  { PseudoVLOXSEG7EI8_V_MF8_MF2, VLOXSEG7EI8_V }, // 4677
  { PseudoVLOXSEG7EI8_V_MF8_MF2_MASK, VLOXSEG7EI8_V }, // 4678
  { PseudoVLOXSEG7EI8_V_MF8_MF2_TU, VLOXSEG7EI8_V }, // 4679
  { PseudoVLOXSEG7EI8_V_MF8_MF4, VLOXSEG7EI8_V }, // 4680
  { PseudoVLOXSEG7EI8_V_MF8_MF4_MASK, VLOXSEG7EI8_V }, // 4681
  { PseudoVLOXSEG7EI8_V_MF8_MF4_TU, VLOXSEG7EI8_V }, // 4682
  { PseudoVLOXSEG7EI8_V_MF8_MF8, VLOXSEG7EI8_V }, // 4683
  { PseudoVLOXSEG7EI8_V_MF8_MF8_MASK, VLOXSEG7EI8_V }, // 4684
  { PseudoVLOXSEG7EI8_V_MF8_MF8_TU, VLOXSEG7EI8_V }, // 4685
  { PseudoVLOXSEG8EI16_V_M1_M1, VLOXSEG8EI16_V }, // 4686
  { PseudoVLOXSEG8EI16_V_M1_M1_MASK, VLOXSEG8EI16_V }, // 4687
  { PseudoVLOXSEG8EI16_V_M1_M1_TU, VLOXSEG8EI16_V }, // 4688
  { PseudoVLOXSEG8EI16_V_M1_MF2, VLOXSEG8EI16_V }, // 4689
  { PseudoVLOXSEG8EI16_V_M1_MF2_MASK, VLOXSEG8EI16_V }, // 4690
  { PseudoVLOXSEG8EI16_V_M1_MF2_TU, VLOXSEG8EI16_V }, // 4691
  { PseudoVLOXSEG8EI16_V_M2_M1, VLOXSEG8EI16_V }, // 4692
  { PseudoVLOXSEG8EI16_V_M2_M1_MASK, VLOXSEG8EI16_V }, // 4693
  { PseudoVLOXSEG8EI16_V_M2_M1_TU, VLOXSEG8EI16_V }, // 4694
  { PseudoVLOXSEG8EI16_V_MF2_M1, VLOXSEG8EI16_V }, // 4695
  { PseudoVLOXSEG8EI16_V_MF2_M1_MASK, VLOXSEG8EI16_V }, // 4696
  { PseudoVLOXSEG8EI16_V_MF2_M1_TU, VLOXSEG8EI16_V }, // 4697
  { PseudoVLOXSEG8EI16_V_MF2_MF2, VLOXSEG8EI16_V }, // 4698
  { PseudoVLOXSEG8EI16_V_MF2_MF2_MASK, VLOXSEG8EI16_V }, // 4699
  { PseudoVLOXSEG8EI16_V_MF2_MF2_TU, VLOXSEG8EI16_V }, // 4700
  { PseudoVLOXSEG8EI16_V_MF2_MF4, VLOXSEG8EI16_V }, // 4701
  { PseudoVLOXSEG8EI16_V_MF2_MF4_MASK, VLOXSEG8EI16_V }, // 4702
  { PseudoVLOXSEG8EI16_V_MF2_MF4_TU, VLOXSEG8EI16_V }, // 4703
  { PseudoVLOXSEG8EI16_V_MF4_M1, VLOXSEG8EI16_V }, // 4704
  { PseudoVLOXSEG8EI16_V_MF4_M1_MASK, VLOXSEG8EI16_V }, // 4705
  { PseudoVLOXSEG8EI16_V_MF4_M1_TU, VLOXSEG8EI16_V }, // 4706
  { PseudoVLOXSEG8EI16_V_MF4_MF2, VLOXSEG8EI16_V }, // 4707
  { PseudoVLOXSEG8EI16_V_MF4_MF2_MASK, VLOXSEG8EI16_V }, // 4708
  { PseudoVLOXSEG8EI16_V_MF4_MF2_TU, VLOXSEG8EI16_V }, // 4709
  { PseudoVLOXSEG8EI16_V_MF4_MF4, VLOXSEG8EI16_V }, // 4710
  { PseudoVLOXSEG8EI16_V_MF4_MF4_MASK, VLOXSEG8EI16_V }, // 4711
  { PseudoVLOXSEG8EI16_V_MF4_MF4_TU, VLOXSEG8EI16_V }, // 4712
  { PseudoVLOXSEG8EI16_V_MF4_MF8, VLOXSEG8EI16_V }, // 4713
  { PseudoVLOXSEG8EI16_V_MF4_MF8_MASK, VLOXSEG8EI16_V }, // 4714
  { PseudoVLOXSEG8EI16_V_MF4_MF8_TU, VLOXSEG8EI16_V }, // 4715
  { PseudoVLOXSEG8EI32_V_M1_M1, VLOXSEG8EI32_V }, // 4716
  { PseudoVLOXSEG8EI32_V_M1_M1_MASK, VLOXSEG8EI32_V }, // 4717
  { PseudoVLOXSEG8EI32_V_M1_M1_TU, VLOXSEG8EI32_V }, // 4718
  { PseudoVLOXSEG8EI32_V_M1_MF2, VLOXSEG8EI32_V }, // 4719
  { PseudoVLOXSEG8EI32_V_M1_MF2_MASK, VLOXSEG8EI32_V }, // 4720
  { PseudoVLOXSEG8EI32_V_M1_MF2_TU, VLOXSEG8EI32_V }, // 4721
  { PseudoVLOXSEG8EI32_V_M1_MF4, VLOXSEG8EI32_V }, // 4722
  { PseudoVLOXSEG8EI32_V_M1_MF4_MASK, VLOXSEG8EI32_V }, // 4723
  { PseudoVLOXSEG8EI32_V_M1_MF4_TU, VLOXSEG8EI32_V }, // 4724
  { PseudoVLOXSEG8EI32_V_M2_M1, VLOXSEG8EI32_V }, // 4725
  { PseudoVLOXSEG8EI32_V_M2_M1_MASK, VLOXSEG8EI32_V }, // 4726
  { PseudoVLOXSEG8EI32_V_M2_M1_TU, VLOXSEG8EI32_V }, // 4727
  { PseudoVLOXSEG8EI32_V_M2_MF2, VLOXSEG8EI32_V }, // 4728
  { PseudoVLOXSEG8EI32_V_M2_MF2_MASK, VLOXSEG8EI32_V }, // 4729
  { PseudoVLOXSEG8EI32_V_M2_MF2_TU, VLOXSEG8EI32_V }, // 4730
  { PseudoVLOXSEG8EI32_V_M4_M1, VLOXSEG8EI32_V }, // 4731
  { PseudoVLOXSEG8EI32_V_M4_M1_MASK, VLOXSEG8EI32_V }, // 4732
  { PseudoVLOXSEG8EI32_V_M4_M1_TU, VLOXSEG8EI32_V }, // 4733
  { PseudoVLOXSEG8EI32_V_MF2_M1, VLOXSEG8EI32_V }, // 4734
  { PseudoVLOXSEG8EI32_V_MF2_M1_MASK, VLOXSEG8EI32_V }, // 4735
  { PseudoVLOXSEG8EI32_V_MF2_M1_TU, VLOXSEG8EI32_V }, // 4736
  { PseudoVLOXSEG8EI32_V_MF2_MF2, VLOXSEG8EI32_V }, // 4737
  { PseudoVLOXSEG8EI32_V_MF2_MF2_MASK, VLOXSEG8EI32_V }, // 4738
  { PseudoVLOXSEG8EI32_V_MF2_MF2_TU, VLOXSEG8EI32_V }, // 4739
  { PseudoVLOXSEG8EI32_V_MF2_MF4, VLOXSEG8EI32_V }, // 4740
  { PseudoVLOXSEG8EI32_V_MF2_MF4_MASK, VLOXSEG8EI32_V }, // 4741
  { PseudoVLOXSEG8EI32_V_MF2_MF4_TU, VLOXSEG8EI32_V }, // 4742
  { PseudoVLOXSEG8EI32_V_MF2_MF8, VLOXSEG8EI32_V }, // 4743
  { PseudoVLOXSEG8EI32_V_MF2_MF8_MASK, VLOXSEG8EI32_V }, // 4744
  { PseudoVLOXSEG8EI32_V_MF2_MF8_TU, VLOXSEG8EI32_V }, // 4745
  { PseudoVLOXSEG8EI64_V_M1_M1, VLOXSEG8EI64_V }, // 4746
  { PseudoVLOXSEG8EI64_V_M1_M1_MASK, VLOXSEG8EI64_V }, // 4747
  { PseudoVLOXSEG8EI64_V_M1_M1_TU, VLOXSEG8EI64_V }, // 4748
  { PseudoVLOXSEG8EI64_V_M1_MF2, VLOXSEG8EI64_V }, // 4749
  { PseudoVLOXSEG8EI64_V_M1_MF2_MASK, VLOXSEG8EI64_V }, // 4750
  { PseudoVLOXSEG8EI64_V_M1_MF2_TU, VLOXSEG8EI64_V }, // 4751
  { PseudoVLOXSEG8EI64_V_M1_MF4, VLOXSEG8EI64_V }, // 4752
  { PseudoVLOXSEG8EI64_V_M1_MF4_MASK, VLOXSEG8EI64_V }, // 4753
  { PseudoVLOXSEG8EI64_V_M1_MF4_TU, VLOXSEG8EI64_V }, // 4754
  { PseudoVLOXSEG8EI64_V_M1_MF8, VLOXSEG8EI64_V }, // 4755
  { PseudoVLOXSEG8EI64_V_M1_MF8_MASK, VLOXSEG8EI64_V }, // 4756
  { PseudoVLOXSEG8EI64_V_M1_MF8_TU, VLOXSEG8EI64_V }, // 4757
  { PseudoVLOXSEG8EI64_V_M2_M1, VLOXSEG8EI64_V }, // 4758
  { PseudoVLOXSEG8EI64_V_M2_M1_MASK, VLOXSEG8EI64_V }, // 4759
  { PseudoVLOXSEG8EI64_V_M2_M1_TU, VLOXSEG8EI64_V }, // 4760
  { PseudoVLOXSEG8EI64_V_M2_MF2, VLOXSEG8EI64_V }, // 4761
  { PseudoVLOXSEG8EI64_V_M2_MF2_MASK, VLOXSEG8EI64_V }, // 4762
  { PseudoVLOXSEG8EI64_V_M2_MF2_TU, VLOXSEG8EI64_V }, // 4763
  { PseudoVLOXSEG8EI64_V_M2_MF4, VLOXSEG8EI64_V }, // 4764
  { PseudoVLOXSEG8EI64_V_M2_MF4_MASK, VLOXSEG8EI64_V }, // 4765
  { PseudoVLOXSEG8EI64_V_M2_MF4_TU, VLOXSEG8EI64_V }, // 4766
  { PseudoVLOXSEG8EI64_V_M4_M1, VLOXSEG8EI64_V }, // 4767
  { PseudoVLOXSEG8EI64_V_M4_M1_MASK, VLOXSEG8EI64_V }, // 4768
  { PseudoVLOXSEG8EI64_V_M4_M1_TU, VLOXSEG8EI64_V }, // 4769
  { PseudoVLOXSEG8EI64_V_M4_MF2, VLOXSEG8EI64_V }, // 4770
  { PseudoVLOXSEG8EI64_V_M4_MF2_MASK, VLOXSEG8EI64_V }, // 4771
  { PseudoVLOXSEG8EI64_V_M4_MF2_TU, VLOXSEG8EI64_V }, // 4772
  { PseudoVLOXSEG8EI64_V_M8_M1, VLOXSEG8EI64_V }, // 4773
  { PseudoVLOXSEG8EI64_V_M8_M1_MASK, VLOXSEG8EI64_V }, // 4774
  { PseudoVLOXSEG8EI64_V_M8_M1_TU, VLOXSEG8EI64_V }, // 4775
  { PseudoVLOXSEG8EI8_V_M1_M1, VLOXSEG8EI8_V }, // 4776
  { PseudoVLOXSEG8EI8_V_M1_M1_MASK, VLOXSEG8EI8_V }, // 4777
  { PseudoVLOXSEG8EI8_V_M1_M1_TU, VLOXSEG8EI8_V }, // 4778
  { PseudoVLOXSEG8EI8_V_MF2_M1, VLOXSEG8EI8_V }, // 4779
  { PseudoVLOXSEG8EI8_V_MF2_M1_MASK, VLOXSEG8EI8_V }, // 4780
  { PseudoVLOXSEG8EI8_V_MF2_M1_TU, VLOXSEG8EI8_V }, // 4781
  { PseudoVLOXSEG8EI8_V_MF2_MF2, VLOXSEG8EI8_V }, // 4782
  { PseudoVLOXSEG8EI8_V_MF2_MF2_MASK, VLOXSEG8EI8_V }, // 4783
  { PseudoVLOXSEG8EI8_V_MF2_MF2_TU, VLOXSEG8EI8_V }, // 4784
  { PseudoVLOXSEG8EI8_V_MF4_M1, VLOXSEG8EI8_V }, // 4785
  { PseudoVLOXSEG8EI8_V_MF4_M1_MASK, VLOXSEG8EI8_V }, // 4786
  { PseudoVLOXSEG8EI8_V_MF4_M1_TU, VLOXSEG8EI8_V }, // 4787
  { PseudoVLOXSEG8EI8_V_MF4_MF2, VLOXSEG8EI8_V }, // 4788
  { PseudoVLOXSEG8EI8_V_MF4_MF2_MASK, VLOXSEG8EI8_V }, // 4789
  { PseudoVLOXSEG8EI8_V_MF4_MF2_TU, VLOXSEG8EI8_V }, // 4790
  { PseudoVLOXSEG8EI8_V_MF4_MF4, VLOXSEG8EI8_V }, // 4791
  { PseudoVLOXSEG8EI8_V_MF4_MF4_MASK, VLOXSEG8EI8_V }, // 4792
  { PseudoVLOXSEG8EI8_V_MF4_MF4_TU, VLOXSEG8EI8_V }, // 4793
  { PseudoVLOXSEG8EI8_V_MF8_M1, VLOXSEG8EI8_V }, // 4794
  { PseudoVLOXSEG8EI8_V_MF8_M1_MASK, VLOXSEG8EI8_V }, // 4795
  { PseudoVLOXSEG8EI8_V_MF8_M1_TU, VLOXSEG8EI8_V }, // 4796
  { PseudoVLOXSEG8EI8_V_MF8_MF2, VLOXSEG8EI8_V }, // 4797
  { PseudoVLOXSEG8EI8_V_MF8_MF2_MASK, VLOXSEG8EI8_V }, // 4798
  { PseudoVLOXSEG8EI8_V_MF8_MF2_TU, VLOXSEG8EI8_V }, // 4799
  { PseudoVLOXSEG8EI8_V_MF8_MF4, VLOXSEG8EI8_V }, // 4800
  { PseudoVLOXSEG8EI8_V_MF8_MF4_MASK, VLOXSEG8EI8_V }, // 4801
  { PseudoVLOXSEG8EI8_V_MF8_MF4_TU, VLOXSEG8EI8_V }, // 4802
  { PseudoVLOXSEG8EI8_V_MF8_MF8, VLOXSEG8EI8_V }, // 4803
  { PseudoVLOXSEG8EI8_V_MF8_MF8_MASK, VLOXSEG8EI8_V }, // 4804
  { PseudoVLOXSEG8EI8_V_MF8_MF8_TU, VLOXSEG8EI8_V }, // 4805
  { PseudoVLSE16_V_M1, VLSE16_V }, // 4806
  { PseudoVLSE16_V_M1_MASK, VLSE16_V }, // 4807
  { PseudoVLSE16_V_M1_TU, VLSE16_V }, // 4808
  { PseudoVLSE16_V_M2, VLSE16_V }, // 4809
  { PseudoVLSE16_V_M2_MASK, VLSE16_V }, // 4810
  { PseudoVLSE16_V_M2_TU, VLSE16_V }, // 4811
  { PseudoVLSE16_V_M4, VLSE16_V }, // 4812
  { PseudoVLSE16_V_M4_MASK, VLSE16_V }, // 4813
  { PseudoVLSE16_V_M4_TU, VLSE16_V }, // 4814
  { PseudoVLSE16_V_M8, VLSE16_V }, // 4815
  { PseudoVLSE16_V_M8_MASK, VLSE16_V }, // 4816
  { PseudoVLSE16_V_M8_TU, VLSE16_V }, // 4817
  { PseudoVLSE16_V_MF2, VLSE16_V }, // 4818
  { PseudoVLSE16_V_MF2_MASK, VLSE16_V }, // 4819
  { PseudoVLSE16_V_MF2_TU, VLSE16_V }, // 4820
  { PseudoVLSE16_V_MF4, VLSE16_V }, // 4821
  { PseudoVLSE16_V_MF4_MASK, VLSE16_V }, // 4822
  { PseudoVLSE16_V_MF4_TU, VLSE16_V }, // 4823
  { PseudoVLSE32_V_M1, VLSE32_V }, // 4824
  { PseudoVLSE32_V_M1_MASK, VLSE32_V }, // 4825
  { PseudoVLSE32_V_M1_TU, VLSE32_V }, // 4826
  { PseudoVLSE32_V_M2, VLSE32_V }, // 4827
  { PseudoVLSE32_V_M2_MASK, VLSE32_V }, // 4828
  { PseudoVLSE32_V_M2_TU, VLSE32_V }, // 4829
  { PseudoVLSE32_V_M4, VLSE32_V }, // 4830
  { PseudoVLSE32_V_M4_MASK, VLSE32_V }, // 4831
  { PseudoVLSE32_V_M4_TU, VLSE32_V }, // 4832
  { PseudoVLSE32_V_M8, VLSE32_V }, // 4833
  { PseudoVLSE32_V_M8_MASK, VLSE32_V }, // 4834
  { PseudoVLSE32_V_M8_TU, VLSE32_V }, // 4835
  { PseudoVLSE32_V_MF2, VLSE32_V }, // 4836
  { PseudoVLSE32_V_MF2_MASK, VLSE32_V }, // 4837
  { PseudoVLSE32_V_MF2_TU, VLSE32_V }, // 4838
  { PseudoVLSE64_V_M1, VLSE64_V }, // 4839
  { PseudoVLSE64_V_M1_MASK, VLSE64_V }, // 4840
  { PseudoVLSE64_V_M1_TU, VLSE64_V }, // 4841
  { PseudoVLSE64_V_M2, VLSE64_V }, // 4842
  { PseudoVLSE64_V_M2_MASK, VLSE64_V }, // 4843
  { PseudoVLSE64_V_M2_TU, VLSE64_V }, // 4844
  { PseudoVLSE64_V_M4, VLSE64_V }, // 4845
  { PseudoVLSE64_V_M4_MASK, VLSE64_V }, // 4846
  { PseudoVLSE64_V_M4_TU, VLSE64_V }, // 4847
  { PseudoVLSE64_V_M8, VLSE64_V }, // 4848
  { PseudoVLSE64_V_M8_MASK, VLSE64_V }, // 4849
  { PseudoVLSE64_V_M8_TU, VLSE64_V }, // 4850
  { PseudoVLSE8_V_M1, VLSE8_V }, // 4851
  { PseudoVLSE8_V_M1_MASK, VLSE8_V }, // 4852
  { PseudoVLSE8_V_M1_TU, VLSE8_V }, // 4853
  { PseudoVLSE8_V_M2, VLSE8_V }, // 4854
  { PseudoVLSE8_V_M2_MASK, VLSE8_V }, // 4855
  { PseudoVLSE8_V_M2_TU, VLSE8_V }, // 4856
  { PseudoVLSE8_V_M4, VLSE8_V }, // 4857
  { PseudoVLSE8_V_M4_MASK, VLSE8_V }, // 4858
  { PseudoVLSE8_V_M4_TU, VLSE8_V }, // 4859
  { PseudoVLSE8_V_M8, VLSE8_V }, // 4860
  { PseudoVLSE8_V_M8_MASK, VLSE8_V }, // 4861
  { PseudoVLSE8_V_M8_TU, VLSE8_V }, // 4862
  { PseudoVLSE8_V_MF2, VLSE8_V }, // 4863
  { PseudoVLSE8_V_MF2_MASK, VLSE8_V }, // 4864
  { PseudoVLSE8_V_MF2_TU, VLSE8_V }, // 4865
  { PseudoVLSE8_V_MF4, VLSE8_V }, // 4866
  { PseudoVLSE8_V_MF4_MASK, VLSE8_V }, // 4867
  { PseudoVLSE8_V_MF4_TU, VLSE8_V }, // 4868
  { PseudoVLSE8_V_MF8, VLSE8_V }, // 4869
  { PseudoVLSE8_V_MF8_MASK, VLSE8_V }, // 4870
  { PseudoVLSE8_V_MF8_TU, VLSE8_V }, // 4871
  { PseudoVLSEG2E16FF_V_M1, VLSEG2E16FF_V }, // 4872
  { PseudoVLSEG2E16FF_V_M1_MASK, VLSEG2E16FF_V }, // 4873
  { PseudoVLSEG2E16FF_V_M1_TU, VLSEG2E16FF_V }, // 4874
  { PseudoVLSEG2E16FF_V_M2, VLSEG2E16FF_V }, // 4875
  { PseudoVLSEG2E16FF_V_M2_MASK, VLSEG2E16FF_V }, // 4876
  { PseudoVLSEG2E16FF_V_M2_TU, VLSEG2E16FF_V }, // 4877
  { PseudoVLSEG2E16FF_V_M4, VLSEG2E16FF_V }, // 4878
  { PseudoVLSEG2E16FF_V_M4_MASK, VLSEG2E16FF_V }, // 4879
  { PseudoVLSEG2E16FF_V_M4_TU, VLSEG2E16FF_V }, // 4880
  { PseudoVLSEG2E16FF_V_MF2, VLSEG2E16FF_V }, // 4881
  { PseudoVLSEG2E16FF_V_MF2_MASK, VLSEG2E16FF_V }, // 4882
  { PseudoVLSEG2E16FF_V_MF2_TU, VLSEG2E16FF_V }, // 4883
  { PseudoVLSEG2E16FF_V_MF4, VLSEG2E16FF_V }, // 4884
  { PseudoVLSEG2E16FF_V_MF4_MASK, VLSEG2E16FF_V }, // 4885
  { PseudoVLSEG2E16FF_V_MF4_TU, VLSEG2E16FF_V }, // 4886
  { PseudoVLSEG2E16_V_M1, VLSEG2E16_V }, // 4887
  { PseudoVLSEG2E16_V_M1_MASK, VLSEG2E16_V }, // 4888
  { PseudoVLSEG2E16_V_M1_TU, VLSEG2E16_V }, // 4889
  { PseudoVLSEG2E16_V_M2, VLSEG2E16_V }, // 4890
  { PseudoVLSEG2E16_V_M2_MASK, VLSEG2E16_V }, // 4891
  { PseudoVLSEG2E16_V_M2_TU, VLSEG2E16_V }, // 4892
  { PseudoVLSEG2E16_V_M4, VLSEG2E16_V }, // 4893
  { PseudoVLSEG2E16_V_M4_MASK, VLSEG2E16_V }, // 4894
  { PseudoVLSEG2E16_V_M4_TU, VLSEG2E16_V }, // 4895
  { PseudoVLSEG2E16_V_MF2, VLSEG2E16_V }, // 4896
  { PseudoVLSEG2E16_V_MF2_MASK, VLSEG2E16_V }, // 4897
  { PseudoVLSEG2E16_V_MF2_TU, VLSEG2E16_V }, // 4898
  { PseudoVLSEG2E16_V_MF4, VLSEG2E16_V }, // 4899
  { PseudoVLSEG2E16_V_MF4_MASK, VLSEG2E16_V }, // 4900
  { PseudoVLSEG2E16_V_MF4_TU, VLSEG2E16_V }, // 4901
  { PseudoVLSEG2E32FF_V_M1, VLSEG2E32FF_V }, // 4902
  { PseudoVLSEG2E32FF_V_M1_MASK, VLSEG2E32FF_V }, // 4903
  { PseudoVLSEG2E32FF_V_M1_TU, VLSEG2E32FF_V }, // 4904
  { PseudoVLSEG2E32FF_V_M2, VLSEG2E32FF_V }, // 4905
  { PseudoVLSEG2E32FF_V_M2_MASK, VLSEG2E32FF_V }, // 4906
  { PseudoVLSEG2E32FF_V_M2_TU, VLSEG2E32FF_V }, // 4907
  { PseudoVLSEG2E32FF_V_M4, VLSEG2E32FF_V }, // 4908
  { PseudoVLSEG2E32FF_V_M4_MASK, VLSEG2E32FF_V }, // 4909
  { PseudoVLSEG2E32FF_V_M4_TU, VLSEG2E32FF_V }, // 4910
  { PseudoVLSEG2E32FF_V_MF2, VLSEG2E32FF_V }, // 4911
  { PseudoVLSEG2E32FF_V_MF2_MASK, VLSEG2E32FF_V }, // 4912
  { PseudoVLSEG2E32FF_V_MF2_TU, VLSEG2E32FF_V }, // 4913
  { PseudoVLSEG2E32_V_M1, VLSEG2E32_V }, // 4914
  { PseudoVLSEG2E32_V_M1_MASK, VLSEG2E32_V }, // 4915
  { PseudoVLSEG2E32_V_M1_TU, VLSEG2E32_V }, // 4916
  { PseudoVLSEG2E32_V_M2, VLSEG2E32_V }, // 4917
  { PseudoVLSEG2E32_V_M2_MASK, VLSEG2E32_V }, // 4918
  { PseudoVLSEG2E32_V_M2_TU, VLSEG2E32_V }, // 4919
  { PseudoVLSEG2E32_V_M4, VLSEG2E32_V }, // 4920
  { PseudoVLSEG2E32_V_M4_MASK, VLSEG2E32_V }, // 4921
  { PseudoVLSEG2E32_V_M4_TU, VLSEG2E32_V }, // 4922
  { PseudoVLSEG2E32_V_MF2, VLSEG2E32_V }, // 4923
  { PseudoVLSEG2E32_V_MF2_MASK, VLSEG2E32_V }, // 4924
  { PseudoVLSEG2E32_V_MF2_TU, VLSEG2E32_V }, // 4925
  { PseudoVLSEG2E64FF_V_M1, VLSEG2E64FF_V }, // 4926
  { PseudoVLSEG2E64FF_V_M1_MASK, VLSEG2E64FF_V }, // 4927
  { PseudoVLSEG2E64FF_V_M1_TU, VLSEG2E64FF_V }, // 4928
  { PseudoVLSEG2E64FF_V_M2, VLSEG2E64FF_V }, // 4929
  { PseudoVLSEG2E64FF_V_M2_MASK, VLSEG2E64FF_V }, // 4930
  { PseudoVLSEG2E64FF_V_M2_TU, VLSEG2E64FF_V }, // 4931
  { PseudoVLSEG2E64FF_V_M4, VLSEG2E64FF_V }, // 4932
  { PseudoVLSEG2E64FF_V_M4_MASK, VLSEG2E64FF_V }, // 4933
  { PseudoVLSEG2E64FF_V_M4_TU, VLSEG2E64FF_V }, // 4934
  { PseudoVLSEG2E64_V_M1, VLSEG2E64_V }, // 4935
  { PseudoVLSEG2E64_V_M1_MASK, VLSEG2E64_V }, // 4936
  { PseudoVLSEG2E64_V_M1_TU, VLSEG2E64_V }, // 4937
  { PseudoVLSEG2E64_V_M2, VLSEG2E64_V }, // 4938
  { PseudoVLSEG2E64_V_M2_MASK, VLSEG2E64_V }, // 4939
  { PseudoVLSEG2E64_V_M2_TU, VLSEG2E64_V }, // 4940
  { PseudoVLSEG2E64_V_M4, VLSEG2E64_V }, // 4941
  { PseudoVLSEG2E64_V_M4_MASK, VLSEG2E64_V }, // 4942
  { PseudoVLSEG2E64_V_M4_TU, VLSEG2E64_V }, // 4943
  { PseudoVLSEG2E8FF_V_M1, VLSEG2E8FF_V }, // 4944
  { PseudoVLSEG2E8FF_V_M1_MASK, VLSEG2E8FF_V }, // 4945
  { PseudoVLSEG2E8FF_V_M1_TU, VLSEG2E8FF_V }, // 4946
  { PseudoVLSEG2E8FF_V_M2, VLSEG2E8FF_V }, // 4947
  { PseudoVLSEG2E8FF_V_M2_MASK, VLSEG2E8FF_V }, // 4948
  { PseudoVLSEG2E8FF_V_M2_TU, VLSEG2E8FF_V }, // 4949
  { PseudoVLSEG2E8FF_V_M4, VLSEG2E8FF_V }, // 4950
  { PseudoVLSEG2E8FF_V_M4_MASK, VLSEG2E8FF_V }, // 4951
  { PseudoVLSEG2E8FF_V_M4_TU, VLSEG2E8FF_V }, // 4952
  { PseudoVLSEG2E8FF_V_MF2, VLSEG2E8FF_V }, // 4953
  { PseudoVLSEG2E8FF_V_MF2_MASK, VLSEG2E8FF_V }, // 4954
  { PseudoVLSEG2E8FF_V_MF2_TU, VLSEG2E8FF_V }, // 4955
  { PseudoVLSEG2E8FF_V_MF4, VLSEG2E8FF_V }, // 4956
  { PseudoVLSEG2E8FF_V_MF4_MASK, VLSEG2E8FF_V }, // 4957
  { PseudoVLSEG2E8FF_V_MF4_TU, VLSEG2E8FF_V }, // 4958
  { PseudoVLSEG2E8FF_V_MF8, VLSEG2E8FF_V }, // 4959
  { PseudoVLSEG2E8FF_V_MF8_MASK, VLSEG2E8FF_V }, // 4960
  { PseudoVLSEG2E8FF_V_MF8_TU, VLSEG2E8FF_V }, // 4961
  { PseudoVLSEG2E8_V_M1, VLSEG2E8_V }, // 4962
  { PseudoVLSEG2E8_V_M1_MASK, VLSEG2E8_V }, // 4963
  { PseudoVLSEG2E8_V_M1_TU, VLSEG2E8_V }, // 4964
  { PseudoVLSEG2E8_V_M2, VLSEG2E8_V }, // 4965
  { PseudoVLSEG2E8_V_M2_MASK, VLSEG2E8_V }, // 4966
  { PseudoVLSEG2E8_V_M2_TU, VLSEG2E8_V }, // 4967
  { PseudoVLSEG2E8_V_M4, VLSEG2E8_V }, // 4968
  { PseudoVLSEG2E8_V_M4_MASK, VLSEG2E8_V }, // 4969
  { PseudoVLSEG2E8_V_M4_TU, VLSEG2E8_V }, // 4970
  { PseudoVLSEG2E8_V_MF2, VLSEG2E8_V }, // 4971
  { PseudoVLSEG2E8_V_MF2_MASK, VLSEG2E8_V }, // 4972
  { PseudoVLSEG2E8_V_MF2_TU, VLSEG2E8_V }, // 4973
  { PseudoVLSEG2E8_V_MF4, VLSEG2E8_V }, // 4974
  { PseudoVLSEG2E8_V_MF4_MASK, VLSEG2E8_V }, // 4975
  { PseudoVLSEG2E8_V_MF4_TU, VLSEG2E8_V }, // 4976
  { PseudoVLSEG2E8_V_MF8, VLSEG2E8_V }, // 4977
  { PseudoVLSEG2E8_V_MF8_MASK, VLSEG2E8_V }, // 4978
  { PseudoVLSEG2E8_V_MF8_TU, VLSEG2E8_V }, // 4979
  { PseudoVLSEG3E16FF_V_M1, VLSEG3E16FF_V }, // 4980
  { PseudoVLSEG3E16FF_V_M1_MASK, VLSEG3E16FF_V }, // 4981
  { PseudoVLSEG3E16FF_V_M1_TU, VLSEG3E16FF_V }, // 4982
  { PseudoVLSEG3E16FF_V_M2, VLSEG3E16FF_V }, // 4983
  { PseudoVLSEG3E16FF_V_M2_MASK, VLSEG3E16FF_V }, // 4984
  { PseudoVLSEG3E16FF_V_M2_TU, VLSEG3E16FF_V }, // 4985
  { PseudoVLSEG3E16FF_V_MF2, VLSEG3E16FF_V }, // 4986
  { PseudoVLSEG3E16FF_V_MF2_MASK, VLSEG3E16FF_V }, // 4987
  { PseudoVLSEG3E16FF_V_MF2_TU, VLSEG3E16FF_V }, // 4988
  { PseudoVLSEG3E16FF_V_MF4, VLSEG3E16FF_V }, // 4989
  { PseudoVLSEG3E16FF_V_MF4_MASK, VLSEG3E16FF_V }, // 4990
  { PseudoVLSEG3E16FF_V_MF4_TU, VLSEG3E16FF_V }, // 4991
  { PseudoVLSEG3E16_V_M1, VLSEG3E16_V }, // 4992
  { PseudoVLSEG3E16_V_M1_MASK, VLSEG3E16_V }, // 4993
  { PseudoVLSEG3E16_V_M1_TU, VLSEG3E16_V }, // 4994
  { PseudoVLSEG3E16_V_M2, VLSEG3E16_V }, // 4995
  { PseudoVLSEG3E16_V_M2_MASK, VLSEG3E16_V }, // 4996
  { PseudoVLSEG3E16_V_M2_TU, VLSEG3E16_V }, // 4997
  { PseudoVLSEG3E16_V_MF2, VLSEG3E16_V }, // 4998
  { PseudoVLSEG3E16_V_MF2_MASK, VLSEG3E16_V }, // 4999
  { PseudoVLSEG3E16_V_MF2_TU, VLSEG3E16_V }, // 5000
  { PseudoVLSEG3E16_V_MF4, VLSEG3E16_V }, // 5001
  { PseudoVLSEG3E16_V_MF4_MASK, VLSEG3E16_V }, // 5002
  { PseudoVLSEG3E16_V_MF4_TU, VLSEG3E16_V }, // 5003
  { PseudoVLSEG3E32FF_V_M1, VLSEG3E32FF_V }, // 5004
  { PseudoVLSEG3E32FF_V_M1_MASK, VLSEG3E32FF_V }, // 5005
  { PseudoVLSEG3E32FF_V_M1_TU, VLSEG3E32FF_V }, // 5006
  { PseudoVLSEG3E32FF_V_M2, VLSEG3E32FF_V }, // 5007
  { PseudoVLSEG3E32FF_V_M2_MASK, VLSEG3E32FF_V }, // 5008
  { PseudoVLSEG3E32FF_V_M2_TU, VLSEG3E32FF_V }, // 5009
  { PseudoVLSEG3E32FF_V_MF2, VLSEG3E32FF_V }, // 5010
  { PseudoVLSEG3E32FF_V_MF2_MASK, VLSEG3E32FF_V }, // 5011
  { PseudoVLSEG3E32FF_V_MF2_TU, VLSEG3E32FF_V }, // 5012
  { PseudoVLSEG3E32_V_M1, VLSEG3E32_V }, // 5013
  { PseudoVLSEG3E32_V_M1_MASK, VLSEG3E32_V }, // 5014
  { PseudoVLSEG3E32_V_M1_TU, VLSEG3E32_V }, // 5015
  { PseudoVLSEG3E32_V_M2, VLSEG3E32_V }, // 5016
  { PseudoVLSEG3E32_V_M2_MASK, VLSEG3E32_V }, // 5017
  { PseudoVLSEG3E32_V_M2_TU, VLSEG3E32_V }, // 5018
  { PseudoVLSEG3E32_V_MF2, VLSEG3E32_V }, // 5019
  { PseudoVLSEG3E32_V_MF2_MASK, VLSEG3E32_V }, // 5020
  { PseudoVLSEG3E32_V_MF2_TU, VLSEG3E32_V }, // 5021
  { PseudoVLSEG3E64FF_V_M1, VLSEG3E64FF_V }, // 5022
  { PseudoVLSEG3E64FF_V_M1_MASK, VLSEG3E64FF_V }, // 5023
  { PseudoVLSEG3E64FF_V_M1_TU, VLSEG3E64FF_V }, // 5024
  { PseudoVLSEG3E64FF_V_M2, VLSEG3E64FF_V }, // 5025
  { PseudoVLSEG3E64FF_V_M2_MASK, VLSEG3E64FF_V }, // 5026
  { PseudoVLSEG3E64FF_V_M2_TU, VLSEG3E64FF_V }, // 5027
  { PseudoVLSEG3E64_V_M1, VLSEG3E64_V }, // 5028
  { PseudoVLSEG3E64_V_M1_MASK, VLSEG3E64_V }, // 5029
  { PseudoVLSEG3E64_V_M1_TU, VLSEG3E64_V }, // 5030
  { PseudoVLSEG3E64_V_M2, VLSEG3E64_V }, // 5031
  { PseudoVLSEG3E64_V_M2_MASK, VLSEG3E64_V }, // 5032
  { PseudoVLSEG3E64_V_M2_TU, VLSEG3E64_V }, // 5033
  { PseudoVLSEG3E8FF_V_M1, VLSEG3E8FF_V }, // 5034
  { PseudoVLSEG3E8FF_V_M1_MASK, VLSEG3E8FF_V }, // 5035
  { PseudoVLSEG3E8FF_V_M1_TU, VLSEG3E8FF_V }, // 5036
  { PseudoVLSEG3E8FF_V_M2, VLSEG3E8FF_V }, // 5037
  { PseudoVLSEG3E8FF_V_M2_MASK, VLSEG3E8FF_V }, // 5038
  { PseudoVLSEG3E8FF_V_M2_TU, VLSEG3E8FF_V }, // 5039
  { PseudoVLSEG3E8FF_V_MF2, VLSEG3E8FF_V }, // 5040
  { PseudoVLSEG3E8FF_V_MF2_MASK, VLSEG3E8FF_V }, // 5041
  { PseudoVLSEG3E8FF_V_MF2_TU, VLSEG3E8FF_V }, // 5042
  { PseudoVLSEG3E8FF_V_MF4, VLSEG3E8FF_V }, // 5043
  { PseudoVLSEG3E8FF_V_MF4_MASK, VLSEG3E8FF_V }, // 5044
  { PseudoVLSEG3E8FF_V_MF4_TU, VLSEG3E8FF_V }, // 5045
  { PseudoVLSEG3E8FF_V_MF8, VLSEG3E8FF_V }, // 5046
  { PseudoVLSEG3E8FF_V_MF8_MASK, VLSEG3E8FF_V }, // 5047
  { PseudoVLSEG3E8FF_V_MF8_TU, VLSEG3E8FF_V }, // 5048
  { PseudoVLSEG3E8_V_M1, VLSEG3E8_V }, // 5049
  { PseudoVLSEG3E8_V_M1_MASK, VLSEG3E8_V }, // 5050
  { PseudoVLSEG3E8_V_M1_TU, VLSEG3E8_V }, // 5051
  { PseudoVLSEG3E8_V_M2, VLSEG3E8_V }, // 5052
  { PseudoVLSEG3E8_V_M2_MASK, VLSEG3E8_V }, // 5053
  { PseudoVLSEG3E8_V_M2_TU, VLSEG3E8_V }, // 5054
  { PseudoVLSEG3E8_V_MF2, VLSEG3E8_V }, // 5055
  { PseudoVLSEG3E8_V_MF2_MASK, VLSEG3E8_V }, // 5056
  { PseudoVLSEG3E8_V_MF2_TU, VLSEG3E8_V }, // 5057
  { PseudoVLSEG3E8_V_MF4, VLSEG3E8_V }, // 5058
  { PseudoVLSEG3E8_V_MF4_MASK, VLSEG3E8_V }, // 5059
  { PseudoVLSEG3E8_V_MF4_TU, VLSEG3E8_V }, // 5060
  { PseudoVLSEG3E8_V_MF8, VLSEG3E8_V }, // 5061
  { PseudoVLSEG3E8_V_MF8_MASK, VLSEG3E8_V }, // 5062
  { PseudoVLSEG3E8_V_MF8_TU, VLSEG3E8_V }, // 5063
  { PseudoVLSEG4E16FF_V_M1, VLSEG4E16FF_V }, // 5064
  { PseudoVLSEG4E16FF_V_M1_MASK, VLSEG4E16FF_V }, // 5065
  { PseudoVLSEG4E16FF_V_M1_TU, VLSEG4E16FF_V }, // 5066
  { PseudoVLSEG4E16FF_V_M2, VLSEG4E16FF_V }, // 5067
  { PseudoVLSEG4E16FF_V_M2_MASK, VLSEG4E16FF_V }, // 5068
  { PseudoVLSEG4E16FF_V_M2_TU, VLSEG4E16FF_V }, // 5069
  { PseudoVLSEG4E16FF_V_MF2, VLSEG4E16FF_V }, // 5070
  { PseudoVLSEG4E16FF_V_MF2_MASK, VLSEG4E16FF_V }, // 5071
  { PseudoVLSEG4E16FF_V_MF2_TU, VLSEG4E16FF_V }, // 5072
  { PseudoVLSEG4E16FF_V_MF4, VLSEG4E16FF_V }, // 5073
  { PseudoVLSEG4E16FF_V_MF4_MASK, VLSEG4E16FF_V }, // 5074
  { PseudoVLSEG4E16FF_V_MF4_TU, VLSEG4E16FF_V }, // 5075
  { PseudoVLSEG4E16_V_M1, VLSEG4E16_V }, // 5076
  { PseudoVLSEG4E16_V_M1_MASK, VLSEG4E16_V }, // 5077
  { PseudoVLSEG4E16_V_M1_TU, VLSEG4E16_V }, // 5078
  { PseudoVLSEG4E16_V_M2, VLSEG4E16_V }, // 5079
  { PseudoVLSEG4E16_V_M2_MASK, VLSEG4E16_V }, // 5080
  { PseudoVLSEG4E16_V_M2_TU, VLSEG4E16_V }, // 5081
  { PseudoVLSEG4E16_V_MF2, VLSEG4E16_V }, // 5082
  { PseudoVLSEG4E16_V_MF2_MASK, VLSEG4E16_V }, // 5083
  { PseudoVLSEG4E16_V_MF2_TU, VLSEG4E16_V }, // 5084
  { PseudoVLSEG4E16_V_MF4, VLSEG4E16_V }, // 5085
  { PseudoVLSEG4E16_V_MF4_MASK, VLSEG4E16_V }, // 5086
  { PseudoVLSEG4E16_V_MF4_TU, VLSEG4E16_V }, // 5087
  { PseudoVLSEG4E32FF_V_M1, VLSEG4E32FF_V }, // 5088
  { PseudoVLSEG4E32FF_V_M1_MASK, VLSEG4E32FF_V }, // 5089
  { PseudoVLSEG4E32FF_V_M1_TU, VLSEG4E32FF_V }, // 5090
  { PseudoVLSEG4E32FF_V_M2, VLSEG4E32FF_V }, // 5091
  { PseudoVLSEG4E32FF_V_M2_MASK, VLSEG4E32FF_V }, // 5092
  { PseudoVLSEG4E32FF_V_M2_TU, VLSEG4E32FF_V }, // 5093
  { PseudoVLSEG4E32FF_V_MF2, VLSEG4E32FF_V }, // 5094
  { PseudoVLSEG4E32FF_V_MF2_MASK, VLSEG4E32FF_V }, // 5095
  { PseudoVLSEG4E32FF_V_MF2_TU, VLSEG4E32FF_V }, // 5096
  { PseudoVLSEG4E32_V_M1, VLSEG4E32_V }, // 5097
  { PseudoVLSEG4E32_V_M1_MASK, VLSEG4E32_V }, // 5098
  { PseudoVLSEG4E32_V_M1_TU, VLSEG4E32_V }, // 5099
  { PseudoVLSEG4E32_V_M2, VLSEG4E32_V }, // 5100
  { PseudoVLSEG4E32_V_M2_MASK, VLSEG4E32_V }, // 5101
  { PseudoVLSEG4E32_V_M2_TU, VLSEG4E32_V }, // 5102
  { PseudoVLSEG4E32_V_MF2, VLSEG4E32_V }, // 5103
  { PseudoVLSEG4E32_V_MF2_MASK, VLSEG4E32_V }, // 5104
  { PseudoVLSEG4E32_V_MF2_TU, VLSEG4E32_V }, // 5105
  { PseudoVLSEG4E64FF_V_M1, VLSEG4E64FF_V }, // 5106
  { PseudoVLSEG4E64FF_V_M1_MASK, VLSEG4E64FF_V }, // 5107
  { PseudoVLSEG4E64FF_V_M1_TU, VLSEG4E64FF_V }, // 5108
  { PseudoVLSEG4E64FF_V_M2, VLSEG4E64FF_V }, // 5109
  { PseudoVLSEG4E64FF_V_M2_MASK, VLSEG4E64FF_V }, // 5110
  { PseudoVLSEG4E64FF_V_M2_TU, VLSEG4E64FF_V }, // 5111
  { PseudoVLSEG4E64_V_M1, VLSEG4E64_V }, // 5112
  { PseudoVLSEG4E64_V_M1_MASK, VLSEG4E64_V }, // 5113
  { PseudoVLSEG4E64_V_M1_TU, VLSEG4E64_V }, // 5114
  { PseudoVLSEG4E64_V_M2, VLSEG4E64_V }, // 5115
  { PseudoVLSEG4E64_V_M2_MASK, VLSEG4E64_V }, // 5116
  { PseudoVLSEG4E64_V_M2_TU, VLSEG4E64_V }, // 5117
  { PseudoVLSEG4E8FF_V_M1, VLSEG4E8FF_V }, // 5118
  { PseudoVLSEG4E8FF_V_M1_MASK, VLSEG4E8FF_V }, // 5119
  { PseudoVLSEG4E8FF_V_M1_TU, VLSEG4E8FF_V }, // 5120
  { PseudoVLSEG4E8FF_V_M2, VLSEG4E8FF_V }, // 5121
  { PseudoVLSEG4E8FF_V_M2_MASK, VLSEG4E8FF_V }, // 5122
  { PseudoVLSEG4E8FF_V_M2_TU, VLSEG4E8FF_V }, // 5123
  { PseudoVLSEG4E8FF_V_MF2, VLSEG4E8FF_V }, // 5124
  { PseudoVLSEG4E8FF_V_MF2_MASK, VLSEG4E8FF_V }, // 5125
  { PseudoVLSEG4E8FF_V_MF2_TU, VLSEG4E8FF_V }, // 5126
  { PseudoVLSEG4E8FF_V_MF4, VLSEG4E8FF_V }, // 5127
  { PseudoVLSEG4E8FF_V_MF4_MASK, VLSEG4E8FF_V }, // 5128
  { PseudoVLSEG4E8FF_V_MF4_TU, VLSEG4E8FF_V }, // 5129
  { PseudoVLSEG4E8FF_V_MF8, VLSEG4E8FF_V }, // 5130
  { PseudoVLSEG4E8FF_V_MF8_MASK, VLSEG4E8FF_V }, // 5131
  { PseudoVLSEG4E8FF_V_MF8_TU, VLSEG4E8FF_V }, // 5132
  { PseudoVLSEG4E8_V_M1, VLSEG4E8_V }, // 5133
  { PseudoVLSEG4E8_V_M1_MASK, VLSEG4E8_V }, // 5134
  { PseudoVLSEG4E8_V_M1_TU, VLSEG4E8_V }, // 5135
  { PseudoVLSEG4E8_V_M2, VLSEG4E8_V }, // 5136
  { PseudoVLSEG4E8_V_M2_MASK, VLSEG4E8_V }, // 5137
  { PseudoVLSEG4E8_V_M2_TU, VLSEG4E8_V }, // 5138
  { PseudoVLSEG4E8_V_MF2, VLSEG4E8_V }, // 5139
  { PseudoVLSEG4E8_V_MF2_MASK, VLSEG4E8_V }, // 5140
  { PseudoVLSEG4E8_V_MF2_TU, VLSEG4E8_V }, // 5141
  { PseudoVLSEG4E8_V_MF4, VLSEG4E8_V }, // 5142
  { PseudoVLSEG4E8_V_MF4_MASK, VLSEG4E8_V }, // 5143
  { PseudoVLSEG4E8_V_MF4_TU, VLSEG4E8_V }, // 5144
  { PseudoVLSEG4E8_V_MF8, VLSEG4E8_V }, // 5145
  { PseudoVLSEG4E8_V_MF8_MASK, VLSEG4E8_V }, // 5146
  { PseudoVLSEG4E8_V_MF8_TU, VLSEG4E8_V }, // 5147
  { PseudoVLSEG5E16FF_V_M1, VLSEG5E16FF_V }, // 5148
  { PseudoVLSEG5E16FF_V_M1_MASK, VLSEG5E16FF_V }, // 5149
  { PseudoVLSEG5E16FF_V_M1_TU, VLSEG5E16FF_V }, // 5150
  { PseudoVLSEG5E16FF_V_MF2, VLSEG5E16FF_V }, // 5151
  { PseudoVLSEG5E16FF_V_MF2_MASK, VLSEG5E16FF_V }, // 5152
  { PseudoVLSEG5E16FF_V_MF2_TU, VLSEG5E16FF_V }, // 5153
  { PseudoVLSEG5E16FF_V_MF4, VLSEG5E16FF_V }, // 5154
  { PseudoVLSEG5E16FF_V_MF4_MASK, VLSEG5E16FF_V }, // 5155
  { PseudoVLSEG5E16FF_V_MF4_TU, VLSEG5E16FF_V }, // 5156
  { PseudoVLSEG5E16_V_M1, VLSEG5E16_V }, // 5157
  { PseudoVLSEG5E16_V_M1_MASK, VLSEG5E16_V }, // 5158
  { PseudoVLSEG5E16_V_M1_TU, VLSEG5E16_V }, // 5159
  { PseudoVLSEG5E16_V_MF2, VLSEG5E16_V }, // 5160
  { PseudoVLSEG5E16_V_MF2_MASK, VLSEG5E16_V }, // 5161
  { PseudoVLSEG5E16_V_MF2_TU, VLSEG5E16_V }, // 5162
  { PseudoVLSEG5E16_V_MF4, VLSEG5E16_V }, // 5163
  { PseudoVLSEG5E16_V_MF4_MASK, VLSEG5E16_V }, // 5164
  { PseudoVLSEG5E16_V_MF4_TU, VLSEG5E16_V }, // 5165
  { PseudoVLSEG5E32FF_V_M1, VLSEG5E32FF_V }, // 5166
  { PseudoVLSEG5E32FF_V_M1_MASK, VLSEG5E32FF_V }, // 5167
  { PseudoVLSEG5E32FF_V_M1_TU, VLSEG5E32FF_V }, // 5168
  { PseudoVLSEG5E32FF_V_MF2, VLSEG5E32FF_V }, // 5169
  { PseudoVLSEG5E32FF_V_MF2_MASK, VLSEG5E32FF_V }, // 5170
  { PseudoVLSEG5E32FF_V_MF2_TU, VLSEG5E32FF_V }, // 5171
  { PseudoVLSEG5E32_V_M1, VLSEG5E32_V }, // 5172
  { PseudoVLSEG5E32_V_M1_MASK, VLSEG5E32_V }, // 5173
  { PseudoVLSEG5E32_V_M1_TU, VLSEG5E32_V }, // 5174
  { PseudoVLSEG5E32_V_MF2, VLSEG5E32_V }, // 5175
  { PseudoVLSEG5E32_V_MF2_MASK, VLSEG5E32_V }, // 5176
  { PseudoVLSEG5E32_V_MF2_TU, VLSEG5E32_V }, // 5177
  { PseudoVLSEG5E64FF_V_M1, VLSEG5E64FF_V }, // 5178
  { PseudoVLSEG5E64FF_V_M1_MASK, VLSEG5E64FF_V }, // 5179
  { PseudoVLSEG5E64FF_V_M1_TU, VLSEG5E64FF_V }, // 5180
  { PseudoVLSEG5E64_V_M1, VLSEG5E64_V }, // 5181
  { PseudoVLSEG5E64_V_M1_MASK, VLSEG5E64_V }, // 5182
  { PseudoVLSEG5E64_V_M1_TU, VLSEG5E64_V }, // 5183
  { PseudoVLSEG5E8FF_V_M1, VLSEG5E8FF_V }, // 5184
  { PseudoVLSEG5E8FF_V_M1_MASK, VLSEG5E8FF_V }, // 5185
  { PseudoVLSEG5E8FF_V_M1_TU, VLSEG5E8FF_V }, // 5186
  { PseudoVLSEG5E8FF_V_MF2, VLSEG5E8FF_V }, // 5187
  { PseudoVLSEG5E8FF_V_MF2_MASK, VLSEG5E8FF_V }, // 5188
  { PseudoVLSEG5E8FF_V_MF2_TU, VLSEG5E8FF_V }, // 5189
  { PseudoVLSEG5E8FF_V_MF4, VLSEG5E8FF_V }, // 5190
  { PseudoVLSEG5E8FF_V_MF4_MASK, VLSEG5E8FF_V }, // 5191
  { PseudoVLSEG5E8FF_V_MF4_TU, VLSEG5E8FF_V }, // 5192
  { PseudoVLSEG5E8FF_V_MF8, VLSEG5E8FF_V }, // 5193
  { PseudoVLSEG5E8FF_V_MF8_MASK, VLSEG5E8FF_V }, // 5194
  { PseudoVLSEG5E8FF_V_MF8_TU, VLSEG5E8FF_V }, // 5195
  { PseudoVLSEG5E8_V_M1, VLSEG5E8_V }, // 5196
  { PseudoVLSEG5E8_V_M1_MASK, VLSEG5E8_V }, // 5197
  { PseudoVLSEG5E8_V_M1_TU, VLSEG5E8_V }, // 5198
  { PseudoVLSEG5E8_V_MF2, VLSEG5E8_V }, // 5199
  { PseudoVLSEG5E8_V_MF2_MASK, VLSEG5E8_V }, // 5200
  { PseudoVLSEG5E8_V_MF2_TU, VLSEG5E8_V }, // 5201
  { PseudoVLSEG5E8_V_MF4, VLSEG5E8_V }, // 5202
  { PseudoVLSEG5E8_V_MF4_MASK, VLSEG5E8_V }, // 5203
  { PseudoVLSEG5E8_V_MF4_TU, VLSEG5E8_V }, // 5204
  { PseudoVLSEG5E8_V_MF8, VLSEG5E8_V }, // 5205
  { PseudoVLSEG5E8_V_MF8_MASK, VLSEG5E8_V }, // 5206
  { PseudoVLSEG5E8_V_MF8_TU, VLSEG5E8_V }, // 5207
  { PseudoVLSEG6E16FF_V_M1, VLSEG6E16FF_V }, // 5208
  { PseudoVLSEG6E16FF_V_M1_MASK, VLSEG6E16FF_V }, // 5209
  { PseudoVLSEG6E16FF_V_M1_TU, VLSEG6E16FF_V }, // 5210
  { PseudoVLSEG6E16FF_V_MF2, VLSEG6E16FF_V }, // 5211
  { PseudoVLSEG6E16FF_V_MF2_MASK, VLSEG6E16FF_V }, // 5212
  { PseudoVLSEG6E16FF_V_MF2_TU, VLSEG6E16FF_V }, // 5213
  { PseudoVLSEG6E16FF_V_MF4, VLSEG6E16FF_V }, // 5214
  { PseudoVLSEG6E16FF_V_MF4_MASK, VLSEG6E16FF_V }, // 5215
  { PseudoVLSEG6E16FF_V_MF4_TU, VLSEG6E16FF_V }, // 5216
  { PseudoVLSEG6E16_V_M1, VLSEG6E16_V }, // 5217
  { PseudoVLSEG6E16_V_M1_MASK, VLSEG6E16_V }, // 5218
  { PseudoVLSEG6E16_V_M1_TU, VLSEG6E16_V }, // 5219
  { PseudoVLSEG6E16_V_MF2, VLSEG6E16_V }, // 5220
  { PseudoVLSEG6E16_V_MF2_MASK, VLSEG6E16_V }, // 5221
  { PseudoVLSEG6E16_V_MF2_TU, VLSEG6E16_V }, // 5222
  { PseudoVLSEG6E16_V_MF4, VLSEG6E16_V }, // 5223
  { PseudoVLSEG6E16_V_MF4_MASK, VLSEG6E16_V }, // 5224
  { PseudoVLSEG6E16_V_MF4_TU, VLSEG6E16_V }, // 5225
  { PseudoVLSEG6E32FF_V_M1, VLSEG6E32FF_V }, // 5226
  { PseudoVLSEG6E32FF_V_M1_MASK, VLSEG6E32FF_V }, // 5227
  { PseudoVLSEG6E32FF_V_M1_TU, VLSEG6E32FF_V }, // 5228
  { PseudoVLSEG6E32FF_V_MF2, VLSEG6E32FF_V }, // 5229
  { PseudoVLSEG6E32FF_V_MF2_MASK, VLSEG6E32FF_V }, // 5230
  { PseudoVLSEG6E32FF_V_MF2_TU, VLSEG6E32FF_V }, // 5231
  { PseudoVLSEG6E32_V_M1, VLSEG6E32_V }, // 5232
  { PseudoVLSEG6E32_V_M1_MASK, VLSEG6E32_V }, // 5233
  { PseudoVLSEG6E32_V_M1_TU, VLSEG6E32_V }, // 5234
  { PseudoVLSEG6E32_V_MF2, VLSEG6E32_V }, // 5235
  { PseudoVLSEG6E32_V_MF2_MASK, VLSEG6E32_V }, // 5236
  { PseudoVLSEG6E32_V_MF2_TU, VLSEG6E32_V }, // 5237
  { PseudoVLSEG6E64FF_V_M1, VLSEG6E64FF_V }, // 5238
  { PseudoVLSEG6E64FF_V_M1_MASK, VLSEG6E64FF_V }, // 5239
  { PseudoVLSEG6E64FF_V_M1_TU, VLSEG6E64FF_V }, // 5240
  { PseudoVLSEG6E64_V_M1, VLSEG6E64_V }, // 5241
  { PseudoVLSEG6E64_V_M1_MASK, VLSEG6E64_V }, // 5242
  { PseudoVLSEG6E64_V_M1_TU, VLSEG6E64_V }, // 5243
  { PseudoVLSEG6E8FF_V_M1, VLSEG6E8FF_V }, // 5244
  { PseudoVLSEG6E8FF_V_M1_MASK, VLSEG6E8FF_V }, // 5245
  { PseudoVLSEG6E8FF_V_M1_TU, VLSEG6E8FF_V }, // 5246
  { PseudoVLSEG6E8FF_V_MF2, VLSEG6E8FF_V }, // 5247
  { PseudoVLSEG6E8FF_V_MF2_MASK, VLSEG6E8FF_V }, // 5248
  { PseudoVLSEG6E8FF_V_MF2_TU, VLSEG6E8FF_V }, // 5249
  { PseudoVLSEG6E8FF_V_MF4, VLSEG6E8FF_V }, // 5250
  { PseudoVLSEG6E8FF_V_MF4_MASK, VLSEG6E8FF_V }, // 5251
  { PseudoVLSEG6E8FF_V_MF4_TU, VLSEG6E8FF_V }, // 5252
  { PseudoVLSEG6E8FF_V_MF8, VLSEG6E8FF_V }, // 5253
  { PseudoVLSEG6E8FF_V_MF8_MASK, VLSEG6E8FF_V }, // 5254
  { PseudoVLSEG6E8FF_V_MF8_TU, VLSEG6E8FF_V }, // 5255
  { PseudoVLSEG6E8_V_M1, VLSEG6E8_V }, // 5256
  { PseudoVLSEG6E8_V_M1_MASK, VLSEG6E8_V }, // 5257
  { PseudoVLSEG6E8_V_M1_TU, VLSEG6E8_V }, // 5258
  { PseudoVLSEG6E8_V_MF2, VLSEG6E8_V }, // 5259
  { PseudoVLSEG6E8_V_MF2_MASK, VLSEG6E8_V }, // 5260
  { PseudoVLSEG6E8_V_MF2_TU, VLSEG6E8_V }, // 5261
  { PseudoVLSEG6E8_V_MF4, VLSEG6E8_V }, // 5262
  { PseudoVLSEG6E8_V_MF4_MASK, VLSEG6E8_V }, // 5263
  { PseudoVLSEG6E8_V_MF4_TU, VLSEG6E8_V }, // 5264
  { PseudoVLSEG6E8_V_MF8, VLSEG6E8_V }, // 5265
  { PseudoVLSEG6E8_V_MF8_MASK, VLSEG6E8_V }, // 5266
  { PseudoVLSEG6E8_V_MF8_TU, VLSEG6E8_V }, // 5267
  { PseudoVLSEG7E16FF_V_M1, VLSEG7E16FF_V }, // 5268
  { PseudoVLSEG7E16FF_V_M1_MASK, VLSEG7E16FF_V }, // 5269
  { PseudoVLSEG7E16FF_V_M1_TU, VLSEG7E16FF_V }, // 5270
  { PseudoVLSEG7E16FF_V_MF2, VLSEG7E16FF_V }, // 5271
  { PseudoVLSEG7E16FF_V_MF2_MASK, VLSEG7E16FF_V }, // 5272
  { PseudoVLSEG7E16FF_V_MF2_TU, VLSEG7E16FF_V }, // 5273
  { PseudoVLSEG7E16FF_V_MF4, VLSEG7E16FF_V }, // 5274
  { PseudoVLSEG7E16FF_V_MF4_MASK, VLSEG7E16FF_V }, // 5275
  { PseudoVLSEG7E16FF_V_MF4_TU, VLSEG7E16FF_V }, // 5276
  { PseudoVLSEG7E16_V_M1, VLSEG7E16_V }, // 5277
  { PseudoVLSEG7E16_V_M1_MASK, VLSEG7E16_V }, // 5278
  { PseudoVLSEG7E16_V_M1_TU, VLSEG7E16_V }, // 5279
  { PseudoVLSEG7E16_V_MF2, VLSEG7E16_V }, // 5280
  { PseudoVLSEG7E16_V_MF2_MASK, VLSEG7E16_V }, // 5281
  { PseudoVLSEG7E16_V_MF2_TU, VLSEG7E16_V }, // 5282
  { PseudoVLSEG7E16_V_MF4, VLSEG7E16_V }, // 5283
  { PseudoVLSEG7E16_V_MF4_MASK, VLSEG7E16_V }, // 5284
  { PseudoVLSEG7E16_V_MF4_TU, VLSEG7E16_V }, // 5285
  { PseudoVLSEG7E32FF_V_M1, VLSEG7E32FF_V }, // 5286
  { PseudoVLSEG7E32FF_V_M1_MASK, VLSEG7E32FF_V }, // 5287
  { PseudoVLSEG7E32FF_V_M1_TU, VLSEG7E32FF_V }, // 5288
  { PseudoVLSEG7E32FF_V_MF2, VLSEG7E32FF_V }, // 5289
  { PseudoVLSEG7E32FF_V_MF2_MASK, VLSEG7E32FF_V }, // 5290
  { PseudoVLSEG7E32FF_V_MF2_TU, VLSEG7E32FF_V }, // 5291
  { PseudoVLSEG7E32_V_M1, VLSEG7E32_V }, // 5292
  { PseudoVLSEG7E32_V_M1_MASK, VLSEG7E32_V }, // 5293
  { PseudoVLSEG7E32_V_M1_TU, VLSEG7E32_V }, // 5294
  { PseudoVLSEG7E32_V_MF2, VLSEG7E32_V }, // 5295
  { PseudoVLSEG7E32_V_MF2_MASK, VLSEG7E32_V }, // 5296
  { PseudoVLSEG7E32_V_MF2_TU, VLSEG7E32_V }, // 5297
  { PseudoVLSEG7E64FF_V_M1, VLSEG7E64FF_V }, // 5298
  { PseudoVLSEG7E64FF_V_M1_MASK, VLSEG7E64FF_V }, // 5299
  { PseudoVLSEG7E64FF_V_M1_TU, VLSEG7E64FF_V }, // 5300
  { PseudoVLSEG7E64_V_M1, VLSEG7E64_V }, // 5301
  { PseudoVLSEG7E64_V_M1_MASK, VLSEG7E64_V }, // 5302
  { PseudoVLSEG7E64_V_M1_TU, VLSEG7E64_V }, // 5303
  { PseudoVLSEG7E8FF_V_M1, VLSEG7E8FF_V }, // 5304
  { PseudoVLSEG7E8FF_V_M1_MASK, VLSEG7E8FF_V }, // 5305
  { PseudoVLSEG7E8FF_V_M1_TU, VLSEG7E8FF_V }, // 5306
  { PseudoVLSEG7E8FF_V_MF2, VLSEG7E8FF_V }, // 5307
  { PseudoVLSEG7E8FF_V_MF2_MASK, VLSEG7E8FF_V }, // 5308
  { PseudoVLSEG7E8FF_V_MF2_TU, VLSEG7E8FF_V }, // 5309
  { PseudoVLSEG7E8FF_V_MF4, VLSEG7E8FF_V }, // 5310
  { PseudoVLSEG7E8FF_V_MF4_MASK, VLSEG7E8FF_V }, // 5311
  { PseudoVLSEG7E8FF_V_MF4_TU, VLSEG7E8FF_V }, // 5312
  { PseudoVLSEG7E8FF_V_MF8, VLSEG7E8FF_V }, // 5313
  { PseudoVLSEG7E8FF_V_MF8_MASK, VLSEG7E8FF_V }, // 5314
  { PseudoVLSEG7E8FF_V_MF8_TU, VLSEG7E8FF_V }, // 5315
  { PseudoVLSEG7E8_V_M1, VLSEG7E8_V }, // 5316
  { PseudoVLSEG7E8_V_M1_MASK, VLSEG7E8_V }, // 5317
  { PseudoVLSEG7E8_V_M1_TU, VLSEG7E8_V }, // 5318
  { PseudoVLSEG7E8_V_MF2, VLSEG7E8_V }, // 5319
  { PseudoVLSEG7E8_V_MF2_MASK, VLSEG7E8_V }, // 5320
  { PseudoVLSEG7E8_V_MF2_TU, VLSEG7E8_V }, // 5321
  { PseudoVLSEG7E8_V_MF4, VLSEG7E8_V }, // 5322
  { PseudoVLSEG7E8_V_MF4_MASK, VLSEG7E8_V }, // 5323
  { PseudoVLSEG7E8_V_MF4_TU, VLSEG7E8_V }, // 5324
  { PseudoVLSEG7E8_V_MF8, VLSEG7E8_V }, // 5325
  { PseudoVLSEG7E8_V_MF8_MASK, VLSEG7E8_V }, // 5326
  { PseudoVLSEG7E8_V_MF8_TU, VLSEG7E8_V }, // 5327
  { PseudoVLSEG8E16FF_V_M1, VLSEG8E16FF_V }, // 5328
  { PseudoVLSEG8E16FF_V_M1_MASK, VLSEG8E16FF_V }, // 5329
  { PseudoVLSEG8E16FF_V_M1_TU, VLSEG8E16FF_V }, // 5330
  { PseudoVLSEG8E16FF_V_MF2, VLSEG8E16FF_V }, // 5331
  { PseudoVLSEG8E16FF_V_MF2_MASK, VLSEG8E16FF_V }, // 5332
  { PseudoVLSEG8E16FF_V_MF2_TU, VLSEG8E16FF_V }, // 5333
  { PseudoVLSEG8E16FF_V_MF4, VLSEG8E16FF_V }, // 5334
  { PseudoVLSEG8E16FF_V_MF4_MASK, VLSEG8E16FF_V }, // 5335
  { PseudoVLSEG8E16FF_V_MF4_TU, VLSEG8E16FF_V }, // 5336
  { PseudoVLSEG8E16_V_M1, VLSEG8E16_V }, // 5337
  { PseudoVLSEG8E16_V_M1_MASK, VLSEG8E16_V }, // 5338
  { PseudoVLSEG8E16_V_M1_TU, VLSEG8E16_V }, // 5339
  { PseudoVLSEG8E16_V_MF2, VLSEG8E16_V }, // 5340
  { PseudoVLSEG8E16_V_MF2_MASK, VLSEG8E16_V }, // 5341
  { PseudoVLSEG8E16_V_MF2_TU, VLSEG8E16_V }, // 5342
  { PseudoVLSEG8E16_V_MF4, VLSEG8E16_V }, // 5343
  { PseudoVLSEG8E16_V_MF4_MASK, VLSEG8E16_V }, // 5344
  { PseudoVLSEG8E16_V_MF4_TU, VLSEG8E16_V }, // 5345
  { PseudoVLSEG8E32FF_V_M1, VLSEG8E32FF_V }, // 5346
  { PseudoVLSEG8E32FF_V_M1_MASK, VLSEG8E32FF_V }, // 5347
  { PseudoVLSEG8E32FF_V_M1_TU, VLSEG8E32FF_V }, // 5348
  { PseudoVLSEG8E32FF_V_MF2, VLSEG8E32FF_V }, // 5349
  { PseudoVLSEG8E32FF_V_MF2_MASK, VLSEG8E32FF_V }, // 5350
  { PseudoVLSEG8E32FF_V_MF2_TU, VLSEG8E32FF_V }, // 5351
  { PseudoVLSEG8E32_V_M1, VLSEG8E32_V }, // 5352
  { PseudoVLSEG8E32_V_M1_MASK, VLSEG8E32_V }, // 5353
  { PseudoVLSEG8E32_V_M1_TU, VLSEG8E32_V }, // 5354
  { PseudoVLSEG8E32_V_MF2, VLSEG8E32_V }, // 5355
  { PseudoVLSEG8E32_V_MF2_MASK, VLSEG8E32_V }, // 5356
  { PseudoVLSEG8E32_V_MF2_TU, VLSEG8E32_V }, // 5357
  { PseudoVLSEG8E64FF_V_M1, VLSEG8E64FF_V }, // 5358
  { PseudoVLSEG8E64FF_V_M1_MASK, VLSEG8E64FF_V }, // 5359
  { PseudoVLSEG8E64FF_V_M1_TU, VLSEG8E64FF_V }, // 5360
  { PseudoVLSEG8E64_V_M1, VLSEG8E64_V }, // 5361
  { PseudoVLSEG8E64_V_M1_MASK, VLSEG8E64_V }, // 5362
  { PseudoVLSEG8E64_V_M1_TU, VLSEG8E64_V }, // 5363
  { PseudoVLSEG8E8FF_V_M1, VLSEG8E8FF_V }, // 5364
  { PseudoVLSEG8E8FF_V_M1_MASK, VLSEG8E8FF_V }, // 5365
  { PseudoVLSEG8E8FF_V_M1_TU, VLSEG8E8FF_V }, // 5366
  { PseudoVLSEG8E8FF_V_MF2, VLSEG8E8FF_V }, // 5367
  { PseudoVLSEG8E8FF_V_MF2_MASK, VLSEG8E8FF_V }, // 5368
  { PseudoVLSEG8E8FF_V_MF2_TU, VLSEG8E8FF_V }, // 5369
  { PseudoVLSEG8E8FF_V_MF4, VLSEG8E8FF_V }, // 5370
  { PseudoVLSEG8E8FF_V_MF4_MASK, VLSEG8E8FF_V }, // 5371
  { PseudoVLSEG8E8FF_V_MF4_TU, VLSEG8E8FF_V }, // 5372
  { PseudoVLSEG8E8FF_V_MF8, VLSEG8E8FF_V }, // 5373
  { PseudoVLSEG8E8FF_V_MF8_MASK, VLSEG8E8FF_V }, // 5374
  { PseudoVLSEG8E8FF_V_MF8_TU, VLSEG8E8FF_V }, // 5375
  { PseudoVLSEG8E8_V_M1, VLSEG8E8_V }, // 5376
  { PseudoVLSEG8E8_V_M1_MASK, VLSEG8E8_V }, // 5377
  { PseudoVLSEG8E8_V_M1_TU, VLSEG8E8_V }, // 5378
  { PseudoVLSEG8E8_V_MF2, VLSEG8E8_V }, // 5379
  { PseudoVLSEG8E8_V_MF2_MASK, VLSEG8E8_V }, // 5380
  { PseudoVLSEG8E8_V_MF2_TU, VLSEG8E8_V }, // 5381
  { PseudoVLSEG8E8_V_MF4, VLSEG8E8_V }, // 5382
  { PseudoVLSEG8E8_V_MF4_MASK, VLSEG8E8_V }, // 5383
  { PseudoVLSEG8E8_V_MF4_TU, VLSEG8E8_V }, // 5384
  { PseudoVLSEG8E8_V_MF8, VLSEG8E8_V }, // 5385
  { PseudoVLSEG8E8_V_MF8_MASK, VLSEG8E8_V }, // 5386
  { PseudoVLSEG8E8_V_MF8_TU, VLSEG8E8_V }, // 5387
  { PseudoVLSSEG2E16_V_M1, VLSSEG2E16_V }, // 5388
  { PseudoVLSSEG2E16_V_M1_MASK, VLSSEG2E16_V }, // 5389
  { PseudoVLSSEG2E16_V_M1_TU, VLSSEG2E16_V }, // 5390
  { PseudoVLSSEG2E16_V_M2, VLSSEG2E16_V }, // 5391
  { PseudoVLSSEG2E16_V_M2_MASK, VLSSEG2E16_V }, // 5392
  { PseudoVLSSEG2E16_V_M2_TU, VLSSEG2E16_V }, // 5393
  { PseudoVLSSEG2E16_V_M4, VLSSEG2E16_V }, // 5394
  { PseudoVLSSEG2E16_V_M4_MASK, VLSSEG2E16_V }, // 5395
  { PseudoVLSSEG2E16_V_M4_TU, VLSSEG2E16_V }, // 5396
  { PseudoVLSSEG2E16_V_MF2, VLSSEG2E16_V }, // 5397
  { PseudoVLSSEG2E16_V_MF2_MASK, VLSSEG2E16_V }, // 5398
  { PseudoVLSSEG2E16_V_MF2_TU, VLSSEG2E16_V }, // 5399
  { PseudoVLSSEG2E16_V_MF4, VLSSEG2E16_V }, // 5400
  { PseudoVLSSEG2E16_V_MF4_MASK, VLSSEG2E16_V }, // 5401
  { PseudoVLSSEG2E16_V_MF4_TU, VLSSEG2E16_V }, // 5402
  { PseudoVLSSEG2E32_V_M1, VLSSEG2E32_V }, // 5403
  { PseudoVLSSEG2E32_V_M1_MASK, VLSSEG2E32_V }, // 5404
  { PseudoVLSSEG2E32_V_M1_TU, VLSSEG2E32_V }, // 5405
  { PseudoVLSSEG2E32_V_M2, VLSSEG2E32_V }, // 5406
  { PseudoVLSSEG2E32_V_M2_MASK, VLSSEG2E32_V }, // 5407
  { PseudoVLSSEG2E32_V_M2_TU, VLSSEG2E32_V }, // 5408
  { PseudoVLSSEG2E32_V_M4, VLSSEG2E32_V }, // 5409
  { PseudoVLSSEG2E32_V_M4_MASK, VLSSEG2E32_V }, // 5410
  { PseudoVLSSEG2E32_V_M4_TU, VLSSEG2E32_V }, // 5411
  { PseudoVLSSEG2E32_V_MF2, VLSSEG2E32_V }, // 5412
  { PseudoVLSSEG2E32_V_MF2_MASK, VLSSEG2E32_V }, // 5413
  { PseudoVLSSEG2E32_V_MF2_TU, VLSSEG2E32_V }, // 5414
  { PseudoVLSSEG2E64_V_M1, VLSSEG2E64_V }, // 5415
  { PseudoVLSSEG2E64_V_M1_MASK, VLSSEG2E64_V }, // 5416
  { PseudoVLSSEG2E64_V_M1_TU, VLSSEG2E64_V }, // 5417
  { PseudoVLSSEG2E64_V_M2, VLSSEG2E64_V }, // 5418
  { PseudoVLSSEG2E64_V_M2_MASK, VLSSEG2E64_V }, // 5419
  { PseudoVLSSEG2E64_V_M2_TU, VLSSEG2E64_V }, // 5420
  { PseudoVLSSEG2E64_V_M4, VLSSEG2E64_V }, // 5421
  { PseudoVLSSEG2E64_V_M4_MASK, VLSSEG2E64_V }, // 5422
  { PseudoVLSSEG2E64_V_M4_TU, VLSSEG2E64_V }, // 5423
  { PseudoVLSSEG2E8_V_M1, VLSSEG2E8_V }, // 5424
  { PseudoVLSSEG2E8_V_M1_MASK, VLSSEG2E8_V }, // 5425
  { PseudoVLSSEG2E8_V_M1_TU, VLSSEG2E8_V }, // 5426
  { PseudoVLSSEG2E8_V_M2, VLSSEG2E8_V }, // 5427
  { PseudoVLSSEG2E8_V_M2_MASK, VLSSEG2E8_V }, // 5428
  { PseudoVLSSEG2E8_V_M2_TU, VLSSEG2E8_V }, // 5429
  { PseudoVLSSEG2E8_V_M4, VLSSEG2E8_V }, // 5430
  { PseudoVLSSEG2E8_V_M4_MASK, VLSSEG2E8_V }, // 5431
  { PseudoVLSSEG2E8_V_M4_TU, VLSSEG2E8_V }, // 5432
  { PseudoVLSSEG2E8_V_MF2, VLSSEG2E8_V }, // 5433
  { PseudoVLSSEG2E8_V_MF2_MASK, VLSSEG2E8_V }, // 5434
  { PseudoVLSSEG2E8_V_MF2_TU, VLSSEG2E8_V }, // 5435
  { PseudoVLSSEG2E8_V_MF4, VLSSEG2E8_V }, // 5436
  { PseudoVLSSEG2E8_V_MF4_MASK, VLSSEG2E8_V }, // 5437
  { PseudoVLSSEG2E8_V_MF4_TU, VLSSEG2E8_V }, // 5438
  { PseudoVLSSEG2E8_V_MF8, VLSSEG2E8_V }, // 5439
  { PseudoVLSSEG2E8_V_MF8_MASK, VLSSEG2E8_V }, // 5440
  { PseudoVLSSEG2E8_V_MF8_TU, VLSSEG2E8_V }, // 5441
  { PseudoVLSSEG3E16_V_M1, VLSSEG3E16_V }, // 5442
  { PseudoVLSSEG3E16_V_M1_MASK, VLSSEG3E16_V }, // 5443
  { PseudoVLSSEG3E16_V_M1_TU, VLSSEG3E16_V }, // 5444
  { PseudoVLSSEG3E16_V_M2, VLSSEG3E16_V }, // 5445
  { PseudoVLSSEG3E16_V_M2_MASK, VLSSEG3E16_V }, // 5446
  { PseudoVLSSEG3E16_V_M2_TU, VLSSEG3E16_V }, // 5447
  { PseudoVLSSEG3E16_V_MF2, VLSSEG3E16_V }, // 5448
  { PseudoVLSSEG3E16_V_MF2_MASK, VLSSEG3E16_V }, // 5449
  { PseudoVLSSEG3E16_V_MF2_TU, VLSSEG3E16_V }, // 5450
  { PseudoVLSSEG3E16_V_MF4, VLSSEG3E16_V }, // 5451
  { PseudoVLSSEG3E16_V_MF4_MASK, VLSSEG3E16_V }, // 5452
  { PseudoVLSSEG3E16_V_MF4_TU, VLSSEG3E16_V }, // 5453
  { PseudoVLSSEG3E32_V_M1, VLSSEG3E32_V }, // 5454
  { PseudoVLSSEG3E32_V_M1_MASK, VLSSEG3E32_V }, // 5455
  { PseudoVLSSEG3E32_V_M1_TU, VLSSEG3E32_V }, // 5456
  { PseudoVLSSEG3E32_V_M2, VLSSEG3E32_V }, // 5457
  { PseudoVLSSEG3E32_V_M2_MASK, VLSSEG3E32_V }, // 5458
  { PseudoVLSSEG3E32_V_M2_TU, VLSSEG3E32_V }, // 5459
  { PseudoVLSSEG3E32_V_MF2, VLSSEG3E32_V }, // 5460
  { PseudoVLSSEG3E32_V_MF2_MASK, VLSSEG3E32_V }, // 5461
  { PseudoVLSSEG3E32_V_MF2_TU, VLSSEG3E32_V }, // 5462
  { PseudoVLSSEG3E64_V_M1, VLSSEG3E64_V }, // 5463
  { PseudoVLSSEG3E64_V_M1_MASK, VLSSEG3E64_V }, // 5464
  { PseudoVLSSEG3E64_V_M1_TU, VLSSEG3E64_V }, // 5465
  { PseudoVLSSEG3E64_V_M2, VLSSEG3E64_V }, // 5466
  { PseudoVLSSEG3E64_V_M2_MASK, VLSSEG3E64_V }, // 5467
  { PseudoVLSSEG3E64_V_M2_TU, VLSSEG3E64_V }, // 5468
  { PseudoVLSSEG3E8_V_M1, VLSSEG3E8_V }, // 5469
  { PseudoVLSSEG3E8_V_M1_MASK, VLSSEG3E8_V }, // 5470
  { PseudoVLSSEG3E8_V_M1_TU, VLSSEG3E8_V }, // 5471
  { PseudoVLSSEG3E8_V_M2, VLSSEG3E8_V }, // 5472
  { PseudoVLSSEG3E8_V_M2_MASK, VLSSEG3E8_V }, // 5473
  { PseudoVLSSEG3E8_V_M2_TU, VLSSEG3E8_V }, // 5474
  { PseudoVLSSEG3E8_V_MF2, VLSSEG3E8_V }, // 5475
  { PseudoVLSSEG3E8_V_MF2_MASK, VLSSEG3E8_V }, // 5476
  { PseudoVLSSEG3E8_V_MF2_TU, VLSSEG3E8_V }, // 5477
  { PseudoVLSSEG3E8_V_MF4, VLSSEG3E8_V }, // 5478
  { PseudoVLSSEG3E8_V_MF4_MASK, VLSSEG3E8_V }, // 5479
  { PseudoVLSSEG3E8_V_MF4_TU, VLSSEG3E8_V }, // 5480
  { PseudoVLSSEG3E8_V_MF8, VLSSEG3E8_V }, // 5481
  { PseudoVLSSEG3E8_V_MF8_MASK, VLSSEG3E8_V }, // 5482
  { PseudoVLSSEG3E8_V_MF8_TU, VLSSEG3E8_V }, // 5483
  { PseudoVLSSEG4E16_V_M1, VLSSEG4E16_V }, // 5484
  { PseudoVLSSEG4E16_V_M1_MASK, VLSSEG4E16_V }, // 5485
  { PseudoVLSSEG4E16_V_M1_TU, VLSSEG4E16_V }, // 5486
  { PseudoVLSSEG4E16_V_M2, VLSSEG4E16_V }, // 5487
  { PseudoVLSSEG4E16_V_M2_MASK, VLSSEG4E16_V }, // 5488
  { PseudoVLSSEG4E16_V_M2_TU, VLSSEG4E16_V }, // 5489
  { PseudoVLSSEG4E16_V_MF2, VLSSEG4E16_V }, // 5490
  { PseudoVLSSEG4E16_V_MF2_MASK, VLSSEG4E16_V }, // 5491
  { PseudoVLSSEG4E16_V_MF2_TU, VLSSEG4E16_V }, // 5492
  { PseudoVLSSEG4E16_V_MF4, VLSSEG4E16_V }, // 5493
  { PseudoVLSSEG4E16_V_MF4_MASK, VLSSEG4E16_V }, // 5494
  { PseudoVLSSEG4E16_V_MF4_TU, VLSSEG4E16_V }, // 5495
  { PseudoVLSSEG4E32_V_M1, VLSSEG4E32_V }, // 5496
  { PseudoVLSSEG4E32_V_M1_MASK, VLSSEG4E32_V }, // 5497
  { PseudoVLSSEG4E32_V_M1_TU, VLSSEG4E32_V }, // 5498
  { PseudoVLSSEG4E32_V_M2, VLSSEG4E32_V }, // 5499
  { PseudoVLSSEG4E32_V_M2_MASK, VLSSEG4E32_V }, // 5500
  { PseudoVLSSEG4E32_V_M2_TU, VLSSEG4E32_V }, // 5501
  { PseudoVLSSEG4E32_V_MF2, VLSSEG4E32_V }, // 5502
  { PseudoVLSSEG4E32_V_MF2_MASK, VLSSEG4E32_V }, // 5503
  { PseudoVLSSEG4E32_V_MF2_TU, VLSSEG4E32_V }, // 5504
  { PseudoVLSSEG4E64_V_M1, VLSSEG4E64_V }, // 5505
  { PseudoVLSSEG4E64_V_M1_MASK, VLSSEG4E64_V }, // 5506
  { PseudoVLSSEG4E64_V_M1_TU, VLSSEG4E64_V }, // 5507
  { PseudoVLSSEG4E64_V_M2, VLSSEG4E64_V }, // 5508
  { PseudoVLSSEG4E64_V_M2_MASK, VLSSEG4E64_V }, // 5509
  { PseudoVLSSEG4E64_V_M2_TU, VLSSEG4E64_V }, // 5510
  { PseudoVLSSEG4E8_V_M1, VLSSEG4E8_V }, // 5511
  { PseudoVLSSEG4E8_V_M1_MASK, VLSSEG4E8_V }, // 5512
  { PseudoVLSSEG4E8_V_M1_TU, VLSSEG4E8_V }, // 5513
  { PseudoVLSSEG4E8_V_M2, VLSSEG4E8_V }, // 5514
  { PseudoVLSSEG4E8_V_M2_MASK, VLSSEG4E8_V }, // 5515
  { PseudoVLSSEG4E8_V_M2_TU, VLSSEG4E8_V }, // 5516
  { PseudoVLSSEG4E8_V_MF2, VLSSEG4E8_V }, // 5517
  { PseudoVLSSEG4E8_V_MF2_MASK, VLSSEG4E8_V }, // 5518
  { PseudoVLSSEG4E8_V_MF2_TU, VLSSEG4E8_V }, // 5519
  { PseudoVLSSEG4E8_V_MF4, VLSSEG4E8_V }, // 5520
  { PseudoVLSSEG4E8_V_MF4_MASK, VLSSEG4E8_V }, // 5521
  { PseudoVLSSEG4E8_V_MF4_TU, VLSSEG4E8_V }, // 5522
  { PseudoVLSSEG4E8_V_MF8, VLSSEG4E8_V }, // 5523
  { PseudoVLSSEG4E8_V_MF8_MASK, VLSSEG4E8_V }, // 5524
  { PseudoVLSSEG4E8_V_MF8_TU, VLSSEG4E8_V }, // 5525
  { PseudoVLSSEG5E16_V_M1, VLSSEG5E16_V }, // 5526
  { PseudoVLSSEG5E16_V_M1_MASK, VLSSEG5E16_V }, // 5527
  { PseudoVLSSEG5E16_V_M1_TU, VLSSEG5E16_V }, // 5528
  { PseudoVLSSEG5E16_V_MF2, VLSSEG5E16_V }, // 5529
  { PseudoVLSSEG5E16_V_MF2_MASK, VLSSEG5E16_V }, // 5530
  { PseudoVLSSEG5E16_V_MF2_TU, VLSSEG5E16_V }, // 5531
  { PseudoVLSSEG5E16_V_MF4, VLSSEG5E16_V }, // 5532
  { PseudoVLSSEG5E16_V_MF4_MASK, VLSSEG5E16_V }, // 5533
  { PseudoVLSSEG5E16_V_MF4_TU, VLSSEG5E16_V }, // 5534
  { PseudoVLSSEG5E32_V_M1, VLSSEG5E32_V }, // 5535
  { PseudoVLSSEG5E32_V_M1_MASK, VLSSEG5E32_V }, // 5536
  { PseudoVLSSEG5E32_V_M1_TU, VLSSEG5E32_V }, // 5537
  { PseudoVLSSEG5E32_V_MF2, VLSSEG5E32_V }, // 5538
  { PseudoVLSSEG5E32_V_MF2_MASK, VLSSEG5E32_V }, // 5539
  { PseudoVLSSEG5E32_V_MF2_TU, VLSSEG5E32_V }, // 5540
  { PseudoVLSSEG5E64_V_M1, VLSSEG5E64_V }, // 5541
  { PseudoVLSSEG5E64_V_M1_MASK, VLSSEG5E64_V }, // 5542
  { PseudoVLSSEG5E64_V_M1_TU, VLSSEG5E64_V }, // 5543
  { PseudoVLSSEG5E8_V_M1, VLSSEG5E8_V }, // 5544
  { PseudoVLSSEG5E8_V_M1_MASK, VLSSEG5E8_V }, // 5545
  { PseudoVLSSEG5E8_V_M1_TU, VLSSEG5E8_V }, // 5546
  { PseudoVLSSEG5E8_V_MF2, VLSSEG5E8_V }, // 5547
  { PseudoVLSSEG5E8_V_MF2_MASK, VLSSEG5E8_V }, // 5548
  { PseudoVLSSEG5E8_V_MF2_TU, VLSSEG5E8_V }, // 5549
  { PseudoVLSSEG5E8_V_MF4, VLSSEG5E8_V }, // 5550
  { PseudoVLSSEG5E8_V_MF4_MASK, VLSSEG5E8_V }, // 5551
  { PseudoVLSSEG5E8_V_MF4_TU, VLSSEG5E8_V }, // 5552
  { PseudoVLSSEG5E8_V_MF8, VLSSEG5E8_V }, // 5553
  { PseudoVLSSEG5E8_V_MF8_MASK, VLSSEG5E8_V }, // 5554
  { PseudoVLSSEG5E8_V_MF8_TU, VLSSEG5E8_V }, // 5555
  { PseudoVLSSEG6E16_V_M1, VLSSEG6E16_V }, // 5556
  { PseudoVLSSEG6E16_V_M1_MASK, VLSSEG6E16_V }, // 5557
  { PseudoVLSSEG6E16_V_M1_TU, VLSSEG6E16_V }, // 5558
  { PseudoVLSSEG6E16_V_MF2, VLSSEG6E16_V }, // 5559
  { PseudoVLSSEG6E16_V_MF2_MASK, VLSSEG6E16_V }, // 5560
  { PseudoVLSSEG6E16_V_MF2_TU, VLSSEG6E16_V }, // 5561
  { PseudoVLSSEG6E16_V_MF4, VLSSEG6E16_V }, // 5562
  { PseudoVLSSEG6E16_V_MF4_MASK, VLSSEG6E16_V }, // 5563
  { PseudoVLSSEG6E16_V_MF4_TU, VLSSEG6E16_V }, // 5564
  { PseudoVLSSEG6E32_V_M1, VLSSEG6E32_V }, // 5565
  { PseudoVLSSEG6E32_V_M1_MASK, VLSSEG6E32_V }, // 5566
  { PseudoVLSSEG6E32_V_M1_TU, VLSSEG6E32_V }, // 5567
  { PseudoVLSSEG6E32_V_MF2, VLSSEG6E32_V }, // 5568
  { PseudoVLSSEG6E32_V_MF2_MASK, VLSSEG6E32_V }, // 5569
  { PseudoVLSSEG6E32_V_MF2_TU, VLSSEG6E32_V }, // 5570
  { PseudoVLSSEG6E64_V_M1, VLSSEG6E64_V }, // 5571
  { PseudoVLSSEG6E64_V_M1_MASK, VLSSEG6E64_V }, // 5572
  { PseudoVLSSEG6E64_V_M1_TU, VLSSEG6E64_V }, // 5573
  { PseudoVLSSEG6E8_V_M1, VLSSEG6E8_V }, // 5574
  { PseudoVLSSEG6E8_V_M1_MASK, VLSSEG6E8_V }, // 5575
  { PseudoVLSSEG6E8_V_M1_TU, VLSSEG6E8_V }, // 5576
  { PseudoVLSSEG6E8_V_MF2, VLSSEG6E8_V }, // 5577
  { PseudoVLSSEG6E8_V_MF2_MASK, VLSSEG6E8_V }, // 5578
  { PseudoVLSSEG6E8_V_MF2_TU, VLSSEG6E8_V }, // 5579
  { PseudoVLSSEG6E8_V_MF4, VLSSEG6E8_V }, // 5580
  { PseudoVLSSEG6E8_V_MF4_MASK, VLSSEG6E8_V }, // 5581
  { PseudoVLSSEG6E8_V_MF4_TU, VLSSEG6E8_V }, // 5582
  { PseudoVLSSEG6E8_V_MF8, VLSSEG6E8_V }, // 5583
  { PseudoVLSSEG6E8_V_MF8_MASK, VLSSEG6E8_V }, // 5584
  { PseudoVLSSEG6E8_V_MF8_TU, VLSSEG6E8_V }, // 5585
  { PseudoVLSSEG7E16_V_M1, VLSSEG7E16_V }, // 5586
  { PseudoVLSSEG7E16_V_M1_MASK, VLSSEG7E16_V }, // 5587
  { PseudoVLSSEG7E16_V_M1_TU, VLSSEG7E16_V }, // 5588
  { PseudoVLSSEG7E16_V_MF2, VLSSEG7E16_V }, // 5589
  { PseudoVLSSEG7E16_V_MF2_MASK, VLSSEG7E16_V }, // 5590
  { PseudoVLSSEG7E16_V_MF2_TU, VLSSEG7E16_V }, // 5591
  { PseudoVLSSEG7E16_V_MF4, VLSSEG7E16_V }, // 5592
  { PseudoVLSSEG7E16_V_MF4_MASK, VLSSEG7E16_V }, // 5593
  { PseudoVLSSEG7E16_V_MF4_TU, VLSSEG7E16_V }, // 5594
  { PseudoVLSSEG7E32_V_M1, VLSSEG7E32_V }, // 5595
  { PseudoVLSSEG7E32_V_M1_MASK, VLSSEG7E32_V }, // 5596
  { PseudoVLSSEG7E32_V_M1_TU, VLSSEG7E32_V }, // 5597
  { PseudoVLSSEG7E32_V_MF2, VLSSEG7E32_V }, // 5598
  { PseudoVLSSEG7E32_V_MF2_MASK, VLSSEG7E32_V }, // 5599
  { PseudoVLSSEG7E32_V_MF2_TU, VLSSEG7E32_V }, // 5600
  { PseudoVLSSEG7E64_V_M1, VLSSEG7E64_V }, // 5601
  { PseudoVLSSEG7E64_V_M1_MASK, VLSSEG7E64_V }, // 5602
  { PseudoVLSSEG7E64_V_M1_TU, VLSSEG7E64_V }, // 5603
  { PseudoVLSSEG7E8_V_M1, VLSSEG7E8_V }, // 5604
  { PseudoVLSSEG7E8_V_M1_MASK, VLSSEG7E8_V }, // 5605
  { PseudoVLSSEG7E8_V_M1_TU, VLSSEG7E8_V }, // 5606
  { PseudoVLSSEG7E8_V_MF2, VLSSEG7E8_V }, // 5607
  { PseudoVLSSEG7E8_V_MF2_MASK, VLSSEG7E8_V }, // 5608
  { PseudoVLSSEG7E8_V_MF2_TU, VLSSEG7E8_V }, // 5609
  { PseudoVLSSEG7E8_V_MF4, VLSSEG7E8_V }, // 5610
  { PseudoVLSSEG7E8_V_MF4_MASK, VLSSEG7E8_V }, // 5611
  { PseudoVLSSEG7E8_V_MF4_TU, VLSSEG7E8_V }, // 5612
  { PseudoVLSSEG7E8_V_MF8, VLSSEG7E8_V }, // 5613
  { PseudoVLSSEG7E8_V_MF8_MASK, VLSSEG7E8_V }, // 5614
  { PseudoVLSSEG7E8_V_MF8_TU, VLSSEG7E8_V }, // 5615
  { PseudoVLSSEG8E16_V_M1, VLSSEG8E16_V }, // 5616
  { PseudoVLSSEG8E16_V_M1_MASK, VLSSEG8E16_V }, // 5617
  { PseudoVLSSEG8E16_V_M1_TU, VLSSEG8E16_V }, // 5618
  { PseudoVLSSEG8E16_V_MF2, VLSSEG8E16_V }, // 5619
  { PseudoVLSSEG8E16_V_MF2_MASK, VLSSEG8E16_V }, // 5620
  { PseudoVLSSEG8E16_V_MF2_TU, VLSSEG8E16_V }, // 5621
  { PseudoVLSSEG8E16_V_MF4, VLSSEG8E16_V }, // 5622
  { PseudoVLSSEG8E16_V_MF4_MASK, VLSSEG8E16_V }, // 5623
  { PseudoVLSSEG8E16_V_MF4_TU, VLSSEG8E16_V }, // 5624
  { PseudoVLSSEG8E32_V_M1, VLSSEG8E32_V }, // 5625
  { PseudoVLSSEG8E32_V_M1_MASK, VLSSEG8E32_V }, // 5626
  { PseudoVLSSEG8E32_V_M1_TU, VLSSEG8E32_V }, // 5627
  { PseudoVLSSEG8E32_V_MF2, VLSSEG8E32_V }, // 5628
  { PseudoVLSSEG8E32_V_MF2_MASK, VLSSEG8E32_V }, // 5629
  { PseudoVLSSEG8E32_V_MF2_TU, VLSSEG8E32_V }, // 5630
  { PseudoVLSSEG8E64_V_M1, VLSSEG8E64_V }, // 5631
  { PseudoVLSSEG8E64_V_M1_MASK, VLSSEG8E64_V }, // 5632
  { PseudoVLSSEG8E64_V_M1_TU, VLSSEG8E64_V }, // 5633
  { PseudoVLSSEG8E8_V_M1, VLSSEG8E8_V }, // 5634
  { PseudoVLSSEG8E8_V_M1_MASK, VLSSEG8E8_V }, // 5635
  { PseudoVLSSEG8E8_V_M1_TU, VLSSEG8E8_V }, // 5636
  { PseudoVLSSEG8E8_V_MF2, VLSSEG8E8_V }, // 5637
  { PseudoVLSSEG8E8_V_MF2_MASK, VLSSEG8E8_V }, // 5638
  { PseudoVLSSEG8E8_V_MF2_TU, VLSSEG8E8_V }, // 5639
  { PseudoVLSSEG8E8_V_MF4, VLSSEG8E8_V }, // 5640
  { PseudoVLSSEG8E8_V_MF4_MASK, VLSSEG8E8_V }, // 5641
  { PseudoVLSSEG8E8_V_MF4_TU, VLSSEG8E8_V }, // 5642
  { PseudoVLSSEG8E8_V_MF8, VLSSEG8E8_V }, // 5643
  { PseudoVLSSEG8E8_V_MF8_MASK, VLSSEG8E8_V }, // 5644
  { PseudoVLSSEG8E8_V_MF8_TU, VLSSEG8E8_V }, // 5645
  { PseudoVLUXEI16_V_M1_M1, VLUXEI16_V }, // 5646
  { PseudoVLUXEI16_V_M1_M1_MASK, VLUXEI16_V }, // 5647
  { PseudoVLUXEI16_V_M1_M1_TU, VLUXEI16_V }, // 5648
  { PseudoVLUXEI16_V_M1_M2, VLUXEI16_V }, // 5649
  { PseudoVLUXEI16_V_M1_M2_MASK, VLUXEI16_V }, // 5650
  { PseudoVLUXEI16_V_M1_M2_TU, VLUXEI16_V }, // 5651
  { PseudoVLUXEI16_V_M1_M4, VLUXEI16_V }, // 5652
  { PseudoVLUXEI16_V_M1_M4_MASK, VLUXEI16_V }, // 5653
  { PseudoVLUXEI16_V_M1_M4_TU, VLUXEI16_V }, // 5654
  { PseudoVLUXEI16_V_M1_MF2, VLUXEI16_V }, // 5655
  { PseudoVLUXEI16_V_M1_MF2_MASK, VLUXEI16_V }, // 5656
  { PseudoVLUXEI16_V_M1_MF2_TU, VLUXEI16_V }, // 5657
  { PseudoVLUXEI16_V_M2_M1, VLUXEI16_V }, // 5658
  { PseudoVLUXEI16_V_M2_M1_MASK, VLUXEI16_V }, // 5659
  { PseudoVLUXEI16_V_M2_M1_TU, VLUXEI16_V }, // 5660
  { PseudoVLUXEI16_V_M2_M2, VLUXEI16_V }, // 5661
  { PseudoVLUXEI16_V_M2_M2_MASK, VLUXEI16_V }, // 5662
  { PseudoVLUXEI16_V_M2_M2_TU, VLUXEI16_V }, // 5663
  { PseudoVLUXEI16_V_M2_M4, VLUXEI16_V }, // 5664
  { PseudoVLUXEI16_V_M2_M4_MASK, VLUXEI16_V }, // 5665
  { PseudoVLUXEI16_V_M2_M4_TU, VLUXEI16_V }, // 5666
  { PseudoVLUXEI16_V_M2_M8, VLUXEI16_V }, // 5667
  { PseudoVLUXEI16_V_M2_M8_MASK, VLUXEI16_V }, // 5668
  { PseudoVLUXEI16_V_M2_M8_TU, VLUXEI16_V }, // 5669
  { PseudoVLUXEI16_V_M4_M2, VLUXEI16_V }, // 5670
  { PseudoVLUXEI16_V_M4_M2_MASK, VLUXEI16_V }, // 5671
  { PseudoVLUXEI16_V_M4_M2_TU, VLUXEI16_V }, // 5672
  { PseudoVLUXEI16_V_M4_M4, VLUXEI16_V }, // 5673
  { PseudoVLUXEI16_V_M4_M4_MASK, VLUXEI16_V }, // 5674
  { PseudoVLUXEI16_V_M4_M4_TU, VLUXEI16_V }, // 5675
  { PseudoVLUXEI16_V_M4_M8, VLUXEI16_V }, // 5676
  { PseudoVLUXEI16_V_M4_M8_MASK, VLUXEI16_V }, // 5677
  { PseudoVLUXEI16_V_M4_M8_TU, VLUXEI16_V }, // 5678
  { PseudoVLUXEI16_V_M8_M4, VLUXEI16_V }, // 5679
  { PseudoVLUXEI16_V_M8_M4_MASK, VLUXEI16_V }, // 5680
  { PseudoVLUXEI16_V_M8_M4_TU, VLUXEI16_V }, // 5681
  { PseudoVLUXEI16_V_M8_M8, VLUXEI16_V }, // 5682
  { PseudoVLUXEI16_V_M8_M8_MASK, VLUXEI16_V }, // 5683
  { PseudoVLUXEI16_V_M8_M8_TU, VLUXEI16_V }, // 5684
  { PseudoVLUXEI16_V_MF2_M1, VLUXEI16_V }, // 5685
  { PseudoVLUXEI16_V_MF2_M1_MASK, VLUXEI16_V }, // 5686
  { PseudoVLUXEI16_V_MF2_M1_TU, VLUXEI16_V }, // 5687
  { PseudoVLUXEI16_V_MF2_M2, VLUXEI16_V }, // 5688
  { PseudoVLUXEI16_V_MF2_M2_MASK, VLUXEI16_V }, // 5689
  { PseudoVLUXEI16_V_MF2_M2_TU, VLUXEI16_V }, // 5690
  { PseudoVLUXEI16_V_MF2_MF2, VLUXEI16_V }, // 5691
  { PseudoVLUXEI16_V_MF2_MF2_MASK, VLUXEI16_V }, // 5692
  { PseudoVLUXEI16_V_MF2_MF2_TU, VLUXEI16_V }, // 5693
  { PseudoVLUXEI16_V_MF2_MF4, VLUXEI16_V }, // 5694
  { PseudoVLUXEI16_V_MF2_MF4_MASK, VLUXEI16_V }, // 5695
  { PseudoVLUXEI16_V_MF2_MF4_TU, VLUXEI16_V }, // 5696
  { PseudoVLUXEI16_V_MF4_M1, VLUXEI16_V }, // 5697
  { PseudoVLUXEI16_V_MF4_M1_MASK, VLUXEI16_V }, // 5698
  { PseudoVLUXEI16_V_MF4_M1_TU, VLUXEI16_V }, // 5699
  { PseudoVLUXEI16_V_MF4_MF2, VLUXEI16_V }, // 5700
  { PseudoVLUXEI16_V_MF4_MF2_MASK, VLUXEI16_V }, // 5701
  { PseudoVLUXEI16_V_MF4_MF2_TU, VLUXEI16_V }, // 5702
  { PseudoVLUXEI16_V_MF4_MF4, VLUXEI16_V }, // 5703
  { PseudoVLUXEI16_V_MF4_MF4_MASK, VLUXEI16_V }, // 5704
  { PseudoVLUXEI16_V_MF4_MF4_TU, VLUXEI16_V }, // 5705
  { PseudoVLUXEI16_V_MF4_MF8, VLUXEI16_V }, // 5706
  { PseudoVLUXEI16_V_MF4_MF8_MASK, VLUXEI16_V }, // 5707
  { PseudoVLUXEI16_V_MF4_MF8_TU, VLUXEI16_V }, // 5708
  { PseudoVLUXEI32_V_M1_M1, VLUXEI32_V }, // 5709
  { PseudoVLUXEI32_V_M1_M1_MASK, VLUXEI32_V }, // 5710
  { PseudoVLUXEI32_V_M1_M1_TU, VLUXEI32_V }, // 5711
  { PseudoVLUXEI32_V_M1_M2, VLUXEI32_V }, // 5712
  { PseudoVLUXEI32_V_M1_M2_MASK, VLUXEI32_V }, // 5713
  { PseudoVLUXEI32_V_M1_M2_TU, VLUXEI32_V }, // 5714
  { PseudoVLUXEI32_V_M1_MF2, VLUXEI32_V }, // 5715
  { PseudoVLUXEI32_V_M1_MF2_MASK, VLUXEI32_V }, // 5716
  { PseudoVLUXEI32_V_M1_MF2_TU, VLUXEI32_V }, // 5717
  { PseudoVLUXEI32_V_M1_MF4, VLUXEI32_V }, // 5718
  { PseudoVLUXEI32_V_M1_MF4_MASK, VLUXEI32_V }, // 5719
  { PseudoVLUXEI32_V_M1_MF4_TU, VLUXEI32_V }, // 5720
  { PseudoVLUXEI32_V_M2_M1, VLUXEI32_V }, // 5721
  { PseudoVLUXEI32_V_M2_M1_MASK, VLUXEI32_V }, // 5722
  { PseudoVLUXEI32_V_M2_M1_TU, VLUXEI32_V }, // 5723
  { PseudoVLUXEI32_V_M2_M2, VLUXEI32_V }, // 5724
  { PseudoVLUXEI32_V_M2_M2_MASK, VLUXEI32_V }, // 5725
  { PseudoVLUXEI32_V_M2_M2_TU, VLUXEI32_V }, // 5726
  { PseudoVLUXEI32_V_M2_M4, VLUXEI32_V }, // 5727
  { PseudoVLUXEI32_V_M2_M4_MASK, VLUXEI32_V }, // 5728
  { PseudoVLUXEI32_V_M2_M4_TU, VLUXEI32_V }, // 5729
  { PseudoVLUXEI32_V_M2_MF2, VLUXEI32_V }, // 5730
  { PseudoVLUXEI32_V_M2_MF2_MASK, VLUXEI32_V }, // 5731
  { PseudoVLUXEI32_V_M2_MF2_TU, VLUXEI32_V }, // 5732
  { PseudoVLUXEI32_V_M4_M1, VLUXEI32_V }, // 5733
  { PseudoVLUXEI32_V_M4_M1_MASK, VLUXEI32_V }, // 5734
  { PseudoVLUXEI32_V_M4_M1_TU, VLUXEI32_V }, // 5735
  { PseudoVLUXEI32_V_M4_M2, VLUXEI32_V }, // 5736
  { PseudoVLUXEI32_V_M4_M2_MASK, VLUXEI32_V }, // 5737
  { PseudoVLUXEI32_V_M4_M2_TU, VLUXEI32_V }, // 5738
  { PseudoVLUXEI32_V_M4_M4, VLUXEI32_V }, // 5739
  { PseudoVLUXEI32_V_M4_M4_MASK, VLUXEI32_V }, // 5740
  { PseudoVLUXEI32_V_M4_M4_TU, VLUXEI32_V }, // 5741
  { PseudoVLUXEI32_V_M4_M8, VLUXEI32_V }, // 5742
  { PseudoVLUXEI32_V_M4_M8_MASK, VLUXEI32_V }, // 5743
  { PseudoVLUXEI32_V_M4_M8_TU, VLUXEI32_V }, // 5744
  { PseudoVLUXEI32_V_M8_M2, VLUXEI32_V }, // 5745
  { PseudoVLUXEI32_V_M8_M2_MASK, VLUXEI32_V }, // 5746
  { PseudoVLUXEI32_V_M8_M2_TU, VLUXEI32_V }, // 5747
  { PseudoVLUXEI32_V_M8_M4, VLUXEI32_V }, // 5748
  { PseudoVLUXEI32_V_M8_M4_MASK, VLUXEI32_V }, // 5749
  { PseudoVLUXEI32_V_M8_M4_TU, VLUXEI32_V }, // 5750
  { PseudoVLUXEI32_V_M8_M8, VLUXEI32_V }, // 5751
  { PseudoVLUXEI32_V_M8_M8_MASK, VLUXEI32_V }, // 5752
  { PseudoVLUXEI32_V_M8_M8_TU, VLUXEI32_V }, // 5753
  { PseudoVLUXEI32_V_MF2_M1, VLUXEI32_V }, // 5754
  { PseudoVLUXEI32_V_MF2_M1_MASK, VLUXEI32_V }, // 5755
  { PseudoVLUXEI32_V_MF2_M1_TU, VLUXEI32_V }, // 5756
  { PseudoVLUXEI32_V_MF2_MF2, VLUXEI32_V }, // 5757
  { PseudoVLUXEI32_V_MF2_MF2_MASK, VLUXEI32_V }, // 5758
  { PseudoVLUXEI32_V_MF2_MF2_TU, VLUXEI32_V }, // 5759
  { PseudoVLUXEI32_V_MF2_MF4, VLUXEI32_V }, // 5760
  { PseudoVLUXEI32_V_MF2_MF4_MASK, VLUXEI32_V }, // 5761
  { PseudoVLUXEI32_V_MF2_MF4_TU, VLUXEI32_V }, // 5762
  { PseudoVLUXEI32_V_MF2_MF8, VLUXEI32_V }, // 5763
  { PseudoVLUXEI32_V_MF2_MF8_MASK, VLUXEI32_V }, // 5764
  { PseudoVLUXEI32_V_MF2_MF8_TU, VLUXEI32_V }, // 5765
  { PseudoVLUXEI64_V_M1_M1, VLUXEI64_V }, // 5766
  { PseudoVLUXEI64_V_M1_M1_MASK, VLUXEI64_V }, // 5767
  { PseudoVLUXEI64_V_M1_M1_TU, VLUXEI64_V }, // 5768
  { PseudoVLUXEI64_V_M1_MF2, VLUXEI64_V }, // 5769
  { PseudoVLUXEI64_V_M1_MF2_MASK, VLUXEI64_V }, // 5770
  { PseudoVLUXEI64_V_M1_MF2_TU, VLUXEI64_V }, // 5771
  { PseudoVLUXEI64_V_M1_MF4, VLUXEI64_V }, // 5772
  { PseudoVLUXEI64_V_M1_MF4_MASK, VLUXEI64_V }, // 5773
  { PseudoVLUXEI64_V_M1_MF4_TU, VLUXEI64_V }, // 5774
  { PseudoVLUXEI64_V_M1_MF8, VLUXEI64_V }, // 5775
  { PseudoVLUXEI64_V_M1_MF8_MASK, VLUXEI64_V }, // 5776
  { PseudoVLUXEI64_V_M1_MF8_TU, VLUXEI64_V }, // 5777
  { PseudoVLUXEI64_V_M2_M1, VLUXEI64_V }, // 5778
  { PseudoVLUXEI64_V_M2_M1_MASK, VLUXEI64_V }, // 5779
  { PseudoVLUXEI64_V_M2_M1_TU, VLUXEI64_V }, // 5780
  { PseudoVLUXEI64_V_M2_M2, VLUXEI64_V }, // 5781
  { PseudoVLUXEI64_V_M2_M2_MASK, VLUXEI64_V }, // 5782
  { PseudoVLUXEI64_V_M2_M2_TU, VLUXEI64_V }, // 5783
  { PseudoVLUXEI64_V_M2_MF2, VLUXEI64_V }, // 5784
  { PseudoVLUXEI64_V_M2_MF2_MASK, VLUXEI64_V }, // 5785
  { PseudoVLUXEI64_V_M2_MF2_TU, VLUXEI64_V }, // 5786
  { PseudoVLUXEI64_V_M2_MF4, VLUXEI64_V }, // 5787
  { PseudoVLUXEI64_V_M2_MF4_MASK, VLUXEI64_V }, // 5788
  { PseudoVLUXEI64_V_M2_MF4_TU, VLUXEI64_V }, // 5789
  { PseudoVLUXEI64_V_M4_M1, VLUXEI64_V }, // 5790
  { PseudoVLUXEI64_V_M4_M1_MASK, VLUXEI64_V }, // 5791
  { PseudoVLUXEI64_V_M4_M1_TU, VLUXEI64_V }, // 5792
  { PseudoVLUXEI64_V_M4_M2, VLUXEI64_V }, // 5793
  { PseudoVLUXEI64_V_M4_M2_MASK, VLUXEI64_V }, // 5794
  { PseudoVLUXEI64_V_M4_M2_TU, VLUXEI64_V }, // 5795
  { PseudoVLUXEI64_V_M4_M4, VLUXEI64_V }, // 5796
  { PseudoVLUXEI64_V_M4_M4_MASK, VLUXEI64_V }, // 5797
  { PseudoVLUXEI64_V_M4_M4_TU, VLUXEI64_V }, // 5798
  { PseudoVLUXEI64_V_M4_MF2, VLUXEI64_V }, // 5799
  { PseudoVLUXEI64_V_M4_MF2_MASK, VLUXEI64_V }, // 5800
  { PseudoVLUXEI64_V_M4_MF2_TU, VLUXEI64_V }, // 5801
  { PseudoVLUXEI64_V_M8_M1, VLUXEI64_V }, // 5802
  { PseudoVLUXEI64_V_M8_M1_MASK, VLUXEI64_V }, // 5803
  { PseudoVLUXEI64_V_M8_M1_TU, VLUXEI64_V }, // 5804
  { PseudoVLUXEI64_V_M8_M2, VLUXEI64_V }, // 5805
  { PseudoVLUXEI64_V_M8_M2_MASK, VLUXEI64_V }, // 5806
  { PseudoVLUXEI64_V_M8_M2_TU, VLUXEI64_V }, // 5807
  { PseudoVLUXEI64_V_M8_M4, VLUXEI64_V }, // 5808
  { PseudoVLUXEI64_V_M8_M4_MASK, VLUXEI64_V }, // 5809
  { PseudoVLUXEI64_V_M8_M4_TU, VLUXEI64_V }, // 5810
  { PseudoVLUXEI64_V_M8_M8, VLUXEI64_V }, // 5811
  { PseudoVLUXEI64_V_M8_M8_MASK, VLUXEI64_V }, // 5812
  { PseudoVLUXEI64_V_M8_M8_TU, VLUXEI64_V }, // 5813
  { PseudoVLUXEI8_V_M1_M1, VLUXEI8_V }, // 5814
  { PseudoVLUXEI8_V_M1_M1_MASK, VLUXEI8_V }, // 5815
  { PseudoVLUXEI8_V_M1_M1_TU, VLUXEI8_V }, // 5816
  { PseudoVLUXEI8_V_M1_M2, VLUXEI8_V }, // 5817
  { PseudoVLUXEI8_V_M1_M2_MASK, VLUXEI8_V }, // 5818
  { PseudoVLUXEI8_V_M1_M2_TU, VLUXEI8_V }, // 5819
  { PseudoVLUXEI8_V_M1_M4, VLUXEI8_V }, // 5820
  { PseudoVLUXEI8_V_M1_M4_MASK, VLUXEI8_V }, // 5821
  { PseudoVLUXEI8_V_M1_M4_TU, VLUXEI8_V }, // 5822
  { PseudoVLUXEI8_V_M1_M8, VLUXEI8_V }, // 5823
  { PseudoVLUXEI8_V_M1_M8_MASK, VLUXEI8_V }, // 5824
  { PseudoVLUXEI8_V_M1_M8_TU, VLUXEI8_V }, // 5825
  { PseudoVLUXEI8_V_M2_M2, VLUXEI8_V }, // 5826
  { PseudoVLUXEI8_V_M2_M2_MASK, VLUXEI8_V }, // 5827
  { PseudoVLUXEI8_V_M2_M2_TU, VLUXEI8_V }, // 5828
  { PseudoVLUXEI8_V_M2_M4, VLUXEI8_V }, // 5829
  { PseudoVLUXEI8_V_M2_M4_MASK, VLUXEI8_V }, // 5830
  { PseudoVLUXEI8_V_M2_M4_TU, VLUXEI8_V }, // 5831
  { PseudoVLUXEI8_V_M2_M8, VLUXEI8_V }, // 5832
  { PseudoVLUXEI8_V_M2_M8_MASK, VLUXEI8_V }, // 5833
  { PseudoVLUXEI8_V_M2_M8_TU, VLUXEI8_V }, // 5834
  { PseudoVLUXEI8_V_M4_M4, VLUXEI8_V }, // 5835
  { PseudoVLUXEI8_V_M4_M4_MASK, VLUXEI8_V }, // 5836
  { PseudoVLUXEI8_V_M4_M4_TU, VLUXEI8_V }, // 5837
  { PseudoVLUXEI8_V_M4_M8, VLUXEI8_V }, // 5838
  { PseudoVLUXEI8_V_M4_M8_MASK, VLUXEI8_V }, // 5839
  { PseudoVLUXEI8_V_M4_M8_TU, VLUXEI8_V }, // 5840
  { PseudoVLUXEI8_V_M8_M8, VLUXEI8_V }, // 5841
  { PseudoVLUXEI8_V_M8_M8_MASK, VLUXEI8_V }, // 5842
  { PseudoVLUXEI8_V_M8_M8_TU, VLUXEI8_V }, // 5843
  { PseudoVLUXEI8_V_MF2_M1, VLUXEI8_V }, // 5844
  { PseudoVLUXEI8_V_MF2_M1_MASK, VLUXEI8_V }, // 5845
  { PseudoVLUXEI8_V_MF2_M1_TU, VLUXEI8_V }, // 5846
  { PseudoVLUXEI8_V_MF2_M2, VLUXEI8_V }, // 5847
  { PseudoVLUXEI8_V_MF2_M2_MASK, VLUXEI8_V }, // 5848
  { PseudoVLUXEI8_V_MF2_M2_TU, VLUXEI8_V }, // 5849
  { PseudoVLUXEI8_V_MF2_M4, VLUXEI8_V }, // 5850
  { PseudoVLUXEI8_V_MF2_M4_MASK, VLUXEI8_V }, // 5851
  { PseudoVLUXEI8_V_MF2_M4_TU, VLUXEI8_V }, // 5852
  { PseudoVLUXEI8_V_MF2_MF2, VLUXEI8_V }, // 5853
  { PseudoVLUXEI8_V_MF2_MF2_MASK, VLUXEI8_V }, // 5854
  { PseudoVLUXEI8_V_MF2_MF2_TU, VLUXEI8_V }, // 5855
  { PseudoVLUXEI8_V_MF4_M1, VLUXEI8_V }, // 5856
  { PseudoVLUXEI8_V_MF4_M1_MASK, VLUXEI8_V }, // 5857
  { PseudoVLUXEI8_V_MF4_M1_TU, VLUXEI8_V }, // 5858
  { PseudoVLUXEI8_V_MF4_M2, VLUXEI8_V }, // 5859
  { PseudoVLUXEI8_V_MF4_M2_MASK, VLUXEI8_V }, // 5860
  { PseudoVLUXEI8_V_MF4_M2_TU, VLUXEI8_V }, // 5861
  { PseudoVLUXEI8_V_MF4_MF2, VLUXEI8_V }, // 5862
  { PseudoVLUXEI8_V_MF4_MF2_MASK, VLUXEI8_V }, // 5863
  { PseudoVLUXEI8_V_MF4_MF2_TU, VLUXEI8_V }, // 5864
  { PseudoVLUXEI8_V_MF4_MF4, VLUXEI8_V }, // 5865
  { PseudoVLUXEI8_V_MF4_MF4_MASK, VLUXEI8_V }, // 5866
  { PseudoVLUXEI8_V_MF4_MF4_TU, VLUXEI8_V }, // 5867
  { PseudoVLUXEI8_V_MF8_M1, VLUXEI8_V }, // 5868
  { PseudoVLUXEI8_V_MF8_M1_MASK, VLUXEI8_V }, // 5869
  { PseudoVLUXEI8_V_MF8_M1_TU, VLUXEI8_V }, // 5870
  { PseudoVLUXEI8_V_MF8_MF2, VLUXEI8_V }, // 5871
  { PseudoVLUXEI8_V_MF8_MF2_MASK, VLUXEI8_V }, // 5872
  { PseudoVLUXEI8_V_MF8_MF2_TU, VLUXEI8_V }, // 5873
  { PseudoVLUXEI8_V_MF8_MF4, VLUXEI8_V }, // 5874
  { PseudoVLUXEI8_V_MF8_MF4_MASK, VLUXEI8_V }, // 5875
  { PseudoVLUXEI8_V_MF8_MF4_TU, VLUXEI8_V }, // 5876
  { PseudoVLUXEI8_V_MF8_MF8, VLUXEI8_V }, // 5877
  { PseudoVLUXEI8_V_MF8_MF8_MASK, VLUXEI8_V }, // 5878
  { PseudoVLUXEI8_V_MF8_MF8_TU, VLUXEI8_V }, // 5879
  { PseudoVLUXSEG2EI16_V_M1_M1, VLUXSEG2EI16_V }, // 5880
  { PseudoVLUXSEG2EI16_V_M1_M1_MASK, VLUXSEG2EI16_V }, // 5881
  { PseudoVLUXSEG2EI16_V_M1_M1_TU, VLUXSEG2EI16_V }, // 5882
  { PseudoVLUXSEG2EI16_V_M1_M2, VLUXSEG2EI16_V }, // 5883
  { PseudoVLUXSEG2EI16_V_M1_M2_MASK, VLUXSEG2EI16_V }, // 5884
  { PseudoVLUXSEG2EI16_V_M1_M2_TU, VLUXSEG2EI16_V }, // 5885
  { PseudoVLUXSEG2EI16_V_M1_M4, VLUXSEG2EI16_V }, // 5886
  { PseudoVLUXSEG2EI16_V_M1_M4_MASK, VLUXSEG2EI16_V }, // 5887
  { PseudoVLUXSEG2EI16_V_M1_M4_TU, VLUXSEG2EI16_V }, // 5888
  { PseudoVLUXSEG2EI16_V_M1_MF2, VLUXSEG2EI16_V }, // 5889
  { PseudoVLUXSEG2EI16_V_M1_MF2_MASK, VLUXSEG2EI16_V }, // 5890
  { PseudoVLUXSEG2EI16_V_M1_MF2_TU, VLUXSEG2EI16_V }, // 5891
  { PseudoVLUXSEG2EI16_V_M2_M1, VLUXSEG2EI16_V }, // 5892
  { PseudoVLUXSEG2EI16_V_M2_M1_MASK, VLUXSEG2EI16_V }, // 5893
  { PseudoVLUXSEG2EI16_V_M2_M1_TU, VLUXSEG2EI16_V }, // 5894
  { PseudoVLUXSEG2EI16_V_M2_M2, VLUXSEG2EI16_V }, // 5895
  { PseudoVLUXSEG2EI16_V_M2_M2_MASK, VLUXSEG2EI16_V }, // 5896
  { PseudoVLUXSEG2EI16_V_M2_M2_TU, VLUXSEG2EI16_V }, // 5897
  { PseudoVLUXSEG2EI16_V_M2_M4, VLUXSEG2EI16_V }, // 5898
  { PseudoVLUXSEG2EI16_V_M2_M4_MASK, VLUXSEG2EI16_V }, // 5899
  { PseudoVLUXSEG2EI16_V_M2_M4_TU, VLUXSEG2EI16_V }, // 5900
  { PseudoVLUXSEG2EI16_V_M4_M2, VLUXSEG2EI16_V }, // 5901
  { PseudoVLUXSEG2EI16_V_M4_M2_MASK, VLUXSEG2EI16_V }, // 5902
  { PseudoVLUXSEG2EI16_V_M4_M2_TU, VLUXSEG2EI16_V }, // 5903
  { PseudoVLUXSEG2EI16_V_M4_M4, VLUXSEG2EI16_V }, // 5904
  { PseudoVLUXSEG2EI16_V_M4_M4_MASK, VLUXSEG2EI16_V }, // 5905
  { PseudoVLUXSEG2EI16_V_M4_M4_TU, VLUXSEG2EI16_V }, // 5906
  { PseudoVLUXSEG2EI16_V_M8_M4, VLUXSEG2EI16_V }, // 5907
  { PseudoVLUXSEG2EI16_V_M8_M4_MASK, VLUXSEG2EI16_V }, // 5908
  { PseudoVLUXSEG2EI16_V_M8_M4_TU, VLUXSEG2EI16_V }, // 5909
  { PseudoVLUXSEG2EI16_V_MF2_M1, VLUXSEG2EI16_V }, // 5910
  { PseudoVLUXSEG2EI16_V_MF2_M1_MASK, VLUXSEG2EI16_V }, // 5911
  { PseudoVLUXSEG2EI16_V_MF2_M1_TU, VLUXSEG2EI16_V }, // 5912
  { PseudoVLUXSEG2EI16_V_MF2_M2, VLUXSEG2EI16_V }, // 5913
  { PseudoVLUXSEG2EI16_V_MF2_M2_MASK, VLUXSEG2EI16_V }, // 5914
  { PseudoVLUXSEG2EI16_V_MF2_M2_TU, VLUXSEG2EI16_V }, // 5915
  { PseudoVLUXSEG2EI16_V_MF2_MF2, VLUXSEG2EI16_V }, // 5916
  { PseudoVLUXSEG2EI16_V_MF2_MF2_MASK, VLUXSEG2EI16_V }, // 5917
  { PseudoVLUXSEG2EI16_V_MF2_MF2_TU, VLUXSEG2EI16_V }, // 5918
  { PseudoVLUXSEG2EI16_V_MF2_MF4, VLUXSEG2EI16_V }, // 5919
  { PseudoVLUXSEG2EI16_V_MF2_MF4_MASK, VLUXSEG2EI16_V }, // 5920
  { PseudoVLUXSEG2EI16_V_MF2_MF4_TU, VLUXSEG2EI16_V }, // 5921
  { PseudoVLUXSEG2EI16_V_MF4_M1, VLUXSEG2EI16_V }, // 5922
  { PseudoVLUXSEG2EI16_V_MF4_M1_MASK, VLUXSEG2EI16_V }, // 5923
  { PseudoVLUXSEG2EI16_V_MF4_M1_TU, VLUXSEG2EI16_V }, // 5924
  { PseudoVLUXSEG2EI16_V_MF4_MF2, VLUXSEG2EI16_V }, // 5925
  { PseudoVLUXSEG2EI16_V_MF4_MF2_MASK, VLUXSEG2EI16_V }, // 5926
  { PseudoVLUXSEG2EI16_V_MF4_MF2_TU, VLUXSEG2EI16_V }, // 5927
  { PseudoVLUXSEG2EI16_V_MF4_MF4, VLUXSEG2EI16_V }, // 5928
  { PseudoVLUXSEG2EI16_V_MF4_MF4_MASK, VLUXSEG2EI16_V }, // 5929
  { PseudoVLUXSEG2EI16_V_MF4_MF4_TU, VLUXSEG2EI16_V }, // 5930
  { PseudoVLUXSEG2EI16_V_MF4_MF8, VLUXSEG2EI16_V }, // 5931
  { PseudoVLUXSEG2EI16_V_MF4_MF8_MASK, VLUXSEG2EI16_V }, // 5932
  { PseudoVLUXSEG2EI16_V_MF4_MF8_TU, VLUXSEG2EI16_V }, // 5933
  { PseudoVLUXSEG2EI32_V_M1_M1, VLUXSEG2EI32_V }, // 5934
  { PseudoVLUXSEG2EI32_V_M1_M1_MASK, VLUXSEG2EI32_V }, // 5935
  { PseudoVLUXSEG2EI32_V_M1_M1_TU, VLUXSEG2EI32_V }, // 5936
  { PseudoVLUXSEG2EI32_V_M1_M2, VLUXSEG2EI32_V }, // 5937
  { PseudoVLUXSEG2EI32_V_M1_M2_MASK, VLUXSEG2EI32_V }, // 5938
  { PseudoVLUXSEG2EI32_V_M1_M2_TU, VLUXSEG2EI32_V }, // 5939
  { PseudoVLUXSEG2EI32_V_M1_MF2, VLUXSEG2EI32_V }, // 5940
  { PseudoVLUXSEG2EI32_V_M1_MF2_MASK, VLUXSEG2EI32_V }, // 5941
  { PseudoVLUXSEG2EI32_V_M1_MF2_TU, VLUXSEG2EI32_V }, // 5942
  { PseudoVLUXSEG2EI32_V_M1_MF4, VLUXSEG2EI32_V }, // 5943
  { PseudoVLUXSEG2EI32_V_M1_MF4_MASK, VLUXSEG2EI32_V }, // 5944
  { PseudoVLUXSEG2EI32_V_M1_MF4_TU, VLUXSEG2EI32_V }, // 5945
  { PseudoVLUXSEG2EI32_V_M2_M1, VLUXSEG2EI32_V }, // 5946
  { PseudoVLUXSEG2EI32_V_M2_M1_MASK, VLUXSEG2EI32_V }, // 5947
  { PseudoVLUXSEG2EI32_V_M2_M1_TU, VLUXSEG2EI32_V }, // 5948
  { PseudoVLUXSEG2EI32_V_M2_M2, VLUXSEG2EI32_V }, // 5949
  { PseudoVLUXSEG2EI32_V_M2_M2_MASK, VLUXSEG2EI32_V }, // 5950
  { PseudoVLUXSEG2EI32_V_M2_M2_TU, VLUXSEG2EI32_V }, // 5951
  { PseudoVLUXSEG2EI32_V_M2_M4, VLUXSEG2EI32_V }, // 5952
  { PseudoVLUXSEG2EI32_V_M2_M4_MASK, VLUXSEG2EI32_V }, // 5953
  { PseudoVLUXSEG2EI32_V_M2_M4_TU, VLUXSEG2EI32_V }, // 5954
  { PseudoVLUXSEG2EI32_V_M2_MF2, VLUXSEG2EI32_V }, // 5955
  { PseudoVLUXSEG2EI32_V_M2_MF2_MASK, VLUXSEG2EI32_V }, // 5956
  { PseudoVLUXSEG2EI32_V_M2_MF2_TU, VLUXSEG2EI32_V }, // 5957
  { PseudoVLUXSEG2EI32_V_M4_M1, VLUXSEG2EI32_V }, // 5958
  { PseudoVLUXSEG2EI32_V_M4_M1_MASK, VLUXSEG2EI32_V }, // 5959
  { PseudoVLUXSEG2EI32_V_M4_M1_TU, VLUXSEG2EI32_V }, // 5960
  { PseudoVLUXSEG2EI32_V_M4_M2, VLUXSEG2EI32_V }, // 5961
  { PseudoVLUXSEG2EI32_V_M4_M2_MASK, VLUXSEG2EI32_V }, // 5962
  { PseudoVLUXSEG2EI32_V_M4_M2_TU, VLUXSEG2EI32_V }, // 5963
  { PseudoVLUXSEG2EI32_V_M4_M4, VLUXSEG2EI32_V }, // 5964
  { PseudoVLUXSEG2EI32_V_M4_M4_MASK, VLUXSEG2EI32_V }, // 5965
  { PseudoVLUXSEG2EI32_V_M4_M4_TU, VLUXSEG2EI32_V }, // 5966
  { PseudoVLUXSEG2EI32_V_M8_M2, VLUXSEG2EI32_V }, // 5967
  { PseudoVLUXSEG2EI32_V_M8_M2_MASK, VLUXSEG2EI32_V }, // 5968
  { PseudoVLUXSEG2EI32_V_M8_M2_TU, VLUXSEG2EI32_V }, // 5969
  { PseudoVLUXSEG2EI32_V_M8_M4, VLUXSEG2EI32_V }, // 5970
  { PseudoVLUXSEG2EI32_V_M8_M4_MASK, VLUXSEG2EI32_V }, // 5971
  { PseudoVLUXSEG2EI32_V_M8_M4_TU, VLUXSEG2EI32_V }, // 5972
  { PseudoVLUXSEG2EI32_V_MF2_M1, VLUXSEG2EI32_V }, // 5973
  { PseudoVLUXSEG2EI32_V_MF2_M1_MASK, VLUXSEG2EI32_V }, // 5974
  { PseudoVLUXSEG2EI32_V_MF2_M1_TU, VLUXSEG2EI32_V }, // 5975
  { PseudoVLUXSEG2EI32_V_MF2_MF2, VLUXSEG2EI32_V }, // 5976
  { PseudoVLUXSEG2EI32_V_MF2_MF2_MASK, VLUXSEG2EI32_V }, // 5977
  { PseudoVLUXSEG2EI32_V_MF2_MF2_TU, VLUXSEG2EI32_V }, // 5978
  { PseudoVLUXSEG2EI32_V_MF2_MF4, VLUXSEG2EI32_V }, // 5979
  { PseudoVLUXSEG2EI32_V_MF2_MF4_MASK, VLUXSEG2EI32_V }, // 5980
  { PseudoVLUXSEG2EI32_V_MF2_MF4_TU, VLUXSEG2EI32_V }, // 5981
  { PseudoVLUXSEG2EI32_V_MF2_MF8, VLUXSEG2EI32_V }, // 5982
  { PseudoVLUXSEG2EI32_V_MF2_MF8_MASK, VLUXSEG2EI32_V }, // 5983
  { PseudoVLUXSEG2EI32_V_MF2_MF8_TU, VLUXSEG2EI32_V }, // 5984
  { PseudoVLUXSEG2EI64_V_M1_M1, VLUXSEG2EI64_V }, // 5985
  { PseudoVLUXSEG2EI64_V_M1_M1_MASK, VLUXSEG2EI64_V }, // 5986
  { PseudoVLUXSEG2EI64_V_M1_M1_TU, VLUXSEG2EI64_V }, // 5987
  { PseudoVLUXSEG2EI64_V_M1_MF2, VLUXSEG2EI64_V }, // 5988
  { PseudoVLUXSEG2EI64_V_M1_MF2_MASK, VLUXSEG2EI64_V }, // 5989
  { PseudoVLUXSEG2EI64_V_M1_MF2_TU, VLUXSEG2EI64_V }, // 5990
  { PseudoVLUXSEG2EI64_V_M1_MF4, VLUXSEG2EI64_V }, // 5991
  { PseudoVLUXSEG2EI64_V_M1_MF4_MASK, VLUXSEG2EI64_V }, // 5992
  { PseudoVLUXSEG2EI64_V_M1_MF4_TU, VLUXSEG2EI64_V }, // 5993
  { PseudoVLUXSEG2EI64_V_M1_MF8, VLUXSEG2EI64_V }, // 5994
  { PseudoVLUXSEG2EI64_V_M1_MF8_MASK, VLUXSEG2EI64_V }, // 5995
  { PseudoVLUXSEG2EI64_V_M1_MF8_TU, VLUXSEG2EI64_V }, // 5996
  { PseudoVLUXSEG2EI64_V_M2_M1, VLUXSEG2EI64_V }, // 5997
  { PseudoVLUXSEG2EI64_V_M2_M1_MASK, VLUXSEG2EI64_V }, // 5998
  { PseudoVLUXSEG2EI64_V_M2_M1_TU, VLUXSEG2EI64_V }, // 5999
  { PseudoVLUXSEG2EI64_V_M2_M2, VLUXSEG2EI64_V }, // 6000
  { PseudoVLUXSEG2EI64_V_M2_M2_MASK, VLUXSEG2EI64_V }, // 6001
  { PseudoVLUXSEG2EI64_V_M2_M2_TU, VLUXSEG2EI64_V }, // 6002
  { PseudoVLUXSEG2EI64_V_M2_MF2, VLUXSEG2EI64_V }, // 6003
  { PseudoVLUXSEG2EI64_V_M2_MF2_MASK, VLUXSEG2EI64_V }, // 6004
  { PseudoVLUXSEG2EI64_V_M2_MF2_TU, VLUXSEG2EI64_V }, // 6005
  { PseudoVLUXSEG2EI64_V_M2_MF4, VLUXSEG2EI64_V }, // 6006
  { PseudoVLUXSEG2EI64_V_M2_MF4_MASK, VLUXSEG2EI64_V }, // 6007
  { PseudoVLUXSEG2EI64_V_M2_MF4_TU, VLUXSEG2EI64_V }, // 6008
  { PseudoVLUXSEG2EI64_V_M4_M1, VLUXSEG2EI64_V }, // 6009
  { PseudoVLUXSEG2EI64_V_M4_M1_MASK, VLUXSEG2EI64_V }, // 6010
  { PseudoVLUXSEG2EI64_V_M4_M1_TU, VLUXSEG2EI64_V }, // 6011
  { PseudoVLUXSEG2EI64_V_M4_M2, VLUXSEG2EI64_V }, // 6012
  { PseudoVLUXSEG2EI64_V_M4_M2_MASK, VLUXSEG2EI64_V }, // 6013
  { PseudoVLUXSEG2EI64_V_M4_M2_TU, VLUXSEG2EI64_V }, // 6014
  { PseudoVLUXSEG2EI64_V_M4_M4, VLUXSEG2EI64_V }, // 6015
  { PseudoVLUXSEG2EI64_V_M4_M4_MASK, VLUXSEG2EI64_V }, // 6016
  { PseudoVLUXSEG2EI64_V_M4_M4_TU, VLUXSEG2EI64_V }, // 6017
  { PseudoVLUXSEG2EI64_V_M4_MF2, VLUXSEG2EI64_V }, // 6018
  { PseudoVLUXSEG2EI64_V_M4_MF2_MASK, VLUXSEG2EI64_V }, // 6019
  { PseudoVLUXSEG2EI64_V_M4_MF2_TU, VLUXSEG2EI64_V }, // 6020
  { PseudoVLUXSEG2EI64_V_M8_M1, VLUXSEG2EI64_V }, // 6021
  { PseudoVLUXSEG2EI64_V_M8_M1_MASK, VLUXSEG2EI64_V }, // 6022
  { PseudoVLUXSEG2EI64_V_M8_M1_TU, VLUXSEG2EI64_V }, // 6023
  { PseudoVLUXSEG2EI64_V_M8_M2, VLUXSEG2EI64_V }, // 6024
  { PseudoVLUXSEG2EI64_V_M8_M2_MASK, VLUXSEG2EI64_V }, // 6025
  { PseudoVLUXSEG2EI64_V_M8_M2_TU, VLUXSEG2EI64_V }, // 6026
  { PseudoVLUXSEG2EI64_V_M8_M4, VLUXSEG2EI64_V }, // 6027
  { PseudoVLUXSEG2EI64_V_M8_M4_MASK, VLUXSEG2EI64_V }, // 6028
  { PseudoVLUXSEG2EI64_V_M8_M4_TU, VLUXSEG2EI64_V }, // 6029
  { PseudoVLUXSEG2EI8_V_M1_M1, VLUXSEG2EI8_V }, // 6030
  { PseudoVLUXSEG2EI8_V_M1_M1_MASK, VLUXSEG2EI8_V }, // 6031
  { PseudoVLUXSEG2EI8_V_M1_M1_TU, VLUXSEG2EI8_V }, // 6032
  { PseudoVLUXSEG2EI8_V_M1_M2, VLUXSEG2EI8_V }, // 6033
  { PseudoVLUXSEG2EI8_V_M1_M2_MASK, VLUXSEG2EI8_V }, // 6034
  { PseudoVLUXSEG2EI8_V_M1_M2_TU, VLUXSEG2EI8_V }, // 6035
  { PseudoVLUXSEG2EI8_V_M1_M4, VLUXSEG2EI8_V }, // 6036
  { PseudoVLUXSEG2EI8_V_M1_M4_MASK, VLUXSEG2EI8_V }, // 6037
  { PseudoVLUXSEG2EI8_V_M1_M4_TU, VLUXSEG2EI8_V }, // 6038
  { PseudoVLUXSEG2EI8_V_M2_M2, VLUXSEG2EI8_V }, // 6039
  { PseudoVLUXSEG2EI8_V_M2_M2_MASK, VLUXSEG2EI8_V }, // 6040
  { PseudoVLUXSEG2EI8_V_M2_M2_TU, VLUXSEG2EI8_V }, // 6041
  { PseudoVLUXSEG2EI8_V_M2_M4, VLUXSEG2EI8_V }, // 6042
  { PseudoVLUXSEG2EI8_V_M2_M4_MASK, VLUXSEG2EI8_V }, // 6043
  { PseudoVLUXSEG2EI8_V_M2_M4_TU, VLUXSEG2EI8_V }, // 6044
  { PseudoVLUXSEG2EI8_V_M4_M4, VLUXSEG2EI8_V }, // 6045
  { PseudoVLUXSEG2EI8_V_M4_M4_MASK, VLUXSEG2EI8_V }, // 6046
  { PseudoVLUXSEG2EI8_V_M4_M4_TU, VLUXSEG2EI8_V }, // 6047
  { PseudoVLUXSEG2EI8_V_MF2_M1, VLUXSEG2EI8_V }, // 6048
  { PseudoVLUXSEG2EI8_V_MF2_M1_MASK, VLUXSEG2EI8_V }, // 6049
  { PseudoVLUXSEG2EI8_V_MF2_M1_TU, VLUXSEG2EI8_V }, // 6050
  { PseudoVLUXSEG2EI8_V_MF2_M2, VLUXSEG2EI8_V }, // 6051
  { PseudoVLUXSEG2EI8_V_MF2_M2_MASK, VLUXSEG2EI8_V }, // 6052
  { PseudoVLUXSEG2EI8_V_MF2_M2_TU, VLUXSEG2EI8_V }, // 6053
  { PseudoVLUXSEG2EI8_V_MF2_M4, VLUXSEG2EI8_V }, // 6054
  { PseudoVLUXSEG2EI8_V_MF2_M4_MASK, VLUXSEG2EI8_V }, // 6055
  { PseudoVLUXSEG2EI8_V_MF2_M4_TU, VLUXSEG2EI8_V }, // 6056
  { PseudoVLUXSEG2EI8_V_MF2_MF2, VLUXSEG2EI8_V }, // 6057
  { PseudoVLUXSEG2EI8_V_MF2_MF2_MASK, VLUXSEG2EI8_V }, // 6058
  { PseudoVLUXSEG2EI8_V_MF2_MF2_TU, VLUXSEG2EI8_V }, // 6059
  { PseudoVLUXSEG2EI8_V_MF4_M1, VLUXSEG2EI8_V }, // 6060
  { PseudoVLUXSEG2EI8_V_MF4_M1_MASK, VLUXSEG2EI8_V }, // 6061
  { PseudoVLUXSEG2EI8_V_MF4_M1_TU, VLUXSEG2EI8_V }, // 6062
  { PseudoVLUXSEG2EI8_V_MF4_M2, VLUXSEG2EI8_V }, // 6063
  { PseudoVLUXSEG2EI8_V_MF4_M2_MASK, VLUXSEG2EI8_V }, // 6064
  { PseudoVLUXSEG2EI8_V_MF4_M2_TU, VLUXSEG2EI8_V }, // 6065
  { PseudoVLUXSEG2EI8_V_MF4_MF2, VLUXSEG2EI8_V }, // 6066
  { PseudoVLUXSEG2EI8_V_MF4_MF2_MASK, VLUXSEG2EI8_V }, // 6067
  { PseudoVLUXSEG2EI8_V_MF4_MF2_TU, VLUXSEG2EI8_V }, // 6068
  { PseudoVLUXSEG2EI8_V_MF4_MF4, VLUXSEG2EI8_V }, // 6069
  { PseudoVLUXSEG2EI8_V_MF4_MF4_MASK, VLUXSEG2EI8_V }, // 6070
  { PseudoVLUXSEG2EI8_V_MF4_MF4_TU, VLUXSEG2EI8_V }, // 6071
  { PseudoVLUXSEG2EI8_V_MF8_M1, VLUXSEG2EI8_V }, // 6072
  { PseudoVLUXSEG2EI8_V_MF8_M1_MASK, VLUXSEG2EI8_V }, // 6073
  { PseudoVLUXSEG2EI8_V_MF8_M1_TU, VLUXSEG2EI8_V }, // 6074
  { PseudoVLUXSEG2EI8_V_MF8_MF2, VLUXSEG2EI8_V }, // 6075
  { PseudoVLUXSEG2EI8_V_MF8_MF2_MASK, VLUXSEG2EI8_V }, // 6076
  { PseudoVLUXSEG2EI8_V_MF8_MF2_TU, VLUXSEG2EI8_V }, // 6077
  { PseudoVLUXSEG2EI8_V_MF8_MF4, VLUXSEG2EI8_V }, // 6078
  { PseudoVLUXSEG2EI8_V_MF8_MF4_MASK, VLUXSEG2EI8_V }, // 6079
  { PseudoVLUXSEG2EI8_V_MF8_MF4_TU, VLUXSEG2EI8_V }, // 6080
  { PseudoVLUXSEG2EI8_V_MF8_MF8, VLUXSEG2EI8_V }, // 6081
  { PseudoVLUXSEG2EI8_V_MF8_MF8_MASK, VLUXSEG2EI8_V }, // 6082
  { PseudoVLUXSEG2EI8_V_MF8_MF8_TU, VLUXSEG2EI8_V }, // 6083
  { PseudoVLUXSEG3EI16_V_M1_M1, VLUXSEG3EI16_V }, // 6084
  { PseudoVLUXSEG3EI16_V_M1_M1_MASK, VLUXSEG3EI16_V }, // 6085
  { PseudoVLUXSEG3EI16_V_M1_M1_TU, VLUXSEG3EI16_V }, // 6086
  { PseudoVLUXSEG3EI16_V_M1_M2, VLUXSEG3EI16_V }, // 6087
  { PseudoVLUXSEG3EI16_V_M1_M2_MASK, VLUXSEG3EI16_V }, // 6088
  { PseudoVLUXSEG3EI16_V_M1_M2_TU, VLUXSEG3EI16_V }, // 6089
  { PseudoVLUXSEG3EI16_V_M1_MF2, VLUXSEG3EI16_V }, // 6090
  { PseudoVLUXSEG3EI16_V_M1_MF2_MASK, VLUXSEG3EI16_V }, // 6091
  { PseudoVLUXSEG3EI16_V_M1_MF2_TU, VLUXSEG3EI16_V }, // 6092
  { PseudoVLUXSEG3EI16_V_M2_M1, VLUXSEG3EI16_V }, // 6093
  { PseudoVLUXSEG3EI16_V_M2_M1_MASK, VLUXSEG3EI16_V }, // 6094
  { PseudoVLUXSEG3EI16_V_M2_M1_TU, VLUXSEG3EI16_V }, // 6095
  { PseudoVLUXSEG3EI16_V_M2_M2, VLUXSEG3EI16_V }, // 6096
  { PseudoVLUXSEG3EI16_V_M2_M2_MASK, VLUXSEG3EI16_V }, // 6097
  { PseudoVLUXSEG3EI16_V_M2_M2_TU, VLUXSEG3EI16_V }, // 6098
  { PseudoVLUXSEG3EI16_V_M4_M2, VLUXSEG3EI16_V }, // 6099
  { PseudoVLUXSEG3EI16_V_M4_M2_MASK, VLUXSEG3EI16_V }, // 6100
  { PseudoVLUXSEG3EI16_V_M4_M2_TU, VLUXSEG3EI16_V }, // 6101
  { PseudoVLUXSEG3EI16_V_MF2_M1, VLUXSEG3EI16_V }, // 6102
  { PseudoVLUXSEG3EI16_V_MF2_M1_MASK, VLUXSEG3EI16_V }, // 6103
  { PseudoVLUXSEG3EI16_V_MF2_M1_TU, VLUXSEG3EI16_V }, // 6104
  { PseudoVLUXSEG3EI16_V_MF2_M2, VLUXSEG3EI16_V }, // 6105
  { PseudoVLUXSEG3EI16_V_MF2_M2_MASK, VLUXSEG3EI16_V }, // 6106
  { PseudoVLUXSEG3EI16_V_MF2_M2_TU, VLUXSEG3EI16_V }, // 6107
  { PseudoVLUXSEG3EI16_V_MF2_MF2, VLUXSEG3EI16_V }, // 6108
  { PseudoVLUXSEG3EI16_V_MF2_MF2_MASK, VLUXSEG3EI16_V }, // 6109
  { PseudoVLUXSEG3EI16_V_MF2_MF2_TU, VLUXSEG3EI16_V }, // 6110
  { PseudoVLUXSEG3EI16_V_MF2_MF4, VLUXSEG3EI16_V }, // 6111
  { PseudoVLUXSEG3EI16_V_MF2_MF4_MASK, VLUXSEG3EI16_V }, // 6112
  { PseudoVLUXSEG3EI16_V_MF2_MF4_TU, VLUXSEG3EI16_V }, // 6113
  { PseudoVLUXSEG3EI16_V_MF4_M1, VLUXSEG3EI16_V }, // 6114
  { PseudoVLUXSEG3EI16_V_MF4_M1_MASK, VLUXSEG3EI16_V }, // 6115
  { PseudoVLUXSEG3EI16_V_MF4_M1_TU, VLUXSEG3EI16_V }, // 6116
  { PseudoVLUXSEG3EI16_V_MF4_MF2, VLUXSEG3EI16_V }, // 6117
  { PseudoVLUXSEG3EI16_V_MF4_MF2_MASK, VLUXSEG3EI16_V }, // 6118
  { PseudoVLUXSEG3EI16_V_MF4_MF2_TU, VLUXSEG3EI16_V }, // 6119
  { PseudoVLUXSEG3EI16_V_MF4_MF4, VLUXSEG3EI16_V }, // 6120
  { PseudoVLUXSEG3EI16_V_MF4_MF4_MASK, VLUXSEG3EI16_V }, // 6121
  { PseudoVLUXSEG3EI16_V_MF4_MF4_TU, VLUXSEG3EI16_V }, // 6122
  { PseudoVLUXSEG3EI16_V_MF4_MF8, VLUXSEG3EI16_V }, // 6123
  { PseudoVLUXSEG3EI16_V_MF4_MF8_MASK, VLUXSEG3EI16_V }, // 6124
  { PseudoVLUXSEG3EI16_V_MF4_MF8_TU, VLUXSEG3EI16_V }, // 6125
  { PseudoVLUXSEG3EI32_V_M1_M1, VLUXSEG3EI32_V }, // 6126
  { PseudoVLUXSEG3EI32_V_M1_M1_MASK, VLUXSEG3EI32_V }, // 6127
  { PseudoVLUXSEG3EI32_V_M1_M1_TU, VLUXSEG3EI32_V }, // 6128
  { PseudoVLUXSEG3EI32_V_M1_M2, VLUXSEG3EI32_V }, // 6129
  { PseudoVLUXSEG3EI32_V_M1_M2_MASK, VLUXSEG3EI32_V }, // 6130
  { PseudoVLUXSEG3EI32_V_M1_M2_TU, VLUXSEG3EI32_V }, // 6131
  { PseudoVLUXSEG3EI32_V_M1_MF2, VLUXSEG3EI32_V }, // 6132
  { PseudoVLUXSEG3EI32_V_M1_MF2_MASK, VLUXSEG3EI32_V }, // 6133
  { PseudoVLUXSEG3EI32_V_M1_MF2_TU, VLUXSEG3EI32_V }, // 6134
  { PseudoVLUXSEG3EI32_V_M1_MF4, VLUXSEG3EI32_V }, // 6135
  { PseudoVLUXSEG3EI32_V_M1_MF4_MASK, VLUXSEG3EI32_V }, // 6136
  { PseudoVLUXSEG3EI32_V_M1_MF4_TU, VLUXSEG3EI32_V }, // 6137
  { PseudoVLUXSEG3EI32_V_M2_M1, VLUXSEG3EI32_V }, // 6138
  { PseudoVLUXSEG3EI32_V_M2_M1_MASK, VLUXSEG3EI32_V }, // 6139
  { PseudoVLUXSEG3EI32_V_M2_M1_TU, VLUXSEG3EI32_V }, // 6140
  { PseudoVLUXSEG3EI32_V_M2_M2, VLUXSEG3EI32_V }, // 6141
  { PseudoVLUXSEG3EI32_V_M2_M2_MASK, VLUXSEG3EI32_V }, // 6142
  { PseudoVLUXSEG3EI32_V_M2_M2_TU, VLUXSEG3EI32_V }, // 6143
  { PseudoVLUXSEG3EI32_V_M2_MF2, VLUXSEG3EI32_V }, // 6144
  { PseudoVLUXSEG3EI32_V_M2_MF2_MASK, VLUXSEG3EI32_V }, // 6145
  { PseudoVLUXSEG3EI32_V_M2_MF2_TU, VLUXSEG3EI32_V }, // 6146
  { PseudoVLUXSEG3EI32_V_M4_M1, VLUXSEG3EI32_V }, // 6147
  { PseudoVLUXSEG3EI32_V_M4_M1_MASK, VLUXSEG3EI32_V }, // 6148
  { PseudoVLUXSEG3EI32_V_M4_M1_TU, VLUXSEG3EI32_V }, // 6149
  { PseudoVLUXSEG3EI32_V_M4_M2, VLUXSEG3EI32_V }, // 6150
  { PseudoVLUXSEG3EI32_V_M4_M2_MASK, VLUXSEG3EI32_V }, // 6151
  { PseudoVLUXSEG3EI32_V_M4_M2_TU, VLUXSEG3EI32_V }, // 6152
  { PseudoVLUXSEG3EI32_V_M8_M2, VLUXSEG3EI32_V }, // 6153
  { PseudoVLUXSEG3EI32_V_M8_M2_MASK, VLUXSEG3EI32_V }, // 6154
  { PseudoVLUXSEG3EI32_V_M8_M2_TU, VLUXSEG3EI32_V }, // 6155
  { PseudoVLUXSEG3EI32_V_MF2_M1, VLUXSEG3EI32_V }, // 6156
  { PseudoVLUXSEG3EI32_V_MF2_M1_MASK, VLUXSEG3EI32_V }, // 6157
  { PseudoVLUXSEG3EI32_V_MF2_M1_TU, VLUXSEG3EI32_V }, // 6158
  { PseudoVLUXSEG3EI32_V_MF2_MF2, VLUXSEG3EI32_V }, // 6159
  { PseudoVLUXSEG3EI32_V_MF2_MF2_MASK, VLUXSEG3EI32_V }, // 6160
  { PseudoVLUXSEG3EI32_V_MF2_MF2_TU, VLUXSEG3EI32_V }, // 6161
  { PseudoVLUXSEG3EI32_V_MF2_MF4, VLUXSEG3EI32_V }, // 6162
  { PseudoVLUXSEG3EI32_V_MF2_MF4_MASK, VLUXSEG3EI32_V }, // 6163
  { PseudoVLUXSEG3EI32_V_MF2_MF4_TU, VLUXSEG3EI32_V }, // 6164
  { PseudoVLUXSEG3EI32_V_MF2_MF8, VLUXSEG3EI32_V }, // 6165
  { PseudoVLUXSEG3EI32_V_MF2_MF8_MASK, VLUXSEG3EI32_V }, // 6166
  { PseudoVLUXSEG3EI32_V_MF2_MF8_TU, VLUXSEG3EI32_V }, // 6167
  { PseudoVLUXSEG3EI64_V_M1_M1, VLUXSEG3EI64_V }, // 6168
  { PseudoVLUXSEG3EI64_V_M1_M1_MASK, VLUXSEG3EI64_V }, // 6169
  { PseudoVLUXSEG3EI64_V_M1_M1_TU, VLUXSEG3EI64_V }, // 6170
  { PseudoVLUXSEG3EI64_V_M1_MF2, VLUXSEG3EI64_V }, // 6171
  { PseudoVLUXSEG3EI64_V_M1_MF2_MASK, VLUXSEG3EI64_V }, // 6172
  { PseudoVLUXSEG3EI64_V_M1_MF2_TU, VLUXSEG3EI64_V }, // 6173
  { PseudoVLUXSEG3EI64_V_M1_MF4, VLUXSEG3EI64_V }, // 6174
  { PseudoVLUXSEG3EI64_V_M1_MF4_MASK, VLUXSEG3EI64_V }, // 6175
  { PseudoVLUXSEG3EI64_V_M1_MF4_TU, VLUXSEG3EI64_V }, // 6176
  { PseudoVLUXSEG3EI64_V_M1_MF8, VLUXSEG3EI64_V }, // 6177
  { PseudoVLUXSEG3EI64_V_M1_MF8_MASK, VLUXSEG3EI64_V }, // 6178
  { PseudoVLUXSEG3EI64_V_M1_MF8_TU, VLUXSEG3EI64_V }, // 6179
  { PseudoVLUXSEG3EI64_V_M2_M1, VLUXSEG3EI64_V }, // 6180
  { PseudoVLUXSEG3EI64_V_M2_M1_MASK, VLUXSEG3EI64_V }, // 6181
  { PseudoVLUXSEG3EI64_V_M2_M1_TU, VLUXSEG3EI64_V }, // 6182
  { PseudoVLUXSEG3EI64_V_M2_M2, VLUXSEG3EI64_V }, // 6183
  { PseudoVLUXSEG3EI64_V_M2_M2_MASK, VLUXSEG3EI64_V }, // 6184
  { PseudoVLUXSEG3EI64_V_M2_M2_TU, VLUXSEG3EI64_V }, // 6185
  { PseudoVLUXSEG3EI64_V_M2_MF2, VLUXSEG3EI64_V }, // 6186
  { PseudoVLUXSEG3EI64_V_M2_MF2_MASK, VLUXSEG3EI64_V }, // 6187
  { PseudoVLUXSEG3EI64_V_M2_MF2_TU, VLUXSEG3EI64_V }, // 6188
  { PseudoVLUXSEG3EI64_V_M2_MF4, VLUXSEG3EI64_V }, // 6189
  { PseudoVLUXSEG3EI64_V_M2_MF4_MASK, VLUXSEG3EI64_V }, // 6190
  { PseudoVLUXSEG3EI64_V_M2_MF4_TU, VLUXSEG3EI64_V }, // 6191
  { PseudoVLUXSEG3EI64_V_M4_M1, VLUXSEG3EI64_V }, // 6192
  { PseudoVLUXSEG3EI64_V_M4_M1_MASK, VLUXSEG3EI64_V }, // 6193
  { PseudoVLUXSEG3EI64_V_M4_M1_TU, VLUXSEG3EI64_V }, // 6194
  { PseudoVLUXSEG3EI64_V_M4_M2, VLUXSEG3EI64_V }, // 6195
  { PseudoVLUXSEG3EI64_V_M4_M2_MASK, VLUXSEG3EI64_V }, // 6196
  { PseudoVLUXSEG3EI64_V_M4_M2_TU, VLUXSEG3EI64_V }, // 6197
  { PseudoVLUXSEG3EI64_V_M4_MF2, VLUXSEG3EI64_V }, // 6198
  { PseudoVLUXSEG3EI64_V_M4_MF2_MASK, VLUXSEG3EI64_V }, // 6199
  { PseudoVLUXSEG3EI64_V_M4_MF2_TU, VLUXSEG3EI64_V }, // 6200
  { PseudoVLUXSEG3EI64_V_M8_M1, VLUXSEG3EI64_V }, // 6201
  { PseudoVLUXSEG3EI64_V_M8_M1_MASK, VLUXSEG3EI64_V }, // 6202
  { PseudoVLUXSEG3EI64_V_M8_M1_TU, VLUXSEG3EI64_V }, // 6203
  { PseudoVLUXSEG3EI64_V_M8_M2, VLUXSEG3EI64_V }, // 6204
  { PseudoVLUXSEG3EI64_V_M8_M2_MASK, VLUXSEG3EI64_V }, // 6205
  { PseudoVLUXSEG3EI64_V_M8_M2_TU, VLUXSEG3EI64_V }, // 6206
  { PseudoVLUXSEG3EI8_V_M1_M1, VLUXSEG3EI8_V }, // 6207
  { PseudoVLUXSEG3EI8_V_M1_M1_MASK, VLUXSEG3EI8_V }, // 6208
  { PseudoVLUXSEG3EI8_V_M1_M1_TU, VLUXSEG3EI8_V }, // 6209
  { PseudoVLUXSEG3EI8_V_M1_M2, VLUXSEG3EI8_V }, // 6210
  { PseudoVLUXSEG3EI8_V_M1_M2_MASK, VLUXSEG3EI8_V }, // 6211
  { PseudoVLUXSEG3EI8_V_M1_M2_TU, VLUXSEG3EI8_V }, // 6212
  { PseudoVLUXSEG3EI8_V_M2_M2, VLUXSEG3EI8_V }, // 6213
  { PseudoVLUXSEG3EI8_V_M2_M2_MASK, VLUXSEG3EI8_V }, // 6214
  { PseudoVLUXSEG3EI8_V_M2_M2_TU, VLUXSEG3EI8_V }, // 6215
  { PseudoVLUXSEG3EI8_V_MF2_M1, VLUXSEG3EI8_V }, // 6216
  { PseudoVLUXSEG3EI8_V_MF2_M1_MASK, VLUXSEG3EI8_V }, // 6217
  { PseudoVLUXSEG3EI8_V_MF2_M1_TU, VLUXSEG3EI8_V }, // 6218
  { PseudoVLUXSEG3EI8_V_MF2_M2, VLUXSEG3EI8_V }, // 6219
  { PseudoVLUXSEG3EI8_V_MF2_M2_MASK, VLUXSEG3EI8_V }, // 6220
  { PseudoVLUXSEG3EI8_V_MF2_M2_TU, VLUXSEG3EI8_V }, // 6221
  { PseudoVLUXSEG3EI8_V_MF2_MF2, VLUXSEG3EI8_V }, // 6222
  { PseudoVLUXSEG3EI8_V_MF2_MF2_MASK, VLUXSEG3EI8_V }, // 6223
  { PseudoVLUXSEG3EI8_V_MF2_MF2_TU, VLUXSEG3EI8_V }, // 6224
  { PseudoVLUXSEG3EI8_V_MF4_M1, VLUXSEG3EI8_V }, // 6225
  { PseudoVLUXSEG3EI8_V_MF4_M1_MASK, VLUXSEG3EI8_V }, // 6226
  { PseudoVLUXSEG3EI8_V_MF4_M1_TU, VLUXSEG3EI8_V }, // 6227
  { PseudoVLUXSEG3EI8_V_MF4_M2, VLUXSEG3EI8_V }, // 6228
  { PseudoVLUXSEG3EI8_V_MF4_M2_MASK, VLUXSEG3EI8_V }, // 6229
  { PseudoVLUXSEG3EI8_V_MF4_M2_TU, VLUXSEG3EI8_V }, // 6230
  { PseudoVLUXSEG3EI8_V_MF4_MF2, VLUXSEG3EI8_V }, // 6231
  { PseudoVLUXSEG3EI8_V_MF4_MF2_MASK, VLUXSEG3EI8_V }, // 6232
  { PseudoVLUXSEG3EI8_V_MF4_MF2_TU, VLUXSEG3EI8_V }, // 6233
  { PseudoVLUXSEG3EI8_V_MF4_MF4, VLUXSEG3EI8_V }, // 6234
  { PseudoVLUXSEG3EI8_V_MF4_MF4_MASK, VLUXSEG3EI8_V }, // 6235
  { PseudoVLUXSEG3EI8_V_MF4_MF4_TU, VLUXSEG3EI8_V }, // 6236
  { PseudoVLUXSEG3EI8_V_MF8_M1, VLUXSEG3EI8_V }, // 6237
  { PseudoVLUXSEG3EI8_V_MF8_M1_MASK, VLUXSEG3EI8_V }, // 6238
  { PseudoVLUXSEG3EI8_V_MF8_M1_TU, VLUXSEG3EI8_V }, // 6239
  { PseudoVLUXSEG3EI8_V_MF8_MF2, VLUXSEG3EI8_V }, // 6240
  { PseudoVLUXSEG3EI8_V_MF8_MF2_MASK, VLUXSEG3EI8_V }, // 6241
  { PseudoVLUXSEG3EI8_V_MF8_MF2_TU, VLUXSEG3EI8_V }, // 6242
  { PseudoVLUXSEG3EI8_V_MF8_MF4, VLUXSEG3EI8_V }, // 6243
  { PseudoVLUXSEG3EI8_V_MF8_MF4_MASK, VLUXSEG3EI8_V }, // 6244
  { PseudoVLUXSEG3EI8_V_MF8_MF4_TU, VLUXSEG3EI8_V }, // 6245
  { PseudoVLUXSEG3EI8_V_MF8_MF8, VLUXSEG3EI8_V }, // 6246
  { PseudoVLUXSEG3EI8_V_MF8_MF8_MASK, VLUXSEG3EI8_V }, // 6247
  { PseudoVLUXSEG3EI8_V_MF8_MF8_TU, VLUXSEG3EI8_V }, // 6248
  { PseudoVLUXSEG4EI16_V_M1_M1, VLUXSEG4EI16_V }, // 6249
  { PseudoVLUXSEG4EI16_V_M1_M1_MASK, VLUXSEG4EI16_V }, // 6250
  { PseudoVLUXSEG4EI16_V_M1_M1_TU, VLUXSEG4EI16_V }, // 6251
  { PseudoVLUXSEG4EI16_V_M1_M2, VLUXSEG4EI16_V }, // 6252
  { PseudoVLUXSEG4EI16_V_M1_M2_MASK, VLUXSEG4EI16_V }, // 6253
  { PseudoVLUXSEG4EI16_V_M1_M2_TU, VLUXSEG4EI16_V }, // 6254
  { PseudoVLUXSEG4EI16_V_M1_MF2, VLUXSEG4EI16_V }, // 6255
  { PseudoVLUXSEG4EI16_V_M1_MF2_MASK, VLUXSEG4EI16_V }, // 6256
  { PseudoVLUXSEG4EI16_V_M1_MF2_TU, VLUXSEG4EI16_V }, // 6257
  { PseudoVLUXSEG4EI16_V_M2_M1, VLUXSEG4EI16_V }, // 6258
  { PseudoVLUXSEG4EI16_V_M2_M1_MASK, VLUXSEG4EI16_V }, // 6259
  { PseudoVLUXSEG4EI16_V_M2_M1_TU, VLUXSEG4EI16_V }, // 6260
  { PseudoVLUXSEG4EI16_V_M2_M2, VLUXSEG4EI16_V }, // 6261
  { PseudoVLUXSEG4EI16_V_M2_M2_MASK, VLUXSEG4EI16_V }, // 6262
  { PseudoVLUXSEG4EI16_V_M2_M2_TU, VLUXSEG4EI16_V }, // 6263
  { PseudoVLUXSEG4EI16_V_M4_M2, VLUXSEG4EI16_V }, // 6264
  { PseudoVLUXSEG4EI16_V_M4_M2_MASK, VLUXSEG4EI16_V }, // 6265
  { PseudoVLUXSEG4EI16_V_M4_M2_TU, VLUXSEG4EI16_V }, // 6266
  { PseudoVLUXSEG4EI16_V_MF2_M1, VLUXSEG4EI16_V }, // 6267
  { PseudoVLUXSEG4EI16_V_MF2_M1_MASK, VLUXSEG4EI16_V }, // 6268
  { PseudoVLUXSEG4EI16_V_MF2_M1_TU, VLUXSEG4EI16_V }, // 6269
  { PseudoVLUXSEG4EI16_V_MF2_M2, VLUXSEG4EI16_V }, // 6270
  { PseudoVLUXSEG4EI16_V_MF2_M2_MASK, VLUXSEG4EI16_V }, // 6271
  { PseudoVLUXSEG4EI16_V_MF2_M2_TU, VLUXSEG4EI16_V }, // 6272
  { PseudoVLUXSEG4EI16_V_MF2_MF2, VLUXSEG4EI16_V }, // 6273
  { PseudoVLUXSEG4EI16_V_MF2_MF2_MASK, VLUXSEG4EI16_V }, // 6274
  { PseudoVLUXSEG4EI16_V_MF2_MF2_TU, VLUXSEG4EI16_V }, // 6275
  { PseudoVLUXSEG4EI16_V_MF2_MF4, VLUXSEG4EI16_V }, // 6276
  { PseudoVLUXSEG4EI16_V_MF2_MF4_MASK, VLUXSEG4EI16_V }, // 6277
  { PseudoVLUXSEG4EI16_V_MF2_MF4_TU, VLUXSEG4EI16_V }, // 6278
  { PseudoVLUXSEG4EI16_V_MF4_M1, VLUXSEG4EI16_V }, // 6279
  { PseudoVLUXSEG4EI16_V_MF4_M1_MASK, VLUXSEG4EI16_V }, // 6280
  { PseudoVLUXSEG4EI16_V_MF4_M1_TU, VLUXSEG4EI16_V }, // 6281
  { PseudoVLUXSEG4EI16_V_MF4_MF2, VLUXSEG4EI16_V }, // 6282
  { PseudoVLUXSEG4EI16_V_MF4_MF2_MASK, VLUXSEG4EI16_V }, // 6283
  { PseudoVLUXSEG4EI16_V_MF4_MF2_TU, VLUXSEG4EI16_V }, // 6284
  { PseudoVLUXSEG4EI16_V_MF4_MF4, VLUXSEG4EI16_V }, // 6285
  { PseudoVLUXSEG4EI16_V_MF4_MF4_MASK, VLUXSEG4EI16_V }, // 6286
  { PseudoVLUXSEG4EI16_V_MF4_MF4_TU, VLUXSEG4EI16_V }, // 6287
  { PseudoVLUXSEG4EI16_V_MF4_MF8, VLUXSEG4EI16_V }, // 6288
  { PseudoVLUXSEG4EI16_V_MF4_MF8_MASK, VLUXSEG4EI16_V }, // 6289
  { PseudoVLUXSEG4EI16_V_MF4_MF8_TU, VLUXSEG4EI16_V }, // 6290
  { PseudoVLUXSEG4EI32_V_M1_M1, VLUXSEG4EI32_V }, // 6291
  { PseudoVLUXSEG4EI32_V_M1_M1_MASK, VLUXSEG4EI32_V }, // 6292
  { PseudoVLUXSEG4EI32_V_M1_M1_TU, VLUXSEG4EI32_V }, // 6293
  { PseudoVLUXSEG4EI32_V_M1_M2, VLUXSEG4EI32_V }, // 6294
  { PseudoVLUXSEG4EI32_V_M1_M2_MASK, VLUXSEG4EI32_V }, // 6295
  { PseudoVLUXSEG4EI32_V_M1_M2_TU, VLUXSEG4EI32_V }, // 6296
  { PseudoVLUXSEG4EI32_V_M1_MF2, VLUXSEG4EI32_V }, // 6297
  { PseudoVLUXSEG4EI32_V_M1_MF2_MASK, VLUXSEG4EI32_V }, // 6298
  { PseudoVLUXSEG4EI32_V_M1_MF2_TU, VLUXSEG4EI32_V }, // 6299
  { PseudoVLUXSEG4EI32_V_M1_MF4, VLUXSEG4EI32_V }, // 6300
  { PseudoVLUXSEG4EI32_V_M1_MF4_MASK, VLUXSEG4EI32_V }, // 6301
  { PseudoVLUXSEG4EI32_V_M1_MF4_TU, VLUXSEG4EI32_V }, // 6302
  { PseudoVLUXSEG4EI32_V_M2_M1, VLUXSEG4EI32_V }, // 6303
  { PseudoVLUXSEG4EI32_V_M2_M1_MASK, VLUXSEG4EI32_V }, // 6304
  { PseudoVLUXSEG4EI32_V_M2_M1_TU, VLUXSEG4EI32_V }, // 6305
  { PseudoVLUXSEG4EI32_V_M2_M2, VLUXSEG4EI32_V }, // 6306
  { PseudoVLUXSEG4EI32_V_M2_M2_MASK, VLUXSEG4EI32_V }, // 6307
  { PseudoVLUXSEG4EI32_V_M2_M2_TU, VLUXSEG4EI32_V }, // 6308
  { PseudoVLUXSEG4EI32_V_M2_MF2, VLUXSEG4EI32_V }, // 6309
  { PseudoVLUXSEG4EI32_V_M2_MF2_MASK, VLUXSEG4EI32_V }, // 6310
  { PseudoVLUXSEG4EI32_V_M2_MF2_TU, VLUXSEG4EI32_V }, // 6311
  { PseudoVLUXSEG4EI32_V_M4_M1, VLUXSEG4EI32_V }, // 6312
  { PseudoVLUXSEG4EI32_V_M4_M1_MASK, VLUXSEG4EI32_V }, // 6313
  { PseudoVLUXSEG4EI32_V_M4_M1_TU, VLUXSEG4EI32_V }, // 6314
  { PseudoVLUXSEG4EI32_V_M4_M2, VLUXSEG4EI32_V }, // 6315
  { PseudoVLUXSEG4EI32_V_M4_M2_MASK, VLUXSEG4EI32_V }, // 6316
  { PseudoVLUXSEG4EI32_V_M4_M2_TU, VLUXSEG4EI32_V }, // 6317
  { PseudoVLUXSEG4EI32_V_M8_M2, VLUXSEG4EI32_V }, // 6318
  { PseudoVLUXSEG4EI32_V_M8_M2_MASK, VLUXSEG4EI32_V }, // 6319
  { PseudoVLUXSEG4EI32_V_M8_M2_TU, VLUXSEG4EI32_V }, // 6320
  { PseudoVLUXSEG4EI32_V_MF2_M1, VLUXSEG4EI32_V }, // 6321
  { PseudoVLUXSEG4EI32_V_MF2_M1_MASK, VLUXSEG4EI32_V }, // 6322
  { PseudoVLUXSEG4EI32_V_MF2_M1_TU, VLUXSEG4EI32_V }, // 6323
  { PseudoVLUXSEG4EI32_V_MF2_MF2, VLUXSEG4EI32_V }, // 6324
  { PseudoVLUXSEG4EI32_V_MF2_MF2_MASK, VLUXSEG4EI32_V }, // 6325
  { PseudoVLUXSEG4EI32_V_MF2_MF2_TU, VLUXSEG4EI32_V }, // 6326
  { PseudoVLUXSEG4EI32_V_MF2_MF4, VLUXSEG4EI32_V }, // 6327
  { PseudoVLUXSEG4EI32_V_MF2_MF4_MASK, VLUXSEG4EI32_V }, // 6328
  { PseudoVLUXSEG4EI32_V_MF2_MF4_TU, VLUXSEG4EI32_V }, // 6329
  { PseudoVLUXSEG4EI32_V_MF2_MF8, VLUXSEG4EI32_V }, // 6330
  { PseudoVLUXSEG4EI32_V_MF2_MF8_MASK, VLUXSEG4EI32_V }, // 6331
  { PseudoVLUXSEG4EI32_V_MF2_MF8_TU, VLUXSEG4EI32_V }, // 6332
  { PseudoVLUXSEG4EI64_V_M1_M1, VLUXSEG4EI64_V }, // 6333
  { PseudoVLUXSEG4EI64_V_M1_M1_MASK, VLUXSEG4EI64_V }, // 6334
  { PseudoVLUXSEG4EI64_V_M1_M1_TU, VLUXSEG4EI64_V }, // 6335
  { PseudoVLUXSEG4EI64_V_M1_MF2, VLUXSEG4EI64_V }, // 6336
  { PseudoVLUXSEG4EI64_V_M1_MF2_MASK, VLUXSEG4EI64_V }, // 6337
  { PseudoVLUXSEG4EI64_V_M1_MF2_TU, VLUXSEG4EI64_V }, // 6338
  { PseudoVLUXSEG4EI64_V_M1_MF4, VLUXSEG4EI64_V }, // 6339
  { PseudoVLUXSEG4EI64_V_M1_MF4_MASK, VLUXSEG4EI64_V }, // 6340
  { PseudoVLUXSEG4EI64_V_M1_MF4_TU, VLUXSEG4EI64_V }, // 6341
  { PseudoVLUXSEG4EI64_V_M1_MF8, VLUXSEG4EI64_V }, // 6342
  { PseudoVLUXSEG4EI64_V_M1_MF8_MASK, VLUXSEG4EI64_V }, // 6343
  { PseudoVLUXSEG4EI64_V_M1_MF8_TU, VLUXSEG4EI64_V }, // 6344
  { PseudoVLUXSEG4EI64_V_M2_M1, VLUXSEG4EI64_V }, // 6345
  { PseudoVLUXSEG4EI64_V_M2_M1_MASK, VLUXSEG4EI64_V }, // 6346
  { PseudoVLUXSEG4EI64_V_M2_M1_TU, VLUXSEG4EI64_V }, // 6347
  { PseudoVLUXSEG4EI64_V_M2_M2, VLUXSEG4EI64_V }, // 6348
  { PseudoVLUXSEG4EI64_V_M2_M2_MASK, VLUXSEG4EI64_V }, // 6349
  { PseudoVLUXSEG4EI64_V_M2_M2_TU, VLUXSEG4EI64_V }, // 6350
  { PseudoVLUXSEG4EI64_V_M2_MF2, VLUXSEG4EI64_V }, // 6351
  { PseudoVLUXSEG4EI64_V_M2_MF2_MASK, VLUXSEG4EI64_V }, // 6352
  { PseudoVLUXSEG4EI64_V_M2_MF2_TU, VLUXSEG4EI64_V }, // 6353
  { PseudoVLUXSEG4EI64_V_M2_MF4, VLUXSEG4EI64_V }, // 6354
  { PseudoVLUXSEG4EI64_V_M2_MF4_MASK, VLUXSEG4EI64_V }, // 6355
  { PseudoVLUXSEG4EI64_V_M2_MF4_TU, VLUXSEG4EI64_V }, // 6356
  { PseudoVLUXSEG4EI64_V_M4_M1, VLUXSEG4EI64_V }, // 6357
  { PseudoVLUXSEG4EI64_V_M4_M1_MASK, VLUXSEG4EI64_V }, // 6358
  { PseudoVLUXSEG4EI64_V_M4_M1_TU, VLUXSEG4EI64_V }, // 6359
  { PseudoVLUXSEG4EI64_V_M4_M2, VLUXSEG4EI64_V }, // 6360
  { PseudoVLUXSEG4EI64_V_M4_M2_MASK, VLUXSEG4EI64_V }, // 6361
  { PseudoVLUXSEG4EI64_V_M4_M2_TU, VLUXSEG4EI64_V }, // 6362
  { PseudoVLUXSEG4EI64_V_M4_MF2, VLUXSEG4EI64_V }, // 6363
  { PseudoVLUXSEG4EI64_V_M4_MF2_MASK, VLUXSEG4EI64_V }, // 6364
  { PseudoVLUXSEG4EI64_V_M4_MF2_TU, VLUXSEG4EI64_V }, // 6365
  { PseudoVLUXSEG4EI64_V_M8_M1, VLUXSEG4EI64_V }, // 6366
  { PseudoVLUXSEG4EI64_V_M8_M1_MASK, VLUXSEG4EI64_V }, // 6367
  { PseudoVLUXSEG4EI64_V_M8_M1_TU, VLUXSEG4EI64_V }, // 6368
  { PseudoVLUXSEG4EI64_V_M8_M2, VLUXSEG4EI64_V }, // 6369
  { PseudoVLUXSEG4EI64_V_M8_M2_MASK, VLUXSEG4EI64_V }, // 6370
  { PseudoVLUXSEG4EI64_V_M8_M2_TU, VLUXSEG4EI64_V }, // 6371
  { PseudoVLUXSEG4EI8_V_M1_M1, VLUXSEG4EI8_V }, // 6372
  { PseudoVLUXSEG4EI8_V_M1_M1_MASK, VLUXSEG4EI8_V }, // 6373
  { PseudoVLUXSEG4EI8_V_M1_M1_TU, VLUXSEG4EI8_V }, // 6374
  { PseudoVLUXSEG4EI8_V_M1_M2, VLUXSEG4EI8_V }, // 6375
  { PseudoVLUXSEG4EI8_V_M1_M2_MASK, VLUXSEG4EI8_V }, // 6376
  { PseudoVLUXSEG4EI8_V_M1_M2_TU, VLUXSEG4EI8_V }, // 6377
  { PseudoVLUXSEG4EI8_V_M2_M2, VLUXSEG4EI8_V }, // 6378
  { PseudoVLUXSEG4EI8_V_M2_M2_MASK, VLUXSEG4EI8_V }, // 6379
  { PseudoVLUXSEG4EI8_V_M2_M2_TU, VLUXSEG4EI8_V }, // 6380
  { PseudoVLUXSEG4EI8_V_MF2_M1, VLUXSEG4EI8_V }, // 6381
  { PseudoVLUXSEG4EI8_V_MF2_M1_MASK, VLUXSEG4EI8_V }, // 6382
  { PseudoVLUXSEG4EI8_V_MF2_M1_TU, VLUXSEG4EI8_V }, // 6383
  { PseudoVLUXSEG4EI8_V_MF2_M2, VLUXSEG4EI8_V }, // 6384
  { PseudoVLUXSEG4EI8_V_MF2_M2_MASK, VLUXSEG4EI8_V }, // 6385
  { PseudoVLUXSEG4EI8_V_MF2_M2_TU, VLUXSEG4EI8_V }, // 6386
  { PseudoVLUXSEG4EI8_V_MF2_MF2, VLUXSEG4EI8_V }, // 6387
  { PseudoVLUXSEG4EI8_V_MF2_MF2_MASK, VLUXSEG4EI8_V }, // 6388
  { PseudoVLUXSEG4EI8_V_MF2_MF2_TU, VLUXSEG4EI8_V }, // 6389
  { PseudoVLUXSEG4EI8_V_MF4_M1, VLUXSEG4EI8_V }, // 6390
  { PseudoVLUXSEG4EI8_V_MF4_M1_MASK, VLUXSEG4EI8_V }, // 6391
  { PseudoVLUXSEG4EI8_V_MF4_M1_TU, VLUXSEG4EI8_V }, // 6392
  { PseudoVLUXSEG4EI8_V_MF4_M2, VLUXSEG4EI8_V }, // 6393
  { PseudoVLUXSEG4EI8_V_MF4_M2_MASK, VLUXSEG4EI8_V }, // 6394
  { PseudoVLUXSEG4EI8_V_MF4_M2_TU, VLUXSEG4EI8_V }, // 6395
  { PseudoVLUXSEG4EI8_V_MF4_MF2, VLUXSEG4EI8_V }, // 6396
  { PseudoVLUXSEG4EI8_V_MF4_MF2_MASK, VLUXSEG4EI8_V }, // 6397
  { PseudoVLUXSEG4EI8_V_MF4_MF2_TU, VLUXSEG4EI8_V }, // 6398
  { PseudoVLUXSEG4EI8_V_MF4_MF4, VLUXSEG4EI8_V }, // 6399
  { PseudoVLUXSEG4EI8_V_MF4_MF4_MASK, VLUXSEG4EI8_V }, // 6400
  { PseudoVLUXSEG4EI8_V_MF4_MF4_TU, VLUXSEG4EI8_V }, // 6401
  { PseudoVLUXSEG4EI8_V_MF8_M1, VLUXSEG4EI8_V }, // 6402
  { PseudoVLUXSEG4EI8_V_MF8_M1_MASK, VLUXSEG4EI8_V }, // 6403
  { PseudoVLUXSEG4EI8_V_MF8_M1_TU, VLUXSEG4EI8_V }, // 6404
  { PseudoVLUXSEG4EI8_V_MF8_MF2, VLUXSEG4EI8_V }, // 6405
  { PseudoVLUXSEG4EI8_V_MF8_MF2_MASK, VLUXSEG4EI8_V }, // 6406
  { PseudoVLUXSEG4EI8_V_MF8_MF2_TU, VLUXSEG4EI8_V }, // 6407
  { PseudoVLUXSEG4EI8_V_MF8_MF4, VLUXSEG4EI8_V }, // 6408
  { PseudoVLUXSEG4EI8_V_MF8_MF4_MASK, VLUXSEG4EI8_V }, // 6409
  { PseudoVLUXSEG4EI8_V_MF8_MF4_TU, VLUXSEG4EI8_V }, // 6410
  { PseudoVLUXSEG4EI8_V_MF8_MF8, VLUXSEG4EI8_V }, // 6411
  { PseudoVLUXSEG4EI8_V_MF8_MF8_MASK, VLUXSEG4EI8_V }, // 6412
  { PseudoVLUXSEG4EI8_V_MF8_MF8_TU, VLUXSEG4EI8_V }, // 6413
  { PseudoVLUXSEG5EI16_V_M1_M1, VLUXSEG5EI16_V }, // 6414
  { PseudoVLUXSEG5EI16_V_M1_M1_MASK, VLUXSEG5EI16_V }, // 6415
  { PseudoVLUXSEG5EI16_V_M1_M1_TU, VLUXSEG5EI16_V }, // 6416
  { PseudoVLUXSEG5EI16_V_M1_MF2, VLUXSEG5EI16_V }, // 6417
  { PseudoVLUXSEG5EI16_V_M1_MF2_MASK, VLUXSEG5EI16_V }, // 6418
  { PseudoVLUXSEG5EI16_V_M1_MF2_TU, VLUXSEG5EI16_V }, // 6419
  { PseudoVLUXSEG5EI16_V_M2_M1, VLUXSEG5EI16_V }, // 6420
  { PseudoVLUXSEG5EI16_V_M2_M1_MASK, VLUXSEG5EI16_V }, // 6421
  { PseudoVLUXSEG5EI16_V_M2_M1_TU, VLUXSEG5EI16_V }, // 6422
  { PseudoVLUXSEG5EI16_V_MF2_M1, VLUXSEG5EI16_V }, // 6423
  { PseudoVLUXSEG5EI16_V_MF2_M1_MASK, VLUXSEG5EI16_V }, // 6424
  { PseudoVLUXSEG5EI16_V_MF2_M1_TU, VLUXSEG5EI16_V }, // 6425
  { PseudoVLUXSEG5EI16_V_MF2_MF2, VLUXSEG5EI16_V }, // 6426
  { PseudoVLUXSEG5EI16_V_MF2_MF2_MASK, VLUXSEG5EI16_V }, // 6427
  { PseudoVLUXSEG5EI16_V_MF2_MF2_TU, VLUXSEG5EI16_V }, // 6428
  { PseudoVLUXSEG5EI16_V_MF2_MF4, VLUXSEG5EI16_V }, // 6429
  { PseudoVLUXSEG5EI16_V_MF2_MF4_MASK, VLUXSEG5EI16_V }, // 6430
  { PseudoVLUXSEG5EI16_V_MF2_MF4_TU, VLUXSEG5EI16_V }, // 6431
  { PseudoVLUXSEG5EI16_V_MF4_M1, VLUXSEG5EI16_V }, // 6432
  { PseudoVLUXSEG5EI16_V_MF4_M1_MASK, VLUXSEG5EI16_V }, // 6433
  { PseudoVLUXSEG5EI16_V_MF4_M1_TU, VLUXSEG5EI16_V }, // 6434
  { PseudoVLUXSEG5EI16_V_MF4_MF2, VLUXSEG5EI16_V }, // 6435
  { PseudoVLUXSEG5EI16_V_MF4_MF2_MASK, VLUXSEG5EI16_V }, // 6436
  { PseudoVLUXSEG5EI16_V_MF4_MF2_TU, VLUXSEG5EI16_V }, // 6437
  { PseudoVLUXSEG5EI16_V_MF4_MF4, VLUXSEG5EI16_V }, // 6438
  { PseudoVLUXSEG5EI16_V_MF4_MF4_MASK, VLUXSEG5EI16_V }, // 6439
  { PseudoVLUXSEG5EI16_V_MF4_MF4_TU, VLUXSEG5EI16_V }, // 6440
  { PseudoVLUXSEG5EI16_V_MF4_MF8, VLUXSEG5EI16_V }, // 6441
  { PseudoVLUXSEG5EI16_V_MF4_MF8_MASK, VLUXSEG5EI16_V }, // 6442
  { PseudoVLUXSEG5EI16_V_MF4_MF8_TU, VLUXSEG5EI16_V }, // 6443
  { PseudoVLUXSEG5EI32_V_M1_M1, VLUXSEG5EI32_V }, // 6444
  { PseudoVLUXSEG5EI32_V_M1_M1_MASK, VLUXSEG5EI32_V }, // 6445
  { PseudoVLUXSEG5EI32_V_M1_M1_TU, VLUXSEG5EI32_V }, // 6446
  { PseudoVLUXSEG5EI32_V_M1_MF2, VLUXSEG5EI32_V }, // 6447
  { PseudoVLUXSEG5EI32_V_M1_MF2_MASK, VLUXSEG5EI32_V }, // 6448
  { PseudoVLUXSEG5EI32_V_M1_MF2_TU, VLUXSEG5EI32_V }, // 6449
  { PseudoVLUXSEG5EI32_V_M1_MF4, VLUXSEG5EI32_V }, // 6450
  { PseudoVLUXSEG5EI32_V_M1_MF4_MASK, VLUXSEG5EI32_V }, // 6451
  { PseudoVLUXSEG5EI32_V_M1_MF4_TU, VLUXSEG5EI32_V }, // 6452
  { PseudoVLUXSEG5EI32_V_M2_M1, VLUXSEG5EI32_V }, // 6453
  { PseudoVLUXSEG5EI32_V_M2_M1_MASK, VLUXSEG5EI32_V }, // 6454
  { PseudoVLUXSEG5EI32_V_M2_M1_TU, VLUXSEG5EI32_V }, // 6455
  { PseudoVLUXSEG5EI32_V_M2_MF2, VLUXSEG5EI32_V }, // 6456
  { PseudoVLUXSEG5EI32_V_M2_MF2_MASK, VLUXSEG5EI32_V }, // 6457
  { PseudoVLUXSEG5EI32_V_M2_MF2_TU, VLUXSEG5EI32_V }, // 6458
  { PseudoVLUXSEG5EI32_V_M4_M1, VLUXSEG5EI32_V }, // 6459
  { PseudoVLUXSEG5EI32_V_M4_M1_MASK, VLUXSEG5EI32_V }, // 6460
  { PseudoVLUXSEG5EI32_V_M4_M1_TU, VLUXSEG5EI32_V }, // 6461
  { PseudoVLUXSEG5EI32_V_MF2_M1, VLUXSEG5EI32_V }, // 6462
  { PseudoVLUXSEG5EI32_V_MF2_M1_MASK, VLUXSEG5EI32_V }, // 6463
  { PseudoVLUXSEG5EI32_V_MF2_M1_TU, VLUXSEG5EI32_V }, // 6464
  { PseudoVLUXSEG5EI32_V_MF2_MF2, VLUXSEG5EI32_V }, // 6465
  { PseudoVLUXSEG5EI32_V_MF2_MF2_MASK, VLUXSEG5EI32_V }, // 6466
  { PseudoVLUXSEG5EI32_V_MF2_MF2_TU, VLUXSEG5EI32_V }, // 6467
  { PseudoVLUXSEG5EI32_V_MF2_MF4, VLUXSEG5EI32_V }, // 6468
  { PseudoVLUXSEG5EI32_V_MF2_MF4_MASK, VLUXSEG5EI32_V }, // 6469
  { PseudoVLUXSEG5EI32_V_MF2_MF4_TU, VLUXSEG5EI32_V }, // 6470
  { PseudoVLUXSEG5EI32_V_MF2_MF8, VLUXSEG5EI32_V }, // 6471
  { PseudoVLUXSEG5EI32_V_MF2_MF8_MASK, VLUXSEG5EI32_V }, // 6472
  { PseudoVLUXSEG5EI32_V_MF2_MF8_TU, VLUXSEG5EI32_V }, // 6473
  { PseudoVLUXSEG5EI64_V_M1_M1, VLUXSEG5EI64_V }, // 6474
  { PseudoVLUXSEG5EI64_V_M1_M1_MASK, VLUXSEG5EI64_V }, // 6475
  { PseudoVLUXSEG5EI64_V_M1_M1_TU, VLUXSEG5EI64_V }, // 6476
  { PseudoVLUXSEG5EI64_V_M1_MF2, VLUXSEG5EI64_V }, // 6477
  { PseudoVLUXSEG5EI64_V_M1_MF2_MASK, VLUXSEG5EI64_V }, // 6478
  { PseudoVLUXSEG5EI64_V_M1_MF2_TU, VLUXSEG5EI64_V }, // 6479
  { PseudoVLUXSEG5EI64_V_M1_MF4, VLUXSEG5EI64_V }, // 6480
  { PseudoVLUXSEG5EI64_V_M1_MF4_MASK, VLUXSEG5EI64_V }, // 6481
  { PseudoVLUXSEG5EI64_V_M1_MF4_TU, VLUXSEG5EI64_V }, // 6482
  { PseudoVLUXSEG5EI64_V_M1_MF8, VLUXSEG5EI64_V }, // 6483
  { PseudoVLUXSEG5EI64_V_M1_MF8_MASK, VLUXSEG5EI64_V }, // 6484
  { PseudoVLUXSEG5EI64_V_M1_MF8_TU, VLUXSEG5EI64_V }, // 6485
  { PseudoVLUXSEG5EI64_V_M2_M1, VLUXSEG5EI64_V }, // 6486
  { PseudoVLUXSEG5EI64_V_M2_M1_MASK, VLUXSEG5EI64_V }, // 6487
  { PseudoVLUXSEG5EI64_V_M2_M1_TU, VLUXSEG5EI64_V }, // 6488
  { PseudoVLUXSEG5EI64_V_M2_MF2, VLUXSEG5EI64_V }, // 6489
  { PseudoVLUXSEG5EI64_V_M2_MF2_MASK, VLUXSEG5EI64_V }, // 6490
  { PseudoVLUXSEG5EI64_V_M2_MF2_TU, VLUXSEG5EI64_V }, // 6491
  { PseudoVLUXSEG5EI64_V_M2_MF4, VLUXSEG5EI64_V }, // 6492
  { PseudoVLUXSEG5EI64_V_M2_MF4_MASK, VLUXSEG5EI64_V }, // 6493
  { PseudoVLUXSEG5EI64_V_M2_MF4_TU, VLUXSEG5EI64_V }, // 6494
  { PseudoVLUXSEG5EI64_V_M4_M1, VLUXSEG5EI64_V }, // 6495
  { PseudoVLUXSEG5EI64_V_M4_M1_MASK, VLUXSEG5EI64_V }, // 6496
  { PseudoVLUXSEG5EI64_V_M4_M1_TU, VLUXSEG5EI64_V }, // 6497
  { PseudoVLUXSEG5EI64_V_M4_MF2, VLUXSEG5EI64_V }, // 6498
  { PseudoVLUXSEG5EI64_V_M4_MF2_MASK, VLUXSEG5EI64_V }, // 6499
  { PseudoVLUXSEG5EI64_V_M4_MF2_TU, VLUXSEG5EI64_V }, // 6500
  { PseudoVLUXSEG5EI64_V_M8_M1, VLUXSEG5EI64_V }, // 6501
  { PseudoVLUXSEG5EI64_V_M8_M1_MASK, VLUXSEG5EI64_V }, // 6502
  { PseudoVLUXSEG5EI64_V_M8_M1_TU, VLUXSEG5EI64_V }, // 6503
  { PseudoVLUXSEG5EI8_V_M1_M1, VLUXSEG5EI8_V }, // 6504
  { PseudoVLUXSEG5EI8_V_M1_M1_MASK, VLUXSEG5EI8_V }, // 6505
  { PseudoVLUXSEG5EI8_V_M1_M1_TU, VLUXSEG5EI8_V }, // 6506
  { PseudoVLUXSEG5EI8_V_MF2_M1, VLUXSEG5EI8_V }, // 6507
  { PseudoVLUXSEG5EI8_V_MF2_M1_MASK, VLUXSEG5EI8_V }, // 6508
  { PseudoVLUXSEG5EI8_V_MF2_M1_TU, VLUXSEG5EI8_V }, // 6509
  { PseudoVLUXSEG5EI8_V_MF2_MF2, VLUXSEG5EI8_V }, // 6510
  { PseudoVLUXSEG5EI8_V_MF2_MF2_MASK, VLUXSEG5EI8_V }, // 6511
  { PseudoVLUXSEG5EI8_V_MF2_MF2_TU, VLUXSEG5EI8_V }, // 6512
  { PseudoVLUXSEG5EI8_V_MF4_M1, VLUXSEG5EI8_V }, // 6513
  { PseudoVLUXSEG5EI8_V_MF4_M1_MASK, VLUXSEG5EI8_V }, // 6514
  { PseudoVLUXSEG5EI8_V_MF4_M1_TU, VLUXSEG5EI8_V }, // 6515
  { PseudoVLUXSEG5EI8_V_MF4_MF2, VLUXSEG5EI8_V }, // 6516
  { PseudoVLUXSEG5EI8_V_MF4_MF2_MASK, VLUXSEG5EI8_V }, // 6517
  { PseudoVLUXSEG5EI8_V_MF4_MF2_TU, VLUXSEG5EI8_V }, // 6518
  { PseudoVLUXSEG5EI8_V_MF4_MF4, VLUXSEG5EI8_V }, // 6519
  { PseudoVLUXSEG5EI8_V_MF4_MF4_MASK, VLUXSEG5EI8_V }, // 6520
  { PseudoVLUXSEG5EI8_V_MF4_MF4_TU, VLUXSEG5EI8_V }, // 6521
  { PseudoVLUXSEG5EI8_V_MF8_M1, VLUXSEG5EI8_V }, // 6522
  { PseudoVLUXSEG5EI8_V_MF8_M1_MASK, VLUXSEG5EI8_V }, // 6523
  { PseudoVLUXSEG5EI8_V_MF8_M1_TU, VLUXSEG5EI8_V }, // 6524
  { PseudoVLUXSEG5EI8_V_MF8_MF2, VLUXSEG5EI8_V }, // 6525
  { PseudoVLUXSEG5EI8_V_MF8_MF2_MASK, VLUXSEG5EI8_V }, // 6526
  { PseudoVLUXSEG5EI8_V_MF8_MF2_TU, VLUXSEG5EI8_V }, // 6527
  { PseudoVLUXSEG5EI8_V_MF8_MF4, VLUXSEG5EI8_V }, // 6528
  { PseudoVLUXSEG5EI8_V_MF8_MF4_MASK, VLUXSEG5EI8_V }, // 6529
  { PseudoVLUXSEG5EI8_V_MF8_MF4_TU, VLUXSEG5EI8_V }, // 6530
  { PseudoVLUXSEG5EI8_V_MF8_MF8, VLUXSEG5EI8_V }, // 6531
  { PseudoVLUXSEG5EI8_V_MF8_MF8_MASK, VLUXSEG5EI8_V }, // 6532
  { PseudoVLUXSEG5EI8_V_MF8_MF8_TU, VLUXSEG5EI8_V }, // 6533
  { PseudoVLUXSEG6EI16_V_M1_M1, VLUXSEG6EI16_V }, // 6534
  { PseudoVLUXSEG6EI16_V_M1_M1_MASK, VLUXSEG6EI16_V }, // 6535
  { PseudoVLUXSEG6EI16_V_M1_M1_TU, VLUXSEG6EI16_V }, // 6536
  { PseudoVLUXSEG6EI16_V_M1_MF2, VLUXSEG6EI16_V }, // 6537
  { PseudoVLUXSEG6EI16_V_M1_MF2_MASK, VLUXSEG6EI16_V }, // 6538
  { PseudoVLUXSEG6EI16_V_M1_MF2_TU, VLUXSEG6EI16_V }, // 6539
  { PseudoVLUXSEG6EI16_V_M2_M1, VLUXSEG6EI16_V }, // 6540
  { PseudoVLUXSEG6EI16_V_M2_M1_MASK, VLUXSEG6EI16_V }, // 6541
  { PseudoVLUXSEG6EI16_V_M2_M1_TU, VLUXSEG6EI16_V }, // 6542
  { PseudoVLUXSEG6EI16_V_MF2_M1, VLUXSEG6EI16_V }, // 6543
  { PseudoVLUXSEG6EI16_V_MF2_M1_MASK, VLUXSEG6EI16_V }, // 6544
  { PseudoVLUXSEG6EI16_V_MF2_M1_TU, VLUXSEG6EI16_V }, // 6545
  { PseudoVLUXSEG6EI16_V_MF2_MF2, VLUXSEG6EI16_V }, // 6546
  { PseudoVLUXSEG6EI16_V_MF2_MF2_MASK, VLUXSEG6EI16_V }, // 6547
  { PseudoVLUXSEG6EI16_V_MF2_MF2_TU, VLUXSEG6EI16_V }, // 6548
  { PseudoVLUXSEG6EI16_V_MF2_MF4, VLUXSEG6EI16_V }, // 6549
  { PseudoVLUXSEG6EI16_V_MF2_MF4_MASK, VLUXSEG6EI16_V }, // 6550
  { PseudoVLUXSEG6EI16_V_MF2_MF4_TU, VLUXSEG6EI16_V }, // 6551
  { PseudoVLUXSEG6EI16_V_MF4_M1, VLUXSEG6EI16_V }, // 6552
  { PseudoVLUXSEG6EI16_V_MF4_M1_MASK, VLUXSEG6EI16_V }, // 6553
  { PseudoVLUXSEG6EI16_V_MF4_M1_TU, VLUXSEG6EI16_V }, // 6554
  { PseudoVLUXSEG6EI16_V_MF4_MF2, VLUXSEG6EI16_V }, // 6555
  { PseudoVLUXSEG6EI16_V_MF4_MF2_MASK, VLUXSEG6EI16_V }, // 6556
  { PseudoVLUXSEG6EI16_V_MF4_MF2_TU, VLUXSEG6EI16_V }, // 6557
  { PseudoVLUXSEG6EI16_V_MF4_MF4, VLUXSEG6EI16_V }, // 6558
  { PseudoVLUXSEG6EI16_V_MF4_MF4_MASK, VLUXSEG6EI16_V }, // 6559
  { PseudoVLUXSEG6EI16_V_MF4_MF4_TU, VLUXSEG6EI16_V }, // 6560
  { PseudoVLUXSEG6EI16_V_MF4_MF8, VLUXSEG6EI16_V }, // 6561
  { PseudoVLUXSEG6EI16_V_MF4_MF8_MASK, VLUXSEG6EI16_V }, // 6562
  { PseudoVLUXSEG6EI16_V_MF4_MF8_TU, VLUXSEG6EI16_V }, // 6563
  { PseudoVLUXSEG6EI32_V_M1_M1, VLUXSEG6EI32_V }, // 6564
  { PseudoVLUXSEG6EI32_V_M1_M1_MASK, VLUXSEG6EI32_V }, // 6565
  { PseudoVLUXSEG6EI32_V_M1_M1_TU, VLUXSEG6EI32_V }, // 6566
  { PseudoVLUXSEG6EI32_V_M1_MF2, VLUXSEG6EI32_V }, // 6567
  { PseudoVLUXSEG6EI32_V_M1_MF2_MASK, VLUXSEG6EI32_V }, // 6568
  { PseudoVLUXSEG6EI32_V_M1_MF2_TU, VLUXSEG6EI32_V }, // 6569
  { PseudoVLUXSEG6EI32_V_M1_MF4, VLUXSEG6EI32_V }, // 6570
  { PseudoVLUXSEG6EI32_V_M1_MF4_MASK, VLUXSEG6EI32_V }, // 6571
  { PseudoVLUXSEG6EI32_V_M1_MF4_TU, VLUXSEG6EI32_V }, // 6572
  { PseudoVLUXSEG6EI32_V_M2_M1, VLUXSEG6EI32_V }, // 6573
  { PseudoVLUXSEG6EI32_V_M2_M1_MASK, VLUXSEG6EI32_V }, // 6574
  { PseudoVLUXSEG6EI32_V_M2_M1_TU, VLUXSEG6EI32_V }, // 6575
  { PseudoVLUXSEG6EI32_V_M2_MF2, VLUXSEG6EI32_V }, // 6576
  { PseudoVLUXSEG6EI32_V_M2_MF2_MASK, VLUXSEG6EI32_V }, // 6577
  { PseudoVLUXSEG6EI32_V_M2_MF2_TU, VLUXSEG6EI32_V }, // 6578
  { PseudoVLUXSEG6EI32_V_M4_M1, VLUXSEG6EI32_V }, // 6579
  { PseudoVLUXSEG6EI32_V_M4_M1_MASK, VLUXSEG6EI32_V }, // 6580
  { PseudoVLUXSEG6EI32_V_M4_M1_TU, VLUXSEG6EI32_V }, // 6581
  { PseudoVLUXSEG6EI32_V_MF2_M1, VLUXSEG6EI32_V }, // 6582
  { PseudoVLUXSEG6EI32_V_MF2_M1_MASK, VLUXSEG6EI32_V }, // 6583
  { PseudoVLUXSEG6EI32_V_MF2_M1_TU, VLUXSEG6EI32_V }, // 6584
  { PseudoVLUXSEG6EI32_V_MF2_MF2, VLUXSEG6EI32_V }, // 6585
  { PseudoVLUXSEG6EI32_V_MF2_MF2_MASK, VLUXSEG6EI32_V }, // 6586
  { PseudoVLUXSEG6EI32_V_MF2_MF2_TU, VLUXSEG6EI32_V }, // 6587
  { PseudoVLUXSEG6EI32_V_MF2_MF4, VLUXSEG6EI32_V }, // 6588
  { PseudoVLUXSEG6EI32_V_MF2_MF4_MASK, VLUXSEG6EI32_V }, // 6589
  { PseudoVLUXSEG6EI32_V_MF2_MF4_TU, VLUXSEG6EI32_V }, // 6590
  { PseudoVLUXSEG6EI32_V_MF2_MF8, VLUXSEG6EI32_V }, // 6591
  { PseudoVLUXSEG6EI32_V_MF2_MF8_MASK, VLUXSEG6EI32_V }, // 6592
  { PseudoVLUXSEG6EI32_V_MF2_MF8_TU, VLUXSEG6EI32_V }, // 6593
  { PseudoVLUXSEG6EI64_V_M1_M1, VLUXSEG6EI64_V }, // 6594
  { PseudoVLUXSEG6EI64_V_M1_M1_MASK, VLUXSEG6EI64_V }, // 6595
  { PseudoVLUXSEG6EI64_V_M1_M1_TU, VLUXSEG6EI64_V }, // 6596
  { PseudoVLUXSEG6EI64_V_M1_MF2, VLUXSEG6EI64_V }, // 6597
  { PseudoVLUXSEG6EI64_V_M1_MF2_MASK, VLUXSEG6EI64_V }, // 6598
  { PseudoVLUXSEG6EI64_V_M1_MF2_TU, VLUXSEG6EI64_V }, // 6599
  { PseudoVLUXSEG6EI64_V_M1_MF4, VLUXSEG6EI64_V }, // 6600
  { PseudoVLUXSEG6EI64_V_M1_MF4_MASK, VLUXSEG6EI64_V }, // 6601
  { PseudoVLUXSEG6EI64_V_M1_MF4_TU, VLUXSEG6EI64_V }, // 6602
  { PseudoVLUXSEG6EI64_V_M1_MF8, VLUXSEG6EI64_V }, // 6603
  { PseudoVLUXSEG6EI64_V_M1_MF8_MASK, VLUXSEG6EI64_V }, // 6604
  { PseudoVLUXSEG6EI64_V_M1_MF8_TU, VLUXSEG6EI64_V }, // 6605
  { PseudoVLUXSEG6EI64_V_M2_M1, VLUXSEG6EI64_V }, // 6606
  { PseudoVLUXSEG6EI64_V_M2_M1_MASK, VLUXSEG6EI64_V }, // 6607
  { PseudoVLUXSEG6EI64_V_M2_M1_TU, VLUXSEG6EI64_V }, // 6608
  { PseudoVLUXSEG6EI64_V_M2_MF2, VLUXSEG6EI64_V }, // 6609
  { PseudoVLUXSEG6EI64_V_M2_MF2_MASK, VLUXSEG6EI64_V }, // 6610
  { PseudoVLUXSEG6EI64_V_M2_MF2_TU, VLUXSEG6EI64_V }, // 6611
  { PseudoVLUXSEG6EI64_V_M2_MF4, VLUXSEG6EI64_V }, // 6612
  { PseudoVLUXSEG6EI64_V_M2_MF4_MASK, VLUXSEG6EI64_V }, // 6613
  { PseudoVLUXSEG6EI64_V_M2_MF4_TU, VLUXSEG6EI64_V }, // 6614
  { PseudoVLUXSEG6EI64_V_M4_M1, VLUXSEG6EI64_V }, // 6615
  { PseudoVLUXSEG6EI64_V_M4_M1_MASK, VLUXSEG6EI64_V }, // 6616
  { PseudoVLUXSEG6EI64_V_M4_M1_TU, VLUXSEG6EI64_V }, // 6617
  { PseudoVLUXSEG6EI64_V_M4_MF2, VLUXSEG6EI64_V }, // 6618
  { PseudoVLUXSEG6EI64_V_M4_MF2_MASK, VLUXSEG6EI64_V }, // 6619
  { PseudoVLUXSEG6EI64_V_M4_MF2_TU, VLUXSEG6EI64_V }, // 6620
  { PseudoVLUXSEG6EI64_V_M8_M1, VLUXSEG6EI64_V }, // 6621
  { PseudoVLUXSEG6EI64_V_M8_M1_MASK, VLUXSEG6EI64_V }, // 6622
  { PseudoVLUXSEG6EI64_V_M8_M1_TU, VLUXSEG6EI64_V }, // 6623
  { PseudoVLUXSEG6EI8_V_M1_M1, VLUXSEG6EI8_V }, // 6624
  { PseudoVLUXSEG6EI8_V_M1_M1_MASK, VLUXSEG6EI8_V }, // 6625
  { PseudoVLUXSEG6EI8_V_M1_M1_TU, VLUXSEG6EI8_V }, // 6626
  { PseudoVLUXSEG6EI8_V_MF2_M1, VLUXSEG6EI8_V }, // 6627
  { PseudoVLUXSEG6EI8_V_MF2_M1_MASK, VLUXSEG6EI8_V }, // 6628
  { PseudoVLUXSEG6EI8_V_MF2_M1_TU, VLUXSEG6EI8_V }, // 6629
  { PseudoVLUXSEG6EI8_V_MF2_MF2, VLUXSEG6EI8_V }, // 6630
  { PseudoVLUXSEG6EI8_V_MF2_MF2_MASK, VLUXSEG6EI8_V }, // 6631
  { PseudoVLUXSEG6EI8_V_MF2_MF2_TU, VLUXSEG6EI8_V }, // 6632
  { PseudoVLUXSEG6EI8_V_MF4_M1, VLUXSEG6EI8_V }, // 6633
  { PseudoVLUXSEG6EI8_V_MF4_M1_MASK, VLUXSEG6EI8_V }, // 6634
  { PseudoVLUXSEG6EI8_V_MF4_M1_TU, VLUXSEG6EI8_V }, // 6635
  { PseudoVLUXSEG6EI8_V_MF4_MF2, VLUXSEG6EI8_V }, // 6636
  { PseudoVLUXSEG6EI8_V_MF4_MF2_MASK, VLUXSEG6EI8_V }, // 6637
  { PseudoVLUXSEG6EI8_V_MF4_MF2_TU, VLUXSEG6EI8_V }, // 6638
  { PseudoVLUXSEG6EI8_V_MF4_MF4, VLUXSEG6EI8_V }, // 6639
  { PseudoVLUXSEG6EI8_V_MF4_MF4_MASK, VLUXSEG6EI8_V }, // 6640
  { PseudoVLUXSEG6EI8_V_MF4_MF4_TU, VLUXSEG6EI8_V }, // 6641
  { PseudoVLUXSEG6EI8_V_MF8_M1, VLUXSEG6EI8_V }, // 6642
  { PseudoVLUXSEG6EI8_V_MF8_M1_MASK, VLUXSEG6EI8_V }, // 6643
  { PseudoVLUXSEG6EI8_V_MF8_M1_TU, VLUXSEG6EI8_V }, // 6644
  { PseudoVLUXSEG6EI8_V_MF8_MF2, VLUXSEG6EI8_V }, // 6645
  { PseudoVLUXSEG6EI8_V_MF8_MF2_MASK, VLUXSEG6EI8_V }, // 6646
  { PseudoVLUXSEG6EI8_V_MF8_MF2_TU, VLUXSEG6EI8_V }, // 6647
  { PseudoVLUXSEG6EI8_V_MF8_MF4, VLUXSEG6EI8_V }, // 6648
  { PseudoVLUXSEG6EI8_V_MF8_MF4_MASK, VLUXSEG6EI8_V }, // 6649
  { PseudoVLUXSEG6EI8_V_MF8_MF4_TU, VLUXSEG6EI8_V }, // 6650
  { PseudoVLUXSEG6EI8_V_MF8_MF8, VLUXSEG6EI8_V }, // 6651
  { PseudoVLUXSEG6EI8_V_MF8_MF8_MASK, VLUXSEG6EI8_V }, // 6652
  { PseudoVLUXSEG6EI8_V_MF8_MF8_TU, VLUXSEG6EI8_V }, // 6653
  { PseudoVLUXSEG7EI16_V_M1_M1, VLUXSEG7EI16_V }, // 6654
  { PseudoVLUXSEG7EI16_V_M1_M1_MASK, VLUXSEG7EI16_V }, // 6655
  { PseudoVLUXSEG7EI16_V_M1_M1_TU, VLUXSEG7EI16_V }, // 6656
  { PseudoVLUXSEG7EI16_V_M1_MF2, VLUXSEG7EI16_V }, // 6657
  { PseudoVLUXSEG7EI16_V_M1_MF2_MASK, VLUXSEG7EI16_V }, // 6658
  { PseudoVLUXSEG7EI16_V_M1_MF2_TU, VLUXSEG7EI16_V }, // 6659
  { PseudoVLUXSEG7EI16_V_M2_M1, VLUXSEG7EI16_V }, // 6660
  { PseudoVLUXSEG7EI16_V_M2_M1_MASK, VLUXSEG7EI16_V }, // 6661
  { PseudoVLUXSEG7EI16_V_M2_M1_TU, VLUXSEG7EI16_V }, // 6662
  { PseudoVLUXSEG7EI16_V_MF2_M1, VLUXSEG7EI16_V }, // 6663
  { PseudoVLUXSEG7EI16_V_MF2_M1_MASK, VLUXSEG7EI16_V }, // 6664
  { PseudoVLUXSEG7EI16_V_MF2_M1_TU, VLUXSEG7EI16_V }, // 6665
  { PseudoVLUXSEG7EI16_V_MF2_MF2, VLUXSEG7EI16_V }, // 6666
  { PseudoVLUXSEG7EI16_V_MF2_MF2_MASK, VLUXSEG7EI16_V }, // 6667
  { PseudoVLUXSEG7EI16_V_MF2_MF2_TU, VLUXSEG7EI16_V }, // 6668
  { PseudoVLUXSEG7EI16_V_MF2_MF4, VLUXSEG7EI16_V }, // 6669
  { PseudoVLUXSEG7EI16_V_MF2_MF4_MASK, VLUXSEG7EI16_V }, // 6670
  { PseudoVLUXSEG7EI16_V_MF2_MF4_TU, VLUXSEG7EI16_V }, // 6671
  { PseudoVLUXSEG7EI16_V_MF4_M1, VLUXSEG7EI16_V }, // 6672
  { PseudoVLUXSEG7EI16_V_MF4_M1_MASK, VLUXSEG7EI16_V }, // 6673
  { PseudoVLUXSEG7EI16_V_MF4_M1_TU, VLUXSEG7EI16_V }, // 6674
  { PseudoVLUXSEG7EI16_V_MF4_MF2, VLUXSEG7EI16_V }, // 6675
  { PseudoVLUXSEG7EI16_V_MF4_MF2_MASK, VLUXSEG7EI16_V }, // 6676
  { PseudoVLUXSEG7EI16_V_MF4_MF2_TU, VLUXSEG7EI16_V }, // 6677
  { PseudoVLUXSEG7EI16_V_MF4_MF4, VLUXSEG7EI16_V }, // 6678
  { PseudoVLUXSEG7EI16_V_MF4_MF4_MASK, VLUXSEG7EI16_V }, // 6679
  { PseudoVLUXSEG7EI16_V_MF4_MF4_TU, VLUXSEG7EI16_V }, // 6680
  { PseudoVLUXSEG7EI16_V_MF4_MF8, VLUXSEG7EI16_V }, // 6681
  { PseudoVLUXSEG7EI16_V_MF4_MF8_MASK, VLUXSEG7EI16_V }, // 6682
  { PseudoVLUXSEG7EI16_V_MF4_MF8_TU, VLUXSEG7EI16_V }, // 6683
  { PseudoVLUXSEG7EI32_V_M1_M1, VLUXSEG7EI32_V }, // 6684
  { PseudoVLUXSEG7EI32_V_M1_M1_MASK, VLUXSEG7EI32_V }, // 6685
  { PseudoVLUXSEG7EI32_V_M1_M1_TU, VLUXSEG7EI32_V }, // 6686
  { PseudoVLUXSEG7EI32_V_M1_MF2, VLUXSEG7EI32_V }, // 6687
  { PseudoVLUXSEG7EI32_V_M1_MF2_MASK, VLUXSEG7EI32_V }, // 6688
  { PseudoVLUXSEG7EI32_V_M1_MF2_TU, VLUXSEG7EI32_V }, // 6689
  { PseudoVLUXSEG7EI32_V_M1_MF4, VLUXSEG7EI32_V }, // 6690
  { PseudoVLUXSEG7EI32_V_M1_MF4_MASK, VLUXSEG7EI32_V }, // 6691
  { PseudoVLUXSEG7EI32_V_M1_MF4_TU, VLUXSEG7EI32_V }, // 6692
  { PseudoVLUXSEG7EI32_V_M2_M1, VLUXSEG7EI32_V }, // 6693
  { PseudoVLUXSEG7EI32_V_M2_M1_MASK, VLUXSEG7EI32_V }, // 6694
  { PseudoVLUXSEG7EI32_V_M2_M1_TU, VLUXSEG7EI32_V }, // 6695
  { PseudoVLUXSEG7EI32_V_M2_MF2, VLUXSEG7EI32_V }, // 6696
  { PseudoVLUXSEG7EI32_V_M2_MF2_MASK, VLUXSEG7EI32_V }, // 6697
  { PseudoVLUXSEG7EI32_V_M2_MF2_TU, VLUXSEG7EI32_V }, // 6698
  { PseudoVLUXSEG7EI32_V_M4_M1, VLUXSEG7EI32_V }, // 6699
  { PseudoVLUXSEG7EI32_V_M4_M1_MASK, VLUXSEG7EI32_V }, // 6700
  { PseudoVLUXSEG7EI32_V_M4_M1_TU, VLUXSEG7EI32_V }, // 6701
  { PseudoVLUXSEG7EI32_V_MF2_M1, VLUXSEG7EI32_V }, // 6702
  { PseudoVLUXSEG7EI32_V_MF2_M1_MASK, VLUXSEG7EI32_V }, // 6703
  { PseudoVLUXSEG7EI32_V_MF2_M1_TU, VLUXSEG7EI32_V }, // 6704
  { PseudoVLUXSEG7EI32_V_MF2_MF2, VLUXSEG7EI32_V }, // 6705
  { PseudoVLUXSEG7EI32_V_MF2_MF2_MASK, VLUXSEG7EI32_V }, // 6706
  { PseudoVLUXSEG7EI32_V_MF2_MF2_TU, VLUXSEG7EI32_V }, // 6707
  { PseudoVLUXSEG7EI32_V_MF2_MF4, VLUXSEG7EI32_V }, // 6708
  { PseudoVLUXSEG7EI32_V_MF2_MF4_MASK, VLUXSEG7EI32_V }, // 6709
  { PseudoVLUXSEG7EI32_V_MF2_MF4_TU, VLUXSEG7EI32_V }, // 6710
  { PseudoVLUXSEG7EI32_V_MF2_MF8, VLUXSEG7EI32_V }, // 6711
  { PseudoVLUXSEG7EI32_V_MF2_MF8_MASK, VLUXSEG7EI32_V }, // 6712
  { PseudoVLUXSEG7EI32_V_MF2_MF8_TU, VLUXSEG7EI32_V }, // 6713
  { PseudoVLUXSEG7EI64_V_M1_M1, VLUXSEG7EI64_V }, // 6714
  { PseudoVLUXSEG7EI64_V_M1_M1_MASK, VLUXSEG7EI64_V }, // 6715
  { PseudoVLUXSEG7EI64_V_M1_M1_TU, VLUXSEG7EI64_V }, // 6716
  { PseudoVLUXSEG7EI64_V_M1_MF2, VLUXSEG7EI64_V }, // 6717
  { PseudoVLUXSEG7EI64_V_M1_MF2_MASK, VLUXSEG7EI64_V }, // 6718
  { PseudoVLUXSEG7EI64_V_M1_MF2_TU, VLUXSEG7EI64_V }, // 6719
  { PseudoVLUXSEG7EI64_V_M1_MF4, VLUXSEG7EI64_V }, // 6720
  { PseudoVLUXSEG7EI64_V_M1_MF4_MASK, VLUXSEG7EI64_V }, // 6721
  { PseudoVLUXSEG7EI64_V_M1_MF4_TU, VLUXSEG7EI64_V }, // 6722
  { PseudoVLUXSEG7EI64_V_M1_MF8, VLUXSEG7EI64_V }, // 6723
  { PseudoVLUXSEG7EI64_V_M1_MF8_MASK, VLUXSEG7EI64_V }, // 6724
  { PseudoVLUXSEG7EI64_V_M1_MF8_TU, VLUXSEG7EI64_V }, // 6725
  { PseudoVLUXSEG7EI64_V_M2_M1, VLUXSEG7EI64_V }, // 6726
  { PseudoVLUXSEG7EI64_V_M2_M1_MASK, VLUXSEG7EI64_V }, // 6727
  { PseudoVLUXSEG7EI64_V_M2_M1_TU, VLUXSEG7EI64_V }, // 6728
  { PseudoVLUXSEG7EI64_V_M2_MF2, VLUXSEG7EI64_V }, // 6729
  { PseudoVLUXSEG7EI64_V_M2_MF2_MASK, VLUXSEG7EI64_V }, // 6730
  { PseudoVLUXSEG7EI64_V_M2_MF2_TU, VLUXSEG7EI64_V }, // 6731
  { PseudoVLUXSEG7EI64_V_M2_MF4, VLUXSEG7EI64_V }, // 6732
  { PseudoVLUXSEG7EI64_V_M2_MF4_MASK, VLUXSEG7EI64_V }, // 6733
  { PseudoVLUXSEG7EI64_V_M2_MF4_TU, VLUXSEG7EI64_V }, // 6734
  { PseudoVLUXSEG7EI64_V_M4_M1, VLUXSEG7EI64_V }, // 6735
  { PseudoVLUXSEG7EI64_V_M4_M1_MASK, VLUXSEG7EI64_V }, // 6736
  { PseudoVLUXSEG7EI64_V_M4_M1_TU, VLUXSEG7EI64_V }, // 6737
  { PseudoVLUXSEG7EI64_V_M4_MF2, VLUXSEG7EI64_V }, // 6738
  { PseudoVLUXSEG7EI64_V_M4_MF2_MASK, VLUXSEG7EI64_V }, // 6739
  { PseudoVLUXSEG7EI64_V_M4_MF2_TU, VLUXSEG7EI64_V }, // 6740
  { PseudoVLUXSEG7EI64_V_M8_M1, VLUXSEG7EI64_V }, // 6741
  { PseudoVLUXSEG7EI64_V_M8_M1_MASK, VLUXSEG7EI64_V }, // 6742
  { PseudoVLUXSEG7EI64_V_M8_M1_TU, VLUXSEG7EI64_V }, // 6743
  { PseudoVLUXSEG7EI8_V_M1_M1, VLUXSEG7EI8_V }, // 6744
  { PseudoVLUXSEG7EI8_V_M1_M1_MASK, VLUXSEG7EI8_V }, // 6745
  { PseudoVLUXSEG7EI8_V_M1_M1_TU, VLUXSEG7EI8_V }, // 6746
  { PseudoVLUXSEG7EI8_V_MF2_M1, VLUXSEG7EI8_V }, // 6747
  { PseudoVLUXSEG7EI8_V_MF2_M1_MASK, VLUXSEG7EI8_V }, // 6748
  { PseudoVLUXSEG7EI8_V_MF2_M1_TU, VLUXSEG7EI8_V }, // 6749
  { PseudoVLUXSEG7EI8_V_MF2_MF2, VLUXSEG7EI8_V }, // 6750
  { PseudoVLUXSEG7EI8_V_MF2_MF2_MASK, VLUXSEG7EI8_V }, // 6751
  { PseudoVLUXSEG7EI8_V_MF2_MF2_TU, VLUXSEG7EI8_V }, // 6752
  { PseudoVLUXSEG7EI8_V_MF4_M1, VLUXSEG7EI8_V }, // 6753
  { PseudoVLUXSEG7EI8_V_MF4_M1_MASK, VLUXSEG7EI8_V }, // 6754
  { PseudoVLUXSEG7EI8_V_MF4_M1_TU, VLUXSEG7EI8_V }, // 6755
  { PseudoVLUXSEG7EI8_V_MF4_MF2, VLUXSEG7EI8_V }, // 6756
  { PseudoVLUXSEG7EI8_V_MF4_MF2_MASK, VLUXSEG7EI8_V }, // 6757
  { PseudoVLUXSEG7EI8_V_MF4_MF2_TU, VLUXSEG7EI8_V }, // 6758
  { PseudoVLUXSEG7EI8_V_MF4_MF4, VLUXSEG7EI8_V }, // 6759
  { PseudoVLUXSEG7EI8_V_MF4_MF4_MASK, VLUXSEG7EI8_V }, // 6760
  { PseudoVLUXSEG7EI8_V_MF4_MF4_TU, VLUXSEG7EI8_V }, // 6761
  { PseudoVLUXSEG7EI8_V_MF8_M1, VLUXSEG7EI8_V }, // 6762
  { PseudoVLUXSEG7EI8_V_MF8_M1_MASK, VLUXSEG7EI8_V }, // 6763
  { PseudoVLUXSEG7EI8_V_MF8_M1_TU, VLUXSEG7EI8_V }, // 6764
  { PseudoVLUXSEG7EI8_V_MF8_MF2, VLUXSEG7EI8_V }, // 6765
  { PseudoVLUXSEG7EI8_V_MF8_MF2_MASK, VLUXSEG7EI8_V }, // 6766
  { PseudoVLUXSEG7EI8_V_MF8_MF2_TU, VLUXSEG7EI8_V }, // 6767
  { PseudoVLUXSEG7EI8_V_MF8_MF4, VLUXSEG7EI8_V }, // 6768
  { PseudoVLUXSEG7EI8_V_MF8_MF4_MASK, VLUXSEG7EI8_V }, // 6769
  { PseudoVLUXSEG7EI8_V_MF8_MF4_TU, VLUXSEG7EI8_V }, // 6770
  { PseudoVLUXSEG7EI8_V_MF8_MF8, VLUXSEG7EI8_V }, // 6771
  { PseudoVLUXSEG7EI8_V_MF8_MF8_MASK, VLUXSEG7EI8_V }, // 6772
  { PseudoVLUXSEG7EI8_V_MF8_MF8_TU, VLUXSEG7EI8_V }, // 6773
  { PseudoVLUXSEG8EI16_V_M1_M1, VLUXSEG8EI16_V }, // 6774
  { PseudoVLUXSEG8EI16_V_M1_M1_MASK, VLUXSEG8EI16_V }, // 6775
  { PseudoVLUXSEG8EI16_V_M1_M1_TU, VLUXSEG8EI16_V }, // 6776
  { PseudoVLUXSEG8EI16_V_M1_MF2, VLUXSEG8EI16_V }, // 6777
  { PseudoVLUXSEG8EI16_V_M1_MF2_MASK, VLUXSEG8EI16_V }, // 6778
  { PseudoVLUXSEG8EI16_V_M1_MF2_TU, VLUXSEG8EI16_V }, // 6779
  { PseudoVLUXSEG8EI16_V_M2_M1, VLUXSEG8EI16_V }, // 6780
  { PseudoVLUXSEG8EI16_V_M2_M1_MASK, VLUXSEG8EI16_V }, // 6781
  { PseudoVLUXSEG8EI16_V_M2_M1_TU, VLUXSEG8EI16_V }, // 6782
  { PseudoVLUXSEG8EI16_V_MF2_M1, VLUXSEG8EI16_V }, // 6783
  { PseudoVLUXSEG8EI16_V_MF2_M1_MASK, VLUXSEG8EI16_V }, // 6784
  { PseudoVLUXSEG8EI16_V_MF2_M1_TU, VLUXSEG8EI16_V }, // 6785
  { PseudoVLUXSEG8EI16_V_MF2_MF2, VLUXSEG8EI16_V }, // 6786
  { PseudoVLUXSEG8EI16_V_MF2_MF2_MASK, VLUXSEG8EI16_V }, // 6787
  { PseudoVLUXSEG8EI16_V_MF2_MF2_TU, VLUXSEG8EI16_V }, // 6788
  { PseudoVLUXSEG8EI16_V_MF2_MF4, VLUXSEG8EI16_V }, // 6789
  { PseudoVLUXSEG8EI16_V_MF2_MF4_MASK, VLUXSEG8EI16_V }, // 6790
  { PseudoVLUXSEG8EI16_V_MF2_MF4_TU, VLUXSEG8EI16_V }, // 6791
  { PseudoVLUXSEG8EI16_V_MF4_M1, VLUXSEG8EI16_V }, // 6792
  { PseudoVLUXSEG8EI16_V_MF4_M1_MASK, VLUXSEG8EI16_V }, // 6793
  { PseudoVLUXSEG8EI16_V_MF4_M1_TU, VLUXSEG8EI16_V }, // 6794
  { PseudoVLUXSEG8EI16_V_MF4_MF2, VLUXSEG8EI16_V }, // 6795
  { PseudoVLUXSEG8EI16_V_MF4_MF2_MASK, VLUXSEG8EI16_V }, // 6796
  { PseudoVLUXSEG8EI16_V_MF4_MF2_TU, VLUXSEG8EI16_V }, // 6797
  { PseudoVLUXSEG8EI16_V_MF4_MF4, VLUXSEG8EI16_V }, // 6798
  { PseudoVLUXSEG8EI16_V_MF4_MF4_MASK, VLUXSEG8EI16_V }, // 6799
  { PseudoVLUXSEG8EI16_V_MF4_MF4_TU, VLUXSEG8EI16_V }, // 6800
  { PseudoVLUXSEG8EI16_V_MF4_MF8, VLUXSEG8EI16_V }, // 6801
  { PseudoVLUXSEG8EI16_V_MF4_MF8_MASK, VLUXSEG8EI16_V }, // 6802
  { PseudoVLUXSEG8EI16_V_MF4_MF8_TU, VLUXSEG8EI16_V }, // 6803
  { PseudoVLUXSEG8EI32_V_M1_M1, VLUXSEG8EI32_V }, // 6804
  { PseudoVLUXSEG8EI32_V_M1_M1_MASK, VLUXSEG8EI32_V }, // 6805
  { PseudoVLUXSEG8EI32_V_M1_M1_TU, VLUXSEG8EI32_V }, // 6806
  { PseudoVLUXSEG8EI32_V_M1_MF2, VLUXSEG8EI32_V }, // 6807
  { PseudoVLUXSEG8EI32_V_M1_MF2_MASK, VLUXSEG8EI32_V }, // 6808
  { PseudoVLUXSEG8EI32_V_M1_MF2_TU, VLUXSEG8EI32_V }, // 6809
  { PseudoVLUXSEG8EI32_V_M1_MF4, VLUXSEG8EI32_V }, // 6810
  { PseudoVLUXSEG8EI32_V_M1_MF4_MASK, VLUXSEG8EI32_V }, // 6811
  { PseudoVLUXSEG8EI32_V_M1_MF4_TU, VLUXSEG8EI32_V }, // 6812
  { PseudoVLUXSEG8EI32_V_M2_M1, VLUXSEG8EI32_V }, // 6813
  { PseudoVLUXSEG8EI32_V_M2_M1_MASK, VLUXSEG8EI32_V }, // 6814
  { PseudoVLUXSEG8EI32_V_M2_M1_TU, VLUXSEG8EI32_V }, // 6815
  { PseudoVLUXSEG8EI32_V_M2_MF2, VLUXSEG8EI32_V }, // 6816
  { PseudoVLUXSEG8EI32_V_M2_MF2_MASK, VLUXSEG8EI32_V }, // 6817
  { PseudoVLUXSEG8EI32_V_M2_MF2_TU, VLUXSEG8EI32_V }, // 6818
  { PseudoVLUXSEG8EI32_V_M4_M1, VLUXSEG8EI32_V }, // 6819
  { PseudoVLUXSEG8EI32_V_M4_M1_MASK, VLUXSEG8EI32_V }, // 6820
  { PseudoVLUXSEG8EI32_V_M4_M1_TU, VLUXSEG8EI32_V }, // 6821
  { PseudoVLUXSEG8EI32_V_MF2_M1, VLUXSEG8EI32_V }, // 6822
  { PseudoVLUXSEG8EI32_V_MF2_M1_MASK, VLUXSEG8EI32_V }, // 6823
  { PseudoVLUXSEG8EI32_V_MF2_M1_TU, VLUXSEG8EI32_V }, // 6824
  { PseudoVLUXSEG8EI32_V_MF2_MF2, VLUXSEG8EI32_V }, // 6825
  { PseudoVLUXSEG8EI32_V_MF2_MF2_MASK, VLUXSEG8EI32_V }, // 6826
  { PseudoVLUXSEG8EI32_V_MF2_MF2_TU, VLUXSEG8EI32_V }, // 6827
  { PseudoVLUXSEG8EI32_V_MF2_MF4, VLUXSEG8EI32_V }, // 6828
  { PseudoVLUXSEG8EI32_V_MF2_MF4_MASK, VLUXSEG8EI32_V }, // 6829
  { PseudoVLUXSEG8EI32_V_MF2_MF4_TU, VLUXSEG8EI32_V }, // 6830
  { PseudoVLUXSEG8EI32_V_MF2_MF8, VLUXSEG8EI32_V }, // 6831
  { PseudoVLUXSEG8EI32_V_MF2_MF8_MASK, VLUXSEG8EI32_V }, // 6832
  { PseudoVLUXSEG8EI32_V_MF2_MF8_TU, VLUXSEG8EI32_V }, // 6833
  { PseudoVLUXSEG8EI64_V_M1_M1, VLUXSEG8EI64_V }, // 6834
  { PseudoVLUXSEG8EI64_V_M1_M1_MASK, VLUXSEG8EI64_V }, // 6835
  { PseudoVLUXSEG8EI64_V_M1_M1_TU, VLUXSEG8EI64_V }, // 6836
  { PseudoVLUXSEG8EI64_V_M1_MF2, VLUXSEG8EI64_V }, // 6837
  { PseudoVLUXSEG8EI64_V_M1_MF2_MASK, VLUXSEG8EI64_V }, // 6838
  { PseudoVLUXSEG8EI64_V_M1_MF2_TU, VLUXSEG8EI64_V }, // 6839
  { PseudoVLUXSEG8EI64_V_M1_MF4, VLUXSEG8EI64_V }, // 6840
  { PseudoVLUXSEG8EI64_V_M1_MF4_MASK, VLUXSEG8EI64_V }, // 6841
  { PseudoVLUXSEG8EI64_V_M1_MF4_TU, VLUXSEG8EI64_V }, // 6842
  { PseudoVLUXSEG8EI64_V_M1_MF8, VLUXSEG8EI64_V }, // 6843
  { PseudoVLUXSEG8EI64_V_M1_MF8_MASK, VLUXSEG8EI64_V }, // 6844
  { PseudoVLUXSEG8EI64_V_M1_MF8_TU, VLUXSEG8EI64_V }, // 6845
  { PseudoVLUXSEG8EI64_V_M2_M1, VLUXSEG8EI64_V }, // 6846
  { PseudoVLUXSEG8EI64_V_M2_M1_MASK, VLUXSEG8EI64_V }, // 6847
  { PseudoVLUXSEG8EI64_V_M2_M1_TU, VLUXSEG8EI64_V }, // 6848
  { PseudoVLUXSEG8EI64_V_M2_MF2, VLUXSEG8EI64_V }, // 6849
  { PseudoVLUXSEG8EI64_V_M2_MF2_MASK, VLUXSEG8EI64_V }, // 6850
  { PseudoVLUXSEG8EI64_V_M2_MF2_TU, VLUXSEG8EI64_V }, // 6851
  { PseudoVLUXSEG8EI64_V_M2_MF4, VLUXSEG8EI64_V }, // 6852
  { PseudoVLUXSEG8EI64_V_M2_MF4_MASK, VLUXSEG8EI64_V }, // 6853
  { PseudoVLUXSEG8EI64_V_M2_MF4_TU, VLUXSEG8EI64_V }, // 6854
  { PseudoVLUXSEG8EI64_V_M4_M1, VLUXSEG8EI64_V }, // 6855
  { PseudoVLUXSEG8EI64_V_M4_M1_MASK, VLUXSEG8EI64_V }, // 6856
  { PseudoVLUXSEG8EI64_V_M4_M1_TU, VLUXSEG8EI64_V }, // 6857
  { PseudoVLUXSEG8EI64_V_M4_MF2, VLUXSEG8EI64_V }, // 6858
  { PseudoVLUXSEG8EI64_V_M4_MF2_MASK, VLUXSEG8EI64_V }, // 6859
  { PseudoVLUXSEG8EI64_V_M4_MF2_TU, VLUXSEG8EI64_V }, // 6860
  { PseudoVLUXSEG8EI64_V_M8_M1, VLUXSEG8EI64_V }, // 6861
  { PseudoVLUXSEG8EI64_V_M8_M1_MASK, VLUXSEG8EI64_V }, // 6862
  { PseudoVLUXSEG8EI64_V_M8_M1_TU, VLUXSEG8EI64_V }, // 6863
  { PseudoVLUXSEG8EI8_V_M1_M1, VLUXSEG8EI8_V }, // 6864
  { PseudoVLUXSEG8EI8_V_M1_M1_MASK, VLUXSEG8EI8_V }, // 6865
  { PseudoVLUXSEG8EI8_V_M1_M1_TU, VLUXSEG8EI8_V }, // 6866
  { PseudoVLUXSEG8EI8_V_MF2_M1, VLUXSEG8EI8_V }, // 6867
  { PseudoVLUXSEG8EI8_V_MF2_M1_MASK, VLUXSEG8EI8_V }, // 6868
  { PseudoVLUXSEG8EI8_V_MF2_M1_TU, VLUXSEG8EI8_V }, // 6869
  { PseudoVLUXSEG8EI8_V_MF2_MF2, VLUXSEG8EI8_V }, // 6870
  { PseudoVLUXSEG8EI8_V_MF2_MF2_MASK, VLUXSEG8EI8_V }, // 6871
  { PseudoVLUXSEG8EI8_V_MF2_MF2_TU, VLUXSEG8EI8_V }, // 6872
  { PseudoVLUXSEG8EI8_V_MF4_M1, VLUXSEG8EI8_V }, // 6873
  { PseudoVLUXSEG8EI8_V_MF4_M1_MASK, VLUXSEG8EI8_V }, // 6874
  { PseudoVLUXSEG8EI8_V_MF4_M1_TU, VLUXSEG8EI8_V }, // 6875
  { PseudoVLUXSEG8EI8_V_MF4_MF2, VLUXSEG8EI8_V }, // 6876
  { PseudoVLUXSEG8EI8_V_MF4_MF2_MASK, VLUXSEG8EI8_V }, // 6877
  { PseudoVLUXSEG8EI8_V_MF4_MF2_TU, VLUXSEG8EI8_V }, // 6878
  { PseudoVLUXSEG8EI8_V_MF4_MF4, VLUXSEG8EI8_V }, // 6879
  { PseudoVLUXSEG8EI8_V_MF4_MF4_MASK, VLUXSEG8EI8_V }, // 6880
  { PseudoVLUXSEG8EI8_V_MF4_MF4_TU, VLUXSEG8EI8_V }, // 6881
  { PseudoVLUXSEG8EI8_V_MF8_M1, VLUXSEG8EI8_V }, // 6882
  { PseudoVLUXSEG8EI8_V_MF8_M1_MASK, VLUXSEG8EI8_V }, // 6883
  { PseudoVLUXSEG8EI8_V_MF8_M1_TU, VLUXSEG8EI8_V }, // 6884
  { PseudoVLUXSEG8EI8_V_MF8_MF2, VLUXSEG8EI8_V }, // 6885
  { PseudoVLUXSEG8EI8_V_MF8_MF2_MASK, VLUXSEG8EI8_V }, // 6886
  { PseudoVLUXSEG8EI8_V_MF8_MF2_TU, VLUXSEG8EI8_V }, // 6887
  { PseudoVLUXSEG8EI8_V_MF8_MF4, VLUXSEG8EI8_V }, // 6888
  { PseudoVLUXSEG8EI8_V_MF8_MF4_MASK, VLUXSEG8EI8_V }, // 6889
  { PseudoVLUXSEG8EI8_V_MF8_MF4_TU, VLUXSEG8EI8_V }, // 6890
  { PseudoVLUXSEG8EI8_V_MF8_MF8, VLUXSEG8EI8_V }, // 6891
  { PseudoVLUXSEG8EI8_V_MF8_MF8_MASK, VLUXSEG8EI8_V }, // 6892
  { PseudoVLUXSEG8EI8_V_MF8_MF8_TU, VLUXSEG8EI8_V }, // 6893
  { PseudoVMACC_VV_M1, VMACC_VV }, // 6894
  { PseudoVMACC_VV_M1_MASK, VMACC_VV }, // 6895
  { PseudoVMACC_VV_M2, VMACC_VV }, // 6896
  { PseudoVMACC_VV_M2_MASK, VMACC_VV }, // 6897
  { PseudoVMACC_VV_M4, VMACC_VV }, // 6898
  { PseudoVMACC_VV_M4_MASK, VMACC_VV }, // 6899
  { PseudoVMACC_VV_M8, VMACC_VV }, // 6900
  { PseudoVMACC_VV_M8_MASK, VMACC_VV }, // 6901
  { PseudoVMACC_VV_MF2, VMACC_VV }, // 6902
  { PseudoVMACC_VV_MF2_MASK, VMACC_VV }, // 6903
  { PseudoVMACC_VV_MF4, VMACC_VV }, // 6904
  { PseudoVMACC_VV_MF4_MASK, VMACC_VV }, // 6905
  { PseudoVMACC_VV_MF8, VMACC_VV }, // 6906
  { PseudoVMACC_VV_MF8_MASK, VMACC_VV }, // 6907
  { PseudoVMACC_VX_M1, VMACC_VX }, // 6908
  { PseudoVMACC_VX_M1_MASK, VMACC_VX }, // 6909
  { PseudoVMACC_VX_M2, VMACC_VX }, // 6910
  { PseudoVMACC_VX_M2_MASK, VMACC_VX }, // 6911
  { PseudoVMACC_VX_M4, VMACC_VX }, // 6912
  { PseudoVMACC_VX_M4_MASK, VMACC_VX }, // 6913
  { PseudoVMACC_VX_M8, VMACC_VX }, // 6914
  { PseudoVMACC_VX_M8_MASK, VMACC_VX }, // 6915
  { PseudoVMACC_VX_MF2, VMACC_VX }, // 6916
  { PseudoVMACC_VX_MF2_MASK, VMACC_VX }, // 6917
  { PseudoVMACC_VX_MF4, VMACC_VX }, // 6918
  { PseudoVMACC_VX_MF4_MASK, VMACC_VX }, // 6919
  { PseudoVMACC_VX_MF8, VMACC_VX }, // 6920
  { PseudoVMACC_VX_MF8_MASK, VMACC_VX }, // 6921
  { PseudoVMADC_VIM_M1, VMADC_VIM }, // 6922
  { PseudoVMADC_VIM_M2, VMADC_VIM }, // 6923
  { PseudoVMADC_VIM_M4, VMADC_VIM }, // 6924
  { PseudoVMADC_VIM_M8, VMADC_VIM }, // 6925
  { PseudoVMADC_VIM_MF2, VMADC_VIM }, // 6926
  { PseudoVMADC_VIM_MF4, VMADC_VIM }, // 6927
  { PseudoVMADC_VIM_MF8, VMADC_VIM }, // 6928
  { PseudoVMADC_VI_M1, VMADC_VI }, // 6929
  { PseudoVMADC_VI_M2, VMADC_VI }, // 6930
  { PseudoVMADC_VI_M4, VMADC_VI }, // 6931
  { PseudoVMADC_VI_M8, VMADC_VI }, // 6932
  { PseudoVMADC_VI_MF2, VMADC_VI }, // 6933
  { PseudoVMADC_VI_MF4, VMADC_VI }, // 6934
  { PseudoVMADC_VI_MF8, VMADC_VI }, // 6935
  { PseudoVMADC_VVM_M1, VMADC_VVM }, // 6936
  { PseudoVMADC_VVM_M2, VMADC_VVM }, // 6937
  { PseudoVMADC_VVM_M4, VMADC_VVM }, // 6938
  { PseudoVMADC_VVM_M8, VMADC_VVM }, // 6939
  { PseudoVMADC_VVM_MF2, VMADC_VVM }, // 6940
  { PseudoVMADC_VVM_MF4, VMADC_VVM }, // 6941
  { PseudoVMADC_VVM_MF8, VMADC_VVM }, // 6942
  { PseudoVMADC_VV_M1, VMADC_VV }, // 6943
  { PseudoVMADC_VV_M2, VMADC_VV }, // 6944
  { PseudoVMADC_VV_M4, VMADC_VV }, // 6945
  { PseudoVMADC_VV_M8, VMADC_VV }, // 6946
  { PseudoVMADC_VV_MF2, VMADC_VV }, // 6947
  { PseudoVMADC_VV_MF4, VMADC_VV }, // 6948
  { PseudoVMADC_VV_MF8, VMADC_VV }, // 6949
  { PseudoVMADC_VXM_M1, VMADC_VXM }, // 6950
  { PseudoVMADC_VXM_M2, VMADC_VXM }, // 6951
  { PseudoVMADC_VXM_M4, VMADC_VXM }, // 6952
  { PseudoVMADC_VXM_M8, VMADC_VXM }, // 6953
  { PseudoVMADC_VXM_MF2, VMADC_VXM }, // 6954
  { PseudoVMADC_VXM_MF4, VMADC_VXM }, // 6955
  { PseudoVMADC_VXM_MF8, VMADC_VXM }, // 6956
  { PseudoVMADC_VX_M1, VMADC_VX }, // 6957
  { PseudoVMADC_VX_M2, VMADC_VX }, // 6958
  { PseudoVMADC_VX_M4, VMADC_VX }, // 6959
  { PseudoVMADC_VX_M8, VMADC_VX }, // 6960
  { PseudoVMADC_VX_MF2, VMADC_VX }, // 6961
  { PseudoVMADC_VX_MF4, VMADC_VX }, // 6962
  { PseudoVMADC_VX_MF8, VMADC_VX }, // 6963
  { PseudoVMADD_VV_M1, VMADD_VV }, // 6964
  { PseudoVMADD_VV_M1_MASK, VMADD_VV }, // 6965
  { PseudoVMADD_VV_M2, VMADD_VV }, // 6966
  { PseudoVMADD_VV_M2_MASK, VMADD_VV }, // 6967
  { PseudoVMADD_VV_M4, VMADD_VV }, // 6968
  { PseudoVMADD_VV_M4_MASK, VMADD_VV }, // 6969
  { PseudoVMADD_VV_M8, VMADD_VV }, // 6970
  { PseudoVMADD_VV_M8_MASK, VMADD_VV }, // 6971
  { PseudoVMADD_VV_MF2, VMADD_VV }, // 6972
  { PseudoVMADD_VV_MF2_MASK, VMADD_VV }, // 6973
  { PseudoVMADD_VV_MF4, VMADD_VV }, // 6974
  { PseudoVMADD_VV_MF4_MASK, VMADD_VV }, // 6975
  { PseudoVMADD_VV_MF8, VMADD_VV }, // 6976
  { PseudoVMADD_VV_MF8_MASK, VMADD_VV }, // 6977
  { PseudoVMADD_VX_M1, VMADD_VX }, // 6978
  { PseudoVMADD_VX_M1_MASK, VMADD_VX }, // 6979
  { PseudoVMADD_VX_M2, VMADD_VX }, // 6980
  { PseudoVMADD_VX_M2_MASK, VMADD_VX }, // 6981
  { PseudoVMADD_VX_M4, VMADD_VX }, // 6982
  { PseudoVMADD_VX_M4_MASK, VMADD_VX }, // 6983
  { PseudoVMADD_VX_M8, VMADD_VX }, // 6984
  { PseudoVMADD_VX_M8_MASK, VMADD_VX }, // 6985
  { PseudoVMADD_VX_MF2, VMADD_VX }, // 6986
  { PseudoVMADD_VX_MF2_MASK, VMADD_VX }, // 6987
  { PseudoVMADD_VX_MF4, VMADD_VX }, // 6988
  { PseudoVMADD_VX_MF4_MASK, VMADD_VX }, // 6989
  { PseudoVMADD_VX_MF8, VMADD_VX }, // 6990
  { PseudoVMADD_VX_MF8_MASK, VMADD_VX }, // 6991
  { PseudoVMANDN_MM_M1, VMANDN_MM }, // 6992
  { PseudoVMANDN_MM_M2, VMANDN_MM }, // 6993
  { PseudoVMANDN_MM_M4, VMANDN_MM }, // 6994
  { PseudoVMANDN_MM_M8, VMANDN_MM }, // 6995
  { PseudoVMANDN_MM_MF2, VMANDN_MM }, // 6996
  { PseudoVMANDN_MM_MF4, VMANDN_MM }, // 6997
  { PseudoVMANDN_MM_MF8, VMANDN_MM }, // 6998
  { PseudoVMAND_MM_M1, VMAND_MM }, // 6999
  { PseudoVMAND_MM_M2, VMAND_MM }, // 7000
  { PseudoVMAND_MM_M4, VMAND_MM }, // 7001
  { PseudoVMAND_MM_M8, VMAND_MM }, // 7002
  { PseudoVMAND_MM_MF2, VMAND_MM }, // 7003
  { PseudoVMAND_MM_MF4, VMAND_MM }, // 7004
  { PseudoVMAND_MM_MF8, VMAND_MM }, // 7005
  { PseudoVMAXU_VV_M1, VMAXU_VV }, // 7006
  { PseudoVMAXU_VV_M1_MASK, VMAXU_VV }, // 7007
  { PseudoVMAXU_VV_M1_TU, VMAXU_VV }, // 7008
  { PseudoVMAXU_VV_M2, VMAXU_VV }, // 7009
  { PseudoVMAXU_VV_M2_MASK, VMAXU_VV }, // 7010
  { PseudoVMAXU_VV_M2_TU, VMAXU_VV }, // 7011
  { PseudoVMAXU_VV_M4, VMAXU_VV }, // 7012
  { PseudoVMAXU_VV_M4_MASK, VMAXU_VV }, // 7013
  { PseudoVMAXU_VV_M4_TU, VMAXU_VV }, // 7014
  { PseudoVMAXU_VV_M8, VMAXU_VV }, // 7015
  { PseudoVMAXU_VV_M8_MASK, VMAXU_VV }, // 7016
  { PseudoVMAXU_VV_M8_TU, VMAXU_VV }, // 7017
  { PseudoVMAXU_VV_MF2, VMAXU_VV }, // 7018
  { PseudoVMAXU_VV_MF2_MASK, VMAXU_VV }, // 7019
  { PseudoVMAXU_VV_MF2_TU, VMAXU_VV }, // 7020
  { PseudoVMAXU_VV_MF4, VMAXU_VV }, // 7021
  { PseudoVMAXU_VV_MF4_MASK, VMAXU_VV }, // 7022
  { PseudoVMAXU_VV_MF4_TU, VMAXU_VV }, // 7023
  { PseudoVMAXU_VV_MF8, VMAXU_VV }, // 7024
  { PseudoVMAXU_VV_MF8_MASK, VMAXU_VV }, // 7025
  { PseudoVMAXU_VV_MF8_TU, VMAXU_VV }, // 7026
  { PseudoVMAXU_VX_M1, VMAXU_VX }, // 7027
  { PseudoVMAXU_VX_M1_MASK, VMAXU_VX }, // 7028
  { PseudoVMAXU_VX_M1_TU, VMAXU_VX }, // 7029
  { PseudoVMAXU_VX_M2, VMAXU_VX }, // 7030
  { PseudoVMAXU_VX_M2_MASK, VMAXU_VX }, // 7031
  { PseudoVMAXU_VX_M2_TU, VMAXU_VX }, // 7032
  { PseudoVMAXU_VX_M4, VMAXU_VX }, // 7033
  { PseudoVMAXU_VX_M4_MASK, VMAXU_VX }, // 7034
  { PseudoVMAXU_VX_M4_TU, VMAXU_VX }, // 7035
  { PseudoVMAXU_VX_M8, VMAXU_VX }, // 7036
  { PseudoVMAXU_VX_M8_MASK, VMAXU_VX }, // 7037
  { PseudoVMAXU_VX_M8_TU, VMAXU_VX }, // 7038
  { PseudoVMAXU_VX_MF2, VMAXU_VX }, // 7039
  { PseudoVMAXU_VX_MF2_MASK, VMAXU_VX }, // 7040
  { PseudoVMAXU_VX_MF2_TU, VMAXU_VX }, // 7041
  { PseudoVMAXU_VX_MF4, VMAXU_VX }, // 7042
  { PseudoVMAXU_VX_MF4_MASK, VMAXU_VX }, // 7043
  { PseudoVMAXU_VX_MF4_TU, VMAXU_VX }, // 7044
  { PseudoVMAXU_VX_MF8, VMAXU_VX }, // 7045
  { PseudoVMAXU_VX_MF8_MASK, VMAXU_VX }, // 7046
  { PseudoVMAXU_VX_MF8_TU, VMAXU_VX }, // 7047
  { PseudoVMAX_VV_M1, VMAX_VV }, // 7048
  { PseudoVMAX_VV_M1_MASK, VMAX_VV }, // 7049
  { PseudoVMAX_VV_M1_TU, VMAX_VV }, // 7050
  { PseudoVMAX_VV_M2, VMAX_VV }, // 7051
  { PseudoVMAX_VV_M2_MASK, VMAX_VV }, // 7052
  { PseudoVMAX_VV_M2_TU, VMAX_VV }, // 7053
  { PseudoVMAX_VV_M4, VMAX_VV }, // 7054
  { PseudoVMAX_VV_M4_MASK, VMAX_VV }, // 7055
  { PseudoVMAX_VV_M4_TU, VMAX_VV }, // 7056
  { PseudoVMAX_VV_M8, VMAX_VV }, // 7057
  { PseudoVMAX_VV_M8_MASK, VMAX_VV }, // 7058
  { PseudoVMAX_VV_M8_TU, VMAX_VV }, // 7059
  { PseudoVMAX_VV_MF2, VMAX_VV }, // 7060
  { PseudoVMAX_VV_MF2_MASK, VMAX_VV }, // 7061
  { PseudoVMAX_VV_MF2_TU, VMAX_VV }, // 7062
  { PseudoVMAX_VV_MF4, VMAX_VV }, // 7063
  { PseudoVMAX_VV_MF4_MASK, VMAX_VV }, // 7064
  { PseudoVMAX_VV_MF4_TU, VMAX_VV }, // 7065
  { PseudoVMAX_VV_MF8, VMAX_VV }, // 7066
  { PseudoVMAX_VV_MF8_MASK, VMAX_VV }, // 7067
  { PseudoVMAX_VV_MF8_TU, VMAX_VV }, // 7068
  { PseudoVMAX_VX_M1, VMAX_VX }, // 7069
  { PseudoVMAX_VX_M1_MASK, VMAX_VX }, // 7070
  { PseudoVMAX_VX_M1_TU, VMAX_VX }, // 7071
  { PseudoVMAX_VX_M2, VMAX_VX }, // 7072
  { PseudoVMAX_VX_M2_MASK, VMAX_VX }, // 7073
  { PseudoVMAX_VX_M2_TU, VMAX_VX }, // 7074
  { PseudoVMAX_VX_M4, VMAX_VX }, // 7075
  { PseudoVMAX_VX_M4_MASK, VMAX_VX }, // 7076
  { PseudoVMAX_VX_M4_TU, VMAX_VX }, // 7077
  { PseudoVMAX_VX_M8, VMAX_VX }, // 7078
  { PseudoVMAX_VX_M8_MASK, VMAX_VX }, // 7079
  { PseudoVMAX_VX_M8_TU, VMAX_VX }, // 7080
  { PseudoVMAX_VX_MF2, VMAX_VX }, // 7081
  { PseudoVMAX_VX_MF2_MASK, VMAX_VX }, // 7082
  { PseudoVMAX_VX_MF2_TU, VMAX_VX }, // 7083
  { PseudoVMAX_VX_MF4, VMAX_VX }, // 7084
  { PseudoVMAX_VX_MF4_MASK, VMAX_VX }, // 7085
  { PseudoVMAX_VX_MF4_TU, VMAX_VX }, // 7086
  { PseudoVMAX_VX_MF8, VMAX_VX }, // 7087
  { PseudoVMAX_VX_MF8_MASK, VMAX_VX }, // 7088
  { PseudoVMAX_VX_MF8_TU, VMAX_VX }, // 7089
  { PseudoVMCLR_M_B1, VMXOR_MM }, // 7090
  { PseudoVMCLR_M_B16, VMXOR_MM }, // 7091
  { PseudoVMCLR_M_B2, VMXOR_MM }, // 7092
  { PseudoVMCLR_M_B32, VMXOR_MM }, // 7093
  { PseudoVMCLR_M_B4, VMXOR_MM }, // 7094
  { PseudoVMCLR_M_B64, VMXOR_MM }, // 7095
  { PseudoVMCLR_M_B8, VMXOR_MM }, // 7096
  { PseudoVMERGE_VIM_M1, VMERGE_VIM }, // 7097
  { PseudoVMERGE_VIM_M1_TU, VMERGE_VIM }, // 7098
  { PseudoVMERGE_VIM_M2, VMERGE_VIM }, // 7099
  { PseudoVMERGE_VIM_M2_TU, VMERGE_VIM }, // 7100
  { PseudoVMERGE_VIM_M4, VMERGE_VIM }, // 7101
  { PseudoVMERGE_VIM_M4_TU, VMERGE_VIM }, // 7102
  { PseudoVMERGE_VIM_M8, VMERGE_VIM }, // 7103
  { PseudoVMERGE_VIM_M8_TU, VMERGE_VIM }, // 7104
  { PseudoVMERGE_VIM_MF2, VMERGE_VIM }, // 7105
  { PseudoVMERGE_VIM_MF2_TU, VMERGE_VIM }, // 7106
  { PseudoVMERGE_VIM_MF4, VMERGE_VIM }, // 7107
  { PseudoVMERGE_VIM_MF4_TU, VMERGE_VIM }, // 7108
  { PseudoVMERGE_VIM_MF8, VMERGE_VIM }, // 7109
  { PseudoVMERGE_VIM_MF8_TU, VMERGE_VIM }, // 7110
  { PseudoVMERGE_VVM_M1, VMERGE_VVM }, // 7111
  { PseudoVMERGE_VVM_M1_TU, VMERGE_VVM }, // 7112
  { PseudoVMERGE_VVM_M2, VMERGE_VVM }, // 7113
  { PseudoVMERGE_VVM_M2_TU, VMERGE_VVM }, // 7114
  { PseudoVMERGE_VVM_M4, VMERGE_VVM }, // 7115
  { PseudoVMERGE_VVM_M4_TU, VMERGE_VVM }, // 7116
  { PseudoVMERGE_VVM_M8, VMERGE_VVM }, // 7117
  { PseudoVMERGE_VVM_M8_TU, VMERGE_VVM }, // 7118
  { PseudoVMERGE_VVM_MF2, VMERGE_VVM }, // 7119
  { PseudoVMERGE_VVM_MF2_TU, VMERGE_VVM }, // 7120
  { PseudoVMERGE_VVM_MF4, VMERGE_VVM }, // 7121
  { PseudoVMERGE_VVM_MF4_TU, VMERGE_VVM }, // 7122
  { PseudoVMERGE_VVM_MF8, VMERGE_VVM }, // 7123
  { PseudoVMERGE_VVM_MF8_TU, VMERGE_VVM }, // 7124
  { PseudoVMERGE_VXM_M1, VMERGE_VXM }, // 7125
  { PseudoVMERGE_VXM_M1_TU, VMERGE_VXM }, // 7126
  { PseudoVMERGE_VXM_M2, VMERGE_VXM }, // 7127
  { PseudoVMERGE_VXM_M2_TU, VMERGE_VXM }, // 7128
  { PseudoVMERGE_VXM_M4, VMERGE_VXM }, // 7129
  { PseudoVMERGE_VXM_M4_TU, VMERGE_VXM }, // 7130
  { PseudoVMERGE_VXM_M8, VMERGE_VXM }, // 7131
  { PseudoVMERGE_VXM_M8_TU, VMERGE_VXM }, // 7132
  { PseudoVMERGE_VXM_MF2, VMERGE_VXM }, // 7133
  { PseudoVMERGE_VXM_MF2_TU, VMERGE_VXM }, // 7134
  { PseudoVMERGE_VXM_MF4, VMERGE_VXM }, // 7135
  { PseudoVMERGE_VXM_MF4_TU, VMERGE_VXM }, // 7136
  { PseudoVMERGE_VXM_MF8, VMERGE_VXM }, // 7137
  { PseudoVMERGE_VXM_MF8_TU, VMERGE_VXM }, // 7138
  { PseudoVMFEQ_VF16_M1, VMFEQ_VF }, // 7139
  { PseudoVMFEQ_VF16_M1_MASK, VMFEQ_VF }, // 7140
  { PseudoVMFEQ_VF16_M2, VMFEQ_VF }, // 7141
  { PseudoVMFEQ_VF16_M2_MASK, VMFEQ_VF }, // 7142
  { PseudoVMFEQ_VF16_M4, VMFEQ_VF }, // 7143
  { PseudoVMFEQ_VF16_M4_MASK, VMFEQ_VF }, // 7144
  { PseudoVMFEQ_VF16_M8, VMFEQ_VF }, // 7145
  { PseudoVMFEQ_VF16_M8_MASK, VMFEQ_VF }, // 7146
  { PseudoVMFEQ_VF16_MF2, VMFEQ_VF }, // 7147
  { PseudoVMFEQ_VF16_MF2_MASK, VMFEQ_VF }, // 7148
  { PseudoVMFEQ_VF16_MF4, VMFEQ_VF }, // 7149
  { PseudoVMFEQ_VF16_MF4_MASK, VMFEQ_VF }, // 7150
  { PseudoVMFEQ_VF32_M1, VMFEQ_VF }, // 7151
  { PseudoVMFEQ_VF32_M1_MASK, VMFEQ_VF }, // 7152
  { PseudoVMFEQ_VF32_M2, VMFEQ_VF }, // 7153
  { PseudoVMFEQ_VF32_M2_MASK, VMFEQ_VF }, // 7154
  { PseudoVMFEQ_VF32_M4, VMFEQ_VF }, // 7155
  { PseudoVMFEQ_VF32_M4_MASK, VMFEQ_VF }, // 7156
  { PseudoVMFEQ_VF32_M8, VMFEQ_VF }, // 7157
  { PseudoVMFEQ_VF32_M8_MASK, VMFEQ_VF }, // 7158
  { PseudoVMFEQ_VF32_MF2, VMFEQ_VF }, // 7159
  { PseudoVMFEQ_VF32_MF2_MASK, VMFEQ_VF }, // 7160
  { PseudoVMFEQ_VF64_M1, VMFEQ_VF }, // 7161
  { PseudoVMFEQ_VF64_M1_MASK, VMFEQ_VF }, // 7162
  { PseudoVMFEQ_VF64_M2, VMFEQ_VF }, // 7163
  { PseudoVMFEQ_VF64_M2_MASK, VMFEQ_VF }, // 7164
  { PseudoVMFEQ_VF64_M4, VMFEQ_VF }, // 7165
  { PseudoVMFEQ_VF64_M4_MASK, VMFEQ_VF }, // 7166
  { PseudoVMFEQ_VF64_M8, VMFEQ_VF }, // 7167
  { PseudoVMFEQ_VF64_M8_MASK, VMFEQ_VF }, // 7168
  { PseudoVMFEQ_VV_M1, VMFEQ_VV }, // 7169
  { PseudoVMFEQ_VV_M1_MASK, VMFEQ_VV }, // 7170
  { PseudoVMFEQ_VV_M2, VMFEQ_VV }, // 7171
  { PseudoVMFEQ_VV_M2_MASK, VMFEQ_VV }, // 7172
  { PseudoVMFEQ_VV_M4, VMFEQ_VV }, // 7173
  { PseudoVMFEQ_VV_M4_MASK, VMFEQ_VV }, // 7174
  { PseudoVMFEQ_VV_M8, VMFEQ_VV }, // 7175
  { PseudoVMFEQ_VV_M8_MASK, VMFEQ_VV }, // 7176
  { PseudoVMFEQ_VV_MF2, VMFEQ_VV }, // 7177
  { PseudoVMFEQ_VV_MF2_MASK, VMFEQ_VV }, // 7178
  { PseudoVMFEQ_VV_MF4, VMFEQ_VV }, // 7179
  { PseudoVMFEQ_VV_MF4_MASK, VMFEQ_VV }, // 7180
  { PseudoVMFGE_VF16_M1, VMFGE_VF }, // 7181
  { PseudoVMFGE_VF16_M1_MASK, VMFGE_VF }, // 7182
  { PseudoVMFGE_VF16_M2, VMFGE_VF }, // 7183
  { PseudoVMFGE_VF16_M2_MASK, VMFGE_VF }, // 7184
  { PseudoVMFGE_VF16_M4, VMFGE_VF }, // 7185
  { PseudoVMFGE_VF16_M4_MASK, VMFGE_VF }, // 7186
  { PseudoVMFGE_VF16_M8, VMFGE_VF }, // 7187
  { PseudoVMFGE_VF16_M8_MASK, VMFGE_VF }, // 7188
  { PseudoVMFGE_VF16_MF2, VMFGE_VF }, // 7189
  { PseudoVMFGE_VF16_MF2_MASK, VMFGE_VF }, // 7190
  { PseudoVMFGE_VF16_MF4, VMFGE_VF }, // 7191
  { PseudoVMFGE_VF16_MF4_MASK, VMFGE_VF }, // 7192
  { PseudoVMFGE_VF32_M1, VMFGE_VF }, // 7193
  { PseudoVMFGE_VF32_M1_MASK, VMFGE_VF }, // 7194
  { PseudoVMFGE_VF32_M2, VMFGE_VF }, // 7195
  { PseudoVMFGE_VF32_M2_MASK, VMFGE_VF }, // 7196
  { PseudoVMFGE_VF32_M4, VMFGE_VF }, // 7197
  { PseudoVMFGE_VF32_M4_MASK, VMFGE_VF }, // 7198
  { PseudoVMFGE_VF32_M8, VMFGE_VF }, // 7199
  { PseudoVMFGE_VF32_M8_MASK, VMFGE_VF }, // 7200
  { PseudoVMFGE_VF32_MF2, VMFGE_VF }, // 7201
  { PseudoVMFGE_VF32_MF2_MASK, VMFGE_VF }, // 7202
  { PseudoVMFGE_VF64_M1, VMFGE_VF }, // 7203
  { PseudoVMFGE_VF64_M1_MASK, VMFGE_VF }, // 7204
  { PseudoVMFGE_VF64_M2, VMFGE_VF }, // 7205
  { PseudoVMFGE_VF64_M2_MASK, VMFGE_VF }, // 7206
  { PseudoVMFGE_VF64_M4, VMFGE_VF }, // 7207
  { PseudoVMFGE_VF64_M4_MASK, VMFGE_VF }, // 7208
  { PseudoVMFGE_VF64_M8, VMFGE_VF }, // 7209
  { PseudoVMFGE_VF64_M8_MASK, VMFGE_VF }, // 7210
  { PseudoVMFGT_VF16_M1, VMFGT_VF }, // 7211
  { PseudoVMFGT_VF16_M1_MASK, VMFGT_VF }, // 7212
  { PseudoVMFGT_VF16_M2, VMFGT_VF }, // 7213
  { PseudoVMFGT_VF16_M2_MASK, VMFGT_VF }, // 7214
  { PseudoVMFGT_VF16_M4, VMFGT_VF }, // 7215
  { PseudoVMFGT_VF16_M4_MASK, VMFGT_VF }, // 7216
  { PseudoVMFGT_VF16_M8, VMFGT_VF }, // 7217
  { PseudoVMFGT_VF16_M8_MASK, VMFGT_VF }, // 7218
  { PseudoVMFGT_VF16_MF2, VMFGT_VF }, // 7219
  { PseudoVMFGT_VF16_MF2_MASK, VMFGT_VF }, // 7220
  { PseudoVMFGT_VF16_MF4, VMFGT_VF }, // 7221
  { PseudoVMFGT_VF16_MF4_MASK, VMFGT_VF }, // 7222
  { PseudoVMFGT_VF32_M1, VMFGT_VF }, // 7223
  { PseudoVMFGT_VF32_M1_MASK, VMFGT_VF }, // 7224
  { PseudoVMFGT_VF32_M2, VMFGT_VF }, // 7225
  { PseudoVMFGT_VF32_M2_MASK, VMFGT_VF }, // 7226
  { PseudoVMFGT_VF32_M4, VMFGT_VF }, // 7227
  { PseudoVMFGT_VF32_M4_MASK, VMFGT_VF }, // 7228
  { PseudoVMFGT_VF32_M8, VMFGT_VF }, // 7229
  { PseudoVMFGT_VF32_M8_MASK, VMFGT_VF }, // 7230
  { PseudoVMFGT_VF32_MF2, VMFGT_VF }, // 7231
  { PseudoVMFGT_VF32_MF2_MASK, VMFGT_VF }, // 7232
  { PseudoVMFGT_VF64_M1, VMFGT_VF }, // 7233
  { PseudoVMFGT_VF64_M1_MASK, VMFGT_VF }, // 7234
  { PseudoVMFGT_VF64_M2, VMFGT_VF }, // 7235
  { PseudoVMFGT_VF64_M2_MASK, VMFGT_VF }, // 7236
  { PseudoVMFGT_VF64_M4, VMFGT_VF }, // 7237
  { PseudoVMFGT_VF64_M4_MASK, VMFGT_VF }, // 7238
  { PseudoVMFGT_VF64_M8, VMFGT_VF }, // 7239
  { PseudoVMFGT_VF64_M8_MASK, VMFGT_VF }, // 7240
  { PseudoVMFLE_VF16_M1, VMFLE_VF }, // 7241
  { PseudoVMFLE_VF16_M1_MASK, VMFLE_VF }, // 7242
  { PseudoVMFLE_VF16_M2, VMFLE_VF }, // 7243
  { PseudoVMFLE_VF16_M2_MASK, VMFLE_VF }, // 7244
  { PseudoVMFLE_VF16_M4, VMFLE_VF }, // 7245
  { PseudoVMFLE_VF16_M4_MASK, VMFLE_VF }, // 7246
  { PseudoVMFLE_VF16_M8, VMFLE_VF }, // 7247
  { PseudoVMFLE_VF16_M8_MASK, VMFLE_VF }, // 7248
  { PseudoVMFLE_VF16_MF2, VMFLE_VF }, // 7249
  { PseudoVMFLE_VF16_MF2_MASK, VMFLE_VF }, // 7250
  { PseudoVMFLE_VF16_MF4, VMFLE_VF }, // 7251
  { PseudoVMFLE_VF16_MF4_MASK, VMFLE_VF }, // 7252
  { PseudoVMFLE_VF32_M1, VMFLE_VF }, // 7253
  { PseudoVMFLE_VF32_M1_MASK, VMFLE_VF }, // 7254
  { PseudoVMFLE_VF32_M2, VMFLE_VF }, // 7255
  { PseudoVMFLE_VF32_M2_MASK, VMFLE_VF }, // 7256
  { PseudoVMFLE_VF32_M4, VMFLE_VF }, // 7257
  { PseudoVMFLE_VF32_M4_MASK, VMFLE_VF }, // 7258
  { PseudoVMFLE_VF32_M8, VMFLE_VF }, // 7259
  { PseudoVMFLE_VF32_M8_MASK, VMFLE_VF }, // 7260
  { PseudoVMFLE_VF32_MF2, VMFLE_VF }, // 7261
  { PseudoVMFLE_VF32_MF2_MASK, VMFLE_VF }, // 7262
  { PseudoVMFLE_VF64_M1, VMFLE_VF }, // 7263
  { PseudoVMFLE_VF64_M1_MASK, VMFLE_VF }, // 7264
  { PseudoVMFLE_VF64_M2, VMFLE_VF }, // 7265
  { PseudoVMFLE_VF64_M2_MASK, VMFLE_VF }, // 7266
  { PseudoVMFLE_VF64_M4, VMFLE_VF }, // 7267
  { PseudoVMFLE_VF64_M4_MASK, VMFLE_VF }, // 7268
  { PseudoVMFLE_VF64_M8, VMFLE_VF }, // 7269
  { PseudoVMFLE_VF64_M8_MASK, VMFLE_VF }, // 7270
  { PseudoVMFLE_VV_M1, VMFLE_VV }, // 7271
  { PseudoVMFLE_VV_M1_MASK, VMFLE_VV }, // 7272
  { PseudoVMFLE_VV_M2, VMFLE_VV }, // 7273
  { PseudoVMFLE_VV_M2_MASK, VMFLE_VV }, // 7274
  { PseudoVMFLE_VV_M4, VMFLE_VV }, // 7275
  { PseudoVMFLE_VV_M4_MASK, VMFLE_VV }, // 7276
  { PseudoVMFLE_VV_M8, VMFLE_VV }, // 7277
  { PseudoVMFLE_VV_M8_MASK, VMFLE_VV }, // 7278
  { PseudoVMFLE_VV_MF2, VMFLE_VV }, // 7279
  { PseudoVMFLE_VV_MF2_MASK, VMFLE_VV }, // 7280
  { PseudoVMFLE_VV_MF4, VMFLE_VV }, // 7281
  { PseudoVMFLE_VV_MF4_MASK, VMFLE_VV }, // 7282
  { PseudoVMFLT_VF16_M1, VMFLT_VF }, // 7283
  { PseudoVMFLT_VF16_M1_MASK, VMFLT_VF }, // 7284
  { PseudoVMFLT_VF16_M2, VMFLT_VF }, // 7285
  { PseudoVMFLT_VF16_M2_MASK, VMFLT_VF }, // 7286
  { PseudoVMFLT_VF16_M4, VMFLT_VF }, // 7287
  { PseudoVMFLT_VF16_M4_MASK, VMFLT_VF }, // 7288
  { PseudoVMFLT_VF16_M8, VMFLT_VF }, // 7289
  { PseudoVMFLT_VF16_M8_MASK, VMFLT_VF }, // 7290
  { PseudoVMFLT_VF16_MF2, VMFLT_VF }, // 7291
  { PseudoVMFLT_VF16_MF2_MASK, VMFLT_VF }, // 7292
  { PseudoVMFLT_VF16_MF4, VMFLT_VF }, // 7293
  { PseudoVMFLT_VF16_MF4_MASK, VMFLT_VF }, // 7294
  { PseudoVMFLT_VF32_M1, VMFLT_VF }, // 7295
  { PseudoVMFLT_VF32_M1_MASK, VMFLT_VF }, // 7296
  { PseudoVMFLT_VF32_M2, VMFLT_VF }, // 7297
  { PseudoVMFLT_VF32_M2_MASK, VMFLT_VF }, // 7298
  { PseudoVMFLT_VF32_M4, VMFLT_VF }, // 7299
  { PseudoVMFLT_VF32_M4_MASK, VMFLT_VF }, // 7300
  { PseudoVMFLT_VF32_M8, VMFLT_VF }, // 7301
  { PseudoVMFLT_VF32_M8_MASK, VMFLT_VF }, // 7302
  { PseudoVMFLT_VF32_MF2, VMFLT_VF }, // 7303
  { PseudoVMFLT_VF32_MF2_MASK, VMFLT_VF }, // 7304
  { PseudoVMFLT_VF64_M1, VMFLT_VF }, // 7305
  { PseudoVMFLT_VF64_M1_MASK, VMFLT_VF }, // 7306
  { PseudoVMFLT_VF64_M2, VMFLT_VF }, // 7307
  { PseudoVMFLT_VF64_M2_MASK, VMFLT_VF }, // 7308
  { PseudoVMFLT_VF64_M4, VMFLT_VF }, // 7309
  { PseudoVMFLT_VF64_M4_MASK, VMFLT_VF }, // 7310
  { PseudoVMFLT_VF64_M8, VMFLT_VF }, // 7311
  { PseudoVMFLT_VF64_M8_MASK, VMFLT_VF }, // 7312
  { PseudoVMFLT_VV_M1, VMFLT_VV }, // 7313
  { PseudoVMFLT_VV_M1_MASK, VMFLT_VV }, // 7314
  { PseudoVMFLT_VV_M2, VMFLT_VV }, // 7315
  { PseudoVMFLT_VV_M2_MASK, VMFLT_VV }, // 7316
  { PseudoVMFLT_VV_M4, VMFLT_VV }, // 7317
  { PseudoVMFLT_VV_M4_MASK, VMFLT_VV }, // 7318
  { PseudoVMFLT_VV_M8, VMFLT_VV }, // 7319
  { PseudoVMFLT_VV_M8_MASK, VMFLT_VV }, // 7320
  { PseudoVMFLT_VV_MF2, VMFLT_VV }, // 7321
  { PseudoVMFLT_VV_MF2_MASK, VMFLT_VV }, // 7322
  { PseudoVMFLT_VV_MF4, VMFLT_VV }, // 7323
  { PseudoVMFLT_VV_MF4_MASK, VMFLT_VV }, // 7324
  { PseudoVMFNE_VF16_M1, VMFNE_VF }, // 7325
  { PseudoVMFNE_VF16_M1_MASK, VMFNE_VF }, // 7326
  { PseudoVMFNE_VF16_M2, VMFNE_VF }, // 7327
  { PseudoVMFNE_VF16_M2_MASK, VMFNE_VF }, // 7328
  { PseudoVMFNE_VF16_M4, VMFNE_VF }, // 7329
  { PseudoVMFNE_VF16_M4_MASK, VMFNE_VF }, // 7330
  { PseudoVMFNE_VF16_M8, VMFNE_VF }, // 7331
  { PseudoVMFNE_VF16_M8_MASK, VMFNE_VF }, // 7332
  { PseudoVMFNE_VF16_MF2, VMFNE_VF }, // 7333
  { PseudoVMFNE_VF16_MF2_MASK, VMFNE_VF }, // 7334
  { PseudoVMFNE_VF16_MF4, VMFNE_VF }, // 7335
  { PseudoVMFNE_VF16_MF4_MASK, VMFNE_VF }, // 7336
  { PseudoVMFNE_VF32_M1, VMFNE_VF }, // 7337
  { PseudoVMFNE_VF32_M1_MASK, VMFNE_VF }, // 7338
  { PseudoVMFNE_VF32_M2, VMFNE_VF }, // 7339
  { PseudoVMFNE_VF32_M2_MASK, VMFNE_VF }, // 7340
  { PseudoVMFNE_VF32_M4, VMFNE_VF }, // 7341
  { PseudoVMFNE_VF32_M4_MASK, VMFNE_VF }, // 7342
  { PseudoVMFNE_VF32_M8, VMFNE_VF }, // 7343
  { PseudoVMFNE_VF32_M8_MASK, VMFNE_VF }, // 7344
  { PseudoVMFNE_VF32_MF2, VMFNE_VF }, // 7345
  { PseudoVMFNE_VF32_MF2_MASK, VMFNE_VF }, // 7346
  { PseudoVMFNE_VF64_M1, VMFNE_VF }, // 7347
  { PseudoVMFNE_VF64_M1_MASK, VMFNE_VF }, // 7348
  { PseudoVMFNE_VF64_M2, VMFNE_VF }, // 7349
  { PseudoVMFNE_VF64_M2_MASK, VMFNE_VF }, // 7350
  { PseudoVMFNE_VF64_M4, VMFNE_VF }, // 7351
  { PseudoVMFNE_VF64_M4_MASK, VMFNE_VF }, // 7352
  { PseudoVMFNE_VF64_M8, VMFNE_VF }, // 7353
  { PseudoVMFNE_VF64_M8_MASK, VMFNE_VF }, // 7354
  { PseudoVMFNE_VV_M1, VMFNE_VV }, // 7355
  { PseudoVMFNE_VV_M1_MASK, VMFNE_VV }, // 7356
  { PseudoVMFNE_VV_M2, VMFNE_VV }, // 7357
  { PseudoVMFNE_VV_M2_MASK, VMFNE_VV }, // 7358
  { PseudoVMFNE_VV_M4, VMFNE_VV }, // 7359
  { PseudoVMFNE_VV_M4_MASK, VMFNE_VV }, // 7360
  { PseudoVMFNE_VV_M8, VMFNE_VV }, // 7361
  { PseudoVMFNE_VV_M8_MASK, VMFNE_VV }, // 7362
  { PseudoVMFNE_VV_MF2, VMFNE_VV }, // 7363
  { PseudoVMFNE_VV_MF2_MASK, VMFNE_VV }, // 7364
  { PseudoVMFNE_VV_MF4, VMFNE_VV }, // 7365
  { PseudoVMFNE_VV_MF4_MASK, VMFNE_VV }, // 7366
  { PseudoVMINU_VV_M1, VMINU_VV }, // 7367
  { PseudoVMINU_VV_M1_MASK, VMINU_VV }, // 7368
  { PseudoVMINU_VV_M1_TU, VMINU_VV }, // 7369
  { PseudoVMINU_VV_M2, VMINU_VV }, // 7370
  { PseudoVMINU_VV_M2_MASK, VMINU_VV }, // 7371
  { PseudoVMINU_VV_M2_TU, VMINU_VV }, // 7372
  { PseudoVMINU_VV_M4, VMINU_VV }, // 7373
  { PseudoVMINU_VV_M4_MASK, VMINU_VV }, // 7374
  { PseudoVMINU_VV_M4_TU, VMINU_VV }, // 7375
  { PseudoVMINU_VV_M8, VMINU_VV }, // 7376
  { PseudoVMINU_VV_M8_MASK, VMINU_VV }, // 7377
  { PseudoVMINU_VV_M8_TU, VMINU_VV }, // 7378
  { PseudoVMINU_VV_MF2, VMINU_VV }, // 7379
  { PseudoVMINU_VV_MF2_MASK, VMINU_VV }, // 7380
  { PseudoVMINU_VV_MF2_TU, VMINU_VV }, // 7381
  { PseudoVMINU_VV_MF4, VMINU_VV }, // 7382
  { PseudoVMINU_VV_MF4_MASK, VMINU_VV }, // 7383
  { PseudoVMINU_VV_MF4_TU, VMINU_VV }, // 7384
  { PseudoVMINU_VV_MF8, VMINU_VV }, // 7385
  { PseudoVMINU_VV_MF8_MASK, VMINU_VV }, // 7386
  { PseudoVMINU_VV_MF8_TU, VMINU_VV }, // 7387
  { PseudoVMINU_VX_M1, VMINU_VX }, // 7388
  { PseudoVMINU_VX_M1_MASK, VMINU_VX }, // 7389
  { PseudoVMINU_VX_M1_TU, VMINU_VX }, // 7390
  { PseudoVMINU_VX_M2, VMINU_VX }, // 7391
  { PseudoVMINU_VX_M2_MASK, VMINU_VX }, // 7392
  { PseudoVMINU_VX_M2_TU, VMINU_VX }, // 7393
  { PseudoVMINU_VX_M4, VMINU_VX }, // 7394
  { PseudoVMINU_VX_M4_MASK, VMINU_VX }, // 7395
  { PseudoVMINU_VX_M4_TU, VMINU_VX }, // 7396
  { PseudoVMINU_VX_M8, VMINU_VX }, // 7397
  { PseudoVMINU_VX_M8_MASK, VMINU_VX }, // 7398
  { PseudoVMINU_VX_M8_TU, VMINU_VX }, // 7399
  { PseudoVMINU_VX_MF2, VMINU_VX }, // 7400
  { PseudoVMINU_VX_MF2_MASK, VMINU_VX }, // 7401
  { PseudoVMINU_VX_MF2_TU, VMINU_VX }, // 7402
  { PseudoVMINU_VX_MF4, VMINU_VX }, // 7403
  { PseudoVMINU_VX_MF4_MASK, VMINU_VX }, // 7404
  { PseudoVMINU_VX_MF4_TU, VMINU_VX }, // 7405
  { PseudoVMINU_VX_MF8, VMINU_VX }, // 7406
  { PseudoVMINU_VX_MF8_MASK, VMINU_VX }, // 7407
  { PseudoVMINU_VX_MF8_TU, VMINU_VX }, // 7408
  { PseudoVMIN_VV_M1, VMIN_VV }, // 7409
  { PseudoVMIN_VV_M1_MASK, VMIN_VV }, // 7410
  { PseudoVMIN_VV_M1_TU, VMIN_VV }, // 7411
  { PseudoVMIN_VV_M2, VMIN_VV }, // 7412
  { PseudoVMIN_VV_M2_MASK, VMIN_VV }, // 7413
  { PseudoVMIN_VV_M2_TU, VMIN_VV }, // 7414
  { PseudoVMIN_VV_M4, VMIN_VV }, // 7415
  { PseudoVMIN_VV_M4_MASK, VMIN_VV }, // 7416
  { PseudoVMIN_VV_M4_TU, VMIN_VV }, // 7417
  { PseudoVMIN_VV_M8, VMIN_VV }, // 7418
  { PseudoVMIN_VV_M8_MASK, VMIN_VV }, // 7419
  { PseudoVMIN_VV_M8_TU, VMIN_VV }, // 7420
  { PseudoVMIN_VV_MF2, VMIN_VV }, // 7421
  { PseudoVMIN_VV_MF2_MASK, VMIN_VV }, // 7422
  { PseudoVMIN_VV_MF2_TU, VMIN_VV }, // 7423
  { PseudoVMIN_VV_MF4, VMIN_VV }, // 7424
  { PseudoVMIN_VV_MF4_MASK, VMIN_VV }, // 7425
  { PseudoVMIN_VV_MF4_TU, VMIN_VV }, // 7426
  { PseudoVMIN_VV_MF8, VMIN_VV }, // 7427
  { PseudoVMIN_VV_MF8_MASK, VMIN_VV }, // 7428
  { PseudoVMIN_VV_MF8_TU, VMIN_VV }, // 7429
  { PseudoVMIN_VX_M1, VMIN_VX }, // 7430
  { PseudoVMIN_VX_M1_MASK, VMIN_VX }, // 7431
  { PseudoVMIN_VX_M1_TU, VMIN_VX }, // 7432
  { PseudoVMIN_VX_M2, VMIN_VX }, // 7433
  { PseudoVMIN_VX_M2_MASK, VMIN_VX }, // 7434
  { PseudoVMIN_VX_M2_TU, VMIN_VX }, // 7435
  { PseudoVMIN_VX_M4, VMIN_VX }, // 7436
  { PseudoVMIN_VX_M4_MASK, VMIN_VX }, // 7437
  { PseudoVMIN_VX_M4_TU, VMIN_VX }, // 7438
  { PseudoVMIN_VX_M8, VMIN_VX }, // 7439
  { PseudoVMIN_VX_M8_MASK, VMIN_VX }, // 7440
  { PseudoVMIN_VX_M8_TU, VMIN_VX }, // 7441
  { PseudoVMIN_VX_MF2, VMIN_VX }, // 7442
  { PseudoVMIN_VX_MF2_MASK, VMIN_VX }, // 7443
  { PseudoVMIN_VX_MF2_TU, VMIN_VX }, // 7444
  { PseudoVMIN_VX_MF4, VMIN_VX }, // 7445
  { PseudoVMIN_VX_MF4_MASK, VMIN_VX }, // 7446
  { PseudoVMIN_VX_MF4_TU, VMIN_VX }, // 7447
  { PseudoVMIN_VX_MF8, VMIN_VX }, // 7448
  { PseudoVMIN_VX_MF8_MASK, VMIN_VX }, // 7449
  { PseudoVMIN_VX_MF8_TU, VMIN_VX }, // 7450
  { PseudoVMNAND_MM_M1, VMNAND_MM }, // 7451
  { PseudoVMNAND_MM_M2, VMNAND_MM }, // 7452
  { PseudoVMNAND_MM_M4, VMNAND_MM }, // 7453
  { PseudoVMNAND_MM_M8, VMNAND_MM }, // 7454
  { PseudoVMNAND_MM_MF2, VMNAND_MM }, // 7455
  { PseudoVMNAND_MM_MF4, VMNAND_MM }, // 7456
  { PseudoVMNAND_MM_MF8, VMNAND_MM }, // 7457
  { PseudoVMNOR_MM_M1, VMNOR_MM }, // 7458
  { PseudoVMNOR_MM_M2, VMNOR_MM }, // 7459
  { PseudoVMNOR_MM_M4, VMNOR_MM }, // 7460
  { PseudoVMNOR_MM_M8, VMNOR_MM }, // 7461
  { PseudoVMNOR_MM_MF2, VMNOR_MM }, // 7462
  { PseudoVMNOR_MM_MF4, VMNOR_MM }, // 7463
  { PseudoVMNOR_MM_MF8, VMNOR_MM }, // 7464
  { PseudoVMORN_MM_M1, VMORN_MM }, // 7465
  { PseudoVMORN_MM_M2, VMORN_MM }, // 7466
  { PseudoVMORN_MM_M4, VMORN_MM }, // 7467
  { PseudoVMORN_MM_M8, VMORN_MM }, // 7468
  { PseudoVMORN_MM_MF2, VMORN_MM }, // 7469
  { PseudoVMORN_MM_MF4, VMORN_MM }, // 7470
  { PseudoVMORN_MM_MF8, VMORN_MM }, // 7471
  { PseudoVMOR_MM_M1, VMOR_MM }, // 7472
  { PseudoVMOR_MM_M2, VMOR_MM }, // 7473
  { PseudoVMOR_MM_M4, VMOR_MM }, // 7474
  { PseudoVMOR_MM_M8, VMOR_MM }, // 7475
  { PseudoVMOR_MM_MF2, VMOR_MM }, // 7476
  { PseudoVMOR_MM_MF4, VMOR_MM }, // 7477
  { PseudoVMOR_MM_MF8, VMOR_MM }, // 7478
  { PseudoVMSBC_VVM_M1, VMSBC_VVM }, // 7479
  { PseudoVMSBC_VVM_M2, VMSBC_VVM }, // 7480
  { PseudoVMSBC_VVM_M4, VMSBC_VVM }, // 7481
  { PseudoVMSBC_VVM_M8, VMSBC_VVM }, // 7482
  { PseudoVMSBC_VVM_MF2, VMSBC_VVM }, // 7483
  { PseudoVMSBC_VVM_MF4, VMSBC_VVM }, // 7484
  { PseudoVMSBC_VVM_MF8, VMSBC_VVM }, // 7485
  { PseudoVMSBC_VV_M1, VMSBC_VV }, // 7486
  { PseudoVMSBC_VV_M2, VMSBC_VV }, // 7487
  { PseudoVMSBC_VV_M4, VMSBC_VV }, // 7488
  { PseudoVMSBC_VV_M8, VMSBC_VV }, // 7489
  { PseudoVMSBC_VV_MF2, VMSBC_VV }, // 7490
  { PseudoVMSBC_VV_MF4, VMSBC_VV }, // 7491
  { PseudoVMSBC_VV_MF8, VMSBC_VV }, // 7492
  { PseudoVMSBC_VXM_M1, VMSBC_VXM }, // 7493
  { PseudoVMSBC_VXM_M2, VMSBC_VXM }, // 7494
  { PseudoVMSBC_VXM_M4, VMSBC_VXM }, // 7495
  { PseudoVMSBC_VXM_M8, VMSBC_VXM }, // 7496
  { PseudoVMSBC_VXM_MF2, VMSBC_VXM }, // 7497
  { PseudoVMSBC_VXM_MF4, VMSBC_VXM }, // 7498
  { PseudoVMSBC_VXM_MF8, VMSBC_VXM }, // 7499
  { PseudoVMSBC_VX_M1, VMSBC_VX }, // 7500
  { PseudoVMSBC_VX_M2, VMSBC_VX }, // 7501
  { PseudoVMSBC_VX_M4, VMSBC_VX }, // 7502
  { PseudoVMSBC_VX_M8, VMSBC_VX }, // 7503
  { PseudoVMSBC_VX_MF2, VMSBC_VX }, // 7504
  { PseudoVMSBC_VX_MF4, VMSBC_VX }, // 7505
  { PseudoVMSBC_VX_MF8, VMSBC_VX }, // 7506
  { PseudoVMSBF_M_B1, VMSBF_M }, // 7507
  { PseudoVMSBF_M_B16, VMSBF_M }, // 7508
  { PseudoVMSBF_M_B16_MASK, VMSBF_M }, // 7509
  { PseudoVMSBF_M_B1_MASK, VMSBF_M }, // 7510
  { PseudoVMSBF_M_B2, VMSBF_M }, // 7511
  { PseudoVMSBF_M_B2_MASK, VMSBF_M }, // 7512
  { PseudoVMSBF_M_B32, VMSBF_M }, // 7513
  { PseudoVMSBF_M_B32_MASK, VMSBF_M }, // 7514
  { PseudoVMSBF_M_B4, VMSBF_M }, // 7515
  { PseudoVMSBF_M_B4_MASK, VMSBF_M }, // 7516
  { PseudoVMSBF_M_B64, VMSBF_M }, // 7517
  { PseudoVMSBF_M_B64_MASK, VMSBF_M }, // 7518
  { PseudoVMSBF_M_B8, VMSBF_M }, // 7519
  { PseudoVMSBF_M_B8_MASK, VMSBF_M }, // 7520
  { PseudoVMSEQ_VI_M1, VMSEQ_VI }, // 7521
  { PseudoVMSEQ_VI_M1_MASK, VMSEQ_VI }, // 7522
  { PseudoVMSEQ_VI_M2, VMSEQ_VI }, // 7523
  { PseudoVMSEQ_VI_M2_MASK, VMSEQ_VI }, // 7524
  { PseudoVMSEQ_VI_M4, VMSEQ_VI }, // 7525
  { PseudoVMSEQ_VI_M4_MASK, VMSEQ_VI }, // 7526
  { PseudoVMSEQ_VI_M8, VMSEQ_VI }, // 7527
  { PseudoVMSEQ_VI_M8_MASK, VMSEQ_VI }, // 7528
  { PseudoVMSEQ_VI_MF2, VMSEQ_VI }, // 7529
  { PseudoVMSEQ_VI_MF2_MASK, VMSEQ_VI }, // 7530
  { PseudoVMSEQ_VI_MF4, VMSEQ_VI }, // 7531
  { PseudoVMSEQ_VI_MF4_MASK, VMSEQ_VI }, // 7532
  { PseudoVMSEQ_VI_MF8, VMSEQ_VI }, // 7533
  { PseudoVMSEQ_VI_MF8_MASK, VMSEQ_VI }, // 7534
  { PseudoVMSEQ_VV_M1, VMSEQ_VV }, // 7535
  { PseudoVMSEQ_VV_M1_MASK, VMSEQ_VV }, // 7536
  { PseudoVMSEQ_VV_M2, VMSEQ_VV }, // 7537
  { PseudoVMSEQ_VV_M2_MASK, VMSEQ_VV }, // 7538
  { PseudoVMSEQ_VV_M4, VMSEQ_VV }, // 7539
  { PseudoVMSEQ_VV_M4_MASK, VMSEQ_VV }, // 7540
  { PseudoVMSEQ_VV_M8, VMSEQ_VV }, // 7541
  { PseudoVMSEQ_VV_M8_MASK, VMSEQ_VV }, // 7542
  { PseudoVMSEQ_VV_MF2, VMSEQ_VV }, // 7543
  { PseudoVMSEQ_VV_MF2_MASK, VMSEQ_VV }, // 7544
  { PseudoVMSEQ_VV_MF4, VMSEQ_VV }, // 7545
  { PseudoVMSEQ_VV_MF4_MASK, VMSEQ_VV }, // 7546
  { PseudoVMSEQ_VV_MF8, VMSEQ_VV }, // 7547
  { PseudoVMSEQ_VV_MF8_MASK, VMSEQ_VV }, // 7548
  { PseudoVMSEQ_VX_M1, VMSEQ_VX }, // 7549
  { PseudoVMSEQ_VX_M1_MASK, VMSEQ_VX }, // 7550
  { PseudoVMSEQ_VX_M2, VMSEQ_VX }, // 7551
  { PseudoVMSEQ_VX_M2_MASK, VMSEQ_VX }, // 7552
  { PseudoVMSEQ_VX_M4, VMSEQ_VX }, // 7553
  { PseudoVMSEQ_VX_M4_MASK, VMSEQ_VX }, // 7554
  { PseudoVMSEQ_VX_M8, VMSEQ_VX }, // 7555
  { PseudoVMSEQ_VX_M8_MASK, VMSEQ_VX }, // 7556
  { PseudoVMSEQ_VX_MF2, VMSEQ_VX }, // 7557
  { PseudoVMSEQ_VX_MF2_MASK, VMSEQ_VX }, // 7558
  { PseudoVMSEQ_VX_MF4, VMSEQ_VX }, // 7559
  { PseudoVMSEQ_VX_MF4_MASK, VMSEQ_VX }, // 7560
  { PseudoVMSEQ_VX_MF8, VMSEQ_VX }, // 7561
  { PseudoVMSEQ_VX_MF8_MASK, VMSEQ_VX }, // 7562
  { PseudoVMSET_M_B1, VMXNOR_MM }, // 7563
  { PseudoVMSET_M_B16, VMXNOR_MM }, // 7564
  { PseudoVMSET_M_B2, VMXNOR_MM }, // 7565
  { PseudoVMSET_M_B32, VMXNOR_MM }, // 7566
  { PseudoVMSET_M_B4, VMXNOR_MM }, // 7567
  { PseudoVMSET_M_B64, VMXNOR_MM }, // 7568
  { PseudoVMSET_M_B8, VMXNOR_MM }, // 7569
  { PseudoVMSGTU_VI_M1, VMSGTU_VI }, // 7570
  { PseudoVMSGTU_VI_M1_MASK, VMSGTU_VI }, // 7571
  { PseudoVMSGTU_VI_M2, VMSGTU_VI }, // 7572
  { PseudoVMSGTU_VI_M2_MASK, VMSGTU_VI }, // 7573
  { PseudoVMSGTU_VI_M4, VMSGTU_VI }, // 7574
  { PseudoVMSGTU_VI_M4_MASK, VMSGTU_VI }, // 7575
  { PseudoVMSGTU_VI_M8, VMSGTU_VI }, // 7576
  { PseudoVMSGTU_VI_M8_MASK, VMSGTU_VI }, // 7577
  { PseudoVMSGTU_VI_MF2, VMSGTU_VI }, // 7578
  { PseudoVMSGTU_VI_MF2_MASK, VMSGTU_VI }, // 7579
  { PseudoVMSGTU_VI_MF4, VMSGTU_VI }, // 7580
  { PseudoVMSGTU_VI_MF4_MASK, VMSGTU_VI }, // 7581
  { PseudoVMSGTU_VI_MF8, VMSGTU_VI }, // 7582
  { PseudoVMSGTU_VI_MF8_MASK, VMSGTU_VI }, // 7583
  { PseudoVMSGTU_VX_M1, VMSGTU_VX }, // 7584
  { PseudoVMSGTU_VX_M1_MASK, VMSGTU_VX }, // 7585
  { PseudoVMSGTU_VX_M2, VMSGTU_VX }, // 7586
  { PseudoVMSGTU_VX_M2_MASK, VMSGTU_VX }, // 7587
  { PseudoVMSGTU_VX_M4, VMSGTU_VX }, // 7588
  { PseudoVMSGTU_VX_M4_MASK, VMSGTU_VX }, // 7589
  { PseudoVMSGTU_VX_M8, VMSGTU_VX }, // 7590
  { PseudoVMSGTU_VX_M8_MASK, VMSGTU_VX }, // 7591
  { PseudoVMSGTU_VX_MF2, VMSGTU_VX }, // 7592
  { PseudoVMSGTU_VX_MF2_MASK, VMSGTU_VX }, // 7593
  { PseudoVMSGTU_VX_MF4, VMSGTU_VX }, // 7594
  { PseudoVMSGTU_VX_MF4_MASK, VMSGTU_VX }, // 7595
  { PseudoVMSGTU_VX_MF8, VMSGTU_VX }, // 7596
  { PseudoVMSGTU_VX_MF8_MASK, VMSGTU_VX }, // 7597
  { PseudoVMSGT_VI_M1, VMSGT_VI }, // 7598
  { PseudoVMSGT_VI_M1_MASK, VMSGT_VI }, // 7599
  { PseudoVMSGT_VI_M2, VMSGT_VI }, // 7600
  { PseudoVMSGT_VI_M2_MASK, VMSGT_VI }, // 7601
  { PseudoVMSGT_VI_M4, VMSGT_VI }, // 7602
  { PseudoVMSGT_VI_M4_MASK, VMSGT_VI }, // 7603
  { PseudoVMSGT_VI_M8, VMSGT_VI }, // 7604
  { PseudoVMSGT_VI_M8_MASK, VMSGT_VI }, // 7605
  { PseudoVMSGT_VI_MF2, VMSGT_VI }, // 7606
  { PseudoVMSGT_VI_MF2_MASK, VMSGT_VI }, // 7607
  { PseudoVMSGT_VI_MF4, VMSGT_VI }, // 7608
  { PseudoVMSGT_VI_MF4_MASK, VMSGT_VI }, // 7609
  { PseudoVMSGT_VI_MF8, VMSGT_VI }, // 7610
  { PseudoVMSGT_VI_MF8_MASK, VMSGT_VI }, // 7611
  { PseudoVMSGT_VX_M1, VMSGT_VX }, // 7612
  { PseudoVMSGT_VX_M1_MASK, VMSGT_VX }, // 7613
  { PseudoVMSGT_VX_M2, VMSGT_VX }, // 7614
  { PseudoVMSGT_VX_M2_MASK, VMSGT_VX }, // 7615
  { PseudoVMSGT_VX_M4, VMSGT_VX }, // 7616
  { PseudoVMSGT_VX_M4_MASK, VMSGT_VX }, // 7617
  { PseudoVMSGT_VX_M8, VMSGT_VX }, // 7618
  { PseudoVMSGT_VX_M8_MASK, VMSGT_VX }, // 7619
  { PseudoVMSGT_VX_MF2, VMSGT_VX }, // 7620
  { PseudoVMSGT_VX_MF2_MASK, VMSGT_VX }, // 7621
  { PseudoVMSGT_VX_MF4, VMSGT_VX }, // 7622
  { PseudoVMSGT_VX_MF4_MASK, VMSGT_VX }, // 7623
  { PseudoVMSGT_VX_MF8, VMSGT_VX }, // 7624
  { PseudoVMSGT_VX_MF8_MASK, VMSGT_VX }, // 7625
  { PseudoVMSIF_M_B1, VMSIF_M }, // 7626
  { PseudoVMSIF_M_B16, VMSIF_M }, // 7627
  { PseudoVMSIF_M_B16_MASK, VMSIF_M }, // 7628
  { PseudoVMSIF_M_B1_MASK, VMSIF_M }, // 7629
  { PseudoVMSIF_M_B2, VMSIF_M }, // 7630
  { PseudoVMSIF_M_B2_MASK, VMSIF_M }, // 7631
  { PseudoVMSIF_M_B32, VMSIF_M }, // 7632
  { PseudoVMSIF_M_B32_MASK, VMSIF_M }, // 7633
  { PseudoVMSIF_M_B4, VMSIF_M }, // 7634
  { PseudoVMSIF_M_B4_MASK, VMSIF_M }, // 7635
  { PseudoVMSIF_M_B64, VMSIF_M }, // 7636
  { PseudoVMSIF_M_B64_MASK, VMSIF_M }, // 7637
  { PseudoVMSIF_M_B8, VMSIF_M }, // 7638
  { PseudoVMSIF_M_B8_MASK, VMSIF_M }, // 7639
  { PseudoVMSLEU_VI_M1, VMSLEU_VI }, // 7640
  { PseudoVMSLEU_VI_M1_MASK, VMSLEU_VI }, // 7641
  { PseudoVMSLEU_VI_M2, VMSLEU_VI }, // 7642
  { PseudoVMSLEU_VI_M2_MASK, VMSLEU_VI }, // 7643
  { PseudoVMSLEU_VI_M4, VMSLEU_VI }, // 7644
  { PseudoVMSLEU_VI_M4_MASK, VMSLEU_VI }, // 7645
  { PseudoVMSLEU_VI_M8, VMSLEU_VI }, // 7646
  { PseudoVMSLEU_VI_M8_MASK, VMSLEU_VI }, // 7647
  { PseudoVMSLEU_VI_MF2, VMSLEU_VI }, // 7648
  { PseudoVMSLEU_VI_MF2_MASK, VMSLEU_VI }, // 7649
  { PseudoVMSLEU_VI_MF4, VMSLEU_VI }, // 7650
  { PseudoVMSLEU_VI_MF4_MASK, VMSLEU_VI }, // 7651
  { PseudoVMSLEU_VI_MF8, VMSLEU_VI }, // 7652
  { PseudoVMSLEU_VI_MF8_MASK, VMSLEU_VI }, // 7653
  { PseudoVMSLEU_VV_M1, VMSLEU_VV }, // 7654
  { PseudoVMSLEU_VV_M1_MASK, VMSLEU_VV }, // 7655
  { PseudoVMSLEU_VV_M2, VMSLEU_VV }, // 7656
  { PseudoVMSLEU_VV_M2_MASK, VMSLEU_VV }, // 7657
  { PseudoVMSLEU_VV_M4, VMSLEU_VV }, // 7658
  { PseudoVMSLEU_VV_M4_MASK, VMSLEU_VV }, // 7659
  { PseudoVMSLEU_VV_M8, VMSLEU_VV }, // 7660
  { PseudoVMSLEU_VV_M8_MASK, VMSLEU_VV }, // 7661
  { PseudoVMSLEU_VV_MF2, VMSLEU_VV }, // 7662
  { PseudoVMSLEU_VV_MF2_MASK, VMSLEU_VV }, // 7663
  { PseudoVMSLEU_VV_MF4, VMSLEU_VV }, // 7664
  { PseudoVMSLEU_VV_MF4_MASK, VMSLEU_VV }, // 7665
  { PseudoVMSLEU_VV_MF8, VMSLEU_VV }, // 7666
  { PseudoVMSLEU_VV_MF8_MASK, VMSLEU_VV }, // 7667
  { PseudoVMSLEU_VX_M1, VMSLEU_VX }, // 7668
  { PseudoVMSLEU_VX_M1_MASK, VMSLEU_VX }, // 7669
  { PseudoVMSLEU_VX_M2, VMSLEU_VX }, // 7670
  { PseudoVMSLEU_VX_M2_MASK, VMSLEU_VX }, // 7671
  { PseudoVMSLEU_VX_M4, VMSLEU_VX }, // 7672
  { PseudoVMSLEU_VX_M4_MASK, VMSLEU_VX }, // 7673
  { PseudoVMSLEU_VX_M8, VMSLEU_VX }, // 7674
  { PseudoVMSLEU_VX_M8_MASK, VMSLEU_VX }, // 7675
  { PseudoVMSLEU_VX_MF2, VMSLEU_VX }, // 7676
  { PseudoVMSLEU_VX_MF2_MASK, VMSLEU_VX }, // 7677
  { PseudoVMSLEU_VX_MF4, VMSLEU_VX }, // 7678
  { PseudoVMSLEU_VX_MF4_MASK, VMSLEU_VX }, // 7679
  { PseudoVMSLEU_VX_MF8, VMSLEU_VX }, // 7680
  { PseudoVMSLEU_VX_MF8_MASK, VMSLEU_VX }, // 7681
  { PseudoVMSLE_VI_M1, VMSLE_VI }, // 7682
  { PseudoVMSLE_VI_M1_MASK, VMSLE_VI }, // 7683
  { PseudoVMSLE_VI_M2, VMSLE_VI }, // 7684
  { PseudoVMSLE_VI_M2_MASK, VMSLE_VI }, // 7685
  { PseudoVMSLE_VI_M4, VMSLE_VI }, // 7686
  { PseudoVMSLE_VI_M4_MASK, VMSLE_VI }, // 7687
  { PseudoVMSLE_VI_M8, VMSLE_VI }, // 7688
  { PseudoVMSLE_VI_M8_MASK, VMSLE_VI }, // 7689
  { PseudoVMSLE_VI_MF2, VMSLE_VI }, // 7690
  { PseudoVMSLE_VI_MF2_MASK, VMSLE_VI }, // 7691
  { PseudoVMSLE_VI_MF4, VMSLE_VI }, // 7692
  { PseudoVMSLE_VI_MF4_MASK, VMSLE_VI }, // 7693
  { PseudoVMSLE_VI_MF8, VMSLE_VI }, // 7694
  { PseudoVMSLE_VI_MF8_MASK, VMSLE_VI }, // 7695
  { PseudoVMSLE_VV_M1, VMSLE_VV }, // 7696
  { PseudoVMSLE_VV_M1_MASK, VMSLE_VV }, // 7697
  { PseudoVMSLE_VV_M2, VMSLE_VV }, // 7698
  { PseudoVMSLE_VV_M2_MASK, VMSLE_VV }, // 7699
  { PseudoVMSLE_VV_M4, VMSLE_VV }, // 7700
  { PseudoVMSLE_VV_M4_MASK, VMSLE_VV }, // 7701
  { PseudoVMSLE_VV_M8, VMSLE_VV }, // 7702
  { PseudoVMSLE_VV_M8_MASK, VMSLE_VV }, // 7703
  { PseudoVMSLE_VV_MF2, VMSLE_VV }, // 7704
  { PseudoVMSLE_VV_MF2_MASK, VMSLE_VV }, // 7705
  { PseudoVMSLE_VV_MF4, VMSLE_VV }, // 7706
  { PseudoVMSLE_VV_MF4_MASK, VMSLE_VV }, // 7707
  { PseudoVMSLE_VV_MF8, VMSLE_VV }, // 7708
  { PseudoVMSLE_VV_MF8_MASK, VMSLE_VV }, // 7709
  { PseudoVMSLE_VX_M1, VMSLE_VX }, // 7710
  { PseudoVMSLE_VX_M1_MASK, VMSLE_VX }, // 7711
  { PseudoVMSLE_VX_M2, VMSLE_VX }, // 7712
  { PseudoVMSLE_VX_M2_MASK, VMSLE_VX }, // 7713
  { PseudoVMSLE_VX_M4, VMSLE_VX }, // 7714
  { PseudoVMSLE_VX_M4_MASK, VMSLE_VX }, // 7715
  { PseudoVMSLE_VX_M8, VMSLE_VX }, // 7716
  { PseudoVMSLE_VX_M8_MASK, VMSLE_VX }, // 7717
  { PseudoVMSLE_VX_MF2, VMSLE_VX }, // 7718
  { PseudoVMSLE_VX_MF2_MASK, VMSLE_VX }, // 7719
  { PseudoVMSLE_VX_MF4, VMSLE_VX }, // 7720
  { PseudoVMSLE_VX_MF4_MASK, VMSLE_VX }, // 7721
  { PseudoVMSLE_VX_MF8, VMSLE_VX }, // 7722
  { PseudoVMSLE_VX_MF8_MASK, VMSLE_VX }, // 7723
  { PseudoVMSLTU_VV_M1, VMSLTU_VV }, // 7724
  { PseudoVMSLTU_VV_M1_MASK, VMSLTU_VV }, // 7725
  { PseudoVMSLTU_VV_M2, VMSLTU_VV }, // 7726
  { PseudoVMSLTU_VV_M2_MASK, VMSLTU_VV }, // 7727
  { PseudoVMSLTU_VV_M4, VMSLTU_VV }, // 7728
  { PseudoVMSLTU_VV_M4_MASK, VMSLTU_VV }, // 7729
  { PseudoVMSLTU_VV_M8, VMSLTU_VV }, // 7730
  { PseudoVMSLTU_VV_M8_MASK, VMSLTU_VV }, // 7731
  { PseudoVMSLTU_VV_MF2, VMSLTU_VV }, // 7732
  { PseudoVMSLTU_VV_MF2_MASK, VMSLTU_VV }, // 7733
  { PseudoVMSLTU_VV_MF4, VMSLTU_VV }, // 7734
  { PseudoVMSLTU_VV_MF4_MASK, VMSLTU_VV }, // 7735
  { PseudoVMSLTU_VV_MF8, VMSLTU_VV }, // 7736
  { PseudoVMSLTU_VV_MF8_MASK, VMSLTU_VV }, // 7737
  { PseudoVMSLTU_VX_M1, VMSLTU_VX }, // 7738
  { PseudoVMSLTU_VX_M1_MASK, VMSLTU_VX }, // 7739
  { PseudoVMSLTU_VX_M2, VMSLTU_VX }, // 7740
  { PseudoVMSLTU_VX_M2_MASK, VMSLTU_VX }, // 7741
  { PseudoVMSLTU_VX_M4, VMSLTU_VX }, // 7742
  { PseudoVMSLTU_VX_M4_MASK, VMSLTU_VX }, // 7743
  { PseudoVMSLTU_VX_M8, VMSLTU_VX }, // 7744
  { PseudoVMSLTU_VX_M8_MASK, VMSLTU_VX }, // 7745
  { PseudoVMSLTU_VX_MF2, VMSLTU_VX }, // 7746
  { PseudoVMSLTU_VX_MF2_MASK, VMSLTU_VX }, // 7747
  { PseudoVMSLTU_VX_MF4, VMSLTU_VX }, // 7748
  { PseudoVMSLTU_VX_MF4_MASK, VMSLTU_VX }, // 7749
  { PseudoVMSLTU_VX_MF8, VMSLTU_VX }, // 7750
  { PseudoVMSLTU_VX_MF8_MASK, VMSLTU_VX }, // 7751
  { PseudoVMSLT_VV_M1, VMSLT_VV }, // 7752
  { PseudoVMSLT_VV_M1_MASK, VMSLT_VV }, // 7753
  { PseudoVMSLT_VV_M2, VMSLT_VV }, // 7754
  { PseudoVMSLT_VV_M2_MASK, VMSLT_VV }, // 7755
  { PseudoVMSLT_VV_M4, VMSLT_VV }, // 7756
  { PseudoVMSLT_VV_M4_MASK, VMSLT_VV }, // 7757
  { PseudoVMSLT_VV_M8, VMSLT_VV }, // 7758
  { PseudoVMSLT_VV_M8_MASK, VMSLT_VV }, // 7759
  { PseudoVMSLT_VV_MF2, VMSLT_VV }, // 7760
  { PseudoVMSLT_VV_MF2_MASK, VMSLT_VV }, // 7761
  { PseudoVMSLT_VV_MF4, VMSLT_VV }, // 7762
  { PseudoVMSLT_VV_MF4_MASK, VMSLT_VV }, // 7763
  { PseudoVMSLT_VV_MF8, VMSLT_VV }, // 7764
  { PseudoVMSLT_VV_MF8_MASK, VMSLT_VV }, // 7765
  { PseudoVMSLT_VX_M1, VMSLT_VX }, // 7766
  { PseudoVMSLT_VX_M1_MASK, VMSLT_VX }, // 7767
  { PseudoVMSLT_VX_M2, VMSLT_VX }, // 7768
  { PseudoVMSLT_VX_M2_MASK, VMSLT_VX }, // 7769
  { PseudoVMSLT_VX_M4, VMSLT_VX }, // 7770
  { PseudoVMSLT_VX_M4_MASK, VMSLT_VX }, // 7771
  { PseudoVMSLT_VX_M8, VMSLT_VX }, // 7772
  { PseudoVMSLT_VX_M8_MASK, VMSLT_VX }, // 7773
  { PseudoVMSLT_VX_MF2, VMSLT_VX }, // 7774
  { PseudoVMSLT_VX_MF2_MASK, VMSLT_VX }, // 7775
  { PseudoVMSLT_VX_MF4, VMSLT_VX }, // 7776
  { PseudoVMSLT_VX_MF4_MASK, VMSLT_VX }, // 7777
  { PseudoVMSLT_VX_MF8, VMSLT_VX }, // 7778
  { PseudoVMSLT_VX_MF8_MASK, VMSLT_VX }, // 7779
  { PseudoVMSNE_VI_M1, VMSNE_VI }, // 7780
  { PseudoVMSNE_VI_M1_MASK, VMSNE_VI }, // 7781
  { PseudoVMSNE_VI_M2, VMSNE_VI }, // 7782
  { PseudoVMSNE_VI_M2_MASK, VMSNE_VI }, // 7783
  { PseudoVMSNE_VI_M4, VMSNE_VI }, // 7784
  { PseudoVMSNE_VI_M4_MASK, VMSNE_VI }, // 7785
  { PseudoVMSNE_VI_M8, VMSNE_VI }, // 7786
  { PseudoVMSNE_VI_M8_MASK, VMSNE_VI }, // 7787
  { PseudoVMSNE_VI_MF2, VMSNE_VI }, // 7788
  { PseudoVMSNE_VI_MF2_MASK, VMSNE_VI }, // 7789
  { PseudoVMSNE_VI_MF4, VMSNE_VI }, // 7790
  { PseudoVMSNE_VI_MF4_MASK, VMSNE_VI }, // 7791
  { PseudoVMSNE_VI_MF8, VMSNE_VI }, // 7792
  { PseudoVMSNE_VI_MF8_MASK, VMSNE_VI }, // 7793
  { PseudoVMSNE_VV_M1, VMSNE_VV }, // 7794
  { PseudoVMSNE_VV_M1_MASK, VMSNE_VV }, // 7795
  { PseudoVMSNE_VV_M2, VMSNE_VV }, // 7796
  { PseudoVMSNE_VV_M2_MASK, VMSNE_VV }, // 7797
  { PseudoVMSNE_VV_M4, VMSNE_VV }, // 7798
  { PseudoVMSNE_VV_M4_MASK, VMSNE_VV }, // 7799
  { PseudoVMSNE_VV_M8, VMSNE_VV }, // 7800
  { PseudoVMSNE_VV_M8_MASK, VMSNE_VV }, // 7801
  { PseudoVMSNE_VV_MF2, VMSNE_VV }, // 7802
  { PseudoVMSNE_VV_MF2_MASK, VMSNE_VV }, // 7803
  { PseudoVMSNE_VV_MF4, VMSNE_VV }, // 7804
  { PseudoVMSNE_VV_MF4_MASK, VMSNE_VV }, // 7805
  { PseudoVMSNE_VV_MF8, VMSNE_VV }, // 7806
  { PseudoVMSNE_VV_MF8_MASK, VMSNE_VV }, // 7807
  { PseudoVMSNE_VX_M1, VMSNE_VX }, // 7808
  { PseudoVMSNE_VX_M1_MASK, VMSNE_VX }, // 7809
  { PseudoVMSNE_VX_M2, VMSNE_VX }, // 7810
  { PseudoVMSNE_VX_M2_MASK, VMSNE_VX }, // 7811
  { PseudoVMSNE_VX_M4, VMSNE_VX }, // 7812
  { PseudoVMSNE_VX_M4_MASK, VMSNE_VX }, // 7813
  { PseudoVMSNE_VX_M8, VMSNE_VX }, // 7814
  { PseudoVMSNE_VX_M8_MASK, VMSNE_VX }, // 7815
  { PseudoVMSNE_VX_MF2, VMSNE_VX }, // 7816
  { PseudoVMSNE_VX_MF2_MASK, VMSNE_VX }, // 7817
  { PseudoVMSNE_VX_MF4, VMSNE_VX }, // 7818
  { PseudoVMSNE_VX_MF4_MASK, VMSNE_VX }, // 7819
  { PseudoVMSNE_VX_MF8, VMSNE_VX }, // 7820
  { PseudoVMSNE_VX_MF8_MASK, VMSNE_VX }, // 7821
  { PseudoVMSOF_M_B1, VMSOF_M }, // 7822
  { PseudoVMSOF_M_B16, VMSOF_M }, // 7823
  { PseudoVMSOF_M_B16_MASK, VMSOF_M }, // 7824
  { PseudoVMSOF_M_B1_MASK, VMSOF_M }, // 7825
  { PseudoVMSOF_M_B2, VMSOF_M }, // 7826
  { PseudoVMSOF_M_B2_MASK, VMSOF_M }, // 7827
  { PseudoVMSOF_M_B32, VMSOF_M }, // 7828
  { PseudoVMSOF_M_B32_MASK, VMSOF_M }, // 7829
  { PseudoVMSOF_M_B4, VMSOF_M }, // 7830
  { PseudoVMSOF_M_B4_MASK, VMSOF_M }, // 7831
  { PseudoVMSOF_M_B64, VMSOF_M }, // 7832
  { PseudoVMSOF_M_B64_MASK, VMSOF_M }, // 7833
  { PseudoVMSOF_M_B8, VMSOF_M }, // 7834
  { PseudoVMSOF_M_B8_MASK, VMSOF_M }, // 7835
  { PseudoVMULHSU_VV_M1, VMULHSU_VV }, // 7836
  { PseudoVMULHSU_VV_M1_MASK, VMULHSU_VV }, // 7837
  { PseudoVMULHSU_VV_M1_TU, VMULHSU_VV }, // 7838
  { PseudoVMULHSU_VV_M2, VMULHSU_VV }, // 7839
  { PseudoVMULHSU_VV_M2_MASK, VMULHSU_VV }, // 7840
  { PseudoVMULHSU_VV_M2_TU, VMULHSU_VV }, // 7841
  { PseudoVMULHSU_VV_M4, VMULHSU_VV }, // 7842
  { PseudoVMULHSU_VV_M4_MASK, VMULHSU_VV }, // 7843
  { PseudoVMULHSU_VV_M4_TU, VMULHSU_VV }, // 7844
  { PseudoVMULHSU_VV_M8, VMULHSU_VV }, // 7845
  { PseudoVMULHSU_VV_M8_MASK, VMULHSU_VV }, // 7846
  { PseudoVMULHSU_VV_M8_TU, VMULHSU_VV }, // 7847
  { PseudoVMULHSU_VV_MF2, VMULHSU_VV }, // 7848
  { PseudoVMULHSU_VV_MF2_MASK, VMULHSU_VV }, // 7849
  { PseudoVMULHSU_VV_MF2_TU, VMULHSU_VV }, // 7850
  { PseudoVMULHSU_VV_MF4, VMULHSU_VV }, // 7851
  { PseudoVMULHSU_VV_MF4_MASK, VMULHSU_VV }, // 7852
  { PseudoVMULHSU_VV_MF4_TU, VMULHSU_VV }, // 7853
  { PseudoVMULHSU_VV_MF8, VMULHSU_VV }, // 7854
  { PseudoVMULHSU_VV_MF8_MASK, VMULHSU_VV }, // 7855
  { PseudoVMULHSU_VV_MF8_TU, VMULHSU_VV }, // 7856
  { PseudoVMULHSU_VX_M1, VMULHSU_VX }, // 7857
  { PseudoVMULHSU_VX_M1_MASK, VMULHSU_VX }, // 7858
  { PseudoVMULHSU_VX_M1_TU, VMULHSU_VX }, // 7859
  { PseudoVMULHSU_VX_M2, VMULHSU_VX }, // 7860
  { PseudoVMULHSU_VX_M2_MASK, VMULHSU_VX }, // 7861
  { PseudoVMULHSU_VX_M2_TU, VMULHSU_VX }, // 7862
  { PseudoVMULHSU_VX_M4, VMULHSU_VX }, // 7863
  { PseudoVMULHSU_VX_M4_MASK, VMULHSU_VX }, // 7864
  { PseudoVMULHSU_VX_M4_TU, VMULHSU_VX }, // 7865
  { PseudoVMULHSU_VX_M8, VMULHSU_VX }, // 7866
  { PseudoVMULHSU_VX_M8_MASK, VMULHSU_VX }, // 7867
  { PseudoVMULHSU_VX_M8_TU, VMULHSU_VX }, // 7868
  { PseudoVMULHSU_VX_MF2, VMULHSU_VX }, // 7869
  { PseudoVMULHSU_VX_MF2_MASK, VMULHSU_VX }, // 7870
  { PseudoVMULHSU_VX_MF2_TU, VMULHSU_VX }, // 7871
  { PseudoVMULHSU_VX_MF4, VMULHSU_VX }, // 7872
  { PseudoVMULHSU_VX_MF4_MASK, VMULHSU_VX }, // 7873
  { PseudoVMULHSU_VX_MF4_TU, VMULHSU_VX }, // 7874
  { PseudoVMULHSU_VX_MF8, VMULHSU_VX }, // 7875
  { PseudoVMULHSU_VX_MF8_MASK, VMULHSU_VX }, // 7876
  { PseudoVMULHSU_VX_MF8_TU, VMULHSU_VX }, // 7877
  { PseudoVMULHU_VV_M1, VMULHU_VV }, // 7878
  { PseudoVMULHU_VV_M1_MASK, VMULHU_VV }, // 7879
  { PseudoVMULHU_VV_M1_TU, VMULHU_VV }, // 7880
  { PseudoVMULHU_VV_M2, VMULHU_VV }, // 7881
  { PseudoVMULHU_VV_M2_MASK, VMULHU_VV }, // 7882
  { PseudoVMULHU_VV_M2_TU, VMULHU_VV }, // 7883
  { PseudoVMULHU_VV_M4, VMULHU_VV }, // 7884
  { PseudoVMULHU_VV_M4_MASK, VMULHU_VV }, // 7885
  { PseudoVMULHU_VV_M4_TU, VMULHU_VV }, // 7886
  { PseudoVMULHU_VV_M8, VMULHU_VV }, // 7887
  { PseudoVMULHU_VV_M8_MASK, VMULHU_VV }, // 7888
  { PseudoVMULHU_VV_M8_TU, VMULHU_VV }, // 7889
  { PseudoVMULHU_VV_MF2, VMULHU_VV }, // 7890
  { PseudoVMULHU_VV_MF2_MASK, VMULHU_VV }, // 7891
  { PseudoVMULHU_VV_MF2_TU, VMULHU_VV }, // 7892
  { PseudoVMULHU_VV_MF4, VMULHU_VV }, // 7893
  { PseudoVMULHU_VV_MF4_MASK, VMULHU_VV }, // 7894
  { PseudoVMULHU_VV_MF4_TU, VMULHU_VV }, // 7895
  { PseudoVMULHU_VV_MF8, VMULHU_VV }, // 7896
  { PseudoVMULHU_VV_MF8_MASK, VMULHU_VV }, // 7897
  { PseudoVMULHU_VV_MF8_TU, VMULHU_VV }, // 7898
  { PseudoVMULHU_VX_M1, VMULHU_VX }, // 7899
  { PseudoVMULHU_VX_M1_MASK, VMULHU_VX }, // 7900
  { PseudoVMULHU_VX_M1_TU, VMULHU_VX }, // 7901
  { PseudoVMULHU_VX_M2, VMULHU_VX }, // 7902
  { PseudoVMULHU_VX_M2_MASK, VMULHU_VX }, // 7903
  { PseudoVMULHU_VX_M2_TU, VMULHU_VX }, // 7904
  { PseudoVMULHU_VX_M4, VMULHU_VX }, // 7905
  { PseudoVMULHU_VX_M4_MASK, VMULHU_VX }, // 7906
  { PseudoVMULHU_VX_M4_TU, VMULHU_VX }, // 7907
  { PseudoVMULHU_VX_M8, VMULHU_VX }, // 7908
  { PseudoVMULHU_VX_M8_MASK, VMULHU_VX }, // 7909
  { PseudoVMULHU_VX_M8_TU, VMULHU_VX }, // 7910
  { PseudoVMULHU_VX_MF2, VMULHU_VX }, // 7911
  { PseudoVMULHU_VX_MF2_MASK, VMULHU_VX }, // 7912
  { PseudoVMULHU_VX_MF2_TU, VMULHU_VX }, // 7913
  { PseudoVMULHU_VX_MF4, VMULHU_VX }, // 7914
  { PseudoVMULHU_VX_MF4_MASK, VMULHU_VX }, // 7915
  { PseudoVMULHU_VX_MF4_TU, VMULHU_VX }, // 7916
  { PseudoVMULHU_VX_MF8, VMULHU_VX }, // 7917
  { PseudoVMULHU_VX_MF8_MASK, VMULHU_VX }, // 7918
  { PseudoVMULHU_VX_MF8_TU, VMULHU_VX }, // 7919
  { PseudoVMULH_VV_M1, VMULH_VV }, // 7920
  { PseudoVMULH_VV_M1_MASK, VMULH_VV }, // 7921
  { PseudoVMULH_VV_M1_TU, VMULH_VV }, // 7922
  { PseudoVMULH_VV_M2, VMULH_VV }, // 7923
  { PseudoVMULH_VV_M2_MASK, VMULH_VV }, // 7924
  { PseudoVMULH_VV_M2_TU, VMULH_VV }, // 7925
  { PseudoVMULH_VV_M4, VMULH_VV }, // 7926
  { PseudoVMULH_VV_M4_MASK, VMULH_VV }, // 7927
  { PseudoVMULH_VV_M4_TU, VMULH_VV }, // 7928
  { PseudoVMULH_VV_M8, VMULH_VV }, // 7929
  { PseudoVMULH_VV_M8_MASK, VMULH_VV }, // 7930
  { PseudoVMULH_VV_M8_TU, VMULH_VV }, // 7931
  { PseudoVMULH_VV_MF2, VMULH_VV }, // 7932
  { PseudoVMULH_VV_MF2_MASK, VMULH_VV }, // 7933
  { PseudoVMULH_VV_MF2_TU, VMULH_VV }, // 7934
  { PseudoVMULH_VV_MF4, VMULH_VV }, // 7935
  { PseudoVMULH_VV_MF4_MASK, VMULH_VV }, // 7936
  { PseudoVMULH_VV_MF4_TU, VMULH_VV }, // 7937
  { PseudoVMULH_VV_MF8, VMULH_VV }, // 7938
  { PseudoVMULH_VV_MF8_MASK, VMULH_VV }, // 7939
  { PseudoVMULH_VV_MF8_TU, VMULH_VV }, // 7940
  { PseudoVMULH_VX_M1, VMULH_VX }, // 7941
  { PseudoVMULH_VX_M1_MASK, VMULH_VX }, // 7942
  { PseudoVMULH_VX_M1_TU, VMULH_VX }, // 7943
  { PseudoVMULH_VX_M2, VMULH_VX }, // 7944
  { PseudoVMULH_VX_M2_MASK, VMULH_VX }, // 7945
  { PseudoVMULH_VX_M2_TU, VMULH_VX }, // 7946
  { PseudoVMULH_VX_M4, VMULH_VX }, // 7947
  { PseudoVMULH_VX_M4_MASK, VMULH_VX }, // 7948
  { PseudoVMULH_VX_M4_TU, VMULH_VX }, // 7949
  { PseudoVMULH_VX_M8, VMULH_VX }, // 7950
  { PseudoVMULH_VX_M8_MASK, VMULH_VX }, // 7951
  { PseudoVMULH_VX_M8_TU, VMULH_VX }, // 7952
  { PseudoVMULH_VX_MF2, VMULH_VX }, // 7953
  { PseudoVMULH_VX_MF2_MASK, VMULH_VX }, // 7954
  { PseudoVMULH_VX_MF2_TU, VMULH_VX }, // 7955
  { PseudoVMULH_VX_MF4, VMULH_VX }, // 7956
  { PseudoVMULH_VX_MF4_MASK, VMULH_VX }, // 7957
  { PseudoVMULH_VX_MF4_TU, VMULH_VX }, // 7958
  { PseudoVMULH_VX_MF8, VMULH_VX }, // 7959
  { PseudoVMULH_VX_MF8_MASK, VMULH_VX }, // 7960
  { PseudoVMULH_VX_MF8_TU, VMULH_VX }, // 7961
  { PseudoVMUL_VV_M1, VMUL_VV }, // 7962
  { PseudoVMUL_VV_M1_MASK, VMUL_VV }, // 7963
  { PseudoVMUL_VV_M1_TU, VMUL_VV }, // 7964
  { PseudoVMUL_VV_M2, VMUL_VV }, // 7965
  { PseudoVMUL_VV_M2_MASK, VMUL_VV }, // 7966
  { PseudoVMUL_VV_M2_TU, VMUL_VV }, // 7967
  { PseudoVMUL_VV_M4, VMUL_VV }, // 7968
  { PseudoVMUL_VV_M4_MASK, VMUL_VV }, // 7969
  { PseudoVMUL_VV_M4_TU, VMUL_VV }, // 7970
  { PseudoVMUL_VV_M8, VMUL_VV }, // 7971
  { PseudoVMUL_VV_M8_MASK, VMUL_VV }, // 7972
  { PseudoVMUL_VV_M8_TU, VMUL_VV }, // 7973
  { PseudoVMUL_VV_MF2, VMUL_VV }, // 7974
  { PseudoVMUL_VV_MF2_MASK, VMUL_VV }, // 7975
  { PseudoVMUL_VV_MF2_TU, VMUL_VV }, // 7976
  { PseudoVMUL_VV_MF4, VMUL_VV }, // 7977
  { PseudoVMUL_VV_MF4_MASK, VMUL_VV }, // 7978
  { PseudoVMUL_VV_MF4_TU, VMUL_VV }, // 7979
  { PseudoVMUL_VV_MF8, VMUL_VV }, // 7980
  { PseudoVMUL_VV_MF8_MASK, VMUL_VV }, // 7981
  { PseudoVMUL_VV_MF8_TU, VMUL_VV }, // 7982
  { PseudoVMUL_VX_M1, VMUL_VX }, // 7983
  { PseudoVMUL_VX_M1_MASK, VMUL_VX }, // 7984
  { PseudoVMUL_VX_M1_TU, VMUL_VX }, // 7985
  { PseudoVMUL_VX_M2, VMUL_VX }, // 7986
  { PseudoVMUL_VX_M2_MASK, VMUL_VX }, // 7987
  { PseudoVMUL_VX_M2_TU, VMUL_VX }, // 7988
  { PseudoVMUL_VX_M4, VMUL_VX }, // 7989
  { PseudoVMUL_VX_M4_MASK, VMUL_VX }, // 7990
  { PseudoVMUL_VX_M4_TU, VMUL_VX }, // 7991
  { PseudoVMUL_VX_M8, VMUL_VX }, // 7992
  { PseudoVMUL_VX_M8_MASK, VMUL_VX }, // 7993
  { PseudoVMUL_VX_M8_TU, VMUL_VX }, // 7994
  { PseudoVMUL_VX_MF2, VMUL_VX }, // 7995
  { PseudoVMUL_VX_MF2_MASK, VMUL_VX }, // 7996
  { PseudoVMUL_VX_MF2_TU, VMUL_VX }, // 7997
  { PseudoVMUL_VX_MF4, VMUL_VX }, // 7998
  { PseudoVMUL_VX_MF4_MASK, VMUL_VX }, // 7999
  { PseudoVMUL_VX_MF4_TU, VMUL_VX }, // 8000
  { PseudoVMUL_VX_MF8, VMUL_VX }, // 8001
  { PseudoVMUL_VX_MF8_MASK, VMUL_VX }, // 8002
  { PseudoVMUL_VX_MF8_TU, VMUL_VX }, // 8003
  { PseudoVMV_S_X_M1, VMV_S_X }, // 8004
  { PseudoVMV_S_X_M2, VMV_S_X }, // 8005
  { PseudoVMV_S_X_M4, VMV_S_X }, // 8006
  { PseudoVMV_S_X_M8, VMV_S_X }, // 8007
  { PseudoVMV_S_X_MF2, VMV_S_X }, // 8008
  { PseudoVMV_S_X_MF4, VMV_S_X }, // 8009
  { PseudoVMV_S_X_MF8, VMV_S_X }, // 8010
  { PseudoVMV_V_I_M1, VMV_V_I }, // 8011
  { PseudoVMV_V_I_M1_TU, VMV_V_I }, // 8012
  { PseudoVMV_V_I_M2, VMV_V_I }, // 8013
  { PseudoVMV_V_I_M2_TU, VMV_V_I }, // 8014
  { PseudoVMV_V_I_M4, VMV_V_I }, // 8015
  { PseudoVMV_V_I_M4_TU, VMV_V_I }, // 8016
  { PseudoVMV_V_I_M8, VMV_V_I }, // 8017
  { PseudoVMV_V_I_M8_TU, VMV_V_I }, // 8018
  { PseudoVMV_V_I_MF2, VMV_V_I }, // 8019
  { PseudoVMV_V_I_MF2_TU, VMV_V_I }, // 8020
  { PseudoVMV_V_I_MF4, VMV_V_I }, // 8021
  { PseudoVMV_V_I_MF4_TU, VMV_V_I }, // 8022
  { PseudoVMV_V_I_MF8, VMV_V_I }, // 8023
  { PseudoVMV_V_I_MF8_TU, VMV_V_I }, // 8024
  { PseudoVMV_V_V_M1, VMV_V_V }, // 8025
  { PseudoVMV_V_V_M1_TU, VMV_V_V }, // 8026
  { PseudoVMV_V_V_M2, VMV_V_V }, // 8027
  { PseudoVMV_V_V_M2_TU, VMV_V_V }, // 8028
  { PseudoVMV_V_V_M4, VMV_V_V }, // 8029
  { PseudoVMV_V_V_M4_TU, VMV_V_V }, // 8030
  { PseudoVMV_V_V_M8, VMV_V_V }, // 8031
  { PseudoVMV_V_V_M8_TU, VMV_V_V }, // 8032
  { PseudoVMV_V_V_MF2, VMV_V_V }, // 8033
  { PseudoVMV_V_V_MF2_TU, VMV_V_V }, // 8034
  { PseudoVMV_V_V_MF4, VMV_V_V }, // 8035
  { PseudoVMV_V_V_MF4_TU, VMV_V_V }, // 8036
  { PseudoVMV_V_V_MF8, VMV_V_V }, // 8037
  { PseudoVMV_V_V_MF8_TU, VMV_V_V }, // 8038
  { PseudoVMV_V_X_M1, VMV_V_X }, // 8039
  { PseudoVMV_V_X_M1_TU, VMV_V_X }, // 8040
  { PseudoVMV_V_X_M2, VMV_V_X }, // 8041
  { PseudoVMV_V_X_M2_TU, VMV_V_X }, // 8042
  { PseudoVMV_V_X_M4, VMV_V_X }, // 8043
  { PseudoVMV_V_X_M4_TU, VMV_V_X }, // 8044
  { PseudoVMV_V_X_M8, VMV_V_X }, // 8045
  { PseudoVMV_V_X_M8_TU, VMV_V_X }, // 8046
  { PseudoVMV_V_X_MF2, VMV_V_X }, // 8047
  { PseudoVMV_V_X_MF2_TU, VMV_V_X }, // 8048
  { PseudoVMV_V_X_MF4, VMV_V_X }, // 8049
  { PseudoVMV_V_X_MF4_TU, VMV_V_X }, // 8050
  { PseudoVMV_V_X_MF8, VMV_V_X }, // 8051
  { PseudoVMV_V_X_MF8_TU, VMV_V_X }, // 8052
  { PseudoVMV_X_S_M1, VMV_X_S }, // 8053
  { PseudoVMV_X_S_M2, VMV_X_S }, // 8054
  { PseudoVMV_X_S_M4, VMV_X_S }, // 8055
  { PseudoVMV_X_S_M8, VMV_X_S }, // 8056
  { PseudoVMV_X_S_MF2, VMV_X_S }, // 8057
  { PseudoVMV_X_S_MF4, VMV_X_S }, // 8058
  { PseudoVMV_X_S_MF8, VMV_X_S }, // 8059
  { PseudoVMXNOR_MM_M1, VMXNOR_MM }, // 8060
  { PseudoVMXNOR_MM_M2, VMXNOR_MM }, // 8061
  { PseudoVMXNOR_MM_M4, VMXNOR_MM }, // 8062
  { PseudoVMXNOR_MM_M8, VMXNOR_MM }, // 8063
  { PseudoVMXNOR_MM_MF2, VMXNOR_MM }, // 8064
  { PseudoVMXNOR_MM_MF4, VMXNOR_MM }, // 8065
  { PseudoVMXNOR_MM_MF8, VMXNOR_MM }, // 8066
  { PseudoVMXOR_MM_M1, VMXOR_MM }, // 8067
  { PseudoVMXOR_MM_M2, VMXOR_MM }, // 8068
  { PseudoVMXOR_MM_M4, VMXOR_MM }, // 8069
  { PseudoVMXOR_MM_M8, VMXOR_MM }, // 8070
  { PseudoVMXOR_MM_MF2, VMXOR_MM }, // 8071
  { PseudoVMXOR_MM_MF4, VMXOR_MM }, // 8072
  { PseudoVMXOR_MM_MF8, VMXOR_MM }, // 8073
  { PseudoVNCLIPU_WI_M1, VNCLIPU_WI }, // 8074
  { PseudoVNCLIPU_WI_M1_MASK, VNCLIPU_WI }, // 8075
  { PseudoVNCLIPU_WI_M1_TU, VNCLIPU_WI }, // 8076
  { PseudoVNCLIPU_WI_M2, VNCLIPU_WI }, // 8077
  { PseudoVNCLIPU_WI_M2_MASK, VNCLIPU_WI }, // 8078
  { PseudoVNCLIPU_WI_M2_TU, VNCLIPU_WI }, // 8079
  { PseudoVNCLIPU_WI_M4, VNCLIPU_WI }, // 8080
  { PseudoVNCLIPU_WI_M4_MASK, VNCLIPU_WI }, // 8081
  { PseudoVNCLIPU_WI_M4_TU, VNCLIPU_WI }, // 8082
  { PseudoVNCLIPU_WI_MF2, VNCLIPU_WI }, // 8083
  { PseudoVNCLIPU_WI_MF2_MASK, VNCLIPU_WI }, // 8084
  { PseudoVNCLIPU_WI_MF2_TU, VNCLIPU_WI }, // 8085
  { PseudoVNCLIPU_WI_MF4, VNCLIPU_WI }, // 8086
  { PseudoVNCLIPU_WI_MF4_MASK, VNCLIPU_WI }, // 8087
  { PseudoVNCLIPU_WI_MF4_TU, VNCLIPU_WI }, // 8088
  { PseudoVNCLIPU_WI_MF8, VNCLIPU_WI }, // 8089
  { PseudoVNCLIPU_WI_MF8_MASK, VNCLIPU_WI }, // 8090
  { PseudoVNCLIPU_WI_MF8_TU, VNCLIPU_WI }, // 8091
  { PseudoVNCLIPU_WV_M1, VNCLIPU_WV }, // 8092
  { PseudoVNCLIPU_WV_M1_MASK, VNCLIPU_WV }, // 8093
  { PseudoVNCLIPU_WV_M1_TU, VNCLIPU_WV }, // 8094
  { PseudoVNCLIPU_WV_M2, VNCLIPU_WV }, // 8095
  { PseudoVNCLIPU_WV_M2_MASK, VNCLIPU_WV }, // 8096
  { PseudoVNCLIPU_WV_M2_TU, VNCLIPU_WV }, // 8097
  { PseudoVNCLIPU_WV_M4, VNCLIPU_WV }, // 8098
  { PseudoVNCLIPU_WV_M4_MASK, VNCLIPU_WV }, // 8099
  { PseudoVNCLIPU_WV_M4_TU, VNCLIPU_WV }, // 8100
  { PseudoVNCLIPU_WV_MF2, VNCLIPU_WV }, // 8101
  { PseudoVNCLIPU_WV_MF2_MASK, VNCLIPU_WV }, // 8102
  { PseudoVNCLIPU_WV_MF2_TU, VNCLIPU_WV }, // 8103
  { PseudoVNCLIPU_WV_MF4, VNCLIPU_WV }, // 8104
  { PseudoVNCLIPU_WV_MF4_MASK, VNCLIPU_WV }, // 8105
  { PseudoVNCLIPU_WV_MF4_TU, VNCLIPU_WV }, // 8106
  { PseudoVNCLIPU_WV_MF8, VNCLIPU_WV }, // 8107
  { PseudoVNCLIPU_WV_MF8_MASK, VNCLIPU_WV }, // 8108
  { PseudoVNCLIPU_WV_MF8_TU, VNCLIPU_WV }, // 8109
  { PseudoVNCLIPU_WX_M1, VNCLIPU_WX }, // 8110
  { PseudoVNCLIPU_WX_M1_MASK, VNCLIPU_WX }, // 8111
  { PseudoVNCLIPU_WX_M1_TU, VNCLIPU_WX }, // 8112
  { PseudoVNCLIPU_WX_M2, VNCLIPU_WX }, // 8113
  { PseudoVNCLIPU_WX_M2_MASK, VNCLIPU_WX }, // 8114
  { PseudoVNCLIPU_WX_M2_TU, VNCLIPU_WX }, // 8115
  { PseudoVNCLIPU_WX_M4, VNCLIPU_WX }, // 8116
  { PseudoVNCLIPU_WX_M4_MASK, VNCLIPU_WX }, // 8117
  { PseudoVNCLIPU_WX_M4_TU, VNCLIPU_WX }, // 8118
  { PseudoVNCLIPU_WX_MF2, VNCLIPU_WX }, // 8119
  { PseudoVNCLIPU_WX_MF2_MASK, VNCLIPU_WX }, // 8120
  { PseudoVNCLIPU_WX_MF2_TU, VNCLIPU_WX }, // 8121
  { PseudoVNCLIPU_WX_MF4, VNCLIPU_WX }, // 8122
  { PseudoVNCLIPU_WX_MF4_MASK, VNCLIPU_WX }, // 8123
  { PseudoVNCLIPU_WX_MF4_TU, VNCLIPU_WX }, // 8124
  { PseudoVNCLIPU_WX_MF8, VNCLIPU_WX }, // 8125
  { PseudoVNCLIPU_WX_MF8_MASK, VNCLIPU_WX }, // 8126
  { PseudoVNCLIPU_WX_MF8_TU, VNCLIPU_WX }, // 8127
  { PseudoVNCLIP_WI_M1, VNCLIP_WI }, // 8128
  { PseudoVNCLIP_WI_M1_MASK, VNCLIP_WI }, // 8129
  { PseudoVNCLIP_WI_M1_TU, VNCLIP_WI }, // 8130
  { PseudoVNCLIP_WI_M2, VNCLIP_WI }, // 8131
  { PseudoVNCLIP_WI_M2_MASK, VNCLIP_WI }, // 8132
  { PseudoVNCLIP_WI_M2_TU, VNCLIP_WI }, // 8133
  { PseudoVNCLIP_WI_M4, VNCLIP_WI }, // 8134
  { PseudoVNCLIP_WI_M4_MASK, VNCLIP_WI }, // 8135
  { PseudoVNCLIP_WI_M4_TU, VNCLIP_WI }, // 8136
  { PseudoVNCLIP_WI_MF2, VNCLIP_WI }, // 8137
  { PseudoVNCLIP_WI_MF2_MASK, VNCLIP_WI }, // 8138
  { PseudoVNCLIP_WI_MF2_TU, VNCLIP_WI }, // 8139
  { PseudoVNCLIP_WI_MF4, VNCLIP_WI }, // 8140
  { PseudoVNCLIP_WI_MF4_MASK, VNCLIP_WI }, // 8141
  { PseudoVNCLIP_WI_MF4_TU, VNCLIP_WI }, // 8142
  { PseudoVNCLIP_WI_MF8, VNCLIP_WI }, // 8143
  { PseudoVNCLIP_WI_MF8_MASK, VNCLIP_WI }, // 8144
  { PseudoVNCLIP_WI_MF8_TU, VNCLIP_WI }, // 8145
  { PseudoVNCLIP_WV_M1, VNCLIP_WV }, // 8146
  { PseudoVNCLIP_WV_M1_MASK, VNCLIP_WV }, // 8147
  { PseudoVNCLIP_WV_M1_TU, VNCLIP_WV }, // 8148
  { PseudoVNCLIP_WV_M2, VNCLIP_WV }, // 8149
  { PseudoVNCLIP_WV_M2_MASK, VNCLIP_WV }, // 8150
  { PseudoVNCLIP_WV_M2_TU, VNCLIP_WV }, // 8151
  { PseudoVNCLIP_WV_M4, VNCLIP_WV }, // 8152
  { PseudoVNCLIP_WV_M4_MASK, VNCLIP_WV }, // 8153
  { PseudoVNCLIP_WV_M4_TU, VNCLIP_WV }, // 8154
  { PseudoVNCLIP_WV_MF2, VNCLIP_WV }, // 8155
  { PseudoVNCLIP_WV_MF2_MASK, VNCLIP_WV }, // 8156
  { PseudoVNCLIP_WV_MF2_TU, VNCLIP_WV }, // 8157
  { PseudoVNCLIP_WV_MF4, VNCLIP_WV }, // 8158
  { PseudoVNCLIP_WV_MF4_MASK, VNCLIP_WV }, // 8159
  { PseudoVNCLIP_WV_MF4_TU, VNCLIP_WV }, // 8160
  { PseudoVNCLIP_WV_MF8, VNCLIP_WV }, // 8161
  { PseudoVNCLIP_WV_MF8_MASK, VNCLIP_WV }, // 8162
  { PseudoVNCLIP_WV_MF8_TU, VNCLIP_WV }, // 8163
  { PseudoVNCLIP_WX_M1, VNCLIP_WX }, // 8164
  { PseudoVNCLIP_WX_M1_MASK, VNCLIP_WX }, // 8165
  { PseudoVNCLIP_WX_M1_TU, VNCLIP_WX }, // 8166
  { PseudoVNCLIP_WX_M2, VNCLIP_WX }, // 8167
  { PseudoVNCLIP_WX_M2_MASK, VNCLIP_WX }, // 8168
  { PseudoVNCLIP_WX_M2_TU, VNCLIP_WX }, // 8169
  { PseudoVNCLIP_WX_M4, VNCLIP_WX }, // 8170
  { PseudoVNCLIP_WX_M4_MASK, VNCLIP_WX }, // 8171
  { PseudoVNCLIP_WX_M4_TU, VNCLIP_WX }, // 8172
  { PseudoVNCLIP_WX_MF2, VNCLIP_WX }, // 8173
  { PseudoVNCLIP_WX_MF2_MASK, VNCLIP_WX }, // 8174
  { PseudoVNCLIP_WX_MF2_TU, VNCLIP_WX }, // 8175
  { PseudoVNCLIP_WX_MF4, VNCLIP_WX }, // 8176
  { PseudoVNCLIP_WX_MF4_MASK, VNCLIP_WX }, // 8177
  { PseudoVNCLIP_WX_MF4_TU, VNCLIP_WX }, // 8178
  { PseudoVNCLIP_WX_MF8, VNCLIP_WX }, // 8179
  { PseudoVNCLIP_WX_MF8_MASK, VNCLIP_WX }, // 8180
  { PseudoVNCLIP_WX_MF8_TU, VNCLIP_WX }, // 8181
  { PseudoVNMSAC_VV_M1, VNMSAC_VV }, // 8182
  { PseudoVNMSAC_VV_M1_MASK, VNMSAC_VV }, // 8183
  { PseudoVNMSAC_VV_M2, VNMSAC_VV }, // 8184
  { PseudoVNMSAC_VV_M2_MASK, VNMSAC_VV }, // 8185
  { PseudoVNMSAC_VV_M4, VNMSAC_VV }, // 8186
  { PseudoVNMSAC_VV_M4_MASK, VNMSAC_VV }, // 8187
  { PseudoVNMSAC_VV_M8, VNMSAC_VV }, // 8188
  { PseudoVNMSAC_VV_M8_MASK, VNMSAC_VV }, // 8189
  { PseudoVNMSAC_VV_MF2, VNMSAC_VV }, // 8190
  { PseudoVNMSAC_VV_MF2_MASK, VNMSAC_VV }, // 8191
  { PseudoVNMSAC_VV_MF4, VNMSAC_VV }, // 8192
  { PseudoVNMSAC_VV_MF4_MASK, VNMSAC_VV }, // 8193
  { PseudoVNMSAC_VV_MF8, VNMSAC_VV }, // 8194
  { PseudoVNMSAC_VV_MF8_MASK, VNMSAC_VV }, // 8195
  { PseudoVNMSAC_VX_M1, VNMSAC_VX }, // 8196
  { PseudoVNMSAC_VX_M1_MASK, VNMSAC_VX }, // 8197
  { PseudoVNMSAC_VX_M2, VNMSAC_VX }, // 8198
  { PseudoVNMSAC_VX_M2_MASK, VNMSAC_VX }, // 8199
  { PseudoVNMSAC_VX_M4, VNMSAC_VX }, // 8200
  { PseudoVNMSAC_VX_M4_MASK, VNMSAC_VX }, // 8201
  { PseudoVNMSAC_VX_M8, VNMSAC_VX }, // 8202
  { PseudoVNMSAC_VX_M8_MASK, VNMSAC_VX }, // 8203
  { PseudoVNMSAC_VX_MF2, VNMSAC_VX }, // 8204
  { PseudoVNMSAC_VX_MF2_MASK, VNMSAC_VX }, // 8205
  { PseudoVNMSAC_VX_MF4, VNMSAC_VX }, // 8206
  { PseudoVNMSAC_VX_MF4_MASK, VNMSAC_VX }, // 8207
  { PseudoVNMSAC_VX_MF8, VNMSAC_VX }, // 8208
  { PseudoVNMSAC_VX_MF8_MASK, VNMSAC_VX }, // 8209
  { PseudoVNMSUB_VV_M1, VNMSUB_VV }, // 8210
  { PseudoVNMSUB_VV_M1_MASK, VNMSUB_VV }, // 8211
  { PseudoVNMSUB_VV_M2, VNMSUB_VV }, // 8212
  { PseudoVNMSUB_VV_M2_MASK, VNMSUB_VV }, // 8213
  { PseudoVNMSUB_VV_M4, VNMSUB_VV }, // 8214
  { PseudoVNMSUB_VV_M4_MASK, VNMSUB_VV }, // 8215
  { PseudoVNMSUB_VV_M8, VNMSUB_VV }, // 8216
  { PseudoVNMSUB_VV_M8_MASK, VNMSUB_VV }, // 8217
  { PseudoVNMSUB_VV_MF2, VNMSUB_VV }, // 8218
  { PseudoVNMSUB_VV_MF2_MASK, VNMSUB_VV }, // 8219
  { PseudoVNMSUB_VV_MF4, VNMSUB_VV }, // 8220
  { PseudoVNMSUB_VV_MF4_MASK, VNMSUB_VV }, // 8221
  { PseudoVNMSUB_VV_MF8, VNMSUB_VV }, // 8222
  { PseudoVNMSUB_VV_MF8_MASK, VNMSUB_VV }, // 8223
  { PseudoVNMSUB_VX_M1, VNMSUB_VX }, // 8224
  { PseudoVNMSUB_VX_M1_MASK, VNMSUB_VX }, // 8225
  { PseudoVNMSUB_VX_M2, VNMSUB_VX }, // 8226
  { PseudoVNMSUB_VX_M2_MASK, VNMSUB_VX }, // 8227
  { PseudoVNMSUB_VX_M4, VNMSUB_VX }, // 8228
  { PseudoVNMSUB_VX_M4_MASK, VNMSUB_VX }, // 8229
  { PseudoVNMSUB_VX_M8, VNMSUB_VX }, // 8230
  { PseudoVNMSUB_VX_M8_MASK, VNMSUB_VX }, // 8231
  { PseudoVNMSUB_VX_MF2, VNMSUB_VX }, // 8232
  { PseudoVNMSUB_VX_MF2_MASK, VNMSUB_VX }, // 8233
  { PseudoVNMSUB_VX_MF4, VNMSUB_VX }, // 8234
  { PseudoVNMSUB_VX_MF4_MASK, VNMSUB_VX }, // 8235
  { PseudoVNMSUB_VX_MF8, VNMSUB_VX }, // 8236
  { PseudoVNMSUB_VX_MF8_MASK, VNMSUB_VX }, // 8237
  { PseudoVNSRA_WI_M1, VNSRA_WI }, // 8238
  { PseudoVNSRA_WI_M1_MASK, VNSRA_WI }, // 8239
  { PseudoVNSRA_WI_M1_TU, VNSRA_WI }, // 8240
  { PseudoVNSRA_WI_M2, VNSRA_WI }, // 8241
  { PseudoVNSRA_WI_M2_MASK, VNSRA_WI }, // 8242
  { PseudoVNSRA_WI_M2_TU, VNSRA_WI }, // 8243
  { PseudoVNSRA_WI_M4, VNSRA_WI }, // 8244
  { PseudoVNSRA_WI_M4_MASK, VNSRA_WI }, // 8245
  { PseudoVNSRA_WI_M4_TU, VNSRA_WI }, // 8246
  { PseudoVNSRA_WI_MF2, VNSRA_WI }, // 8247
  { PseudoVNSRA_WI_MF2_MASK, VNSRA_WI }, // 8248
  { PseudoVNSRA_WI_MF2_TU, VNSRA_WI }, // 8249
  { PseudoVNSRA_WI_MF4, VNSRA_WI }, // 8250
  { PseudoVNSRA_WI_MF4_MASK, VNSRA_WI }, // 8251
  { PseudoVNSRA_WI_MF4_TU, VNSRA_WI }, // 8252
  { PseudoVNSRA_WI_MF8, VNSRA_WI }, // 8253
  { PseudoVNSRA_WI_MF8_MASK, VNSRA_WI }, // 8254
  { PseudoVNSRA_WI_MF8_TU, VNSRA_WI }, // 8255
  { PseudoVNSRA_WV_M1, VNSRA_WV }, // 8256
  { PseudoVNSRA_WV_M1_MASK, VNSRA_WV }, // 8257
  { PseudoVNSRA_WV_M1_TU, VNSRA_WV }, // 8258
  { PseudoVNSRA_WV_M2, VNSRA_WV }, // 8259
  { PseudoVNSRA_WV_M2_MASK, VNSRA_WV }, // 8260
  { PseudoVNSRA_WV_M2_TU, VNSRA_WV }, // 8261
  { PseudoVNSRA_WV_M4, VNSRA_WV }, // 8262
  { PseudoVNSRA_WV_M4_MASK, VNSRA_WV }, // 8263
  { PseudoVNSRA_WV_M4_TU, VNSRA_WV }, // 8264
  { PseudoVNSRA_WV_MF2, VNSRA_WV }, // 8265
  { PseudoVNSRA_WV_MF2_MASK, VNSRA_WV }, // 8266
  { PseudoVNSRA_WV_MF2_TU, VNSRA_WV }, // 8267
  { PseudoVNSRA_WV_MF4, VNSRA_WV }, // 8268
  { PseudoVNSRA_WV_MF4_MASK, VNSRA_WV }, // 8269
  { PseudoVNSRA_WV_MF4_TU, VNSRA_WV }, // 8270
  { PseudoVNSRA_WV_MF8, VNSRA_WV }, // 8271
  { PseudoVNSRA_WV_MF8_MASK, VNSRA_WV }, // 8272
  { PseudoVNSRA_WV_MF8_TU, VNSRA_WV }, // 8273
  { PseudoVNSRA_WX_M1, VNSRA_WX }, // 8274
  { PseudoVNSRA_WX_M1_MASK, VNSRA_WX }, // 8275
  { PseudoVNSRA_WX_M1_TU, VNSRA_WX }, // 8276
  { PseudoVNSRA_WX_M2, VNSRA_WX }, // 8277
  { PseudoVNSRA_WX_M2_MASK, VNSRA_WX }, // 8278
  { PseudoVNSRA_WX_M2_TU, VNSRA_WX }, // 8279
  { PseudoVNSRA_WX_M4, VNSRA_WX }, // 8280
  { PseudoVNSRA_WX_M4_MASK, VNSRA_WX }, // 8281
  { PseudoVNSRA_WX_M4_TU, VNSRA_WX }, // 8282
  { PseudoVNSRA_WX_MF2, VNSRA_WX }, // 8283
  { PseudoVNSRA_WX_MF2_MASK, VNSRA_WX }, // 8284
  { PseudoVNSRA_WX_MF2_TU, VNSRA_WX }, // 8285
  { PseudoVNSRA_WX_MF4, VNSRA_WX }, // 8286
  { PseudoVNSRA_WX_MF4_MASK, VNSRA_WX }, // 8287
  { PseudoVNSRA_WX_MF4_TU, VNSRA_WX }, // 8288
  { PseudoVNSRA_WX_MF8, VNSRA_WX }, // 8289
  { PseudoVNSRA_WX_MF8_MASK, VNSRA_WX }, // 8290
  { PseudoVNSRA_WX_MF8_TU, VNSRA_WX }, // 8291
  { PseudoVNSRL_WI_M1, VNSRL_WI }, // 8292
  { PseudoVNSRL_WI_M1_MASK, VNSRL_WI }, // 8293
  { PseudoVNSRL_WI_M1_TU, VNSRL_WI }, // 8294
  { PseudoVNSRL_WI_M2, VNSRL_WI }, // 8295
  { PseudoVNSRL_WI_M2_MASK, VNSRL_WI }, // 8296
  { PseudoVNSRL_WI_M2_TU, VNSRL_WI }, // 8297
  { PseudoVNSRL_WI_M4, VNSRL_WI }, // 8298
  { PseudoVNSRL_WI_M4_MASK, VNSRL_WI }, // 8299
  { PseudoVNSRL_WI_M4_TU, VNSRL_WI }, // 8300
  { PseudoVNSRL_WI_MF2, VNSRL_WI }, // 8301
  { PseudoVNSRL_WI_MF2_MASK, VNSRL_WI }, // 8302
  { PseudoVNSRL_WI_MF2_TU, VNSRL_WI }, // 8303
  { PseudoVNSRL_WI_MF4, VNSRL_WI }, // 8304
  { PseudoVNSRL_WI_MF4_MASK, VNSRL_WI }, // 8305
  { PseudoVNSRL_WI_MF4_TU, VNSRL_WI }, // 8306
  { PseudoVNSRL_WI_MF8, VNSRL_WI }, // 8307
  { PseudoVNSRL_WI_MF8_MASK, VNSRL_WI }, // 8308
  { PseudoVNSRL_WI_MF8_TU, VNSRL_WI }, // 8309
  { PseudoVNSRL_WV_M1, VNSRL_WV }, // 8310
  { PseudoVNSRL_WV_M1_MASK, VNSRL_WV }, // 8311
  { PseudoVNSRL_WV_M1_TU, VNSRL_WV }, // 8312
  { PseudoVNSRL_WV_M2, VNSRL_WV }, // 8313
  { PseudoVNSRL_WV_M2_MASK, VNSRL_WV }, // 8314
  { PseudoVNSRL_WV_M2_TU, VNSRL_WV }, // 8315
  { PseudoVNSRL_WV_M4, VNSRL_WV }, // 8316
  { PseudoVNSRL_WV_M4_MASK, VNSRL_WV }, // 8317
  { PseudoVNSRL_WV_M4_TU, VNSRL_WV }, // 8318
  { PseudoVNSRL_WV_MF2, VNSRL_WV }, // 8319
  { PseudoVNSRL_WV_MF2_MASK, VNSRL_WV }, // 8320
  { PseudoVNSRL_WV_MF2_TU, VNSRL_WV }, // 8321
  { PseudoVNSRL_WV_MF4, VNSRL_WV }, // 8322
  { PseudoVNSRL_WV_MF4_MASK, VNSRL_WV }, // 8323
  { PseudoVNSRL_WV_MF4_TU, VNSRL_WV }, // 8324
  { PseudoVNSRL_WV_MF8, VNSRL_WV }, // 8325
  { PseudoVNSRL_WV_MF8_MASK, VNSRL_WV }, // 8326
  { PseudoVNSRL_WV_MF8_TU, VNSRL_WV }, // 8327
  { PseudoVNSRL_WX_M1, VNSRL_WX }, // 8328
  { PseudoVNSRL_WX_M1_MASK, VNSRL_WX }, // 8329
  { PseudoVNSRL_WX_M1_TU, VNSRL_WX }, // 8330
  { PseudoVNSRL_WX_M2, VNSRL_WX }, // 8331
  { PseudoVNSRL_WX_M2_MASK, VNSRL_WX }, // 8332
  { PseudoVNSRL_WX_M2_TU, VNSRL_WX }, // 8333
  { PseudoVNSRL_WX_M4, VNSRL_WX }, // 8334
  { PseudoVNSRL_WX_M4_MASK, VNSRL_WX }, // 8335
  { PseudoVNSRL_WX_M4_TU, VNSRL_WX }, // 8336
  { PseudoVNSRL_WX_MF2, VNSRL_WX }, // 8337
  { PseudoVNSRL_WX_MF2_MASK, VNSRL_WX }, // 8338
  { PseudoVNSRL_WX_MF2_TU, VNSRL_WX }, // 8339
  { PseudoVNSRL_WX_MF4, VNSRL_WX }, // 8340
  { PseudoVNSRL_WX_MF4_MASK, VNSRL_WX }, // 8341
  { PseudoVNSRL_WX_MF4_TU, VNSRL_WX }, // 8342
  { PseudoVNSRL_WX_MF8, VNSRL_WX }, // 8343
  { PseudoVNSRL_WX_MF8_MASK, VNSRL_WX }, // 8344
  { PseudoVNSRL_WX_MF8_TU, VNSRL_WX }, // 8345
  { PseudoVOR_VI_M1, VOR_VI }, // 8346
  { PseudoVOR_VI_M1_MASK, VOR_VI }, // 8347
  { PseudoVOR_VI_M1_TU, VOR_VI }, // 8348
  { PseudoVOR_VI_M2, VOR_VI }, // 8349
  { PseudoVOR_VI_M2_MASK, VOR_VI }, // 8350
  { PseudoVOR_VI_M2_TU, VOR_VI }, // 8351
  { PseudoVOR_VI_M4, VOR_VI }, // 8352
  { PseudoVOR_VI_M4_MASK, VOR_VI }, // 8353
  { PseudoVOR_VI_M4_TU, VOR_VI }, // 8354
  { PseudoVOR_VI_M8, VOR_VI }, // 8355
  { PseudoVOR_VI_M8_MASK, VOR_VI }, // 8356
  { PseudoVOR_VI_M8_TU, VOR_VI }, // 8357
  { PseudoVOR_VI_MF2, VOR_VI }, // 8358
  { PseudoVOR_VI_MF2_MASK, VOR_VI }, // 8359
  { PseudoVOR_VI_MF2_TU, VOR_VI }, // 8360
  { PseudoVOR_VI_MF4, VOR_VI }, // 8361
  { PseudoVOR_VI_MF4_MASK, VOR_VI }, // 8362
  { PseudoVOR_VI_MF4_TU, VOR_VI }, // 8363
  { PseudoVOR_VI_MF8, VOR_VI }, // 8364
  { PseudoVOR_VI_MF8_MASK, VOR_VI }, // 8365
  { PseudoVOR_VI_MF8_TU, VOR_VI }, // 8366
  { PseudoVOR_VV_M1, VOR_VV }, // 8367
  { PseudoVOR_VV_M1_MASK, VOR_VV }, // 8368
  { PseudoVOR_VV_M1_TU, VOR_VV }, // 8369
  { PseudoVOR_VV_M2, VOR_VV }, // 8370
  { PseudoVOR_VV_M2_MASK, VOR_VV }, // 8371
  { PseudoVOR_VV_M2_TU, VOR_VV }, // 8372
  { PseudoVOR_VV_M4, VOR_VV }, // 8373
  { PseudoVOR_VV_M4_MASK, VOR_VV }, // 8374
  { PseudoVOR_VV_M4_TU, VOR_VV }, // 8375
  { PseudoVOR_VV_M8, VOR_VV }, // 8376
  { PseudoVOR_VV_M8_MASK, VOR_VV }, // 8377
  { PseudoVOR_VV_M8_TU, VOR_VV }, // 8378
  { PseudoVOR_VV_MF2, VOR_VV }, // 8379
  { PseudoVOR_VV_MF2_MASK, VOR_VV }, // 8380
  { PseudoVOR_VV_MF2_TU, VOR_VV }, // 8381
  { PseudoVOR_VV_MF4, VOR_VV }, // 8382
  { PseudoVOR_VV_MF4_MASK, VOR_VV }, // 8383
  { PseudoVOR_VV_MF4_TU, VOR_VV }, // 8384
  { PseudoVOR_VV_MF8, VOR_VV }, // 8385
  { PseudoVOR_VV_MF8_MASK, VOR_VV }, // 8386
  { PseudoVOR_VV_MF8_TU, VOR_VV }, // 8387
  { PseudoVOR_VX_M1, VOR_VX }, // 8388
  { PseudoVOR_VX_M1_MASK, VOR_VX }, // 8389
  { PseudoVOR_VX_M1_TU, VOR_VX }, // 8390
  { PseudoVOR_VX_M2, VOR_VX }, // 8391
  { PseudoVOR_VX_M2_MASK, VOR_VX }, // 8392
  { PseudoVOR_VX_M2_TU, VOR_VX }, // 8393
  { PseudoVOR_VX_M4, VOR_VX }, // 8394
  { PseudoVOR_VX_M4_MASK, VOR_VX }, // 8395
  { PseudoVOR_VX_M4_TU, VOR_VX }, // 8396
  { PseudoVOR_VX_M8, VOR_VX }, // 8397
  { PseudoVOR_VX_M8_MASK, VOR_VX }, // 8398
  { PseudoVOR_VX_M8_TU, VOR_VX }, // 8399
  { PseudoVOR_VX_MF2, VOR_VX }, // 8400
  { PseudoVOR_VX_MF2_MASK, VOR_VX }, // 8401
  { PseudoVOR_VX_MF2_TU, VOR_VX }, // 8402
  { PseudoVOR_VX_MF4, VOR_VX }, // 8403
  { PseudoVOR_VX_MF4_MASK, VOR_VX }, // 8404
  { PseudoVOR_VX_MF4_TU, VOR_VX }, // 8405
  { PseudoVOR_VX_MF8, VOR_VX }, // 8406
  { PseudoVOR_VX_MF8_MASK, VOR_VX }, // 8407
  { PseudoVOR_VX_MF8_TU, VOR_VX }, // 8408
  { PseudoVREDAND_VS_M1_E16, VREDAND_VS }, // 8409
  { PseudoVREDAND_VS_M1_E16_MASK, VREDAND_VS }, // 8410
  { PseudoVREDAND_VS_M1_E32, VREDAND_VS }, // 8411
  { PseudoVREDAND_VS_M1_E32_MASK, VREDAND_VS }, // 8412
  { PseudoVREDAND_VS_M1_E64, VREDAND_VS }, // 8413
  { PseudoVREDAND_VS_M1_E64_MASK, VREDAND_VS }, // 8414
  { PseudoVREDAND_VS_M1_E8, VREDAND_VS }, // 8415
  { PseudoVREDAND_VS_M1_E8_MASK, VREDAND_VS }, // 8416
  { PseudoVREDAND_VS_M2_E16, VREDAND_VS }, // 8417
  { PseudoVREDAND_VS_M2_E16_MASK, VREDAND_VS }, // 8418
  { PseudoVREDAND_VS_M2_E32, VREDAND_VS }, // 8419
  { PseudoVREDAND_VS_M2_E32_MASK, VREDAND_VS }, // 8420
  { PseudoVREDAND_VS_M2_E64, VREDAND_VS }, // 8421
  { PseudoVREDAND_VS_M2_E64_MASK, VREDAND_VS }, // 8422
  { PseudoVREDAND_VS_M2_E8, VREDAND_VS }, // 8423
  { PseudoVREDAND_VS_M2_E8_MASK, VREDAND_VS }, // 8424
  { PseudoVREDAND_VS_M4_E16, VREDAND_VS }, // 8425
  { PseudoVREDAND_VS_M4_E16_MASK, VREDAND_VS }, // 8426
  { PseudoVREDAND_VS_M4_E32, VREDAND_VS }, // 8427
  { PseudoVREDAND_VS_M4_E32_MASK, VREDAND_VS }, // 8428
  { PseudoVREDAND_VS_M4_E64, VREDAND_VS }, // 8429
  { PseudoVREDAND_VS_M4_E64_MASK, VREDAND_VS }, // 8430
  { PseudoVREDAND_VS_M4_E8, VREDAND_VS }, // 8431
  { PseudoVREDAND_VS_M4_E8_MASK, VREDAND_VS }, // 8432
  { PseudoVREDAND_VS_M8_E16, VREDAND_VS }, // 8433
  { PseudoVREDAND_VS_M8_E16_MASK, VREDAND_VS }, // 8434
  { PseudoVREDAND_VS_M8_E32, VREDAND_VS }, // 8435
  { PseudoVREDAND_VS_M8_E32_MASK, VREDAND_VS }, // 8436
  { PseudoVREDAND_VS_M8_E64, VREDAND_VS }, // 8437
  { PseudoVREDAND_VS_M8_E64_MASK, VREDAND_VS }, // 8438
  { PseudoVREDAND_VS_M8_E8, VREDAND_VS }, // 8439
  { PseudoVREDAND_VS_M8_E8_MASK, VREDAND_VS }, // 8440
  { PseudoVREDAND_VS_MF2_E16, VREDAND_VS }, // 8441
  { PseudoVREDAND_VS_MF2_E16_MASK, VREDAND_VS }, // 8442
  { PseudoVREDAND_VS_MF2_E32, VREDAND_VS }, // 8443
  { PseudoVREDAND_VS_MF2_E32_MASK, VREDAND_VS }, // 8444
  { PseudoVREDAND_VS_MF2_E8, VREDAND_VS }, // 8445
  { PseudoVREDAND_VS_MF2_E8_MASK, VREDAND_VS }, // 8446
  { PseudoVREDAND_VS_MF4_E16, VREDAND_VS }, // 8447
  { PseudoVREDAND_VS_MF4_E16_MASK, VREDAND_VS }, // 8448
  { PseudoVREDAND_VS_MF4_E8, VREDAND_VS }, // 8449
  { PseudoVREDAND_VS_MF4_E8_MASK, VREDAND_VS }, // 8450
  { PseudoVREDAND_VS_MF8_E8, VREDAND_VS }, // 8451
  { PseudoVREDAND_VS_MF8_E8_MASK, VREDAND_VS }, // 8452
  { PseudoVREDMAXU_VS_M1_E16, VREDMAXU_VS }, // 8453
  { PseudoVREDMAXU_VS_M1_E16_MASK, VREDMAXU_VS }, // 8454
  { PseudoVREDMAXU_VS_M1_E32, VREDMAXU_VS }, // 8455
  { PseudoVREDMAXU_VS_M1_E32_MASK, VREDMAXU_VS }, // 8456
  { PseudoVREDMAXU_VS_M1_E64, VREDMAXU_VS }, // 8457
  { PseudoVREDMAXU_VS_M1_E64_MASK, VREDMAXU_VS }, // 8458
  { PseudoVREDMAXU_VS_M1_E8, VREDMAXU_VS }, // 8459
  { PseudoVREDMAXU_VS_M1_E8_MASK, VREDMAXU_VS }, // 8460
  { PseudoVREDMAXU_VS_M2_E16, VREDMAXU_VS }, // 8461
  { PseudoVREDMAXU_VS_M2_E16_MASK, VREDMAXU_VS }, // 8462
  { PseudoVREDMAXU_VS_M2_E32, VREDMAXU_VS }, // 8463
  { PseudoVREDMAXU_VS_M2_E32_MASK, VREDMAXU_VS }, // 8464
  { PseudoVREDMAXU_VS_M2_E64, VREDMAXU_VS }, // 8465
  { PseudoVREDMAXU_VS_M2_E64_MASK, VREDMAXU_VS }, // 8466
  { PseudoVREDMAXU_VS_M2_E8, VREDMAXU_VS }, // 8467
  { PseudoVREDMAXU_VS_M2_E8_MASK, VREDMAXU_VS }, // 8468
  { PseudoVREDMAXU_VS_M4_E16, VREDMAXU_VS }, // 8469
  { PseudoVREDMAXU_VS_M4_E16_MASK, VREDMAXU_VS }, // 8470
  { PseudoVREDMAXU_VS_M4_E32, VREDMAXU_VS }, // 8471
  { PseudoVREDMAXU_VS_M4_E32_MASK, VREDMAXU_VS }, // 8472
  { PseudoVREDMAXU_VS_M4_E64, VREDMAXU_VS }, // 8473
  { PseudoVREDMAXU_VS_M4_E64_MASK, VREDMAXU_VS }, // 8474
  { PseudoVREDMAXU_VS_M4_E8, VREDMAXU_VS }, // 8475
  { PseudoVREDMAXU_VS_M4_E8_MASK, VREDMAXU_VS }, // 8476
  { PseudoVREDMAXU_VS_M8_E16, VREDMAXU_VS }, // 8477
  { PseudoVREDMAXU_VS_M8_E16_MASK, VREDMAXU_VS }, // 8478
  { PseudoVREDMAXU_VS_M8_E32, VREDMAXU_VS }, // 8479
  { PseudoVREDMAXU_VS_M8_E32_MASK, VREDMAXU_VS }, // 8480
  { PseudoVREDMAXU_VS_M8_E64, VREDMAXU_VS }, // 8481
  { PseudoVREDMAXU_VS_M8_E64_MASK, VREDMAXU_VS }, // 8482
  { PseudoVREDMAXU_VS_M8_E8, VREDMAXU_VS }, // 8483
  { PseudoVREDMAXU_VS_M8_E8_MASK, VREDMAXU_VS }, // 8484
  { PseudoVREDMAXU_VS_MF2_E16, VREDMAXU_VS }, // 8485
  { PseudoVREDMAXU_VS_MF2_E16_MASK, VREDMAXU_VS }, // 8486
  { PseudoVREDMAXU_VS_MF2_E32, VREDMAXU_VS }, // 8487
  { PseudoVREDMAXU_VS_MF2_E32_MASK, VREDMAXU_VS }, // 8488
  { PseudoVREDMAXU_VS_MF2_E8, VREDMAXU_VS }, // 8489
  { PseudoVREDMAXU_VS_MF2_E8_MASK, VREDMAXU_VS }, // 8490
  { PseudoVREDMAXU_VS_MF4_E16, VREDMAXU_VS }, // 8491
  { PseudoVREDMAXU_VS_MF4_E16_MASK, VREDMAXU_VS }, // 8492
  { PseudoVREDMAXU_VS_MF4_E8, VREDMAXU_VS }, // 8493
  { PseudoVREDMAXU_VS_MF4_E8_MASK, VREDMAXU_VS }, // 8494
  { PseudoVREDMAXU_VS_MF8_E8, VREDMAXU_VS }, // 8495
  { PseudoVREDMAXU_VS_MF8_E8_MASK, VREDMAXU_VS }, // 8496
  { PseudoVREDMAX_VS_M1_E16, VREDMAX_VS }, // 8497
  { PseudoVREDMAX_VS_M1_E16_MASK, VREDMAX_VS }, // 8498
  { PseudoVREDMAX_VS_M1_E32, VREDMAX_VS }, // 8499
  { PseudoVREDMAX_VS_M1_E32_MASK, VREDMAX_VS }, // 8500
  { PseudoVREDMAX_VS_M1_E64, VREDMAX_VS }, // 8501
  { PseudoVREDMAX_VS_M1_E64_MASK, VREDMAX_VS }, // 8502
  { PseudoVREDMAX_VS_M1_E8, VREDMAX_VS }, // 8503
  { PseudoVREDMAX_VS_M1_E8_MASK, VREDMAX_VS }, // 8504
  { PseudoVREDMAX_VS_M2_E16, VREDMAX_VS }, // 8505
  { PseudoVREDMAX_VS_M2_E16_MASK, VREDMAX_VS }, // 8506
  { PseudoVREDMAX_VS_M2_E32, VREDMAX_VS }, // 8507
  { PseudoVREDMAX_VS_M2_E32_MASK, VREDMAX_VS }, // 8508
  { PseudoVREDMAX_VS_M2_E64, VREDMAX_VS }, // 8509
  { PseudoVREDMAX_VS_M2_E64_MASK, VREDMAX_VS }, // 8510
  { PseudoVREDMAX_VS_M2_E8, VREDMAX_VS }, // 8511
  { PseudoVREDMAX_VS_M2_E8_MASK, VREDMAX_VS }, // 8512
  { PseudoVREDMAX_VS_M4_E16, VREDMAX_VS }, // 8513
  { PseudoVREDMAX_VS_M4_E16_MASK, VREDMAX_VS }, // 8514
  { PseudoVREDMAX_VS_M4_E32, VREDMAX_VS }, // 8515
  { PseudoVREDMAX_VS_M4_E32_MASK, VREDMAX_VS }, // 8516
  { PseudoVREDMAX_VS_M4_E64, VREDMAX_VS }, // 8517
  { PseudoVREDMAX_VS_M4_E64_MASK, VREDMAX_VS }, // 8518
  { PseudoVREDMAX_VS_M4_E8, VREDMAX_VS }, // 8519
  { PseudoVREDMAX_VS_M4_E8_MASK, VREDMAX_VS }, // 8520
  { PseudoVREDMAX_VS_M8_E16, VREDMAX_VS }, // 8521
  { PseudoVREDMAX_VS_M8_E16_MASK, VREDMAX_VS }, // 8522
  { PseudoVREDMAX_VS_M8_E32, VREDMAX_VS }, // 8523
  { PseudoVREDMAX_VS_M8_E32_MASK, VREDMAX_VS }, // 8524
  { PseudoVREDMAX_VS_M8_E64, VREDMAX_VS }, // 8525
  { PseudoVREDMAX_VS_M8_E64_MASK, VREDMAX_VS }, // 8526
  { PseudoVREDMAX_VS_M8_E8, VREDMAX_VS }, // 8527
  { PseudoVREDMAX_VS_M8_E8_MASK, VREDMAX_VS }, // 8528
  { PseudoVREDMAX_VS_MF2_E16, VREDMAX_VS }, // 8529
  { PseudoVREDMAX_VS_MF2_E16_MASK, VREDMAX_VS }, // 8530
  { PseudoVREDMAX_VS_MF2_E32, VREDMAX_VS }, // 8531
  { PseudoVREDMAX_VS_MF2_E32_MASK, VREDMAX_VS }, // 8532
  { PseudoVREDMAX_VS_MF2_E8, VREDMAX_VS }, // 8533
  { PseudoVREDMAX_VS_MF2_E8_MASK, VREDMAX_VS }, // 8534
  { PseudoVREDMAX_VS_MF4_E16, VREDMAX_VS }, // 8535
  { PseudoVREDMAX_VS_MF4_E16_MASK, VREDMAX_VS }, // 8536
  { PseudoVREDMAX_VS_MF4_E8, VREDMAX_VS }, // 8537
  { PseudoVREDMAX_VS_MF4_E8_MASK, VREDMAX_VS }, // 8538
  { PseudoVREDMAX_VS_MF8_E8, VREDMAX_VS }, // 8539
  { PseudoVREDMAX_VS_MF8_E8_MASK, VREDMAX_VS }, // 8540
  { PseudoVREDMINU_VS_M1_E16, VREDMINU_VS }, // 8541
  { PseudoVREDMINU_VS_M1_E16_MASK, VREDMINU_VS }, // 8542
  { PseudoVREDMINU_VS_M1_E32, VREDMINU_VS }, // 8543
  { PseudoVREDMINU_VS_M1_E32_MASK, VREDMINU_VS }, // 8544
  { PseudoVREDMINU_VS_M1_E64, VREDMINU_VS }, // 8545
  { PseudoVREDMINU_VS_M1_E64_MASK, VREDMINU_VS }, // 8546
  { PseudoVREDMINU_VS_M1_E8, VREDMINU_VS }, // 8547
  { PseudoVREDMINU_VS_M1_E8_MASK, VREDMINU_VS }, // 8548
  { PseudoVREDMINU_VS_M2_E16, VREDMINU_VS }, // 8549
  { PseudoVREDMINU_VS_M2_E16_MASK, VREDMINU_VS }, // 8550
  { PseudoVREDMINU_VS_M2_E32, VREDMINU_VS }, // 8551
  { PseudoVREDMINU_VS_M2_E32_MASK, VREDMINU_VS }, // 8552
  { PseudoVREDMINU_VS_M2_E64, VREDMINU_VS }, // 8553
  { PseudoVREDMINU_VS_M2_E64_MASK, VREDMINU_VS }, // 8554
  { PseudoVREDMINU_VS_M2_E8, VREDMINU_VS }, // 8555
  { PseudoVREDMINU_VS_M2_E8_MASK, VREDMINU_VS }, // 8556
  { PseudoVREDMINU_VS_M4_E16, VREDMINU_VS }, // 8557
  { PseudoVREDMINU_VS_M4_E16_MASK, VREDMINU_VS }, // 8558
  { PseudoVREDMINU_VS_M4_E32, VREDMINU_VS }, // 8559
  { PseudoVREDMINU_VS_M4_E32_MASK, VREDMINU_VS }, // 8560
  { PseudoVREDMINU_VS_M4_E64, VREDMINU_VS }, // 8561
  { PseudoVREDMINU_VS_M4_E64_MASK, VREDMINU_VS }, // 8562
  { PseudoVREDMINU_VS_M4_E8, VREDMINU_VS }, // 8563
  { PseudoVREDMINU_VS_M4_E8_MASK, VREDMINU_VS }, // 8564
  { PseudoVREDMINU_VS_M8_E16, VREDMINU_VS }, // 8565
  { PseudoVREDMINU_VS_M8_E16_MASK, VREDMINU_VS }, // 8566
  { PseudoVREDMINU_VS_M8_E32, VREDMINU_VS }, // 8567
  { PseudoVREDMINU_VS_M8_E32_MASK, VREDMINU_VS }, // 8568
  { PseudoVREDMINU_VS_M8_E64, VREDMINU_VS }, // 8569
  { PseudoVREDMINU_VS_M8_E64_MASK, VREDMINU_VS }, // 8570
  { PseudoVREDMINU_VS_M8_E8, VREDMINU_VS }, // 8571
  { PseudoVREDMINU_VS_M8_E8_MASK, VREDMINU_VS }, // 8572
  { PseudoVREDMINU_VS_MF2_E16, VREDMINU_VS }, // 8573
  { PseudoVREDMINU_VS_MF2_E16_MASK, VREDMINU_VS }, // 8574
  { PseudoVREDMINU_VS_MF2_E32, VREDMINU_VS }, // 8575
  { PseudoVREDMINU_VS_MF2_E32_MASK, VREDMINU_VS }, // 8576
  { PseudoVREDMINU_VS_MF2_E8, VREDMINU_VS }, // 8577
  { PseudoVREDMINU_VS_MF2_E8_MASK, VREDMINU_VS }, // 8578
  { PseudoVREDMINU_VS_MF4_E16, VREDMINU_VS }, // 8579
  { PseudoVREDMINU_VS_MF4_E16_MASK, VREDMINU_VS }, // 8580
  { PseudoVREDMINU_VS_MF4_E8, VREDMINU_VS }, // 8581
  { PseudoVREDMINU_VS_MF4_E8_MASK, VREDMINU_VS }, // 8582
  { PseudoVREDMINU_VS_MF8_E8, VREDMINU_VS }, // 8583
  { PseudoVREDMINU_VS_MF8_E8_MASK, VREDMINU_VS }, // 8584
  { PseudoVREDMIN_VS_M1_E16, VREDMIN_VS }, // 8585
  { PseudoVREDMIN_VS_M1_E16_MASK, VREDMIN_VS }, // 8586
  { PseudoVREDMIN_VS_M1_E32, VREDMIN_VS }, // 8587
  { PseudoVREDMIN_VS_M1_E32_MASK, VREDMIN_VS }, // 8588
  { PseudoVREDMIN_VS_M1_E64, VREDMIN_VS }, // 8589
  { PseudoVREDMIN_VS_M1_E64_MASK, VREDMIN_VS }, // 8590
  { PseudoVREDMIN_VS_M1_E8, VREDMIN_VS }, // 8591
  { PseudoVREDMIN_VS_M1_E8_MASK, VREDMIN_VS }, // 8592
  { PseudoVREDMIN_VS_M2_E16, VREDMIN_VS }, // 8593
  { PseudoVREDMIN_VS_M2_E16_MASK, VREDMIN_VS }, // 8594
  { PseudoVREDMIN_VS_M2_E32, VREDMIN_VS }, // 8595
  { PseudoVREDMIN_VS_M2_E32_MASK, VREDMIN_VS }, // 8596
  { PseudoVREDMIN_VS_M2_E64, VREDMIN_VS }, // 8597
  { PseudoVREDMIN_VS_M2_E64_MASK, VREDMIN_VS }, // 8598
  { PseudoVREDMIN_VS_M2_E8, VREDMIN_VS }, // 8599
  { PseudoVREDMIN_VS_M2_E8_MASK, VREDMIN_VS }, // 8600
  { PseudoVREDMIN_VS_M4_E16, VREDMIN_VS }, // 8601
  { PseudoVREDMIN_VS_M4_E16_MASK, VREDMIN_VS }, // 8602
  { PseudoVREDMIN_VS_M4_E32, VREDMIN_VS }, // 8603
  { PseudoVREDMIN_VS_M4_E32_MASK, VREDMIN_VS }, // 8604
  { PseudoVREDMIN_VS_M4_E64, VREDMIN_VS }, // 8605
  { PseudoVREDMIN_VS_M4_E64_MASK, VREDMIN_VS }, // 8606
  { PseudoVREDMIN_VS_M4_E8, VREDMIN_VS }, // 8607
  { PseudoVREDMIN_VS_M4_E8_MASK, VREDMIN_VS }, // 8608
  { PseudoVREDMIN_VS_M8_E16, VREDMIN_VS }, // 8609
  { PseudoVREDMIN_VS_M8_E16_MASK, VREDMIN_VS }, // 8610
  { PseudoVREDMIN_VS_M8_E32, VREDMIN_VS }, // 8611
  { PseudoVREDMIN_VS_M8_E32_MASK, VREDMIN_VS }, // 8612
  { PseudoVREDMIN_VS_M8_E64, VREDMIN_VS }, // 8613
  { PseudoVREDMIN_VS_M8_E64_MASK, VREDMIN_VS }, // 8614
  { PseudoVREDMIN_VS_M8_E8, VREDMIN_VS }, // 8615
  { PseudoVREDMIN_VS_M8_E8_MASK, VREDMIN_VS }, // 8616
  { PseudoVREDMIN_VS_MF2_E16, VREDMIN_VS }, // 8617
  { PseudoVREDMIN_VS_MF2_E16_MASK, VREDMIN_VS }, // 8618
  { PseudoVREDMIN_VS_MF2_E32, VREDMIN_VS }, // 8619
  { PseudoVREDMIN_VS_MF2_E32_MASK, VREDMIN_VS }, // 8620
  { PseudoVREDMIN_VS_MF2_E8, VREDMIN_VS }, // 8621
  { PseudoVREDMIN_VS_MF2_E8_MASK, VREDMIN_VS }, // 8622
  { PseudoVREDMIN_VS_MF4_E16, VREDMIN_VS }, // 8623
  { PseudoVREDMIN_VS_MF4_E16_MASK, VREDMIN_VS }, // 8624
  { PseudoVREDMIN_VS_MF4_E8, VREDMIN_VS }, // 8625
  { PseudoVREDMIN_VS_MF4_E8_MASK, VREDMIN_VS }, // 8626
  { PseudoVREDMIN_VS_MF8_E8, VREDMIN_VS }, // 8627
  { PseudoVREDMIN_VS_MF8_E8_MASK, VREDMIN_VS }, // 8628
  { PseudoVREDOR_VS_M1_E16, VREDOR_VS }, // 8629
  { PseudoVREDOR_VS_M1_E16_MASK, VREDOR_VS }, // 8630
  { PseudoVREDOR_VS_M1_E32, VREDOR_VS }, // 8631
  { PseudoVREDOR_VS_M1_E32_MASK, VREDOR_VS }, // 8632
  { PseudoVREDOR_VS_M1_E64, VREDOR_VS }, // 8633
  { PseudoVREDOR_VS_M1_E64_MASK, VREDOR_VS }, // 8634
  { PseudoVREDOR_VS_M1_E8, VREDOR_VS }, // 8635
  { PseudoVREDOR_VS_M1_E8_MASK, VREDOR_VS }, // 8636
  { PseudoVREDOR_VS_M2_E16, VREDOR_VS }, // 8637
  { PseudoVREDOR_VS_M2_E16_MASK, VREDOR_VS }, // 8638
  { PseudoVREDOR_VS_M2_E32, VREDOR_VS }, // 8639
  { PseudoVREDOR_VS_M2_E32_MASK, VREDOR_VS }, // 8640
  { PseudoVREDOR_VS_M2_E64, VREDOR_VS }, // 8641
  { PseudoVREDOR_VS_M2_E64_MASK, VREDOR_VS }, // 8642
  { PseudoVREDOR_VS_M2_E8, VREDOR_VS }, // 8643
  { PseudoVREDOR_VS_M2_E8_MASK, VREDOR_VS }, // 8644
  { PseudoVREDOR_VS_M4_E16, VREDOR_VS }, // 8645
  { PseudoVREDOR_VS_M4_E16_MASK, VREDOR_VS }, // 8646
  { PseudoVREDOR_VS_M4_E32, VREDOR_VS }, // 8647
  { PseudoVREDOR_VS_M4_E32_MASK, VREDOR_VS }, // 8648
  { PseudoVREDOR_VS_M4_E64, VREDOR_VS }, // 8649
  { PseudoVREDOR_VS_M4_E64_MASK, VREDOR_VS }, // 8650
  { PseudoVREDOR_VS_M4_E8, VREDOR_VS }, // 8651
  { PseudoVREDOR_VS_M4_E8_MASK, VREDOR_VS }, // 8652
  { PseudoVREDOR_VS_M8_E16, VREDOR_VS }, // 8653
  { PseudoVREDOR_VS_M8_E16_MASK, VREDOR_VS }, // 8654
  { PseudoVREDOR_VS_M8_E32, VREDOR_VS }, // 8655
  { PseudoVREDOR_VS_M8_E32_MASK, VREDOR_VS }, // 8656
  { PseudoVREDOR_VS_M8_E64, VREDOR_VS }, // 8657
  { PseudoVREDOR_VS_M8_E64_MASK, VREDOR_VS }, // 8658
  { PseudoVREDOR_VS_M8_E8, VREDOR_VS }, // 8659
  { PseudoVREDOR_VS_M8_E8_MASK, VREDOR_VS }, // 8660
  { PseudoVREDOR_VS_MF2_E16, VREDOR_VS }, // 8661
  { PseudoVREDOR_VS_MF2_E16_MASK, VREDOR_VS }, // 8662
  { PseudoVREDOR_VS_MF2_E32, VREDOR_VS }, // 8663
  { PseudoVREDOR_VS_MF2_E32_MASK, VREDOR_VS }, // 8664
  { PseudoVREDOR_VS_MF2_E8, VREDOR_VS }, // 8665
  { PseudoVREDOR_VS_MF2_E8_MASK, VREDOR_VS }, // 8666
  { PseudoVREDOR_VS_MF4_E16, VREDOR_VS }, // 8667
  { PseudoVREDOR_VS_MF4_E16_MASK, VREDOR_VS }, // 8668
  { PseudoVREDOR_VS_MF4_E8, VREDOR_VS }, // 8669
  { PseudoVREDOR_VS_MF4_E8_MASK, VREDOR_VS }, // 8670
  { PseudoVREDOR_VS_MF8_E8, VREDOR_VS }, // 8671
  { PseudoVREDOR_VS_MF8_E8_MASK, VREDOR_VS }, // 8672
  { PseudoVREDSUM_VS_M1_E16, VREDSUM_VS }, // 8673
  { PseudoVREDSUM_VS_M1_E16_MASK, VREDSUM_VS }, // 8674
  { PseudoVREDSUM_VS_M1_E32, VREDSUM_VS }, // 8675
  { PseudoVREDSUM_VS_M1_E32_MASK, VREDSUM_VS }, // 8676
  { PseudoVREDSUM_VS_M1_E64, VREDSUM_VS }, // 8677
  { PseudoVREDSUM_VS_M1_E64_MASK, VREDSUM_VS }, // 8678
  { PseudoVREDSUM_VS_M1_E8, VREDSUM_VS }, // 8679
  { PseudoVREDSUM_VS_M1_E8_MASK, VREDSUM_VS }, // 8680
  { PseudoVREDSUM_VS_M2_E16, VREDSUM_VS }, // 8681
  { PseudoVREDSUM_VS_M2_E16_MASK, VREDSUM_VS }, // 8682
  { PseudoVREDSUM_VS_M2_E32, VREDSUM_VS }, // 8683
  { PseudoVREDSUM_VS_M2_E32_MASK, VREDSUM_VS }, // 8684
  { PseudoVREDSUM_VS_M2_E64, VREDSUM_VS }, // 8685
  { PseudoVREDSUM_VS_M2_E64_MASK, VREDSUM_VS }, // 8686
  { PseudoVREDSUM_VS_M2_E8, VREDSUM_VS }, // 8687
  { PseudoVREDSUM_VS_M2_E8_MASK, VREDSUM_VS }, // 8688
  { PseudoVREDSUM_VS_M4_E16, VREDSUM_VS }, // 8689
  { PseudoVREDSUM_VS_M4_E16_MASK, VREDSUM_VS }, // 8690
  { PseudoVREDSUM_VS_M4_E32, VREDSUM_VS }, // 8691
  { PseudoVREDSUM_VS_M4_E32_MASK, VREDSUM_VS }, // 8692
  { PseudoVREDSUM_VS_M4_E64, VREDSUM_VS }, // 8693
  { PseudoVREDSUM_VS_M4_E64_MASK, VREDSUM_VS }, // 8694
  { PseudoVREDSUM_VS_M4_E8, VREDSUM_VS }, // 8695
  { PseudoVREDSUM_VS_M4_E8_MASK, VREDSUM_VS }, // 8696
  { PseudoVREDSUM_VS_M8_E16, VREDSUM_VS }, // 8697
  { PseudoVREDSUM_VS_M8_E16_MASK, VREDSUM_VS }, // 8698
  { PseudoVREDSUM_VS_M8_E32, VREDSUM_VS }, // 8699
  { PseudoVREDSUM_VS_M8_E32_MASK, VREDSUM_VS }, // 8700
  { PseudoVREDSUM_VS_M8_E64, VREDSUM_VS }, // 8701
  { PseudoVREDSUM_VS_M8_E64_MASK, VREDSUM_VS }, // 8702
  { PseudoVREDSUM_VS_M8_E8, VREDSUM_VS }, // 8703
  { PseudoVREDSUM_VS_M8_E8_MASK, VREDSUM_VS }, // 8704
  { PseudoVREDSUM_VS_MF2_E16, VREDSUM_VS }, // 8705
  { PseudoVREDSUM_VS_MF2_E16_MASK, VREDSUM_VS }, // 8706
  { PseudoVREDSUM_VS_MF2_E32, VREDSUM_VS }, // 8707
  { PseudoVREDSUM_VS_MF2_E32_MASK, VREDSUM_VS }, // 8708
  { PseudoVREDSUM_VS_MF2_E8, VREDSUM_VS }, // 8709
  { PseudoVREDSUM_VS_MF2_E8_MASK, VREDSUM_VS }, // 8710
  { PseudoVREDSUM_VS_MF4_E16, VREDSUM_VS }, // 8711
  { PseudoVREDSUM_VS_MF4_E16_MASK, VREDSUM_VS }, // 8712
  { PseudoVREDSUM_VS_MF4_E8, VREDSUM_VS }, // 8713
  { PseudoVREDSUM_VS_MF4_E8_MASK, VREDSUM_VS }, // 8714
  { PseudoVREDSUM_VS_MF8_E8, VREDSUM_VS }, // 8715
  { PseudoVREDSUM_VS_MF8_E8_MASK, VREDSUM_VS }, // 8716
  { PseudoVREDXOR_VS_M1_E16, VREDXOR_VS }, // 8717
  { PseudoVREDXOR_VS_M1_E16_MASK, VREDXOR_VS }, // 8718
  { PseudoVREDXOR_VS_M1_E32, VREDXOR_VS }, // 8719
  { PseudoVREDXOR_VS_M1_E32_MASK, VREDXOR_VS }, // 8720
  { PseudoVREDXOR_VS_M1_E64, VREDXOR_VS }, // 8721
  { PseudoVREDXOR_VS_M1_E64_MASK, VREDXOR_VS }, // 8722
  { PseudoVREDXOR_VS_M1_E8, VREDXOR_VS }, // 8723
  { PseudoVREDXOR_VS_M1_E8_MASK, VREDXOR_VS }, // 8724
  { PseudoVREDXOR_VS_M2_E16, VREDXOR_VS }, // 8725
  { PseudoVREDXOR_VS_M2_E16_MASK, VREDXOR_VS }, // 8726
  { PseudoVREDXOR_VS_M2_E32, VREDXOR_VS }, // 8727
  { PseudoVREDXOR_VS_M2_E32_MASK, VREDXOR_VS }, // 8728
  { PseudoVREDXOR_VS_M2_E64, VREDXOR_VS }, // 8729
  { PseudoVREDXOR_VS_M2_E64_MASK, VREDXOR_VS }, // 8730
  { PseudoVREDXOR_VS_M2_E8, VREDXOR_VS }, // 8731
  { PseudoVREDXOR_VS_M2_E8_MASK, VREDXOR_VS }, // 8732
  { PseudoVREDXOR_VS_M4_E16, VREDXOR_VS }, // 8733
  { PseudoVREDXOR_VS_M4_E16_MASK, VREDXOR_VS }, // 8734
  { PseudoVREDXOR_VS_M4_E32, VREDXOR_VS }, // 8735
  { PseudoVREDXOR_VS_M4_E32_MASK, VREDXOR_VS }, // 8736
  { PseudoVREDXOR_VS_M4_E64, VREDXOR_VS }, // 8737
  { PseudoVREDXOR_VS_M4_E64_MASK, VREDXOR_VS }, // 8738
  { PseudoVREDXOR_VS_M4_E8, VREDXOR_VS }, // 8739
  { PseudoVREDXOR_VS_M4_E8_MASK, VREDXOR_VS }, // 8740
  { PseudoVREDXOR_VS_M8_E16, VREDXOR_VS }, // 8741
  { PseudoVREDXOR_VS_M8_E16_MASK, VREDXOR_VS }, // 8742
  { PseudoVREDXOR_VS_M8_E32, VREDXOR_VS }, // 8743
  { PseudoVREDXOR_VS_M8_E32_MASK, VREDXOR_VS }, // 8744
  { PseudoVREDXOR_VS_M8_E64, VREDXOR_VS }, // 8745
  { PseudoVREDXOR_VS_M8_E64_MASK, VREDXOR_VS }, // 8746
  { PseudoVREDXOR_VS_M8_E8, VREDXOR_VS }, // 8747
  { PseudoVREDXOR_VS_M8_E8_MASK, VREDXOR_VS }, // 8748
  { PseudoVREDXOR_VS_MF2_E16, VREDXOR_VS }, // 8749
  { PseudoVREDXOR_VS_MF2_E16_MASK, VREDXOR_VS }, // 8750
  { PseudoVREDXOR_VS_MF2_E32, VREDXOR_VS }, // 8751
  { PseudoVREDXOR_VS_MF2_E32_MASK, VREDXOR_VS }, // 8752
  { PseudoVREDXOR_VS_MF2_E8, VREDXOR_VS }, // 8753
  { PseudoVREDXOR_VS_MF2_E8_MASK, VREDXOR_VS }, // 8754
  { PseudoVREDXOR_VS_MF4_E16, VREDXOR_VS }, // 8755
  { PseudoVREDXOR_VS_MF4_E16_MASK, VREDXOR_VS }, // 8756
  { PseudoVREDXOR_VS_MF4_E8, VREDXOR_VS }, // 8757
  { PseudoVREDXOR_VS_MF4_E8_MASK, VREDXOR_VS }, // 8758
  { PseudoVREDXOR_VS_MF8_E8, VREDXOR_VS }, // 8759
  { PseudoVREDXOR_VS_MF8_E8_MASK, VREDXOR_VS }, // 8760
  { PseudoVREMU_VV_M1_E16, VREMU_VV }, // 8761
  { PseudoVREMU_VV_M1_E16_MASK, VREMU_VV }, // 8762
  { PseudoVREMU_VV_M1_E16_TU, VREMU_VV }, // 8763
  { PseudoVREMU_VV_M1_E32, VREMU_VV }, // 8764
  { PseudoVREMU_VV_M1_E32_MASK, VREMU_VV }, // 8765
  { PseudoVREMU_VV_M1_E32_TU, VREMU_VV }, // 8766
  { PseudoVREMU_VV_M1_E64, VREMU_VV }, // 8767
  { PseudoVREMU_VV_M1_E64_MASK, VREMU_VV }, // 8768
  { PseudoVREMU_VV_M1_E64_TU, VREMU_VV }, // 8769
  { PseudoVREMU_VV_M1_E8, VREMU_VV }, // 8770
  { PseudoVREMU_VV_M1_E8_MASK, VREMU_VV }, // 8771
  { PseudoVREMU_VV_M1_E8_TU, VREMU_VV }, // 8772
  { PseudoVREMU_VV_M2_E16, VREMU_VV }, // 8773
  { PseudoVREMU_VV_M2_E16_MASK, VREMU_VV }, // 8774
  { PseudoVREMU_VV_M2_E16_TU, VREMU_VV }, // 8775
  { PseudoVREMU_VV_M2_E32, VREMU_VV }, // 8776
  { PseudoVREMU_VV_M2_E32_MASK, VREMU_VV }, // 8777
  { PseudoVREMU_VV_M2_E32_TU, VREMU_VV }, // 8778
  { PseudoVREMU_VV_M2_E64, VREMU_VV }, // 8779
  { PseudoVREMU_VV_M2_E64_MASK, VREMU_VV }, // 8780
  { PseudoVREMU_VV_M2_E64_TU, VREMU_VV }, // 8781
  { PseudoVREMU_VV_M2_E8, VREMU_VV }, // 8782
  { PseudoVREMU_VV_M2_E8_MASK, VREMU_VV }, // 8783
  { PseudoVREMU_VV_M2_E8_TU, VREMU_VV }, // 8784
  { PseudoVREMU_VV_M4_E16, VREMU_VV }, // 8785
  { PseudoVREMU_VV_M4_E16_MASK, VREMU_VV }, // 8786
  { PseudoVREMU_VV_M4_E16_TU, VREMU_VV }, // 8787
  { PseudoVREMU_VV_M4_E32, VREMU_VV }, // 8788
  { PseudoVREMU_VV_M4_E32_MASK, VREMU_VV }, // 8789
  { PseudoVREMU_VV_M4_E32_TU, VREMU_VV }, // 8790
  { PseudoVREMU_VV_M4_E64, VREMU_VV }, // 8791
  { PseudoVREMU_VV_M4_E64_MASK, VREMU_VV }, // 8792
  { PseudoVREMU_VV_M4_E64_TU, VREMU_VV }, // 8793
  { PseudoVREMU_VV_M4_E8, VREMU_VV }, // 8794
  { PseudoVREMU_VV_M4_E8_MASK, VREMU_VV }, // 8795
  { PseudoVREMU_VV_M4_E8_TU, VREMU_VV }, // 8796
  { PseudoVREMU_VV_M8_E16, VREMU_VV }, // 8797
  { PseudoVREMU_VV_M8_E16_MASK, VREMU_VV }, // 8798
  { PseudoVREMU_VV_M8_E16_TU, VREMU_VV }, // 8799
  { PseudoVREMU_VV_M8_E32, VREMU_VV }, // 8800
  { PseudoVREMU_VV_M8_E32_MASK, VREMU_VV }, // 8801
  { PseudoVREMU_VV_M8_E32_TU, VREMU_VV }, // 8802
  { PseudoVREMU_VV_M8_E64, VREMU_VV }, // 8803
  { PseudoVREMU_VV_M8_E64_MASK, VREMU_VV }, // 8804
  { PseudoVREMU_VV_M8_E64_TU, VREMU_VV }, // 8805
  { PseudoVREMU_VV_M8_E8, VREMU_VV }, // 8806
  { PseudoVREMU_VV_M8_E8_MASK, VREMU_VV }, // 8807
  { PseudoVREMU_VV_M8_E8_TU, VREMU_VV }, // 8808
  { PseudoVREMU_VV_MF2_E16, VREMU_VV }, // 8809
  { PseudoVREMU_VV_MF2_E16_MASK, VREMU_VV }, // 8810
  { PseudoVREMU_VV_MF2_E16_TU, VREMU_VV }, // 8811
  { PseudoVREMU_VV_MF2_E32, VREMU_VV }, // 8812
  { PseudoVREMU_VV_MF2_E32_MASK, VREMU_VV }, // 8813
  { PseudoVREMU_VV_MF2_E32_TU, VREMU_VV }, // 8814
  { PseudoVREMU_VV_MF2_E8, VREMU_VV }, // 8815
  { PseudoVREMU_VV_MF2_E8_MASK, VREMU_VV }, // 8816
  { PseudoVREMU_VV_MF2_E8_TU, VREMU_VV }, // 8817
  { PseudoVREMU_VV_MF4_E16, VREMU_VV }, // 8818
  { PseudoVREMU_VV_MF4_E16_MASK, VREMU_VV }, // 8819
  { PseudoVREMU_VV_MF4_E16_TU, VREMU_VV }, // 8820
  { PseudoVREMU_VV_MF4_E8, VREMU_VV }, // 8821
  { PseudoVREMU_VV_MF4_E8_MASK, VREMU_VV }, // 8822
  { PseudoVREMU_VV_MF4_E8_TU, VREMU_VV }, // 8823
  { PseudoVREMU_VV_MF8_E8, VREMU_VV }, // 8824
  { PseudoVREMU_VV_MF8_E8_MASK, VREMU_VV }, // 8825
  { PseudoVREMU_VV_MF8_E8_TU, VREMU_VV }, // 8826
  { PseudoVREMU_VX_M1_E16, VREMU_VX }, // 8827
  { PseudoVREMU_VX_M1_E16_MASK, VREMU_VX }, // 8828
  { PseudoVREMU_VX_M1_E16_TU, VREMU_VX }, // 8829
  { PseudoVREMU_VX_M1_E32, VREMU_VX }, // 8830
  { PseudoVREMU_VX_M1_E32_MASK, VREMU_VX }, // 8831
  { PseudoVREMU_VX_M1_E32_TU, VREMU_VX }, // 8832
  { PseudoVREMU_VX_M1_E64, VREMU_VX }, // 8833
  { PseudoVREMU_VX_M1_E64_MASK, VREMU_VX }, // 8834
  { PseudoVREMU_VX_M1_E64_TU, VREMU_VX }, // 8835
  { PseudoVREMU_VX_M1_E8, VREMU_VX }, // 8836
  { PseudoVREMU_VX_M1_E8_MASK, VREMU_VX }, // 8837
  { PseudoVREMU_VX_M1_E8_TU, VREMU_VX }, // 8838
  { PseudoVREMU_VX_M2_E16, VREMU_VX }, // 8839
  { PseudoVREMU_VX_M2_E16_MASK, VREMU_VX }, // 8840
  { PseudoVREMU_VX_M2_E16_TU, VREMU_VX }, // 8841
  { PseudoVREMU_VX_M2_E32, VREMU_VX }, // 8842
  { PseudoVREMU_VX_M2_E32_MASK, VREMU_VX }, // 8843
  { PseudoVREMU_VX_M2_E32_TU, VREMU_VX }, // 8844
  { PseudoVREMU_VX_M2_E64, VREMU_VX }, // 8845
  { PseudoVREMU_VX_M2_E64_MASK, VREMU_VX }, // 8846
  { PseudoVREMU_VX_M2_E64_TU, VREMU_VX }, // 8847
  { PseudoVREMU_VX_M2_E8, VREMU_VX }, // 8848
  { PseudoVREMU_VX_M2_E8_MASK, VREMU_VX }, // 8849
  { PseudoVREMU_VX_M2_E8_TU, VREMU_VX }, // 8850
  { PseudoVREMU_VX_M4_E16, VREMU_VX }, // 8851
  { PseudoVREMU_VX_M4_E16_MASK, VREMU_VX }, // 8852
  { PseudoVREMU_VX_M4_E16_TU, VREMU_VX }, // 8853
  { PseudoVREMU_VX_M4_E32, VREMU_VX }, // 8854
  { PseudoVREMU_VX_M4_E32_MASK, VREMU_VX }, // 8855
  { PseudoVREMU_VX_M4_E32_TU, VREMU_VX }, // 8856
  { PseudoVREMU_VX_M4_E64, VREMU_VX }, // 8857
  { PseudoVREMU_VX_M4_E64_MASK, VREMU_VX }, // 8858
  { PseudoVREMU_VX_M4_E64_TU, VREMU_VX }, // 8859
  { PseudoVREMU_VX_M4_E8, VREMU_VX }, // 8860
  { PseudoVREMU_VX_M4_E8_MASK, VREMU_VX }, // 8861
  { PseudoVREMU_VX_M4_E8_TU, VREMU_VX }, // 8862
  { PseudoVREMU_VX_M8_E16, VREMU_VX }, // 8863
  { PseudoVREMU_VX_M8_E16_MASK, VREMU_VX }, // 8864
  { PseudoVREMU_VX_M8_E16_TU, VREMU_VX }, // 8865
  { PseudoVREMU_VX_M8_E32, VREMU_VX }, // 8866
  { PseudoVREMU_VX_M8_E32_MASK, VREMU_VX }, // 8867
  { PseudoVREMU_VX_M8_E32_TU, VREMU_VX }, // 8868
  { PseudoVREMU_VX_M8_E64, VREMU_VX }, // 8869
  { PseudoVREMU_VX_M8_E64_MASK, VREMU_VX }, // 8870
  { PseudoVREMU_VX_M8_E64_TU, VREMU_VX }, // 8871
  { PseudoVREMU_VX_M8_E8, VREMU_VX }, // 8872
  { PseudoVREMU_VX_M8_E8_MASK, VREMU_VX }, // 8873
  { PseudoVREMU_VX_M8_E8_TU, VREMU_VX }, // 8874
  { PseudoVREMU_VX_MF2_E16, VREMU_VX }, // 8875
  { PseudoVREMU_VX_MF2_E16_MASK, VREMU_VX }, // 8876
  { PseudoVREMU_VX_MF2_E16_TU, VREMU_VX }, // 8877
  { PseudoVREMU_VX_MF2_E32, VREMU_VX }, // 8878
  { PseudoVREMU_VX_MF2_E32_MASK, VREMU_VX }, // 8879
  { PseudoVREMU_VX_MF2_E32_TU, VREMU_VX }, // 8880
  { PseudoVREMU_VX_MF2_E8, VREMU_VX }, // 8881
  { PseudoVREMU_VX_MF2_E8_MASK, VREMU_VX }, // 8882
  { PseudoVREMU_VX_MF2_E8_TU, VREMU_VX }, // 8883
  { PseudoVREMU_VX_MF4_E16, VREMU_VX }, // 8884
  { PseudoVREMU_VX_MF4_E16_MASK, VREMU_VX }, // 8885
  { PseudoVREMU_VX_MF4_E16_TU, VREMU_VX }, // 8886
  { PseudoVREMU_VX_MF4_E8, VREMU_VX }, // 8887
  { PseudoVREMU_VX_MF4_E8_MASK, VREMU_VX }, // 8888
  { PseudoVREMU_VX_MF4_E8_TU, VREMU_VX }, // 8889
  { PseudoVREMU_VX_MF8_E8, VREMU_VX }, // 8890
  { PseudoVREMU_VX_MF8_E8_MASK, VREMU_VX }, // 8891
  { PseudoVREMU_VX_MF8_E8_TU, VREMU_VX }, // 8892
  { PseudoVREM_VV_M1_E16, VREM_VV }, // 8893
  { PseudoVREM_VV_M1_E16_MASK, VREM_VV }, // 8894
  { PseudoVREM_VV_M1_E16_TU, VREM_VV }, // 8895
  { PseudoVREM_VV_M1_E32, VREM_VV }, // 8896
  { PseudoVREM_VV_M1_E32_MASK, VREM_VV }, // 8897
  { PseudoVREM_VV_M1_E32_TU, VREM_VV }, // 8898
  { PseudoVREM_VV_M1_E64, VREM_VV }, // 8899
  { PseudoVREM_VV_M1_E64_MASK, VREM_VV }, // 8900
  { PseudoVREM_VV_M1_E64_TU, VREM_VV }, // 8901
  { PseudoVREM_VV_M1_E8, VREM_VV }, // 8902
  { PseudoVREM_VV_M1_E8_MASK, VREM_VV }, // 8903
  { PseudoVREM_VV_M1_E8_TU, VREM_VV }, // 8904
  { PseudoVREM_VV_M2_E16, VREM_VV }, // 8905
  { PseudoVREM_VV_M2_E16_MASK, VREM_VV }, // 8906
  { PseudoVREM_VV_M2_E16_TU, VREM_VV }, // 8907
  { PseudoVREM_VV_M2_E32, VREM_VV }, // 8908
  { PseudoVREM_VV_M2_E32_MASK, VREM_VV }, // 8909
  { PseudoVREM_VV_M2_E32_TU, VREM_VV }, // 8910
  { PseudoVREM_VV_M2_E64, VREM_VV }, // 8911
  { PseudoVREM_VV_M2_E64_MASK, VREM_VV }, // 8912
  { PseudoVREM_VV_M2_E64_TU, VREM_VV }, // 8913
  { PseudoVREM_VV_M2_E8, VREM_VV }, // 8914
  { PseudoVREM_VV_M2_E8_MASK, VREM_VV }, // 8915
  { PseudoVREM_VV_M2_E8_TU, VREM_VV }, // 8916
  { PseudoVREM_VV_M4_E16, VREM_VV }, // 8917
  { PseudoVREM_VV_M4_E16_MASK, VREM_VV }, // 8918
  { PseudoVREM_VV_M4_E16_TU, VREM_VV }, // 8919
  { PseudoVREM_VV_M4_E32, VREM_VV }, // 8920
  { PseudoVREM_VV_M4_E32_MASK, VREM_VV }, // 8921
  { PseudoVREM_VV_M4_E32_TU, VREM_VV }, // 8922
  { PseudoVREM_VV_M4_E64, VREM_VV }, // 8923
  { PseudoVREM_VV_M4_E64_MASK, VREM_VV }, // 8924
  { PseudoVREM_VV_M4_E64_TU, VREM_VV }, // 8925
  { PseudoVREM_VV_M4_E8, VREM_VV }, // 8926
  { PseudoVREM_VV_M4_E8_MASK, VREM_VV }, // 8927
  { PseudoVREM_VV_M4_E8_TU, VREM_VV }, // 8928
  { PseudoVREM_VV_M8_E16, VREM_VV }, // 8929
  { PseudoVREM_VV_M8_E16_MASK, VREM_VV }, // 8930
  { PseudoVREM_VV_M8_E16_TU, VREM_VV }, // 8931
  { PseudoVREM_VV_M8_E32, VREM_VV }, // 8932
  { PseudoVREM_VV_M8_E32_MASK, VREM_VV }, // 8933
  { PseudoVREM_VV_M8_E32_TU, VREM_VV }, // 8934
  { PseudoVREM_VV_M8_E64, VREM_VV }, // 8935
  { PseudoVREM_VV_M8_E64_MASK, VREM_VV }, // 8936
  { PseudoVREM_VV_M8_E64_TU, VREM_VV }, // 8937
  { PseudoVREM_VV_M8_E8, VREM_VV }, // 8938
  { PseudoVREM_VV_M8_E8_MASK, VREM_VV }, // 8939
  { PseudoVREM_VV_M8_E8_TU, VREM_VV }, // 8940
  { PseudoVREM_VV_MF2_E16, VREM_VV }, // 8941
  { PseudoVREM_VV_MF2_E16_MASK, VREM_VV }, // 8942
  { PseudoVREM_VV_MF2_E16_TU, VREM_VV }, // 8943
  { PseudoVREM_VV_MF2_E32, VREM_VV }, // 8944
  { PseudoVREM_VV_MF2_E32_MASK, VREM_VV }, // 8945
  { PseudoVREM_VV_MF2_E32_TU, VREM_VV }, // 8946
  { PseudoVREM_VV_MF2_E8, VREM_VV }, // 8947
  { PseudoVREM_VV_MF2_E8_MASK, VREM_VV }, // 8948
  { PseudoVREM_VV_MF2_E8_TU, VREM_VV }, // 8949
  { PseudoVREM_VV_MF4_E16, VREM_VV }, // 8950
  { PseudoVREM_VV_MF4_E16_MASK, VREM_VV }, // 8951
  { PseudoVREM_VV_MF4_E16_TU, VREM_VV }, // 8952
  { PseudoVREM_VV_MF4_E8, VREM_VV }, // 8953
  { PseudoVREM_VV_MF4_E8_MASK, VREM_VV }, // 8954
  { PseudoVREM_VV_MF4_E8_TU, VREM_VV }, // 8955
  { PseudoVREM_VV_MF8_E8, VREM_VV }, // 8956
  { PseudoVREM_VV_MF8_E8_MASK, VREM_VV }, // 8957
  { PseudoVREM_VV_MF8_E8_TU, VREM_VV }, // 8958
  { PseudoVREM_VX_M1_E16, VREM_VX }, // 8959
  { PseudoVREM_VX_M1_E16_MASK, VREM_VX }, // 8960
  { PseudoVREM_VX_M1_E16_TU, VREM_VX }, // 8961
  { PseudoVREM_VX_M1_E32, VREM_VX }, // 8962
  { PseudoVREM_VX_M1_E32_MASK, VREM_VX }, // 8963
  { PseudoVREM_VX_M1_E32_TU, VREM_VX }, // 8964
  { PseudoVREM_VX_M1_E64, VREM_VX }, // 8965
  { PseudoVREM_VX_M1_E64_MASK, VREM_VX }, // 8966
  { PseudoVREM_VX_M1_E64_TU, VREM_VX }, // 8967
  { PseudoVREM_VX_M1_E8, VREM_VX }, // 8968
  { PseudoVREM_VX_M1_E8_MASK, VREM_VX }, // 8969
  { PseudoVREM_VX_M1_E8_TU, VREM_VX }, // 8970
  { PseudoVREM_VX_M2_E16, VREM_VX }, // 8971
  { PseudoVREM_VX_M2_E16_MASK, VREM_VX }, // 8972
  { PseudoVREM_VX_M2_E16_TU, VREM_VX }, // 8973
  { PseudoVREM_VX_M2_E32, VREM_VX }, // 8974
  { PseudoVREM_VX_M2_E32_MASK, VREM_VX }, // 8975
  { PseudoVREM_VX_M2_E32_TU, VREM_VX }, // 8976
  { PseudoVREM_VX_M2_E64, VREM_VX }, // 8977
  { PseudoVREM_VX_M2_E64_MASK, VREM_VX }, // 8978
  { PseudoVREM_VX_M2_E64_TU, VREM_VX }, // 8979
  { PseudoVREM_VX_M2_E8, VREM_VX }, // 8980
  { PseudoVREM_VX_M2_E8_MASK, VREM_VX }, // 8981
  { PseudoVREM_VX_M2_E8_TU, VREM_VX }, // 8982
  { PseudoVREM_VX_M4_E16, VREM_VX }, // 8983
  { PseudoVREM_VX_M4_E16_MASK, VREM_VX }, // 8984
  { PseudoVREM_VX_M4_E16_TU, VREM_VX }, // 8985
  { PseudoVREM_VX_M4_E32, VREM_VX }, // 8986
  { PseudoVREM_VX_M4_E32_MASK, VREM_VX }, // 8987
  { PseudoVREM_VX_M4_E32_TU, VREM_VX }, // 8988
  { PseudoVREM_VX_M4_E64, VREM_VX }, // 8989
  { PseudoVREM_VX_M4_E64_MASK, VREM_VX }, // 8990
  { PseudoVREM_VX_M4_E64_TU, VREM_VX }, // 8991
  { PseudoVREM_VX_M4_E8, VREM_VX }, // 8992
  { PseudoVREM_VX_M4_E8_MASK, VREM_VX }, // 8993
  { PseudoVREM_VX_M4_E8_TU, VREM_VX }, // 8994
  { PseudoVREM_VX_M8_E16, VREM_VX }, // 8995
  { PseudoVREM_VX_M8_E16_MASK, VREM_VX }, // 8996
  { PseudoVREM_VX_M8_E16_TU, VREM_VX }, // 8997
  { PseudoVREM_VX_M8_E32, VREM_VX }, // 8998
  { PseudoVREM_VX_M8_E32_MASK, VREM_VX }, // 8999
  { PseudoVREM_VX_M8_E32_TU, VREM_VX }, // 9000
  { PseudoVREM_VX_M8_E64, VREM_VX }, // 9001
  { PseudoVREM_VX_M8_E64_MASK, VREM_VX }, // 9002
  { PseudoVREM_VX_M8_E64_TU, VREM_VX }, // 9003
  { PseudoVREM_VX_M8_E8, VREM_VX }, // 9004
  { PseudoVREM_VX_M8_E8_MASK, VREM_VX }, // 9005
  { PseudoVREM_VX_M8_E8_TU, VREM_VX }, // 9006
  { PseudoVREM_VX_MF2_E16, VREM_VX }, // 9007
  { PseudoVREM_VX_MF2_E16_MASK, VREM_VX }, // 9008
  { PseudoVREM_VX_MF2_E16_TU, VREM_VX }, // 9009
  { PseudoVREM_VX_MF2_E32, VREM_VX }, // 9010
  { PseudoVREM_VX_MF2_E32_MASK, VREM_VX }, // 9011
  { PseudoVREM_VX_MF2_E32_TU, VREM_VX }, // 9012
  { PseudoVREM_VX_MF2_E8, VREM_VX }, // 9013
  { PseudoVREM_VX_MF2_E8_MASK, VREM_VX }, // 9014
  { PseudoVREM_VX_MF2_E8_TU, VREM_VX }, // 9015
  { PseudoVREM_VX_MF4_E16, VREM_VX }, // 9016
  { PseudoVREM_VX_MF4_E16_MASK, VREM_VX }, // 9017
  { PseudoVREM_VX_MF4_E16_TU, VREM_VX }, // 9018
  { PseudoVREM_VX_MF4_E8, VREM_VX }, // 9019
  { PseudoVREM_VX_MF4_E8_MASK, VREM_VX }, // 9020
  { PseudoVREM_VX_MF4_E8_TU, VREM_VX }, // 9021
  { PseudoVREM_VX_MF8_E8, VREM_VX }, // 9022
  { PseudoVREM_VX_MF8_E8_MASK, VREM_VX }, // 9023
  { PseudoVREM_VX_MF8_E8_TU, VREM_VX }, // 9024
  { PseudoVRGATHEREI16_VV_M1_E16_M1, VRGATHEREI16_VV }, // 9025
  { PseudoVRGATHEREI16_VV_M1_E16_M1_MASK, VRGATHEREI16_VV }, // 9026
  { PseudoVRGATHEREI16_VV_M1_E16_M1_TU, VRGATHEREI16_VV }, // 9027
  { PseudoVRGATHEREI16_VV_M1_E16_M2, VRGATHEREI16_VV }, // 9028
  { PseudoVRGATHEREI16_VV_M1_E16_M2_MASK, VRGATHEREI16_VV }, // 9029
  { PseudoVRGATHEREI16_VV_M1_E16_M2_TU, VRGATHEREI16_VV }, // 9030
  { PseudoVRGATHEREI16_VV_M1_E16_MF2, VRGATHEREI16_VV }, // 9031
  { PseudoVRGATHEREI16_VV_M1_E16_MF2_MASK, VRGATHEREI16_VV }, // 9032
  { PseudoVRGATHEREI16_VV_M1_E16_MF2_TU, VRGATHEREI16_VV }, // 9033
  { PseudoVRGATHEREI16_VV_M1_E16_MF4, VRGATHEREI16_VV }, // 9034
  { PseudoVRGATHEREI16_VV_M1_E16_MF4_MASK, VRGATHEREI16_VV }, // 9035
  { PseudoVRGATHEREI16_VV_M1_E16_MF4_TU, VRGATHEREI16_VV }, // 9036
  { PseudoVRGATHEREI16_VV_M1_E32_M1, VRGATHEREI16_VV }, // 9037
  { PseudoVRGATHEREI16_VV_M1_E32_M1_MASK, VRGATHEREI16_VV }, // 9038
  { PseudoVRGATHEREI16_VV_M1_E32_M1_TU, VRGATHEREI16_VV }, // 9039
  { PseudoVRGATHEREI16_VV_M1_E32_M2, VRGATHEREI16_VV }, // 9040
  { PseudoVRGATHEREI16_VV_M1_E32_M2_MASK, VRGATHEREI16_VV }, // 9041
  { PseudoVRGATHEREI16_VV_M1_E32_M2_TU, VRGATHEREI16_VV }, // 9042
  { PseudoVRGATHEREI16_VV_M1_E32_MF2, VRGATHEREI16_VV }, // 9043
  { PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK, VRGATHEREI16_VV }, // 9044
  { PseudoVRGATHEREI16_VV_M1_E32_MF2_TU, VRGATHEREI16_VV }, // 9045
  { PseudoVRGATHEREI16_VV_M1_E32_MF4, VRGATHEREI16_VV }, // 9046
  { PseudoVRGATHEREI16_VV_M1_E32_MF4_MASK, VRGATHEREI16_VV }, // 9047
  { PseudoVRGATHEREI16_VV_M1_E32_MF4_TU, VRGATHEREI16_VV }, // 9048
  { PseudoVRGATHEREI16_VV_M1_E64_M1, VRGATHEREI16_VV }, // 9049
  { PseudoVRGATHEREI16_VV_M1_E64_M1_MASK, VRGATHEREI16_VV }, // 9050
  { PseudoVRGATHEREI16_VV_M1_E64_M1_TU, VRGATHEREI16_VV }, // 9051
  { PseudoVRGATHEREI16_VV_M1_E64_M2, VRGATHEREI16_VV }, // 9052
  { PseudoVRGATHEREI16_VV_M1_E64_M2_MASK, VRGATHEREI16_VV }, // 9053
  { PseudoVRGATHEREI16_VV_M1_E64_M2_TU, VRGATHEREI16_VV }, // 9054
  { PseudoVRGATHEREI16_VV_M1_E64_MF2, VRGATHEREI16_VV }, // 9055
  { PseudoVRGATHEREI16_VV_M1_E64_MF2_MASK, VRGATHEREI16_VV }, // 9056
  { PseudoVRGATHEREI16_VV_M1_E64_MF2_TU, VRGATHEREI16_VV }, // 9057
  { PseudoVRGATHEREI16_VV_M1_E64_MF4, VRGATHEREI16_VV }, // 9058
  { PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK, VRGATHEREI16_VV }, // 9059
  { PseudoVRGATHEREI16_VV_M1_E64_MF4_TU, VRGATHEREI16_VV }, // 9060
  { PseudoVRGATHEREI16_VV_M1_E8_M1, VRGATHEREI16_VV }, // 9061
  { PseudoVRGATHEREI16_VV_M1_E8_M1_MASK, VRGATHEREI16_VV }, // 9062
  { PseudoVRGATHEREI16_VV_M1_E8_M1_TU, VRGATHEREI16_VV }, // 9063
  { PseudoVRGATHEREI16_VV_M1_E8_M2, VRGATHEREI16_VV }, // 9064
  { PseudoVRGATHEREI16_VV_M1_E8_M2_MASK, VRGATHEREI16_VV }, // 9065
  { PseudoVRGATHEREI16_VV_M1_E8_M2_TU, VRGATHEREI16_VV }, // 9066
  { PseudoVRGATHEREI16_VV_M1_E8_MF2, VRGATHEREI16_VV }, // 9067
  { PseudoVRGATHEREI16_VV_M1_E8_MF2_MASK, VRGATHEREI16_VV }, // 9068
  { PseudoVRGATHEREI16_VV_M1_E8_MF2_TU, VRGATHEREI16_VV }, // 9069
  { PseudoVRGATHEREI16_VV_M1_E8_MF4, VRGATHEREI16_VV }, // 9070
  { PseudoVRGATHEREI16_VV_M1_E8_MF4_MASK, VRGATHEREI16_VV }, // 9071
  { PseudoVRGATHEREI16_VV_M1_E8_MF4_TU, VRGATHEREI16_VV }, // 9072
  { PseudoVRGATHEREI16_VV_M2_E16_M1, VRGATHEREI16_VV }, // 9073
  { PseudoVRGATHEREI16_VV_M2_E16_M1_MASK, VRGATHEREI16_VV }, // 9074
  { PseudoVRGATHEREI16_VV_M2_E16_M1_TU, VRGATHEREI16_VV }, // 9075
  { PseudoVRGATHEREI16_VV_M2_E16_M2, VRGATHEREI16_VV }, // 9076
  { PseudoVRGATHEREI16_VV_M2_E16_M2_MASK, VRGATHEREI16_VV }, // 9077
  { PseudoVRGATHEREI16_VV_M2_E16_M2_TU, VRGATHEREI16_VV }, // 9078
  { PseudoVRGATHEREI16_VV_M2_E16_M4, VRGATHEREI16_VV }, // 9079
  { PseudoVRGATHEREI16_VV_M2_E16_M4_MASK, VRGATHEREI16_VV }, // 9080
  { PseudoVRGATHEREI16_VV_M2_E16_M4_TU, VRGATHEREI16_VV }, // 9081
  { PseudoVRGATHEREI16_VV_M2_E16_MF2, VRGATHEREI16_VV }, // 9082
  { PseudoVRGATHEREI16_VV_M2_E16_MF2_MASK, VRGATHEREI16_VV }, // 9083
  { PseudoVRGATHEREI16_VV_M2_E16_MF2_TU, VRGATHEREI16_VV }, // 9084
  { PseudoVRGATHEREI16_VV_M2_E32_M1, VRGATHEREI16_VV }, // 9085
  { PseudoVRGATHEREI16_VV_M2_E32_M1_MASK, VRGATHEREI16_VV }, // 9086
  { PseudoVRGATHEREI16_VV_M2_E32_M1_TU, VRGATHEREI16_VV }, // 9087
  { PseudoVRGATHEREI16_VV_M2_E32_M2, VRGATHEREI16_VV }, // 9088
  { PseudoVRGATHEREI16_VV_M2_E32_M2_MASK, VRGATHEREI16_VV }, // 9089
  { PseudoVRGATHEREI16_VV_M2_E32_M2_TU, VRGATHEREI16_VV }, // 9090
  { PseudoVRGATHEREI16_VV_M2_E32_M4, VRGATHEREI16_VV }, // 9091
  { PseudoVRGATHEREI16_VV_M2_E32_M4_MASK, VRGATHEREI16_VV }, // 9092
  { PseudoVRGATHEREI16_VV_M2_E32_M4_TU, VRGATHEREI16_VV }, // 9093
  { PseudoVRGATHEREI16_VV_M2_E32_MF2, VRGATHEREI16_VV }, // 9094
  { PseudoVRGATHEREI16_VV_M2_E32_MF2_MASK, VRGATHEREI16_VV }, // 9095
  { PseudoVRGATHEREI16_VV_M2_E32_MF2_TU, VRGATHEREI16_VV }, // 9096
  { PseudoVRGATHEREI16_VV_M2_E64_M1, VRGATHEREI16_VV }, // 9097
  { PseudoVRGATHEREI16_VV_M2_E64_M1_MASK, VRGATHEREI16_VV }, // 9098
  { PseudoVRGATHEREI16_VV_M2_E64_M1_TU, VRGATHEREI16_VV }, // 9099
  { PseudoVRGATHEREI16_VV_M2_E64_M2, VRGATHEREI16_VV }, // 9100
  { PseudoVRGATHEREI16_VV_M2_E64_M2_MASK, VRGATHEREI16_VV }, // 9101
  { PseudoVRGATHEREI16_VV_M2_E64_M2_TU, VRGATHEREI16_VV }, // 9102
  { PseudoVRGATHEREI16_VV_M2_E64_M4, VRGATHEREI16_VV }, // 9103
  { PseudoVRGATHEREI16_VV_M2_E64_M4_MASK, VRGATHEREI16_VV }, // 9104
  { PseudoVRGATHEREI16_VV_M2_E64_M4_TU, VRGATHEREI16_VV }, // 9105
  { PseudoVRGATHEREI16_VV_M2_E64_MF2, VRGATHEREI16_VV }, // 9106
  { PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK, VRGATHEREI16_VV }, // 9107
  { PseudoVRGATHEREI16_VV_M2_E64_MF2_TU, VRGATHEREI16_VV }, // 9108
  { PseudoVRGATHEREI16_VV_M2_E8_M1, VRGATHEREI16_VV }, // 9109
  { PseudoVRGATHEREI16_VV_M2_E8_M1_MASK, VRGATHEREI16_VV }, // 9110
  { PseudoVRGATHEREI16_VV_M2_E8_M1_TU, VRGATHEREI16_VV }, // 9111
  { PseudoVRGATHEREI16_VV_M2_E8_M2, VRGATHEREI16_VV }, // 9112
  { PseudoVRGATHEREI16_VV_M2_E8_M2_MASK, VRGATHEREI16_VV }, // 9113
  { PseudoVRGATHEREI16_VV_M2_E8_M2_TU, VRGATHEREI16_VV }, // 9114
  { PseudoVRGATHEREI16_VV_M2_E8_M4, VRGATHEREI16_VV }, // 9115
  { PseudoVRGATHEREI16_VV_M2_E8_M4_MASK, VRGATHEREI16_VV }, // 9116
  { PseudoVRGATHEREI16_VV_M2_E8_M4_TU, VRGATHEREI16_VV }, // 9117
  { PseudoVRGATHEREI16_VV_M2_E8_MF2, VRGATHEREI16_VV }, // 9118
  { PseudoVRGATHEREI16_VV_M2_E8_MF2_MASK, VRGATHEREI16_VV }, // 9119
  { PseudoVRGATHEREI16_VV_M2_E8_MF2_TU, VRGATHEREI16_VV }, // 9120
  { PseudoVRGATHEREI16_VV_M4_E16_M1, VRGATHEREI16_VV }, // 9121
  { PseudoVRGATHEREI16_VV_M4_E16_M1_MASK, VRGATHEREI16_VV }, // 9122
  { PseudoVRGATHEREI16_VV_M4_E16_M1_TU, VRGATHEREI16_VV }, // 9123
  { PseudoVRGATHEREI16_VV_M4_E16_M2, VRGATHEREI16_VV }, // 9124
  { PseudoVRGATHEREI16_VV_M4_E16_M2_MASK, VRGATHEREI16_VV }, // 9125
  { PseudoVRGATHEREI16_VV_M4_E16_M2_TU, VRGATHEREI16_VV }, // 9126
  { PseudoVRGATHEREI16_VV_M4_E16_M4, VRGATHEREI16_VV }, // 9127
  { PseudoVRGATHEREI16_VV_M4_E16_M4_MASK, VRGATHEREI16_VV }, // 9128
  { PseudoVRGATHEREI16_VV_M4_E16_M4_TU, VRGATHEREI16_VV }, // 9129
  { PseudoVRGATHEREI16_VV_M4_E16_M8, VRGATHEREI16_VV }, // 9130
  { PseudoVRGATHEREI16_VV_M4_E16_M8_MASK, VRGATHEREI16_VV }, // 9131
  { PseudoVRGATHEREI16_VV_M4_E16_M8_TU, VRGATHEREI16_VV }, // 9132
  { PseudoVRGATHEREI16_VV_M4_E32_M1, VRGATHEREI16_VV }, // 9133
  { PseudoVRGATHEREI16_VV_M4_E32_M1_MASK, VRGATHEREI16_VV }, // 9134
  { PseudoVRGATHEREI16_VV_M4_E32_M1_TU, VRGATHEREI16_VV }, // 9135
  { PseudoVRGATHEREI16_VV_M4_E32_M2, VRGATHEREI16_VV }, // 9136
  { PseudoVRGATHEREI16_VV_M4_E32_M2_MASK, VRGATHEREI16_VV }, // 9137
  { PseudoVRGATHEREI16_VV_M4_E32_M2_TU, VRGATHEREI16_VV }, // 9138
  { PseudoVRGATHEREI16_VV_M4_E32_M4, VRGATHEREI16_VV }, // 9139
  { PseudoVRGATHEREI16_VV_M4_E32_M4_MASK, VRGATHEREI16_VV }, // 9140
  { PseudoVRGATHEREI16_VV_M4_E32_M4_TU, VRGATHEREI16_VV }, // 9141
  { PseudoVRGATHEREI16_VV_M4_E32_M8, VRGATHEREI16_VV }, // 9142
  { PseudoVRGATHEREI16_VV_M4_E32_M8_MASK, VRGATHEREI16_VV }, // 9143
  { PseudoVRGATHEREI16_VV_M4_E32_M8_TU, VRGATHEREI16_VV }, // 9144
  { PseudoVRGATHEREI16_VV_M4_E64_M1, VRGATHEREI16_VV }, // 9145
  { PseudoVRGATHEREI16_VV_M4_E64_M1_MASK, VRGATHEREI16_VV }, // 9146
  { PseudoVRGATHEREI16_VV_M4_E64_M1_TU, VRGATHEREI16_VV }, // 9147
  { PseudoVRGATHEREI16_VV_M4_E64_M2, VRGATHEREI16_VV }, // 9148
  { PseudoVRGATHEREI16_VV_M4_E64_M2_MASK, VRGATHEREI16_VV }, // 9149
  { PseudoVRGATHEREI16_VV_M4_E64_M2_TU, VRGATHEREI16_VV }, // 9150
  { PseudoVRGATHEREI16_VV_M4_E64_M4, VRGATHEREI16_VV }, // 9151
  { PseudoVRGATHEREI16_VV_M4_E64_M4_MASK, VRGATHEREI16_VV }, // 9152
  { PseudoVRGATHEREI16_VV_M4_E64_M4_TU, VRGATHEREI16_VV }, // 9153
  { PseudoVRGATHEREI16_VV_M4_E64_M8, VRGATHEREI16_VV }, // 9154
  { PseudoVRGATHEREI16_VV_M4_E64_M8_MASK, VRGATHEREI16_VV }, // 9155
  { PseudoVRGATHEREI16_VV_M4_E64_M8_TU, VRGATHEREI16_VV }, // 9156
  { PseudoVRGATHEREI16_VV_M4_E8_M1, VRGATHEREI16_VV }, // 9157
  { PseudoVRGATHEREI16_VV_M4_E8_M1_MASK, VRGATHEREI16_VV }, // 9158
  { PseudoVRGATHEREI16_VV_M4_E8_M1_TU, VRGATHEREI16_VV }, // 9159
  { PseudoVRGATHEREI16_VV_M4_E8_M2, VRGATHEREI16_VV }, // 9160
  { PseudoVRGATHEREI16_VV_M4_E8_M2_MASK, VRGATHEREI16_VV }, // 9161
  { PseudoVRGATHEREI16_VV_M4_E8_M2_TU, VRGATHEREI16_VV }, // 9162
  { PseudoVRGATHEREI16_VV_M4_E8_M4, VRGATHEREI16_VV }, // 9163
  { PseudoVRGATHEREI16_VV_M4_E8_M4_MASK, VRGATHEREI16_VV }, // 9164
  { PseudoVRGATHEREI16_VV_M4_E8_M4_TU, VRGATHEREI16_VV }, // 9165
  { PseudoVRGATHEREI16_VV_M4_E8_M8, VRGATHEREI16_VV }, // 9166
  { PseudoVRGATHEREI16_VV_M4_E8_M8_MASK, VRGATHEREI16_VV }, // 9167
  { PseudoVRGATHEREI16_VV_M4_E8_M8_TU, VRGATHEREI16_VV }, // 9168
  { PseudoVRGATHEREI16_VV_M8_E16_M2, VRGATHEREI16_VV }, // 9169
  { PseudoVRGATHEREI16_VV_M8_E16_M2_MASK, VRGATHEREI16_VV }, // 9170
  { PseudoVRGATHEREI16_VV_M8_E16_M2_TU, VRGATHEREI16_VV }, // 9171
  { PseudoVRGATHEREI16_VV_M8_E16_M4, VRGATHEREI16_VV }, // 9172
  { PseudoVRGATHEREI16_VV_M8_E16_M4_MASK, VRGATHEREI16_VV }, // 9173
  { PseudoVRGATHEREI16_VV_M8_E16_M4_TU, VRGATHEREI16_VV }, // 9174
  { PseudoVRGATHEREI16_VV_M8_E16_M8, VRGATHEREI16_VV }, // 9175
  { PseudoVRGATHEREI16_VV_M8_E16_M8_MASK, VRGATHEREI16_VV }, // 9176
  { PseudoVRGATHEREI16_VV_M8_E16_M8_TU, VRGATHEREI16_VV }, // 9177
  { PseudoVRGATHEREI16_VV_M8_E32_M2, VRGATHEREI16_VV }, // 9178
  { PseudoVRGATHEREI16_VV_M8_E32_M2_MASK, VRGATHEREI16_VV }, // 9179
  { PseudoVRGATHEREI16_VV_M8_E32_M2_TU, VRGATHEREI16_VV }, // 9180
  { PseudoVRGATHEREI16_VV_M8_E32_M4, VRGATHEREI16_VV }, // 9181
  { PseudoVRGATHEREI16_VV_M8_E32_M4_MASK, VRGATHEREI16_VV }, // 9182
  { PseudoVRGATHEREI16_VV_M8_E32_M4_TU, VRGATHEREI16_VV }, // 9183
  { PseudoVRGATHEREI16_VV_M8_E32_M8, VRGATHEREI16_VV }, // 9184
  { PseudoVRGATHEREI16_VV_M8_E32_M8_MASK, VRGATHEREI16_VV }, // 9185
  { PseudoVRGATHEREI16_VV_M8_E32_M8_TU, VRGATHEREI16_VV }, // 9186
  { PseudoVRGATHEREI16_VV_M8_E64_M2, VRGATHEREI16_VV }, // 9187
  { PseudoVRGATHEREI16_VV_M8_E64_M2_MASK, VRGATHEREI16_VV }, // 9188
  { PseudoVRGATHEREI16_VV_M8_E64_M2_TU, VRGATHEREI16_VV }, // 9189
  { PseudoVRGATHEREI16_VV_M8_E64_M4, VRGATHEREI16_VV }, // 9190
  { PseudoVRGATHEREI16_VV_M8_E64_M4_MASK, VRGATHEREI16_VV }, // 9191
  { PseudoVRGATHEREI16_VV_M8_E64_M4_TU, VRGATHEREI16_VV }, // 9192
  { PseudoVRGATHEREI16_VV_M8_E64_M8, VRGATHEREI16_VV }, // 9193
  { PseudoVRGATHEREI16_VV_M8_E64_M8_MASK, VRGATHEREI16_VV }, // 9194
  { PseudoVRGATHEREI16_VV_M8_E64_M8_TU, VRGATHEREI16_VV }, // 9195
  { PseudoVRGATHEREI16_VV_M8_E8_M2, VRGATHEREI16_VV }, // 9196
  { PseudoVRGATHEREI16_VV_M8_E8_M2_MASK, VRGATHEREI16_VV }, // 9197
  { PseudoVRGATHEREI16_VV_M8_E8_M2_TU, VRGATHEREI16_VV }, // 9198
  { PseudoVRGATHEREI16_VV_M8_E8_M4, VRGATHEREI16_VV }, // 9199
  { PseudoVRGATHEREI16_VV_M8_E8_M4_MASK, VRGATHEREI16_VV }, // 9200
  { PseudoVRGATHEREI16_VV_M8_E8_M4_TU, VRGATHEREI16_VV }, // 9201
  { PseudoVRGATHEREI16_VV_M8_E8_M8, VRGATHEREI16_VV }, // 9202
  { PseudoVRGATHEREI16_VV_M8_E8_M8_MASK, VRGATHEREI16_VV }, // 9203
  { PseudoVRGATHEREI16_VV_M8_E8_M8_TU, VRGATHEREI16_VV }, // 9204
  { PseudoVRGATHEREI16_VV_MF2_E16_M1, VRGATHEREI16_VV }, // 9205
  { PseudoVRGATHEREI16_VV_MF2_E16_M1_MASK, VRGATHEREI16_VV }, // 9206
  { PseudoVRGATHEREI16_VV_MF2_E16_M1_TU, VRGATHEREI16_VV }, // 9207
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2, VRGATHEREI16_VV }, // 9208
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK, VRGATHEREI16_VV }, // 9209
  { PseudoVRGATHEREI16_VV_MF2_E16_MF2_TU, VRGATHEREI16_VV }, // 9210
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4, VRGATHEREI16_VV }, // 9211
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4_MASK, VRGATHEREI16_VV }, // 9212
  { PseudoVRGATHEREI16_VV_MF2_E16_MF4_TU, VRGATHEREI16_VV }, // 9213
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8, VRGATHEREI16_VV }, // 9214
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8_MASK, VRGATHEREI16_VV }, // 9215
  { PseudoVRGATHEREI16_VV_MF2_E16_MF8_TU, VRGATHEREI16_VV }, // 9216
  { PseudoVRGATHEREI16_VV_MF2_E32_M1, VRGATHEREI16_VV }, // 9217
  { PseudoVRGATHEREI16_VV_MF2_E32_M1_MASK, VRGATHEREI16_VV }, // 9218
  { PseudoVRGATHEREI16_VV_MF2_E32_M1_TU, VRGATHEREI16_VV }, // 9219
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2, VRGATHEREI16_VV }, // 9220
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2_MASK, VRGATHEREI16_VV }, // 9221
  { PseudoVRGATHEREI16_VV_MF2_E32_MF2_TU, VRGATHEREI16_VV }, // 9222
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4, VRGATHEREI16_VV }, // 9223
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK, VRGATHEREI16_VV }, // 9224
  { PseudoVRGATHEREI16_VV_MF2_E32_MF4_TU, VRGATHEREI16_VV }, // 9225
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8, VRGATHEREI16_VV }, // 9226
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8_MASK, VRGATHEREI16_VV }, // 9227
  { PseudoVRGATHEREI16_VV_MF2_E32_MF8_TU, VRGATHEREI16_VV }, // 9228
  { PseudoVRGATHEREI16_VV_MF2_E8_M1, VRGATHEREI16_VV }, // 9229
  { PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK, VRGATHEREI16_VV }, // 9230
  { PseudoVRGATHEREI16_VV_MF2_E8_M1_TU, VRGATHEREI16_VV }, // 9231
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2, VRGATHEREI16_VV }, // 9232
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2_MASK, VRGATHEREI16_VV }, // 9233
  { PseudoVRGATHEREI16_VV_MF2_E8_MF2_TU, VRGATHEREI16_VV }, // 9234
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4, VRGATHEREI16_VV }, // 9235
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4_MASK, VRGATHEREI16_VV }, // 9236
  { PseudoVRGATHEREI16_VV_MF2_E8_MF4_TU, VRGATHEREI16_VV }, // 9237
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8, VRGATHEREI16_VV }, // 9238
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8_MASK, VRGATHEREI16_VV }, // 9239
  { PseudoVRGATHEREI16_VV_MF2_E8_MF8_TU, VRGATHEREI16_VV }, // 9240
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2, VRGATHEREI16_VV }, // 9241
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2_MASK, VRGATHEREI16_VV }, // 9242
  { PseudoVRGATHEREI16_VV_MF4_E16_MF2_TU, VRGATHEREI16_VV }, // 9243
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4, VRGATHEREI16_VV }, // 9244
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK, VRGATHEREI16_VV }, // 9245
  { PseudoVRGATHEREI16_VV_MF4_E16_MF4_TU, VRGATHEREI16_VV }, // 9246
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8, VRGATHEREI16_VV }, // 9247
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8_MASK, VRGATHEREI16_VV }, // 9248
  { PseudoVRGATHEREI16_VV_MF4_E16_MF8_TU, VRGATHEREI16_VV }, // 9249
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2, VRGATHEREI16_VV }, // 9250
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK, VRGATHEREI16_VV }, // 9251
  { PseudoVRGATHEREI16_VV_MF4_E8_MF2_TU, VRGATHEREI16_VV }, // 9252
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4, VRGATHEREI16_VV }, // 9253
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4_MASK, VRGATHEREI16_VV }, // 9254
  { PseudoVRGATHEREI16_VV_MF4_E8_MF4_TU, VRGATHEREI16_VV }, // 9255
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8, VRGATHEREI16_VV }, // 9256
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8_MASK, VRGATHEREI16_VV }, // 9257
  { PseudoVRGATHEREI16_VV_MF4_E8_MF8_TU, VRGATHEREI16_VV }, // 9258
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4, VRGATHEREI16_VV }, // 9259
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK, VRGATHEREI16_VV }, // 9260
  { PseudoVRGATHEREI16_VV_MF8_E8_MF4_TU, VRGATHEREI16_VV }, // 9261
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8, VRGATHEREI16_VV }, // 9262
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8_MASK, VRGATHEREI16_VV }, // 9263
  { PseudoVRGATHEREI16_VV_MF8_E8_MF8_TU, VRGATHEREI16_VV }, // 9264
  { PseudoVRGATHER_VI_M1, VRGATHER_VI }, // 9265
  { PseudoVRGATHER_VI_M1_MASK, VRGATHER_VI }, // 9266
  { PseudoVRGATHER_VI_M1_TU, VRGATHER_VI }, // 9267
  { PseudoVRGATHER_VI_M2, VRGATHER_VI }, // 9268
  { PseudoVRGATHER_VI_M2_MASK, VRGATHER_VI }, // 9269
  { PseudoVRGATHER_VI_M2_TU, VRGATHER_VI }, // 9270
  { PseudoVRGATHER_VI_M4, VRGATHER_VI }, // 9271
  { PseudoVRGATHER_VI_M4_MASK, VRGATHER_VI }, // 9272
  { PseudoVRGATHER_VI_M4_TU, VRGATHER_VI }, // 9273
  { PseudoVRGATHER_VI_M8, VRGATHER_VI }, // 9274
  { PseudoVRGATHER_VI_M8_MASK, VRGATHER_VI }, // 9275
  { PseudoVRGATHER_VI_M8_TU, VRGATHER_VI }, // 9276
  { PseudoVRGATHER_VI_MF2, VRGATHER_VI }, // 9277
  { PseudoVRGATHER_VI_MF2_MASK, VRGATHER_VI }, // 9278
  { PseudoVRGATHER_VI_MF2_TU, VRGATHER_VI }, // 9279
  { PseudoVRGATHER_VI_MF4, VRGATHER_VI }, // 9280
  { PseudoVRGATHER_VI_MF4_MASK, VRGATHER_VI }, // 9281
  { PseudoVRGATHER_VI_MF4_TU, VRGATHER_VI }, // 9282
  { PseudoVRGATHER_VI_MF8, VRGATHER_VI }, // 9283
  { PseudoVRGATHER_VI_MF8_MASK, VRGATHER_VI }, // 9284
  { PseudoVRGATHER_VI_MF8_TU, VRGATHER_VI }, // 9285
  { PseudoVRGATHER_VV_M1_E16, VRGATHER_VV }, // 9286
  { PseudoVRGATHER_VV_M1_E16_MASK, VRGATHER_VV }, // 9287
  { PseudoVRGATHER_VV_M1_E16_TU, VRGATHER_VV }, // 9288
  { PseudoVRGATHER_VV_M1_E32, VRGATHER_VV }, // 9289
  { PseudoVRGATHER_VV_M1_E32_MASK, VRGATHER_VV }, // 9290
  { PseudoVRGATHER_VV_M1_E32_TU, VRGATHER_VV }, // 9291
  { PseudoVRGATHER_VV_M1_E64, VRGATHER_VV }, // 9292
  { PseudoVRGATHER_VV_M1_E64_MASK, VRGATHER_VV }, // 9293
  { PseudoVRGATHER_VV_M1_E64_TU, VRGATHER_VV }, // 9294
  { PseudoVRGATHER_VV_M1_E8, VRGATHER_VV }, // 9295
  { PseudoVRGATHER_VV_M1_E8_MASK, VRGATHER_VV }, // 9296
  { PseudoVRGATHER_VV_M1_E8_TU, VRGATHER_VV }, // 9297
  { PseudoVRGATHER_VV_M2_E16, VRGATHER_VV }, // 9298
  { PseudoVRGATHER_VV_M2_E16_MASK, VRGATHER_VV }, // 9299
  { PseudoVRGATHER_VV_M2_E16_TU, VRGATHER_VV }, // 9300
  { PseudoVRGATHER_VV_M2_E32, VRGATHER_VV }, // 9301
  { PseudoVRGATHER_VV_M2_E32_MASK, VRGATHER_VV }, // 9302
  { PseudoVRGATHER_VV_M2_E32_TU, VRGATHER_VV }, // 9303
  { PseudoVRGATHER_VV_M2_E64, VRGATHER_VV }, // 9304
  { PseudoVRGATHER_VV_M2_E64_MASK, VRGATHER_VV }, // 9305
  { PseudoVRGATHER_VV_M2_E64_TU, VRGATHER_VV }, // 9306
  { PseudoVRGATHER_VV_M2_E8, VRGATHER_VV }, // 9307
  { PseudoVRGATHER_VV_M2_E8_MASK, VRGATHER_VV }, // 9308
  { PseudoVRGATHER_VV_M2_E8_TU, VRGATHER_VV }, // 9309
  { PseudoVRGATHER_VV_M4_E16, VRGATHER_VV }, // 9310
  { PseudoVRGATHER_VV_M4_E16_MASK, VRGATHER_VV }, // 9311
  { PseudoVRGATHER_VV_M4_E16_TU, VRGATHER_VV }, // 9312
  { PseudoVRGATHER_VV_M4_E32, VRGATHER_VV }, // 9313
  { PseudoVRGATHER_VV_M4_E32_MASK, VRGATHER_VV }, // 9314
  { PseudoVRGATHER_VV_M4_E32_TU, VRGATHER_VV }, // 9315
  { PseudoVRGATHER_VV_M4_E64, VRGATHER_VV }, // 9316
  { PseudoVRGATHER_VV_M4_E64_MASK, VRGATHER_VV }, // 9317
  { PseudoVRGATHER_VV_M4_E64_TU, VRGATHER_VV }, // 9318
  { PseudoVRGATHER_VV_M4_E8, VRGATHER_VV }, // 9319
  { PseudoVRGATHER_VV_M4_E8_MASK, VRGATHER_VV }, // 9320
  { PseudoVRGATHER_VV_M4_E8_TU, VRGATHER_VV }, // 9321
  { PseudoVRGATHER_VV_M8_E16, VRGATHER_VV }, // 9322
  { PseudoVRGATHER_VV_M8_E16_MASK, VRGATHER_VV }, // 9323
  { PseudoVRGATHER_VV_M8_E16_TU, VRGATHER_VV }, // 9324
  { PseudoVRGATHER_VV_M8_E32, VRGATHER_VV }, // 9325
  { PseudoVRGATHER_VV_M8_E32_MASK, VRGATHER_VV }, // 9326
  { PseudoVRGATHER_VV_M8_E32_TU, VRGATHER_VV }, // 9327
  { PseudoVRGATHER_VV_M8_E64, VRGATHER_VV }, // 9328
  { PseudoVRGATHER_VV_M8_E64_MASK, VRGATHER_VV }, // 9329
  { PseudoVRGATHER_VV_M8_E64_TU, VRGATHER_VV }, // 9330
  { PseudoVRGATHER_VV_M8_E8, VRGATHER_VV }, // 9331
  { PseudoVRGATHER_VV_M8_E8_MASK, VRGATHER_VV }, // 9332
  { PseudoVRGATHER_VV_M8_E8_TU, VRGATHER_VV }, // 9333
  { PseudoVRGATHER_VV_MF2_E16, VRGATHER_VV }, // 9334
  { PseudoVRGATHER_VV_MF2_E16_MASK, VRGATHER_VV }, // 9335
  { PseudoVRGATHER_VV_MF2_E16_TU, VRGATHER_VV }, // 9336
  { PseudoVRGATHER_VV_MF2_E32, VRGATHER_VV }, // 9337
  { PseudoVRGATHER_VV_MF2_E32_MASK, VRGATHER_VV }, // 9338
  { PseudoVRGATHER_VV_MF2_E32_TU, VRGATHER_VV }, // 9339
  { PseudoVRGATHER_VV_MF2_E8, VRGATHER_VV }, // 9340
  { PseudoVRGATHER_VV_MF2_E8_MASK, VRGATHER_VV }, // 9341
  { PseudoVRGATHER_VV_MF2_E8_TU, VRGATHER_VV }, // 9342
  { PseudoVRGATHER_VV_MF4_E16, VRGATHER_VV }, // 9343
  { PseudoVRGATHER_VV_MF4_E16_MASK, VRGATHER_VV }, // 9344
  { PseudoVRGATHER_VV_MF4_E16_TU, VRGATHER_VV }, // 9345
  { PseudoVRGATHER_VV_MF4_E8, VRGATHER_VV }, // 9346
  { PseudoVRGATHER_VV_MF4_E8_MASK, VRGATHER_VV }, // 9347
  { PseudoVRGATHER_VV_MF4_E8_TU, VRGATHER_VV }, // 9348
  { PseudoVRGATHER_VV_MF8_E8, VRGATHER_VV }, // 9349
  { PseudoVRGATHER_VV_MF8_E8_MASK, VRGATHER_VV }, // 9350
  { PseudoVRGATHER_VV_MF8_E8_TU, VRGATHER_VV }, // 9351
  { PseudoVRGATHER_VX_M1, VRGATHER_VX }, // 9352
  { PseudoVRGATHER_VX_M1_MASK, VRGATHER_VX }, // 9353
  { PseudoVRGATHER_VX_M1_TU, VRGATHER_VX }, // 9354
  { PseudoVRGATHER_VX_M2, VRGATHER_VX }, // 9355
  { PseudoVRGATHER_VX_M2_MASK, VRGATHER_VX }, // 9356
  { PseudoVRGATHER_VX_M2_TU, VRGATHER_VX }, // 9357
  { PseudoVRGATHER_VX_M4, VRGATHER_VX }, // 9358
  { PseudoVRGATHER_VX_M4_MASK, VRGATHER_VX }, // 9359
  { PseudoVRGATHER_VX_M4_TU, VRGATHER_VX }, // 9360
  { PseudoVRGATHER_VX_M8, VRGATHER_VX }, // 9361
  { PseudoVRGATHER_VX_M8_MASK, VRGATHER_VX }, // 9362
  { PseudoVRGATHER_VX_M8_TU, VRGATHER_VX }, // 9363
  { PseudoVRGATHER_VX_MF2, VRGATHER_VX }, // 9364
  { PseudoVRGATHER_VX_MF2_MASK, VRGATHER_VX }, // 9365
  { PseudoVRGATHER_VX_MF2_TU, VRGATHER_VX }, // 9366
  { PseudoVRGATHER_VX_MF4, VRGATHER_VX }, // 9367
  { PseudoVRGATHER_VX_MF4_MASK, VRGATHER_VX }, // 9368
  { PseudoVRGATHER_VX_MF4_TU, VRGATHER_VX }, // 9369
  { PseudoVRGATHER_VX_MF8, VRGATHER_VX }, // 9370
  { PseudoVRGATHER_VX_MF8_MASK, VRGATHER_VX }, // 9371
  { PseudoVRGATHER_VX_MF8_TU, VRGATHER_VX }, // 9372
  { PseudoVRSUB_VI_M1, VRSUB_VI }, // 9373
  { PseudoVRSUB_VI_M1_MASK, VRSUB_VI }, // 9374
  { PseudoVRSUB_VI_M1_TU, VRSUB_VI }, // 9375
  { PseudoVRSUB_VI_M2, VRSUB_VI }, // 9376
  { PseudoVRSUB_VI_M2_MASK, VRSUB_VI }, // 9377
  { PseudoVRSUB_VI_M2_TU, VRSUB_VI }, // 9378
  { PseudoVRSUB_VI_M4, VRSUB_VI }, // 9379
  { PseudoVRSUB_VI_M4_MASK, VRSUB_VI }, // 9380
  { PseudoVRSUB_VI_M4_TU, VRSUB_VI }, // 9381
  { PseudoVRSUB_VI_M8, VRSUB_VI }, // 9382
  { PseudoVRSUB_VI_M8_MASK, VRSUB_VI }, // 9383
  { PseudoVRSUB_VI_M8_TU, VRSUB_VI }, // 9384
  { PseudoVRSUB_VI_MF2, VRSUB_VI }, // 9385
  { PseudoVRSUB_VI_MF2_MASK, VRSUB_VI }, // 9386
  { PseudoVRSUB_VI_MF2_TU, VRSUB_VI }, // 9387
  { PseudoVRSUB_VI_MF4, VRSUB_VI }, // 9388
  { PseudoVRSUB_VI_MF4_MASK, VRSUB_VI }, // 9389
  { PseudoVRSUB_VI_MF4_TU, VRSUB_VI }, // 9390
  { PseudoVRSUB_VI_MF8, VRSUB_VI }, // 9391
  { PseudoVRSUB_VI_MF8_MASK, VRSUB_VI }, // 9392
  { PseudoVRSUB_VI_MF8_TU, VRSUB_VI }, // 9393
  { PseudoVRSUB_VX_M1, VRSUB_VX }, // 9394
  { PseudoVRSUB_VX_M1_MASK, VRSUB_VX }, // 9395
  { PseudoVRSUB_VX_M1_TU, VRSUB_VX }, // 9396
  { PseudoVRSUB_VX_M2, VRSUB_VX }, // 9397
  { PseudoVRSUB_VX_M2_MASK, VRSUB_VX }, // 9398
  { PseudoVRSUB_VX_M2_TU, VRSUB_VX }, // 9399
  { PseudoVRSUB_VX_M4, VRSUB_VX }, // 9400
  { PseudoVRSUB_VX_M4_MASK, VRSUB_VX }, // 9401
  { PseudoVRSUB_VX_M4_TU, VRSUB_VX }, // 9402
  { PseudoVRSUB_VX_M8, VRSUB_VX }, // 9403
  { PseudoVRSUB_VX_M8_MASK, VRSUB_VX }, // 9404
  { PseudoVRSUB_VX_M8_TU, VRSUB_VX }, // 9405
  { PseudoVRSUB_VX_MF2, VRSUB_VX }, // 9406
  { PseudoVRSUB_VX_MF2_MASK, VRSUB_VX }, // 9407
  { PseudoVRSUB_VX_MF2_TU, VRSUB_VX }, // 9408
  { PseudoVRSUB_VX_MF4, VRSUB_VX }, // 9409
  { PseudoVRSUB_VX_MF4_MASK, VRSUB_VX }, // 9410
  { PseudoVRSUB_VX_MF4_TU, VRSUB_VX }, // 9411
  { PseudoVRSUB_VX_MF8, VRSUB_VX }, // 9412
  { PseudoVRSUB_VX_MF8_MASK, VRSUB_VX }, // 9413
  { PseudoVRSUB_VX_MF8_TU, VRSUB_VX }, // 9414
  { PseudoVSADDU_VI_M1, VSADDU_VI }, // 9415
  { PseudoVSADDU_VI_M1_MASK, VSADDU_VI }, // 9416
  { PseudoVSADDU_VI_M1_TU, VSADDU_VI }, // 9417
  { PseudoVSADDU_VI_M2, VSADDU_VI }, // 9418
  { PseudoVSADDU_VI_M2_MASK, VSADDU_VI }, // 9419
  { PseudoVSADDU_VI_M2_TU, VSADDU_VI }, // 9420
  { PseudoVSADDU_VI_M4, VSADDU_VI }, // 9421
  { PseudoVSADDU_VI_M4_MASK, VSADDU_VI }, // 9422
  { PseudoVSADDU_VI_M4_TU, VSADDU_VI }, // 9423
  { PseudoVSADDU_VI_M8, VSADDU_VI }, // 9424
  { PseudoVSADDU_VI_M8_MASK, VSADDU_VI }, // 9425
  { PseudoVSADDU_VI_M8_TU, VSADDU_VI }, // 9426
  { PseudoVSADDU_VI_MF2, VSADDU_VI }, // 9427
  { PseudoVSADDU_VI_MF2_MASK, VSADDU_VI }, // 9428
  { PseudoVSADDU_VI_MF2_TU, VSADDU_VI }, // 9429
  { PseudoVSADDU_VI_MF4, VSADDU_VI }, // 9430
  { PseudoVSADDU_VI_MF4_MASK, VSADDU_VI }, // 9431
  { PseudoVSADDU_VI_MF4_TU, VSADDU_VI }, // 9432
  { PseudoVSADDU_VI_MF8, VSADDU_VI }, // 9433
  { PseudoVSADDU_VI_MF8_MASK, VSADDU_VI }, // 9434
  { PseudoVSADDU_VI_MF8_TU, VSADDU_VI }, // 9435
  { PseudoVSADDU_VV_M1, VSADDU_VV }, // 9436
  { PseudoVSADDU_VV_M1_MASK, VSADDU_VV }, // 9437
  { PseudoVSADDU_VV_M1_TU, VSADDU_VV }, // 9438
  { PseudoVSADDU_VV_M2, VSADDU_VV }, // 9439
  { PseudoVSADDU_VV_M2_MASK, VSADDU_VV }, // 9440
  { PseudoVSADDU_VV_M2_TU, VSADDU_VV }, // 9441
  { PseudoVSADDU_VV_M4, VSADDU_VV }, // 9442
  { PseudoVSADDU_VV_M4_MASK, VSADDU_VV }, // 9443
  { PseudoVSADDU_VV_M4_TU, VSADDU_VV }, // 9444
  { PseudoVSADDU_VV_M8, VSADDU_VV }, // 9445
  { PseudoVSADDU_VV_M8_MASK, VSADDU_VV }, // 9446
  { PseudoVSADDU_VV_M8_TU, VSADDU_VV }, // 9447
  { PseudoVSADDU_VV_MF2, VSADDU_VV }, // 9448
  { PseudoVSADDU_VV_MF2_MASK, VSADDU_VV }, // 9449
  { PseudoVSADDU_VV_MF2_TU, VSADDU_VV }, // 9450
  { PseudoVSADDU_VV_MF4, VSADDU_VV }, // 9451
  { PseudoVSADDU_VV_MF4_MASK, VSADDU_VV }, // 9452
  { PseudoVSADDU_VV_MF4_TU, VSADDU_VV }, // 9453
  { PseudoVSADDU_VV_MF8, VSADDU_VV }, // 9454
  { PseudoVSADDU_VV_MF8_MASK, VSADDU_VV }, // 9455
  { PseudoVSADDU_VV_MF8_TU, VSADDU_VV }, // 9456
  { PseudoVSADDU_VX_M1, VSADDU_VX }, // 9457
  { PseudoVSADDU_VX_M1_MASK, VSADDU_VX }, // 9458
  { PseudoVSADDU_VX_M1_TU, VSADDU_VX }, // 9459
  { PseudoVSADDU_VX_M2, VSADDU_VX }, // 9460
  { PseudoVSADDU_VX_M2_MASK, VSADDU_VX }, // 9461
  { PseudoVSADDU_VX_M2_TU, VSADDU_VX }, // 9462
  { PseudoVSADDU_VX_M4, VSADDU_VX }, // 9463
  { PseudoVSADDU_VX_M4_MASK, VSADDU_VX }, // 9464
  { PseudoVSADDU_VX_M4_TU, VSADDU_VX }, // 9465
  { PseudoVSADDU_VX_M8, VSADDU_VX }, // 9466
  { PseudoVSADDU_VX_M8_MASK, VSADDU_VX }, // 9467
  { PseudoVSADDU_VX_M8_TU, VSADDU_VX }, // 9468
  { PseudoVSADDU_VX_MF2, VSADDU_VX }, // 9469
  { PseudoVSADDU_VX_MF2_MASK, VSADDU_VX }, // 9470
  { PseudoVSADDU_VX_MF2_TU, VSADDU_VX }, // 9471
  { PseudoVSADDU_VX_MF4, VSADDU_VX }, // 9472
  { PseudoVSADDU_VX_MF4_MASK, VSADDU_VX }, // 9473
  { PseudoVSADDU_VX_MF4_TU, VSADDU_VX }, // 9474
  { PseudoVSADDU_VX_MF8, VSADDU_VX }, // 9475
  { PseudoVSADDU_VX_MF8_MASK, VSADDU_VX }, // 9476
  { PseudoVSADDU_VX_MF8_TU, VSADDU_VX }, // 9477
  { PseudoVSADD_VI_M1, VSADD_VI }, // 9478
  { PseudoVSADD_VI_M1_MASK, VSADD_VI }, // 9479
  { PseudoVSADD_VI_M1_TU, VSADD_VI }, // 9480
  { PseudoVSADD_VI_M2, VSADD_VI }, // 9481
  { PseudoVSADD_VI_M2_MASK, VSADD_VI }, // 9482
  { PseudoVSADD_VI_M2_TU, VSADD_VI }, // 9483
  { PseudoVSADD_VI_M4, VSADD_VI }, // 9484
  { PseudoVSADD_VI_M4_MASK, VSADD_VI }, // 9485
  { PseudoVSADD_VI_M4_TU, VSADD_VI }, // 9486
  { PseudoVSADD_VI_M8, VSADD_VI }, // 9487
  { PseudoVSADD_VI_M8_MASK, VSADD_VI }, // 9488
  { PseudoVSADD_VI_M8_TU, VSADD_VI }, // 9489
  { PseudoVSADD_VI_MF2, VSADD_VI }, // 9490
  { PseudoVSADD_VI_MF2_MASK, VSADD_VI }, // 9491
  { PseudoVSADD_VI_MF2_TU, VSADD_VI }, // 9492
  { PseudoVSADD_VI_MF4, VSADD_VI }, // 9493
  { PseudoVSADD_VI_MF4_MASK, VSADD_VI }, // 9494
  { PseudoVSADD_VI_MF4_TU, VSADD_VI }, // 9495
  { PseudoVSADD_VI_MF8, VSADD_VI }, // 9496
  { PseudoVSADD_VI_MF8_MASK, VSADD_VI }, // 9497
  { PseudoVSADD_VI_MF8_TU, VSADD_VI }, // 9498
  { PseudoVSADD_VV_M1, VSADD_VV }, // 9499
  { PseudoVSADD_VV_M1_MASK, VSADD_VV }, // 9500
  { PseudoVSADD_VV_M1_TU, VSADD_VV }, // 9501
  { PseudoVSADD_VV_M2, VSADD_VV }, // 9502
  { PseudoVSADD_VV_M2_MASK, VSADD_VV }, // 9503
  { PseudoVSADD_VV_M2_TU, VSADD_VV }, // 9504
  { PseudoVSADD_VV_M4, VSADD_VV }, // 9505
  { PseudoVSADD_VV_M4_MASK, VSADD_VV }, // 9506
  { PseudoVSADD_VV_M4_TU, VSADD_VV }, // 9507
  { PseudoVSADD_VV_M8, VSADD_VV }, // 9508
  { PseudoVSADD_VV_M8_MASK, VSADD_VV }, // 9509
  { PseudoVSADD_VV_M8_TU, VSADD_VV }, // 9510
  { PseudoVSADD_VV_MF2, VSADD_VV }, // 9511
  { PseudoVSADD_VV_MF2_MASK, VSADD_VV }, // 9512
  { PseudoVSADD_VV_MF2_TU, VSADD_VV }, // 9513
  { PseudoVSADD_VV_MF4, VSADD_VV }, // 9514
  { PseudoVSADD_VV_MF4_MASK, VSADD_VV }, // 9515
  { PseudoVSADD_VV_MF4_TU, VSADD_VV }, // 9516
  { PseudoVSADD_VV_MF8, VSADD_VV }, // 9517
  { PseudoVSADD_VV_MF8_MASK, VSADD_VV }, // 9518
  { PseudoVSADD_VV_MF8_TU, VSADD_VV }, // 9519
  { PseudoVSADD_VX_M1, VSADD_VX }, // 9520
  { PseudoVSADD_VX_M1_MASK, VSADD_VX }, // 9521
  { PseudoVSADD_VX_M1_TU, VSADD_VX }, // 9522
  { PseudoVSADD_VX_M2, VSADD_VX }, // 9523
  { PseudoVSADD_VX_M2_MASK, VSADD_VX }, // 9524
  { PseudoVSADD_VX_M2_TU, VSADD_VX }, // 9525
  { PseudoVSADD_VX_M4, VSADD_VX }, // 9526
  { PseudoVSADD_VX_M4_MASK, VSADD_VX }, // 9527
  { PseudoVSADD_VX_M4_TU, VSADD_VX }, // 9528
  { PseudoVSADD_VX_M8, VSADD_VX }, // 9529
  { PseudoVSADD_VX_M8_MASK, VSADD_VX }, // 9530
  { PseudoVSADD_VX_M8_TU, VSADD_VX }, // 9531
  { PseudoVSADD_VX_MF2, VSADD_VX }, // 9532
  { PseudoVSADD_VX_MF2_MASK, VSADD_VX }, // 9533
  { PseudoVSADD_VX_MF2_TU, VSADD_VX }, // 9534
  { PseudoVSADD_VX_MF4, VSADD_VX }, // 9535
  { PseudoVSADD_VX_MF4_MASK, VSADD_VX }, // 9536
  { PseudoVSADD_VX_MF4_TU, VSADD_VX }, // 9537
  { PseudoVSADD_VX_MF8, VSADD_VX }, // 9538
  { PseudoVSADD_VX_MF8_MASK, VSADD_VX }, // 9539
  { PseudoVSADD_VX_MF8_TU, VSADD_VX }, // 9540
  { PseudoVSBC_VVM_M1, VSBC_VVM }, // 9541
  { PseudoVSBC_VVM_M1_TU, VSBC_VVM }, // 9542
  { PseudoVSBC_VVM_M2, VSBC_VVM }, // 9543
  { PseudoVSBC_VVM_M2_TU, VSBC_VVM }, // 9544
  { PseudoVSBC_VVM_M4, VSBC_VVM }, // 9545
  { PseudoVSBC_VVM_M4_TU, VSBC_VVM }, // 9546
  { PseudoVSBC_VVM_M8, VSBC_VVM }, // 9547
  { PseudoVSBC_VVM_M8_TU, VSBC_VVM }, // 9548
  { PseudoVSBC_VVM_MF2, VSBC_VVM }, // 9549
  { PseudoVSBC_VVM_MF2_TU, VSBC_VVM }, // 9550
  { PseudoVSBC_VVM_MF4, VSBC_VVM }, // 9551
  { PseudoVSBC_VVM_MF4_TU, VSBC_VVM }, // 9552
  { PseudoVSBC_VVM_MF8, VSBC_VVM }, // 9553
  { PseudoVSBC_VVM_MF8_TU, VSBC_VVM }, // 9554
  { PseudoVSBC_VXM_M1, VSBC_VXM }, // 9555
  { PseudoVSBC_VXM_M1_TU, VSBC_VXM }, // 9556
  { PseudoVSBC_VXM_M2, VSBC_VXM }, // 9557
  { PseudoVSBC_VXM_M2_TU, VSBC_VXM }, // 9558
  { PseudoVSBC_VXM_M4, VSBC_VXM }, // 9559
  { PseudoVSBC_VXM_M4_TU, VSBC_VXM }, // 9560
  { PseudoVSBC_VXM_M8, VSBC_VXM }, // 9561
  { PseudoVSBC_VXM_M8_TU, VSBC_VXM }, // 9562
  { PseudoVSBC_VXM_MF2, VSBC_VXM }, // 9563
  { PseudoVSBC_VXM_MF2_TU, VSBC_VXM }, // 9564
  { PseudoVSBC_VXM_MF4, VSBC_VXM }, // 9565
  { PseudoVSBC_VXM_MF4_TU, VSBC_VXM }, // 9566
  { PseudoVSBC_VXM_MF8, VSBC_VXM }, // 9567
  { PseudoVSBC_VXM_MF8_TU, VSBC_VXM }, // 9568
  { PseudoVSE16_V_M1, VSE16_V }, // 9569
  { PseudoVSE16_V_M1_MASK, VSE16_V }, // 9570
  { PseudoVSE16_V_M2, VSE16_V }, // 9571
  { PseudoVSE16_V_M2_MASK, VSE16_V }, // 9572
  { PseudoVSE16_V_M4, VSE16_V }, // 9573
  { PseudoVSE16_V_M4_MASK, VSE16_V }, // 9574
  { PseudoVSE16_V_M8, VSE16_V }, // 9575
  { PseudoVSE16_V_M8_MASK, VSE16_V }, // 9576
  { PseudoVSE16_V_MF2, VSE16_V }, // 9577
  { PseudoVSE16_V_MF2_MASK, VSE16_V }, // 9578
  { PseudoVSE16_V_MF4, VSE16_V }, // 9579
  { PseudoVSE16_V_MF4_MASK, VSE16_V }, // 9580
  { PseudoVSE32_V_M1, VSE32_V }, // 9581
  { PseudoVSE32_V_M1_MASK, VSE32_V }, // 9582
  { PseudoVSE32_V_M2, VSE32_V }, // 9583
  { PseudoVSE32_V_M2_MASK, VSE32_V }, // 9584
  { PseudoVSE32_V_M4, VSE32_V }, // 9585
  { PseudoVSE32_V_M4_MASK, VSE32_V }, // 9586
  { PseudoVSE32_V_M8, VSE32_V }, // 9587
  { PseudoVSE32_V_M8_MASK, VSE32_V }, // 9588
  { PseudoVSE32_V_MF2, VSE32_V }, // 9589
  { PseudoVSE32_V_MF2_MASK, VSE32_V }, // 9590
  { PseudoVSE64_V_M1, VSE64_V }, // 9591
  { PseudoVSE64_V_M1_MASK, VSE64_V }, // 9592
  { PseudoVSE64_V_M2, VSE64_V }, // 9593
  { PseudoVSE64_V_M2_MASK, VSE64_V }, // 9594
  { PseudoVSE64_V_M4, VSE64_V }, // 9595
  { PseudoVSE64_V_M4_MASK, VSE64_V }, // 9596
  { PseudoVSE64_V_M8, VSE64_V }, // 9597
  { PseudoVSE64_V_M8_MASK, VSE64_V }, // 9598
  { PseudoVSE8_V_M1, VSE8_V }, // 9599
  { PseudoVSE8_V_M1_MASK, VSE8_V }, // 9600
  { PseudoVSE8_V_M2, VSE8_V }, // 9601
  { PseudoVSE8_V_M2_MASK, VSE8_V }, // 9602
  { PseudoVSE8_V_M4, VSE8_V }, // 9603
  { PseudoVSE8_V_M4_MASK, VSE8_V }, // 9604
  { PseudoVSE8_V_M8, VSE8_V }, // 9605
  { PseudoVSE8_V_M8_MASK, VSE8_V }, // 9606
  { PseudoVSE8_V_MF2, VSE8_V }, // 9607
  { PseudoVSE8_V_MF2_MASK, VSE8_V }, // 9608
  { PseudoVSE8_V_MF4, VSE8_V }, // 9609
  { PseudoVSE8_V_MF4_MASK, VSE8_V }, // 9610
  { PseudoVSE8_V_MF8, VSE8_V }, // 9611
  { PseudoVSE8_V_MF8_MASK, VSE8_V }, // 9612
  { PseudoVSEXT_VF2_M1, VSEXT_VF2 }, // 9613
  { PseudoVSEXT_VF2_M1_MASK, VSEXT_VF2 }, // 9614
  { PseudoVSEXT_VF2_M1_TU, VSEXT_VF2 }, // 9615
  { PseudoVSEXT_VF2_M2, VSEXT_VF2 }, // 9616
  { PseudoVSEXT_VF2_M2_MASK, VSEXT_VF2 }, // 9617
  { PseudoVSEXT_VF2_M2_TU, VSEXT_VF2 }, // 9618
  { PseudoVSEXT_VF2_M4, VSEXT_VF2 }, // 9619
  { PseudoVSEXT_VF2_M4_MASK, VSEXT_VF2 }, // 9620
  { PseudoVSEXT_VF2_M4_TU, VSEXT_VF2 }, // 9621
  { PseudoVSEXT_VF2_M8, VSEXT_VF2 }, // 9622
  { PseudoVSEXT_VF2_M8_MASK, VSEXT_VF2 }, // 9623
  { PseudoVSEXT_VF2_M8_TU, VSEXT_VF2 }, // 9624
  { PseudoVSEXT_VF2_MF2, VSEXT_VF2 }, // 9625
  { PseudoVSEXT_VF2_MF2_MASK, VSEXT_VF2 }, // 9626
  { PseudoVSEXT_VF2_MF2_TU, VSEXT_VF2 }, // 9627
  { PseudoVSEXT_VF2_MF4, VSEXT_VF2 }, // 9628
  { PseudoVSEXT_VF2_MF4_MASK, VSEXT_VF2 }, // 9629
  { PseudoVSEXT_VF2_MF4_TU, VSEXT_VF2 }, // 9630
  { PseudoVSEXT_VF4_M1, VSEXT_VF4 }, // 9631
  { PseudoVSEXT_VF4_M1_MASK, VSEXT_VF4 }, // 9632
  { PseudoVSEXT_VF4_M1_TU, VSEXT_VF4 }, // 9633
  { PseudoVSEXT_VF4_M2, VSEXT_VF4 }, // 9634
  { PseudoVSEXT_VF4_M2_MASK, VSEXT_VF4 }, // 9635
  { PseudoVSEXT_VF4_M2_TU, VSEXT_VF4 }, // 9636
  { PseudoVSEXT_VF4_M4, VSEXT_VF4 }, // 9637
  { PseudoVSEXT_VF4_M4_MASK, VSEXT_VF4 }, // 9638
  { PseudoVSEXT_VF4_M4_TU, VSEXT_VF4 }, // 9639
  { PseudoVSEXT_VF4_M8, VSEXT_VF4 }, // 9640
  { PseudoVSEXT_VF4_M8_MASK, VSEXT_VF4 }, // 9641
  { PseudoVSEXT_VF4_M8_TU, VSEXT_VF4 }, // 9642
  { PseudoVSEXT_VF4_MF2, VSEXT_VF4 }, // 9643
  { PseudoVSEXT_VF4_MF2_MASK, VSEXT_VF4 }, // 9644
  { PseudoVSEXT_VF4_MF2_TU, VSEXT_VF4 }, // 9645
  { PseudoVSEXT_VF8_M1, VSEXT_VF8 }, // 9646
  { PseudoVSEXT_VF8_M1_MASK, VSEXT_VF8 }, // 9647
  { PseudoVSEXT_VF8_M1_TU, VSEXT_VF8 }, // 9648
  { PseudoVSEXT_VF8_M2, VSEXT_VF8 }, // 9649
  { PseudoVSEXT_VF8_M2_MASK, VSEXT_VF8 }, // 9650
  { PseudoVSEXT_VF8_M2_TU, VSEXT_VF8 }, // 9651
  { PseudoVSEXT_VF8_M4, VSEXT_VF8 }, // 9652
  { PseudoVSEXT_VF8_M4_MASK, VSEXT_VF8 }, // 9653
  { PseudoVSEXT_VF8_M4_TU, VSEXT_VF8 }, // 9654
  { PseudoVSEXT_VF8_M8, VSEXT_VF8 }, // 9655
  { PseudoVSEXT_VF8_M8_MASK, VSEXT_VF8 }, // 9656
  { PseudoVSEXT_VF8_M8_TU, VSEXT_VF8 }, // 9657
  { PseudoVSLIDE1DOWN_VX_M1, VSLIDE1DOWN_VX }, // 9658
  { PseudoVSLIDE1DOWN_VX_M1_MASK, VSLIDE1DOWN_VX }, // 9659
  { PseudoVSLIDE1DOWN_VX_M1_TU, VSLIDE1DOWN_VX }, // 9660
  { PseudoVSLIDE1DOWN_VX_M2, VSLIDE1DOWN_VX }, // 9661
  { PseudoVSLIDE1DOWN_VX_M2_MASK, VSLIDE1DOWN_VX }, // 9662
  { PseudoVSLIDE1DOWN_VX_M2_TU, VSLIDE1DOWN_VX }, // 9663
  { PseudoVSLIDE1DOWN_VX_M4, VSLIDE1DOWN_VX }, // 9664
  { PseudoVSLIDE1DOWN_VX_M4_MASK, VSLIDE1DOWN_VX }, // 9665
  { PseudoVSLIDE1DOWN_VX_M4_TU, VSLIDE1DOWN_VX }, // 9666
  { PseudoVSLIDE1DOWN_VX_M8, VSLIDE1DOWN_VX }, // 9667
  { PseudoVSLIDE1DOWN_VX_M8_MASK, VSLIDE1DOWN_VX }, // 9668
  { PseudoVSLIDE1DOWN_VX_M8_TU, VSLIDE1DOWN_VX }, // 9669
  { PseudoVSLIDE1DOWN_VX_MF2, VSLIDE1DOWN_VX }, // 9670
  { PseudoVSLIDE1DOWN_VX_MF2_MASK, VSLIDE1DOWN_VX }, // 9671
  { PseudoVSLIDE1DOWN_VX_MF2_TU, VSLIDE1DOWN_VX }, // 9672
  { PseudoVSLIDE1DOWN_VX_MF4, VSLIDE1DOWN_VX }, // 9673
  { PseudoVSLIDE1DOWN_VX_MF4_MASK, VSLIDE1DOWN_VX }, // 9674
  { PseudoVSLIDE1DOWN_VX_MF4_TU, VSLIDE1DOWN_VX }, // 9675
  { PseudoVSLIDE1DOWN_VX_MF8, VSLIDE1DOWN_VX }, // 9676
  { PseudoVSLIDE1DOWN_VX_MF8_MASK, VSLIDE1DOWN_VX }, // 9677
  { PseudoVSLIDE1DOWN_VX_MF8_TU, VSLIDE1DOWN_VX }, // 9678
  { PseudoVSLIDE1UP_VX_M1, VSLIDE1UP_VX }, // 9679
  { PseudoVSLIDE1UP_VX_M1_MASK, VSLIDE1UP_VX }, // 9680
  { PseudoVSLIDE1UP_VX_M1_TU, VSLIDE1UP_VX }, // 9681
  { PseudoVSLIDE1UP_VX_M2, VSLIDE1UP_VX }, // 9682
  { PseudoVSLIDE1UP_VX_M2_MASK, VSLIDE1UP_VX }, // 9683
  { PseudoVSLIDE1UP_VX_M2_TU, VSLIDE1UP_VX }, // 9684
  { PseudoVSLIDE1UP_VX_M4, VSLIDE1UP_VX }, // 9685
  { PseudoVSLIDE1UP_VX_M4_MASK, VSLIDE1UP_VX }, // 9686
  { PseudoVSLIDE1UP_VX_M4_TU, VSLIDE1UP_VX }, // 9687
  { PseudoVSLIDE1UP_VX_M8, VSLIDE1UP_VX }, // 9688
  { PseudoVSLIDE1UP_VX_M8_MASK, VSLIDE1UP_VX }, // 9689
  { PseudoVSLIDE1UP_VX_M8_TU, VSLIDE1UP_VX }, // 9690
  { PseudoVSLIDE1UP_VX_MF2, VSLIDE1UP_VX }, // 9691
  { PseudoVSLIDE1UP_VX_MF2_MASK, VSLIDE1UP_VX }, // 9692
  { PseudoVSLIDE1UP_VX_MF2_TU, VSLIDE1UP_VX }, // 9693
  { PseudoVSLIDE1UP_VX_MF4, VSLIDE1UP_VX }, // 9694
  { PseudoVSLIDE1UP_VX_MF4_MASK, VSLIDE1UP_VX }, // 9695
  { PseudoVSLIDE1UP_VX_MF4_TU, VSLIDE1UP_VX }, // 9696
  { PseudoVSLIDE1UP_VX_MF8, VSLIDE1UP_VX }, // 9697
  { PseudoVSLIDE1UP_VX_MF8_MASK, VSLIDE1UP_VX }, // 9698
  { PseudoVSLIDE1UP_VX_MF8_TU, VSLIDE1UP_VX }, // 9699
  { PseudoVSLIDEDOWN_VI_M1, VSLIDEDOWN_VI }, // 9700
  { PseudoVSLIDEDOWN_VI_M1_MASK, VSLIDEDOWN_VI }, // 9701
  { PseudoVSLIDEDOWN_VI_M2, VSLIDEDOWN_VI }, // 9702
  { PseudoVSLIDEDOWN_VI_M2_MASK, VSLIDEDOWN_VI }, // 9703
  { PseudoVSLIDEDOWN_VI_M4, VSLIDEDOWN_VI }, // 9704
  { PseudoVSLIDEDOWN_VI_M4_MASK, VSLIDEDOWN_VI }, // 9705
  { PseudoVSLIDEDOWN_VI_M8, VSLIDEDOWN_VI }, // 9706
  { PseudoVSLIDEDOWN_VI_M8_MASK, VSLIDEDOWN_VI }, // 9707
  { PseudoVSLIDEDOWN_VI_MF2, VSLIDEDOWN_VI }, // 9708
  { PseudoVSLIDEDOWN_VI_MF2_MASK, VSLIDEDOWN_VI }, // 9709
  { PseudoVSLIDEDOWN_VI_MF4, VSLIDEDOWN_VI }, // 9710
  { PseudoVSLIDEDOWN_VI_MF4_MASK, VSLIDEDOWN_VI }, // 9711
  { PseudoVSLIDEDOWN_VI_MF8, VSLIDEDOWN_VI }, // 9712
  { PseudoVSLIDEDOWN_VI_MF8_MASK, VSLIDEDOWN_VI }, // 9713
  { PseudoVSLIDEDOWN_VX_M1, VSLIDEDOWN_VX }, // 9714
  { PseudoVSLIDEDOWN_VX_M1_MASK, VSLIDEDOWN_VX }, // 9715
  { PseudoVSLIDEDOWN_VX_M2, VSLIDEDOWN_VX }, // 9716
  { PseudoVSLIDEDOWN_VX_M2_MASK, VSLIDEDOWN_VX }, // 9717
  { PseudoVSLIDEDOWN_VX_M4, VSLIDEDOWN_VX }, // 9718
  { PseudoVSLIDEDOWN_VX_M4_MASK, VSLIDEDOWN_VX }, // 9719
  { PseudoVSLIDEDOWN_VX_M8, VSLIDEDOWN_VX }, // 9720
  { PseudoVSLIDEDOWN_VX_M8_MASK, VSLIDEDOWN_VX }, // 9721
  { PseudoVSLIDEDOWN_VX_MF2, VSLIDEDOWN_VX }, // 9722
  { PseudoVSLIDEDOWN_VX_MF2_MASK, VSLIDEDOWN_VX }, // 9723
  { PseudoVSLIDEDOWN_VX_MF4, VSLIDEDOWN_VX }, // 9724
  { PseudoVSLIDEDOWN_VX_MF4_MASK, VSLIDEDOWN_VX }, // 9725
  { PseudoVSLIDEDOWN_VX_MF8, VSLIDEDOWN_VX }, // 9726
  { PseudoVSLIDEDOWN_VX_MF8_MASK, VSLIDEDOWN_VX }, // 9727
  { PseudoVSLIDEUP_VI_M1, VSLIDEUP_VI }, // 9728
  { PseudoVSLIDEUP_VI_M1_MASK, VSLIDEUP_VI }, // 9729
  { PseudoVSLIDEUP_VI_M2, VSLIDEUP_VI }, // 9730
  { PseudoVSLIDEUP_VI_M2_MASK, VSLIDEUP_VI }, // 9731
  { PseudoVSLIDEUP_VI_M4, VSLIDEUP_VI }, // 9732
  { PseudoVSLIDEUP_VI_M4_MASK, VSLIDEUP_VI }, // 9733
  { PseudoVSLIDEUP_VI_M8, VSLIDEUP_VI }, // 9734
  { PseudoVSLIDEUP_VI_M8_MASK, VSLIDEUP_VI }, // 9735
  { PseudoVSLIDEUP_VI_MF2, VSLIDEUP_VI }, // 9736
  { PseudoVSLIDEUP_VI_MF2_MASK, VSLIDEUP_VI }, // 9737
  { PseudoVSLIDEUP_VI_MF4, VSLIDEUP_VI }, // 9738
  { PseudoVSLIDEUP_VI_MF4_MASK, VSLIDEUP_VI }, // 9739
  { PseudoVSLIDEUP_VI_MF8, VSLIDEUP_VI }, // 9740
  { PseudoVSLIDEUP_VI_MF8_MASK, VSLIDEUP_VI }, // 9741
  { PseudoVSLIDEUP_VX_M1, VSLIDEUP_VX }, // 9742
  { PseudoVSLIDEUP_VX_M1_MASK, VSLIDEUP_VX }, // 9743
  { PseudoVSLIDEUP_VX_M2, VSLIDEUP_VX }, // 9744
  { PseudoVSLIDEUP_VX_M2_MASK, VSLIDEUP_VX }, // 9745
  { PseudoVSLIDEUP_VX_M4, VSLIDEUP_VX }, // 9746
  { PseudoVSLIDEUP_VX_M4_MASK, VSLIDEUP_VX }, // 9747
  { PseudoVSLIDEUP_VX_M8, VSLIDEUP_VX }, // 9748
  { PseudoVSLIDEUP_VX_M8_MASK, VSLIDEUP_VX }, // 9749
  { PseudoVSLIDEUP_VX_MF2, VSLIDEUP_VX }, // 9750
  { PseudoVSLIDEUP_VX_MF2_MASK, VSLIDEUP_VX }, // 9751
  { PseudoVSLIDEUP_VX_MF4, VSLIDEUP_VX }, // 9752
  { PseudoVSLIDEUP_VX_MF4_MASK, VSLIDEUP_VX }, // 9753
  { PseudoVSLIDEUP_VX_MF8, VSLIDEUP_VX }, // 9754
  { PseudoVSLIDEUP_VX_MF8_MASK, VSLIDEUP_VX }, // 9755
  { PseudoVSLL_VI_M1, VSLL_VI }, // 9756
  { PseudoVSLL_VI_M1_MASK, VSLL_VI }, // 9757
  { PseudoVSLL_VI_M1_TU, VSLL_VI }, // 9758
  { PseudoVSLL_VI_M2, VSLL_VI }, // 9759
  { PseudoVSLL_VI_M2_MASK, VSLL_VI }, // 9760
  { PseudoVSLL_VI_M2_TU, VSLL_VI }, // 9761
  { PseudoVSLL_VI_M4, VSLL_VI }, // 9762
  { PseudoVSLL_VI_M4_MASK, VSLL_VI }, // 9763
  { PseudoVSLL_VI_M4_TU, VSLL_VI }, // 9764
  { PseudoVSLL_VI_M8, VSLL_VI }, // 9765
  { PseudoVSLL_VI_M8_MASK, VSLL_VI }, // 9766
  { PseudoVSLL_VI_M8_TU, VSLL_VI }, // 9767
  { PseudoVSLL_VI_MF2, VSLL_VI }, // 9768
  { PseudoVSLL_VI_MF2_MASK, VSLL_VI }, // 9769
  { PseudoVSLL_VI_MF2_TU, VSLL_VI }, // 9770
  { PseudoVSLL_VI_MF4, VSLL_VI }, // 9771
  { PseudoVSLL_VI_MF4_MASK, VSLL_VI }, // 9772
  { PseudoVSLL_VI_MF4_TU, VSLL_VI }, // 9773
  { PseudoVSLL_VI_MF8, VSLL_VI }, // 9774
  { PseudoVSLL_VI_MF8_MASK, VSLL_VI }, // 9775
  { PseudoVSLL_VI_MF8_TU, VSLL_VI }, // 9776
  { PseudoVSLL_VV_M1, VSLL_VV }, // 9777
  { PseudoVSLL_VV_M1_MASK, VSLL_VV }, // 9778
  { PseudoVSLL_VV_M1_TU, VSLL_VV }, // 9779
  { PseudoVSLL_VV_M2, VSLL_VV }, // 9780
  { PseudoVSLL_VV_M2_MASK, VSLL_VV }, // 9781
  { PseudoVSLL_VV_M2_TU, VSLL_VV }, // 9782
  { PseudoVSLL_VV_M4, VSLL_VV }, // 9783
  { PseudoVSLL_VV_M4_MASK, VSLL_VV }, // 9784
  { PseudoVSLL_VV_M4_TU, VSLL_VV }, // 9785
  { PseudoVSLL_VV_M8, VSLL_VV }, // 9786
  { PseudoVSLL_VV_M8_MASK, VSLL_VV }, // 9787
  { PseudoVSLL_VV_M8_TU, VSLL_VV }, // 9788
  { PseudoVSLL_VV_MF2, VSLL_VV }, // 9789
  { PseudoVSLL_VV_MF2_MASK, VSLL_VV }, // 9790
  { PseudoVSLL_VV_MF2_TU, VSLL_VV }, // 9791
  { PseudoVSLL_VV_MF4, VSLL_VV }, // 9792
  { PseudoVSLL_VV_MF4_MASK, VSLL_VV }, // 9793
  { PseudoVSLL_VV_MF4_TU, VSLL_VV }, // 9794
  { PseudoVSLL_VV_MF8, VSLL_VV }, // 9795
  { PseudoVSLL_VV_MF8_MASK, VSLL_VV }, // 9796
  { PseudoVSLL_VV_MF8_TU, VSLL_VV }, // 9797
  { PseudoVSLL_VX_M1, VSLL_VX }, // 9798
  { PseudoVSLL_VX_M1_MASK, VSLL_VX }, // 9799
  { PseudoVSLL_VX_M1_TU, VSLL_VX }, // 9800
  { PseudoVSLL_VX_M2, VSLL_VX }, // 9801
  { PseudoVSLL_VX_M2_MASK, VSLL_VX }, // 9802
  { PseudoVSLL_VX_M2_TU, VSLL_VX }, // 9803
  { PseudoVSLL_VX_M4, VSLL_VX }, // 9804
  { PseudoVSLL_VX_M4_MASK, VSLL_VX }, // 9805
  { PseudoVSLL_VX_M4_TU, VSLL_VX }, // 9806
  { PseudoVSLL_VX_M8, VSLL_VX }, // 9807
  { PseudoVSLL_VX_M8_MASK, VSLL_VX }, // 9808
  { PseudoVSLL_VX_M8_TU, VSLL_VX }, // 9809
  { PseudoVSLL_VX_MF2, VSLL_VX }, // 9810
  { PseudoVSLL_VX_MF2_MASK, VSLL_VX }, // 9811
  { PseudoVSLL_VX_MF2_TU, VSLL_VX }, // 9812
  { PseudoVSLL_VX_MF4, VSLL_VX }, // 9813
  { PseudoVSLL_VX_MF4_MASK, VSLL_VX }, // 9814
  { PseudoVSLL_VX_MF4_TU, VSLL_VX }, // 9815
  { PseudoVSLL_VX_MF8, VSLL_VX }, // 9816
  { PseudoVSLL_VX_MF8_MASK, VSLL_VX }, // 9817
  { PseudoVSLL_VX_MF8_TU, VSLL_VX }, // 9818
  { PseudoVSMUL_VV_M1, VSMUL_VV }, // 9819
  { PseudoVSMUL_VV_M1_MASK, VSMUL_VV }, // 9820
  { PseudoVSMUL_VV_M1_TU, VSMUL_VV }, // 9821
  { PseudoVSMUL_VV_M2, VSMUL_VV }, // 9822
  { PseudoVSMUL_VV_M2_MASK, VSMUL_VV }, // 9823
  { PseudoVSMUL_VV_M2_TU, VSMUL_VV }, // 9824
  { PseudoVSMUL_VV_M4, VSMUL_VV }, // 9825
  { PseudoVSMUL_VV_M4_MASK, VSMUL_VV }, // 9826
  { PseudoVSMUL_VV_M4_TU, VSMUL_VV }, // 9827
  { PseudoVSMUL_VV_M8, VSMUL_VV }, // 9828
  { PseudoVSMUL_VV_M8_MASK, VSMUL_VV }, // 9829
  { PseudoVSMUL_VV_M8_TU, VSMUL_VV }, // 9830
  { PseudoVSMUL_VV_MF2, VSMUL_VV }, // 9831
  { PseudoVSMUL_VV_MF2_MASK, VSMUL_VV }, // 9832
  { PseudoVSMUL_VV_MF2_TU, VSMUL_VV }, // 9833
  { PseudoVSMUL_VV_MF4, VSMUL_VV }, // 9834
  { PseudoVSMUL_VV_MF4_MASK, VSMUL_VV }, // 9835
  { PseudoVSMUL_VV_MF4_TU, VSMUL_VV }, // 9836
  { PseudoVSMUL_VV_MF8, VSMUL_VV }, // 9837
  { PseudoVSMUL_VV_MF8_MASK, VSMUL_VV }, // 9838
  { PseudoVSMUL_VV_MF8_TU, VSMUL_VV }, // 9839
  { PseudoVSMUL_VX_M1, VSMUL_VX }, // 9840
  { PseudoVSMUL_VX_M1_MASK, VSMUL_VX }, // 9841
  { PseudoVSMUL_VX_M1_TU, VSMUL_VX }, // 9842
  { PseudoVSMUL_VX_M2, VSMUL_VX }, // 9843
  { PseudoVSMUL_VX_M2_MASK, VSMUL_VX }, // 9844
  { PseudoVSMUL_VX_M2_TU, VSMUL_VX }, // 9845
  { PseudoVSMUL_VX_M4, VSMUL_VX }, // 9846
  { PseudoVSMUL_VX_M4_MASK, VSMUL_VX }, // 9847
  { PseudoVSMUL_VX_M4_TU, VSMUL_VX }, // 9848
  { PseudoVSMUL_VX_M8, VSMUL_VX }, // 9849
  { PseudoVSMUL_VX_M8_MASK, VSMUL_VX }, // 9850
  { PseudoVSMUL_VX_M8_TU, VSMUL_VX }, // 9851
  { PseudoVSMUL_VX_MF2, VSMUL_VX }, // 9852
  { PseudoVSMUL_VX_MF2_MASK, VSMUL_VX }, // 9853
  { PseudoVSMUL_VX_MF2_TU, VSMUL_VX }, // 9854
  { PseudoVSMUL_VX_MF4, VSMUL_VX }, // 9855
  { PseudoVSMUL_VX_MF4_MASK, VSMUL_VX }, // 9856
  { PseudoVSMUL_VX_MF4_TU, VSMUL_VX }, // 9857
  { PseudoVSMUL_VX_MF8, VSMUL_VX }, // 9858
  { PseudoVSMUL_VX_MF8_MASK, VSMUL_VX }, // 9859
  { PseudoVSMUL_VX_MF8_TU, VSMUL_VX }, // 9860
  { PseudoVSM_V_B1, VSM_V }, // 9861
  { PseudoVSM_V_B16, VSM_V }, // 9862
  { PseudoVSM_V_B2, VSM_V }, // 9863
  { PseudoVSM_V_B32, VSM_V }, // 9864
  { PseudoVSM_V_B4, VSM_V }, // 9865
  { PseudoVSM_V_B64, VSM_V }, // 9866
  { PseudoVSM_V_B8, VSM_V }, // 9867
  { PseudoVSOXEI16_V_M1_M1, VSOXEI16_V }, // 9868
  { PseudoVSOXEI16_V_M1_M1_MASK, VSOXEI16_V }, // 9869
  { PseudoVSOXEI16_V_M1_M2, VSOXEI16_V }, // 9870
  { PseudoVSOXEI16_V_M1_M2_MASK, VSOXEI16_V }, // 9871
  { PseudoVSOXEI16_V_M1_M4, VSOXEI16_V }, // 9872
  { PseudoVSOXEI16_V_M1_M4_MASK, VSOXEI16_V }, // 9873
  { PseudoVSOXEI16_V_M1_MF2, VSOXEI16_V }, // 9874
  { PseudoVSOXEI16_V_M1_MF2_MASK, VSOXEI16_V }, // 9875
  { PseudoVSOXEI16_V_M2_M1, VSOXEI16_V }, // 9876
  { PseudoVSOXEI16_V_M2_M1_MASK, VSOXEI16_V }, // 9877
  { PseudoVSOXEI16_V_M2_M2, VSOXEI16_V }, // 9878
  { PseudoVSOXEI16_V_M2_M2_MASK, VSOXEI16_V }, // 9879
  { PseudoVSOXEI16_V_M2_M4, VSOXEI16_V }, // 9880
  { PseudoVSOXEI16_V_M2_M4_MASK, VSOXEI16_V }, // 9881
  { PseudoVSOXEI16_V_M2_M8, VSOXEI16_V }, // 9882
  { PseudoVSOXEI16_V_M2_M8_MASK, VSOXEI16_V }, // 9883
  { PseudoVSOXEI16_V_M4_M2, VSOXEI16_V }, // 9884
  { PseudoVSOXEI16_V_M4_M2_MASK, VSOXEI16_V }, // 9885
  { PseudoVSOXEI16_V_M4_M4, VSOXEI16_V }, // 9886
  { PseudoVSOXEI16_V_M4_M4_MASK, VSOXEI16_V }, // 9887
  { PseudoVSOXEI16_V_M4_M8, VSOXEI16_V }, // 9888
  { PseudoVSOXEI16_V_M4_M8_MASK, VSOXEI16_V }, // 9889
  { PseudoVSOXEI16_V_M8_M4, VSOXEI16_V }, // 9890
  { PseudoVSOXEI16_V_M8_M4_MASK, VSOXEI16_V }, // 9891
  { PseudoVSOXEI16_V_M8_M8, VSOXEI16_V }, // 9892
  { PseudoVSOXEI16_V_M8_M8_MASK, VSOXEI16_V }, // 9893
  { PseudoVSOXEI16_V_MF2_M1, VSOXEI16_V }, // 9894
  { PseudoVSOXEI16_V_MF2_M1_MASK, VSOXEI16_V }, // 9895
  { PseudoVSOXEI16_V_MF2_M2, VSOXEI16_V }, // 9896
  { PseudoVSOXEI16_V_MF2_M2_MASK, VSOXEI16_V }, // 9897
  { PseudoVSOXEI16_V_MF2_MF2, VSOXEI16_V }, // 9898
  { PseudoVSOXEI16_V_MF2_MF2_MASK, VSOXEI16_V }, // 9899
  { PseudoVSOXEI16_V_MF2_MF4, VSOXEI16_V }, // 9900
  { PseudoVSOXEI16_V_MF2_MF4_MASK, VSOXEI16_V }, // 9901
  { PseudoVSOXEI16_V_MF4_M1, VSOXEI16_V }, // 9902
  { PseudoVSOXEI16_V_MF4_M1_MASK, VSOXEI16_V }, // 9903
  { PseudoVSOXEI16_V_MF4_MF2, VSOXEI16_V }, // 9904
  { PseudoVSOXEI16_V_MF4_MF2_MASK, VSOXEI16_V }, // 9905
  { PseudoVSOXEI16_V_MF4_MF4, VSOXEI16_V }, // 9906
  { PseudoVSOXEI16_V_MF4_MF4_MASK, VSOXEI16_V }, // 9907
  { PseudoVSOXEI16_V_MF4_MF8, VSOXEI16_V }, // 9908
  { PseudoVSOXEI16_V_MF4_MF8_MASK, VSOXEI16_V }, // 9909
  { PseudoVSOXEI32_V_M1_M1, VSOXEI32_V }, // 9910
  { PseudoVSOXEI32_V_M1_M1_MASK, VSOXEI32_V }, // 9911
  { PseudoVSOXEI32_V_M1_M2, VSOXEI32_V }, // 9912
  { PseudoVSOXEI32_V_M1_M2_MASK, VSOXEI32_V }, // 9913
  { PseudoVSOXEI32_V_M1_MF2, VSOXEI32_V }, // 9914
  { PseudoVSOXEI32_V_M1_MF2_MASK, VSOXEI32_V }, // 9915
  { PseudoVSOXEI32_V_M1_MF4, VSOXEI32_V }, // 9916
  { PseudoVSOXEI32_V_M1_MF4_MASK, VSOXEI32_V }, // 9917
  { PseudoVSOXEI32_V_M2_M1, VSOXEI32_V }, // 9918
  { PseudoVSOXEI32_V_M2_M1_MASK, VSOXEI32_V }, // 9919
  { PseudoVSOXEI32_V_M2_M2, VSOXEI32_V }, // 9920
  { PseudoVSOXEI32_V_M2_M2_MASK, VSOXEI32_V }, // 9921
  { PseudoVSOXEI32_V_M2_M4, VSOXEI32_V }, // 9922
  { PseudoVSOXEI32_V_M2_M4_MASK, VSOXEI32_V }, // 9923
  { PseudoVSOXEI32_V_M2_MF2, VSOXEI32_V }, // 9924
  { PseudoVSOXEI32_V_M2_MF2_MASK, VSOXEI32_V }, // 9925
  { PseudoVSOXEI32_V_M4_M1, VSOXEI32_V }, // 9926
  { PseudoVSOXEI32_V_M4_M1_MASK, VSOXEI32_V }, // 9927
  { PseudoVSOXEI32_V_M4_M2, VSOXEI32_V }, // 9928
  { PseudoVSOXEI32_V_M4_M2_MASK, VSOXEI32_V }, // 9929
  { PseudoVSOXEI32_V_M4_M4, VSOXEI32_V }, // 9930
  { PseudoVSOXEI32_V_M4_M4_MASK, VSOXEI32_V }, // 9931
  { PseudoVSOXEI32_V_M4_M8, VSOXEI32_V }, // 9932
  { PseudoVSOXEI32_V_M4_M8_MASK, VSOXEI32_V }, // 9933
  { PseudoVSOXEI32_V_M8_M2, VSOXEI32_V }, // 9934
  { PseudoVSOXEI32_V_M8_M2_MASK, VSOXEI32_V }, // 9935
  { PseudoVSOXEI32_V_M8_M4, VSOXEI32_V }, // 9936
  { PseudoVSOXEI32_V_M8_M4_MASK, VSOXEI32_V }, // 9937
  { PseudoVSOXEI32_V_M8_M8, VSOXEI32_V }, // 9938
  { PseudoVSOXEI32_V_M8_M8_MASK, VSOXEI32_V }, // 9939
  { PseudoVSOXEI32_V_MF2_M1, VSOXEI32_V }, // 9940
  { PseudoVSOXEI32_V_MF2_M1_MASK, VSOXEI32_V }, // 9941
  { PseudoVSOXEI32_V_MF2_MF2, VSOXEI32_V }, // 9942
  { PseudoVSOXEI32_V_MF2_MF2_MASK, VSOXEI32_V }, // 9943
  { PseudoVSOXEI32_V_MF2_MF4, VSOXEI32_V }, // 9944
  { PseudoVSOXEI32_V_MF2_MF4_MASK, VSOXEI32_V }, // 9945
  { PseudoVSOXEI32_V_MF2_MF8, VSOXEI32_V }, // 9946
  { PseudoVSOXEI32_V_MF2_MF8_MASK, VSOXEI32_V }, // 9947
  { PseudoVSOXEI64_V_M1_M1, VSOXEI64_V }, // 9948
  { PseudoVSOXEI64_V_M1_M1_MASK, VSOXEI64_V }, // 9949
  { PseudoVSOXEI64_V_M1_MF2, VSOXEI64_V }, // 9950
  { PseudoVSOXEI64_V_M1_MF2_MASK, VSOXEI64_V }, // 9951
  { PseudoVSOXEI64_V_M1_MF4, VSOXEI64_V }, // 9952
  { PseudoVSOXEI64_V_M1_MF4_MASK, VSOXEI64_V }, // 9953
  { PseudoVSOXEI64_V_M1_MF8, VSOXEI64_V }, // 9954
  { PseudoVSOXEI64_V_M1_MF8_MASK, VSOXEI64_V }, // 9955
  { PseudoVSOXEI64_V_M2_M1, VSOXEI64_V }, // 9956
  { PseudoVSOXEI64_V_M2_M1_MASK, VSOXEI64_V }, // 9957
  { PseudoVSOXEI64_V_M2_M2, VSOXEI64_V }, // 9958
  { PseudoVSOXEI64_V_M2_M2_MASK, VSOXEI64_V }, // 9959
  { PseudoVSOXEI64_V_M2_MF2, VSOXEI64_V }, // 9960
  { PseudoVSOXEI64_V_M2_MF2_MASK, VSOXEI64_V }, // 9961
  { PseudoVSOXEI64_V_M2_MF4, VSOXEI64_V }, // 9962
  { PseudoVSOXEI64_V_M2_MF4_MASK, VSOXEI64_V }, // 9963
  { PseudoVSOXEI64_V_M4_M1, VSOXEI64_V }, // 9964
  { PseudoVSOXEI64_V_M4_M1_MASK, VSOXEI64_V }, // 9965
  { PseudoVSOXEI64_V_M4_M2, VSOXEI64_V }, // 9966
  { PseudoVSOXEI64_V_M4_M2_MASK, VSOXEI64_V }, // 9967
  { PseudoVSOXEI64_V_M4_M4, VSOXEI64_V }, // 9968
  { PseudoVSOXEI64_V_M4_M4_MASK, VSOXEI64_V }, // 9969
  { PseudoVSOXEI64_V_M4_MF2, VSOXEI64_V }, // 9970
  { PseudoVSOXEI64_V_M4_MF2_MASK, VSOXEI64_V }, // 9971
  { PseudoVSOXEI64_V_M8_M1, VSOXEI64_V }, // 9972
  { PseudoVSOXEI64_V_M8_M1_MASK, VSOXEI64_V }, // 9973
  { PseudoVSOXEI64_V_M8_M2, VSOXEI64_V }, // 9974
  { PseudoVSOXEI64_V_M8_M2_MASK, VSOXEI64_V }, // 9975
  { PseudoVSOXEI64_V_M8_M4, VSOXEI64_V }, // 9976
  { PseudoVSOXEI64_V_M8_M4_MASK, VSOXEI64_V }, // 9977
  { PseudoVSOXEI64_V_M8_M8, VSOXEI64_V }, // 9978
  { PseudoVSOXEI64_V_M8_M8_MASK, VSOXEI64_V }, // 9979
  { PseudoVSOXEI8_V_M1_M1, VSOXEI8_V }, // 9980
  { PseudoVSOXEI8_V_M1_M1_MASK, VSOXEI8_V }, // 9981
  { PseudoVSOXEI8_V_M1_M2, VSOXEI8_V }, // 9982
  { PseudoVSOXEI8_V_M1_M2_MASK, VSOXEI8_V }, // 9983
  { PseudoVSOXEI8_V_M1_M4, VSOXEI8_V }, // 9984
  { PseudoVSOXEI8_V_M1_M4_MASK, VSOXEI8_V }, // 9985
  { PseudoVSOXEI8_V_M1_M8, VSOXEI8_V }, // 9986
  { PseudoVSOXEI8_V_M1_M8_MASK, VSOXEI8_V }, // 9987
  { PseudoVSOXEI8_V_M2_M2, VSOXEI8_V }, // 9988
  { PseudoVSOXEI8_V_M2_M2_MASK, VSOXEI8_V }, // 9989
  { PseudoVSOXEI8_V_M2_M4, VSOXEI8_V }, // 9990
  { PseudoVSOXEI8_V_M2_M4_MASK, VSOXEI8_V }, // 9991
  { PseudoVSOXEI8_V_M2_M8, VSOXEI8_V }, // 9992
  { PseudoVSOXEI8_V_M2_M8_MASK, VSOXEI8_V }, // 9993
  { PseudoVSOXEI8_V_M4_M4, VSOXEI8_V }, // 9994
  { PseudoVSOXEI8_V_M4_M4_MASK, VSOXEI8_V }, // 9995
  { PseudoVSOXEI8_V_M4_M8, VSOXEI8_V }, // 9996
  { PseudoVSOXEI8_V_M4_M8_MASK, VSOXEI8_V }, // 9997
  { PseudoVSOXEI8_V_M8_M8, VSOXEI8_V }, // 9998
  { PseudoVSOXEI8_V_M8_M8_MASK, VSOXEI8_V }, // 9999
  { PseudoVSOXEI8_V_MF2_M1, VSOXEI8_V }, // 10000
  { PseudoVSOXEI8_V_MF2_M1_MASK, VSOXEI8_V }, // 10001
  { PseudoVSOXEI8_V_MF2_M2, VSOXEI8_V }, // 10002
  { PseudoVSOXEI8_V_MF2_M2_MASK, VSOXEI8_V }, // 10003
  { PseudoVSOXEI8_V_MF2_M4, VSOXEI8_V }, // 10004
  { PseudoVSOXEI8_V_MF2_M4_MASK, VSOXEI8_V }, // 10005
  { PseudoVSOXEI8_V_MF2_MF2, VSOXEI8_V }, // 10006
  { PseudoVSOXEI8_V_MF2_MF2_MASK, VSOXEI8_V }, // 10007
  { PseudoVSOXEI8_V_MF4_M1, VSOXEI8_V }, // 10008
  { PseudoVSOXEI8_V_MF4_M1_MASK, VSOXEI8_V }, // 10009
  { PseudoVSOXEI8_V_MF4_M2, VSOXEI8_V }, // 10010
  { PseudoVSOXEI8_V_MF4_M2_MASK, VSOXEI8_V }, // 10011
  { PseudoVSOXEI8_V_MF4_MF2, VSOXEI8_V }, // 10012
  { PseudoVSOXEI8_V_MF4_MF2_MASK, VSOXEI8_V }, // 10013
  { PseudoVSOXEI8_V_MF4_MF4, VSOXEI8_V }, // 10014
  { PseudoVSOXEI8_V_MF4_MF4_MASK, VSOXEI8_V }, // 10015
  { PseudoVSOXEI8_V_MF8_M1, VSOXEI8_V }, // 10016
  { PseudoVSOXEI8_V_MF8_M1_MASK, VSOXEI8_V }, // 10017
  { PseudoVSOXEI8_V_MF8_MF2, VSOXEI8_V }, // 10018
  { PseudoVSOXEI8_V_MF8_MF2_MASK, VSOXEI8_V }, // 10019
  { PseudoVSOXEI8_V_MF8_MF4, VSOXEI8_V }, // 10020
  { PseudoVSOXEI8_V_MF8_MF4_MASK, VSOXEI8_V }, // 10021
  { PseudoVSOXEI8_V_MF8_MF8, VSOXEI8_V }, // 10022
  { PseudoVSOXEI8_V_MF8_MF8_MASK, VSOXEI8_V }, // 10023
  { PseudoVSOXSEG2EI16_V_M1_M1, VSOXSEG2EI16_V }, // 10024
  { PseudoVSOXSEG2EI16_V_M1_M1_MASK, VSOXSEG2EI16_V }, // 10025
  { PseudoVSOXSEG2EI16_V_M1_M2, VSOXSEG2EI16_V }, // 10026
  { PseudoVSOXSEG2EI16_V_M1_M2_MASK, VSOXSEG2EI16_V }, // 10027
  { PseudoVSOXSEG2EI16_V_M1_M4, VSOXSEG2EI16_V }, // 10028
  { PseudoVSOXSEG2EI16_V_M1_M4_MASK, VSOXSEG2EI16_V }, // 10029
  { PseudoVSOXSEG2EI16_V_M1_MF2, VSOXSEG2EI16_V }, // 10030
  { PseudoVSOXSEG2EI16_V_M1_MF2_MASK, VSOXSEG2EI16_V }, // 10031
  { PseudoVSOXSEG2EI16_V_M2_M1, VSOXSEG2EI16_V }, // 10032
  { PseudoVSOXSEG2EI16_V_M2_M1_MASK, VSOXSEG2EI16_V }, // 10033
  { PseudoVSOXSEG2EI16_V_M2_M2, VSOXSEG2EI16_V }, // 10034
  { PseudoVSOXSEG2EI16_V_M2_M2_MASK, VSOXSEG2EI16_V }, // 10035
  { PseudoVSOXSEG2EI16_V_M2_M4, VSOXSEG2EI16_V }, // 10036
  { PseudoVSOXSEG2EI16_V_M2_M4_MASK, VSOXSEG2EI16_V }, // 10037
  { PseudoVSOXSEG2EI16_V_M4_M2, VSOXSEG2EI16_V }, // 10038
  { PseudoVSOXSEG2EI16_V_M4_M2_MASK, VSOXSEG2EI16_V }, // 10039
  { PseudoVSOXSEG2EI16_V_M4_M4, VSOXSEG2EI16_V }, // 10040
  { PseudoVSOXSEG2EI16_V_M4_M4_MASK, VSOXSEG2EI16_V }, // 10041
  { PseudoVSOXSEG2EI16_V_M8_M4, VSOXSEG2EI16_V }, // 10042
  { PseudoVSOXSEG2EI16_V_M8_M4_MASK, VSOXSEG2EI16_V }, // 10043
  { PseudoVSOXSEG2EI16_V_MF2_M1, VSOXSEG2EI16_V }, // 10044
  { PseudoVSOXSEG2EI16_V_MF2_M1_MASK, VSOXSEG2EI16_V }, // 10045
  { PseudoVSOXSEG2EI16_V_MF2_M2, VSOXSEG2EI16_V }, // 10046
  { PseudoVSOXSEG2EI16_V_MF2_M2_MASK, VSOXSEG2EI16_V }, // 10047
  { PseudoVSOXSEG2EI16_V_MF2_MF2, VSOXSEG2EI16_V }, // 10048
  { PseudoVSOXSEG2EI16_V_MF2_MF2_MASK, VSOXSEG2EI16_V }, // 10049
  { PseudoVSOXSEG2EI16_V_MF2_MF4, VSOXSEG2EI16_V }, // 10050
  { PseudoVSOXSEG2EI16_V_MF2_MF4_MASK, VSOXSEG2EI16_V }, // 10051
  { PseudoVSOXSEG2EI16_V_MF4_M1, VSOXSEG2EI16_V }, // 10052
  { PseudoVSOXSEG2EI16_V_MF4_M1_MASK, VSOXSEG2EI16_V }, // 10053
  { PseudoVSOXSEG2EI16_V_MF4_MF2, VSOXSEG2EI16_V }, // 10054
  { PseudoVSOXSEG2EI16_V_MF4_MF2_MASK, VSOXSEG2EI16_V }, // 10055
  { PseudoVSOXSEG2EI16_V_MF4_MF4, VSOXSEG2EI16_V }, // 10056
  { PseudoVSOXSEG2EI16_V_MF4_MF4_MASK, VSOXSEG2EI16_V }, // 10057
  { PseudoVSOXSEG2EI16_V_MF4_MF8, VSOXSEG2EI16_V }, // 10058
  { PseudoVSOXSEG2EI16_V_MF4_MF8_MASK, VSOXSEG2EI16_V }, // 10059
  { PseudoVSOXSEG2EI32_V_M1_M1, VSOXSEG2EI32_V }, // 10060
  { PseudoVSOXSEG2EI32_V_M1_M1_MASK, VSOXSEG2EI32_V }, // 10061
  { PseudoVSOXSEG2EI32_V_M1_M2, VSOXSEG2EI32_V }, // 10062
  { PseudoVSOXSEG2EI32_V_M1_M2_MASK, VSOXSEG2EI32_V }, // 10063
  { PseudoVSOXSEG2EI32_V_M1_MF2, VSOXSEG2EI32_V }, // 10064
  { PseudoVSOXSEG2EI32_V_M1_MF2_MASK, VSOXSEG2EI32_V }, // 10065
  { PseudoVSOXSEG2EI32_V_M1_MF4, VSOXSEG2EI32_V }, // 10066
  { PseudoVSOXSEG2EI32_V_M1_MF4_MASK, VSOXSEG2EI32_V }, // 10067
  { PseudoVSOXSEG2EI32_V_M2_M1, VSOXSEG2EI32_V }, // 10068
  { PseudoVSOXSEG2EI32_V_M2_M1_MASK, VSOXSEG2EI32_V }, // 10069
  { PseudoVSOXSEG2EI32_V_M2_M2, VSOXSEG2EI32_V }, // 10070
  { PseudoVSOXSEG2EI32_V_M2_M2_MASK, VSOXSEG2EI32_V }, // 10071
  { PseudoVSOXSEG2EI32_V_M2_M4, VSOXSEG2EI32_V }, // 10072
  { PseudoVSOXSEG2EI32_V_M2_M4_MASK, VSOXSEG2EI32_V }, // 10073
  { PseudoVSOXSEG2EI32_V_M2_MF2, VSOXSEG2EI32_V }, // 10074
  { PseudoVSOXSEG2EI32_V_M2_MF2_MASK, VSOXSEG2EI32_V }, // 10075
  { PseudoVSOXSEG2EI32_V_M4_M1, VSOXSEG2EI32_V }, // 10076
  { PseudoVSOXSEG2EI32_V_M4_M1_MASK, VSOXSEG2EI32_V }, // 10077
  { PseudoVSOXSEG2EI32_V_M4_M2, VSOXSEG2EI32_V }, // 10078
  { PseudoVSOXSEG2EI32_V_M4_M2_MASK, VSOXSEG2EI32_V }, // 10079
  { PseudoVSOXSEG2EI32_V_M4_M4, VSOXSEG2EI32_V }, // 10080
  { PseudoVSOXSEG2EI32_V_M4_M4_MASK, VSOXSEG2EI32_V }, // 10081
  { PseudoVSOXSEG2EI32_V_M8_M2, VSOXSEG2EI32_V }, // 10082
  { PseudoVSOXSEG2EI32_V_M8_M2_MASK, VSOXSEG2EI32_V }, // 10083
  { PseudoVSOXSEG2EI32_V_M8_M4, VSOXSEG2EI32_V }, // 10084
  { PseudoVSOXSEG2EI32_V_M8_M4_MASK, VSOXSEG2EI32_V }, // 10085
  { PseudoVSOXSEG2EI32_V_MF2_M1, VSOXSEG2EI32_V }, // 10086
  { PseudoVSOXSEG2EI32_V_MF2_M1_MASK, VSOXSEG2EI32_V }, // 10087
  { PseudoVSOXSEG2EI32_V_MF2_MF2, VSOXSEG2EI32_V }, // 10088
  { PseudoVSOXSEG2EI32_V_MF2_MF2_MASK, VSOXSEG2EI32_V }, // 10089
  { PseudoVSOXSEG2EI32_V_MF2_MF4, VSOXSEG2EI32_V }, // 10090
  { PseudoVSOXSEG2EI32_V_MF2_MF4_MASK, VSOXSEG2EI32_V }, // 10091
  { PseudoVSOXSEG2EI32_V_MF2_MF8, VSOXSEG2EI32_V }, // 10092
  { PseudoVSOXSEG2EI32_V_MF2_MF8_MASK, VSOXSEG2EI32_V }, // 10093
  { PseudoVSOXSEG2EI64_V_M1_M1, VSOXSEG2EI64_V }, // 10094
  { PseudoVSOXSEG2EI64_V_M1_M1_MASK, VSOXSEG2EI64_V }, // 10095
  { PseudoVSOXSEG2EI64_V_M1_MF2, VSOXSEG2EI64_V }, // 10096
  { PseudoVSOXSEG2EI64_V_M1_MF2_MASK, VSOXSEG2EI64_V }, // 10097
  { PseudoVSOXSEG2EI64_V_M1_MF4, VSOXSEG2EI64_V }, // 10098
  { PseudoVSOXSEG2EI64_V_M1_MF4_MASK, VSOXSEG2EI64_V }, // 10099
  { PseudoVSOXSEG2EI64_V_M1_MF8, VSOXSEG2EI64_V }, // 10100
  { PseudoVSOXSEG2EI64_V_M1_MF8_MASK, VSOXSEG2EI64_V }, // 10101
  { PseudoVSOXSEG2EI64_V_M2_M1, VSOXSEG2EI64_V }, // 10102
  { PseudoVSOXSEG2EI64_V_M2_M1_MASK, VSOXSEG2EI64_V }, // 10103
  { PseudoVSOXSEG2EI64_V_M2_M2, VSOXSEG2EI64_V }, // 10104
  { PseudoVSOXSEG2EI64_V_M2_M2_MASK, VSOXSEG2EI64_V }, // 10105
  { PseudoVSOXSEG2EI64_V_M2_MF2, VSOXSEG2EI64_V }, // 10106
  { PseudoVSOXSEG2EI64_V_M2_MF2_MASK, VSOXSEG2EI64_V }, // 10107
  { PseudoVSOXSEG2EI64_V_M2_MF4, VSOXSEG2EI64_V }, // 10108
  { PseudoVSOXSEG2EI64_V_M2_MF4_MASK, VSOXSEG2EI64_V }, // 10109
  { PseudoVSOXSEG2EI64_V_M4_M1, VSOXSEG2EI64_V }, // 10110
  { PseudoVSOXSEG2EI64_V_M4_M1_MASK, VSOXSEG2EI64_V }, // 10111
  { PseudoVSOXSEG2EI64_V_M4_M2, VSOXSEG2EI64_V }, // 10112
  { PseudoVSOXSEG2EI64_V_M4_M2_MASK, VSOXSEG2EI64_V }, // 10113
  { PseudoVSOXSEG2EI64_V_M4_M4, VSOXSEG2EI64_V }, // 10114
  { PseudoVSOXSEG2EI64_V_M4_M4_MASK, VSOXSEG2EI64_V }, // 10115
  { PseudoVSOXSEG2EI64_V_M4_MF2, VSOXSEG2EI64_V }, // 10116
  { PseudoVSOXSEG2EI64_V_M4_MF2_MASK, VSOXSEG2EI64_V }, // 10117
  { PseudoVSOXSEG2EI64_V_M8_M1, VSOXSEG2EI64_V }, // 10118
  { PseudoVSOXSEG2EI64_V_M8_M1_MASK, VSOXSEG2EI64_V }, // 10119
  { PseudoVSOXSEG2EI64_V_M8_M2, VSOXSEG2EI64_V }, // 10120
  { PseudoVSOXSEG2EI64_V_M8_M2_MASK, VSOXSEG2EI64_V }, // 10121
  { PseudoVSOXSEG2EI64_V_M8_M4, VSOXSEG2EI64_V }, // 10122
  { PseudoVSOXSEG2EI64_V_M8_M4_MASK, VSOXSEG2EI64_V }, // 10123
  { PseudoVSOXSEG2EI8_V_M1_M1, VSOXSEG2EI8_V }, // 10124
  { PseudoVSOXSEG2EI8_V_M1_M1_MASK, VSOXSEG2EI8_V }, // 10125
  { PseudoVSOXSEG2EI8_V_M1_M2, VSOXSEG2EI8_V }, // 10126
  { PseudoVSOXSEG2EI8_V_M1_M2_MASK, VSOXSEG2EI8_V }, // 10127
  { PseudoVSOXSEG2EI8_V_M1_M4, VSOXSEG2EI8_V }, // 10128
  { PseudoVSOXSEG2EI8_V_M1_M4_MASK, VSOXSEG2EI8_V }, // 10129
  { PseudoVSOXSEG2EI8_V_M2_M2, VSOXSEG2EI8_V }, // 10130
  { PseudoVSOXSEG2EI8_V_M2_M2_MASK, VSOXSEG2EI8_V }, // 10131
  { PseudoVSOXSEG2EI8_V_M2_M4, VSOXSEG2EI8_V }, // 10132
  { PseudoVSOXSEG2EI8_V_M2_M4_MASK, VSOXSEG2EI8_V }, // 10133
  { PseudoVSOXSEG2EI8_V_M4_M4, VSOXSEG2EI8_V }, // 10134
  { PseudoVSOXSEG2EI8_V_M4_M4_MASK, VSOXSEG2EI8_V }, // 10135
  { PseudoVSOXSEG2EI8_V_MF2_M1, VSOXSEG2EI8_V }, // 10136
  { PseudoVSOXSEG2EI8_V_MF2_M1_MASK, VSOXSEG2EI8_V }, // 10137
  { PseudoVSOXSEG2EI8_V_MF2_M2, VSOXSEG2EI8_V }, // 10138
  { PseudoVSOXSEG2EI8_V_MF2_M2_MASK, VSOXSEG2EI8_V }, // 10139
  { PseudoVSOXSEG2EI8_V_MF2_M4, VSOXSEG2EI8_V }, // 10140
  { PseudoVSOXSEG2EI8_V_MF2_M4_MASK, VSOXSEG2EI8_V }, // 10141
  { PseudoVSOXSEG2EI8_V_MF2_MF2, VSOXSEG2EI8_V }, // 10142
  { PseudoVSOXSEG2EI8_V_MF2_MF2_MASK, VSOXSEG2EI8_V }, // 10143
  { PseudoVSOXSEG2EI8_V_MF4_M1, VSOXSEG2EI8_V }, // 10144
  { PseudoVSOXSEG2EI8_V_MF4_M1_MASK, VSOXSEG2EI8_V }, // 10145
  { PseudoVSOXSEG2EI8_V_MF4_M2, VSOXSEG2EI8_V }, // 10146
  { PseudoVSOXSEG2EI8_V_MF4_M2_MASK, VSOXSEG2EI8_V }, // 10147
  { PseudoVSOXSEG2EI8_V_MF4_MF2, VSOXSEG2EI8_V }, // 10148
  { PseudoVSOXSEG2EI8_V_MF4_MF2_MASK, VSOXSEG2EI8_V }, // 10149
  { PseudoVSOXSEG2EI8_V_MF4_MF4, VSOXSEG2EI8_V }, // 10150
  { PseudoVSOXSEG2EI8_V_MF4_MF4_MASK, VSOXSEG2EI8_V }, // 10151
  { PseudoVSOXSEG2EI8_V_MF8_M1, VSOXSEG2EI8_V }, // 10152
  { PseudoVSOXSEG2EI8_V_MF8_M1_MASK, VSOXSEG2EI8_V }, // 10153
  { PseudoVSOXSEG2EI8_V_MF8_MF2, VSOXSEG2EI8_V }, // 10154
  { PseudoVSOXSEG2EI8_V_MF8_MF2_MASK, VSOXSEG2EI8_V }, // 10155
  { PseudoVSOXSEG2EI8_V_MF8_MF4, VSOXSEG2EI8_V }, // 10156
  { PseudoVSOXSEG2EI8_V_MF8_MF4_MASK, VSOXSEG2EI8_V }, // 10157
  { PseudoVSOXSEG2EI8_V_MF8_MF8, VSOXSEG2EI8_V }, // 10158
  { PseudoVSOXSEG2EI8_V_MF8_MF8_MASK, VSOXSEG2EI8_V }, // 10159
  { PseudoVSOXSEG3EI16_V_M1_M1, VSOXSEG3EI16_V }, // 10160
  { PseudoVSOXSEG3EI16_V_M1_M1_MASK, VSOXSEG3EI16_V }, // 10161
  { PseudoVSOXSEG3EI16_V_M1_M2, VSOXSEG3EI16_V }, // 10162
  { PseudoVSOXSEG3EI16_V_M1_M2_MASK, VSOXSEG3EI16_V }, // 10163
  { PseudoVSOXSEG3EI16_V_M1_MF2, VSOXSEG3EI16_V }, // 10164
  { PseudoVSOXSEG3EI16_V_M1_MF2_MASK, VSOXSEG3EI16_V }, // 10165
  { PseudoVSOXSEG3EI16_V_M2_M1, VSOXSEG3EI16_V }, // 10166
  { PseudoVSOXSEG3EI16_V_M2_M1_MASK, VSOXSEG3EI16_V }, // 10167
  { PseudoVSOXSEG3EI16_V_M2_M2, VSOXSEG3EI16_V }, // 10168
  { PseudoVSOXSEG3EI16_V_M2_M2_MASK, VSOXSEG3EI16_V }, // 10169
  { PseudoVSOXSEG3EI16_V_M4_M2, VSOXSEG3EI16_V }, // 10170
  { PseudoVSOXSEG3EI16_V_M4_M2_MASK, VSOXSEG3EI16_V }, // 10171
  { PseudoVSOXSEG3EI16_V_MF2_M1, VSOXSEG3EI16_V }, // 10172
  { PseudoVSOXSEG3EI16_V_MF2_M1_MASK, VSOXSEG3EI16_V }, // 10173
  { PseudoVSOXSEG3EI16_V_MF2_M2, VSOXSEG3EI16_V }, // 10174
  { PseudoVSOXSEG3EI16_V_MF2_M2_MASK, VSOXSEG3EI16_V }, // 10175
  { PseudoVSOXSEG3EI16_V_MF2_MF2, VSOXSEG3EI16_V }, // 10176
  { PseudoVSOXSEG3EI16_V_MF2_MF2_MASK, VSOXSEG3EI16_V }, // 10177
  { PseudoVSOXSEG3EI16_V_MF2_MF4, VSOXSEG3EI16_V }, // 10178
  { PseudoVSOXSEG3EI16_V_MF2_MF4_MASK, VSOXSEG3EI16_V }, // 10179
  { PseudoVSOXSEG3EI16_V_MF4_M1, VSOXSEG3EI16_V }, // 10180
  { PseudoVSOXSEG3EI16_V_MF4_M1_MASK, VSOXSEG3EI16_V }, // 10181
  { PseudoVSOXSEG3EI16_V_MF4_MF2, VSOXSEG3EI16_V }, // 10182
  { PseudoVSOXSEG3EI16_V_MF4_MF2_MASK, VSOXSEG3EI16_V }, // 10183
  { PseudoVSOXSEG3EI16_V_MF4_MF4, VSOXSEG3EI16_V }, // 10184
  { PseudoVSOXSEG3EI16_V_MF4_MF4_MASK, VSOXSEG3EI16_V }, // 10185
  { PseudoVSOXSEG3EI16_V_MF4_MF8, VSOXSEG3EI16_V }, // 10186
  { PseudoVSOXSEG3EI16_V_MF4_MF8_MASK, VSOXSEG3EI16_V }, // 10187
  { PseudoVSOXSEG3EI32_V_M1_M1, VSOXSEG3EI32_V }, // 10188
  { PseudoVSOXSEG3EI32_V_M1_M1_MASK, VSOXSEG3EI32_V }, // 10189
  { PseudoVSOXSEG3EI32_V_M1_M2, VSOXSEG3EI32_V }, // 10190
  { PseudoVSOXSEG3EI32_V_M1_M2_MASK, VSOXSEG3EI32_V }, // 10191
  { PseudoVSOXSEG3EI32_V_M1_MF2, VSOXSEG3EI32_V }, // 10192
  { PseudoVSOXSEG3EI32_V_M1_MF2_MASK, VSOXSEG3EI32_V }, // 10193
  { PseudoVSOXSEG3EI32_V_M1_MF4, VSOXSEG3EI32_V }, // 10194
  { PseudoVSOXSEG3EI32_V_M1_MF4_MASK, VSOXSEG3EI32_V }, // 10195
  { PseudoVSOXSEG3EI32_V_M2_M1, VSOXSEG3EI32_V }, // 10196
  { PseudoVSOXSEG3EI32_V_M2_M1_MASK, VSOXSEG3EI32_V }, // 10197
  { PseudoVSOXSEG3EI32_V_M2_M2, VSOXSEG3EI32_V }, // 10198
  { PseudoVSOXSEG3EI32_V_M2_M2_MASK, VSOXSEG3EI32_V }, // 10199
  { PseudoVSOXSEG3EI32_V_M2_MF2, VSOXSEG3EI32_V }, // 10200
  { PseudoVSOXSEG3EI32_V_M2_MF2_MASK, VSOXSEG3EI32_V }, // 10201
  { PseudoVSOXSEG3EI32_V_M4_M1, VSOXSEG3EI32_V }, // 10202
  { PseudoVSOXSEG3EI32_V_M4_M1_MASK, VSOXSEG3EI32_V }, // 10203
  { PseudoVSOXSEG3EI32_V_M4_M2, VSOXSEG3EI32_V }, // 10204
  { PseudoVSOXSEG3EI32_V_M4_M2_MASK, VSOXSEG3EI32_V }, // 10205
  { PseudoVSOXSEG3EI32_V_M8_M2, VSOXSEG3EI32_V }, // 10206
  { PseudoVSOXSEG3EI32_V_M8_M2_MASK, VSOXSEG3EI32_V }, // 10207
  { PseudoVSOXSEG3EI32_V_MF2_M1, VSOXSEG3EI32_V }, // 10208
  { PseudoVSOXSEG3EI32_V_MF2_M1_MASK, VSOXSEG3EI32_V }, // 10209
  { PseudoVSOXSEG3EI32_V_MF2_MF2, VSOXSEG3EI32_V }, // 10210
  { PseudoVSOXSEG3EI32_V_MF2_MF2_MASK, VSOXSEG3EI32_V }, // 10211
  { PseudoVSOXSEG3EI32_V_MF2_MF4, VSOXSEG3EI32_V }, // 10212
  { PseudoVSOXSEG3EI32_V_MF2_MF4_MASK, VSOXSEG3EI32_V }, // 10213
  { PseudoVSOXSEG3EI32_V_MF2_MF8, VSOXSEG3EI32_V }, // 10214
  { PseudoVSOXSEG3EI32_V_MF2_MF8_MASK, VSOXSEG3EI32_V }, // 10215
  { PseudoVSOXSEG3EI64_V_M1_M1, VSOXSEG3EI64_V }, // 10216
  { PseudoVSOXSEG3EI64_V_M1_M1_MASK, VSOXSEG3EI64_V }, // 10217
  { PseudoVSOXSEG3EI64_V_M1_MF2, VSOXSEG3EI64_V }, // 10218
  { PseudoVSOXSEG3EI64_V_M1_MF2_MASK, VSOXSEG3EI64_V }, // 10219
  { PseudoVSOXSEG3EI64_V_M1_MF4, VSOXSEG3EI64_V }, // 10220
  { PseudoVSOXSEG3EI64_V_M1_MF4_MASK, VSOXSEG3EI64_V }, // 10221
  { PseudoVSOXSEG3EI64_V_M1_MF8, VSOXSEG3EI64_V }, // 10222
  { PseudoVSOXSEG3EI64_V_M1_MF8_MASK, VSOXSEG3EI64_V }, // 10223
  { PseudoVSOXSEG3EI64_V_M2_M1, VSOXSEG3EI64_V }, // 10224
  { PseudoVSOXSEG3EI64_V_M2_M1_MASK, VSOXSEG3EI64_V }, // 10225
  { PseudoVSOXSEG3EI64_V_M2_M2, VSOXSEG3EI64_V }, // 10226
  { PseudoVSOXSEG3EI64_V_M2_M2_MASK, VSOXSEG3EI64_V }, // 10227
  { PseudoVSOXSEG3EI64_V_M2_MF2, VSOXSEG3EI64_V }, // 10228
  { PseudoVSOXSEG3EI64_V_M2_MF2_MASK, VSOXSEG3EI64_V }, // 10229
  { PseudoVSOXSEG3EI64_V_M2_MF4, VSOXSEG3EI64_V }, // 10230
  { PseudoVSOXSEG3EI64_V_M2_MF4_MASK, VSOXSEG3EI64_V }, // 10231
  { PseudoVSOXSEG3EI64_V_M4_M1, VSOXSEG3EI64_V }, // 10232
  { PseudoVSOXSEG3EI64_V_M4_M1_MASK, VSOXSEG3EI64_V }, // 10233
  { PseudoVSOXSEG3EI64_V_M4_M2, VSOXSEG3EI64_V }, // 10234
  { PseudoVSOXSEG3EI64_V_M4_M2_MASK, VSOXSEG3EI64_V }, // 10235
  { PseudoVSOXSEG3EI64_V_M4_MF2, VSOXSEG3EI64_V }, // 10236
  { PseudoVSOXSEG3EI64_V_M4_MF2_MASK, VSOXSEG3EI64_V }, // 10237
  { PseudoVSOXSEG3EI64_V_M8_M1, VSOXSEG3EI64_V }, // 10238
  { PseudoVSOXSEG3EI64_V_M8_M1_MASK, VSOXSEG3EI64_V }, // 10239
  { PseudoVSOXSEG3EI64_V_M8_M2, VSOXSEG3EI64_V }, // 10240
  { PseudoVSOXSEG3EI64_V_M8_M2_MASK, VSOXSEG3EI64_V }, // 10241
  { PseudoVSOXSEG3EI8_V_M1_M1, VSOXSEG3EI8_V }, // 10242
  { PseudoVSOXSEG3EI8_V_M1_M1_MASK, VSOXSEG3EI8_V }, // 10243
  { PseudoVSOXSEG3EI8_V_M1_M2, VSOXSEG3EI8_V }, // 10244
  { PseudoVSOXSEG3EI8_V_M1_M2_MASK, VSOXSEG3EI8_V }, // 10245
  { PseudoVSOXSEG3EI8_V_M2_M2, VSOXSEG3EI8_V }, // 10246
  { PseudoVSOXSEG3EI8_V_M2_M2_MASK, VSOXSEG3EI8_V }, // 10247
  { PseudoVSOXSEG3EI8_V_MF2_M1, VSOXSEG3EI8_V }, // 10248
  { PseudoVSOXSEG3EI8_V_MF2_M1_MASK, VSOXSEG3EI8_V }, // 10249
  { PseudoVSOXSEG3EI8_V_MF2_M2, VSOXSEG3EI8_V }, // 10250
  { PseudoVSOXSEG3EI8_V_MF2_M2_MASK, VSOXSEG3EI8_V }, // 10251
  { PseudoVSOXSEG3EI8_V_MF2_MF2, VSOXSEG3EI8_V }, // 10252
  { PseudoVSOXSEG3EI8_V_MF2_MF2_MASK, VSOXSEG3EI8_V }, // 10253
  { PseudoVSOXSEG3EI8_V_MF4_M1, VSOXSEG3EI8_V }, // 10254
  { PseudoVSOXSEG3EI8_V_MF4_M1_MASK, VSOXSEG3EI8_V }, // 10255
  { PseudoVSOXSEG3EI8_V_MF4_M2, VSOXSEG3EI8_V }, // 10256
  { PseudoVSOXSEG3EI8_V_MF4_M2_MASK, VSOXSEG3EI8_V }, // 10257
  { PseudoVSOXSEG3EI8_V_MF4_MF2, VSOXSEG3EI8_V }, // 10258
  { PseudoVSOXSEG3EI8_V_MF4_MF2_MASK, VSOXSEG3EI8_V }, // 10259
  { PseudoVSOXSEG3EI8_V_MF4_MF4, VSOXSEG3EI8_V }, // 10260
  { PseudoVSOXSEG3EI8_V_MF4_MF4_MASK, VSOXSEG3EI8_V }, // 10261
  { PseudoVSOXSEG3EI8_V_MF8_M1, VSOXSEG3EI8_V }, // 10262
  { PseudoVSOXSEG3EI8_V_MF8_M1_MASK, VSOXSEG3EI8_V }, // 10263
  { PseudoVSOXSEG3EI8_V_MF8_MF2, VSOXSEG3EI8_V }, // 10264
  { PseudoVSOXSEG3EI8_V_MF8_MF2_MASK, VSOXSEG3EI8_V }, // 10265
  { PseudoVSOXSEG3EI8_V_MF8_MF4, VSOXSEG3EI8_V }, // 10266
  { PseudoVSOXSEG3EI8_V_MF8_MF4_MASK, VSOXSEG3EI8_V }, // 10267
  { PseudoVSOXSEG3EI8_V_MF8_MF8, VSOXSEG3EI8_V }, // 10268
  { PseudoVSOXSEG3EI8_V_MF8_MF8_MASK, VSOXSEG3EI8_V }, // 10269
  { PseudoVSOXSEG4EI16_V_M1_M1, VSOXSEG4EI16_V }, // 10270
  { PseudoVSOXSEG4EI16_V_M1_M1_MASK, VSOXSEG4EI16_V }, // 10271
  { PseudoVSOXSEG4EI16_V_M1_M2, VSOXSEG4EI16_V }, // 10272
  { PseudoVSOXSEG4EI16_V_M1_M2_MASK, VSOXSEG4EI16_V }, // 10273
  { PseudoVSOXSEG4EI16_V_M1_MF2, VSOXSEG4EI16_V }, // 10274
  { PseudoVSOXSEG4EI16_V_M1_MF2_MASK, VSOXSEG4EI16_V }, // 10275
  { PseudoVSOXSEG4EI16_V_M2_M1, VSOXSEG4EI16_V }, // 10276
  { PseudoVSOXSEG4EI16_V_M2_M1_MASK, VSOXSEG4EI16_V }, // 10277
  { PseudoVSOXSEG4EI16_V_M2_M2, VSOXSEG4EI16_V }, // 10278
  { PseudoVSOXSEG4EI16_V_M2_M2_MASK, VSOXSEG4EI16_V }, // 10279
  { PseudoVSOXSEG4EI16_V_M4_M2, VSOXSEG4EI16_V }, // 10280
  { PseudoVSOXSEG4EI16_V_M4_M2_MASK, VSOXSEG4EI16_V }, // 10281
  { PseudoVSOXSEG4EI16_V_MF2_M1, VSOXSEG4EI16_V }, // 10282
  { PseudoVSOXSEG4EI16_V_MF2_M1_MASK, VSOXSEG4EI16_V }, // 10283
  { PseudoVSOXSEG4EI16_V_MF2_M2, VSOXSEG4EI16_V }, // 10284
  { PseudoVSOXSEG4EI16_V_MF2_M2_MASK, VSOXSEG4EI16_V }, // 10285
  { PseudoVSOXSEG4EI16_V_MF2_MF2, VSOXSEG4EI16_V }, // 10286
  { PseudoVSOXSEG4EI16_V_MF2_MF2_MASK, VSOXSEG4EI16_V }, // 10287
  { PseudoVSOXSEG4EI16_V_MF2_MF4, VSOXSEG4EI16_V }, // 10288
  { PseudoVSOXSEG4EI16_V_MF2_MF4_MASK, VSOXSEG4EI16_V }, // 10289
  { PseudoVSOXSEG4EI16_V_MF4_M1, VSOXSEG4EI16_V }, // 10290
  { PseudoVSOXSEG4EI16_V_MF4_M1_MASK, VSOXSEG4EI16_V }, // 10291
  { PseudoVSOXSEG4EI16_V_MF4_MF2, VSOXSEG4EI16_V }, // 10292
  { PseudoVSOXSEG4EI16_V_MF4_MF2_MASK, VSOXSEG4EI16_V }, // 10293
  { PseudoVSOXSEG4EI16_V_MF4_MF4, VSOXSEG4EI16_V }, // 10294
  { PseudoVSOXSEG4EI16_V_MF4_MF4_MASK, VSOXSEG4EI16_V }, // 10295
  { PseudoVSOXSEG4EI16_V_MF4_MF8, VSOXSEG4EI16_V }, // 10296
  { PseudoVSOXSEG4EI16_V_MF4_MF8_MASK, VSOXSEG4EI16_V }, // 10297
  { PseudoVSOXSEG4EI32_V_M1_M1, VSOXSEG4EI32_V }, // 10298
  { PseudoVSOXSEG4EI32_V_M1_M1_MASK, VSOXSEG4EI32_V }, // 10299
  { PseudoVSOXSEG4EI32_V_M1_M2, VSOXSEG4EI32_V }, // 10300
  { PseudoVSOXSEG4EI32_V_M1_M2_MASK, VSOXSEG4EI32_V }, // 10301
  { PseudoVSOXSEG4EI32_V_M1_MF2, VSOXSEG4EI32_V }, // 10302
  { PseudoVSOXSEG4EI32_V_M1_MF2_MASK, VSOXSEG4EI32_V }, // 10303
  { PseudoVSOXSEG4EI32_V_M1_MF4, VSOXSEG4EI32_V }, // 10304
  { PseudoVSOXSEG4EI32_V_M1_MF4_MASK, VSOXSEG4EI32_V }, // 10305
  { PseudoVSOXSEG4EI32_V_M2_M1, VSOXSEG4EI32_V }, // 10306
  { PseudoVSOXSEG4EI32_V_M2_M1_MASK, VSOXSEG4EI32_V }, // 10307
  { PseudoVSOXSEG4EI32_V_M2_M2, VSOXSEG4EI32_V }, // 10308
  { PseudoVSOXSEG4EI32_V_M2_M2_MASK, VSOXSEG4EI32_V }, // 10309
  { PseudoVSOXSEG4EI32_V_M2_MF2, VSOXSEG4EI32_V }, // 10310
  { PseudoVSOXSEG4EI32_V_M2_MF2_MASK, VSOXSEG4EI32_V }, // 10311
  { PseudoVSOXSEG4EI32_V_M4_M1, VSOXSEG4EI32_V }, // 10312
  { PseudoVSOXSEG4EI32_V_M4_M1_MASK, VSOXSEG4EI32_V }, // 10313
  { PseudoVSOXSEG4EI32_V_M4_M2, VSOXSEG4EI32_V }, // 10314
  { PseudoVSOXSEG4EI32_V_M4_M2_MASK, VSOXSEG4EI32_V }, // 10315
  { PseudoVSOXSEG4EI32_V_M8_M2, VSOXSEG4EI32_V }, // 10316
  { PseudoVSOXSEG4EI32_V_M8_M2_MASK, VSOXSEG4EI32_V }, // 10317
  { PseudoVSOXSEG4EI32_V_MF2_M1, VSOXSEG4EI32_V }, // 10318
  { PseudoVSOXSEG4EI32_V_MF2_M1_MASK, VSOXSEG4EI32_V }, // 10319
  { PseudoVSOXSEG4EI32_V_MF2_MF2, VSOXSEG4EI32_V }, // 10320
  { PseudoVSOXSEG4EI32_V_MF2_MF2_MASK, VSOXSEG4EI32_V }, // 10321
  { PseudoVSOXSEG4EI32_V_MF2_MF4, VSOXSEG4EI32_V }, // 10322
  { PseudoVSOXSEG4EI32_V_MF2_MF4_MASK, VSOXSEG4EI32_V }, // 10323
  { PseudoVSOXSEG4EI32_V_MF2_MF8, VSOXSEG4EI32_V }, // 10324
  { PseudoVSOXSEG4EI32_V_MF2_MF8_MASK, VSOXSEG4EI32_V }, // 10325
  { PseudoVSOXSEG4EI64_V_M1_M1, VSOXSEG4EI64_V }, // 10326
  { PseudoVSOXSEG4EI64_V_M1_M1_MASK, VSOXSEG4EI64_V }, // 10327
  { PseudoVSOXSEG4EI64_V_M1_MF2, VSOXSEG4EI64_V }, // 10328
  { PseudoVSOXSEG4EI64_V_M1_MF2_MASK, VSOXSEG4EI64_V }, // 10329
  { PseudoVSOXSEG4EI64_V_M1_MF4, VSOXSEG4EI64_V }, // 10330
  { PseudoVSOXSEG4EI64_V_M1_MF4_MASK, VSOXSEG4EI64_V }, // 10331
  { PseudoVSOXSEG4EI64_V_M1_MF8, VSOXSEG4EI64_V }, // 10332
  { PseudoVSOXSEG4EI64_V_M1_MF8_MASK, VSOXSEG4EI64_V }, // 10333
  { PseudoVSOXSEG4EI64_V_M2_M1, VSOXSEG4EI64_V }, // 10334
  { PseudoVSOXSEG4EI64_V_M2_M1_MASK, VSOXSEG4EI64_V }, // 10335
  { PseudoVSOXSEG4EI64_V_M2_M2, VSOXSEG4EI64_V }, // 10336
  { PseudoVSOXSEG4EI64_V_M2_M2_MASK, VSOXSEG4EI64_V }, // 10337
  { PseudoVSOXSEG4EI64_V_M2_MF2, VSOXSEG4EI64_V }, // 10338
  { PseudoVSOXSEG4EI64_V_M2_MF2_MASK, VSOXSEG4EI64_V }, // 10339
  { PseudoVSOXSEG4EI64_V_M2_MF4, VSOXSEG4EI64_V }, // 10340
  { PseudoVSOXSEG4EI64_V_M2_MF4_MASK, VSOXSEG4EI64_V }, // 10341
  { PseudoVSOXSEG4EI64_V_M4_M1, VSOXSEG4EI64_V }, // 10342
  { PseudoVSOXSEG4EI64_V_M4_M1_MASK, VSOXSEG4EI64_V }, // 10343
  { PseudoVSOXSEG4EI64_V_M4_M2, VSOXSEG4EI64_V }, // 10344
  { PseudoVSOXSEG4EI64_V_M4_M2_MASK, VSOXSEG4EI64_V }, // 10345
  { PseudoVSOXSEG4EI64_V_M4_MF2, VSOXSEG4EI64_V }, // 10346
  { PseudoVSOXSEG4EI64_V_M4_MF2_MASK, VSOXSEG4EI64_V }, // 10347
  { PseudoVSOXSEG4EI64_V_M8_M1, VSOXSEG4EI64_V }, // 10348
  { PseudoVSOXSEG4EI64_V_M8_M1_MASK, VSOXSEG4EI64_V }, // 10349
  { PseudoVSOXSEG4EI64_V_M8_M2, VSOXSEG4EI64_V }, // 10350
  { PseudoVSOXSEG4EI64_V_M8_M2_MASK, VSOXSEG4EI64_V }, // 10351
  { PseudoVSOXSEG4EI8_V_M1_M1, VSOXSEG4EI8_V }, // 10352
  { PseudoVSOXSEG4EI8_V_M1_M1_MASK, VSOXSEG4EI8_V }, // 10353
  { PseudoVSOXSEG4EI8_V_M1_M2, VSOXSEG4EI8_V }, // 10354
  { PseudoVSOXSEG4EI8_V_M1_M2_MASK, VSOXSEG4EI8_V }, // 10355
  { PseudoVSOXSEG4EI8_V_M2_M2, VSOXSEG4EI8_V }, // 10356
  { PseudoVSOXSEG4EI8_V_M2_M2_MASK, VSOXSEG4EI8_V }, // 10357
  { PseudoVSOXSEG4EI8_V_MF2_M1, VSOXSEG4EI8_V }, // 10358
  { PseudoVSOXSEG4EI8_V_MF2_M1_MASK, VSOXSEG4EI8_V }, // 10359
  { PseudoVSOXSEG4EI8_V_MF2_M2, VSOXSEG4EI8_V }, // 10360
  { PseudoVSOXSEG4EI8_V_MF2_M2_MASK, VSOXSEG4EI8_V }, // 10361
  { PseudoVSOXSEG4EI8_V_MF2_MF2, VSOXSEG4EI8_V }, // 10362
  { PseudoVSOXSEG4EI8_V_MF2_MF2_MASK, VSOXSEG4EI8_V }, // 10363
  { PseudoVSOXSEG4EI8_V_MF4_M1, VSOXSEG4EI8_V }, // 10364
  { PseudoVSOXSEG4EI8_V_MF4_M1_MASK, VSOXSEG4EI8_V }, // 10365
  { PseudoVSOXSEG4EI8_V_MF4_M2, VSOXSEG4EI8_V }, // 10366
  { PseudoVSOXSEG4EI8_V_MF4_M2_MASK, VSOXSEG4EI8_V }, // 10367
  { PseudoVSOXSEG4EI8_V_MF4_MF2, VSOXSEG4EI8_V }, // 10368
  { PseudoVSOXSEG4EI8_V_MF4_MF2_MASK, VSOXSEG4EI8_V }, // 10369
  { PseudoVSOXSEG4EI8_V_MF4_MF4, VSOXSEG4EI8_V }, // 10370
  { PseudoVSOXSEG4EI8_V_MF4_MF4_MASK, VSOXSEG4EI8_V }, // 10371
  { PseudoVSOXSEG4EI8_V_MF8_M1, VSOXSEG4EI8_V }, // 10372
  { PseudoVSOXSEG4EI8_V_MF8_M1_MASK, VSOXSEG4EI8_V }, // 10373
  { PseudoVSOXSEG4EI8_V_MF8_MF2, VSOXSEG4EI8_V }, // 10374
  { PseudoVSOXSEG4EI8_V_MF8_MF2_MASK, VSOXSEG4EI8_V }, // 10375
  { PseudoVSOXSEG4EI8_V_MF8_MF4, VSOXSEG4EI8_V }, // 10376
  { PseudoVSOXSEG4EI8_V_MF8_MF4_MASK, VSOXSEG4EI8_V }, // 10377
  { PseudoVSOXSEG4EI8_V_MF8_MF8, VSOXSEG4EI8_V }, // 10378
  { PseudoVSOXSEG4EI8_V_MF8_MF8_MASK, VSOXSEG4EI8_V }, // 10379
  { PseudoVSOXSEG5EI16_V_M1_M1, VSOXSEG5EI16_V }, // 10380
  { PseudoVSOXSEG5EI16_V_M1_M1_MASK, VSOXSEG5EI16_V }, // 10381
  { PseudoVSOXSEG5EI16_V_M1_MF2, VSOXSEG5EI16_V }, // 10382
  { PseudoVSOXSEG5EI16_V_M1_MF2_MASK, VSOXSEG5EI16_V }, // 10383
  { PseudoVSOXSEG5EI16_V_M2_M1, VSOXSEG5EI16_V }, // 10384
  { PseudoVSOXSEG5EI16_V_M2_M1_MASK, VSOXSEG5EI16_V }, // 10385
  { PseudoVSOXSEG5EI16_V_MF2_M1, VSOXSEG5EI16_V }, // 10386
  { PseudoVSOXSEG5EI16_V_MF2_M1_MASK, VSOXSEG5EI16_V }, // 10387
  { PseudoVSOXSEG5EI16_V_MF2_MF2, VSOXSEG5EI16_V }, // 10388
  { PseudoVSOXSEG5EI16_V_MF2_MF2_MASK, VSOXSEG5EI16_V }, // 10389
  { PseudoVSOXSEG5EI16_V_MF2_MF4, VSOXSEG5EI16_V }, // 10390
  { PseudoVSOXSEG5EI16_V_MF2_MF4_MASK, VSOXSEG5EI16_V }, // 10391
  { PseudoVSOXSEG5EI16_V_MF4_M1, VSOXSEG5EI16_V }, // 10392
  { PseudoVSOXSEG5EI16_V_MF4_M1_MASK, VSOXSEG5EI16_V }, // 10393
  { PseudoVSOXSEG5EI16_V_MF4_MF2, VSOXSEG5EI16_V }, // 10394
  { PseudoVSOXSEG5EI16_V_MF4_MF2_MASK, VSOXSEG5EI16_V }, // 10395
  { PseudoVSOXSEG5EI16_V_MF4_MF4, VSOXSEG5EI16_V }, // 10396
  { PseudoVSOXSEG5EI16_V_MF4_MF4_MASK, VSOXSEG5EI16_V }, // 10397
  { PseudoVSOXSEG5EI16_V_MF4_MF8, VSOXSEG5EI16_V }, // 10398
  { PseudoVSOXSEG5EI16_V_MF4_MF8_MASK, VSOXSEG5EI16_V }, // 10399
  { PseudoVSOXSEG5EI32_V_M1_M1, VSOXSEG5EI32_V }, // 10400
  { PseudoVSOXSEG5EI32_V_M1_M1_MASK, VSOXSEG5EI32_V }, // 10401
  { PseudoVSOXSEG5EI32_V_M1_MF2, VSOXSEG5EI32_V }, // 10402
  { PseudoVSOXSEG5EI32_V_M1_MF2_MASK, VSOXSEG5EI32_V }, // 10403
  { PseudoVSOXSEG5EI32_V_M1_MF4, VSOXSEG5EI32_V }, // 10404
  { PseudoVSOXSEG5EI32_V_M1_MF4_MASK, VSOXSEG5EI32_V }, // 10405
  { PseudoVSOXSEG5EI32_V_M2_M1, VSOXSEG5EI32_V }, // 10406
  { PseudoVSOXSEG5EI32_V_M2_M1_MASK, VSOXSEG5EI32_V }, // 10407
  { PseudoVSOXSEG5EI32_V_M2_MF2, VSOXSEG5EI32_V }, // 10408
  { PseudoVSOXSEG5EI32_V_M2_MF2_MASK, VSOXSEG5EI32_V }, // 10409
  { PseudoVSOXSEG5EI32_V_M4_M1, VSOXSEG5EI32_V }, // 10410
  { PseudoVSOXSEG5EI32_V_M4_M1_MASK, VSOXSEG5EI32_V }, // 10411
  { PseudoVSOXSEG5EI32_V_MF2_M1, VSOXSEG5EI32_V }, // 10412
  { PseudoVSOXSEG5EI32_V_MF2_M1_MASK, VSOXSEG5EI32_V }, // 10413
  { PseudoVSOXSEG5EI32_V_MF2_MF2, VSOXSEG5EI32_V }, // 10414
  { PseudoVSOXSEG5EI32_V_MF2_MF2_MASK, VSOXSEG5EI32_V }, // 10415
  { PseudoVSOXSEG5EI32_V_MF2_MF4, VSOXSEG5EI32_V }, // 10416
  { PseudoVSOXSEG5EI32_V_MF2_MF4_MASK, VSOXSEG5EI32_V }, // 10417
  { PseudoVSOXSEG5EI32_V_MF2_MF8, VSOXSEG5EI32_V }, // 10418
  { PseudoVSOXSEG5EI32_V_MF2_MF8_MASK, VSOXSEG5EI32_V }, // 10419
  { PseudoVSOXSEG5EI64_V_M1_M1, VSOXSEG5EI64_V }, // 10420
  { PseudoVSOXSEG5EI64_V_M1_M1_MASK, VSOXSEG5EI64_V }, // 10421
  { PseudoVSOXSEG5EI64_V_M1_MF2, VSOXSEG5EI64_V }, // 10422
  { PseudoVSOXSEG5EI64_V_M1_MF2_MASK, VSOXSEG5EI64_V }, // 10423
  { PseudoVSOXSEG5EI64_V_M1_MF4, VSOXSEG5EI64_V }, // 10424
  { PseudoVSOXSEG5EI64_V_M1_MF4_MASK, VSOXSEG5EI64_V }, // 10425
  { PseudoVSOXSEG5EI64_V_M1_MF8, VSOXSEG5EI64_V }, // 10426
  { PseudoVSOXSEG5EI64_V_M1_MF8_MASK, VSOXSEG5EI64_V }, // 10427
  { PseudoVSOXSEG5EI64_V_M2_M1, VSOXSEG5EI64_V }, // 10428
  { PseudoVSOXSEG5EI64_V_M2_M1_MASK, VSOXSEG5EI64_V }, // 10429
  { PseudoVSOXSEG5EI64_V_M2_MF2, VSOXSEG5EI64_V }, // 10430
  { PseudoVSOXSEG5EI64_V_M2_MF2_MASK, VSOXSEG5EI64_V }, // 10431
  { PseudoVSOXSEG5EI64_V_M2_MF4, VSOXSEG5EI64_V }, // 10432
  { PseudoVSOXSEG5EI64_V_M2_MF4_MASK, VSOXSEG5EI64_V }, // 10433
  { PseudoVSOXSEG5EI64_V_M4_M1, VSOXSEG5EI64_V }, // 10434
  { PseudoVSOXSEG5EI64_V_M4_M1_MASK, VSOXSEG5EI64_V }, // 10435
  { PseudoVSOXSEG5EI64_V_M4_MF2, VSOXSEG5EI64_V }, // 10436
  { PseudoVSOXSEG5EI64_V_M4_MF2_MASK, VSOXSEG5EI64_V }, // 10437
  { PseudoVSOXSEG5EI64_V_M8_M1, VSOXSEG5EI64_V }, // 10438
  { PseudoVSOXSEG5EI64_V_M8_M1_MASK, VSOXSEG5EI64_V }, // 10439
  { PseudoVSOXSEG5EI8_V_M1_M1, VSOXSEG5EI8_V }, // 10440
  { PseudoVSOXSEG5EI8_V_M1_M1_MASK, VSOXSEG5EI8_V }, // 10441
  { PseudoVSOXSEG5EI8_V_MF2_M1, VSOXSEG5EI8_V }, // 10442
  { PseudoVSOXSEG5EI8_V_MF2_M1_MASK, VSOXSEG5EI8_V }, // 10443
  { PseudoVSOXSEG5EI8_V_MF2_MF2, VSOXSEG5EI8_V }, // 10444
  { PseudoVSOXSEG5EI8_V_MF2_MF2_MASK, VSOXSEG5EI8_V }, // 10445
  { PseudoVSOXSEG5EI8_V_MF4_M1, VSOXSEG5EI8_V }, // 10446
  { PseudoVSOXSEG5EI8_V_MF4_M1_MASK, VSOXSEG5EI8_V }, // 10447
  { PseudoVSOXSEG5EI8_V_MF4_MF2, VSOXSEG5EI8_V }, // 10448
  { PseudoVSOXSEG5EI8_V_MF4_MF2_MASK, VSOXSEG5EI8_V }, // 10449
  { PseudoVSOXSEG5EI8_V_MF4_MF4, VSOXSEG5EI8_V }, // 10450
  { PseudoVSOXSEG5EI8_V_MF4_MF4_MASK, VSOXSEG5EI8_V }, // 10451
  { PseudoVSOXSEG5EI8_V_MF8_M1, VSOXSEG5EI8_V }, // 10452
  { PseudoVSOXSEG5EI8_V_MF8_M1_MASK, VSOXSEG5EI8_V }, // 10453
  { PseudoVSOXSEG5EI8_V_MF8_MF2, VSOXSEG5EI8_V }, // 10454
  { PseudoVSOXSEG5EI8_V_MF8_MF2_MASK, VSOXSEG5EI8_V }, // 10455
  { PseudoVSOXSEG5EI8_V_MF8_MF4, VSOXSEG5EI8_V }, // 10456
  { PseudoVSOXSEG5EI8_V_MF8_MF4_MASK, VSOXSEG5EI8_V }, // 10457
  { PseudoVSOXSEG5EI8_V_MF8_MF8, VSOXSEG5EI8_V }, // 10458
  { PseudoVSOXSEG5EI8_V_MF8_MF8_MASK, VSOXSEG5EI8_V }, // 10459
  { PseudoVSOXSEG6EI16_V_M1_M1, VSOXSEG6EI16_V }, // 10460
  { PseudoVSOXSEG6EI16_V_M1_M1_MASK, VSOXSEG6EI16_V }, // 10461
  { PseudoVSOXSEG6EI16_V_M1_MF2, VSOXSEG6EI16_V }, // 10462
  { PseudoVSOXSEG6EI16_V_M1_MF2_MASK, VSOXSEG6EI16_V }, // 10463
  { PseudoVSOXSEG6EI16_V_M2_M1, VSOXSEG6EI16_V }, // 10464
  { PseudoVSOXSEG6EI16_V_M2_M1_MASK, VSOXSEG6EI16_V }, // 10465
  { PseudoVSOXSEG6EI16_V_MF2_M1, VSOXSEG6EI16_V }, // 10466
  { PseudoVSOXSEG6EI16_V_MF2_M1_MASK, VSOXSEG6EI16_V }, // 10467
  { PseudoVSOXSEG6EI16_V_MF2_MF2, VSOXSEG6EI16_V }, // 10468
  { PseudoVSOXSEG6EI16_V_MF2_MF2_MASK, VSOXSEG6EI16_V }, // 10469
  { PseudoVSOXSEG6EI16_V_MF2_MF4, VSOXSEG6EI16_V }, // 10470
  { PseudoVSOXSEG6EI16_V_MF2_MF4_MASK, VSOXSEG6EI16_V }, // 10471
  { PseudoVSOXSEG6EI16_V_MF4_M1, VSOXSEG6EI16_V }, // 10472
  { PseudoVSOXSEG6EI16_V_MF4_M1_MASK, VSOXSEG6EI16_V }, // 10473
  { PseudoVSOXSEG6EI16_V_MF4_MF2, VSOXSEG6EI16_V }, // 10474
  { PseudoVSOXSEG6EI16_V_MF4_MF2_MASK, VSOXSEG6EI16_V }, // 10475
  { PseudoVSOXSEG6EI16_V_MF4_MF4, VSOXSEG6EI16_V }, // 10476
  { PseudoVSOXSEG6EI16_V_MF4_MF4_MASK, VSOXSEG6EI16_V }, // 10477
  { PseudoVSOXSEG6EI16_V_MF4_MF8, VSOXSEG6EI16_V }, // 10478
  { PseudoVSOXSEG6EI16_V_MF4_MF8_MASK, VSOXSEG6EI16_V }, // 10479
  { PseudoVSOXSEG6EI32_V_M1_M1, VSOXSEG6EI32_V }, // 10480
  { PseudoVSOXSEG6EI32_V_M1_M1_MASK, VSOXSEG6EI32_V }, // 10481
  { PseudoVSOXSEG6EI32_V_M1_MF2, VSOXSEG6EI32_V }, // 10482
  { PseudoVSOXSEG6EI32_V_M1_MF2_MASK, VSOXSEG6EI32_V }, // 10483
  { PseudoVSOXSEG6EI32_V_M1_MF4, VSOXSEG6EI32_V }, // 10484
  { PseudoVSOXSEG6EI32_V_M1_MF4_MASK, VSOXSEG6EI32_V }, // 10485
  { PseudoVSOXSEG6EI32_V_M2_M1, VSOXSEG6EI32_V }, // 10486
  { PseudoVSOXSEG6EI32_V_M2_M1_MASK, VSOXSEG6EI32_V }, // 10487
  { PseudoVSOXSEG6EI32_V_M2_MF2, VSOXSEG6EI32_V }, // 10488
  { PseudoVSOXSEG6EI32_V_M2_MF2_MASK, VSOXSEG6EI32_V }, // 10489
  { PseudoVSOXSEG6EI32_V_M4_M1, VSOXSEG6EI32_V }, // 10490
  { PseudoVSOXSEG6EI32_V_M4_M1_MASK, VSOXSEG6EI32_V }, // 10491
  { PseudoVSOXSEG6EI32_V_MF2_M1, VSOXSEG6EI32_V }, // 10492
  { PseudoVSOXSEG6EI32_V_MF2_M1_MASK, VSOXSEG6EI32_V }, // 10493
  { PseudoVSOXSEG6EI32_V_MF2_MF2, VSOXSEG6EI32_V }, // 10494
  { PseudoVSOXSEG6EI32_V_MF2_MF2_MASK, VSOXSEG6EI32_V }, // 10495
  { PseudoVSOXSEG6EI32_V_MF2_MF4, VSOXSEG6EI32_V }, // 10496
  { PseudoVSOXSEG6EI32_V_MF2_MF4_MASK, VSOXSEG6EI32_V }, // 10497
  { PseudoVSOXSEG6EI32_V_MF2_MF8, VSOXSEG6EI32_V }, // 10498
  { PseudoVSOXSEG6EI32_V_MF2_MF8_MASK, VSOXSEG6EI32_V }, // 10499
  { PseudoVSOXSEG6EI64_V_M1_M1, VSOXSEG6EI64_V }, // 10500
  { PseudoVSOXSEG6EI64_V_M1_M1_MASK, VSOXSEG6EI64_V }, // 10501
  { PseudoVSOXSEG6EI64_V_M1_MF2, VSOXSEG6EI64_V }, // 10502
  { PseudoVSOXSEG6EI64_V_M1_MF2_MASK, VSOXSEG6EI64_V }, // 10503
  { PseudoVSOXSEG6EI64_V_M1_MF4, VSOXSEG6EI64_V }, // 10504
  { PseudoVSOXSEG6EI64_V_M1_MF4_MASK, VSOXSEG6EI64_V }, // 10505
  { PseudoVSOXSEG6EI64_V_M1_MF8, VSOXSEG6EI64_V }, // 10506
  { PseudoVSOXSEG6EI64_V_M1_MF8_MASK, VSOXSEG6EI64_V }, // 10507
  { PseudoVSOXSEG6EI64_V_M2_M1, VSOXSEG6EI64_V }, // 10508
  { PseudoVSOXSEG6EI64_V_M2_M1_MASK, VSOXSEG6EI64_V }, // 10509
  { PseudoVSOXSEG6EI64_V_M2_MF2, VSOXSEG6EI64_V }, // 10510
  { PseudoVSOXSEG6EI64_V_M2_MF2_MASK, VSOXSEG6EI64_V }, // 10511
  { PseudoVSOXSEG6EI64_V_M2_MF4, VSOXSEG6EI64_V }, // 10512
  { PseudoVSOXSEG6EI64_V_M2_MF4_MASK, VSOXSEG6EI64_V }, // 10513
  { PseudoVSOXSEG6EI64_V_M4_M1, VSOXSEG6EI64_V }, // 10514
  { PseudoVSOXSEG6EI64_V_M4_M1_MASK, VSOXSEG6EI64_V }, // 10515
  { PseudoVSOXSEG6EI64_V_M4_MF2, VSOXSEG6EI64_V }, // 10516
  { PseudoVSOXSEG6EI64_V_M4_MF2_MASK, VSOXSEG6EI64_V }, // 10517
  { PseudoVSOXSEG6EI64_V_M8_M1, VSOXSEG6EI64_V }, // 10518
  { PseudoVSOXSEG6EI64_V_M8_M1_MASK, VSOXSEG6EI64_V }, // 10519
  { PseudoVSOXSEG6EI8_V_M1_M1, VSOXSEG6EI8_V }, // 10520
  { PseudoVSOXSEG6EI8_V_M1_M1_MASK, VSOXSEG6EI8_V }, // 10521
  { PseudoVSOXSEG6EI8_V_MF2_M1, VSOXSEG6EI8_V }, // 10522
  { PseudoVSOXSEG6EI8_V_MF2_M1_MASK, VSOXSEG6EI8_V }, // 10523
  { PseudoVSOXSEG6EI8_V_MF2_MF2, VSOXSEG6EI8_V }, // 10524
  { PseudoVSOXSEG6EI8_V_MF2_MF2_MASK, VSOXSEG6EI8_V }, // 10525
  { PseudoVSOXSEG6EI8_V_MF4_M1, VSOXSEG6EI8_V }, // 10526
  { PseudoVSOXSEG6EI8_V_MF4_M1_MASK, VSOXSEG6EI8_V }, // 10527
  { PseudoVSOXSEG6EI8_V_MF4_MF2, VSOXSEG6EI8_V }, // 10528
  { PseudoVSOXSEG6EI8_V_MF4_MF2_MASK, VSOXSEG6EI8_V }, // 10529
  { PseudoVSOXSEG6EI8_V_MF4_MF4, VSOXSEG6EI8_V }, // 10530
  { PseudoVSOXSEG6EI8_V_MF4_MF4_MASK, VSOXSEG6EI8_V }, // 10531
  { PseudoVSOXSEG6EI8_V_MF8_M1, VSOXSEG6EI8_V }, // 10532
  { PseudoVSOXSEG6EI8_V_MF8_M1_MASK, VSOXSEG6EI8_V }, // 10533
  { PseudoVSOXSEG6EI8_V_MF8_MF2, VSOXSEG6EI8_V }, // 10534
  { PseudoVSOXSEG6EI8_V_MF8_MF2_MASK, VSOXSEG6EI8_V }, // 10535
  { PseudoVSOXSEG6EI8_V_MF8_MF4, VSOXSEG6EI8_V }, // 10536
  { PseudoVSOXSEG6EI8_V_MF8_MF4_MASK, VSOXSEG6EI8_V }, // 10537
  { PseudoVSOXSEG6EI8_V_MF8_MF8, VSOXSEG6EI8_V }, // 10538
  { PseudoVSOXSEG6EI8_V_MF8_MF8_MASK, VSOXSEG6EI8_V }, // 10539
  { PseudoVSOXSEG7EI16_V_M1_M1, VSOXSEG7EI16_V }, // 10540
  { PseudoVSOXSEG7EI16_V_M1_M1_MASK, VSOXSEG7EI16_V }, // 10541
  { PseudoVSOXSEG7EI16_V_M1_MF2, VSOXSEG7EI16_V }, // 10542
  { PseudoVSOXSEG7EI16_V_M1_MF2_MASK, VSOXSEG7EI16_V }, // 10543
  { PseudoVSOXSEG7EI16_V_M2_M1, VSOXSEG7EI16_V }, // 10544
  { PseudoVSOXSEG7EI16_V_M2_M1_MASK, VSOXSEG7EI16_V }, // 10545
  { PseudoVSOXSEG7EI16_V_MF2_M1, VSOXSEG7EI16_V }, // 10546
  { PseudoVSOXSEG7EI16_V_MF2_M1_MASK, VSOXSEG7EI16_V }, // 10547
  { PseudoVSOXSEG7EI16_V_MF2_MF2, VSOXSEG7EI16_V }, // 10548
  { PseudoVSOXSEG7EI16_V_MF2_MF2_MASK, VSOXSEG7EI16_V }, // 10549
  { PseudoVSOXSEG7EI16_V_MF2_MF4, VSOXSEG7EI16_V }, // 10550
  { PseudoVSOXSEG7EI16_V_MF2_MF4_MASK, VSOXSEG7EI16_V }, // 10551
  { PseudoVSOXSEG7EI16_V_MF4_M1, VSOXSEG7EI16_V }, // 10552
  { PseudoVSOXSEG7EI16_V_MF4_M1_MASK, VSOXSEG7EI16_V }, // 10553
  { PseudoVSOXSEG7EI16_V_MF4_MF2, VSOXSEG7EI16_V }, // 10554
  { PseudoVSOXSEG7EI16_V_MF4_MF2_MASK, VSOXSEG7EI16_V }, // 10555
  { PseudoVSOXSEG7EI16_V_MF4_MF4, VSOXSEG7EI16_V }, // 10556
  { PseudoVSOXSEG7EI16_V_MF4_MF4_MASK, VSOXSEG7EI16_V }, // 10557
  { PseudoVSOXSEG7EI16_V_MF4_MF8, VSOXSEG7EI16_V }, // 10558
  { PseudoVSOXSEG7EI16_V_MF4_MF8_MASK, VSOXSEG7EI16_V }, // 10559
  { PseudoVSOXSEG7EI32_V_M1_M1, VSOXSEG7EI32_V }, // 10560
  { PseudoVSOXSEG7EI32_V_M1_M1_MASK, VSOXSEG7EI32_V }, // 10561
  { PseudoVSOXSEG7EI32_V_M1_MF2, VSOXSEG7EI32_V }, // 10562
  { PseudoVSOXSEG7EI32_V_M1_MF2_MASK, VSOXSEG7EI32_V }, // 10563
  { PseudoVSOXSEG7EI32_V_M1_MF4, VSOXSEG7EI32_V }, // 10564
  { PseudoVSOXSEG7EI32_V_M1_MF4_MASK, VSOXSEG7EI32_V }, // 10565
  { PseudoVSOXSEG7EI32_V_M2_M1, VSOXSEG7EI32_V }, // 10566
  { PseudoVSOXSEG7EI32_V_M2_M1_MASK, VSOXSEG7EI32_V }, // 10567
  { PseudoVSOXSEG7EI32_V_M2_MF2, VSOXSEG7EI32_V }, // 10568
  { PseudoVSOXSEG7EI32_V_M2_MF2_MASK, VSOXSEG7EI32_V }, // 10569
  { PseudoVSOXSEG7EI32_V_M4_M1, VSOXSEG7EI32_V }, // 10570
  { PseudoVSOXSEG7EI32_V_M4_M1_MASK, VSOXSEG7EI32_V }, // 10571
  { PseudoVSOXSEG7EI32_V_MF2_M1, VSOXSEG7EI32_V }, // 10572
  { PseudoVSOXSEG7EI32_V_MF2_M1_MASK, VSOXSEG7EI32_V }, // 10573
  { PseudoVSOXSEG7EI32_V_MF2_MF2, VSOXSEG7EI32_V }, // 10574
  { PseudoVSOXSEG7EI32_V_MF2_MF2_MASK, VSOXSEG7EI32_V }, // 10575
  { PseudoVSOXSEG7EI32_V_MF2_MF4, VSOXSEG7EI32_V }, // 10576
  { PseudoVSOXSEG7EI32_V_MF2_MF4_MASK, VSOXSEG7EI32_V }, // 10577
  { PseudoVSOXSEG7EI32_V_MF2_MF8, VSOXSEG7EI32_V }, // 10578
  { PseudoVSOXSEG7EI32_V_MF2_MF8_MASK, VSOXSEG7EI32_V }, // 10579
  { PseudoVSOXSEG7EI64_V_M1_M1, VSOXSEG7EI64_V }, // 10580
  { PseudoVSOXSEG7EI64_V_M1_M1_MASK, VSOXSEG7EI64_V }, // 10581
  { PseudoVSOXSEG7EI64_V_M1_MF2, VSOXSEG7EI64_V }, // 10582
  { PseudoVSOXSEG7EI64_V_M1_MF2_MASK, VSOXSEG7EI64_V }, // 10583
  { PseudoVSOXSEG7EI64_V_M1_MF4, VSOXSEG7EI64_V }, // 10584
  { PseudoVSOXSEG7EI64_V_M1_MF4_MASK, VSOXSEG7EI64_V }, // 10585
  { PseudoVSOXSEG7EI64_V_M1_MF8, VSOXSEG7EI64_V }, // 10586
  { PseudoVSOXSEG7EI64_V_M1_MF8_MASK, VSOXSEG7EI64_V }, // 10587
  { PseudoVSOXSEG7EI64_V_M2_M1, VSOXSEG7EI64_V }, // 10588
  { PseudoVSOXSEG7EI64_V_M2_M1_MASK, VSOXSEG7EI64_V }, // 10589
  { PseudoVSOXSEG7EI64_V_M2_MF2, VSOXSEG7EI64_V }, // 10590
  { PseudoVSOXSEG7EI64_V_M2_MF2_MASK, VSOXSEG7EI64_V }, // 10591
  { PseudoVSOXSEG7EI64_V_M2_MF4, VSOXSEG7EI64_V }, // 10592
  { PseudoVSOXSEG7EI64_V_M2_MF4_MASK, VSOXSEG7EI64_V }, // 10593
  { PseudoVSOXSEG7EI64_V_M4_M1, VSOXSEG7EI64_V }, // 10594
  { PseudoVSOXSEG7EI64_V_M4_M1_MASK, VSOXSEG7EI64_V }, // 10595
  { PseudoVSOXSEG7EI64_V_M4_MF2, VSOXSEG7EI64_V }, // 10596
  { PseudoVSOXSEG7EI64_V_M4_MF2_MASK, VSOXSEG7EI64_V }, // 10597
  { PseudoVSOXSEG7EI64_V_M8_M1, VSOXSEG7EI64_V }, // 10598
  { PseudoVSOXSEG7EI64_V_M8_M1_MASK, VSOXSEG7EI64_V }, // 10599
  { PseudoVSOXSEG7EI8_V_M1_M1, VSOXSEG7EI8_V }, // 10600
  { PseudoVSOXSEG7EI8_V_M1_M1_MASK, VSOXSEG7EI8_V }, // 10601
  { PseudoVSOXSEG7EI8_V_MF2_M1, VSOXSEG7EI8_V }, // 10602
  { PseudoVSOXSEG7EI8_V_MF2_M1_MASK, VSOXSEG7EI8_V }, // 10603
  { PseudoVSOXSEG7EI8_V_MF2_MF2, VSOXSEG7EI8_V }, // 10604
  { PseudoVSOXSEG7EI8_V_MF2_MF2_MASK, VSOXSEG7EI8_V }, // 10605
  { PseudoVSOXSEG7EI8_V_MF4_M1, VSOXSEG7EI8_V }, // 10606
  { PseudoVSOXSEG7EI8_V_MF4_M1_MASK, VSOXSEG7EI8_V }, // 10607
  { PseudoVSOXSEG7EI8_V_MF4_MF2, VSOXSEG7EI8_V }, // 10608
  { PseudoVSOXSEG7EI8_V_MF4_MF2_MASK, VSOXSEG7EI8_V }, // 10609
  { PseudoVSOXSEG7EI8_V_MF4_MF4, VSOXSEG7EI8_V }, // 10610
  { PseudoVSOXSEG7EI8_V_MF4_MF4_MASK, VSOXSEG7EI8_V }, // 10611
  { PseudoVSOXSEG7EI8_V_MF8_M1, VSOXSEG7EI8_V }, // 10612
  { PseudoVSOXSEG7EI8_V_MF8_M1_MASK, VSOXSEG7EI8_V }, // 10613
  { PseudoVSOXSEG7EI8_V_MF8_MF2, VSOXSEG7EI8_V }, // 10614
  { PseudoVSOXSEG7EI8_V_MF8_MF2_MASK, VSOXSEG7EI8_V }, // 10615
  { PseudoVSOXSEG7EI8_V_MF8_MF4, VSOXSEG7EI8_V }, // 10616
  { PseudoVSOXSEG7EI8_V_MF8_MF4_MASK, VSOXSEG7EI8_V }, // 10617
  { PseudoVSOXSEG7EI8_V_MF8_MF8, VSOXSEG7EI8_V }, // 10618
  { PseudoVSOXSEG7EI8_V_MF8_MF8_MASK, VSOXSEG7EI8_V }, // 10619
  { PseudoVSOXSEG8EI16_V_M1_M1, VSOXSEG8EI16_V }, // 10620
  { PseudoVSOXSEG8EI16_V_M1_M1_MASK, VSOXSEG8EI16_V }, // 10621
  { PseudoVSOXSEG8EI16_V_M1_MF2, VSOXSEG8EI16_V }, // 10622
  { PseudoVSOXSEG8EI16_V_M1_MF2_MASK, VSOXSEG8EI16_V }, // 10623
  { PseudoVSOXSEG8EI16_V_M2_M1, VSOXSEG8EI16_V }, // 10624
  { PseudoVSOXSEG8EI16_V_M2_M1_MASK, VSOXSEG8EI16_V }, // 10625
  { PseudoVSOXSEG8EI16_V_MF2_M1, VSOXSEG8EI16_V }, // 10626
  { PseudoVSOXSEG8EI16_V_MF2_M1_MASK, VSOXSEG8EI16_V }, // 10627
  { PseudoVSOXSEG8EI16_V_MF2_MF2, VSOXSEG8EI16_V }, // 10628
  { PseudoVSOXSEG8EI16_V_MF2_MF2_MASK, VSOXSEG8EI16_V }, // 10629
  { PseudoVSOXSEG8EI16_V_MF2_MF4, VSOXSEG8EI16_V }, // 10630
  { PseudoVSOXSEG8EI16_V_MF2_MF4_MASK, VSOXSEG8EI16_V }, // 10631
  { PseudoVSOXSEG8EI16_V_MF4_M1, VSOXSEG8EI16_V }, // 10632
  { PseudoVSOXSEG8EI16_V_MF4_M1_MASK, VSOXSEG8EI16_V }, // 10633
  { PseudoVSOXSEG8EI16_V_MF4_MF2, VSOXSEG8EI16_V }, // 10634
  { PseudoVSOXSEG8EI16_V_MF4_MF2_MASK, VSOXSEG8EI16_V }, // 10635
  { PseudoVSOXSEG8EI16_V_MF4_MF4, VSOXSEG8EI16_V }, // 10636
  { PseudoVSOXSEG8EI16_V_MF4_MF4_MASK, VSOXSEG8EI16_V }, // 10637
  { PseudoVSOXSEG8EI16_V_MF4_MF8, VSOXSEG8EI16_V }, // 10638
  { PseudoVSOXSEG8EI16_V_MF4_MF8_MASK, VSOXSEG8EI16_V }, // 10639
  { PseudoVSOXSEG8EI32_V_M1_M1, VSOXSEG8EI32_V }, // 10640
  { PseudoVSOXSEG8EI32_V_M1_M1_MASK, VSOXSEG8EI32_V }, // 10641
  { PseudoVSOXSEG8EI32_V_M1_MF2, VSOXSEG8EI32_V }, // 10642
  { PseudoVSOXSEG8EI32_V_M1_MF2_MASK, VSOXSEG8EI32_V }, // 10643
  { PseudoVSOXSEG8EI32_V_M1_MF4, VSOXSEG8EI32_V }, // 10644
  { PseudoVSOXSEG8EI32_V_M1_MF4_MASK, VSOXSEG8EI32_V }, // 10645
  { PseudoVSOXSEG8EI32_V_M2_M1, VSOXSEG8EI32_V }, // 10646
  { PseudoVSOXSEG8EI32_V_M2_M1_MASK, VSOXSEG8EI32_V }, // 10647
  { PseudoVSOXSEG8EI32_V_M2_MF2, VSOXSEG8EI32_V }, // 10648
  { PseudoVSOXSEG8EI32_V_M2_MF2_MASK, VSOXSEG8EI32_V }, // 10649
  { PseudoVSOXSEG8EI32_V_M4_M1, VSOXSEG8EI32_V }, // 10650
  { PseudoVSOXSEG8EI32_V_M4_M1_MASK, VSOXSEG8EI32_V }, // 10651
  { PseudoVSOXSEG8EI32_V_MF2_M1, VSOXSEG8EI32_V }, // 10652
  { PseudoVSOXSEG8EI32_V_MF2_M1_MASK, VSOXSEG8EI32_V }, // 10653
  { PseudoVSOXSEG8EI32_V_MF2_MF2, VSOXSEG8EI32_V }, // 10654
  { PseudoVSOXSEG8EI32_V_MF2_MF2_MASK, VSOXSEG8EI32_V }, // 10655
  { PseudoVSOXSEG8EI32_V_MF2_MF4, VSOXSEG8EI32_V }, // 10656
  { PseudoVSOXSEG8EI32_V_MF2_MF4_MASK, VSOXSEG8EI32_V }, // 10657
  { PseudoVSOXSEG8EI32_V_MF2_MF8, VSOXSEG8EI32_V }, // 10658
  { PseudoVSOXSEG8EI32_V_MF2_MF8_MASK, VSOXSEG8EI32_V }, // 10659
  { PseudoVSOXSEG8EI64_V_M1_M1, VSOXSEG8EI64_V }, // 10660
  { PseudoVSOXSEG8EI64_V_M1_M1_MASK, VSOXSEG8EI64_V }, // 10661
  { PseudoVSOXSEG8EI64_V_M1_MF2, VSOXSEG8EI64_V }, // 10662
  { PseudoVSOXSEG8EI64_V_M1_MF2_MASK, VSOXSEG8EI64_V }, // 10663
  { PseudoVSOXSEG8EI64_V_M1_MF4, VSOXSEG8EI64_V }, // 10664
  { PseudoVSOXSEG8EI64_V_M1_MF4_MASK, VSOXSEG8EI64_V }, // 10665
  { PseudoVSOXSEG8EI64_V_M1_MF8, VSOXSEG8EI64_V }, // 10666
  { PseudoVSOXSEG8EI64_V_M1_MF8_MASK, VSOXSEG8EI64_V }, // 10667
  { PseudoVSOXSEG8EI64_V_M2_M1, VSOXSEG8EI64_V }, // 10668
  { PseudoVSOXSEG8EI64_V_M2_M1_MASK, VSOXSEG8EI64_V }, // 10669
  { PseudoVSOXSEG8EI64_V_M2_MF2, VSOXSEG8EI64_V }, // 10670
  { PseudoVSOXSEG8EI64_V_M2_MF2_MASK, VSOXSEG8EI64_V }, // 10671
  { PseudoVSOXSEG8EI64_V_M2_MF4, VSOXSEG8EI64_V }, // 10672
  { PseudoVSOXSEG8EI64_V_M2_MF4_MASK, VSOXSEG8EI64_V }, // 10673
  { PseudoVSOXSEG8EI64_V_M4_M1, VSOXSEG8EI64_V }, // 10674
  { PseudoVSOXSEG8EI64_V_M4_M1_MASK, VSOXSEG8EI64_V }, // 10675
  { PseudoVSOXSEG8EI64_V_M4_MF2, VSOXSEG8EI64_V }, // 10676
  { PseudoVSOXSEG8EI64_V_M4_MF2_MASK, VSOXSEG8EI64_V }, // 10677
  { PseudoVSOXSEG8EI64_V_M8_M1, VSOXSEG8EI64_V }, // 10678
  { PseudoVSOXSEG8EI64_V_M8_M1_MASK, VSOXSEG8EI64_V }, // 10679
  { PseudoVSOXSEG8EI8_V_M1_M1, VSOXSEG8EI8_V }, // 10680
  { PseudoVSOXSEG8EI8_V_M1_M1_MASK, VSOXSEG8EI8_V }, // 10681
  { PseudoVSOXSEG8EI8_V_MF2_M1, VSOXSEG8EI8_V }, // 10682
  { PseudoVSOXSEG8EI8_V_MF2_M1_MASK, VSOXSEG8EI8_V }, // 10683
  { PseudoVSOXSEG8EI8_V_MF2_MF2, VSOXSEG8EI8_V }, // 10684
  { PseudoVSOXSEG8EI8_V_MF2_MF2_MASK, VSOXSEG8EI8_V }, // 10685
  { PseudoVSOXSEG8EI8_V_MF4_M1, VSOXSEG8EI8_V }, // 10686
  { PseudoVSOXSEG8EI8_V_MF4_M1_MASK, VSOXSEG8EI8_V }, // 10687
  { PseudoVSOXSEG8EI8_V_MF4_MF2, VSOXSEG8EI8_V }, // 10688
  { PseudoVSOXSEG8EI8_V_MF4_MF2_MASK, VSOXSEG8EI8_V }, // 10689
  { PseudoVSOXSEG8EI8_V_MF4_MF4, VSOXSEG8EI8_V }, // 10690
  { PseudoVSOXSEG8EI8_V_MF4_MF4_MASK, VSOXSEG8EI8_V }, // 10691
  { PseudoVSOXSEG8EI8_V_MF8_M1, VSOXSEG8EI8_V }, // 10692
  { PseudoVSOXSEG8EI8_V_MF8_M1_MASK, VSOXSEG8EI8_V }, // 10693
  { PseudoVSOXSEG8EI8_V_MF8_MF2, VSOXSEG8EI8_V }, // 10694
  { PseudoVSOXSEG8EI8_V_MF8_MF2_MASK, VSOXSEG8EI8_V }, // 10695
  { PseudoVSOXSEG8EI8_V_MF8_MF4, VSOXSEG8EI8_V }, // 10696
  { PseudoVSOXSEG8EI8_V_MF8_MF4_MASK, VSOXSEG8EI8_V }, // 10697
  { PseudoVSOXSEG8EI8_V_MF8_MF8, VSOXSEG8EI8_V }, // 10698
  { PseudoVSOXSEG8EI8_V_MF8_MF8_MASK, VSOXSEG8EI8_V }, // 10699
  { PseudoVSRA_VI_M1, VSRA_VI }, // 10700
  { PseudoVSRA_VI_M1_MASK, VSRA_VI }, // 10701
  { PseudoVSRA_VI_M1_TU, VSRA_VI }, // 10702
  { PseudoVSRA_VI_M2, VSRA_VI }, // 10703
  { PseudoVSRA_VI_M2_MASK, VSRA_VI }, // 10704
  { PseudoVSRA_VI_M2_TU, VSRA_VI }, // 10705
  { PseudoVSRA_VI_M4, VSRA_VI }, // 10706
  { PseudoVSRA_VI_M4_MASK, VSRA_VI }, // 10707
  { PseudoVSRA_VI_M4_TU, VSRA_VI }, // 10708
  { PseudoVSRA_VI_M8, VSRA_VI }, // 10709
  { PseudoVSRA_VI_M8_MASK, VSRA_VI }, // 10710
  { PseudoVSRA_VI_M8_TU, VSRA_VI }, // 10711
  { PseudoVSRA_VI_MF2, VSRA_VI }, // 10712
  { PseudoVSRA_VI_MF2_MASK, VSRA_VI }, // 10713
  { PseudoVSRA_VI_MF2_TU, VSRA_VI }, // 10714
  { PseudoVSRA_VI_MF4, VSRA_VI }, // 10715
  { PseudoVSRA_VI_MF4_MASK, VSRA_VI }, // 10716
  { PseudoVSRA_VI_MF4_TU, VSRA_VI }, // 10717
  { PseudoVSRA_VI_MF8, VSRA_VI }, // 10718
  { PseudoVSRA_VI_MF8_MASK, VSRA_VI }, // 10719
  { PseudoVSRA_VI_MF8_TU, VSRA_VI }, // 10720
  { PseudoVSRA_VV_M1, VSRA_VV }, // 10721
  { PseudoVSRA_VV_M1_MASK, VSRA_VV }, // 10722
  { PseudoVSRA_VV_M1_TU, VSRA_VV }, // 10723
  { PseudoVSRA_VV_M2, VSRA_VV }, // 10724
  { PseudoVSRA_VV_M2_MASK, VSRA_VV }, // 10725
  { PseudoVSRA_VV_M2_TU, VSRA_VV }, // 10726
  { PseudoVSRA_VV_M4, VSRA_VV }, // 10727
  { PseudoVSRA_VV_M4_MASK, VSRA_VV }, // 10728
  { PseudoVSRA_VV_M4_TU, VSRA_VV }, // 10729
  { PseudoVSRA_VV_M8, VSRA_VV }, // 10730
  { PseudoVSRA_VV_M8_MASK, VSRA_VV }, // 10731
  { PseudoVSRA_VV_M8_TU, VSRA_VV }, // 10732
  { PseudoVSRA_VV_MF2, VSRA_VV }, // 10733
  { PseudoVSRA_VV_MF2_MASK, VSRA_VV }, // 10734
  { PseudoVSRA_VV_MF2_TU, VSRA_VV }, // 10735
  { PseudoVSRA_VV_MF4, VSRA_VV }, // 10736
  { PseudoVSRA_VV_MF4_MASK, VSRA_VV }, // 10737
  { PseudoVSRA_VV_MF4_TU, VSRA_VV }, // 10738
  { PseudoVSRA_VV_MF8, VSRA_VV }, // 10739
  { PseudoVSRA_VV_MF8_MASK, VSRA_VV }, // 10740
  { PseudoVSRA_VV_MF8_TU, VSRA_VV }, // 10741
  { PseudoVSRA_VX_M1, VSRA_VX }, // 10742
  { PseudoVSRA_VX_M1_MASK, VSRA_VX }, // 10743
  { PseudoVSRA_VX_M1_TU, VSRA_VX }, // 10744
  { PseudoVSRA_VX_M2, VSRA_VX }, // 10745
  { PseudoVSRA_VX_M2_MASK, VSRA_VX }, // 10746
  { PseudoVSRA_VX_M2_TU, VSRA_VX }, // 10747
  { PseudoVSRA_VX_M4, VSRA_VX }, // 10748
  { PseudoVSRA_VX_M4_MASK, VSRA_VX }, // 10749
  { PseudoVSRA_VX_M4_TU, VSRA_VX }, // 10750
  { PseudoVSRA_VX_M8, VSRA_VX }, // 10751
  { PseudoVSRA_VX_M8_MASK, VSRA_VX }, // 10752
  { PseudoVSRA_VX_M8_TU, VSRA_VX }, // 10753
  { PseudoVSRA_VX_MF2, VSRA_VX }, // 10754
  { PseudoVSRA_VX_MF2_MASK, VSRA_VX }, // 10755
  { PseudoVSRA_VX_MF2_TU, VSRA_VX }, // 10756
  { PseudoVSRA_VX_MF4, VSRA_VX }, // 10757
  { PseudoVSRA_VX_MF4_MASK, VSRA_VX }, // 10758
  { PseudoVSRA_VX_MF4_TU, VSRA_VX }, // 10759
  { PseudoVSRA_VX_MF8, VSRA_VX }, // 10760
  { PseudoVSRA_VX_MF8_MASK, VSRA_VX }, // 10761
  { PseudoVSRA_VX_MF8_TU, VSRA_VX }, // 10762
  { PseudoVSRL_VI_M1, VSRL_VI }, // 10763
  { PseudoVSRL_VI_M1_MASK, VSRL_VI }, // 10764
  { PseudoVSRL_VI_M1_TU, VSRL_VI }, // 10765
  { PseudoVSRL_VI_M2, VSRL_VI }, // 10766
  { PseudoVSRL_VI_M2_MASK, VSRL_VI }, // 10767
  { PseudoVSRL_VI_M2_TU, VSRL_VI }, // 10768
  { PseudoVSRL_VI_M4, VSRL_VI }, // 10769
  { PseudoVSRL_VI_M4_MASK, VSRL_VI }, // 10770
  { PseudoVSRL_VI_M4_TU, VSRL_VI }, // 10771
  { PseudoVSRL_VI_M8, VSRL_VI }, // 10772
  { PseudoVSRL_VI_M8_MASK, VSRL_VI }, // 10773
  { PseudoVSRL_VI_M8_TU, VSRL_VI }, // 10774
  { PseudoVSRL_VI_MF2, VSRL_VI }, // 10775
  { PseudoVSRL_VI_MF2_MASK, VSRL_VI }, // 10776
  { PseudoVSRL_VI_MF2_TU, VSRL_VI }, // 10777
  { PseudoVSRL_VI_MF4, VSRL_VI }, // 10778
  { PseudoVSRL_VI_MF4_MASK, VSRL_VI }, // 10779
  { PseudoVSRL_VI_MF4_TU, VSRL_VI }, // 10780
  { PseudoVSRL_VI_MF8, VSRL_VI }, // 10781
  { PseudoVSRL_VI_MF8_MASK, VSRL_VI }, // 10782
  { PseudoVSRL_VI_MF8_TU, VSRL_VI }, // 10783
  { PseudoVSRL_VV_M1, VSRL_VV }, // 10784
  { PseudoVSRL_VV_M1_MASK, VSRL_VV }, // 10785
  { PseudoVSRL_VV_M1_TU, VSRL_VV }, // 10786
  { PseudoVSRL_VV_M2, VSRL_VV }, // 10787
  { PseudoVSRL_VV_M2_MASK, VSRL_VV }, // 10788
  { PseudoVSRL_VV_M2_TU, VSRL_VV }, // 10789
  { PseudoVSRL_VV_M4, VSRL_VV }, // 10790
  { PseudoVSRL_VV_M4_MASK, VSRL_VV }, // 10791
  { PseudoVSRL_VV_M4_TU, VSRL_VV }, // 10792
  { PseudoVSRL_VV_M8, VSRL_VV }, // 10793
  { PseudoVSRL_VV_M8_MASK, VSRL_VV }, // 10794
  { PseudoVSRL_VV_M8_TU, VSRL_VV }, // 10795
  { PseudoVSRL_VV_MF2, VSRL_VV }, // 10796
  { PseudoVSRL_VV_MF2_MASK, VSRL_VV }, // 10797
  { PseudoVSRL_VV_MF2_TU, VSRL_VV }, // 10798
  { PseudoVSRL_VV_MF4, VSRL_VV }, // 10799
  { PseudoVSRL_VV_MF4_MASK, VSRL_VV }, // 10800
  { PseudoVSRL_VV_MF4_TU, VSRL_VV }, // 10801
  { PseudoVSRL_VV_MF8, VSRL_VV }, // 10802
  { PseudoVSRL_VV_MF8_MASK, VSRL_VV }, // 10803
  { PseudoVSRL_VV_MF8_TU, VSRL_VV }, // 10804
  { PseudoVSRL_VX_M1, VSRL_VX }, // 10805
  { PseudoVSRL_VX_M1_MASK, VSRL_VX }, // 10806
  { PseudoVSRL_VX_M1_TU, VSRL_VX }, // 10807
  { PseudoVSRL_VX_M2, VSRL_VX }, // 10808
  { PseudoVSRL_VX_M2_MASK, VSRL_VX }, // 10809
  { PseudoVSRL_VX_M2_TU, VSRL_VX }, // 10810
  { PseudoVSRL_VX_M4, VSRL_VX }, // 10811
  { PseudoVSRL_VX_M4_MASK, VSRL_VX }, // 10812
  { PseudoVSRL_VX_M4_TU, VSRL_VX }, // 10813
  { PseudoVSRL_VX_M8, VSRL_VX }, // 10814
  { PseudoVSRL_VX_M8_MASK, VSRL_VX }, // 10815
  { PseudoVSRL_VX_M8_TU, VSRL_VX }, // 10816
  { PseudoVSRL_VX_MF2, VSRL_VX }, // 10817
  { PseudoVSRL_VX_MF2_MASK, VSRL_VX }, // 10818
  { PseudoVSRL_VX_MF2_TU, VSRL_VX }, // 10819
  { PseudoVSRL_VX_MF4, VSRL_VX }, // 10820
  { PseudoVSRL_VX_MF4_MASK, VSRL_VX }, // 10821
  { PseudoVSRL_VX_MF4_TU, VSRL_VX }, // 10822
  { PseudoVSRL_VX_MF8, VSRL_VX }, // 10823
  { PseudoVSRL_VX_MF8_MASK, VSRL_VX }, // 10824
  { PseudoVSRL_VX_MF8_TU, VSRL_VX }, // 10825
  { PseudoVSSE16_V_M1, VSSE16_V }, // 10826
  { PseudoVSSE16_V_M1_MASK, VSSE16_V }, // 10827
  { PseudoVSSE16_V_M2, VSSE16_V }, // 10828
  { PseudoVSSE16_V_M2_MASK, VSSE16_V }, // 10829
  { PseudoVSSE16_V_M4, VSSE16_V }, // 10830
  { PseudoVSSE16_V_M4_MASK, VSSE16_V }, // 10831
  { PseudoVSSE16_V_M8, VSSE16_V }, // 10832
  { PseudoVSSE16_V_M8_MASK, VSSE16_V }, // 10833
  { PseudoVSSE16_V_MF2, VSSE16_V }, // 10834
  { PseudoVSSE16_V_MF2_MASK, VSSE16_V }, // 10835
  { PseudoVSSE16_V_MF4, VSSE16_V }, // 10836
  { PseudoVSSE16_V_MF4_MASK, VSSE16_V }, // 10837
  { PseudoVSSE32_V_M1, VSSE32_V }, // 10838
  { PseudoVSSE32_V_M1_MASK, VSSE32_V }, // 10839
  { PseudoVSSE32_V_M2, VSSE32_V }, // 10840
  { PseudoVSSE32_V_M2_MASK, VSSE32_V }, // 10841
  { PseudoVSSE32_V_M4, VSSE32_V }, // 10842
  { PseudoVSSE32_V_M4_MASK, VSSE32_V }, // 10843
  { PseudoVSSE32_V_M8, VSSE32_V }, // 10844
  { PseudoVSSE32_V_M8_MASK, VSSE32_V }, // 10845
  { PseudoVSSE32_V_MF2, VSSE32_V }, // 10846
  { PseudoVSSE32_V_MF2_MASK, VSSE32_V }, // 10847
  { PseudoVSSE64_V_M1, VSSE64_V }, // 10848
  { PseudoVSSE64_V_M1_MASK, VSSE64_V }, // 10849
  { PseudoVSSE64_V_M2, VSSE64_V }, // 10850
  { PseudoVSSE64_V_M2_MASK, VSSE64_V }, // 10851
  { PseudoVSSE64_V_M4, VSSE64_V }, // 10852
  { PseudoVSSE64_V_M4_MASK, VSSE64_V }, // 10853
  { PseudoVSSE64_V_M8, VSSE64_V }, // 10854
  { PseudoVSSE64_V_M8_MASK, VSSE64_V }, // 10855
  { PseudoVSSE8_V_M1, VSSE8_V }, // 10856
  { PseudoVSSE8_V_M1_MASK, VSSE8_V }, // 10857
  { PseudoVSSE8_V_M2, VSSE8_V }, // 10858
  { PseudoVSSE8_V_M2_MASK, VSSE8_V }, // 10859
  { PseudoVSSE8_V_M4, VSSE8_V }, // 10860
  { PseudoVSSE8_V_M4_MASK, VSSE8_V }, // 10861
  { PseudoVSSE8_V_M8, VSSE8_V }, // 10862
  { PseudoVSSE8_V_M8_MASK, VSSE8_V }, // 10863
  { PseudoVSSE8_V_MF2, VSSE8_V }, // 10864
  { PseudoVSSE8_V_MF2_MASK, VSSE8_V }, // 10865
  { PseudoVSSE8_V_MF4, VSSE8_V }, // 10866
  { PseudoVSSE8_V_MF4_MASK, VSSE8_V }, // 10867
  { PseudoVSSE8_V_MF8, VSSE8_V }, // 10868
  { PseudoVSSE8_V_MF8_MASK, VSSE8_V }, // 10869
  { PseudoVSSEG2E16_V_M1, VSSEG2E16_V }, // 10870
  { PseudoVSSEG2E16_V_M1_MASK, VSSEG2E16_V }, // 10871
  { PseudoVSSEG2E16_V_M2, VSSEG2E16_V }, // 10872
  { PseudoVSSEG2E16_V_M2_MASK, VSSEG2E16_V }, // 10873
  { PseudoVSSEG2E16_V_M4, VSSEG2E16_V }, // 10874
  { PseudoVSSEG2E16_V_M4_MASK, VSSEG2E16_V }, // 10875
  { PseudoVSSEG2E16_V_MF2, VSSEG2E16_V }, // 10876
  { PseudoVSSEG2E16_V_MF2_MASK, VSSEG2E16_V }, // 10877
  { PseudoVSSEG2E16_V_MF4, VSSEG2E16_V }, // 10878
  { PseudoVSSEG2E16_V_MF4_MASK, VSSEG2E16_V }, // 10879
  { PseudoVSSEG2E32_V_M1, VSSEG2E32_V }, // 10880
  { PseudoVSSEG2E32_V_M1_MASK, VSSEG2E32_V }, // 10881
  { PseudoVSSEG2E32_V_M2, VSSEG2E32_V }, // 10882
  { PseudoVSSEG2E32_V_M2_MASK, VSSEG2E32_V }, // 10883
  { PseudoVSSEG2E32_V_M4, VSSEG2E32_V }, // 10884
  { PseudoVSSEG2E32_V_M4_MASK, VSSEG2E32_V }, // 10885
  { PseudoVSSEG2E32_V_MF2, VSSEG2E32_V }, // 10886
  { PseudoVSSEG2E32_V_MF2_MASK, VSSEG2E32_V }, // 10887
  { PseudoVSSEG2E64_V_M1, VSSEG2E64_V }, // 10888
  { PseudoVSSEG2E64_V_M1_MASK, VSSEG2E64_V }, // 10889
  { PseudoVSSEG2E64_V_M2, VSSEG2E64_V }, // 10890
  { PseudoVSSEG2E64_V_M2_MASK, VSSEG2E64_V }, // 10891
  { PseudoVSSEG2E64_V_M4, VSSEG2E64_V }, // 10892
  { PseudoVSSEG2E64_V_M4_MASK, VSSEG2E64_V }, // 10893
  { PseudoVSSEG2E8_V_M1, VSSEG2E8_V }, // 10894
  { PseudoVSSEG2E8_V_M1_MASK, VSSEG2E8_V }, // 10895
  { PseudoVSSEG2E8_V_M2, VSSEG2E8_V }, // 10896
  { PseudoVSSEG2E8_V_M2_MASK, VSSEG2E8_V }, // 10897
  { PseudoVSSEG2E8_V_M4, VSSEG2E8_V }, // 10898
  { PseudoVSSEG2E8_V_M4_MASK, VSSEG2E8_V }, // 10899
  { PseudoVSSEG2E8_V_MF2, VSSEG2E8_V }, // 10900
  { PseudoVSSEG2E8_V_MF2_MASK, VSSEG2E8_V }, // 10901
  { PseudoVSSEG2E8_V_MF4, VSSEG2E8_V }, // 10902
  { PseudoVSSEG2E8_V_MF4_MASK, VSSEG2E8_V }, // 10903
  { PseudoVSSEG2E8_V_MF8, VSSEG2E8_V }, // 10904
  { PseudoVSSEG2E8_V_MF8_MASK, VSSEG2E8_V }, // 10905
  { PseudoVSSEG3E16_V_M1, VSSEG3E16_V }, // 10906
  { PseudoVSSEG3E16_V_M1_MASK, VSSEG3E16_V }, // 10907
  { PseudoVSSEG3E16_V_M2, VSSEG3E16_V }, // 10908
  { PseudoVSSEG3E16_V_M2_MASK, VSSEG3E16_V }, // 10909
  { PseudoVSSEG3E16_V_MF2, VSSEG3E16_V }, // 10910
  { PseudoVSSEG3E16_V_MF2_MASK, VSSEG3E16_V }, // 10911
  { PseudoVSSEG3E16_V_MF4, VSSEG3E16_V }, // 10912
  { PseudoVSSEG3E16_V_MF4_MASK, VSSEG3E16_V }, // 10913
  { PseudoVSSEG3E32_V_M1, VSSEG3E32_V }, // 10914
  { PseudoVSSEG3E32_V_M1_MASK, VSSEG3E32_V }, // 10915
  { PseudoVSSEG3E32_V_M2, VSSEG3E32_V }, // 10916
  { PseudoVSSEG3E32_V_M2_MASK, VSSEG3E32_V }, // 10917
  { PseudoVSSEG3E32_V_MF2, VSSEG3E32_V }, // 10918
  { PseudoVSSEG3E32_V_MF2_MASK, VSSEG3E32_V }, // 10919
  { PseudoVSSEG3E64_V_M1, VSSEG3E64_V }, // 10920
  { PseudoVSSEG3E64_V_M1_MASK, VSSEG3E64_V }, // 10921
  { PseudoVSSEG3E64_V_M2, VSSEG3E64_V }, // 10922
  { PseudoVSSEG3E64_V_M2_MASK, VSSEG3E64_V }, // 10923
  { PseudoVSSEG3E8_V_M1, VSSEG3E8_V }, // 10924
  { PseudoVSSEG3E8_V_M1_MASK, VSSEG3E8_V }, // 10925
  { PseudoVSSEG3E8_V_M2, VSSEG3E8_V }, // 10926
  { PseudoVSSEG3E8_V_M2_MASK, VSSEG3E8_V }, // 10927
  { PseudoVSSEG3E8_V_MF2, VSSEG3E8_V }, // 10928
  { PseudoVSSEG3E8_V_MF2_MASK, VSSEG3E8_V }, // 10929
  { PseudoVSSEG3E8_V_MF4, VSSEG3E8_V }, // 10930
  { PseudoVSSEG3E8_V_MF4_MASK, VSSEG3E8_V }, // 10931
  { PseudoVSSEG3E8_V_MF8, VSSEG3E8_V }, // 10932
  { PseudoVSSEG3E8_V_MF8_MASK, VSSEG3E8_V }, // 10933
  { PseudoVSSEG4E16_V_M1, VSSEG4E16_V }, // 10934
  { PseudoVSSEG4E16_V_M1_MASK, VSSEG4E16_V }, // 10935
  { PseudoVSSEG4E16_V_M2, VSSEG4E16_V }, // 10936
  { PseudoVSSEG4E16_V_M2_MASK, VSSEG4E16_V }, // 10937
  { PseudoVSSEG4E16_V_MF2, VSSEG4E16_V }, // 10938
  { PseudoVSSEG4E16_V_MF2_MASK, VSSEG4E16_V }, // 10939
  { PseudoVSSEG4E16_V_MF4, VSSEG4E16_V }, // 10940
  { PseudoVSSEG4E16_V_MF4_MASK, VSSEG4E16_V }, // 10941
  { PseudoVSSEG4E32_V_M1, VSSEG4E32_V }, // 10942
  { PseudoVSSEG4E32_V_M1_MASK, VSSEG4E32_V }, // 10943
  { PseudoVSSEG4E32_V_M2, VSSEG4E32_V }, // 10944
  { PseudoVSSEG4E32_V_M2_MASK, VSSEG4E32_V }, // 10945
  { PseudoVSSEG4E32_V_MF2, VSSEG4E32_V }, // 10946
  { PseudoVSSEG4E32_V_MF2_MASK, VSSEG4E32_V }, // 10947
  { PseudoVSSEG4E64_V_M1, VSSEG4E64_V }, // 10948
  { PseudoVSSEG4E64_V_M1_MASK, VSSEG4E64_V }, // 10949
  { PseudoVSSEG4E64_V_M2, VSSEG4E64_V }, // 10950
  { PseudoVSSEG4E64_V_M2_MASK, VSSEG4E64_V }, // 10951
  { PseudoVSSEG4E8_V_M1, VSSEG4E8_V }, // 10952
  { PseudoVSSEG4E8_V_M1_MASK, VSSEG4E8_V }, // 10953
  { PseudoVSSEG4E8_V_M2, VSSEG4E8_V }, // 10954
  { PseudoVSSEG4E8_V_M2_MASK, VSSEG4E8_V }, // 10955
  { PseudoVSSEG4E8_V_MF2, VSSEG4E8_V }, // 10956
  { PseudoVSSEG4E8_V_MF2_MASK, VSSEG4E8_V }, // 10957
  { PseudoVSSEG4E8_V_MF4, VSSEG4E8_V }, // 10958
  { PseudoVSSEG4E8_V_MF4_MASK, VSSEG4E8_V }, // 10959
  { PseudoVSSEG4E8_V_MF8, VSSEG4E8_V }, // 10960
  { PseudoVSSEG4E8_V_MF8_MASK, VSSEG4E8_V }, // 10961
  { PseudoVSSEG5E16_V_M1, VSSEG5E16_V }, // 10962
  { PseudoVSSEG5E16_V_M1_MASK, VSSEG5E16_V }, // 10963
  { PseudoVSSEG5E16_V_MF2, VSSEG5E16_V }, // 10964
  { PseudoVSSEG5E16_V_MF2_MASK, VSSEG5E16_V }, // 10965
  { PseudoVSSEG5E16_V_MF4, VSSEG5E16_V }, // 10966
  { PseudoVSSEG5E16_V_MF4_MASK, VSSEG5E16_V }, // 10967
  { PseudoVSSEG5E32_V_M1, VSSEG5E32_V }, // 10968
  { PseudoVSSEG5E32_V_M1_MASK, VSSEG5E32_V }, // 10969
  { PseudoVSSEG5E32_V_MF2, VSSEG5E32_V }, // 10970
  { PseudoVSSEG5E32_V_MF2_MASK, VSSEG5E32_V }, // 10971
  { PseudoVSSEG5E64_V_M1, VSSEG5E64_V }, // 10972
  { PseudoVSSEG5E64_V_M1_MASK, VSSEG5E64_V }, // 10973
  { PseudoVSSEG5E8_V_M1, VSSEG5E8_V }, // 10974
  { PseudoVSSEG5E8_V_M1_MASK, VSSEG5E8_V }, // 10975
  { PseudoVSSEG5E8_V_MF2, VSSEG5E8_V }, // 10976
  { PseudoVSSEG5E8_V_MF2_MASK, VSSEG5E8_V }, // 10977
  { PseudoVSSEG5E8_V_MF4, VSSEG5E8_V }, // 10978
  { PseudoVSSEG5E8_V_MF4_MASK, VSSEG5E8_V }, // 10979
  { PseudoVSSEG5E8_V_MF8, VSSEG5E8_V }, // 10980
  { PseudoVSSEG5E8_V_MF8_MASK, VSSEG5E8_V }, // 10981
  { PseudoVSSEG6E16_V_M1, VSSEG6E16_V }, // 10982
  { PseudoVSSEG6E16_V_M1_MASK, VSSEG6E16_V }, // 10983
  { PseudoVSSEG6E16_V_MF2, VSSEG6E16_V }, // 10984
  { PseudoVSSEG6E16_V_MF2_MASK, VSSEG6E16_V }, // 10985
  { PseudoVSSEG6E16_V_MF4, VSSEG6E16_V }, // 10986
  { PseudoVSSEG6E16_V_MF4_MASK, VSSEG6E16_V }, // 10987
  { PseudoVSSEG6E32_V_M1, VSSEG6E32_V }, // 10988
  { PseudoVSSEG6E32_V_M1_MASK, VSSEG6E32_V }, // 10989
  { PseudoVSSEG6E32_V_MF2, VSSEG6E32_V }, // 10990
  { PseudoVSSEG6E32_V_MF2_MASK, VSSEG6E32_V }, // 10991
  { PseudoVSSEG6E64_V_M1, VSSEG6E64_V }, // 10992
  { PseudoVSSEG6E64_V_M1_MASK, VSSEG6E64_V }, // 10993
  { PseudoVSSEG6E8_V_M1, VSSEG6E8_V }, // 10994
  { PseudoVSSEG6E8_V_M1_MASK, VSSEG6E8_V }, // 10995
  { PseudoVSSEG6E8_V_MF2, VSSEG6E8_V }, // 10996
  { PseudoVSSEG6E8_V_MF2_MASK, VSSEG6E8_V }, // 10997
  { PseudoVSSEG6E8_V_MF4, VSSEG6E8_V }, // 10998
  { PseudoVSSEG6E8_V_MF4_MASK, VSSEG6E8_V }, // 10999
  { PseudoVSSEG6E8_V_MF8, VSSEG6E8_V }, // 11000
  { PseudoVSSEG6E8_V_MF8_MASK, VSSEG6E8_V }, // 11001
  { PseudoVSSEG7E16_V_M1, VSSEG7E16_V }, // 11002
  { PseudoVSSEG7E16_V_M1_MASK, VSSEG7E16_V }, // 11003
  { PseudoVSSEG7E16_V_MF2, VSSEG7E16_V }, // 11004
  { PseudoVSSEG7E16_V_MF2_MASK, VSSEG7E16_V }, // 11005
  { PseudoVSSEG7E16_V_MF4, VSSEG7E16_V }, // 11006
  { PseudoVSSEG7E16_V_MF4_MASK, VSSEG7E16_V }, // 11007
  { PseudoVSSEG7E32_V_M1, VSSEG7E32_V }, // 11008
  { PseudoVSSEG7E32_V_M1_MASK, VSSEG7E32_V }, // 11009
  { PseudoVSSEG7E32_V_MF2, VSSEG7E32_V }, // 11010
  { PseudoVSSEG7E32_V_MF2_MASK, VSSEG7E32_V }, // 11011
  { PseudoVSSEG7E64_V_M1, VSSEG7E64_V }, // 11012
  { PseudoVSSEG7E64_V_M1_MASK, VSSEG7E64_V }, // 11013
  { PseudoVSSEG7E8_V_M1, VSSEG7E8_V }, // 11014
  { PseudoVSSEG7E8_V_M1_MASK, VSSEG7E8_V }, // 11015
  { PseudoVSSEG7E8_V_MF2, VSSEG7E8_V }, // 11016
  { PseudoVSSEG7E8_V_MF2_MASK, VSSEG7E8_V }, // 11017
  { PseudoVSSEG7E8_V_MF4, VSSEG7E8_V }, // 11018
  { PseudoVSSEG7E8_V_MF4_MASK, VSSEG7E8_V }, // 11019
  { PseudoVSSEG7E8_V_MF8, VSSEG7E8_V }, // 11020
  { PseudoVSSEG7E8_V_MF8_MASK, VSSEG7E8_V }, // 11021
  { PseudoVSSEG8E16_V_M1, VSSEG8E16_V }, // 11022
  { PseudoVSSEG8E16_V_M1_MASK, VSSEG8E16_V }, // 11023
  { PseudoVSSEG8E16_V_MF2, VSSEG8E16_V }, // 11024
  { PseudoVSSEG8E16_V_MF2_MASK, VSSEG8E16_V }, // 11025
  { PseudoVSSEG8E16_V_MF4, VSSEG8E16_V }, // 11026
  { PseudoVSSEG8E16_V_MF4_MASK, VSSEG8E16_V }, // 11027
  { PseudoVSSEG8E32_V_M1, VSSEG8E32_V }, // 11028
  { PseudoVSSEG8E32_V_M1_MASK, VSSEG8E32_V }, // 11029
  { PseudoVSSEG8E32_V_MF2, VSSEG8E32_V }, // 11030
  { PseudoVSSEG8E32_V_MF2_MASK, VSSEG8E32_V }, // 11031
  { PseudoVSSEG8E64_V_M1, VSSEG8E64_V }, // 11032
  { PseudoVSSEG8E64_V_M1_MASK, VSSEG8E64_V }, // 11033
  { PseudoVSSEG8E8_V_M1, VSSEG8E8_V }, // 11034
  { PseudoVSSEG8E8_V_M1_MASK, VSSEG8E8_V }, // 11035
  { PseudoVSSEG8E8_V_MF2, VSSEG8E8_V }, // 11036
  { PseudoVSSEG8E8_V_MF2_MASK, VSSEG8E8_V }, // 11037
  { PseudoVSSEG8E8_V_MF4, VSSEG8E8_V }, // 11038
  { PseudoVSSEG8E8_V_MF4_MASK, VSSEG8E8_V }, // 11039
  { PseudoVSSEG8E8_V_MF8, VSSEG8E8_V }, // 11040
  { PseudoVSSEG8E8_V_MF8_MASK, VSSEG8E8_V }, // 11041
  { PseudoVSSRA_VI_M1, VSSRA_VI }, // 11042
  { PseudoVSSRA_VI_M1_MASK, VSSRA_VI }, // 11043
  { PseudoVSSRA_VI_M1_TU, VSSRA_VI }, // 11044
  { PseudoVSSRA_VI_M2, VSSRA_VI }, // 11045
  { PseudoVSSRA_VI_M2_MASK, VSSRA_VI }, // 11046
  { PseudoVSSRA_VI_M2_TU, VSSRA_VI }, // 11047
  { PseudoVSSRA_VI_M4, VSSRA_VI }, // 11048
  { PseudoVSSRA_VI_M4_MASK, VSSRA_VI }, // 11049
  { PseudoVSSRA_VI_M4_TU, VSSRA_VI }, // 11050
  { PseudoVSSRA_VI_M8, VSSRA_VI }, // 11051
  { PseudoVSSRA_VI_M8_MASK, VSSRA_VI }, // 11052
  { PseudoVSSRA_VI_M8_TU, VSSRA_VI }, // 11053
  { PseudoVSSRA_VI_MF2, VSSRA_VI }, // 11054
  { PseudoVSSRA_VI_MF2_MASK, VSSRA_VI }, // 11055
  { PseudoVSSRA_VI_MF2_TU, VSSRA_VI }, // 11056
  { PseudoVSSRA_VI_MF4, VSSRA_VI }, // 11057
  { PseudoVSSRA_VI_MF4_MASK, VSSRA_VI }, // 11058
  { PseudoVSSRA_VI_MF4_TU, VSSRA_VI }, // 11059
  { PseudoVSSRA_VI_MF8, VSSRA_VI }, // 11060
  { PseudoVSSRA_VI_MF8_MASK, VSSRA_VI }, // 11061
  { PseudoVSSRA_VI_MF8_TU, VSSRA_VI }, // 11062
  { PseudoVSSRA_VV_M1, VSSRA_VV }, // 11063
  { PseudoVSSRA_VV_M1_MASK, VSSRA_VV }, // 11064
  { PseudoVSSRA_VV_M1_TU, VSSRA_VV }, // 11065
  { PseudoVSSRA_VV_M2, VSSRA_VV }, // 11066
  { PseudoVSSRA_VV_M2_MASK, VSSRA_VV }, // 11067
  { PseudoVSSRA_VV_M2_TU, VSSRA_VV }, // 11068
  { PseudoVSSRA_VV_M4, VSSRA_VV }, // 11069
  { PseudoVSSRA_VV_M4_MASK, VSSRA_VV }, // 11070
  { PseudoVSSRA_VV_M4_TU, VSSRA_VV }, // 11071
  { PseudoVSSRA_VV_M8, VSSRA_VV }, // 11072
  { PseudoVSSRA_VV_M8_MASK, VSSRA_VV }, // 11073
  { PseudoVSSRA_VV_M8_TU, VSSRA_VV }, // 11074
  { PseudoVSSRA_VV_MF2, VSSRA_VV }, // 11075
  { PseudoVSSRA_VV_MF2_MASK, VSSRA_VV }, // 11076
  { PseudoVSSRA_VV_MF2_TU, VSSRA_VV }, // 11077
  { PseudoVSSRA_VV_MF4, VSSRA_VV }, // 11078
  { PseudoVSSRA_VV_MF4_MASK, VSSRA_VV }, // 11079
  { PseudoVSSRA_VV_MF4_TU, VSSRA_VV }, // 11080
  { PseudoVSSRA_VV_MF8, VSSRA_VV }, // 11081
  { PseudoVSSRA_VV_MF8_MASK, VSSRA_VV }, // 11082
  { PseudoVSSRA_VV_MF8_TU, VSSRA_VV }, // 11083
  { PseudoVSSRA_VX_M1, VSSRA_VX }, // 11084
  { PseudoVSSRA_VX_M1_MASK, VSSRA_VX }, // 11085
  { PseudoVSSRA_VX_M1_TU, VSSRA_VX }, // 11086
  { PseudoVSSRA_VX_M2, VSSRA_VX }, // 11087
  { PseudoVSSRA_VX_M2_MASK, VSSRA_VX }, // 11088
  { PseudoVSSRA_VX_M2_TU, VSSRA_VX }, // 11089
  { PseudoVSSRA_VX_M4, VSSRA_VX }, // 11090
  { PseudoVSSRA_VX_M4_MASK, VSSRA_VX }, // 11091
  { PseudoVSSRA_VX_M4_TU, VSSRA_VX }, // 11092
  { PseudoVSSRA_VX_M8, VSSRA_VX }, // 11093
  { PseudoVSSRA_VX_M8_MASK, VSSRA_VX }, // 11094
  { PseudoVSSRA_VX_M8_TU, VSSRA_VX }, // 11095
  { PseudoVSSRA_VX_MF2, VSSRA_VX }, // 11096
  { PseudoVSSRA_VX_MF2_MASK, VSSRA_VX }, // 11097
  { PseudoVSSRA_VX_MF2_TU, VSSRA_VX }, // 11098
  { PseudoVSSRA_VX_MF4, VSSRA_VX }, // 11099
  { PseudoVSSRA_VX_MF4_MASK, VSSRA_VX }, // 11100
  { PseudoVSSRA_VX_MF4_TU, VSSRA_VX }, // 11101
  { PseudoVSSRA_VX_MF8, VSSRA_VX }, // 11102
  { PseudoVSSRA_VX_MF8_MASK, VSSRA_VX }, // 11103
  { PseudoVSSRA_VX_MF8_TU, VSSRA_VX }, // 11104
  { PseudoVSSRL_VI_M1, VSSRL_VI }, // 11105
  { PseudoVSSRL_VI_M1_MASK, VSSRL_VI }, // 11106
  { PseudoVSSRL_VI_M1_TU, VSSRL_VI }, // 11107
  { PseudoVSSRL_VI_M2, VSSRL_VI }, // 11108
  { PseudoVSSRL_VI_M2_MASK, VSSRL_VI }, // 11109
  { PseudoVSSRL_VI_M2_TU, VSSRL_VI }, // 11110
  { PseudoVSSRL_VI_M4, VSSRL_VI }, // 11111
  { PseudoVSSRL_VI_M4_MASK, VSSRL_VI }, // 11112
  { PseudoVSSRL_VI_M4_TU, VSSRL_VI }, // 11113
  { PseudoVSSRL_VI_M8, VSSRL_VI }, // 11114
  { PseudoVSSRL_VI_M8_MASK, VSSRL_VI }, // 11115
  { PseudoVSSRL_VI_M8_TU, VSSRL_VI }, // 11116
  { PseudoVSSRL_VI_MF2, VSSRL_VI }, // 11117
  { PseudoVSSRL_VI_MF2_MASK, VSSRL_VI }, // 11118
  { PseudoVSSRL_VI_MF2_TU, VSSRL_VI }, // 11119
  { PseudoVSSRL_VI_MF4, VSSRL_VI }, // 11120
  { PseudoVSSRL_VI_MF4_MASK, VSSRL_VI }, // 11121
  { PseudoVSSRL_VI_MF4_TU, VSSRL_VI }, // 11122
  { PseudoVSSRL_VI_MF8, VSSRL_VI }, // 11123
  { PseudoVSSRL_VI_MF8_MASK, VSSRL_VI }, // 11124
  { PseudoVSSRL_VI_MF8_TU, VSSRL_VI }, // 11125
  { PseudoVSSRL_VV_M1, VSSRL_VV }, // 11126
  { PseudoVSSRL_VV_M1_MASK, VSSRL_VV }, // 11127
  { PseudoVSSRL_VV_M1_TU, VSSRL_VV }, // 11128
  { PseudoVSSRL_VV_M2, VSSRL_VV }, // 11129
  { PseudoVSSRL_VV_M2_MASK, VSSRL_VV }, // 11130
  { PseudoVSSRL_VV_M2_TU, VSSRL_VV }, // 11131
  { PseudoVSSRL_VV_M4, VSSRL_VV }, // 11132
  { PseudoVSSRL_VV_M4_MASK, VSSRL_VV }, // 11133
  { PseudoVSSRL_VV_M4_TU, VSSRL_VV }, // 11134
  { PseudoVSSRL_VV_M8, VSSRL_VV }, // 11135
  { PseudoVSSRL_VV_M8_MASK, VSSRL_VV }, // 11136
  { PseudoVSSRL_VV_M8_TU, VSSRL_VV }, // 11137
  { PseudoVSSRL_VV_MF2, VSSRL_VV }, // 11138
  { PseudoVSSRL_VV_MF2_MASK, VSSRL_VV }, // 11139
  { PseudoVSSRL_VV_MF2_TU, VSSRL_VV }, // 11140
  { PseudoVSSRL_VV_MF4, VSSRL_VV }, // 11141
  { PseudoVSSRL_VV_MF4_MASK, VSSRL_VV }, // 11142
  { PseudoVSSRL_VV_MF4_TU, VSSRL_VV }, // 11143
  { PseudoVSSRL_VV_MF8, VSSRL_VV }, // 11144
  { PseudoVSSRL_VV_MF8_MASK, VSSRL_VV }, // 11145
  { PseudoVSSRL_VV_MF8_TU, VSSRL_VV }, // 11146
  { PseudoVSSRL_VX_M1, VSSRL_VX }, // 11147
  { PseudoVSSRL_VX_M1_MASK, VSSRL_VX }, // 11148
  { PseudoVSSRL_VX_M1_TU, VSSRL_VX }, // 11149
  { PseudoVSSRL_VX_M2, VSSRL_VX }, // 11150
  { PseudoVSSRL_VX_M2_MASK, VSSRL_VX }, // 11151
  { PseudoVSSRL_VX_M2_TU, VSSRL_VX }, // 11152
  { PseudoVSSRL_VX_M4, VSSRL_VX }, // 11153
  { PseudoVSSRL_VX_M4_MASK, VSSRL_VX }, // 11154
  { PseudoVSSRL_VX_M4_TU, VSSRL_VX }, // 11155
  { PseudoVSSRL_VX_M8, VSSRL_VX }, // 11156
  { PseudoVSSRL_VX_M8_MASK, VSSRL_VX }, // 11157
  { PseudoVSSRL_VX_M8_TU, VSSRL_VX }, // 11158
  { PseudoVSSRL_VX_MF2, VSSRL_VX }, // 11159
  { PseudoVSSRL_VX_MF2_MASK, VSSRL_VX }, // 11160
  { PseudoVSSRL_VX_MF2_TU, VSSRL_VX }, // 11161
  { PseudoVSSRL_VX_MF4, VSSRL_VX }, // 11162
  { PseudoVSSRL_VX_MF4_MASK, VSSRL_VX }, // 11163
  { PseudoVSSRL_VX_MF4_TU, VSSRL_VX }, // 11164
  { PseudoVSSRL_VX_MF8, VSSRL_VX }, // 11165
  { PseudoVSSRL_VX_MF8_MASK, VSSRL_VX }, // 11166
  { PseudoVSSRL_VX_MF8_TU, VSSRL_VX }, // 11167
  { PseudoVSSSEG2E16_V_M1, VSSSEG2E16_V }, // 11168
  { PseudoVSSSEG2E16_V_M1_MASK, VSSSEG2E16_V }, // 11169
  { PseudoVSSSEG2E16_V_M2, VSSSEG2E16_V }, // 11170
  { PseudoVSSSEG2E16_V_M2_MASK, VSSSEG2E16_V }, // 11171
  { PseudoVSSSEG2E16_V_M4, VSSSEG2E16_V }, // 11172
  { PseudoVSSSEG2E16_V_M4_MASK, VSSSEG2E16_V }, // 11173
  { PseudoVSSSEG2E16_V_MF2, VSSSEG2E16_V }, // 11174
  { PseudoVSSSEG2E16_V_MF2_MASK, VSSSEG2E16_V }, // 11175
  { PseudoVSSSEG2E16_V_MF4, VSSSEG2E16_V }, // 11176
  { PseudoVSSSEG2E16_V_MF4_MASK, VSSSEG2E16_V }, // 11177
  { PseudoVSSSEG2E32_V_M1, VSSSEG2E32_V }, // 11178
  { PseudoVSSSEG2E32_V_M1_MASK, VSSSEG2E32_V }, // 11179
  { PseudoVSSSEG2E32_V_M2, VSSSEG2E32_V }, // 11180
  { PseudoVSSSEG2E32_V_M2_MASK, VSSSEG2E32_V }, // 11181
  { PseudoVSSSEG2E32_V_M4, VSSSEG2E32_V }, // 11182
  { PseudoVSSSEG2E32_V_M4_MASK, VSSSEG2E32_V }, // 11183
  { PseudoVSSSEG2E32_V_MF2, VSSSEG2E32_V }, // 11184
  { PseudoVSSSEG2E32_V_MF2_MASK, VSSSEG2E32_V }, // 11185
  { PseudoVSSSEG2E64_V_M1, VSSSEG2E64_V }, // 11186
  { PseudoVSSSEG2E64_V_M1_MASK, VSSSEG2E64_V }, // 11187
  { PseudoVSSSEG2E64_V_M2, VSSSEG2E64_V }, // 11188
  { PseudoVSSSEG2E64_V_M2_MASK, VSSSEG2E64_V }, // 11189
  { PseudoVSSSEG2E64_V_M4, VSSSEG2E64_V }, // 11190
  { PseudoVSSSEG2E64_V_M4_MASK, VSSSEG2E64_V }, // 11191
  { PseudoVSSSEG2E8_V_M1, VSSSEG2E8_V }, // 11192
  { PseudoVSSSEG2E8_V_M1_MASK, VSSSEG2E8_V }, // 11193
  { PseudoVSSSEG2E8_V_M2, VSSSEG2E8_V }, // 11194
  { PseudoVSSSEG2E8_V_M2_MASK, VSSSEG2E8_V }, // 11195
  { PseudoVSSSEG2E8_V_M4, VSSSEG2E8_V }, // 11196
  { PseudoVSSSEG2E8_V_M4_MASK, VSSSEG2E8_V }, // 11197
  { PseudoVSSSEG2E8_V_MF2, VSSSEG2E8_V }, // 11198
  { PseudoVSSSEG2E8_V_MF2_MASK, VSSSEG2E8_V }, // 11199
  { PseudoVSSSEG2E8_V_MF4, VSSSEG2E8_V }, // 11200
  { PseudoVSSSEG2E8_V_MF4_MASK, VSSSEG2E8_V }, // 11201
  { PseudoVSSSEG2E8_V_MF8, VSSSEG2E8_V }, // 11202
  { PseudoVSSSEG2E8_V_MF8_MASK, VSSSEG2E8_V }, // 11203
  { PseudoVSSSEG3E16_V_M1, VSSSEG3E16_V }, // 11204
  { PseudoVSSSEG3E16_V_M1_MASK, VSSSEG3E16_V }, // 11205
  { PseudoVSSSEG3E16_V_M2, VSSSEG3E16_V }, // 11206
  { PseudoVSSSEG3E16_V_M2_MASK, VSSSEG3E16_V }, // 11207
  { PseudoVSSSEG3E16_V_MF2, VSSSEG3E16_V }, // 11208
  { PseudoVSSSEG3E16_V_MF2_MASK, VSSSEG3E16_V }, // 11209
  { PseudoVSSSEG3E16_V_MF4, VSSSEG3E16_V }, // 11210
  { PseudoVSSSEG3E16_V_MF4_MASK, VSSSEG3E16_V }, // 11211
  { PseudoVSSSEG3E32_V_M1, VSSSEG3E32_V }, // 11212
  { PseudoVSSSEG3E32_V_M1_MASK, VSSSEG3E32_V }, // 11213
  { PseudoVSSSEG3E32_V_M2, VSSSEG3E32_V }, // 11214
  { PseudoVSSSEG3E32_V_M2_MASK, VSSSEG3E32_V }, // 11215
  { PseudoVSSSEG3E32_V_MF2, VSSSEG3E32_V }, // 11216
  { PseudoVSSSEG3E32_V_MF2_MASK, VSSSEG3E32_V }, // 11217
  { PseudoVSSSEG3E64_V_M1, VSSSEG3E64_V }, // 11218
  { PseudoVSSSEG3E64_V_M1_MASK, VSSSEG3E64_V }, // 11219
  { PseudoVSSSEG3E64_V_M2, VSSSEG3E64_V }, // 11220
  { PseudoVSSSEG3E64_V_M2_MASK, VSSSEG3E64_V }, // 11221
  { PseudoVSSSEG3E8_V_M1, VSSSEG3E8_V }, // 11222
  { PseudoVSSSEG3E8_V_M1_MASK, VSSSEG3E8_V }, // 11223
  { PseudoVSSSEG3E8_V_M2, VSSSEG3E8_V }, // 11224
  { PseudoVSSSEG3E8_V_M2_MASK, VSSSEG3E8_V }, // 11225
  { PseudoVSSSEG3E8_V_MF2, VSSSEG3E8_V }, // 11226
  { PseudoVSSSEG3E8_V_MF2_MASK, VSSSEG3E8_V }, // 11227
  { PseudoVSSSEG3E8_V_MF4, VSSSEG3E8_V }, // 11228
  { PseudoVSSSEG3E8_V_MF4_MASK, VSSSEG3E8_V }, // 11229
  { PseudoVSSSEG3E8_V_MF8, VSSSEG3E8_V }, // 11230
  { PseudoVSSSEG3E8_V_MF8_MASK, VSSSEG3E8_V }, // 11231
  { PseudoVSSSEG4E16_V_M1, VSSSEG4E16_V }, // 11232
  { PseudoVSSSEG4E16_V_M1_MASK, VSSSEG4E16_V }, // 11233
  { PseudoVSSSEG4E16_V_M2, VSSSEG4E16_V }, // 11234
  { PseudoVSSSEG4E16_V_M2_MASK, VSSSEG4E16_V }, // 11235
  { PseudoVSSSEG4E16_V_MF2, VSSSEG4E16_V }, // 11236
  { PseudoVSSSEG4E16_V_MF2_MASK, VSSSEG4E16_V }, // 11237
  { PseudoVSSSEG4E16_V_MF4, VSSSEG4E16_V }, // 11238
  { PseudoVSSSEG4E16_V_MF4_MASK, VSSSEG4E16_V }, // 11239
  { PseudoVSSSEG4E32_V_M1, VSSSEG4E32_V }, // 11240
  { PseudoVSSSEG4E32_V_M1_MASK, VSSSEG4E32_V }, // 11241
  { PseudoVSSSEG4E32_V_M2, VSSSEG4E32_V }, // 11242
  { PseudoVSSSEG4E32_V_M2_MASK, VSSSEG4E32_V }, // 11243
  { PseudoVSSSEG4E32_V_MF2, VSSSEG4E32_V }, // 11244
  { PseudoVSSSEG4E32_V_MF2_MASK, VSSSEG4E32_V }, // 11245
  { PseudoVSSSEG4E64_V_M1, VSSSEG4E64_V }, // 11246
  { PseudoVSSSEG4E64_V_M1_MASK, VSSSEG4E64_V }, // 11247
  { PseudoVSSSEG4E64_V_M2, VSSSEG4E64_V }, // 11248
  { PseudoVSSSEG4E64_V_M2_MASK, VSSSEG4E64_V }, // 11249
  { PseudoVSSSEG4E8_V_M1, VSSSEG4E8_V }, // 11250
  { PseudoVSSSEG4E8_V_M1_MASK, VSSSEG4E8_V }, // 11251
  { PseudoVSSSEG4E8_V_M2, VSSSEG4E8_V }, // 11252
  { PseudoVSSSEG4E8_V_M2_MASK, VSSSEG4E8_V }, // 11253
  { PseudoVSSSEG4E8_V_MF2, VSSSEG4E8_V }, // 11254
  { PseudoVSSSEG4E8_V_MF2_MASK, VSSSEG4E8_V }, // 11255
  { PseudoVSSSEG4E8_V_MF4, VSSSEG4E8_V }, // 11256
  { PseudoVSSSEG4E8_V_MF4_MASK, VSSSEG4E8_V }, // 11257
  { PseudoVSSSEG4E8_V_MF8, VSSSEG4E8_V }, // 11258
  { PseudoVSSSEG4E8_V_MF8_MASK, VSSSEG4E8_V }, // 11259
  { PseudoVSSSEG5E16_V_M1, VSSSEG5E16_V }, // 11260
  { PseudoVSSSEG5E16_V_M1_MASK, VSSSEG5E16_V }, // 11261
  { PseudoVSSSEG5E16_V_MF2, VSSSEG5E16_V }, // 11262
  { PseudoVSSSEG5E16_V_MF2_MASK, VSSSEG5E16_V }, // 11263
  { PseudoVSSSEG5E16_V_MF4, VSSSEG5E16_V }, // 11264
  { PseudoVSSSEG5E16_V_MF4_MASK, VSSSEG5E16_V }, // 11265
  { PseudoVSSSEG5E32_V_M1, VSSSEG5E32_V }, // 11266
  { PseudoVSSSEG5E32_V_M1_MASK, VSSSEG5E32_V }, // 11267
  { PseudoVSSSEG5E32_V_MF2, VSSSEG5E32_V }, // 11268
  { PseudoVSSSEG5E32_V_MF2_MASK, VSSSEG5E32_V }, // 11269
  { PseudoVSSSEG5E64_V_M1, VSSSEG5E64_V }, // 11270
  { PseudoVSSSEG5E64_V_M1_MASK, VSSSEG5E64_V }, // 11271
  { PseudoVSSSEG5E8_V_M1, VSSSEG5E8_V }, // 11272
  { PseudoVSSSEG5E8_V_M1_MASK, VSSSEG5E8_V }, // 11273
  { PseudoVSSSEG5E8_V_MF2, VSSSEG5E8_V }, // 11274
  { PseudoVSSSEG5E8_V_MF2_MASK, VSSSEG5E8_V }, // 11275
  { PseudoVSSSEG5E8_V_MF4, VSSSEG5E8_V }, // 11276
  { PseudoVSSSEG5E8_V_MF4_MASK, VSSSEG5E8_V }, // 11277
  { PseudoVSSSEG5E8_V_MF8, VSSSEG5E8_V }, // 11278
  { PseudoVSSSEG5E8_V_MF8_MASK, VSSSEG5E8_V }, // 11279
  { PseudoVSSSEG6E16_V_M1, VSSSEG6E16_V }, // 11280
  { PseudoVSSSEG6E16_V_M1_MASK, VSSSEG6E16_V }, // 11281
  { PseudoVSSSEG6E16_V_MF2, VSSSEG6E16_V }, // 11282
  { PseudoVSSSEG6E16_V_MF2_MASK, VSSSEG6E16_V }, // 11283
  { PseudoVSSSEG6E16_V_MF4, VSSSEG6E16_V }, // 11284
  { PseudoVSSSEG6E16_V_MF4_MASK, VSSSEG6E16_V }, // 11285
  { PseudoVSSSEG6E32_V_M1, VSSSEG6E32_V }, // 11286
  { PseudoVSSSEG6E32_V_M1_MASK, VSSSEG6E32_V }, // 11287
  { PseudoVSSSEG6E32_V_MF2, VSSSEG6E32_V }, // 11288
  { PseudoVSSSEG6E32_V_MF2_MASK, VSSSEG6E32_V }, // 11289
  { PseudoVSSSEG6E64_V_M1, VSSSEG6E64_V }, // 11290
  { PseudoVSSSEG6E64_V_M1_MASK, VSSSEG6E64_V }, // 11291
  { PseudoVSSSEG6E8_V_M1, VSSSEG6E8_V }, // 11292
  { PseudoVSSSEG6E8_V_M1_MASK, VSSSEG6E8_V }, // 11293
  { PseudoVSSSEG6E8_V_MF2, VSSSEG6E8_V }, // 11294
  { PseudoVSSSEG6E8_V_MF2_MASK, VSSSEG6E8_V }, // 11295
  { PseudoVSSSEG6E8_V_MF4, VSSSEG6E8_V }, // 11296
  { PseudoVSSSEG6E8_V_MF4_MASK, VSSSEG6E8_V }, // 11297
  { PseudoVSSSEG6E8_V_MF8, VSSSEG6E8_V }, // 11298
  { PseudoVSSSEG6E8_V_MF8_MASK, VSSSEG6E8_V }, // 11299
  { PseudoVSSSEG7E16_V_M1, VSSSEG7E16_V }, // 11300
  { PseudoVSSSEG7E16_V_M1_MASK, VSSSEG7E16_V }, // 11301
  { PseudoVSSSEG7E16_V_MF2, VSSSEG7E16_V }, // 11302
  { PseudoVSSSEG7E16_V_MF2_MASK, VSSSEG7E16_V }, // 11303
  { PseudoVSSSEG7E16_V_MF4, VSSSEG7E16_V }, // 11304
  { PseudoVSSSEG7E16_V_MF4_MASK, VSSSEG7E16_V }, // 11305
  { PseudoVSSSEG7E32_V_M1, VSSSEG7E32_V }, // 11306
  { PseudoVSSSEG7E32_V_M1_MASK, VSSSEG7E32_V }, // 11307
  { PseudoVSSSEG7E32_V_MF2, VSSSEG7E32_V }, // 11308
  { PseudoVSSSEG7E32_V_MF2_MASK, VSSSEG7E32_V }, // 11309
  { PseudoVSSSEG7E64_V_M1, VSSSEG7E64_V }, // 11310
  { PseudoVSSSEG7E64_V_M1_MASK, VSSSEG7E64_V }, // 11311
  { PseudoVSSSEG7E8_V_M1, VSSSEG7E8_V }, // 11312
  { PseudoVSSSEG7E8_V_M1_MASK, VSSSEG7E8_V }, // 11313
  { PseudoVSSSEG7E8_V_MF2, VSSSEG7E8_V }, // 11314
  { PseudoVSSSEG7E8_V_MF2_MASK, VSSSEG7E8_V }, // 11315
  { PseudoVSSSEG7E8_V_MF4, VSSSEG7E8_V }, // 11316
  { PseudoVSSSEG7E8_V_MF4_MASK, VSSSEG7E8_V }, // 11317
  { PseudoVSSSEG7E8_V_MF8, VSSSEG7E8_V }, // 11318
  { PseudoVSSSEG7E8_V_MF8_MASK, VSSSEG7E8_V }, // 11319
  { PseudoVSSSEG8E16_V_M1, VSSSEG8E16_V }, // 11320
  { PseudoVSSSEG8E16_V_M1_MASK, VSSSEG8E16_V }, // 11321
  { PseudoVSSSEG8E16_V_MF2, VSSSEG8E16_V }, // 11322
  { PseudoVSSSEG8E16_V_MF2_MASK, VSSSEG8E16_V }, // 11323
  { PseudoVSSSEG8E16_V_MF4, VSSSEG8E16_V }, // 11324
  { PseudoVSSSEG8E16_V_MF4_MASK, VSSSEG8E16_V }, // 11325
  { PseudoVSSSEG8E32_V_M1, VSSSEG8E32_V }, // 11326
  { PseudoVSSSEG8E32_V_M1_MASK, VSSSEG8E32_V }, // 11327
  { PseudoVSSSEG8E32_V_MF2, VSSSEG8E32_V }, // 11328
  { PseudoVSSSEG8E32_V_MF2_MASK, VSSSEG8E32_V }, // 11329
  { PseudoVSSSEG8E64_V_M1, VSSSEG8E64_V }, // 11330
  { PseudoVSSSEG8E64_V_M1_MASK, VSSSEG8E64_V }, // 11331
  { PseudoVSSSEG8E8_V_M1, VSSSEG8E8_V }, // 11332
  { PseudoVSSSEG8E8_V_M1_MASK, VSSSEG8E8_V }, // 11333
  { PseudoVSSSEG8E8_V_MF2, VSSSEG8E8_V }, // 11334
  { PseudoVSSSEG8E8_V_MF2_MASK, VSSSEG8E8_V }, // 11335
  { PseudoVSSSEG8E8_V_MF4, VSSSEG8E8_V }, // 11336
  { PseudoVSSSEG8E8_V_MF4_MASK, VSSSEG8E8_V }, // 11337
  { PseudoVSSSEG8E8_V_MF8, VSSSEG8E8_V }, // 11338
  { PseudoVSSSEG8E8_V_MF8_MASK, VSSSEG8E8_V }, // 11339
  { PseudoVSSUBU_VV_M1, VSSUBU_VV }, // 11340
  { PseudoVSSUBU_VV_M1_MASK, VSSUBU_VV }, // 11341
  { PseudoVSSUBU_VV_M1_TU, VSSUBU_VV }, // 11342
  { PseudoVSSUBU_VV_M2, VSSUBU_VV }, // 11343
  { PseudoVSSUBU_VV_M2_MASK, VSSUBU_VV }, // 11344
  { PseudoVSSUBU_VV_M2_TU, VSSUBU_VV }, // 11345
  { PseudoVSSUBU_VV_M4, VSSUBU_VV }, // 11346
  { PseudoVSSUBU_VV_M4_MASK, VSSUBU_VV }, // 11347
  { PseudoVSSUBU_VV_M4_TU, VSSUBU_VV }, // 11348
  { PseudoVSSUBU_VV_M8, VSSUBU_VV }, // 11349
  { PseudoVSSUBU_VV_M8_MASK, VSSUBU_VV }, // 11350
  { PseudoVSSUBU_VV_M8_TU, VSSUBU_VV }, // 11351
  { PseudoVSSUBU_VV_MF2, VSSUBU_VV }, // 11352
  { PseudoVSSUBU_VV_MF2_MASK, VSSUBU_VV }, // 11353
  { PseudoVSSUBU_VV_MF2_TU, VSSUBU_VV }, // 11354
  { PseudoVSSUBU_VV_MF4, VSSUBU_VV }, // 11355
  { PseudoVSSUBU_VV_MF4_MASK, VSSUBU_VV }, // 11356
  { PseudoVSSUBU_VV_MF4_TU, VSSUBU_VV }, // 11357
  { PseudoVSSUBU_VV_MF8, VSSUBU_VV }, // 11358
  { PseudoVSSUBU_VV_MF8_MASK, VSSUBU_VV }, // 11359
  { PseudoVSSUBU_VV_MF8_TU, VSSUBU_VV }, // 11360
  { PseudoVSSUBU_VX_M1, VSSUBU_VX }, // 11361
  { PseudoVSSUBU_VX_M1_MASK, VSSUBU_VX }, // 11362
  { PseudoVSSUBU_VX_M1_TU, VSSUBU_VX }, // 11363
  { PseudoVSSUBU_VX_M2, VSSUBU_VX }, // 11364
  { PseudoVSSUBU_VX_M2_MASK, VSSUBU_VX }, // 11365
  { PseudoVSSUBU_VX_M2_TU, VSSUBU_VX }, // 11366
  { PseudoVSSUBU_VX_M4, VSSUBU_VX }, // 11367
  { PseudoVSSUBU_VX_M4_MASK, VSSUBU_VX }, // 11368
  { PseudoVSSUBU_VX_M4_TU, VSSUBU_VX }, // 11369
  { PseudoVSSUBU_VX_M8, VSSUBU_VX }, // 11370
  { PseudoVSSUBU_VX_M8_MASK, VSSUBU_VX }, // 11371
  { PseudoVSSUBU_VX_M8_TU, VSSUBU_VX }, // 11372
  { PseudoVSSUBU_VX_MF2, VSSUBU_VX }, // 11373
  { PseudoVSSUBU_VX_MF2_MASK, VSSUBU_VX }, // 11374
  { PseudoVSSUBU_VX_MF2_TU, VSSUBU_VX }, // 11375
  { PseudoVSSUBU_VX_MF4, VSSUBU_VX }, // 11376
  { PseudoVSSUBU_VX_MF4_MASK, VSSUBU_VX }, // 11377
  { PseudoVSSUBU_VX_MF4_TU, VSSUBU_VX }, // 11378
  { PseudoVSSUBU_VX_MF8, VSSUBU_VX }, // 11379
  { PseudoVSSUBU_VX_MF8_MASK, VSSUBU_VX }, // 11380
  { PseudoVSSUBU_VX_MF8_TU, VSSUBU_VX }, // 11381
  { PseudoVSSUB_VV_M1, VSSUB_VV }, // 11382
  { PseudoVSSUB_VV_M1_MASK, VSSUB_VV }, // 11383
  { PseudoVSSUB_VV_M1_TU, VSSUB_VV }, // 11384
  { PseudoVSSUB_VV_M2, VSSUB_VV }, // 11385
  { PseudoVSSUB_VV_M2_MASK, VSSUB_VV }, // 11386
  { PseudoVSSUB_VV_M2_TU, VSSUB_VV }, // 11387
  { PseudoVSSUB_VV_M4, VSSUB_VV }, // 11388
  { PseudoVSSUB_VV_M4_MASK, VSSUB_VV }, // 11389
  { PseudoVSSUB_VV_M4_TU, VSSUB_VV }, // 11390
  { PseudoVSSUB_VV_M8, VSSUB_VV }, // 11391
  { PseudoVSSUB_VV_M8_MASK, VSSUB_VV }, // 11392
  { PseudoVSSUB_VV_M8_TU, VSSUB_VV }, // 11393
  { PseudoVSSUB_VV_MF2, VSSUB_VV }, // 11394
  { PseudoVSSUB_VV_MF2_MASK, VSSUB_VV }, // 11395
  { PseudoVSSUB_VV_MF2_TU, VSSUB_VV }, // 11396
  { PseudoVSSUB_VV_MF4, VSSUB_VV }, // 11397
  { PseudoVSSUB_VV_MF4_MASK, VSSUB_VV }, // 11398
  { PseudoVSSUB_VV_MF4_TU, VSSUB_VV }, // 11399
  { PseudoVSSUB_VV_MF8, VSSUB_VV }, // 11400
  { PseudoVSSUB_VV_MF8_MASK, VSSUB_VV }, // 11401
  { PseudoVSSUB_VV_MF8_TU, VSSUB_VV }, // 11402
  { PseudoVSSUB_VX_M1, VSSUB_VX }, // 11403
  { PseudoVSSUB_VX_M1_MASK, VSSUB_VX }, // 11404
  { PseudoVSSUB_VX_M1_TU, VSSUB_VX }, // 11405
  { PseudoVSSUB_VX_M2, VSSUB_VX }, // 11406
  { PseudoVSSUB_VX_M2_MASK, VSSUB_VX }, // 11407
  { PseudoVSSUB_VX_M2_TU, VSSUB_VX }, // 11408
  { PseudoVSSUB_VX_M4, VSSUB_VX }, // 11409
  { PseudoVSSUB_VX_M4_MASK, VSSUB_VX }, // 11410
  { PseudoVSSUB_VX_M4_TU, VSSUB_VX }, // 11411
  { PseudoVSSUB_VX_M8, VSSUB_VX }, // 11412
  { PseudoVSSUB_VX_M8_MASK, VSSUB_VX }, // 11413
  { PseudoVSSUB_VX_M8_TU, VSSUB_VX }, // 11414
  { PseudoVSSUB_VX_MF2, VSSUB_VX }, // 11415
  { PseudoVSSUB_VX_MF2_MASK, VSSUB_VX }, // 11416
  { PseudoVSSUB_VX_MF2_TU, VSSUB_VX }, // 11417
  { PseudoVSSUB_VX_MF4, VSSUB_VX }, // 11418
  { PseudoVSSUB_VX_MF4_MASK, VSSUB_VX }, // 11419
  { PseudoVSSUB_VX_MF4_TU, VSSUB_VX }, // 11420
  { PseudoVSSUB_VX_MF8, VSSUB_VX }, // 11421
  { PseudoVSSUB_VX_MF8_MASK, VSSUB_VX }, // 11422
  { PseudoVSSUB_VX_MF8_TU, VSSUB_VX }, // 11423
  { PseudoVSUB_VV_M1, VSUB_VV }, // 11424
  { PseudoVSUB_VV_M1_MASK, VSUB_VV }, // 11425
  { PseudoVSUB_VV_M1_TU, VSUB_VV }, // 11426
  { PseudoVSUB_VV_M2, VSUB_VV }, // 11427
  { PseudoVSUB_VV_M2_MASK, VSUB_VV }, // 11428
  { PseudoVSUB_VV_M2_TU, VSUB_VV }, // 11429
  { PseudoVSUB_VV_M4, VSUB_VV }, // 11430
  { PseudoVSUB_VV_M4_MASK, VSUB_VV }, // 11431
  { PseudoVSUB_VV_M4_TU, VSUB_VV }, // 11432
  { PseudoVSUB_VV_M8, VSUB_VV }, // 11433
  { PseudoVSUB_VV_M8_MASK, VSUB_VV }, // 11434
  { PseudoVSUB_VV_M8_TU, VSUB_VV }, // 11435
  { PseudoVSUB_VV_MF2, VSUB_VV }, // 11436
  { PseudoVSUB_VV_MF2_MASK, VSUB_VV }, // 11437
  { PseudoVSUB_VV_MF2_TU, VSUB_VV }, // 11438
  { PseudoVSUB_VV_MF4, VSUB_VV }, // 11439
  { PseudoVSUB_VV_MF4_MASK, VSUB_VV }, // 11440
  { PseudoVSUB_VV_MF4_TU, VSUB_VV }, // 11441
  { PseudoVSUB_VV_MF8, VSUB_VV }, // 11442
  { PseudoVSUB_VV_MF8_MASK, VSUB_VV }, // 11443
  { PseudoVSUB_VV_MF8_TU, VSUB_VV }, // 11444
  { PseudoVSUB_VX_M1, VSUB_VX }, // 11445
  { PseudoVSUB_VX_M1_MASK, VSUB_VX }, // 11446
  { PseudoVSUB_VX_M1_TU, VSUB_VX }, // 11447
  { PseudoVSUB_VX_M2, VSUB_VX }, // 11448
  { PseudoVSUB_VX_M2_MASK, VSUB_VX }, // 11449
  { PseudoVSUB_VX_M2_TU, VSUB_VX }, // 11450
  { PseudoVSUB_VX_M4, VSUB_VX }, // 11451
  { PseudoVSUB_VX_M4_MASK, VSUB_VX }, // 11452
  { PseudoVSUB_VX_M4_TU, VSUB_VX }, // 11453
  { PseudoVSUB_VX_M8, VSUB_VX }, // 11454
  { PseudoVSUB_VX_M8_MASK, VSUB_VX }, // 11455
  { PseudoVSUB_VX_M8_TU, VSUB_VX }, // 11456
  { PseudoVSUB_VX_MF2, VSUB_VX }, // 11457
  { PseudoVSUB_VX_MF2_MASK, VSUB_VX }, // 11458
  { PseudoVSUB_VX_MF2_TU, VSUB_VX }, // 11459
  { PseudoVSUB_VX_MF4, VSUB_VX }, // 11460
  { PseudoVSUB_VX_MF4_MASK, VSUB_VX }, // 11461
  { PseudoVSUB_VX_MF4_TU, VSUB_VX }, // 11462
  { PseudoVSUB_VX_MF8, VSUB_VX }, // 11463
  { PseudoVSUB_VX_MF8_MASK, VSUB_VX }, // 11464
  { PseudoVSUB_VX_MF8_TU, VSUB_VX }, // 11465
  { PseudoVSUXEI16_V_M1_M1, VSUXEI16_V }, // 11466
  { PseudoVSUXEI16_V_M1_M1_MASK, VSUXEI16_V }, // 11467
  { PseudoVSUXEI16_V_M1_M2, VSUXEI16_V }, // 11468
  { PseudoVSUXEI16_V_M1_M2_MASK, VSUXEI16_V }, // 11469
  { PseudoVSUXEI16_V_M1_M4, VSUXEI16_V }, // 11470
  { PseudoVSUXEI16_V_M1_M4_MASK, VSUXEI16_V }, // 11471
  { PseudoVSUXEI16_V_M1_MF2, VSUXEI16_V }, // 11472
  { PseudoVSUXEI16_V_M1_MF2_MASK, VSUXEI16_V }, // 11473
  { PseudoVSUXEI16_V_M2_M1, VSUXEI16_V }, // 11474
  { PseudoVSUXEI16_V_M2_M1_MASK, VSUXEI16_V }, // 11475
  { PseudoVSUXEI16_V_M2_M2, VSUXEI16_V }, // 11476
  { PseudoVSUXEI16_V_M2_M2_MASK, VSUXEI16_V }, // 11477
  { PseudoVSUXEI16_V_M2_M4, VSUXEI16_V }, // 11478
  { PseudoVSUXEI16_V_M2_M4_MASK, VSUXEI16_V }, // 11479
  { PseudoVSUXEI16_V_M2_M8, VSUXEI16_V }, // 11480
  { PseudoVSUXEI16_V_M2_M8_MASK, VSUXEI16_V }, // 11481
  { PseudoVSUXEI16_V_M4_M2, VSUXEI16_V }, // 11482
  { PseudoVSUXEI16_V_M4_M2_MASK, VSUXEI16_V }, // 11483
  { PseudoVSUXEI16_V_M4_M4, VSUXEI16_V }, // 11484
  { PseudoVSUXEI16_V_M4_M4_MASK, VSUXEI16_V }, // 11485
  { PseudoVSUXEI16_V_M4_M8, VSUXEI16_V }, // 11486
  { PseudoVSUXEI16_V_M4_M8_MASK, VSUXEI16_V }, // 11487
  { PseudoVSUXEI16_V_M8_M4, VSUXEI16_V }, // 11488
  { PseudoVSUXEI16_V_M8_M4_MASK, VSUXEI16_V }, // 11489
  { PseudoVSUXEI16_V_M8_M8, VSUXEI16_V }, // 11490
  { PseudoVSUXEI16_V_M8_M8_MASK, VSUXEI16_V }, // 11491
  { PseudoVSUXEI16_V_MF2_M1, VSUXEI16_V }, // 11492
  { PseudoVSUXEI16_V_MF2_M1_MASK, VSUXEI16_V }, // 11493
  { PseudoVSUXEI16_V_MF2_M2, VSUXEI16_V }, // 11494
  { PseudoVSUXEI16_V_MF2_M2_MASK, VSUXEI16_V }, // 11495
  { PseudoVSUXEI16_V_MF2_MF2, VSUXEI16_V }, // 11496
  { PseudoVSUXEI16_V_MF2_MF2_MASK, VSUXEI16_V }, // 11497
  { PseudoVSUXEI16_V_MF2_MF4, VSUXEI16_V }, // 11498
  { PseudoVSUXEI16_V_MF2_MF4_MASK, VSUXEI16_V }, // 11499
  { PseudoVSUXEI16_V_MF4_M1, VSUXEI16_V }, // 11500
  { PseudoVSUXEI16_V_MF4_M1_MASK, VSUXEI16_V }, // 11501
  { PseudoVSUXEI16_V_MF4_MF2, VSUXEI16_V }, // 11502
  { PseudoVSUXEI16_V_MF4_MF2_MASK, VSUXEI16_V }, // 11503
  { PseudoVSUXEI16_V_MF4_MF4, VSUXEI16_V }, // 11504
  { PseudoVSUXEI16_V_MF4_MF4_MASK, VSUXEI16_V }, // 11505
  { PseudoVSUXEI16_V_MF4_MF8, VSUXEI16_V }, // 11506
  { PseudoVSUXEI16_V_MF4_MF8_MASK, VSUXEI16_V }, // 11507
  { PseudoVSUXEI32_V_M1_M1, VSUXEI32_V }, // 11508
  { PseudoVSUXEI32_V_M1_M1_MASK, VSUXEI32_V }, // 11509
  { PseudoVSUXEI32_V_M1_M2, VSUXEI32_V }, // 11510
  { PseudoVSUXEI32_V_M1_M2_MASK, VSUXEI32_V }, // 11511
  { PseudoVSUXEI32_V_M1_MF2, VSUXEI32_V }, // 11512
  { PseudoVSUXEI32_V_M1_MF2_MASK, VSUXEI32_V }, // 11513
  { PseudoVSUXEI32_V_M1_MF4, VSUXEI32_V }, // 11514
  { PseudoVSUXEI32_V_M1_MF4_MASK, VSUXEI32_V }, // 11515
  { PseudoVSUXEI32_V_M2_M1, VSUXEI32_V }, // 11516
  { PseudoVSUXEI32_V_M2_M1_MASK, VSUXEI32_V }, // 11517
  { PseudoVSUXEI32_V_M2_M2, VSUXEI32_V }, // 11518
  { PseudoVSUXEI32_V_M2_M2_MASK, VSUXEI32_V }, // 11519
  { PseudoVSUXEI32_V_M2_M4, VSUXEI32_V }, // 11520
  { PseudoVSUXEI32_V_M2_M4_MASK, VSUXEI32_V }, // 11521
  { PseudoVSUXEI32_V_M2_MF2, VSUXEI32_V }, // 11522
  { PseudoVSUXEI32_V_M2_MF2_MASK, VSUXEI32_V }, // 11523
  { PseudoVSUXEI32_V_M4_M1, VSUXEI32_V }, // 11524
  { PseudoVSUXEI32_V_M4_M1_MASK, VSUXEI32_V }, // 11525
  { PseudoVSUXEI32_V_M4_M2, VSUXEI32_V }, // 11526
  { PseudoVSUXEI32_V_M4_M2_MASK, VSUXEI32_V }, // 11527
  { PseudoVSUXEI32_V_M4_M4, VSUXEI32_V }, // 11528
  { PseudoVSUXEI32_V_M4_M4_MASK, VSUXEI32_V }, // 11529
  { PseudoVSUXEI32_V_M4_M8, VSUXEI32_V }, // 11530
  { PseudoVSUXEI32_V_M4_M8_MASK, VSUXEI32_V }, // 11531
  { PseudoVSUXEI32_V_M8_M2, VSUXEI32_V }, // 11532
  { PseudoVSUXEI32_V_M8_M2_MASK, VSUXEI32_V }, // 11533
  { PseudoVSUXEI32_V_M8_M4, VSUXEI32_V }, // 11534
  { PseudoVSUXEI32_V_M8_M4_MASK, VSUXEI32_V }, // 11535
  { PseudoVSUXEI32_V_M8_M8, VSUXEI32_V }, // 11536
  { PseudoVSUXEI32_V_M8_M8_MASK, VSUXEI32_V }, // 11537
  { PseudoVSUXEI32_V_MF2_M1, VSUXEI32_V }, // 11538
  { PseudoVSUXEI32_V_MF2_M1_MASK, VSUXEI32_V }, // 11539
  { PseudoVSUXEI32_V_MF2_MF2, VSUXEI32_V }, // 11540
  { PseudoVSUXEI32_V_MF2_MF2_MASK, VSUXEI32_V }, // 11541
  { PseudoVSUXEI32_V_MF2_MF4, VSUXEI32_V }, // 11542
  { PseudoVSUXEI32_V_MF2_MF4_MASK, VSUXEI32_V }, // 11543
  { PseudoVSUXEI32_V_MF2_MF8, VSUXEI32_V }, // 11544
  { PseudoVSUXEI32_V_MF2_MF8_MASK, VSUXEI32_V }, // 11545
  { PseudoVSUXEI64_V_M1_M1, VSUXEI64_V }, // 11546
  { PseudoVSUXEI64_V_M1_M1_MASK, VSUXEI64_V }, // 11547
  { PseudoVSUXEI64_V_M1_MF2, VSUXEI64_V }, // 11548
  { PseudoVSUXEI64_V_M1_MF2_MASK, VSUXEI64_V }, // 11549
  { PseudoVSUXEI64_V_M1_MF4, VSUXEI64_V }, // 11550
  { PseudoVSUXEI64_V_M1_MF4_MASK, VSUXEI64_V }, // 11551
  { PseudoVSUXEI64_V_M1_MF8, VSUXEI64_V }, // 11552
  { PseudoVSUXEI64_V_M1_MF8_MASK, VSUXEI64_V }, // 11553
  { PseudoVSUXEI64_V_M2_M1, VSUXEI64_V }, // 11554
  { PseudoVSUXEI64_V_M2_M1_MASK, VSUXEI64_V }, // 11555
  { PseudoVSUXEI64_V_M2_M2, VSUXEI64_V }, // 11556
  { PseudoVSUXEI64_V_M2_M2_MASK, VSUXEI64_V }, // 11557
  { PseudoVSUXEI64_V_M2_MF2, VSUXEI64_V }, // 11558
  { PseudoVSUXEI64_V_M2_MF2_MASK, VSUXEI64_V }, // 11559
  { PseudoVSUXEI64_V_M2_MF4, VSUXEI64_V }, // 11560
  { PseudoVSUXEI64_V_M2_MF4_MASK, VSUXEI64_V }, // 11561
  { PseudoVSUXEI64_V_M4_M1, VSUXEI64_V }, // 11562
  { PseudoVSUXEI64_V_M4_M1_MASK, VSUXEI64_V }, // 11563
  { PseudoVSUXEI64_V_M4_M2, VSUXEI64_V }, // 11564
  { PseudoVSUXEI64_V_M4_M2_MASK, VSUXEI64_V }, // 11565
  { PseudoVSUXEI64_V_M4_M4, VSUXEI64_V }, // 11566
  { PseudoVSUXEI64_V_M4_M4_MASK, VSUXEI64_V }, // 11567
  { PseudoVSUXEI64_V_M4_MF2, VSUXEI64_V }, // 11568
  { PseudoVSUXEI64_V_M4_MF2_MASK, VSUXEI64_V }, // 11569
  { PseudoVSUXEI64_V_M8_M1, VSUXEI64_V }, // 11570
  { PseudoVSUXEI64_V_M8_M1_MASK, VSUXEI64_V }, // 11571
  { PseudoVSUXEI64_V_M8_M2, VSUXEI64_V }, // 11572
  { PseudoVSUXEI64_V_M8_M2_MASK, VSUXEI64_V }, // 11573
  { PseudoVSUXEI64_V_M8_M4, VSUXEI64_V }, // 11574
  { PseudoVSUXEI64_V_M8_M4_MASK, VSUXEI64_V }, // 11575
  { PseudoVSUXEI64_V_M8_M8, VSUXEI64_V }, // 11576
  { PseudoVSUXEI64_V_M8_M8_MASK, VSUXEI64_V }, // 11577
  { PseudoVSUXEI8_V_M1_M1, VSUXEI8_V }, // 11578
  { PseudoVSUXEI8_V_M1_M1_MASK, VSUXEI8_V }, // 11579
  { PseudoVSUXEI8_V_M1_M2, VSUXEI8_V }, // 11580
  { PseudoVSUXEI8_V_M1_M2_MASK, VSUXEI8_V }, // 11581
  { PseudoVSUXEI8_V_M1_M4, VSUXEI8_V }, // 11582
  { PseudoVSUXEI8_V_M1_M4_MASK, VSUXEI8_V }, // 11583
  { PseudoVSUXEI8_V_M1_M8, VSUXEI8_V }, // 11584
  { PseudoVSUXEI8_V_M1_M8_MASK, VSUXEI8_V }, // 11585
  { PseudoVSUXEI8_V_M2_M2, VSUXEI8_V }, // 11586
  { PseudoVSUXEI8_V_M2_M2_MASK, VSUXEI8_V }, // 11587
  { PseudoVSUXEI8_V_M2_M4, VSUXEI8_V }, // 11588
  { PseudoVSUXEI8_V_M2_M4_MASK, VSUXEI8_V }, // 11589
  { PseudoVSUXEI8_V_M2_M8, VSUXEI8_V }, // 11590
  { PseudoVSUXEI8_V_M2_M8_MASK, VSUXEI8_V }, // 11591
  { PseudoVSUXEI8_V_M4_M4, VSUXEI8_V }, // 11592
  { PseudoVSUXEI8_V_M4_M4_MASK, VSUXEI8_V }, // 11593
  { PseudoVSUXEI8_V_M4_M8, VSUXEI8_V }, // 11594
  { PseudoVSUXEI8_V_M4_M8_MASK, VSUXEI8_V }, // 11595
  { PseudoVSUXEI8_V_M8_M8, VSUXEI8_V }, // 11596
  { PseudoVSUXEI8_V_M8_M8_MASK, VSUXEI8_V }, // 11597
  { PseudoVSUXEI8_V_MF2_M1, VSUXEI8_V }, // 11598
  { PseudoVSUXEI8_V_MF2_M1_MASK, VSUXEI8_V }, // 11599
  { PseudoVSUXEI8_V_MF2_M2, VSUXEI8_V }, // 11600
  { PseudoVSUXEI8_V_MF2_M2_MASK, VSUXEI8_V }, // 11601
  { PseudoVSUXEI8_V_MF2_M4, VSUXEI8_V }, // 11602
  { PseudoVSUXEI8_V_MF2_M4_MASK, VSUXEI8_V }, // 11603
  { PseudoVSUXEI8_V_MF2_MF2, VSUXEI8_V }, // 11604
  { PseudoVSUXEI8_V_MF2_MF2_MASK, VSUXEI8_V }, // 11605
  { PseudoVSUXEI8_V_MF4_M1, VSUXEI8_V }, // 11606
  { PseudoVSUXEI8_V_MF4_M1_MASK, VSUXEI8_V }, // 11607
  { PseudoVSUXEI8_V_MF4_M2, VSUXEI8_V }, // 11608
  { PseudoVSUXEI8_V_MF4_M2_MASK, VSUXEI8_V }, // 11609
  { PseudoVSUXEI8_V_MF4_MF2, VSUXEI8_V }, // 11610
  { PseudoVSUXEI8_V_MF4_MF2_MASK, VSUXEI8_V }, // 11611
  { PseudoVSUXEI8_V_MF4_MF4, VSUXEI8_V }, // 11612
  { PseudoVSUXEI8_V_MF4_MF4_MASK, VSUXEI8_V }, // 11613
  { PseudoVSUXEI8_V_MF8_M1, VSUXEI8_V }, // 11614
  { PseudoVSUXEI8_V_MF8_M1_MASK, VSUXEI8_V }, // 11615
  { PseudoVSUXEI8_V_MF8_MF2, VSUXEI8_V }, // 11616
  { PseudoVSUXEI8_V_MF8_MF2_MASK, VSUXEI8_V }, // 11617
  { PseudoVSUXEI8_V_MF8_MF4, VSUXEI8_V }, // 11618
  { PseudoVSUXEI8_V_MF8_MF4_MASK, VSUXEI8_V }, // 11619
  { PseudoVSUXEI8_V_MF8_MF8, VSUXEI8_V }, // 11620
  { PseudoVSUXEI8_V_MF8_MF8_MASK, VSUXEI8_V }, // 11621
  { PseudoVSUXSEG2EI16_V_M1_M1, VSUXSEG2EI16_V }, // 11622
  { PseudoVSUXSEG2EI16_V_M1_M1_MASK, VSUXSEG2EI16_V }, // 11623
  { PseudoVSUXSEG2EI16_V_M1_M2, VSUXSEG2EI16_V }, // 11624
  { PseudoVSUXSEG2EI16_V_M1_M2_MASK, VSUXSEG2EI16_V }, // 11625
  { PseudoVSUXSEG2EI16_V_M1_M4, VSUXSEG2EI16_V }, // 11626
  { PseudoVSUXSEG2EI16_V_M1_M4_MASK, VSUXSEG2EI16_V }, // 11627
  { PseudoVSUXSEG2EI16_V_M1_MF2, VSUXSEG2EI16_V }, // 11628
  { PseudoVSUXSEG2EI16_V_M1_MF2_MASK, VSUXSEG2EI16_V }, // 11629
  { PseudoVSUXSEG2EI16_V_M2_M1, VSUXSEG2EI16_V }, // 11630
  { PseudoVSUXSEG2EI16_V_M2_M1_MASK, VSUXSEG2EI16_V }, // 11631
  { PseudoVSUXSEG2EI16_V_M2_M2, VSUXSEG2EI16_V }, // 11632
  { PseudoVSUXSEG2EI16_V_M2_M2_MASK, VSUXSEG2EI16_V }, // 11633
  { PseudoVSUXSEG2EI16_V_M2_M4, VSUXSEG2EI16_V }, // 11634
  { PseudoVSUXSEG2EI16_V_M2_M4_MASK, VSUXSEG2EI16_V }, // 11635
  { PseudoVSUXSEG2EI16_V_M4_M2, VSUXSEG2EI16_V }, // 11636
  { PseudoVSUXSEG2EI16_V_M4_M2_MASK, VSUXSEG2EI16_V }, // 11637
  { PseudoVSUXSEG2EI16_V_M4_M4, VSUXSEG2EI16_V }, // 11638
  { PseudoVSUXSEG2EI16_V_M4_M4_MASK, VSUXSEG2EI16_V }, // 11639
  { PseudoVSUXSEG2EI16_V_M8_M4, VSUXSEG2EI16_V }, // 11640
  { PseudoVSUXSEG2EI16_V_M8_M4_MASK, VSUXSEG2EI16_V }, // 11641
  { PseudoVSUXSEG2EI16_V_MF2_M1, VSUXSEG2EI16_V }, // 11642
  { PseudoVSUXSEG2EI16_V_MF2_M1_MASK, VSUXSEG2EI16_V }, // 11643
  { PseudoVSUXSEG2EI16_V_MF2_M2, VSUXSEG2EI16_V }, // 11644
  { PseudoVSUXSEG2EI16_V_MF2_M2_MASK, VSUXSEG2EI16_V }, // 11645
  { PseudoVSUXSEG2EI16_V_MF2_MF2, VSUXSEG2EI16_V }, // 11646
  { PseudoVSUXSEG2EI16_V_MF2_MF2_MASK, VSUXSEG2EI16_V }, // 11647
  { PseudoVSUXSEG2EI16_V_MF2_MF4, VSUXSEG2EI16_V }, // 11648
  { PseudoVSUXSEG2EI16_V_MF2_MF4_MASK, VSUXSEG2EI16_V }, // 11649
  { PseudoVSUXSEG2EI16_V_MF4_M1, VSUXSEG2EI16_V }, // 11650
  { PseudoVSUXSEG2EI16_V_MF4_M1_MASK, VSUXSEG2EI16_V }, // 11651
  { PseudoVSUXSEG2EI16_V_MF4_MF2, VSUXSEG2EI16_V }, // 11652
  { PseudoVSUXSEG2EI16_V_MF4_MF2_MASK, VSUXSEG2EI16_V }, // 11653
  { PseudoVSUXSEG2EI16_V_MF4_MF4, VSUXSEG2EI16_V }, // 11654
  { PseudoVSUXSEG2EI16_V_MF4_MF4_MASK, VSUXSEG2EI16_V }, // 11655
  { PseudoVSUXSEG2EI16_V_MF4_MF8, VSUXSEG2EI16_V }, // 11656
  { PseudoVSUXSEG2EI16_V_MF4_MF8_MASK, VSUXSEG2EI16_V }, // 11657
  { PseudoVSUXSEG2EI32_V_M1_M1, VSUXSEG2EI32_V }, // 11658
  { PseudoVSUXSEG2EI32_V_M1_M1_MASK, VSUXSEG2EI32_V }, // 11659
  { PseudoVSUXSEG2EI32_V_M1_M2, VSUXSEG2EI32_V }, // 11660
  { PseudoVSUXSEG2EI32_V_M1_M2_MASK, VSUXSEG2EI32_V }, // 11661
  { PseudoVSUXSEG2EI32_V_M1_MF2, VSUXSEG2EI32_V }, // 11662
  { PseudoVSUXSEG2EI32_V_M1_MF2_MASK, VSUXSEG2EI32_V }, // 11663
  { PseudoVSUXSEG2EI32_V_M1_MF4, VSUXSEG2EI32_V }, // 11664
  { PseudoVSUXSEG2EI32_V_M1_MF4_MASK, VSUXSEG2EI32_V }, // 11665
  { PseudoVSUXSEG2EI32_V_M2_M1, VSUXSEG2EI32_V }, // 11666
  { PseudoVSUXSEG2EI32_V_M2_M1_MASK, VSUXSEG2EI32_V }, // 11667
  { PseudoVSUXSEG2EI32_V_M2_M2, VSUXSEG2EI32_V }, // 11668
  { PseudoVSUXSEG2EI32_V_M2_M2_MASK, VSUXSEG2EI32_V }, // 11669
  { PseudoVSUXSEG2EI32_V_M2_M4, VSUXSEG2EI32_V }, // 11670
  { PseudoVSUXSEG2EI32_V_M2_M4_MASK, VSUXSEG2EI32_V }, // 11671
  { PseudoVSUXSEG2EI32_V_M2_MF2, VSUXSEG2EI32_V }, // 11672
  { PseudoVSUXSEG2EI32_V_M2_MF2_MASK, VSUXSEG2EI32_V }, // 11673
  { PseudoVSUXSEG2EI32_V_M4_M1, VSUXSEG2EI32_V }, // 11674
  { PseudoVSUXSEG2EI32_V_M4_M1_MASK, VSUXSEG2EI32_V }, // 11675
  { PseudoVSUXSEG2EI32_V_M4_M2, VSUXSEG2EI32_V }, // 11676
  { PseudoVSUXSEG2EI32_V_M4_M2_MASK, VSUXSEG2EI32_V }, // 11677
  { PseudoVSUXSEG2EI32_V_M4_M4, VSUXSEG2EI32_V }, // 11678
  { PseudoVSUXSEG2EI32_V_M4_M4_MASK, VSUXSEG2EI32_V }, // 11679
  { PseudoVSUXSEG2EI32_V_M8_M2, VSUXSEG2EI32_V }, // 11680
  { PseudoVSUXSEG2EI32_V_M8_M2_MASK, VSUXSEG2EI32_V }, // 11681
  { PseudoVSUXSEG2EI32_V_M8_M4, VSUXSEG2EI32_V }, // 11682
  { PseudoVSUXSEG2EI32_V_M8_M4_MASK, VSUXSEG2EI32_V }, // 11683
  { PseudoVSUXSEG2EI32_V_MF2_M1, VSUXSEG2EI32_V }, // 11684
  { PseudoVSUXSEG2EI32_V_MF2_M1_MASK, VSUXSEG2EI32_V }, // 11685
  { PseudoVSUXSEG2EI32_V_MF2_MF2, VSUXSEG2EI32_V }, // 11686
  { PseudoVSUXSEG2EI32_V_MF2_MF2_MASK, VSUXSEG2EI32_V }, // 11687
  { PseudoVSUXSEG2EI32_V_MF2_MF4, VSUXSEG2EI32_V }, // 11688
  { PseudoVSUXSEG2EI32_V_MF2_MF4_MASK, VSUXSEG2EI32_V }, // 11689
  { PseudoVSUXSEG2EI32_V_MF2_MF8, VSUXSEG2EI32_V }, // 11690
  { PseudoVSUXSEG2EI32_V_MF2_MF8_MASK, VSUXSEG2EI32_V }, // 11691
  { PseudoVSUXSEG2EI64_V_M1_M1, VSUXSEG2EI64_V }, // 11692
  { PseudoVSUXSEG2EI64_V_M1_M1_MASK, VSUXSEG2EI64_V }, // 11693
  { PseudoVSUXSEG2EI64_V_M1_MF2, VSUXSEG2EI64_V }, // 11694
  { PseudoVSUXSEG2EI64_V_M1_MF2_MASK, VSUXSEG2EI64_V }, // 11695
  { PseudoVSUXSEG2EI64_V_M1_MF4, VSUXSEG2EI64_V }, // 11696
  { PseudoVSUXSEG2EI64_V_M1_MF4_MASK, VSUXSEG2EI64_V }, // 11697
  { PseudoVSUXSEG2EI64_V_M1_MF8, VSUXSEG2EI64_V }, // 11698
  { PseudoVSUXSEG2EI64_V_M1_MF8_MASK, VSUXSEG2EI64_V }, // 11699
  { PseudoVSUXSEG2EI64_V_M2_M1, VSUXSEG2EI64_V }, // 11700
  { PseudoVSUXSEG2EI64_V_M2_M1_MASK, VSUXSEG2EI64_V }, // 11701
  { PseudoVSUXSEG2EI64_V_M2_M2, VSUXSEG2EI64_V }, // 11702
  { PseudoVSUXSEG2EI64_V_M2_M2_MASK, VSUXSEG2EI64_V }, // 11703
  { PseudoVSUXSEG2EI64_V_M2_MF2, VSUXSEG2EI64_V }, // 11704
  { PseudoVSUXSEG2EI64_V_M2_MF2_MASK, VSUXSEG2EI64_V }, // 11705
  { PseudoVSUXSEG2EI64_V_M2_MF4, VSUXSEG2EI64_V }, // 11706
  { PseudoVSUXSEG2EI64_V_M2_MF4_MASK, VSUXSEG2EI64_V }, // 11707
  { PseudoVSUXSEG2EI64_V_M4_M1, VSUXSEG2EI64_V }, // 11708
  { PseudoVSUXSEG2EI64_V_M4_M1_MASK, VSUXSEG2EI64_V }, // 11709
  { PseudoVSUXSEG2EI64_V_M4_M2, VSUXSEG2EI64_V }, // 11710
  { PseudoVSUXSEG2EI64_V_M4_M2_MASK, VSUXSEG2EI64_V }, // 11711
  { PseudoVSUXSEG2EI64_V_M4_M4, VSUXSEG2EI64_V }, // 11712
  { PseudoVSUXSEG2EI64_V_M4_M4_MASK, VSUXSEG2EI64_V }, // 11713
  { PseudoVSUXSEG2EI64_V_M4_MF2, VSUXSEG2EI64_V }, // 11714
  { PseudoVSUXSEG2EI64_V_M4_MF2_MASK, VSUXSEG2EI64_V }, // 11715
  { PseudoVSUXSEG2EI64_V_M8_M1, VSUXSEG2EI64_V }, // 11716
  { PseudoVSUXSEG2EI64_V_M8_M1_MASK, VSUXSEG2EI64_V }, // 11717
  { PseudoVSUXSEG2EI64_V_M8_M2, VSUXSEG2EI64_V }, // 11718
  { PseudoVSUXSEG2EI64_V_M8_M2_MASK, VSUXSEG2EI64_V }, // 11719
  { PseudoVSUXSEG2EI64_V_M8_M4, VSUXSEG2EI64_V }, // 11720
  { PseudoVSUXSEG2EI64_V_M8_M4_MASK, VSUXSEG2EI64_V }, // 11721
  { PseudoVSUXSEG2EI8_V_M1_M1, VSUXSEG2EI8_V }, // 11722
  { PseudoVSUXSEG2EI8_V_M1_M1_MASK, VSUXSEG2EI8_V }, // 11723
  { PseudoVSUXSEG2EI8_V_M1_M2, VSUXSEG2EI8_V }, // 11724
  { PseudoVSUXSEG2EI8_V_M1_M2_MASK, VSUXSEG2EI8_V }, // 11725
  { PseudoVSUXSEG2EI8_V_M1_M4, VSUXSEG2EI8_V }, // 11726
  { PseudoVSUXSEG2EI8_V_M1_M4_MASK, VSUXSEG2EI8_V }, // 11727
  { PseudoVSUXSEG2EI8_V_M2_M2, VSUXSEG2EI8_V }, // 11728
  { PseudoVSUXSEG2EI8_V_M2_M2_MASK, VSUXSEG2EI8_V }, // 11729
  { PseudoVSUXSEG2EI8_V_M2_M4, VSUXSEG2EI8_V }, // 11730
  { PseudoVSUXSEG2EI8_V_M2_M4_MASK, VSUXSEG2EI8_V }, // 11731
  { PseudoVSUXSEG2EI8_V_M4_M4, VSUXSEG2EI8_V }, // 11732
  { PseudoVSUXSEG2EI8_V_M4_M4_MASK, VSUXSEG2EI8_V }, // 11733
  { PseudoVSUXSEG2EI8_V_MF2_M1, VSUXSEG2EI8_V }, // 11734
  { PseudoVSUXSEG2EI8_V_MF2_M1_MASK, VSUXSEG2EI8_V }, // 11735
  { PseudoVSUXSEG2EI8_V_MF2_M2, VSUXSEG2EI8_V }, // 11736
  { PseudoVSUXSEG2EI8_V_MF2_M2_MASK, VSUXSEG2EI8_V }, // 11737
  { PseudoVSUXSEG2EI8_V_MF2_M4, VSUXSEG2EI8_V }, // 11738
  { PseudoVSUXSEG2EI8_V_MF2_M4_MASK, VSUXSEG2EI8_V }, // 11739
  { PseudoVSUXSEG2EI8_V_MF2_MF2, VSUXSEG2EI8_V }, // 11740
  { PseudoVSUXSEG2EI8_V_MF2_MF2_MASK, VSUXSEG2EI8_V }, // 11741
  { PseudoVSUXSEG2EI8_V_MF4_M1, VSUXSEG2EI8_V }, // 11742
  { PseudoVSUXSEG2EI8_V_MF4_M1_MASK, VSUXSEG2EI8_V }, // 11743
  { PseudoVSUXSEG2EI8_V_MF4_M2, VSUXSEG2EI8_V }, // 11744
  { PseudoVSUXSEG2EI8_V_MF4_M2_MASK, VSUXSEG2EI8_V }, // 11745
  { PseudoVSUXSEG2EI8_V_MF4_MF2, VSUXSEG2EI8_V }, // 11746
  { PseudoVSUXSEG2EI8_V_MF4_MF2_MASK, VSUXSEG2EI8_V }, // 11747
  { PseudoVSUXSEG2EI8_V_MF4_MF4, VSUXSEG2EI8_V }, // 11748
  { PseudoVSUXSEG2EI8_V_MF4_MF4_MASK, VSUXSEG2EI8_V }, // 11749
  { PseudoVSUXSEG2EI8_V_MF8_M1, VSUXSEG2EI8_V }, // 11750
  { PseudoVSUXSEG2EI8_V_MF8_M1_MASK, VSUXSEG2EI8_V }, // 11751
  { PseudoVSUXSEG2EI8_V_MF8_MF2, VSUXSEG2EI8_V }, // 11752
  { PseudoVSUXSEG2EI8_V_MF8_MF2_MASK, VSUXSEG2EI8_V }, // 11753
  { PseudoVSUXSEG2EI8_V_MF8_MF4, VSUXSEG2EI8_V }, // 11754
  { PseudoVSUXSEG2EI8_V_MF8_MF4_MASK, VSUXSEG2EI8_V }, // 11755
  { PseudoVSUXSEG2EI8_V_MF8_MF8, VSUXSEG2EI8_V }, // 11756
  { PseudoVSUXSEG2EI8_V_MF8_MF8_MASK, VSUXSEG2EI8_V }, // 11757
  { PseudoVSUXSEG3EI16_V_M1_M1, VSUXSEG3EI16_V }, // 11758
  { PseudoVSUXSEG3EI16_V_M1_M1_MASK, VSUXSEG3EI16_V }, // 11759
  { PseudoVSUXSEG3EI16_V_M1_M2, VSUXSEG3EI16_V }, // 11760
  { PseudoVSUXSEG3EI16_V_M1_M2_MASK, VSUXSEG3EI16_V }, // 11761
  { PseudoVSUXSEG3EI16_V_M1_MF2, VSUXSEG3EI16_V }, // 11762
  { PseudoVSUXSEG3EI16_V_M1_MF2_MASK, VSUXSEG3EI16_V }, // 11763
  { PseudoVSUXSEG3EI16_V_M2_M1, VSUXSEG3EI16_V }, // 11764
  { PseudoVSUXSEG3EI16_V_M2_M1_MASK, VSUXSEG3EI16_V }, // 11765
  { PseudoVSUXSEG3EI16_V_M2_M2, VSUXSEG3EI16_V }, // 11766
  { PseudoVSUXSEG3EI16_V_M2_M2_MASK, VSUXSEG3EI16_V }, // 11767
  { PseudoVSUXSEG3EI16_V_M4_M2, VSUXSEG3EI16_V }, // 11768
  { PseudoVSUXSEG3EI16_V_M4_M2_MASK, VSUXSEG3EI16_V }, // 11769
  { PseudoVSUXSEG3EI16_V_MF2_M1, VSUXSEG3EI16_V }, // 11770
  { PseudoVSUXSEG3EI16_V_MF2_M1_MASK, VSUXSEG3EI16_V }, // 11771
  { PseudoVSUXSEG3EI16_V_MF2_M2, VSUXSEG3EI16_V }, // 11772
  { PseudoVSUXSEG3EI16_V_MF2_M2_MASK, VSUXSEG3EI16_V }, // 11773
  { PseudoVSUXSEG3EI16_V_MF2_MF2, VSUXSEG3EI16_V }, // 11774
  { PseudoVSUXSEG3EI16_V_MF2_MF2_MASK, VSUXSEG3EI16_V }, // 11775
  { PseudoVSUXSEG3EI16_V_MF2_MF4, VSUXSEG3EI16_V }, // 11776
  { PseudoVSUXSEG3EI16_V_MF2_MF4_MASK, VSUXSEG3EI16_V }, // 11777
  { PseudoVSUXSEG3EI16_V_MF4_M1, VSUXSEG3EI16_V }, // 11778
  { PseudoVSUXSEG3EI16_V_MF4_M1_MASK, VSUXSEG3EI16_V }, // 11779
  { PseudoVSUXSEG3EI16_V_MF4_MF2, VSUXSEG3EI16_V }, // 11780
  { PseudoVSUXSEG3EI16_V_MF4_MF2_MASK, VSUXSEG3EI16_V }, // 11781
  { PseudoVSUXSEG3EI16_V_MF4_MF4, VSUXSEG3EI16_V }, // 11782
  { PseudoVSUXSEG3EI16_V_MF4_MF4_MASK, VSUXSEG3EI16_V }, // 11783
  { PseudoVSUXSEG3EI16_V_MF4_MF8, VSUXSEG3EI16_V }, // 11784
  { PseudoVSUXSEG3EI16_V_MF4_MF8_MASK, VSUXSEG3EI16_V }, // 11785
  { PseudoVSUXSEG3EI32_V_M1_M1, VSUXSEG3EI32_V }, // 11786
  { PseudoVSUXSEG3EI32_V_M1_M1_MASK, VSUXSEG3EI32_V }, // 11787
  { PseudoVSUXSEG3EI32_V_M1_M2, VSUXSEG3EI32_V }, // 11788
  { PseudoVSUXSEG3EI32_V_M1_M2_MASK, VSUXSEG3EI32_V }, // 11789
  { PseudoVSUXSEG3EI32_V_M1_MF2, VSUXSEG3EI32_V }, // 11790
  { PseudoVSUXSEG3EI32_V_M1_MF2_MASK, VSUXSEG3EI32_V }, // 11791
  { PseudoVSUXSEG3EI32_V_M1_MF4, VSUXSEG3EI32_V }, // 11792
  { PseudoVSUXSEG3EI32_V_M1_MF4_MASK, VSUXSEG3EI32_V }, // 11793
  { PseudoVSUXSEG3EI32_V_M2_M1, VSUXSEG3EI32_V }, // 11794
  { PseudoVSUXSEG3EI32_V_M2_M1_MASK, VSUXSEG3EI32_V }, // 11795
  { PseudoVSUXSEG3EI32_V_M2_M2, VSUXSEG3EI32_V }, // 11796
  { PseudoVSUXSEG3EI32_V_M2_M2_MASK, VSUXSEG3EI32_V }, // 11797
  { PseudoVSUXSEG3EI32_V_M2_MF2, VSUXSEG3EI32_V }, // 11798
  { PseudoVSUXSEG3EI32_V_M2_MF2_MASK, VSUXSEG3EI32_V }, // 11799
  { PseudoVSUXSEG3EI32_V_M4_M1, VSUXSEG3EI32_V }, // 11800
  { PseudoVSUXSEG3EI32_V_M4_M1_MASK, VSUXSEG3EI32_V }, // 11801
  { PseudoVSUXSEG3EI32_V_M4_M2, VSUXSEG3EI32_V }, // 11802
  { PseudoVSUXSEG3EI32_V_M4_M2_MASK, VSUXSEG3EI32_V }, // 11803
  { PseudoVSUXSEG3EI32_V_M8_M2, VSUXSEG3EI32_V }, // 11804
  { PseudoVSUXSEG3EI32_V_M8_M2_MASK, VSUXSEG3EI32_V }, // 11805
  { PseudoVSUXSEG3EI32_V_MF2_M1, VSUXSEG3EI32_V }, // 11806
  { PseudoVSUXSEG3EI32_V_MF2_M1_MASK, VSUXSEG3EI32_V }, // 11807
  { PseudoVSUXSEG3EI32_V_MF2_MF2, VSUXSEG3EI32_V }, // 11808
  { PseudoVSUXSEG3EI32_V_MF2_MF2_MASK, VSUXSEG3EI32_V }, // 11809
  { PseudoVSUXSEG3EI32_V_MF2_MF4, VSUXSEG3EI32_V }, // 11810
  { PseudoVSUXSEG3EI32_V_MF2_MF4_MASK, VSUXSEG3EI32_V }, // 11811
  { PseudoVSUXSEG3EI32_V_MF2_MF8, VSUXSEG3EI32_V }, // 11812
  { PseudoVSUXSEG3EI32_V_MF2_MF8_MASK, VSUXSEG3EI32_V }, // 11813
  { PseudoVSUXSEG3EI64_V_M1_M1, VSUXSEG3EI64_V }, // 11814
  { PseudoVSUXSEG3EI64_V_M1_M1_MASK, VSUXSEG3EI64_V }, // 11815
  { PseudoVSUXSEG3EI64_V_M1_MF2, VSUXSEG3EI64_V }, // 11816
  { PseudoVSUXSEG3EI64_V_M1_MF2_MASK, VSUXSEG3EI64_V }, // 11817
  { PseudoVSUXSEG3EI64_V_M1_MF4, VSUXSEG3EI64_V }, // 11818
  { PseudoVSUXSEG3EI64_V_M1_MF4_MASK, VSUXSEG3EI64_V }, // 11819
  { PseudoVSUXSEG3EI64_V_M1_MF8, VSUXSEG3EI64_V }, // 11820
  { PseudoVSUXSEG3EI64_V_M1_MF8_MASK, VSUXSEG3EI64_V }, // 11821
  { PseudoVSUXSEG3EI64_V_M2_M1, VSUXSEG3EI64_V }, // 11822
  { PseudoVSUXSEG3EI64_V_M2_M1_MASK, VSUXSEG3EI64_V }, // 11823
  { PseudoVSUXSEG3EI64_V_M2_M2, VSUXSEG3EI64_V }, // 11824
  { PseudoVSUXSEG3EI64_V_M2_M2_MASK, VSUXSEG3EI64_V }, // 11825
  { PseudoVSUXSEG3EI64_V_M2_MF2, VSUXSEG3EI64_V }, // 11826
  { PseudoVSUXSEG3EI64_V_M2_MF2_MASK, VSUXSEG3EI64_V }, // 11827
  { PseudoVSUXSEG3EI64_V_M2_MF4, VSUXSEG3EI64_V }, // 11828
  { PseudoVSUXSEG3EI64_V_M2_MF4_MASK, VSUXSEG3EI64_V }, // 11829
  { PseudoVSUXSEG3EI64_V_M4_M1, VSUXSEG3EI64_V }, // 11830
  { PseudoVSUXSEG3EI64_V_M4_M1_MASK, VSUXSEG3EI64_V }, // 11831
  { PseudoVSUXSEG3EI64_V_M4_M2, VSUXSEG3EI64_V }, // 11832
  { PseudoVSUXSEG3EI64_V_M4_M2_MASK, VSUXSEG3EI64_V }, // 11833
  { PseudoVSUXSEG3EI64_V_M4_MF2, VSUXSEG3EI64_V }, // 11834
  { PseudoVSUXSEG3EI64_V_M4_MF2_MASK, VSUXSEG3EI64_V }, // 11835
  { PseudoVSUXSEG3EI64_V_M8_M1, VSUXSEG3EI64_V }, // 11836
  { PseudoVSUXSEG3EI64_V_M8_M1_MASK, VSUXSEG3EI64_V }, // 11837
  { PseudoVSUXSEG3EI64_V_M8_M2, VSUXSEG3EI64_V }, // 11838
  { PseudoVSUXSEG3EI64_V_M8_M2_MASK, VSUXSEG3EI64_V }, // 11839
  { PseudoVSUXSEG3EI8_V_M1_M1, VSUXSEG3EI8_V }, // 11840
  { PseudoVSUXSEG3EI8_V_M1_M1_MASK, VSUXSEG3EI8_V }, // 11841
  { PseudoVSUXSEG3EI8_V_M1_M2, VSUXSEG3EI8_V }, // 11842
  { PseudoVSUXSEG3EI8_V_M1_M2_MASK, VSUXSEG3EI8_V }, // 11843
  { PseudoVSUXSEG3EI8_V_M2_M2, VSUXSEG3EI8_V }, // 11844
  { PseudoVSUXSEG3EI8_V_M2_M2_MASK, VSUXSEG3EI8_V }, // 11845
  { PseudoVSUXSEG3EI8_V_MF2_M1, VSUXSEG3EI8_V }, // 11846
  { PseudoVSUXSEG3EI8_V_MF2_M1_MASK, VSUXSEG3EI8_V }, // 11847
  { PseudoVSUXSEG3EI8_V_MF2_M2, VSUXSEG3EI8_V }, // 11848
  { PseudoVSUXSEG3EI8_V_MF2_M2_MASK, VSUXSEG3EI8_V }, // 11849
  { PseudoVSUXSEG3EI8_V_MF2_MF2, VSUXSEG3EI8_V }, // 11850
  { PseudoVSUXSEG3EI8_V_MF2_MF2_MASK, VSUXSEG3EI8_V }, // 11851
  { PseudoVSUXSEG3EI8_V_MF4_M1, VSUXSEG3EI8_V }, // 11852
  { PseudoVSUXSEG3EI8_V_MF4_M1_MASK, VSUXSEG3EI8_V }, // 11853
  { PseudoVSUXSEG3EI8_V_MF4_M2, VSUXSEG3EI8_V }, // 11854
  { PseudoVSUXSEG3EI8_V_MF4_M2_MASK, VSUXSEG3EI8_V }, // 11855
  { PseudoVSUXSEG3EI8_V_MF4_MF2, VSUXSEG3EI8_V }, // 11856
  { PseudoVSUXSEG3EI8_V_MF4_MF2_MASK, VSUXSEG3EI8_V }, // 11857
  { PseudoVSUXSEG3EI8_V_MF4_MF4, VSUXSEG3EI8_V }, // 11858
  { PseudoVSUXSEG3EI8_V_MF4_MF4_MASK, VSUXSEG3EI8_V }, // 11859
  { PseudoVSUXSEG3EI8_V_MF8_M1, VSUXSEG3EI8_V }, // 11860
  { PseudoVSUXSEG3EI8_V_MF8_M1_MASK, VSUXSEG3EI8_V }, // 11861
  { PseudoVSUXSEG3EI8_V_MF8_MF2, VSUXSEG3EI8_V }, // 11862
  { PseudoVSUXSEG3EI8_V_MF8_MF2_MASK, VSUXSEG3EI8_V }, // 11863
  { PseudoVSUXSEG3EI8_V_MF8_MF4, VSUXSEG3EI8_V }, // 11864
  { PseudoVSUXSEG3EI8_V_MF8_MF4_MASK, VSUXSEG3EI8_V }, // 11865
  { PseudoVSUXSEG3EI8_V_MF8_MF8, VSUXSEG3EI8_V }, // 11866
  { PseudoVSUXSEG3EI8_V_MF8_MF8_MASK, VSUXSEG3EI8_V }, // 11867
  { PseudoVSUXSEG4EI16_V_M1_M1, VSUXSEG4EI16_V }, // 11868
  { PseudoVSUXSEG4EI16_V_M1_M1_MASK, VSUXSEG4EI16_V }, // 11869
  { PseudoVSUXSEG4EI16_V_M1_M2, VSUXSEG4EI16_V }, // 11870
  { PseudoVSUXSEG4EI16_V_M1_M2_MASK, VSUXSEG4EI16_V }, // 11871
  { PseudoVSUXSEG4EI16_V_M1_MF2, VSUXSEG4EI16_V }, // 11872
  { PseudoVSUXSEG4EI16_V_M1_MF2_MASK, VSUXSEG4EI16_V }, // 11873
  { PseudoVSUXSEG4EI16_V_M2_M1, VSUXSEG4EI16_V }, // 11874
  { PseudoVSUXSEG4EI16_V_M2_M1_MASK, VSUXSEG4EI16_V }, // 11875
  { PseudoVSUXSEG4EI16_V_M2_M2, VSUXSEG4EI16_V }, // 11876
  { PseudoVSUXSEG4EI16_V_M2_M2_MASK, VSUXSEG4EI16_V }, // 11877
  { PseudoVSUXSEG4EI16_V_M4_M2, VSUXSEG4EI16_V }, // 11878
  { PseudoVSUXSEG4EI16_V_M4_M2_MASK, VSUXSEG4EI16_V }, // 11879
  { PseudoVSUXSEG4EI16_V_MF2_M1, VSUXSEG4EI16_V }, // 11880
  { PseudoVSUXSEG4EI16_V_MF2_M1_MASK, VSUXSEG4EI16_V }, // 11881
  { PseudoVSUXSEG4EI16_V_MF2_M2, VSUXSEG4EI16_V }, // 11882
  { PseudoVSUXSEG4EI16_V_MF2_M2_MASK, VSUXSEG4EI16_V }, // 11883
  { PseudoVSUXSEG4EI16_V_MF2_MF2, VSUXSEG4EI16_V }, // 11884
  { PseudoVSUXSEG4EI16_V_MF2_MF2_MASK, VSUXSEG4EI16_V }, // 11885
  { PseudoVSUXSEG4EI16_V_MF2_MF4, VSUXSEG4EI16_V }, // 11886
  { PseudoVSUXSEG4EI16_V_MF2_MF4_MASK, VSUXSEG4EI16_V }, // 11887
  { PseudoVSUXSEG4EI16_V_MF4_M1, VSUXSEG4EI16_V }, // 11888
  { PseudoVSUXSEG4EI16_V_MF4_M1_MASK, VSUXSEG4EI16_V }, // 11889
  { PseudoVSUXSEG4EI16_V_MF4_MF2, VSUXSEG4EI16_V }, // 11890
  { PseudoVSUXSEG4EI16_V_MF4_MF2_MASK, VSUXSEG4EI16_V }, // 11891
  { PseudoVSUXSEG4EI16_V_MF4_MF4, VSUXSEG4EI16_V }, // 11892
  { PseudoVSUXSEG4EI16_V_MF4_MF4_MASK, VSUXSEG4EI16_V }, // 11893
  { PseudoVSUXSEG4EI16_V_MF4_MF8, VSUXSEG4EI16_V }, // 11894
  { PseudoVSUXSEG4EI16_V_MF4_MF8_MASK, VSUXSEG4EI16_V }, // 11895
  { PseudoVSUXSEG4EI32_V_M1_M1, VSUXSEG4EI32_V }, // 11896
  { PseudoVSUXSEG4EI32_V_M1_M1_MASK, VSUXSEG4EI32_V }, // 11897
  { PseudoVSUXSEG4EI32_V_M1_M2, VSUXSEG4EI32_V }, // 11898
  { PseudoVSUXSEG4EI32_V_M1_M2_MASK, VSUXSEG4EI32_V }, // 11899
  { PseudoVSUXSEG4EI32_V_M1_MF2, VSUXSEG4EI32_V }, // 11900
  { PseudoVSUXSEG4EI32_V_M1_MF2_MASK, VSUXSEG4EI32_V }, // 11901
  { PseudoVSUXSEG4EI32_V_M1_MF4, VSUXSEG4EI32_V }, // 11902
  { PseudoVSUXSEG4EI32_V_M1_MF4_MASK, VSUXSEG4EI32_V }, // 11903
  { PseudoVSUXSEG4EI32_V_M2_M1, VSUXSEG4EI32_V }, // 11904
  { PseudoVSUXSEG4EI32_V_M2_M1_MASK, VSUXSEG4EI32_V }, // 11905
  { PseudoVSUXSEG4EI32_V_M2_M2, VSUXSEG4EI32_V }, // 11906
  { PseudoVSUXSEG4EI32_V_M2_M2_MASK, VSUXSEG4EI32_V }, // 11907
  { PseudoVSUXSEG4EI32_V_M2_MF2, VSUXSEG4EI32_V }, // 11908
  { PseudoVSUXSEG4EI32_V_M2_MF2_MASK, VSUXSEG4EI32_V }, // 11909
  { PseudoVSUXSEG4EI32_V_M4_M1, VSUXSEG4EI32_V }, // 11910
  { PseudoVSUXSEG4EI32_V_M4_M1_MASK, VSUXSEG4EI32_V }, // 11911
  { PseudoVSUXSEG4EI32_V_M4_M2, VSUXSEG4EI32_V }, // 11912
  { PseudoVSUXSEG4EI32_V_M4_M2_MASK, VSUXSEG4EI32_V }, // 11913
  { PseudoVSUXSEG4EI32_V_M8_M2, VSUXSEG4EI32_V }, // 11914
  { PseudoVSUXSEG4EI32_V_M8_M2_MASK, VSUXSEG4EI32_V }, // 11915
  { PseudoVSUXSEG4EI32_V_MF2_M1, VSUXSEG4EI32_V }, // 11916
  { PseudoVSUXSEG4EI32_V_MF2_M1_MASK, VSUXSEG4EI32_V }, // 11917
  { PseudoVSUXSEG4EI32_V_MF2_MF2, VSUXSEG4EI32_V }, // 11918
  { PseudoVSUXSEG4EI32_V_MF2_MF2_MASK, VSUXSEG4EI32_V }, // 11919
  { PseudoVSUXSEG4EI32_V_MF2_MF4, VSUXSEG4EI32_V }, // 11920
  { PseudoVSUXSEG4EI32_V_MF2_MF4_MASK, VSUXSEG4EI32_V }, // 11921
  { PseudoVSUXSEG4EI32_V_MF2_MF8, VSUXSEG4EI32_V }, // 11922
  { PseudoVSUXSEG4EI32_V_MF2_MF8_MASK, VSUXSEG4EI32_V }, // 11923
  { PseudoVSUXSEG4EI64_V_M1_M1, VSUXSEG4EI64_V }, // 11924
  { PseudoVSUXSEG4EI64_V_M1_M1_MASK, VSUXSEG4EI64_V }, // 11925
  { PseudoVSUXSEG4EI64_V_M1_MF2, VSUXSEG4EI64_V }, // 11926
  { PseudoVSUXSEG4EI64_V_M1_MF2_MASK, VSUXSEG4EI64_V }, // 11927
  { PseudoVSUXSEG4EI64_V_M1_MF4, VSUXSEG4EI64_V }, // 11928
  { PseudoVSUXSEG4EI64_V_M1_MF4_MASK, VSUXSEG4EI64_V }, // 11929
  { PseudoVSUXSEG4EI64_V_M1_MF8, VSUXSEG4EI64_V }, // 11930
  { PseudoVSUXSEG4EI64_V_M1_MF8_MASK, VSUXSEG4EI64_V }, // 11931
  { PseudoVSUXSEG4EI64_V_M2_M1, VSUXSEG4EI64_V }, // 11932
  { PseudoVSUXSEG4EI64_V_M2_M1_MASK, VSUXSEG4EI64_V }, // 11933
  { PseudoVSUXSEG4EI64_V_M2_M2, VSUXSEG4EI64_V }, // 11934
  { PseudoVSUXSEG4EI64_V_M2_M2_MASK, VSUXSEG4EI64_V }, // 11935
  { PseudoVSUXSEG4EI64_V_M2_MF2, VSUXSEG4EI64_V }, // 11936
  { PseudoVSUXSEG4EI64_V_M2_MF2_MASK, VSUXSEG4EI64_V }, // 11937
  { PseudoVSUXSEG4EI64_V_M2_MF4, VSUXSEG4EI64_V }, // 11938
  { PseudoVSUXSEG4EI64_V_M2_MF4_MASK, VSUXSEG4EI64_V }, // 11939
  { PseudoVSUXSEG4EI64_V_M4_M1, VSUXSEG4EI64_V }, // 11940
  { PseudoVSUXSEG4EI64_V_M4_M1_MASK, VSUXSEG4EI64_V }, // 11941
  { PseudoVSUXSEG4EI64_V_M4_M2, VSUXSEG4EI64_V }, // 11942
  { PseudoVSUXSEG4EI64_V_M4_M2_MASK, VSUXSEG4EI64_V }, // 11943
  { PseudoVSUXSEG4EI64_V_M4_MF2, VSUXSEG4EI64_V }, // 11944
  { PseudoVSUXSEG4EI64_V_M4_MF2_MASK, VSUXSEG4EI64_V }, // 11945
  { PseudoVSUXSEG4EI64_V_M8_M1, VSUXSEG4EI64_V }, // 11946
  { PseudoVSUXSEG4EI64_V_M8_M1_MASK, VSUXSEG4EI64_V }, // 11947
  { PseudoVSUXSEG4EI64_V_M8_M2, VSUXSEG4EI64_V }, // 11948
  { PseudoVSUXSEG4EI64_V_M8_M2_MASK, VSUXSEG4EI64_V }, // 11949
  { PseudoVSUXSEG4EI8_V_M1_M1, VSUXSEG4EI8_V }, // 11950
  { PseudoVSUXSEG4EI8_V_M1_M1_MASK, VSUXSEG4EI8_V }, // 11951
  { PseudoVSUXSEG4EI8_V_M1_M2, VSUXSEG4EI8_V }, // 11952
  { PseudoVSUXSEG4EI8_V_M1_M2_MASK, VSUXSEG4EI8_V }, // 11953
  { PseudoVSUXSEG4EI8_V_M2_M2, VSUXSEG4EI8_V }, // 11954
  { PseudoVSUXSEG4EI8_V_M2_M2_MASK, VSUXSEG4EI8_V }, // 11955
  { PseudoVSUXSEG4EI8_V_MF2_M1, VSUXSEG4EI8_V }, // 11956
  { PseudoVSUXSEG4EI8_V_MF2_M1_MASK, VSUXSEG4EI8_V }, // 11957
  { PseudoVSUXSEG4EI8_V_MF2_M2, VSUXSEG4EI8_V }, // 11958
  { PseudoVSUXSEG4EI8_V_MF2_M2_MASK, VSUXSEG4EI8_V }, // 11959
  { PseudoVSUXSEG4EI8_V_MF2_MF2, VSUXSEG4EI8_V }, // 11960
  { PseudoVSUXSEG4EI8_V_MF2_MF2_MASK, VSUXSEG4EI8_V }, // 11961
  { PseudoVSUXSEG4EI8_V_MF4_M1, VSUXSEG4EI8_V }, // 11962
  { PseudoVSUXSEG4EI8_V_MF4_M1_MASK, VSUXSEG4EI8_V }, // 11963
  { PseudoVSUXSEG4EI8_V_MF4_M2, VSUXSEG4EI8_V }, // 11964
  { PseudoVSUXSEG4EI8_V_MF4_M2_MASK, VSUXSEG4EI8_V }, // 11965
  { PseudoVSUXSEG4EI8_V_MF4_MF2, VSUXSEG4EI8_V }, // 11966
  { PseudoVSUXSEG4EI8_V_MF4_MF2_MASK, VSUXSEG4EI8_V }, // 11967
  { PseudoVSUXSEG4EI8_V_MF4_MF4, VSUXSEG4EI8_V }, // 11968
  { PseudoVSUXSEG4EI8_V_MF4_MF4_MASK, VSUXSEG4EI8_V }, // 11969
  { PseudoVSUXSEG4EI8_V_MF8_M1, VSUXSEG4EI8_V }, // 11970
  { PseudoVSUXSEG4EI8_V_MF8_M1_MASK, VSUXSEG4EI8_V }, // 11971
  { PseudoVSUXSEG4EI8_V_MF8_MF2, VSUXSEG4EI8_V }, // 11972
  { PseudoVSUXSEG4EI8_V_MF8_MF2_MASK, VSUXSEG4EI8_V }, // 11973
  { PseudoVSUXSEG4EI8_V_MF8_MF4, VSUXSEG4EI8_V }, // 11974
  { PseudoVSUXSEG4EI8_V_MF8_MF4_MASK, VSUXSEG4EI8_V }, // 11975
  { PseudoVSUXSEG4EI8_V_MF8_MF8, VSUXSEG4EI8_V }, // 11976
  { PseudoVSUXSEG4EI8_V_MF8_MF8_MASK, VSUXSEG4EI8_V }, // 11977
  { PseudoVSUXSEG5EI16_V_M1_M1, VSUXSEG5EI16_V }, // 11978
  { PseudoVSUXSEG5EI16_V_M1_M1_MASK, VSUXSEG5EI16_V }, // 11979
  { PseudoVSUXSEG5EI16_V_M1_MF2, VSUXSEG5EI16_V }, // 11980
  { PseudoVSUXSEG5EI16_V_M1_MF2_MASK, VSUXSEG5EI16_V }, // 11981
  { PseudoVSUXSEG5EI16_V_M2_M1, VSUXSEG5EI16_V }, // 11982
  { PseudoVSUXSEG5EI16_V_M2_M1_MASK, VSUXSEG5EI16_V }, // 11983
  { PseudoVSUXSEG5EI16_V_MF2_M1, VSUXSEG5EI16_V }, // 11984
  { PseudoVSUXSEG5EI16_V_MF2_M1_MASK, VSUXSEG5EI16_V }, // 11985
  { PseudoVSUXSEG5EI16_V_MF2_MF2, VSUXSEG5EI16_V }, // 11986
  { PseudoVSUXSEG5EI16_V_MF2_MF2_MASK, VSUXSEG5EI16_V }, // 11987
  { PseudoVSUXSEG5EI16_V_MF2_MF4, VSUXSEG5EI16_V }, // 11988
  { PseudoVSUXSEG5EI16_V_MF2_MF4_MASK, VSUXSEG5EI16_V }, // 11989
  { PseudoVSUXSEG5EI16_V_MF4_M1, VSUXSEG5EI16_V }, // 11990
  { PseudoVSUXSEG5EI16_V_MF4_M1_MASK, VSUXSEG5EI16_V }, // 11991
  { PseudoVSUXSEG5EI16_V_MF4_MF2, VSUXSEG5EI16_V }, // 11992
  { PseudoVSUXSEG5EI16_V_MF4_MF2_MASK, VSUXSEG5EI16_V }, // 11993
  { PseudoVSUXSEG5EI16_V_MF4_MF4, VSUXSEG5EI16_V }, // 11994
  { PseudoVSUXSEG5EI16_V_MF4_MF4_MASK, VSUXSEG5EI16_V }, // 11995
  { PseudoVSUXSEG5EI16_V_MF4_MF8, VSUXSEG5EI16_V }, // 11996
  { PseudoVSUXSEG5EI16_V_MF4_MF8_MASK, VSUXSEG5EI16_V }, // 11997
  { PseudoVSUXSEG5EI32_V_M1_M1, VSUXSEG5EI32_V }, // 11998
  { PseudoVSUXSEG5EI32_V_M1_M1_MASK, VSUXSEG5EI32_V }, // 11999
  { PseudoVSUXSEG5EI32_V_M1_MF2, VSUXSEG5EI32_V }, // 12000
  { PseudoVSUXSEG5EI32_V_M1_MF2_MASK, VSUXSEG5EI32_V }, // 12001
  { PseudoVSUXSEG5EI32_V_M1_MF4, VSUXSEG5EI32_V }, // 12002
  { PseudoVSUXSEG5EI32_V_M1_MF4_MASK, VSUXSEG5EI32_V }, // 12003
  { PseudoVSUXSEG5EI32_V_M2_M1, VSUXSEG5EI32_V }, // 12004
  { PseudoVSUXSEG5EI32_V_M2_M1_MASK, VSUXSEG5EI32_V }, // 12005
  { PseudoVSUXSEG5EI32_V_M2_MF2, VSUXSEG5EI32_V }, // 12006
  { PseudoVSUXSEG5EI32_V_M2_MF2_MASK, VSUXSEG5EI32_V }, // 12007
  { PseudoVSUXSEG5EI32_V_M4_M1, VSUXSEG5EI32_V }, // 12008
  { PseudoVSUXSEG5EI32_V_M4_M1_MASK, VSUXSEG5EI32_V }, // 12009
  { PseudoVSUXSEG5EI32_V_MF2_M1, VSUXSEG5EI32_V }, // 12010
  { PseudoVSUXSEG5EI32_V_MF2_M1_MASK, VSUXSEG5EI32_V }, // 12011
  { PseudoVSUXSEG5EI32_V_MF2_MF2, VSUXSEG5EI32_V }, // 12012
  { PseudoVSUXSEG5EI32_V_MF2_MF2_MASK, VSUXSEG5EI32_V }, // 12013
  { PseudoVSUXSEG5EI32_V_MF2_MF4, VSUXSEG5EI32_V }, // 12014
  { PseudoVSUXSEG5EI32_V_MF2_MF4_MASK, VSUXSEG5EI32_V }, // 12015
  { PseudoVSUXSEG5EI32_V_MF2_MF8, VSUXSEG5EI32_V }, // 12016
  { PseudoVSUXSEG5EI32_V_MF2_MF8_MASK, VSUXSEG5EI32_V }, // 12017
  { PseudoVSUXSEG5EI64_V_M1_M1, VSUXSEG5EI64_V }, // 12018
  { PseudoVSUXSEG5EI64_V_M1_M1_MASK, VSUXSEG5EI64_V }, // 12019
  { PseudoVSUXSEG5EI64_V_M1_MF2, VSUXSEG5EI64_V }, // 12020
  { PseudoVSUXSEG5EI64_V_M1_MF2_MASK, VSUXSEG5EI64_V }, // 12021
  { PseudoVSUXSEG5EI64_V_M1_MF4, VSUXSEG5EI64_V }, // 12022
  { PseudoVSUXSEG5EI64_V_M1_MF4_MASK, VSUXSEG5EI64_V }, // 12023
  { PseudoVSUXSEG5EI64_V_M1_MF8, VSUXSEG5EI64_V }, // 12024
  { PseudoVSUXSEG5EI64_V_M1_MF8_MASK, VSUXSEG5EI64_V }, // 12025
  { PseudoVSUXSEG5EI64_V_M2_M1, VSUXSEG5EI64_V }, // 12026
  { PseudoVSUXSEG5EI64_V_M2_M1_MASK, VSUXSEG5EI64_V }, // 12027
  { PseudoVSUXSEG5EI64_V_M2_MF2, VSUXSEG5EI64_V }, // 12028
  { PseudoVSUXSEG5EI64_V_M2_MF2_MASK, VSUXSEG5EI64_V }, // 12029
  { PseudoVSUXSEG5EI64_V_M2_MF4, VSUXSEG5EI64_V }, // 12030
  { PseudoVSUXSEG5EI64_V_M2_MF4_MASK, VSUXSEG5EI64_V }, // 12031
  { PseudoVSUXSEG5EI64_V_M4_M1, VSUXSEG5EI64_V }, // 12032
  { PseudoVSUXSEG5EI64_V_M4_M1_MASK, VSUXSEG5EI64_V }, // 12033
  { PseudoVSUXSEG5EI64_V_M4_MF2, VSUXSEG5EI64_V }, // 12034
  { PseudoVSUXSEG5EI64_V_M4_MF2_MASK, VSUXSEG5EI64_V }, // 12035
  { PseudoVSUXSEG5EI64_V_M8_M1, VSUXSEG5EI64_V }, // 12036
  { PseudoVSUXSEG5EI64_V_M8_M1_MASK, VSUXSEG5EI64_V }, // 12037
  { PseudoVSUXSEG5EI8_V_M1_M1, VSUXSEG5EI8_V }, // 12038
  { PseudoVSUXSEG5EI8_V_M1_M1_MASK, VSUXSEG5EI8_V }, // 12039
  { PseudoVSUXSEG5EI8_V_MF2_M1, VSUXSEG5EI8_V }, // 12040
  { PseudoVSUXSEG5EI8_V_MF2_M1_MASK, VSUXSEG5EI8_V }, // 12041
  { PseudoVSUXSEG5EI8_V_MF2_MF2, VSUXSEG5EI8_V }, // 12042
  { PseudoVSUXSEG5EI8_V_MF2_MF2_MASK, VSUXSEG5EI8_V }, // 12043
  { PseudoVSUXSEG5EI8_V_MF4_M1, VSUXSEG5EI8_V }, // 12044
  { PseudoVSUXSEG5EI8_V_MF4_M1_MASK, VSUXSEG5EI8_V }, // 12045
  { PseudoVSUXSEG5EI8_V_MF4_MF2, VSUXSEG5EI8_V }, // 12046
  { PseudoVSUXSEG5EI8_V_MF4_MF2_MASK, VSUXSEG5EI8_V }, // 12047
  { PseudoVSUXSEG5EI8_V_MF4_MF4, VSUXSEG5EI8_V }, // 12048
  { PseudoVSUXSEG5EI8_V_MF4_MF4_MASK, VSUXSEG5EI8_V }, // 12049
  { PseudoVSUXSEG5EI8_V_MF8_M1, VSUXSEG5EI8_V }, // 12050
  { PseudoVSUXSEG5EI8_V_MF8_M1_MASK, VSUXSEG5EI8_V }, // 12051
  { PseudoVSUXSEG5EI8_V_MF8_MF2, VSUXSEG5EI8_V }, // 12052
  { PseudoVSUXSEG5EI8_V_MF8_MF2_MASK, VSUXSEG5EI8_V }, // 12053
  { PseudoVSUXSEG5EI8_V_MF8_MF4, VSUXSEG5EI8_V }, // 12054
  { PseudoVSUXSEG5EI8_V_MF8_MF4_MASK, VSUXSEG5EI8_V }, // 12055
  { PseudoVSUXSEG5EI8_V_MF8_MF8, VSUXSEG5EI8_V }, // 12056
  { PseudoVSUXSEG5EI8_V_MF8_MF8_MASK, VSUXSEG5EI8_V }, // 12057
  { PseudoVSUXSEG6EI16_V_M1_M1, VSUXSEG6EI16_V }, // 12058
  { PseudoVSUXSEG6EI16_V_M1_M1_MASK, VSUXSEG6EI16_V }, // 12059
  { PseudoVSUXSEG6EI16_V_M1_MF2, VSUXSEG6EI16_V }, // 12060
  { PseudoVSUXSEG6EI16_V_M1_MF2_MASK, VSUXSEG6EI16_V }, // 12061
  { PseudoVSUXSEG6EI16_V_M2_M1, VSUXSEG6EI16_V }, // 12062
  { PseudoVSUXSEG6EI16_V_M2_M1_MASK, VSUXSEG6EI16_V }, // 12063
  { PseudoVSUXSEG6EI16_V_MF2_M1, VSUXSEG6EI16_V }, // 12064
  { PseudoVSUXSEG6EI16_V_MF2_M1_MASK, VSUXSEG6EI16_V }, // 12065
  { PseudoVSUXSEG6EI16_V_MF2_MF2, VSUXSEG6EI16_V }, // 12066
  { PseudoVSUXSEG6EI16_V_MF2_MF2_MASK, VSUXSEG6EI16_V }, // 12067
  { PseudoVSUXSEG6EI16_V_MF2_MF4, VSUXSEG6EI16_V }, // 12068
  { PseudoVSUXSEG6EI16_V_MF2_MF4_MASK, VSUXSEG6EI16_V }, // 12069
  { PseudoVSUXSEG6EI16_V_MF4_M1, VSUXSEG6EI16_V }, // 12070
  { PseudoVSUXSEG6EI16_V_MF4_M1_MASK, VSUXSEG6EI16_V }, // 12071
  { PseudoVSUXSEG6EI16_V_MF4_MF2, VSUXSEG6EI16_V }, // 12072
  { PseudoVSUXSEG6EI16_V_MF4_MF2_MASK, VSUXSEG6EI16_V }, // 12073
  { PseudoVSUXSEG6EI16_V_MF4_MF4, VSUXSEG6EI16_V }, // 12074
  { PseudoVSUXSEG6EI16_V_MF4_MF4_MASK, VSUXSEG6EI16_V }, // 12075
  { PseudoVSUXSEG6EI16_V_MF4_MF8, VSUXSEG6EI16_V }, // 12076
  { PseudoVSUXSEG6EI16_V_MF4_MF8_MASK, VSUXSEG6EI16_V }, // 12077
  { PseudoVSUXSEG6EI32_V_M1_M1, VSUXSEG6EI32_V }, // 12078
  { PseudoVSUXSEG6EI32_V_M1_M1_MASK, VSUXSEG6EI32_V }, // 12079
  { PseudoVSUXSEG6EI32_V_M1_MF2, VSUXSEG6EI32_V }, // 12080
  { PseudoVSUXSEG6EI32_V_M1_MF2_MASK, VSUXSEG6EI32_V }, // 12081
  { PseudoVSUXSEG6EI32_V_M1_MF4, VSUXSEG6EI32_V }, // 12082
  { PseudoVSUXSEG6EI32_V_M1_MF4_MASK, VSUXSEG6EI32_V }, // 12083
  { PseudoVSUXSEG6EI32_V_M2_M1, VSUXSEG6EI32_V }, // 12084
  { PseudoVSUXSEG6EI32_V_M2_M1_MASK, VSUXSEG6EI32_V }, // 12085
  { PseudoVSUXSEG6EI32_V_M2_MF2, VSUXSEG6EI32_V }, // 12086
  { PseudoVSUXSEG6EI32_V_M2_MF2_MASK, VSUXSEG6EI32_V }, // 12087
  { PseudoVSUXSEG6EI32_V_M4_M1, VSUXSEG6EI32_V }, // 12088
  { PseudoVSUXSEG6EI32_V_M4_M1_MASK, VSUXSEG6EI32_V }, // 12089
  { PseudoVSUXSEG6EI32_V_MF2_M1, VSUXSEG6EI32_V }, // 12090
  { PseudoVSUXSEG6EI32_V_MF2_M1_MASK, VSUXSEG6EI32_V }, // 12091
  { PseudoVSUXSEG6EI32_V_MF2_MF2, VSUXSEG6EI32_V }, // 12092
  { PseudoVSUXSEG6EI32_V_MF2_MF2_MASK, VSUXSEG6EI32_V }, // 12093
  { PseudoVSUXSEG6EI32_V_MF2_MF4, VSUXSEG6EI32_V }, // 12094
  { PseudoVSUXSEG6EI32_V_MF2_MF4_MASK, VSUXSEG6EI32_V }, // 12095
  { PseudoVSUXSEG6EI32_V_MF2_MF8, VSUXSEG6EI32_V }, // 12096
  { PseudoVSUXSEG6EI32_V_MF2_MF8_MASK, VSUXSEG6EI32_V }, // 12097
  { PseudoVSUXSEG6EI64_V_M1_M1, VSUXSEG6EI64_V }, // 12098
  { PseudoVSUXSEG6EI64_V_M1_M1_MASK, VSUXSEG6EI64_V }, // 12099
  { PseudoVSUXSEG6EI64_V_M1_MF2, VSUXSEG6EI64_V }, // 12100
  { PseudoVSUXSEG6EI64_V_M1_MF2_MASK, VSUXSEG6EI64_V }, // 12101
  { PseudoVSUXSEG6EI64_V_M1_MF4, VSUXSEG6EI64_V }, // 12102
  { PseudoVSUXSEG6EI64_V_M1_MF4_MASK, VSUXSEG6EI64_V }, // 12103
  { PseudoVSUXSEG6EI64_V_M1_MF8, VSUXSEG6EI64_V }, // 12104
  { PseudoVSUXSEG6EI64_V_M1_MF8_MASK, VSUXSEG6EI64_V }, // 12105
  { PseudoVSUXSEG6EI64_V_M2_M1, VSUXSEG6EI64_V }, // 12106
  { PseudoVSUXSEG6EI64_V_M2_M1_MASK, VSUXSEG6EI64_V }, // 12107
  { PseudoVSUXSEG6EI64_V_M2_MF2, VSUXSEG6EI64_V }, // 12108
  { PseudoVSUXSEG6EI64_V_M2_MF2_MASK, VSUXSEG6EI64_V }, // 12109
  { PseudoVSUXSEG6EI64_V_M2_MF4, VSUXSEG6EI64_V }, // 12110
  { PseudoVSUXSEG6EI64_V_M2_MF4_MASK, VSUXSEG6EI64_V }, // 12111
  { PseudoVSUXSEG6EI64_V_M4_M1, VSUXSEG6EI64_V }, // 12112
  { PseudoVSUXSEG6EI64_V_M4_M1_MASK, VSUXSEG6EI64_V }, // 12113
  { PseudoVSUXSEG6EI64_V_M4_MF2, VSUXSEG6EI64_V }, // 12114
  { PseudoVSUXSEG6EI64_V_M4_MF2_MASK, VSUXSEG6EI64_V }, // 12115
  { PseudoVSUXSEG6EI64_V_M8_M1, VSUXSEG6EI64_V }, // 12116
  { PseudoVSUXSEG6EI64_V_M8_M1_MASK, VSUXSEG6EI64_V }, // 12117
  { PseudoVSUXSEG6EI8_V_M1_M1, VSUXSEG6EI8_V }, // 12118
  { PseudoVSUXSEG6EI8_V_M1_M1_MASK, VSUXSEG6EI8_V }, // 12119
  { PseudoVSUXSEG6EI8_V_MF2_M1, VSUXSEG6EI8_V }, // 12120
  { PseudoVSUXSEG6EI8_V_MF2_M1_MASK, VSUXSEG6EI8_V }, // 12121
  { PseudoVSUXSEG6EI8_V_MF2_MF2, VSUXSEG6EI8_V }, // 12122
  { PseudoVSUXSEG6EI8_V_MF2_MF2_MASK, VSUXSEG6EI8_V }, // 12123
  { PseudoVSUXSEG6EI8_V_MF4_M1, VSUXSEG6EI8_V }, // 12124
  { PseudoVSUXSEG6EI8_V_MF4_M1_MASK, VSUXSEG6EI8_V }, // 12125
  { PseudoVSUXSEG6EI8_V_MF4_MF2, VSUXSEG6EI8_V }, // 12126
  { PseudoVSUXSEG6EI8_V_MF4_MF2_MASK, VSUXSEG6EI8_V }, // 12127
  { PseudoVSUXSEG6EI8_V_MF4_MF4, VSUXSEG6EI8_V }, // 12128
  { PseudoVSUXSEG6EI8_V_MF4_MF4_MASK, VSUXSEG6EI8_V }, // 12129
  { PseudoVSUXSEG6EI8_V_MF8_M1, VSUXSEG6EI8_V }, // 12130
  { PseudoVSUXSEG6EI8_V_MF8_M1_MASK, VSUXSEG6EI8_V }, // 12131
  { PseudoVSUXSEG6EI8_V_MF8_MF2, VSUXSEG6EI8_V }, // 12132
  { PseudoVSUXSEG6EI8_V_MF8_MF2_MASK, VSUXSEG6EI8_V }, // 12133
  { PseudoVSUXSEG6EI8_V_MF8_MF4, VSUXSEG6EI8_V }, // 12134
  { PseudoVSUXSEG6EI8_V_MF8_MF4_MASK, VSUXSEG6EI8_V }, // 12135
  { PseudoVSUXSEG6EI8_V_MF8_MF8, VSUXSEG6EI8_V }, // 12136
  { PseudoVSUXSEG6EI8_V_MF8_MF8_MASK, VSUXSEG6EI8_V }, // 12137
  { PseudoVSUXSEG7EI16_V_M1_M1, VSUXSEG7EI16_V }, // 12138
  { PseudoVSUXSEG7EI16_V_M1_M1_MASK, VSUXSEG7EI16_V }, // 12139
  { PseudoVSUXSEG7EI16_V_M1_MF2, VSUXSEG7EI16_V }, // 12140
  { PseudoVSUXSEG7EI16_V_M1_MF2_MASK, VSUXSEG7EI16_V }, // 12141
  { PseudoVSUXSEG7EI16_V_M2_M1, VSUXSEG7EI16_V }, // 12142
  { PseudoVSUXSEG7EI16_V_M2_M1_MASK, VSUXSEG7EI16_V }, // 12143
  { PseudoVSUXSEG7EI16_V_MF2_M1, VSUXSEG7EI16_V }, // 12144
  { PseudoVSUXSEG7EI16_V_MF2_M1_MASK, VSUXSEG7EI16_V }, // 12145
  { PseudoVSUXSEG7EI16_V_MF2_MF2, VSUXSEG7EI16_V }, // 12146
  { PseudoVSUXSEG7EI16_V_MF2_MF2_MASK, VSUXSEG7EI16_V }, // 12147
  { PseudoVSUXSEG7EI16_V_MF2_MF4, VSUXSEG7EI16_V }, // 12148
  { PseudoVSUXSEG7EI16_V_MF2_MF4_MASK, VSUXSEG7EI16_V }, // 12149
  { PseudoVSUXSEG7EI16_V_MF4_M1, VSUXSEG7EI16_V }, // 12150
  { PseudoVSUXSEG7EI16_V_MF4_M1_MASK, VSUXSEG7EI16_V }, // 12151
  { PseudoVSUXSEG7EI16_V_MF4_MF2, VSUXSEG7EI16_V }, // 12152
  { PseudoVSUXSEG7EI16_V_MF4_MF2_MASK, VSUXSEG7EI16_V }, // 12153
  { PseudoVSUXSEG7EI16_V_MF4_MF4, VSUXSEG7EI16_V }, // 12154
  { PseudoVSUXSEG7EI16_V_MF4_MF4_MASK, VSUXSEG7EI16_V }, // 12155
  { PseudoVSUXSEG7EI16_V_MF4_MF8, VSUXSEG7EI16_V }, // 12156
  { PseudoVSUXSEG7EI16_V_MF4_MF8_MASK, VSUXSEG7EI16_V }, // 12157
  { PseudoVSUXSEG7EI32_V_M1_M1, VSUXSEG7EI32_V }, // 12158
  { PseudoVSUXSEG7EI32_V_M1_M1_MASK, VSUXSEG7EI32_V }, // 12159
  { PseudoVSUXSEG7EI32_V_M1_MF2, VSUXSEG7EI32_V }, // 12160
  { PseudoVSUXSEG7EI32_V_M1_MF2_MASK, VSUXSEG7EI32_V }, // 12161
  { PseudoVSUXSEG7EI32_V_M1_MF4, VSUXSEG7EI32_V }, // 12162
  { PseudoVSUXSEG7EI32_V_M1_MF4_MASK, VSUXSEG7EI32_V }, // 12163
  { PseudoVSUXSEG7EI32_V_M2_M1, VSUXSEG7EI32_V }, // 12164
  { PseudoVSUXSEG7EI32_V_M2_M1_MASK, VSUXSEG7EI32_V }, // 12165
  { PseudoVSUXSEG7EI32_V_M2_MF2, VSUXSEG7EI32_V }, // 12166
  { PseudoVSUXSEG7EI32_V_M2_MF2_MASK, VSUXSEG7EI32_V }, // 12167
  { PseudoVSUXSEG7EI32_V_M4_M1, VSUXSEG7EI32_V }, // 12168
  { PseudoVSUXSEG7EI32_V_M4_M1_MASK, VSUXSEG7EI32_V }, // 12169
  { PseudoVSUXSEG7EI32_V_MF2_M1, VSUXSEG7EI32_V }, // 12170
  { PseudoVSUXSEG7EI32_V_MF2_M1_MASK, VSUXSEG7EI32_V }, // 12171
  { PseudoVSUXSEG7EI32_V_MF2_MF2, VSUXSEG7EI32_V }, // 12172
  { PseudoVSUXSEG7EI32_V_MF2_MF2_MASK, VSUXSEG7EI32_V }, // 12173
  { PseudoVSUXSEG7EI32_V_MF2_MF4, VSUXSEG7EI32_V }, // 12174
  { PseudoVSUXSEG7EI32_V_MF2_MF4_MASK, VSUXSEG7EI32_V }, // 12175
  { PseudoVSUXSEG7EI32_V_MF2_MF8, VSUXSEG7EI32_V }, // 12176
  { PseudoVSUXSEG7EI32_V_MF2_MF8_MASK, VSUXSEG7EI32_V }, // 12177
  { PseudoVSUXSEG7EI64_V_M1_M1, VSUXSEG7EI64_V }, // 12178
  { PseudoVSUXSEG7EI64_V_M1_M1_MASK, VSUXSEG7EI64_V }, // 12179
  { PseudoVSUXSEG7EI64_V_M1_MF2, VSUXSEG7EI64_V }, // 12180
  { PseudoVSUXSEG7EI64_V_M1_MF2_MASK, VSUXSEG7EI64_V }, // 12181
  { PseudoVSUXSEG7EI64_V_M1_MF4, VSUXSEG7EI64_V }, // 12182
  { PseudoVSUXSEG7EI64_V_M1_MF4_MASK, VSUXSEG7EI64_V }, // 12183
  { PseudoVSUXSEG7EI64_V_M1_MF8, VSUXSEG7EI64_V }, // 12184
  { PseudoVSUXSEG7EI64_V_M1_MF8_MASK, VSUXSEG7EI64_V }, // 12185
  { PseudoVSUXSEG7EI64_V_M2_M1, VSUXSEG7EI64_V }, // 12186
  { PseudoVSUXSEG7EI64_V_M2_M1_MASK, VSUXSEG7EI64_V }, // 12187
  { PseudoVSUXSEG7EI64_V_M2_MF2, VSUXSEG7EI64_V }, // 12188
  { PseudoVSUXSEG7EI64_V_M2_MF2_MASK, VSUXSEG7EI64_V }, // 12189
  { PseudoVSUXSEG7EI64_V_M2_MF4, VSUXSEG7EI64_V }, // 12190
  { PseudoVSUXSEG7EI64_V_M2_MF4_MASK, VSUXSEG7EI64_V }, // 12191
  { PseudoVSUXSEG7EI64_V_M4_M1, VSUXSEG7EI64_V }, // 12192
  { PseudoVSUXSEG7EI64_V_M4_M1_MASK, VSUXSEG7EI64_V }, // 12193
  { PseudoVSUXSEG7EI64_V_M4_MF2, VSUXSEG7EI64_V }, // 12194
  { PseudoVSUXSEG7EI64_V_M4_MF2_MASK, VSUXSEG7EI64_V }, // 12195
  { PseudoVSUXSEG7EI64_V_M8_M1, VSUXSEG7EI64_V }, // 12196
  { PseudoVSUXSEG7EI64_V_M8_M1_MASK, VSUXSEG7EI64_V }, // 12197
  { PseudoVSUXSEG7EI8_V_M1_M1, VSUXSEG7EI8_V }, // 12198
  { PseudoVSUXSEG7EI8_V_M1_M1_MASK, VSUXSEG7EI8_V }, // 12199
  { PseudoVSUXSEG7EI8_V_MF2_M1, VSUXSEG7EI8_V }, // 12200
  { PseudoVSUXSEG7EI8_V_MF2_M1_MASK, VSUXSEG7EI8_V }, // 12201
  { PseudoVSUXSEG7EI8_V_MF2_MF2, VSUXSEG7EI8_V }, // 12202
  { PseudoVSUXSEG7EI8_V_MF2_MF2_MASK, VSUXSEG7EI8_V }, // 12203
  { PseudoVSUXSEG7EI8_V_MF4_M1, VSUXSEG7EI8_V }, // 12204
  { PseudoVSUXSEG7EI8_V_MF4_M1_MASK, VSUXSEG7EI8_V }, // 12205
  { PseudoVSUXSEG7EI8_V_MF4_MF2, VSUXSEG7EI8_V }, // 12206
  { PseudoVSUXSEG7EI8_V_MF4_MF2_MASK, VSUXSEG7EI8_V }, // 12207
  { PseudoVSUXSEG7EI8_V_MF4_MF4, VSUXSEG7EI8_V }, // 12208
  { PseudoVSUXSEG7EI8_V_MF4_MF4_MASK, VSUXSEG7EI8_V }, // 12209
  { PseudoVSUXSEG7EI8_V_MF8_M1, VSUXSEG7EI8_V }, // 12210
  { PseudoVSUXSEG7EI8_V_MF8_M1_MASK, VSUXSEG7EI8_V }, // 12211
  { PseudoVSUXSEG7EI8_V_MF8_MF2, VSUXSEG7EI8_V }, // 12212
  { PseudoVSUXSEG7EI8_V_MF8_MF2_MASK, VSUXSEG7EI8_V }, // 12213
  { PseudoVSUXSEG7EI8_V_MF8_MF4, VSUXSEG7EI8_V }, // 12214
  { PseudoVSUXSEG7EI8_V_MF8_MF4_MASK, VSUXSEG7EI8_V }, // 12215
  { PseudoVSUXSEG7EI8_V_MF8_MF8, VSUXSEG7EI8_V }, // 12216
  { PseudoVSUXSEG7EI8_V_MF8_MF8_MASK, VSUXSEG7EI8_V }, // 12217
  { PseudoVSUXSEG8EI16_V_M1_M1, VSUXSEG8EI16_V }, // 12218
  { PseudoVSUXSEG8EI16_V_M1_M1_MASK, VSUXSEG8EI16_V }, // 12219
  { PseudoVSUXSEG8EI16_V_M1_MF2, VSUXSEG8EI16_V }, // 12220
  { PseudoVSUXSEG8EI16_V_M1_MF2_MASK, VSUXSEG8EI16_V }, // 12221
  { PseudoVSUXSEG8EI16_V_M2_M1, VSUXSEG8EI16_V }, // 12222
  { PseudoVSUXSEG8EI16_V_M2_M1_MASK, VSUXSEG8EI16_V }, // 12223
  { PseudoVSUXSEG8EI16_V_MF2_M1, VSUXSEG8EI16_V }, // 12224
  { PseudoVSUXSEG8EI16_V_MF2_M1_MASK, VSUXSEG8EI16_V }, // 12225
  { PseudoVSUXSEG8EI16_V_MF2_MF2, VSUXSEG8EI16_V }, // 12226
  { PseudoVSUXSEG8EI16_V_MF2_MF2_MASK, VSUXSEG8EI16_V }, // 12227
  { PseudoVSUXSEG8EI16_V_MF2_MF4, VSUXSEG8EI16_V }, // 12228
  { PseudoVSUXSEG8EI16_V_MF2_MF4_MASK, VSUXSEG8EI16_V }, // 12229
  { PseudoVSUXSEG8EI16_V_MF4_M1, VSUXSEG8EI16_V }, // 12230
  { PseudoVSUXSEG8EI16_V_MF4_M1_MASK, VSUXSEG8EI16_V }, // 12231
  { PseudoVSUXSEG8EI16_V_MF4_MF2, VSUXSEG8EI16_V }, // 12232
  { PseudoVSUXSEG8EI16_V_MF4_MF2_MASK, VSUXSEG8EI16_V }, // 12233
  { PseudoVSUXSEG8EI16_V_MF4_MF4, VSUXSEG8EI16_V }, // 12234
  { PseudoVSUXSEG8EI16_V_MF4_MF4_MASK, VSUXSEG8EI16_V }, // 12235
  { PseudoVSUXSEG8EI16_V_MF4_MF8, VSUXSEG8EI16_V }, // 12236
  { PseudoVSUXSEG8EI16_V_MF4_MF8_MASK, VSUXSEG8EI16_V }, // 12237
  { PseudoVSUXSEG8EI32_V_M1_M1, VSUXSEG8EI32_V }, // 12238
  { PseudoVSUXSEG8EI32_V_M1_M1_MASK, VSUXSEG8EI32_V }, // 12239
  { PseudoVSUXSEG8EI32_V_M1_MF2, VSUXSEG8EI32_V }, // 12240
  { PseudoVSUXSEG8EI32_V_M1_MF2_MASK, VSUXSEG8EI32_V }, // 12241
  { PseudoVSUXSEG8EI32_V_M1_MF4, VSUXSEG8EI32_V }, // 12242
  { PseudoVSUXSEG8EI32_V_M1_MF4_MASK, VSUXSEG8EI32_V }, // 12243
  { PseudoVSUXSEG8EI32_V_M2_M1, VSUXSEG8EI32_V }, // 12244
  { PseudoVSUXSEG8EI32_V_M2_M1_MASK, VSUXSEG8EI32_V }, // 12245
  { PseudoVSUXSEG8EI32_V_M2_MF2, VSUXSEG8EI32_V }, // 12246
  { PseudoVSUXSEG8EI32_V_M2_MF2_MASK, VSUXSEG8EI32_V }, // 12247
  { PseudoVSUXSEG8EI32_V_M4_M1, VSUXSEG8EI32_V }, // 12248
  { PseudoVSUXSEG8EI32_V_M4_M1_MASK, VSUXSEG8EI32_V }, // 12249
  { PseudoVSUXSEG8EI32_V_MF2_M1, VSUXSEG8EI32_V }, // 12250
  { PseudoVSUXSEG8EI32_V_MF2_M1_MASK, VSUXSEG8EI32_V }, // 12251
  { PseudoVSUXSEG8EI32_V_MF2_MF2, VSUXSEG8EI32_V }, // 12252
  { PseudoVSUXSEG8EI32_V_MF2_MF2_MASK, VSUXSEG8EI32_V }, // 12253
  { PseudoVSUXSEG8EI32_V_MF2_MF4, VSUXSEG8EI32_V }, // 12254
  { PseudoVSUXSEG8EI32_V_MF2_MF4_MASK, VSUXSEG8EI32_V }, // 12255
  { PseudoVSUXSEG8EI32_V_MF2_MF8, VSUXSEG8EI32_V }, // 12256
  { PseudoVSUXSEG8EI32_V_MF2_MF8_MASK, VSUXSEG8EI32_V }, // 12257
  { PseudoVSUXSEG8EI64_V_M1_M1, VSUXSEG8EI64_V }, // 12258
  { PseudoVSUXSEG8EI64_V_M1_M1_MASK, VSUXSEG8EI64_V }, // 12259
  { PseudoVSUXSEG8EI64_V_M1_MF2, VSUXSEG8EI64_V }, // 12260
  { PseudoVSUXSEG8EI64_V_M1_MF2_MASK, VSUXSEG8EI64_V }, // 12261
  { PseudoVSUXSEG8EI64_V_M1_MF4, VSUXSEG8EI64_V }, // 12262
  { PseudoVSUXSEG8EI64_V_M1_MF4_MASK, VSUXSEG8EI64_V }, // 12263
  { PseudoVSUXSEG8EI64_V_M1_MF8, VSUXSEG8EI64_V }, // 12264
  { PseudoVSUXSEG8EI64_V_M1_MF8_MASK, VSUXSEG8EI64_V }, // 12265
  { PseudoVSUXSEG8EI64_V_M2_M1, VSUXSEG8EI64_V }, // 12266
  { PseudoVSUXSEG8EI64_V_M2_M1_MASK, VSUXSEG8EI64_V }, // 12267
  { PseudoVSUXSEG8EI64_V_M2_MF2, VSUXSEG8EI64_V }, // 12268
  { PseudoVSUXSEG8EI64_V_M2_MF2_MASK, VSUXSEG8EI64_V }, // 12269
  { PseudoVSUXSEG8EI64_V_M2_MF4, VSUXSEG8EI64_V }, // 12270
  { PseudoVSUXSEG8EI64_V_M2_MF4_MASK, VSUXSEG8EI64_V }, // 12271
  { PseudoVSUXSEG8EI64_V_M4_M1, VSUXSEG8EI64_V }, // 12272
  { PseudoVSUXSEG8EI64_V_M4_M1_MASK, VSUXSEG8EI64_V }, // 12273
  { PseudoVSUXSEG8EI64_V_M4_MF2, VSUXSEG8EI64_V }, // 12274
  { PseudoVSUXSEG8EI64_V_M4_MF2_MASK, VSUXSEG8EI64_V }, // 12275
  { PseudoVSUXSEG8EI64_V_M8_M1, VSUXSEG8EI64_V }, // 12276
  { PseudoVSUXSEG8EI64_V_M8_M1_MASK, VSUXSEG8EI64_V }, // 12277
  { PseudoVSUXSEG8EI8_V_M1_M1, VSUXSEG8EI8_V }, // 12278
  { PseudoVSUXSEG8EI8_V_M1_M1_MASK, VSUXSEG8EI8_V }, // 12279
  { PseudoVSUXSEG8EI8_V_MF2_M1, VSUXSEG8EI8_V }, // 12280
  { PseudoVSUXSEG8EI8_V_MF2_M1_MASK, VSUXSEG8EI8_V }, // 12281
  { PseudoVSUXSEG8EI8_V_MF2_MF2, VSUXSEG8EI8_V }, // 12282
  { PseudoVSUXSEG8EI8_V_MF2_MF2_MASK, VSUXSEG8EI8_V }, // 12283
  { PseudoVSUXSEG8EI8_V_MF4_M1, VSUXSEG8EI8_V }, // 12284
  { PseudoVSUXSEG8EI8_V_MF4_M1_MASK, VSUXSEG8EI8_V }, // 12285
  { PseudoVSUXSEG8EI8_V_MF4_MF2, VSUXSEG8EI8_V }, // 12286
  { PseudoVSUXSEG8EI8_V_MF4_MF2_MASK, VSUXSEG8EI8_V }, // 12287
  { PseudoVSUXSEG8EI8_V_MF4_MF4, VSUXSEG8EI8_V }, // 12288
  { PseudoVSUXSEG8EI8_V_MF4_MF4_MASK, VSUXSEG8EI8_V }, // 12289
  { PseudoVSUXSEG8EI8_V_MF8_M1, VSUXSEG8EI8_V }, // 12290
  { PseudoVSUXSEG8EI8_V_MF8_M1_MASK, VSUXSEG8EI8_V }, // 12291
  { PseudoVSUXSEG8EI8_V_MF8_MF2, VSUXSEG8EI8_V }, // 12292
  { PseudoVSUXSEG8EI8_V_MF8_MF2_MASK, VSUXSEG8EI8_V }, // 12293
  { PseudoVSUXSEG8EI8_V_MF8_MF4, VSUXSEG8EI8_V }, // 12294
  { PseudoVSUXSEG8EI8_V_MF8_MF4_MASK, VSUXSEG8EI8_V }, // 12295
  { PseudoVSUXSEG8EI8_V_MF8_MF8, VSUXSEG8EI8_V }, // 12296
  { PseudoVSUXSEG8EI8_V_MF8_MF8_MASK, VSUXSEG8EI8_V }, // 12297
  { PseudoVWADDU_VV_M1, VWADDU_VV }, // 12298
  { PseudoVWADDU_VV_M1_MASK, VWADDU_VV }, // 12299
  { PseudoVWADDU_VV_M1_TU, VWADDU_VV }, // 12300
  { PseudoVWADDU_VV_M2, VWADDU_VV }, // 12301
  { PseudoVWADDU_VV_M2_MASK, VWADDU_VV }, // 12302
  { PseudoVWADDU_VV_M2_TU, VWADDU_VV }, // 12303
  { PseudoVWADDU_VV_M4, VWADDU_VV }, // 12304
  { PseudoVWADDU_VV_M4_MASK, VWADDU_VV }, // 12305
  { PseudoVWADDU_VV_M4_TU, VWADDU_VV }, // 12306
  { PseudoVWADDU_VV_MF2, VWADDU_VV }, // 12307
  { PseudoVWADDU_VV_MF2_MASK, VWADDU_VV }, // 12308
  { PseudoVWADDU_VV_MF2_TU, VWADDU_VV }, // 12309
  { PseudoVWADDU_VV_MF4, VWADDU_VV }, // 12310
  { PseudoVWADDU_VV_MF4_MASK, VWADDU_VV }, // 12311
  { PseudoVWADDU_VV_MF4_TU, VWADDU_VV }, // 12312
  { PseudoVWADDU_VV_MF8, VWADDU_VV }, // 12313
  { PseudoVWADDU_VV_MF8_MASK, VWADDU_VV }, // 12314
  { PseudoVWADDU_VV_MF8_TU, VWADDU_VV }, // 12315
  { PseudoVWADDU_VX_M1, VWADDU_VX }, // 12316
  { PseudoVWADDU_VX_M1_MASK, VWADDU_VX }, // 12317
  { PseudoVWADDU_VX_M1_TU, VWADDU_VX }, // 12318
  { PseudoVWADDU_VX_M2, VWADDU_VX }, // 12319
  { PseudoVWADDU_VX_M2_MASK, VWADDU_VX }, // 12320
  { PseudoVWADDU_VX_M2_TU, VWADDU_VX }, // 12321
  { PseudoVWADDU_VX_M4, VWADDU_VX }, // 12322
  { PseudoVWADDU_VX_M4_MASK, VWADDU_VX }, // 12323
  { PseudoVWADDU_VX_M4_TU, VWADDU_VX }, // 12324
  { PseudoVWADDU_VX_MF2, VWADDU_VX }, // 12325
  { PseudoVWADDU_VX_MF2_MASK, VWADDU_VX }, // 12326
  { PseudoVWADDU_VX_MF2_TU, VWADDU_VX }, // 12327
  { PseudoVWADDU_VX_MF4, VWADDU_VX }, // 12328
  { PseudoVWADDU_VX_MF4_MASK, VWADDU_VX }, // 12329
  { PseudoVWADDU_VX_MF4_TU, VWADDU_VX }, // 12330
  { PseudoVWADDU_VX_MF8, VWADDU_VX }, // 12331
  { PseudoVWADDU_VX_MF8_MASK, VWADDU_VX }, // 12332
  { PseudoVWADDU_VX_MF8_TU, VWADDU_VX }, // 12333
  { PseudoVWADDU_WV_M1, VWADDU_WV }, // 12334
  { PseudoVWADDU_WV_M1_MASK, VWADDU_WV }, // 12335
  { PseudoVWADDU_WV_M1_MASK_TIED, VWADDU_WV }, // 12336
  { PseudoVWADDU_WV_M1_TIED, VWADDU_WV }, // 12337
  { PseudoVWADDU_WV_M1_TU, VWADDU_WV }, // 12338
  { PseudoVWADDU_WV_M2, VWADDU_WV }, // 12339
  { PseudoVWADDU_WV_M2_MASK, VWADDU_WV }, // 12340
  { PseudoVWADDU_WV_M2_MASK_TIED, VWADDU_WV }, // 12341
  { PseudoVWADDU_WV_M2_TIED, VWADDU_WV }, // 12342
  { PseudoVWADDU_WV_M2_TU, VWADDU_WV }, // 12343
  { PseudoVWADDU_WV_M4, VWADDU_WV }, // 12344
  { PseudoVWADDU_WV_M4_MASK, VWADDU_WV }, // 12345
  { PseudoVWADDU_WV_M4_MASK_TIED, VWADDU_WV }, // 12346
  { PseudoVWADDU_WV_M4_TIED, VWADDU_WV }, // 12347
  { PseudoVWADDU_WV_M4_TU, VWADDU_WV }, // 12348
  { PseudoVWADDU_WV_MF2, VWADDU_WV }, // 12349
  { PseudoVWADDU_WV_MF2_MASK, VWADDU_WV }, // 12350
  { PseudoVWADDU_WV_MF2_MASK_TIED, VWADDU_WV }, // 12351
  { PseudoVWADDU_WV_MF2_TIED, VWADDU_WV }, // 12352
  { PseudoVWADDU_WV_MF2_TU, VWADDU_WV }, // 12353
  { PseudoVWADDU_WV_MF4, VWADDU_WV }, // 12354
  { PseudoVWADDU_WV_MF4_MASK, VWADDU_WV }, // 12355
  { PseudoVWADDU_WV_MF4_MASK_TIED, VWADDU_WV }, // 12356
  { PseudoVWADDU_WV_MF4_TIED, VWADDU_WV }, // 12357
  { PseudoVWADDU_WV_MF4_TU, VWADDU_WV }, // 12358
  { PseudoVWADDU_WV_MF8, VWADDU_WV }, // 12359
  { PseudoVWADDU_WV_MF8_MASK, VWADDU_WV }, // 12360
  { PseudoVWADDU_WV_MF8_MASK_TIED, VWADDU_WV }, // 12361
  { PseudoVWADDU_WV_MF8_TIED, VWADDU_WV }, // 12362
  { PseudoVWADDU_WV_MF8_TU, VWADDU_WV }, // 12363
  { PseudoVWADDU_WX_M1, VWADDU_WX }, // 12364
  { PseudoVWADDU_WX_M1_MASK, VWADDU_WX }, // 12365
  { PseudoVWADDU_WX_M1_TU, VWADDU_WX }, // 12366
  { PseudoVWADDU_WX_M2, VWADDU_WX }, // 12367
  { PseudoVWADDU_WX_M2_MASK, VWADDU_WX }, // 12368
  { PseudoVWADDU_WX_M2_TU, VWADDU_WX }, // 12369
  { PseudoVWADDU_WX_M4, VWADDU_WX }, // 12370
  { PseudoVWADDU_WX_M4_MASK, VWADDU_WX }, // 12371
  { PseudoVWADDU_WX_M4_TU, VWADDU_WX }, // 12372
  { PseudoVWADDU_WX_MF2, VWADDU_WX }, // 12373
  { PseudoVWADDU_WX_MF2_MASK, VWADDU_WX }, // 12374
  { PseudoVWADDU_WX_MF2_TU, VWADDU_WX }, // 12375
  { PseudoVWADDU_WX_MF4, VWADDU_WX }, // 12376
  { PseudoVWADDU_WX_MF4_MASK, VWADDU_WX }, // 12377
  { PseudoVWADDU_WX_MF4_TU, VWADDU_WX }, // 12378
  { PseudoVWADDU_WX_MF8, VWADDU_WX }, // 12379
  { PseudoVWADDU_WX_MF8_MASK, VWADDU_WX }, // 12380
  { PseudoVWADDU_WX_MF8_TU, VWADDU_WX }, // 12381
  { PseudoVWADD_VV_M1, VWADD_VV }, // 12382
  { PseudoVWADD_VV_M1_MASK, VWADD_VV }, // 12383
  { PseudoVWADD_VV_M1_TU, VWADD_VV }, // 12384
  { PseudoVWADD_VV_M2, VWADD_VV }, // 12385
  { PseudoVWADD_VV_M2_MASK, VWADD_VV }, // 12386
  { PseudoVWADD_VV_M2_TU, VWADD_VV }, // 12387
  { PseudoVWADD_VV_M4, VWADD_VV }, // 12388
  { PseudoVWADD_VV_M4_MASK, VWADD_VV }, // 12389
  { PseudoVWADD_VV_M4_TU, VWADD_VV }, // 12390
  { PseudoVWADD_VV_MF2, VWADD_VV }, // 12391
  { PseudoVWADD_VV_MF2_MASK, VWADD_VV }, // 12392
  { PseudoVWADD_VV_MF2_TU, VWADD_VV }, // 12393
  { PseudoVWADD_VV_MF4, VWADD_VV }, // 12394
  { PseudoVWADD_VV_MF4_MASK, VWADD_VV }, // 12395
  { PseudoVWADD_VV_MF4_TU, VWADD_VV }, // 12396
  { PseudoVWADD_VV_MF8, VWADD_VV }, // 12397
  { PseudoVWADD_VV_MF8_MASK, VWADD_VV }, // 12398
  { PseudoVWADD_VV_MF8_TU, VWADD_VV }, // 12399
  { PseudoVWADD_VX_M1, VWADD_VX }, // 12400
  { PseudoVWADD_VX_M1_MASK, VWADD_VX }, // 12401
  { PseudoVWADD_VX_M1_TU, VWADD_VX }, // 12402
  { PseudoVWADD_VX_M2, VWADD_VX }, // 12403
  { PseudoVWADD_VX_M2_MASK, VWADD_VX }, // 12404
  { PseudoVWADD_VX_M2_TU, VWADD_VX }, // 12405
  { PseudoVWADD_VX_M4, VWADD_VX }, // 12406
  { PseudoVWADD_VX_M4_MASK, VWADD_VX }, // 12407
  { PseudoVWADD_VX_M4_TU, VWADD_VX }, // 12408
  { PseudoVWADD_VX_MF2, VWADD_VX }, // 12409
  { PseudoVWADD_VX_MF2_MASK, VWADD_VX }, // 12410
  { PseudoVWADD_VX_MF2_TU, VWADD_VX }, // 12411
  { PseudoVWADD_VX_MF4, VWADD_VX }, // 12412
  { PseudoVWADD_VX_MF4_MASK, VWADD_VX }, // 12413
  { PseudoVWADD_VX_MF4_TU, VWADD_VX }, // 12414
  { PseudoVWADD_VX_MF8, VWADD_VX }, // 12415
  { PseudoVWADD_VX_MF8_MASK, VWADD_VX }, // 12416
  { PseudoVWADD_VX_MF8_TU, VWADD_VX }, // 12417
  { PseudoVWADD_WV_M1, VWADD_WV }, // 12418
  { PseudoVWADD_WV_M1_MASK, VWADD_WV }, // 12419
  { PseudoVWADD_WV_M1_MASK_TIED, VWADD_WV }, // 12420
  { PseudoVWADD_WV_M1_TIED, VWADD_WV }, // 12421
  { PseudoVWADD_WV_M1_TU, VWADD_WV }, // 12422
  { PseudoVWADD_WV_M2, VWADD_WV }, // 12423
  { PseudoVWADD_WV_M2_MASK, VWADD_WV }, // 12424
  { PseudoVWADD_WV_M2_MASK_TIED, VWADD_WV }, // 12425
  { PseudoVWADD_WV_M2_TIED, VWADD_WV }, // 12426
  { PseudoVWADD_WV_M2_TU, VWADD_WV }, // 12427
  { PseudoVWADD_WV_M4, VWADD_WV }, // 12428
  { PseudoVWADD_WV_M4_MASK, VWADD_WV }, // 12429
  { PseudoVWADD_WV_M4_MASK_TIED, VWADD_WV }, // 12430
  { PseudoVWADD_WV_M4_TIED, VWADD_WV }, // 12431
  { PseudoVWADD_WV_M4_TU, VWADD_WV }, // 12432
  { PseudoVWADD_WV_MF2, VWADD_WV }, // 12433
  { PseudoVWADD_WV_MF2_MASK, VWADD_WV }, // 12434
  { PseudoVWADD_WV_MF2_MASK_TIED, VWADD_WV }, // 12435
  { PseudoVWADD_WV_MF2_TIED, VWADD_WV }, // 12436
  { PseudoVWADD_WV_MF2_TU, VWADD_WV }, // 12437
  { PseudoVWADD_WV_MF4, VWADD_WV }, // 12438
  { PseudoVWADD_WV_MF4_MASK, VWADD_WV }, // 12439
  { PseudoVWADD_WV_MF4_MASK_TIED, VWADD_WV }, // 12440
  { PseudoVWADD_WV_MF4_TIED, VWADD_WV }, // 12441
  { PseudoVWADD_WV_MF4_TU, VWADD_WV }, // 12442
  { PseudoVWADD_WV_MF8, VWADD_WV }, // 12443
  { PseudoVWADD_WV_MF8_MASK, VWADD_WV }, // 12444
  { PseudoVWADD_WV_MF8_MASK_TIED, VWADD_WV }, // 12445
  { PseudoVWADD_WV_MF8_TIED, VWADD_WV }, // 12446
  { PseudoVWADD_WV_MF8_TU, VWADD_WV }, // 12447
  { PseudoVWADD_WX_M1, VWADD_WX }, // 12448
  { PseudoVWADD_WX_M1_MASK, VWADD_WX }, // 12449
  { PseudoVWADD_WX_M1_TU, VWADD_WX }, // 12450
  { PseudoVWADD_WX_M2, VWADD_WX }, // 12451
  { PseudoVWADD_WX_M2_MASK, VWADD_WX }, // 12452
  { PseudoVWADD_WX_M2_TU, VWADD_WX }, // 12453
  { PseudoVWADD_WX_M4, VWADD_WX }, // 12454
  { PseudoVWADD_WX_M4_MASK, VWADD_WX }, // 12455
  { PseudoVWADD_WX_M4_TU, VWADD_WX }, // 12456
  { PseudoVWADD_WX_MF2, VWADD_WX }, // 12457
  { PseudoVWADD_WX_MF2_MASK, VWADD_WX }, // 12458
  { PseudoVWADD_WX_MF2_TU, VWADD_WX }, // 12459
  { PseudoVWADD_WX_MF4, VWADD_WX }, // 12460
  { PseudoVWADD_WX_MF4_MASK, VWADD_WX }, // 12461
  { PseudoVWADD_WX_MF4_TU, VWADD_WX }, // 12462
  { PseudoVWADD_WX_MF8, VWADD_WX }, // 12463
  { PseudoVWADD_WX_MF8_MASK, VWADD_WX }, // 12464
  { PseudoVWADD_WX_MF8_TU, VWADD_WX }, // 12465
  { PseudoVWMACCSU_VV_M1, VWMACCSU_VV }, // 12466
  { PseudoVWMACCSU_VV_M1_MASK, VWMACCSU_VV }, // 12467
  { PseudoVWMACCSU_VV_M2, VWMACCSU_VV }, // 12468
  { PseudoVWMACCSU_VV_M2_MASK, VWMACCSU_VV }, // 12469
  { PseudoVWMACCSU_VV_M4, VWMACCSU_VV }, // 12470
  { PseudoVWMACCSU_VV_M4_MASK, VWMACCSU_VV }, // 12471
  { PseudoVWMACCSU_VV_MF2, VWMACCSU_VV }, // 12472
  { PseudoVWMACCSU_VV_MF2_MASK, VWMACCSU_VV }, // 12473
  { PseudoVWMACCSU_VV_MF4, VWMACCSU_VV }, // 12474
  { PseudoVWMACCSU_VV_MF4_MASK, VWMACCSU_VV }, // 12475
  { PseudoVWMACCSU_VV_MF8, VWMACCSU_VV }, // 12476
  { PseudoVWMACCSU_VV_MF8_MASK, VWMACCSU_VV }, // 12477
  { PseudoVWMACCSU_VX_M1, VWMACCSU_VX }, // 12478
  { PseudoVWMACCSU_VX_M1_MASK, VWMACCSU_VX }, // 12479
  { PseudoVWMACCSU_VX_M2, VWMACCSU_VX }, // 12480
  { PseudoVWMACCSU_VX_M2_MASK, VWMACCSU_VX }, // 12481
  { PseudoVWMACCSU_VX_M4, VWMACCSU_VX }, // 12482
  { PseudoVWMACCSU_VX_M4_MASK, VWMACCSU_VX }, // 12483
  { PseudoVWMACCSU_VX_MF2, VWMACCSU_VX }, // 12484
  { PseudoVWMACCSU_VX_MF2_MASK, VWMACCSU_VX }, // 12485
  { PseudoVWMACCSU_VX_MF4, VWMACCSU_VX }, // 12486
  { PseudoVWMACCSU_VX_MF4_MASK, VWMACCSU_VX }, // 12487
  { PseudoVWMACCSU_VX_MF8, VWMACCSU_VX }, // 12488
  { PseudoVWMACCSU_VX_MF8_MASK, VWMACCSU_VX }, // 12489
  { PseudoVWMACCUS_VX_M1, VWMACCUS_VX }, // 12490
  { PseudoVWMACCUS_VX_M1_MASK, VWMACCUS_VX }, // 12491
  { PseudoVWMACCUS_VX_M2, VWMACCUS_VX }, // 12492
  { PseudoVWMACCUS_VX_M2_MASK, VWMACCUS_VX }, // 12493
  { PseudoVWMACCUS_VX_M4, VWMACCUS_VX }, // 12494
  { PseudoVWMACCUS_VX_M4_MASK, VWMACCUS_VX }, // 12495
  { PseudoVWMACCUS_VX_MF2, VWMACCUS_VX }, // 12496
  { PseudoVWMACCUS_VX_MF2_MASK, VWMACCUS_VX }, // 12497
  { PseudoVWMACCUS_VX_MF4, VWMACCUS_VX }, // 12498
  { PseudoVWMACCUS_VX_MF4_MASK, VWMACCUS_VX }, // 12499
  { PseudoVWMACCUS_VX_MF8, VWMACCUS_VX }, // 12500
  { PseudoVWMACCUS_VX_MF8_MASK, VWMACCUS_VX }, // 12501
  { PseudoVWMACCU_VV_M1, VWMACCU_VV }, // 12502
  { PseudoVWMACCU_VV_M1_MASK, VWMACCU_VV }, // 12503
  { PseudoVWMACCU_VV_M2, VWMACCU_VV }, // 12504
  { PseudoVWMACCU_VV_M2_MASK, VWMACCU_VV }, // 12505
  { PseudoVWMACCU_VV_M4, VWMACCU_VV }, // 12506
  { PseudoVWMACCU_VV_M4_MASK, VWMACCU_VV }, // 12507
  { PseudoVWMACCU_VV_MF2, VWMACCU_VV }, // 12508
  { PseudoVWMACCU_VV_MF2_MASK, VWMACCU_VV }, // 12509
  { PseudoVWMACCU_VV_MF4, VWMACCU_VV }, // 12510
  { PseudoVWMACCU_VV_MF4_MASK, VWMACCU_VV }, // 12511
  { PseudoVWMACCU_VV_MF8, VWMACCU_VV }, // 12512
  { PseudoVWMACCU_VV_MF8_MASK, VWMACCU_VV }, // 12513
  { PseudoVWMACCU_VX_M1, VWMACCU_VX }, // 12514
  { PseudoVWMACCU_VX_M1_MASK, VWMACCU_VX }, // 12515
  { PseudoVWMACCU_VX_M2, VWMACCU_VX }, // 12516
  { PseudoVWMACCU_VX_M2_MASK, VWMACCU_VX }, // 12517
  { PseudoVWMACCU_VX_M4, VWMACCU_VX }, // 12518
  { PseudoVWMACCU_VX_M4_MASK, VWMACCU_VX }, // 12519
  { PseudoVWMACCU_VX_MF2, VWMACCU_VX }, // 12520
  { PseudoVWMACCU_VX_MF2_MASK, VWMACCU_VX }, // 12521
  { PseudoVWMACCU_VX_MF4, VWMACCU_VX }, // 12522
  { PseudoVWMACCU_VX_MF4_MASK, VWMACCU_VX }, // 12523
  { PseudoVWMACCU_VX_MF8, VWMACCU_VX }, // 12524
  { PseudoVWMACCU_VX_MF8_MASK, VWMACCU_VX }, // 12525
  { PseudoVWMACC_VV_M1, VWMACC_VV }, // 12526
  { PseudoVWMACC_VV_M1_MASK, VWMACC_VV }, // 12527
  { PseudoVWMACC_VV_M2, VWMACC_VV }, // 12528
  { PseudoVWMACC_VV_M2_MASK, VWMACC_VV }, // 12529
  { PseudoVWMACC_VV_M4, VWMACC_VV }, // 12530
  { PseudoVWMACC_VV_M4_MASK, VWMACC_VV }, // 12531
  { PseudoVWMACC_VV_MF2, VWMACC_VV }, // 12532
  { PseudoVWMACC_VV_MF2_MASK, VWMACC_VV }, // 12533
  { PseudoVWMACC_VV_MF4, VWMACC_VV }, // 12534
  { PseudoVWMACC_VV_MF4_MASK, VWMACC_VV }, // 12535
  { PseudoVWMACC_VV_MF8, VWMACC_VV }, // 12536
  { PseudoVWMACC_VV_MF8_MASK, VWMACC_VV }, // 12537
  { PseudoVWMACC_VX_M1, VWMACC_VX }, // 12538
  { PseudoVWMACC_VX_M1_MASK, VWMACC_VX }, // 12539
  { PseudoVWMACC_VX_M2, VWMACC_VX }, // 12540
  { PseudoVWMACC_VX_M2_MASK, VWMACC_VX }, // 12541
  { PseudoVWMACC_VX_M4, VWMACC_VX }, // 12542
  { PseudoVWMACC_VX_M4_MASK, VWMACC_VX }, // 12543
  { PseudoVWMACC_VX_MF2, VWMACC_VX }, // 12544
  { PseudoVWMACC_VX_MF2_MASK, VWMACC_VX }, // 12545
  { PseudoVWMACC_VX_MF4, VWMACC_VX }, // 12546
  { PseudoVWMACC_VX_MF4_MASK, VWMACC_VX }, // 12547
  { PseudoVWMACC_VX_MF8, VWMACC_VX }, // 12548
  { PseudoVWMACC_VX_MF8_MASK, VWMACC_VX }, // 12549
  { PseudoVWMULSU_VV_M1, VWMULSU_VV }, // 12550
  { PseudoVWMULSU_VV_M1_MASK, VWMULSU_VV }, // 12551
  { PseudoVWMULSU_VV_M1_TU, VWMULSU_VV }, // 12552
  { PseudoVWMULSU_VV_M2, VWMULSU_VV }, // 12553
  { PseudoVWMULSU_VV_M2_MASK, VWMULSU_VV }, // 12554
  { PseudoVWMULSU_VV_M2_TU, VWMULSU_VV }, // 12555
  { PseudoVWMULSU_VV_M4, VWMULSU_VV }, // 12556
  { PseudoVWMULSU_VV_M4_MASK, VWMULSU_VV }, // 12557
  { PseudoVWMULSU_VV_M4_TU, VWMULSU_VV }, // 12558
  { PseudoVWMULSU_VV_MF2, VWMULSU_VV }, // 12559
  { PseudoVWMULSU_VV_MF2_MASK, VWMULSU_VV }, // 12560
  { PseudoVWMULSU_VV_MF2_TU, VWMULSU_VV }, // 12561
  { PseudoVWMULSU_VV_MF4, VWMULSU_VV }, // 12562
  { PseudoVWMULSU_VV_MF4_MASK, VWMULSU_VV }, // 12563
  { PseudoVWMULSU_VV_MF4_TU, VWMULSU_VV }, // 12564
  { PseudoVWMULSU_VV_MF8, VWMULSU_VV }, // 12565
  { PseudoVWMULSU_VV_MF8_MASK, VWMULSU_VV }, // 12566
  { PseudoVWMULSU_VV_MF8_TU, VWMULSU_VV }, // 12567
  { PseudoVWMULSU_VX_M1, VWMULSU_VX }, // 12568
  { PseudoVWMULSU_VX_M1_MASK, VWMULSU_VX }, // 12569
  { PseudoVWMULSU_VX_M1_TU, VWMULSU_VX }, // 12570
  { PseudoVWMULSU_VX_M2, VWMULSU_VX }, // 12571
  { PseudoVWMULSU_VX_M2_MASK, VWMULSU_VX }, // 12572
  { PseudoVWMULSU_VX_M2_TU, VWMULSU_VX }, // 12573
  { PseudoVWMULSU_VX_M4, VWMULSU_VX }, // 12574
  { PseudoVWMULSU_VX_M4_MASK, VWMULSU_VX }, // 12575
  { PseudoVWMULSU_VX_M4_TU, VWMULSU_VX }, // 12576
  { PseudoVWMULSU_VX_MF2, VWMULSU_VX }, // 12577
  { PseudoVWMULSU_VX_MF2_MASK, VWMULSU_VX }, // 12578
  { PseudoVWMULSU_VX_MF2_TU, VWMULSU_VX }, // 12579
  { PseudoVWMULSU_VX_MF4, VWMULSU_VX }, // 12580
  { PseudoVWMULSU_VX_MF4_MASK, VWMULSU_VX }, // 12581
  { PseudoVWMULSU_VX_MF4_TU, VWMULSU_VX }, // 12582
  { PseudoVWMULSU_VX_MF8, VWMULSU_VX }, // 12583
  { PseudoVWMULSU_VX_MF8_MASK, VWMULSU_VX }, // 12584
  { PseudoVWMULSU_VX_MF8_TU, VWMULSU_VX }, // 12585
  { PseudoVWMULU_VV_M1, VWMULU_VV }, // 12586
  { PseudoVWMULU_VV_M1_MASK, VWMULU_VV }, // 12587
  { PseudoVWMULU_VV_M1_TU, VWMULU_VV }, // 12588
  { PseudoVWMULU_VV_M2, VWMULU_VV }, // 12589
  { PseudoVWMULU_VV_M2_MASK, VWMULU_VV }, // 12590
  { PseudoVWMULU_VV_M2_TU, VWMULU_VV }, // 12591
  { PseudoVWMULU_VV_M4, VWMULU_VV }, // 12592
  { PseudoVWMULU_VV_M4_MASK, VWMULU_VV }, // 12593
  { PseudoVWMULU_VV_M4_TU, VWMULU_VV }, // 12594
  { PseudoVWMULU_VV_MF2, VWMULU_VV }, // 12595
  { PseudoVWMULU_VV_MF2_MASK, VWMULU_VV }, // 12596
  { PseudoVWMULU_VV_MF2_TU, VWMULU_VV }, // 12597
  { PseudoVWMULU_VV_MF4, VWMULU_VV }, // 12598
  { PseudoVWMULU_VV_MF4_MASK, VWMULU_VV }, // 12599
  { PseudoVWMULU_VV_MF4_TU, VWMULU_VV }, // 12600
  { PseudoVWMULU_VV_MF8, VWMULU_VV }, // 12601
  { PseudoVWMULU_VV_MF8_MASK, VWMULU_VV }, // 12602
  { PseudoVWMULU_VV_MF8_TU, VWMULU_VV }, // 12603
  { PseudoVWMULU_VX_M1, VWMULU_VX }, // 12604
  { PseudoVWMULU_VX_M1_MASK, VWMULU_VX }, // 12605
  { PseudoVWMULU_VX_M1_TU, VWMULU_VX }, // 12606
  { PseudoVWMULU_VX_M2, VWMULU_VX }, // 12607
  { PseudoVWMULU_VX_M2_MASK, VWMULU_VX }, // 12608
  { PseudoVWMULU_VX_M2_TU, VWMULU_VX }, // 12609
  { PseudoVWMULU_VX_M4, VWMULU_VX }, // 12610
  { PseudoVWMULU_VX_M4_MASK, VWMULU_VX }, // 12611
  { PseudoVWMULU_VX_M4_TU, VWMULU_VX }, // 12612
  { PseudoVWMULU_VX_MF2, VWMULU_VX }, // 12613
  { PseudoVWMULU_VX_MF2_MASK, VWMULU_VX }, // 12614
  { PseudoVWMULU_VX_MF2_TU, VWMULU_VX }, // 12615
  { PseudoVWMULU_VX_MF4, VWMULU_VX }, // 12616
  { PseudoVWMULU_VX_MF4_MASK, VWMULU_VX }, // 12617
  { PseudoVWMULU_VX_MF4_TU, VWMULU_VX }, // 12618
  { PseudoVWMULU_VX_MF8, VWMULU_VX }, // 12619
  { PseudoVWMULU_VX_MF8_MASK, VWMULU_VX }, // 12620
  { PseudoVWMULU_VX_MF8_TU, VWMULU_VX }, // 12621
  { PseudoVWMUL_VV_M1, VWMUL_VV }, // 12622
  { PseudoVWMUL_VV_M1_MASK, VWMUL_VV }, // 12623
  { PseudoVWMUL_VV_M1_TU, VWMUL_VV }, // 12624
  { PseudoVWMUL_VV_M2, VWMUL_VV }, // 12625
  { PseudoVWMUL_VV_M2_MASK, VWMUL_VV }, // 12626
  { PseudoVWMUL_VV_M2_TU, VWMUL_VV }, // 12627
  { PseudoVWMUL_VV_M4, VWMUL_VV }, // 12628
  { PseudoVWMUL_VV_M4_MASK, VWMUL_VV }, // 12629
  { PseudoVWMUL_VV_M4_TU, VWMUL_VV }, // 12630
  { PseudoVWMUL_VV_MF2, VWMUL_VV }, // 12631
  { PseudoVWMUL_VV_MF2_MASK, VWMUL_VV }, // 12632
  { PseudoVWMUL_VV_MF2_TU, VWMUL_VV }, // 12633
  { PseudoVWMUL_VV_MF4, VWMUL_VV }, // 12634
  { PseudoVWMUL_VV_MF4_MASK, VWMUL_VV }, // 12635
  { PseudoVWMUL_VV_MF4_TU, VWMUL_VV }, // 12636
  { PseudoVWMUL_VV_MF8, VWMUL_VV }, // 12637
  { PseudoVWMUL_VV_MF8_MASK, VWMUL_VV }, // 12638
  { PseudoVWMUL_VV_MF8_TU, VWMUL_VV }, // 12639
  { PseudoVWMUL_VX_M1, VWMUL_VX }, // 12640
  { PseudoVWMUL_VX_M1_MASK, VWMUL_VX }, // 12641
  { PseudoVWMUL_VX_M1_TU, VWMUL_VX }, // 12642
  { PseudoVWMUL_VX_M2, VWMUL_VX }, // 12643
  { PseudoVWMUL_VX_M2_MASK, VWMUL_VX }, // 12644
  { PseudoVWMUL_VX_M2_TU, VWMUL_VX }, // 12645
  { PseudoVWMUL_VX_M4, VWMUL_VX }, // 12646
  { PseudoVWMUL_VX_M4_MASK, VWMUL_VX }, // 12647
  { PseudoVWMUL_VX_M4_TU, VWMUL_VX }, // 12648
  { PseudoVWMUL_VX_MF2, VWMUL_VX }, // 12649
  { PseudoVWMUL_VX_MF2_MASK, VWMUL_VX }, // 12650
  { PseudoVWMUL_VX_MF2_TU, VWMUL_VX }, // 12651
  { PseudoVWMUL_VX_MF4, VWMUL_VX }, // 12652
  { PseudoVWMUL_VX_MF4_MASK, VWMUL_VX }, // 12653
  { PseudoVWMUL_VX_MF4_TU, VWMUL_VX }, // 12654
  { PseudoVWMUL_VX_MF8, VWMUL_VX }, // 12655
  { PseudoVWMUL_VX_MF8_MASK, VWMUL_VX }, // 12656
  { PseudoVWMUL_VX_MF8_TU, VWMUL_VX }, // 12657
  { PseudoVWREDSUMU_VS_M1_E16, VWREDSUMU_VS }, // 12658
  { PseudoVWREDSUMU_VS_M1_E16_MASK, VWREDSUMU_VS }, // 12659
  { PseudoVWREDSUMU_VS_M1_E32, VWREDSUMU_VS }, // 12660
  { PseudoVWREDSUMU_VS_M1_E32_MASK, VWREDSUMU_VS }, // 12661
  { PseudoVWREDSUMU_VS_M1_E8, VWREDSUMU_VS }, // 12662
  { PseudoVWREDSUMU_VS_M1_E8_MASK, VWREDSUMU_VS }, // 12663
  { PseudoVWREDSUMU_VS_M2_E16, VWREDSUMU_VS }, // 12664
  { PseudoVWREDSUMU_VS_M2_E16_MASK, VWREDSUMU_VS }, // 12665
  { PseudoVWREDSUMU_VS_M2_E32, VWREDSUMU_VS }, // 12666
  { PseudoVWREDSUMU_VS_M2_E32_MASK, VWREDSUMU_VS }, // 12667
  { PseudoVWREDSUMU_VS_M2_E8, VWREDSUMU_VS }, // 12668
  { PseudoVWREDSUMU_VS_M2_E8_MASK, VWREDSUMU_VS }, // 12669
  { PseudoVWREDSUMU_VS_M4_E16, VWREDSUMU_VS }, // 12670
  { PseudoVWREDSUMU_VS_M4_E16_MASK, VWREDSUMU_VS }, // 12671
  { PseudoVWREDSUMU_VS_M4_E32, VWREDSUMU_VS }, // 12672
  { PseudoVWREDSUMU_VS_M4_E32_MASK, VWREDSUMU_VS }, // 12673
  { PseudoVWREDSUMU_VS_M4_E8, VWREDSUMU_VS }, // 12674
  { PseudoVWREDSUMU_VS_M4_E8_MASK, VWREDSUMU_VS }, // 12675
  { PseudoVWREDSUMU_VS_M8_E16, VWREDSUMU_VS }, // 12676
  { PseudoVWREDSUMU_VS_M8_E16_MASK, VWREDSUMU_VS }, // 12677
  { PseudoVWREDSUMU_VS_M8_E32, VWREDSUMU_VS }, // 12678
  { PseudoVWREDSUMU_VS_M8_E32_MASK, VWREDSUMU_VS }, // 12679
  { PseudoVWREDSUMU_VS_M8_E8, VWREDSUMU_VS }, // 12680
  { PseudoVWREDSUMU_VS_M8_E8_MASK, VWREDSUMU_VS }, // 12681
  { PseudoVWREDSUMU_VS_MF2_E16, VWREDSUMU_VS }, // 12682
  { PseudoVWREDSUMU_VS_MF2_E16_MASK, VWREDSUMU_VS }, // 12683
  { PseudoVWREDSUMU_VS_MF2_E32, VWREDSUMU_VS }, // 12684
  { PseudoVWREDSUMU_VS_MF2_E32_MASK, VWREDSUMU_VS }, // 12685
  { PseudoVWREDSUMU_VS_MF2_E8, VWREDSUMU_VS }, // 12686
  { PseudoVWREDSUMU_VS_MF2_E8_MASK, VWREDSUMU_VS }, // 12687
  { PseudoVWREDSUMU_VS_MF4_E16, VWREDSUMU_VS }, // 12688
  { PseudoVWREDSUMU_VS_MF4_E16_MASK, VWREDSUMU_VS }, // 12689
  { PseudoVWREDSUMU_VS_MF4_E8, VWREDSUMU_VS }, // 12690
  { PseudoVWREDSUMU_VS_MF4_E8_MASK, VWREDSUMU_VS }, // 12691
  { PseudoVWREDSUMU_VS_MF8_E8, VWREDSUMU_VS }, // 12692
  { PseudoVWREDSUMU_VS_MF8_E8_MASK, VWREDSUMU_VS }, // 12693
  { PseudoVWREDSUM_VS_M1_E16, VWREDSUM_VS }, // 12694
  { PseudoVWREDSUM_VS_M1_E16_MASK, VWREDSUM_VS }, // 12695
  { PseudoVWREDSUM_VS_M1_E32, VWREDSUM_VS }, // 12696
  { PseudoVWREDSUM_VS_M1_E32_MASK, VWREDSUM_VS }, // 12697
  { PseudoVWREDSUM_VS_M1_E8, VWREDSUM_VS }, // 12698
  { PseudoVWREDSUM_VS_M1_E8_MASK, VWREDSUM_VS }, // 12699
  { PseudoVWREDSUM_VS_M2_E16, VWREDSUM_VS }, // 12700
  { PseudoVWREDSUM_VS_M2_E16_MASK, VWREDSUM_VS }, // 12701
  { PseudoVWREDSUM_VS_M2_E32, VWREDSUM_VS }, // 12702
  { PseudoVWREDSUM_VS_M2_E32_MASK, VWREDSUM_VS }, // 12703
  { PseudoVWREDSUM_VS_M2_E8, VWREDSUM_VS }, // 12704
  { PseudoVWREDSUM_VS_M2_E8_MASK, VWREDSUM_VS }, // 12705
  { PseudoVWREDSUM_VS_M4_E16, VWREDSUM_VS }, // 12706
  { PseudoVWREDSUM_VS_M4_E16_MASK, VWREDSUM_VS }, // 12707
  { PseudoVWREDSUM_VS_M4_E32, VWREDSUM_VS }, // 12708
  { PseudoVWREDSUM_VS_M4_E32_MASK, VWREDSUM_VS }, // 12709
  { PseudoVWREDSUM_VS_M4_E8, VWREDSUM_VS }, // 12710
  { PseudoVWREDSUM_VS_M4_E8_MASK, VWREDSUM_VS }, // 12711
  { PseudoVWREDSUM_VS_M8_E16, VWREDSUM_VS }, // 12712
  { PseudoVWREDSUM_VS_M8_E16_MASK, VWREDSUM_VS }, // 12713
  { PseudoVWREDSUM_VS_M8_E32, VWREDSUM_VS }, // 12714
  { PseudoVWREDSUM_VS_M8_E32_MASK, VWREDSUM_VS }, // 12715
  { PseudoVWREDSUM_VS_M8_E8, VWREDSUM_VS }, // 12716
  { PseudoVWREDSUM_VS_M8_E8_MASK, VWREDSUM_VS }, // 12717
  { PseudoVWREDSUM_VS_MF2_E16, VWREDSUM_VS }, // 12718
  { PseudoVWREDSUM_VS_MF2_E16_MASK, VWREDSUM_VS }, // 12719
  { PseudoVWREDSUM_VS_MF2_E32, VWREDSUM_VS }, // 12720
  { PseudoVWREDSUM_VS_MF2_E32_MASK, VWREDSUM_VS }, // 12721
  { PseudoVWREDSUM_VS_MF2_E8, VWREDSUM_VS }, // 12722
  { PseudoVWREDSUM_VS_MF2_E8_MASK, VWREDSUM_VS }, // 12723
  { PseudoVWREDSUM_VS_MF4_E16, VWREDSUM_VS }, // 12724
  { PseudoVWREDSUM_VS_MF4_E16_MASK, VWREDSUM_VS }, // 12725
  { PseudoVWREDSUM_VS_MF4_E8, VWREDSUM_VS }, // 12726
  { PseudoVWREDSUM_VS_MF4_E8_MASK, VWREDSUM_VS }, // 12727
  { PseudoVWREDSUM_VS_MF8_E8, VWREDSUM_VS }, // 12728
  { PseudoVWREDSUM_VS_MF8_E8_MASK, VWREDSUM_VS }, // 12729
  { PseudoVWSUBU_VV_M1, VWSUBU_VV }, // 12730
  { PseudoVWSUBU_VV_M1_MASK, VWSUBU_VV }, // 12731
  { PseudoVWSUBU_VV_M1_TU, VWSUBU_VV }, // 12732
  { PseudoVWSUBU_VV_M2, VWSUBU_VV }, // 12733
  { PseudoVWSUBU_VV_M2_MASK, VWSUBU_VV }, // 12734
  { PseudoVWSUBU_VV_M2_TU, VWSUBU_VV }, // 12735
  { PseudoVWSUBU_VV_M4, VWSUBU_VV }, // 12736
  { PseudoVWSUBU_VV_M4_MASK, VWSUBU_VV }, // 12737
  { PseudoVWSUBU_VV_M4_TU, VWSUBU_VV }, // 12738
  { PseudoVWSUBU_VV_MF2, VWSUBU_VV }, // 12739
  { PseudoVWSUBU_VV_MF2_MASK, VWSUBU_VV }, // 12740
  { PseudoVWSUBU_VV_MF2_TU, VWSUBU_VV }, // 12741
  { PseudoVWSUBU_VV_MF4, VWSUBU_VV }, // 12742
  { PseudoVWSUBU_VV_MF4_MASK, VWSUBU_VV }, // 12743
  { PseudoVWSUBU_VV_MF4_TU, VWSUBU_VV }, // 12744
  { PseudoVWSUBU_VV_MF8, VWSUBU_VV }, // 12745
  { PseudoVWSUBU_VV_MF8_MASK, VWSUBU_VV }, // 12746
  { PseudoVWSUBU_VV_MF8_TU, VWSUBU_VV }, // 12747
  { PseudoVWSUBU_VX_M1, VWSUBU_VX }, // 12748
  { PseudoVWSUBU_VX_M1_MASK, VWSUBU_VX }, // 12749
  { PseudoVWSUBU_VX_M1_TU, VWSUBU_VX }, // 12750
  { PseudoVWSUBU_VX_M2, VWSUBU_VX }, // 12751
  { PseudoVWSUBU_VX_M2_MASK, VWSUBU_VX }, // 12752
  { PseudoVWSUBU_VX_M2_TU, VWSUBU_VX }, // 12753
  { PseudoVWSUBU_VX_M4, VWSUBU_VX }, // 12754
  { PseudoVWSUBU_VX_M4_MASK, VWSUBU_VX }, // 12755
  { PseudoVWSUBU_VX_M4_TU, VWSUBU_VX }, // 12756
  { PseudoVWSUBU_VX_MF2, VWSUBU_VX }, // 12757
  { PseudoVWSUBU_VX_MF2_MASK, VWSUBU_VX }, // 12758
  { PseudoVWSUBU_VX_MF2_TU, VWSUBU_VX }, // 12759
  { PseudoVWSUBU_VX_MF4, VWSUBU_VX }, // 12760
  { PseudoVWSUBU_VX_MF4_MASK, VWSUBU_VX }, // 12761
  { PseudoVWSUBU_VX_MF4_TU, VWSUBU_VX }, // 12762
  { PseudoVWSUBU_VX_MF8, VWSUBU_VX }, // 12763
  { PseudoVWSUBU_VX_MF8_MASK, VWSUBU_VX }, // 12764
  { PseudoVWSUBU_VX_MF8_TU, VWSUBU_VX }, // 12765
  { PseudoVWSUBU_WV_M1, VWSUBU_WV }, // 12766
  { PseudoVWSUBU_WV_M1_MASK, VWSUBU_WV }, // 12767
  { PseudoVWSUBU_WV_M1_MASK_TIED, VWSUBU_WV }, // 12768
  { PseudoVWSUBU_WV_M1_TIED, VWSUBU_WV }, // 12769
  { PseudoVWSUBU_WV_M1_TU, VWSUBU_WV }, // 12770
  { PseudoVWSUBU_WV_M2, VWSUBU_WV }, // 12771
  { PseudoVWSUBU_WV_M2_MASK, VWSUBU_WV }, // 12772
  { PseudoVWSUBU_WV_M2_MASK_TIED, VWSUBU_WV }, // 12773
  { PseudoVWSUBU_WV_M2_TIED, VWSUBU_WV }, // 12774
  { PseudoVWSUBU_WV_M2_TU, VWSUBU_WV }, // 12775
  { PseudoVWSUBU_WV_M4, VWSUBU_WV }, // 12776
  { PseudoVWSUBU_WV_M4_MASK, VWSUBU_WV }, // 12777
  { PseudoVWSUBU_WV_M4_MASK_TIED, VWSUBU_WV }, // 12778
  { PseudoVWSUBU_WV_M4_TIED, VWSUBU_WV }, // 12779
  { PseudoVWSUBU_WV_M4_TU, VWSUBU_WV }, // 12780
  { PseudoVWSUBU_WV_MF2, VWSUBU_WV }, // 12781
  { PseudoVWSUBU_WV_MF2_MASK, VWSUBU_WV }, // 12782
  { PseudoVWSUBU_WV_MF2_MASK_TIED, VWSUBU_WV }, // 12783
  { PseudoVWSUBU_WV_MF2_TIED, VWSUBU_WV }, // 12784
  { PseudoVWSUBU_WV_MF2_TU, VWSUBU_WV }, // 12785
  { PseudoVWSUBU_WV_MF4, VWSUBU_WV }, // 12786
  { PseudoVWSUBU_WV_MF4_MASK, VWSUBU_WV }, // 12787
  { PseudoVWSUBU_WV_MF4_MASK_TIED, VWSUBU_WV }, // 12788
  { PseudoVWSUBU_WV_MF4_TIED, VWSUBU_WV }, // 12789
  { PseudoVWSUBU_WV_MF4_TU, VWSUBU_WV }, // 12790
  { PseudoVWSUBU_WV_MF8, VWSUBU_WV }, // 12791
  { PseudoVWSUBU_WV_MF8_MASK, VWSUBU_WV }, // 12792
  { PseudoVWSUBU_WV_MF8_MASK_TIED, VWSUBU_WV }, // 12793
  { PseudoVWSUBU_WV_MF8_TIED, VWSUBU_WV }, // 12794
  { PseudoVWSUBU_WV_MF8_TU, VWSUBU_WV }, // 12795
  { PseudoVWSUBU_WX_M1, VWSUBU_WX }, // 12796
  { PseudoVWSUBU_WX_M1_MASK, VWSUBU_WX }, // 12797
  { PseudoVWSUBU_WX_M1_TU, VWSUBU_WX }, // 12798
  { PseudoVWSUBU_WX_M2, VWSUBU_WX }, // 12799
  { PseudoVWSUBU_WX_M2_MASK, VWSUBU_WX }, // 12800
  { PseudoVWSUBU_WX_M2_TU, VWSUBU_WX }, // 12801
  { PseudoVWSUBU_WX_M4, VWSUBU_WX }, // 12802
  { PseudoVWSUBU_WX_M4_MASK, VWSUBU_WX }, // 12803
  { PseudoVWSUBU_WX_M4_TU, VWSUBU_WX }, // 12804
  { PseudoVWSUBU_WX_MF2, VWSUBU_WX }, // 12805
  { PseudoVWSUBU_WX_MF2_MASK, VWSUBU_WX }, // 12806
  { PseudoVWSUBU_WX_MF2_TU, VWSUBU_WX }, // 12807
  { PseudoVWSUBU_WX_MF4, VWSUBU_WX }, // 12808
  { PseudoVWSUBU_WX_MF4_MASK, VWSUBU_WX }, // 12809
  { PseudoVWSUBU_WX_MF4_TU, VWSUBU_WX }, // 12810
  { PseudoVWSUBU_WX_MF8, VWSUBU_WX }, // 12811
  { PseudoVWSUBU_WX_MF8_MASK, VWSUBU_WX }, // 12812
  { PseudoVWSUBU_WX_MF8_TU, VWSUBU_WX }, // 12813
  { PseudoVWSUB_VV_M1, VWSUB_VV }, // 12814
  { PseudoVWSUB_VV_M1_MASK, VWSUB_VV }, // 12815
  { PseudoVWSUB_VV_M1_TU, VWSUB_VV }, // 12816
  { PseudoVWSUB_VV_M2, VWSUB_VV }, // 12817
  { PseudoVWSUB_VV_M2_MASK, VWSUB_VV }, // 12818
  { PseudoVWSUB_VV_M2_TU, VWSUB_VV }, // 12819
  { PseudoVWSUB_VV_M4, VWSUB_VV }, // 12820
  { PseudoVWSUB_VV_M4_MASK, VWSUB_VV }, // 12821
  { PseudoVWSUB_VV_M4_TU, VWSUB_VV }, // 12822
  { PseudoVWSUB_VV_MF2, VWSUB_VV }, // 12823
  { PseudoVWSUB_VV_MF2_MASK, VWSUB_VV }, // 12824
  { PseudoVWSUB_VV_MF2_TU, VWSUB_VV }, // 12825
  { PseudoVWSUB_VV_MF4, VWSUB_VV }, // 12826
  { PseudoVWSUB_VV_MF4_MASK, VWSUB_VV }, // 12827
  { PseudoVWSUB_VV_MF4_TU, VWSUB_VV }, // 12828
  { PseudoVWSUB_VV_MF8, VWSUB_VV }, // 12829
  { PseudoVWSUB_VV_MF8_MASK, VWSUB_VV }, // 12830
  { PseudoVWSUB_VV_MF8_TU, VWSUB_VV }, // 12831
  { PseudoVWSUB_VX_M1, VWSUB_VX }, // 12832
  { PseudoVWSUB_VX_M1_MASK, VWSUB_VX }, // 12833
  { PseudoVWSUB_VX_M1_TU, VWSUB_VX }, // 12834
  { PseudoVWSUB_VX_M2, VWSUB_VX }, // 12835
  { PseudoVWSUB_VX_M2_MASK, VWSUB_VX }, // 12836
  { PseudoVWSUB_VX_M2_TU, VWSUB_VX }, // 12837
  { PseudoVWSUB_VX_M4, VWSUB_VX }, // 12838
  { PseudoVWSUB_VX_M4_MASK, VWSUB_VX }, // 12839
  { PseudoVWSUB_VX_M4_TU, VWSUB_VX }, // 12840
  { PseudoVWSUB_VX_MF2, VWSUB_VX }, // 12841
  { PseudoVWSUB_VX_MF2_MASK, VWSUB_VX }, // 12842
  { PseudoVWSUB_VX_MF2_TU, VWSUB_VX }, // 12843
  { PseudoVWSUB_VX_MF4, VWSUB_VX }, // 12844
  { PseudoVWSUB_VX_MF4_MASK, VWSUB_VX }, // 12845
  { PseudoVWSUB_VX_MF4_TU, VWSUB_VX }, // 12846
  { PseudoVWSUB_VX_MF8, VWSUB_VX }, // 12847
  { PseudoVWSUB_VX_MF8_MASK, VWSUB_VX }, // 12848
  { PseudoVWSUB_VX_MF8_TU, VWSUB_VX }, // 12849
  { PseudoVWSUB_WV_M1, VWSUB_WV }, // 12850
  { PseudoVWSUB_WV_M1_MASK, VWSUB_WV }, // 12851
  { PseudoVWSUB_WV_M1_MASK_TIED, VWSUB_WV }, // 12852
  { PseudoVWSUB_WV_M1_TIED, VWSUB_WV }, // 12853
  { PseudoVWSUB_WV_M1_TU, VWSUB_WV }, // 12854
  { PseudoVWSUB_WV_M2, VWSUB_WV }, // 12855
  { PseudoVWSUB_WV_M2_MASK, VWSUB_WV }, // 12856
  { PseudoVWSUB_WV_M2_MASK_TIED, VWSUB_WV }, // 12857
  { PseudoVWSUB_WV_M2_TIED, VWSUB_WV }, // 12858
  { PseudoVWSUB_WV_M2_TU, VWSUB_WV }, // 12859
  { PseudoVWSUB_WV_M4, VWSUB_WV }, // 12860
  { PseudoVWSUB_WV_M4_MASK, VWSUB_WV }, // 12861
  { PseudoVWSUB_WV_M4_MASK_TIED, VWSUB_WV }, // 12862
  { PseudoVWSUB_WV_M4_TIED, VWSUB_WV }, // 12863
  { PseudoVWSUB_WV_M4_TU, VWSUB_WV }, // 12864
  { PseudoVWSUB_WV_MF2, VWSUB_WV }, // 12865
  { PseudoVWSUB_WV_MF2_MASK, VWSUB_WV }, // 12866
  { PseudoVWSUB_WV_MF2_MASK_TIED, VWSUB_WV }, // 12867
  { PseudoVWSUB_WV_MF2_TIED, VWSUB_WV }, // 12868
  { PseudoVWSUB_WV_MF2_TU, VWSUB_WV }, // 12869
  { PseudoVWSUB_WV_MF4, VWSUB_WV }, // 12870
  { PseudoVWSUB_WV_MF4_MASK, VWSUB_WV }, // 12871
  { PseudoVWSUB_WV_MF4_MASK_TIED, VWSUB_WV }, // 12872
  { PseudoVWSUB_WV_MF4_TIED, VWSUB_WV }, // 12873
  { PseudoVWSUB_WV_MF4_TU, VWSUB_WV }, // 12874
  { PseudoVWSUB_WV_MF8, VWSUB_WV }, // 12875
  { PseudoVWSUB_WV_MF8_MASK, VWSUB_WV }, // 12876
  { PseudoVWSUB_WV_MF8_MASK_TIED, VWSUB_WV }, // 12877
  { PseudoVWSUB_WV_MF8_TIED, VWSUB_WV }, // 12878
  { PseudoVWSUB_WV_MF8_TU, VWSUB_WV }, // 12879
  { PseudoVWSUB_WX_M1, VWSUB_WX }, // 12880
  { PseudoVWSUB_WX_M1_MASK, VWSUB_WX }, // 12881
  { PseudoVWSUB_WX_M1_TU, VWSUB_WX }, // 12882
  { PseudoVWSUB_WX_M2, VWSUB_WX }, // 12883
  { PseudoVWSUB_WX_M2_MASK, VWSUB_WX }, // 12884
  { PseudoVWSUB_WX_M2_TU, VWSUB_WX }, // 12885
  { PseudoVWSUB_WX_M4, VWSUB_WX }, // 12886
  { PseudoVWSUB_WX_M4_MASK, VWSUB_WX }, // 12887
  { PseudoVWSUB_WX_M4_TU, VWSUB_WX }, // 12888
  { PseudoVWSUB_WX_MF2, VWSUB_WX }, // 12889
  { PseudoVWSUB_WX_MF2_MASK, VWSUB_WX }, // 12890
  { PseudoVWSUB_WX_MF2_TU, VWSUB_WX }, // 12891
  { PseudoVWSUB_WX_MF4, VWSUB_WX }, // 12892
  { PseudoVWSUB_WX_MF4_MASK, VWSUB_WX }, // 12893
  { PseudoVWSUB_WX_MF4_TU, VWSUB_WX }, // 12894
  { PseudoVWSUB_WX_MF8, VWSUB_WX }, // 12895
  { PseudoVWSUB_WX_MF8_MASK, VWSUB_WX }, // 12896
  { PseudoVWSUB_WX_MF8_TU, VWSUB_WX }, // 12897
  { PseudoVXOR_VI_M1, VXOR_VI }, // 12898
  { PseudoVXOR_VI_M1_MASK, VXOR_VI }, // 12899
  { PseudoVXOR_VI_M1_TU, VXOR_VI }, // 12900
  { PseudoVXOR_VI_M2, VXOR_VI }, // 12901
  { PseudoVXOR_VI_M2_MASK, VXOR_VI }, // 12902
  { PseudoVXOR_VI_M2_TU, VXOR_VI }, // 12903
  { PseudoVXOR_VI_M4, VXOR_VI }, // 12904
  { PseudoVXOR_VI_M4_MASK, VXOR_VI }, // 12905
  { PseudoVXOR_VI_M4_TU, VXOR_VI }, // 12906
  { PseudoVXOR_VI_M8, VXOR_VI }, // 12907
  { PseudoVXOR_VI_M8_MASK, VXOR_VI }, // 12908
  { PseudoVXOR_VI_M8_TU, VXOR_VI }, // 12909
  { PseudoVXOR_VI_MF2, VXOR_VI }, // 12910
  { PseudoVXOR_VI_MF2_MASK, VXOR_VI }, // 12911
  { PseudoVXOR_VI_MF2_TU, VXOR_VI }, // 12912
  { PseudoVXOR_VI_MF4, VXOR_VI }, // 12913
  { PseudoVXOR_VI_MF4_MASK, VXOR_VI }, // 12914
  { PseudoVXOR_VI_MF4_TU, VXOR_VI }, // 12915
  { PseudoVXOR_VI_MF8, VXOR_VI }, // 12916
  { PseudoVXOR_VI_MF8_MASK, VXOR_VI }, // 12917
  { PseudoVXOR_VI_MF8_TU, VXOR_VI }, // 12918
  { PseudoVXOR_VV_M1, VXOR_VV }, // 12919
  { PseudoVXOR_VV_M1_MASK, VXOR_VV }, // 12920
  { PseudoVXOR_VV_M1_TU, VXOR_VV }, // 12921
  { PseudoVXOR_VV_M2, VXOR_VV }, // 12922
  { PseudoVXOR_VV_M2_MASK, VXOR_VV }, // 12923
  { PseudoVXOR_VV_M2_TU, VXOR_VV }, // 12924
  { PseudoVXOR_VV_M4, VXOR_VV }, // 12925
  { PseudoVXOR_VV_M4_MASK, VXOR_VV }, // 12926
  { PseudoVXOR_VV_M4_TU, VXOR_VV }, // 12927
  { PseudoVXOR_VV_M8, VXOR_VV }, // 12928
  { PseudoVXOR_VV_M8_MASK, VXOR_VV }, // 12929
  { PseudoVXOR_VV_M8_TU, VXOR_VV }, // 12930
  { PseudoVXOR_VV_MF2, VXOR_VV }, // 12931
  { PseudoVXOR_VV_MF2_MASK, VXOR_VV }, // 12932
  { PseudoVXOR_VV_MF2_TU, VXOR_VV }, // 12933
  { PseudoVXOR_VV_MF4, VXOR_VV }, // 12934
  { PseudoVXOR_VV_MF4_MASK, VXOR_VV }, // 12935
  { PseudoVXOR_VV_MF4_TU, VXOR_VV }, // 12936
  { PseudoVXOR_VV_MF8, VXOR_VV }, // 12937
  { PseudoVXOR_VV_MF8_MASK, VXOR_VV }, // 12938
  { PseudoVXOR_VV_MF8_TU, VXOR_VV }, // 12939
  { PseudoVXOR_VX_M1, VXOR_VX }, // 12940
  { PseudoVXOR_VX_M1_MASK, VXOR_VX }, // 12941
  { PseudoVXOR_VX_M1_TU, VXOR_VX }, // 12942
  { PseudoVXOR_VX_M2, VXOR_VX }, // 12943
  { PseudoVXOR_VX_M2_MASK, VXOR_VX }, // 12944
  { PseudoVXOR_VX_M2_TU, VXOR_VX }, // 12945
  { PseudoVXOR_VX_M4, VXOR_VX }, // 12946
  { PseudoVXOR_VX_M4_MASK, VXOR_VX }, // 12947
  { PseudoVXOR_VX_M4_TU, VXOR_VX }, // 12948
  { PseudoVXOR_VX_M8, VXOR_VX }, // 12949
  { PseudoVXOR_VX_M8_MASK, VXOR_VX }, // 12950
  { PseudoVXOR_VX_M8_TU, VXOR_VX }, // 12951
  { PseudoVXOR_VX_MF2, VXOR_VX }, // 12952
  { PseudoVXOR_VX_MF2_MASK, VXOR_VX }, // 12953
  { PseudoVXOR_VX_MF2_TU, VXOR_VX }, // 12954
  { PseudoVXOR_VX_MF4, VXOR_VX }, // 12955
  { PseudoVXOR_VX_MF4_MASK, VXOR_VX }, // 12956
  { PseudoVXOR_VX_MF4_TU, VXOR_VX }, // 12957
  { PseudoVXOR_VX_MF8, VXOR_VX }, // 12958
  { PseudoVXOR_VX_MF8_MASK, VXOR_VX }, // 12959
  { PseudoVXOR_VX_MF8_TU, VXOR_VX }, // 12960
  { PseudoVZEXT_VF2_M1, VZEXT_VF2 }, // 12961
  { PseudoVZEXT_VF2_M1_MASK, VZEXT_VF2 }, // 12962
  { PseudoVZEXT_VF2_M1_TU, VZEXT_VF2 }, // 12963
  { PseudoVZEXT_VF2_M2, VZEXT_VF2 }, // 12964
  { PseudoVZEXT_VF2_M2_MASK, VZEXT_VF2 }, // 12965
  { PseudoVZEXT_VF2_M2_TU, VZEXT_VF2 }, // 12966
  { PseudoVZEXT_VF2_M4, VZEXT_VF2 }, // 12967
  { PseudoVZEXT_VF2_M4_MASK, VZEXT_VF2 }, // 12968
  { PseudoVZEXT_VF2_M4_TU, VZEXT_VF2 }, // 12969
  { PseudoVZEXT_VF2_M8, VZEXT_VF2 }, // 12970
  { PseudoVZEXT_VF2_M8_MASK, VZEXT_VF2 }, // 12971
  { PseudoVZEXT_VF2_M8_TU, VZEXT_VF2 }, // 12972
  { PseudoVZEXT_VF2_MF2, VZEXT_VF2 }, // 12973
  { PseudoVZEXT_VF2_MF2_MASK, VZEXT_VF2 }, // 12974
  { PseudoVZEXT_VF2_MF2_TU, VZEXT_VF2 }, // 12975
  { PseudoVZEXT_VF2_MF4, VZEXT_VF2 }, // 12976
  { PseudoVZEXT_VF2_MF4_MASK, VZEXT_VF2 }, // 12977
  { PseudoVZEXT_VF2_MF4_TU, VZEXT_VF2 }, // 12978
  { PseudoVZEXT_VF4_M1, VZEXT_VF4 }, // 12979
  { PseudoVZEXT_VF4_M1_MASK, VZEXT_VF4 }, // 12980
  { PseudoVZEXT_VF4_M1_TU, VZEXT_VF4 }, // 12981
  { PseudoVZEXT_VF4_M2, VZEXT_VF4 }, // 12982
  { PseudoVZEXT_VF4_M2_MASK, VZEXT_VF4 }, // 12983
  { PseudoVZEXT_VF4_M2_TU, VZEXT_VF4 }, // 12984
  { PseudoVZEXT_VF4_M4, VZEXT_VF4 }, // 12985
  { PseudoVZEXT_VF4_M4_MASK, VZEXT_VF4 }, // 12986
  { PseudoVZEXT_VF4_M4_TU, VZEXT_VF4 }, // 12987
  { PseudoVZEXT_VF4_M8, VZEXT_VF4 }, // 12988
  { PseudoVZEXT_VF4_M8_MASK, VZEXT_VF4 }, // 12989
  { PseudoVZEXT_VF4_M8_TU, VZEXT_VF4 }, // 12990
  { PseudoVZEXT_VF4_MF2, VZEXT_VF4 }, // 12991
  { PseudoVZEXT_VF4_MF2_MASK, VZEXT_VF4 }, // 12992
  { PseudoVZEXT_VF4_MF2_TU, VZEXT_VF4 }, // 12993
  { PseudoVZEXT_VF8_M1, VZEXT_VF8 }, // 12994
  { PseudoVZEXT_VF8_M1_MASK, VZEXT_VF8 }, // 12995
  { PseudoVZEXT_VF8_M1_TU, VZEXT_VF8 }, // 12996
  { PseudoVZEXT_VF8_M2, VZEXT_VF8 }, // 12997
  { PseudoVZEXT_VF8_M2_MASK, VZEXT_VF8 }, // 12998
  { PseudoVZEXT_VF8_M2_TU, VZEXT_VF8 }, // 12999
  { PseudoVZEXT_VF8_M4, VZEXT_VF8 }, // 13000
  { PseudoVZEXT_VF8_M4_MASK, VZEXT_VF8 }, // 13001
  { PseudoVZEXT_VF8_M4_TU, VZEXT_VF8 }, // 13002
  { PseudoVZEXT_VF8_M8, VZEXT_VF8 }, // 13003
  { PseudoVZEXT_VF8_M8_MASK, VZEXT_VF8 }, // 13004
  { PseudoVZEXT_VF8_M8_TU, VZEXT_VF8 }, // 13005
 };

const PseudoInfo *getPseudoInfo(unsigned Pseudo) {
  if ((Pseudo < PseudoTHVdotVMAQASU_VV_M1) ||
      (Pseudo > PseudoVZEXT_VF8_M8_TU))
    return nullptr;

  struct KeyType {
    unsigned Pseudo;
  };
  KeyType Key = {Pseudo};
  auto Table = ArrayRef(RISCVVPseudosTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const PseudoInfo &LHS, const KeyType &RHS) {
      if (LHS.Pseudo < RHS.Pseudo)
        return true;
      if (LHS.Pseudo > RHS.Pseudo)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Pseudo != Idx->Pseudo)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVSETable_DECL
const VSEPseudo *getVSEPseudo(uint8_t Masked, uint8_t Strided, uint8_t Log2SEW, uint8_t LMUL);
#endif

#ifdef GET_RISCVVSETable_IMPL
constexpr VSEPseudo RISCVVSETable[] = {
  { 0x0, 0x0, 0x0, 0x0, PseudoVSM_V_B8 }, // 0
  { 0x0, 0x0, 0x0, 0x1, PseudoVSM_V_B16 }, // 1
  { 0x0, 0x0, 0x0, 0x2, PseudoVSM_V_B32 }, // 2
  { 0x0, 0x0, 0x0, 0x3, PseudoVSM_V_B64 }, // 3
  { 0x0, 0x0, 0x0, 0x5, PseudoVSM_V_B1 }, // 4
  { 0x0, 0x0, 0x0, 0x6, PseudoVSM_V_B2 }, // 5
  { 0x0, 0x0, 0x0, 0x7, PseudoVSM_V_B4 }, // 6
  { 0x0, 0x0, 0x3, 0x0, PseudoVSE8_V_M1 }, // 7
  { 0x0, 0x0, 0x3, 0x1, PseudoVSE8_V_M2 }, // 8
  { 0x0, 0x0, 0x3, 0x2, PseudoVSE8_V_M4 }, // 9
  { 0x0, 0x0, 0x3, 0x3, PseudoVSE8_V_M8 }, // 10
  { 0x0, 0x0, 0x3, 0x5, PseudoVSE8_V_MF8 }, // 11
  { 0x0, 0x0, 0x3, 0x6, PseudoVSE8_V_MF4 }, // 12
  { 0x0, 0x0, 0x3, 0x7, PseudoVSE8_V_MF2 }, // 13
  { 0x0, 0x0, 0x4, 0x0, PseudoVSE16_V_M1 }, // 14
  { 0x0, 0x0, 0x4, 0x1, PseudoVSE16_V_M2 }, // 15
  { 0x0, 0x0, 0x4, 0x2, PseudoVSE16_V_M4 }, // 16
  { 0x0, 0x0, 0x4, 0x3, PseudoVSE16_V_M8 }, // 17
  { 0x0, 0x0, 0x4, 0x6, PseudoVSE16_V_MF4 }, // 18
  { 0x0, 0x0, 0x4, 0x7, PseudoVSE16_V_MF2 }, // 19
  { 0x0, 0x0, 0x5, 0x0, PseudoVSE32_V_M1 }, // 20
  { 0x0, 0x0, 0x5, 0x1, PseudoVSE32_V_M2 }, // 21
  { 0x0, 0x0, 0x5, 0x2, PseudoVSE32_V_M4 }, // 22
  { 0x0, 0x0, 0x5, 0x3, PseudoVSE32_V_M8 }, // 23
  { 0x0, 0x0, 0x5, 0x7, PseudoVSE32_V_MF2 }, // 24
  { 0x0, 0x0, 0x6, 0x0, PseudoVSE64_V_M1 }, // 25
  { 0x0, 0x0, 0x6, 0x1, PseudoVSE64_V_M2 }, // 26
  { 0x0, 0x0, 0x6, 0x2, PseudoVSE64_V_M4 }, // 27
  { 0x0, 0x0, 0x6, 0x3, PseudoVSE64_V_M8 }, // 28
  { 0x0, 0x1, 0x3, 0x0, PseudoVSSE8_V_M1 }, // 29
  { 0x0, 0x1, 0x3, 0x1, PseudoVSSE8_V_M2 }, // 30
  { 0x0, 0x1, 0x3, 0x2, PseudoVSSE8_V_M4 }, // 31
  { 0x0, 0x1, 0x3, 0x3, PseudoVSSE8_V_M8 }, // 32
  { 0x0, 0x1, 0x3, 0x5, PseudoVSSE8_V_MF8 }, // 33
  { 0x0, 0x1, 0x3, 0x6, PseudoVSSE8_V_MF4 }, // 34
  { 0x0, 0x1, 0x3, 0x7, PseudoVSSE8_V_MF2 }, // 35
  { 0x0, 0x1, 0x4, 0x0, PseudoVSSE16_V_M1 }, // 36
  { 0x0, 0x1, 0x4, 0x1, PseudoVSSE16_V_M2 }, // 37
  { 0x0, 0x1, 0x4, 0x2, PseudoVSSE16_V_M4 }, // 38
  { 0x0, 0x1, 0x4, 0x3, PseudoVSSE16_V_M8 }, // 39
  { 0x0, 0x1, 0x4, 0x6, PseudoVSSE16_V_MF4 }, // 40
  { 0x0, 0x1, 0x4, 0x7, PseudoVSSE16_V_MF2 }, // 41
  { 0x0, 0x1, 0x5, 0x0, PseudoVSSE32_V_M1 }, // 42
  { 0x0, 0x1, 0x5, 0x1, PseudoVSSE32_V_M2 }, // 43
  { 0x0, 0x1, 0x5, 0x2, PseudoVSSE32_V_M4 }, // 44
  { 0x0, 0x1, 0x5, 0x3, PseudoVSSE32_V_M8 }, // 45
  { 0x0, 0x1, 0x5, 0x7, PseudoVSSE32_V_MF2 }, // 46
  { 0x0, 0x1, 0x6, 0x0, PseudoVSSE64_V_M1 }, // 47
  { 0x0, 0x1, 0x6, 0x1, PseudoVSSE64_V_M2 }, // 48
  { 0x0, 0x1, 0x6, 0x2, PseudoVSSE64_V_M4 }, // 49
  { 0x0, 0x1, 0x6, 0x3, PseudoVSSE64_V_M8 }, // 50
  { 0x1, 0x0, 0x3, 0x0, PseudoVSE8_V_M1_MASK }, // 51
  { 0x1, 0x0, 0x3, 0x1, PseudoVSE8_V_M2_MASK }, // 52
  { 0x1, 0x0, 0x3, 0x2, PseudoVSE8_V_M4_MASK }, // 53
  { 0x1, 0x0, 0x3, 0x3, PseudoVSE8_V_M8_MASK }, // 54
  { 0x1, 0x0, 0x3, 0x5, PseudoVSE8_V_MF8_MASK }, // 55
  { 0x1, 0x0, 0x3, 0x6, PseudoVSE8_V_MF4_MASK }, // 56
  { 0x1, 0x0, 0x3, 0x7, PseudoVSE8_V_MF2_MASK }, // 57
  { 0x1, 0x0, 0x4, 0x0, PseudoVSE16_V_M1_MASK }, // 58
  { 0x1, 0x0, 0x4, 0x1, PseudoVSE16_V_M2_MASK }, // 59
  { 0x1, 0x0, 0x4, 0x2, PseudoVSE16_V_M4_MASK }, // 60
  { 0x1, 0x0, 0x4, 0x3, PseudoVSE16_V_M8_MASK }, // 61
  { 0x1, 0x0, 0x4, 0x6, PseudoVSE16_V_MF4_MASK }, // 62
  { 0x1, 0x0, 0x4, 0x7, PseudoVSE16_V_MF2_MASK }, // 63
  { 0x1, 0x0, 0x5, 0x0, PseudoVSE32_V_M1_MASK }, // 64
  { 0x1, 0x0, 0x5, 0x1, PseudoVSE32_V_M2_MASK }, // 65
  { 0x1, 0x0, 0x5, 0x2, PseudoVSE32_V_M4_MASK }, // 66
  { 0x1, 0x0, 0x5, 0x3, PseudoVSE32_V_M8_MASK }, // 67
  { 0x1, 0x0, 0x5, 0x7, PseudoVSE32_V_MF2_MASK }, // 68
  { 0x1, 0x0, 0x6, 0x0, PseudoVSE64_V_M1_MASK }, // 69
  { 0x1, 0x0, 0x6, 0x1, PseudoVSE64_V_M2_MASK }, // 70
  { 0x1, 0x0, 0x6, 0x2, PseudoVSE64_V_M4_MASK }, // 71
  { 0x1, 0x0, 0x6, 0x3, PseudoVSE64_V_M8_MASK }, // 72
  { 0x1, 0x1, 0x3, 0x0, PseudoVSSE8_V_M1_MASK }, // 73
  { 0x1, 0x1, 0x3, 0x1, PseudoVSSE8_V_M2_MASK }, // 74
  { 0x1, 0x1, 0x3, 0x2, PseudoVSSE8_V_M4_MASK }, // 75
  { 0x1, 0x1, 0x3, 0x3, PseudoVSSE8_V_M8_MASK }, // 76
  { 0x1, 0x1, 0x3, 0x5, PseudoVSSE8_V_MF8_MASK }, // 77
  { 0x1, 0x1, 0x3, 0x6, PseudoVSSE8_V_MF4_MASK }, // 78
  { 0x1, 0x1, 0x3, 0x7, PseudoVSSE8_V_MF2_MASK }, // 79
  { 0x1, 0x1, 0x4, 0x0, PseudoVSSE16_V_M1_MASK }, // 80
  { 0x1, 0x1, 0x4, 0x1, PseudoVSSE16_V_M2_MASK }, // 81
  { 0x1, 0x1, 0x4, 0x2, PseudoVSSE16_V_M4_MASK }, // 82
  { 0x1, 0x1, 0x4, 0x3, PseudoVSSE16_V_M8_MASK }, // 83
  { 0x1, 0x1, 0x4, 0x6, PseudoVSSE16_V_MF4_MASK }, // 84
  { 0x1, 0x1, 0x4, 0x7, PseudoVSSE16_V_MF2_MASK }, // 85
  { 0x1, 0x1, 0x5, 0x0, PseudoVSSE32_V_M1_MASK }, // 86
  { 0x1, 0x1, 0x5, 0x1, PseudoVSSE32_V_M2_MASK }, // 87
  { 0x1, 0x1, 0x5, 0x2, PseudoVSSE32_V_M4_MASK }, // 88
  { 0x1, 0x1, 0x5, 0x3, PseudoVSSE32_V_M8_MASK }, // 89
  { 0x1, 0x1, 0x5, 0x7, PseudoVSSE32_V_MF2_MASK }, // 90
  { 0x1, 0x1, 0x6, 0x0, PseudoVSSE64_V_M1_MASK }, // 91
  { 0x1, 0x1, 0x6, 0x1, PseudoVSSE64_V_M2_MASK }, // 92
  { 0x1, 0x1, 0x6, 0x2, PseudoVSSE64_V_M4_MASK }, // 93
  { 0x1, 0x1, 0x6, 0x3, PseudoVSSE64_V_M8_MASK }, // 94
 };

const VSEPseudo *getVSEPseudo(uint8_t Masked, uint8_t Strided, uint8_t Log2SEW, uint8_t LMUL) {
  struct KeyType {
    uint8_t Masked;
    uint8_t Strided;
    uint8_t Log2SEW;
    uint8_t LMUL;
  };
  KeyType Key = {Masked, Strided, Log2SEW, LMUL};
  auto Table = ArrayRef(RISCVVSETable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VSEPseudo &LHS, const KeyType &RHS) {
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.Strided < RHS.Strided)
        return true;
      if (LHS.Strided > RHS.Strided)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Masked != Idx->Masked ||
      Key.Strided != Idx->Strided ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVSSEGTable_DECL
const VSSEGPseudo *getVSSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t Strided, uint8_t Log2SEW, uint8_t LMUL);
#endif

#ifdef GET_RISCVVSSEGTable_IMPL
constexpr VSSEGPseudo RISCVVSSEGTable[] = {
  { 0x2, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG2E8_V_M1 }, // 0
  { 0x2, 0x0, 0x0, 0x3, 0x1, PseudoVSSEG2E8_V_M2 }, // 1
  { 0x2, 0x0, 0x0, 0x3, 0x2, PseudoVSSEG2E8_V_M4 }, // 2
  { 0x2, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG2E8_V_MF8 }, // 3
  { 0x2, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG2E8_V_MF4 }, // 4
  { 0x2, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG2E8_V_MF2 }, // 5
  { 0x2, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG2E16_V_M1 }, // 6
  { 0x2, 0x0, 0x0, 0x4, 0x1, PseudoVSSEG2E16_V_M2 }, // 7
  { 0x2, 0x0, 0x0, 0x4, 0x2, PseudoVSSEG2E16_V_M4 }, // 8
  { 0x2, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG2E16_V_MF4 }, // 9
  { 0x2, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG2E16_V_MF2 }, // 10
  { 0x2, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG2E32_V_M1 }, // 11
  { 0x2, 0x0, 0x0, 0x5, 0x1, PseudoVSSEG2E32_V_M2 }, // 12
  { 0x2, 0x0, 0x0, 0x5, 0x2, PseudoVSSEG2E32_V_M4 }, // 13
  { 0x2, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG2E32_V_MF2 }, // 14
  { 0x2, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG2E64_V_M1 }, // 15
  { 0x2, 0x0, 0x0, 0x6, 0x1, PseudoVSSEG2E64_V_M2 }, // 16
  { 0x2, 0x0, 0x0, 0x6, 0x2, PseudoVSSEG2E64_V_M4 }, // 17
  { 0x2, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG2E8_V_M1 }, // 18
  { 0x2, 0x0, 0x1, 0x3, 0x1, PseudoVSSSEG2E8_V_M2 }, // 19
  { 0x2, 0x0, 0x1, 0x3, 0x2, PseudoVSSSEG2E8_V_M4 }, // 20
  { 0x2, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG2E8_V_MF8 }, // 21
  { 0x2, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG2E8_V_MF4 }, // 22
  { 0x2, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG2E8_V_MF2 }, // 23
  { 0x2, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG2E16_V_M1 }, // 24
  { 0x2, 0x0, 0x1, 0x4, 0x1, PseudoVSSSEG2E16_V_M2 }, // 25
  { 0x2, 0x0, 0x1, 0x4, 0x2, PseudoVSSSEG2E16_V_M4 }, // 26
  { 0x2, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG2E16_V_MF4 }, // 27
  { 0x2, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG2E16_V_MF2 }, // 28
  { 0x2, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG2E32_V_M1 }, // 29
  { 0x2, 0x0, 0x1, 0x5, 0x1, PseudoVSSSEG2E32_V_M2 }, // 30
  { 0x2, 0x0, 0x1, 0x5, 0x2, PseudoVSSSEG2E32_V_M4 }, // 31
  { 0x2, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG2E32_V_MF2 }, // 32
  { 0x2, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG2E64_V_M1 }, // 33
  { 0x2, 0x0, 0x1, 0x6, 0x1, PseudoVSSSEG2E64_V_M2 }, // 34
  { 0x2, 0x0, 0x1, 0x6, 0x2, PseudoVSSSEG2E64_V_M4 }, // 35
  { 0x2, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG2E8_V_M1_MASK }, // 36
  { 0x2, 0x1, 0x0, 0x3, 0x1, PseudoVSSEG2E8_V_M2_MASK }, // 37
  { 0x2, 0x1, 0x0, 0x3, 0x2, PseudoVSSEG2E8_V_M4_MASK }, // 38
  { 0x2, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG2E8_V_MF8_MASK }, // 39
  { 0x2, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG2E8_V_MF4_MASK }, // 40
  { 0x2, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG2E8_V_MF2_MASK }, // 41
  { 0x2, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG2E16_V_M1_MASK }, // 42
  { 0x2, 0x1, 0x0, 0x4, 0x1, PseudoVSSEG2E16_V_M2_MASK }, // 43
  { 0x2, 0x1, 0x0, 0x4, 0x2, PseudoVSSEG2E16_V_M4_MASK }, // 44
  { 0x2, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG2E16_V_MF4_MASK }, // 45
  { 0x2, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG2E16_V_MF2_MASK }, // 46
  { 0x2, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG2E32_V_M1_MASK }, // 47
  { 0x2, 0x1, 0x0, 0x5, 0x1, PseudoVSSEG2E32_V_M2_MASK }, // 48
  { 0x2, 0x1, 0x0, 0x5, 0x2, PseudoVSSEG2E32_V_M4_MASK }, // 49
  { 0x2, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG2E32_V_MF2_MASK }, // 50
  { 0x2, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG2E64_V_M1_MASK }, // 51
  { 0x2, 0x1, 0x0, 0x6, 0x1, PseudoVSSEG2E64_V_M2_MASK }, // 52
  { 0x2, 0x1, 0x0, 0x6, 0x2, PseudoVSSEG2E64_V_M4_MASK }, // 53
  { 0x2, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG2E8_V_M1_MASK }, // 54
  { 0x2, 0x1, 0x1, 0x3, 0x1, PseudoVSSSEG2E8_V_M2_MASK }, // 55
  { 0x2, 0x1, 0x1, 0x3, 0x2, PseudoVSSSEG2E8_V_M4_MASK }, // 56
  { 0x2, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG2E8_V_MF8_MASK }, // 57
  { 0x2, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG2E8_V_MF4_MASK }, // 58
  { 0x2, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG2E8_V_MF2_MASK }, // 59
  { 0x2, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG2E16_V_M1_MASK }, // 60
  { 0x2, 0x1, 0x1, 0x4, 0x1, PseudoVSSSEG2E16_V_M2_MASK }, // 61
  { 0x2, 0x1, 0x1, 0x4, 0x2, PseudoVSSSEG2E16_V_M4_MASK }, // 62
  { 0x2, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG2E16_V_MF4_MASK }, // 63
  { 0x2, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG2E16_V_MF2_MASK }, // 64
  { 0x2, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG2E32_V_M1_MASK }, // 65
  { 0x2, 0x1, 0x1, 0x5, 0x1, PseudoVSSSEG2E32_V_M2_MASK }, // 66
  { 0x2, 0x1, 0x1, 0x5, 0x2, PseudoVSSSEG2E32_V_M4_MASK }, // 67
  { 0x2, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG2E32_V_MF2_MASK }, // 68
  { 0x2, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG2E64_V_M1_MASK }, // 69
  { 0x2, 0x1, 0x1, 0x6, 0x1, PseudoVSSSEG2E64_V_M2_MASK }, // 70
  { 0x2, 0x1, 0x1, 0x6, 0x2, PseudoVSSSEG2E64_V_M4_MASK }, // 71
  { 0x3, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG3E8_V_M1 }, // 72
  { 0x3, 0x0, 0x0, 0x3, 0x1, PseudoVSSEG3E8_V_M2 }, // 73
  { 0x3, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG3E8_V_MF8 }, // 74
  { 0x3, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG3E8_V_MF4 }, // 75
  { 0x3, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG3E8_V_MF2 }, // 76
  { 0x3, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG3E16_V_M1 }, // 77
  { 0x3, 0x0, 0x0, 0x4, 0x1, PseudoVSSEG3E16_V_M2 }, // 78
  { 0x3, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG3E16_V_MF4 }, // 79
  { 0x3, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG3E16_V_MF2 }, // 80
  { 0x3, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG3E32_V_M1 }, // 81
  { 0x3, 0x0, 0x0, 0x5, 0x1, PseudoVSSEG3E32_V_M2 }, // 82
  { 0x3, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG3E32_V_MF2 }, // 83
  { 0x3, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG3E64_V_M1 }, // 84
  { 0x3, 0x0, 0x0, 0x6, 0x1, PseudoVSSEG3E64_V_M2 }, // 85
  { 0x3, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG3E8_V_M1 }, // 86
  { 0x3, 0x0, 0x1, 0x3, 0x1, PseudoVSSSEG3E8_V_M2 }, // 87
  { 0x3, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG3E8_V_MF8 }, // 88
  { 0x3, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG3E8_V_MF4 }, // 89
  { 0x3, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG3E8_V_MF2 }, // 90
  { 0x3, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG3E16_V_M1 }, // 91
  { 0x3, 0x0, 0x1, 0x4, 0x1, PseudoVSSSEG3E16_V_M2 }, // 92
  { 0x3, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG3E16_V_MF4 }, // 93
  { 0x3, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG3E16_V_MF2 }, // 94
  { 0x3, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG3E32_V_M1 }, // 95
  { 0x3, 0x0, 0x1, 0x5, 0x1, PseudoVSSSEG3E32_V_M2 }, // 96
  { 0x3, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG3E32_V_MF2 }, // 97
  { 0x3, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG3E64_V_M1 }, // 98
  { 0x3, 0x0, 0x1, 0x6, 0x1, PseudoVSSSEG3E64_V_M2 }, // 99
  { 0x3, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG3E8_V_M1_MASK }, // 100
  { 0x3, 0x1, 0x0, 0x3, 0x1, PseudoVSSEG3E8_V_M2_MASK }, // 101
  { 0x3, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG3E8_V_MF8_MASK }, // 102
  { 0x3, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG3E8_V_MF4_MASK }, // 103
  { 0x3, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG3E8_V_MF2_MASK }, // 104
  { 0x3, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG3E16_V_M1_MASK }, // 105
  { 0x3, 0x1, 0x0, 0x4, 0x1, PseudoVSSEG3E16_V_M2_MASK }, // 106
  { 0x3, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG3E16_V_MF4_MASK }, // 107
  { 0x3, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG3E16_V_MF2_MASK }, // 108
  { 0x3, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG3E32_V_M1_MASK }, // 109
  { 0x3, 0x1, 0x0, 0x5, 0x1, PseudoVSSEG3E32_V_M2_MASK }, // 110
  { 0x3, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG3E32_V_MF2_MASK }, // 111
  { 0x3, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG3E64_V_M1_MASK }, // 112
  { 0x3, 0x1, 0x0, 0x6, 0x1, PseudoVSSEG3E64_V_M2_MASK }, // 113
  { 0x3, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG3E8_V_M1_MASK }, // 114
  { 0x3, 0x1, 0x1, 0x3, 0x1, PseudoVSSSEG3E8_V_M2_MASK }, // 115
  { 0x3, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG3E8_V_MF8_MASK }, // 116
  { 0x3, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG3E8_V_MF4_MASK }, // 117
  { 0x3, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG3E8_V_MF2_MASK }, // 118
  { 0x3, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG3E16_V_M1_MASK }, // 119
  { 0x3, 0x1, 0x1, 0x4, 0x1, PseudoVSSSEG3E16_V_M2_MASK }, // 120
  { 0x3, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG3E16_V_MF4_MASK }, // 121
  { 0x3, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG3E16_V_MF2_MASK }, // 122
  { 0x3, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG3E32_V_M1_MASK }, // 123
  { 0x3, 0x1, 0x1, 0x5, 0x1, PseudoVSSSEG3E32_V_M2_MASK }, // 124
  { 0x3, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG3E32_V_MF2_MASK }, // 125
  { 0x3, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG3E64_V_M1_MASK }, // 126
  { 0x3, 0x1, 0x1, 0x6, 0x1, PseudoVSSSEG3E64_V_M2_MASK }, // 127
  { 0x4, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG4E8_V_M1 }, // 128
  { 0x4, 0x0, 0x0, 0x3, 0x1, PseudoVSSEG4E8_V_M2 }, // 129
  { 0x4, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG4E8_V_MF8 }, // 130
  { 0x4, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG4E8_V_MF4 }, // 131
  { 0x4, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG4E8_V_MF2 }, // 132
  { 0x4, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG4E16_V_M1 }, // 133
  { 0x4, 0x0, 0x0, 0x4, 0x1, PseudoVSSEG4E16_V_M2 }, // 134
  { 0x4, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG4E16_V_MF4 }, // 135
  { 0x4, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG4E16_V_MF2 }, // 136
  { 0x4, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG4E32_V_M1 }, // 137
  { 0x4, 0x0, 0x0, 0x5, 0x1, PseudoVSSEG4E32_V_M2 }, // 138
  { 0x4, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG4E32_V_MF2 }, // 139
  { 0x4, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG4E64_V_M1 }, // 140
  { 0x4, 0x0, 0x0, 0x6, 0x1, PseudoVSSEG4E64_V_M2 }, // 141
  { 0x4, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG4E8_V_M1 }, // 142
  { 0x4, 0x0, 0x1, 0x3, 0x1, PseudoVSSSEG4E8_V_M2 }, // 143
  { 0x4, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG4E8_V_MF8 }, // 144
  { 0x4, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG4E8_V_MF4 }, // 145
  { 0x4, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG4E8_V_MF2 }, // 146
  { 0x4, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG4E16_V_M1 }, // 147
  { 0x4, 0x0, 0x1, 0x4, 0x1, PseudoVSSSEG4E16_V_M2 }, // 148
  { 0x4, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG4E16_V_MF4 }, // 149
  { 0x4, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG4E16_V_MF2 }, // 150
  { 0x4, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG4E32_V_M1 }, // 151
  { 0x4, 0x0, 0x1, 0x5, 0x1, PseudoVSSSEG4E32_V_M2 }, // 152
  { 0x4, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG4E32_V_MF2 }, // 153
  { 0x4, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG4E64_V_M1 }, // 154
  { 0x4, 0x0, 0x1, 0x6, 0x1, PseudoVSSSEG4E64_V_M2 }, // 155
  { 0x4, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG4E8_V_M1_MASK }, // 156
  { 0x4, 0x1, 0x0, 0x3, 0x1, PseudoVSSEG4E8_V_M2_MASK }, // 157
  { 0x4, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG4E8_V_MF8_MASK }, // 158
  { 0x4, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG4E8_V_MF4_MASK }, // 159
  { 0x4, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG4E8_V_MF2_MASK }, // 160
  { 0x4, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG4E16_V_M1_MASK }, // 161
  { 0x4, 0x1, 0x0, 0x4, 0x1, PseudoVSSEG4E16_V_M2_MASK }, // 162
  { 0x4, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG4E16_V_MF4_MASK }, // 163
  { 0x4, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG4E16_V_MF2_MASK }, // 164
  { 0x4, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG4E32_V_M1_MASK }, // 165
  { 0x4, 0x1, 0x0, 0x5, 0x1, PseudoVSSEG4E32_V_M2_MASK }, // 166
  { 0x4, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG4E32_V_MF2_MASK }, // 167
  { 0x4, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG4E64_V_M1_MASK }, // 168
  { 0x4, 0x1, 0x0, 0x6, 0x1, PseudoVSSEG4E64_V_M2_MASK }, // 169
  { 0x4, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG4E8_V_M1_MASK }, // 170
  { 0x4, 0x1, 0x1, 0x3, 0x1, PseudoVSSSEG4E8_V_M2_MASK }, // 171
  { 0x4, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG4E8_V_MF8_MASK }, // 172
  { 0x4, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG4E8_V_MF4_MASK }, // 173
  { 0x4, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG4E8_V_MF2_MASK }, // 174
  { 0x4, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG4E16_V_M1_MASK }, // 175
  { 0x4, 0x1, 0x1, 0x4, 0x1, PseudoVSSSEG4E16_V_M2_MASK }, // 176
  { 0x4, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG4E16_V_MF4_MASK }, // 177
  { 0x4, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG4E16_V_MF2_MASK }, // 178
  { 0x4, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG4E32_V_M1_MASK }, // 179
  { 0x4, 0x1, 0x1, 0x5, 0x1, PseudoVSSSEG4E32_V_M2_MASK }, // 180
  { 0x4, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG4E32_V_MF2_MASK }, // 181
  { 0x4, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG4E64_V_M1_MASK }, // 182
  { 0x4, 0x1, 0x1, 0x6, 0x1, PseudoVSSSEG4E64_V_M2_MASK }, // 183
  { 0x5, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG5E8_V_M1 }, // 184
  { 0x5, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG5E8_V_MF8 }, // 185
  { 0x5, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG5E8_V_MF4 }, // 186
  { 0x5, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG5E8_V_MF2 }, // 187
  { 0x5, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG5E16_V_M1 }, // 188
  { 0x5, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG5E16_V_MF4 }, // 189
  { 0x5, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG5E16_V_MF2 }, // 190
  { 0x5, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG5E32_V_M1 }, // 191
  { 0x5, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG5E32_V_MF2 }, // 192
  { 0x5, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG5E64_V_M1 }, // 193
  { 0x5, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG5E8_V_M1 }, // 194
  { 0x5, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG5E8_V_MF8 }, // 195
  { 0x5, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG5E8_V_MF4 }, // 196
  { 0x5, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG5E8_V_MF2 }, // 197
  { 0x5, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG5E16_V_M1 }, // 198
  { 0x5, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG5E16_V_MF4 }, // 199
  { 0x5, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG5E16_V_MF2 }, // 200
  { 0x5, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG5E32_V_M1 }, // 201
  { 0x5, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG5E32_V_MF2 }, // 202
  { 0x5, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG5E64_V_M1 }, // 203
  { 0x5, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG5E8_V_M1_MASK }, // 204
  { 0x5, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG5E8_V_MF8_MASK }, // 205
  { 0x5, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG5E8_V_MF4_MASK }, // 206
  { 0x5, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG5E8_V_MF2_MASK }, // 207
  { 0x5, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG5E16_V_M1_MASK }, // 208
  { 0x5, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG5E16_V_MF4_MASK }, // 209
  { 0x5, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG5E16_V_MF2_MASK }, // 210
  { 0x5, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG5E32_V_M1_MASK }, // 211
  { 0x5, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG5E32_V_MF2_MASK }, // 212
  { 0x5, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG5E64_V_M1_MASK }, // 213
  { 0x5, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG5E8_V_M1_MASK }, // 214
  { 0x5, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG5E8_V_MF8_MASK }, // 215
  { 0x5, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG5E8_V_MF4_MASK }, // 216
  { 0x5, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG5E8_V_MF2_MASK }, // 217
  { 0x5, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG5E16_V_M1_MASK }, // 218
  { 0x5, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG5E16_V_MF4_MASK }, // 219
  { 0x5, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG5E16_V_MF2_MASK }, // 220
  { 0x5, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG5E32_V_M1_MASK }, // 221
  { 0x5, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG5E32_V_MF2_MASK }, // 222
  { 0x5, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG5E64_V_M1_MASK }, // 223
  { 0x6, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG6E8_V_M1 }, // 224
  { 0x6, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG6E8_V_MF8 }, // 225
  { 0x6, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG6E8_V_MF4 }, // 226
  { 0x6, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG6E8_V_MF2 }, // 227
  { 0x6, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG6E16_V_M1 }, // 228
  { 0x6, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG6E16_V_MF4 }, // 229
  { 0x6, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG6E16_V_MF2 }, // 230
  { 0x6, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG6E32_V_M1 }, // 231
  { 0x6, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG6E32_V_MF2 }, // 232
  { 0x6, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG6E64_V_M1 }, // 233
  { 0x6, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG6E8_V_M1 }, // 234
  { 0x6, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG6E8_V_MF8 }, // 235
  { 0x6, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG6E8_V_MF4 }, // 236
  { 0x6, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG6E8_V_MF2 }, // 237
  { 0x6, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG6E16_V_M1 }, // 238
  { 0x6, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG6E16_V_MF4 }, // 239
  { 0x6, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG6E16_V_MF2 }, // 240
  { 0x6, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG6E32_V_M1 }, // 241
  { 0x6, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG6E32_V_MF2 }, // 242
  { 0x6, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG6E64_V_M1 }, // 243
  { 0x6, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG6E8_V_M1_MASK }, // 244
  { 0x6, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG6E8_V_MF8_MASK }, // 245
  { 0x6, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG6E8_V_MF4_MASK }, // 246
  { 0x6, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG6E8_V_MF2_MASK }, // 247
  { 0x6, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG6E16_V_M1_MASK }, // 248
  { 0x6, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG6E16_V_MF4_MASK }, // 249
  { 0x6, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG6E16_V_MF2_MASK }, // 250
  { 0x6, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG6E32_V_M1_MASK }, // 251
  { 0x6, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG6E32_V_MF2_MASK }, // 252
  { 0x6, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG6E64_V_M1_MASK }, // 253
  { 0x6, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG6E8_V_M1_MASK }, // 254
  { 0x6, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG6E8_V_MF8_MASK }, // 255
  { 0x6, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG6E8_V_MF4_MASK }, // 256
  { 0x6, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG6E8_V_MF2_MASK }, // 257
  { 0x6, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG6E16_V_M1_MASK }, // 258
  { 0x6, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG6E16_V_MF4_MASK }, // 259
  { 0x6, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG6E16_V_MF2_MASK }, // 260
  { 0x6, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG6E32_V_M1_MASK }, // 261
  { 0x6, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG6E32_V_MF2_MASK }, // 262
  { 0x6, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG6E64_V_M1_MASK }, // 263
  { 0x7, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG7E8_V_M1 }, // 264
  { 0x7, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG7E8_V_MF8 }, // 265
  { 0x7, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG7E8_V_MF4 }, // 266
  { 0x7, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG7E8_V_MF2 }, // 267
  { 0x7, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG7E16_V_M1 }, // 268
  { 0x7, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG7E16_V_MF4 }, // 269
  { 0x7, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG7E16_V_MF2 }, // 270
  { 0x7, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG7E32_V_M1 }, // 271
  { 0x7, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG7E32_V_MF2 }, // 272
  { 0x7, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG7E64_V_M1 }, // 273
  { 0x7, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG7E8_V_M1 }, // 274
  { 0x7, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG7E8_V_MF8 }, // 275
  { 0x7, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG7E8_V_MF4 }, // 276
  { 0x7, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG7E8_V_MF2 }, // 277
  { 0x7, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG7E16_V_M1 }, // 278
  { 0x7, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG7E16_V_MF4 }, // 279
  { 0x7, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG7E16_V_MF2 }, // 280
  { 0x7, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG7E32_V_M1 }, // 281
  { 0x7, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG7E32_V_MF2 }, // 282
  { 0x7, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG7E64_V_M1 }, // 283
  { 0x7, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG7E8_V_M1_MASK }, // 284
  { 0x7, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG7E8_V_MF8_MASK }, // 285
  { 0x7, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG7E8_V_MF4_MASK }, // 286
  { 0x7, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG7E8_V_MF2_MASK }, // 287
  { 0x7, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG7E16_V_M1_MASK }, // 288
  { 0x7, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG7E16_V_MF4_MASK }, // 289
  { 0x7, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG7E16_V_MF2_MASK }, // 290
  { 0x7, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG7E32_V_M1_MASK }, // 291
  { 0x7, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG7E32_V_MF2_MASK }, // 292
  { 0x7, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG7E64_V_M1_MASK }, // 293
  { 0x7, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG7E8_V_M1_MASK }, // 294
  { 0x7, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG7E8_V_MF8_MASK }, // 295
  { 0x7, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG7E8_V_MF4_MASK }, // 296
  { 0x7, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG7E8_V_MF2_MASK }, // 297
  { 0x7, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG7E16_V_M1_MASK }, // 298
  { 0x7, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG7E16_V_MF4_MASK }, // 299
  { 0x7, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG7E16_V_MF2_MASK }, // 300
  { 0x7, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG7E32_V_M1_MASK }, // 301
  { 0x7, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG7E32_V_MF2_MASK }, // 302
  { 0x7, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG7E64_V_M1_MASK }, // 303
  { 0x8, 0x0, 0x0, 0x3, 0x0, PseudoVSSEG8E8_V_M1 }, // 304
  { 0x8, 0x0, 0x0, 0x3, 0x5, PseudoVSSEG8E8_V_MF8 }, // 305
  { 0x8, 0x0, 0x0, 0x3, 0x6, PseudoVSSEG8E8_V_MF4 }, // 306
  { 0x8, 0x0, 0x0, 0x3, 0x7, PseudoVSSEG8E8_V_MF2 }, // 307
  { 0x8, 0x0, 0x0, 0x4, 0x0, PseudoVSSEG8E16_V_M1 }, // 308
  { 0x8, 0x0, 0x0, 0x4, 0x6, PseudoVSSEG8E16_V_MF4 }, // 309
  { 0x8, 0x0, 0x0, 0x4, 0x7, PseudoVSSEG8E16_V_MF2 }, // 310
  { 0x8, 0x0, 0x0, 0x5, 0x0, PseudoVSSEG8E32_V_M1 }, // 311
  { 0x8, 0x0, 0x0, 0x5, 0x7, PseudoVSSEG8E32_V_MF2 }, // 312
  { 0x8, 0x0, 0x0, 0x6, 0x0, PseudoVSSEG8E64_V_M1 }, // 313
  { 0x8, 0x0, 0x1, 0x3, 0x0, PseudoVSSSEG8E8_V_M1 }, // 314
  { 0x8, 0x0, 0x1, 0x3, 0x5, PseudoVSSSEG8E8_V_MF8 }, // 315
  { 0x8, 0x0, 0x1, 0x3, 0x6, PseudoVSSSEG8E8_V_MF4 }, // 316
  { 0x8, 0x0, 0x1, 0x3, 0x7, PseudoVSSSEG8E8_V_MF2 }, // 317
  { 0x8, 0x0, 0x1, 0x4, 0x0, PseudoVSSSEG8E16_V_M1 }, // 318
  { 0x8, 0x0, 0x1, 0x4, 0x6, PseudoVSSSEG8E16_V_MF4 }, // 319
  { 0x8, 0x0, 0x1, 0x4, 0x7, PseudoVSSSEG8E16_V_MF2 }, // 320
  { 0x8, 0x0, 0x1, 0x5, 0x0, PseudoVSSSEG8E32_V_M1 }, // 321
  { 0x8, 0x0, 0x1, 0x5, 0x7, PseudoVSSSEG8E32_V_MF2 }, // 322
  { 0x8, 0x0, 0x1, 0x6, 0x0, PseudoVSSSEG8E64_V_M1 }, // 323
  { 0x8, 0x1, 0x0, 0x3, 0x0, PseudoVSSEG8E8_V_M1_MASK }, // 324
  { 0x8, 0x1, 0x0, 0x3, 0x5, PseudoVSSEG8E8_V_MF8_MASK }, // 325
  { 0x8, 0x1, 0x0, 0x3, 0x6, PseudoVSSEG8E8_V_MF4_MASK }, // 326
  { 0x8, 0x1, 0x0, 0x3, 0x7, PseudoVSSEG8E8_V_MF2_MASK }, // 327
  { 0x8, 0x1, 0x0, 0x4, 0x0, PseudoVSSEG8E16_V_M1_MASK }, // 328
  { 0x8, 0x1, 0x0, 0x4, 0x6, PseudoVSSEG8E16_V_MF4_MASK }, // 329
  { 0x8, 0x1, 0x0, 0x4, 0x7, PseudoVSSEG8E16_V_MF2_MASK }, // 330
  { 0x8, 0x1, 0x0, 0x5, 0x0, PseudoVSSEG8E32_V_M1_MASK }, // 331
  { 0x8, 0x1, 0x0, 0x5, 0x7, PseudoVSSEG8E32_V_MF2_MASK }, // 332
  { 0x8, 0x1, 0x0, 0x6, 0x0, PseudoVSSEG8E64_V_M1_MASK }, // 333
  { 0x8, 0x1, 0x1, 0x3, 0x0, PseudoVSSSEG8E8_V_M1_MASK }, // 334
  { 0x8, 0x1, 0x1, 0x3, 0x5, PseudoVSSSEG8E8_V_MF8_MASK }, // 335
  { 0x8, 0x1, 0x1, 0x3, 0x6, PseudoVSSSEG8E8_V_MF4_MASK }, // 336
  { 0x8, 0x1, 0x1, 0x3, 0x7, PseudoVSSSEG8E8_V_MF2_MASK }, // 337
  { 0x8, 0x1, 0x1, 0x4, 0x0, PseudoVSSSEG8E16_V_M1_MASK }, // 338
  { 0x8, 0x1, 0x1, 0x4, 0x6, PseudoVSSSEG8E16_V_MF4_MASK }, // 339
  { 0x8, 0x1, 0x1, 0x4, 0x7, PseudoVSSSEG8E16_V_MF2_MASK }, // 340
  { 0x8, 0x1, 0x1, 0x5, 0x0, PseudoVSSSEG8E32_V_M1_MASK }, // 341
  { 0x8, 0x1, 0x1, 0x5, 0x7, PseudoVSSSEG8E32_V_MF2_MASK }, // 342
  { 0x8, 0x1, 0x1, 0x6, 0x0, PseudoVSSSEG8E64_V_M1_MASK }, // 343
 };

const VSSEGPseudo *getVSSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t Strided, uint8_t Log2SEW, uint8_t LMUL) {
  struct KeyType {
    uint8_t NF;
    uint8_t Masked;
    uint8_t Strided;
    uint8_t Log2SEW;
    uint8_t LMUL;
  };
  KeyType Key = {NF, Masked, Strided, Log2SEW, LMUL};
  auto Table = ArrayRef(RISCVVSSEGTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VSSEGPseudo &LHS, const KeyType &RHS) {
      if (LHS.NF < RHS.NF)
        return true;
      if (LHS.NF > RHS.NF)
        return false;
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.Strided < RHS.Strided)
        return true;
      if (LHS.Strided > RHS.Strided)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.NF != Idx->NF ||
      Key.Masked != Idx->Masked ||
      Key.Strided != Idx->Strided ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVSXSEGTable_DECL
const VSXSEGPseudo *getVSXSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL);
#endif

#ifdef GET_RISCVVSXSEGTable_IMPL
constexpr VSXSEGPseudo RISCVVSXSEGTable[] = {
  { 0x2, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG2EI8_V_M1_M1 }, // 0
  { 0x2, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG2EI8_V_MF8_M1 }, // 1
  { 0x2, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG2EI8_V_MF4_M1 }, // 2
  { 0x2, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG2EI8_V_MF2_M1 }, // 3
  { 0x2, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVSUXSEG2EI8_V_M1_M2 }, // 4
  { 0x2, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVSUXSEG2EI8_V_M2_M2 }, // 5
  { 0x2, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVSUXSEG2EI8_V_MF4_M2 }, // 6
  { 0x2, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVSUXSEG2EI8_V_MF2_M2 }, // 7
  { 0x2, 0x0, 0x0, 0x3, 0x2, 0x0, PseudoVSUXSEG2EI8_V_M1_M4 }, // 8
  { 0x2, 0x0, 0x0, 0x3, 0x2, 0x1, PseudoVSUXSEG2EI8_V_M2_M4 }, // 9
  { 0x2, 0x0, 0x0, 0x3, 0x2, 0x2, PseudoVSUXSEG2EI8_V_M4_M4 }, // 10
  { 0x2, 0x0, 0x0, 0x3, 0x2, 0x7, PseudoVSUXSEG2EI8_V_MF2_M4 }, // 11
  { 0x2, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF8 }, // 12
  { 0x2, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF4 }, // 13
  { 0x2, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF4 }, // 14
  { 0x2, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF2 }, // 15
  { 0x2, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF2 }, // 16
  { 0x2, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF2 }, // 17
  { 0x2, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG2EI16_V_M1_M1 }, // 18
  { 0x2, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG2EI16_V_M2_M1 }, // 19
  { 0x2, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG2EI16_V_MF4_M1 }, // 20
  { 0x2, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG2EI16_V_MF2_M1 }, // 21
  { 0x2, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVSUXSEG2EI16_V_M1_M2 }, // 22
  { 0x2, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVSUXSEG2EI16_V_M2_M2 }, // 23
  { 0x2, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVSUXSEG2EI16_V_M4_M2 }, // 24
  { 0x2, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVSUXSEG2EI16_V_MF2_M2 }, // 25
  { 0x2, 0x0, 0x0, 0x4, 0x2, 0x0, PseudoVSUXSEG2EI16_V_M1_M4 }, // 26
  { 0x2, 0x0, 0x0, 0x4, 0x2, 0x1, PseudoVSUXSEG2EI16_V_M2_M4 }, // 27
  { 0x2, 0x0, 0x0, 0x4, 0x2, 0x2, PseudoVSUXSEG2EI16_V_M4_M4 }, // 28
  { 0x2, 0x0, 0x0, 0x4, 0x2, 0x3, PseudoVSUXSEG2EI16_V_M8_M4 }, // 29
  { 0x2, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF8 }, // 30
  { 0x2, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF4 }, // 31
  { 0x2, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF4 }, // 32
  { 0x2, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG2EI16_V_M1_MF2 }, // 33
  { 0x2, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF2 }, // 34
  { 0x2, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF2 }, // 35
  { 0x2, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG2EI32_V_M1_M1 }, // 36
  { 0x2, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG2EI32_V_M2_M1 }, // 37
  { 0x2, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG2EI32_V_M4_M1 }, // 38
  { 0x2, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG2EI32_V_MF2_M1 }, // 39
  { 0x2, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVSUXSEG2EI32_V_M1_M2 }, // 40
  { 0x2, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVSUXSEG2EI32_V_M2_M2 }, // 41
  { 0x2, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVSUXSEG2EI32_V_M4_M2 }, // 42
  { 0x2, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVSUXSEG2EI32_V_M8_M2 }, // 43
  { 0x2, 0x0, 0x0, 0x5, 0x2, 0x1, PseudoVSUXSEG2EI32_V_M2_M4 }, // 44
  { 0x2, 0x0, 0x0, 0x5, 0x2, 0x2, PseudoVSUXSEG2EI32_V_M4_M4 }, // 45
  { 0x2, 0x0, 0x0, 0x5, 0x2, 0x3, PseudoVSUXSEG2EI32_V_M8_M4 }, // 46
  { 0x2, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF8 }, // 47
  { 0x2, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG2EI32_V_M1_MF4 }, // 48
  { 0x2, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF4 }, // 49
  { 0x2, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG2EI32_V_M1_MF2 }, // 50
  { 0x2, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG2EI32_V_M2_MF2 }, // 51
  { 0x2, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF2 }, // 52
  { 0x2, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG2EI64_V_M1_M1 }, // 53
  { 0x2, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG2EI64_V_M2_M1 }, // 54
  { 0x2, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG2EI64_V_M4_M1 }, // 55
  { 0x2, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG2EI64_V_M8_M1 }, // 56
  { 0x2, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVSUXSEG2EI64_V_M2_M2 }, // 57
  { 0x2, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVSUXSEG2EI64_V_M4_M2 }, // 58
  { 0x2, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVSUXSEG2EI64_V_M8_M2 }, // 59
  { 0x2, 0x0, 0x0, 0x6, 0x2, 0x2, PseudoVSUXSEG2EI64_V_M4_M4 }, // 60
  { 0x2, 0x0, 0x0, 0x6, 0x2, 0x3, PseudoVSUXSEG2EI64_V_M8_M4 }, // 61
  { 0x2, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG2EI64_V_M1_MF8 }, // 62
  { 0x2, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG2EI64_V_M1_MF4 }, // 63
  { 0x2, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG2EI64_V_M2_MF4 }, // 64
  { 0x2, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG2EI64_V_M1_MF2 }, // 65
  { 0x2, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG2EI64_V_M2_MF2 }, // 66
  { 0x2, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG2EI64_V_M4_MF2 }, // 67
  { 0x2, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG2EI8_V_M1_M1 }, // 68
  { 0x2, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG2EI8_V_MF8_M1 }, // 69
  { 0x2, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG2EI8_V_MF4_M1 }, // 70
  { 0x2, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG2EI8_V_MF2_M1 }, // 71
  { 0x2, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVSOXSEG2EI8_V_M1_M2 }, // 72
  { 0x2, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVSOXSEG2EI8_V_M2_M2 }, // 73
  { 0x2, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVSOXSEG2EI8_V_MF4_M2 }, // 74
  { 0x2, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVSOXSEG2EI8_V_MF2_M2 }, // 75
  { 0x2, 0x0, 0x1, 0x3, 0x2, 0x0, PseudoVSOXSEG2EI8_V_M1_M4 }, // 76
  { 0x2, 0x0, 0x1, 0x3, 0x2, 0x1, PseudoVSOXSEG2EI8_V_M2_M4 }, // 77
  { 0x2, 0x0, 0x1, 0x3, 0x2, 0x2, PseudoVSOXSEG2EI8_V_M4_M4 }, // 78
  { 0x2, 0x0, 0x1, 0x3, 0x2, 0x7, PseudoVSOXSEG2EI8_V_MF2_M4 }, // 79
  { 0x2, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF8 }, // 80
  { 0x2, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF4 }, // 81
  { 0x2, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF4 }, // 82
  { 0x2, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF2 }, // 83
  { 0x2, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF2 }, // 84
  { 0x2, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF2 }, // 85
  { 0x2, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG2EI16_V_M1_M1 }, // 86
  { 0x2, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG2EI16_V_M2_M1 }, // 87
  { 0x2, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG2EI16_V_MF4_M1 }, // 88
  { 0x2, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG2EI16_V_MF2_M1 }, // 89
  { 0x2, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVSOXSEG2EI16_V_M1_M2 }, // 90
  { 0x2, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVSOXSEG2EI16_V_M2_M2 }, // 91
  { 0x2, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVSOXSEG2EI16_V_M4_M2 }, // 92
  { 0x2, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVSOXSEG2EI16_V_MF2_M2 }, // 93
  { 0x2, 0x0, 0x1, 0x4, 0x2, 0x0, PseudoVSOXSEG2EI16_V_M1_M4 }, // 94
  { 0x2, 0x0, 0x1, 0x4, 0x2, 0x1, PseudoVSOXSEG2EI16_V_M2_M4 }, // 95
  { 0x2, 0x0, 0x1, 0x4, 0x2, 0x2, PseudoVSOXSEG2EI16_V_M4_M4 }, // 96
  { 0x2, 0x0, 0x1, 0x4, 0x2, 0x3, PseudoVSOXSEG2EI16_V_M8_M4 }, // 97
  { 0x2, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF8 }, // 98
  { 0x2, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF4 }, // 99
  { 0x2, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF4 }, // 100
  { 0x2, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG2EI16_V_M1_MF2 }, // 101
  { 0x2, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF2 }, // 102
  { 0x2, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF2 }, // 103
  { 0x2, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG2EI32_V_M1_M1 }, // 104
  { 0x2, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG2EI32_V_M2_M1 }, // 105
  { 0x2, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG2EI32_V_M4_M1 }, // 106
  { 0x2, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG2EI32_V_MF2_M1 }, // 107
  { 0x2, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVSOXSEG2EI32_V_M1_M2 }, // 108
  { 0x2, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVSOXSEG2EI32_V_M2_M2 }, // 109
  { 0x2, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVSOXSEG2EI32_V_M4_M2 }, // 110
  { 0x2, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVSOXSEG2EI32_V_M8_M2 }, // 111
  { 0x2, 0x0, 0x1, 0x5, 0x2, 0x1, PseudoVSOXSEG2EI32_V_M2_M4 }, // 112
  { 0x2, 0x0, 0x1, 0x5, 0x2, 0x2, PseudoVSOXSEG2EI32_V_M4_M4 }, // 113
  { 0x2, 0x0, 0x1, 0x5, 0x2, 0x3, PseudoVSOXSEG2EI32_V_M8_M4 }, // 114
  { 0x2, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF8 }, // 115
  { 0x2, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG2EI32_V_M1_MF4 }, // 116
  { 0x2, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF4 }, // 117
  { 0x2, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG2EI32_V_M1_MF2 }, // 118
  { 0x2, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG2EI32_V_M2_MF2 }, // 119
  { 0x2, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF2 }, // 120
  { 0x2, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG2EI64_V_M1_M1 }, // 121
  { 0x2, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG2EI64_V_M2_M1 }, // 122
  { 0x2, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG2EI64_V_M4_M1 }, // 123
  { 0x2, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG2EI64_V_M8_M1 }, // 124
  { 0x2, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVSOXSEG2EI64_V_M2_M2 }, // 125
  { 0x2, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVSOXSEG2EI64_V_M4_M2 }, // 126
  { 0x2, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVSOXSEG2EI64_V_M8_M2 }, // 127
  { 0x2, 0x0, 0x1, 0x6, 0x2, 0x2, PseudoVSOXSEG2EI64_V_M4_M4 }, // 128
  { 0x2, 0x0, 0x1, 0x6, 0x2, 0x3, PseudoVSOXSEG2EI64_V_M8_M4 }, // 129
  { 0x2, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG2EI64_V_M1_MF8 }, // 130
  { 0x2, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG2EI64_V_M1_MF4 }, // 131
  { 0x2, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG2EI64_V_M2_MF4 }, // 132
  { 0x2, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG2EI64_V_M1_MF2 }, // 133
  { 0x2, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG2EI64_V_M2_MF2 }, // 134
  { 0x2, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG2EI64_V_M4_MF2 }, // 135
  { 0x2, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG2EI8_V_M1_M1_MASK }, // 136
  { 0x2, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG2EI8_V_MF8_M1_MASK }, // 137
  { 0x2, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG2EI8_V_MF4_M1_MASK }, // 138
  { 0x2, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG2EI8_V_MF2_M1_MASK }, // 139
  { 0x2, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVSUXSEG2EI8_V_M1_M2_MASK }, // 140
  { 0x2, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVSUXSEG2EI8_V_M2_M2_MASK }, // 141
  { 0x2, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVSUXSEG2EI8_V_MF4_M2_MASK }, // 142
  { 0x2, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVSUXSEG2EI8_V_MF2_M2_MASK }, // 143
  { 0x2, 0x1, 0x0, 0x3, 0x2, 0x0, PseudoVSUXSEG2EI8_V_M1_M4_MASK }, // 144
  { 0x2, 0x1, 0x0, 0x3, 0x2, 0x1, PseudoVSUXSEG2EI8_V_M2_M4_MASK }, // 145
  { 0x2, 0x1, 0x0, 0x3, 0x2, 0x2, PseudoVSUXSEG2EI8_V_M4_M4_MASK }, // 146
  { 0x2, 0x1, 0x0, 0x3, 0x2, 0x7, PseudoVSUXSEG2EI8_V_MF2_M4_MASK }, // 147
  { 0x2, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF8_MASK }, // 148
  { 0x2, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF4_MASK }, // 149
  { 0x2, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF4_MASK }, // 150
  { 0x2, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF2_MASK }, // 151
  { 0x2, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF2_MASK }, // 152
  { 0x2, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF2_MASK }, // 153
  { 0x2, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG2EI16_V_M1_M1_MASK }, // 154
  { 0x2, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG2EI16_V_M2_M1_MASK }, // 155
  { 0x2, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG2EI16_V_MF4_M1_MASK }, // 156
  { 0x2, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG2EI16_V_MF2_M1_MASK }, // 157
  { 0x2, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVSUXSEG2EI16_V_M1_M2_MASK }, // 158
  { 0x2, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVSUXSEG2EI16_V_M2_M2_MASK }, // 159
  { 0x2, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVSUXSEG2EI16_V_M4_M2_MASK }, // 160
  { 0x2, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVSUXSEG2EI16_V_MF2_M2_MASK }, // 161
  { 0x2, 0x1, 0x0, 0x4, 0x2, 0x0, PseudoVSUXSEG2EI16_V_M1_M4_MASK }, // 162
  { 0x2, 0x1, 0x0, 0x4, 0x2, 0x1, PseudoVSUXSEG2EI16_V_M2_M4_MASK }, // 163
  { 0x2, 0x1, 0x0, 0x4, 0x2, 0x2, PseudoVSUXSEG2EI16_V_M4_M4_MASK }, // 164
  { 0x2, 0x1, 0x0, 0x4, 0x2, 0x3, PseudoVSUXSEG2EI16_V_M8_M4_MASK }, // 165
  { 0x2, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF8_MASK }, // 166
  { 0x2, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF4_MASK }, // 167
  { 0x2, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF4_MASK }, // 168
  { 0x2, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG2EI16_V_M1_MF2_MASK }, // 169
  { 0x2, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF2_MASK }, // 170
  { 0x2, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF2_MASK }, // 171
  { 0x2, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG2EI32_V_M1_M1_MASK }, // 172
  { 0x2, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG2EI32_V_M2_M1_MASK }, // 173
  { 0x2, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG2EI32_V_M4_M1_MASK }, // 174
  { 0x2, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG2EI32_V_MF2_M1_MASK }, // 175
  { 0x2, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVSUXSEG2EI32_V_M1_M2_MASK }, // 176
  { 0x2, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVSUXSEG2EI32_V_M2_M2_MASK }, // 177
  { 0x2, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVSUXSEG2EI32_V_M4_M2_MASK }, // 178
  { 0x2, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVSUXSEG2EI32_V_M8_M2_MASK }, // 179
  { 0x2, 0x1, 0x0, 0x5, 0x2, 0x1, PseudoVSUXSEG2EI32_V_M2_M4_MASK }, // 180
  { 0x2, 0x1, 0x0, 0x5, 0x2, 0x2, PseudoVSUXSEG2EI32_V_M4_M4_MASK }, // 181
  { 0x2, 0x1, 0x0, 0x5, 0x2, 0x3, PseudoVSUXSEG2EI32_V_M8_M4_MASK }, // 182
  { 0x2, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF8_MASK }, // 183
  { 0x2, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG2EI32_V_M1_MF4_MASK }, // 184
  { 0x2, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF4_MASK }, // 185
  { 0x2, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG2EI32_V_M1_MF2_MASK }, // 186
  { 0x2, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG2EI32_V_M2_MF2_MASK }, // 187
  { 0x2, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF2_MASK }, // 188
  { 0x2, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG2EI64_V_M1_M1_MASK }, // 189
  { 0x2, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG2EI64_V_M2_M1_MASK }, // 190
  { 0x2, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG2EI64_V_M4_M1_MASK }, // 191
  { 0x2, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG2EI64_V_M8_M1_MASK }, // 192
  { 0x2, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVSUXSEG2EI64_V_M2_M2_MASK }, // 193
  { 0x2, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVSUXSEG2EI64_V_M4_M2_MASK }, // 194
  { 0x2, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVSUXSEG2EI64_V_M8_M2_MASK }, // 195
  { 0x2, 0x1, 0x0, 0x6, 0x2, 0x2, PseudoVSUXSEG2EI64_V_M4_M4_MASK }, // 196
  { 0x2, 0x1, 0x0, 0x6, 0x2, 0x3, PseudoVSUXSEG2EI64_V_M8_M4_MASK }, // 197
  { 0x2, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG2EI64_V_M1_MF8_MASK }, // 198
  { 0x2, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG2EI64_V_M1_MF4_MASK }, // 199
  { 0x2, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG2EI64_V_M2_MF4_MASK }, // 200
  { 0x2, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG2EI64_V_M1_MF2_MASK }, // 201
  { 0x2, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG2EI64_V_M2_MF2_MASK }, // 202
  { 0x2, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG2EI64_V_M4_MF2_MASK }, // 203
  { 0x2, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG2EI8_V_M1_M1_MASK }, // 204
  { 0x2, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG2EI8_V_MF8_M1_MASK }, // 205
  { 0x2, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG2EI8_V_MF4_M1_MASK }, // 206
  { 0x2, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG2EI8_V_MF2_M1_MASK }, // 207
  { 0x2, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVSOXSEG2EI8_V_M1_M2_MASK }, // 208
  { 0x2, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVSOXSEG2EI8_V_M2_M2_MASK }, // 209
  { 0x2, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVSOXSEG2EI8_V_MF4_M2_MASK }, // 210
  { 0x2, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVSOXSEG2EI8_V_MF2_M2_MASK }, // 211
  { 0x2, 0x1, 0x1, 0x3, 0x2, 0x0, PseudoVSOXSEG2EI8_V_M1_M4_MASK }, // 212
  { 0x2, 0x1, 0x1, 0x3, 0x2, 0x1, PseudoVSOXSEG2EI8_V_M2_M4_MASK }, // 213
  { 0x2, 0x1, 0x1, 0x3, 0x2, 0x2, PseudoVSOXSEG2EI8_V_M4_M4_MASK }, // 214
  { 0x2, 0x1, 0x1, 0x3, 0x2, 0x7, PseudoVSOXSEG2EI8_V_MF2_M4_MASK }, // 215
  { 0x2, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF8_MASK }, // 216
  { 0x2, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF4_MASK }, // 217
  { 0x2, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF4_MASK }, // 218
  { 0x2, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF2_MASK }, // 219
  { 0x2, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF2_MASK }, // 220
  { 0x2, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF2_MASK }, // 221
  { 0x2, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG2EI16_V_M1_M1_MASK }, // 222
  { 0x2, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG2EI16_V_M2_M1_MASK }, // 223
  { 0x2, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG2EI16_V_MF4_M1_MASK }, // 224
  { 0x2, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG2EI16_V_MF2_M1_MASK }, // 225
  { 0x2, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVSOXSEG2EI16_V_M1_M2_MASK }, // 226
  { 0x2, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVSOXSEG2EI16_V_M2_M2_MASK }, // 227
  { 0x2, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVSOXSEG2EI16_V_M4_M2_MASK }, // 228
  { 0x2, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVSOXSEG2EI16_V_MF2_M2_MASK }, // 229
  { 0x2, 0x1, 0x1, 0x4, 0x2, 0x0, PseudoVSOXSEG2EI16_V_M1_M4_MASK }, // 230
  { 0x2, 0x1, 0x1, 0x4, 0x2, 0x1, PseudoVSOXSEG2EI16_V_M2_M4_MASK }, // 231
  { 0x2, 0x1, 0x1, 0x4, 0x2, 0x2, PseudoVSOXSEG2EI16_V_M4_M4_MASK }, // 232
  { 0x2, 0x1, 0x1, 0x4, 0x2, 0x3, PseudoVSOXSEG2EI16_V_M8_M4_MASK }, // 233
  { 0x2, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF8_MASK }, // 234
  { 0x2, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF4_MASK }, // 235
  { 0x2, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF4_MASK }, // 236
  { 0x2, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG2EI16_V_M1_MF2_MASK }, // 237
  { 0x2, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF2_MASK }, // 238
  { 0x2, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF2_MASK }, // 239
  { 0x2, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG2EI32_V_M1_M1_MASK }, // 240
  { 0x2, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG2EI32_V_M2_M1_MASK }, // 241
  { 0x2, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG2EI32_V_M4_M1_MASK }, // 242
  { 0x2, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG2EI32_V_MF2_M1_MASK }, // 243
  { 0x2, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVSOXSEG2EI32_V_M1_M2_MASK }, // 244
  { 0x2, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVSOXSEG2EI32_V_M2_M2_MASK }, // 245
  { 0x2, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVSOXSEG2EI32_V_M4_M2_MASK }, // 246
  { 0x2, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVSOXSEG2EI32_V_M8_M2_MASK }, // 247
  { 0x2, 0x1, 0x1, 0x5, 0x2, 0x1, PseudoVSOXSEG2EI32_V_M2_M4_MASK }, // 248
  { 0x2, 0x1, 0x1, 0x5, 0x2, 0x2, PseudoVSOXSEG2EI32_V_M4_M4_MASK }, // 249
  { 0x2, 0x1, 0x1, 0x5, 0x2, 0x3, PseudoVSOXSEG2EI32_V_M8_M4_MASK }, // 250
  { 0x2, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF8_MASK }, // 251
  { 0x2, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG2EI32_V_M1_MF4_MASK }, // 252
  { 0x2, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF4_MASK }, // 253
  { 0x2, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG2EI32_V_M1_MF2_MASK }, // 254
  { 0x2, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG2EI32_V_M2_MF2_MASK }, // 255
  { 0x2, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF2_MASK }, // 256
  { 0x2, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG2EI64_V_M1_M1_MASK }, // 257
  { 0x2, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG2EI64_V_M2_M1_MASK }, // 258
  { 0x2, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG2EI64_V_M4_M1_MASK }, // 259
  { 0x2, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG2EI64_V_M8_M1_MASK }, // 260
  { 0x2, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVSOXSEG2EI64_V_M2_M2_MASK }, // 261
  { 0x2, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVSOXSEG2EI64_V_M4_M2_MASK }, // 262
  { 0x2, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVSOXSEG2EI64_V_M8_M2_MASK }, // 263
  { 0x2, 0x1, 0x1, 0x6, 0x2, 0x2, PseudoVSOXSEG2EI64_V_M4_M4_MASK }, // 264
  { 0x2, 0x1, 0x1, 0x6, 0x2, 0x3, PseudoVSOXSEG2EI64_V_M8_M4_MASK }, // 265
  { 0x2, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG2EI64_V_M1_MF8_MASK }, // 266
  { 0x2, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG2EI64_V_M1_MF4_MASK }, // 267
  { 0x2, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG2EI64_V_M2_MF4_MASK }, // 268
  { 0x2, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG2EI64_V_M1_MF2_MASK }, // 269
  { 0x2, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG2EI64_V_M2_MF2_MASK }, // 270
  { 0x2, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG2EI64_V_M4_MF2_MASK }, // 271
  { 0x3, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG3EI8_V_M1_M1 }, // 272
  { 0x3, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG3EI8_V_MF8_M1 }, // 273
  { 0x3, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG3EI8_V_MF4_M1 }, // 274
  { 0x3, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG3EI8_V_MF2_M1 }, // 275
  { 0x3, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVSUXSEG3EI8_V_M1_M2 }, // 276
  { 0x3, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVSUXSEG3EI8_V_M2_M2 }, // 277
  { 0x3, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVSUXSEG3EI8_V_MF4_M2 }, // 278
  { 0x3, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVSUXSEG3EI8_V_MF2_M2 }, // 279
  { 0x3, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF8 }, // 280
  { 0x3, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF4 }, // 281
  { 0x3, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF4 }, // 282
  { 0x3, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF2 }, // 283
  { 0x3, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF2 }, // 284
  { 0x3, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF2 }, // 285
  { 0x3, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG3EI16_V_M1_M1 }, // 286
  { 0x3, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG3EI16_V_M2_M1 }, // 287
  { 0x3, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG3EI16_V_MF4_M1 }, // 288
  { 0x3, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG3EI16_V_MF2_M1 }, // 289
  { 0x3, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVSUXSEG3EI16_V_M1_M2 }, // 290
  { 0x3, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVSUXSEG3EI16_V_M2_M2 }, // 291
  { 0x3, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVSUXSEG3EI16_V_M4_M2 }, // 292
  { 0x3, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVSUXSEG3EI16_V_MF2_M2 }, // 293
  { 0x3, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF8 }, // 294
  { 0x3, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF4 }, // 295
  { 0x3, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF4 }, // 296
  { 0x3, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG3EI16_V_M1_MF2 }, // 297
  { 0x3, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF2 }, // 298
  { 0x3, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF2 }, // 299
  { 0x3, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG3EI32_V_M1_M1 }, // 300
  { 0x3, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG3EI32_V_M2_M1 }, // 301
  { 0x3, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG3EI32_V_M4_M1 }, // 302
  { 0x3, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG3EI32_V_MF2_M1 }, // 303
  { 0x3, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVSUXSEG3EI32_V_M1_M2 }, // 304
  { 0x3, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVSUXSEG3EI32_V_M2_M2 }, // 305
  { 0x3, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVSUXSEG3EI32_V_M4_M2 }, // 306
  { 0x3, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVSUXSEG3EI32_V_M8_M2 }, // 307
  { 0x3, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF8 }, // 308
  { 0x3, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG3EI32_V_M1_MF4 }, // 309
  { 0x3, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF4 }, // 310
  { 0x3, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG3EI32_V_M1_MF2 }, // 311
  { 0x3, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG3EI32_V_M2_MF2 }, // 312
  { 0x3, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF2 }, // 313
  { 0x3, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG3EI64_V_M1_M1 }, // 314
  { 0x3, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG3EI64_V_M2_M1 }, // 315
  { 0x3, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG3EI64_V_M4_M1 }, // 316
  { 0x3, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG3EI64_V_M8_M1 }, // 317
  { 0x3, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVSUXSEG3EI64_V_M2_M2 }, // 318
  { 0x3, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVSUXSEG3EI64_V_M4_M2 }, // 319
  { 0x3, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVSUXSEG3EI64_V_M8_M2 }, // 320
  { 0x3, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG3EI64_V_M1_MF8 }, // 321
  { 0x3, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG3EI64_V_M1_MF4 }, // 322
  { 0x3, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG3EI64_V_M2_MF4 }, // 323
  { 0x3, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG3EI64_V_M1_MF2 }, // 324
  { 0x3, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG3EI64_V_M2_MF2 }, // 325
  { 0x3, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG3EI64_V_M4_MF2 }, // 326
  { 0x3, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG3EI8_V_M1_M1 }, // 327
  { 0x3, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG3EI8_V_MF8_M1 }, // 328
  { 0x3, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG3EI8_V_MF4_M1 }, // 329
  { 0x3, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG3EI8_V_MF2_M1 }, // 330
  { 0x3, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVSOXSEG3EI8_V_M1_M2 }, // 331
  { 0x3, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVSOXSEG3EI8_V_M2_M2 }, // 332
  { 0x3, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVSOXSEG3EI8_V_MF4_M2 }, // 333
  { 0x3, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVSOXSEG3EI8_V_MF2_M2 }, // 334
  { 0x3, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF8 }, // 335
  { 0x3, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF4 }, // 336
  { 0x3, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF4 }, // 337
  { 0x3, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF2 }, // 338
  { 0x3, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF2 }, // 339
  { 0x3, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF2 }, // 340
  { 0x3, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG3EI16_V_M1_M1 }, // 341
  { 0x3, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG3EI16_V_M2_M1 }, // 342
  { 0x3, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG3EI16_V_MF4_M1 }, // 343
  { 0x3, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG3EI16_V_MF2_M1 }, // 344
  { 0x3, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVSOXSEG3EI16_V_M1_M2 }, // 345
  { 0x3, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVSOXSEG3EI16_V_M2_M2 }, // 346
  { 0x3, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVSOXSEG3EI16_V_M4_M2 }, // 347
  { 0x3, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVSOXSEG3EI16_V_MF2_M2 }, // 348
  { 0x3, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF8 }, // 349
  { 0x3, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF4 }, // 350
  { 0x3, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF4 }, // 351
  { 0x3, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG3EI16_V_M1_MF2 }, // 352
  { 0x3, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF2 }, // 353
  { 0x3, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF2 }, // 354
  { 0x3, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG3EI32_V_M1_M1 }, // 355
  { 0x3, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG3EI32_V_M2_M1 }, // 356
  { 0x3, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG3EI32_V_M4_M1 }, // 357
  { 0x3, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG3EI32_V_MF2_M1 }, // 358
  { 0x3, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVSOXSEG3EI32_V_M1_M2 }, // 359
  { 0x3, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVSOXSEG3EI32_V_M2_M2 }, // 360
  { 0x3, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVSOXSEG3EI32_V_M4_M2 }, // 361
  { 0x3, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVSOXSEG3EI32_V_M8_M2 }, // 362
  { 0x3, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF8 }, // 363
  { 0x3, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG3EI32_V_M1_MF4 }, // 364
  { 0x3, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF4 }, // 365
  { 0x3, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG3EI32_V_M1_MF2 }, // 366
  { 0x3, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG3EI32_V_M2_MF2 }, // 367
  { 0x3, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF2 }, // 368
  { 0x3, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG3EI64_V_M1_M1 }, // 369
  { 0x3, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG3EI64_V_M2_M1 }, // 370
  { 0x3, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG3EI64_V_M4_M1 }, // 371
  { 0x3, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG3EI64_V_M8_M1 }, // 372
  { 0x3, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVSOXSEG3EI64_V_M2_M2 }, // 373
  { 0x3, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVSOXSEG3EI64_V_M4_M2 }, // 374
  { 0x3, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVSOXSEG3EI64_V_M8_M2 }, // 375
  { 0x3, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG3EI64_V_M1_MF8 }, // 376
  { 0x3, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG3EI64_V_M1_MF4 }, // 377
  { 0x3, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG3EI64_V_M2_MF4 }, // 378
  { 0x3, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG3EI64_V_M1_MF2 }, // 379
  { 0x3, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG3EI64_V_M2_MF2 }, // 380
  { 0x3, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG3EI64_V_M4_MF2 }, // 381
  { 0x3, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG3EI8_V_M1_M1_MASK }, // 382
  { 0x3, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG3EI8_V_MF8_M1_MASK }, // 383
  { 0x3, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG3EI8_V_MF4_M1_MASK }, // 384
  { 0x3, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG3EI8_V_MF2_M1_MASK }, // 385
  { 0x3, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVSUXSEG3EI8_V_M1_M2_MASK }, // 386
  { 0x3, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVSUXSEG3EI8_V_M2_M2_MASK }, // 387
  { 0x3, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVSUXSEG3EI8_V_MF4_M2_MASK }, // 388
  { 0x3, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVSUXSEG3EI8_V_MF2_M2_MASK }, // 389
  { 0x3, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF8_MASK }, // 390
  { 0x3, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF4_MASK }, // 391
  { 0x3, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF4_MASK }, // 392
  { 0x3, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF2_MASK }, // 393
  { 0x3, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF2_MASK }, // 394
  { 0x3, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF2_MASK }, // 395
  { 0x3, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG3EI16_V_M1_M1_MASK }, // 396
  { 0x3, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG3EI16_V_M2_M1_MASK }, // 397
  { 0x3, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG3EI16_V_MF4_M1_MASK }, // 398
  { 0x3, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG3EI16_V_MF2_M1_MASK }, // 399
  { 0x3, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVSUXSEG3EI16_V_M1_M2_MASK }, // 400
  { 0x3, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVSUXSEG3EI16_V_M2_M2_MASK }, // 401
  { 0x3, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVSUXSEG3EI16_V_M4_M2_MASK }, // 402
  { 0x3, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVSUXSEG3EI16_V_MF2_M2_MASK }, // 403
  { 0x3, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF8_MASK }, // 404
  { 0x3, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF4_MASK }, // 405
  { 0x3, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF4_MASK }, // 406
  { 0x3, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG3EI16_V_M1_MF2_MASK }, // 407
  { 0x3, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF2_MASK }, // 408
  { 0x3, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF2_MASK }, // 409
  { 0x3, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG3EI32_V_M1_M1_MASK }, // 410
  { 0x3, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG3EI32_V_M2_M1_MASK }, // 411
  { 0x3, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG3EI32_V_M4_M1_MASK }, // 412
  { 0x3, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG3EI32_V_MF2_M1_MASK }, // 413
  { 0x3, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVSUXSEG3EI32_V_M1_M2_MASK }, // 414
  { 0x3, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVSUXSEG3EI32_V_M2_M2_MASK }, // 415
  { 0x3, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVSUXSEG3EI32_V_M4_M2_MASK }, // 416
  { 0x3, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVSUXSEG3EI32_V_M8_M2_MASK }, // 417
  { 0x3, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF8_MASK }, // 418
  { 0x3, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG3EI32_V_M1_MF4_MASK }, // 419
  { 0x3, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF4_MASK }, // 420
  { 0x3, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG3EI32_V_M1_MF2_MASK }, // 421
  { 0x3, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG3EI32_V_M2_MF2_MASK }, // 422
  { 0x3, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF2_MASK }, // 423
  { 0x3, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG3EI64_V_M1_M1_MASK }, // 424
  { 0x3, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG3EI64_V_M2_M1_MASK }, // 425
  { 0x3, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG3EI64_V_M4_M1_MASK }, // 426
  { 0x3, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG3EI64_V_M8_M1_MASK }, // 427
  { 0x3, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVSUXSEG3EI64_V_M2_M2_MASK }, // 428
  { 0x3, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVSUXSEG3EI64_V_M4_M2_MASK }, // 429
  { 0x3, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVSUXSEG3EI64_V_M8_M2_MASK }, // 430
  { 0x3, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG3EI64_V_M1_MF8_MASK }, // 431
  { 0x3, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG3EI64_V_M1_MF4_MASK }, // 432
  { 0x3, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG3EI64_V_M2_MF4_MASK }, // 433
  { 0x3, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG3EI64_V_M1_MF2_MASK }, // 434
  { 0x3, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG3EI64_V_M2_MF2_MASK }, // 435
  { 0x3, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG3EI64_V_M4_MF2_MASK }, // 436
  { 0x3, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG3EI8_V_M1_M1_MASK }, // 437
  { 0x3, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG3EI8_V_MF8_M1_MASK }, // 438
  { 0x3, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG3EI8_V_MF4_M1_MASK }, // 439
  { 0x3, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG3EI8_V_MF2_M1_MASK }, // 440
  { 0x3, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVSOXSEG3EI8_V_M1_M2_MASK }, // 441
  { 0x3, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVSOXSEG3EI8_V_M2_M2_MASK }, // 442
  { 0x3, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVSOXSEG3EI8_V_MF4_M2_MASK }, // 443
  { 0x3, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVSOXSEG3EI8_V_MF2_M2_MASK }, // 444
  { 0x3, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF8_MASK }, // 445
  { 0x3, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF4_MASK }, // 446
  { 0x3, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF4_MASK }, // 447
  { 0x3, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF2_MASK }, // 448
  { 0x3, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF2_MASK }, // 449
  { 0x3, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF2_MASK }, // 450
  { 0x3, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG3EI16_V_M1_M1_MASK }, // 451
  { 0x3, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG3EI16_V_M2_M1_MASK }, // 452
  { 0x3, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG3EI16_V_MF4_M1_MASK }, // 453
  { 0x3, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG3EI16_V_MF2_M1_MASK }, // 454
  { 0x3, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVSOXSEG3EI16_V_M1_M2_MASK }, // 455
  { 0x3, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVSOXSEG3EI16_V_M2_M2_MASK }, // 456
  { 0x3, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVSOXSEG3EI16_V_M4_M2_MASK }, // 457
  { 0x3, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVSOXSEG3EI16_V_MF2_M2_MASK }, // 458
  { 0x3, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF8_MASK }, // 459
  { 0x3, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF4_MASK }, // 460
  { 0x3, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF4_MASK }, // 461
  { 0x3, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG3EI16_V_M1_MF2_MASK }, // 462
  { 0x3, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF2_MASK }, // 463
  { 0x3, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF2_MASK }, // 464
  { 0x3, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG3EI32_V_M1_M1_MASK }, // 465
  { 0x3, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG3EI32_V_M2_M1_MASK }, // 466
  { 0x3, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG3EI32_V_M4_M1_MASK }, // 467
  { 0x3, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG3EI32_V_MF2_M1_MASK }, // 468
  { 0x3, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVSOXSEG3EI32_V_M1_M2_MASK }, // 469
  { 0x3, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVSOXSEG3EI32_V_M2_M2_MASK }, // 470
  { 0x3, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVSOXSEG3EI32_V_M4_M2_MASK }, // 471
  { 0x3, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVSOXSEG3EI32_V_M8_M2_MASK }, // 472
  { 0x3, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF8_MASK }, // 473
  { 0x3, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG3EI32_V_M1_MF4_MASK }, // 474
  { 0x3, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF4_MASK }, // 475
  { 0x3, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG3EI32_V_M1_MF2_MASK }, // 476
  { 0x3, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG3EI32_V_M2_MF2_MASK }, // 477
  { 0x3, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF2_MASK }, // 478
  { 0x3, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG3EI64_V_M1_M1_MASK }, // 479
  { 0x3, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG3EI64_V_M2_M1_MASK }, // 480
  { 0x3, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG3EI64_V_M4_M1_MASK }, // 481
  { 0x3, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG3EI64_V_M8_M1_MASK }, // 482
  { 0x3, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVSOXSEG3EI64_V_M2_M2_MASK }, // 483
  { 0x3, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVSOXSEG3EI64_V_M4_M2_MASK }, // 484
  { 0x3, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVSOXSEG3EI64_V_M8_M2_MASK }, // 485
  { 0x3, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG3EI64_V_M1_MF8_MASK }, // 486
  { 0x3, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG3EI64_V_M1_MF4_MASK }, // 487
  { 0x3, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG3EI64_V_M2_MF4_MASK }, // 488
  { 0x3, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG3EI64_V_M1_MF2_MASK }, // 489
  { 0x3, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG3EI64_V_M2_MF2_MASK }, // 490
  { 0x3, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG3EI64_V_M4_MF2_MASK }, // 491
  { 0x4, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG4EI8_V_M1_M1 }, // 492
  { 0x4, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG4EI8_V_MF8_M1 }, // 493
  { 0x4, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG4EI8_V_MF4_M1 }, // 494
  { 0x4, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG4EI8_V_MF2_M1 }, // 495
  { 0x4, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVSUXSEG4EI8_V_M1_M2 }, // 496
  { 0x4, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVSUXSEG4EI8_V_M2_M2 }, // 497
  { 0x4, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVSUXSEG4EI8_V_MF4_M2 }, // 498
  { 0x4, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVSUXSEG4EI8_V_MF2_M2 }, // 499
  { 0x4, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF8 }, // 500
  { 0x4, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF4 }, // 501
  { 0x4, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF4 }, // 502
  { 0x4, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF2 }, // 503
  { 0x4, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF2 }, // 504
  { 0x4, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF2 }, // 505
  { 0x4, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG4EI16_V_M1_M1 }, // 506
  { 0x4, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG4EI16_V_M2_M1 }, // 507
  { 0x4, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG4EI16_V_MF4_M1 }, // 508
  { 0x4, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG4EI16_V_MF2_M1 }, // 509
  { 0x4, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVSUXSEG4EI16_V_M1_M2 }, // 510
  { 0x4, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVSUXSEG4EI16_V_M2_M2 }, // 511
  { 0x4, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVSUXSEG4EI16_V_M4_M2 }, // 512
  { 0x4, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVSUXSEG4EI16_V_MF2_M2 }, // 513
  { 0x4, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF8 }, // 514
  { 0x4, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF4 }, // 515
  { 0x4, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF4 }, // 516
  { 0x4, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG4EI16_V_M1_MF2 }, // 517
  { 0x4, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF2 }, // 518
  { 0x4, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF2 }, // 519
  { 0x4, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG4EI32_V_M1_M1 }, // 520
  { 0x4, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG4EI32_V_M2_M1 }, // 521
  { 0x4, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG4EI32_V_M4_M1 }, // 522
  { 0x4, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG4EI32_V_MF2_M1 }, // 523
  { 0x4, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVSUXSEG4EI32_V_M1_M2 }, // 524
  { 0x4, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVSUXSEG4EI32_V_M2_M2 }, // 525
  { 0x4, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVSUXSEG4EI32_V_M4_M2 }, // 526
  { 0x4, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVSUXSEG4EI32_V_M8_M2 }, // 527
  { 0x4, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF8 }, // 528
  { 0x4, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG4EI32_V_M1_MF4 }, // 529
  { 0x4, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF4 }, // 530
  { 0x4, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG4EI32_V_M1_MF2 }, // 531
  { 0x4, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG4EI32_V_M2_MF2 }, // 532
  { 0x4, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF2 }, // 533
  { 0x4, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG4EI64_V_M1_M1 }, // 534
  { 0x4, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG4EI64_V_M2_M1 }, // 535
  { 0x4, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG4EI64_V_M4_M1 }, // 536
  { 0x4, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG4EI64_V_M8_M1 }, // 537
  { 0x4, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVSUXSEG4EI64_V_M2_M2 }, // 538
  { 0x4, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVSUXSEG4EI64_V_M4_M2 }, // 539
  { 0x4, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVSUXSEG4EI64_V_M8_M2 }, // 540
  { 0x4, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG4EI64_V_M1_MF8 }, // 541
  { 0x4, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG4EI64_V_M1_MF4 }, // 542
  { 0x4, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG4EI64_V_M2_MF4 }, // 543
  { 0x4, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG4EI64_V_M1_MF2 }, // 544
  { 0x4, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG4EI64_V_M2_MF2 }, // 545
  { 0x4, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG4EI64_V_M4_MF2 }, // 546
  { 0x4, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG4EI8_V_M1_M1 }, // 547
  { 0x4, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG4EI8_V_MF8_M1 }, // 548
  { 0x4, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG4EI8_V_MF4_M1 }, // 549
  { 0x4, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG4EI8_V_MF2_M1 }, // 550
  { 0x4, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVSOXSEG4EI8_V_M1_M2 }, // 551
  { 0x4, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVSOXSEG4EI8_V_M2_M2 }, // 552
  { 0x4, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVSOXSEG4EI8_V_MF4_M2 }, // 553
  { 0x4, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVSOXSEG4EI8_V_MF2_M2 }, // 554
  { 0x4, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF8 }, // 555
  { 0x4, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF4 }, // 556
  { 0x4, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF4 }, // 557
  { 0x4, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF2 }, // 558
  { 0x4, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF2 }, // 559
  { 0x4, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF2 }, // 560
  { 0x4, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG4EI16_V_M1_M1 }, // 561
  { 0x4, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG4EI16_V_M2_M1 }, // 562
  { 0x4, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG4EI16_V_MF4_M1 }, // 563
  { 0x4, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG4EI16_V_MF2_M1 }, // 564
  { 0x4, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVSOXSEG4EI16_V_M1_M2 }, // 565
  { 0x4, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVSOXSEG4EI16_V_M2_M2 }, // 566
  { 0x4, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVSOXSEG4EI16_V_M4_M2 }, // 567
  { 0x4, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVSOXSEG4EI16_V_MF2_M2 }, // 568
  { 0x4, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF8 }, // 569
  { 0x4, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF4 }, // 570
  { 0x4, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF4 }, // 571
  { 0x4, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG4EI16_V_M1_MF2 }, // 572
  { 0x4, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF2 }, // 573
  { 0x4, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF2 }, // 574
  { 0x4, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG4EI32_V_M1_M1 }, // 575
  { 0x4, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG4EI32_V_M2_M1 }, // 576
  { 0x4, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG4EI32_V_M4_M1 }, // 577
  { 0x4, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG4EI32_V_MF2_M1 }, // 578
  { 0x4, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVSOXSEG4EI32_V_M1_M2 }, // 579
  { 0x4, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVSOXSEG4EI32_V_M2_M2 }, // 580
  { 0x4, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVSOXSEG4EI32_V_M4_M2 }, // 581
  { 0x4, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVSOXSEG4EI32_V_M8_M2 }, // 582
  { 0x4, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF8 }, // 583
  { 0x4, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG4EI32_V_M1_MF4 }, // 584
  { 0x4, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF4 }, // 585
  { 0x4, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG4EI32_V_M1_MF2 }, // 586
  { 0x4, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG4EI32_V_M2_MF2 }, // 587
  { 0x4, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF2 }, // 588
  { 0x4, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG4EI64_V_M1_M1 }, // 589
  { 0x4, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG4EI64_V_M2_M1 }, // 590
  { 0x4, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG4EI64_V_M4_M1 }, // 591
  { 0x4, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG4EI64_V_M8_M1 }, // 592
  { 0x4, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVSOXSEG4EI64_V_M2_M2 }, // 593
  { 0x4, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVSOXSEG4EI64_V_M4_M2 }, // 594
  { 0x4, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVSOXSEG4EI64_V_M8_M2 }, // 595
  { 0x4, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG4EI64_V_M1_MF8 }, // 596
  { 0x4, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG4EI64_V_M1_MF4 }, // 597
  { 0x4, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG4EI64_V_M2_MF4 }, // 598
  { 0x4, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG4EI64_V_M1_MF2 }, // 599
  { 0x4, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG4EI64_V_M2_MF2 }, // 600
  { 0x4, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG4EI64_V_M4_MF2 }, // 601
  { 0x4, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG4EI8_V_M1_M1_MASK }, // 602
  { 0x4, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG4EI8_V_MF8_M1_MASK }, // 603
  { 0x4, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG4EI8_V_MF4_M1_MASK }, // 604
  { 0x4, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG4EI8_V_MF2_M1_MASK }, // 605
  { 0x4, 0x1, 0x0, 0x3, 0x1, 0x0, PseudoVSUXSEG4EI8_V_M1_M2_MASK }, // 606
  { 0x4, 0x1, 0x0, 0x3, 0x1, 0x1, PseudoVSUXSEG4EI8_V_M2_M2_MASK }, // 607
  { 0x4, 0x1, 0x0, 0x3, 0x1, 0x6, PseudoVSUXSEG4EI8_V_MF4_M2_MASK }, // 608
  { 0x4, 0x1, 0x0, 0x3, 0x1, 0x7, PseudoVSUXSEG4EI8_V_MF2_M2_MASK }, // 609
  { 0x4, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF8_MASK }, // 610
  { 0x4, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF4_MASK }, // 611
  { 0x4, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF4_MASK }, // 612
  { 0x4, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF2_MASK }, // 613
  { 0x4, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF2_MASK }, // 614
  { 0x4, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF2_MASK }, // 615
  { 0x4, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG4EI16_V_M1_M1_MASK }, // 616
  { 0x4, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG4EI16_V_M2_M1_MASK }, // 617
  { 0x4, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG4EI16_V_MF4_M1_MASK }, // 618
  { 0x4, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG4EI16_V_MF2_M1_MASK }, // 619
  { 0x4, 0x1, 0x0, 0x4, 0x1, 0x0, PseudoVSUXSEG4EI16_V_M1_M2_MASK }, // 620
  { 0x4, 0x1, 0x0, 0x4, 0x1, 0x1, PseudoVSUXSEG4EI16_V_M2_M2_MASK }, // 621
  { 0x4, 0x1, 0x0, 0x4, 0x1, 0x2, PseudoVSUXSEG4EI16_V_M4_M2_MASK }, // 622
  { 0x4, 0x1, 0x0, 0x4, 0x1, 0x7, PseudoVSUXSEG4EI16_V_MF2_M2_MASK }, // 623
  { 0x4, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF8_MASK }, // 624
  { 0x4, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF4_MASK }, // 625
  { 0x4, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF4_MASK }, // 626
  { 0x4, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG4EI16_V_M1_MF2_MASK }, // 627
  { 0x4, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF2_MASK }, // 628
  { 0x4, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF2_MASK }, // 629
  { 0x4, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG4EI32_V_M1_M1_MASK }, // 630
  { 0x4, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG4EI32_V_M2_M1_MASK }, // 631
  { 0x4, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG4EI32_V_M4_M1_MASK }, // 632
  { 0x4, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG4EI32_V_MF2_M1_MASK }, // 633
  { 0x4, 0x1, 0x0, 0x5, 0x1, 0x0, PseudoVSUXSEG4EI32_V_M1_M2_MASK }, // 634
  { 0x4, 0x1, 0x0, 0x5, 0x1, 0x1, PseudoVSUXSEG4EI32_V_M2_M2_MASK }, // 635
  { 0x4, 0x1, 0x0, 0x5, 0x1, 0x2, PseudoVSUXSEG4EI32_V_M4_M2_MASK }, // 636
  { 0x4, 0x1, 0x0, 0x5, 0x1, 0x3, PseudoVSUXSEG4EI32_V_M8_M2_MASK }, // 637
  { 0x4, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF8_MASK }, // 638
  { 0x4, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG4EI32_V_M1_MF4_MASK }, // 639
  { 0x4, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF4_MASK }, // 640
  { 0x4, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG4EI32_V_M1_MF2_MASK }, // 641
  { 0x4, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG4EI32_V_M2_MF2_MASK }, // 642
  { 0x4, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF2_MASK }, // 643
  { 0x4, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG4EI64_V_M1_M1_MASK }, // 644
  { 0x4, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG4EI64_V_M2_M1_MASK }, // 645
  { 0x4, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG4EI64_V_M4_M1_MASK }, // 646
  { 0x4, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG4EI64_V_M8_M1_MASK }, // 647
  { 0x4, 0x1, 0x0, 0x6, 0x1, 0x1, PseudoVSUXSEG4EI64_V_M2_M2_MASK }, // 648
  { 0x4, 0x1, 0x0, 0x6, 0x1, 0x2, PseudoVSUXSEG4EI64_V_M4_M2_MASK }, // 649
  { 0x4, 0x1, 0x0, 0x6, 0x1, 0x3, PseudoVSUXSEG4EI64_V_M8_M2_MASK }, // 650
  { 0x4, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG4EI64_V_M1_MF8_MASK }, // 651
  { 0x4, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG4EI64_V_M1_MF4_MASK }, // 652
  { 0x4, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG4EI64_V_M2_MF4_MASK }, // 653
  { 0x4, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG4EI64_V_M1_MF2_MASK }, // 654
  { 0x4, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG4EI64_V_M2_MF2_MASK }, // 655
  { 0x4, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG4EI64_V_M4_MF2_MASK }, // 656
  { 0x4, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG4EI8_V_M1_M1_MASK }, // 657
  { 0x4, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG4EI8_V_MF8_M1_MASK }, // 658
  { 0x4, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG4EI8_V_MF4_M1_MASK }, // 659
  { 0x4, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG4EI8_V_MF2_M1_MASK }, // 660
  { 0x4, 0x1, 0x1, 0x3, 0x1, 0x0, PseudoVSOXSEG4EI8_V_M1_M2_MASK }, // 661
  { 0x4, 0x1, 0x1, 0x3, 0x1, 0x1, PseudoVSOXSEG4EI8_V_M2_M2_MASK }, // 662
  { 0x4, 0x1, 0x1, 0x3, 0x1, 0x6, PseudoVSOXSEG4EI8_V_MF4_M2_MASK }, // 663
  { 0x4, 0x1, 0x1, 0x3, 0x1, 0x7, PseudoVSOXSEG4EI8_V_MF2_M2_MASK }, // 664
  { 0x4, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF8_MASK }, // 665
  { 0x4, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF4_MASK }, // 666
  { 0x4, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF4_MASK }, // 667
  { 0x4, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF2_MASK }, // 668
  { 0x4, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF2_MASK }, // 669
  { 0x4, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF2_MASK }, // 670
  { 0x4, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG4EI16_V_M1_M1_MASK }, // 671
  { 0x4, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG4EI16_V_M2_M1_MASK }, // 672
  { 0x4, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG4EI16_V_MF4_M1_MASK }, // 673
  { 0x4, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG4EI16_V_MF2_M1_MASK }, // 674
  { 0x4, 0x1, 0x1, 0x4, 0x1, 0x0, PseudoVSOXSEG4EI16_V_M1_M2_MASK }, // 675
  { 0x4, 0x1, 0x1, 0x4, 0x1, 0x1, PseudoVSOXSEG4EI16_V_M2_M2_MASK }, // 676
  { 0x4, 0x1, 0x1, 0x4, 0x1, 0x2, PseudoVSOXSEG4EI16_V_M4_M2_MASK }, // 677
  { 0x4, 0x1, 0x1, 0x4, 0x1, 0x7, PseudoVSOXSEG4EI16_V_MF2_M2_MASK }, // 678
  { 0x4, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF8_MASK }, // 679
  { 0x4, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF4_MASK }, // 680
  { 0x4, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF4_MASK }, // 681
  { 0x4, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG4EI16_V_M1_MF2_MASK }, // 682
  { 0x4, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF2_MASK }, // 683
  { 0x4, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF2_MASK }, // 684
  { 0x4, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG4EI32_V_M1_M1_MASK }, // 685
  { 0x4, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG4EI32_V_M2_M1_MASK }, // 686
  { 0x4, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG4EI32_V_M4_M1_MASK }, // 687
  { 0x4, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG4EI32_V_MF2_M1_MASK }, // 688
  { 0x4, 0x1, 0x1, 0x5, 0x1, 0x0, PseudoVSOXSEG4EI32_V_M1_M2_MASK }, // 689
  { 0x4, 0x1, 0x1, 0x5, 0x1, 0x1, PseudoVSOXSEG4EI32_V_M2_M2_MASK }, // 690
  { 0x4, 0x1, 0x1, 0x5, 0x1, 0x2, PseudoVSOXSEG4EI32_V_M4_M2_MASK }, // 691
  { 0x4, 0x1, 0x1, 0x5, 0x1, 0x3, PseudoVSOXSEG4EI32_V_M8_M2_MASK }, // 692
  { 0x4, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF8_MASK }, // 693
  { 0x4, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG4EI32_V_M1_MF4_MASK }, // 694
  { 0x4, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF4_MASK }, // 695
  { 0x4, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG4EI32_V_M1_MF2_MASK }, // 696
  { 0x4, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG4EI32_V_M2_MF2_MASK }, // 697
  { 0x4, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF2_MASK }, // 698
  { 0x4, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG4EI64_V_M1_M1_MASK }, // 699
  { 0x4, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG4EI64_V_M2_M1_MASK }, // 700
  { 0x4, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG4EI64_V_M4_M1_MASK }, // 701
  { 0x4, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG4EI64_V_M8_M1_MASK }, // 702
  { 0x4, 0x1, 0x1, 0x6, 0x1, 0x1, PseudoVSOXSEG4EI64_V_M2_M2_MASK }, // 703
  { 0x4, 0x1, 0x1, 0x6, 0x1, 0x2, PseudoVSOXSEG4EI64_V_M4_M2_MASK }, // 704
  { 0x4, 0x1, 0x1, 0x6, 0x1, 0x3, PseudoVSOXSEG4EI64_V_M8_M2_MASK }, // 705
  { 0x4, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG4EI64_V_M1_MF8_MASK }, // 706
  { 0x4, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG4EI64_V_M1_MF4_MASK }, // 707
  { 0x4, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG4EI64_V_M2_MF4_MASK }, // 708
  { 0x4, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG4EI64_V_M1_MF2_MASK }, // 709
  { 0x4, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG4EI64_V_M2_MF2_MASK }, // 710
  { 0x4, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG4EI64_V_M4_MF2_MASK }, // 711
  { 0x5, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG5EI8_V_M1_M1 }, // 712
  { 0x5, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG5EI8_V_MF8_M1 }, // 713
  { 0x5, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG5EI8_V_MF4_M1 }, // 714
  { 0x5, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG5EI8_V_MF2_M1 }, // 715
  { 0x5, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF8 }, // 716
  { 0x5, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF4 }, // 717
  { 0x5, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF4 }, // 718
  { 0x5, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF2 }, // 719
  { 0x5, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF2 }, // 720
  { 0x5, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF2 }, // 721
  { 0x5, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG5EI16_V_M1_M1 }, // 722
  { 0x5, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG5EI16_V_M2_M1 }, // 723
  { 0x5, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG5EI16_V_MF4_M1 }, // 724
  { 0x5, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG5EI16_V_MF2_M1 }, // 725
  { 0x5, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF8 }, // 726
  { 0x5, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF4 }, // 727
  { 0x5, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF4 }, // 728
  { 0x5, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG5EI16_V_M1_MF2 }, // 729
  { 0x5, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF2 }, // 730
  { 0x5, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF2 }, // 731
  { 0x5, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG5EI32_V_M1_M1 }, // 732
  { 0x5, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG5EI32_V_M2_M1 }, // 733
  { 0x5, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG5EI32_V_M4_M1 }, // 734
  { 0x5, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG5EI32_V_MF2_M1 }, // 735
  { 0x5, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF8 }, // 736
  { 0x5, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG5EI32_V_M1_MF4 }, // 737
  { 0x5, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF4 }, // 738
  { 0x5, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG5EI32_V_M1_MF2 }, // 739
  { 0x5, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG5EI32_V_M2_MF2 }, // 740
  { 0x5, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF2 }, // 741
  { 0x5, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG5EI64_V_M1_M1 }, // 742
  { 0x5, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG5EI64_V_M2_M1 }, // 743
  { 0x5, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG5EI64_V_M4_M1 }, // 744
  { 0x5, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG5EI64_V_M8_M1 }, // 745
  { 0x5, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG5EI64_V_M1_MF8 }, // 746
  { 0x5, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG5EI64_V_M1_MF4 }, // 747
  { 0x5, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG5EI64_V_M2_MF4 }, // 748
  { 0x5, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG5EI64_V_M1_MF2 }, // 749
  { 0x5, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG5EI64_V_M2_MF2 }, // 750
  { 0x5, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG5EI64_V_M4_MF2 }, // 751
  { 0x5, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG5EI8_V_M1_M1 }, // 752
  { 0x5, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG5EI8_V_MF8_M1 }, // 753
  { 0x5, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG5EI8_V_MF4_M1 }, // 754
  { 0x5, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG5EI8_V_MF2_M1 }, // 755
  { 0x5, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF8 }, // 756
  { 0x5, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF4 }, // 757
  { 0x5, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF4 }, // 758
  { 0x5, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF2 }, // 759
  { 0x5, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF2 }, // 760
  { 0x5, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF2 }, // 761
  { 0x5, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG5EI16_V_M1_M1 }, // 762
  { 0x5, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG5EI16_V_M2_M1 }, // 763
  { 0x5, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG5EI16_V_MF4_M1 }, // 764
  { 0x5, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG5EI16_V_MF2_M1 }, // 765
  { 0x5, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF8 }, // 766
  { 0x5, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF4 }, // 767
  { 0x5, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF4 }, // 768
  { 0x5, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG5EI16_V_M1_MF2 }, // 769
  { 0x5, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF2 }, // 770
  { 0x5, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF2 }, // 771
  { 0x5, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG5EI32_V_M1_M1 }, // 772
  { 0x5, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG5EI32_V_M2_M1 }, // 773
  { 0x5, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG5EI32_V_M4_M1 }, // 774
  { 0x5, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG5EI32_V_MF2_M1 }, // 775
  { 0x5, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF8 }, // 776
  { 0x5, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG5EI32_V_M1_MF4 }, // 777
  { 0x5, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF4 }, // 778
  { 0x5, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG5EI32_V_M1_MF2 }, // 779
  { 0x5, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG5EI32_V_M2_MF2 }, // 780
  { 0x5, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF2 }, // 781
  { 0x5, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG5EI64_V_M1_M1 }, // 782
  { 0x5, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG5EI64_V_M2_M1 }, // 783
  { 0x5, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG5EI64_V_M4_M1 }, // 784
  { 0x5, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG5EI64_V_M8_M1 }, // 785
  { 0x5, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG5EI64_V_M1_MF8 }, // 786
  { 0x5, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG5EI64_V_M1_MF4 }, // 787
  { 0x5, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG5EI64_V_M2_MF4 }, // 788
  { 0x5, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG5EI64_V_M1_MF2 }, // 789
  { 0x5, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG5EI64_V_M2_MF2 }, // 790
  { 0x5, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG5EI64_V_M4_MF2 }, // 791
  { 0x5, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG5EI8_V_M1_M1_MASK }, // 792
  { 0x5, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG5EI8_V_MF8_M1_MASK }, // 793
  { 0x5, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG5EI8_V_MF4_M1_MASK }, // 794
  { 0x5, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG5EI8_V_MF2_M1_MASK }, // 795
  { 0x5, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF8_MASK }, // 796
  { 0x5, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF4_MASK }, // 797
  { 0x5, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF4_MASK }, // 798
  { 0x5, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF2_MASK }, // 799
  { 0x5, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF2_MASK }, // 800
  { 0x5, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF2_MASK }, // 801
  { 0x5, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG5EI16_V_M1_M1_MASK }, // 802
  { 0x5, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG5EI16_V_M2_M1_MASK }, // 803
  { 0x5, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG5EI16_V_MF4_M1_MASK }, // 804
  { 0x5, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG5EI16_V_MF2_M1_MASK }, // 805
  { 0x5, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF8_MASK }, // 806
  { 0x5, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF4_MASK }, // 807
  { 0x5, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF4_MASK }, // 808
  { 0x5, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG5EI16_V_M1_MF2_MASK }, // 809
  { 0x5, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF2_MASK }, // 810
  { 0x5, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF2_MASK }, // 811
  { 0x5, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG5EI32_V_M1_M1_MASK }, // 812
  { 0x5, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG5EI32_V_M2_M1_MASK }, // 813
  { 0x5, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG5EI32_V_M4_M1_MASK }, // 814
  { 0x5, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG5EI32_V_MF2_M1_MASK }, // 815
  { 0x5, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF8_MASK }, // 816
  { 0x5, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG5EI32_V_M1_MF4_MASK }, // 817
  { 0x5, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF4_MASK }, // 818
  { 0x5, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG5EI32_V_M1_MF2_MASK }, // 819
  { 0x5, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG5EI32_V_M2_MF2_MASK }, // 820
  { 0x5, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF2_MASK }, // 821
  { 0x5, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG5EI64_V_M1_M1_MASK }, // 822
  { 0x5, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG5EI64_V_M2_M1_MASK }, // 823
  { 0x5, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG5EI64_V_M4_M1_MASK }, // 824
  { 0x5, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG5EI64_V_M8_M1_MASK }, // 825
  { 0x5, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG5EI64_V_M1_MF8_MASK }, // 826
  { 0x5, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG5EI64_V_M1_MF4_MASK }, // 827
  { 0x5, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG5EI64_V_M2_MF4_MASK }, // 828
  { 0x5, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG5EI64_V_M1_MF2_MASK }, // 829
  { 0x5, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG5EI64_V_M2_MF2_MASK }, // 830
  { 0x5, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG5EI64_V_M4_MF2_MASK }, // 831
  { 0x5, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG5EI8_V_M1_M1_MASK }, // 832
  { 0x5, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG5EI8_V_MF8_M1_MASK }, // 833
  { 0x5, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG5EI8_V_MF4_M1_MASK }, // 834
  { 0x5, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG5EI8_V_MF2_M1_MASK }, // 835
  { 0x5, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF8_MASK }, // 836
  { 0x5, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF4_MASK }, // 837
  { 0x5, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF4_MASK }, // 838
  { 0x5, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF2_MASK }, // 839
  { 0x5, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF2_MASK }, // 840
  { 0x5, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF2_MASK }, // 841
  { 0x5, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG5EI16_V_M1_M1_MASK }, // 842
  { 0x5, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG5EI16_V_M2_M1_MASK }, // 843
  { 0x5, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG5EI16_V_MF4_M1_MASK }, // 844
  { 0x5, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG5EI16_V_MF2_M1_MASK }, // 845
  { 0x5, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF8_MASK }, // 846
  { 0x5, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF4_MASK }, // 847
  { 0x5, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF4_MASK }, // 848
  { 0x5, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG5EI16_V_M1_MF2_MASK }, // 849
  { 0x5, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF2_MASK }, // 850
  { 0x5, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF2_MASK }, // 851
  { 0x5, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG5EI32_V_M1_M1_MASK }, // 852
  { 0x5, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG5EI32_V_M2_M1_MASK }, // 853
  { 0x5, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG5EI32_V_M4_M1_MASK }, // 854
  { 0x5, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG5EI32_V_MF2_M1_MASK }, // 855
  { 0x5, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF8_MASK }, // 856
  { 0x5, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG5EI32_V_M1_MF4_MASK }, // 857
  { 0x5, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF4_MASK }, // 858
  { 0x5, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG5EI32_V_M1_MF2_MASK }, // 859
  { 0x5, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG5EI32_V_M2_MF2_MASK }, // 860
  { 0x5, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF2_MASK }, // 861
  { 0x5, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG5EI64_V_M1_M1_MASK }, // 862
  { 0x5, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG5EI64_V_M2_M1_MASK }, // 863
  { 0x5, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG5EI64_V_M4_M1_MASK }, // 864
  { 0x5, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG5EI64_V_M8_M1_MASK }, // 865
  { 0x5, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG5EI64_V_M1_MF8_MASK }, // 866
  { 0x5, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG5EI64_V_M1_MF4_MASK }, // 867
  { 0x5, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG5EI64_V_M2_MF4_MASK }, // 868
  { 0x5, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG5EI64_V_M1_MF2_MASK }, // 869
  { 0x5, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG5EI64_V_M2_MF2_MASK }, // 870
  { 0x5, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG5EI64_V_M4_MF2_MASK }, // 871
  { 0x6, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG6EI8_V_M1_M1 }, // 872
  { 0x6, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG6EI8_V_MF8_M1 }, // 873
  { 0x6, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG6EI8_V_MF4_M1 }, // 874
  { 0x6, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG6EI8_V_MF2_M1 }, // 875
  { 0x6, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF8 }, // 876
  { 0x6, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF4 }, // 877
  { 0x6, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF4 }, // 878
  { 0x6, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF2 }, // 879
  { 0x6, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF2 }, // 880
  { 0x6, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF2 }, // 881
  { 0x6, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG6EI16_V_M1_M1 }, // 882
  { 0x6, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG6EI16_V_M2_M1 }, // 883
  { 0x6, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG6EI16_V_MF4_M1 }, // 884
  { 0x6, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG6EI16_V_MF2_M1 }, // 885
  { 0x6, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF8 }, // 886
  { 0x6, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF4 }, // 887
  { 0x6, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF4 }, // 888
  { 0x6, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG6EI16_V_M1_MF2 }, // 889
  { 0x6, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF2 }, // 890
  { 0x6, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF2 }, // 891
  { 0x6, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG6EI32_V_M1_M1 }, // 892
  { 0x6, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG6EI32_V_M2_M1 }, // 893
  { 0x6, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG6EI32_V_M4_M1 }, // 894
  { 0x6, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG6EI32_V_MF2_M1 }, // 895
  { 0x6, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF8 }, // 896
  { 0x6, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG6EI32_V_M1_MF4 }, // 897
  { 0x6, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF4 }, // 898
  { 0x6, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG6EI32_V_M1_MF2 }, // 899
  { 0x6, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG6EI32_V_M2_MF2 }, // 900
  { 0x6, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF2 }, // 901
  { 0x6, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG6EI64_V_M1_M1 }, // 902
  { 0x6, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG6EI64_V_M2_M1 }, // 903
  { 0x6, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG6EI64_V_M4_M1 }, // 904
  { 0x6, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG6EI64_V_M8_M1 }, // 905
  { 0x6, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG6EI64_V_M1_MF8 }, // 906
  { 0x6, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG6EI64_V_M1_MF4 }, // 907
  { 0x6, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG6EI64_V_M2_MF4 }, // 908
  { 0x6, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG6EI64_V_M1_MF2 }, // 909
  { 0x6, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG6EI64_V_M2_MF2 }, // 910
  { 0x6, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG6EI64_V_M4_MF2 }, // 911
  { 0x6, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG6EI8_V_M1_M1 }, // 912
  { 0x6, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG6EI8_V_MF8_M1 }, // 913
  { 0x6, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG6EI8_V_MF4_M1 }, // 914
  { 0x6, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG6EI8_V_MF2_M1 }, // 915
  { 0x6, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF8 }, // 916
  { 0x6, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF4 }, // 917
  { 0x6, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF4 }, // 918
  { 0x6, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF2 }, // 919
  { 0x6, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF2 }, // 920
  { 0x6, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF2 }, // 921
  { 0x6, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG6EI16_V_M1_M1 }, // 922
  { 0x6, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG6EI16_V_M2_M1 }, // 923
  { 0x6, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG6EI16_V_MF4_M1 }, // 924
  { 0x6, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG6EI16_V_MF2_M1 }, // 925
  { 0x6, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF8 }, // 926
  { 0x6, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF4 }, // 927
  { 0x6, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF4 }, // 928
  { 0x6, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG6EI16_V_M1_MF2 }, // 929
  { 0x6, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF2 }, // 930
  { 0x6, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF2 }, // 931
  { 0x6, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG6EI32_V_M1_M1 }, // 932
  { 0x6, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG6EI32_V_M2_M1 }, // 933
  { 0x6, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG6EI32_V_M4_M1 }, // 934
  { 0x6, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG6EI32_V_MF2_M1 }, // 935
  { 0x6, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF8 }, // 936
  { 0x6, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG6EI32_V_M1_MF4 }, // 937
  { 0x6, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF4 }, // 938
  { 0x6, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG6EI32_V_M1_MF2 }, // 939
  { 0x6, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG6EI32_V_M2_MF2 }, // 940
  { 0x6, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF2 }, // 941
  { 0x6, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG6EI64_V_M1_M1 }, // 942
  { 0x6, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG6EI64_V_M2_M1 }, // 943
  { 0x6, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG6EI64_V_M4_M1 }, // 944
  { 0x6, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG6EI64_V_M8_M1 }, // 945
  { 0x6, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG6EI64_V_M1_MF8 }, // 946
  { 0x6, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG6EI64_V_M1_MF4 }, // 947
  { 0x6, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG6EI64_V_M2_MF4 }, // 948
  { 0x6, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG6EI64_V_M1_MF2 }, // 949
  { 0x6, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG6EI64_V_M2_MF2 }, // 950
  { 0x6, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG6EI64_V_M4_MF2 }, // 951
  { 0x6, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG6EI8_V_M1_M1_MASK }, // 952
  { 0x6, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG6EI8_V_MF8_M1_MASK }, // 953
  { 0x6, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG6EI8_V_MF4_M1_MASK }, // 954
  { 0x6, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG6EI8_V_MF2_M1_MASK }, // 955
  { 0x6, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF8_MASK }, // 956
  { 0x6, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF4_MASK }, // 957
  { 0x6, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF4_MASK }, // 958
  { 0x6, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF2_MASK }, // 959
  { 0x6, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF2_MASK }, // 960
  { 0x6, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF2_MASK }, // 961
  { 0x6, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG6EI16_V_M1_M1_MASK }, // 962
  { 0x6, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG6EI16_V_M2_M1_MASK }, // 963
  { 0x6, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG6EI16_V_MF4_M1_MASK }, // 964
  { 0x6, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG6EI16_V_MF2_M1_MASK }, // 965
  { 0x6, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF8_MASK }, // 966
  { 0x6, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF4_MASK }, // 967
  { 0x6, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF4_MASK }, // 968
  { 0x6, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG6EI16_V_M1_MF2_MASK }, // 969
  { 0x6, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF2_MASK }, // 970
  { 0x6, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF2_MASK }, // 971
  { 0x6, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG6EI32_V_M1_M1_MASK }, // 972
  { 0x6, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG6EI32_V_M2_M1_MASK }, // 973
  { 0x6, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG6EI32_V_M4_M1_MASK }, // 974
  { 0x6, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG6EI32_V_MF2_M1_MASK }, // 975
  { 0x6, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF8_MASK }, // 976
  { 0x6, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG6EI32_V_M1_MF4_MASK }, // 977
  { 0x6, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF4_MASK }, // 978
  { 0x6, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG6EI32_V_M1_MF2_MASK }, // 979
  { 0x6, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG6EI32_V_M2_MF2_MASK }, // 980
  { 0x6, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF2_MASK }, // 981
  { 0x6, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG6EI64_V_M1_M1_MASK }, // 982
  { 0x6, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG6EI64_V_M2_M1_MASK }, // 983
  { 0x6, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG6EI64_V_M4_M1_MASK }, // 984
  { 0x6, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG6EI64_V_M8_M1_MASK }, // 985
  { 0x6, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG6EI64_V_M1_MF8_MASK }, // 986
  { 0x6, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG6EI64_V_M1_MF4_MASK }, // 987
  { 0x6, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG6EI64_V_M2_MF4_MASK }, // 988
  { 0x6, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG6EI64_V_M1_MF2_MASK }, // 989
  { 0x6, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG6EI64_V_M2_MF2_MASK }, // 990
  { 0x6, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG6EI64_V_M4_MF2_MASK }, // 991
  { 0x6, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG6EI8_V_M1_M1_MASK }, // 992
  { 0x6, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG6EI8_V_MF8_M1_MASK }, // 993
  { 0x6, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG6EI8_V_MF4_M1_MASK }, // 994
  { 0x6, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG6EI8_V_MF2_M1_MASK }, // 995
  { 0x6, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF8_MASK }, // 996
  { 0x6, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF4_MASK }, // 997
  { 0x6, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF4_MASK }, // 998
  { 0x6, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF2_MASK }, // 999
  { 0x6, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF2_MASK }, // 1000
  { 0x6, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF2_MASK }, // 1001
  { 0x6, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG6EI16_V_M1_M1_MASK }, // 1002
  { 0x6, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG6EI16_V_M2_M1_MASK }, // 1003
  { 0x6, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG6EI16_V_MF4_M1_MASK }, // 1004
  { 0x6, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG6EI16_V_MF2_M1_MASK }, // 1005
  { 0x6, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF8_MASK }, // 1006
  { 0x6, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF4_MASK }, // 1007
  { 0x6, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF4_MASK }, // 1008
  { 0x6, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG6EI16_V_M1_MF2_MASK }, // 1009
  { 0x6, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF2_MASK }, // 1010
  { 0x6, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF2_MASK }, // 1011
  { 0x6, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG6EI32_V_M1_M1_MASK }, // 1012
  { 0x6, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG6EI32_V_M2_M1_MASK }, // 1013
  { 0x6, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG6EI32_V_M4_M1_MASK }, // 1014
  { 0x6, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG6EI32_V_MF2_M1_MASK }, // 1015
  { 0x6, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF8_MASK }, // 1016
  { 0x6, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG6EI32_V_M1_MF4_MASK }, // 1017
  { 0x6, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF4_MASK }, // 1018
  { 0x6, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG6EI32_V_M1_MF2_MASK }, // 1019
  { 0x6, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG6EI32_V_M2_MF2_MASK }, // 1020
  { 0x6, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF2_MASK }, // 1021
  { 0x6, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG6EI64_V_M1_M1_MASK }, // 1022
  { 0x6, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG6EI64_V_M2_M1_MASK }, // 1023
  { 0x6, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG6EI64_V_M4_M1_MASK }, // 1024
  { 0x6, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG6EI64_V_M8_M1_MASK }, // 1025
  { 0x6, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG6EI64_V_M1_MF8_MASK }, // 1026
  { 0x6, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG6EI64_V_M1_MF4_MASK }, // 1027
  { 0x6, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG6EI64_V_M2_MF4_MASK }, // 1028
  { 0x6, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG6EI64_V_M1_MF2_MASK }, // 1029
  { 0x6, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG6EI64_V_M2_MF2_MASK }, // 1030
  { 0x6, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG6EI64_V_M4_MF2_MASK }, // 1031
  { 0x7, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG7EI8_V_M1_M1 }, // 1032
  { 0x7, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG7EI8_V_MF8_M1 }, // 1033
  { 0x7, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG7EI8_V_MF4_M1 }, // 1034
  { 0x7, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG7EI8_V_MF2_M1 }, // 1035
  { 0x7, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF8 }, // 1036
  { 0x7, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF4 }, // 1037
  { 0x7, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF4 }, // 1038
  { 0x7, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF2 }, // 1039
  { 0x7, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF2 }, // 1040
  { 0x7, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF2 }, // 1041
  { 0x7, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG7EI16_V_M1_M1 }, // 1042
  { 0x7, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG7EI16_V_M2_M1 }, // 1043
  { 0x7, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG7EI16_V_MF4_M1 }, // 1044
  { 0x7, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG7EI16_V_MF2_M1 }, // 1045
  { 0x7, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF8 }, // 1046
  { 0x7, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF4 }, // 1047
  { 0x7, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF4 }, // 1048
  { 0x7, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG7EI16_V_M1_MF2 }, // 1049
  { 0x7, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF2 }, // 1050
  { 0x7, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF2 }, // 1051
  { 0x7, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG7EI32_V_M1_M1 }, // 1052
  { 0x7, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG7EI32_V_M2_M1 }, // 1053
  { 0x7, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG7EI32_V_M4_M1 }, // 1054
  { 0x7, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG7EI32_V_MF2_M1 }, // 1055
  { 0x7, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF8 }, // 1056
  { 0x7, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG7EI32_V_M1_MF4 }, // 1057
  { 0x7, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF4 }, // 1058
  { 0x7, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG7EI32_V_M1_MF2 }, // 1059
  { 0x7, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG7EI32_V_M2_MF2 }, // 1060
  { 0x7, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF2 }, // 1061
  { 0x7, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG7EI64_V_M1_M1 }, // 1062
  { 0x7, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG7EI64_V_M2_M1 }, // 1063
  { 0x7, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG7EI64_V_M4_M1 }, // 1064
  { 0x7, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG7EI64_V_M8_M1 }, // 1065
  { 0x7, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG7EI64_V_M1_MF8 }, // 1066
  { 0x7, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG7EI64_V_M1_MF4 }, // 1067
  { 0x7, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG7EI64_V_M2_MF4 }, // 1068
  { 0x7, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG7EI64_V_M1_MF2 }, // 1069
  { 0x7, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG7EI64_V_M2_MF2 }, // 1070
  { 0x7, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG7EI64_V_M4_MF2 }, // 1071
  { 0x7, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG7EI8_V_M1_M1 }, // 1072
  { 0x7, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG7EI8_V_MF8_M1 }, // 1073
  { 0x7, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG7EI8_V_MF4_M1 }, // 1074
  { 0x7, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG7EI8_V_MF2_M1 }, // 1075
  { 0x7, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF8 }, // 1076
  { 0x7, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF4 }, // 1077
  { 0x7, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF4 }, // 1078
  { 0x7, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF2 }, // 1079
  { 0x7, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF2 }, // 1080
  { 0x7, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF2 }, // 1081
  { 0x7, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG7EI16_V_M1_M1 }, // 1082
  { 0x7, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG7EI16_V_M2_M1 }, // 1083
  { 0x7, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG7EI16_V_MF4_M1 }, // 1084
  { 0x7, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG7EI16_V_MF2_M1 }, // 1085
  { 0x7, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF8 }, // 1086
  { 0x7, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF4 }, // 1087
  { 0x7, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF4 }, // 1088
  { 0x7, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG7EI16_V_M1_MF2 }, // 1089
  { 0x7, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF2 }, // 1090
  { 0x7, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF2 }, // 1091
  { 0x7, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG7EI32_V_M1_M1 }, // 1092
  { 0x7, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG7EI32_V_M2_M1 }, // 1093
  { 0x7, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG7EI32_V_M4_M1 }, // 1094
  { 0x7, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG7EI32_V_MF2_M1 }, // 1095
  { 0x7, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF8 }, // 1096
  { 0x7, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG7EI32_V_M1_MF4 }, // 1097
  { 0x7, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF4 }, // 1098
  { 0x7, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG7EI32_V_M1_MF2 }, // 1099
  { 0x7, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG7EI32_V_M2_MF2 }, // 1100
  { 0x7, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF2 }, // 1101
  { 0x7, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG7EI64_V_M1_M1 }, // 1102
  { 0x7, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG7EI64_V_M2_M1 }, // 1103
  { 0x7, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG7EI64_V_M4_M1 }, // 1104
  { 0x7, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG7EI64_V_M8_M1 }, // 1105
  { 0x7, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG7EI64_V_M1_MF8 }, // 1106
  { 0x7, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG7EI64_V_M1_MF4 }, // 1107
  { 0x7, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG7EI64_V_M2_MF4 }, // 1108
  { 0x7, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG7EI64_V_M1_MF2 }, // 1109
  { 0x7, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG7EI64_V_M2_MF2 }, // 1110
  { 0x7, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG7EI64_V_M4_MF2 }, // 1111
  { 0x7, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG7EI8_V_M1_M1_MASK }, // 1112
  { 0x7, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG7EI8_V_MF8_M1_MASK }, // 1113
  { 0x7, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG7EI8_V_MF4_M1_MASK }, // 1114
  { 0x7, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG7EI8_V_MF2_M1_MASK }, // 1115
  { 0x7, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF8_MASK }, // 1116
  { 0x7, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF4_MASK }, // 1117
  { 0x7, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF4_MASK }, // 1118
  { 0x7, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF2_MASK }, // 1119
  { 0x7, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF2_MASK }, // 1120
  { 0x7, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF2_MASK }, // 1121
  { 0x7, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG7EI16_V_M1_M1_MASK }, // 1122
  { 0x7, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG7EI16_V_M2_M1_MASK }, // 1123
  { 0x7, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG7EI16_V_MF4_M1_MASK }, // 1124
  { 0x7, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG7EI16_V_MF2_M1_MASK }, // 1125
  { 0x7, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF8_MASK }, // 1126
  { 0x7, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF4_MASK }, // 1127
  { 0x7, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF4_MASK }, // 1128
  { 0x7, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG7EI16_V_M1_MF2_MASK }, // 1129
  { 0x7, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF2_MASK }, // 1130
  { 0x7, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF2_MASK }, // 1131
  { 0x7, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG7EI32_V_M1_M1_MASK }, // 1132
  { 0x7, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG7EI32_V_M2_M1_MASK }, // 1133
  { 0x7, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG7EI32_V_M4_M1_MASK }, // 1134
  { 0x7, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG7EI32_V_MF2_M1_MASK }, // 1135
  { 0x7, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF8_MASK }, // 1136
  { 0x7, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG7EI32_V_M1_MF4_MASK }, // 1137
  { 0x7, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF4_MASK }, // 1138
  { 0x7, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG7EI32_V_M1_MF2_MASK }, // 1139
  { 0x7, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG7EI32_V_M2_MF2_MASK }, // 1140
  { 0x7, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF2_MASK }, // 1141
  { 0x7, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG7EI64_V_M1_M1_MASK }, // 1142
  { 0x7, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG7EI64_V_M2_M1_MASK }, // 1143
  { 0x7, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG7EI64_V_M4_M1_MASK }, // 1144
  { 0x7, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG7EI64_V_M8_M1_MASK }, // 1145
  { 0x7, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG7EI64_V_M1_MF8_MASK }, // 1146
  { 0x7, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG7EI64_V_M1_MF4_MASK }, // 1147
  { 0x7, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG7EI64_V_M2_MF4_MASK }, // 1148
  { 0x7, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG7EI64_V_M1_MF2_MASK }, // 1149
  { 0x7, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG7EI64_V_M2_MF2_MASK }, // 1150
  { 0x7, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG7EI64_V_M4_MF2_MASK }, // 1151
  { 0x7, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG7EI8_V_M1_M1_MASK }, // 1152
  { 0x7, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG7EI8_V_MF8_M1_MASK }, // 1153
  { 0x7, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG7EI8_V_MF4_M1_MASK }, // 1154
  { 0x7, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG7EI8_V_MF2_M1_MASK }, // 1155
  { 0x7, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF8_MASK }, // 1156
  { 0x7, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF4_MASK }, // 1157
  { 0x7, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF4_MASK }, // 1158
  { 0x7, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF2_MASK }, // 1159
  { 0x7, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF2_MASK }, // 1160
  { 0x7, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF2_MASK }, // 1161
  { 0x7, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG7EI16_V_M1_M1_MASK }, // 1162
  { 0x7, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG7EI16_V_M2_M1_MASK }, // 1163
  { 0x7, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG7EI16_V_MF4_M1_MASK }, // 1164
  { 0x7, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG7EI16_V_MF2_M1_MASK }, // 1165
  { 0x7, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF8_MASK }, // 1166
  { 0x7, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF4_MASK }, // 1167
  { 0x7, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF4_MASK }, // 1168
  { 0x7, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG7EI16_V_M1_MF2_MASK }, // 1169
  { 0x7, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF2_MASK }, // 1170
  { 0x7, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF2_MASK }, // 1171
  { 0x7, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG7EI32_V_M1_M1_MASK }, // 1172
  { 0x7, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG7EI32_V_M2_M1_MASK }, // 1173
  { 0x7, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG7EI32_V_M4_M1_MASK }, // 1174
  { 0x7, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG7EI32_V_MF2_M1_MASK }, // 1175
  { 0x7, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF8_MASK }, // 1176
  { 0x7, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG7EI32_V_M1_MF4_MASK }, // 1177
  { 0x7, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF4_MASK }, // 1178
  { 0x7, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG7EI32_V_M1_MF2_MASK }, // 1179
  { 0x7, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG7EI32_V_M2_MF2_MASK }, // 1180
  { 0x7, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF2_MASK }, // 1181
  { 0x7, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG7EI64_V_M1_M1_MASK }, // 1182
  { 0x7, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG7EI64_V_M2_M1_MASK }, // 1183
  { 0x7, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG7EI64_V_M4_M1_MASK }, // 1184
  { 0x7, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG7EI64_V_M8_M1_MASK }, // 1185
  { 0x7, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG7EI64_V_M1_MF8_MASK }, // 1186
  { 0x7, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG7EI64_V_M1_MF4_MASK }, // 1187
  { 0x7, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG7EI64_V_M2_MF4_MASK }, // 1188
  { 0x7, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG7EI64_V_M1_MF2_MASK }, // 1189
  { 0x7, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG7EI64_V_M2_MF2_MASK }, // 1190
  { 0x7, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG7EI64_V_M4_MF2_MASK }, // 1191
  { 0x8, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG8EI8_V_M1_M1 }, // 1192
  { 0x8, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG8EI8_V_MF8_M1 }, // 1193
  { 0x8, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG8EI8_V_MF4_M1 }, // 1194
  { 0x8, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG8EI8_V_MF2_M1 }, // 1195
  { 0x8, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF8 }, // 1196
  { 0x8, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF4 }, // 1197
  { 0x8, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF4 }, // 1198
  { 0x8, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF2 }, // 1199
  { 0x8, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF2 }, // 1200
  { 0x8, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF2 }, // 1201
  { 0x8, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG8EI16_V_M1_M1 }, // 1202
  { 0x8, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG8EI16_V_M2_M1 }, // 1203
  { 0x8, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG8EI16_V_MF4_M1 }, // 1204
  { 0x8, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG8EI16_V_MF2_M1 }, // 1205
  { 0x8, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF8 }, // 1206
  { 0x8, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF4 }, // 1207
  { 0x8, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF4 }, // 1208
  { 0x8, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG8EI16_V_M1_MF2 }, // 1209
  { 0x8, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF2 }, // 1210
  { 0x8, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF2 }, // 1211
  { 0x8, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG8EI32_V_M1_M1 }, // 1212
  { 0x8, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG8EI32_V_M2_M1 }, // 1213
  { 0x8, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG8EI32_V_M4_M1 }, // 1214
  { 0x8, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG8EI32_V_MF2_M1 }, // 1215
  { 0x8, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF8 }, // 1216
  { 0x8, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG8EI32_V_M1_MF4 }, // 1217
  { 0x8, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF4 }, // 1218
  { 0x8, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG8EI32_V_M1_MF2 }, // 1219
  { 0x8, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG8EI32_V_M2_MF2 }, // 1220
  { 0x8, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF2 }, // 1221
  { 0x8, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG8EI64_V_M1_M1 }, // 1222
  { 0x8, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG8EI64_V_M2_M1 }, // 1223
  { 0x8, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG8EI64_V_M4_M1 }, // 1224
  { 0x8, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG8EI64_V_M8_M1 }, // 1225
  { 0x8, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG8EI64_V_M1_MF8 }, // 1226
  { 0x8, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG8EI64_V_M1_MF4 }, // 1227
  { 0x8, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG8EI64_V_M2_MF4 }, // 1228
  { 0x8, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG8EI64_V_M1_MF2 }, // 1229
  { 0x8, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG8EI64_V_M2_MF2 }, // 1230
  { 0x8, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG8EI64_V_M4_MF2 }, // 1231
  { 0x8, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG8EI8_V_M1_M1 }, // 1232
  { 0x8, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG8EI8_V_MF8_M1 }, // 1233
  { 0x8, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG8EI8_V_MF4_M1 }, // 1234
  { 0x8, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG8EI8_V_MF2_M1 }, // 1235
  { 0x8, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF8 }, // 1236
  { 0x8, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF4 }, // 1237
  { 0x8, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF4 }, // 1238
  { 0x8, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF2 }, // 1239
  { 0x8, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF2 }, // 1240
  { 0x8, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF2 }, // 1241
  { 0x8, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG8EI16_V_M1_M1 }, // 1242
  { 0x8, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG8EI16_V_M2_M1 }, // 1243
  { 0x8, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG8EI16_V_MF4_M1 }, // 1244
  { 0x8, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG8EI16_V_MF2_M1 }, // 1245
  { 0x8, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF8 }, // 1246
  { 0x8, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF4 }, // 1247
  { 0x8, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF4 }, // 1248
  { 0x8, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG8EI16_V_M1_MF2 }, // 1249
  { 0x8, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF2 }, // 1250
  { 0x8, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF2 }, // 1251
  { 0x8, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG8EI32_V_M1_M1 }, // 1252
  { 0x8, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG8EI32_V_M2_M1 }, // 1253
  { 0x8, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG8EI32_V_M4_M1 }, // 1254
  { 0x8, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG8EI32_V_MF2_M1 }, // 1255
  { 0x8, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF8 }, // 1256
  { 0x8, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG8EI32_V_M1_MF4 }, // 1257
  { 0x8, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF4 }, // 1258
  { 0x8, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG8EI32_V_M1_MF2 }, // 1259
  { 0x8, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG8EI32_V_M2_MF2 }, // 1260
  { 0x8, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF2 }, // 1261
  { 0x8, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG8EI64_V_M1_M1 }, // 1262
  { 0x8, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG8EI64_V_M2_M1 }, // 1263
  { 0x8, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG8EI64_V_M4_M1 }, // 1264
  { 0x8, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG8EI64_V_M8_M1 }, // 1265
  { 0x8, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG8EI64_V_M1_MF8 }, // 1266
  { 0x8, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG8EI64_V_M1_MF4 }, // 1267
  { 0x8, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG8EI64_V_M2_MF4 }, // 1268
  { 0x8, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG8EI64_V_M1_MF2 }, // 1269
  { 0x8, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG8EI64_V_M2_MF2 }, // 1270
  { 0x8, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG8EI64_V_M4_MF2 }, // 1271
  { 0x8, 0x1, 0x0, 0x3, 0x0, 0x0, PseudoVSUXSEG8EI8_V_M1_M1_MASK }, // 1272
  { 0x8, 0x1, 0x0, 0x3, 0x0, 0x5, PseudoVSUXSEG8EI8_V_MF8_M1_MASK }, // 1273
  { 0x8, 0x1, 0x0, 0x3, 0x0, 0x6, PseudoVSUXSEG8EI8_V_MF4_M1_MASK }, // 1274
  { 0x8, 0x1, 0x0, 0x3, 0x0, 0x7, PseudoVSUXSEG8EI8_V_MF2_M1_MASK }, // 1275
  { 0x8, 0x1, 0x0, 0x3, 0x5, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF8_MASK }, // 1276
  { 0x8, 0x1, 0x0, 0x3, 0x6, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF4_MASK }, // 1277
  { 0x8, 0x1, 0x0, 0x3, 0x6, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF4_MASK }, // 1278
  { 0x8, 0x1, 0x0, 0x3, 0x7, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF2_MASK }, // 1279
  { 0x8, 0x1, 0x0, 0x3, 0x7, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF2_MASK }, // 1280
  { 0x8, 0x1, 0x0, 0x3, 0x7, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF2_MASK }, // 1281
  { 0x8, 0x1, 0x0, 0x4, 0x0, 0x0, PseudoVSUXSEG8EI16_V_M1_M1_MASK }, // 1282
  { 0x8, 0x1, 0x0, 0x4, 0x0, 0x1, PseudoVSUXSEG8EI16_V_M2_M1_MASK }, // 1283
  { 0x8, 0x1, 0x0, 0x4, 0x0, 0x6, PseudoVSUXSEG8EI16_V_MF4_M1_MASK }, // 1284
  { 0x8, 0x1, 0x0, 0x4, 0x0, 0x7, PseudoVSUXSEG8EI16_V_MF2_M1_MASK }, // 1285
  { 0x8, 0x1, 0x0, 0x4, 0x5, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF8_MASK }, // 1286
  { 0x8, 0x1, 0x0, 0x4, 0x6, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF4_MASK }, // 1287
  { 0x8, 0x1, 0x0, 0x4, 0x6, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF4_MASK }, // 1288
  { 0x8, 0x1, 0x0, 0x4, 0x7, 0x0, PseudoVSUXSEG8EI16_V_M1_MF2_MASK }, // 1289
  { 0x8, 0x1, 0x0, 0x4, 0x7, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF2_MASK }, // 1290
  { 0x8, 0x1, 0x0, 0x4, 0x7, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF2_MASK }, // 1291
  { 0x8, 0x1, 0x0, 0x5, 0x0, 0x0, PseudoVSUXSEG8EI32_V_M1_M1_MASK }, // 1292
  { 0x8, 0x1, 0x0, 0x5, 0x0, 0x1, PseudoVSUXSEG8EI32_V_M2_M1_MASK }, // 1293
  { 0x8, 0x1, 0x0, 0x5, 0x0, 0x2, PseudoVSUXSEG8EI32_V_M4_M1_MASK }, // 1294
  { 0x8, 0x1, 0x0, 0x5, 0x0, 0x7, PseudoVSUXSEG8EI32_V_MF2_M1_MASK }, // 1295
  { 0x8, 0x1, 0x0, 0x5, 0x5, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF8_MASK }, // 1296
  { 0x8, 0x1, 0x0, 0x5, 0x6, 0x0, PseudoVSUXSEG8EI32_V_M1_MF4_MASK }, // 1297
  { 0x8, 0x1, 0x0, 0x5, 0x6, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF4_MASK }, // 1298
  { 0x8, 0x1, 0x0, 0x5, 0x7, 0x0, PseudoVSUXSEG8EI32_V_M1_MF2_MASK }, // 1299
  { 0x8, 0x1, 0x0, 0x5, 0x7, 0x1, PseudoVSUXSEG8EI32_V_M2_MF2_MASK }, // 1300
  { 0x8, 0x1, 0x0, 0x5, 0x7, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF2_MASK }, // 1301
  { 0x8, 0x1, 0x0, 0x6, 0x0, 0x0, PseudoVSUXSEG8EI64_V_M1_M1_MASK }, // 1302
  { 0x8, 0x1, 0x0, 0x6, 0x0, 0x1, PseudoVSUXSEG8EI64_V_M2_M1_MASK }, // 1303
  { 0x8, 0x1, 0x0, 0x6, 0x0, 0x2, PseudoVSUXSEG8EI64_V_M4_M1_MASK }, // 1304
  { 0x8, 0x1, 0x0, 0x6, 0x0, 0x3, PseudoVSUXSEG8EI64_V_M8_M1_MASK }, // 1305
  { 0x8, 0x1, 0x0, 0x6, 0x5, 0x0, PseudoVSUXSEG8EI64_V_M1_MF8_MASK }, // 1306
  { 0x8, 0x1, 0x0, 0x6, 0x6, 0x0, PseudoVSUXSEG8EI64_V_M1_MF4_MASK }, // 1307
  { 0x8, 0x1, 0x0, 0x6, 0x6, 0x1, PseudoVSUXSEG8EI64_V_M2_MF4_MASK }, // 1308
  { 0x8, 0x1, 0x0, 0x6, 0x7, 0x0, PseudoVSUXSEG8EI64_V_M1_MF2_MASK }, // 1309
  { 0x8, 0x1, 0x0, 0x6, 0x7, 0x1, PseudoVSUXSEG8EI64_V_M2_MF2_MASK }, // 1310
  { 0x8, 0x1, 0x0, 0x6, 0x7, 0x2, PseudoVSUXSEG8EI64_V_M4_MF2_MASK }, // 1311
  { 0x8, 0x1, 0x1, 0x3, 0x0, 0x0, PseudoVSOXSEG8EI8_V_M1_M1_MASK }, // 1312
  { 0x8, 0x1, 0x1, 0x3, 0x0, 0x5, PseudoVSOXSEG8EI8_V_MF8_M1_MASK }, // 1313
  { 0x8, 0x1, 0x1, 0x3, 0x0, 0x6, PseudoVSOXSEG8EI8_V_MF4_M1_MASK }, // 1314
  { 0x8, 0x1, 0x1, 0x3, 0x0, 0x7, PseudoVSOXSEG8EI8_V_MF2_M1_MASK }, // 1315
  { 0x8, 0x1, 0x1, 0x3, 0x5, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF8_MASK }, // 1316
  { 0x8, 0x1, 0x1, 0x3, 0x6, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF4_MASK }, // 1317
  { 0x8, 0x1, 0x1, 0x3, 0x6, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF4_MASK }, // 1318
  { 0x8, 0x1, 0x1, 0x3, 0x7, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF2_MASK }, // 1319
  { 0x8, 0x1, 0x1, 0x3, 0x7, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF2_MASK }, // 1320
  { 0x8, 0x1, 0x1, 0x3, 0x7, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF2_MASK }, // 1321
  { 0x8, 0x1, 0x1, 0x4, 0x0, 0x0, PseudoVSOXSEG8EI16_V_M1_M1_MASK }, // 1322
  { 0x8, 0x1, 0x1, 0x4, 0x0, 0x1, PseudoVSOXSEG8EI16_V_M2_M1_MASK }, // 1323
  { 0x8, 0x1, 0x1, 0x4, 0x0, 0x6, PseudoVSOXSEG8EI16_V_MF4_M1_MASK }, // 1324
  { 0x8, 0x1, 0x1, 0x4, 0x0, 0x7, PseudoVSOXSEG8EI16_V_MF2_M1_MASK }, // 1325
  { 0x8, 0x1, 0x1, 0x4, 0x5, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF8_MASK }, // 1326
  { 0x8, 0x1, 0x1, 0x4, 0x6, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF4_MASK }, // 1327
  { 0x8, 0x1, 0x1, 0x4, 0x6, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF4_MASK }, // 1328
  { 0x8, 0x1, 0x1, 0x4, 0x7, 0x0, PseudoVSOXSEG8EI16_V_M1_MF2_MASK }, // 1329
  { 0x8, 0x1, 0x1, 0x4, 0x7, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF2_MASK }, // 1330
  { 0x8, 0x1, 0x1, 0x4, 0x7, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF2_MASK }, // 1331
  { 0x8, 0x1, 0x1, 0x5, 0x0, 0x0, PseudoVSOXSEG8EI32_V_M1_M1_MASK }, // 1332
  { 0x8, 0x1, 0x1, 0x5, 0x0, 0x1, PseudoVSOXSEG8EI32_V_M2_M1_MASK }, // 1333
  { 0x8, 0x1, 0x1, 0x5, 0x0, 0x2, PseudoVSOXSEG8EI32_V_M4_M1_MASK }, // 1334
  { 0x8, 0x1, 0x1, 0x5, 0x0, 0x7, PseudoVSOXSEG8EI32_V_MF2_M1_MASK }, // 1335
  { 0x8, 0x1, 0x1, 0x5, 0x5, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF8_MASK }, // 1336
  { 0x8, 0x1, 0x1, 0x5, 0x6, 0x0, PseudoVSOXSEG8EI32_V_M1_MF4_MASK }, // 1337
  { 0x8, 0x1, 0x1, 0x5, 0x6, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF4_MASK }, // 1338
  { 0x8, 0x1, 0x1, 0x5, 0x7, 0x0, PseudoVSOXSEG8EI32_V_M1_MF2_MASK }, // 1339
  { 0x8, 0x1, 0x1, 0x5, 0x7, 0x1, PseudoVSOXSEG8EI32_V_M2_MF2_MASK }, // 1340
  { 0x8, 0x1, 0x1, 0x5, 0x7, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF2_MASK }, // 1341
  { 0x8, 0x1, 0x1, 0x6, 0x0, 0x0, PseudoVSOXSEG8EI64_V_M1_M1_MASK }, // 1342
  { 0x8, 0x1, 0x1, 0x6, 0x0, 0x1, PseudoVSOXSEG8EI64_V_M2_M1_MASK }, // 1343
  { 0x8, 0x1, 0x1, 0x6, 0x0, 0x2, PseudoVSOXSEG8EI64_V_M4_M1_MASK }, // 1344
  { 0x8, 0x1, 0x1, 0x6, 0x0, 0x3, PseudoVSOXSEG8EI64_V_M8_M1_MASK }, // 1345
  { 0x8, 0x1, 0x1, 0x6, 0x5, 0x0, PseudoVSOXSEG8EI64_V_M1_MF8_MASK }, // 1346
  { 0x8, 0x1, 0x1, 0x6, 0x6, 0x0, PseudoVSOXSEG8EI64_V_M1_MF4_MASK }, // 1347
  { 0x8, 0x1, 0x1, 0x6, 0x6, 0x1, PseudoVSOXSEG8EI64_V_M2_MF4_MASK }, // 1348
  { 0x8, 0x1, 0x1, 0x6, 0x7, 0x0, PseudoVSOXSEG8EI64_V_M1_MF2_MASK }, // 1349
  { 0x8, 0x1, 0x1, 0x6, 0x7, 0x1, PseudoVSOXSEG8EI64_V_M2_MF2_MASK }, // 1350
  { 0x8, 0x1, 0x1, 0x6, 0x7, 0x2, PseudoVSOXSEG8EI64_V_M4_MF2_MASK }, // 1351
 };

const VSXSEGPseudo *getVSXSEGPseudo(uint8_t NF, uint8_t Masked, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL) {
  struct KeyType {
    uint8_t NF;
    uint8_t Masked;
    uint8_t Ordered;
    uint8_t Log2SEW;
    uint8_t LMUL;
    uint8_t IndexLMUL;
  };
  KeyType Key = {NF, Masked, Ordered, Log2SEW, LMUL, IndexLMUL};
  auto Table = ArrayRef(RISCVVSXSEGTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VSXSEGPseudo &LHS, const KeyType &RHS) {
      if (LHS.NF < RHS.NF)
        return true;
      if (LHS.NF > RHS.NF)
        return false;
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.Ordered < RHS.Ordered)
        return true;
      if (LHS.Ordered > RHS.Ordered)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      if (LHS.IndexLMUL < RHS.IndexLMUL)
        return true;
      if (LHS.IndexLMUL > RHS.IndexLMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.NF != Idx->NF ||
      Key.Masked != Idx->Masked ||
      Key.Ordered != Idx->Ordered ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL ||
      Key.IndexLMUL != Idx->IndexLMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVSXTable_DECL
const VLX_VSXPseudo *getVSXPseudo(uint8_t Masked, uint8_t IsTU, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL);
#endif

#ifdef GET_RISCVVSXTable_IMPL
constexpr VLX_VSXPseudo RISCVVSXTable[] = {
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXEI8_V_M1_M1 }, // 0
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXEI8_V_MF8_M1 }, // 1
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXEI8_V_MF4_M1 }, // 2
  { 0x0, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXEI8_V_MF2_M1 }, // 3
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVSUXEI8_V_M1_M2 }, // 4
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVSUXEI8_V_M2_M2 }, // 5
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVSUXEI8_V_MF4_M2 }, // 6
  { 0x0, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVSUXEI8_V_MF2_M2 }, // 7
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x0, PseudoVSUXEI8_V_M1_M4 }, // 8
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x1, PseudoVSUXEI8_V_M2_M4 }, // 9
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x2, PseudoVSUXEI8_V_M4_M4 }, // 10
  { 0x0, 0x0, 0x0, 0x3, 0x2, 0x7, PseudoVSUXEI8_V_MF2_M4 }, // 11
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x0, PseudoVSUXEI8_V_M1_M8 }, // 12
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x1, PseudoVSUXEI8_V_M2_M8 }, // 13
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x2, PseudoVSUXEI8_V_M4_M8 }, // 14
  { 0x0, 0x0, 0x0, 0x3, 0x3, 0x3, PseudoVSUXEI8_V_M8_M8 }, // 15
  { 0x0, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXEI8_V_MF8_MF8 }, // 16
  { 0x0, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXEI8_V_MF8_MF4 }, // 17
  { 0x0, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXEI8_V_MF4_MF4 }, // 18
  { 0x0, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXEI8_V_MF8_MF2 }, // 19
  { 0x0, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXEI8_V_MF4_MF2 }, // 20
  { 0x0, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXEI8_V_MF2_MF2 }, // 21
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXEI16_V_M1_M1 }, // 22
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXEI16_V_M2_M1 }, // 23
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXEI16_V_MF4_M1 }, // 24
  { 0x0, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXEI16_V_MF2_M1 }, // 25
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVSUXEI16_V_M1_M2 }, // 26
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVSUXEI16_V_M2_M2 }, // 27
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVSUXEI16_V_M4_M2 }, // 28
  { 0x0, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVSUXEI16_V_MF2_M2 }, // 29
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x0, PseudoVSUXEI16_V_M1_M4 }, // 30
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x1, PseudoVSUXEI16_V_M2_M4 }, // 31
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x2, PseudoVSUXEI16_V_M4_M4 }, // 32
  { 0x0, 0x0, 0x0, 0x4, 0x2, 0x3, PseudoVSUXEI16_V_M8_M4 }, // 33
  { 0x0, 0x0, 0x0, 0x4, 0x3, 0x1, PseudoVSUXEI16_V_M2_M8 }, // 34
  { 0x0, 0x0, 0x0, 0x4, 0x3, 0x2, PseudoVSUXEI16_V_M4_M8 }, // 35
  { 0x0, 0x0, 0x0, 0x4, 0x3, 0x3, PseudoVSUXEI16_V_M8_M8 }, // 36
  { 0x0, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXEI16_V_MF4_MF8 }, // 37
  { 0x0, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXEI16_V_MF4_MF4 }, // 38
  { 0x0, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXEI16_V_MF2_MF4 }, // 39
  { 0x0, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXEI16_V_M1_MF2 }, // 40
  { 0x0, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXEI16_V_MF4_MF2 }, // 41
  { 0x0, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXEI16_V_MF2_MF2 }, // 42
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXEI32_V_M1_M1 }, // 43
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXEI32_V_M2_M1 }, // 44
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXEI32_V_M4_M1 }, // 45
  { 0x0, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXEI32_V_MF2_M1 }, // 46
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVSUXEI32_V_M1_M2 }, // 47
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVSUXEI32_V_M2_M2 }, // 48
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVSUXEI32_V_M4_M2 }, // 49
  { 0x0, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVSUXEI32_V_M8_M2 }, // 50
  { 0x0, 0x0, 0x0, 0x5, 0x2, 0x1, PseudoVSUXEI32_V_M2_M4 }, // 51
  { 0x0, 0x0, 0x0, 0x5, 0x2, 0x2, PseudoVSUXEI32_V_M4_M4 }, // 52
  { 0x0, 0x0, 0x0, 0x5, 0x2, 0x3, PseudoVSUXEI32_V_M8_M4 }, // 53
  { 0x0, 0x0, 0x0, 0x5, 0x3, 0x2, PseudoVSUXEI32_V_M4_M8 }, // 54
  { 0x0, 0x0, 0x0, 0x5, 0x3, 0x3, PseudoVSUXEI32_V_M8_M8 }, // 55
  { 0x0, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXEI32_V_MF2_MF8 }, // 56
  { 0x0, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXEI32_V_M1_MF4 }, // 57
  { 0x0, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXEI32_V_MF2_MF4 }, // 58
  { 0x0, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXEI32_V_M1_MF2 }, // 59
  { 0x0, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXEI32_V_M2_MF2 }, // 60
  { 0x0, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXEI32_V_MF2_MF2 }, // 61
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXEI64_V_M1_M1 }, // 62
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXEI64_V_M2_M1 }, // 63
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXEI64_V_M4_M1 }, // 64
  { 0x0, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXEI64_V_M8_M1 }, // 65
  { 0x0, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVSUXEI64_V_M2_M2 }, // 66
  { 0x0, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVSUXEI64_V_M4_M2 }, // 67
  { 0x0, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVSUXEI64_V_M8_M2 }, // 68
  { 0x0, 0x0, 0x0, 0x6, 0x2, 0x2, PseudoVSUXEI64_V_M4_M4 }, // 69
  { 0x0, 0x0, 0x0, 0x6, 0x2, 0x3, PseudoVSUXEI64_V_M8_M4 }, // 70
  { 0x0, 0x0, 0x0, 0x6, 0x3, 0x3, PseudoVSUXEI64_V_M8_M8 }, // 71
  { 0x0, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXEI64_V_M1_MF8 }, // 72
  { 0x0, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXEI64_V_M1_MF4 }, // 73
  { 0x0, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXEI64_V_M2_MF4 }, // 74
  { 0x0, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXEI64_V_M1_MF2 }, // 75
  { 0x0, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXEI64_V_M2_MF2 }, // 76
  { 0x0, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXEI64_V_M4_MF2 }, // 77
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXEI8_V_M1_M1 }, // 78
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXEI8_V_MF8_M1 }, // 79
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXEI8_V_MF4_M1 }, // 80
  { 0x0, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXEI8_V_MF2_M1 }, // 81
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVSOXEI8_V_M1_M2 }, // 82
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVSOXEI8_V_M2_M2 }, // 83
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVSOXEI8_V_MF4_M2 }, // 84
  { 0x0, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVSOXEI8_V_MF2_M2 }, // 85
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x0, PseudoVSOXEI8_V_M1_M4 }, // 86
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x1, PseudoVSOXEI8_V_M2_M4 }, // 87
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x2, PseudoVSOXEI8_V_M4_M4 }, // 88
  { 0x0, 0x0, 0x1, 0x3, 0x2, 0x7, PseudoVSOXEI8_V_MF2_M4 }, // 89
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x0, PseudoVSOXEI8_V_M1_M8 }, // 90
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x1, PseudoVSOXEI8_V_M2_M8 }, // 91
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x2, PseudoVSOXEI8_V_M4_M8 }, // 92
  { 0x0, 0x0, 0x1, 0x3, 0x3, 0x3, PseudoVSOXEI8_V_M8_M8 }, // 93
  { 0x0, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXEI8_V_MF8_MF8 }, // 94
  { 0x0, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXEI8_V_MF8_MF4 }, // 95
  { 0x0, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXEI8_V_MF4_MF4 }, // 96
  { 0x0, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXEI8_V_MF8_MF2 }, // 97
  { 0x0, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXEI8_V_MF4_MF2 }, // 98
  { 0x0, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXEI8_V_MF2_MF2 }, // 99
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXEI16_V_M1_M1 }, // 100
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXEI16_V_M2_M1 }, // 101
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXEI16_V_MF4_M1 }, // 102
  { 0x0, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXEI16_V_MF2_M1 }, // 103
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVSOXEI16_V_M1_M2 }, // 104
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVSOXEI16_V_M2_M2 }, // 105
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVSOXEI16_V_M4_M2 }, // 106
  { 0x0, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVSOXEI16_V_MF2_M2 }, // 107
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x0, PseudoVSOXEI16_V_M1_M4 }, // 108
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x1, PseudoVSOXEI16_V_M2_M4 }, // 109
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x2, PseudoVSOXEI16_V_M4_M4 }, // 110
  { 0x0, 0x0, 0x1, 0x4, 0x2, 0x3, PseudoVSOXEI16_V_M8_M4 }, // 111
  { 0x0, 0x0, 0x1, 0x4, 0x3, 0x1, PseudoVSOXEI16_V_M2_M8 }, // 112
  { 0x0, 0x0, 0x1, 0x4, 0x3, 0x2, PseudoVSOXEI16_V_M4_M8 }, // 113
  { 0x0, 0x0, 0x1, 0x4, 0x3, 0x3, PseudoVSOXEI16_V_M8_M8 }, // 114
  { 0x0, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXEI16_V_MF4_MF8 }, // 115
  { 0x0, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXEI16_V_MF4_MF4 }, // 116
  { 0x0, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXEI16_V_MF2_MF4 }, // 117
  { 0x0, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXEI16_V_M1_MF2 }, // 118
  { 0x0, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXEI16_V_MF4_MF2 }, // 119
  { 0x0, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXEI16_V_MF2_MF2 }, // 120
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXEI32_V_M1_M1 }, // 121
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXEI32_V_M2_M1 }, // 122
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXEI32_V_M4_M1 }, // 123
  { 0x0, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXEI32_V_MF2_M1 }, // 124
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVSOXEI32_V_M1_M2 }, // 125
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVSOXEI32_V_M2_M2 }, // 126
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVSOXEI32_V_M4_M2 }, // 127
  { 0x0, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVSOXEI32_V_M8_M2 }, // 128
  { 0x0, 0x0, 0x1, 0x5, 0x2, 0x1, PseudoVSOXEI32_V_M2_M4 }, // 129
  { 0x0, 0x0, 0x1, 0x5, 0x2, 0x2, PseudoVSOXEI32_V_M4_M4 }, // 130
  { 0x0, 0x0, 0x1, 0x5, 0x2, 0x3, PseudoVSOXEI32_V_M8_M4 }, // 131
  { 0x0, 0x0, 0x1, 0x5, 0x3, 0x2, PseudoVSOXEI32_V_M4_M8 }, // 132
  { 0x0, 0x0, 0x1, 0x5, 0x3, 0x3, PseudoVSOXEI32_V_M8_M8 }, // 133
  { 0x0, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXEI32_V_MF2_MF8 }, // 134
  { 0x0, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXEI32_V_M1_MF4 }, // 135
  { 0x0, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXEI32_V_MF2_MF4 }, // 136
  { 0x0, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXEI32_V_M1_MF2 }, // 137
  { 0x0, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXEI32_V_M2_MF2 }, // 138
  { 0x0, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXEI32_V_MF2_MF2 }, // 139
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXEI64_V_M1_M1 }, // 140
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXEI64_V_M2_M1 }, // 141
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXEI64_V_M4_M1 }, // 142
  { 0x0, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXEI64_V_M8_M1 }, // 143
  { 0x0, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVSOXEI64_V_M2_M2 }, // 144
  { 0x0, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVSOXEI64_V_M4_M2 }, // 145
  { 0x0, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVSOXEI64_V_M8_M2 }, // 146
  { 0x0, 0x0, 0x1, 0x6, 0x2, 0x2, PseudoVSOXEI64_V_M4_M4 }, // 147
  { 0x0, 0x0, 0x1, 0x6, 0x2, 0x3, PseudoVSOXEI64_V_M8_M4 }, // 148
  { 0x0, 0x0, 0x1, 0x6, 0x3, 0x3, PseudoVSOXEI64_V_M8_M8 }, // 149
  { 0x0, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXEI64_V_M1_MF8 }, // 150
  { 0x0, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXEI64_V_M1_MF4 }, // 151
  { 0x0, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXEI64_V_M2_MF4 }, // 152
  { 0x0, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXEI64_V_M1_MF2 }, // 153
  { 0x0, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXEI64_V_M2_MF2 }, // 154
  { 0x0, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXEI64_V_M4_MF2 }, // 155
  { 0x1, 0x0, 0x0, 0x3, 0x0, 0x0, PseudoVSUXEI8_V_M1_M1_MASK }, // 156
  { 0x1, 0x0, 0x0, 0x3, 0x0, 0x5, PseudoVSUXEI8_V_MF8_M1_MASK }, // 157
  { 0x1, 0x0, 0x0, 0x3, 0x0, 0x6, PseudoVSUXEI8_V_MF4_M1_MASK }, // 158
  { 0x1, 0x0, 0x0, 0x3, 0x0, 0x7, PseudoVSUXEI8_V_MF2_M1_MASK }, // 159
  { 0x1, 0x0, 0x0, 0x3, 0x1, 0x0, PseudoVSUXEI8_V_M1_M2_MASK }, // 160
  { 0x1, 0x0, 0x0, 0x3, 0x1, 0x1, PseudoVSUXEI8_V_M2_M2_MASK }, // 161
  { 0x1, 0x0, 0x0, 0x3, 0x1, 0x6, PseudoVSUXEI8_V_MF4_M2_MASK }, // 162
  { 0x1, 0x0, 0x0, 0x3, 0x1, 0x7, PseudoVSUXEI8_V_MF2_M2_MASK }, // 163
  { 0x1, 0x0, 0x0, 0x3, 0x2, 0x0, PseudoVSUXEI8_V_M1_M4_MASK }, // 164
  { 0x1, 0x0, 0x0, 0x3, 0x2, 0x1, PseudoVSUXEI8_V_M2_M4_MASK }, // 165
  { 0x1, 0x0, 0x0, 0x3, 0x2, 0x2, PseudoVSUXEI8_V_M4_M4_MASK }, // 166
  { 0x1, 0x0, 0x0, 0x3, 0x2, 0x7, PseudoVSUXEI8_V_MF2_M4_MASK }, // 167
  { 0x1, 0x0, 0x0, 0x3, 0x3, 0x0, PseudoVSUXEI8_V_M1_M8_MASK }, // 168
  { 0x1, 0x0, 0x0, 0x3, 0x3, 0x1, PseudoVSUXEI8_V_M2_M8_MASK }, // 169
  { 0x1, 0x0, 0x0, 0x3, 0x3, 0x2, PseudoVSUXEI8_V_M4_M8_MASK }, // 170
  { 0x1, 0x0, 0x0, 0x3, 0x3, 0x3, PseudoVSUXEI8_V_M8_M8_MASK }, // 171
  { 0x1, 0x0, 0x0, 0x3, 0x5, 0x5, PseudoVSUXEI8_V_MF8_MF8_MASK }, // 172
  { 0x1, 0x0, 0x0, 0x3, 0x6, 0x5, PseudoVSUXEI8_V_MF8_MF4_MASK }, // 173
  { 0x1, 0x0, 0x0, 0x3, 0x6, 0x6, PseudoVSUXEI8_V_MF4_MF4_MASK }, // 174
  { 0x1, 0x0, 0x0, 0x3, 0x7, 0x5, PseudoVSUXEI8_V_MF8_MF2_MASK }, // 175
  { 0x1, 0x0, 0x0, 0x3, 0x7, 0x6, PseudoVSUXEI8_V_MF4_MF2_MASK }, // 176
  { 0x1, 0x0, 0x0, 0x3, 0x7, 0x7, PseudoVSUXEI8_V_MF2_MF2_MASK }, // 177
  { 0x1, 0x0, 0x0, 0x4, 0x0, 0x0, PseudoVSUXEI16_V_M1_M1_MASK }, // 178
  { 0x1, 0x0, 0x0, 0x4, 0x0, 0x1, PseudoVSUXEI16_V_M2_M1_MASK }, // 179
  { 0x1, 0x0, 0x0, 0x4, 0x0, 0x6, PseudoVSUXEI16_V_MF4_M1_MASK }, // 180
  { 0x1, 0x0, 0x0, 0x4, 0x0, 0x7, PseudoVSUXEI16_V_MF2_M1_MASK }, // 181
  { 0x1, 0x0, 0x0, 0x4, 0x1, 0x0, PseudoVSUXEI16_V_M1_M2_MASK }, // 182
  { 0x1, 0x0, 0x0, 0x4, 0x1, 0x1, PseudoVSUXEI16_V_M2_M2_MASK }, // 183
  { 0x1, 0x0, 0x0, 0x4, 0x1, 0x2, PseudoVSUXEI16_V_M4_M2_MASK }, // 184
  { 0x1, 0x0, 0x0, 0x4, 0x1, 0x7, PseudoVSUXEI16_V_MF2_M2_MASK }, // 185
  { 0x1, 0x0, 0x0, 0x4, 0x2, 0x0, PseudoVSUXEI16_V_M1_M4_MASK }, // 186
  { 0x1, 0x0, 0x0, 0x4, 0x2, 0x1, PseudoVSUXEI16_V_M2_M4_MASK }, // 187
  { 0x1, 0x0, 0x0, 0x4, 0x2, 0x2, PseudoVSUXEI16_V_M4_M4_MASK }, // 188
  { 0x1, 0x0, 0x0, 0x4, 0x2, 0x3, PseudoVSUXEI16_V_M8_M4_MASK }, // 189
  { 0x1, 0x0, 0x0, 0x4, 0x3, 0x1, PseudoVSUXEI16_V_M2_M8_MASK }, // 190
  { 0x1, 0x0, 0x0, 0x4, 0x3, 0x2, PseudoVSUXEI16_V_M4_M8_MASK }, // 191
  { 0x1, 0x0, 0x0, 0x4, 0x3, 0x3, PseudoVSUXEI16_V_M8_M8_MASK }, // 192
  { 0x1, 0x0, 0x0, 0x4, 0x5, 0x6, PseudoVSUXEI16_V_MF4_MF8_MASK }, // 193
  { 0x1, 0x0, 0x0, 0x4, 0x6, 0x6, PseudoVSUXEI16_V_MF4_MF4_MASK }, // 194
  { 0x1, 0x0, 0x0, 0x4, 0x6, 0x7, PseudoVSUXEI16_V_MF2_MF4_MASK }, // 195
  { 0x1, 0x0, 0x0, 0x4, 0x7, 0x0, PseudoVSUXEI16_V_M1_MF2_MASK }, // 196
  { 0x1, 0x0, 0x0, 0x4, 0x7, 0x6, PseudoVSUXEI16_V_MF4_MF2_MASK }, // 197
  { 0x1, 0x0, 0x0, 0x4, 0x7, 0x7, PseudoVSUXEI16_V_MF2_MF2_MASK }, // 198
  { 0x1, 0x0, 0x0, 0x5, 0x0, 0x0, PseudoVSUXEI32_V_M1_M1_MASK }, // 199
  { 0x1, 0x0, 0x0, 0x5, 0x0, 0x1, PseudoVSUXEI32_V_M2_M1_MASK }, // 200
  { 0x1, 0x0, 0x0, 0x5, 0x0, 0x2, PseudoVSUXEI32_V_M4_M1_MASK }, // 201
  { 0x1, 0x0, 0x0, 0x5, 0x0, 0x7, PseudoVSUXEI32_V_MF2_M1_MASK }, // 202
  { 0x1, 0x0, 0x0, 0x5, 0x1, 0x0, PseudoVSUXEI32_V_M1_M2_MASK }, // 203
  { 0x1, 0x0, 0x0, 0x5, 0x1, 0x1, PseudoVSUXEI32_V_M2_M2_MASK }, // 204
  { 0x1, 0x0, 0x0, 0x5, 0x1, 0x2, PseudoVSUXEI32_V_M4_M2_MASK }, // 205
  { 0x1, 0x0, 0x0, 0x5, 0x1, 0x3, PseudoVSUXEI32_V_M8_M2_MASK }, // 206
  { 0x1, 0x0, 0x0, 0x5, 0x2, 0x1, PseudoVSUXEI32_V_M2_M4_MASK }, // 207
  { 0x1, 0x0, 0x0, 0x5, 0x2, 0x2, PseudoVSUXEI32_V_M4_M4_MASK }, // 208
  { 0x1, 0x0, 0x0, 0x5, 0x2, 0x3, PseudoVSUXEI32_V_M8_M4_MASK }, // 209
  { 0x1, 0x0, 0x0, 0x5, 0x3, 0x2, PseudoVSUXEI32_V_M4_M8_MASK }, // 210
  { 0x1, 0x0, 0x0, 0x5, 0x3, 0x3, PseudoVSUXEI32_V_M8_M8_MASK }, // 211
  { 0x1, 0x0, 0x0, 0x5, 0x5, 0x7, PseudoVSUXEI32_V_MF2_MF8_MASK }, // 212
  { 0x1, 0x0, 0x0, 0x5, 0x6, 0x0, PseudoVSUXEI32_V_M1_MF4_MASK }, // 213
  { 0x1, 0x0, 0x0, 0x5, 0x6, 0x7, PseudoVSUXEI32_V_MF2_MF4_MASK }, // 214
  { 0x1, 0x0, 0x0, 0x5, 0x7, 0x0, PseudoVSUXEI32_V_M1_MF2_MASK }, // 215
  { 0x1, 0x0, 0x0, 0x5, 0x7, 0x1, PseudoVSUXEI32_V_M2_MF2_MASK }, // 216
  { 0x1, 0x0, 0x0, 0x5, 0x7, 0x7, PseudoVSUXEI32_V_MF2_MF2_MASK }, // 217
  { 0x1, 0x0, 0x0, 0x6, 0x0, 0x0, PseudoVSUXEI64_V_M1_M1_MASK }, // 218
  { 0x1, 0x0, 0x0, 0x6, 0x0, 0x1, PseudoVSUXEI64_V_M2_M1_MASK }, // 219
  { 0x1, 0x0, 0x0, 0x6, 0x0, 0x2, PseudoVSUXEI64_V_M4_M1_MASK }, // 220
  { 0x1, 0x0, 0x0, 0x6, 0x0, 0x3, PseudoVSUXEI64_V_M8_M1_MASK }, // 221
  { 0x1, 0x0, 0x0, 0x6, 0x1, 0x1, PseudoVSUXEI64_V_M2_M2_MASK }, // 222
  { 0x1, 0x0, 0x0, 0x6, 0x1, 0x2, PseudoVSUXEI64_V_M4_M2_MASK }, // 223
  { 0x1, 0x0, 0x0, 0x6, 0x1, 0x3, PseudoVSUXEI64_V_M8_M2_MASK }, // 224
  { 0x1, 0x0, 0x0, 0x6, 0x2, 0x2, PseudoVSUXEI64_V_M4_M4_MASK }, // 225
  { 0x1, 0x0, 0x0, 0x6, 0x2, 0x3, PseudoVSUXEI64_V_M8_M4_MASK }, // 226
  { 0x1, 0x0, 0x0, 0x6, 0x3, 0x3, PseudoVSUXEI64_V_M8_M8_MASK }, // 227
  { 0x1, 0x0, 0x0, 0x6, 0x5, 0x0, PseudoVSUXEI64_V_M1_MF8_MASK }, // 228
  { 0x1, 0x0, 0x0, 0x6, 0x6, 0x0, PseudoVSUXEI64_V_M1_MF4_MASK }, // 229
  { 0x1, 0x0, 0x0, 0x6, 0x6, 0x1, PseudoVSUXEI64_V_M2_MF4_MASK }, // 230
  { 0x1, 0x0, 0x0, 0x6, 0x7, 0x0, PseudoVSUXEI64_V_M1_MF2_MASK }, // 231
  { 0x1, 0x0, 0x0, 0x6, 0x7, 0x1, PseudoVSUXEI64_V_M2_MF2_MASK }, // 232
  { 0x1, 0x0, 0x0, 0x6, 0x7, 0x2, PseudoVSUXEI64_V_M4_MF2_MASK }, // 233
  { 0x1, 0x0, 0x1, 0x3, 0x0, 0x0, PseudoVSOXEI8_V_M1_M1_MASK }, // 234
  { 0x1, 0x0, 0x1, 0x3, 0x0, 0x5, PseudoVSOXEI8_V_MF8_M1_MASK }, // 235
  { 0x1, 0x0, 0x1, 0x3, 0x0, 0x6, PseudoVSOXEI8_V_MF4_M1_MASK }, // 236
  { 0x1, 0x0, 0x1, 0x3, 0x0, 0x7, PseudoVSOXEI8_V_MF2_M1_MASK }, // 237
  { 0x1, 0x0, 0x1, 0x3, 0x1, 0x0, PseudoVSOXEI8_V_M1_M2_MASK }, // 238
  { 0x1, 0x0, 0x1, 0x3, 0x1, 0x1, PseudoVSOXEI8_V_M2_M2_MASK }, // 239
  { 0x1, 0x0, 0x1, 0x3, 0x1, 0x6, PseudoVSOXEI8_V_MF4_M2_MASK }, // 240
  { 0x1, 0x0, 0x1, 0x3, 0x1, 0x7, PseudoVSOXEI8_V_MF2_M2_MASK }, // 241
  { 0x1, 0x0, 0x1, 0x3, 0x2, 0x0, PseudoVSOXEI8_V_M1_M4_MASK }, // 242
  { 0x1, 0x0, 0x1, 0x3, 0x2, 0x1, PseudoVSOXEI8_V_M2_M4_MASK }, // 243
  { 0x1, 0x0, 0x1, 0x3, 0x2, 0x2, PseudoVSOXEI8_V_M4_M4_MASK }, // 244
  { 0x1, 0x0, 0x1, 0x3, 0x2, 0x7, PseudoVSOXEI8_V_MF2_M4_MASK }, // 245
  { 0x1, 0x0, 0x1, 0x3, 0x3, 0x0, PseudoVSOXEI8_V_M1_M8_MASK }, // 246
  { 0x1, 0x0, 0x1, 0x3, 0x3, 0x1, PseudoVSOXEI8_V_M2_M8_MASK }, // 247
  { 0x1, 0x0, 0x1, 0x3, 0x3, 0x2, PseudoVSOXEI8_V_M4_M8_MASK }, // 248
  { 0x1, 0x0, 0x1, 0x3, 0x3, 0x3, PseudoVSOXEI8_V_M8_M8_MASK }, // 249
  { 0x1, 0x0, 0x1, 0x3, 0x5, 0x5, PseudoVSOXEI8_V_MF8_MF8_MASK }, // 250
  { 0x1, 0x0, 0x1, 0x3, 0x6, 0x5, PseudoVSOXEI8_V_MF8_MF4_MASK }, // 251
  { 0x1, 0x0, 0x1, 0x3, 0x6, 0x6, PseudoVSOXEI8_V_MF4_MF4_MASK }, // 252
  { 0x1, 0x0, 0x1, 0x3, 0x7, 0x5, PseudoVSOXEI8_V_MF8_MF2_MASK }, // 253
  { 0x1, 0x0, 0x1, 0x3, 0x7, 0x6, PseudoVSOXEI8_V_MF4_MF2_MASK }, // 254
  { 0x1, 0x0, 0x1, 0x3, 0x7, 0x7, PseudoVSOXEI8_V_MF2_MF2_MASK }, // 255
  { 0x1, 0x0, 0x1, 0x4, 0x0, 0x0, PseudoVSOXEI16_V_M1_M1_MASK }, // 256
  { 0x1, 0x0, 0x1, 0x4, 0x0, 0x1, PseudoVSOXEI16_V_M2_M1_MASK }, // 257
  { 0x1, 0x0, 0x1, 0x4, 0x0, 0x6, PseudoVSOXEI16_V_MF4_M1_MASK }, // 258
  { 0x1, 0x0, 0x1, 0x4, 0x0, 0x7, PseudoVSOXEI16_V_MF2_M1_MASK }, // 259
  { 0x1, 0x0, 0x1, 0x4, 0x1, 0x0, PseudoVSOXEI16_V_M1_M2_MASK }, // 260
  { 0x1, 0x0, 0x1, 0x4, 0x1, 0x1, PseudoVSOXEI16_V_M2_M2_MASK }, // 261
  { 0x1, 0x0, 0x1, 0x4, 0x1, 0x2, PseudoVSOXEI16_V_M4_M2_MASK }, // 262
  { 0x1, 0x0, 0x1, 0x4, 0x1, 0x7, PseudoVSOXEI16_V_MF2_M2_MASK }, // 263
  { 0x1, 0x0, 0x1, 0x4, 0x2, 0x0, PseudoVSOXEI16_V_M1_M4_MASK }, // 264
  { 0x1, 0x0, 0x1, 0x4, 0x2, 0x1, PseudoVSOXEI16_V_M2_M4_MASK }, // 265
  { 0x1, 0x0, 0x1, 0x4, 0x2, 0x2, PseudoVSOXEI16_V_M4_M4_MASK }, // 266
  { 0x1, 0x0, 0x1, 0x4, 0x2, 0x3, PseudoVSOXEI16_V_M8_M4_MASK }, // 267
  { 0x1, 0x0, 0x1, 0x4, 0x3, 0x1, PseudoVSOXEI16_V_M2_M8_MASK }, // 268
  { 0x1, 0x0, 0x1, 0x4, 0x3, 0x2, PseudoVSOXEI16_V_M4_M8_MASK }, // 269
  { 0x1, 0x0, 0x1, 0x4, 0x3, 0x3, PseudoVSOXEI16_V_M8_M8_MASK }, // 270
  { 0x1, 0x0, 0x1, 0x4, 0x5, 0x6, PseudoVSOXEI16_V_MF4_MF8_MASK }, // 271
  { 0x1, 0x0, 0x1, 0x4, 0x6, 0x6, PseudoVSOXEI16_V_MF4_MF4_MASK }, // 272
  { 0x1, 0x0, 0x1, 0x4, 0x6, 0x7, PseudoVSOXEI16_V_MF2_MF4_MASK }, // 273
  { 0x1, 0x0, 0x1, 0x4, 0x7, 0x0, PseudoVSOXEI16_V_M1_MF2_MASK }, // 274
  { 0x1, 0x0, 0x1, 0x4, 0x7, 0x6, PseudoVSOXEI16_V_MF4_MF2_MASK }, // 275
  { 0x1, 0x0, 0x1, 0x4, 0x7, 0x7, PseudoVSOXEI16_V_MF2_MF2_MASK }, // 276
  { 0x1, 0x0, 0x1, 0x5, 0x0, 0x0, PseudoVSOXEI32_V_M1_M1_MASK }, // 277
  { 0x1, 0x0, 0x1, 0x5, 0x0, 0x1, PseudoVSOXEI32_V_M2_M1_MASK }, // 278
  { 0x1, 0x0, 0x1, 0x5, 0x0, 0x2, PseudoVSOXEI32_V_M4_M1_MASK }, // 279
  { 0x1, 0x0, 0x1, 0x5, 0x0, 0x7, PseudoVSOXEI32_V_MF2_M1_MASK }, // 280
  { 0x1, 0x0, 0x1, 0x5, 0x1, 0x0, PseudoVSOXEI32_V_M1_M2_MASK }, // 281
  { 0x1, 0x0, 0x1, 0x5, 0x1, 0x1, PseudoVSOXEI32_V_M2_M2_MASK }, // 282
  { 0x1, 0x0, 0x1, 0x5, 0x1, 0x2, PseudoVSOXEI32_V_M4_M2_MASK }, // 283
  { 0x1, 0x0, 0x1, 0x5, 0x1, 0x3, PseudoVSOXEI32_V_M8_M2_MASK }, // 284
  { 0x1, 0x0, 0x1, 0x5, 0x2, 0x1, PseudoVSOXEI32_V_M2_M4_MASK }, // 285
  { 0x1, 0x0, 0x1, 0x5, 0x2, 0x2, PseudoVSOXEI32_V_M4_M4_MASK }, // 286
  { 0x1, 0x0, 0x1, 0x5, 0x2, 0x3, PseudoVSOXEI32_V_M8_M4_MASK }, // 287
  { 0x1, 0x0, 0x1, 0x5, 0x3, 0x2, PseudoVSOXEI32_V_M4_M8_MASK }, // 288
  { 0x1, 0x0, 0x1, 0x5, 0x3, 0x3, PseudoVSOXEI32_V_M8_M8_MASK }, // 289
  { 0x1, 0x0, 0x1, 0x5, 0x5, 0x7, PseudoVSOXEI32_V_MF2_MF8_MASK }, // 290
  { 0x1, 0x0, 0x1, 0x5, 0x6, 0x0, PseudoVSOXEI32_V_M1_MF4_MASK }, // 291
  { 0x1, 0x0, 0x1, 0x5, 0x6, 0x7, PseudoVSOXEI32_V_MF2_MF4_MASK }, // 292
  { 0x1, 0x0, 0x1, 0x5, 0x7, 0x0, PseudoVSOXEI32_V_M1_MF2_MASK }, // 293
  { 0x1, 0x0, 0x1, 0x5, 0x7, 0x1, PseudoVSOXEI32_V_M2_MF2_MASK }, // 294
  { 0x1, 0x0, 0x1, 0x5, 0x7, 0x7, PseudoVSOXEI32_V_MF2_MF2_MASK }, // 295
  { 0x1, 0x0, 0x1, 0x6, 0x0, 0x0, PseudoVSOXEI64_V_M1_M1_MASK }, // 296
  { 0x1, 0x0, 0x1, 0x6, 0x0, 0x1, PseudoVSOXEI64_V_M2_M1_MASK }, // 297
  { 0x1, 0x0, 0x1, 0x6, 0x0, 0x2, PseudoVSOXEI64_V_M4_M1_MASK }, // 298
  { 0x1, 0x0, 0x1, 0x6, 0x0, 0x3, PseudoVSOXEI64_V_M8_M1_MASK }, // 299
  { 0x1, 0x0, 0x1, 0x6, 0x1, 0x1, PseudoVSOXEI64_V_M2_M2_MASK }, // 300
  { 0x1, 0x0, 0x1, 0x6, 0x1, 0x2, PseudoVSOXEI64_V_M4_M2_MASK }, // 301
  { 0x1, 0x0, 0x1, 0x6, 0x1, 0x3, PseudoVSOXEI64_V_M8_M2_MASK }, // 302
  { 0x1, 0x0, 0x1, 0x6, 0x2, 0x2, PseudoVSOXEI64_V_M4_M4_MASK }, // 303
  { 0x1, 0x0, 0x1, 0x6, 0x2, 0x3, PseudoVSOXEI64_V_M8_M4_MASK }, // 304
  { 0x1, 0x0, 0x1, 0x6, 0x3, 0x3, PseudoVSOXEI64_V_M8_M8_MASK }, // 305
  { 0x1, 0x0, 0x1, 0x6, 0x5, 0x0, PseudoVSOXEI64_V_M1_MF8_MASK }, // 306
  { 0x1, 0x0, 0x1, 0x6, 0x6, 0x0, PseudoVSOXEI64_V_M1_MF4_MASK }, // 307
  { 0x1, 0x0, 0x1, 0x6, 0x6, 0x1, PseudoVSOXEI64_V_M2_MF4_MASK }, // 308
  { 0x1, 0x0, 0x1, 0x6, 0x7, 0x0, PseudoVSOXEI64_V_M1_MF2_MASK }, // 309
  { 0x1, 0x0, 0x1, 0x6, 0x7, 0x1, PseudoVSOXEI64_V_M2_MF2_MASK }, // 310
  { 0x1, 0x0, 0x1, 0x6, 0x7, 0x2, PseudoVSOXEI64_V_M4_MF2_MASK }, // 311
 };

const VLX_VSXPseudo *getVSXPseudo(uint8_t Masked, uint8_t IsTU, uint8_t Ordered, uint8_t Log2SEW, uint8_t LMUL, uint8_t IndexLMUL) {
  struct KeyType {
    uint8_t Masked;
    uint8_t IsTU;
    uint8_t Ordered;
    uint8_t Log2SEW;
    uint8_t LMUL;
    uint8_t IndexLMUL;
  };
  KeyType Key = {Masked, IsTU, Ordered, Log2SEW, LMUL, IndexLMUL};
  auto Table = ArrayRef(RISCVVSXTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const VLX_VSXPseudo &LHS, const KeyType &RHS) {
      if (LHS.Masked < RHS.Masked)
        return true;
      if (LHS.Masked > RHS.Masked)
        return false;
      if (LHS.IsTU < RHS.IsTU)
        return true;
      if (LHS.IsTU > RHS.IsTU)
        return false;
      if (LHS.Ordered < RHS.Ordered)
        return true;
      if (LHS.Ordered > RHS.Ordered)
        return false;
      if (LHS.Log2SEW < RHS.Log2SEW)
        return true;
      if (LHS.Log2SEW > RHS.Log2SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      if (LHS.IndexLMUL < RHS.IndexLMUL)
        return true;
      if (LHS.IndexLMUL > RHS.IndexLMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Masked != Idx->Masked ||
      Key.IsTU != Idx->IsTU ||
      Key.Ordered != Idx->Ordered ||
      Key.Log2SEW != Idx->Log2SEW ||
      Key.LMUL != Idx->LMUL ||
      Key.IndexLMUL != Idx->IndexLMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_SysRegsList_DECL
const SysReg *lookupSysRegByEncoding(uint16_t Encoding);
const SysReg *lookupSysRegByAltName(StringRef AltName);
const SysReg *lookupSysRegByDeprecatedName(StringRef DeprecatedName);
const SysReg *lookupSysRegByName(StringRef Name);
#endif

#ifdef GET_SysRegsList_IMPL
constexpr SysReg SysRegsList[] = {
  { "fflags", "fflags", "", 0x1,  {} , false }, // 0
  { "frm", "frm", "", 0x2,  {} , false }, // 1
  { "fcsr", "fcsr", "", 0x3,  {} , false }, // 2
  { "vstart", "vstart", "", 0x8,  {} , false }, // 3
  { "vxsat", "vxsat", "", 0x9,  {} , false }, // 4
  { "vxrm", "vxrm", "", 0xA,  {} , false }, // 5
  { "vcsr", "vcsr", "", 0xF,  {} , false }, // 6
  { "seed", "seed", "", 0x15,  {} , false }, // 7
  { "jvt", "jvt", "", 0x17,  {} , false }, // 8
  { "sstatus", "sstatus", "", 0x100,  {} , false }, // 9
  { "sie", "sie", "", 0x104,  {} , false }, // 10
  { "stvec", "stvec", "", 0x105,  {} , false }, // 11
  { "scounteren", "scounteren", "", 0x106,  {} , false }, // 12
  { "senvcfg", "senvcfg", "", 0x10A,  {} , false }, // 13
  { "sstateen0", "sstateen0", "", 0x10C,  {} , false }, // 14
  { "sstateen1", "sstateen1", "", 0x10D,  {} , false }, // 15
  { "sstateen2", "sstateen2", "", 0x10E,  {} , false }, // 16
  { "sstateen3", "sstateen3", "", 0x10F,  {} , false }, // 17
  { "sieh", "sieh", "", 0x114,  {} , true }, // 18
  { "sscratch", "sscratch", "", 0x140,  {} , false }, // 19
  { "sepc", "sepc", "", 0x141,  {} , false }, // 20
  { "scause", "scause", "", 0x142,  {} , false }, // 21
  { "stval", "stval", "sbadaddr", 0x143,  {} , false }, // 22
  { "sip", "sip", "", 0x144,  {} , false }, // 23
  { "stimecmp", "stimecmp", "", 0x14D,  {} , false }, // 24
  { "siselect", "siselect", "", 0x150,  {} , false }, // 25
  { "sireg", "sireg", "", 0x151,  {} , false }, // 26
  { "siph", "siph", "", 0x154,  {} , true }, // 27
  { "stopei", "stopei", "", 0x15C,  {} , false }, // 28
  { "stimecmph", "stimecmph", "", 0x15D,  {} , true }, // 29
  { "satp", "satp", "sptbr", 0x180,  {} , false }, // 30
  { "vsstatus", "vsstatus", "", 0x200,  {} , false }, // 31
  { "vsie", "vsie", "", 0x204,  {} , false }, // 32
  { "vstvec", "vstvec", "", 0x205,  {} , false }, // 33
  { "vsieh", "vsieh", "", 0x214,  {} , true }, // 34
  { "vsscratch", "vsscratch", "", 0x240,  {} , false }, // 35
  { "vsepc", "vsepc", "", 0x241,  {} , false }, // 36
  { "vscause", "vscause", "", 0x242,  {} , false }, // 37
  { "vstval", "vstval", "", 0x243,  {} , false }, // 38
  { "vsip", "vsip", "", 0x244,  {} , false }, // 39
  { "vstimecmp", "vstimecmp", "", 0x24D,  {} , false }, // 40
  { "vsiselect", "vsiselect", "", 0x250,  {} , false }, // 41
  { "vsireg", "vsireg", "", 0x251,  {} , false }, // 42
  { "vsiph", "vsiph", "", 0x254,  {} , true }, // 43
  { "vstopei", "vstopei", "", 0x25C,  {} , false }, // 44
  { "vstimecmph", "vstimecmph", "", 0x25D,  {} , true }, // 45
  { "vsatp", "vsatp", "", 0x280,  {} , false }, // 46
  { "mstatus", "mstatus", "", 0x300,  {} , false }, // 47
  { "misa", "misa", "", 0x301,  {} , false }, // 48
  { "medeleg", "medeleg", "", 0x302,  {} , false }, // 49
  { "mideleg", "mideleg", "", 0x303,  {} , false }, // 50
  { "mie", "mie", "", 0x304,  {} , false }, // 51
  { "mtvec", "mtvec", "", 0x305,  {} , false }, // 52
  { "mcounteren", "mcounteren", "", 0x306,  {} , false }, // 53
  { "mvien", "mvien", "", 0x308,  {} , false }, // 54
  { "mvip", "mvip", "", 0x309,  {} , false }, // 55
  { "menvcfg", "menvcfg", "", 0x30A,  {} , false }, // 56
  { "mstateen0", "mstateen0", "", 0x30C,  {} , false }, // 57
  { "mstateen1", "mstateen1", "", 0x30D,  {} , false }, // 58
  { "mstateen2", "mstateen2", "", 0x30E,  {} , false }, // 59
  { "mstateen3", "mstateen3", "", 0x30F,  {} , false }, // 60
  { "mstatush", "mstatush", "", 0x310,  {} , true }, // 61
  { "midelegh", "midelegh", "", 0x313,  {} , true }, // 62
  { "mieh", "mieh", "", 0x314,  {} , true }, // 63
  { "mvienh", "mvienh", "", 0x318,  {} , true }, // 64
  { "mviph", "mviph", "", 0x319,  {} , true }, // 65
  { "menvcfgh", "menvcfgh", "", 0x31A,  {} , true }, // 66
  { "mstateen0h", "mstateen0h", "", 0x31C,  {} , true }, // 67
  { "mstateen1h", "mstateen1h", "", 0x31D,  {} , true }, // 68
  { "mstateen2h", "mstateen2h", "", 0x31E,  {} , true }, // 69
  { "mstateen3h", "mstateen3h", "", 0x31F,  {} , true }, // 70
  { "mcountinhibit", "mucounteren", "", 0x320,  {} , false }, // 71
  { "mhpmevent3", "mhpmevent3", "", 0x323,  {} , false }, // 72
  { "mhpmevent4", "mhpmevent4", "", 0x324,  {} , false }, // 73
  { "mhpmevent5", "mhpmevent5", "", 0x325,  {} , false }, // 74
  { "mhpmevent6", "mhpmevent6", "", 0x326,  {} , false }, // 75
  { "mhpmevent7", "mhpmevent7", "", 0x327,  {} , false }, // 76
  { "mhpmevent8", "mhpmevent8", "", 0x328,  {} , false }, // 77
  { "mhpmevent9", "mhpmevent9", "", 0x329,  {} , false }, // 78
  { "mhpmevent10", "mhpmevent10", "", 0x32A,  {} , false }, // 79
  { "mhpmevent11", "mhpmevent11", "", 0x32B,  {} , false }, // 80
  { "mhpmevent12", "mhpmevent12", "", 0x32C,  {} , false }, // 81
  { "mhpmevent13", "mhpmevent13", "", 0x32D,  {} , false }, // 82
  { "mhpmevent14", "mhpmevent14", "", 0x32E,  {} , false }, // 83
  { "mhpmevent15", "mhpmevent15", "", 0x32F,  {} , false }, // 84
  { "mhpmevent16", "mhpmevent16", "", 0x330,  {} , false }, // 85
  { "mhpmevent17", "mhpmevent17", "", 0x331,  {} , false }, // 86
  { "mhpmevent18", "mhpmevent18", "", 0x332,  {} , false }, // 87
  { "mhpmevent19", "mhpmevent19", "", 0x333,  {} , false }, // 88
  { "mhpmevent20", "mhpmevent20", "", 0x334,  {} , false }, // 89
  { "mhpmevent21", "mhpmevent21", "", 0x335,  {} , false }, // 90
  { "mhpmevent22", "mhpmevent22", "", 0x336,  {} , false }, // 91
  { "mhpmevent23", "mhpmevent23", "", 0x337,  {} , false }, // 92
  { "mhpmevent24", "mhpmevent24", "", 0x338,  {} , false }, // 93
  { "mhpmevent25", "mhpmevent25", "", 0x339,  {} , false }, // 94
  { "mhpmevent26", "mhpmevent26", "", 0x33A,  {} , false }, // 95
  { "mhpmevent27", "mhpmevent27", "", 0x33B,  {} , false }, // 96
  { "mhpmevent28", "mhpmevent28", "", 0x33C,  {} , false }, // 97
  { "mhpmevent29", "mhpmevent29", "", 0x33D,  {} , false }, // 98
  { "mhpmevent30", "mhpmevent30", "", 0x33E,  {} , false }, // 99
  { "mhpmevent31", "mhpmevent31", "", 0x33F,  {} , false }, // 100
  { "mscratch", "mscratch", "", 0x340,  {} , false }, // 101
  { "mepc", "mepc", "", 0x341,  {} , false }, // 102
  { "mcause", "mcause", "", 0x342,  {} , false }, // 103
  { "mtval", "mtval", "mbadaddr", 0x343,  {} , false }, // 104
  { "mip", "mip", "", 0x344,  {} , false }, // 105
  { "mtinst", "mtinst", "", 0x34A,  {} , false }, // 106
  { "mtval2", "mtval2", "", 0x34B,  {} , false }, // 107
  { "miselect", "miselect", "", 0x350,  {} , false }, // 108
  { "mireg", "mireg", "", 0x351,  {} , false }, // 109
  { "miph", "miph", "", 0x354,  {} , true }, // 110
  { "mtopei", "mtopei", "", 0x35C,  {} , false }, // 111
  { "pmpcfg0", "pmpcfg0", "", 0x3A0,  {} , false }, // 112
  { "pmpcfg1", "pmpcfg1", "", 0x3A1,  {} , true }, // 113
  { "pmpcfg2", "pmpcfg2", "", 0x3A2,  {} , false }, // 114
  { "pmpcfg3", "pmpcfg3", "", 0x3A3,  {} , true }, // 115
  { "pmpcfg4", "pmpcfg4", "", 0x3A4,  {} , false }, // 116
  { "pmpcfg5", "pmpcfg5", "", 0x3A5,  {} , true }, // 117
  { "pmpcfg6", "pmpcfg6", "", 0x3A6,  {} , false }, // 118
  { "pmpcfg7", "pmpcfg7", "", 0x3A7,  {} , true }, // 119
  { "pmpcfg8", "pmpcfg8", "", 0x3A8,  {} , false }, // 120
  { "pmpcfg9", "pmpcfg9", "", 0x3A9,  {} , true }, // 121
  { "pmpcfg10", "pmpcfg10", "", 0x3AA,  {} , false }, // 122
  { "pmpcfg11", "pmpcfg11", "", 0x3AB,  {} , true }, // 123
  { "pmpcfg12", "pmpcfg12", "", 0x3AC,  {} , false }, // 124
  { "pmpcfg13", "pmpcfg13", "", 0x3AD,  {} , true }, // 125
  { "pmpcfg14", "pmpcfg14", "", 0x3AE,  {} , false }, // 126
  { "pmpcfg15", "pmpcfg15", "", 0x3AF,  {} , true }, // 127
  { "pmpaddr0", "pmpaddr0", "", 0x3B0,  {} , false }, // 128
  { "pmpaddr1", "pmpaddr1", "", 0x3B1,  {} , false }, // 129
  { "pmpaddr2", "pmpaddr2", "", 0x3B2,  {} , false }, // 130
  { "pmpaddr3", "pmpaddr3", "", 0x3B3,  {} , false }, // 131
  { "pmpaddr4", "pmpaddr4", "", 0x3B4,  {} , false }, // 132
  { "pmpaddr5", "pmpaddr5", "", 0x3B5,  {} , false }, // 133
  { "pmpaddr6", "pmpaddr6", "", 0x3B6,  {} , false }, // 134
  { "pmpaddr7", "pmpaddr7", "", 0x3B7,  {} , false }, // 135
  { "pmpaddr8", "pmpaddr8", "", 0x3B8,  {} , false }, // 136
  { "pmpaddr9", "pmpaddr9", "", 0x3B9,  {} , false }, // 137
  { "pmpaddr10", "pmpaddr10", "", 0x3BA,  {} , false }, // 138
  { "pmpaddr11", "pmpaddr11", "", 0x3BB,  {} , false }, // 139
  { "pmpaddr12", "pmpaddr12", "", 0x3BC,  {} , false }, // 140
  { "pmpaddr13", "pmpaddr13", "", 0x3BD,  {} , false }, // 141
  { "pmpaddr14", "pmpaddr14", "", 0x3BE,  {} , false }, // 142
  { "pmpaddr15", "pmpaddr15", "", 0x3BF,  {} , false }, // 143
  { "pmpaddr16", "pmpaddr16", "", 0x3C0,  {} , false }, // 144
  { "pmpaddr17", "pmpaddr17", "", 0x3C1,  {} , false }, // 145
  { "pmpaddr18", "pmpaddr18", "", 0x3C2,  {} , false }, // 146
  { "pmpaddr19", "pmpaddr19", "", 0x3C3,  {} , false }, // 147
  { "pmpaddr20", "pmpaddr20", "", 0x3C4,  {} , false }, // 148
  { "pmpaddr21", "pmpaddr21", "", 0x3C5,  {} , false }, // 149
  { "pmpaddr22", "pmpaddr22", "", 0x3C6,  {} , false }, // 150
  { "pmpaddr23", "pmpaddr23", "", 0x3C7,  {} , false }, // 151
  { "pmpaddr24", "pmpaddr24", "", 0x3C8,  {} , false }, // 152
  { "pmpaddr25", "pmpaddr25", "", 0x3C9,  {} , false }, // 153
  { "pmpaddr26", "pmpaddr26", "", 0x3CA,  {} , false }, // 154
  { "pmpaddr27", "pmpaddr27", "", 0x3CB,  {} , false }, // 155
  { "pmpaddr28", "pmpaddr28", "", 0x3CC,  {} , false }, // 156
  { "pmpaddr29", "pmpaddr29", "", 0x3CD,  {} , false }, // 157
  { "pmpaddr30", "pmpaddr30", "", 0x3CE,  {} , false }, // 158
  { "pmpaddr31", "pmpaddr31", "", 0x3CF,  {} , false }, // 159
  { "pmpaddr32", "pmpaddr32", "", 0x3D0,  {} , false }, // 160
  { "pmpaddr33", "pmpaddr33", "", 0x3D1,  {} , false }, // 161
  { "pmpaddr34", "pmpaddr34", "", 0x3D2,  {} , false }, // 162
  { "pmpaddr35", "pmpaddr35", "", 0x3D3,  {} , false }, // 163
  { "pmpaddr36", "pmpaddr36", "", 0x3D4,  {} , false }, // 164
  { "pmpaddr37", "pmpaddr37", "", 0x3D5,  {} , false }, // 165
  { "pmpaddr38", "pmpaddr38", "", 0x3D6,  {} , false }, // 166
  { "pmpaddr39", "pmpaddr39", "", 0x3D7,  {} , false }, // 167
  { "pmpaddr40", "pmpaddr40", "", 0x3D8,  {} , false }, // 168
  { "pmpaddr41", "pmpaddr41", "", 0x3D9,  {} , false }, // 169
  { "pmpaddr42", "pmpaddr42", "", 0x3DA,  {} , false }, // 170
  { "pmpaddr43", "pmpaddr43", "", 0x3DB,  {} , false }, // 171
  { "pmpaddr44", "pmpaddr44", "", 0x3DC,  {} , false }, // 172
  { "pmpaddr45", "pmpaddr45", "", 0x3DD,  {} , false }, // 173
  { "pmpaddr46", "pmpaddr46", "", 0x3DE,  {} , false }, // 174
  { "pmpaddr47", "pmpaddr47", "", 0x3DF,  {} , false }, // 175
  { "pmpaddr48", "pmpaddr48", "", 0x3E0,  {} , false }, // 176
  { "pmpaddr49", "pmpaddr49", "", 0x3E1,  {} , false }, // 177
  { "pmpaddr50", "pmpaddr50", "", 0x3E2,  {} , false }, // 178
  { "pmpaddr51", "pmpaddr51", "", 0x3E3,  {} , false }, // 179
  { "pmpaddr52", "pmpaddr52", "", 0x3E4,  {} , false }, // 180
  { "pmpaddr53", "pmpaddr53", "", 0x3E5,  {} , false }, // 181
  { "pmpaddr54", "pmpaddr54", "", 0x3E6,  {} , false }, // 182
  { "pmpaddr55", "pmpaddr55", "", 0x3E7,  {} , false }, // 183
  { "pmpaddr56", "pmpaddr56", "", 0x3E8,  {} , false }, // 184
  { "pmpaddr57", "pmpaddr57", "", 0x3E9,  {} , false }, // 185
  { "pmpaddr58", "pmpaddr58", "", 0x3EA,  {} , false }, // 186
  { "pmpaddr59", "pmpaddr59", "", 0x3EB,  {} , false }, // 187
  { "pmpaddr60", "pmpaddr60", "", 0x3EC,  {} , false }, // 188
  { "pmpaddr61", "pmpaddr61", "", 0x3ED,  {} , false }, // 189
  { "pmpaddr62", "pmpaddr62", "", 0x3EE,  {} , false }, // 190
  { "pmpaddr63", "pmpaddr63", "", 0x3EF,  {} , false }, // 191
  { "scontext", "scontext", "", 0x5A8,  {} , false }, // 192
  { "hstatus", "hstatus", "", 0x600,  {} , false }, // 193
  { "hedeleg", "hedeleg", "", 0x602,  {} , false }, // 194
  { "hideleg", "hideleg", "", 0x603,  {} , false }, // 195
  { "hie", "hie", "", 0x604,  {} , false }, // 196
  { "htimedelta", "htimedelta", "", 0x605,  {} , false }, // 197
  { "hcounteren", "hcounteren", "", 0x606,  {} , false }, // 198
  { "hgeie", "hgeie", "", 0x607,  {} , false }, // 199
  { "hvien", "hvien", "", 0x608,  {} , false }, // 200
  { "hvictl", "hvictl", "", 0x609,  {} , false }, // 201
  { "henvcfg", "henvcfg", "", 0x60A,  {} , false }, // 202
  { "hstateen0", "hstateen0", "", 0x60C,  {} , false }, // 203
  { "hstateen1", "hstateen1", "", 0x60D,  {} , false }, // 204
  { "hstateen2", "hstateen2", "", 0x60E,  {} , false }, // 205
  { "hstateen3", "hstateen3", "", 0x60F,  {} , false }, // 206
  { "hidelegh", "hidelegh", "", 0x613,  {} , true }, // 207
  { "htimedeltah", "htimedeltah", "", 0x615,  {} , true }, // 208
  { "hvienh", "hvienh", "", 0x618,  {} , true }, // 209
  { "henvcfgh", "henvcfgh", "", 0x61A,  {} , true }, // 210
  { "hstateen0h", "hstateen0h", "", 0x61C,  {} , true }, // 211
  { "hstateen1h", "hstateen1h", "", 0x61D,  {} , true }, // 212
  { "hstateen2h", "hstateen2h", "", 0x61E,  {} , true }, // 213
  { "hstateen3h", "hstateen3h", "", 0x61F,  {} , true }, // 214
  { "htval", "htval", "", 0x643,  {} , false }, // 215
  { "hip", "hip", "", 0x644,  {} , false }, // 216
  { "hvip", "hvip", "", 0x645,  {} , false }, // 217
  { "hviprio1", "hviprio1", "", 0x646,  {} , false }, // 218
  { "hviprio2", "hviprio2", "", 0x647,  {} , false }, // 219
  { "htinst", "htinst", "", 0x64A,  {} , false }, // 220
  { "hviph", "hviph", "", 0x655,  {} , true }, // 221
  { "hviprio1h", "hviprio1h", "", 0x656,  {} , true }, // 222
  { "hviprio2h", "hviprio2h", "", 0x657,  {} , true }, // 223
  { "hgatp", "hgatp", "", 0x680,  {} , false }, // 224
  { "hcontext", "hcontext", "", 0x6A8,  {} , false }, // 225
  { "mhpmevent3h", "mhpmevent3h", "", 0x723,  {} , true }, // 226
  { "mhpmevent4h", "mhpmevent4h", "", 0x724,  {} , true }, // 227
  { "mhpmevent5h", "mhpmevent5h", "", 0x725,  {} , true }, // 228
  { "mhpmevent6h", "mhpmevent6h", "", 0x726,  {} , true }, // 229
  { "mhpmevent7h", "mhpmevent7h", "", 0x727,  {} , true }, // 230
  { "mhpmevent8h", "mhpmevent8h", "", 0x728,  {} , true }, // 231
  { "mhpmevent9h", "mhpmevent9h", "", 0x729,  {} , true }, // 232
  { "mhpmevent10h", "mhpmevent10h", "", 0x72A,  {} , true }, // 233
  { "mhpmevent11h", "mhpmevent11h", "", 0x72B,  {} , true }, // 234
  { "mhpmevent12h", "mhpmevent12h", "", 0x72C,  {} , true }, // 235
  { "mhpmevent13h", "mhpmevent13h", "", 0x72D,  {} , true }, // 236
  { "mhpmevent14h", "mhpmevent14h", "", 0x72E,  {} , true }, // 237
  { "mhpmevent15h", "mhpmevent15h", "", 0x72F,  {} , true }, // 238
  { "mhpmevent16h", "mhpmevent16h", "", 0x730,  {} , true }, // 239
  { "mhpmevent17h", "mhpmevent17h", "", 0x731,  {} , true }, // 240
  { "mhpmevent18h", "mhpmevent18h", "", 0x732,  {} , true }, // 241
  { "mhpmevent19h", "mhpmevent19h", "", 0x733,  {} , true }, // 242
  { "mhpmevent20h", "mhpmevent20h", "", 0x734,  {} , true }, // 243
  { "mhpmevent21h", "mhpmevent21h", "", 0x735,  {} , true }, // 244
  { "mhpmevent22h", "mhpmevent22h", "", 0x736,  {} , true }, // 245
  { "mhpmevent23h", "mhpmevent23h", "", 0x737,  {} , true }, // 246
  { "mhpmevent24h", "mhpmevent24h", "", 0x738,  {} , true }, // 247
  { "mhpmevent25h", "mhpmevent25h", "", 0x739,  {} , true }, // 248
  { "mhpmevent26h", "mhpmevent26h", "", 0x73A,  {} , true }, // 249
  { "mhpmevent27h", "mhpmevent27h", "", 0x73B,  {} , true }, // 250
  { "mhpmevent28h", "mhpmevent28h", "", 0x73C,  {} , true }, // 251
  { "mhpmevent29h", "mhpmevent29h", "", 0x73D,  {} , true }, // 252
  { "mhpmevent30h", "mhpmevent30h", "", 0x73E,  {} , true }, // 253
  { "mhpmevent31h", "mhpmevent31h", "", 0x73F,  {} , true }, // 254
  { "mseccfg", "mseccfg", "", 0x747,  {} , false }, // 255
  { "mseccfgh", "mseccfgh", "", 0x757,  {} , true }, // 256
  { "tselect", "tselect", "", 0x7A0,  {} , false }, // 257
  { "tdata1", "tdata1", "", 0x7A1,  {} , false }, // 258
  { "tdata2", "tdata2", "", 0x7A2,  {} , false }, // 259
  { "tdata3", "tdata3", "", 0x7A3,  {} , false }, // 260
  { "mcontext", "mcontext", "", 0x7A8,  {} , false }, // 261
  { "dcsr", "dcsr", "", 0x7B0,  {} , false }, // 262
  { "dpc", "dpc", "", 0x7B1,  {} , false }, // 263
  { "dscratch0", "dscratch", "", 0x7B2,  {} , false }, // 264
  { "dscratch1", "dscratch1", "", 0x7B3,  {} , false }, // 265
  { "mcycle", "mcycle", "", 0xB00,  {} , false }, // 266
  { "minstret", "minstret", "", 0xB02,  {} , false }, // 267
  { "mhpmcounter3", "mhpmcounter3", "", 0xB03,  {} , false }, // 268
  { "mhpmcounter4", "mhpmcounter4", "", 0xB04,  {} , false }, // 269
  { "mhpmcounter5", "mhpmcounter5", "", 0xB05,  {} , false }, // 270
  { "mhpmcounter6", "mhpmcounter6", "", 0xB06,  {} , false }, // 271
  { "mhpmcounter7", "mhpmcounter7", "", 0xB07,  {} , false }, // 272
  { "mhpmcounter8", "mhpmcounter8", "", 0xB08,  {} , false }, // 273
  { "mhpmcounter9", "mhpmcounter9", "", 0xB09,  {} , false }, // 274
  { "mhpmcounter10", "mhpmcounter10", "", 0xB0A,  {} , false }, // 275
  { "mhpmcounter11", "mhpmcounter11", "", 0xB0B,  {} , false }, // 276
  { "mhpmcounter12", "mhpmcounter12", "", 0xB0C,  {} , false }, // 277
  { "mhpmcounter13", "mhpmcounter13", "", 0xB0D,  {} , false }, // 278
  { "mhpmcounter14", "mhpmcounter14", "", 0xB0E,  {} , false }, // 279
  { "mhpmcounter15", "mhpmcounter15", "", 0xB0F,  {} , false }, // 280
  { "mhpmcounter16", "mhpmcounter16", "", 0xB10,  {} , false }, // 281
  { "mhpmcounter17", "mhpmcounter17", "", 0xB11,  {} , false }, // 282
  { "mhpmcounter18", "mhpmcounter18", "", 0xB12,  {} , false }, // 283
  { "mhpmcounter19", "mhpmcounter19", "", 0xB13,  {} , false }, // 284
  { "mhpmcounter20", "mhpmcounter20", "", 0xB14,  {} , false }, // 285
  { "mhpmcounter21", "mhpmcounter21", "", 0xB15,  {} , false }, // 286
  { "mhpmcounter22", "mhpmcounter22", "", 0xB16,  {} , false }, // 287
  { "mhpmcounter23", "mhpmcounter23", "", 0xB17,  {} , false }, // 288
  { "mhpmcounter24", "mhpmcounter24", "", 0xB18,  {} , false }, // 289
  { "mhpmcounter25", "mhpmcounter25", "", 0xB19,  {} , false }, // 290
  { "mhpmcounter26", "mhpmcounter26", "", 0xB1A,  {} , false }, // 291
  { "mhpmcounter27", "mhpmcounter27", "", 0xB1B,  {} , false }, // 292
  { "mhpmcounter28", "mhpmcounter28", "", 0xB1C,  {} , false }, // 293
  { "mhpmcounter29", "mhpmcounter29", "", 0xB1D,  {} , false }, // 294
  { "mhpmcounter30", "mhpmcounter30", "", 0xB1E,  {} , false }, // 295
  { "mhpmcounter31", "mhpmcounter31", "", 0xB1F,  {} , false }, // 296
  { "mcycleh", "mcycleh", "", 0xB80,  {} , true }, // 297
  { "minstreth", "minstreth", "", 0xB82,  {} , true }, // 298
  { "mhpmcounter3h", "mhpmcounter3h", "", 0xB83,  {} , true }, // 299
  { "mhpmcounter4h", "mhpmcounter4h", "", 0xB84,  {} , true }, // 300
  { "mhpmcounter5h", "mhpmcounter5h", "", 0xB85,  {} , true }, // 301
  { "mhpmcounter6h", "mhpmcounter6h", "", 0xB86,  {} , true }, // 302
  { "mhpmcounter7h", "mhpmcounter7h", "", 0xB87,  {} , true }, // 303
  { "mhpmcounter8h", "mhpmcounter8h", "", 0xB88,  {} , true }, // 304
  { "mhpmcounter9h", "mhpmcounter9h", "", 0xB89,  {} , true }, // 305
  { "mhpmcounter10h", "mhpmcounter10h", "", 0xB8A,  {} , true }, // 306
  { "mhpmcounter11h", "mhpmcounter11h", "", 0xB8B,  {} , true }, // 307
  { "mhpmcounter12h", "mhpmcounter12h", "", 0xB8C,  {} , true }, // 308
  { "mhpmcounter13h", "mhpmcounter13h", "", 0xB8D,  {} , true }, // 309
  { "mhpmcounter14h", "mhpmcounter14h", "", 0xB8E,  {} , true }, // 310
  { "mhpmcounter15h", "mhpmcounter15h", "", 0xB8F,  {} , true }, // 311
  { "mhpmcounter16h", "mhpmcounter16h", "", 0xB90,  {} , true }, // 312
  { "mhpmcounter17h", "mhpmcounter17h", "", 0xB91,  {} , true }, // 313
  { "mhpmcounter18h", "mhpmcounter18h", "", 0xB92,  {} , true }, // 314
  { "mhpmcounter19h", "mhpmcounter19h", "", 0xB93,  {} , true }, // 315
  { "mhpmcounter20h", "mhpmcounter20h", "", 0xB94,  {} , true }, // 316
  { "mhpmcounter21h", "mhpmcounter21h", "", 0xB95,  {} , true }, // 317
  { "mhpmcounter22h", "mhpmcounter22h", "", 0xB96,  {} , true }, // 318
  { "mhpmcounter23h", "mhpmcounter23h", "", 0xB97,  {} , true }, // 319
  { "mhpmcounter24h", "mhpmcounter24h", "", 0xB98,  {} , true }, // 320
  { "mhpmcounter25h", "mhpmcounter25h", "", 0xB99,  {} , true }, // 321
  { "mhpmcounter26h", "mhpmcounter26h", "", 0xB9A,  {} , true }, // 322
  { "mhpmcounter27h", "mhpmcounter27h", "", 0xB9B,  {} , true }, // 323
  { "mhpmcounter28h", "mhpmcounter28h", "", 0xB9C,  {} , true }, // 324
  { "mhpmcounter29h", "mhpmcounter29h", "", 0xB9D,  {} , true }, // 325
  { "mhpmcounter30h", "mhpmcounter30h", "", 0xB9E,  {} , true }, // 326
  { "mhpmcounter31h", "mhpmcounter31h", "", 0xB9F,  {} , true }, // 327
  { "cycle", "cycle", "", 0xC00,  {} , false }, // 328
  { "time", "time", "", 0xC01,  {} , false }, // 329
  { "instret", "instret", "", 0xC02,  {} , false }, // 330
  { "hpmcounter3", "hpmcounter3", "", 0xC03,  {} , false }, // 331
  { "hpmcounter4", "hpmcounter4", "", 0xC04,  {} , false }, // 332
  { "hpmcounter5", "hpmcounter5", "", 0xC05,  {} , false }, // 333
  { "hpmcounter6", "hpmcounter6", "", 0xC06,  {} , false }, // 334
  { "hpmcounter7", "hpmcounter7", "", 0xC07,  {} , false }, // 335
  { "hpmcounter8", "hpmcounter8", "", 0xC08,  {} , false }, // 336
  { "hpmcounter9", "hpmcounter9", "", 0xC09,  {} , false }, // 337
  { "hpmcounter10", "hpmcounter10", "", 0xC0A,  {} , false }, // 338
  { "hpmcounter11", "hpmcounter11", "", 0xC0B,  {} , false }, // 339
  { "hpmcounter12", "hpmcounter12", "", 0xC0C,  {} , false }, // 340
  { "hpmcounter13", "hpmcounter13", "", 0xC0D,  {} , false }, // 341
  { "hpmcounter14", "hpmcounter14", "", 0xC0E,  {} , false }, // 342
  { "hpmcounter15", "hpmcounter15", "", 0xC0F,  {} , false }, // 343
  { "hpmcounter16", "hpmcounter16", "", 0xC10,  {} , false }, // 344
  { "hpmcounter17", "hpmcounter17", "", 0xC11,  {} , false }, // 345
  { "hpmcounter18", "hpmcounter18", "", 0xC12,  {} , false }, // 346
  { "hpmcounter19", "hpmcounter19", "", 0xC13,  {} , false }, // 347
  { "hpmcounter20", "hpmcounter20", "", 0xC14,  {} , false }, // 348
  { "hpmcounter21", "hpmcounter21", "", 0xC15,  {} , false }, // 349
  { "hpmcounter22", "hpmcounter22", "", 0xC16,  {} , false }, // 350
  { "hpmcounter23", "hpmcounter23", "", 0xC17,  {} , false }, // 351
  { "hpmcounter24", "hpmcounter24", "", 0xC18,  {} , false }, // 352
  { "hpmcounter25", "hpmcounter25", "", 0xC19,  {} , false }, // 353
  { "hpmcounter26", "hpmcounter26", "", 0xC1A,  {} , false }, // 354
  { "hpmcounter27", "hpmcounter27", "", 0xC1B,  {} , false }, // 355
  { "hpmcounter28", "hpmcounter28", "", 0xC1C,  {} , false }, // 356
  { "hpmcounter29", "hpmcounter29", "", 0xC1D,  {} , false }, // 357
  { "hpmcounter30", "hpmcounter30", "", 0xC1E,  {} , false }, // 358
  { "hpmcounter31", "hpmcounter31", "", 0xC1F,  {} , false }, // 359
  { "vl", "vl", "", 0xC20,  {} , false }, // 360
  { "vtype", "vtype", "", 0xC21,  {} , false }, // 361
  { "vlenb", "vlenb", "", 0xC22,  {} , false }, // 362
  { "cycleh", "cycleh", "", 0xC80,  {} , true }, // 363
  { "timeh", "timeh", "", 0xC81,  {} , true }, // 364
  { "instreth", "instreth", "", 0xC82,  {} , true }, // 365
  { "hpmcounter3h", "hpmcounter3h", "", 0xC83,  {} , true }, // 366
  { "hpmcounter4h", "hpmcounter4h", "", 0xC84,  {} , true }, // 367
  { "hpmcounter5h", "hpmcounter5h", "", 0xC85,  {} , true }, // 368
  { "hpmcounter6h", "hpmcounter6h", "", 0xC86,  {} , true }, // 369
  { "hpmcounter7h", "hpmcounter7h", "", 0xC87,  {} , true }, // 370
  { "hpmcounter8h", "hpmcounter8h", "", 0xC88,  {} , true }, // 371
  { "hpmcounter9h", "hpmcounter9h", "", 0xC89,  {} , true }, // 372
  { "hpmcounter10h", "hpmcounter10h", "", 0xC8A,  {} , true }, // 373
  { "hpmcounter11h", "hpmcounter11h", "", 0xC8B,  {} , true }, // 374
  { "hpmcounter12h", "hpmcounter12h", "", 0xC8C,  {} , true }, // 375
  { "hpmcounter13h", "hpmcounter13h", "", 0xC8D,  {} , true }, // 376
  { "hpmcounter14h", "hpmcounter14h", "", 0xC8E,  {} , true }, // 377
  { "hpmcounter15h", "hpmcounter15h", "", 0xC8F,  {} , true }, // 378
  { "hpmcounter16h", "hpmcounter16h", "", 0xC90,  {} , true }, // 379
  { "hpmcounter17h", "hpmcounter17h", "", 0xC91,  {} , true }, // 380
  { "hpmcounter18h", "hpmcounter18h", "", 0xC92,  {} , true }, // 381
  { "hpmcounter19h", "hpmcounter19h", "", 0xC93,  {} , true }, // 382
  { "hpmcounter20h", "hpmcounter20h", "", 0xC94,  {} , true }, // 383
  { "hpmcounter21h", "hpmcounter21h", "", 0xC95,  {} , true }, // 384
  { "hpmcounter22h", "hpmcounter22h", "", 0xC96,  {} , true }, // 385
  { "hpmcounter23h", "hpmcounter23h", "", 0xC97,  {} , true }, // 386
  { "hpmcounter24h", "hpmcounter24h", "", 0xC98,  {} , true }, // 387
  { "hpmcounter25h", "hpmcounter25h", "", 0xC99,  {} , true }, // 388
  { "hpmcounter26h", "hpmcounter26h", "", 0xC9A,  {} , true }, // 389
  { "hpmcounter27h", "hpmcounter27h", "", 0xC9B,  {} , true }, // 390
  { "hpmcounter28h", "hpmcounter28h", "", 0xC9C,  {} , true }, // 391
  { "hpmcounter29h", "hpmcounter29h", "", 0xC9D,  {} , true }, // 392
  { "hpmcounter30h", "hpmcounter30h", "", 0xC9E,  {} , true }, // 393
  { "hpmcounter31h", "hpmcounter31h", "", 0xC9F,  {} , true }, // 394
  { "scountovf", "scountovf", "", 0xDA0,  {} , false }, // 395
  { "stopi", "stopi", "", 0xDB0,  {} , false }, // 396
  { "hgeip", "hgeip", "", 0xE12,  {} , false }, // 397
  { "vstopi", "vstopi", "", 0xEB0,  {} , false }, // 398
  { "mvendorid", "mvendorid", "", 0xF11,  {} , false }, // 399
  { "marchid", "marchid", "", 0xF12,  {} , false }, // 400
  { "mimpid", "mimpid", "", 0xF13,  {} , false }, // 401
  { "mhartid", "mhartid", "", 0xF14,  {} , false }, // 402
  { "mconfigptr", "mconfigptr", "", 0xF15,  {} , false }, // 403
  { "mtopi", "mtopi", "", 0xFB0,  {} , false }, // 404
 };

const SysReg *lookupSysRegByEncoding(uint16_t Encoding) {
  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = ArrayRef(SysRegsList);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const SysReg &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &*Idx;
}

const SysReg *lookupSysRegByAltName(StringRef AltName) {
  struct IndexType {
    const char * AltName;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CYCLE", 328 },
    { "CYCLEH", 363 },
    { "DCSR", 262 },
    { "DPC", 263 },
    { "DSCRATCH", 264 },
    { "DSCRATCH1", 265 },
    { "FCSR", 2 },
    { "FFLAGS", 0 },
    { "FRM", 1 },
    { "HCONTEXT", 225 },
    { "HCOUNTEREN", 198 },
    { "HEDELEG", 194 },
    { "HENVCFG", 202 },
    { "HENVCFGH", 210 },
    { "HGATP", 224 },
    { "HGEIE", 199 },
    { "HGEIP", 397 },
    { "HIDELEG", 195 },
    { "HIDELEGH", 207 },
    { "HIE", 196 },
    { "HIP", 216 },
    { "HPMCOUNTER10", 338 },
    { "HPMCOUNTER10H", 373 },
    { "HPMCOUNTER11", 339 },
    { "HPMCOUNTER11H", 374 },
    { "HPMCOUNTER12", 340 },
    { "HPMCOUNTER12H", 375 },
    { "HPMCOUNTER13", 341 },
    { "HPMCOUNTER13H", 376 },
    { "HPMCOUNTER14", 342 },
    { "HPMCOUNTER14H", 377 },
    { "HPMCOUNTER15", 343 },
    { "HPMCOUNTER15H", 378 },
    { "HPMCOUNTER16", 344 },
    { "HPMCOUNTER16H", 379 },
    { "HPMCOUNTER17", 345 },
    { "HPMCOUNTER17H", 380 },
    { "HPMCOUNTER18", 346 },
    { "HPMCOUNTER18H", 381 },
    { "HPMCOUNTER19", 347 },
    { "HPMCOUNTER19H", 382 },
    { "HPMCOUNTER20", 348 },
    { "HPMCOUNTER20H", 383 },
    { "HPMCOUNTER21", 349 },
    { "HPMCOUNTER21H", 384 },
    { "HPMCOUNTER22", 350 },
    { "HPMCOUNTER22H", 385 },
    { "HPMCOUNTER23", 351 },
    { "HPMCOUNTER23H", 386 },
    { "HPMCOUNTER24", 352 },
    { "HPMCOUNTER24H", 387 },
    { "HPMCOUNTER25", 353 },
    { "HPMCOUNTER25H", 388 },
    { "HPMCOUNTER26", 354 },
    { "HPMCOUNTER26H", 389 },
    { "HPMCOUNTER27", 355 },
    { "HPMCOUNTER27H", 390 },
    { "HPMCOUNTER28", 356 },
    { "HPMCOUNTER28H", 391 },
    { "HPMCOUNTER29", 357 },
    { "HPMCOUNTER29H", 392 },
    { "HPMCOUNTER3", 331 },
    { "HPMCOUNTER30", 358 },
    { "HPMCOUNTER30H", 393 },
    { "HPMCOUNTER31", 359 },
    { "HPMCOUNTER31H", 394 },
    { "HPMCOUNTER3H", 366 },
    { "HPMCOUNTER4", 332 },
    { "HPMCOUNTER4H", 367 },
    { "HPMCOUNTER5", 333 },
    { "HPMCOUNTER5H", 368 },
    { "HPMCOUNTER6", 334 },
    { "HPMCOUNTER6H", 369 },
    { "HPMCOUNTER7", 335 },
    { "HPMCOUNTER7H", 370 },
    { "HPMCOUNTER8", 336 },
    { "HPMCOUNTER8H", 371 },
    { "HPMCOUNTER9", 337 },
    { "HPMCOUNTER9H", 372 },
    { "HSTATEEN0", 203 },
    { "HSTATEEN0H", 211 },
    { "HSTATEEN1", 204 },
    { "HSTATEEN1H", 212 },
    { "HSTATEEN2", 205 },
    { "HSTATEEN2H", 213 },
    { "HSTATEEN3", 206 },
    { "HSTATEEN3H", 214 },
    { "HSTATUS", 193 },
    { "HTIMEDELTA", 197 },
    { "HTIMEDELTAH", 208 },
    { "HTINST", 220 },
    { "HTVAL", 215 },
    { "HVICTL", 201 },
    { "HVIEN", 200 },
    { "HVIENH", 209 },
    { "HVIP", 217 },
    { "HVIPH", 221 },
    { "HVIPRIO1", 218 },
    { "HVIPRIO1H", 222 },
    { "HVIPRIO2", 219 },
    { "HVIPRIO2H", 223 },
    { "INSTRET", 330 },
    { "INSTRETH", 365 },
    { "JVT", 8 },
    { "MARCHID", 400 },
    { "MCAUSE", 103 },
    { "MCONFIGPTR", 403 },
    { "MCONTEXT", 261 },
    { "MCOUNTEREN", 53 },
    { "MCYCLE", 266 },
    { "MCYCLEH", 297 },
    { "MEDELEG", 49 },
    { "MENVCFG", 56 },
    { "MENVCFGH", 66 },
    { "MEPC", 102 },
    { "MHARTID", 402 },
    { "MHPMCOUNTER10", 275 },
    { "MHPMCOUNTER10H", 306 },
    { "MHPMCOUNTER11", 276 },
    { "MHPMCOUNTER11H", 307 },
    { "MHPMCOUNTER12", 277 },
    { "MHPMCOUNTER12H", 308 },
    { "MHPMCOUNTER13", 278 },
    { "MHPMCOUNTER13H", 309 },
    { "MHPMCOUNTER14", 279 },
    { "MHPMCOUNTER14H", 310 },
    { "MHPMCOUNTER15", 280 },
    { "MHPMCOUNTER15H", 311 },
    { "MHPMCOUNTER16", 281 },
    { "MHPMCOUNTER16H", 312 },
    { "MHPMCOUNTER17", 282 },
    { "MHPMCOUNTER17H", 313 },
    { "MHPMCOUNTER18", 283 },
    { "MHPMCOUNTER18H", 314 },
    { "MHPMCOUNTER19", 284 },
    { "MHPMCOUNTER19H", 315 },
    { "MHPMCOUNTER20", 285 },
    { "MHPMCOUNTER20H", 316 },
    { "MHPMCOUNTER21", 286 },
    { "MHPMCOUNTER21H", 317 },
    { "MHPMCOUNTER22", 287 },
    { "MHPMCOUNTER22H", 318 },
    { "MHPMCOUNTER23", 288 },
    { "MHPMCOUNTER23H", 319 },
    { "MHPMCOUNTER24", 289 },
    { "MHPMCOUNTER24H", 320 },
    { "MHPMCOUNTER25", 290 },
    { "MHPMCOUNTER25H", 321 },
    { "MHPMCOUNTER26", 291 },
    { "MHPMCOUNTER26H", 322 },
    { "MHPMCOUNTER27", 292 },
    { "MHPMCOUNTER27H", 323 },
    { "MHPMCOUNTER28", 293 },
    { "MHPMCOUNTER28H", 324 },
    { "MHPMCOUNTER29", 294 },
    { "MHPMCOUNTER29H", 325 },
    { "MHPMCOUNTER3", 268 },
    { "MHPMCOUNTER30", 295 },
    { "MHPMCOUNTER30H", 326 },
    { "MHPMCOUNTER31", 296 },
    { "MHPMCOUNTER31H", 327 },
    { "MHPMCOUNTER3H", 299 },
    { "MHPMCOUNTER4", 269 },
    { "MHPMCOUNTER4H", 300 },
    { "MHPMCOUNTER5", 270 },
    { "MHPMCOUNTER5H", 301 },
    { "MHPMCOUNTER6", 271 },
    { "MHPMCOUNTER6H", 302 },
    { "MHPMCOUNTER7", 272 },
    { "MHPMCOUNTER7H", 303 },
    { "MHPMCOUNTER8", 273 },
    { "MHPMCOUNTER8H", 304 },
    { "MHPMCOUNTER9", 274 },
    { "MHPMCOUNTER9H", 305 },
    { "MHPMEVENT10", 79 },
    { "MHPMEVENT10H", 233 },
    { "MHPMEVENT11", 80 },
    { "MHPMEVENT11H", 234 },
    { "MHPMEVENT12", 81 },
    { "MHPMEVENT12H", 235 },
    { "MHPMEVENT13", 82 },
    { "MHPMEVENT13H", 236 },
    { "MHPMEVENT14", 83 },
    { "MHPMEVENT14H", 237 },
    { "MHPMEVENT15", 84 },
    { "MHPMEVENT15H", 238 },
    { "MHPMEVENT16", 85 },
    { "MHPMEVENT16H", 239 },
    { "MHPMEVENT17", 86 },
    { "MHPMEVENT17H", 240 },
    { "MHPMEVENT18", 87 },
    { "MHPMEVENT18H", 241 },
    { "MHPMEVENT19", 88 },
    { "MHPMEVENT19H", 242 },
    { "MHPMEVENT20", 89 },
    { "MHPMEVENT20H", 243 },
    { "MHPMEVENT21", 90 },
    { "MHPMEVENT21H", 244 },
    { "MHPMEVENT22", 91 },
    { "MHPMEVENT22H", 245 },
    { "MHPMEVENT23", 92 },
    { "MHPMEVENT23H", 246 },
    { "MHPMEVENT24", 93 },
    { "MHPMEVENT24H", 247 },
    { "MHPMEVENT25", 94 },
    { "MHPMEVENT25H", 248 },
    { "MHPMEVENT26", 95 },
    { "MHPMEVENT26H", 249 },
    { "MHPMEVENT27", 96 },
    { "MHPMEVENT27H", 250 },
    { "MHPMEVENT28", 97 },
    { "MHPMEVENT28H", 251 },
    { "MHPMEVENT29", 98 },
    { "MHPMEVENT29H", 252 },
    { "MHPMEVENT3", 72 },
    { "MHPMEVENT30", 99 },
    { "MHPMEVENT30H", 253 },
    { "MHPMEVENT31", 100 },
    { "MHPMEVENT31H", 254 },
    { "MHPMEVENT3H", 226 },
    { "MHPMEVENT4", 73 },
    { "MHPMEVENT4H", 227 },
    { "MHPMEVENT5", 74 },
    { "MHPMEVENT5H", 228 },
    { "MHPMEVENT6", 75 },
    { "MHPMEVENT6H", 229 },
    { "MHPMEVENT7", 76 },
    { "MHPMEVENT7H", 230 },
    { "MHPMEVENT8", 77 },
    { "MHPMEVENT8H", 231 },
    { "MHPMEVENT9", 78 },
    { "MHPMEVENT9H", 232 },
    { "MIDELEG", 50 },
    { "MIDELEGH", 62 },
    { "MIE", 51 },
    { "MIEH", 63 },
    { "MIMPID", 401 },
    { "MINSTRET", 267 },
    { "MINSTRETH", 298 },
    { "MIP", 105 },
    { "MIPH", 110 },
    { "MIREG", 109 },
    { "MISA", 48 },
    { "MISELECT", 108 },
    { "MSCRATCH", 101 },
    { "MSECCFG", 255 },
    { "MSECCFGH", 256 },
    { "MSTATEEN0", 57 },
    { "MSTATEEN0H", 67 },
    { "MSTATEEN1", 58 },
    { "MSTATEEN1H", 68 },
    { "MSTATEEN2", 59 },
    { "MSTATEEN2H", 69 },
    { "MSTATEEN3", 60 },
    { "MSTATEEN3H", 70 },
    { "MSTATUS", 47 },
    { "MSTATUSH", 61 },
    { "MTINST", 106 },
    { "MTOPEI", 111 },
    { "MTOPI", 404 },
    { "MTVAL", 104 },
    { "MTVAL2", 107 },
    { "MTVEC", 52 },
    { "MUCOUNTEREN", 71 },
    { "MVENDORID", 399 },
    { "MVIEN", 54 },
    { "MVIENH", 64 },
    { "MVIP", 55 },
    { "MVIPH", 65 },
    { "PMPADDR0", 128 },
    { "PMPADDR1", 129 },
    { "PMPADDR10", 138 },
    { "PMPADDR11", 139 },
    { "PMPADDR12", 140 },
    { "PMPADDR13", 141 },
    { "PMPADDR14", 142 },
    { "PMPADDR15", 143 },
    { "PMPADDR16", 144 },
    { "PMPADDR17", 145 },
    { "PMPADDR18", 146 },
    { "PMPADDR19", 147 },
    { "PMPADDR2", 130 },
    { "PMPADDR20", 148 },
    { "PMPADDR21", 149 },
    { "PMPADDR22", 150 },
    { "PMPADDR23", 151 },
    { "PMPADDR24", 152 },
    { "PMPADDR25", 153 },
    { "PMPADDR26", 154 },
    { "PMPADDR27", 155 },
    { "PMPADDR28", 156 },
    { "PMPADDR29", 157 },
    { "PMPADDR3", 131 },
    { "PMPADDR30", 158 },
    { "PMPADDR31", 159 },
    { "PMPADDR32", 160 },
    { "PMPADDR33", 161 },
    { "PMPADDR34", 162 },
    { "PMPADDR35", 163 },
    { "PMPADDR36", 164 },
    { "PMPADDR37", 165 },
    { "PMPADDR38", 166 },
    { "PMPADDR39", 167 },
    { "PMPADDR4", 132 },
    { "PMPADDR40", 168 },
    { "PMPADDR41", 169 },
    { "PMPADDR42", 170 },
    { "PMPADDR43", 171 },
    { "PMPADDR44", 172 },
    { "PMPADDR45", 173 },
    { "PMPADDR46", 174 },
    { "PMPADDR47", 175 },
    { "PMPADDR48", 176 },
    { "PMPADDR49", 177 },
    { "PMPADDR5", 133 },
    { "PMPADDR50", 178 },
    { "PMPADDR51", 179 },
    { "PMPADDR52", 180 },
    { "PMPADDR53", 181 },
    { "PMPADDR54", 182 },
    { "PMPADDR55", 183 },
    { "PMPADDR56", 184 },
    { "PMPADDR57", 185 },
    { "PMPADDR58", 186 },
    { "PMPADDR59", 187 },
    { "PMPADDR6", 134 },
    { "PMPADDR60", 188 },
    { "PMPADDR61", 189 },
    { "PMPADDR62", 190 },
    { "PMPADDR63", 191 },
    { "PMPADDR7", 135 },
    { "PMPADDR8", 136 },
    { "PMPADDR9", 137 },
    { "PMPCFG0", 112 },
    { "PMPCFG1", 113 },
    { "PMPCFG10", 122 },
    { "PMPCFG11", 123 },
    { "PMPCFG12", 124 },
    { "PMPCFG13", 125 },
    { "PMPCFG14", 126 },
    { "PMPCFG15", 127 },
    { "PMPCFG2", 114 },
    { "PMPCFG3", 115 },
    { "PMPCFG4", 116 },
    { "PMPCFG5", 117 },
    { "PMPCFG6", 118 },
    { "PMPCFG7", 119 },
    { "PMPCFG8", 120 },
    { "PMPCFG9", 121 },
    { "SATP", 30 },
    { "SCAUSE", 21 },
    { "SCONTEXT", 192 },
    { "SCOUNTEREN", 12 },
    { "SCOUNTOVF", 395 },
    { "SEED", 7 },
    { "SENVCFG", 13 },
    { "SEPC", 20 },
    { "SIE", 10 },
    { "SIEH", 18 },
    { "SIP", 23 },
    { "SIPH", 27 },
    { "SIREG", 26 },
    { "SISELECT", 25 },
    { "SSCRATCH", 19 },
    { "SSTATEEN0", 14 },
    { "SSTATEEN1", 15 },
    { "SSTATEEN2", 16 },
    { "SSTATEEN3", 17 },
    { "SSTATUS", 9 },
    { "STIMECMP", 24 },
    { "STIMECMPH", 29 },
    { "STOPEI", 28 },
    { "STOPI", 396 },
    { "STVAL", 22 },
    { "STVEC", 11 },
    { "TDATA1", 258 },
    { "TDATA2", 259 },
    { "TDATA3", 260 },
    { "TIME", 329 },
    { "TIMEH", 364 },
    { "TSELECT", 257 },
    { "VCSR", 6 },
    { "VL", 360 },
    { "VLENB", 362 },
    { "VSATP", 46 },
    { "VSCAUSE", 37 },
    { "VSEPC", 36 },
    { "VSIE", 32 },
    { "VSIEH", 34 },
    { "VSIP", 39 },
    { "VSIPH", 43 },
    { "VSIREG", 42 },
    { "VSISELECT", 41 },
    { "VSSCRATCH", 35 },
    { "VSSTATUS", 31 },
    { "VSTART", 3 },
    { "VSTIMECMP", 40 },
    { "VSTIMECMPH", 45 },
    { "VSTOPEI", 44 },
    { "VSTOPI", 398 },
    { "VSTVAL", 38 },
    { "VSTVEC", 33 },
    { "VTYPE", 361 },
    { "VXRM", 5 },
    { "VXSAT", 4 },
  };

  struct KeyType {
    std::string AltName;
  };
  KeyType Key = {AltName.upper()};
  auto Table = ArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpAltName = StringRef(LHS.AltName).compare(RHS.AltName);
      if (CmpAltName < 0) return true;
      if (CmpAltName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.AltName != Idx->AltName)
    return nullptr;
  return &SysRegsList[Idx->_index];
}

const SysReg *lookupSysRegByDeprecatedName(StringRef DeprecatedName) {
  struct IndexType {
    const char * DeprecatedName;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "", 0 },
    { "", 1 },
    { "", 2 },
    { "", 3 },
    { "", 4 },
    { "", 5 },
    { "", 6 },
    { "", 7 },
    { "", 8 },
    { "", 9 },
    { "", 10 },
    { "", 11 },
    { "", 12 },
    { "", 13 },
    { "", 14 },
    { "", 15 },
    { "", 16 },
    { "", 17 },
    { "", 18 },
    { "", 19 },
    { "", 20 },
    { "", 21 },
    { "", 23 },
    { "", 24 },
    { "", 25 },
    { "", 26 },
    { "", 27 },
    { "", 28 },
    { "", 29 },
    { "", 31 },
    { "", 32 },
    { "", 33 },
    { "", 34 },
    { "", 35 },
    { "", 36 },
    { "", 37 },
    { "", 38 },
    { "", 39 },
    { "", 40 },
    { "", 41 },
    { "", 42 },
    { "", 43 },
    { "", 44 },
    { "", 45 },
    { "", 46 },
    { "", 47 },
    { "", 48 },
    { "", 49 },
    { "", 50 },
    { "", 51 },
    { "", 52 },
    { "", 53 },
    { "", 54 },
    { "", 55 },
    { "", 56 },
    { "", 57 },
    { "", 58 },
    { "", 59 },
    { "", 60 },
    { "", 61 },
    { "", 62 },
    { "", 63 },
    { "", 64 },
    { "", 65 },
    { "", 66 },
    { "", 67 },
    { "", 68 },
    { "", 69 },
    { "", 70 },
    { "", 71 },
    { "", 72 },
    { "", 73 },
    { "", 74 },
    { "", 75 },
    { "", 76 },
    { "", 77 },
    { "", 78 },
    { "", 79 },
    { "", 80 },
    { "", 81 },
    { "", 82 },
    { "", 83 },
    { "", 84 },
    { "", 85 },
    { "", 86 },
    { "", 87 },
    { "", 88 },
    { "", 89 },
    { "", 90 },
    { "", 91 },
    { "", 92 },
    { "", 93 },
    { "", 94 },
    { "", 95 },
    { "", 96 },
    { "", 97 },
    { "", 98 },
    { "", 99 },
    { "", 100 },
    { "", 101 },
    { "", 102 },
    { "", 103 },
    { "", 105 },
    { "", 106 },
    { "", 107 },
    { "", 108 },
    { "", 109 },
    { "", 110 },
    { "", 111 },
    { "", 112 },
    { "", 113 },
    { "", 114 },
    { "", 115 },
    { "", 116 },
    { "", 117 },
    { "", 118 },
    { "", 119 },
    { "", 120 },
    { "", 121 },
    { "", 122 },
    { "", 123 },
    { "", 124 },
    { "", 125 },
    { "", 126 },
    { "", 127 },
    { "", 128 },
    { "", 129 },
    { "", 130 },
    { "", 131 },
    { "", 132 },
    { "", 133 },
    { "", 134 },
    { "", 135 },
    { "", 136 },
    { "", 137 },
    { "", 138 },
    { "", 139 },
    { "", 140 },
    { "", 141 },
    { "", 142 },
    { "", 143 },
    { "", 144 },
    { "", 145 },
    { "", 146 },
    { "", 147 },
    { "", 148 },
    { "", 149 },
    { "", 150 },
    { "", 151 },
    { "", 152 },
    { "", 153 },
    { "", 154 },
    { "", 155 },
    { "", 156 },
    { "", 157 },
    { "", 158 },
    { "", 159 },
    { "", 160 },
    { "", 161 },
    { "", 162 },
    { "", 163 },
    { "", 164 },
    { "", 165 },
    { "", 166 },
    { "", 167 },
    { "", 168 },
    { "", 169 },
    { "", 170 },
    { "", 171 },
    { "", 172 },
    { "", 173 },
    { "", 174 },
    { "", 175 },
    { "", 176 },
    { "", 177 },
    { "", 178 },
    { "", 179 },
    { "", 180 },
    { "", 181 },
    { "", 182 },
    { "", 183 },
    { "", 184 },
    { "", 185 },
    { "", 186 },
    { "", 187 },
    { "", 188 },
    { "", 189 },
    { "", 190 },
    { "", 191 },
    { "", 192 },
    { "", 193 },
    { "", 194 },
    { "", 195 },
    { "", 196 },
    { "", 197 },
    { "", 198 },
    { "", 199 },
    { "", 200 },
    { "", 201 },
    { "", 202 },
    { "", 203 },
    { "", 204 },
    { "", 205 },
    { "", 206 },
    { "", 207 },
    { "", 208 },
    { "", 209 },
    { "", 210 },
    { "", 211 },
    { "", 212 },
    { "", 213 },
    { "", 214 },
    { "", 215 },
    { "", 216 },
    { "", 217 },
    { "", 218 },
    { "", 219 },
    { "", 220 },
    { "", 221 },
    { "", 222 },
    { "", 223 },
    { "", 224 },
    { "", 225 },
    { "", 226 },
    { "", 227 },
    { "", 228 },
    { "", 229 },
    { "", 230 },
    { "", 231 },
    { "", 232 },
    { "", 233 },
    { "", 234 },
    { "", 235 },
    { "", 236 },
    { "", 237 },
    { "", 238 },
    { "", 239 },
    { "", 240 },
    { "", 241 },
    { "", 242 },
    { "", 243 },
    { "", 244 },
    { "", 245 },
    { "", 246 },
    { "", 247 },
    { "", 248 },
    { "", 249 },
    { "", 250 },
    { "", 251 },
    { "", 252 },
    { "", 253 },
    { "", 254 },
    { "", 255 },
    { "", 256 },
    { "", 257 },
    { "", 258 },
    { "", 259 },
    { "", 260 },
    { "", 261 },
    { "", 262 },
    { "", 263 },
    { "", 264 },
    { "", 265 },
    { "", 266 },
    { "", 267 },
    { "", 268 },
    { "", 269 },
    { "", 270 },
    { "", 271 },
    { "", 272 },
    { "", 273 },
    { "", 274 },
    { "", 275 },
    { "", 276 },
    { "", 277 },
    { "", 278 },
    { "", 279 },
    { "", 280 },
    { "", 281 },
    { "", 282 },
    { "", 283 },
    { "", 284 },
    { "", 285 },
    { "", 286 },
    { "", 287 },
    { "", 288 },
    { "", 289 },
    { "", 290 },
    { "", 291 },
    { "", 292 },
    { "", 293 },
    { "", 294 },
    { "", 295 },
    { "", 296 },
    { "", 297 },
    { "", 298 },
    { "", 299 },
    { "", 300 },
    { "", 301 },
    { "", 302 },
    { "", 303 },
    { "", 304 },
    { "", 305 },
    { "", 306 },
    { "", 307 },
    { "", 308 },
    { "", 309 },
    { "", 310 },
    { "", 311 },
    { "", 312 },
    { "", 313 },
    { "", 314 },
    { "", 315 },
    { "", 316 },
    { "", 317 },
    { "", 318 },
    { "", 319 },
    { "", 320 },
    { "", 321 },
    { "", 322 },
    { "", 323 },
    { "", 324 },
    { "", 325 },
    { "", 326 },
    { "", 327 },
    { "", 328 },
    { "", 329 },
    { "", 330 },
    { "", 331 },
    { "", 332 },
    { "", 333 },
    { "", 334 },
    { "", 335 },
    { "", 336 },
    { "", 337 },
    { "", 338 },
    { "", 339 },
    { "", 340 },
    { "", 341 },
    { "", 342 },
    { "", 343 },
    { "", 344 },
    { "", 345 },
    { "", 346 },
    { "", 347 },
    { "", 348 },
    { "", 349 },
    { "", 350 },
    { "", 351 },
    { "", 352 },
    { "", 353 },
    { "", 354 },
    { "", 355 },
    { "", 356 },
    { "", 357 },
    { "", 358 },
    { "", 359 },
    { "", 360 },
    { "", 361 },
    { "", 362 },
    { "", 363 },
    { "", 364 },
    { "", 365 },
    { "", 366 },
    { "", 367 },
    { "", 368 },
    { "", 369 },
    { "", 370 },
    { "", 371 },
    { "", 372 },
    { "", 373 },
    { "", 374 },
    { "", 375 },
    { "", 376 },
    { "", 377 },
    { "", 378 },
    { "", 379 },
    { "", 380 },
    { "", 381 },
    { "", 382 },
    { "", 383 },
    { "", 384 },
    { "", 385 },
    { "", 386 },
    { "", 387 },
    { "", 388 },
    { "", 389 },
    { "", 390 },
    { "", 391 },
    { "", 392 },
    { "", 393 },
    { "", 394 },
    { "", 395 },
    { "", 396 },
    { "", 397 },
    { "", 398 },
    { "", 399 },
    { "", 400 },
    { "", 401 },
    { "", 402 },
    { "", 403 },
    { "", 404 },
    { "MBADADDR", 104 },
    { "SBADADDR", 22 },
    { "SPTBR", 30 },
  };

  struct KeyType {
    std::string DeprecatedName;
  };
  KeyType Key = {DeprecatedName.upper()};
  auto Table = ArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpDeprecatedName = StringRef(LHS.DeprecatedName).compare(RHS.DeprecatedName);
      if (CmpDeprecatedName < 0) return true;
      if (CmpDeprecatedName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.DeprecatedName != Idx->DeprecatedName)
    return nullptr;
  return &SysRegsList[Idx->_index];
}

const SysReg *lookupSysRegByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CYCLE", 328 },
    { "CYCLEH", 363 },
    { "DCSR", 262 },
    { "DPC", 263 },
    { "DSCRATCH0", 264 },
    { "DSCRATCH1", 265 },
    { "FCSR", 2 },
    { "FFLAGS", 0 },
    { "FRM", 1 },
    { "HCONTEXT", 225 },
    { "HCOUNTEREN", 198 },
    { "HEDELEG", 194 },
    { "HENVCFG", 202 },
    { "HENVCFGH", 210 },
    { "HGATP", 224 },
    { "HGEIE", 199 },
    { "HGEIP", 397 },
    { "HIDELEG", 195 },
    { "HIDELEGH", 207 },
    { "HIE", 196 },
    { "HIP", 216 },
    { "HPMCOUNTER10", 338 },
    { "HPMCOUNTER10H", 373 },
    { "HPMCOUNTER11", 339 },
    { "HPMCOUNTER11H", 374 },
    { "HPMCOUNTER12", 340 },
    { "HPMCOUNTER12H", 375 },
    { "HPMCOUNTER13", 341 },
    { "HPMCOUNTER13H", 376 },
    { "HPMCOUNTER14", 342 },
    { "HPMCOUNTER14H", 377 },
    { "HPMCOUNTER15", 343 },
    { "HPMCOUNTER15H", 378 },
    { "HPMCOUNTER16", 344 },
    { "HPMCOUNTER16H", 379 },
    { "HPMCOUNTER17", 345 },
    { "HPMCOUNTER17H", 380 },
    { "HPMCOUNTER18", 346 },
    { "HPMCOUNTER18H", 381 },
    { "HPMCOUNTER19", 347 },
    { "HPMCOUNTER19H", 382 },
    { "HPMCOUNTER20", 348 },
    { "HPMCOUNTER20H", 383 },
    { "HPMCOUNTER21", 349 },
    { "HPMCOUNTER21H", 384 },
    { "HPMCOUNTER22", 350 },
    { "HPMCOUNTER22H", 385 },
    { "HPMCOUNTER23", 351 },
    { "HPMCOUNTER23H", 386 },
    { "HPMCOUNTER24", 352 },
    { "HPMCOUNTER24H", 387 },
    { "HPMCOUNTER25", 353 },
    { "HPMCOUNTER25H", 388 },
    { "HPMCOUNTER26", 354 },
    { "HPMCOUNTER26H", 389 },
    { "HPMCOUNTER27", 355 },
    { "HPMCOUNTER27H", 390 },
    { "HPMCOUNTER28", 356 },
    { "HPMCOUNTER28H", 391 },
    { "HPMCOUNTER29", 357 },
    { "HPMCOUNTER29H", 392 },
    { "HPMCOUNTER3", 331 },
    { "HPMCOUNTER30", 358 },
    { "HPMCOUNTER30H", 393 },
    { "HPMCOUNTER31", 359 },
    { "HPMCOUNTER31H", 394 },
    { "HPMCOUNTER3H", 366 },
    { "HPMCOUNTER4", 332 },
    { "HPMCOUNTER4H", 367 },
    { "HPMCOUNTER5", 333 },
    { "HPMCOUNTER5H", 368 },
    { "HPMCOUNTER6", 334 },
    { "HPMCOUNTER6H", 369 },
    { "HPMCOUNTER7", 335 },
    { "HPMCOUNTER7H", 370 },
    { "HPMCOUNTER8", 336 },
    { "HPMCOUNTER8H", 371 },
    { "HPMCOUNTER9", 337 },
    { "HPMCOUNTER9H", 372 },
    { "HSTATEEN0", 203 },
    { "HSTATEEN0H", 211 },
    { "HSTATEEN1", 204 },
    { "HSTATEEN1H", 212 },
    { "HSTATEEN2", 205 },
    { "HSTATEEN2H", 213 },
    { "HSTATEEN3", 206 },
    { "HSTATEEN3H", 214 },
    { "HSTATUS", 193 },
    { "HTIMEDELTA", 197 },
    { "HTIMEDELTAH", 208 },
    { "HTINST", 220 },
    { "HTVAL", 215 },
    { "HVICTL", 201 },
    { "HVIEN", 200 },
    { "HVIENH", 209 },
    { "HVIP", 217 },
    { "HVIPH", 221 },
    { "HVIPRIO1", 218 },
    { "HVIPRIO1H", 222 },
    { "HVIPRIO2", 219 },
    { "HVIPRIO2H", 223 },
    { "INSTRET", 330 },
    { "INSTRETH", 365 },
    { "JVT", 8 },
    { "MARCHID", 400 },
    { "MCAUSE", 103 },
    { "MCONFIGPTR", 403 },
    { "MCONTEXT", 261 },
    { "MCOUNTEREN", 53 },
    { "MCOUNTINHIBIT", 71 },
    { "MCYCLE", 266 },
    { "MCYCLEH", 297 },
    { "MEDELEG", 49 },
    { "MENVCFG", 56 },
    { "MENVCFGH", 66 },
    { "MEPC", 102 },
    { "MHARTID", 402 },
    { "MHPMCOUNTER10", 275 },
    { "MHPMCOUNTER10H", 306 },
    { "MHPMCOUNTER11", 276 },
    { "MHPMCOUNTER11H", 307 },
    { "MHPMCOUNTER12", 277 },
    { "MHPMCOUNTER12H", 308 },
    { "MHPMCOUNTER13", 278 },
    { "MHPMCOUNTER13H", 309 },
    { "MHPMCOUNTER14", 279 },
    { "MHPMCOUNTER14H", 310 },
    { "MHPMCOUNTER15", 280 },
    { "MHPMCOUNTER15H", 311 },
    { "MHPMCOUNTER16", 281 },
    { "MHPMCOUNTER16H", 312 },
    { "MHPMCOUNTER17", 282 },
    { "MHPMCOUNTER17H", 313 },
    { "MHPMCOUNTER18", 283 },
    { "MHPMCOUNTER18H", 314 },
    { "MHPMCOUNTER19", 284 },
    { "MHPMCOUNTER19H", 315 },
    { "MHPMCOUNTER20", 285 },
    { "MHPMCOUNTER20H", 316 },
    { "MHPMCOUNTER21", 286 },
    { "MHPMCOUNTER21H", 317 },
    { "MHPMCOUNTER22", 287 },
    { "MHPMCOUNTER22H", 318 },
    { "MHPMCOUNTER23", 288 },
    { "MHPMCOUNTER23H", 319 },
    { "MHPMCOUNTER24", 289 },
    { "MHPMCOUNTER24H", 320 },
    { "MHPMCOUNTER25", 290 },
    { "MHPMCOUNTER25H", 321 },
    { "MHPMCOUNTER26", 291 },
    { "MHPMCOUNTER26H", 322 },
    { "MHPMCOUNTER27", 292 },
    { "MHPMCOUNTER27H", 323 },
    { "MHPMCOUNTER28", 293 },
    { "MHPMCOUNTER28H", 324 },
    { "MHPMCOUNTER29", 294 },
    { "MHPMCOUNTER29H", 325 },
    { "MHPMCOUNTER3", 268 },
    { "MHPMCOUNTER30", 295 },
    { "MHPMCOUNTER30H", 326 },
    { "MHPMCOUNTER31", 296 },
    { "MHPMCOUNTER31H", 327 },
    { "MHPMCOUNTER3H", 299 },
    { "MHPMCOUNTER4", 269 },
    { "MHPMCOUNTER4H", 300 },
    { "MHPMCOUNTER5", 270 },
    { "MHPMCOUNTER5H", 301 },
    { "MHPMCOUNTER6", 271 },
    { "MHPMCOUNTER6H", 302 },
    { "MHPMCOUNTER7", 272 },
    { "MHPMCOUNTER7H", 303 },
    { "MHPMCOUNTER8", 273 },
    { "MHPMCOUNTER8H", 304 },
    { "MHPMCOUNTER9", 274 },
    { "MHPMCOUNTER9H", 305 },
    { "MHPMEVENT10", 79 },
    { "MHPMEVENT10H", 233 },
    { "MHPMEVENT11", 80 },
    { "MHPMEVENT11H", 234 },
    { "MHPMEVENT12", 81 },
    { "MHPMEVENT12H", 235 },
    { "MHPMEVENT13", 82 },
    { "MHPMEVENT13H", 236 },
    { "MHPMEVENT14", 83 },
    { "MHPMEVENT14H", 237 },
    { "MHPMEVENT15", 84 },
    { "MHPMEVENT15H", 238 },
    { "MHPMEVENT16", 85 },
    { "MHPMEVENT16H", 239 },
    { "MHPMEVENT17", 86 },
    { "MHPMEVENT17H", 240 },
    { "MHPMEVENT18", 87 },
    { "MHPMEVENT18H", 241 },
    { "MHPMEVENT19", 88 },
    { "MHPMEVENT19H", 242 },
    { "MHPMEVENT20", 89 },
    { "MHPMEVENT20H", 243 },
    { "MHPMEVENT21", 90 },
    { "MHPMEVENT21H", 244 },
    { "MHPMEVENT22", 91 },
    { "MHPMEVENT22H", 245 },
    { "MHPMEVENT23", 92 },
    { "MHPMEVENT23H", 246 },
    { "MHPMEVENT24", 93 },
    { "MHPMEVENT24H", 247 },
    { "MHPMEVENT25", 94 },
    { "MHPMEVENT25H", 248 },
    { "MHPMEVENT26", 95 },
    { "MHPMEVENT26H", 249 },
    { "MHPMEVENT27", 96 },
    { "MHPMEVENT27H", 250 },
    { "MHPMEVENT28", 97 },
    { "MHPMEVENT28H", 251 },
    { "MHPMEVENT29", 98 },
    { "MHPMEVENT29H", 252 },
    { "MHPMEVENT3", 72 },
    { "MHPMEVENT30", 99 },
    { "MHPMEVENT30H", 253 },
    { "MHPMEVENT31", 100 },
    { "MHPMEVENT31H", 254 },
    { "MHPMEVENT3H", 226 },
    { "MHPMEVENT4", 73 },
    { "MHPMEVENT4H", 227 },
    { "MHPMEVENT5", 74 },
    { "MHPMEVENT5H", 228 },
    { "MHPMEVENT6", 75 },
    { "MHPMEVENT6H", 229 },
    { "MHPMEVENT7", 76 },
    { "MHPMEVENT7H", 230 },
    { "MHPMEVENT8", 77 },
    { "MHPMEVENT8H", 231 },
    { "MHPMEVENT9", 78 },
    { "MHPMEVENT9H", 232 },
    { "MIDELEG", 50 },
    { "MIDELEGH", 62 },
    { "MIE", 51 },
    { "MIEH", 63 },
    { "MIMPID", 401 },
    { "MINSTRET", 267 },
    { "MINSTRETH", 298 },
    { "MIP", 105 },
    { "MIPH", 110 },
    { "MIREG", 109 },
    { "MISA", 48 },
    { "MISELECT", 108 },
    { "MSCRATCH", 101 },
    { "MSECCFG", 255 },
    { "MSECCFGH", 256 },
    { "MSTATEEN0", 57 },
    { "MSTATEEN0H", 67 },
    { "MSTATEEN1", 58 },
    { "MSTATEEN1H", 68 },
    { "MSTATEEN2", 59 },
    { "MSTATEEN2H", 69 },
    { "MSTATEEN3", 60 },
    { "MSTATEEN3H", 70 },
    { "MSTATUS", 47 },
    { "MSTATUSH", 61 },
    { "MTINST", 106 },
    { "MTOPEI", 111 },
    { "MTOPI", 404 },
    { "MTVAL", 104 },
    { "MTVAL2", 107 },
    { "MTVEC", 52 },
    { "MVENDORID", 399 },
    { "MVIEN", 54 },
    { "MVIENH", 64 },
    { "MVIP", 55 },
    { "MVIPH", 65 },
    { "PMPADDR0", 128 },
    { "PMPADDR1", 129 },
    { "PMPADDR10", 138 },
    { "PMPADDR11", 139 },
    { "PMPADDR12", 140 },
    { "PMPADDR13", 141 },
    { "PMPADDR14", 142 },
    { "PMPADDR15", 143 },
    { "PMPADDR16", 144 },
    { "PMPADDR17", 145 },
    { "PMPADDR18", 146 },
    { "PMPADDR19", 147 },
    { "PMPADDR2", 130 },
    { "PMPADDR20", 148 },
    { "PMPADDR21", 149 },
    { "PMPADDR22", 150 },
    { "PMPADDR23", 151 },
    { "PMPADDR24", 152 },
    { "PMPADDR25", 153 },
    { "PMPADDR26", 154 },
    { "PMPADDR27", 155 },
    { "PMPADDR28", 156 },
    { "PMPADDR29", 157 },
    { "PMPADDR3", 131 },
    { "PMPADDR30", 158 },
    { "PMPADDR31", 159 },
    { "PMPADDR32", 160 },
    { "PMPADDR33", 161 },
    { "PMPADDR34", 162 },
    { "PMPADDR35", 163 },
    { "PMPADDR36", 164 },
    { "PMPADDR37", 165 },
    { "PMPADDR38", 166 },
    { "PMPADDR39", 167 },
    { "PMPADDR4", 132 },
    { "PMPADDR40", 168 },
    { "PMPADDR41", 169 },
    { "PMPADDR42", 170 },
    { "PMPADDR43", 171 },
    { "PMPADDR44", 172 },
    { "PMPADDR45", 173 },
    { "PMPADDR46", 174 },
    { "PMPADDR47", 175 },
    { "PMPADDR48", 176 },
    { "PMPADDR49", 177 },
    { "PMPADDR5", 133 },
    { "PMPADDR50", 178 },
    { "PMPADDR51", 179 },
    { "PMPADDR52", 180 },
    { "PMPADDR53", 181 },
    { "PMPADDR54", 182 },
    { "PMPADDR55", 183 },
    { "PMPADDR56", 184 },
    { "PMPADDR57", 185 },
    { "PMPADDR58", 186 },
    { "PMPADDR59", 187 },
    { "PMPADDR6", 134 },
    { "PMPADDR60", 188 },
    { "PMPADDR61", 189 },
    { "PMPADDR62", 190 },
    { "PMPADDR63", 191 },
    { "PMPADDR7", 135 },
    { "PMPADDR8", 136 },
    { "PMPADDR9", 137 },
    { "PMPCFG0", 112 },
    { "PMPCFG1", 113 },
    { "PMPCFG10", 122 },
    { "PMPCFG11", 123 },
    { "PMPCFG12", 124 },
    { "PMPCFG13", 125 },
    { "PMPCFG14", 126 },
    { "PMPCFG15", 127 },
    { "PMPCFG2", 114 },
    { "PMPCFG3", 115 },
    { "PMPCFG4", 116 },
    { "PMPCFG5", 117 },
    { "PMPCFG6", 118 },
    { "PMPCFG7", 119 },
    { "PMPCFG8", 120 },
    { "PMPCFG9", 121 },
    { "SATP", 30 },
    { "SCAUSE", 21 },
    { "SCONTEXT", 192 },
    { "SCOUNTEREN", 12 },
    { "SCOUNTOVF", 395 },
    { "SEED", 7 },
    { "SENVCFG", 13 },
    { "SEPC", 20 },
    { "SIE", 10 },
    { "SIEH", 18 },
    { "SIP", 23 },
    { "SIPH", 27 },
    { "SIREG", 26 },
    { "SISELECT", 25 },
    { "SSCRATCH", 19 },
    { "SSTATEEN0", 14 },
    { "SSTATEEN1", 15 },
    { "SSTATEEN2", 16 },
    { "SSTATEEN3", 17 },
    { "SSTATUS", 9 },
    { "STIMECMP", 24 },
    { "STIMECMPH", 29 },
    { "STOPEI", 28 },
    { "STOPI", 396 },
    { "STVAL", 22 },
    { "STVEC", 11 },
    { "TDATA1", 258 },
    { "TDATA2", 259 },
    { "TDATA3", 260 },
    { "TIME", 329 },
    { "TIMEH", 364 },
    { "TSELECT", 257 },
    { "VCSR", 6 },
    { "VL", 360 },
    { "VLENB", 362 },
    { "VSATP", 46 },
    { "VSCAUSE", 37 },
    { "VSEPC", 36 },
    { "VSIE", 32 },
    { "VSIEH", 34 },
    { "VSIP", 39 },
    { "VSIPH", 43 },
    { "VSIREG", 42 },
    { "VSISELECT", 41 },
    { "VSSCRATCH", 35 },
    { "VSSTATUS", 31 },
    { "VSTART", 3 },
    { "VSTIMECMP", 40 },
    { "VSTIMECMPH", 45 },
    { "VSTOPEI", 44 },
    { "VSTOPI", 398 },
    { "VSTVAL", 38 },
    { "VSTVEC", 33 },
    { "VTYPE", 361 },
    { "VXRM", 5 },
    { "VXSAT", 4 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = ArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &SysRegsList[Idx->_index];
}
#endif

#undef GET_RISCVMaskedPseudosTable_DECL
#undef GET_RISCVMaskedPseudosTable_IMPL
#undef GET_RISCVOpcodesList_DECL
#undef GET_RISCVOpcodesList_IMPL
#undef GET_RISCVVIntrinsicsTable_DECL
#undef GET_RISCVVIntrinsicsTable_IMPL
#undef GET_RISCVVInversePseudosTable_DECL
#undef GET_RISCVVInversePseudosTable_IMPL
#undef GET_RISCVVLETable_DECL
#undef GET_RISCVVLETable_IMPL
#undef GET_RISCVVLSEGTable_DECL
#undef GET_RISCVVLSEGTable_IMPL
#undef GET_RISCVVLXSEGTable_DECL
#undef GET_RISCVVLXSEGTable_IMPL
#undef GET_RISCVVLXTable_DECL
#undef GET_RISCVVLXTable_IMPL
#undef GET_RISCVVPseudosTable_DECL
#undef GET_RISCVVPseudosTable_IMPL
#undef GET_RISCVVSETable_DECL
#undef GET_RISCVVSETable_IMPL
#undef GET_RISCVVSSEGTable_DECL
#undef GET_RISCVVSSEGTable_IMPL
#undef GET_RISCVVSXSEGTable_DECL
#undef GET_RISCVVSXSEGTable_IMPL
#undef GET_RISCVVSXTable_DECL
#undef GET_RISCVVSXTable_IMPL
#undef GET_SysRegsList_DECL
#undef GET_SysRegsList_IMPL
